/* xg.c: s7, Ruby, and Forth bindings for gtk/pango/cairo, some of glib
 *   this file generated automatically from makexg.scm and xgdata.scm
 *   needs xen.h
 *
 * reference args initial values are usually ignored, resultant values are returned in a list.
 * null ptrs are passed and returned as #f, trailing "user_data" callback function arguments are optional (default: #f).
 * where supported, "..." args are passed as a list, trailing NULL or -1 should be omitted.
 * 'xg is added to *features*
 *
 * added funcs:
 *    (xg-version): date string.
 *    (c-array->list arr len) derefs each member of arr, returning lisp list, len=#f: null terminated array
 *    (list->c-array lst ctype) packages each member of list as c-type "type" returning (wrapped) c array
 *    (GtkTextIter): GtkTextIter struct
 *    (GtkTreeIter): GtkTreeIter struct
 *    (PangoRectangle): PangoRectangle struct
 *    (cairo_matrix_t): cairo_matrix_t struct (if cairo)
 *
 * omitted functions and macros:
 *     anything with a va_list or GtkArg* argument.
 *     most of the unusual keysym names
 *     all *_CLASS, *_IFACE macros, *_get_type functions
 *     win32-specific functions
 *
 * HISTORY:
 *
 *     28-Jul-17: scheme Init_libxg arg added.
 *     --------
 *     17-Mar-16: gtk_enum_t for better signature checks.
 *     --------
 *     29-Oct:    removed ->string.
 *     21-Aug-15: procedure-signature changes.
 *     --------
 *     27-Dec:    integer procedure stuff.
 *     16-Apr:    changed max-args to 8.
 *     6-Mar:     changed most macros.
 *     21-Feb-14: changed _p to _is_.
 *     --------
 *     3-Sep:     use symbol directly in type checks, not the symbol name.
 *     18-Aug:    changed the gtk version macros to reflect the version number.
 *     7-Jun-13:  added mixed arg types to the ... arg lists.
 *     --------
 *     19-Aug-10: removed lots of Gdk stuff -- we assume Gtk 2.9 and cairo now.
 *     28-Jan-10: removed the rest of the struct accessors.
 *     --------
 *     16-Dec-09: removed Guile support.
 *     --------
 *     16-Oct:    removed Gauche support.
 *     1-Sep:     s7 support.
 *     8-Jul-08:  started removing all struct accessors (for Gtk 3).
 *     --------
 *     9-Mar:     removed all *_get_type functions (nearly 300!).
 *     5-Mar-07:  cairo and more gtkprint.
 *     --------
 *     26-Aug:    removed --with-x11, WITH_GTK_AND_X11, xg-x11.h.
 *     4-Aug:     added a form of g_object_get and gtk_settings_get_for_screen.
 *     20-Jul:    gtkprint stuff.
 *     17-Jul:    g_signal_connect and other related macros.
 *     21-Apr:    Gauche support.
 *     29-Mar:    Forth support.
 *     7-Mar-06:  if g_set_error, return the error message, not the GError pointer
 *     --------
 *     9-Jul:     Collapse 2.3.* into 2.3.6, 2.5.* into 2.5.6.
 *     13-Jun:    folded xg-ruby.c into xg.c.
 *     21-Feb:    changed libxm to libxg, xm-version to xg-version.
 *     10-Jan:    plugged some memory leaks.
 *     4-Jan-05:  removed deprecated Xen_VECTOR_ELEMENTS.
 *     --------
 *     8-Dec:     added some g_log handler funcs.
 *     6-Dec:     check for lost callback context.
 *                tightened type (pointer) checking considerably (#f only acceptable if explicit @ used in xgdata.scm).
 *     3-Dec:     changed GPOINTER cast func to accept non-lists.
 *     27-Aug:    removed the PANGO_ENGINE and PANGO_BACKEND stuff.
 *     2-Jun:     gdk_atom_name needs to free return value
 *     28-May:    GtkFileSelection struct support put back in -- need ok_button et al.
 *     14-Apr:    make-target-entry.
 *     4-Apr:     various additions, deletions, and bugfixes for snd-test 26
 *     29-Mar:    support for some ... args.
 *     22-Mar:    g_source_remove and related changes.
 *     12-Feb-04: g_list_nth_data (Kjetil S. Matheussen).
 *     --------
 *     15-Sep:    removed client_window GtkIMMulticontext struct field.
 *     26-May:    removed nugatory GdkInputFunction stuff and some unused type converters.
 *     1-Apr:     gdk_property_get uses scm_mem2string in some cases now.
 *     31-Mar:    gchar* -> xen string bugfix (thanks to Friedrich Delgado Friedrichs).
 *     10-Mar-03: Ruby Xm_Version.
 *     --------
 *     18-Nov:    Ruby/Gtk bugfixes.
 *     25-Oct:    removed (deprecated) gdk_set_pointer_hooks
 *     31-Jul:    removed GTK 1.n support
 *     24-Jul:    changed Guile prefix (R5RS reserves vertical-bar).
 *     19-Jul:    XG_FIELD_PRE for change from using vertical-bar (reserved in R5RS)
 *     2-Jun:     removed deprecated and broken stuff
 *     12-Mar:    support for GtkDestroyNotify callbacks
 *                Ruby support via xg-ruby.c
 *     21-Feb:    #f=NULL throughout, gdk-pixbuf, GTypes.
 *     11-Feb-02: initial version.
 */

#include "mus-config.h"

#define HAVE_CAIRO_1_8    ((CAIRO_VERSION_MAJOR >= 1) && (CAIRO_VERSION_MINOR >= 8))
#define HAVE_CAIRO_1_9_12 ((CAIRO_VERSION_MAJOR >= 1) && (CAIRO_VERSION_MINOR >= 9) && (CAIRO_VERSION_MICRO >= 12))

#if ((!__NetBSD__) && ((_MSC_VER) || (!defined(__STC__)) || (defined(__STDC_VERSION__) && (__STDC_VERSION__ < 199901L))))
  #define __func__ __FUNCTION__
#endif

#if HAVE_EXTENSION_LANGUAGE

#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>

#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#if (!GTK_CHECK_VERSION(3, 0, 0))
  #include <gdk/gdkkeysyms.h>
#endif
#include <glib-object.h>
#include <pango/pango.h>
#include <cairo/cairo.h>
#if USE_SND
  /* USE_SND causes xm to use Snd's error handlers which are much smarter than xen's fallback versions */
  #include "snd.h"
#else
  #include "xen.h"
  #define NOT_A_GC_LOC -1
#endif

#ifndef PROC_FALSE
  #if HAVE_RUBY
    #define PROC_FALSE "false"
    #define PROC_TRUE "true"
  #else
    #define PROC_FALSE "#f"
    #define PROC_TRUE  "#t"
  #endif
#endif

/* -------------------------------- GC -------------------------------- */
static Xen_object_type_t xm_obj_tag;
#if HAVE_RUBY
static void *xm_obj_free(Xen obj)
{
  void *xobj;
  xobj = (void *)obj;
  free(xobj);
  return(NULL);
}
#endif
#if HAVE_FORTH
static void xm_obj_free(Xen obj)
{
  void *val;
  val = (void *)Xen_object_ref(obj);
  free(val);
}
#endif
#if HAVE_SCHEME
static void xm_obj_free(void *val)
{
  free(val);
}
static bool s7_equalp_xm(void *x1, void *x2)
{
  return(x1 == x2);
}
#endif
static Xen make_xm_obj(void *ptr)
{
  return(Xen_make_object(xm_obj_tag, ptr, 0, xm_obj_free));
}
static void define_xm_obj(void)
{
#if HAVE_SCHEME
  xm_obj_tag = s7_make_c_type(s7, "<XmObj>");
  s7_c_type_set_free(s7, xm_obj_tag, xm_obj_free);
  s7_c_type_set_equal(s7, xm_obj_tag, s7_equalp_xm);
#else
  xm_obj_tag = Xen_make_object_type("XmObj", sizeof(void *));
#endif
#if HAVE_FORTH
  fth_set_object_free(xm_obj_tag, xm_obj_free);
#endif
}  

/* prefix for all names */
#if HAVE_SCHEME
  #define Xg_pre ""
  #define Xg_field_pre "."
  #define Xg_post ""
#endif
#if HAVE_RUBY
/* for Ruby, XG PRE needs to be uppercase */
  #define Xg_pre "R"
  #define Xg_post ""
  #define Xg_field_pre "R"
#endif
#if HAVE_FORTH
  #define Xg_pre "F"
  #define Xg_post ""
  #define Xg_field_pre "F"
#endif

static Xen xg_GMenu__symbol, xg_GtkApplicationInhibitFlags_symbol, xg_GApplicationFlags_symbol, xg_GtkContentFormats__symbol, xg_GdkAtom__symbol, xg_GdkDisplay_gtk_invisible_get_display_symbol, xg_GtkInvisible__symbol, xg_GtkIconSize_symbol, xg_GValue_symbol, xg_GBytes__symbol, xg_GdkContentDeserializeFunc_symbol, xg_GdkContentDeserializer__symbol, xg_GdkContentSerializeFunc_symbol, xg_GdkContentSerializer__symbol, xg_GOutputStream__symbol, xg_GdkContentFormatsBuilder__symbol, xg_GdkContentFormatsBuilder_symbol, xg_GString__symbol, xg_GdkTexture__symbol, xg_har___symbol, xg_GInputStream__symbol, xg_GAsyncResult__symbol, xg_GAsyncReadyCallback_symbol, xg_GCancellable__symbol, xg_GdkContentProvider__symbol, xg_GdkContentFormats__symbol, xg_GdkClipboard__symbol, xg_GdkAppLaunchContext__symbol, xg_GtkEventControllerScroll__symbol, xg_GtkEventControllerScrollFlags_symbol, xg_GtkSnapshot__symbol, xg_GdkTouchpadGesturePhase_symbol, xg_GdkNotifyType_symbol, xg_GdkCrossingMode_symbol, xg_GtkCssProvider__symbol, xg_GtkStyleContextPrintFlags_symbol, xg_GdkFrameClock__symbol, xg_GtkCssSection__symbol, xg_GtkStyleProvider__symbol, xg_GdkEventScroll__symbol, xg_GtkScrollbar__symbol, xg_GtkCenterBox__symbol, xg_GtkCheckButton__symbol, xg_GdkDrawContext__symbol, xg_GtkDrawingAreaDrawFunc_symbol, xg_GtkShortcutLabel__symbol, xg_GtkPadActionType_symbol, xg_GtkPadActionEntry__symbol, xg_GActionGroup__symbol, xg_GtkPadController__symbol, xg_GdkDevicePadFeature_symbol, xg_GdkDevicePad__symbol, xg_GdkDrawingContext__symbol, xg_GdkSubpixelLayout_symbol, xg_GdkMonitor__symbol, xg_GdkDeviceTool__symbol, xg_GdkAxisFlags_symbol, xg_GdkSeatGrabPrepareFunc_symbol, xg_GdkSeatCapabilities_symbol, xg_GdkGrabStatus_symbol, xg_GtkPopoverConstraint_symbol, xg_GtkShortcutsWindow__symbol, xg_GtkStackSidebar__symbol, xg_GtkSearchEntry__symbol, xg_GtkPopoverMenu__symbol, xg_GtkStyleContext__symbol, xg_GdkGLContext__symbol, xg_GtkGLArea__symbol, xg_GtkPropagationPhase_symbol, xg_GtkEventController__symbol, xg_GtkGestureZoom__symbol, xg_GtkGestureSwipe__symbol, xg_GtkGestureSingle__symbol, xg_GtkGestureRotate__symbol, xg_GtkGestureMultiPress__symbol, xg_GtkGesturePan__symbol, xg_GtkGestureDrag__symbol, xg_GdkEventSequence__symbol, xg_GtkEventSequenceState_symbol, xg_GtkGesture__symbol, xg_GtkAllocation__symbol, xg_GtkPopover__symbol, xg_GtkActionBar__symbol, xg_GtkFlowBox__symbol, xg_GtkFlowBoxChild__symbol, xg_GdkEventType_symbol, xg_GtkSearchBar__symbol, xg_GtkListBox__symbol, xg_GtkListBoxRow__symbol, xg_GtkHeaderBar__symbol, xg_GtkRevealerTransitionType_symbol, xg_GtkRevealer__symbol, xg_GtkStackTransitionType_symbol, xg_GtkStack__symbol, xg_GtkStackSwitcher__symbol, xg_GtkPlacesSidebar__symbol, xg_GtkPlacesOpenFlags_symbol, xg_GtkBaselinePosition_symbol, xg_GdkFullscreenMode_symbol, xg_GtkInputHints_symbol, xg_GtkInputPurpose_symbol, xg_GtkLevelBarMode_symbol, xg_GtkLevelBar__symbol, xg_GtkMenuButton__symbol, xg_GtkColorChooser__symbol, xg_GtkApplicationWindow__symbol, xg_GtkApplication__symbol, xg_GMenuModel__symbol, xg_guint___symbol, xg_GdkModifierIntent_symbol, xg_GtkFontChooser__symbol, xg_GdkScrollDirection_symbol, xg_GtkOverlay__symbol, xg_GtkWidgetPath__symbol, xg_GtkStateFlags_symbol, xg_GtkToolShell__symbol, xg_GtkWindowGroup__symbol, xg_GIcon__symbol, xg_GtkOrientable__symbol, xg_GtkCellArea__symbol, xg_GtkBorder__symbol, xg_GtkSwitch__symbol, xg_GtkScrollablePolicy_symbol, xg_GtkScrollable__symbol, xg_GtkGrid__symbol, xg_GdkRGBA__symbol, xg_GtkComboBoxText__symbol, xg_GtkAlign_symbol, xg_GtkSizeRequestMode_symbol, xg_cairo_region_overlap_t_symbol, xg_cairo_rectangle_int_t__symbol, xg_double__symbol, xg_cairo_rectangle_t__symbol, xg_cairo_device_t__symbol, xg_cairo_bool_t_symbol, xg_cairo_text_cluster_flags_t__symbol, xg_cairo_text_cluster_t___symbol, xg_cairo_glyph_t___symbol, xg_cairo_text_cluster_flags_t_symbol, xg_cairo_text_cluster_t__symbol, xg_cairo_region_t__symbol, xg_GtkMessageDialog__symbol, xg_GdkDevice__symbol, xg_GtkAccessible__symbol, xg_GdkModifierType__symbol, xg_GtkDestDefaults_symbol, xg_GtkToolPaletteDragTargets_symbol, xg_GtkToolItemGroup__symbol, xg_GtkToolPalette__symbol, xg_GtkPackType_symbol, xg_GtkSpinner__symbol, xg_GtkEntryBuffer__symbol, xg_GtkMessageType_symbol, xg_GtkInfoBar__symbol, xg_GtkEntryIconPosition_symbol, xg_GFile__symbol, xg_GtkSensitivityType_symbol, xg_GtkScaleButton__symbol, xg_GtkCalendarDetailFunc_symbol, xg_GtkTooltip__symbol, xg_cairo_rectangle_list_t__symbol, xg_void__symbol, xg_cairo_filter_t_symbol, xg_cairo_extend_t_symbol, xg_cairo_format_t_symbol, xg_cairo_path_t__symbol, xg_cairo_destroy_func_t_symbol, xg_cairo_user_data_key_t__symbol, xg_cairo_text_extents_t__symbol, xg_cairo_font_extents_t__symbol, xg_cairo_font_face_t__symbol, xg_cairo_glyph_t__symbol, xg_cairo_scaled_font_t__symbol, xg_cairo_font_weight_t_symbol, xg_cairo_font_slant_t_symbol, xg_cairo_hint_metrics_t_symbol, xg_cairo_hint_style_t_symbol, xg_cairo_subpixel_order_t_symbol, xg_cairo_status_t_symbol, xg_bool_symbol, xg_cairo_matrix_t__symbol, xg_cairo_line_join_t_symbol, xg_cairo_line_cap_t_symbol, xg_cairo_fill_rule_t_symbol, xg_cairo_antialias_t_symbol, xg_cairo_operator_t_symbol, xg_cairo_pattern_t__symbol, xg_cairo_content_t_symbol, xg_GtkPageSet_symbol, xg_GtkPageRange__symbol, xg_GtkPrintPages_symbol, xg_GtkPrintQuality_symbol, xg_GtkPrintDuplex_symbol, xg_GtkPaperSize__symbol, xg_GtkPageOrientation_symbol, xg_GtkPrintSettingsFunc_symbol, xg_GtkPageSetupDoneFunc_symbol, xg_GtkPrintStatus_symbol, xg_GtkPrintOperationAction_symbol, xg_GtkPrintOperationResult_symbol, xg_GtkUnit_symbol, xg_GtkPrintSettings__symbol, xg_GtkPrintOperation__symbol, xg_GtkPageSetup__symbol, xg_GtkPrintContext__symbol, xg_cairo_surface_t__symbol, xg_GtkTreeViewGridLines_symbol, xg_GtkRecentData__symbol, xg_time_t_symbol, xg_GtkRecentChooserMenu__symbol, xg_GtkRecentManager__symbol, xg_GtkRecentFilter__symbol, xg_GtkRecentSortFunc_symbol, xg_GtkRecentSortType_symbol, xg_GtkRecentChooser__symbol, xg_GtkLinkButton__symbol, xg_GtkAssistantPageType_symbol, xg_GtkAssistantPageFunc_symbol, xg_GtkAssistant__symbol, xg_GDestroyNotify_symbol, xg_GtkTreeViewSearchPositionFunc_symbol, xg_GtkMenuBar__symbol, xg_GtkPackDirection_symbol, xg_GtkIconViewDropPosition_symbol, xg_GValue__symbol, xg_GLogFunc_symbol, xg_PangoMatrix__symbol, xg_PangoRenderPart_symbol, xg_PangoRenderer__symbol, xg_GtkMenuToolButton__symbol, xg_GtkFileChooserButton__symbol, xg_PangoScriptIter__symbol, xg_PangoScript_symbol, xg_PangoAttrFilterFunc_symbol, xg_PangoEllipsizeMode_symbol, xg_GtkIconViewForeachFunc_symbol, xg_GtkAboutDialog__symbol, xg_GtkTreeViewRowSeparatorFunc_symbol, xg_GtkCellView__symbol, xg_GtkAccelMap__symbol, xg_GtkOrientation_symbol, xg_GtkToolButton__symbol, xg_GtkIconLookupFlags_symbol, xg_GtkIconInfo__symbol, xg_gchar___symbol, xg_GtkIconTheme__symbol, xg_GtkFileChooser__symbol, xg_GtkCellLayoutDataFunc_symbol, xg_GtkCellLayout__symbol, xg_GtkFileFilterFunc_symbol, xg_GtkFileFilterFlags_symbol, xg_GtkFileFilter__symbol, xg_GSourceFunc_symbol, xg_GtkToggleToolButton__symbol, xg_GtkSeparatorToolItem__symbol, xg_GtkRadioToolButton__symbol, xg_GtkEntryCompletionMatchFunc_symbol, xg_GtkFontButton__symbol, xg_GtkExpander__symbol, xg_GtkComboBox__symbol, xg_GtkTreeModelFilter__symbol, xg_GtkFileChooserAction_symbol, xg_GtkToolItem__symbol, xg_GtkCalendarDisplayOptions_symbol, xg_GdkDisplay__symbol, xg_PangoLayoutRun__symbol, xg_PangoLayoutIter__symbol, xg_PangoLayoutLine__symbol, xg_int__symbol, xg_PangoAlignment_symbol, xg_PangoWrapMode_symbol, xg_PangoItem__symbol, xg_PangoGlyphString__symbol, xg_PangoFontMap__symbol, xg_PangoGlyph_symbol, xg_PangoFontFace__symbol, xg_PangoFontFace___symbol, xg_PangoFontFamily__symbol, xg_PangoFontMask_symbol, xg_PangoFontDescription___symbol, xg_PangoCoverageLevel_symbol, xg_PangoCoverage__symbol, xg_PangoFontMetrics__symbol, xg_PangoFontset__symbol, xg_PangoFont__symbol, xg_PangoFontFamily___symbol, xg_PangoLogAttr__symbol, xg_PangoAnalysis__symbol, xg_PangoAttrList___symbol, xg_PangoAttrIterator__symbol, xg_PangoRectangle__symbol, xg_PangoUnderline_symbol, xg_PangoStretch_symbol, xg_PangoVariant_symbol, xg_PangoWeight_symbol, xg_PangoStyle_symbol, xg_guint16_symbol, xg_PangoAttribute__symbol, xg_PangoAttrType_symbol, xg_PangoColor__symbol, xg_GdkGravity_symbol, xg_GtkWindowPosition_symbol, xg_GtkWindowType_symbol, xg_GtkWindow__symbol, xg_GtkTextDirection_symbol, xg_PangoContext__symbol, xg_AtkObject__symbol, xg_GtkDirectionType_symbol, xg_GtkViewport__symbol, xg_GtkTreeViewSearchEqualFunc_symbol, xg_GtkTreeViewDropPosition_symbol, xg_GtkTreeViewMappingFunc_symbol, xg_GtkTreeViewColumnDropFunc_symbol, xg_GtkTreeViewColumnSizing_symbol, xg_GtkTreeCellDataFunc_symbol, xg_GtkTreeStore__symbol, xg_GtkTreeIterCompareFunc_symbol, xg_GtkSortType_symbol, xg_GtkTreeSortable__symbol, xg_GtkTreeSelectionForeachFunc_symbol, xg_GtkTreeModel___symbol, xg_GtkTreeSelectionFunc_symbol, xg_GtkSelectionMode_symbol, xg_GtkTreeModelSort__symbol, xg_GtkTreeModelForeachFunc_symbol, xg_GtkTreeModelFlags_symbol, xg_GtkTreeRowReference__symbol, xg_GtkTreeDragDest__symbol, xg_GtkTreeDragSource__symbol, xg_GtkToolbarStyle_symbol, xg_GtkToolbar__symbol, xg_GtkToggleButton__symbol, xg_PangoTabArray__symbol, xg_GtkWrapMode_symbol, xg_GtkTextWindowType_symbol, xg_GtkTextView__symbol, xg_GtkTextTagTableForeach_symbol, xg_GtkTextSearchFlags_symbol, xg_GtkTextCharPredicate_symbol, xg_GtkTextMark__symbol, xg_GtkTextChildAnchor__symbol, xg_GtkTextIter__symbol, xg_GtkTextTagTable__symbol, xg_GtkTextBuffer__symbol, xg_GtkStatusbar__symbol, xg_GtkSpinType_symbol, xg_GtkSpinButtonUpdatePolicy_symbol, xg_GtkSpinButton__symbol, xg_GtkSizeGroupMode_symbol, xg_GtkSizeGroup__symbol, xg_GtkSettings__symbol, xg_GtkSelectionData__symbol, xg_GtkCornerType_symbol, xg_GtkPolicyType_symbol, xg_GtkScrolledWindow__symbol, xg_GtkScale__symbol, xg_GtkRange__symbol, xg_GtkRadioMenuItem__symbol, xg_GtkRadioButton__symbol, xg_GtkProgressBar__symbol, xg_GtkPaned__symbol, xg_GtkPositionType_symbol, xg_GtkNotebook__symbol, xg_GtkMenuShell__symbol, xg_gint__symbol, xg_GtkMenuItem__symbol, xg_GtkMenu__symbol, xg_PangoLanguage__symbol, xg_GtkListStore__symbol, xg_GtkLayout__symbol, xg_GtkJustification_symbol, xg_GtkLabel__symbol, xg_guint16__symbol, xg_GtkIMContextSimple__symbol, xg_GdkEventKey__symbol, xg_PangoAttrList__symbol, xg_GtkIMContext__symbol, xg_GtkImageType_symbol, xg_GtkImage__symbol, xg_GtkShadowType_symbol, xg_GtkFrame__symbol, xg_GtkFixed__symbol, xg_PangoLayout__symbol, xg_GtkEntry__symbol, xg_GtkEditable__symbol, xg_GdkAtom_symbol, xg_etc_symbol, xg_GtkDialog__symbol, xg_GtkCallback_symbol, xg_GtkContainer__symbol, xg_GtkCheckMenuItem__symbol, xg_GtkCellRendererToggle__symbol, xg_GtkCellRendererText__symbol, xg_GtkCellRendererState_symbol, xg_GtkCellEditable__symbol, xg_GtkCalendar__symbol, xg_GtkReliefStyle_symbol, xg_GtkButton__symbol, xg_GtkBox__symbol, xg_GtkBin__symbol, xg_GtkBindingSet__symbol, xg_GtkButtonBox__symbol, xg_GtkButtonBoxStyle_symbol, xg_GtkAspectFrame__symbol, xg_GtkAdjustment__symbol, xg_GtkAccelMapForeach_symbol, xg_GtkAccelLabel__symbol, xg_GtkAccelGroupEntry__symbol, xg_lambda3_symbol, xg_GSList__symbol, xg_GObject__symbol, xg_GtkAccelFlags_symbol, xg_GtkAccelGroup__symbol, xg_GdkInterpType_symbol, xg_double_symbol, xg_gfloat_symbol, xg_guchar_symbol, xg_char___symbol, xg_GdkPixbufDestroyNotify_symbol, xg_GError__symbol, xg_char__symbol, xg_guchar__symbol, xg_GdkPixbuf__symbol, xg_GdkColorspace_symbol, xg_GdkCursor__symbol, xg_GdkWindowTypeHint_symbol, xg_GdkWindowHints_symbol, xg_GdkGeometry__symbol, xg_GdkWindowEdge_symbol, xg_GdkWMFunction_symbol, xg_GdkWMDecoration_symbol, xg_GdkEventMask_symbol, xg_GList__symbol, xg_GdkWindowState_symbol, xg_GdkFilterFunc_symbol, xg_GdkWindowType_symbol, xg_PangoDirection_symbol, xg_GdkKeymapKey__symbol, xg_GdkKeymap__symbol, xg_GdkRectangle__symbol, xg_GdkEventFunc_symbol, xg_gdouble_symbol, xg_guint32_symbol, xg_GdkDragAction_symbol, xg_GdkDragContext__symbol, xg_GSignalMatchType_symbol, xg_GConnectFlags_symbol, xg_GtkDestroyNotify_symbol, xg_GSignalEmissionHook_symbol, xg_gulong_symbol, xg_GSignalInvocationHint__symbol, xg_GQuark_symbol, xg_guint__symbol, xg_GSignalQuery__symbol, xg_GType__symbol, xg_GSignalCMarshaller_symbol, xg_GSignalAccumulator_symbol, xg_GSignalFlags_symbol, xg_GType_symbol, xg_GClosureNotify_symbol, xg_GCallback_symbol, xg_GNormalizeMode_symbol, xg_glong_symbol, xg_gssize_symbol, xg_gsize_symbol, xg_gunichar__symbol, xg_void_symbol, xg_int_symbol, xg_GtkDrawingArea__symbol, xg_GdkSeat__symbol, xg_gpointer_symbol, xg_GtkRecentInfo__symbol, xg_GLogLevelFlags_symbol, xg_GtkIconView__symbol, xg_GtkEntryCompletion__symbol, xg_GtkFileFilterInfo__symbol, xg_GtkTreeSelection__symbol, xg_GtkCellRenderer__symbol, xg_gint_symbol, xg_GtkTreeViewColumn__symbol, xg_GtkTreeView__symbol, xg_gunichar_symbol, xg_GtkTreeIter__symbol, xg_GtkTreePath__symbol, xg_GtkTreeModel__symbol, xg_gboolean_symbol, xg_GdkModifierType_symbol, xg_guint_symbol, xg_gchar__symbol, xg_GtkTextTag__symbol, xg_GdkXEvent__symbol, xg_GtkWidget__symbol, xg_lambda_data_symbol, xg_GClosure__symbol, xg_GtkAccelKey__symbol, xg_GdkEventMotion__symbol, xg_gdouble__symbol, xg_GdkEventAny__symbol, xg_GdkEvent__symbol, xg_GdkWindow__symbol, xg_cairo_t__symbol, xg_cairo_font_options_t__symbol, xg_PangoFontDescription__symbol, xg_GtkCellRendererPixbuf__symbol, xg_GtkSeparator__symbol, xg_GtkSeparatorMenuItem__symbol, xg_GdkEventExpose__symbol, xg_GdkEventNoExpose__symbol, xg_GdkEventVisibility__symbol, xg_GdkEventButton__symbol, xg_GdkEventCrossing__symbol, xg_GdkEventFocus__symbol, xg_GdkEventConfigure__symbol, xg_GdkEventProperty__symbol, xg_GdkEventSelection__symbol, xg_GdkEventProximity__symbol, xg_GdkEventSetting__symbol, xg_GdkEventWindowState__symbol, xg_GdkEventDND__symbol, xg_GtkFileChooserDialog__symbol, xg_GtkFileChooserWidget__symbol, xg_GtkColorButton__symbol, xg_GtkAccelMap_symbol, xg_GtkCellRendererCombo__symbol, xg_GtkCellRendererProgress__symbol, xg_GtkCellRendererAccel__symbol, xg_GtkCellRendererSpin__symbol, xg_GtkRecentChooserDialog__symbol, xg_GtkRecentChooserWidget__symbol, xg_GtkCellRendererSpinner__symbol, xg_GtkFontChooserDialog__symbol, xg_GtkFontChooserWidget__symbol, xg_GtkColorChooserDialog__symbol, xg_GtkColorWidget__symbol, xg_GtkGestureLongPress__symbol, xg_idler_symbol;

#define wrap_for_Xen(Name, Value) Xen_list_2(xg_ ## Name ## _symbol, Xen_wrap_C_pointer(Value))
#define is_wrapped(Name, Value) (Xen_is_pair(Value) && (Xen_car(Value) == xg_ ## Name ## _symbol))

#define Xm_type(Name, XType) \
  static Xen C_to_Xen_ ## Name (XType val) {return(Xen_list_2(xg_ ## Name ## _symbol, C_ulong_to_Xen_ulong(val)));} \
  static XType Xen_to_C_ ## Name (Xen val) {return((XType)Xen_ulong_to_C_ulong(Xen_cadr(val)));} \
  static bool Xen_is_ ## Name (Xen val) {return(is_wrapped(Name, val));}

#define Xm_type_1(Name, XType) \
  static XType Xen_to_C_ ## Name (Xen val) {return((XType)Xen_ulong_to_C_ulong(Xen_cadr(val)));} \
  static bool Xen_is_ ## Name (Xen val) {return(is_wrapped(Name, val));}

#define Xm_type_no_p_2(Name, XType) \
  static Xen C_to_Xen_ ## Name (XType val) {return(wrap_for_Xen(Name, val));}

#define Xm_type_Ptr(Name, XType) \
  static Xen C_to_Xen_ ## Name (XType val) {if (val) return(wrap_for_Xen(Name, val)); return(Xen_false);} \
  static XType Xen_to_C_ ## Name (Xen val) {if (Xen_is_false(val)) return(NULL); return((XType)Xen_unwrap_C_pointer(Xen_cadr(val)));} \
  static bool Xen_is_ ## Name (Xen val) {return(is_wrapped(Name, val));}

#define Xm_type_Ptr_1(Name, XType) \
  static XType Xen_to_C_ ## Name (Xen val) {if (Xen_is_false(val)) return(NULL); return((XType)Xen_unwrap_C_pointer(Xen_cadr(val)));} \
  static bool Xen_is_ ## Name (Xen val) {return(is_wrapped(Name, val));}

#define Xm_type_Ptr_2(Name, XType) \
  static Xen C_to_Xen_ ## Name (XType val) {if (val) return(wrap_for_Xen(Name, val)); return(Xen_false);} \

/* type checks for callback wrappers */
#define Xen_is_lambda3(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GtkCallback(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 2)))
#define Xen_is_GSourceFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 1)))
#define Xen_is_GtkDestroyNotify(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 1)))
#define Xen_is_GdkFilterFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GdkEventFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 2)))
#define Xen_is_GtkTextTagTableForeach(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 2)))
#define Xen_is_GtkAccelMapForeach(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 5)))
#define Xen_is_GtkTreeModelForeachFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 4)))
#define Xen_is_GtkTreeSelectionForeachFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 4)))
#define Xen_is_GtkTextCharPredicate(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 2)))
#define Xen_is_GtkTreeViewColumnDropFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 5)))
#define Xen_is_GtkTreeViewMappingFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GtkTreeViewSearchEqualFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 5)))
#define Xen_is_GtkTreeCellDataFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 5)))
#define Xen_is_GtkTreeIterCompareFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 4)))
#define Xen_is_GtkTreeSelectionFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 5)))
#define Xen_is_GtkFileFilterFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 2)))
#define Xen_is_GtkEntryCompletionMatchFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 4)))
#define Xen_is_GtkTreeViewRowSeparatorFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GtkIconViewForeachFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GLogFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 4)))
#define Xen_is_GtkTreeViewSearchPositionFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GtkAssistantPageFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 2)))
#define Xen_is_GtkRecentSortFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GDestroyNotify(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 1)))
#define Xen_is_GdkSeatGrabPrepareFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 3)))
#define Xen_is_GtkDrawingAreaDrawFunc(Arg)  Xen_is_false(Arg) || (Xen_is_procedure(Arg) && (Xen_is_aritable(Arg, 5)))
#define Xen_is_GCallback(Arg) (Xen_is_procedure(Arg) && ((Xen_is_aritable(Arg, 2)) || (Xen_is_aritable(Arg, 3)) || (Xen_is_aritable(Arg, 4))))
#define Xen_to_C_lambda3(Arg) Xen_is_false(Arg) ? NULL : gxg_find_func
#define Xen_to_C_GtkCallback(Arg) Xen_is_false(Arg) ? NULL : gxg_func2
#define Xen_to_C_GSourceFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_timer_func
#define Xen_to_C_GtkDestroyNotify(Arg) Xen_is_false(Arg) ? NULL : gxg_destroy_func
#define Xen_to_C_GdkFilterFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_filter_func
#define Xen_to_C_GdkEventFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_event_func
#define Xen_to_C_GtkTextTagTableForeach(Arg) Xen_is_false(Arg) ? NULL : gxg_text_tag_table_foreach
#define Xen_to_C_GtkAccelMapForeach(Arg) Xen_is_false(Arg) ? NULL : gxg_accel_map_foreach
#define Xen_to_C_GtkTreeModelForeachFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_model_func
#define Xen_to_C_GtkTreeSelectionForeachFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_tree_selection_func
#define Xen_to_C_GtkTextCharPredicate(Arg) Xen_is_false(Arg) ? NULL : gxg_text_char_predicate
#define Xen_to_C_GtkTreeViewColumnDropFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_tree_column
#define Xen_to_C_GtkTreeViewMappingFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_tree_mapping
#define Xen_to_C_GtkTreeViewSearchEqualFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_tree_search
#define Xen_to_C_GtkTreeCellDataFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_cell_data
#define Xen_to_C_GtkTreeIterCompareFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_iter_compare
#define Xen_to_C_GtkTreeSelectionFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_tree_selection
#define Xen_to_C_GtkFileFilterFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_file_filter
#define Xen_to_C_GtkEntryCompletionMatchFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_entry_completion_match
#define Xen_to_C_GtkTreeViewRowSeparatorFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_row_separator
#define Xen_to_C_GtkIconViewForeachFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_icon_view_foreach
#define Xen_to_C_GLogFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_g_message_log_func
#define Xen_to_C_GtkTreeViewSearchPositionFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_search_position
#define Xen_to_C_GtkAssistantPageFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_page_func
#define Xen_to_C_GtkRecentSortFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_recent_sort
#define Xen_to_C_GDestroyNotify(Arg) Xen_is_false(Arg) ? NULL : gxg_destroy_func
#define Xen_to_C_GdkSeatGrabPrepareFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_prepare_func
#define Xen_to_C_GtkDrawingAreaDrawFunc(Arg) Xen_is_false(Arg) ? NULL : gxg_draw_func
#define Xen_to_C_GCallback(Arg) ((Xen_is_aritable(Arg, 4)) ? (GCallback)gxg_func4 : ((Xen_is_aritable(Arg, 3)) ? (GCallback)gxg_func3 : (GCallback)gxg_func2))
#define Xen_to_C_lambda_data(Arg) (gpointer)gxg_ptr
#define Xen_is_lambda_data(Arg) 1
#define C_to_Xen_GtkTreeViewSearchPositionFunc(Arg) wrap_for_Xen(GtkTreeViewSearchPositionFunc, Arg)
#define C_to_Xen_GtkTreeViewSearchEqualFunc(Arg) wrap_for_Xen(GtkTreeViewSearchEqualFunc, Arg)
#define Xen_to_C_GdkFilterReturn(Arg) (GdkFilterReturn)Xen_integer_to_C_int(Arg)
#define C_to_Xen_String(Arg) C_string_to_Xen_string((char *)Arg)
static Xen C_to_Xen_GError_(GError *err)
{
  if (err)
    {
      Xen msg;
      msg = C_string_to_Xen_string(err->message);
      g_error_free(err);
      return(msg);
    }
  return(Xen_false);
}


/* ---------------------------------------- types ---------------------------------------- */

Xm_type_Ptr(PangoFontDescription_, PangoFontDescription*)
Xm_type_Ptr(cairo_font_options_t_, cairo_font_options_t*)
Xm_type_Ptr(cairo_t_, cairo_t*)
Xm_type_Ptr(GdkWindow_, GdkWindow*)
Xm_type_Ptr(GdkEvent_, GdkEvent*)
Xm_type_Ptr_2(GdkEventAny_, GdkEventAny*)
Xm_type_Ptr_1(gdouble_, gdouble*)
Xm_type_Ptr(GtkAccelKey_, GtkAccelKey*)
Xm_type_Ptr(GClosure_, GClosure*)
Xm_type_Ptr(GtkWidget_, GtkWidget*)
Xm_type_Ptr_2(GdkXEvent_, GdkXEvent*)
Xm_type_Ptr(GtkTextTag_, GtkTextTag*)
#define C_to_Xen_gchar_(Arg) C_string_to_Xen_string(Arg)
#define Xen_to_C_gchar_(Arg) (gchar*)(Xen_string_to_C_string(Arg))
#define Xen_is_gchar_(Arg) Xen_is_string(Arg)
#define C_to_Xen_guint(Arg) C_ulong_to_Xen_ulong(Arg)
#define Xen_to_C_guint(Arg) (guint)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_guint(Arg) Xen_is_ulong(Arg)
#define C_to_Xen_GdkModifierType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkModifierType(Arg) (GdkModifierType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkModifierType(Arg) Xen_is_integer(Arg)
#define C_to_Xen_gboolean(Arg) C_bool_to_Xen_boolean(Arg)
#define Xen_to_C_gboolean(Arg) (gboolean)(Xen_boolean_to_C_bool(Arg))
#define Xen_is_gboolean(Arg) Xen_is_boolean(Arg)
Xm_type_Ptr(GtkTreeModel_, GtkTreeModel*)
Xm_type_Ptr(GtkTreePath_, GtkTreePath*)
Xm_type_Ptr(GtkTreeIter_, GtkTreeIter*)
#define C_to_Xen_gunichar(Arg) C_ulong_to_Xen_ulong(Arg)
#define Xen_to_C_gunichar(Arg) (gunichar)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_gunichar(Arg) Xen_is_ulong(Arg)
Xm_type_Ptr(GtkTreeView_, GtkTreeView*)
Xm_type_Ptr(GtkTreeViewColumn_, GtkTreeViewColumn*)
#define C_to_Xen_gint(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_gint(Arg) (gint)(Xen_integer_to_C_int(Arg))
#define Xen_is_gint(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkCellRenderer_, GtkCellRenderer*)
Xm_type_Ptr(GtkTreeSelection_, GtkTreeSelection*)
Xm_type_Ptr(GtkFileFilterInfo_, GtkFileFilterInfo*)
Xm_type_Ptr(GtkEntryCompletion_, GtkEntryCompletion*)
Xm_type_Ptr(GtkIconView_, GtkIconView*)
#define C_to_Xen_GLogLevelFlags(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GLogLevelFlags(Arg) (GLogLevelFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GLogLevelFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkRecentInfo_, GtkRecentInfo*)
Xm_type_Ptr(gpointer, gpointer)
#define Xen_to_C_gunichar_(Arg) (gunichar*)(Xen_string_to_C_string(Arg))
#define Xen_is_gunichar_(Arg) Xen_is_string(Arg)
#define C_to_Xen_gsize(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_gsize(Arg) (gsize)(Xen_integer_to_C_int(Arg))
#define Xen_is_gsize(Arg) Xen_is_integer(Arg)
#define Xen_to_C_gssize(Arg) (gssize)(Xen_integer_to_C_int(Arg))
#define Xen_is_gssize(Arg) Xen_is_integer(Arg)
#define C_to_Xen_glong(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GNormalizeMode(Arg) (GNormalizeMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_GNormalizeMode(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GClosureNotify, GClosureNotify)
#define C_to_Xen_GType(Arg) C_ulong_to_Xen_ulong(Arg)
#define Xen_to_C_GType(Arg) (GType)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_GType(Arg) Xen_is_ulong(Arg)
#define Xen_to_C_GSignalFlags(Arg) (GSignalFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GSignalFlags(Arg) Xen_is_integer(Arg)
Xm_type_1(GSignalAccumulator, GSignalAccumulator)
Xm_type_1(GSignalCMarshaller, GSignalCMarshaller)
Xm_type_Ptr_1(GType_, GType*)
Xm_type_Ptr_1(GSignalQuery_, GSignalQuery*)
Xm_type_Ptr(guint_, guint*)
#define C_to_Xen_GQuark(Arg) C_ulong_to_Xen_ulong(Arg)
#define Xen_to_C_GQuark(Arg) (GQuark)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_GQuark(Arg) Xen_is_ulong(Arg)
Xm_type_Ptr_2(GSignalInvocationHint_, GSignalInvocationHint*)
#define C_to_Xen_gulong(Arg) C_ulong_to_Xen_ulong(Arg)
#define Xen_to_C_gulong(Arg) (gulong)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_gulong(Arg) Xen_is_ulong(Arg)
Xm_type_1(GSignalEmissionHook, GSignalEmissionHook)
#define Xen_to_C_GConnectFlags(Arg) (GConnectFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GConnectFlags(Arg) Xen_is_integer(Arg)
#define Xen_to_C_GSignalMatchType(Arg) (GSignalMatchType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GSignalMatchType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GdkDragContext_, GdkDragContext*)
#define Xen_to_C_GdkDragAction(Arg) (GdkDragAction)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkDragAction(Arg) Xen_is_integer(Arg)
#define C_to_Xen_guint32(Arg) C_ulong_to_Xen_ulong(Arg)
#define Xen_to_C_guint32(Arg) (guint32)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_guint32(Arg) Xen_is_ulong(Arg)
#define C_to_Xen_gdouble(Arg) C_double_to_Xen_real(Arg)
#define Xen_to_C_gdouble(Arg) (gdouble)(Xen_real_to_C_double(Arg))
#define Xen_is_gdouble(Arg) Xen_is_number(Arg)
Xm_type_Ptr_1(GdkRectangle_, GdkRectangle*)
Xm_type_Ptr_1(GdkKeymap_, GdkKeymap*)
Xm_type_Ptr(GdkKeymapKey_, GdkKeymapKey*)
#define C_to_Xen_PangoDirection(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoDirection(Arg) (PangoDirection)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoDirection(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GdkWindowType(Arg) C_int_to_Xen_integer(Arg)
#define C_to_Xen_GdkWindowState(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr(GList_, GList*)
#define C_to_Xen_GdkEventMask(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkEventMask(Arg) (GdkEventMask)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkEventMask(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GdkWMDecoration(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkWMDecoration(Arg) (GdkWMDecoration)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkWMDecoration(Arg) Xen_is_integer(Arg)
#define Xen_to_C_GdkWMFunction(Arg) (GdkWMFunction)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkWMFunction(Arg) Xen_is_integer(Arg)
#define Xen_to_C_GdkWindowEdge(Arg) (GdkWindowEdge)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkWindowEdge(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GdkGeometry_, GdkGeometry*)
#define Xen_to_C_GdkWindowHints(Arg) (GdkWindowHints)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkWindowHints(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GdkWindowTypeHint(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkWindowTypeHint(Arg) (GdkWindowTypeHint)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkWindowTypeHint(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GdkCursor_, GdkCursor*)
#define C_to_Xen_GdkColorspace(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkColorspace(Arg) (GdkColorspace)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkColorspace(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GdkPixbuf_, GdkPixbuf*)
#define C_to_Xen_int(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_int(Arg) (int)(Xen_integer_to_C_int(Arg))
#define Xen_is_int(Arg) Xen_is_integer(Arg)
#define C_to_Xen_guchar_(Arg) C_to_Xen_String(Arg)
#define Xen_to_C_guchar_(Arg) (guchar*)(Xen_string_to_C_string(Arg))
#define Xen_is_guchar_(Arg) Xen_is_string(Arg)
#define C_to_Xen_char_(Arg) C_string_to_Xen_string(Arg)
#define Xen_to_C_char_(Arg) (char*)(Xen_string_to_C_string(Arg))
#define Xen_is_char_(Arg) Xen_is_string(Arg)
Xm_type_1(GdkPixbufDestroyNotify, GdkPixbufDestroyNotify)
Xm_type_Ptr(char__, char**)
#define C_to_Xen_guchar(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_guchar(Arg) (guchar)(Xen_integer_to_C_int(Arg))
#define Xen_is_guchar(Arg) Xen_is_integer(Arg)
#define C_to_Xen_gfloat(Arg) C_double_to_Xen_real(Arg)
#define Xen_to_C_gfloat(Arg) (gfloat)(Xen_real_to_C_double(Arg))
#define Xen_is_gfloat(Arg) Xen_is_number(Arg)
#define C_to_Xen_double(Arg) C_double_to_Xen_real(Arg)
#define Xen_to_C_double(Arg) (double)(Xen_real_to_C_double(Arg))
#define Xen_to_C_GdkInterpType(Arg) (GdkInterpType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkInterpType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkAccelGroup_, GtkAccelGroup*)
#define Xen_to_C_GtkAccelFlags(Arg) (GtkAccelFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkAccelFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GObject_, GObject*)
Xm_type_Ptr(GSList_, GSList*)
Xm_type_Ptr_2(GtkAccelGroupEntry_, GtkAccelGroupEntry*)
Xm_type_Ptr_1(GtkAccelLabel_, GtkAccelLabel*)
Xm_type_Ptr(GtkAdjustment_, GtkAdjustment*)
Xm_type_Ptr_1(GtkAspectFrame_, GtkAspectFrame*)
#define C_to_Xen_GtkButtonBoxStyle(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkButtonBoxStyle(Arg) (GtkButtonBoxStyle)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkButtonBoxStyle(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkButtonBox_, GtkButtonBox*)
Xm_type_Ptr(GtkBindingSet_, GtkBindingSet*)
Xm_type_Ptr_1(GtkBin_, GtkBin*)
Xm_type_Ptr_1(GtkBox_, GtkBox*)
Xm_type_Ptr_1(GtkButton_, GtkButton*)
#define C_to_Xen_GtkReliefStyle(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkReliefStyle(Arg) (GtkReliefStyle)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkReliefStyle(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkCalendar_, GtkCalendar*)
Xm_type_Ptr(GtkCellEditable_, GtkCellEditable*)
#define Xen_to_C_GtkCellRendererState(Arg) (GtkCellRendererState)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkCellRendererState(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkCellRendererText_, GtkCellRendererText*)
Xm_type_Ptr_1(GtkCellRendererToggle_, GtkCellRendererToggle*)
Xm_type_Ptr_1(GtkCheckMenuItem_, GtkCheckMenuItem*)
Xm_type_Ptr_1(GtkContainer_, GtkContainer*)
Xm_type_Ptr_1(GtkDialog_, GtkDialog*)
#define Xen_is_etc(Arg) (Xen_is_list(Arg))
Xm_type(GdkAtom, GdkAtom)
Xm_type_Ptr_1(GtkEditable_, GtkEditable*)
Xm_type_Ptr(GtkEntry_, GtkEntry*)
Xm_type_Ptr(PangoLayout_, PangoLayout*)
Xm_type_Ptr_1(GtkFixed_, GtkFixed*)
Xm_type_Ptr_1(GtkFrame_, GtkFrame*)
#define C_to_Xen_GtkShadowType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkShadowType(Arg) (GtkShadowType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkShadowType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkImage_, GtkImage*)
#define C_to_Xen_GtkImageType(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr(GtkIMContext_, GtkIMContext*)
Xm_type_Ptr(PangoAttrList_, PangoAttrList*)
Xm_type_Ptr_1(GdkEventKey_, GdkEventKey*)
Xm_type_Ptr_1(GtkIMContextSimple_, GtkIMContextSimple*)
Xm_type_Ptr_1(guint16_, guint16*)
Xm_type_Ptr_1(GtkLabel_, GtkLabel*)
#define C_to_Xen_GtkJustification(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkJustification(Arg) (GtkJustification)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkJustification(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkLayout_, GtkLayout*)
Xm_type_Ptr(GtkListStore_, GtkListStore*)
Xm_type_Ptr(PangoLanguage_, PangoLanguage*)
Xm_type_Ptr(GtkMenu_, GtkMenu*)
Xm_type_Ptr_1(GtkMenuItem_, GtkMenuItem*)
Xm_type_Ptr(gint_, gint*)
Xm_type_Ptr_1(GtkMenuShell_, GtkMenuShell*)
Xm_type_Ptr_1(GtkNotebook_, GtkNotebook*)
#define C_to_Xen_GtkPositionType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPositionType(Arg) (GtkPositionType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPositionType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkPaned_, GtkPaned*)
Xm_type_Ptr_1(GtkProgressBar_, GtkProgressBar*)
Xm_type_Ptr_1(GtkRadioButton_, GtkRadioButton*)
Xm_type_Ptr_1(GtkRadioMenuItem_, GtkRadioMenuItem*)
Xm_type_Ptr_1(GtkRange_, GtkRange*)
Xm_type_Ptr_1(GtkScale_, GtkScale*)
Xm_type_Ptr_1(GtkScrolledWindow_, GtkScrolledWindow*)
#define C_to_Xen_GtkPolicyType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPolicyType(Arg) (GtkPolicyType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPolicyType(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkCornerType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkCornerType(Arg) (GtkCornerType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkCornerType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkSelectionData_, GtkSelectionData*)
Xm_type_Ptr(GtkSettings_, GtkSettings*)
Xm_type_Ptr(GtkSizeGroup_, GtkSizeGroup*)
#define C_to_Xen_GtkSizeGroupMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkSizeGroupMode(Arg) (GtkSizeGroupMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkSizeGroupMode(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkSpinButton_, GtkSpinButton*)
#define C_to_Xen_GtkSpinButtonUpdatePolicy(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkSpinButtonUpdatePolicy(Arg) (GtkSpinButtonUpdatePolicy)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkSpinButtonUpdatePolicy(Arg) Xen_is_integer(Arg)
#define Xen_to_C_GtkSpinType(Arg) (GtkSpinType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkSpinType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkStatusbar_, GtkStatusbar*)
Xm_type_Ptr(GtkTextBuffer_, GtkTextBuffer*)
Xm_type_Ptr(GtkTextTagTable_, GtkTextTagTable*)
Xm_type_Ptr(GtkTextIter_, GtkTextIter*)
Xm_type_Ptr(GtkTextChildAnchor_, GtkTextChildAnchor*)
Xm_type_Ptr(GtkTextMark_, GtkTextMark*)
#define Xen_to_C_GtkTextSearchFlags(Arg) (GtkTextSearchFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkTextSearchFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkTextView_, GtkTextView*)
#define Xen_to_C_GtkTextWindowType(Arg) (GtkTextWindowType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkTextWindowType(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkWrapMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkWrapMode(Arg) (GtkWrapMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkWrapMode(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(PangoTabArray_, PangoTabArray*)
Xm_type_Ptr_1(GtkToggleButton_, GtkToggleButton*)
Xm_type_Ptr_1(GtkToolbar_, GtkToolbar*)
#define C_to_Xen_GtkToolbarStyle(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkToolbarStyle(Arg) (GtkToolbarStyle)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkToolbarStyle(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkTreeDragSource_, GtkTreeDragSource*)
Xm_type_Ptr_1(GtkTreeDragDest_, GtkTreeDragDest*)
Xm_type_Ptr(GtkTreeRowReference_, GtkTreeRowReference*)
#define C_to_Xen_GtkTreeModelFlags(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr_1(GtkTreeModelSort_, GtkTreeModelSort*)
#define C_to_Xen_GtkSelectionMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkSelectionMode(Arg) (GtkSelectionMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkSelectionMode(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkTreeModel__, GtkTreeModel**)
Xm_type_Ptr_1(GtkTreeSortable_, GtkTreeSortable*)
#define C_to_Xen_GtkSortType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkSortType(Arg) (GtkSortType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkSortType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkTreeStore_, GtkTreeStore*)
#define C_to_Xen_GtkTreeViewColumnSizing(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkTreeViewColumnSizing(Arg) (GtkTreeViewColumnSizing)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkTreeViewColumnSizing(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkTreeViewDropPosition(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkTreeViewDropPosition(Arg) (GtkTreeViewDropPosition)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkTreeViewDropPosition(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkViewport_, GtkViewport*)
#define Xen_to_C_GtkDirectionType(Arg) (GtkDirectionType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkDirectionType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_2(AtkObject_, AtkObject*)
Xm_type_Ptr(PangoContext_, PangoContext*)
#define C_to_Xen_GtkTextDirection(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkTextDirection(Arg) (GtkTextDirection)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkTextDirection(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkWindow_, GtkWindow*)
#define C_to_Xen_GtkWindowType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkWindowType(Arg) (GtkWindowType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkWindowType(Arg) Xen_is_integer(Arg)
#define Xen_to_C_GtkWindowPosition(Arg) (GtkWindowPosition)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkWindowPosition(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GdkGravity(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkGravity(Arg) (GdkGravity)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkGravity(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(PangoColor_, PangoColor*)
#define C_to_Xen_PangoAttrType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoAttrType(Arg) (PangoAttrType)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoAttrType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(PangoAttribute_, PangoAttribute*)
#define C_to_Xen_guint16(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_guint16(Arg) (guint16)(Xen_integer_to_C_int(Arg))
#define Xen_is_guint16(Arg) Xen_is_integer(Arg)
#define C_to_Xen_PangoStyle(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoStyle(Arg) (PangoStyle)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoStyle(Arg) Xen_is_integer(Arg)
#define C_to_Xen_PangoWeight(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoWeight(Arg) (PangoWeight)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoWeight(Arg) Xen_is_integer(Arg)
#define C_to_Xen_PangoVariant(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoVariant(Arg) (PangoVariant)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoVariant(Arg) Xen_is_integer(Arg)
#define C_to_Xen_PangoStretch(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoStretch(Arg) (PangoStretch)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoStretch(Arg) Xen_is_integer(Arg)
#define Xen_to_C_PangoUnderline(Arg) (PangoUnderline)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoUnderline(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(PangoRectangle_, PangoRectangle*)
Xm_type_Ptr(PangoAttrIterator_, PangoAttrIterator*)
Xm_type_Ptr_1(PangoAttrList__, PangoAttrList**)
Xm_type_Ptr_1(PangoAnalysis_, PangoAnalysis*)
Xm_type_Ptr(PangoLogAttr_, PangoLogAttr*)
Xm_type_Ptr_2(PangoFontFamily__, PangoFontFamily**)
Xm_type_Ptr(PangoFont_, PangoFont*)
Xm_type_Ptr_2(PangoFontset_, PangoFontset*)
Xm_type_Ptr(PangoFontMetrics_, PangoFontMetrics*)
Xm_type_Ptr(PangoCoverage_, PangoCoverage*)
#define C_to_Xen_PangoCoverageLevel(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoCoverageLevel(Arg) (PangoCoverageLevel)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoCoverageLevel(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(PangoFontDescription__, PangoFontDescription**)
#define C_to_Xen_PangoFontMask(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoFontMask(Arg) (PangoFontMask)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoFontMask(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(PangoFontFamily_, PangoFontFamily*)
Xm_type_Ptr_2(PangoFontFace__, PangoFontFace**)
Xm_type_Ptr(PangoFontFace_, PangoFontFace*)
#define Xen_to_C_PangoGlyph(Arg) (PangoGlyph)(Xen_ulong_to_C_ulong(Arg))
#define Xen_is_PangoGlyph(Arg) Xen_is_ulong(Arg)
Xm_type_Ptr(PangoFontMap_, PangoFontMap*)
Xm_type_Ptr(PangoGlyphString_, PangoGlyphString*)
Xm_type_Ptr(PangoItem_, PangoItem*)
#define C_to_Xen_PangoWrapMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoWrapMode(Arg) (PangoWrapMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoWrapMode(Arg) Xen_is_integer(Arg)
#define C_to_Xen_PangoAlignment(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoAlignment(Arg) (PangoAlignment)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoAlignment(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(int_, int*)
Xm_type_Ptr(PangoLayoutLine_, PangoLayoutLine*)
Xm_type_Ptr(PangoLayoutIter_, PangoLayoutIter*)
Xm_type_Ptr_2(PangoLayoutRun_, PangoLayoutRun*)
Xm_type_Ptr(GdkDisplay_, GdkDisplay*)
#define C_to_Xen_GtkCalendarDisplayOptions(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkCalendarDisplayOptions(Arg) (GtkCalendarDisplayOptions)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkCalendarDisplayOptions(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkToolItem_, GtkToolItem*)
#define C_to_Xen_GtkFileChooserAction(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkFileChooserAction(Arg) (GtkFileChooserAction)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkFileChooserAction(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkTreeModelFilter_, GtkTreeModelFilter*)
Xm_type_Ptr_1(GtkComboBox_, GtkComboBox*)
Xm_type_Ptr_1(GtkExpander_, GtkExpander*)
Xm_type_Ptr_1(GtkFontButton_, GtkFontButton*)
Xm_type_Ptr_1(GtkRadioToolButton_, GtkRadioToolButton*)
Xm_type_Ptr_1(GtkSeparatorToolItem_, GtkSeparatorToolItem*)
Xm_type_Ptr_1(GtkToggleToolButton_, GtkToggleToolButton*)
Xm_type_Ptr(GtkFileFilter_, GtkFileFilter*)
#define C_to_Xen_GtkFileFilterFlags(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkFileFilterFlags(Arg) (GtkFileFilterFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkFileFilterFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkCellLayout_, GtkCellLayout*)
Xm_type_1(GtkCellLayoutDataFunc, GtkCellLayoutDataFunc)
Xm_type_Ptr_1(GtkFileChooser_, GtkFileChooser*)
Xm_type_Ptr(GtkIconTheme_, GtkIconTheme*)
Xm_type_Ptr(gchar__, gchar**)
Xm_type_Ptr(GtkIconInfo_, GtkIconInfo*)
#define Xen_to_C_GtkIconLookupFlags(Arg) (GtkIconLookupFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkIconLookupFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkToolButton_, GtkToolButton*)
#define C_to_Xen_GtkOrientation(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkOrientation(Arg) (GtkOrientation)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkOrientation(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_2(GtkAccelMap_, GtkAccelMap*)
Xm_type_Ptr_1(GtkCellView_, GtkCellView*)
Xm_type_Ptr_1(GtkAboutDialog_, GtkAboutDialog*)
#define C_to_Xen_PangoEllipsizeMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_PangoEllipsizeMode(Arg) (PangoEllipsizeMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoEllipsizeMode(Arg) Xen_is_integer(Arg)
Xm_type_1(PangoAttrFilterFunc, PangoAttrFilterFunc)
#define C_to_Xen_PangoScript(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr(PangoScriptIter_, PangoScriptIter*)
Xm_type_Ptr_1(GtkFileChooserButton_, GtkFileChooserButton*)
Xm_type_Ptr_1(GtkMenuToolButton_, GtkMenuToolButton*)
Xm_type_Ptr_1(PangoRenderer_, PangoRenderer*)
#define Xen_to_C_PangoRenderPart(Arg) (PangoRenderPart)(Xen_integer_to_C_int(Arg))
#define Xen_is_PangoRenderPart(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(PangoMatrix_, PangoMatrix*)
Xm_type_Ptr_1(GValue_, GValue*)
#define C_to_Xen_GtkIconViewDropPosition(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkIconViewDropPosition(Arg) (GtkIconViewDropPosition)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkIconViewDropPosition(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkPackDirection(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPackDirection(Arg) (GtkPackDirection)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPackDirection(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkMenuBar_, GtkMenuBar*)
Xm_type_Ptr_1(GtkAssistant_, GtkAssistant*)
#define C_to_Xen_GtkAssistantPageType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkAssistantPageType(Arg) (GtkAssistantPageType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkAssistantPageType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkLinkButton_, GtkLinkButton*)
Xm_type_Ptr_1(GtkRecentChooser_, GtkRecentChooser*)
#define C_to_Xen_GtkRecentSortType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkRecentSortType(Arg) (GtkRecentSortType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkRecentSortType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkRecentFilter_, GtkRecentFilter*)
Xm_type_Ptr(GtkRecentManager_, GtkRecentManager*)
Xm_type_Ptr_1(GtkRecentChooserMenu_, GtkRecentChooserMenu*)
Xm_type_no_p_2(time_t, time_t)
Xm_type_Ptr_1(GtkRecentData_, GtkRecentData*)
#define C_to_Xen_GtkTreeViewGridLines(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkTreeViewGridLines(Arg) (GtkTreeViewGridLines)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkTreeViewGridLines(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkPrintContext_, GtkPrintContext*)
Xm_type_Ptr(GtkPageSetup_, GtkPageSetup*)
Xm_type_Ptr(GtkPrintOperation_, GtkPrintOperation*)
Xm_type_Ptr(GtkPrintSettings_, GtkPrintSettings*)
#define Xen_to_C_GtkUnit(Arg) (GtkUnit)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkUnit(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkPrintOperationResult(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPrintOperationAction(Arg) (GtkPrintOperationAction)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPrintOperationAction(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkPrintStatus(Arg) C_int_to_Xen_integer(Arg)
Xm_type_1(GtkPageSetupDoneFunc, GtkPageSetupDoneFunc)
Xm_type_1(GtkPrintSettingsFunc, GtkPrintSettingsFunc)
#define C_to_Xen_GtkPageOrientation(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPageOrientation(Arg) (GtkPageOrientation)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPageOrientation(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkPaperSize_, GtkPaperSize*)
#define C_to_Xen_GtkPrintDuplex(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPrintDuplex(Arg) (GtkPrintDuplex)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPrintDuplex(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkPrintQuality(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPrintQuality(Arg) (GtkPrintQuality)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPrintQuality(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkPrintPages(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPrintPages(Arg) (GtkPrintPages)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPrintPages(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkPageRange_, GtkPageRange*)
#define C_to_Xen_GtkPageSet(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPageSet(Arg) (GtkPageSet)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPageSet(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkTooltip_, GtkTooltip*)
#if GTK_CHECK_VERSION(2, 14, 0)
Xm_type_1(GtkCalendarDetailFunc, GtkCalendarDetailFunc)
Xm_type_Ptr_1(GtkScaleButton_, GtkScaleButton*)
#define C_to_Xen_GtkSensitivityType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkSensitivityType(Arg) (GtkSensitivityType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkSensitivityType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GFile_, GFile*)
#endif

#if GTK_CHECK_VERSION(2, 16, 0)
#define Xen_to_C_GtkEntryIconPosition(Arg) (GtkEntryIconPosition)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkEntryIconPosition(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(2, 18, 0)
Xm_type_Ptr_1(GtkInfoBar_, GtkInfoBar*)
#define C_to_Xen_GtkMessageType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkMessageType(Arg) (GtkMessageType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkMessageType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkEntryBuffer_, GtkEntryBuffer*)
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
Xm_type_Ptr_1(GtkSpinner_, GtkSpinner*)
#define Xen_to_C_GtkPackType(Arg) (GtkPackType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPackType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkToolPalette_, GtkToolPalette*)
Xm_type_Ptr(GtkToolItemGroup_, GtkToolItemGroup*)
#define Xen_to_C_GtkToolPaletteDragTargets(Arg) (GtkToolPaletteDragTargets)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkToolPaletteDragTargets(Arg) Xen_is_integer(Arg)
#define Xen_to_C_GtkDestDefaults(Arg) (GtkDestDefaults)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkDestDefaults(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
Xm_type_Ptr_1(GdkModifierType_, GdkModifierType*)
Xm_type_Ptr_1(GtkAccessible_, GtkAccessible*)
Xm_type_Ptr(GdkDevice_, GdkDevice*)
Xm_type_Ptr_1(GtkMessageDialog_, GtkMessageDialog*)
Xm_type_Ptr(cairo_region_t_, cairo_region_t*)
#define C_to_Xen_GtkSizeRequestMode(Arg) C_int_to_Xen_integer(Arg)
#define C_to_Xen_GtkAlign(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkAlign(Arg) (GtkAlign)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkAlign(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkComboBoxText_, GtkComboBoxText*)
Xm_type_Ptr(GdkRGBA_, GdkRGBA*)
Xm_type_Ptr_1(GtkGrid_, GtkGrid*)
Xm_type_Ptr_1(GtkScrollable_, GtkScrollable*)
#define C_to_Xen_GtkScrollablePolicy(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkScrollablePolicy(Arg) (GtkScrollablePolicy)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkScrollablePolicy(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkSwitch_, GtkSwitch*)
Xm_type_Ptr(GtkBorder_, GtkBorder*)
Xm_type_Ptr_1(GtkCellArea_, GtkCellArea*)
Xm_type_Ptr_1(GtkOrientable_, GtkOrientable*)
Xm_type_Ptr(GIcon_, GIcon*)
Xm_type_Ptr(GtkWindowGroup_, GtkWindowGroup*)
Xm_type_Ptr_1(GtkToolShell_, GtkToolShell*)
#define C_to_Xen_GtkStateFlags(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkStateFlags(Arg) (GtkStateFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkStateFlags(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
Xm_type_Ptr(GtkWidgetPath_, GtkWidgetPath*)
Xm_type_Ptr_1(GtkOverlay_, GtkOverlay*)
#define C_to_Xen_GdkScrollDirection(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr_1(GtkFontChooser_, GtkFontChooser*)
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
#define Xen_to_C_GdkModifierIntent(Arg) (GdkModifierIntent)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkModifierIntent(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(guint__, guint**)
Xm_type_Ptr(GMenuModel_, GMenuModel*)
Xm_type_Ptr_1(GtkApplication_, GtkApplication*)
Xm_type_Ptr_1(GtkApplicationWindow_, GtkApplicationWindow*)
Xm_type_Ptr_1(GtkColorChooser_, GtkColorChooser*)
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
Xm_type_Ptr_1(GtkMenuButton_, GtkMenuButton*)
Xm_type_Ptr_1(GtkLevelBar_, GtkLevelBar*)
#define C_to_Xen_GtkLevelBarMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkLevelBarMode(Arg) (GtkLevelBarMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkLevelBarMode(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkInputPurpose(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkInputPurpose(Arg) (GtkInputPurpose)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkInputPurpose(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkInputHints(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkInputHints(Arg) (GtkInputHints)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkInputHints(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
#define C_to_Xen_GdkFullscreenMode(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkFullscreenMode(Arg) (GdkFullscreenMode)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkFullscreenMode(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
#define C_to_Xen_GtkBaselinePosition(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkBaselinePosition(Arg) (GtkBaselinePosition)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkBaselinePosition(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GtkPlacesOpenFlags(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPlacesOpenFlags(Arg) (GtkPlacesOpenFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPlacesOpenFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkPlacesSidebar_, GtkPlacesSidebar*)
Xm_type_Ptr_1(GtkStackSwitcher_, GtkStackSwitcher*)
Xm_type_Ptr(GtkStack_, GtkStack*)
#define C_to_Xen_GtkStackTransitionType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkStackTransitionType(Arg) (GtkStackTransitionType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkStackTransitionType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkRevealer_, GtkRevealer*)
#define C_to_Xen_GtkRevealerTransitionType(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkRevealerTransitionType(Arg) (GtkRevealerTransitionType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkRevealerTransitionType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkHeaderBar_, GtkHeaderBar*)
Xm_type_Ptr(GtkListBoxRow_, GtkListBoxRow*)
Xm_type_Ptr_1(GtkListBox_, GtkListBox*)
Xm_type_Ptr_1(GtkSearchBar_, GtkSearchBar*)
#define C_to_Xen_GdkEventType(Arg) C_int_to_Xen_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
Xm_type_Ptr(GtkFlowBoxChild_, GtkFlowBoxChild*)
Xm_type_Ptr_1(GtkFlowBox_, GtkFlowBox*)
Xm_type_Ptr_1(GtkActionBar_, GtkActionBar*)
Xm_type_Ptr_1(GtkPopover_, GtkPopover*)
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
Xm_type_Ptr_1(GtkAllocation_, GtkAllocation*)
Xm_type_Ptr(GtkGesture_, GtkGesture*)
#define C_to_Xen_GtkEventSequenceState(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkEventSequenceState(Arg) (GtkEventSequenceState)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkEventSequenceState(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GdkEventSequence_, GdkEventSequence*)
Xm_type_Ptr_1(GtkGestureDrag_, GtkGestureDrag*)
Xm_type_Ptr_1(GtkGesturePan_, GtkGesturePan*)
Xm_type_Ptr_1(GtkGestureMultiPress_, GtkGestureMultiPress*)
Xm_type_Ptr_1(GtkGestureRotate_, GtkGestureRotate*)
Xm_type_Ptr_1(GtkGestureSingle_, GtkGestureSingle*)
Xm_type_Ptr_1(GtkGestureSwipe_, GtkGestureSwipe*)
Xm_type_Ptr_1(GtkGestureZoom_, GtkGestureZoom*)
Xm_type_Ptr_1(GtkEventController_, GtkEventController*)
#define C_to_Xen_GtkPropagationPhase(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPropagationPhase(Arg) (GtkPropagationPhase)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPropagationPhase(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
Xm_type_Ptr_1(GtkGLArea_, GtkGLArea*)
Xm_type_Ptr(GdkGLContext_, GdkGLContext*)
Xm_type_Ptr(GtkStyleContext_, GtkStyleContext*)
Xm_type_Ptr_1(GtkPopoverMenu_, GtkPopoverMenu*)
Xm_type_Ptr_1(GtkSearchEntry_, GtkSearchEntry*)
Xm_type_Ptr_1(GtkStackSidebar_, GtkStackSidebar*)
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
Xm_type_Ptr(GdkSeat_, GdkSeat*)
Xm_type_Ptr_1(GtkShortcutsWindow_, GtkShortcutsWindow*)
#define C_to_Xen_GtkPopoverConstraint(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkPopoverConstraint(Arg) (GtkPopoverConstraint)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPopoverConstraint(Arg) Xen_is_integer(Arg)
#define C_to_Xen_GdkGrabStatus(Arg) C_int_to_Xen_integer(Arg)
#define C_to_Xen_GdkSeatCapabilities(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GdkSeatCapabilities(Arg) (GdkSeatCapabilities)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkSeatCapabilities(Arg) Xen_is_integer(Arg)
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
#define C_to_Xen_GdkAxisFlags(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr(GdkDeviceTool_, GdkDeviceTool*)
Xm_type_Ptr(GdkMonitor_, GdkMonitor*)
#define C_to_Xen_GdkSubpixelLayout(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr(GdkDrawingContext_, GdkDrawingContext*)
Xm_type_Ptr_1(GdkDevicePad_, GdkDevicePad*)
#define Xen_to_C_GdkDevicePadFeature(Arg) (GdkDevicePadFeature)(Xen_integer_to_C_int(Arg))
#define Xen_is_GdkDevicePadFeature(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkPadController_, GtkPadController*)
Xm_type_Ptr_1(GActionGroup_, GActionGroup*)
Xm_type_Ptr_1(GtkPadActionEntry_, GtkPadActionEntry*)
#define Xen_to_C_GtkPadActionType(Arg) (GtkPadActionType)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkPadActionType(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkShortcutLabel_, GtkShortcutLabel*)
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
Xm_type_Ptr(GtkDrawingArea_, GtkDrawingArea*)
#define C_to_Xen_int(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_int(Arg) (int)(Xen_integer_to_C_int(Arg))
#define Xen_is_int(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GdkDrawContext_, GdkDrawContext*)
Xm_type_Ptr_1(GtkCheckButton_, GtkCheckButton*)
Xm_type_Ptr_1(GtkCenterBox_, GtkCenterBox*)
Xm_type_Ptr_1(GtkScrollbar_, GtkScrollbar*)
Xm_type_Ptr_1(GdkEventScroll_, GdkEventScroll*)
Xm_type_Ptr_1(GtkStyleProvider_, GtkStyleProvider*)
Xm_type_Ptr_2(GtkCssSection_, GtkCssSection*)
Xm_type_Ptr(GdkFrameClock_, GdkFrameClock*)
#define Xen_to_C_GtkStyleContextPrintFlags(Arg) (GtkStyleContextPrintFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkStyleContextPrintFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkCssProvider_, GtkCssProvider*)
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
#define C_to_Xen_GdkCrossingMode(Arg) C_int_to_Xen_integer(Arg)
#define C_to_Xen_GdkNotifyType(Arg) C_int_to_Xen_integer(Arg)
#define C_to_Xen_GdkTouchpadGesturePhase(Arg) C_int_to_Xen_integer(Arg)
Xm_type_Ptr(GtkSnapshot_, GtkSnapshot*)
#define C_to_Xen_GtkEventControllerScrollFlags(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkEventControllerScrollFlags(Arg) (GtkEventControllerScrollFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkEventControllerScrollFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GtkEventControllerScroll_, GtkEventControllerScroll*)
Xm_type_Ptr(GdkAppLaunchContext_, GdkAppLaunchContext*)
Xm_type_Ptr(GdkClipboard_, GdkClipboard*)
Xm_type_Ptr(GdkContentFormats_, GdkContentFormats*)
Xm_type_Ptr(GdkContentProvider_, GdkContentProvider*)
Xm_type_Ptr(GCancellable_, GCancellable*)
Xm_type(GAsyncReadyCallback, GAsyncReadyCallback)
Xm_type_Ptr(GAsyncResult_, GAsyncResult*)
Xm_type_Ptr(GInputStream_, GInputStream*)
Xm_type_Ptr(har__, har**)
Xm_type_Ptr(GdkTexture_, GdkTexture*)
Xm_type_Ptr_1(GString_, GString*)
Xm_type(GdkContentFormatsBuilder, GdkContentFormatsBuilder)
Xm_type_Ptr(GdkContentFormatsBuilder_, GdkContentFormatsBuilder*)
Xm_type_Ptr(GOutputStream_, GOutputStream*)
Xm_type_Ptr(GdkContentSerializer_, GdkContentSerializer*)
Xm_type(GdkContentSerializeFunc, GdkContentSerializeFunc)
Xm_type_Ptr(GdkContentDeserializer_, GdkContentDeserializer*)
Xm_type(GdkContentDeserializeFunc, GdkContentDeserializeFunc)
Xm_type_Ptr(GBytes_, GBytes*)
Xm_type(GValue, GValue)
#define C_to_Xen_GtkIconSize(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_GtkIconSize(Arg) (GtkIconSize)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkIconSize(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(GtkInvisible_, GtkInvisible*)
Xm_type_Ptr(GdkDisplay_gtk_invisible_get_display, GdkDisplay*gtk_invisible_get_display)
Xm_type_Ptr(GdkAtom_, GdkAtom*)
Xm_type_Ptr(GtkContentFormats_, GtkContentFormats*)
Xm_type(GApplicationFlags, GApplicationFlags)
#define Xen_to_C_GtkApplicationInhibitFlags(Arg) (GtkApplicationInhibitFlags)(Xen_integer_to_C_int(Arg))
#define Xen_is_GtkApplicationInhibitFlags(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(GMenu_, GMenu*)
#endif

Xm_type_Ptr(cairo_surface_t_, cairo_surface_t*)
#define C_to_Xen_cairo_content_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_content_t(Arg) (cairo_content_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_content_t(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(cairo_pattern_t_, cairo_pattern_t*)
#define C_to_Xen_cairo_operator_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_operator_t(Arg) (cairo_operator_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_operator_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_antialias_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_antialias_t(Arg) (cairo_antialias_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_antialias_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_fill_rule_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_fill_rule_t(Arg) (cairo_fill_rule_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_fill_rule_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_line_cap_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_line_cap_t(Arg) (cairo_line_cap_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_line_cap_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_line_join_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_line_join_t(Arg) (cairo_line_join_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_line_join_t(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(cairo_matrix_t_, cairo_matrix_t*)
#define C_to_Xen_bool(Arg) C_bool_to_Xen_boolean(Arg)
#define Xen_to_C_bool(Arg) (bool)(Xen_boolean_to_C_bool(Arg))
#define Xen_is_bool(Arg) Xen_is_boolean(Arg)
#define C_to_Xen_cairo_status_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_status_t(Arg) (cairo_status_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_status_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_subpixel_order_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_subpixel_order_t(Arg) (cairo_subpixel_order_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_subpixel_order_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_hint_style_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_hint_style_t(Arg) (cairo_hint_style_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_hint_style_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_hint_metrics_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_hint_metrics_t(Arg) (cairo_hint_metrics_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_hint_metrics_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_font_slant_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_font_slant_t(Arg) (cairo_font_slant_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_font_slant_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_font_weight_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_font_weight_t(Arg) (cairo_font_weight_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_font_weight_t(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(cairo_scaled_font_t_, cairo_scaled_font_t*)
Xm_type_Ptr(cairo_glyph_t_, cairo_glyph_t*)
Xm_type_Ptr(cairo_font_face_t_, cairo_font_face_t*)
Xm_type_Ptr_1(cairo_font_extents_t_, cairo_font_extents_t*)
Xm_type_Ptr_1(cairo_text_extents_t_, cairo_text_extents_t*)
Xm_type_Ptr_1(cairo_user_data_key_t_, cairo_user_data_key_t*)
Xm_type_1(cairo_destroy_func_t, cairo_destroy_func_t)
Xm_type_Ptr(cairo_path_t_, cairo_path_t*)
#define C_to_Xen_cairo_format_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_format_t(Arg) (cairo_format_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_format_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_extend_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_extend_t(Arg) (cairo_extend_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_extend_t(Arg) Xen_is_integer(Arg)
#define C_to_Xen_cairo_filter_t(Arg) C_int_to_Xen_integer(Arg)
#define Xen_to_C_cairo_filter_t(Arg) (cairo_filter_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_filter_t(Arg) Xen_is_integer(Arg)
Xm_type_Ptr(void_, void*)
Xm_type_Ptr(cairo_rectangle_list_t_, cairo_rectangle_list_t*)
#if HAVE_CAIRO_1_8
Xm_type_Ptr(cairo_text_cluster_t_, cairo_text_cluster_t*)
#define Xen_to_C_cairo_text_cluster_flags_t(Arg) (cairo_text_cluster_flags_t)(Xen_integer_to_C_int(Arg))
#define Xen_is_cairo_text_cluster_flags_t(Arg) Xen_is_integer(Arg)
Xm_type_Ptr_1(cairo_glyph_t__, cairo_glyph_t**)
Xm_type_Ptr_1(cairo_text_cluster_t__, cairo_text_cluster_t**)
Xm_type_Ptr_1(cairo_text_cluster_flags_t_, cairo_text_cluster_flags_t*)
#define C_to_Xen_cairo_bool_t(Arg) C_int_to_Xen_integer(Arg)
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
Xm_type_Ptr(cairo_device_t_, cairo_device_t*)
Xm_type_Ptr_1(cairo_rectangle_t_, cairo_rectangle_t*)
Xm_type_Ptr_1(double_, double*)
Xm_type_Ptr_1(cairo_rectangle_int_t_, cairo_rectangle_int_t*)
Xm_type_no_p_2(cairo_region_overlap_t, cairo_region_overlap_t)
#endif

#define XLS(a, b) Xen_to_C_gchar_(Xen_list_ref(a, b))
#define XLI(a, b) ((int)Xen_integer_to_C_int(Xen_list_ref(a, b)))
#define XLL(a, b) (Xen_llong_to_C_llong(Xen_list_ref(a, b)))
#define XLG(a, b) Xen_to_C_GType(Xen_list_ref(a, b))
#define XLT(a, b) Xen_to_C_GtkTextTag_(Xen_list_ref(a, b))
#define XLA(a, b) ((Xen_is_integer(Xen_list_ref(a, b))) ? ((gpointer)((intptr_t)XLL(a, b))) : ((Xen_is_string(Xen_list_ref(a, b))) ? ((gpointer)XLS(a, b)) : ((gpointer)XLG(a, b))))

/* -------------------------------- gc protection -------------------------------- */

static Xen xm_protected;
static int xm_protected_size = 0;
static Xen xm_gc_table;
static int last_xm_unprotect = NOT_A_GC_LOC;

static int xm_protect(Xen obj)
{
  int i, new_size;
  Xen new_table;
  if (last_xm_unprotect >= 0)
    {
      i = last_xm_unprotect;
      if (Xen_is_false(Xen_vector_ref(xm_protected, i)))
	{
	  Xen_vector_set(xm_protected, i, obj);
	  last_xm_unprotect = NOT_A_GC_LOC;
	  return(i);
	}
      last_xm_unprotect = NOT_A_GC_LOC;
    }
  for (i = 0; i < xm_protected_size; i++)
    if (Xen_is_false(Xen_vector_ref(xm_protected, i)))
      {
	Xen_vector_set(xm_protected, i, obj);
	return(i);
      }
  new_size = xm_protected_size * 2;
  new_table = Xen_make_vector(new_size, Xen_false);
  for (i = 0; i < xm_protected_size; i++)
    {
      Xen_vector_set(new_table, i, Xen_vector_ref(xm_protected, i));
      Xen_vector_set(xm_protected, i, Xen_false);
    }
  Xen_vector_set(new_table, xm_protected_size, obj);
  Xen_vector_set(xm_gc_table, 0, new_table);
  i = xm_protected_size;
  xm_protected_size = new_size;
  xm_protected = new_table;
  return(i);
}

static void xm_unprotect_at(int ind)
{
  Xen_vector_set(xm_protected, ind, Xen_false);
  last_xm_unprotect = ind;
}



/* ---------------------------------------- callback handlers ---------------------------------------- */

static gboolean gxg_find_func(GtkAccelKey* key, GClosure* closure, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_3_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkAccelKey_(key),
                                      C_to_Xen_GClosure_(closure),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static void gxg_func2(GtkWidget* w, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_2_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkWidget_(w),
             Xen_cadr((Xen)func_info),
             __func__);
}

static gboolean gxg_timer_func(gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_1_arg(Xen_car((Xen)func_info),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static void gxg_destroy_func(gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_1_arg(Xen_cadddr((Xen)func_info),
             Xen_cadr((Xen)func_info),
             __func__);
}

static GdkFilterReturn gxg_filter_func(GdkXEvent* xevent, GdkEvent* event, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((GdkFilterReturn)0);
  return(Xen_to_C_GdkFilterReturn(Xen_call_with_3_args(Xen_car((Xen)func_info),
                                             C_to_Xen_GdkXEvent_(xevent),
                                             C_to_Xen_GdkEvent_(event),
                                             Xen_cadr((Xen)func_info),
                                             __func__)));
}

static void gxg_event_func(GdkEvent* event, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_2_args(Xen_car((Xen)func_info),
             C_to_Xen_GdkEvent_(event),
             Xen_cadr((Xen)func_info),
             __func__);
}

static void gxg_text_tag_table_foreach(GtkTextTag* tag, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_2_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkTextTag_(tag),
             Xen_cadr((Xen)func_info),
             __func__);
}

static void gxg_accel_map_foreach(gpointer func_info, const gchar* accel_path, guint accel_key, GdkModifierType accel_mods, gboolean changed)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_5_args(Xen_car((Xen)func_info),
             Xen_cadr((Xen)func_info),
             C_to_Xen_gchar_(accel_path),
             C_to_Xen_guint(accel_key),
             C_to_Xen_GdkModifierType(accel_mods),
             C_to_Xen_gboolean(changed),
             __func__);
}

static gboolean gxg_model_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_4_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkTreeModel_(model),
                                      C_to_Xen_GtkTreePath_(path),
                                      C_to_Xen_GtkTreeIter_(iter),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static void gxg_tree_selection_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_4_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkTreeModel_(model),
             C_to_Xen_GtkTreePath_(path),
             C_to_Xen_GtkTreeIter_(iter),
             Xen_cadr((Xen)func_info),
             __func__);
}

static gboolean gxg_text_char_predicate(gunichar ch, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_2_args(Xen_car((Xen)func_info),
                                      C_to_Xen_gunichar(ch),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static gboolean gxg_tree_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, GtkTreeViewColumn* prev_column, GtkTreeViewColumn* next_column, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_5_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkTreeView_(tree_view),
                                      C_to_Xen_GtkTreeViewColumn_(column),
                                      C_to_Xen_GtkTreeViewColumn_(prev_column),
                                      C_to_Xen_GtkTreeViewColumn_(next_column),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static void gxg_tree_mapping(GtkTreeView* tree_view, GtkTreePath* path, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_3_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkTreeView_(tree_view),
             C_to_Xen_GtkTreePath_(path),
             Xen_cadr((Xen)func_info),
             __func__);
}

static gboolean gxg_tree_search(GtkTreeModel* model, gint column, const gchar* key, GtkTreeIter* iter, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_5_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkTreeModel_(model),
                                      C_to_Xen_gint(column),
                                      C_to_Xen_gchar_(key),
                                      C_to_Xen_GtkTreeIter_(iter),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static void gxg_cell_data(GtkTreeViewColumn* tree_column, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_5_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkTreeViewColumn_(tree_column),
             C_to_Xen_GtkCellRenderer_(cell),
             C_to_Xen_GtkTreeModel_(tree_model),
             C_to_Xen_GtkTreeIter_(iter),
             Xen_cadr((Xen)func_info),
             __func__);
}

static gint gxg_iter_compare(GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gint)0);
  return(Xen_to_C_gint(Xen_call_with_4_args(Xen_car((Xen)func_info),
                                  C_to_Xen_GtkTreeModel_(model),
                                  C_to_Xen_GtkTreeIter_(a),
                                  C_to_Xen_GtkTreeIter_(b),
                                  Xen_cadr((Xen)func_info),
                                  __func__)));
}

static gboolean gxg_tree_selection(GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_5_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkTreeSelection_(selection),
                                      C_to_Xen_GtkTreeModel_(model),
                                      C_to_Xen_GtkTreePath_(path),
                                      C_to_Xen_gboolean(path_currently_selected),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static gboolean gxg_file_filter(const GtkFileFilterInfo* info, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_2_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkFileFilterInfo_((GtkFileFilterInfo *)info),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static gboolean gxg_entry_completion_match(GtkEntryCompletion* completion, const gchar* key, GtkTreeIter* iter, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_4_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkEntryCompletion_(completion),
                                      C_to_Xen_gchar_(key),
                                      C_to_Xen_GtkTreeIter_(iter),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static gboolean gxg_row_separator(GtkTreeModel* model, GtkTreeIter* iter, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gboolean)0);
  return(Xen_to_C_gboolean(Xen_call_with_3_args(Xen_car((Xen)func_info),
                                      C_to_Xen_GtkTreeModel_(model),
                                      C_to_Xen_GtkTreeIter_(iter),
                                      Xen_cadr((Xen)func_info),
                                      __func__)));
}

static void gxg_icon_view_foreach(GtkIconView* icon_view, GtkTreePath* path, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_3_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkIconView_(icon_view),
             C_to_Xen_GtkTreePath_(path),
             Xen_cadr((Xen)func_info),
             __func__);
}

static void gxg_g_message_log_func(const gchar* domain, GLogLevelFlags log_level, const gchar* message, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_4_args(Xen_car((Xen)func_info),
             C_to_Xen_gchar_(domain),
             C_to_Xen_GLogLevelFlags(log_level),
             C_to_Xen_gchar_(message),
             Xen_cadr((Xen)func_info),
             __func__);
}

static void gxg_search_position(GtkTreeView* tree_view, GtkWidget* search_dialog, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_3_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkTreeView_(tree_view),
             C_to_Xen_GtkWidget_(search_dialog),
             Xen_cadr((Xen)func_info),
             __func__);
}

static gint gxg_page_func(gint current_page, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gint)0);
  return(Xen_to_C_gint(Xen_call_with_2_args(Xen_car((Xen)func_info),
                                  C_to_Xen_gint(current_page),
                                  Xen_cadr((Xen)func_info),
                                  __func__)));
}

static gint gxg_recent_sort(GtkRecentInfo* a, GtkRecentInfo* b, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return((gint)0);
  return(Xen_to_C_gint(Xen_call_with_3_args(Xen_car((Xen)func_info),
                                  C_to_Xen_GtkRecentInfo_(a),
                                  C_to_Xen_GtkRecentInfo_(b),
                                  Xen_cadr((Xen)func_info),
                                  __func__)));
}

#if GTK_CHECK_VERSION(3, 20, 0)
static void gxg_prepare_func(GdkSeat* seat, GdkWindow* window, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_3_args(Xen_car((Xen)func_info),
             C_to_Xen_GdkSeat_(seat),
             C_to_Xen_GdkWindow_(window),
             Xen_cadr((Xen)func_info),
             __func__);
}
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static void gxg_draw_func(GtkDrawingArea* self, cairo_t* cr, int width, int height, gpointer func_info)
{
  if (!Xen_is_list((Xen)func_info)) return;
  Xen_call_with_5_args(Xen_car((Xen)func_info),
             C_to_Xen_GtkDrawingArea_(self),
             C_to_Xen_cairo_t_(cr),
             C_to_Xen_int(width),
             C_to_Xen_int(height),
             Xen_cadr((Xen)func_info),
             __func__);
}
#endif


static gboolean gxg_func3(GtkWidget *w, GdkEventAny *ev, gpointer data)
{
  return(Xen_boolean_to_C_bool(Xen_call_with_3_args(Xen_car((Xen)data),
                                     C_to_Xen_GtkWidget_(w),
                                     C_to_Xen_GdkEventAny_(ev),
                                     Xen_cadr((Xen)data),
                                     __func__)));
}

static gboolean gxg_func4(GtkPrintOperation *op, GtkPrintContext *context, gint page_nr, gpointer data)
{
  return(Xen_boolean_to_C_bool(Xen_call_with_4_args(Xen_car((Xen)data),
                                     C_to_Xen_GtkPrintOperation_(op),
                                     C_to_Xen_GtkPrintContext_(context),
                                     C_int_to_Xen_integer(page_nr),
                                     Xen_cadr((Xen)data),
                                     __func__)));
}

#if (!GTK_CHECK_VERSION(3, 90, 0))
static Xen gxg_gtk_widget_set_events(Xen widget, Xen events)
{
  #define H_gtk_widget_set_events "void gtk_widget_set_events(GtkWidget* widget, gint events)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_events", "GtkWidget*");
  Xen_check_type(Xen_is_gint(events), events, 2, "gtk_widget_set_events", "gint");
  gtk_widget_set_events(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(events));
  return(Xen_false);
}
#endif



/* ---------------------------------------- functions ---------------------------------------- */

static Xen gxg_g_unichar_validate(Xen ch)
{
  #define H_g_unichar_validate "gboolean g_unichar_validate(gunichar ch)"
  Xen_check_type(Xen_is_gunichar(ch), ch, 1, "g_unichar_validate", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_validate(Xen_to_C_gunichar(ch))));
}

static Xen gxg_g_unichar_isalnum(Xen c)
{
  #define H_g_unichar_isalnum "gboolean g_unichar_isalnum(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isalnum", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isalnum(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isalpha(Xen c)
{
  #define H_g_unichar_isalpha "gboolean g_unichar_isalpha(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isalpha", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isalpha(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_iscntrl(Xen c)
{
  #define H_g_unichar_iscntrl "gboolean g_unichar_iscntrl(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_iscntrl", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_iscntrl(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isdefined(Xen c)
{
  #define H_g_unichar_isdefined "gboolean g_unichar_isdefined(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isdefined", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isdefined(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isdigit(Xen c)
{
  #define H_g_unichar_isdigit "gboolean g_unichar_isdigit(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isdigit", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isdigit(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isgraph(Xen c)
{
  #define H_g_unichar_isgraph "gboolean g_unichar_isgraph(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isgraph", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isgraph(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_islower(Xen c)
{
  #define H_g_unichar_islower "gboolean g_unichar_islower(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_islower", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_islower(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_ismark(Xen c)
{
  #define H_g_unichar_ismark "gboolean g_unichar_ismark(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_ismark", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_ismark(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isprint(Xen c)
{
  #define H_g_unichar_isprint "gboolean g_unichar_isprint(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isprint", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isprint(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_ispunct(Xen c)
{
  #define H_g_unichar_ispunct "gboolean g_unichar_ispunct(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_ispunct", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_ispunct(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isspace(Xen c)
{
  #define H_g_unichar_isspace "gboolean g_unichar_isspace(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isspace", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isspace(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_istitle(Xen c)
{
  #define H_g_unichar_istitle "gboolean g_unichar_istitle(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_istitle", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_istitle(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isupper(Xen c)
{
  #define H_g_unichar_isupper "gboolean g_unichar_isupper(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isupper", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isupper(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_isxdigit(Xen c)
{
  #define H_g_unichar_isxdigit "gboolean g_unichar_isxdigit(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_isxdigit", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_isxdigit(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_iswide(Xen c)
{
  #define H_g_unichar_iswide "gboolean g_unichar_iswide(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_iswide", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_iswide(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_iswide_cjk(Xen c)
{
  #define H_g_unichar_iswide_cjk "gboolean g_unichar_iswide_cjk(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_iswide_cjk", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_iswide_cjk(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_iszerowidth(Xen c)
{
  #define H_g_unichar_iszerowidth "gboolean g_unichar_iszerowidth(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_iszerowidth", "gunichar");
  return(C_to_Xen_gboolean(g_unichar_iszerowidth(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_toupper(Xen c)
{
  #define H_g_unichar_toupper "gunichar g_unichar_toupper(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_toupper", "gunichar");
  return(C_to_Xen_gunichar(g_unichar_toupper(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_tolower(Xen c)
{
  #define H_g_unichar_tolower "gunichar g_unichar_tolower(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_tolower", "gunichar");
  return(C_to_Xen_gunichar(g_unichar_tolower(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_totitle(Xen c)
{
  #define H_g_unichar_totitle "gunichar g_unichar_totitle(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_totitle", "gunichar");
  return(C_to_Xen_gunichar(g_unichar_totitle(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_digit_value(Xen c)
{
  #define H_g_unichar_digit_value "gint g_unichar_digit_value(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_digit_value", "gunichar");
  return(C_to_Xen_gint(g_unichar_digit_value(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_xdigit_value(Xen c)
{
  #define H_g_unichar_xdigit_value "gint g_unichar_xdigit_value(gunichar c)"
  Xen_check_type(Xen_is_gunichar(c), c, 1, "g_unichar_xdigit_value", "gunichar");
  return(C_to_Xen_gint(g_unichar_xdigit_value(Xen_to_C_gunichar(c))));
}

static Xen gxg_g_unichar_combining_class(Xen uc)
{
  #define H_g_unichar_combining_class "gint g_unichar_combining_class(gunichar uc)"
  Xen_check_type(Xen_is_gunichar(uc), uc, 1, "g_unichar_combining_class", "gunichar");
  return(C_to_Xen_gint(g_unichar_combining_class(Xen_to_C_gunichar(uc))));
}

static Xen gxg_g_unicode_canonical_ordering(Xen string, Xen len)
{
  #define H_g_unicode_canonical_ordering "void g_unicode_canonical_ordering(gunichar* string, gsize len)"
  Xen_check_type(Xen_is_gunichar_(string), string, 1, "g_unicode_canonical_ordering", "gunichar*");
  Xen_check_type(Xen_is_gsize(len), len, 2, "g_unicode_canonical_ordering", "gsize");
  g_unicode_canonical_ordering(Xen_to_C_gunichar_(string), Xen_to_C_gsize(len));
  return(Xen_false);
}

static Xen gxg_g_utf8_get_char(Xen p)
{
  #define H_g_utf8_get_char "gunichar g_utf8_get_char(gchar* p)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_get_char", "gchar*");
  return(C_to_Xen_gunichar(g_utf8_get_char((const gchar*)Xen_to_C_gchar_(p))));
}

static Xen gxg_g_utf8_get_char_validated(Xen p, Xen max_len)
{
  #define H_g_utf8_get_char_validated "gunichar g_utf8_get_char_validated(gchar* p, gssize max_len)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_get_char_validated", "gchar*");
  Xen_check_type(Xen_is_gssize(max_len), max_len, 2, "g_utf8_get_char_validated", "gssize");
  return(C_to_Xen_gunichar(g_utf8_get_char_validated((const gchar*)Xen_to_C_gchar_(p), Xen_to_C_gssize(max_len))));
}

static Xen gxg_g_utf8_prev_char(Xen p)
{
  #define H_g_utf8_prev_char "gchar* g_utf8_prev_char(gchar* p)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_prev_char", "gchar*");
  return(C_to_Xen_gchar_(g_utf8_prev_char((const gchar*)Xen_to_C_gchar_(p))));
}

static Xen gxg_g_utf8_find_next_char(Xen p, Xen end)
{
  #define H_g_utf8_find_next_char "gchar* g_utf8_find_next_char(gchar* p, gchar* end)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_find_next_char", "gchar*");
  Xen_check_type(Xen_is_gchar_(end), end, 2, "g_utf8_find_next_char", "gchar*");
  return(C_to_Xen_gchar_(g_utf8_find_next_char((const gchar*)Xen_to_C_gchar_(p), (const gchar*)Xen_to_C_gchar_(end))));
}

static Xen gxg_g_utf8_find_prev_char(Xen str, Xen p)
{
  #define H_g_utf8_find_prev_char "gchar* g_utf8_find_prev_char(gchar* str, gchar* p)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_find_prev_char", "gchar*");
  Xen_check_type(Xen_is_gchar_(p), p, 2, "g_utf8_find_prev_char", "gchar*");
  return(C_to_Xen_gchar_(g_utf8_find_prev_char((const gchar*)Xen_to_C_gchar_(str), (const gchar*)Xen_to_C_gchar_(p))));
}

static Xen gxg_g_utf8_strlen(Xen p, Xen max)
{
  #define H_g_utf8_strlen "glong g_utf8_strlen(gchar* p, gssize max)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_strlen", "gchar*");
  Xen_check_type(Xen_is_gssize(max), max, 2, "g_utf8_strlen", "gssize");
  return(C_to_Xen_glong(g_utf8_strlen((const gchar*)Xen_to_C_gchar_(p), Xen_to_C_gssize(max))));
}

static Xen gxg_g_utf8_strchr(Xen p, Xen len, Xen c)
{
  #define H_g_utf8_strchr "gchar* g_utf8_strchr(gchar* p, gssize len, gunichar c)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_strchr", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_strchr", "gssize");
  Xen_check_type(Xen_is_gunichar(c), c, 3, "g_utf8_strchr", "gunichar");
  return(C_to_Xen_gchar_(g_utf8_strchr((const gchar*)Xen_to_C_gchar_(p), Xen_to_C_gssize(len), Xen_to_C_gunichar(c))));
}

static Xen gxg_g_utf8_strrchr(Xen p, Xen len, Xen c)
{
  #define H_g_utf8_strrchr "gchar* g_utf8_strrchr(gchar* p, gssize len, gunichar c)"
  Xen_check_type(Xen_is_gchar_(p), p, 1, "g_utf8_strrchr", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_strrchr", "gssize");
  Xen_check_type(Xen_is_gunichar(c), c, 3, "g_utf8_strrchr", "gunichar");
  return(C_to_Xen_gchar_(g_utf8_strrchr((const gchar*)Xen_to_C_gchar_(p), Xen_to_C_gssize(len), Xen_to_C_gunichar(c))));
}

static Xen gxg_g_utf8_strreverse(Xen str, Xen len)
{
  #define H_g_utf8_strreverse "gchar* g_utf8_strreverse(gchar* str, gssize len)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_strreverse", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_strreverse", "gssize");
  return(C_to_Xen_gchar_(g_utf8_strreverse((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len))));
}

static Xen gxg_g_utf8_validate(Xen str, Xen max_len, Xen ignore_end)
{
  #define H_g_utf8_validate "gboolean g_utf8_validate(gchar* str, gssize max_len, gchar** [end])"
  gchar* ref_end = NULL;
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_validate", "gchar*");
  Xen_check_type(Xen_is_gssize(max_len), max_len, 2, "g_utf8_validate", "gssize");
  {
    Xen result;
    result = C_to_Xen_gboolean(g_utf8_validate((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(max_len), (const gchar**)&ref_end));
    return(Xen_list_2(result, C_to_Xen_gchar_(ref_end)));
   }
}

static Xen gxg_g_utf8_strup(Xen str, Xen len)
{
  #define H_g_utf8_strup "gchar* g_utf8_strup(gchar* str, gssize len)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_strup", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_strup", "gssize");
  return(C_to_Xen_gchar_(g_utf8_strup((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len))));
}

static Xen gxg_g_utf8_strdown(Xen str, Xen len)
{
  #define H_g_utf8_strdown "gchar* g_utf8_strdown(gchar* str, gssize len)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_strdown", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_strdown", "gssize");
  return(C_to_Xen_gchar_(g_utf8_strdown((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len))));
}

static Xen gxg_g_utf8_casefold(Xen str, Xen len)
{
  #define H_g_utf8_casefold "gchar* g_utf8_casefold(gchar* str, gssize len)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_casefold", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_casefold", "gssize");
  return(C_to_Xen_gchar_(g_utf8_casefold((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len))));
}

static Xen gxg_g_utf8_normalize(Xen str, Xen len, Xen mode)
{
  #define H_g_utf8_normalize "gchar* g_utf8_normalize(gchar* str, gssize len, GNormalizeMode mode)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_normalize", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_normalize", "gssize");
  Xen_check_type(Xen_is_GNormalizeMode(mode), mode, 3, "g_utf8_normalize", "GNormalizeMode");
  return(C_to_Xen_gchar_(g_utf8_normalize((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len), Xen_to_C_GNormalizeMode(mode))));
}

static Xen gxg_g_utf8_collate(Xen str1, Xen str2)
{
  #define H_g_utf8_collate "gint g_utf8_collate(gchar* str1, gchar* str2)"
  Xen_check_type(Xen_is_gchar_(str1), str1, 1, "g_utf8_collate", "gchar*");
  Xen_check_type(Xen_is_gchar_(str2), str2, 2, "g_utf8_collate", "gchar*");
  return(C_to_Xen_gint(g_utf8_collate((const gchar*)Xen_to_C_gchar_(str1), (const gchar*)Xen_to_C_gchar_(str2))));
}

static Xen gxg_g_utf8_collate_key(Xen str, Xen len)
{
  #define H_g_utf8_collate_key "gchar* g_utf8_collate_key(gchar* str, gssize len)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_collate_key", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_collate_key", "gssize");
  return(C_to_Xen_gchar_(g_utf8_collate_key((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len))));
}

static Xen gxg_g_utf8_collate_key_for_filename(Xen str, Xen len)
{
  #define H_g_utf8_collate_key_for_filename "gchar* g_utf8_collate_key_for_filename(gchar* str, gssize len)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "g_utf8_collate_key_for_filename", "gchar*");
  Xen_check_type(Xen_is_gssize(len), len, 2, "g_utf8_collate_key_for_filename", "gssize");
  return(C_to_Xen_gchar_(g_utf8_collate_key_for_filename((const gchar*)Xen_to_C_gchar_(str), Xen_to_C_gssize(len))));
}

static Xen gxg_g_cclosure_new(Xen func, Xen func_info, Xen destroy_data)
{
  #define H_g_cclosure_new "GClosure* g_cclosure_new(GCallback func, lambda_data func_info, GClosureNotify destroy_data)"
  Xen_check_type(Xen_is_GCallback(func), func, 1, "g_cclosure_new", "GCallback");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 2, "g_cclosure_new", "lambda_data");
  Xen_check_type(Xen_is_GClosureNotify(destroy_data) || Xen_is_false(destroy_data), destroy_data, 3, "g_cclosure_new", "GClosureNotify");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_GClosure_(g_cclosure_new(Xen_to_C_GCallback(func), Xen_to_C_lambda_data(func_info), Xen_to_C_GClosureNotify(destroy_data)));
    return(result);
   }
}

static Xen gxg_g_signal_newv(Xen arglist)
{
  #define H_g_signal_newv "guint g_signal_newv(gchar* signal_name, GType itype, GSignalFlags signal_flags, \
GClosure* class_closure, GSignalAccumulator accumulator, gpointer accu_data, GSignalCMarshaller c_marshaller, \
GType return_type, guint n_params, GType* param_types)"
  Xen signal_name, itype, signal_flags, class_closure, accumulator, accu_data, c_marshaller, return_type, n_params, param_types;
  signal_name = Xen_list_ref(arglist, 0);
  itype = Xen_list_ref(arglist, 1);
  signal_flags = Xen_list_ref(arglist, 2);
  class_closure = Xen_list_ref(arglist, 3);
  accumulator = Xen_list_ref(arglist, 4);
  accu_data = Xen_list_ref(arglist, 5);
  c_marshaller = Xen_list_ref(arglist, 6);
  return_type = Xen_list_ref(arglist, 7);
  n_params = Xen_list_ref(arglist, 8);
  param_types = Xen_list_ref(arglist, 9);
  Xen_check_type(Xen_is_gchar_(signal_name), signal_name, 1, "g_signal_newv", "gchar*");
  Xen_check_type(Xen_is_GType(itype), itype, 2, "g_signal_newv", "GType");
  Xen_check_type(Xen_is_GSignalFlags(signal_flags), signal_flags, 3, "g_signal_newv", "GSignalFlags");
  Xen_check_type(Xen_is_GClosure_(class_closure) || Xen_is_false(class_closure), class_closure, 4, "g_signal_newv", "GClosure*");
  Xen_check_type(Xen_is_GSignalAccumulator(accumulator), accumulator, 5, "g_signal_newv", "GSignalAccumulator");
  Xen_check_type(Xen_is_gpointer(accu_data), accu_data, 6, "g_signal_newv", "gpointer");
  Xen_check_type(Xen_is_GSignalCMarshaller(c_marshaller), c_marshaller, 7, "g_signal_newv", "GSignalCMarshaller");
  Xen_check_type(Xen_is_GType(return_type), return_type, 8, "g_signal_newv", "GType");
  Xen_check_type(Xen_is_guint(n_params), n_params, 9, "g_signal_newv", "guint");
  Xen_check_type(Xen_is_GType_(param_types), param_types, 10, "g_signal_newv", "GType*");
  return(C_to_Xen_guint(g_signal_newv(Xen_to_C_gchar_(signal_name), Xen_to_C_GType(itype), Xen_to_C_GSignalFlags(signal_flags), 
                                      Xen_to_C_GClosure_(class_closure), Xen_to_C_GSignalAccumulator(accumulator), Xen_to_C_gpointer(accu_data), 
                                      Xen_to_C_GSignalCMarshaller(c_marshaller), Xen_to_C_GType(return_type), Xen_to_C_guint(n_params), 
                                      Xen_to_C_GType_(param_types))));
}

static Xen gxg_g_signal_lookup(Xen name, Xen itype)
{
  #define H_g_signal_lookup "guint g_signal_lookup(gchar* name, GType itype)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "g_signal_lookup", "gchar*");
  Xen_check_type(Xen_is_GType(itype), itype, 2, "g_signal_lookup", "GType");
  return(C_to_Xen_guint(g_signal_lookup(Xen_to_C_gchar_(name), Xen_to_C_GType(itype))));
}

static Xen gxg_g_signal_name(Xen signal_id)
{
  #define H_g_signal_name "gchar* g_signal_name(guint signal_id)"
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 1, "g_signal_name", "guint");
  return(C_to_Xen_gchar_(g_signal_name(Xen_to_C_guint(signal_id))));
}

static Xen gxg_g_signal_query(Xen signal_id, Xen query)
{
  #define H_g_signal_query "void g_signal_query(guint signal_id, GSignalQuery* query)"
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 1, "g_signal_query", "guint");
  Xen_check_type(Xen_is_GSignalQuery_(query), query, 2, "g_signal_query", "GSignalQuery*");
  g_signal_query(Xen_to_C_guint(signal_id), Xen_to_C_GSignalQuery_(query));
  return(Xen_false);
}

static Xen gxg_g_signal_list_ids(Xen itype, Xen n_ids)
{
  #define H_g_signal_list_ids "guint* g_signal_list_ids(GType itype, guint* n_ids)"
  Xen_check_type(Xen_is_GType(itype), itype, 1, "g_signal_list_ids", "GType");
  Xen_check_type(Xen_is_guint_(n_ids), n_ids, 2, "g_signal_list_ids", "guint*");
  return(C_to_Xen_guint_(g_signal_list_ids(Xen_to_C_GType(itype), Xen_to_C_guint_(n_ids))));
}

static Xen gxg_g_signal_parse_name(Xen detailed_signal, Xen itype, Xen ignore_signal_id_p, Xen ignore_detail_p, Xen force_detail_quark)
{
  #define H_g_signal_parse_name "gboolean g_signal_parse_name(gchar* detailed_signal, GType itype, guint* [signal_id_p], \
GQuark* [detail_p], gboolean force_detail_quark)"
  guint ref_signal_id_p;
  GQuark ref_detail_p;
  Xen_check_type(Xen_is_gchar_(detailed_signal), detailed_signal, 1, "g_signal_parse_name", "gchar*");
  Xen_check_type(Xen_is_GType(itype), itype, 2, "g_signal_parse_name", "GType");
  Xen_check_type(Xen_is_gboolean(force_detail_quark), force_detail_quark, 5, "g_signal_parse_name", "gboolean");
  {
    Xen result;
    result = C_to_Xen_gboolean(g_signal_parse_name(Xen_to_C_gchar_(detailed_signal), Xen_to_C_GType(itype), &ref_signal_id_p, 
                                                   &ref_detail_p, Xen_to_C_gboolean(force_detail_quark)));
    return(Xen_list_3(result, C_to_Xen_guint(ref_signal_id_p), C_to_Xen_GQuark(ref_detail_p)));
   }
}

static Xen gxg_g_signal_get_invocation_hint(Xen instance)
{
  #define H_g_signal_get_invocation_hint "GSignalInvocationHint* g_signal_get_invocation_hint(gpointer instance)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_get_invocation_hint", "gpointer");
  return(C_to_Xen_GSignalInvocationHint_(g_signal_get_invocation_hint(Xen_to_C_gpointer(instance))));
}

static Xen gxg_g_signal_stop_emission(Xen instance, Xen signal_id, Xen detail)
{
  #define H_g_signal_stop_emission "void g_signal_stop_emission(gpointer instance, guint signal_id, GQuark detail)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_stop_emission", "gpointer");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 2, "g_signal_stop_emission", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 3, "g_signal_stop_emission", "GQuark");
  g_signal_stop_emission(Xen_to_C_gpointer(instance), Xen_to_C_guint(signal_id), Xen_to_C_GQuark(detail));
  return(Xen_false);
}

static Xen gxg_g_signal_stop_emission_by_name(Xen instance, Xen detailed_signal)
{
  #define H_g_signal_stop_emission_by_name "void g_signal_stop_emission_by_name(gpointer instance, gchar* detailed_signal)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_stop_emission_by_name", "gpointer");
  Xen_check_type(Xen_is_gchar_(detailed_signal), detailed_signal, 2, "g_signal_stop_emission_by_name", "gchar*");
  g_signal_stop_emission_by_name(Xen_to_C_gpointer(instance), Xen_to_C_gchar_(detailed_signal));
  return(Xen_false);
}

static Xen gxg_g_signal_add_emission_hook(Xen signal_id, Xen quark, Xen hook_func, Xen func_info, Xen data_destroy)
{
  #define H_g_signal_add_emission_hook "gulong g_signal_add_emission_hook(guint signal_id, GQuark quark, \
GSignalEmissionHook hook_func, lambda_data func_info, GtkDestroyNotify data_destroy)"
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 1, "g_signal_add_emission_hook", "guint");
  Xen_check_type(Xen_is_GQuark(quark), quark, 2, "g_signal_add_emission_hook", "GQuark");
  Xen_check_type(Xen_is_GSignalEmissionHook(hook_func), hook_func, 3, "g_signal_add_emission_hook", "GSignalEmissionHook");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "g_signal_add_emission_hook", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(data_destroy), data_destroy, 5, "g_signal_add_emission_hook", "GtkDestroyNotify");
  {
    Xen result;
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, data_destroy);
    result = C_to_Xen_gulong(g_signal_add_emission_hook(Xen_to_C_guint(signal_id), Xen_to_C_GQuark(quark), Xen_to_C_GSignalEmissionHook(hook_func), 
                                                        Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(data_destroy)));
    return(result);
   }
}

static Xen gxg_g_signal_remove_emission_hook(Xen signal_id, Xen hook_id)
{
  #define H_g_signal_remove_emission_hook "void g_signal_remove_emission_hook(guint signal_id, gulong hook_id)"
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 1, "g_signal_remove_emission_hook", "guint");
  Xen_check_type(Xen_is_gulong(hook_id), hook_id, 2, "g_signal_remove_emission_hook", "gulong");
  g_signal_remove_emission_hook(Xen_to_C_guint(signal_id), Xen_to_C_gulong(hook_id));
  return(Xen_false);
}

static Xen gxg_g_signal_has_handler_pending(Xen instance, Xen signal_id, Xen detail, Xen may_be_blocked)
{
  #define H_g_signal_has_handler_pending "gboolean g_signal_has_handler_pending(gpointer instance, guint signal_id, \
GQuark detail, gboolean may_be_blocked)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_has_handler_pending", "gpointer");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 2, "g_signal_has_handler_pending", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 3, "g_signal_has_handler_pending", "GQuark");
  Xen_check_type(Xen_is_gboolean(may_be_blocked), may_be_blocked, 4, "g_signal_has_handler_pending", "gboolean");
  return(C_to_Xen_gboolean(g_signal_has_handler_pending(Xen_to_C_gpointer(instance), Xen_to_C_guint(signal_id), Xen_to_C_GQuark(detail), 
                                                        Xen_to_C_gboolean(may_be_blocked))));
}

static Xen gxg_g_signal_connect_closure_by_id(Xen instance, Xen signal_id, Xen detail, Xen closure, Xen after)
{
  #define H_g_signal_connect_closure_by_id "gulong g_signal_connect_closure_by_id(gpointer instance, \
guint signal_id, GQuark detail, GClosure* closure, gboolean after)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_connect_closure_by_id", "gpointer");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 2, "g_signal_connect_closure_by_id", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 3, "g_signal_connect_closure_by_id", "GQuark");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 4, "g_signal_connect_closure_by_id", "GClosure*");
  Xen_check_type(Xen_is_gboolean(after), after, 5, "g_signal_connect_closure_by_id", "gboolean");
  return(C_to_Xen_gulong(g_signal_connect_closure_by_id(Xen_to_C_gpointer(instance), Xen_to_C_guint(signal_id), Xen_to_C_GQuark(detail), 
                                                        Xen_to_C_GClosure_(closure), Xen_to_C_gboolean(after))));
}

static Xen gxg_g_signal_connect_closure(Xen instance, Xen detailed_signal, Xen closure, Xen after)
{
  #define H_g_signal_connect_closure "gulong g_signal_connect_closure(gpointer instance, gchar* detailed_signal, \
GClosure* closure, gboolean after)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_connect_closure", "gpointer");
  Xen_check_type(Xen_is_gchar_(detailed_signal), detailed_signal, 2, "g_signal_connect_closure", "gchar*");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 3, "g_signal_connect_closure", "GClosure*");
  Xen_check_type(Xen_is_gboolean(after), after, 4, "g_signal_connect_closure", "gboolean");
  return(C_to_Xen_gulong(g_signal_connect_closure(Xen_to_C_gpointer(instance), Xen_to_C_gchar_(detailed_signal), Xen_to_C_GClosure_(closure), 
                                                  Xen_to_C_gboolean(after))));
}

static Xen gxg_g_signal_connect_data(Xen instance, Xen detailed_signal, Xen func, Xen func_info, Xen destroy_data, Xen connect_flags)
{
  #define H_g_signal_connect_data "gulong g_signal_connect_data(gpointer instance, gchar* detailed_signal, \
GCallback func, lambda_data func_info, GClosureNotify destroy_data, GConnectFlags connect_flags)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_connect_data", "gpointer");
  Xen_check_type(Xen_is_gchar_(detailed_signal), detailed_signal, 2, "g_signal_connect_data", "gchar*");
  Xen_check_type(Xen_is_GCallback(func), func, 3, "g_signal_connect_data", "GCallback");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "g_signal_connect_data", "lambda_data");
  Xen_check_type(Xen_is_GClosureNotify(destroy_data) || Xen_is_false(destroy_data), destroy_data, 5, "g_signal_connect_data", "GClosureNotify");
  Xen_check_type(Xen_is_GConnectFlags(connect_flags), connect_flags, 6, "g_signal_connect_data", "GConnectFlags");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_gulong(g_signal_connect_data(Xen_to_C_gpointer(instance), Xen_to_C_gchar_(detailed_signal), Xen_to_C_GCallback(func), 
                                                   Xen_to_C_lambda_data(func_info), Xen_to_C_GClosureNotify(destroy_data), 
                                                   Xen_to_C_GConnectFlags(connect_flags)));
    return(result);
   }
}

static Xen gxg_g_signal_handler_block(Xen instance, Xen handler_id)
{
  #define H_g_signal_handler_block "void g_signal_handler_block(gpointer instance, gulong handler_id)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handler_block", "gpointer");
  Xen_check_type(Xen_is_gulong(handler_id), handler_id, 2, "g_signal_handler_block", "gulong");
  g_signal_handler_block(Xen_to_C_gpointer(instance), Xen_to_C_gulong(handler_id));
  return(Xen_false);
}

static Xen gxg_g_signal_handler_unblock(Xen instance, Xen handler_id)
{
  #define H_g_signal_handler_unblock "void g_signal_handler_unblock(gpointer instance, gulong handler_id)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handler_unblock", "gpointer");
  Xen_check_type(Xen_is_gulong(handler_id), handler_id, 2, "g_signal_handler_unblock", "gulong");
  g_signal_handler_unblock(Xen_to_C_gpointer(instance), Xen_to_C_gulong(handler_id));
  return(Xen_false);
}

static Xen gxg_g_signal_handler_disconnect(Xen instance, Xen handler_id)
{
  #define H_g_signal_handler_disconnect "void g_signal_handler_disconnect(gpointer instance, gulong handler_id)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handler_disconnect", "gpointer");
  Xen_check_type(Xen_is_gulong(handler_id), handler_id, 2, "g_signal_handler_disconnect", "gulong");
  g_signal_handler_disconnect(Xen_to_C_gpointer(instance), Xen_to_C_gulong(handler_id));
  return(Xen_false);
}

static Xen gxg_g_signal_handler_is_connected(Xen instance, Xen handler_id)
{
  #define H_g_signal_handler_is_connected "gboolean g_signal_handler_is_connected(gpointer instance, \
gulong handler_id)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handler_is_connected", "gpointer");
  Xen_check_type(Xen_is_gulong(handler_id), handler_id, 2, "g_signal_handler_is_connected", "gulong");
  return(C_to_Xen_gboolean(g_signal_handler_is_connected(Xen_to_C_gpointer(instance), Xen_to_C_gulong(handler_id))));
}

static Xen gxg_g_signal_handler_find(Xen instance, Xen mask, Xen signal_id, Xen detail, Xen closure, Xen func, Xen data)
{
  #define H_g_signal_handler_find "gulong g_signal_handler_find(gpointer instance, GSignalMatchType mask, \
guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handler_find", "gpointer");
  Xen_check_type(Xen_is_GSignalMatchType(mask), mask, 2, "g_signal_handler_find", "GSignalMatchType");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 3, "g_signal_handler_find", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 4, "g_signal_handler_find", "GQuark");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 5, "g_signal_handler_find", "GClosure*");
  Xen_check_type(Xen_is_gpointer(func), func, 6, "g_signal_handler_find", "gpointer");
  Xen_check_type(Xen_is_gpointer(data), data, 7, "g_signal_handler_find", "gpointer");
  return(C_to_Xen_gulong(g_signal_handler_find(Xen_to_C_gpointer(instance), Xen_to_C_GSignalMatchType(mask), Xen_to_C_guint(signal_id), 
                                               Xen_to_C_GQuark(detail), Xen_to_C_GClosure_(closure), Xen_to_C_gpointer(func), 
                                               Xen_to_C_gpointer(data))));
}

static Xen gxg_g_signal_handlers_block_matched(Xen instance, Xen mask, Xen signal_id, Xen detail, Xen closure, Xen func, Xen data)
{
  #define H_g_signal_handlers_block_matched "guint g_signal_handlers_block_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handlers_block_matched", "gpointer");
  Xen_check_type(Xen_is_GSignalMatchType(mask), mask, 2, "g_signal_handlers_block_matched", "GSignalMatchType");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 3, "g_signal_handlers_block_matched", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 4, "g_signal_handlers_block_matched", "GQuark");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 5, "g_signal_handlers_block_matched", "GClosure*");
  Xen_check_type(Xen_is_gpointer(func), func, 6, "g_signal_handlers_block_matched", "gpointer");
  Xen_check_type(Xen_is_gpointer(data), data, 7, "g_signal_handlers_block_matched", "gpointer");
  return(C_to_Xen_guint(g_signal_handlers_block_matched(Xen_to_C_gpointer(instance), Xen_to_C_GSignalMatchType(mask), Xen_to_C_guint(signal_id), 
                                                        Xen_to_C_GQuark(detail), Xen_to_C_GClosure_(closure), Xen_to_C_gpointer(func), 
                                                        Xen_to_C_gpointer(data))));
}

static Xen gxg_g_signal_handlers_unblock_matched(Xen instance, Xen mask, Xen signal_id, Xen detail, Xen closure, Xen func, Xen data)
{
  #define H_g_signal_handlers_unblock_matched "guint g_signal_handlers_unblock_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handlers_unblock_matched", "gpointer");
  Xen_check_type(Xen_is_GSignalMatchType(mask), mask, 2, "g_signal_handlers_unblock_matched", "GSignalMatchType");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 3, "g_signal_handlers_unblock_matched", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 4, "g_signal_handlers_unblock_matched", "GQuark");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 5, "g_signal_handlers_unblock_matched", "GClosure*");
  Xen_check_type(Xen_is_gpointer(func), func, 6, "g_signal_handlers_unblock_matched", "gpointer");
  Xen_check_type(Xen_is_gpointer(data), data, 7, "g_signal_handlers_unblock_matched", "gpointer");
  return(C_to_Xen_guint(g_signal_handlers_unblock_matched(Xen_to_C_gpointer(instance), Xen_to_C_GSignalMatchType(mask), Xen_to_C_guint(signal_id), 
                                                          Xen_to_C_GQuark(detail), Xen_to_C_GClosure_(closure), Xen_to_C_gpointer(func), 
                                                          Xen_to_C_gpointer(data))));
}

static Xen gxg_g_signal_handlers_disconnect_matched(Xen instance, Xen mask, Xen signal_id, Xen detail, Xen closure, Xen func, Xen data)
{
  #define H_g_signal_handlers_disconnect_matched "guint g_signal_handlers_disconnect_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handlers_disconnect_matched", "gpointer");
  Xen_check_type(Xen_is_GSignalMatchType(mask), mask, 2, "g_signal_handlers_disconnect_matched", "GSignalMatchType");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 3, "g_signal_handlers_disconnect_matched", "guint");
  Xen_check_type(Xen_is_GQuark(detail), detail, 4, "g_signal_handlers_disconnect_matched", "GQuark");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 5, "g_signal_handlers_disconnect_matched", "GClosure*");
  Xen_check_type(Xen_is_gpointer(func), func, 6, "g_signal_handlers_disconnect_matched", "gpointer");
  Xen_check_type(Xen_is_gpointer(data), data, 7, "g_signal_handlers_disconnect_matched", "gpointer");
  return(C_to_Xen_guint(g_signal_handlers_disconnect_matched(Xen_to_C_gpointer(instance), Xen_to_C_GSignalMatchType(mask), 
                                                             Xen_to_C_guint(signal_id), Xen_to_C_GQuark(detail), Xen_to_C_GClosure_(closure), 
                                                             Xen_to_C_gpointer(func), Xen_to_C_gpointer(data))));
}

static Xen gxg_g_signal_handlers_destroy(Xen instance)
{
  #define H_g_signal_handlers_destroy "void g_signal_handlers_destroy(gpointer instance)"
  Xen_check_type(Xen_is_gpointer(instance), instance, 1, "g_signal_handlers_destroy", "gpointer");
  g_signal_handlers_destroy(Xen_to_C_gpointer(instance));
  return(Xen_false);
}

static Xen gxg_g_object_ref(Xen object)
{
  #define H_g_object_ref "gpointer g_object_ref(gpointer object)"
  Xen_check_type(Xen_is_gpointer(object), object, 1, "g_object_ref", "gpointer");
  return(C_to_Xen_gpointer(g_object_ref(Xen_to_C_gpointer(object))));
}

static Xen gxg_g_object_unref(Xen object)
{
  #define H_g_object_unref "void g_object_unref(gpointer object)"
  Xen_check_type(Xen_is_gpointer(object), object, 1, "g_object_unref", "gpointer");
  g_object_unref(Xen_to_C_gpointer(object));
  return(Xen_false);
}

static Xen gxg_gdk_drag_status(Xen context, Xen action, Xen time)
{
  #define H_gdk_drag_status "void gdk_drag_status(GdkDragContext* context, GdkDragAction action, guint32 time)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_status", "GdkDragContext*");
  Xen_check_type(Xen_is_GdkDragAction(action), action, 2, "gdk_drag_status", "GdkDragAction");
  Xen_check_type(Xen_is_guint32(time), time, 3, "gdk_drag_status", "guint32");
  gdk_drag_status(Xen_to_C_GdkDragContext_(context), Xen_to_C_GdkDragAction(action), Xen_to_C_guint32(time));
  return(Xen_false);
}

static Xen gxg_gdk_drop_reply(Xen context, Xen ok, Xen time)
{
  #define H_gdk_drop_reply "void gdk_drop_reply(GdkDragContext* context, gboolean ok, guint32 time)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drop_reply", "GdkDragContext*");
  Xen_check_type(Xen_is_gboolean(ok), ok, 2, "gdk_drop_reply", "gboolean");
  Xen_check_type(Xen_is_guint32(time), time, 3, "gdk_drop_reply", "guint32");
  gdk_drop_reply(Xen_to_C_GdkDragContext_(context), Xen_to_C_gboolean(ok), Xen_to_C_guint32(time));
  return(Xen_false);
}

static Xen gxg_gdk_drop_finish(Xen context, Xen success, Xen time)
{
  #define H_gdk_drop_finish "void gdk_drop_finish(GdkDragContext* context, gboolean success, guint32 time)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drop_finish", "GdkDragContext*");
  Xen_check_type(Xen_is_gboolean(success), success, 2, "gdk_drop_finish", "gboolean");
  Xen_check_type(Xen_is_guint32(time), time, 3, "gdk_drop_finish", "guint32");
  gdk_drop_finish(Xen_to_C_GdkDragContext_(context), Xen_to_C_gboolean(success), Xen_to_C_guint32(time));
  return(Xen_false);
}

static Xen gxg_gdk_event_copy(Xen event)
{
  #define H_gdk_event_copy "GdkEvent* gdk_event_copy(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_copy", "GdkEvent*");
  return(C_to_Xen_GdkEvent_(gdk_event_copy(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_event_free(Xen event)
{
  #define H_gdk_event_free "void gdk_event_free(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_free", "GdkEvent*");
  gdk_event_free(Xen_to_C_GdkEvent_(event));
  return(Xen_false);
}

static Xen gxg_gdk_event_get_time(Xen event)
{
  #define H_gdk_event_get_time "guint32 gdk_event_get_time(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event) || Xen_is_false(event), event, 1, "gdk_event_get_time", "GdkEvent*");
  return(C_to_Xen_guint32(gdk_event_get_time(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_event_get_state(Xen event, Xen ignore_state)
{
  #define H_gdk_event_get_state "gboolean gdk_event_get_state(GdkEvent* event, GdkModifierType* [state])"
  GdkModifierType ref_state;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_state", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_state(Xen_to_C_GdkEvent_(event), &ref_state));
    return(Xen_list_2(result, C_to_Xen_GdkModifierType(ref_state)));
   }
}

static Xen gxg_gdk_event_get_coords(Xen event, Xen ignore_x_win, Xen ignore_y_win)
{
  #define H_gdk_event_get_coords "gboolean gdk_event_get_coords(GdkEvent* event, gdouble* [x_win], gdouble* [y_win])"
  gdouble ref_x_win;
  gdouble ref_y_win;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_coords", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_coords(Xen_to_C_GdkEvent_(event), &ref_x_win, &ref_y_win));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x_win), C_to_Xen_gdouble(ref_y_win)));
   }
}

static Xen gxg_gdk_event_get_root_coords(Xen event, Xen ignore_x_root, Xen ignore_y_root)
{
  #define H_gdk_event_get_root_coords "gboolean gdk_event_get_root_coords(GdkEvent* event, gdouble* [x_root], \
gdouble* [y_root])"
  gdouble ref_x_root;
  gdouble ref_y_root;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_root_coords", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_root_coords(Xen_to_C_GdkEvent_(event), &ref_x_root, &ref_y_root));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x_root), C_to_Xen_gdouble(ref_y_root)));
   }
}

static Xen gxg_gdk_event_handler_set(Xen func, Xen func_info, Xen notify)
{
  #define H_gdk_event_handler_set "void gdk_event_handler_set(GdkEventFunc func, lambda_data func_info, \
GtkDestroyNotify notify)"
  Xen_check_type(Xen_is_GdkEventFunc(func), func, 1, "gdk_event_handler_set", "GdkEventFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 2, "gdk_event_handler_set", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(notify), notify, 3, "gdk_event_handler_set", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, notify);
    gdk_event_handler_set(Xen_to_C_GdkEventFunc(func), Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(notify));
    return(Xen_false);
   }
}

static Xen gxg_gdk_set_show_events(Xen show_events)
{
  #define H_gdk_set_show_events "void gdk_set_show_events(gboolean show_events)"
  Xen_check_type(Xen_is_gboolean(show_events), show_events, 1, "gdk_set_show_events", "gboolean");
  gdk_set_show_events(Xen_to_C_gboolean(show_events));
  return(Xen_false);
}

static Xen gxg_gdk_get_show_events(void)
{
  #define H_gdk_get_show_events "gboolean gdk_get_show_events( void)"
  return(C_to_Xen_gboolean(gdk_get_show_events()));
}

static Xen gxg_gdk_rectangle_intersect(Xen src1, Xen src2, Xen dest)
{
  #define H_gdk_rectangle_intersect "gboolean gdk_rectangle_intersect(GdkRectangle* src1, GdkRectangle* src2, \
GdkRectangle* dest)"
  Xen_check_type(Xen_is_GdkRectangle_(src1), src1, 1, "gdk_rectangle_intersect", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(src2), src2, 2, "gdk_rectangle_intersect", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(dest), dest, 3, "gdk_rectangle_intersect", "GdkRectangle*");
  return(C_to_Xen_gboolean(gdk_rectangle_intersect(Xen_to_C_GdkRectangle_(src1), Xen_to_C_GdkRectangle_(src2), Xen_to_C_GdkRectangle_(dest))));
}

static Xen gxg_gdk_rectangle_union(Xen src1, Xen src2, Xen dest)
{
  #define H_gdk_rectangle_union "void gdk_rectangle_union(GdkRectangle* src1, GdkRectangle* src2, GdkRectangle* dest)"
  Xen_check_type(Xen_is_GdkRectangle_(src1), src1, 1, "gdk_rectangle_union", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(src2), src2, 2, "gdk_rectangle_union", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(dest), dest, 3, "gdk_rectangle_union", "GdkRectangle*");
  gdk_rectangle_union(Xen_to_C_GdkRectangle_(src1), Xen_to_C_GdkRectangle_(src2), Xen_to_C_GdkRectangle_(dest));
  return(Xen_false);
}

static Xen gxg_gdk_keymap_lookup_key(Xen keymap, Xen key)
{
  #define H_gdk_keymap_lookup_key "guint gdk_keymap_lookup_key(GdkKeymap* keymap, GdkKeymapKey* key)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_lookup_key", "GdkKeymap*");
  Xen_check_type(Xen_is_GdkKeymapKey_(key), key, 2, "gdk_keymap_lookup_key", "GdkKeymapKey*");
  return(C_to_Xen_guint(gdk_keymap_lookup_key(Xen_to_C_GdkKeymap_(keymap), Xen_to_C_GdkKeymapKey_(key))));
}

static Xen gxg_gdk_keymap_get_entries_for_keyval(Xen keymap, Xen keyval, Xen ignore_keys, Xen ignore_n_keys)
{
  #define H_gdk_keymap_get_entries_for_keyval "gboolean gdk_keymap_get_entries_for_keyval(GdkKeymap* keymap, \
guint keyval, GdkKeymapKey** [keys], gint* [n_keys])"
  GdkKeymapKey* ref_keys = NULL;
  gint ref_n_keys;
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_entries_for_keyval", "GdkKeymap*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gdk_keymap_get_entries_for_keyval", "guint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_keymap_get_entries_for_keyval(Xen_to_C_GdkKeymap_(keymap), Xen_to_C_guint(keyval), &ref_keys, 
                                                                 &ref_n_keys));
    return(Xen_list_3(result, C_to_Xen_GdkKeymapKey_(ref_keys), C_to_Xen_gint(ref_n_keys)));
   }
}

static Xen gxg_gdk_keymap_get_entries_for_keycode(Xen keymap, Xen hardware_keycode, Xen ignore_keys, Xen ignore_keyvals, Xen ignore_n_entries)
{
  #define H_gdk_keymap_get_entries_for_keycode "gboolean gdk_keymap_get_entries_for_keycode(GdkKeymap* keymap, \
guint hardware_keycode, GdkKeymapKey** [keys], guint** [keyvals], gint* [n_entries])"
  GdkKeymapKey* ref_keys = NULL;
  guint* ref_keyvals = NULL;
  gint ref_n_entries;
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_entries_for_keycode", "GdkKeymap*");
  Xen_check_type(Xen_is_guint(hardware_keycode), hardware_keycode, 2, "gdk_keymap_get_entries_for_keycode", "guint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_keymap_get_entries_for_keycode(Xen_to_C_GdkKeymap_(keymap), Xen_to_C_guint(hardware_keycode), 
                                                                  &ref_keys, &ref_keyvals, &ref_n_entries));
    return(Xen_list_4(result, C_to_Xen_GdkKeymapKey_(ref_keys), C_to_Xen_guint_(ref_keyvals), C_to_Xen_gint(ref_n_entries)));
   }
}

static Xen gxg_gdk_keymap_get_direction(Xen keymap)
{
  #define H_gdk_keymap_get_direction "PangoDirection gdk_keymap_get_direction(GdkKeymap* keymap)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_direction", "GdkKeymap*");
  return(C_to_Xen_PangoDirection(gdk_keymap_get_direction(Xen_to_C_GdkKeymap_(keymap))));
}

static Xen gxg_gdk_keyval_name(Xen keyval)
{
  #define H_gdk_keyval_name "gchar* gdk_keyval_name(guint keyval)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gdk_keyval_name", "guint");
  return(C_to_Xen_gchar_(gdk_keyval_name(Xen_to_C_guint(keyval))));
}

static Xen gxg_gdk_keyval_from_name(Xen keyval_name)
{
  #define H_gdk_keyval_from_name "guint gdk_keyval_from_name(gchar* keyval_name)"
  Xen_check_type(Xen_is_gchar_(keyval_name), keyval_name, 1, "gdk_keyval_from_name", "gchar*");
  return(C_to_Xen_guint(gdk_keyval_from_name(Xen_to_C_gchar_(keyval_name))));
}

static Xen gxg_gdk_keyval_convert_case(Xen symbol, Xen ignore_lower, Xen ignore_upper)
{
  #define H_gdk_keyval_convert_case "void gdk_keyval_convert_case(guint symbol, guint* [lower], guint* [upper])"
  guint ref_lower;
  guint ref_upper;
  Xen_check_type(Xen_is_guint(symbol), symbol, 1, "gdk_keyval_convert_case", "guint");
  gdk_keyval_convert_case(Xen_to_C_guint(symbol), &ref_lower, &ref_upper);
  return(Xen_list_2(C_to_Xen_guint(ref_lower), C_to_Xen_guint(ref_upper)));
}

static Xen gxg_gdk_keyval_to_upper(Xen keyval)
{
  #define H_gdk_keyval_to_upper "guint gdk_keyval_to_upper(guint keyval)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gdk_keyval_to_upper", "guint");
  return(C_to_Xen_guint(gdk_keyval_to_upper(Xen_to_C_guint(keyval))));
}

static Xen gxg_gdk_keyval_to_lower(Xen keyval)
{
  #define H_gdk_keyval_to_lower "guint gdk_keyval_to_lower(guint keyval)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gdk_keyval_to_lower", "guint");
  return(C_to_Xen_guint(gdk_keyval_to_lower(Xen_to_C_guint(keyval))));
}

static Xen gxg_gdk_keyval_is_upper(Xen keyval)
{
  #define H_gdk_keyval_is_upper "gboolean gdk_keyval_is_upper(guint keyval)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gdk_keyval_is_upper", "guint");
  return(C_to_Xen_gboolean(gdk_keyval_is_upper(Xen_to_C_guint(keyval))));
}

static Xen gxg_gdk_keyval_is_lower(Xen keyval)
{
  #define H_gdk_keyval_is_lower "gboolean gdk_keyval_is_lower(guint keyval)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gdk_keyval_is_lower", "guint");
  return(C_to_Xen_gboolean(gdk_keyval_is_lower(Xen_to_C_guint(keyval))));
}

static Xen gxg_gdk_keyval_to_unicode(Xen keyval)
{
  #define H_gdk_keyval_to_unicode "guint32 gdk_keyval_to_unicode(guint keyval)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gdk_keyval_to_unicode", "guint");
  return(C_to_Xen_guint32(gdk_keyval_to_unicode(Xen_to_C_guint(keyval))));
}

static Xen gxg_gdk_unicode_to_keyval(Xen wc)
{
  #define H_gdk_unicode_to_keyval "guint gdk_unicode_to_keyval(guint32 wc)"
  Xen_check_type(Xen_is_guint32(wc), wc, 1, "gdk_unicode_to_keyval", "guint32");
  return(C_to_Xen_guint(gdk_unicode_to_keyval(Xen_to_C_guint32(wc))));
}

static Xen gxg_gdk_utf8_to_string_target(Xen str)
{
  #define H_gdk_utf8_to_string_target "gchar* gdk_utf8_to_string_target(gchar* str)"
  Xen_check_type(Xen_is_gchar_(str), str, 1, "gdk_utf8_to_string_target", "gchar*");
  {
   gchar* result;
   Xen rtn;
   result = gdk_utf8_to_string_target(Xen_to_C_gchar_(str));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gdk_window_destroy(Xen window)
{
  #define H_gdk_window_destroy "void gdk_window_destroy(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_destroy", "GdkWindow*");
  gdk_window_destroy(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_window_type(Xen window)
{
  #define H_gdk_window_get_window_type "GdkWindowType gdk_window_get_window_type(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_window_type", "GdkWindow*");
  return(C_to_Xen_GdkWindowType(gdk_window_get_window_type(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_show(Xen window)
{
  #define H_gdk_window_show "void gdk_window_show(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_show", "GdkWindow*");
  gdk_window_show(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_hide(Xen window)
{
  #define H_gdk_window_hide "void gdk_window_hide(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_hide", "GdkWindow*");
  gdk_window_hide(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_withdraw(Xen window)
{
  #define H_gdk_window_withdraw "void gdk_window_withdraw(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_withdraw", "GdkWindow*");
  gdk_window_withdraw(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_show_unraised(Xen window)
{
  #define H_gdk_window_show_unraised "void gdk_window_show_unraised(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_show_unraised", "GdkWindow*");
  gdk_window_show_unraised(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_move(Xen window, Xen x, Xen y)
{
  #define H_gdk_window_move "void gdk_window_move(GdkWindow* window, gint x, gint y)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_move", "GdkWindow*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gdk_window_move", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gdk_window_move", "gint");
  gdk_window_move(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
}

static Xen gxg_gdk_window_resize(Xen window, Xen width, Xen height)
{
  #define H_gdk_window_resize "void gdk_window_resize(GdkWindow* window, gint width, gint height)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_resize", "GdkWindow*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gdk_window_resize", "gint");
  Xen_check_type(Xen_is_gint(height), height, 3, "gdk_window_resize", "gint");
  gdk_window_resize(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gdk_window_move_resize(Xen window, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gdk_window_move_resize "void gdk_window_move_resize(GdkWindow* window, gint x, gint y, gint width, \
gint height)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_move_resize", "GdkWindow*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gdk_window_move_resize", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gdk_window_move_resize", "gint");
  Xen_check_type(Xen_is_gint(width), width, 4, "gdk_window_move_resize", "gint");
  Xen_check_type(Xen_is_gint(height), height, 5, "gdk_window_move_resize", "gint");
  gdk_window_move_resize(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(x), Xen_to_C_gint(y), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gdk_window_raise(Xen window)
{
  #define H_gdk_window_raise "void gdk_window_raise(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_raise", "GdkWindow*");
  gdk_window_raise(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_lower(Xen window)
{
  #define H_gdk_window_lower "void gdk_window_lower(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_lower", "GdkWindow*");
  gdk_window_lower(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_focus(Xen window, Xen timestamp)
{
  #define H_gdk_window_focus "void gdk_window_focus(GdkWindow* window, guint32 timestamp)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_focus", "GdkWindow*");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 2, "gdk_window_focus", "guint32");
  gdk_window_focus(Xen_to_C_GdkWindow_(window), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_user_data(Xen window, Xen user_data)
{
  #define H_gdk_window_set_user_data "void gdk_window_set_user_data(GdkWindow* window, gpointer user_data)"
  Xen_check_type(Xen_is_GdkWindow_(window) || Xen_is_false(window), window, 1, "gdk_window_set_user_data", "GdkWindow*");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 2, "gdk_window_set_user_data", "gpointer");
  gdk_window_set_user_data(Xen_to_C_GdkWindow_(window), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_window_add_filter(Xen window, Xen func, Xen func_info)
{
  #define H_gdk_window_add_filter "void gdk_window_add_filter(GdkWindow* window, GdkFilterFunc func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_add_filter", "GdkWindow*");
  Xen_check_type(Xen_is_GdkFilterFunc(func), func, 2, "gdk_window_add_filter", "GdkFilterFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gdk_window_add_filter", "lambda_data");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gdk_window_add_filter(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkFilterFunc(func), Xen_to_C_lambda_data(func_info));
    return(Xen_false);
   }
}

static Xen gxg_gdk_window_remove_filter(Xen window, Xen func, Xen func_info)
{
  #define H_gdk_window_remove_filter "void gdk_window_remove_filter(GdkWindow* window, GdkFilterFunc func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_remove_filter", "GdkWindow*");
  Xen_check_type(Xen_is_GdkFilterFunc(func), func, 2, "gdk_window_remove_filter", "GdkFilterFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gdk_window_remove_filter", "lambda_data");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gdk_window_remove_filter(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkFilterFunc(func), Xen_to_C_lambda_data(func_info));
    return(Xen_false);
   }
}

static Xen gxg_gdk_window_scroll(Xen window, Xen dx, Xen dy)
{
  #define H_gdk_window_scroll "void gdk_window_scroll(GdkWindow* window, gint dx, gint dy)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_scroll", "GdkWindow*");
  Xen_check_type(Xen_is_gint(dx), dx, 2, "gdk_window_scroll", "gint");
  Xen_check_type(Xen_is_gint(dy), dy, 3, "gdk_window_scroll", "gint");
  gdk_window_scroll(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(dx), Xen_to_C_gint(dy));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_child_shapes(Xen window)
{
  #define H_gdk_window_set_child_shapes "void gdk_window_set_child_shapes(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_child_shapes", "GdkWindow*");
  gdk_window_set_child_shapes(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_merge_child_shapes(Xen window)
{
  #define H_gdk_window_merge_child_shapes "void gdk_window_merge_child_shapes(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_merge_child_shapes", "GdkWindow*");
  gdk_window_merge_child_shapes(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_is_visible(Xen window)
{
  #define H_gdk_window_is_visible "gboolean gdk_window_is_visible(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_is_visible", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_is_visible(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_is_viewable(Xen window)
{
  #define H_gdk_window_is_viewable "gboolean gdk_window_is_viewable(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_is_viewable", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_is_viewable(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_state(Xen window)
{
  #define H_gdk_window_get_state "GdkWindowState gdk_window_get_state(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_state", "GdkWindow*");
  return(C_to_Xen_GdkWindowState(gdk_window_get_state(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_root_origin(Xen window, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_window_get_root_origin "void gdk_window_get_root_origin(GdkWindow* window, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_root_origin", "GdkWindow*");
  gdk_window_get_root_origin(Xen_to_C_GdkWindow_(window), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
}

static Xen gxg_gdk_window_get_frame_extents(Xen window, Xen rect)
{
  #define H_gdk_window_get_frame_extents "void gdk_window_get_frame_extents(GdkWindow* window, GdkRectangle* rect)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_frame_extents", "GdkWindow*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gdk_window_get_frame_extents", "GdkRectangle*");
  gdk_window_get_frame_extents(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkRectangle_(rect));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_parent(Xen window)
{
  #define H_gdk_window_get_parent "GdkWindow* gdk_window_get_parent(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_parent", "GdkWindow*");
  return(C_to_Xen_GdkWindow_(gdk_window_get_parent(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_toplevel(Xen window)
{
  #define H_gdk_window_get_toplevel "GdkWindow* gdk_window_get_toplevel(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_toplevel", "GdkWindow*");
  return(C_to_Xen_GdkWindow_(gdk_window_get_toplevel(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_children(Xen window)
{
  #define H_gdk_window_get_children "GList* gdk_window_get_children(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_children", "GdkWindow*");
  return(C_to_Xen_GList_(gdk_window_get_children(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_peek_children(Xen window)
{
  #define H_gdk_window_peek_children "GList* gdk_window_peek_children(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_peek_children", "GdkWindow*");
  return(C_to_Xen_GList_(gdk_window_peek_children(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_events(Xen window)
{
  #define H_gdk_window_get_events "GdkEventMask gdk_window_get_events(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_events", "GdkWindow*");
  return(C_to_Xen_GdkEventMask(gdk_window_get_events(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_set_events(Xen window, Xen event_mask)
{
  #define H_gdk_window_set_events "void gdk_window_set_events(GdkWindow* window, GdkEventMask event_mask)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_events", "GdkWindow*");
  Xen_check_type(Xen_is_GdkEventMask(event_mask), event_mask, 2, "gdk_window_set_events", "GdkEventMask");
  gdk_window_set_events(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkEventMask(event_mask));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_icon_name(Xen window, Xen name)
{
  #define H_gdk_window_set_icon_name "void gdk_window_set_icon_name(GdkWindow* window, gchar* name)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_icon_name", "GdkWindow*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gdk_window_set_icon_name", "gchar*");
  gdk_window_set_icon_name(Xen_to_C_GdkWindow_(window), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_group(Xen window, Xen leader)
{
  #define H_gdk_window_set_group "void gdk_window_set_group(GdkWindow* window, GdkWindow* leader)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_group", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWindow_(leader), leader, 2, "gdk_window_set_group", "GdkWindow*");
  gdk_window_set_group(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWindow_(leader));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_decorations(Xen window, Xen decorations)
{
  #define H_gdk_window_set_decorations "void gdk_window_set_decorations(GdkWindow* window, GdkWMDecoration decorations)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_decorations", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWMDecoration(decorations), decorations, 2, "gdk_window_set_decorations", "GdkWMDecoration");
  gdk_window_set_decorations(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWMDecoration(decorations));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_decorations(Xen window, Xen ignore_decorations)
{
  #define H_gdk_window_get_decorations "gboolean gdk_window_get_decorations(GdkWindow* window, GdkWMDecoration* [decorations])"
  GdkWMDecoration ref_decorations;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_decorations", "GdkWindow*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_window_get_decorations(Xen_to_C_GdkWindow_(window), &ref_decorations));
    return(Xen_list_2(result, C_to_Xen_GdkWMDecoration(ref_decorations)));
   }
}

static Xen gxg_gdk_window_set_functions(Xen window, Xen functions)
{
  #define H_gdk_window_set_functions "void gdk_window_set_functions(GdkWindow* window, GdkWMFunction functions)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_functions", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWMFunction(functions), functions, 2, "gdk_window_set_functions", "GdkWMFunction");
  gdk_window_set_functions(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWMFunction(functions));
  return(Xen_false);
}

static Xen gxg_gdk_window_iconify(Xen window)
{
  #define H_gdk_window_iconify "void gdk_window_iconify(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_iconify", "GdkWindow*");
  gdk_window_iconify(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_deiconify(Xen window)
{
  #define H_gdk_window_deiconify "void gdk_window_deiconify(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_deiconify", "GdkWindow*");
  gdk_window_deiconify(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_stick(Xen window)
{
  #define H_gdk_window_stick "void gdk_window_stick(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_stick", "GdkWindow*");
  gdk_window_stick(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_unstick(Xen window)
{
  #define H_gdk_window_unstick "void gdk_window_unstick(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_unstick", "GdkWindow*");
  gdk_window_unstick(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_maximize(Xen window)
{
  #define H_gdk_window_maximize "void gdk_window_maximize(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_maximize", "GdkWindow*");
  gdk_window_maximize(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_unmaximize(Xen window)
{
  #define H_gdk_window_unmaximize "void gdk_window_unmaximize(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_unmaximize", "GdkWindow*");
  gdk_window_unmaximize(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_register_dnd(Xen window)
{
  #define H_gdk_window_register_dnd "void gdk_window_register_dnd(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_register_dnd", "GdkWindow*");
  gdk_window_register_dnd(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_begin_resize_drag(Xen window, Xen edge, Xen button, Xen root_x, Xen root_y, Xen timestamp)
{
  #define H_gdk_window_begin_resize_drag "void gdk_window_begin_resize_drag(GdkWindow* window, GdkWindowEdge edge, \
gint button, gint root_x, gint root_y, guint32 timestamp)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_begin_resize_drag", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWindowEdge(edge), edge, 2, "gdk_window_begin_resize_drag", "GdkWindowEdge");
  Xen_check_type(Xen_is_gint(button), button, 3, "gdk_window_begin_resize_drag", "gint");
  Xen_check_type(Xen_is_gint(root_x), root_x, 4, "gdk_window_begin_resize_drag", "gint");
  Xen_check_type(Xen_is_gint(root_y), root_y, 5, "gdk_window_begin_resize_drag", "gint");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 6, "gdk_window_begin_resize_drag", "guint32");
  gdk_window_begin_resize_drag(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWindowEdge(edge), Xen_to_C_gint(button), Xen_to_C_gint(root_x), 
                               Xen_to_C_gint(root_y), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gdk_window_begin_move_drag(Xen window, Xen button, Xen root_x, Xen root_y, Xen timestamp)
{
  #define H_gdk_window_begin_move_drag "void gdk_window_begin_move_drag(GdkWindow* window, gint button, \
gint root_x, gint root_y, guint32 timestamp)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_begin_move_drag", "GdkWindow*");
  Xen_check_type(Xen_is_gint(button), button, 2, "gdk_window_begin_move_drag", "gint");
  Xen_check_type(Xen_is_gint(root_x), root_x, 3, "gdk_window_begin_move_drag", "gint");
  Xen_check_type(Xen_is_gint(root_y), root_y, 4, "gdk_window_begin_move_drag", "gint");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 5, "gdk_window_begin_move_drag", "guint32");
  gdk_window_begin_move_drag(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(button), Xen_to_C_gint(root_x), Xen_to_C_gint(root_y), 
                             Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gdk_window_invalidate_rect(Xen window, Xen rect, Xen invalidate_children)
{
  #define H_gdk_window_invalidate_rect "void gdk_window_invalidate_rect(GdkWindow* window, GdkRectangle* rect, \
gboolean invalidate_children)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_invalidate_rect", "GdkWindow*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gdk_window_invalidate_rect", "GdkRectangle*");
  Xen_check_type(Xen_is_gboolean(invalidate_children), invalidate_children, 3, "gdk_window_invalidate_rect", "gboolean");
  gdk_window_invalidate_rect(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkRectangle_(rect), Xen_to_C_gboolean(invalidate_children));
  return(Xen_false);
}

static Xen gxg_gdk_window_freeze_updates(Xen window)
{
  #define H_gdk_window_freeze_updates "void gdk_window_freeze_updates(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_freeze_updates", "GdkWindow*");
  gdk_window_freeze_updates(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_thaw_updates(Xen window)
{
  #define H_gdk_window_thaw_updates "void gdk_window_thaw_updates(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_thaw_updates", "GdkWindow*");
  gdk_window_thaw_updates(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_constrain_size(Xen geometry, Xen flags, Xen width, Xen height, Xen ignore_new_width, Xen ignore_new_height)
{
  #define H_gdk_window_constrain_size "void gdk_window_constrain_size(GdkGeometry* geometry, GdkWindowHints flags, \
gint width, gint height, gint* [new_width], gint* [new_height])"
  gint ref_new_width;
  gint ref_new_height;
  Xen_check_type(Xen_is_GdkGeometry_(geometry), geometry, 1, "gdk_window_constrain_size", "GdkGeometry*");
  Xen_check_type(Xen_is_GdkWindowHints(flags), flags, 2, "gdk_window_constrain_size", "GdkWindowHints");
  Xen_check_type(Xen_is_gint(width), width, 3, "gdk_window_constrain_size", "gint");
  Xen_check_type(Xen_is_gint(height), height, 4, "gdk_window_constrain_size", "gint");
  gdk_window_constrain_size(Xen_to_C_GdkGeometry_(geometry), Xen_to_C_GdkWindowHints(flags), Xen_to_C_gint(width), Xen_to_C_gint(height), 
                            &ref_new_width, &ref_new_height);
  return(Xen_list_2(C_to_Xen_gint(ref_new_width), C_to_Xen_gint(ref_new_height)));
}

static Xen gxg_gdk_window_set_type_hint(Xen window, Xen hint)
{
  #define H_gdk_window_set_type_hint "void gdk_window_set_type_hint(GdkWindow* window, GdkWindowTypeHint hint)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_type_hint", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWindowTypeHint(hint), hint, 2, "gdk_window_set_type_hint", "GdkWindowTypeHint");
  gdk_window_set_type_hint(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWindowTypeHint(hint));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_modal_hint(Xen window, Xen modal)
{
  #define H_gdk_window_set_modal_hint "void gdk_window_set_modal_hint(GdkWindow* window, gboolean modal)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_modal_hint", "GdkWindow*");
  Xen_check_type(Xen_is_gboolean(modal), modal, 2, "gdk_window_set_modal_hint", "gboolean");
  gdk_window_set_modal_hint(Xen_to_C_GdkWindow_(window), Xen_to_C_gboolean(modal));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_title(Xen window, Xen title)
{
  #define H_gdk_window_set_title "void gdk_window_set_title(GdkWindow* window, gchar* title)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_title", "GdkWindow*");
  Xen_check_type(Xen_is_gchar_(title), title, 2, "gdk_window_set_title", "gchar*");
  gdk_window_set_title(Xen_to_C_GdkWindow_(window), Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_role(Xen window, Xen role)
{
  #define H_gdk_window_set_role "void gdk_window_set_role(GdkWindow* window, gchar* role)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_role", "GdkWindow*");
  Xen_check_type(Xen_is_gchar_(role), role, 2, "gdk_window_set_role", "gchar*");
  gdk_window_set_role(Xen_to_C_GdkWindow_(window), Xen_to_C_gchar_(role));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_transient_for(Xen window, Xen parent)
{
  #define H_gdk_window_set_transient_for "void gdk_window_set_transient_for(GdkWindow* window, GdkWindow* parent)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_transient_for", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWindow_(parent), parent, 2, "gdk_window_set_transient_for", "GdkWindow*");
  gdk_window_set_transient_for(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWindow_(parent));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_cursor(Xen window, Xen cursor)
{
  #define H_gdk_window_set_cursor "void gdk_window_set_cursor(GdkWindow* window, GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_cursor", "GdkWindow*");
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 2, "gdk_window_set_cursor", "GdkCursor*");
  gdk_window_set_cursor(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkCursor_(cursor));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_user_data(Xen window, Xen ignore_data)
{
  #define H_gdk_window_get_user_data "void gdk_window_get_user_data(GdkWindow* window, gpointer* [data])"
  gpointer ref_data;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_user_data", "GdkWindow*");
  gdk_window_get_user_data(Xen_to_C_GdkWindow_(window), &ref_data);
  return(Xen_list_1(C_to_Xen_gpointer(ref_data)));
}

static Xen gxg_gdk_window_get_position(Xen window, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_window_get_position "void gdk_window_get_position(GdkWindow* window, gint* [x], gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_position", "GdkWindow*");
  gdk_window_get_position(Xen_to_C_GdkWindow_(window), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
}

static Xen gxg_gdk_window_get_origin(Xen window, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_window_get_origin "gint gdk_window_get_origin(GdkWindow* window, gint* [x], gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_origin", "GdkWindow*");
  {
    Xen result;
    result = C_to_Xen_gint(gdk_window_get_origin(Xen_to_C_GdkWindow_(window), &ref_x, &ref_y));
    return(Xen_list_3(result, C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
   }
}

static Xen gxg_gdk_pixbuf_error_quark(void)
{
  #define H_gdk_pixbuf_error_quark "GQuark gdk_pixbuf_error_quark( void)"
  return(C_to_Xen_GQuark(gdk_pixbuf_error_quark()));
}

static Xen gxg_gdk_pixbuf_get_colorspace(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_colorspace "GdkColorspace gdk_pixbuf_get_colorspace(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_colorspace", "GdkPixbuf*");
  return(C_to_Xen_GdkColorspace(gdk_pixbuf_get_colorspace(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_n_channels(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_n_channels "int gdk_pixbuf_get_n_channels(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_n_channels", "GdkPixbuf*");
  return(C_to_Xen_int(gdk_pixbuf_get_n_channels(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_has_alpha(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_has_alpha "gboolean gdk_pixbuf_get_has_alpha(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_has_alpha", "GdkPixbuf*");
  return(C_to_Xen_gboolean(gdk_pixbuf_get_has_alpha(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_bits_per_sample(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_bits_per_sample "int gdk_pixbuf_get_bits_per_sample(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_bits_per_sample", "GdkPixbuf*");
  return(C_to_Xen_int(gdk_pixbuf_get_bits_per_sample(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_pixels(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_pixels "guchar* gdk_pixbuf_get_pixels(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_pixels", "GdkPixbuf*");
  return(C_to_Xen_guchar_(gdk_pixbuf_get_pixels(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_width(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_width "int gdk_pixbuf_get_width(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_width", "GdkPixbuf*");
  return(C_to_Xen_int(gdk_pixbuf_get_width(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_height(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_height "int gdk_pixbuf_get_height(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_height", "GdkPixbuf*");
  return(C_to_Xen_int(gdk_pixbuf_get_height(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_get_rowstride(Xen pixbuf)
{
  #define H_gdk_pixbuf_get_rowstride "int gdk_pixbuf_get_rowstride(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_rowstride", "GdkPixbuf*");
  return(C_to_Xen_int(gdk_pixbuf_get_rowstride(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_new(Xen colorspace, Xen has_alpha, Xen bits_per_sample, Xen width, Xen height)
{
  #define H_gdk_pixbuf_new "GdkPixbuf* gdk_pixbuf_new(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, \
int width, int height)"
  Xen_check_type(Xen_is_GdkColorspace(colorspace), colorspace, 1, "gdk_pixbuf_new", "GdkColorspace");
  Xen_check_type(Xen_is_gboolean(has_alpha), has_alpha, 2, "gdk_pixbuf_new", "gboolean");
  Xen_check_type(Xen_is_int(bits_per_sample), bits_per_sample, 3, "gdk_pixbuf_new", "int");
  Xen_check_type(Xen_is_int(width), width, 4, "gdk_pixbuf_new", "int");
  Xen_check_type(Xen_is_int(height), height, 5, "gdk_pixbuf_new", "int");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_new(Xen_to_C_GdkColorspace(colorspace), Xen_to_C_gboolean(has_alpha), Xen_to_C_int(bits_per_sample), 
                                            Xen_to_C_int(width), Xen_to_C_int(height))));
}

static Xen gxg_gdk_pixbuf_copy(Xen pixbuf)
{
  #define H_gdk_pixbuf_copy "GdkPixbuf* gdk_pixbuf_copy(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_copy", "GdkPixbuf*");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_copy(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_pixbuf_new_subpixbuf(Xen src_pixbuf, Xen src_x, Xen src_y, Xen width, Xen height)
{
  #define H_gdk_pixbuf_new_subpixbuf "GdkPixbuf* gdk_pixbuf_new_subpixbuf(GdkPixbuf* src_pixbuf, int src_x, \
int src_y, int width, int height)"
  Xen_check_type(Xen_is_GdkPixbuf_(src_pixbuf), src_pixbuf, 1, "gdk_pixbuf_new_subpixbuf", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(src_x), src_x, 2, "gdk_pixbuf_new_subpixbuf", "int");
  Xen_check_type(Xen_is_int(src_y), src_y, 3, "gdk_pixbuf_new_subpixbuf", "int");
  Xen_check_type(Xen_is_int(width), width, 4, "gdk_pixbuf_new_subpixbuf", "int");
  Xen_check_type(Xen_is_int(height), height, 5, "gdk_pixbuf_new_subpixbuf", "int");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_new_subpixbuf(Xen_to_C_GdkPixbuf_(src_pixbuf), Xen_to_C_int(src_x), Xen_to_C_int(src_y), 
                                                      Xen_to_C_int(width), Xen_to_C_int(height))));
}

static Xen gxg_gdk_pixbuf_new_from_file(Xen filename, Xen ignore_error)
{
  #define H_gdk_pixbuf_new_from_file "GdkPixbuf* gdk_pixbuf_new_from_file(char* filename, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_char_(filename), filename, 1, "gdk_pixbuf_new_from_file", "char*");
  {
    Xen result;
    result = C_to_Xen_GdkPixbuf_(gdk_pixbuf_new_from_file(Xen_to_C_char_(filename), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_pixbuf_new_from_data(Xen arglist)
{
  #define H_gdk_pixbuf_new_from_data "GdkPixbuf* gdk_pixbuf_new_from_data(guchar* data, GdkColorspace colorspace, \
gboolean has_alpha, int bits_per_sample, int width, int height, int rowstride, GdkPixbufDestroyNotify destroy_fn, \
gpointer destroy_fn_data)"
  Xen data, colorspace, has_alpha, bits_per_sample, width, height, rowstride, destroy_fn, destroy_fn_data;
  data = Xen_list_ref(arglist, 0);
  colorspace = Xen_list_ref(arglist, 1);
  has_alpha = Xen_list_ref(arglist, 2);
  bits_per_sample = Xen_list_ref(arglist, 3);
  width = Xen_list_ref(arglist, 4);
  height = Xen_list_ref(arglist, 5);
  rowstride = Xen_list_ref(arglist, 6);
  destroy_fn = Xen_list_ref(arglist, 7);
  destroy_fn_data = Xen_list_ref(arglist, 8);
  Xen_check_type(Xen_is_guchar_(data), data, 1, "gdk_pixbuf_new_from_data", "guchar*");
  Xen_check_type(Xen_is_GdkColorspace(colorspace), colorspace, 2, "gdk_pixbuf_new_from_data", "GdkColorspace");
  Xen_check_type(Xen_is_gboolean(has_alpha), has_alpha, 3, "gdk_pixbuf_new_from_data", "gboolean");
  Xen_check_type(Xen_is_int(bits_per_sample), bits_per_sample, 4, "gdk_pixbuf_new_from_data", "int");
  Xen_check_type(Xen_is_int(width), width, 5, "gdk_pixbuf_new_from_data", "int");
  Xen_check_type(Xen_is_int(height), height, 6, "gdk_pixbuf_new_from_data", "int");
  Xen_check_type(Xen_is_int(rowstride), rowstride, 7, "gdk_pixbuf_new_from_data", "int");
  Xen_check_type(Xen_is_GdkPixbufDestroyNotify(destroy_fn), destroy_fn, 8, "gdk_pixbuf_new_from_data", "GdkPixbufDestroyNotify");
  Xen_check_type(Xen_is_gpointer(destroy_fn_data), destroy_fn_data, 9, "gdk_pixbuf_new_from_data", "gpointer");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_new_from_data(Xen_to_C_guchar_(data), Xen_to_C_GdkColorspace(colorspace), Xen_to_C_gboolean(has_alpha), 
                                                      Xen_to_C_int(bits_per_sample), Xen_to_C_int(width), Xen_to_C_int(height), 
                                                      Xen_to_C_int(rowstride), Xen_to_C_GdkPixbufDestroyNotify(destroy_fn), 
                                                      Xen_to_C_gpointer(destroy_fn_data))));
}

static Xen gxg_gdk_pixbuf_new_from_xpm_data(Xen data)
{
  #define H_gdk_pixbuf_new_from_xpm_data "GdkPixbuf* gdk_pixbuf_new_from_xpm_data(char** data)"
  Xen_check_type(Xen_is_char__(data), data, 1, "gdk_pixbuf_new_from_xpm_data", "char**");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_new_from_xpm_data((const char**)Xen_to_C_char__(data))));
}

static Xen gxg_gdk_pixbuf_fill(Xen pixbuf, Xen pixel)
{
  #define H_gdk_pixbuf_fill "void gdk_pixbuf_fill(GdkPixbuf* pixbuf, guint32 pixel)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_fill", "GdkPixbuf*");
  Xen_check_type(Xen_is_guint32(pixel), pixel, 2, "gdk_pixbuf_fill", "guint32");
  gdk_pixbuf_fill(Xen_to_C_GdkPixbuf_(pixbuf), Xen_to_C_guint32(pixel));
  return(Xen_false);
}

static Xen gxg_gdk_pixbuf_savev(Xen pixbuf, Xen filename, Xen type, Xen option_keys, Xen option_values, Xen ignore_error)
{
  #define H_gdk_pixbuf_savev "gboolean gdk_pixbuf_savev(GdkPixbuf* pixbuf, char* filename, char* type, \
char** option_keys, char** option_values, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_savev", "GdkPixbuf*");
  Xen_check_type(Xen_is_char_(filename), filename, 2, "gdk_pixbuf_savev", "char*");
  Xen_check_type(Xen_is_char_(type), type, 3, "gdk_pixbuf_savev", "char*");
  Xen_check_type(Xen_is_char__(option_keys), option_keys, 4, "gdk_pixbuf_savev", "char**");
  Xen_check_type(Xen_is_char__(option_values), option_values, 5, "gdk_pixbuf_savev", "char**");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_pixbuf_savev(Xen_to_C_GdkPixbuf_(pixbuf), Xen_to_C_char_(filename), Xen_to_C_char_(type), 
                                                Xen_to_C_char__(option_keys), Xen_to_C_char__(option_values), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_pixbuf_add_alpha(Xen pixbuf, Xen substitute_color, Xen r, Xen g, Xen b)
{
  #define H_gdk_pixbuf_add_alpha "GdkPixbuf* gdk_pixbuf_add_alpha(GdkPixbuf* pixbuf, gboolean substitute_color, \
guchar r, guchar g, guchar b)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_add_alpha", "GdkPixbuf*");
  Xen_check_type(Xen_is_gboolean(substitute_color), substitute_color, 2, "gdk_pixbuf_add_alpha", "gboolean");
  Xen_check_type(Xen_is_guchar(r), r, 3, "gdk_pixbuf_add_alpha", "guchar");
  Xen_check_type(Xen_is_guchar(g), g, 4, "gdk_pixbuf_add_alpha", "guchar");
  Xen_check_type(Xen_is_guchar(b), b, 5, "gdk_pixbuf_add_alpha", "guchar");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_add_alpha(Xen_to_C_GdkPixbuf_(pixbuf), Xen_to_C_gboolean(substitute_color), Xen_to_C_guchar(r), 
                                                  Xen_to_C_guchar(g), Xen_to_C_guchar(b))));
}

static Xen gxg_gdk_pixbuf_copy_area(Xen arglist)
{
  #define H_gdk_pixbuf_copy_area "void gdk_pixbuf_copy_area(GdkPixbuf* src_pixbuf, int src_x, int src_y, \
int width, int height, GdkPixbuf* dest_pixbuf, int dest_x, int dest_y)"
  Xen src_pixbuf, src_x, src_y, width, height, dest_pixbuf, dest_x, dest_y;
  src_pixbuf = Xen_list_ref(arglist, 0);
  src_x = Xen_list_ref(arglist, 1);
  src_y = Xen_list_ref(arglist, 2);
  width = Xen_list_ref(arglist, 3);
  height = Xen_list_ref(arglist, 4);
  dest_pixbuf = Xen_list_ref(arglist, 5);
  dest_x = Xen_list_ref(arglist, 6);
  dest_y = Xen_list_ref(arglist, 7);
  Xen_check_type(Xen_is_GdkPixbuf_(src_pixbuf), src_pixbuf, 1, "gdk_pixbuf_copy_area", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(src_x), src_x, 2, "gdk_pixbuf_copy_area", "int");
  Xen_check_type(Xen_is_int(src_y), src_y, 3, "gdk_pixbuf_copy_area", "int");
  Xen_check_type(Xen_is_int(width), width, 4, "gdk_pixbuf_copy_area", "int");
  Xen_check_type(Xen_is_int(height), height, 5, "gdk_pixbuf_copy_area", "int");
  Xen_check_type(Xen_is_GdkPixbuf_(dest_pixbuf), dest_pixbuf, 6, "gdk_pixbuf_copy_area", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(dest_x), dest_x, 7, "gdk_pixbuf_copy_area", "int");
  Xen_check_type(Xen_is_int(dest_y), dest_y, 8, "gdk_pixbuf_copy_area", "int");
  gdk_pixbuf_copy_area(Xen_to_C_GdkPixbuf_(src_pixbuf), Xen_to_C_int(src_x), Xen_to_C_int(src_y), Xen_to_C_int(width), Xen_to_C_int(height), 
                       Xen_to_C_GdkPixbuf_(dest_pixbuf), Xen_to_C_int(dest_x), Xen_to_C_int(dest_y));
  return(Xen_false);
}

static Xen gxg_gdk_pixbuf_saturate_and_pixelate(Xen src, Xen dest, Xen saturation, Xen pixelate)
{
  #define H_gdk_pixbuf_saturate_and_pixelate "void gdk_pixbuf_saturate_and_pixelate(GdkPixbuf* src, GdkPixbuf* dest, \
gfloat saturation, gboolean pixelate)"
  Xen_check_type(Xen_is_GdkPixbuf_(src), src, 1, "gdk_pixbuf_saturate_and_pixelate", "GdkPixbuf*");
  Xen_check_type(Xen_is_GdkPixbuf_(dest), dest, 2, "gdk_pixbuf_saturate_and_pixelate", "GdkPixbuf*");
  Xen_check_type(Xen_is_gfloat(saturation), saturation, 3, "gdk_pixbuf_saturate_and_pixelate", "gfloat");
  Xen_check_type(Xen_is_gboolean(pixelate), pixelate, 4, "gdk_pixbuf_saturate_and_pixelate", "gboolean");
  gdk_pixbuf_saturate_and_pixelate(Xen_to_C_GdkPixbuf_(src), Xen_to_C_GdkPixbuf_(dest), Xen_to_C_gfloat(saturation), Xen_to_C_gboolean(pixelate));
  return(Xen_false);
}

static Xen gxg_gdk_pixbuf_scale(Xen arglist)
{
  #define H_gdk_pixbuf_scale "void gdk_pixbuf_scale(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, int dest_y, \
int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type)"
  Xen src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type;
  src = Xen_list_ref(arglist, 0);
  dest = Xen_list_ref(arglist, 1);
  dest_x = Xen_list_ref(arglist, 2);
  dest_y = Xen_list_ref(arglist, 3);
  dest_width = Xen_list_ref(arglist, 4);
  dest_height = Xen_list_ref(arglist, 5);
  offset_x = Xen_list_ref(arglist, 6);
  offset_y = Xen_list_ref(arglist, 7);
  scale_x = Xen_list_ref(arglist, 8);
  scale_y = Xen_list_ref(arglist, 9);
  interp_type = Xen_list_ref(arglist, 10);
  Xen_check_type(Xen_is_GdkPixbuf_(src), src, 1, "gdk_pixbuf_scale", "GdkPixbuf*");
  Xen_check_type(Xen_is_GdkPixbuf_(dest), dest, 2, "gdk_pixbuf_scale", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(dest_x), dest_x, 3, "gdk_pixbuf_scale", "int");
  Xen_check_type(Xen_is_int(dest_y), dest_y, 4, "gdk_pixbuf_scale", "int");
  Xen_check_type(Xen_is_int(dest_width), dest_width, 5, "gdk_pixbuf_scale", "int");
  Xen_check_type(Xen_is_int(dest_height), dest_height, 6, "gdk_pixbuf_scale", "int");
  Xen_check_type(Xen_is_double(offset_x), offset_x, 7, "gdk_pixbuf_scale", "double");
  Xen_check_type(Xen_is_double(offset_y), offset_y, 8, "gdk_pixbuf_scale", "double");
  Xen_check_type(Xen_is_double(scale_x), scale_x, 9, "gdk_pixbuf_scale", "double");
  Xen_check_type(Xen_is_double(scale_y), scale_y, 10, "gdk_pixbuf_scale", "double");
  Xen_check_type(Xen_is_GdkInterpType(interp_type), interp_type, 11, "gdk_pixbuf_scale", "GdkInterpType");
  gdk_pixbuf_scale(Xen_to_C_GdkPixbuf_(src), Xen_to_C_GdkPixbuf_(dest), Xen_to_C_int(dest_x), Xen_to_C_int(dest_y), Xen_to_C_int(dest_width), 
                   Xen_to_C_int(dest_height), Xen_to_C_double(offset_x), Xen_to_C_double(offset_y), Xen_to_C_double(scale_x), 
                   Xen_to_C_double(scale_y), Xen_to_C_GdkInterpType(interp_type));
  return(Xen_false);
}

static Xen gxg_gdk_pixbuf_composite(Xen arglist)
{
  #define H_gdk_pixbuf_composite "void gdk_pixbuf_composite(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, \
int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, \
GdkInterpType interp_type, int overall_alpha)"
  Xen src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha;
  src = Xen_list_ref(arglist, 0);
  dest = Xen_list_ref(arglist, 1);
  dest_x = Xen_list_ref(arglist, 2);
  dest_y = Xen_list_ref(arglist, 3);
  dest_width = Xen_list_ref(arglist, 4);
  dest_height = Xen_list_ref(arglist, 5);
  offset_x = Xen_list_ref(arglist, 6);
  offset_y = Xen_list_ref(arglist, 7);
  scale_x = Xen_list_ref(arglist, 8);
  scale_y = Xen_list_ref(arglist, 9);
  interp_type = Xen_list_ref(arglist, 10);
  overall_alpha = Xen_list_ref(arglist, 11);
  Xen_check_type(Xen_is_GdkPixbuf_(src), src, 1, "gdk_pixbuf_composite", "GdkPixbuf*");
  Xen_check_type(Xen_is_GdkPixbuf_(dest), dest, 2, "gdk_pixbuf_composite", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(dest_x), dest_x, 3, "gdk_pixbuf_composite", "int");
  Xen_check_type(Xen_is_int(dest_y), dest_y, 4, "gdk_pixbuf_composite", "int");
  Xen_check_type(Xen_is_int(dest_width), dest_width, 5, "gdk_pixbuf_composite", "int");
  Xen_check_type(Xen_is_int(dest_height), dest_height, 6, "gdk_pixbuf_composite", "int");
  Xen_check_type(Xen_is_double(offset_x), offset_x, 7, "gdk_pixbuf_composite", "double");
  Xen_check_type(Xen_is_double(offset_y), offset_y, 8, "gdk_pixbuf_composite", "double");
  Xen_check_type(Xen_is_double(scale_x), scale_x, 9, "gdk_pixbuf_composite", "double");
  Xen_check_type(Xen_is_double(scale_y), scale_y, 10, "gdk_pixbuf_composite", "double");
  Xen_check_type(Xen_is_GdkInterpType(interp_type), interp_type, 11, "gdk_pixbuf_composite", "GdkInterpType");
  Xen_check_type(Xen_is_int(overall_alpha), overall_alpha, 12, "gdk_pixbuf_composite", "int");
  gdk_pixbuf_composite(Xen_to_C_GdkPixbuf_(src), Xen_to_C_GdkPixbuf_(dest), Xen_to_C_int(dest_x), Xen_to_C_int(dest_y), Xen_to_C_int(dest_width), 
                       Xen_to_C_int(dest_height), Xen_to_C_double(offset_x), Xen_to_C_double(offset_y), Xen_to_C_double(scale_x), 
                       Xen_to_C_double(scale_y), Xen_to_C_GdkInterpType(interp_type), Xen_to_C_int(overall_alpha));
  return(Xen_false);
}

static Xen gxg_gdk_pixbuf_composite_color(Xen arglist)
{
  #define H_gdk_pixbuf_composite_color "void gdk_pixbuf_composite_color(GdkPixbuf* src, GdkPixbuf* dest, \
int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, \
double scale_y, GdkInterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, \
guint32 color1, guint32 color2)"
  Xen src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha, check_x, check_y, check_size, color1, color2;
  src = Xen_list_ref(arglist, 0);
  dest = Xen_list_ref(arglist, 1);
  dest_x = Xen_list_ref(arglist, 2);
  dest_y = Xen_list_ref(arglist, 3);
  dest_width = Xen_list_ref(arglist, 4);
  dest_height = Xen_list_ref(arglist, 5);
  offset_x = Xen_list_ref(arglist, 6);
  offset_y = Xen_list_ref(arglist, 7);
  scale_x = Xen_list_ref(arglist, 8);
  scale_y = Xen_list_ref(arglist, 9);
  interp_type = Xen_list_ref(arglist, 10);
  overall_alpha = Xen_list_ref(arglist, 11);
  check_x = Xen_list_ref(arglist, 12);
  check_y = Xen_list_ref(arglist, 13);
  check_size = Xen_list_ref(arglist, 14);
  color1 = Xen_list_ref(arglist, 15);
  color2 = Xen_list_ref(arglist, 16);
  Xen_check_type(Xen_is_GdkPixbuf_(src), src, 1, "gdk_pixbuf_composite_color", "GdkPixbuf*");
  Xen_check_type(Xen_is_GdkPixbuf_(dest), dest, 2, "gdk_pixbuf_composite_color", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(dest_x), dest_x, 3, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_int(dest_y), dest_y, 4, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_int(dest_width), dest_width, 5, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_int(dest_height), dest_height, 6, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_double(offset_x), offset_x, 7, "gdk_pixbuf_composite_color", "double");
  Xen_check_type(Xen_is_double(offset_y), offset_y, 8, "gdk_pixbuf_composite_color", "double");
  Xen_check_type(Xen_is_double(scale_x), scale_x, 9, "gdk_pixbuf_composite_color", "double");
  Xen_check_type(Xen_is_double(scale_y), scale_y, 10, "gdk_pixbuf_composite_color", "double");
  Xen_check_type(Xen_is_GdkInterpType(interp_type), interp_type, 11, "gdk_pixbuf_composite_color", "GdkInterpType");
  Xen_check_type(Xen_is_int(overall_alpha), overall_alpha, 12, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_int(check_x), check_x, 13, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_int(check_y), check_y, 14, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_int(check_size), check_size, 15, "gdk_pixbuf_composite_color", "int");
  Xen_check_type(Xen_is_guint32(color1), color1, 16, "gdk_pixbuf_composite_color", "guint32");
  Xen_check_type(Xen_is_guint32(color2), color2, 17, "gdk_pixbuf_composite_color", "guint32");
  gdk_pixbuf_composite_color(Xen_to_C_GdkPixbuf_(src), Xen_to_C_GdkPixbuf_(dest), Xen_to_C_int(dest_x), Xen_to_C_int(dest_y), 
                             Xen_to_C_int(dest_width), Xen_to_C_int(dest_height), Xen_to_C_double(offset_x), Xen_to_C_double(offset_y), 
                             Xen_to_C_double(scale_x), Xen_to_C_double(scale_y), Xen_to_C_GdkInterpType(interp_type), Xen_to_C_int(overall_alpha), 
                             Xen_to_C_int(check_x), Xen_to_C_int(check_y), Xen_to_C_int(check_size), Xen_to_C_guint32(color1), 
                             Xen_to_C_guint32(color2));
  return(Xen_false);
}

static Xen gxg_gdk_pixbuf_scale_simple(Xen src, Xen dest_width, Xen dest_height, Xen interp_type)
{
  #define H_gdk_pixbuf_scale_simple "GdkPixbuf* gdk_pixbuf_scale_simple(GdkPixbuf* src, int dest_width, \
int dest_height, GdkInterpType interp_type)"
  Xen_check_type(Xen_is_GdkPixbuf_(src), src, 1, "gdk_pixbuf_scale_simple", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(dest_width), dest_width, 2, "gdk_pixbuf_scale_simple", "int");
  Xen_check_type(Xen_is_int(dest_height), dest_height, 3, "gdk_pixbuf_scale_simple", "int");
  Xen_check_type(Xen_is_GdkInterpType(interp_type), interp_type, 4, "gdk_pixbuf_scale_simple", "GdkInterpType");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_scale_simple(Xen_to_C_GdkPixbuf_(src), Xen_to_C_int(dest_width), Xen_to_C_int(dest_height), 
                                                     Xen_to_C_GdkInterpType(interp_type))));
}

static Xen gxg_gdk_pixbuf_composite_color_simple(Xen arglist)
{
  #define H_gdk_pixbuf_composite_color_simple "GdkPixbuf* gdk_pixbuf_composite_color_simple(GdkPixbuf* src, \
int dest_width, int dest_height, GdkInterpType interp_type, int overall_alpha, int check_size, guint32 color1, \
guint32 color2)"
  Xen src, dest_width, dest_height, interp_type, overall_alpha, check_size, color1, color2;
  src = Xen_list_ref(arglist, 0);
  dest_width = Xen_list_ref(arglist, 1);
  dest_height = Xen_list_ref(arglist, 2);
  interp_type = Xen_list_ref(arglist, 3);
  overall_alpha = Xen_list_ref(arglist, 4);
  check_size = Xen_list_ref(arglist, 5);
  color1 = Xen_list_ref(arglist, 6);
  color2 = Xen_list_ref(arglist, 7);
  Xen_check_type(Xen_is_GdkPixbuf_(src), src, 1, "gdk_pixbuf_composite_color_simple", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(dest_width), dest_width, 2, "gdk_pixbuf_composite_color_simple", "int");
  Xen_check_type(Xen_is_int(dest_height), dest_height, 3, "gdk_pixbuf_composite_color_simple", "int");
  Xen_check_type(Xen_is_GdkInterpType(interp_type), interp_type, 4, "gdk_pixbuf_composite_color_simple", "GdkInterpType");
  Xen_check_type(Xen_is_int(overall_alpha), overall_alpha, 5, "gdk_pixbuf_composite_color_simple", "int");
  Xen_check_type(Xen_is_int(check_size), check_size, 6, "gdk_pixbuf_composite_color_simple", "int");
  Xen_check_type(Xen_is_guint32(color1), color1, 7, "gdk_pixbuf_composite_color_simple", "guint32");
  Xen_check_type(Xen_is_guint32(color2), color2, 8, "gdk_pixbuf_composite_color_simple", "guint32");
  return(C_to_Xen_GdkPixbuf_(gdk_pixbuf_composite_color_simple(Xen_to_C_GdkPixbuf_(src), Xen_to_C_int(dest_width), Xen_to_C_int(dest_height), 
                                                               Xen_to_C_GdkInterpType(interp_type), Xen_to_C_int(overall_alpha), 
                                                               Xen_to_C_int(check_size), Xen_to_C_guint32(color1), Xen_to_C_guint32(color2))));
}

static Xen gxg_gdk_pixbuf_get_option(Xen pixbuf, Xen key)
{
  #define H_gdk_pixbuf_get_option "gchar* gdk_pixbuf_get_option(GdkPixbuf* pixbuf, gchar* key)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_pixbuf_get_option", "GdkPixbuf*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gdk_pixbuf_get_option", "gchar*");
  return(C_to_Xen_gchar_(gdk_pixbuf_get_option(Xen_to_C_GdkPixbuf_(pixbuf), Xen_to_C_gchar_(key))));
}

static Xen gxg_gtk_accel_group_new(void)
{
  #define H_gtk_accel_group_new "GtkAccelGroup* gtk_accel_group_new( void)"
  return(C_to_Xen_GtkAccelGroup_(gtk_accel_group_new()));
}

static Xen gxg_gtk_accel_group_lock(Xen accel_group)
{
  #define H_gtk_accel_group_lock "void gtk_accel_group_lock(GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_lock", "GtkAccelGroup*");
  gtk_accel_group_lock(Xen_to_C_GtkAccelGroup_(accel_group));
  return(Xen_false);
}

static Xen gxg_gtk_accel_group_unlock(Xen accel_group)
{
  #define H_gtk_accel_group_unlock "void gtk_accel_group_unlock(GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_unlock", "GtkAccelGroup*");
  gtk_accel_group_unlock(Xen_to_C_GtkAccelGroup_(accel_group));
  return(Xen_false);
}

static Xen gxg_gtk_accel_group_connect(Xen accel_group, Xen accel_key, Xen accel_mods, Xen accel_flags, Xen closure)
{
  #define H_gtk_accel_group_connect "void gtk_accel_group_connect(GtkAccelGroup* accel_group, guint accel_key, \
GdkModifierType accel_mods, GtkAccelFlags accel_flags, GClosure* closure)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_connect", "GtkAccelGroup*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 2, "gtk_accel_group_connect", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 3, "gtk_accel_group_connect", "GdkModifierType");
  Xen_check_type(Xen_is_GtkAccelFlags(accel_flags), accel_flags, 4, "gtk_accel_group_connect", "GtkAccelFlags");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 5, "gtk_accel_group_connect", "GClosure*");
  gtk_accel_group_connect(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods), 
                          Xen_to_C_GtkAccelFlags(accel_flags), Xen_to_C_GClosure_(closure));
  return(Xen_false);
}

static Xen gxg_gtk_accel_group_connect_by_path(Xen accel_group, Xen accel_path, Xen closure)
{
  #define H_gtk_accel_group_connect_by_path "void gtk_accel_group_connect_by_path(GtkAccelGroup* accel_group, \
gchar* accel_path, GClosure* closure)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_connect_by_path", "GtkAccelGroup*");
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 2, "gtk_accel_group_connect_by_path", "gchar*");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 3, "gtk_accel_group_connect_by_path", "GClosure*");
  gtk_accel_group_connect_by_path(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_gchar_(accel_path), Xen_to_C_GClosure_(closure));
  return(Xen_false);
}

static Xen gxg_gtk_accel_group_disconnect(Xen accel_group, Xen closure)
{
  #define H_gtk_accel_group_disconnect "gboolean gtk_accel_group_disconnect(GtkAccelGroup* accel_group, \
GClosure* closure)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_disconnect", "GtkAccelGroup*");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 2, "gtk_accel_group_disconnect", "GClosure*");
  return(C_to_Xen_gboolean(gtk_accel_group_disconnect(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_GClosure_(closure))));
}

static Xen gxg_gtk_accel_group_disconnect_key(Xen accel_group, Xen accel_key, Xen accel_mods)
{
  #define H_gtk_accel_group_disconnect_key "gboolean gtk_accel_group_disconnect_key(GtkAccelGroup* accel_group, \
guint accel_key, GdkModifierType accel_mods)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_disconnect_key", "GtkAccelGroup*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 2, "gtk_accel_group_disconnect_key", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 3, "gtk_accel_group_disconnect_key", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_accel_group_disconnect_key(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_guint(accel_key), 
                                                          Xen_to_C_GdkModifierType(accel_mods))));
}

static Xen gxg_gtk_accel_groups_activate(Xen object, Xen accel_key, Xen accel_mods)
{
  #define H_gtk_accel_groups_activate "gboolean gtk_accel_groups_activate(GObject* object, guint accel_key, \
GdkModifierType accel_mods)"
  Xen_check_type(Xen_is_GObject_(object), object, 1, "gtk_accel_groups_activate", "GObject*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 2, "gtk_accel_groups_activate", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 3, "gtk_accel_groups_activate", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_accel_groups_activate(Xen_to_C_GObject_(object), Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods))));
}

static Xen gxg_gtk_accel_groups_from_object(Xen object)
{
  #define H_gtk_accel_groups_from_object "GSList* gtk_accel_groups_from_object(GObject* object)"
  Xen_check_type(Xen_is_GObject_(object), object, 1, "gtk_accel_groups_from_object", "GObject*");
  return(C_to_Xen_GSList_(gtk_accel_groups_from_object(Xen_to_C_GObject_(object))));
}

static Xen gxg_gtk_accel_group_find(Xen accel_group, Xen func, Xen func_info)
{
  #define H_gtk_accel_group_find "GtkAccelKey* gtk_accel_group_find(GtkAccelGroup* accel_group, lambda3 func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_find", "GtkAccelGroup*");
  Xen_check_type(Xen_is_lambda3(func), func, 2, "gtk_accel_group_find", "lambda3");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_accel_group_find", "lambda_data");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_GtkAccelKey_(gtk_accel_group_find(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_lambda3(func), Xen_to_C_lambda_data(func_info)));
    xm_unprotect_at(loc);
    return(result);
   }
}

static Xen gxg_gtk_accel_group_from_accel_closure(Xen closure)
{
  #define H_gtk_accel_group_from_accel_closure "GtkAccelGroup* gtk_accel_group_from_accel_closure(GClosure* closure)"
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 1, "gtk_accel_group_from_accel_closure", "GClosure*");
  return(C_to_Xen_GtkAccelGroup_(gtk_accel_group_from_accel_closure(Xen_to_C_GClosure_(closure))));
}

static Xen gxg_gtk_accelerator_valid(Xen keyval, Xen modifiers)
{
  #define H_gtk_accelerator_valid "gboolean gtk_accelerator_valid(guint keyval, GdkModifierType modifiers)"
  Xen_check_type(Xen_is_guint(keyval), keyval, 1, "gtk_accelerator_valid", "guint");
  Xen_check_type(Xen_is_GdkModifierType(modifiers), modifiers, 2, "gtk_accelerator_valid", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_accelerator_valid(Xen_to_C_guint(keyval), Xen_to_C_GdkModifierType(modifiers))));
}

static Xen gxg_gtk_accelerator_parse(Xen accelerator, Xen ignore_accelerator_key, Xen ignore_accelerator_mods)
{
  #define H_gtk_accelerator_parse "void gtk_accelerator_parse(gchar* accelerator, guint* [accelerator_key], \
GdkModifierType* [accelerator_mods])"
  guint ref_accelerator_key;
  GdkModifierType ref_accelerator_mods;
  Xen_check_type(Xen_is_gchar_(accelerator), accelerator, 1, "gtk_accelerator_parse", "gchar*");
  gtk_accelerator_parse(Xen_to_C_gchar_(accelerator), &ref_accelerator_key, &ref_accelerator_mods);
  return(Xen_list_2(C_to_Xen_guint(ref_accelerator_key), C_to_Xen_GdkModifierType(ref_accelerator_mods)));
}

static Xen gxg_gtk_accelerator_name(Xen accelerator_key, Xen accelerator_mods)
{
  #define H_gtk_accelerator_name "gchar* gtk_accelerator_name(guint accelerator_key, GdkModifierType accelerator_mods)"
  Xen_check_type(Xen_is_guint(accelerator_key), accelerator_key, 1, "gtk_accelerator_name", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accelerator_mods), accelerator_mods, 2, "gtk_accelerator_name", "GdkModifierType");
  {
   gchar* result;
   Xen rtn;
   result = gtk_accelerator_name(Xen_to_C_guint(accelerator_key), Xen_to_C_GdkModifierType(accelerator_mods));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_accelerator_set_default_mod_mask(Xen default_mod_mask)
{
  #define H_gtk_accelerator_set_default_mod_mask "void gtk_accelerator_set_default_mod_mask(GdkModifierType default_mod_mask)"
  Xen_check_type(Xen_is_GdkModifierType(default_mod_mask), default_mod_mask, 1, "gtk_accelerator_set_default_mod_mask", "GdkModifierType");
  gtk_accelerator_set_default_mod_mask(Xen_to_C_GdkModifierType(default_mod_mask));
  return(Xen_false);
}

static Xen gxg_gtk_accel_group_query(Xen accel_group, Xen accel_key, Xen accel_mods, Xen ignore_n_entries)
{
  #define H_gtk_accel_group_query "GtkAccelGroupEntry* gtk_accel_group_query(GtkAccelGroup* accel_group, \
guint accel_key, GdkModifierType accel_mods, guint* [n_entries])"
  guint ref_n_entries;
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_query", "GtkAccelGroup*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 2, "gtk_accel_group_query", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 3, "gtk_accel_group_query", "GdkModifierType");
  {
    Xen result;
    result = C_to_Xen_GtkAccelGroupEntry_(gtk_accel_group_query(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_guint(accel_key), 
                                                                Xen_to_C_GdkModifierType(accel_mods), &ref_n_entries));
    return(Xen_list_2(result, C_to_Xen_guint(ref_n_entries)));
   }
}

static Xen gxg_gtk_accel_group_activate(Xen accel_group, Xen accel_quark, Xen acceleratable, Xen accel_key, Xen accel_mods)
{
  #define H_gtk_accel_group_activate "gboolean gtk_accel_group_activate(GtkAccelGroup* accel_group, GQuark accel_quark, \
GObject* acceleratable, guint accel_key, GdkModifierType accel_mods)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_activate", "GtkAccelGroup*");
  Xen_check_type(Xen_is_GQuark(accel_quark), accel_quark, 2, "gtk_accel_group_activate", "GQuark");
  Xen_check_type(Xen_is_GObject_(acceleratable), acceleratable, 3, "gtk_accel_group_activate", "GObject*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 4, "gtk_accel_group_activate", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 5, "gtk_accel_group_activate", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_accel_group_activate(Xen_to_C_GtkAccelGroup_(accel_group), Xen_to_C_GQuark(accel_quark), Xen_to_C_GObject_(acceleratable), 
                                                    Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods))));
}

static Xen gxg_gtk_accel_label_new(Xen string)
{
  #define H_gtk_accel_label_new "GtkWidget* gtk_accel_label_new(gchar* string)"
  Xen_check_type(Xen_is_gchar_(string), string, 1, "gtk_accel_label_new", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_accel_label_new(Xen_to_C_gchar_(string))));
}

static Xen gxg_gtk_accel_label_get_accel_widget(Xen accel_label)
{
  #define H_gtk_accel_label_get_accel_widget "GtkWidget* gtk_accel_label_get_accel_widget(GtkAccelLabel* accel_label)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_get_accel_widget", "GtkAccelLabel*");
  return(C_to_Xen_GtkWidget_(gtk_accel_label_get_accel_widget(Xen_to_C_GtkAccelLabel_(accel_label))));
}

static Xen gxg_gtk_accel_label_get_accel_width(Xen accel_label)
{
  #define H_gtk_accel_label_get_accel_width "guint gtk_accel_label_get_accel_width(GtkAccelLabel* accel_label)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_get_accel_width", "GtkAccelLabel*");
  return(C_to_Xen_guint(gtk_accel_label_get_accel_width(Xen_to_C_GtkAccelLabel_(accel_label))));
}

static Xen gxg_gtk_accel_label_set_accel_widget(Xen accel_label, Xen accel_widget)
{
  #define H_gtk_accel_label_set_accel_widget "void gtk_accel_label_set_accel_widget(GtkAccelLabel* accel_label, \
GtkWidget* accel_widget)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_set_accel_widget", "GtkAccelLabel*");
  Xen_check_type(Xen_is_GtkWidget_(accel_widget), accel_widget, 2, "gtk_accel_label_set_accel_widget", "GtkWidget*");
  gtk_accel_label_set_accel_widget(Xen_to_C_GtkAccelLabel_(accel_label), Xen_to_C_GtkWidget_(accel_widget));
  return(Xen_false);
}

static Xen gxg_gtk_accel_label_set_accel_closure(Xen accel_label, Xen closure)
{
  #define H_gtk_accel_label_set_accel_closure "void gtk_accel_label_set_accel_closure(GtkAccelLabel* accel_label, \
GClosure* closure)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_set_accel_closure", "GtkAccelLabel*");
  Xen_check_type(Xen_is_GClosure_(closure) || Xen_is_false(closure), closure, 2, "gtk_accel_label_set_accel_closure", "GClosure*");
  gtk_accel_label_set_accel_closure(Xen_to_C_GtkAccelLabel_(accel_label), Xen_to_C_GClosure_(closure));
  return(Xen_false);
}

static Xen gxg_gtk_accel_label_refetch(Xen accel_label)
{
  #define H_gtk_accel_label_refetch "gboolean gtk_accel_label_refetch(GtkAccelLabel* accel_label)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_refetch", "GtkAccelLabel*");
  return(C_to_Xen_gboolean(gtk_accel_label_refetch(Xen_to_C_GtkAccelLabel_(accel_label))));
}

static Xen gxg_gtk_accel_map_add_entry(Xen accel_path, Xen accel_key, Xen accel_mods)
{
  #define H_gtk_accel_map_add_entry "void gtk_accel_map_add_entry(gchar* accel_path, guint accel_key, \
GdkModifierType accel_mods)"
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 1, "gtk_accel_map_add_entry", "gchar*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 2, "gtk_accel_map_add_entry", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 3, "gtk_accel_map_add_entry", "GdkModifierType");
  gtk_accel_map_add_entry(Xen_to_C_gchar_(accel_path), Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_lookup_entry(Xen accel_path, Xen key)
{
  #define H_gtk_accel_map_lookup_entry "gboolean gtk_accel_map_lookup_entry(gchar* accel_path, GtkAccelKey* key)"
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 1, "gtk_accel_map_lookup_entry", "gchar*");
  Xen_check_type(Xen_is_GtkAccelKey_(key), key, 2, "gtk_accel_map_lookup_entry", "GtkAccelKey*");
  return(C_to_Xen_gboolean(gtk_accel_map_lookup_entry(Xen_to_C_gchar_(accel_path), Xen_to_C_GtkAccelKey_(key))));
}

static Xen gxg_gtk_accel_map_change_entry(Xen accel_path, Xen accel_key, Xen accel_mods, Xen replace)
{
  #define H_gtk_accel_map_change_entry "gboolean gtk_accel_map_change_entry(gchar* accel_path, guint accel_key, \
GdkModifierType accel_mods, gboolean replace)"
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 1, "gtk_accel_map_change_entry", "gchar*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 2, "gtk_accel_map_change_entry", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 3, "gtk_accel_map_change_entry", "GdkModifierType");
  Xen_check_type(Xen_is_gboolean(replace), replace, 4, "gtk_accel_map_change_entry", "gboolean");
  return(C_to_Xen_gboolean(gtk_accel_map_change_entry(Xen_to_C_gchar_(accel_path), Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods), 
                                                      Xen_to_C_gboolean(replace))));
}

static Xen gxg_gtk_accel_map_load(Xen file_name)
{
  #define H_gtk_accel_map_load "void gtk_accel_map_load(gchar* file_name)"
  Xen_check_type(Xen_is_gchar_(file_name), file_name, 1, "gtk_accel_map_load", "gchar*");
  gtk_accel_map_load(Xen_to_C_gchar_(file_name));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_save(Xen file_name)
{
  #define H_gtk_accel_map_save "void gtk_accel_map_save(gchar* file_name)"
  Xen_check_type(Xen_is_gchar_(file_name), file_name, 1, "gtk_accel_map_save", "gchar*");
  gtk_accel_map_save(Xen_to_C_gchar_(file_name));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_foreach(Xen func_info, Xen func)
{
  #define H_gtk_accel_map_foreach "void gtk_accel_map_foreach(lambda_data func_info, GtkAccelMapForeach func)"
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 1, "gtk_accel_map_foreach", "lambda_data");
  Xen_check_type(Xen_is_GtkAccelMapForeach(func), func, 2, "gtk_accel_map_foreach", "GtkAccelMapForeach");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_accel_map_foreach(Xen_to_C_lambda_data(func_info), Xen_to_C_GtkAccelMapForeach(func));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_accel_map_load_fd(Xen fd)
{
  #define H_gtk_accel_map_load_fd "void gtk_accel_map_load_fd(gint fd)"
  Xen_check_type(Xen_is_gint(fd), fd, 1, "gtk_accel_map_load_fd", "gint");
  gtk_accel_map_load_fd(Xen_to_C_gint(fd));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_save_fd(Xen fd)
{
  #define H_gtk_accel_map_save_fd "void gtk_accel_map_save_fd(gint fd)"
  Xen_check_type(Xen_is_gint(fd), fd, 1, "gtk_accel_map_save_fd", "gint");
  gtk_accel_map_save_fd(Xen_to_C_gint(fd));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_add_filter(Xen filter_pattern)
{
  #define H_gtk_accel_map_add_filter "void gtk_accel_map_add_filter(gchar* filter_pattern)"
  Xen_check_type(Xen_is_gchar_(filter_pattern), filter_pattern, 1, "gtk_accel_map_add_filter", "gchar*");
  gtk_accel_map_add_filter(Xen_to_C_gchar_(filter_pattern));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_foreach_unfiltered(Xen func_info, Xen func)
{
  #define H_gtk_accel_map_foreach_unfiltered "void gtk_accel_map_foreach_unfiltered(lambda_data func_info, \
GtkAccelMapForeach func)"
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 1, "gtk_accel_map_foreach_unfiltered", "lambda_data");
  Xen_check_type(Xen_is_GtkAccelMapForeach(func), func, 2, "gtk_accel_map_foreach_unfiltered", "GtkAccelMapForeach");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_accel_map_foreach_unfiltered(Xen_to_C_lambda_data(func_info), Xen_to_C_GtkAccelMapForeach(func));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_adjustment_clamp_page(Xen adjustment, Xen lower, Xen upper)
{
  #define H_gtk_adjustment_clamp_page "void gtk_adjustment_clamp_page(GtkAdjustment* adjustment, gdouble lower, \
gdouble upper)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_clamp_page", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(lower), lower, 2, "gtk_adjustment_clamp_page", "gdouble");
  Xen_check_type(Xen_is_gdouble(upper), upper, 3, "gtk_adjustment_clamp_page", "gdouble");
  gtk_adjustment_clamp_page(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(lower), Xen_to_C_gdouble(upper));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_get_value(Xen adjustment)
{
  #define H_gtk_adjustment_get_value "gdouble gtk_adjustment_get_value(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_value", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_value(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_adjustment_set_value(Xen adjustment, Xen value)
{
  #define H_gtk_adjustment_set_value "void gtk_adjustment_set_value(GtkAdjustment* adjustment, gdouble value)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_set_value", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_adjustment_set_value", "gdouble");
  gtk_adjustment_set_value(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_aspect_frame_new(Xen label, Xen xalign, Xen yalign, Xen ratio, Xen obey_child)
{
  #define H_gtk_aspect_frame_new "GtkWidget* gtk_aspect_frame_new(gchar* label, gfloat xalign, gfloat yalign, \
gfloat ratio, gboolean obey_child)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_aspect_frame_new", "gchar*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_aspect_frame_new", "gfloat");
  Xen_check_type(Xen_is_gfloat(yalign), yalign, 3, "gtk_aspect_frame_new", "gfloat");
  Xen_check_type(Xen_is_gfloat(ratio), ratio, 4, "gtk_aspect_frame_new", "gfloat");
  Xen_check_type(Xen_is_gboolean(obey_child), obey_child, 5, "gtk_aspect_frame_new", "gboolean");
  return(C_to_Xen_GtkWidget_(gtk_aspect_frame_new(Xen_to_C_gchar_(label), Xen_to_C_gfloat(xalign), Xen_to_C_gfloat(yalign), 
                                                  Xen_to_C_gfloat(ratio), Xen_to_C_gboolean(obey_child))));
}

static Xen gxg_gtk_aspect_frame_set(Xen aspect_frame, Xen xalign, Xen yalign, Xen ratio, Xen obey_child)
{
  #define H_gtk_aspect_frame_set "void gtk_aspect_frame_set(GtkAspectFrame* aspect_frame, gfloat xalign, \
gfloat yalign, gfloat ratio, gboolean obey_child)"
  Xen_check_type(Xen_is_GtkAspectFrame_(aspect_frame), aspect_frame, 1, "gtk_aspect_frame_set", "GtkAspectFrame*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_aspect_frame_set", "gfloat");
  Xen_check_type(Xen_is_gfloat(yalign), yalign, 3, "gtk_aspect_frame_set", "gfloat");
  Xen_check_type(Xen_is_gfloat(ratio), ratio, 4, "gtk_aspect_frame_set", "gfloat");
  Xen_check_type(Xen_is_gboolean(obey_child), obey_child, 5, "gtk_aspect_frame_set", "gboolean");
  gtk_aspect_frame_set(Xen_to_C_GtkAspectFrame_(aspect_frame), Xen_to_C_gfloat(xalign), Xen_to_C_gfloat(yalign), Xen_to_C_gfloat(ratio), 
                       Xen_to_C_gboolean(obey_child));
  return(Xen_false);
}

static Xen gxg_gtk_button_box_get_layout(Xen widget)
{
  #define H_gtk_button_box_get_layout "GtkButtonBoxStyle gtk_button_box_get_layout(GtkButtonBox* widget)"
  Xen_check_type(Xen_is_GtkButtonBox_(widget), widget, 1, "gtk_button_box_get_layout", "GtkButtonBox*");
  return(C_to_Xen_GtkButtonBoxStyle(gtk_button_box_get_layout(Xen_to_C_GtkButtonBox_(widget))));
}

static Xen gxg_gtk_button_box_set_layout(Xen widget, Xen layout_style)
{
  #define H_gtk_button_box_set_layout "void gtk_button_box_set_layout(GtkButtonBox* widget, GtkButtonBoxStyle layout_style)"
  Xen_check_type(Xen_is_GtkButtonBox_(widget), widget, 1, "gtk_button_box_set_layout", "GtkButtonBox*");
  Xen_check_type(Xen_is_GtkButtonBoxStyle(layout_style), layout_style, 2, "gtk_button_box_set_layout", "GtkButtonBoxStyle");
  gtk_button_box_set_layout(Xen_to_C_GtkButtonBox_(widget), Xen_to_C_GtkButtonBoxStyle(layout_style));
  return(Xen_false);
}

static Xen gxg_gtk_button_box_set_child_secondary(Xen widget, Xen child, Xen is_secondary)
{
  #define H_gtk_button_box_set_child_secondary "void gtk_button_box_set_child_secondary(GtkButtonBox* widget, \
GtkWidget* child, gboolean is_secondary)"
  Xen_check_type(Xen_is_GtkButtonBox_(widget), widget, 1, "gtk_button_box_set_child_secondary", "GtkButtonBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_button_box_set_child_secondary", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(is_secondary), is_secondary, 3, "gtk_button_box_set_child_secondary", "gboolean");
  gtk_button_box_set_child_secondary(Xen_to_C_GtkButtonBox_(widget), Xen_to_C_GtkWidget_(child), Xen_to_C_gboolean(is_secondary));
  return(Xen_false);
}

static Xen gxg_gtk_binding_set_new(Xen set_name)
{
  #define H_gtk_binding_set_new "GtkBindingSet* gtk_binding_set_new(gchar* set_name)"
  Xen_check_type(Xen_is_gchar_(set_name), set_name, 1, "gtk_binding_set_new", "gchar*");
  return(C_to_Xen_GtkBindingSet_(gtk_binding_set_new(Xen_to_C_gchar_(set_name))));
}

static Xen gxg_gtk_binding_set_by_class(Xen object_class)
{
  #define H_gtk_binding_set_by_class "GtkBindingSet* gtk_binding_set_by_class(gpointer object_class)"
  Xen_check_type(Xen_is_gpointer(object_class), object_class, 1, "gtk_binding_set_by_class", "gpointer");
  return(C_to_Xen_GtkBindingSet_(gtk_binding_set_by_class(Xen_to_C_gpointer(object_class))));
}

static Xen gxg_gtk_binding_set_find(Xen set_name)
{
  #define H_gtk_binding_set_find "GtkBindingSet* gtk_binding_set_find(gchar* set_name)"
  Xen_check_type(Xen_is_gchar_(set_name), set_name, 1, "gtk_binding_set_find", "gchar*");
  return(C_to_Xen_GtkBindingSet_(gtk_binding_set_find(Xen_to_C_gchar_(set_name))));
}

static Xen gxg_gtk_binding_entry_remove(Xen binding_set, Xen keyval, Xen modifiers)
{
  #define H_gtk_binding_entry_remove "void gtk_binding_entry_remove(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers)"
  Xen_check_type(Xen_is_GtkBindingSet_(binding_set), binding_set, 1, "gtk_binding_entry_remove", "GtkBindingSet*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_binding_entry_remove", "guint");
  Xen_check_type(Xen_is_GdkModifierType(modifiers), modifiers, 3, "gtk_binding_entry_remove", "GdkModifierType");
  gtk_binding_entry_remove(Xen_to_C_GtkBindingSet_(binding_set), Xen_to_C_guint(keyval), Xen_to_C_GdkModifierType(modifiers));
  return(Xen_false);
}

static Xen gxg_gtk_bin_get_child(Xen bin)
{
  #define H_gtk_bin_get_child "GtkWidget* gtk_bin_get_child(GtkBin* bin)"
  Xen_check_type(Xen_is_GtkBin_(bin), bin, 1, "gtk_bin_get_child", "GtkBin*");
  return(C_to_Xen_GtkWidget_(gtk_bin_get_child(Xen_to_C_GtkBin_(bin))));
}

static Xen gxg_gtk_box_set_homogeneous(Xen box, Xen homogeneous)
{
  #define H_gtk_box_set_homogeneous "void gtk_box_set_homogeneous(GtkBox* box, gboolean homogeneous)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_set_homogeneous", "GtkBox*");
  Xen_check_type(Xen_is_gboolean(homogeneous), homogeneous, 2, "gtk_box_set_homogeneous", "gboolean");
  gtk_box_set_homogeneous(Xen_to_C_GtkBox_(box), Xen_to_C_gboolean(homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_box_get_homogeneous(Xen box)
{
  #define H_gtk_box_get_homogeneous "gboolean gtk_box_get_homogeneous(GtkBox* box)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_get_homogeneous", "GtkBox*");
  return(C_to_Xen_gboolean(gtk_box_get_homogeneous(Xen_to_C_GtkBox_(box))));
}

static Xen gxg_gtk_box_set_spacing(Xen box, Xen spacing)
{
  #define H_gtk_box_set_spacing "void gtk_box_set_spacing(GtkBox* box, gint spacing)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_set_spacing", "GtkBox*");
  Xen_check_type(Xen_is_gint(spacing), spacing, 2, "gtk_box_set_spacing", "gint");
  gtk_box_set_spacing(Xen_to_C_GtkBox_(box), Xen_to_C_gint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_box_get_spacing(Xen box)
{
  #define H_gtk_box_get_spacing "gint gtk_box_get_spacing(GtkBox* box)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_get_spacing", "GtkBox*");
  return(C_to_Xen_gint(gtk_box_get_spacing(Xen_to_C_GtkBox_(box))));
}

static Xen gxg_gtk_box_reorder_child(Xen box, Xen child, Xen position)
{
  #define H_gtk_box_reorder_child "void gtk_box_reorder_child(GtkBox* box, GtkWidget* child, gint position)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_reorder_child", "GtkBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_box_reorder_child", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_box_reorder_child", "gint");
  gtk_box_reorder_child(Xen_to_C_GtkBox_(box), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_button_new(void)
{
  #define H_gtk_button_new "GtkWidget* gtk_button_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_button_new()));
}

static Xen gxg_gtk_button_new_with_label(Xen label)
{
  #define H_gtk_button_new_with_label "GtkWidget* gtk_button_new_with_label(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_button_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_button_new_with_label(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_button_new_with_mnemonic(Xen label)
{
  #define H_gtk_button_new_with_mnemonic "GtkWidget* gtk_button_new_with_mnemonic(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_button_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_button_new_with_mnemonic(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_button_clicked(Xen button)
{
  #define H_gtk_button_clicked "void gtk_button_clicked(GtkButton* button)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_clicked", "GtkButton*");
  gtk_button_clicked(Xen_to_C_GtkButton_(button));
  return(Xen_false);
}

static Xen gxg_gtk_button_set_relief(Xen button, Xen newstyle)
{
  #define H_gtk_button_set_relief "void gtk_button_set_relief(GtkButton* button, GtkReliefStyle newstyle)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_set_relief", "GtkButton*");
  Xen_check_type(Xen_is_GtkReliefStyle(newstyle), newstyle, 2, "gtk_button_set_relief", "GtkReliefStyle");
  gtk_button_set_relief(Xen_to_C_GtkButton_(button), Xen_to_C_GtkReliefStyle(newstyle));
  return(Xen_false);
}

static Xen gxg_gtk_button_get_relief(Xen button)
{
  #define H_gtk_button_get_relief "GtkReliefStyle gtk_button_get_relief(GtkButton* button)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_get_relief", "GtkButton*");
  return(C_to_Xen_GtkReliefStyle(gtk_button_get_relief(Xen_to_C_GtkButton_(button))));
}

static Xen gxg_gtk_button_set_label(Xen button, Xen label)
{
  #define H_gtk_button_set_label "void gtk_button_set_label(GtkButton* button, gchar* label)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_set_label", "GtkButton*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_button_set_label", "gchar*");
  gtk_button_set_label(Xen_to_C_GtkButton_(button), Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_button_get_label(Xen button)
{
  #define H_gtk_button_get_label "gchar* gtk_button_get_label(GtkButton* button)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_get_label", "GtkButton*");
  return(C_to_Xen_gchar_(gtk_button_get_label(Xen_to_C_GtkButton_(button))));
}

static Xen gxg_gtk_button_set_use_underline(Xen button, Xen use_underline)
{
  #define H_gtk_button_set_use_underline "void gtk_button_set_use_underline(GtkButton* button, gboolean use_underline)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_set_use_underline", "GtkButton*");
  Xen_check_type(Xen_is_gboolean(use_underline), use_underline, 2, "gtk_button_set_use_underline", "gboolean");
  gtk_button_set_use_underline(Xen_to_C_GtkButton_(button), Xen_to_C_gboolean(use_underline));
  return(Xen_false);
}

static Xen gxg_gtk_button_get_use_underline(Xen button)
{
  #define H_gtk_button_get_use_underline "gboolean gtk_button_get_use_underline(GtkButton* button)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_get_use_underline", "GtkButton*");
  return(C_to_Xen_gboolean(gtk_button_get_use_underline(Xen_to_C_GtkButton_(button))));
}

static Xen gxg_gtk_calendar_new(void)
{
  #define H_gtk_calendar_new "GtkWidget* gtk_calendar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_calendar_new()));
}

static Xen gxg_gtk_calendar_select_day(Xen calendar, Xen day)
{
  #define H_gtk_calendar_select_day "void gtk_calendar_select_day(GtkCalendar* calendar, guint day)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_select_day", "GtkCalendar*");
  Xen_check_type(Xen_is_guint(day), day, 2, "gtk_calendar_select_day", "guint");
  gtk_calendar_select_day(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_guint(day));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_clear_marks(Xen calendar)
{
  #define H_gtk_calendar_clear_marks "void gtk_calendar_clear_marks(GtkCalendar* calendar)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_clear_marks", "GtkCalendar*");
  gtk_calendar_clear_marks(Xen_to_C_GtkCalendar_(calendar));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_get_date(Xen calendar, Xen ignore_year, Xen ignore_month, Xen ignore_day)
{
  #define H_gtk_calendar_get_date "void gtk_calendar_get_date(GtkCalendar* calendar, guint* [year], guint* [month], \
guint* [day])"
  guint ref_year;
  guint ref_month;
  guint ref_day;
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_get_date", "GtkCalendar*");
  gtk_calendar_get_date(Xen_to_C_GtkCalendar_(calendar), &ref_year, &ref_month, &ref_day);
  return(Xen_list_3(C_to_Xen_guint(ref_year), C_to_Xen_guint(ref_month), C_to_Xen_guint(ref_day)));
}

static Xen gxg_gtk_cell_editable_start_editing(Xen cell_editable, Xen event)
{
  #define H_gtk_cell_editable_start_editing "void gtk_cell_editable_start_editing(GtkCellEditable* cell_editable, \
GdkEvent* event)"
  Xen_check_type(Xen_is_GtkCellEditable_(cell_editable), cell_editable, 1, "gtk_cell_editable_start_editing", "GtkCellEditable*");
  Xen_check_type(Xen_is_GdkEvent_(event) || Xen_is_false(event), event, 2, "gtk_cell_editable_start_editing", "GdkEvent*");
  gtk_cell_editable_start_editing(Xen_to_C_GtkCellEditable_(cell_editable), Xen_to_C_GdkEvent_(event));
  return(Xen_false);
}

static Xen gxg_gtk_cell_editable_editing_done(Xen cell_editable)
{
  #define H_gtk_cell_editable_editing_done "void gtk_cell_editable_editing_done(GtkCellEditable* cell_editable)"
  Xen_check_type(Xen_is_GtkCellEditable_(cell_editable), cell_editable, 1, "gtk_cell_editable_editing_done", "GtkCellEditable*");
  gtk_cell_editable_editing_done(Xen_to_C_GtkCellEditable_(cell_editable));
  return(Xen_false);
}

static Xen gxg_gtk_cell_editable_remove_widget(Xen cell_editable)
{
  #define H_gtk_cell_editable_remove_widget "void gtk_cell_editable_remove_widget(GtkCellEditable* cell_editable)"
  Xen_check_type(Xen_is_GtkCellEditable_(cell_editable), cell_editable, 1, "gtk_cell_editable_remove_widget", "GtkCellEditable*");
  gtk_cell_editable_remove_widget(Xen_to_C_GtkCellEditable_(cell_editable));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_activate(Xen cell, Xen event, Xen widget, Xen path, Xen background_area, Xen cell_area, Xen flags)
{
  #define H_gtk_cell_renderer_activate "gboolean gtk_cell_renderer_activate(GtkCellRenderer* cell, GdkEvent* event, \
GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_activate", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_cell_renderer_activate", "GdkEvent*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 3, "gtk_cell_renderer_activate", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(path), path, 4, "gtk_cell_renderer_activate", "gchar*");
  Xen_check_type(Xen_is_GdkRectangle_(background_area), background_area, 5, "gtk_cell_renderer_activate", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(cell_area), cell_area, 6, "gtk_cell_renderer_activate", "GdkRectangle*");
  Xen_check_type(Xen_is_GtkCellRendererState(flags), flags, 7, "gtk_cell_renderer_activate", "GtkCellRendererState");
  return(C_to_Xen_gboolean(gtk_cell_renderer_activate(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GdkEvent_(event), Xen_to_C_GtkWidget_(widget), 
                                                      Xen_to_C_gchar_(path), Xen_to_C_GdkRectangle_(background_area), Xen_to_C_GdkRectangle_(cell_area), 
                                                      Xen_to_C_GtkCellRendererState(flags))));
}

static Xen gxg_gtk_cell_renderer_start_editing(Xen cell, Xen event, Xen widget, Xen path, Xen background_area, Xen cell_area, Xen flags)
{
  #define H_gtk_cell_renderer_start_editing "GtkCellEditable* gtk_cell_renderer_start_editing(GtkCellRenderer* cell, \
GdkEvent* event, GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, \
GtkCellRendererState flags)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_start_editing", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GdkEvent_(event) || Xen_is_false(event), event, 2, "gtk_cell_renderer_start_editing", "GdkEvent*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 3, "gtk_cell_renderer_start_editing", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(path), path, 4, "gtk_cell_renderer_start_editing", "gchar*");
  Xen_check_type(Xen_is_GdkRectangle_(background_area), background_area, 5, "gtk_cell_renderer_start_editing", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(cell_area), cell_area, 6, "gtk_cell_renderer_start_editing", "GdkRectangle*");
  Xen_check_type(Xen_is_GtkCellRendererState(flags), flags, 7, "gtk_cell_renderer_start_editing", "GtkCellRendererState");
  return(C_to_Xen_GtkCellEditable_(gtk_cell_renderer_start_editing(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GdkEvent_(event), 
                                                                   Xen_to_C_GtkWidget_(widget), Xen_to_C_gchar_(path), Xen_to_C_GdkRectangle_(background_area), 
                                                                   Xen_to_C_GdkRectangle_(cell_area), Xen_to_C_GtkCellRendererState(flags))));
}

static Xen gxg_gtk_cell_renderer_set_fixed_size(Xen cell, Xen width, Xen height)
{
  #define H_gtk_cell_renderer_set_fixed_size "void gtk_cell_renderer_set_fixed_size(GtkCellRenderer* cell, \
gint width, gint height)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_set_fixed_size", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_cell_renderer_set_fixed_size", "gint");
  Xen_check_type(Xen_is_gint(height), height, 3, "gtk_cell_renderer_set_fixed_size", "gint");
  gtk_cell_renderer_set_fixed_size(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_get_fixed_size(Xen cell, Xen ignore_width, Xen ignore_height)
{
  #define H_gtk_cell_renderer_get_fixed_size "void gtk_cell_renderer_get_fixed_size(GtkCellRenderer* cell, \
gint* [width], gint* [height])"
  gint ref_width;
  gint ref_height;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_fixed_size", "GtkCellRenderer*");
  gtk_cell_renderer_get_fixed_size(Xen_to_C_GtkCellRenderer_(cell), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_gint(ref_width), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gtk_cell_renderer_pixbuf_new(void)
{
  #define H_gtk_cell_renderer_pixbuf_new "GtkCellRenderer* gtk_cell_renderer_pixbuf_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_pixbuf_new()));
}

static Xen gxg_gtk_cell_renderer_text_new(void)
{
  #define H_gtk_cell_renderer_text_new "GtkCellRenderer* gtk_cell_renderer_text_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_text_new()));
}

static Xen gxg_gtk_cell_renderer_text_set_fixed_height_from_font(Xen renderer, Xen number_of_rows)
{
  #define H_gtk_cell_renderer_text_set_fixed_height_from_font "void gtk_cell_renderer_text_set_fixed_height_from_font(GtkCellRendererText* renderer, \
gint number_of_rows)"
  Xen_check_type(Xen_is_GtkCellRendererText_(renderer), renderer, 1, "gtk_cell_renderer_text_set_fixed_height_from_font", "GtkCellRendererText*");
  Xen_check_type(Xen_is_gint(number_of_rows), number_of_rows, 2, "gtk_cell_renderer_text_set_fixed_height_from_font", "gint");
  gtk_cell_renderer_text_set_fixed_height_from_font(Xen_to_C_GtkCellRendererText_(renderer), Xen_to_C_gint(number_of_rows));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_toggle_new(void)
{
  #define H_gtk_cell_renderer_toggle_new "GtkCellRenderer* gtk_cell_renderer_toggle_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_toggle_new()));
}

static Xen gxg_gtk_cell_renderer_toggle_get_radio(Xen toggle)
{
  #define H_gtk_cell_renderer_toggle_get_radio "gboolean gtk_cell_renderer_toggle_get_radio(GtkCellRendererToggle* toggle)"
  Xen_check_type(Xen_is_GtkCellRendererToggle_(toggle), toggle, 1, "gtk_cell_renderer_toggle_get_radio", "GtkCellRendererToggle*");
  return(C_to_Xen_gboolean(gtk_cell_renderer_toggle_get_radio(Xen_to_C_GtkCellRendererToggle_(toggle))));
}

static Xen gxg_gtk_cell_renderer_toggle_set_radio(Xen toggle, Xen radio)
{
  #define H_gtk_cell_renderer_toggle_set_radio "void gtk_cell_renderer_toggle_set_radio(GtkCellRendererToggle* toggle, \
gboolean radio)"
  Xen_check_type(Xen_is_GtkCellRendererToggle_(toggle), toggle, 1, "gtk_cell_renderer_toggle_set_radio", "GtkCellRendererToggle*");
  Xen_check_type(Xen_is_gboolean(radio), radio, 2, "gtk_cell_renderer_toggle_set_radio", "gboolean");
  gtk_cell_renderer_toggle_set_radio(Xen_to_C_GtkCellRendererToggle_(toggle), Xen_to_C_gboolean(radio));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_toggle_get_active(Xen toggle)
{
  #define H_gtk_cell_renderer_toggle_get_active "gboolean gtk_cell_renderer_toggle_get_active(GtkCellRendererToggle* toggle)"
  Xen_check_type(Xen_is_GtkCellRendererToggle_(toggle), toggle, 1, "gtk_cell_renderer_toggle_get_active", "GtkCellRendererToggle*");
  return(C_to_Xen_gboolean(gtk_cell_renderer_toggle_get_active(Xen_to_C_GtkCellRendererToggle_(toggle))));
}

static Xen gxg_gtk_cell_renderer_toggle_set_active(Xen toggle, Xen setting)
{
  #define H_gtk_cell_renderer_toggle_set_active "void gtk_cell_renderer_toggle_set_active(GtkCellRendererToggle* toggle, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkCellRendererToggle_(toggle), toggle, 1, "gtk_cell_renderer_toggle_set_active", "GtkCellRendererToggle*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_cell_renderer_toggle_set_active", "gboolean");
  gtk_cell_renderer_toggle_set_active(Xen_to_C_GtkCellRendererToggle_(toggle), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_check_button_new(void)
{
  #define H_gtk_check_button_new "GtkWidget* gtk_check_button_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_check_button_new()));
}

static Xen gxg_gtk_check_button_new_with_label(Xen label)
{
  #define H_gtk_check_button_new_with_label "GtkWidget* gtk_check_button_new_with_label(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_check_button_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_check_button_new_with_label(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_check_button_new_with_mnemonic(Xen label)
{
  #define H_gtk_check_button_new_with_mnemonic "GtkWidget* gtk_check_button_new_with_mnemonic(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_check_button_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_check_button_new_with_mnemonic(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_check_menu_item_new(void)
{
  #define H_gtk_check_menu_item_new "GtkWidget* gtk_check_menu_item_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_check_menu_item_new()));
}

static Xen gxg_gtk_check_menu_item_new_with_label(Xen label)
{
  #define H_gtk_check_menu_item_new_with_label "GtkWidget* gtk_check_menu_item_new_with_label(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_check_menu_item_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_check_menu_item_new_with_label(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_check_menu_item_new_with_mnemonic(Xen label)
{
  #define H_gtk_check_menu_item_new_with_mnemonic "GtkWidget* gtk_check_menu_item_new_with_mnemonic(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_check_menu_item_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_check_menu_item_new_with_mnemonic(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_check_menu_item_set_active(Xen check_menu_item, Xen is_active)
{
  #define H_gtk_check_menu_item_set_active "void gtk_check_menu_item_set_active(GtkCheckMenuItem* check_menu_item, \
gboolean is_active)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_set_active", "GtkCheckMenuItem*");
  Xen_check_type(Xen_is_gboolean(is_active), is_active, 2, "gtk_check_menu_item_set_active", "gboolean");
  gtk_check_menu_item_set_active(Xen_to_C_GtkCheckMenuItem_(check_menu_item), Xen_to_C_gboolean(is_active));
  return(Xen_false);
}

static Xen gxg_gtk_check_menu_item_get_active(Xen check_menu_item)
{
  #define H_gtk_check_menu_item_get_active "gboolean gtk_check_menu_item_get_active(GtkCheckMenuItem* check_menu_item)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_get_active", "GtkCheckMenuItem*");
  return(C_to_Xen_gboolean(gtk_check_menu_item_get_active(Xen_to_C_GtkCheckMenuItem_(check_menu_item))));
}

static Xen gxg_gtk_check_menu_item_toggled(Xen check_menu_item)
{
  #define H_gtk_check_menu_item_toggled "void gtk_check_menu_item_toggled(GtkCheckMenuItem* check_menu_item)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_toggled", "GtkCheckMenuItem*");
  gtk_check_menu_item_toggled(Xen_to_C_GtkCheckMenuItem_(check_menu_item));
  return(Xen_false);
}

static Xen gxg_gtk_check_menu_item_set_inconsistent(Xen check_menu_item, Xen setting)
{
  #define H_gtk_check_menu_item_set_inconsistent "void gtk_check_menu_item_set_inconsistent(GtkCheckMenuItem* check_menu_item, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_set_inconsistent", "GtkCheckMenuItem*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_check_menu_item_set_inconsistent", "gboolean");
  gtk_check_menu_item_set_inconsistent(Xen_to_C_GtkCheckMenuItem_(check_menu_item), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_check_menu_item_get_inconsistent(Xen check_menu_item)
{
  #define H_gtk_check_menu_item_get_inconsistent "gboolean gtk_check_menu_item_get_inconsistent(GtkCheckMenuItem* check_menu_item)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_get_inconsistent", "GtkCheckMenuItem*");
  return(C_to_Xen_gboolean(gtk_check_menu_item_get_inconsistent(Xen_to_C_GtkCheckMenuItem_(check_menu_item))));
}

static Xen gxg_gtk_container_add(Xen container, Xen widget)
{
  #define H_gtk_container_add "void gtk_container_add(GtkContainer* container, GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_add", "GtkContainer*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_container_add", "GtkWidget*");
  gtk_container_add(Xen_to_C_GtkContainer_(container), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_container_remove(Xen container, Xen widget)
{
  #define H_gtk_container_remove "void gtk_container_remove(GtkContainer* container, GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_remove", "GtkContainer*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_container_remove", "GtkWidget*");
  gtk_container_remove(Xen_to_C_GtkContainer_(container), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_container_check_resize(Xen container)
{
  #define H_gtk_container_check_resize "void gtk_container_check_resize(GtkContainer* container)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_check_resize", "GtkContainer*");
  gtk_container_check_resize(Xen_to_C_GtkContainer_(container));
  return(Xen_false);
}

static Xen gxg_gtk_container_foreach(Xen container, Xen func, Xen func_info)
{
  #define H_gtk_container_foreach "void gtk_container_foreach(GtkContainer* container, GtkCallback func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_foreach", "GtkContainer*");
  Xen_check_type(Xen_is_GtkCallback(func), func, 2, "gtk_container_foreach", "GtkCallback");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_container_foreach", "lambda_data");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_container_foreach(Xen_to_C_GtkContainer_(container), Xen_to_C_GtkCallback(func), Xen_to_C_lambda_data(func_info));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_container_get_children(Xen container)
{
  #define H_gtk_container_get_children "GList* gtk_container_get_children(GtkContainer* container)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_get_children", "GtkContainer*");
  return(C_to_Xen_GList_(gtk_container_get_children(Xen_to_C_GtkContainer_(container))));
}

static Xen gxg_gtk_dialog_new(void)
{
  #define H_gtk_dialog_new "GtkWidget* gtk_dialog_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_dialog_new()));
}

static Xen gxg_gtk_dialog_add_action_widget(Xen dialog, Xen child, Xen response_id)
{
  #define H_gtk_dialog_add_action_widget "void gtk_dialog_add_action_widget(GtkDialog* dialog, GtkWidget* child, \
gint response_id)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_add_action_widget", "GtkDialog*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_dialog_add_action_widget", "GtkWidget*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 3, "gtk_dialog_add_action_widget", "gint");
  gtk_dialog_add_action_widget(Xen_to_C_GtkDialog_(dialog), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(response_id));
  return(Xen_false);
}

static Xen gxg_gtk_dialog_add_button(Xen dialog, Xen button_text, Xen response_id)
{
  #define H_gtk_dialog_add_button "GtkWidget* gtk_dialog_add_button(GtkDialog* dialog, gchar* button_text, \
gint response_id)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_add_button", "GtkDialog*");
  Xen_check_type(Xen_is_gchar_(button_text), button_text, 2, "gtk_dialog_add_button", "gchar*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 3, "gtk_dialog_add_button", "gint");
  return(C_to_Xen_GtkWidget_(gtk_dialog_add_button(Xen_to_C_GtkDialog_(dialog), Xen_to_C_gchar_(button_text), Xen_to_C_gint(response_id))));
}

static Xen gxg_gtk_dialog_add_buttons(Xen dialog, Xen buttons)
{
  #define H_gtk_dialog_add_buttons "void gtk_dialog_add_buttons(GtkDialog* dialog, etc buttons)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_add_buttons", "GtkDialog*");
  Xen_check_type(Xen_is_etc(buttons), buttons, 2, "gtk_dialog_add_buttons", "etc");
  {
    int etc_len = 0;
    GtkDialog* p_arg0;
    if (Xen_is_list(buttons)) etc_len = Xen_list_length(buttons);
    if (etc_len < 2) Xen_out_of_range_error("gtk_dialog_add_buttons", 1, buttons, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_dialog_add_buttons", 1, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_dialog_add_buttons", 1, buttons, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkDialog_(dialog);
    switch (etc_len)
      {
        case 2: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), NULL); break;
        case 4: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), NULL); break;
        case 6: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), NULL); break;
        case 8: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), NULL); break;
        case 10: gtk_dialog_add_buttons(p_arg0, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), XLS(buttons, 8), XLI(buttons, 9), NULL); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_dialog_set_response_sensitive(Xen dialog, Xen response_id, Xen setting)
{
  #define H_gtk_dialog_set_response_sensitive "void gtk_dialog_set_response_sensitive(GtkDialog* dialog, \
gint response_id, gboolean setting)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_set_response_sensitive", "GtkDialog*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_dialog_set_response_sensitive", "gint");
  Xen_check_type(Xen_is_gboolean(setting), setting, 3, "gtk_dialog_set_response_sensitive", "gboolean");
  gtk_dialog_set_response_sensitive(Xen_to_C_GtkDialog_(dialog), Xen_to_C_gint(response_id), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_dialog_set_default_response(Xen dialog, Xen response_id)
{
  #define H_gtk_dialog_set_default_response "void gtk_dialog_set_default_response(GtkDialog* dialog, \
gint response_id)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_set_default_response", "GtkDialog*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_dialog_set_default_response", "gint");
  gtk_dialog_set_default_response(Xen_to_C_GtkDialog_(dialog), Xen_to_C_gint(response_id));
  return(Xen_false);
}

static Xen gxg_gtk_dialog_response(Xen dialog, Xen response_id)
{
  #define H_gtk_dialog_response "void gtk_dialog_response(GtkDialog* dialog, gint response_id)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_response", "GtkDialog*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_dialog_response", "gint");
  gtk_dialog_response(Xen_to_C_GtkDialog_(dialog), Xen_to_C_gint(response_id));
  return(Xen_false);
}

static Xen gxg_gtk_dialog_run(Xen dialog)
{
  #define H_gtk_dialog_run "gint gtk_dialog_run(GtkDialog* dialog)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_run", "GtkDialog*");
  return(C_to_Xen_gint(gtk_dialog_run(Xen_to_C_GtkDialog_(dialog))));
}

static Xen gxg_gtk_drag_get_data(Xen widget, Xen context, Xen target, Xen time)
{
  #define H_gtk_drag_get_data "void gtk_drag_get_data(GtkWidget* widget, GdkDragContext* context, GdkAtom target, \
guint32 time)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_get_data", "GtkWidget*");
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 2, "gtk_drag_get_data", "GdkDragContext*");
  Xen_check_type(Xen_is_GdkAtom(target), target, 3, "gtk_drag_get_data", "GdkAtom");
  Xen_check_type(Xen_is_guint32(time), time, 4, "gtk_drag_get_data", "guint32");
  gtk_drag_get_data(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkDragContext_(context), Xen_to_C_GdkAtom(target), Xen_to_C_guint32(time));
  return(Xen_false);
}

static Xen gxg_gtk_drag_get_source_widget(Xen context)
{
  #define H_gtk_drag_get_source_widget "GtkWidget* gtk_drag_get_source_widget(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_get_source_widget", "GdkDragContext*");
  return(C_to_Xen_GtkWidget_(gtk_drag_get_source_widget(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gtk_drag_highlight(Xen widget)
{
  #define H_gtk_drag_highlight "void gtk_drag_highlight(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_highlight", "GtkWidget*");
  gtk_drag_highlight(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_unhighlight(Xen widget)
{
  #define H_gtk_drag_unhighlight "void gtk_drag_unhighlight(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_unhighlight", "GtkWidget*");
  gtk_drag_unhighlight(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_dest_unset(Xen widget)
{
  #define H_gtk_drag_dest_unset "void gtk_drag_dest_unset(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_unset", "GtkWidget*");
  gtk_drag_dest_unset(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_unset(Xen widget)
{
  #define H_gtk_drag_source_unset "void gtk_drag_source_unset(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_unset", "GtkWidget*");
  gtk_drag_source_unset(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_set_icon_widget(Xen context, Xen widget, Xen hot_x, Xen hot_y)
{
  #define H_gtk_drag_set_icon_widget "void gtk_drag_set_icon_widget(GdkDragContext* context, GtkWidget* widget, \
gint hot_x, gint hot_y)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_set_icon_widget", "GdkDragContext*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_drag_set_icon_widget", "GtkWidget*");
  Xen_check_type(Xen_is_gint(hot_x), hot_x, 3, "gtk_drag_set_icon_widget", "gint");
  Xen_check_type(Xen_is_gint(hot_y), hot_y, 4, "gtk_drag_set_icon_widget", "gint");
  gtk_drag_set_icon_widget(Xen_to_C_GdkDragContext_(context), Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(hot_x), Xen_to_C_gint(hot_y));
  return(Xen_false);
}

static Xen gxg_gtk_drag_set_icon_default(Xen context)
{
  #define H_gtk_drag_set_icon_default "void gtk_drag_set_icon_default(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_set_icon_default", "GdkDragContext*");
  gtk_drag_set_icon_default(Xen_to_C_GdkDragContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_drag_check_threshold(Xen widget, Xen start_x, Xen start_y, Xen current_x, Xen current_y)
{
  #define H_gtk_drag_check_threshold "gboolean gtk_drag_check_threshold(GtkWidget* widget, gint start_x, \
gint start_y, gint current_x, gint current_y)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_check_threshold", "GtkWidget*");
  Xen_check_type(Xen_is_gint(start_x), start_x, 2, "gtk_drag_check_threshold", "gint");
  Xen_check_type(Xen_is_gint(start_y), start_y, 3, "gtk_drag_check_threshold", "gint");
  Xen_check_type(Xen_is_gint(current_x), current_x, 4, "gtk_drag_check_threshold", "gint");
  Xen_check_type(Xen_is_gint(current_y), current_y, 5, "gtk_drag_check_threshold", "gint");
  return(C_to_Xen_gboolean(gtk_drag_check_threshold(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(start_x), Xen_to_C_gint(start_y), 
                                                    Xen_to_C_gint(current_x), Xen_to_C_gint(current_y))));
}

static Xen gxg_gtk_drawing_area_new(void)
{
  #define H_gtk_drawing_area_new "GtkWidget* gtk_drawing_area_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_drawing_area_new()));
}

static Xen gxg_gtk_editable_select_region(Xen editable, Xen start, Xen end)
{
  #define H_gtk_editable_select_region "void gtk_editable_select_region(GtkEditable* editable, gint start, \
gint end)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_select_region", "GtkEditable*");
  Xen_check_type(Xen_is_gint(start), start, 2, "gtk_editable_select_region", "gint");
  Xen_check_type(Xen_is_gint(end), end, 3, "gtk_editable_select_region", "gint");
  gtk_editable_select_region(Xen_to_C_GtkEditable_(editable), Xen_to_C_gint(start), Xen_to_C_gint(end));
  return(Xen_false);
}

static Xen gxg_gtk_editable_get_selection_bounds(Xen editable, Xen ignore_start, Xen ignore_end)
{
  #define H_gtk_editable_get_selection_bounds "gboolean gtk_editable_get_selection_bounds(GtkEditable* editable, \
gint* [start], gint* [end])"
  gint ref_start;
  gint ref_end;
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_get_selection_bounds", "GtkEditable*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_editable_get_selection_bounds(Xen_to_C_GtkEditable_(editable), &ref_start, &ref_end));
    return(Xen_list_3(result, C_to_Xen_gint(ref_start), C_to_Xen_gint(ref_end)));
   }
}

static Xen gxg_gtk_editable_insert_text(Xen editable, Xen new_text, Xen new_text_length, Xen ignore_position)
{
  #define H_gtk_editable_insert_text "void gtk_editable_insert_text(GtkEditable* editable, gchar* new_text, \
gint new_text_length, gint* [position])"
  gint ref_position;
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_insert_text", "GtkEditable*");
  Xen_check_type(Xen_is_gchar_(new_text), new_text, 2, "gtk_editable_insert_text", "gchar*");
  Xen_check_type(Xen_is_gint(new_text_length), new_text_length, 3, "gtk_editable_insert_text", "gint");
  gtk_editable_insert_text(Xen_to_C_GtkEditable_(editable), Xen_to_C_gchar_(new_text), Xen_to_C_gint(new_text_length), &ref_position);
  return(Xen_list_1(C_to_Xen_gint(ref_position)));
}

static Xen gxg_gtk_editable_delete_text(Xen editable, Xen start_pos, Xen end_pos)
{
  #define H_gtk_editable_delete_text "void gtk_editable_delete_text(GtkEditable* editable, gint start_pos, \
gint end_pos)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_delete_text", "GtkEditable*");
  Xen_check_type(Xen_is_gint(start_pos), start_pos, 2, "gtk_editable_delete_text", "gint");
  Xen_check_type(Xen_is_gint(end_pos), end_pos, 3, "gtk_editable_delete_text", "gint");
  gtk_editable_delete_text(Xen_to_C_GtkEditable_(editable), Xen_to_C_gint(start_pos), Xen_to_C_gint(end_pos));
  return(Xen_false);
}

static Xen gxg_gtk_editable_get_chars(Xen editable, Xen start_pos, Xen end_pos)
{
  #define H_gtk_editable_get_chars "gchar* gtk_editable_get_chars(GtkEditable* editable, gint start_pos, \
gint end_pos)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_get_chars", "GtkEditable*");
  Xen_check_type(Xen_is_gint(start_pos), start_pos, 2, "gtk_editable_get_chars", "gint");
  Xen_check_type(Xen_is_gint(end_pos), end_pos, 3, "gtk_editable_get_chars", "gint");
  {
   gchar* result;
   Xen rtn;
   result = gtk_editable_get_chars(Xen_to_C_GtkEditable_(editable), Xen_to_C_gint(start_pos), 
                                                                     Xen_to_C_gint(end_pos));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_editable_cut_clipboard(Xen editable)
{
  #define H_gtk_editable_cut_clipboard "void gtk_editable_cut_clipboard(GtkEditable* editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_cut_clipboard", "GtkEditable*");
  gtk_editable_cut_clipboard(Xen_to_C_GtkEditable_(editable));
  return(Xen_false);
}

static Xen gxg_gtk_editable_copy_clipboard(Xen editable)
{
  #define H_gtk_editable_copy_clipboard "void gtk_editable_copy_clipboard(GtkEditable* editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_copy_clipboard", "GtkEditable*");
  gtk_editable_copy_clipboard(Xen_to_C_GtkEditable_(editable));
  return(Xen_false);
}

static Xen gxg_gtk_editable_paste_clipboard(Xen editable)
{
  #define H_gtk_editable_paste_clipboard "void gtk_editable_paste_clipboard(GtkEditable* editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_paste_clipboard", "GtkEditable*");
  gtk_editable_paste_clipboard(Xen_to_C_GtkEditable_(editable));
  return(Xen_false);
}

static Xen gxg_gtk_editable_delete_selection(Xen editable)
{
  #define H_gtk_editable_delete_selection "void gtk_editable_delete_selection(GtkEditable* editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_delete_selection", "GtkEditable*");
  gtk_editable_delete_selection(Xen_to_C_GtkEditable_(editable));
  return(Xen_false);
}

static Xen gxg_gtk_editable_set_position(Xen editable, Xen position)
{
  #define H_gtk_editable_set_position "void gtk_editable_set_position(GtkEditable* editable, gint position)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_set_position", "GtkEditable*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_editable_set_position", "gint");
  gtk_editable_set_position(Xen_to_C_GtkEditable_(editable), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_editable_get_position(Xen editable)
{
  #define H_gtk_editable_get_position "gint gtk_editable_get_position(GtkEditable* editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_get_position", "GtkEditable*");
  return(C_to_Xen_gint(gtk_editable_get_position(Xen_to_C_GtkEditable_(editable))));
}

static Xen gxg_gtk_editable_set_editable(Xen editable, Xen is_editable)
{
  #define H_gtk_editable_set_editable "void gtk_editable_set_editable(GtkEditable* editable, gboolean is_editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_set_editable", "GtkEditable*");
  Xen_check_type(Xen_is_gboolean(is_editable), is_editable, 2, "gtk_editable_set_editable", "gboolean");
  gtk_editable_set_editable(Xen_to_C_GtkEditable_(editable), Xen_to_C_gboolean(is_editable));
  return(Xen_false);
}

static Xen gxg_gtk_editable_get_editable(Xen editable)
{
  #define H_gtk_editable_get_editable "gboolean gtk_editable_get_editable(GtkEditable* editable)"
  Xen_check_type(Xen_is_GtkEditable_(editable), editable, 1, "gtk_editable_get_editable", "GtkEditable*");
  return(C_to_Xen_gboolean(gtk_editable_get_editable(Xen_to_C_GtkEditable_(editable))));
}

static Xen gxg_gtk_entry_new(void)
{
  #define H_gtk_entry_new "GtkWidget* gtk_entry_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_entry_new()));
}

static Xen gxg_gtk_entry_set_visibility(Xen entry, Xen visible)
{
  #define H_gtk_entry_set_visibility "void gtk_entry_set_visibility(GtkEntry* entry, gboolean visible)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_visibility", "GtkEntry*");
  Xen_check_type(Xen_is_gboolean(visible), visible, 2, "gtk_entry_set_visibility", "gboolean");
  gtk_entry_set_visibility(Xen_to_C_GtkEntry_(entry), Xen_to_C_gboolean(visible));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_visibility(Xen entry)
{
  #define H_gtk_entry_get_visibility "gboolean gtk_entry_get_visibility(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_visibility", "GtkEntry*");
  return(C_to_Xen_gboolean(gtk_entry_get_visibility(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_invisible_char(Xen entry, Xen ch)
{
  #define H_gtk_entry_set_invisible_char "void gtk_entry_set_invisible_char(GtkEntry* entry, gunichar ch)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_invisible_char", "GtkEntry*");
  Xen_check_type(Xen_is_gunichar(ch), ch, 2, "gtk_entry_set_invisible_char", "gunichar");
  gtk_entry_set_invisible_char(Xen_to_C_GtkEntry_(entry), Xen_to_C_gunichar(ch));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_invisible_char(Xen entry)
{
  #define H_gtk_entry_get_invisible_char "gunichar gtk_entry_get_invisible_char(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_invisible_char", "GtkEntry*");
  return(C_to_Xen_gunichar(gtk_entry_get_invisible_char(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_has_frame(Xen entry, Xen setting)
{
  #define H_gtk_entry_set_has_frame "void gtk_entry_set_has_frame(GtkEntry* entry, gboolean setting)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_has_frame", "GtkEntry*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_entry_set_has_frame", "gboolean");
  gtk_entry_set_has_frame(Xen_to_C_GtkEntry_(entry), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_has_frame(Xen entry)
{
  #define H_gtk_entry_get_has_frame "gboolean gtk_entry_get_has_frame(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_has_frame", "GtkEntry*");
  return(C_to_Xen_gboolean(gtk_entry_get_has_frame(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_max_length(Xen entry, Xen max)
{
  #define H_gtk_entry_set_max_length "void gtk_entry_set_max_length(GtkEntry* entry, gint max)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_max_length", "GtkEntry*");
  Xen_check_type(Xen_is_gint(max), max, 2, "gtk_entry_set_max_length", "gint");
  gtk_entry_set_max_length(Xen_to_C_GtkEntry_(entry), Xen_to_C_gint(max));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_max_length(Xen entry)
{
  #define H_gtk_entry_get_max_length "gint gtk_entry_get_max_length(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_max_length", "GtkEntry*");
  return(C_to_Xen_gint(gtk_entry_get_max_length(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_activates_default(Xen entry, Xen setting)
{
  #define H_gtk_entry_set_activates_default "void gtk_entry_set_activates_default(GtkEntry* entry, gboolean setting)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_activates_default", "GtkEntry*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_entry_set_activates_default", "gboolean");
  gtk_entry_set_activates_default(Xen_to_C_GtkEntry_(entry), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_activates_default(Xen entry)
{
  #define H_gtk_entry_get_activates_default "gboolean gtk_entry_get_activates_default(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_activates_default", "GtkEntry*");
  return(C_to_Xen_gboolean(gtk_entry_get_activates_default(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_width_chars(Xen entry, Xen n_chars)
{
  #define H_gtk_entry_set_width_chars "void gtk_entry_set_width_chars(GtkEntry* entry, gint n_chars)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_width_chars", "GtkEntry*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 2, "gtk_entry_set_width_chars", "gint");
  gtk_entry_set_width_chars(Xen_to_C_GtkEntry_(entry), Xen_to_C_gint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_width_chars(Xen entry)
{
  #define H_gtk_entry_get_width_chars "gint gtk_entry_get_width_chars(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_width_chars", "GtkEntry*");
  return(C_to_Xen_gint(gtk_entry_get_width_chars(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_text(Xen entry, Xen text)
{
  #define H_gtk_entry_set_text "void gtk_entry_set_text(GtkEntry* entry, gchar* text)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_text", "GtkEntry*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_entry_set_text", "gchar*");
  gtk_entry_set_text(Xen_to_C_GtkEntry_(entry), Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_text(Xen entry)
{
  #define H_gtk_entry_get_text "gchar* gtk_entry_get_text(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_text", "GtkEntry*");
  return(C_to_Xen_gchar_(gtk_entry_get_text(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_get_layout(Xen entry)
{
  #define H_gtk_entry_get_layout "PangoLayout* gtk_entry_get_layout(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_layout", "GtkEntry*");
  return(C_to_Xen_PangoLayout_(gtk_entry_get_layout(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_get_layout_offsets(Xen entry, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_entry_get_layout_offsets "void gtk_entry_get_layout_offsets(GtkEntry* entry, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_layout_offsets", "GtkEntry*");
  gtk_entry_get_layout_offsets(Xen_to_C_GtkEntry_(entry), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
}

static Xen gxg_gtk_fixed_new(void)
{
  #define H_gtk_fixed_new "GtkWidget* gtk_fixed_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_fixed_new()));
}

static Xen gxg_gtk_fixed_put(Xen fixed, Xen widget, Xen x, Xen y)
{
  #define H_gtk_fixed_put "void gtk_fixed_put(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  Xen_check_type(Xen_is_GtkFixed_(fixed), fixed, 1, "gtk_fixed_put", "GtkFixed*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_fixed_put", "GtkWidget*");
  Xen_check_type(Xen_is_gint(x), x, 3, "gtk_fixed_put", "gint");
  Xen_check_type(Xen_is_gint(y), y, 4, "gtk_fixed_put", "gint");
  gtk_fixed_put(Xen_to_C_GtkFixed_(fixed), Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
}

static Xen gxg_gtk_fixed_move(Xen fixed, Xen widget, Xen x, Xen y)
{
  #define H_gtk_fixed_move "void gtk_fixed_move(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  Xen_check_type(Xen_is_GtkFixed_(fixed), fixed, 1, "gtk_fixed_move", "GtkFixed*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_fixed_move", "GtkWidget*");
  Xen_check_type(Xen_is_gint(x), x, 3, "gtk_fixed_move", "gint");
  Xen_check_type(Xen_is_gint(y), y, 4, "gtk_fixed_move", "gint");
  gtk_fixed_move(Xen_to_C_GtkFixed_(fixed), Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
}

static Xen gxg_gtk_frame_new(Xen label)
{
  #define H_gtk_frame_new "GtkWidget* gtk_frame_new(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_frame_new", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_frame_new(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_frame_set_label(Xen frame, Xen label)
{
  #define H_gtk_frame_set_label "void gtk_frame_set_label(GtkFrame* frame, gchar* label)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_set_label", "GtkFrame*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_frame_set_label", "gchar*");
  gtk_frame_set_label(Xen_to_C_GtkFrame_(frame), Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_frame_get_label(Xen frame)
{
  #define H_gtk_frame_get_label "gchar* gtk_frame_get_label(GtkFrame* frame)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_get_label", "GtkFrame*");
  return(C_to_Xen_gchar_(gtk_frame_get_label(Xen_to_C_GtkFrame_(frame))));
}

static Xen gxg_gtk_frame_set_label_widget(Xen frame, Xen label_widget)
{
  #define H_gtk_frame_set_label_widget "void gtk_frame_set_label_widget(GtkFrame* frame, GtkWidget* label_widget)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_set_label_widget", "GtkFrame*");
  Xen_check_type(Xen_is_GtkWidget_(label_widget), label_widget, 2, "gtk_frame_set_label_widget", "GtkWidget*");
  gtk_frame_set_label_widget(Xen_to_C_GtkFrame_(frame), Xen_to_C_GtkWidget_(label_widget));
  return(Xen_false);
}

static Xen gxg_gtk_frame_get_label_widget(Xen frame)
{
  #define H_gtk_frame_get_label_widget "GtkWidget* gtk_frame_get_label_widget(GtkFrame* frame)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_get_label_widget", "GtkFrame*");
  return(C_to_Xen_GtkWidget_(gtk_frame_get_label_widget(Xen_to_C_GtkFrame_(frame))));
}

static Xen gxg_gtk_frame_set_label_align(Xen frame, Xen xalign, Xen yalign)
{
  #define H_gtk_frame_set_label_align "void gtk_frame_set_label_align(GtkFrame* frame, gfloat xalign, \
gfloat yalign)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_set_label_align", "GtkFrame*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_frame_set_label_align", "gfloat");
  Xen_check_type(Xen_is_gfloat(yalign), yalign, 3, "gtk_frame_set_label_align", "gfloat");
  gtk_frame_set_label_align(Xen_to_C_GtkFrame_(frame), Xen_to_C_gfloat(xalign), Xen_to_C_gfloat(yalign));
  return(Xen_false);
}

static Xen gxg_gtk_frame_get_label_align(Xen frame, Xen ignore_xalign, Xen ignore_yalign)
{
  #define H_gtk_frame_get_label_align "void gtk_frame_get_label_align(GtkFrame* frame, gfloat* [xalign], \
gfloat* [yalign])"
  gfloat ref_xalign;
  gfloat ref_yalign;
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_get_label_align", "GtkFrame*");
  gtk_frame_get_label_align(Xen_to_C_GtkFrame_(frame), &ref_xalign, &ref_yalign);
  return(Xen_list_2(C_to_Xen_gfloat(ref_xalign), C_to_Xen_gfloat(ref_yalign)));
}

static Xen gxg_gtk_frame_set_shadow_type(Xen frame, Xen type)
{
  #define H_gtk_frame_set_shadow_type "void gtk_frame_set_shadow_type(GtkFrame* frame, GtkShadowType type)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_set_shadow_type", "GtkFrame*");
  Xen_check_type(Xen_is_GtkShadowType(type), type, 2, "gtk_frame_set_shadow_type", "GtkShadowType");
  gtk_frame_set_shadow_type(Xen_to_C_GtkFrame_(frame), Xen_to_C_GtkShadowType(type));
  return(Xen_false);
}

static Xen gxg_gtk_frame_get_shadow_type(Xen frame)
{
  #define H_gtk_frame_get_shadow_type "GtkShadowType gtk_frame_get_shadow_type(GtkFrame* frame)"
  Xen_check_type(Xen_is_GtkFrame_(frame), frame, 1, "gtk_frame_get_shadow_type", "GtkFrame*");
  return(C_to_Xen_GtkShadowType(gtk_frame_get_shadow_type(Xen_to_C_GtkFrame_(frame))));
}

static Xen gxg_gtk_image_new(void)
{
  #define H_gtk_image_new "GtkWidget* gtk_image_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_image_new()));
}

static Xen gxg_gtk_image_new_from_file(Xen filename)
{
  #define H_gtk_image_new_from_file "GtkWidget* gtk_image_new_from_file(gchar* filename)"
  Xen_check_type(Xen_is_gchar_(filename), filename, 1, "gtk_image_new_from_file", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_file(Xen_to_C_gchar_(filename))));
}

static Xen gxg_gtk_image_new_from_pixbuf(Xen pixbuf)
{
  #define H_gtk_image_new_from_pixbuf "GtkWidget* gtk_image_new_from_pixbuf(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf) || Xen_is_false(pixbuf), pixbuf, 1, "gtk_image_new_from_pixbuf", "GdkPixbuf*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_pixbuf(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gtk_image_set_from_file(Xen image, Xen filename)
{
  #define H_gtk_image_set_from_file "void gtk_image_set_from_file(GtkImage* image, gchar* filename)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_file", "GtkImage*");
  Xen_check_type(Xen_is_gchar_(filename), filename, 2, "gtk_image_set_from_file", "gchar*");
  gtk_image_set_from_file(Xen_to_C_GtkImage_(image), Xen_to_C_gchar_(filename));
  return(Xen_false);
}

static Xen gxg_gtk_image_set_from_pixbuf(Xen image, Xen pixbuf)
{
  #define H_gtk_image_set_from_pixbuf "void gtk_image_set_from_pixbuf(GtkImage* image, GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_pixbuf", "GtkImage*");
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf) || Xen_is_false(pixbuf), pixbuf, 2, "gtk_image_set_from_pixbuf", "GdkPixbuf*");
  gtk_image_set_from_pixbuf(Xen_to_C_GtkImage_(image), Xen_to_C_GdkPixbuf_(pixbuf));
  return(Xen_false);
}

static Xen gxg_gtk_image_get_storage_type(Xen image)
{
  #define H_gtk_image_get_storage_type "GtkImageType gtk_image_get_storage_type(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_storage_type", "GtkImage*");
  return(C_to_Xen_GtkImageType(gtk_image_get_storage_type(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_im_context_get_preedit_string(Xen context, Xen ignore_str, Xen ignore_attrs, Xen ignore_cursor_pos)
{
  #define H_gtk_im_context_get_preedit_string "void gtk_im_context_get_preedit_string(GtkIMContext* context, \
gchar** [str], PangoAttrList** [attrs], gint* [cursor_pos])"
  gchar* ref_str = NULL;
  PangoAttrList* ref_attrs = NULL;
  gint ref_cursor_pos;
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_get_preedit_string", "GtkIMContext*");
  gtk_im_context_get_preedit_string(Xen_to_C_GtkIMContext_(context), &ref_str, &ref_attrs, &ref_cursor_pos);
  return(Xen_list_3(C_to_Xen_gchar_(ref_str), C_to_Xen_PangoAttrList_(ref_attrs), C_to_Xen_gint(ref_cursor_pos)));
}

static Xen gxg_gtk_im_context_filter_keypress(Xen context, Xen event)
{
  #define H_gtk_im_context_filter_keypress "gboolean gtk_im_context_filter_keypress(GtkIMContext* context, \
GdkEventKey* event)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_filter_keypress", "GtkIMContext*");
  Xen_check_type(Xen_is_GdkEventKey_(event), event, 2, "gtk_im_context_filter_keypress", "GdkEventKey*");
  return(C_to_Xen_gboolean(gtk_im_context_filter_keypress(Xen_to_C_GtkIMContext_(context), Xen_to_C_GdkEventKey_(event))));
}

static Xen gxg_gtk_im_context_focus_in(Xen context)
{
  #define H_gtk_im_context_focus_in "void gtk_im_context_focus_in(GtkIMContext* context)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_focus_in", "GtkIMContext*");
  gtk_im_context_focus_in(Xen_to_C_GtkIMContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_im_context_focus_out(Xen context)
{
  #define H_gtk_im_context_focus_out "void gtk_im_context_focus_out(GtkIMContext* context)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_focus_out", "GtkIMContext*");
  gtk_im_context_focus_out(Xen_to_C_GtkIMContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_im_context_reset(Xen context)
{
  #define H_gtk_im_context_reset "void gtk_im_context_reset(GtkIMContext* context)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_reset", "GtkIMContext*");
  gtk_im_context_reset(Xen_to_C_GtkIMContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_im_context_set_cursor_location(Xen context, Xen area)
{
  #define H_gtk_im_context_set_cursor_location "void gtk_im_context_set_cursor_location(GtkIMContext* context, \
GdkRectangle* area)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_set_cursor_location", "GtkIMContext*");
  Xen_check_type(Xen_is_GdkRectangle_(area), area, 2, "gtk_im_context_set_cursor_location", "GdkRectangle*");
  gtk_im_context_set_cursor_location(Xen_to_C_GtkIMContext_(context), Xen_to_C_GdkRectangle_(area));
  return(Xen_false);
}

static Xen gxg_gtk_im_context_set_use_preedit(Xen context, Xen use_preedit)
{
  #define H_gtk_im_context_set_use_preedit "void gtk_im_context_set_use_preedit(GtkIMContext* context, \
gboolean use_preedit)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_set_use_preedit", "GtkIMContext*");
  Xen_check_type(Xen_is_gboolean(use_preedit), use_preedit, 2, "gtk_im_context_set_use_preedit", "gboolean");
  gtk_im_context_set_use_preedit(Xen_to_C_GtkIMContext_(context), Xen_to_C_gboolean(use_preedit));
  return(Xen_false);
}

static Xen gxg_gtk_im_context_set_surrounding(Xen context, Xen text, Xen len, Xen cursor_index)
{
  #define H_gtk_im_context_set_surrounding "void gtk_im_context_set_surrounding(GtkIMContext* context, \
gchar* text, gint len, gint cursor_index)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_set_surrounding", "GtkIMContext*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_im_context_set_surrounding", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 3, "gtk_im_context_set_surrounding", "gint");
  Xen_check_type(Xen_is_gint(cursor_index), cursor_index, 4, "gtk_im_context_set_surrounding", "gint");
  gtk_im_context_set_surrounding(Xen_to_C_GtkIMContext_(context), Xen_to_C_gchar_(text), Xen_to_C_gint(len), Xen_to_C_gint(cursor_index));
  return(Xen_false);
}

static Xen gxg_gtk_im_context_get_surrounding(Xen context, Xen ignore_text, Xen ignore_cursor_index)
{
  #define H_gtk_im_context_get_surrounding "gboolean gtk_im_context_get_surrounding(GtkIMContext* context, \
gchar** [text], gint* [cursor_index])"
  gchar* ref_text = NULL;
  gint ref_cursor_index;
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_get_surrounding", "GtkIMContext*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_im_context_get_surrounding(Xen_to_C_GtkIMContext_(context), &ref_text, &ref_cursor_index));
    return(Xen_list_3(result, C_to_Xen_gchar_(ref_text), C_to_Xen_gint(ref_cursor_index)));
   }
}

static Xen gxg_gtk_im_context_delete_surrounding(Xen context, Xen offset, Xen n_chars)
{
  #define H_gtk_im_context_delete_surrounding "gboolean gtk_im_context_delete_surrounding(GtkIMContext* context, \
gint offset, gint n_chars)"
  Xen_check_type(Xen_is_GtkIMContext_(context), context, 1, "gtk_im_context_delete_surrounding", "GtkIMContext*");
  Xen_check_type(Xen_is_gint(offset), offset, 2, "gtk_im_context_delete_surrounding", "gint");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 3, "gtk_im_context_delete_surrounding", "gint");
  return(C_to_Xen_gboolean(gtk_im_context_delete_surrounding(Xen_to_C_GtkIMContext_(context), Xen_to_C_gint(offset), Xen_to_C_gint(n_chars))));
}

static Xen gxg_gtk_im_context_simple_new(void)
{
  #define H_gtk_im_context_simple_new "GtkIMContext* gtk_im_context_simple_new( void)"
  return(C_to_Xen_GtkIMContext_(gtk_im_context_simple_new()));
}

static Xen gxg_gtk_im_context_simple_add_table(Xen context_simple, Xen data, Xen max_seq_len, Xen n_seqs)
{
  #define H_gtk_im_context_simple_add_table "void gtk_im_context_simple_add_table(GtkIMContextSimple* context_simple, \
guint16* data, gint max_seq_len, gint n_seqs)"
  Xen_check_type(Xen_is_GtkIMContextSimple_(context_simple), context_simple, 1, "gtk_im_context_simple_add_table", "GtkIMContextSimple*");
  Xen_check_type(Xen_is_guint16_(data), data, 2, "gtk_im_context_simple_add_table", "guint16*");
  Xen_check_type(Xen_is_gint(max_seq_len), max_seq_len, 3, "gtk_im_context_simple_add_table", "gint");
  Xen_check_type(Xen_is_gint(n_seqs), n_seqs, 4, "gtk_im_context_simple_add_table", "gint");
  gtk_im_context_simple_add_table(Xen_to_C_GtkIMContextSimple_(context_simple), Xen_to_C_guint16_(data), Xen_to_C_gint(max_seq_len), 
                                  Xen_to_C_gint(n_seqs));
  return(Xen_false);
}

static Xen gxg_gtk_invisible_new(void)
{
  #define H_gtk_invisible_new "GtkWidget* gtk_invisible_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_invisible_new()));
}

static Xen gxg_gtk_label_new(Xen str)
{
  #define H_gtk_label_new "GtkWidget* gtk_label_new(char* str)"
  Xen_check_type(Xen_is_char_(str), str, 1, "gtk_label_new", "char*");
  return(C_to_Xen_GtkWidget_(gtk_label_new(Xen_to_C_char_(str))));
}

static Xen gxg_gtk_label_new_with_mnemonic(Xen str)
{
  #define H_gtk_label_new_with_mnemonic "GtkWidget* gtk_label_new_with_mnemonic(char* str)"
  Xen_check_type(Xen_is_char_(str), str, 1, "gtk_label_new_with_mnemonic", "char*");
  return(C_to_Xen_GtkWidget_(gtk_label_new_with_mnemonic(Xen_to_C_char_(str))));
}

static Xen gxg_gtk_label_set_text(Xen label, Xen str)
{
  #define H_gtk_label_set_text "void gtk_label_set_text(GtkLabel* label, char* str)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_text", "GtkLabel*");
  Xen_check_type(Xen_is_char_(str), str, 2, "gtk_label_set_text", "char*");
  gtk_label_set_text(Xen_to_C_GtkLabel_(label), Xen_to_C_char_(str));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_text(Xen label)
{
  #define H_gtk_label_get_text "gchar* gtk_label_get_text(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_text", "GtkLabel*");
  return(C_to_Xen_gchar_(gtk_label_get_text(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_attributes(Xen label, Xen attrs)
{
  #define H_gtk_label_set_attributes "void gtk_label_set_attributes(GtkLabel* label, PangoAttrList* attrs)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_attributes", "GtkLabel*");
  Xen_check_type(Xen_is_PangoAttrList_(attrs), attrs, 2, "gtk_label_set_attributes", "PangoAttrList*");
  gtk_label_set_attributes(Xen_to_C_GtkLabel_(label), Xen_to_C_PangoAttrList_(attrs));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_attributes(Xen label)
{
  #define H_gtk_label_get_attributes "PangoAttrList* gtk_label_get_attributes(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_attributes", "GtkLabel*");
  return(C_to_Xen_PangoAttrList_(gtk_label_get_attributes(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_label(Xen label, Xen str)
{
  #define H_gtk_label_set_label "void gtk_label_set_label(GtkLabel* label, gchar* str)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_label", "GtkLabel*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_label_set_label", "gchar*");
  gtk_label_set_label(Xen_to_C_GtkLabel_(label), Xen_to_C_gchar_(str));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_label(Xen label)
{
  #define H_gtk_label_get_label "gchar* gtk_label_get_label(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_label", "GtkLabel*");
  return(C_to_Xen_gchar_(gtk_label_get_label(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_markup(Xen label, Xen str)
{
  #define H_gtk_label_set_markup "void gtk_label_set_markup(GtkLabel* label, gchar* str)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_markup", "GtkLabel*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_label_set_markup", "gchar*");
  gtk_label_set_markup(Xen_to_C_GtkLabel_(label), Xen_to_C_gchar_(str));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_use_markup(Xen label, Xen setting)
{
  #define H_gtk_label_set_use_markup "void gtk_label_set_use_markup(GtkLabel* label, gboolean setting)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_use_markup", "GtkLabel*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_label_set_use_markup", "gboolean");
  gtk_label_set_use_markup(Xen_to_C_GtkLabel_(label), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_use_markup(Xen label)
{
  #define H_gtk_label_get_use_markup "gboolean gtk_label_get_use_markup(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_use_markup", "GtkLabel*");
  return(C_to_Xen_gboolean(gtk_label_get_use_markup(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_use_underline(Xen label, Xen setting)
{
  #define H_gtk_label_set_use_underline "void gtk_label_set_use_underline(GtkLabel* label, gboolean setting)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_use_underline", "GtkLabel*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_label_set_use_underline", "gboolean");
  gtk_label_set_use_underline(Xen_to_C_GtkLabel_(label), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_use_underline(Xen label)
{
  #define H_gtk_label_get_use_underline "gboolean gtk_label_get_use_underline(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_use_underline", "GtkLabel*");
  return(C_to_Xen_gboolean(gtk_label_get_use_underline(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_markup_with_mnemonic(Xen label, Xen str)
{
  #define H_gtk_label_set_markup_with_mnemonic "void gtk_label_set_markup_with_mnemonic(GtkLabel* label, \
gchar* str)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_markup_with_mnemonic", "GtkLabel*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_label_set_markup_with_mnemonic", "gchar*");
  gtk_label_set_markup_with_mnemonic(Xen_to_C_GtkLabel_(label), Xen_to_C_gchar_(str));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_mnemonic_keyval(Xen label)
{
  #define H_gtk_label_get_mnemonic_keyval "guint gtk_label_get_mnemonic_keyval(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_mnemonic_keyval", "GtkLabel*");
  return(C_to_Xen_guint(gtk_label_get_mnemonic_keyval(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_mnemonic_widget(Xen label, Xen widget)
{
  #define H_gtk_label_set_mnemonic_widget "void gtk_label_set_mnemonic_widget(GtkLabel* label, GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_mnemonic_widget", "GtkLabel*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_label_set_mnemonic_widget", "GtkWidget*");
  gtk_label_set_mnemonic_widget(Xen_to_C_GtkLabel_(label), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_mnemonic_widget(Xen label)
{
  #define H_gtk_label_get_mnemonic_widget "GtkWidget* gtk_label_get_mnemonic_widget(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_mnemonic_widget", "GtkLabel*");
  return(C_to_Xen_GtkWidget_(gtk_label_get_mnemonic_widget(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_text_with_mnemonic(Xen label, Xen str)
{
  #define H_gtk_label_set_text_with_mnemonic "void gtk_label_set_text_with_mnemonic(GtkLabel* label, \
gchar* str)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_text_with_mnemonic", "GtkLabel*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_label_set_text_with_mnemonic", "gchar*");
  gtk_label_set_text_with_mnemonic(Xen_to_C_GtkLabel_(label), Xen_to_C_gchar_(str));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_justify(Xen label, Xen jtype)
{
  #define H_gtk_label_set_justify "void gtk_label_set_justify(GtkLabel* label, GtkJustification jtype)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_justify", "GtkLabel*");
  Xen_check_type(Xen_is_GtkJustification(jtype), jtype, 2, "gtk_label_set_justify", "GtkJustification");
  gtk_label_set_justify(Xen_to_C_GtkLabel_(label), Xen_to_C_GtkJustification(jtype));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_justify(Xen label)
{
  #define H_gtk_label_get_justify "GtkJustification gtk_label_get_justify(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_justify", "GtkLabel*");
  return(C_to_Xen_GtkJustification(gtk_label_get_justify(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_pattern(Xen label, Xen pattern)
{
  #define H_gtk_label_set_pattern "void gtk_label_set_pattern(GtkLabel* label, gchar* pattern)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_pattern", "GtkLabel*");
  Xen_check_type(Xen_is_gchar_(pattern), pattern, 2, "gtk_label_set_pattern", "gchar*");
  gtk_label_set_pattern(Xen_to_C_GtkLabel_(label), Xen_to_C_gchar_(pattern));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_line_wrap(Xen label, Xen wrap)
{
  #define H_gtk_label_set_line_wrap "void gtk_label_set_line_wrap(GtkLabel* label, gboolean wrap)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_line_wrap", "GtkLabel*");
  Xen_check_type(Xen_is_gboolean(wrap), wrap, 2, "gtk_label_set_line_wrap", "gboolean");
  gtk_label_set_line_wrap(Xen_to_C_GtkLabel_(label), Xen_to_C_gboolean(wrap));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_line_wrap(Xen label)
{
  #define H_gtk_label_get_line_wrap "gboolean gtk_label_get_line_wrap(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_line_wrap", "GtkLabel*");
  return(C_to_Xen_gboolean(gtk_label_get_line_wrap(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_selectable(Xen label, Xen setting)
{
  #define H_gtk_label_set_selectable "void gtk_label_set_selectable(GtkLabel* label, gboolean setting)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_selectable", "GtkLabel*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_label_set_selectable", "gboolean");
  gtk_label_set_selectable(Xen_to_C_GtkLabel_(label), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_selectable(Xen label)
{
  #define H_gtk_label_get_selectable "gboolean gtk_label_get_selectable(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_selectable", "GtkLabel*");
  return(C_to_Xen_gboolean(gtk_label_get_selectable(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_select_region(Xen label, Xen start_offset, Xen end_offset)
{
  #define H_gtk_label_select_region "void gtk_label_select_region(GtkLabel* label, gint start_offset, \
gint end_offset)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_select_region", "GtkLabel*");
  Xen_check_type(Xen_is_gint(start_offset), start_offset, 2, "gtk_label_select_region", "gint");
  Xen_check_type(Xen_is_gint(end_offset), end_offset, 3, "gtk_label_select_region", "gint");
  gtk_label_select_region(Xen_to_C_GtkLabel_(label), Xen_to_C_gint(start_offset), Xen_to_C_gint(end_offset));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_selection_bounds(Xen label, Xen ignore_start, Xen ignore_end)
{
  #define H_gtk_label_get_selection_bounds "gboolean gtk_label_get_selection_bounds(GtkLabel* label, \
gint* [start], gint* [end])"
  gint ref_start;
  gint ref_end;
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_selection_bounds", "GtkLabel*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_label_get_selection_bounds(Xen_to_C_GtkLabel_(label), &ref_start, &ref_end));
    return(Xen_list_3(result, C_to_Xen_gint(ref_start), C_to_Xen_gint(ref_end)));
   }
}

static Xen gxg_gtk_label_get_layout(Xen label)
{
  #define H_gtk_label_get_layout "PangoLayout* gtk_label_get_layout(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_layout", "GtkLabel*");
  return(C_to_Xen_PangoLayout_(gtk_label_get_layout(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_get_layout_offsets(Xen label, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_label_get_layout_offsets "void gtk_label_get_layout_offsets(GtkLabel* label, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_layout_offsets", "GtkLabel*");
  gtk_label_get_layout_offsets(Xen_to_C_GtkLabel_(label), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
}

static Xen gxg_gtk_layout_new(Xen hadjustment, Xen vadjustment)
{
  #define H_gtk_layout_new "GtkWidget* gtk_layout_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(hadjustment) || Xen_is_false(hadjustment), hadjustment, 1, "gtk_layout_new", "GtkAdjustment*");
  Xen_check_type(Xen_is_GtkAdjustment_(vadjustment) || Xen_is_false(vadjustment), vadjustment, 2, "gtk_layout_new", "GtkAdjustment*");
  return(C_to_Xen_GtkWidget_(gtk_layout_new(Xen_to_C_GtkAdjustment_(hadjustment), Xen_to_C_GtkAdjustment_(vadjustment))));
}

static Xen gxg_gtk_layout_put(Xen layout, Xen child_widget, Xen x, Xen y)
{
  #define H_gtk_layout_put "void gtk_layout_put(GtkLayout* layout, GtkWidget* child_widget, gint x, gint y)"
  Xen_check_type(Xen_is_GtkLayout_(layout), layout, 1, "gtk_layout_put", "GtkLayout*");
  Xen_check_type(Xen_is_GtkWidget_(child_widget), child_widget, 2, "gtk_layout_put", "GtkWidget*");
  Xen_check_type(Xen_is_gint(x), x, 3, "gtk_layout_put", "gint");
  Xen_check_type(Xen_is_gint(y), y, 4, "gtk_layout_put", "gint");
  gtk_layout_put(Xen_to_C_GtkLayout_(layout), Xen_to_C_GtkWidget_(child_widget), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
}

static Xen gxg_gtk_layout_move(Xen layout, Xen child_widget, Xen x, Xen y)
{
  #define H_gtk_layout_move "void gtk_layout_move(GtkLayout* layout, GtkWidget* child_widget, gint x, \
gint y)"
  Xen_check_type(Xen_is_GtkLayout_(layout), layout, 1, "gtk_layout_move", "GtkLayout*");
  Xen_check_type(Xen_is_GtkWidget_(child_widget), child_widget, 2, "gtk_layout_move", "GtkWidget*");
  Xen_check_type(Xen_is_gint(x), x, 3, "gtk_layout_move", "gint");
  Xen_check_type(Xen_is_gint(y), y, 4, "gtk_layout_move", "gint");
  gtk_layout_move(Xen_to_C_GtkLayout_(layout), Xen_to_C_GtkWidget_(child_widget), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
}

static Xen gxg_gtk_layout_set_size(Xen layout, Xen width, Xen height)
{
  #define H_gtk_layout_set_size "void gtk_layout_set_size(GtkLayout* layout, guint width, guint height)"
  Xen_check_type(Xen_is_GtkLayout_(layout), layout, 1, "gtk_layout_set_size", "GtkLayout*");
  Xen_check_type(Xen_is_guint(width), width, 2, "gtk_layout_set_size", "guint");
  Xen_check_type(Xen_is_guint(height), height, 3, "gtk_layout_set_size", "guint");
  gtk_layout_set_size(Xen_to_C_GtkLayout_(layout), Xen_to_C_guint(width), Xen_to_C_guint(height));
  return(Xen_false);
}

static Xen gxg_gtk_layout_get_size(Xen layout, Xen ignore_width, Xen ignore_height)
{
  #define H_gtk_layout_get_size "void gtk_layout_get_size(GtkLayout* layout, guint* [width], guint* [height])"
  guint ref_width;
  guint ref_height;
  Xen_check_type(Xen_is_GtkLayout_(layout), layout, 1, "gtk_layout_get_size", "GtkLayout*");
  gtk_layout_get_size(Xen_to_C_GtkLayout_(layout), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_guint(ref_width), C_to_Xen_guint(ref_height)));
}

static Xen gxg_gtk_list_store_new(Xen n_columns, Xen types)
{
  #define H_gtk_list_store_new "GtkListStore* gtk_list_store_new(gint n_columns, etc types)"
  Xen_check_type(Xen_is_gint(n_columns), n_columns, 1, "gtk_list_store_new", "gint");
  Xen_check_type(Xen_is_etc(types), types, 2, "gtk_list_store_new", "etc");
  {
    int etc_len = 0;
    GtkListStore* result = NULL;
    gint p_arg0;
    if (Xen_is_list(types)) etc_len = Xen_list_length(types);
    if (etc_len < 1) Xen_out_of_range_error("gtk_list_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) Xen_out_of_range_error("gtk_list_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = Xen_to_C_gint(n_columns);
    switch (etc_len)
      {
        case 1: result = gtk_list_store_new(p_arg0, XLG(types, 0)); break;
        case 2: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1)); break;
        case 3: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2)); break;
        case 4: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3)); break;
        case 5: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4)); break;
        case 6: result = gtk_list_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4), XLG(types, 5)); break;
      }
    return(C_to_Xen_GtkListStore_(result));
  }
}

static Xen gxg_gtk_list_store_newv(Xen n_columns, Xen types)
{
  #define H_gtk_list_store_newv "GtkListStore* gtk_list_store_newv(gint n_columns, GType* types)"
  Xen_check_type(Xen_is_gint(n_columns), n_columns, 1, "gtk_list_store_newv", "gint");
  Xen_check_type(Xen_is_GType_(types), types, 2, "gtk_list_store_newv", "GType*");
  return(C_to_Xen_GtkListStore_(gtk_list_store_newv(Xen_to_C_gint(n_columns), Xen_to_C_GType_(types))));
}

static Xen gxg_gtk_list_store_set_column_types(Xen list_store, Xen n_columns, Xen types)
{
  #define H_gtk_list_store_set_column_types "void gtk_list_store_set_column_types(GtkListStore* list_store, \
gint n_columns, GType* types)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_set_column_types", "GtkListStore*");
  Xen_check_type(Xen_is_gint(n_columns), n_columns, 2, "gtk_list_store_set_column_types", "gint");
  Xen_check_type(Xen_is_GType_(types), types, 3, "gtk_list_store_set_column_types", "GType*");
  gtk_list_store_set_column_types(Xen_to_C_GtkListStore_(list_store), Xen_to_C_gint(n_columns), Xen_to_C_GType_(types));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_set(Xen list_store, Xen iter, Xen values)
{
  #define H_gtk_list_store_set "void gtk_list_store_set(GtkListStore* list_store, GtkTreeIter* iter, \
etc values)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_set", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_set", "GtkTreeIter*");
  Xen_check_type(Xen_is_etc(values), values, 3, "gtk_list_store_set", "etc");
  {
    int etc_len = 0;
    GtkListStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (Xen_is_list(values)) etc_len = Xen_list_length(values);
    if (etc_len < 2) Xen_out_of_range_error("gtk_list_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_list_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_list_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkListStore_(list_store);
    p_arg1 = Xen_to_C_GtkTreeIter_(iter);
    switch (etc_len)
      {
        case 2: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), -1); break;
        case 4: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), -1); break;
        case 6: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), -1); break;
        case 8: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), -1); break;
        case 10: gtk_list_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), XLI(values, 8), XLS(values, 9), -1); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_list_store_insert(Xen list_store, Xen iter, Xen position)
{
  #define H_gtk_list_store_insert "void gtk_list_store_insert(GtkListStore* list_store, GtkTreeIter* iter, \
gint position)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_insert", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_insert", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_list_store_insert", "gint");
  gtk_list_store_insert(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_insert_before(Xen list_store, Xen iter, Xen sibling)
{
  #define H_gtk_list_store_insert_before "void gtk_list_store_insert_before(GtkListStore* list_store, \
GtkTreeIter* iter, GtkTreeIter* sibling)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_insert_before", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_insert_before", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(sibling) || Xen_is_false(sibling), sibling, 3, "gtk_list_store_insert_before", "GtkTreeIter*");
  gtk_list_store_insert_before(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(sibling));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_insert_after(Xen list_store, Xen iter, Xen sibling)
{
  #define H_gtk_list_store_insert_after "void gtk_list_store_insert_after(GtkListStore* list_store, GtkTreeIter* iter, \
GtkTreeIter* sibling)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_insert_after", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_insert_after", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(sibling) || Xen_is_false(sibling), sibling, 3, "gtk_list_store_insert_after", "GtkTreeIter*");
  gtk_list_store_insert_after(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(sibling));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_prepend(Xen list_store, Xen iter)
{
  #define H_gtk_list_store_prepend "void gtk_list_store_prepend(GtkListStore* list_store, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_prepend", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_prepend", "GtkTreeIter*");
  gtk_list_store_prepend(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_append(Xen list_store, Xen iter)
{
  #define H_gtk_list_store_append "void gtk_list_store_append(GtkListStore* list_store, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_append", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_append", "GtkTreeIter*");
  gtk_list_store_append(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_clear(Xen list_store)
{
  #define H_gtk_list_store_clear "void gtk_list_store_clear(GtkListStore* list_store)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_clear", "GtkListStore*");
  gtk_list_store_clear(Xen_to_C_GtkListStore_(list_store));
  return(Xen_false);
}

static Xen gxg_gtk_check_version(Xen required_major, Xen required_minor, Xen required_micro)
{
  #define H_gtk_check_version "gchar* gtk_check_version(guint required_major, guint required_minor, guint required_micro)"
  Xen_check_type(Xen_is_guint(required_major), required_major, 1, "gtk_check_version", "guint");
  Xen_check_type(Xen_is_guint(required_minor), required_minor, 2, "gtk_check_version", "guint");
  Xen_check_type(Xen_is_guint(required_micro), required_micro, 3, "gtk_check_version", "guint");
    return(C_to_Xen_gchar_((gchar*)gtk_check_version(Xen_to_C_guint(required_major), Xen_to_C_guint(required_minor), Xen_to_C_guint(required_micro))));
}

static Xen gxg_gtk_disable_setlocale(void)
{
  #define H_gtk_disable_setlocale "void gtk_disable_setlocale( void)"
  gtk_disable_setlocale();
  return(Xen_false);
}

static Xen gxg_gtk_get_default_language(void)
{
  #define H_gtk_get_default_language "PangoLanguage* gtk_get_default_language( void)"
  return(C_to_Xen_PangoLanguage_(gtk_get_default_language()));
}

static Xen gxg_gtk_events_pending(void)
{
  #define H_gtk_events_pending "gint gtk_events_pending( void)"
  return(C_to_Xen_gint(gtk_events_pending()));
}

static Xen gxg_gtk_main_do_event(Xen event)
{
  #define H_gtk_main_do_event "void gtk_main_do_event(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gtk_main_do_event", "GdkEvent*");
  gtk_main_do_event(Xen_to_C_GdkEvent_(event));
  return(Xen_false);
}

static Xen gxg_gtk_main(void)
{
  #define H_gtk_main "void gtk_main( void)"
  gtk_main();
  return(Xen_false);
}

static Xen gxg_gtk_main_level(void)
{
  #define H_gtk_main_level "guint gtk_main_level( void)"
  return(C_to_Xen_guint(gtk_main_level()));
}

static Xen gxg_gtk_main_quit(void)
{
  #define H_gtk_main_quit "void gtk_main_quit( void)"
  gtk_main_quit();
  return(Xen_false);
}

static Xen gxg_gtk_main_iteration(void)
{
  #define H_gtk_main_iteration "gboolean gtk_main_iteration( void)"
  return(C_to_Xen_gboolean(gtk_main_iteration()));
}

static Xen gxg_gtk_main_iteration_do(Xen blocking)
{
  #define H_gtk_main_iteration_do "gboolean gtk_main_iteration_do(gboolean blocking)"
  Xen_check_type(Xen_is_gboolean(blocking), blocking, 1, "gtk_main_iteration_do", "gboolean");
  return(C_to_Xen_gboolean(gtk_main_iteration_do(Xen_to_C_gboolean(blocking))));
}

static Xen gxg_gtk_true(void)
{
  #define H_gtk_true "gboolean gtk_true( void)"
  return(C_to_Xen_gboolean(gtk_true()));
}

static Xen gxg_gtk_false(void)
{
  #define H_gtk_false "gboolean gtk_false( void)"
  return(C_to_Xen_gboolean(gtk_false()));
}

static Xen gxg_gtk_grab_add(Xen widget)
{
  #define H_gtk_grab_add "void gtk_grab_add(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_grab_add", "GtkWidget*");
  gtk_grab_add(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_grab_get_current(void)
{
  #define H_gtk_grab_get_current "GtkWidget* gtk_grab_get_current( void)"
  return(C_to_Xen_GtkWidget_(gtk_grab_get_current()));
}

static Xen gxg_gtk_grab_remove(Xen widget)
{
  #define H_gtk_grab_remove "void gtk_grab_remove(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_grab_remove", "GtkWidget*");
  gtk_grab_remove(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_get_current_event(void)
{
  #define H_gtk_get_current_event "GdkEvent* gtk_get_current_event( void)"
  return(C_to_Xen_GdkEvent_(gtk_get_current_event()));
}

static Xen gxg_gtk_get_current_event_time(void)
{
  #define H_gtk_get_current_event_time "guint32 gtk_get_current_event_time( void)"
  return(C_to_Xen_guint32(gtk_get_current_event_time()));
}

static Xen gxg_gtk_get_current_event_state(Xen ignore_state)
{
  #define H_gtk_get_current_event_state "gboolean gtk_get_current_event_state(GdkModifierType* [state])"
  GdkModifierType ref_state;
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_get_current_event_state(&ref_state));
    return(Xen_list_2(result, C_to_Xen_GdkModifierType(ref_state)));
   }
}

static Xen gxg_gtk_get_event_widget(Xen event)
{
  #define H_gtk_get_event_widget "GtkWidget* gtk_get_event_widget(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event) || Xen_is_false(event), event, 1, "gtk_get_event_widget", "GdkEvent*");
  return(C_to_Xen_GtkWidget_(gtk_get_event_widget(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_propagate_event(Xen widget, Xen event)
{
  #define H_gtk_propagate_event "void gtk_propagate_event(GtkWidget* widget, GdkEvent* event)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_propagate_event", "GtkWidget*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_propagate_event", "GdkEvent*");
  gtk_propagate_event(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkEvent_(event));
  return(Xen_false);
}

static Xen gxg_gtk_menu_bar_new(void)
{
  #define H_gtk_menu_bar_new "GtkWidget* gtk_menu_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_menu_bar_new()));
}

static Xen gxg_gtk_menu_new(void)
{
  #define H_gtk_menu_new "GtkWidget* gtk_menu_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_menu_new()));
}

static Xen gxg_gtk_menu_reposition(Xen menu)
{
  #define H_gtk_menu_reposition "void gtk_menu_reposition(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_reposition", "GtkMenu*");
  gtk_menu_reposition(Xen_to_C_GtkMenu_(menu));
  return(Xen_false);
}

static Xen gxg_gtk_menu_popdown(Xen menu)
{
  #define H_gtk_menu_popdown "void gtk_menu_popdown(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_popdown", "GtkMenu*");
  gtk_menu_popdown(Xen_to_C_GtkMenu_(menu));
  return(Xen_false);
}

static Xen gxg_gtk_menu_get_active(Xen menu)
{
  #define H_gtk_menu_get_active "GtkWidget* gtk_menu_get_active(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_get_active", "GtkMenu*");
  return(C_to_Xen_GtkWidget_(gtk_menu_get_active(Xen_to_C_GtkMenu_(menu))));
}

static Xen gxg_gtk_menu_set_active(Xen menu, Xen index)
{
  #define H_gtk_menu_set_active "void gtk_menu_set_active(GtkMenu* menu, guint index)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_set_active", "GtkMenu*");
  Xen_check_type(Xen_is_guint(index), index, 2, "gtk_menu_set_active", "guint");
  gtk_menu_set_active(Xen_to_C_GtkMenu_(menu), Xen_to_C_guint(index));
  return(Xen_false);
}

static Xen gxg_gtk_menu_set_accel_group(Xen menu, Xen accel_group)
{
  #define H_gtk_menu_set_accel_group "void gtk_menu_set_accel_group(GtkMenu* menu, GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_set_accel_group", "GtkMenu*");
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group) || Xen_is_false(accel_group), accel_group, 2, "gtk_menu_set_accel_group", "GtkAccelGroup*");
  gtk_menu_set_accel_group(Xen_to_C_GtkMenu_(menu), Xen_to_C_GtkAccelGroup_(accel_group));
  return(Xen_false);
}

static Xen gxg_gtk_menu_get_accel_group(Xen menu)
{
  #define H_gtk_menu_get_accel_group "GtkAccelGroup* gtk_menu_get_accel_group(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_get_accel_group", "GtkMenu*");
  return(C_to_Xen_GtkAccelGroup_(gtk_menu_get_accel_group(Xen_to_C_GtkMenu_(menu))));
}

static Xen gxg_gtk_menu_set_accel_path(Xen menu, Xen accel_path)
{
  #define H_gtk_menu_set_accel_path "void gtk_menu_set_accel_path(GtkMenu* menu, gchar* accel_path)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_set_accel_path", "GtkMenu*");
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 2, "gtk_menu_set_accel_path", "gchar*");
  gtk_menu_set_accel_path(Xen_to_C_GtkMenu_(menu), Xen_to_C_gchar_(accel_path));
  return(Xen_false);
}

static Xen gxg_gtk_menu_detach(Xen menu)
{
  #define H_gtk_menu_detach "void gtk_menu_detach(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_detach", "GtkMenu*");
  gtk_menu_detach(Xen_to_C_GtkMenu_(menu));
  return(Xen_false);
}

static Xen gxg_gtk_menu_get_attach_widget(Xen menu)
{
  #define H_gtk_menu_get_attach_widget "GtkWidget* gtk_menu_get_attach_widget(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_get_attach_widget", "GtkMenu*");
  return(C_to_Xen_GtkWidget_(gtk_menu_get_attach_widget(Xen_to_C_GtkMenu_(menu))));
}

static Xen gxg_gtk_menu_reorder_child(Xen menu, Xen child, Xen position)
{
  #define H_gtk_menu_reorder_child "void gtk_menu_reorder_child(GtkMenu* menu, GtkWidget* child, gint position)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_reorder_child", "GtkMenu*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_menu_reorder_child", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_menu_reorder_child", "gint");
  gtk_menu_reorder_child(Xen_to_C_GtkMenu_(menu), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_menu_set_monitor(Xen menu, Xen monitor_num)
{
  #define H_gtk_menu_set_monitor "void gtk_menu_set_monitor(GtkMenu* menu, gint monitor_num)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_set_monitor", "GtkMenu*");
  Xen_check_type(Xen_is_gint(monitor_num), monitor_num, 2, "gtk_menu_set_monitor", "gint");
  gtk_menu_set_monitor(Xen_to_C_GtkMenu_(menu), Xen_to_C_gint(monitor_num));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_new(void)
{
  #define H_gtk_menu_item_new "GtkWidget* gtk_menu_item_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_menu_item_new()));
}

static Xen gxg_gtk_menu_item_new_with_label(Xen label)
{
  #define H_gtk_menu_item_new_with_label "GtkWidget* gtk_menu_item_new_with_label(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_menu_item_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_menu_item_new_with_label(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_menu_item_new_with_mnemonic(Xen label)
{
  #define H_gtk_menu_item_new_with_mnemonic "GtkWidget* gtk_menu_item_new_with_mnemonic(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_menu_item_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_menu_item_new_with_mnemonic(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_menu_item_set_submenu(Xen menu_item, Xen submenu)
{
  #define H_gtk_menu_item_set_submenu "void gtk_menu_item_set_submenu(GtkMenuItem* menu_item, GtkWidget* submenu)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_set_submenu", "GtkMenuItem*");
  Xen_check_type(Xen_is_GtkWidget_(submenu), submenu, 2, "gtk_menu_item_set_submenu", "GtkWidget*");
  gtk_menu_item_set_submenu(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_GtkWidget_(submenu));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_get_submenu(Xen menu_item)
{
  #define H_gtk_menu_item_get_submenu "GtkWidget* gtk_menu_item_get_submenu(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_get_submenu", "GtkMenuItem*");
  return(C_to_Xen_GtkWidget_(gtk_menu_item_get_submenu(Xen_to_C_GtkMenuItem_(menu_item))));
}

static Xen gxg_gtk_menu_item_select(Xen menu_item)
{
  #define H_gtk_menu_item_select "void gtk_menu_item_select(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_select", "GtkMenuItem*");
  gtk_menu_item_select(Xen_to_C_GtkMenuItem_(menu_item));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_deselect(Xen menu_item)
{
  #define H_gtk_menu_item_deselect "void gtk_menu_item_deselect(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_deselect", "GtkMenuItem*");
  gtk_menu_item_deselect(Xen_to_C_GtkMenuItem_(menu_item));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_activate(Xen menu_item)
{
  #define H_gtk_menu_item_activate "void gtk_menu_item_activate(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_activate", "GtkMenuItem*");
  gtk_menu_item_activate(Xen_to_C_GtkMenuItem_(menu_item));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_toggle_size_request(Xen menu_item, Xen requisition)
{
  #define H_gtk_menu_item_toggle_size_request "void gtk_menu_item_toggle_size_request(GtkMenuItem* menu_item, \
gint* requisition)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_toggle_size_request", "GtkMenuItem*");
  Xen_check_type(Xen_is_gint_(requisition), requisition, 2, "gtk_menu_item_toggle_size_request", "gint*");
  gtk_menu_item_toggle_size_request(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_gint_(requisition));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_toggle_size_allocate(Xen menu_item, Xen allocation)
{
  #define H_gtk_menu_item_toggle_size_allocate "void gtk_menu_item_toggle_size_allocate(GtkMenuItem* menu_item, \
gint allocation)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_toggle_size_allocate", "GtkMenuItem*");
  Xen_check_type(Xen_is_gint(allocation), allocation, 2, "gtk_menu_item_toggle_size_allocate", "gint");
  gtk_menu_item_toggle_size_allocate(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_gint(allocation));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_set_accel_path(Xen menu_item, Xen accel_path)
{
  #define H_gtk_menu_item_set_accel_path "void gtk_menu_item_set_accel_path(GtkMenuItem* menu_item, gchar* accel_path)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_set_accel_path", "GtkMenuItem*");
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 2, "gtk_menu_item_set_accel_path", "gchar*");
  gtk_menu_item_set_accel_path(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_gchar_(accel_path));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_append(Xen menu_shell, Xen child)
{
  #define H_gtk_menu_shell_append "void gtk_menu_shell_append(GtkMenuShell* menu_shell, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_append", "GtkMenuShell*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_menu_shell_append", "GtkWidget*");
  gtk_menu_shell_append(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_prepend(Xen menu_shell, Xen child)
{
  #define H_gtk_menu_shell_prepend "void gtk_menu_shell_prepend(GtkMenuShell* menu_shell, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_prepend", "GtkMenuShell*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_menu_shell_prepend", "GtkWidget*");
  gtk_menu_shell_prepend(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_insert(Xen menu_shell, Xen child, Xen position)
{
  #define H_gtk_menu_shell_insert "void gtk_menu_shell_insert(GtkMenuShell* menu_shell, GtkWidget* child, \
gint position)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_insert", "GtkMenuShell*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_menu_shell_insert", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_menu_shell_insert", "gint");
  gtk_menu_shell_insert(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_deactivate(Xen menu_shell)
{
  #define H_gtk_menu_shell_deactivate "void gtk_menu_shell_deactivate(GtkMenuShell* menu_shell)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_deactivate", "GtkMenuShell*");
  gtk_menu_shell_deactivate(Xen_to_C_GtkMenuShell_(menu_shell));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_select_item(Xen menu_shell, Xen menu_item)
{
  #define H_gtk_menu_shell_select_item "void gtk_menu_shell_select_item(GtkMenuShell* menu_shell, GtkWidget* menu_item)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_select_item", "GtkMenuShell*");
  Xen_check_type(Xen_is_GtkWidget_(menu_item), menu_item, 2, "gtk_menu_shell_select_item", "GtkWidget*");
  gtk_menu_shell_select_item(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_GtkWidget_(menu_item));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_deselect(Xen menu_shell)
{
  #define H_gtk_menu_shell_deselect "void gtk_menu_shell_deselect(GtkMenuShell* menu_shell)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_deselect", "GtkMenuShell*");
  gtk_menu_shell_deselect(Xen_to_C_GtkMenuShell_(menu_shell));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_activate_item(Xen menu_shell, Xen menu_item, Xen force_deactivate)
{
  #define H_gtk_menu_shell_activate_item "void gtk_menu_shell_activate_item(GtkMenuShell* menu_shell, \
GtkWidget* menu_item, gboolean force_deactivate)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_activate_item", "GtkMenuShell*");
  Xen_check_type(Xen_is_GtkWidget_(menu_item), menu_item, 2, "gtk_menu_shell_activate_item", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(force_deactivate), force_deactivate, 3, "gtk_menu_shell_activate_item", "gboolean");
  gtk_menu_shell_activate_item(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_GtkWidget_(menu_item), Xen_to_C_gboolean(force_deactivate));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_new(void)
{
  #define H_gtk_notebook_new "GtkWidget* gtk_notebook_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_notebook_new()));
}

static Xen gxg_gtk_notebook_remove_page(Xen notebook, Xen page_num)
{
  #define H_gtk_notebook_remove_page "void gtk_notebook_remove_page(GtkNotebook* notebook, gint page_num)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_remove_page", "GtkNotebook*");
  Xen_check_type(Xen_is_gint(page_num), page_num, 2, "gtk_notebook_remove_page", "gint");
  gtk_notebook_remove_page(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_gint(page_num));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_current_page(Xen notebook)
{
  #define H_gtk_notebook_get_current_page "gint gtk_notebook_get_current_page(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_current_page", "GtkNotebook*");
  return(C_to_Xen_gint(gtk_notebook_get_current_page(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_notebook_get_nth_page(Xen notebook, Xen page_num)
{
  #define H_gtk_notebook_get_nth_page "GtkWidget* gtk_notebook_get_nth_page(GtkNotebook* notebook, gint page_num)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_nth_page", "GtkNotebook*");
  Xen_check_type(Xen_is_gint(page_num), page_num, 2, "gtk_notebook_get_nth_page", "gint");
  return(C_to_Xen_GtkWidget_(gtk_notebook_get_nth_page(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_gint(page_num))));
}

static Xen gxg_gtk_notebook_page_num(Xen notebook, Xen child)
{
  #define H_gtk_notebook_page_num "gint gtk_notebook_page_num(GtkNotebook* notebook, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_page_num", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_page_num", "GtkWidget*");
  return(C_to_Xen_gint(gtk_notebook_page_num(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_set_current_page(Xen notebook, Xen page_num)
{
  #define H_gtk_notebook_set_current_page "void gtk_notebook_set_current_page(GtkNotebook* notebook, \
gint page_num)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_current_page", "GtkNotebook*");
  Xen_check_type(Xen_is_gint(page_num), page_num, 2, "gtk_notebook_set_current_page", "gint");
  gtk_notebook_set_current_page(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_gint(page_num));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_next_page(Xen notebook)
{
  #define H_gtk_notebook_next_page "void gtk_notebook_next_page(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_next_page", "GtkNotebook*");
  gtk_notebook_next_page(Xen_to_C_GtkNotebook_(notebook));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_prev_page(Xen notebook)
{
  #define H_gtk_notebook_prev_page "void gtk_notebook_prev_page(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_prev_page", "GtkNotebook*");
  gtk_notebook_prev_page(Xen_to_C_GtkNotebook_(notebook));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_set_show_border(Xen notebook, Xen show_border)
{
  #define H_gtk_notebook_set_show_border "void gtk_notebook_set_show_border(GtkNotebook* notebook, gboolean show_border)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_show_border", "GtkNotebook*");
  Xen_check_type(Xen_is_gboolean(show_border), show_border, 2, "gtk_notebook_set_show_border", "gboolean");
  gtk_notebook_set_show_border(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_gboolean(show_border));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_show_border(Xen notebook)
{
  #define H_gtk_notebook_get_show_border "gboolean gtk_notebook_get_show_border(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_show_border", "GtkNotebook*");
  return(C_to_Xen_gboolean(gtk_notebook_get_show_border(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_notebook_set_show_tabs(Xen notebook, Xen show_tabs)
{
  #define H_gtk_notebook_set_show_tabs "void gtk_notebook_set_show_tabs(GtkNotebook* notebook, gboolean show_tabs)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_show_tabs", "GtkNotebook*");
  Xen_check_type(Xen_is_gboolean(show_tabs), show_tabs, 2, "gtk_notebook_set_show_tabs", "gboolean");
  gtk_notebook_set_show_tabs(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_gboolean(show_tabs));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_show_tabs(Xen notebook)
{
  #define H_gtk_notebook_get_show_tabs "gboolean gtk_notebook_get_show_tabs(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_show_tabs", "GtkNotebook*");
  return(C_to_Xen_gboolean(gtk_notebook_get_show_tabs(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_notebook_set_tab_pos(Xen notebook, Xen pos)
{
  #define H_gtk_notebook_set_tab_pos "void gtk_notebook_set_tab_pos(GtkNotebook* notebook, GtkPositionType pos)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_tab_pos", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkPositionType(pos), pos, 2, "gtk_notebook_set_tab_pos", "GtkPositionType");
  gtk_notebook_set_tab_pos(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkPositionType(pos));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_tab_pos(Xen notebook)
{
  #define H_gtk_notebook_get_tab_pos "GtkPositionType gtk_notebook_get_tab_pos(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_tab_pos", "GtkNotebook*");
  return(C_to_Xen_GtkPositionType(gtk_notebook_get_tab_pos(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_notebook_set_scrollable(Xen notebook, Xen scrollable)
{
  #define H_gtk_notebook_set_scrollable "void gtk_notebook_set_scrollable(GtkNotebook* notebook, gboolean scrollable)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_scrollable", "GtkNotebook*");
  Xen_check_type(Xen_is_gboolean(scrollable), scrollable, 2, "gtk_notebook_set_scrollable", "gboolean");
  gtk_notebook_set_scrollable(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_gboolean(scrollable));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_scrollable(Xen notebook)
{
  #define H_gtk_notebook_get_scrollable "gboolean gtk_notebook_get_scrollable(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_scrollable", "GtkNotebook*");
  return(C_to_Xen_gboolean(gtk_notebook_get_scrollable(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_notebook_popup_enable(Xen notebook)
{
  #define H_gtk_notebook_popup_enable "void gtk_notebook_popup_enable(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_popup_enable", "GtkNotebook*");
  gtk_notebook_popup_enable(Xen_to_C_GtkNotebook_(notebook));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_popup_disable(Xen notebook)
{
  #define H_gtk_notebook_popup_disable "void gtk_notebook_popup_disable(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_popup_disable", "GtkNotebook*");
  gtk_notebook_popup_disable(Xen_to_C_GtkNotebook_(notebook));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_tab_label(Xen notebook, Xen child)
{
  #define H_gtk_notebook_get_tab_label "GtkWidget* gtk_notebook_get_tab_label(GtkNotebook* notebook, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_tab_label", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_get_tab_label", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_notebook_get_tab_label(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_set_tab_label(Xen notebook, Xen child, Xen tab_label)
{
  #define H_gtk_notebook_set_tab_label "void gtk_notebook_set_tab_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_tab_label", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_set_tab_label", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_set_tab_label", "GtkWidget*");
  gtk_notebook_set_tab_label(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_set_tab_label_text(Xen notebook, Xen child, Xen tab_text)
{
  #define H_gtk_notebook_set_tab_label_text "void gtk_notebook_set_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* tab_text)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_tab_label_text", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_set_tab_label_text", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(tab_text), tab_text, 3, "gtk_notebook_set_tab_label_text", "gchar*");
  gtk_notebook_set_tab_label_text(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_gchar_(tab_text));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_tab_label_text(Xen notebook, Xen child)
{
  #define H_gtk_notebook_get_tab_label_text "gchar* gtk_notebook_get_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_tab_label_text", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_get_tab_label_text", "GtkWidget*");
  return(C_to_Xen_gchar_(gtk_notebook_get_tab_label_text(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_get_menu_label(Xen notebook, Xen child)
{
  #define H_gtk_notebook_get_menu_label "GtkWidget* gtk_notebook_get_menu_label(GtkNotebook* notebook, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_menu_label", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_get_menu_label", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_notebook_get_menu_label(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_set_menu_label(Xen notebook, Xen child, Xen menu_label)
{
  #define H_gtk_notebook_set_menu_label "void gtk_notebook_set_menu_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* menu_label)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_menu_label", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_set_menu_label", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(menu_label), menu_label, 3, "gtk_notebook_set_menu_label", "GtkWidget*");
  gtk_notebook_set_menu_label(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(menu_label));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_set_menu_label_text(Xen notebook, Xen child, Xen menu_text)
{
  #define H_gtk_notebook_set_menu_label_text "void gtk_notebook_set_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* menu_text)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_menu_label_text", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_set_menu_label_text", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(menu_text), menu_text, 3, "gtk_notebook_set_menu_label_text", "gchar*");
  gtk_notebook_set_menu_label_text(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_gchar_(menu_text));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_menu_label_text(Xen notebook, Xen child)
{
  #define H_gtk_notebook_get_menu_label_text "gchar* gtk_notebook_get_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_menu_label_text", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_get_menu_label_text", "GtkWidget*");
  return(C_to_Xen_gchar_(gtk_notebook_get_menu_label_text(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_reorder_child(Xen notebook, Xen child, Xen position)
{
  #define H_gtk_notebook_reorder_child "void gtk_notebook_reorder_child(GtkNotebook* notebook, GtkWidget* child, \
gint position)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_reorder_child", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_reorder_child", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_notebook_reorder_child", "gint");
  gtk_notebook_reorder_child(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_append_page(Xen notebook, Xen child, Xen tab_label)
{
  #define H_gtk_notebook_append_page "gint gtk_notebook_append_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_append_page", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_append_page", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_append_page", "GtkWidget*");
  return(C_to_Xen_gint(gtk_notebook_append_page(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label))));
}

static Xen gxg_gtk_notebook_append_page_menu(Xen notebook, Xen child, Xen tab_label, Xen menu_label)
{
  #define H_gtk_notebook_append_page_menu "gint gtk_notebook_append_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_append_page_menu", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_append_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_append_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(menu_label) || Xen_is_false(menu_label), menu_label, 4, "gtk_notebook_append_page_menu", "GtkWidget*");
  return(C_to_Xen_gint(gtk_notebook_append_page_menu(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label), 
                                                     Xen_to_C_GtkWidget_(menu_label))));
}

static Xen gxg_gtk_notebook_prepend_page(Xen notebook, Xen child, Xen tab_label)
{
  #define H_gtk_notebook_prepend_page "gint gtk_notebook_prepend_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_prepend_page", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_prepend_page", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_prepend_page", "GtkWidget*");
  return(C_to_Xen_gint(gtk_notebook_prepend_page(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label))));
}

static Xen gxg_gtk_notebook_prepend_page_menu(Xen notebook, Xen child, Xen tab_label, Xen menu_label)
{
  #define H_gtk_notebook_prepend_page_menu "gint gtk_notebook_prepend_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_prepend_page_menu", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_prepend_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_prepend_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(menu_label) || Xen_is_false(menu_label), menu_label, 4, "gtk_notebook_prepend_page_menu", "GtkWidget*");
  return(C_to_Xen_gint(gtk_notebook_prepend_page_menu(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label), 
                                                      Xen_to_C_GtkWidget_(menu_label))));
}

static Xen gxg_gtk_notebook_insert_page(Xen notebook, Xen child, Xen tab_label, Xen position)
{
  #define H_gtk_notebook_insert_page "gint gtk_notebook_insert_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label, gint position)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_insert_page", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_insert_page", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_insert_page", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 4, "gtk_notebook_insert_page", "gint");
  return(C_to_Xen_gint(gtk_notebook_insert_page(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label), 
                                                Xen_to_C_gint(position))));
}

static Xen gxg_gtk_notebook_insert_page_menu(Xen notebook, Xen child, Xen tab_label, Xen menu_label, Xen position)
{
  #define H_gtk_notebook_insert_page_menu "gint gtk_notebook_insert_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label, gint position)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_insert_page_menu", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_insert_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(tab_label) || Xen_is_false(tab_label), tab_label, 3, "gtk_notebook_insert_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(menu_label) || Xen_is_false(menu_label), menu_label, 4, "gtk_notebook_insert_page_menu", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 5, "gtk_notebook_insert_page_menu", "gint");
  return(C_to_Xen_gint(gtk_notebook_insert_page_menu(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(tab_label), 
                                                     Xen_to_C_GtkWidget_(menu_label), Xen_to_C_gint(position))));
}

static Xen gxg_gtk_paned_add1(Xen paned, Xen child)
{
  #define H_gtk_paned_add1 "void gtk_paned_add1(GtkPaned* paned, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_add1", "GtkPaned*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_paned_add1", "GtkWidget*");
  gtk_paned_add1(Xen_to_C_GtkPaned_(paned), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_paned_add2(Xen paned, Xen child)
{
  #define H_gtk_paned_add2 "void gtk_paned_add2(GtkPaned* paned, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_add2", "GtkPaned*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_paned_add2", "GtkWidget*");
  gtk_paned_add2(Xen_to_C_GtkPaned_(paned), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_paned_pack1(Xen paned, Xen child, Xen resize, Xen shrink)
{
  #define H_gtk_paned_pack1 "void gtk_paned_pack1(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_pack1", "GtkPaned*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_paned_pack1", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(resize), resize, 3, "gtk_paned_pack1", "gboolean");
  Xen_check_type(Xen_is_gboolean(shrink), shrink, 4, "gtk_paned_pack1", "gboolean");
  gtk_paned_pack1(Xen_to_C_GtkPaned_(paned), Xen_to_C_GtkWidget_(child), Xen_to_C_gboolean(resize), Xen_to_C_gboolean(shrink));
  return(Xen_false);
}

static Xen gxg_gtk_paned_pack2(Xen paned, Xen child, Xen resize, Xen shrink)
{
  #define H_gtk_paned_pack2 "void gtk_paned_pack2(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_pack2", "GtkPaned*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_paned_pack2", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(resize), resize, 3, "gtk_paned_pack2", "gboolean");
  Xen_check_type(Xen_is_gboolean(shrink), shrink, 4, "gtk_paned_pack2", "gboolean");
  gtk_paned_pack2(Xen_to_C_GtkPaned_(paned), Xen_to_C_GtkWidget_(child), Xen_to_C_gboolean(resize), Xen_to_C_gboolean(shrink));
  return(Xen_false);
}

static Xen gxg_gtk_paned_get_position(Xen paned)
{
  #define H_gtk_paned_get_position "gint gtk_paned_get_position(GtkPaned* paned)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_get_position", "GtkPaned*");
  return(C_to_Xen_gint(gtk_paned_get_position(Xen_to_C_GtkPaned_(paned))));
}

static Xen gxg_gtk_paned_set_position(Xen paned, Xen position)
{
  #define H_gtk_paned_set_position "void gtk_paned_set_position(GtkPaned* paned, gint position)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_set_position", "GtkPaned*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_paned_set_position", "gint");
  gtk_paned_set_position(Xen_to_C_GtkPaned_(paned), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_new(void)
{
  #define H_gtk_progress_bar_new "GtkWidget* gtk_progress_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_progress_bar_new()));
}

static Xen gxg_gtk_progress_bar_pulse(Xen pbar)
{
  #define H_gtk_progress_bar_pulse "void gtk_progress_bar_pulse(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_pulse", "GtkProgressBar*");
  gtk_progress_bar_pulse(Xen_to_C_GtkProgressBar_(pbar));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_set_text(Xen pbar, Xen text)
{
  #define H_gtk_progress_bar_set_text "void gtk_progress_bar_set_text(GtkProgressBar* pbar, gchar* text)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_set_text", "GtkProgressBar*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_progress_bar_set_text", "gchar*");
  gtk_progress_bar_set_text(Xen_to_C_GtkProgressBar_(pbar), Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_set_fraction(Xen pbar, Xen fraction)
{
  #define H_gtk_progress_bar_set_fraction "void gtk_progress_bar_set_fraction(GtkProgressBar* pbar, gdouble fraction)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_set_fraction", "GtkProgressBar*");
  Xen_check_type(Xen_is_gdouble(fraction), fraction, 2, "gtk_progress_bar_set_fraction", "gdouble");
  gtk_progress_bar_set_fraction(Xen_to_C_GtkProgressBar_(pbar), Xen_to_C_gdouble(fraction));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_set_pulse_step(Xen pbar, Xen fraction)
{
  #define H_gtk_progress_bar_set_pulse_step "void gtk_progress_bar_set_pulse_step(GtkProgressBar* pbar, \
gdouble fraction)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_set_pulse_step", "GtkProgressBar*");
  Xen_check_type(Xen_is_gdouble(fraction), fraction, 2, "gtk_progress_bar_set_pulse_step", "gdouble");
  gtk_progress_bar_set_pulse_step(Xen_to_C_GtkProgressBar_(pbar), Xen_to_C_gdouble(fraction));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_get_text(Xen pbar)
{
  #define H_gtk_progress_bar_get_text "gchar* gtk_progress_bar_get_text(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_get_text", "GtkProgressBar*");
  return(C_to_Xen_gchar_(gtk_progress_bar_get_text(Xen_to_C_GtkProgressBar_(pbar))));
}

static Xen gxg_gtk_progress_bar_get_fraction(Xen pbar)
{
  #define H_gtk_progress_bar_get_fraction "gdouble gtk_progress_bar_get_fraction(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_get_fraction", "GtkProgressBar*");
  return(C_to_Xen_gdouble(gtk_progress_bar_get_fraction(Xen_to_C_GtkProgressBar_(pbar))));
}

static Xen gxg_gtk_progress_bar_get_pulse_step(Xen pbar)
{
  #define H_gtk_progress_bar_get_pulse_step "gdouble gtk_progress_bar_get_pulse_step(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_get_pulse_step", "GtkProgressBar*");
  return(C_to_Xen_gdouble(gtk_progress_bar_get_pulse_step(Xen_to_C_GtkProgressBar_(pbar))));
}

static Xen gxg_gtk_radio_button_new(Xen group)
{
  #define H_gtk_radio_button_new "GtkWidget* gtk_radio_button_new(GSList* group)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_button_new", "GSList*");
  return(C_to_Xen_GtkWidget_(gtk_radio_button_new(Xen_to_C_GSList_(group))));
}

static Xen gxg_gtk_radio_button_new_from_widget(Xen group)
{
  #define H_gtk_radio_button_new_from_widget "GtkWidget* gtk_radio_button_new_from_widget(GtkRadioButton* group)"
  Xen_check_type(Xen_is_GtkRadioButton_(group), group, 1, "gtk_radio_button_new_from_widget", "GtkRadioButton*");
  return(C_to_Xen_GtkWidget_(gtk_radio_button_new_from_widget(Xen_to_C_GtkRadioButton_(group))));
}

static Xen gxg_gtk_radio_button_new_with_label(Xen group, Xen label)
{
  #define H_gtk_radio_button_new_with_label "GtkWidget* gtk_radio_button_new_with_label(GSList* group, \
gchar* label)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_button_new_with_label", "GSList*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_button_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_button_new_with_label(Xen_to_C_GSList_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_button_new_with_label_from_widget(Xen group, Xen label)
{
  #define H_gtk_radio_button_new_with_label_from_widget "GtkWidget* gtk_radio_button_new_with_label_from_widget(GtkRadioButton* group, \
gchar* label)"
  Xen_check_type(Xen_is_GtkRadioButton_(group), group, 1, "gtk_radio_button_new_with_label_from_widget", "GtkRadioButton*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_button_new_with_label_from_widget", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_button_new_with_label_from_widget(Xen_to_C_GtkRadioButton_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_button_new_with_mnemonic(Xen group, Xen label)
{
  #define H_gtk_radio_button_new_with_mnemonic "GtkWidget* gtk_radio_button_new_with_mnemonic(GSList* group, \
gchar* label)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_button_new_with_mnemonic", "GSList*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_button_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_button_new_with_mnemonic(Xen_to_C_GSList_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_button_new_with_mnemonic_from_widget(Xen group, Xen label)
{
  #define H_gtk_radio_button_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_button_new_with_mnemonic_from_widget(GtkRadioButton* group, \
gchar* label)"
  Xen_check_type(Xen_is_GtkRadioButton_(group), group, 1, "gtk_radio_button_new_with_mnemonic_from_widget", "GtkRadioButton*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_button_new_with_mnemonic_from_widget", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_button_new_with_mnemonic_from_widget(Xen_to_C_GtkRadioButton_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_button_get_group(Xen radio_button)
{
  #define H_gtk_radio_button_get_group "GSList* gtk_radio_button_get_group(GtkRadioButton* radio_button)"
  Xen_check_type(Xen_is_GtkRadioButton_(radio_button), radio_button, 1, "gtk_radio_button_get_group", "GtkRadioButton*");
  return(C_to_Xen_GSList_(gtk_radio_button_get_group(Xen_to_C_GtkRadioButton_(radio_button))));
}

static Xen gxg_gtk_radio_button_set_group(Xen radio_button, Xen group)
{
  #define H_gtk_radio_button_set_group "void gtk_radio_button_set_group(GtkRadioButton* radio_button, \
GSList* group)"
  Xen_check_type(Xen_is_GtkRadioButton_(radio_button), radio_button, 1, "gtk_radio_button_set_group", "GtkRadioButton*");
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 2, "gtk_radio_button_set_group", "GSList*");
  gtk_radio_button_set_group(Xen_to_C_GtkRadioButton_(radio_button), Xen_to_C_GSList_(group));
  return(Xen_false);
}

static Xen gxg_gtk_radio_menu_item_new(Xen group)
{
  #define H_gtk_radio_menu_item_new "GtkWidget* gtk_radio_menu_item_new(GSList* group)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_menu_item_new", "GSList*");
  return(C_to_Xen_GtkWidget_(gtk_radio_menu_item_new(Xen_to_C_GSList_(group))));
}

static Xen gxg_gtk_radio_menu_item_new_with_label(Xen group, Xen label)
{
  #define H_gtk_radio_menu_item_new_with_label "GtkWidget* gtk_radio_menu_item_new_with_label(GSList* group, \
gchar* label)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_menu_item_new_with_label", "GSList*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_menu_item_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_menu_item_new_with_label(Xen_to_C_GSList_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_menu_item_new_with_mnemonic(Xen group, Xen label)
{
  #define H_gtk_radio_menu_item_new_with_mnemonic "GtkWidget* gtk_radio_menu_item_new_with_mnemonic(GSList* group, \
gchar* label)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_menu_item_new_with_mnemonic", "GSList*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_menu_item_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_menu_item_new_with_mnemonic(Xen_to_C_GSList_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_menu_item_get_group(Xen radio_menu_item)
{
  #define H_gtk_radio_menu_item_get_group "GSList* gtk_radio_menu_item_get_group(GtkRadioMenuItem* radio_menu_item)"
  Xen_check_type(Xen_is_GtkRadioMenuItem_(radio_menu_item), radio_menu_item, 1, "gtk_radio_menu_item_get_group", "GtkRadioMenuItem*");
  return(C_to_Xen_GSList_(gtk_radio_menu_item_get_group(Xen_to_C_GtkRadioMenuItem_(radio_menu_item))));
}

static Xen gxg_gtk_radio_menu_item_set_group(Xen radio_menu_item, Xen group)
{
  #define H_gtk_radio_menu_item_set_group "void gtk_radio_menu_item_set_group(GtkRadioMenuItem* radio_menu_item, \
GSList* group)"
  Xen_check_type(Xen_is_GtkRadioMenuItem_(radio_menu_item), radio_menu_item, 1, "gtk_radio_menu_item_set_group", "GtkRadioMenuItem*");
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 2, "gtk_radio_menu_item_set_group", "GSList*");
  gtk_radio_menu_item_set_group(Xen_to_C_GtkRadioMenuItem_(radio_menu_item), Xen_to_C_GSList_(group));
  return(Xen_false);
}

static Xen gxg_gtk_range_set_adjustment(Xen range, Xen adjustment)
{
  #define H_gtk_range_set_adjustment "void gtk_range_set_adjustment(GtkRange* range, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_adjustment", "GtkRange*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment) || Xen_is_false(adjustment), adjustment, 2, "gtk_range_set_adjustment", "GtkAdjustment*");
  gtk_range_set_adjustment(Xen_to_C_GtkRange_(range), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_adjustment(Xen range)
{
  #define H_gtk_range_get_adjustment "GtkAdjustment* gtk_range_get_adjustment(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_adjustment", "GtkRange*");
  return(C_to_Xen_GtkAdjustment_(gtk_range_get_adjustment(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_range_set_inverted(Xen range, Xen setting)
{
  #define H_gtk_range_set_inverted "void gtk_range_set_inverted(GtkRange* range, gboolean setting)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_inverted", "GtkRange*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_range_set_inverted", "gboolean");
  gtk_range_set_inverted(Xen_to_C_GtkRange_(range), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_inverted(Xen range)
{
  #define H_gtk_range_get_inverted "gboolean gtk_range_get_inverted(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_inverted", "GtkRange*");
  return(C_to_Xen_gboolean(gtk_range_get_inverted(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_range_set_increments(Xen range, Xen step, Xen page)
{
  #define H_gtk_range_set_increments "void gtk_range_set_increments(GtkRange* range, gdouble step, gdouble page)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_increments", "GtkRange*");
  Xen_check_type(Xen_is_gdouble(step), step, 2, "gtk_range_set_increments", "gdouble");
  Xen_check_type(Xen_is_gdouble(page), page, 3, "gtk_range_set_increments", "gdouble");
  gtk_range_set_increments(Xen_to_C_GtkRange_(range), Xen_to_C_gdouble(step), Xen_to_C_gdouble(page));
  return(Xen_false);
}

static Xen gxg_gtk_range_set_range(Xen range, Xen min, Xen max)
{
  #define H_gtk_range_set_range "void gtk_range_set_range(GtkRange* range, gdouble min, gdouble max)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_range", "GtkRange*");
  Xen_check_type(Xen_is_gdouble(min), min, 2, "gtk_range_set_range", "gdouble");
  Xen_check_type(Xen_is_gdouble(max), max, 3, "gtk_range_set_range", "gdouble");
  gtk_range_set_range(Xen_to_C_GtkRange_(range), Xen_to_C_gdouble(min), Xen_to_C_gdouble(max));
  return(Xen_false);
}

static Xen gxg_gtk_range_set_value(Xen range, Xen value)
{
  #define H_gtk_range_set_value "void gtk_range_set_value(GtkRange* range, gdouble value)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_value", "GtkRange*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_range_set_value", "gdouble");
  gtk_range_set_value(Xen_to_C_GtkRange_(range), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_value(Xen range)
{
  #define H_gtk_range_get_value "gdouble gtk_range_get_value(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_value", "GtkRange*");
  return(C_to_Xen_gdouble(gtk_range_get_value(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_scale_set_digits(Xen scale, Xen digits)
{
  #define H_gtk_scale_set_digits "void gtk_scale_set_digits(GtkScale* scale, gint digits)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_set_digits", "GtkScale*");
  Xen_check_type(Xen_is_gint(digits), digits, 2, "gtk_scale_set_digits", "gint");
  gtk_scale_set_digits(Xen_to_C_GtkScale_(scale), Xen_to_C_gint(digits));
  return(Xen_false);
}

static Xen gxg_gtk_scale_get_digits(Xen scale)
{
  #define H_gtk_scale_get_digits "gint gtk_scale_get_digits(GtkScale* scale)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_get_digits", "GtkScale*");
  return(C_to_Xen_gint(gtk_scale_get_digits(Xen_to_C_GtkScale_(scale))));
}

static Xen gxg_gtk_scale_set_draw_value(Xen scale, Xen draw_value)
{
  #define H_gtk_scale_set_draw_value "void gtk_scale_set_draw_value(GtkScale* scale, gboolean draw_value)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_set_draw_value", "GtkScale*");
  Xen_check_type(Xen_is_gboolean(draw_value), draw_value, 2, "gtk_scale_set_draw_value", "gboolean");
  gtk_scale_set_draw_value(Xen_to_C_GtkScale_(scale), Xen_to_C_gboolean(draw_value));
  return(Xen_false);
}

static Xen gxg_gtk_scale_get_draw_value(Xen scale)
{
  #define H_gtk_scale_get_draw_value "gboolean gtk_scale_get_draw_value(GtkScale* scale)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_get_draw_value", "GtkScale*");
  return(C_to_Xen_gboolean(gtk_scale_get_draw_value(Xen_to_C_GtkScale_(scale))));
}

static Xen gxg_gtk_scale_set_value_pos(Xen scale, Xen pos)
{
  #define H_gtk_scale_set_value_pos "void gtk_scale_set_value_pos(GtkScale* scale, GtkPositionType pos)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_set_value_pos", "GtkScale*");
  Xen_check_type(Xen_is_GtkPositionType(pos), pos, 2, "gtk_scale_set_value_pos", "GtkPositionType");
  gtk_scale_set_value_pos(Xen_to_C_GtkScale_(scale), Xen_to_C_GtkPositionType(pos));
  return(Xen_false);
}

static Xen gxg_gtk_scale_get_value_pos(Xen scale)
{
  #define H_gtk_scale_get_value_pos "GtkPositionType gtk_scale_get_value_pos(GtkScale* scale)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_get_value_pos", "GtkScale*");
  return(C_to_Xen_GtkPositionType(gtk_scale_get_value_pos(Xen_to_C_GtkScale_(scale))));
}

static Xen gxg_gtk_scrolled_window_new(Xen hadjustment, Xen vadjustment)
{
  #define H_gtk_scrolled_window_new "GtkWidget* gtk_scrolled_window_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(hadjustment) || Xen_is_false(hadjustment), hadjustment, 1, "gtk_scrolled_window_new", "GtkAdjustment*");
  Xen_check_type(Xen_is_GtkAdjustment_(vadjustment) || Xen_is_false(vadjustment), vadjustment, 2, "gtk_scrolled_window_new", "GtkAdjustment*");
  return(C_to_Xen_GtkWidget_(gtk_scrolled_window_new(Xen_to_C_GtkAdjustment_(hadjustment), Xen_to_C_GtkAdjustment_(vadjustment))));
}

static Xen gxg_gtk_scrolled_window_set_hadjustment(Xen scrolled_window, Xen hadjustment)
{
  #define H_gtk_scrolled_window_set_hadjustment "void gtk_scrolled_window_set_hadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_hadjustment", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_GtkAdjustment_(hadjustment) || Xen_is_false(hadjustment), hadjustment, 2, "gtk_scrolled_window_set_hadjustment", "GtkAdjustment*");
  gtk_scrolled_window_set_hadjustment(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_GtkAdjustment_(hadjustment));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_set_vadjustment(Xen scrolled_window, Xen hadjustment)
{
  #define H_gtk_scrolled_window_set_vadjustment "void gtk_scrolled_window_set_vadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_vadjustment", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_GtkAdjustment_(hadjustment) || Xen_is_false(hadjustment), hadjustment, 2, "gtk_scrolled_window_set_vadjustment", "GtkAdjustment*");
  gtk_scrolled_window_set_vadjustment(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_GtkAdjustment_(hadjustment));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_hadjustment(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_hadjustment "GtkAdjustment* gtk_scrolled_window_get_hadjustment(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_hadjustment", "GtkScrolledWindow*");
  return(C_to_Xen_GtkAdjustment_(gtk_scrolled_window_get_hadjustment(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_get_vadjustment(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_vadjustment "GtkAdjustment* gtk_scrolled_window_get_vadjustment(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_vadjustment", "GtkScrolledWindow*");
  return(C_to_Xen_GtkAdjustment_(gtk_scrolled_window_get_vadjustment(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_set_policy(Xen scrolled_window, Xen hscrollbar_policy, Xen vscrollbar_policy)
{
  #define H_gtk_scrolled_window_set_policy "void gtk_scrolled_window_set_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType hscrollbar_policy, GtkPolicyType vscrollbar_policy)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_policy", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_GtkPolicyType(hscrollbar_policy), hscrollbar_policy, 2, "gtk_scrolled_window_set_policy", "GtkPolicyType");
  Xen_check_type(Xen_is_GtkPolicyType(vscrollbar_policy), vscrollbar_policy, 3, "gtk_scrolled_window_set_policy", "GtkPolicyType");
  gtk_scrolled_window_set_policy(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_GtkPolicyType(hscrollbar_policy), 
                                 Xen_to_C_GtkPolicyType(vscrollbar_policy));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_policy(Xen scrolled_window, Xen ignore_hscrollbar_policy, Xen ignore_vscrollbar_policy)
{
  #define H_gtk_scrolled_window_get_policy "void gtk_scrolled_window_get_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType* [hscrollbar_policy], GtkPolicyType* [vscrollbar_policy])"
  GtkPolicyType ref_hscrollbar_policy;
  GtkPolicyType ref_vscrollbar_policy;
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_policy", "GtkScrolledWindow*");
  gtk_scrolled_window_get_policy(Xen_to_C_GtkScrolledWindow_(scrolled_window), &ref_hscrollbar_policy, &ref_vscrollbar_policy);
  return(Xen_list_2(C_to_Xen_GtkPolicyType(ref_hscrollbar_policy), C_to_Xen_GtkPolicyType(ref_vscrollbar_policy)));
}

static Xen gxg_gtk_scrolled_window_set_placement(Xen scrolled_window, Xen window_placement)
{
  #define H_gtk_scrolled_window_set_placement "void gtk_scrolled_window_set_placement(GtkScrolledWindow* scrolled_window, \
GtkCornerType window_placement)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_placement", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_GtkCornerType(window_placement), window_placement, 2, "gtk_scrolled_window_set_placement", "GtkCornerType");
  gtk_scrolled_window_set_placement(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_GtkCornerType(window_placement));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_placement(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_placement "GtkCornerType gtk_scrolled_window_get_placement(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_placement", "GtkScrolledWindow*");
  return(C_to_Xen_GtkCornerType(gtk_scrolled_window_get_placement(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_set_shadow_type(Xen scrolled_window, Xen type)
{
  #define H_gtk_scrolled_window_set_shadow_type "void gtk_scrolled_window_set_shadow_type(GtkScrolledWindow* scrolled_window, \
GtkShadowType type)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_shadow_type", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_GtkShadowType(type), type, 2, "gtk_scrolled_window_set_shadow_type", "GtkShadowType");
  gtk_scrolled_window_set_shadow_type(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_GtkShadowType(type));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_shadow_type(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_shadow_type "GtkShadowType gtk_scrolled_window_get_shadow_type(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_shadow_type", "GtkScrolledWindow*");
  return(C_to_Xen_GtkShadowType(gtk_scrolled_window_get_shadow_type(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_selection_data_copy(Xen data)
{
  #define H_gtk_selection_data_copy "GtkSelectionData* gtk_selection_data_copy(GtkSelectionData* data)"
  Xen_check_type(Xen_is_GtkSelectionData_(data), data, 1, "gtk_selection_data_copy", "GtkSelectionData*");
  return(C_to_Xen_GtkSelectionData_(gtk_selection_data_copy(Xen_to_C_GtkSelectionData_(data))));
}

static Xen gxg_gtk_selection_data_free(Xen data)
{
  #define H_gtk_selection_data_free "void gtk_selection_data_free(GtkSelectionData* data)"
  Xen_check_type(Xen_is_GtkSelectionData_(data), data, 1, "gtk_selection_data_free", "GtkSelectionData*");
  gtk_selection_data_free(Xen_to_C_GtkSelectionData_(data));
  return(Xen_false);
}

static Xen gxg_gtk_separator_menu_item_new(void)
{
  #define H_gtk_separator_menu_item_new "GtkWidget* gtk_separator_menu_item_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_separator_menu_item_new()));
}

static Xen gxg_gtk_settings_get_default(void)
{
  #define H_gtk_settings_get_default "GtkSettings* gtk_settings_get_default( void)"
  return(C_to_Xen_GtkSettings_(gtk_settings_get_default()));
}

static Xen gxg_gtk_size_group_new(Xen mode)
{
  #define H_gtk_size_group_new "GtkSizeGroup* gtk_size_group_new(GtkSizeGroupMode mode)"
  Xen_check_type(Xen_is_GtkSizeGroupMode(mode), mode, 1, "gtk_size_group_new", "GtkSizeGroupMode");
  return(C_to_Xen_GtkSizeGroup_(gtk_size_group_new(Xen_to_C_GtkSizeGroupMode(mode))));
}

static Xen gxg_gtk_size_group_set_mode(Xen size_group, Xen mode)
{
  #define H_gtk_size_group_set_mode "void gtk_size_group_set_mode(GtkSizeGroup* size_group, GtkSizeGroupMode mode)"
  Xen_check_type(Xen_is_GtkSizeGroup_(size_group), size_group, 1, "gtk_size_group_set_mode", "GtkSizeGroup*");
  Xen_check_type(Xen_is_GtkSizeGroupMode(mode), mode, 2, "gtk_size_group_set_mode", "GtkSizeGroupMode");
  gtk_size_group_set_mode(Xen_to_C_GtkSizeGroup_(size_group), Xen_to_C_GtkSizeGroupMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_size_group_get_mode(Xen size_group)
{
  #define H_gtk_size_group_get_mode "GtkSizeGroupMode gtk_size_group_get_mode(GtkSizeGroup* size_group)"
  Xen_check_type(Xen_is_GtkSizeGroup_(size_group), size_group, 1, "gtk_size_group_get_mode", "GtkSizeGroup*");
  return(C_to_Xen_GtkSizeGroupMode(gtk_size_group_get_mode(Xen_to_C_GtkSizeGroup_(size_group))));
}

static Xen gxg_gtk_size_group_add_widget(Xen size_group, Xen widget)
{
  #define H_gtk_size_group_add_widget "void gtk_size_group_add_widget(GtkSizeGroup* size_group, GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkSizeGroup_(size_group), size_group, 1, "gtk_size_group_add_widget", "GtkSizeGroup*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_size_group_add_widget", "GtkWidget*");
  gtk_size_group_add_widget(Xen_to_C_GtkSizeGroup_(size_group), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_size_group_remove_widget(Xen size_group, Xen widget)
{
  #define H_gtk_size_group_remove_widget "void gtk_size_group_remove_widget(GtkSizeGroup* size_group, \
GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkSizeGroup_(size_group), size_group, 1, "gtk_size_group_remove_widget", "GtkSizeGroup*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_size_group_remove_widget", "GtkWidget*");
  gtk_size_group_remove_widget(Xen_to_C_GtkSizeGroup_(size_group), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_configure(Xen spin_button, Xen adjustment, Xen climb_rate, Xen digits)
{
  #define H_gtk_spin_button_configure "void gtk_spin_button_configure(GtkSpinButton* spin_button, GtkAdjustment* adjustment, \
gdouble climb_rate, guint digits)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_configure", "GtkSpinButton*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment) || Xen_is_false(adjustment), adjustment, 2, "gtk_spin_button_configure", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(climb_rate), climb_rate, 3, "gtk_spin_button_configure", "gdouble");
  Xen_check_type(Xen_is_guint(digits), digits, 4, "gtk_spin_button_configure", "guint");
  gtk_spin_button_configure(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(climb_rate), 
                            Xen_to_C_guint(digits));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_new(Xen adjustment, Xen climb_rate, Xen digits)
{
  #define H_gtk_spin_button_new "GtkWidget* gtk_spin_button_new(GtkAdjustment* adjustment, gdouble climb_rate, \
guint digits)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment) || Xen_is_false(adjustment), adjustment, 1, "gtk_spin_button_new", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(climb_rate), climb_rate, 2, "gtk_spin_button_new", "gdouble");
  Xen_check_type(Xen_is_guint(digits), digits, 3, "gtk_spin_button_new", "guint");
  return(C_to_Xen_GtkWidget_(gtk_spin_button_new(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(climb_rate), Xen_to_C_guint(digits))));
}

static Xen gxg_gtk_spin_button_new_with_range(Xen min, Xen max, Xen step)
{
  #define H_gtk_spin_button_new_with_range "GtkWidget* gtk_spin_button_new_with_range(gdouble min, gdouble max, \
gdouble step)"
  Xen_check_type(Xen_is_gdouble(min), min, 1, "gtk_spin_button_new_with_range", "gdouble");
  Xen_check_type(Xen_is_gdouble(max), max, 2, "gtk_spin_button_new_with_range", "gdouble");
  Xen_check_type(Xen_is_gdouble(step), step, 3, "gtk_spin_button_new_with_range", "gdouble");
  return(C_to_Xen_GtkWidget_(gtk_spin_button_new_with_range(Xen_to_C_gdouble(min), Xen_to_C_gdouble(max), Xen_to_C_gdouble(step))));
}

static Xen gxg_gtk_spin_button_set_adjustment(Xen spin_button, Xen adjustment)
{
  #define H_gtk_spin_button_set_adjustment "void gtk_spin_button_set_adjustment(GtkSpinButton* spin_button, \
GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_adjustment", "GtkSpinButton*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment) || Xen_is_false(adjustment), adjustment, 2, "gtk_spin_button_set_adjustment", "GtkAdjustment*");
  gtk_spin_button_set_adjustment(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_adjustment(Xen spin_button)
{
  #define H_gtk_spin_button_get_adjustment "GtkAdjustment* gtk_spin_button_get_adjustment(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_adjustment", "GtkSpinButton*");
  return(C_to_Xen_GtkAdjustment_(gtk_spin_button_get_adjustment(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_digits(Xen spin_button, Xen digits)
{
  #define H_gtk_spin_button_set_digits "void gtk_spin_button_set_digits(GtkSpinButton* spin_button, guint digits)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_digits", "GtkSpinButton*");
  Xen_check_type(Xen_is_guint(digits), digits, 2, "gtk_spin_button_set_digits", "guint");
  gtk_spin_button_set_digits(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_guint(digits));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_digits(Xen spin_button)
{
  #define H_gtk_spin_button_get_digits "guint gtk_spin_button_get_digits(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_digits", "GtkSpinButton*");
  return(C_to_Xen_guint(gtk_spin_button_get_digits(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_increments(Xen spin_button, Xen step, Xen page)
{
  #define H_gtk_spin_button_set_increments "void gtk_spin_button_set_increments(GtkSpinButton* spin_button, \
gdouble step, gdouble page)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_increments", "GtkSpinButton*");
  Xen_check_type(Xen_is_gdouble(step), step, 2, "gtk_spin_button_set_increments", "gdouble");
  Xen_check_type(Xen_is_gdouble(page), page, 3, "gtk_spin_button_set_increments", "gdouble");
  gtk_spin_button_set_increments(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_gdouble(step), Xen_to_C_gdouble(page));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_increments(Xen spin_button, Xen ignore_step, Xen ignore_page)
{
  #define H_gtk_spin_button_get_increments "void gtk_spin_button_get_increments(GtkSpinButton* spin_button, \
gdouble* [step], gdouble* [page])"
  gdouble ref_step;
  gdouble ref_page;
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_increments", "GtkSpinButton*");
  gtk_spin_button_get_increments(Xen_to_C_GtkSpinButton_(spin_button), &ref_step, &ref_page);
  return(Xen_list_2(C_to_Xen_gdouble(ref_step), C_to_Xen_gdouble(ref_page)));
}

static Xen gxg_gtk_spin_button_set_range(Xen spin_button, Xen min, Xen max)
{
  #define H_gtk_spin_button_set_range "void gtk_spin_button_set_range(GtkSpinButton* spin_button, gdouble min, \
gdouble max)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_range", "GtkSpinButton*");
  Xen_check_type(Xen_is_gdouble(min), min, 2, "gtk_spin_button_set_range", "gdouble");
  Xen_check_type(Xen_is_gdouble(max), max, 3, "gtk_spin_button_set_range", "gdouble");
  gtk_spin_button_set_range(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_gdouble(min), Xen_to_C_gdouble(max));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_range(Xen spin_button, Xen ignore_min, Xen ignore_max)
{
  #define H_gtk_spin_button_get_range "void gtk_spin_button_get_range(GtkSpinButton* spin_button, gdouble* [min], \
gdouble* [max])"
  gdouble ref_min;
  gdouble ref_max;
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_range", "GtkSpinButton*");
  gtk_spin_button_get_range(Xen_to_C_GtkSpinButton_(spin_button), &ref_min, &ref_max);
  return(Xen_list_2(C_to_Xen_gdouble(ref_min), C_to_Xen_gdouble(ref_max)));
}

static Xen gxg_gtk_spin_button_get_value(Xen spin_button)
{
  #define H_gtk_spin_button_get_value "gdouble gtk_spin_button_get_value(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_value", "GtkSpinButton*");
  return(C_to_Xen_gdouble(gtk_spin_button_get_value(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_get_value_as_int(Xen spin_button)
{
  #define H_gtk_spin_button_get_value_as_int "gint gtk_spin_button_get_value_as_int(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_value_as_int", "GtkSpinButton*");
  return(C_to_Xen_gint(gtk_spin_button_get_value_as_int(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_value(Xen spin_button, Xen value)
{
  #define H_gtk_spin_button_set_value "void gtk_spin_button_set_value(GtkSpinButton* spin_button, gdouble value)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_value", "GtkSpinButton*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_spin_button_set_value", "gdouble");
  gtk_spin_button_set_value(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_set_update_policy(Xen spin_button, Xen policy)
{
  #define H_gtk_spin_button_set_update_policy "void gtk_spin_button_set_update_policy(GtkSpinButton* spin_button, \
GtkSpinButtonUpdatePolicy policy)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_update_policy", "GtkSpinButton*");
  Xen_check_type(Xen_is_GtkSpinButtonUpdatePolicy(policy), policy, 2, "gtk_spin_button_set_update_policy", "GtkSpinButtonUpdatePolicy");
  gtk_spin_button_set_update_policy(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_GtkSpinButtonUpdatePolicy(policy));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_update_policy(Xen spin_button)
{
  #define H_gtk_spin_button_get_update_policy "GtkSpinButtonUpdatePolicy gtk_spin_button_get_update_policy(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_update_policy", "GtkSpinButton*");
  return(C_to_Xen_GtkSpinButtonUpdatePolicy(gtk_spin_button_get_update_policy(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_numeric(Xen spin_button, Xen numeric)
{
  #define H_gtk_spin_button_set_numeric "void gtk_spin_button_set_numeric(GtkSpinButton* spin_button, \
gboolean numeric)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_numeric", "GtkSpinButton*");
  Xen_check_type(Xen_is_gboolean(numeric), numeric, 2, "gtk_spin_button_set_numeric", "gboolean");
  gtk_spin_button_set_numeric(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_gboolean(numeric));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_numeric(Xen spin_button)
{
  #define H_gtk_spin_button_get_numeric "gboolean gtk_spin_button_get_numeric(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_numeric", "GtkSpinButton*");
  return(C_to_Xen_gboolean(gtk_spin_button_get_numeric(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_spin(Xen spin_button, Xen direction, Xen increment)
{
  #define H_gtk_spin_button_spin "void gtk_spin_button_spin(GtkSpinButton* spin_button, GtkSpinType direction, \
gdouble increment)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_spin", "GtkSpinButton*");
  Xen_check_type(Xen_is_GtkSpinType(direction), direction, 2, "gtk_spin_button_spin", "GtkSpinType");
  Xen_check_type(Xen_is_gdouble(increment), increment, 3, "gtk_spin_button_spin", "gdouble");
  gtk_spin_button_spin(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_GtkSpinType(direction), Xen_to_C_gdouble(increment));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_set_wrap(Xen spin_button, Xen wrap)
{
  #define H_gtk_spin_button_set_wrap "void gtk_spin_button_set_wrap(GtkSpinButton* spin_button, gboolean wrap)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_wrap", "GtkSpinButton*");
  Xen_check_type(Xen_is_gboolean(wrap), wrap, 2, "gtk_spin_button_set_wrap", "gboolean");
  gtk_spin_button_set_wrap(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_gboolean(wrap));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_wrap(Xen spin_button)
{
  #define H_gtk_spin_button_get_wrap "gboolean gtk_spin_button_get_wrap(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_wrap", "GtkSpinButton*");
  return(C_to_Xen_gboolean(gtk_spin_button_get_wrap(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_snap_to_ticks(Xen spin_button, Xen snap_to_ticks)
{
  #define H_gtk_spin_button_set_snap_to_ticks "void gtk_spin_button_set_snap_to_ticks(GtkSpinButton* spin_button, \
gboolean snap_to_ticks)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_snap_to_ticks", "GtkSpinButton*");
  Xen_check_type(Xen_is_gboolean(snap_to_ticks), snap_to_ticks, 2, "gtk_spin_button_set_snap_to_ticks", "gboolean");
  gtk_spin_button_set_snap_to_ticks(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_gboolean(snap_to_ticks));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_snap_to_ticks(Xen spin_button)
{
  #define H_gtk_spin_button_get_snap_to_ticks "gboolean gtk_spin_button_get_snap_to_ticks(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_snap_to_ticks", "GtkSpinButton*");
  return(C_to_Xen_gboolean(gtk_spin_button_get_snap_to_ticks(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_update(Xen spin_button)
{
  #define H_gtk_spin_button_update "void gtk_spin_button_update(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_update", "GtkSpinButton*");
  gtk_spin_button_update(Xen_to_C_GtkSpinButton_(spin_button));
  return(Xen_false);
}

static Xen gxg_gtk_statusbar_new(void)
{
  #define H_gtk_statusbar_new "GtkWidget* gtk_statusbar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_statusbar_new()));
}

static Xen gxg_gtk_statusbar_get_context_id(Xen statusbar, Xen context_description)
{
  #define H_gtk_statusbar_get_context_id "guint gtk_statusbar_get_context_id(GtkStatusbar* statusbar, \
gchar* context_description)"
  Xen_check_type(Xen_is_GtkStatusbar_(statusbar), statusbar, 1, "gtk_statusbar_get_context_id", "GtkStatusbar*");
  Xen_check_type(Xen_is_gchar_(context_description), context_description, 2, "gtk_statusbar_get_context_id", "gchar*");
  return(C_to_Xen_guint(gtk_statusbar_get_context_id(Xen_to_C_GtkStatusbar_(statusbar), Xen_to_C_gchar_(context_description))));
}

static Xen gxg_gtk_statusbar_push(Xen statusbar, Xen context_id, Xen text)
{
  #define H_gtk_statusbar_push "guint gtk_statusbar_push(GtkStatusbar* statusbar, guint context_id, gchar* text)"
  Xen_check_type(Xen_is_GtkStatusbar_(statusbar), statusbar, 1, "gtk_statusbar_push", "GtkStatusbar*");
  Xen_check_type(Xen_is_guint(context_id), context_id, 2, "gtk_statusbar_push", "guint");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_statusbar_push", "gchar*");
  return(C_to_Xen_guint(gtk_statusbar_push(Xen_to_C_GtkStatusbar_(statusbar), Xen_to_C_guint(context_id), Xen_to_C_gchar_(text))));
}

static Xen gxg_gtk_statusbar_pop(Xen statusbar, Xen context_id)
{
  #define H_gtk_statusbar_pop "void gtk_statusbar_pop(GtkStatusbar* statusbar, guint context_id)"
  Xen_check_type(Xen_is_GtkStatusbar_(statusbar), statusbar, 1, "gtk_statusbar_pop", "GtkStatusbar*");
  Xen_check_type(Xen_is_guint(context_id), context_id, 2, "gtk_statusbar_pop", "guint");
  gtk_statusbar_pop(Xen_to_C_GtkStatusbar_(statusbar), Xen_to_C_guint(context_id));
  return(Xen_false);
}

static Xen gxg_gtk_statusbar_remove(Xen statusbar, Xen context_id, Xen message_id)
{
  #define H_gtk_statusbar_remove "void gtk_statusbar_remove(GtkStatusbar* statusbar, guint context_id, \
guint message_id)"
  Xen_check_type(Xen_is_GtkStatusbar_(statusbar), statusbar, 1, "gtk_statusbar_remove", "GtkStatusbar*");
  Xen_check_type(Xen_is_guint(context_id), context_id, 2, "gtk_statusbar_remove", "guint");
  Xen_check_type(Xen_is_guint(message_id), message_id, 3, "gtk_statusbar_remove", "guint");
  gtk_statusbar_remove(Xen_to_C_GtkStatusbar_(statusbar), Xen_to_C_guint(context_id), Xen_to_C_guint(message_id));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_new(Xen table)
{
  #define H_gtk_text_buffer_new "GtkTextBuffer* gtk_text_buffer_new(GtkTextTagTable* table)"
  Xen_check_type(Xen_is_GtkTextTagTable_(table) || Xen_is_false(table), table, 1, "gtk_text_buffer_new", "GtkTextTagTable*");
  return(C_to_Xen_GtkTextBuffer_(gtk_text_buffer_new(Xen_to_C_GtkTextTagTable_(table))));
}

static Xen gxg_gtk_text_buffer_get_line_count(Xen buffer)
{
  #define H_gtk_text_buffer_get_line_count "gint gtk_text_buffer_get_line_count(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_line_count", "GtkTextBuffer*");
  return(C_to_Xen_gint(gtk_text_buffer_get_line_count(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_buffer_get_char_count(Xen buffer)
{
  #define H_gtk_text_buffer_get_char_count "gint gtk_text_buffer_get_char_count(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_char_count", "GtkTextBuffer*");
  return(C_to_Xen_gint(gtk_text_buffer_get_char_count(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_buffer_get_tag_table(Xen buffer)
{
  #define H_gtk_text_buffer_get_tag_table "GtkTextTagTable* gtk_text_buffer_get_tag_table(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_tag_table", "GtkTextBuffer*");
  return(C_to_Xen_GtkTextTagTable_(gtk_text_buffer_get_tag_table(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_buffer_set_text(Xen buffer, Xen text, Xen len)
{
  #define H_gtk_text_buffer_set_text "void gtk_text_buffer_set_text(GtkTextBuffer* buffer, gchar* text, \
gint len)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_set_text", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_text_buffer_set_text", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 3, "gtk_text_buffer_set_text", "gint");
  gtk_text_buffer_set_text(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(text), Xen_to_C_gint(len));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_insert(Xen buffer, Xen iter, Xen text, Xen len)
{
  #define H_gtk_text_buffer_insert "void gtk_text_buffer_insert(GtkTextBuffer* buffer, GtkTextIter* iter, \
gchar* text, gint len)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_text_buffer_insert", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 4, "gtk_text_buffer_insert", "gint");
  gtk_text_buffer_insert(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gchar_(text), Xen_to_C_gint(len));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_insert_at_cursor(Xen buffer, Xen text, Xen len)
{
  #define H_gtk_text_buffer_insert_at_cursor "void gtk_text_buffer_insert_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_at_cursor", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_text_buffer_insert_at_cursor", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 3, "gtk_text_buffer_insert_at_cursor", "gint");
  gtk_text_buffer_insert_at_cursor(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(text), Xen_to_C_gint(len));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_insert_interactive(Xen buffer, Xen iter, Xen text, Xen len, Xen default_editable)
{
  #define H_gtk_text_buffer_insert_interactive "gboolean gtk_text_buffer_insert_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_interactive", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_interactive", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_text_buffer_insert_interactive", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 4, "gtk_text_buffer_insert_interactive", "gint");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 5, "gtk_text_buffer_insert_interactive", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_buffer_insert_interactive(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), 
                                                              Xen_to_C_gchar_(text), Xen_to_C_gint(len), Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_text_buffer_insert_interactive_at_cursor(Xen buffer, Xen text, Xen len, Xen default_editable)
{
  #define H_gtk_text_buffer_insert_interactive_at_cursor "gboolean gtk_text_buffer_insert_interactive_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_interactive_at_cursor", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_text_buffer_insert_interactive_at_cursor", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 3, "gtk_text_buffer_insert_interactive_at_cursor", "gint");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 4, "gtk_text_buffer_insert_interactive_at_cursor", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_buffer_insert_interactive_at_cursor(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(text), 
                                                                        Xen_to_C_gint(len), Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_text_buffer_insert_range(Xen buffer, Xen iter, Xen start, Xen end)
{
  #define H_gtk_text_buffer_insert_range "void gtk_text_buffer_insert_range(GtkTextBuffer* buffer, GtkTextIter* iter, \
GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_range", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_range", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 3, "gtk_text_buffer_insert_range", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 4, "gtk_text_buffer_insert_range", "GtkTextIter*");
  gtk_text_buffer_insert_range(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextIter_(start), 
                               Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_insert_range_interactive(Xen buffer, Xen iter, Xen start, Xen end, Xen default_editable)
{
  #define H_gtk_text_buffer_insert_range_interactive "gboolean gtk_text_buffer_insert_range_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextIter* start, GtkTextIter* end, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_range_interactive", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_range_interactive", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 3, "gtk_text_buffer_insert_range_interactive", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 4, "gtk_text_buffer_insert_range_interactive", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 5, "gtk_text_buffer_insert_range_interactive", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_buffer_insert_range_interactive(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), 
                                                                    Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end), 
                                                                    Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_text_buffer_insert_with_tags(Xen buffer, Xen iter, Xen text, Xen len, Xen tags)
{
  #define H_gtk_text_buffer_insert_with_tags "void gtk_text_buffer_insert_with_tags(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_with_tags", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_with_tags", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_text_buffer_insert_with_tags", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 4, "gtk_text_buffer_insert_with_tags", "gint");
  Xen_check_type(Xen_is_etc(tags), tags, 5, "gtk_text_buffer_insert_with_tags", "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (Xen_is_list(tags)) etc_len = Xen_list_length(tags);
    if (etc_len < 1) Xen_out_of_range_error("gtk_text_buffer_insert_with_tags", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) Xen_out_of_range_error("gtk_text_buffer_insert_with_tags", 4, tags, "... list too long (max len: 6)");
    p_arg0 = Xen_to_C_GtkTextBuffer_(buffer);
    p_arg1 = Xen_to_C_GtkTextIter_(iter);
    p_arg2 = Xen_to_C_gchar_(text);
    p_arg3 = Xen_to_C_gint(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), NULL); break;
        case 2: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), NULL); break;
        case 4: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), XLT(tags, 3), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), XLT(tags, 3), XLT(tags, 4), NULL); break;
        case 6: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, XLT(tags, 0), XLT(tags, 1), XLT(tags, 2), XLT(tags, 3), XLT(tags, 4), XLT(tags, 5), NULL); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_text_buffer_insert_with_tags_by_name(Xen buffer, Xen iter, Xen text, Xen len, Xen tags)
{
  #define H_gtk_text_buffer_insert_with_tags_by_name "void gtk_text_buffer_insert_with_tags_by_name(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_with_tags_by_name", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_with_tags_by_name", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_text_buffer_insert_with_tags_by_name", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 4, "gtk_text_buffer_insert_with_tags_by_name", "gint");
  Xen_check_type(Xen_is_etc(tags), tags, 5, "gtk_text_buffer_insert_with_tags_by_name", "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (Xen_is_list(tags)) etc_len = Xen_list_length(tags);
    if (etc_len < 1) Xen_out_of_range_error("gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) Xen_out_of_range_error("gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list too long (max len: 6)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkTextBuffer_(buffer);
    p_arg1 = Xen_to_C_GtkTextIter_(iter);
    p_arg2 = Xen_to_C_gchar_(text);
    p_arg3 = Xen_to_C_gint(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLI(tags, 1), XLS(tags, 2), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, XLS(tags, 0), XLI(tags, 1), XLS(tags, 2), XLI(tags, 3), XLS(tags, 4), NULL); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_text_buffer_delete(Xen buffer, Xen start, Xen end)
{
  #define H_gtk_text_buffer_delete "void gtk_text_buffer_delete(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_delete", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_buffer_delete", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_buffer_delete", "GtkTextIter*");
  gtk_text_buffer_delete(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_delete_interactive(Xen buffer, Xen start_iter, Xen end_iter, Xen default_editable)
{
  #define H_gtk_text_buffer_delete_interactive "gboolean gtk_text_buffer_delete_interactive(GtkTextBuffer* buffer, \
GtkTextIter* start_iter, GtkTextIter* end_iter, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_delete_interactive", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start_iter), start_iter, 2, "gtk_text_buffer_delete_interactive", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end_iter), end_iter, 3, "gtk_text_buffer_delete_interactive", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 4, "gtk_text_buffer_delete_interactive", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_buffer_delete_interactive(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start_iter), 
                                                              Xen_to_C_GtkTextIter_(end_iter), Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_text_buffer_get_text(Xen buffer, Xen start, Xen end, Xen include_hidden_chars)
{
  #define H_gtk_text_buffer_get_text "gchar* gtk_text_buffer_get_text(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_text", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_buffer_get_text", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_buffer_get_text", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(include_hidden_chars), include_hidden_chars, 4, "gtk_text_buffer_get_text", "gboolean");
  {
   gchar* result;
   Xen rtn;
   result = gtk_text_buffer_get_text(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start), 
                                                                       Xen_to_C_GtkTextIter_(end), Xen_to_C_gboolean(include_hidden_chars));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_text_buffer_get_slice(Xen buffer, Xen start, Xen end, Xen include_hidden_chars)
{
  #define H_gtk_text_buffer_get_slice "gchar* gtk_text_buffer_get_slice(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_slice", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_buffer_get_slice", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_buffer_get_slice", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(include_hidden_chars), include_hidden_chars, 4, "gtk_text_buffer_get_slice", "gboolean");
  {
   gchar* result;
   Xen rtn;
   result = gtk_text_buffer_get_slice(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start), 
                                                                        Xen_to_C_GtkTextIter_(end), Xen_to_C_gboolean(include_hidden_chars));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_text_buffer_insert_child_anchor(Xen buffer, Xen iter, Xen anchor)
{
  #define H_gtk_text_buffer_insert_child_anchor "void gtk_text_buffer_insert_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_child_anchor", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_child_anchor", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextChildAnchor_(anchor), anchor, 3, "gtk_text_buffer_insert_child_anchor", "GtkTextChildAnchor*");
  gtk_text_buffer_insert_child_anchor(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextChildAnchor_(anchor));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_create_child_anchor(Xen buffer, Xen iter)
{
  #define H_gtk_text_buffer_create_child_anchor "GtkTextChildAnchor* gtk_text_buffer_create_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_create_child_anchor", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_create_child_anchor", "GtkTextIter*");
  return(C_to_Xen_GtkTextChildAnchor_(gtk_text_buffer_create_child_anchor(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_buffer_create_mark(Xen buffer, Xen mark_name, Xen where, Xen left_gravity)
{
  #define H_gtk_text_buffer_create_mark "GtkTextMark* gtk_text_buffer_create_mark(GtkTextBuffer* buffer, \
gchar* mark_name, GtkTextIter* where, gboolean left_gravity)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_create_mark", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(mark_name), mark_name, 2, "gtk_text_buffer_create_mark", "gchar*");
  Xen_check_type(Xen_is_GtkTextIter_(where), where, 3, "gtk_text_buffer_create_mark", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(left_gravity), left_gravity, 4, "gtk_text_buffer_create_mark", "gboolean");
  return(C_to_Xen_GtkTextMark_(gtk_text_buffer_create_mark(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(mark_name), Xen_to_C_GtkTextIter_(where), 
                                                           Xen_to_C_gboolean(left_gravity))));
}

static Xen gxg_gtk_text_buffer_move_mark(Xen buffer, Xen mark, Xen where)
{
  #define H_gtk_text_buffer_move_mark "void gtk_text_buffer_move_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_move_mark", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 2, "gtk_text_buffer_move_mark", "GtkTextMark*");
  Xen_check_type(Xen_is_GtkTextIter_(where), where, 3, "gtk_text_buffer_move_mark", "GtkTextIter*");
  gtk_text_buffer_move_mark(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextMark_(mark), Xen_to_C_GtkTextIter_(where));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_delete_mark(Xen buffer, Xen mark)
{
  #define H_gtk_text_buffer_delete_mark "void gtk_text_buffer_delete_mark(GtkTextBuffer* buffer, GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_delete_mark", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 2, "gtk_text_buffer_delete_mark", "GtkTextMark*");
  gtk_text_buffer_delete_mark(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextMark_(mark));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_mark(Xen buffer, Xen name)
{
  #define H_gtk_text_buffer_get_mark "GtkTextMark* gtk_text_buffer_get_mark(GtkTextBuffer* buffer, gchar* name)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_mark", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_text_buffer_get_mark", "gchar*");
  return(C_to_Xen_GtkTextMark_(gtk_text_buffer_get_mark(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(name))));
}

static Xen gxg_gtk_text_buffer_move_mark_by_name(Xen buffer, Xen name, Xen where)
{
  #define H_gtk_text_buffer_move_mark_by_name "void gtk_text_buffer_move_mark_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* where)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_move_mark_by_name", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_text_buffer_move_mark_by_name", "gchar*");
  Xen_check_type(Xen_is_GtkTextIter_(where), where, 3, "gtk_text_buffer_move_mark_by_name", "GtkTextIter*");
  gtk_text_buffer_move_mark_by_name(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(name), Xen_to_C_GtkTextIter_(where));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_delete_mark_by_name(Xen buffer, Xen name)
{
  #define H_gtk_text_buffer_delete_mark_by_name "void gtk_text_buffer_delete_mark_by_name(GtkTextBuffer* buffer, \
gchar* name)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_delete_mark_by_name", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_text_buffer_delete_mark_by_name", "gchar*");
  gtk_text_buffer_delete_mark_by_name(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_insert(Xen buffer)
{
  #define H_gtk_text_buffer_get_insert "GtkTextMark* gtk_text_buffer_get_insert(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_insert", "GtkTextBuffer*");
  return(C_to_Xen_GtkTextMark_(gtk_text_buffer_get_insert(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_buffer_get_selection_bound(Xen buffer)
{
  #define H_gtk_text_buffer_get_selection_bound "GtkTextMark* gtk_text_buffer_get_selection_bound(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_selection_bound", "GtkTextBuffer*");
  return(C_to_Xen_GtkTextMark_(gtk_text_buffer_get_selection_bound(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_buffer_place_cursor(Xen buffer, Xen where)
{
  #define H_gtk_text_buffer_place_cursor "void gtk_text_buffer_place_cursor(GtkTextBuffer* buffer, GtkTextIter* where)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_place_cursor", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(where), where, 2, "gtk_text_buffer_place_cursor", "GtkTextIter*");
  gtk_text_buffer_place_cursor(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(where));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_apply_tag(Xen buffer, Xen tag, Xen start, Xen end)
{
  #define H_gtk_text_buffer_apply_tag "void gtk_text_buffer_apply_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_apply_tag", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 2, "gtk_text_buffer_apply_tag", "GtkTextTag*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 3, "gtk_text_buffer_apply_tag", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 4, "gtk_text_buffer_apply_tag", "GtkTextIter*");
  gtk_text_buffer_apply_tag(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextTag_(tag), Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_remove_tag(Xen buffer, Xen tag, Xen start, Xen end)
{
  #define H_gtk_text_buffer_remove_tag "void gtk_text_buffer_remove_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_remove_tag", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 2, "gtk_text_buffer_remove_tag", "GtkTextTag*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 3, "gtk_text_buffer_remove_tag", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 4, "gtk_text_buffer_remove_tag", "GtkTextIter*");
  gtk_text_buffer_remove_tag(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextTag_(tag), Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_apply_tag_by_name(Xen buffer, Xen name, Xen start, Xen end)
{
  #define H_gtk_text_buffer_apply_tag_by_name "void gtk_text_buffer_apply_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_apply_tag_by_name", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_text_buffer_apply_tag_by_name", "gchar*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 3, "gtk_text_buffer_apply_tag_by_name", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 4, "gtk_text_buffer_apply_tag_by_name", "GtkTextIter*");
  gtk_text_buffer_apply_tag_by_name(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(name), Xen_to_C_GtkTextIter_(start), 
                                    Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_remove_tag_by_name(Xen buffer, Xen name, Xen start, Xen end)
{
  #define H_gtk_text_buffer_remove_tag_by_name "void gtk_text_buffer_remove_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_remove_tag_by_name", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_text_buffer_remove_tag_by_name", "gchar*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 3, "gtk_text_buffer_remove_tag_by_name", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 4, "gtk_text_buffer_remove_tag_by_name", "GtkTextIter*");
  gtk_text_buffer_remove_tag_by_name(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gchar_(name), Xen_to_C_GtkTextIter_(start), 
                                     Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_remove_all_tags(Xen buffer, Xen start, Xen end)
{
  #define H_gtk_text_buffer_remove_all_tags "void gtk_text_buffer_remove_all_tags(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_remove_all_tags", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_buffer_remove_all_tags", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_buffer_remove_all_tags", "GtkTextIter*");
  gtk_text_buffer_remove_all_tags(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_create_tag(Xen buffer, Xen tag_name, Xen tags)
{
  #define H_gtk_text_buffer_create_tag "GtkTextTag* gtk_text_buffer_create_tag(GtkTextBuffer* buffer, \
gchar* tag_name, etc tags)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_create_tag", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gchar_(tag_name), tag_name, 2, "gtk_text_buffer_create_tag", "gchar*");
  if (!Xen_is_bound(tags)) tags = Xen_false; 
  else Xen_check_type(Xen_is_etc(tags), tags, 3, "gtk_text_buffer_create_tag", "etc");
  {
    int etc_len = 0;
    GtkTextTag* result = NULL;
    GtkTextBuffer* p_arg0;
    gchar* p_arg1;
    if (Xen_is_list(tags)) etc_len = Xen_list_length(tags);
    if (etc_len > 6) Xen_out_of_range_error("gtk_text_buffer_create_tag", 2, tags, "... list too long (max len: 6)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_text_buffer_create_tag", 2, tags, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkTextBuffer_(buffer);
    p_arg1 = Xen_to_C_gchar_(tag_name);
    switch (etc_len)
      {
        case 0: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, NULL); break;
        case 2: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLA(tags, 1), NULL); break;
        case 4: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLA(tags, 1), XLS(tags, 2), XLA(tags, 3), NULL); break;
        case 6: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, XLS(tags, 0), XLA(tags, 1), XLS(tags, 2), XLA(tags, 3), XLS(tags, 4), XLA(tags, 5), NULL); break;
      }
    return(C_to_Xen_GtkTextTag_(result));
  }
}

static Xen gxg_gtk_text_buffer_get_iter_at_line_offset(Xen buffer, Xen iter, Xen line_number, Xen char_offset)
{
  #define H_gtk_text_buffer_get_iter_at_line_offset "void gtk_text_buffer_get_iter_at_line_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint char_offset)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_line_offset", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_iter_at_line_offset", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(line_number), line_number, 3, "gtk_text_buffer_get_iter_at_line_offset", "gint");
  Xen_check_type(Xen_is_gint(char_offset), char_offset, 4, "gtk_text_buffer_get_iter_at_line_offset", "gint");
  gtk_text_buffer_get_iter_at_line_offset(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(line_number), 
                                          Xen_to_C_gint(char_offset));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_iter_at_line_index(Xen buffer, Xen iter, Xen line_number, Xen byte_index)
{
  #define H_gtk_text_buffer_get_iter_at_line_index "void gtk_text_buffer_get_iter_at_line_index(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint byte_index)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_line_index", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_iter_at_line_index", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(line_number), line_number, 3, "gtk_text_buffer_get_iter_at_line_index", "gint");
  Xen_check_type(Xen_is_gint(byte_index), byte_index, 4, "gtk_text_buffer_get_iter_at_line_index", "gint");
  gtk_text_buffer_get_iter_at_line_index(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(line_number), 
                                         Xen_to_C_gint(byte_index));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_iter_at_offset(Xen buffer, Xen iter, Xen char_offset)
{
  #define H_gtk_text_buffer_get_iter_at_offset "void gtk_text_buffer_get_iter_at_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint char_offset)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_offset", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_iter_at_offset", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(char_offset), char_offset, 3, "gtk_text_buffer_get_iter_at_offset", "gint");
  gtk_text_buffer_get_iter_at_offset(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(char_offset));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_iter_at_line(Xen buffer, Xen iter, Xen line_number)
{
  #define H_gtk_text_buffer_get_iter_at_line "void gtk_text_buffer_get_iter_at_line(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_line", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_iter_at_line", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(line_number), line_number, 3, "gtk_text_buffer_get_iter_at_line", "gint");
  gtk_text_buffer_get_iter_at_line(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(line_number));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_start_iter(Xen buffer, Xen iter)
{
  #define H_gtk_text_buffer_get_start_iter "void gtk_text_buffer_get_start_iter(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_start_iter", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_start_iter", "GtkTextIter*");
  gtk_text_buffer_get_start_iter(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_end_iter(Xen buffer, Xen iter)
{
  #define H_gtk_text_buffer_get_end_iter "void gtk_text_buffer_get_end_iter(GtkTextBuffer* buffer, GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_end_iter", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_end_iter", "GtkTextIter*");
  gtk_text_buffer_get_end_iter(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_bounds(Xen buffer, Xen start, Xen end)
{
  #define H_gtk_text_buffer_get_bounds "void gtk_text_buffer_get_bounds(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_bounds", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_buffer_get_bounds", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_buffer_get_bounds", "GtkTextIter*");
  gtk_text_buffer_get_bounds(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_iter_at_mark(Xen buffer, Xen iter, Xen mark)
{
  #define H_gtk_text_buffer_get_iter_at_mark "void gtk_text_buffer_get_iter_at_mark(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_mark", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_iter_at_mark", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 3, "gtk_text_buffer_get_iter_at_mark", "GtkTextMark*");
  gtk_text_buffer_get_iter_at_mark(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextMark_(mark));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_iter_at_child_anchor(Xen buffer, Xen iter, Xen anchor)
{
  #define H_gtk_text_buffer_get_iter_at_child_anchor "void gtk_text_buffer_get_iter_at_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_iter_at_child_anchor", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_get_iter_at_child_anchor", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextChildAnchor_(anchor), anchor, 3, "gtk_text_buffer_get_iter_at_child_anchor", "GtkTextChildAnchor*");
  gtk_text_buffer_get_iter_at_child_anchor(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextChildAnchor_(anchor));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_modified(Xen buffer)
{
  #define H_gtk_text_buffer_get_modified "gboolean gtk_text_buffer_get_modified(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_modified", "GtkTextBuffer*");
  return(C_to_Xen_gboolean(gtk_text_buffer_get_modified(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_buffer_set_modified(Xen buffer, Xen setting)
{
  #define H_gtk_text_buffer_set_modified "void gtk_text_buffer_set_modified(GtkTextBuffer* buffer, gboolean setting)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_set_modified", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_text_buffer_set_modified", "gboolean");
  gtk_text_buffer_set_modified(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_get_selection_bounds(Xen buffer, Xen start, Xen end)
{
  #define H_gtk_text_buffer_get_selection_bounds "gboolean gtk_text_buffer_get_selection_bounds(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_selection_bounds", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_buffer_get_selection_bounds", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_buffer_get_selection_bounds", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_buffer_get_selection_bounds(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(start), 
                                                                Xen_to_C_GtkTextIter_(end))));
}

static Xen gxg_gtk_text_buffer_delete_selection(Xen buffer, Xen interactive, Xen default_editable)
{
  #define H_gtk_text_buffer_delete_selection "gboolean gtk_text_buffer_delete_selection(GtkTextBuffer* buffer, \
gboolean interactive, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_delete_selection", "GtkTextBuffer*");
  Xen_check_type(Xen_is_gboolean(interactive), interactive, 2, "gtk_text_buffer_delete_selection", "gboolean");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 3, "gtk_text_buffer_delete_selection", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_buffer_delete_selection(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_gboolean(interactive), 
                                                            Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_text_buffer_begin_user_action(Xen buffer)
{
  #define H_gtk_text_buffer_begin_user_action "void gtk_text_buffer_begin_user_action(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_begin_user_action", "GtkTextBuffer*");
  gtk_text_buffer_begin_user_action(Xen_to_C_GtkTextBuffer_(buffer));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_end_user_action(Xen buffer)
{
  #define H_gtk_text_buffer_end_user_action "void gtk_text_buffer_end_user_action(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_end_user_action", "GtkTextBuffer*");
  gtk_text_buffer_end_user_action(Xen_to_C_GtkTextBuffer_(buffer));
  return(Xen_false);
}

static Xen gxg_gtk_text_child_anchor_new(void)
{
  #define H_gtk_text_child_anchor_new "GtkTextChildAnchor* gtk_text_child_anchor_new( void)"
  return(C_to_Xen_GtkTextChildAnchor_(gtk_text_child_anchor_new()));
}

static Xen gxg_gtk_text_child_anchor_get_widgets(Xen anchor)
{
  #define H_gtk_text_child_anchor_get_widgets "GList* gtk_text_child_anchor_get_widgets(GtkTextChildAnchor* anchor)"
  Xen_check_type(Xen_is_GtkTextChildAnchor_(anchor), anchor, 1, "gtk_text_child_anchor_get_widgets", "GtkTextChildAnchor*");
  return(C_to_Xen_GList_(gtk_text_child_anchor_get_widgets(Xen_to_C_GtkTextChildAnchor_(anchor))));
}

static Xen gxg_gtk_text_child_anchor_get_deleted(Xen anchor)
{
  #define H_gtk_text_child_anchor_get_deleted "gboolean gtk_text_child_anchor_get_deleted(GtkTextChildAnchor* anchor)"
  Xen_check_type(Xen_is_GtkTextChildAnchor_(anchor), anchor, 1, "gtk_text_child_anchor_get_deleted", "GtkTextChildAnchor*");
  return(C_to_Xen_gboolean(gtk_text_child_anchor_get_deleted(Xen_to_C_GtkTextChildAnchor_(anchor))));
}

static Xen gxg_gtk_text_iter_get_buffer(Xen iter)
{
  #define H_gtk_text_iter_get_buffer "GtkTextBuffer* gtk_text_iter_get_buffer(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_buffer", "GtkTextIter*");
  return(C_to_Xen_GtkTextBuffer_(gtk_text_iter_get_buffer(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_copy(Xen iter)
{
  #define H_gtk_text_iter_copy "GtkTextIter* gtk_text_iter_copy(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_copy", "GtkTextIter*");
  return(C_to_Xen_GtkTextIter_(gtk_text_iter_copy(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_free(Xen iter)
{
  #define H_gtk_text_iter_free "void gtk_text_iter_free(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_free", "GtkTextIter*");
  gtk_text_iter_free(Xen_to_C_GtkTextIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_get_offset(Xen iter)
{
  #define H_gtk_text_iter_get_offset "gint gtk_text_iter_get_offset(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_offset", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_offset(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_line(Xen iter)
{
  #define H_gtk_text_iter_get_line "gint gtk_text_iter_get_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_line", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_line_offset(Xen iter)
{
  #define H_gtk_text_iter_get_line_offset "gint gtk_text_iter_get_line_offset(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_line_offset", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_line_offset(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_line_index(Xen iter)
{
  #define H_gtk_text_iter_get_line_index "gint gtk_text_iter_get_line_index(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_line_index", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_line_index(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_visible_line_offset(Xen iter)
{
  #define H_gtk_text_iter_get_visible_line_offset "gint gtk_text_iter_get_visible_line_offset(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_visible_line_offset", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_visible_line_offset(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_visible_line_index(Xen iter)
{
  #define H_gtk_text_iter_get_visible_line_index "gint gtk_text_iter_get_visible_line_index(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_visible_line_index", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_visible_line_index(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_char(Xen iter)
{
  #define H_gtk_text_iter_get_char "gunichar gtk_text_iter_get_char(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_char", "GtkTextIter*");
  return(C_to_Xen_gunichar(gtk_text_iter_get_char(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_slice(Xen start, Xen end)
{
  #define H_gtk_text_iter_get_slice "gchar* gtk_text_iter_get_slice(GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 1, "gtk_text_iter_get_slice", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 2, "gtk_text_iter_get_slice", "GtkTextIter*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_text_iter_get_slice(Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_text_iter_get_text(Xen start, Xen end)
{
  #define H_gtk_text_iter_get_text "gchar* gtk_text_iter_get_text(GtkTextIter* start, GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 1, "gtk_text_iter_get_text", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 2, "gtk_text_iter_get_text", "GtkTextIter*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_text_iter_get_text(Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_text_iter_get_visible_slice(Xen start, Xen end)
{
  #define H_gtk_text_iter_get_visible_slice "gchar* gtk_text_iter_get_visible_slice(GtkTextIter* start, \
GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 1, "gtk_text_iter_get_visible_slice", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 2, "gtk_text_iter_get_visible_slice", "GtkTextIter*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_text_iter_get_visible_slice(Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_text_iter_get_visible_text(Xen start, Xen end)
{
  #define H_gtk_text_iter_get_visible_text "gchar* gtk_text_iter_get_visible_text(GtkTextIter* start, \
GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 1, "gtk_text_iter_get_visible_text", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 2, "gtk_text_iter_get_visible_text", "GtkTextIter*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_text_iter_get_visible_text(Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_text_iter_get_marks(Xen iter)
{
  #define H_gtk_text_iter_get_marks "GSList* gtk_text_iter_get_marks(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_marks", "GtkTextIter*");
  return(C_to_Xen_GSList_(gtk_text_iter_get_marks(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_child_anchor(Xen iter)
{
  #define H_gtk_text_iter_get_child_anchor "GtkTextChildAnchor* gtk_text_iter_get_child_anchor(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_child_anchor", "GtkTextIter*");
  return(C_to_Xen_GtkTextChildAnchor_(gtk_text_iter_get_child_anchor(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_toggled_tags(Xen iter, Xen toggled_on)
{
  #define H_gtk_text_iter_get_toggled_tags "GSList* gtk_text_iter_get_toggled_tags(GtkTextIter* iter, \
gboolean toggled_on)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_toggled_tags", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(toggled_on), toggled_on, 2, "gtk_text_iter_get_toggled_tags", "gboolean");
  return(C_to_Xen_GSList_(gtk_text_iter_get_toggled_tags(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gboolean(toggled_on))));
}

static Xen gxg_gtk_text_iter_ends_tag(Xen iter, Xen tag)
{
  #define H_gtk_text_iter_ends_tag "gboolean gtk_text_iter_ends_tag(GtkTextIter* iter, GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_ends_tag", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextTag_(tag) || Xen_is_false(tag), tag, 2, "gtk_text_iter_ends_tag", "GtkTextTag*");
  return(C_to_Xen_gboolean(gtk_text_iter_ends_tag(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gtk_text_iter_toggles_tag(Xen iter, Xen tag)
{
  #define H_gtk_text_iter_toggles_tag "gboolean gtk_text_iter_toggles_tag(GtkTextIter* iter, GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_toggles_tag", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextTag_(tag) || Xen_is_false(tag), tag, 2, "gtk_text_iter_toggles_tag", "GtkTextTag*");
  return(C_to_Xen_gboolean(gtk_text_iter_toggles_tag(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gtk_text_iter_has_tag(Xen iter, Xen tag)
{
  #define H_gtk_text_iter_has_tag "gboolean gtk_text_iter_has_tag(GtkTextIter* iter, GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_has_tag", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 2, "gtk_text_iter_has_tag", "GtkTextTag*");
  return(C_to_Xen_gboolean(gtk_text_iter_has_tag(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gtk_text_iter_get_tags(Xen iter)
{
  #define H_gtk_text_iter_get_tags "GSList* gtk_text_iter_get_tags(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_tags", "GtkTextIter*");
  return(C_to_Xen_GSList_(gtk_text_iter_get_tags(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_editable(Xen iter, Xen default_setting)
{
  #define H_gtk_text_iter_editable "gboolean gtk_text_iter_editable(GtkTextIter* iter, gboolean default_setting)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_editable", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(default_setting), default_setting, 2, "gtk_text_iter_editable", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_iter_editable(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gboolean(default_setting))));
}

static Xen gxg_gtk_text_iter_can_insert(Xen iter, Xen default_editability)
{
  #define H_gtk_text_iter_can_insert "gboolean gtk_text_iter_can_insert(GtkTextIter* iter, gboolean default_editability)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_can_insert", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(default_editability), default_editability, 2, "gtk_text_iter_can_insert", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_iter_can_insert(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gboolean(default_editability))));
}

static Xen gxg_gtk_text_iter_starts_word(Xen iter)
{
  #define H_gtk_text_iter_starts_word "gboolean gtk_text_iter_starts_word(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_starts_word", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_starts_word(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_ends_word(Xen iter)
{
  #define H_gtk_text_iter_ends_word "gboolean gtk_text_iter_ends_word(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_ends_word", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_ends_word(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_inside_word(Xen iter)
{
  #define H_gtk_text_iter_inside_word "gboolean gtk_text_iter_inside_word(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_inside_word", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_inside_word(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_starts_sentence(Xen iter)
{
  #define H_gtk_text_iter_starts_sentence "gboolean gtk_text_iter_starts_sentence(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_starts_sentence", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_starts_sentence(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_ends_sentence(Xen iter)
{
  #define H_gtk_text_iter_ends_sentence "gboolean gtk_text_iter_ends_sentence(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_ends_sentence", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_ends_sentence(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_inside_sentence(Xen iter)
{
  #define H_gtk_text_iter_inside_sentence "gboolean gtk_text_iter_inside_sentence(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_inside_sentence", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_inside_sentence(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_starts_line(Xen iter)
{
  #define H_gtk_text_iter_starts_line "gboolean gtk_text_iter_starts_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_starts_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_starts_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_ends_line(Xen iter)
{
  #define H_gtk_text_iter_ends_line "gboolean gtk_text_iter_ends_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_ends_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_ends_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_is_cursor_position(Xen iter)
{
  #define H_gtk_text_iter_is_cursor_position "gboolean gtk_text_iter_is_cursor_position(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_is_cursor_position", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_is_cursor_position(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_chars_in_line(Xen iter)
{
  #define H_gtk_text_iter_get_chars_in_line "gint gtk_text_iter_get_chars_in_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_chars_in_line", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_chars_in_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_bytes_in_line(Xen iter)
{
  #define H_gtk_text_iter_get_bytes_in_line "gint gtk_text_iter_get_bytes_in_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_bytes_in_line", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_get_bytes_in_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_get_language(Xen iter)
{
  #define H_gtk_text_iter_get_language "PangoLanguage* gtk_text_iter_get_language(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_language", "GtkTextIter*");
  return(C_to_Xen_PangoLanguage_(gtk_text_iter_get_language(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_is_end(Xen iter)
{
  #define H_gtk_text_iter_is_end "gboolean gtk_text_iter_is_end(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_is_end", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_is_end(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_is_start(Xen iter)
{
  #define H_gtk_text_iter_is_start "gboolean gtk_text_iter_is_start(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_is_start", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_is_start(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_char(Xen iter)
{
  #define H_gtk_text_iter_forward_char "gboolean gtk_text_iter_forward_char(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_char", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_char(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_backward_char(Xen iter)
{
  #define H_gtk_text_iter_backward_char "gboolean gtk_text_iter_backward_char(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_char", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_char(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_chars(Xen iter, Xen count)
{
  #define H_gtk_text_iter_forward_chars "gboolean gtk_text_iter_forward_chars(GtkTextIter* iter, gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_chars", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_forward_chars", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_chars(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_backward_chars(Xen iter, Xen count)
{
  #define H_gtk_text_iter_backward_chars "gboolean gtk_text_iter_backward_chars(GtkTextIter* iter, gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_chars", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_backward_chars", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_chars(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_forward_line(Xen iter)
{
  #define H_gtk_text_iter_forward_line "gboolean gtk_text_iter_forward_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_backward_line(Xen iter)
{
  #define H_gtk_text_iter_backward_line "gboolean gtk_text_iter_backward_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_lines(Xen iter, Xen count)
{
  #define H_gtk_text_iter_forward_lines "gboolean gtk_text_iter_forward_lines(GtkTextIter* iter, gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_lines", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_forward_lines", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_lines(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_backward_lines(Xen iter, Xen count)
{
  #define H_gtk_text_iter_backward_lines "gboolean gtk_text_iter_backward_lines(GtkTextIter* iter, gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_lines", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_backward_lines", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_lines(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_forward_word_end(Xen iter)
{
  #define H_gtk_text_iter_forward_word_end "gboolean gtk_text_iter_forward_word_end(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_word_end", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_word_end(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_backward_word_start(Xen iter)
{
  #define H_gtk_text_iter_backward_word_start "gboolean gtk_text_iter_backward_word_start(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_word_start", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_word_start(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_word_ends(Xen iter, Xen count)
{
  #define H_gtk_text_iter_forward_word_ends "gboolean gtk_text_iter_forward_word_ends(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_word_ends", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_forward_word_ends", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_word_ends(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_backward_word_starts(Xen iter, Xen count)
{
  #define H_gtk_text_iter_backward_word_starts "gboolean gtk_text_iter_backward_word_starts(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_word_starts", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_backward_word_starts", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_word_starts(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_forward_sentence_end(Xen iter)
{
  #define H_gtk_text_iter_forward_sentence_end "gboolean gtk_text_iter_forward_sentence_end(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_sentence_end", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_sentence_end(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_backward_sentence_start(Xen iter)
{
  #define H_gtk_text_iter_backward_sentence_start "gboolean gtk_text_iter_backward_sentence_start(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_sentence_start", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_sentence_start(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_sentence_ends(Xen iter, Xen count)
{
  #define H_gtk_text_iter_forward_sentence_ends "gboolean gtk_text_iter_forward_sentence_ends(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_sentence_ends", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_forward_sentence_ends", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_sentence_ends(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_backward_sentence_starts(Xen iter, Xen count)
{
  #define H_gtk_text_iter_backward_sentence_starts "gboolean gtk_text_iter_backward_sentence_starts(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_sentence_starts", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_backward_sentence_starts", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_sentence_starts(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_forward_cursor_position(Xen iter)
{
  #define H_gtk_text_iter_forward_cursor_position "gboolean gtk_text_iter_forward_cursor_position(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_cursor_position", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_cursor_position(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_backward_cursor_position(Xen iter)
{
  #define H_gtk_text_iter_backward_cursor_position "gboolean gtk_text_iter_backward_cursor_position(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_cursor_position", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_cursor_position(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_cursor_positions(Xen iter, Xen count)
{
  #define H_gtk_text_iter_forward_cursor_positions "gboolean gtk_text_iter_forward_cursor_positions(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_cursor_positions", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_forward_cursor_positions", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_cursor_positions(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_backward_cursor_positions(Xen iter, Xen count)
{
  #define H_gtk_text_iter_backward_cursor_positions "gboolean gtk_text_iter_backward_cursor_positions(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_cursor_positions", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_backward_cursor_positions", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_cursor_positions(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_set_offset(Xen iter, Xen char_offset)
{
  #define H_gtk_text_iter_set_offset "void gtk_text_iter_set_offset(GtkTextIter* iter, gint char_offset)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_set_offset", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(char_offset), char_offset, 2, "gtk_text_iter_set_offset", "gint");
  gtk_text_iter_set_offset(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(char_offset));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_set_line(Xen iter, Xen line_number)
{
  #define H_gtk_text_iter_set_line "void gtk_text_iter_set_line(GtkTextIter* iter, gint line_number)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_set_line", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(line_number), line_number, 2, "gtk_text_iter_set_line", "gint");
  gtk_text_iter_set_line(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(line_number));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_set_line_offset(Xen iter, Xen char_on_line)
{
  #define H_gtk_text_iter_set_line_offset "void gtk_text_iter_set_line_offset(GtkTextIter* iter, gint char_on_line)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_set_line_offset", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(char_on_line), char_on_line, 2, "gtk_text_iter_set_line_offset", "gint");
  gtk_text_iter_set_line_offset(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(char_on_line));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_set_line_index(Xen iter, Xen byte_on_line)
{
  #define H_gtk_text_iter_set_line_index "void gtk_text_iter_set_line_index(GtkTextIter* iter, gint byte_on_line)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_set_line_index", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(byte_on_line), byte_on_line, 2, "gtk_text_iter_set_line_index", "gint");
  gtk_text_iter_set_line_index(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(byte_on_line));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_forward_to_end(Xen iter)
{
  #define H_gtk_text_iter_forward_to_end "void gtk_text_iter_forward_to_end(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_to_end", "GtkTextIter*");
  gtk_text_iter_forward_to_end(Xen_to_C_GtkTextIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_forward_to_line_end(Xen iter)
{
  #define H_gtk_text_iter_forward_to_line_end "gboolean gtk_text_iter_forward_to_line_end(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_to_line_end", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_to_line_end(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_set_visible_line_offset(Xen iter, Xen char_on_line)
{
  #define H_gtk_text_iter_set_visible_line_offset "void gtk_text_iter_set_visible_line_offset(GtkTextIter* iter, \
gint char_on_line)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_set_visible_line_offset", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(char_on_line), char_on_line, 2, "gtk_text_iter_set_visible_line_offset", "gint");
  gtk_text_iter_set_visible_line_offset(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(char_on_line));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_set_visible_line_index(Xen iter, Xen byte_on_line)
{
  #define H_gtk_text_iter_set_visible_line_index "void gtk_text_iter_set_visible_line_index(GtkTextIter* iter, \
gint byte_on_line)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_set_visible_line_index", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(byte_on_line), byte_on_line, 2, "gtk_text_iter_set_visible_line_index", "gint");
  gtk_text_iter_set_visible_line_index(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(byte_on_line));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_forward_to_tag_toggle(Xen iter, Xen tag)
{
  #define H_gtk_text_iter_forward_to_tag_toggle "gboolean gtk_text_iter_forward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_to_tag_toggle", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextTag_(tag) || Xen_is_false(tag), tag, 2, "gtk_text_iter_forward_to_tag_toggle", "GtkTextTag*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_to_tag_toggle(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gtk_text_iter_backward_to_tag_toggle(Xen iter, Xen tag)
{
  #define H_gtk_text_iter_backward_to_tag_toggle "gboolean gtk_text_iter_backward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_to_tag_toggle", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextTag_(tag) || Xen_is_false(tag), tag, 2, "gtk_text_iter_backward_to_tag_toggle", "GtkTextTag*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_to_tag_toggle(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gtk_text_iter_forward_find_char(Xen iter, Xen pred, Xen func_info, Xen limit)
{
  #define H_gtk_text_iter_forward_find_char "gboolean gtk_text_iter_forward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_info, GtkTextIter* limit)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_find_char", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextCharPredicate(pred), pred, 2, "gtk_text_iter_forward_find_char", "GtkTextCharPredicate");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_text_iter_forward_find_char", "lambda_data");
  Xen_check_type(Xen_is_GtkTextIter_(limit) || Xen_is_false(limit), limit, 4, "gtk_text_iter_forward_find_char", "GtkTextIter*");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_gboolean(gtk_text_iter_forward_find_char(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextCharPredicate(pred), 
                                                               Xen_to_C_lambda_data(func_info), Xen_to_C_GtkTextIter_(limit)));
    xm_unprotect_at(loc);
    return(result);
   }
}

static Xen gxg_gtk_text_iter_backward_find_char(Xen iter, Xen pred, Xen func_info, Xen limit)
{
  #define H_gtk_text_iter_backward_find_char "gboolean gtk_text_iter_backward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_info, GtkTextIter* limit)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_find_char", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextCharPredicate(pred), pred, 2, "gtk_text_iter_backward_find_char", "GtkTextCharPredicate");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_text_iter_backward_find_char", "lambda_data");
  Xen_check_type(Xen_is_GtkTextIter_(limit) || Xen_is_false(limit), limit, 4, "gtk_text_iter_backward_find_char", "GtkTextIter*");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_gboolean(gtk_text_iter_backward_find_char(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextCharPredicate(pred), 
                                                                Xen_to_C_lambda_data(func_info), Xen_to_C_GtkTextIter_(limit)));
    xm_unprotect_at(loc);
    return(result);
   }
}

static Xen gxg_gtk_text_iter_forward_search(Xen iter, Xen str, Xen flags, Xen match_start, Xen match_end, Xen limit)
{
  #define H_gtk_text_iter_forward_search "gboolean gtk_text_iter_forward_search(GtkTextIter* iter, gchar* str, \
GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_search", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_text_iter_forward_search", "gchar*");
  Xen_check_type(Xen_is_GtkTextSearchFlags(flags), flags, 3, "gtk_text_iter_forward_search", "GtkTextSearchFlags");
  Xen_check_type(Xen_is_GtkTextIter_(match_start) || Xen_is_false(match_start), match_start, 4, "gtk_text_iter_forward_search", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(match_end) || Xen_is_false(match_end), match_end, 5, "gtk_text_iter_forward_search", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(limit) || Xen_is_false(limit), limit, 6, "gtk_text_iter_forward_search", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_search(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gchar_(str), Xen_to_C_GtkTextSearchFlags(flags), 
                                                        Xen_to_C_GtkTextIter_(match_start), Xen_to_C_GtkTextIter_(match_end), 
                                                        Xen_to_C_GtkTextIter_(limit))));
}

static Xen gxg_gtk_text_iter_backward_search(Xen iter, Xen str, Xen flags, Xen match_start, Xen match_end, Xen limit)
{
  #define H_gtk_text_iter_backward_search "gboolean gtk_text_iter_backward_search(GtkTextIter* iter, \
gchar* str, GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_search", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_text_iter_backward_search", "gchar*");
  Xen_check_type(Xen_is_GtkTextSearchFlags(flags), flags, 3, "gtk_text_iter_backward_search", "GtkTextSearchFlags");
  Xen_check_type(Xen_is_GtkTextIter_(match_start) || Xen_is_false(match_start), match_start, 4, "gtk_text_iter_backward_search", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(match_end) || Xen_is_false(match_end), match_end, 5, "gtk_text_iter_backward_search", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(limit) || Xen_is_false(limit), limit, 6, "gtk_text_iter_backward_search", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_search(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gchar_(str), Xen_to_C_GtkTextSearchFlags(flags), 
                                                         Xen_to_C_GtkTextIter_(match_start), Xen_to_C_GtkTextIter_(match_end), 
                                                         Xen_to_C_GtkTextIter_(limit))));
}

static Xen gxg_gtk_text_iter_equal(Xen lhs, Xen rhs)
{
  #define H_gtk_text_iter_equal "gboolean gtk_text_iter_equal(GtkTextIter* lhs, GtkTextIter* rhs)"
  Xen_check_type(Xen_is_GtkTextIter_(lhs), lhs, 1, "gtk_text_iter_equal", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(rhs), rhs, 2, "gtk_text_iter_equal", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_equal(Xen_to_C_GtkTextIter_(lhs), Xen_to_C_GtkTextIter_(rhs))));
}

static Xen gxg_gtk_text_iter_compare(Xen lhs, Xen rhs)
{
  #define H_gtk_text_iter_compare "gint gtk_text_iter_compare(GtkTextIter* lhs, GtkTextIter* rhs)"
  Xen_check_type(Xen_is_GtkTextIter_(lhs), lhs, 1, "gtk_text_iter_compare", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(rhs), rhs, 2, "gtk_text_iter_compare", "GtkTextIter*");
  return(C_to_Xen_gint(gtk_text_iter_compare(Xen_to_C_GtkTextIter_(lhs), Xen_to_C_GtkTextIter_(rhs))));
}

static Xen gxg_gtk_text_iter_in_range(Xen iter, Xen start, Xen end)
{
  #define H_gtk_text_iter_in_range "gboolean gtk_text_iter_in_range(GtkTextIter* iter, GtkTextIter* start, \
GtkTextIter* end)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_in_range", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(start), start, 2, "gtk_text_iter_in_range", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(end), end, 3, "gtk_text_iter_in_range", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_in_range(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextIter_(start), Xen_to_C_GtkTextIter_(end))));
}

static Xen gxg_gtk_text_iter_order(Xen first, Xen second)
{
  #define H_gtk_text_iter_order "void gtk_text_iter_order(GtkTextIter* first, GtkTextIter* second)"
  Xen_check_type(Xen_is_GtkTextIter_(first), first, 1, "gtk_text_iter_order", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(second), second, 2, "gtk_text_iter_order", "GtkTextIter*");
  gtk_text_iter_order(Xen_to_C_GtkTextIter_(first), Xen_to_C_GtkTextIter_(second));
  return(Xen_false);
}

static Xen gxg_gtk_text_mark_set_visible(Xen mark, Xen setting)
{
  #define H_gtk_text_mark_set_visible "void gtk_text_mark_set_visible(GtkTextMark* mark, gboolean setting)"
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 1, "gtk_text_mark_set_visible", "GtkTextMark*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_text_mark_set_visible", "gboolean");
  gtk_text_mark_set_visible(Xen_to_C_GtkTextMark_(mark), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_text_mark_get_visible(Xen mark)
{
  #define H_gtk_text_mark_get_visible "gboolean gtk_text_mark_get_visible(GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 1, "gtk_text_mark_get_visible", "GtkTextMark*");
  return(C_to_Xen_gboolean(gtk_text_mark_get_visible(Xen_to_C_GtkTextMark_(mark))));
}

static Xen gxg_gtk_text_mark_get_name(Xen mark)
{
  #define H_gtk_text_mark_get_name "char* gtk_text_mark_get_name(GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 1, "gtk_text_mark_get_name", "GtkTextMark*");
  return(C_to_Xen_char_(gtk_text_mark_get_name(Xen_to_C_GtkTextMark_(mark))));
}

static Xen gxg_gtk_text_mark_get_deleted(Xen mark)
{
  #define H_gtk_text_mark_get_deleted "gboolean gtk_text_mark_get_deleted(GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 1, "gtk_text_mark_get_deleted", "GtkTextMark*");
  return(C_to_Xen_gboolean(gtk_text_mark_get_deleted(Xen_to_C_GtkTextMark_(mark))));
}

static Xen gxg_gtk_text_mark_get_buffer(Xen mark)
{
  #define H_gtk_text_mark_get_buffer "GtkTextBuffer* gtk_text_mark_get_buffer(GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 1, "gtk_text_mark_get_buffer", "GtkTextMark*");
  return(C_to_Xen_GtkTextBuffer_(gtk_text_mark_get_buffer(Xen_to_C_GtkTextMark_(mark))));
}

static Xen gxg_gtk_text_mark_get_left_gravity(Xen mark)
{
  #define H_gtk_text_mark_get_left_gravity "gboolean gtk_text_mark_get_left_gravity(GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 1, "gtk_text_mark_get_left_gravity", "GtkTextMark*");
  return(C_to_Xen_gboolean(gtk_text_mark_get_left_gravity(Xen_to_C_GtkTextMark_(mark))));
}

static Xen gxg_gtk_text_tag_new(Xen name)
{
  #define H_gtk_text_tag_new "GtkTextTag* gtk_text_tag_new(gchar* name)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "gtk_text_tag_new", "gchar*");
  return(C_to_Xen_GtkTextTag_(gtk_text_tag_new(Xen_to_C_gchar_(name))));
}

static Xen gxg_gtk_text_tag_get_priority(Xen tag)
{
  #define H_gtk_text_tag_get_priority "gint gtk_text_tag_get_priority(GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 1, "gtk_text_tag_get_priority", "GtkTextTag*");
  return(C_to_Xen_gint(gtk_text_tag_get_priority(Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gtk_text_tag_set_priority(Xen tag, Xen priority)
{
  #define H_gtk_text_tag_set_priority "void gtk_text_tag_set_priority(GtkTextTag* tag, gint priority)"
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 1, "gtk_text_tag_set_priority", "GtkTextTag*");
  Xen_check_type(Xen_is_gint(priority), priority, 2, "gtk_text_tag_set_priority", "gint");
  gtk_text_tag_set_priority(Xen_to_C_GtkTextTag_(tag), Xen_to_C_gint(priority));
  return(Xen_false);
}

static Xen gxg_gtk_text_tag_table_new(void)
{
  #define H_gtk_text_tag_table_new "GtkTextTagTable* gtk_text_tag_table_new( void)"
  return(C_to_Xen_GtkTextTagTable_(gtk_text_tag_table_new()));
}

static Xen gxg_gtk_text_tag_table_add(Xen table, Xen tag)
{
  #define H_gtk_text_tag_table_add "void gtk_text_tag_table_add(GtkTextTagTable* table, GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextTagTable_(table), table, 1, "gtk_text_tag_table_add", "GtkTextTagTable*");
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 2, "gtk_text_tag_table_add", "GtkTextTag*");
  gtk_text_tag_table_add(Xen_to_C_GtkTextTagTable_(table), Xen_to_C_GtkTextTag_(tag));
  return(Xen_false);
}

static Xen gxg_gtk_text_tag_table_remove(Xen table, Xen tag)
{
  #define H_gtk_text_tag_table_remove "void gtk_text_tag_table_remove(GtkTextTagTable* table, GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextTagTable_(table), table, 1, "gtk_text_tag_table_remove", "GtkTextTagTable*");
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 2, "gtk_text_tag_table_remove", "GtkTextTag*");
  gtk_text_tag_table_remove(Xen_to_C_GtkTextTagTable_(table), Xen_to_C_GtkTextTag_(tag));
  return(Xen_false);
}

static Xen gxg_gtk_text_tag_table_lookup(Xen table, Xen name)
{
  #define H_gtk_text_tag_table_lookup "GtkTextTag* gtk_text_tag_table_lookup(GtkTextTagTable* table, \
gchar* name)"
  Xen_check_type(Xen_is_GtkTextTagTable_(table), table, 1, "gtk_text_tag_table_lookup", "GtkTextTagTable*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_text_tag_table_lookup", "gchar*");
  return(C_to_Xen_GtkTextTag_(gtk_text_tag_table_lookup(Xen_to_C_GtkTextTagTable_(table), Xen_to_C_gchar_(name))));
}

static Xen gxg_gtk_text_tag_table_foreach(Xen table, Xen func, Xen func_info)
{
  #define H_gtk_text_tag_table_foreach "void gtk_text_tag_table_foreach(GtkTextTagTable* table, GtkTextTagTableForeach func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_GtkTextTagTable_(table), table, 1, "gtk_text_tag_table_foreach", "GtkTextTagTable*");
  Xen_check_type(Xen_is_GtkTextTagTableForeach(func), func, 2, "gtk_text_tag_table_foreach", "GtkTextTagTableForeach");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_text_tag_table_foreach", "lambda_data");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_text_tag_table_foreach(Xen_to_C_GtkTextTagTable_(table), Xen_to_C_GtkTextTagTableForeach(func), Xen_to_C_lambda_data(func_info));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_text_tag_table_get_size(Xen table)
{
  #define H_gtk_text_tag_table_get_size "gint gtk_text_tag_table_get_size(GtkTextTagTable* table)"
  Xen_check_type(Xen_is_GtkTextTagTable_(table), table, 1, "gtk_text_tag_table_get_size", "GtkTextTagTable*");
  return(C_to_Xen_gint(gtk_text_tag_table_get_size(Xen_to_C_GtkTextTagTable_(table))));
}

static Xen gxg_gtk_text_view_new(void)
{
  #define H_gtk_text_view_new "GtkWidget* gtk_text_view_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_text_view_new()));
}

static Xen gxg_gtk_text_view_new_with_buffer(Xen buffer)
{
  #define H_gtk_text_view_new_with_buffer "GtkWidget* gtk_text_view_new_with_buffer(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_view_new_with_buffer", "GtkTextBuffer*");
  return(C_to_Xen_GtkWidget_(gtk_text_view_new_with_buffer(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_text_view_set_buffer(Xen text_view, Xen buffer)
{
  #define H_gtk_text_view_set_buffer "void gtk_text_view_set_buffer(GtkTextView* text_view, GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_buffer", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 2, "gtk_text_view_set_buffer", "GtkTextBuffer*");
  gtk_text_view_set_buffer(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextBuffer_(buffer));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_buffer(Xen text_view)
{
  #define H_gtk_text_view_get_buffer "GtkTextBuffer* gtk_text_view_get_buffer(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_buffer", "GtkTextView*");
  return(C_to_Xen_GtkTextBuffer_(gtk_text_view_get_buffer(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_scroll_to_iter(Xen text_view, Xen iter, Xen within_margin, Xen use_align, Xen xalign, Xen yalign)
{
  #define H_gtk_text_view_scroll_to_iter "gboolean gtk_text_view_scroll_to_iter(GtkTextView* text_view, \
GtkTextIter* iter, gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_scroll_to_iter", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_scroll_to_iter", "GtkTextIter*");
  Xen_check_type(Xen_is_gdouble(within_margin), within_margin, 3, "gtk_text_view_scroll_to_iter", "gdouble");
  Xen_check_type(Xen_is_gboolean(use_align), use_align, 4, "gtk_text_view_scroll_to_iter", "gboolean");
  Xen_check_type(Xen_is_gdouble(xalign), xalign, 5, "gtk_text_view_scroll_to_iter", "gdouble");
  Xen_check_type(Xen_is_gdouble(yalign), yalign, 6, "gtk_text_view_scroll_to_iter", "gdouble");
  return(C_to_Xen_gboolean(gtk_text_view_scroll_to_iter(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gdouble(within_margin), 
                                                        Xen_to_C_gboolean(use_align), Xen_to_C_gdouble(xalign), Xen_to_C_gdouble(yalign))));
}

static Xen gxg_gtk_text_view_scroll_to_mark(Xen text_view, Xen mark, Xen within_margin, Xen use_align, Xen xalign, Xen yalign)
{
  #define H_gtk_text_view_scroll_to_mark "void gtk_text_view_scroll_to_mark(GtkTextView* text_view, GtkTextMark* mark, \
gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_scroll_to_mark", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 2, "gtk_text_view_scroll_to_mark", "GtkTextMark*");
  Xen_check_type(Xen_is_gdouble(within_margin), within_margin, 3, "gtk_text_view_scroll_to_mark", "gdouble");
  Xen_check_type(Xen_is_gboolean(use_align), use_align, 4, "gtk_text_view_scroll_to_mark", "gboolean");
  Xen_check_type(Xen_is_gdouble(xalign), xalign, 5, "gtk_text_view_scroll_to_mark", "gdouble");
  Xen_check_type(Xen_is_gdouble(yalign), yalign, 6, "gtk_text_view_scroll_to_mark", "gdouble");
  gtk_text_view_scroll_to_mark(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextMark_(mark), Xen_to_C_gdouble(within_margin), 
                               Xen_to_C_gboolean(use_align), Xen_to_C_gdouble(xalign), Xen_to_C_gdouble(yalign));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_scroll_mark_onscreen(Xen text_view, Xen mark)
{
  #define H_gtk_text_view_scroll_mark_onscreen "void gtk_text_view_scroll_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_scroll_mark_onscreen", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 2, "gtk_text_view_scroll_mark_onscreen", "GtkTextMark*");
  gtk_text_view_scroll_mark_onscreen(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextMark_(mark));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_move_mark_onscreen(Xen text_view, Xen mark)
{
  #define H_gtk_text_view_move_mark_onscreen "gboolean gtk_text_view_move_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_move_mark_onscreen", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 2, "gtk_text_view_move_mark_onscreen", "GtkTextMark*");
  return(C_to_Xen_gboolean(gtk_text_view_move_mark_onscreen(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextMark_(mark))));
}

static Xen gxg_gtk_text_view_place_cursor_onscreen(Xen text_view)
{
  #define H_gtk_text_view_place_cursor_onscreen "gboolean gtk_text_view_place_cursor_onscreen(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_place_cursor_onscreen", "GtkTextView*");
  return(C_to_Xen_gboolean(gtk_text_view_place_cursor_onscreen(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_get_visible_rect(Xen text_view, Xen visible_rect)
{
  #define H_gtk_text_view_get_visible_rect "void gtk_text_view_get_visible_rect(GtkTextView* text_view, \
GdkRectangle* visible_rect)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_visible_rect", "GtkTextView*");
  Xen_check_type(Xen_is_GdkRectangle_(visible_rect), visible_rect, 2, "gtk_text_view_get_visible_rect", "GdkRectangle*");
  gtk_text_view_get_visible_rect(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GdkRectangle_(visible_rect));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_set_cursor_visible(Xen text_view, Xen setting)
{
  #define H_gtk_text_view_set_cursor_visible "void gtk_text_view_set_cursor_visible(GtkTextView* text_view, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_cursor_visible", "GtkTextView*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_text_view_set_cursor_visible", "gboolean");
  gtk_text_view_set_cursor_visible(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_cursor_visible(Xen text_view)
{
  #define H_gtk_text_view_get_cursor_visible "gboolean gtk_text_view_get_cursor_visible(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_cursor_visible", "GtkTextView*");
  return(C_to_Xen_gboolean(gtk_text_view_get_cursor_visible(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_get_iter_location(Xen text_view, Xen iter, Xen location)
{
  #define H_gtk_text_view_get_iter_location "void gtk_text_view_get_iter_location(GtkTextView* text_view, \
GtkTextIter* iter, GdkRectangle* location)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_iter_location", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_get_iter_location", "GtkTextIter*");
  Xen_check_type(Xen_is_GdkRectangle_(location), location, 3, "gtk_text_view_get_iter_location", "GdkRectangle*");
  gtk_text_view_get_iter_location(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), Xen_to_C_GdkRectangle_(location));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_line_yrange(Xen text_view, Xen iter, Xen ignore_y, Xen ignore_height)
{
  #define H_gtk_text_view_get_line_yrange "void gtk_text_view_get_line_yrange(GtkTextView* text_view, \
GtkTextIter* iter, gint* [y], gint* [height])"
  gint ref_y;
  gint ref_height;
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_line_yrange", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_get_line_yrange", "GtkTextIter*");
  gtk_text_view_get_line_yrange(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), &ref_y, &ref_height);
  return(Xen_list_2(C_to_Xen_gint(ref_y), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gtk_text_view_get_line_at_y(Xen text_view, Xen target_iter, Xen y, Xen ignore_line_top)
{
  #define H_gtk_text_view_get_line_at_y "void gtk_text_view_get_line_at_y(GtkTextView* text_view, GtkTextIter* target_iter, \
gint y, gint* [line_top])"
  gint ref_line_top;
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_line_at_y", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(target_iter), target_iter, 2, "gtk_text_view_get_line_at_y", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_text_view_get_line_at_y", "gint");
  gtk_text_view_get_line_at_y(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(target_iter), Xen_to_C_gint(y), &ref_line_top);
  return(Xen_list_1(C_to_Xen_gint(ref_line_top)));
}

static Xen gxg_gtk_text_view_buffer_to_window_coords(Xen text_view, Xen win, Xen buffer_x, Xen buffer_y, Xen ignore_window_x, Xen ignore_window_y)
{
  #define H_gtk_text_view_buffer_to_window_coords "void gtk_text_view_buffer_to_window_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint buffer_x, gint buffer_y, gint* [window_x], gint* [window_y])"
  gint ref_window_x;
  gint ref_window_y;
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_buffer_to_window_coords", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextWindowType(win), win, 2, "gtk_text_view_buffer_to_window_coords", "GtkTextWindowType");
  Xen_check_type(Xen_is_gint(buffer_x), buffer_x, 3, "gtk_text_view_buffer_to_window_coords", "gint");
  Xen_check_type(Xen_is_gint(buffer_y), buffer_y, 4, "gtk_text_view_buffer_to_window_coords", "gint");
  gtk_text_view_buffer_to_window_coords(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextWindowType(win), Xen_to_C_gint(buffer_x), 
                                        Xen_to_C_gint(buffer_y), &ref_window_x, &ref_window_y);
  return(Xen_list_2(C_to_Xen_gint(ref_window_x), C_to_Xen_gint(ref_window_y)));
}

static Xen gxg_gtk_text_view_window_to_buffer_coords(Xen text_view, Xen win, Xen window_x, Xen window_y, Xen ignore_buffer_x, Xen ignore_buffer_y)
{
  #define H_gtk_text_view_window_to_buffer_coords "void gtk_text_view_window_to_buffer_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint window_x, gint window_y, gint* [buffer_x], gint* [buffer_y])"
  gint ref_buffer_x;
  gint ref_buffer_y;
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_window_to_buffer_coords", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextWindowType(win), win, 2, "gtk_text_view_window_to_buffer_coords", "GtkTextWindowType");
  Xen_check_type(Xen_is_gint(window_x), window_x, 3, "gtk_text_view_window_to_buffer_coords", "gint");
  Xen_check_type(Xen_is_gint(window_y), window_y, 4, "gtk_text_view_window_to_buffer_coords", "gint");
  gtk_text_view_window_to_buffer_coords(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextWindowType(win), Xen_to_C_gint(window_x), 
                                        Xen_to_C_gint(window_y), &ref_buffer_x, &ref_buffer_y);
  return(Xen_list_2(C_to_Xen_gint(ref_buffer_x), C_to_Xen_gint(ref_buffer_y)));
}

static Xen gxg_gtk_text_view_set_border_window_size(Xen text_view, Xen type, Xen size)
{
  #define H_gtk_text_view_set_border_window_size "void gtk_text_view_set_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type, gint size)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_border_window_size", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextWindowType(type), type, 2, "gtk_text_view_set_border_window_size", "GtkTextWindowType");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_text_view_set_border_window_size", "gint");
  gtk_text_view_set_border_window_size(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextWindowType(type), Xen_to_C_gint(size));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_border_window_size(Xen text_view, Xen type)
{
  #define H_gtk_text_view_get_border_window_size "gint gtk_text_view_get_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_border_window_size", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextWindowType(type), type, 2, "gtk_text_view_get_border_window_size", "GtkTextWindowType");
  return(C_to_Xen_gint(gtk_text_view_get_border_window_size(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextWindowType(type))));
}

static Xen gxg_gtk_text_view_forward_display_line(Xen text_view, Xen iter)
{
  #define H_gtk_text_view_forward_display_line "gboolean gtk_text_view_forward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_forward_display_line", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_forward_display_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_view_forward_display_line(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_view_backward_display_line(Xen text_view, Xen iter)
{
  #define H_gtk_text_view_backward_display_line "gboolean gtk_text_view_backward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_backward_display_line", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_backward_display_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_view_backward_display_line(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_view_forward_display_line_end(Xen text_view, Xen iter)
{
  #define H_gtk_text_view_forward_display_line_end "gboolean gtk_text_view_forward_display_line_end(GtkTextView* text_view, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_forward_display_line_end", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_forward_display_line_end", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_view_forward_display_line_end(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_view_backward_display_line_start(Xen text_view, Xen iter)
{
  #define H_gtk_text_view_backward_display_line_start "gboolean gtk_text_view_backward_display_line_start(GtkTextView* text_view, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_backward_display_line_start", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_backward_display_line_start", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_view_backward_display_line_start(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_view_starts_display_line(Xen text_view, Xen iter)
{
  #define H_gtk_text_view_starts_display_line "gboolean gtk_text_view_starts_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_starts_display_line", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_starts_display_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_view_starts_display_line(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_view_move_visually(Xen text_view, Xen iter, Xen count)
{
  #define H_gtk_text_view_move_visually "gboolean gtk_text_view_move_visually(GtkTextView* text_view, \
GtkTextIter* iter, gint count)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_move_visually", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_move_visually", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 3, "gtk_text_view_move_visually", "gint");
  return(C_to_Xen_gboolean(gtk_text_view_move_visually(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_view_add_child_at_anchor(Xen text_view, Xen child, Xen anchor)
{
  #define H_gtk_text_view_add_child_at_anchor "void gtk_text_view_add_child_at_anchor(GtkTextView* text_view, \
GtkWidget* child, GtkTextChildAnchor* anchor)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_add_child_at_anchor", "GtkTextView*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_text_view_add_child_at_anchor", "GtkWidget*");
  Xen_check_type(Xen_is_GtkTextChildAnchor_(anchor), anchor, 3, "gtk_text_view_add_child_at_anchor", "GtkTextChildAnchor*");
  gtk_text_view_add_child_at_anchor(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkTextChildAnchor_(anchor));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_add_child_in_window(Xen text_view, Xen child, Xen which_window, Xen xpos, Xen ypos)
{
  #define H_gtk_text_view_add_child_in_window "void gtk_text_view_add_child_in_window(GtkTextView* text_view, \
GtkWidget* child, GtkTextWindowType which_window, gint xpos, gint ypos)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_add_child_in_window", "GtkTextView*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_text_view_add_child_in_window", "GtkWidget*");
  Xen_check_type(Xen_is_GtkTextWindowType(which_window), which_window, 3, "gtk_text_view_add_child_in_window", "GtkTextWindowType");
  Xen_check_type(Xen_is_gint(xpos), xpos, 4, "gtk_text_view_add_child_in_window", "gint");
  Xen_check_type(Xen_is_gint(ypos), ypos, 5, "gtk_text_view_add_child_in_window", "gint");
  gtk_text_view_add_child_in_window(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkTextWindowType(which_window), 
                                    Xen_to_C_gint(xpos), Xen_to_C_gint(ypos));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_move_child(Xen text_view, Xen child, Xen xpos, Xen ypos)
{
  #define H_gtk_text_view_move_child "void gtk_text_view_move_child(GtkTextView* text_view, GtkWidget* child, \
gint xpos, gint ypos)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_move_child", "GtkTextView*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_text_view_move_child", "GtkWidget*");
  Xen_check_type(Xen_is_gint(xpos), xpos, 3, "gtk_text_view_move_child", "gint");
  Xen_check_type(Xen_is_gint(ypos), ypos, 4, "gtk_text_view_move_child", "gint");
  gtk_text_view_move_child(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(xpos), Xen_to_C_gint(ypos));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_set_wrap_mode(Xen text_view, Xen wrap_mode)
{
  #define H_gtk_text_view_set_wrap_mode "void gtk_text_view_set_wrap_mode(GtkTextView* text_view, GtkWrapMode wrap_mode)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_wrap_mode", "GtkTextView*");
  Xen_check_type(Xen_is_GtkWrapMode(wrap_mode), wrap_mode, 2, "gtk_text_view_set_wrap_mode", "GtkWrapMode");
  gtk_text_view_set_wrap_mode(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkWrapMode(wrap_mode));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_wrap_mode(Xen text_view)
{
  #define H_gtk_text_view_get_wrap_mode "GtkWrapMode gtk_text_view_get_wrap_mode(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_wrap_mode", "GtkTextView*");
  return(C_to_Xen_GtkWrapMode(gtk_text_view_get_wrap_mode(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_editable(Xen text_view, Xen setting)
{
  #define H_gtk_text_view_set_editable "void gtk_text_view_set_editable(GtkTextView* text_view, gboolean setting)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_editable", "GtkTextView*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_text_view_set_editable", "gboolean");
  gtk_text_view_set_editable(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_editable(Xen text_view)
{
  #define H_gtk_text_view_get_editable "gboolean gtk_text_view_get_editable(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_editable", "GtkTextView*");
  return(C_to_Xen_gboolean(gtk_text_view_get_editable(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_pixels_above_lines(Xen text_view, Xen pixels_above_lines)
{
  #define H_gtk_text_view_set_pixels_above_lines "void gtk_text_view_set_pixels_above_lines(GtkTextView* text_view, \
gint pixels_above_lines)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_pixels_above_lines", "GtkTextView*");
  Xen_check_type(Xen_is_gint(pixels_above_lines), pixels_above_lines, 2, "gtk_text_view_set_pixels_above_lines", "gint");
  gtk_text_view_set_pixels_above_lines(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(pixels_above_lines));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_pixels_above_lines(Xen text_view)
{
  #define H_gtk_text_view_get_pixels_above_lines "gint gtk_text_view_get_pixels_above_lines(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_pixels_above_lines", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_pixels_above_lines(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_pixels_below_lines(Xen text_view, Xen pixels_below_lines)
{
  #define H_gtk_text_view_set_pixels_below_lines "void gtk_text_view_set_pixels_below_lines(GtkTextView* text_view, \
gint pixels_below_lines)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_pixels_below_lines", "GtkTextView*");
  Xen_check_type(Xen_is_gint(pixels_below_lines), pixels_below_lines, 2, "gtk_text_view_set_pixels_below_lines", "gint");
  gtk_text_view_set_pixels_below_lines(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(pixels_below_lines));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_pixels_below_lines(Xen text_view)
{
  #define H_gtk_text_view_get_pixels_below_lines "gint gtk_text_view_get_pixels_below_lines(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_pixels_below_lines", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_pixels_below_lines(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_pixels_inside_wrap(Xen text_view, Xen pixels_inside_wrap)
{
  #define H_gtk_text_view_set_pixels_inside_wrap "void gtk_text_view_set_pixels_inside_wrap(GtkTextView* text_view, \
gint pixels_inside_wrap)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_pixels_inside_wrap", "GtkTextView*");
  Xen_check_type(Xen_is_gint(pixels_inside_wrap), pixels_inside_wrap, 2, "gtk_text_view_set_pixels_inside_wrap", "gint");
  gtk_text_view_set_pixels_inside_wrap(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(pixels_inside_wrap));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_pixels_inside_wrap(Xen text_view)
{
  #define H_gtk_text_view_get_pixels_inside_wrap "gint gtk_text_view_get_pixels_inside_wrap(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_pixels_inside_wrap", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_pixels_inside_wrap(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_justification(Xen text_view, Xen justification)
{
  #define H_gtk_text_view_set_justification "void gtk_text_view_set_justification(GtkTextView* text_view, \
GtkJustification justification)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_justification", "GtkTextView*");
  Xen_check_type(Xen_is_GtkJustification(justification), justification, 2, "gtk_text_view_set_justification", "GtkJustification");
  gtk_text_view_set_justification(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkJustification(justification));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_justification(Xen text_view)
{
  #define H_gtk_text_view_get_justification "GtkJustification gtk_text_view_get_justification(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_justification", "GtkTextView*");
  return(C_to_Xen_GtkJustification(gtk_text_view_get_justification(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_left_margin(Xen text_view, Xen left_margin)
{
  #define H_gtk_text_view_set_left_margin "void gtk_text_view_set_left_margin(GtkTextView* text_view, \
gint left_margin)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_left_margin", "GtkTextView*");
  Xen_check_type(Xen_is_gint(left_margin), left_margin, 2, "gtk_text_view_set_left_margin", "gint");
  gtk_text_view_set_left_margin(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(left_margin));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_left_margin(Xen text_view)
{
  #define H_gtk_text_view_get_left_margin "gint gtk_text_view_get_left_margin(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_left_margin", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_left_margin(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_right_margin(Xen text_view, Xen right_margin)
{
  #define H_gtk_text_view_set_right_margin "void gtk_text_view_set_right_margin(GtkTextView* text_view, \
gint right_margin)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_right_margin", "GtkTextView*");
  Xen_check_type(Xen_is_gint(right_margin), right_margin, 2, "gtk_text_view_set_right_margin", "gint");
  gtk_text_view_set_right_margin(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(right_margin));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_right_margin(Xen text_view)
{
  #define H_gtk_text_view_get_right_margin "gint gtk_text_view_get_right_margin(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_right_margin", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_right_margin(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_indent(Xen text_view, Xen indent)
{
  #define H_gtk_text_view_set_indent "void gtk_text_view_set_indent(GtkTextView* text_view, gint indent)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_indent", "GtkTextView*");
  Xen_check_type(Xen_is_gint(indent), indent, 2, "gtk_text_view_set_indent", "gint");
  gtk_text_view_set_indent(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(indent));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_indent(Xen text_view)
{
  #define H_gtk_text_view_get_indent "gint gtk_text_view_get_indent(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_indent", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_indent(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_tabs(Xen text_view, Xen tabs)
{
  #define H_gtk_text_view_set_tabs "void gtk_text_view_set_tabs(GtkTextView* text_view, PangoTabArray* tabs)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_tabs", "GtkTextView*");
  Xen_check_type(Xen_is_PangoTabArray_(tabs) || Xen_is_false(tabs), tabs, 2, "gtk_text_view_set_tabs", "PangoTabArray*");
  gtk_text_view_set_tabs(Xen_to_C_GtkTextView_(text_view), Xen_to_C_PangoTabArray_(tabs));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_tabs(Xen text_view)
{
  #define H_gtk_text_view_get_tabs "PangoTabArray* gtk_text_view_get_tabs(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_tabs", "GtkTextView*");
  return(C_to_Xen_PangoTabArray_(gtk_text_view_get_tabs(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_toggle_button_new(void)
{
  #define H_gtk_toggle_button_new "GtkWidget* gtk_toggle_button_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_toggle_button_new()));
}

static Xen gxg_gtk_toggle_button_new_with_label(Xen label)
{
  #define H_gtk_toggle_button_new_with_label "GtkWidget* gtk_toggle_button_new_with_label(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_toggle_button_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_toggle_button_new_with_label(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_toggle_button_new_with_mnemonic(Xen label)
{
  #define H_gtk_toggle_button_new_with_mnemonic "GtkWidget* gtk_toggle_button_new_with_mnemonic(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_toggle_button_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_toggle_button_new_with_mnemonic(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_toggle_button_set_active(Xen toggle_button, Xen is_active)
{
  #define H_gtk_toggle_button_set_active "void gtk_toggle_button_set_active(GtkToggleButton* toggle_button, \
gboolean is_active)"
  Xen_check_type(Xen_is_GtkToggleButton_(toggle_button), toggle_button, 1, "gtk_toggle_button_set_active", "GtkToggleButton*");
  Xen_check_type(Xen_is_gboolean(is_active), is_active, 2, "gtk_toggle_button_set_active", "gboolean");
  gtk_toggle_button_set_active(Xen_to_C_GtkToggleButton_(toggle_button), Xen_to_C_gboolean(is_active));
  return(Xen_false);
}

static Xen gxg_gtk_toggle_button_get_active(Xen toggle_button)
{
  #define H_gtk_toggle_button_get_active "gboolean gtk_toggle_button_get_active(GtkToggleButton* toggle_button)"
  Xen_check_type(Xen_is_GtkToggleButton_(toggle_button), toggle_button, 1, "gtk_toggle_button_get_active", "GtkToggleButton*");
  return(C_to_Xen_gboolean(gtk_toggle_button_get_active(Xen_to_C_GtkToggleButton_(toggle_button))));
}

static Xen gxg_gtk_toggle_button_toggled(Xen toggle_button)
{
  #define H_gtk_toggle_button_toggled "void gtk_toggle_button_toggled(GtkToggleButton* toggle_button)"
  Xen_check_type(Xen_is_GtkToggleButton_(toggle_button), toggle_button, 1, "gtk_toggle_button_toggled", "GtkToggleButton*");
  gtk_toggle_button_toggled(Xen_to_C_GtkToggleButton_(toggle_button));
  return(Xen_false);
}

static Xen gxg_gtk_toolbar_new(void)
{
  #define H_gtk_toolbar_new "GtkWidget* gtk_toolbar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_toolbar_new()));
}

static Xen gxg_gtk_toolbar_set_style(Xen toolbar, Xen style)
{
  #define H_gtk_toolbar_set_style "void gtk_toolbar_set_style(GtkToolbar* toolbar, GtkToolbarStyle style)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_set_style", "GtkToolbar*");
  Xen_check_type(Xen_is_GtkToolbarStyle(style), style, 2, "gtk_toolbar_set_style", "GtkToolbarStyle");
  gtk_toolbar_set_style(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_GtkToolbarStyle(style));
  return(Xen_false);
}

static Xen gxg_gtk_toolbar_unset_style(Xen toolbar)
{
  #define H_gtk_toolbar_unset_style "void gtk_toolbar_unset_style(GtkToolbar* toolbar)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_unset_style", "GtkToolbar*");
  gtk_toolbar_unset_style(Xen_to_C_GtkToolbar_(toolbar));
  return(Xen_false);
}

static Xen gxg_gtk_toolbar_get_style(Xen toolbar)
{
  #define H_gtk_toolbar_get_style "GtkToolbarStyle gtk_toolbar_get_style(GtkToolbar* toolbar)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_get_style", "GtkToolbar*");
  return(C_to_Xen_GtkToolbarStyle(gtk_toolbar_get_style(Xen_to_C_GtkToolbar_(toolbar))));
}

static Xen gxg_gtk_tree_drag_source_row_draggable(Xen drag_source, Xen path)
{
  #define H_gtk_tree_drag_source_row_draggable "gboolean gtk_tree_drag_source_row_draggable(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeDragSource_(drag_source), drag_source, 1, "gtk_tree_drag_source_row_draggable", "GtkTreeDragSource*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_drag_source_row_draggable", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_drag_source_row_draggable(Xen_to_C_GtkTreeDragSource_(drag_source), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_drag_source_drag_data_delete(Xen drag_source, Xen path)
{
  #define H_gtk_tree_drag_source_drag_data_delete "gboolean gtk_tree_drag_source_drag_data_delete(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeDragSource_(drag_source), drag_source, 1, "gtk_tree_drag_source_drag_data_delete", "GtkTreeDragSource*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_drag_source_drag_data_delete", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_drag_source_drag_data_delete(Xen_to_C_GtkTreeDragSource_(drag_source), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_drag_source_drag_data_get(Xen drag_source, Xen path, Xen selection_data)
{
  #define H_gtk_tree_drag_source_drag_data_get "gboolean gtk_tree_drag_source_drag_data_get(GtkTreeDragSource* drag_source, \
GtkTreePath* path, GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkTreeDragSource_(drag_source), drag_source, 1, "gtk_tree_drag_source_drag_data_get", "GtkTreeDragSource*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_drag_source_drag_data_get", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 3, "gtk_tree_drag_source_drag_data_get", "GtkSelectionData*");
  return(C_to_Xen_gboolean(gtk_tree_drag_source_drag_data_get(Xen_to_C_GtkTreeDragSource_(drag_source), Xen_to_C_GtkTreePath_(path), 
                                                              Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_tree_drag_dest_drag_data_received(Xen drag_dest, Xen dest, Xen selection_data)
{
  #define H_gtk_tree_drag_dest_drag_data_received "gboolean gtk_tree_drag_dest_drag_data_received(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest, GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkTreeDragDest_(drag_dest), drag_dest, 1, "gtk_tree_drag_dest_drag_data_received", "GtkTreeDragDest*");
  Xen_check_type(Xen_is_GtkTreePath_(dest), dest, 2, "gtk_tree_drag_dest_drag_data_received", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 3, "gtk_tree_drag_dest_drag_data_received", "GtkSelectionData*");
  return(C_to_Xen_gboolean(gtk_tree_drag_dest_drag_data_received(Xen_to_C_GtkTreeDragDest_(drag_dest), Xen_to_C_GtkTreePath_(dest), 
                                                                 Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_tree_drag_dest_row_drop_possible(Xen drag_dest, Xen dest_path, Xen selection_data)
{
  #define H_gtk_tree_drag_dest_row_drop_possible "gboolean gtk_tree_drag_dest_row_drop_possible(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest_path, GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkTreeDragDest_(drag_dest), drag_dest, 1, "gtk_tree_drag_dest_row_drop_possible", "GtkTreeDragDest*");
  Xen_check_type(Xen_is_GtkTreePath_(dest_path), dest_path, 2, "gtk_tree_drag_dest_row_drop_possible", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 3, "gtk_tree_drag_dest_row_drop_possible", "GtkSelectionData*");
  return(C_to_Xen_gboolean(gtk_tree_drag_dest_row_drop_possible(Xen_to_C_GtkTreeDragDest_(drag_dest), Xen_to_C_GtkTreePath_(dest_path), 
                                                                Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_tree_set_row_drag_data(Xen selection_data, Xen tree_model, Xen path)
{
  #define H_gtk_tree_set_row_drag_data "gboolean gtk_tree_set_row_drag_data(GtkSelectionData* selection_data, \
GtkTreeModel* tree_model, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_tree_set_row_drag_data", "GtkSelectionData*");
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 2, "gtk_tree_set_row_drag_data", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_tree_set_row_drag_data", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_set_row_drag_data(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_GtkTreeModel_(tree_model), 
                                                      Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_get_row_drag_data(Xen selection_data, Xen ignore_tree_model, Xen ignore_path)
{
  #define H_gtk_tree_get_row_drag_data "gboolean gtk_tree_get_row_drag_data(GtkSelectionData* selection_data, \
GtkTreeModel** [tree_model], GtkTreePath** [path])"
  GtkTreeModel* ref_tree_model = NULL;
  GtkTreePath* ref_path = NULL;
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_tree_get_row_drag_data", "GtkSelectionData*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_get_row_drag_data(Xen_to_C_GtkSelectionData_(selection_data), &ref_tree_model, &ref_path));
    return(Xen_list_3(result, C_to_Xen_GtkTreeModel_(ref_tree_model), C_to_Xen_GtkTreePath_(ref_path)));
   }
}

static Xen gxg_gtk_tree_path_new(void)
{
  #define H_gtk_tree_path_new "GtkTreePath* gtk_tree_path_new( void)"
  return(C_to_Xen_GtkTreePath_(gtk_tree_path_new()));
}

static Xen gxg_gtk_tree_path_new_from_string(Xen path)
{
  #define H_gtk_tree_path_new_from_string "GtkTreePath* gtk_tree_path_new_from_string(gchar* path)"
  Xen_check_type(Xen_is_gchar_(path), path, 1, "gtk_tree_path_new_from_string", "gchar*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_path_new_from_string(Xen_to_C_gchar_(path))));
}

static Xen gxg_gtk_tree_path_to_string(Xen path)
{
  #define H_gtk_tree_path_to_string "gchar* gtk_tree_path_to_string(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_to_string", "GtkTreePath*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_tree_path_to_string(Xen_to_C_GtkTreePath_(path));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_tree_path_new_first(void)
{
  #define H_gtk_tree_path_new_first "GtkTreePath* gtk_tree_path_new_first( void)"
  return(C_to_Xen_GtkTreePath_(gtk_tree_path_new_first()));
}

static Xen gxg_gtk_tree_path_append_index(Xen path, Xen index)
{
  #define H_gtk_tree_path_append_index "void gtk_tree_path_append_index(GtkTreePath* path, gint index)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_append_index", "GtkTreePath*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_tree_path_append_index", "gint");
  gtk_tree_path_append_index(Xen_to_C_GtkTreePath_(path), Xen_to_C_gint(index));
  return(Xen_false);
}

static Xen gxg_gtk_tree_path_prepend_index(Xen path, Xen index)
{
  #define H_gtk_tree_path_prepend_index "void gtk_tree_path_prepend_index(GtkTreePath* path, gint index)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_prepend_index", "GtkTreePath*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_tree_path_prepend_index", "gint");
  gtk_tree_path_prepend_index(Xen_to_C_GtkTreePath_(path), Xen_to_C_gint(index));
  return(Xen_false);
}

static Xen gxg_gtk_tree_path_get_depth(Xen path)
{
  #define H_gtk_tree_path_get_depth "gint gtk_tree_path_get_depth(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_get_depth", "GtkTreePath*");
  return(C_to_Xen_gint(gtk_tree_path_get_depth(Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_path_get_indices(Xen path)
{
  #define H_gtk_tree_path_get_indices "gint* gtk_tree_path_get_indices(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_get_indices", "GtkTreePath*");
  return(C_to_Xen_gint_(gtk_tree_path_get_indices(Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_path_free(Xen path)
{
  #define H_gtk_tree_path_free "void gtk_tree_path_free(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_free", "GtkTreePath*");
  gtk_tree_path_free(Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_path_copy(Xen path)
{
  #define H_gtk_tree_path_copy "GtkTreePath* gtk_tree_path_copy(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_copy", "GtkTreePath*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_path_copy(Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_path_compare(Xen a, Xen b)
{
  #define H_gtk_tree_path_compare "gint gtk_tree_path_compare(GtkTreePath* a, GtkTreePath* b)"
  Xen_check_type(Xen_is_GtkTreePath_(a), a, 1, "gtk_tree_path_compare", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreePath_(b), b, 2, "gtk_tree_path_compare", "GtkTreePath*");
  return(C_to_Xen_gint(gtk_tree_path_compare(Xen_to_C_GtkTreePath_(a), Xen_to_C_GtkTreePath_(b))));
}

static Xen gxg_gtk_tree_path_next(Xen path)
{
  #define H_gtk_tree_path_next "void gtk_tree_path_next(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_next", "GtkTreePath*");
  gtk_tree_path_next(Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_path_prev(Xen path)
{
  #define H_gtk_tree_path_prev "gboolean gtk_tree_path_prev(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_prev", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_path_prev(Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_path_up(Xen path)
{
  #define H_gtk_tree_path_up "gboolean gtk_tree_path_up(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_up", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_path_up(Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_path_down(Xen path)
{
  #define H_gtk_tree_path_down "void gtk_tree_path_down(GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_down", "GtkTreePath*");
  gtk_tree_path_down(Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_path_is_ancestor(Xen path, Xen descendant)
{
  #define H_gtk_tree_path_is_ancestor "gboolean gtk_tree_path_is_ancestor(GtkTreePath* path, GtkTreePath* descendant)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_is_ancestor", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreePath_(descendant), descendant, 2, "gtk_tree_path_is_ancestor", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_path_is_ancestor(Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreePath_(descendant))));
}

static Xen gxg_gtk_tree_path_is_descendant(Xen path, Xen ancestor)
{
  #define H_gtk_tree_path_is_descendant "gboolean gtk_tree_path_is_descendant(GtkTreePath* path, GtkTreePath* ancestor)"
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 1, "gtk_tree_path_is_descendant", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreePath_(ancestor), ancestor, 2, "gtk_tree_path_is_descendant", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_path_is_descendant(Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreePath_(ancestor))));
}

static Xen gxg_gtk_tree_row_reference_new(Xen model, Xen path)
{
  #define H_gtk_tree_row_reference_new "GtkTreeRowReference* gtk_tree_row_reference_new(GtkTreeModel* model, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 1, "gtk_tree_row_reference_new", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_row_reference_new", "GtkTreePath*");
  return(C_to_Xen_GtkTreeRowReference_(gtk_tree_row_reference_new(Xen_to_C_GtkTreeModel_(model), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_row_reference_new_proxy(Xen proxy, Xen model, Xen path)
{
  #define H_gtk_tree_row_reference_new_proxy "GtkTreeRowReference* gtk_tree_row_reference_new_proxy(GObject* proxy, \
GtkTreeModel* model, GtkTreePath* path)"
  Xen_check_type(Xen_is_GObject_(proxy), proxy, 1, "gtk_tree_row_reference_new_proxy", "GObject*");
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 2, "gtk_tree_row_reference_new_proxy", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_tree_row_reference_new_proxy", "GtkTreePath*");
  return(C_to_Xen_GtkTreeRowReference_(gtk_tree_row_reference_new_proxy(Xen_to_C_GObject_(proxy), Xen_to_C_GtkTreeModel_(model), 
                                                                        Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_row_reference_get_path(Xen reference)
{
  #define H_gtk_tree_row_reference_get_path "GtkTreePath* gtk_tree_row_reference_get_path(GtkTreeRowReference* reference)"
  Xen_check_type(Xen_is_GtkTreeRowReference_(reference), reference, 1, "gtk_tree_row_reference_get_path", "GtkTreeRowReference*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_row_reference_get_path(Xen_to_C_GtkTreeRowReference_(reference))));
}

static Xen gxg_gtk_tree_row_reference_valid(Xen reference)
{
  #define H_gtk_tree_row_reference_valid "gboolean gtk_tree_row_reference_valid(GtkTreeRowReference* reference)"
  Xen_check_type(Xen_is_GtkTreeRowReference_(reference), reference, 1, "gtk_tree_row_reference_valid", "GtkTreeRowReference*");
  return(C_to_Xen_gboolean(gtk_tree_row_reference_valid(Xen_to_C_GtkTreeRowReference_(reference))));
}

static Xen gxg_gtk_tree_row_reference_free(Xen reference)
{
  #define H_gtk_tree_row_reference_free "void gtk_tree_row_reference_free(GtkTreeRowReference* reference)"
  Xen_check_type(Xen_is_GtkTreeRowReference_(reference), reference, 1, "gtk_tree_row_reference_free", "GtkTreeRowReference*");
  gtk_tree_row_reference_free(Xen_to_C_GtkTreeRowReference_(reference));
  return(Xen_false);
}

static Xen gxg_gtk_tree_row_reference_inserted(Xen proxy, Xen path)
{
  #define H_gtk_tree_row_reference_inserted "void gtk_tree_row_reference_inserted(GObject* proxy, GtkTreePath* path)"
  Xen_check_type(Xen_is_GObject_(proxy), proxy, 1, "gtk_tree_row_reference_inserted", "GObject*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_row_reference_inserted", "GtkTreePath*");
  gtk_tree_row_reference_inserted(Xen_to_C_GObject_(proxy), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_row_reference_deleted(Xen proxy, Xen path)
{
  #define H_gtk_tree_row_reference_deleted "void gtk_tree_row_reference_deleted(GObject* proxy, GtkTreePath* path)"
  Xen_check_type(Xen_is_GObject_(proxy), proxy, 1, "gtk_tree_row_reference_deleted", "GObject*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_row_reference_deleted", "GtkTreePath*");
  gtk_tree_row_reference_deleted(Xen_to_C_GObject_(proxy), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_row_reference_reordered(Xen proxy, Xen path, Xen iter, Xen new_order)
{
  #define H_gtk_tree_row_reference_reordered "void gtk_tree_row_reference_reordered(GObject* proxy, GtkTreePath* path, \
GtkTreeIter* iter, gint* new_order)"
  Xen_check_type(Xen_is_GObject_(proxy), proxy, 1, "gtk_tree_row_reference_reordered", "GObject*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_row_reference_reordered", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_row_reference_reordered", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint_(new_order), new_order, 4, "gtk_tree_row_reference_reordered", "gint*");
  gtk_tree_row_reference_reordered(Xen_to_C_GObject_(proxy), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_gint_(new_order));
  return(Xen_false);
}

static Xen gxg_gtk_tree_iter_copy(Xen iter)
{
  #define H_gtk_tree_iter_copy "GtkTreeIter* gtk_tree_iter_copy(GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 1, "gtk_tree_iter_copy", "GtkTreeIter*");
  return(C_to_Xen_GtkTreeIter_(gtk_tree_iter_copy(Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_iter_free(Xen iter)
{
  #define H_gtk_tree_iter_free "void gtk_tree_iter_free(GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 1, "gtk_tree_iter_free", "GtkTreeIter*");
  gtk_tree_iter_free(Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_get_flags(Xen tree_model)
{
  #define H_gtk_tree_model_get_flags "GtkTreeModelFlags gtk_tree_model_get_flags(GtkTreeModel* tree_model)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_flags", "GtkTreeModel*");
  return(C_to_Xen_GtkTreeModelFlags(gtk_tree_model_get_flags(Xen_to_C_GtkTreeModel_(tree_model))));
}

static Xen gxg_gtk_tree_model_get_n_columns(Xen tree_model)
{
  #define H_gtk_tree_model_get_n_columns "gint gtk_tree_model_get_n_columns(GtkTreeModel* tree_model)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_n_columns", "GtkTreeModel*");
  return(C_to_Xen_gint(gtk_tree_model_get_n_columns(Xen_to_C_GtkTreeModel_(tree_model))));
}

static Xen gxg_gtk_tree_model_get_column_type(Xen tree_model, Xen index)
{
  #define H_gtk_tree_model_get_column_type "GType gtk_tree_model_get_column_type(GtkTreeModel* tree_model, \
gint index)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_column_type", "GtkTreeModel*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_tree_model_get_column_type", "gint");
  return(C_to_Xen_GType(gtk_tree_model_get_column_type(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_gint(index))));
}

static Xen gxg_gtk_tree_model_get_iter(Xen tree_model, Xen iter, Xen path)
{
  #define H_gtk_tree_model_get_iter "gboolean gtk_tree_model_get_iter(GtkTreeModel* tree_model, GtkTreeIter* iter, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_iter", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_get_iter", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_tree_model_get_iter", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_model_get_iter(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_model_get_iter_from_string(Xen tree_model, Xen iter, Xen path_string)
{
  #define H_gtk_tree_model_get_iter_from_string "gboolean gtk_tree_model_get_iter_from_string(GtkTreeModel* tree_model, \
GtkTreeIter* iter, gchar* path_string)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_iter_from_string", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_get_iter_from_string", "GtkTreeIter*");
  Xen_check_type(Xen_is_gchar_(path_string), path_string, 3, "gtk_tree_model_get_iter_from_string", "gchar*");
  return(C_to_Xen_gboolean(gtk_tree_model_get_iter_from_string(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter), 
                                                               Xen_to_C_gchar_(path_string))));
}

static Xen gxg_gtk_tree_model_get_iter_first(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_get_iter_first "gboolean gtk_tree_model_get_iter_first(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_iter_first", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_get_iter_first", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_get_iter_first(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_model_get_path(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_get_path "GtkTreePath* gtk_tree_model_get_path(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_path", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_get_path", "GtkTreeIter*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_model_get_path(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_model_iter_next(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_iter_next "gboolean gtk_tree_model_iter_next(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_next", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_iter_next", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_iter_next(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_model_iter_children(Xen tree_model, Xen iter, Xen parent)
{
  #define H_gtk_tree_model_iter_children "gboolean gtk_tree_model_iter_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_children", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_iter_children", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_model_iter_children", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_iter_children(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter), 
                                                        Xen_to_C_GtkTreeIter_(parent))));
}

static Xen gxg_gtk_tree_model_iter_has_child(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_iter_has_child "gboolean gtk_tree_model_iter_has_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_has_child", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_iter_has_child", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_iter_has_child(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_model_iter_n_children(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_iter_n_children "gint gtk_tree_model_iter_n_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_n_children", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter) || Xen_is_false(iter), iter, 2, "gtk_tree_model_iter_n_children", "GtkTreeIter*");
  return(C_to_Xen_gint(gtk_tree_model_iter_n_children(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_model_iter_nth_child(Xen tree_model, Xen iter, Xen parent, Xen n)
{
  #define H_gtk_tree_model_iter_nth_child "gboolean gtk_tree_model_iter_nth_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent, gint n)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_nth_child", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_iter_nth_child", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_model_iter_nth_child", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint(n), n, 4, "gtk_tree_model_iter_nth_child", "gint");
  return(C_to_Xen_gboolean(gtk_tree_model_iter_nth_child(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter), 
                                                         Xen_to_C_GtkTreeIter_(parent), Xen_to_C_gint(n))));
}

static Xen gxg_gtk_tree_model_iter_parent(Xen tree_model, Xen iter, Xen child)
{
  #define H_gtk_tree_model_iter_parent "gboolean gtk_tree_model_iter_parent(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* child)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_parent", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_iter_parent", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(child), child, 3, "gtk_tree_model_iter_parent", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_iter_parent(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(child))));
}

static Xen gxg_gtk_tree_model_ref_node(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_ref_node "void gtk_tree_model_ref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_ref_node", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_ref_node", "GtkTreeIter*");
  gtk_tree_model_ref_node(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_unref_node(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_unref_node "void gtk_tree_model_unref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_unref_node", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_unref_node", "GtkTreeIter*");
  gtk_tree_model_unref_node(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_foreach(Xen model, Xen func, Xen func_info)
{
  #define H_gtk_tree_model_foreach "void gtk_tree_model_foreach(GtkTreeModel* model, GtkTreeModelForeachFunc func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 1, "gtk_tree_model_foreach", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeModelForeachFunc(func), func, 2, "gtk_tree_model_foreach", "GtkTreeModelForeachFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_model_foreach", "lambda_data");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_tree_model_foreach(Xen_to_C_GtkTreeModel_(model), Xen_to_C_GtkTreeModelForeachFunc(func), Xen_to_C_lambda_data(func_info));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_model_row_changed(Xen tree_model, Xen path, Xen iter)
{
  #define H_gtk_tree_model_row_changed "void gtk_tree_model_row_changed(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_row_changed", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_model_row_changed", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_model_row_changed", "GtkTreeIter*");
  gtk_tree_model_row_changed(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_row_inserted(Xen tree_model, Xen path, Xen iter)
{
  #define H_gtk_tree_model_row_inserted "void gtk_tree_model_row_inserted(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_row_inserted", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_model_row_inserted", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_model_row_inserted", "GtkTreeIter*");
  gtk_tree_model_row_inserted(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_row_has_child_toggled(Xen tree_model, Xen path, Xen iter)
{
  #define H_gtk_tree_model_row_has_child_toggled "void gtk_tree_model_row_has_child_toggled(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_row_has_child_toggled", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_model_row_has_child_toggled", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_model_row_has_child_toggled", "GtkTreeIter*");
  gtk_tree_model_row_has_child_toggled(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_row_deleted(Xen tree_model, Xen path)
{
  #define H_gtk_tree_model_row_deleted "void gtk_tree_model_row_deleted(GtkTreeModel* tree_model, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_row_deleted", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_model_row_deleted", "GtkTreePath*");
  gtk_tree_model_row_deleted(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_rows_reordered(Xen tree_model, Xen path, Xen iter, Xen new_order)
{
  #define H_gtk_tree_model_rows_reordered "void gtk_tree_model_rows_reordered(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_rows_reordered", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_model_rows_reordered", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_model_rows_reordered", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint_(new_order), new_order, 4, "gtk_tree_model_rows_reordered", "gint*");
  gtk_tree_model_rows_reordered(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeIter_(iter), 
                                Xen_to_C_gint_(new_order));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_sort_new_with_model(Xen child_model)
{
  #define H_gtk_tree_model_sort_new_with_model "GtkTreeModel* gtk_tree_model_sort_new_with_model(GtkTreeModel* child_model)"
  Xen_check_type(Xen_is_GtkTreeModel_(child_model), child_model, 1, "gtk_tree_model_sort_new_with_model", "GtkTreeModel*");
  return(C_to_Xen_GtkTreeModel_(gtk_tree_model_sort_new_with_model(Xen_to_C_GtkTreeModel_(child_model))));
}

static Xen gxg_gtk_tree_model_sort_get_model(Xen tree_model)
{
  #define H_gtk_tree_model_sort_get_model "GtkTreeModel* gtk_tree_model_sort_get_model(GtkTreeModelSort* tree_model)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model), tree_model, 1, "gtk_tree_model_sort_get_model", "GtkTreeModelSort*");
  return(C_to_Xen_GtkTreeModel_(gtk_tree_model_sort_get_model(Xen_to_C_GtkTreeModelSort_(tree_model))));
}

static Xen gxg_gtk_tree_model_sort_convert_child_path_to_path(Xen tree_model_sort, Xen child_path)
{
  #define H_gtk_tree_model_sort_convert_child_path_to_path "GtkTreePath* gtk_tree_model_sort_convert_child_path_to_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* child_path)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_child_path_to_path", "GtkTreeModelSort*");
  Xen_check_type(Xen_is_GtkTreePath_(child_path), child_path, 2, "gtk_tree_model_sort_convert_child_path_to_path", "GtkTreePath*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_model_sort_convert_child_path_to_path(Xen_to_C_GtkTreeModelSort_(tree_model_sort), 
                                                                              Xen_to_C_GtkTreePath_(child_path))));
}

static Xen gxg_gtk_tree_model_sort_convert_child_iter_to_iter(Xen tree_model_sort, Xen sort_iter, Xen child_iter)
{
  #define H_gtk_tree_model_sort_convert_child_iter_to_iter "void gtk_tree_model_sort_convert_child_iter_to_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* sort_iter, GtkTreeIter* child_iter)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_child_iter_to_iter", "GtkTreeModelSort*");
  Xen_check_type(Xen_is_GtkTreeIter_(sort_iter), sort_iter, 2, "gtk_tree_model_sort_convert_child_iter_to_iter", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(child_iter), child_iter, 3, "gtk_tree_model_sort_convert_child_iter_to_iter", "GtkTreeIter*");
  gtk_tree_model_sort_convert_child_iter_to_iter(Xen_to_C_GtkTreeModelSort_(tree_model_sort), Xen_to_C_GtkTreeIter_(sort_iter), 
                                                 Xen_to_C_GtkTreeIter_(child_iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_sort_convert_path_to_child_path(Xen tree_model_sort, Xen sorted_path)
{
  #define H_gtk_tree_model_sort_convert_path_to_child_path "GtkTreePath* gtk_tree_model_sort_convert_path_to_child_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* sorted_path)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_path_to_child_path", "GtkTreeModelSort*");
  Xen_check_type(Xen_is_GtkTreePath_(sorted_path), sorted_path, 2, "gtk_tree_model_sort_convert_path_to_child_path", "GtkTreePath*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_model_sort_convert_path_to_child_path(Xen_to_C_GtkTreeModelSort_(tree_model_sort), 
                                                                              Xen_to_C_GtkTreePath_(sorted_path))));
}

static Xen gxg_gtk_tree_model_sort_convert_iter_to_child_iter(Xen tree_model_sort, Xen child_iter, Xen sorted_iter)
{
  #define H_gtk_tree_model_sort_convert_iter_to_child_iter "void gtk_tree_model_sort_convert_iter_to_child_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* child_iter, GtkTreeIter* sorted_iter)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_convert_iter_to_child_iter", "GtkTreeModelSort*");
  Xen_check_type(Xen_is_GtkTreeIter_(child_iter), child_iter, 2, "gtk_tree_model_sort_convert_iter_to_child_iter", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(sorted_iter), sorted_iter, 3, "gtk_tree_model_sort_convert_iter_to_child_iter", "GtkTreeIter*");
  gtk_tree_model_sort_convert_iter_to_child_iter(Xen_to_C_GtkTreeModelSort_(tree_model_sort), Xen_to_C_GtkTreeIter_(child_iter), 
                                                 Xen_to_C_GtkTreeIter_(sorted_iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_sort_reset_default_sort_func(Xen tree_model_sort)
{
  #define H_gtk_tree_model_sort_reset_default_sort_func "void gtk_tree_model_sort_reset_default_sort_func(GtkTreeModelSort* tree_model_sort)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_reset_default_sort_func", "GtkTreeModelSort*");
  gtk_tree_model_sort_reset_default_sort_func(Xen_to_C_GtkTreeModelSort_(tree_model_sort));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_sort_clear_cache(Xen tree_model_sort)
{
  #define H_gtk_tree_model_sort_clear_cache "void gtk_tree_model_sort_clear_cache(GtkTreeModelSort* tree_model_sort)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_clear_cache", "GtkTreeModelSort*");
  gtk_tree_model_sort_clear_cache(Xen_to_C_GtkTreeModelSort_(tree_model_sort));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_set_mode(Xen selection, Xen type)
{
  #define H_gtk_tree_selection_set_mode "void gtk_tree_selection_set_mode(GtkTreeSelection* selection, \
GtkSelectionMode type)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_set_mode", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkSelectionMode(type), type, 2, "gtk_tree_selection_set_mode", "GtkSelectionMode");
  gtk_tree_selection_set_mode(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkSelectionMode(type));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_get_mode(Xen selection)
{
  #define H_gtk_tree_selection_get_mode "GtkSelectionMode gtk_tree_selection_get_mode(GtkTreeSelection* selection)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_get_mode", "GtkTreeSelection*");
  return(C_to_Xen_GtkSelectionMode(gtk_tree_selection_get_mode(Xen_to_C_GtkTreeSelection_(selection))));
}

static Xen gxg_gtk_tree_selection_set_select_function(Xen selection, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_selection_set_select_function "void gtk_tree_selection_set_select_function(GtkTreeSelection* selection, \
GtkTreeSelectionFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_set_select_function", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeSelectionFunc(func), func, 2, "gtk_tree_selection_set_select_function", "GtkTreeSelectionFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_selection_set_select_function", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 4, "gtk_tree_selection_set_select_function", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_tree_selection_set_select_function(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeSelectionFunc(func), Xen_to_C_lambda_data(func_info), 
                                       Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_selection_get_user_data(Xen selection)
{
  #define H_gtk_tree_selection_get_user_data "gpointer gtk_tree_selection_get_user_data(GtkTreeSelection* selection)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_get_user_data", "GtkTreeSelection*");
  return(C_to_Xen_gpointer(gtk_tree_selection_get_user_data(Xen_to_C_GtkTreeSelection_(selection))));
}

static Xen gxg_gtk_tree_selection_get_tree_view(Xen selection)
{
  #define H_gtk_tree_selection_get_tree_view "GtkTreeView* gtk_tree_selection_get_tree_view(GtkTreeSelection* selection)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_get_tree_view", "GtkTreeSelection*");
  return(C_to_Xen_GtkTreeView_(gtk_tree_selection_get_tree_view(Xen_to_C_GtkTreeSelection_(selection))));
}

static Xen gxg_gtk_tree_selection_get_selected(Xen selection, Xen model, Xen iter)
{
  #define H_gtk_tree_selection_get_selected "gboolean gtk_tree_selection_get_selected(GtkTreeSelection* selection, \
GtkTreeModel** model, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_get_selected", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeModel__(model), model, 2, "gtk_tree_selection_get_selected", "GtkTreeModel**");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_selection_get_selected", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_selection_get_selected(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeModel__(model), 
                                                           Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_selection_selected_foreach(Xen selection, Xen func, Xen func_info)
{
  #define H_gtk_tree_selection_selected_foreach "void gtk_tree_selection_selected_foreach(GtkTreeSelection* selection, \
GtkTreeSelectionForeachFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_selected_foreach", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeSelectionForeachFunc(func), func, 2, "gtk_tree_selection_selected_foreach", "GtkTreeSelectionForeachFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_selection_selected_foreach", "lambda_data");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_tree_selection_selected_foreach(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeSelectionForeachFunc(func), Xen_to_C_lambda_data(func_info));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_selection_select_path(Xen selection, Xen path)
{
  #define H_gtk_tree_selection_select_path "void gtk_tree_selection_select_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_select_path", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_selection_select_path", "GtkTreePath*");
  gtk_tree_selection_select_path(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_unselect_path(Xen selection, Xen path)
{
  #define H_gtk_tree_selection_unselect_path "void gtk_tree_selection_unselect_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_unselect_path", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_selection_unselect_path", "GtkTreePath*");
  gtk_tree_selection_unselect_path(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_select_iter(Xen selection, Xen iter)
{
  #define H_gtk_tree_selection_select_iter "void gtk_tree_selection_select_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_select_iter", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_selection_select_iter", "GtkTreeIter*");
  gtk_tree_selection_select_iter(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_unselect_iter(Xen selection, Xen iter)
{
  #define H_gtk_tree_selection_unselect_iter "void gtk_tree_selection_unselect_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_unselect_iter", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_selection_unselect_iter", "GtkTreeIter*");
  gtk_tree_selection_unselect_iter(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_path_is_selected(Xen selection, Xen path)
{
  #define H_gtk_tree_selection_path_is_selected "gboolean gtk_tree_selection_path_is_selected(GtkTreeSelection* selection, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_path_is_selected", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_selection_path_is_selected", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_selection_path_is_selected(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_selection_iter_is_selected(Xen selection, Xen iter)
{
  #define H_gtk_tree_selection_iter_is_selected "gboolean gtk_tree_selection_iter_is_selected(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_iter_is_selected", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_selection_iter_is_selected", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_selection_iter_is_selected(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_selection_select_all(Xen selection)
{
  #define H_gtk_tree_selection_select_all "void gtk_tree_selection_select_all(GtkTreeSelection* selection)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_select_all", "GtkTreeSelection*");
  gtk_tree_selection_select_all(Xen_to_C_GtkTreeSelection_(selection));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_unselect_all(Xen selection)
{
  #define H_gtk_tree_selection_unselect_all "void gtk_tree_selection_unselect_all(GtkTreeSelection* selection)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_unselect_all", "GtkTreeSelection*");
  gtk_tree_selection_unselect_all(Xen_to_C_GtkTreeSelection_(selection));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_select_range(Xen selection, Xen start_path, Xen end_path)
{
  #define H_gtk_tree_selection_select_range "void gtk_tree_selection_select_range(GtkTreeSelection* selection, \
GtkTreePath* start_path, GtkTreePath* end_path)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_select_range", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreePath_(start_path), start_path, 2, "gtk_tree_selection_select_range", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreePath_(end_path), end_path, 3, "gtk_tree_selection_select_range", "GtkTreePath*");
  gtk_tree_selection_select_range(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreePath_(start_path), Xen_to_C_GtkTreePath_(end_path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_sortable_sort_column_changed(Xen sortable)
{
  #define H_gtk_tree_sortable_sort_column_changed "void gtk_tree_sortable_sort_column_changed(GtkTreeSortable* sortable)"
  Xen_check_type(Xen_is_GtkTreeSortable_(sortable), sortable, 1, "gtk_tree_sortable_sort_column_changed", "GtkTreeSortable*");
  gtk_tree_sortable_sort_column_changed(Xen_to_C_GtkTreeSortable_(sortable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_sortable_get_sort_column_id(Xen sortable, Xen ignore_sort_column_id, Xen ignore_order)
{
  #define H_gtk_tree_sortable_get_sort_column_id "gboolean gtk_tree_sortable_get_sort_column_id(GtkTreeSortable* sortable, \
gint* [sort_column_id], GtkSortType* [order])"
  gint ref_sort_column_id;
  GtkSortType ref_order;
  Xen_check_type(Xen_is_GtkTreeSortable_(sortable), sortable, 1, "gtk_tree_sortable_get_sort_column_id", "GtkTreeSortable*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_sortable_get_sort_column_id(Xen_to_C_GtkTreeSortable_(sortable), &ref_sort_column_id, 
                                                                    &ref_order));
    return(Xen_list_3(result, C_to_Xen_gint(ref_sort_column_id), C_to_Xen_GtkSortType(ref_order)));
   }
}

static Xen gxg_gtk_tree_sortable_set_sort_column_id(Xen sortable, Xen sort_column_id, Xen order)
{
  #define H_gtk_tree_sortable_set_sort_column_id "void gtk_tree_sortable_set_sort_column_id(GtkTreeSortable* sortable, \
gint sort_column_id, GtkSortType order)"
  Xen_check_type(Xen_is_GtkTreeSortable_(sortable), sortable, 1, "gtk_tree_sortable_set_sort_column_id", "GtkTreeSortable*");
  Xen_check_type(Xen_is_gint(sort_column_id), sort_column_id, 2, "gtk_tree_sortable_set_sort_column_id", "gint");
  Xen_check_type(Xen_is_GtkSortType(order), order, 3, "gtk_tree_sortable_set_sort_column_id", "GtkSortType");
  gtk_tree_sortable_set_sort_column_id(Xen_to_C_GtkTreeSortable_(sortable), Xen_to_C_gint(sort_column_id), Xen_to_C_GtkSortType(order));
  return(Xen_false);
}

static Xen gxg_gtk_tree_sortable_set_sort_func(Xen sortable, Xen sort_column_id, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_sortable_set_sort_func "void gtk_tree_sortable_set_sort_func(GtkTreeSortable* sortable, \
gint sort_column_id, GtkTreeIterCompareFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeSortable_(sortable), sortable, 1, "gtk_tree_sortable_set_sort_func", "GtkTreeSortable*");
  Xen_check_type(Xen_is_gint(sort_column_id), sort_column_id, 2, "gtk_tree_sortable_set_sort_func", "gint");
  Xen_check_type(Xen_is_GtkTreeIterCompareFunc(func), func, 3, "gtk_tree_sortable_set_sort_func", "GtkTreeIterCompareFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "gtk_tree_sortable_set_sort_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 5, "gtk_tree_sortable_set_sort_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_tree_sortable_set_sort_func(Xen_to_C_GtkTreeSortable_(sortable), Xen_to_C_gint(sort_column_id), Xen_to_C_GtkTreeIterCompareFunc(func), 
                                Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_sortable_set_default_sort_func(Xen sortable, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_sortable_set_default_sort_func "void gtk_tree_sortable_set_default_sort_func(GtkTreeSortable* sortable, \
GtkTreeIterCompareFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeSortable_(sortable), sortable, 1, "gtk_tree_sortable_set_default_sort_func", "GtkTreeSortable*");
  Xen_check_type(Xen_is_GtkTreeIterCompareFunc(func), func, 2, "gtk_tree_sortable_set_default_sort_func", "GtkTreeIterCompareFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_sortable_set_default_sort_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 4, "gtk_tree_sortable_set_default_sort_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_tree_sortable_set_default_sort_func(Xen_to_C_GtkTreeSortable_(sortable), Xen_to_C_GtkTreeIterCompareFunc(func), Xen_to_C_lambda_data(func_info), 
                                        Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_sortable_has_default_sort_func(Xen sortable)
{
  #define H_gtk_tree_sortable_has_default_sort_func "gboolean gtk_tree_sortable_has_default_sort_func(GtkTreeSortable* sortable)"
  Xen_check_type(Xen_is_GtkTreeSortable_(sortable), sortable, 1, "gtk_tree_sortable_has_default_sort_func", "GtkTreeSortable*");
  return(C_to_Xen_gboolean(gtk_tree_sortable_has_default_sort_func(Xen_to_C_GtkTreeSortable_(sortable))));
}

static Xen gxg_gtk_tree_store_new(Xen n_columns, Xen types)
{
  #define H_gtk_tree_store_new "GtkTreeStore* gtk_tree_store_new(gint n_columns, etc types)"
  Xen_check_type(Xen_is_gint(n_columns), n_columns, 1, "gtk_tree_store_new", "gint");
  Xen_check_type(Xen_is_etc(types), types, 2, "gtk_tree_store_new", "etc");
  {
    int etc_len = 0;
    GtkTreeStore* result = NULL;
    gint p_arg0;
    if (Xen_is_list(types)) etc_len = Xen_list_length(types);
    if (etc_len < 1) Xen_out_of_range_error("gtk_tree_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) Xen_out_of_range_error("gtk_tree_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = Xen_to_C_gint(n_columns);
    switch (etc_len)
      {
        case 1: result = gtk_tree_store_new(p_arg0, XLG(types, 0)); break;
        case 2: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1)); break;
        case 3: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2)); break;
        case 4: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3)); break;
        case 5: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4)); break;
        case 6: result = gtk_tree_store_new(p_arg0, XLG(types, 0), XLG(types, 1), XLG(types, 2), XLG(types, 3), XLG(types, 4), XLG(types, 5)); break;
      }
    return(C_to_Xen_GtkTreeStore_(result));
  }
}

static Xen gxg_gtk_tree_store_newv(Xen n_columns, Xen types)
{
  #define H_gtk_tree_store_newv "GtkTreeStore* gtk_tree_store_newv(gint n_columns, GType* types)"
  Xen_check_type(Xen_is_gint(n_columns), n_columns, 1, "gtk_tree_store_newv", "gint");
  Xen_check_type(Xen_is_GType_(types), types, 2, "gtk_tree_store_newv", "GType*");
  return(C_to_Xen_GtkTreeStore_(gtk_tree_store_newv(Xen_to_C_gint(n_columns), Xen_to_C_GType_(types))));
}

static Xen gxg_gtk_tree_store_set_column_types(Xen tree_store, Xen n_columns, Xen types)
{
  #define H_gtk_tree_store_set_column_types "void gtk_tree_store_set_column_types(GtkTreeStore* tree_store, \
gint n_columns, GType* types)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_set_column_types", "GtkTreeStore*");
  Xen_check_type(Xen_is_gint(n_columns), n_columns, 2, "gtk_tree_store_set_column_types", "gint");
  Xen_check_type(Xen_is_GType_(types), types, 3, "gtk_tree_store_set_column_types", "GType*");
  gtk_tree_store_set_column_types(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_gint(n_columns), Xen_to_C_GType_(types));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_set(Xen tree_store, Xen iter, Xen values)
{
  #define H_gtk_tree_store_set "void gtk_tree_store_set(GtkTreeStore* tree_store, GtkTreeIter* iter, \
etc values)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_set", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_set", "GtkTreeIter*");
  Xen_check_type(Xen_is_etc(values), values, 3, "gtk_tree_store_set", "etc");
  {
    int etc_len = 0;
    GtkTreeStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (Xen_is_list(values)) etc_len = Xen_list_length(values);
    if (etc_len < 2) Xen_out_of_range_error("gtk_tree_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_tree_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_tree_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkTreeStore_(tree_store);
    p_arg1 = Xen_to_C_GtkTreeIter_(iter);
    switch (etc_len)
      {
        case 2: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), -1); break;
        case 4: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), -1); break;
        case 6: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), -1); break;
        case 8: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), -1); break;
        case 10: gtk_tree_store_set(p_arg0, p_arg1, XLI(values, 0), XLS(values, 1), XLI(values, 2), XLS(values, 3), XLI(values, 4), XLS(values, 5), XLI(values, 6), XLS(values, 7), XLI(values, 8), XLS(values, 9), -1); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_tree_store_remove(Xen tree_store, Xen iter)
{
  #define H_gtk_tree_store_remove "void gtk_tree_store_remove(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_remove", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_remove", "GtkTreeIter*");
  gtk_tree_store_remove(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_insert(Xen tree_store, Xen iter, Xen parent, Xen position)
{
  #define H_gtk_tree_store_insert "void gtk_tree_store_insert(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, gint position)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_insert", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_insert", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_store_insert", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint(position), position, 4, "gtk_tree_store_insert", "gint");
  gtk_tree_store_insert(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(parent), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_insert_before(Xen tree_store, Xen iter, Xen parent, Xen sibling)
{
  #define H_gtk_tree_store_insert_before "void gtk_tree_store_insert_before(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* parent, GtkTreeIter* sibling)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_insert_before", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_insert_before", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_store_insert_before", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(sibling) || Xen_is_false(sibling), sibling, 4, "gtk_tree_store_insert_before", "GtkTreeIter*");
  gtk_tree_store_insert_before(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(parent), 
                               Xen_to_C_GtkTreeIter_(sibling));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_insert_after(Xen tree_store, Xen iter, Xen parent, Xen sibling)
{
  #define H_gtk_tree_store_insert_after "void gtk_tree_store_insert_after(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, GtkTreeIter* sibling)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_insert_after", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_insert_after", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_store_insert_after", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(sibling) || Xen_is_false(sibling), sibling, 4, "gtk_tree_store_insert_after", "GtkTreeIter*");
  gtk_tree_store_insert_after(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(parent), 
                              Xen_to_C_GtkTreeIter_(sibling));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_prepend(Xen tree_store, Xen iter, Xen parent)
{
  #define H_gtk_tree_store_prepend "void gtk_tree_store_prepend(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_prepend", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_prepend", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_store_prepend", "GtkTreeIter*");
  gtk_tree_store_prepend(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(parent));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_append(Xen tree_store, Xen iter, Xen parent)
{
  #define H_gtk_tree_store_append "void gtk_tree_store_append(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_append", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_append", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent) || Xen_is_false(parent), parent, 3, "gtk_tree_store_append", "GtkTreeIter*");
  gtk_tree_store_append(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(parent));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_is_ancestor(Xen tree_store, Xen iter, Xen descendant)
{
  #define H_gtk_tree_store_is_ancestor "gboolean gtk_tree_store_is_ancestor(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* descendant)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_is_ancestor", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_is_ancestor", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(descendant), descendant, 3, "gtk_tree_store_is_ancestor", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_store_is_ancestor(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(descendant))));
}

static Xen gxg_gtk_tree_store_iter_depth(Xen tree_store, Xen iter)
{
  #define H_gtk_tree_store_iter_depth "gint gtk_tree_store_iter_depth(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_iter_depth", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_store_iter_depth", "GtkTreeIter*");
  return(C_to_Xen_gint(gtk_tree_store_iter_depth(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_store_clear(Xen tree_store)
{
  #define H_gtk_tree_store_clear "void gtk_tree_store_clear(GtkTreeStore* tree_store)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_clear", "GtkTreeStore*");
  gtk_tree_store_clear(Xen_to_C_GtkTreeStore_(tree_store));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_new(void)
{
  #define H_gtk_tree_view_column_new "GtkTreeViewColumn* gtk_tree_view_column_new( void)"
  return(C_to_Xen_GtkTreeViewColumn_(gtk_tree_view_column_new()));
}

static Xen gxg_gtk_tree_view_column_new_with_attributes(Xen title, Xen cell, Xen attributes)
{
  #define H_gtk_tree_view_column_new_with_attributes "GtkTreeViewColumn* gtk_tree_view_column_new_with_attributes(gchar* title, \
GtkCellRenderer* cell, etc attributes)"
  Xen_check_type(Xen_is_gchar_(title), title, 1, "gtk_tree_view_column_new_with_attributes", "gchar*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_tree_view_column_new_with_attributes", "GtkCellRenderer*");
  Xen_check_type(Xen_is_etc(attributes), attributes, 3, "gtk_tree_view_column_new_with_attributes", "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* result = NULL;
    gchar* p_arg0;
    GtkCellRenderer* p_arg1;
    if (Xen_is_list(attributes)) etc_len = Xen_list_length(attributes);
    if (etc_len < 2) Xen_out_of_range_error("gtk_tree_view_column_new_with_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_tree_view_column_new_with_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_tree_view_column_new_with_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_gchar_(title);
    p_arg1 = Xen_to_C_GtkCellRenderer_(cell);
    switch (etc_len)
      {
        case 2: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(C_to_Xen_GtkTreeViewColumn_(result));
  }
}

static Xen gxg_gtk_tree_view_column_pack_start(Xen tree_column, Xen cell, Xen expand)
{
  #define H_gtk_tree_view_column_pack_start "void gtk_tree_view_column_pack_start(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_pack_start", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_tree_view_column_pack_start", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 3, "gtk_tree_view_column_pack_start", "gboolean");
  gtk_tree_view_column_pack_start(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_pack_end(Xen tree_column, Xen cell, Xen expand)
{
  #define H_gtk_tree_view_column_pack_end "void gtk_tree_view_column_pack_end(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_pack_end", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_tree_view_column_pack_end", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 3, "gtk_tree_view_column_pack_end", "gboolean");
  gtk_tree_view_column_pack_end(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_clear(Xen tree_column)
{
  #define H_gtk_tree_view_column_clear "void gtk_tree_view_column_clear(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_clear", "GtkTreeViewColumn*");
  gtk_tree_view_column_clear(Xen_to_C_GtkTreeViewColumn_(tree_column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_add_attribute(Xen tree_column, Xen cell_renderer, Xen attribute, Xen column)
{
  #define H_gtk_tree_view_column_add_attribute "void gtk_tree_view_column_add_attribute(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gchar* attribute, gint column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_add_attribute", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_add_attribute", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gchar_(attribute), attribute, 3, "gtk_tree_view_column_add_attribute", "gchar*");
  Xen_check_type(Xen_is_gint(column), column, 4, "gtk_tree_view_column_add_attribute", "gint");
  gtk_tree_view_column_add_attribute(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell_renderer), 
                                     Xen_to_C_gchar_(attribute), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_set_attributes(Xen tree_column, Xen cell_renderer, Xen attributes)
{
  #define H_gtk_tree_view_column_set_attributes "void gtk_tree_view_column_set_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, etc attributes)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_attributes", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_set_attributes", "GtkCellRenderer*");
  Xen_check_type(Xen_is_etc(attributes), attributes, 3, "gtk_tree_view_column_set_attributes", "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* p_arg0;
    GtkCellRenderer* p_arg1;
    if (Xen_is_list(attributes)) etc_len = Xen_list_length(attributes);
    if (etc_len < 2) Xen_out_of_range_error("gtk_tree_view_column_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_tree_view_column_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_tree_view_column_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkTreeViewColumn_(tree_column);
    p_arg1 = Xen_to_C_GtkCellRenderer_(cell_renderer);
    switch (etc_len)
      {
        case 2: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_tree_view_column_set_cell_data_func(Xen tree_column, Xen cell_renderer, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_view_column_set_cell_data_func "void gtk_tree_view_column_set_cell_data_func(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, GtkTreeCellDataFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_cell_data_func", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_set_cell_data_func", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkTreeCellDataFunc(func), func, 3, "gtk_tree_view_column_set_cell_data_func", "GtkTreeCellDataFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "gtk_tree_view_column_set_cell_data_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 5, "gtk_tree_view_column_set_cell_data_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_tree_view_column_set_cell_data_func(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell_renderer), 
                                        Xen_to_C_GtkTreeCellDataFunc(func), Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_view_column_clear_attributes(Xen tree_column, Xen cell_renderer)
{
  #define H_gtk_tree_view_column_clear_attributes "void gtk_tree_view_column_clear_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_clear_attributes", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_clear_attributes", "GtkCellRenderer*");
  gtk_tree_view_column_clear_attributes(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell_renderer));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_set_spacing(Xen tree_column, Xen spacing)
{
  #define H_gtk_tree_view_column_set_spacing "void gtk_tree_view_column_set_spacing(GtkTreeViewColumn* tree_column, \
gint spacing)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_spacing", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gint(spacing), spacing, 2, "gtk_tree_view_column_set_spacing", "gint");
  gtk_tree_view_column_set_spacing(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_spacing(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_spacing "gint gtk_tree_view_column_get_spacing(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_spacing", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_spacing(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_visible(Xen tree_column, Xen visible)
{
  #define H_gtk_tree_view_column_set_visible "void gtk_tree_view_column_set_visible(GtkTreeViewColumn* tree_column, \
gboolean visible)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_visible", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(visible), visible, 2, "gtk_tree_view_column_set_visible", "gboolean");
  gtk_tree_view_column_set_visible(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gboolean(visible));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_visible(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_visible "gboolean gtk_tree_view_column_get_visible(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_visible", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_get_visible(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_resizable(Xen tree_column, Xen resizable)
{
  #define H_gtk_tree_view_column_set_resizable "void gtk_tree_view_column_set_resizable(GtkTreeViewColumn* tree_column, \
gboolean resizable)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_resizable", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(resizable), resizable, 2, "gtk_tree_view_column_set_resizable", "gboolean");
  gtk_tree_view_column_set_resizable(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gboolean(resizable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_resizable(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_resizable "gboolean gtk_tree_view_column_get_resizable(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_resizable", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_get_resizable(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_sizing(Xen tree_column, Xen type)
{
  #define H_gtk_tree_view_column_set_sizing "void gtk_tree_view_column_set_sizing(GtkTreeViewColumn* tree_column, \
GtkTreeViewColumnSizing type)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_sizing", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkTreeViewColumnSizing(type), type, 2, "gtk_tree_view_column_set_sizing", "GtkTreeViewColumnSizing");
  gtk_tree_view_column_set_sizing(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkTreeViewColumnSizing(type));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_sizing(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_sizing "GtkTreeViewColumnSizing gtk_tree_view_column_get_sizing(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_sizing", "GtkTreeViewColumn*");
  return(C_to_Xen_GtkTreeViewColumnSizing(gtk_tree_view_column_get_sizing(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_get_width(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_width "gint gtk_tree_view_column_get_width(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_width", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_width(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_get_fixed_width(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_fixed_width "gint gtk_tree_view_column_get_fixed_width(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_fixed_width", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_fixed_width(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_fixed_width(Xen tree_column, Xen fixed_width)
{
  #define H_gtk_tree_view_column_set_fixed_width "void gtk_tree_view_column_set_fixed_width(GtkTreeViewColumn* tree_column, \
gint fixed_width)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_fixed_width", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gint(fixed_width), fixed_width, 2, "gtk_tree_view_column_set_fixed_width", "gint");
  gtk_tree_view_column_set_fixed_width(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gint(fixed_width));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_set_min_width(Xen tree_column, Xen min_width)
{
  #define H_gtk_tree_view_column_set_min_width "void gtk_tree_view_column_set_min_width(GtkTreeViewColumn* tree_column, \
gint min_width)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_min_width", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gint(min_width), min_width, 2, "gtk_tree_view_column_set_min_width", "gint");
  gtk_tree_view_column_set_min_width(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gint(min_width));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_min_width(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_min_width "gint gtk_tree_view_column_get_min_width(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_min_width", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_min_width(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_max_width(Xen tree_column, Xen max_width)
{
  #define H_gtk_tree_view_column_set_max_width "void gtk_tree_view_column_set_max_width(GtkTreeViewColumn* tree_column, \
gint max_width)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_max_width", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gint(max_width), max_width, 2, "gtk_tree_view_column_set_max_width", "gint");
  gtk_tree_view_column_set_max_width(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gint(max_width));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_max_width(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_max_width "gint gtk_tree_view_column_get_max_width(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_max_width", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_max_width(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_clicked(Xen tree_column)
{
  #define H_gtk_tree_view_column_clicked "void gtk_tree_view_column_clicked(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_clicked", "GtkTreeViewColumn*");
  gtk_tree_view_column_clicked(Xen_to_C_GtkTreeViewColumn_(tree_column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_set_title(Xen tree_column, Xen title)
{
  #define H_gtk_tree_view_column_set_title "void gtk_tree_view_column_set_title(GtkTreeViewColumn* tree_column, \
gchar* title)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_title", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gchar_(title), title, 2, "gtk_tree_view_column_set_title", "gchar*");
  gtk_tree_view_column_set_title(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_title(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_title "gchar* gtk_tree_view_column_get_title(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_title", "GtkTreeViewColumn*");
  return(C_to_Xen_gchar_(gtk_tree_view_column_get_title(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_clickable(Xen tree_column, Xen clickable)
{
  #define H_gtk_tree_view_column_set_clickable "void gtk_tree_view_column_set_clickable(GtkTreeViewColumn* tree_column, \
gboolean clickable)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_clickable", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(clickable), clickable, 2, "gtk_tree_view_column_set_clickable", "gboolean");
  gtk_tree_view_column_set_clickable(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gboolean(clickable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_clickable(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_clickable "gboolean gtk_tree_view_column_get_clickable(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_clickable", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_get_clickable(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_widget(Xen tree_column, Xen widget)
{
  #define H_gtk_tree_view_column_set_widget "void gtk_tree_view_column_set_widget(GtkTreeViewColumn* tree_column, \
GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_widget", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkWidget_(widget) || Xen_is_false(widget), widget, 2, "gtk_tree_view_column_set_widget", "GtkWidget*");
  gtk_tree_view_column_set_widget(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_widget(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_widget "GtkWidget* gtk_tree_view_column_get_widget(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_widget", "GtkTreeViewColumn*");
  return(C_to_Xen_GtkWidget_(gtk_tree_view_column_get_widget(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_alignment(Xen tree_column, Xen xalign)
{
  #define H_gtk_tree_view_column_set_alignment "void gtk_tree_view_column_set_alignment(GtkTreeViewColumn* tree_column, \
gfloat xalign)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_alignment", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_tree_view_column_set_alignment", "gfloat");
  gtk_tree_view_column_set_alignment(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gfloat(xalign));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_alignment(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_alignment "gfloat gtk_tree_view_column_get_alignment(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_alignment", "GtkTreeViewColumn*");
  return(C_to_Xen_gfloat(gtk_tree_view_column_get_alignment(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_reorderable(Xen tree_column, Xen reorderable)
{
  #define H_gtk_tree_view_column_set_reorderable "void gtk_tree_view_column_set_reorderable(GtkTreeViewColumn* tree_column, \
gboolean reorderable)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_reorderable", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(reorderable), reorderable, 2, "gtk_tree_view_column_set_reorderable", "gboolean");
  gtk_tree_view_column_set_reorderable(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gboolean(reorderable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_reorderable(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_reorderable "gboolean gtk_tree_view_column_get_reorderable(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_reorderable", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_get_reorderable(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_sort_column_id(Xen tree_column, Xen sort_column_id)
{
  #define H_gtk_tree_view_column_set_sort_column_id "void gtk_tree_view_column_set_sort_column_id(GtkTreeViewColumn* tree_column, \
gint sort_column_id)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_sort_column_id", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gint(sort_column_id), sort_column_id, 2, "gtk_tree_view_column_set_sort_column_id", "gint");
  gtk_tree_view_column_set_sort_column_id(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gint(sort_column_id));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_sort_column_id(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_sort_column_id "gint gtk_tree_view_column_get_sort_column_id(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_sort_column_id", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_sort_column_id(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_sort_indicator(Xen tree_column, Xen setting)
{
  #define H_gtk_tree_view_column_set_sort_indicator "void gtk_tree_view_column_set_sort_indicator(GtkTreeViewColumn* tree_column, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_sort_indicator", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_tree_view_column_set_sort_indicator", "gboolean");
  gtk_tree_view_column_set_sort_indicator(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_sort_indicator(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_sort_indicator "gboolean gtk_tree_view_column_get_sort_indicator(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_sort_indicator", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_get_sort_indicator(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_set_sort_order(Xen tree_column, Xen order)
{
  #define H_gtk_tree_view_column_set_sort_order "void gtk_tree_view_column_set_sort_order(GtkTreeViewColumn* tree_column, \
GtkSortType order)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_sort_order", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkSortType(order), order, 2, "gtk_tree_view_column_set_sort_order", "GtkSortType");
  gtk_tree_view_column_set_sort_order(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkSortType(order));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_sort_order(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_sort_order "GtkSortType gtk_tree_view_column_get_sort_order(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_sort_order", "GtkTreeViewColumn*");
  return(C_to_Xen_GtkSortType(gtk_tree_view_column_get_sort_order(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_cell_set_cell_data(Xen tree_column, Xen tree_model, Xen iter, Xen is_expander, Xen is_expanded)
{
  #define H_gtk_tree_view_column_cell_set_cell_data "void gtk_tree_view_column_cell_set_cell_data(GtkTreeViewColumn* tree_column, \
GtkTreeModel* tree_model, GtkTreeIter* iter, gboolean is_expander, gboolean is_expanded)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_cell_set_cell_data", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 2, "gtk_tree_view_column_cell_set_cell_data", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_view_column_cell_set_cell_data", "GtkTreeIter*");
  Xen_check_type(Xen_is_gboolean(is_expander), is_expander, 4, "gtk_tree_view_column_cell_set_cell_data", "gboolean");
  Xen_check_type(Xen_is_gboolean(is_expanded), is_expanded, 5, "gtk_tree_view_column_cell_set_cell_data", "gboolean");
  gtk_tree_view_column_cell_set_cell_data(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter), 
                                          Xen_to_C_gboolean(is_expander), Xen_to_C_gboolean(is_expanded));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_cell_get_size(Xen tree_column, Xen cell_area, Xen ignore_x_offset, Xen ignore_y_offset, Xen ignore_width, Xen ignore_height)
{
  #define H_gtk_tree_view_column_cell_get_size "void gtk_tree_view_column_cell_get_size(GtkTreeViewColumn* tree_column, \
GdkRectangle* cell_area, gint* [x_offset], gint* [y_offset], gint* [width], gint* [height])"
  gint ref_x_offset;
  gint ref_y_offset;
  gint ref_width;
  gint ref_height;
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_cell_get_size", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GdkRectangle_(cell_area), cell_area, 2, "gtk_tree_view_column_cell_get_size", "GdkRectangle*");
  gtk_tree_view_column_cell_get_size(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GdkRectangle_(cell_area), &ref_x_offset, 
                                     &ref_y_offset, &ref_width, &ref_height);
  return(Xen_list_4(C_to_Xen_gint(ref_x_offset), C_to_Xen_gint(ref_y_offset), C_to_Xen_gint(ref_width), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gtk_tree_view_column_cell_is_visible(Xen tree_column)
{
  #define H_gtk_tree_view_column_cell_is_visible "gboolean gtk_tree_view_column_cell_is_visible(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_cell_is_visible", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_cell_is_visible(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_cell_get_position(Xen tree_column, Xen cell_renderer, Xen ignore_start_pos, Xen ignore_width)
{
  #define H_gtk_tree_view_column_cell_get_position "gboolean gtk_tree_view_column_cell_get_position(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gint* [start_pos], gint* [width])"
  gint ref_start_pos;
  gint ref_width;
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_cell_get_position", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell_renderer), cell_renderer, 2, "gtk_tree_view_column_cell_get_position", "GtkCellRenderer*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_view_column_cell_get_position(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell_renderer), 
                                                                      &ref_start_pos, &ref_width));
    return(Xen_list_3(result, C_to_Xen_gint(ref_start_pos), C_to_Xen_gint(ref_width)));
   }
}

static Xen gxg_gtk_tree_view_new(void)
{
  #define H_gtk_tree_view_new "GtkWidget* gtk_tree_view_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_tree_view_new()));
}

static Xen gxg_gtk_tree_view_new_with_model(Xen model)
{
  #define H_gtk_tree_view_new_with_model "GtkWidget* gtk_tree_view_new_with_model(GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 1, "gtk_tree_view_new_with_model", "GtkTreeModel*");
  return(C_to_Xen_GtkWidget_(gtk_tree_view_new_with_model(Xen_to_C_GtkTreeModel_(model))));
}

static Xen gxg_gtk_tree_view_get_model(Xen tree_view)
{
  #define H_gtk_tree_view_get_model "GtkTreeModel* gtk_tree_view_get_model(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_model", "GtkTreeView*");
  return(C_to_Xen_GtkTreeModel_(gtk_tree_view_get_model(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_model(Xen tree_view, Xen model)
{
  #define H_gtk_tree_view_set_model "void gtk_tree_view_set_model(GtkTreeView* tree_view, GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_model", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeModel_(model) || Xen_is_false(model), model, 2, "gtk_tree_view_set_model", "GtkTreeModel*");
  gtk_tree_view_set_model(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_selection(Xen tree_view)
{
  #define H_gtk_tree_view_get_selection "GtkTreeSelection* gtk_tree_view_get_selection(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_selection", "GtkTreeView*");
  return(C_to_Xen_GtkTreeSelection_(gtk_tree_view_get_selection(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_get_headers_visible(Xen tree_view)
{
  #define H_gtk_tree_view_get_headers_visible "gboolean gtk_tree_view_get_headers_visible(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_headers_visible", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_headers_visible(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_headers_visible(Xen tree_view, Xen headers_visible)
{
  #define H_gtk_tree_view_set_headers_visible "void gtk_tree_view_set_headers_visible(GtkTreeView* tree_view, \
gboolean headers_visible)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_headers_visible", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(headers_visible), headers_visible, 2, "gtk_tree_view_set_headers_visible", "gboolean");
  gtk_tree_view_set_headers_visible(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(headers_visible));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_columns_autosize(Xen tree_view)
{
  #define H_gtk_tree_view_columns_autosize "void gtk_tree_view_columns_autosize(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_columns_autosize", "GtkTreeView*");
  gtk_tree_view_columns_autosize(Xen_to_C_GtkTreeView_(tree_view));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_set_headers_clickable(Xen tree_view, Xen setting)
{
  #define H_gtk_tree_view_set_headers_clickable "void gtk_tree_view_set_headers_clickable(GtkTreeView* tree_view, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_headers_clickable", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_tree_view_set_headers_clickable", "gboolean");
  gtk_tree_view_set_headers_clickable(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_append_column(Xen tree_view, Xen column)
{
  #define H_gtk_tree_view_append_column "gint gtk_tree_view_append_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_append_column", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column), column, 2, "gtk_tree_view_append_column", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_append_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewColumn_(column))));
}

static Xen gxg_gtk_tree_view_remove_column(Xen tree_view, Xen column)
{
  #define H_gtk_tree_view_remove_column "gint gtk_tree_view_remove_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_remove_column", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column), column, 2, "gtk_tree_view_remove_column", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_remove_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewColumn_(column))));
}

static Xen gxg_gtk_tree_view_insert_column(Xen tree_view, Xen column, Xen position)
{
  #define H_gtk_tree_view_insert_column "gint gtk_tree_view_insert_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, \
gint position)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_insert_column", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column), column, 2, "gtk_tree_view_insert_column", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_tree_view_insert_column", "gint");
  return(C_to_Xen_gint(gtk_tree_view_insert_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewColumn_(column), 
                                                   Xen_to_C_gint(position))));
}

static Xen gxg_gtk_tree_view_insert_column_with_attributes(Xen tree_view, Xen position, Xen title, Xen cell, Xen attributes)
{
  #define H_gtk_tree_view_insert_column_with_attributes "gint gtk_tree_view_insert_column_with_attributes(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, etc attributes)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_insert_column_with_attributes", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_tree_view_insert_column_with_attributes", "gint");
  Xen_check_type(Xen_is_gchar_(title), title, 3, "gtk_tree_view_insert_column_with_attributes", "gchar*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 4, "gtk_tree_view_insert_column_with_attributes", "GtkCellRenderer*");
  Xen_check_type(Xen_is_etc(attributes), attributes, 5, "gtk_tree_view_insert_column_with_attributes", "etc");
  {
    int etc_len = 0;
    gint result = 0;
    GtkTreeView* p_arg0;
    gint p_arg1;
    gchar* p_arg2;
    GtkCellRenderer* p_arg3;
    if (Xen_is_list(attributes)) etc_len = Xen_list_length(attributes);
    if (etc_len < 2) Xen_out_of_range_error("gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkTreeView_(tree_view);
    p_arg1 = Xen_to_C_gint(position);
    p_arg2 = Xen_to_C_gchar_(title);
    p_arg3 = Xen_to_C_GtkCellRenderer_(cell);
    switch (etc_len)
      {
        case 2: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(C_to_Xen_gint(result));
  }
}

static Xen gxg_gtk_tree_view_insert_column_with_data_func(Xen tree_view, Xen position, Xen title, Xen cell, Xen func, Xen func_info, Xen dnotify)
{
  #define H_gtk_tree_view_insert_column_with_data_func "gint gtk_tree_view_insert_column_with_data_func(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, GtkTreeCellDataFunc func, lambda_data func_info, \
GtkDestroyNotify dnotify)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_insert_column_with_data_func", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_tree_view_insert_column_with_data_func", "gint");
  Xen_check_type(Xen_is_gchar_(title), title, 3, "gtk_tree_view_insert_column_with_data_func", "gchar*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 4, "gtk_tree_view_insert_column_with_data_func", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkTreeCellDataFunc(func), func, 5, "gtk_tree_view_insert_column_with_data_func", "GtkTreeCellDataFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 6, "gtk_tree_view_insert_column_with_data_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(dnotify), dnotify, 7, "gtk_tree_view_insert_column_with_data_func", "GtkDestroyNotify");
  {
    Xen result;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, dnotify);
    result = C_to_Xen_gint(gtk_tree_view_insert_column_with_data_func(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(position), 
                                                                      Xen_to_C_gchar_(title), Xen_to_C_GtkCellRenderer_(cell), 
                                                                      Xen_to_C_GtkTreeCellDataFunc(func), Xen_to_C_lambda_data(func_info), 
                                                                      Xen_to_C_GtkDestroyNotify(dnotify)));
    return(result);
   }
}

static Xen gxg_gtk_tree_view_get_column(Xen tree_view, Xen n)
{
  #define H_gtk_tree_view_get_column "GtkTreeViewColumn* gtk_tree_view_get_column(GtkTreeView* tree_view, \
gint n)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_column", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(n), n, 2, "gtk_tree_view_get_column", "gint");
  return(C_to_Xen_GtkTreeViewColumn_(gtk_tree_view_get_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(n))));
}

static Xen gxg_gtk_tree_view_get_columns(Xen tree_view)
{
  #define H_gtk_tree_view_get_columns "GList* gtk_tree_view_get_columns(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_columns", "GtkTreeView*");
  return(C_to_Xen_GList_(gtk_tree_view_get_columns(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_move_column_after(Xen tree_view, Xen column, Xen base_column)
{
  #define H_gtk_tree_view_move_column_after "void gtk_tree_view_move_column_after(GtkTreeView* tree_view, \
GtkTreeViewColumn* column, GtkTreeViewColumn* base_column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_move_column_after", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column), column, 2, "gtk_tree_view_move_column_after", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(base_column) || Xen_is_false(base_column), base_column, 3, "gtk_tree_view_move_column_after", "GtkTreeViewColumn*");
  gtk_tree_view_move_column_after(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewColumn_(column), Xen_to_C_GtkTreeViewColumn_(base_column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_set_expander_column(Xen tree_view, Xen column)
{
  #define H_gtk_tree_view_set_expander_column "void gtk_tree_view_set_expander_column(GtkTreeView* tree_view, \
GtkTreeViewColumn* column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_expander_column", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column) || Xen_is_false(column), column, 2, "gtk_tree_view_set_expander_column", "GtkTreeViewColumn*");
  gtk_tree_view_set_expander_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewColumn_(column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_expander_column(Xen tree_view)
{
  #define H_gtk_tree_view_get_expander_column "GtkTreeViewColumn* gtk_tree_view_get_expander_column(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_expander_column", "GtkTreeView*");
  return(C_to_Xen_GtkTreeViewColumn_(gtk_tree_view_get_expander_column(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_column_drag_function(Xen tree_view, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_view_set_column_drag_function "void gtk_tree_view_set_column_drag_function(GtkTreeView* tree_view, \
GtkTreeViewColumnDropFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_column_drag_function", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewColumnDropFunc(func), func, 2, "gtk_tree_view_set_column_drag_function", "GtkTreeViewColumnDropFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_view_set_column_drag_function", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 4, "gtk_tree_view_set_column_drag_function", "GtkDestroyNotify");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_tree_view_set_column_drag_function(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewColumnDropFunc(func), Xen_to_C_lambda_data(func_info), 
                                       Xen_to_C_GtkDestroyNotify(destroy));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_view_scroll_to_point(Xen tree_view, Xen tree_x, Xen tree_y)
{
  #define H_gtk_tree_view_scroll_to_point "void gtk_tree_view_scroll_to_point(GtkTreeView* tree_view, \
gint tree_x, gint tree_y)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_scroll_to_point", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(tree_x), tree_x, 2, "gtk_tree_view_scroll_to_point", "gint");
  Xen_check_type(Xen_is_gint(tree_y), tree_y, 3, "gtk_tree_view_scroll_to_point", "gint");
  gtk_tree_view_scroll_to_point(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(tree_x), Xen_to_C_gint(tree_y));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_scroll_to_cell(Xen tree_view, Xen path, Xen column, Xen use_align, Xen row_align, Xen col_align)
{
  #define H_gtk_tree_view_scroll_to_cell "void gtk_tree_view_scroll_to_cell(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, gboolean use_align, gfloat row_align, gfloat col_align)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_scroll_to_cell", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path) || Xen_is_false(path), path, 2, "gtk_tree_view_scroll_to_cell", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column) || Xen_is_false(column), column, 3, "gtk_tree_view_scroll_to_cell", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(use_align), use_align, 4, "gtk_tree_view_scroll_to_cell", "gboolean");
  Xen_check_type(Xen_is_gfloat(row_align), row_align, 5, "gtk_tree_view_scroll_to_cell", "gfloat");
  Xen_check_type(Xen_is_gfloat(col_align), col_align, 6, "gtk_tree_view_scroll_to_cell", "gfloat");
  gtk_tree_view_scroll_to_cell(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewColumn_(column), 
                               Xen_to_C_gboolean(use_align), Xen_to_C_gfloat(row_align), Xen_to_C_gfloat(col_align));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_row_activated(Xen tree_view, Xen path, Xen column)
{
  #define H_gtk_tree_view_row_activated "void gtk_tree_view_row_activated(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_row_activated", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_row_activated", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column), column, 3, "gtk_tree_view_row_activated", "GtkTreeViewColumn*");
  gtk_tree_view_row_activated(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewColumn_(column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_expand_all(Xen tree_view)
{
  #define H_gtk_tree_view_expand_all "void gtk_tree_view_expand_all(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_expand_all", "GtkTreeView*");
  gtk_tree_view_expand_all(Xen_to_C_GtkTreeView_(tree_view));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_collapse_all(Xen tree_view)
{
  #define H_gtk_tree_view_collapse_all "void gtk_tree_view_collapse_all(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_collapse_all", "GtkTreeView*");
  gtk_tree_view_collapse_all(Xen_to_C_GtkTreeView_(tree_view));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_expand_row(Xen tree_view, Xen path, Xen open_all)
{
  #define H_gtk_tree_view_expand_row "gboolean gtk_tree_view_expand_row(GtkTreeView* tree_view, GtkTreePath* path, \
gboolean open_all)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_expand_row", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_expand_row", "GtkTreePath*");
  Xen_check_type(Xen_is_gboolean(open_all), open_all, 3, "gtk_tree_view_expand_row", "gboolean");
  return(C_to_Xen_gboolean(gtk_tree_view_expand_row(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_gboolean(open_all))));
}

static Xen gxg_gtk_tree_view_collapse_row(Xen tree_view, Xen path)
{
  #define H_gtk_tree_view_collapse_row "gboolean gtk_tree_view_collapse_row(GtkTreeView* tree_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_collapse_row", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_collapse_row", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_view_collapse_row(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_view_map_expanded_rows(Xen tree_view, Xen func, Xen func_info)
{
  #define H_gtk_tree_view_map_expanded_rows "void gtk_tree_view_map_expanded_rows(GtkTreeView* tree_view, \
GtkTreeViewMappingFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_map_expanded_rows", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewMappingFunc(func), func, 2, "gtk_tree_view_map_expanded_rows", "GtkTreeViewMappingFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_view_map_expanded_rows", "lambda_data");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    gtk_tree_view_map_expanded_rows(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewMappingFunc(func), Xen_to_C_lambda_data(func_info));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_tree_view_row_expanded(Xen tree_view, Xen path)
{
  #define H_gtk_tree_view_row_expanded "gboolean gtk_tree_view_row_expanded(GtkTreeView* tree_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_row_expanded", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_row_expanded", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_tree_view_row_expanded(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_view_set_reorderable(Xen tree_view, Xen reorderable)
{
  #define H_gtk_tree_view_set_reorderable "void gtk_tree_view_set_reorderable(GtkTreeView* tree_view, \
gboolean reorderable)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_reorderable", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(reorderable), reorderable, 2, "gtk_tree_view_set_reorderable", "gboolean");
  gtk_tree_view_set_reorderable(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(reorderable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_reorderable(Xen tree_view)
{
  #define H_gtk_tree_view_get_reorderable "gboolean gtk_tree_view_get_reorderable(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_reorderable", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_reorderable(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_cursor(Xen tree_view, Xen path, Xen focus_column, Xen start_editing)
{
  #define H_gtk_tree_view_set_cursor "void gtk_tree_view_set_cursor(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* focus_column, gboolean start_editing)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_cursor", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_set_cursor", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(focus_column), focus_column, 3, "gtk_tree_view_set_cursor", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(start_editing), start_editing, 4, "gtk_tree_view_set_cursor", "gboolean");
  gtk_tree_view_set_cursor(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewColumn_(focus_column), 
                           Xen_to_C_gboolean(start_editing));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_cursor(Xen tree_view, Xen ignore_path, Xen ignore_focus_column)
{
  #define H_gtk_tree_view_get_cursor "void gtk_tree_view_get_cursor(GtkTreeView* tree_view, GtkTreePath** [path], \
GtkTreeViewColumn** [focus_column])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_focus_column = NULL;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_cursor", "GtkTreeView*");
  gtk_tree_view_get_cursor(Xen_to_C_GtkTreeView_(tree_view), &ref_path, &ref_focus_column);
  return(Xen_list_2(C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkTreeViewColumn_(ref_focus_column)));
}

static Xen gxg_gtk_tree_view_get_path_at_pos(Xen tree_view, Xen x, Xen y, Xen ignore_path, Xen ignore_column, Xen ignore_cell_x, Xen ignore_cell_y)
{
  #define H_gtk_tree_view_get_path_at_pos "gboolean gtk_tree_view_get_path_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_path_at_pos", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_tree_view_get_path_at_pos", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_tree_view_get_path_at_pos", "gint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_view_get_path_at_pos(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(x), Xen_to_C_gint(y), 
                                                             &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
    return(Xen_list_5(result, C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkTreeViewColumn_(ref_column), C_to_Xen_gint(ref_cell_x), C_to_Xen_gint(ref_cell_y)));
   }
}

static Xen gxg_gtk_tree_view_get_cell_area(Xen tree_view, Xen path, Xen column, Xen rect)
{
  #define H_gtk_tree_view_get_cell_area "void gtk_tree_view_get_cell_area(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, GdkRectangle* rect)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_cell_area", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path) || Xen_is_false(path), path, 2, "gtk_tree_view_get_cell_area", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column) || Xen_is_false(column), column, 3, "gtk_tree_view_get_cell_area", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 4, "gtk_tree_view_get_cell_area", "GdkRectangle*");
  gtk_tree_view_get_cell_area(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewColumn_(column), 
                              Xen_to_C_GdkRectangle_(rect));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_background_area(Xen tree_view, Xen path, Xen column, Xen rect)
{
  #define H_gtk_tree_view_get_background_area "void gtk_tree_view_get_background_area(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* column, GdkRectangle* rect)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_background_area", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path) || Xen_is_false(path), path, 2, "gtk_tree_view_get_background_area", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column) || Xen_is_false(column), column, 3, "gtk_tree_view_get_background_area", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 4, "gtk_tree_view_get_background_area", "GdkRectangle*");
  gtk_tree_view_get_background_area(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewColumn_(column), 
                                    Xen_to_C_GdkRectangle_(rect));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_visible_rect(Xen tree_view, Xen visible_rect)
{
  #define H_gtk_tree_view_get_visible_rect "void gtk_tree_view_get_visible_rect(GtkTreeView* tree_view, \
GdkRectangle* visible_rect)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_visible_rect", "GtkTreeView*");
  Xen_check_type(Xen_is_GdkRectangle_(visible_rect), visible_rect, 2, "gtk_tree_view_get_visible_rect", "GdkRectangle*");
  gtk_tree_view_get_visible_rect(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GdkRectangle_(visible_rect));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_unset_rows_drag_source(Xen tree_view)
{
  #define H_gtk_tree_view_unset_rows_drag_source "void gtk_tree_view_unset_rows_drag_source(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_unset_rows_drag_source", "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_source(Xen_to_C_GtkTreeView_(tree_view));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_unset_rows_drag_dest(Xen tree_view)
{
  #define H_gtk_tree_view_unset_rows_drag_dest "void gtk_tree_view_unset_rows_drag_dest(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_unset_rows_drag_dest", "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_dest(Xen_to_C_GtkTreeView_(tree_view));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_set_drag_dest_row(Xen tree_view, Xen path, Xen pos)
{
  #define H_gtk_tree_view_set_drag_dest_row "void gtk_tree_view_set_drag_dest_row(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewDropPosition pos)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_drag_dest_row", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_set_drag_dest_row", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewDropPosition(pos), pos, 3, "gtk_tree_view_set_drag_dest_row", "GtkTreeViewDropPosition");
  gtk_tree_view_set_drag_dest_row(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewDropPosition(pos));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_drag_dest_row(Xen tree_view, Xen ignore_path, Xen ignore_pos)
{
  #define H_gtk_tree_view_get_drag_dest_row "void gtk_tree_view_get_drag_dest_row(GtkTreeView* tree_view, \
GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_drag_dest_row", "GtkTreeView*");
  gtk_tree_view_get_drag_dest_row(Xen_to_C_GtkTreeView_(tree_view), &ref_path, &ref_pos);
  return(Xen_list_2(C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkTreeViewDropPosition(ref_pos)));
}

static Xen gxg_gtk_tree_view_get_dest_row_at_pos(Xen tree_view, Xen drag_x, Xen drag_y, Xen ignore_path, Xen ignore_pos)
{
  #define H_gtk_tree_view_get_dest_row_at_pos "gboolean gtk_tree_view_get_dest_row_at_pos(GtkTreeView* tree_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_dest_row_at_pos", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(drag_x), drag_x, 2, "gtk_tree_view_get_dest_row_at_pos", "gint");
  Xen_check_type(Xen_is_gint(drag_y), drag_y, 3, "gtk_tree_view_get_dest_row_at_pos", "gint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_view_get_dest_row_at_pos(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(drag_x), 
                                                                 Xen_to_C_gint(drag_y), &ref_path, &ref_pos));
    return(Xen_list_3(result, C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkTreeViewDropPosition(ref_pos)));
   }
}

static Xen gxg_gtk_tree_view_set_enable_search(Xen tree_view, Xen enable_search)
{
  #define H_gtk_tree_view_set_enable_search "void gtk_tree_view_set_enable_search(GtkTreeView* tree_view, \
gboolean enable_search)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_enable_search", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(enable_search), enable_search, 2, "gtk_tree_view_set_enable_search", "gboolean");
  gtk_tree_view_set_enable_search(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(enable_search));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_enable_search(Xen tree_view)
{
  #define H_gtk_tree_view_get_enable_search "gboolean gtk_tree_view_get_enable_search(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_enable_search", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_enable_search(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_get_search_column(Xen tree_view)
{
  #define H_gtk_tree_view_get_search_column "gint gtk_tree_view_get_search_column(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_search_column", "GtkTreeView*");
  return(C_to_Xen_gint(gtk_tree_view_get_search_column(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_search_column(Xen tree_view, Xen column)
{
  #define H_gtk_tree_view_set_search_column "void gtk_tree_view_set_search_column(GtkTreeView* tree_view, \
gint column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_search_column", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_tree_view_set_search_column", "gint");
  gtk_tree_view_set_search_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_search_equal_func(Xen tree_view)
{
  #define H_gtk_tree_view_get_search_equal_func "GtkTreeViewSearchEqualFunc gtk_tree_view_get_search_equal_func(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_search_equal_func", "GtkTreeView*");
  return(C_to_Xen_GtkTreeViewSearchEqualFunc(gtk_tree_view_get_search_equal_func(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_search_equal_func(Xen tree_view, Xen func, Xen func_info, Xen search_destroy)
{
  #define H_gtk_tree_view_set_search_equal_func "void gtk_tree_view_set_search_equal_func(GtkTreeView* tree_view, \
GtkTreeViewSearchEqualFunc func, lambda_data func_info, GtkDestroyNotify search_destroy)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_search_equal_func", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewSearchEqualFunc(func), func, 2, "gtk_tree_view_set_search_equal_func", "GtkTreeViewSearchEqualFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_view_set_search_equal_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(search_destroy), search_destroy, 4, "gtk_tree_view_set_search_equal_func", "GtkDestroyNotify");
  {
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    Xen_list_set(gxg_ptr, 3, search_destroy);
    gtk_tree_view_set_search_equal_func(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewSearchEqualFunc(func), Xen_to_C_lambda_data(func_info), 
                                    Xen_to_C_GtkDestroyNotify(search_destroy));
    xm_unprotect_at(loc);
    return(Xen_false);
   }
}

static Xen gxg_gtk_viewport_new(Xen hadjustment, Xen vadjustment)
{
  #define H_gtk_viewport_new "GtkWidget* gtk_viewport_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(hadjustment) || Xen_is_false(hadjustment), hadjustment, 1, "gtk_viewport_new", "GtkAdjustment*");
  Xen_check_type(Xen_is_GtkAdjustment_(vadjustment) || Xen_is_false(vadjustment), vadjustment, 2, "gtk_viewport_new", "GtkAdjustment*");
  return(C_to_Xen_GtkWidget_(gtk_viewport_new(Xen_to_C_GtkAdjustment_(hadjustment), Xen_to_C_GtkAdjustment_(vadjustment))));
}

static Xen gxg_gtk_viewport_set_shadow_type(Xen viewport, Xen type)
{
  #define H_gtk_viewport_set_shadow_type "void gtk_viewport_set_shadow_type(GtkViewport* viewport, GtkShadowType type)"
  Xen_check_type(Xen_is_GtkViewport_(viewport), viewport, 1, "gtk_viewport_set_shadow_type", "GtkViewport*");
  Xen_check_type(Xen_is_GtkShadowType(type), type, 2, "gtk_viewport_set_shadow_type", "GtkShadowType");
  gtk_viewport_set_shadow_type(Xen_to_C_GtkViewport_(viewport), Xen_to_C_GtkShadowType(type));
  return(Xen_false);
}

static Xen gxg_gtk_viewport_get_shadow_type(Xen viewport)
{
  #define H_gtk_viewport_get_shadow_type "GtkShadowType gtk_viewport_get_shadow_type(GtkViewport* viewport)"
  Xen_check_type(Xen_is_GtkViewport_(viewport), viewport, 1, "gtk_viewport_get_shadow_type", "GtkViewport*");
  return(C_to_Xen_GtkShadowType(gtk_viewport_get_shadow_type(Xen_to_C_GtkViewport_(viewport))));
}

static Xen gxg_gtk_widget_destroy(Xen widget)
{
  #define H_gtk_widget_destroy "void gtk_widget_destroy(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_destroy", "GtkWidget*");
  gtk_widget_destroy(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_destroyed(Xen widget, Xen ignore_widget_pointer)
{
  #define H_gtk_widget_destroyed "void gtk_widget_destroyed(GtkWidget* widget, GtkWidget** [widget_pointer])"
  GtkWidget* ref_widget_pointer = NULL;
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_destroyed", "GtkWidget*");
  gtk_widget_destroyed(Xen_to_C_GtkWidget_(widget), &ref_widget_pointer);
  return(Xen_list_1(C_to_Xen_GtkWidget_(ref_widget_pointer)));
}

static Xen gxg_gtk_widget_unparent(Xen widget)
{
  #define H_gtk_widget_unparent "void gtk_widget_unparent(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_unparent", "GtkWidget*");
  gtk_widget_unparent(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_show(Xen widget)
{
  #define H_gtk_widget_show "void gtk_widget_show(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_show", "GtkWidget*");
  gtk_widget_show(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_show_now(Xen widget)
{
  #define H_gtk_widget_show_now "void gtk_widget_show_now(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_show_now", "GtkWidget*");
  gtk_widget_show_now(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_hide(Xen widget)
{
  #define H_gtk_widget_hide "void gtk_widget_hide(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_hide", "GtkWidget*");
  gtk_widget_hide(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_map(Xen widget)
{
  #define H_gtk_widget_map "void gtk_widget_map(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_map", "GtkWidget*");
  gtk_widget_map(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_unmap(Xen widget)
{
  #define H_gtk_widget_unmap "void gtk_widget_unmap(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_unmap", "GtkWidget*");
  gtk_widget_unmap(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_realize(Xen widget)
{
  #define H_gtk_widget_realize "void gtk_widget_realize(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_realize", "GtkWidget*");
  gtk_widget_realize(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_unrealize(Xen widget)
{
  #define H_gtk_widget_unrealize "void gtk_widget_unrealize(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_unrealize", "GtkWidget*");
  gtk_widget_unrealize(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_queue_draw(Xen widget)
{
  #define H_gtk_widget_queue_draw "void gtk_widget_queue_draw(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_queue_draw", "GtkWidget*");
  gtk_widget_queue_draw(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_queue_draw_area(Xen widget, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_widget_queue_draw_area "void gtk_widget_queue_draw_area(GtkWidget* widget, gint x, gint y, \
gint width, gint height)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_queue_draw_area", "GtkWidget*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_widget_queue_draw_area", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_widget_queue_draw_area", "gint");
  Xen_check_type(Xen_is_gint(width), width, 4, "gtk_widget_queue_draw_area", "gint");
  Xen_check_type(Xen_is_gint(height), height, 5, "gtk_widget_queue_draw_area", "gint");
  gtk_widget_queue_draw_area(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(x), Xen_to_C_gint(y), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_widget_queue_resize(Xen widget)
{
  #define H_gtk_widget_queue_resize "void gtk_widget_queue_resize(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_queue_resize", "GtkWidget*");
  gtk_widget_queue_resize(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_add_accelerator(Xen widget, Xen accel_signal, Xen accel_group, Xen accel_key, Xen accel_mods, Xen accel_flags)
{
  #define H_gtk_widget_add_accelerator "void gtk_widget_add_accelerator(GtkWidget* widget, gchar* accel_signal, \
GtkAccelGroup* accel_group, guint accel_key, GdkModifierType accel_mods, GtkAccelFlags accel_flags)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_add_accelerator", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(accel_signal), accel_signal, 2, "gtk_widget_add_accelerator", "gchar*");
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 3, "gtk_widget_add_accelerator", "GtkAccelGroup*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 4, "gtk_widget_add_accelerator", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 5, "gtk_widget_add_accelerator", "GdkModifierType");
  Xen_check_type(Xen_is_GtkAccelFlags(accel_flags), accel_flags, 6, "gtk_widget_add_accelerator", "GtkAccelFlags");
  gtk_widget_add_accelerator(Xen_to_C_GtkWidget_(widget), Xen_to_C_gchar_(accel_signal), Xen_to_C_GtkAccelGroup_(accel_group), 
                             Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods), Xen_to_C_GtkAccelFlags(accel_flags));
  return(Xen_false);
}

static Xen gxg_gtk_widget_remove_accelerator(Xen widget, Xen accel_group, Xen accel_key, Xen accel_mods)
{
  #define H_gtk_widget_remove_accelerator "gboolean gtk_widget_remove_accelerator(GtkWidget* widget, \
GtkAccelGroup* accel_group, guint accel_key, GdkModifierType accel_mods)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_remove_accelerator", "GtkWidget*");
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 2, "gtk_widget_remove_accelerator", "GtkAccelGroup*");
  Xen_check_type(Xen_is_guint(accel_key), accel_key, 3, "gtk_widget_remove_accelerator", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accel_mods), accel_mods, 4, "gtk_widget_remove_accelerator", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_widget_remove_accelerator(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkAccelGroup_(accel_group), 
                                                         Xen_to_C_guint(accel_key), Xen_to_C_GdkModifierType(accel_mods))));
}

static Xen gxg_gtk_widget_list_accel_closures(Xen widget)
{
  #define H_gtk_widget_list_accel_closures "GList* gtk_widget_list_accel_closures(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_list_accel_closures", "GtkWidget*");
  return(C_to_Xen_GList_(gtk_widget_list_accel_closures(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_mnemonic_activate(Xen widget, Xen group_cycling)
{
  #define H_gtk_widget_mnemonic_activate "gboolean gtk_widget_mnemonic_activate(GtkWidget* widget, gboolean group_cycling)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_mnemonic_activate", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(group_cycling), group_cycling, 2, "gtk_widget_mnemonic_activate", "gboolean");
  return(C_to_Xen_gboolean(gtk_widget_mnemonic_activate(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(group_cycling))));
}

static Xen gxg_gtk_widget_event(Xen widget, Xen event)
{
  #define H_gtk_widget_event "gboolean gtk_widget_event(GtkWidget* widget, GdkEvent* event)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_event", "GtkWidget*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_widget_event", "GdkEvent*");
  return(C_to_Xen_gboolean(gtk_widget_event(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_widget_activate(Xen widget)
{
  #define H_gtk_widget_activate "gboolean gtk_widget_activate(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_activate", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_activate(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_intersect(Xen widget, Xen area, Xen intersection)
{
  #define H_gtk_widget_intersect "gboolean gtk_widget_intersect(GtkWidget* widget, GdkRectangle* area, \
GdkRectangle* intersection)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_intersect", "GtkWidget*");
  Xen_check_type(Xen_is_GdkRectangle_(area), area, 2, "gtk_widget_intersect", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(intersection) || Xen_is_false(intersection), intersection, 3, "gtk_widget_intersect", "GdkRectangle*");
  return(C_to_Xen_gboolean(gtk_widget_intersect(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkRectangle_(area), Xen_to_C_GdkRectangle_(intersection))));
}

static Xen gxg_gtk_widget_freeze_child_notify(Xen widget)
{
  #define H_gtk_widget_freeze_child_notify "void gtk_widget_freeze_child_notify(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_freeze_child_notify", "GtkWidget*");
  gtk_widget_freeze_child_notify(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_child_notify(Xen widget, Xen child_property)
{
  #define H_gtk_widget_child_notify "void gtk_widget_child_notify(GtkWidget* widget, gchar* child_property)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_child_notify", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(child_property), child_property, 2, "gtk_widget_child_notify", "gchar*");
  gtk_widget_child_notify(Xen_to_C_GtkWidget_(widget), Xen_to_C_gchar_(child_property));
  return(Xen_false);
}

static Xen gxg_gtk_widget_thaw_child_notify(Xen widget)
{
  #define H_gtk_widget_thaw_child_notify "void gtk_widget_thaw_child_notify(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_thaw_child_notify", "GtkWidget*");
  gtk_widget_thaw_child_notify(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_is_focus(Xen widget)
{
  #define H_gtk_widget_is_focus "gboolean gtk_widget_is_focus(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_is_focus", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_is_focus(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_grab_focus(Xen widget)
{
  #define H_gtk_widget_grab_focus "void gtk_widget_grab_focus(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_grab_focus", "GtkWidget*");
  gtk_widget_grab_focus(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_grab_default(Xen widget)
{
  #define H_gtk_widget_grab_default "void gtk_widget_grab_default(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_grab_default", "GtkWidget*");
  gtk_widget_grab_default(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_name(Xen widget, Xen name)
{
  #define H_gtk_widget_set_name "void gtk_widget_set_name(GtkWidget* widget, gchar* name)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_name", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_widget_set_name", "gchar*");
  gtk_widget_set_name(Xen_to_C_GtkWidget_(widget), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_name(Xen widget)
{
  #define H_gtk_widget_get_name "gchar* gtk_widget_get_name(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_name", "GtkWidget*");
  return(C_to_Xen_gchar_(gtk_widget_get_name(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_sensitive(Xen widget, Xen sensitive)
{
  #define H_gtk_widget_set_sensitive "void gtk_widget_set_sensitive(GtkWidget* widget, gboolean sensitive)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_sensitive", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(sensitive), sensitive, 2, "gtk_widget_set_sensitive", "gboolean");
  gtk_widget_set_sensitive(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(sensitive));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_parent(Xen widget, Xen parent)
{
  #define H_gtk_widget_set_parent "void gtk_widget_set_parent(GtkWidget* widget, GtkWidget* parent)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_parent", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(parent), parent, 2, "gtk_widget_set_parent", "GtkWidget*");
  gtk_widget_set_parent(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(parent));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_parent_window(Xen widget, Xen parent_window)
{
  #define H_gtk_widget_set_parent_window "void gtk_widget_set_parent_window(GtkWidget* widget, GdkWindow* parent_window)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_parent_window", "GtkWidget*");
  Xen_check_type(Xen_is_GdkWindow_(parent_window), parent_window, 2, "gtk_widget_set_parent_window", "GdkWindow*");
  gtk_widget_set_parent_window(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkWindow_(parent_window));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_child_visible(Xen widget, Xen is_visible)
{
  #define H_gtk_widget_set_child_visible "void gtk_widget_set_child_visible(GtkWidget* widget, gboolean is_visible)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_child_visible", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(is_visible), is_visible, 2, "gtk_widget_set_child_visible", "gboolean");
  gtk_widget_set_child_visible(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(is_visible));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_accel_path(Xen widget, Xen accel_path, Xen accel_group)
{
  #define H_gtk_widget_set_accel_path "void gtk_widget_set_accel_path(GtkWidget* widget, gchar* accel_path, \
GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_accel_path", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 2, "gtk_widget_set_accel_path", "gchar*");
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 3, "gtk_widget_set_accel_path", "GtkAccelGroup*");
  gtk_widget_set_accel_path(Xen_to_C_GtkWidget_(widget), Xen_to_C_gchar_(accel_path), Xen_to_C_GtkAccelGroup_(accel_group));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_child_visible(Xen widget)
{
  #define H_gtk_widget_get_child_visible "gboolean gtk_widget_get_child_visible(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_child_visible", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_child_visible(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_parent(Xen widget)
{
  #define H_gtk_widget_get_parent "GtkWidget* gtk_widget_get_parent(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_parent", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_parent(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_parent_window(Xen widget)
{
  #define H_gtk_widget_get_parent_window "GdkWindow* gtk_widget_get_parent_window(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_parent_window", "GtkWidget*");
  return(C_to_Xen_GdkWindow_(gtk_widget_get_parent_window(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_child_focus(Xen widget, Xen direction)
{
  #define H_gtk_widget_child_focus "gboolean gtk_widget_child_focus(GtkWidget* widget, GtkDirectionType direction)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_child_focus", "GtkWidget*");
  Xen_check_type(Xen_is_GtkDirectionType(direction), direction, 2, "gtk_widget_child_focus", "GtkDirectionType");
  return(C_to_Xen_gboolean(gtk_widget_child_focus(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkDirectionType(direction))));
}

static Xen gxg_gtk_widget_set_size_request(Xen widget, Xen width, Xen height)
{
  #define H_gtk_widget_set_size_request "void gtk_widget_set_size_request(GtkWidget* widget, gint width, \
gint height)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_size_request", "GtkWidget*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_widget_set_size_request", "gint");
  Xen_check_type(Xen_is_gint(height), height, 3, "gtk_widget_set_size_request", "gint");
  gtk_widget_set_size_request(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_size_request(Xen widget, Xen ignore_width, Xen ignore_height)
{
  #define H_gtk_widget_get_size_request "void gtk_widget_get_size_request(GtkWidget* widget, gint* [width], \
gint* [height])"
  gint ref_width;
  gint ref_height;
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_size_request", "GtkWidget*");
  gtk_widget_get_size_request(Xen_to_C_GtkWidget_(widget), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_gint(ref_width), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gtk_widget_get_toplevel(Xen widget)
{
  #define H_gtk_widget_get_toplevel "GtkWidget* gtk_widget_get_toplevel(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_toplevel", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_toplevel(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_ancestor(Xen widget, Xen widget_type)
{
  #define H_gtk_widget_get_ancestor "GtkWidget* gtk_widget_get_ancestor(GtkWidget* widget, GType widget_type)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_ancestor", "GtkWidget*");
  Xen_check_type(Xen_is_GType(widget_type), widget_type, 2, "gtk_widget_get_ancestor", "GType");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_ancestor(Xen_to_C_GtkWidget_(widget), Xen_to_C_GType(widget_type))));
}

static Xen gxg_gtk_widget_get_settings(Xen widget)
{
  #define H_gtk_widget_get_settings "GtkSettings* gtk_widget_get_settings(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_settings", "GtkWidget*");
  return(C_to_Xen_GtkSettings_(gtk_widget_get_settings(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_accessible(Xen widget)
{
  #define H_gtk_widget_get_accessible "AtkObject* gtk_widget_get_accessible(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_accessible", "GtkWidget*");
  return(C_to_Xen_AtkObject_(gtk_widget_get_accessible(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_is_ancestor(Xen widget, Xen ancestor)
{
  #define H_gtk_widget_is_ancestor "gboolean gtk_widget_is_ancestor(GtkWidget* widget, GtkWidget* ancestor)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_is_ancestor", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(ancestor), ancestor, 2, "gtk_widget_is_ancestor", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_is_ancestor(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(ancestor))));
}

static Xen gxg_gtk_widget_translate_coordinates(Xen src_widget, Xen dest_widget, Xen src_x, Xen src_y, Xen ignore_dest_x, Xen ignore_dest_y)
{
  #define H_gtk_widget_translate_coordinates "gboolean gtk_widget_translate_coordinates(GtkWidget* src_widget, \
GtkWidget* dest_widget, gint src_x, gint src_y, gint* [dest_x], gint* [dest_y])"
  gint ref_dest_x;
  gint ref_dest_y;
  Xen_check_type(Xen_is_GtkWidget_(src_widget), src_widget, 1, "gtk_widget_translate_coordinates", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(dest_widget), dest_widget, 2, "gtk_widget_translate_coordinates", "GtkWidget*");
  Xen_check_type(Xen_is_gint(src_x), src_x, 3, "gtk_widget_translate_coordinates", "gint");
  Xen_check_type(Xen_is_gint(src_y), src_y, 4, "gtk_widget_translate_coordinates", "gint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_widget_translate_coordinates(Xen_to_C_GtkWidget_(src_widget), Xen_to_C_GtkWidget_(dest_widget), 
                                                                Xen_to_C_gint(src_x), Xen_to_C_gint(src_y), &ref_dest_x, 
                                                                &ref_dest_y));
    return(Xen_list_3(result, C_to_Xen_gint(ref_dest_x), C_to_Xen_gint(ref_dest_y)));
   }
}

static Xen gxg_gtk_widget_hide_on_delete(Xen widget)
{
  #define H_gtk_widget_hide_on_delete "gboolean gtk_widget_hide_on_delete(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_hide_on_delete", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_hide_on_delete(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_create_pango_context(Xen widget)
{
  #define H_gtk_widget_create_pango_context "PangoContext* gtk_widget_create_pango_context(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_create_pango_context", "GtkWidget*");
  return(C_to_Xen_PangoContext_(gtk_widget_create_pango_context(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_pango_context(Xen widget)
{
  #define H_gtk_widget_get_pango_context "PangoContext* gtk_widget_get_pango_context(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_pango_context", "GtkWidget*");
  return(C_to_Xen_PangoContext_(gtk_widget_get_pango_context(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_create_pango_layout(Xen widget, Xen text)
{
  #define H_gtk_widget_create_pango_layout "PangoLayout* gtk_widget_create_pango_layout(GtkWidget* widget, \
gchar* text)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_create_pango_layout", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_widget_create_pango_layout", "gchar*");
  return(C_to_Xen_PangoLayout_(gtk_widget_create_pango_layout(Xen_to_C_GtkWidget_(widget), Xen_to_C_gchar_(text))));
}

static Xen gxg_gtk_widget_set_direction(Xen widget, Xen dir)
{
  #define H_gtk_widget_set_direction "void gtk_widget_set_direction(GtkWidget* widget, GtkTextDirection dir)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_direction", "GtkWidget*");
  Xen_check_type(Xen_is_GtkTextDirection(dir), dir, 2, "gtk_widget_set_direction", "GtkTextDirection");
  gtk_widget_set_direction(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkTextDirection(dir));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_direction(Xen widget)
{
  #define H_gtk_widget_get_direction "GtkTextDirection gtk_widget_get_direction(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_direction", "GtkWidget*");
  return(C_to_Xen_GtkTextDirection(gtk_widget_get_direction(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_default_direction(Xen dir)
{
  #define H_gtk_widget_set_default_direction "void gtk_widget_set_default_direction(GtkTextDirection dir)"
  Xen_check_type(Xen_is_GtkTextDirection(dir), dir, 1, "gtk_widget_set_default_direction", "GtkTextDirection");
  gtk_widget_set_default_direction(Xen_to_C_GtkTextDirection(dir));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_default_direction(void)
{
  #define H_gtk_widget_get_default_direction "GtkTextDirection gtk_widget_get_default_direction( void)"
  return(C_to_Xen_GtkTextDirection(gtk_widget_get_default_direction()));
}

static Xen gxg_gtk_widget_can_activate_accel(Xen widget, Xen signal_id)
{
  #define H_gtk_widget_can_activate_accel "gboolean gtk_widget_can_activate_accel(GtkWidget* widget, \
guint signal_id)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_can_activate_accel", "GtkWidget*");
  Xen_check_type(Xen_is_guint(signal_id), signal_id, 2, "gtk_widget_can_activate_accel", "guint");
  return(C_to_Xen_gboolean(gtk_widget_can_activate_accel(Xen_to_C_GtkWidget_(widget), Xen_to_C_guint(signal_id))));
}

static Xen gxg_gtk_window_is_active(Xen window)
{
  #define H_gtk_window_is_active "gboolean gtk_window_is_active(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_is_active", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_is_active(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_new(Xen type)
{
  #define H_gtk_window_new "GtkWidget* gtk_window_new(GtkWindowType type)"
  Xen_check_type(Xen_is_GtkWindowType(type), type, 1, "gtk_window_new", "GtkWindowType");
  return(C_to_Xen_GtkWidget_(gtk_window_new(Xen_to_C_GtkWindowType(type))));
}

static Xen gxg_gtk_window_set_title(Xen window, Xen title)
{
  #define H_gtk_window_set_title "void gtk_window_set_title(GtkWindow* window, gchar* title)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_title", "GtkWindow*");
  Xen_check_type(Xen_is_gchar_(title), title, 2, "gtk_window_set_title", "gchar*");
  gtk_window_set_title(Xen_to_C_GtkWindow_(window), Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_auto_startup_notification(Xen setting)
{
  #define H_gtk_window_set_auto_startup_notification "void gtk_window_set_auto_startup_notification(gboolean setting)"
  Xen_check_type(Xen_is_gboolean(setting), setting, 1, "gtk_window_set_auto_startup_notification", "gboolean");
  gtk_window_set_auto_startup_notification(Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_title(Xen window)
{
  #define H_gtk_window_get_title "gchar* gtk_window_get_title(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_title", "GtkWindow*");
  return(C_to_Xen_gchar_(gtk_window_get_title(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_role(Xen window, Xen role)
{
  #define H_gtk_window_set_role "void gtk_window_set_role(GtkWindow* window, gchar* role)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_role", "GtkWindow*");
  Xen_check_type(Xen_is_gchar_(role), role, 2, "gtk_window_set_role", "gchar*");
  gtk_window_set_role(Xen_to_C_GtkWindow_(window), Xen_to_C_gchar_(role));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_role(Xen window)
{
  #define H_gtk_window_get_role "gchar* gtk_window_get_role(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_role", "GtkWindow*");
  return(C_to_Xen_gchar_(gtk_window_get_role(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_add_accel_group(Xen window, Xen accel_group)
{
  #define H_gtk_window_add_accel_group "void gtk_window_add_accel_group(GtkWindow* window, GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_add_accel_group", "GtkWindow*");
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 2, "gtk_window_add_accel_group", "GtkAccelGroup*");
  gtk_window_add_accel_group(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkAccelGroup_(accel_group));
  return(Xen_false);
}

static Xen gxg_gtk_window_remove_accel_group(Xen window, Xen accel_group)
{
  #define H_gtk_window_remove_accel_group "void gtk_window_remove_accel_group(GtkWindow* window, GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_remove_accel_group", "GtkWindow*");
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 2, "gtk_window_remove_accel_group", "GtkAccelGroup*");
  gtk_window_remove_accel_group(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkAccelGroup_(accel_group));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_position(Xen window, Xen position)
{
  #define H_gtk_window_set_position "void gtk_window_set_position(GtkWindow* window, GtkWindowPosition position)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_position", "GtkWindow*");
  Xen_check_type(Xen_is_GtkWindowPosition(position), position, 2, "gtk_window_set_position", "GtkWindowPosition");
  gtk_window_set_position(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkWindowPosition(position));
  return(Xen_false);
}

static Xen gxg_gtk_window_activate_focus(Xen window)
{
  #define H_gtk_window_activate_focus "gboolean gtk_window_activate_focus(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_activate_focus", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_activate_focus(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_focus(Xen window, Xen focus)
{
  #define H_gtk_window_set_focus "void gtk_window_set_focus(GtkWindow* window, GtkWidget* focus)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_focus", "GtkWindow*");
  Xen_check_type(Xen_is_GtkWidget_(focus) || Xen_is_false(focus), focus, 2, "gtk_window_set_focus", "GtkWidget*");
  gtk_window_set_focus(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkWidget_(focus));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_focus(Xen window)
{
  #define H_gtk_window_get_focus "GtkWidget* gtk_window_get_focus(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_focus", "GtkWindow*");
  return(C_to_Xen_GtkWidget_(gtk_window_get_focus(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_default(Xen window, Xen default_widget)
{
  #define H_gtk_window_set_default "void gtk_window_set_default(GtkWindow* window, GtkWidget* default_widget)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_default", "GtkWindow*");
  Xen_check_type(Xen_is_GtkWidget_(default_widget) || Xen_is_false(default_widget), default_widget, 2, "gtk_window_set_default", "GtkWidget*");
  gtk_window_set_default(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkWidget_(default_widget));
  return(Xen_false);
}

static Xen gxg_gtk_window_activate_default(Xen window)
{
  #define H_gtk_window_activate_default "gboolean gtk_window_activate_default(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_activate_default", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_activate_default(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_transient_for(Xen window, Xen parent)
{
  #define H_gtk_window_set_transient_for "void gtk_window_set_transient_for(GtkWindow* window, GtkWindow* parent)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_transient_for", "GtkWindow*");
  Xen_check_type(Xen_is_GtkWindow_(parent) || Xen_is_false(parent), parent, 2, "gtk_window_set_transient_for", "GtkWindow*");
  gtk_window_set_transient_for(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkWindow_(parent));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_transient_for(Xen window)
{
  #define H_gtk_window_get_transient_for "GtkWindow* gtk_window_get_transient_for(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_transient_for", "GtkWindow*");
  return(C_to_Xen_GtkWindow_(gtk_window_get_transient_for(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_type_hint(Xen window, Xen hint)
{
  #define H_gtk_window_set_type_hint "void gtk_window_set_type_hint(GtkWindow* window, GdkWindowTypeHint hint)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_type_hint", "GtkWindow*");
  Xen_check_type(Xen_is_GdkWindowTypeHint(hint), hint, 2, "gtk_window_set_type_hint", "GdkWindowTypeHint");
  gtk_window_set_type_hint(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkWindowTypeHint(hint));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_type_hint(Xen window)
{
  #define H_gtk_window_get_type_hint "GdkWindowTypeHint gtk_window_get_type_hint(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_type_hint", "GtkWindow*");
  return(C_to_Xen_GdkWindowTypeHint(gtk_window_get_type_hint(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_destroy_with_parent(Xen window, Xen setting)
{
  #define H_gtk_window_set_destroy_with_parent "void gtk_window_set_destroy_with_parent(GtkWindow* window, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_destroy_with_parent", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_destroy_with_parent", "gboolean");
  gtk_window_set_destroy_with_parent(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_destroy_with_parent(Xen window)
{
  #define H_gtk_window_get_destroy_with_parent "gboolean gtk_window_get_destroy_with_parent(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_destroy_with_parent", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_destroy_with_parent(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_resizable(Xen window, Xen resizable)
{
  #define H_gtk_window_set_resizable "void gtk_window_set_resizable(GtkWindow* window, gboolean resizable)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_resizable", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(resizable), resizable, 2, "gtk_window_set_resizable", "gboolean");
  gtk_window_set_resizable(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(resizable));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_resizable(Xen window)
{
  #define H_gtk_window_get_resizable "gboolean gtk_window_get_resizable(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_resizable", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_resizable(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_gravity(Xen window, Xen gravity)
{
  #define H_gtk_window_set_gravity "void gtk_window_set_gravity(GtkWindow* window, GdkGravity gravity)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_gravity", "GtkWindow*");
  Xen_check_type(Xen_is_GdkGravity(gravity), gravity, 2, "gtk_window_set_gravity", "GdkGravity");
  gtk_window_set_gravity(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkGravity(gravity));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_gravity(Xen window)
{
  #define H_gtk_window_get_gravity "GdkGravity gtk_window_get_gravity(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_gravity", "GtkWindow*");
  return(C_to_Xen_GdkGravity(gtk_window_get_gravity(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_decorated(Xen window, Xen setting)
{
  #define H_gtk_window_set_decorated "void gtk_window_set_decorated(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_decorated", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_decorated", "gboolean");
  gtk_window_set_decorated(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_decorated(Xen window)
{
  #define H_gtk_window_get_decorated "gboolean gtk_window_get_decorated(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_decorated", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_decorated(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_icon_list(Xen window, Xen list)
{
  #define H_gtk_window_set_icon_list "void gtk_window_set_icon_list(GtkWindow* window, GList* list)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_icon_list", "GtkWindow*");
  Xen_check_type(Xen_is_GList_(list) || Xen_is_false(list), list, 2, "gtk_window_set_icon_list", "GList*");
  gtk_window_set_icon_list(Xen_to_C_GtkWindow_(window), Xen_to_C_GList_(list));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_default_icon_list(void)
{
  #define H_gtk_window_get_default_icon_list "GList* gtk_window_get_default_icon_list( void)"
  return(C_to_Xen_GList_(gtk_window_get_default_icon_list()));
}

static Xen gxg_gtk_window_set_modal(Xen window, Xen modal)
{
  #define H_gtk_window_set_modal "void gtk_window_set_modal(GtkWindow* window, gboolean modal)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_modal", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(modal), modal, 2, "gtk_window_set_modal", "gboolean");
  gtk_window_set_modal(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(modal));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_modal(Xen window)
{
  #define H_gtk_window_get_modal "gboolean gtk_window_get_modal(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_modal", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_modal(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_list_toplevels(void)
{
  #define H_gtk_window_list_toplevels "GList* gtk_window_list_toplevels( void)"
  return(C_to_Xen_GList_(gtk_window_list_toplevels()));
}

static Xen gxg_gtk_window_add_mnemonic(Xen window, Xen keyval, Xen target)
{
  #define H_gtk_window_add_mnemonic "void gtk_window_add_mnemonic(GtkWindow* window, guint keyval, GtkWidget* target)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_add_mnemonic", "GtkWindow*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_window_add_mnemonic", "guint");
  Xen_check_type(Xen_is_GtkWidget_(target), target, 3, "gtk_window_add_mnemonic", "GtkWidget*");
  gtk_window_add_mnemonic(Xen_to_C_GtkWindow_(window), Xen_to_C_guint(keyval), Xen_to_C_GtkWidget_(target));
  return(Xen_false);
}

static Xen gxg_gtk_window_remove_mnemonic(Xen window, Xen keyval, Xen target)
{
  #define H_gtk_window_remove_mnemonic "void gtk_window_remove_mnemonic(GtkWindow* window, guint keyval, \
GtkWidget* target)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_remove_mnemonic", "GtkWindow*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_window_remove_mnemonic", "guint");
  Xen_check_type(Xen_is_GtkWidget_(target), target, 3, "gtk_window_remove_mnemonic", "GtkWidget*");
  gtk_window_remove_mnemonic(Xen_to_C_GtkWindow_(window), Xen_to_C_guint(keyval), Xen_to_C_GtkWidget_(target));
  return(Xen_false);
}

static Xen gxg_gtk_window_mnemonic_activate(Xen window, Xen keyval, Xen modifier)
{
  #define H_gtk_window_mnemonic_activate "gboolean gtk_window_mnemonic_activate(GtkWindow* window, guint keyval, \
GdkModifierType modifier)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_mnemonic_activate", "GtkWindow*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_window_mnemonic_activate", "guint");
  Xen_check_type(Xen_is_GdkModifierType(modifier), modifier, 3, "gtk_window_mnemonic_activate", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_window_mnemonic_activate(Xen_to_C_GtkWindow_(window), Xen_to_C_guint(keyval), Xen_to_C_GdkModifierType(modifier))));
}

static Xen gxg_gtk_window_set_mnemonic_modifier(Xen window, Xen modifier)
{
  #define H_gtk_window_set_mnemonic_modifier "void gtk_window_set_mnemonic_modifier(GtkWindow* window, \
GdkModifierType modifier)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_mnemonic_modifier", "GtkWindow*");
  Xen_check_type(Xen_is_GdkModifierType(modifier), modifier, 2, "gtk_window_set_mnemonic_modifier", "GdkModifierType");
  gtk_window_set_mnemonic_modifier(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkModifierType(modifier));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_mnemonic_modifier(Xen window)
{
  #define H_gtk_window_get_mnemonic_modifier "GdkModifierType gtk_window_get_mnemonic_modifier(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_mnemonic_modifier", "GtkWindow*");
  return(C_to_Xen_GdkModifierType(gtk_window_get_mnemonic_modifier(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_present(Xen window)
{
  #define H_gtk_window_present "void gtk_window_present(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_present", "GtkWindow*");
  gtk_window_present(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_iconify(Xen window)
{
  #define H_gtk_window_iconify "void gtk_window_iconify(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_iconify", "GtkWindow*");
  gtk_window_iconify(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_deiconify(Xen window)
{
  #define H_gtk_window_deiconify "void gtk_window_deiconify(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_deiconify", "GtkWindow*");
  gtk_window_deiconify(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_stick(Xen window)
{
  #define H_gtk_window_stick "void gtk_window_stick(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_stick", "GtkWindow*");
  gtk_window_stick(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_unstick(Xen window)
{
  #define H_gtk_window_unstick "void gtk_window_unstick(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_unstick", "GtkWindow*");
  gtk_window_unstick(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_maximize(Xen window)
{
  #define H_gtk_window_maximize "void gtk_window_maximize(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_maximize", "GtkWindow*");
  gtk_window_maximize(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_unmaximize(Xen window)
{
  #define H_gtk_window_unmaximize "void gtk_window_unmaximize(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_unmaximize", "GtkWindow*");
  gtk_window_unmaximize(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_begin_resize_drag(Xen window, Xen edge, Xen button, Xen root_x, Xen root_y, Xen timestamp)
{
  #define H_gtk_window_begin_resize_drag "void gtk_window_begin_resize_drag(GtkWindow* window, GdkWindowEdge edge, \
gint button, gint root_x, gint root_y, guint32 timestamp)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_begin_resize_drag", "GtkWindow*");
  Xen_check_type(Xen_is_GdkWindowEdge(edge), edge, 2, "gtk_window_begin_resize_drag", "GdkWindowEdge");
  Xen_check_type(Xen_is_gint(button), button, 3, "gtk_window_begin_resize_drag", "gint");
  Xen_check_type(Xen_is_gint(root_x), root_x, 4, "gtk_window_begin_resize_drag", "gint");
  Xen_check_type(Xen_is_gint(root_y), root_y, 5, "gtk_window_begin_resize_drag", "gint");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 6, "gtk_window_begin_resize_drag", "guint32");
  gtk_window_begin_resize_drag(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkWindowEdge(edge), Xen_to_C_gint(button), Xen_to_C_gint(root_x), 
                               Xen_to_C_gint(root_y), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gtk_window_begin_move_drag(Xen window, Xen button, Xen root_x, Xen root_y, Xen timestamp)
{
  #define H_gtk_window_begin_move_drag "void gtk_window_begin_move_drag(GtkWindow* window, gint button, \
gint root_x, gint root_y, guint32 timestamp)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_begin_move_drag", "GtkWindow*");
  Xen_check_type(Xen_is_gint(button), button, 2, "gtk_window_begin_move_drag", "gint");
  Xen_check_type(Xen_is_gint(root_x), root_x, 3, "gtk_window_begin_move_drag", "gint");
  Xen_check_type(Xen_is_gint(root_y), root_y, 4, "gtk_window_begin_move_drag", "gint");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 5, "gtk_window_begin_move_drag", "guint32");
  gtk_window_begin_move_drag(Xen_to_C_GtkWindow_(window), Xen_to_C_gint(button), Xen_to_C_gint(root_x), Xen_to_C_gint(root_y), 
                             Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_default_size(Xen window, Xen width, Xen height)
{
  #define H_gtk_window_set_default_size "void gtk_window_set_default_size(GtkWindow* window, gint width, \
gint height)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_default_size", "GtkWindow*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_window_set_default_size", "gint");
  Xen_check_type(Xen_is_gint(height), height, 3, "gtk_window_set_default_size", "gint");
  gtk_window_set_default_size(Xen_to_C_GtkWindow_(window), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_default_size(Xen window, Xen ignore_width, Xen ignore_height)
{
  #define H_gtk_window_get_default_size "void gtk_window_get_default_size(GtkWindow* window, gint* [width], \
gint* [height])"
  gint ref_width;
  gint ref_height;
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_default_size", "GtkWindow*");
  gtk_window_get_default_size(Xen_to_C_GtkWindow_(window), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_gint(ref_width), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gtk_window_resize(Xen window, Xen width, Xen height)
{
  #define H_gtk_window_resize "void gtk_window_resize(GtkWindow* window, gint width, gint height)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_resize", "GtkWindow*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_window_resize", "gint");
  Xen_check_type(Xen_is_gint(height), height, 3, "gtk_window_resize", "gint");
  gtk_window_resize(Xen_to_C_GtkWindow_(window), Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_size(Xen window, Xen ignore_width, Xen ignore_height)
{
  #define H_gtk_window_get_size "void gtk_window_get_size(GtkWindow* window, gint* [width], gint* [height])"
  gint ref_width;
  gint ref_height;
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_size", "GtkWindow*");
  gtk_window_get_size(Xen_to_C_GtkWindow_(window), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_gint(ref_width), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gtk_window_move(Xen window, Xen x, Xen y)
{
  #define H_gtk_window_move "void gtk_window_move(GtkWindow* window, gint x, gint y)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_move", "GtkWindow*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_window_move", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_window_move", "gint");
  gtk_window_move(Xen_to_C_GtkWindow_(window), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_position(Xen window, Xen ignore_root_x, Xen ignore_root_y)
{
  #define H_gtk_window_get_position "void gtk_window_get_position(GtkWindow* window, gint* [root_x], \
gint* [root_y])"
  gint ref_root_x;
  gint ref_root_y;
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_position", "GtkWindow*");
  gtk_window_get_position(Xen_to_C_GtkWindow_(window), &ref_root_x, &ref_root_y);
  return(Xen_list_2(C_to_Xen_gint(ref_root_x), C_to_Xen_gint(ref_root_y)));
}

static Xen gxg_pango_color_copy(Xen src)
{
  #define H_pango_color_copy "PangoColor* pango_color_copy(PangoColor* src)"
  Xen_check_type(Xen_is_PangoColor_(src), src, 1, "pango_color_copy", "PangoColor*");
  return(C_to_Xen_PangoColor_(pango_color_copy(Xen_to_C_PangoColor_(src))));
}

static Xen gxg_pango_color_free(Xen color)
{
  #define H_pango_color_free "void pango_color_free(PangoColor* color)"
  Xen_check_type(Xen_is_PangoColor_(color), color, 1, "pango_color_free", "PangoColor*");
  pango_color_free(Xen_to_C_PangoColor_(color));
  return(Xen_false);
}

static Xen gxg_pango_color_parse(Xen color, Xen spec)
{
  #define H_pango_color_parse "gboolean pango_color_parse(PangoColor* color, char* spec)"
  Xen_check_type(Xen_is_PangoColor_(color), color, 1, "pango_color_parse", "PangoColor*");
  Xen_check_type(Xen_is_char_(spec), spec, 2, "pango_color_parse", "char*");
  return(C_to_Xen_gboolean(pango_color_parse(Xen_to_C_PangoColor_(color), Xen_to_C_char_(spec))));
}

static Xen gxg_pango_attr_type_register(Xen name)
{
  #define H_pango_attr_type_register "PangoAttrType pango_attr_type_register(gchar* name)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "pango_attr_type_register", "gchar*");
  return(C_to_Xen_PangoAttrType(pango_attr_type_register(Xen_to_C_gchar_(name))));
}

static Xen gxg_pango_attribute_copy(Xen attr)
{
  #define H_pango_attribute_copy "PangoAttribute* pango_attribute_copy(PangoAttribute* attr)"
  Xen_check_type(Xen_is_PangoAttribute_(attr), attr, 1, "pango_attribute_copy", "PangoAttribute*");
  return(C_to_Xen_PangoAttribute_(pango_attribute_copy(Xen_to_C_PangoAttribute_(attr))));
}

static Xen gxg_pango_attribute_destroy(Xen attr)
{
  #define H_pango_attribute_destroy "void pango_attribute_destroy(PangoAttribute* attr)"
  Xen_check_type(Xen_is_PangoAttribute_(attr), attr, 1, "pango_attribute_destroy", "PangoAttribute*");
  pango_attribute_destroy(Xen_to_C_PangoAttribute_(attr));
  return(Xen_false);
}

static Xen gxg_pango_attribute_equal(Xen attr1, Xen attr2)
{
  #define H_pango_attribute_equal "gboolean pango_attribute_equal(PangoAttribute* attr1, PangoAttribute* attr2)"
  Xen_check_type(Xen_is_PangoAttribute_(attr1), attr1, 1, "pango_attribute_equal", "PangoAttribute*");
  Xen_check_type(Xen_is_PangoAttribute_(attr2), attr2, 2, "pango_attribute_equal", "PangoAttribute*");
  return(C_to_Xen_gboolean(pango_attribute_equal(Xen_to_C_PangoAttribute_(attr1), Xen_to_C_PangoAttribute_(attr2))));
}

static Xen gxg_pango_attr_language_new(Xen language)
{
  #define H_pango_attr_language_new "PangoAttribute* pango_attr_language_new(PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 1, "pango_attr_language_new", "PangoLanguage*");
  return(C_to_Xen_PangoAttribute_(pango_attr_language_new(Xen_to_C_PangoLanguage_(language))));
}

static Xen gxg_pango_attr_family_new(Xen family)
{
  #define H_pango_attr_family_new "PangoAttribute* pango_attr_family_new(char* family)"
  Xen_check_type(Xen_is_char_(family), family, 1, "pango_attr_family_new", "char*");
  return(C_to_Xen_PangoAttribute_(pango_attr_family_new(Xen_to_C_char_(family))));
}

static Xen gxg_pango_attr_foreground_new(Xen red, Xen green, Xen blue)
{
  #define H_pango_attr_foreground_new "PangoAttribute* pango_attr_foreground_new(guint16 red, guint16 green, \
guint16 blue)"
  Xen_check_type(Xen_is_guint16(red), red, 1, "pango_attr_foreground_new", "guint16");
  Xen_check_type(Xen_is_guint16(green), green, 2, "pango_attr_foreground_new", "guint16");
  Xen_check_type(Xen_is_guint16(blue), blue, 3, "pango_attr_foreground_new", "guint16");
  return(C_to_Xen_PangoAttribute_(pango_attr_foreground_new(Xen_to_C_guint16(red), Xen_to_C_guint16(green), Xen_to_C_guint16(blue))));
}

static Xen gxg_pango_attr_background_new(Xen red, Xen green, Xen blue)
{
  #define H_pango_attr_background_new "PangoAttribute* pango_attr_background_new(guint16 red, guint16 green, \
guint16 blue)"
  Xen_check_type(Xen_is_guint16(red), red, 1, "pango_attr_background_new", "guint16");
  Xen_check_type(Xen_is_guint16(green), green, 2, "pango_attr_background_new", "guint16");
  Xen_check_type(Xen_is_guint16(blue), blue, 3, "pango_attr_background_new", "guint16");
  return(C_to_Xen_PangoAttribute_(pango_attr_background_new(Xen_to_C_guint16(red), Xen_to_C_guint16(green), Xen_to_C_guint16(blue))));
}

static Xen gxg_pango_attr_size_new(Xen size)
{
  #define H_pango_attr_size_new "PangoAttribute* pango_attr_size_new(int size)"
  Xen_check_type(Xen_is_int(size), size, 1, "pango_attr_size_new", "int");
  return(C_to_Xen_PangoAttribute_(pango_attr_size_new(Xen_to_C_int(size))));
}

static Xen gxg_pango_attr_style_new(Xen style)
{
  #define H_pango_attr_style_new "PangoAttribute* pango_attr_style_new(PangoStyle style)"
  Xen_check_type(Xen_is_PangoStyle(style), style, 1, "pango_attr_style_new", "PangoStyle");
  return(C_to_Xen_PangoAttribute_(pango_attr_style_new(Xen_to_C_PangoStyle(style))));
}

static Xen gxg_pango_attr_weight_new(Xen weight)
{
  #define H_pango_attr_weight_new "PangoAttribute* pango_attr_weight_new(PangoWeight weight)"
  Xen_check_type(Xen_is_PangoWeight(weight), weight, 1, "pango_attr_weight_new", "PangoWeight");
  return(C_to_Xen_PangoAttribute_(pango_attr_weight_new(Xen_to_C_PangoWeight(weight))));
}

static Xen gxg_pango_attr_variant_new(Xen variant)
{
  #define H_pango_attr_variant_new "PangoAttribute* pango_attr_variant_new(PangoVariant variant)"
  Xen_check_type(Xen_is_PangoVariant(variant), variant, 1, "pango_attr_variant_new", "PangoVariant");
  return(C_to_Xen_PangoAttribute_(pango_attr_variant_new(Xen_to_C_PangoVariant(variant))));
}

static Xen gxg_pango_attr_stretch_new(Xen stretch)
{
  #define H_pango_attr_stretch_new "PangoAttribute* pango_attr_stretch_new(PangoStretch stretch)"
  Xen_check_type(Xen_is_PangoStretch(stretch), stretch, 1, "pango_attr_stretch_new", "PangoStretch");
  return(C_to_Xen_PangoAttribute_(pango_attr_stretch_new(Xen_to_C_PangoStretch(stretch))));
}

static Xen gxg_pango_attr_font_desc_new(Xen desc)
{
  #define H_pango_attr_font_desc_new "PangoAttribute* pango_attr_font_desc_new(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_attr_font_desc_new", "PangoFontDescription*");
  return(C_to_Xen_PangoAttribute_(pango_attr_font_desc_new(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_attr_underline_new(Xen underline)
{
  #define H_pango_attr_underline_new "PangoAttribute* pango_attr_underline_new(PangoUnderline underline)"
  Xen_check_type(Xen_is_PangoUnderline(underline), underline, 1, "pango_attr_underline_new", "PangoUnderline");
  return(C_to_Xen_PangoAttribute_(pango_attr_underline_new(Xen_to_C_PangoUnderline(underline))));
}

static Xen gxg_pango_attr_strikethrough_new(Xen strikethrough)
{
  #define H_pango_attr_strikethrough_new "PangoAttribute* pango_attr_strikethrough_new(gboolean strikethrough)"
  Xen_check_type(Xen_is_gboolean(strikethrough), strikethrough, 1, "pango_attr_strikethrough_new", "gboolean");
  return(C_to_Xen_PangoAttribute_(pango_attr_strikethrough_new(Xen_to_C_gboolean(strikethrough))));
}

static Xen gxg_pango_attr_rise_new(Xen rise)
{
  #define H_pango_attr_rise_new "PangoAttribute* pango_attr_rise_new(int rise)"
  Xen_check_type(Xen_is_int(rise), rise, 1, "pango_attr_rise_new", "int");
  return(C_to_Xen_PangoAttribute_(pango_attr_rise_new(Xen_to_C_int(rise))));
}

static Xen gxg_pango_attr_shape_new(Xen ink_rect, Xen logical_rect)
{
  #define H_pango_attr_shape_new "PangoAttribute* pango_attr_shape_new(PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 1, "pango_attr_shape_new", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 2, "pango_attr_shape_new", "PangoRectangle*");
  return(C_to_Xen_PangoAttribute_(pango_attr_shape_new(Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect))));
}

static Xen gxg_pango_attr_scale_new(Xen scale_factor)
{
  #define H_pango_attr_scale_new "PangoAttribute* pango_attr_scale_new(double scale_factor)"
  Xen_check_type(Xen_is_double(scale_factor), scale_factor, 1, "pango_attr_scale_new", "double");
  return(C_to_Xen_PangoAttribute_(pango_attr_scale_new(Xen_to_C_double(scale_factor))));
}

static Xen gxg_pango_attr_list_new(void)
{
  #define H_pango_attr_list_new "PangoAttrList* pango_attr_list_new( void)"
  return(C_to_Xen_PangoAttrList_(pango_attr_list_new()));
}

static Xen gxg_pango_attr_list_unref(Xen list)
{
  #define H_pango_attr_list_unref "void pango_attr_list_unref(PangoAttrList* list)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_unref", "PangoAttrList*");
  pango_attr_list_unref(Xen_to_C_PangoAttrList_(list));
  return(Xen_false);
}

static Xen gxg_pango_attr_list_copy(Xen list)
{
  #define H_pango_attr_list_copy "PangoAttrList* pango_attr_list_copy(PangoAttrList* list)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_copy", "PangoAttrList*");
  return(C_to_Xen_PangoAttrList_(pango_attr_list_copy(Xen_to_C_PangoAttrList_(list))));
}

static Xen gxg_pango_attr_list_insert(Xen list, Xen attr)
{
  #define H_pango_attr_list_insert "void pango_attr_list_insert(PangoAttrList* list, PangoAttribute* attr)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_insert", "PangoAttrList*");
  Xen_check_type(Xen_is_PangoAttribute_(attr), attr, 2, "pango_attr_list_insert", "PangoAttribute*");
  pango_attr_list_insert(Xen_to_C_PangoAttrList_(list), Xen_to_C_PangoAttribute_(attr));
  return(Xen_false);
}

static Xen gxg_pango_attr_list_insert_before(Xen list, Xen attr)
{
  #define H_pango_attr_list_insert_before "void pango_attr_list_insert_before(PangoAttrList* list, PangoAttribute* attr)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_insert_before", "PangoAttrList*");
  Xen_check_type(Xen_is_PangoAttribute_(attr), attr, 2, "pango_attr_list_insert_before", "PangoAttribute*");
  pango_attr_list_insert_before(Xen_to_C_PangoAttrList_(list), Xen_to_C_PangoAttribute_(attr));
  return(Xen_false);
}

static Xen gxg_pango_attr_list_change(Xen list, Xen attr)
{
  #define H_pango_attr_list_change "void pango_attr_list_change(PangoAttrList* list, PangoAttribute* attr)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_change", "PangoAttrList*");
  Xen_check_type(Xen_is_PangoAttribute_(attr), attr, 2, "pango_attr_list_change", "PangoAttribute*");
  pango_attr_list_change(Xen_to_C_PangoAttrList_(list), Xen_to_C_PangoAttribute_(attr));
  return(Xen_false);
}

static Xen gxg_pango_attr_list_splice(Xen list, Xen other, Xen pos, Xen len)
{
  #define H_pango_attr_list_splice "void pango_attr_list_splice(PangoAttrList* list, PangoAttrList* other, \
gint pos, gint len)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_splice", "PangoAttrList*");
  Xen_check_type(Xen_is_PangoAttrList_(other), other, 2, "pango_attr_list_splice", "PangoAttrList*");
  Xen_check_type(Xen_is_gint(pos), pos, 3, "pango_attr_list_splice", "gint");
  Xen_check_type(Xen_is_gint(len), len, 4, "pango_attr_list_splice", "gint");
  pango_attr_list_splice(Xen_to_C_PangoAttrList_(list), Xen_to_C_PangoAttrList_(other), Xen_to_C_gint(pos), Xen_to_C_gint(len));
  return(Xen_false);
}

static Xen gxg_pango_attr_list_get_iterator(Xen list)
{
  #define H_pango_attr_list_get_iterator "PangoAttrIterator* pango_attr_list_get_iterator(PangoAttrList* list)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_get_iterator", "PangoAttrList*");
  return(C_to_Xen_PangoAttrIterator_(pango_attr_list_get_iterator(Xen_to_C_PangoAttrList_(list))));
}

static Xen gxg_pango_attr_iterator_range(Xen iterator, Xen ignore_start, Xen ignore_end)
{
  #define H_pango_attr_iterator_range "void pango_attr_iterator_range(PangoAttrIterator* iterator, gint* [start], \
gint* [end])"
  gint ref_start;
  gint ref_end;
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_range", "PangoAttrIterator*");
  pango_attr_iterator_range(Xen_to_C_PangoAttrIterator_(iterator), &ref_start, &ref_end);
  return(Xen_list_2(C_to_Xen_gint(ref_start), C_to_Xen_gint(ref_end)));
}

static Xen gxg_pango_attr_iterator_next(Xen iterator)
{
  #define H_pango_attr_iterator_next "gboolean pango_attr_iterator_next(PangoAttrIterator* iterator)"
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_next", "PangoAttrIterator*");
  return(C_to_Xen_gboolean(pango_attr_iterator_next(Xen_to_C_PangoAttrIterator_(iterator))));
}

static Xen gxg_pango_attr_iterator_copy(Xen iterator)
{
  #define H_pango_attr_iterator_copy "PangoAttrIterator* pango_attr_iterator_copy(PangoAttrIterator* iterator)"
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_copy", "PangoAttrIterator*");
  return(C_to_Xen_PangoAttrIterator_(pango_attr_iterator_copy(Xen_to_C_PangoAttrIterator_(iterator))));
}

static Xen gxg_pango_attr_iterator_destroy(Xen iterator)
{
  #define H_pango_attr_iterator_destroy "void pango_attr_iterator_destroy(PangoAttrIterator* iterator)"
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_destroy", "PangoAttrIterator*");
  pango_attr_iterator_destroy(Xen_to_C_PangoAttrIterator_(iterator));
  return(Xen_false);
}

static Xen gxg_pango_attr_iterator_get(Xen iterator, Xen type)
{
  #define H_pango_attr_iterator_get "PangoAttribute* pango_attr_iterator_get(PangoAttrIterator* iterator, \
PangoAttrType type)"
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_get", "PangoAttrIterator*");
  Xen_check_type(Xen_is_PangoAttrType(type), type, 2, "pango_attr_iterator_get", "PangoAttrType");
  return(C_to_Xen_PangoAttribute_(pango_attr_iterator_get(Xen_to_C_PangoAttrIterator_(iterator), Xen_to_C_PangoAttrType(type))));
}

static Xen gxg_pango_attr_iterator_get_font(Xen iterator, Xen desc, Xen ignore_language, Xen ignore_extra_attrs)
{
  #define H_pango_attr_iterator_get_font "void pango_attr_iterator_get_font(PangoAttrIterator* iterator, \
PangoFontDescription* desc, PangoLanguage** [language], GSList** [extra_attrs])"
  PangoLanguage* ref_language = NULL;
  GSList* ref_extra_attrs = NULL;
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_get_font", "PangoAttrIterator*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 2, "pango_attr_iterator_get_font", "PangoFontDescription*");
  pango_attr_iterator_get_font(Xen_to_C_PangoAttrIterator_(iterator), Xen_to_C_PangoFontDescription_(desc), &ref_language, 
                               &ref_extra_attrs);
  return(Xen_list_2(C_to_Xen_PangoLanguage_(ref_language), C_to_Xen_GSList_(ref_extra_attrs)));
}

static Xen gxg_pango_parse_markup(Xen markup_text, Xen length, Xen accel_marker, Xen attr_list, Xen text, Xen accel_char, Xen ignore_error)
{
  #define H_pango_parse_markup "gboolean pango_parse_markup(char* markup_text, int length, gunichar accel_marker, \
PangoAttrList** attr_list, char** text, gunichar* accel_char, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_char_(markup_text), markup_text, 1, "pango_parse_markup", "char*");
  Xen_check_type(Xen_is_int(length), length, 2, "pango_parse_markup", "int");
  Xen_check_type(Xen_is_gunichar(accel_marker), accel_marker, 3, "pango_parse_markup", "gunichar");
  Xen_check_type(Xen_is_PangoAttrList__(attr_list), attr_list, 4, "pango_parse_markup", "PangoAttrList**");
  Xen_check_type(Xen_is_char__(text), text, 5, "pango_parse_markup", "char**");
  Xen_check_type(Xen_is_gunichar_(accel_char), accel_char, 6, "pango_parse_markup", "gunichar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(pango_parse_markup(Xen_to_C_char_(markup_text), Xen_to_C_int(length), Xen_to_C_gunichar(accel_marker), 
                                                  Xen_to_C_PangoAttrList__(attr_list), Xen_to_C_char__(text), Xen_to_C_gunichar_(accel_char), 
                                                  &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_pango_break(Xen text, Xen length, Xen analysis, Xen attrs, Xen attrs_len)
{
  #define H_pango_break "void pango_break(gchar* text, int length, PangoAnalysis* analysis, PangoLogAttr* attrs, \
int attrs_len)"
  Xen_check_type(Xen_is_gchar_(text), text, 1, "pango_break", "gchar*");
  Xen_check_type(Xen_is_int(length), length, 2, "pango_break", "int");
  Xen_check_type(Xen_is_PangoAnalysis_(analysis), analysis, 3, "pango_break", "PangoAnalysis*");
  Xen_check_type(Xen_is_PangoLogAttr_(attrs), attrs, 4, "pango_break", "PangoLogAttr*");
  Xen_check_type(Xen_is_int(attrs_len), attrs_len, 5, "pango_break", "int");
  pango_break(Xen_to_C_gchar_(text), Xen_to_C_int(length), Xen_to_C_PangoAnalysis_(analysis), Xen_to_C_PangoLogAttr_(attrs), 
              Xen_to_C_int(attrs_len));
  return(Xen_false);
}

static Xen gxg_pango_find_paragraph_boundary(Xen text, Xen length, Xen ignore_paragraph_delimiter_index, Xen ignore_next_paragraph_start)
{
  #define H_pango_find_paragraph_boundary "void pango_find_paragraph_boundary(gchar* text, gint length, \
gint* [paragraph_delimiter_index], gint* [next_paragraph_start])"
  gint ref_paragraph_delimiter_index;
  gint ref_next_paragraph_start;
  Xen_check_type(Xen_is_gchar_(text), text, 1, "pango_find_paragraph_boundary", "gchar*");
  Xen_check_type(Xen_is_gint(length), length, 2, "pango_find_paragraph_boundary", "gint");
  pango_find_paragraph_boundary(Xen_to_C_gchar_(text), Xen_to_C_gint(length), &ref_paragraph_delimiter_index, &ref_next_paragraph_start);
  return(Xen_list_2(C_to_Xen_gint(ref_paragraph_delimiter_index), C_to_Xen_gint(ref_next_paragraph_start)));
}

static Xen gxg_pango_get_log_attrs(Xen text, Xen length, Xen level, Xen language, Xen log_attrs, Xen attrs_len)
{
  #define H_pango_get_log_attrs "void pango_get_log_attrs(char* text, int length, int level, PangoLanguage* language, \
PangoLogAttr* log_attrs, int attrs_len)"
  Xen_check_type(Xen_is_char_(text), text, 1, "pango_get_log_attrs", "char*");
  Xen_check_type(Xen_is_int(length), length, 2, "pango_get_log_attrs", "int");
  Xen_check_type(Xen_is_int(level), level, 3, "pango_get_log_attrs", "int");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 4, "pango_get_log_attrs", "PangoLanguage*");
  Xen_check_type(Xen_is_PangoLogAttr_(log_attrs), log_attrs, 5, "pango_get_log_attrs", "PangoLogAttr*");
  Xen_check_type(Xen_is_int(attrs_len), attrs_len, 6, "pango_get_log_attrs", "int");
  pango_get_log_attrs(Xen_to_C_char_(text), Xen_to_C_int(length), Xen_to_C_int(level), Xen_to_C_PangoLanguage_(language), 
                      Xen_to_C_PangoLogAttr_(log_attrs), Xen_to_C_int(attrs_len));
  return(Xen_false);
}

static Xen gxg_pango_context_list_families(Xen context, Xen ignore_families, Xen ignore_n_families)
{
  #define H_pango_context_list_families "void pango_context_list_families(PangoContext* context, PangoFontFamily*** [families], \
int* [n_families])"
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_list_families", "PangoContext*");
  pango_context_list_families(Xen_to_C_PangoContext_(context), &ref_families, &ref_n_families);
  return(Xen_list_2(C_to_Xen_PangoFontFamily__(ref_families), C_to_Xen_int(ref_n_families)));
}

static Xen gxg_pango_context_load_font(Xen context, Xen desc)
{
  #define H_pango_context_load_font "PangoFont* pango_context_load_font(PangoContext* context, PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_load_font", "PangoContext*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 2, "pango_context_load_font", "PangoFontDescription*");
  return(C_to_Xen_PangoFont_(pango_context_load_font(Xen_to_C_PangoContext_(context), Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_context_load_fontset(Xen context, Xen desc, Xen language)
{
  #define H_pango_context_load_fontset "PangoFontset* pango_context_load_fontset(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_load_fontset", "PangoContext*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 2, "pango_context_load_fontset", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 3, "pango_context_load_fontset", "PangoLanguage*");
  return(C_to_Xen_PangoFontset_(pango_context_load_fontset(Xen_to_C_PangoContext_(context), Xen_to_C_PangoFontDescription_(desc), 
                                                           Xen_to_C_PangoLanguage_(language))));
}

static Xen gxg_pango_context_get_metrics(Xen context, Xen desc, Xen language)
{
  #define H_pango_context_get_metrics "PangoFontMetrics* pango_context_get_metrics(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_get_metrics", "PangoContext*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 2, "pango_context_get_metrics", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 3, "pango_context_get_metrics", "PangoLanguage*");
  return(C_to_Xen_PangoFontMetrics_(pango_context_get_metrics(Xen_to_C_PangoContext_(context), Xen_to_C_PangoFontDescription_(desc), 
                                                              Xen_to_C_PangoLanguage_(language))));
}

static Xen gxg_pango_context_set_font_description(Xen context, Xen desc)
{
  #define H_pango_context_set_font_description "void pango_context_set_font_description(PangoContext* context, \
PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_set_font_description", "PangoContext*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 2, "pango_context_set_font_description", "PangoFontDescription*");
  pango_context_set_font_description(Xen_to_C_PangoContext_(context), Xen_to_C_PangoFontDescription_(desc));
  return(Xen_false);
}

static Xen gxg_pango_context_get_font_description(Xen context)
{
  #define H_pango_context_get_font_description "PangoFontDescription* pango_context_get_font_description(PangoContext* context)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_get_font_description", "PangoContext*");
  return(C_to_Xen_PangoFontDescription_(pango_context_get_font_description(Xen_to_C_PangoContext_(context))));
}

static Xen gxg_pango_context_get_language(Xen context)
{
  #define H_pango_context_get_language "PangoLanguage* pango_context_get_language(PangoContext* context)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_get_language", "PangoContext*");
  return(C_to_Xen_PangoLanguage_(pango_context_get_language(Xen_to_C_PangoContext_(context))));
}

static Xen gxg_pango_context_set_language(Xen context, Xen language)
{
  #define H_pango_context_set_language "void pango_context_set_language(PangoContext* context, PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_set_language", "PangoContext*");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 2, "pango_context_set_language", "PangoLanguage*");
  pango_context_set_language(Xen_to_C_PangoContext_(context), Xen_to_C_PangoLanguage_(language));
  return(Xen_false);
}

static Xen gxg_pango_context_set_base_dir(Xen context, Xen direction)
{
  #define H_pango_context_set_base_dir "void pango_context_set_base_dir(PangoContext* context, PangoDirection direction)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_set_base_dir", "PangoContext*");
  Xen_check_type(Xen_is_PangoDirection(direction), direction, 2, "pango_context_set_base_dir", "PangoDirection");
  pango_context_set_base_dir(Xen_to_C_PangoContext_(context), Xen_to_C_PangoDirection(direction));
  return(Xen_false);
}

static Xen gxg_pango_context_get_base_dir(Xen context)
{
  #define H_pango_context_get_base_dir "PangoDirection pango_context_get_base_dir(PangoContext* context)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_context_get_base_dir", "PangoContext*");
  return(C_to_Xen_PangoDirection(pango_context_get_base_dir(Xen_to_C_PangoContext_(context))));
}

static Xen gxg_pango_itemize(Xen context, Xen text, Xen start_index, Xen length, Xen attrs, Xen cached_iter)
{
  #define H_pango_itemize "GList* pango_itemize(PangoContext* context, char* text, int start_index, int length, \
PangoAttrList* attrs, PangoAttrIterator* cached_iter)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_itemize", "PangoContext*");
  Xen_check_type(Xen_is_char_(text), text, 2, "pango_itemize", "char*");
  Xen_check_type(Xen_is_int(start_index), start_index, 3, "pango_itemize", "int");
  Xen_check_type(Xen_is_int(length), length, 4, "pango_itemize", "int");
  Xen_check_type(Xen_is_PangoAttrList_(attrs), attrs, 5, "pango_itemize", "PangoAttrList*");
  Xen_check_type(Xen_is_PangoAttrIterator_(cached_iter), cached_iter, 6, "pango_itemize", "PangoAttrIterator*");
  return(C_to_Xen_GList_(pango_itemize(Xen_to_C_PangoContext_(context), Xen_to_C_char_(text), Xen_to_C_int(start_index), 
                                       Xen_to_C_int(length), Xen_to_C_PangoAttrList_(attrs), Xen_to_C_PangoAttrIterator_(cached_iter))));
}

static Xen gxg_pango_coverage_new(void)
{
  #define H_pango_coverage_new "PangoCoverage* pango_coverage_new( void)"
  return(C_to_Xen_PangoCoverage_(pango_coverage_new()));
}

static Xen gxg_pango_coverage_ref(Xen coverage)
{
  #define H_pango_coverage_ref "PangoCoverage* pango_coverage_ref(PangoCoverage* coverage)"
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_ref", "PangoCoverage*");
  return(C_to_Xen_PangoCoverage_(pango_coverage_ref(Xen_to_C_PangoCoverage_(coverage))));
}

static Xen gxg_pango_coverage_unref(Xen coverage)
{
  #define H_pango_coverage_unref "void pango_coverage_unref(PangoCoverage* coverage)"
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_unref", "PangoCoverage*");
  pango_coverage_unref(Xen_to_C_PangoCoverage_(coverage));
  return(Xen_false);
}

static Xen gxg_pango_coverage_copy(Xen coverage)
{
  #define H_pango_coverage_copy "PangoCoverage* pango_coverage_copy(PangoCoverage* coverage)"
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_copy", "PangoCoverage*");
  return(C_to_Xen_PangoCoverage_(pango_coverage_copy(Xen_to_C_PangoCoverage_(coverage))));
}

static Xen gxg_pango_coverage_get(Xen coverage, Xen index)
{
  #define H_pango_coverage_get "PangoCoverageLevel pango_coverage_get(PangoCoverage* coverage, int index)"
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_get", "PangoCoverage*");
  Xen_check_type(Xen_is_int(index), index, 2, "pango_coverage_get", "int");
  return(C_to_Xen_PangoCoverageLevel(pango_coverage_get(Xen_to_C_PangoCoverage_(coverage), Xen_to_C_int(index))));
}

static Xen gxg_pango_coverage_set(Xen coverage, Xen index, Xen level)
{
  #define H_pango_coverage_set "void pango_coverage_set(PangoCoverage* coverage, int index, PangoCoverageLevel level)"
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_set", "PangoCoverage*");
  Xen_check_type(Xen_is_int(index), index, 2, "pango_coverage_set", "int");
  Xen_check_type(Xen_is_PangoCoverageLevel(level), level, 3, "pango_coverage_set", "PangoCoverageLevel");
  pango_coverage_set(Xen_to_C_PangoCoverage_(coverage), Xen_to_C_int(index), Xen_to_C_PangoCoverageLevel(level));
  return(Xen_false);
}

static Xen gxg_pango_coverage_max(Xen coverage, Xen other)
{
  #define H_pango_coverage_max "void pango_coverage_max(PangoCoverage* coverage, PangoCoverage* other)"
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_max", "PangoCoverage*");
  Xen_check_type(Xen_is_PangoCoverage_(other), other, 2, "pango_coverage_max", "PangoCoverage*");
  pango_coverage_max(Xen_to_C_PangoCoverage_(coverage), Xen_to_C_PangoCoverage_(other));
  return(Xen_false);
}

static Xen gxg_pango_coverage_to_bytes(Xen coverage, Xen ignore_bytes, Xen ignore_n_bytes)
{
  #define H_pango_coverage_to_bytes "void pango_coverage_to_bytes(PangoCoverage* coverage, guchar** [bytes], \
int* [n_bytes])"
  guchar* ref_bytes = NULL;
  int ref_n_bytes;
  Xen_check_type(Xen_is_PangoCoverage_(coverage), coverage, 1, "pango_coverage_to_bytes", "PangoCoverage*");
  pango_coverage_to_bytes(Xen_to_C_PangoCoverage_(coverage), &ref_bytes, &ref_n_bytes);
  return(Xen_list_2(C_to_Xen_guchar_(ref_bytes), C_to_Xen_int(ref_n_bytes)));
}

static Xen gxg_pango_coverage_from_bytes(Xen bytes, Xen n_bytes)
{
  #define H_pango_coverage_from_bytes "PangoCoverage* pango_coverage_from_bytes(guchar* bytes, int n_bytes)"
  Xen_check_type(Xen_is_guchar_(bytes), bytes, 1, "pango_coverage_from_bytes", "guchar*");
  Xen_check_type(Xen_is_int(n_bytes), n_bytes, 2, "pango_coverage_from_bytes", "int");
  return(C_to_Xen_PangoCoverage_(pango_coverage_from_bytes(Xen_to_C_guchar_(bytes), Xen_to_C_int(n_bytes))));
}

static Xen gxg_pango_font_description_new(void)
{
  #define H_pango_font_description_new "PangoFontDescription* pango_font_description_new( void)"
  return(C_to_Xen_PangoFontDescription_(pango_font_description_new()));
}

static Xen gxg_pango_font_description_copy(Xen desc)
{
  #define H_pango_font_description_copy "PangoFontDescription* pango_font_description_copy(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_copy", "PangoFontDescription*");
  return(C_to_Xen_PangoFontDescription_(pango_font_description_copy(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_copy_static(Xen desc)
{
  #define H_pango_font_description_copy_static "PangoFontDescription* pango_font_description_copy_static(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_copy_static", "PangoFontDescription*");
  return(C_to_Xen_PangoFontDescription_(pango_font_description_copy_static(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_hash(Xen desc)
{
  #define H_pango_font_description_hash "guint pango_font_description_hash(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_hash", "PangoFontDescription*");
  return(C_to_Xen_guint(pango_font_description_hash(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_equal(Xen desc1, Xen desc2)
{
  #define H_pango_font_description_equal "gboolean pango_font_description_equal(PangoFontDescription* desc1, \
PangoFontDescription* desc2)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc1), desc1, 1, "pango_font_description_equal", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc2), desc2, 2, "pango_font_description_equal", "PangoFontDescription*");
  return(C_to_Xen_gboolean(pango_font_description_equal(Xen_to_C_PangoFontDescription_(desc1), Xen_to_C_PangoFontDescription_(desc2))));
}

static Xen gxg_pango_font_description_free(Xen desc)
{
  #define H_pango_font_description_free "void pango_font_description_free(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_free", "PangoFontDescription*");
  pango_font_description_free(Xen_to_C_PangoFontDescription_(desc));
  return(Xen_false);
}

static Xen gxg_pango_font_descriptions_free(Xen descs, Xen n_descs)
{
  #define H_pango_font_descriptions_free "void pango_font_descriptions_free(PangoFontDescription** descs, \
int n_descs)"
  Xen_check_type(Xen_is_PangoFontDescription__(descs), descs, 1, "pango_font_descriptions_free", "PangoFontDescription**");
  Xen_check_type(Xen_is_int(n_descs), n_descs, 2, "pango_font_descriptions_free", "int");
  pango_font_descriptions_free(Xen_to_C_PangoFontDescription__(descs), Xen_to_C_int(n_descs));
  return(Xen_false);
}

static Xen gxg_pango_font_description_set_family(Xen desc, Xen family)
{
  #define H_pango_font_description_set_family "void pango_font_description_set_family(PangoFontDescription* desc, \
char* family)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_family", "PangoFontDescription*");
  Xen_check_type(Xen_is_char_(family), family, 2, "pango_font_description_set_family", "char*");
  pango_font_description_set_family(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_char_(family));
  return(Xen_false);
}

static Xen gxg_pango_font_description_set_family_static(Xen desc, Xen family)
{
  #define H_pango_font_description_set_family_static "void pango_font_description_set_family_static(PangoFontDescription* desc, \
char* family)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_family_static", "PangoFontDescription*");
  Xen_check_type(Xen_is_char_(family), family, 2, "pango_font_description_set_family_static", "char*");
  pango_font_description_set_family_static(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_char_(family));
  return(Xen_false);
}

static Xen gxg_pango_font_description_get_family(Xen desc)
{
  #define H_pango_font_description_get_family "char* pango_font_description_get_family(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_family", "PangoFontDescription*");
  return(C_to_Xen_char_(pango_font_description_get_family(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_set_style(Xen desc, Xen style)
{
  #define H_pango_font_description_set_style "void pango_font_description_set_style(PangoFontDescription* desc, \
PangoStyle style)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_style", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoStyle(style), style, 2, "pango_font_description_set_style", "PangoStyle");
  pango_font_description_set_style(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoStyle(style));
  return(Xen_false);
}

static Xen gxg_pango_font_description_get_style(Xen desc)
{
  #define H_pango_font_description_get_style "PangoStyle pango_font_description_get_style(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_style", "PangoFontDescription*");
  return(C_to_Xen_PangoStyle(pango_font_description_get_style(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_set_variant(Xen desc, Xen variant)
{
  #define H_pango_font_description_set_variant "void pango_font_description_set_variant(PangoFontDescription* desc, \
PangoVariant variant)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_variant", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoVariant(variant), variant, 2, "pango_font_description_set_variant", "PangoVariant");
  pango_font_description_set_variant(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoVariant(variant));
  return(Xen_false);
}

static Xen gxg_pango_font_description_get_variant(Xen desc)
{
  #define H_pango_font_description_get_variant "PangoVariant pango_font_description_get_variant(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_variant", "PangoFontDescription*");
  return(C_to_Xen_PangoVariant(pango_font_description_get_variant(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_set_weight(Xen desc, Xen weight)
{
  #define H_pango_font_description_set_weight "void pango_font_description_set_weight(PangoFontDescription* desc, \
PangoWeight weight)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_weight", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoWeight(weight), weight, 2, "pango_font_description_set_weight", "PangoWeight");
  pango_font_description_set_weight(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoWeight(weight));
  return(Xen_false);
}

static Xen gxg_pango_font_description_get_weight(Xen desc)
{
  #define H_pango_font_description_get_weight "PangoWeight pango_font_description_get_weight(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_weight", "PangoFontDescription*");
  return(C_to_Xen_PangoWeight(pango_font_description_get_weight(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_set_stretch(Xen desc, Xen stretch)
{
  #define H_pango_font_description_set_stretch "void pango_font_description_set_stretch(PangoFontDescription* desc, \
PangoStretch stretch)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_stretch", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoStretch(stretch), stretch, 2, "pango_font_description_set_stretch", "PangoStretch");
  pango_font_description_set_stretch(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoStretch(stretch));
  return(Xen_false);
}

static Xen gxg_pango_font_description_get_stretch(Xen desc)
{
  #define H_pango_font_description_get_stretch "PangoStretch pango_font_description_get_stretch(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_stretch", "PangoFontDescription*");
  return(C_to_Xen_PangoStretch(pango_font_description_get_stretch(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_set_size(Xen desc, Xen size)
{
  #define H_pango_font_description_set_size "void pango_font_description_set_size(PangoFontDescription* desc, \
gint size)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_size", "PangoFontDescription*");
  Xen_check_type(Xen_is_gint(size), size, 2, "pango_font_description_set_size", "gint");
  pango_font_description_set_size(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_gint(size));
  return(Xen_false);
}

static Xen gxg_pango_font_description_get_size(Xen desc)
{
  #define H_pango_font_description_get_size "gint pango_font_description_get_size(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_size", "PangoFontDescription*");
  return(C_to_Xen_gint(pango_font_description_get_size(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_get_set_fields(Xen desc)
{
  #define H_pango_font_description_get_set_fields "PangoFontMask pango_font_description_get_set_fields(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_get_set_fields", "PangoFontDescription*");
  return(C_to_Xen_PangoFontMask(pango_font_description_get_set_fields(Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_description_unset_fields(Xen desc, Xen to_unset)
{
  #define H_pango_font_description_unset_fields "void pango_font_description_unset_fields(PangoFontDescription* desc, \
PangoFontMask to_unset)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_unset_fields", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoFontMask(to_unset), to_unset, 2, "pango_font_description_unset_fields", "PangoFontMask");
  pango_font_description_unset_fields(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoFontMask(to_unset));
  return(Xen_false);
}

static Xen gxg_pango_font_description_merge(Xen desc, Xen desc_to_merge, Xen replace_existing)
{
  #define H_pango_font_description_merge "void pango_font_description_merge(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_merge", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc_to_merge), desc_to_merge, 2, "pango_font_description_merge", "PangoFontDescription*");
  Xen_check_type(Xen_is_gboolean(replace_existing), replace_existing, 3, "pango_font_description_merge", "gboolean");
  pango_font_description_merge(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoFontDescription_(desc_to_merge), Xen_to_C_gboolean(replace_existing));
  return(Xen_false);
}

static Xen gxg_pango_font_description_merge_static(Xen desc, Xen desc_to_merge, Xen replace_existing)
{
  #define H_pango_font_description_merge_static "void pango_font_description_merge_static(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_merge_static", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc_to_merge), desc_to_merge, 2, "pango_font_description_merge_static", "PangoFontDescription*");
  Xen_check_type(Xen_is_gboolean(replace_existing), replace_existing, 3, "pango_font_description_merge_static", "gboolean");
  pango_font_description_merge_static(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoFontDescription_(desc_to_merge), 
                                      Xen_to_C_gboolean(replace_existing));
  return(Xen_false);
}

static Xen gxg_pango_font_description_better_match(Xen desc, Xen old_match, Xen new_match)
{
  #define H_pango_font_description_better_match "gboolean pango_font_description_better_match(PangoFontDescription* desc, \
PangoFontDescription* old_match, PangoFontDescription* new_match)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_better_match", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoFontDescription_(old_match), old_match, 2, "pango_font_description_better_match", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoFontDescription_(new_match), new_match, 3, "pango_font_description_better_match", "PangoFontDescription*");
  return(C_to_Xen_gboolean(pango_font_description_better_match(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoFontDescription_(old_match), 
                                                               Xen_to_C_PangoFontDescription_(new_match))));
}

static Xen gxg_pango_font_description_from_string(Xen str)
{
  #define H_pango_font_description_from_string "PangoFontDescription* pango_font_description_from_string(char* str)"
  Xen_check_type(Xen_is_char_(str), str, 1, "pango_font_description_from_string", "char*");
  return(C_to_Xen_PangoFontDescription_(pango_font_description_from_string(Xen_to_C_char_(str))));
}

static Xen gxg_pango_font_description_to_string(Xen desc)
{
  #define H_pango_font_description_to_string "char* pango_font_description_to_string(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_to_string", "PangoFontDescription*");
  {
   char* result;
   Xen rtn;
   result = pango_font_description_to_string(Xen_to_C_PangoFontDescription_(desc));
   rtn = C_to_Xen_char_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_pango_font_description_to_filename(Xen desc)
{
  #define H_pango_font_description_to_filename "char* pango_font_description_to_filename(PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_to_filename", "PangoFontDescription*");
  {
   char* result;
   Xen rtn;
   result = pango_font_description_to_filename(Xen_to_C_PangoFontDescription_(desc));
   rtn = C_to_Xen_char_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_pango_font_metrics_ref(Xen metrics)
{
  #define H_pango_font_metrics_ref "PangoFontMetrics* pango_font_metrics_ref(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_ref", "PangoFontMetrics*");
  return(C_to_Xen_PangoFontMetrics_(pango_font_metrics_ref(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_unref(Xen metrics)
{
  #define H_pango_font_metrics_unref "void pango_font_metrics_unref(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_unref", "PangoFontMetrics*");
  pango_font_metrics_unref(Xen_to_C_PangoFontMetrics_(metrics));
  return(Xen_false);
}

static Xen gxg_pango_font_metrics_get_ascent(Xen metrics)
{
  #define H_pango_font_metrics_get_ascent "int pango_font_metrics_get_ascent(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_ascent", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_ascent(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_get_descent(Xen metrics)
{
  #define H_pango_font_metrics_get_descent "int pango_font_metrics_get_descent(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_descent", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_descent(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_get_approximate_char_width(Xen metrics)
{
  #define H_pango_font_metrics_get_approximate_char_width "int pango_font_metrics_get_approximate_char_width(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_approximate_char_width", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_approximate_char_width(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_get_approximate_digit_width(Xen metrics)
{
  #define H_pango_font_metrics_get_approximate_digit_width "int pango_font_metrics_get_approximate_digit_width(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_approximate_digit_width", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_approximate_digit_width(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_family_list_faces(Xen family, Xen ignore_faces, Xen ignore_n_faces)
{
  #define H_pango_font_family_list_faces "void pango_font_family_list_faces(PangoFontFamily* family, \
PangoFontFace*** [faces], int* [n_faces])"
  PangoFontFace** ref_faces = NULL;
  int ref_n_faces;
  Xen_check_type(Xen_is_PangoFontFamily_(family), family, 1, "pango_font_family_list_faces", "PangoFontFamily*");
  pango_font_family_list_faces(Xen_to_C_PangoFontFamily_(family), &ref_faces, &ref_n_faces);
  return(Xen_list_2(C_to_Xen_PangoFontFace__(ref_faces), C_to_Xen_int(ref_n_faces)));
}

static Xen gxg_pango_font_family_get_name(Xen family)
{
  #define H_pango_font_family_get_name "char* pango_font_family_get_name(PangoFontFamily* family)"
  Xen_check_type(Xen_is_PangoFontFamily_(family), family, 1, "pango_font_family_get_name", "PangoFontFamily*");
  return(C_to_Xen_char_(pango_font_family_get_name(Xen_to_C_PangoFontFamily_(family))));
}

static Xen gxg_pango_font_face_describe(Xen face)
{
  #define H_pango_font_face_describe "PangoFontDescription* pango_font_face_describe(PangoFontFace* face)"
  Xen_check_type(Xen_is_PangoFontFace_(face), face, 1, "pango_font_face_describe", "PangoFontFace*");
  return(C_to_Xen_PangoFontDescription_(pango_font_face_describe(Xen_to_C_PangoFontFace_(face))));
}

static Xen gxg_pango_font_face_get_face_name(Xen face)
{
  #define H_pango_font_face_get_face_name "char* pango_font_face_get_face_name(PangoFontFace* face)"
  Xen_check_type(Xen_is_PangoFontFace_(face), face, 1, "pango_font_face_get_face_name", "PangoFontFace*");
  return(C_to_Xen_char_(pango_font_face_get_face_name(Xen_to_C_PangoFontFace_(face))));
}

static Xen gxg_pango_font_describe(Xen font)
{
  #define H_pango_font_describe "PangoFontDescription* pango_font_describe(PangoFont* font)"
  Xen_check_type(Xen_is_PangoFont_(font), font, 1, "pango_font_describe", "PangoFont*");
  return(C_to_Xen_PangoFontDescription_(pango_font_describe(Xen_to_C_PangoFont_(font))));
}

static Xen gxg_pango_font_get_coverage(Xen font, Xen language)
{
  #define H_pango_font_get_coverage "PangoCoverage* pango_font_get_coverage(PangoFont* font, PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoFont_(font), font, 1, "pango_font_get_coverage", "PangoFont*");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 2, "pango_font_get_coverage", "PangoLanguage*");
  return(C_to_Xen_PangoCoverage_(pango_font_get_coverage(Xen_to_C_PangoFont_(font), Xen_to_C_PangoLanguage_(language))));
}

static Xen gxg_pango_font_get_metrics(Xen font, Xen language)
{
  #define H_pango_font_get_metrics "PangoFontMetrics* pango_font_get_metrics(PangoFont* font, PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoFont_(font), font, 1, "pango_font_get_metrics", "PangoFont*");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 2, "pango_font_get_metrics", "PangoLanguage*");
  return(C_to_Xen_PangoFontMetrics_(pango_font_get_metrics(Xen_to_C_PangoFont_(font), Xen_to_C_PangoLanguage_(language))));
}

static Xen gxg_pango_font_get_glyph_extents(Xen font, Xen glyph, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_font_get_glyph_extents "void pango_font_get_glyph_extents(PangoFont* font, PangoGlyph glyph, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoFont_(font), font, 1, "pango_font_get_glyph_extents", "PangoFont*");
  Xen_check_type(Xen_is_PangoGlyph(glyph), glyph, 2, "pango_font_get_glyph_extents", "PangoGlyph");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 3, "pango_font_get_glyph_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 4, "pango_font_get_glyph_extents", "PangoRectangle*");
  pango_font_get_glyph_extents(Xen_to_C_PangoFont_(font), Xen_to_C_PangoGlyph(glyph), Xen_to_C_PangoRectangle_(ink_rect), 
                               Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_font_map_load_font(Xen fontmap, Xen context, Xen desc)
{
  #define H_pango_font_map_load_font "PangoFont* pango_font_map_load_font(PangoFontMap* fontmap, PangoContext* context, \
PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoFontMap_(fontmap), fontmap, 1, "pango_font_map_load_font", "PangoFontMap*");
  Xen_check_type(Xen_is_PangoContext_(context), context, 2, "pango_font_map_load_font", "PangoContext*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 3, "pango_font_map_load_font", "PangoFontDescription*");
  return(C_to_Xen_PangoFont_(pango_font_map_load_font(Xen_to_C_PangoFontMap_(fontmap), Xen_to_C_PangoContext_(context), Xen_to_C_PangoFontDescription_(desc))));
}

static Xen gxg_pango_font_map_load_fontset(Xen fontmap, Xen context, Xen desc, Xen language)
{
  #define H_pango_font_map_load_fontset "PangoFontset* pango_font_map_load_fontset(PangoFontMap* fontmap, \
PangoContext* context, PangoFontDescription* desc, PangoLanguage* language)"
  Xen_check_type(Xen_is_PangoFontMap_(fontmap), fontmap, 1, "pango_font_map_load_fontset", "PangoFontMap*");
  Xen_check_type(Xen_is_PangoContext_(context), context, 2, "pango_font_map_load_fontset", "PangoContext*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 3, "pango_font_map_load_fontset", "PangoFontDescription*");
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 4, "pango_font_map_load_fontset", "PangoLanguage*");
  return(C_to_Xen_PangoFontset_(pango_font_map_load_fontset(Xen_to_C_PangoFontMap_(fontmap), Xen_to_C_PangoContext_(context), 
                                                            Xen_to_C_PangoFontDescription_(desc), Xen_to_C_PangoLanguage_(language))));
}

static Xen gxg_pango_font_map_list_families(Xen fontmap, Xen ignore_families, Xen ignore_n_families)
{
  #define H_pango_font_map_list_families "void pango_font_map_list_families(PangoFontMap* fontmap, PangoFontFamily*** [families], \
int* [n_families])"
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  Xen_check_type(Xen_is_PangoFontMap_(fontmap), fontmap, 1, "pango_font_map_list_families", "PangoFontMap*");
  pango_font_map_list_families(Xen_to_C_PangoFontMap_(fontmap), &ref_families, &ref_n_families);
  return(Xen_list_2(C_to_Xen_PangoFontFamily__(ref_families), C_to_Xen_int(ref_n_families)));
}

static Xen gxg_pango_glyph_string_new(void)
{
  #define H_pango_glyph_string_new "PangoGlyphString* pango_glyph_string_new( void)"
  return(C_to_Xen_PangoGlyphString_(pango_glyph_string_new()));
}

static Xen gxg_pango_glyph_string_set_size(Xen string, Xen new_len)
{
  #define H_pango_glyph_string_set_size "void pango_glyph_string_set_size(PangoGlyphString* string, gint new_len)"
  Xen_check_type(Xen_is_PangoGlyphString_(string), string, 1, "pango_glyph_string_set_size", "PangoGlyphString*");
  Xen_check_type(Xen_is_gint(new_len), new_len, 2, "pango_glyph_string_set_size", "gint");
  pango_glyph_string_set_size(Xen_to_C_PangoGlyphString_(string), Xen_to_C_gint(new_len));
  return(Xen_false);
}

static Xen gxg_pango_glyph_string_copy(Xen string)
{
  #define H_pango_glyph_string_copy "PangoGlyphString* pango_glyph_string_copy(PangoGlyphString* string)"
  Xen_check_type(Xen_is_PangoGlyphString_(string), string, 1, "pango_glyph_string_copy", "PangoGlyphString*");
  return(C_to_Xen_PangoGlyphString_(pango_glyph_string_copy(Xen_to_C_PangoGlyphString_(string))));
}

static Xen gxg_pango_glyph_string_free(Xen string)
{
  #define H_pango_glyph_string_free "void pango_glyph_string_free(PangoGlyphString* string)"
  Xen_check_type(Xen_is_PangoGlyphString_(string), string, 1, "pango_glyph_string_free", "PangoGlyphString*");
  pango_glyph_string_free(Xen_to_C_PangoGlyphString_(string));
  return(Xen_false);
}

static Xen gxg_pango_glyph_string_extents(Xen glyphs, Xen font, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_glyph_string_extents "void pango_glyph_string_extents(PangoGlyphString* glyphs, PangoFont* font, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 1, "pango_glyph_string_extents", "PangoGlyphString*");
  Xen_check_type(Xen_is_PangoFont_(font), font, 2, "pango_glyph_string_extents", "PangoFont*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 3, "pango_glyph_string_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 4, "pango_glyph_string_extents", "PangoRectangle*");
  pango_glyph_string_extents(Xen_to_C_PangoGlyphString_(glyphs), Xen_to_C_PangoFont_(font), Xen_to_C_PangoRectangle_(ink_rect), 
                             Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_glyph_string_extents_range(Xen glyphs, Xen start, Xen end, Xen font, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_glyph_string_extents_range "void pango_glyph_string_extents_range(PangoGlyphString* glyphs, \
int start, int end, PangoFont* font, PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 1, "pango_glyph_string_extents_range", "PangoGlyphString*");
  Xen_check_type(Xen_is_int(start), start, 2, "pango_glyph_string_extents_range", "int");
  Xen_check_type(Xen_is_int(end), end, 3, "pango_glyph_string_extents_range", "int");
  Xen_check_type(Xen_is_PangoFont_(font), font, 4, "pango_glyph_string_extents_range", "PangoFont*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 5, "pango_glyph_string_extents_range", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 6, "pango_glyph_string_extents_range", "PangoRectangle*");
  pango_glyph_string_extents_range(Xen_to_C_PangoGlyphString_(glyphs), Xen_to_C_int(start), Xen_to_C_int(end), Xen_to_C_PangoFont_(font), 
                                   Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_glyph_string_get_logical_widths(Xen glyphs, Xen text, Xen length, Xen embedding_level, Xen ignore_logical_widths)
{
  #define H_pango_glyph_string_get_logical_widths "void pango_glyph_string_get_logical_widths(PangoGlyphString* glyphs, \
char* text, int length, int embedding_level, int* [logical_widths])"
  int ref_logical_widths;
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 1, "pango_glyph_string_get_logical_widths", "PangoGlyphString*");
  Xen_check_type(Xen_is_char_(text), text, 2, "pango_glyph_string_get_logical_widths", "char*");
  Xen_check_type(Xen_is_int(length), length, 3, "pango_glyph_string_get_logical_widths", "int");
  Xen_check_type(Xen_is_int(embedding_level), embedding_level, 4, "pango_glyph_string_get_logical_widths", "int");
  pango_glyph_string_get_logical_widths(Xen_to_C_PangoGlyphString_(glyphs), Xen_to_C_char_(text), Xen_to_C_int(length), Xen_to_C_int(embedding_level), 
                                        &ref_logical_widths);
  return(Xen_list_1(C_to_Xen_int(ref_logical_widths)));
}

static Xen gxg_pango_glyph_string_index_to_x(Xen glyphs, Xen text, Xen length, Xen analysis, Xen index, Xen trailing, Xen ignore_x_pos)
{
  #define H_pango_glyph_string_index_to_x "void pango_glyph_string_index_to_x(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int index, gboolean trailing, int* [x_pos])"
  int ref_x_pos;
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 1, "pango_glyph_string_index_to_x", "PangoGlyphString*");
  Xen_check_type(Xen_is_char_(text), text, 2, "pango_glyph_string_index_to_x", "char*");
  Xen_check_type(Xen_is_int(length), length, 3, "pango_glyph_string_index_to_x", "int");
  Xen_check_type(Xen_is_PangoAnalysis_(analysis), analysis, 4, "pango_glyph_string_index_to_x", "PangoAnalysis*");
  Xen_check_type(Xen_is_int(index), index, 5, "pango_glyph_string_index_to_x", "int");
  Xen_check_type(Xen_is_gboolean(trailing), trailing, 6, "pango_glyph_string_index_to_x", "gboolean");
  pango_glyph_string_index_to_x(Xen_to_C_PangoGlyphString_(glyphs), Xen_to_C_char_(text), Xen_to_C_int(length), Xen_to_C_PangoAnalysis_(analysis), 
                                Xen_to_C_int(index), Xen_to_C_gboolean(trailing), &ref_x_pos);
  return(Xen_list_1(C_to_Xen_int(ref_x_pos)));
}

static Xen gxg_pango_glyph_string_x_to_index(Xen glyphs, Xen text, Xen length, Xen analysis, Xen x_pos, Xen ignore_index, Xen ignore_trailing)
{
  #define H_pango_glyph_string_x_to_index "void pango_glyph_string_x_to_index(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int x_pos, int* [index], int* [trailing])"
  int ref_index;
  int ref_trailing;
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 1, "pango_glyph_string_x_to_index", "PangoGlyphString*");
  Xen_check_type(Xen_is_char_(text), text, 2, "pango_glyph_string_x_to_index", "char*");
  Xen_check_type(Xen_is_int(length), length, 3, "pango_glyph_string_x_to_index", "int");
  Xen_check_type(Xen_is_PangoAnalysis_(analysis), analysis, 4, "pango_glyph_string_x_to_index", "PangoAnalysis*");
  Xen_check_type(Xen_is_int(x_pos), x_pos, 5, "pango_glyph_string_x_to_index", "int");
  pango_glyph_string_x_to_index(Xen_to_C_PangoGlyphString_(glyphs), Xen_to_C_char_(text), Xen_to_C_int(length), Xen_to_C_PangoAnalysis_(analysis), 
                                Xen_to_C_int(x_pos), &ref_index, &ref_trailing);
  return(Xen_list_2(C_to_Xen_int(ref_index), C_to_Xen_int(ref_trailing)));
}

static Xen gxg_pango_shape(Xen text, Xen length, Xen analysis, Xen glyphs)
{
  #define H_pango_shape "void pango_shape(gchar* text, gint length, PangoAnalysis* analysis, PangoGlyphString* glyphs)"
  Xen_check_type(Xen_is_gchar_(text), text, 1, "pango_shape", "gchar*");
  Xen_check_type(Xen_is_gint(length), length, 2, "pango_shape", "gint");
  Xen_check_type(Xen_is_PangoAnalysis_(analysis), analysis, 3, "pango_shape", "PangoAnalysis*");
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 4, "pango_shape", "PangoGlyphString*");
  pango_shape(Xen_to_C_gchar_(text), Xen_to_C_gint(length), Xen_to_C_PangoAnalysis_(analysis), Xen_to_C_PangoGlyphString_(glyphs));
  return(Xen_false);
}

static Xen gxg_pango_reorder_items(Xen logical_items)
{
  #define H_pango_reorder_items "GList* pango_reorder_items(GList* logical_items)"
  Xen_check_type(Xen_is_GList_(logical_items), logical_items, 1, "pango_reorder_items", "GList*");
  return(C_to_Xen_GList_(pango_reorder_items(Xen_to_C_GList_(logical_items))));
}

static Xen gxg_pango_item_new(void)
{
  #define H_pango_item_new "PangoItem* pango_item_new( void)"
  return(C_to_Xen_PangoItem_(pango_item_new()));
}

static Xen gxg_pango_item_copy(Xen item)
{
  #define H_pango_item_copy "PangoItem* pango_item_copy(PangoItem* item)"
  Xen_check_type(Xen_is_PangoItem_(item), item, 1, "pango_item_copy", "PangoItem*");
  return(C_to_Xen_PangoItem_(pango_item_copy(Xen_to_C_PangoItem_(item))));
}

static Xen gxg_pango_item_free(Xen item)
{
  #define H_pango_item_free "void pango_item_free(PangoItem* item)"
  Xen_check_type(Xen_is_PangoItem_(item), item, 1, "pango_item_free", "PangoItem*");
  pango_item_free(Xen_to_C_PangoItem_(item));
  return(Xen_false);
}

static Xen gxg_pango_item_split(Xen orig, Xen split_index, Xen split_offset)
{
  #define H_pango_item_split "PangoItem* pango_item_split(PangoItem* orig, int split_index, int split_offset)"
  Xen_check_type(Xen_is_PangoItem_(orig), orig, 1, "pango_item_split", "PangoItem*");
  Xen_check_type(Xen_is_int(split_index), split_index, 2, "pango_item_split", "int");
  Xen_check_type(Xen_is_int(split_offset), split_offset, 3, "pango_item_split", "int");
  return(C_to_Xen_PangoItem_(pango_item_split(Xen_to_C_PangoItem_(orig), Xen_to_C_int(split_index), Xen_to_C_int(split_offset))));
}

static Xen gxg_pango_layout_new(Xen context)
{
  #define H_pango_layout_new "PangoLayout* pango_layout_new(PangoContext* context)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_layout_new", "PangoContext*");
  return(C_to_Xen_PangoLayout_(pango_layout_new(Xen_to_C_PangoContext_(context))));
}

static Xen gxg_pango_layout_copy(Xen src)
{
  #define H_pango_layout_copy "PangoLayout* pango_layout_copy(PangoLayout* src)"
  Xen_check_type(Xen_is_PangoLayout_(src), src, 1, "pango_layout_copy", "PangoLayout*");
  return(C_to_Xen_PangoLayout_(pango_layout_copy(Xen_to_C_PangoLayout_(src))));
}

static Xen gxg_pango_layout_get_context(Xen layout)
{
  #define H_pango_layout_get_context "PangoContext* pango_layout_get_context(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_context", "PangoLayout*");
  return(C_to_Xen_PangoContext_(pango_layout_get_context(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_attributes(Xen layout, Xen attrs)
{
  #define H_pango_layout_set_attributes "void pango_layout_set_attributes(PangoLayout* layout, PangoAttrList* attrs)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_attributes", "PangoLayout*");
  Xen_check_type(Xen_is_PangoAttrList_(attrs), attrs, 2, "pango_layout_set_attributes", "PangoAttrList*");
  pango_layout_set_attributes(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoAttrList_(attrs));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_attributes(Xen layout)
{
  #define H_pango_layout_get_attributes "PangoAttrList* pango_layout_get_attributes(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_attributes", "PangoLayout*");
  return(C_to_Xen_PangoAttrList_(pango_layout_get_attributes(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_text(Xen layout, Xen text, Xen length)
{
  #define H_pango_layout_set_text "void pango_layout_set_text(PangoLayout* layout, char* text, int length)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_text", "PangoLayout*");
  Xen_check_type(Xen_is_char_(text), text, 2, "pango_layout_set_text", "char*");
  Xen_check_type(Xen_is_int(length), length, 3, "pango_layout_set_text", "int");
  pango_layout_set_text(Xen_to_C_PangoLayout_(layout), Xen_to_C_char_(text), Xen_to_C_int(length));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_text(Xen layout)
{
  #define H_pango_layout_get_text "char* pango_layout_get_text(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_text", "PangoLayout*");
  return(C_to_Xen_char_(pango_layout_get_text(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_markup(Xen layout, Xen markup, Xen length)
{
  #define H_pango_layout_set_markup "void pango_layout_set_markup(PangoLayout* layout, char* markup, \
int length)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_markup", "PangoLayout*");
  Xen_check_type(Xen_is_char_(markup), markup, 2, "pango_layout_set_markup", "char*");
  Xen_check_type(Xen_is_int(length), length, 3, "pango_layout_set_markup", "int");
  pango_layout_set_markup(Xen_to_C_PangoLayout_(layout), Xen_to_C_char_(markup), Xen_to_C_int(length));
  return(Xen_false);
}

static Xen gxg_pango_layout_set_markup_with_accel(Xen layout, Xen markup, Xen length, Xen accel_marker, Xen accel_char)
{
  #define H_pango_layout_set_markup_with_accel "void pango_layout_set_markup_with_accel(PangoLayout* layout, \
char* markup, int length, gunichar accel_marker, gunichar* accel_char)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_markup_with_accel", "PangoLayout*");
  Xen_check_type(Xen_is_char_(markup), markup, 2, "pango_layout_set_markup_with_accel", "char*");
  Xen_check_type(Xen_is_int(length), length, 3, "pango_layout_set_markup_with_accel", "int");
  Xen_check_type(Xen_is_gunichar(accel_marker), accel_marker, 4, "pango_layout_set_markup_with_accel", "gunichar");
  Xen_check_type(Xen_is_gunichar_(accel_char), accel_char, 5, "pango_layout_set_markup_with_accel", "gunichar*");
  pango_layout_set_markup_with_accel(Xen_to_C_PangoLayout_(layout), Xen_to_C_char_(markup), Xen_to_C_int(length), Xen_to_C_gunichar(accel_marker), 
                                     Xen_to_C_gunichar_(accel_char));
  return(Xen_false);
}

static Xen gxg_pango_layout_set_font_description(Xen layout, Xen desc)
{
  #define H_pango_layout_set_font_description "void pango_layout_set_font_description(PangoLayout* layout, \
PangoFontDescription* desc)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_font_description", "PangoLayout*");
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 2, "pango_layout_set_font_description", "PangoFontDescription*");
  pango_layout_set_font_description(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoFontDescription_(desc));
  return(Xen_false);
}

static Xen gxg_pango_layout_set_width(Xen layout, Xen width)
{
  #define H_pango_layout_set_width "void pango_layout_set_width(PangoLayout* layout, int width)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_width", "PangoLayout*");
  Xen_check_type(Xen_is_int(width), width, 2, "pango_layout_set_width", "int");
  pango_layout_set_width(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(width));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_width(Xen layout)
{
  #define H_pango_layout_get_width "int pango_layout_get_width(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_width", "PangoLayout*");
  return(C_to_Xen_int(pango_layout_get_width(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_wrap(Xen layout, Xen wrap)
{
  #define H_pango_layout_set_wrap "void pango_layout_set_wrap(PangoLayout* layout, PangoWrapMode wrap)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_wrap", "PangoLayout*");
  Xen_check_type(Xen_is_PangoWrapMode(wrap), wrap, 2, "pango_layout_set_wrap", "PangoWrapMode");
  pango_layout_set_wrap(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoWrapMode(wrap));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_wrap(Xen layout)
{
  #define H_pango_layout_get_wrap "PangoWrapMode pango_layout_get_wrap(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_wrap", "PangoLayout*");
  return(C_to_Xen_PangoWrapMode(pango_layout_get_wrap(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_indent(Xen layout, Xen indent)
{
  #define H_pango_layout_set_indent "void pango_layout_set_indent(PangoLayout* layout, int indent)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_indent", "PangoLayout*");
  Xen_check_type(Xen_is_int(indent), indent, 2, "pango_layout_set_indent", "int");
  pango_layout_set_indent(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(indent));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_indent(Xen layout)
{
  #define H_pango_layout_get_indent "int pango_layout_get_indent(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_indent", "PangoLayout*");
  return(C_to_Xen_int(pango_layout_get_indent(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_spacing(Xen layout, Xen spacing)
{
  #define H_pango_layout_set_spacing "void pango_layout_set_spacing(PangoLayout* layout, int spacing)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_spacing", "PangoLayout*");
  Xen_check_type(Xen_is_int(spacing), spacing, 2, "pango_layout_set_spacing", "int");
  pango_layout_set_spacing(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(spacing));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_spacing(Xen layout)
{
  #define H_pango_layout_get_spacing "int pango_layout_get_spacing(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_spacing", "PangoLayout*");
  return(C_to_Xen_int(pango_layout_get_spacing(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_justify(Xen layout, Xen justify)
{
  #define H_pango_layout_set_justify "void pango_layout_set_justify(PangoLayout* layout, gboolean justify)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_justify", "PangoLayout*");
  Xen_check_type(Xen_is_gboolean(justify), justify, 2, "pango_layout_set_justify", "gboolean");
  pango_layout_set_justify(Xen_to_C_PangoLayout_(layout), Xen_to_C_gboolean(justify));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_justify(Xen layout)
{
  #define H_pango_layout_get_justify "gboolean pango_layout_get_justify(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_justify", "PangoLayout*");
  return(C_to_Xen_gboolean(pango_layout_get_justify(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_alignment(Xen layout, Xen alignment)
{
  #define H_pango_layout_set_alignment "void pango_layout_set_alignment(PangoLayout* layout, PangoAlignment alignment)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_alignment", "PangoLayout*");
  Xen_check_type(Xen_is_PangoAlignment(alignment), alignment, 2, "pango_layout_set_alignment", "PangoAlignment");
  pango_layout_set_alignment(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoAlignment(alignment));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_alignment(Xen layout)
{
  #define H_pango_layout_get_alignment "PangoAlignment pango_layout_get_alignment(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_alignment", "PangoLayout*");
  return(C_to_Xen_PangoAlignment(pango_layout_get_alignment(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_tabs(Xen layout, Xen tabs)
{
  #define H_pango_layout_set_tabs "void pango_layout_set_tabs(PangoLayout* layout, PangoTabArray* tabs)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_tabs", "PangoLayout*");
  Xen_check_type(Xen_is_PangoTabArray_(tabs) || Xen_is_false(tabs), tabs, 2, "pango_layout_set_tabs", "PangoTabArray*");
  pango_layout_set_tabs(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoTabArray_(tabs));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_tabs(Xen layout)
{
  #define H_pango_layout_get_tabs "PangoTabArray* pango_layout_get_tabs(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_tabs", "PangoLayout*");
  return(C_to_Xen_PangoTabArray_(pango_layout_get_tabs(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_set_single_paragraph_mode(Xen layout, Xen setting)
{
  #define H_pango_layout_set_single_paragraph_mode "void pango_layout_set_single_paragraph_mode(PangoLayout* layout, \
gboolean setting)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_single_paragraph_mode", "PangoLayout*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "pango_layout_set_single_paragraph_mode", "gboolean");
  pango_layout_set_single_paragraph_mode(Xen_to_C_PangoLayout_(layout), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_single_paragraph_mode(Xen layout)
{
  #define H_pango_layout_get_single_paragraph_mode "gboolean pango_layout_get_single_paragraph_mode(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_single_paragraph_mode", "PangoLayout*");
  return(C_to_Xen_gboolean(pango_layout_get_single_paragraph_mode(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_context_changed(Xen layout)
{
  #define H_pango_layout_context_changed "void pango_layout_context_changed(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_context_changed", "PangoLayout*");
  pango_layout_context_changed(Xen_to_C_PangoLayout_(layout));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_log_attrs(Xen layout, Xen ignore_attrs, Xen ignore_n_attrs)
{
  #define H_pango_layout_get_log_attrs "void pango_layout_get_log_attrs(PangoLayout* layout, PangoLogAttr** [attrs], \
gint* [n_attrs])"
  PangoLogAttr* ref_attrs = NULL;
  gint ref_n_attrs;
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_log_attrs", "PangoLayout*");
  pango_layout_get_log_attrs(Xen_to_C_PangoLayout_(layout), &ref_attrs, &ref_n_attrs);
  return(Xen_list_2(C_to_Xen_PangoLogAttr_(ref_attrs), C_to_Xen_gint(ref_n_attrs)));
}

static Xen gxg_pango_layout_index_to_pos(Xen layout, Xen index, Xen pos)
{
  #define H_pango_layout_index_to_pos "void pango_layout_index_to_pos(PangoLayout* layout, int index, \
PangoRectangle* pos)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_index_to_pos", "PangoLayout*");
  Xen_check_type(Xen_is_int(index), index, 2, "pango_layout_index_to_pos", "int");
  Xen_check_type(Xen_is_PangoRectangle_(pos), pos, 3, "pango_layout_index_to_pos", "PangoRectangle*");
  pango_layout_index_to_pos(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(index), Xen_to_C_PangoRectangle_(pos));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_cursor_pos(Xen layout, Xen index, Xen strong_pos, Xen weak_pos)
{
  #define H_pango_layout_get_cursor_pos "void pango_layout_get_cursor_pos(PangoLayout* layout, int index, \
PangoRectangle* strong_pos, PangoRectangle* weak_pos)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_cursor_pos", "PangoLayout*");
  Xen_check_type(Xen_is_int(index), index, 2, "pango_layout_get_cursor_pos", "int");
  Xen_check_type(Xen_is_PangoRectangle_(strong_pos), strong_pos, 3, "pango_layout_get_cursor_pos", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(weak_pos), weak_pos, 4, "pango_layout_get_cursor_pos", "PangoRectangle*");
  pango_layout_get_cursor_pos(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(index), Xen_to_C_PangoRectangle_(strong_pos), Xen_to_C_PangoRectangle_(weak_pos));
  return(Xen_false);
}

static Xen gxg_pango_layout_move_cursor_visually(Xen layout, Xen strong, Xen old_index, Xen old_trailing, Xen direction, Xen new_index, Xen new_trailing)
{
  #define H_pango_layout_move_cursor_visually "void pango_layout_move_cursor_visually(PangoLayout* layout, \
gboolean strong, int old_index, int old_trailing, int direction, int* new_index, int* new_trailing)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_move_cursor_visually", "PangoLayout*");
  Xen_check_type(Xen_is_gboolean(strong), strong, 2, "pango_layout_move_cursor_visually", "gboolean");
  Xen_check_type(Xen_is_int(old_index), old_index, 3, "pango_layout_move_cursor_visually", "int");
  Xen_check_type(Xen_is_int(old_trailing), old_trailing, 4, "pango_layout_move_cursor_visually", "int");
  Xen_check_type(Xen_is_int(direction), direction, 5, "pango_layout_move_cursor_visually", "int");
  Xen_check_type(Xen_is_int_(new_index), new_index, 6, "pango_layout_move_cursor_visually", "int*");
  Xen_check_type(Xen_is_int_(new_trailing), new_trailing, 7, "pango_layout_move_cursor_visually", "int*");
  pango_layout_move_cursor_visually(Xen_to_C_PangoLayout_(layout), Xen_to_C_gboolean(strong), Xen_to_C_int(old_index), Xen_to_C_int(old_trailing), 
                                    Xen_to_C_int(direction), Xen_to_C_int_(new_index), Xen_to_C_int_(new_trailing));
  return(Xen_false);
}

static Xen gxg_pango_layout_xy_to_index(Xen layout, Xen x, Xen y, Xen ignore_index, Xen ignore_trailing)
{
  #define H_pango_layout_xy_to_index "gboolean pango_layout_xy_to_index(PangoLayout* layout, int x, int y, \
int* [index], int* [trailing])"
  int ref_index;
  int ref_trailing;
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_xy_to_index", "PangoLayout*");
  Xen_check_type(Xen_is_int(x), x, 2, "pango_layout_xy_to_index", "int");
  Xen_check_type(Xen_is_int(y), y, 3, "pango_layout_xy_to_index", "int");
  {
    Xen result;
    result = C_to_Xen_gboolean(pango_layout_xy_to_index(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(x), Xen_to_C_int(y), 
                                                        &ref_index, &ref_trailing));
    return(Xen_list_3(result, C_to_Xen_int(ref_index), C_to_Xen_int(ref_trailing)));
   }
}

static Xen gxg_pango_layout_get_extents(Xen layout, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_get_extents "void pango_layout_get_extents(PangoLayout* layout, PangoRectangle* ink_rect, \
PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_extents", "PangoLayout*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_get_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_get_extents", "PangoRectangle*");
  pango_layout_get_extents(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_pixel_extents(Xen layout, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_get_pixel_extents "void pango_layout_get_pixel_extents(PangoLayout* layout, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_pixel_extents", "PangoLayout*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_get_pixel_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_get_pixel_extents", "PangoRectangle*");
  pango_layout_get_pixel_extents(Xen_to_C_PangoLayout_(layout), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_size(Xen layout, Xen ignore_width, Xen ignore_height)
{
  #define H_pango_layout_get_size "void pango_layout_get_size(PangoLayout* layout, int* [width], int* [height])"
  int ref_width;
  int ref_height;
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_size", "PangoLayout*");
  pango_layout_get_size(Xen_to_C_PangoLayout_(layout), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_int(ref_width), C_to_Xen_int(ref_height)));
}

static Xen gxg_pango_layout_get_pixel_size(Xen layout, Xen ignore_width, Xen ignore_height)
{
  #define H_pango_layout_get_pixel_size "void pango_layout_get_pixel_size(PangoLayout* layout, int* [width], \
int* [height])"
  int ref_width;
  int ref_height;
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_pixel_size", "PangoLayout*");
  pango_layout_get_pixel_size(Xen_to_C_PangoLayout_(layout), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_int(ref_width), C_to_Xen_int(ref_height)));
}

static Xen gxg_pango_layout_get_line_count(Xen layout)
{
  #define H_pango_layout_get_line_count "int pango_layout_get_line_count(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_line_count", "PangoLayout*");
  return(C_to_Xen_int(pango_layout_get_line_count(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_get_line(Xen layout, Xen line)
{
  #define H_pango_layout_get_line "PangoLayoutLine* pango_layout_get_line(PangoLayout* layout, int line)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_line", "PangoLayout*");
  Xen_check_type(Xen_is_int(line), line, 2, "pango_layout_get_line", "int");
  return(C_to_Xen_PangoLayoutLine_(pango_layout_get_line(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(line))));
}

static Xen gxg_pango_layout_get_lines(Xen layout)
{
  #define H_pango_layout_get_lines "GSList* pango_layout_get_lines(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_lines", "PangoLayout*");
  return(C_to_Xen_GSList_(pango_layout_get_lines(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_line_unref(Xen line)
{
  #define H_pango_layout_line_unref "void pango_layout_line_unref(PangoLayoutLine* line)"
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "pango_layout_line_unref", "PangoLayoutLine*");
  pango_layout_line_unref(Xen_to_C_PangoLayoutLine_(line));
  return(Xen_false);
}

static Xen gxg_pango_layout_line_x_to_index(Xen line, Xen x_pos, Xen ignore_index, Xen ignore_trailing)
{
  #define H_pango_layout_line_x_to_index "gboolean pango_layout_line_x_to_index(PangoLayoutLine* line, \
int x_pos, int* [index], int* [trailing])"
  int ref_index;
  int ref_trailing;
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "pango_layout_line_x_to_index", "PangoLayoutLine*");
  Xen_check_type(Xen_is_int(x_pos), x_pos, 2, "pango_layout_line_x_to_index", "int");
  {
    Xen result;
    result = C_to_Xen_gboolean(pango_layout_line_x_to_index(Xen_to_C_PangoLayoutLine_(line), Xen_to_C_int(x_pos), &ref_index, 
                                                            &ref_trailing));
    return(Xen_list_3(result, C_to_Xen_int(ref_index), C_to_Xen_int(ref_trailing)));
   }
}

static Xen gxg_pango_layout_line_index_to_x(Xen line, Xen index, Xen trailing, Xen ignore_x_pos)
{
  #define H_pango_layout_line_index_to_x "void pango_layout_line_index_to_x(PangoLayoutLine* line, int index, \
gboolean trailing, int* [x_pos])"
  int ref_x_pos;
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "pango_layout_line_index_to_x", "PangoLayoutLine*");
  Xen_check_type(Xen_is_int(index), index, 2, "pango_layout_line_index_to_x", "int");
  Xen_check_type(Xen_is_gboolean(trailing), trailing, 3, "pango_layout_line_index_to_x", "gboolean");
  pango_layout_line_index_to_x(Xen_to_C_PangoLayoutLine_(line), Xen_to_C_int(index), Xen_to_C_gboolean(trailing), &ref_x_pos);
  return(Xen_list_1(C_to_Xen_int(ref_x_pos)));
}

static Xen gxg_pango_layout_line_get_x_ranges(Xen line, Xen start_index, Xen end_index, Xen ignore_ranges, Xen ignore_n_ranges)
{
  #define H_pango_layout_line_get_x_ranges "void pango_layout_line_get_x_ranges(PangoLayoutLine* line, \
int start_index, int end_index, int** [ranges], int* [n_ranges])"
  int* ref_ranges = NULL;
  int ref_n_ranges;
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "pango_layout_line_get_x_ranges", "PangoLayoutLine*");
  Xen_check_type(Xen_is_int(start_index), start_index, 2, "pango_layout_line_get_x_ranges", "int");
  Xen_check_type(Xen_is_int(end_index), end_index, 3, "pango_layout_line_get_x_ranges", "int");
  pango_layout_line_get_x_ranges(Xen_to_C_PangoLayoutLine_(line), Xen_to_C_int(start_index), Xen_to_C_int(end_index), &ref_ranges, 
                                 &ref_n_ranges);
  return(Xen_list_2(C_to_Xen_int_(ref_ranges), C_to_Xen_int(ref_n_ranges)));
}

static Xen gxg_pango_layout_line_get_extents(Xen line, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_line_get_extents "void pango_layout_line_get_extents(PangoLayoutLine* line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "pango_layout_line_get_extents", "PangoLayoutLine*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_line_get_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_line_get_extents", "PangoRectangle*");
  pango_layout_line_get_extents(Xen_to_C_PangoLayoutLine_(line), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_line_get_pixel_extents(Xen layout_line, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_line_get_pixel_extents "void pango_layout_line_get_pixel_extents(PangoLayoutLine* layout_line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutLine_(layout_line), layout_line, 1, "pango_layout_line_get_pixel_extents", "PangoLayoutLine*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_line_get_pixel_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_line_get_pixel_extents", "PangoRectangle*");
  pango_layout_line_get_pixel_extents(Xen_to_C_PangoLayoutLine_(layout_line), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_iter(Xen layout)
{
  #define H_pango_layout_get_iter "PangoLayoutIter* pango_layout_get_iter(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_iter", "PangoLayout*");
  return(C_to_Xen_PangoLayoutIter_(pango_layout_get_iter(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_layout_iter_free(Xen iter)
{
  #define H_pango_layout_iter_free "void pango_layout_iter_free(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_free", "PangoLayoutIter*");
  pango_layout_iter_free(Xen_to_C_PangoLayoutIter_(iter));
  return(Xen_false);
}

static Xen gxg_pango_layout_iter_get_index(Xen iter)
{
  #define H_pango_layout_iter_get_index "int pango_layout_iter_get_index(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_index", "PangoLayoutIter*");
  return(C_to_Xen_int(pango_layout_iter_get_index(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_get_run(Xen iter)
{
  #define H_pango_layout_iter_get_run "PangoLayoutRun* pango_layout_iter_get_run(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_run", "PangoLayoutIter*");
  return(C_to_Xen_PangoLayoutRun_(pango_layout_iter_get_run(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_get_line(Xen iter)
{
  #define H_pango_layout_iter_get_line "PangoLayoutLine* pango_layout_iter_get_line(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_line", "PangoLayoutIter*");
  return(C_to_Xen_PangoLayoutLine_(pango_layout_iter_get_line(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_at_last_line(Xen iter)
{
  #define H_pango_layout_iter_at_last_line "gboolean pango_layout_iter_at_last_line(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_at_last_line", "PangoLayoutIter*");
  return(C_to_Xen_gboolean(pango_layout_iter_at_last_line(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_next_char(Xen iter)
{
  #define H_pango_layout_iter_next_char "gboolean pango_layout_iter_next_char(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_next_char", "PangoLayoutIter*");
  return(C_to_Xen_gboolean(pango_layout_iter_next_char(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_next_cluster(Xen iter)
{
  #define H_pango_layout_iter_next_cluster "gboolean pango_layout_iter_next_cluster(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_next_cluster", "PangoLayoutIter*");
  return(C_to_Xen_gboolean(pango_layout_iter_next_cluster(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_next_run(Xen iter)
{
  #define H_pango_layout_iter_next_run "gboolean pango_layout_iter_next_run(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_next_run", "PangoLayoutIter*");
  return(C_to_Xen_gboolean(pango_layout_iter_next_run(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_next_line(Xen iter)
{
  #define H_pango_layout_iter_next_line "gboolean pango_layout_iter_next_line(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_next_line", "PangoLayoutIter*");
  return(C_to_Xen_gboolean(pango_layout_iter_next_line(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_layout_iter_get_char_extents(Xen iter, Xen logical_rect)
{
  #define H_pango_layout_iter_get_char_extents "void pango_layout_iter_get_char_extents(PangoLayoutIter* iter, \
PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_char_extents", "PangoLayoutIter*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 2, "pango_layout_iter_get_char_extents", "PangoRectangle*");
  pango_layout_iter_get_char_extents(Xen_to_C_PangoLayoutIter_(iter), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_iter_get_cluster_extents(Xen iter, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_iter_get_cluster_extents "void pango_layout_iter_get_cluster_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_cluster_extents", "PangoLayoutIter*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_iter_get_cluster_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_iter_get_cluster_extents", "PangoRectangle*");
  pango_layout_iter_get_cluster_extents(Xen_to_C_PangoLayoutIter_(iter), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_iter_get_run_extents(Xen iter, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_iter_get_run_extents "void pango_layout_iter_get_run_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_run_extents", "PangoLayoutIter*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_iter_get_run_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_iter_get_run_extents", "PangoRectangle*");
  pango_layout_iter_get_run_extents(Xen_to_C_PangoLayoutIter_(iter), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_iter_get_line_extents(Xen iter, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_iter_get_line_extents "void pango_layout_iter_get_line_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_line_extents", "PangoLayoutIter*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_iter_get_line_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_iter_get_line_extents", "PangoRectangle*");
  pango_layout_iter_get_line_extents(Xen_to_C_PangoLayoutIter_(iter), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_iter_get_line_yrange(Xen iter, Xen ignore_y0, Xen ignore_y1)
{
  #define H_pango_layout_iter_get_line_yrange "void pango_layout_iter_get_line_yrange(PangoLayoutIter* iter, \
int* [y0], int* [y1])"
  int ref_y0;
  int ref_y1;
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_line_yrange", "PangoLayoutIter*");
  pango_layout_iter_get_line_yrange(Xen_to_C_PangoLayoutIter_(iter), &ref_y0, &ref_y1);
  return(Xen_list_2(C_to_Xen_int(ref_y0), C_to_Xen_int(ref_y1)));
}

static Xen gxg_pango_layout_iter_get_layout_extents(Xen iter, Xen ink_rect, Xen logical_rect)
{
  #define H_pango_layout_iter_get_layout_extents "void pango_layout_iter_get_layout_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_layout_extents", "PangoLayoutIter*");
  Xen_check_type(Xen_is_PangoRectangle_(ink_rect), ink_rect, 2, "pango_layout_iter_get_layout_extents", "PangoRectangle*");
  Xen_check_type(Xen_is_PangoRectangle_(logical_rect), logical_rect, 3, "pango_layout_iter_get_layout_extents", "PangoRectangle*");
  pango_layout_iter_get_layout_extents(Xen_to_C_PangoLayoutIter_(iter), Xen_to_C_PangoRectangle_(ink_rect), Xen_to_C_PangoRectangle_(logical_rect));
  return(Xen_false);
}

static Xen gxg_pango_layout_iter_get_baseline(Xen iter)
{
  #define H_pango_layout_iter_get_baseline "int pango_layout_iter_get_baseline(PangoLayoutIter* iter)"
  Xen_check_type(Xen_is_PangoLayoutIter_(iter), iter, 1, "pango_layout_iter_get_baseline", "PangoLayoutIter*");
  return(C_to_Xen_int(pango_layout_iter_get_baseline(Xen_to_C_PangoLayoutIter_(iter))));
}

static Xen gxg_pango_language_from_string(Xen language)
{
  #define H_pango_language_from_string "PangoLanguage* pango_language_from_string(char* language)"
  Xen_check_type(Xen_is_char_(language), language, 1, "pango_language_from_string", "char*");
  return(C_to_Xen_PangoLanguage_(pango_language_from_string(Xen_to_C_char_(language))));
}

static Xen gxg_pango_language_matches(Xen language, Xen range_list)
{
  #define H_pango_language_matches "gboolean pango_language_matches(PangoLanguage* language, char* range_list)"
  Xen_check_type(Xen_is_PangoLanguage_(language), language, 1, "pango_language_matches", "PangoLanguage*");
  Xen_check_type(Xen_is_char_(range_list), range_list, 2, "pango_language_matches", "char*");
  return(C_to_Xen_gboolean(pango_language_matches(Xen_to_C_PangoLanguage_(language), Xen_to_C_char_(range_list))));
}

static Xen gxg_G_OBJECT_TYPE(Xen object)
{
  #define H_G_OBJECT_TYPE "GType G_OBJECT_TYPE(GObject* object)"
  Xen_check_type(Xen_is_GObject_(object), object, 1, "G_OBJECT_TYPE", "GObject*");
  return(C_to_Xen_GType(G_OBJECT_TYPE(Xen_to_C_GObject_(object))));
}

static Xen gxg_gtk_tree_model_get_string_from_iter(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_get_string_from_iter "gchar* gtk_tree_model_get_string_from_iter(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_get_string_from_iter", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_get_string_from_iter", "GtkTreeIter*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_tree_model_get_string_from_iter(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_tree_model_sort_iter_is_valid(Xen tree_model_sort, Xen iter)
{
  #define H_gtk_tree_model_sort_iter_is_valid "gboolean gtk_tree_model_sort_iter_is_valid(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModelSort_(tree_model_sort), tree_model_sort, 1, "gtk_tree_model_sort_iter_is_valid", "GtkTreeModelSort*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_sort_iter_is_valid", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_sort_iter_is_valid(Xen_to_C_GtkTreeModelSort_(tree_model_sort), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_view_expand_to_path(Xen tree_view, Xen path)
{
  #define H_gtk_tree_view_expand_to_path "void gtk_tree_view_expand_to_path(GtkTreeView* tree_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_expand_to_path", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_expand_to_path", "GtkTreePath*");
  gtk_tree_view_expand_to_path(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_selection_get_selected_rows(Xen selection, Xen model)
{
  #define H_gtk_tree_selection_get_selected_rows "GList* gtk_tree_selection_get_selected_rows(GtkTreeSelection* selection, \
GtkTreeModel** model)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_get_selected_rows", "GtkTreeSelection*");
  Xen_check_type(Xen_is_GtkTreeModel__(model), model, 2, "gtk_tree_selection_get_selected_rows", "GtkTreeModel**");
  return(C_to_Xen_GList_(gtk_tree_selection_get_selected_rows(Xen_to_C_GtkTreeSelection_(selection), Xen_to_C_GtkTreeModel__(model))));
}

static Xen gxg_gtk_tree_selection_count_selected_rows(Xen selection)
{
  #define H_gtk_tree_selection_count_selected_rows "int gtk_tree_selection_count_selected_rows(GtkTreeSelection* selection)"
  Xen_check_type(Xen_is_GtkTreeSelection_(selection), selection, 1, "gtk_tree_selection_count_selected_rows", "GtkTreeSelection*");
  return(C_to_Xen_int(gtk_tree_selection_count_selected_rows(Xen_to_C_GtkTreeSelection_(selection))));
}

static Xen gxg_gtk_menu_shell_select_first(Xen menu_shell, Xen search_sensitive)
{
  #define H_gtk_menu_shell_select_first "void gtk_menu_shell_select_first(GtkMenuShell* menu_shell, gboolean search_sensitive)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_select_first", "GtkMenuShell*");
  Xen_check_type(Xen_is_gboolean(search_sensitive), search_sensitive, 2, "gtk_menu_shell_select_first", "gboolean");
  gtk_menu_shell_select_first(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_gboolean(search_sensitive));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_n_pages(Xen notebook)
{
  #define H_gtk_notebook_get_n_pages "int gtk_notebook_get_n_pages(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_n_pages", "GtkNotebook*");
  return(C_to_Xen_int(gtk_notebook_get_n_pages(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_list_store_reorder(Xen store, Xen new_order)
{
  #define H_gtk_list_store_reorder "void gtk_list_store_reorder(GtkListStore* store, int* new_order)"
  Xen_check_type(Xen_is_GtkListStore_(store), store, 1, "gtk_list_store_reorder", "GtkListStore*");
  Xen_check_type(Xen_is_int_(new_order), new_order, 2, "gtk_list_store_reorder", "int*");
  gtk_list_store_reorder(Xen_to_C_GtkListStore_(store), Xen_to_C_int_(new_order));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_swap(Xen store, Xen a, Xen b)
{
  #define H_gtk_list_store_swap "void gtk_list_store_swap(GtkListStore* store, GtkTreeIter* a, GtkTreeIter* b)"
  Xen_check_type(Xen_is_GtkListStore_(store), store, 1, "gtk_list_store_swap", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(a), a, 2, "gtk_list_store_swap", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(b), b, 3, "gtk_list_store_swap", "GtkTreeIter*");
  gtk_list_store_swap(Xen_to_C_GtkListStore_(store), Xen_to_C_GtkTreeIter_(a), Xen_to_C_GtkTreeIter_(b));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_move_after(Xen store, Xen iter, Xen position)
{
  #define H_gtk_list_store_move_after "void gtk_list_store_move_after(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  Xen_check_type(Xen_is_GtkListStore_(store), store, 1, "gtk_list_store_move_after", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_move_after", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(position) || Xen_is_false(position), position, 3, "gtk_list_store_move_after", "GtkTreeIter*");
  gtk_list_store_move_after(Xen_to_C_GtkListStore_(store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(position));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_move_before(Xen store, Xen iter, Xen position)
{
  #define H_gtk_list_store_move_before "void gtk_list_store_move_before(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  Xen_check_type(Xen_is_GtkListStore_(store), store, 1, "gtk_list_store_move_before", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_move_before", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(position) || Xen_is_false(position), position, 3, "gtk_list_store_move_before", "GtkTreeIter*");
  gtk_list_store_move_before(Xen_to_C_GtkListStore_(store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_GtkTreeIter_(position));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_reorder(Xen tree_store, Xen parent, Xen new_order)
{
  #define H_gtk_tree_store_reorder "void gtk_tree_store_reorder(GtkTreeStore* tree_store, GtkTreeIter* parent, \
int* new_order)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_reorder", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(parent), parent, 2, "gtk_tree_store_reorder", "GtkTreeIter*");
  Xen_check_type(Xen_is_int_(new_order), new_order, 3, "gtk_tree_store_reorder", "int*");
  gtk_tree_store_reorder(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(parent), Xen_to_C_int_(new_order));
  return(Xen_false);
}

static Xen gxg_gtk_tree_store_swap(Xen tree_store, Xen a, Xen b)
{
  #define H_gtk_tree_store_swap "void gtk_tree_store_swap(GtkTreeStore* tree_store, GtkTreeIter* a, GtkTreeIter* b)"
  Xen_check_type(Xen_is_GtkTreeStore_(tree_store), tree_store, 1, "gtk_tree_store_swap", "GtkTreeStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(a), a, 2, "gtk_tree_store_swap", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(b), b, 3, "gtk_tree_store_swap", "GtkTreeIter*");
  gtk_tree_store_swap(Xen_to_C_GtkTreeStore_(tree_store), Xen_to_C_GtkTreeIter_(a), Xen_to_C_GtkTreeIter_(b));
  return(Xen_false);
}

static Xen gxg_gdk_display_open(Xen display_name)
{
  #define H_gdk_display_open "GdkDisplay* gdk_display_open(gchar* display_name)"
  Xen_check_type(Xen_is_gchar_(display_name), display_name, 1, "gdk_display_open", "gchar*");
  return(C_to_Xen_GdkDisplay_(gdk_display_open(Xen_to_C_gchar_(display_name))));
}

static Xen gxg_gdk_display_get_name(Xen display)
{
  #define H_gdk_display_get_name "gchar* gdk_display_get_name(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_name", "GdkDisplay*");
  return(C_to_Xen_gchar_(gdk_display_get_name(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_beep(Xen display)
{
  #define H_gdk_display_beep "void gdk_display_beep(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_beep", "GdkDisplay*");
  gdk_display_beep(Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gdk_display_sync(Xen display)
{
  #define H_gdk_display_sync "void gdk_display_sync(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_sync", "GdkDisplay*");
  gdk_display_sync(Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gdk_display_close(Xen display)
{
  #define H_gdk_display_close "void gdk_display_close(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_close", "GdkDisplay*");
  gdk_display_close(Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gdk_display_get_event(Xen display)
{
  #define H_gdk_display_get_event "GdkEvent* gdk_display_get_event(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_event", "GdkDisplay*");
  return(C_to_Xen_GdkEvent_(gdk_display_get_event(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_peek_event(Xen display)
{
  #define H_gdk_display_peek_event "GdkEvent* gdk_display_peek_event(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_peek_event", "GdkDisplay*");
  return(C_to_Xen_GdkEvent_(gdk_display_peek_event(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_put_event(Xen display, Xen event)
{
  #define H_gdk_display_put_event "void gdk_display_put_event(GdkDisplay* display, GdkEvent* event)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_put_event", "GdkDisplay*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gdk_display_put_event", "GdkEvent*");
  gdk_display_put_event(Xen_to_C_GdkDisplay_(display), Xen_to_C_GdkEvent_(event));
  return(Xen_false);
}

static Xen gxg_gdk_display_get_default(void)
{
  #define H_gdk_display_get_default "GdkDisplay* gdk_display_get_default( void)"
  return(C_to_Xen_GdkDisplay_(gdk_display_get_default()));
}

static Xen gxg_gtk_widget_get_display(Xen widget)
{
  #define H_gtk_widget_get_display "GdkDisplay* gtk_widget_get_display(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_display", "GtkWidget*");
  return(C_to_Xen_GdkDisplay_(gtk_widget_get_display(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_g_list_free(Xen list)
{
  #define H_g_list_free "void g_list_free(GList* list)"
  Xen_check_type(Xen_is_GList_(list), list, 1, "g_list_free", "GList*");
  g_list_free(Xen_to_C_GList_(list));
  return(Xen_false);
}

static Xen gxg_g_list_reverse(Xen list)
{
  #define H_g_list_reverse "GList* g_list_reverse(GList* list)"
  Xen_check_type(Xen_is_GList_(list) || Xen_is_false(list), list, 1, "g_list_reverse", "GList*");
  return(C_to_Xen_GList_(g_list_reverse(Xen_to_C_GList_(list))));
}

static Xen gxg_g_list_copy(Xen list)
{
  #define H_g_list_copy "GList* g_list_copy(GList* list)"
  Xen_check_type(Xen_is_GList_(list) || Xen_is_false(list), list, 1, "g_list_copy", "GList*");
  return(C_to_Xen_GList_(g_list_copy(Xen_to_C_GList_(list))));
}

static Xen gxg_g_list_last(Xen list)
{
  #define H_g_list_last "GList* g_list_last(GList* list)"
  Xen_check_type(Xen_is_GList_(list), list, 1, "g_list_last", "GList*");
  return(C_to_Xen_GList_(g_list_last(Xen_to_C_GList_(list))));
}

static Xen gxg_g_list_first(Xen list)
{
  #define H_g_list_first "GList* g_list_first(GList* list)"
  Xen_check_type(Xen_is_GList_(list), list, 1, "g_list_first", "GList*");
  return(C_to_Xen_GList_(g_list_first(Xen_to_C_GList_(list))));
}

static Xen gxg_g_list_length(Xen list)
{
  #define H_g_list_length "guint g_list_length(GList* list)"
  Xen_check_type(Xen_is_GList_(list) || Xen_is_false(list), list, 1, "g_list_length", "GList*");
  return(C_to_Xen_guint(g_list_length(Xen_to_C_GList_(list))));
}

static Xen gxg_g_free(Xen mem)
{
  #define H_g_free "void g_free(gpointer mem)"
  Xen_check_type(Xen_is_gpointer(mem), mem, 1, "g_free", "gpointer");
  g_free(Xen_to_C_gpointer(mem));
  return(Xen_false);
}

static Xen gxg_g_list_remove_link(Xen list, Xen llink)
{
  #define H_g_list_remove_link "GList* g_list_remove_link(GList* list, GList* llink)"
  Xen_check_type(Xen_is_GList_(list), list, 1, "g_list_remove_link", "GList*");
  Xen_check_type(Xen_is_GList_(llink), llink, 2, "g_list_remove_link", "GList*");
  return(C_to_Xen_GList_(g_list_remove_link(Xen_to_C_GList_(list), Xen_to_C_GList_(llink))));
}

static Xen gxg_g_object_get_data(Xen object, Xen key)
{
  #define H_g_object_get_data "gpointer g_object_get_data(GObject* object, gchar* key)"
  Xen_check_type(Xen_is_GObject_(object), object, 1, "g_object_get_data", "GObject*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "g_object_get_data", "gchar*");
  return(C_to_Xen_gpointer(g_object_get_data(Xen_to_C_GObject_(object), (const gchar*)Xen_to_C_gchar_(key))));
}

static Xen gxg_g_object_set_data(Xen object, Xen key, Xen data)
{
  #define H_g_object_set_data "void g_object_set_data(GObject* object, gchar* key, gpointer data)"
  Xen_check_type(Xen_is_GObject_(object), object, 1, "g_object_set_data", "GObject*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "g_object_set_data", "gchar*");
  Xen_check_type(Xen_is_gpointer(data), data, 3, "g_object_set_data", "gpointer");
  g_object_set_data(Xen_to_C_GObject_(object), (const gchar*)Xen_to_C_gchar_(key), Xen_to_C_gpointer(data));
  return(Xen_false);
}

static Xen gxg_gdk_display_flush(Xen display)
{
  #define H_gdk_display_flush "void gdk_display_flush(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_flush", "GdkDisplay*");
  gdk_display_flush(Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gdk_display_supports_cursor_alpha(Xen display)
{
  #define H_gdk_display_supports_cursor_alpha "gboolean gdk_display_supports_cursor_alpha(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_supports_cursor_alpha", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_supports_cursor_alpha(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_supports_cursor_color(Xen display)
{
  #define H_gdk_display_supports_cursor_color "gboolean gdk_display_supports_cursor_color(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_supports_cursor_color", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_supports_cursor_color(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_default_cursor_size(Xen display)
{
  #define H_gdk_display_get_default_cursor_size "guint gdk_display_get_default_cursor_size(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_default_cursor_size", "GdkDisplay*");
  return(C_to_Xen_guint(gdk_display_get_default_cursor_size(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_maximal_cursor_size(Xen display, Xen ignore_width, Xen ignore_height)
{
  #define H_gdk_display_get_maximal_cursor_size "void gdk_display_get_maximal_cursor_size(GdkDisplay* display, \
guint* [width], guint* [height])"
  guint ref_width;
  guint ref_height;
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_maximal_cursor_size", "GdkDisplay*");
  gdk_display_get_maximal_cursor_size(Xen_to_C_GdkDisplay_(display), &ref_width, &ref_height);
  return(Xen_list_2(C_to_Xen_guint(ref_width), C_to_Xen_guint(ref_height)));
}

static Xen gxg_gdk_window_set_keep_above(Xen window, Xen setting)
{
  #define H_gdk_window_set_keep_above "void gdk_window_set_keep_above(GdkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_keep_above", "GdkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gdk_window_set_keep_above", "gboolean");
  gdk_window_set_keep_above(Xen_to_C_GdkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_keep_below(Xen window, Xen setting)
{
  #define H_gdk_window_set_keep_below "void gdk_window_set_keep_below(GdkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_keep_below", "GdkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gdk_window_set_keep_below", "gboolean");
  gdk_window_set_keep_below(Xen_to_C_GdkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_button_box_get_child_secondary(Xen widget, Xen child)
{
  #define H_gtk_button_box_get_child_secondary "gboolean gtk_button_box_get_child_secondary(GtkButtonBox* widget, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkButtonBox_(widget), widget, 1, "gtk_button_box_get_child_secondary", "GtkButtonBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_button_box_get_child_secondary", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_button_box_get_child_secondary(Xen_to_C_GtkButtonBox_(widget), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_calendar_set_display_options(Xen calendar, Xen flags)
{
  #define H_gtk_calendar_set_display_options "void gtk_calendar_set_display_options(GtkCalendar* calendar, \
GtkCalendarDisplayOptions flags)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_set_display_options", "GtkCalendar*");
  Xen_check_type(Xen_is_GtkCalendarDisplayOptions(flags), flags, 2, "gtk_calendar_set_display_options", "GtkCalendarDisplayOptions");
  gtk_calendar_set_display_options(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_GtkCalendarDisplayOptions(flags));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_get_display_options(Xen calendar)
{
  #define H_gtk_calendar_get_display_options "GtkCalendarDisplayOptions gtk_calendar_get_display_options(GtkCalendar* calendar)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_get_display_options", "GtkCalendar*");
  return(C_to_Xen_GtkCalendarDisplayOptions(gtk_calendar_get_display_options(Xen_to_C_GtkCalendar_(calendar))));
}

static Xen gxg_gtk_check_menu_item_set_draw_as_radio(Xen check_menu_item, Xen draw_as_radio)
{
  #define H_gtk_check_menu_item_set_draw_as_radio "void gtk_check_menu_item_set_draw_as_radio(GtkCheckMenuItem* check_menu_item, \
gboolean draw_as_radio)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_set_draw_as_radio", "GtkCheckMenuItem*");
  Xen_check_type(Xen_is_gboolean(draw_as_radio), draw_as_radio, 2, "gtk_check_menu_item_set_draw_as_radio", "gboolean");
  gtk_check_menu_item_set_draw_as_radio(Xen_to_C_GtkCheckMenuItem_(check_menu_item), Xen_to_C_gboolean(draw_as_radio));
  return(Xen_false);
}

static Xen gxg_gtk_check_menu_item_get_draw_as_radio(Xen check_menu_item)
{
  #define H_gtk_check_menu_item_get_draw_as_radio "gboolean gtk_check_menu_item_get_draw_as_radio(GtkCheckMenuItem* check_menu_item)"
  Xen_check_type(Xen_is_GtkCheckMenuItem_(check_menu_item), check_menu_item, 1, "gtk_check_menu_item_get_draw_as_radio", "GtkCheckMenuItem*");
  return(C_to_Xen_gboolean(gtk_check_menu_item_get_draw_as_radio(Xen_to_C_GtkCheckMenuItem_(check_menu_item))));
}

static Xen gxg_gtk_entry_set_completion(Xen entry, Xen completion)
{
  #define H_gtk_entry_set_completion "void gtk_entry_set_completion(GtkEntry* entry, GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_completion", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 2, "gtk_entry_set_completion", "GtkEntryCompletion*");
  gtk_entry_set_completion(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryCompletion_(completion));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_completion(Xen entry)
{
  #define H_gtk_entry_get_completion "GtkEntryCompletion* gtk_entry_get_completion(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_completion", "GtkEntry*");
  return(C_to_Xen_GtkEntryCompletion_(gtk_entry_get_completion(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_menu_attach(Xen menu, Xen child, Xen left_attach, Xen right_attach, Xen top_attach, Xen bottom_attach)
{
  #define H_gtk_menu_attach "void gtk_menu_attach(GtkMenu* menu, GtkWidget* child, guint left_attach, \
guint right_attach, guint top_attach, guint bottom_attach)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_attach", "GtkMenu*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_menu_attach", "GtkWidget*");
  Xen_check_type(Xen_is_guint(left_attach), left_attach, 3, "gtk_menu_attach", "guint");
  Xen_check_type(Xen_is_guint(right_attach), right_attach, 4, "gtk_menu_attach", "guint");
  Xen_check_type(Xen_is_guint(top_attach), top_attach, 5, "gtk_menu_attach", "guint");
  Xen_check_type(Xen_is_guint(bottom_attach), bottom_attach, 6, "gtk_menu_attach", "guint");
  gtk_menu_attach(Xen_to_C_GtkMenu_(menu), Xen_to_C_GtkWidget_(child), Xen_to_C_guint(left_attach), Xen_to_C_guint(right_attach), 
                  Xen_to_C_guint(top_attach), Xen_to_C_guint(bottom_attach));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_select_range(Xen buffer, Xen ins, Xen bound)
{
  #define H_gtk_text_buffer_select_range "void gtk_text_buffer_select_range(GtkTextBuffer* buffer, GtkTextIter* ins, \
GtkTextIter* bound)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_select_range", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(ins), ins, 2, "gtk_text_buffer_select_range", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(bound), bound, 3, "gtk_text_buffer_select_range", "GtkTextIter*");
  gtk_text_buffer_select_range(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(ins), Xen_to_C_GtkTextIter_(bound));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_set_overwrite(Xen text_view, Xen overwrite)
{
  #define H_gtk_text_view_set_overwrite "void gtk_text_view_set_overwrite(GtkTextView* text_view, gboolean overwrite)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_overwrite", "GtkTextView*");
  Xen_check_type(Xen_is_gboolean(overwrite), overwrite, 2, "gtk_text_view_set_overwrite", "gboolean");
  gtk_text_view_set_overwrite(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gboolean(overwrite));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_overwrite(Xen text_view)
{
  #define H_gtk_text_view_get_overwrite "gboolean gtk_text_view_get_overwrite(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_overwrite", "GtkTextView*");
  return(C_to_Xen_gboolean(gtk_text_view_get_overwrite(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_accepts_tab(Xen text_view, Xen accepts_tab)
{
  #define H_gtk_text_view_set_accepts_tab "void gtk_text_view_set_accepts_tab(GtkTextView* text_view, \
gboolean accepts_tab)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_accepts_tab", "GtkTextView*");
  Xen_check_type(Xen_is_gboolean(accepts_tab), accepts_tab, 2, "gtk_text_view_set_accepts_tab", "gboolean");
  gtk_text_view_set_accepts_tab(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gboolean(accepts_tab));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_accepts_tab(Xen text_view)
{
  #define H_gtk_text_view_get_accepts_tab "gboolean gtk_text_view_get_accepts_tab(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_accepts_tab", "GtkTextView*");
  return(C_to_Xen_gboolean(gtk_text_view_get_accepts_tab(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_toolbar_insert(Xen toolbar, Xen item, Xen pos)
{
  #define H_gtk_toolbar_insert "void gtk_toolbar_insert(GtkToolbar* toolbar, GtkToolItem* item, gint pos)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_insert", "GtkToolbar*");
  Xen_check_type(Xen_is_GtkToolItem_(item), item, 2, "gtk_toolbar_insert", "GtkToolItem*");
  Xen_check_type(Xen_is_gint(pos), pos, 3, "gtk_toolbar_insert", "gint");
  gtk_toolbar_insert(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_GtkToolItem_(item), Xen_to_C_gint(pos));
  return(Xen_false);
}

static Xen gxg_gtk_toolbar_get_item_index(Xen toolbar, Xen item)
{
  #define H_gtk_toolbar_get_item_index "gint gtk_toolbar_get_item_index(GtkToolbar* toolbar, GtkToolItem* item)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_get_item_index", "GtkToolbar*");
  Xen_check_type(Xen_is_GtkToolItem_(item), item, 2, "gtk_toolbar_get_item_index", "GtkToolItem*");
  return(C_to_Xen_gint(gtk_toolbar_get_item_index(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_GtkToolItem_(item))));
}

static Xen gxg_gtk_toolbar_get_n_items(Xen toolbar)
{
  #define H_gtk_toolbar_get_n_items "gint gtk_toolbar_get_n_items(GtkToolbar* toolbar)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_get_n_items", "GtkToolbar*");
  return(C_to_Xen_gint(gtk_toolbar_get_n_items(Xen_to_C_GtkToolbar_(toolbar))));
}

static Xen gxg_gtk_toolbar_get_nth_item(Xen toolbar, Xen n)
{
  #define H_gtk_toolbar_get_nth_item "GtkToolItem* gtk_toolbar_get_nth_item(GtkToolbar* toolbar, gint n)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_get_nth_item", "GtkToolbar*");
  Xen_check_type(Xen_is_gint(n), n, 2, "gtk_toolbar_get_nth_item", "gint");
  return(C_to_Xen_GtkToolItem_(gtk_toolbar_get_nth_item(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_gint(n))));
}

static Xen gxg_gtk_toolbar_set_show_arrow(Xen toolbar, Xen show_arrow)
{
  #define H_gtk_toolbar_set_show_arrow "void gtk_toolbar_set_show_arrow(GtkToolbar* toolbar, gboolean show_arrow)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_set_show_arrow", "GtkToolbar*");
  Xen_check_type(Xen_is_gboolean(show_arrow), show_arrow, 2, "gtk_toolbar_set_show_arrow", "gboolean");
  gtk_toolbar_set_show_arrow(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_gboolean(show_arrow));
  return(Xen_false);
}

static Xen gxg_gtk_toolbar_get_show_arrow(Xen toolbar)
{
  #define H_gtk_toolbar_get_show_arrow "gboolean gtk_toolbar_get_show_arrow(GtkToolbar* toolbar)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_get_show_arrow", "GtkToolbar*");
  return(C_to_Xen_gboolean(gtk_toolbar_get_show_arrow(Xen_to_C_GtkToolbar_(toolbar))));
}

static Xen gxg_gtk_toolbar_get_drop_index(Xen toolbar, Xen x, Xen y)
{
  #define H_gtk_toolbar_get_drop_index "gint gtk_toolbar_get_drop_index(GtkToolbar* toolbar, gint x, \
gint y)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_get_drop_index", "GtkToolbar*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_toolbar_get_drop_index", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_toolbar_get_drop_index", "gint");
  return(C_to_Xen_gint(gtk_toolbar_get_drop_index(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_tree_view_column_set_expand(Xen tree_column, Xen expand)
{
  #define H_gtk_tree_view_column_set_expand "void gtk_tree_view_column_set_expand(GtkTreeViewColumn* tree_column, \
gboolean expand)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_set_expand", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 2, "gtk_tree_view_column_set_expand", "gboolean");
  gtk_tree_view_column_set_expand(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_get_expand(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_expand "gboolean gtk_tree_view_column_get_expand(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_expand", "GtkTreeViewColumn*");
  return(C_to_Xen_gboolean(gtk_tree_view_column_get_expand(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_widget_queue_resize_no_redraw(Xen widget)
{
  #define H_gtk_widget_queue_resize_no_redraw "void gtk_widget_queue_resize_no_redraw(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_queue_resize_no_redraw", "GtkWidget*");
  gtk_widget_queue_resize_no_redraw(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_keep_above(Xen window, Xen setting)
{
  #define H_gtk_window_set_keep_above "void gtk_window_set_keep_above(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_keep_above", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_keep_above", "gboolean");
  gtk_window_set_keep_above(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_keep_below(Xen window, Xen setting)
{
  #define H_gtk_window_set_keep_below "void gtk_window_set_keep_below(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_keep_below", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_keep_below", "gboolean");
  gtk_window_set_keep_below(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_dialog_new(Xen title, Xen parent, Xen action, Xen buttons)
{
  #define H_gtk_file_chooser_dialog_new "GtkWidget* gtk_file_chooser_dialog_new(gchar* title, GtkWindow* parent, \
GtkFileChooserAction action, etc buttons)"
  Xen_check_type(Xen_is_gchar_(title), title, 1, "gtk_file_chooser_dialog_new", "gchar*");
  Xen_check_type(Xen_is_GtkWindow_(parent) || Xen_is_false(parent), parent, 2, "gtk_file_chooser_dialog_new", "GtkWindow*");
  Xen_check_type(Xen_is_GtkFileChooserAction(action), action, 3, "gtk_file_chooser_dialog_new", "GtkFileChooserAction");
  if (!Xen_is_bound(buttons)) buttons = Xen_false; 
  else Xen_check_type(Xen_is_etc(buttons), buttons, 4, "gtk_file_chooser_dialog_new", "etc");
  {
    int etc_len = 0;
    GtkWidget* result = NULL;
    gchar* p_arg0;
    GtkWindow* p_arg1;
    GtkFileChooserAction p_arg2;
    if (Xen_is_list(buttons)) etc_len = Xen_list_length(buttons);
    if (etc_len > 10) Xen_out_of_range_error("gtk_file_chooser_dialog_new", 3, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_file_chooser_dialog_new", 3, buttons, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_gchar_(title);
    p_arg1 = Xen_to_C_GtkWindow_(parent);
    p_arg2 = Xen_to_C_GtkFileChooserAction(action);
    switch (etc_len)
      {
        case 0: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, NULL, NULL); break;
        case 2: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), NULL); break;
        case 4: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), NULL); break;
        case 6: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), NULL); break;
        case 8: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), NULL); break;
        case 10: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, XLS(buttons, 0), XLI(buttons, 1), XLS(buttons, 2), XLI(buttons, 3), XLS(buttons, 4), XLI(buttons, 5), XLS(buttons, 6), XLI(buttons, 7), XLS(buttons, 8), XLI(buttons, 9), NULL); break;
      }
    return(C_to_Xen_GtkWidget_(result));
  }
}

static Xen gxg_gtk_file_chooser_widget_new(Xen action)
{
  #define H_gtk_file_chooser_widget_new "GtkWidget* gtk_file_chooser_widget_new(GtkFileChooserAction action)"
  Xen_check_type(Xen_is_GtkFileChooserAction(action), action, 1, "gtk_file_chooser_widget_new", "GtkFileChooserAction");
  return(C_to_Xen_GtkWidget_(gtk_file_chooser_widget_new(Xen_to_C_GtkFileChooserAction(action))));
}

static Xen gxg_gtk_tree_model_filter_new(Xen child_model, Xen root)
{
  #define H_gtk_tree_model_filter_new "GtkTreeModel* gtk_tree_model_filter_new(GtkTreeModel* child_model, \
GtkTreePath* root)"
  Xen_check_type(Xen_is_GtkTreeModel_(child_model), child_model, 1, "gtk_tree_model_filter_new", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(root) || Xen_is_false(root), root, 2, "gtk_tree_model_filter_new", "GtkTreePath*");
  return(C_to_Xen_GtkTreeModel_(gtk_tree_model_filter_new(Xen_to_C_GtkTreeModel_(child_model), Xen_to_C_GtkTreePath_(root))));
}

static Xen gxg_gtk_tree_model_filter_set_visible_column(Xen filter, Xen column)
{
  #define H_gtk_tree_model_filter_set_visible_column "void gtk_tree_model_filter_set_visible_column(GtkTreeModelFilter* filter, \
gint column)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_set_visible_column", "GtkTreeModelFilter*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_tree_model_filter_set_visible_column", "gint");
  gtk_tree_model_filter_set_visible_column(Xen_to_C_GtkTreeModelFilter_(filter), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_filter_get_model(Xen filter)
{
  #define H_gtk_tree_model_filter_get_model "GtkTreeModel* gtk_tree_model_filter_get_model(GtkTreeModelFilter* filter)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_get_model", "GtkTreeModelFilter*");
  return(C_to_Xen_GtkTreeModel_(gtk_tree_model_filter_get_model(Xen_to_C_GtkTreeModelFilter_(filter))));
}

static Xen gxg_gtk_tree_model_filter_convert_iter_to_child_iter(Xen filter, Xen child_iter, Xen filter_iter)
{
  #define H_gtk_tree_model_filter_convert_iter_to_child_iter "void gtk_tree_model_filter_convert_iter_to_child_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* child_iter, GtkTreeIter* filter_iter)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_convert_iter_to_child_iter", "GtkTreeModelFilter*");
  Xen_check_type(Xen_is_GtkTreeIter_(child_iter), child_iter, 2, "gtk_tree_model_filter_convert_iter_to_child_iter", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(filter_iter), filter_iter, 3, "gtk_tree_model_filter_convert_iter_to_child_iter", "GtkTreeIter*");
  gtk_tree_model_filter_convert_iter_to_child_iter(Xen_to_C_GtkTreeModelFilter_(filter), Xen_to_C_GtkTreeIter_(child_iter), 
                                                   Xen_to_C_GtkTreeIter_(filter_iter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_filter_convert_child_path_to_path(Xen filter, Xen child_path)
{
  #define H_gtk_tree_model_filter_convert_child_path_to_path "GtkTreePath* gtk_tree_model_filter_convert_child_path_to_path(GtkTreeModelFilter* filter, \
GtkTreePath* child_path)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_convert_child_path_to_path", "GtkTreeModelFilter*");
  Xen_check_type(Xen_is_GtkTreePath_(child_path), child_path, 2, "gtk_tree_model_filter_convert_child_path_to_path", "GtkTreePath*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_model_filter_convert_child_path_to_path(Xen_to_C_GtkTreeModelFilter_(filter), Xen_to_C_GtkTreePath_(child_path))));
}

static Xen gxg_gtk_tree_model_filter_convert_path_to_child_path(Xen path, Xen filter_path)
{
  #define H_gtk_tree_model_filter_convert_path_to_child_path "GtkTreePath* gtk_tree_model_filter_convert_path_to_child_path(GtkTreeModelFilter* path, \
GtkTreePath* filter_path)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(path), path, 1, "gtk_tree_model_filter_convert_path_to_child_path", "GtkTreeModelFilter*");
  Xen_check_type(Xen_is_GtkTreePath_(filter_path), filter_path, 2, "gtk_tree_model_filter_convert_path_to_child_path", "GtkTreePath*");
  return(C_to_Xen_GtkTreePath_(gtk_tree_model_filter_convert_path_to_child_path(Xen_to_C_GtkTreeModelFilter_(path), Xen_to_C_GtkTreePath_(filter_path))));
}

static Xen gxg_gtk_tree_model_filter_refilter(Xen filter)
{
  #define H_gtk_tree_model_filter_refilter "void gtk_tree_model_filter_refilter(GtkTreeModelFilter* filter)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_refilter", "GtkTreeModelFilter*");
  gtk_tree_model_filter_refilter(Xen_to_C_GtkTreeModelFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_tree_model_filter_clear_cache(Xen filter)
{
  #define H_gtk_tree_model_filter_clear_cache "void gtk_tree_model_filter_clear_cache(GtkTreeModelFilter* filter)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_clear_cache", "GtkTreeModelFilter*");
  gtk_tree_model_filter_clear_cache(Xen_to_C_GtkTreeModelFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_new(void)
{
  #define H_gtk_combo_box_new "GtkWidget* gtk_combo_box_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_combo_box_new()));
}

static Xen gxg_gtk_combo_box_new_with_model(Xen model)
{
  #define H_gtk_combo_box_new_with_model "GtkWidget* gtk_combo_box_new_with_model(GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 1, "gtk_combo_box_new_with_model", "GtkTreeModel*");
  return(C_to_Xen_GtkWidget_(gtk_combo_box_new_with_model(Xen_to_C_GtkTreeModel_(model))));
}

static Xen gxg_gtk_combo_box_set_model(Xen combo_box, Xen model)
{
  #define H_gtk_combo_box_set_model "void gtk_combo_box_set_model(GtkComboBox* combo_box, GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_model", "GtkComboBox*");
  Xen_check_type(Xen_is_GtkTreeModel_(model) || Xen_is_false(model), model, 2, "gtk_combo_box_set_model", "GtkTreeModel*");
  gtk_combo_box_set_model(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_GtkTreeModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_set_wrap_width(Xen combo_box, Xen width)
{
  #define H_gtk_combo_box_set_wrap_width "void gtk_combo_box_set_wrap_width(GtkComboBox* combo_box, gint width)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_wrap_width", "GtkComboBox*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_combo_box_set_wrap_width", "gint");
  gtk_combo_box_set_wrap_width(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gint(width));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_set_row_span_column(Xen combo_box, Xen row_span)
{
  #define H_gtk_combo_box_set_row_span_column "void gtk_combo_box_set_row_span_column(GtkComboBox* combo_box, \
gint row_span)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_row_span_column", "GtkComboBox*");
  Xen_check_type(Xen_is_gint(row_span), row_span, 2, "gtk_combo_box_set_row_span_column", "gint");
  gtk_combo_box_set_row_span_column(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gint(row_span));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_set_column_span_column(Xen combo_box, Xen column_span)
{
  #define H_gtk_combo_box_set_column_span_column "void gtk_combo_box_set_column_span_column(GtkComboBox* combo_box, \
gint column_span)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_column_span_column", "GtkComboBox*");
  Xen_check_type(Xen_is_gint(column_span), column_span, 2, "gtk_combo_box_set_column_span_column", "gint");
  gtk_combo_box_set_column_span_column(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gint(column_span));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_active(Xen combo_box)
{
  #define H_gtk_combo_box_get_active "gint gtk_combo_box_get_active(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_active", "GtkComboBox*");
  return(C_to_Xen_gint(gtk_combo_box_get_active(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_combo_box_set_active(Xen combo_box, Xen index)
{
  #define H_gtk_combo_box_set_active "void gtk_combo_box_set_active(GtkComboBox* combo_box, gint index)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_active", "GtkComboBox*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_combo_box_set_active", "gint");
  gtk_combo_box_set_active(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gint(index));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_active_iter(Xen combo_box, Xen iter)
{
  #define H_gtk_combo_box_get_active_iter "gboolean gtk_combo_box_get_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_active_iter", "GtkComboBox*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_combo_box_get_active_iter", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_combo_box_get_active_iter(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_combo_box_set_active_iter(Xen combo_box, Xen iter)
{
  #define H_gtk_combo_box_set_active_iter "void gtk_combo_box_set_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_active_iter", "GtkComboBox*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_combo_box_set_active_iter", "GtkTreeIter*");
  gtk_combo_box_set_active_iter(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_GtkTreeIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_model(Xen combo_box)
{
  #define H_gtk_combo_box_get_model "GtkTreeModel* gtk_combo_box_get_model(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_model", "GtkComboBox*");
  return(C_to_Xen_GtkTreeModel_(gtk_combo_box_get_model(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_expander_new(Xen label)
{
  #define H_gtk_expander_new "GtkWidget* gtk_expander_new(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_expander_new", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_expander_new(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_expander_new_with_mnemonic(Xen label)
{
  #define H_gtk_expander_new_with_mnemonic "GtkWidget* gtk_expander_new_with_mnemonic(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_expander_new_with_mnemonic", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_expander_new_with_mnemonic(Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_expander_set_expanded(Xen expander, Xen expanded)
{
  #define H_gtk_expander_set_expanded "void gtk_expander_set_expanded(GtkExpander* expander, gboolean expanded)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_expanded", "GtkExpander*");
  Xen_check_type(Xen_is_gboolean(expanded), expanded, 2, "gtk_expander_set_expanded", "gboolean");
  gtk_expander_set_expanded(Xen_to_C_GtkExpander_(expander), Xen_to_C_gboolean(expanded));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_expanded(Xen expander)
{
  #define H_gtk_expander_get_expanded "gboolean gtk_expander_get_expanded(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_expanded", "GtkExpander*");
  return(C_to_Xen_gboolean(gtk_expander_get_expanded(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_expander_set_label(Xen expander, Xen label)
{
  #define H_gtk_expander_set_label "void gtk_expander_set_label(GtkExpander* expander, gchar* label)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_label", "GtkExpander*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_expander_set_label", "gchar*");
  gtk_expander_set_label(Xen_to_C_GtkExpander_(expander), Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_label(Xen expander)
{
  #define H_gtk_expander_get_label "gchar* gtk_expander_get_label(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_label", "GtkExpander*");
  return(C_to_Xen_gchar_(gtk_expander_get_label(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_expander_set_use_underline(Xen expander, Xen use_underline)
{
  #define H_gtk_expander_set_use_underline "void gtk_expander_set_use_underline(GtkExpander* expander, \
gboolean use_underline)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_use_underline", "GtkExpander*");
  Xen_check_type(Xen_is_gboolean(use_underline), use_underline, 2, "gtk_expander_set_use_underline", "gboolean");
  gtk_expander_set_use_underline(Xen_to_C_GtkExpander_(expander), Xen_to_C_gboolean(use_underline));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_use_underline(Xen expander)
{
  #define H_gtk_expander_get_use_underline "gboolean gtk_expander_get_use_underline(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_use_underline", "GtkExpander*");
  return(C_to_Xen_gboolean(gtk_expander_get_use_underline(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_expander_set_label_widget(Xen expander, Xen label_widget)
{
  #define H_gtk_expander_set_label_widget "void gtk_expander_set_label_widget(GtkExpander* expander, \
GtkWidget* label_widget)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_label_widget", "GtkExpander*");
  Xen_check_type(Xen_is_GtkWidget_(label_widget), label_widget, 2, "gtk_expander_set_label_widget", "GtkWidget*");
  gtk_expander_set_label_widget(Xen_to_C_GtkExpander_(expander), Xen_to_C_GtkWidget_(label_widget));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_label_widget(Xen expander)
{
  #define H_gtk_expander_get_label_widget "GtkWidget* gtk_expander_get_label_widget(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_label_widget", "GtkExpander*");
  return(C_to_Xen_GtkWidget_(gtk_expander_get_label_widget(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_expander_set_use_markup(Xen expander, Xen use_markup)
{
  #define H_gtk_expander_set_use_markup "void gtk_expander_set_use_markup(GtkExpander* expander, gboolean use_markup)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_use_markup", "GtkExpander*");
  Xen_check_type(Xen_is_gboolean(use_markup), use_markup, 2, "gtk_expander_set_use_markup", "gboolean");
  gtk_expander_set_use_markup(Xen_to_C_GtkExpander_(expander), Xen_to_C_gboolean(use_markup));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_use_markup(Xen expander)
{
  #define H_gtk_expander_get_use_markup "gboolean gtk_expander_get_use_markup(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_use_markup", "GtkExpander*");
  return(C_to_Xen_gboolean(gtk_expander_get_use_markup(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_font_button_new(void)
{
  #define H_gtk_font_button_new "GtkWidget* gtk_font_button_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_font_button_new()));
}

static Xen gxg_gtk_font_button_new_with_font(Xen fontname)
{
  #define H_gtk_font_button_new_with_font "GtkWidget* gtk_font_button_new_with_font(gchar* fontname)"
  Xen_check_type(Xen_is_gchar_(fontname), fontname, 1, "gtk_font_button_new_with_font", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_font_button_new_with_font(Xen_to_C_gchar_(fontname))));
}

static Xen gxg_gtk_font_button_get_title(Xen font_button)
{
  #define H_gtk_font_button_get_title "gchar* gtk_font_button_get_title(GtkFontButton* font_button)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_get_title", "GtkFontButton*");
  return(C_to_Xen_gchar_(gtk_font_button_get_title(Xen_to_C_GtkFontButton_(font_button))));
}

static Xen gxg_gtk_font_button_set_title(Xen font_button, Xen title)
{
  #define H_gtk_font_button_set_title "void gtk_font_button_set_title(GtkFontButton* font_button, gchar* title)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_set_title", "GtkFontButton*");
  Xen_check_type(Xen_is_gchar_(title), title, 2, "gtk_font_button_set_title", "gchar*");
  gtk_font_button_set_title(Xen_to_C_GtkFontButton_(font_button), Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gtk_font_button_get_use_font(Xen font_button)
{
  #define H_gtk_font_button_get_use_font "gboolean gtk_font_button_get_use_font(GtkFontButton* font_button)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_get_use_font", "GtkFontButton*");
  return(C_to_Xen_gboolean(gtk_font_button_get_use_font(Xen_to_C_GtkFontButton_(font_button))));
}

static Xen gxg_gtk_font_button_set_use_font(Xen font_button, Xen use_font)
{
  #define H_gtk_font_button_set_use_font "void gtk_font_button_set_use_font(GtkFontButton* font_button, \
gboolean use_font)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_set_use_font", "GtkFontButton*");
  Xen_check_type(Xen_is_gboolean(use_font), use_font, 2, "gtk_font_button_set_use_font", "gboolean");
  gtk_font_button_set_use_font(Xen_to_C_GtkFontButton_(font_button), Xen_to_C_gboolean(use_font));
  return(Xen_false);
}

static Xen gxg_gtk_font_button_get_use_size(Xen font_button)
{
  #define H_gtk_font_button_get_use_size "gboolean gtk_font_button_get_use_size(GtkFontButton* font_button)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_get_use_size", "GtkFontButton*");
  return(C_to_Xen_gboolean(gtk_font_button_get_use_size(Xen_to_C_GtkFontButton_(font_button))));
}

static Xen gxg_gtk_font_button_set_use_size(Xen font_button, Xen use_size)
{
  #define H_gtk_font_button_set_use_size "void gtk_font_button_set_use_size(GtkFontButton* font_button, \
gboolean use_size)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_set_use_size", "GtkFontButton*");
  Xen_check_type(Xen_is_gboolean(use_size), use_size, 2, "gtk_font_button_set_use_size", "gboolean");
  gtk_font_button_set_use_size(Xen_to_C_GtkFontButton_(font_button), Xen_to_C_gboolean(use_size));
  return(Xen_false);
}

static Xen gxg_gtk_font_button_get_show_style(Xen font_button)
{
  #define H_gtk_font_button_get_show_style "gboolean gtk_font_button_get_show_style(GtkFontButton* font_button)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_get_show_style", "GtkFontButton*");
  return(C_to_Xen_gboolean(gtk_font_button_get_show_style(Xen_to_C_GtkFontButton_(font_button))));
}

static Xen gxg_gtk_font_button_set_show_style(Xen font_button, Xen show_style)
{
  #define H_gtk_font_button_set_show_style "void gtk_font_button_set_show_style(GtkFontButton* font_button, \
gboolean show_style)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_set_show_style", "GtkFontButton*");
  Xen_check_type(Xen_is_gboolean(show_style), show_style, 2, "gtk_font_button_set_show_style", "gboolean");
  gtk_font_button_set_show_style(Xen_to_C_GtkFontButton_(font_button), Xen_to_C_gboolean(show_style));
  return(Xen_false);
}

static Xen gxg_gtk_font_button_get_show_size(Xen font_button)
{
  #define H_gtk_font_button_get_show_size "gboolean gtk_font_button_get_show_size(GtkFontButton* font_button)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_get_show_size", "GtkFontButton*");
  return(C_to_Xen_gboolean(gtk_font_button_get_show_size(Xen_to_C_GtkFontButton_(font_button))));
}

static Xen gxg_gtk_font_button_set_show_size(Xen font_button, Xen show_size)
{
  #define H_gtk_font_button_set_show_size "void gtk_font_button_set_show_size(GtkFontButton* font_button, \
gboolean show_size)"
  Xen_check_type(Xen_is_GtkFontButton_(font_button), font_button, 1, "gtk_font_button_set_show_size", "GtkFontButton*");
  Xen_check_type(Xen_is_gboolean(show_size), show_size, 2, "gtk_font_button_set_show_size", "gboolean");
  gtk_font_button_set_show_size(Xen_to_C_GtkFontButton_(font_button), Xen_to_C_gboolean(show_size));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_new(void)
{
  #define H_gtk_entry_completion_new "GtkEntryCompletion* gtk_entry_completion_new( void)"
  return(C_to_Xen_GtkEntryCompletion_(gtk_entry_completion_new()));
}

static Xen gxg_gtk_entry_completion_get_entry(Xen entry)
{
  #define H_gtk_entry_completion_get_entry "GtkWidget* gtk_entry_completion_get_entry(GtkEntryCompletion* entry)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(entry), entry, 1, "gtk_entry_completion_get_entry", "GtkEntryCompletion*");
  return(C_to_Xen_GtkWidget_(gtk_entry_completion_get_entry(Xen_to_C_GtkEntryCompletion_(entry))));
}

static Xen gxg_gtk_entry_completion_set_model(Xen completion, Xen model)
{
  #define H_gtk_entry_completion_set_model "void gtk_entry_completion_set_model(GtkEntryCompletion* completion, \
GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_model", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_GtkTreeModel_(model) || Xen_is_false(model), model, 2, "gtk_entry_completion_set_model", "GtkTreeModel*");
  gtk_entry_completion_set_model(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_GtkTreeModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_model(Xen completion)
{
  #define H_gtk_entry_completion_get_model "GtkTreeModel* gtk_entry_completion_get_model(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_model", "GtkEntryCompletion*");
  return(C_to_Xen_GtkTreeModel_(gtk_entry_completion_get_model(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_completion_set_match_func(Xen completion, Xen func, Xen func_info, Xen func_notify)
{
  #define H_gtk_entry_completion_set_match_func "void gtk_entry_completion_set_match_func(GtkEntryCompletion* completion, \
GtkEntryCompletionMatchFunc func, lambda_data func_info, GtkDestroyNotify func_notify)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_match_func", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_GtkEntryCompletionMatchFunc(func), func, 2, "gtk_entry_completion_set_match_func", "GtkEntryCompletionMatchFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_entry_completion_set_match_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(func_notify), func_notify, 4, "gtk_entry_completion_set_match_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, func_notify);
    gtk_entry_completion_set_match_func(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_GtkEntryCompletionMatchFunc(func), 
                                    Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(func_notify));
    return(Xen_false);
   }
}

static Xen gxg_gtk_entry_completion_set_minimum_key_length(Xen completion, Xen length)
{
  #define H_gtk_entry_completion_set_minimum_key_length "void gtk_entry_completion_set_minimum_key_length(GtkEntryCompletion* completion, \
gint length)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_minimum_key_length", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gint(length), length, 2, "gtk_entry_completion_set_minimum_key_length", "gint");
  gtk_entry_completion_set_minimum_key_length(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gint(length));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_minimum_key_length(Xen completion)
{
  #define H_gtk_entry_completion_get_minimum_key_length "gint gtk_entry_completion_get_minimum_key_length(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_minimum_key_length", "GtkEntryCompletion*");
  return(C_to_Xen_gint(gtk_entry_completion_get_minimum_key_length(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_completion_complete(Xen completion)
{
  #define H_gtk_entry_completion_complete "void gtk_entry_completion_complete(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_complete", "GtkEntryCompletion*");
  gtk_entry_completion_complete(Xen_to_C_GtkEntryCompletion_(completion));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_insert_action_text(Xen completion, Xen index, Xen text)
{
  #define H_gtk_entry_completion_insert_action_text "void gtk_entry_completion_insert_action_text(GtkEntryCompletion* completion, \
gint index, gchar* text)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_insert_action_text", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_entry_completion_insert_action_text", "gint");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_entry_completion_insert_action_text", "gchar*");
  gtk_entry_completion_insert_action_text(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gint(index), Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_insert_action_markup(Xen completion, Xen index, Xen markup)
{
  #define H_gtk_entry_completion_insert_action_markup "void gtk_entry_completion_insert_action_markup(GtkEntryCompletion* completion, \
gint index, gchar* markup)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_insert_action_markup", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_entry_completion_insert_action_markup", "gint");
  Xen_check_type(Xen_is_gchar_(markup), markup, 3, "gtk_entry_completion_insert_action_markup", "gchar*");
  gtk_entry_completion_insert_action_markup(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gint(index), Xen_to_C_gchar_(markup));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_delete_action(Xen completion, Xen index)
{
  #define H_gtk_entry_completion_delete_action "void gtk_entry_completion_delete_action(GtkEntryCompletion* completion, \
gint index)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_delete_action", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gint(index), index, 2, "gtk_entry_completion_delete_action", "gint");
  gtk_entry_completion_delete_action(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gint(index));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_set_text_column(Xen completion, Xen column)
{
  #define H_gtk_entry_completion_set_text_column "void gtk_entry_completion_set_text_column(GtkEntryCompletion* completion, \
gint column)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_text_column", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_entry_completion_set_text_column", "gint");
  gtk_entry_completion_set_text_column(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_radio_tool_button_new(Xen group)
{
  #define H_gtk_radio_tool_button_new "GtkToolItem* gtk_radio_tool_button_new(GSList* group)"
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 1, "gtk_radio_tool_button_new", "GSList*");
  return(C_to_Xen_GtkToolItem_(gtk_radio_tool_button_new(Xen_to_C_GSList_(group))));
}

static Xen gxg_gtk_radio_tool_button_new_from_widget(Xen group)
{
  #define H_gtk_radio_tool_button_new_from_widget "GtkToolItem* gtk_radio_tool_button_new_from_widget(GtkRadioToolButton* group)"
  Xen_check_type(Xen_is_GtkRadioToolButton_(group), group, 1, "gtk_radio_tool_button_new_from_widget", "GtkRadioToolButton*");
  return(C_to_Xen_GtkToolItem_(gtk_radio_tool_button_new_from_widget(Xen_to_C_GtkRadioToolButton_(group))));
}

static Xen gxg_gtk_radio_tool_button_get_group(Xen button)
{
  #define H_gtk_radio_tool_button_get_group "GSList* gtk_radio_tool_button_get_group(GtkRadioToolButton* button)"
  Xen_check_type(Xen_is_GtkRadioToolButton_(button), button, 1, "gtk_radio_tool_button_get_group", "GtkRadioToolButton*");
  return(C_to_Xen_GSList_(gtk_radio_tool_button_get_group(Xen_to_C_GtkRadioToolButton_(button))));
}

static Xen gxg_gtk_radio_tool_button_set_group(Xen button, Xen group)
{
  #define H_gtk_radio_tool_button_set_group "void gtk_radio_tool_button_set_group(GtkRadioToolButton* button, \
GSList* group)"
  Xen_check_type(Xen_is_GtkRadioToolButton_(button), button, 1, "gtk_radio_tool_button_set_group", "GtkRadioToolButton*");
  Xen_check_type(Xen_is_GSList_(group) || Xen_is_false(group), group, 2, "gtk_radio_tool_button_set_group", "GSList*");
  gtk_radio_tool_button_set_group(Xen_to_C_GtkRadioToolButton_(button), Xen_to_C_GSList_(group));
  return(Xen_false);
}

static Xen gxg_gtk_separator_tool_item_new(void)
{
  #define H_gtk_separator_tool_item_new "GtkToolItem* gtk_separator_tool_item_new( void)"
  return(C_to_Xen_GtkToolItem_(gtk_separator_tool_item_new()));
}

static Xen gxg_gtk_separator_tool_item_get_draw(Xen item)
{
  #define H_gtk_separator_tool_item_get_draw "gboolean gtk_separator_tool_item_get_draw(GtkSeparatorToolItem* item)"
  Xen_check_type(Xen_is_GtkSeparatorToolItem_(item), item, 1, "gtk_separator_tool_item_get_draw", "GtkSeparatorToolItem*");
  return(C_to_Xen_gboolean(gtk_separator_tool_item_get_draw(Xen_to_C_GtkSeparatorToolItem_(item))));
}

static Xen gxg_gtk_separator_tool_item_set_draw(Xen tool_item, Xen draw)
{
  #define H_gtk_separator_tool_item_set_draw "void gtk_separator_tool_item_set_draw(GtkSeparatorToolItem* tool_item, \
gboolean draw)"
  Xen_check_type(Xen_is_GtkSeparatorToolItem_(tool_item), tool_item, 1, "gtk_separator_tool_item_set_draw", "GtkSeparatorToolItem*");
  Xen_check_type(Xen_is_gboolean(draw), draw, 2, "gtk_separator_tool_item_set_draw", "gboolean");
  gtk_separator_tool_item_set_draw(Xen_to_C_GtkSeparatorToolItem_(tool_item), Xen_to_C_gboolean(draw));
  return(Xen_false);
}

static Xen gxg_gtk_toggle_tool_button_new(void)
{
  #define H_gtk_toggle_tool_button_new "GtkToolItem* gtk_toggle_tool_button_new( void)"
  return(C_to_Xen_GtkToolItem_(gtk_toggle_tool_button_new()));
}

static Xen gxg_gtk_toggle_tool_button_set_active(Xen button, Xen is_active)
{
  #define H_gtk_toggle_tool_button_set_active "void gtk_toggle_tool_button_set_active(GtkToggleToolButton* button, \
gboolean is_active)"
  Xen_check_type(Xen_is_GtkToggleToolButton_(button), button, 1, "gtk_toggle_tool_button_set_active", "GtkToggleToolButton*");
  Xen_check_type(Xen_is_gboolean(is_active), is_active, 2, "gtk_toggle_tool_button_set_active", "gboolean");
  gtk_toggle_tool_button_set_active(Xen_to_C_GtkToggleToolButton_(button), Xen_to_C_gboolean(is_active));
  return(Xen_false);
}

static Xen gxg_gtk_toggle_tool_button_get_active(Xen button)
{
  #define H_gtk_toggle_tool_button_get_active "gboolean gtk_toggle_tool_button_get_active(GtkToggleToolButton* button)"
  Xen_check_type(Xen_is_GtkToggleToolButton_(button), button, 1, "gtk_toggle_tool_button_get_active", "GtkToggleToolButton*");
  return(C_to_Xen_gboolean(gtk_toggle_tool_button_get_active(Xen_to_C_GtkToggleToolButton_(button))));
}

static Xen gxg_g_timeout_add_full(Xen priority, Xen interval, Xen func, Xen func_info, Xen notify)
{
  #define H_g_timeout_add_full "guint g_timeout_add_full(gint priority, guint interval, GSourceFunc func, \
lambda_data func_info, GtkDestroyNotify notify)"
  Xen_check_type(Xen_is_gint(priority), priority, 1, "g_timeout_add_full", "gint");
  Xen_check_type(Xen_is_guint(interval), interval, 2, "g_timeout_add_full", "guint");
  Xen_check_type(Xen_is_GSourceFunc(func), func, 3, "g_timeout_add_full", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "g_timeout_add_full", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(notify), notify, 5, "g_timeout_add_full", "GtkDestroyNotify");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    Xen_list_set(gxg_ptr, 3, notify);
    result = C_to_Xen_guint(g_timeout_add_full(Xen_to_C_gint(priority), Xen_to_C_guint(interval), Xen_to_C_GSourceFunc(func), 
                                               Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(notify)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_g_timeout_add(Xen interval, Xen func, Xen func_info)
{
  #define H_g_timeout_add "guint g_timeout_add(guint interval, GSourceFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_guint(interval), interval, 1, "g_timeout_add", "guint");
  Xen_check_type(Xen_is_GSourceFunc(func), func, 2, "g_timeout_add", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "g_timeout_add", "lambda_data");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(g_timeout_add(Xen_to_C_guint(interval), Xen_to_C_GSourceFunc(func), Xen_to_C_lambda_data(func_info)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_g_idle_add(Xen func, Xen func_info)
{
  #define H_g_idle_add "guint g_idle_add(GSourceFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_GSourceFunc(func), func, 1, "g_idle_add", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 2, "g_idle_add", "lambda_data");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(g_idle_add(Xen_to_C_GSourceFunc(func), Xen_to_C_lambda_data(func_info)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_g_idle_add_full(Xen priority, Xen func, Xen func_info, Xen notify)
{
  #define H_g_idle_add_full "guint g_idle_add_full(gint priority, GSourceFunc func, lambda_data func_info, \
GtkDestroyNotify notify)"
  Xen_check_type(Xen_is_gint(priority), priority, 1, "g_idle_add_full", "gint");
  Xen_check_type(Xen_is_GSourceFunc(func), func, 2, "g_idle_add_full", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "g_idle_add_full", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(notify), notify, 4, "g_idle_add_full", "GtkDestroyNotify");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    Xen_list_set(gxg_ptr, 3, notify);
    result = C_to_Xen_guint(g_idle_add_full(Xen_to_C_gint(priority), Xen_to_C_GSourceFunc(func), Xen_to_C_lambda_data(func_info), 
                                            Xen_to_C_GtkDestroyNotify(notify)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_g_idle_remove_by_data(Xen data)
{
  #define H_g_idle_remove_by_data "gboolean g_idle_remove_by_data(gpointer data)"
  Xen_check_type(Xen_is_gpointer(data), data, 1, "g_idle_remove_by_data", "gpointer");
  xm_unprotect_at(Xen_integer_to_C_int(Xen_caddr(data)));
  return(C_to_Xen_gboolean(g_idle_remove_by_data(Xen_to_C_gpointer(data))));
}

static Xen gxg_g_source_remove(Xen tag)
{
  #define H_g_source_remove "gboolean g_source_remove(guint tag)"
  Xen_check_type(Xen_is_guint(tag), tag, 1, "g_source_remove", "guint");
  xm_unprotect_at(Xen_integer_to_C_int(Xen_caddr(tag)));
  return(C_to_Xen_gboolean(g_source_remove(Xen_to_C_guint(tag))));
}

static Xen gxg_gtk_file_filter_new(void)
{
  #define H_gtk_file_filter_new "GtkFileFilter* gtk_file_filter_new( void)"
  return(C_to_Xen_GtkFileFilter_(gtk_file_filter_new()));
}

static Xen gxg_gtk_file_filter_set_name(Xen filter, Xen name)
{
  #define H_gtk_file_filter_set_name "void gtk_file_filter_set_name(GtkFileFilter* filter, gchar* name)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_set_name", "GtkFileFilter*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_file_filter_set_name", "gchar*");
  gtk_file_filter_set_name(Xen_to_C_GtkFileFilter_(filter), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_file_filter_get_name(Xen filter)
{
  #define H_gtk_file_filter_get_name "gchar* gtk_file_filter_get_name(GtkFileFilter* filter)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_get_name", "GtkFileFilter*");
  return(C_to_Xen_gchar_(gtk_file_filter_get_name(Xen_to_C_GtkFileFilter_(filter))));
}

static Xen gxg_gtk_file_filter_add_mime_type(Xen filter, Xen mime_type)
{
  #define H_gtk_file_filter_add_mime_type "void gtk_file_filter_add_mime_type(GtkFileFilter* filter, \
gchar* mime_type)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_add_mime_type", "GtkFileFilter*");
  Xen_check_type(Xen_is_gchar_(mime_type), mime_type, 2, "gtk_file_filter_add_mime_type", "gchar*");
  gtk_file_filter_add_mime_type(Xen_to_C_GtkFileFilter_(filter), Xen_to_C_gchar_(mime_type));
  return(Xen_false);
}

static Xen gxg_gtk_file_filter_add_pattern(Xen filter, Xen pattern)
{
  #define H_gtk_file_filter_add_pattern "void gtk_file_filter_add_pattern(GtkFileFilter* filter, gchar* pattern)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_add_pattern", "GtkFileFilter*");
  Xen_check_type(Xen_is_gchar_(pattern), pattern, 2, "gtk_file_filter_add_pattern", "gchar*");
  gtk_file_filter_add_pattern(Xen_to_C_GtkFileFilter_(filter), Xen_to_C_gchar_(pattern));
  return(Xen_false);
}

static Xen gxg_gtk_file_filter_add_custom(Xen filter, Xen needed, Xen func, Xen func_info, Xen notify)
{
  #define H_gtk_file_filter_add_custom "void gtk_file_filter_add_custom(GtkFileFilter* filter, GtkFileFilterFlags needed, \
GtkFileFilterFunc func, lambda_data func_info, GtkDestroyNotify notify)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_add_custom", "GtkFileFilter*");
  Xen_check_type(Xen_is_GtkFileFilterFlags(needed), needed, 2, "gtk_file_filter_add_custom", "GtkFileFilterFlags");
  Xen_check_type(Xen_is_GtkFileFilterFunc(func), func, 3, "gtk_file_filter_add_custom", "GtkFileFilterFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "gtk_file_filter_add_custom", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(notify), notify, 5, "gtk_file_filter_add_custom", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, notify);
    gtk_file_filter_add_custom(Xen_to_C_GtkFileFilter_(filter), Xen_to_C_GtkFileFilterFlags(needed), Xen_to_C_GtkFileFilterFunc(func), 
                           Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(notify));
    return(Xen_false);
   }
}

static Xen gxg_gtk_file_filter_get_needed(Xen filter)
{
  #define H_gtk_file_filter_get_needed "GtkFileFilterFlags gtk_file_filter_get_needed(GtkFileFilter* filter)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_get_needed", "GtkFileFilter*");
  return(C_to_Xen_GtkFileFilterFlags(gtk_file_filter_get_needed(Xen_to_C_GtkFileFilter_(filter))));
}

static Xen gxg_gtk_file_filter_filter(Xen filter, Xen filter_info)
{
  #define H_gtk_file_filter_filter "gboolean gtk_file_filter_filter(GtkFileFilter* filter, GtkFileFilterInfo* filter_info)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_filter", "GtkFileFilter*");
  Xen_check_type(Xen_is_GtkFileFilterInfo_(filter_info), filter_info, 2, "gtk_file_filter_filter", "GtkFileFilterInfo*");
  return(C_to_Xen_gboolean(gtk_file_filter_filter(Xen_to_C_GtkFileFilter_(filter), Xen_to_C_GtkFileFilterInfo_(filter_info))));
}

static Xen gxg_gtk_cell_layout_pack_start(Xen cell_layout, Xen cell, Xen expand)
{
  #define H_gtk_cell_layout_pack_start "void gtk_cell_layout_pack_start(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_pack_start", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_pack_start", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 3, "gtk_cell_layout_pack_start", "gboolean");
  gtk_cell_layout_pack_start(Xen_to_C_GtkCellLayout_(cell_layout), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_cell_layout_pack_end(Xen cell_layout, Xen cell, Xen expand)
{
  #define H_gtk_cell_layout_pack_end "void gtk_cell_layout_pack_end(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_pack_end", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_pack_end", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 3, "gtk_cell_layout_pack_end", "gboolean");
  gtk_cell_layout_pack_end(Xen_to_C_GtkCellLayout_(cell_layout), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_cell_layout_clear(Xen cell_layout)
{
  #define H_gtk_cell_layout_clear "void gtk_cell_layout_clear(GtkCellLayout* cell_layout)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_clear", "GtkCellLayout*");
  gtk_cell_layout_clear(Xen_to_C_GtkCellLayout_(cell_layout));
  return(Xen_false);
}

static Xen gxg_gtk_cell_layout_set_attributes(Xen cell_layout, Xen cell, Xen attributes)
{
  #define H_gtk_cell_layout_set_attributes "void gtk_cell_layout_set_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, etc attributes)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_set_attributes", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_set_attributes", "GtkCellRenderer*");
  Xen_check_type(Xen_is_etc(attributes), attributes, 3, "gtk_cell_layout_set_attributes", "etc");
  {
    int etc_len = 0;
    GtkCellLayout* p_arg0;
    GtkCellRenderer* p_arg1;
    if (Xen_is_list(attributes)) etc_len = Xen_list_length(attributes);
    if (etc_len < 2) Xen_out_of_range_error("gtk_cell_layout_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) Xen_out_of_range_error("gtk_cell_layout_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) Xen_out_of_range_error("gtk_cell_layout_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = Xen_to_C_GtkCellLayout_(cell_layout);
    p_arg1 = Xen_to_C_GtkCellRenderer_(cell);
    switch (etc_len)
      {
        case 2: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), NULL); break;
        case 4: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), NULL); break;
        case 6: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), NULL); break;
        case 8: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), NULL); break;
        case 10: gtk_cell_layout_set_attributes(p_arg0, p_arg1, XLS(attributes, 0), XLI(attributes, 1), XLS(attributes, 2), XLI(attributes, 3), XLS(attributes, 4), XLI(attributes, 5), XLS(attributes, 6), XLI(attributes, 7), XLS(attributes, 8), XLI(attributes, 9), NULL); break;
      }
    return(Xen_false);
  }
}

static Xen gxg_gtk_cell_layout_add_attribute(Xen cell_layout, Xen cell, Xen attribute, Xen column)
{
  #define H_gtk_cell_layout_add_attribute "void gtk_cell_layout_add_attribute(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, gchar* attribute, gint column)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_add_attribute", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_add_attribute", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gchar_(attribute), attribute, 3, "gtk_cell_layout_add_attribute", "gchar*");
  Xen_check_type(Xen_is_gint(column), column, 4, "gtk_cell_layout_add_attribute", "gint");
  gtk_cell_layout_add_attribute(Xen_to_C_GtkCellLayout_(cell_layout), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gchar_(attribute), 
                                Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_cell_layout_set_cell_data_func(Xen cell_layout, Xen cell, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_cell_layout_set_cell_data_func "void gtk_cell_layout_set_cell_data_func(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, GtkCellLayoutDataFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_set_cell_data_func", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_set_cell_data_func", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkCellLayoutDataFunc(func), func, 3, "gtk_cell_layout_set_cell_data_func", "GtkCellLayoutDataFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "gtk_cell_layout_set_cell_data_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 5, "gtk_cell_layout_set_cell_data_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_cell_layout_set_cell_data_func(Xen_to_C_GtkCellLayout_(cell_layout), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GtkCellLayoutDataFunc(func), 
                                   Xen_to_C_lambda_data(func_info), Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_cell_layout_clear_attributes(Xen cell_layout, Xen cell)
{
  #define H_gtk_cell_layout_clear_attributes "void gtk_cell_layout_clear_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_clear_attributes", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_clear_attributes", "GtkCellRenderer*");
  gtk_cell_layout_clear_attributes(Xen_to_C_GtkCellLayout_(cell_layout), Xen_to_C_GtkCellRenderer_(cell));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_set_action(Xen chooser, Xen action)
{
  #define H_gtk_file_chooser_set_action "void gtk_file_chooser_set_action(GtkFileChooser* chooser, GtkFileChooserAction action)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_action", "GtkFileChooser*");
  Xen_check_type(Xen_is_GtkFileChooserAction(action), action, 2, "gtk_file_chooser_set_action", "GtkFileChooserAction");
  gtk_file_chooser_set_action(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GtkFileChooserAction(action));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_action(Xen chooser)
{
  #define H_gtk_file_chooser_get_action "GtkFileChooserAction gtk_file_chooser_get_action(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_action", "GtkFileChooser*");
  return(C_to_Xen_GtkFileChooserAction(gtk_file_chooser_get_action(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_local_only(Xen chooser, Xen files_only)
{
  #define H_gtk_file_chooser_set_local_only "void gtk_file_chooser_set_local_only(GtkFileChooser* chooser, \
gboolean files_only)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_local_only", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(files_only), files_only, 2, "gtk_file_chooser_set_local_only", "gboolean");
  gtk_file_chooser_set_local_only(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(files_only));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_local_only(Xen chooser)
{
  #define H_gtk_file_chooser_get_local_only "gboolean gtk_file_chooser_get_local_only(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_local_only", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_local_only(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_select_multiple(Xen chooser, Xen select_multiple)
{
  #define H_gtk_file_chooser_set_select_multiple "void gtk_file_chooser_set_select_multiple(GtkFileChooser* chooser, \
gboolean select_multiple)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_select_multiple", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(select_multiple), select_multiple, 2, "gtk_file_chooser_set_select_multiple", "gboolean");
  gtk_file_chooser_set_select_multiple(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(select_multiple));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_select_multiple(Xen chooser)
{
  #define H_gtk_file_chooser_get_select_multiple "gboolean gtk_file_chooser_get_select_multiple(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_select_multiple", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_select_multiple(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_current_name(Xen chooser, Xen name)
{
  #define H_gtk_file_chooser_set_current_name "void gtk_file_chooser_set_current_name(GtkFileChooser* chooser, \
gchar* name)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_current_name", "GtkFileChooser*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_file_chooser_set_current_name", "gchar*");
  gtk_file_chooser_set_current_name(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_filename(Xen chooser)
{
  #define H_gtk_file_chooser_get_filename "gchar* gtk_file_chooser_get_filename(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_filename", "GtkFileChooser*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_file_chooser_get_filename(Xen_to_C_GtkFileChooser_(chooser));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_file_chooser_set_filename(Xen chooser, Xen filename)
{
  #define H_gtk_file_chooser_set_filename "gboolean gtk_file_chooser_set_filename(GtkFileChooser* chooser, \
char* filename)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_filename", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(filename), filename, 2, "gtk_file_chooser_set_filename", "char*");
  return(C_to_Xen_gboolean(gtk_file_chooser_set_filename(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(filename))));
}

static Xen gxg_gtk_file_chooser_select_filename(Xen chooser, Xen filename)
{
  #define H_gtk_file_chooser_select_filename "gboolean gtk_file_chooser_select_filename(GtkFileChooser* chooser, \
char* filename)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_select_filename", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(filename), filename, 2, "gtk_file_chooser_select_filename", "char*");
  return(C_to_Xen_gboolean(gtk_file_chooser_select_filename(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(filename))));
}

static Xen gxg_gtk_file_chooser_unselect_filename(Xen chooser, Xen filename)
{
  #define H_gtk_file_chooser_unselect_filename "void gtk_file_chooser_unselect_filename(GtkFileChooser* chooser, \
char* filename)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_unselect_filename", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(filename), filename, 2, "gtk_file_chooser_unselect_filename", "char*");
  gtk_file_chooser_unselect_filename(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(filename));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_select_all(Xen chooser)
{
  #define H_gtk_file_chooser_select_all "void gtk_file_chooser_select_all(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_select_all", "GtkFileChooser*");
  gtk_file_chooser_select_all(Xen_to_C_GtkFileChooser_(chooser));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_unselect_all(Xen chooser)
{
  #define H_gtk_file_chooser_unselect_all "void gtk_file_chooser_unselect_all(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_unselect_all", "GtkFileChooser*");
  gtk_file_chooser_unselect_all(Xen_to_C_GtkFileChooser_(chooser));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_filenames(Xen chooser)
{
  #define H_gtk_file_chooser_get_filenames "GSList* gtk_file_chooser_get_filenames(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_filenames", "GtkFileChooser*");
  return(C_to_Xen_GSList_(gtk_file_chooser_get_filenames(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_current_folder(Xen chooser, Xen filename)
{
  #define H_gtk_file_chooser_set_current_folder "gboolean gtk_file_chooser_set_current_folder(GtkFileChooser* chooser, \
gchar* filename)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_current_folder", "GtkFileChooser*");
  Xen_check_type(Xen_is_gchar_(filename), filename, 2, "gtk_file_chooser_set_current_folder", "gchar*");
  return(C_to_Xen_gboolean(gtk_file_chooser_set_current_folder(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gchar_(filename))));
}

static Xen gxg_gtk_file_chooser_get_current_folder(Xen chooser)
{
  #define H_gtk_file_chooser_get_current_folder "gchar* gtk_file_chooser_get_current_folder(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_current_folder", "GtkFileChooser*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_file_chooser_get_current_folder(Xen_to_C_GtkFileChooser_(chooser));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_file_chooser_get_uri(Xen chooser)
{
  #define H_gtk_file_chooser_get_uri "gchar* gtk_file_chooser_get_uri(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_uri", "GtkFileChooser*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_file_chooser_get_uri(Xen_to_C_GtkFileChooser_(chooser));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_file_chooser_set_uri(Xen chooser, Xen uri)
{
  #define H_gtk_file_chooser_set_uri "gboolean gtk_file_chooser_set_uri(GtkFileChooser* chooser, char* uri)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_uri", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(uri), uri, 2, "gtk_file_chooser_set_uri", "char*");
  return(C_to_Xen_gboolean(gtk_file_chooser_set_uri(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(uri))));
}

static Xen gxg_gtk_file_chooser_select_uri(Xen chooser, Xen uri)
{
  #define H_gtk_file_chooser_select_uri "gboolean gtk_file_chooser_select_uri(GtkFileChooser* chooser, \
char* uri)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_select_uri", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(uri), uri, 2, "gtk_file_chooser_select_uri", "char*");
  return(C_to_Xen_gboolean(gtk_file_chooser_select_uri(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(uri))));
}

static Xen gxg_gtk_file_chooser_unselect_uri(Xen chooser, Xen uri)
{
  #define H_gtk_file_chooser_unselect_uri "void gtk_file_chooser_unselect_uri(GtkFileChooser* chooser, \
char* uri)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_unselect_uri", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(uri), uri, 2, "gtk_file_chooser_unselect_uri", "char*");
  gtk_file_chooser_unselect_uri(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(uri));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_uris(Xen chooser)
{
  #define H_gtk_file_chooser_get_uris "GSList* gtk_file_chooser_get_uris(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_uris", "GtkFileChooser*");
  return(C_to_Xen_GSList_(gtk_file_chooser_get_uris(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_current_folder_uri(Xen chooser, Xen uri)
{
  #define H_gtk_file_chooser_set_current_folder_uri "gboolean gtk_file_chooser_set_current_folder_uri(GtkFileChooser* chooser, \
gchar* uri)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_current_folder_uri", "GtkFileChooser*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_file_chooser_set_current_folder_uri", "gchar*");
  return(C_to_Xen_gboolean(gtk_file_chooser_set_current_folder_uri(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gchar_(uri))));
}

static Xen gxg_gtk_file_chooser_get_current_folder_uri(Xen chooser)
{
  #define H_gtk_file_chooser_get_current_folder_uri "gchar* gtk_file_chooser_get_current_folder_uri(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_current_folder_uri", "GtkFileChooser*");
  {
   gchar* result;
   Xen rtn;
   result = gtk_file_chooser_get_current_folder_uri(Xen_to_C_GtkFileChooser_(chooser));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_file_chooser_set_preview_widget(Xen chooser, Xen preview_widget)
{
  #define H_gtk_file_chooser_set_preview_widget "void gtk_file_chooser_set_preview_widget(GtkFileChooser* chooser, \
GtkWidget* preview_widget)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_preview_widget", "GtkFileChooser*");
  Xen_check_type(Xen_is_GtkWidget_(preview_widget), preview_widget, 2, "gtk_file_chooser_set_preview_widget", "GtkWidget*");
  gtk_file_chooser_set_preview_widget(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GtkWidget_(preview_widget));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_preview_widget(Xen chooser)
{
  #define H_gtk_file_chooser_get_preview_widget "GtkWidget* gtk_file_chooser_get_preview_widget(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_preview_widget", "GtkFileChooser*");
  return(C_to_Xen_GtkWidget_(gtk_file_chooser_get_preview_widget(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_preview_widget_active(Xen chooser, Xen active)
{
  #define H_gtk_file_chooser_set_preview_widget_active "void gtk_file_chooser_set_preview_widget_active(GtkFileChooser* chooser, \
gboolean active)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_preview_widget_active", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(active), active, 2, "gtk_file_chooser_set_preview_widget_active", "gboolean");
  gtk_file_chooser_set_preview_widget_active(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(active));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_preview_widget_active(Xen chooser)
{
  #define H_gtk_file_chooser_get_preview_widget_active "gboolean gtk_file_chooser_get_preview_widget_active(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_preview_widget_active", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_preview_widget_active(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_get_preview_filename(Xen file_chooser)
{
  #define H_gtk_file_chooser_get_preview_filename "char* gtk_file_chooser_get_preview_filename(GtkFileChooser* file_chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(file_chooser), file_chooser, 1, "gtk_file_chooser_get_preview_filename", "GtkFileChooser*");
  {
   char* result;
   Xen rtn;
   result = gtk_file_chooser_get_preview_filename(Xen_to_C_GtkFileChooser_(file_chooser));
   rtn = C_to_Xen_char_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_file_chooser_get_preview_uri(Xen file_chooser)
{
  #define H_gtk_file_chooser_get_preview_uri "char* gtk_file_chooser_get_preview_uri(GtkFileChooser* file_chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(file_chooser), file_chooser, 1, "gtk_file_chooser_get_preview_uri", "GtkFileChooser*");
  {
   char* result;
   Xen rtn;
   result = gtk_file_chooser_get_preview_uri(Xen_to_C_GtkFileChooser_(file_chooser));
   rtn = C_to_Xen_char_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_file_chooser_set_extra_widget(Xen chooser, Xen extra_widget)
{
  #define H_gtk_file_chooser_set_extra_widget "void gtk_file_chooser_set_extra_widget(GtkFileChooser* chooser, \
GtkWidget* extra_widget)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_extra_widget", "GtkFileChooser*");
  Xen_check_type(Xen_is_GtkWidget_(extra_widget), extra_widget, 2, "gtk_file_chooser_set_extra_widget", "GtkWidget*");
  gtk_file_chooser_set_extra_widget(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GtkWidget_(extra_widget));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_extra_widget(Xen chooser)
{
  #define H_gtk_file_chooser_get_extra_widget "GtkWidget* gtk_file_chooser_get_extra_widget(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_extra_widget", "GtkFileChooser*");
  return(C_to_Xen_GtkWidget_(gtk_file_chooser_get_extra_widget(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_add_filter(Xen chooser, Xen filter)
{
  #define H_gtk_file_chooser_add_filter "void gtk_file_chooser_add_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_add_filter", "GtkFileChooser*");
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 2, "gtk_file_chooser_add_filter", "GtkFileFilter*");
  gtk_file_chooser_add_filter(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GtkFileFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_remove_filter(Xen chooser, Xen filter)
{
  #define H_gtk_file_chooser_remove_filter "void gtk_file_chooser_remove_filter(GtkFileChooser* chooser, \
GtkFileFilter* filter)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_remove_filter", "GtkFileChooser*");
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 2, "gtk_file_chooser_remove_filter", "GtkFileFilter*");
  gtk_file_chooser_remove_filter(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GtkFileFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_list_filters(Xen chooser)
{
  #define H_gtk_file_chooser_list_filters "GSList* gtk_file_chooser_list_filters(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_list_filters", "GtkFileChooser*");
  return(C_to_Xen_GSList_(gtk_file_chooser_list_filters(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_filter(Xen chooser, Xen filter)
{
  #define H_gtk_file_chooser_set_filter "void gtk_file_chooser_set_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_filter", "GtkFileChooser*");
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 2, "gtk_file_chooser_set_filter", "GtkFileFilter*");
  gtk_file_chooser_set_filter(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GtkFileFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_filter(Xen chooser)
{
  #define H_gtk_file_chooser_get_filter "GtkFileFilter* gtk_file_chooser_get_filter(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_filter", "GtkFileChooser*");
  return(C_to_Xen_GtkFileFilter_(gtk_file_chooser_get_filter(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_add_shortcut_folder(Xen chooser, Xen folder, Xen ignore_error)
{
  #define H_gtk_file_chooser_add_shortcut_folder "gboolean gtk_file_chooser_add_shortcut_folder(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_add_shortcut_folder", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(folder), folder, 2, "gtk_file_chooser_add_shortcut_folder", "char*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_add_shortcut_folder(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(folder), 
                                                                    &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_remove_shortcut_folder(Xen chooser, Xen folder, Xen ignore_error)
{
  #define H_gtk_file_chooser_remove_shortcut_folder "gboolean gtk_file_chooser_remove_shortcut_folder(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_remove_shortcut_folder", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(folder), folder, 2, "gtk_file_chooser_remove_shortcut_folder", "char*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_remove_shortcut_folder(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(folder), 
                                                                       &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_list_shortcut_folders(Xen chooser)
{
  #define H_gtk_file_chooser_list_shortcut_folders "GSList* gtk_file_chooser_list_shortcut_folders(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_list_shortcut_folders", "GtkFileChooser*");
  return(C_to_Xen_GSList_(gtk_file_chooser_list_shortcut_folders(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_add_shortcut_folder_uri(Xen chooser, Xen folder, Xen ignore_error)
{
  #define H_gtk_file_chooser_add_shortcut_folder_uri "gboolean gtk_file_chooser_add_shortcut_folder_uri(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_add_shortcut_folder_uri", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(folder), folder, 2, "gtk_file_chooser_add_shortcut_folder_uri", "char*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_add_shortcut_folder_uri(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(folder), 
                                                                        &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_remove_shortcut_folder_uri(Xen chooser, Xen folder, Xen ignore_error)
{
  #define H_gtk_file_chooser_remove_shortcut_folder_uri "gboolean gtk_file_chooser_remove_shortcut_folder_uri(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_remove_shortcut_folder_uri", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(folder), folder, 2, "gtk_file_chooser_remove_shortcut_folder_uri", "char*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_remove_shortcut_folder_uri(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(folder), 
                                                                           &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_list_shortcut_folder_uris(Xen chooser)
{
  #define H_gtk_file_chooser_list_shortcut_folder_uris "GSList* gtk_file_chooser_list_shortcut_folder_uris(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_list_shortcut_folder_uris", "GtkFileChooser*");
  return(C_to_Xen_GSList_(gtk_file_chooser_list_shortcut_folder_uris(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_icon_theme_new(void)
{
  #define H_gtk_icon_theme_new "GtkIconTheme* gtk_icon_theme_new( void)"
  return(C_to_Xen_GtkIconTheme_(gtk_icon_theme_new()));
}

static Xen gxg_gtk_icon_theme_get_default(void)
{
  #define H_gtk_icon_theme_get_default "GtkIconTheme* gtk_icon_theme_get_default( void)"
  return(C_to_Xen_GtkIconTheme_(gtk_icon_theme_get_default()));
}

static Xen gxg_gtk_icon_theme_get_search_path(Xen icon_theme, Xen ignore_path, Xen ignore_n_elements)
{
  #define H_gtk_icon_theme_get_search_path "void gtk_icon_theme_get_search_path(GtkIconTheme* icon_theme, \
gchar*** [path], gint* [n_elements])"
  gchar** ref_path = NULL;
  gint ref_n_elements;
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_get_search_path", "GtkIconTheme*");
  gtk_icon_theme_get_search_path(Xen_to_C_GtkIconTheme_(icon_theme), &ref_path, &ref_n_elements);
  return(Xen_list_2(C_to_Xen_gchar__(ref_path), C_to_Xen_gint(ref_n_elements)));
}

static Xen gxg_gtk_icon_theme_append_search_path(Xen icon_theme, Xen path)
{
  #define H_gtk_icon_theme_append_search_path "void gtk_icon_theme_append_search_path(GtkIconTheme* icon_theme, \
gchar* path)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_append_search_path", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(path), path, 2, "gtk_icon_theme_append_search_path", "gchar*");
  gtk_icon_theme_append_search_path(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(path));
  return(Xen_false);
}

static Xen gxg_gtk_icon_theme_prepend_search_path(Xen icon_theme, Xen path)
{
  #define H_gtk_icon_theme_prepend_search_path "void gtk_icon_theme_prepend_search_path(GtkIconTheme* icon_theme, \
gchar* path)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_prepend_search_path", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(path), path, 2, "gtk_icon_theme_prepend_search_path", "gchar*");
  gtk_icon_theme_prepend_search_path(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(path));
  return(Xen_false);
}

static Xen gxg_gtk_icon_theme_set_custom_theme(Xen icon_theme, Xen theme_name)
{
  #define H_gtk_icon_theme_set_custom_theme "void gtk_icon_theme_set_custom_theme(GtkIconTheme* icon_theme, \
gchar* theme_name)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_set_custom_theme", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(theme_name), theme_name, 2, "gtk_icon_theme_set_custom_theme", "gchar*");
  gtk_icon_theme_set_custom_theme(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(theme_name));
  return(Xen_false);
}

static Xen gxg_gtk_icon_theme_has_icon(Xen icon_theme, Xen icon_name)
{
  #define H_gtk_icon_theme_has_icon "gboolean gtk_icon_theme_has_icon(GtkIconTheme* icon_theme, gchar* icon_name)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_has_icon", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_has_icon", "gchar*");
  return(C_to_Xen_gboolean(gtk_icon_theme_has_icon(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(icon_name))));
}

static Xen gxg_gtk_icon_theme_lookup_icon(Xen icon_theme, Xen icon_name, Xen size, Xen flags)
{
  #define H_gtk_icon_theme_lookup_icon "GtkIconInfo* gtk_icon_theme_lookup_icon(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, GtkIconLookupFlags flags)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_lookup_icon", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_lookup_icon", "gchar*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_lookup_icon", "gint");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 4, "gtk_icon_theme_lookup_icon", "GtkIconLookupFlags");
  return(C_to_Xen_GtkIconInfo_(gtk_icon_theme_lookup_icon(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(icon_name), 
                                                          Xen_to_C_gint(size), Xen_to_C_GtkIconLookupFlags(flags))));
}

static Xen gxg_gtk_icon_theme_load_icon(Xen icon_theme, Xen icon_name, Xen size, Xen flags, Xen ignore_error)
{
  #define H_gtk_icon_theme_load_icon "GdkPixbuf* gtk_icon_theme_load_icon(GtkIconTheme* icon_theme, gchar* icon_name, \
gint size, GtkIconLookupFlags flags, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_load_icon", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_load_icon", "gchar*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_load_icon", "gint");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 4, "gtk_icon_theme_load_icon", "GtkIconLookupFlags");
  {
    Xen result;
    result = C_to_Xen_GdkPixbuf_(gtk_icon_theme_load_icon(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(icon_name), 
                                                          Xen_to_C_gint(size), Xen_to_C_GtkIconLookupFlags(flags), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_icon_theme_list_icons(Xen icon_theme, Xen context)
{
  #define H_gtk_icon_theme_list_icons "GList* gtk_icon_theme_list_icons(GtkIconTheme* icon_theme, gchar* context)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_list_icons", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(context), context, 2, "gtk_icon_theme_list_icons", "gchar*");
  return(C_to_Xen_GList_(gtk_icon_theme_list_icons(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(context))));
}

static Xen gxg_gtk_icon_theme_get_example_icon_name(Xen icon_theme)
{
  #define H_gtk_icon_theme_get_example_icon_name "char* gtk_icon_theme_get_example_icon_name(GtkIconTheme* icon_theme)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_get_example_icon_name", "GtkIconTheme*");
  return(C_to_Xen_char_(gtk_icon_theme_get_example_icon_name(Xen_to_C_GtkIconTheme_(icon_theme))));
}

static Xen gxg_gtk_icon_theme_rescan_if_needed(Xen icon_theme)
{
  #define H_gtk_icon_theme_rescan_if_needed "gboolean gtk_icon_theme_rescan_if_needed(GtkIconTheme* icon_theme)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_rescan_if_needed", "GtkIconTheme*");
  return(C_to_Xen_gboolean(gtk_icon_theme_rescan_if_needed(Xen_to_C_GtkIconTheme_(icon_theme))));
}

static Xen gxg_gtk_icon_info_get_base_size(Xen icon_info)
{
  #define H_gtk_icon_info_get_base_size "gint gtk_icon_info_get_base_size(GtkIconInfo* icon_info)"
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_get_base_size", "GtkIconInfo*");
  return(C_to_Xen_gint(gtk_icon_info_get_base_size(Xen_to_C_GtkIconInfo_(icon_info))));
}

static Xen gxg_gtk_icon_info_get_filename(Xen icon_info)
{
  #define H_gtk_icon_info_get_filename "gchar* gtk_icon_info_get_filename(GtkIconInfo* icon_info)"
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_get_filename", "GtkIconInfo*");
  return(C_to_Xen_gchar_(gtk_icon_info_get_filename(Xen_to_C_GtkIconInfo_(icon_info))));
}

static Xen gxg_gtk_icon_info_load_icon(Xen icon_info, Xen ignore_error)
{
  #define H_gtk_icon_info_load_icon "GdkPixbuf* gtk_icon_info_load_icon(GtkIconInfo* icon_info, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_load_icon", "GtkIconInfo*");
  {
    Xen result;
    result = C_to_Xen_GdkPixbuf_(gtk_icon_info_load_icon(Xen_to_C_GtkIconInfo_(icon_info), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_tool_button_new(Xen icon_widget, Xen label)
{
  #define H_gtk_tool_button_new "GtkToolItem* gtk_tool_button_new(GtkWidget* icon_widget, gchar* label)"
  Xen_check_type(Xen_is_GtkWidget_(icon_widget) || Xen_is_false(icon_widget), icon_widget, 1, "gtk_tool_button_new", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_tool_button_new", "gchar*");
  return(C_to_Xen_GtkToolItem_(gtk_tool_button_new(Xen_to_C_GtkWidget_(icon_widget), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_tool_button_set_label(Xen button, Xen label)
{
  #define H_gtk_tool_button_set_label "void gtk_tool_button_set_label(GtkToolButton* button, gchar* label)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_set_label", "GtkToolButton*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_tool_button_set_label", "gchar*");
  gtk_tool_button_set_label(Xen_to_C_GtkToolButton_(button), Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_tool_button_get_label(Xen button)
{
  #define H_gtk_tool_button_get_label "gchar* gtk_tool_button_get_label(GtkToolButton* button)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_get_label", "GtkToolButton*");
  return(C_to_Xen_gchar_(gtk_tool_button_get_label(Xen_to_C_GtkToolButton_(button))));
}

static Xen gxg_gtk_tool_button_set_use_underline(Xen button, Xen use_underline)
{
  #define H_gtk_tool_button_set_use_underline "void gtk_tool_button_set_use_underline(GtkToolButton* button, \
gboolean use_underline)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_set_use_underline", "GtkToolButton*");
  Xen_check_type(Xen_is_gboolean(use_underline), use_underline, 2, "gtk_tool_button_set_use_underline", "gboolean");
  gtk_tool_button_set_use_underline(Xen_to_C_GtkToolButton_(button), Xen_to_C_gboolean(use_underline));
  return(Xen_false);
}

static Xen gxg_gtk_tool_button_get_use_underline(Xen button)
{
  #define H_gtk_tool_button_get_use_underline "gboolean gtk_tool_button_get_use_underline(GtkToolButton* button)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_get_use_underline", "GtkToolButton*");
  return(C_to_Xen_gboolean(gtk_tool_button_get_use_underline(Xen_to_C_GtkToolButton_(button))));
}

static Xen gxg_gtk_tool_button_set_icon_widget(Xen button, Xen icon_widget)
{
  #define H_gtk_tool_button_set_icon_widget "void gtk_tool_button_set_icon_widget(GtkToolButton* button, \
GtkWidget* icon_widget)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_set_icon_widget", "GtkToolButton*");
  Xen_check_type(Xen_is_GtkWidget_(icon_widget) || Xen_is_false(icon_widget), icon_widget, 2, "gtk_tool_button_set_icon_widget", "GtkWidget*");
  gtk_tool_button_set_icon_widget(Xen_to_C_GtkToolButton_(button), Xen_to_C_GtkWidget_(icon_widget));
  return(Xen_false);
}

static Xen gxg_gtk_tool_button_get_icon_widget(Xen button)
{
  #define H_gtk_tool_button_get_icon_widget "GtkWidget* gtk_tool_button_get_icon_widget(GtkToolButton* button)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_get_icon_widget", "GtkToolButton*");
  return(C_to_Xen_GtkWidget_(gtk_tool_button_get_icon_widget(Xen_to_C_GtkToolButton_(button))));
}

static Xen gxg_gtk_tool_button_set_label_widget(Xen button, Xen label_widget)
{
  #define H_gtk_tool_button_set_label_widget "void gtk_tool_button_set_label_widget(GtkToolButton* button, \
GtkWidget* label_widget)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_set_label_widget", "GtkToolButton*");
  Xen_check_type(Xen_is_GtkWidget_(label_widget) || Xen_is_false(label_widget), label_widget, 2, "gtk_tool_button_set_label_widget", "GtkWidget*");
  gtk_tool_button_set_label_widget(Xen_to_C_GtkToolButton_(button), Xen_to_C_GtkWidget_(label_widget));
  return(Xen_false);
}

static Xen gxg_gtk_tool_button_get_label_widget(Xen button)
{
  #define H_gtk_tool_button_get_label_widget "GtkWidget* gtk_tool_button_get_label_widget(GtkToolButton* button)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_get_label_widget", "GtkToolButton*");
  return(C_to_Xen_GtkWidget_(gtk_tool_button_get_label_widget(Xen_to_C_GtkToolButton_(button))));
}

static Xen gxg_gtk_tool_item_new(void)
{
  #define H_gtk_tool_item_new "GtkToolItem* gtk_tool_item_new( void)"
  return(C_to_Xen_GtkToolItem_(gtk_tool_item_new()));
}

static Xen gxg_gtk_tool_item_set_homogeneous(Xen tool_item, Xen homogeneous)
{
  #define H_gtk_tool_item_set_homogeneous "void gtk_tool_item_set_homogeneous(GtkToolItem* tool_item, \
gboolean homogeneous)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_set_homogeneous", "GtkToolItem*");
  Xen_check_type(Xen_is_gboolean(homogeneous), homogeneous, 2, "gtk_tool_item_set_homogeneous", "gboolean");
  gtk_tool_item_set_homogeneous(Xen_to_C_GtkToolItem_(tool_item), Xen_to_C_gboolean(homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_get_homogeneous(Xen tool_item)
{
  #define H_gtk_tool_item_get_homogeneous "gboolean gtk_tool_item_get_homogeneous(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_homogeneous", "GtkToolItem*");
  return(C_to_Xen_gboolean(gtk_tool_item_get_homogeneous(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_set_expand(Xen tool_item, Xen expand)
{
  #define H_gtk_tool_item_set_expand "void gtk_tool_item_set_expand(GtkToolItem* tool_item, gboolean expand)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_set_expand", "GtkToolItem*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 2, "gtk_tool_item_set_expand", "gboolean");
  gtk_tool_item_set_expand(Xen_to_C_GtkToolItem_(tool_item), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_get_expand(Xen tool_item)
{
  #define H_gtk_tool_item_get_expand "gboolean gtk_tool_item_get_expand(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_expand", "GtkToolItem*");
  return(C_to_Xen_gboolean(gtk_tool_item_get_expand(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_set_visible_horizontal(Xen toolitem, Xen visible_horizontal)
{
  #define H_gtk_tool_item_set_visible_horizontal "void gtk_tool_item_set_visible_horizontal(GtkToolItem* toolitem, \
gboolean visible_horizontal)"
  Xen_check_type(Xen_is_GtkToolItem_(toolitem), toolitem, 1, "gtk_tool_item_set_visible_horizontal", "GtkToolItem*");
  Xen_check_type(Xen_is_gboolean(visible_horizontal), visible_horizontal, 2, "gtk_tool_item_set_visible_horizontal", "gboolean");
  gtk_tool_item_set_visible_horizontal(Xen_to_C_GtkToolItem_(toolitem), Xen_to_C_gboolean(visible_horizontal));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_get_visible_horizontal(Xen toolitem)
{
  #define H_gtk_tool_item_get_visible_horizontal "gboolean gtk_tool_item_get_visible_horizontal(GtkToolItem* toolitem)"
  Xen_check_type(Xen_is_GtkToolItem_(toolitem), toolitem, 1, "gtk_tool_item_get_visible_horizontal", "GtkToolItem*");
  return(C_to_Xen_gboolean(gtk_tool_item_get_visible_horizontal(Xen_to_C_GtkToolItem_(toolitem))));
}

static Xen gxg_gtk_tool_item_set_visible_vertical(Xen toolitem, Xen visible_vertical)
{
  #define H_gtk_tool_item_set_visible_vertical "void gtk_tool_item_set_visible_vertical(GtkToolItem* toolitem, \
gboolean visible_vertical)"
  Xen_check_type(Xen_is_GtkToolItem_(toolitem), toolitem, 1, "gtk_tool_item_set_visible_vertical", "GtkToolItem*");
  Xen_check_type(Xen_is_gboolean(visible_vertical), visible_vertical, 2, "gtk_tool_item_set_visible_vertical", "gboolean");
  gtk_tool_item_set_visible_vertical(Xen_to_C_GtkToolItem_(toolitem), Xen_to_C_gboolean(visible_vertical));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_get_visible_vertical(Xen toolitem)
{
  #define H_gtk_tool_item_get_visible_vertical "gboolean gtk_tool_item_get_visible_vertical(GtkToolItem* toolitem)"
  Xen_check_type(Xen_is_GtkToolItem_(toolitem), toolitem, 1, "gtk_tool_item_get_visible_vertical", "GtkToolItem*");
  return(C_to_Xen_gboolean(gtk_tool_item_get_visible_vertical(Xen_to_C_GtkToolItem_(toolitem))));
}

static Xen gxg_gtk_tool_item_get_is_important(Xen tool_item)
{
  #define H_gtk_tool_item_get_is_important "gboolean gtk_tool_item_get_is_important(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_is_important", "GtkToolItem*");
  return(C_to_Xen_gboolean(gtk_tool_item_get_is_important(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_set_is_important(Xen tool_item, Xen is_important)
{
  #define H_gtk_tool_item_set_is_important "void gtk_tool_item_set_is_important(GtkToolItem* tool_item, \
gboolean is_important)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_set_is_important", "GtkToolItem*");
  Xen_check_type(Xen_is_gboolean(is_important), is_important, 2, "gtk_tool_item_set_is_important", "gboolean");
  gtk_tool_item_set_is_important(Xen_to_C_GtkToolItem_(tool_item), Xen_to_C_gboolean(is_important));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_get_orientation(Xen tool_item)
{
  #define H_gtk_tool_item_get_orientation "GtkOrientation gtk_tool_item_get_orientation(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_orientation", "GtkToolItem*");
  return(C_to_Xen_GtkOrientation(gtk_tool_item_get_orientation(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_get_toolbar_style(Xen tool_item)
{
  #define H_gtk_tool_item_get_toolbar_style "GtkToolbarStyle gtk_tool_item_get_toolbar_style(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_toolbar_style", "GtkToolItem*");
  return(C_to_Xen_GtkToolbarStyle(gtk_tool_item_get_toolbar_style(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_retrieve_proxy_menu_item(Xen tool_item)
{
  #define H_gtk_tool_item_retrieve_proxy_menu_item "GtkWidget* gtk_tool_item_retrieve_proxy_menu_item(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_retrieve_proxy_menu_item", "GtkToolItem*");
  return(C_to_Xen_GtkWidget_(gtk_tool_item_retrieve_proxy_menu_item(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_get_proxy_menu_item(Xen tool_item, Xen menu_item_id)
{
  #define H_gtk_tool_item_get_proxy_menu_item "GtkWidget* gtk_tool_item_get_proxy_menu_item(GtkToolItem* tool_item, \
gchar* menu_item_id)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_proxy_menu_item", "GtkToolItem*");
  Xen_check_type(Xen_is_gchar_(menu_item_id), menu_item_id, 2, "gtk_tool_item_get_proxy_menu_item", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_tool_item_get_proxy_menu_item(Xen_to_C_GtkToolItem_(tool_item), Xen_to_C_gchar_(menu_item_id))));
}

static Xen gxg_gtk_tool_item_set_proxy_menu_item(Xen tool_item, Xen menu_item_id, Xen menu_item)
{
  #define H_gtk_tool_item_set_proxy_menu_item "void gtk_tool_item_set_proxy_menu_item(GtkToolItem* tool_item, \
gchar* menu_item_id, GtkWidget* menu_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item) || Xen_is_false(tool_item), tool_item, 1, "gtk_tool_item_set_proxy_menu_item", "GtkToolItem*");
  Xen_check_type(Xen_is_gchar_(menu_item_id), menu_item_id, 2, "gtk_tool_item_set_proxy_menu_item", "gchar*");
  Xen_check_type(Xen_is_GtkWidget_(menu_item) || Xen_is_false(menu_item), menu_item, 3, "gtk_tool_item_set_proxy_menu_item", "GtkWidget*");
  gtk_tool_item_set_proxy_menu_item(Xen_to_C_GtkToolItem_(tool_item), Xen_to_C_gchar_(menu_item_id), Xen_to_C_GtkWidget_(menu_item));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_remove(Xen list_store, Xen iter)
{
  #define H_gtk_list_store_remove "gboolean gtk_list_store_remove(GtkListStore* list_store, GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_remove", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_remove", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_list_store_remove(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gdk_display_get_default_group(Xen display)
{
  #define H_gdk_display_get_default_group "GdkWindow* gdk_display_get_default_group(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_default_group", "GdkDisplay*");
  return(C_to_Xen_GdkWindow_(gdk_display_get_default_group(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_window_get_group(Xen window)
{
  #define H_gdk_window_get_group "GdkWindow* gdk_window_get_group(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_group", "GdkWindow*");
  return(C_to_Xen_GdkWindow_(gdk_window_get_group(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_cell_layout_reorder(Xen cell_layout, Xen cell, Xen position)
{
  #define H_gtk_cell_layout_reorder "void gtk_cell_layout_reorder(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gint position)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_reorder", "GtkCellLayout*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_cell_layout_reorder", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_cell_layout_reorder", "gint");
  gtk_cell_layout_reorder(Xen_to_C_GtkCellLayout_(cell_layout), Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_cancel(Xen menu_shell)
{
  #define H_gtk_menu_shell_cancel "void gtk_menu_shell_cancel(GtkMenuShell* menu_shell)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_cancel", "GtkMenuShell*");
  gtk_menu_shell_cancel(Xen_to_C_GtkMenuShell_(menu_shell));
  return(Xen_false);
}

static Xen gxg_gtk_paned_get_child1(Xen paned)
{
  #define H_gtk_paned_get_child1 "GtkWidget* gtk_paned_get_child1(GtkPaned* paned)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_get_child1", "GtkPaned*");
  return(C_to_Xen_GtkWidget_(gtk_paned_get_child1(Xen_to_C_GtkPaned_(paned))));
}

static Xen gxg_gtk_paned_get_child2(Xen paned)
{
  #define H_gtk_paned_get_child2 "GtkWidget* gtk_paned_get_child2(GtkPaned* paned)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_get_child2", "GtkPaned*");
  return(C_to_Xen_GtkWidget_(gtk_paned_get_child2(Xen_to_C_GtkPaned_(paned))));
}

static Xen gxg_gtk_window_set_accept_focus(Xen window, Xen setting)
{
  #define H_gtk_window_set_accept_focus "void gtk_window_set_accept_focus(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_accept_focus", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_accept_focus", "gboolean");
  gtk_window_set_accept_focus(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_accept_focus(Xen window)
{
  #define H_gtk_window_get_accept_focus "gboolean gtk_window_get_accept_focus(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_accept_focus", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_accept_focus(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_g_list_nth_data(Xen list, Xen n)
{
  #define H_g_list_nth_data "gpointer g_list_nth_data(GList* list, guint n)"
  Xen_check_type(Xen_is_GList_(list), list, 1, "g_list_nth_data", "GList*");
  Xen_check_type(Xen_is_guint(n), n, 2, "g_list_nth_data", "guint");
  return(C_to_Xen_gpointer(g_list_nth_data(Xen_to_C_GList_(list), Xen_to_C_guint(n))));
}

static Xen gxg_gtk_accel_map_get(void)
{
  #define H_gtk_accel_map_get "GtkAccelMap* gtk_accel_map_get( void)"
  return(C_to_Xen_GtkAccelMap_(gtk_accel_map_get()));
}

static Xen gxg_gtk_combo_box_popup(Xen combo_box)
{
  #define H_gtk_combo_box_popup "void gtk_combo_box_popup(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_popup", "GtkComboBox*");
  gtk_combo_box_popup(Xen_to_C_GtkComboBox_(combo_box));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_popdown(Xen combo_box)
{
  #define H_gtk_combo_box_popdown "void gtk_combo_box_popdown(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_popdown", "GtkComboBox*");
  gtk_combo_box_popdown(Xen_to_C_GtkComboBox_(combo_box));
  return(Xen_false);
}

static Xen gxg_gtk_radio_menu_item_new_from_widget(Xen group)
{
  #define H_gtk_radio_menu_item_new_from_widget "GtkWidget* gtk_radio_menu_item_new_from_widget(GtkRadioMenuItem* group)"
  Xen_check_type(Xen_is_GtkRadioMenuItem_(group), group, 1, "gtk_radio_menu_item_new_from_widget", "GtkRadioMenuItem*");
  return(C_to_Xen_GtkWidget_(gtk_radio_menu_item_new_from_widget(Xen_to_C_GtkRadioMenuItem_(group))));
}

static Xen gxg_gtk_radio_menu_item_new_with_mnemonic_from_widget(Xen group, Xen label)
{
  #define H_gtk_radio_menu_item_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_menu_item_new_with_mnemonic_from_widget(GtkRadioMenuItem* group, \
gchar* label)"
  Xen_check_type(Xen_is_GtkRadioMenuItem_(group), group, 1, "gtk_radio_menu_item_new_with_mnemonic_from_widget", "GtkRadioMenuItem*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_menu_item_new_with_mnemonic_from_widget", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_menu_item_new_with_mnemonic_from_widget(Xen_to_C_GtkRadioMenuItem_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_radio_menu_item_new_with_label_from_widget(Xen group, Xen label)
{
  #define H_gtk_radio_menu_item_new_with_label_from_widget "GtkWidget* gtk_radio_menu_item_new_with_label_from_widget(GtkRadioMenuItem* group, \
gchar* label)"
  Xen_check_type(Xen_is_GtkRadioMenuItem_(group), group, 1, "gtk_radio_menu_item_new_with_label_from_widget", "GtkRadioMenuItem*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_radio_menu_item_new_with_label_from_widget", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_radio_menu_item_new_with_label_from_widget(Xen_to_C_GtkRadioMenuItem_(group), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_scale_get_layout(Xen scale)
{
  #define H_gtk_scale_get_layout "PangoLayout* gtk_scale_get_layout(GtkScale* scale)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_get_layout", "GtkScale*");
  return(C_to_Xen_PangoLayout_(gtk_scale_get_layout(Xen_to_C_GtkScale_(scale))));
}

static Xen gxg_gtk_scale_get_layout_offsets(Xen scale, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_scale_get_layout_offsets "void gtk_scale_get_layout_offsets(GtkScale* scale, gint* [x], \
gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_get_layout_offsets", "GtkScale*");
  gtk_scale_get_layout_offsets(Xen_to_C_GtkScale_(scale), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
}

static Xen gxg_gtk_entry_set_alignment(Xen entry, Xen xalign)
{
  #define H_gtk_entry_set_alignment "void gtk_entry_set_alignment(GtkEntry* entry, gfloat xalign)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_alignment", "GtkEntry*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_entry_set_alignment", "gfloat");
  gtk_entry_set_alignment(Xen_to_C_GtkEntry_(entry), Xen_to_C_gfloat(xalign));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_alignment(Xen entry)
{
  #define H_gtk_entry_get_alignment "gfloat gtk_entry_get_alignment(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_alignment", "GtkEntry*");
  return(C_to_Xen_gfloat(gtk_entry_get_alignment(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_file_chooser_set_use_preview_label(Xen chooser, Xen use_label)
{
  #define H_gtk_file_chooser_set_use_preview_label "void gtk_file_chooser_set_use_preview_label(GtkFileChooser* chooser, \
gboolean use_label)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_use_preview_label", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(use_label), use_label, 2, "gtk_file_chooser_set_use_preview_label", "gboolean");
  gtk_file_chooser_set_use_preview_label(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(use_label));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_use_preview_label(Xen chooser)
{
  #define H_gtk_file_chooser_get_use_preview_label "gboolean gtk_file_chooser_get_use_preview_label(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_use_preview_label", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_use_preview_label(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_widget_list_mnemonic_labels(Xen widget)
{
  #define H_gtk_widget_list_mnemonic_labels "GList* gtk_widget_list_mnemonic_labels(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_list_mnemonic_labels", "GtkWidget*");
  return(C_to_Xen_GList_(gtk_widget_list_mnemonic_labels(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_add_mnemonic_label(Xen widget, Xen label)
{
  #define H_gtk_widget_add_mnemonic_label "void gtk_widget_add_mnemonic_label(GtkWidget* widget, GtkWidget* label)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_add_mnemonic_label", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(label), label, 2, "gtk_widget_add_mnemonic_label", "GtkWidget*");
  gtk_widget_add_mnemonic_label(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(label));
  return(Xen_false);
}

static Xen gxg_gtk_widget_remove_mnemonic_label(Xen widget, Xen label)
{
  #define H_gtk_widget_remove_mnemonic_label "void gtk_widget_remove_mnemonic_label(GtkWidget* widget, \
GtkWidget* label)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_remove_mnemonic_label", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(label), label, 2, "gtk_widget_remove_mnemonic_label", "GtkWidget*");
  gtk_widget_remove_mnemonic_label(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(label));
  return(Xen_false);
}

static Xen gxg_gtk_window_activate_key(Xen window, Xen event)
{
  #define H_gtk_window_activate_key "gboolean gtk_window_activate_key(GtkWindow* window, GdkEventKey* event)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_activate_key", "GtkWindow*");
  Xen_check_type(Xen_is_GdkEventKey_(event), event, 2, "gtk_window_activate_key", "GdkEventKey*");
  return(C_to_Xen_gboolean(gtk_window_activate_key(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkEventKey_(event))));
}

static Xen gxg_gtk_window_propagate_key_event(Xen window, Xen event)
{
  #define H_gtk_window_propagate_key_event "gboolean gtk_window_propagate_key_event(GtkWindow* window, \
GdkEventKey* event)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_propagate_key_event", "GtkWindow*");
  Xen_check_type(Xen_is_GdkEventKey_(event), event, 2, "gtk_window_propagate_key_event", "GdkEventKey*");
  return(C_to_Xen_gboolean(gtk_window_propagate_key_event(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkEventKey_(event))));
}

static Xen gxg_g_quark_from_string(Xen string)
{
  #define H_g_quark_from_string "GQuark g_quark_from_string(gchar* string)"
  Xen_check_type(Xen_is_gchar_(string), string, 1, "g_quark_from_string", "gchar*");
  return(C_to_Xen_GQuark(g_quark_from_string(Xen_to_C_gchar_(string))));
}

static Xen gxg_g_quark_to_string(Xen quark)
{
  #define H_g_quark_to_string "gchar* g_quark_to_string(GQuark quark)"
  Xen_check_type(Xen_is_GQuark(quark), quark, 1, "g_quark_to_string", "GQuark");
  return(C_to_Xen_gchar_(g_quark_to_string(Xen_to_C_GQuark(quark))));
}

static Xen gxg_gtk_cell_view_new(void)
{
  #define H_gtk_cell_view_new "GtkWidget* gtk_cell_view_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_cell_view_new()));
}

static Xen gxg_gtk_cell_view_new_with_text(Xen text)
{
  #define H_gtk_cell_view_new_with_text "GtkWidget* gtk_cell_view_new_with_text(gchar* text)"
  Xen_check_type(Xen_is_gchar_(text), text, 1, "gtk_cell_view_new_with_text", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_cell_view_new_with_text(Xen_to_C_gchar_(text))));
}

static Xen gxg_gtk_cell_view_new_with_markup(Xen markup)
{
  #define H_gtk_cell_view_new_with_markup "GtkWidget* gtk_cell_view_new_with_markup(gchar* markup)"
  Xen_check_type(Xen_is_gchar_(markup), markup, 1, "gtk_cell_view_new_with_markup", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_cell_view_new_with_markup(Xen_to_C_gchar_(markup))));
}

static Xen gxg_gtk_cell_view_set_model(Xen cell_view, Xen model)
{
  #define H_gtk_cell_view_set_model "void gtk_cell_view_set_model(GtkCellView* cell_view, GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_set_model", "GtkCellView*");
  Xen_check_type(Xen_is_GtkTreeModel_(model) || Xen_is_false(model), model, 2, "gtk_cell_view_set_model", "GtkTreeModel*");
  gtk_cell_view_set_model(Xen_to_C_GtkCellView_(cell_view), Xen_to_C_GtkTreeModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_cell_view_set_displayed_row(Xen cell_view, Xen path)
{
  #define H_gtk_cell_view_set_displayed_row "void gtk_cell_view_set_displayed_row(GtkCellView* cell_view, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_set_displayed_row", "GtkCellView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_cell_view_set_displayed_row", "GtkTreePath*");
  gtk_cell_view_set_displayed_row(Xen_to_C_GtkCellView_(cell_view), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_cell_view_get_displayed_row(Xen cell_view)
{
  #define H_gtk_cell_view_get_displayed_row "GtkTreePath* gtk_cell_view_get_displayed_row(GtkCellView* cell_view)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_get_displayed_row", "GtkCellView*");
  return(C_to_Xen_GtkTreePath_(gtk_cell_view_get_displayed_row(Xen_to_C_GtkCellView_(cell_view))));
}

static Xen gxg_gtk_combo_box_get_wrap_width(Xen combo_box)
{
  #define H_gtk_combo_box_get_wrap_width "gint gtk_combo_box_get_wrap_width(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_wrap_width", "GtkComboBox*");
  return(C_to_Xen_gint(gtk_combo_box_get_wrap_width(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_combo_box_get_row_span_column(Xen combo_box)
{
  #define H_gtk_combo_box_get_row_span_column "gint gtk_combo_box_get_row_span_column(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_row_span_column", "GtkComboBox*");
  return(C_to_Xen_gint(gtk_combo_box_get_row_span_column(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_combo_box_get_column_span_column(Xen combo_box)
{
  #define H_gtk_combo_box_get_column_span_column "gint gtk_combo_box_get_column_span_column(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_column_span_column", "GtkComboBox*");
  return(C_to_Xen_gint(gtk_combo_box_get_column_span_column(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_drag_dest_add_text_targets(Xen widget)
{
  #define H_gtk_drag_dest_add_text_targets "void gtk_drag_dest_add_text_targets(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_add_text_targets", "GtkWidget*");
  gtk_drag_dest_add_text_targets(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_add_text_targets(Xen widget)
{
  #define H_gtk_drag_source_add_text_targets "void gtk_drag_source_add_text_targets(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_add_text_targets", "GtkWidget*");
  gtk_drag_source_add_text_targets(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_insert_prefix(Xen completion)
{
  #define H_gtk_entry_completion_insert_prefix "void gtk_entry_completion_insert_prefix(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_insert_prefix", "GtkEntryCompletion*");
  gtk_entry_completion_insert_prefix(Xen_to_C_GtkEntryCompletion_(completion));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_set_inline_completion(Xen completion, Xen inline_completion)
{
  #define H_gtk_entry_completion_set_inline_completion "void gtk_entry_completion_set_inline_completion(GtkEntryCompletion* completion, \
gboolean inline_completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_inline_completion", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gboolean(inline_completion), inline_completion, 2, "gtk_entry_completion_set_inline_completion", "gboolean");
  gtk_entry_completion_set_inline_completion(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gboolean(inline_completion));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_inline_completion(Xen completion)
{
  #define H_gtk_entry_completion_get_inline_completion "gboolean gtk_entry_completion_get_inline_completion(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_inline_completion", "GtkEntryCompletion*");
  return(C_to_Xen_gboolean(gtk_entry_completion_get_inline_completion(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_completion_set_popup_completion(Xen completion, Xen popup_completion)
{
  #define H_gtk_entry_completion_set_popup_completion "void gtk_entry_completion_set_popup_completion(GtkEntryCompletion* completion, \
gboolean popup_completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_popup_completion", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gboolean(popup_completion), popup_completion, 2, "gtk_entry_completion_set_popup_completion", "gboolean");
  gtk_entry_completion_set_popup_completion(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gboolean(popup_completion));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_popup_completion(Xen completion)
{
  #define H_gtk_entry_completion_get_popup_completion "gboolean gtk_entry_completion_get_popup_completion(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_popup_completion", "GtkEntryCompletion*");
  return(C_to_Xen_gboolean(gtk_entry_completion_get_popup_completion(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_completion_get_text_column(Xen completion)
{
  #define H_gtk_entry_completion_get_text_column "gint gtk_entry_completion_get_text_column(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_text_column", "GtkEntryCompletion*");
  return(C_to_Xen_gint(gtk_entry_completion_get_text_column(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_icon_theme_get_icon_sizes(Xen icon_theme, Xen icon_name)
{
  #define H_gtk_icon_theme_get_icon_sizes "gint* gtk_icon_theme_get_icon_sizes(GtkIconTheme* icon_theme, \
gchar* icon_name)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_get_icon_sizes", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_get_icon_sizes", "gchar*");
  return(C_to_Xen_gint_(gtk_icon_theme_get_icon_sizes(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_gchar_(icon_name))));
}

static Xen gxg_gtk_menu_get_for_attach_widget(Xen widget )
{
  #define H_gtk_menu_get_for_attach_widget "GList* gtk_menu_get_for_attach_widget(GtkWidget* widget, \
)"
  Xen_check_type(Xen_is_GtkWidget_(widget ), widget , 1, "gtk_menu_get_for_attach_widget", "GtkWidget*");
  return(C_to_Xen_GList_(gtk_menu_get_for_attach_widget(Xen_to_C_GtkWidget_(widget ))));
}

static Xen gxg_gtk_tree_view_set_fixed_height_mode(Xen tree_view, Xen enable)
{
  #define H_gtk_tree_view_set_fixed_height_mode "void gtk_tree_view_set_fixed_height_mode(GtkTreeView* tree_view, \
gboolean enable)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_fixed_height_mode", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(enable), enable, 2, "gtk_tree_view_set_fixed_height_mode", "gboolean");
  gtk_tree_view_set_fixed_height_mode(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(enable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_fixed_height_mode(Xen tree_view)
{
  #define H_gtk_tree_view_get_fixed_height_mode "gboolean gtk_tree_view_get_fixed_height_mode(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_fixed_height_mode", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_fixed_height_mode(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_hover_selection(Xen tree_view, Xen hover)
{
  #define H_gtk_tree_view_set_hover_selection "void gtk_tree_view_set_hover_selection(GtkTreeView* tree_view, \
gboolean hover)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_hover_selection", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(hover), hover, 2, "gtk_tree_view_set_hover_selection", "gboolean");
  gtk_tree_view_set_hover_selection(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(hover));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_hover_selection(Xen tree_view)
{
  #define H_gtk_tree_view_get_hover_selection "gboolean gtk_tree_view_get_hover_selection(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_hover_selection", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_hover_selection(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_row_separator_func(Xen tree_view, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_view_set_row_separator_func "void gtk_tree_view_set_row_separator_func(GtkTreeView* tree_view, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_row_separator_func", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewRowSeparatorFunc(func), func, 2, "gtk_tree_view_set_row_separator_func", "GtkTreeViewRowSeparatorFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_view_set_row_separator_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 4, "gtk_tree_view_set_row_separator_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_tree_view_set_row_separator_func(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewRowSeparatorFunc(func), Xen_to_C_lambda_data(func_info), 
                                     Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_window_set_focus_on_map(Xen window, Xen setting)
{
  #define H_gtk_window_set_focus_on_map "void gtk_window_set_focus_on_map(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_focus_on_map", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_focus_on_map", "gboolean");
  gtk_window_set_focus_on_map(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_focus_on_map(Xen window)
{
  #define H_gtk_window_get_focus_on_map "gboolean gtk_window_get_focus_on_map(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_focus_on_map", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_focus_on_map(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_icon_name(Xen window, Xen name)
{
  #define H_gtk_window_set_icon_name "void gtk_window_set_icon_name(GtkWindow* window, gchar* name)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_icon_name", "GtkWindow*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_window_set_icon_name", "gchar*");
  gtk_window_set_icon_name(Xen_to_C_GtkWindow_(window), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_icon_name(Xen window)
{
  #define H_gtk_window_get_icon_name "gchar* gtk_window_get_icon_name(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_icon_name", "GtkWindow*");
  return(C_to_Xen_gchar_(gtk_window_get_icon_name(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_default_icon_name(Xen name)
{
  #define H_gtk_window_set_default_icon_name "void gtk_window_set_default_icon_name(gchar* name)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "gtk_window_set_default_icon_name", "gchar*");
  gtk_window_set_default_icon_name(Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_new(void)
{
  #define H_gtk_about_dialog_new "GtkWidget* gtk_about_dialog_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_about_dialog_new()));
}

static Xen gxg_gtk_about_dialog_get_version(Xen about)
{
  #define H_gtk_about_dialog_get_version "gchar* gtk_about_dialog_get_version(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_version", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_version(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_version(Xen about, Xen version)
{
  #define H_gtk_about_dialog_set_version "void gtk_about_dialog_set_version(GtkAboutDialog* about, gchar* version)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_version", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(version), version, 2, "gtk_about_dialog_set_version", "gchar*");
  gtk_about_dialog_set_version(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(version));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_copyright(Xen about)
{
  #define H_gtk_about_dialog_get_copyright "gchar* gtk_about_dialog_get_copyright(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_copyright", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_copyright(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_copyright(Xen about, Xen copyright)
{
  #define H_gtk_about_dialog_set_copyright "void gtk_about_dialog_set_copyright(GtkAboutDialog* about, \
gchar* copyright)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_copyright", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(copyright), copyright, 2, "gtk_about_dialog_set_copyright", "gchar*");
  gtk_about_dialog_set_copyright(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(copyright));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_comments(Xen about)
{
  #define H_gtk_about_dialog_get_comments "gchar* gtk_about_dialog_get_comments(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_comments", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_comments(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_comments(Xen about, Xen comments)
{
  #define H_gtk_about_dialog_set_comments "void gtk_about_dialog_set_comments(GtkAboutDialog* about, \
gchar* comments)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_comments", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(comments), comments, 2, "gtk_about_dialog_set_comments", "gchar*");
  gtk_about_dialog_set_comments(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(comments));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_website(Xen about)
{
  #define H_gtk_about_dialog_get_website "gchar* gtk_about_dialog_get_website(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_website", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_website(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_website(Xen about, Xen website)
{
  #define H_gtk_about_dialog_set_website "void gtk_about_dialog_set_website(GtkAboutDialog* about, gchar* website)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_website", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(website), website, 2, "gtk_about_dialog_set_website", "gchar*");
  gtk_about_dialog_set_website(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(website));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_website_label(Xen about)
{
  #define H_gtk_about_dialog_get_website_label "gchar* gtk_about_dialog_get_website_label(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_website_label", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_website_label(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_website_label(Xen about, Xen website_label)
{
  #define H_gtk_about_dialog_set_website_label "void gtk_about_dialog_set_website_label(GtkAboutDialog* about, \
gchar* website_label)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_website_label", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(website_label), website_label, 2, "gtk_about_dialog_set_website_label", "gchar*");
  gtk_about_dialog_set_website_label(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(website_label));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_authors(Xen about)
{
  #define H_gtk_about_dialog_get_authors "gchar** gtk_about_dialog_get_authors(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_authors", "GtkAboutDialog*");
    return(C_to_Xen_gchar__((gchar**)gtk_about_dialog_get_authors(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_authors(Xen about, Xen authors)
{
  #define H_gtk_about_dialog_set_authors "void gtk_about_dialog_set_authors(GtkAboutDialog* about, gchar** authors)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_authors", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar__(authors), authors, 2, "gtk_about_dialog_set_authors", "gchar**");
  gtk_about_dialog_set_authors(Xen_to_C_GtkAboutDialog_(about), (const gchar**)Xen_to_C_gchar__(authors));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_documenters(Xen about)
{
  #define H_gtk_about_dialog_get_documenters "gchar** gtk_about_dialog_get_documenters(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_documenters", "GtkAboutDialog*");
    return(C_to_Xen_gchar__((gchar**)gtk_about_dialog_get_documenters(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_documenters(Xen about, Xen documenters)
{
  #define H_gtk_about_dialog_set_documenters "void gtk_about_dialog_set_documenters(GtkAboutDialog* about, \
gchar** documenters)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_documenters", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar__(documenters), documenters, 2, "gtk_about_dialog_set_documenters", "gchar**");
  gtk_about_dialog_set_documenters(Xen_to_C_GtkAboutDialog_(about), (const gchar**)Xen_to_C_gchar__(documenters));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_artists(Xen about)
{
  #define H_gtk_about_dialog_get_artists "gchar** gtk_about_dialog_get_artists(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_artists", "GtkAboutDialog*");
    return(C_to_Xen_gchar__((gchar**)gtk_about_dialog_get_artists(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_artists(Xen about, Xen artists)
{
  #define H_gtk_about_dialog_set_artists "void gtk_about_dialog_set_artists(GtkAboutDialog* about, gchar** artists)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_artists", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar__(artists), artists, 2, "gtk_about_dialog_set_artists", "gchar**");
  gtk_about_dialog_set_artists(Xen_to_C_GtkAboutDialog_(about), (const gchar**)Xen_to_C_gchar__(artists));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_translator_credits(Xen about)
{
  #define H_gtk_about_dialog_get_translator_credits "gchar* gtk_about_dialog_get_translator_credits(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_translator_credits", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_translator_credits(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_translator_credits(Xen about, Xen translator_credits)
{
  #define H_gtk_about_dialog_set_translator_credits "void gtk_about_dialog_set_translator_credits(GtkAboutDialog* about, \
gchar* translator_credits)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_translator_credits", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(translator_credits), translator_credits, 2, "gtk_about_dialog_set_translator_credits", "gchar*");
  gtk_about_dialog_set_translator_credits(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(translator_credits));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_program_name(Xen about)
{
  #define H_gtk_about_dialog_get_program_name "gchar* gtk_about_dialog_get_program_name(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_program_name", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_program_name(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_program_name(Xen about, Xen name)
{
  #define H_gtk_about_dialog_set_program_name "void gtk_about_dialog_set_program_name(GtkAboutDialog* about, \
gchar* name)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_program_name", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_about_dialog_set_program_name", "gchar*");
  gtk_about_dialog_set_program_name(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_new(void)
{
  #define H_gtk_icon_view_new "GtkWidget* gtk_icon_view_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_icon_view_new()));
}

static Xen gxg_gtk_icon_view_new_with_model(Xen model)
{
  #define H_gtk_icon_view_new_with_model "GtkWidget* gtk_icon_view_new_with_model(GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 1, "gtk_icon_view_new_with_model", "GtkTreeModel*");
  return(C_to_Xen_GtkWidget_(gtk_icon_view_new_with_model(Xen_to_C_GtkTreeModel_(model))));
}

static Xen gxg_gtk_icon_view_set_model(Xen icon_view, Xen model)
{
  #define H_gtk_icon_view_set_model "void gtk_icon_view_set_model(GtkIconView* icon_view, GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_model", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreeModel_(model) || Xen_is_false(model), model, 2, "gtk_icon_view_set_model", "GtkTreeModel*");
  gtk_icon_view_set_model(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreeModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_model(Xen icon_view)
{
  #define H_gtk_icon_view_get_model "GtkTreeModel* gtk_icon_view_get_model(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_model", "GtkIconView*");
  return(C_to_Xen_GtkTreeModel_(gtk_icon_view_get_model(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_text_column(Xen icon_view, Xen column)
{
  #define H_gtk_icon_view_set_text_column "void gtk_icon_view_set_text_column(GtkIconView* icon_view, \
gint column)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_text_column", "GtkIconView*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_icon_view_set_text_column", "gint");
  gtk_icon_view_set_text_column(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_text_column(Xen icon_view)
{
  #define H_gtk_icon_view_get_text_column "gint gtk_icon_view_get_text_column(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_text_column", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_text_column(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_markup_column(Xen icon_view, Xen column)
{
  #define H_gtk_icon_view_set_markup_column "void gtk_icon_view_set_markup_column(GtkIconView* icon_view, \
gint column)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_markup_column", "GtkIconView*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_icon_view_set_markup_column", "gint");
  gtk_icon_view_set_markup_column(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_markup_column(Xen icon_view)
{
  #define H_gtk_icon_view_get_markup_column "gint gtk_icon_view_get_markup_column(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_markup_column", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_markup_column(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_pixbuf_column(Xen icon_view, Xen column)
{
  #define H_gtk_icon_view_set_pixbuf_column "void gtk_icon_view_set_pixbuf_column(GtkIconView* icon_view, \
gint column)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_pixbuf_column", "GtkIconView*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_icon_view_set_pixbuf_column", "gint");
  gtk_icon_view_set_pixbuf_column(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_pixbuf_column(Xen icon_view)
{
  #define H_gtk_icon_view_get_pixbuf_column "gint gtk_icon_view_get_pixbuf_column(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_pixbuf_column", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_pixbuf_column(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_get_path_at_pos(Xen icon_view, Xen x, Xen y)
{
  #define H_gtk_icon_view_get_path_at_pos "GtkTreePath* gtk_icon_view_get_path_at_pos(GtkIconView* icon_view, \
gint x, gint y)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_path_at_pos", "GtkIconView*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_icon_view_get_path_at_pos", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_icon_view_get_path_at_pos", "gint");
  return(C_to_Xen_GtkTreePath_(gtk_icon_view_get_path_at_pos(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_icon_view_selected_foreach(Xen icon_view, Xen func, Xen func_info)
{
  #define H_gtk_icon_view_selected_foreach "void gtk_icon_view_selected_foreach(GtkIconView* icon_view, \
GtkIconViewForeachFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_selected_foreach", "GtkIconView*");
  Xen_check_type(Xen_is_GtkIconViewForeachFunc(func), func, 2, "gtk_icon_view_selected_foreach", "GtkIconViewForeachFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_icon_view_selected_foreach", "lambda_data");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gtk_icon_view_selected_foreach(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkIconViewForeachFunc(func), Xen_to_C_lambda_data(func_info));
    return(Xen_false);
   }
}

static Xen gxg_gtk_icon_view_set_selection_mode(Xen icon_view, Xen mode)
{
  #define H_gtk_icon_view_set_selection_mode "void gtk_icon_view_set_selection_mode(GtkIconView* icon_view, \
GtkSelectionMode mode)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_selection_mode", "GtkIconView*");
  Xen_check_type(Xen_is_GtkSelectionMode(mode), mode, 2, "gtk_icon_view_set_selection_mode", "GtkSelectionMode");
  gtk_icon_view_set_selection_mode(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkSelectionMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_selection_mode(Xen icon_view)
{
  #define H_gtk_icon_view_get_selection_mode "GtkSelectionMode gtk_icon_view_get_selection_mode(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_selection_mode", "GtkIconView*");
  return(C_to_Xen_GtkSelectionMode(gtk_icon_view_get_selection_mode(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_select_path(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_select_path "void gtk_icon_view_select_path(GtkIconView* icon_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_select_path", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_select_path", "GtkTreePath*");
  gtk_icon_view_select_path(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_unselect_path(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_unselect_path "void gtk_icon_view_unselect_path(GtkIconView* icon_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_unselect_path", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_unselect_path", "GtkTreePath*");
  gtk_icon_view_unselect_path(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_path_is_selected(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_path_is_selected "gboolean gtk_icon_view_path_is_selected(GtkIconView* icon_view, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_path_is_selected", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_path_is_selected", "GtkTreePath*");
  return(C_to_Xen_gboolean(gtk_icon_view_path_is_selected(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_icon_view_get_selected_items(Xen icon_view)
{
  #define H_gtk_icon_view_get_selected_items "GList* gtk_icon_view_get_selected_items(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_selected_items", "GtkIconView*");
  return(C_to_Xen_GList_(gtk_icon_view_get_selected_items(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_select_all(Xen icon_view)
{
  #define H_gtk_icon_view_select_all "void gtk_icon_view_select_all(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_select_all", "GtkIconView*");
  gtk_icon_view_select_all(Xen_to_C_GtkIconView_(icon_view));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_unselect_all(Xen icon_view)
{
  #define H_gtk_icon_view_unselect_all "void gtk_icon_view_unselect_all(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_unselect_all", "GtkIconView*");
  gtk_icon_view_unselect_all(Xen_to_C_GtkIconView_(icon_view));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_item_activated(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_item_activated "void gtk_icon_view_item_activated(GtkIconView* icon_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_item_activated", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_item_activated", "GtkTreePath*");
  gtk_icon_view_item_activated(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_combo_new(void)
{
  #define H_gtk_cell_renderer_combo_new "GtkCellRenderer* gtk_cell_renderer_combo_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_combo_new()));
}

static Xen gxg_gtk_cell_renderer_progress_new(void)
{
  #define H_gtk_cell_renderer_progress_new "GtkCellRenderer* gtk_cell_renderer_progress_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_progress_new()));
}

static Xen gxg_gtk_combo_box_set_row_separator_func(Xen combo_box, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_combo_box_set_row_separator_func "void gtk_combo_box_set_row_separator_func(GtkComboBox* combo_box, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_row_separator_func", "GtkComboBox*");
  Xen_check_type(Xen_is_GtkTreeViewRowSeparatorFunc(func), func, 2, "gtk_combo_box_set_row_separator_func", "GtkTreeViewRowSeparatorFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_combo_box_set_row_separator_func", "lambda_data");
  Xen_check_type(Xen_is_GtkDestroyNotify(destroy), destroy, 4, "gtk_combo_box_set_row_separator_func", "GtkDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 3, destroy);
    gtk_combo_box_set_row_separator_func(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_GtkTreeViewRowSeparatorFunc(func), Xen_to_C_lambda_data(func_info), 
                                     Xen_to_C_GtkDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_label_set_ellipsize(Xen label, Xen mode)
{
  #define H_gtk_label_set_ellipsize "void gtk_label_set_ellipsize(GtkLabel* label, PangoEllipsizeMode mode)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_ellipsize", "GtkLabel*");
  Xen_check_type(Xen_is_PangoEllipsizeMode(mode), mode, 2, "gtk_label_set_ellipsize", "PangoEllipsizeMode");
  gtk_label_set_ellipsize(Xen_to_C_GtkLabel_(label), Xen_to_C_PangoEllipsizeMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_ellipsize(Xen label)
{
  #define H_gtk_label_get_ellipsize "PangoEllipsizeMode gtk_label_get_ellipsize(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_ellipsize", "GtkLabel*");
  return(C_to_Xen_PangoEllipsizeMode(gtk_label_get_ellipsize(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_pango_attr_fallback_new(Xen enable_fallback)
{
  #define H_pango_attr_fallback_new "PangoAttribute* pango_attr_fallback_new(gboolean enable_fallback)"
  Xen_check_type(Xen_is_gboolean(enable_fallback), enable_fallback, 1, "pango_attr_fallback_new", "gboolean");
  return(C_to_Xen_PangoAttribute_(pango_attr_fallback_new(Xen_to_C_gboolean(enable_fallback))));
}

static Xen gxg_pango_attr_letter_spacing_new(Xen letter_spacing)
{
  #define H_pango_attr_letter_spacing_new "PangoAttribute* pango_attr_letter_spacing_new(int letter_spacing)"
  Xen_check_type(Xen_is_int(letter_spacing), letter_spacing, 1, "pango_attr_letter_spacing_new", "int");
  return(C_to_Xen_PangoAttribute_(pango_attr_letter_spacing_new(Xen_to_C_int(letter_spacing))));
}

static Xen gxg_pango_attr_list_filter(Xen list, Xen func, Xen data)
{
  #define H_pango_attr_list_filter "PangoAttrList* pango_attr_list_filter(PangoAttrList* list, PangoAttrFilterFunc func, \
gpointer data)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_filter", "PangoAttrList*");
  Xen_check_type(Xen_is_PangoAttrFilterFunc(func), func, 2, "pango_attr_list_filter", "PangoAttrFilterFunc");
  Xen_check_type(Xen_is_gpointer(data), data, 3, "pango_attr_list_filter", "gpointer");
  return(C_to_Xen_PangoAttrList_(pango_attr_list_filter(Xen_to_C_PangoAttrList_(list), Xen_to_C_PangoAttrFilterFunc(func), 
                                                        Xen_to_C_gpointer(data))));
}

static Xen gxg_pango_attr_iterator_get_attrs(Xen iterator)
{
  #define H_pango_attr_iterator_get_attrs "GSList* pango_attr_iterator_get_attrs(PangoAttrIterator* iterator)"
  Xen_check_type(Xen_is_PangoAttrIterator_(iterator), iterator, 1, "pango_attr_iterator_get_attrs", "PangoAttrIterator*");
  return(C_to_Xen_GSList_(pango_attr_iterator_get_attrs(Xen_to_C_PangoAttrIterator_(iterator))));
}

static Xen gxg_pango_font_metrics_get_underline_position(Xen metrics)
{
  #define H_pango_font_metrics_get_underline_position "int pango_font_metrics_get_underline_position(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_underline_position", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_underline_position(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_get_underline_thickness(Xen metrics)
{
  #define H_pango_font_metrics_get_underline_thickness "int pango_font_metrics_get_underline_thickness(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_underline_thickness", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_underline_thickness(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_get_strikethrough_position(Xen metrics)
{
  #define H_pango_font_metrics_get_strikethrough_position "int pango_font_metrics_get_strikethrough_position(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_strikethrough_position", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_strikethrough_position(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_metrics_get_strikethrough_thickness(Xen metrics)
{
  #define H_pango_font_metrics_get_strikethrough_thickness "int pango_font_metrics_get_strikethrough_thickness(PangoFontMetrics* metrics)"
  Xen_check_type(Xen_is_PangoFontMetrics_(metrics), metrics, 1, "pango_font_metrics_get_strikethrough_thickness", "PangoFontMetrics*");
  return(C_to_Xen_int(pango_font_metrics_get_strikethrough_thickness(Xen_to_C_PangoFontMetrics_(metrics))));
}

static Xen gxg_pango_font_family_is_monospace(Xen family)
{
  #define H_pango_font_family_is_monospace "gboolean pango_font_family_is_monospace(PangoFontFamily* family)"
  Xen_check_type(Xen_is_PangoFontFamily_(family), family, 1, "pango_font_family_is_monospace", "PangoFontFamily*");
  return(C_to_Xen_gboolean(pango_font_family_is_monospace(Xen_to_C_PangoFontFamily_(family))));
}

static Xen gxg_pango_font_face_list_sizes(Xen face, Xen ignore_sizes, Xen ignore_n_sizes)
{
  #define H_pango_font_face_list_sizes "void pango_font_face_list_sizes(PangoFontFace* face, int** [sizes], \
int* [n_sizes])"
  int* ref_sizes = NULL;
  int ref_n_sizes;
  Xen_check_type(Xen_is_PangoFontFace_(face), face, 1, "pango_font_face_list_sizes", "PangoFontFace*");
  pango_font_face_list_sizes(Xen_to_C_PangoFontFace_(face), &ref_sizes, &ref_n_sizes);
  return(Xen_list_2(C_to_Xen_int_(ref_sizes), C_to_Xen_int(ref_n_sizes)));
}

static Xen gxg_pango_layout_set_auto_dir(Xen layout, Xen auto_dir)
{
  #define H_pango_layout_set_auto_dir "void pango_layout_set_auto_dir(PangoLayout* layout, gboolean auto_dir)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_set_auto_dir", "PangoLayout*");
  Xen_check_type(Xen_is_gboolean(auto_dir), auto_dir, 2, "pango_layout_set_auto_dir", "gboolean");
  pango_layout_set_auto_dir(Xen_to_C_PangoLayout_(layout), Xen_to_C_gboolean(auto_dir));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_auto_dir(Xen layout)
{
  #define H_pango_layout_get_auto_dir "gboolean pango_layout_get_auto_dir(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_auto_dir", "PangoLayout*");
  return(C_to_Xen_gboolean(pango_layout_get_auto_dir(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_pango_script_for_unichar(Xen ch)
{
  #define H_pango_script_for_unichar "PangoScript pango_script_for_unichar(gunichar ch)"
  Xen_check_type(Xen_is_gunichar(ch), ch, 1, "pango_script_for_unichar", "gunichar");
  return(C_to_Xen_PangoScript(pango_script_for_unichar(Xen_to_C_gunichar(ch))));
}

static Xen gxg_pango_script_iter_new(Xen text, Xen length)
{
  #define H_pango_script_iter_new "PangoScriptIter* pango_script_iter_new(char* text, int length)"
  Xen_check_type(Xen_is_char_(text), text, 1, "pango_script_iter_new", "char*");
  Xen_check_type(Xen_is_int(length), length, 2, "pango_script_iter_new", "int");
  return(C_to_Xen_PangoScriptIter_(pango_script_iter_new(Xen_to_C_char_(text), Xen_to_C_int(length))));
}

static Xen gxg_pango_script_iter_get_range(Xen iter, Xen ignore_start, Xen ignore_end, Xen ignore_script)
{
  #define H_pango_script_iter_get_range "void pango_script_iter_get_range(PangoScriptIter* iter, char** [start], \
char** [end], PangoScript* [script])"
  char* ref_start = NULL;
  char* ref_end = NULL;
  PangoScript ref_script;
  Xen_check_type(Xen_is_PangoScriptIter_(iter), iter, 1, "pango_script_iter_get_range", "PangoScriptIter*");
  pango_script_iter_get_range(Xen_to_C_PangoScriptIter_(iter), (const char**)&ref_start, (const char**)&ref_end, &ref_script);
  return(Xen_list_3(C_to_Xen_char_(ref_start), C_to_Xen_char_(ref_end), C_to_Xen_PangoScript(ref_script)));
}

static Xen gxg_pango_script_iter_next(Xen iter)
{
  #define H_pango_script_iter_next "gboolean pango_script_iter_next(PangoScriptIter* iter)"
  Xen_check_type(Xen_is_PangoScriptIter_(iter), iter, 1, "pango_script_iter_next", "PangoScriptIter*");
  return(C_to_Xen_gboolean(pango_script_iter_next(Xen_to_C_PangoScriptIter_(iter))));
}

static Xen gxg_pango_script_iter_free(Xen iter)
{
  #define H_pango_script_iter_free "void pango_script_iter_free(PangoScriptIter* iter)"
  Xen_check_type(Xen_is_PangoScriptIter_(iter), iter, 1, "pango_script_iter_free", "PangoScriptIter*");
  pango_script_iter_free(Xen_to_C_PangoScriptIter_(iter));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_button_new_with_dialog(Xen dialog)
{
  #define H_gtk_file_chooser_button_new_with_dialog "GtkWidget* gtk_file_chooser_button_new_with_dialog(GtkWidget* dialog)"
  Xen_check_type(Xen_is_GtkWidget_(dialog), dialog, 1, "gtk_file_chooser_button_new_with_dialog", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_file_chooser_button_new_with_dialog(Xen_to_C_GtkWidget_(dialog))));
}

static Xen gxg_gtk_file_chooser_button_get_title(Xen button)
{
  #define H_gtk_file_chooser_button_get_title "gchar* gtk_file_chooser_button_get_title(GtkFileChooserButton* button)"
  Xen_check_type(Xen_is_GtkFileChooserButton_(button), button, 1, "gtk_file_chooser_button_get_title", "GtkFileChooserButton*");
  return(C_to_Xen_gchar_(gtk_file_chooser_button_get_title(Xen_to_C_GtkFileChooserButton_(button))));
}

static Xen gxg_gtk_file_chooser_button_set_title(Xen button, Xen title)
{
  #define H_gtk_file_chooser_button_set_title "void gtk_file_chooser_button_set_title(GtkFileChooserButton* button, \
gchar* title)"
  Xen_check_type(Xen_is_GtkFileChooserButton_(button), button, 1, "gtk_file_chooser_button_set_title", "GtkFileChooserButton*");
  Xen_check_type(Xen_is_gchar_(title), title, 2, "gtk_file_chooser_button_set_title", "gchar*");
  gtk_file_chooser_button_set_title(Xen_to_C_GtkFileChooserButton_(button), Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gdk_drag_drop_succeeded(Xen context)
{
  #define H_gdk_drag_drop_succeeded "gboolean gdk_drag_drop_succeeded(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_drop_succeeded", "GdkDragContext*");
  return(C_to_Xen_gboolean(gdk_drag_drop_succeeded(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gtk_entry_layout_index_to_text_index(Xen entry, Xen layout_index)
{
  #define H_gtk_entry_layout_index_to_text_index "gint gtk_entry_layout_index_to_text_index(GtkEntry* entry, \
gint layout_index)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_layout_index_to_text_index", "GtkEntry*");
  Xen_check_type(Xen_is_gint(layout_index), layout_index, 2, "gtk_entry_layout_index_to_text_index", "gint");
  return(C_to_Xen_gint(gtk_entry_layout_index_to_text_index(Xen_to_C_GtkEntry_(entry), Xen_to_C_gint(layout_index))));
}

static Xen gxg_gtk_entry_text_index_to_layout_index(Xen entry, Xen text_index)
{
  #define H_gtk_entry_text_index_to_layout_index "gint gtk_entry_text_index_to_layout_index(GtkEntry* entry, \
gint text_index)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_text_index_to_layout_index", "GtkEntry*");
  Xen_check_type(Xen_is_gint(text_index), text_index, 2, "gtk_entry_text_index_to_layout_index", "gint");
  return(C_to_Xen_gint(gtk_entry_text_index_to_layout_index(Xen_to_C_GtkEntry_(entry), Xen_to_C_gint(text_index))));
}

static Xen gxg_gtk_file_chooser_set_show_hidden(Xen chooser, Xen show_hidden)
{
  #define H_gtk_file_chooser_set_show_hidden "void gtk_file_chooser_set_show_hidden(GtkFileChooser* chooser, \
gboolean show_hidden)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_show_hidden", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(show_hidden), show_hidden, 2, "gtk_file_chooser_set_show_hidden", "gboolean");
  gtk_file_chooser_set_show_hidden(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(show_hidden));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_show_hidden(Xen chooser)
{
  #define H_gtk_file_chooser_get_show_hidden "gboolean gtk_file_chooser_get_show_hidden(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_show_hidden", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_show_hidden(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_tree_view_set_hover_expand(Xen tree_view, Xen expand)
{
  #define H_gtk_tree_view_set_hover_expand "void gtk_tree_view_set_hover_expand(GtkTreeView* tree_view, \
gboolean expand)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_hover_expand", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 2, "gtk_tree_view_set_hover_expand", "gboolean");
  gtk_tree_view_set_hover_expand(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_hover_expand(Xen tree_view)
{
  #define H_gtk_tree_view_get_hover_expand "gboolean gtk_tree_view_get_hover_expand(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_hover_expand", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_hover_expand(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tool_item_rebuild_menu(Xen tool_item)
{
  #define H_gtk_tool_item_rebuild_menu "void gtk_tool_item_rebuild_menu(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_rebuild_menu", "GtkToolItem*");
  gtk_tool_item_rebuild_menu(Xen_to_C_GtkToolItem_(tool_item));
  return(Xen_false);
}

static Xen gxg_gtk_menu_tool_button_new(Xen icon_widget, Xen label)
{
  #define H_gtk_menu_tool_button_new "GtkToolItem* gtk_menu_tool_button_new(GtkWidget* icon_widget, gchar* label)"
  Xen_check_type(Xen_is_GtkWidget_(icon_widget) || Xen_is_false(icon_widget), icon_widget, 1, "gtk_menu_tool_button_new", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_menu_tool_button_new", "gchar*");
  return(C_to_Xen_GtkToolItem_(gtk_menu_tool_button_new(Xen_to_C_GtkWidget_(icon_widget), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_menu_tool_button_set_menu(Xen button, Xen menu)
{
  #define H_gtk_menu_tool_button_set_menu "void gtk_menu_tool_button_set_menu(GtkMenuToolButton* button, \
GtkWidget* menu)"
  Xen_check_type(Xen_is_GtkMenuToolButton_(button), button, 1, "gtk_menu_tool_button_set_menu", "GtkMenuToolButton*");
  Xen_check_type(Xen_is_GtkWidget_(menu), menu, 2, "gtk_menu_tool_button_set_menu", "GtkWidget*");
  gtk_menu_tool_button_set_menu(Xen_to_C_GtkMenuToolButton_(button), Xen_to_C_GtkWidget_(menu));
  return(Xen_false);
}

static Xen gxg_gtk_menu_tool_button_get_menu(Xen button)
{
  #define H_gtk_menu_tool_button_get_menu "GtkWidget* gtk_menu_tool_button_get_menu(GtkMenuToolButton* button)"
  Xen_check_type(Xen_is_GtkMenuToolButton_(button), button, 1, "gtk_menu_tool_button_get_menu", "GtkMenuToolButton*");
  return(C_to_Xen_GtkWidget_(gtk_menu_tool_button_get_menu(Xen_to_C_GtkMenuToolButton_(button))));
}

static Xen gxg_gtk_about_dialog_get_logo_icon_name(Xen about)
{
  #define H_gtk_about_dialog_get_logo_icon_name "gchar* gtk_about_dialog_get_logo_icon_name(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_logo_icon_name", "GtkAboutDialog*");
  return(C_to_Xen_gchar_(gtk_about_dialog_get_logo_icon_name(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_logo_icon_name(Xen about, Xen icon_name)
{
  #define H_gtk_about_dialog_set_logo_icon_name "void gtk_about_dialog_set_logo_icon_name(GtkAboutDialog* about, \
gchar* icon_name)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_logo_icon_name", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_about_dialog_set_logo_icon_name", "gchar*");
  gtk_about_dialog_set_logo_icon_name(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_gchar_(icon_name));
  return(Xen_false);
}

static Xen gxg_gtk_accelerator_get_label(Xen accelerator_key, Xen accelerator_mods)
{
  #define H_gtk_accelerator_get_label "gchar* gtk_accelerator_get_label(guint accelerator_key, GdkModifierType accelerator_mods)"
  Xen_check_type(Xen_is_guint(accelerator_key), accelerator_key, 1, "gtk_accelerator_get_label", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accelerator_mods), accelerator_mods, 2, "gtk_accelerator_get_label", "GdkModifierType");
  {
   gchar* result;
   Xen rtn;
   result = gtk_accelerator_get_label(Xen_to_C_guint(accelerator_key), Xen_to_C_GdkModifierType(accelerator_mods));
   rtn = C_to_Xen_gchar_(result);
   g_free(result);
   return(rtn);
  }
}

static Xen gxg_gtk_drag_dest_add_image_targets(Xen widget)
{
  #define H_gtk_drag_dest_add_image_targets "void gtk_drag_dest_add_image_targets(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_add_image_targets", "GtkWidget*");
  gtk_drag_dest_add_image_targets(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_dest_add_uri_targets(Xen widget)
{
  #define H_gtk_drag_dest_add_uri_targets "void gtk_drag_dest_add_uri_targets(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_add_uri_targets", "GtkWidget*");
  gtk_drag_dest_add_uri_targets(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_add_image_targets(Xen widget)
{
  #define H_gtk_drag_source_add_image_targets "void gtk_drag_source_add_image_targets(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_add_image_targets", "GtkWidget*");
  gtk_drag_source_add_image_targets(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_add_uri_targets(Xen widget)
{
  #define H_gtk_drag_source_add_uri_targets "void gtk_drag_source_add_uri_targets(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_add_uri_targets", "GtkWidget*");
  gtk_drag_source_add_uri_targets(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_button_get_width_chars(Xen button)
{
  #define H_gtk_file_chooser_button_get_width_chars "gint gtk_file_chooser_button_get_width_chars(GtkFileChooserButton* button)"
  Xen_check_type(Xen_is_GtkFileChooserButton_(button), button, 1, "gtk_file_chooser_button_get_width_chars", "GtkFileChooserButton*");
  return(C_to_Xen_gint(gtk_file_chooser_button_get_width_chars(Xen_to_C_GtkFileChooserButton_(button))));
}

static Xen gxg_gtk_file_chooser_button_set_width_chars(Xen button, Xen n_chars)
{
  #define H_gtk_file_chooser_button_set_width_chars "void gtk_file_chooser_button_set_width_chars(GtkFileChooserButton* button, \
gint n_chars)"
  Xen_check_type(Xen_is_GtkFileChooserButton_(button), button, 1, "gtk_file_chooser_button_set_width_chars", "GtkFileChooserButton*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 2, "gtk_file_chooser_button_set_width_chars", "gint");
  gtk_file_chooser_button_set_width_chars(Xen_to_C_GtkFileChooserButton_(button), Xen_to_C_gint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_image_set_pixel_size(Xen image, Xen pixel_size)
{
  #define H_gtk_image_set_pixel_size "void gtk_image_set_pixel_size(GtkImage* image, gint pixel_size)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_pixel_size", "GtkImage*");
  Xen_check_type(Xen_is_gint(pixel_size), pixel_size, 2, "gtk_image_set_pixel_size", "gint");
  gtk_image_set_pixel_size(Xen_to_C_GtkImage_(image), Xen_to_C_gint(pixel_size));
  return(Xen_false);
}

static Xen gxg_gtk_image_get_pixel_size(Xen image)
{
  #define H_gtk_image_get_pixel_size "gint gtk_image_get_pixel_size(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_pixel_size", "GtkImage*");
  return(C_to_Xen_gint(gtk_image_get_pixel_size(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_label_set_width_chars(Xen label, Xen n_chars)
{
  #define H_gtk_label_set_width_chars "void gtk_label_set_width_chars(GtkLabel* label, gint n_chars)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_width_chars", "GtkLabel*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 2, "gtk_label_set_width_chars", "gint");
  gtk_label_set_width_chars(Xen_to_C_GtkLabel_(label), Xen_to_C_gint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_width_chars(Xen label)
{
  #define H_gtk_label_get_width_chars "gint gtk_label_get_width_chars(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_width_chars", "GtkLabel*");
  return(C_to_Xen_gint(gtk_label_get_width_chars(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_text_buffer_backspace(Xen buffer, Xen iter, Xen interactive, Xen default_editable)
{
  #define H_gtk_text_buffer_backspace "gboolean gtk_text_buffer_backspace(GtkTextBuffer* buffer, GtkTextIter* iter, \
gboolean interactive, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_backspace", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_backspace", "GtkTextIter*");
  Xen_check_type(Xen_is_gboolean(interactive), interactive, 3, "gtk_text_buffer_backspace", "gboolean");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 4, "gtk_text_buffer_backspace", "gboolean");
  return(C_to_Xen_gboolean(gtk_text_buffer_backspace(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gboolean(interactive), 
                                                     Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_file_filter_add_pixbuf_formats(Xen filter)
{
  #define H_gtk_file_filter_add_pixbuf_formats "void gtk_file_filter_add_pixbuf_formats(GtkFileFilter* filter)"
  Xen_check_type(Xen_is_GtkFileFilter_(filter), filter, 1, "gtk_file_filter_add_pixbuf_formats", "GtkFileFilter*");
  gtk_file_filter_add_pixbuf_formats(Xen_to_C_GtkFileFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_single_line_mode(Xen label, Xen single_line_mode)
{
  #define H_gtk_label_set_single_line_mode "void gtk_label_set_single_line_mode(GtkLabel* label, gboolean single_line_mode)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_single_line_mode", "GtkLabel*");
  Xen_check_type(Xen_is_gboolean(single_line_mode), single_line_mode, 2, "gtk_label_set_single_line_mode", "gboolean");
  gtk_label_set_single_line_mode(Xen_to_C_GtkLabel_(label), Xen_to_C_gboolean(single_line_mode));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_single_line_mode(Xen label)
{
  #define H_gtk_label_get_single_line_mode "gboolean gtk_label_get_single_line_mode(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_single_line_mode", "GtkLabel*");
  return(C_to_Xen_gboolean(gtk_label_get_single_line_mode(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_progress_bar_set_ellipsize(Xen pbar, Xen mode)
{
  #define H_gtk_progress_bar_set_ellipsize "void gtk_progress_bar_set_ellipsize(GtkProgressBar* pbar, \
PangoEllipsizeMode mode)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_set_ellipsize", "GtkProgressBar*");
  Xen_check_type(Xen_is_PangoEllipsizeMode(mode), mode, 2, "gtk_progress_bar_set_ellipsize", "PangoEllipsizeMode");
  gtk_progress_bar_set_ellipsize(Xen_to_C_GtkProgressBar_(pbar), Xen_to_C_PangoEllipsizeMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_get_ellipsize(Xen pbar)
{
  #define H_gtk_progress_bar_get_ellipsize "PangoEllipsizeMode gtk_progress_bar_get_ellipsize(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_get_ellipsize", "GtkProgressBar*");
  return(C_to_Xen_PangoEllipsizeMode(gtk_progress_bar_get_ellipsize(Xen_to_C_GtkProgressBar_(pbar))));
}

static Xen gxg_gtk_selection_data_targets_include_image(Xen selection_data, Xen writable)
{
  #define H_gtk_selection_data_targets_include_image "gboolean gtk_selection_data_targets_include_image(GtkSelectionData* selection_data, \
gboolean writable)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_targets_include_image", "GtkSelectionData*");
  Xen_check_type(Xen_is_gboolean(writable), writable, 2, "gtk_selection_data_targets_include_image", "gboolean");
  return(C_to_Xen_gboolean(gtk_selection_data_targets_include_image(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_gboolean(writable))));
}

static Xen gxg_pango_attr_underline_color_new(Xen red, Xen green, Xen blue)
{
  #define H_pango_attr_underline_color_new "PangoAttribute* pango_attr_underline_color_new(guint16 red, \
guint16 green, guint16 blue)"
  Xen_check_type(Xen_is_guint16(red), red, 1, "pango_attr_underline_color_new", "guint16");
  Xen_check_type(Xen_is_guint16(green), green, 2, "pango_attr_underline_color_new", "guint16");
  Xen_check_type(Xen_is_guint16(blue), blue, 3, "pango_attr_underline_color_new", "guint16");
  return(C_to_Xen_PangoAttribute_(pango_attr_underline_color_new(Xen_to_C_guint16(red), Xen_to_C_guint16(green), Xen_to_C_guint16(blue))));
}

static Xen gxg_pango_attr_strikethrough_color_new(Xen red, Xen green, Xen blue)
{
  #define H_pango_attr_strikethrough_color_new "PangoAttribute* pango_attr_strikethrough_color_new(guint16 red, \
guint16 green, guint16 blue)"
  Xen_check_type(Xen_is_guint16(red), red, 1, "pango_attr_strikethrough_color_new", "guint16");
  Xen_check_type(Xen_is_guint16(green), green, 2, "pango_attr_strikethrough_color_new", "guint16");
  Xen_check_type(Xen_is_guint16(blue), blue, 3, "pango_attr_strikethrough_color_new", "guint16");
  return(C_to_Xen_PangoAttribute_(pango_attr_strikethrough_color_new(Xen_to_C_guint16(red), Xen_to_C_guint16(green), Xen_to_C_guint16(blue))));
}

static Xen gxg_pango_renderer_draw_layout(Xen renderer, Xen layout, Xen x, Xen y)
{
  #define H_pango_renderer_draw_layout "void pango_renderer_draw_layout(PangoRenderer* renderer, PangoLayout* layout, \
int x, int y)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_layout", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 2, "pango_renderer_draw_layout", "PangoLayout*");
  Xen_check_type(Xen_is_int(x), x, 3, "pango_renderer_draw_layout", "int");
  Xen_check_type(Xen_is_int(y), y, 4, "pango_renderer_draw_layout", "int");
  pango_renderer_draw_layout(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoLayout_(layout), Xen_to_C_int(x), Xen_to_C_int(y));
  return(Xen_false);
}

static Xen gxg_pango_renderer_draw_layout_line(Xen renderer, Xen line, Xen x, Xen y)
{
  #define H_pango_renderer_draw_layout_line "void pango_renderer_draw_layout_line(PangoRenderer* renderer, \
PangoLayoutLine* line, int x, int y)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_layout_line", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 2, "pango_renderer_draw_layout_line", "PangoLayoutLine*");
  Xen_check_type(Xen_is_int(x), x, 3, "pango_renderer_draw_layout_line", "int");
  Xen_check_type(Xen_is_int(y), y, 4, "pango_renderer_draw_layout_line", "int");
  pango_renderer_draw_layout_line(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoLayoutLine_(line), Xen_to_C_int(x), Xen_to_C_int(y));
  return(Xen_false);
}

static Xen gxg_pango_renderer_draw_glyphs(Xen renderer, Xen font, Xen glyphs, Xen x, Xen y)
{
  #define H_pango_renderer_draw_glyphs "void pango_renderer_draw_glyphs(PangoRenderer* renderer, PangoFont* font, \
PangoGlyphString* glyphs, int x, int y)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_glyphs", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoFont_(font), font, 2, "pango_renderer_draw_glyphs", "PangoFont*");
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 3, "pango_renderer_draw_glyphs", "PangoGlyphString*");
  Xen_check_type(Xen_is_int(x), x, 4, "pango_renderer_draw_glyphs", "int");
  Xen_check_type(Xen_is_int(y), y, 5, "pango_renderer_draw_glyphs", "int");
  pango_renderer_draw_glyphs(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoFont_(font), Xen_to_C_PangoGlyphString_(glyphs), 
                             Xen_to_C_int(x), Xen_to_C_int(y));
  return(Xen_false);
}

static Xen gxg_pango_renderer_draw_rectangle(Xen renderer, Xen part, Xen x, Xen y, Xen width, Xen height)
{
  #define H_pango_renderer_draw_rectangle "void pango_renderer_draw_rectangle(PangoRenderer* renderer, \
PangoRenderPart part, int x, int y, int width, int height)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_rectangle", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoRenderPart(part), part, 2, "pango_renderer_draw_rectangle", "PangoRenderPart");
  Xen_check_type(Xen_is_int(x), x, 3, "pango_renderer_draw_rectangle", "int");
  Xen_check_type(Xen_is_int(y), y, 4, "pango_renderer_draw_rectangle", "int");
  Xen_check_type(Xen_is_int(width), width, 5, "pango_renderer_draw_rectangle", "int");
  Xen_check_type(Xen_is_int(height), height, 6, "pango_renderer_draw_rectangle", "int");
  pango_renderer_draw_rectangle(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoRenderPart(part), Xen_to_C_int(x), Xen_to_C_int(y), 
                                Xen_to_C_int(width), Xen_to_C_int(height));
  return(Xen_false);
}

static Xen gxg_pango_renderer_draw_error_underline(Xen renderer, Xen x, Xen y, Xen width, Xen height)
{
  #define H_pango_renderer_draw_error_underline "void pango_renderer_draw_error_underline(PangoRenderer* renderer, \
int x, int y, int width, int height)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_error_underline", "PangoRenderer*");
  Xen_check_type(Xen_is_int(x), x, 2, "pango_renderer_draw_error_underline", "int");
  Xen_check_type(Xen_is_int(y), y, 3, "pango_renderer_draw_error_underline", "int");
  Xen_check_type(Xen_is_int(width), width, 4, "pango_renderer_draw_error_underline", "int");
  Xen_check_type(Xen_is_int(height), height, 5, "pango_renderer_draw_error_underline", "int");
  pango_renderer_draw_error_underline(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_int(x), Xen_to_C_int(y), Xen_to_C_int(width), 
                                      Xen_to_C_int(height));
  return(Xen_false);
}

static Xen gxg_pango_renderer_draw_trapezoid(Xen arglist)
{
  #define H_pango_renderer_draw_trapezoid "void pango_renderer_draw_trapezoid(PangoRenderer* renderer, \
PangoRenderPart part, double y1, double x11, double x21, double y2, double x12, double x22)"
  Xen renderer, part, y1, x11, x21, y2, x12, x22;
  renderer = Xen_list_ref(arglist, 0);
  part = Xen_list_ref(arglist, 1);
  y1 = Xen_list_ref(arglist, 2);
  x11 = Xen_list_ref(arglist, 3);
  x21 = Xen_list_ref(arglist, 4);
  y2 = Xen_list_ref(arglist, 5);
  x12 = Xen_list_ref(arglist, 6);
  x22 = Xen_list_ref(arglist, 7);
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_trapezoid", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoRenderPart(part), part, 2, "pango_renderer_draw_trapezoid", "PangoRenderPart");
  Xen_check_type(Xen_is_double(y1), y1, 3, "pango_renderer_draw_trapezoid", "double");
  Xen_check_type(Xen_is_double(x11), x11, 4, "pango_renderer_draw_trapezoid", "double");
  Xen_check_type(Xen_is_double(x21), x21, 5, "pango_renderer_draw_trapezoid", "double");
  Xen_check_type(Xen_is_double(y2), y2, 6, "pango_renderer_draw_trapezoid", "double");
  Xen_check_type(Xen_is_double(x12), x12, 7, "pango_renderer_draw_trapezoid", "double");
  Xen_check_type(Xen_is_double(x22), x22, 8, "pango_renderer_draw_trapezoid", "double");
  pango_renderer_draw_trapezoid(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoRenderPart(part), Xen_to_C_double(y1), Xen_to_C_double(x11), 
                                Xen_to_C_double(x21), Xen_to_C_double(y2), Xen_to_C_double(x12), Xen_to_C_double(x22));
  return(Xen_false);
}

static Xen gxg_pango_renderer_draw_glyph(Xen renderer, Xen font, Xen glyph, Xen x, Xen y)
{
  #define H_pango_renderer_draw_glyph "void pango_renderer_draw_glyph(PangoRenderer* renderer, PangoFont* font, \
PangoGlyph glyph, double x, double y)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_draw_glyph", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoFont_(font), font, 2, "pango_renderer_draw_glyph", "PangoFont*");
  Xen_check_type(Xen_is_PangoGlyph(glyph), glyph, 3, "pango_renderer_draw_glyph", "PangoGlyph");
  Xen_check_type(Xen_is_double(x), x, 4, "pango_renderer_draw_glyph", "double");
  Xen_check_type(Xen_is_double(y), y, 5, "pango_renderer_draw_glyph", "double");
  pango_renderer_draw_glyph(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoFont_(font), Xen_to_C_PangoGlyph(glyph), Xen_to_C_double(x), 
                            Xen_to_C_double(y));
  return(Xen_false);
}

static Xen gxg_pango_renderer_activate(Xen renderer)
{
  #define H_pango_renderer_activate "void pango_renderer_activate(PangoRenderer* renderer)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_activate", "PangoRenderer*");
  pango_renderer_activate(Xen_to_C_PangoRenderer_(renderer));
  return(Xen_false);
}

static Xen gxg_pango_renderer_deactivate(Xen renderer)
{
  #define H_pango_renderer_deactivate "void pango_renderer_deactivate(PangoRenderer* renderer)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_deactivate", "PangoRenderer*");
  pango_renderer_deactivate(Xen_to_C_PangoRenderer_(renderer));
  return(Xen_false);
}

static Xen gxg_pango_renderer_part_changed(Xen renderer, Xen part)
{
  #define H_pango_renderer_part_changed "void pango_renderer_part_changed(PangoRenderer* renderer, PangoRenderPart part)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_part_changed", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoRenderPart(part), part, 2, "pango_renderer_part_changed", "PangoRenderPart");
  pango_renderer_part_changed(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoRenderPart(part));
  return(Xen_false);
}

static Xen gxg_pango_renderer_set_color(Xen renderer, Xen part, Xen color)
{
  #define H_pango_renderer_set_color "void pango_renderer_set_color(PangoRenderer* renderer, PangoRenderPart part, \
PangoColor* color)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_set_color", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoRenderPart(part), part, 2, "pango_renderer_set_color", "PangoRenderPart");
  Xen_check_type(Xen_is_PangoColor_(color), color, 3, "pango_renderer_set_color", "PangoColor*");
  pango_renderer_set_color(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoRenderPart(part), Xen_to_C_PangoColor_(color));
  return(Xen_false);
}

static Xen gxg_pango_renderer_get_color(Xen renderer, Xen part)
{
  #define H_pango_renderer_get_color "PangoColor* pango_renderer_get_color(PangoRenderer* renderer, PangoRenderPart part)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_get_color", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoRenderPart(part), part, 2, "pango_renderer_get_color", "PangoRenderPart");
  return(C_to_Xen_PangoColor_(pango_renderer_get_color(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoRenderPart(part))));
}

static Xen gxg_pango_renderer_set_matrix(Xen renderer, Xen matrix)
{
  #define H_pango_renderer_set_matrix "void pango_renderer_set_matrix(PangoRenderer* renderer, PangoMatrix* matrix)"
  Xen_check_type(Xen_is_PangoRenderer_(renderer), renderer, 1, "pango_renderer_set_matrix", "PangoRenderer*");
  Xen_check_type(Xen_is_PangoMatrix_(matrix), matrix, 2, "pango_renderer_set_matrix", "PangoMatrix*");
  pango_renderer_set_matrix(Xen_to_C_PangoRenderer_(renderer), Xen_to_C_PangoMatrix_(matrix));
  return(Xen_false);
}

static Xen gxg_g_log_set_handler(Xen log_domain, Xen log_levels, Xen func, Xen func_info)
{
  #define H_g_log_set_handler "guint g_log_set_handler(gchar* log_domain, GLogLevelFlags log_levels, \
GLogFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_gchar_(log_domain), log_domain, 1, "g_log_set_handler", "gchar*");
  Xen_check_type(Xen_is_GLogLevelFlags(log_levels), log_levels, 2, "g_log_set_handler", "GLogLevelFlags");
  Xen_check_type(Xen_is_GLogFunc(func), func, 3, "g_log_set_handler", "GLogFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "g_log_set_handler", "lambda_data");
  {
    Xen result;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    result = C_to_Xen_guint(g_log_set_handler(Xen_to_C_gchar_(log_domain), Xen_to_C_GLogLevelFlags(log_levels), Xen_to_C_GLogFunc(func), 
                                              Xen_to_C_lambda_data(func_info)));
    return(result);
   }
}

static Xen gxg_g_log_remove_handler(Xen log_domain, Xen handler_id)
{
  #define H_g_log_remove_handler "void g_log_remove_handler(gchar* log_domain, guint handler_id)"
  Xen_check_type(Xen_is_gchar_(log_domain), log_domain, 1, "g_log_remove_handler", "gchar*");
  Xen_check_type(Xen_is_guint(handler_id), handler_id, 2, "g_log_remove_handler", "guint");
  g_log_remove_handler(Xen_to_C_gchar_(log_domain), Xen_to_C_guint(handler_id));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_stop_editing(Xen cell, Xen canceled)
{
  #define H_gtk_cell_renderer_stop_editing "void gtk_cell_renderer_stop_editing(GtkCellRenderer* cell, \
gboolean canceled)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_stop_editing", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(canceled), canceled, 2, "gtk_cell_renderer_stop_editing", "gboolean");
  gtk_cell_renderer_stop_editing(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(canceled));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_button_new(Xen title, Xen action)
{
  #define H_gtk_file_chooser_button_new "GtkWidget* gtk_file_chooser_button_new(gchar* title, GtkFileChooserAction action)"
  Xen_check_type(Xen_is_gchar_(title), title, 1, "gtk_file_chooser_button_new", "gchar*");
  Xen_check_type(Xen_is_GtkFileChooserAction(action), action, 2, "gtk_file_chooser_button_new", "GtkFileChooserAction");
  return(C_to_Xen_GtkWidget_(gtk_file_chooser_button_new((const gchar*)Xen_to_C_gchar_(title), Xen_to_C_GtkFileChooserAction(action))));
}

static Xen gxg_gtk_icon_view_set_columns(Xen icon_view, Xen columns)
{
  #define H_gtk_icon_view_set_columns "void gtk_icon_view_set_columns(GtkIconView* icon_view, gint columns)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_columns", "GtkIconView*");
  Xen_check_type(Xen_is_gint(columns), columns, 2, "gtk_icon_view_set_columns", "gint");
  gtk_icon_view_set_columns(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(columns));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_columns(Xen icon_view)
{
  #define H_gtk_icon_view_get_columns "gint gtk_icon_view_get_columns(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_columns", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_columns(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_item_width(Xen icon_view, Xen item_width)
{
  #define H_gtk_icon_view_set_item_width "void gtk_icon_view_set_item_width(GtkIconView* icon_view, gint item_width)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_item_width", "GtkIconView*");
  Xen_check_type(Xen_is_gint(item_width), item_width, 2, "gtk_icon_view_set_item_width", "gint");
  gtk_icon_view_set_item_width(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(item_width));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_item_width(Xen icon_view)
{
  #define H_gtk_icon_view_get_item_width "gint gtk_icon_view_get_item_width(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_item_width", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_item_width(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_spacing(Xen icon_view, Xen spacing)
{
  #define H_gtk_icon_view_set_spacing "void gtk_icon_view_set_spacing(GtkIconView* icon_view, gint spacing)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_spacing", "GtkIconView*");
  Xen_check_type(Xen_is_gint(spacing), spacing, 2, "gtk_icon_view_set_spacing", "gint");
  gtk_icon_view_set_spacing(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_spacing(Xen icon_view)
{
  #define H_gtk_icon_view_get_spacing "gint gtk_icon_view_get_spacing(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_spacing", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_spacing(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_row_spacing(Xen icon_view, Xen row_spacing)
{
  #define H_gtk_icon_view_set_row_spacing "void gtk_icon_view_set_row_spacing(GtkIconView* icon_view, \
gint row_spacing)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_row_spacing", "GtkIconView*");
  Xen_check_type(Xen_is_gint(row_spacing), row_spacing, 2, "gtk_icon_view_set_row_spacing", "gint");
  gtk_icon_view_set_row_spacing(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(row_spacing));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_row_spacing(Xen icon_view)
{
  #define H_gtk_icon_view_get_row_spacing "gint gtk_icon_view_get_row_spacing(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_row_spacing", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_row_spacing(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_column_spacing(Xen icon_view, Xen column_spacing)
{
  #define H_gtk_icon_view_set_column_spacing "void gtk_icon_view_set_column_spacing(GtkIconView* icon_view, \
gint column_spacing)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_column_spacing", "GtkIconView*");
  Xen_check_type(Xen_is_gint(column_spacing), column_spacing, 2, "gtk_icon_view_set_column_spacing", "gint");
  gtk_icon_view_set_column_spacing(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(column_spacing));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_column_spacing(Xen icon_view)
{
  #define H_gtk_icon_view_get_column_spacing "gint gtk_icon_view_get_column_spacing(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_column_spacing", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_column_spacing(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_margin(Xen icon_view, Xen margin)
{
  #define H_gtk_icon_view_set_margin "void gtk_icon_view_set_margin(GtkIconView* icon_view, gint margin)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_margin", "GtkIconView*");
  Xen_check_type(Xen_is_gint(margin), margin, 2, "gtk_icon_view_set_margin", "gint");
  gtk_icon_view_set_margin(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(margin));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_margin(Xen icon_view)
{
  #define H_gtk_icon_view_get_margin "gint gtk_icon_view_get_margin(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_margin", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_margin(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_label_set_max_width_chars(Xen label, Xen n_chars)
{
  #define H_gtk_label_set_max_width_chars "void gtk_label_set_max_width_chars(GtkLabel* label, gint n_chars)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_max_width_chars", "GtkLabel*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 2, "gtk_label_set_max_width_chars", "gint");
  gtk_label_set_max_width_chars(Xen_to_C_GtkLabel_(label), Xen_to_C_gint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_max_width_chars(Xen label)
{
  #define H_gtk_label_get_max_width_chars "gint gtk_label_get_max_width_chars(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_max_width_chars", "GtkLabel*");
  return(C_to_Xen_gint(gtk_label_get_max_width_chars(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_list_store_insert_with_values(Xen list_store, Xen iter, Xen position)
{
  #define H_gtk_list_store_insert_with_values "void gtk_list_store_insert_with_values(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, ...)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_insert_with_values", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_insert_with_values", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_list_store_insert_with_values", "gint");
  gtk_list_store_insert_with_values(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_list_store_insert_with_valuesv(Xen list_store, Xen iter, Xen position, Xen columns, Xen values, Xen n_values)
{
  #define H_gtk_list_store_insert_with_valuesv "void gtk_list_store_insert_with_valuesv(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, gint* columns, GValue* values, gint n_values)"
  Xen_check_type(Xen_is_GtkListStore_(list_store), list_store, 1, "gtk_list_store_insert_with_valuesv", "GtkListStore*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_list_store_insert_with_valuesv", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_list_store_insert_with_valuesv", "gint");
  Xen_check_type(Xen_is_gint_(columns), columns, 4, "gtk_list_store_insert_with_valuesv", "gint*");
  Xen_check_type(Xen_is_GValue_(values), values, 5, "gtk_list_store_insert_with_valuesv", "GValue*");
  Xen_check_type(Xen_is_gint(n_values), n_values, 6, "gtk_list_store_insert_with_valuesv", "gint");
  gtk_list_store_insert_with_valuesv(Xen_to_C_GtkListStore_(list_store), Xen_to_C_GtkTreeIter_(iter), Xen_to_C_gint(position), 
                                     Xen_to_C_gint_(columns), Xen_to_C_GValue_(values), Xen_to_C_gint(n_values));
  return(Xen_false);
}

static Xen gxg_pango_attr_size_new_absolute(Xen size)
{
  #define H_pango_attr_size_new_absolute "PangoAttribute* pango_attr_size_new_absolute(int size)"
  Xen_check_type(Xen_is_int(size), size, 1, "pango_attr_size_new_absolute", "int");
  return(C_to_Xen_PangoAttribute_(pango_attr_size_new_absolute(Xen_to_C_int(size))));
}

static Xen gxg_pango_font_description_set_absolute_size(Xen desc, Xen size)
{
  #define H_pango_font_description_set_absolute_size "void pango_font_description_set_absolute_size(PangoFontDescription* desc, \
double size)"
  Xen_check_type(Xen_is_PangoFontDescription_(desc), desc, 1, "pango_font_description_set_absolute_size", "PangoFontDescription*");
  Xen_check_type(Xen_is_double(size), size, 2, "pango_font_description_set_absolute_size", "double");
  pango_font_description_set_absolute_size(Xen_to_C_PangoFontDescription_(desc), Xen_to_C_double(size));
  return(Xen_false);
}

static Xen gxg_pango_layout_get_font_description(Xen layout)
{
  #define H_pango_layout_get_font_description "PangoFontDescription* pango_layout_get_font_description(PangoLayout* layout)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_get_font_description", "PangoLayout*");
    return(C_to_Xen_PangoFontDescription_((PangoFontDescription*)pango_layout_get_font_description(Xen_to_C_PangoLayout_(layout))));
}

static Xen gxg_gdk_window_set_urgency_hint(Xen window, Xen urgent)
{
  #define H_gdk_window_set_urgency_hint "void gdk_window_set_urgency_hint(GdkWindow* window, gboolean urgent)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_urgency_hint", "GdkWindow*");
  Xen_check_type(Xen_is_gboolean(urgent), urgent, 2, "gdk_window_set_urgency_hint", "gboolean");
  gdk_window_set_urgency_hint(Xen_to_C_GdkWindow_(window), Xen_to_C_gboolean(urgent));
  return(Xen_false);
}

static Xen gxg_gtk_dialog_get_response_for_widget(Xen dialog, Xen widget)
{
  #define H_gtk_dialog_get_response_for_widget "gint gtk_dialog_get_response_for_widget(GtkDialog* dialog, \
GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_get_response_for_widget", "GtkDialog*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_dialog_get_response_for_widget", "GtkWidget*");
  return(C_to_Xen_gint(gtk_dialog_get_response_for_widget(Xen_to_C_GtkDialog_(dialog), Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_drag_source_set_icon_name(Xen widget, Xen icon_name)
{
  #define H_gtk_drag_source_set_icon_name "void gtk_drag_source_set_icon_name(GtkWidget* widget, gchar* icon_name)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_set_icon_name", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_drag_source_set_icon_name", "gchar*");
  gtk_drag_source_set_icon_name(Xen_to_C_GtkWidget_(widget), (const gchar*)Xen_to_C_gchar_(icon_name));
  return(Xen_false);
}

static Xen gxg_gtk_drag_set_icon_name(Xen context, Xen icon_name, Xen hot_x, Xen hot_y)
{
  #define H_gtk_drag_set_icon_name "void gtk_drag_set_icon_name(GdkDragContext* context, gchar* icon_name, \
gint hot_x, gint hot_y)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_set_icon_name", "GdkDragContext*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_drag_set_icon_name", "gchar*");
  Xen_check_type(Xen_is_gint(hot_x), hot_x, 3, "gtk_drag_set_icon_name", "gint");
  Xen_check_type(Xen_is_gint(hot_y), hot_y, 4, "gtk_drag_set_icon_name", "gint");
  gtk_drag_set_icon_name(Xen_to_C_GdkDragContext_(context), (const gchar*)Xen_to_C_gchar_(icon_name), Xen_to_C_gint(hot_x), Xen_to_C_gint(hot_y));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_set_popup_set_width(Xen completion, Xen popup_set_width)
{
  #define H_gtk_entry_completion_set_popup_set_width "void gtk_entry_completion_set_popup_set_width(GtkEntryCompletion* completion, \
gboolean popup_set_width)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_popup_set_width", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gboolean(popup_set_width), popup_set_width, 2, "gtk_entry_completion_set_popup_set_width", "gboolean");
  gtk_entry_completion_set_popup_set_width(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gboolean(popup_set_width));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_popup_set_width(Xen completion)
{
  #define H_gtk_entry_completion_get_popup_set_width "gboolean gtk_entry_completion_get_popup_set_width(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_popup_set_width", "GtkEntryCompletion*");
  return(C_to_Xen_gboolean(gtk_entry_completion_get_popup_set_width(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_completion_set_popup_single_match(Xen completion, Xen popup_single_match)
{
  #define H_gtk_entry_completion_set_popup_single_match "void gtk_entry_completion_set_popup_single_match(GtkEntryCompletion* completion, \
gboolean popup_single_match)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_popup_single_match", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gboolean(popup_single_match), popup_single_match, 2, "gtk_entry_completion_set_popup_single_match", "gboolean");
  gtk_entry_completion_set_popup_single_match(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gboolean(popup_single_match));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_popup_single_match(Xen completion)
{
  #define H_gtk_entry_completion_get_popup_single_match "gboolean gtk_entry_completion_get_popup_single_match(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_popup_single_match", "GtkEntryCompletion*");
  return(C_to_Xen_gboolean(gtk_entry_completion_get_popup_single_match(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_icon_view_get_item_at_pos(Xen icon_view, Xen x, Xen y, Xen ignore_path, Xen ignore_cell)
{
  #define H_gtk_icon_view_get_item_at_pos "gboolean gtk_icon_view_get_item_at_pos(GtkIconView* icon_view, \
gint x, gint y, GtkTreePath** [path], GtkCellRenderer** [cell])"
  GtkTreePath* ref_path = NULL;
  GtkCellRenderer* ref_cell = NULL;
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_item_at_pos", "GtkIconView*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_icon_view_get_item_at_pos", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_icon_view_get_item_at_pos", "gint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_icon_view_get_item_at_pos(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(x), Xen_to_C_gint(y), 
                                                             &ref_path, &ref_cell));
    return(Xen_list_3(result, C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkCellRenderer_(ref_cell)));
   }
}

static Xen gxg_gtk_icon_view_get_visible_range(Xen icon_view, Xen ignore_start_path, Xen ignore_end_path)
{
  #define H_gtk_icon_view_get_visible_range "gboolean gtk_icon_view_get_visible_range(GtkIconView* icon_view, \
GtkTreePath** [start_path], GtkTreePath** [end_path])"
  GtkTreePath* ref_start_path = NULL;
  GtkTreePath* ref_end_path = NULL;
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_visible_range", "GtkIconView*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_icon_view_get_visible_range(Xen_to_C_GtkIconView_(icon_view), &ref_start_path, &ref_end_path));
    return(Xen_list_3(result, C_to_Xen_GtkTreePath_(ref_start_path), C_to_Xen_GtkTreePath_(ref_end_path)));
   }
}

static Xen gxg_gtk_icon_view_set_cursor(Xen icon_view, Xen path, Xen cell, Xen start_editing)
{
  #define H_gtk_icon_view_set_cursor "void gtk_icon_view_set_cursor(GtkIconView* icon_view, GtkTreePath* path, \
GtkCellRenderer* cell, gboolean start_editing)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_cursor", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_set_cursor", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 3, "gtk_icon_view_set_cursor", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(start_editing), start_editing, 4, "gtk_icon_view_set_cursor", "gboolean");
  gtk_icon_view_set_cursor(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkCellRenderer_(cell), 
                           Xen_to_C_gboolean(start_editing));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_cursor(Xen icon_view, Xen ignore_path, Xen ignore_cell)
{
  #define H_gtk_icon_view_get_cursor "gboolean gtk_icon_view_get_cursor(GtkIconView* icon_view, GtkTreePath** [path], \
GtkCellRenderer** [cell])"
  GtkTreePath* ref_path = NULL;
  GtkCellRenderer* ref_cell = NULL;
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_cursor", "GtkIconView*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_icon_view_get_cursor(Xen_to_C_GtkIconView_(icon_view), &ref_path, &ref_cell));
    return(Xen_list_3(result, C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkCellRenderer_(ref_cell)));
   }
}

static Xen gxg_gtk_icon_view_scroll_to_path(Xen icon_view, Xen path, Xen use_align, Xen row_align, Xen col_align)
{
  #define H_gtk_icon_view_scroll_to_path "void gtk_icon_view_scroll_to_path(GtkIconView* icon_view, GtkTreePath* path, \
gboolean use_align, gfloat row_align, gfloat col_align)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_scroll_to_path", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_scroll_to_path", "GtkTreePath*");
  Xen_check_type(Xen_is_gboolean(use_align), use_align, 3, "gtk_icon_view_scroll_to_path", "gboolean");
  Xen_check_type(Xen_is_gfloat(row_align), row_align, 4, "gtk_icon_view_scroll_to_path", "gfloat");
  Xen_check_type(Xen_is_gfloat(col_align), col_align, 5, "gtk_icon_view_scroll_to_path", "gfloat");
  gtk_icon_view_scroll_to_path(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_gboolean(use_align), 
                               Xen_to_C_gfloat(row_align), Xen_to_C_gfloat(col_align));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_unset_model_drag_source(Xen icon_view)
{
  #define H_gtk_icon_view_unset_model_drag_source "void gtk_icon_view_unset_model_drag_source(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_unset_model_drag_source", "GtkIconView*");
  gtk_icon_view_unset_model_drag_source(Xen_to_C_GtkIconView_(icon_view));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_unset_model_drag_dest(Xen icon_view)
{
  #define H_gtk_icon_view_unset_model_drag_dest "void gtk_icon_view_unset_model_drag_dest(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_unset_model_drag_dest", "GtkIconView*");
  gtk_icon_view_unset_model_drag_dest(Xen_to_C_GtkIconView_(icon_view));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_set_reorderable(Xen icon_view, Xen reorderable)
{
  #define H_gtk_icon_view_set_reorderable "void gtk_icon_view_set_reorderable(GtkIconView* icon_view, \
gboolean reorderable)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_reorderable", "GtkIconView*");
  Xen_check_type(Xen_is_gboolean(reorderable), reorderable, 2, "gtk_icon_view_set_reorderable", "gboolean");
  gtk_icon_view_set_reorderable(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gboolean(reorderable));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_reorderable(Xen icon_view)
{
  #define H_gtk_icon_view_get_reorderable "gboolean gtk_icon_view_get_reorderable(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_reorderable", "GtkIconView*");
  return(C_to_Xen_gboolean(gtk_icon_view_get_reorderable(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_icon_view_set_drag_dest_item(Xen icon_view, Xen path, Xen pos)
{
  #define H_gtk_icon_view_set_drag_dest_item "void gtk_icon_view_set_drag_dest_item(GtkIconView* icon_view, \
GtkTreePath* path, GtkIconViewDropPosition pos)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_drag_dest_item", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_set_drag_dest_item", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkIconViewDropPosition(pos), pos, 3, "gtk_icon_view_set_drag_dest_item", "GtkIconViewDropPosition");
  gtk_icon_view_set_drag_dest_item(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkIconViewDropPosition(pos));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_drag_dest_item(Xen icon_view, Xen ignore_path, Xen ignore_pos)
{
  #define H_gtk_icon_view_get_drag_dest_item "void gtk_icon_view_get_drag_dest_item(GtkIconView* icon_view, \
GtkTreePath** [path], GtkIconViewDropPosition* [pos])"
  GtkTreePath* ref_path = NULL;
  GtkIconViewDropPosition ref_pos;
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_drag_dest_item", "GtkIconView*");
  gtk_icon_view_get_drag_dest_item(Xen_to_C_GtkIconView_(icon_view), &ref_path, &ref_pos);
  return(Xen_list_2(C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkIconViewDropPosition(ref_pos)));
}

static Xen gxg_gtk_icon_view_get_dest_item_at_pos(Xen icon_view, Xen drag_x, Xen drag_y, Xen ignore_path, Xen ignore_pos)
{
  #define H_gtk_icon_view_get_dest_item_at_pos "gboolean gtk_icon_view_get_dest_item_at_pos(GtkIconView* icon_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkIconViewDropPosition* [pos])"
  GtkTreePath* ref_path = NULL;
  GtkIconViewDropPosition ref_pos;
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_dest_item_at_pos", "GtkIconView*");
  Xen_check_type(Xen_is_gint(drag_x), drag_x, 2, "gtk_icon_view_get_dest_item_at_pos", "gint");
  Xen_check_type(Xen_is_gint(drag_y), drag_y, 3, "gtk_icon_view_get_dest_item_at_pos", "gint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_icon_view_get_dest_item_at_pos(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(drag_x), 
                                                                  Xen_to_C_gint(drag_y), &ref_path, &ref_pos));
    return(Xen_list_3(result, C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkIconViewDropPosition(ref_pos)));
   }
}

static Xen gxg_gtk_image_clear(Xen image)
{
  #define H_gtk_image_clear "void gtk_image_clear(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_clear", "GtkImage*");
  gtk_image_clear(Xen_to_C_GtkImage_(image));
  return(Xen_false);
}

static Xen gxg_gtk_menu_bar_get_pack_direction(Xen menubar)
{
  #define H_gtk_menu_bar_get_pack_direction "GtkPackDirection gtk_menu_bar_get_pack_direction(GtkMenuBar* menubar)"
  Xen_check_type(Xen_is_GtkMenuBar_(menubar), menubar, 1, "gtk_menu_bar_get_pack_direction", "GtkMenuBar*");
  return(C_to_Xen_GtkPackDirection(gtk_menu_bar_get_pack_direction(Xen_to_C_GtkMenuBar_(menubar))));
}

static Xen gxg_gtk_menu_bar_set_pack_direction(Xen menubar, Xen pack_dir)
{
  #define H_gtk_menu_bar_set_pack_direction "void gtk_menu_bar_set_pack_direction(GtkMenuBar* menubar, \
GtkPackDirection pack_dir)"
  Xen_check_type(Xen_is_GtkMenuBar_(menubar), menubar, 1, "gtk_menu_bar_set_pack_direction", "GtkMenuBar*");
  Xen_check_type(Xen_is_GtkPackDirection(pack_dir), pack_dir, 2, "gtk_menu_bar_set_pack_direction", "GtkPackDirection");
  gtk_menu_bar_set_pack_direction(Xen_to_C_GtkMenuBar_(menubar), Xen_to_C_GtkPackDirection(pack_dir));
  return(Xen_false);
}

static Xen gxg_gtk_menu_bar_get_child_pack_direction(Xen menubar)
{
  #define H_gtk_menu_bar_get_child_pack_direction "GtkPackDirection gtk_menu_bar_get_child_pack_direction(GtkMenuBar* menubar)"
  Xen_check_type(Xen_is_GtkMenuBar_(menubar), menubar, 1, "gtk_menu_bar_get_child_pack_direction", "GtkMenuBar*");
  return(C_to_Xen_GtkPackDirection(gtk_menu_bar_get_child_pack_direction(Xen_to_C_GtkMenuBar_(menubar))));
}

static Xen gxg_gtk_menu_bar_set_child_pack_direction(Xen menubar, Xen child_pack_dir)
{
  #define H_gtk_menu_bar_set_child_pack_direction "void gtk_menu_bar_set_child_pack_direction(GtkMenuBar* menubar, \
GtkPackDirection child_pack_dir)"
  Xen_check_type(Xen_is_GtkMenuBar_(menubar), menubar, 1, "gtk_menu_bar_set_child_pack_direction", "GtkMenuBar*");
  Xen_check_type(Xen_is_GtkPackDirection(child_pack_dir), child_pack_dir, 2, "gtk_menu_bar_set_child_pack_direction", "GtkPackDirection");
  gtk_menu_bar_set_child_pack_direction(Xen_to_C_GtkMenuBar_(menubar), Xen_to_C_GtkPackDirection(child_pack_dir));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_get_take_focus(Xen menu_shell)
{
  #define H_gtk_menu_shell_get_take_focus "gboolean gtk_menu_shell_get_take_focus(GtkMenuShell* menu_shell)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_get_take_focus", "GtkMenuShell*");
  return(C_to_Xen_gboolean(gtk_menu_shell_get_take_focus(Xen_to_C_GtkMenuShell_(menu_shell))));
}

static Xen gxg_gtk_menu_shell_set_take_focus(Xen menu_shell, Xen take_focus)
{
  #define H_gtk_menu_shell_set_take_focus "void gtk_menu_shell_set_take_focus(GtkMenuShell* menu_shell, \
gboolean take_focus)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_set_take_focus", "GtkMenuShell*");
  Xen_check_type(Xen_is_gboolean(take_focus), take_focus, 2, "gtk_menu_shell_set_take_focus", "gboolean");
  gtk_menu_shell_set_take_focus(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_gboolean(take_focus));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_forward_visible_line(Xen iter)
{
  #define H_gtk_text_iter_forward_visible_line "gboolean gtk_text_iter_forward_visible_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_visible_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_visible_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_backward_visible_line(Xen iter)
{
  #define H_gtk_text_iter_backward_visible_line "gboolean gtk_text_iter_backward_visible_line(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_visible_line", "GtkTextIter*");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_visible_line(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_text_iter_forward_visible_lines(Xen iter, Xen count)
{
  #define H_gtk_text_iter_forward_visible_lines "gboolean gtk_text_iter_forward_visible_lines(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_forward_visible_lines", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_forward_visible_lines", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_forward_visible_lines(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_text_iter_backward_visible_lines(Xen iter, Xen count)
{
  #define H_gtk_text_iter_backward_visible_lines "gboolean gtk_text_iter_backward_visible_lines(GtkTextIter* iter, \
gint count)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_backward_visible_lines", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(count), count, 2, "gtk_text_iter_backward_visible_lines", "gint");
  return(C_to_Xen_gboolean(gtk_text_iter_backward_visible_lines(Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(count))));
}

static Xen gxg_gtk_tool_button_set_icon_name(Xen button, Xen icon_name)
{
  #define H_gtk_tool_button_set_icon_name "void gtk_tool_button_set_icon_name(GtkToolButton* button, \
gchar* icon_name)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_set_icon_name", "GtkToolButton*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_tool_button_set_icon_name", "gchar*");
  gtk_tool_button_set_icon_name(Xen_to_C_GtkToolButton_(button), (const gchar*)Xen_to_C_gchar_(icon_name));
  return(Xen_false);
}

static Xen gxg_gtk_tool_button_get_icon_name(Xen button)
{
  #define H_gtk_tool_button_get_icon_name "gchar* gtk_tool_button_get_icon_name(GtkToolButton* button)"
  Xen_check_type(Xen_is_GtkToolButton_(button), button, 1, "gtk_tool_button_get_icon_name", "GtkToolButton*");
    return(C_to_Xen_gchar_((gchar*)gtk_tool_button_get_icon_name(Xen_to_C_GtkToolButton_(button))));
}

static Xen gxg_gtk_window_set_urgency_hint(Xen window, Xen setting)
{
  #define H_gtk_window_set_urgency_hint "void gtk_window_set_urgency_hint(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_urgency_hint", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_urgency_hint", "gboolean");
  gtk_window_set_urgency_hint(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_urgency_hint(Xen window)
{
  #define H_gtk_window_get_urgency_hint "gboolean gtk_window_get_urgency_hint(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_urgency_hint", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_urgency_hint(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_present_with_time(Xen window, Xen timestamp)
{
  #define H_gtk_window_present_with_time "void gtk_window_present_with_time(GtkWindow* window, guint32 timestamp)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_present_with_time", "GtkWindow*");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 2, "gtk_window_present_with_time", "guint32");
  gtk_window_present_with_time(Xen_to_C_GtkWindow_(window), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_set_do_overwrite_confirmation(Xen chooser, Xen do_overwrite_confirmation)
{
  #define H_gtk_file_chooser_set_do_overwrite_confirmation "void gtk_file_chooser_set_do_overwrite_confirmation(GtkFileChooser* chooser, \
gboolean do_overwrite_confirmation)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_do_overwrite_confirmation", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(do_overwrite_confirmation), do_overwrite_confirmation, 2, "gtk_file_chooser_set_do_overwrite_confirmation", "gboolean");
  gtk_file_chooser_set_do_overwrite_confirmation(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(do_overwrite_confirmation));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_do_overwrite_confirmation(Xen chooser)
{
  #define H_gtk_file_chooser_get_do_overwrite_confirmation "gboolean gtk_file_chooser_get_do_overwrite_confirmation(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_do_overwrite_confirmation", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_do_overwrite_confirmation(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_tree_row_reference_get_model(Xen reference)
{
  #define H_gtk_tree_row_reference_get_model "GtkTreeModel* gtk_tree_row_reference_get_model(GtkTreeRowReference* reference)"
  Xen_check_type(Xen_is_GtkTreeRowReference_(reference), reference, 1, "gtk_tree_row_reference_get_model", "GtkTreeRowReference*");
  return(C_to_Xen_GtkTreeModel_(gtk_tree_row_reference_get_model(Xen_to_C_GtkTreeRowReference_(reference))));
}

static Xen gxg_gtk_tree_view_column_queue_resize(Xen tree_column)
{
  #define H_gtk_tree_view_column_queue_resize "void gtk_tree_view_column_queue_resize(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_queue_resize", "GtkTreeViewColumn*");
  gtk_tree_view_column_queue_resize(Xen_to_C_GtkTreeViewColumn_(tree_column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_visible_range(Xen tree_view, Xen ignore_start_path, Xen ignore_end_path)
{
  #define H_gtk_tree_view_get_visible_range "gboolean gtk_tree_view_get_visible_range(GtkTreeView* tree_view, \
GtkTreePath** [start_path], GtkTreePath** [end_path])"
  GtkTreePath* ref_start_path = NULL;
  GtkTreePath* ref_end_path = NULL;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_visible_range", "GtkTreeView*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_view_get_visible_range(Xen_to_C_GtkTreeView_(tree_view), &ref_start_path, &ref_end_path));
    return(Xen_list_3(result, C_to_Xen_GtkTreePath_(ref_start_path), C_to_Xen_GtkTreePath_(ref_end_path)));
   }
}

static Xen gxg_pango_attr_list_ref(Xen list)
{
  #define H_pango_attr_list_ref "PangoAttrList* pango_attr_list_ref(PangoAttrList* list)"
  Xen_check_type(Xen_is_PangoAttrList_(list), list, 1, "pango_attr_list_ref", "PangoAttrList*");
  return(C_to_Xen_PangoAttrList_(pango_attr_list_ref(Xen_to_C_PangoAttrList_(list))));
}

static Xen gxg_pango_layout_line_ref(Xen line)
{
  #define H_pango_layout_line_ref "PangoLayoutLine* pango_layout_line_ref(PangoLayoutLine* line)"
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "pango_layout_line_ref", "PangoLayoutLine*");
  return(C_to_Xen_PangoLayoutLine_(pango_layout_line_ref(Xen_to_C_PangoLayoutLine_(line))));
}

static Xen gxg_pango_layout_index_to_line_x(Xen layout, Xen index_, Xen trailing, Xen ignore_line, Xen ignore_x_pos)
{
  #define H_pango_layout_index_to_line_x "void pango_layout_index_to_line_x(PangoLayout* layout, int index_, \
gboolean trailing, int* [line], int* [x_pos])"
  int ref_line;
  int ref_x_pos;
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "pango_layout_index_to_line_x", "PangoLayout*");
  Xen_check_type(Xen_is_int(index_), index_, 2, "pango_layout_index_to_line_x", "int");
  Xen_check_type(Xen_is_gboolean(trailing), trailing, 3, "pango_layout_index_to_line_x", "gboolean");
  pango_layout_index_to_line_x(Xen_to_C_PangoLayout_(layout), Xen_to_C_int(index_), Xen_to_C_gboolean(trailing), &ref_line, 
                               &ref_x_pos);
  return(Xen_list_2(C_to_Xen_int(ref_line), C_to_Xen_int(ref_x_pos)));
}

static Xen gxg_gdk_display_supports_shapes(Xen display)
{
  #define H_gdk_display_supports_shapes "gboolean gdk_display_supports_shapes(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_supports_shapes", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_supports_shapes(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_supports_input_shapes(Xen display)
{
  #define H_gdk_display_supports_input_shapes "gboolean gdk_display_supports_input_shapes(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_supports_input_shapes", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_supports_input_shapes(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_window_get_type_hint(Xen window)
{
  #define H_gdk_window_get_type_hint "GdkWindowTypeHint gdk_window_get_type_hint(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_type_hint", "GdkWindow*");
  return(C_to_Xen_GdkWindowTypeHint(gdk_window_get_type_hint(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_drag_dest_set_track_motion(Xen widget, Xen track_motion)
{
  #define H_gtk_drag_dest_set_track_motion "void gtk_drag_dest_set_track_motion(GtkWidget* widget, gboolean track_motion)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_set_track_motion", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(track_motion), track_motion, 2, "gtk_drag_dest_set_track_motion", "gboolean");
  gtk_drag_dest_set_track_motion(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(track_motion));
  return(Xen_false);
}

static Xen gxg_gtk_drag_dest_get_track_motion(Xen widget)
{
  #define H_gtk_drag_dest_get_track_motion "gboolean gtk_drag_dest_get_track_motion(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_get_track_motion", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_drag_dest_get_track_motion(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_notebook_get_tab_reorderable(Xen notebook, Xen child)
{
  #define H_gtk_notebook_get_tab_reorderable "gboolean gtk_notebook_get_tab_reorderable(GtkNotebook* notebook, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_tab_reorderable", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_get_tab_reorderable", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_notebook_get_tab_reorderable(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_set_tab_reorderable(Xen notebook, Xen child, Xen reorderable)
{
  #define H_gtk_notebook_set_tab_reorderable "void gtk_notebook_set_tab_reorderable(GtkNotebook* notebook, \
GtkWidget* child, gboolean reorderable)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_tab_reorderable", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_set_tab_reorderable", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(reorderable), reorderable, 3, "gtk_notebook_set_tab_reorderable", "gboolean");
  gtk_notebook_set_tab_reorderable(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_gboolean(reorderable));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_tab_detachable(Xen notebook, Xen child)
{
  #define H_gtk_notebook_get_tab_detachable "gboolean gtk_notebook_get_tab_detachable(GtkNotebook* notebook, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_tab_detachable", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_get_tab_detachable", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_notebook_get_tab_detachable(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_notebook_set_tab_detachable(Xen notebook, Xen child, Xen detachable)
{
  #define H_gtk_notebook_set_tab_detachable "void gtk_notebook_set_tab_detachable(GtkNotebook* notebook, \
GtkWidget* child, gboolean detachable)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_tab_detachable", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_set_tab_detachable", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(detachable), detachable, 3, "gtk_notebook_set_tab_detachable", "gboolean");
  gtk_notebook_set_tab_detachable(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child), Xen_to_C_gboolean(detachable));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_unset_placement(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_unset_placement "void gtk_scrolled_window_unset_placement(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_unset_placement", "GtkScrolledWindow*");
  gtk_scrolled_window_unset_placement(Xen_to_C_GtkScrolledWindow_(scrolled_window));
  return(Xen_false);
}

static Xen gxg_gtk_size_group_get_widgets(Xen size_group)
{
  #define H_gtk_size_group_get_widgets "GSList* gtk_size_group_get_widgets(GtkSizeGroup* size_group)"
  Xen_check_type(Xen_is_GtkSizeGroup_(size_group), size_group, 1, "gtk_size_group_get_widgets", "GtkSizeGroup*");
  return(C_to_Xen_GSList_(gtk_size_group_get_widgets(Xen_to_C_GtkSizeGroup_(size_group))));
}

static Xen gxg_gtk_text_buffer_get_has_selection(Xen buffer)
{
  #define H_gtk_text_buffer_get_has_selection "gboolean gtk_text_buffer_get_has_selection(GtkTextBuffer* buffer)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_get_has_selection", "GtkTextBuffer*");
  return(C_to_Xen_gboolean(gtk_text_buffer_get_has_selection(Xen_to_C_GtkTextBuffer_(buffer))));
}

static Xen gxg_gtk_tree_view_get_headers_clickable(Xen tree_view)
{
  #define H_gtk_tree_view_get_headers_clickable "gboolean gtk_tree_view_get_headers_clickable(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_headers_clickable", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_headers_clickable(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_get_search_entry(Xen tree_view)
{
  #define H_gtk_tree_view_get_search_entry "GtkEntry* gtk_tree_view_get_search_entry(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_search_entry", "GtkTreeView*");
  return(C_to_Xen_GtkEntry_(gtk_tree_view_get_search_entry(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_search_entry(Xen tree_view, Xen entry)
{
  #define H_gtk_tree_view_set_search_entry "void gtk_tree_view_set_search_entry(GtkTreeView* tree_view, \
GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_search_entry", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 2, "gtk_tree_view_set_search_entry", "GtkEntry*");
  gtk_tree_view_set_search_entry(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkEntry_(entry));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_search_position_func(Xen tree_view)
{
  #define H_gtk_tree_view_get_search_position_func "GtkTreeViewSearchPositionFunc gtk_tree_view_get_search_position_func(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_search_position_func", "GtkTreeView*");
  return(C_to_Xen_GtkTreeViewSearchPositionFunc(gtk_tree_view_get_search_position_func(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_search_position_func(Xen tree_view, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_tree_view_set_search_position_func "void gtk_tree_view_set_search_position_func(GtkTreeView* tree_view, \
GtkTreeViewSearchPositionFunc func, lambda_data func_info, GDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_search_position_func", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewSearchPositionFunc(func), func, 2, "gtk_tree_view_set_search_position_func", "GtkTreeViewSearchPositionFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_tree_view_set_search_position_func", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(destroy), destroy, 4, "gtk_tree_view_set_search_position_func", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gtk_tree_view_set_search_position_func(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewSearchPositionFunc(func), Xen_to_C_lambda_data(func_info), 
                                       Xen_to_C_GDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_window_set_deletable(Xen window, Xen setting)
{
  #define H_gtk_window_set_deletable "void gtk_window_set_deletable(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_deletable", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_deletable", "gboolean");
  gtk_window_set_deletable(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_deletable(Xen window)
{
  #define H_gtk_window_get_deletable "gboolean gtk_window_get_deletable(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_deletable", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_deletable(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_assistant_new(void)
{
  #define H_gtk_assistant_new "GtkWidget* gtk_assistant_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_assistant_new()));
}

static Xen gxg_gtk_assistant_get_current_page(Xen assistant)
{
  #define H_gtk_assistant_get_current_page "gint gtk_assistant_get_current_page(GtkAssistant* assistant)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_get_current_page", "GtkAssistant*");
  return(C_to_Xen_gint(gtk_assistant_get_current_page(Xen_to_C_GtkAssistant_(assistant))));
}

static Xen gxg_gtk_assistant_set_current_page(Xen assistant, Xen page_num)
{
  #define H_gtk_assistant_set_current_page "void gtk_assistant_set_current_page(GtkAssistant* assistant, \
gint page_num)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_set_current_page", "GtkAssistant*");
  Xen_check_type(Xen_is_gint(page_num), page_num, 2, "gtk_assistant_set_current_page", "gint");
  gtk_assistant_set_current_page(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_gint(page_num));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_get_n_pages(Xen assistant)
{
  #define H_gtk_assistant_get_n_pages "gint gtk_assistant_get_n_pages(GtkAssistant* assistant)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_get_n_pages", "GtkAssistant*");
  return(C_to_Xen_gint(gtk_assistant_get_n_pages(Xen_to_C_GtkAssistant_(assistant))));
}

static Xen gxg_gtk_assistant_get_nth_page(Xen assistant, Xen page_num)
{
  #define H_gtk_assistant_get_nth_page "GtkWidget* gtk_assistant_get_nth_page(GtkAssistant* assistant, \
gint page_num)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_get_nth_page", "GtkAssistant*");
  Xen_check_type(Xen_is_gint(page_num), page_num, 2, "gtk_assistant_get_nth_page", "gint");
  return(C_to_Xen_GtkWidget_(gtk_assistant_get_nth_page(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_gint(page_num))));
}

static Xen gxg_gtk_assistant_prepend_page(Xen assistant, Xen page)
{
  #define H_gtk_assistant_prepend_page "gint gtk_assistant_prepend_page(GtkAssistant* assistant, GtkWidget* page)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_prepend_page", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_prepend_page", "GtkWidget*");
  return(C_to_Xen_gint(gtk_assistant_prepend_page(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page))));
}

static Xen gxg_gtk_assistant_append_page(Xen assistant, Xen page)
{
  #define H_gtk_assistant_append_page "gint gtk_assistant_append_page(GtkAssistant* assistant, GtkWidget* page)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_append_page", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_append_page", "GtkWidget*");
  return(C_to_Xen_gint(gtk_assistant_append_page(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page))));
}

static Xen gxg_gtk_assistant_insert_page(Xen assistant, Xen page, Xen position)
{
  #define H_gtk_assistant_insert_page "gint gtk_assistant_insert_page(GtkAssistant* assistant, GtkWidget* page, \
gint position)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_insert_page", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_insert_page", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_assistant_insert_page", "gint");
  return(C_to_Xen_gint(gtk_assistant_insert_page(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page), Xen_to_C_gint(position))));
}

static Xen gxg_gtk_assistant_set_forward_page_func(Xen assistant, Xen page_func, Xen func_info, Xen destroy)
{
  #define H_gtk_assistant_set_forward_page_func "void gtk_assistant_set_forward_page_func(GtkAssistant* assistant, \
GtkAssistantPageFunc page_func, lambda_data func_info, GDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_set_forward_page_func", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkAssistantPageFunc(page_func), page_func, 2, "gtk_assistant_set_forward_page_func", "GtkAssistantPageFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_assistant_set_forward_page_func", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(destroy), destroy, 4, "gtk_assistant_set_forward_page_func", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gtk_assistant_set_forward_page_func(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkAssistantPageFunc(page_func), Xen_to_C_lambda_data(func_info), 
                                    Xen_to_C_GDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_assistant_set_page_type(Xen assistant, Xen page, Xen type)
{
  #define H_gtk_assistant_set_page_type "void gtk_assistant_set_page_type(GtkAssistant* assistant, GtkWidget* page, \
GtkAssistantPageType type)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_set_page_type", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_set_page_type", "GtkWidget*");
  Xen_check_type(Xen_is_GtkAssistantPageType(type), type, 3, "gtk_assistant_set_page_type", "GtkAssistantPageType");
  gtk_assistant_set_page_type(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page), Xen_to_C_GtkAssistantPageType(type));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_get_page_type(Xen assistant, Xen page)
{
  #define H_gtk_assistant_get_page_type "GtkAssistantPageType gtk_assistant_get_page_type(GtkAssistant* assistant, \
GtkWidget* page)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_get_page_type", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_get_page_type", "GtkWidget*");
  return(C_to_Xen_GtkAssistantPageType(gtk_assistant_get_page_type(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page))));
}

static Xen gxg_gtk_assistant_set_page_title(Xen assistant, Xen page, Xen title)
{
  #define H_gtk_assistant_set_page_title "void gtk_assistant_set_page_title(GtkAssistant* assistant, \
GtkWidget* page, gchar* title)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_set_page_title", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_set_page_title", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(title), title, 3, "gtk_assistant_set_page_title", "gchar*");
  gtk_assistant_set_page_title(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page), Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_get_page_title(Xen assistant, Xen page)
{
  #define H_gtk_assistant_get_page_title "gchar* gtk_assistant_get_page_title(GtkAssistant* assistant, \
GtkWidget* page)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_get_page_title", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_get_page_title", "GtkWidget*");
  return(C_to_Xen_gchar_(gtk_assistant_get_page_title(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page))));
}

static Xen gxg_gtk_assistant_set_page_complete(Xen assistant, Xen page, Xen complete)
{
  #define H_gtk_assistant_set_page_complete "void gtk_assistant_set_page_complete(GtkAssistant* assistant, \
GtkWidget* page, gboolean complete)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_set_page_complete", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_set_page_complete", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(complete), complete, 3, "gtk_assistant_set_page_complete", "gboolean");
  gtk_assistant_set_page_complete(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page), Xen_to_C_gboolean(complete));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_get_page_complete(Xen assistant, Xen page)
{
  #define H_gtk_assistant_get_page_complete "gboolean gtk_assistant_get_page_complete(GtkAssistant* assistant, \
GtkWidget* page)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_get_page_complete", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(page), page, 2, "gtk_assistant_get_page_complete", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_assistant_get_page_complete(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(page))));
}

static Xen gxg_gtk_assistant_add_action_widget(Xen assistant, Xen child)
{
  #define H_gtk_assistant_add_action_widget "void gtk_assistant_add_action_widget(GtkAssistant* assistant, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_add_action_widget", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_assistant_add_action_widget", "GtkWidget*");
  gtk_assistant_add_action_widget(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_remove_action_widget(Xen assistant, Xen child)
{
  #define H_gtk_assistant_remove_action_widget "void gtk_assistant_remove_action_widget(GtkAssistant* assistant, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_remove_action_widget", "GtkAssistant*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_assistant_remove_action_widget", "GtkWidget*");
  gtk_assistant_remove_action_widget(Xen_to_C_GtkAssistant_(assistant), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_update_buttons_state(Xen assistant)
{
  #define H_gtk_assistant_update_buttons_state "void gtk_assistant_update_buttons_state(GtkAssistant* assistant)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_update_buttons_state", "GtkAssistant*");
  gtk_assistant_update_buttons_state(Xen_to_C_GtkAssistant_(assistant));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_accel_new(void)
{
  #define H_gtk_cell_renderer_accel_new "GtkCellRenderer* gtk_cell_renderer_accel_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_accel_new()));
}

static Xen gxg_gtk_cell_renderer_spin_new(void)
{
  #define H_gtk_cell_renderer_spin_new "GtkCellRenderer* gtk_cell_renderer_spin_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_spin_new()));
}

static Xen gxg_gtk_link_button_new(Xen uri)
{
  #define H_gtk_link_button_new "GtkWidget* gtk_link_button_new(gchar* uri)"
  Xen_check_type(Xen_is_gchar_(uri), uri, 1, "gtk_link_button_new", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_link_button_new(Xen_to_C_gchar_(uri))));
}

static Xen gxg_gtk_link_button_new_with_label(Xen uri, Xen label)
{
  #define H_gtk_link_button_new_with_label "GtkWidget* gtk_link_button_new_with_label(gchar* uri, gchar* label)"
  Xen_check_type(Xen_is_gchar_(uri), uri, 1, "gtk_link_button_new_with_label", "gchar*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_link_button_new_with_label", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_link_button_new_with_label(Xen_to_C_gchar_(uri), Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_link_button_get_uri(Xen link_button)
{
  #define H_gtk_link_button_get_uri "gchar* gtk_link_button_get_uri(GtkLinkButton* link_button)"
  Xen_check_type(Xen_is_GtkLinkButton_(link_button), link_button, 1, "gtk_link_button_get_uri", "GtkLinkButton*");
  return(C_to_Xen_gchar_(gtk_link_button_get_uri(Xen_to_C_GtkLinkButton_(link_button))));
}

static Xen gxg_gtk_link_button_set_uri(Xen link_button, Xen uri)
{
  #define H_gtk_link_button_set_uri "void gtk_link_button_set_uri(GtkLinkButton* link_button, gchar* uri)"
  Xen_check_type(Xen_is_GtkLinkButton_(link_button), link_button, 1, "gtk_link_button_set_uri", "GtkLinkButton*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_link_button_set_uri", "gchar*");
  gtk_link_button_set_uri(Xen_to_C_GtkLinkButton_(link_button), Xen_to_C_gchar_(uri));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_error_quark(void)
{
  #define H_gtk_recent_chooser_error_quark "GQuark gtk_recent_chooser_error_quark( void)"
  return(C_to_Xen_GQuark(gtk_recent_chooser_error_quark()));
}

static Xen gxg_gtk_recent_chooser_set_show_private(Xen chooser, Xen show_private)
{
  #define H_gtk_recent_chooser_set_show_private "void gtk_recent_chooser_set_show_private(GtkRecentChooser* chooser, \
gboolean show_private)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_show_private", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gboolean(show_private), show_private, 2, "gtk_recent_chooser_set_show_private", "gboolean");
  gtk_recent_chooser_set_show_private(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gboolean(show_private));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_show_private(Xen chooser)
{
  #define H_gtk_recent_chooser_get_show_private "gboolean gtk_recent_chooser_get_show_private(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_show_private", "GtkRecentChooser*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_get_show_private(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_show_not_found(Xen chooser, Xen show_not_found)
{
  #define H_gtk_recent_chooser_set_show_not_found "void gtk_recent_chooser_set_show_not_found(GtkRecentChooser* chooser, \
gboolean show_not_found)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_show_not_found", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gboolean(show_not_found), show_not_found, 2, "gtk_recent_chooser_set_show_not_found", "gboolean");
  gtk_recent_chooser_set_show_not_found(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gboolean(show_not_found));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_show_not_found(Xen chooser)
{
  #define H_gtk_recent_chooser_get_show_not_found "gboolean gtk_recent_chooser_get_show_not_found(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_show_not_found", "GtkRecentChooser*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_get_show_not_found(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_select_multiple(Xen chooser, Xen select_multiple)
{
  #define H_gtk_recent_chooser_set_select_multiple "void gtk_recent_chooser_set_select_multiple(GtkRecentChooser* chooser, \
gboolean select_multiple)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_select_multiple", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gboolean(select_multiple), select_multiple, 2, "gtk_recent_chooser_set_select_multiple", "gboolean");
  gtk_recent_chooser_set_select_multiple(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gboolean(select_multiple));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_select_multiple(Xen chooser)
{
  #define H_gtk_recent_chooser_get_select_multiple "gboolean gtk_recent_chooser_get_select_multiple(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_select_multiple", "GtkRecentChooser*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_get_select_multiple(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_limit(Xen chooser, Xen limit)
{
  #define H_gtk_recent_chooser_set_limit "void gtk_recent_chooser_set_limit(GtkRecentChooser* chooser, \
gint limit)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_limit", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gint(limit), limit, 2, "gtk_recent_chooser_set_limit", "gint");
  gtk_recent_chooser_set_limit(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gint(limit));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_limit(Xen chooser)
{
  #define H_gtk_recent_chooser_get_limit "gint gtk_recent_chooser_get_limit(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_limit", "GtkRecentChooser*");
  return(C_to_Xen_gint(gtk_recent_chooser_get_limit(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_local_only(Xen chooser, Xen local_only)
{
  #define H_gtk_recent_chooser_set_local_only "void gtk_recent_chooser_set_local_only(GtkRecentChooser* chooser, \
gboolean local_only)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_local_only", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gboolean(local_only), local_only, 2, "gtk_recent_chooser_set_local_only", "gboolean");
  gtk_recent_chooser_set_local_only(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gboolean(local_only));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_local_only(Xen chooser)
{
  #define H_gtk_recent_chooser_get_local_only "gboolean gtk_recent_chooser_get_local_only(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_local_only", "GtkRecentChooser*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_get_local_only(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_show_tips(Xen chooser, Xen show_tips)
{
  #define H_gtk_recent_chooser_set_show_tips "void gtk_recent_chooser_set_show_tips(GtkRecentChooser* chooser, \
gboolean show_tips)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_show_tips", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gboolean(show_tips), show_tips, 2, "gtk_recent_chooser_set_show_tips", "gboolean");
  gtk_recent_chooser_set_show_tips(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gboolean(show_tips));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_show_tips(Xen chooser)
{
  #define H_gtk_recent_chooser_get_show_tips "gboolean gtk_recent_chooser_get_show_tips(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_show_tips", "GtkRecentChooser*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_get_show_tips(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_show_icons(Xen chooser, Xen show_icons)
{
  #define H_gtk_recent_chooser_set_show_icons "void gtk_recent_chooser_set_show_icons(GtkRecentChooser* chooser, \
gboolean show_icons)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_show_icons", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gboolean(show_icons), show_icons, 2, "gtk_recent_chooser_set_show_icons", "gboolean");
  gtk_recent_chooser_set_show_icons(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gboolean(show_icons));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_show_icons(Xen chooser)
{
  #define H_gtk_recent_chooser_get_show_icons "gboolean gtk_recent_chooser_get_show_icons(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_show_icons", "GtkRecentChooser*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_get_show_icons(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_sort_type(Xen chooser, Xen sort_type)
{
  #define H_gtk_recent_chooser_set_sort_type "void gtk_recent_chooser_set_sort_type(GtkRecentChooser* chooser, \
GtkRecentSortType sort_type)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_sort_type", "GtkRecentChooser*");
  Xen_check_type(Xen_is_GtkRecentSortType(sort_type), sort_type, 2, "gtk_recent_chooser_set_sort_type", "GtkRecentSortType");
  gtk_recent_chooser_set_sort_type(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_GtkRecentSortType(sort_type));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_sort_type(Xen chooser)
{
  #define H_gtk_recent_chooser_get_sort_type "GtkRecentSortType gtk_recent_chooser_get_sort_type(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_sort_type", "GtkRecentChooser*");
  return(C_to_Xen_GtkRecentSortType(gtk_recent_chooser_get_sort_type(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_sort_func(Xen chooser, Xen func, Xen func_info, Xen data_destroy)
{
  #define H_gtk_recent_chooser_set_sort_func "void gtk_recent_chooser_set_sort_func(GtkRecentChooser* chooser, \
GtkRecentSortFunc func, lambda_data func_info, GDestroyNotify data_destroy)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_sort_func", "GtkRecentChooser*");
  Xen_check_type(Xen_is_GtkRecentSortFunc(func), func, 2, "gtk_recent_chooser_set_sort_func", "GtkRecentSortFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_recent_chooser_set_sort_func", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(data_destroy), data_destroy, 4, "gtk_recent_chooser_set_sort_func", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gtk_recent_chooser_set_sort_func(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_GtkRecentSortFunc(func), Xen_to_C_lambda_data(func_info), 
                                 Xen_to_C_GDestroyNotify(data_destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_recent_chooser_set_current_uri(Xen chooser, Xen uri, Xen ignore_error)
{
  #define H_gtk_recent_chooser_set_current_uri "gboolean gtk_recent_chooser_set_current_uri(GtkRecentChooser* chooser, \
gchar* uri, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_current_uri", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_chooser_set_current_uri", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_recent_chooser_set_current_uri(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gchar_(uri), 
                                                                  &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_recent_chooser_get_current_uri(Xen chooser)
{
  #define H_gtk_recent_chooser_get_current_uri "gchar* gtk_recent_chooser_get_current_uri(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_current_uri", "GtkRecentChooser*");
  return(C_to_Xen_gchar_(gtk_recent_chooser_get_current_uri(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_get_current_item(Xen chooser)
{
  #define H_gtk_recent_chooser_get_current_item "GtkRecentInfo* gtk_recent_chooser_get_current_item(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_current_item", "GtkRecentChooser*");
  return(C_to_Xen_GtkRecentInfo_(gtk_recent_chooser_get_current_item(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_select_uri(Xen chooser, Xen uri, Xen ignore_error)
{
  #define H_gtk_recent_chooser_select_uri "gboolean gtk_recent_chooser_select_uri(GtkRecentChooser* chooser, \
gchar* uri, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_select_uri", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_chooser_select_uri", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_recent_chooser_select_uri(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gchar_(uri), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_recent_chooser_unselect_uri(Xen chooser, Xen uri)
{
  #define H_gtk_recent_chooser_unselect_uri "void gtk_recent_chooser_unselect_uri(GtkRecentChooser* chooser, \
gchar* uri)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_unselect_uri", "GtkRecentChooser*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_chooser_unselect_uri", "gchar*");
  gtk_recent_chooser_unselect_uri(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_gchar_(uri));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_select_all(Xen chooser)
{
  #define H_gtk_recent_chooser_select_all "void gtk_recent_chooser_select_all(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_select_all", "GtkRecentChooser*");
  gtk_recent_chooser_select_all(Xen_to_C_GtkRecentChooser_(chooser));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_unselect_all(Xen chooser)
{
  #define H_gtk_recent_chooser_unselect_all "void gtk_recent_chooser_unselect_all(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_unselect_all", "GtkRecentChooser*");
  gtk_recent_chooser_unselect_all(Xen_to_C_GtkRecentChooser_(chooser));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_items(Xen chooser)
{
  #define H_gtk_recent_chooser_get_items "GList* gtk_recent_chooser_get_items(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_items", "GtkRecentChooser*");
  return(C_to_Xen_GList_(gtk_recent_chooser_get_items(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_get_uris(Xen chooser, Xen ignore_length)
{
  #define H_gtk_recent_chooser_get_uris "gchar** gtk_recent_chooser_get_uris(GtkRecentChooser* chooser, \
gsize* [length])"
  gsize ref_length;
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_uris", "GtkRecentChooser*");
  {
    Xen result;
    result = C_to_Xen_gchar__(gtk_recent_chooser_get_uris(Xen_to_C_GtkRecentChooser_(chooser), &ref_length));
    return(Xen_list_2(result, C_to_Xen_gsize(ref_length)));
   }
}

static Xen gxg_gtk_recent_chooser_add_filter(Xen chooser, Xen filter)
{
  #define H_gtk_recent_chooser_add_filter "void gtk_recent_chooser_add_filter(GtkRecentChooser* chooser, \
GtkRecentFilter* filter)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_add_filter", "GtkRecentChooser*");
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 2, "gtk_recent_chooser_add_filter", "GtkRecentFilter*");
  gtk_recent_chooser_add_filter(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_GtkRecentFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_remove_filter(Xen chooser, Xen filter)
{
  #define H_gtk_recent_chooser_remove_filter "void gtk_recent_chooser_remove_filter(GtkRecentChooser* chooser, \
GtkRecentFilter* filter)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_remove_filter", "GtkRecentChooser*");
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 2, "gtk_recent_chooser_remove_filter", "GtkRecentFilter*");
  gtk_recent_chooser_remove_filter(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_GtkRecentFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_list_filters(Xen chooser)
{
  #define H_gtk_recent_chooser_list_filters "GSList* gtk_recent_chooser_list_filters(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_list_filters", "GtkRecentChooser*");
  return(C_to_Xen_GSList_(gtk_recent_chooser_list_filters(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_set_filter(Xen chooser, Xen filter)
{
  #define H_gtk_recent_chooser_set_filter "void gtk_recent_chooser_set_filter(GtkRecentChooser* chooser, \
GtkRecentFilter* filter)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_set_filter", "GtkRecentChooser*");
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 2, "gtk_recent_chooser_set_filter", "GtkRecentFilter*");
  gtk_recent_chooser_set_filter(Xen_to_C_GtkRecentChooser_(chooser), Xen_to_C_GtkRecentFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_get_filter(Xen chooser)
{
  #define H_gtk_recent_chooser_get_filter "GtkRecentFilter* gtk_recent_chooser_get_filter(GtkRecentChooser* chooser)"
  Xen_check_type(Xen_is_GtkRecentChooser_(chooser), chooser, 1, "gtk_recent_chooser_get_filter", "GtkRecentChooser*");
  return(C_to_Xen_GtkRecentFilter_(gtk_recent_chooser_get_filter(Xen_to_C_GtkRecentChooser_(chooser))));
}

static Xen gxg_gtk_recent_chooser_menu_new(void)
{
  #define H_gtk_recent_chooser_menu_new "GtkWidget* gtk_recent_chooser_menu_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_recent_chooser_menu_new()));
}

static Xen gxg_gtk_recent_chooser_menu_new_for_manager(Xen manager)
{
  #define H_gtk_recent_chooser_menu_new_for_manager "GtkWidget* gtk_recent_chooser_menu_new_for_manager(GtkRecentManager* manager)"
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_chooser_menu_new_for_manager", "GtkRecentManager*");
  return(C_to_Xen_GtkWidget_(gtk_recent_chooser_menu_new_for_manager(Xen_to_C_GtkRecentManager_(manager))));
}

static Xen gxg_gtk_recent_chooser_menu_get_show_numbers(Xen menu)
{
  #define H_gtk_recent_chooser_menu_get_show_numbers "gboolean gtk_recent_chooser_menu_get_show_numbers(GtkRecentChooserMenu* menu)"
  Xen_check_type(Xen_is_GtkRecentChooserMenu_(menu), menu, 1, "gtk_recent_chooser_menu_get_show_numbers", "GtkRecentChooserMenu*");
  return(C_to_Xen_gboolean(gtk_recent_chooser_menu_get_show_numbers(Xen_to_C_GtkRecentChooserMenu_(menu))));
}

static Xen gxg_gtk_recent_chooser_menu_set_show_numbers(Xen menu, Xen show_numbers)
{
  #define H_gtk_recent_chooser_menu_set_show_numbers "void gtk_recent_chooser_menu_set_show_numbers(GtkRecentChooserMenu* menu, \
gboolean show_numbers)"
  Xen_check_type(Xen_is_GtkRecentChooserMenu_(menu), menu, 1, "gtk_recent_chooser_menu_set_show_numbers", "GtkRecentChooserMenu*");
  Xen_check_type(Xen_is_gboolean(show_numbers), show_numbers, 2, "gtk_recent_chooser_menu_set_show_numbers", "gboolean");
  gtk_recent_chooser_menu_set_show_numbers(Xen_to_C_GtkRecentChooserMenu_(menu), Xen_to_C_gboolean(show_numbers));
  return(Xen_false);
}

static Xen gxg_gtk_recent_chooser_widget_new(void)
{
  #define H_gtk_recent_chooser_widget_new "GtkWidget* gtk_recent_chooser_widget_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_recent_chooser_widget_new()));
}

static Xen gxg_gtk_recent_chooser_widget_new_for_manager(Xen manager)
{
  #define H_gtk_recent_chooser_widget_new_for_manager "GtkWidget* gtk_recent_chooser_widget_new_for_manager(GtkRecentManager* manager)"
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_chooser_widget_new_for_manager", "GtkRecentManager*");
  return(C_to_Xen_GtkWidget_(gtk_recent_chooser_widget_new_for_manager(Xen_to_C_GtkRecentManager_(manager))));
}

static Xen gxg_gtk_recent_filter_new(void)
{
  #define H_gtk_recent_filter_new "GtkRecentFilter* gtk_recent_filter_new( void)"
  return(C_to_Xen_GtkRecentFilter_(gtk_recent_filter_new()));
}

static Xen gxg_gtk_recent_filter_set_name(Xen filter, Xen name)
{
  #define H_gtk_recent_filter_set_name "void gtk_recent_filter_set_name(GtkRecentFilter* filter, gchar* name)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_set_name", "GtkRecentFilter*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_recent_filter_set_name", "gchar*");
  gtk_recent_filter_set_name(Xen_to_C_GtkRecentFilter_(filter), Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_recent_filter_get_name(Xen filter)
{
  #define H_gtk_recent_filter_get_name "gchar* gtk_recent_filter_get_name(GtkRecentFilter* filter)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_get_name", "GtkRecentFilter*");
    return(C_to_Xen_gchar_((gchar*)gtk_recent_filter_get_name(Xen_to_C_GtkRecentFilter_(filter))));
}

static Xen gxg_gtk_recent_filter_add_mime_type(Xen filter, Xen mime_type)
{
  #define H_gtk_recent_filter_add_mime_type "void gtk_recent_filter_add_mime_type(GtkRecentFilter* filter, \
gchar* mime_type)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_add_mime_type", "GtkRecentFilter*");
  Xen_check_type(Xen_is_gchar_(mime_type), mime_type, 2, "gtk_recent_filter_add_mime_type", "gchar*");
  gtk_recent_filter_add_mime_type(Xen_to_C_GtkRecentFilter_(filter), Xen_to_C_gchar_(mime_type));
  return(Xen_false);
}

static Xen gxg_gtk_recent_filter_add_pattern(Xen filter, Xen pattern)
{
  #define H_gtk_recent_filter_add_pattern "void gtk_recent_filter_add_pattern(GtkRecentFilter* filter, \
gchar* pattern)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_add_pattern", "GtkRecentFilter*");
  Xen_check_type(Xen_is_gchar_(pattern), pattern, 2, "gtk_recent_filter_add_pattern", "gchar*");
  gtk_recent_filter_add_pattern(Xen_to_C_GtkRecentFilter_(filter), Xen_to_C_gchar_(pattern));
  return(Xen_false);
}

static Xen gxg_gtk_recent_filter_add_pixbuf_formats(Xen filter)
{
  #define H_gtk_recent_filter_add_pixbuf_formats "void gtk_recent_filter_add_pixbuf_formats(GtkRecentFilter* filter)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_add_pixbuf_formats", "GtkRecentFilter*");
  gtk_recent_filter_add_pixbuf_formats(Xen_to_C_GtkRecentFilter_(filter));
  return(Xen_false);
}

static Xen gxg_gtk_recent_filter_add_application(Xen filter, Xen application)
{
  #define H_gtk_recent_filter_add_application "void gtk_recent_filter_add_application(GtkRecentFilter* filter, \
gchar* application)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_add_application", "GtkRecentFilter*");
  Xen_check_type(Xen_is_gchar_(application), application, 2, "gtk_recent_filter_add_application", "gchar*");
  gtk_recent_filter_add_application(Xen_to_C_GtkRecentFilter_(filter), Xen_to_C_gchar_(application));
  return(Xen_false);
}

static Xen gxg_gtk_recent_filter_add_group(Xen filter, Xen group)
{
  #define H_gtk_recent_filter_add_group "void gtk_recent_filter_add_group(GtkRecentFilter* filter, gchar* group)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_add_group", "GtkRecentFilter*");
  Xen_check_type(Xen_is_gchar_(group), group, 2, "gtk_recent_filter_add_group", "gchar*");
  gtk_recent_filter_add_group(Xen_to_C_GtkRecentFilter_(filter), Xen_to_C_gchar_(group));
  return(Xen_false);
}

static Xen gxg_gtk_recent_filter_add_age(Xen filter, Xen days)
{
  #define H_gtk_recent_filter_add_age "void gtk_recent_filter_add_age(GtkRecentFilter* filter, gint days)"
  Xen_check_type(Xen_is_GtkRecentFilter_(filter), filter, 1, "gtk_recent_filter_add_age", "GtkRecentFilter*");
  Xen_check_type(Xen_is_gint(days), days, 2, "gtk_recent_filter_add_age", "gint");
  gtk_recent_filter_add_age(Xen_to_C_GtkRecentFilter_(filter), Xen_to_C_gint(days));
  return(Xen_false);
}

static Xen gxg_gtk_recent_manager_error_quark(void)
{
  #define H_gtk_recent_manager_error_quark "GQuark gtk_recent_manager_error_quark( void)"
  return(C_to_Xen_GQuark(gtk_recent_manager_error_quark()));
}

static Xen gxg_gtk_recent_manager_new(void)
{
  #define H_gtk_recent_manager_new "GtkRecentManager* gtk_recent_manager_new( void)"
  return(C_to_Xen_GtkRecentManager_(gtk_recent_manager_new()));
}

static Xen gxg_gtk_recent_manager_get_default(void)
{
  #define H_gtk_recent_manager_get_default "GtkRecentManager* gtk_recent_manager_get_default( void)"
  return(C_to_Xen_GtkRecentManager_(gtk_recent_manager_get_default()));
}

static Xen gxg_gtk_recent_manager_remove_item(Xen manager, Xen uri, Xen ignore_error)
{
  #define H_gtk_recent_manager_remove_item "gboolean gtk_recent_manager_remove_item(GtkRecentManager* manager, \
gchar* uri, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_remove_item", "GtkRecentManager*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_manager_remove_item", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_recent_manager_remove_item(Xen_to_C_GtkRecentManager_(manager), Xen_to_C_gchar_(uri), 
                                                              &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_recent_manager_lookup_item(Xen manager, Xen uri, Xen ignore_error)
{
  #define H_gtk_recent_manager_lookup_item "GtkRecentInfo* gtk_recent_manager_lookup_item(GtkRecentManager* manager, \
gchar* uri, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_lookup_item", "GtkRecentManager*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_manager_lookup_item", "gchar*");
  {
    Xen result;
    result = C_to_Xen_GtkRecentInfo_(gtk_recent_manager_lookup_item(Xen_to_C_GtkRecentManager_(manager), Xen_to_C_gchar_(uri), 
                                                                    &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_recent_manager_has_item(Xen manager, Xen uri)
{
  #define H_gtk_recent_manager_has_item "gboolean gtk_recent_manager_has_item(GtkRecentManager* manager, \
gchar* uri)"
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_has_item", "GtkRecentManager*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_manager_has_item", "gchar*");
  return(C_to_Xen_gboolean(gtk_recent_manager_has_item(Xen_to_C_GtkRecentManager_(manager), Xen_to_C_gchar_(uri))));
}

static Xen gxg_gtk_recent_manager_move_item(Xen manager, Xen uri, Xen new_uri, Xen ignore_error)
{
  #define H_gtk_recent_manager_move_item "gboolean gtk_recent_manager_move_item(GtkRecentManager* manager, \
gchar* uri, gchar* new_uri, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_move_item", "GtkRecentManager*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_manager_move_item", "gchar*");
  Xen_check_type(Xen_is_gchar_(new_uri), new_uri, 3, "gtk_recent_manager_move_item", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_recent_manager_move_item(Xen_to_C_GtkRecentManager_(manager), Xen_to_C_gchar_(uri), Xen_to_C_gchar_(new_uri), 
                                                            &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_recent_manager_get_items(Xen manager)
{
  #define H_gtk_recent_manager_get_items "GList* gtk_recent_manager_get_items(GtkRecentManager* manager)"
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_get_items", "GtkRecentManager*");
  return(C_to_Xen_GList_(gtk_recent_manager_get_items(Xen_to_C_GtkRecentManager_(manager))));
}

static Xen gxg_gtk_recent_manager_purge_items(Xen manager, Xen ignore_error)
{
  #define H_gtk_recent_manager_purge_items "gint gtk_recent_manager_purge_items(GtkRecentManager* manager, \
GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_purge_items", "GtkRecentManager*");
  {
    Xen result;
    result = C_to_Xen_gint(gtk_recent_manager_purge_items(Xen_to_C_GtkRecentManager_(manager), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_recent_info_ref(Xen info)
{
  #define H_gtk_recent_info_ref "GtkRecentInfo* gtk_recent_info_ref(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_ref", "GtkRecentInfo*");
  return(C_to_Xen_GtkRecentInfo_(gtk_recent_info_ref(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_unref(Xen info)
{
  #define H_gtk_recent_info_unref "void gtk_recent_info_unref(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_unref", "GtkRecentInfo*");
  gtk_recent_info_unref(Xen_to_C_GtkRecentInfo_(info));
  return(Xen_false);
}

static Xen gxg_gtk_recent_info_get_uri(Xen info)
{
  #define H_gtk_recent_info_get_uri "gchar* gtk_recent_info_get_uri(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_uri", "GtkRecentInfo*");
  return(C_to_Xen_gchar_(gtk_recent_info_get_uri(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_display_name(Xen info)
{
  #define H_gtk_recent_info_get_display_name "gchar* gtk_recent_info_get_display_name(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_display_name", "GtkRecentInfo*");
    return(C_to_Xen_gchar_((gchar*)gtk_recent_info_get_display_name(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_description(Xen info)
{
  #define H_gtk_recent_info_get_description "gchar* gtk_recent_info_get_description(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_description", "GtkRecentInfo*");
    return(C_to_Xen_gchar_((gchar*)gtk_recent_info_get_description(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_mime_type(Xen info)
{
  #define H_gtk_recent_info_get_mime_type "gchar* gtk_recent_info_get_mime_type(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_mime_type", "GtkRecentInfo*");
    return(C_to_Xen_gchar_((gchar*)gtk_recent_info_get_mime_type(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_added(Xen info)
{
  #define H_gtk_recent_info_get_added "time_t gtk_recent_info_get_added(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_added", "GtkRecentInfo*");
  return(C_to_Xen_time_t(gtk_recent_info_get_added(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_modified(Xen info)
{
  #define H_gtk_recent_info_get_modified "time_t gtk_recent_info_get_modified(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_modified", "GtkRecentInfo*");
  return(C_to_Xen_time_t(gtk_recent_info_get_modified(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_visited(Xen info)
{
  #define H_gtk_recent_info_get_visited "time_t gtk_recent_info_get_visited(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_visited", "GtkRecentInfo*");
  return(C_to_Xen_time_t(gtk_recent_info_get_visited(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_private_hint(Xen info)
{
  #define H_gtk_recent_info_get_private_hint "gboolean gtk_recent_info_get_private_hint(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_private_hint", "GtkRecentInfo*");
  return(C_to_Xen_gboolean(gtk_recent_info_get_private_hint(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_applications(Xen info, Xen ignore_length)
{
  #define H_gtk_recent_info_get_applications "gchar** gtk_recent_info_get_applications(GtkRecentInfo* info, \
gsize* [length])"
  gsize ref_length;
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_applications", "GtkRecentInfo*");
  {
    Xen result;
    result = C_to_Xen_gchar__(gtk_recent_info_get_applications(Xen_to_C_GtkRecentInfo_(info), &ref_length));
    return(Xen_list_2(result, C_to_Xen_gsize(ref_length)));
   }
}

static Xen gxg_gtk_recent_info_last_application(Xen info)
{
  #define H_gtk_recent_info_last_application "gchar* gtk_recent_info_last_application(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_last_application", "GtkRecentInfo*");
  return(C_to_Xen_gchar_(gtk_recent_info_last_application(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_has_application(Xen info, Xen app_name)
{
  #define H_gtk_recent_info_has_application "gboolean gtk_recent_info_has_application(GtkRecentInfo* info, \
gchar* app_name)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_has_application", "GtkRecentInfo*");
  Xen_check_type(Xen_is_gchar_(app_name), app_name, 2, "gtk_recent_info_has_application", "gchar*");
  return(C_to_Xen_gboolean(gtk_recent_info_has_application(Xen_to_C_GtkRecentInfo_(info), Xen_to_C_gchar_(app_name))));
}

static Xen gxg_gtk_recent_info_get_groups(Xen info, Xen ignore_length)
{
  #define H_gtk_recent_info_get_groups "gchar** gtk_recent_info_get_groups(GtkRecentInfo* info, gsize* [length])"
  gsize ref_length;
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_groups", "GtkRecentInfo*");
  {
    Xen result;
    result = C_to_Xen_gchar__(gtk_recent_info_get_groups(Xen_to_C_GtkRecentInfo_(info), &ref_length));
    return(Xen_list_2(result, C_to_Xen_gsize(ref_length)));
   }
}

static Xen gxg_gtk_recent_info_has_group(Xen info, Xen group_name)
{
  #define H_gtk_recent_info_has_group "gboolean gtk_recent_info_has_group(GtkRecentInfo* info, gchar* group_name)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_has_group", "GtkRecentInfo*");
  Xen_check_type(Xen_is_gchar_(group_name), group_name, 2, "gtk_recent_info_has_group", "gchar*");
  return(C_to_Xen_gboolean(gtk_recent_info_has_group(Xen_to_C_GtkRecentInfo_(info), Xen_to_C_gchar_(group_name))));
}

static Xen gxg_gtk_recent_info_get_short_name(Xen info)
{
  #define H_gtk_recent_info_get_short_name "gchar* gtk_recent_info_get_short_name(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_short_name", "GtkRecentInfo*");
  return(C_to_Xen_gchar_(gtk_recent_info_get_short_name(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_uri_display(Xen info)
{
  #define H_gtk_recent_info_get_uri_display "gchar* gtk_recent_info_get_uri_display(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_uri_display", "GtkRecentInfo*");
  return(C_to_Xen_gchar_(gtk_recent_info_get_uri_display(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_get_age(Xen info)
{
  #define H_gtk_recent_info_get_age "gint gtk_recent_info_get_age(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_get_age", "GtkRecentInfo*");
  return(C_to_Xen_gint(gtk_recent_info_get_age(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_is_local(Xen info)
{
  #define H_gtk_recent_info_is_local "gboolean gtk_recent_info_is_local(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_is_local", "GtkRecentInfo*");
  return(C_to_Xen_gboolean(gtk_recent_info_is_local(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_exists(Xen info)
{
  #define H_gtk_recent_info_exists "gboolean gtk_recent_info_exists(GtkRecentInfo* info)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info), info, 1, "gtk_recent_info_exists", "GtkRecentInfo*");
  return(C_to_Xen_gboolean(gtk_recent_info_exists(Xen_to_C_GtkRecentInfo_(info))));
}

static Xen gxg_gtk_recent_info_match(Xen info_a, Xen info_b)
{
  #define H_gtk_recent_info_match "gboolean gtk_recent_info_match(GtkRecentInfo* info_a, GtkRecentInfo* info_b)"
  Xen_check_type(Xen_is_GtkRecentInfo_(info_a), info_a, 1, "gtk_recent_info_match", "GtkRecentInfo*");
  Xen_check_type(Xen_is_GtkRecentInfo_(info_b), info_b, 2, "gtk_recent_info_match", "GtkRecentInfo*");
  return(C_to_Xen_gboolean(gtk_recent_info_match(Xen_to_C_GtkRecentInfo_(info_a), Xen_to_C_GtkRecentInfo_(info_b))));
}

static Xen gxg_gtk_recent_manager_add_item(Xen manager, Xen uri)
{
  #define H_gtk_recent_manager_add_item "gboolean gtk_recent_manager_add_item(GtkRecentManager* manager, \
gchar* uri)"
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_add_item", "GtkRecentManager*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_manager_add_item", "gchar*");
  return(C_to_Xen_gboolean(gtk_recent_manager_add_item(Xen_to_C_GtkRecentManager_(manager), Xen_to_C_gchar_(uri))));
}

static Xen gxg_gtk_recent_manager_add_full(Xen manager, Xen uri, Xen recent_data)
{
  #define H_gtk_recent_manager_add_full "gboolean gtk_recent_manager_add_full(GtkRecentManager* manager, \
gchar* uri, GtkRecentData* recent_data)"
  Xen_check_type(Xen_is_GtkRecentManager_(manager), manager, 1, "gtk_recent_manager_add_full", "GtkRecentManager*");
  Xen_check_type(Xen_is_gchar_(uri), uri, 2, "gtk_recent_manager_add_full", "gchar*");
  Xen_check_type(Xen_is_GtkRecentData_(recent_data), recent_data, 3, "gtk_recent_manager_add_full", "GtkRecentData*");
  return(C_to_Xen_gboolean(gtk_recent_manager_add_full(Xen_to_C_GtkRecentManager_(manager), Xen_to_C_gchar_(uri), Xen_to_C_GtkRecentData_(recent_data))));
}

static Xen gxg_gtk_tree_model_filter_convert_child_iter_to_iter(Xen filter, Xen filter_iter, Xen child_iter)
{
  #define H_gtk_tree_model_filter_convert_child_iter_to_iter "gboolean gtk_tree_model_filter_convert_child_iter_to_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* filter_iter, GtkTreeIter* child_iter)"
  Xen_check_type(Xen_is_GtkTreeModelFilter_(filter), filter, 1, "gtk_tree_model_filter_convert_child_iter_to_iter", "GtkTreeModelFilter*");
  Xen_check_type(Xen_is_GtkTreeIter_(filter_iter), filter_iter, 2, "gtk_tree_model_filter_convert_child_iter_to_iter", "GtkTreeIter*");
  Xen_check_type(Xen_is_GtkTreeIter_(child_iter), child_iter, 3, "gtk_tree_model_filter_convert_child_iter_to_iter", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_filter_convert_child_iter_to_iter(Xen_to_C_GtkTreeModelFilter_(filter), Xen_to_C_GtkTreeIter_(filter_iter), 
                                                                            Xen_to_C_GtkTreeIter_(child_iter))));
}

static Xen gxg_gtk_tree_view_get_grid_lines(Xen tree_view)
{
  #define H_gtk_tree_view_get_grid_lines "GtkTreeViewGridLines gtk_tree_view_get_grid_lines(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_grid_lines", "GtkTreeView*");
  return(C_to_Xen_GtkTreeViewGridLines(gtk_tree_view_get_grid_lines(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_grid_lines(Xen tree_view, Xen grid_lines)
{
  #define H_gtk_tree_view_set_grid_lines "void gtk_tree_view_set_grid_lines(GtkTreeView* tree_view, GtkTreeViewGridLines grid_lines)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_grid_lines", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreeViewGridLines(grid_lines), grid_lines, 2, "gtk_tree_view_set_grid_lines", "GtkTreeViewGridLines");
  gtk_tree_view_set_grid_lines(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreeViewGridLines(grid_lines));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_enable_tree_lines(Xen tree_view)
{
  #define H_gtk_tree_view_get_enable_tree_lines "gboolean gtk_tree_view_get_enable_tree_lines(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_enable_tree_lines", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_enable_tree_lines(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_enable_tree_lines(Xen tree_view, Xen enabled)
{
  #define H_gtk_tree_view_set_enable_tree_lines "void gtk_tree_view_set_enable_tree_lines(GtkTreeView* tree_view, \
gboolean enabled)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_enable_tree_lines", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(enabled), enabled, 2, "gtk_tree_view_set_enable_tree_lines", "gboolean");
  gtk_tree_view_set_enable_tree_lines(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(enabled));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_line_wrap_mode(Xen label, Xen wrap_mode)
{
  #define H_gtk_label_set_line_wrap_mode "void gtk_label_set_line_wrap_mode(GtkLabel* label, PangoWrapMode wrap_mode)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_line_wrap_mode", "GtkLabel*");
  Xen_check_type(Xen_is_PangoWrapMode(wrap_mode), wrap_mode, 2, "gtk_label_set_line_wrap_mode", "PangoWrapMode");
  gtk_label_set_line_wrap_mode(Xen_to_C_GtkLabel_(label), Xen_to_C_PangoWrapMode(wrap_mode));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_line_wrap_mode(Xen label)
{
  #define H_gtk_label_get_line_wrap_mode "PangoWrapMode gtk_label_get_line_wrap_mode(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_line_wrap_mode", "GtkLabel*");
  return(C_to_Xen_PangoWrapMode(gtk_label_get_line_wrap_mode(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_print_context_get_cairo_context(Xen context)
{
  #define H_gtk_print_context_get_cairo_context "cairo_t* gtk_print_context_get_cairo_context(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_get_cairo_context", "GtkPrintContext*");
  return(C_to_Xen_cairo_t_(gtk_print_context_get_cairo_context(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_get_page_setup(Xen context)
{
  #define H_gtk_print_context_get_page_setup "GtkPageSetup* gtk_print_context_get_page_setup(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_get_page_setup", "GtkPrintContext*");
  return(C_to_Xen_GtkPageSetup_(gtk_print_context_get_page_setup(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_get_width(Xen context)
{
  #define H_gtk_print_context_get_width "gdouble gtk_print_context_get_width(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_get_width", "GtkPrintContext*");
  return(C_to_Xen_gdouble(gtk_print_context_get_width(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_get_height(Xen context)
{
  #define H_gtk_print_context_get_height "gdouble gtk_print_context_get_height(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_get_height", "GtkPrintContext*");
  return(C_to_Xen_gdouble(gtk_print_context_get_height(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_get_dpi_x(Xen context)
{
  #define H_gtk_print_context_get_dpi_x "gdouble gtk_print_context_get_dpi_x(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_get_dpi_x", "GtkPrintContext*");
  return(C_to_Xen_gdouble(gtk_print_context_get_dpi_x(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_get_dpi_y(Xen context)
{
  #define H_gtk_print_context_get_dpi_y "gdouble gtk_print_context_get_dpi_y(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_get_dpi_y", "GtkPrintContext*");
  return(C_to_Xen_gdouble(gtk_print_context_get_dpi_y(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_create_pango_context(Xen context)
{
  #define H_gtk_print_context_create_pango_context "PangoContext* gtk_print_context_create_pango_context(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_create_pango_context", "GtkPrintContext*");
  return(C_to_Xen_PangoContext_(gtk_print_context_create_pango_context(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_create_pango_layout(Xen context)
{
  #define H_gtk_print_context_create_pango_layout "PangoLayout* gtk_print_context_create_pango_layout(GtkPrintContext* context)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_create_pango_layout", "GtkPrintContext*");
  return(C_to_Xen_PangoLayout_(gtk_print_context_create_pango_layout(Xen_to_C_GtkPrintContext_(context))));
}

static Xen gxg_gtk_print_context_set_cairo_context(Xen context, Xen cr, Xen dpi_x, Xen dpi_y)
{
  #define H_gtk_print_context_set_cairo_context "void gtk_print_context_set_cairo_context(GtkPrintContext* context, \
cairo_t* cr, double dpi_x, double dpi_y)"
  Xen_check_type(Xen_is_GtkPrintContext_(context), context, 1, "gtk_print_context_set_cairo_context", "GtkPrintContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_print_context_set_cairo_context", "cairo_t*");
  Xen_check_type(Xen_is_double(dpi_x), dpi_x, 3, "gtk_print_context_set_cairo_context", "double");
  Xen_check_type(Xen_is_double(dpi_y), dpi_y, 4, "gtk_print_context_set_cairo_context", "double");
  gtk_print_context_set_cairo_context(Xen_to_C_GtkPrintContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_double(dpi_x), 
                                      Xen_to_C_double(dpi_y));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_new(void)
{
  #define H_gtk_print_operation_new "GtkPrintOperation* gtk_print_operation_new( void)"
  return(C_to_Xen_GtkPrintOperation_(gtk_print_operation_new()));
}

static Xen gxg_gtk_print_operation_set_default_page_setup(Xen op, Xen default_page_setup)
{
  #define H_gtk_print_operation_set_default_page_setup "void gtk_print_operation_set_default_page_setup(GtkPrintOperation* op, \
GtkPageSetup* default_page_setup)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_default_page_setup", "GtkPrintOperation*");
  Xen_check_type(Xen_is_GtkPageSetup_(default_page_setup), default_page_setup, 2, "gtk_print_operation_set_default_page_setup", "GtkPageSetup*");
  gtk_print_operation_set_default_page_setup(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_GtkPageSetup_(default_page_setup));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_get_default_page_setup(Xen op)
{
  #define H_gtk_print_operation_get_default_page_setup "GtkPageSetup* gtk_print_operation_get_default_page_setup(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_get_default_page_setup", "GtkPrintOperation*");
  return(C_to_Xen_GtkPageSetup_(gtk_print_operation_get_default_page_setup(Xen_to_C_GtkPrintOperation_(op))));
}

static Xen gxg_gtk_print_operation_set_print_settings(Xen op, Xen print_settings)
{
  #define H_gtk_print_operation_set_print_settings "void gtk_print_operation_set_print_settings(GtkPrintOperation* op, \
GtkPrintSettings* print_settings)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_print_settings", "GtkPrintOperation*");
  Xen_check_type(Xen_is_GtkPrintSettings_(print_settings), print_settings, 2, "gtk_print_operation_set_print_settings", "GtkPrintSettings*");
  gtk_print_operation_set_print_settings(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_GtkPrintSettings_(print_settings));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_get_print_settings(Xen op)
{
  #define H_gtk_print_operation_get_print_settings "GtkPrintSettings* gtk_print_operation_get_print_settings(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_get_print_settings", "GtkPrintOperation*");
  return(C_to_Xen_GtkPrintSettings_(gtk_print_operation_get_print_settings(Xen_to_C_GtkPrintOperation_(op))));
}

static Xen gxg_gtk_print_operation_set_job_name(Xen op, Xen job_name)
{
  #define H_gtk_print_operation_set_job_name "void gtk_print_operation_set_job_name(GtkPrintOperation* op, \
gchar* job_name)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_job_name", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gchar_(job_name), job_name, 2, "gtk_print_operation_set_job_name", "gchar*");
  gtk_print_operation_set_job_name(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gchar_(job_name));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_n_pages(Xen op, Xen n_pages)
{
  #define H_gtk_print_operation_set_n_pages "void gtk_print_operation_set_n_pages(GtkPrintOperation* op, \
gint n_pages)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_n_pages", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gint(n_pages), n_pages, 2, "gtk_print_operation_set_n_pages", "gint");
  gtk_print_operation_set_n_pages(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gint(n_pages));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_current_page(Xen op, Xen current_page)
{
  #define H_gtk_print_operation_set_current_page "void gtk_print_operation_set_current_page(GtkPrintOperation* op, \
gint current_page)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_current_page", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gint(current_page), current_page, 2, "gtk_print_operation_set_current_page", "gint");
  gtk_print_operation_set_current_page(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gint(current_page));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_use_full_page(Xen op, Xen full_page)
{
  #define H_gtk_print_operation_set_use_full_page "void gtk_print_operation_set_use_full_page(GtkPrintOperation* op, \
gboolean full_page)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_use_full_page", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gboolean(full_page), full_page, 2, "gtk_print_operation_set_use_full_page", "gboolean");
  gtk_print_operation_set_use_full_page(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gboolean(full_page));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_unit(Xen op, Xen unit)
{
  #define H_gtk_print_operation_set_unit "void gtk_print_operation_set_unit(GtkPrintOperation* op, GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_unit", "GtkPrintOperation*");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 2, "gtk_print_operation_set_unit", "GtkUnit");
  gtk_print_operation_set_unit(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_GtkUnit(unit));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_export_filename(Xen op, Xen filename)
{
  #define H_gtk_print_operation_set_export_filename "void gtk_print_operation_set_export_filename(GtkPrintOperation* op, \
gchar* filename)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_export_filename", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gchar_(filename), filename, 2, "gtk_print_operation_set_export_filename", "gchar*");
  gtk_print_operation_set_export_filename(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gchar_(filename));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_track_print_status(Xen op, Xen track_status)
{
  #define H_gtk_print_operation_set_track_print_status "void gtk_print_operation_set_track_print_status(GtkPrintOperation* op, \
gboolean track_status)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_track_print_status", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gboolean(track_status), track_status, 2, "gtk_print_operation_set_track_print_status", "gboolean");
  gtk_print_operation_set_track_print_status(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gboolean(track_status));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_show_progress(Xen op, Xen show_progress)
{
  #define H_gtk_print_operation_set_show_progress "void gtk_print_operation_set_show_progress(GtkPrintOperation* op, \
gboolean show_progress)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_show_progress", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gboolean(show_progress), show_progress, 2, "gtk_print_operation_set_show_progress", "gboolean");
  gtk_print_operation_set_show_progress(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gboolean(show_progress));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_allow_async(Xen op, Xen allow_async)
{
  #define H_gtk_print_operation_set_allow_async "void gtk_print_operation_set_allow_async(GtkPrintOperation* op, \
gboolean allow_async)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_allow_async", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gboolean(allow_async), allow_async, 2, "gtk_print_operation_set_allow_async", "gboolean");
  gtk_print_operation_set_allow_async(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gboolean(allow_async));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_set_custom_tab_label(Xen op, Xen label)
{
  #define H_gtk_print_operation_set_custom_tab_label "void gtk_print_operation_set_custom_tab_label(GtkPrintOperation* op, \
gchar* label)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_custom_tab_label", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_print_operation_set_custom_tab_label", "gchar*");
  gtk_print_operation_set_custom_tab_label(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_run(Xen op, Xen action, Xen parent, Xen ignore_error)
{
  #define H_gtk_print_operation_run "GtkPrintOperationResult gtk_print_operation_run(GtkPrintOperation* op, \
GtkPrintOperationAction action, GtkWindow* parent, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_run", "GtkPrintOperation*");
  Xen_check_type(Xen_is_GtkPrintOperationAction(action), action, 2, "gtk_print_operation_run", "GtkPrintOperationAction");
  Xen_check_type(Xen_is_GtkWindow_(parent), parent, 3, "gtk_print_operation_run", "GtkWindow*");
  {
    Xen result;
    result = C_to_Xen_GtkPrintOperationResult(gtk_print_operation_run(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_GtkPrintOperationAction(action), 
                                                                      Xen_to_C_GtkWindow_(parent), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_print_operation_get_error(Xen op, Xen ignore_error)
{
  #define H_gtk_print_operation_get_error "void gtk_print_operation_get_error(GtkPrintOperation* op, \
GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_get_error", "GtkPrintOperation*");
  gtk_print_operation_get_error(Xen_to_C_GtkPrintOperation_(op), &ref_error);
  return(Xen_list_1(C_to_Xen_GError_(ref_error)));
}

static Xen gxg_gtk_print_operation_get_status(Xen op)
{
  #define H_gtk_print_operation_get_status "GtkPrintStatus gtk_print_operation_get_status(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_get_status", "GtkPrintOperation*");
  return(C_to_Xen_GtkPrintStatus(gtk_print_operation_get_status(Xen_to_C_GtkPrintOperation_(op))));
}

static Xen gxg_gtk_print_operation_get_status_string(Xen op)
{
  #define H_gtk_print_operation_get_status_string "gchar* gtk_print_operation_get_status_string(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_get_status_string", "GtkPrintOperation*");
  return(C_to_Xen_gchar_(gtk_print_operation_get_status_string(Xen_to_C_GtkPrintOperation_(op))));
}

static Xen gxg_gtk_print_operation_is_finished(Xen op)
{
  #define H_gtk_print_operation_is_finished "gboolean gtk_print_operation_is_finished(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_is_finished", "GtkPrintOperation*");
  return(C_to_Xen_gboolean(gtk_print_operation_is_finished(Xen_to_C_GtkPrintOperation_(op))));
}

static Xen gxg_gtk_print_operation_cancel(Xen op)
{
  #define H_gtk_print_operation_cancel "void gtk_print_operation_cancel(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_cancel", "GtkPrintOperation*");
  gtk_print_operation_cancel(Xen_to_C_GtkPrintOperation_(op));
  return(Xen_false);
}

static Xen gxg_gtk_print_run_page_setup_dialog(Xen parent, Xen page_setup, Xen settings)
{
  #define H_gtk_print_run_page_setup_dialog "GtkPageSetup* gtk_print_run_page_setup_dialog(GtkWindow* parent, \
GtkPageSetup* page_setup, GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkWindow_(parent), parent, 1, "gtk_print_run_page_setup_dialog", "GtkWindow*");
  Xen_check_type(Xen_is_GtkPageSetup_(page_setup), page_setup, 2, "gtk_print_run_page_setup_dialog", "GtkPageSetup*");
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 3, "gtk_print_run_page_setup_dialog", "GtkPrintSettings*");
  return(C_to_Xen_GtkPageSetup_(gtk_print_run_page_setup_dialog(Xen_to_C_GtkWindow_(parent), Xen_to_C_GtkPageSetup_(page_setup), 
                                                                Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_run_page_setup_dialog_async(Xen parent, Xen page_setup, Xen settings, Xen done_cb, Xen data)
{
  #define H_gtk_print_run_page_setup_dialog_async "void gtk_print_run_page_setup_dialog_async(GtkWindow* parent, \
GtkPageSetup* page_setup, GtkPrintSettings* settings, GtkPageSetupDoneFunc done_cb, gpointer data)"
  Xen_check_type(Xen_is_GtkWindow_(parent), parent, 1, "gtk_print_run_page_setup_dialog_async", "GtkWindow*");
  Xen_check_type(Xen_is_GtkPageSetup_(page_setup), page_setup, 2, "gtk_print_run_page_setup_dialog_async", "GtkPageSetup*");
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 3, "gtk_print_run_page_setup_dialog_async", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPageSetupDoneFunc(done_cb), done_cb, 4, "gtk_print_run_page_setup_dialog_async", "GtkPageSetupDoneFunc");
  Xen_check_type(Xen_is_gpointer(data), data, 5, "gtk_print_run_page_setup_dialog_async", "gpointer");
  gtk_print_run_page_setup_dialog_async(Xen_to_C_GtkWindow_(parent), Xen_to_C_GtkPageSetup_(page_setup), Xen_to_C_GtkPrintSettings_(settings), 
                                        Xen_to_C_GtkPageSetupDoneFunc(done_cb), Xen_to_C_gpointer(data));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_new(void)
{
  #define H_gtk_print_settings_new "GtkPrintSettings* gtk_print_settings_new( void)"
  return(C_to_Xen_GtkPrintSettings_(gtk_print_settings_new()));
}

static Xen gxg_gtk_print_settings_copy(Xen other)
{
  #define H_gtk_print_settings_copy "GtkPrintSettings* gtk_print_settings_copy(GtkPrintSettings* other)"
  Xen_check_type(Xen_is_GtkPrintSettings_(other), other, 1, "gtk_print_settings_copy", "GtkPrintSettings*");
  return(C_to_Xen_GtkPrintSettings_(gtk_print_settings_copy(Xen_to_C_GtkPrintSettings_(other))));
}

static Xen gxg_gtk_print_settings_has_key(Xen settings, Xen key)
{
  #define H_gtk_print_settings_has_key "gboolean gtk_print_settings_has_key(GtkPrintSettings* settings, \
gchar* key)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_has_key", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_has_key", "gchar*");
  return(C_to_Xen_gboolean(gtk_print_settings_has_key(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key))));
}

static Xen gxg_gtk_print_settings_get(Xen settings, Xen key)
{
  #define H_gtk_print_settings_get "gchar* gtk_print_settings_get(GtkPrintSettings* settings, gchar* key)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get", "gchar*");
  return(C_to_Xen_gchar_(gtk_print_settings_get(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key))));
}

static Xen gxg_gtk_print_settings_set(Xen settings, Xen key, Xen value)
{
  #define H_gtk_print_settings_set "void gtk_print_settings_set(GtkPrintSettings* settings, gchar* key, \
gchar* value)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_set", "gchar*");
  Xen_check_type(Xen_is_gchar_(value), value, 3, "gtk_print_settings_set", "gchar*");
  gtk_print_settings_set(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), Xen_to_C_gchar_(value));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_unset(Xen settings, Xen key)
{
  #define H_gtk_print_settings_unset "void gtk_print_settings_unset(GtkPrintSettings* settings, gchar* key)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_unset", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_unset", "gchar*");
  gtk_print_settings_unset(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_foreach(Xen settings, Xen func, Xen user_data)
{
  #define H_gtk_print_settings_foreach "void gtk_print_settings_foreach(GtkPrintSettings* settings, GtkPrintSettingsFunc func, \
gpointer user_data)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_foreach", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPrintSettingsFunc(func), func, 2, "gtk_print_settings_foreach", "GtkPrintSettingsFunc");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 3, "gtk_print_settings_foreach", "gpointer");
  gtk_print_settings_foreach(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPrintSettingsFunc(func), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_bool(Xen settings, Xen key)
{
  #define H_gtk_print_settings_get_bool "gboolean gtk_print_settings_get_bool(GtkPrintSettings* settings, \
gchar* key)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_bool", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get_bool", "gchar*");
  return(C_to_Xen_gboolean(gtk_print_settings_get_bool(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key))));
}

static Xen gxg_gtk_print_settings_set_bool(Xen settings, Xen key, Xen value)
{
  #define H_gtk_print_settings_set_bool "void gtk_print_settings_set_bool(GtkPrintSettings* settings, \
gchar* key, gboolean value)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_bool", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_set_bool", "gchar*");
  Xen_check_type(Xen_is_gboolean(value), value, 3, "gtk_print_settings_set_bool", "gboolean");
  gtk_print_settings_set_bool(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), Xen_to_C_gboolean(value));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_double(Xen settings, Xen key)
{
  #define H_gtk_print_settings_get_double "gdouble gtk_print_settings_get_double(GtkPrintSettings* settings, \
gchar* key)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_double", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get_double", "gchar*");
  return(C_to_Xen_gdouble(gtk_print_settings_get_double(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key))));
}

static Xen gxg_gtk_print_settings_get_double_with_default(Xen settings, Xen key, Xen def)
{
  #define H_gtk_print_settings_get_double_with_default "gdouble gtk_print_settings_get_double_with_default(GtkPrintSettings* settings, \
gchar* key, gdouble def)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_double_with_default", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get_double_with_default", "gchar*");
  Xen_check_type(Xen_is_gdouble(def), def, 3, "gtk_print_settings_get_double_with_default", "gdouble");
  return(C_to_Xen_gdouble(gtk_print_settings_get_double_with_default(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), 
                                                                     Xen_to_C_gdouble(def))));
}

static Xen gxg_gtk_print_settings_set_double(Xen settings, Xen key, Xen value)
{
  #define H_gtk_print_settings_set_double "void gtk_print_settings_set_double(GtkPrintSettings* settings, \
gchar* key, gdouble value)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_double", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_set_double", "gchar*");
  Xen_check_type(Xen_is_gdouble(value), value, 3, "gtk_print_settings_set_double", "gdouble");
  gtk_print_settings_set_double(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_length(Xen settings, Xen key, Xen unit)
{
  #define H_gtk_print_settings_get_length "gdouble gtk_print_settings_get_length(GtkPrintSettings* settings, \
gchar* key, GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_length", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get_length", "gchar*");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 3, "gtk_print_settings_get_length", "GtkUnit");
  return(C_to_Xen_gdouble(gtk_print_settings_get_length(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), Xen_to_C_GtkUnit(unit))));
}

static Xen gxg_gtk_print_settings_set_length(Xen settings, Xen key, Xen value, Xen unit)
{
  #define H_gtk_print_settings_set_length "void gtk_print_settings_set_length(GtkPrintSettings* settings, \
gchar* key, gdouble value, GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_length", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_set_length", "gchar*");
  Xen_check_type(Xen_is_gdouble(value), value, 3, "gtk_print_settings_set_length", "gdouble");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 4, "gtk_print_settings_set_length", "GtkUnit");
  gtk_print_settings_set_length(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), Xen_to_C_gdouble(value), Xen_to_C_GtkUnit(unit));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_int(Xen settings, Xen key)
{
  #define H_gtk_print_settings_get_int "gint gtk_print_settings_get_int(GtkPrintSettings* settings, gchar* key)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_int", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get_int", "gchar*");
  return(C_to_Xen_gint(gtk_print_settings_get_int(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key))));
}

static Xen gxg_gtk_print_settings_get_int_with_default(Xen settings, Xen key, Xen def)
{
  #define H_gtk_print_settings_get_int_with_default "gint gtk_print_settings_get_int_with_default(GtkPrintSettings* settings, \
gchar* key, gint def)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_int_with_default", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_get_int_with_default", "gchar*");
  Xen_check_type(Xen_is_gint(def), def, 3, "gtk_print_settings_get_int_with_default", "gint");
  return(C_to_Xen_gint(gtk_print_settings_get_int_with_default(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), 
                                                               Xen_to_C_gint(def))));
}

static Xen gxg_gtk_print_settings_set_int(Xen settings, Xen key, Xen value)
{
  #define H_gtk_print_settings_set_int "void gtk_print_settings_set_int(GtkPrintSettings* settings, gchar* key, \
gint value)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_int", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(key), key, 2, "gtk_print_settings_set_int", "gchar*");
  Xen_check_type(Xen_is_gint(value), value, 3, "gtk_print_settings_set_int", "gint");
  gtk_print_settings_set_int(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(key), Xen_to_C_gint(value));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_printer(Xen settings)
{
  #define H_gtk_print_settings_get_printer "gchar* gtk_print_settings_get_printer(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_printer", "GtkPrintSettings*");
  return(C_to_Xen_gchar_(gtk_print_settings_get_printer(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_printer(Xen settings, Xen printer)
{
  #define H_gtk_print_settings_set_printer "void gtk_print_settings_set_printer(GtkPrintSettings* settings, \
gchar* printer)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_printer", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(printer), printer, 2, "gtk_print_settings_set_printer", "gchar*");
  gtk_print_settings_set_printer(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(printer));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_orientation(Xen settings)
{
  #define H_gtk_print_settings_get_orientation "GtkPageOrientation gtk_print_settings_get_orientation(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_orientation", "GtkPrintSettings*");
  return(C_to_Xen_GtkPageOrientation(gtk_print_settings_get_orientation(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_orientation(Xen settings, Xen orientation)
{
  #define H_gtk_print_settings_set_orientation "void gtk_print_settings_set_orientation(GtkPrintSettings* settings, \
GtkPageOrientation orientation)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_orientation", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPageOrientation(orientation), orientation, 2, "gtk_print_settings_set_orientation", "GtkPageOrientation");
  gtk_print_settings_set_orientation(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPageOrientation(orientation));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_paper_size(Xen settings)
{
  #define H_gtk_print_settings_get_paper_size "GtkPaperSize* gtk_print_settings_get_paper_size(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_paper_size", "GtkPrintSettings*");
  return(C_to_Xen_GtkPaperSize_(gtk_print_settings_get_paper_size(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_paper_size(Xen settings, Xen paper_size)
{
  #define H_gtk_print_settings_set_paper_size "void gtk_print_settings_set_paper_size(GtkPrintSettings* settings, \
GtkPaperSize* paper_size)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_paper_size", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPaperSize_(paper_size), paper_size, 2, "gtk_print_settings_set_paper_size", "GtkPaperSize*");
  gtk_print_settings_set_paper_size(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPaperSize_(paper_size));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_paper_width(Xen settings, Xen unit)
{
  #define H_gtk_print_settings_get_paper_width "gdouble gtk_print_settings_get_paper_width(GtkPrintSettings* settings, \
GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_paper_width", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 2, "gtk_print_settings_get_paper_width", "GtkUnit");
  return(C_to_Xen_gdouble(gtk_print_settings_get_paper_width(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkUnit(unit))));
}

static Xen gxg_gtk_print_settings_set_paper_width(Xen settings, Xen width, Xen unit)
{
  #define H_gtk_print_settings_set_paper_width "void gtk_print_settings_set_paper_width(GtkPrintSettings* settings, \
gdouble width, GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_paper_width", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gdouble(width), width, 2, "gtk_print_settings_set_paper_width", "gdouble");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 3, "gtk_print_settings_set_paper_width", "GtkUnit");
  gtk_print_settings_set_paper_width(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gdouble(width), Xen_to_C_GtkUnit(unit));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_paper_height(Xen settings, Xen unit)
{
  #define H_gtk_print_settings_get_paper_height "gdouble gtk_print_settings_get_paper_height(GtkPrintSettings* settings, \
GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_paper_height", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 2, "gtk_print_settings_get_paper_height", "GtkUnit");
  return(C_to_Xen_gdouble(gtk_print_settings_get_paper_height(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkUnit(unit))));
}

static Xen gxg_gtk_print_settings_set_paper_height(Xen settings, Xen height, Xen unit)
{
  #define H_gtk_print_settings_set_paper_height "void gtk_print_settings_set_paper_height(GtkPrintSettings* settings, \
gdouble height, GtkUnit unit)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_paper_height", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gdouble(height), height, 2, "gtk_print_settings_set_paper_height", "gdouble");
  Xen_check_type(Xen_is_GtkUnit(unit), unit, 3, "gtk_print_settings_set_paper_height", "GtkUnit");
  gtk_print_settings_set_paper_height(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gdouble(height), Xen_to_C_GtkUnit(unit));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_use_color(Xen settings)
{
  #define H_gtk_print_settings_get_use_color "gboolean gtk_print_settings_get_use_color(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_use_color", "GtkPrintSettings*");
  return(C_to_Xen_gboolean(gtk_print_settings_get_use_color(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_use_color(Xen settings, Xen use_color)
{
  #define H_gtk_print_settings_set_use_color "void gtk_print_settings_set_use_color(GtkPrintSettings* settings, \
gboolean use_color)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_use_color", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gboolean(use_color), use_color, 2, "gtk_print_settings_set_use_color", "gboolean");
  gtk_print_settings_set_use_color(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gboolean(use_color));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_collate(Xen settings)
{
  #define H_gtk_print_settings_get_collate "gboolean gtk_print_settings_get_collate(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_collate", "GtkPrintSettings*");
  return(C_to_Xen_gboolean(gtk_print_settings_get_collate(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_collate(Xen settings, Xen collate)
{
  #define H_gtk_print_settings_set_collate "void gtk_print_settings_set_collate(GtkPrintSettings* settings, \
gboolean collate)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_collate", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gboolean(collate), collate, 2, "gtk_print_settings_set_collate", "gboolean");
  gtk_print_settings_set_collate(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gboolean(collate));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_reverse(Xen settings)
{
  #define H_gtk_print_settings_get_reverse "gboolean gtk_print_settings_get_reverse(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_reverse", "GtkPrintSettings*");
  return(C_to_Xen_gboolean(gtk_print_settings_get_reverse(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_reverse(Xen settings, Xen reverse)
{
  #define H_gtk_print_settings_set_reverse "void gtk_print_settings_set_reverse(GtkPrintSettings* settings, \
gboolean reverse)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_reverse", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gboolean(reverse), reverse, 2, "gtk_print_settings_set_reverse", "gboolean");
  gtk_print_settings_set_reverse(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gboolean(reverse));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_duplex(Xen settings)
{
  #define H_gtk_print_settings_get_duplex "GtkPrintDuplex gtk_print_settings_get_duplex(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_duplex", "GtkPrintSettings*");
  return(C_to_Xen_GtkPrintDuplex(gtk_print_settings_get_duplex(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_duplex(Xen settings, Xen duplex)
{
  #define H_gtk_print_settings_set_duplex "void gtk_print_settings_set_duplex(GtkPrintSettings* settings, \
GtkPrintDuplex duplex)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_duplex", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPrintDuplex(duplex), duplex, 2, "gtk_print_settings_set_duplex", "GtkPrintDuplex");
  gtk_print_settings_set_duplex(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPrintDuplex(duplex));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_quality(Xen settings)
{
  #define H_gtk_print_settings_get_quality "GtkPrintQuality gtk_print_settings_get_quality(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_quality", "GtkPrintSettings*");
  return(C_to_Xen_GtkPrintQuality(gtk_print_settings_get_quality(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_quality(Xen settings, Xen quality)
{
  #define H_gtk_print_settings_set_quality "void gtk_print_settings_set_quality(GtkPrintSettings* settings, \
GtkPrintQuality quality)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_quality", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPrintQuality(quality), quality, 2, "gtk_print_settings_set_quality", "GtkPrintQuality");
  gtk_print_settings_set_quality(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPrintQuality(quality));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_n_copies(Xen settings)
{
  #define H_gtk_print_settings_get_n_copies "gint gtk_print_settings_get_n_copies(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_n_copies", "GtkPrintSettings*");
  return(C_to_Xen_gint(gtk_print_settings_get_n_copies(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_n_copies(Xen settings, Xen num_copies)
{
  #define H_gtk_print_settings_set_n_copies "void gtk_print_settings_set_n_copies(GtkPrintSettings* settings, \
gint num_copies)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_n_copies", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gint(num_copies), num_copies, 2, "gtk_print_settings_set_n_copies", "gint");
  gtk_print_settings_set_n_copies(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gint(num_copies));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_number_up(Xen settings)
{
  #define H_gtk_print_settings_get_number_up "gint gtk_print_settings_get_number_up(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_number_up", "GtkPrintSettings*");
  return(C_to_Xen_gint(gtk_print_settings_get_number_up(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_number_up(Xen settings, Xen number_up)
{
  #define H_gtk_print_settings_set_number_up "void gtk_print_settings_set_number_up(GtkPrintSettings* settings, \
gint number_up)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_number_up", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gint(number_up), number_up, 2, "gtk_print_settings_set_number_up", "gint");
  gtk_print_settings_set_number_up(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gint(number_up));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_resolution(Xen settings)
{
  #define H_gtk_print_settings_get_resolution "gint gtk_print_settings_get_resolution(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_resolution", "GtkPrintSettings*");
  return(C_to_Xen_gint(gtk_print_settings_get_resolution(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_resolution(Xen settings, Xen resolution)
{
  #define H_gtk_print_settings_set_resolution "void gtk_print_settings_set_resolution(GtkPrintSettings* settings, \
gint resolution)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_resolution", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gint(resolution), resolution, 2, "gtk_print_settings_set_resolution", "gint");
  gtk_print_settings_set_resolution(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gint(resolution));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_scale(Xen settings)
{
  #define H_gtk_print_settings_get_scale "gdouble gtk_print_settings_get_scale(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_scale", "GtkPrintSettings*");
  return(C_to_Xen_gdouble(gtk_print_settings_get_scale(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_scale(Xen settings, Xen scale)
{
  #define H_gtk_print_settings_set_scale "void gtk_print_settings_set_scale(GtkPrintSettings* settings, \
gdouble scale)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_scale", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gdouble(scale), scale, 2, "gtk_print_settings_set_scale", "gdouble");
  gtk_print_settings_set_scale(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gdouble(scale));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_print_pages(Xen settings)
{
  #define H_gtk_print_settings_get_print_pages "GtkPrintPages gtk_print_settings_get_print_pages(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_print_pages", "GtkPrintSettings*");
  return(C_to_Xen_GtkPrintPages(gtk_print_settings_get_print_pages(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_print_pages(Xen settings, Xen pages)
{
  #define H_gtk_print_settings_set_print_pages "void gtk_print_settings_set_print_pages(GtkPrintSettings* settings, \
GtkPrintPages pages)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_print_pages", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPrintPages(pages), pages, 2, "gtk_print_settings_set_print_pages", "GtkPrintPages");
  gtk_print_settings_set_print_pages(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPrintPages(pages));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_page_ranges(Xen settings, Xen num_ranges)
{
  #define H_gtk_print_settings_get_page_ranges "GtkPageRange* gtk_print_settings_get_page_ranges(GtkPrintSettings* settings, \
gint* num_ranges)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_page_ranges", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gint_(num_ranges), num_ranges, 2, "gtk_print_settings_get_page_ranges", "gint*");
  return(C_to_Xen_GtkPageRange_(gtk_print_settings_get_page_ranges(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gint_(num_ranges))));
}

static Xen gxg_gtk_print_settings_set_page_ranges(Xen settings, Xen page_ranges, Xen num_ranges)
{
  #define H_gtk_print_settings_set_page_ranges "void gtk_print_settings_set_page_ranges(GtkPrintSettings* settings, \
GtkPageRange* page_ranges, gint num_ranges)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_page_ranges", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPageRange_(page_ranges), page_ranges, 2, "gtk_print_settings_set_page_ranges", "GtkPageRange*");
  Xen_check_type(Xen_is_gint(num_ranges), num_ranges, 3, "gtk_print_settings_set_page_ranges", "gint");
  gtk_print_settings_set_page_ranges(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPageRange_(page_ranges), Xen_to_C_gint(num_ranges));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_page_set(Xen settings)
{
  #define H_gtk_print_settings_get_page_set "GtkPageSet gtk_print_settings_get_page_set(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_page_set", "GtkPrintSettings*");
  return(C_to_Xen_GtkPageSet(gtk_print_settings_get_page_set(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_page_set(Xen settings, Xen page_set)
{
  #define H_gtk_print_settings_set_page_set "void gtk_print_settings_set_page_set(GtkPrintSettings* settings, \
GtkPageSet page_set)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_page_set", "GtkPrintSettings*");
  Xen_check_type(Xen_is_GtkPageSet(page_set), page_set, 2, "gtk_print_settings_set_page_set", "GtkPageSet");
  gtk_print_settings_set_page_set(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_GtkPageSet(page_set));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_default_source(Xen settings)
{
  #define H_gtk_print_settings_get_default_source "gchar* gtk_print_settings_get_default_source(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_default_source", "GtkPrintSettings*");
  return(C_to_Xen_gchar_(gtk_print_settings_get_default_source(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_default_source(Xen settings, Xen default_source)
{
  #define H_gtk_print_settings_set_default_source "void gtk_print_settings_set_default_source(GtkPrintSettings* settings, \
gchar* default_source)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_default_source", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(default_source), default_source, 2, "gtk_print_settings_set_default_source", "gchar*");
  gtk_print_settings_set_default_source(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(default_source));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_media_type(Xen settings)
{
  #define H_gtk_print_settings_get_media_type "gchar* gtk_print_settings_get_media_type(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_media_type", "GtkPrintSettings*");
  return(C_to_Xen_gchar_(gtk_print_settings_get_media_type(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_media_type(Xen settings, Xen media_type)
{
  #define H_gtk_print_settings_set_media_type "void gtk_print_settings_set_media_type(GtkPrintSettings* settings, \
gchar* media_type)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_media_type", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(media_type), media_type, 2, "gtk_print_settings_set_media_type", "gchar*");
  gtk_print_settings_set_media_type(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(media_type));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_dither(Xen settings)
{
  #define H_gtk_print_settings_get_dither "gchar* gtk_print_settings_get_dither(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_dither", "GtkPrintSettings*");
  return(C_to_Xen_gchar_(gtk_print_settings_get_dither(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_dither(Xen settings, Xen dither)
{
  #define H_gtk_print_settings_set_dither "void gtk_print_settings_set_dither(GtkPrintSettings* settings, \
gchar* dither)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_dither", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(dither), dither, 2, "gtk_print_settings_set_dither", "gchar*");
  gtk_print_settings_set_dither(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(dither));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_finishings(Xen settings)
{
  #define H_gtk_print_settings_get_finishings "gchar* gtk_print_settings_get_finishings(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_finishings", "GtkPrintSettings*");
  return(C_to_Xen_gchar_(gtk_print_settings_get_finishings(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_finishings(Xen settings, Xen finishings)
{
  #define H_gtk_print_settings_set_finishings "void gtk_print_settings_set_finishings(GtkPrintSettings* settings, \
gchar* finishings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_finishings", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(finishings), finishings, 2, "gtk_print_settings_set_finishings", "gchar*");
  gtk_print_settings_set_finishings(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(finishings));
  return(Xen_false);
}

static Xen gxg_gtk_print_settings_get_output_bin(Xen settings)
{
  #define H_gtk_print_settings_get_output_bin "gchar* gtk_print_settings_get_output_bin(GtkPrintSettings* settings)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_get_output_bin", "GtkPrintSettings*");
  return(C_to_Xen_gchar_(gtk_print_settings_get_output_bin(Xen_to_C_GtkPrintSettings_(settings))));
}

static Xen gxg_gtk_print_settings_set_output_bin(Xen settings, Xen output_bin)
{
  #define H_gtk_print_settings_set_output_bin "void gtk_print_settings_set_output_bin(GtkPrintSettings* settings, \
gchar* output_bin)"
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_set_output_bin", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(output_bin), output_bin, 2, "gtk_print_settings_set_output_bin", "gchar*");
  gtk_print_settings_set_output_bin(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(output_bin));
  return(Xen_false);
}

static Xen gxg_pango_cairo_create_layout(Xen cr)
{
  #define H_pango_cairo_create_layout "PangoLayout* pango_cairo_create_layout(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_create_layout", "cairo_t*");
  return(C_to_Xen_PangoLayout_(pango_cairo_create_layout(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_pango_cairo_update_layout(Xen cr, Xen layout)
{
  #define H_pango_cairo_update_layout "void pango_cairo_update_layout(cairo_t* cr, PangoLayout* layout)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_update_layout", "cairo_t*");
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 2, "pango_cairo_update_layout", "PangoLayout*");
  pango_cairo_update_layout(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoLayout_(layout));
  return(Xen_false);
}

static Xen gxg_pango_cairo_update_context(Xen cr, Xen context)
{
  #define H_pango_cairo_update_context "void pango_cairo_update_context(cairo_t* cr, PangoContext* context)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_update_context", "cairo_t*");
  Xen_check_type(Xen_is_PangoContext_(context), context, 2, "pango_cairo_update_context", "PangoContext*");
  pango_cairo_update_context(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoContext_(context));
  return(Xen_false);
}

static Xen gxg_pango_cairo_context_set_font_options(Xen context, Xen options)
{
  #define H_pango_cairo_context_set_font_options "void pango_cairo_context_set_font_options(PangoContext* context, \
cairo_font_options_t* options)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_cairo_context_set_font_options", "PangoContext*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 2, "pango_cairo_context_set_font_options", "cairo_font_options_t*");
  pango_cairo_context_set_font_options(Xen_to_C_PangoContext_(context), Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_pango_cairo_context_get_font_options(Xen context)
{
  #define H_pango_cairo_context_get_font_options "cairo_font_options_t* pango_cairo_context_get_font_options(PangoContext* context)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_cairo_context_get_font_options", "PangoContext*");
    return(C_to_Xen_cairo_font_options_t_((cairo_font_options_t*)pango_cairo_context_get_font_options(Xen_to_C_PangoContext_(context))));
}

static Xen gxg_pango_cairo_context_set_resolution(Xen context, Xen dpi)
{
  #define H_pango_cairo_context_set_resolution "void pango_cairo_context_set_resolution(PangoContext* context, \
gdouble dpi)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_cairo_context_set_resolution", "PangoContext*");
  Xen_check_type(Xen_is_gdouble(dpi), dpi, 2, "pango_cairo_context_set_resolution", "gdouble");
  pango_cairo_context_set_resolution(Xen_to_C_PangoContext_(context), Xen_to_C_gdouble(dpi));
  return(Xen_false);
}

static Xen gxg_pango_cairo_context_get_resolution(Xen context)
{
  #define H_pango_cairo_context_get_resolution "gdouble pango_cairo_context_get_resolution(PangoContext* context)"
  Xen_check_type(Xen_is_PangoContext_(context), context, 1, "pango_cairo_context_get_resolution", "PangoContext*");
  return(C_to_Xen_gdouble(pango_cairo_context_get_resolution(Xen_to_C_PangoContext_(context))));
}

static Xen gxg_pango_cairo_show_glyph_string(Xen cr, Xen font, Xen glyphs)
{
  #define H_pango_cairo_show_glyph_string "void pango_cairo_show_glyph_string(cairo_t* cr, PangoFont* font, \
PangoGlyphString* glyphs)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_show_glyph_string", "cairo_t*");
  Xen_check_type(Xen_is_PangoFont_(font), font, 2, "pango_cairo_show_glyph_string", "PangoFont*");
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 3, "pango_cairo_show_glyph_string", "PangoGlyphString*");
  pango_cairo_show_glyph_string(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoFont_(font), Xen_to_C_PangoGlyphString_(glyphs));
  return(Xen_false);
}

static Xen gxg_pango_cairo_show_layout_line(Xen cr, Xen line)
{
  #define H_pango_cairo_show_layout_line "void pango_cairo_show_layout_line(cairo_t* cr, PangoLayoutLine* line)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_show_layout_line", "cairo_t*");
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 2, "pango_cairo_show_layout_line", "PangoLayoutLine*");
  pango_cairo_show_layout_line(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoLayoutLine_(line));
  return(Xen_false);
}

static Xen gxg_pango_cairo_show_layout(Xen cr, Xen layout)
{
  #define H_pango_cairo_show_layout "void pango_cairo_show_layout(cairo_t* cr, PangoLayout* layout)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_show_layout", "cairo_t*");
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 2, "pango_cairo_show_layout", "PangoLayout*");
  pango_cairo_show_layout(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoLayout_(layout));
  return(Xen_false);
}

static Xen gxg_pango_cairo_show_error_underline(Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_pango_cairo_show_error_underline "void pango_cairo_show_error_underline(cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_show_error_underline", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 2, "pango_cairo_show_error_underline", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 3, "pango_cairo_show_error_underline", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 4, "pango_cairo_show_error_underline", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 5, "pango_cairo_show_error_underline", "gdouble");
  pango_cairo_show_error_underline(Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), Xen_to_C_gdouble(width), 
                                   Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_pango_cairo_glyph_string_path(Xen cr, Xen font, Xen glyphs)
{
  #define H_pango_cairo_glyph_string_path "void pango_cairo_glyph_string_path(cairo_t* cr, PangoFont* font, \
PangoGlyphString* glyphs)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_glyph_string_path", "cairo_t*");
  Xen_check_type(Xen_is_PangoFont_(font), font, 2, "pango_cairo_glyph_string_path", "PangoFont*");
  Xen_check_type(Xen_is_PangoGlyphString_(glyphs), glyphs, 3, "pango_cairo_glyph_string_path", "PangoGlyphString*");
  pango_cairo_glyph_string_path(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoFont_(font), Xen_to_C_PangoGlyphString_(glyphs));
  return(Xen_false);
}

static Xen gxg_pango_cairo_layout_line_path(Xen cr, Xen line)
{
  #define H_pango_cairo_layout_line_path "void pango_cairo_layout_line_path(cairo_t* cr, PangoLayoutLine* line)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_layout_line_path", "cairo_t*");
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 2, "pango_cairo_layout_line_path", "PangoLayoutLine*");
  pango_cairo_layout_line_path(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoLayoutLine_(line));
  return(Xen_false);
}

static Xen gxg_pango_cairo_layout_path(Xen cr, Xen layout)
{
  #define H_pango_cairo_layout_path "void pango_cairo_layout_path(cairo_t* cr, PangoLayout* layout)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_layout_path", "cairo_t*");
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 2, "pango_cairo_layout_path", "PangoLayout*");
  pango_cairo_layout_path(Xen_to_C_cairo_t_(cr), Xen_to_C_PangoLayout_(layout));
  return(Xen_false);
}

static Xen gxg_pango_cairo_error_underline_path(Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_pango_cairo_error_underline_path "void pango_cairo_error_underline_path(cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "pango_cairo_error_underline_path", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 2, "pango_cairo_error_underline_path", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 3, "pango_cairo_error_underline_path", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 4, "pango_cairo_error_underline_path", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 5, "pango_cairo_error_underline_path", "gdouble");
  pango_cairo_error_underline_path(Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), Xen_to_C_gdouble(width), 
                                   Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gdk_cairo_set_source_pixbuf(Xen cr, Xen pixbuf, Xen pixbuf_x, Xen pixbuf_y)
{
  #define H_gdk_cairo_set_source_pixbuf "void gdk_cairo_set_source_pixbuf(cairo_t* cr, GdkPixbuf* pixbuf, \
gdouble pixbuf_x, gdouble pixbuf_y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "gdk_cairo_set_source_pixbuf", "cairo_t*");
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 2, "gdk_cairo_set_source_pixbuf", "GdkPixbuf*");
  Xen_check_type(Xen_is_gdouble(pixbuf_x), pixbuf_x, 3, "gdk_cairo_set_source_pixbuf", "gdouble");
  Xen_check_type(Xen_is_gdouble(pixbuf_y), pixbuf_y, 4, "gdk_cairo_set_source_pixbuf", "gdouble");
  gdk_cairo_set_source_pixbuf(Xen_to_C_cairo_t_(cr), Xen_to_C_GdkPixbuf_(pixbuf), Xen_to_C_gdouble(pixbuf_x), Xen_to_C_gdouble(pixbuf_y));
  return(Xen_false);
}

static Xen gxg_gdk_cairo_rectangle(Xen cr, Xen rectangle)
{
  #define H_gdk_cairo_rectangle "void gdk_cairo_rectangle(cairo_t* cr, GdkRectangle* rectangle)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "gdk_cairo_rectangle", "cairo_t*");
  Xen_check_type(Xen_is_GdkRectangle_(rectangle), rectangle, 2, "gdk_cairo_rectangle", "GdkRectangle*");
  gdk_cairo_rectangle(Xen_to_C_cairo_t_(cr), Xen_to_C_GdkRectangle_(rectangle));
  return(Xen_false);
}

static Xen gxg_gdk_threads_add_idle_full(Xen priority, Xen func, Xen func_info, Xen notify)
{
  #define H_gdk_threads_add_idle_full "guint gdk_threads_add_idle_full(gint priority, GSourceFunc func, \
lambda_data func_info, GDestroyNotify notify)"
  Xen_check_type(Xen_is_gint(priority), priority, 1, "gdk_threads_add_idle_full", "gint");
  Xen_check_type(Xen_is_GSourceFunc(func), func, 2, "gdk_threads_add_idle_full", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gdk_threads_add_idle_full", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 4, "gdk_threads_add_idle_full", "GDestroyNotify");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(gdk_threads_add_idle_full(Xen_to_C_gint(priority), Xen_to_C_GSourceFunc(func), Xen_to_C_lambda_data(func_info), 
                                                      Xen_to_C_GDestroyNotify(notify)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_gdk_threads_add_idle(Xen func, Xen func_info)
{
  #define H_gdk_threads_add_idle "guint gdk_threads_add_idle(GSourceFunc func, lambda_data func_info)"
  Xen_check_type(Xen_is_GSourceFunc(func), func, 1, "gdk_threads_add_idle", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 2, "gdk_threads_add_idle", "lambda_data");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(gdk_threads_add_idle(Xen_to_C_GSourceFunc(func), Xen_to_C_lambda_data(func_info)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_gdk_threads_add_timeout_full(Xen priority, Xen interval, Xen func, Xen func_info, Xen notify)
{
  #define H_gdk_threads_add_timeout_full "guint gdk_threads_add_timeout_full(gint priority, guint interval, \
GSourceFunc func, lambda_data func_info, GDestroyNotify notify)"
  Xen_check_type(Xen_is_gint(priority), priority, 1, "gdk_threads_add_timeout_full", "gint");
  Xen_check_type(Xen_is_guint(interval), interval, 2, "gdk_threads_add_timeout_full", "guint");
  Xen_check_type(Xen_is_GSourceFunc(func), func, 3, "gdk_threads_add_timeout_full", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "gdk_threads_add_timeout_full", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 5, "gdk_threads_add_timeout_full", "GDestroyNotify");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(gdk_threads_add_timeout_full(Xen_to_C_gint(priority), Xen_to_C_guint(interval), Xen_to_C_GSourceFunc(func), 
                                                         Xen_to_C_lambda_data(func_info), Xen_to_C_GDestroyNotify(notify)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_gdk_threads_add_timeout(Xen interval, Xen func, Xen func_info)
{
  #define H_gdk_threads_add_timeout "guint gdk_threads_add_timeout(guint interval, GSourceFunc func, \
lambda_data func_info)"
  Xen_check_type(Xen_is_guint(interval), interval, 1, "gdk_threads_add_timeout", "guint");
  Xen_check_type(Xen_is_GSourceFunc(func), func, 2, "gdk_threads_add_timeout", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gdk_threads_add_timeout", "lambda_data");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(gdk_threads_add_timeout(Xen_to_C_guint(interval), Xen_to_C_GSourceFunc(func), Xen_to_C_lambda_data(func_info)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_gdk_window_set_startup_id(Xen window, Xen startup_id)
{
  #define H_gdk_window_set_startup_id "void gdk_window_set_startup_id(GdkWindow* window, gchar* startup_id)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_startup_id", "GdkWindow*");
  Xen_check_type(Xen_is_gchar_(startup_id), startup_id, 2, "gdk_window_set_startup_id", "gchar*");
  gdk_window_set_startup_id(Xen_to_C_GdkWindow_(window), Xen_to_C_gchar_(startup_id));
  return(Xen_false);
}

static Xen gxg_gdk_window_beep(Xen window)
{
  #define H_gdk_window_beep "void gdk_window_beep(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_beep", "GdkWindow*");
  gdk_window_beep(Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_opacity(Xen window, Xen opacity)
{
  #define H_gdk_window_set_opacity "void gdk_window_set_opacity(GdkWindow* window, gdouble opacity)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_opacity", "GdkWindow*");
  Xen_check_type(Xen_is_gdouble(opacity), opacity, 2, "gdk_window_set_opacity", "gdouble");
  gdk_window_set_opacity(Xen_to_C_GdkWindow_(window), Xen_to_C_gdouble(opacity));
  return(Xen_false);
}

static Xen gxg_gtk_binding_entry_skip(Xen binding_set, Xen keyval, Xen modifiers)
{
  #define H_gtk_binding_entry_skip "void gtk_binding_entry_skip(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers)"
  Xen_check_type(Xen_is_GtkBindingSet_(binding_set), binding_set, 1, "gtk_binding_entry_skip", "GtkBindingSet*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_binding_entry_skip", "guint");
  Xen_check_type(Xen_is_GdkModifierType(modifiers), modifiers, 3, "gtk_binding_entry_skip", "GdkModifierType");
  gtk_binding_entry_skip(Xen_to_C_GtkBindingSet_(binding_set), Xen_to_C_guint(keyval), Xen_to_C_GdkModifierType(modifiers));
  return(Xen_false);
}

static Xen gxg_gtk_cell_layout_get_cells(Xen cell_layout)
{
  #define H_gtk_cell_layout_get_cells "GList* gtk_cell_layout_get_cells(GtkCellLayout* cell_layout)"
  Xen_check_type(Xen_is_GtkCellLayout_(cell_layout), cell_layout, 1, "gtk_cell_layout_get_cells", "GtkCellLayout*");
  return(C_to_Xen_GList_(gtk_cell_layout_get_cells(Xen_to_C_GtkCellLayout_(cell_layout))));
}

static Xen gxg_gtk_entry_completion_set_inline_selection(Xen completion, Xen inline_selection)
{
  #define H_gtk_entry_completion_set_inline_selection "void gtk_entry_completion_set_inline_selection(GtkEntryCompletion* completion, \
gboolean inline_selection)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_set_inline_selection", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_gboolean(inline_selection), inline_selection, 2, "gtk_entry_completion_set_inline_selection", "gboolean");
  gtk_entry_completion_set_inline_selection(Xen_to_C_GtkEntryCompletion_(completion), Xen_to_C_gboolean(inline_selection));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_get_inline_selection(Xen completion)
{
  #define H_gtk_entry_completion_get_inline_selection "gboolean gtk_entry_completion_get_inline_selection(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_inline_selection", "GtkEntryCompletion*");
  return(C_to_Xen_gboolean(gtk_entry_completion_get_inline_selection(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_completion_get_completion_prefix(Xen completion)
{
  #define H_gtk_entry_completion_get_completion_prefix "gchar* gtk_entry_completion_get_completion_prefix(GtkEntryCompletion* completion)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_get_completion_prefix", "GtkEntryCompletion*");
  return(C_to_Xen_gchar_(gtk_entry_completion_get_completion_prefix(Xen_to_C_GtkEntryCompletion_(completion))));
}

static Xen gxg_gtk_entry_set_cursor_hadjustment(Xen entry, Xen adjustment)
{
  #define H_gtk_entry_set_cursor_hadjustment "void gtk_entry_set_cursor_hadjustment(GtkEntry* entry, \
GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_cursor_hadjustment", "GtkEntry*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_entry_set_cursor_hadjustment", "GtkAdjustment*");
  gtk_entry_set_cursor_hadjustment(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_cursor_hadjustment(Xen entry)
{
  #define H_gtk_entry_get_cursor_hadjustment "GtkAdjustment* gtk_entry_get_cursor_hadjustment(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_cursor_hadjustment", "GtkEntry*");
  return(C_to_Xen_GtkAdjustment_(gtk_entry_get_cursor_hadjustment(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_icon_theme_list_contexts(Xen icon_theme)
{
  #define H_gtk_icon_theme_list_contexts "GList* gtk_icon_theme_list_contexts(GtkIconTheme* icon_theme)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_list_contexts", "GtkIconTheme*");
  return(C_to_Xen_GList_(gtk_icon_theme_list_contexts(Xen_to_C_GtkIconTheme_(icon_theme))));
}

static Xen gxg_gtk_print_settings_new_from_file(Xen file_name, Xen ignore_error)
{
  #define H_gtk_print_settings_new_from_file "GtkPrintSettings* gtk_print_settings_new_from_file(gchar* file_name, \
GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_gchar_(file_name), file_name, 1, "gtk_print_settings_new_from_file", "gchar*");
  {
    Xen result;
    result = C_to_Xen_GtkPrintSettings_(gtk_print_settings_new_from_file(Xen_to_C_gchar_(file_name), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_print_settings_to_file(Xen settings, Xen file_name, Xen ignore_error)
{
  #define H_gtk_print_settings_to_file "gboolean gtk_print_settings_to_file(GtkPrintSettings* settings, \
gchar* file_name, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkPrintSettings_(settings), settings, 1, "gtk_print_settings_to_file", "GtkPrintSettings*");
  Xen_check_type(Xen_is_gchar_(file_name), file_name, 2, "gtk_print_settings_to_file", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_print_settings_to_file(Xen_to_C_GtkPrintSettings_(settings), Xen_to_C_gchar_(file_name), 
                                                          &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_range_set_show_fill_level(Xen range, Xen show_fill_level)
{
  #define H_gtk_range_set_show_fill_level "void gtk_range_set_show_fill_level(GtkRange* range,  gboolean, \
show_fill_level)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_show_fill_level", "GtkRange*");
  Xen_check_type(Xen_is_gboolean(show_fill_level), show_fill_level, 2, "gtk_range_set_show_fill_level", "gboolean");
  gtk_range_set_show_fill_level(Xen_to_C_GtkRange_(range), Xen_to_C_gboolean(show_fill_level));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_show_fill_level(Xen range)
{
  #define H_gtk_range_get_show_fill_level "gboolean gtk_range_get_show_fill_level(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_show_fill_level", "GtkRange*");
  return(C_to_Xen_gboolean(gtk_range_get_show_fill_level(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_range_set_restrict_to_fill_level(Xen range, Xen restrict_to_fill_level)
{
  #define H_gtk_range_set_restrict_to_fill_level "void gtk_range_set_restrict_to_fill_level(GtkRange* range, \
 gboolean, restrict_to_fill_level)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_restrict_to_fill_level", "GtkRange*");
  Xen_check_type(Xen_is_gboolean(restrict_to_fill_level), restrict_to_fill_level, 2, "gtk_range_set_restrict_to_fill_level", "gboolean");
  gtk_range_set_restrict_to_fill_level(Xen_to_C_GtkRange_(range), Xen_to_C_gboolean(restrict_to_fill_level));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_restrict_to_fill_level(Xen range)
{
  #define H_gtk_range_get_restrict_to_fill_level "gboolean gtk_range_get_restrict_to_fill_level(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_restrict_to_fill_level", "GtkRange*");
  return(C_to_Xen_gboolean(gtk_range_get_restrict_to_fill_level(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_range_set_fill_level(Xen range, Xen fill_level)
{
  #define H_gtk_range_set_fill_level "void gtk_range_set_fill_level(GtkRange* range,  gdouble, fill_level)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_fill_level", "GtkRange*");
  Xen_check_type(Xen_is_gdouble(fill_level), fill_level, 2, "gtk_range_set_fill_level", "gdouble");
  gtk_range_set_fill_level(Xen_to_C_GtkRange_(range), Xen_to_C_gdouble(fill_level));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_fill_level(Xen range)
{
  #define H_gtk_range_get_fill_level "gdouble gtk_range_get_fill_level(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_fill_level", "GtkRange*");
  return(C_to_Xen_gdouble(gtk_range_get_fill_level(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_tree_view_set_show_expanders(Xen tree_view, Xen enabled)
{
  #define H_gtk_tree_view_set_show_expanders "void gtk_tree_view_set_show_expanders(GtkTreeView* tree_view, \
gboolean enabled)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_show_expanders", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(enabled), enabled, 2, "gtk_tree_view_set_show_expanders", "gboolean");
  gtk_tree_view_set_show_expanders(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(enabled));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_show_expanders(Xen tree_view)
{
  #define H_gtk_tree_view_get_show_expanders "gboolean gtk_tree_view_get_show_expanders(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_show_expanders", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_show_expanders(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_level_indentation(Xen tree_view, Xen indentation)
{
  #define H_gtk_tree_view_set_level_indentation "void gtk_tree_view_set_level_indentation(GtkTreeView* tree_view, \
gint indentation)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_level_indentation", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(indentation), indentation, 2, "gtk_tree_view_set_level_indentation", "gint");
  gtk_tree_view_set_level_indentation(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(indentation));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_level_indentation(Xen tree_view)
{
  #define H_gtk_tree_view_get_level_indentation "gint gtk_tree_view_get_level_indentation(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_level_indentation", "GtkTreeView*");
  return(C_to_Xen_gint(gtk_tree_view_get_level_indentation(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_widget_keynav_failed(Xen widget, Xen direction)
{
  #define H_gtk_widget_keynav_failed "gboolean gtk_widget_keynav_failed(GtkWidget* widget, GtkDirectionType direction)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_keynav_failed", "GtkWidget*");
  Xen_check_type(Xen_is_GtkDirectionType(direction), direction, 2, "gtk_widget_keynav_failed", "GtkDirectionType");
  return(C_to_Xen_gboolean(gtk_widget_keynav_failed(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkDirectionType(direction))));
}

static Xen gxg_gtk_widget_error_bell(Xen widget)
{
  #define H_gtk_widget_error_bell "void gtk_widget_error_bell(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_error_bell", "GtkWidget*");
  gtk_widget_error_bell(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_tooltip_window(Xen widget, Xen custom_window)
{
  #define H_gtk_widget_set_tooltip_window "void gtk_widget_set_tooltip_window(GtkWidget* widget, GtkWindow* custom_window)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_tooltip_window", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWindow_(custom_window), custom_window, 2, "gtk_widget_set_tooltip_window", "GtkWindow*");
  gtk_widget_set_tooltip_window(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWindow_(custom_window));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_tooltip_window(Xen widget)
{
  #define H_gtk_widget_get_tooltip_window "GtkWindow* gtk_widget_get_tooltip_window(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_tooltip_window", "GtkWidget*");
  return(C_to_Xen_GtkWindow_(gtk_widget_get_tooltip_window(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_trigger_tooltip_query(Xen widget)
{
  #define H_gtk_widget_trigger_tooltip_query "void gtk_widget_trigger_tooltip_query(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_trigger_tooltip_query", "GtkWidget*");
  gtk_widget_trigger_tooltip_query(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_startup_id(Xen window, Xen startup_id)
{
  #define H_gtk_window_set_startup_id "void gtk_window_set_startup_id(GtkWindow* window, gchar* startup_id)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_startup_id", "GtkWindow*");
  Xen_check_type(Xen_is_gchar_(startup_id), startup_id, 2, "gtk_window_set_startup_id", "gchar*");
  gtk_window_set_startup_id(Xen_to_C_GtkWindow_(window), Xen_to_C_gchar_(startup_id));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_add_mark(Xen buffer, Xen mark, Xen where)
{
  #define H_gtk_text_buffer_add_mark "void gtk_text_buffer_add_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_add_mark", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextMark_(mark), mark, 2, "gtk_text_buffer_add_mark", "GtkTextMark*");
  Xen_check_type(Xen_is_GtkTextIter_(where), where, 3, "gtk_text_buffer_add_mark", "GtkTextIter*");
  gtk_text_buffer_add_mark(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextMark_(mark), Xen_to_C_GtkTextIter_(where));
  return(Xen_false);
}

static Xen gxg_gtk_text_mark_new(Xen name, Xen left_gravity)
{
  #define H_gtk_text_mark_new "GtkTextMark* gtk_text_mark_new(gchar* name, gboolean left_gravity)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "gtk_text_mark_new", "gchar*");
  Xen_check_type(Xen_is_gboolean(left_gravity), left_gravity, 2, "gtk_text_mark_new", "gboolean");
  return(C_to_Xen_GtkTextMark_(gtk_text_mark_new(Xen_to_C_gchar_(name), Xen_to_C_gboolean(left_gravity))));
}

static Xen gxg_gtk_tree_view_column_get_tree_view(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_tree_view "GtkWidget* gtk_tree_view_column_get_tree_view(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_tree_view", "GtkTreeViewColumn*");
  return(C_to_Xen_GtkWidget_(gtk_tree_view_column_get_tree_view(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tooltip_set_text(Xen tooltip, Xen text)
{
  #define H_gtk_tooltip_set_text "void gtk_tooltip_set_text(GtkTooltip* tooltip, gchar* text)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_text", "GtkTooltip*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_tooltip_set_text", "gchar*");
  gtk_tooltip_set_text(Xen_to_C_GtkTooltip_(tooltip), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_convert_widget_to_tree_coords(Xen tree_view, Xen wx, Xen wy, Xen ignore_tx, Xen ignore_ty)
{
  #define H_gtk_tree_view_convert_widget_to_tree_coords "void gtk_tree_view_convert_widget_to_tree_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [tx], gint* [ty])"
  gint ref_tx;
  gint ref_ty;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_convert_widget_to_tree_coords", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(wx), wx, 2, "gtk_tree_view_convert_widget_to_tree_coords", "gint");
  Xen_check_type(Xen_is_gint(wy), wy, 3, "gtk_tree_view_convert_widget_to_tree_coords", "gint");
  gtk_tree_view_convert_widget_to_tree_coords(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(wx), Xen_to_C_gint(wy), &ref_tx, 
                                              &ref_ty);
  return(Xen_list_2(C_to_Xen_gint(ref_tx), C_to_Xen_gint(ref_ty)));
}

static Xen gxg_gtk_tree_view_convert_tree_to_widget_coords(Xen tree_view, Xen tx, Xen ty, Xen ignore_wx, Xen ignore_wy)
{
  #define H_gtk_tree_view_convert_tree_to_widget_coords "void gtk_tree_view_convert_tree_to_widget_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [wx], gint* [wy])"
  gint ref_wx;
  gint ref_wy;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_convert_tree_to_widget_coords", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(tx), tx, 2, "gtk_tree_view_convert_tree_to_widget_coords", "gint");
  Xen_check_type(Xen_is_gint(ty), ty, 3, "gtk_tree_view_convert_tree_to_widget_coords", "gint");
  gtk_tree_view_convert_tree_to_widget_coords(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(tx), Xen_to_C_gint(ty), &ref_wx, 
                                              &ref_wy);
  return(Xen_list_2(C_to_Xen_gint(ref_wx), C_to_Xen_gint(ref_wy)));
}

static Xen gxg_gtk_tree_view_convert_widget_to_bin_window_coords(Xen tree_view, Xen wx, Xen wy, Xen ignore_bx, Xen ignore_by)
{
  #define H_gtk_tree_view_convert_widget_to_bin_window_coords "void gtk_tree_view_convert_widget_to_bin_window_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [bx], gint* [by])"
  gint ref_bx;
  gint ref_by;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_convert_widget_to_bin_window_coords", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(wx), wx, 2, "gtk_tree_view_convert_widget_to_bin_window_coords", "gint");
  Xen_check_type(Xen_is_gint(wy), wy, 3, "gtk_tree_view_convert_widget_to_bin_window_coords", "gint");
  gtk_tree_view_convert_widget_to_bin_window_coords(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(wx), Xen_to_C_gint(wy), 
                                                    &ref_bx, &ref_by);
  return(Xen_list_2(C_to_Xen_gint(ref_bx), C_to_Xen_gint(ref_by)));
}

static Xen gxg_gtk_tree_view_convert_bin_window_to_widget_coords(Xen tree_view, Xen bx, Xen by, Xen ignore_wx, Xen ignore_wy)
{
  #define H_gtk_tree_view_convert_bin_window_to_widget_coords "void gtk_tree_view_convert_bin_window_to_widget_coords(GtkTreeView* tree_view, \
gint bx, gint by, gint* [wx], gint* [wy])"
  gint ref_wx;
  gint ref_wy;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_convert_bin_window_to_widget_coords", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(bx), bx, 2, "gtk_tree_view_convert_bin_window_to_widget_coords", "gint");
  Xen_check_type(Xen_is_gint(by), by, 3, "gtk_tree_view_convert_bin_window_to_widget_coords", "gint");
  gtk_tree_view_convert_bin_window_to_widget_coords(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(bx), Xen_to_C_gint(by), 
                                                    &ref_wx, &ref_wy);
  return(Xen_list_2(C_to_Xen_gint(ref_wx), C_to_Xen_gint(ref_wy)));
}

static Xen gxg_gtk_tree_view_convert_tree_to_bin_window_coords(Xen tree_view, Xen tx, Xen ty, Xen ignore_bx, Xen ignore_by)
{
  #define H_gtk_tree_view_convert_tree_to_bin_window_coords "void gtk_tree_view_convert_tree_to_bin_window_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [bx], gint* [by])"
  gint ref_bx;
  gint ref_by;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_convert_tree_to_bin_window_coords", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(tx), tx, 2, "gtk_tree_view_convert_tree_to_bin_window_coords", "gint");
  Xen_check_type(Xen_is_gint(ty), ty, 3, "gtk_tree_view_convert_tree_to_bin_window_coords", "gint");
  gtk_tree_view_convert_tree_to_bin_window_coords(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(tx), Xen_to_C_gint(ty), 
                                                  &ref_bx, &ref_by);
  return(Xen_list_2(C_to_Xen_gint(ref_bx), C_to_Xen_gint(ref_by)));
}

static Xen gxg_gtk_tree_view_convert_bin_window_to_tree_coords(Xen tree_view, Xen bx, Xen by, Xen ignore_tx, Xen ignore_ty)
{
  #define H_gtk_tree_view_convert_bin_window_to_tree_coords "void gtk_tree_view_convert_bin_window_to_tree_coords(GtkTreeView* tree_view, \
gint bx, gint by, gint* [tx], gint* [ty])"
  gint ref_tx;
  gint ref_ty;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_convert_bin_window_to_tree_coords", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(bx), bx, 2, "gtk_tree_view_convert_bin_window_to_tree_coords", "gint");
  Xen_check_type(Xen_is_gint(by), by, 3, "gtk_tree_view_convert_bin_window_to_tree_coords", "gint");
  gtk_tree_view_convert_bin_window_to_tree_coords(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(bx), Xen_to_C_gint(by), 
                                                  &ref_tx, &ref_ty);
  return(Xen_list_2(C_to_Xen_gint(ref_tx), C_to_Xen_gint(ref_ty)));
}

static Xen gxg_gtk_widget_set_tooltip_text(Xen widget, Xen text)
{
  #define H_gtk_widget_set_tooltip_text "void gtk_widget_set_tooltip_text(GtkWidget* widget, gchar* text)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_tooltip_text", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_widget_set_tooltip_text", "gchar*");
  gtk_widget_set_tooltip_text(Xen_to_C_GtkWidget_(widget), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_tooltip_text(Xen widget)
{
  #define H_gtk_widget_get_tooltip_text "gchar* gtk_widget_get_tooltip_text(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_tooltip_text", "GtkWidget*");
  return(C_to_Xen_gchar_(gtk_widget_get_tooltip_text(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_tooltip_markup(Xen widget, Xen markup)
{
  #define H_gtk_widget_set_tooltip_markup "void gtk_widget_set_tooltip_markup(GtkWidget* widget, gchar* markup)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_tooltip_markup", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(markup), markup, 2, "gtk_widget_set_tooltip_markup", "gchar*");
  gtk_widget_set_tooltip_markup(Xen_to_C_GtkWidget_(widget), (const gchar*)Xen_to_C_gchar_(markup));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_tooltip_markup(Xen widget)
{
  #define H_gtk_widget_get_tooltip_markup "gchar* gtk_widget_get_tooltip_markup(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_tooltip_markup", "GtkWidget*");
  return(C_to_Xen_gchar_(gtk_widget_get_tooltip_markup(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_tree_view_is_rubber_banding_active(Xen tree_view)
{
  #define H_gtk_tree_view_is_rubber_banding_active "gboolean gtk_tree_view_is_rubber_banding_active(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_is_rubber_banding_active", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_is_rubber_banding_active(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_icon_view_set_tooltip_item(Xen icon_view, Xen tooltip, Xen path)
{
  #define H_gtk_icon_view_set_tooltip_item "void gtk_icon_view_set_tooltip_item(GtkIconView* icon_view, \
GtkTooltip* tooltip, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_tooltip_item", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 2, "gtk_icon_view_set_tooltip_item", "GtkTooltip*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_icon_view_set_tooltip_item", "GtkTreePath*");
  gtk_icon_view_set_tooltip_item(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_set_tooltip_cell(Xen icon_view, Xen tooltip, Xen path, Xen cell)
{
  #define H_gtk_icon_view_set_tooltip_cell "void gtk_icon_view_set_tooltip_cell(GtkIconView* icon_view, \
GtkTooltip* tooltip, GtkTreePath* path, GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_tooltip_cell", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 2, "gtk_icon_view_set_tooltip_cell", "GtkTooltip*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_icon_view_set_tooltip_cell", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 4, "gtk_icon_view_set_tooltip_cell", "GtkCellRenderer*");
  gtk_icon_view_set_tooltip_cell(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GtkTreePath_(path), 
                                 Xen_to_C_GtkCellRenderer_(cell));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_tooltip_context(Xen icon_view, Xen ignore_x, Xen ignore_y, Xen keyboard_tip, Xen ignore_model, Xen ignore_path, Xen iter)
{
  #define H_gtk_icon_view_get_tooltip_context "gboolean gtk_icon_view_get_tooltip_context(GtkIconView* icon_view, \
gint* [x], gint* [y], gboolean keyboard_tip, GtkTreeModel** [model], GtkTreePath** [path], GtkTreeIter* iter)"
  gint ref_x;
  gint ref_y;
  GtkTreeModel* ref_model = NULL;
  GtkTreePath* ref_path = NULL;
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_tooltip_context", "GtkIconView*");
  Xen_check_type(Xen_is_gboolean(keyboard_tip), keyboard_tip, 4, "gtk_icon_view_get_tooltip_context", "gboolean");
  Xen_check_type(Xen_is_GtkTreeIter_(iter) || Xen_is_false(iter), iter, 7, "gtk_icon_view_get_tooltip_context", "GtkTreeIter*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_icon_view_get_tooltip_context(Xen_to_C_GtkIconView_(icon_view), &ref_x, &ref_y, Xen_to_C_gboolean(keyboard_tip), 
                                                                 &ref_model, &ref_path, Xen_to_C_GtkTreeIter_(iter)));
    return(Xen_list_5(result, C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y), C_to_Xen_GtkTreeModel_(ref_model), C_to_Xen_GtkTreePath_(ref_path)));
   }
}

static Xen gxg_gtk_icon_view_set_tooltip_column(Xen icon_view, Xen column)
{
  #define H_gtk_icon_view_set_tooltip_column "void gtk_icon_view_set_tooltip_column(GtkIconView* icon_view, \
gint column)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_tooltip_column", "GtkIconView*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_icon_view_set_tooltip_column", "gint");
  gtk_icon_view_set_tooltip_column(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_tooltip_column(Xen icon_view )
{
  #define H_gtk_icon_view_get_tooltip_column "gint gtk_icon_view_get_tooltip_column(GtkIconView* icon_view, \
)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view ), icon_view , 1, "gtk_icon_view_get_tooltip_column", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_tooltip_column(Xen_to_C_GtkIconView_(icon_view ))));
}

static Xen gxg_gtk_menu_tool_button_set_arrow_tooltip_text(Xen button, Xen text)
{
  #define H_gtk_menu_tool_button_set_arrow_tooltip_text "void gtk_menu_tool_button_set_arrow_tooltip_text(GtkMenuToolButton* button, \
gchar* text)"
  Xen_check_type(Xen_is_GtkMenuToolButton_(button), button, 1, "gtk_menu_tool_button_set_arrow_tooltip_text", "GtkMenuToolButton*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_menu_tool_button_set_arrow_tooltip_text", "gchar*");
  gtk_menu_tool_button_set_arrow_tooltip_text(Xen_to_C_GtkMenuToolButton_(button), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_menu_tool_button_set_arrow_tooltip_markup(Xen button, Xen markup)
{
  #define H_gtk_menu_tool_button_set_arrow_tooltip_markup "void gtk_menu_tool_button_set_arrow_tooltip_markup(GtkMenuToolButton* button, \
gchar* markup)"
  Xen_check_type(Xen_is_GtkMenuToolButton_(button), button, 1, "gtk_menu_tool_button_set_arrow_tooltip_markup", "GtkMenuToolButton*");
  Xen_check_type(Xen_is_gchar_(markup), markup, 2, "gtk_menu_tool_button_set_arrow_tooltip_markup", "gchar*");
  gtk_menu_tool_button_set_arrow_tooltip_markup(Xen_to_C_GtkMenuToolButton_(button), (const gchar*)Xen_to_C_gchar_(markup));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_set_tooltip_text(Xen tool_item, Xen text)
{
  #define H_gtk_tool_item_set_tooltip_text "void gtk_tool_item_set_tooltip_text(GtkToolItem* tool_item, \
gchar* text)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_set_tooltip_text", "GtkToolItem*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_tool_item_set_tooltip_text", "gchar*");
  gtk_tool_item_set_tooltip_text(Xen_to_C_GtkToolItem_(tool_item), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_set_tooltip_markup(Xen tool_item, Xen markup)
{
  #define H_gtk_tool_item_set_tooltip_markup "void gtk_tool_item_set_tooltip_markup(GtkToolItem* tool_item, \
gchar* markup)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_set_tooltip_markup", "GtkToolItem*");
  Xen_check_type(Xen_is_gchar_(markup), markup, 2, "gtk_tool_item_set_tooltip_markup", "gchar*");
  gtk_tool_item_set_tooltip_markup(Xen_to_C_GtkToolItem_(tool_item), (const gchar*)Xen_to_C_gchar_(markup));
  return(Xen_false);
}

static Xen gxg_gtk_tooltip_set_tip_area(Xen tooltip, Xen rect)
{
  #define H_gtk_tooltip_set_tip_area "void gtk_tooltip_set_tip_area(GtkTooltip* tooltip, GdkRectangle* rect)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_tip_area", "GtkTooltip*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gtk_tooltip_set_tip_area", "GdkRectangle*");
  gtk_tooltip_set_tip_area(Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GdkRectangle_(rect));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_set_tooltip_row(Xen tree_view, Xen tooltip, Xen path)
{
  #define H_gtk_tree_view_set_tooltip_row "void gtk_tree_view_set_tooltip_row(GtkTreeView* tree_view, \
GtkTooltip* tooltip, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_tooltip_row", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 2, "gtk_tree_view_set_tooltip_row", "GtkTooltip*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_tree_view_set_tooltip_row", "GtkTreePath*");
  gtk_tree_view_set_tooltip_row(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GtkTreePath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_set_tooltip_cell(Xen tree_view, Xen tooltip, Xen path, Xen column, Xen cell)
{
  #define H_gtk_tree_view_set_tooltip_cell "void gtk_tree_view_set_tooltip_cell(GtkTreeView* tree_view, \
GtkTooltip* tooltip, GtkTreePath* path, GtkTreeViewColumn* column, GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_tooltip_cell", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 2, "gtk_tree_view_set_tooltip_cell", "GtkTooltip*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 3, "gtk_tree_view_set_tooltip_cell", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(column), column, 4, "gtk_tree_view_set_tooltip_cell", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 5, "gtk_tree_view_set_tooltip_cell", "GtkCellRenderer*");
  gtk_tree_view_set_tooltip_cell(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GtkTreePath_(path), 
                                 Xen_to_C_GtkTreeViewColumn_(column), Xen_to_C_GtkCellRenderer_(cell));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_tooltip_context(Xen tree_view, Xen ignore_x, Xen ignore_y, Xen keyboard_tip, Xen ignore_model, Xen ignore_path, Xen iter)
{
  #define H_gtk_tree_view_get_tooltip_context "gboolean gtk_tree_view_get_tooltip_context(GtkTreeView* tree_view, \
gint* [x], gint* [y], gboolean keyboard_tip, GtkTreeModel** [model], GtkTreePath** [path], GtkTreeIter* iter)"
  gint ref_x;
  gint ref_y;
  GtkTreeModel* ref_model = NULL;
  GtkTreePath* ref_path = NULL;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_tooltip_context", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(keyboard_tip), keyboard_tip, 4, "gtk_tree_view_get_tooltip_context", "gboolean");
  Xen_check_type(Xen_is_GtkTreeIter_(iter) || Xen_is_false(iter), iter, 7, "gtk_tree_view_get_tooltip_context", "GtkTreeIter*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_view_get_tooltip_context(Xen_to_C_GtkTreeView_(tree_view), &ref_x, &ref_y, Xen_to_C_gboolean(keyboard_tip), 
                                                                 &ref_model, &ref_path, Xen_to_C_GtkTreeIter_(iter)));
    return(Xen_list_5(result, C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y), C_to_Xen_GtkTreeModel_(ref_model), C_to_Xen_GtkTreePath_(ref_path)));
   }
}

static Xen gxg_gtk_tree_view_set_tooltip_column(Xen tree_view, Xen column)
{
  #define H_gtk_tree_view_set_tooltip_column "void gtk_tree_view_set_tooltip_column(GtkTreeView* tree_view, \
gint column)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_tooltip_column", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(column), column, 2, "gtk_tree_view_set_tooltip_column", "gint");
  gtk_tree_view_set_tooltip_column(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(column));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_tooltip_column(Xen tree_view )
{
  #define H_gtk_tree_view_get_tooltip_column "gint gtk_tree_view_get_tooltip_column(GtkTreeView* tree_view, \
)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view ), tree_view , 1, "gtk_tree_view_get_tooltip_column", "GtkTreeView*");
  return(C_to_Xen_gint(gtk_tree_view_get_tooltip_column(Xen_to_C_GtkTreeView_(tree_view ))));
}

static Xen gxg_gtk_widget_set_has_tooltip(Xen widget, Xen has_tooltip)
{
  #define H_gtk_widget_set_has_tooltip "void gtk_widget_set_has_tooltip(GtkWidget* widget, gboolean has_tooltip)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_has_tooltip", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(has_tooltip), has_tooltip, 2, "gtk_widget_set_has_tooltip", "gboolean");
  gtk_widget_set_has_tooltip(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(has_tooltip));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_has_tooltip(Xen widget)
{
  #define H_gtk_widget_get_has_tooltip "gboolean gtk_widget_get_has_tooltip(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_has_tooltip", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_has_tooltip(Xen_to_C_GtkWidget_(widget))));
}

#if GTK_CHECK_VERSION(2, 14, 0)
static Xen gxg_gtk_calendar_set_detail_func(Xen calendar, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_calendar_set_detail_func "void gtk_calendar_set_detail_func(GtkCalendar* calendar, GtkCalendarDetailFunc func, \
lambda_data func_info, GDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_set_detail_func", "GtkCalendar*");
  Xen_check_type(Xen_is_GtkCalendarDetailFunc(func), func, 2, "gtk_calendar_set_detail_func", "GtkCalendarDetailFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_calendar_set_detail_func", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(destroy), destroy, 4, "gtk_calendar_set_detail_func", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gtk_calendar_set_detail_func(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_GtkCalendarDetailFunc(func), Xen_to_C_lambda_data(func_info), 
                             Xen_to_C_GDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gtk_calendar_set_detail_width_chars(Xen calendar, Xen chars)
{
  #define H_gtk_calendar_set_detail_width_chars "void gtk_calendar_set_detail_width_chars(GtkCalendar* calendar, \
gint chars)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_set_detail_width_chars", "GtkCalendar*");
  Xen_check_type(Xen_is_gint(chars), chars, 2, "gtk_calendar_set_detail_width_chars", "gint");
  gtk_calendar_set_detail_width_chars(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_gint(chars));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_set_detail_height_rows(Xen calendar, Xen rows)
{
  #define H_gtk_calendar_set_detail_height_rows "void gtk_calendar_set_detail_height_rows(GtkCalendar* calendar, \
gint rows)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_set_detail_height_rows", "GtkCalendar*");
  Xen_check_type(Xen_is_gint(rows), rows, 2, "gtk_calendar_set_detail_height_rows", "gint");
  gtk_calendar_set_detail_height_rows(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_gint(rows));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_get_detail_width_chars(Xen calendar)
{
  #define H_gtk_calendar_get_detail_width_chars "gint gtk_calendar_get_detail_width_chars(GtkCalendar* calendar)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_get_detail_width_chars", "GtkCalendar*");
  return(C_to_Xen_gint(gtk_calendar_get_detail_width_chars(Xen_to_C_GtkCalendar_(calendar))));
}

static Xen gxg_gtk_calendar_get_detail_height_rows(Xen calendar)
{
  #define H_gtk_calendar_get_detail_height_rows "gint gtk_calendar_get_detail_height_rows(GtkCalendar* calendar)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_get_detail_height_rows", "GtkCalendar*");
  return(C_to_Xen_gint(gtk_calendar_get_detail_height_rows(Xen_to_C_GtkCalendar_(calendar))));
}

static Xen gxg_gtk_accel_group_get_is_locked(Xen accel_group)
{
  #define H_gtk_accel_group_get_is_locked "gboolean gtk_accel_group_get_is_locked(GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_get_is_locked", "GtkAccelGroup*");
  return(C_to_Xen_gboolean(gtk_accel_group_get_is_locked(Xen_to_C_GtkAccelGroup_(accel_group))));
}

static Xen gxg_gtk_dialog_get_content_area(Xen dialog)
{
  #define H_gtk_dialog_get_content_area "GtkWidget* gtk_dialog_get_content_area(GtkDialog* dialog)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_get_content_area", "GtkDialog*");
  return(C_to_Xen_GtkWidget_(gtk_dialog_get_content_area(Xen_to_C_GtkDialog_(dialog))));
}

static Xen gxg_gtk_entry_set_overwrite_mode(Xen entry, Xen overwrite)
{
  #define H_gtk_entry_set_overwrite_mode "void gtk_entry_set_overwrite_mode(GtkEntry* entry, gboolean overwrite)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_overwrite_mode", "GtkEntry*");
  Xen_check_type(Xen_is_gboolean(overwrite), overwrite, 2, "gtk_entry_set_overwrite_mode", "gboolean");
  gtk_entry_set_overwrite_mode(Xen_to_C_GtkEntry_(entry), Xen_to_C_gboolean(overwrite));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_overwrite_mode(Xen entry)
{
  #define H_gtk_entry_get_overwrite_mode "gboolean gtk_entry_get_overwrite_mode(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_overwrite_mode", "GtkEntry*");
  return(C_to_Xen_gboolean(gtk_entry_get_overwrite_mode(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_get_text_length(Xen entry)
{
  #define H_gtk_entry_get_text_length "guint16 gtk_entry_get_text_length(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_text_length", "GtkEntry*");
  return(C_to_Xen_guint16(gtk_entry_get_text_length(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_menu_get_accel_path(Xen menu)
{
  #define H_gtk_menu_get_accel_path "gchar* gtk_menu_get_accel_path(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_get_accel_path", "GtkMenu*");
  return(C_to_Xen_gchar_(gtk_menu_get_accel_path(Xen_to_C_GtkMenu_(menu))));
}

static Xen gxg_gtk_menu_get_monitor(Xen menu)
{
  #define H_gtk_menu_get_monitor "gint gtk_menu_get_monitor(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_get_monitor", "GtkMenu*");
  return(C_to_Xen_gint(gtk_menu_get_monitor(Xen_to_C_GtkMenu_(menu))));
}

static Xen gxg_gtk_menu_item_get_accel_path(Xen menu_item)
{
  #define H_gtk_menu_item_get_accel_path "gchar* gtk_menu_item_get_accel_path(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_get_accel_path", "GtkMenuItem*");
  return(C_to_Xen_gchar_(gtk_menu_item_get_accel_path(Xen_to_C_GtkMenuItem_(menu_item))));
}

static Xen gxg_gtk_scale_button_get_plus_button(Xen button)
{
  #define H_gtk_scale_button_get_plus_button "GtkWidget* gtk_scale_button_get_plus_button(GtkScaleButton* button)"
  Xen_check_type(Xen_is_GtkScaleButton_(button), button, 1, "gtk_scale_button_get_plus_button", "GtkScaleButton*");
  return(C_to_Xen_GtkWidget_(gtk_scale_button_get_plus_button(Xen_to_C_GtkScaleButton_(button))));
}

static Xen gxg_gtk_scale_button_get_minus_button(Xen button)
{
  #define H_gtk_scale_button_get_minus_button "GtkWidget* gtk_scale_button_get_minus_button(GtkScaleButton* button)"
  Xen_check_type(Xen_is_GtkScaleButton_(button), button, 1, "gtk_scale_button_get_minus_button", "GtkScaleButton*");
  return(C_to_Xen_GtkWidget_(gtk_scale_button_get_minus_button(Xen_to_C_GtkScaleButton_(button))));
}

static Xen gxg_gtk_scale_button_get_popup(Xen button)
{
  #define H_gtk_scale_button_get_popup "GtkWidget* gtk_scale_button_get_popup(GtkScaleButton* button)"
  Xen_check_type(Xen_is_GtkScaleButton_(button), button, 1, "gtk_scale_button_get_popup", "GtkScaleButton*");
  return(C_to_Xen_GtkWidget_(gtk_scale_button_get_popup(Xen_to_C_GtkScaleButton_(button))));
}

static Xen gxg_gtk_selection_data_get_target(Xen selection_data)
{
  #define H_gtk_selection_data_get_target "GdkAtom gtk_selection_data_get_target(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_target", "GtkSelectionData*");
  return(C_to_Xen_GdkAtom(gtk_selection_data_get_target(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_get_data_type(Xen selection_data)
{
  #define H_gtk_selection_data_get_data_type "GdkAtom gtk_selection_data_get_data_type(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_data_type", "GtkSelectionData*");
  return(C_to_Xen_GdkAtom(gtk_selection_data_get_data_type(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_get_format(Xen selection_data)
{
  #define H_gtk_selection_data_get_format "gint gtk_selection_data_get_format(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_format", "GtkSelectionData*");
  return(C_to_Xen_gint(gtk_selection_data_get_format(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_get_display(Xen selection_data)
{
  #define H_gtk_selection_data_get_display "GdkDisplay* gtk_selection_data_get_display(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_display", "GtkSelectionData*");
  return(C_to_Xen_GdkDisplay_(gtk_selection_data_get_display(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_widget_get_window(Xen widget)
{
  #define H_gtk_widget_get_window "GdkWindow* gtk_widget_get_window(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_window", "GtkWidget*");
  return(C_to_Xen_GdkWindow_(gtk_widget_get_window(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_accel_group_get_modifier_mask(Xen accel_group)
{
  #define H_gtk_accel_group_get_modifier_mask "GdkModifierType gtk_accel_group_get_modifier_mask(GtkAccelGroup* accel_group)"
  Xen_check_type(Xen_is_GtkAccelGroup_(accel_group), accel_group, 1, "gtk_accel_group_get_modifier_mask", "GtkAccelGroup*");
  return(C_to_Xen_GdkModifierType(gtk_accel_group_get_modifier_mask(Xen_to_C_GtkAccelGroup_(accel_group))));
}

static Xen gxg_gdk_threads_add_timeout_seconds_full(Xen priority, Xen interval, Xen function, Xen func_info, Xen notify)
{
  #define H_gdk_threads_add_timeout_seconds_full "guint gdk_threads_add_timeout_seconds_full(gint priority, \
guint interval, GSourceFunc function, lambda_data func_info, GDestroyNotify notify)"
  Xen_check_type(Xen_is_gint(priority), priority, 1, "gdk_threads_add_timeout_seconds_full", "gint");
  Xen_check_type(Xen_is_guint(interval), interval, 2, "gdk_threads_add_timeout_seconds_full", "guint");
  Xen_check_type(Xen_is_GSourceFunc(function), function, 3, "gdk_threads_add_timeout_seconds_full", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 4, "gdk_threads_add_timeout_seconds_full", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 5, "gdk_threads_add_timeout_seconds_full", "GDestroyNotify");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(gdk_threads_add_timeout_seconds_full(Xen_to_C_gint(priority), Xen_to_C_guint(interval), Xen_to_C_GSourceFunc(function), 
                                                                 Xen_to_C_lambda_data(func_info), Xen_to_C_GDestroyNotify(notify)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_gdk_threads_add_timeout_seconds(Xen interval, Xen function, Xen func_info)
{
  #define H_gdk_threads_add_timeout_seconds "guint gdk_threads_add_timeout_seconds(guint interval, GSourceFunc function, \
lambda_data func_info)"
  Xen_check_type(Xen_is_guint(interval), interval, 1, "gdk_threads_add_timeout_seconds", "guint");
  Xen_check_type(Xen_is_GSourceFunc(function), function, 2, "gdk_threads_add_timeout_seconds", "GSourceFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gdk_threads_add_timeout_seconds", "lambda_data");
  {
    Xen result;
    int loc;
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    loc = xm_protect(gxg_ptr);
    Xen_list_set(gxg_ptr, 2, C_int_to_Xen_integer(loc));
    result = C_to_Xen_guint(gdk_threads_add_timeout_seconds(Xen_to_C_guint(interval), Xen_to_C_GSourceFunc(function), Xen_to_C_lambda_data(func_info)));
    Xen_list_set(gxg_ptr, 2, Xen_list_3(xg_idler_symbol, result, C_int_to_Xen_integer(loc)));
    return(result);
   }
}

static Xen gxg_gtk_adjustment_get_lower(Xen adjustment)
{
  #define H_gtk_adjustment_get_lower "gdouble gtk_adjustment_get_lower(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_lower", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_lower(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_adjustment_set_lower(Xen adjustment, Xen lower)
{
  #define H_gtk_adjustment_set_lower "void gtk_adjustment_set_lower(GtkAdjustment* adjustment, gdouble lower)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_set_lower", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(lower), lower, 2, "gtk_adjustment_set_lower", "gdouble");
  gtk_adjustment_set_lower(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(lower));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_get_upper(Xen adjustment)
{
  #define H_gtk_adjustment_get_upper "gdouble gtk_adjustment_get_upper(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_upper", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_upper(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_adjustment_set_upper(Xen adjustment, Xen upper)
{
  #define H_gtk_adjustment_set_upper "void gtk_adjustment_set_upper(GtkAdjustment* adjustment, gdouble upper)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_set_upper", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(upper), upper, 2, "gtk_adjustment_set_upper", "gdouble");
  gtk_adjustment_set_upper(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(upper));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_get_step_increment(Xen adjustment)
{
  #define H_gtk_adjustment_get_step_increment "gdouble gtk_adjustment_get_step_increment(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_step_increment", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_step_increment(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_adjustment_set_step_increment(Xen adjustment, Xen step_increment)
{
  #define H_gtk_adjustment_set_step_increment "void gtk_adjustment_set_step_increment(GtkAdjustment* adjustment, \
gdouble step_increment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_set_step_increment", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(step_increment), step_increment, 2, "gtk_adjustment_set_step_increment", "gdouble");
  gtk_adjustment_set_step_increment(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(step_increment));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_get_page_increment(Xen adjustment)
{
  #define H_gtk_adjustment_get_page_increment "gdouble gtk_adjustment_get_page_increment(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_page_increment", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_page_increment(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_adjustment_set_page_increment(Xen adjustment, Xen page_increment)
{
  #define H_gtk_adjustment_set_page_increment "void gtk_adjustment_set_page_increment(GtkAdjustment* adjustment, \
gdouble page_increment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_set_page_increment", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(page_increment), page_increment, 2, "gtk_adjustment_set_page_increment", "gdouble");
  gtk_adjustment_set_page_increment(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(page_increment));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_get_page_size(Xen adjustment)
{
  #define H_gtk_adjustment_get_page_size "gdouble gtk_adjustment_get_page_size(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_page_size", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_page_size(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_adjustment_set_page_size(Xen adjustment, Xen page_size)
{
  #define H_gtk_adjustment_set_page_size "void gtk_adjustment_set_page_size(GtkAdjustment* adjustment, \
gdouble page_size)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_set_page_size", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(page_size), page_size, 2, "gtk_adjustment_set_page_size", "gdouble");
  gtk_adjustment_set_page_size(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(page_size));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_configure(Xen adjustment, Xen value, Xen lower, Xen upper, Xen step_increment, Xen page_increment, Xen page_size)
{
  #define H_gtk_adjustment_configure "void gtk_adjustment_configure(GtkAdjustment* adjustment, gdouble value, \
gdouble lower, gdouble upper, gdouble step_increment, gdouble page_increment, gdouble page_size)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_configure", "GtkAdjustment*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_adjustment_configure", "gdouble");
  Xen_check_type(Xen_is_gdouble(lower), lower, 3, "gtk_adjustment_configure", "gdouble");
  Xen_check_type(Xen_is_gdouble(upper), upper, 4, "gtk_adjustment_configure", "gdouble");
  Xen_check_type(Xen_is_gdouble(step_increment), step_increment, 5, "gtk_adjustment_configure", "gdouble");
  Xen_check_type(Xen_is_gdouble(page_increment), page_increment, 6, "gtk_adjustment_configure", "gdouble");
  Xen_check_type(Xen_is_gdouble(page_size), page_size, 7, "gtk_adjustment_configure", "gdouble");
  gtk_adjustment_configure(Xen_to_C_GtkAdjustment_(adjustment), Xen_to_C_gdouble(value), Xen_to_C_gdouble(lower), Xen_to_C_gdouble(upper), 
                           Xen_to_C_gdouble(step_increment), Xen_to_C_gdouble(page_increment), Xen_to_C_gdouble(page_size));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_set_button_sensitivity(Xen combo_box, Xen sensitivity)
{
  #define H_gtk_combo_box_set_button_sensitivity "void gtk_combo_box_set_button_sensitivity(GtkComboBox* combo_box, \
GtkSensitivityType sensitivity)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_button_sensitivity", "GtkComboBox*");
  Xen_check_type(Xen_is_GtkSensitivityType(sensitivity), sensitivity, 2, "gtk_combo_box_set_button_sensitivity", "GtkSensitivityType");
  gtk_combo_box_set_button_sensitivity(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_GtkSensitivityType(sensitivity));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_button_sensitivity(Xen combo_box)
{
  #define H_gtk_combo_box_get_button_sensitivity "GtkSensitivityType gtk_combo_box_get_button_sensitivity(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_button_sensitivity", "GtkComboBox*");
  return(C_to_Xen_GtkSensitivityType(gtk_combo_box_get_button_sensitivity(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_file_chooser_get_file(Xen chooser)
{
  #define H_gtk_file_chooser_get_file "GFile* gtk_file_chooser_get_file(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_file", "GtkFileChooser*");
  return(C_to_Xen_GFile_(gtk_file_chooser_get_file(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_file(Xen chooser, Xen file, Xen ignore_error)
{
  #define H_gtk_file_chooser_set_file "gboolean gtk_file_chooser_set_file(GtkFileChooser* chooser, GFile* file, \
GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_file", "GtkFileChooser*");
  Xen_check_type(Xen_is_GFile_(file), file, 2, "gtk_file_chooser_set_file", "GFile*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_set_file(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GFile_(file), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_select_file(Xen chooser, Xen file, Xen ignore_error)
{
  #define H_gtk_file_chooser_select_file "gboolean gtk_file_chooser_select_file(GtkFileChooser* chooser, \
GFile* file, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_select_file", "GtkFileChooser*");
  Xen_check_type(Xen_is_GFile_(file), file, 2, "gtk_file_chooser_select_file", "GFile*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_select_file(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GFile_(file), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_unselect_file(Xen chooser, Xen file)
{
  #define H_gtk_file_chooser_unselect_file "void gtk_file_chooser_unselect_file(GtkFileChooser* chooser, \
GFile* file)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_unselect_file", "GtkFileChooser*");
  Xen_check_type(Xen_is_GFile_(file), file, 2, "gtk_file_chooser_unselect_file", "GFile*");
  gtk_file_chooser_unselect_file(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GFile_(file));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_files(Xen chooser)
{
  #define H_gtk_file_chooser_get_files "GSList* gtk_file_chooser_get_files(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_files", "GtkFileChooser*");
  return(C_to_Xen_GSList_(gtk_file_chooser_get_files(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_set_current_folder_file(Xen chooser, Xen file, Xen ignore_error)
{
  #define H_gtk_file_chooser_set_current_folder_file "gboolean gtk_file_chooser_set_current_folder_file(GtkFileChooser* chooser, \
GFile* file, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_current_folder_file", "GtkFileChooser*");
  Xen_check_type(Xen_is_GFile_(file), file, 2, "gtk_file_chooser_set_current_folder_file", "GFile*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_file_chooser_set_current_folder_file(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_GFile_(file), 
                                                                        &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_file_chooser_get_current_folder_file(Xen chooser)
{
  #define H_gtk_file_chooser_get_current_folder_file "GFile* gtk_file_chooser_get_current_folder_file(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_current_folder_file", "GtkFileChooser*");
  return(C_to_Xen_GFile_(gtk_file_chooser_get_current_folder_file(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_file_chooser_get_preview_file(Xen chooser)
{
  #define H_gtk_file_chooser_get_preview_file "GFile* gtk_file_chooser_get_preview_file(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_preview_file", "GtkFileChooser*");
  return(C_to_Xen_GFile_(gtk_file_chooser_get_preview_file(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_window_get_default_widget(Xen window)
{
  #define H_gtk_window_get_default_widget "GtkWidget* gtk_window_get_default_widget(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_default_widget", "GtkWindow*");
  return(C_to_Xen_GtkWidget_(gtk_window_get_default_widget(Xen_to_C_GtkWindow_(window))));
}

#endif

#if GTK_CHECK_VERSION(2, 16, 0)
static Xen gxg_gtk_link_button_get_visited(Xen link_button)
{
  #define H_gtk_link_button_get_visited "gboolean gtk_link_button_get_visited(GtkLinkButton* link_button)"
  Xen_check_type(Xen_is_GtkLinkButton_(link_button), link_button, 1, "gtk_link_button_get_visited", "GtkLinkButton*");
  return(C_to_Xen_gboolean(gtk_link_button_get_visited(Xen_to_C_GtkLinkButton_(link_button))));
}

static Xen gxg_gtk_link_button_set_visited(Xen link_button, Xen visited)
{
  #define H_gtk_link_button_set_visited "void gtk_link_button_set_visited(GtkLinkButton* link_button, \
bool visited)"
  Xen_check_type(Xen_is_GtkLinkButton_(link_button), link_button, 1, "gtk_link_button_set_visited", "GtkLinkButton*");
  Xen_check_type(Xen_is_bool(visited), visited, 2, "gtk_link_button_set_visited", "bool");
  gtk_link_button_set_visited(Xen_to_C_GtkLinkButton_(link_button), Xen_to_C_bool(visited));
  return(Xen_false);
}

static Xen gxg_gdk_keymap_get_caps_lock_state(Xen keymap)
{
  #define H_gdk_keymap_get_caps_lock_state "gboolean gdk_keymap_get_caps_lock_state(GdkKeymap* keymap)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_caps_lock_state", "GdkKeymap*");
  return(C_to_Xen_gboolean(gdk_keymap_get_caps_lock_state(Xen_to_C_GdkKeymap_(keymap))));
}

static Xen gxg_gtk_cell_view_get_model(Xen cell_view)
{
  #define H_gtk_cell_view_get_model "GtkTreeModel* gtk_cell_view_get_model(GtkCellView* cell_view)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_get_model", "GtkCellView*");
  return(C_to_Xen_GtkTreeModel_(gtk_cell_view_get_model(Xen_to_C_GtkCellView_(cell_view))));
}

static Xen gxg_gtk_entry_unset_invisible_char(Xen entry)
{
  #define H_gtk_entry_unset_invisible_char "void gtk_entry_unset_invisible_char(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_unset_invisible_char", "GtkEntry*");
  gtk_entry_unset_invisible_char(Xen_to_C_GtkEntry_(entry));
  return(Xen_false);
}

static Xen gxg_gtk_entry_set_progress_fraction(Xen entry, Xen fraction)
{
  #define H_gtk_entry_set_progress_fraction "void gtk_entry_set_progress_fraction(GtkEntry* entry, gdouble fraction)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_progress_fraction", "GtkEntry*");
  Xen_check_type(Xen_is_gdouble(fraction), fraction, 2, "gtk_entry_set_progress_fraction", "gdouble");
  gtk_entry_set_progress_fraction(Xen_to_C_GtkEntry_(entry), Xen_to_C_gdouble(fraction));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_progress_fraction(Xen entry)
{
  #define H_gtk_entry_get_progress_fraction "gdouble gtk_entry_get_progress_fraction(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_progress_fraction", "GtkEntry*");
  return(C_to_Xen_gdouble(gtk_entry_get_progress_fraction(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_progress_pulse_step(Xen entry, Xen fraction)
{
  #define H_gtk_entry_set_progress_pulse_step "void gtk_entry_set_progress_pulse_step(GtkEntry* entry, \
gdouble fraction)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_progress_pulse_step", "GtkEntry*");
  Xen_check_type(Xen_is_gdouble(fraction), fraction, 2, "gtk_entry_set_progress_pulse_step", "gdouble");
  gtk_entry_set_progress_pulse_step(Xen_to_C_GtkEntry_(entry), Xen_to_C_gdouble(fraction));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_progress_pulse_step(Xen entry)
{
  #define H_gtk_entry_get_progress_pulse_step "gdouble gtk_entry_get_progress_pulse_step(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_progress_pulse_step", "GtkEntry*");
  return(C_to_Xen_gdouble(gtk_entry_get_progress_pulse_step(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_progress_pulse(Xen entry)
{
  #define H_gtk_entry_progress_pulse "void gtk_entry_progress_pulse(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_progress_pulse", "GtkEntry*");
  gtk_entry_progress_pulse(Xen_to_C_GtkEntry_(entry));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_icon_name(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_name "gchar* gtk_entry_get_icon_name(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_name", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_name", "GtkEntryIconPosition");
  return(C_to_Xen_gchar_(gtk_entry_get_icon_name(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_entry_set_icon_activatable(Xen entry, Xen icon_pos, Xen activatable)
{
  #define H_gtk_entry_set_icon_activatable "void gtk_entry_set_icon_activatable(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gboolean activatable)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_icon_activatable", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_set_icon_activatable", "GtkEntryIconPosition");
  Xen_check_type(Xen_is_gboolean(activatable), activatable, 3, "gtk_entry_set_icon_activatable", "gboolean");
  gtk_entry_set_icon_activatable(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos), Xen_to_C_gboolean(activatable));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_icon_activatable(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_activatable "gboolean gtk_entry_get_icon_activatable(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_activatable", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_activatable", "GtkEntryIconPosition");
  return(C_to_Xen_gboolean(gtk_entry_get_icon_activatable(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_entry_set_icon_sensitive(Xen entry, Xen icon_pos, Xen sensitive)
{
  #define H_gtk_entry_set_icon_sensitive "void gtk_entry_set_icon_sensitive(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gboolean sensitive)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_icon_sensitive", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_set_icon_sensitive", "GtkEntryIconPosition");
  Xen_check_type(Xen_is_gboolean(sensitive), sensitive, 3, "gtk_entry_set_icon_sensitive", "gboolean");
  gtk_entry_set_icon_sensitive(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos), Xen_to_C_gboolean(sensitive));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_icon_sensitive(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_sensitive "gboolean gtk_entry_get_icon_sensitive(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_sensitive", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_sensitive", "GtkEntryIconPosition");
  return(C_to_Xen_gboolean(gtk_entry_get_icon_sensitive(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_entry_get_icon_at_pos(Xen entry, Xen x, Xen y)
{
  #define H_gtk_entry_get_icon_at_pos "gint gtk_entry_get_icon_at_pos(GtkEntry* entry, gint x, gint y)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_at_pos", "GtkEntry*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_entry_get_icon_at_pos", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_entry_get_icon_at_pos", "gint");
  return(C_to_Xen_gint(gtk_entry_get_icon_at_pos(Xen_to_C_GtkEntry_(entry), Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_entry_set_icon_tooltip_text(Xen entry, Xen icon_pos, Xen tooltip)
{
  #define H_gtk_entry_set_icon_tooltip_text "void gtk_entry_set_icon_tooltip_text(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gchar* tooltip)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_icon_tooltip_text", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_set_icon_tooltip_text", "GtkEntryIconPosition");
  Xen_check_type(Xen_is_gchar_(tooltip), tooltip, 3, "gtk_entry_set_icon_tooltip_text", "gchar*");
  gtk_entry_set_icon_tooltip_text(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos), Xen_to_C_gchar_(tooltip));
  return(Xen_false);
}

static Xen gxg_gtk_entry_set_icon_tooltip_markup(Xen entry, Xen icon_pos, Xen tooltip)
{
  #define H_gtk_entry_set_icon_tooltip_markup "void gtk_entry_set_icon_tooltip_markup(GtkEntry* entry, \
GtkEntryIconPosition icon_pos, gchar* tooltip)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_icon_tooltip_markup", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_set_icon_tooltip_markup", "GtkEntryIconPosition");
  Xen_check_type(Xen_is_gchar_(tooltip), tooltip, 3, "gtk_entry_set_icon_tooltip_markup", "gchar*");
  gtk_entry_set_icon_tooltip_markup(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos), Xen_to_C_gchar_(tooltip));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_set_label(Xen menu_item, Xen label)
{
  #define H_gtk_menu_item_set_label "void gtk_menu_item_set_label(GtkMenuItem* menu_item, gchar* label)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_set_label", "GtkMenuItem*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_menu_item_set_label", "gchar*");
  gtk_menu_item_set_label(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_get_label(Xen menu_item)
{
  #define H_gtk_menu_item_get_label "gchar* gtk_menu_item_get_label(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_get_label", "GtkMenuItem*");
  return(C_to_Xen_gchar_(gtk_menu_item_get_label(Xen_to_C_GtkMenuItem_(menu_item))));
}

static Xen gxg_gtk_menu_item_set_use_underline(Xen menu_item, Xen setting)
{
  #define H_gtk_menu_item_set_use_underline "void gtk_menu_item_set_use_underline(GtkMenuItem* menu_item, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_set_use_underline", "GtkMenuItem*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_menu_item_set_use_underline", "gboolean");
  gtk_menu_item_set_use_underline(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_get_use_underline(Xen menu_item)
{
  #define H_gtk_menu_item_get_use_underline "gboolean gtk_menu_item_get_use_underline(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_get_use_underline", "GtkMenuItem*");
  return(C_to_Xen_gboolean(gtk_menu_item_get_use_underline(Xen_to_C_GtkMenuItem_(menu_item))));
}

static Xen gxg_gtk_entry_get_icon_tooltip_text(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_tooltip_text "gchar* gtk_entry_get_icon_tooltip_text(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_tooltip_text", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_tooltip_text", "GtkEntryIconPosition");
  return(C_to_Xen_gchar_(gtk_entry_get_icon_tooltip_text(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_entry_get_icon_tooltip_markup(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_tooltip_markup "gchar* gtk_entry_get_icon_tooltip_markup(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_tooltip_markup", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_tooltip_markup", "GtkEntryIconPosition");
  return(C_to_Xen_gchar_(gtk_entry_get_icon_tooltip_markup(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_scale_add_mark(Xen scale, Xen value, Xen position, Xen markup)
{
  #define H_gtk_scale_add_mark "void gtk_scale_add_mark(GtkScale* scale, gdouble value, GtkPositionType position, \
gchar* markup)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_add_mark", "GtkScale*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_scale_add_mark", "gdouble");
  Xen_check_type(Xen_is_GtkPositionType(position), position, 3, "gtk_scale_add_mark", "GtkPositionType");
  Xen_check_type(Xen_is_gchar_(markup), markup, 4, "gtk_scale_add_mark", "gchar*");
  gtk_scale_add_mark(Xen_to_C_GtkScale_(scale), Xen_to_C_gdouble(value), Xen_to_C_GtkPositionType(position), Xen_to_C_gchar_(markup));
  return(Xen_false);
}

static Xen gxg_gtk_scale_clear_marks(Xen scale)
{
  #define H_gtk_scale_clear_marks "void gtk_scale_clear_marks(GtkScale* scale)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_clear_marks", "GtkScale*");
  gtk_scale_clear_marks(Xen_to_C_GtkScale_(scale));
  return(Xen_false);
}

#endif

#if GTK_CHECK_VERSION(2, 18, 0)
static Xen gxg_gtk_window_get_default_icon_name(void)
{
  #define H_gtk_window_get_default_icon_name "gchar* gtk_window_get_default_icon_name( void)"
  return(C_to_Xen_gchar_(gtk_window_get_default_icon_name()));
}

static Xen gxg_gtk_label_get_current_uri(Xen label)
{
  #define H_gtk_label_get_current_uri "gchar* gtk_label_get_current_uri(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_current_uri", "GtkLabel*");
  return(C_to_Xen_gchar_(gtk_label_get_current_uri(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_info_bar_new(void)
{
  #define H_gtk_info_bar_new "GtkWidget* gtk_info_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_info_bar_new()));
}

static Xen gxg_gtk_info_bar_get_action_area(Xen info_bar)
{
  #define H_gtk_info_bar_get_action_area "GtkWidget* gtk_info_bar_get_action_area(GtkInfoBar* info_bar)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_get_action_area", "GtkInfoBar*");
  return(C_to_Xen_GtkWidget_(gtk_info_bar_get_action_area(Xen_to_C_GtkInfoBar_(info_bar))));
}

static Xen gxg_gtk_info_bar_get_content_area(Xen info_bar)
{
  #define H_gtk_info_bar_get_content_area "GtkWidget* gtk_info_bar_get_content_area(GtkInfoBar* info_bar)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_get_content_area", "GtkInfoBar*");
  return(C_to_Xen_GtkWidget_(gtk_info_bar_get_content_area(Xen_to_C_GtkInfoBar_(info_bar))));
}

static Xen gxg_gtk_info_bar_add_action_widget(Xen info_bar, Xen child, Xen response_id)
{
  #define H_gtk_info_bar_add_action_widget "void gtk_info_bar_add_action_widget(GtkInfoBar* info_bar, \
GtkWidget* child, gint response_id)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_add_action_widget", "GtkInfoBar*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_info_bar_add_action_widget", "GtkWidget*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 3, "gtk_info_bar_add_action_widget", "gint");
  gtk_info_bar_add_action_widget(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(response_id));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_add_button(Xen info_bar, Xen button_text, Xen response_id)
{
  #define H_gtk_info_bar_add_button "GtkWidget* gtk_info_bar_add_button(GtkInfoBar* info_bar, gchar* button_text, \
gint response_id)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_add_button", "GtkInfoBar*");
  Xen_check_type(Xen_is_gchar_(button_text), button_text, 2, "gtk_info_bar_add_button", "gchar*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 3, "gtk_info_bar_add_button", "gint");
  return(C_to_Xen_GtkWidget_(gtk_info_bar_add_button(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_gchar_(button_text), Xen_to_C_gint(response_id))));
}

static Xen gxg_gtk_info_bar_set_response_sensitive(Xen info_bar, Xen response_id, Xen setting)
{
  #define H_gtk_info_bar_set_response_sensitive "void gtk_info_bar_set_response_sensitive(GtkInfoBar* info_bar, \
gint response_id, gboolean setting)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_set_response_sensitive", "GtkInfoBar*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_info_bar_set_response_sensitive", "gint");
  Xen_check_type(Xen_is_gboolean(setting), setting, 3, "gtk_info_bar_set_response_sensitive", "gboolean");
  gtk_info_bar_set_response_sensitive(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_gint(response_id), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_set_default_response(Xen info_bar, Xen response_id)
{
  #define H_gtk_info_bar_set_default_response "void gtk_info_bar_set_default_response(GtkInfoBar* info_bar, \
gint response_id)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_set_default_response", "GtkInfoBar*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_info_bar_set_default_response", "gint");
  gtk_info_bar_set_default_response(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_gint(response_id));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_response(Xen info_bar, Xen response_id)
{
  #define H_gtk_info_bar_response "void gtk_info_bar_response(GtkInfoBar* info_bar, gint response_id)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_response", "GtkInfoBar*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_info_bar_response", "gint");
  gtk_info_bar_response(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_gint(response_id));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_set_message_type(Xen info_bar, Xen message_type)
{
  #define H_gtk_info_bar_set_message_type "void gtk_info_bar_set_message_type(GtkInfoBar* info_bar, GtkMessageType message_type)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_set_message_type", "GtkInfoBar*");
  Xen_check_type(Xen_is_GtkMessageType(message_type), message_type, 2, "gtk_info_bar_set_message_type", "GtkMessageType");
  gtk_info_bar_set_message_type(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_GtkMessageType(message_type));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_get_message_type(Xen info_bar)
{
  #define H_gtk_info_bar_get_message_type "GtkMessageType gtk_info_bar_get_message_type(GtkInfoBar* info_bar)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_get_message_type", "GtkInfoBar*");
  return(C_to_Xen_GtkMessageType(gtk_info_bar_get_message_type(Xen_to_C_GtkInfoBar_(info_bar))));
}

static Xen gxg_gdk_window_get_root_coords(Xen window, Xen x, Xen y, Xen ignore_root_x, Xen ignore_root_y)
{
  #define H_gdk_window_get_root_coords "void gdk_window_get_root_coords(GdkWindow* window, gint x, gint y, \
gint* [root_x], gint* [root_y])"
  gint ref_root_x;
  gint ref_root_y;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_root_coords", "GdkWindow*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gdk_window_get_root_coords", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gdk_window_get_root_coords", "gint");
  gdk_window_get_root_coords(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(x), Xen_to_C_gint(y), &ref_root_x, &ref_root_y);
  return(Xen_list_2(C_to_Xen_gint(ref_root_x), C_to_Xen_gint(ref_root_y)));
}

static Xen gxg_gtk_menu_set_reserve_toggle_size(Xen menu, Xen reserve_toggle_size)
{
  #define H_gtk_menu_set_reserve_toggle_size "void gtk_menu_set_reserve_toggle_size(GtkMenu* menu, gboolean reserve_toggle_size)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_set_reserve_toggle_size", "GtkMenu*");
  Xen_check_type(Xen_is_gboolean(reserve_toggle_size), reserve_toggle_size, 2, "gtk_menu_set_reserve_toggle_size", "gboolean");
  gtk_menu_set_reserve_toggle_size(Xen_to_C_GtkMenu_(menu), Xen_to_C_gboolean(reserve_toggle_size));
  return(Xen_false);
}

static Xen gxg_gtk_menu_get_reserve_toggle_size(Xen menu)
{
  #define H_gtk_menu_get_reserve_toggle_size "gboolean gtk_menu_get_reserve_toggle_size(GtkMenu* menu)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_get_reserve_toggle_size", "GtkMenu*");
  return(C_to_Xen_gboolean(gtk_menu_get_reserve_toggle_size(Xen_to_C_GtkMenu_(menu))));
}

static Xen gxg_gtk_entry_new_with_buffer(Xen buffer)
{
  #define H_gtk_entry_new_with_buffer "GtkWidget* gtk_entry_new_with_buffer(GtkEntryBuffer* buffer)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_new_with_buffer", "GtkEntryBuffer*");
  return(C_to_Xen_GtkWidget_(gtk_entry_new_with_buffer(Xen_to_C_GtkEntryBuffer_(buffer))));
}

static Xen gxg_gtk_entry_get_buffer(Xen entry)
{
  #define H_gtk_entry_get_buffer "GtkEntryBuffer* gtk_entry_get_buffer(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_buffer", "GtkEntry*");
  return(C_to_Xen_GtkEntryBuffer_(gtk_entry_get_buffer(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_buffer(Xen entry, Xen buffer)
{
  #define H_gtk_entry_set_buffer "void gtk_entry_set_buffer(GtkEntry* entry, GtkEntryBuffer* buffer)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_buffer", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 2, "gtk_entry_set_buffer", "GtkEntryBuffer*");
  gtk_entry_set_buffer(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryBuffer_(buffer));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_track_visited_links(Xen label, Xen track_links)
{
  #define H_gtk_label_set_track_visited_links "void gtk_label_set_track_visited_links(GtkLabel* label, \
gboolean track_links)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_track_visited_links", "GtkLabel*");
  Xen_check_type(Xen_is_gboolean(track_links), track_links, 2, "gtk_label_set_track_visited_links", "gboolean");
  gtk_label_set_track_visited_links(Xen_to_C_GtkLabel_(label), Xen_to_C_gboolean(track_links));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_track_visited_links(Xen label)
{
  #define H_gtk_label_get_track_visited_links "gboolean gtk_label_get_track_visited_links(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_track_visited_links", "GtkLabel*");
  return(C_to_Xen_gboolean(gtk_label_get_track_visited_links(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_print_operation_set_embed_page_setup(Xen op, Xen embed)
{
  #define H_gtk_print_operation_set_embed_page_setup "void gtk_print_operation_set_embed_page_setup(GtkPrintOperation* op, \
gboolean embed)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_set_embed_page_setup", "GtkPrintOperation*");
  Xen_check_type(Xen_is_gboolean(embed), embed, 2, "gtk_print_operation_set_embed_page_setup", "gboolean");
  gtk_print_operation_set_embed_page_setup(Xen_to_C_GtkPrintOperation_(op), Xen_to_C_gboolean(embed));
  return(Xen_false);
}

static Xen gxg_gtk_print_operation_get_embed_page_setup(Xen op)
{
  #define H_gtk_print_operation_get_embed_page_setup "gboolean gtk_print_operation_get_embed_page_setup(GtkPrintOperation* op)"
  Xen_check_type(Xen_is_GtkPrintOperation_(op), op, 1, "gtk_print_operation_get_embed_page_setup", "GtkPrintOperation*");
  return(C_to_Xen_gboolean(gtk_print_operation_get_embed_page_setup(Xen_to_C_GtkPrintOperation_(op))));
}

static Xen gxg_gtk_entry_buffer_new(Xen initial_chars, Xen n_initial_chars)
{
  #define H_gtk_entry_buffer_new "GtkEntryBuffer* gtk_entry_buffer_new(gchar* initial_chars, gint n_initial_chars)"
  Xen_check_type(Xen_is_gchar_(initial_chars), initial_chars, 1, "gtk_entry_buffer_new", "gchar*");
  Xen_check_type(Xen_is_gint(n_initial_chars), n_initial_chars, 2, "gtk_entry_buffer_new", "gint");
  return(C_to_Xen_GtkEntryBuffer_(gtk_entry_buffer_new(Xen_to_C_gchar_(initial_chars), Xen_to_C_gint(n_initial_chars))));
}

static Xen gxg_gtk_entry_buffer_get_bytes(Xen buffer)
{
  #define H_gtk_entry_buffer_get_bytes "gsize gtk_entry_buffer_get_bytes(GtkEntryBuffer* buffer)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_get_bytes", "GtkEntryBuffer*");
  return(C_to_Xen_gsize(gtk_entry_buffer_get_bytes(Xen_to_C_GtkEntryBuffer_(buffer))));
}

static Xen gxg_gtk_entry_buffer_get_length(Xen buffer)
{
  #define H_gtk_entry_buffer_get_length "guint gtk_entry_buffer_get_length(GtkEntryBuffer* buffer)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_get_length", "GtkEntryBuffer*");
  return(C_to_Xen_guint(gtk_entry_buffer_get_length(Xen_to_C_GtkEntryBuffer_(buffer))));
}

static Xen gxg_gtk_entry_buffer_get_text(Xen buffer)
{
  #define H_gtk_entry_buffer_get_text "gchar* gtk_entry_buffer_get_text(GtkEntryBuffer* buffer)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_get_text", "GtkEntryBuffer*");
  return(C_to_Xen_gchar_(gtk_entry_buffer_get_text(Xen_to_C_GtkEntryBuffer_(buffer))));
}

static Xen gxg_gtk_entry_buffer_set_text(Xen buffer, Xen chars, Xen n_chars)
{
  #define H_gtk_entry_buffer_set_text "void gtk_entry_buffer_set_text(GtkEntryBuffer* buffer, gchar* chars, \
gint n_chars)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_set_text", "GtkEntryBuffer*");
  Xen_check_type(Xen_is_gchar_(chars), chars, 2, "gtk_entry_buffer_set_text", "gchar*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 3, "gtk_entry_buffer_set_text", "gint");
  gtk_entry_buffer_set_text(Xen_to_C_GtkEntryBuffer_(buffer), Xen_to_C_gchar_(chars), Xen_to_C_gint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_entry_buffer_set_max_length(Xen buffer, Xen max_length)
{
  #define H_gtk_entry_buffer_set_max_length "void gtk_entry_buffer_set_max_length(GtkEntryBuffer* buffer, \
guint max_length)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_set_max_length", "GtkEntryBuffer*");
  Xen_check_type(Xen_is_guint(max_length), max_length, 2, "gtk_entry_buffer_set_max_length", "guint");
  gtk_entry_buffer_set_max_length(Xen_to_C_GtkEntryBuffer_(buffer), Xen_to_C_guint(max_length));
  return(Xen_false);
}

static Xen gxg_gtk_entry_buffer_get_max_length(Xen buffer)
{
  #define H_gtk_entry_buffer_get_max_length "guint gtk_entry_buffer_get_max_length(GtkEntryBuffer* buffer)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_get_max_length", "GtkEntryBuffer*");
  return(C_to_Xen_guint(gtk_entry_buffer_get_max_length(Xen_to_C_GtkEntryBuffer_(buffer))));
}

static Xen gxg_gtk_entry_buffer_insert_text(Xen buffer, Xen position, Xen chars, Xen n_chars)
{
  #define H_gtk_entry_buffer_insert_text "guint gtk_entry_buffer_insert_text(GtkEntryBuffer* buffer, \
guint position, gchar* chars, gint n_chars)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_insert_text", "GtkEntryBuffer*");
  Xen_check_type(Xen_is_guint(position), position, 2, "gtk_entry_buffer_insert_text", "guint");
  Xen_check_type(Xen_is_gchar_(chars), chars, 3, "gtk_entry_buffer_insert_text", "gchar*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 4, "gtk_entry_buffer_insert_text", "gint");
  return(C_to_Xen_guint(gtk_entry_buffer_insert_text(Xen_to_C_GtkEntryBuffer_(buffer), Xen_to_C_guint(position), Xen_to_C_gchar_(chars), 
                                                     Xen_to_C_gint(n_chars))));
}

static Xen gxg_gtk_entry_buffer_delete_text(Xen buffer, Xen position, Xen n_chars)
{
  #define H_gtk_entry_buffer_delete_text "guint gtk_entry_buffer_delete_text(GtkEntryBuffer* buffer, \
guint position, gint n_chars)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_delete_text", "GtkEntryBuffer*");
  Xen_check_type(Xen_is_guint(position), position, 2, "gtk_entry_buffer_delete_text", "guint");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 3, "gtk_entry_buffer_delete_text", "gint");
  return(C_to_Xen_guint(gtk_entry_buffer_delete_text(Xen_to_C_GtkEntryBuffer_(buffer), Xen_to_C_guint(position), Xen_to_C_gint(n_chars))));
}

static Xen gxg_gtk_entry_buffer_emit_inserted_text(Xen buffer, Xen position, Xen chars, Xen n_chars)
{
  #define H_gtk_entry_buffer_emit_inserted_text "void gtk_entry_buffer_emit_inserted_text(GtkEntryBuffer* buffer, \
guint position, gchar* chars, guint n_chars)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_emit_inserted_text", "GtkEntryBuffer*");
  Xen_check_type(Xen_is_guint(position), position, 2, "gtk_entry_buffer_emit_inserted_text", "guint");
  Xen_check_type(Xen_is_gchar_(chars), chars, 3, "gtk_entry_buffer_emit_inserted_text", "gchar*");
  Xen_check_type(Xen_is_guint(n_chars), n_chars, 4, "gtk_entry_buffer_emit_inserted_text", "guint");
  gtk_entry_buffer_emit_inserted_text(Xen_to_C_GtkEntryBuffer_(buffer), Xen_to_C_guint(position), Xen_to_C_gchar_(chars), 
                                      Xen_to_C_guint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_entry_buffer_emit_deleted_text(Xen buffer, Xen position, Xen n_chars)
{
  #define H_gtk_entry_buffer_emit_deleted_text "void gtk_entry_buffer_emit_deleted_text(GtkEntryBuffer* buffer, \
guint position, guint n_chars)"
  Xen_check_type(Xen_is_GtkEntryBuffer_(buffer), buffer, 1, "gtk_entry_buffer_emit_deleted_text", "GtkEntryBuffer*");
  Xen_check_type(Xen_is_guint(position), position, 2, "gtk_entry_buffer_emit_deleted_text", "guint");
  Xen_check_type(Xen_is_guint(n_chars), n_chars, 3, "gtk_entry_buffer_emit_deleted_text", "guint");
  gtk_entry_buffer_emit_deleted_text(Xen_to_C_GtkEntryBuffer_(buffer), Xen_to_C_guint(position), Xen_to_C_guint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_set_alignment(Xen cell, Xen xalign, Xen yalign)
{
  #define H_gtk_cell_renderer_set_alignment "void gtk_cell_renderer_set_alignment(GtkCellRenderer* cell, \
gfloat xalign, gfloat yalign)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_set_alignment", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_cell_renderer_set_alignment", "gfloat");
  Xen_check_type(Xen_is_gfloat(yalign), yalign, 3, "gtk_cell_renderer_set_alignment", "gfloat");
  gtk_cell_renderer_set_alignment(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gfloat(xalign), Xen_to_C_gfloat(yalign));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_get_alignment(Xen cell, Xen ignore_xalign, Xen ignore_yalign)
{
  #define H_gtk_cell_renderer_get_alignment "void gtk_cell_renderer_get_alignment(GtkCellRenderer* cell, \
gfloat* [xalign], gfloat* [yalign])"
  gfloat ref_xalign;
  gfloat ref_yalign;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_alignment", "GtkCellRenderer*");
  gtk_cell_renderer_get_alignment(Xen_to_C_GtkCellRenderer_(cell), &ref_xalign, &ref_yalign);
  return(Xen_list_2(C_to_Xen_gfloat(ref_xalign), C_to_Xen_gfloat(ref_yalign)));
}

static Xen gxg_gtk_cell_renderer_set_padding(Xen cell, Xen xpad, Xen ypad)
{
  #define H_gtk_cell_renderer_set_padding "void gtk_cell_renderer_set_padding(GtkCellRenderer* cell, \
gint xpad, gint ypad)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_set_padding", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gint(xpad), xpad, 2, "gtk_cell_renderer_set_padding", "gint");
  Xen_check_type(Xen_is_gint(ypad), ypad, 3, "gtk_cell_renderer_set_padding", "gint");
  gtk_cell_renderer_set_padding(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gint(xpad), Xen_to_C_gint(ypad));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_get_padding(Xen cell, Xen ignore_xpad, Xen ignore_ypad)
{
  #define H_gtk_cell_renderer_get_padding "void gtk_cell_renderer_get_padding(GtkCellRenderer* cell, \
gint* [xpad], gint* [ypad])"
  gint ref_xpad;
  gint ref_ypad;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_padding", "GtkCellRenderer*");
  gtk_cell_renderer_get_padding(Xen_to_C_GtkCellRenderer_(cell), &ref_xpad, &ref_ypad);
  return(Xen_list_2(C_to_Xen_gint(ref_xpad), C_to_Xen_gint(ref_ypad)));
}

static Xen gxg_gtk_cell_renderer_set_visible(Xen cell, Xen visible)
{
  #define H_gtk_cell_renderer_set_visible "void gtk_cell_renderer_set_visible(GtkCellRenderer* cell, \
gboolean visible)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_set_visible", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(visible), visible, 2, "gtk_cell_renderer_set_visible", "gboolean");
  gtk_cell_renderer_set_visible(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(visible));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_get_visible(Xen cell)
{
  #define H_gtk_cell_renderer_get_visible "gboolean gtk_cell_renderer_get_visible(GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_visible", "GtkCellRenderer*");
  return(C_to_Xen_gboolean(gtk_cell_renderer_get_visible(Xen_to_C_GtkCellRenderer_(cell))));
}

static Xen gxg_gtk_cell_renderer_set_sensitive(Xen cell, Xen sensitive)
{
  #define H_gtk_cell_renderer_set_sensitive "void gtk_cell_renderer_set_sensitive(GtkCellRenderer* cell, \
gboolean sensitive)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_set_sensitive", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(sensitive), sensitive, 2, "gtk_cell_renderer_set_sensitive", "gboolean");
  gtk_cell_renderer_set_sensitive(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_gboolean(sensitive));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_get_sensitive(Xen cell)
{
  #define H_gtk_cell_renderer_get_sensitive "gboolean gtk_cell_renderer_get_sensitive(GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_sensitive", "GtkCellRenderer*");
  return(C_to_Xen_gboolean(gtk_cell_renderer_get_sensitive(Xen_to_C_GtkCellRenderer_(cell))));
}

static Xen gxg_gtk_cell_renderer_toggle_get_activatable(Xen toggle)
{
  #define H_gtk_cell_renderer_toggle_get_activatable "gboolean gtk_cell_renderer_toggle_get_activatable(GtkCellRendererToggle* toggle)"
  Xen_check_type(Xen_is_GtkCellRendererToggle_(toggle), toggle, 1, "gtk_cell_renderer_toggle_get_activatable", "GtkCellRendererToggle*");
  return(C_to_Xen_gboolean(gtk_cell_renderer_toggle_get_activatable(Xen_to_C_GtkCellRendererToggle_(toggle))));
}

static Xen gxg_gtk_cell_renderer_toggle_set_activatable(Xen toggle, Xen setting)
{
  #define H_gtk_cell_renderer_toggle_set_activatable "void gtk_cell_renderer_toggle_set_activatable(GtkCellRendererToggle* toggle, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkCellRendererToggle_(toggle), toggle, 1, "gtk_cell_renderer_toggle_set_activatable", "GtkCellRendererToggle*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_cell_renderer_toggle_set_activatable", "gboolean");
  gtk_cell_renderer_toggle_set_activatable(Xen_to_C_GtkCellRendererToggle_(toggle), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_can_focus(Xen widget, Xen can_focus)
{
  #define H_gtk_widget_set_can_focus "void gtk_widget_set_can_focus(GtkWidget* widget, gboolean can_focus)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_can_focus", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(can_focus), can_focus, 2, "gtk_widget_set_can_focus", "gboolean");
  gtk_widget_set_can_focus(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(can_focus));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_can_focus(Xen widget)
{
  #define H_gtk_widget_get_can_focus "gboolean gtk_widget_get_can_focus(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_can_focus", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_can_focus(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_has_focus(Xen widget)
{
  #define H_gtk_widget_has_focus "gboolean gtk_widget_has_focus(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_has_focus", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_has_focus(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_can_default(Xen widget, Xen can_default)
{
  #define H_gtk_widget_set_can_default "void gtk_widget_set_can_default(GtkWidget* widget, gboolean can_default)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_can_default", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(can_default), can_default, 2, "gtk_widget_set_can_default", "gboolean");
  gtk_widget_set_can_default(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(can_default));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_can_default(Xen widget)
{
  #define H_gtk_widget_get_can_default "gboolean gtk_widget_get_can_default(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_can_default", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_can_default(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_has_default(Xen widget)
{
  #define H_gtk_widget_has_default "gboolean gtk_widget_has_default(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_has_default", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_has_default(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_sensitive(Xen widget)
{
  #define H_gtk_widget_get_sensitive "gboolean gtk_widget_get_sensitive(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_sensitive", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_sensitive(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_is_sensitive(Xen widget)
{
  #define H_gtk_widget_is_sensitive "gboolean gtk_widget_is_sensitive(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_is_sensitive", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_is_sensitive(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_has_window(Xen widget, Xen has_window)
{
  #define H_gtk_widget_set_has_window "void gtk_widget_set_has_window(GtkWidget* widget, gboolean has_window)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_has_window", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(has_window), has_window, 2, "gtk_widget_set_has_window", "gboolean");
  gtk_widget_set_has_window(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(has_window));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_has_window(Xen widget)
{
  #define H_gtk_widget_get_has_window "gboolean gtk_widget_get_has_window(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_has_window", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_has_window(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gdk_window_get_cursor(Xen window)
{
  #define H_gdk_window_get_cursor "GdkCursor* gdk_window_get_cursor(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_cursor", "GdkWindow*");
  return(C_to_Xen_GdkCursor_(gdk_window_get_cursor(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_file_chooser_set_create_folders(Xen chooser, Xen create_folders)
{
  #define H_gtk_file_chooser_set_create_folders "void gtk_file_chooser_set_create_folders(GtkFileChooser* chooser, \
gboolean create_folders)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_create_folders", "GtkFileChooser*");
  Xen_check_type(Xen_is_gboolean(create_folders), create_folders, 2, "gtk_file_chooser_set_create_folders", "gboolean");
  gtk_file_chooser_set_create_folders(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_gboolean(create_folders));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_create_folders(Xen chooser)
{
  #define H_gtk_file_chooser_get_create_folders "gboolean gtk_file_chooser_get_create_folders(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_create_folders", "GtkFileChooser*");
  return(C_to_Xen_gboolean(gtk_file_chooser_get_create_folders(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gtk_icon_view_set_item_padding(Xen icon_view, Xen item_padding)
{
  #define H_gtk_icon_view_set_item_padding "void gtk_icon_view_set_item_padding(GtkIconView* icon_view, \
gint item_padding)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_item_padding", "GtkIconView*");
  Xen_check_type(Xen_is_gint(item_padding), item_padding, 2, "gtk_icon_view_set_item_padding", "gint");
  gtk_icon_view_set_item_padding(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gint(item_padding));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_item_padding(Xen icon_view)
{
  #define H_gtk_icon_view_get_item_padding "gint gtk_icon_view_get_item_padding(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_item_padding", "GtkIconView*");
  return(C_to_Xen_gint(gtk_icon_view_get_item_padding(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_widget_has_grab(Xen widget)
{
  #define H_gtk_widget_has_grab "gboolean gtk_widget_has_grab(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_has_grab", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_has_grab(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_visible(Xen widget, Xen visible)
{
  #define H_gtk_widget_set_visible "void gtk_widget_set_visible(GtkWidget* widget, gboolean visible)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_visible", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(visible), visible, 2, "gtk_widget_set_visible", "gboolean");
  gtk_widget_set_visible(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(visible));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_visible(Xen widget)
{
  #define H_gtk_widget_get_visible "gboolean gtk_widget_get_visible(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_visible", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_visible(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_range_set_flippable(Xen range, Xen flippable)
{
  #define H_gtk_range_set_flippable "void gtk_range_set_flippable(GtkRange* range, gboolean flippable)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_flippable", "GtkRange*");
  Xen_check_type(Xen_is_gboolean(flippable), flippable, 2, "gtk_range_set_flippable", "gboolean");
  gtk_range_set_flippable(Xen_to_C_GtkRange_(range), Xen_to_C_gboolean(flippable));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_flippable(Xen range)
{
  #define H_gtk_range_get_flippable "gboolean gtk_range_get_flippable(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_flippable", "GtkRange*");
  return(C_to_Xen_gboolean(gtk_range_get_flippable(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_widget_is_toplevel(Xen widget)
{
  #define H_gtk_widget_is_toplevel "gboolean gtk_widget_is_toplevel(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_is_toplevel", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_is_toplevel(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_is_drawable(Xen widget)
{
  #define H_gtk_widget_is_drawable "gboolean gtk_widget_is_drawable(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_is_drawable", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_is_drawable(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_window(Xen widget, Xen window)
{
  #define H_gtk_widget_set_window "void gtk_widget_set_window(GtkWidget* widget, GdkWindow* window)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_window", "GtkWidget*");
  Xen_check_type(Xen_is_GdkWindow_(window), window, 2, "gtk_widget_set_window", "GdkWindow*");
  gtk_widget_set_window(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gdk_window_is_destroyed(Xen window)
{
  #define H_gdk_window_is_destroyed "gboolean gdk_window_is_destroyed(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_is_destroyed", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_is_destroyed(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_restack(Xen window, Xen sibling, Xen above)
{
  #define H_gdk_window_restack "void gdk_window_restack(GdkWindow* window, GdkWindow* sibling, gboolean above)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_restack", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWindow_(sibling), sibling, 2, "gdk_window_restack", "GdkWindow*");
  Xen_check_type(Xen_is_gboolean(above), above, 3, "gdk_window_restack", "gboolean");
  gdk_window_restack(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWindow_(sibling), Xen_to_C_gboolean(above));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_receives_default(Xen widget, Xen receives_default)
{
  #define H_gtk_widget_set_receives_default "void gtk_widget_set_receives_default(GtkWidget* widget, \
gboolean receives_default)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_receives_default", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(receives_default), receives_default, 2, "gtk_widget_set_receives_default", "gboolean");
  gtk_widget_set_receives_default(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(receives_default));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_receives_default(Xen widget)
{
  #define H_gtk_widget_get_receives_default "gboolean gtk_widget_get_receives_default(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_receives_default", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_receives_default(Xen_to_C_GtkWidget_(widget))));
}

#endif

#if GTK_CHECK_VERSION(2, 20, 0)
static Xen gxg_gtk_dialog_get_widget_for_response(Xen dialog, Xen response_id)
{
  #define H_gtk_dialog_get_widget_for_response "GtkWidget* gtk_dialog_get_widget_for_response(GtkDialog* dialog, \
gint response_id)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_get_widget_for_response", "GtkDialog*");
  Xen_check_type(Xen_is_gint(response_id), response_id, 2, "gtk_dialog_get_widget_for_response", "gint");
  return(C_to_Xen_GtkWidget_(gtk_dialog_get_widget_for_response(Xen_to_C_GtkDialog_(dialog), Xen_to_C_gint(response_id))));
}

static Xen gxg_gtk_spinner_new(void)
{
  #define H_gtk_spinner_new "GtkWidget* gtk_spinner_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_spinner_new()));
}

static Xen gxg_gtk_spinner_start(Xen spinner)
{
  #define H_gtk_spinner_start "void gtk_spinner_start(GtkSpinner* spinner)"
  Xen_check_type(Xen_is_GtkSpinner_(spinner), spinner, 1, "gtk_spinner_start", "GtkSpinner*");
  gtk_spinner_start(Xen_to_C_GtkSpinner_(spinner));
  return(Xen_false);
}

static Xen gxg_gtk_spinner_stop(Xen spinner)
{
  #define H_gtk_spinner_stop "void gtk_spinner_stop(GtkSpinner* spinner)"
  Xen_check_type(Xen_is_GtkSpinner_(spinner), spinner, 1, "gtk_spinner_stop", "GtkSpinner*");
  gtk_spinner_stop(Xen_to_C_GtkSpinner_(spinner));
  return(Xen_false);
}

static Xen gxg_gtk_cell_renderer_spinner_new(void)
{
  #define H_gtk_cell_renderer_spinner_new "GtkCellRenderer* gtk_cell_renderer_spinner_new( void)"
  return(C_to_Xen_GtkCellRenderer_(gtk_cell_renderer_spinner_new()));
}

static Xen gxg_gtk_notebook_get_action_widget(Xen notebook, Xen pack_type)
{
  #define H_gtk_notebook_get_action_widget "GtkWidget* gtk_notebook_get_action_widget(GtkNotebook* notebook, \
GtkPackType pack_type)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_action_widget", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkPackType(pack_type), pack_type, 2, "gtk_notebook_get_action_widget", "GtkPackType");
  return(C_to_Xen_GtkWidget_(gtk_notebook_get_action_widget(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkPackType(pack_type))));
}

static Xen gxg_gtk_notebook_set_action_widget(Xen notebook, Xen widget, Xen pack_type)
{
  #define H_gtk_notebook_set_action_widget "void gtk_notebook_set_action_widget(GtkNotebook* notebook, \
GtkWidget* widget, GtkPackType pack_type)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_action_widget", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_notebook_set_action_widget", "GtkWidget*");
  Xen_check_type(Xen_is_GtkPackType(pack_type), pack_type, 3, "gtk_notebook_set_action_widget", "GtkPackType");
  gtk_notebook_set_action_widget(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkPackType(pack_type));
  return(Xen_false);
}

static Xen gxg_gtk_statusbar_get_message_area(Xen statusbar)
{
  #define H_gtk_statusbar_get_message_area "GtkWidget* gtk_statusbar_get_message_area(GtkStatusbar* statusbar)"
  Xen_check_type(Xen_is_GtkStatusbar_(statusbar), statusbar, 1, "gtk_statusbar_get_message_area", "GtkStatusbar*");
  return(C_to_Xen_GtkWidget_(gtk_statusbar_get_message_area(Xen_to_C_GtkStatusbar_(statusbar))));
}

static Xen gxg_gtk_tool_item_get_ellipsize_mode(Xen tool_item)
{
  #define H_gtk_tool_item_get_ellipsize_mode "PangoEllipsizeMode gtk_tool_item_get_ellipsize_mode(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_ellipsize_mode", "GtkToolItem*");
  return(C_to_Xen_PangoEllipsizeMode(gtk_tool_item_get_ellipsize_mode(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_get_text_alignment(Xen tool_item)
{
  #define H_gtk_tool_item_get_text_alignment "gfloat gtk_tool_item_get_text_alignment(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_text_alignment", "GtkToolItem*");
  return(C_to_Xen_gfloat(gtk_tool_item_get_text_alignment(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_get_text_orientation(Xen tool_item)
{
  #define H_gtk_tool_item_get_text_orientation "GtkOrientation gtk_tool_item_get_text_orientation(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_text_orientation", "GtkToolItem*");
  return(C_to_Xen_GtkOrientation(gtk_tool_item_get_text_orientation(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_item_get_text_size_group(Xen tool_item)
{
  #define H_gtk_tool_item_get_text_size_group "GtkSizeGroup* gtk_tool_item_get_text_size_group(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_get_text_size_group", "GtkToolItem*");
  return(C_to_Xen_GtkSizeGroup_(gtk_tool_item_get_text_size_group(Xen_to_C_GtkToolItem_(tool_item))));
}

static Xen gxg_gtk_tool_palette_new(void)
{
  #define H_gtk_tool_palette_new "GtkWidget* gtk_tool_palette_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_tool_palette_new()));
}

static Xen gxg_gtk_tool_palette_set_group_position(Xen palette, Xen group, Xen position)
{
  #define H_gtk_tool_palette_set_group_position "void gtk_tool_palette_set_group_position(GtkToolPalette* palette, \
GtkToolItemGroup* group, gint position)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_set_group_position", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 2, "gtk_tool_palette_set_group_position", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_tool_palette_set_group_position", "gint");
  gtk_tool_palette_set_group_position(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_tool_palette_set_exclusive(Xen palette, Xen group, Xen exclusive)
{
  #define H_gtk_tool_palette_set_exclusive "void gtk_tool_palette_set_exclusive(GtkToolPalette* palette, \
GtkToolItemGroup* group, gboolean exclusive)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_set_exclusive", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 2, "gtk_tool_palette_set_exclusive", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_gboolean(exclusive), exclusive, 3, "gtk_tool_palette_set_exclusive", "gboolean");
  gtk_tool_palette_set_exclusive(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_gboolean(exclusive));
  return(Xen_false);
}

static Xen gxg_gtk_tool_palette_set_expand(Xen palette, Xen group, Xen expand)
{
  #define H_gtk_tool_palette_set_expand "void gtk_tool_palette_set_expand(GtkToolPalette* palette, GtkToolItemGroup* group, \
gboolean expand)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_set_expand", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 2, "gtk_tool_palette_set_expand", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 3, "gtk_tool_palette_set_expand", "gboolean");
  gtk_tool_palette_set_expand(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_tool_palette_get_group_position(Xen palette, Xen group)
{
  #define H_gtk_tool_palette_get_group_position "gint gtk_tool_palette_get_group_position(GtkToolPalette* palette, \
GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_group_position", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 2, "gtk_tool_palette_get_group_position", "GtkToolItemGroup*");
  return(C_to_Xen_gint(gtk_tool_palette_get_group_position(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_palette_get_exclusive(Xen palette, Xen group)
{
  #define H_gtk_tool_palette_get_exclusive "gboolean gtk_tool_palette_get_exclusive(GtkToolPalette* palette, \
GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_exclusive", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 2, "gtk_tool_palette_get_exclusive", "GtkToolItemGroup*");
  return(C_to_Xen_gboolean(gtk_tool_palette_get_exclusive(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_palette_get_expand(Xen palette, Xen group)
{
  #define H_gtk_tool_palette_get_expand "gboolean gtk_tool_palette_get_expand(GtkToolPalette* palette, \
GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_expand", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 2, "gtk_tool_palette_get_expand", "GtkToolItemGroup*");
  return(C_to_Xen_gboolean(gtk_tool_palette_get_expand(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_palette_set_style(Xen palette, Xen style)
{
  #define H_gtk_tool_palette_set_style "void gtk_tool_palette_set_style(GtkToolPalette* palette, GtkToolbarStyle style)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_set_style", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolbarStyle(style), style, 2, "gtk_tool_palette_set_style", "GtkToolbarStyle");
  gtk_tool_palette_set_style(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolbarStyle(style));
  return(Xen_false);
}

static Xen gxg_gtk_tool_palette_unset_style(Xen palette)
{
  #define H_gtk_tool_palette_unset_style "void gtk_tool_palette_unset_style(GtkToolPalette* palette)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_unset_style", "GtkToolPalette*");
  gtk_tool_palette_unset_style(Xen_to_C_GtkToolPalette_(palette));
  return(Xen_false);
}

static Xen gxg_gtk_tool_palette_get_style(Xen palette)
{
  #define H_gtk_tool_palette_get_style "GtkToolbarStyle gtk_tool_palette_get_style(GtkToolPalette* palette)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_style", "GtkToolPalette*");
  return(C_to_Xen_GtkToolbarStyle(gtk_tool_palette_get_style(Xen_to_C_GtkToolPalette_(palette))));
}

static Xen gxg_gtk_tool_palette_get_drop_item(Xen palette, Xen x, Xen y)
{
  #define H_gtk_tool_palette_get_drop_item "GtkToolItem* gtk_tool_palette_get_drop_item(GtkToolPalette* palette, \
gint x, gint y)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_drop_item", "GtkToolPalette*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_tool_palette_get_drop_item", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_tool_palette_get_drop_item", "gint");
  return(C_to_Xen_GtkToolItem_(gtk_tool_palette_get_drop_item(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_tool_palette_get_drop_group(Xen palette, Xen x, Xen y)
{
  #define H_gtk_tool_palette_get_drop_group "GtkToolItemGroup* gtk_tool_palette_get_drop_group(GtkToolPalette* palette, \
gint x, gint y)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_drop_group", "GtkToolPalette*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_tool_palette_get_drop_group", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_tool_palette_get_drop_group", "gint");
  return(C_to_Xen_GtkToolItemGroup_(gtk_tool_palette_get_drop_group(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_gint(x), 
                                                                    Xen_to_C_gint(y))));
}

static Xen gxg_gtk_tool_palette_get_drag_item(Xen palette, Xen selection)
{
  #define H_gtk_tool_palette_get_drag_item "GtkWidget* gtk_tool_palette_get_drag_item(GtkToolPalette* palette, \
GtkSelectionData* selection)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_get_drag_item", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkSelectionData_(selection), selection, 2, "gtk_tool_palette_get_drag_item", "GtkSelectionData*");
  return(C_to_Xen_GtkWidget_(gtk_tool_palette_get_drag_item(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkSelectionData_(selection))));
}

static Xen gxg_gtk_tool_palette_set_drag_source(Xen palette, Xen targets)
{
  #define H_gtk_tool_palette_set_drag_source "void gtk_tool_palette_set_drag_source(GtkToolPalette* palette, \
GtkToolPaletteDragTargets targets)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_set_drag_source", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkToolPaletteDragTargets(targets), targets, 2, "gtk_tool_palette_set_drag_source", "GtkToolPaletteDragTargets");
  gtk_tool_palette_set_drag_source(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkToolPaletteDragTargets(targets));
  return(Xen_false);
}

static Xen gxg_gtk_tool_palette_add_drag_dest(Xen palette, Xen widget, Xen flags, Xen targets, Xen actions)
{
  #define H_gtk_tool_palette_add_drag_dest "void gtk_tool_palette_add_drag_dest(GtkToolPalette* palette, \
GtkWidget* widget, GtkDestDefaults flags, GtkToolPaletteDragTargets targets, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkToolPalette_(palette), palette, 1, "gtk_tool_palette_add_drag_dest", "GtkToolPalette*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_tool_palette_add_drag_dest", "GtkWidget*");
  Xen_check_type(Xen_is_GtkDestDefaults(flags), flags, 3, "gtk_tool_palette_add_drag_dest", "GtkDestDefaults");
  Xen_check_type(Xen_is_GtkToolPaletteDragTargets(targets), targets, 4, "gtk_tool_palette_add_drag_dest", "GtkToolPaletteDragTargets");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 5, "gtk_tool_palette_add_drag_dest", "GdkDragAction");
  gtk_tool_palette_add_drag_dest(Xen_to_C_GtkToolPalette_(palette), Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkDestDefaults(flags), 
                                 Xen_to_C_GtkToolPaletteDragTargets(targets), Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_new(Xen label)
{
  #define H_gtk_tool_item_group_new "GtkWidget* gtk_tool_item_group_new(gchar* label)"
  Xen_check_type(Xen_is_gchar_(label), label, 1, "gtk_tool_item_group_new", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_tool_item_group_new((const gchar*)Xen_to_C_gchar_(label))));
}

static Xen gxg_gtk_tool_item_group_set_label(Xen group, Xen label)
{
  #define H_gtk_tool_item_group_set_label "void gtk_tool_item_group_set_label(GtkToolItemGroup* group, \
gchar* label)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_set_label", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_gchar_(label), label, 2, "gtk_tool_item_group_set_label", "gchar*");
  gtk_tool_item_group_set_label(Xen_to_C_GtkToolItemGroup_(group), (const gchar*)Xen_to_C_gchar_(label));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_set_label_widget(Xen group, Xen label_widget)
{
  #define H_gtk_tool_item_group_set_label_widget "void gtk_tool_item_group_set_label_widget(GtkToolItemGroup* group, \
GtkWidget* label_widget)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_set_label_widget", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_GtkWidget_(label_widget), label_widget, 2, "gtk_tool_item_group_set_label_widget", "GtkWidget*");
  gtk_tool_item_group_set_label_widget(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_GtkWidget_(label_widget));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_set_collapsed(Xen group, Xen collapsed)
{
  #define H_gtk_tool_item_group_set_collapsed "void gtk_tool_item_group_set_collapsed(GtkToolItemGroup* group, \
gboolean collapsed)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_set_collapsed", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_gboolean(collapsed), collapsed, 2, "gtk_tool_item_group_set_collapsed", "gboolean");
  gtk_tool_item_group_set_collapsed(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_gboolean(collapsed));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_set_ellipsize(Xen group, Xen ellipsize)
{
  #define H_gtk_tool_item_group_set_ellipsize "void gtk_tool_item_group_set_ellipsize(GtkToolItemGroup* group, \
PangoEllipsizeMode ellipsize)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_set_ellipsize", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_PangoEllipsizeMode(ellipsize), ellipsize, 2, "gtk_tool_item_group_set_ellipsize", "PangoEllipsizeMode");
  gtk_tool_item_group_set_ellipsize(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_PangoEllipsizeMode(ellipsize));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_set_header_relief(Xen group, Xen style)
{
  #define H_gtk_tool_item_group_set_header_relief "void gtk_tool_item_group_set_header_relief(GtkToolItemGroup* group, \
GtkReliefStyle style)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_set_header_relief", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_GtkReliefStyle(style), style, 2, "gtk_tool_item_group_set_header_relief", "GtkReliefStyle");
  gtk_tool_item_group_set_header_relief(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_GtkReliefStyle(style));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_get_label(Xen group)
{
  #define H_gtk_tool_item_group_get_label "gchar* gtk_tool_item_group_get_label(GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_label", "GtkToolItemGroup*");
  return(C_to_Xen_gchar_(gtk_tool_item_group_get_label(Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_item_group_get_label_widget(Xen group)
{
  #define H_gtk_tool_item_group_get_label_widget "GtkWidget* gtk_tool_item_group_get_label_widget(GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_label_widget", "GtkToolItemGroup*");
  return(C_to_Xen_GtkWidget_(gtk_tool_item_group_get_label_widget(Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_item_group_get_collapsed(Xen group)
{
  #define H_gtk_tool_item_group_get_collapsed "gboolean gtk_tool_item_group_get_collapsed(GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_collapsed", "GtkToolItemGroup*");
  return(C_to_Xen_gboolean(gtk_tool_item_group_get_collapsed(Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_item_group_get_ellipsize(Xen group)
{
  #define H_gtk_tool_item_group_get_ellipsize "PangoEllipsizeMode gtk_tool_item_group_get_ellipsize(GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_ellipsize", "GtkToolItemGroup*");
  return(C_to_Xen_PangoEllipsizeMode(gtk_tool_item_group_get_ellipsize(Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_item_group_get_header_relief(Xen group)
{
  #define H_gtk_tool_item_group_get_header_relief "GtkReliefStyle gtk_tool_item_group_get_header_relief(GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_header_relief", "GtkToolItemGroup*");
  return(C_to_Xen_GtkReliefStyle(gtk_tool_item_group_get_header_relief(Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_item_group_insert(Xen group, Xen item, Xen position)
{
  #define H_gtk_tool_item_group_insert "void gtk_tool_item_group_insert(GtkToolItemGroup* group, GtkToolItem* item, \
gint position)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_insert", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_GtkToolItem_(item), item, 2, "gtk_tool_item_group_insert", "GtkToolItem*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_tool_item_group_insert", "gint");
  gtk_tool_item_group_insert(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_GtkToolItem_(item), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_set_item_position(Xen group, Xen item, Xen position)
{
  #define H_gtk_tool_item_group_set_item_position "void gtk_tool_item_group_set_item_position(GtkToolItemGroup* group, \
GtkToolItem* item, gint position)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_set_item_position", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_GtkToolItem_(item), item, 2, "gtk_tool_item_group_set_item_position", "GtkToolItem*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_tool_item_group_set_item_position", "gint");
  gtk_tool_item_group_set_item_position(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_GtkToolItem_(item), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_group_get_item_position(Xen group, Xen item)
{
  #define H_gtk_tool_item_group_get_item_position "gint gtk_tool_item_group_get_item_position(GtkToolItemGroup* group, \
GtkToolItem* item)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_item_position", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_GtkToolItem_(item), item, 2, "gtk_tool_item_group_get_item_position", "GtkToolItem*");
  return(C_to_Xen_gint(gtk_tool_item_group_get_item_position(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_GtkToolItem_(item))));
}

static Xen gxg_gtk_tool_item_group_get_n_items(Xen group)
{
  #define H_gtk_tool_item_group_get_n_items "guint gtk_tool_item_group_get_n_items(GtkToolItemGroup* group)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_n_items", "GtkToolItemGroup*");
  return(C_to_Xen_guint(gtk_tool_item_group_get_n_items(Xen_to_C_GtkToolItemGroup_(group))));
}

static Xen gxg_gtk_tool_item_group_get_nth_item(Xen group, Xen index)
{
  #define H_gtk_tool_item_group_get_nth_item "GtkToolItem* gtk_tool_item_group_get_nth_item(GtkToolItemGroup* group, \
guint index)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_nth_item", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_guint(index), index, 2, "gtk_tool_item_group_get_nth_item", "guint");
  return(C_to_Xen_GtkToolItem_(gtk_tool_item_group_get_nth_item(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_guint(index))));
}

static Xen gxg_gtk_tool_item_group_get_drop_item(Xen group, Xen x, Xen y)
{
  #define H_gtk_tool_item_group_get_drop_item "GtkToolItem* gtk_tool_item_group_get_drop_item(GtkToolItemGroup* group, \
gint x, gint y)"
  Xen_check_type(Xen_is_GtkToolItemGroup_(group), group, 1, "gtk_tool_item_group_get_drop_item", "GtkToolItemGroup*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_tool_item_group_get_drop_item", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_tool_item_group_get_drop_item", "gint");
  return(C_to_Xen_GtkToolItem_(gtk_tool_item_group_get_drop_item(Xen_to_C_GtkToolItemGroup_(group), Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_window_set_mnemonics_visible(Xen window, Xen setting)
{
  #define H_gtk_window_set_mnemonics_visible "void gtk_window_set_mnemonics_visible(GtkWindow* window, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_mnemonics_visible", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_mnemonics_visible", "gboolean");
  gtk_window_set_mnemonics_visible(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_mnemonics_visible(Xen window)
{
  #define H_gtk_window_get_mnemonics_visible "gboolean gtk_window_get_mnemonics_visible(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_mnemonics_visible", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_mnemonics_visible(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_range_set_slider_size_fixed(Xen range, Xen size_fixed)
{
  #define H_gtk_range_set_slider_size_fixed "void gtk_range_set_slider_size_fixed(GtkRange* range, gboolean size_fixed)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_set_slider_size_fixed", "GtkRange*");
  Xen_check_type(Xen_is_gboolean(size_fixed), size_fixed, 2, "gtk_range_set_slider_size_fixed", "gboolean");
  gtk_range_set_slider_size_fixed(Xen_to_C_GtkRange_(range), Xen_to_C_gboolean(size_fixed));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_slider_size_fixed(Xen range)
{
  #define H_gtk_range_get_slider_size_fixed "gboolean gtk_range_get_slider_size_fixed(GtkRange* range)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_slider_size_fixed", "GtkRange*");
  return(C_to_Xen_gboolean(gtk_range_get_slider_size_fixed(Xen_to_C_GtkRange_(range))));
}

static Xen gxg_gtk_range_get_range_rect(Xen range, Xen range_rect)
{
  #define H_gtk_range_get_range_rect "void gtk_range_get_range_rect(GtkRange* range, GdkRectangle* range_rect)"
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_range_rect", "GtkRange*");
  Xen_check_type(Xen_is_GdkRectangle_(range_rect), range_rect, 2, "gtk_range_get_range_rect", "GdkRectangle*");
  gtk_range_get_range_rect(Xen_to_C_GtkRange_(range), Xen_to_C_GdkRectangle_(range_rect));
  return(Xen_false);
}

static Xen gxg_gtk_range_get_slider_range(Xen range, Xen ignore_slider_start, Xen ignore_slider_end)
{
  #define H_gtk_range_get_slider_range "void gtk_range_get_slider_range(GtkRange* range, gint* [slider_start], \
gint* [slider_end])"
  gint ref_slider_start;
  gint ref_slider_end;
  Xen_check_type(Xen_is_GtkRange_(range), range, 1, "gtk_range_get_slider_range", "GtkRange*");
  gtk_range_get_slider_range(Xen_to_C_GtkRange_(range), &ref_slider_start, &ref_slider_end);
  return(Xen_list_2(C_to_Xen_gint(ref_slider_start), C_to_Xen_gint(ref_slider_end)));
}

static Xen gxg_gtk_widget_set_realized(Xen widget, Xen realized)
{
  #define H_gtk_widget_set_realized "void gtk_widget_set_realized(GtkWidget* widget, gboolean realized)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_realized", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(realized), realized, 2, "gtk_widget_set_realized", "gboolean");
  gtk_widget_set_realized(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(realized));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_realized(Xen widget)
{
  #define H_gtk_widget_get_realized "gboolean gtk_widget_get_realized(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_realized", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_realized(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_mapped(Xen widget)
{
  #define H_gtk_widget_get_mapped "gboolean gtk_widget_get_mapped(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_mapped", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_mapped(Xen_to_C_GtkWidget_(widget))));
}

#endif

#if GTK_CHECK_VERSION(3, 0, 0)
static Xen gxg_gdk_window_get_geometry(Xen window, Xen ignore_x, Xen ignore_y, Xen ignore_width, Xen ignore_height)
{
  #define H_gdk_window_get_geometry "void gdk_window_get_geometry(GdkWindow* window, gint* [x], gint* [y], \
gint* [width], gint* [height])"
  gint ref_x;
  gint ref_y;
  gint ref_width;
  gint ref_height;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_geometry", "GdkWindow*");
  gdk_window_get_geometry(Xen_to_C_GdkWindow_(window), &ref_x, &ref_y, &ref_width, &ref_height);
  return(Xen_list_4(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y), C_to_Xen_gint(ref_width), C_to_Xen_gint(ref_height)));
}

static Xen gxg_gdk_keymap_add_virtual_modifiers(Xen keymap, Xen state)
{
  #define H_gdk_keymap_add_virtual_modifiers "void gdk_keymap_add_virtual_modifiers(GdkKeymap* keymap, \
GdkModifierType* state)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_add_virtual_modifiers", "GdkKeymap*");
  Xen_check_type(Xen_is_GdkModifierType_(state), state, 2, "gdk_keymap_add_virtual_modifiers", "GdkModifierType*");
  gdk_keymap_add_virtual_modifiers(Xen_to_C_GdkKeymap_(keymap), Xen_to_C_GdkModifierType_(state));
  return(Xen_false);
}

static Xen gxg_gdk_window_coords_to_parent(Xen window, Xen x, Xen y, Xen ignore_parent_x, Xen ignore_parent_y)
{
  #define H_gdk_window_coords_to_parent "void gdk_window_coords_to_parent(GdkWindow* window, gdouble x, \
gdouble y, gdouble* [parent_x], gdouble* [parent_y])"
  gdouble ref_parent_x;
  gdouble ref_parent_y;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_coords_to_parent", "GdkWindow*");
  Xen_check_type(Xen_is_gdouble(x), x, 2, "gdk_window_coords_to_parent", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 3, "gdk_window_coords_to_parent", "gdouble");
  gdk_window_coords_to_parent(Xen_to_C_GdkWindow_(window), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), &ref_parent_x, &ref_parent_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_parent_x), C_to_Xen_gdouble(ref_parent_y)));
}

static Xen gxg_gdk_window_coords_from_parent(Xen window, Xen parent_x, Xen parent_y, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_window_coords_from_parent "void gdk_window_coords_from_parent(GdkWindow* window, gdouble parent_x, \
gdouble parent_y, gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_coords_from_parent", "GdkWindow*");
  Xen_check_type(Xen_is_gdouble(parent_x), parent_x, 2, "gdk_window_coords_from_parent", "gdouble");
  Xen_check_type(Xen_is_gdouble(parent_y), parent_y, 3, "gdk_window_coords_from_parent", "gdouble");
  gdk_window_coords_from_parent(Xen_to_C_GdkWindow_(window), Xen_to_C_gdouble(parent_x), Xen_to_C_gdouble(parent_y), &ref_x, 
                                &ref_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
}

static Xen gxg_gtk_accessible_get_widget(Xen accessible)
{
  #define H_gtk_accessible_get_widget "GtkWidget* gtk_accessible_get_widget(GtkAccessible* accessible)"
  Xen_check_type(Xen_is_GtkAccessible_(accessible), accessible, 1, "gtk_accessible_get_widget", "GtkAccessible*");
  return(C_to_Xen_GtkWidget_(gtk_accessible_get_widget(Xen_to_C_GtkAccessible_(accessible))));
}

static Xen gxg_gtk_widget_send_focus_change(Xen widget, Xen event)
{
  #define H_gtk_widget_send_focus_change "gboolean gtk_widget_send_focus_change(GtkWidget* widget, GdkEvent* event)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_send_focus_change", "GtkWidget*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_widget_send_focus_change", "GdkEvent*");
  return(C_to_Xen_gboolean(gtk_widget_send_focus_change(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_drag_context_get_device(Xen context)
{
  #define H_gdk_drag_context_get_device "GdkDevice* gdk_drag_context_get_device(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_context_get_device", "GdkDragContext*");
  return(C_to_Xen_GdkDevice_(gdk_drag_context_get_device(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gdk_event_set_device(Xen event, Xen device)
{
  #define H_gdk_event_set_device "void gdk_event_set_device(GdkEvent* event, GdkDevice* device)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_set_device", "GdkEvent*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_event_set_device", "GdkDevice*");
  gdk_event_set_device(Xen_to_C_GdkEvent_(event), Xen_to_C_GdkDevice_(device));
  return(Xen_false);
}

static Xen gxg_gdk_event_get_device(Xen event)
{
  #define H_gdk_event_get_device "GdkDevice* gdk_event_get_device(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_device", "GdkEvent*");
  return(C_to_Xen_GdkDevice_(gdk_event_get_device(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_events_get_distance(Xen event1, Xen event2, Xen ignore_distance)
{
  #define H_gdk_events_get_distance "gboolean gdk_events_get_distance(GdkEvent* event1, GdkEvent* event2, \
gdouble* [distance])"
  gdouble ref_distance;
  Xen_check_type(Xen_is_GdkEvent_(event1), event1, 1, "gdk_events_get_distance", "GdkEvent*");
  Xen_check_type(Xen_is_GdkEvent_(event2), event2, 2, "gdk_events_get_distance", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_events_get_distance(Xen_to_C_GdkEvent_(event1), Xen_to_C_GdkEvent_(event2), &ref_distance));
    return(Xen_list_2(result, C_to_Xen_gdouble(ref_distance)));
   }
}

static Xen gxg_gdk_events_get_angle(Xen event1, Xen event2, Xen ignore_angle)
{
  #define H_gdk_events_get_angle "gboolean gdk_events_get_angle(GdkEvent* event1, GdkEvent* event2, gdouble* [angle])"
  gdouble ref_angle;
  Xen_check_type(Xen_is_GdkEvent_(event1), event1, 1, "gdk_events_get_angle", "GdkEvent*");
  Xen_check_type(Xen_is_GdkEvent_(event2), event2, 2, "gdk_events_get_angle", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_events_get_angle(Xen_to_C_GdkEvent_(event1), Xen_to_C_GdkEvent_(event2), &ref_angle));
    return(Xen_list_2(result, C_to_Xen_gdouble(ref_angle)));
   }
}

static Xen gxg_gdk_events_get_center(Xen event1, Xen event2, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_events_get_center "gboolean gdk_events_get_center(GdkEvent* event1, GdkEvent* event2, \
gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GdkEvent_(event1), event1, 1, "gdk_events_get_center", "GdkEvent*");
  Xen_check_type(Xen_is_GdkEvent_(event2), event2, 2, "gdk_events_get_center", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_events_get_center(Xen_to_C_GdkEvent_(event1), Xen_to_C_GdkEvent_(event2), &ref_x, &ref_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
   }
}

static Xen gxg_gdk_window_get_accept_focus(Xen window)
{
  #define H_gdk_window_get_accept_focus "gboolean gdk_window_get_accept_focus(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_accept_focus", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_get_accept_focus(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_focus_on_map(Xen window)
{
  #define H_gdk_window_get_focus_on_map "gboolean gdk_window_get_focus_on_map(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_focus_on_map", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_get_focus_on_map(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_is_input_only(Xen window)
{
  #define H_gdk_window_is_input_only "gboolean gdk_window_is_input_only(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_is_input_only", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_is_input_only(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_is_shaped(Xen window)
{
  #define H_gdk_window_is_shaped "gboolean gdk_window_is_shaped(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_is_shaped", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_is_shaped(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_modal_hint(Xen window)
{
  #define H_gdk_window_get_modal_hint "gboolean gdk_window_get_modal_hint(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_modal_hint", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_get_modal_hint(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_set_device_cursor(Xen window, Xen device, Xen cursor)
{
  #define H_gdk_window_set_device_cursor "void gdk_window_set_device_cursor(GdkWindow* window, GdkDevice* device, \
GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_device_cursor", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_set_device_cursor", "GdkDevice*");
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 3, "gdk_window_set_device_cursor", "GdkCursor*");
  gdk_window_set_device_cursor(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device), Xen_to_C_GdkCursor_(cursor));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_device_cursor(Xen window, Xen device)
{
  #define H_gdk_window_get_device_cursor "GdkCursor* gdk_window_get_device_cursor(GdkWindow* window, \
GdkDevice* device)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_device_cursor", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_get_device_cursor", "GdkDevice*");
  return(C_to_Xen_GdkCursor_(gdk_window_get_device_cursor(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gdk_window_get_device_position(Xen window, Xen device, Xen ignore_x, Xen ignore_y, Xen ignore_mask)
{
  #define H_gdk_window_get_device_position "GdkWindow* gdk_window_get_device_position(GdkWindow* window, \
GdkDevice* device, gint* [x], gint* [y], GdkModifierType* [mask])"
  gint ref_x;
  gint ref_y;
  GdkModifierType ref_mask;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_device_position", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_get_device_position", "GdkDevice*");
  {
    Xen result;
    result = C_to_Xen_GdkWindow_(gdk_window_get_device_position(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device), 
                                                                &ref_x, &ref_y, &ref_mask));
    return(Xen_list_4(result, C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y), C_to_Xen_GdkModifierType(ref_mask)));
   }
}

static Xen gxg_gdk_window_set_device_events(Xen window, Xen device, Xen event_mask)
{
  #define H_gdk_window_set_device_events "void gdk_window_set_device_events(GdkWindow* window, GdkDevice* device, \
GdkEventMask event_mask)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_device_events", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_set_device_events", "GdkDevice*");
  Xen_check_type(Xen_is_GdkEventMask(event_mask), event_mask, 3, "gdk_window_set_device_events", "GdkEventMask");
  gdk_window_set_device_events(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device), Xen_to_C_GdkEventMask(event_mask));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_device_events(Xen window, Xen device)
{
  #define H_gdk_window_get_device_events "GdkEventMask gdk_window_get_device_events(GdkWindow* window, \
GdkDevice* device)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_device_events", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_get_device_events", "GdkDevice*");
  return(C_to_Xen_GdkEventMask(gdk_window_get_device_events(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gtk_combo_box_popup_for_device(Xen combo_box, Xen device)
{
  #define H_gtk_combo_box_popup_for_device "void gtk_combo_box_popup_for_device(GtkComboBox* combo_box, \
GdkDevice* device)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_popup_for_device", "GtkComboBox*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gtk_combo_box_popup_for_device", "GdkDevice*");
  gtk_combo_box_popup_for_device(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_GdkDevice_(device));
  return(Xen_false);
}

static Xen gxg_gtk_device_grab_add(Xen widget, Xen device, Xen block_others)
{
  #define H_gtk_device_grab_add "void gtk_device_grab_add(GtkWidget* widget, GdkDevice* device, gboolean block_others)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_device_grab_add", "GtkWidget*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gtk_device_grab_add", "GdkDevice*");
  Xen_check_type(Xen_is_gboolean(block_others), block_others, 3, "gtk_device_grab_add", "gboolean");
  gtk_device_grab_add(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkDevice_(device), Xen_to_C_gboolean(block_others));
  return(Xen_false);
}

static Xen gxg_gtk_device_grab_remove(Xen widget, Xen device)
{
  #define H_gtk_device_grab_remove "void gtk_device_grab_remove(GtkWidget* widget, GdkDevice* device)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_device_grab_remove", "GtkWidget*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gtk_device_grab_remove", "GdkDevice*");
  gtk_device_grab_remove(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkDevice_(device));
  return(Xen_false);
}

static Xen gxg_gtk_get_current_event_device(void)
{
  #define H_gtk_get_current_event_device "GdkDevice* gtk_get_current_event_device( void)"
  return(C_to_Xen_GdkDevice_(gtk_get_current_event_device()));
}

static Xen gxg_gtk_paned_new(Xen orientation)
{
  #define H_gtk_paned_new "GtkWidget* gtk_paned_new(GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_paned_new", "GtkOrientation");
  return(C_to_Xen_GtkWidget_(gtk_paned_new(Xen_to_C_GtkOrientation(orientation))));
}

static Xen gxg_gtk_scale_new(Xen orientation, Xen adjustment)
{
  #define H_gtk_scale_new "GtkWidget* gtk_scale_new(GtkOrientation orientation, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_scale_new", "GtkOrientation");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_scale_new", "GtkAdjustment*");
  return(C_to_Xen_GtkWidget_(gtk_scale_new(Xen_to_C_GtkOrientation(orientation), Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_scale_new_with_range(Xen orientation, Xen min, Xen max, Xen step)
{
  #define H_gtk_scale_new_with_range "GtkWidget* gtk_scale_new_with_range(GtkOrientation orientation, \
gdouble min, gdouble max, gdouble step)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_scale_new_with_range", "GtkOrientation");
  Xen_check_type(Xen_is_gdouble(min), min, 2, "gtk_scale_new_with_range", "gdouble");
  Xen_check_type(Xen_is_gdouble(max), max, 3, "gtk_scale_new_with_range", "gdouble");
  Xen_check_type(Xen_is_gdouble(step), step, 4, "gtk_scale_new_with_range", "gdouble");
  return(C_to_Xen_GtkWidget_(gtk_scale_new_with_range(Xen_to_C_GtkOrientation(orientation), Xen_to_C_gdouble(min), Xen_to_C_gdouble(max), 
                                                      Xen_to_C_gdouble(step))));
}

static Xen gxg_gtk_scrollbar_new(Xen orientation, Xen adjustment)
{
  #define H_gtk_scrollbar_new "GtkWidget* gtk_scrollbar_new(GtkOrientation orientation, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_scrollbar_new", "GtkOrientation");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_scrollbar_new", "GtkAdjustment*");
  return(C_to_Xen_GtkWidget_(gtk_scrollbar_new(Xen_to_C_GtkOrientation(orientation), Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_separator_new(Xen orientation)
{
  #define H_gtk_separator_new "GtkWidget* gtk_separator_new(GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_separator_new", "GtkOrientation");
  return(C_to_Xen_GtkWidget_(gtk_separator_new(Xen_to_C_GtkOrientation(orientation))));
}

static Xen gxg_gtk_widget_device_is_shadowed(Xen widget, Xen device)
{
  #define H_gtk_widget_device_is_shadowed "gboolean gtk_widget_device_is_shadowed(GtkWidget* widget, \
GdkDevice* device)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_device_is_shadowed", "GtkWidget*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gtk_widget_device_is_shadowed", "GdkDevice*");
  return(C_to_Xen_gboolean(gtk_widget_device_is_shadowed(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gtk_widget_get_support_multidevice(Xen widget)
{
  #define H_gtk_widget_get_support_multidevice "gboolean gtk_widget_get_support_multidevice(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_support_multidevice", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_support_multidevice(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_support_multidevice(Xen widget, Xen support_multidevice)
{
  #define H_gtk_widget_set_support_multidevice "void gtk_widget_set_support_multidevice(GtkWidget* widget, \
gboolean support_multidevice)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_support_multidevice", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(support_multidevice), support_multidevice, 2, "gtk_widget_set_support_multidevice", "gboolean");
  gtk_widget_set_support_multidevice(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(support_multidevice));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_item_row(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_get_item_row "gint gtk_icon_view_get_item_row(GtkIconView* icon_view, GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_item_row", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_get_item_row", "GtkTreePath*");
  return(C_to_Xen_gint(gtk_icon_view_get_item_row(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_icon_view_get_item_column(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_get_item_column "gint gtk_icon_view_get_item_column(GtkIconView* icon_view, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_item_column", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_get_item_column", "GtkTreePath*");
  return(C_to_Xen_gint(gtk_icon_view_get_item_column(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_statusbar_remove_all(Xen statusbar, Xen context_id)
{
  #define H_gtk_statusbar_remove_all "void gtk_statusbar_remove_all(GtkStatusbar* statusbar, guint context_id)"
  Xen_check_type(Xen_is_GtkStatusbar_(statusbar), statusbar, 1, "gtk_statusbar_remove_all", "GtkStatusbar*");
  Xen_check_type(Xen_is_guint(context_id), context_id, 2, "gtk_statusbar_remove_all", "guint");
  gtk_statusbar_remove_all(Xen_to_C_GtkStatusbar_(statusbar), Xen_to_C_guint(context_id));
  return(Xen_false);
}

static Xen gxg_gtk_window_has_group(Xen window)
{
  #define H_gtk_window_has_group "gboolean gtk_window_has_group(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_has_group", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_has_group(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_calendar_select_month(Xen calendar, Xen month, Xen year)
{
  #define H_gtk_calendar_select_month "void gtk_calendar_select_month(GtkCalendar* calendar, guint month, \
guint year)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_select_month", "GtkCalendar*");
  Xen_check_type(Xen_is_guint(month), month, 2, "gtk_calendar_select_month", "guint");
  Xen_check_type(Xen_is_guint(year), year, 3, "gtk_calendar_select_month", "guint");
  gtk_calendar_select_month(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_guint(month), Xen_to_C_guint(year));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_mark_day(Xen calendar, Xen day)
{
  #define H_gtk_calendar_mark_day "void gtk_calendar_mark_day(GtkCalendar* calendar, guint day)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_mark_day", "GtkCalendar*");
  Xen_check_type(Xen_is_guint(day), day, 2, "gtk_calendar_mark_day", "guint");
  gtk_calendar_mark_day(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_guint(day));
  return(Xen_false);
}

static Xen gxg_gtk_calendar_unmark_day(Xen calendar, Xen day)
{
  #define H_gtk_calendar_unmark_day "void gtk_calendar_unmark_day(GtkCalendar* calendar, guint day)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_unmark_day", "GtkCalendar*");
  Xen_check_type(Xen_is_guint(day), day, 2, "gtk_calendar_unmark_day", "guint");
  gtk_calendar_unmark_day(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_guint(day));
  return(Xen_false);
}

static Xen gxg_gdk_drag_context_get_source_window(Xen context)
{
  #define H_gdk_drag_context_get_source_window "GdkWindow* gdk_drag_context_get_source_window(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_context_get_source_window", "GdkDragContext*");
  return(C_to_Xen_GdkWindow_(gdk_drag_context_get_source_window(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gtk_accessible_set_widget(Xen accessible, Xen widget)
{
  #define H_gtk_accessible_set_widget "void gtk_accessible_set_widget(GtkAccessible* accessible, GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkAccessible_(accessible), accessible, 1, "gtk_accessible_set_widget", "GtkAccessible*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_accessible_set_widget", "GtkWidget*");
  gtk_accessible_set_widget(Xen_to_C_GtkAccessible_(accessible), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_message_dialog_get_message_area(Xen message_dialog)
{
  #define H_gtk_message_dialog_get_message_area "GtkWidget* gtk_message_dialog_get_message_area(GtkMessageDialog* message_dialog)"
  Xen_check_type(Xen_is_GtkMessageDialog_(message_dialog), message_dialog, 1, "gtk_message_dialog_get_message_area", "GtkMessageDialog*");
  return(C_to_Xen_GtkWidget_(gtk_message_dialog_get_message_area(Xen_to_C_GtkMessageDialog_(message_dialog))));
}

static Xen gxg_gtk_selection_data_get_length(Xen selection_data)
{
  #define H_gtk_selection_data_get_length "gint gtk_selection_data_get_length(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_length", "GtkSelectionData*");
  return(C_to_Xen_gint(gtk_selection_data_get_length(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gdk_pango_layout_line_get_clip_region(Xen line, Xen x_origin, Xen y_origin, Xen index_ranges, Xen n_ranges)
{
  #define H_gdk_pango_layout_line_get_clip_region "cairo_region_t* gdk_pango_layout_line_get_clip_region(PangoLayoutLine* line, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  Xen_check_type(Xen_is_PangoLayoutLine_(line), line, 1, "gdk_pango_layout_line_get_clip_region", "PangoLayoutLine*");
  Xen_check_type(Xen_is_gint(x_origin), x_origin, 2, "gdk_pango_layout_line_get_clip_region", "gint");
  Xen_check_type(Xen_is_gint(y_origin), y_origin, 3, "gdk_pango_layout_line_get_clip_region", "gint");
  Xen_check_type(Xen_is_gint_(index_ranges), index_ranges, 4, "gdk_pango_layout_line_get_clip_region", "gint*");
  Xen_check_type(Xen_is_gint(n_ranges), n_ranges, 5, "gdk_pango_layout_line_get_clip_region", "gint");
  return(C_to_Xen_cairo_region_t_(gdk_pango_layout_line_get_clip_region(Xen_to_C_PangoLayoutLine_(line), Xen_to_C_gint(x_origin), 
                                                                        Xen_to_C_gint(y_origin), Xen_to_C_gint_(index_ranges), 
                                                                        Xen_to_C_gint(n_ranges))));
}

static Xen gxg_gdk_pango_layout_get_clip_region(Xen layout, Xen x_origin, Xen y_origin, Xen index_ranges, Xen n_ranges)
{
  #define H_gdk_pango_layout_get_clip_region "cairo_region_t* gdk_pango_layout_get_clip_region(PangoLayout* layout, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 1, "gdk_pango_layout_get_clip_region", "PangoLayout*");
  Xen_check_type(Xen_is_gint(x_origin), x_origin, 2, "gdk_pango_layout_get_clip_region", "gint");
  Xen_check_type(Xen_is_gint(y_origin), y_origin, 3, "gdk_pango_layout_get_clip_region", "gint");
  Xen_check_type(Xen_is_gint_(index_ranges), index_ranges, 4, "gdk_pango_layout_get_clip_region", "gint*");
  Xen_check_type(Xen_is_gint(n_ranges), n_ranges, 5, "gdk_pango_layout_get_clip_region", "gint");
  return(C_to_Xen_cairo_region_t_(gdk_pango_layout_get_clip_region(Xen_to_C_PangoLayout_(layout), Xen_to_C_gint(x_origin), 
                                                                   Xen_to_C_gint(y_origin), Xen_to_C_gint_(index_ranges), 
                                                                   Xen_to_C_gint(n_ranges))));
}

static Xen gxg_gdk_window_shape_combine_region(Xen window, Xen shape_region, Xen offset_x, Xen offset_y)
{
  #define H_gdk_window_shape_combine_region "void gdk_window_shape_combine_region(GdkWindow* window, \
cairo_region_t* shape_region, gint offset_x, gint offset_y)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_shape_combine_region", "GdkWindow*");
  Xen_check_type(Xen_is_cairo_region_t_(shape_region), shape_region, 2, "gdk_window_shape_combine_region", "cairo_region_t*");
  Xen_check_type(Xen_is_gint(offset_x), offset_x, 3, "gdk_window_shape_combine_region", "gint");
  Xen_check_type(Xen_is_gint(offset_y), offset_y, 4, "gdk_window_shape_combine_region", "gint");
  gdk_window_shape_combine_region(Xen_to_C_GdkWindow_(window), Xen_to_C_cairo_region_t_(shape_region), Xen_to_C_gint(offset_x), 
                                  Xen_to_C_gint(offset_y));
  return(Xen_false);
}

static Xen gxg_gdk_window_invalidate_region(Xen window, Xen region, Xen invalidate_children)
{
  #define H_gdk_window_invalidate_region "void gdk_window_invalidate_region(GdkWindow* window, cairo_region_t* region, \
gboolean invalidate_children)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_invalidate_region", "GdkWindow*");
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 2, "gdk_window_invalidate_region", "cairo_region_t*");
  Xen_check_type(Xen_is_gboolean(invalidate_children), invalidate_children, 3, "gdk_window_invalidate_region", "gboolean");
  gdk_window_invalidate_region(Xen_to_C_GdkWindow_(window), Xen_to_C_cairo_region_t_(region), Xen_to_C_gboolean(invalidate_children));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_update_area(Xen window)
{
  #define H_gdk_window_get_update_area "cairo_region_t* gdk_window_get_update_area(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_update_area", "GdkWindow*");
  return(C_to_Xen_cairo_region_t_(gdk_window_get_update_area(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_move_region(Xen window, Xen region, Xen dx, Xen dy)
{
  #define H_gdk_window_move_region "void gdk_window_move_region(GdkWindow* window, cairo_region_t* region, \
gint dx, gint dy)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_move_region", "GdkWindow*");
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 2, "gdk_window_move_region", "cairo_region_t*");
  Xen_check_type(Xen_is_gint(dx), dx, 3, "gdk_window_move_region", "gint");
  Xen_check_type(Xen_is_gint(dy), dy, 4, "gdk_window_move_region", "gint");
  gdk_window_move_region(Xen_to_C_GdkWindow_(window), Xen_to_C_cairo_region_t_(region), Xen_to_C_gint(dx), Xen_to_C_gint(dy));
  return(Xen_false);
}

static Xen gxg_gdk_keymap_get_num_lock_state(Xen keymap)
{
  #define H_gdk_keymap_get_num_lock_state "gboolean gdk_keymap_get_num_lock_state(GdkKeymap* keymap)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_num_lock_state", "GdkKeymap*");
  return(C_to_Xen_gboolean(gdk_keymap_get_num_lock_state(Xen_to_C_GdkKeymap_(keymap))));
}

static Xen gxg_gdk_window_has_native(Xen window)
{
  #define H_gdk_window_has_native "gboolean gdk_window_has_native(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_has_native", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_has_native(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_display_is_closed(Xen display)
{
  #define H_gdk_display_is_closed "gboolean gdk_display_is_closed(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_is_closed", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_is_closed(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_window_create_similar_surface(Xen window, Xen content, Xen width, Xen height)
{
  #define H_gdk_window_create_similar_surface "cairo_surface_t* gdk_window_create_similar_surface(GdkWindow* window, \
cairo_content_t content, int width, int height)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_create_similar_surface", "GdkWindow*");
  Xen_check_type(Xen_is_cairo_content_t(content), content, 2, "gdk_window_create_similar_surface", "cairo_content_t");
  Xen_check_type(Xen_is_int(width), width, 3, "gdk_window_create_similar_surface", "int");
  Xen_check_type(Xen_is_int(height), height, 4, "gdk_window_create_similar_surface", "int");
  return(C_to_Xen_cairo_surface_t_(gdk_window_create_similar_surface(Xen_to_C_GdkWindow_(window), Xen_to_C_cairo_content_t(content), 
                                                                     Xen_to_C_int(width), Xen_to_C_int(height))));
}

static Xen gxg_gtk_expander_set_label_fill(Xen expander, Xen label_fill)
{
  #define H_gtk_expander_set_label_fill "void gtk_expander_set_label_fill(GtkExpander* expander, gboolean label_fill)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_label_fill", "GtkExpander*");
  Xen_check_type(Xen_is_gboolean(label_fill), label_fill, 2, "gtk_expander_set_label_fill", "gboolean");
  gtk_expander_set_label_fill(Xen_to_C_GtkExpander_(expander), Xen_to_C_gboolean(label_fill));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_label_fill(Xen expander)
{
  #define H_gtk_expander_get_label_fill "gboolean gtk_expander_get_label_fill(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_label_fill", "GtkExpander*");
  return(C_to_Xen_gboolean(gtk_expander_get_label_fill(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_calendar_get_day_is_marked(Xen calendar, Xen day)
{
  #define H_gtk_calendar_get_day_is_marked "gboolean gtk_calendar_get_day_is_marked(GtkCalendar* calendar, \
guint day)"
  Xen_check_type(Xen_is_GtkCalendar_(calendar), calendar, 1, "gtk_calendar_get_day_is_marked", "GtkCalendar*");
  Xen_check_type(Xen_is_guint(day), day, 2, "gtk_calendar_get_day_is_marked", "guint");
  return(C_to_Xen_gboolean(gtk_calendar_get_day_is_marked(Xen_to_C_GtkCalendar_(calendar), Xen_to_C_guint(day))));
}

static Xen gxg_gtk_progress_bar_set_inverted(Xen pbar, Xen inverted)
{
  #define H_gtk_progress_bar_set_inverted "void gtk_progress_bar_set_inverted(GtkProgressBar* pbar, gboolean inverted)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_set_inverted", "GtkProgressBar*");
  Xen_check_type(Xen_is_gboolean(inverted), inverted, 2, "gtk_progress_bar_set_inverted", "gboolean");
  gtk_progress_bar_set_inverted(Xen_to_C_GtkProgressBar_(pbar), Xen_to_C_gboolean(inverted));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_get_inverted(Xen pbar)
{
  #define H_gtk_progress_bar_get_inverted "gboolean gtk_progress_bar_get_inverted(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_get_inverted", "GtkProgressBar*");
  return(C_to_Xen_gboolean(gtk_progress_bar_get_inverted(Xen_to_C_GtkProgressBar_(pbar))));
}

static Xen gxg_gtk_radio_button_join_group(Xen radio_button, Xen group_source)
{
  #define H_gtk_radio_button_join_group "void gtk_radio_button_join_group(GtkRadioButton* radio_button, \
GtkRadioButton* group_source)"
  Xen_check_type(Xen_is_GtkRadioButton_(radio_button), radio_button, 1, "gtk_radio_button_join_group", "GtkRadioButton*");
  Xen_check_type(Xen_is_GtkRadioButton_(group_source), group_source, 2, "gtk_radio_button_join_group", "GtkRadioButton*");
  gtk_radio_button_join_group(Xen_to_C_GtkRadioButton_(radio_button), Xen_to_C_GtkRadioButton_(group_source));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_new(Xen value, Xen lower, Xen upper, Xen step_increment, Xen page_increment, Xen page_size)
{
  #define H_gtk_adjustment_new "GtkAdjustment* gtk_adjustment_new(gdouble value, gdouble lower, gdouble upper, \
gdouble step_increment, gdouble page_increment, gdouble page_size)"
  Xen_check_type(Xen_is_gdouble(value), value, 1, "gtk_adjustment_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(lower), lower, 2, "gtk_adjustment_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(upper), upper, 3, "gtk_adjustment_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(step_increment), step_increment, 4, "gtk_adjustment_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(page_increment), page_increment, 5, "gtk_adjustment_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(page_size), page_size, 6, "gtk_adjustment_new", "gdouble");
  return(C_to_Xen_GtkAdjustment_(gtk_adjustment_new(Xen_to_C_gdouble(value), Xen_to_C_gdouble(lower), Xen_to_C_gdouble(upper), 
                                                    Xen_to_C_gdouble(step_increment), Xen_to_C_gdouble(page_increment), Xen_to_C_gdouble(page_size))));
}

static Xen gxg_gtk_binding_set_activate(Xen binding_set, Xen keyval, Xen modifiers, Xen object)
{
  #define H_gtk_binding_set_activate "gboolean gtk_binding_set_activate(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers, GObject* object)"
  Xen_check_type(Xen_is_GtkBindingSet_(binding_set), binding_set, 1, "gtk_binding_set_activate", "GtkBindingSet*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_binding_set_activate", "guint");
  Xen_check_type(Xen_is_GdkModifierType(modifiers), modifiers, 3, "gtk_binding_set_activate", "GdkModifierType");
  Xen_check_type(Xen_is_GObject_(object), object, 4, "gtk_binding_set_activate", "GObject*");
  return(C_to_Xen_gboolean(gtk_binding_set_activate(Xen_to_C_GtkBindingSet_(binding_set), Xen_to_C_guint(keyval), Xen_to_C_GdkModifierType(modifiers), 
                                                    Xen_to_C_GObject_(object))));
}

static Xen gxg_gtk_bindings_activate(Xen object, Xen keyval, Xen modifiers)
{
  #define H_gtk_bindings_activate "gboolean gtk_bindings_activate(GObject* object, guint keyval, GdkModifierType modifiers)"
  Xen_check_type(Xen_is_GObject_(object), object, 1, "gtk_bindings_activate", "GObject*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gtk_bindings_activate", "guint");
  Xen_check_type(Xen_is_GdkModifierType(modifiers), modifiers, 3, "gtk_bindings_activate", "GdkModifierType");
  return(C_to_Xen_gboolean(gtk_bindings_activate(Xen_to_C_GObject_(object), Xen_to_C_guint(keyval), Xen_to_C_GdkModifierType(modifiers))));
}

static Xen gxg_gtk_icon_view_create_drag_icon(Xen icon_view, Xen path)
{
  #define H_gtk_icon_view_create_drag_icon "cairo_surface_t* gtk_icon_view_create_drag_icon(GtkIconView* icon_view, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_create_drag_icon", "GtkIconView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_icon_view_create_drag_icon", "GtkTreePath*");
  return(C_to_Xen_cairo_surface_t_(gtk_icon_view_create_drag_icon(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gtk_tree_view_create_row_drag_icon(Xen tree_view, Xen path)
{
  #define H_gtk_tree_view_create_row_drag_icon "cairo_surface_t* gtk_tree_view_create_row_drag_icon(GtkTreeView* tree_view, \
GtkTreePath* path)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_create_row_drag_icon", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_create_row_drag_icon", "GtkTreePath*");
  return(C_to_Xen_cairo_surface_t_(gtk_tree_view_create_row_drag_icon(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path))));
}

static Xen gxg_gdk_cairo_get_clip_rectangle(Xen cr, Xen rect)
{
  #define H_gdk_cairo_get_clip_rectangle "gboolean gdk_cairo_get_clip_rectangle(cairo_t* cr, GdkRectangle* rect)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "gdk_cairo_get_clip_rectangle", "cairo_t*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gdk_cairo_get_clip_rectangle", "GdkRectangle*");
  return(C_to_Xen_gboolean(gdk_cairo_get_clip_rectangle(Xen_to_C_cairo_t_(cr), Xen_to_C_GdkRectangle_(rect))));
}

static Xen gxg_gdk_cairo_region_create_from_surface(Xen surface)
{
  #define H_gdk_cairo_region_create_from_surface "cairo_region_t* gdk_cairo_region_create_from_surface(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "gdk_cairo_region_create_from_surface", "cairo_surface_t*");
  return(C_to_Xen_cairo_region_t_(gdk_cairo_region_create_from_surface(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_gdk_window_get_display(Xen window)
{
  #define H_gdk_window_get_display "GdkDisplay* gdk_window_get_display(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_display", "GdkWindow*");
  return(C_to_Xen_GdkDisplay_(gdk_window_get_display(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_width(Xen window)
{
  #define H_gdk_window_get_width "int gdk_window_get_width(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_width", "GdkWindow*");
  return(C_to_Xen_int(gdk_window_get_width(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_height(Xen window)
{
  #define H_gdk_window_get_height "int gdk_window_get_height(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_height", "GdkWindow*");
  return(C_to_Xen_int(gdk_window_get_height(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_cell_renderer_get_request_mode(Xen cell)
{
  #define H_gtk_cell_renderer_get_request_mode "GtkSizeRequestMode gtk_cell_renderer_get_request_mode(GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_request_mode", "GtkCellRenderer*");
  return(C_to_Xen_GtkSizeRequestMode(gtk_cell_renderer_get_request_mode(Xen_to_C_GtkCellRenderer_(cell))));
}

static Xen gxg_gtk_cell_renderer_get_preferred_width(Xen cell, Xen widget, Xen ignore_minimum_size, Xen ignore_natural_size)
{
  #define H_gtk_cell_renderer_get_preferred_width "void gtk_cell_renderer_get_preferred_width(GtkCellRenderer* cell, \
GtkWidget* widget, gint* [minimum_size], gint* [natural_size])"
  gint ref_minimum_size;
  gint ref_natural_size;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_preferred_width", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_cell_renderer_get_preferred_width", "GtkWidget*");
  gtk_cell_renderer_get_preferred_width(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GtkWidget_(widget), &ref_minimum_size, 
                                        &ref_natural_size);
  return(Xen_list_2(C_to_Xen_gint(ref_minimum_size), C_to_Xen_gint(ref_natural_size)));
}

static Xen gxg_gtk_cell_renderer_get_preferred_height_for_width(Xen cell, Xen widget, Xen width, Xen ignore_minimum_height, Xen ignore_natural_height)
{
  #define H_gtk_cell_renderer_get_preferred_height_for_width "void gtk_cell_renderer_get_preferred_height_for_width(GtkCellRenderer* cell, \
GtkWidget* widget, gint width, gint* [minimum_height], gint* [natural_height])"
  gint ref_minimum_height;
  gint ref_natural_height;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_preferred_height_for_width", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_cell_renderer_get_preferred_height_for_width", "GtkWidget*");
  Xen_check_type(Xen_is_gint(width), width, 3, "gtk_cell_renderer_get_preferred_height_for_width", "gint");
  gtk_cell_renderer_get_preferred_height_for_width(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(width), 
                                                   &ref_minimum_height, &ref_natural_height);
  return(Xen_list_2(C_to_Xen_gint(ref_minimum_height), C_to_Xen_gint(ref_natural_height)));
}

static Xen gxg_gtk_cell_renderer_get_preferred_height(Xen cell, Xen widget, Xen ignore_minimum_size, Xen ignore_natural_size)
{
  #define H_gtk_cell_renderer_get_preferred_height "void gtk_cell_renderer_get_preferred_height(GtkCellRenderer* cell, \
GtkWidget* widget, gint* [minimum_size], gint* [natural_size])"
  gint ref_minimum_size;
  gint ref_natural_size;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_preferred_height", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_cell_renderer_get_preferred_height", "GtkWidget*");
  gtk_cell_renderer_get_preferred_height(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GtkWidget_(widget), &ref_minimum_size, 
                                         &ref_natural_size);
  return(Xen_list_2(C_to_Xen_gint(ref_minimum_size), C_to_Xen_gint(ref_natural_size)));
}

static Xen gxg_gtk_cell_renderer_get_preferred_width_for_height(Xen cell, Xen widget, Xen height, Xen ignore_minimum_width, Xen ignore_natural_width)
{
  #define H_gtk_cell_renderer_get_preferred_width_for_height "void gtk_cell_renderer_get_preferred_width_for_height(GtkCellRenderer* cell, \
GtkWidget* widget, gint height, gint* [minimum_width], gint* [natural_width])"
  gint ref_minimum_width;
  gint ref_natural_width;
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 1, "gtk_cell_renderer_get_preferred_width_for_height", "GtkCellRenderer*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_cell_renderer_get_preferred_width_for_height", "GtkWidget*");
  Xen_check_type(Xen_is_gint(height), height, 3, "gtk_cell_renderer_get_preferred_width_for_height", "gint");
  gtk_cell_renderer_get_preferred_width_for_height(Xen_to_C_GtkCellRenderer_(cell), Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(height), 
                                                   &ref_minimum_width, &ref_natural_width);
  return(Xen_list_2(C_to_Xen_gint(ref_minimum_width), C_to_Xen_gint(ref_natural_width)));
}

static Xen gxg_gtk_drag_set_icon_surface(Xen context, Xen surface)
{
  #define H_gtk_drag_set_icon_surface "void gtk_drag_set_icon_surface(GdkDragContext* context, cairo_surface_t* surface)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_set_icon_surface", "GdkDragContext*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 2, "gtk_drag_set_icon_surface", "cairo_surface_t*");
  gtk_drag_set_icon_surface(Xen_to_C_GdkDragContext_(context), Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_set_group_name(Xen notebook, Xen group_name)
{
  #define H_gtk_notebook_set_group_name "void gtk_notebook_set_group_name(GtkNotebook* notebook, gchar* group_name)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_set_group_name", "GtkNotebook*");
  Xen_check_type(Xen_is_gchar_(group_name), group_name, 2, "gtk_notebook_set_group_name", "gchar*");
  gtk_notebook_set_group_name(Xen_to_C_GtkNotebook_(notebook), (const gchar*)Xen_to_C_gchar_(group_name));
  return(Xen_false);
}

static Xen gxg_gtk_notebook_get_group_name(Xen notebook)
{
  #define H_gtk_notebook_get_group_name "gchar* gtk_notebook_get_group_name(GtkNotebook* notebook)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_get_group_name", "GtkNotebook*");
    return(C_to_Xen_gchar_((gchar*)gtk_notebook_get_group_name(Xen_to_C_GtkNotebook_(notebook))));
}

static Xen gxg_gtk_widget_draw(Xen widget, Xen cr)
{
  #define H_gtk_widget_draw "void gtk_widget_draw(GtkWidget* widget, cairo_t* cr)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_draw", "GtkWidget*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_widget_draw", "cairo_t*");
  gtk_widget_draw(Xen_to_C_GtkWidget_(widget), Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_request_mode(Xen widget)
{
  #define H_gtk_widget_get_request_mode "GtkSizeRequestMode gtk_widget_get_request_mode(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_request_mode", "GtkWidget*");
  return(C_to_Xen_GtkSizeRequestMode(gtk_widget_get_request_mode(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_allocated_width(Xen widget)
{
  #define H_gtk_widget_get_allocated_width "int gtk_widget_get_allocated_width(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_allocated_width", "GtkWidget*");
  return(C_to_Xen_int(gtk_widget_get_allocated_width(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_allocated_height(Xen widget)
{
  #define H_gtk_widget_get_allocated_height "int gtk_widget_get_allocated_height(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_allocated_height", "GtkWidget*");
  return(C_to_Xen_int(gtk_widget_get_allocated_height(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_halign(Xen widget)
{
  #define H_gtk_widget_get_halign "GtkAlign gtk_widget_get_halign(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_halign", "GtkWidget*");
  return(C_to_Xen_GtkAlign(gtk_widget_get_halign(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_halign(Xen widget, Xen align)
{
  #define H_gtk_widget_set_halign "void gtk_widget_set_halign(GtkWidget* widget, GtkAlign align)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_halign", "GtkWidget*");
  Xen_check_type(Xen_is_GtkAlign(align), align, 2, "gtk_widget_set_halign", "GtkAlign");
  gtk_widget_set_halign(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkAlign(align));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_valign(Xen widget)
{
  #define H_gtk_widget_get_valign "GtkAlign gtk_widget_get_valign(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_valign", "GtkWidget*");
  return(C_to_Xen_GtkAlign(gtk_widget_get_valign(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_valign(Xen widget, Xen align)
{
  #define H_gtk_widget_set_valign "void gtk_widget_set_valign(GtkWidget* widget, GtkAlign align)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_valign", "GtkWidget*");
  Xen_check_type(Xen_is_GtkAlign(align), align, 2, "gtk_widget_set_valign", "GtkAlign");
  gtk_widget_set_valign(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkAlign(align));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_margin_top(Xen widget)
{
  #define H_gtk_widget_get_margin_top "gint gtk_widget_get_margin_top(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_margin_top", "GtkWidget*");
  return(C_to_Xen_gint(gtk_widget_get_margin_top(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_margin_top(Xen widget, Xen margin)
{
  #define H_gtk_widget_set_margin_top "void gtk_widget_set_margin_top(GtkWidget* widget, gint margin)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_margin_top", "GtkWidget*");
  Xen_check_type(Xen_is_gint(margin), margin, 2, "gtk_widget_set_margin_top", "gint");
  gtk_widget_set_margin_top(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(margin));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_margin_bottom(Xen widget)
{
  #define H_gtk_widget_get_margin_bottom "gint gtk_widget_get_margin_bottom(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_margin_bottom", "GtkWidget*");
  return(C_to_Xen_gint(gtk_widget_get_margin_bottom(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_margin_bottom(Xen widget, Xen margin)
{
  #define H_gtk_widget_set_margin_bottom "void gtk_widget_set_margin_bottom(GtkWidget* widget, gint margin)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_margin_bottom", "GtkWidget*");
  Xen_check_type(Xen_is_gint(margin), margin, 2, "gtk_widget_set_margin_bottom", "gint");
  gtk_widget_set_margin_bottom(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(margin));
  return(Xen_false);
}

static Xen gxg_gtk_widget_shape_combine_region(Xen widget, Xen region)
{
  #define H_gtk_widget_shape_combine_region "void gtk_widget_shape_combine_region(GtkWidget* widget, \
cairo_region_t* region)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_shape_combine_region", "GtkWidget*");
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 2, "gtk_widget_shape_combine_region", "cairo_region_t*");
  gtk_widget_shape_combine_region(Xen_to_C_GtkWidget_(widget), Xen_to_C_cairo_region_t_(region));
  return(Xen_false);
}

static Xen gxg_gtk_widget_input_shape_combine_region(Xen widget, Xen region)
{
  #define H_gtk_widget_input_shape_combine_region "void gtk_widget_input_shape_combine_region(GtkWidget* widget, \
cairo_region_t* region)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_input_shape_combine_region", "GtkWidget*");
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 2, "gtk_widget_input_shape_combine_region", "cairo_region_t*");
  gtk_widget_input_shape_combine_region(Xen_to_C_GtkWidget_(widget), Xen_to_C_cairo_region_t_(region));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_new_with_entry(void)
{
  #define H_gtk_combo_box_new_with_entry "GtkWidget* gtk_combo_box_new_with_entry( void)"
  return(C_to_Xen_GtkWidget_(gtk_combo_box_new_with_entry()));
}

static Xen gxg_gtk_combo_box_get_has_entry(Xen combo_box)
{
  #define H_gtk_combo_box_get_has_entry "gboolean gtk_combo_box_get_has_entry(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_has_entry", "GtkComboBox*");
  return(C_to_Xen_gboolean(gtk_combo_box_get_has_entry(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_combo_box_set_entry_text_column(Xen combo_box, Xen text_column)
{
  #define H_gtk_combo_box_set_entry_text_column "void gtk_combo_box_set_entry_text_column(GtkComboBox* combo_box, \
gint text_column)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_entry_text_column", "GtkComboBox*");
  Xen_check_type(Xen_is_gint(text_column), text_column, 2, "gtk_combo_box_set_entry_text_column", "gint");
  gtk_combo_box_set_entry_text_column(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gint(text_column));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_entry_text_column(Xen combo_box)
{
  #define H_gtk_combo_box_get_entry_text_column "gint gtk_combo_box_get_entry_text_column(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_entry_text_column", "GtkComboBox*");
  return(C_to_Xen_gint(gtk_combo_box_get_entry_text_column(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_widget_get_hexpand(Xen widget)
{
  #define H_gtk_widget_get_hexpand "gboolean gtk_widget_get_hexpand(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_hexpand", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_hexpand(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_hexpand(Xen widget, Xen expand)
{
  #define H_gtk_widget_set_hexpand "void gtk_widget_set_hexpand(GtkWidget* widget, gboolean expand)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_hexpand", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 2, "gtk_widget_set_hexpand", "gboolean");
  gtk_widget_set_hexpand(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_hexpand_set(Xen widget)
{
  #define H_gtk_widget_get_hexpand_set "gboolean gtk_widget_get_hexpand_set(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_hexpand_set", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_hexpand_set(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_hexpand_set(Xen widget, Xen set)
{
  #define H_gtk_widget_set_hexpand_set "void gtk_widget_set_hexpand_set(GtkWidget* widget, gboolean set)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_hexpand_set", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(set), set, 2, "gtk_widget_set_hexpand_set", "gboolean");
  gtk_widget_set_hexpand_set(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(set));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_vexpand(Xen widget)
{
  #define H_gtk_widget_get_vexpand "gboolean gtk_widget_get_vexpand(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_vexpand", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_vexpand(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_vexpand(Xen widget, Xen expand)
{
  #define H_gtk_widget_set_vexpand "void gtk_widget_set_vexpand(GtkWidget* widget, gboolean expand)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_vexpand", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(expand), expand, 2, "gtk_widget_set_vexpand", "gboolean");
  gtk_widget_set_vexpand(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(expand));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_vexpand_set(Xen widget)
{
  #define H_gtk_widget_get_vexpand_set "gboolean gtk_widget_get_vexpand_set(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_vexpand_set", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_vexpand_set(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_vexpand_set(Xen widget, Xen set)
{
  #define H_gtk_widget_set_vexpand_set "void gtk_widget_set_vexpand_set(GtkWidget* widget, gboolean set)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_vexpand_set", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(set), set, 2, "gtk_widget_set_vexpand_set", "gboolean");
  gtk_widget_set_vexpand_set(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(set));
  return(Xen_false);
}

static Xen gxg_gtk_widget_queue_compute_expand(Xen widget)
{
  #define H_gtk_widget_queue_compute_expand "void gtk_widget_queue_compute_expand(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_queue_compute_expand", "GtkWidget*");
  gtk_widget_queue_compute_expand(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_compute_expand(Xen widget, Xen orientation)
{
  #define H_gtk_widget_compute_expand "gboolean gtk_widget_compute_expand(GtkWidget* widget, GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_compute_expand", "GtkWidget*");
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 2, "gtk_widget_compute_expand", "GtkOrientation");
  return(C_to_Xen_gboolean(gtk_widget_compute_expand(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkOrientation(orientation))));
}

static Xen gxg_gtk_combo_box_text_new(void)
{
  #define H_gtk_combo_box_text_new "GtkWidget* gtk_combo_box_text_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_combo_box_text_new()));
}

static Xen gxg_gtk_combo_box_text_new_with_entry(void)
{
  #define H_gtk_combo_box_text_new_with_entry "GtkWidget* gtk_combo_box_text_new_with_entry( void)"
  return(C_to_Xen_GtkWidget_(gtk_combo_box_text_new_with_entry()));
}

static Xen gxg_gtk_combo_box_text_append_text(Xen combo_box, Xen text)
{
  #define H_gtk_combo_box_text_append_text "void gtk_combo_box_text_append_text(GtkComboBoxText* combo_box, \
gchar* text)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_append_text", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_combo_box_text_append_text", "gchar*");
  gtk_combo_box_text_append_text(Xen_to_C_GtkComboBoxText_(combo_box), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_insert_text(Xen combo_box, Xen position, Xen text)
{
  #define H_gtk_combo_box_text_insert_text "void gtk_combo_box_text_insert_text(GtkComboBoxText* combo_box, \
gint position, gchar* text)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_insert_text", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_combo_box_text_insert_text", "gint");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_combo_box_text_insert_text", "gchar*");
  gtk_combo_box_text_insert_text(Xen_to_C_GtkComboBoxText_(combo_box), Xen_to_C_gint(position), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_prepend_text(Xen combo_box, Xen text)
{
  #define H_gtk_combo_box_text_prepend_text "void gtk_combo_box_text_prepend_text(GtkComboBoxText* combo_box, \
gchar* text)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_prepend_text", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_combo_box_text_prepend_text", "gchar*");
  gtk_combo_box_text_prepend_text(Xen_to_C_GtkComboBoxText_(combo_box), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_remove(Xen combo_box, Xen position)
{
  #define H_gtk_combo_box_text_remove "void gtk_combo_box_text_remove(GtkComboBoxText* combo_box, gint position)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_remove", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_combo_box_text_remove", "gint");
  gtk_combo_box_text_remove(Xen_to_C_GtkComboBoxText_(combo_box), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_get_active_text(Xen combo_box)
{
  #define H_gtk_combo_box_text_get_active_text "gchar* gtk_combo_box_text_get_active_text(GtkComboBoxText* combo_box)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_get_active_text", "GtkComboBoxText*");
  return(C_to_Xen_gchar_(gtk_combo_box_text_get_active_text(Xen_to_C_GtkComboBoxText_(combo_box))));
}

static Xen gxg_gdk_cairo_set_source_rgba(Xen cr, Xen rgba)
{
  #define H_gdk_cairo_set_source_rgba "void gdk_cairo_set_source_rgba(cairo_t* cr, GdkRGBA* rgba)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "gdk_cairo_set_source_rgba", "cairo_t*");
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 2, "gdk_cairo_set_source_rgba", "GdkRGBA*");
  gdk_cairo_set_source_rgba(Xen_to_C_cairo_t_(cr), Xen_to_C_GdkRGBA_(rgba));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_remove_all(Xen combo_box)
{
  #define H_gtk_combo_box_text_remove_all "void gtk_combo_box_text_remove_all(GtkComboBoxText* combo_box)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_remove_all", "GtkComboBoxText*");
  gtk_combo_box_text_remove_all(Xen_to_C_GtkComboBoxText_(combo_box));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_set_popup_fixed_width(Xen combo_box, Xen fixed)
{
  #define H_gtk_combo_box_set_popup_fixed_width "void gtk_combo_box_set_popup_fixed_width(GtkComboBox* combo_box, \
gboolean fixed)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_popup_fixed_width", "GtkComboBox*");
  Xen_check_type(Xen_is_gboolean(fixed), fixed, 2, "gtk_combo_box_set_popup_fixed_width", "gboolean");
  gtk_combo_box_set_popup_fixed_width(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gboolean(fixed));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_popup_fixed_width(Xen combo_box)
{
  #define H_gtk_combo_box_get_popup_fixed_width "gboolean gtk_combo_box_get_popup_fixed_width(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_popup_fixed_width", "GtkComboBox*");
  return(C_to_Xen_gboolean(gtk_combo_box_get_popup_fixed_width(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_scrolled_window_get_min_content_width(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_min_content_width "gint gtk_scrolled_window_get_min_content_width(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_min_content_width", "GtkScrolledWindow*");
  return(C_to_Xen_gint(gtk_scrolled_window_get_min_content_width(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_set_min_content_width(Xen scrolled_window, Xen width)
{
  #define H_gtk_scrolled_window_set_min_content_width "void gtk_scrolled_window_set_min_content_width(GtkScrolledWindow* scrolled_window, \
gint width)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_min_content_width", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_scrolled_window_set_min_content_width", "gint");
  gtk_scrolled_window_set_min_content_width(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gint(width));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_min_content_height(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_min_content_height "gint gtk_scrolled_window_get_min_content_height(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_min_content_height", "GtkScrolledWindow*");
  return(C_to_Xen_gint(gtk_scrolled_window_get_min_content_height(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_set_min_content_height(Xen scrolled_window, Xen height)
{
  #define H_gtk_scrolled_window_set_min_content_height "void gtk_scrolled_window_set_min_content_height(GtkScrolledWindow* scrolled_window, \
gint height)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_min_content_height", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gint(height), height, 2, "gtk_scrolled_window_set_min_content_height", "gint");
  gtk_scrolled_window_set_min_content_height(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_grid_new(void)
{
  #define H_gtk_grid_new "GtkWidget* gtk_grid_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_grid_new()));
}

static Xen gxg_gtk_grid_attach(Xen grid, Xen child, Xen left, Xen top, Xen width, Xen height)
{
  #define H_gtk_grid_attach "void gtk_grid_attach(GtkGrid* grid, GtkWidget* child, gint left, gint top, \
gint width, gint height)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_attach", "GtkGrid*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_grid_attach", "GtkWidget*");
  Xen_check_type(Xen_is_gint(left), left, 3, "gtk_grid_attach", "gint");
  Xen_check_type(Xen_is_gint(top), top, 4, "gtk_grid_attach", "gint");
  Xen_check_type(Xen_is_gint(width), width, 5, "gtk_grid_attach", "gint");
  Xen_check_type(Xen_is_gint(height), height, 6, "gtk_grid_attach", "gint");
  gtk_grid_attach(Xen_to_C_GtkGrid_(grid), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(left), Xen_to_C_gint(top), Xen_to_C_gint(width), 
                  Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_grid_attach_next_to(Xen grid, Xen child, Xen sibling, Xen side, Xen width, Xen height)
{
  #define H_gtk_grid_attach_next_to "void gtk_grid_attach_next_to(GtkGrid* grid, GtkWidget* child, GtkWidget* sibling, \
GtkPositionType side, gint width, gint height)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_attach_next_to", "GtkGrid*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_grid_attach_next_to", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(sibling), sibling, 3, "gtk_grid_attach_next_to", "GtkWidget*");
  Xen_check_type(Xen_is_GtkPositionType(side), side, 4, "gtk_grid_attach_next_to", "GtkPositionType");
  Xen_check_type(Xen_is_gint(width), width, 5, "gtk_grid_attach_next_to", "gint");
  Xen_check_type(Xen_is_gint(height), height, 6, "gtk_grid_attach_next_to", "gint");
  gtk_grid_attach_next_to(Xen_to_C_GtkGrid_(grid), Xen_to_C_GtkWidget_(child), Xen_to_C_GtkWidget_(sibling), Xen_to_C_GtkPositionType(side), 
                          Xen_to_C_gint(width), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_grid_set_row_homogeneous(Xen grid, Xen homogeneous)
{
  #define H_gtk_grid_set_row_homogeneous "void gtk_grid_set_row_homogeneous(GtkGrid* grid, gboolean homogeneous)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_set_row_homogeneous", "GtkGrid*");
  Xen_check_type(Xen_is_gboolean(homogeneous), homogeneous, 2, "gtk_grid_set_row_homogeneous", "gboolean");
  gtk_grid_set_row_homogeneous(Xen_to_C_GtkGrid_(grid), Xen_to_C_gboolean(homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_grid_get_row_homogeneous(Xen grid)
{
  #define H_gtk_grid_get_row_homogeneous "gboolean gtk_grid_get_row_homogeneous(GtkGrid* grid)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_row_homogeneous", "GtkGrid*");
  return(C_to_Xen_gboolean(gtk_grid_get_row_homogeneous(Xen_to_C_GtkGrid_(grid))));
}

static Xen gxg_gtk_grid_set_row_spacing(Xen grid, Xen spacing)
{
  #define H_gtk_grid_set_row_spacing "void gtk_grid_set_row_spacing(GtkGrid* grid, guint spacing)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_set_row_spacing", "GtkGrid*");
  Xen_check_type(Xen_is_guint(spacing), spacing, 2, "gtk_grid_set_row_spacing", "guint");
  gtk_grid_set_row_spacing(Xen_to_C_GtkGrid_(grid), Xen_to_C_guint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_grid_get_row_spacing(Xen grid)
{
  #define H_gtk_grid_get_row_spacing "guint gtk_grid_get_row_spacing(GtkGrid* grid)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_row_spacing", "GtkGrid*");
  return(C_to_Xen_guint(gtk_grid_get_row_spacing(Xen_to_C_GtkGrid_(grid))));
}

static Xen gxg_gtk_grid_set_column_homogeneous(Xen grid, Xen homogeneous)
{
  #define H_gtk_grid_set_column_homogeneous "void gtk_grid_set_column_homogeneous(GtkGrid* grid, gboolean homogeneous)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_set_column_homogeneous", "GtkGrid*");
  Xen_check_type(Xen_is_gboolean(homogeneous), homogeneous, 2, "gtk_grid_set_column_homogeneous", "gboolean");
  gtk_grid_set_column_homogeneous(Xen_to_C_GtkGrid_(grid), Xen_to_C_gboolean(homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_grid_get_column_homogeneous(Xen grid)
{
  #define H_gtk_grid_get_column_homogeneous "gboolean gtk_grid_get_column_homogeneous(GtkGrid* grid)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_column_homogeneous", "GtkGrid*");
  return(C_to_Xen_gboolean(gtk_grid_get_column_homogeneous(Xen_to_C_GtkGrid_(grid))));
}

static Xen gxg_gtk_grid_set_column_spacing(Xen grid, Xen spacing)
{
  #define H_gtk_grid_set_column_spacing "void gtk_grid_set_column_spacing(GtkGrid* grid, guint spacing)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_set_column_spacing", "GtkGrid*");
  Xen_check_type(Xen_is_guint(spacing), spacing, 2, "gtk_grid_set_column_spacing", "guint");
  gtk_grid_set_column_spacing(Xen_to_C_GtkGrid_(grid), Xen_to_C_guint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_grid_get_column_spacing(Xen grid)
{
  #define H_gtk_grid_get_column_spacing "guint gtk_grid_get_column_spacing(GtkGrid* grid)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_column_spacing", "GtkGrid*");
  return(C_to_Xen_guint(gtk_grid_get_column_spacing(Xen_to_C_GtkGrid_(grid))));
}

static Xen gxg_gtk_scrollable_get_hadjustment(Xen scrollable)
{
  #define H_gtk_scrollable_get_hadjustment "GtkAdjustment* gtk_scrollable_get_hadjustment(GtkScrollable* scrollable)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_get_hadjustment", "GtkScrollable*");
  return(C_to_Xen_GtkAdjustment_(gtk_scrollable_get_hadjustment(Xen_to_C_GtkScrollable_(scrollable))));
}

static Xen gxg_gtk_scrollable_set_hadjustment(Xen scrollable, Xen hadjustment)
{
  #define H_gtk_scrollable_set_hadjustment "void gtk_scrollable_set_hadjustment(GtkScrollable* scrollable, \
GtkAdjustment* hadjustment)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_set_hadjustment", "GtkScrollable*");
  Xen_check_type(Xen_is_GtkAdjustment_(hadjustment), hadjustment, 2, "gtk_scrollable_set_hadjustment", "GtkAdjustment*");
  gtk_scrollable_set_hadjustment(Xen_to_C_GtkScrollable_(scrollable), Xen_to_C_GtkAdjustment_(hadjustment));
  return(Xen_false);
}

static Xen gxg_gtk_scrollable_get_vadjustment(Xen scrollable)
{
  #define H_gtk_scrollable_get_vadjustment "GtkAdjustment* gtk_scrollable_get_vadjustment(GtkScrollable* scrollable)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_get_vadjustment", "GtkScrollable*");
  return(C_to_Xen_GtkAdjustment_(gtk_scrollable_get_vadjustment(Xen_to_C_GtkScrollable_(scrollable))));
}

static Xen gxg_gtk_scrollable_set_vadjustment(Xen scrollable, Xen vadjustment)
{
  #define H_gtk_scrollable_set_vadjustment "void gtk_scrollable_set_vadjustment(GtkScrollable* scrollable, \
GtkAdjustment* vadjustment)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_set_vadjustment", "GtkScrollable*");
  Xen_check_type(Xen_is_GtkAdjustment_(vadjustment), vadjustment, 2, "gtk_scrollable_set_vadjustment", "GtkAdjustment*");
  gtk_scrollable_set_vadjustment(Xen_to_C_GtkScrollable_(scrollable), Xen_to_C_GtkAdjustment_(vadjustment));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_next_page(Xen assistant)
{
  #define H_gtk_assistant_next_page "void gtk_assistant_next_page(GtkAssistant* assistant)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_next_page", "GtkAssistant*");
  gtk_assistant_next_page(Xen_to_C_GtkAssistant_(assistant));
  return(Xen_false);
}

static Xen gxg_gtk_assistant_previous_page(Xen assistant)
{
  #define H_gtk_assistant_previous_page "void gtk_assistant_previous_page(GtkAssistant* assistant)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_previous_page", "GtkAssistant*");
  gtk_assistant_previous_page(Xen_to_C_GtkAssistant_(assistant));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_new_with_model_and_entry(Xen model)
{
  #define H_gtk_combo_box_new_with_model_and_entry "GtkWidget* gtk_combo_box_new_with_model_and_entry(GtkTreeModel* model)"
  Xen_check_type(Xen_is_GtkTreeModel_(model), model, 1, "gtk_combo_box_new_with_model_and_entry", "GtkTreeModel*");
  return(C_to_Xen_GtkWidget_(gtk_combo_box_new_with_model_and_entry(Xen_to_C_GtkTreeModel_(model))));
}

static Xen gxg_gtk_scrollable_get_hscroll_policy(Xen scrollable)
{
  #define H_gtk_scrollable_get_hscroll_policy "GtkScrollablePolicy gtk_scrollable_get_hscroll_policy(GtkScrollable* scrollable)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_get_hscroll_policy", "GtkScrollable*");
  return(C_to_Xen_GtkScrollablePolicy(gtk_scrollable_get_hscroll_policy(Xen_to_C_GtkScrollable_(scrollable))));
}

static Xen gxg_gtk_scrollable_set_hscroll_policy(Xen scrollable, Xen policy)
{
  #define H_gtk_scrollable_set_hscroll_policy "void gtk_scrollable_set_hscroll_policy(GtkScrollable* scrollable, \
GtkScrollablePolicy policy)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_set_hscroll_policy", "GtkScrollable*");
  Xen_check_type(Xen_is_GtkScrollablePolicy(policy), policy, 2, "gtk_scrollable_set_hscroll_policy", "GtkScrollablePolicy");
  gtk_scrollable_set_hscroll_policy(Xen_to_C_GtkScrollable_(scrollable), Xen_to_C_GtkScrollablePolicy(policy));
  return(Xen_false);
}

static Xen gxg_gtk_scrollable_get_vscroll_policy(Xen scrollable)
{
  #define H_gtk_scrollable_get_vscroll_policy "GtkScrollablePolicy gtk_scrollable_get_vscroll_policy(GtkScrollable* scrollable)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_get_vscroll_policy", "GtkScrollable*");
  return(C_to_Xen_GtkScrollablePolicy(gtk_scrollable_get_vscroll_policy(Xen_to_C_GtkScrollable_(scrollable))));
}

static Xen gxg_gtk_scrollable_set_vscroll_policy(Xen scrollable, Xen policy)
{
  #define H_gtk_scrollable_set_vscroll_policy "void gtk_scrollable_set_vscroll_policy(GtkScrollable* scrollable, \
GtkScrollablePolicy policy)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_set_vscroll_policy", "GtkScrollable*");
  Xen_check_type(Xen_is_GtkScrollablePolicy(policy), policy, 2, "gtk_scrollable_set_vscroll_policy", "GtkScrollablePolicy");
  gtk_scrollable_set_vscroll_policy(Xen_to_C_GtkScrollable_(scrollable), Xen_to_C_GtkScrollablePolicy(policy));
  return(Xen_false);
}

static Xen gxg_gtk_switch_new(void)
{
  #define H_gtk_switch_new "GtkWidget* gtk_switch_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_switch_new()));
}

static Xen gxg_gtk_switch_set_active(Xen sw, Xen is_active)
{
  #define H_gtk_switch_set_active "void gtk_switch_set_active(GtkSwitch* sw, gboolean is_active)"
  Xen_check_type(Xen_is_GtkSwitch_(sw), sw, 1, "gtk_switch_set_active", "GtkSwitch*");
  Xen_check_type(Xen_is_gboolean(is_active), is_active, 2, "gtk_switch_set_active", "gboolean");
  gtk_switch_set_active(Xen_to_C_GtkSwitch_(sw), Xen_to_C_gboolean(is_active));
  return(Xen_false);
}

static Xen gxg_gtk_switch_get_active(Xen sw)
{
  #define H_gtk_switch_get_active "gboolean gtk_switch_get_active(GtkSwitch* sw)"
  Xen_check_type(Xen_is_GtkSwitch_(sw), sw, 1, "gtk_switch_get_active", "GtkSwitch*");
  return(C_to_Xen_gboolean(gtk_switch_get_active(Xen_to_C_GtkSwitch_(sw))));
}

static Xen gxg_gdk_window_get_clip_region(Xen window)
{
  #define H_gdk_window_get_clip_region "cairo_region_t* gdk_window_get_clip_region(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_clip_region", "GdkWindow*");
  return(C_to_Xen_cairo_region_t_(gdk_window_get_clip_region(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_visible_region(Xen window)
{
  #define H_gdk_window_get_visible_region "cairo_region_t* gdk_window_get_visible_region(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_visible_region", "GdkWindow*");
  return(C_to_Xen_cairo_region_t_(gdk_window_get_visible_region(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_border_new(void)
{
  #define H_gtk_border_new "GtkBorder* gtk_border_new( void)"
  return(C_to_Xen_GtkBorder_(gtk_border_new()));
}

static Xen gxg_gtk_border_copy(Xen border_)
{
  #define H_gtk_border_copy "GtkBorder* gtk_border_copy(GtkBorder* border_)"
  Xen_check_type(Xen_is_GtkBorder_(border_), border_, 1, "gtk_border_copy", "GtkBorder*");
  return(C_to_Xen_GtkBorder_(gtk_border_copy(Xen_to_C_GtkBorder_(border_))));
}

static Xen gxg_gtk_border_free(Xen border_)
{
  #define H_gtk_border_free "void gtk_border_free(GtkBorder* border_)"
  Xen_check_type(Xen_is_GtkBorder_(border_), border_, 1, "gtk_border_free", "GtkBorder*");
  gtk_border_free(Xen_to_C_GtkBorder_(border_));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_id_column(Xen combo_box)
{
  #define H_gtk_combo_box_get_id_column "gint gtk_combo_box_get_id_column(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_id_column", "GtkComboBox*");
  return(C_to_Xen_gint(gtk_combo_box_get_id_column(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_combo_box_set_id_column(Xen combo_box, Xen id_column)
{
  #define H_gtk_combo_box_set_id_column "void gtk_combo_box_set_id_column(GtkComboBox* combo_box, gint id_column)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_id_column", "GtkComboBox*");
  Xen_check_type(Xen_is_gint(id_column), id_column, 2, "gtk_combo_box_set_id_column", "gint");
  gtk_combo_box_set_id_column(Xen_to_C_GtkComboBox_(combo_box), Xen_to_C_gint(id_column));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_get_active_id(Xen combo_box)
{
  #define H_gtk_combo_box_get_active_id "gchar* gtk_combo_box_get_active_id(GtkComboBox* combo_box)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_get_active_id", "GtkComboBox*");
  return(C_to_Xen_gchar_(gtk_combo_box_get_active_id(Xen_to_C_GtkComboBox_(combo_box))));
}

static Xen gxg_gtk_combo_box_text_insert(Xen combo_box, Xen position, Xen id, Xen text)
{
  #define H_gtk_combo_box_text_insert "void gtk_combo_box_text_insert(GtkComboBoxText* combo_box, gint position, \
gchar* id, gchar* text)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_insert", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_combo_box_text_insert", "gint");
  Xen_check_type(Xen_is_gchar_(id), id, 3, "gtk_combo_box_text_insert", "gchar*");
  Xen_check_type(Xen_is_gchar_(text), text, 4, "gtk_combo_box_text_insert", "gchar*");
  gtk_combo_box_text_insert(Xen_to_C_GtkComboBoxText_(combo_box), Xen_to_C_gint(position), (const gchar*)Xen_to_C_gchar_(id), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_append(Xen combo_box, Xen id, Xen text)
{
  #define H_gtk_combo_box_text_append "void gtk_combo_box_text_append(GtkComboBoxText* combo_box, gchar* id, \
gchar* text)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_append", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gchar_(id), id, 2, "gtk_combo_box_text_append", "gchar*");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_combo_box_text_append", "gchar*");
  gtk_combo_box_text_append(Xen_to_C_GtkComboBoxText_(combo_box), (const gchar*)Xen_to_C_gchar_(id), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_text_prepend(Xen combo_box, Xen id, Xen text)
{
  #define H_gtk_combo_box_text_prepend "void gtk_combo_box_text_prepend(GtkComboBoxText* combo_box, gchar* id, \
gchar* text)"
  Xen_check_type(Xen_is_GtkComboBoxText_(combo_box), combo_box, 1, "gtk_combo_box_text_prepend", "GtkComboBoxText*");
  Xen_check_type(Xen_is_gchar_(id), id, 2, "gtk_combo_box_text_prepend", "gchar*");
  Xen_check_type(Xen_is_gchar_(text), text, 3, "gtk_combo_box_text_prepend", "gchar*");
  gtk_combo_box_text_prepend(Xen_to_C_GtkComboBoxText_(combo_box), (const gchar*)Xen_to_C_gchar_(id), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_button_box_new(Xen orientation)
{
  #define H_gtk_button_box_new "GtkWidget* gtk_button_box_new(GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_button_box_new", "GtkOrientation");
  return(C_to_Xen_GtkWidget_(gtk_button_box_new(Xen_to_C_GtkOrientation(orientation))));
}

static Xen gxg_gtk_box_new(Xen orientation, Xen spacing)
{
  #define H_gtk_box_new "GtkWidget* gtk_box_new(GtkOrientation orientation, gint spacing)"
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 1, "gtk_box_new", "GtkOrientation");
  Xen_check_type(Xen_is_gint(spacing), spacing, 2, "gtk_box_new", "gint");
  return(C_to_Xen_GtkWidget_(gtk_box_new(Xen_to_C_GtkOrientation(orientation), Xen_to_C_gint(spacing))));
}

static Xen gxg_gtk_tree_view_set_cursor_on_cell(Xen tree_view, Xen path, Xen focus_column, Xen focus_cell, Xen start_editing)
{
  #define H_gtk_tree_view_set_cursor_on_cell "void gtk_tree_view_set_cursor_on_cell(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* focus_column, GtkCellRenderer* focus_cell, gboolean start_editing)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_cursor_on_cell", "GtkTreeView*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_view_set_cursor_on_cell", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeViewColumn_(focus_column), focus_column, 3, "gtk_tree_view_set_cursor_on_cell", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(focus_cell), focus_cell, 4, "gtk_tree_view_set_cursor_on_cell", "GtkCellRenderer*");
  Xen_check_type(Xen_is_gboolean(start_editing), start_editing, 5, "gtk_tree_view_set_cursor_on_cell", "gboolean");
  gtk_tree_view_set_cursor_on_cell(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeViewColumn_(focus_column), 
                                   Xen_to_C_GtkCellRenderer_(focus_cell), Xen_to_C_gboolean(start_editing));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_set_rubber_banding(Xen tree_view, Xen enable)
{
  #define H_gtk_tree_view_set_rubber_banding "void gtk_tree_view_set_rubber_banding(GtkTreeView* tree_view, \
gboolean enable)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_rubber_banding", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(enable), enable, 2, "gtk_tree_view_set_rubber_banding", "gboolean");
  gtk_tree_view_set_rubber_banding(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(enable));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_rubber_banding(Xen tree_view)
{
  #define H_gtk_tree_view_get_rubber_banding "gboolean gtk_tree_view_get_rubber_banding(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_rubber_banding", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_rubber_banding(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tooltip_set_markup(Xen tooltip, Xen markup)
{
  #define H_gtk_tooltip_set_markup "void gtk_tooltip_set_markup(GtkTooltip* tooltip, gchar* markup)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_markup", "GtkTooltip*");
  Xen_check_type(Xen_is_gchar_(markup), markup, 2, "gtk_tooltip_set_markup", "gchar*");
  gtk_tooltip_set_markup(Xen_to_C_GtkTooltip_(tooltip), (const gchar*)Xen_to_C_gchar_(markup));
  return(Xen_false);
}

static Xen gxg_gtk_tooltip_set_custom(Xen tooltip, Xen custom_widget)
{
  #define H_gtk_tooltip_set_custom "void gtk_tooltip_set_custom(GtkTooltip* tooltip, GtkWidget* custom_widget)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_custom", "GtkTooltip*");
  Xen_check_type(Xen_is_GtkWidget_(custom_widget), custom_widget, 2, "gtk_tooltip_set_custom", "GtkWidget*");
  gtk_tooltip_set_custom(Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GtkWidget_(custom_widget));
  return(Xen_false);
}

static Xen gxg_gtk_tooltip_trigger_tooltip_query(Xen display)
{
  #define H_gtk_tooltip_trigger_tooltip_query "void gtk_tooltip_trigger_tooltip_query(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_tooltip_trigger_tooltip_query", "GdkDisplay*");
  gtk_tooltip_trigger_tooltip_query(Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_column_new_with_area(Xen area)
{
  #define H_gtk_tree_view_column_new_with_area "GtkTreeViewColumn* gtk_tree_view_column_new_with_area(GtkCellArea* area)"
  Xen_check_type(Xen_is_GtkCellArea_(area), area, 1, "gtk_tree_view_column_new_with_area", "GtkCellArea*");
  return(C_to_Xen_GtkTreeViewColumn_(gtk_tree_view_column_new_with_area(Xen_to_C_GtkCellArea_(area))));
}

static Xen gxg_gtk_tree_view_column_get_button(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_button "GtkWidget* gtk_tree_view_column_get_button(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_button", "GtkTreeViewColumn*");
  return(C_to_Xen_GtkWidget_(gtk_tree_view_column_get_button(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_tree_view_column_focus_cell(Xen tree_column, Xen cell)
{
  #define H_gtk_tree_view_column_focus_cell "void gtk_tree_view_column_focus_cell(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_focus_cell", "GtkTreeViewColumn*");
  Xen_check_type(Xen_is_GtkCellRenderer_(cell), cell, 2, "gtk_tree_view_column_focus_cell", "GtkCellRenderer*");
  gtk_tree_view_column_focus_cell(Xen_to_C_GtkTreeViewColumn_(tree_column), Xen_to_C_GtkCellRenderer_(cell));
  return(Xen_false);
}

static Xen gxg_gtk_toolbar_set_drop_highlight_item(Xen toolbar, Xen tool_item, Xen index)
{
  #define H_gtk_toolbar_set_drop_highlight_item "void gtk_toolbar_set_drop_highlight_item(GtkToolbar* toolbar, \
GtkToolItem* tool_item, gint index)"
  Xen_check_type(Xen_is_GtkToolbar_(toolbar), toolbar, 1, "gtk_toolbar_set_drop_highlight_item", "GtkToolbar*");
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 2, "gtk_toolbar_set_drop_highlight_item", "GtkToolItem*");
  Xen_check_type(Xen_is_gint(index), index, 3, "gtk_toolbar_set_drop_highlight_item", "gint");
  gtk_toolbar_set_drop_highlight_item(Xen_to_C_GtkToolbar_(toolbar), Xen_to_C_GtkToolItem_(tool_item), Xen_to_C_gint(index));
  return(Xen_false);
}

static Xen gxg_gtk_tool_item_toolbar_reconfigured(Xen tool_item)
{
  #define H_gtk_tool_item_toolbar_reconfigured "void gtk_tool_item_toolbar_reconfigured(GtkToolItem* tool_item)"
  Xen_check_type(Xen_is_GtkToolItem_(tool_item), tool_item, 1, "gtk_tool_item_toolbar_reconfigured", "GtkToolItem*");
  gtk_tool_item_toolbar_reconfigured(Xen_to_C_GtkToolItem_(tool_item));
  return(Xen_false);
}

static Xen gxg_gtk_orientable_set_orientation(Xen orientable, Xen orientation)
{
  #define H_gtk_orientable_set_orientation "void gtk_orientable_set_orientation(GtkOrientable* orientable, \
GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkOrientable_(orientable), orientable, 1, "gtk_orientable_set_orientation", "GtkOrientable*");
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 2, "gtk_orientable_set_orientation", "GtkOrientation");
  gtk_orientable_set_orientation(Xen_to_C_GtkOrientable_(orientable), Xen_to_C_GtkOrientation(orientation));
  return(Xen_false);
}

static Xen gxg_gtk_orientable_get_orientation(Xen orientable)
{
  #define H_gtk_orientable_get_orientation "GtkOrientation gtk_orientable_get_orientation(GtkOrientable* orientable)"
  Xen_check_type(Xen_is_GtkOrientable_(orientable), orientable, 1, "gtk_orientable_get_orientation", "GtkOrientable*");
  return(C_to_Xen_GtkOrientation(gtk_orientable_get_orientation(Xen_to_C_GtkOrientable_(orientable))));
}

static Xen gxg_gtk_get_major_version(void)
{
  #define H_gtk_get_major_version "guint gtk_get_major_version( void)"
    return(C_to_Xen_guint((guint)gtk_get_major_version()));
}

static Xen gxg_gtk_get_minor_version(void)
{
  #define H_gtk_get_minor_version "guint gtk_get_minor_version( void)"
    return(C_to_Xen_guint((guint)gtk_get_minor_version()));
}

static Xen gxg_gtk_get_micro_version(void)
{
  #define H_gtk_get_micro_version "guint gtk_get_micro_version( void)"
    return(C_to_Xen_guint((guint)gtk_get_micro_version()));
}

static Xen gxg_gtk_get_binary_age(void)
{
  #define H_gtk_get_binary_age "guint gtk_get_binary_age( void)"
    return(C_to_Xen_guint((guint)gtk_get_binary_age()));
}

static Xen gxg_gtk_get_interface_age(void)
{
  #define H_gtk_get_interface_age "guint gtk_get_interface_age( void)"
    return(C_to_Xen_guint((guint)gtk_get_interface_age()));
}

static Xen gxg_gtk_progress_bar_set_show_text(Xen pbar, Xen show_text)
{
  #define H_gtk_progress_bar_set_show_text "void gtk_progress_bar_set_show_text(GtkProgressBar* pbar, \
gboolean show_text)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_set_show_text", "GtkProgressBar*");
  Xen_check_type(Xen_is_gboolean(show_text), show_text, 2, "gtk_progress_bar_set_show_text", "gboolean");
  gtk_progress_bar_set_show_text(Xen_to_C_GtkProgressBar_(pbar), Xen_to_C_gboolean(show_text));
  return(Xen_false);
}

static Xen gxg_gtk_progress_bar_get_show_text(Xen pbar)
{
  #define H_gtk_progress_bar_get_show_text "gboolean gtk_progress_bar_get_show_text(GtkProgressBar* pbar)"
  Xen_check_type(Xen_is_GtkProgressBar_(pbar), pbar, 1, "gtk_progress_bar_get_show_text", "GtkProgressBar*");
  return(C_to_Xen_gboolean(gtk_progress_bar_get_show_text(Xen_to_C_GtkProgressBar_(pbar))));
}

static Xen gxg_gtk_entry_get_icon_storage_type(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_storage_type "GtkImageType gtk_entry_get_icon_storage_type(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_storage_type", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_storage_type", "GtkEntryIconPosition");
  return(C_to_Xen_GtkImageType(gtk_entry_get_icon_storage_type(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_entry_get_icon_gicon(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_gicon "GIcon* gtk_entry_get_icon_gicon(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_gicon", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_gicon", "GtkEntryIconPosition");
  return(C_to_Xen_GIcon_(gtk_entry_get_icon_gicon(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_container_set_focus_chain(Xen container, Xen focusable_widgets)
{
  #define H_gtk_container_set_focus_chain "void gtk_container_set_focus_chain(GtkContainer* container, \
GList* focusable_widgets)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_set_focus_chain", "GtkContainer*");
  Xen_check_type(Xen_is_GList_(focusable_widgets), focusable_widgets, 2, "gtk_container_set_focus_chain", "GList*");
  gtk_container_set_focus_chain(Xen_to_C_GtkContainer_(container), Xen_to_C_GList_(focusable_widgets));
  return(Xen_false);
}

static Xen gxg_gtk_container_get_focus_chain(Xen container, Xen ignore_focusable_widgets)
{
  #define H_gtk_container_get_focus_chain "gboolean gtk_container_get_focus_chain(GtkContainer* container, \
GList** [focusable_widgets])"
  GList* ref_focusable_widgets = NULL;
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_get_focus_chain", "GtkContainer*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_container_get_focus_chain(Xen_to_C_GtkContainer_(container), &ref_focusable_widgets));
    return(Xen_list_2(result, C_to_Xen_GList_(ref_focusable_widgets)));
   }
}

static Xen gxg_gtk_container_unset_focus_chain(Xen container)
{
  #define H_gtk_container_unset_focus_chain "void gtk_container_unset_focus_chain(GtkContainer* container)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_unset_focus_chain", "GtkContainer*");
  gtk_container_unset_focus_chain(Xen_to_C_GtkContainer_(container));
  return(Xen_false);
}

static Xen gxg_gtk_container_set_focus_vadjustment(Xen container, Xen adjustment)
{
  #define H_gtk_container_set_focus_vadjustment "void gtk_container_set_focus_vadjustment(GtkContainer* container, \
GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_set_focus_vadjustment", "GtkContainer*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_container_set_focus_vadjustment", "GtkAdjustment*");
  gtk_container_set_focus_vadjustment(Xen_to_C_GtkContainer_(container), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_container_get_focus_vadjustment(Xen container)
{
  #define H_gtk_container_get_focus_vadjustment "GtkAdjustment* gtk_container_get_focus_vadjustment(GtkContainer* container)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_get_focus_vadjustment", "GtkContainer*");
  return(C_to_Xen_GtkAdjustment_(gtk_container_get_focus_vadjustment(Xen_to_C_GtkContainer_(container))));
}

static Xen gxg_gtk_container_set_focus_hadjustment(Xen container, Xen adjustment)
{
  #define H_gtk_container_set_focus_hadjustment "void gtk_container_set_focus_hadjustment(GtkContainer* container, \
GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_set_focus_hadjustment", "GtkContainer*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_container_set_focus_hadjustment", "GtkAdjustment*");
  gtk_container_set_focus_hadjustment(Xen_to_C_GtkContainer_(container), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_container_get_focus_hadjustment(Xen container)
{
  #define H_gtk_container_get_focus_hadjustment "GtkAdjustment* gtk_container_get_focus_hadjustment(GtkContainer* container)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_get_focus_hadjustment", "GtkContainer*");
  return(C_to_Xen_GtkAdjustment_(gtk_container_get_focus_hadjustment(Xen_to_C_GtkContainer_(container))));
}

static Xen gxg_gtk_assistant_commit(Xen assistant)
{
  #define H_gtk_assistant_commit "void gtk_assistant_commit(GtkAssistant* assistant)"
  Xen_check_type(Xen_is_GtkAssistant_(assistant), assistant, 1, "gtk_assistant_commit", "GtkAssistant*");
  gtk_assistant_commit(Xen_to_C_GtkAssistant_(assistant));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_skip_taskbar_hint(Xen window, Xen setting)
{
  #define H_gtk_window_set_skip_taskbar_hint "void gtk_window_set_skip_taskbar_hint(GtkWindow* window, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_skip_taskbar_hint", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_skip_taskbar_hint", "gboolean");
  gtk_window_set_skip_taskbar_hint(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_skip_taskbar_hint(Xen window)
{
  #define H_gtk_window_get_skip_taskbar_hint "gboolean gtk_window_get_skip_taskbar_hint(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_skip_taskbar_hint", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_skip_taskbar_hint(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_skip_pager_hint(Xen window, Xen setting)
{
  #define H_gtk_window_set_skip_pager_hint "void gtk_window_set_skip_pager_hint(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_skip_pager_hint", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_skip_pager_hint", "gboolean");
  gtk_window_set_skip_pager_hint(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_skip_pager_hint(Xen window)
{
  #define H_gtk_window_get_skip_pager_hint "gboolean gtk_window_get_skip_pager_hint(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_skip_pager_hint", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_skip_pager_hint(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_icon_from_file(Xen window, Xen filename, Xen ignore_err)
{
  #define H_gtk_window_set_icon_from_file "gboolean gtk_window_set_icon_from_file(GtkWindow* window, \
gchar* filename, GError** [err])"
  GError* ref_err = NULL;
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_icon_from_file", "GtkWindow*");
  Xen_check_type(Xen_is_gchar_(filename), filename, 2, "gtk_window_set_icon_from_file", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_window_set_icon_from_file(Xen_to_C_GtkWindow_(window), (const gchar*)Xen_to_C_gchar_(filename), &ref_err));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_err)));
   }
}

static Xen gxg_gtk_window_set_default_icon_from_file(Xen filename, Xen ignore_err)
{
  #define H_gtk_window_set_default_icon_from_file "gboolean gtk_window_set_default_icon_from_file(gchar* filename, \
GError** [err])"
  GError* ref_err = NULL;
  Xen_check_type(Xen_is_gchar_(filename), filename, 1, "gtk_window_set_default_icon_from_file", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_window_set_default_icon_from_file((const gchar*)Xen_to_C_gchar_(filename), &ref_err));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_err)));
   }
}

static Xen gxg_gtk_window_fullscreen(Xen window)
{
  #define H_gtk_window_fullscreen "void gtk_window_fullscreen(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_fullscreen", "GtkWindow*");
  gtk_window_fullscreen(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_unfullscreen(Xen window)
{
  #define H_gtk_window_unfullscreen "void gtk_window_unfullscreen(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_unfullscreen", "GtkWindow*");
  gtk_window_unfullscreen(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_window_type(Xen window)
{
  #define H_gtk_window_get_window_type "GtkWindowType gtk_window_get_window_type(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_window_type", "GtkWindow*");
  return(C_to_Xen_GtkWindowType(gtk_window_get_window_type(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_group_add_window(Xen window_group, Xen window)
{
  #define H_gtk_window_group_add_window "void gtk_window_group_add_window(GtkWindowGroup* window_group, \
GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindowGroup_(window_group), window_group, 1, "gtk_window_group_add_window", "GtkWindowGroup*");
  Xen_check_type(Xen_is_GtkWindow_(window), window, 2, "gtk_window_group_add_window", "GtkWindow*");
  gtk_window_group_add_window(Xen_to_C_GtkWindowGroup_(window_group), Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_group_remove_window(Xen window_group, Xen window)
{
  #define H_gtk_window_group_remove_window "void gtk_window_group_remove_window(GtkWindowGroup* window_group, \
GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindowGroup_(window_group), window_group, 1, "gtk_window_group_remove_window", "GtkWindowGroup*");
  Xen_check_type(Xen_is_GtkWindow_(window), window, 2, "gtk_window_group_remove_window", "GtkWindow*");
  gtk_window_group_remove_window(Xen_to_C_GtkWindowGroup_(window_group), Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_window_group_new(void)
{
  #define H_gtk_window_group_new "GtkWindowGroup* gtk_window_group_new( void)"
  return(C_to_Xen_GtkWindowGroup_(gtk_window_group_new()));
}

static Xen gxg_gtk_window_get_group(Xen window)
{
  #define H_gtk_window_get_group "GtkWindowGroup* gtk_window_get_group(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_group", "GtkWindow*");
  return(C_to_Xen_GtkWindowGroup_(gtk_window_get_group(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_group_list_windows(Xen window_group)
{
  #define H_gtk_window_group_list_windows "GList* gtk_window_group_list_windows(GtkWindowGroup* window_group)"
  Xen_check_type(Xen_is_GtkWindowGroup_(window_group), window_group, 1, "gtk_window_group_list_windows", "GtkWindowGroup*");
  return(C_to_Xen_GList_(gtk_window_group_list_windows(Xen_to_C_GtkWindowGroup_(window_group))));
}

static Xen gxg_gtk_window_group_get_current_device_grab(Xen window_group, Xen device)
{
  #define H_gtk_window_group_get_current_device_grab "GtkWidget* gtk_window_group_get_current_device_grab(GtkWindowGroup* window_group, \
GdkDevice* device)"
  Xen_check_type(Xen_is_GtkWindowGroup_(window_group), window_group, 1, "gtk_window_group_get_current_device_grab", "GtkWindowGroup*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gtk_window_group_get_current_device_grab", "GdkDevice*");
  return(C_to_Xen_GtkWidget_(gtk_window_group_get_current_device_grab(Xen_to_C_GtkWindowGroup_(window_group), Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gtk_window_group_get_current_grab(Xen window_group)
{
  #define H_gtk_window_group_get_current_grab "GtkWidget* gtk_window_group_get_current_grab(GtkWindowGroup* window_group)"
  Xen_check_type(Xen_is_GtkWindowGroup_(window_group), window_group, 1, "gtk_window_group_get_current_grab", "GtkWindowGroup*");
  return(C_to_Xen_GtkWidget_(gtk_window_group_get_current_grab(Xen_to_C_GtkWindowGroup_(window_group))));
}

static Xen gxg_gtk_selection_data_get_data(Xen selection_data)
{
  #define H_gtk_selection_data_get_data "guchar* gtk_selection_data_get_data(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_data", "GtkSelectionData*");
  return(C_to_Xen_guchar_(gtk_selection_data_get_data(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_tool_shell_get_text_orientation(Xen shell)
{
  #define H_gtk_tool_shell_get_text_orientation "GtkOrientation gtk_tool_shell_get_text_orientation(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_get_text_orientation", "GtkToolShell*");
  return(C_to_Xen_GtkOrientation(gtk_tool_shell_get_text_orientation(Xen_to_C_GtkToolShell_(shell))));
}

static Xen gxg_gtk_tool_shell_get_text_alignment(Xen shell)
{
  #define H_gtk_tool_shell_get_text_alignment "gfloat gtk_tool_shell_get_text_alignment(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_get_text_alignment", "GtkToolShell*");
  return(C_to_Xen_gfloat(gtk_tool_shell_get_text_alignment(Xen_to_C_GtkToolShell_(shell))));
}

static Xen gxg_gtk_tool_shell_get_ellipsize_mode(Xen shell)
{
  #define H_gtk_tool_shell_get_ellipsize_mode "PangoEllipsizeMode gtk_tool_shell_get_ellipsize_mode(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_get_ellipsize_mode", "GtkToolShell*");
  return(C_to_Xen_PangoEllipsizeMode(gtk_tool_shell_get_ellipsize_mode(Xen_to_C_GtkToolShell_(shell))));
}

static Xen gxg_gtk_tool_shell_get_text_size_group(Xen shell)
{
  #define H_gtk_tool_shell_get_text_size_group "GtkSizeGroup* gtk_tool_shell_get_text_size_group(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_get_text_size_group", "GtkToolShell*");
  return(C_to_Xen_GtkSizeGroup_(gtk_tool_shell_get_text_size_group(Xen_to_C_GtkToolShell_(shell))));
}

static Xen gxg_gtk_tool_shell_get_orientation(Xen shell)
{
  #define H_gtk_tool_shell_get_orientation "GtkOrientation gtk_tool_shell_get_orientation(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_get_orientation", "GtkToolShell*");
  return(C_to_Xen_GtkOrientation(gtk_tool_shell_get_orientation(Xen_to_C_GtkToolShell_(shell))));
}

static Xen gxg_gtk_tool_shell_get_style(Xen shell)
{
  #define H_gtk_tool_shell_get_style "GtkToolbarStyle gtk_tool_shell_get_style(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_get_style", "GtkToolShell*");
  return(C_to_Xen_GtkToolbarStyle(gtk_tool_shell_get_style(Xen_to_C_GtkToolShell_(shell))));
}

static Xen gxg_gtk_tool_shell_rebuild_menu(Xen shell)
{
  #define H_gtk_tool_shell_rebuild_menu "void gtk_tool_shell_rebuild_menu(GtkToolShell* shell)"
  Xen_check_type(Xen_is_GtkToolShell_(shell), shell, 1, "gtk_tool_shell_rebuild_menu", "GtkToolShell*");
  gtk_tool_shell_rebuild_menu(Xen_to_C_GtkToolShell_(shell));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_lock_path(Xen accel_path)
{
  #define H_gtk_accel_map_lock_path "void gtk_accel_map_lock_path(gchar* accel_path)"
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 1, "gtk_accel_map_lock_path", "gchar*");
  gtk_accel_map_lock_path((const gchar*)Xen_to_C_gchar_(accel_path));
  return(Xen_false);
}

static Xen gxg_gtk_accel_map_unlock_path(Xen accel_path)
{
  #define H_gtk_accel_map_unlock_path "void gtk_accel_map_unlock_path(gchar* accel_path)"
  Xen_check_type(Xen_is_gchar_(accel_path), accel_path, 1, "gtk_accel_map_unlock_path", "gchar*");
  gtk_accel_map_unlock_path((const gchar*)Xen_to_C_gchar_(accel_path));
  return(Xen_false);
}

static Xen gxg_gtk_icon_theme_lookup_by_gicon(Xen icon_theme, Xen icon, Xen size, Xen flags)
{
  #define H_gtk_icon_theme_lookup_by_gicon "GtkIconInfo* gtk_icon_theme_lookup_by_gicon(GtkIconTheme* icon_theme, \
GIcon* icon, gint size, GtkIconLookupFlags flags)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_lookup_by_gicon", "GtkIconTheme*");
  Xen_check_type(Xen_is_GIcon_(icon), icon, 2, "gtk_icon_theme_lookup_by_gicon", "GIcon*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_lookup_by_gicon", "gint");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 4, "gtk_icon_theme_lookup_by_gicon", "GtkIconLookupFlags");
  return(C_to_Xen_GtkIconInfo_(gtk_icon_theme_lookup_by_gicon(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_GIcon_(icon), 
                                                              Xen_to_C_gint(size), Xen_to_C_GtkIconLookupFlags(flags))));
}

static Xen gxg_gtk_icon_info_new_for_pixbuf(Xen icon_theme, Xen pixbuf)
{
  #define H_gtk_icon_info_new_for_pixbuf "GtkIconInfo* gtk_icon_info_new_for_pixbuf(GtkIconTheme* icon_theme, \
GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_info_new_for_pixbuf", "GtkIconTheme*");
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 2, "gtk_icon_info_new_for_pixbuf", "GdkPixbuf*");
  return(C_to_Xen_GtkIconInfo_(gtk_icon_info_new_for_pixbuf(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gtk_icon_view_set_item_orientation(Xen icon_view, Xen orientation)
{
  #define H_gtk_icon_view_set_item_orientation "void gtk_icon_view_set_item_orientation(GtkIconView* icon_view, \
GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_item_orientation", "GtkIconView*");
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 2, "gtk_icon_view_set_item_orientation", "GtkOrientation");
  gtk_icon_view_set_item_orientation(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkOrientation(orientation));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_item_orientation(Xen icon_view)
{
  #define H_gtk_icon_view_get_item_orientation "GtkOrientation gtk_icon_view_get_item_orientation(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_item_orientation", "GtkIconView*");
  return(C_to_Xen_GtkOrientation(gtk_icon_view_get_item_orientation(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_text_view_im_context_filter_keypress(Xen text_view, Xen event)
{
  #define H_gtk_text_view_im_context_filter_keypress "gboolean gtk_text_view_im_context_filter_keypress(GtkTextView* text_view, \
GdkEventKey* event)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_im_context_filter_keypress", "GtkTextView*");
  Xen_check_type(Xen_is_GdkEventKey_(event), event, 2, "gtk_text_view_im_context_filter_keypress", "GdkEventKey*");
  return(C_to_Xen_gboolean(gtk_text_view_im_context_filter_keypress(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GdkEventKey_(event))));
}

static Xen gxg_gtk_text_view_reset_im_context(Xen text_view)
{
  #define H_gtk_text_view_reset_im_context "void gtk_text_view_reset_im_context(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_reset_im_context", "GtkTextView*");
  gtk_text_view_reset_im_context(Xen_to_C_GtkTextView_(text_view));
  return(Xen_false);
}

static Xen gxg_gdk_device_get_window_at_position(Xen device, Xen ignore_win_x, Xen ignore_win_y)
{
  #define H_gdk_device_get_window_at_position "GdkWindow* gdk_device_get_window_at_position(GdkDevice* device, \
gint* [win_x], gint* [win_y])"
  gint ref_win_x;
  gint ref_win_y;
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_window_at_position", "GdkDevice*");
  {
    Xen result;
    result = C_to_Xen_GdkWindow_(gdk_device_get_window_at_position(Xen_to_C_GdkDevice_(device), &ref_win_x, &ref_win_y));
    return(Xen_list_3(result, C_to_Xen_gint(ref_win_x), C_to_Xen_gint(ref_win_y)));
   }
}

static Xen gxg_gtk_cell_view_get_draw_sensitive(Xen cell_view)
{
  #define H_gtk_cell_view_get_draw_sensitive "gboolean gtk_cell_view_get_draw_sensitive(GtkCellView* cell_view)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_get_draw_sensitive", "GtkCellView*");
  return(C_to_Xen_gboolean(gtk_cell_view_get_draw_sensitive(Xen_to_C_GtkCellView_(cell_view))));
}

static Xen gxg_gtk_cell_view_set_draw_sensitive(Xen cell_view, Xen draw_sensitive)
{
  #define H_gtk_cell_view_set_draw_sensitive "void gtk_cell_view_set_draw_sensitive(GtkCellView* cell_view, \
gboolean draw_sensitive)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_set_draw_sensitive", "GtkCellView*");
  Xen_check_type(Xen_is_gboolean(draw_sensitive), draw_sensitive, 2, "gtk_cell_view_set_draw_sensitive", "gboolean");
  gtk_cell_view_set_draw_sensitive(Xen_to_C_GtkCellView_(cell_view), Xen_to_C_gboolean(draw_sensitive));
  return(Xen_false);
}

static Xen gxg_gtk_cell_view_get_fit_model(Xen cell_view)
{
  #define H_gtk_cell_view_get_fit_model "gboolean gtk_cell_view_get_fit_model(GtkCellView* cell_view)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_get_fit_model", "GtkCellView*");
  return(C_to_Xen_gboolean(gtk_cell_view_get_fit_model(Xen_to_C_GtkCellView_(cell_view))));
}

static Xen gxg_gtk_cell_view_set_fit_model(Xen cell_view, Xen fit_model)
{
  #define H_gtk_cell_view_set_fit_model "void gtk_cell_view_set_fit_model(GtkCellView* cell_view, gboolean fit_model)"
  Xen_check_type(Xen_is_GtkCellView_(cell_view), cell_view, 1, "gtk_cell_view_set_fit_model", "GtkCellView*");
  Xen_check_type(Xen_is_gboolean(fit_model), fit_model, 2, "gtk_cell_view_set_fit_model", "gboolean");
  gtk_cell_view_set_fit_model(Xen_to_C_GtkCellView_(cell_view), Xen_to_C_gboolean(fit_model));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_new_with_area(Xen area)
{
  #define H_gtk_icon_view_new_with_area "GtkWidget* gtk_icon_view_new_with_area(GtkCellArea* area)"
  Xen_check_type(Xen_is_GtkCellArea_(area), area, 1, "gtk_icon_view_new_with_area", "GtkCellArea*");
  return(C_to_Xen_GtkWidget_(gtk_icon_view_new_with_area(Xen_to_C_GtkCellArea_(area))));
}

static Xen gxg_gtk_menu_item_set_reserve_indicator(Xen menu_item, Xen reserve)
{
  #define H_gtk_menu_item_set_reserve_indicator "void gtk_menu_item_set_reserve_indicator(GtkMenuItem* menu_item, \
gboolean reserve)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_set_reserve_indicator", "GtkMenuItem*");
  Xen_check_type(Xen_is_gboolean(reserve), reserve, 2, "gtk_menu_item_set_reserve_indicator", "gboolean");
  gtk_menu_item_set_reserve_indicator(Xen_to_C_GtkMenuItem_(menu_item), Xen_to_C_gboolean(reserve));
  return(Xen_false);
}

static Xen gxg_gtk_menu_item_get_reserve_indicator(Xen menu_item)
{
  #define H_gtk_menu_item_get_reserve_indicator "gboolean gtk_menu_item_get_reserve_indicator(GtkMenuItem* menu_item)"
  Xen_check_type(Xen_is_GtkMenuItem_(menu_item), menu_item, 1, "gtk_menu_item_get_reserve_indicator", "GtkMenuItem*");
  return(C_to_Xen_gboolean(gtk_menu_item_get_reserve_indicator(Xen_to_C_GtkMenuItem_(menu_item))));
}

static Xen gxg_gtk_menu_shell_get_selected_item(Xen menu_shell)
{
  #define H_gtk_menu_shell_get_selected_item "GtkWidget* gtk_menu_shell_get_selected_item(GtkMenuShell* menu_shell)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_get_selected_item", "GtkMenuShell*");
  return(C_to_Xen_GtkWidget_(gtk_menu_shell_get_selected_item(Xen_to_C_GtkMenuShell_(menu_shell))));
}

static Xen gxg_gtk_menu_shell_get_parent_shell(Xen menu_shell)
{
  #define H_gtk_menu_shell_get_parent_shell "GtkWidget* gtk_menu_shell_get_parent_shell(GtkMenuShell* menu_shell)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_get_parent_shell", "GtkMenuShell*");
  return(C_to_Xen_GtkWidget_(gtk_menu_shell_get_parent_shell(Xen_to_C_GtkMenuShell_(menu_shell))));
}

static Xen gxg_gtk_selection_data_get_data_with_length(Xen selection_data, Xen ignore_length)
{
  #define H_gtk_selection_data_get_data_with_length "guchar* gtk_selection_data_get_data_with_length(GtkSelectionData* selection_data, \
gint* [length])"
  gint ref_length;
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_data_with_length", "GtkSelectionData*");
  {
    Xen result;
    result = C_to_Xen_guchar_(gtk_selection_data_get_data_with_length(Xen_to_C_GtkSelectionData_(selection_data), &ref_length));
    return(Xen_list_2(result, C_to_Xen_gint(ref_length)));
   }
}

static Xen gxg_gtk_tree_model_iter_previous(Xen tree_model, Xen iter)
{
  #define H_gtk_tree_model_iter_previous "gboolean gtk_tree_model_iter_previous(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_iter_previous", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 2, "gtk_tree_model_iter_previous", "GtkTreeIter*");
  return(C_to_Xen_gboolean(gtk_tree_model_iter_previous(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreeIter_(iter))));
}

static Xen gxg_gtk_tree_view_is_blank_at_pos(Xen tree_view, Xen x, Xen y, Xen ignore_path, Xen ignore_column, Xen ignore_cell_x, Xen ignore_cell_y)
{
  #define H_gtk_tree_view_is_blank_at_pos "gboolean gtk_tree_view_is_blank_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_is_blank_at_pos", "GtkTreeView*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_tree_view_is_blank_at_pos", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_tree_view_is_blank_at_pos", "gint");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_tree_view_is_blank_at_pos(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gint(x), Xen_to_C_gint(y), 
                                                             &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
    return(Xen_list_5(result, C_to_Xen_GtkTreePath_(ref_path), C_to_Xen_GtkTreeViewColumn_(ref_column), C_to_Xen_gint(ref_cell_x), C_to_Xen_gint(ref_cell_y)));
   }
}

static Xen gxg_gtk_window_set_has_user_ref_count(Xen window, Xen setting)
{
  #define H_gtk_window_set_has_user_ref_count "void gtk_window_set_has_user_ref_count(GtkWindow* window, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_has_user_ref_count", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_has_user_ref_count", "gboolean");
  gtk_window_set_has_user_ref_count(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gdk_rgba_copy(Xen rgba)
{
  #define H_gdk_rgba_copy "GdkRGBA* gdk_rgba_copy(GdkRGBA* rgba)"
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 1, "gdk_rgba_copy", "GdkRGBA*");
  return(C_to_Xen_GdkRGBA_(gdk_rgba_copy(Xen_to_C_GdkRGBA_(rgba))));
}

static Xen gxg_gdk_rgba_free(Xen rgba)
{
  #define H_gdk_rgba_free "void gdk_rgba_free(GdkRGBA* rgba)"
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 1, "gdk_rgba_free", "GdkRGBA*");
  gdk_rgba_free(Xen_to_C_GdkRGBA_(rgba));
  return(Xen_false);
}

static Xen gxg_gdk_rgba_parse(Xen rgba, Xen spec)
{
  #define H_gdk_rgba_parse "gboolean gdk_rgba_parse(GdkRGBA* rgba, gchar* spec)"
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 1, "gdk_rgba_parse", "GdkRGBA*");
  Xen_check_type(Xen_is_gchar_(spec), spec, 2, "gdk_rgba_parse", "gchar*");
  return(C_to_Xen_gboolean(gdk_rgba_parse(Xen_to_C_GdkRGBA_(rgba), (const gchar*)Xen_to_C_gchar_(spec))));
}

static Xen gxg_gdk_rgba_to_string(Xen rgba)
{
  #define H_gdk_rgba_to_string "gchar* gdk_rgba_to_string(GdkRGBA* rgba)"
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 1, "gdk_rgba_to_string", "GdkRGBA*");
  return(C_to_Xen_gchar_(gdk_rgba_to_string(Xen_to_C_GdkRGBA_(rgba))));
}

static Xen gxg_gtk_widget_set_state_flags(Xen widget, Xen flags, Xen clear)
{
  #define H_gtk_widget_set_state_flags "void gtk_widget_set_state_flags(GtkWidget* widget, GtkStateFlags flags, \
gboolean clear)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_state_flags", "GtkWidget*");
  Xen_check_type(Xen_is_GtkStateFlags(flags), flags, 2, "gtk_widget_set_state_flags", "GtkStateFlags");
  Xen_check_type(Xen_is_gboolean(clear), clear, 3, "gtk_widget_set_state_flags", "gboolean");
  gtk_widget_set_state_flags(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkStateFlags(flags), Xen_to_C_gboolean(clear));
  return(Xen_false);
}

static Xen gxg_gtk_widget_unset_state_flags(Xen widget, Xen flags)
{
  #define H_gtk_widget_unset_state_flags "void gtk_widget_unset_state_flags(GtkWidget* widget, GtkStateFlags flags)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_unset_state_flags", "GtkWidget*");
  Xen_check_type(Xen_is_GtkStateFlags(flags), flags, 2, "gtk_widget_unset_state_flags", "GtkStateFlags");
  gtk_widget_unset_state_flags(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkStateFlags(flags));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_state_flags(Xen widget)
{
  #define H_gtk_widget_get_state_flags "GtkStateFlags gtk_widget_get_state_flags(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_state_flags", "GtkWidget*");
  return(C_to_Xen_GtkStateFlags(gtk_widget_get_state_flags(Xen_to_C_GtkWidget_(widget))));
}

#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static Xen gxg_gtk_entry_get_placeholder_text(Xen entry)
{
  #define H_gtk_entry_get_placeholder_text "gchar* gtk_entry_get_placeholder_text(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_placeholder_text", "GtkEntry*");
  return(C_to_Xen_gchar_(gtk_entry_get_placeholder_text(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_placeholder_text(Xen entry, Xen text)
{
  #define H_gtk_entry_set_placeholder_text "void gtk_entry_set_placeholder_text(GtkEntry* entry, gchar* text)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_placeholder_text", "GtkEntry*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_entry_set_placeholder_text", "gchar*");
  gtk_entry_set_placeholder_text(Xen_to_C_GtkEntry_(entry), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_expander_set_resize_toplevel(Xen expander, Xen resize_toplevel)
{
  #define H_gtk_expander_set_resize_toplevel "void gtk_expander_set_resize_toplevel(GtkExpander* expander, \
gboolean resize_toplevel)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_set_resize_toplevel", "GtkExpander*");
  Xen_check_type(Xen_is_gboolean(resize_toplevel), resize_toplevel, 2, "gtk_expander_set_resize_toplevel", "gboolean");
  gtk_expander_set_resize_toplevel(Xen_to_C_GtkExpander_(expander), Xen_to_C_gboolean(resize_toplevel));
  return(Xen_false);
}

static Xen gxg_gtk_expander_get_resize_toplevel(Xen expander)
{
  #define H_gtk_expander_get_resize_toplevel "gboolean gtk_expander_get_resize_toplevel(GtkExpander* expander)"
  Xen_check_type(Xen_is_GtkExpander_(expander), expander, 1, "gtk_expander_get_resize_toplevel", "GtkExpander*");
  return(C_to_Xen_gboolean(gtk_expander_get_resize_toplevel(Xen_to_C_GtkExpander_(expander))));
}

static Xen gxg_gtk_widget_path_to_string(Xen path)
{
  #define H_gtk_widget_path_to_string "char* gtk_widget_path_to_string(GtkWidgetPath* path)"
  Xen_check_type(Xen_is_GtkWidgetPath_(path), path, 1, "gtk_widget_path_to_string", "GtkWidgetPath*");
  return(C_to_Xen_char_(gtk_widget_path_to_string(Xen_to_C_GtkWidgetPath_(path))));
}

static Xen gxg_gtk_button_box_get_child_non_homogeneous(Xen widget, Xen child)
{
  #define H_gtk_button_box_get_child_non_homogeneous "gboolean gtk_button_box_get_child_non_homogeneous(GtkButtonBox* widget, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkButtonBox_(widget), widget, 1, "gtk_button_box_get_child_non_homogeneous", "GtkButtonBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_button_box_get_child_non_homogeneous", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_button_box_get_child_non_homogeneous(Xen_to_C_GtkButtonBox_(widget), Xen_to_C_GtkWidget_(child))));
}

static Xen gxg_gtk_button_box_set_child_non_homogeneous(Xen widget, Xen child, Xen non_homogeneous)
{
  #define H_gtk_button_box_set_child_non_homogeneous "void gtk_button_box_set_child_non_homogeneous(GtkButtonBox* widget, \
GtkWidget* child, gboolean non_homogeneous)"
  Xen_check_type(Xen_is_GtkButtonBox_(widget), widget, 1, "gtk_button_box_set_child_non_homogeneous", "GtkButtonBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_button_box_set_child_non_homogeneous", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(non_homogeneous), non_homogeneous, 3, "gtk_button_box_set_child_non_homogeneous", "gboolean");
  gtk_button_box_set_child_non_homogeneous(Xen_to_C_GtkButtonBox_(widget), Xen_to_C_GtkWidget_(child), Xen_to_C_gboolean(non_homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_container_child_notify(Xen container, Xen child, Xen property_name)
{
  #define H_gtk_container_child_notify "void gtk_container_child_notify(GtkContainer* container, GtkWidget* child, \
gchar* property_name)"
  Xen_check_type(Xen_is_GtkContainer_(container), container, 1, "gtk_container_child_notify", "GtkContainer*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_container_child_notify", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(property_name), property_name, 3, "gtk_container_child_notify", "gchar*");
  gtk_container_child_notify(Xen_to_C_GtkContainer_(container), Xen_to_C_GtkWidget_(child), (const gchar*)Xen_to_C_gchar_(property_name));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_set_icon_gicon(Xen widget, Xen icon)
{
  #define H_gtk_drag_source_set_icon_gicon "void gtk_drag_source_set_icon_gicon(GtkWidget* widget, GIcon* icon)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_set_icon_gicon", "GtkWidget*");
  Xen_check_type(Xen_is_GIcon_(icon), icon, 2, "gtk_drag_source_set_icon_gicon", "GIcon*");
  gtk_drag_source_set_icon_gicon(Xen_to_C_GtkWidget_(widget), Xen_to_C_GIcon_(icon));
  return(Xen_false);
}

static Xen gxg_gtk_drag_set_icon_gicon(Xen context, Xen icon, Xen hot_x, Xen hot_y)
{
  #define H_gtk_drag_set_icon_gicon "void gtk_drag_set_icon_gicon(GdkDragContext* context, GIcon* icon, \
gint hot_x, gint hot_y)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_set_icon_gicon", "GdkDragContext*");
  Xen_check_type(Xen_is_GIcon_(icon), icon, 2, "gtk_drag_set_icon_gicon", "GIcon*");
  Xen_check_type(Xen_is_gint(hot_x), hot_x, 3, "gtk_drag_set_icon_gicon", "gint");
  Xen_check_type(Xen_is_gint(hot_y), hot_y, 4, "gtk_drag_set_icon_gicon", "gint");
  gtk_drag_set_icon_gicon(Xen_to_C_GdkDragContext_(context), Xen_to_C_GIcon_(icon), Xen_to_C_gint(hot_x), Xen_to_C_gint(hot_y));
  return(Xen_false);
}

static Xen gxg_gtk_combo_box_set_active_id(Xen combo_box, Xen active_id)
{
  #define H_gtk_combo_box_set_active_id "gboolean gtk_combo_box_set_active_id(GtkComboBox* combo_box, \
gchar* active_id)"
  Xen_check_type(Xen_is_GtkComboBox_(combo_box), combo_box, 1, "gtk_combo_box_set_active_id", "GtkComboBox*");
  Xen_check_type(Xen_is_gchar_(active_id), active_id, 2, "gtk_combo_box_set_active_id", "gchar*");
  return(C_to_Xen_gboolean(gtk_combo_box_set_active_id(Xen_to_C_GtkComboBox_(combo_box), (const gchar*)Xen_to_C_gchar_(active_id))));
}

static Xen gxg_gtk_tree_view_column_get_x_offset(Xen tree_column)
{
  #define H_gtk_tree_view_column_get_x_offset "gint gtk_tree_view_column_get_x_offset(GtkTreeViewColumn* tree_column)"
  Xen_check_type(Xen_is_GtkTreeViewColumn_(tree_column), tree_column, 1, "gtk_tree_view_column_get_x_offset", "GtkTreeViewColumn*");
  return(C_to_Xen_gint(gtk_tree_view_column_get_x_offset(Xen_to_C_GtkTreeViewColumn_(tree_column))));
}

static Xen gxg_gtk_overlay_new(void)
{
  #define H_gtk_overlay_new "GtkWidget* gtk_overlay_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_overlay_new()));
}

static Xen gxg_gtk_overlay_add_overlay(Xen overlay, Xen widget)
{
  #define H_gtk_overlay_add_overlay "void gtk_overlay_add_overlay(GtkOverlay* overlay, GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkOverlay_(overlay), overlay, 1, "gtk_overlay_add_overlay", "GtkOverlay*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_overlay_add_overlay", "GtkWidget*");
  gtk_overlay_add_overlay(Xen_to_C_GtkOverlay_(overlay), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_adjustment_get_minimum_increment(Xen adjustment)
{
  #define H_gtk_adjustment_get_minimum_increment "gdouble gtk_adjustment_get_minimum_increment(GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 1, "gtk_adjustment_get_minimum_increment", "GtkAdjustment*");
  return(C_to_Xen_gdouble(gtk_adjustment_get_minimum_increment(Xen_to_C_GtkAdjustment_(adjustment))));
}

static Xen gxg_gtk_grid_insert_row(Xen grid, Xen position)
{
  #define H_gtk_grid_insert_row "void gtk_grid_insert_row(GtkGrid* grid, gint position)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_insert_row", "GtkGrid*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_grid_insert_row", "gint");
  gtk_grid_insert_row(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_grid_insert_column(Xen grid, Xen position)
{
  #define H_gtk_grid_insert_column "void gtk_grid_insert_column(GtkGrid* grid, gint position)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_insert_column", "GtkGrid*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_grid_insert_column", "gint");
  gtk_grid_insert_column(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_grid_insert_next_to(Xen grid, Xen sibling, Xen side)
{
  #define H_gtk_grid_insert_next_to "void gtk_grid_insert_next_to(GtkGrid* grid, GtkWidget* sibling, \
GtkPositionType side)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_insert_next_to", "GtkGrid*");
  Xen_check_type(Xen_is_GtkWidget_(sibling), sibling, 2, "gtk_grid_insert_next_to", "GtkWidget*");
  Xen_check_type(Xen_is_GtkPositionType(side), side, 3, "gtk_grid_insert_next_to", "GtkPositionType");
  gtk_grid_insert_next_to(Xen_to_C_GtkGrid_(grid), Xen_to_C_GtkWidget_(sibling), Xen_to_C_GtkPositionType(side));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_assign(Xen iter, Xen other)
{
  #define H_gtk_text_iter_assign "void gtk_text_iter_assign(GtkTextIter* iter, GtkTextIter* other)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_assign", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextIter_(other), other, 2, "gtk_text_iter_assign", "GtkTextIter*");
  gtk_text_iter_assign(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextIter_(other));
  return(Xen_false);
}

static Xen gxg_gtk_widget_has_visible_focus(Xen widget)
{
  #define H_gtk_widget_has_visible_focus "gboolean gtk_widget_has_visible_focus(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_has_visible_focus", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_has_visible_focus(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_window_set_focus_visible(Xen window, Xen setting)
{
  #define H_gtk_window_set_focus_visible "void gtk_window_set_focus_visible(GtkWindow* window, gboolean setting)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_focus_visible", "GtkWindow*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_window_set_focus_visible", "gboolean");
  gtk_window_set_focus_visible(Xen_to_C_GtkWindow_(window), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_focus_visible(Xen window)
{
  #define H_gtk_window_get_focus_visible "gboolean gtk_window_get_focus_visible(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_focus_visible", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_get_focus_visible(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_font_chooser_dialog_new(Xen title, Xen window)
{
  #define H_gtk_font_chooser_dialog_new "GtkWidget* gtk_font_chooser_dialog_new(gchar* title, GtkWindow* window)"
  Xen_check_type(Xen_is_gchar_(title), title, 1, "gtk_font_chooser_dialog_new", "gchar*");
  Xen_check_type(Xen_is_GtkWindow_(window), window, 2, "gtk_font_chooser_dialog_new", "GtkWindow*");
  return(C_to_Xen_GtkWidget_(gtk_font_chooser_dialog_new((const gchar*)Xen_to_C_gchar_(title), Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gdk_event_get_button(Xen event, Xen button)
{
  #define H_gdk_event_get_button "gboolean gdk_event_get_button(GdkEvent* event, guint* button)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_button", "GdkEvent*");
  Xen_check_type(Xen_is_guint_(button), button, 2, "gdk_event_get_button", "guint*");
  return(C_to_Xen_gboolean(gdk_event_get_button(Xen_to_C_GdkEvent_(event), Xen_to_C_guint_(button))));
}

static Xen gxg_gdk_event_get_click_count(Xen event, Xen click_count)
{
  #define H_gdk_event_get_click_count "gboolean gdk_event_get_click_count(GdkEvent* event, guint* click_count)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_click_count", "GdkEvent*");
  Xen_check_type(Xen_is_guint_(click_count), click_count, 2, "gdk_event_get_click_count", "guint*");
  return(C_to_Xen_gboolean(gdk_event_get_click_count(Xen_to_C_GdkEvent_(event), Xen_to_C_guint_(click_count))));
}

static Xen gxg_gdk_event_get_keyval(Xen event, Xen keyval)
{
  #define H_gdk_event_get_keyval "gboolean gdk_event_get_keyval(GdkEvent* event, guint* keyval)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_keyval", "GdkEvent*");
  Xen_check_type(Xen_is_guint_(keyval), keyval, 2, "gdk_event_get_keyval", "guint*");
  return(C_to_Xen_gboolean(gdk_event_get_keyval(Xen_to_C_GdkEvent_(event), Xen_to_C_guint_(keyval))));
}

static Xen gxg_gdk_event_get_keycode(Xen event, Xen keycode)
{
  #define H_gdk_event_get_keycode "gboolean gdk_event_get_keycode(GdkEvent* event, guint16* keycode)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_keycode", "GdkEvent*");
  Xen_check_type(Xen_is_guint16_(keycode), keycode, 2, "gdk_event_get_keycode", "guint16*");
  return(C_to_Xen_gboolean(gdk_event_get_keycode(Xen_to_C_GdkEvent_(event), Xen_to_C_guint16_(keycode))));
}

static Xen gxg_gdk_event_get_scroll_direction(Xen event, Xen ignore_direction)
{
  #define H_gdk_event_get_scroll_direction "gboolean gdk_event_get_scroll_direction(GdkEvent* event, \
GdkScrollDirection* [direction])"
  GdkScrollDirection ref_direction;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_scroll_direction", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_scroll_direction(Xen_to_C_GdkEvent_(event), &ref_direction));
    return(Xen_list_2(result, C_to_Xen_GdkScrollDirection(ref_direction)));
   }
}

static Xen gxg_gtk_grid_get_child_at(Xen grid, Xen left, Xen top)
{
  #define H_gtk_grid_get_child_at "GtkWidget* gtk_grid_get_child_at(GtkGrid* grid, gint left, gint top)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_child_at", "GtkGrid*");
  Xen_check_type(Xen_is_gint(left), left, 2, "gtk_grid_get_child_at", "gint");
  Xen_check_type(Xen_is_gint(top), top, 3, "gtk_grid_get_child_at", "gint");
  return(C_to_Xen_GtkWidget_(gtk_grid_get_child_at(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(left), Xen_to_C_gint(top))));
}

static Xen gxg_gtk_font_chooser_get_font_family(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_font_family "PangoFontFamily* gtk_font_chooser_get_font_family(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_font_family", "GtkFontChooser*");
  return(C_to_Xen_PangoFontFamily_(gtk_font_chooser_get_font_family(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_get_font_face(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_font_face "PangoFontFace* gtk_font_chooser_get_font_face(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_font_face", "GtkFontChooser*");
  return(C_to_Xen_PangoFontFace_(gtk_font_chooser_get_font_face(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_get_font_size(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_font_size "gint gtk_font_chooser_get_font_size(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_font_size", "GtkFontChooser*");
  return(C_to_Xen_gint(gtk_font_chooser_get_font_size(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_get_font_desc(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_font_desc "PangoFontDescription* gtk_font_chooser_get_font_desc(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_font_desc", "GtkFontChooser*");
  return(C_to_Xen_PangoFontDescription_(gtk_font_chooser_get_font_desc(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_set_font_desc(Xen fontchooser, Xen font_desc)
{
  #define H_gtk_font_chooser_set_font_desc "void gtk_font_chooser_set_font_desc(GtkFontChooser* fontchooser, \
PangoFontDescription* font_desc)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_set_font_desc", "GtkFontChooser*");
  Xen_check_type(Xen_is_PangoFontDescription_(font_desc), font_desc, 2, "gtk_font_chooser_set_font_desc", "PangoFontDescription*");
  gtk_font_chooser_set_font_desc(Xen_to_C_GtkFontChooser_(fontchooser), Xen_to_C_PangoFontDescription_(font_desc));
  return(Xen_false);
}

static Xen gxg_gtk_font_chooser_get_font(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_font "gchar* gtk_font_chooser_get_font(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_font", "GtkFontChooser*");
  return(C_to_Xen_gchar_(gtk_font_chooser_get_font(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_set_font(Xen fontchooser, Xen fontname)
{
  #define H_gtk_font_chooser_set_font "void gtk_font_chooser_set_font(GtkFontChooser* fontchooser, gchar* fontname)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_set_font", "GtkFontChooser*");
  Xen_check_type(Xen_is_gchar_(fontname), fontname, 2, "gtk_font_chooser_set_font", "gchar*");
  gtk_font_chooser_set_font(Xen_to_C_GtkFontChooser_(fontchooser), (const gchar*)Xen_to_C_gchar_(fontname));
  return(Xen_false);
}

static Xen gxg_gtk_font_chooser_get_preview_text(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_preview_text "gchar* gtk_font_chooser_get_preview_text(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_preview_text", "GtkFontChooser*");
  return(C_to_Xen_gchar_(gtk_font_chooser_get_preview_text(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_set_preview_text(Xen fontchooser, Xen text)
{
  #define H_gtk_font_chooser_set_preview_text "void gtk_font_chooser_set_preview_text(GtkFontChooser* fontchooser, \
gchar* text)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_set_preview_text", "GtkFontChooser*");
  Xen_check_type(Xen_is_gchar_(text), text, 2, "gtk_font_chooser_set_preview_text", "gchar*");
  gtk_font_chooser_set_preview_text(Xen_to_C_GtkFontChooser_(fontchooser), (const gchar*)Xen_to_C_gchar_(text));
  return(Xen_false);
}

static Xen gxg_gtk_font_chooser_get_show_preview_entry(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_show_preview_entry "gboolean gtk_font_chooser_get_show_preview_entry(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_show_preview_entry", "GtkFontChooser*");
  return(C_to_Xen_gboolean(gtk_font_chooser_get_show_preview_entry(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_font_chooser_set_show_preview_entry(Xen fontchooser, Xen show_preview_entry)
{
  #define H_gtk_font_chooser_set_show_preview_entry "void gtk_font_chooser_set_show_preview_entry(GtkFontChooser* fontchooser, \
gboolean show_preview_entry)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_set_show_preview_entry", "GtkFontChooser*");
  Xen_check_type(Xen_is_gboolean(show_preview_entry), show_preview_entry, 2, "gtk_font_chooser_set_show_preview_entry", "gboolean");
  gtk_font_chooser_set_show_preview_entry(Xen_to_C_GtkFontChooser_(fontchooser), Xen_to_C_gboolean(show_preview_entry));
  return(Xen_false);
}

static Xen gxg_gtk_font_chooser_widget_new(void)
{
  #define H_gtk_font_chooser_widget_new "GtkWidget* gtk_font_chooser_widget_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_font_chooser_widget_new()));
}

#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static Xen gxg_gdk_keymap_get_modifier_mask(Xen keymap, Xen intent)
{
  #define H_gdk_keymap_get_modifier_mask "GdkModifierType gdk_keymap_get_modifier_mask(GdkKeymap* keymap, \
GdkModifierIntent intent)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_modifier_mask", "GdkKeymap*");
  Xen_check_type(Xen_is_GdkModifierIntent(intent), intent, 2, "gdk_keymap_get_modifier_mask", "GdkModifierIntent");
  return(C_to_Xen_GdkModifierType(gdk_keymap_get_modifier_mask(Xen_to_C_GdkKeymap_(keymap), Xen_to_C_GdkModifierIntent(intent))));
}

static Xen gxg_gdk_window_begin_resize_drag_for_device(Xen window, Xen edge, Xen device, Xen button, Xen root_x, Xen root_y, Xen timestamp)
{
  #define H_gdk_window_begin_resize_drag_for_device "void gdk_window_begin_resize_drag_for_device(GdkWindow* window, \
GdkWindowEdge edge, GdkDevice* device, gint button, gint root_x, gint root_y, guint32 timestamp)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_begin_resize_drag_for_device", "GdkWindow*");
  Xen_check_type(Xen_is_GdkWindowEdge(edge), edge, 2, "gdk_window_begin_resize_drag_for_device", "GdkWindowEdge");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 3, "gdk_window_begin_resize_drag_for_device", "GdkDevice*");
  Xen_check_type(Xen_is_gint(button), button, 4, "gdk_window_begin_resize_drag_for_device", "gint");
  Xen_check_type(Xen_is_gint(root_x), root_x, 5, "gdk_window_begin_resize_drag_for_device", "gint");
  Xen_check_type(Xen_is_gint(root_y), root_y, 6, "gdk_window_begin_resize_drag_for_device", "gint");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 7, "gdk_window_begin_resize_drag_for_device", "guint32");
  gdk_window_begin_resize_drag_for_device(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkWindowEdge(edge), Xen_to_C_GdkDevice_(device), 
                                          Xen_to_C_gint(button), Xen_to_C_gint(root_x), Xen_to_C_gint(root_y), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gdk_window_begin_move_drag_for_device(Xen window, Xen device, Xen button, Xen root_x, Xen root_y, Xen timestamp)
{
  #define H_gdk_window_begin_move_drag_for_device "void gdk_window_begin_move_drag_for_device(GdkWindow* window, \
GdkDevice* device, gint button, gint root_x, gint root_y, guint32 timestamp)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_begin_move_drag_for_device", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_begin_move_drag_for_device", "GdkDevice*");
  Xen_check_type(Xen_is_gint(button), button, 3, "gdk_window_begin_move_drag_for_device", "gint");
  Xen_check_type(Xen_is_gint(root_x), root_x, 4, "gdk_window_begin_move_drag_for_device", "gint");
  Xen_check_type(Xen_is_gint(root_y), root_y, 5, "gdk_window_begin_move_drag_for_device", "gint");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 6, "gdk_window_begin_move_drag_for_device", "guint32");
  gdk_window_begin_move_drag_for_device(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device), Xen_to_C_gint(button), 
                                        Xen_to_C_gint(root_x), Xen_to_C_gint(root_y), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gtk_accelerator_parse_with_keycode(Xen accelerator, Xen accelerator_key, Xen accelerator_codes, Xen accelerator_mods)
{
  #define H_gtk_accelerator_parse_with_keycode "void gtk_accelerator_parse_with_keycode(gchar* accelerator, \
guint* accelerator_key, guint** accelerator_codes, GdkModifierType* accelerator_mods)"
  Xen_check_type(Xen_is_gchar_(accelerator), accelerator, 1, "gtk_accelerator_parse_with_keycode", "gchar*");
  Xen_check_type(Xen_is_guint_(accelerator_key), accelerator_key, 2, "gtk_accelerator_parse_with_keycode", "guint*");
  Xen_check_type(Xen_is_guint__(accelerator_codes), accelerator_codes, 3, "gtk_accelerator_parse_with_keycode", "guint**");
  Xen_check_type(Xen_is_GdkModifierType_(accelerator_mods), accelerator_mods, 4, "gtk_accelerator_parse_with_keycode", "GdkModifierType*");
  gtk_accelerator_parse_with_keycode((const gchar*)Xen_to_C_gchar_(accelerator), Xen_to_C_guint_(accelerator_key), Xen_to_C_guint__(accelerator_codes), 
                                     Xen_to_C_GdkModifierType_(accelerator_mods));
  return(Xen_false);
}

static Xen gxg_gtk_accelerator_name_with_keycode(Xen display, Xen accelerator_key, Xen keycode, Xen accelerator_mods)
{
  #define H_gtk_accelerator_name_with_keycode "gchar* gtk_accelerator_name_with_keycode(GdkDisplay* display, \
guint accelerator_key, guint keycode, GdkModifierType accelerator_mods)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_accelerator_name_with_keycode", "GdkDisplay*");
  Xen_check_type(Xen_is_guint(accelerator_key), accelerator_key, 2, "gtk_accelerator_name_with_keycode", "guint");
  Xen_check_type(Xen_is_guint(keycode), keycode, 3, "gtk_accelerator_name_with_keycode", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accelerator_mods), accelerator_mods, 4, "gtk_accelerator_name_with_keycode", "GdkModifierType");
  return(C_to_Xen_gchar_(gtk_accelerator_name_with_keycode(Xen_to_C_GdkDisplay_(display), Xen_to_C_guint(accelerator_key), 
                                                           Xen_to_C_guint(keycode), Xen_to_C_GdkModifierType(accelerator_mods))));
}

static Xen gxg_gtk_accelerator_get_label_with_keycode(Xen display, Xen accelerator_key, Xen keycode, Xen accelerator_mods)
{
  #define H_gtk_accelerator_get_label_with_keycode "gchar* gtk_accelerator_get_label_with_keycode(GdkDisplay* display, \
guint accelerator_key, guint keycode, GdkModifierType accelerator_mods)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_accelerator_get_label_with_keycode", "GdkDisplay*");
  Xen_check_type(Xen_is_guint(accelerator_key), accelerator_key, 2, "gtk_accelerator_get_label_with_keycode", "guint");
  Xen_check_type(Xen_is_guint(keycode), keycode, 3, "gtk_accelerator_get_label_with_keycode", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accelerator_mods), accelerator_mods, 4, "gtk_accelerator_get_label_with_keycode", "GdkModifierType");
  return(C_to_Xen_gchar_(gtk_accelerator_get_label_with_keycode(Xen_to_C_GdkDisplay_(display), Xen_to_C_guint(accelerator_key), 
                                                                Xen_to_C_guint(keycode), Xen_to_C_GdkModifierType(accelerator_mods))));
}

static Xen gxg_gtk_application_get_app_menu(Xen application)
{
  #define H_gtk_application_get_app_menu "GMenuModel* gtk_application_get_app_menu(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_app_menu", "GtkApplication*");
  return(C_to_Xen_GMenuModel_(gtk_application_get_app_menu(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_application_set_app_menu(Xen application, Xen model)
{
  #define H_gtk_application_set_app_menu "void gtk_application_set_app_menu(GtkApplication* application, \
GMenuModel* model)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_set_app_menu", "GtkApplication*");
  Xen_check_type(Xen_is_GMenuModel_(model), model, 2, "gtk_application_set_app_menu", "GMenuModel*");
  gtk_application_set_app_menu(Xen_to_C_GtkApplication_(application), Xen_to_C_GMenuModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_application_get_menubar(Xen application)
{
  #define H_gtk_application_get_menubar "GMenuModel* gtk_application_get_menubar(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_menubar", "GtkApplication*");
  return(C_to_Xen_GMenuModel_(gtk_application_get_menubar(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_application_set_menubar(Xen application, Xen model)
{
  #define H_gtk_application_set_menubar "void gtk_application_set_menubar(GtkApplication* application, \
GMenuModel* model)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_set_menubar", "GtkApplication*");
  Xen_check_type(Xen_is_GMenuModel_(model), model, 2, "gtk_application_set_menubar", "GMenuModel*");
  gtk_application_set_menubar(Xen_to_C_GtkApplication_(application), Xen_to_C_GMenuModel_(model));
  return(Xen_false);
}

static Xen gxg_gtk_entry_completion_compute_prefix(Xen completion, Xen key)
{
  #define H_gtk_entry_completion_compute_prefix "gchar* gtk_entry_completion_compute_prefix(GtkEntryCompletion* completion, \
char* key)"
  Xen_check_type(Xen_is_GtkEntryCompletion_(completion), completion, 1, "gtk_entry_completion_compute_prefix", "GtkEntryCompletion*");
  Xen_check_type(Xen_is_char_(key), key, 2, "gtk_entry_completion_compute_prefix", "char*");
  return(C_to_Xen_gchar_(gtk_entry_completion_compute_prefix(Xen_to_C_GtkEntryCompletion_(completion), (const char*)Xen_to_C_char_(key))));
}

static Xen gxg_gtk_scale_set_has_origin(Xen scale, Xen has_origin)
{
  #define H_gtk_scale_set_has_origin "void gtk_scale_set_has_origin(GtkScale* scale, gboolean has_origin)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_set_has_origin", "GtkScale*");
  Xen_check_type(Xen_is_gboolean(has_origin), has_origin, 2, "gtk_scale_set_has_origin", "gboolean");
  gtk_scale_set_has_origin(Xen_to_C_GtkScale_(scale), Xen_to_C_gboolean(has_origin));
  return(Xen_false);
}

static Xen gxg_gtk_scale_get_has_origin(Xen scale)
{
  #define H_gtk_scale_get_has_origin "gboolean gtk_scale_get_has_origin(GtkScale* scale)"
  Xen_check_type(Xen_is_GtkScale_(scale), scale, 1, "gtk_scale_get_has_origin", "GtkScale*");
  return(C_to_Xen_gboolean(gtk_scale_get_has_origin(Xen_to_C_GtkScale_(scale))));
}

static Xen gxg_gtk_application_window_new(Xen application)
{
  #define H_gtk_application_window_new "GtkWidget* gtk_application_window_new(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_window_new", "GtkApplication*");
  return(C_to_Xen_GtkWidget_(gtk_application_window_new(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_application_window_set_show_menubar(Xen window, Xen show_menubar)
{
  #define H_gtk_application_window_set_show_menubar "void gtk_application_window_set_show_menubar(GtkApplicationWindow* window, \
gboolean show_menubar)"
  Xen_check_type(Xen_is_GtkApplicationWindow_(window), window, 1, "gtk_application_window_set_show_menubar", "GtkApplicationWindow*");
  Xen_check_type(Xen_is_gboolean(show_menubar), show_menubar, 2, "gtk_application_window_set_show_menubar", "gboolean");
  gtk_application_window_set_show_menubar(Xen_to_C_GtkApplicationWindow_(window), Xen_to_C_gboolean(show_menubar));
  return(Xen_false);
}

static Xen gxg_gtk_application_window_get_show_menubar(Xen window)
{
  #define H_gtk_application_window_get_show_menubar "gboolean gtk_application_window_get_show_menubar(GtkApplicationWindow* window)"
  Xen_check_type(Xen_is_GtkApplicationWindow_(window), window, 1, "gtk_application_window_get_show_menubar", "GtkApplicationWindow*");
  return(C_to_Xen_gboolean(gtk_application_window_get_show_menubar(Xen_to_C_GtkApplicationWindow_(window))));
}

static Xen gxg_gtk_image_new_from_resource(Xen resource_path)
{
  #define H_gtk_image_new_from_resource "GtkWidget* gtk_image_new_from_resource(gchar* resource_path)"
  Xen_check_type(Xen_is_gchar_(resource_path), resource_path, 1, "gtk_image_new_from_resource", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_resource((const gchar*)Xen_to_C_gchar_(resource_path))));
}

static Xen gxg_gtk_image_set_from_resource(Xen image, Xen resource_path)
{
  #define H_gtk_image_set_from_resource "void gtk_image_set_from_resource(GtkImage* image, gchar* resource_path)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_resource", "GtkImage*");
  Xen_check_type(Xen_is_gchar_(resource_path), resource_path, 2, "gtk_image_set_from_resource", "gchar*");
  gtk_image_set_from_resource(Xen_to_C_GtkImage_(image), (const gchar*)Xen_to_C_gchar_(resource_path));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_attached_to(Xen window, Xen attach_widget)
{
  #define H_gtk_window_set_attached_to "void gtk_window_set_attached_to(GtkWindow* window, GtkWidget* attach_widget)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_attached_to", "GtkWindow*");
  Xen_check_type(Xen_is_GtkWidget_(attach_widget), attach_widget, 2, "gtk_window_set_attached_to", "GtkWidget*");
  gtk_window_set_attached_to(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkWidget_(attach_widget));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_attached_to(Xen window)
{
  #define H_gtk_window_get_attached_to "GtkWidget* gtk_window_get_attached_to(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_attached_to", "GtkWindow*");
  return(C_to_Xen_GtkWidget_(gtk_window_get_attached_to(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_about_dialog_add_credit_section(Xen about, Xen section_name, Xen people)
{
  #define H_gtk_about_dialog_add_credit_section "void gtk_about_dialog_add_credit_section(GtkAboutDialog* about, \
gchar* section_name, gchar** people)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_add_credit_section", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(section_name), section_name, 2, "gtk_about_dialog_add_credit_section", "gchar*");
  Xen_check_type(Xen_is_gchar__(people), people, 3, "gtk_about_dialog_add_credit_section", "gchar**");
  gtk_about_dialog_add_credit_section(Xen_to_C_GtkAboutDialog_(about), (const gchar*)Xen_to_C_gchar_(section_name), (const gchar**)Xen_to_C_gchar__(people));
  return(Xen_false);
}

static Xen gxg_gdk_keymap_get_modifier_state(Xen keymap)
{
  #define H_gdk_keymap_get_modifier_state "guint gdk_keymap_get_modifier_state(GdkKeymap* keymap)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_modifier_state", "GdkKeymap*");
  return(C_to_Xen_guint(gdk_keymap_get_modifier_state(Xen_to_C_GdkKeymap_(keymap))));
}

static Xen gxg_gtk_hsv_to_rgb(Xen h, Xen s, Xen v, Xen ignore_r, Xen ignore_g, Xen ignore_b)
{
  #define H_gtk_hsv_to_rgb "void gtk_hsv_to_rgb(gdouble h, gdouble s, gdouble v, gdouble* [r], gdouble* [g], \
gdouble* [b])"
  gdouble ref_r;
  gdouble ref_g;
  gdouble ref_b;
  Xen_check_type(Xen_is_gdouble(h), h, 1, "gtk_hsv_to_rgb", "gdouble");
  Xen_check_type(Xen_is_gdouble(s), s, 2, "gtk_hsv_to_rgb", "gdouble");
  Xen_check_type(Xen_is_gdouble(v), v, 3, "gtk_hsv_to_rgb", "gdouble");
  gtk_hsv_to_rgb(Xen_to_C_gdouble(h), Xen_to_C_gdouble(s), Xen_to_C_gdouble(v), &ref_r, &ref_g, &ref_b);
  return(Xen_list_3(C_to_Xen_gdouble(ref_r), C_to_Xen_gdouble(ref_g), C_to_Xen_gdouble(ref_b)));
}

static Xen gxg_gtk_rgb_to_hsv(Xen r, Xen g, Xen b, Xen ignore_h, Xen ignore_s, Xen ignore_v)
{
  #define H_gtk_rgb_to_hsv "void gtk_rgb_to_hsv(gdouble r, gdouble g, gdouble b, gdouble* [h], gdouble* [s], \
gdouble* [v])"
  gdouble ref_h;
  gdouble ref_s;
  gdouble ref_v;
  Xen_check_type(Xen_is_gdouble(r), r, 1, "gtk_rgb_to_hsv", "gdouble");
  Xen_check_type(Xen_is_gdouble(g), g, 2, "gtk_rgb_to_hsv", "gdouble");
  Xen_check_type(Xen_is_gdouble(b), b, 3, "gtk_rgb_to_hsv", "gdouble");
  gtk_rgb_to_hsv(Xen_to_C_gdouble(r), Xen_to_C_gdouble(g), Xen_to_C_gdouble(b), &ref_h, &ref_s, &ref_v);
  return(Xen_list_3(C_to_Xen_gdouble(ref_h), C_to_Xen_gdouble(ref_s), C_to_Xen_gdouble(ref_v)));
}

static Xen gxg_gtk_color_chooser_get_rgba(Xen chooser, Xen color)
{
  #define H_gtk_color_chooser_get_rgba "void gtk_color_chooser_get_rgba(GtkColorChooser* chooser, GdkRGBA* color)"
  Xen_check_type(Xen_is_GtkColorChooser_(chooser), chooser, 1, "gtk_color_chooser_get_rgba", "GtkColorChooser*");
  Xen_check_type(Xen_is_GdkRGBA_(color), color, 2, "gtk_color_chooser_get_rgba", "GdkRGBA*");
  gtk_color_chooser_get_rgba(Xen_to_C_GtkColorChooser_(chooser), Xen_to_C_GdkRGBA_(color));
  return(Xen_false);
}

static Xen gxg_gtk_color_chooser_set_rgba(Xen chooser, Xen color)
{
  #define H_gtk_color_chooser_set_rgba "void gtk_color_chooser_set_rgba(GtkColorChooser* chooser, GdkRGBA* color)"
  Xen_check_type(Xen_is_GtkColorChooser_(chooser), chooser, 1, "gtk_color_chooser_set_rgba", "GtkColorChooser*");
  Xen_check_type(Xen_is_GdkRGBA_(color), color, 2, "gtk_color_chooser_set_rgba", "GdkRGBA*");
  gtk_color_chooser_set_rgba(Xen_to_C_GtkColorChooser_(chooser), Xen_to_C_GdkRGBA_(color));
  return(Xen_false);
}

static Xen gxg_gtk_color_chooser_get_use_alpha(Xen chooser)
{
  #define H_gtk_color_chooser_get_use_alpha "gboolean gtk_color_chooser_get_use_alpha(GtkColorChooser* chooser)"
  Xen_check_type(Xen_is_GtkColorChooser_(chooser), chooser, 1, "gtk_color_chooser_get_use_alpha", "GtkColorChooser*");
  return(C_to_Xen_gboolean(gtk_color_chooser_get_use_alpha(Xen_to_C_GtkColorChooser_(chooser))));
}

static Xen gxg_gtk_color_chooser_set_use_alpha(Xen chooser, Xen use_alpha)
{
  #define H_gtk_color_chooser_set_use_alpha "void gtk_color_chooser_set_use_alpha(GtkColorChooser* chooser, \
gboolean use_alpha)"
  Xen_check_type(Xen_is_GtkColorChooser_(chooser), chooser, 1, "gtk_color_chooser_set_use_alpha", "GtkColorChooser*");
  Xen_check_type(Xen_is_gboolean(use_alpha), use_alpha, 2, "gtk_color_chooser_set_use_alpha", "gboolean");
  gtk_color_chooser_set_use_alpha(Xen_to_C_GtkColorChooser_(chooser), Xen_to_C_gboolean(use_alpha));
  return(Xen_false);
}

static Xen gxg_gtk_color_chooser_dialog_new(Xen title, Xen parent)
{
  #define H_gtk_color_chooser_dialog_new "GtkWidget* gtk_color_chooser_dialog_new(gchar* title, GtkWindow* parent)"
  Xen_check_type(Xen_is_gchar_(title), title, 1, "gtk_color_chooser_dialog_new", "gchar*");
  Xen_check_type(Xen_is_GtkWindow_(parent), parent, 2, "gtk_color_chooser_dialog_new", "GtkWindow*");
  return(C_to_Xen_GtkWidget_(gtk_color_chooser_dialog_new((const gchar*)Xen_to_C_gchar_(title), Xen_to_C_GtkWindow_(parent))));
}

static Xen gxg_gtk_color_chooser_widget_new(void)
{
  #define H_gtk_color_chooser_widget_new "GtkWidget* gtk_color_chooser_widget_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_color_chooser_widget_new()));
}

#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static Xen gxg_gdk_event_get_scroll_deltas(Xen event, Xen ignore_delta_x, Xen ignore_delta_y)
{
  #define H_gdk_event_get_scroll_deltas "gboolean gdk_event_get_scroll_deltas(GdkEvent* event, gdouble* [delta_x], \
gdouble* [delta_y])"
  gdouble ref_delta_x;
  gdouble ref_delta_y;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_scroll_deltas", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_scroll_deltas(Xen_to_C_GdkEvent_(event), &ref_delta_x, &ref_delta_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_delta_x), C_to_Xen_gdouble(ref_delta_y)));
   }
}

static Xen gxg_gtk_color_chooser_add_palette(Xen chooser, Xen horizontal, Xen colors_per_line, Xen n_colors, Xen colors)
{
  #define H_gtk_color_chooser_add_palette "void gtk_color_chooser_add_palette(GtkColorChooser* chooser, \
GtkOrientation horizontal, gint colors_per_line, gint n_colors, GdkRGBA* colors)"
  Xen_check_type(Xen_is_GtkColorChooser_(chooser), chooser, 1, "gtk_color_chooser_add_palette", "GtkColorChooser*");
  Xen_check_type(Xen_is_GtkOrientation(horizontal), horizontal, 2, "gtk_color_chooser_add_palette", "GtkOrientation");
  Xen_check_type(Xen_is_gint(colors_per_line), colors_per_line, 3, "gtk_color_chooser_add_palette", "gint");
  Xen_check_type(Xen_is_gint(n_colors), n_colors, 4, "gtk_color_chooser_add_palette", "gint");
  Xen_check_type(Xen_is_GdkRGBA_(colors), colors, 5, "gtk_color_chooser_add_palette", "GdkRGBA*");
  gtk_color_chooser_add_palette(Xen_to_C_GtkColorChooser_(chooser), Xen_to_C_GtkOrientation(horizontal), Xen_to_C_gint(colors_per_line), 
                                Xen_to_C_gint(n_colors), Xen_to_C_GdkRGBA_(colors));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_get_n_columns(Xen tree_view)
{
  #define H_gtk_tree_view_get_n_columns "guint gtk_tree_view_get_n_columns(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_n_columns", "GtkTreeView*");
  return(C_to_Xen_guint(gtk_tree_view_get_n_columns(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_menu_button_new(void)
{
  #define H_gtk_menu_button_new "GtkWidget* gtk_menu_button_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_menu_button_new()));
}

static Xen gxg_gtk_menu_button_set_menu_model(Xen menu_button, Xen menu_model)
{
  #define H_gtk_menu_button_set_menu_model "void gtk_menu_button_set_menu_model(GtkMenuButton* menu_button, \
GMenuModel* menu_model)"
  Xen_check_type(Xen_is_GtkMenuButton_(menu_button), menu_button, 1, "gtk_menu_button_set_menu_model", "GtkMenuButton*");
  Xen_check_type(Xen_is_GMenuModel_(menu_model), menu_model, 2, "gtk_menu_button_set_menu_model", "GMenuModel*");
  gtk_menu_button_set_menu_model(Xen_to_C_GtkMenuButton_(menu_button), Xen_to_C_GMenuModel_(menu_model));
  return(Xen_false);
}

static Xen gxg_gtk_menu_button_get_menu_model(Xen menu_button)
{
  #define H_gtk_menu_button_get_menu_model "GMenuModel* gtk_menu_button_get_menu_model(GtkMenuButton* menu_button)"
  Xen_check_type(Xen_is_GtkMenuButton_(menu_button), menu_button, 1, "gtk_menu_button_get_menu_model", "GtkMenuButton*");
  return(C_to_Xen_GMenuModel_(gtk_menu_button_get_menu_model(Xen_to_C_GtkMenuButton_(menu_button))));
}

static Xen gxg_gtk_menu_button_set_align_widget(Xen menu_button, Xen align_widget)
{
  #define H_gtk_menu_button_set_align_widget "void gtk_menu_button_set_align_widget(GtkMenuButton* menu_button, \
GtkWidget* align_widget)"
  Xen_check_type(Xen_is_GtkMenuButton_(menu_button), menu_button, 1, "gtk_menu_button_set_align_widget", "GtkMenuButton*");
  Xen_check_type(Xen_is_GtkWidget_(align_widget), align_widget, 2, "gtk_menu_button_set_align_widget", "GtkWidget*");
  gtk_menu_button_set_align_widget(Xen_to_C_GtkMenuButton_(menu_button), Xen_to_C_GtkWidget_(align_widget));
  return(Xen_false);
}

static Xen gxg_gtk_menu_button_get_align_widget(Xen menu_button)
{
  #define H_gtk_menu_button_get_align_widget "GtkWidget* gtk_menu_button_get_align_widget(GtkMenuButton* menu_button)"
  Xen_check_type(Xen_is_GtkMenuButton_(menu_button), menu_button, 1, "gtk_menu_button_get_align_widget", "GtkMenuButton*");
  return(C_to_Xen_GtkWidget_(gtk_menu_button_get_align_widget(Xen_to_C_GtkMenuButton_(menu_button))));
}

static Xen gxg_gtk_search_entry_new(void)
{
  #define H_gtk_search_entry_new "GtkWidget* gtk_search_entry_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_search_entry_new()));
}

static Xen gxg_gtk_level_bar_new(void)
{
  #define H_gtk_level_bar_new "GtkWidget* gtk_level_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_level_bar_new()));
}

static Xen gxg_gtk_level_bar_new_for_interval(Xen min_value, Xen max_value)
{
  #define H_gtk_level_bar_new_for_interval "GtkWidget* gtk_level_bar_new_for_interval(gdouble min_value, \
gdouble max_value)"
  Xen_check_type(Xen_is_gdouble(min_value), min_value, 1, "gtk_level_bar_new_for_interval", "gdouble");
  Xen_check_type(Xen_is_gdouble(max_value), max_value, 2, "gtk_level_bar_new_for_interval", "gdouble");
  return(C_to_Xen_GtkWidget_(gtk_level_bar_new_for_interval(Xen_to_C_gdouble(min_value), Xen_to_C_gdouble(max_value))));
}

static Xen gxg_gtk_level_bar_set_mode(Xen self, Xen mode)
{
  #define H_gtk_level_bar_set_mode "void gtk_level_bar_set_mode(GtkLevelBar* self, GtkLevelBarMode mode)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_set_mode", "GtkLevelBar*");
  Xen_check_type(Xen_is_GtkLevelBarMode(mode), mode, 2, "gtk_level_bar_set_mode", "GtkLevelBarMode");
  gtk_level_bar_set_mode(Xen_to_C_GtkLevelBar_(self), Xen_to_C_GtkLevelBarMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_get_mode(Xen self)
{
  #define H_gtk_level_bar_get_mode "GtkLevelBarMode gtk_level_bar_get_mode(GtkLevelBar* self)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_get_mode", "GtkLevelBar*");
  return(C_to_Xen_GtkLevelBarMode(gtk_level_bar_get_mode(Xen_to_C_GtkLevelBar_(self))));
}

static Xen gxg_gtk_level_bar_set_value(Xen self, Xen value)
{
  #define H_gtk_level_bar_set_value "void gtk_level_bar_set_value(GtkLevelBar* self, gdouble value)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_set_value", "GtkLevelBar*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_level_bar_set_value", "gdouble");
  gtk_level_bar_set_value(Xen_to_C_GtkLevelBar_(self), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_get_value(Xen self)
{
  #define H_gtk_level_bar_get_value "gdouble gtk_level_bar_get_value(GtkLevelBar* self)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_get_value", "GtkLevelBar*");
  return(C_to_Xen_gdouble(gtk_level_bar_get_value(Xen_to_C_GtkLevelBar_(self))));
}

static Xen gxg_gtk_level_bar_set_min_value(Xen self, Xen value)
{
  #define H_gtk_level_bar_set_min_value "void gtk_level_bar_set_min_value(GtkLevelBar* self, gdouble value)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_set_min_value", "GtkLevelBar*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_level_bar_set_min_value", "gdouble");
  gtk_level_bar_set_min_value(Xen_to_C_GtkLevelBar_(self), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_get_min_value(Xen self)
{
  #define H_gtk_level_bar_get_min_value "gdouble gtk_level_bar_get_min_value(GtkLevelBar* self)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_get_min_value", "GtkLevelBar*");
  return(C_to_Xen_gdouble(gtk_level_bar_get_min_value(Xen_to_C_GtkLevelBar_(self))));
}

static Xen gxg_gtk_level_bar_set_max_value(Xen self, Xen value)
{
  #define H_gtk_level_bar_set_max_value "void gtk_level_bar_set_max_value(GtkLevelBar* self, gdouble value)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_set_max_value", "GtkLevelBar*");
  Xen_check_type(Xen_is_gdouble(value), value, 2, "gtk_level_bar_set_max_value", "gdouble");
  gtk_level_bar_set_max_value(Xen_to_C_GtkLevelBar_(self), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_get_max_value(Xen self)
{
  #define H_gtk_level_bar_get_max_value "gdouble gtk_level_bar_get_max_value(GtkLevelBar* self)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_get_max_value", "GtkLevelBar*");
  return(C_to_Xen_gdouble(gtk_level_bar_get_max_value(Xen_to_C_GtkLevelBar_(self))));
}

static Xen gxg_gtk_level_bar_add_offset_value(Xen self, Xen name, Xen value)
{
  #define H_gtk_level_bar_add_offset_value "void gtk_level_bar_add_offset_value(GtkLevelBar* self, gchar* name, \
gdouble value)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_add_offset_value", "GtkLevelBar*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_level_bar_add_offset_value", "gchar*");
  Xen_check_type(Xen_is_gdouble(value), value, 3, "gtk_level_bar_add_offset_value", "gdouble");
  gtk_level_bar_add_offset_value(Xen_to_C_GtkLevelBar_(self), (const gchar*)Xen_to_C_gchar_(name), Xen_to_C_gdouble(value));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_remove_offset_value(Xen self, Xen name)
{
  #define H_gtk_level_bar_remove_offset_value "void gtk_level_bar_remove_offset_value(GtkLevelBar* self, \
gchar* name)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_remove_offset_value", "GtkLevelBar*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_level_bar_remove_offset_value", "gchar*");
  gtk_level_bar_remove_offset_value(Xen_to_C_GtkLevelBar_(self), (const gchar*)Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_get_offset_value(Xen self, Xen name, Xen ignore_value)
{
  #define H_gtk_level_bar_get_offset_value "gboolean gtk_level_bar_get_offset_value(GtkLevelBar* self, \
gchar* name, gdouble* [value])"
  gdouble ref_value;
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_get_offset_value", "GtkLevelBar*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_level_bar_get_offset_value", "gchar*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_level_bar_get_offset_value(Xen_to_C_GtkLevelBar_(self), (const gchar*)Xen_to_C_gchar_(name), &ref_value));
    return(Xen_list_2(result, C_to_Xen_gdouble(ref_value)));
   }
}

static Xen gxg_gtk_application_get_active_window(Xen application)
{
  #define H_gtk_application_get_active_window "GtkWindow* gtk_application_get_active_window(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_active_window", "GtkApplication*");
  return(C_to_Xen_GtkWindow_(gtk_application_get_active_window(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_entry_set_input_purpose(Xen entry, Xen purpose)
{
  #define H_gtk_entry_set_input_purpose "void gtk_entry_set_input_purpose(GtkEntry* entry, GtkInputPurpose purpose)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_input_purpose", "GtkEntry*");
  Xen_check_type(Xen_is_GtkInputPurpose(purpose), purpose, 2, "gtk_entry_set_input_purpose", "GtkInputPurpose");
  gtk_entry_set_input_purpose(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkInputPurpose(purpose));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_input_purpose(Xen entry)
{
  #define H_gtk_entry_get_input_purpose "GtkInputPurpose gtk_entry_get_input_purpose(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_input_purpose", "GtkEntry*");
  return(C_to_Xen_GtkInputPurpose(gtk_entry_get_input_purpose(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_entry_set_input_hints(Xen entry, Xen hints)
{
  #define H_gtk_entry_set_input_hints "void gtk_entry_set_input_hints(GtkEntry* entry, GtkInputHints hints)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_input_hints", "GtkEntry*");
  Xen_check_type(Xen_is_GtkInputHints(hints), hints, 2, "gtk_entry_set_input_hints", "GtkInputHints");
  gtk_entry_set_input_hints(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkInputHints(hints));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_input_hints(Xen entry)
{
  #define H_gtk_entry_get_input_hints "GtkInputHints gtk_entry_get_input_hints(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_input_hints", "GtkEntry*");
  return(C_to_Xen_GtkInputHints(gtk_entry_get_input_hints(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_menu_button_get_popup(Xen menu_button)
{
  #define H_gtk_menu_button_get_popup "GtkMenu* gtk_menu_button_get_popup(GtkMenuButton* menu_button)"
  Xen_check_type(Xen_is_GtkMenuButton_(menu_button), menu_button, 1, "gtk_menu_button_get_popup", "GtkMenuButton*");
  return(C_to_Xen_GtkMenu_(gtk_menu_button_get_popup(Xen_to_C_GtkMenuButton_(menu_button))));
}

static Xen gxg_gtk_text_view_set_input_purpose(Xen text_view, Xen purpose)
{
  #define H_gtk_text_view_set_input_purpose "void gtk_text_view_set_input_purpose(GtkTextView* text_view, \
GtkInputPurpose purpose)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_input_purpose", "GtkTextView*");
  Xen_check_type(Xen_is_GtkInputPurpose(purpose), purpose, 2, "gtk_text_view_set_input_purpose", "GtkInputPurpose");
  gtk_text_view_set_input_purpose(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkInputPurpose(purpose));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_input_purpose(Xen text_view)
{
  #define H_gtk_text_view_get_input_purpose "GtkInputPurpose gtk_text_view_get_input_purpose(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_input_purpose", "GtkTextView*");
  return(C_to_Xen_GtkInputPurpose(gtk_text_view_get_input_purpose(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_input_hints(Xen text_view, Xen hints)
{
  #define H_gtk_text_view_set_input_hints "void gtk_text_view_set_input_hints(GtkTextView* text_view, \
GtkInputHints hints)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_input_hints", "GtkTextView*");
  Xen_check_type(Xen_is_GtkInputHints(hints), hints, 2, "gtk_text_view_set_input_hints", "GtkInputHints");
  gtk_text_view_set_input_hints(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkInputHints(hints));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_input_hints(Xen text_view)
{
  #define H_gtk_text_view_get_input_hints "GtkInputHints gtk_text_view_get_input_hints(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_input_hints", "GtkTextView*");
  return(C_to_Xen_GtkInputHints(gtk_text_view_get_input_hints(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_entry_set_attributes(Xen entry, Xen attrs)
{
  #define H_gtk_entry_set_attributes "void gtk_entry_set_attributes(GtkEntry* entry, PangoAttrList* attrs)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_attributes", "GtkEntry*");
  Xen_check_type(Xen_is_PangoAttrList_(attrs), attrs, 2, "gtk_entry_set_attributes", "PangoAttrList*");
  gtk_entry_set_attributes(Xen_to_C_GtkEntry_(entry), Xen_to_C_PangoAttrList_(attrs));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_attributes(Xen entry)
{
  #define H_gtk_entry_get_attributes "PangoAttrList* gtk_entry_get_attributes(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_attributes", "GtkEntry*");
  return(C_to_Xen_PangoAttrList_(gtk_entry_get_attributes(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_accel_label_set_accel(Xen accel_label, Xen accelerator_key, Xen accelerator_mods)
{
  #define H_gtk_accel_label_set_accel "void gtk_accel_label_set_accel(GtkAccelLabel* accel_label, guint accelerator_key, \
GdkModifierType accelerator_mods)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_set_accel", "GtkAccelLabel*");
  Xen_check_type(Xen_is_guint(accelerator_key), accelerator_key, 2, "gtk_accel_label_set_accel", "guint");
  Xen_check_type(Xen_is_GdkModifierType(accelerator_mods), accelerator_mods, 3, "gtk_accel_label_set_accel", "GdkModifierType");
  gtk_accel_label_set_accel(Xen_to_C_GtkAccelLabel_(accel_label), Xen_to_C_guint(accelerator_key), Xen_to_C_GdkModifierType(accelerator_mods));
  return(Xen_false);
}

static Xen gxg_gtk_menu_shell_bind_model(Xen menu_shell, Xen model, Xen action_namespace, Xen with_separators)
{
  #define H_gtk_menu_shell_bind_model "void gtk_menu_shell_bind_model(GtkMenuShell* menu_shell, GMenuModel* model, \
gchar* action_namespace, gboolean with_separators)"
  Xen_check_type(Xen_is_GtkMenuShell_(menu_shell), menu_shell, 1, "gtk_menu_shell_bind_model", "GtkMenuShell*");
  Xen_check_type(Xen_is_GMenuModel_(model), model, 2, "gtk_menu_shell_bind_model", "GMenuModel*");
  Xen_check_type(Xen_is_gchar_(action_namespace), action_namespace, 3, "gtk_menu_shell_bind_model", "gchar*");
  Xen_check_type(Xen_is_gboolean(with_separators), with_separators, 4, "gtk_menu_shell_bind_model", "gboolean");
  gtk_menu_shell_bind_model(Xen_to_C_GtkMenuShell_(menu_shell), Xen_to_C_GMenuModel_(model), (const gchar*)Xen_to_C_gchar_(action_namespace), 
                            Xen_to_C_gboolean(with_separators));
  return(Xen_false);
}

#endif

#if GTK_CHECK_VERSION(3, 8, 0)
static Xen gxg_gtk_level_bar_set_inverted(Xen self, Xen inverted)
{
  #define H_gtk_level_bar_set_inverted "void gtk_level_bar_set_inverted(GtkLevelBar* self, gboolean inverted)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_set_inverted", "GtkLevelBar*");
  Xen_check_type(Xen_is_gboolean(inverted), inverted, 2, "gtk_level_bar_set_inverted", "gboolean");
  gtk_level_bar_set_inverted(Xen_to_C_GtkLevelBar_(self), Xen_to_C_gboolean(inverted));
  return(Xen_false);
}

static Xen gxg_gtk_level_bar_get_inverted(Xen self)
{
  #define H_gtk_level_bar_get_inverted "gboolean gtk_level_bar_get_inverted(GtkLevelBar* self)"
  Xen_check_type(Xen_is_GtkLevelBar_(self), self, 1, "gtk_level_bar_get_inverted", "GtkLevelBar*");
  return(C_to_Xen_gboolean(gtk_level_bar_get_inverted(Xen_to_C_GtkLevelBar_(self))));
}

static Xen gxg_gtk_widget_is_visible(Xen widget)
{
  #define H_gtk_widget_is_visible "gboolean gtk_widget_is_visible(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_is_visible", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_is_visible(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gdk_window_set_fullscreen_mode(Xen window, Xen mode)
{
  #define H_gdk_window_set_fullscreen_mode "void gdk_window_set_fullscreen_mode(GdkWindow* window, GdkFullscreenMode mode)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_fullscreen_mode", "GdkWindow*");
  Xen_check_type(Xen_is_GdkFullscreenMode(mode), mode, 2, "gdk_window_set_fullscreen_mode", "GdkFullscreenMode");
  gdk_window_set_fullscreen_mode(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkFullscreenMode(mode));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_fullscreen_mode(Xen window)
{
  #define H_gdk_window_get_fullscreen_mode "GdkFullscreenMode gdk_window_get_fullscreen_mode(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_fullscreen_mode", "GdkWindow*");
  return(C_to_Xen_GdkFullscreenMode(gdk_window_get_fullscreen_mode(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_icon_view_set_activate_on_single_click(Xen icon_view, Xen single)
{
  #define H_gtk_icon_view_set_activate_on_single_click "void gtk_icon_view_set_activate_on_single_click(GtkIconView* icon_view, \
gboolean single)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_set_activate_on_single_click", "GtkIconView*");
  Xen_check_type(Xen_is_gboolean(single), single, 2, "gtk_icon_view_set_activate_on_single_click", "gboolean");
  gtk_icon_view_set_activate_on_single_click(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_gboolean(single));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_get_activate_on_single_click(Xen icon_view)
{
  #define H_gtk_icon_view_get_activate_on_single_click "gboolean gtk_icon_view_get_activate_on_single_click(GtkIconView* icon_view)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_get_activate_on_single_click", "GtkIconView*");
  return(C_to_Xen_gboolean(gtk_icon_view_get_activate_on_single_click(Xen_to_C_GtkIconView_(icon_view))));
}

static Xen gxg_gtk_tree_view_get_activate_on_single_click(Xen tree_view)
{
  #define H_gtk_tree_view_get_activate_on_single_click "gboolean gtk_tree_view_get_activate_on_single_click(GtkTreeView* tree_view)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_get_activate_on_single_click", "GtkTreeView*");
  return(C_to_Xen_gboolean(gtk_tree_view_get_activate_on_single_click(Xen_to_C_GtkTreeView_(tree_view))));
}

static Xen gxg_gtk_tree_view_set_activate_on_single_click(Xen tree_view, Xen single)
{
  #define H_gtk_tree_view_set_activate_on_single_click "void gtk_tree_view_set_activate_on_single_click(GtkTreeView* tree_view, \
gboolean single)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_set_activate_on_single_click", "GtkTreeView*");
  Xen_check_type(Xen_is_gboolean(single), single, 2, "gtk_tree_view_set_activate_on_single_click", "gboolean");
  gtk_tree_view_set_activate_on_single_click(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_gboolean(single));
  return(Xen_false);
}

static Xen gxg_gtk_widget_register_window(Xen widget, Xen window)
{
  #define H_gtk_widget_register_window "void gtk_widget_register_window(GtkWidget* widget, GdkWindow* window)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_register_window", "GtkWidget*");
  Xen_check_type(Xen_is_GdkWindow_(window), window, 2, "gtk_widget_register_window", "GdkWindow*");
  gtk_widget_register_window(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_widget_unregister_window(Xen widget, Xen window)
{
  #define H_gtk_widget_unregister_window "void gtk_widget_unregister_window(GtkWidget* widget, GdkWindow* window)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_unregister_window", "GtkWidget*");
  Xen_check_type(Xen_is_GdkWindow_(window), window, 2, "gtk_widget_unregister_window", "GdkWindow*");
  gtk_widget_unregister_window(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_opacity(Xen widget, Xen opacity)
{
  #define H_gtk_widget_set_opacity "void gtk_widget_set_opacity(GtkWidget* widget, double opacity)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_opacity", "GtkWidget*");
  Xen_check_type(Xen_is_double(opacity), opacity, 2, "gtk_widget_set_opacity", "double");
  gtk_widget_set_opacity(Xen_to_C_GtkWidget_(widget), Xen_to_C_double(opacity));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_opacity(Xen widget)
{
  #define H_gtk_widget_get_opacity "double gtk_widget_get_opacity(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_opacity", "GtkWidget*");
  return(C_to_Xen_double(gtk_widget_get_opacity(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_pango_font_map_changed(Xen fontmap)
{
  #define H_pango_font_map_changed "void pango_font_map_changed(PangoFontMap* fontmap)"
  Xen_check_type(Xen_is_PangoFontMap_(fontmap), fontmap, 1, "pango_font_map_changed", "PangoFontMap*");
  pango_font_map_changed(Xen_to_C_PangoFontMap_(fontmap));
  return(Xen_false);
}

#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static Xen gxg_gtk_box_set_baseline_position(Xen box, Xen position)
{
  #define H_gtk_box_set_baseline_position "void gtk_box_set_baseline_position(GtkBox* box, GtkBaselinePosition position)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_set_baseline_position", "GtkBox*");
  Xen_check_type(Xen_is_GtkBaselinePosition(position), position, 2, "gtk_box_set_baseline_position", "GtkBaselinePosition");
  gtk_box_set_baseline_position(Xen_to_C_GtkBox_(box), Xen_to_C_GtkBaselinePosition(position));
  return(Xen_false);
}

static Xen gxg_gtk_box_get_baseline_position(Xen box)
{
  #define H_gtk_box_get_baseline_position "GtkBaselinePosition gtk_box_get_baseline_position(GtkBox* box)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_get_baseline_position", "GtkBox*");
  return(C_to_Xen_GtkBaselinePosition(gtk_box_get_baseline_position(Xen_to_C_GtkBox_(box))));
}

static Xen gxg_gtk_grid_remove_row(Xen grid, Xen position)
{
  #define H_gtk_grid_remove_row "void gtk_grid_remove_row(GtkGrid* grid, gint position)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_remove_row", "GtkGrid*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_grid_remove_row", "gint");
  gtk_grid_remove_row(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_grid_remove_column(Xen grid, Xen position)
{
  #define H_gtk_grid_remove_column "void gtk_grid_remove_column(GtkGrid* grid, gint position)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_remove_column", "GtkGrid*");
  Xen_check_type(Xen_is_gint(position), position, 2, "gtk_grid_remove_column", "gint");
  gtk_grid_remove_column(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_grid_set_row_baseline_position(Xen grid, Xen row, Xen pos)
{
  #define H_gtk_grid_set_row_baseline_position "void gtk_grid_set_row_baseline_position(GtkGrid* grid, \
gint row, GtkBaselinePosition pos)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_set_row_baseline_position", "GtkGrid*");
  Xen_check_type(Xen_is_gint(row), row, 2, "gtk_grid_set_row_baseline_position", "gint");
  Xen_check_type(Xen_is_GtkBaselinePosition(pos), pos, 3, "gtk_grid_set_row_baseline_position", "GtkBaselinePosition");
  gtk_grid_set_row_baseline_position(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(row), Xen_to_C_GtkBaselinePosition(pos));
  return(Xen_false);
}

static Xen gxg_gtk_grid_get_row_baseline_position(Xen grid, Xen row)
{
  #define H_gtk_grid_get_row_baseline_position "GtkBaselinePosition gtk_grid_get_row_baseline_position(GtkGrid* grid, \
gint row)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_row_baseline_position", "GtkGrid*");
  Xen_check_type(Xen_is_gint(row), row, 2, "gtk_grid_get_row_baseline_position", "gint");
  return(C_to_Xen_GtkBaselinePosition(gtk_grid_get_row_baseline_position(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(row))));
}

static Xen gxg_gtk_grid_set_baseline_row(Xen grid, Xen row)
{
  #define H_gtk_grid_set_baseline_row "void gtk_grid_set_baseline_row(GtkGrid* grid, gint row)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_set_baseline_row", "GtkGrid*");
  Xen_check_type(Xen_is_gint(row), row, 2, "gtk_grid_set_baseline_row", "gint");
  gtk_grid_set_baseline_row(Xen_to_C_GtkGrid_(grid), Xen_to_C_gint(row));
  return(Xen_false);
}

static Xen gxg_gtk_grid_get_baseline_row(Xen grid)
{
  #define H_gtk_grid_get_baseline_row "gint gtk_grid_get_baseline_row(GtkGrid* grid)"
  Xen_check_type(Xen_is_GtkGrid_(grid), grid, 1, "gtk_grid_get_baseline_row", "GtkGrid*");
  return(C_to_Xen_gint(gtk_grid_get_baseline_row(Xen_to_C_GtkGrid_(grid))));
}

static Xen gxg_gtk_widget_get_allocated_baseline(Xen widget)
{
  #define H_gtk_widget_get_allocated_baseline "int gtk_widget_get_allocated_baseline(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_allocated_baseline", "GtkWidget*");
  return(C_to_Xen_int(gtk_widget_get_allocated_baseline(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_init_template(Xen widget)
{
  #define H_gtk_widget_init_template "void gtk_widget_init_template(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_init_template", "GtkWidget*");
  gtk_widget_init_template(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_titlebar(Xen window, Xen titlebar)
{
  #define H_gtk_window_set_titlebar "void gtk_window_set_titlebar(GtkWindow* window, GtkWidget* titlebar)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_titlebar", "GtkWindow*");
  Xen_check_type(Xen_is_GtkWidget_(titlebar), titlebar, 2, "gtk_window_set_titlebar", "GtkWidget*");
  gtk_window_set_titlebar(Xen_to_C_GtkWindow_(window), Xen_to_C_GtkWidget_(titlebar));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_new(void)
{
  #define H_gtk_places_sidebar_new "GtkWidget* gtk_places_sidebar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_places_sidebar_new()));
}

static Xen gxg_gtk_places_sidebar_get_open_flags(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_open_flags "GtkPlacesOpenFlags gtk_places_sidebar_get_open_flags(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_open_flags", "GtkPlacesSidebar*");
  return(C_to_Xen_GtkPlacesOpenFlags(gtk_places_sidebar_get_open_flags(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_set_open_flags(Xen sidebar, Xen flags)
{
  #define H_gtk_places_sidebar_set_open_flags "void gtk_places_sidebar_set_open_flags(GtkPlacesSidebar* sidebar, \
GtkPlacesOpenFlags flags)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_open_flags", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_GtkPlacesOpenFlags(flags), flags, 2, "gtk_places_sidebar_set_open_flags", "GtkPlacesOpenFlags");
  gtk_places_sidebar_set_open_flags(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_GtkPlacesOpenFlags(flags));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_location(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_location "GFile* gtk_places_sidebar_get_location(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_location", "GtkPlacesSidebar*");
  return(C_to_Xen_GFile_(gtk_places_sidebar_get_location(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_set_location(Xen sidebar, Xen location)
{
  #define H_gtk_places_sidebar_set_location "void gtk_places_sidebar_set_location(GtkPlacesSidebar* sidebar, \
GFile* location)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_location", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_GFile_(location), location, 2, "gtk_places_sidebar_set_location", "GFile*");
  gtk_places_sidebar_set_location(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_GFile_(location));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_show_desktop(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_show_desktop "gboolean gtk_places_sidebar_get_show_desktop(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_show_desktop", "GtkPlacesSidebar*");
  return(C_to_Xen_gboolean(gtk_places_sidebar_get_show_desktop(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_set_show_desktop(Xen sidebar, Xen show_desktop)
{
  #define H_gtk_places_sidebar_set_show_desktop "void gtk_places_sidebar_set_show_desktop(GtkPlacesSidebar* sidebar, \
gboolean show_desktop)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_show_desktop", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(show_desktop), show_desktop, 2, "gtk_places_sidebar_set_show_desktop", "gboolean");
  gtk_places_sidebar_set_show_desktop(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(show_desktop));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_add_shortcut(Xen sidebar, Xen location)
{
  #define H_gtk_places_sidebar_add_shortcut "void gtk_places_sidebar_add_shortcut(GtkPlacesSidebar* sidebar, \
GFile* location)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_add_shortcut", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_GFile_(location), location, 2, "gtk_places_sidebar_add_shortcut", "GFile*");
  gtk_places_sidebar_add_shortcut(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_GFile_(location));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_remove_shortcut(Xen sidebar, Xen location)
{
  #define H_gtk_places_sidebar_remove_shortcut "void gtk_places_sidebar_remove_shortcut(GtkPlacesSidebar* sidebar, \
GFile* location)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_remove_shortcut", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_GFile_(location), location, 2, "gtk_places_sidebar_remove_shortcut", "GFile*");
  gtk_places_sidebar_remove_shortcut(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_GFile_(location));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_list_shortcuts(Xen sidebar)
{
  #define H_gtk_places_sidebar_list_shortcuts "GSList* gtk_places_sidebar_list_shortcuts(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_list_shortcuts", "GtkPlacesSidebar*");
  return(C_to_Xen_GSList_(gtk_places_sidebar_list_shortcuts(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_get_nth_bookmark(Xen sidebar, Xen n)
{
  #define H_gtk_places_sidebar_get_nth_bookmark "GFile* gtk_places_sidebar_get_nth_bookmark(GtkPlacesSidebar* sidebar, \
gint n)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_nth_bookmark", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gint(n), n, 2, "gtk_places_sidebar_get_nth_bookmark", "gint");
  return(C_to_Xen_GFile_(gtk_places_sidebar_get_nth_bookmark(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gint(n))));
}

static Xen gxg_gtk_stack_switcher_new(void)
{
  #define H_gtk_stack_switcher_new "GtkWidget* gtk_stack_switcher_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_stack_switcher_new()));
}

static Xen gxg_gtk_stack_switcher_set_stack(Xen switcher, Xen stack)
{
  #define H_gtk_stack_switcher_set_stack "void gtk_stack_switcher_set_stack(GtkStackSwitcher* switcher, \
GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStackSwitcher_(switcher), switcher, 1, "gtk_stack_switcher_set_stack", "GtkStackSwitcher*");
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 2, "gtk_stack_switcher_set_stack", "GtkStack*");
  gtk_stack_switcher_set_stack(Xen_to_C_GtkStackSwitcher_(switcher), Xen_to_C_GtkStack_(stack));
  return(Xen_false);
}

static Xen gxg_gtk_stack_switcher_get_stack(Xen switcher)
{
  #define H_gtk_stack_switcher_get_stack "GtkStack* gtk_stack_switcher_get_stack(GtkStackSwitcher* switcher)"
  Xen_check_type(Xen_is_GtkStackSwitcher_(switcher), switcher, 1, "gtk_stack_switcher_get_stack", "GtkStackSwitcher*");
  return(C_to_Xen_GtkStack_(gtk_stack_switcher_get_stack(Xen_to_C_GtkStackSwitcher_(switcher))));
}

static Xen gxg_gtk_stack_new(void)
{
  #define H_gtk_stack_new "GtkWidget* gtk_stack_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_stack_new()));
}

static Xen gxg_gtk_stack_add_named(Xen stack, Xen child, Xen name)
{
  #define H_gtk_stack_add_named "void gtk_stack_add_named(GtkStack* stack, GtkWidget* child, gchar* name)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_add_named", "GtkStack*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_stack_add_named", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(name), name, 3, "gtk_stack_add_named", "gchar*");
  gtk_stack_add_named(Xen_to_C_GtkStack_(stack), Xen_to_C_GtkWidget_(child), (const gchar*)Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_stack_add_titled(Xen stack, Xen child, Xen name, Xen title)
{
  #define H_gtk_stack_add_titled "void gtk_stack_add_titled(GtkStack* stack, GtkWidget* child, gchar* name, \
gchar* title)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_add_titled", "GtkStack*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_stack_add_titled", "GtkWidget*");
  Xen_check_type(Xen_is_gchar_(name), name, 3, "gtk_stack_add_titled", "gchar*");
  Xen_check_type(Xen_is_gchar_(title), title, 4, "gtk_stack_add_titled", "gchar*");
  gtk_stack_add_titled(Xen_to_C_GtkStack_(stack), Xen_to_C_GtkWidget_(child), (const gchar*)Xen_to_C_gchar_(name), (const gchar*)Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gtk_stack_set_visible_child(Xen stack, Xen child)
{
  #define H_gtk_stack_set_visible_child "void gtk_stack_set_visible_child(GtkStack* stack, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_visible_child", "GtkStack*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_stack_set_visible_child", "GtkWidget*");
  gtk_stack_set_visible_child(Xen_to_C_GtkStack_(stack), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_visible_child(Xen stack)
{
  #define H_gtk_stack_get_visible_child "GtkWidget* gtk_stack_get_visible_child(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_visible_child", "GtkStack*");
  return(C_to_Xen_GtkWidget_(gtk_stack_get_visible_child(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_stack_set_visible_child_name(Xen stack, Xen name)
{
  #define H_gtk_stack_set_visible_child_name "void gtk_stack_set_visible_child_name(GtkStack* stack, \
gchar* name)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_visible_child_name", "GtkStack*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_stack_set_visible_child_name", "gchar*");
  gtk_stack_set_visible_child_name(Xen_to_C_GtkStack_(stack), (const gchar*)Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_visible_child_name(Xen stack)
{
  #define H_gtk_stack_get_visible_child_name "gchar* gtk_stack_get_visible_child_name(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_visible_child_name", "GtkStack*");
  return(C_to_Xen_gchar_(gtk_stack_get_visible_child_name(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_stack_set_visible_child_full(Xen stack, Xen name, Xen transition)
{
  #define H_gtk_stack_set_visible_child_full "void gtk_stack_set_visible_child_full(GtkStack* stack, \
gchar* name, GtkStackTransitionType transition)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_visible_child_full", "GtkStack*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_stack_set_visible_child_full", "gchar*");
  Xen_check_type(Xen_is_GtkStackTransitionType(transition), transition, 3, "gtk_stack_set_visible_child_full", "GtkStackTransitionType");
  gtk_stack_set_visible_child_full(Xen_to_C_GtkStack_(stack), (const gchar*)Xen_to_C_gchar_(name), Xen_to_C_GtkStackTransitionType(transition));
  return(Xen_false);
}

static Xen gxg_gtk_stack_set_homogeneous(Xen stack, Xen homogeneous)
{
  #define H_gtk_stack_set_homogeneous "void gtk_stack_set_homogeneous(GtkStack* stack, gboolean homogeneous)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_homogeneous", "GtkStack*");
  Xen_check_type(Xen_is_gboolean(homogeneous), homogeneous, 2, "gtk_stack_set_homogeneous", "gboolean");
  gtk_stack_set_homogeneous(Xen_to_C_GtkStack_(stack), Xen_to_C_gboolean(homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_homogeneous(Xen stack)
{
  #define H_gtk_stack_get_homogeneous "gboolean gtk_stack_get_homogeneous(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_homogeneous", "GtkStack*");
  return(C_to_Xen_gboolean(gtk_stack_get_homogeneous(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_stack_set_transition_duration(Xen stack, Xen duration)
{
  #define H_gtk_stack_set_transition_duration "void gtk_stack_set_transition_duration(GtkStack* stack, \
guint duration)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_transition_duration", "GtkStack*");
  Xen_check_type(Xen_is_guint(duration), duration, 2, "gtk_stack_set_transition_duration", "guint");
  gtk_stack_set_transition_duration(Xen_to_C_GtkStack_(stack), Xen_to_C_guint(duration));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_transition_duration(Xen stack)
{
  #define H_gtk_stack_get_transition_duration "guint gtk_stack_get_transition_duration(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_transition_duration", "GtkStack*");
  return(C_to_Xen_guint(gtk_stack_get_transition_duration(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_stack_set_transition_type(Xen stack, Xen transition)
{
  #define H_gtk_stack_set_transition_type "void gtk_stack_set_transition_type(GtkStack* stack, GtkStackTransitionType transition)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_transition_type", "GtkStack*");
  Xen_check_type(Xen_is_GtkStackTransitionType(transition), transition, 2, "gtk_stack_set_transition_type", "GtkStackTransitionType");
  gtk_stack_set_transition_type(Xen_to_C_GtkStack_(stack), Xen_to_C_GtkStackTransitionType(transition));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_transition_type(Xen stack)
{
  #define H_gtk_stack_get_transition_type "GtkStackTransitionType gtk_stack_get_transition_type(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_transition_type", "GtkStack*");
  return(C_to_Xen_GtkStackTransitionType(gtk_stack_get_transition_type(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_revealer_new(void)
{
  #define H_gtk_revealer_new "GtkWidget* gtk_revealer_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_revealer_new()));
}

static Xen gxg_gtk_revealer_get_reveal_child(Xen revealer)
{
  #define H_gtk_revealer_get_reveal_child "gboolean gtk_revealer_get_reveal_child(GtkRevealer* revealer)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_get_reveal_child", "GtkRevealer*");
  return(C_to_Xen_gboolean(gtk_revealer_get_reveal_child(Xen_to_C_GtkRevealer_(revealer))));
}

static Xen gxg_gtk_revealer_set_reveal_child(Xen revealer, Xen reveal_child)
{
  #define H_gtk_revealer_set_reveal_child "void gtk_revealer_set_reveal_child(GtkRevealer* revealer, \
gboolean reveal_child)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_set_reveal_child", "GtkRevealer*");
  Xen_check_type(Xen_is_gboolean(reveal_child), reveal_child, 2, "gtk_revealer_set_reveal_child", "gboolean");
  gtk_revealer_set_reveal_child(Xen_to_C_GtkRevealer_(revealer), Xen_to_C_gboolean(reveal_child));
  return(Xen_false);
}

static Xen gxg_gtk_revealer_get_child_revealed(Xen revealer)
{
  #define H_gtk_revealer_get_child_revealed "gboolean gtk_revealer_get_child_revealed(GtkRevealer* revealer)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_get_child_revealed", "GtkRevealer*");
  return(C_to_Xen_gboolean(gtk_revealer_get_child_revealed(Xen_to_C_GtkRevealer_(revealer))));
}

static Xen gxg_gtk_revealer_get_transition_duration(Xen revealer)
{
  #define H_gtk_revealer_get_transition_duration "guint gtk_revealer_get_transition_duration(GtkRevealer* revealer)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_get_transition_duration", "GtkRevealer*");
  return(C_to_Xen_guint(gtk_revealer_get_transition_duration(Xen_to_C_GtkRevealer_(revealer))));
}

static Xen gxg_gtk_revealer_set_transition_duration(Xen revealer, Xen duration)
{
  #define H_gtk_revealer_set_transition_duration "void gtk_revealer_set_transition_duration(GtkRevealer* revealer, \
guint duration)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_set_transition_duration", "GtkRevealer*");
  Xen_check_type(Xen_is_guint(duration), duration, 2, "gtk_revealer_set_transition_duration", "guint");
  gtk_revealer_set_transition_duration(Xen_to_C_GtkRevealer_(revealer), Xen_to_C_guint(duration));
  return(Xen_false);
}

static Xen gxg_gtk_revealer_set_transition_type(Xen revealer, Xen transition)
{
  #define H_gtk_revealer_set_transition_type "void gtk_revealer_set_transition_type(GtkRevealer* revealer, \
GtkRevealerTransitionType transition)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_set_transition_type", "GtkRevealer*");
  Xen_check_type(Xen_is_GtkRevealerTransitionType(transition), transition, 2, "gtk_revealer_set_transition_type", "GtkRevealerTransitionType");
  gtk_revealer_set_transition_type(Xen_to_C_GtkRevealer_(revealer), Xen_to_C_GtkRevealerTransitionType(transition));
  return(Xen_false);
}

static Xen gxg_gtk_revealer_get_transition_type(Xen revealer)
{
  #define H_gtk_revealer_get_transition_type "GtkRevealerTransitionType gtk_revealer_get_transition_type(GtkRevealer* revealer)"
  Xen_check_type(Xen_is_GtkRevealer_(revealer), revealer, 1, "gtk_revealer_get_transition_type", "GtkRevealer*");
  return(C_to_Xen_GtkRevealerTransitionType(gtk_revealer_get_transition_type(Xen_to_C_GtkRevealer_(revealer))));
}

static Xen gxg_gtk_header_bar_new(void)
{
  #define H_gtk_header_bar_new "GtkWidget* gtk_header_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_header_bar_new()));
}

static Xen gxg_gtk_header_bar_set_title(Xen bar, Xen title)
{
  #define H_gtk_header_bar_set_title "void gtk_header_bar_set_title(GtkHeaderBar* bar, gchar* title)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_set_title", "GtkHeaderBar*");
  Xen_check_type(Xen_is_gchar_(title), title, 2, "gtk_header_bar_set_title", "gchar*");
  gtk_header_bar_set_title(Xen_to_C_GtkHeaderBar_(bar), (const gchar*)Xen_to_C_gchar_(title));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_get_title(Xen bar)
{
  #define H_gtk_header_bar_get_title "gchar* gtk_header_bar_get_title(GtkHeaderBar* bar)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_get_title", "GtkHeaderBar*");
  return(C_to_Xen_gchar_(gtk_header_bar_get_title(Xen_to_C_GtkHeaderBar_(bar))));
}

static Xen gxg_gtk_header_bar_set_subtitle(Xen bar, Xen subtitle)
{
  #define H_gtk_header_bar_set_subtitle "void gtk_header_bar_set_subtitle(GtkHeaderBar* bar, gchar* subtitle)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_set_subtitle", "GtkHeaderBar*");
  Xen_check_type(Xen_is_gchar_(subtitle), subtitle, 2, "gtk_header_bar_set_subtitle", "gchar*");
  gtk_header_bar_set_subtitle(Xen_to_C_GtkHeaderBar_(bar), (const gchar*)Xen_to_C_gchar_(subtitle));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_get_subtitle(Xen bar)
{
  #define H_gtk_header_bar_get_subtitle "gchar* gtk_header_bar_get_subtitle(GtkHeaderBar* bar)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_get_subtitle", "GtkHeaderBar*");
  return(C_to_Xen_gchar_(gtk_header_bar_get_subtitle(Xen_to_C_GtkHeaderBar_(bar))));
}

static Xen gxg_gtk_header_bar_set_custom_title(Xen bar, Xen title_widget)
{
  #define H_gtk_header_bar_set_custom_title "void gtk_header_bar_set_custom_title(GtkHeaderBar* bar, \
GtkWidget* title_widget)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_set_custom_title", "GtkHeaderBar*");
  Xen_check_type(Xen_is_GtkWidget_(title_widget), title_widget, 2, "gtk_header_bar_set_custom_title", "GtkWidget*");
  gtk_header_bar_set_custom_title(Xen_to_C_GtkHeaderBar_(bar), Xen_to_C_GtkWidget_(title_widget));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_get_custom_title(Xen bar)
{
  #define H_gtk_header_bar_get_custom_title "GtkWidget* gtk_header_bar_get_custom_title(GtkHeaderBar* bar)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_get_custom_title", "GtkHeaderBar*");
  return(C_to_Xen_GtkWidget_(gtk_header_bar_get_custom_title(Xen_to_C_GtkHeaderBar_(bar))));
}

static Xen gxg_gtk_header_bar_pack_start(Xen bar, Xen child)
{
  #define H_gtk_header_bar_pack_start "void gtk_header_bar_pack_start(GtkHeaderBar* bar, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_pack_start", "GtkHeaderBar*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_header_bar_pack_start", "GtkWidget*");
  gtk_header_bar_pack_start(Xen_to_C_GtkHeaderBar_(bar), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_pack_end(Xen bar, Xen child)
{
  #define H_gtk_header_bar_pack_end "void gtk_header_bar_pack_end(GtkHeaderBar* bar, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_pack_end", "GtkHeaderBar*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_header_bar_pack_end", "GtkWidget*");
  gtk_header_bar_pack_end(Xen_to_C_GtkHeaderBar_(bar), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_row_new(void)
{
  #define H_gtk_list_box_row_new "GtkWidget* gtk_list_box_row_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_list_box_row_new()));
}

static Xen gxg_gtk_list_box_row_get_header(Xen row)
{
  #define H_gtk_list_box_row_get_header "GtkWidget* gtk_list_box_row_get_header(GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_get_header", "GtkListBoxRow*");
  return(C_to_Xen_GtkWidget_(gtk_list_box_row_get_header(Xen_to_C_GtkListBoxRow_(row))));
}

static Xen gxg_gtk_list_box_row_set_header(Xen row, Xen header)
{
  #define H_gtk_list_box_row_set_header "void gtk_list_box_row_set_header(GtkListBoxRow* row, GtkWidget* header)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_set_header", "GtkListBoxRow*");
  Xen_check_type(Xen_is_GtkWidget_(header), header, 2, "gtk_list_box_row_set_header", "GtkWidget*");
  gtk_list_box_row_set_header(Xen_to_C_GtkListBoxRow_(row), Xen_to_C_GtkWidget_(header));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_row_changed(Xen row)
{
  #define H_gtk_list_box_row_changed "void gtk_list_box_row_changed(GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_changed", "GtkListBoxRow*");
  gtk_list_box_row_changed(Xen_to_C_GtkListBoxRow_(row));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_get_selected_row(Xen list_box)
{
  #define H_gtk_list_box_get_selected_row "GtkListBoxRow* gtk_list_box_get_selected_row(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_get_selected_row", "GtkListBox*");
  return(C_to_Xen_GtkListBoxRow_(gtk_list_box_get_selected_row(Xen_to_C_GtkListBox_(list_box))));
}

static Xen gxg_gtk_list_box_get_row_at_index(Xen list_box, Xen index_)
{
  #define H_gtk_list_box_get_row_at_index "GtkListBoxRow* gtk_list_box_get_row_at_index(GtkListBox* list_box, \
gint index_)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_get_row_at_index", "GtkListBox*");
  Xen_check_type(Xen_is_gint(index_), index_, 2, "gtk_list_box_get_row_at_index", "gint");
  return(C_to_Xen_GtkListBoxRow_(gtk_list_box_get_row_at_index(Xen_to_C_GtkListBox_(list_box), Xen_to_C_gint(index_))));
}

static Xen gxg_gtk_list_box_get_row_at_y(Xen list_box, Xen y)
{
  #define H_gtk_list_box_get_row_at_y "GtkListBoxRow* gtk_list_box_get_row_at_y(GtkListBox* list_box, \
gint y)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_get_row_at_y", "GtkListBox*");
  Xen_check_type(Xen_is_gint(y), y, 2, "gtk_list_box_get_row_at_y", "gint");
  return(C_to_Xen_GtkListBoxRow_(gtk_list_box_get_row_at_y(Xen_to_C_GtkListBox_(list_box), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_list_box_select_row(Xen list_box, Xen row)
{
  #define H_gtk_list_box_select_row "void gtk_list_box_select_row(GtkListBox* list_box, GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_select_row", "GtkListBox*");
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 2, "gtk_list_box_select_row", "GtkListBoxRow*");
  gtk_list_box_select_row(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkListBoxRow_(row));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_set_placeholder(Xen list_box, Xen placeholder)
{
  #define H_gtk_list_box_set_placeholder "void gtk_list_box_set_placeholder(GtkListBox* list_box, GtkWidget* placeholder)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_set_placeholder", "GtkListBox*");
  Xen_check_type(Xen_is_GtkWidget_(placeholder), placeholder, 2, "gtk_list_box_set_placeholder", "GtkWidget*");
  gtk_list_box_set_placeholder(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkWidget_(placeholder));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_set_adjustment(Xen list_box, Xen adjustment)
{
  #define H_gtk_list_box_set_adjustment "void gtk_list_box_set_adjustment(GtkListBox* list_box, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_set_adjustment", "GtkListBox*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_list_box_set_adjustment", "GtkAdjustment*");
  gtk_list_box_set_adjustment(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_get_adjustment(Xen list_box)
{
  #define H_gtk_list_box_get_adjustment "GtkAdjustment* gtk_list_box_get_adjustment(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_get_adjustment", "GtkListBox*");
  return(C_to_Xen_GtkAdjustment_(gtk_list_box_get_adjustment(Xen_to_C_GtkListBox_(list_box))));
}

static Xen gxg_gtk_list_box_set_selection_mode(Xen list_box, Xen mode)
{
  #define H_gtk_list_box_set_selection_mode "void gtk_list_box_set_selection_mode(GtkListBox* list_box, \
GtkSelectionMode mode)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_set_selection_mode", "GtkListBox*");
  Xen_check_type(Xen_is_GtkSelectionMode(mode), mode, 2, "gtk_list_box_set_selection_mode", "GtkSelectionMode");
  gtk_list_box_set_selection_mode(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkSelectionMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_get_selection_mode(Xen list_box)
{
  #define H_gtk_list_box_get_selection_mode "GtkSelectionMode gtk_list_box_get_selection_mode(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_get_selection_mode", "GtkListBox*");
  return(C_to_Xen_GtkSelectionMode(gtk_list_box_get_selection_mode(Xen_to_C_GtkListBox_(list_box))));
}

static Xen gxg_gtk_list_box_invalidate_filter(Xen list_box)
{
  #define H_gtk_list_box_invalidate_filter "void gtk_list_box_invalidate_filter(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_invalidate_filter", "GtkListBox*");
  gtk_list_box_invalidate_filter(Xen_to_C_GtkListBox_(list_box));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_invalidate_sort(Xen list_box)
{
  #define H_gtk_list_box_invalidate_sort "void gtk_list_box_invalidate_sort(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_invalidate_sort", "GtkListBox*");
  gtk_list_box_invalidate_sort(Xen_to_C_GtkListBox_(list_box));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_invalidate_headers(Xen list_box)
{
  #define H_gtk_list_box_invalidate_headers "void gtk_list_box_invalidate_headers(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_invalidate_headers", "GtkListBox*");
  gtk_list_box_invalidate_headers(Xen_to_C_GtkListBox_(list_box));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_set_activate_on_single_click(Xen list_box, Xen single)
{
  #define H_gtk_list_box_set_activate_on_single_click "void gtk_list_box_set_activate_on_single_click(GtkListBox* list_box, \
gboolean single)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_set_activate_on_single_click", "GtkListBox*");
  Xen_check_type(Xen_is_gboolean(single), single, 2, "gtk_list_box_set_activate_on_single_click", "gboolean");
  gtk_list_box_set_activate_on_single_click(Xen_to_C_GtkListBox_(list_box), Xen_to_C_gboolean(single));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_get_activate_on_single_click(Xen list_box)
{
  #define H_gtk_list_box_get_activate_on_single_click "gboolean gtk_list_box_get_activate_on_single_click(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_get_activate_on_single_click", "GtkListBox*");
  return(C_to_Xen_gboolean(gtk_list_box_get_activate_on_single_click(Xen_to_C_GtkListBox_(list_box))));
}

static Xen gxg_gtk_list_box_drag_unhighlight_row(Xen list_box)
{
  #define H_gtk_list_box_drag_unhighlight_row "void gtk_list_box_drag_unhighlight_row(GtkListBox* list_box)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_drag_unhighlight_row", "GtkListBox*");
  gtk_list_box_drag_unhighlight_row(Xen_to_C_GtkListBox_(list_box));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_drag_highlight_row(Xen list_box, Xen row)
{
  #define H_gtk_list_box_drag_highlight_row "void gtk_list_box_drag_highlight_row(GtkListBox* list_box, \
GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_drag_highlight_row", "GtkListBox*");
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 2, "gtk_list_box_drag_highlight_row", "GtkListBoxRow*");
  gtk_list_box_drag_highlight_row(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkListBoxRow_(row));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_new(void)
{
  #define H_gtk_list_box_new "GtkWidget* gtk_list_box_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_list_box_new()));
}

static Xen gxg_gtk_search_bar_new(void)
{
  #define H_gtk_search_bar_new "GtkWidget* gtk_search_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_search_bar_new()));
}

static Xen gxg_gtk_search_bar_connect_entry(Xen bar, Xen entry)
{
  #define H_gtk_search_bar_connect_entry "void gtk_search_bar_connect_entry(GtkSearchBar* bar, GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkSearchBar_(bar), bar, 1, "gtk_search_bar_connect_entry", "GtkSearchBar*");
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 2, "gtk_search_bar_connect_entry", "GtkEntry*");
  gtk_search_bar_connect_entry(Xen_to_C_GtkSearchBar_(bar), Xen_to_C_GtkEntry_(entry));
  return(Xen_false);
}

static Xen gxg_gtk_search_bar_get_search_mode(Xen bar)
{
  #define H_gtk_search_bar_get_search_mode "gboolean gtk_search_bar_get_search_mode(GtkSearchBar* bar)"
  Xen_check_type(Xen_is_GtkSearchBar_(bar), bar, 1, "gtk_search_bar_get_search_mode", "GtkSearchBar*");
  return(C_to_Xen_gboolean(gtk_search_bar_get_search_mode(Xen_to_C_GtkSearchBar_(bar))));
}

static Xen gxg_gtk_search_bar_set_search_mode(Xen bar, Xen search_mode)
{
  #define H_gtk_search_bar_set_search_mode "void gtk_search_bar_set_search_mode(GtkSearchBar* bar, gboolean search_mode)"
  Xen_check_type(Xen_is_GtkSearchBar_(bar), bar, 1, "gtk_search_bar_set_search_mode", "GtkSearchBar*");
  Xen_check_type(Xen_is_gboolean(search_mode), search_mode, 2, "gtk_search_bar_set_search_mode", "gboolean");
  gtk_search_bar_set_search_mode(Xen_to_C_GtkSearchBar_(bar), Xen_to_C_gboolean(search_mode));
  return(Xen_false);
}

static Xen gxg_gtk_search_bar_handle_event(Xen bar, Xen event)
{
  #define H_gtk_search_bar_handle_event "gboolean gtk_search_bar_handle_event(GtkSearchBar* bar, GdkEvent* event)"
  Xen_check_type(Xen_is_GtkSearchBar_(bar), bar, 1, "gtk_search_bar_handle_event", "GtkSearchBar*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_search_bar_handle_event", "GdkEvent*");
  return(C_to_Xen_gboolean(gtk_search_bar_handle_event(Xen_to_C_GtkSearchBar_(bar), Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_file_chooser_get_current_name(Xen chooser)
{
  #define H_gtk_file_chooser_get_current_name "gchar* gtk_file_chooser_get_current_name(GtkFileChooser* chooser)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_current_name", "GtkFileChooser*");
  return(C_to_Xen_gchar_(gtk_file_chooser_get_current_name(Xen_to_C_GtkFileChooser_(chooser))));
}

static Xen gxg_gdk_cairo_surface_create_from_pixbuf(Xen pixbuf, Xen scale, Xen for_window)
{
  #define H_gdk_cairo_surface_create_from_pixbuf "cairo_surface_t* gdk_cairo_surface_create_from_pixbuf(GdkPixbuf* pixbuf, \
int scale, GdkWindow* for_window)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_cairo_surface_create_from_pixbuf", "GdkPixbuf*");
  Xen_check_type(Xen_is_int(scale), scale, 2, "gdk_cairo_surface_create_from_pixbuf", "int");
  Xen_check_type(Xen_is_GdkWindow_(for_window), for_window, 3, "gdk_cairo_surface_create_from_pixbuf", "GdkWindow*");
  return(C_to_Xen_cairo_surface_t_(gdk_cairo_surface_create_from_pixbuf(Xen_to_C_GdkPixbuf_(pixbuf), Xen_to_C_int(scale), 
                                                                        Xen_to_C_GdkWindow_(for_window))));
}

static Xen gxg_gdk_device_get_window_at_position_double(Xen device, Xen ignore_win_x, Xen ignore_win_y)
{
  #define H_gdk_device_get_window_at_position_double "GdkWindow* gdk_device_get_window_at_position_double(GdkDevice* device, \
gdouble* [win_x], gdouble* [win_y])"
  gdouble ref_win_x;
  gdouble ref_win_y;
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_window_at_position_double", "GdkDevice*");
  {
    Xen result;
    result = C_to_Xen_GdkWindow_(gdk_device_get_window_at_position_double(Xen_to_C_GdkDevice_(device), &ref_win_x, &ref_win_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_win_x), C_to_Xen_gdouble(ref_win_y)));
   }
}

static Xen gxg_gdk_window_get_scale_factor(Xen window)
{
  #define H_gdk_window_get_scale_factor "gint gdk_window_get_scale_factor(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_scale_factor", "GdkWindow*");
  return(C_to_Xen_gint(gdk_window_get_scale_factor(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_window_get_device_position_double(Xen window, Xen device, Xen ignore_x, Xen ignore_y, Xen ignore_mask)
{
  #define H_gdk_window_get_device_position_double "GdkWindow* gdk_window_get_device_position_double(GdkWindow* window, \
GdkDevice* device, gdouble* [x], gdouble* [y], GdkModifierType* [mask])"
  gdouble ref_x;
  gdouble ref_y;
  GdkModifierType ref_mask;
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_device_position_double", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_window_get_device_position_double", "GdkDevice*");
  {
    Xen result;
    result = C_to_Xen_GdkWindow_(gdk_window_get_device_position_double(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device), 
                                                                       &ref_x, &ref_y, &ref_mask));
    return(Xen_list_4(result, C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y), C_to_Xen_GdkModifierType(ref_mask)));
   }
}

static Xen gxg_gdk_window_create_similar_image_surface(Xen window, Xen format, Xen width, Xen height, Xen scale)
{
  #define H_gdk_window_create_similar_image_surface "cairo_surface_t* gdk_window_create_similar_image_surface(GdkWindow* window, \
cairo_format_t format, int width, int height, int scale)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_create_similar_image_surface", "GdkWindow*");
  Xen_check_type(Xen_is_cairo_format_t(format), format, 2, "gdk_window_create_similar_image_surface", "cairo_format_t");
  Xen_check_type(Xen_is_int(width), width, 3, "gdk_window_create_similar_image_surface", "int");
  Xen_check_type(Xen_is_int(height), height, 4, "gdk_window_create_similar_image_surface", "int");
  Xen_check_type(Xen_is_int(scale), scale, 5, "gdk_window_create_similar_image_surface", "int");
  return(C_to_Xen_cairo_surface_t_(gdk_window_create_similar_image_surface(Xen_to_C_GdkWindow_(window), Xen_to_C_cairo_format_t(format), 
                                                                           Xen_to_C_int(width), Xen_to_C_int(height), Xen_to_C_int(scale))));
}

static Xen gxg_gtk_icon_theme_lookup_icon_for_scale(Xen icon_theme, Xen icon_name, Xen size, Xen scale, Xen flags)
{
  #define H_gtk_icon_theme_lookup_icon_for_scale "GtkIconInfo* gtk_icon_theme_lookup_icon_for_scale(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, gint scale, GtkIconLookupFlags flags)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_lookup_icon_for_scale", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_lookup_icon_for_scale", "gchar*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_lookup_icon_for_scale", "gint");
  Xen_check_type(Xen_is_gint(scale), scale, 4, "gtk_icon_theme_lookup_icon_for_scale", "gint");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 5, "gtk_icon_theme_lookup_icon_for_scale", "GtkIconLookupFlags");
  return(C_to_Xen_GtkIconInfo_(gtk_icon_theme_lookup_icon_for_scale(Xen_to_C_GtkIconTheme_(icon_theme), (const gchar*)Xen_to_C_gchar_(icon_name), 
                                                                    Xen_to_C_gint(size), Xen_to_C_gint(scale), Xen_to_C_GtkIconLookupFlags(flags))));
}

static Xen gxg_gtk_icon_theme_load_icon_for_scale(Xen icon_theme, Xen icon_name, Xen size, Xen scale, Xen flags, Xen ignore_error)
{
  #define H_gtk_icon_theme_load_icon_for_scale "GdkPixbuf* gtk_icon_theme_load_icon_for_scale(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, gint scale, GtkIconLookupFlags flags, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_load_icon_for_scale", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_load_icon_for_scale", "gchar*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_load_icon_for_scale", "gint");
  Xen_check_type(Xen_is_gint(scale), scale, 4, "gtk_icon_theme_load_icon_for_scale", "gint");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 5, "gtk_icon_theme_load_icon_for_scale", "GtkIconLookupFlags");
  {
    Xen result;
    result = C_to_Xen_GdkPixbuf_(gtk_icon_theme_load_icon_for_scale(Xen_to_C_GtkIconTheme_(icon_theme), (const gchar*)Xen_to_C_gchar_(icon_name), 
                                                                    Xen_to_C_gint(size), Xen_to_C_gint(scale), Xen_to_C_GtkIconLookupFlags(flags), 
                                                                    &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_icon_theme_load_surface(Xen icon_theme, Xen icon_name, Xen size, Xen scale, Xen for_window, Xen flags, Xen ignore_error)
{
  #define H_gtk_icon_theme_load_surface "cairo_surface_t* gtk_icon_theme_load_surface(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, gint scale, GdkWindow* for_window, GtkIconLookupFlags flags, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_load_surface", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_icon_theme_load_surface", "gchar*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_load_surface", "gint");
  Xen_check_type(Xen_is_gint(scale), scale, 4, "gtk_icon_theme_load_surface", "gint");
  Xen_check_type(Xen_is_GdkWindow_(for_window), for_window, 5, "gtk_icon_theme_load_surface", "GdkWindow*");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 6, "gtk_icon_theme_load_surface", "GtkIconLookupFlags");
  {
    Xen result;
    result = C_to_Xen_cairo_surface_t_(gtk_icon_theme_load_surface(Xen_to_C_GtkIconTheme_(icon_theme), (const gchar*)Xen_to_C_gchar_(icon_name), 
                                                                   Xen_to_C_gint(size), Xen_to_C_gint(scale), Xen_to_C_GdkWindow_(for_window), 
                                                                   Xen_to_C_GtkIconLookupFlags(flags), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_icon_theme_lookup_by_gicon_for_scale(Xen icon_theme, Xen icon, Xen size, Xen scale, Xen flags)
{
  #define H_gtk_icon_theme_lookup_by_gicon_for_scale "GtkIconInfo* gtk_icon_theme_lookup_by_gicon_for_scale(GtkIconTheme* icon_theme, \
GIcon* icon, gint size, gint scale, GtkIconLookupFlags flags)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_lookup_by_gicon_for_scale", "GtkIconTheme*");
  Xen_check_type(Xen_is_GIcon_(icon), icon, 2, "gtk_icon_theme_lookup_by_gicon_for_scale", "GIcon*");
  Xen_check_type(Xen_is_gint(size), size, 3, "gtk_icon_theme_lookup_by_gicon_for_scale", "gint");
  Xen_check_type(Xen_is_gint(scale), scale, 4, "gtk_icon_theme_lookup_by_gicon_for_scale", "gint");
  Xen_check_type(Xen_is_GtkIconLookupFlags(flags), flags, 5, "gtk_icon_theme_lookup_by_gicon_for_scale", "GtkIconLookupFlags");
  return(C_to_Xen_GtkIconInfo_(gtk_icon_theme_lookup_by_gicon_for_scale(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_GIcon_(icon), 
                                                                        Xen_to_C_gint(size), Xen_to_C_gint(scale), Xen_to_C_GtkIconLookupFlags(flags))));
}

static Xen gxg_gtk_icon_info_get_base_scale(Xen icon_info)
{
  #define H_gtk_icon_info_get_base_scale "gint gtk_icon_info_get_base_scale(GtkIconInfo* icon_info)"
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_get_base_scale", "GtkIconInfo*");
  return(C_to_Xen_gint(gtk_icon_info_get_base_scale(Xen_to_C_GtkIconInfo_(icon_info))));
}

static Xen gxg_gtk_icon_info_load_surface(Xen icon_info, Xen for_window, Xen ignore_error)
{
  #define H_gtk_icon_info_load_surface "cairo_surface_t* gtk_icon_info_load_surface(GtkIconInfo* icon_info, \
GdkWindow* for_window, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_load_surface", "GtkIconInfo*");
  Xen_check_type(Xen_is_GdkWindow_(for_window), for_window, 2, "gtk_icon_info_load_surface", "GdkWindow*");
  {
    Xen result;
    result = C_to_Xen_cairo_surface_t_(gtk_icon_info_load_surface(Xen_to_C_GtkIconInfo_(icon_info), Xen_to_C_GdkWindow_(for_window), 
                                                                  &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_image_new_from_surface(Xen surface)
{
  #define H_gtk_image_new_from_surface "GtkWidget* gtk_image_new_from_surface(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "gtk_image_new_from_surface", "cairo_surface_t*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_surface(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_gtk_image_set_from_surface(Xen image, Xen surface)
{
  #define H_gtk_image_set_from_surface "void gtk_image_set_from_surface(GtkImage* image, cairo_surface_t* surface)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_surface", "GtkImage*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 2, "gtk_image_set_from_surface", "cairo_surface_t*");
  gtk_image_set_from_surface(Xen_to_C_GtkImage_(image), Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_row_get_index(Xen row)
{
  #define H_gtk_list_box_row_get_index "gint gtk_list_box_row_get_index(GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_get_index", "GtkListBoxRow*");
  return(C_to_Xen_gint(gtk_list_box_row_get_index(Xen_to_C_GtkListBoxRow_(row))));
}

static Xen gxg_gtk_widget_get_scale_factor(Xen widget)
{
  #define H_gtk_widget_get_scale_factor "gint gtk_widget_get_scale_factor(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_scale_factor", "GtkWidget*");
  return(C_to_Xen_gint(gtk_widget_get_scale_factor(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_window_close(Xen window)
{
  #define H_gtk_window_close "void gtk_window_close(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_close", "GtkWindow*");
  gtk_window_close(Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_set_show_close_button(Xen info_bar, Xen setting)
{
  #define H_gtk_info_bar_set_show_close_button "void gtk_info_bar_set_show_close_button(GtkInfoBar* info_bar, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_set_show_close_button", "GtkInfoBar*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_info_bar_set_show_close_button", "gboolean");
  gtk_info_bar_set_show_close_button(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_get_show_close_button(Xen info_bar)
{
  #define H_gtk_info_bar_get_show_close_button "gboolean gtk_info_bar_get_show_close_button(GtkInfoBar* info_bar)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_get_show_close_button", "GtkInfoBar*");
  return(C_to_Xen_gboolean(gtk_info_bar_get_show_close_button(Xen_to_C_GtkInfoBar_(info_bar))));
}

static Xen gxg_gtk_tree_model_rows_reordered_with_length(Xen tree_model, Xen path, Xen iter, Xen new_order, Xen length)
{
  #define H_gtk_tree_model_rows_reordered_with_length "void gtk_tree_model_rows_reordered_with_length(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order, gint length)"
  Xen_check_type(Xen_is_GtkTreeModel_(tree_model), tree_model, 1, "gtk_tree_model_rows_reordered_with_length", "GtkTreeModel*");
  Xen_check_type(Xen_is_GtkTreePath_(path), path, 2, "gtk_tree_model_rows_reordered_with_length", "GtkTreePath*");
  Xen_check_type(Xen_is_GtkTreeIter_(iter), iter, 3, "gtk_tree_model_rows_reordered_with_length", "GtkTreeIter*");
  Xen_check_type(Xen_is_gint_(new_order), new_order, 4, "gtk_tree_model_rows_reordered_with_length", "gint*");
  Xen_check_type(Xen_is_gint(length), length, 5, "gtk_tree_model_rows_reordered_with_length", "gint");
  gtk_tree_model_rows_reordered_with_length(Xen_to_C_GtkTreeModel_(tree_model), Xen_to_C_GtkTreePath_(path), Xen_to_C_GtkTreeIter_(iter), 
                                            Xen_to_C_gint_(new_order), Xen_to_C_gint(length));
  return(Xen_false);
}

static Xen gxg_gdk_event_get_event_type(Xen event)
{
  #define H_gdk_event_get_event_type "GdkEventType gdk_event_get_event_type(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_event_type", "GdkEvent*");
  return(C_to_Xen_GdkEventType(gdk_event_get_event_type(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_entry_set_tabs(Xen entry, Xen tabs)
{
  #define H_gtk_entry_set_tabs "void gtk_entry_set_tabs(GtkEntry* entry, PangoTabArray* tabs)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_tabs", "GtkEntry*");
  Xen_check_type(Xen_is_PangoTabArray_(tabs), tabs, 2, "gtk_entry_set_tabs", "PangoTabArray*");
  gtk_entry_set_tabs(Xen_to_C_GtkEntry_(entry), Xen_to_C_PangoTabArray_(tabs));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_tabs(Xen entry)
{
  #define H_gtk_entry_get_tabs "PangoTabArray* gtk_entry_get_tabs(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_tabs", "GtkEntry*");
  return(C_to_Xen_PangoTabArray_(gtk_entry_get_tabs(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gtk_list_box_prepend(Xen list_box, Xen child)
{
  #define H_gtk_list_box_prepend "void gtk_list_box_prepend(GtkListBox* list_box, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_prepend", "GtkListBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_list_box_prepend", "GtkWidget*");
  gtk_list_box_prepend(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_insert(Xen list_box, Xen child, Xen position)
{
  #define H_gtk_list_box_insert "void gtk_list_box_insert(GtkListBox* list_box, GtkWidget* child, gint position)"
  Xen_check_type(Xen_is_GtkListBox_(list_box), list_box, 1, "gtk_list_box_insert", "GtkListBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_list_box_insert", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_list_box_insert", "gint");
  gtk_list_box_insert(Xen_to_C_GtkListBox_(list_box), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gdk_window_set_opaque_region(Xen window, Xen region)
{
  #define H_gdk_window_set_opaque_region "void gdk_window_set_opaque_region(GdkWindow* window, cairo_region_t* region)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_opaque_region", "GdkWindow*");
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 2, "gdk_window_set_opaque_region", "cairo_region_t*");
  gdk_window_set_opaque_region(Xen_to_C_GdkWindow_(window), Xen_to_C_cairo_region_t_(region));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_lines(Xen label, Xen lines)
{
  #define H_gtk_label_set_lines "void gtk_label_set_lines(GtkLabel* label, gint lines)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_lines", "GtkLabel*");
  Xen_check_type(Xen_is_gint(lines), lines, 2, "gtk_label_set_lines", "gint");
  gtk_label_set_lines(Xen_to_C_GtkLabel_(label), Xen_to_C_gint(lines));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_lines(Xen label)
{
  #define H_gtk_label_get_lines "gint gtk_label_get_lines(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_lines", "GtkLabel*");
  return(C_to_Xen_gint(gtk_label_get_lines(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gdk_event_get_window(Xen event)
{
  #define H_gdk_event_get_window "GdkWindow* gdk_event_get_window(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_window", "GdkEvent*");
  return(C_to_Xen_GdkWindow_(gdk_event_get_window(Xen_to_C_GdkEvent_(event))));
}

#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static Xen gxg_gtk_flow_box_child_new(void)
{
  #define H_gtk_flow_box_child_new "GtkWidget* gtk_flow_box_child_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_flow_box_child_new()));
}

static Xen gxg_gtk_flow_box_child_get_index(Xen child)
{
  #define H_gtk_flow_box_child_get_index "gint gtk_flow_box_child_get_index(GtkFlowBoxChild* child)"
  Xen_check_type(Xen_is_GtkFlowBoxChild_(child), child, 1, "gtk_flow_box_child_get_index", "GtkFlowBoxChild*");
  return(C_to_Xen_gint(gtk_flow_box_child_get_index(Xen_to_C_GtkFlowBoxChild_(child))));
}

static Xen gxg_gtk_flow_box_child_is_selected(Xen child)
{
  #define H_gtk_flow_box_child_is_selected "gboolean gtk_flow_box_child_is_selected(GtkFlowBoxChild* child)"
  Xen_check_type(Xen_is_GtkFlowBoxChild_(child), child, 1, "gtk_flow_box_child_is_selected", "GtkFlowBoxChild*");
  return(C_to_Xen_gboolean(gtk_flow_box_child_is_selected(Xen_to_C_GtkFlowBoxChild_(child))));
}

static Xen gxg_gtk_flow_box_child_changed(Xen child)
{
  #define H_gtk_flow_box_child_changed "void gtk_flow_box_child_changed(GtkFlowBoxChild* child)"
  Xen_check_type(Xen_is_GtkFlowBoxChild_(child), child, 1, "gtk_flow_box_child_changed", "GtkFlowBoxChild*");
  gtk_flow_box_child_changed(Xen_to_C_GtkFlowBoxChild_(child));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_new(void)
{
  #define H_gtk_flow_box_new "GtkWidget* gtk_flow_box_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_flow_box_new()));
}

static Xen gxg_gtk_flow_box_set_homogeneous(Xen box, Xen homogeneous)
{
  #define H_gtk_flow_box_set_homogeneous "void gtk_flow_box_set_homogeneous(GtkFlowBox* box, gboolean homogeneous)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_homogeneous", "GtkFlowBox*");
  Xen_check_type(Xen_is_gboolean(homogeneous), homogeneous, 2, "gtk_flow_box_set_homogeneous", "gboolean");
  gtk_flow_box_set_homogeneous(Xen_to_C_GtkFlowBox_(box), Xen_to_C_gboolean(homogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_homogeneous(Xen box)
{
  #define H_gtk_flow_box_get_homogeneous "gboolean gtk_flow_box_get_homogeneous(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_homogeneous", "GtkFlowBox*");
  return(C_to_Xen_gboolean(gtk_flow_box_get_homogeneous(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_set_row_spacing(Xen box, Xen spacing)
{
  #define H_gtk_flow_box_set_row_spacing "void gtk_flow_box_set_row_spacing(GtkFlowBox* box, guint spacing)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_row_spacing", "GtkFlowBox*");
  Xen_check_type(Xen_is_guint(spacing), spacing, 2, "gtk_flow_box_set_row_spacing", "guint");
  gtk_flow_box_set_row_spacing(Xen_to_C_GtkFlowBox_(box), Xen_to_C_guint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_row_spacing(Xen box)
{
  #define H_gtk_flow_box_get_row_spacing "guint gtk_flow_box_get_row_spacing(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_row_spacing", "GtkFlowBox*");
  return(C_to_Xen_guint(gtk_flow_box_get_row_spacing(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_set_column_spacing(Xen box, Xen spacing)
{
  #define H_gtk_flow_box_set_column_spacing "void gtk_flow_box_set_column_spacing(GtkFlowBox* box, guint spacing)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_column_spacing", "GtkFlowBox*");
  Xen_check_type(Xen_is_guint(spacing), spacing, 2, "gtk_flow_box_set_column_spacing", "guint");
  gtk_flow_box_set_column_spacing(Xen_to_C_GtkFlowBox_(box), Xen_to_C_guint(spacing));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_column_spacing(Xen box)
{
  #define H_gtk_flow_box_get_column_spacing "guint gtk_flow_box_get_column_spacing(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_column_spacing", "GtkFlowBox*");
  return(C_to_Xen_guint(gtk_flow_box_get_column_spacing(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_set_min_children_per_line(Xen box, Xen n_children)
{
  #define H_gtk_flow_box_set_min_children_per_line "void gtk_flow_box_set_min_children_per_line(GtkFlowBox* box, \
guint n_children)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_min_children_per_line", "GtkFlowBox*");
  Xen_check_type(Xen_is_guint(n_children), n_children, 2, "gtk_flow_box_set_min_children_per_line", "guint");
  gtk_flow_box_set_min_children_per_line(Xen_to_C_GtkFlowBox_(box), Xen_to_C_guint(n_children));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_min_children_per_line(Xen box)
{
  #define H_gtk_flow_box_get_min_children_per_line "guint gtk_flow_box_get_min_children_per_line(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_min_children_per_line", "GtkFlowBox*");
  return(C_to_Xen_guint(gtk_flow_box_get_min_children_per_line(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_set_max_children_per_line(Xen box, Xen n_children)
{
  #define H_gtk_flow_box_set_max_children_per_line "void gtk_flow_box_set_max_children_per_line(GtkFlowBox* box, \
guint n_children)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_max_children_per_line", "GtkFlowBox*");
  Xen_check_type(Xen_is_guint(n_children), n_children, 2, "gtk_flow_box_set_max_children_per_line", "guint");
  gtk_flow_box_set_max_children_per_line(Xen_to_C_GtkFlowBox_(box), Xen_to_C_guint(n_children));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_max_children_per_line(Xen box)
{
  #define H_gtk_flow_box_get_max_children_per_line "guint gtk_flow_box_get_max_children_per_line(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_max_children_per_line", "GtkFlowBox*");
  return(C_to_Xen_guint(gtk_flow_box_get_max_children_per_line(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_set_activate_on_single_click(Xen box, Xen single)
{
  #define H_gtk_flow_box_set_activate_on_single_click "void gtk_flow_box_set_activate_on_single_click(GtkFlowBox* box, \
gboolean single)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_activate_on_single_click", "GtkFlowBox*");
  Xen_check_type(Xen_is_gboolean(single), single, 2, "gtk_flow_box_set_activate_on_single_click", "gboolean");
  gtk_flow_box_set_activate_on_single_click(Xen_to_C_GtkFlowBox_(box), Xen_to_C_gboolean(single));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_activate_on_single_click(Xen box)
{
  #define H_gtk_flow_box_get_activate_on_single_click "gboolean gtk_flow_box_get_activate_on_single_click(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_activate_on_single_click", "GtkFlowBox*");
  return(C_to_Xen_gboolean(gtk_flow_box_get_activate_on_single_click(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_insert(Xen box, Xen widget, Xen position)
{
  #define H_gtk_flow_box_insert "void gtk_flow_box_insert(GtkFlowBox* box, GtkWidget* widget, gint position)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_insert", "GtkFlowBox*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_flow_box_insert", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_flow_box_insert", "gint");
  gtk_flow_box_insert(Xen_to_C_GtkFlowBox_(box), Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_child_at_index(Xen box, Xen idx)
{
  #define H_gtk_flow_box_get_child_at_index "GtkFlowBoxChild* gtk_flow_box_get_child_at_index(GtkFlowBox* box, \
gint idx)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_child_at_index", "GtkFlowBox*");
  Xen_check_type(Xen_is_gint(idx), idx, 2, "gtk_flow_box_get_child_at_index", "gint");
  return(C_to_Xen_GtkFlowBoxChild_(gtk_flow_box_get_child_at_index(Xen_to_C_GtkFlowBox_(box), Xen_to_C_gint(idx))));
}

static Xen gxg_gtk_flow_box_get_selected_children(Xen box)
{
  #define H_gtk_flow_box_get_selected_children "GList* gtk_flow_box_get_selected_children(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_selected_children", "GtkFlowBox*");
  return(C_to_Xen_GList_(gtk_flow_box_get_selected_children(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_select_child(Xen box, Xen child)
{
  #define H_gtk_flow_box_select_child "void gtk_flow_box_select_child(GtkFlowBox* box, GtkFlowBoxChild* child)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_select_child", "GtkFlowBox*");
  Xen_check_type(Xen_is_GtkFlowBoxChild_(child), child, 2, "gtk_flow_box_select_child", "GtkFlowBoxChild*");
  gtk_flow_box_select_child(Xen_to_C_GtkFlowBox_(box), Xen_to_C_GtkFlowBoxChild_(child));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_unselect_child(Xen box, Xen child)
{
  #define H_gtk_flow_box_unselect_child "void gtk_flow_box_unselect_child(GtkFlowBox* box, GtkFlowBoxChild* child)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_unselect_child", "GtkFlowBox*");
  Xen_check_type(Xen_is_GtkFlowBoxChild_(child), child, 2, "gtk_flow_box_unselect_child", "GtkFlowBoxChild*");
  gtk_flow_box_unselect_child(Xen_to_C_GtkFlowBox_(box), Xen_to_C_GtkFlowBoxChild_(child));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_select_all(Xen box)
{
  #define H_gtk_flow_box_select_all "void gtk_flow_box_select_all(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_select_all", "GtkFlowBox*");
  gtk_flow_box_select_all(Xen_to_C_GtkFlowBox_(box));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_unselect_all(Xen box)
{
  #define H_gtk_flow_box_unselect_all "void gtk_flow_box_unselect_all(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_unselect_all", "GtkFlowBox*");
  gtk_flow_box_unselect_all(Xen_to_C_GtkFlowBox_(box));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_set_selection_mode(Xen box, Xen mode)
{
  #define H_gtk_flow_box_set_selection_mode "void gtk_flow_box_set_selection_mode(GtkFlowBox* box, GtkSelectionMode mode)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_selection_mode", "GtkFlowBox*");
  Xen_check_type(Xen_is_GtkSelectionMode(mode), mode, 2, "gtk_flow_box_set_selection_mode", "GtkSelectionMode");
  gtk_flow_box_set_selection_mode(Xen_to_C_GtkFlowBox_(box), Xen_to_C_GtkSelectionMode(mode));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_get_selection_mode(Xen box)
{
  #define H_gtk_flow_box_get_selection_mode "GtkSelectionMode gtk_flow_box_get_selection_mode(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_selection_mode", "GtkFlowBox*");
  return(C_to_Xen_GtkSelectionMode(gtk_flow_box_get_selection_mode(Xen_to_C_GtkFlowBox_(box))));
}

static Xen gxg_gtk_flow_box_set_hadjustment(Xen box, Xen adjustment)
{
  #define H_gtk_flow_box_set_hadjustment "void gtk_flow_box_set_hadjustment(GtkFlowBox* box, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_hadjustment", "GtkFlowBox*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_flow_box_set_hadjustment", "GtkAdjustment*");
  gtk_flow_box_set_hadjustment(Xen_to_C_GtkFlowBox_(box), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_set_vadjustment(Xen box, Xen adjustment)
{
  #define H_gtk_flow_box_set_vadjustment "void gtk_flow_box_set_vadjustment(GtkFlowBox* box, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_set_vadjustment", "GtkFlowBox*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_flow_box_set_vadjustment", "GtkAdjustment*");
  gtk_flow_box_set_vadjustment(Xen_to_C_GtkFlowBox_(box), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_invalidate_filter(Xen box)
{
  #define H_gtk_flow_box_invalidate_filter "void gtk_flow_box_invalidate_filter(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_invalidate_filter", "GtkFlowBox*");
  gtk_flow_box_invalidate_filter(Xen_to_C_GtkFlowBox_(box));
  return(Xen_false);
}

static Xen gxg_gtk_flow_box_invalidate_sort(Xen box)
{
  #define H_gtk_flow_box_invalidate_sort "void gtk_flow_box_invalidate_sort(GtkFlowBox* box)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_invalidate_sort", "GtkFlowBox*");
  gtk_flow_box_invalidate_sort(Xen_to_C_GtkFlowBox_(box));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_set_local_only(Xen sidebar, Xen local_only)
{
  #define H_gtk_places_sidebar_set_local_only "void gtk_places_sidebar_set_local_only(GtkPlacesSidebar* sidebar, \
gboolean local_only)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_local_only", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(local_only), local_only, 2, "gtk_places_sidebar_set_local_only", "gboolean");
  gtk_places_sidebar_set_local_only(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(local_only));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_local_only(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_local_only "gboolean gtk_places_sidebar_get_local_only(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_local_only", "GtkPlacesSidebar*");
  return(C_to_Xen_gboolean(gtk_places_sidebar_get_local_only(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_stack_get_transition_running(Xen stack)
{
  #define H_gtk_stack_get_transition_running "gboolean gtk_stack_get_transition_running(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_transition_running", "GtkStack*");
  return(C_to_Xen_gboolean(gtk_stack_get_transition_running(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_widget_get_margin_start(Xen widget)
{
  #define H_gtk_widget_get_margin_start "gint gtk_widget_get_margin_start(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_margin_start", "GtkWidget*");
  return(C_to_Xen_gint(gtk_widget_get_margin_start(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_margin_start(Xen widget, Xen margin)
{
  #define H_gtk_widget_set_margin_start "void gtk_widget_set_margin_start(GtkWidget* widget, gint margin)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_margin_start", "GtkWidget*");
  Xen_check_type(Xen_is_gint(margin), margin, 2, "gtk_widget_set_margin_start", "gint");
  gtk_widget_set_margin_start(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(margin));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_margin_end(Xen widget)
{
  #define H_gtk_widget_get_margin_end "gint gtk_widget_get_margin_end(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_margin_end", "GtkWidget*");
  return(C_to_Xen_gint(gtk_widget_get_margin_end(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_margin_end(Xen widget, Xen margin)
{
  #define H_gtk_widget_set_margin_end "void gtk_widget_set_margin_end(GtkWidget* widget, gint margin)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_margin_end", "GtkWidget*");
  Xen_check_type(Xen_is_gint(margin), margin, 2, "gtk_widget_set_margin_end", "gint");
  gtk_widget_set_margin_end(Xen_to_C_GtkWidget_(widget), Xen_to_C_gint(margin));
  return(Xen_false);
}

static Xen gxg_gtk_accel_label_get_accel(Xen accel_label, Xen ignore_accelerator_key, Xen ignore_accelerator_mods)
{
  #define H_gtk_accel_label_get_accel "void gtk_accel_label_get_accel(GtkAccelLabel* accel_label, guint* [accelerator_key], \
GdkModifierType* [accelerator_mods])"
  guint ref_accelerator_key;
  GdkModifierType ref_accelerator_mods;
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_get_accel", "GtkAccelLabel*");
  gtk_accel_label_get_accel(Xen_to_C_GtkAccelLabel_(accel_label), &ref_accelerator_key, &ref_accelerator_mods);
  return(Xen_list_2(C_to_Xen_guint(ref_accelerator_key), C_to_Xen_GdkModifierType(ref_accelerator_mods)));
}

static Xen gxg_gdk_window_set_shadow_width(Xen window, Xen left, Xen right, Xen top, Xen bottom)
{
  #define H_gdk_window_set_shadow_width "void gdk_window_set_shadow_width(GdkWindow* window, gint left, \
gint right, gint top, gint bottom)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_shadow_width", "GdkWindow*");
  Xen_check_type(Xen_is_gint(left), left, 2, "gdk_window_set_shadow_width", "gint");
  Xen_check_type(Xen_is_gint(right), right, 3, "gdk_window_set_shadow_width", "gint");
  Xen_check_type(Xen_is_gint(top), top, 4, "gdk_window_set_shadow_width", "gint");
  Xen_check_type(Xen_is_gint(bottom), bottom, 5, "gdk_window_set_shadow_width", "gint");
  gdk_window_set_shadow_width(Xen_to_C_GdkWindow_(window), Xen_to_C_gint(left), Xen_to_C_gint(right), Xen_to_C_gint(top), 
                              Xen_to_C_gint(bottom));
  return(Xen_false);
}

static Xen gxg_gtk_action_bar_new(void)
{
  #define H_gtk_action_bar_new "GtkWidget* gtk_action_bar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_action_bar_new()));
}

static Xen gxg_gtk_action_bar_get_center_widget(Xen bar)
{
  #define H_gtk_action_bar_get_center_widget "GtkWidget* gtk_action_bar_get_center_widget(GtkActionBar* bar)"
  Xen_check_type(Xen_is_GtkActionBar_(bar), bar, 1, "gtk_action_bar_get_center_widget", "GtkActionBar*");
  return(C_to_Xen_GtkWidget_(gtk_action_bar_get_center_widget(Xen_to_C_GtkActionBar_(bar))));
}

static Xen gxg_gtk_action_bar_set_center_widget(Xen bar, Xen center_widget)
{
  #define H_gtk_action_bar_set_center_widget "void gtk_action_bar_set_center_widget(GtkActionBar* bar, \
GtkWidget* center_widget)"
  Xen_check_type(Xen_is_GtkActionBar_(bar), bar, 1, "gtk_action_bar_set_center_widget", "GtkActionBar*");
  Xen_check_type(Xen_is_GtkWidget_(center_widget), center_widget, 2, "gtk_action_bar_set_center_widget", "GtkWidget*");
  gtk_action_bar_set_center_widget(Xen_to_C_GtkActionBar_(bar), Xen_to_C_GtkWidget_(center_widget));
  return(Xen_false);
}

static Xen gxg_gtk_action_bar_pack_start(Xen bar, Xen child)
{
  #define H_gtk_action_bar_pack_start "void gtk_action_bar_pack_start(GtkActionBar* bar, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkActionBar_(bar), bar, 1, "gtk_action_bar_pack_start", "GtkActionBar*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_action_bar_pack_start", "GtkWidget*");
  gtk_action_bar_pack_start(Xen_to_C_GtkActionBar_(bar), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_action_bar_pack_end(Xen bar, Xen child)
{
  #define H_gtk_action_bar_pack_end "void gtk_action_bar_pack_end(GtkActionBar* bar, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkActionBar_(bar), bar, 1, "gtk_action_bar_pack_end", "GtkActionBar*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_action_bar_pack_end", "GtkWidget*");
  gtk_action_bar_pack_end(Xen_to_C_GtkActionBar_(bar), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_set_has_subtitle(Xen bar, Xen setting)
{
  #define H_gtk_header_bar_set_has_subtitle "void gtk_header_bar_set_has_subtitle(GtkHeaderBar* bar, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_set_has_subtitle", "GtkHeaderBar*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_header_bar_set_has_subtitle", "gboolean");
  gtk_header_bar_set_has_subtitle(Xen_to_C_GtkHeaderBar_(bar), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_get_has_subtitle(Xen bar)
{
  #define H_gtk_header_bar_get_has_subtitle "gboolean gtk_header_bar_get_has_subtitle(GtkHeaderBar* bar)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_get_has_subtitle", "GtkHeaderBar*");
  return(C_to_Xen_gboolean(gtk_header_bar_get_has_subtitle(Xen_to_C_GtkHeaderBar_(bar))));
}

static Xen gxg_gtk_header_bar_set_decoration_layout(Xen bar, Xen layout)
{
  #define H_gtk_header_bar_set_decoration_layout "void gtk_header_bar_set_decoration_layout(GtkHeaderBar* bar, \
gchar* layout)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_set_decoration_layout", "GtkHeaderBar*");
  Xen_check_type(Xen_is_gchar_(layout), layout, 2, "gtk_header_bar_set_decoration_layout", "gchar*");
  gtk_header_bar_set_decoration_layout(Xen_to_C_GtkHeaderBar_(bar), (const gchar*)Xen_to_C_gchar_(layout));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_get_decoration_layout(Xen bar)
{
  #define H_gtk_header_bar_get_decoration_layout "gchar* gtk_header_bar_get_decoration_layout(GtkHeaderBar* bar)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_get_decoration_layout", "GtkHeaderBar*");
  return(C_to_Xen_gchar_(gtk_header_bar_get_decoration_layout(Xen_to_C_GtkHeaderBar_(bar))));
}

static Xen gxg_gtk_icon_info_is_symbolic(Xen icon_info)
{
  #define H_gtk_icon_info_is_symbolic "gboolean gtk_icon_info_is_symbolic(GtkIconInfo* icon_info)"
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_is_symbolic", "GtkIconInfo*");
  return(C_to_Xen_gboolean(gtk_icon_info_is_symbolic(Xen_to_C_GtkIconInfo_(icon_info))));
}

static Xen gxg_gtk_get_locale_direction(void)
{
  #define H_gtk_get_locale_direction "GtkTextDirection gtk_get_locale_direction( void)"
  return(C_to_Xen_GtkTextDirection(gtk_get_locale_direction()));
}

static Xen gxg_gtk_window_is_maximized(Xen window)
{
  #define H_gtk_window_is_maximized "gboolean gtk_window_is_maximized(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_is_maximized", "GtkWindow*");
  return(C_to_Xen_gboolean(gtk_window_is_maximized(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_dialog_get_header_bar(Xen dialog)
{
  #define H_gtk_dialog_get_header_bar "GtkWidget* gtk_dialog_get_header_bar(GtkDialog* dialog)"
  Xen_check_type(Xen_is_GtkDialog_(dialog), dialog, 1, "gtk_dialog_get_header_bar", "GtkDialog*");
  return(C_to_Xen_GtkWidget_(gtk_dialog_get_header_bar(Xen_to_C_GtkDialog_(dialog))));
}

static Xen gxg_gtk_popover_new(Xen relative_to)
{
  #define H_gtk_popover_new "GtkWidget* gtk_popover_new(GtkWidget* relative_to)"
  Xen_check_type(Xen_is_GtkWidget_(relative_to), relative_to, 1, "gtk_popover_new", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_popover_new(Xen_to_C_GtkWidget_(relative_to))));
}

static Xen gxg_gtk_popover_set_relative_to(Xen popover, Xen relative_to)
{
  #define H_gtk_popover_set_relative_to "void gtk_popover_set_relative_to(GtkPopover* popover, GtkWidget* relative_to)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_set_relative_to", "GtkPopover*");
  Xen_check_type(Xen_is_GtkWidget_(relative_to), relative_to, 2, "gtk_popover_set_relative_to", "GtkWidget*");
  gtk_popover_set_relative_to(Xen_to_C_GtkPopover_(popover), Xen_to_C_GtkWidget_(relative_to));
  return(Xen_false);
}

static Xen gxg_gtk_popover_get_relative_to(Xen popover)
{
  #define H_gtk_popover_get_relative_to "GtkWidget* gtk_popover_get_relative_to(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_get_relative_to", "GtkPopover*");
  return(C_to_Xen_GtkWidget_(gtk_popover_get_relative_to(Xen_to_C_GtkPopover_(popover))));
}

static Xen gxg_gtk_popover_set_position(Xen popover, Xen position)
{
  #define H_gtk_popover_set_position "void gtk_popover_set_position(GtkPopover* popover, GtkPositionType position)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_set_position", "GtkPopover*");
  Xen_check_type(Xen_is_GtkPositionType(position), position, 2, "gtk_popover_set_position", "GtkPositionType");
  gtk_popover_set_position(Xen_to_C_GtkPopover_(popover), Xen_to_C_GtkPositionType(position));
  return(Xen_false);
}

static Xen gxg_gtk_popover_get_position(Xen popover)
{
  #define H_gtk_popover_get_position "GtkPositionType gtk_popover_get_position(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_get_position", "GtkPopover*");
  return(C_to_Xen_GtkPositionType(gtk_popover_get_position(Xen_to_C_GtkPopover_(popover))));
}

static Xen gxg_gtk_popover_set_modal(Xen popover, Xen modal)
{
  #define H_gtk_popover_set_modal "void gtk_popover_set_modal(GtkPopover* popover, gboolean modal)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_set_modal", "GtkPopover*");
  Xen_check_type(Xen_is_gboolean(modal), modal, 2, "gtk_popover_set_modal", "gboolean");
  gtk_popover_set_modal(Xen_to_C_GtkPopover_(popover), Xen_to_C_gboolean(modal));
  return(Xen_false);
}

static Xen gxg_gtk_popover_get_modal(Xen popover)
{
  #define H_gtk_popover_get_modal "gboolean gtk_popover_get_modal(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_get_modal", "GtkPopover*");
  return(C_to_Xen_gboolean(gtk_popover_get_modal(Xen_to_C_GtkPopover_(popover))));
}

static Xen gxg_gtk_entry_set_max_width_chars(Xen entry, Xen n_chars)
{
  #define H_gtk_entry_set_max_width_chars "void gtk_entry_set_max_width_chars(GtkEntry* entry, gint n_chars)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_max_width_chars", "GtkEntry*");
  Xen_check_type(Xen_is_gint(n_chars), n_chars, 2, "gtk_entry_set_max_width_chars", "gint");
  gtk_entry_set_max_width_chars(Xen_to_C_GtkEntry_(entry), Xen_to_C_gint(n_chars));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_max_width_chars(Xen entry)
{
  #define H_gtk_entry_get_max_width_chars "gint gtk_entry_get_max_width_chars(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_max_width_chars", "GtkEntry*");
  return(C_to_Xen_gint(gtk_entry_get_max_width_chars(Xen_to_C_GtkEntry_(entry))));
}

static Xen gxg_gdk_device_get_last_event_window(Xen device)
{
  #define H_gdk_device_get_last_event_window "GdkWindow* gdk_device_get_last_event_window(GdkDevice* device)"
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_last_event_window", "GdkDevice*");
  return(C_to_Xen_GdkWindow_(gdk_device_get_last_event_window(Xen_to_C_GdkDevice_(device))));
}

#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static Xen gxg_gtk_list_box_row_is_selected(Xen row)
{
  #define H_gtk_list_box_row_is_selected "gboolean gtk_list_box_row_is_selected(GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_is_selected", "GtkListBoxRow*");
  return(C_to_Xen_gboolean(gtk_list_box_row_is_selected(Xen_to_C_GtkListBoxRow_(row))));
}

static Xen gxg_gtk_list_box_unselect_row(Xen box, Xen row)
{
  #define H_gtk_list_box_unselect_row "void gtk_list_box_unselect_row(GtkListBox* box, GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBox_(box), box, 1, "gtk_list_box_unselect_row", "GtkListBox*");
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 2, "gtk_list_box_unselect_row", "GtkListBoxRow*");
  gtk_list_box_unselect_row(Xen_to_C_GtkListBox_(box), Xen_to_C_GtkListBoxRow_(row));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_select_all(Xen box)
{
  #define H_gtk_list_box_select_all "void gtk_list_box_select_all(GtkListBox* box)"
  Xen_check_type(Xen_is_GtkListBox_(box), box, 1, "gtk_list_box_select_all", "GtkListBox*");
  gtk_list_box_select_all(Xen_to_C_GtkListBox_(box));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_unselect_all(Xen box)
{
  #define H_gtk_list_box_unselect_all "void gtk_list_box_unselect_all(GtkListBox* box)"
  Xen_check_type(Xen_is_GtkListBox_(box), box, 1, "gtk_list_box_unselect_all", "GtkListBox*");
  gtk_list_box_unselect_all(Xen_to_C_GtkListBox_(box));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_show_enter_location(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_show_enter_location "gboolean gtk_places_sidebar_get_show_enter_location(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_show_enter_location", "GtkPlacesSidebar*");
  return(C_to_Xen_gboolean(gtk_places_sidebar_get_show_enter_location(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_set_show_enter_location(Xen sidebar, Xen show_enter_location)
{
  #define H_gtk_places_sidebar_set_show_enter_location "void gtk_places_sidebar_set_show_enter_location(GtkPlacesSidebar* sidebar, \
gboolean show_enter_location)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_show_enter_location", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(show_enter_location), show_enter_location, 2, "gtk_places_sidebar_set_show_enter_location", "gboolean");
  gtk_places_sidebar_set_show_enter_location(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(show_enter_location));
  return(Xen_false);
}

static Xen gxg_gtk_switch_set_state(Xen sw, Xen state)
{
  #define H_gtk_switch_set_state "void gtk_switch_set_state(GtkSwitch* sw, gboolean state)"
  Xen_check_type(Xen_is_GtkSwitch_(sw), sw, 1, "gtk_switch_set_state", "GtkSwitch*");
  Xen_check_type(Xen_is_gboolean(state), state, 2, "gtk_switch_set_state", "gboolean");
  gtk_switch_set_state(Xen_to_C_GtkSwitch_(sw), Xen_to_C_gboolean(state));
  return(Xen_false);
}

static Xen gxg_gtk_switch_get_state(Xen sw)
{
  #define H_gtk_switch_get_state "gboolean gtk_switch_get_state(GtkSwitch* sw)"
  Xen_check_type(Xen_is_GtkSwitch_(sw), sw, 1, "gtk_switch_get_state", "GtkSwitch*");
  return(C_to_Xen_gboolean(gtk_switch_get_state(Xen_to_C_GtkSwitch_(sw))));
}

static Xen gxg_gdk_window_show_window_menu(Xen window, Xen event)
{
  #define H_gdk_window_show_window_menu "gboolean gdk_window_show_window_menu(GdkWindow* window, GdkEvent* event)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_show_window_menu", "GdkWindow*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gdk_window_show_window_menu", "GdkEvent*");
  return(C_to_Xen_gboolean(gdk_window_show_window_menu(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_widget_get_clip(Xen widget, Xen clip)
{
  #define H_gtk_widget_get_clip "void gtk_widget_get_clip(GtkWidget* widget, GtkAllocation* clip)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_clip", "GtkWidget*");
  Xen_check_type(Xen_is_GtkAllocation_(clip), clip, 2, "gtk_widget_get_clip", "GtkAllocation*");
  gtk_widget_get_clip(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkAllocation_(clip));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_get_device(Xen gesture)
{
  #define H_gtk_gesture_get_device "GdkDevice* gtk_gesture_get_device(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_device", "GtkGesture*");
  return(C_to_Xen_GdkDevice_(gtk_gesture_get_device(Xen_to_C_GtkGesture_(gesture))));
}

static Xen gxg_gtk_gesture_set_state(Xen gesture, Xen state)
{
  #define H_gtk_gesture_set_state "gboolean gtk_gesture_set_state(GtkGesture* gesture, GtkEventSequenceState state)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_set_state", "GtkGesture*");
  Xen_check_type(Xen_is_GtkEventSequenceState(state), state, 2, "gtk_gesture_set_state", "GtkEventSequenceState");
  return(C_to_Xen_gboolean(gtk_gesture_set_state(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GtkEventSequenceState(state))));
}

static Xen gxg_gtk_gesture_get_sequence_state(Xen gesture, Xen sequence)
{
  #define H_gtk_gesture_get_sequence_state "GtkEventSequenceState gtk_gesture_get_sequence_state(GtkGesture* gesture, \
GdkEventSequence* sequence)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_sequence_state", "GtkGesture*");
  Xen_check_type(Xen_is_GdkEventSequence_(sequence), sequence, 2, "gtk_gesture_get_sequence_state", "GdkEventSequence*");
  return(C_to_Xen_GtkEventSequenceState(gtk_gesture_get_sequence_state(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GdkEventSequence_(sequence))));
}

static Xen gxg_gtk_gesture_set_sequence_state(Xen gesture, Xen sequence, Xen state)
{
  #define H_gtk_gesture_set_sequence_state "gboolean gtk_gesture_set_sequence_state(GtkGesture* gesture, \
GdkEventSequence* sequence, GtkEventSequenceState state)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_set_sequence_state", "GtkGesture*");
  Xen_check_type(Xen_is_GdkEventSequence_(sequence), sequence, 2, "gtk_gesture_set_sequence_state", "GdkEventSequence*");
  Xen_check_type(Xen_is_GtkEventSequenceState(state), state, 3, "gtk_gesture_set_sequence_state", "GtkEventSequenceState");
  return(C_to_Xen_gboolean(gtk_gesture_set_sequence_state(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GdkEventSequence_(sequence), 
                                                          Xen_to_C_GtkEventSequenceState(state))));
}

static Xen gxg_gtk_gesture_get_sequences(Xen gesture)
{
  #define H_gtk_gesture_get_sequences "GList* gtk_gesture_get_sequences(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_sequences", "GtkGesture*");
  return(C_to_Xen_GList_(gtk_gesture_get_sequences(Xen_to_C_GtkGesture_(gesture))));
}

static Xen gxg_gtk_gesture_get_last_updated_sequence(Xen gesture)
{
  #define H_gtk_gesture_get_last_updated_sequence "GdkEventSequence* gtk_gesture_get_last_updated_sequence(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_last_updated_sequence", "GtkGesture*");
  return(C_to_Xen_GdkEventSequence_(gtk_gesture_get_last_updated_sequence(Xen_to_C_GtkGesture_(gesture))));
}

static Xen gxg_gtk_gesture_handles_sequence(Xen gesture, Xen sequence)
{
  #define H_gtk_gesture_handles_sequence "gboolean gtk_gesture_handles_sequence(GtkGesture* gesture, \
GdkEventSequence* sequence)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_handles_sequence", "GtkGesture*");
  Xen_check_type(Xen_is_GdkEventSequence_(sequence), sequence, 2, "gtk_gesture_handles_sequence", "GdkEventSequence*");
  return(C_to_Xen_gboolean(gtk_gesture_handles_sequence(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GdkEventSequence_(sequence))));
}

static Xen gxg_gtk_gesture_get_last_event(Xen gesture, Xen sequence)
{
  #define H_gtk_gesture_get_last_event "GdkEvent* gtk_gesture_get_last_event(GtkGesture* gesture, GdkEventSequence* sequence)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_last_event", "GtkGesture*");
  Xen_check_type(Xen_is_GdkEventSequence_(sequence), sequence, 2, "gtk_gesture_get_last_event", "GdkEventSequence*");
    return(C_to_Xen_GdkEvent_((GdkEvent*)gtk_gesture_get_last_event(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GdkEventSequence_(sequence))));
}

static Xen gxg_gtk_gesture_get_point(Xen gesture, Xen sequence, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_gesture_get_point "gboolean gtk_gesture_get_point(GtkGesture* gesture, GdkEventSequence* sequence, \
gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_point", "GtkGesture*");
  Xen_check_type(Xen_is_GdkEventSequence_(sequence), sequence, 2, "gtk_gesture_get_point", "GdkEventSequence*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_gesture_get_point(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GdkEventSequence_(sequence), 
                                                     &ref_x, &ref_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
   }
}

static Xen gxg_gtk_gesture_get_bounding_box(Xen gesture, Xen rect)
{
  #define H_gtk_gesture_get_bounding_box "gboolean gtk_gesture_get_bounding_box(GtkGesture* gesture, \
GdkRectangle* rect)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_bounding_box", "GtkGesture*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gtk_gesture_get_bounding_box", "GdkRectangle*");
  return(C_to_Xen_gboolean(gtk_gesture_get_bounding_box(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GdkRectangle_(rect))));
}

static Xen gxg_gtk_gesture_get_bounding_box_center(Xen gesture, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_gesture_get_bounding_box_center "gboolean gtk_gesture_get_bounding_box_center(GtkGesture* gesture, \
gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_bounding_box_center", "GtkGesture*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_gesture_get_bounding_box_center(Xen_to_C_GtkGesture_(gesture), &ref_x, &ref_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
   }
}

static Xen gxg_gtk_gesture_is_active(Xen gesture)
{
  #define H_gtk_gesture_is_active "gboolean gtk_gesture_is_active(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_is_active", "GtkGesture*");
  return(C_to_Xen_gboolean(gtk_gesture_is_active(Xen_to_C_GtkGesture_(gesture))));
}

static Xen gxg_gtk_gesture_is_recognized(Xen gesture)
{
  #define H_gtk_gesture_is_recognized "gboolean gtk_gesture_is_recognized(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_is_recognized", "GtkGesture*");
  return(C_to_Xen_gboolean(gtk_gesture_is_recognized(Xen_to_C_GtkGesture_(gesture))));
}

static Xen gxg_gtk_gesture_group(Xen group_gesture, Xen gesture)
{
  #define H_gtk_gesture_group "void gtk_gesture_group(GtkGesture* group_gesture, GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(group_gesture), group_gesture, 1, "gtk_gesture_group", "GtkGesture*");
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 2, "gtk_gesture_group", "GtkGesture*");
  gtk_gesture_group(Xen_to_C_GtkGesture_(group_gesture), Xen_to_C_GtkGesture_(gesture));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_ungroup(Xen gesture)
{
  #define H_gtk_gesture_ungroup "void gtk_gesture_ungroup(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_ungroup", "GtkGesture*");
  gtk_gesture_ungroup(Xen_to_C_GtkGesture_(gesture));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_get_group(Xen gesture)
{
  #define H_gtk_gesture_get_group "GList* gtk_gesture_get_group(GtkGesture* gesture)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_get_group", "GtkGesture*");
  return(C_to_Xen_GList_(gtk_gesture_get_group(Xen_to_C_GtkGesture_(gesture))));
}

static Xen gxg_gtk_gesture_is_grouped_with(Xen gesture, Xen other)
{
  #define H_gtk_gesture_is_grouped_with "gboolean gtk_gesture_is_grouped_with(GtkGesture* gesture, GtkGesture* other)"
  Xen_check_type(Xen_is_GtkGesture_(gesture), gesture, 1, "gtk_gesture_is_grouped_with", "GtkGesture*");
  Xen_check_type(Xen_is_GtkGesture_(other), other, 2, "gtk_gesture_is_grouped_with", "GtkGesture*");
  return(C_to_Xen_gboolean(gtk_gesture_is_grouped_with(Xen_to_C_GtkGesture_(gesture), Xen_to_C_GtkGesture_(other))));
}

static Xen gxg_gtk_gesture_drag_new(Xen widget)
{
  #define H_gtk_gesture_drag_new "GtkGesture* gtk_gesture_drag_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_drag_new", "GtkWidget*");
  return(C_to_Xen_GtkGesture_(gtk_gesture_drag_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_gesture_drag_get_start_point(Xen gesture, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_gesture_drag_get_start_point "gboolean gtk_gesture_drag_get_start_point(GtkGestureDrag* gesture, \
gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GtkGestureDrag_(gesture), gesture, 1, "gtk_gesture_drag_get_start_point", "GtkGestureDrag*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_gesture_drag_get_start_point(Xen_to_C_GtkGestureDrag_(gesture), &ref_x, &ref_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
   }
}

static Xen gxg_gtk_gesture_drag_get_offset(Xen gesture, Xen ignore_x, Xen ignore_y)
{
  #define H_gtk_gesture_drag_get_offset "gboolean gtk_gesture_drag_get_offset(GtkGestureDrag* gesture, \
gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GtkGestureDrag_(gesture), gesture, 1, "gtk_gesture_drag_get_offset", "GtkGestureDrag*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_gesture_drag_get_offset(Xen_to_C_GtkGestureDrag_(gesture), &ref_x, &ref_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
   }
}

static Xen gxg_gtk_gesture_long_press_new(Xen widget)
{
  #define H_gtk_gesture_long_press_new "GtkGesture* gtk_gesture_long_press_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_long_press_new", "GtkWidget*");
  return(C_to_Xen_GtkGesture_(gtk_gesture_long_press_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_gesture_pan_new(Xen widget, Xen orientation)
{
  #define H_gtk_gesture_pan_new "GtkGesture* gtk_gesture_pan_new(GtkWidget* widget, GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_pan_new", "GtkWidget*");
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 2, "gtk_gesture_pan_new", "GtkOrientation");
  return(C_to_Xen_GtkGesture_(gtk_gesture_pan_new(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkOrientation(orientation))));
}

static Xen gxg_gtk_gesture_pan_get_orientation(Xen gesture)
{
  #define H_gtk_gesture_pan_get_orientation "GtkOrientation gtk_gesture_pan_get_orientation(GtkGesturePan* gesture)"
  Xen_check_type(Xen_is_GtkGesturePan_(gesture), gesture, 1, "gtk_gesture_pan_get_orientation", "GtkGesturePan*");
  return(C_to_Xen_GtkOrientation(gtk_gesture_pan_get_orientation(Xen_to_C_GtkGesturePan_(gesture))));
}

static Xen gxg_gtk_gesture_pan_set_orientation(Xen gesture, Xen orientation)
{
  #define H_gtk_gesture_pan_set_orientation "void gtk_gesture_pan_set_orientation(GtkGesturePan* gesture, \
GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkGesturePan_(gesture), gesture, 1, "gtk_gesture_pan_set_orientation", "GtkGesturePan*");
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 2, "gtk_gesture_pan_set_orientation", "GtkOrientation");
  gtk_gesture_pan_set_orientation(Xen_to_C_GtkGesturePan_(gesture), Xen_to_C_GtkOrientation(orientation));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_multi_press_new(Xen widget)
{
  #define H_gtk_gesture_multi_press_new "GtkGesture* gtk_gesture_multi_press_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_multi_press_new", "GtkWidget*");
  return(C_to_Xen_GtkGesture_(gtk_gesture_multi_press_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_gesture_multi_press_set_area(Xen gesture, Xen rect)
{
  #define H_gtk_gesture_multi_press_set_area "void gtk_gesture_multi_press_set_area(GtkGestureMultiPress* gesture, \
GdkRectangle* rect)"
  Xen_check_type(Xen_is_GtkGestureMultiPress_(gesture), gesture, 1, "gtk_gesture_multi_press_set_area", "GtkGestureMultiPress*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gtk_gesture_multi_press_set_area", "GdkRectangle*");
  gtk_gesture_multi_press_set_area(Xen_to_C_GtkGestureMultiPress_(gesture), Xen_to_C_GdkRectangle_(rect));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_multi_press_get_area(Xen gesture, Xen rect)
{
  #define H_gtk_gesture_multi_press_get_area "gboolean gtk_gesture_multi_press_get_area(GtkGestureMultiPress* gesture, \
GdkRectangle* rect)"
  Xen_check_type(Xen_is_GtkGestureMultiPress_(gesture), gesture, 1, "gtk_gesture_multi_press_get_area", "GtkGestureMultiPress*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 2, "gtk_gesture_multi_press_get_area", "GdkRectangle*");
  return(C_to_Xen_gboolean(gtk_gesture_multi_press_get_area(Xen_to_C_GtkGestureMultiPress_(gesture), Xen_to_C_GdkRectangle_(rect))));
}

static Xen gxg_gtk_gesture_rotate_new(Xen widget)
{
  #define H_gtk_gesture_rotate_new "GtkGesture* gtk_gesture_rotate_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_rotate_new", "GtkWidget*");
  return(C_to_Xen_GtkGesture_(gtk_gesture_rotate_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_gesture_rotate_get_angle_delta(Xen gesture)
{
  #define H_gtk_gesture_rotate_get_angle_delta "gdouble gtk_gesture_rotate_get_angle_delta(GtkGestureRotate* gesture)"
  Xen_check_type(Xen_is_GtkGestureRotate_(gesture), gesture, 1, "gtk_gesture_rotate_get_angle_delta", "GtkGestureRotate*");
  return(C_to_Xen_gdouble(gtk_gesture_rotate_get_angle_delta(Xen_to_C_GtkGestureRotate_(gesture))));
}

static Xen gxg_gtk_gesture_single_get_touch_only(Xen gesture)
{
  #define H_gtk_gesture_single_get_touch_only "gboolean gtk_gesture_single_get_touch_only(GtkGestureSingle* gesture)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_get_touch_only", "GtkGestureSingle*");
  return(C_to_Xen_gboolean(gtk_gesture_single_get_touch_only(Xen_to_C_GtkGestureSingle_(gesture))));
}

static Xen gxg_gtk_gesture_single_set_touch_only(Xen gesture, Xen touch_only)
{
  #define H_gtk_gesture_single_set_touch_only "void gtk_gesture_single_set_touch_only(GtkGestureSingle* gesture, \
gboolean touch_only)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_set_touch_only", "GtkGestureSingle*");
  Xen_check_type(Xen_is_gboolean(touch_only), touch_only, 2, "gtk_gesture_single_set_touch_only", "gboolean");
  gtk_gesture_single_set_touch_only(Xen_to_C_GtkGestureSingle_(gesture), Xen_to_C_gboolean(touch_only));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_single_get_exclusive(Xen gesture)
{
  #define H_gtk_gesture_single_get_exclusive "gboolean gtk_gesture_single_get_exclusive(GtkGestureSingle* gesture)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_get_exclusive", "GtkGestureSingle*");
  return(C_to_Xen_gboolean(gtk_gesture_single_get_exclusive(Xen_to_C_GtkGestureSingle_(gesture))));
}

static Xen gxg_gtk_gesture_single_set_exclusive(Xen gesture, Xen exclusive)
{
  #define H_gtk_gesture_single_set_exclusive "void gtk_gesture_single_set_exclusive(GtkGestureSingle* gesture, \
gboolean exclusive)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_set_exclusive", "GtkGestureSingle*");
  Xen_check_type(Xen_is_gboolean(exclusive), exclusive, 2, "gtk_gesture_single_set_exclusive", "gboolean");
  gtk_gesture_single_set_exclusive(Xen_to_C_GtkGestureSingle_(gesture), Xen_to_C_gboolean(exclusive));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_single_get_button(Xen gesture)
{
  #define H_gtk_gesture_single_get_button "guint gtk_gesture_single_get_button(GtkGestureSingle* gesture)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_get_button", "GtkGestureSingle*");
  return(C_to_Xen_guint(gtk_gesture_single_get_button(Xen_to_C_GtkGestureSingle_(gesture))));
}

static Xen gxg_gtk_gesture_single_set_button(Xen gesture, Xen button)
{
  #define H_gtk_gesture_single_set_button "void gtk_gesture_single_set_button(GtkGestureSingle* gesture, \
guint button)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_set_button", "GtkGestureSingle*");
  Xen_check_type(Xen_is_guint(button), button, 2, "gtk_gesture_single_set_button", "guint");
  gtk_gesture_single_set_button(Xen_to_C_GtkGestureSingle_(gesture), Xen_to_C_guint(button));
  return(Xen_false);
}

static Xen gxg_gtk_gesture_single_get_current_button(Xen gesture)
{
  #define H_gtk_gesture_single_get_current_button "guint gtk_gesture_single_get_current_button(GtkGestureSingle* gesture)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_get_current_button", "GtkGestureSingle*");
  return(C_to_Xen_guint(gtk_gesture_single_get_current_button(Xen_to_C_GtkGestureSingle_(gesture))));
}

static Xen gxg_gtk_gesture_single_get_current_sequence(Xen gesture)
{
  #define H_gtk_gesture_single_get_current_sequence "GdkEventSequence* gtk_gesture_single_get_current_sequence(GtkGestureSingle* gesture)"
  Xen_check_type(Xen_is_GtkGestureSingle_(gesture), gesture, 1, "gtk_gesture_single_get_current_sequence", "GtkGestureSingle*");
  return(C_to_Xen_GdkEventSequence_(gtk_gesture_single_get_current_sequence(Xen_to_C_GtkGestureSingle_(gesture))));
}

static Xen gxg_gtk_gesture_swipe_new(Xen widget)
{
  #define H_gtk_gesture_swipe_new "GtkGesture* gtk_gesture_swipe_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_swipe_new", "GtkWidget*");
  return(C_to_Xen_GtkGesture_(gtk_gesture_swipe_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_gesture_swipe_get_velocity(Xen gesture, Xen ignore_velocity_x, Xen ignore_velocity_y)
{
  #define H_gtk_gesture_swipe_get_velocity "gboolean gtk_gesture_swipe_get_velocity(GtkGestureSwipe* gesture, \
gdouble* [velocity_x], gdouble* [velocity_y])"
  gdouble ref_velocity_x;
  gdouble ref_velocity_y;
  Xen_check_type(Xen_is_GtkGestureSwipe_(gesture), gesture, 1, "gtk_gesture_swipe_get_velocity", "GtkGestureSwipe*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_gesture_swipe_get_velocity(Xen_to_C_GtkGestureSwipe_(gesture), &ref_velocity_x, &ref_velocity_y));
    return(Xen_list_3(result, C_to_Xen_gdouble(ref_velocity_x), C_to_Xen_gdouble(ref_velocity_y)));
   }
}

static Xen gxg_gtk_gesture_zoom_new(Xen widget)
{
  #define H_gtk_gesture_zoom_new "GtkGesture* gtk_gesture_zoom_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_gesture_zoom_new", "GtkWidget*");
  return(C_to_Xen_GtkGesture_(gtk_gesture_zoom_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_gesture_zoom_get_scale_delta(Xen gesture)
{
  #define H_gtk_gesture_zoom_get_scale_delta "gdouble gtk_gesture_zoom_get_scale_delta(GtkGestureZoom* gesture)"
  Xen_check_type(Xen_is_GtkGestureZoom_(gesture), gesture, 1, "gtk_gesture_zoom_get_scale_delta", "GtkGestureZoom*");
  return(C_to_Xen_gdouble(gtk_gesture_zoom_get_scale_delta(Xen_to_C_GtkGestureZoom_(gesture))));
}

static Xen gxg_gtk_event_controller_get_widget(Xen controller)
{
  #define H_gtk_event_controller_get_widget "GtkWidget* gtk_event_controller_get_widget(GtkEventController* controller)"
  Xen_check_type(Xen_is_GtkEventController_(controller), controller, 1, "gtk_event_controller_get_widget", "GtkEventController*");
  return(C_to_Xen_GtkWidget_(gtk_event_controller_get_widget(Xen_to_C_GtkEventController_(controller))));
}

static Xen gxg_gtk_event_controller_handle_event(Xen controller, Xen event)
{
  #define H_gtk_event_controller_handle_event "gboolean gtk_event_controller_handle_event(GtkEventController* controller, \
GdkEvent* event)"
  Xen_check_type(Xen_is_GtkEventController_(controller), controller, 1, "gtk_event_controller_handle_event", "GtkEventController*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_event_controller_handle_event", "GdkEvent*");
  return(C_to_Xen_gboolean(gtk_event_controller_handle_event(Xen_to_C_GtkEventController_(controller), Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_event_controller_reset(Xen controller)
{
  #define H_gtk_event_controller_reset "void gtk_event_controller_reset(GtkEventController* controller)"
  Xen_check_type(Xen_is_GtkEventController_(controller), controller, 1, "gtk_event_controller_reset", "GtkEventController*");
  gtk_event_controller_reset(Xen_to_C_GtkEventController_(controller));
  return(Xen_false);
}

static Xen gxg_gtk_event_controller_get_propagation_phase(Xen controller)
{
  #define H_gtk_event_controller_get_propagation_phase "GtkPropagationPhase gtk_event_controller_get_propagation_phase(GtkEventController* controller)"
  Xen_check_type(Xen_is_GtkEventController_(controller), controller, 1, "gtk_event_controller_get_propagation_phase", "GtkEventController*");
  return(C_to_Xen_GtkPropagationPhase(gtk_event_controller_get_propagation_phase(Xen_to_C_GtkEventController_(controller))));
}

static Xen gxg_gtk_event_controller_set_propagation_phase(Xen controller, Xen phase)
{
  #define H_gtk_event_controller_set_propagation_phase "void gtk_event_controller_set_propagation_phase(GtkEventController* controller, \
GtkPropagationPhase phase)"
  Xen_check_type(Xen_is_GtkEventController_(controller), controller, 1, "gtk_event_controller_set_propagation_phase", "GtkEventController*");
  Xen_check_type(Xen_is_GtkPropagationPhase(phase), phase, 2, "gtk_event_controller_set_propagation_phase", "GtkPropagationPhase");
  gtk_event_controller_set_propagation_phase(Xen_to_C_GtkEventController_(controller), Xen_to_C_GtkPropagationPhase(phase));
  return(Xen_false);
}

static Xen gxg_gtk_icon_theme_add_resource_path(Xen icon_theme, Xen path)
{
  #define H_gtk_icon_theme_add_resource_path "void gtk_icon_theme_add_resource_path(GtkIconTheme* icon_theme, \
gchar* path)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_add_resource_path", "GtkIconTheme*");
  Xen_check_type(Xen_is_gchar_(path), path, 2, "gtk_icon_theme_add_resource_path", "gchar*");
  gtk_icon_theme_add_resource_path(Xen_to_C_GtkIconTheme_(icon_theme), (const gchar*)Xen_to_C_gchar_(path));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_row_set_activatable(Xen row, Xen activatable)
{
  #define H_gtk_list_box_row_set_activatable "void gtk_list_box_row_set_activatable(GtkListBoxRow* row, \
gboolean activatable)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_set_activatable", "GtkListBoxRow*");
  Xen_check_type(Xen_is_gboolean(activatable), activatable, 2, "gtk_list_box_row_set_activatable", "gboolean");
  gtk_list_box_row_set_activatable(Xen_to_C_GtkListBoxRow_(row), Xen_to_C_gboolean(activatable));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_row_get_activatable(Xen row)
{
  #define H_gtk_list_box_row_get_activatable "gboolean gtk_list_box_row_get_activatable(GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_get_activatable", "GtkListBoxRow*");
  return(C_to_Xen_gboolean(gtk_list_box_row_get_activatable(Xen_to_C_GtkListBoxRow_(row))));
}

static Xen gxg_gtk_list_box_row_set_selectable(Xen row, Xen selectable)
{
  #define H_gtk_list_box_row_set_selectable "void gtk_list_box_row_set_selectable(GtkListBoxRow* row, \
gboolean selectable)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_set_selectable", "GtkListBoxRow*");
  Xen_check_type(Xen_is_gboolean(selectable), selectable, 2, "gtk_list_box_row_set_selectable", "gboolean");
  gtk_list_box_row_set_selectable(Xen_to_C_GtkListBoxRow_(row), Xen_to_C_gboolean(selectable));
  return(Xen_false);
}

static Xen gxg_gtk_list_box_row_get_selectable(Xen row)
{
  #define H_gtk_list_box_row_get_selectable "gboolean gtk_list_box_row_get_selectable(GtkListBoxRow* row)"
  Xen_check_type(Xen_is_GtkListBoxRow_(row), row, 1, "gtk_list_box_row_get_selectable", "GtkListBoxRow*");
  return(C_to_Xen_gboolean(gtk_list_box_row_get_selectable(Xen_to_C_GtkListBoxRow_(row))));
}

static Xen gxg_gtk_widget_path_iter_get_state(Xen path, Xen pos)
{
  #define H_gtk_widget_path_iter_get_state "GtkStateFlags gtk_widget_path_iter_get_state(GtkWidgetPath* path, \
gint pos)"
  Xen_check_type(Xen_is_GtkWidgetPath_(path), path, 1, "gtk_widget_path_iter_get_state", "GtkWidgetPath*");
  Xen_check_type(Xen_is_gint(pos), pos, 2, "gtk_widget_path_iter_get_state", "gint");
  return(C_to_Xen_GtkStateFlags(gtk_widget_path_iter_get_state(Xen_to_C_GtkWidgetPath_(path), Xen_to_C_gint(pos))));
}

static Xen gxg_gtk_widget_path_iter_set_state(Xen path, Xen pos, Xen state)
{
  #define H_gtk_widget_path_iter_set_state "void gtk_widget_path_iter_set_state(GtkWidgetPath* path, \
gint pos, GtkStateFlags state)"
  Xen_check_type(Xen_is_GtkWidgetPath_(path), path, 1, "gtk_widget_path_iter_set_state", "GtkWidgetPath*");
  Xen_check_type(Xen_is_gint(pos), pos, 2, "gtk_widget_path_iter_set_state", "gint");
  Xen_check_type(Xen_is_GtkStateFlags(state), state, 3, "gtk_widget_path_iter_set_state", "GtkStateFlags");
  gtk_widget_path_iter_set_state(Xen_to_C_GtkWidgetPath_(path), Xen_to_C_gint(pos), Xen_to_C_GtkStateFlags(state));
  return(Xen_false);
}

#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static Xen gxg_gdk_cairo_draw_from_gl(Xen arglist)
{
  #define H_gdk_cairo_draw_from_gl "void gdk_cairo_draw_from_gl(cairo_t* cr, GdkWindow* window, int source, \
int source_type, int buffer_scale, int x, int y, int width, int height)"
  Xen cr, window, source, source_type, buffer_scale, x, y, width, height;
  cr = Xen_list_ref(arglist, 0);
  window = Xen_list_ref(arglist, 1);
  source = Xen_list_ref(arglist, 2);
  source_type = Xen_list_ref(arglist, 3);
  buffer_scale = Xen_list_ref(arglist, 4);
  x = Xen_list_ref(arglist, 5);
  y = Xen_list_ref(arglist, 6);
  width = Xen_list_ref(arglist, 7);
  height = Xen_list_ref(arglist, 8);
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "gdk_cairo_draw_from_gl", "cairo_t*");
  Xen_check_type(Xen_is_GdkWindow_(window), window, 2, "gdk_cairo_draw_from_gl", "GdkWindow*");
  Xen_check_type(Xen_is_int(source), source, 3, "gdk_cairo_draw_from_gl", "int");
  Xen_check_type(Xen_is_int(source_type), source_type, 4, "gdk_cairo_draw_from_gl", "int");
  Xen_check_type(Xen_is_int(buffer_scale), buffer_scale, 5, "gdk_cairo_draw_from_gl", "int");
  Xen_check_type(Xen_is_int(x), x, 6, "gdk_cairo_draw_from_gl", "int");
  Xen_check_type(Xen_is_int(y), y, 7, "gdk_cairo_draw_from_gl", "int");
  Xen_check_type(Xen_is_int(width), width, 8, "gdk_cairo_draw_from_gl", "int");
  Xen_check_type(Xen_is_int(height), height, 9, "gdk_cairo_draw_from_gl", "int");
  gdk_cairo_draw_from_gl(Xen_to_C_cairo_t_(cr), Xen_to_C_GdkWindow_(window), Xen_to_C_int(source), Xen_to_C_int(source_type), 
                         Xen_to_C_int(buffer_scale), Xen_to_C_int(x), Xen_to_C_int(y), Xen_to_C_int(width), Xen_to_C_int(height));
  return(Xen_false);
}

static Xen gxg_gtk_label_set_xalign(Xen label, Xen xalign)
{
  #define H_gtk_label_set_xalign "void gtk_label_set_xalign(GtkLabel* label, gfloat xalign)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_xalign", "GtkLabel*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_label_set_xalign", "gfloat");
  gtk_label_set_xalign(Xen_to_C_GtkLabel_(label), Xen_to_C_gfloat(xalign));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_xalign(Xen label)
{
  #define H_gtk_label_get_xalign "gfloat gtk_label_get_xalign(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_xalign", "GtkLabel*");
  return(C_to_Xen_gfloat(gtk_label_get_xalign(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_label_set_yalign(Xen label, Xen xalign)
{
  #define H_gtk_label_set_yalign "void gtk_label_set_yalign(GtkLabel* label, gfloat xalign)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_set_yalign", "GtkLabel*");
  Xen_check_type(Xen_is_gfloat(xalign), xalign, 2, "gtk_label_set_yalign", "gfloat");
  gtk_label_set_yalign(Xen_to_C_GtkLabel_(label), Xen_to_C_gfloat(xalign));
  return(Xen_false);
}

static Xen gxg_gtk_label_get_yalign(Xen label)
{
  #define H_gtk_label_get_yalign "gfloat gtk_label_get_yalign(GtkLabel* label)"
  Xen_check_type(Xen_is_GtkLabel_(label), label, 1, "gtk_label_get_yalign", "GtkLabel*");
  return(C_to_Xen_gfloat(gtk_label_get_yalign(Xen_to_C_GtkLabel_(label))));
}

static Xen gxg_gtk_paned_set_wide_handle(Xen paned, Xen wide)
{
  #define H_gtk_paned_set_wide_handle "void gtk_paned_set_wide_handle(GtkPaned* paned, gboolean wide)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_set_wide_handle", "GtkPaned*");
  Xen_check_type(Xen_is_gboolean(wide), wide, 2, "gtk_paned_set_wide_handle", "gboolean");
  gtk_paned_set_wide_handle(Xen_to_C_GtkPaned_(paned), Xen_to_C_gboolean(wide));
  return(Xen_false);
}

static Xen gxg_gtk_paned_get_wide_handle(Xen paned)
{
  #define H_gtk_paned_get_wide_handle "gboolean gtk_paned_get_wide_handle(GtkPaned* paned)"
  Xen_check_type(Xen_is_GtkPaned_(paned), paned, 1, "gtk_paned_get_wide_handle", "GtkPaned*");
  return(C_to_Xen_gboolean(gtk_paned_get_wide_handle(Xen_to_C_GtkPaned_(paned))));
}

static Xen gxg_gtk_scrolled_window_set_overlay_scrolling(Xen scrolled_window, Xen overlay_scrolling)
{
  #define H_gtk_scrolled_window_set_overlay_scrolling "void gtk_scrolled_window_set_overlay_scrolling(GtkScrolledWindow* scrolled_window, \
gboolean overlay_scrolling)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_overlay_scrolling", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gboolean(overlay_scrolling), overlay_scrolling, 2, "gtk_scrolled_window_set_overlay_scrolling", "gboolean");
  gtk_scrolled_window_set_overlay_scrolling(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gboolean(overlay_scrolling));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_overlay_scrolling(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_overlay_scrolling "gboolean gtk_scrolled_window_get_overlay_scrolling(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_overlay_scrolling", "GtkScrolledWindow*");
  return(C_to_Xen_gboolean(gtk_scrolled_window_get_overlay_scrolling(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_text_view_set_monospace(Xen text_view, Xen monospace)
{
  #define H_gtk_text_view_set_monospace "void gtk_text_view_set_monospace(GtkTextView* text_view, gboolean monospace)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_monospace", "GtkTextView*");
  Xen_check_type(Xen_is_gboolean(monospace), monospace, 2, "gtk_text_view_set_monospace", "gboolean");
  gtk_text_view_set_monospace(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gboolean(monospace));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_monospace(Xen text_view)
{
  #define H_gtk_text_view_get_monospace "gboolean gtk_text_view_get_monospace(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_monospace", "GtkTextView*");
  return(C_to_Xen_gboolean(gtk_text_view_get_monospace(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_window_get_titlebar(Xen window)
{
  #define H_gtk_window_get_titlebar "GtkWidget* gtk_window_get_titlebar(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_titlebar", "GtkWindow*");
  return(C_to_Xen_GtkWidget_(gtk_window_get_titlebar(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_gl_area_new(void)
{
  #define H_gtk_gl_area_new "GtkWidget* gtk_gl_area_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_gl_area_new()));
}

static Xen gxg_gtk_gl_area_get_has_alpha(Xen area)
{
  #define H_gtk_gl_area_get_has_alpha "gboolean gtk_gl_area_get_has_alpha(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_has_alpha", "GtkGLArea*");
  return(C_to_Xen_gboolean(gtk_gl_area_get_has_alpha(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gtk_gl_area_set_has_alpha(Xen area, Xen has_alpha)
{
  #define H_gtk_gl_area_set_has_alpha "void gtk_gl_area_set_has_alpha(GtkGLArea* area, gboolean has_alpha)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_set_has_alpha", "GtkGLArea*");
  Xen_check_type(Xen_is_gboolean(has_alpha), has_alpha, 2, "gtk_gl_area_set_has_alpha", "gboolean");
  gtk_gl_area_set_has_alpha(Xen_to_C_GtkGLArea_(area), Xen_to_C_gboolean(has_alpha));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_get_has_depth_buffer(Xen area)
{
  #define H_gtk_gl_area_get_has_depth_buffer "gboolean gtk_gl_area_get_has_depth_buffer(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_has_depth_buffer", "GtkGLArea*");
  return(C_to_Xen_gboolean(gtk_gl_area_get_has_depth_buffer(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gtk_gl_area_set_has_depth_buffer(Xen area, Xen has_depth_buffer)
{
  #define H_gtk_gl_area_set_has_depth_buffer "void gtk_gl_area_set_has_depth_buffer(GtkGLArea* area, \
gboolean has_depth_buffer)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_set_has_depth_buffer", "GtkGLArea*");
  Xen_check_type(Xen_is_gboolean(has_depth_buffer), has_depth_buffer, 2, "gtk_gl_area_set_has_depth_buffer", "gboolean");
  gtk_gl_area_set_has_depth_buffer(Xen_to_C_GtkGLArea_(area), Xen_to_C_gboolean(has_depth_buffer));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_get_context(Xen area)
{
  #define H_gtk_gl_area_get_context "GdkGLContext* gtk_gl_area_get_context(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_context", "GtkGLArea*");
  return(C_to_Xen_GdkGLContext_(gtk_gl_area_get_context(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gtk_gl_area_make_current(Xen area)
{
  #define H_gtk_gl_area_make_current "void gtk_gl_area_make_current(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_make_current", "GtkGLArea*");
  gtk_gl_area_make_current(Xen_to_C_GtkGLArea_(area));
  return(Xen_false);
}

static Xen gxg_gtk_render_check(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_check "void gtk_render_check(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_check", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_check", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_check", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_check", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_check", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_check", "gdouble");
  gtk_render_check(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), Xen_to_C_gdouble(width), 
                   Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_option(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_option "void gtk_render_option(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_option", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_option", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_option", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_option", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_option", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_option", "gdouble");
  gtk_render_option(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                    Xen_to_C_gdouble(width), Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_arrow(Xen context, Xen cr, Xen angle, Xen x, Xen y, Xen size)
{
  #define H_gtk_render_arrow "void gtk_render_arrow(GtkStyleContext* context, cairo_t* cr, gdouble angle, \
gdouble x, gdouble y, gdouble size)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_arrow", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_arrow", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(angle), angle, 3, "gtk_render_arrow", "gdouble");
  Xen_check_type(Xen_is_gdouble(x), x, 4, "gtk_render_arrow", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 5, "gtk_render_arrow", "gdouble");
  Xen_check_type(Xen_is_gdouble(size), size, 6, "gtk_render_arrow", "gdouble");
  gtk_render_arrow(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(angle), Xen_to_C_gdouble(x), 
                   Xen_to_C_gdouble(y), Xen_to_C_gdouble(size));
  return(Xen_false);
}

static Xen gxg_gtk_render_background(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_background "void gtk_render_background(GtkStyleContext* context, cairo_t* cr, \
gdouble x, gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_background", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_background", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_background", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_background", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_background", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_background", "gdouble");
  gtk_render_background(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                        Xen_to_C_gdouble(width), Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_frame(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_frame "void gtk_render_frame(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_frame", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_frame", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_frame", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_frame", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_frame", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_frame", "gdouble");
  gtk_render_frame(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), Xen_to_C_gdouble(width), 
                   Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_expander(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_expander "void gtk_render_expander(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_expander", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_expander", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_expander", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_expander", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_expander", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_expander", "gdouble");
  gtk_render_expander(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                      Xen_to_C_gdouble(width), Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_focus(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_focus "void gtk_render_focus(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_focus", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_focus", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_focus", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_focus", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_focus", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_focus", "gdouble");
  gtk_render_focus(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), Xen_to_C_gdouble(width), 
                   Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_layout(Xen context, Xen cr, Xen x, Xen y, Xen layout)
{
  #define H_gtk_render_layout "void gtk_render_layout(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, PangoLayout* layout)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_layout", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_layout", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_layout", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_layout", "gdouble");
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 5, "gtk_render_layout", "PangoLayout*");
  gtk_render_layout(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                    Xen_to_C_PangoLayout_(layout));
  return(Xen_false);
}

static Xen gxg_gtk_render_line(Xen context, Xen cr, Xen x0, Xen y0, Xen x1, Xen y1)
{
  #define H_gtk_render_line "void gtk_render_line(GtkStyleContext* context, cairo_t* cr, gdouble x0, \
gdouble y0, gdouble x1, gdouble y1)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_line", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_line", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x0), x0, 3, "gtk_render_line", "gdouble");
  Xen_check_type(Xen_is_gdouble(y0), y0, 4, "gtk_render_line", "gdouble");
  Xen_check_type(Xen_is_gdouble(x1), x1, 5, "gtk_render_line", "gdouble");
  Xen_check_type(Xen_is_gdouble(y1), y1, 6, "gtk_render_line", "gdouble");
  gtk_render_line(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x0), Xen_to_C_gdouble(y0), 
                  Xen_to_C_gdouble(x1), Xen_to_C_gdouble(y1));
  return(Xen_false);
}

static Xen gxg_gtk_render_slider(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height, Xen orientation)
{
  #define H_gtk_render_slider "void gtk_render_slider(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height, GtkOrientation orientation)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_slider", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_slider", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_slider", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_slider", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_slider", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_slider", "gdouble");
  Xen_check_type(Xen_is_GtkOrientation(orientation), orientation, 7, "gtk_render_slider", "GtkOrientation");
  gtk_render_slider(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                    Xen_to_C_gdouble(width), Xen_to_C_gdouble(height), Xen_to_C_GtkOrientation(orientation));
  return(Xen_false);
}

static Xen gxg_gtk_render_frame_gap(Xen arglist)
{
  #define H_gtk_render_frame_gap "void gtk_render_frame_gap(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height, GtkPositionType gap_side, gdouble xy0_gap, gdouble xy1_gap)"
  Xen context, cr, x, y, width, height, gap_side, xy0_gap, xy1_gap;
  context = Xen_list_ref(arglist, 0);
  cr = Xen_list_ref(arglist, 1);
  x = Xen_list_ref(arglist, 2);
  y = Xen_list_ref(arglist, 3);
  width = Xen_list_ref(arglist, 4);
  height = Xen_list_ref(arglist, 5);
  gap_side = Xen_list_ref(arglist, 6);
  xy0_gap = Xen_list_ref(arglist, 7);
  xy1_gap = Xen_list_ref(arglist, 8);
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_frame_gap", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_frame_gap", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_frame_gap", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_frame_gap", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_frame_gap", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_frame_gap", "gdouble");
  Xen_check_type(Xen_is_GtkPositionType(gap_side), gap_side, 7, "gtk_render_frame_gap", "GtkPositionType");
  Xen_check_type(Xen_is_gdouble(xy0_gap), xy0_gap, 8, "gtk_render_frame_gap", "gdouble");
  Xen_check_type(Xen_is_gdouble(xy1_gap), xy1_gap, 9, "gtk_render_frame_gap", "gdouble");
  gtk_render_frame_gap(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                       Xen_to_C_gdouble(width), Xen_to_C_gdouble(height), Xen_to_C_GtkPositionType(gap_side), Xen_to_C_gdouble(xy0_gap), 
                       Xen_to_C_gdouble(xy1_gap));
  return(Xen_false);
}

static Xen gxg_gtk_render_handle(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_handle "void gtk_render_handle(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_handle", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_handle", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_handle", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_handle", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_handle", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_handle", "gdouble");
  gtk_render_handle(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                    Xen_to_C_gdouble(width), Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_activity(Xen context, Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_gtk_render_activity "void gtk_render_activity(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_activity", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_activity", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_activity", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_activity", "gdouble");
  Xen_check_type(Xen_is_gdouble(width), width, 5, "gtk_render_activity", "gdouble");
  Xen_check_type(Xen_is_gdouble(height), height, 6, "gtk_render_activity", "gdouble");
  gtk_render_activity(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                      Xen_to_C_gdouble(width), Xen_to_C_gdouble(height));
  return(Xen_false);
}

static Xen gxg_gtk_render_icon_surface(Xen context, Xen cr, Xen surface, Xen x, Xen y)
{
  #define H_gtk_render_icon_surface "void gtk_render_icon_surface(GtkStyleContext* context, cairo_t* cr, \
cairo_surface_t* surface, gdouble x, gdouble y)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_icon_surface", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_icon_surface", "cairo_t*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 3, "gtk_render_icon_surface", "cairo_surface_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 4, "gtk_render_icon_surface", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 5, "gtk_render_icon_surface", "gdouble");
  gtk_render_icon_surface(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_surface_t_(surface), 
                          Xen_to_C_gdouble(x), Xen_to_C_gdouble(y));
  return(Xen_false);
}

static Xen gxg_gdk_gl_context_get_window(Xen context)
{
  #define H_gdk_gl_context_get_window "GdkWindow* gdk_gl_context_get_window(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_window", "GdkGLContext*");
  return(C_to_Xen_GdkWindow_(gdk_gl_context_get_window(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gdk_gl_context_make_current(Xen context)
{
  #define H_gdk_gl_context_make_current "void gdk_gl_context_make_current(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_make_current", "GdkGLContext*");
  gdk_gl_context_make_current(Xen_to_C_GdkGLContext_(context));
  return(Xen_false);
}

static Xen gxg_gdk_gl_context_get_current(void)
{
  #define H_gdk_gl_context_get_current "GdkGLContext* gdk_gl_context_get_current( void)"
  return(C_to_Xen_GdkGLContext_(gdk_gl_context_get_current()));
}

static Xen gxg_gdk_gl_context_clear_current(void)
{
  #define H_gdk_gl_context_clear_current "void gdk_gl_context_clear_current( void)"
  gdk_gl_context_clear_current();
  return(Xen_false);
}

static Xen gxg_gtk_stack_set_hhomogeneous(Xen stack, Xen hhomogeneous)
{
  #define H_gtk_stack_set_hhomogeneous "void gtk_stack_set_hhomogeneous(GtkStack* stack, gboolean hhomogeneous)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_hhomogeneous", "GtkStack*");
  Xen_check_type(Xen_is_gboolean(hhomogeneous), hhomogeneous, 2, "gtk_stack_set_hhomogeneous", "gboolean");
  gtk_stack_set_hhomogeneous(Xen_to_C_GtkStack_(stack), Xen_to_C_gboolean(hhomogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_hhomogeneous(Xen stack)
{
  #define H_gtk_stack_get_hhomogeneous "gboolean gtk_stack_get_hhomogeneous(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_hhomogeneous", "GtkStack*");
  return(C_to_Xen_gboolean(gtk_stack_get_hhomogeneous(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_stack_set_vhomogeneous(Xen stack, Xen vhomogeneous)
{
  #define H_gtk_stack_set_vhomogeneous "void gtk_stack_set_vhomogeneous(GtkStack* stack, gboolean vhomogeneous)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_vhomogeneous", "GtkStack*");
  Xen_check_type(Xen_is_gboolean(vhomogeneous), vhomogeneous, 2, "gtk_stack_set_vhomogeneous", "gboolean");
  gtk_stack_set_vhomogeneous(Xen_to_C_GtkStack_(stack), Xen_to_C_gboolean(vhomogeneous));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_vhomogeneous(Xen stack)
{
  #define H_gtk_stack_get_vhomogeneous "gboolean gtk_stack_get_vhomogeneous(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_vhomogeneous", "GtkStack*");
  return(C_to_Xen_gboolean(gtk_stack_get_vhomogeneous(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gdk_gl_context_get_display(Xen context)
{
  #define H_gdk_gl_context_get_display "GdkDisplay* gdk_gl_context_get_display(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_display", "GdkGLContext*");
  return(C_to_Xen_GdkDisplay_(gdk_gl_context_get_display(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gtk_gl_area_get_has_stencil_buffer(Xen area)
{
  #define H_gtk_gl_area_get_has_stencil_buffer "gboolean gtk_gl_area_get_has_stencil_buffer(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_has_stencil_buffer", "GtkGLArea*");
  return(C_to_Xen_gboolean(gtk_gl_area_get_has_stencil_buffer(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gtk_gl_area_set_has_stencil_buffer(Xen area, Xen has_stencil_buffer)
{
  #define H_gtk_gl_area_set_has_stencil_buffer "void gtk_gl_area_set_has_stencil_buffer(GtkGLArea* area, \
gboolean has_stencil_buffer)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_set_has_stencil_buffer", "GtkGLArea*");
  Xen_check_type(Xen_is_gboolean(has_stencil_buffer), has_stencil_buffer, 2, "gtk_gl_area_set_has_stencil_buffer", "gboolean");
  gtk_gl_area_set_has_stencil_buffer(Xen_to_C_GtkGLArea_(area), Xen_to_C_gboolean(has_stencil_buffer));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_get_auto_render(Xen area)
{
  #define H_gtk_gl_area_get_auto_render "gboolean gtk_gl_area_get_auto_render(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_auto_render", "GtkGLArea*");
  return(C_to_Xen_gboolean(gtk_gl_area_get_auto_render(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gtk_gl_area_set_auto_render(Xen area, Xen auto_render)
{
  #define H_gtk_gl_area_set_auto_render "void gtk_gl_area_set_auto_render(GtkGLArea* area, gboolean auto_render)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_set_auto_render", "GtkGLArea*");
  Xen_check_type(Xen_is_gboolean(auto_render), auto_render, 2, "gtk_gl_area_set_auto_render", "gboolean");
  gtk_gl_area_set_auto_render(Xen_to_C_GtkGLArea_(area), Xen_to_C_gboolean(auto_render));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_queue_render(Xen area)
{
  #define H_gtk_gl_area_queue_render "void gtk_gl_area_queue_render(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_queue_render", "GtkGLArea*");
  gtk_gl_area_queue_render(Xen_to_C_GtkGLArea_(area));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_attach_buffers(Xen area)
{
  #define H_gtk_gl_area_attach_buffers "void gtk_gl_area_attach_buffers(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_attach_buffers", "GtkGLArea*");
  gtk_gl_area_attach_buffers(Xen_to_C_GtkGLArea_(area));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_get_error(Xen area)
{
  #define H_gtk_gl_area_get_error "GError* gtk_gl_area_get_error(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_error", "GtkGLArea*");
  return(C_to_Xen_GError_(gtk_gl_area_get_error(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gtk_popover_menu_new(void)
{
  #define H_gtk_popover_menu_new "GtkWidget* gtk_popover_menu_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_popover_menu_new()));
}

static Xen gxg_gtk_popover_menu_open_submenu(Xen popover, Xen name)
{
  #define H_gtk_popover_menu_open_submenu "void gtk_popover_menu_open_submenu(GtkPopoverMenu* popover, \
gchar* name)"
  Xen_check_type(Xen_is_GtkPopoverMenu_(popover), popover, 1, "gtk_popover_menu_open_submenu", "GtkPopoverMenu*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_popover_menu_open_submenu", "gchar*");
  gtk_popover_menu_open_submenu(Xen_to_C_GtkPopoverMenu_(popover), (const gchar*)Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_entry_grab_focus_without_selecting(Xen entry)
{
  #define H_gtk_entry_grab_focus_without_selecting "void gtk_entry_grab_focus_without_selecting(GtkEntry* entry)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_grab_focus_without_selecting", "GtkEntry*");
  gtk_entry_grab_focus_without_selecting(Xen_to_C_GtkEntry_(entry));
  return(Xen_false);
}

static Xen gxg_gtk_scrollable_get_border(Xen scrollable, Xen border)
{
  #define H_gtk_scrollable_get_border "gboolean gtk_scrollable_get_border(GtkScrollable* scrollable, \
GtkBorder* border)"
  Xen_check_type(Xen_is_GtkScrollable_(scrollable), scrollable, 1, "gtk_scrollable_get_border", "GtkScrollable*");
  Xen_check_type(Xen_is_GtkBorder_(border), border, 2, "gtk_scrollable_get_border", "GtkBorder*");
  return(C_to_Xen_gboolean(gtk_scrollable_get_border(Xen_to_C_GtkScrollable_(scrollable), Xen_to_C_GtkBorder_(border))));
}

static Xen gxg_gtk_text_buffer_insert_markup(Xen buffer, Xen iter, Xen markup, Xen len)
{
  #define H_gtk_text_buffer_insert_markup "void gtk_text_buffer_insert_markup(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* markup, gint len)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_markup", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_markup", "GtkTextIter*");
  Xen_check_type(Xen_is_gchar_(markup), markup, 3, "gtk_text_buffer_insert_markup", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 4, "gtk_text_buffer_insert_markup", "gint");
  gtk_text_buffer_insert_markup(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), (const gchar*)Xen_to_C_gchar_(markup), Xen_to_C_gint(len));
  return(Xen_false);
}

static Xen gxg_gdk_device_get_vendor_id(Xen device)
{
  #define H_gdk_device_get_vendor_id "gchar* gdk_device_get_vendor_id(GdkDevice* device)"
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_vendor_id", "GdkDevice*");
    return(C_to_Xen_gchar_((gchar*)gdk_device_get_vendor_id(Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gdk_device_get_product_id(Xen device)
{
  #define H_gdk_device_get_product_id "gchar* gdk_device_get_product_id(GdkDevice* device)"
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_product_id", "GdkDevice*");
    return(C_to_Xen_gchar_((gchar*)gdk_device_get_product_id(Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gdk_gl_context_get_shared_context(Xen context)
{
  #define H_gdk_gl_context_get_shared_context "GdkGLContext* gdk_gl_context_get_shared_context(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_shared_context", "GdkGLContext*");
  return(C_to_Xen_GdkGLContext_(gdk_gl_context_get_shared_context(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gdk_gl_context_set_required_version(Xen context, Xen major, Xen minor)
{
  #define H_gdk_gl_context_set_required_version "void gdk_gl_context_set_required_version(GdkGLContext* context, \
int major, int minor)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_set_required_version", "GdkGLContext*");
  Xen_check_type(Xen_is_int(major), major, 2, "gdk_gl_context_set_required_version", "int");
  Xen_check_type(Xen_is_int(minor), minor, 3, "gdk_gl_context_set_required_version", "int");
  gdk_gl_context_set_required_version(Xen_to_C_GdkGLContext_(context), Xen_to_C_int(major), Xen_to_C_int(minor));
  return(Xen_false);
}

static Xen gxg_gdk_gl_context_get_required_version(Xen context, Xen ignore_major, Xen ignore_minor)
{
  #define H_gdk_gl_context_get_required_version "void gdk_gl_context_get_required_version(GdkGLContext* context, \
int* [major], int* [minor])"
  int ref_major;
  int ref_minor;
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_required_version", "GdkGLContext*");
  gdk_gl_context_get_required_version(Xen_to_C_GdkGLContext_(context), &ref_major, &ref_minor);
  return(Xen_list_2(C_to_Xen_int(ref_major), C_to_Xen_int(ref_minor)));
}

static Xen gxg_gdk_gl_context_set_debug_enabled(Xen context, Xen enabled)
{
  #define H_gdk_gl_context_set_debug_enabled "void gdk_gl_context_set_debug_enabled(GdkGLContext* context, \
gboolean enabled)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_set_debug_enabled", "GdkGLContext*");
  Xen_check_type(Xen_is_gboolean(enabled), enabled, 2, "gdk_gl_context_set_debug_enabled", "gboolean");
  gdk_gl_context_set_debug_enabled(Xen_to_C_GdkGLContext_(context), Xen_to_C_gboolean(enabled));
  return(Xen_false);
}

static Xen gxg_gdk_gl_context_get_debug_enabled(Xen context)
{
  #define H_gdk_gl_context_get_debug_enabled "gboolean gdk_gl_context_get_debug_enabled(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_debug_enabled", "GdkGLContext*");
  return(C_to_Xen_gboolean(gdk_gl_context_get_debug_enabled(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gdk_gl_context_set_forward_compatible(Xen context, Xen compatible)
{
  #define H_gdk_gl_context_set_forward_compatible "void gdk_gl_context_set_forward_compatible(GdkGLContext* context, \
gboolean compatible)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_set_forward_compatible", "GdkGLContext*");
  Xen_check_type(Xen_is_gboolean(compatible), compatible, 2, "gdk_gl_context_set_forward_compatible", "gboolean");
  gdk_gl_context_set_forward_compatible(Xen_to_C_GdkGLContext_(context), Xen_to_C_gboolean(compatible));
  return(Xen_false);
}

static Xen gxg_gdk_gl_context_get_forward_compatible(Xen context)
{
  #define H_gdk_gl_context_get_forward_compatible "gboolean gdk_gl_context_get_forward_compatible(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_forward_compatible", "GdkGLContext*");
  return(C_to_Xen_gboolean(gdk_gl_context_get_forward_compatible(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gdk_gl_context_realize(Xen context, Xen ignore_error)
{
  #define H_gdk_gl_context_realize "gboolean gdk_gl_context_realize(GdkGLContext* context, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_realize", "GdkGLContext*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_gl_context_realize(Xen_to_C_GdkGLContext_(context), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_drag_cancel(Xen context)
{
  #define H_gtk_drag_cancel "void gtk_drag_cancel(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_cancel", "GdkDragContext*");
  gtk_drag_cancel(Xen_to_C_GdkDragContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_search_entry_handle_event(Xen entry, Xen event)
{
  #define H_gtk_search_entry_handle_event "gboolean gtk_search_entry_handle_event(GtkSearchEntry* entry, \
GdkEvent* event)"
  Xen_check_type(Xen_is_GtkSearchEntry_(entry), entry, 1, "gtk_search_entry_handle_event", "GtkSearchEntry*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 2, "gtk_search_entry_handle_event", "GdkEvent*");
  return(C_to_Xen_gboolean(gtk_search_entry_handle_event(Xen_to_C_GtkSearchEntry_(entry), Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_gl_context_get_version(Xen context, Xen ignore_major, Xen ignore_minor)
{
  #define H_gdk_gl_context_get_version "void gdk_gl_context_get_version(GdkGLContext* context, int* [major], \
int* [minor])"
  int ref_major;
  int ref_minor;
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_version", "GdkGLContext*");
  gdk_gl_context_get_version(Xen_to_C_GdkGLContext_(context), &ref_major, &ref_minor);
  return(Xen_list_2(C_to_Xen_int(ref_major), C_to_Xen_int(ref_minor)));
}

static Xen gxg_gtk_gl_area_set_required_version(Xen area, Xen major, Xen minor)
{
  #define H_gtk_gl_area_set_required_version "void gtk_gl_area_set_required_version(GtkGLArea* area, \
gint major, gint minor)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_set_required_version", "GtkGLArea*");
  Xen_check_type(Xen_is_gint(major), major, 2, "gtk_gl_area_set_required_version", "gint");
  Xen_check_type(Xen_is_gint(minor), minor, 3, "gtk_gl_area_set_required_version", "gint");
  gtk_gl_area_set_required_version(Xen_to_C_GtkGLArea_(area), Xen_to_C_gint(major), Xen_to_C_gint(minor));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_get_required_version(Xen area, Xen ignore_major, Xen ignore_minor)
{
  #define H_gtk_gl_area_get_required_version "void gtk_gl_area_get_required_version(GtkGLArea* area, \
gint* [major], gint* [minor])"
  gint ref_major;
  gint ref_minor;
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_required_version", "GtkGLArea*");
  gtk_gl_area_get_required_version(Xen_to_C_GtkGLArea_(area), &ref_major, &ref_minor);
  return(Xen_list_2(C_to_Xen_gint(ref_major), C_to_Xen_gint(ref_minor)));
}

static Xen gxg_gtk_notebook_detach_tab(Xen notebook, Xen child)
{
  #define H_gtk_notebook_detach_tab "void gtk_notebook_detach_tab(GtkNotebook* notebook, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkNotebook_(notebook), notebook, 1, "gtk_notebook_detach_tab", "GtkNotebook*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_notebook_detach_tab", "GtkWidget*");
  gtk_notebook_detach_tab(Xen_to_C_GtkNotebook_(notebook), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_stack_sidebar_new(void)
{
  #define H_gtk_stack_sidebar_new "GtkWidget* gtk_stack_sidebar_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_stack_sidebar_new()));
}

static Xen gxg_gtk_stack_sidebar_set_stack(Xen sidebar, Xen stack)
{
  #define H_gtk_stack_sidebar_set_stack "void gtk_stack_sidebar_set_stack(GtkStackSidebar* sidebar, GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStackSidebar_(sidebar), sidebar, 1, "gtk_stack_sidebar_set_stack", "GtkStackSidebar*");
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 2, "gtk_stack_sidebar_set_stack", "GtkStack*");
  gtk_stack_sidebar_set_stack(Xen_to_C_GtkStackSidebar_(sidebar), Xen_to_C_GtkStack_(stack));
  return(Xen_false);
}

static Xen gxg_gtk_stack_sidebar_get_stack(Xen sidebar)
{
  #define H_gtk_stack_sidebar_get_stack "GtkStack* gtk_stack_sidebar_get_stack(GtkStackSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkStackSidebar_(sidebar), sidebar, 1, "gtk_stack_sidebar_get_stack", "GtkStackSidebar*");
  return(C_to_Xen_GtkStack_(gtk_stack_sidebar_get_stack(Xen_to_C_GtkStackSidebar_(sidebar))));
}

#endif

#if GTK_CHECK_VERSION(3, 18, 0)
static Xen gxg_gdk_keymap_get_scroll_lock_state(Xen keymap)
{
  #define H_gdk_keymap_get_scroll_lock_state "gboolean gdk_keymap_get_scroll_lock_state(GdkKeymap* keymap)"
  Xen_check_type(Xen_is_GdkKeymap_(keymap), keymap, 1, "gdk_keymap_get_scroll_lock_state", "GdkKeymap*");
  return(C_to_Xen_gboolean(gdk_keymap_get_scroll_lock_state(Xen_to_C_GdkKeymap_(keymap))));
}

static Xen gxg_gtk_radio_menu_item_join_group(Xen radio_menu_item, Xen group_source)
{
  #define H_gtk_radio_menu_item_join_group "void gtk_radio_menu_item_join_group(GtkRadioMenuItem* radio_menu_item, \
GtkRadioMenuItem* group_source)"
  Xen_check_type(Xen_is_GtkRadioMenuItem_(radio_menu_item), radio_menu_item, 1, "gtk_radio_menu_item_join_group", "GtkRadioMenuItem*");
  Xen_check_type(Xen_is_GtkRadioMenuItem_(group_source), group_source, 2, "gtk_radio_menu_item_join_group", "GtkRadioMenuItem*");
  gtk_radio_menu_item_join_group(Xen_to_C_GtkRadioMenuItem_(radio_menu_item), Xen_to_C_GtkRadioMenuItem_(group_source));
  return(Xen_false);
}

static Xen gxg_gtk_font_chooser_set_font_map(Xen fontchooser, Xen fontmap)
{
  #define H_gtk_font_chooser_set_font_map "void gtk_font_chooser_set_font_map(GtkFontChooser* fontchooser, \
PangoFontMap* fontmap)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_set_font_map", "GtkFontChooser*");
  Xen_check_type(Xen_is_PangoFontMap_(fontmap), fontmap, 2, "gtk_font_chooser_set_font_map", "PangoFontMap*");
  gtk_font_chooser_set_font_map(Xen_to_C_GtkFontChooser_(fontchooser), Xen_to_C_PangoFontMap_(fontmap));
  return(Xen_false);
}

static Xen gxg_gtk_font_chooser_get_font_map(Xen fontchooser)
{
  #define H_gtk_font_chooser_get_font_map "PangoFontMap* gtk_font_chooser_get_font_map(GtkFontChooser* fontchooser)"
  Xen_check_type(Xen_is_GtkFontChooser_(fontchooser), fontchooser, 1, "gtk_font_chooser_get_font_map", "GtkFontChooser*");
  return(C_to_Xen_PangoFontMap_(gtk_font_chooser_get_font_map(Xen_to_C_GtkFontChooser_(fontchooser))));
}

static Xen gxg_gtk_popover_set_default_widget(Xen popover, Xen widget)
{
  #define H_gtk_popover_set_default_widget "void gtk_popover_set_default_widget(GtkPopover* popover, \
GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_set_default_widget", "GtkPopover*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_popover_set_default_widget", "GtkWidget*");
  gtk_popover_set_default_widget(Xen_to_C_GtkPopover_(popover), Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_popover_get_default_widget(Xen popover)
{
  #define H_gtk_popover_get_default_widget "GtkWidget* gtk_popover_get_default_widget(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_get_default_widget", "GtkPopover*");
  return(C_to_Xen_GtkWidget_(gtk_popover_get_default_widget(Xen_to_C_GtkPopover_(popover))));
}

static Xen gxg_gdk_window_set_pass_through(Xen window, Xen pass_through)
{
  #define H_gdk_window_set_pass_through "void gdk_window_set_pass_through(GdkWindow* window, gboolean pass_through)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_set_pass_through", "GdkWindow*");
  Xen_check_type(Xen_is_gboolean(pass_through), pass_through, 2, "gdk_window_set_pass_through", "gboolean");
  gdk_window_set_pass_through(Xen_to_C_GdkWindow_(window), Xen_to_C_gboolean(pass_through));
  return(Xen_false);
}

static Xen gxg_gdk_window_get_pass_through(Xen window)
{
  #define H_gdk_window_get_pass_through "gboolean gdk_window_get_pass_through(GdkWindow* window)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_get_pass_through", "GdkWindow*");
  return(C_to_Xen_gboolean(gdk_window_get_pass_through(Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gtk_overlay_reorder_overlay(Xen overlay, Xen child, Xen position)
{
  #define H_gtk_overlay_reorder_overlay "void gtk_overlay_reorder_overlay(GtkOverlay* overlay, GtkWidget* child, \
gint position)"
  Xen_check_type(Xen_is_GtkOverlay_(overlay), overlay, 1, "gtk_overlay_reorder_overlay", "GtkOverlay*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_overlay_reorder_overlay", "GtkWidget*");
  Xen_check_type(Xen_is_gint(position), position, 3, "gtk_overlay_reorder_overlay", "gint");
  gtk_overlay_reorder_overlay(Xen_to_C_GtkOverlay_(overlay), Xen_to_C_GtkWidget_(child), Xen_to_C_gint(position));
  return(Xen_false);
}

static Xen gxg_gtk_overlay_get_overlay_pass_through(Xen overlay, Xen widget)
{
  #define H_gtk_overlay_get_overlay_pass_through "gboolean gtk_overlay_get_overlay_pass_through(GtkOverlay* overlay, \
GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkOverlay_(overlay), overlay, 1, "gtk_overlay_get_overlay_pass_through", "GtkOverlay*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_overlay_get_overlay_pass_through", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_overlay_get_overlay_pass_through(Xen_to_C_GtkOverlay_(overlay), Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_overlay_set_overlay_pass_through(Xen overlay, Xen widget, Xen pass_through)
{
  #define H_gtk_overlay_set_overlay_pass_through "void gtk_overlay_set_overlay_pass_through(GtkOverlay* overlay, \
GtkWidget* widget, gboolean pass_through)"
  Xen_check_type(Xen_is_GtkOverlay_(overlay), overlay, 1, "gtk_overlay_set_overlay_pass_through", "GtkOverlay*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_overlay_set_overlay_pass_through", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(pass_through), pass_through, 3, "gtk_overlay_set_overlay_pass_through", "gboolean");
  gtk_overlay_set_overlay_pass_through(Xen_to_C_GtkOverlay_(overlay), Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(pass_through));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_show_recent(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_show_recent "gboolean gtk_places_sidebar_get_show_recent(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_show_recent", "GtkPlacesSidebar*");
  return(C_to_Xen_gboolean(gtk_places_sidebar_get_show_recent(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_set_show_recent(Xen sidebar, Xen show_recent)
{
  #define H_gtk_places_sidebar_set_show_recent "void gtk_places_sidebar_set_show_recent(GtkPlacesSidebar* sidebar, \
gboolean show_recent)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_show_recent", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(show_recent), show_recent, 2, "gtk_places_sidebar_set_show_recent", "gboolean");
  gtk_places_sidebar_set_show_recent(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(show_recent));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_set_drop_targets_visible(Xen sidebar, Xen visible, Xen context)
{
  #define H_gtk_places_sidebar_set_drop_targets_visible "void gtk_places_sidebar_set_drop_targets_visible(GtkPlacesSidebar* sidebar, \
gboolean visible, GdkDragContext* context)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_drop_targets_visible", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(visible), visible, 2, "gtk_places_sidebar_set_drop_targets_visible", "gboolean");
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 3, "gtk_places_sidebar_set_drop_targets_visible", "GdkDragContext*");
  gtk_places_sidebar_set_drop_targets_visible(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(visible), Xen_to_C_GdkDragContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_show_trash(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_show_trash "gboolean gtk_places_sidebar_get_show_trash(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_show_trash", "GtkPlacesSidebar*");
  return(C_to_Xen_gboolean(gtk_places_sidebar_get_show_trash(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_places_sidebar_set_show_trash(Xen sidebar, Xen show_trash)
{
  #define H_gtk_places_sidebar_set_show_trash "void gtk_places_sidebar_set_show_trash(GtkPlacesSidebar* sidebar, \
gboolean show_trash)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_show_trash", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(show_trash), show_trash, 2, "gtk_places_sidebar_set_show_trash", "gboolean");
  gtk_places_sidebar_set_show_trash(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(show_trash));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_set_show_other_locations(Xen sidebar, Xen show_other_locations)
{
  #define H_gtk_places_sidebar_set_show_other_locations "void gtk_places_sidebar_set_show_other_locations(GtkPlacesSidebar* sidebar, \
gboolean show_other_locations)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_set_show_other_locations", "GtkPlacesSidebar*");
  Xen_check_type(Xen_is_gboolean(show_other_locations), show_other_locations, 2, "gtk_places_sidebar_set_show_other_locations", "gboolean");
  gtk_places_sidebar_set_show_other_locations(Xen_to_C_GtkPlacesSidebar_(sidebar), Xen_to_C_gboolean(show_other_locations));
  return(Xen_false);
}

static Xen gxg_gtk_places_sidebar_get_show_other_locations(Xen sidebar)
{
  #define H_gtk_places_sidebar_get_show_other_locations "gboolean gtk_places_sidebar_get_show_other_locations(GtkPlacesSidebar* sidebar)"
  Xen_check_type(Xen_is_GtkPlacesSidebar_(sidebar), sidebar, 1, "gtk_places_sidebar_get_show_other_locations", "GtkPlacesSidebar*");
  return(C_to_Xen_gboolean(gtk_places_sidebar_get_show_other_locations(Xen_to_C_GtkPlacesSidebar_(sidebar))));
}

static Xen gxg_gtk_stack_set_interpolate_size(Xen stack, Xen interpolate_size)
{
  #define H_gtk_stack_set_interpolate_size "void gtk_stack_set_interpolate_size(GtkStack* stack, gboolean interpolate_size)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_set_interpolate_size", "GtkStack*");
  Xen_check_type(Xen_is_gboolean(interpolate_size), interpolate_size, 2, "gtk_stack_set_interpolate_size", "gboolean");
  gtk_stack_set_interpolate_size(Xen_to_C_GtkStack_(stack), Xen_to_C_gboolean(interpolate_size));
  return(Xen_false);
}

static Xen gxg_gtk_stack_get_interpolate_size(Xen stack)
{
  #define H_gtk_stack_get_interpolate_size "gboolean gtk_stack_get_interpolate_size(GtkStack* stack)"
  Xen_check_type(Xen_is_GtkStack_(stack), stack, 1, "gtk_stack_get_interpolate_size", "GtkStack*");
  return(C_to_Xen_gboolean(gtk_stack_get_interpolate_size(Xen_to_C_GtkStack_(stack))));
}

static Xen gxg_gtk_widget_set_font_options(Xen widget, Xen options)
{
  #define H_gtk_widget_set_font_options "void gtk_widget_set_font_options(GtkWidget* widget, cairo_font_options_t* options)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_font_options", "GtkWidget*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 2, "gtk_widget_set_font_options", "cairo_font_options_t*");
  gtk_widget_set_font_options(Xen_to_C_GtkWidget_(widget), Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_font_options(Xen widget)
{
  #define H_gtk_widget_get_font_options "cairo_font_options_t* gtk_widget_get_font_options(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_font_options", "GtkWidget*");
    return(C_to_Xen_cairo_font_options_t_((cairo_font_options_t*)gtk_widget_get_font_options(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_font_map(Xen widget, Xen fontmap)
{
  #define H_gtk_widget_set_font_map "void gtk_widget_set_font_map(GtkWidget* widget, PangoFontMap* fontmap)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_font_map", "GtkWidget*");
  Xen_check_type(Xen_is_PangoFontMap_(fontmap), fontmap, 2, "gtk_widget_set_font_map", "PangoFontMap*");
  gtk_widget_set_font_map(Xen_to_C_GtkWidget_(widget), Xen_to_C_PangoFontMap_(fontmap));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_font_map(Xen widget)
{
  #define H_gtk_widget_get_font_map "PangoFontMap* gtk_widget_get_font_map(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_font_map", "GtkWidget*");
  return(C_to_Xen_PangoFontMap_(gtk_widget_get_font_map(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_text_view_set_top_margin(Xen text_view, Xen top_margin)
{
  #define H_gtk_text_view_set_top_margin "void gtk_text_view_set_top_margin(GtkTextView* text_view, gint top_margin)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_top_margin", "GtkTextView*");
  Xen_check_type(Xen_is_gint(top_margin), top_margin, 2, "gtk_text_view_set_top_margin", "gint");
  gtk_text_view_set_top_margin(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(top_margin));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_top_margin(Xen text_view)
{
  #define H_gtk_text_view_get_top_margin "gint gtk_text_view_get_top_margin(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_top_margin", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_top_margin(Xen_to_C_GtkTextView_(text_view))));
}

static Xen gxg_gtk_text_view_set_bottom_margin(Xen text_view, Xen bottom_margin)
{
  #define H_gtk_text_view_set_bottom_margin "void gtk_text_view_set_bottom_margin(GtkTextView* text_view, \
gint bottom_margin)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_set_bottom_margin", "GtkTextView*");
  Xen_check_type(Xen_is_gint(bottom_margin), bottom_margin, 2, "gtk_text_view_set_bottom_margin", "gint");
  gtk_text_view_set_bottom_margin(Xen_to_C_GtkTextView_(text_view), Xen_to_C_gint(bottom_margin));
  return(Xen_false);
}

static Xen gxg_gtk_text_view_get_bottom_margin(Xen text_view)
{
  #define H_gtk_text_view_get_bottom_margin "gint gtk_text_view_get_bottom_margin(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_bottom_margin", "GtkTextView*");
  return(C_to_Xen_gint(gtk_text_view_get_bottom_margin(Xen_to_C_GtkTextView_(text_view))));
}

#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static Xen gxg_gdk_gl_context_is_legacy(Xen context)
{
  #define H_gdk_gl_context_is_legacy "gboolean gdk_gl_context_is_legacy(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_is_legacy", "GdkGLContext*");
  return(C_to_Xen_gboolean(gdk_gl_context_is_legacy(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gdk_rectangle_equal(Xen rect1, Xen rect2)
{
  #define H_gdk_rectangle_equal "gboolean gdk_rectangle_equal(GdkRectangle* rect1, GdkRectangle* rect2)"
  Xen_check_type(Xen_is_GdkRectangle_(rect1), rect1, 1, "gdk_rectangle_equal", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkRectangle_(rect2), rect2, 2, "gdk_rectangle_equal", "GdkRectangle*");
  return(C_to_Xen_gboolean(gdk_rectangle_equal(Xen_to_C_GdkRectangle_(rect1), Xen_to_C_GdkRectangle_(rect2))));
}

static Xen gxg_gtk_application_window_set_help_overlay(Xen window, Xen help_overlay)
{
  #define H_gtk_application_window_set_help_overlay "void gtk_application_window_set_help_overlay(GtkApplicationWindow* window, \
GtkShortcutsWindow* help_overlay)"
  Xen_check_type(Xen_is_GtkApplicationWindow_(window), window, 1, "gtk_application_window_set_help_overlay", "GtkApplicationWindow*");
  Xen_check_type(Xen_is_GtkShortcutsWindow_(help_overlay), help_overlay, 2, "gtk_application_window_set_help_overlay", "GtkShortcutsWindow*");
  gtk_application_window_set_help_overlay(Xen_to_C_GtkApplicationWindow_(window), Xen_to_C_GtkShortcutsWindow_(help_overlay));
  return(Xen_false);
}

static Xen gxg_gtk_settings_reset_property(Xen settings, Xen name)
{
  #define H_gtk_settings_reset_property "void gtk_settings_reset_property(GtkSettings* settings, gchar* name)"
  Xen_check_type(Xen_is_GtkSettings_(settings), settings, 1, "gtk_settings_reset_property", "GtkSettings*");
  Xen_check_type(Xen_is_gchar_(name), name, 2, "gtk_settings_reset_property", "gchar*");
  gtk_settings_reset_property(Xen_to_C_GtkSettings_(settings), (const gchar*)Xen_to_C_gchar_(name));
  return(Xen_false);
}

static Xen gxg_gtk_text_tag_changed(Xen tag, Xen size_changed)
{
  #define H_gtk_text_tag_changed "void gtk_text_tag_changed(GtkTextTag* tag, gboolean size_changed)"
  Xen_check_type(Xen_is_GtkTextTag_(tag), tag, 1, "gtk_text_tag_changed", "GtkTextTag*");
  Xen_check_type(Xen_is_gboolean(size_changed), size_changed, 2, "gtk_text_tag_changed", "gboolean");
  gtk_text_tag_changed(Xen_to_C_GtkTextTag_(tag), Xen_to_C_gboolean(size_changed));
  return(Xen_false);
}

static Xen gxg_gtk_widget_path_iter_get_object_name(Xen path, Xen pos)
{
  #define H_gtk_widget_path_iter_get_object_name "char* gtk_widget_path_iter_get_object_name(GtkWidgetPath* path, \
gint pos)"
  Xen_check_type(Xen_is_GtkWidgetPath_(path), path, 1, "gtk_widget_path_iter_get_object_name", "GtkWidgetPath*");
  Xen_check_type(Xen_is_gint(pos), pos, 2, "gtk_widget_path_iter_get_object_name", "gint");
    return(C_to_Xen_char_((char*)gtk_widget_path_iter_get_object_name(Xen_to_C_GtkWidgetPath_(path), Xen_to_C_gint(pos))));
}

static Xen gxg_gtk_widget_path_iter_set_object_name(Xen path, Xen pos, Xen name)
{
  #define H_gtk_widget_path_iter_set_object_name "void gtk_widget_path_iter_set_object_name(GtkWidgetPath* path, \
gint pos, char* name)"
  Xen_check_type(Xen_is_GtkWidgetPath_(path), path, 1, "gtk_widget_path_iter_set_object_name", "GtkWidgetPath*");
  Xen_check_type(Xen_is_gint(pos), pos, 2, "gtk_widget_path_iter_set_object_name", "gint");
  Xen_check_type(Xen_is_char_(name), name, 3, "gtk_widget_path_iter_set_object_name", "char*");
  gtk_widget_path_iter_set_object_name(Xen_to_C_GtkWidgetPath_(path), Xen_to_C_gint(pos), (const char*)Xen_to_C_char_(name));
  return(Xen_false);
}

static Xen gxg_gtk_widget_queue_allocate(Xen widget)
{
  #define H_gtk_widget_queue_allocate "void gtk_widget_queue_allocate(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_queue_allocate", "GtkWidget*");
  gtk_widget_queue_allocate(Xen_to_C_GtkWidget_(widget));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_focus_on_click(Xen widget, Xen focus_on_click)
{
  #define H_gtk_widget_set_focus_on_click "void gtk_widget_set_focus_on_click(GtkWidget* widget, gboolean focus_on_click)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_focus_on_click", "GtkWidget*");
  Xen_check_type(Xen_is_gboolean(focus_on_click), focus_on_click, 2, "gtk_widget_set_focus_on_click", "gboolean");
  gtk_widget_set_focus_on_click(Xen_to_C_GtkWidget_(widget), Xen_to_C_gboolean(focus_on_click));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_focus_on_click(Xen widget)
{
  #define H_gtk_widget_get_focus_on_click "gboolean gtk_widget_get_focus_on_click(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_focus_on_click", "GtkWidget*");
  return(C_to_Xen_gboolean(gtk_widget_get_focus_on_click(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gdk_drag_context_get_drag_window(Xen context)
{
  #define H_gdk_drag_context_get_drag_window "GdkWindow* gdk_drag_context_get_drag_window(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_context_get_drag_window", "GdkDragContext*");
  return(C_to_Xen_GdkWindow_(gdk_drag_context_get_drag_window(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gtk_popover_set_constrain_to(Xen popover, Xen constraint)
{
  #define H_gtk_popover_set_constrain_to "void gtk_popover_set_constrain_to(GtkPopover* popover, GtkPopoverConstraint constraint)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_set_constrain_to", "GtkPopover*");
  Xen_check_type(Xen_is_GtkPopoverConstraint(constraint), constraint, 2, "gtk_popover_set_constrain_to", "GtkPopoverConstraint");
  gtk_popover_set_constrain_to(Xen_to_C_GtkPopover_(popover), Xen_to_C_GtkPopoverConstraint(constraint));
  return(Xen_false);
}

static Xen gxg_gtk_popover_get_constrain_to(Xen popover)
{
  #define H_gtk_popover_get_constrain_to "GtkPopoverConstraint gtk_popover_get_constrain_to(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_get_constrain_to", "GtkPopover*");
  return(C_to_Xen_GtkPopoverConstraint(gtk_popover_get_constrain_to(Xen_to_C_GtkPopover_(popover))));
}

static Xen gxg_gtk_text_iter_starts_tag(Xen iter, Xen tag)
{
  #define H_gtk_text_iter_starts_tag "gboolean gtk_text_iter_starts_tag(GtkTextIter* iter, GtkTextTag* tag)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_starts_tag", "GtkTextIter*");
  Xen_check_type(Xen_is_GtkTextTag_(tag) || Xen_is_false(tag), tag, 2, "gtk_text_iter_starts_tag", "GtkTextTag*");
  return(C_to_Xen_gboolean(gtk_text_iter_starts_tag(Xen_to_C_GtkTextIter_(iter), Xen_to_C_GtkTextTag_(tag))));
}

static Xen gxg_gdk_device_get_seat(Xen device)
{
  #define H_gdk_device_get_seat "GdkSeat* gdk_device_get_seat(GdkDevice* device)"
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_seat", "GdkDevice*");
  return(C_to_Xen_GdkSeat_(gdk_device_get_seat(Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gdk_display_get_default_seat(Xen display)
{
  #define H_gdk_display_get_default_seat "GdkSeat* gdk_display_get_default_seat(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_default_seat", "GdkDisplay*");
  return(C_to_Xen_GdkSeat_(gdk_display_get_default_seat(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_list_seats(Xen display)
{
  #define H_gdk_display_list_seats "GList* gdk_display_list_seats(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_list_seats", "GdkDisplay*");
  return(C_to_Xen_GList_(gdk_display_list_seats(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_drag_drop_done(Xen context, Xen success)
{
  #define H_gdk_drag_drop_done "void gdk_drag_drop_done(GdkDragContext* context, gboolean success)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_drop_done", "GdkDragContext*");
  Xen_check_type(Xen_is_gboolean(success), success, 2, "gdk_drag_drop_done", "gboolean");
  gdk_drag_drop_done(Xen_to_C_GdkDragContext_(context), Xen_to_C_gboolean(success));
  return(Xen_false);
}

static Xen gxg_gdk_drag_context_set_hotspot(Xen context, Xen hot_x, Xen hot_y)
{
  #define H_gdk_drag_context_set_hotspot "void gdk_drag_context_set_hotspot(GdkDragContext* context, \
gint hot_x, gint hot_y)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_context_set_hotspot", "GdkDragContext*");
  Xen_check_type(Xen_is_gint(hot_x), hot_x, 2, "gdk_drag_context_set_hotspot", "gint");
  Xen_check_type(Xen_is_gint(hot_y), hot_y, 3, "gdk_drag_context_set_hotspot", "gint");
  gdk_drag_context_set_hotspot(Xen_to_C_GdkDragContext_(context), Xen_to_C_gint(hot_x), Xen_to_C_gint(hot_y));
  return(Xen_false);
}

static Xen gxg_gdk_seat_grab(Xen arglist)
{
  #define H_gdk_seat_grab "GdkGrabStatus gdk_seat_grab(GdkSeat* seat, GdkWindow* window, GdkSeatCapabilities capabilities, \
gboolean owner_events, GdkCursor* cursor, GdkEvent* event, GdkSeatGrabPrepareFunc prepare_func, lambda_data func_info)"
  Xen seat, window, capabilities, owner_events, cursor, event, prepare_func, func_info;
  seat = Xen_list_ref(arglist, 0);
  window = Xen_list_ref(arglist, 1);
  capabilities = Xen_list_ref(arglist, 2);
  owner_events = Xen_list_ref(arglist, 3);
  cursor = Xen_list_ref(arglist, 4);
  event = Xen_list_ref(arglist, 5);
  prepare_func = Xen_list_ref(arglist, 6);
  func_info = Xen_list_ref(arglist, 7);
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_grab", "GdkSeat*");
  Xen_check_type(Xen_is_GdkWindow_(window), window, 2, "gdk_seat_grab", "GdkWindow*");
  Xen_check_type(Xen_is_GdkSeatCapabilities(capabilities), capabilities, 3, "gdk_seat_grab", "GdkSeatCapabilities");
  Xen_check_type(Xen_is_gboolean(owner_events), owner_events, 4, "gdk_seat_grab", "gboolean");
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 5, "gdk_seat_grab", "GdkCursor*");
  Xen_check_type(Xen_is_GdkEvent_(event), event, 6, "gdk_seat_grab", "GdkEvent*");
  Xen_check_type(Xen_is_GdkSeatGrabPrepareFunc(prepare_func), prepare_func, 7, "gdk_seat_grab", "GdkSeatGrabPrepareFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 8, "gdk_seat_grab", "lambda_data");
  {
    Xen result;
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    result = C_to_Xen_GdkGrabStatus(gdk_seat_grab(Xen_to_C_GdkSeat_(seat), Xen_to_C_GdkWindow_(window), Xen_to_C_GdkSeatCapabilities(capabilities), 
                                                  Xen_to_C_gboolean(owner_events), Xen_to_C_GdkCursor_(cursor), Xen_to_C_GdkEvent_(event), 
                                                  Xen_to_C_GdkSeatGrabPrepareFunc(prepare_func), Xen_to_C_lambda_data(func_info)));
    return(result);
   }
}

static Xen gxg_gdk_seat_ungrab(Xen seat)
{
  #define H_gdk_seat_ungrab "void gdk_seat_ungrab(GdkSeat* seat)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_ungrab", "GdkSeat*");
  gdk_seat_ungrab(Xen_to_C_GdkSeat_(seat));
  return(Xen_false);
}

static Xen gxg_gdk_seat_get_display(Xen seat)
{
  #define H_gdk_seat_get_display "GdkDisplay* gdk_seat_get_display(GdkSeat* seat)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_get_display", "GdkSeat*");
  return(C_to_Xen_GdkDisplay_(gdk_seat_get_display(Xen_to_C_GdkSeat_(seat))));
}

static Xen gxg_gdk_seat_get_capabilities(Xen seat)
{
  #define H_gdk_seat_get_capabilities "GdkSeatCapabilities gdk_seat_get_capabilities(GdkSeat* seat)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_get_capabilities", "GdkSeat*");
  return(C_to_Xen_GdkSeatCapabilities(gdk_seat_get_capabilities(Xen_to_C_GdkSeat_(seat))));
}

static Xen gxg_gdk_seat_get_slaves(Xen seat, Xen capabilities)
{
  #define H_gdk_seat_get_slaves "GList* gdk_seat_get_slaves(GdkSeat* seat, GdkSeatCapabilities capabilities)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_get_slaves", "GdkSeat*");
  Xen_check_type(Xen_is_GdkSeatCapabilities(capabilities), capabilities, 2, "gdk_seat_get_slaves", "GdkSeatCapabilities");
  return(C_to_Xen_GList_(gdk_seat_get_slaves(Xen_to_C_GdkSeat_(seat), Xen_to_C_GdkSeatCapabilities(capabilities))));
}

static Xen gxg_gdk_seat_get_pointer(Xen seat)
{
  #define H_gdk_seat_get_pointer "GdkDevice* gdk_seat_get_pointer(GdkSeat* seat)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_get_pointer", "GdkSeat*");
  return(C_to_Xen_GdkDevice_(gdk_seat_get_pointer(Xen_to_C_GdkSeat_(seat))));
}

static Xen gxg_gdk_seat_get_keyboard(Xen seat)
{
  #define H_gdk_seat_get_keyboard "GdkDevice* gdk_seat_get_keyboard(GdkSeat* seat)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_get_keyboard", "GdkSeat*");
  return(C_to_Xen_GdkDevice_(gdk_seat_get_keyboard(Xen_to_C_GdkSeat_(seat))));
}

static Xen gxg_gdk_event_is_scroll_stop_event(Xen event)
{
  #define H_gdk_event_is_scroll_stop_event "gboolean gdk_event_is_scroll_stop_event(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_is_scroll_stop_event", "GdkEvent*");
  return(C_to_Xen_gboolean(gdk_event_is_scroll_stop_event(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_text_view_reset_cursor_blink(Xen text_view)
{
  #define H_gtk_text_view_reset_cursor_blink "void gtk_text_view_reset_cursor_blink(GtkTextView* text_view)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_reset_cursor_blink", "GtkTextView*");
  gtk_text_view_reset_cursor_blink(Xen_to_C_GtkTextView_(text_view));
  return(Xen_false);
}

#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static Xen gxg_gdk_device_get_axes(Xen device)
{
  #define H_gdk_device_get_axes "GdkAxisFlags gdk_device_get_axes(GdkDevice* device)"
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_axes", "GdkDevice*");
  return(C_to_Xen_GdkAxisFlags(gdk_device_get_axes(Xen_to_C_GdkDevice_(device))));
}

static Xen gxg_gdk_event_get_device_tool(Xen event)
{
  #define H_gdk_event_get_device_tool "GdkDeviceTool* gdk_event_get_device_tool(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_device_tool", "GdkEvent*");
  return(C_to_Xen_GdkDeviceTool_(gdk_event_get_device_tool(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_event_set_device_tool(Xen event, Xen tool)
{
  #define H_gdk_event_set_device_tool "void gdk_event_set_device_tool(GdkEvent* event, GdkDeviceTool* tool)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_set_device_tool", "GdkEvent*");
  Xen_check_type(Xen_is_GdkDeviceTool_(tool), tool, 2, "gdk_event_set_device_tool", "GdkDeviceTool*");
  gdk_event_set_device_tool(Xen_to_C_GdkEvent_(event), Xen_to_C_GdkDeviceTool_(tool));
  return(Xen_false);
}

static Xen gxg_gdk_event_get_scancode(Xen event)
{
  #define H_gdk_event_get_scancode "int gdk_event_get_scancode(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_scancode", "GdkEvent*");
  return(C_to_Xen_int(gdk_event_get_scancode(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_gl_context_set_use_es(Xen context, Xen use_es)
{
  #define H_gdk_gl_context_set_use_es "void gdk_gl_context_set_use_es(GdkGLContext* context, int use_es)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_set_use_es", "GdkGLContext*");
  Xen_check_type(Xen_is_int(use_es), use_es, 2, "gdk_gl_context_set_use_es", "int");
  gdk_gl_context_set_use_es(Xen_to_C_GdkGLContext_(context), Xen_to_C_int(use_es));
  return(Xen_false);
}

static Xen gxg_gdk_gl_context_get_use_es(Xen context)
{
  #define H_gdk_gl_context_get_use_es "gboolean gdk_gl_context_get_use_es(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_use_es", "GdkGLContext*");
  return(C_to_Xen_gboolean(gdk_gl_context_get_use_es(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gtk_gl_area_set_use_es(Xen area, Xen use_es)
{
  #define H_gtk_gl_area_set_use_es "void gtk_gl_area_set_use_es(GtkGLArea* area, gboolean use_es)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_set_use_es", "GtkGLArea*");
  Xen_check_type(Xen_is_gboolean(use_es), use_es, 2, "gtk_gl_area_set_use_es", "gboolean");
  gtk_gl_area_set_use_es(Xen_to_C_GtkGLArea_(area), Xen_to_C_gboolean(use_es));
  return(Xen_false);
}

static Xen gxg_gtk_gl_area_get_use_es(Xen area)
{
  #define H_gtk_gl_area_get_use_es "gboolean gtk_gl_area_get_use_es(GtkGLArea* area)"
  Xen_check_type(Xen_is_GtkGLArea_(area), area, 1, "gtk_gl_area_get_use_es", "GtkGLArea*");
  return(C_to_Xen_gboolean(gtk_gl_area_get_use_es(Xen_to_C_GtkGLArea_(area))));
}

static Xen gxg_gdk_device_tool_get_serial(Xen tool)
{
  #define H_gdk_device_tool_get_serial "guint gdk_device_tool_get_serial(GdkDeviceTool* tool)"
  Xen_check_type(Xen_is_GdkDeviceTool_(tool), tool, 1, "gdk_device_tool_get_serial", "GdkDeviceTool*");
  return(C_to_Xen_guint(gdk_device_tool_get_serial(Xen_to_C_GdkDeviceTool_(tool))));
}

static Xen gxg_gdk_display_get_n_monitors(Xen display)
{
  #define H_gdk_display_get_n_monitors "int gdk_display_get_n_monitors(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_n_monitors", "GdkDisplay*");
  return(C_to_Xen_int(gdk_display_get_n_monitors(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_monitor(Xen display, Xen monitor_num)
{
  #define H_gdk_display_get_monitor "GdkMonitor* gdk_display_get_monitor(GdkDisplay* display, int monitor_num)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_monitor", "GdkDisplay*");
  Xen_check_type(Xen_is_int(monitor_num), monitor_num, 2, "gdk_display_get_monitor", "int");
  return(C_to_Xen_GdkMonitor_(gdk_display_get_monitor(Xen_to_C_GdkDisplay_(display), Xen_to_C_int(monitor_num))));
}

static Xen gxg_gdk_display_get_primary_monitor(Xen display)
{
  #define H_gdk_display_get_primary_monitor "GdkMonitor* gdk_display_get_primary_monitor(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_primary_monitor", "GdkDisplay*");
  return(C_to_Xen_GdkMonitor_(gdk_display_get_primary_monitor(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_monitor_at_point(Xen display, Xen x, Xen y)
{
  #define H_gdk_display_get_monitor_at_point "GdkMonitor* gdk_display_get_monitor_at_point(GdkDisplay* display, \
int x, int y)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_monitor_at_point", "GdkDisplay*");
  Xen_check_type(Xen_is_int(x), x, 2, "gdk_display_get_monitor_at_point", "int");
  Xen_check_type(Xen_is_int(y), y, 3, "gdk_display_get_monitor_at_point", "int");
  return(C_to_Xen_GdkMonitor_(gdk_display_get_monitor_at_point(Xen_to_C_GdkDisplay_(display), Xen_to_C_int(x), Xen_to_C_int(y))));
}

static Xen gxg_gdk_display_get_monitor_at_window(Xen display, Xen window)
{
  #define H_gdk_display_get_monitor_at_window "GdkMonitor* gdk_display_get_monitor_at_window(GdkDisplay* display, \
GdkWindow* window)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_monitor_at_window", "GdkDisplay*");
  Xen_check_type(Xen_is_GdkWindow_(window), window, 2, "gdk_display_get_monitor_at_window", "GdkWindow*");
  return(C_to_Xen_GdkMonitor_(gdk_display_get_monitor_at_window(Xen_to_C_GdkDisplay_(display), Xen_to_C_GdkWindow_(window))));
}

static Xen gxg_gdk_event_get_pointer_emulated(Xen event)
{
  #define H_gdk_event_get_pointer_emulated "gboolean gdk_event_get_pointer_emulated(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_pointer_emulated", "GdkEvent*");
  return(C_to_Xen_gboolean(gdk_event_get_pointer_emulated(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_menu_place_on_monitor(Xen menu, Xen monitor)
{
  #define H_gtk_menu_place_on_monitor "void gtk_menu_place_on_monitor(GtkMenu* menu, GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_place_on_monitor", "GtkMenu*");
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 2, "gtk_menu_place_on_monitor", "GdkMonitor*");
  gtk_menu_place_on_monitor(Xen_to_C_GtkMenu_(menu), Xen_to_C_GdkMonitor_(monitor));
  return(Xen_false);
}

static Xen gxg_gdk_monitor_get_display(Xen monitor)
{
  #define H_gdk_monitor_get_display "GdkDisplay* gdk_monitor_get_display(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_display", "GdkMonitor*");
  return(C_to_Xen_GdkDisplay_(gdk_monitor_get_display(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_geometry(Xen monitor, Xen geometry)
{
  #define H_gdk_monitor_get_geometry "void gdk_monitor_get_geometry(GdkMonitor* monitor, GdkRectangle* geometry)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_geometry", "GdkMonitor*");
  Xen_check_type(Xen_is_GdkRectangle_(geometry), geometry, 2, "gdk_monitor_get_geometry", "GdkRectangle*");
  gdk_monitor_get_geometry(Xen_to_C_GdkMonitor_(monitor), Xen_to_C_GdkRectangle_(geometry));
  return(Xen_false);
}

static Xen gxg_gdk_monitor_get_workarea(Xen monitor, Xen workarea)
{
  #define H_gdk_monitor_get_workarea "void gdk_monitor_get_workarea(GdkMonitor* monitor, GdkRectangle* workarea)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_workarea", "GdkMonitor*");
  Xen_check_type(Xen_is_GdkRectangle_(workarea), workarea, 2, "gdk_monitor_get_workarea", "GdkRectangle*");
  gdk_monitor_get_workarea(Xen_to_C_GdkMonitor_(monitor), Xen_to_C_GdkRectangle_(workarea));
  return(Xen_false);
}

static Xen gxg_gdk_monitor_get_width_mm(Xen monitor)
{
  #define H_gdk_monitor_get_width_mm "int gdk_monitor_get_width_mm(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_width_mm", "GdkMonitor*");
  return(C_to_Xen_int(gdk_monitor_get_width_mm(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_height_mm(Xen monitor)
{
  #define H_gdk_monitor_get_height_mm "int gdk_monitor_get_height_mm(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_height_mm", "GdkMonitor*");
  return(C_to_Xen_int(gdk_monitor_get_height_mm(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_manufacturer(Xen monitor)
{
  #define H_gdk_monitor_get_manufacturer "char* gdk_monitor_get_manufacturer(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_manufacturer", "GdkMonitor*");
  return(C_to_Xen_char_(gdk_monitor_get_manufacturer(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_model(Xen monitor)
{
  #define H_gdk_monitor_get_model "char* gdk_monitor_get_model(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_model", "GdkMonitor*");
  return(C_to_Xen_char_(gdk_monitor_get_model(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_scale_factor(Xen monitor)
{
  #define H_gdk_monitor_get_scale_factor "int gdk_monitor_get_scale_factor(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_scale_factor", "GdkMonitor*");
  return(C_to_Xen_int(gdk_monitor_get_scale_factor(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_refresh_rate(Xen monitor)
{
  #define H_gdk_monitor_get_refresh_rate "int gdk_monitor_get_refresh_rate(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_refresh_rate", "GdkMonitor*");
  return(C_to_Xen_int(gdk_monitor_get_refresh_rate(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_get_subpixel_layout(Xen monitor)
{
  #define H_gdk_monitor_get_subpixel_layout "GdkSubpixelLayout gdk_monitor_get_subpixel_layout(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_get_subpixel_layout", "GdkMonitor*");
  return(C_to_Xen_GdkSubpixelLayout(gdk_monitor_get_subpixel_layout(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_monitor_is_primary(Xen monitor)
{
  #define H_gdk_monitor_is_primary "gboolean gdk_monitor_is_primary(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_is_primary", "GdkMonitor*");
  return(C_to_Xen_gboolean(gdk_monitor_is_primary(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_drawing_context_get_window(Xen context)
{
  #define H_gdk_drawing_context_get_window "GdkWindow* gdk_drawing_context_get_window(GdkDrawingContext* context)"
  Xen_check_type(Xen_is_GdkDrawingContext_(context), context, 1, "gdk_drawing_context_get_window", "GdkDrawingContext*");
  return(C_to_Xen_GdkWindow_(gdk_drawing_context_get_window(Xen_to_C_GdkDrawingContext_(context))));
}

static Xen gxg_gdk_drawing_context_get_clip(Xen context)
{
  #define H_gdk_drawing_context_get_clip "cairo_region_t* gdk_drawing_context_get_clip(GdkDrawingContext* context)"
  Xen_check_type(Xen_is_GdkDrawingContext_(context), context, 1, "gdk_drawing_context_get_clip", "GdkDrawingContext*");
  return(C_to_Xen_cairo_region_t_(gdk_drawing_context_get_clip(Xen_to_C_GdkDrawingContext_(context))));
}

static Xen gxg_gdk_drawing_context_is_valid(Xen context)
{
  #define H_gdk_drawing_context_is_valid "gboolean gdk_drawing_context_is_valid(GdkDrawingContext* context)"
  Xen_check_type(Xen_is_GdkDrawingContext_(context), context, 1, "gdk_drawing_context_is_valid", "GdkDrawingContext*");
  return(C_to_Xen_gboolean(gdk_drawing_context_is_valid(Xen_to_C_GdkDrawingContext_(context))));
}

static Xen gxg_gdk_drawing_context_get_cairo_context(Xen context)
{
  #define H_gdk_drawing_context_get_cairo_context "cairo_t* gdk_drawing_context_get_cairo_context(GdkDrawingContext* context)"
  Xen_check_type(Xen_is_GdkDrawingContext_(context), context, 1, "gdk_drawing_context_get_cairo_context", "GdkDrawingContext*");
  return(C_to_Xen_cairo_t_(gdk_drawing_context_get_cairo_context(Xen_to_C_GdkDrawingContext_(context))));
}

static Xen gxg_gdk_cairo_get_drawing_context(Xen cr)
{
  #define H_gdk_cairo_get_drawing_context "GdkDrawingContext* gdk_cairo_get_drawing_context(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "gdk_cairo_get_drawing_context", "cairo_t*");
  return(C_to_Xen_GdkDrawingContext_(gdk_cairo_get_drawing_context(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_gtk_scrolled_window_set_max_content_width(Xen scrolled_window, Xen width)
{
  #define H_gtk_scrolled_window_set_max_content_width "void gtk_scrolled_window_set_max_content_width(GtkScrolledWindow* scrolled_window, \
gint width)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_max_content_width", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gint(width), width, 2, "gtk_scrolled_window_set_max_content_width", "gint");
  gtk_scrolled_window_set_max_content_width(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gint(width));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_max_content_width(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_max_content_width "gint gtk_scrolled_window_get_max_content_width(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_max_content_width", "GtkScrolledWindow*");
  return(C_to_Xen_gint(gtk_scrolled_window_get_max_content_width(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_set_max_content_height(Xen scrolled_window, Xen height)
{
  #define H_gtk_scrolled_window_set_max_content_height "void gtk_scrolled_window_set_max_content_height(GtkScrolledWindow* scrolled_window, \
gint height)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_max_content_height", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gint(height), height, 2, "gtk_scrolled_window_set_max_content_height", "gint");
  gtk_scrolled_window_set_max_content_height(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gint(height));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_max_content_height(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_max_content_height "gint gtk_scrolled_window_get_max_content_height(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_max_content_height", "GtkScrolledWindow*");
  return(C_to_Xen_gint(gtk_scrolled_window_get_max_content_height(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_file_chooser_add_choice(Xen chooser, Xen id, Xen label, Xen options, Xen option_labels)
{
  #define H_gtk_file_chooser_add_choice "void gtk_file_chooser_add_choice(GtkFileChooser* chooser, char* id, \
char* label, char** options, char** option_labels)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_add_choice", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(id), id, 2, "gtk_file_chooser_add_choice", "char*");
  Xen_check_type(Xen_is_char_(label), label, 3, "gtk_file_chooser_add_choice", "char*");
  Xen_check_type(Xen_is_char__(options), options, 4, "gtk_file_chooser_add_choice", "char**");
  Xen_check_type(Xen_is_char__(option_labels), option_labels, 5, "gtk_file_chooser_add_choice", "char**");
  gtk_file_chooser_add_choice(Xen_to_C_GtkFileChooser_(chooser), (const char*)Xen_to_C_char_(id), (const char*)Xen_to_C_char_(label), (const char**)Xen_to_C_char__(options), 
                              (const char**)Xen_to_C_char__(option_labels));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_remove_choice(Xen chooser, Xen id)
{
  #define H_gtk_file_chooser_remove_choice "void gtk_file_chooser_remove_choice(GtkFileChooser* chooser, \
char* id)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_remove_choice", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(id), id, 2, "gtk_file_chooser_remove_choice", "char*");
  gtk_file_chooser_remove_choice(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(id));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_set_choice(Xen chooser, Xen id, Xen option)
{
  #define H_gtk_file_chooser_set_choice "void gtk_file_chooser_set_choice(GtkFileChooser* chooser, char* id, \
char* option)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_set_choice", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(id), id, 2, "gtk_file_chooser_set_choice", "char*");
  Xen_check_type(Xen_is_char_(option), option, 3, "gtk_file_chooser_set_choice", "char*");
  gtk_file_chooser_set_choice(Xen_to_C_GtkFileChooser_(chooser), Xen_to_C_char_(id), Xen_to_C_char_(option));
  return(Xen_false);
}

static Xen gxg_gtk_file_chooser_get_choice(Xen chooser, Xen id)
{
  #define H_gtk_file_chooser_get_choice "char* gtk_file_chooser_get_choice(GtkFileChooser* chooser, char* id)"
  Xen_check_type(Xen_is_GtkFileChooser_(chooser), chooser, 1, "gtk_file_chooser_get_choice", "GtkFileChooser*");
  Xen_check_type(Xen_is_char_(id), id, 2, "gtk_file_chooser_get_choice", "char*");
  return(C_to_Xen_char_(gtk_file_chooser_get_choice(Xen_to_C_GtkFileChooser_(chooser), (const char*)Xen_to_C_char_(id))));
}

static Xen gxg_gdk_device_pad_get_n_groups(Xen pad)
{
  #define H_gdk_device_pad_get_n_groups "gint gdk_device_pad_get_n_groups(GdkDevicePad* pad)"
  Xen_check_type(Xen_is_GdkDevicePad_(pad), pad, 1, "gdk_device_pad_get_n_groups", "GdkDevicePad*");
  return(C_to_Xen_gint(gdk_device_pad_get_n_groups(Xen_to_C_GdkDevicePad_(pad))));
}

static Xen gxg_gdk_device_pad_get_group_n_modes(Xen pad, Xen group_idx)
{
  #define H_gdk_device_pad_get_group_n_modes "gint gdk_device_pad_get_group_n_modes(GdkDevicePad* pad, \
gint group_idx)"
  Xen_check_type(Xen_is_GdkDevicePad_(pad), pad, 1, "gdk_device_pad_get_group_n_modes", "GdkDevicePad*");
  Xen_check_type(Xen_is_gint(group_idx), group_idx, 2, "gdk_device_pad_get_group_n_modes", "gint");
  return(C_to_Xen_gint(gdk_device_pad_get_group_n_modes(Xen_to_C_GdkDevicePad_(pad), Xen_to_C_gint(group_idx))));
}

static Xen gxg_gdk_device_pad_get_n_features(Xen pad, Xen feature)
{
  #define H_gdk_device_pad_get_n_features "gint gdk_device_pad_get_n_features(GdkDevicePad* pad, GdkDevicePadFeature feature)"
  Xen_check_type(Xen_is_GdkDevicePad_(pad), pad, 1, "gdk_device_pad_get_n_features", "GdkDevicePad*");
  Xen_check_type(Xen_is_GdkDevicePadFeature(feature), feature, 2, "gdk_device_pad_get_n_features", "GdkDevicePadFeature");
  return(C_to_Xen_gint(gdk_device_pad_get_n_features(Xen_to_C_GdkDevicePad_(pad), Xen_to_C_GdkDevicePadFeature(feature))));
}

static Xen gxg_gdk_device_pad_get_feature_group(Xen pad, Xen feature, Xen feature_idx)
{
  #define H_gdk_device_pad_get_feature_group "gint gdk_device_pad_get_feature_group(GdkDevicePad* pad, \
GdkDevicePadFeature feature, gint feature_idx)"
  Xen_check_type(Xen_is_GdkDevicePad_(pad), pad, 1, "gdk_device_pad_get_feature_group", "GdkDevicePad*");
  Xen_check_type(Xen_is_GdkDevicePadFeature(feature), feature, 2, "gdk_device_pad_get_feature_group", "GdkDevicePadFeature");
  Xen_check_type(Xen_is_gint(feature_idx), feature_idx, 3, "gdk_device_pad_get_feature_group", "gint");
  return(C_to_Xen_gint(gdk_device_pad_get_feature_group(Xen_to_C_GdkDevicePad_(pad), Xen_to_C_GdkDevicePadFeature(feature), 
                                                        Xen_to_C_gint(feature_idx))));
}

static Xen gxg_gtk_menu_popup_at_rect(Xen menu, Xen rect_window, Xen rect, Xen rect_anchor, Xen menu_anchor, Xen trigger_event)
{
  #define H_gtk_menu_popup_at_rect "void gtk_menu_popup_at_rect(GtkMenu* menu, GdkWindow* rect_window, \
GdkRectangle* rect, GdkGravity rect_anchor, GdkGravity menu_anchor, GdkEvent* trigger_event)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_popup_at_rect", "GtkMenu*");
  Xen_check_type(Xen_is_GdkWindow_(rect_window), rect_window, 2, "gtk_menu_popup_at_rect", "GdkWindow*");
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 3, "gtk_menu_popup_at_rect", "GdkRectangle*");
  Xen_check_type(Xen_is_GdkGravity(rect_anchor), rect_anchor, 4, "gtk_menu_popup_at_rect", "GdkGravity");
  Xen_check_type(Xen_is_GdkGravity(menu_anchor), menu_anchor, 5, "gtk_menu_popup_at_rect", "GdkGravity");
  Xen_check_type(Xen_is_GdkEvent_(trigger_event), trigger_event, 6, "gtk_menu_popup_at_rect", "GdkEvent*");
  gtk_menu_popup_at_rect(Xen_to_C_GtkMenu_(menu), Xen_to_C_GdkWindow_(rect_window), Xen_to_C_GdkRectangle_(rect), Xen_to_C_GdkGravity(rect_anchor), 
                         Xen_to_C_GdkGravity(menu_anchor), Xen_to_C_GdkEvent_(trigger_event));
  return(Xen_false);
}

static Xen gxg_gtk_menu_popup_at_widget(Xen menu, Xen widget, Xen widget_anchor, Xen menu_anchor, Xen trigger_event)
{
  #define H_gtk_menu_popup_at_widget "void gtk_menu_popup_at_widget(GtkMenu* menu, GtkWidget* widget, \
GdkGravity widget_anchor, GdkGravity menu_anchor, GdkEvent* trigger_event)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_popup_at_widget", "GtkMenu*");
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 2, "gtk_menu_popup_at_widget", "GtkWidget*");
  Xen_check_type(Xen_is_GdkGravity(widget_anchor), widget_anchor, 3, "gtk_menu_popup_at_widget", "GdkGravity");
  Xen_check_type(Xen_is_GdkGravity(menu_anchor), menu_anchor, 4, "gtk_menu_popup_at_widget", "GdkGravity");
  Xen_check_type(Xen_is_GdkEvent_(trigger_event), trigger_event, 5, "gtk_menu_popup_at_widget", "GdkEvent*");
  gtk_menu_popup_at_widget(Xen_to_C_GtkMenu_(menu), Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkGravity(widget_anchor), Xen_to_C_GdkGravity(menu_anchor), 
                           Xen_to_C_GdkEvent_(trigger_event));
  return(Xen_false);
}

static Xen gxg_gtk_menu_popup_at_pointer(Xen menu, Xen trigger_event)
{
  #define H_gtk_menu_popup_at_pointer "void gtk_menu_popup_at_pointer(GtkMenu* menu, GdkEvent* trigger_event)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_popup_at_pointer", "GtkMenu*");
  Xen_check_type(Xen_is_GdkEvent_(trigger_event), trigger_event, 2, "gtk_menu_popup_at_pointer", "GdkEvent*");
  gtk_menu_popup_at_pointer(Xen_to_C_GtkMenu_(menu), Xen_to_C_GdkEvent_(trigger_event));
  return(Xen_false);
}

static Xen gxg_gtk_pad_controller_new(Xen window, Xen group, Xen pad)
{
  #define H_gtk_pad_controller_new "GtkPadController* gtk_pad_controller_new(GtkWindow* window, GActionGroup* group, \
GdkDevice* pad)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_pad_controller_new", "GtkWindow*");
  Xen_check_type(Xen_is_GActionGroup_(group), group, 2, "gtk_pad_controller_new", "GActionGroup*");
  Xen_check_type(Xen_is_GdkDevice_(pad), pad, 3, "gtk_pad_controller_new", "GdkDevice*");
  return(C_to_Xen_GtkPadController_(gtk_pad_controller_new(Xen_to_C_GtkWindow_(window), Xen_to_C_GActionGroup_(group), Xen_to_C_GdkDevice_(pad))));
}

static Xen gxg_gtk_pad_controller_set_action_entries(Xen controller, Xen entries, Xen n_entries)
{
  #define H_gtk_pad_controller_set_action_entries "void gtk_pad_controller_set_action_entries(GtkPadController* controller, \
GtkPadActionEntry* entries, gint n_entries)"
  Xen_check_type(Xen_is_GtkPadController_(controller), controller, 1, "gtk_pad_controller_set_action_entries", "GtkPadController*");
  Xen_check_type(Xen_is_GtkPadActionEntry_(entries), entries, 2, "gtk_pad_controller_set_action_entries", "GtkPadActionEntry*");
  Xen_check_type(Xen_is_gint(n_entries), n_entries, 3, "gtk_pad_controller_set_action_entries", "gint");
  gtk_pad_controller_set_action_entries(Xen_to_C_GtkPadController_(controller), Xen_to_C_GtkPadActionEntry_(entries), Xen_to_C_gint(n_entries));
  return(Xen_false);
}

static Xen gxg_gtk_pad_controller_set_action(Xen controller, Xen type, Xen index, Xen mode, Xen label, Xen action_name)
{
  #define H_gtk_pad_controller_set_action "void gtk_pad_controller_set_action(GtkPadController* controller, \
GtkPadActionType type, gint index, gint mode, gchar* label, gchar* action_name)"
  Xen_check_type(Xen_is_GtkPadController_(controller), controller, 1, "gtk_pad_controller_set_action", "GtkPadController*");
  Xen_check_type(Xen_is_GtkPadActionType(type), type, 2, "gtk_pad_controller_set_action", "GtkPadActionType");
  Xen_check_type(Xen_is_gint(index), index, 3, "gtk_pad_controller_set_action", "gint");
  Xen_check_type(Xen_is_gint(mode), mode, 4, "gtk_pad_controller_set_action", "gint");
  Xen_check_type(Xen_is_gchar_(label), label, 5, "gtk_pad_controller_set_action", "gchar*");
  Xen_check_type(Xen_is_gchar_(action_name), action_name, 6, "gtk_pad_controller_set_action", "gchar*");
  gtk_pad_controller_set_action(Xen_to_C_GtkPadController_(controller), Xen_to_C_GtkPadActionType(type), Xen_to_C_gint(index), 
                                Xen_to_C_gint(mode), (const gchar*)Xen_to_C_gchar_(label), (const gchar*)Xen_to_C_gchar_(action_name));
  return(Xen_false);
}

static Xen gxg_gtk_popover_popup(Xen popover)
{
  #define H_gtk_popover_popup "void gtk_popover_popup(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_popup", "GtkPopover*");
  gtk_popover_popup(Xen_to_C_GtkPopover_(popover));
  return(Xen_false);
}

static Xen gxg_gtk_popover_popdown(Xen popover)
{
  #define H_gtk_popover_popdown "void gtk_popover_popdown(GtkPopover* popover)"
  Xen_check_type(Xen_is_GtkPopover_(popover), popover, 1, "gtk_popover_popdown", "GtkPopover*");
  gtk_popover_popdown(Xen_to_C_GtkPopover_(popover));
  return(Xen_false);
}

static Xen gxg_gtk_shortcut_label_new(Xen accelerator)
{
  #define H_gtk_shortcut_label_new "GtkWidget* gtk_shortcut_label_new(gchar* accelerator)"
  Xen_check_type(Xen_is_gchar_(accelerator), accelerator, 1, "gtk_shortcut_label_new", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_shortcut_label_new((const gchar*)Xen_to_C_gchar_(accelerator))));
}

static Xen gxg_gtk_shortcut_label_get_accelerator(Xen self)
{
  #define H_gtk_shortcut_label_get_accelerator "gchar* gtk_shortcut_label_get_accelerator(GtkShortcutLabel* self)"
  Xen_check_type(Xen_is_GtkShortcutLabel_(self), self, 1, "gtk_shortcut_label_get_accelerator", "GtkShortcutLabel*");
    return(C_to_Xen_gchar_((gchar*)gtk_shortcut_label_get_accelerator(Xen_to_C_GtkShortcutLabel_(self))));
}

static Xen gxg_gtk_shortcut_label_set_accelerator(Xen self, Xen accelerator)
{
  #define H_gtk_shortcut_label_set_accelerator "void gtk_shortcut_label_set_accelerator(GtkShortcutLabel* self, \
gchar* accelerator)"
  Xen_check_type(Xen_is_GtkShortcutLabel_(self), self, 1, "gtk_shortcut_label_set_accelerator", "GtkShortcutLabel*");
  Xen_check_type(Xen_is_gchar_(accelerator), accelerator, 2, "gtk_shortcut_label_set_accelerator", "gchar*");
  gtk_shortcut_label_set_accelerator(Xen_to_C_GtkShortcutLabel_(self), (const gchar*)Xen_to_C_gchar_(accelerator));
  return(Xen_false);
}

static Xen gxg_gtk_shortcut_label_get_disabled_text(Xen self)
{
  #define H_gtk_shortcut_label_get_disabled_text "gchar* gtk_shortcut_label_get_disabled_text(GtkShortcutLabel* self)"
  Xen_check_type(Xen_is_GtkShortcutLabel_(self), self, 1, "gtk_shortcut_label_get_disabled_text", "GtkShortcutLabel*");
    return(C_to_Xen_gchar_((gchar*)gtk_shortcut_label_get_disabled_text(Xen_to_C_GtkShortcutLabel_(self))));
}

static Xen gxg_gtk_shortcut_label_set_disabled_text(Xen self, Xen disabled_text)
{
  #define H_gtk_shortcut_label_set_disabled_text "void gtk_shortcut_label_set_disabled_text(GtkShortcutLabel* self, \
gchar* disabled_text)"
  Xen_check_type(Xen_is_GtkShortcutLabel_(self), self, 1, "gtk_shortcut_label_set_disabled_text", "GtkShortcutLabel*");
  Xen_check_type(Xen_is_gchar_(disabled_text), disabled_text, 2, "gtk_shortcut_label_set_disabled_text", "gchar*");
  gtk_shortcut_label_set_disabled_text(Xen_to_C_GtkShortcutLabel_(self), (const gchar*)Xen_to_C_gchar_(disabled_text));
  return(Xen_false);
}

static Xen gxg_gdk_window_end_draw_frame(Xen window, Xen context)
{
  #define H_gdk_window_end_draw_frame "void gdk_window_end_draw_frame(GdkWindow* window, GdkDrawingContext* context)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_end_draw_frame", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDrawingContext_(context), context, 2, "gdk_window_end_draw_frame", "GdkDrawingContext*");
  gdk_window_end_draw_frame(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDrawingContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_set_propagate_natural_width(Xen scrolled_window, Xen propagate)
{
  #define H_gtk_scrolled_window_set_propagate_natural_width "void gtk_scrolled_window_set_propagate_natural_width(GtkScrolledWindow* scrolled_window, \
gboolean propagate)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_propagate_natural_width", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gboolean(propagate), propagate, 2, "gtk_scrolled_window_set_propagate_natural_width", "gboolean");
  gtk_scrolled_window_set_propagate_natural_width(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gboolean(propagate));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_propagate_natural_width(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_propagate_natural_width "gboolean gtk_scrolled_window_get_propagate_natural_width(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_propagate_natural_width", "GtkScrolledWindow*");
  return(C_to_Xen_gboolean(gtk_scrolled_window_get_propagate_natural_width(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

static Xen gxg_gtk_scrolled_window_set_propagate_natural_height(Xen scrolled_window, Xen propagate)
{
  #define H_gtk_scrolled_window_set_propagate_natural_height "void gtk_scrolled_window_set_propagate_natural_height(GtkScrolledWindow* scrolled_window, \
gboolean propagate)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_set_propagate_natural_height", "GtkScrolledWindow*");
  Xen_check_type(Xen_is_gboolean(propagate), propagate, 2, "gtk_scrolled_window_set_propagate_natural_height", "gboolean");
  gtk_scrolled_window_set_propagate_natural_height(Xen_to_C_GtkScrolledWindow_(scrolled_window), Xen_to_C_gboolean(propagate));
  return(Xen_false);
}

static Xen gxg_gtk_scrolled_window_get_propagate_natural_height(Xen scrolled_window)
{
  #define H_gtk_scrolled_window_get_propagate_natural_height "gboolean gtk_scrolled_window_get_propagate_natural_height(GtkScrolledWindow* scrolled_window)"
  Xen_check_type(Xen_is_GtkScrolledWindow_(scrolled_window), scrolled_window, 1, "gtk_scrolled_window_get_propagate_natural_height", "GtkScrolledWindow*");
  return(C_to_Xen_gboolean(gtk_scrolled_window_get_propagate_natural_height(Xen_to_C_GtkScrolledWindow_(scrolled_window))));
}

#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static Xen gxg_gdk_display_is_composited(Xen display)
{
  #define H_gdk_display_is_composited "gboolean gdk_display_is_composited(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_is_composited", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_is_composited(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_is_rgba(Xen display)
{
  #define H_gdk_display_is_rgba "gboolean gdk_display_is_rgba(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_is_rgba", "GdkDisplay*");
  return(C_to_Xen_gboolean(gdk_display_is_rgba(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_window_new_toplevel(Xen display, Xen event_mask, Xen width, Xen height)
{
  #define H_gdk_window_new_toplevel "GdkWindow* gdk_window_new_toplevel(GdkDisplay* display, gint event_mask, \
int width, int height)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_window_new_toplevel", "GdkDisplay*");
  Xen_check_type(Xen_is_gint(event_mask), event_mask, 2, "gdk_window_new_toplevel", "gint");
  Xen_check_type(Xen_is_int(width), width, 3, "gdk_window_new_toplevel", "int");
  Xen_check_type(Xen_is_int(height), height, 4, "gdk_window_new_toplevel", "int");
  return(C_to_Xen_GdkWindow_(gdk_window_new_toplevel(Xen_to_C_GdkDisplay_(display), Xen_to_C_gint(event_mask), Xen_to_C_int(width), 
                                                     Xen_to_C_int(height))));
}

static Xen gxg_gdk_window_new_popup(Xen display, Xen event_mask, Xen position)
{
  #define H_gdk_window_new_popup "GdkWindow* gdk_window_new_popup(GdkDisplay* display, gint event_mask, \
GdkRectangle* position)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_window_new_popup", "GdkDisplay*");
  Xen_check_type(Xen_is_gint(event_mask), event_mask, 2, "gdk_window_new_popup", "gint");
  Xen_check_type(Xen_is_GdkRectangle_(position), position, 3, "gdk_window_new_popup", "GdkRectangle*");
  return(C_to_Xen_GdkWindow_(gdk_window_new_popup(Xen_to_C_GdkDisplay_(display), Xen_to_C_gint(event_mask), Xen_to_C_GdkRectangle_(position))));
}

static Xen gxg_gdk_window_new_temp(Xen display)
{
  #define H_gdk_window_new_temp "GdkWindow* gdk_window_new_temp(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_window_new_temp", "GdkDisplay*");
  return(C_to_Xen_GdkWindow_(gdk_window_new_temp(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_window_new_child(Xen parent, Xen event_mask, Xen position)
{
  #define H_gdk_window_new_child "GdkWindow* gdk_window_new_child(GdkWindow* parent, gint event_mask, \
GdkRectangle* position)"
  Xen_check_type(Xen_is_GdkWindow_(parent), parent, 1, "gdk_window_new_child", "GdkWindow*");
  Xen_check_type(Xen_is_gint(event_mask), event_mask, 2, "gdk_window_new_child", "gint");
  Xen_check_type(Xen_is_GdkRectangle_(position), position, 3, "gdk_window_new_child", "GdkRectangle*");
  return(C_to_Xen_GdkWindow_(gdk_window_new_child(Xen_to_C_GdkWindow_(parent), Xen_to_C_gint(event_mask), Xen_to_C_GdkRectangle_(position))));
}

static Xen gxg_gtk_button_set_icon_name(Xen button, Xen icon_name)
{
  #define H_gtk_button_set_icon_name "void gtk_button_set_icon_name(GtkButton* button, char* icon_name)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_set_icon_name", "GtkButton*");
  Xen_check_type(Xen_is_char_(icon_name), icon_name, 2, "gtk_button_set_icon_name", "char*");
  gtk_button_set_icon_name(Xen_to_C_GtkButton_(button), Xen_to_C_char_(icon_name));
  return(Xen_false);
}

static Xen gxg_gtk_button_get_icon_name(Xen button)
{
  #define H_gtk_button_get_icon_name "char* gtk_button_get_icon_name(GtkButton* button)"
  Xen_check_type(Xen_is_GtkButton_(button), button, 1, "gtk_button_get_icon_name", "GtkButton*");
  return(C_to_Xen_char_(gtk_button_get_icon_name(Xen_to_C_GtkButton_(button))));
}

static Xen gxg_gtk_drawing_area_set_content_width(Xen self, Xen width)
{
  #define H_gtk_drawing_area_set_content_width "void gtk_drawing_area_set_content_width(GtkDrawingArea* self, \
int width)"
  Xen_check_type(Xen_is_GtkDrawingArea_(self), self, 1, "gtk_drawing_area_set_content_width", "GtkDrawingArea*");
  Xen_check_type(Xen_is_int(width), width, 2, "gtk_drawing_area_set_content_width", "int");
  gtk_drawing_area_set_content_width(Xen_to_C_GtkDrawingArea_(self), Xen_to_C_int(width));
  return(Xen_false);
}

static Xen gxg_gtk_drawing_area_get_content_width(Xen self)
{
  #define H_gtk_drawing_area_get_content_width "int gtk_drawing_area_get_content_width(GtkDrawingArea* self)"
  Xen_check_type(Xen_is_GtkDrawingArea_(self), self, 1, "gtk_drawing_area_get_content_width", "GtkDrawingArea*");
  return(C_to_Xen_int(gtk_drawing_area_get_content_width(Xen_to_C_GtkDrawingArea_(self))));
}

static Xen gxg_gtk_drawing_area_set_content_height(Xen self, Xen height)
{
  #define H_gtk_drawing_area_set_content_height "void gtk_drawing_area_set_content_height(GtkDrawingArea* self, \
int height)"
  Xen_check_type(Xen_is_GtkDrawingArea_(self), self, 1, "gtk_drawing_area_set_content_height", "GtkDrawingArea*");
  Xen_check_type(Xen_is_int(height), height, 2, "gtk_drawing_area_set_content_height", "int");
  gtk_drawing_area_set_content_height(Xen_to_C_GtkDrawingArea_(self), Xen_to_C_int(height));
  return(Xen_false);
}

static Xen gxg_gtk_drawing_area_get_content_height(Xen self)
{
  #define H_gtk_drawing_area_get_content_height "int gtk_drawing_area_get_content_height(GtkDrawingArea* self)"
  Xen_check_type(Xen_is_GtkDrawingArea_(self), self, 1, "gtk_drawing_area_get_content_height", "GtkDrawingArea*");
  return(C_to_Xen_int(gtk_drawing_area_get_content_height(Xen_to_C_GtkDrawingArea_(self))));
}

static Xen gxg_gtk_drawing_area_set_draw_func(Xen self, Xen func, Xen func_info, Xen destroy)
{
  #define H_gtk_drawing_area_set_draw_func "void gtk_drawing_area_set_draw_func(GtkDrawingArea* self, \
GtkDrawingAreaDrawFunc func, lambda_data func_info, GDestroyNotify destroy)"
  Xen_check_type(Xen_is_GtkDrawingArea_(self), self, 1, "gtk_drawing_area_set_draw_func", "GtkDrawingArea*");
  Xen_check_type(Xen_is_GtkDrawingAreaDrawFunc(func), func, 2, "gtk_drawing_area_set_draw_func", "GtkDrawingAreaDrawFunc");
  Xen_check_type(Xen_is_lambda_data(func_info) || Xen_is_false(func_info), func_info, 3, "gtk_drawing_area_set_draw_func", "lambda_data");
  Xen_check_type(Xen_is_GDestroyNotify(destroy), destroy, 4, "gtk_drawing_area_set_draw_func", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(func, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gtk_drawing_area_set_draw_func(Xen_to_C_GtkDrawingArea_(self), Xen_to_C_GtkDrawingAreaDrawFunc(func), Xen_to_C_lambda_data(func_info), 
                               Xen_to_C_GDestroyNotify(destroy));
    return(Xen_false);
   }
}

static Xen gxg_gdk_drawing_context_get_paint_context(Xen context)
{
  #define H_gdk_drawing_context_get_paint_context "GdkDrawContext* gdk_drawing_context_get_paint_context(GdkDrawingContext* context)"
  Xen_check_type(Xen_is_GdkDrawingContext_(context), context, 1, "gdk_drawing_context_get_paint_context", "GdkDrawingContext*");
  return(C_to_Xen_GdkDrawContext_(gdk_drawing_context_get_paint_context(Xen_to_C_GdkDrawingContext_(context))));
}

static Xen gxg_gdk_gl_context_get_damage(Xen context)
{
  #define H_gdk_gl_context_get_damage "cairo_region_t* gdk_gl_context_get_damage(GdkGLContext* context)"
  Xen_check_type(Xen_is_GdkGLContext_(context), context, 1, "gdk_gl_context_get_damage", "GdkGLContext*");
  return(C_to_Xen_cairo_region_t_(gdk_gl_context_get_damage(Xen_to_C_GdkGLContext_(context))));
}

static Xen gxg_gdk_rgba_is_clear(Xen rgba)
{
  #define H_gdk_rgba_is_clear "gboolean gdk_rgba_is_clear(GdkRGBA* rgba)"
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 1, "gdk_rgba_is_clear", "GdkRGBA*");
  return(C_to_Xen_gboolean(gdk_rgba_is_clear(Xen_to_C_GdkRGBA_(rgba))));
}

static Xen gxg_gdk_rgba_is_opaque(Xen rgba)
{
  #define H_gdk_rgba_is_opaque "gboolean gdk_rgba_is_opaque(GdkRGBA* rgba)"
  Xen_check_type(Xen_is_GdkRGBA_(rgba), rgba, 1, "gdk_rgba_is_opaque", "GdkRGBA*");
  return(C_to_Xen_gboolean(gdk_rgba_is_opaque(Xen_to_C_GdkRGBA_(rgba))));
}

static Xen gxg_gdk_window_begin_draw_frame(Xen window, Xen context, Xen region)
{
  #define H_gdk_window_begin_draw_frame "GdkDrawingContext* gdk_window_begin_draw_frame(GdkWindow* window, \
GdkDrawContext* context, cairo_region_t* region)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_window_begin_draw_frame", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDrawContext_(context), context, 2, "gdk_window_begin_draw_frame", "GdkDrawContext*");
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 3, "gdk_window_begin_draw_frame", "cairo_region_t*");
  return(C_to_Xen_GdkDrawingContext_(gdk_window_begin_draw_frame(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDrawContext_(context), 
                                                                 Xen_to_C_cairo_region_t_(region))));
}

static Xen gxg_gtk_flow_box_get_child_at_pos(Xen box, Xen x, Xen y)
{
  #define H_gtk_flow_box_get_child_at_pos "GtkFlowBoxChild* gtk_flow_box_get_child_at_pos(GtkFlowBox* box, \
gint x, gint y)"
  Xen_check_type(Xen_is_GtkFlowBox_(box), box, 1, "gtk_flow_box_get_child_at_pos", "GtkFlowBox*");
  Xen_check_type(Xen_is_gint(x), x, 2, "gtk_flow_box_get_child_at_pos", "gint");
  Xen_check_type(Xen_is_gint(y), y, 3, "gtk_flow_box_get_child_at_pos", "gint");
  return(C_to_Xen_GtkFlowBoxChild_(gtk_flow_box_get_child_at_pos(Xen_to_C_GtkFlowBox_(box), Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_about_dialog_get_system_information(Xen about)
{
  #define H_gtk_about_dialog_get_system_information "gchar* gtk_about_dialog_get_system_information(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_system_information", "GtkAboutDialog*");
    return(C_to_Xen_gchar_((gchar*)gtk_about_dialog_get_system_information(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_system_information(Xen about, Xen system_information)
{
  #define H_gtk_about_dialog_set_system_information "void gtk_about_dialog_set_system_information(GtkAboutDialog* about, \
gchar* system_information)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_system_information", "GtkAboutDialog*");
  Xen_check_type(Xen_is_gchar_(system_information), system_information, 2, "gtk_about_dialog_set_system_information", "gchar*");
  gtk_about_dialog_set_system_information(Xen_to_C_GtkAboutDialog_(about), (const gchar*)Xen_to_C_gchar_(system_information));
  return(Xen_false);
}

static Xen gxg_gtk_action_bar_set_revealed(Xen action_bar, Xen revealed)
{
  #define H_gtk_action_bar_set_revealed "void gtk_action_bar_set_revealed(GtkActionBar* action_bar, gboolean revealed)"
  Xen_check_type(Xen_is_GtkActionBar_(action_bar), action_bar, 1, "gtk_action_bar_set_revealed", "GtkActionBar*");
  Xen_check_type(Xen_is_gboolean(revealed), revealed, 2, "gtk_action_bar_set_revealed", "gboolean");
  gtk_action_bar_set_revealed(Xen_to_C_GtkActionBar_(action_bar), Xen_to_C_gboolean(revealed));
  return(Xen_false);
}

static Xen gxg_gtk_action_bar_get_revealed(Xen action_bar)
{
  #define H_gtk_action_bar_get_revealed "gboolean gtk_action_bar_get_revealed(GtkActionBar* action_bar)"
  Xen_check_type(Xen_is_GtkActionBar_(action_bar), action_bar, 1, "gtk_action_bar_get_revealed", "GtkActionBar*");
  return(C_to_Xen_gboolean(gtk_action_bar_get_revealed(Xen_to_C_GtkActionBar_(action_bar))));
}

static Xen gxg_gtk_check_button_set_draw_indicator(Xen check_button, Xen draw_indicator)
{
  #define H_gtk_check_button_set_draw_indicator "void gtk_check_button_set_draw_indicator(GtkCheckButton* check_button, \
gboolean draw_indicator)"
  Xen_check_type(Xen_is_GtkCheckButton_(check_button), check_button, 1, "gtk_check_button_set_draw_indicator", "GtkCheckButton*");
  Xen_check_type(Xen_is_gboolean(draw_indicator), draw_indicator, 2, "gtk_check_button_set_draw_indicator", "gboolean");
  gtk_check_button_set_draw_indicator(Xen_to_C_GtkCheckButton_(check_button), Xen_to_C_gboolean(draw_indicator));
  return(Xen_false);
}

static Xen gxg_gtk_check_button_get_draw_indicator(Xen check_button)
{
  #define H_gtk_check_button_get_draw_indicator "gboolean gtk_check_button_get_draw_indicator(GtkCheckButton* check_button)"
  Xen_check_type(Xen_is_GtkCheckButton_(check_button), check_button, 1, "gtk_check_button_get_draw_indicator", "GtkCheckButton*");
  return(C_to_Xen_gboolean(gtk_check_button_get_draw_indicator(Xen_to_C_GtkCheckButton_(check_button))));
}

static Xen gxg_gtk_check_button_set_inconsistent(Xen check_button, Xen inconsistent)
{
  #define H_gtk_check_button_set_inconsistent "void gtk_check_button_set_inconsistent(GtkCheckButton* check_button, \
gboolean inconsistent)"
  Xen_check_type(Xen_is_GtkCheckButton_(check_button), check_button, 1, "gtk_check_button_set_inconsistent", "GtkCheckButton*");
  Xen_check_type(Xen_is_gboolean(inconsistent), inconsistent, 2, "gtk_check_button_set_inconsistent", "gboolean");
  gtk_check_button_set_inconsistent(Xen_to_C_GtkCheckButton_(check_button), Xen_to_C_gboolean(inconsistent));
  return(Xen_false);
}

static Xen gxg_gtk_check_button_get_inconsistent(Xen check_button)
{
  #define H_gtk_check_button_get_inconsistent "gboolean gtk_check_button_get_inconsistent(GtkCheckButton* check_button)"
  Xen_check_type(Xen_is_GtkCheckButton_(check_button), check_button, 1, "gtk_check_button_get_inconsistent", "GtkCheckButton*");
  return(C_to_Xen_gboolean(gtk_check_button_get_inconsistent(Xen_to_C_GtkCheckButton_(check_button))));
}

static Xen gxg_gtk_info_bar_set_revealed(Xen info_bar, Xen revealed)
{
  #define H_gtk_info_bar_set_revealed "void gtk_info_bar_set_revealed(GtkInfoBar* info_bar, gboolean revealed)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_set_revealed", "GtkInfoBar*");
  Xen_check_type(Xen_is_gboolean(revealed), revealed, 2, "gtk_info_bar_set_revealed", "gboolean");
  gtk_info_bar_set_revealed(Xen_to_C_GtkInfoBar_(info_bar), Xen_to_C_gboolean(revealed));
  return(Xen_false);
}

static Xen gxg_gtk_info_bar_get_revealed(Xen info_bar)
{
  #define H_gtk_info_bar_get_revealed "gboolean gtk_info_bar_get_revealed(GtkInfoBar* info_bar)"
  Xen_check_type(Xen_is_GtkInfoBar_(info_bar), info_bar, 1, "gtk_info_bar_get_revealed", "GtkInfoBar*");
  return(C_to_Xen_gboolean(gtk_info_bar_get_revealed(Xen_to_C_GtkInfoBar_(info_bar))));
}

static Xen gxg_gtk_widget_get_first_child(Xen widget)
{
  #define H_gtk_widget_get_first_child "GtkWidget* gtk_widget_get_first_child(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_first_child", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_first_child(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_last_child(Xen widget)
{
  #define H_gtk_widget_get_last_child "GtkWidget* gtk_widget_get_last_child(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_last_child", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_last_child(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_next_sibling(Xen widget)
{
  #define H_gtk_widget_get_next_sibling "GtkWidget* gtk_widget_get_next_sibling(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_next_sibling", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_next_sibling(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_prev_sibling(Xen widget)
{
  #define H_gtk_widget_get_prev_sibling "GtkWidget* gtk_widget_get_prev_sibling(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_prev_sibling", "GtkWidget*");
  return(C_to_Xen_GtkWidget_(gtk_widget_get_prev_sibling(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_set_focus_child(Xen widget, Xen child)
{
  #define H_gtk_widget_set_focus_child "void gtk_widget_set_focus_child(GtkWidget* widget, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_focus_child", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_widget_set_focus_child", "GtkWidget*");
  gtk_widget_set_focus_child(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_show_uri_on_window(Xen parent, Xen uri, Xen timestamp, Xen ignore_error)
{
  #define H_gtk_show_uri_on_window "gboolean gtk_show_uri_on_window(GtkWindow* parent, char* uri, guint32 timestamp, \
GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GtkWindow_(parent), parent, 1, "gtk_show_uri_on_window", "GtkWindow*");
  Xen_check_type(Xen_is_char_(uri), uri, 2, "gtk_show_uri_on_window", "char*");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 3, "gtk_show_uri_on_window", "guint32");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_show_uri_on_window(Xen_to_C_GtkWindow_(parent), (const char*)Xen_to_C_char_(uri), Xen_to_C_guint32(timestamp), 
                                                      &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gtk_box_pack_start(Xen box, Xen child)
{
  #define H_gtk_box_pack_start "void gtk_box_pack_start(GtkBox* box, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_pack_start", "GtkBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_box_pack_start", "GtkWidget*");
  gtk_box_pack_start(Xen_to_C_GtkBox_(box), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_box_pack_end(Xen box, Xen child)
{
  #define H_gtk_box_pack_end "void gtk_box_pack_end(GtkBox* box, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkBox_(box), box, 1, "gtk_box_pack_end", "GtkBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_box_pack_end", "GtkWidget*");
  gtk_box_pack_end(Xen_to_C_GtkBox_(box), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_widget_insert_after(Xen widget, Xen parent, Xen previous_sibling)
{
  #define H_gtk_widget_insert_after "void gtk_widget_insert_after(GtkWidget* widget, GtkWidget* parent, \
GtkWidget* previous_sibling)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_insert_after", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(parent), parent, 2, "gtk_widget_insert_after", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(previous_sibling), previous_sibling, 3, "gtk_widget_insert_after", "GtkWidget*");
  gtk_widget_insert_after(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(parent), Xen_to_C_GtkWidget_(previous_sibling));
  return(Xen_false);
}

static Xen gxg_gtk_widget_insert_before(Xen widget, Xen parent, Xen next_sibling)
{
  #define H_gtk_widget_insert_before "void gtk_widget_insert_before(GtkWidget* widget, GtkWidget* parent, \
GtkWidget* next_sibling)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_insert_before", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(parent), parent, 2, "gtk_widget_insert_before", "GtkWidget*");
  Xen_check_type(Xen_is_GtkWidget_(next_sibling), next_sibling, 3, "gtk_widget_insert_before", "GtkWidget*");
  gtk_widget_insert_before(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkWidget_(parent), Xen_to_C_GtkWidget_(next_sibling));
  return(Xen_false);
}

static Xen gxg_gtk_center_box_new(void)
{
  #define H_gtk_center_box_new "GtkWidget* gtk_center_box_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_center_box_new()));
}

static Xen gxg_gtk_center_box_set_start_widget(Xen self, Xen child)
{
  #define H_gtk_center_box_set_start_widget "void gtk_center_box_set_start_widget(GtkCenterBox* self, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_set_start_widget", "GtkCenterBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_center_box_set_start_widget", "GtkWidget*");
  gtk_center_box_set_start_widget(Xen_to_C_GtkCenterBox_(self), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_center_box_set_center_widget(Xen self, Xen child)
{
  #define H_gtk_center_box_set_center_widget "void gtk_center_box_set_center_widget(GtkCenterBox* self, \
GtkWidget* child)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_set_center_widget", "GtkCenterBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_center_box_set_center_widget", "GtkWidget*");
  gtk_center_box_set_center_widget(Xen_to_C_GtkCenterBox_(self), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_center_box_set_end_widget(Xen self, Xen child)
{
  #define H_gtk_center_box_set_end_widget "void gtk_center_box_set_end_widget(GtkCenterBox* self, GtkWidget* child)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_set_end_widget", "GtkCenterBox*");
  Xen_check_type(Xen_is_GtkWidget_(child), child, 2, "gtk_center_box_set_end_widget", "GtkWidget*");
  gtk_center_box_set_end_widget(Xen_to_C_GtkCenterBox_(self), Xen_to_C_GtkWidget_(child));
  return(Xen_false);
}

static Xen gxg_gtk_center_box_get_start_widget(Xen self)
{
  #define H_gtk_center_box_get_start_widget "GtkWidget* gtk_center_box_get_start_widget(GtkCenterBox* self)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_get_start_widget", "GtkCenterBox*");
  return(C_to_Xen_GtkWidget_(gtk_center_box_get_start_widget(Xen_to_C_GtkCenterBox_(self))));
}

static Xen gxg_gtk_center_box_get_center_widget(Xen self)
{
  #define H_gtk_center_box_get_center_widget "GtkWidget* gtk_center_box_get_center_widget(GtkCenterBox* self)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_get_center_widget", "GtkCenterBox*");
  return(C_to_Xen_GtkWidget_(gtk_center_box_get_center_widget(Xen_to_C_GtkCenterBox_(self))));
}

static Xen gxg_gtk_center_box_get_end_widget(Xen self)
{
  #define H_gtk_center_box_get_end_widget "GtkWidget* gtk_center_box_get_end_widget(GtkCenterBox* self)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_get_end_widget", "GtkCenterBox*");
  return(C_to_Xen_GtkWidget_(gtk_center_box_get_end_widget(Xen_to_C_GtkCenterBox_(self))));
}

static Xen gxg_gtk_center_box_set_baseline_position(Xen self, Xen position)
{
  #define H_gtk_center_box_set_baseline_position "void gtk_center_box_set_baseline_position(GtkCenterBox* self, \
GtkBaselinePosition position)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_set_baseline_position", "GtkCenterBox*");
  Xen_check_type(Xen_is_GtkBaselinePosition(position), position, 2, "gtk_center_box_set_baseline_position", "GtkBaselinePosition");
  gtk_center_box_set_baseline_position(Xen_to_C_GtkCenterBox_(self), Xen_to_C_GtkBaselinePosition(position));
  return(Xen_false);
}

static Xen gxg_gtk_center_box_get_baseline_position(Xen self)
{
  #define H_gtk_center_box_get_baseline_position "GtkBaselinePosition gtk_center_box_get_baseline_position(GtkCenterBox* self)"
  Xen_check_type(Xen_is_GtkCenterBox_(self), self, 1, "gtk_center_box_get_baseline_position", "GtkCenterBox*");
  return(C_to_Xen_GtkBaselinePosition(gtk_center_box_get_baseline_position(Xen_to_C_GtkCenterBox_(self))));
}

static Xen gxg_gdk_event_set_coords(Xen event, Xen x, Xen y)
{
  #define H_gdk_event_set_coords "void gdk_event_set_coords(GdkEvent* event, gdouble x, gdouble y)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_set_coords", "GdkEvent*");
  Xen_check_type(Xen_is_gdouble(x), x, 2, "gdk_event_set_coords", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 3, "gdk_event_set_coords", "gdouble");
  gdk_event_set_coords(Xen_to_C_GdkEvent_(event), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y));
  return(Xen_false);
}

static Xen gxg_gdk_event_set_user_data(Xen event, Xen user_data)
{
  #define H_gdk_event_set_user_data "void gdk_event_set_user_data(GdkEvent* event, GObject* user_data)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_set_user_data", "GdkEvent*");
  Xen_check_type(Xen_is_GObject_(user_data), user_data, 2, "gdk_event_set_user_data", "GObject*");
  gdk_event_set_user_data(Xen_to_C_GdkEvent_(event), Xen_to_C_GObject_(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_rectangle_contains_point(Xen rect, Xen x, Xen y)
{
  #define H_gdk_rectangle_contains_point "gboolean gdk_rectangle_contains_point(GdkRectangle* rect, int x, \
int y)"
  Xen_check_type(Xen_is_GdkRectangle_(rect), rect, 1, "gdk_rectangle_contains_point", "GdkRectangle*");
  Xen_check_type(Xen_is_int(x), x, 2, "gdk_rectangle_contains_point", "int");
  Xen_check_type(Xen_is_int(y), y, 3, "gdk_rectangle_contains_point", "int");
  return(C_to_Xen_gboolean(gdk_rectangle_contains_point(Xen_to_C_GdkRectangle_(rect), Xen_to_C_int(x), Xen_to_C_int(y))));
}

static Xen gxg_gtk_get_event_target(Xen event)
{
  #define H_gtk_get_event_target "GtkWidget* gtk_get_event_target(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gtk_get_event_target", "GdkEvent*");
  return(C_to_Xen_GtkWidget_(gtk_get_event_target(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gtk_accel_label_set_label(Xen accel_label, Xen text)
{
  #define H_gtk_accel_label_set_label "void gtk_accel_label_set_label(GtkAccelLabel* accel_label, char* text)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_set_label", "GtkAccelLabel*");
  Xen_check_type(Xen_is_char_(text), text, 2, "gtk_accel_label_set_label", "char*");
  gtk_accel_label_set_label(Xen_to_C_GtkAccelLabel_(accel_label), (const char*)Xen_to_C_char_(text));
  return(Xen_false);
}

static Xen gxg_gtk_accel_label_get_label(Xen accel_label)
{
  #define H_gtk_accel_label_get_label "char* gtk_accel_label_get_label(GtkAccelLabel* accel_label)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_get_label", "GtkAccelLabel*");
    return(C_to_Xen_char_((char*)gtk_accel_label_get_label(Xen_to_C_GtkAccelLabel_(accel_label))));
}

static Xen gxg_gtk_accel_label_set_use_underline(Xen accel_label, Xen setting)
{
  #define H_gtk_accel_label_set_use_underline "void gtk_accel_label_set_use_underline(GtkAccelLabel* accel_label, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_set_use_underline", "GtkAccelLabel*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_accel_label_set_use_underline", "gboolean");
  gtk_accel_label_set_use_underline(Xen_to_C_GtkAccelLabel_(accel_label), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_accel_label_get_use_underline(Xen accel_label)
{
  #define H_gtk_accel_label_get_use_underline "gboolean gtk_accel_label_get_use_underline(GtkAccelLabel* accel_label)"
  Xen_check_type(Xen_is_GtkAccelLabel_(accel_label), accel_label, 1, "gtk_accel_label_get_use_underline", "GtkAccelLabel*");
  return(C_to_Xen_gboolean(gtk_accel_label_get_use_underline(Xen_to_C_GtkAccelLabel_(accel_label))));
}

static Xen gxg_gtk_scrollbar_set_adjustment(Xen self, Xen adjustment)
{
  #define H_gtk_scrollbar_set_adjustment "void gtk_scrollbar_set_adjustment(GtkScrollbar* self, GtkAdjustment* adjustment)"
  Xen_check_type(Xen_is_GtkScrollbar_(self), self, 1, "gtk_scrollbar_set_adjustment", "GtkScrollbar*");
  Xen_check_type(Xen_is_GtkAdjustment_(adjustment), adjustment, 2, "gtk_scrollbar_set_adjustment", "GtkAdjustment*");
  gtk_scrollbar_set_adjustment(Xen_to_C_GtkScrollbar_(self), Xen_to_C_GtkAdjustment_(adjustment));
  return(Xen_false);
}

static Xen gxg_gtk_scrollbar_get_adjustment(Xen self)
{
  #define H_gtk_scrollbar_get_adjustment "GtkAdjustment* gtk_scrollbar_get_adjustment(GtkScrollbar* self)"
  Xen_check_type(Xen_is_GtkScrollbar_(self), self, 1, "gtk_scrollbar_get_adjustment", "GtkScrollbar*");
  return(C_to_Xen_GtkAdjustment_(gtk_scrollbar_get_adjustment(Xen_to_C_GtkScrollbar_(self))));
}

static Xen gxg_gtk_scrollbar_get_wheel_delta(Xen self, Xen event)
{
  #define H_gtk_scrollbar_get_wheel_delta "double gtk_scrollbar_get_wheel_delta(GtkScrollbar* self, GdkEventScroll* event)"
  Xen_check_type(Xen_is_GtkScrollbar_(self), self, 1, "gtk_scrollbar_get_wheel_delta", "GtkScrollbar*");
  Xen_check_type(Xen_is_GdkEventScroll_(event), event, 2, "gtk_scrollbar_get_wheel_delta", "GdkEventScroll*");
  return(C_to_Xen_double(gtk_scrollbar_get_wheel_delta(Xen_to_C_GtkScrollbar_(self), Xen_to_C_GdkEventScroll_(event))));
}

static Xen gxg_gtk_spin_button_get_text(Xen spin_button)
{
  #define H_gtk_spin_button_get_text "char* gtk_spin_button_get_text(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_text", "GtkSpinButton*");
    return(C_to_Xen_char_((char*)gtk_spin_button_get_text(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_text(Xen spin_button, Xen text)
{
  #define H_gtk_spin_button_set_text "void gtk_spin_button_set_text(GtkSpinButton* spin_button, char* text)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_text", "GtkSpinButton*");
  Xen_check_type(Xen_is_char_(text), text, 2, "gtk_spin_button_set_text", "char*");
  gtk_spin_button_set_text(Xen_to_C_GtkSpinButton_(spin_button), (const char*)Xen_to_C_char_(text));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_max_width_chars(Xen spin_button)
{
  #define H_gtk_spin_button_get_max_width_chars "int gtk_spin_button_get_max_width_chars(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_max_width_chars", "GtkSpinButton*");
  return(C_to_Xen_int(gtk_spin_button_get_max_width_chars(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_max_width_chars(Xen spin_button, Xen max_width_chars)
{
  #define H_gtk_spin_button_set_max_width_chars "void gtk_spin_button_set_max_width_chars(GtkSpinButton* spin_button, \
int max_width_chars)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_max_width_chars", "GtkSpinButton*");
  Xen_check_type(Xen_is_int(max_width_chars), max_width_chars, 2, "gtk_spin_button_set_max_width_chars", "int");
  gtk_spin_button_set_max_width_chars(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_int(max_width_chars));
  return(Xen_false);
}

static Xen gxg_gtk_spin_button_get_width_chars(Xen spin_button)
{
  #define H_gtk_spin_button_get_width_chars "int gtk_spin_button_get_width_chars(GtkSpinButton* spin_button)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_get_width_chars", "GtkSpinButton*");
  return(C_to_Xen_int(gtk_spin_button_get_width_chars(Xen_to_C_GtkSpinButton_(spin_button))));
}

static Xen gxg_gtk_spin_button_set_width_chars(Xen spin_button, Xen width_chars)
{
  #define H_gtk_spin_button_set_width_chars "void gtk_spin_button_set_width_chars(GtkSpinButton* spin_button, \
int width_chars)"
  Xen_check_type(Xen_is_GtkSpinButton_(spin_button), spin_button, 1, "gtk_spin_button_set_width_chars", "GtkSpinButton*");
  Xen_check_type(Xen_is_int(width_chars), width_chars, 2, "gtk_spin_button_set_width_chars", "int");
  gtk_spin_button_set_width_chars(Xen_to_C_GtkSpinButton_(spin_button), Xen_to_C_int(width_chars));
  return(Xen_false);
}

static Xen gxg_gtk_widget_size_allocate(Xen widget, Xen allocation, Xen baseline, Xen out_clip)
{
  #define H_gtk_widget_size_allocate "void gtk_widget_size_allocate(GtkWidget* widget, GtkAllocation* allocation, \
int baseline, GtkAllocation* out_clip)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_size_allocate", "GtkWidget*");
  Xen_check_type(Xen_is_GtkAllocation_(allocation), allocation, 2, "gtk_widget_size_allocate", "GtkAllocation*");
  Xen_check_type(Xen_is_int(baseline), baseline, 3, "gtk_widget_size_allocate", "int");
  Xen_check_type(Xen_is_GtkAllocation_(out_clip), out_clip, 4, "gtk_widget_size_allocate", "GtkAllocation*");
  gtk_widget_size_allocate(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkAllocation_(allocation), Xen_to_C_int(baseline), Xen_to_C_GtkAllocation_(out_clip));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_new(void)
{
  #define H_gtk_style_context_new "GtkStyleContext* gtk_style_context_new( void)"
  return(C_to_Xen_GtkStyleContext_(gtk_style_context_new()));
}

static Xen gxg_gtk_style_context_add_provider(Xen context, Xen provider, Xen priority)
{
  #define H_gtk_style_context_add_provider "void gtk_style_context_add_provider(GtkStyleContext* context, \
GtkStyleProvider* provider, guint priority)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_add_provider", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkStyleProvider_(provider), provider, 2, "gtk_style_context_add_provider", "GtkStyleProvider*");
  Xen_check_type(Xen_is_guint(priority), priority, 3, "gtk_style_context_add_provider", "guint");
  gtk_style_context_add_provider(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkStyleProvider_(provider), Xen_to_C_guint(priority));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_save(Xen context)
{
  #define H_gtk_style_context_save "void gtk_style_context_save(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_save", "GtkStyleContext*");
  gtk_style_context_save(Xen_to_C_GtkStyleContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_restore(Xen context)
{
  #define H_gtk_style_context_restore "void gtk_style_context_restore(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_restore", "GtkStyleContext*");
  gtk_style_context_restore(Xen_to_C_GtkStyleContext_(context));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_section(Xen context, Xen property)
{
  #define H_gtk_style_context_get_section "GtkCssSection* gtk_style_context_get_section(GtkStyleContext* context, \
gchar* property)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_section", "GtkStyleContext*");
  Xen_check_type(Xen_is_gchar_(property), property, 2, "gtk_style_context_get_section", "gchar*");
  return(C_to_Xen_GtkCssSection_(gtk_style_context_get_section(Xen_to_C_GtkStyleContext_(context), (const gchar*)Xen_to_C_gchar_(property))));
}

static Xen gxg_gtk_style_context_get_property(Xen context, Xen property, Xen value)
{
  #define H_gtk_style_context_get_property "void gtk_style_context_get_property(GtkStyleContext* context, \
gchar* property, GValue* value)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_property", "GtkStyleContext*");
  Xen_check_type(Xen_is_gchar_(property), property, 2, "gtk_style_context_get_property", "gchar*");
  Xen_check_type(Xen_is_GValue_(value), value, 3, "gtk_style_context_get_property", "GValue*");
  gtk_style_context_get_property(Xen_to_C_GtkStyleContext_(context), Xen_to_C_gchar_(property), Xen_to_C_GValue_(value));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_set_state(Xen context, Xen flags)
{
  #define H_gtk_style_context_set_state "void gtk_style_context_set_state(GtkStyleContext* context, GtkStateFlags flags)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_set_state", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkStateFlags(flags), flags, 2, "gtk_style_context_set_state", "GtkStateFlags");
  gtk_style_context_set_state(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkStateFlags(flags));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_state(Xen context)
{
  #define H_gtk_style_context_get_state "GtkStateFlags gtk_style_context_get_state(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_state", "GtkStyleContext*");
  return(C_to_Xen_GtkStateFlags(gtk_style_context_get_state(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_set_scale(Xen context, Xen scale)
{
  #define H_gtk_style_context_set_scale "void gtk_style_context_set_scale(GtkStyleContext* context, gint scale)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_set_scale", "GtkStyleContext*");
  Xen_check_type(Xen_is_gint(scale), scale, 2, "gtk_style_context_set_scale", "gint");
  gtk_style_context_set_scale(Xen_to_C_GtkStyleContext_(context), Xen_to_C_gint(scale));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_scale(Xen context)
{
  #define H_gtk_style_context_get_scale "gint gtk_style_context_get_scale(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_scale", "GtkStyleContext*");
  return(C_to_Xen_gint(gtk_style_context_get_scale(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_set_path(Xen context, Xen path)
{
  #define H_gtk_style_context_set_path "void gtk_style_context_set_path(GtkStyleContext* context, GtkWidgetPath* path)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_set_path", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkWidgetPath_(path), path, 2, "gtk_style_context_set_path", "GtkWidgetPath*");
  gtk_style_context_set_path(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkWidgetPath_(path));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_path(Xen context)
{
  #define H_gtk_style_context_get_path "GtkWidgetPath* gtk_style_context_get_path(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_path", "GtkStyleContext*");
    return(C_to_Xen_GtkWidgetPath_((GtkWidgetPath*)gtk_style_context_get_path(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_set_parent(Xen context, Xen parent)
{
  #define H_gtk_style_context_set_parent "void gtk_style_context_set_parent(GtkStyleContext* context, \
GtkStyleContext* parent)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_set_parent", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkStyleContext_(parent), parent, 2, "gtk_style_context_set_parent", "GtkStyleContext*");
  gtk_style_context_set_parent(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkStyleContext_(parent));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_parent(Xen context)
{
  #define H_gtk_style_context_get_parent "GtkStyleContext* gtk_style_context_get_parent(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_parent", "GtkStyleContext*");
  return(C_to_Xen_GtkStyleContext_(gtk_style_context_get_parent(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_list_classes(Xen context)
{
  #define H_gtk_style_context_list_classes "GList* gtk_style_context_list_classes(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_list_classes", "GtkStyleContext*");
  return(C_to_Xen_GList_(gtk_style_context_list_classes(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_add_class(Xen context, Xen class_name)
{
  #define H_gtk_style_context_add_class "void gtk_style_context_add_class(GtkStyleContext* context, gchar* class_name)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_add_class", "GtkStyleContext*");
  Xen_check_type(Xen_is_gchar_(class_name), class_name, 2, "gtk_style_context_add_class", "gchar*");
  gtk_style_context_add_class(Xen_to_C_GtkStyleContext_(context), (const gchar*)Xen_to_C_gchar_(class_name));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_remove_class(Xen context, Xen class_name)
{
  #define H_gtk_style_context_remove_class "void gtk_style_context_remove_class(GtkStyleContext* context, \
gchar* class_name)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_remove_class", "GtkStyleContext*");
  Xen_check_type(Xen_is_gchar_(class_name), class_name, 2, "gtk_style_context_remove_class", "gchar*");
  gtk_style_context_remove_class(Xen_to_C_GtkStyleContext_(context), (const gchar*)Xen_to_C_gchar_(class_name));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_has_class(Xen context, Xen class_name)
{
  #define H_gtk_style_context_has_class "gboolean gtk_style_context_has_class(GtkStyleContext* context, \
gchar* class_name)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_has_class", "GtkStyleContext*");
  Xen_check_type(Xen_is_gchar_(class_name), class_name, 2, "gtk_style_context_has_class", "gchar*");
  return(C_to_Xen_gboolean(gtk_style_context_has_class(Xen_to_C_GtkStyleContext_(context), (const gchar*)Xen_to_C_gchar_(class_name))));
}

static Xen gxg_gtk_style_context_set_frame_clock(Xen context, Xen frame_clock)
{
  #define H_gtk_style_context_set_frame_clock "void gtk_style_context_set_frame_clock(GtkStyleContext* context, \
GdkFrameClock* frame_clock)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_set_frame_clock", "GtkStyleContext*");
  Xen_check_type(Xen_is_GdkFrameClock_(frame_clock), frame_clock, 2, "gtk_style_context_set_frame_clock", "GdkFrameClock*");
  gtk_style_context_set_frame_clock(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GdkFrameClock_(frame_clock));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_frame_clock(Xen context)
{
  #define H_gtk_style_context_get_frame_clock "GdkFrameClock* gtk_style_context_get_frame_clock(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_frame_clock", "GtkStyleContext*");
  return(C_to_Xen_GdkFrameClock_(gtk_style_context_get_frame_clock(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_lookup_color(Xen context, Xen color_name, Xen color)
{
  #define H_gtk_style_context_lookup_color "gboolean gtk_style_context_lookup_color(GtkStyleContext* context, \
gchar* color_name, GdkRGBA* color)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_lookup_color", "GtkStyleContext*");
  Xen_check_type(Xen_is_gchar_(color_name), color_name, 2, "gtk_style_context_lookup_color", "gchar*");
  Xen_check_type(Xen_is_GdkRGBA_(color), color, 3, "gtk_style_context_lookup_color", "GdkRGBA*");
  return(C_to_Xen_gboolean(gtk_style_context_lookup_color(Xen_to_C_GtkStyleContext_(context), (const gchar*)Xen_to_C_gchar_(color_name), 
                                                          Xen_to_C_GdkRGBA_(color))));
}

static Xen gxg_gtk_style_context_get_color(Xen context, Xen color)
{
  #define H_gtk_style_context_get_color "void gtk_style_context_get_color(GtkStyleContext* context, GdkRGBA* color)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_color", "GtkStyleContext*");
  Xen_check_type(Xen_is_GdkRGBA_(color), color, 2, "gtk_style_context_get_color", "GdkRGBA*");
  gtk_style_context_get_color(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GdkRGBA_(color));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_border(Xen context, Xen border)
{
  #define H_gtk_style_context_get_border "void gtk_style_context_get_border(GtkStyleContext* context, \
GtkBorder* border)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_border", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkBorder_(border), border, 2, "gtk_style_context_get_border", "GtkBorder*");
  gtk_style_context_get_border(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkBorder_(border));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_padding(Xen context, Xen padding)
{
  #define H_gtk_style_context_get_padding "void gtk_style_context_get_padding(GtkStyleContext* context, \
GtkBorder* padding)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_padding", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkBorder_(padding), padding, 2, "gtk_style_context_get_padding", "GtkBorder*");
  gtk_style_context_get_padding(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkBorder_(padding));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_margin(Xen context, Xen margin)
{
  #define H_gtk_style_context_get_margin "void gtk_style_context_get_margin(GtkStyleContext* context, \
GtkBorder* margin)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_margin", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkBorder_(margin), margin, 2, "gtk_style_context_get_margin", "GtkBorder*");
  gtk_style_context_get_margin(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkBorder_(margin));
  return(Xen_false);
}

static Xen gxg_gtk_render_insertion_cursor(Xen context, Xen cr, Xen x, Xen y, Xen layout, Xen index, Xen direction)
{
  #define H_gtk_render_insertion_cursor "void gtk_render_insertion_cursor(GtkStyleContext* context, cairo_t* cr, \
gdouble x, gdouble y, PangoLayout* layout, int index, PangoDirection direction)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_insertion_cursor", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_insertion_cursor", "cairo_t*");
  Xen_check_type(Xen_is_gdouble(x), x, 3, "gtk_render_insertion_cursor", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 4, "gtk_render_insertion_cursor", "gdouble");
  Xen_check_type(Xen_is_PangoLayout_(layout), layout, 5, "gtk_render_insertion_cursor", "PangoLayout*");
  Xen_check_type(Xen_is_int(index), index, 6, "gtk_render_insertion_cursor", "int");
  Xen_check_type(Xen_is_PangoDirection(direction), direction, 7, "gtk_render_insertion_cursor", "PangoDirection");
  gtk_render_insertion_cursor(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y), 
                              Xen_to_C_PangoLayout_(layout), Xen_to_C_int(index), Xen_to_C_PangoDirection(direction));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_to_string(Xen context, Xen flags)
{
  #define H_gtk_style_context_to_string "char* gtk_style_context_to_string(GtkStyleContext* context, \
GtkStyleContextPrintFlags flags)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_to_string", "GtkStyleContext*");
  Xen_check_type(Xen_is_GtkStyleContextPrintFlags(flags), flags, 2, "gtk_style_context_to_string", "GtkStyleContextPrintFlags");
  return(C_to_Xen_char_(gtk_style_context_to_string(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GtkStyleContextPrintFlags(flags))));
}

static Xen gxg_gtk_css_provider_new(void)
{
  #define H_gtk_css_provider_new "GtkCssProvider* gtk_css_provider_new( void)"
  return(C_to_Xen_GtkCssProvider_(gtk_css_provider_new()));
}

static Xen gxg_gtk_css_provider_to_string(Xen provider)
{
  #define H_gtk_css_provider_to_string "char* gtk_css_provider_to_string(GtkCssProvider* provider)"
  Xen_check_type(Xen_is_GtkCssProvider_(provider), provider, 1, "gtk_css_provider_to_string", "GtkCssProvider*");
  return(C_to_Xen_char_(gtk_css_provider_to_string(Xen_to_C_GtkCssProvider_(provider))));
}

static Xen gxg_gtk_css_provider_load_from_data(Xen css_provider, Xen data, Xen length)
{
  #define H_gtk_css_provider_load_from_data "void gtk_css_provider_load_from_data(GtkCssProvider* css_provider, \
gchar* data, gssize length)"
  Xen_check_type(Xen_is_GtkCssProvider_(css_provider), css_provider, 1, "gtk_css_provider_load_from_data", "GtkCssProvider*");
  Xen_check_type(Xen_is_gchar_(data), data, 2, "gtk_css_provider_load_from_data", "gchar*");
  Xen_check_type(Xen_is_gssize(length), length, 3, "gtk_css_provider_load_from_data", "gssize");
  gtk_css_provider_load_from_data(Xen_to_C_GtkCssProvider_(css_provider), (const gchar*)Xen_to_C_gchar_(data), Xen_to_C_gssize(length));
  return(Xen_false);
}

static Xen gxg_gtk_css_provider_load_from_file(Xen css_provider, Xen file)
{
  #define H_gtk_css_provider_load_from_file "void gtk_css_provider_load_from_file(GtkCssProvider* css_provider, \
GFile* file)"
  Xen_check_type(Xen_is_GtkCssProvider_(css_provider), css_provider, 1, "gtk_css_provider_load_from_file", "GtkCssProvider*");
  Xen_check_type(Xen_is_GFile_(file), file, 2, "gtk_css_provider_load_from_file", "GFile*");
  gtk_css_provider_load_from_file(Xen_to_C_GtkCssProvider_(css_provider), Xen_to_C_GFile_(file));
  return(Xen_false);
}

static Xen gxg_gtk_css_provider_load_from_path(Xen css_provider, Xen path)
{
  #define H_gtk_css_provider_load_from_path "void gtk_css_provider_load_from_path(GtkCssProvider* css_provider, \
gchar* path)"
  Xen_check_type(Xen_is_GtkCssProvider_(css_provider), css_provider, 1, "gtk_css_provider_load_from_path", "GtkCssProvider*");
  Xen_check_type(Xen_is_gchar_(path), path, 2, "gtk_css_provider_load_from_path", "gchar*");
  gtk_css_provider_load_from_path(Xen_to_C_GtkCssProvider_(css_provider), (const gchar*)Xen_to_C_gchar_(path));
  return(Xen_false);
}

static Xen gxg_gtk_css_provider_load_from_resource(Xen css_provider, Xen resource_path)
{
  #define H_gtk_css_provider_load_from_resource "void gtk_css_provider_load_from_resource(GtkCssProvider* css_provider, \
gchar* resource_path)"
  Xen_check_type(Xen_is_GtkCssProvider_(css_provider), css_provider, 1, "gtk_css_provider_load_from_resource", "GtkCssProvider*");
  Xen_check_type(Xen_is_gchar_(resource_path), resource_path, 2, "gtk_css_provider_load_from_resource", "gchar*");
  gtk_css_provider_load_from_resource(Xen_to_C_GtkCssProvider_(css_provider), (const gchar*)Xen_to_C_gchar_(resource_path));
  return(Xen_false);
}

static Xen gxg_gtk_css_provider_get_default(void)
{
  #define H_gtk_css_provider_get_default "GtkCssProvider* gtk_css_provider_get_default( void)"
  return(C_to_Xen_GtkCssProvider_(gtk_css_provider_get_default()));
}

static Xen gxg_gtk_css_provider_get_named(Xen name, Xen variant)
{
  #define H_gtk_css_provider_get_named "GtkCssProvider* gtk_css_provider_get_named(gchar* name, gchar* variant)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "gtk_css_provider_get_named", "gchar*");
  Xen_check_type(Xen_is_gchar_(variant), variant, 2, "gtk_css_provider_get_named", "gchar*");
  return(C_to_Xen_GtkCssProvider_(gtk_css_provider_get_named((const gchar*)Xen_to_C_gchar_(name), (const gchar*)Xen_to_C_gchar_(variant))));
}

#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static Xen gxg_gdk_event_set_keyval(Xen event, Xen keyval)
{
  #define H_gdk_event_set_keyval "void gdk_event_set_keyval(GdkEvent* event, guint keyval)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_set_keyval", "GdkEvent*");
  Xen_check_type(Xen_is_guint(keyval), keyval, 2, "gdk_event_set_keyval", "guint");
  gdk_event_set_keyval(Xen_to_C_GdkEvent_(event), Xen_to_C_guint(keyval));
  return(Xen_false);
}

static Xen gxg_gdk_event_get_key_is_modifier(Xen event, Xen ignore_is_modifier)
{
  #define H_gdk_event_get_key_is_modifier "gboolean gdk_event_get_key_is_modifier(GdkEvent* event, gboolean* [is_modifier])"
  gboolean ref_is_modifier;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_key_is_modifier", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_key_is_modifier(Xen_to_C_GdkEvent_(event), &ref_is_modifier));
    return(Xen_list_2(result, C_to_Xen_gboolean(ref_is_modifier)));
   }
}

static Xen gxg_gdk_event_get_key_group(Xen event, Xen ignore_group)
{
  #define H_gdk_event_get_key_group "gboolean gdk_event_get_key_group(GdkEvent* event, guint* [group])"
  guint ref_group;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_key_group", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_key_group(Xen_to_C_GdkEvent_(event), &ref_group));
    return(Xen_list_2(result, C_to_Xen_guint(ref_group)));
   }
}

static Xen gxg_gdk_event_get_string(Xen event, Xen ignore_string)
{
  #define H_gdk_event_get_string "gboolean gdk_event_get_string(GdkEvent* event, char** [string])"
  char* ref_string = NULL;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_string", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_string(Xen_to_C_GdkEvent_(event), (const char**)&ref_string));
    return(Xen_list_2(result, C_to_Xen_char_(ref_string)));
   }
}

static Xen gxg_gdk_event_get_setting(Xen event, Xen ignore_setting)
{
  #define H_gdk_event_get_setting "gboolean gdk_event_get_setting(GdkEvent* event, char** [setting])"
  char* ref_setting = NULL;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_setting", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_setting(Xen_to_C_GdkEvent_(event), (const char**)&ref_setting));
    return(Xen_list_2(result, C_to_Xen_char_(ref_setting)));
   }
}

static Xen gxg_gdk_event_is_sent(Xen event)
{
  #define H_gdk_event_is_sent "gboolean gdk_event_is_sent(GdkEvent* event)"
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_is_sent", "GdkEvent*");
  return(C_to_Xen_gboolean(gdk_event_is_sent(Xen_to_C_GdkEvent_(event))));
}

static Xen gxg_gdk_event_get_drag_context(Xen event, Xen ignore_context)
{
  #define H_gdk_event_get_drag_context "gboolean gdk_event_get_drag_context(GdkEvent* event, GdkDragContext** [context])"
  GdkDragContext* ref_context = NULL;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_drag_context", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_drag_context(Xen_to_C_GdkEvent_(event), &ref_context));
    return(Xen_list_2(result, C_to_Xen_GdkDragContext_(ref_context)));
   }
}

static Xen gxg_gdk_event_get_crossing_mode(Xen event, Xen ignore_mode)
{
  #define H_gdk_event_get_crossing_mode "gboolean gdk_event_get_crossing_mode(GdkEvent* event, GdkCrossingMode* [mode])"
  GdkCrossingMode ref_mode;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_crossing_mode", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_crossing_mode(Xen_to_C_GdkEvent_(event), &ref_mode));
    return(Xen_list_2(result, C_to_Xen_GdkCrossingMode(ref_mode)));
   }
}

static Xen gxg_gdk_event_get_crossing_detail(Xen event, Xen ignore_detail)
{
  #define H_gdk_event_get_crossing_detail "gboolean gdk_event_get_crossing_detail(GdkEvent* event, GdkNotifyType* [detail])"
  GdkNotifyType ref_detail;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_crossing_detail", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_crossing_detail(Xen_to_C_GdkEvent_(event), &ref_detail));
    return(Xen_list_2(result, C_to_Xen_GdkNotifyType(ref_detail)));
   }
}

static Xen gxg_gdk_event_get_touchpad_gesture_phase(Xen event, Xen ignore_phase)
{
  #define H_gdk_event_get_touchpad_gesture_phase "gboolean gdk_event_get_touchpad_gesture_phase(GdkEvent* event, \
GdkTouchpadGesturePhase* [phase])"
  GdkTouchpadGesturePhase ref_phase;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_touchpad_gesture_phase", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_touchpad_gesture_phase(Xen_to_C_GdkEvent_(event), &ref_phase));
    return(Xen_list_2(result, C_to_Xen_GdkTouchpadGesturePhase(ref_phase)));
   }
}

static Xen gxg_gdk_event_get_touchpad_gesture_n_fingers(Xen event, Xen ignore_n_fingers)
{
  #define H_gdk_event_get_touchpad_gesture_n_fingers "gboolean gdk_event_get_touchpad_gesture_n_fingers(GdkEvent* event, \
guint* [n_fingers])"
  guint ref_n_fingers;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_touchpad_gesture_n_fingers", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_touchpad_gesture_n_fingers(Xen_to_C_GdkEvent_(event), &ref_n_fingers));
    return(Xen_list_2(result, C_to_Xen_guint(ref_n_fingers)));
   }
}

static Xen gxg_gdk_event_get_touchpad_deltas(Xen event, Xen ignore_dx, Xen ignore_dy)
{
  #define H_gdk_event_get_touchpad_deltas "gboolean gdk_event_get_touchpad_deltas(GdkEvent* event, double* [dx], \
double* [dy])"
  double ref_dx;
  double ref_dy;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_touchpad_deltas", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_touchpad_deltas(Xen_to_C_GdkEvent_(event), &ref_dx, &ref_dy));
    return(Xen_list_3(result, C_to_Xen_double(ref_dx), C_to_Xen_double(ref_dy)));
   }
}

static Xen gxg_gdk_event_get_touchpad_angle_delta(Xen event, Xen ignore_delta)
{
  #define H_gdk_event_get_touchpad_angle_delta "gboolean gdk_event_get_touchpad_angle_delta(GdkEvent* event, \
double* [delta])"
  double ref_delta;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_touchpad_angle_delta", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_touchpad_angle_delta(Xen_to_C_GdkEvent_(event), &ref_delta));
    return(Xen_list_2(result, C_to_Xen_double(ref_delta)));
   }
}

static Xen gxg_gdk_event_get_touchpad_scale(Xen event, Xen ignore_scale)
{
  #define H_gdk_event_get_touchpad_scale "gboolean gdk_event_get_touchpad_scale(GdkEvent* event, double* [scale])"
  double ref_scale;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_touchpad_scale", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_touchpad_scale(Xen_to_C_GdkEvent_(event), &ref_scale));
    return(Xen_list_2(result, C_to_Xen_double(ref_scale)));
   }
}

static Xen gxg_gdk_event_get_touch_emulating_pointer(Xen event, Xen ignore_emulating)
{
  #define H_gdk_event_get_touch_emulating_pointer "gboolean gdk_event_get_touch_emulating_pointer(GdkEvent* event, \
gboolean* [emulating])"
  gboolean ref_emulating;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_touch_emulating_pointer", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_touch_emulating_pointer(Xen_to_C_GdkEvent_(event), &ref_emulating));
    return(Xen_list_2(result, C_to_Xen_gboolean(ref_emulating)));
   }
}

static Xen gxg_gdk_event_get_grab_window(Xen event, Xen ignore_window)
{
  #define H_gdk_event_get_grab_window "gboolean gdk_event_get_grab_window(GdkEvent* event, GdkWindow** [window])"
  GdkWindow* ref_window = NULL;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_grab_window", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_grab_window(Xen_to_C_GdkEvent_(event), &ref_window));
    return(Xen_list_2(result, C_to_Xen_GdkWindow_(ref_window)));
   }
}

static Xen gxg_gdk_event_get_focus_in(Xen event, Xen ignore_focus_in)
{
  #define H_gdk_event_get_focus_in "gboolean gdk_event_get_focus_in(GdkEvent* event, gboolean* [focus_in])"
  gboolean ref_focus_in;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_focus_in", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_focus_in(Xen_to_C_GdkEvent_(event), &ref_focus_in));
    return(Xen_list_2(result, C_to_Xen_gboolean(ref_focus_in)));
   }
}

static Xen gxg_gdk_event_get_pad_group_mode(Xen event, Xen ignore_group, Xen ignore_mode)
{
  #define H_gdk_event_get_pad_group_mode "gboolean gdk_event_get_pad_group_mode(GdkEvent* event, guint* [group], \
guint* [mode])"
  guint ref_group;
  guint ref_mode;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_pad_group_mode", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_pad_group_mode(Xen_to_C_GdkEvent_(event), &ref_group, &ref_mode));
    return(Xen_list_3(result, C_to_Xen_guint(ref_group), C_to_Xen_guint(ref_mode)));
   }
}

static Xen gxg_gdk_event_get_pad_button(Xen event, Xen ignore_button)
{
  #define H_gdk_event_get_pad_button "gboolean gdk_event_get_pad_button(GdkEvent* event, guint* [button])"
  guint ref_button;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_pad_button", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_pad_button(Xen_to_C_GdkEvent_(event), &ref_button));
    return(Xen_list_2(result, C_to_Xen_guint(ref_button)));
   }
}

static Xen gxg_gdk_event_get_pad_axis_value(Xen event, Xen ignore_index, Xen ignore_value)
{
  #define H_gdk_event_get_pad_axis_value "gboolean gdk_event_get_pad_axis_value(GdkEvent* event, guint* [index], \
gdouble* [value])"
  guint ref_index;
  gdouble ref_value;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_pad_axis_value", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_pad_axis_value(Xen_to_C_GdkEvent_(event), &ref_index, &ref_value));
    return(Xen_list_3(result, C_to_Xen_guint(ref_index), C_to_Xen_gdouble(ref_value)));
   }
}

static Xen gxg_gdk_event_get_axes(Xen event, Xen ignore_axes, Xen ignore_n_axes)
{
  #define H_gdk_event_get_axes "gboolean gdk_event_get_axes(GdkEvent* event, gdouble** [axes], guint* [n_axes])"
  gdouble* ref_axes = NULL;
  guint ref_n_axes;
  Xen_check_type(Xen_is_GdkEvent_(event), event, 1, "gdk_event_get_axes", "GdkEvent*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_event_get_axes(Xen_to_C_GdkEvent_(event), &ref_axes, &ref_n_axes));
    return(Xen_list_3(result, C_to_Xen_gdouble_(ref_axes), C_to_Xen_guint(ref_n_axes)));
   }
}

static Xen gxg_gtk_snapshot_push_blur(Xen snapshot, Xen radius, Xen name)
{
  #define H_gtk_snapshot_push_blur "void gtk_snapshot_push_blur(GtkSnapshot* snapshot, double radius, \
char* name)"
  Xen_check_type(Xen_is_GtkSnapshot_(snapshot), snapshot, 1, "gtk_snapshot_push_blur", "GtkSnapshot*");
  Xen_check_type(Xen_is_double(radius), radius, 2, "gtk_snapshot_push_blur", "double");
  Xen_check_type(Xen_is_char_(name), name, 3, "gtk_snapshot_push_blur", "char*");
  gtk_snapshot_push_blur(Xen_to_C_GtkSnapshot_(snapshot), Xen_to_C_double(radius), (const char*)Xen_to_C_char_(name));
  return(Xen_false);
}

static Xen gxg_gtk_emoji_chooser_new(void)
{
  #define H_gtk_emoji_chooser_new "GtkWidget* gtk_emoji_chooser_new( void)"
  return(C_to_Xen_GtkWidget_(gtk_emoji_chooser_new()));
}

static Xen gxg_gtk_event_controller_scroll_new(Xen widget, Xen flags)
{
  #define H_gtk_event_controller_scroll_new "GtkEventController* gtk_event_controller_scroll_new(GtkWidget* widget, \
GtkEventControllerScrollFlags flags)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_event_controller_scroll_new", "GtkWidget*");
  Xen_check_type(Xen_is_GtkEventControllerScrollFlags(flags), flags, 2, "gtk_event_controller_scroll_new", "GtkEventControllerScrollFlags");
  return(C_to_Xen_GtkEventController_(gtk_event_controller_scroll_new(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkEventControllerScrollFlags(flags))));
}

static Xen gxg_gtk_event_controller_scroll_set_flags(Xen controller, Xen flags)
{
  #define H_gtk_event_controller_scroll_set_flags "void gtk_event_controller_scroll_set_flags(GtkEventControllerScroll* controller, \
GtkEventControllerScrollFlags flags)"
  Xen_check_type(Xen_is_GtkEventControllerScroll_(controller), controller, 1, "gtk_event_controller_scroll_set_flags", "GtkEventControllerScroll*");
  Xen_check_type(Xen_is_GtkEventControllerScrollFlags(flags), flags, 2, "gtk_event_controller_scroll_set_flags", "GtkEventControllerScrollFlags");
  gtk_event_controller_scroll_set_flags(Xen_to_C_GtkEventControllerScroll_(controller), Xen_to_C_GtkEventControllerScrollFlags(flags));
  return(Xen_false);
}

static Xen gxg_gtk_event_controller_scroll_get_flags(Xen controller)
{
  #define H_gtk_event_controller_scroll_get_flags "GtkEventControllerScrollFlags gtk_event_controller_scroll_get_flags(GtkEventControllerScroll* controller)"
  Xen_check_type(Xen_is_GtkEventControllerScroll_(controller), controller, 1, "gtk_event_controller_scroll_get_flags", "GtkEventControllerScroll*");
  return(C_to_Xen_GtkEventControllerScrollFlags(gtk_event_controller_scroll_get_flags(Xen_to_C_GtkEventControllerScroll_(controller))));
}

static Xen gxg_gdk_app_launch_context_set_desktop(Xen context, Xen desktop)
{
  #define H_gdk_app_launch_context_set_desktop "void gdk_app_launch_context_set_desktop(GdkAppLaunchContext* context, \
gint desktop)"
  Xen_check_type(Xen_is_GdkAppLaunchContext_(context), context, 1, "gdk_app_launch_context_set_desktop", "GdkAppLaunchContext*");
  Xen_check_type(Xen_is_gint(desktop), desktop, 2, "gdk_app_launch_context_set_desktop", "gint");
  gdk_app_launch_context_set_desktop(Xen_to_C_GdkAppLaunchContext_(context), Xen_to_C_gint(desktop));
  return(Xen_false);
}

static Xen gxg_gdk_app_launch_context_set_timestamp(Xen context, Xen timestamp)
{
  #define H_gdk_app_launch_context_set_timestamp "void gdk_app_launch_context_set_timestamp(GdkAppLaunchContext* context, \
guint32 timestamp)"
  Xen_check_type(Xen_is_GdkAppLaunchContext_(context), context, 1, "gdk_app_launch_context_set_timestamp", "GdkAppLaunchContext*");
  Xen_check_type(Xen_is_guint32(timestamp), timestamp, 2, "gdk_app_launch_context_set_timestamp", "guint32");
  gdk_app_launch_context_set_timestamp(Xen_to_C_GdkAppLaunchContext_(context), Xen_to_C_guint32(timestamp));
  return(Xen_false);
}

static Xen gxg_gdk_app_launch_context_set_icon(Xen context, Xen icon)
{
  #define H_gdk_app_launch_context_set_icon "void gdk_app_launch_context_set_icon(GdkAppLaunchContext* context, \
GIcon* icon)"
  Xen_check_type(Xen_is_GdkAppLaunchContext_(context), context, 1, "gdk_app_launch_context_set_icon", "GdkAppLaunchContext*");
  Xen_check_type(Xen_is_GIcon_(icon), icon, 2, "gdk_app_launch_context_set_icon", "GIcon*");
  gdk_app_launch_context_set_icon(Xen_to_C_GdkAppLaunchContext_(context), Xen_to_C_GIcon_(icon));
  return(Xen_false);
}

static Xen gxg_gdk_app_launch_context_set_icon_name(Xen context, Xen icon_name)
{
  #define H_gdk_app_launch_context_set_icon_name "void gdk_app_launch_context_set_icon_name(GdkAppLaunchContext* context, \
char* icon_name)"
  Xen_check_type(Xen_is_GdkAppLaunchContext_(context), context, 1, "gdk_app_launch_context_set_icon_name", "GdkAppLaunchContext*");
  Xen_check_type(Xen_is_char_(icon_name), icon_name, 2, "gdk_app_launch_context_set_icon_name", "char*");
  gdk_app_launch_context_set_icon_name(Xen_to_C_GdkAppLaunchContext_(context), (const char*)Xen_to_C_char_(icon_name));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_get_display(Xen clipboard)
{
  #define H_gdk_clipboard_get_display "GdkDisplay* gdk_clipboard_get_display(GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_get_display", "GdkClipboard*");
  return(C_to_Xen_GdkDisplay_(gdk_clipboard_get_display(Xen_to_C_GdkClipboard_(clipboard))));
}

static Xen gxg_gdk_clipboard_get_formats(Xen clipboard)
{
  #define H_gdk_clipboard_get_formats "GdkContentFormats* gdk_clipboard_get_formats(GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_get_formats", "GdkClipboard*");
  return(C_to_Xen_GdkContentFormats_(gdk_clipboard_get_formats(Xen_to_C_GdkClipboard_(clipboard))));
}

static Xen gxg_gdk_clipboard_is_local(Xen clipboard)
{
  #define H_gdk_clipboard_is_local "gboolean gdk_clipboard_is_local(GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_is_local", "GdkClipboard*");
  return(C_to_Xen_gboolean(gdk_clipboard_is_local(Xen_to_C_GdkClipboard_(clipboard))));
}

static Xen gxg_gdk_clipboard_get_content(Xen clipboard)
{
  #define H_gdk_clipboard_get_content "GdkContentProvider* gdk_clipboard_get_content(GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_get_content", "GdkClipboard*");
  return(C_to_Xen_GdkContentProvider_(gdk_clipboard_get_content(Xen_to_C_GdkClipboard_(clipboard))));
}

static Xen gxg_gdk_clipboard_store_async(Xen clipboard, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_clipboard_store_async "void gdk_clipboard_store_async(GdkClipboard* clipboard, int io_priority, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_store_async", "GdkClipboard*");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 2, "gdk_clipboard_store_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 3, "gdk_clipboard_store_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 4, "gdk_clipboard_store_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 5, "gdk_clipboard_store_async", "gpointer");
  gdk_clipboard_store_async(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_int(io_priority), Xen_to_C_GCancellable_(cancellable), 
                            Xen_to_C_GAsyncReadyCallback(callback), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_store_finish(Xen clipboard, Xen result, Xen ignore_error)
{
  #define H_gdk_clipboard_store_finish "gboolean gdk_clipboard_store_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_store_finish", "GdkClipboard*");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 2, "gdk_clipboard_store_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_clipboard_store_finish(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GAsyncResult_(result), 
                                                          &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_clipboard_read_async(Xen clipboard, Xen mime_types, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_clipboard_read_async "void gdk_clipboard_read_async(GdkClipboard* clipboard, char** mime_types, \
int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_async", "GdkClipboard*");
  Xen_check_type(Xen_is_char__(mime_types), mime_types, 2, "gdk_clipboard_read_async", "char**");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 3, "gdk_clipboard_read_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 4, "gdk_clipboard_read_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 5, "gdk_clipboard_read_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 6, "gdk_clipboard_read_async", "gpointer");
  gdk_clipboard_read_async(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_char__(mime_types), Xen_to_C_int(io_priority), Xen_to_C_GCancellable_(cancellable), 
                           Xen_to_C_GAsyncReadyCallback(callback), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_read_finish(Xen clipboard, Xen out_mime_type, Xen result, Xen ignore_error)
{
  #define H_gdk_clipboard_read_finish "GInputStream* gdk_clipboard_read_finish(GdkClipboard* clipboard, \
har** out_mime_type, GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_finish", "GdkClipboard*");
  Xen_check_type(Xen_is_har__(out_mime_type), out_mime_type, 2, "gdk_clipboard_read_finish", "har**");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 3, "gdk_clipboard_read_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_GInputStream_(gdk_clipboard_read_finish(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_har__(out_mime_type), 
                                                              Xen_to_C_GAsyncResult_(result), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_clipboard_read_value_async(Xen clipboard, Xen type, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_clipboard_read_value_async "void gdk_clipboard_read_value_async(GdkClipboard* clipboard, \
GType type, int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_value_async", "GdkClipboard*");
  Xen_check_type(Xen_is_GType(type), type, 2, "gdk_clipboard_read_value_async", "GType");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 3, "gdk_clipboard_read_value_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 4, "gdk_clipboard_read_value_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 5, "gdk_clipboard_read_value_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 6, "gdk_clipboard_read_value_async", "gpointer");
  gdk_clipboard_read_value_async(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GType(type), Xen_to_C_int(io_priority), Xen_to_C_GCancellable_(cancellable), 
                                 Xen_to_C_GAsyncReadyCallback(callback), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_read_value_finish(Xen clipboard, Xen result, Xen ignore_error)
{
  #define H_gdk_clipboard_read_value_finish "GValue* gdk_clipboard_read_value_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_value_finish", "GdkClipboard*");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 2, "gdk_clipboard_read_value_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_GValue_(gdk_clipboard_read_value_finish(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GAsyncResult_(result), 
                                                              &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_clipboard_read_texture_async(Xen clipboard, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_clipboard_read_texture_async "void gdk_clipboard_read_texture_async(GdkClipboard* clipboard, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_texture_async", "GdkClipboard*");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 2, "gdk_clipboard_read_texture_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 3, "gdk_clipboard_read_texture_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 4, "gdk_clipboard_read_texture_async", "gpointer");
  gdk_clipboard_read_texture_async(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GCancellable_(cancellable), Xen_to_C_GAsyncReadyCallback(callback), 
                                   Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_read_texture_finish(Xen clipboard, Xen result, Xen ignore_error)
{
  #define H_gdk_clipboard_read_texture_finish "GdkTexture* gdk_clipboard_read_texture_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_texture_finish", "GdkClipboard*");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 2, "gdk_clipboard_read_texture_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_GdkTexture_(gdk_clipboard_read_texture_finish(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GAsyncResult_(result), 
                                                                    &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_clipboard_read_text_async(Xen clipboard, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_clipboard_read_text_async "void gdk_clipboard_read_text_async(GdkClipboard* clipboard, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_text_async", "GdkClipboard*");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 2, "gdk_clipboard_read_text_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 3, "gdk_clipboard_read_text_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 4, "gdk_clipboard_read_text_async", "gpointer");
  gdk_clipboard_read_text_async(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GCancellable_(cancellable), Xen_to_C_GAsyncReadyCallback(callback), 
                                Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_read_text_finish(Xen clipboard, Xen result, Xen ignore_error)
{
  #define H_gdk_clipboard_read_text_finish "char* gdk_clipboard_read_text_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_read_text_finish", "GdkClipboard*");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 2, "gdk_clipboard_read_text_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_char_(gdk_clipboard_read_text_finish(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GAsyncResult_(result), 
                                                           &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_clipboard_set_content(Xen clipboard, Xen provider)
{
  #define H_gdk_clipboard_set_content "gboolean gdk_clipboard_set_content(GdkClipboard* clipboard, GdkContentProvider* provider)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_set_content", "GdkClipboard*");
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 2, "gdk_clipboard_set_content", "GdkContentProvider*");
  return(C_to_Xen_gboolean(gdk_clipboard_set_content(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GdkContentProvider_(provider))));
}

static Xen gxg_gdk_clipboard_set(Xen clipboard, Xen type)
{
  #define H_gdk_clipboard_set "void gdk_clipboard_set(GdkClipboard* clipboard, GType type, ...)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_set", "GdkClipboard*");
  Xen_check_type(Xen_is_GType(type), type, 2, "gdk_clipboard_set", "GType");
  gdk_clipboard_set(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GType(type));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_set_value(Xen clipboard, Xen value)
{
  #define H_gdk_clipboard_set_value "void gdk_clipboard_set_value(GdkClipboard* clipboard, GValue* value)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_set_value", "GdkClipboard*");
  Xen_check_type(Xen_is_GValue_(value), value, 2, "gdk_clipboard_set_value", "GValue*");
  gdk_clipboard_set_value(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GValue_(value));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_set_text(Xen clipboard, Xen text)
{
  #define H_gdk_clipboard_set_text "void gdk_clipboard_set_text(GdkClipboard* clipboard, char* text)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_set_text", "GdkClipboard*");
  Xen_check_type(Xen_is_char_(text), text, 2, "gdk_clipboard_set_text", "char*");
  gdk_clipboard_set_text(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_char_(text));
  return(Xen_false);
}

static Xen gxg_gdk_clipboard_set_texture(Xen clipboard, Xen texture)
{
  #define H_gdk_clipboard_set_texture "void gdk_clipboard_set_texture(GdkClipboard* clipboard, GdkTexture* texture)"
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 1, "gdk_clipboard_set_texture", "GdkClipboard*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 2, "gdk_clipboard_set_texture", "GdkTexture*");
  gdk_clipboard_set_texture(Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_GdkTexture_(texture));
  return(Xen_false);
}

static Xen gxg_gdk_intern_mime_type(Xen string)
{
  #define H_gdk_intern_mime_type "char* gdk_intern_mime_type(char* string)"
  Xen_check_type(Xen_is_char_(string), string, 1, "gdk_intern_mime_type", "char*");
  return(C_to_Xen_char_(gdk_intern_mime_type((const char*)Xen_to_C_char_(string))));
}

static Xen gxg_gdk_content_formats_new(Xen mime_types, Xen n_mime_types)
{
  #define H_gdk_content_formats_new "GdkContentFormats* gdk_content_formats_new(char** mime_types, guint n_mime_types)"
  Xen_check_type(Xen_is_char__(mime_types), mime_types, 1, "gdk_content_formats_new", "char**");
  Xen_check_type(Xen_is_guint(n_mime_types), n_mime_types, 2, "gdk_content_formats_new", "guint");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_new(Xen_to_C_char__(mime_types), Xen_to_C_guint(n_mime_types))));
}

static Xen gxg_gdk_content_formats_new_for_gtype(Xen type)
{
  #define H_gdk_content_formats_new_for_gtype "GdkContentFormats* gdk_content_formats_new_for_gtype(GType type)"
  Xen_check_type(Xen_is_GType(type), type, 1, "gdk_content_formats_new_for_gtype", "GType");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_new_for_gtype(Xen_to_C_GType(type))));
}

static Xen gxg_gdk_content_formats_ref(Xen formats)
{
  #define H_gdk_content_formats_ref "GdkContentFormats* gdk_content_formats_ref(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_ref", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_ref(Xen_to_C_GdkContentFormats_(formats))));
}

static Xen gxg_gdk_content_formats_unref(Xen formats)
{
  #define H_gdk_content_formats_unref "void gdk_content_formats_unref(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_unref", "GdkContentFormats*");
  gdk_content_formats_unref(Xen_to_C_GdkContentFormats_(formats));
  return(Xen_false);
}

static Xen gxg_gdk_content_formats_print(Xen formats, Xen string)
{
  #define H_gdk_content_formats_print "void gdk_content_formats_print(GdkContentFormats* formats, GString* string)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_print", "GdkContentFormats*");
  Xen_check_type(Xen_is_GString_(string), string, 2, "gdk_content_formats_print", "GString*");
  gdk_content_formats_print(Xen_to_C_GdkContentFormats_(formats), Xen_to_C_GString_(string));
  return(Xen_false);
}

static Xen gxg_gdk_content_formats_to_string(Xen formats)
{
  #define H_gdk_content_formats_to_string "char* gdk_content_formats_to_string(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_to_string", "GdkContentFormats*");
  return(C_to_Xen_char_(gdk_content_formats_to_string(Xen_to_C_GdkContentFormats_(formats))));
}

static Xen gxg_gdk_content_formats_get_gtypes(Xen formats, Xen ignore_n_gtypes)
{
  #define H_gdk_content_formats_get_gtypes "GType* gdk_content_formats_get_gtypes(GdkContentFormats* formats, \
gsize* [n_gtypes])"
  gsize ref_n_gtypes;
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_get_gtypes", "GdkContentFormats*");
  {
    Xen result;
    result = C_to_Xen_GType_(gdk_content_formats_get_gtypes(Xen_to_C_GdkContentFormats_(formats), &ref_n_gtypes));
    return(Xen_list_2(result, C_to_Xen_gsize(ref_n_gtypes)));
   }
}

static Xen gxg_gdk_content_formats_get_mime_types(Xen formats, Xen ignore_n_mime_types)
{
  #define H_gdk_content_formats_get_mime_types "char* gdk_content_formats_get_mime_types(GdkContentFormats* formats, \
gsize* [n_mime_types])"
  gsize ref_n_mime_types;
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_get_mime_types", "GdkContentFormats*");
  {
    Xen result;
    result = C_to_Xen_char_(gdk_content_formats_get_mime_types(Xen_to_C_GdkContentFormats_(formats), &ref_n_mime_types));
    return(Xen_list_2(result, C_to_Xen_gsize(ref_n_mime_types)));
   }
}

static Xen gxg_gdk_content_formats_union(Xen first, Xen second)
{
  #define H_gdk_content_formats_union "GdkContentFormats* gdk_content_formats_union(GdkContentFormats* first, \
GdkContentFormats* second)"
  Xen_check_type(Xen_is_GdkContentFormats_(first), first, 1, "gdk_content_formats_union", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkContentFormats_(second), second, 2, "gdk_content_formats_union", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_union(Xen_to_C_GdkContentFormats_(first), Xen_to_C_GdkContentFormats_(second))));
}

static Xen gxg_gdk_content_formats_match(Xen first, Xen second)
{
  #define H_gdk_content_formats_match "gboolean gdk_content_formats_match(GdkContentFormats* first, GdkContentFormats* second)"
  Xen_check_type(Xen_is_GdkContentFormats_(first), first, 1, "gdk_content_formats_match", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkContentFormats_(second), second, 2, "gdk_content_formats_match", "GdkContentFormats*");
  return(C_to_Xen_gboolean(gdk_content_formats_match(Xen_to_C_GdkContentFormats_(first), Xen_to_C_GdkContentFormats_(second))));
}

static Xen gxg_gdk_content_formats_match_gtype(Xen first, Xen second)
{
  #define H_gdk_content_formats_match_gtype "GType gdk_content_formats_match_gtype(GdkContentFormats* first, \
GdkContentFormats* second)"
  Xen_check_type(Xen_is_GdkContentFormats_(first), first, 1, "gdk_content_formats_match_gtype", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkContentFormats_(second), second, 2, "gdk_content_formats_match_gtype", "GdkContentFormats*");
  return(C_to_Xen_GType(gdk_content_formats_match_gtype(Xen_to_C_GdkContentFormats_(first), Xen_to_C_GdkContentFormats_(second))));
}

static Xen gxg_gdk_content_formats_match_mime_type(Xen first, Xen second)
{
  #define H_gdk_content_formats_match_mime_type "char* gdk_content_formats_match_mime_type(GdkContentFormats* first, \
GdkContentFormats* second)"
  Xen_check_type(Xen_is_GdkContentFormats_(first), first, 1, "gdk_content_formats_match_mime_type", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkContentFormats_(second), second, 2, "gdk_content_formats_match_mime_type", "GdkContentFormats*");
    return(C_to_Xen_char_((char*)gdk_content_formats_match_mime_type(Xen_to_C_GdkContentFormats_(first), Xen_to_C_GdkContentFormats_(second))));
}

static Xen gxg_gdk_content_formats_contain_gtype(Xen formats, Xen type)
{
  #define H_gdk_content_formats_contain_gtype "gboolean gdk_content_formats_contain_gtype(GdkContentFormats* formats, \
GType type)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_contain_gtype", "GdkContentFormats*");
  Xen_check_type(Xen_is_GType(type), type, 2, "gdk_content_formats_contain_gtype", "GType");
  return(C_to_Xen_gboolean(gdk_content_formats_contain_gtype(Xen_to_C_GdkContentFormats_(formats), Xen_to_C_GType(type))));
}

static Xen gxg_gdk_content_formats_contain_mime_type(Xen formats, Xen mime_type)
{
  #define H_gdk_content_formats_contain_mime_type "gboolean gdk_content_formats_contain_mime_type(GdkContentFormats* formats, \
char* mime_type)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_contain_mime_type", "GdkContentFormats*");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "gdk_content_formats_contain_mime_type", "char*");
  return(C_to_Xen_gboolean(gdk_content_formats_contain_mime_type(Xen_to_C_GdkContentFormats_(formats), (const char*)Xen_to_C_char_(mime_type))));
}

static Xen gxg_*gdk_content_formats_builder_new(void)
{
  #define H_*gdk_content_formats_builder_new "GdkContentFormatsBuilder *gdk_content_formats_builder_new( void)"
  return(C_to_Xen_GdkContentFormatsBuilder(*gdk_content_formats_builder_new()));
}

static Xen gxg_gdk_content_formats_builder_free(Xen builder)
{
  #define H_gdk_content_formats_builder_free "GdkContentFormats* gdk_content_formats_builder_free(GdkContentFormatsBuilder* builder)"
  Xen_check_type(Xen_is_GdkContentFormatsBuilder_(builder), builder, 1, "gdk_content_formats_builder_free", "GdkContentFormatsBuilder*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_builder_free(Xen_to_C_GdkContentFormatsBuilder_(builder))));
}

static Xen gxg_gdk_content_formats_builder_add_formats(Xen builder, Xen formats)
{
  #define H_gdk_content_formats_builder_add_formats "void gdk_content_formats_builder_add_formats(GdkContentFormatsBuilder* builder, \
GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormatsBuilder_(builder), builder, 1, "gdk_content_formats_builder_add_formats", "GdkContentFormatsBuilder*");
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 2, "gdk_content_formats_builder_add_formats", "GdkContentFormats*");
  gdk_content_formats_builder_add_formats(Xen_to_C_GdkContentFormatsBuilder_(builder), Xen_to_C_GdkContentFormats_(formats));
  return(Xen_false);
}

static Xen gxg_gdk_content_formats_builder_add_mime_type(Xen builder, Xen mime_type)
{
  #define H_gdk_content_formats_builder_add_mime_type "void gdk_content_formats_builder_add_mime_type(GdkContentFormatsBuilder* builder, \
char* mime_type)"
  Xen_check_type(Xen_is_GdkContentFormatsBuilder_(builder), builder, 1, "gdk_content_formats_builder_add_mime_type", "GdkContentFormatsBuilder*");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "gdk_content_formats_builder_add_mime_type", "char*");
  gdk_content_formats_builder_add_mime_type(Xen_to_C_GdkContentFormatsBuilder_(builder), (const char*)Xen_to_C_char_(mime_type));
  return(Xen_false);
}

static Xen gxg_gdk_content_formats_builder_add_gtype(Xen builder, Xen type)
{
  #define H_gdk_content_formats_builder_add_gtype "void gdk_content_formats_builder_add_gtype(GdkContentFormatsBuilder* builder, \
GType type)"
  Xen_check_type(Xen_is_GdkContentFormatsBuilder_(builder), builder, 1, "gdk_content_formats_builder_add_gtype", "GdkContentFormatsBuilder*");
  Xen_check_type(Xen_is_GType(type), type, 2, "gdk_content_formats_builder_add_gtype", "GType");
  gdk_content_formats_builder_add_gtype(Xen_to_C_GdkContentFormatsBuilder_(builder), Xen_to_C_GType(type));
  return(Xen_false);
}

static Xen gxg_gdk_content_provider_ref_formats(Xen provider)
{
  #define H_gdk_content_provider_ref_formats "GdkContentFormats* gdk_content_provider_ref_formats(GdkContentProvider* provider)"
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 1, "gdk_content_provider_ref_formats", "GdkContentProvider*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_provider_ref_formats(Xen_to_C_GdkContentProvider_(provider))));
}

static Xen gxg_gdk_content_provider_ref_storable_formats(Xen provider)
{
  #define H_gdk_content_provider_ref_storable_formats "GdkContentFormats* gdk_content_provider_ref_storable_formats(GdkContentProvider* provider)"
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 1, "gdk_content_provider_ref_storable_formats", "GdkContentProvider*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_provider_ref_storable_formats(Xen_to_C_GdkContentProvider_(provider))));
}

static Xen gxg_gdk_content_provider_content_changed(Xen provider)
{
  #define H_gdk_content_provider_content_changed "void gdk_content_provider_content_changed(GdkContentProvider* provider)"
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 1, "gdk_content_provider_content_changed", "GdkContentProvider*");
  gdk_content_provider_content_changed(Xen_to_C_GdkContentProvider_(provider));
  return(Xen_false);
}

static Xen gxg_gdk_content_provider_write_mime_type_async(Xen provider, Xen mime_type, Xen stream, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_content_provider_write_mime_type_async "void gdk_content_provider_write_mime_type_async(GdkContentProvider* provider, \
char* mime_type, GOutputStream* stream, int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, \
gpointer user_data)"
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 1, "gdk_content_provider_write_mime_type_async", "GdkContentProvider*");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "gdk_content_provider_write_mime_type_async", "char*");
  Xen_check_type(Xen_is_GOutputStream_(stream), stream, 3, "gdk_content_provider_write_mime_type_async", "GOutputStream*");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 4, "gdk_content_provider_write_mime_type_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 5, "gdk_content_provider_write_mime_type_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 6, "gdk_content_provider_write_mime_type_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 7, "gdk_content_provider_write_mime_type_async", "gpointer");
  gdk_content_provider_write_mime_type_async(Xen_to_C_GdkContentProvider_(provider), (const char*)Xen_to_C_char_(mime_type), Xen_to_C_GOutputStream_(stream), 
                                             Xen_to_C_int(io_priority), Xen_to_C_GCancellable_(cancellable), Xen_to_C_GAsyncReadyCallback(callback), 
                                             Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_content_provider_write_mime_type_finish(Xen provider, Xen result, Xen ignore_error)
{
  #define H_gdk_content_provider_write_mime_type_finish "gboolean gdk_content_provider_write_mime_type_finish(GdkContentProvider* provider, \
GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 1, "gdk_content_provider_write_mime_type_finish", "GdkContentProvider*");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 2, "gdk_content_provider_write_mime_type_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_content_provider_write_mime_type_finish(Xen_to_C_GdkContentProvider_(provider), Xen_to_C_GAsyncResult_(result), 
                                                                           &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_content_provider_get_value(Xen provider, Xen value, Xen ignore_error)
{
  #define H_gdk_content_provider_get_value "gboolean gdk_content_provider_get_value(GdkContentProvider* provider, \
GValue* value, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkContentProvider_(provider), provider, 1, "gdk_content_provider_get_value", "GdkContentProvider*");
  Xen_check_type(Xen_is_GValue_(value), value, 2, "gdk_content_provider_get_value", "GValue*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_content_provider_get_value(Xen_to_C_GdkContentProvider_(provider), Xen_to_C_GValue_(value), 
                                                              &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_content_serializer_get_mime_type(Xen serializer)
{
  #define H_gdk_content_serializer_get_mime_type "char* gdk_content_serializer_get_mime_type(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_mime_type", "GdkContentSerializer*");
    return(C_to_Xen_char_((char*)gdk_content_serializer_get_mime_type(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_get_value(Xen serializer)
{
  #define H_gdk_content_serializer_get_value "GValue* gdk_content_serializer_get_value(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_value", "GdkContentSerializer*");
    return(C_to_Xen_GValue_((GValue*)gdk_content_serializer_get_value(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_get_output_stream(Xen serializer)
{
  #define H_gdk_content_serializer_get_output_stream "GOutputStream* gdk_content_serializer_get_output_stream(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_output_stream", "GdkContentSerializer*");
  return(C_to_Xen_GOutputStream_(gdk_content_serializer_get_output_stream(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_get_priority(Xen serializer)
{
  #define H_gdk_content_serializer_get_priority "int gdk_content_serializer_get_priority(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_priority", "GdkContentSerializer*");
  return(C_to_Xen_int(gdk_content_serializer_get_priority(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_get_cancellable(Xen serializer)
{
  #define H_gdk_content_serializer_get_cancellable "GCancellable* gdk_content_serializer_get_cancellable(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_cancellable", "GdkContentSerializer*");
  return(C_to_Xen_GCancellable_(gdk_content_serializer_get_cancellable(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_get_user_data(Xen serializer)
{
  #define H_gdk_content_serializer_get_user_data "gpointer gdk_content_serializer_get_user_data(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_user_data", "GdkContentSerializer*");
  return(C_to_Xen_gpointer(gdk_content_serializer_get_user_data(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_set_task_data(Xen serializer, Xen data, Xen notify)
{
  #define H_gdk_content_serializer_set_task_data "void gdk_content_serializer_set_task_data(GdkContentSerializer* serializer, \
gpointer data, GDestroyNotify notify)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_set_task_data", "GdkContentSerializer*");
  Xen_check_type(Xen_is_gpointer(data), data, 2, "gdk_content_serializer_set_task_data", "gpointer");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 3, "gdk_content_serializer_set_task_data", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gdk_content_serializer_set_task_data(Xen_to_C_GdkContentSerializer_(serializer), Xen_to_C_gpointer(data), Xen_to_C_GDestroyNotify(notify));
    return(Xen_false);
   }
}

static Xen gxg_gdk_content_serializer_get_task_data(Xen serializer)
{
  #define H_gdk_content_serializer_get_task_data "gpointer gdk_content_serializer_get_task_data(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_get_task_data", "GdkContentSerializer*");
  return(C_to_Xen_gpointer(gdk_content_serializer_get_task_data(Xen_to_C_GdkContentSerializer_(serializer))));
}

static Xen gxg_gdk_content_serializer_return_success(Xen serializer)
{
  #define H_gdk_content_serializer_return_success "void gdk_content_serializer_return_success(GdkContentSerializer* serializer)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_return_success", "GdkContentSerializer*");
  gdk_content_serializer_return_success(Xen_to_C_GdkContentSerializer_(serializer));
  return(Xen_false);
}

static Xen gxg_gdk_content_serializer_return_error(Xen serializer, Xen error)
{
  #define H_gdk_content_serializer_return_error "void gdk_content_serializer_return_error(GdkContentSerializer* serializer, \
GError* error)"
  Xen_check_type(Xen_is_GdkContentSerializer_(serializer), serializer, 1, "gdk_content_serializer_return_error", "GdkContentSerializer*");
  Xen_check_type(Xen_is_GError_(error), error, 2, "gdk_content_serializer_return_error", "GError*");
  gdk_content_serializer_return_error(Xen_to_C_GdkContentSerializer_(serializer), Xen_to_C_GError_(error));
  return(Xen_false);
}

static Xen gxg_gdk_content_formats_union_serialize_gtypes(Xen formats)
{
  #define H_gdk_content_formats_union_serialize_gtypes "GdkContentFormats* gdk_content_formats_union_serialize_gtypes(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_union_serialize_gtypes", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_union_serialize_gtypes(Xen_to_C_GdkContentFormats_(formats))));
}

static Xen gxg_gdk_content_formats_union_serialize_mime_types(Xen formats)
{
  #define H_gdk_content_formats_union_serialize_mime_types "GdkContentFormats* gdk_content_formats_union_serialize_mime_types(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_union_serialize_mime_types", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_union_serialize_mime_types(Xen_to_C_GdkContentFormats_(formats))));
}

static Xen gxg_gdk_content_register_serializer(Xen type, Xen mime_type, Xen serialize, Xen data, Xen notify)
{
  #define H_gdk_content_register_serializer "void gdk_content_register_serializer(GType type, char* mime_type, \
GdkContentSerializeFunc serialize, gpointer data, GDestroyNotify notify)"
  Xen_check_type(Xen_is_GType(type), type, 1, "gdk_content_register_serializer", "GType");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "gdk_content_register_serializer", "char*");
  Xen_check_type(Xen_is_GdkContentSerializeFunc(serialize), serialize, 3, "gdk_content_register_serializer", "GdkContentSerializeFunc");
  Xen_check_type(Xen_is_gpointer(data), data, 4, "gdk_content_register_serializer", "gpointer");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 5, "gdk_content_register_serializer", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gdk_content_register_serializer(Xen_to_C_GType(type), (const char*)Xen_to_C_char_(mime_type), Xen_to_C_GdkContentSerializeFunc(serialize), 
                                Xen_to_C_gpointer(data), Xen_to_C_GDestroyNotify(notify));
    return(Xen_false);
   }
}

static Xen gxg_gdk_content_serialize_async(Xen stream, Xen mime_type, Xen value, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_content_serialize_async "void gdk_content_serialize_async(GOutputStream* stream, char* mime_type, \
GValue* value, int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GOutputStream_(stream), stream, 1, "gdk_content_serialize_async", "GOutputStream*");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "gdk_content_serialize_async", "char*");
  Xen_check_type(Xen_is_GValue_(value), value, 3, "gdk_content_serialize_async", "GValue*");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 4, "gdk_content_serialize_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 5, "gdk_content_serialize_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 6, "gdk_content_serialize_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 7, "gdk_content_serialize_async", "gpointer");
  gdk_content_serialize_async(Xen_to_C_GOutputStream_(stream), (const char*)Xen_to_C_char_(mime_type), (const GValue*)Xen_to_C_GValue_(value), Xen_to_C_int(io_priority), 
                              Xen_to_C_GCancellable_(cancellable), Xen_to_C_GAsyncReadyCallback(callback), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_content_serialize_finish(Xen result, Xen ignore_error)
{
  #define H_gdk_content_serialize_finish "gboolean gdk_content_serialize_finish(GAsyncResult* result, \
GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 1, "gdk_content_serialize_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_content_serialize_finish(Xen_to_C_GAsyncResult_(result), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_content_deserializer_get_mime_type(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_mime_type "char* gdk_content_deserializer_get_mime_type(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_mime_type", "GdkContentDeserializer*");
    return(C_to_Xen_char_((char*)gdk_content_deserializer_get_mime_type(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_get_value(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_value "GValue* gdk_content_deserializer_get_value(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_value", "GdkContentDeserializer*");
  return(C_to_Xen_GValue_(gdk_content_deserializer_get_value(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_get_input_stream(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_input_stream "GInputStream* gdk_content_deserializer_get_input_stream(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_input_stream", "GdkContentDeserializer*");
  return(C_to_Xen_GInputStream_(gdk_content_deserializer_get_input_stream(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_get_priority(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_priority "int gdk_content_deserializer_get_priority(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_priority", "GdkContentDeserializer*");
  return(C_to_Xen_int(gdk_content_deserializer_get_priority(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_get_cancellable(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_cancellable "GCancellable* gdk_content_deserializer_get_cancellable(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_cancellable", "GdkContentDeserializer*");
  return(C_to_Xen_GCancellable_(gdk_content_deserializer_get_cancellable(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_get_user_data(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_user_data "gpointer gdk_content_deserializer_get_user_data(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_user_data", "GdkContentDeserializer*");
  return(C_to_Xen_gpointer(gdk_content_deserializer_get_user_data(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_set_task_data(Xen deserializer, Xen data, Xen notify)
{
  #define H_gdk_content_deserializer_set_task_data "void gdk_content_deserializer_set_task_data(GdkContentDeserializer* deserializer, \
gpointer data, GDestroyNotify notify)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_set_task_data", "GdkContentDeserializer*");
  Xen_check_type(Xen_is_gpointer(data), data, 2, "gdk_content_deserializer_set_task_data", "gpointer");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 3, "gdk_content_deserializer_set_task_data", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gdk_content_deserializer_set_task_data(Xen_to_C_GdkContentDeserializer_(deserializer), Xen_to_C_gpointer(data), Xen_to_C_GDestroyNotify(notify));
    return(Xen_false);
   }
}

static Xen gxg_gdk_content_deserializer_get_task_data(Xen deserializer)
{
  #define H_gdk_content_deserializer_get_task_data "gpointer gdk_content_deserializer_get_task_data(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_get_task_data", "GdkContentDeserializer*");
  return(C_to_Xen_gpointer(gdk_content_deserializer_get_task_data(Xen_to_C_GdkContentDeserializer_(deserializer))));
}

static Xen gxg_gdk_content_deserializer_return_success(Xen deserializer)
{
  #define H_gdk_content_deserializer_return_success "void gdk_content_deserializer_return_success(GdkContentDeserializer* deserializer)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_return_success", "GdkContentDeserializer*");
  gdk_content_deserializer_return_success(Xen_to_C_GdkContentDeserializer_(deserializer));
  return(Xen_false);
}

static Xen gxg_gdk_content_deserializer_return_error(Xen deserializer, Xen error)
{
  #define H_gdk_content_deserializer_return_error "void gdk_content_deserializer_return_error(GdkContentDeserializer* deserializer, \
GError* error)"
  Xen_check_type(Xen_is_GdkContentDeserializer_(deserializer), deserializer, 1, "gdk_content_deserializer_return_error", "GdkContentDeserializer*");
  Xen_check_type(Xen_is_GError_(error), error, 2, "gdk_content_deserializer_return_error", "GError*");
  gdk_content_deserializer_return_error(Xen_to_C_GdkContentDeserializer_(deserializer), Xen_to_C_GError_(error));
  return(Xen_false);
}

static Xen gxg_gdk_content_formats_union_deserialize_gtypes(Xen formats)
{
  #define H_gdk_content_formats_union_deserialize_gtypes "GdkContentFormats* gdk_content_formats_union_deserialize_gtypes(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_union_deserialize_gtypes", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_union_deserialize_gtypes(Xen_to_C_GdkContentFormats_(formats))));
}

static Xen gxg_gdk_content_formats_union_deserialize_mime_types(Xen formats)
{
  #define H_gdk_content_formats_union_deserialize_mime_types "GdkContentFormats* gdk_content_formats_union_deserialize_mime_types(GdkContentFormats* formats)"
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 1, "gdk_content_formats_union_deserialize_mime_types", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gdk_content_formats_union_deserialize_mime_types(Xen_to_C_GdkContentFormats_(formats))));
}

static Xen gxg_gdk_content_register_deserializer(Xen mime_type, Xen type, Xen deserialize, Xen data, Xen notify)
{
  #define H_gdk_content_register_deserializer "void gdk_content_register_deserializer(char* mime_type, \
GType type, GdkContentDeserializeFunc deserialize, gpointer data, GDestroyNotify notify)"
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 1, "gdk_content_register_deserializer", "char*");
  Xen_check_type(Xen_is_GType(type), type, 2, "gdk_content_register_deserializer", "GType");
  Xen_check_type(Xen_is_GdkContentDeserializeFunc(deserialize), deserialize, 3, "gdk_content_register_deserializer", "GdkContentDeserializeFunc");
  Xen_check_type(Xen_is_gpointer(data), data, 4, "gdk_content_register_deserializer", "gpointer");
  Xen_check_type(Xen_is_GDestroyNotify(notify), notify, 5, "gdk_content_register_deserializer", "GDestroyNotify");
  {
    Xen gxg_ptr = Xen_list_5(Xen_false, func_info, Xen_false, Xen_false, Xen_false);
    xm_protect(gxg_ptr);
    gdk_content_register_deserializer(Xen_to_C_char_(mime_type), Xen_to_C_GType(type), Xen_to_C_GdkContentDeserializeFunc(deserialize), 
                                  Xen_to_C_gpointer(data), Xen_to_C_GDestroyNotify(notify));
    return(Xen_false);
   }
}

static Xen gxg_gdk_content_deserialize_async(Xen stream, Xen mime_type, Xen type, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_content_deserialize_async "void gdk_content_deserialize_async(GInputStream* stream, char* mime_type, \
GType type, int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GInputStream_(stream), stream, 1, "gdk_content_deserialize_async", "GInputStream*");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "gdk_content_deserialize_async", "char*");
  Xen_check_type(Xen_is_GType(type), type, 3, "gdk_content_deserialize_async", "GType");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 4, "gdk_content_deserialize_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 5, "gdk_content_deserialize_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 6, "gdk_content_deserialize_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 7, "gdk_content_deserialize_async", "gpointer");
  gdk_content_deserialize_async(Xen_to_C_GInputStream_(stream), Xen_to_C_char_(mime_type), Xen_to_C_GType(type), Xen_to_C_int(io_priority), 
                                Xen_to_C_GCancellable_(cancellable), Xen_to_C_GAsyncReadyCallback(callback), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_content_deserialize_finish(Xen result, Xen value, Xen ignore_error)
{
  #define H_gdk_content_deserialize_finish "gboolean gdk_content_deserialize_finish(GAsyncResult* result, \
GValue* value, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 1, "gdk_content_deserialize_finish", "GAsyncResult*");
  Xen_check_type(Xen_is_GValue_(value), value, 2, "gdk_content_deserialize_finish", "GValue*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_content_deserialize_finish(Xen_to_C_GAsyncResult_(result), Xen_to_C_GValue_(value), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_content_provider_new_for_value(Xen value)
{
  #define H_gdk_content_provider_new_for_value "GdkContentProvider* gdk_content_provider_new_for_value(GValue* value)"
  Xen_check_type(Xen_is_GValue_(value), value, 1, "gdk_content_provider_new_for_value", "GValue*");
  return(C_to_Xen_GdkContentProvider_(gdk_content_provider_new_for_value(Xen_to_C_GValue_(value))));
}

static Xen gxg_gdk_content_provider_new_for_bytes(Xen mime_type, Xen bytes)
{
  #define H_gdk_content_provider_new_for_bytes "GdkContentProvider* gdk_content_provider_new_for_bytes(char* mime_type, \
GBytes* bytes)"
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 1, "gdk_content_provider_new_for_bytes", "char*");
  Xen_check_type(Xen_is_GBytes_(bytes), bytes, 2, "gdk_content_provider_new_for_bytes", "GBytes*");
  return(C_to_Xen_GdkContentProvider_(gdk_content_provider_new_for_bytes((const char*)Xen_to_C_char_(mime_type), Xen_to_C_GBytes_(bytes))));
}

static Xen gxg_gtk_event_controller_motion_new(Xen widget)
{
  #define H_gtk_event_controller_motion_new "GtkEventController* gtk_event_controller_motion_new(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_event_controller_motion_new", "GtkWidget*");
  return(C_to_Xen_GtkEventController_(gtk_event_controller_motion_new(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gdk_texture_new_for_data(Xen data, Xen width, Xen height, Xen stride)
{
  #define H_gdk_texture_new_for_data "GdkTexture* gdk_texture_new_for_data(guchar* data, int width, int height, \
int stride)"
  Xen_check_type(Xen_is_guchar_(data), data, 1, "gdk_texture_new_for_data", "guchar*");
  Xen_check_type(Xen_is_int(width), width, 2, "gdk_texture_new_for_data", "int");
  Xen_check_type(Xen_is_int(height), height, 3, "gdk_texture_new_for_data", "int");
  Xen_check_type(Xen_is_int(stride), stride, 4, "gdk_texture_new_for_data", "int");
  return(C_to_Xen_GdkTexture_(gdk_texture_new_for_data(Xen_to_C_guchar_(data), Xen_to_C_int(width), Xen_to_C_int(height), 
                                                       Xen_to_C_int(stride))));
}

static Xen gxg_gdk_texture_new_for_pixbuf(Xen pixbuf)
{
  #define H_gdk_texture_new_for_pixbuf "GdkTexture* gdk_texture_new_for_pixbuf(GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 1, "gdk_texture_new_for_pixbuf", "GdkPixbuf*");
  return(C_to_Xen_GdkTexture_(gdk_texture_new_for_pixbuf(Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gdk_texture_new_from_resource(Xen resource_path)
{
  #define H_gdk_texture_new_from_resource "GdkTexture* gdk_texture_new_from_resource(char* resource_path)"
  Xen_check_type(Xen_is_char_(resource_path), resource_path, 1, "gdk_texture_new_from_resource", "char*");
  return(C_to_Xen_GdkTexture_(gdk_texture_new_from_resource((const char*)Xen_to_C_char_(resource_path))));
}

static Xen gxg_gdk_texture_new_from_file(Xen file, Xen ignore_error)
{
  #define H_gdk_texture_new_from_file "GdkTexture* gdk_texture_new_from_file(GFile* file, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GFile_(file), file, 1, "gdk_texture_new_from_file", "GFile*");
  {
    Xen result;
    result = C_to_Xen_GdkTexture_(gdk_texture_new_from_file(Xen_to_C_GFile_(file), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_texture_get_width(Xen texture)
{
  #define H_gdk_texture_get_width "int gdk_texture_get_width(GdkTexture* texture)"
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 1, "gdk_texture_get_width", "GdkTexture*");
  return(C_to_Xen_int(gdk_texture_get_width(Xen_to_C_GdkTexture_(texture))));
}

static Xen gxg_gdk_texture_get_height(Xen texture)
{
  #define H_gdk_texture_get_height "int gdk_texture_get_height(GdkTexture* texture)"
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 1, "gdk_texture_get_height", "GdkTexture*");
  return(C_to_Xen_int(gdk_texture_get_height(Xen_to_C_GdkTexture_(texture))));
}

static Xen gxg_gdk_texture_download(Xen texture, Xen data, Xen stride)
{
  #define H_gdk_texture_download "void gdk_texture_download(GdkTexture* texture, guchar* data, gsize stride)"
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 1, "gdk_texture_download", "GdkTexture*");
  Xen_check_type(Xen_is_guchar_(data), data, 2, "gdk_texture_download", "guchar*");
  Xen_check_type(Xen_is_gsize(stride), stride, 3, "gdk_texture_download", "gsize");
  gdk_texture_download(Xen_to_C_GdkTexture_(texture), Xen_to_C_guchar_(data), Xen_to_C_gsize(stride));
  return(Xen_false);
}

static Xen gxg_gdk_cursor_new_from_texture(Xen texture, Xen hotspot_x, Xen hotspot_y, Xen fallback)
{
  #define H_gdk_cursor_new_from_texture "GdkCursor* gdk_cursor_new_from_texture(GdkTexture* texture, \
int hotspot_x, int hotspot_y, GdkCursor* fallback)"
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 1, "gdk_cursor_new_from_texture", "GdkTexture*");
  Xen_check_type(Xen_is_int(hotspot_x), hotspot_x, 2, "gdk_cursor_new_from_texture", "int");
  Xen_check_type(Xen_is_int(hotspot_y), hotspot_y, 3, "gdk_cursor_new_from_texture", "int");
  Xen_check_type(Xen_is_GdkCursor_(fallback), fallback, 4, "gdk_cursor_new_from_texture", "GdkCursor*");
  return(C_to_Xen_GdkCursor_(gdk_cursor_new_from_texture(Xen_to_C_GdkTexture_(texture), Xen_to_C_int(hotspot_x), Xen_to_C_int(hotspot_y), 
                                                         Xen_to_C_GdkCursor_(fallback))));
}

static Xen gxg_gdk_cursor_new_from_name(Xen name, Xen fallback)
{
  #define H_gdk_cursor_new_from_name "GdkCursor* gdk_cursor_new_from_name(gchar* name, GdkCursor* fallback)"
  Xen_check_type(Xen_is_gchar_(name), name, 1, "gdk_cursor_new_from_name", "gchar*");
  Xen_check_type(Xen_is_GdkCursor_(fallback), fallback, 2, "gdk_cursor_new_from_name", "GdkCursor*");
  return(C_to_Xen_GdkCursor_(gdk_cursor_new_from_name((const gchar*)Xen_to_C_gchar_(name), Xen_to_C_GdkCursor_(fallback))));
}

static Xen gxg_gdk_cursor_get_fallback(Xen cursor)
{
  #define H_gdk_cursor_get_fallback "GdkCursor* gdk_cursor_get_fallback(GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 1, "gdk_cursor_get_fallback", "GdkCursor*");
  return(C_to_Xen_GdkCursor_(gdk_cursor_get_fallback(Xen_to_C_GdkCursor_(cursor))));
}

static Xen gxg_gdk_cursor_get_name(Xen cursor)
{
  #define H_gdk_cursor_get_name "char* gdk_cursor_get_name(GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 1, "gdk_cursor_get_name", "GdkCursor*");
  return(C_to_Xen_char_(gdk_cursor_get_name(Xen_to_C_GdkCursor_(cursor))));
}

static Xen gxg_gdk_cursor_get_texture(Xen cursor)
{
  #define H_gdk_cursor_get_texture "GdkTexture* gdk_cursor_get_texture(GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 1, "gdk_cursor_get_texture", "GdkCursor*");
  return(C_to_Xen_GdkTexture_(gdk_cursor_get_texture(Xen_to_C_GdkCursor_(cursor))));
}

static Xen gxg_gdk_cursor_get_hotspot_x(Xen cursor)
{
  #define H_gdk_cursor_get_hotspot_x "int gdk_cursor_get_hotspot_x(GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 1, "gdk_cursor_get_hotspot_x", "GdkCursor*");
  return(C_to_Xen_int(gdk_cursor_get_hotspot_x(Xen_to_C_GdkCursor_(cursor))));
}

static Xen gxg_gdk_cursor_get_hotspot_y(Xen cursor)
{
  #define H_gdk_cursor_get_hotspot_y "int gdk_cursor_get_hotspot_y(GdkCursor* cursor)"
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 1, "gdk_cursor_get_hotspot_y", "GdkCursor*");
  return(C_to_Xen_int(gdk_cursor_get_hotspot_y(Xen_to_C_GdkCursor_(cursor))));
}

static Xen gxg_gdk_device_get_position(Xen device, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_device_get_position "void gdk_device_get_position(GdkDevice* device, gint* [x], gint* [y])"
  gint ref_x;
  gint ref_y;
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_position", "GdkDevice*");
  gdk_device_get_position(Xen_to_C_GdkDevice_(device), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gint(ref_x), C_to_Xen_gint(ref_y)));
}

static Xen gxg_gdk_device_get_position_double(Xen device, Xen ignore_x, Xen ignore_y)
{
  #define H_gdk_device_get_position_double "void gdk_device_get_position_double(GdkDevice* device, gdouble* [x], \
gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_GdkDevice_(device), device, 1, "gdk_device_get_position_double", "GdkDevice*");
  gdk_device_get_position_double(Xen_to_C_GdkDevice_(device), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
}

static Xen gxg_gdk_display_get_clipboard(Xen display)
{
  #define H_gdk_display_get_clipboard "GdkClipboard* gdk_display_get_clipboard(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_clipboard", "GdkDisplay*");
  return(C_to_Xen_GdkClipboard_(gdk_display_get_clipboard(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_primary_clipboard(Xen display)
{
  #define H_gdk_display_get_primary_clipboard "GdkClipboard* gdk_display_get_primary_clipboard(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_primary_clipboard", "GdkDisplay*");
  return(C_to_Xen_GdkClipboard_(gdk_display_get_primary_clipboard(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_keymap(Xen display)
{
  #define H_gdk_display_get_keymap "GdkKeymap* gdk_display_get_keymap(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_keymap", "GdkDisplay*");
  return(C_to_Xen_GdkKeymap_(gdk_display_get_keymap(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gdk_display_get_setting(Xen display, Xen name, Xen ignore_value)
{
  #define H_gdk_display_get_setting "gboolean gdk_display_get_setting(GdkDisplay* display, char* name, \
GValue* [value])"
  GValue ref_value;
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gdk_display_get_setting", "GdkDisplay*");
  Xen_check_type(Xen_is_char_(name), name, 2, "gdk_display_get_setting", "char*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gdk_display_get_setting(Xen_to_C_GdkDisplay_(display), (const char*)Xen_to_C_char_(name), (const GValue*)&ref_value));
    return(Xen_list_2(result, C_to_Xen_GValue(ref_value)));
   }
}

static Xen gxg_gdk_drag_context_get_display(Xen context)
{
  #define H_gdk_drag_context_get_display "GdkDisplay* gdk_drag_context_get_display(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_context_get_display", "GdkDragContext*");
  return(C_to_Xen_GdkDisplay_(gdk_drag_context_get_display(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gdk_drag_context_get_formats(Xen context)
{
  #define H_gdk_drag_context_get_formats "GdkContentFormats* gdk_drag_context_get_formats(GdkDragContext* context)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drag_context_get_formats", "GdkDragContext*");
  return(C_to_Xen_GdkContentFormats_(gdk_drag_context_get_formats(Xen_to_C_GdkDragContext_(context))));
}

static Xen gxg_gdk_drop_read_async(Xen context, Xen mime_types, Xen io_priority, Xen cancellable, Xen callback, Xen user_data)
{
  #define H_gdk_drop_read_async "void gdk_drop_read_async(GdkDragContext* context, char** mime_types, \
int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drop_read_async", "GdkDragContext*");
  Xen_check_type(Xen_is_char__(mime_types), mime_types, 2, "gdk_drop_read_async", "char**");
  Xen_check_type(Xen_is_int(io_priority), io_priority, 3, "gdk_drop_read_async", "int");
  Xen_check_type(Xen_is_GCancellable_(cancellable), cancellable, 4, "gdk_drop_read_async", "GCancellable*");
  Xen_check_type(Xen_is_GAsyncReadyCallback(callback), callback, 5, "gdk_drop_read_async", "GAsyncReadyCallback");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 6, "gdk_drop_read_async", "gpointer");
  gdk_drop_read_async(Xen_to_C_GdkDragContext_(context), Xen_to_C_char__(mime_types), Xen_to_C_int(io_priority), Xen_to_C_GCancellable_(cancellable), 
                      Xen_to_C_GAsyncReadyCallback(callback), Xen_to_C_gpointer(user_data));
  return(Xen_false);
}

static Xen gxg_gdk_drop_read_finish(Xen context, Xen out_mime_type, Xen result, Xen ignore_error)
{
  #define H_gdk_drop_read_finish "GInputStream* gdk_drop_read_finish(GdkDragContext* context, char** out_mime_type, \
GAsyncResult* result, GError** [error])"
  GError* ref_error = NULL;
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gdk_drop_read_finish", "GdkDragContext*");
  Xen_check_type(Xen_is_char__(out_mime_type), out_mime_type, 2, "gdk_drop_read_finish", "char**");
  Xen_check_type(Xen_is_GAsyncResult_(result), result, 3, "gdk_drop_read_finish", "GAsyncResult*");
  {
    Xen result;
    result = C_to_Xen_GInputStream_(gdk_drop_read_finish(Xen_to_C_GdkDragContext_(context), Xen_to_C_char__(out_mime_type), 
                                                         Xen_to_C_GAsyncResult_(result), &ref_error));
    return(Xen_list_2(result, C_to_Xen_GError_(ref_error)));
   }
}

static Xen gxg_gdk_drag_begin(Xen window, Xen device, Xen content, Xen actions, Xen dx, Xen dy)
{
  #define H_gdk_drag_begin "GdkDragContext* gdk_drag_begin(GdkWindow* window, GdkDevice* device, GdkContentProvider* content, \
GdkDragAction actions, gint dx, gint dy)"
  Xen_check_type(Xen_is_GdkWindow_(window), window, 1, "gdk_drag_begin", "GdkWindow*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gdk_drag_begin", "GdkDevice*");
  Xen_check_type(Xen_is_GdkContentProvider_(content), content, 3, "gdk_drag_begin", "GdkContentProvider*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gdk_drag_begin", "GdkDragAction");
  Xen_check_type(Xen_is_gint(dx), dx, 5, "gdk_drag_begin", "gint");
  Xen_check_type(Xen_is_gint(dy), dy, 6, "gdk_drag_begin", "gint");
  return(C_to_Xen_GdkDragContext_(gdk_drag_begin(Xen_to_C_GdkWindow_(window), Xen_to_C_GdkDevice_(device), Xen_to_C_GdkContentProvider_(content), 
                                                 Xen_to_C_GdkDragAction(actions), Xen_to_C_gint(dx), Xen_to_C_gint(dy))));
}

static Xen gxg_gdk_monitor_is_valid(Xen monitor)
{
  #define H_gdk_monitor_is_valid "gboolean gdk_monitor_is_valid(GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 1, "gdk_monitor_is_valid", "GdkMonitor*");
  return(C_to_Xen_gboolean(gdk_monitor_is_valid(Xen_to_C_GdkMonitor_(monitor))));
}

static Xen gxg_gdk_seat_get_master_pointers(Xen seat, Xen capabilities)
{
  #define H_gdk_seat_get_master_pointers "GList* gdk_seat_get_master_pointers(GdkSeat* seat, GdkSeatCapabilities capabilities)"
  Xen_check_type(Xen_is_GdkSeat_(seat), seat, 1, "gdk_seat_get_master_pointers", "GdkSeat*");
  Xen_check_type(Xen_is_GdkSeatCapabilities(capabilities), capabilities, 2, "gdk_seat_get_master_pointers", "GdkSeatCapabilities");
  return(C_to_Xen_GList_(gdk_seat_get_master_pointers(Xen_to_C_GdkSeat_(seat), Xen_to_C_GdkSeatCapabilities(capabilities))));
}

static Xen gxg_gtk_drag_begin_with_coordinates(Xen widget, Xen device, Xen targets, Xen actions, Xen x, Xen y)
{
  #define H_gtk_drag_begin_with_coordinates "GdkDragContext* gtk_drag_begin_with_coordinates(GtkWidget* widget, \
GdkDevice* device, GdkContentFormats* targets, GdkDragAction actions, gint x, gint y)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_begin_with_coordinates", "GtkWidget*");
  Xen_check_type(Xen_is_GdkDevice_(device), device, 2, "gtk_drag_begin_with_coordinates", "GdkDevice*");
  Xen_check_type(Xen_is_GdkContentFormats_(targets), targets, 3, "gtk_drag_begin_with_coordinates", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gtk_drag_begin_with_coordinates", "GdkDragAction");
  Xen_check_type(Xen_is_gint(x), x, 5, "gtk_drag_begin_with_coordinates", "gint");
  Xen_check_type(Xen_is_gint(y), y, 6, "gtk_drag_begin_with_coordinates", "gint");
  return(C_to_Xen_GdkDragContext_(gtk_drag_begin_with_coordinates(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkDevice_(device), 
                                                                  Xen_to_C_GdkContentFormats_(targets), Xen_to_C_GdkDragAction(actions), 
                                                                  Xen_to_C_gint(x), Xen_to_C_gint(y))));
}

static Xen gxg_gtk_drag_source_set_icon_surface(Xen widget, Xen surface)
{
  #define H_gtk_drag_source_set_icon_surface "void gtk_drag_source_set_icon_surface(GtkWidget* widget, \
cairo_surface_t* surface)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_set_icon_surface", "GtkWidget*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 2, "gtk_drag_source_set_icon_surface", "cairo_surface_t*");
  gtk_drag_source_set_icon_surface(Xen_to_C_GtkWidget_(widget), Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_gtk_entry_set_icon_from_texture(Xen entry, Xen icon_pos, Xen texture)
{
  #define H_gtk_entry_set_icon_from_texture "void gtk_entry_set_icon_from_texture(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
GdkTexture* texture)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_icon_from_texture", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_set_icon_from_texture", "GtkEntryIconPosition");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 3, "gtk_entry_set_icon_from_texture", "GdkTexture*");
  gtk_entry_set_icon_from_texture(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos), Xen_to_C_GdkTexture_(texture));
  return(Xen_false);
}

static Xen gxg_gtk_entry_get_icon_texture(Xen entry, Xen icon_pos)
{
  #define H_gtk_entry_get_icon_texture "GdkTexture* gtk_entry_get_icon_texture(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_get_icon_texture", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_get_icon_texture", "GtkEntryIconPosition");
  return(C_to_Xen_GdkTexture_(gtk_entry_get_icon_texture(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos))));
}

static Xen gxg_gtk_entry_set_icon_drag_source(Xen entry, Xen icon_pos, Xen formats, Xen actions)
{
  #define H_gtk_entry_set_icon_drag_source "void gtk_entry_set_icon_drag_source(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
GdkContentFormats* formats, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkEntry_(entry), entry, 1, "gtk_entry_set_icon_drag_source", "GtkEntry*");
  Xen_check_type(Xen_is_GtkEntryIconPosition(icon_pos), icon_pos, 2, "gtk_entry_set_icon_drag_source", "GtkEntryIconPosition");
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 3, "gtk_entry_set_icon_drag_source", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gtk_entry_set_icon_drag_source", "GdkDragAction");
  gtk_entry_set_icon_drag_source(Xen_to_C_GtkEntry_(entry), Xen_to_C_GtkEntryIconPosition(icon_pos), Xen_to_C_GdkContentFormats_(formats), 
                                 Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_header_bar_get_show_title_buttons(Xen bar)
{
  #define H_gtk_header_bar_get_show_title_buttons "gboolean gtk_header_bar_get_show_title_buttons(GtkHeaderBar* bar)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_get_show_title_buttons", "GtkHeaderBar*");
  return(C_to_Xen_gboolean(gtk_header_bar_get_show_title_buttons(Xen_to_C_GtkHeaderBar_(bar))));
}

static Xen gxg_gtk_header_bar_set_show_title_buttons(Xen bar, Xen setting)
{
  #define H_gtk_header_bar_set_show_title_buttons "void gtk_header_bar_set_show_title_buttons(GtkHeaderBar* bar, \
gboolean setting)"
  Xen_check_type(Xen_is_GtkHeaderBar_(bar), bar, 1, "gtk_header_bar_set_show_title_buttons", "GtkHeaderBar*");
  Xen_check_type(Xen_is_gboolean(setting), setting, 2, "gtk_header_bar_set_show_title_buttons", "gboolean");
  gtk_header_bar_set_show_title_buttons(Xen_to_C_GtkHeaderBar_(bar), Xen_to_C_gboolean(setting));
  return(Xen_false);
}

static Xen gxg_gtk_icon_theme_get_for_display(Xen display)
{
  #define H_gtk_icon_theme_get_for_display "GtkIconTheme* gtk_icon_theme_get_for_display(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_icon_theme_get_for_display", "GdkDisplay*");
  return(C_to_Xen_GtkIconTheme_(gtk_icon_theme_get_for_display(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gtk_icon_theme_set_display(Xen icon_theme, Xen display)
{
  #define H_gtk_icon_theme_set_display "void gtk_icon_theme_set_display(GtkIconTheme* icon_theme, GdkDisplay* display)"
  Xen_check_type(Xen_is_GtkIconTheme_(icon_theme), icon_theme, 1, "gtk_icon_theme_set_display", "GtkIconTheme*");
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 2, "gtk_icon_theme_set_display", "GdkDisplay*");
  gtk_icon_theme_set_display(Xen_to_C_GtkIconTheme_(icon_theme), Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gtk_icon_info_load_texture(Xen icon_info)
{
  #define H_gtk_icon_info_load_texture "GdkTexture* gtk_icon_info_load_texture(GtkIconInfo* icon_info)"
  Xen_check_type(Xen_is_GtkIconInfo_(icon_info), icon_info, 1, "gtk_icon_info_load_texture", "GtkIconInfo*");
  return(C_to_Xen_GdkTexture_(gtk_icon_info_load_texture(Xen_to_C_GtkIconInfo_(icon_info))));
}

static Xen gxg_gtk_image_new_from_texture(Xen texture)
{
  #define H_gtk_image_new_from_texture "GtkWidget* gtk_image_new_from_texture(GdkTexture* texture)"
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 1, "gtk_image_new_from_texture", "GdkTexture*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_texture(Xen_to_C_GdkTexture_(texture))));
}

static Xen gxg_gtk_image_new_from_icon_name(Xen icon_name)
{
  #define H_gtk_image_new_from_icon_name "GtkWidget* gtk_image_new_from_icon_name(gchar* icon_name)"
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 1, "gtk_image_new_from_icon_name", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_icon_name((const gchar*)Xen_to_C_gchar_(icon_name))));
}

static Xen gxg_gtk_image_new_from_gicon(Xen icon)
{
  #define H_gtk_image_new_from_gicon "GtkWidget* gtk_image_new_from_gicon(GIcon* icon)"
  Xen_check_type(Xen_is_GIcon_(icon), icon, 1, "gtk_image_new_from_gicon", "GIcon*");
  return(C_to_Xen_GtkWidget_(gtk_image_new_from_gicon(Xen_to_C_GIcon_(icon))));
}

static Xen gxg_gtk_image_set_from_texture(Xen image, Xen texture)
{
  #define H_gtk_image_set_from_texture "void gtk_image_set_from_texture(GtkImage* image, GdkTexture* texture)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_texture", "GtkImage*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 2, "gtk_image_set_from_texture", "GdkTexture*");
  gtk_image_set_from_texture(Xen_to_C_GtkImage_(image), Xen_to_C_GdkTexture_(texture));
  return(Xen_false);
}

static Xen gxg_gtk_image_set_from_icon_name(Xen image, Xen icon_name)
{
  #define H_gtk_image_set_from_icon_name "void gtk_image_set_from_icon_name(GtkImage* image, gchar* icon_name)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_icon_name", "GtkImage*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_image_set_from_icon_name", "gchar*");
  gtk_image_set_from_icon_name(Xen_to_C_GtkImage_(image), (const gchar*)Xen_to_C_gchar_(icon_name));
  return(Xen_false);
}

static Xen gxg_gtk_image_set_from_gicon(Xen image, Xen icon)
{
  #define H_gtk_image_set_from_gicon "void gtk_image_set_from_gicon(GtkImage* image, GIcon* icon)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_from_gicon", "GtkImage*");
  Xen_check_type(Xen_is_GIcon_(icon), icon, 2, "gtk_image_set_from_gicon", "GIcon*");
  gtk_image_set_from_gicon(Xen_to_C_GtkImage_(image), Xen_to_C_GIcon_(icon));
  return(Xen_false);
}

static Xen gxg_gtk_image_set_icon_size(Xen image, Xen icon_size)
{
  #define H_gtk_image_set_icon_size "void gtk_image_set_icon_size(GtkImage* image, GtkIconSize icon_size)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_set_icon_size", "GtkImage*");
  Xen_check_type(Xen_is_GtkIconSize(icon_size), icon_size, 2, "gtk_image_set_icon_size", "GtkIconSize");
  gtk_image_set_icon_size(Xen_to_C_GtkImage_(image), Xen_to_C_GtkIconSize(icon_size));
  return(Xen_false);
}

static Xen gxg_gtk_image_get_surface(Xen image)
{
  #define H_gtk_image_get_surface "cairo_surface_t* gtk_image_get_surface(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_surface", "GtkImage*");
  return(C_to_Xen_cairo_surface_t_(gtk_image_get_surface(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_image_get_texture(Xen image)
{
  #define H_gtk_image_get_texture "GdkTexture* gtk_image_get_texture(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_texture", "GtkImage*");
  return(C_to_Xen_GdkTexture_(gtk_image_get_texture(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_image_get_icon_size(Xen image)
{
  #define H_gtk_image_get_icon_size "GtkIconSize gtk_image_get_icon_size(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_icon_size", "GtkImage*");
  return(C_to_Xen_GtkIconSize(gtk_image_get_icon_size(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_image_get_icon_name(Xen image)
{
  #define H_gtk_image_get_icon_name "char* gtk_image_get_icon_name(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_icon_name", "GtkImage*");
    return(C_to_Xen_char_((char*)gtk_image_get_icon_name(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_image_get_gicon(Xen image)
{
  #define H_gtk_image_get_gicon "GIcon* gtk_image_get_gicon(GtkImage* image)"
  Xen_check_type(Xen_is_GtkImage_(image), image, 1, "gtk_image_get_gicon", "GtkImage*");
  return(C_to_Xen_GIcon_(gtk_image_get_gicon(Xen_to_C_GtkImage_(image))));
}

static Xen gxg_gtk_invisible_new_for_display(Xen display)
{
  #define H_gtk_invisible_new_for_display "GtkWidget* gtk_invisible_new_for_display(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_invisible_new_for_display", "GdkDisplay*");
  return(C_to_Xen_GtkWidget_(gtk_invisible_new_for_display(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gtk_invisible_set_display(Xen invisible, Xen display)
{
  #define H_gtk_invisible_set_display "void gtk_invisible_set_display(GtkInvisible* invisible, GdkDisplay* display)"
  Xen_check_type(Xen_is_GtkInvisible_(invisible), invisible, 1, "gtk_invisible_set_display", "GtkInvisible*");
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 2, "gtk_invisible_set_display", "GdkDisplay*");
  gtk_invisible_set_display(Xen_to_C_GtkInvisible_(invisible), Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_GtkInvisible*(void)
{
  #define H_GtkInvisible* "GdkDisplay*gtk_invisible_get_display GtkInvisible*( invisible)"
  return(C_to_Xen_GdkDisplay_gtk_invisible_get_display(GtkInvisible*()));
}

static Xen gxg_gtk_menu_set_display(Xen menu, Xen display)
{
  #define H_gtk_menu_set_display "void gtk_menu_set_display(GtkMenu* menu, GdkDisplay* display)"
  Xen_check_type(Xen_is_GtkMenu_(menu), menu, 1, "gtk_menu_set_display", "GtkMenu*");
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 2, "gtk_menu_set_display", "GdkDisplay*");
  gtk_menu_set_display(Xen_to_C_GtkMenu_(menu), Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gtk_render_icon(Xen context, Xen cr, Xen texture, Xen x, Xen y)
{
  #define H_gtk_render_icon "void gtk_render_icon(GtkStyleContext* context, cairo_t* cr, GdkTexture* texture, \
gdouble x, gdouble y)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_render_icon", "GtkStyleContext*");
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 2, "gtk_render_icon", "cairo_t*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 3, "gtk_render_icon", "GdkTexture*");
  Xen_check_type(Xen_is_gdouble(x), x, 4, "gtk_render_icon", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 5, "gtk_render_icon", "gdouble");
  gtk_render_icon(Xen_to_C_GtkStyleContext_(context), Xen_to_C_cairo_t_(cr), Xen_to_C_GdkTexture_(texture), Xen_to_C_gdouble(x), 
                  Xen_to_C_gdouble(y));
  return(Xen_false);
}

static Xen gxg_gtk_content_formats_add_text_targets(Xen list)
{
  #define H_gtk_content_formats_add_text_targets "GdkContentFormats* gtk_content_formats_add_text_targets(GdkContentFormats* list)"
  Xen_check_type(Xen_is_GdkContentFormats_(list), list, 1, "gtk_content_formats_add_text_targets", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gtk_content_formats_add_text_targets(Xen_to_C_GdkContentFormats_(list))));
}

static Xen gxg_gtk_content_formats_add_image_targets(Xen list, Xen writable)
{
  #define H_gtk_content_formats_add_image_targets "GdkContentFormats* gtk_content_formats_add_image_targets(GdkContentFormats* list, \
gboolean writable)"
  Xen_check_type(Xen_is_GdkContentFormats_(list), list, 1, "gtk_content_formats_add_image_targets", "GdkContentFormats*");
  Xen_check_type(Xen_is_gboolean(writable), writable, 2, "gtk_content_formats_add_image_targets", "gboolean");
  return(C_to_Xen_GdkContentFormats_(gtk_content_formats_add_image_targets(Xen_to_C_GdkContentFormats_(list), Xen_to_C_gboolean(writable))));
}

static Xen gxg_gtk_content_formats_add_uri_targets(Xen list)
{
  #define H_gtk_content_formats_add_uri_targets "GdkContentFormats* gtk_content_formats_add_uri_targets(GdkContentFormats* list)"
  Xen_check_type(Xen_is_GdkContentFormats_(list), list, 1, "gtk_content_formats_add_uri_targets", "GdkContentFormats*");
  return(C_to_Xen_GdkContentFormats_(gtk_content_formats_add_uri_targets(Xen_to_C_GdkContentFormats_(list))));
}

static Xen gxg_gtk_selection_data_set(Xen selection_data, Xen type, Xen format, Xen data, Xen length)
{
  #define H_gtk_selection_data_set "void gtk_selection_data_set(GtkSelectionData* selection_data, GdkAtom type, \
gint format, guchar* data, gint length)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_set", "GtkSelectionData*");
  Xen_check_type(Xen_is_GdkAtom(type), type, 2, "gtk_selection_data_set", "GdkAtom");
  Xen_check_type(Xen_is_gint(format), format, 3, "gtk_selection_data_set", "gint");
  Xen_check_type(Xen_is_guchar_(data), data, 4, "gtk_selection_data_set", "guchar*");
  Xen_check_type(Xen_is_gint(length), length, 5, "gtk_selection_data_set", "gint");
  gtk_selection_data_set(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_GdkAtom(type), Xen_to_C_gint(format), Xen_to_C_guchar_(data), 
                         Xen_to_C_gint(length));
  return(Xen_false);
}

static Xen gxg_gtk_selection_data_set_text(Xen selection_data, Xen str, Xen len)
{
  #define H_gtk_selection_data_set_text "gboolean gtk_selection_data_set_text(GtkSelectionData* selection_data, \
gchar* str, gint len)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_set_text", "GtkSelectionData*");
  Xen_check_type(Xen_is_gchar_(str), str, 2, "gtk_selection_data_set_text", "gchar*");
  Xen_check_type(Xen_is_gint(len), len, 3, "gtk_selection_data_set_text", "gint");
  return(C_to_Xen_gboolean(gtk_selection_data_set_text(Xen_to_C_GtkSelectionData_(selection_data), (const gchar*)Xen_to_C_gchar_(str), 
                                                       Xen_to_C_gint(len))));
}

static Xen gxg_gtk_selection_data_get_text(Xen selection_data)
{
  #define H_gtk_selection_data_get_text "guchar* gtk_selection_data_get_text(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_text", "GtkSelectionData*");
  return(C_to_Xen_guchar_(gtk_selection_data_get_text(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_set_pixbuf(Xen selection_data, Xen pixbuf)
{
  #define H_gtk_selection_data_set_pixbuf "gboolean gtk_selection_data_set_pixbuf(GtkSelectionData* selection_data, \
GdkPixbuf* pixbuf)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_set_pixbuf", "GtkSelectionData*");
  Xen_check_type(Xen_is_GdkPixbuf_(pixbuf), pixbuf, 2, "gtk_selection_data_set_pixbuf", "GdkPixbuf*");
  return(C_to_Xen_gboolean(gtk_selection_data_set_pixbuf(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_GdkPixbuf_(pixbuf))));
}

static Xen gxg_gtk_selection_data_get_surface(Xen selection_data)
{
  #define H_gtk_selection_data_get_surface "cairo_surface_t* gtk_selection_data_get_surface(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_surface", "GtkSelectionData*");
  return(C_to_Xen_cairo_surface_t_(gtk_selection_data_get_surface(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_set_surface(Xen selection_data, Xen surface)
{
  #define H_gtk_selection_data_set_surface "gboolean gtk_selection_data_set_surface(GtkSelectionData* selection_data, \
cairo_surface_t* surface)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_set_surface", "GtkSelectionData*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 2, "gtk_selection_data_set_surface", "cairo_surface_t*");
  return(C_to_Xen_gboolean(gtk_selection_data_set_surface(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_gtk_selection_data_get_pixbuf(Xen selection_data)
{
  #define H_gtk_selection_data_get_pixbuf "GdkPixbuf* gtk_selection_data_get_pixbuf(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_pixbuf", "GtkSelectionData*");
  return(C_to_Xen_GdkPixbuf_(gtk_selection_data_get_pixbuf(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_set_texture(Xen selection_data, Xen texture)
{
  #define H_gtk_selection_data_set_texture "gboolean gtk_selection_data_set_texture(GtkSelectionData* selection_data, \
GdkTexture* texture)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_set_texture", "GtkSelectionData*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 2, "gtk_selection_data_set_texture", "GdkTexture*");
  return(C_to_Xen_gboolean(gtk_selection_data_set_texture(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_GdkTexture_(texture))));
}

static Xen gxg_gtk_selection_data_get_texture(Xen selection_data)
{
  #define H_gtk_selection_data_get_texture "GdkTexture* gtk_selection_data_get_texture(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_texture", "GtkSelectionData*");
  return(C_to_Xen_GdkTexture_(gtk_selection_data_get_texture(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_set_uris(Xen selection_data, Xen uris)
{
  #define H_gtk_selection_data_set_uris "gboolean gtk_selection_data_set_uris(GtkSelectionData* selection_data, \
gchar** uris)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_set_uris", "GtkSelectionData*");
  Xen_check_type(Xen_is_gchar__(uris), uris, 2, "gtk_selection_data_set_uris", "gchar**");
  return(C_to_Xen_gboolean(gtk_selection_data_set_uris(Xen_to_C_GtkSelectionData_(selection_data), Xen_to_C_gchar__(uris))));
}

static Xen gxg_gtk_selection_data_get_uris(Xen selection_data)
{
  #define H_gtk_selection_data_get_uris "gchar** gtk_selection_data_get_uris(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_uris", "GtkSelectionData*");
  return(C_to_Xen_gchar__(gtk_selection_data_get_uris(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_get_targets(Xen selection_data, Xen ignore_targets, Xen ignore_natoms)
{
  #define H_gtk_selection_data_get_targets "gboolean gtk_selection_data_get_targets(GtkSelectionData* selection_data, \
GdkAtom** [targets], gint* [natoms])"
  GdkAtom* ref_targets = NULL;
  gint ref_natoms;
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_get_targets", "GtkSelectionData*");
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_selection_data_get_targets(Xen_to_C_GtkSelectionData_(selection_data), &ref_targets, &ref_natoms));
    return(Xen_list_3(result, C_to_Xen_GdkAtom_(ref_targets), C_to_Xen_gint(ref_natoms)));
   }
}

static Xen gxg_gtk_selection_data_targets_include_text(Xen selection_data)
{
  #define H_gtk_selection_data_targets_include_text "gboolean gtk_selection_data_targets_include_text(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_targets_include_text", "GtkSelectionData*");
  return(C_to_Xen_gboolean(gtk_selection_data_targets_include_text(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_selection_data_targets_include_uri(Xen selection_data)
{
  #define H_gtk_selection_data_targets_include_uri "gboolean gtk_selection_data_targets_include_uri(GtkSelectionData* selection_data)"
  Xen_check_type(Xen_is_GtkSelectionData_(selection_data), selection_data, 1, "gtk_selection_data_targets_include_uri", "GtkSelectionData*");
  return(C_to_Xen_gboolean(gtk_selection_data_targets_include_uri(Xen_to_C_GtkSelectionData_(selection_data))));
}

static Xen gxg_gtk_targets_include_text(Xen targets, Xen n_targets)
{
  #define H_gtk_targets_include_text "gboolean gtk_targets_include_text(GdkAtom* targets, gint n_targets)"
  Xen_check_type(Xen_is_GdkAtom_(targets), targets, 1, "gtk_targets_include_text", "GdkAtom*");
  Xen_check_type(Xen_is_gint(n_targets), n_targets, 2, "gtk_targets_include_text", "gint");
  return(C_to_Xen_gboolean(gtk_targets_include_text(Xen_to_C_GdkAtom_(targets), Xen_to_C_gint(n_targets))));
}

static Xen gxg_gtk_targets_include_image(Xen targets, Xen n_targets, Xen writable)
{
  #define H_gtk_targets_include_image "gboolean gtk_targets_include_image(GdkAtom* targets, gint n_targets, \
gboolean writable)"
  Xen_check_type(Xen_is_GdkAtom_(targets), targets, 1, "gtk_targets_include_image", "GdkAtom*");
  Xen_check_type(Xen_is_gint(n_targets), n_targets, 2, "gtk_targets_include_image", "gint");
  Xen_check_type(Xen_is_gboolean(writable), writable, 3, "gtk_targets_include_image", "gboolean");
  return(C_to_Xen_gboolean(gtk_targets_include_image(Xen_to_C_GdkAtom_(targets), Xen_to_C_gint(n_targets), Xen_to_C_gboolean(writable))));
}

static Xen gxg_gtk_targets_include_uri(Xen targets, Xen n_targets)
{
  #define H_gtk_targets_include_uri "gboolean gtk_targets_include_uri(GdkAtom* targets, gint n_targets)"
  Xen_check_type(Xen_is_GdkAtom_(targets), targets, 1, "gtk_targets_include_uri", "GdkAtom*");
  Xen_check_type(Xen_is_gint(n_targets), n_targets, 2, "gtk_targets_include_uri", "gint");
  return(C_to_Xen_gboolean(gtk_targets_include_uri(Xen_to_C_GdkAtom_(targets), Xen_to_C_gint(n_targets))));
}

static Xen gxg_gtk_settings_get_for_display(Xen display)
{
  #define H_gtk_settings_get_for_display "GtkSettings* gtk_settings_get_for_display(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_settings_get_for_display", "GdkDisplay*");
  return(C_to_Xen_GtkSettings_(gtk_settings_get_for_display(Xen_to_C_GdkDisplay_(display))));
}

static Xen gxg_gtk_style_context_add_provider_for_display(Xen display, Xen provider, Xen priority)
{
  #define H_gtk_style_context_add_provider_for_display "void gtk_style_context_add_provider_for_display(GdkDisplay* display, \
GtkStyleProvider* provider, guint priority)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_style_context_add_provider_for_display", "GdkDisplay*");
  Xen_check_type(Xen_is_GtkStyleProvider_(provider), provider, 2, "gtk_style_context_add_provider_for_display", "GtkStyleProvider*");
  Xen_check_type(Xen_is_guint(priority), priority, 3, "gtk_style_context_add_provider_for_display", "guint");
  gtk_style_context_add_provider_for_display(Xen_to_C_GdkDisplay_(display), Xen_to_C_GtkStyleProvider_(provider), Xen_to_C_guint(priority));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_remove_provider_for_display(Xen display, Xen provider)
{
  #define H_gtk_style_context_remove_provider_for_display "void gtk_style_context_remove_provider_for_display(GdkDisplay* display, \
GtkStyleProvider* provider)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_style_context_remove_provider_for_display", "GdkDisplay*");
  Xen_check_type(Xen_is_GtkStyleProvider_(provider), provider, 2, "gtk_style_context_remove_provider_for_display", "GtkStyleProvider*");
  gtk_style_context_remove_provider_for_display(Xen_to_C_GdkDisplay_(display), Xen_to_C_GtkStyleProvider_(provider));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_set_display(Xen context, Xen display)
{
  #define H_gtk_style_context_set_display "void gtk_style_context_set_display(GtkStyleContext* context, \
GdkDisplay* display)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_set_display", "GtkStyleContext*");
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 2, "gtk_style_context_set_display", "GdkDisplay*");
  gtk_style_context_set_display(Xen_to_C_GtkStyleContext_(context), Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gtk_style_context_get_display(Xen context)
{
  #define H_gtk_style_context_get_display "GdkDisplay* gtk_style_context_get_display(GtkStyleContext* context)"
  Xen_check_type(Xen_is_GtkStyleContext_(context), context, 1, "gtk_style_context_get_display", "GtkStyleContext*");
  return(C_to_Xen_GdkDisplay_(gtk_style_context_get_display(Xen_to_C_GtkStyleContext_(context))));
}

static Xen gxg_gtk_style_context_reset_widgets(Xen display)
{
  #define H_gtk_style_context_reset_widgets "void gtk_style_context_reset_widgets(GdkDisplay* display)"
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 1, "gtk_style_context_reset_widgets", "GdkDisplay*");
  gtk_style_context_reset_widgets(Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_insert_texture(Xen buffer, Xen iter, Xen texture)
{
  #define H_gtk_text_buffer_insert_texture "void gtk_text_buffer_insert_texture(GtkTextBuffer* buffer, \
GtkTextIter* iter, GdkTexture* texture)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_insert_texture", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_buffer_insert_texture", "GtkTextIter*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 3, "gtk_text_buffer_insert_texture", "GdkTexture*");
  gtk_text_buffer_insert_texture(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GtkTextIter_(iter), Xen_to_C_GdkTexture_(texture));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_add_selection_clipboard(Xen buffer, Xen clipboard)
{
  #define H_gtk_text_buffer_add_selection_clipboard "void gtk_text_buffer_add_selection_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_add_selection_clipboard", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 2, "gtk_text_buffer_add_selection_clipboard", "GdkClipboard*");
  gtk_text_buffer_add_selection_clipboard(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GdkClipboard_(clipboard));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_remove_selection_clipboard(Xen buffer, Xen clipboard)
{
  #define H_gtk_text_buffer_remove_selection_clipboard "void gtk_text_buffer_remove_selection_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_remove_selection_clipboard", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 2, "gtk_text_buffer_remove_selection_clipboard", "GdkClipboard*");
  gtk_text_buffer_remove_selection_clipboard(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GdkClipboard_(clipboard));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_cut_clipboard(Xen buffer, Xen clipboard, Xen default_editable)
{
  #define H_gtk_text_buffer_cut_clipboard "void gtk_text_buffer_cut_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard, gboolean default_editable)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_cut_clipboard", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 2, "gtk_text_buffer_cut_clipboard", "GdkClipboard*");
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 3, "gtk_text_buffer_cut_clipboard", "gboolean");
  gtk_text_buffer_cut_clipboard(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GdkClipboard_(clipboard), Xen_to_C_gboolean(default_editable));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_copy_clipboard(Xen buffer, Xen clipboard)
{
  #define H_gtk_text_buffer_copy_clipboard "void gtk_text_buffer_copy_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_copy_clipboard", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 2, "gtk_text_buffer_copy_clipboard", "GdkClipboard*");
  gtk_text_buffer_copy_clipboard(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GdkClipboard_(clipboard));
  return(Xen_false);
}

static Xen gxg_gtk_text_buffer_paste_clipboard(Xen buffer, Xen clipboard)
{
  #define H_gtk_text_buffer_paste_clipboard "void gtk_text_buffer_paste_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  Xen_check_type(Xen_is_GtkTextBuffer_(buffer), buffer, 1, "gtk_text_buffer_paste_clipboard", "GtkTextBuffer*");
  Xen_check_type(Xen_is_GdkClipboard_(clipboard), clipboard, 2, "gtk_text_buffer_paste_clipboard", "GdkClipboard*");
  gtk_text_buffer_paste_clipboard(Xen_to_C_GtkTextBuffer_(buffer), Xen_to_C_GdkClipboard_(clipboard));
  return(Xen_false);
}

static Xen gxg_override_location(Xen default_editable)
{
  #define H_override_location "GtkTextIter* override_location(gboolean default_editable)"
  Xen_check_type(Xen_is_gboolean(default_editable), default_editable, 1, "override_location", "gboolean");
  return(C_to_Xen_GtkTextIter_(override_location(Xen_to_C_gboolean(default_editable))));
}

static Xen gxg_gtk_tool_palette_get_drag_target_item(void)
{
  #define H_gtk_tool_palette_get_drag_target_item "char* gtk_tool_palette_get_drag_target_item( void)"
    return(C_to_Xen_char_((char*)gtk_tool_palette_get_drag_target_item()));
}

static Xen gxg_gtk_tool_palette_get_drag_target_group(void)
{
  #define H_gtk_tool_palette_get_drag_target_group "char* gtk_tool_palette_get_drag_target_group( void)"
    return(C_to_Xen_char_((char*)gtk_tool_palette_get_drag_target_group()));
}

static Xen gxg_gtk_tooltip_set_icon(Xen tooltip, Xen texture)
{
  #define H_gtk_tooltip_set_icon "void gtk_tooltip_set_icon(GtkTooltip* tooltip, GdkTexture* texture)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_icon", "GtkTooltip*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 2, "gtk_tooltip_set_icon", "GdkTexture*");
  gtk_tooltip_set_icon(Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GdkTexture_(texture));
  return(Xen_false);
}

static Xen gxg_gtk_tooltip_set_icon_from_icon_name(Xen tooltip, Xen icon_name)
{
  #define H_gtk_tooltip_set_icon_from_icon_name "void gtk_tooltip_set_icon_from_icon_name(GtkTooltip* tooltip, \
gchar* icon_name)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_icon_from_icon_name", "GtkTooltip*");
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 2, "gtk_tooltip_set_icon_from_icon_name", "gchar*");
  gtk_tooltip_set_icon_from_icon_name(Xen_to_C_GtkTooltip_(tooltip), (const gchar*)Xen_to_C_gchar_(icon_name));
  return(Xen_false);
}

static Xen gxg_gtk_tooltip_set_icon_from_gicon(Xen tooltip, Xen gicon)
{
  #define H_gtk_tooltip_set_icon_from_gicon "void gtk_tooltip_set_icon_from_gicon(GtkTooltip* tooltip, \
GIcon* gicon)"
  Xen_check_type(Xen_is_GtkTooltip_(tooltip), tooltip, 1, "gtk_tooltip_set_icon_from_gicon", "GtkTooltip*");
  Xen_check_type(Xen_is_GIcon_(gicon), gicon, 2, "gtk_tooltip_set_icon_from_gicon", "GIcon*");
  gtk_tooltip_set_icon_from_gicon(Xen_to_C_GtkTooltip_(tooltip), Xen_to_C_GIcon_(gicon));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_enable_model_drag_source(Xen tree_view, Xen start_button_mask, Xen formats, Xen actions)
{
  #define H_gtk_tree_view_enable_model_drag_source "void gtk_tree_view_enable_model_drag_source(GtkTreeView* tree_view, \
GdkModifierType start_button_mask, GdkContentFormats* formats, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_enable_model_drag_source", "GtkTreeView*");
  Xen_check_type(Xen_is_GdkModifierType(start_button_mask), start_button_mask, 2, "gtk_tree_view_enable_model_drag_source", "GdkModifierType");
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 3, "gtk_tree_view_enable_model_drag_source", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gtk_tree_view_enable_model_drag_source", "GdkDragAction");
  gtk_tree_view_enable_model_drag_source(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GdkModifierType(start_button_mask), Xen_to_C_GdkContentFormats_(formats), 
                                         Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_tree_view_enable_model_drag_dest(Xen tree_view, Xen formats, Xen actions)
{
  #define H_gtk_tree_view_enable_model_drag_dest "void gtk_tree_view_enable_model_drag_dest(GtkTreeView* tree_view, \
GdkContentFormats* formats, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkTreeView_(tree_view), tree_view, 1, "gtk_tree_view_enable_model_drag_dest", "GtkTreeView*");
  Xen_check_type(Xen_is_GdkContentFormats_(formats), formats, 2, "gtk_tree_view_enable_model_drag_dest", "GdkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 3, "gtk_tree_view_enable_model_drag_dest", "GdkDragAction");
  gtk_tree_view_enable_model_drag_dest(Xen_to_C_GtkTreeView_(tree_view), Xen_to_C_GdkContentFormats_(formats), Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_width(Xen widget)
{
  #define H_gtk_widget_get_width "int gtk_widget_get_width(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_width", "GtkWidget*");
  return(C_to_Xen_int(gtk_widget_get_width(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_height(Xen widget)
{
  #define H_gtk_widget_get_height "int gtk_widget_get_height(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_height", "GtkWidget*");
  return(C_to_Xen_int(gtk_widget_get_height(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_clipboard(Xen widget)
{
  #define H_gtk_widget_get_clipboard "GdkClipboard* gtk_widget_get_clipboard(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_clipboard", "GtkWidget*");
  return(C_to_Xen_GdkClipboard_(gtk_widget_get_clipboard(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_get_primary_clipboard(Xen widget)
{
  #define H_gtk_widget_get_primary_clipboard "GdkClipboard* gtk_widget_get_primary_clipboard(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_primary_clipboard", "GtkWidget*");
  return(C_to_Xen_GdkClipboard_(gtk_widget_get_primary_clipboard(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_widget_contains(Xen widget, Xen x, Xen y)
{
  #define H_gtk_widget_contains "gboolean gtk_widget_contains(GtkWidget* widget, gdouble x, gdouble y)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_contains", "GtkWidget*");
  Xen_check_type(Xen_is_gdouble(x), x, 2, "gtk_widget_contains", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 3, "gtk_widget_contains", "gdouble");
  return(C_to_Xen_gboolean(gtk_widget_contains(Xen_to_C_GtkWidget_(widget), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y))));
}

static Xen gxg_gtk_widget_pick(Xen widget, Xen x, Xen y)
{
  #define H_gtk_widget_pick "GtkWidget* gtk_widget_pick(GtkWidget* widget, gdouble x, gdouble y)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_pick", "GtkWidget*");
  Xen_check_type(Xen_is_gdouble(x), x, 2, "gtk_widget_pick", "gdouble");
  Xen_check_type(Xen_is_gdouble(y), y, 3, "gtk_widget_pick", "gdouble");
  return(C_to_Xen_GtkWidget_(gtk_widget_pick(Xen_to_C_GtkWidget_(widget), Xen_to_C_gdouble(x), Xen_to_C_gdouble(y))));
}

static Xen gxg_gtk_widget_set_cursor(Xen widget, Xen cursor)
{
  #define H_gtk_widget_set_cursor "void gtk_widget_set_cursor(GtkWidget* widget, GdkCursor* cursor)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_cursor", "GtkWidget*");
  Xen_check_type(Xen_is_GdkCursor_(cursor), cursor, 2, "gtk_widget_set_cursor", "GdkCursor*");
  gtk_widget_set_cursor(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkCursor_(cursor));
  return(Xen_false);
}

static Xen gxg_gtk_widget_set_cursor_from_name(Xen widget, Xen name)
{
  #define H_gtk_widget_set_cursor_from_name "void gtk_widget_set_cursor_from_name(GtkWidget* widget, \
char* name)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_set_cursor_from_name", "GtkWidget*");
  Xen_check_type(Xen_is_char_(name), name, 2, "gtk_widget_set_cursor_from_name", "char*");
  gtk_widget_set_cursor_from_name(Xen_to_C_GtkWidget_(widget), (const char*)Xen_to_C_char_(name));
  return(Xen_false);
}

static Xen gxg_gtk_widget_get_cursor(Xen widget)
{
  #define H_gtk_widget_get_cursor "GdkCursor* gtk_widget_get_cursor(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_widget_get_cursor", "GtkWidget*");
  return(C_to_Xen_GdkCursor_(gtk_widget_get_cursor(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_window_set_display(Xen window, Xen display)
{
  #define H_gtk_window_set_display "void gtk_window_set_display(GtkWindow* window, GdkDisplay* display)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_display", "GtkWindow*");
  Xen_check_type(Xen_is_GdkDisplay_(display), display, 2, "gtk_window_set_display", "GdkDisplay*");
  gtk_window_set_display(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkDisplay_(display));
  return(Xen_false);
}

static Xen gxg_gtk_window_set_icon(Xen window, Xen icon)
{
  #define H_gtk_window_set_icon "void gtk_window_set_icon(GtkWindow* window, GdkTexture* icon)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_set_icon", "GtkWindow*");
  Xen_check_type(Xen_is_GdkTexture_(icon), icon, 2, "gtk_window_set_icon", "GdkTexture*");
  gtk_window_set_icon(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkTexture_(icon));
  return(Xen_false);
}

static Xen gxg_gtk_window_get_icon(Xen window)
{
  #define H_gtk_window_get_icon "GdkTexture* gtk_window_get_icon(GtkWindow* window)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_get_icon", "GtkWindow*");
  return(C_to_Xen_GdkTexture_(gtk_window_get_icon(Xen_to_C_GtkWindow_(window))));
}

static Xen gxg_gtk_window_set_default_icon(Xen icon)
{
  #define H_gtk_window_set_default_icon "void gtk_window_set_default_icon(GdkTexture* icon)"
  Xen_check_type(Xen_is_GdkTexture_(icon), icon, 1, "gtk_window_set_default_icon", "GdkTexture*");
  gtk_window_set_default_icon(Xen_to_C_GdkTexture_(icon));
  return(Xen_false);
}

static Xen gxg_gtk_window_fullscreen_on_monitor(Xen window, Xen monitor)
{
  #define H_gtk_window_fullscreen_on_monitor "void gtk_window_fullscreen_on_monitor(GtkWindow* window, \
GdkMonitor* monitor)"
  Xen_check_type(Xen_is_GtkWindow_(window), window, 1, "gtk_window_fullscreen_on_monitor", "GtkWindow*");
  Xen_check_type(Xen_is_GdkMonitor_(monitor), monitor, 2, "gtk_window_fullscreen_on_monitor", "GdkMonitor*");
  gtk_window_fullscreen_on_monitor(Xen_to_C_GtkWindow_(window), Xen_to_C_GdkMonitor_(monitor));
  return(Xen_false);
}

static Xen gxg_gtk_text_iter_get_texture(Xen iter)
{
  #define H_gtk_text_iter_get_texture "GdkTexture* gtk_text_iter_get_texture(GtkTextIter* iter)"
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 1, "gtk_text_iter_get_texture", "GtkTextIter*");
  return(C_to_Xen_GdkTexture_(gtk_text_iter_get_texture(Xen_to_C_GtkTextIter_(iter))));
}

static Xen gxg_gtk_icon_view_enable_model_drag_source(Xen icon_view, Xen start_button_mask, Xen targets, Xen actions)
{
  #define H_gtk_icon_view_enable_model_drag_source "void gtk_icon_view_enable_model_drag_source(GtkIconView* icon_view, \
GdkModifierType start_button_mask, GtkContentFormats* targets, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_enable_model_drag_source", "GtkIconView*");
  Xen_check_type(Xen_is_GdkModifierType(start_button_mask), start_button_mask, 2, "gtk_icon_view_enable_model_drag_source", "GdkModifierType");
  Xen_check_type(Xen_is_GtkContentFormats_(targets), targets, 3, "gtk_icon_view_enable_model_drag_source", "GtkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gtk_icon_view_enable_model_drag_source", "GdkDragAction");
  gtk_icon_view_enable_model_drag_source(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GdkModifierType(start_button_mask), Xen_to_C_GtkContentFormats_(targets), 
                                         Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_icon_view_enable_model_drag_dest(Xen icon_view, Xen targets, Xen actions)
{
  #define H_gtk_icon_view_enable_model_drag_dest "void gtk_icon_view_enable_model_drag_dest(GtkIconView* icon_view, \
GtkContentFormats* targets, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkIconView_(icon_view), icon_view, 1, "gtk_icon_view_enable_model_drag_dest", "GtkIconView*");
  Xen_check_type(Xen_is_GtkContentFormats_(targets), targets, 2, "gtk_icon_view_enable_model_drag_dest", "GtkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 3, "gtk_icon_view_enable_model_drag_dest", "GdkDragAction");
  gtk_icon_view_enable_model_drag_dest(Xen_to_C_GtkIconView_(icon_view), Xen_to_C_GtkContentFormats_(targets), Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_about_dialog_get_logo(Xen about)
{
  #define H_gtk_about_dialog_get_logo "GdkTexture* gtk_about_dialog_get_logo(GtkAboutDialog* about)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_get_logo", "GtkAboutDialog*");
  return(C_to_Xen_GdkTexture_(gtk_about_dialog_get_logo(Xen_to_C_GtkAboutDialog_(about))));
}

static Xen gxg_gtk_about_dialog_set_logo(Xen about, Xen logo)
{
  #define H_gtk_about_dialog_set_logo "void gtk_about_dialog_set_logo(GtkAboutDialog* about, GdkTexture* logo)"
  Xen_check_type(Xen_is_GtkAboutDialog_(about), about, 1, "gtk_about_dialog_set_logo", "GtkAboutDialog*");
  Xen_check_type(Xen_is_GdkTexture_(logo) || Xen_is_false(logo), logo, 2, "gtk_about_dialog_set_logo", "GdkTexture*");
  gtk_about_dialog_set_logo(Xen_to_C_GtkAboutDialog_(about), Xen_to_C_GdkTexture_(logo));
  return(Xen_false);
}

static Xen gxg_gtk_button_new_from_icon_name(Xen icon_name)
{
  #define H_gtk_button_new_from_icon_name "GtkWidget* gtk_button_new_from_icon_name(gchar* icon_name)"
  Xen_check_type(Xen_is_gchar_(icon_name), icon_name, 1, "gtk_button_new_from_icon_name", "gchar*");
  return(C_to_Xen_GtkWidget_(gtk_button_new_from_icon_name((const gchar*)Xen_to_C_gchar_(icon_name))));
}

static Xen gxg_gtk_cell_view_new_with_texture(Xen texture)
{
  #define H_gtk_cell_view_new_with_texture "GtkWidget* gtk_cell_view_new_with_texture(GdkTexture* texture)"
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 1, "gtk_cell_view_new_with_texture", "GdkTexture*");
  return(C_to_Xen_GtkWidget_(gtk_cell_view_new_with_texture(Xen_to_C_GdkTexture_(texture))));
}

static Xen gxg_gtk_drag_finish(Xen context, Xen success, Xen time)
{
  #define H_gtk_drag_finish "void gtk_drag_finish(GdkDragContext* context, gboolean success, guint32 time)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_finish", "GdkDragContext*");
  Xen_check_type(Xen_is_gboolean(success), success, 2, "gtk_drag_finish", "gboolean");
  Xen_check_type(Xen_is_guint32(time), time, 3, "gtk_drag_finish", "guint32");
  gtk_drag_finish(Xen_to_C_GdkDragContext_(context), Xen_to_C_gboolean(success), Xen_to_C_guint32(time));
  return(Xen_false);
}

static Xen gxg_gtk_drag_set_icon_pixbuf(Xen context, Xen texture, Xen hot_x, Xen hot_y)
{
  #define H_gtk_drag_set_icon_pixbuf "void gtk_drag_set_icon_pixbuf(GdkDragContext* context, GdkTexture* texture, \
gint hot_x, gint hot_y)"
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 1, "gtk_drag_set_icon_pixbuf", "GdkDragContext*");
  Xen_check_type(Xen_is_GdkTexture_(texture), texture, 2, "gtk_drag_set_icon_pixbuf", "GdkTexture*");
  Xen_check_type(Xen_is_gint(hot_x), hot_x, 3, "gtk_drag_set_icon_pixbuf", "gint");
  Xen_check_type(Xen_is_gint(hot_y), hot_y, 4, "gtk_drag_set_icon_pixbuf", "gint");
  gtk_drag_set_icon_pixbuf(Xen_to_C_GdkDragContext_(context), Xen_to_C_GdkTexture_(texture), Xen_to_C_gint(hot_x), Xen_to_C_gint(hot_y));
  return(Xen_false);
}

static Xen gxg_gtk_drag_dest_set(Xen widget, Xen flags, Xen targets, Xen actions)
{
  #define H_gtk_drag_dest_set "void gtk_drag_dest_set(GtkWidget* widget, GtkDestDefaults flags, GtkContentFormats* targets, \
GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_set", "GtkWidget*");
  Xen_check_type(Xen_is_GtkDestDefaults(flags), flags, 2, "gtk_drag_dest_set", "GtkDestDefaults");
  Xen_check_type(Xen_is_GtkContentFormats_(targets), targets, 3, "gtk_drag_dest_set", "GtkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gtk_drag_dest_set", "GdkDragAction");
  gtk_drag_dest_set(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkDestDefaults(flags), Xen_to_C_GtkContentFormats_(targets), Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_drag_dest_find_target(Xen widget, Xen context, Xen target_list)
{
  #define H_gtk_drag_dest_find_target "char* gtk_drag_dest_find_target(GtkWidget* widget, GdkDragContext* context, \
GtkContentFormats* target_list)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_find_target", "GtkWidget*");
  Xen_check_type(Xen_is_GdkDragContext_(context), context, 2, "gtk_drag_dest_find_target", "GdkDragContext*");
  Xen_check_type(Xen_is_GtkContentFormats_(target_list) || Xen_is_false(target_list), target_list, 3, "gtk_drag_dest_find_target", "GtkContentFormats*");
    return(C_to_Xen_char_((char*)gtk_drag_dest_find_target(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkDragContext_(context), Xen_to_C_GtkContentFormats_(target_list))));
}

static Xen gxg_gtk_drag_dest_get_target_list(Xen widget)
{
  #define H_gtk_drag_dest_get_target_list "GtkContentFormats* gtk_drag_dest_get_target_list(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_get_target_list", "GtkWidget*");
  return(C_to_Xen_GtkContentFormats_(gtk_drag_dest_get_target_list(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_drag_dest_set_target_list(Xen widget, Xen target_list)
{
  #define H_gtk_drag_dest_set_target_list "void gtk_drag_dest_set_target_list(GtkWidget* widget, GtkContentFormats* target_list)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_dest_set_target_list", "GtkWidget*");
  Xen_check_type(Xen_is_GtkContentFormats_(target_list) || Xen_is_false(target_list), target_list, 2, "gtk_drag_dest_set_target_list", "GtkContentFormats*");
  gtk_drag_dest_set_target_list(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkContentFormats_(target_list));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_set(Xen widget, Xen start_button_mask, Xen targets, Xen actions)
{
  #define H_gtk_drag_source_set "void gtk_drag_source_set(GtkWidget* widget, GdkModifierType start_button_mask, \
GtkContentFormats* targets, GdkDragAction actions)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_set", "GtkWidget*");
  Xen_check_type(Xen_is_GdkModifierType(start_button_mask), start_button_mask, 2, "gtk_drag_source_set", "GdkModifierType");
  Xen_check_type(Xen_is_GtkContentFormats_(targets), targets, 3, "gtk_drag_source_set", "GtkContentFormats*");
  Xen_check_type(Xen_is_GdkDragAction(actions), actions, 4, "gtk_drag_source_set", "GdkDragAction");
  gtk_drag_source_set(Xen_to_C_GtkWidget_(widget), Xen_to_C_GdkModifierType(start_button_mask), Xen_to_C_GtkContentFormats_(targets), 
                      Xen_to_C_GdkDragAction(actions));
  return(Xen_false);
}

static Xen gxg_gtk_drag_source_get_target_list(Xen widget)
{
  #define H_gtk_drag_source_get_target_list "GtkContentFormats* gtk_drag_source_get_target_list(GtkWidget* widget)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_get_target_list", "GtkWidget*");
  return(C_to_Xen_GtkContentFormats_(gtk_drag_source_get_target_list(Xen_to_C_GtkWidget_(widget))));
}

static Xen gxg_gtk_drag_source_set_target_list(Xen widget, Xen target_list)
{
  #define H_gtk_drag_source_set_target_list "void gtk_drag_source_set_target_list(GtkWidget* widget, \
GtkContentFormats* target_list)"
  Xen_check_type(Xen_is_GtkWidget_(widget), widget, 1, "gtk_drag_source_set_target_list", "GtkWidget*");
  Xen_check_type(Xen_is_GtkContentFormats_(target_list) || Xen_is_false(target_list), target_list, 2, "gtk_drag_source_set_target_list", "GtkContentFormats*");
  gtk_drag_source_set_target_list(Xen_to_C_GtkWidget_(widget), Xen_to_C_GtkContentFormats_(target_list));
  return(Xen_false);
}

static Xen gxg_gtk_scale_button_new(Xen min, Xen max, Xen step, Xen icons)
{
  #define H_gtk_scale_button_new "GtkWidget* gtk_scale_button_new(gdouble min, gdouble max, gdouble step, \
gchar** icons)"
  Xen_check_type(Xen_is_gdouble(min), min, 1, "gtk_scale_button_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(max), max, 2, "gtk_scale_button_new", "gdouble");
  Xen_check_type(Xen_is_gdouble(step), step, 3, "gtk_scale_button_new", "gdouble");
  Xen_check_type(Xen_is_gchar__(icons), icons, 4, "gtk_scale_button_new", "gchar**");
  return(C_to_Xen_GtkWidget_(gtk_scale_button_new(Xen_to_C_gdouble(min), Xen_to_C_gdouble(max), Xen_to_C_gdouble(step), (const gchar**)Xen_to_C_gchar__(icons))));
}

static Xen gxg_gtk_application_new(Xen application_id, Xen flags)
{
  #define H_gtk_application_new "GtkApplication* gtk_application_new(gchar* application_id, GApplicationFlags flags)"
  Xen_check_type(Xen_is_gchar_(application_id), application_id, 1, "gtk_application_new", "gchar*");
  Xen_check_type(Xen_is_GApplicationFlags(flags), flags, 2, "gtk_application_new", "GApplicationFlags");
  return(C_to_Xen_GtkApplication_(gtk_application_new((const gchar*)Xen_to_C_gchar_(application_id), Xen_to_C_GApplicationFlags(flags))));
}

static Xen gxg_gtk_application_add_window(Xen application, Xen window)
{
  #define H_gtk_application_add_window "void gtk_application_add_window(GtkApplication* application, \
GtkWindow* window)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_add_window", "GtkApplication*");
  Xen_check_type(Xen_is_GtkWindow_(window), window, 2, "gtk_application_add_window", "GtkWindow*");
  gtk_application_add_window(Xen_to_C_GtkApplication_(application), Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_application_remove_window(Xen application, Xen window)
{
  #define H_gtk_application_remove_window "void gtk_application_remove_window(GtkApplication* application, \
GtkWindow* window)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_remove_window", "GtkApplication*");
  Xen_check_type(Xen_is_GtkWindow_(window), window, 2, "gtk_application_remove_window", "GtkWindow*");
  gtk_application_remove_window(Xen_to_C_GtkApplication_(application), Xen_to_C_GtkWindow_(window));
  return(Xen_false);
}

static Xen gxg_gtk_application_get_windows(Xen application)
{
  #define H_gtk_application_get_windows "GList* gtk_application_get_windows(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_windows", "GtkApplication*");
  return(C_to_Xen_GList_(gtk_application_get_windows(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_application_inhibit(Xen application, Xen window, Xen flags, Xen reason)
{
  #define H_gtk_application_inhibit "guint gtk_application_inhibit(GtkApplication* application, GtkWindow* window, \
GtkApplicationInhibitFlags flags, gchar* reason)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_inhibit", "GtkApplication*");
  Xen_check_type(Xen_is_GtkWindow_(window), window, 2, "gtk_application_inhibit", "GtkWindow*");
  Xen_check_type(Xen_is_GtkApplicationInhibitFlags(flags), flags, 3, "gtk_application_inhibit", "GtkApplicationInhibitFlags");
  Xen_check_type(Xen_is_gchar_(reason), reason, 4, "gtk_application_inhibit", "gchar*");
  return(C_to_Xen_guint(gtk_application_inhibit(Xen_to_C_GtkApplication_(application), Xen_to_C_GtkWindow_(window), Xen_to_C_GtkApplicationInhibitFlags(flags), 
                                                (const gchar*)Xen_to_C_gchar_(reason))));
}

static Xen gxg_gtk_application_uninhibit(Xen application, Xen cookie)
{
  #define H_gtk_application_uninhibit "void gtk_application_uninhibit(GtkApplication* application, guint cookie)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_uninhibit", "GtkApplication*");
  Xen_check_type(Xen_is_guint(cookie), cookie, 2, "gtk_application_uninhibit", "guint");
  gtk_application_uninhibit(Xen_to_C_GtkApplication_(application), Xen_to_C_guint(cookie));
  return(Xen_false);
}

static Xen gxg_gtk_application_get_window_by_id(Xen application, Xen id)
{
  #define H_gtk_application_get_window_by_id "GtkWindow* gtk_application_get_window_by_id(GtkApplication* application, \
guint id)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_window_by_id", "GtkApplication*");
  Xen_check_type(Xen_is_guint(id), id, 2, "gtk_application_get_window_by_id", "guint");
  return(C_to_Xen_GtkWindow_(gtk_application_get_window_by_id(Xen_to_C_GtkApplication_(application), Xen_to_C_guint(id))));
}

static Xen gxg_gtk_application_list_action_descriptions(Xen application)
{
  #define H_gtk_application_list_action_descriptions "gchar** gtk_application_list_action_descriptions(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_list_action_descriptions", "GtkApplication*");
  return(C_to_Xen_gchar__(gtk_application_list_action_descriptions(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_application_get_accels_for_action(Xen application, Xen detailed_action_name)
{
  #define H_gtk_application_get_accels_for_action "gchar** gtk_application_get_accels_for_action(GtkApplication* application, \
gchar* detailed_action_name)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_accels_for_action", "GtkApplication*");
  Xen_check_type(Xen_is_gchar_(detailed_action_name), detailed_action_name, 2, "gtk_application_get_accels_for_action", "gchar*");
  return(C_to_Xen_gchar__(gtk_application_get_accels_for_action(Xen_to_C_GtkApplication_(application), (const gchar*)Xen_to_C_gchar_(detailed_action_name))));
}

static Xen gxg_gtk_application_get_actions_for_accel(Xen application, Xen accel)
{
  #define H_gtk_application_get_actions_for_accel "gchar** gtk_application_get_actions_for_accel(GtkApplication* application, \
gchar* accel)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_actions_for_accel", "GtkApplication*");
  Xen_check_type(Xen_is_gchar_(accel), accel, 2, "gtk_application_get_actions_for_accel", "gchar*");
  return(C_to_Xen_gchar__(gtk_application_get_actions_for_accel(Xen_to_C_GtkApplication_(application), (const gchar*)Xen_to_C_gchar_(accel))));
}

static Xen gxg_gtk_application_set_accels_for_action(Xen application, Xen detailed_action_name, Xen accels)
{
  #define H_gtk_application_set_accels_for_action "void gtk_application_set_accels_for_action(GtkApplication* application, \
gchar* detailed_action_name, gchar* accels)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_set_accels_for_action", "GtkApplication*");
  Xen_check_type(Xen_is_gchar_(detailed_action_name), detailed_action_name, 2, "gtk_application_set_accels_for_action", "gchar*");
  Xen_check_type(Xen_is_gchar_(accels), accels, 3, "gtk_application_set_accels_for_action", "gchar*");
  gtk_application_set_accels_for_action(Xen_to_C_GtkApplication_(application), (const gchar*)Xen_to_C_gchar_(detailed_action_name), (const gchar*)Xen_to_C_gchar_(accels));
  return(Xen_false);
}

static Xen gxg_gtk_application_prefers_app_menu(Xen application)
{
  #define H_gtk_application_prefers_app_menu "gboolean gtk_application_prefers_app_menu(GtkApplication* application)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_prefers_app_menu", "GtkApplication*");
  return(C_to_Xen_gboolean(gtk_application_prefers_app_menu(Xen_to_C_GtkApplication_(application))));
}

static Xen gxg_gtk_application_get_menu_by_id(Xen application, Xen id)
{
  #define H_gtk_application_get_menu_by_id "GMenu* gtk_application_get_menu_by_id(GtkApplication* application, \
gchar* id)"
  Xen_check_type(Xen_is_GtkApplication_(application), application, 1, "gtk_application_get_menu_by_id", "GtkApplication*");
  Xen_check_type(Xen_is_gchar_(id), id, 2, "gtk_application_get_menu_by_id", "gchar*");
  return(C_to_Xen_GMenu_(gtk_application_get_menu_by_id(Xen_to_C_GtkApplication_(application), (const gchar*)Xen_to_C_gchar_(id))));
}

#endif

static Xen gxg_cairo_create(Xen target)
{
  #define H_cairo_create "cairo_t* cairo_create(cairo_surface_t* target)"
  Xen_check_type(Xen_is_cairo_surface_t_(target), target, 1, "cairo_create", "cairo_surface_t*");
  return(C_to_Xen_cairo_t_(cairo_create(Xen_to_C_cairo_surface_t_(target))));
}

static Xen gxg_cairo_version(void)
{
  #define H_cairo_version "int cairo_version( void)"
  return(C_to_Xen_int(cairo_version()));
}

static Xen gxg_cairo_version_string(void)
{
  #define H_cairo_version_string "char* cairo_version_string( void)"
  return(C_to_Xen_char_(cairo_version_string()));
}

static Xen gxg_cairo_reference(Xen cr)
{
  #define H_cairo_reference "cairo_t* cairo_reference(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_reference", "cairo_t*");
  return(C_to_Xen_cairo_t_(cairo_reference(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_destroy(Xen cr)
{
  #define H_cairo_destroy "void cairo_destroy(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_destroy", "cairo_t*");
  cairo_destroy(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_save(Xen cr)
{
  #define H_cairo_save "void cairo_save(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_save", "cairo_t*");
  cairo_save(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_restore(Xen cr)
{
  #define H_cairo_restore "void cairo_restore(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_restore", "cairo_t*");
  cairo_restore(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_push_group(Xen cr)
{
  #define H_cairo_push_group "void cairo_push_group(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_push_group", "cairo_t*");
  cairo_push_group(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_push_group_with_content(Xen cr, Xen content)
{
  #define H_cairo_push_group_with_content "void cairo_push_group_with_content(cairo_t* cr, cairo_content_t content)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_push_group_with_content", "cairo_t*");
  Xen_check_type(Xen_is_cairo_content_t(content), content, 2, "cairo_push_group_with_content", "cairo_content_t");
  cairo_push_group_with_content(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_content_t(content));
  return(Xen_false);
}

static Xen gxg_cairo_pop_group(Xen cr)
{
  #define H_cairo_pop_group "cairo_pattern_t* cairo_pop_group(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_pop_group", "cairo_t*");
  return(C_to_Xen_cairo_pattern_t_(cairo_pop_group(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_pop_group_to_source(Xen cr)
{
  #define H_cairo_pop_group_to_source "void cairo_pop_group_to_source(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_pop_group_to_source", "cairo_t*");
  cairo_pop_group_to_source(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_set_operator(Xen cr, Xen op)
{
  #define H_cairo_set_operator "void cairo_set_operator(cairo_t* cr, cairo_operator_t op)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_operator", "cairo_t*");
  Xen_check_type(Xen_is_cairo_operator_t(op), op, 2, "cairo_set_operator", "cairo_operator_t");
  cairo_set_operator(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_operator_t(op));
  return(Xen_false);
}

static Xen gxg_cairo_set_source(Xen cr, Xen source)
{
  #define H_cairo_set_source "void cairo_set_source(cairo_t* cr, cairo_pattern_t* source)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_source", "cairo_t*");
  Xen_check_type(Xen_is_cairo_pattern_t_(source), source, 2, "cairo_set_source", "cairo_pattern_t*");
  cairo_set_source(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_pattern_t_(source));
  return(Xen_false);
}

static Xen gxg_cairo_set_source_rgb(Xen cr, Xen red, Xen green, Xen blue)
{
  #define H_cairo_set_source_rgb "void cairo_set_source_rgb(cairo_t* cr, double red, double green, double blue)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_source_rgb", "cairo_t*");
  Xen_check_type(Xen_is_double(red), red, 2, "cairo_set_source_rgb", "double");
  Xen_check_type(Xen_is_double(green), green, 3, "cairo_set_source_rgb", "double");
  Xen_check_type(Xen_is_double(blue), blue, 4, "cairo_set_source_rgb", "double");
  cairo_set_source_rgb(Xen_to_C_cairo_t_(cr), Xen_to_C_double(red), Xen_to_C_double(green), Xen_to_C_double(blue));
  return(Xen_false);
}

static Xen gxg_cairo_set_source_rgba(Xen cr, Xen red, Xen green, Xen blue, Xen alpha)
{
  #define H_cairo_set_source_rgba "void cairo_set_source_rgba(cairo_t* cr, double red, double green, \
double blue, double alpha)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_source_rgba", "cairo_t*");
  Xen_check_type(Xen_is_double(red), red, 2, "cairo_set_source_rgba", "double");
  Xen_check_type(Xen_is_double(green), green, 3, "cairo_set_source_rgba", "double");
  Xen_check_type(Xen_is_double(blue), blue, 4, "cairo_set_source_rgba", "double");
  Xen_check_type(Xen_is_double(alpha), alpha, 5, "cairo_set_source_rgba", "double");
  cairo_set_source_rgba(Xen_to_C_cairo_t_(cr), Xen_to_C_double(red), Xen_to_C_double(green), Xen_to_C_double(blue), Xen_to_C_double(alpha));
  return(Xen_false);
}

static Xen gxg_cairo_set_source_surface(Xen cr, Xen surface, Xen x, Xen y)
{
  #define H_cairo_set_source_surface "void cairo_set_source_surface(cairo_t* cr, cairo_surface_t* surface, \
double x, double y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_source_surface", "cairo_t*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 2, "cairo_set_source_surface", "cairo_surface_t*");
  Xen_check_type(Xen_is_double(x), x, 3, "cairo_set_source_surface", "double");
  Xen_check_type(Xen_is_double(y), y, 4, "cairo_set_source_surface", "double");
  cairo_set_source_surface(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_surface_t_(surface), Xen_to_C_double(x), Xen_to_C_double(y));
  return(Xen_false);
}

static Xen gxg_cairo_set_tolerance(Xen cr, Xen tolerance)
{
  #define H_cairo_set_tolerance "void cairo_set_tolerance(cairo_t* cr, double tolerance)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_tolerance", "cairo_t*");
  Xen_check_type(Xen_is_double(tolerance), tolerance, 2, "cairo_set_tolerance", "double");
  cairo_set_tolerance(Xen_to_C_cairo_t_(cr), Xen_to_C_double(tolerance));
  return(Xen_false);
}

static Xen gxg_cairo_set_antialias(Xen cr, Xen antialias)
{
  #define H_cairo_set_antialias "void cairo_set_antialias(cairo_t* cr, cairo_antialias_t antialias)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_antialias", "cairo_t*");
  Xen_check_type(Xen_is_cairo_antialias_t(antialias), antialias, 2, "cairo_set_antialias", "cairo_antialias_t");
  cairo_set_antialias(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_antialias_t(antialias));
  return(Xen_false);
}

static Xen gxg_cairo_set_fill_rule(Xen cr, Xen fill_rule)
{
  #define H_cairo_set_fill_rule "void cairo_set_fill_rule(cairo_t* cr, cairo_fill_rule_t fill_rule)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_fill_rule", "cairo_t*");
  Xen_check_type(Xen_is_cairo_fill_rule_t(fill_rule), fill_rule, 2, "cairo_set_fill_rule", "cairo_fill_rule_t");
  cairo_set_fill_rule(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_fill_rule_t(fill_rule));
  return(Xen_false);
}

static Xen gxg_cairo_set_line_width(Xen cr, Xen width)
{
  #define H_cairo_set_line_width "void cairo_set_line_width(cairo_t* cr, double width)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_line_width", "cairo_t*");
  Xen_check_type(Xen_is_double(width), width, 2, "cairo_set_line_width", "double");
  cairo_set_line_width(Xen_to_C_cairo_t_(cr), Xen_to_C_double(width));
  return(Xen_false);
}

static Xen gxg_cairo_set_line_cap(Xen cr, Xen line_cap)
{
  #define H_cairo_set_line_cap "void cairo_set_line_cap(cairo_t* cr, cairo_line_cap_t line_cap)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_line_cap", "cairo_t*");
  Xen_check_type(Xen_is_cairo_line_cap_t(line_cap), line_cap, 2, "cairo_set_line_cap", "cairo_line_cap_t");
  cairo_set_line_cap(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_line_cap_t(line_cap));
  return(Xen_false);
}

static Xen gxg_cairo_set_line_join(Xen cr, Xen line_join)
{
  #define H_cairo_set_line_join "void cairo_set_line_join(cairo_t* cr, cairo_line_join_t line_join)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_line_join", "cairo_t*");
  Xen_check_type(Xen_is_cairo_line_join_t(line_join), line_join, 2, "cairo_set_line_join", "cairo_line_join_t");
  cairo_set_line_join(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_line_join_t(line_join));
  return(Xen_false);
}

static Xen gxg_cairo_set_dash(Xen cr, Xen dashes, Xen num_dashes, Xen offset)
{
  #define H_cairo_set_dash "void cairo_set_dash(cairo_t* cr, gdouble* dashes, int num_dashes, double offset)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_dash", "cairo_t*");
  Xen_check_type(Xen_is_gdouble_(dashes), dashes, 2, "cairo_set_dash", "gdouble*");
  Xen_check_type(Xen_is_int(num_dashes), num_dashes, 3, "cairo_set_dash", "int");
  Xen_check_type(Xen_is_double(offset), offset, 4, "cairo_set_dash", "double");
  cairo_set_dash(Xen_to_C_cairo_t_(cr), Xen_to_C_gdouble_(dashes), Xen_to_C_int(num_dashes), Xen_to_C_double(offset));
  return(Xen_false);
}

static Xen gxg_cairo_set_miter_limit(Xen cr, Xen limit)
{
  #define H_cairo_set_miter_limit "void cairo_set_miter_limit(cairo_t* cr, double limit)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_miter_limit", "cairo_t*");
  Xen_check_type(Xen_is_double(limit), limit, 2, "cairo_set_miter_limit", "double");
  cairo_set_miter_limit(Xen_to_C_cairo_t_(cr), Xen_to_C_double(limit));
  return(Xen_false);
}

static Xen gxg_cairo_translate(Xen cr, Xen tx, Xen ty)
{
  #define H_cairo_translate "void cairo_translate(cairo_t* cr, double tx, double ty)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_translate", "cairo_t*");
  Xen_check_type(Xen_is_double(tx), tx, 2, "cairo_translate", "double");
  Xen_check_type(Xen_is_double(ty), ty, 3, "cairo_translate", "double");
  cairo_translate(Xen_to_C_cairo_t_(cr), Xen_to_C_double(tx), Xen_to_C_double(ty));
  return(Xen_false);
}

static Xen gxg_cairo_scale(Xen cr, Xen sx, Xen sy)
{
  #define H_cairo_scale "void cairo_scale(cairo_t* cr, double sx, double sy)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_scale", "cairo_t*");
  Xen_check_type(Xen_is_double(sx), sx, 2, "cairo_scale", "double");
  Xen_check_type(Xen_is_double(sy), sy, 3, "cairo_scale", "double");
  cairo_scale(Xen_to_C_cairo_t_(cr), Xen_to_C_double(sx), Xen_to_C_double(sy));
  return(Xen_false);
}

static Xen gxg_cairo_rotate(Xen cr, Xen angle)
{
  #define H_cairo_rotate "void cairo_rotate(cairo_t* cr, double angle)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_rotate", "cairo_t*");
  Xen_check_type(Xen_is_double(angle), angle, 2, "cairo_rotate", "double");
  cairo_rotate(Xen_to_C_cairo_t_(cr), Xen_to_C_double(angle));
  return(Xen_false);
}

static Xen gxg_cairo_transform(Xen cr, Xen matrix)
{
  #define H_cairo_transform "void cairo_transform(cairo_t* cr, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_transform", "cairo_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_transform", "cairo_matrix_t*");
  cairo_transform(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_set_matrix(Xen cr, Xen matrix)
{
  #define H_cairo_set_matrix "void cairo_set_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_matrix", "cairo_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_set_matrix", "cairo_matrix_t*");
  cairo_set_matrix(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_identity_matrix(Xen cr)
{
  #define H_cairo_identity_matrix "void cairo_identity_matrix(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_identity_matrix", "cairo_t*");
  cairo_identity_matrix(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_user_to_device(Xen cr, Xen ignore_x, Xen ignore_y)
{
  #define H_cairo_user_to_device "void cairo_user_to_device(cairo_t* cr, gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_user_to_device", "cairo_t*");
  cairo_user_to_device(Xen_to_C_cairo_t_(cr), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
}

static Xen gxg_cairo_user_to_device_distance(Xen cr, Xen ignore_dx, Xen ignore_dy)
{
  #define H_cairo_user_to_device_distance "void cairo_user_to_device_distance(cairo_t* cr, gdouble* [dx], \
gdouble* [dy])"
  gdouble ref_dx;
  gdouble ref_dy;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_user_to_device_distance", "cairo_t*");
  cairo_user_to_device_distance(Xen_to_C_cairo_t_(cr), &ref_dx, &ref_dy);
  return(Xen_list_2(C_to_Xen_gdouble(ref_dx), C_to_Xen_gdouble(ref_dy)));
}

static Xen gxg_cairo_device_to_user(Xen cr, Xen ignore_x, Xen ignore_y)
{
  #define H_cairo_device_to_user "void cairo_device_to_user(cairo_t* cr, gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_device_to_user", "cairo_t*");
  cairo_device_to_user(Xen_to_C_cairo_t_(cr), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
}

static Xen gxg_cairo_device_to_user_distance(Xen cr, Xen ignore_dx, Xen ignore_dy)
{
  #define H_cairo_device_to_user_distance "void cairo_device_to_user_distance(cairo_t* cr, gdouble* [dx], \
gdouble* [dy])"
  gdouble ref_dx;
  gdouble ref_dy;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_device_to_user_distance", "cairo_t*");
  cairo_device_to_user_distance(Xen_to_C_cairo_t_(cr), &ref_dx, &ref_dy);
  return(Xen_list_2(C_to_Xen_gdouble(ref_dx), C_to_Xen_gdouble(ref_dy)));
}

static Xen gxg_cairo_new_path(Xen cr)
{
  #define H_cairo_new_path "void cairo_new_path(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_new_path", "cairo_t*");
  cairo_new_path(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_move_to(Xen cr, Xen x, Xen y)
{
  #define H_cairo_move_to "void cairo_move_to(cairo_t* cr, double x, double y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_move_to", "cairo_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_move_to", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_move_to", "double");
  cairo_move_to(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x), Xen_to_C_double(y));
  return(Xen_false);
}

static Xen gxg_cairo_new_sub_path(Xen cr)
{
  #define H_cairo_new_sub_path "void cairo_new_sub_path(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_new_sub_path", "cairo_t*");
  cairo_new_sub_path(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_line_to(Xen cr, Xen x, Xen y)
{
  #define H_cairo_line_to "void cairo_line_to(cairo_t* cr, double x, double y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_line_to", "cairo_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_line_to", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_line_to", "double");
  cairo_line_to(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x), Xen_to_C_double(y));
  return(Xen_false);
}

static Xen gxg_cairo_curve_to(Xen cr, Xen x1, Xen y1, Xen x2, Xen y2, Xen x3, Xen y3)
{
  #define H_cairo_curve_to "void cairo_curve_to(cairo_t* cr, double x1, double y1, double x2, double y2, \
double x3, double y3)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_curve_to", "cairo_t*");
  Xen_check_type(Xen_is_double(x1), x1, 2, "cairo_curve_to", "double");
  Xen_check_type(Xen_is_double(y1), y1, 3, "cairo_curve_to", "double");
  Xen_check_type(Xen_is_double(x2), x2, 4, "cairo_curve_to", "double");
  Xen_check_type(Xen_is_double(y2), y2, 5, "cairo_curve_to", "double");
  Xen_check_type(Xen_is_double(x3), x3, 6, "cairo_curve_to", "double");
  Xen_check_type(Xen_is_double(y3), y3, 7, "cairo_curve_to", "double");
  cairo_curve_to(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x1), Xen_to_C_double(y1), Xen_to_C_double(x2), Xen_to_C_double(y2), 
                 Xen_to_C_double(x3), Xen_to_C_double(y3));
  return(Xen_false);
}

static Xen gxg_cairo_arc(Xen cr, Xen xc, Xen yc, Xen radius, Xen angle1, Xen angle2)
{
  #define H_cairo_arc "void cairo_arc(cairo_t* cr, double xc, double yc, double radius, double angle1, \
double angle2)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_arc", "cairo_t*");
  Xen_check_type(Xen_is_double(xc), xc, 2, "cairo_arc", "double");
  Xen_check_type(Xen_is_double(yc), yc, 3, "cairo_arc", "double");
  Xen_check_type(Xen_is_double(radius), radius, 4, "cairo_arc", "double");
  Xen_check_type(Xen_is_double(angle1), angle1, 5, "cairo_arc", "double");
  Xen_check_type(Xen_is_double(angle2), angle2, 6, "cairo_arc", "double");
  cairo_arc(Xen_to_C_cairo_t_(cr), Xen_to_C_double(xc), Xen_to_C_double(yc), Xen_to_C_double(radius), Xen_to_C_double(angle1), 
            Xen_to_C_double(angle2));
  return(Xen_false);
}

static Xen gxg_cairo_arc_negative(Xen cr, Xen xc, Xen yc, Xen radius, Xen angle1, Xen angle2)
{
  #define H_cairo_arc_negative "void cairo_arc_negative(cairo_t* cr, double xc, double yc, double radius, \
double angle1, double angle2)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_arc_negative", "cairo_t*");
  Xen_check_type(Xen_is_double(xc), xc, 2, "cairo_arc_negative", "double");
  Xen_check_type(Xen_is_double(yc), yc, 3, "cairo_arc_negative", "double");
  Xen_check_type(Xen_is_double(radius), radius, 4, "cairo_arc_negative", "double");
  Xen_check_type(Xen_is_double(angle1), angle1, 5, "cairo_arc_negative", "double");
  Xen_check_type(Xen_is_double(angle2), angle2, 6, "cairo_arc_negative", "double");
  cairo_arc_negative(Xen_to_C_cairo_t_(cr), Xen_to_C_double(xc), Xen_to_C_double(yc), Xen_to_C_double(radius), Xen_to_C_double(angle1), 
                     Xen_to_C_double(angle2));
  return(Xen_false);
}

static Xen gxg_cairo_rel_move_to(Xen cr, Xen dx, Xen dy)
{
  #define H_cairo_rel_move_to "void cairo_rel_move_to(cairo_t* cr, double dx, double dy)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_rel_move_to", "cairo_t*");
  Xen_check_type(Xen_is_double(dx), dx, 2, "cairo_rel_move_to", "double");
  Xen_check_type(Xen_is_double(dy), dy, 3, "cairo_rel_move_to", "double");
  cairo_rel_move_to(Xen_to_C_cairo_t_(cr), Xen_to_C_double(dx), Xen_to_C_double(dy));
  return(Xen_false);
}

static Xen gxg_cairo_rel_line_to(Xen cr, Xen dx, Xen dy)
{
  #define H_cairo_rel_line_to "void cairo_rel_line_to(cairo_t* cr, double dx, double dy)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_rel_line_to", "cairo_t*");
  Xen_check_type(Xen_is_double(dx), dx, 2, "cairo_rel_line_to", "double");
  Xen_check_type(Xen_is_double(dy), dy, 3, "cairo_rel_line_to", "double");
  cairo_rel_line_to(Xen_to_C_cairo_t_(cr), Xen_to_C_double(dx), Xen_to_C_double(dy));
  return(Xen_false);
}

static Xen gxg_cairo_rel_curve_to(Xen cr, Xen dx1, Xen dy1, Xen dx2, Xen dy2, Xen dx3, Xen dy3)
{
  #define H_cairo_rel_curve_to "void cairo_rel_curve_to(cairo_t* cr, double dx1, double dy1, double dx2, \
double dy2, double dx3, double dy3)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_rel_curve_to", "cairo_t*");
  Xen_check_type(Xen_is_double(dx1), dx1, 2, "cairo_rel_curve_to", "double");
  Xen_check_type(Xen_is_double(dy1), dy1, 3, "cairo_rel_curve_to", "double");
  Xen_check_type(Xen_is_double(dx2), dx2, 4, "cairo_rel_curve_to", "double");
  Xen_check_type(Xen_is_double(dy2), dy2, 5, "cairo_rel_curve_to", "double");
  Xen_check_type(Xen_is_double(dx3), dx3, 6, "cairo_rel_curve_to", "double");
  Xen_check_type(Xen_is_double(dy3), dy3, 7, "cairo_rel_curve_to", "double");
  cairo_rel_curve_to(Xen_to_C_cairo_t_(cr), Xen_to_C_double(dx1), Xen_to_C_double(dy1), Xen_to_C_double(dx2), Xen_to_C_double(dy2), 
                     Xen_to_C_double(dx3), Xen_to_C_double(dy3));
  return(Xen_false);
}

static Xen gxg_cairo_rectangle(Xen cr, Xen x, Xen y, Xen width, Xen height)
{
  #define H_cairo_rectangle "void cairo_rectangle(cairo_t* cr, double x, double y, double width, double height)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_rectangle", "cairo_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_rectangle", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_rectangle", "double");
  Xen_check_type(Xen_is_double(width), width, 4, "cairo_rectangle", "double");
  Xen_check_type(Xen_is_double(height), height, 5, "cairo_rectangle", "double");
  cairo_rectangle(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x), Xen_to_C_double(y), Xen_to_C_double(width), Xen_to_C_double(height));
  return(Xen_false);
}

static Xen gxg_cairo_close_path(Xen cr)
{
  #define H_cairo_close_path "void cairo_close_path(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_close_path", "cairo_t*");
  cairo_close_path(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_paint(Xen cr)
{
  #define H_cairo_paint "void cairo_paint(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_paint", "cairo_t*");
  cairo_paint(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_paint_with_alpha(Xen cr, Xen alpha)
{
  #define H_cairo_paint_with_alpha "void cairo_paint_with_alpha(cairo_t* cr, double alpha)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_paint_with_alpha", "cairo_t*");
  Xen_check_type(Xen_is_double(alpha), alpha, 2, "cairo_paint_with_alpha", "double");
  cairo_paint_with_alpha(Xen_to_C_cairo_t_(cr), Xen_to_C_double(alpha));
  return(Xen_false);
}

static Xen gxg_cairo_mask(Xen cr, Xen pattern)
{
  #define H_cairo_mask "void cairo_mask(cairo_t* cr, cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_mask", "cairo_t*");
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 2, "cairo_mask", "cairo_pattern_t*");
  cairo_mask(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_pattern_t_(pattern));
  return(Xen_false);
}

static Xen gxg_cairo_mask_surface(Xen cr, Xen surface, Xen surface_x, Xen surface_y)
{
  #define H_cairo_mask_surface "void cairo_mask_surface(cairo_t* cr, cairo_surface_t* surface, double surface_x, \
double surface_y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_mask_surface", "cairo_t*");
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 2, "cairo_mask_surface", "cairo_surface_t*");
  Xen_check_type(Xen_is_double(surface_x), surface_x, 3, "cairo_mask_surface", "double");
  Xen_check_type(Xen_is_double(surface_y), surface_y, 4, "cairo_mask_surface", "double");
  cairo_mask_surface(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_surface_t_(surface), Xen_to_C_double(surface_x), Xen_to_C_double(surface_y));
  return(Xen_false);
}

static Xen gxg_cairo_stroke(Xen cr)
{
  #define H_cairo_stroke "void cairo_stroke(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_stroke", "cairo_t*");
  cairo_stroke(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_stroke_preserve(Xen cr)
{
  #define H_cairo_stroke_preserve "void cairo_stroke_preserve(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_stroke_preserve", "cairo_t*");
  cairo_stroke_preserve(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_fill(Xen cr)
{
  #define H_cairo_fill "void cairo_fill(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_fill", "cairo_t*");
  cairo_fill(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_fill_preserve(Xen cr)
{
  #define H_cairo_fill_preserve "void cairo_fill_preserve(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_fill_preserve", "cairo_t*");
  cairo_fill_preserve(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_copy_page(Xen cr)
{
  #define H_cairo_copy_page "void cairo_copy_page(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_copy_page", "cairo_t*");
  cairo_copy_page(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_show_page(Xen cr)
{
  #define H_cairo_show_page "void cairo_show_page(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_show_page", "cairo_t*");
  cairo_show_page(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_in_stroke(Xen cr, Xen x, Xen y)
{
  #define H_cairo_in_stroke "bool cairo_in_stroke(cairo_t* cr, double x, double y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_in_stroke", "cairo_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_in_stroke", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_in_stroke", "double");
  return(C_to_Xen_bool(cairo_in_stroke(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x), Xen_to_C_double(y))));
}

static Xen gxg_cairo_in_fill(Xen cr, Xen x, Xen y)
{
  #define H_cairo_in_fill "bool cairo_in_fill(cairo_t* cr, double x, double y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_in_fill", "cairo_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_in_fill", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_in_fill", "double");
  return(C_to_Xen_bool(cairo_in_fill(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x), Xen_to_C_double(y))));
}

static Xen gxg_cairo_reset_clip(Xen cr)
{
  #define H_cairo_reset_clip "void cairo_reset_clip(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_reset_clip", "cairo_t*");
  cairo_reset_clip(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_clip(Xen cr)
{
  #define H_cairo_clip "void cairo_clip(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_clip", "cairo_t*");
  cairo_clip(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_clip_preserve(Xen cr)
{
  #define H_cairo_clip_preserve "void cairo_clip_preserve(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_clip_preserve", "cairo_t*");
  cairo_clip_preserve(Xen_to_C_cairo_t_(cr));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_create(void)
{
  #define H_cairo_font_options_create "cairo_font_options_t* cairo_font_options_create( void)"
  return(C_to_Xen_cairo_font_options_t_(cairo_font_options_create()));
}

static Xen gxg_cairo_font_options_copy(Xen original)
{
  #define H_cairo_font_options_copy "cairo_font_options_t* cairo_font_options_copy(cairo_font_options_t* original)"
  Xen_check_type(Xen_is_cairo_font_options_t_(original), original, 1, "cairo_font_options_copy", "cairo_font_options_t*");
  return(C_to_Xen_cairo_font_options_t_(cairo_font_options_copy(Xen_to_C_cairo_font_options_t_(original))));
}

static Xen gxg_cairo_font_options_destroy(Xen options)
{
  #define H_cairo_font_options_destroy "void cairo_font_options_destroy(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_destroy", "cairo_font_options_t*");
  cairo_font_options_destroy(Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_status(Xen options)
{
  #define H_cairo_font_options_status "cairo_status_t cairo_font_options_status(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_status", "cairo_font_options_t*");
  return(C_to_Xen_cairo_status_t(cairo_font_options_status(Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_font_options_merge(Xen options, Xen other)
{
  #define H_cairo_font_options_merge "void cairo_font_options_merge(cairo_font_options_t* options, cairo_font_options_t* other)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_merge", "cairo_font_options_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(other), other, 2, "cairo_font_options_merge", "cairo_font_options_t*");
  cairo_font_options_merge(Xen_to_C_cairo_font_options_t_(options), Xen_to_C_cairo_font_options_t_(other));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_equal(Xen options, Xen other)
{
  #define H_cairo_font_options_equal "bool cairo_font_options_equal(cairo_font_options_t* options, cairo_font_options_t* other)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_equal", "cairo_font_options_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(other), other, 2, "cairo_font_options_equal", "cairo_font_options_t*");
  return(C_to_Xen_bool(cairo_font_options_equal(Xen_to_C_cairo_font_options_t_(options), Xen_to_C_cairo_font_options_t_(other))));
}

static Xen gxg_cairo_font_options_hash(Xen options)
{
  #define H_cairo_font_options_hash "gulong cairo_font_options_hash(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_hash", "cairo_font_options_t*");
  return(C_to_Xen_gulong(cairo_font_options_hash(Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_font_options_set_antialias(Xen options, Xen antialias)
{
  #define H_cairo_font_options_set_antialias "void cairo_font_options_set_antialias(cairo_font_options_t* options, \
cairo_antialias_t antialias)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_set_antialias", "cairo_font_options_t*");
  Xen_check_type(Xen_is_cairo_antialias_t(antialias), antialias, 2, "cairo_font_options_set_antialias", "cairo_antialias_t");
  cairo_font_options_set_antialias(Xen_to_C_cairo_font_options_t_(options), Xen_to_C_cairo_antialias_t(antialias));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_get_antialias(Xen options)
{
  #define H_cairo_font_options_get_antialias "cairo_antialias_t cairo_font_options_get_antialias(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_get_antialias", "cairo_font_options_t*");
  return(C_to_Xen_cairo_antialias_t(cairo_font_options_get_antialias(Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_font_options_set_subpixel_order(Xen options, Xen subpixel_order)
{
  #define H_cairo_font_options_set_subpixel_order "void cairo_font_options_set_subpixel_order(cairo_font_options_t* options, \
cairo_subpixel_order_t subpixel_order)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_set_subpixel_order", "cairo_font_options_t*");
  Xen_check_type(Xen_is_cairo_subpixel_order_t(subpixel_order), subpixel_order, 2, "cairo_font_options_set_subpixel_order", "cairo_subpixel_order_t");
  cairo_font_options_set_subpixel_order(Xen_to_C_cairo_font_options_t_(options), Xen_to_C_cairo_subpixel_order_t(subpixel_order));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_get_subpixel_order(Xen options)
{
  #define H_cairo_font_options_get_subpixel_order "cairo_subpixel_order_t cairo_font_options_get_subpixel_order(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_get_subpixel_order", "cairo_font_options_t*");
  return(C_to_Xen_cairo_subpixel_order_t(cairo_font_options_get_subpixel_order(Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_font_options_set_hint_style(Xen options, Xen hint_style)
{
  #define H_cairo_font_options_set_hint_style "void cairo_font_options_set_hint_style(cairo_font_options_t* options, \
cairo_hint_style_t hint_style)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_set_hint_style", "cairo_font_options_t*");
  Xen_check_type(Xen_is_cairo_hint_style_t(hint_style), hint_style, 2, "cairo_font_options_set_hint_style", "cairo_hint_style_t");
  cairo_font_options_set_hint_style(Xen_to_C_cairo_font_options_t_(options), Xen_to_C_cairo_hint_style_t(hint_style));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_get_hint_style(Xen options)
{
  #define H_cairo_font_options_get_hint_style "cairo_hint_style_t cairo_font_options_get_hint_style(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_get_hint_style", "cairo_font_options_t*");
  return(C_to_Xen_cairo_hint_style_t(cairo_font_options_get_hint_style(Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_font_options_set_hint_metrics(Xen options, Xen hint_metrics)
{
  #define H_cairo_font_options_set_hint_metrics "void cairo_font_options_set_hint_metrics(cairo_font_options_t* options, \
cairo_hint_metrics_t hint_metrics)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_set_hint_metrics", "cairo_font_options_t*");
  Xen_check_type(Xen_is_cairo_hint_metrics_t(hint_metrics), hint_metrics, 2, "cairo_font_options_set_hint_metrics", "cairo_hint_metrics_t");
  cairo_font_options_set_hint_metrics(Xen_to_C_cairo_font_options_t_(options), Xen_to_C_cairo_hint_metrics_t(hint_metrics));
  return(Xen_false);
}

static Xen gxg_cairo_font_options_get_hint_metrics(Xen options)
{
  #define H_cairo_font_options_get_hint_metrics "cairo_hint_metrics_t cairo_font_options_get_hint_metrics(cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 1, "cairo_font_options_get_hint_metrics", "cairo_font_options_t*");
  return(C_to_Xen_cairo_hint_metrics_t(cairo_font_options_get_hint_metrics(Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_select_font_face(Xen cr, Xen family, Xen slant, Xen weight)
{
  #define H_cairo_select_font_face "void cairo_select_font_face(cairo_t* cr, char* family, cairo_font_slant_t slant, \
cairo_font_weight_t weight)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_select_font_face", "cairo_t*");
  Xen_check_type(Xen_is_char_(family), family, 2, "cairo_select_font_face", "char*");
  Xen_check_type(Xen_is_cairo_font_slant_t(slant), slant, 3, "cairo_select_font_face", "cairo_font_slant_t");
  Xen_check_type(Xen_is_cairo_font_weight_t(weight), weight, 4, "cairo_select_font_face", "cairo_font_weight_t");
  cairo_select_font_face(Xen_to_C_cairo_t_(cr), Xen_to_C_char_(family), Xen_to_C_cairo_font_slant_t(slant), Xen_to_C_cairo_font_weight_t(weight));
  return(Xen_false);
}

static Xen gxg_cairo_set_font_size(Xen cr, Xen size)
{
  #define H_cairo_set_font_size "void cairo_set_font_size(cairo_t* cr, double size)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_font_size", "cairo_t*");
  Xen_check_type(Xen_is_double(size), size, 2, "cairo_set_font_size", "double");
  cairo_set_font_size(Xen_to_C_cairo_t_(cr), Xen_to_C_double(size));
  return(Xen_false);
}

static Xen gxg_cairo_set_font_matrix(Xen cr, Xen matrix)
{
  #define H_cairo_set_font_matrix "void cairo_set_font_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_font_matrix", "cairo_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_set_font_matrix", "cairo_matrix_t*");
  cairo_set_font_matrix(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_get_font_matrix(Xen cr, Xen matrix)
{
  #define H_cairo_get_font_matrix "void cairo_get_font_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_font_matrix", "cairo_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_get_font_matrix", "cairo_matrix_t*");
  cairo_get_font_matrix(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_set_font_options(Xen cr, Xen options)
{
  #define H_cairo_set_font_options "void cairo_set_font_options(cairo_t* cr, cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_font_options", "cairo_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 2, "cairo_set_font_options", "cairo_font_options_t*");
  cairo_set_font_options(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_cairo_get_font_options(Xen cr, Xen options)
{
  #define H_cairo_get_font_options "void cairo_get_font_options(cairo_t* cr, cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_font_options", "cairo_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 2, "cairo_get_font_options", "cairo_font_options_t*");
  cairo_get_font_options(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_cairo_set_scaled_font(Xen cr, Xen scaled_font)
{
  #define H_cairo_set_scaled_font "void cairo_set_scaled_font(cairo_t* cr, cairo_scaled_font_t* scaled_font)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_scaled_font", "cairo_t*");
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 2, "cairo_set_scaled_font", "cairo_scaled_font_t*");
  cairo_set_scaled_font(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_scaled_font_t_(scaled_font));
  return(Xen_false);
}

static Xen gxg_cairo_show_text(Xen cr, Xen utf8)
{
  #define H_cairo_show_text "void cairo_show_text(cairo_t* cr, char* utf8)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_show_text", "cairo_t*");
  Xen_check_type(Xen_is_char_(utf8), utf8, 2, "cairo_show_text", "char*");
  cairo_show_text(Xen_to_C_cairo_t_(cr), Xen_to_C_char_(utf8));
  return(Xen_false);
}

static Xen gxg_cairo_show_glyphs(Xen cr, Xen glyphs, Xen num_glyphs)
{
  #define H_cairo_show_glyphs "void cairo_show_glyphs(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_show_glyphs", "cairo_t*");
  Xen_check_type(Xen_is_cairo_glyph_t_(glyphs), glyphs, 2, "cairo_show_glyphs", "cairo_glyph_t*");
  Xen_check_type(Xen_is_int(num_glyphs), num_glyphs, 3, "cairo_show_glyphs", "int");
  cairo_show_glyphs(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_glyph_t_(glyphs), Xen_to_C_int(num_glyphs));
  return(Xen_false);
}

static Xen gxg_cairo_get_font_face(Xen cr)
{
  #define H_cairo_get_font_face "cairo_font_face_t* cairo_get_font_face(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_font_face", "cairo_t*");
  return(C_to_Xen_cairo_font_face_t_(cairo_get_font_face(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_font_extents(Xen cr, Xen extents)
{
  #define H_cairo_font_extents "void cairo_font_extents(cairo_t* cr, cairo_font_extents_t* extents)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_font_extents", "cairo_t*");
  Xen_check_type(Xen_is_cairo_font_extents_t_(extents), extents, 2, "cairo_font_extents", "cairo_font_extents_t*");
  cairo_font_extents(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_font_extents_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_set_font_face(Xen cr, Xen font_face)
{
  #define H_cairo_set_font_face "void cairo_set_font_face(cairo_t* cr, cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_font_face", "cairo_t*");
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 2, "cairo_set_font_face", "cairo_font_face_t*");
  cairo_set_font_face(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_font_face_t_(font_face));
  return(Xen_false);
}

static Xen gxg_cairo_text_extents(Xen cr, Xen utf8, Xen extents)
{
  #define H_cairo_text_extents "void cairo_text_extents(cairo_t* cr, char* utf8, cairo_text_extents_t* extents)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_text_extents", "cairo_t*");
  Xen_check_type(Xen_is_char_(utf8), utf8, 2, "cairo_text_extents", "char*");
  Xen_check_type(Xen_is_cairo_text_extents_t_(extents), extents, 3, "cairo_text_extents", "cairo_text_extents_t*");
  cairo_text_extents(Xen_to_C_cairo_t_(cr), Xen_to_C_char_(utf8), Xen_to_C_cairo_text_extents_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_glyph_extents(Xen cr, Xen glyphs, Xen num_glyphs, Xen extents)
{
  #define H_cairo_glyph_extents "void cairo_glyph_extents(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs, \
cairo_text_extents_t* extents)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_glyph_extents", "cairo_t*");
  Xen_check_type(Xen_is_cairo_glyph_t_(glyphs), glyphs, 2, "cairo_glyph_extents", "cairo_glyph_t*");
  Xen_check_type(Xen_is_int(num_glyphs), num_glyphs, 3, "cairo_glyph_extents", "int");
  Xen_check_type(Xen_is_cairo_text_extents_t_(extents), extents, 4, "cairo_glyph_extents", "cairo_text_extents_t*");
  cairo_glyph_extents(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_glyph_t_(glyphs), Xen_to_C_int(num_glyphs), Xen_to_C_cairo_text_extents_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_text_path(Xen cr, Xen utf8)
{
  #define H_cairo_text_path "void cairo_text_path(cairo_t* cr, char* utf8)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_text_path", "cairo_t*");
  Xen_check_type(Xen_is_char_(utf8), utf8, 2, "cairo_text_path", "char*");
  cairo_text_path(Xen_to_C_cairo_t_(cr), Xen_to_C_char_(utf8));
  return(Xen_false);
}

static Xen gxg_cairo_glyph_path(Xen cr, Xen glyphs, Xen num_glyphs)
{
  #define H_cairo_glyph_path "void cairo_glyph_path(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_glyph_path", "cairo_t*");
  Xen_check_type(Xen_is_cairo_glyph_t_(glyphs), glyphs, 2, "cairo_glyph_path", "cairo_glyph_t*");
  Xen_check_type(Xen_is_int(num_glyphs), num_glyphs, 3, "cairo_glyph_path", "int");
  cairo_glyph_path(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_glyph_t_(glyphs), Xen_to_C_int(num_glyphs));
  return(Xen_false);
}

static Xen gxg_cairo_font_face_reference(Xen font_face)
{
  #define H_cairo_font_face_reference "cairo_font_face_t* cairo_font_face_reference(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_font_face_reference", "cairo_font_face_t*");
  return(C_to_Xen_cairo_font_face_t_(cairo_font_face_reference(Xen_to_C_cairo_font_face_t_(font_face))));
}

static Xen gxg_cairo_font_face_destroy(Xen font_face)
{
  #define H_cairo_font_face_destroy "void cairo_font_face_destroy(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_font_face_destroy", "cairo_font_face_t*");
  cairo_font_face_destroy(Xen_to_C_cairo_font_face_t_(font_face));
  return(Xen_false);
}

static Xen gxg_cairo_font_face_status(Xen font_face)
{
  #define H_cairo_font_face_status "cairo_status_t cairo_font_face_status(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_font_face_status", "cairo_font_face_t*");
  return(C_to_Xen_cairo_status_t(cairo_font_face_status(Xen_to_C_cairo_font_face_t_(font_face))));
}

static Xen gxg_cairo_font_face_get_user_data(Xen font_face, Xen key)
{
  #define H_cairo_font_face_get_user_data "gpointer cairo_font_face_get_user_data(cairo_font_face_t* font_face, \
cairo_user_data_key_t* key)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_font_face_get_user_data", "cairo_font_face_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_font_face_get_user_data", "cairo_user_data_key_t*");
  return(C_to_Xen_gpointer(cairo_font_face_get_user_data(Xen_to_C_cairo_font_face_t_(font_face), Xen_to_C_cairo_user_data_key_t_(key))));
}

static Xen gxg_cairo_font_face_set_user_data(Xen font_face, Xen key, Xen user_data, Xen destroy)
{
  #define H_cairo_font_face_set_user_data "cairo_status_t cairo_font_face_set_user_data(cairo_font_face_t* font_face, \
cairo_user_data_key_t* key, gpointer user_data, cairo_destroy_func_t destroy)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_font_face_set_user_data", "cairo_font_face_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_font_face_set_user_data", "cairo_user_data_key_t*");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 3, "cairo_font_face_set_user_data", "gpointer");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 4, "cairo_font_face_set_user_data", "cairo_destroy_func_t");
  return(C_to_Xen_cairo_status_t(cairo_font_face_set_user_data(Xen_to_C_cairo_font_face_t_(font_face), Xen_to_C_cairo_user_data_key_t_(key), 
                                                               Xen_to_C_gpointer(user_data), Xen_to_C_cairo_destroy_func_t(destroy))));
}

static Xen gxg_cairo_scaled_font_create(Xen font_face, Xen font_matrix, Xen ctm, Xen options)
{
  #define H_cairo_scaled_font_create "cairo_scaled_font_t* cairo_scaled_font_create(cairo_font_face_t* font_face, \
cairo_matrix_t* font_matrix, cairo_matrix_t* ctm, cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_scaled_font_create", "cairo_font_face_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(font_matrix), font_matrix, 2, "cairo_scaled_font_create", "cairo_matrix_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(ctm), ctm, 3, "cairo_scaled_font_create", "cairo_matrix_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 4, "cairo_scaled_font_create", "cairo_font_options_t*");
  return(C_to_Xen_cairo_scaled_font_t_(cairo_scaled_font_create(Xen_to_C_cairo_font_face_t_(font_face), Xen_to_C_cairo_matrix_t_(font_matrix), 
                                                                Xen_to_C_cairo_matrix_t_(ctm), Xen_to_C_cairo_font_options_t_(options))));
}

static Xen gxg_cairo_scaled_font_reference(Xen scaled_font)
{
  #define H_cairo_scaled_font_reference "cairo_scaled_font_t* cairo_scaled_font_reference(cairo_scaled_font_t* scaled_font)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_reference", "cairo_scaled_font_t*");
  return(C_to_Xen_cairo_scaled_font_t_(cairo_scaled_font_reference(Xen_to_C_cairo_scaled_font_t_(scaled_font))));
}

static Xen gxg_cairo_scaled_font_destroy(Xen scaled_font)
{
  #define H_cairo_scaled_font_destroy "void cairo_scaled_font_destroy(cairo_scaled_font_t* scaled_font)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_destroy", "cairo_scaled_font_t*");
  cairo_scaled_font_destroy(Xen_to_C_cairo_scaled_font_t_(scaled_font));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_status(Xen scaled_font)
{
  #define H_cairo_scaled_font_status "cairo_status_t cairo_scaled_font_status(cairo_scaled_font_t* scaled_font)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_status", "cairo_scaled_font_t*");
  return(C_to_Xen_cairo_status_t(cairo_scaled_font_status(Xen_to_C_cairo_scaled_font_t_(scaled_font))));
}

static Xen gxg_cairo_scaled_font_extents(Xen scaled_font, Xen extents)
{
  #define H_cairo_scaled_font_extents "void cairo_scaled_font_extents(cairo_scaled_font_t* scaled_font, \
cairo_font_extents_t* extents)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_extents", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_font_extents_t_(extents), extents, 2, "cairo_scaled_font_extents", "cairo_font_extents_t*");
  cairo_scaled_font_extents(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_font_extents_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_text_extents(Xen scaled_font, Xen utf8, Xen extents)
{
  #define H_cairo_scaled_font_text_extents "void cairo_scaled_font_text_extents(cairo_scaled_font_t* scaled_font, \
char* utf8, cairo_text_extents_t* extents)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_text_extents", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_char_(utf8), utf8, 2, "cairo_scaled_font_text_extents", "char*");
  Xen_check_type(Xen_is_cairo_text_extents_t_(extents), extents, 3, "cairo_scaled_font_text_extents", "cairo_text_extents_t*");
  cairo_scaled_font_text_extents(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_char_(utf8), Xen_to_C_cairo_text_extents_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_glyph_extents(Xen scaled_font, Xen glyphs, Xen num_glyphs, Xen extents)
{
  #define H_cairo_scaled_font_glyph_extents "void cairo_scaled_font_glyph_extents(cairo_scaled_font_t* scaled_font, \
cairo_glyph_t* glyphs, int num_glyphs, cairo_text_extents_t* extents)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_glyph_extents", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_glyph_t_(glyphs), glyphs, 2, "cairo_scaled_font_glyph_extents", "cairo_glyph_t*");
  Xen_check_type(Xen_is_int(num_glyphs), num_glyphs, 3, "cairo_scaled_font_glyph_extents", "int");
  Xen_check_type(Xen_is_cairo_text_extents_t_(extents), extents, 4, "cairo_scaled_font_glyph_extents", "cairo_text_extents_t*");
  cairo_scaled_font_glyph_extents(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_glyph_t_(glyphs), Xen_to_C_int(num_glyphs), 
                                  Xen_to_C_cairo_text_extents_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_get_font_face(Xen scaled_font)
{
  #define H_cairo_scaled_font_get_font_face "cairo_font_face_t* cairo_scaled_font_get_font_face(cairo_scaled_font_t* scaled_font)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_font_face", "cairo_scaled_font_t*");
  return(C_to_Xen_cairo_font_face_t_(cairo_scaled_font_get_font_face(Xen_to_C_cairo_scaled_font_t_(scaled_font))));
}

static Xen gxg_cairo_scaled_font_get_font_matrix(Xen scaled_font, Xen font_matrix)
{
  #define H_cairo_scaled_font_get_font_matrix "void cairo_scaled_font_get_font_matrix(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* font_matrix)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_font_matrix", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(font_matrix), font_matrix, 2, "cairo_scaled_font_get_font_matrix", "cairo_matrix_t*");
  cairo_scaled_font_get_font_matrix(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_matrix_t_(font_matrix));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_get_ctm(Xen scaled_font, Xen ctm)
{
  #define H_cairo_scaled_font_get_ctm "void cairo_scaled_font_get_ctm(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* ctm)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_ctm", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(ctm), ctm, 2, "cairo_scaled_font_get_ctm", "cairo_matrix_t*");
  cairo_scaled_font_get_ctm(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_matrix_t_(ctm));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_get_font_options(Xen scaled_font, Xen options)
{
  #define H_cairo_scaled_font_get_font_options "void cairo_scaled_font_get_font_options(cairo_scaled_font_t* scaled_font, \
cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_font_options", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 2, "cairo_scaled_font_get_font_options", "cairo_font_options_t*");
  cairo_scaled_font_get_font_options(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_cairo_get_operator(Xen cr)
{
  #define H_cairo_get_operator "cairo_operator_t cairo_get_operator(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_operator", "cairo_t*");
  return(C_to_Xen_cairo_operator_t(cairo_get_operator(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_source(Xen cr)
{
  #define H_cairo_get_source "cairo_pattern_t* cairo_get_source(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_source", "cairo_t*");
  return(C_to_Xen_cairo_pattern_t_(cairo_get_source(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_tolerance(Xen cr)
{
  #define H_cairo_get_tolerance "gdouble cairo_get_tolerance(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_tolerance", "cairo_t*");
  return(C_to_Xen_gdouble(cairo_get_tolerance(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_antialias(Xen cr)
{
  #define H_cairo_get_antialias "cairo_antialias_t cairo_get_antialias(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_antialias", "cairo_t*");
  return(C_to_Xen_cairo_antialias_t(cairo_get_antialias(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_current_point(Xen cr, Xen ignore_x, Xen ignore_y)
{
  #define H_cairo_get_current_point "void cairo_get_current_point(cairo_t* cr, gdouble* [x], gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_current_point", "cairo_t*");
  cairo_get_current_point(Xen_to_C_cairo_t_(cr), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
}

static Xen gxg_cairo_get_fill_rule(Xen cr)
{
  #define H_cairo_get_fill_rule "cairo_fill_rule_t cairo_get_fill_rule(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_fill_rule", "cairo_t*");
  return(C_to_Xen_cairo_fill_rule_t(cairo_get_fill_rule(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_line_width(Xen cr)
{
  #define H_cairo_get_line_width "gdouble cairo_get_line_width(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_line_width", "cairo_t*");
  return(C_to_Xen_gdouble(cairo_get_line_width(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_line_cap(Xen cr)
{
  #define H_cairo_get_line_cap "cairo_line_cap_t cairo_get_line_cap(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_line_cap", "cairo_t*");
  return(C_to_Xen_cairo_line_cap_t(cairo_get_line_cap(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_line_join(Xen cr)
{
  #define H_cairo_get_line_join "cairo_line_join_t cairo_get_line_join(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_line_join", "cairo_t*");
  return(C_to_Xen_cairo_line_join_t(cairo_get_line_join(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_miter_limit(Xen cr)
{
  #define H_cairo_get_miter_limit "gdouble cairo_get_miter_limit(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_miter_limit", "cairo_t*");
  return(C_to_Xen_gdouble(cairo_get_miter_limit(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_matrix(Xen cr, Xen matrix)
{
  #define H_cairo_get_matrix "void cairo_get_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_matrix", "cairo_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_get_matrix", "cairo_matrix_t*");
  cairo_get_matrix(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_get_target(Xen cr)
{
  #define H_cairo_get_target "cairo_surface_t* cairo_get_target(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_target", "cairo_t*");
  return(C_to_Xen_cairo_surface_t_(cairo_get_target(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_group_target(Xen cr)
{
  #define H_cairo_get_group_target "cairo_surface_t* cairo_get_group_target(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_group_target", "cairo_t*");
  return(C_to_Xen_cairo_surface_t_(cairo_get_group_target(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_copy_path(Xen cr)
{
  #define H_cairo_copy_path "cairo_path_t* cairo_copy_path(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_copy_path", "cairo_t*");
  return(C_to_Xen_cairo_path_t_(cairo_copy_path(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_copy_path_flat(Xen cr)
{
  #define H_cairo_copy_path_flat "cairo_path_t* cairo_copy_path_flat(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_copy_path_flat", "cairo_t*");
  return(C_to_Xen_cairo_path_t_(cairo_copy_path_flat(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_append_path(Xen cr, Xen path)
{
  #define H_cairo_append_path "void cairo_append_path(cairo_t* cr, cairo_path_t* path)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_append_path", "cairo_t*");
  Xen_check_type(Xen_is_cairo_path_t_(path), path, 2, "cairo_append_path", "cairo_path_t*");
  cairo_append_path(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_path_t_(path));
  return(Xen_false);
}

static Xen gxg_cairo_path_destroy(Xen path)
{
  #define H_cairo_path_destroy "void cairo_path_destroy(cairo_path_t* path)"
  Xen_check_type(Xen_is_cairo_path_t_(path), path, 1, "cairo_path_destroy", "cairo_path_t*");
  cairo_path_destroy(Xen_to_C_cairo_path_t_(path));
  return(Xen_false);
}

static Xen gxg_cairo_status(Xen cr)
{
  #define H_cairo_status "cairo_status_t cairo_status(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_status", "cairo_t*");
  return(C_to_Xen_cairo_status_t(cairo_status(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_status_to_string(Xen status)
{
  #define H_cairo_status_to_string "char* cairo_status_to_string(cairo_status_t status)"
  Xen_check_type(Xen_is_cairo_status_t(status), status, 1, "cairo_status_to_string", "cairo_status_t");
  return(C_to_Xen_char_(cairo_status_to_string(Xen_to_C_cairo_status_t(status))));
}

static Xen gxg_cairo_surface_create_similar(Xen other, Xen content, Xen width, Xen height)
{
  #define H_cairo_surface_create_similar "cairo_surface_t* cairo_surface_create_similar(cairo_surface_t* other, \
cairo_content_t content, int width, int height)"
  Xen_check_type(Xen_is_cairo_surface_t_(other), other, 1, "cairo_surface_create_similar", "cairo_surface_t*");
  Xen_check_type(Xen_is_cairo_content_t(content), content, 2, "cairo_surface_create_similar", "cairo_content_t");
  Xen_check_type(Xen_is_int(width), width, 3, "cairo_surface_create_similar", "int");
  Xen_check_type(Xen_is_int(height), height, 4, "cairo_surface_create_similar", "int");
  return(C_to_Xen_cairo_surface_t_(cairo_surface_create_similar(Xen_to_C_cairo_surface_t_(other), Xen_to_C_cairo_content_t(content), 
                                                                Xen_to_C_int(width), Xen_to_C_int(height))));
}

static Xen gxg_cairo_surface_reference(Xen surface)
{
  #define H_cairo_surface_reference "cairo_surface_t* cairo_surface_reference(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_reference", "cairo_surface_t*");
  return(C_to_Xen_cairo_surface_t_(cairo_surface_reference(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_surface_finish(Xen surface)
{
  #define H_cairo_surface_finish "void cairo_surface_finish(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_finish", "cairo_surface_t*");
  cairo_surface_finish(Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_cairo_surface_destroy(Xen surface)
{
  #define H_cairo_surface_destroy "void cairo_surface_destroy(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_destroy", "cairo_surface_t*");
  cairo_surface_destroy(Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_cairo_surface_status(Xen surface)
{
  #define H_cairo_surface_status "cairo_status_t cairo_surface_status(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_status", "cairo_surface_t*");
  return(C_to_Xen_cairo_status_t(cairo_surface_status(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_surface_get_content(Xen surface)
{
  #define H_cairo_surface_get_content "cairo_content_t cairo_surface_get_content(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_content", "cairo_surface_t*");
  return(C_to_Xen_cairo_content_t(cairo_surface_get_content(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_surface_get_user_data(Xen surface, Xen key)
{
  #define H_cairo_surface_get_user_data "gpointer cairo_surface_get_user_data(cairo_surface_t* surface, \
cairo_user_data_key_t* key)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_user_data", "cairo_surface_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_surface_get_user_data", "cairo_user_data_key_t*");
  return(C_to_Xen_gpointer(cairo_surface_get_user_data(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_cairo_user_data_key_t_(key))));
}

static Xen gxg_cairo_surface_set_user_data(Xen surface, Xen key, Xen user_data, Xen destroy)
{
  #define H_cairo_surface_set_user_data "cairo_status_t cairo_surface_set_user_data(cairo_surface_t* surface, \
cairo_user_data_key_t* key, gpointer user_data, cairo_destroy_func_t destroy)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_set_user_data", "cairo_surface_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_surface_set_user_data", "cairo_user_data_key_t*");
  Xen_check_type(Xen_is_gpointer(user_data), user_data, 3, "cairo_surface_set_user_data", "gpointer");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 4, "cairo_surface_set_user_data", "cairo_destroy_func_t");
  return(C_to_Xen_cairo_status_t(cairo_surface_set_user_data(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_cairo_user_data_key_t_(key), 
                                                             Xen_to_C_gpointer(user_data), Xen_to_C_cairo_destroy_func_t(destroy))));
}

static Xen gxg_cairo_surface_get_font_options(Xen surface, Xen options)
{
  #define H_cairo_surface_get_font_options "void cairo_surface_get_font_options(cairo_surface_t* surface, \
cairo_font_options_t* options)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_font_options", "cairo_surface_t*");
  Xen_check_type(Xen_is_cairo_font_options_t_(options), options, 2, "cairo_surface_get_font_options", "cairo_font_options_t*");
  cairo_surface_get_font_options(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_cairo_font_options_t_(options));
  return(Xen_false);
}

static Xen gxg_cairo_surface_flush(Xen surface)
{
  #define H_cairo_surface_flush "void cairo_surface_flush(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_flush", "cairo_surface_t*");
  cairo_surface_flush(Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_cairo_surface_mark_dirty(Xen surface)
{
  #define H_cairo_surface_mark_dirty "void cairo_surface_mark_dirty(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_mark_dirty", "cairo_surface_t*");
  cairo_surface_mark_dirty(Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_cairo_surface_mark_dirty_rectangle(Xen surface, Xen x, Xen y, Xen width, Xen height)
{
  #define H_cairo_surface_mark_dirty_rectangle "void cairo_surface_mark_dirty_rectangle(cairo_surface_t* surface, \
int x, int y, int width, int height)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_mark_dirty_rectangle", "cairo_surface_t*");
  Xen_check_type(Xen_is_int(x), x, 2, "cairo_surface_mark_dirty_rectangle", "int");
  Xen_check_type(Xen_is_int(y), y, 3, "cairo_surface_mark_dirty_rectangle", "int");
  Xen_check_type(Xen_is_int(width), width, 4, "cairo_surface_mark_dirty_rectangle", "int");
  Xen_check_type(Xen_is_int(height), height, 5, "cairo_surface_mark_dirty_rectangle", "int");
  cairo_surface_mark_dirty_rectangle(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_int(x), Xen_to_C_int(y), Xen_to_C_int(width), 
                                     Xen_to_C_int(height));
  return(Xen_false);
}

static Xen gxg_cairo_surface_set_device_offset(Xen surface, Xen x_offset, Xen y_offset)
{
  #define H_cairo_surface_set_device_offset "void cairo_surface_set_device_offset(cairo_surface_t* surface, \
double x_offset, double y_offset)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_set_device_offset", "cairo_surface_t*");
  Xen_check_type(Xen_is_double(x_offset), x_offset, 2, "cairo_surface_set_device_offset", "double");
  Xen_check_type(Xen_is_double(y_offset), y_offset, 3, "cairo_surface_set_device_offset", "double");
  cairo_surface_set_device_offset(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_double(x_offset), Xen_to_C_double(y_offset));
  return(Xen_false);
}

static Xen gxg_cairo_surface_get_device_offset(Xen surface, Xen ignore_x_offset, Xen ignore_y_offset)
{
  #define H_cairo_surface_get_device_offset "void cairo_surface_get_device_offset(cairo_surface_t* surface, \
gdouble* [x_offset], gdouble* [y_offset])"
  gdouble ref_x_offset;
  gdouble ref_y_offset;
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_device_offset", "cairo_surface_t*");
  cairo_surface_get_device_offset(Xen_to_C_cairo_surface_t_(surface), &ref_x_offset, &ref_y_offset);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x_offset), C_to_Xen_gdouble(ref_y_offset)));
}

static Xen gxg_cairo_surface_set_fallback_resolution(Xen surface, Xen x_pixels_per_inch, Xen y_pixels_per_inch)
{
  #define H_cairo_surface_set_fallback_resolution "void cairo_surface_set_fallback_resolution(cairo_surface_t* surface, \
double x_pixels_per_inch, double y_pixels_per_inch)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_set_fallback_resolution", "cairo_surface_t*");
  Xen_check_type(Xen_is_double(x_pixels_per_inch), x_pixels_per_inch, 2, "cairo_surface_set_fallback_resolution", "double");
  Xen_check_type(Xen_is_double(y_pixels_per_inch), y_pixels_per_inch, 3, "cairo_surface_set_fallback_resolution", "double");
  cairo_surface_set_fallback_resolution(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_double(x_pixels_per_inch), Xen_to_C_double(y_pixels_per_inch));
  return(Xen_false);
}

static Xen gxg_cairo_image_surface_create(Xen format, Xen width, Xen height)
{
  #define H_cairo_image_surface_create "cairo_surface_t* cairo_image_surface_create(cairo_format_t format, \
int width, int height)"
  Xen_check_type(Xen_is_cairo_format_t(format), format, 1, "cairo_image_surface_create", "cairo_format_t");
  Xen_check_type(Xen_is_int(width), width, 2, "cairo_image_surface_create", "int");
  Xen_check_type(Xen_is_int(height), height, 3, "cairo_image_surface_create", "int");
  return(C_to_Xen_cairo_surface_t_(cairo_image_surface_create(Xen_to_C_cairo_format_t(format), Xen_to_C_int(width), Xen_to_C_int(height))));
}

static Xen gxg_cairo_image_surface_create_for_data(Xen data, Xen format, Xen width, Xen height, Xen stride)
{
  #define H_cairo_image_surface_create_for_data "cairo_surface_t* cairo_image_surface_create_for_data(guchar* data, \
cairo_format_t format, int width, int height, int stride)"
  Xen_check_type(Xen_is_guchar_(data), data, 1, "cairo_image_surface_create_for_data", "guchar*");
  Xen_check_type(Xen_is_cairo_format_t(format), format, 2, "cairo_image_surface_create_for_data", "cairo_format_t");
  Xen_check_type(Xen_is_int(width), width, 3, "cairo_image_surface_create_for_data", "int");
  Xen_check_type(Xen_is_int(height), height, 4, "cairo_image_surface_create_for_data", "int");
  Xen_check_type(Xen_is_int(stride), stride, 5, "cairo_image_surface_create_for_data", "int");
  return(C_to_Xen_cairo_surface_t_(cairo_image_surface_create_for_data(Xen_to_C_guchar_(data), Xen_to_C_cairo_format_t(format), 
                                                                       Xen_to_C_int(width), Xen_to_C_int(height), Xen_to_C_int(stride))));
}

static Xen gxg_cairo_image_surface_get_data(Xen surface)
{
  #define H_cairo_image_surface_get_data "guchar* cairo_image_surface_get_data(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_image_surface_get_data", "cairo_surface_t*");
  return(C_to_Xen_guchar_(cairo_image_surface_get_data(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_image_surface_get_format(Xen surface)
{
  #define H_cairo_image_surface_get_format "cairo_format_t cairo_image_surface_get_format(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_image_surface_get_format", "cairo_surface_t*");
  return(C_to_Xen_cairo_format_t(cairo_image_surface_get_format(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_image_surface_get_width(Xen surface)
{
  #define H_cairo_image_surface_get_width "int cairo_image_surface_get_width(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_image_surface_get_width", "cairo_surface_t*");
  return(C_to_Xen_int(cairo_image_surface_get_width(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_image_surface_get_height(Xen surface)
{
  #define H_cairo_image_surface_get_height "int cairo_image_surface_get_height(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_image_surface_get_height", "cairo_surface_t*");
  return(C_to_Xen_int(cairo_image_surface_get_height(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_image_surface_get_stride(Xen surface)
{
  #define H_cairo_image_surface_get_stride "int cairo_image_surface_get_stride(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_image_surface_get_stride", "cairo_surface_t*");
  return(C_to_Xen_int(cairo_image_surface_get_stride(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_pattern_create_rgb(Xen red, Xen green, Xen blue)
{
  #define H_cairo_pattern_create_rgb "cairo_pattern_t* cairo_pattern_create_rgb(double red, double green, \
double blue)"
  Xen_check_type(Xen_is_double(red), red, 1, "cairo_pattern_create_rgb", "double");
  Xen_check_type(Xen_is_double(green), green, 2, "cairo_pattern_create_rgb", "double");
  Xen_check_type(Xen_is_double(blue), blue, 3, "cairo_pattern_create_rgb", "double");
  return(C_to_Xen_cairo_pattern_t_(cairo_pattern_create_rgb(Xen_to_C_double(red), Xen_to_C_double(green), Xen_to_C_double(blue))));
}

static Xen gxg_cairo_pattern_create_rgba(Xen red, Xen green, Xen blue, Xen alpha)
{
  #define H_cairo_pattern_create_rgba "cairo_pattern_t* cairo_pattern_create_rgba(double red, double green, \
double blue, double alpha)"
  Xen_check_type(Xen_is_double(red), red, 1, "cairo_pattern_create_rgba", "double");
  Xen_check_type(Xen_is_double(green), green, 2, "cairo_pattern_create_rgba", "double");
  Xen_check_type(Xen_is_double(blue), blue, 3, "cairo_pattern_create_rgba", "double");
  Xen_check_type(Xen_is_double(alpha), alpha, 4, "cairo_pattern_create_rgba", "double");
  return(C_to_Xen_cairo_pattern_t_(cairo_pattern_create_rgba(Xen_to_C_double(red), Xen_to_C_double(green), Xen_to_C_double(blue), 
                                                             Xen_to_C_double(alpha))));
}

static Xen gxg_cairo_pattern_create_for_surface(Xen surface)
{
  #define H_cairo_pattern_create_for_surface "cairo_pattern_t* cairo_pattern_create_for_surface(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_pattern_create_for_surface", "cairo_surface_t*");
  return(C_to_Xen_cairo_pattern_t_(cairo_pattern_create_for_surface(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_pattern_create_linear(Xen x0, Xen y0, Xen x1, Xen y1)
{
  #define H_cairo_pattern_create_linear "cairo_pattern_t* cairo_pattern_create_linear(double x0, double y0, \
double x1, double y1)"
  Xen_check_type(Xen_is_double(x0), x0, 1, "cairo_pattern_create_linear", "double");
  Xen_check_type(Xen_is_double(y0), y0, 2, "cairo_pattern_create_linear", "double");
  Xen_check_type(Xen_is_double(x1), x1, 3, "cairo_pattern_create_linear", "double");
  Xen_check_type(Xen_is_double(y1), y1, 4, "cairo_pattern_create_linear", "double");
  return(C_to_Xen_cairo_pattern_t_(cairo_pattern_create_linear(Xen_to_C_double(x0), Xen_to_C_double(y0), Xen_to_C_double(x1), 
                                                               Xen_to_C_double(y1))));
}

static Xen gxg_cairo_pattern_create_radial(Xen cx0, Xen cy0, Xen radius0, Xen cx1, Xen cy1, Xen radius1)
{
  #define H_cairo_pattern_create_radial "cairo_pattern_t* cairo_pattern_create_radial(double cx0, double cy0, \
double radius0, double cx1, double cy1, double radius1)"
  Xen_check_type(Xen_is_double(cx0), cx0, 1, "cairo_pattern_create_radial", "double");
  Xen_check_type(Xen_is_double(cy0), cy0, 2, "cairo_pattern_create_radial", "double");
  Xen_check_type(Xen_is_double(radius0), radius0, 3, "cairo_pattern_create_radial", "double");
  Xen_check_type(Xen_is_double(cx1), cx1, 4, "cairo_pattern_create_radial", "double");
  Xen_check_type(Xen_is_double(cy1), cy1, 5, "cairo_pattern_create_radial", "double");
  Xen_check_type(Xen_is_double(radius1), radius1, 6, "cairo_pattern_create_radial", "double");
  return(C_to_Xen_cairo_pattern_t_(cairo_pattern_create_radial(Xen_to_C_double(cx0), Xen_to_C_double(cy0), Xen_to_C_double(radius0), 
                                                               Xen_to_C_double(cx1), Xen_to_C_double(cy1), Xen_to_C_double(radius1))));
}

static Xen gxg_cairo_pattern_reference(Xen pattern)
{
  #define H_cairo_pattern_reference "cairo_pattern_t* cairo_pattern_reference(cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_reference", "cairo_pattern_t*");
  return(C_to_Xen_cairo_pattern_t_(cairo_pattern_reference(Xen_to_C_cairo_pattern_t_(pattern))));
}

static Xen gxg_cairo_pattern_destroy(Xen pattern)
{
  #define H_cairo_pattern_destroy "void cairo_pattern_destroy(cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_destroy", "cairo_pattern_t*");
  cairo_pattern_destroy(Xen_to_C_cairo_pattern_t_(pattern));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_status(Xen pattern)
{
  #define H_cairo_pattern_status "cairo_status_t cairo_pattern_status(cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_status", "cairo_pattern_t*");
  return(C_to_Xen_cairo_status_t(cairo_pattern_status(Xen_to_C_cairo_pattern_t_(pattern))));
}

static Xen gxg_cairo_pattern_add_color_stop_rgb(Xen pattern, Xen offset, Xen red, Xen green, Xen blue)
{
  #define H_cairo_pattern_add_color_stop_rgb "void cairo_pattern_add_color_stop_rgb(cairo_pattern_t* pattern, \
double offset, double red, double green, double blue)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_add_color_stop_rgb", "cairo_pattern_t*");
  Xen_check_type(Xen_is_double(offset), offset, 2, "cairo_pattern_add_color_stop_rgb", "double");
  Xen_check_type(Xen_is_double(red), red, 3, "cairo_pattern_add_color_stop_rgb", "double");
  Xen_check_type(Xen_is_double(green), green, 4, "cairo_pattern_add_color_stop_rgb", "double");
  Xen_check_type(Xen_is_double(blue), blue, 5, "cairo_pattern_add_color_stop_rgb", "double");
  cairo_pattern_add_color_stop_rgb(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_double(offset), Xen_to_C_double(red), Xen_to_C_double(green), 
                                   Xen_to_C_double(blue));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_add_color_stop_rgba(Xen pattern, Xen offset, Xen red, Xen green, Xen blue, Xen alpha)
{
  #define H_cairo_pattern_add_color_stop_rgba "void cairo_pattern_add_color_stop_rgba(cairo_pattern_t* pattern, \
double offset, double red, double green, double blue, double alpha)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_add_color_stop_rgba", "cairo_pattern_t*");
  Xen_check_type(Xen_is_double(offset), offset, 2, "cairo_pattern_add_color_stop_rgba", "double");
  Xen_check_type(Xen_is_double(red), red, 3, "cairo_pattern_add_color_stop_rgba", "double");
  Xen_check_type(Xen_is_double(green), green, 4, "cairo_pattern_add_color_stop_rgba", "double");
  Xen_check_type(Xen_is_double(blue), blue, 5, "cairo_pattern_add_color_stop_rgba", "double");
  Xen_check_type(Xen_is_double(alpha), alpha, 6, "cairo_pattern_add_color_stop_rgba", "double");
  cairo_pattern_add_color_stop_rgba(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_double(offset), Xen_to_C_double(red), Xen_to_C_double(green), 
                                    Xen_to_C_double(blue), Xen_to_C_double(alpha));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_set_matrix(Xen pattern, Xen matrix)
{
  #define H_cairo_pattern_set_matrix "void cairo_pattern_set_matrix(cairo_pattern_t* pattern, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_set_matrix", "cairo_pattern_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_pattern_set_matrix", "cairo_matrix_t*");
  cairo_pattern_set_matrix(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_get_matrix(Xen pattern, Xen matrix)
{
  #define H_cairo_pattern_get_matrix "void cairo_pattern_get_matrix(cairo_pattern_t* pattern, cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_matrix", "cairo_pattern_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 2, "cairo_pattern_get_matrix", "cairo_matrix_t*");
  cairo_pattern_get_matrix(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_set_extend(Xen pattern, Xen extend)
{
  #define H_cairo_pattern_set_extend "void cairo_pattern_set_extend(cairo_pattern_t* pattern, cairo_extend_t extend)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_set_extend", "cairo_pattern_t*");
  Xen_check_type(Xen_is_cairo_extend_t(extend), extend, 2, "cairo_pattern_set_extend", "cairo_extend_t");
  cairo_pattern_set_extend(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_cairo_extend_t(extend));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_get_extend(Xen pattern)
{
  #define H_cairo_pattern_get_extend "cairo_extend_t cairo_pattern_get_extend(cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_extend", "cairo_pattern_t*");
  return(C_to_Xen_cairo_extend_t(cairo_pattern_get_extend(Xen_to_C_cairo_pattern_t_(pattern))));
}

static Xen gxg_cairo_pattern_set_filter(Xen pattern, Xen filter)
{
  #define H_cairo_pattern_set_filter "void cairo_pattern_set_filter(cairo_pattern_t* pattern, cairo_filter_t filter)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_set_filter", "cairo_pattern_t*");
  Xen_check_type(Xen_is_cairo_filter_t(filter), filter, 2, "cairo_pattern_set_filter", "cairo_filter_t");
  cairo_pattern_set_filter(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_cairo_filter_t(filter));
  return(Xen_false);
}

static Xen gxg_cairo_pattern_get_filter(Xen pattern)
{
  #define H_cairo_pattern_get_filter "cairo_filter_t cairo_pattern_get_filter(cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_filter", "cairo_pattern_t*");
  return(C_to_Xen_cairo_filter_t(cairo_pattern_get_filter(Xen_to_C_cairo_pattern_t_(pattern))));
}

static Xen gxg_cairo_matrix_init(Xen matrix, Xen xx, Xen yx, Xen xy, Xen yy, Xen x0, Xen y0)
{
  #define H_cairo_matrix_init "void cairo_matrix_init(cairo_matrix_t* matrix, double xx, double yx, double xy, \
double yy, double x0, double y0)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_init", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(xx), xx, 2, "cairo_matrix_init", "double");
  Xen_check_type(Xen_is_double(yx), yx, 3, "cairo_matrix_init", "double");
  Xen_check_type(Xen_is_double(xy), xy, 4, "cairo_matrix_init", "double");
  Xen_check_type(Xen_is_double(yy), yy, 5, "cairo_matrix_init", "double");
  Xen_check_type(Xen_is_double(x0), x0, 6, "cairo_matrix_init", "double");
  Xen_check_type(Xen_is_double(y0), y0, 7, "cairo_matrix_init", "double");
  cairo_matrix_init(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(xx), Xen_to_C_double(yx), Xen_to_C_double(xy), Xen_to_C_double(yy), 
                    Xen_to_C_double(x0), Xen_to_C_double(y0));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_init_identity(Xen matrix)
{
  #define H_cairo_matrix_init_identity "void cairo_matrix_init_identity(cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_init_identity", "cairo_matrix_t*");
  cairo_matrix_init_identity(Xen_to_C_cairo_matrix_t_(matrix));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_init_translate(Xen matrix, Xen tx, Xen ty)
{
  #define H_cairo_matrix_init_translate "void cairo_matrix_init_translate(cairo_matrix_t* matrix, double tx, \
double ty)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_init_translate", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(tx), tx, 2, "cairo_matrix_init_translate", "double");
  Xen_check_type(Xen_is_double(ty), ty, 3, "cairo_matrix_init_translate", "double");
  cairo_matrix_init_translate(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(tx), Xen_to_C_double(ty));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_init_scale(Xen matrix, Xen sx, Xen sy)
{
  #define H_cairo_matrix_init_scale "void cairo_matrix_init_scale(cairo_matrix_t* matrix, double sx, \
double sy)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_init_scale", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(sx), sx, 2, "cairo_matrix_init_scale", "double");
  Xen_check_type(Xen_is_double(sy), sy, 3, "cairo_matrix_init_scale", "double");
  cairo_matrix_init_scale(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(sx), Xen_to_C_double(sy));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_init_rotate(Xen matrix, Xen radians)
{
  #define H_cairo_matrix_init_rotate "void cairo_matrix_init_rotate(cairo_matrix_t* matrix, double radians)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_init_rotate", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(radians), radians, 2, "cairo_matrix_init_rotate", "double");
  cairo_matrix_init_rotate(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(radians));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_translate(Xen matrix, Xen tx, Xen ty)
{
  #define H_cairo_matrix_translate "void cairo_matrix_translate(cairo_matrix_t* matrix, double tx, double ty)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_translate", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(tx), tx, 2, "cairo_matrix_translate", "double");
  Xen_check_type(Xen_is_double(ty), ty, 3, "cairo_matrix_translate", "double");
  cairo_matrix_translate(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(tx), Xen_to_C_double(ty));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_scale(Xen matrix, Xen sx, Xen sy)
{
  #define H_cairo_matrix_scale "void cairo_matrix_scale(cairo_matrix_t* matrix, double sx, double sy)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_scale", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(sx), sx, 2, "cairo_matrix_scale", "double");
  Xen_check_type(Xen_is_double(sy), sy, 3, "cairo_matrix_scale", "double");
  cairo_matrix_scale(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(sx), Xen_to_C_double(sy));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_rotate(Xen matrix, Xen radians)
{
  #define H_cairo_matrix_rotate "void cairo_matrix_rotate(cairo_matrix_t* matrix, double radians)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_rotate", "cairo_matrix_t*");
  Xen_check_type(Xen_is_double(radians), radians, 2, "cairo_matrix_rotate", "double");
  cairo_matrix_rotate(Xen_to_C_cairo_matrix_t_(matrix), Xen_to_C_double(radians));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_invert(Xen matrix)
{
  #define H_cairo_matrix_invert "cairo_status_t cairo_matrix_invert(cairo_matrix_t* matrix)"
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_invert", "cairo_matrix_t*");
  return(C_to_Xen_cairo_status_t(cairo_matrix_invert(Xen_to_C_cairo_matrix_t_(matrix))));
}

static Xen gxg_cairo_matrix_multiply(Xen result, Xen a, Xen b)
{
  #define H_cairo_matrix_multiply "void cairo_matrix_multiply(cairo_matrix_t* result, cairo_matrix_t* a, \
cairo_matrix_t* b)"
  Xen_check_type(Xen_is_cairo_matrix_t_(result), result, 1, "cairo_matrix_multiply", "cairo_matrix_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(a), a, 2, "cairo_matrix_multiply", "cairo_matrix_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(b), b, 3, "cairo_matrix_multiply", "cairo_matrix_t*");
  cairo_matrix_multiply(Xen_to_C_cairo_matrix_t_(result), Xen_to_C_cairo_matrix_t_(a), Xen_to_C_cairo_matrix_t_(b));
  return(Xen_false);
}

static Xen gxg_cairo_matrix_transform_distance(Xen matrix, Xen ignore_dx, Xen ignore_dy)
{
  #define H_cairo_matrix_transform_distance "void cairo_matrix_transform_distance(cairo_matrix_t* matrix, \
gdouble* [dx], gdouble* [dy])"
  gdouble ref_dx;
  gdouble ref_dy;
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_transform_distance", "cairo_matrix_t*");
  cairo_matrix_transform_distance(Xen_to_C_cairo_matrix_t_(matrix), &ref_dx, &ref_dy);
  return(Xen_list_2(C_to_Xen_gdouble(ref_dx), C_to_Xen_gdouble(ref_dy)));
}

static Xen gxg_cairo_matrix_transform_point(Xen matrix, Xen ignore_x, Xen ignore_y)
{
  #define H_cairo_matrix_transform_point "void cairo_matrix_transform_point(cairo_matrix_t* matrix, gdouble* [x], \
gdouble* [y])"
  gdouble ref_x;
  gdouble ref_y;
  Xen_check_type(Xen_is_cairo_matrix_t_(matrix), matrix, 1, "cairo_matrix_transform_point", "cairo_matrix_t*");
  cairo_matrix_transform_point(Xen_to_C_cairo_matrix_t_(matrix), &ref_x, &ref_y);
  return(Xen_list_2(C_to_Xen_gdouble(ref_x), C_to_Xen_gdouble(ref_y)));
}

static Xen gxg_cairo_get_reference_count(Xen cr)
{
  #define H_cairo_get_reference_count "guint cairo_get_reference_count(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_reference_count", "cairo_t*");
  return(C_to_Xen_guint(cairo_get_reference_count(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_user_data(Xen cr, Xen key)
{
  #define H_cairo_get_user_data "void* cairo_get_user_data(cairo_t* cr, cairo_user_data_key_t* key)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_user_data", "cairo_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_get_user_data", "cairo_user_data_key_t*");
  return(C_to_Xen_void_(cairo_get_user_data(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_user_data_key_t_(key))));
}

static Xen gxg_cairo_set_user_data(Xen cr, Xen key, Xen user_data, Xen destroy)
{
  #define H_cairo_set_user_data "cairo_status_t cairo_set_user_data(cairo_t* cr, cairo_user_data_key_t* key, \
void* user_data, cairo_destroy_func_t destroy)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_set_user_data", "cairo_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_set_user_data", "cairo_user_data_key_t*");
  Xen_check_type(Xen_is_void_(user_data), user_data, 3, "cairo_set_user_data", "void*");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 4, "cairo_set_user_data", "cairo_destroy_func_t");
  return(C_to_Xen_cairo_status_t(cairo_set_user_data(Xen_to_C_cairo_t_(cr), Xen_to_C_cairo_user_data_key_t_(key), Xen_to_C_void_(user_data), 
                                                     Xen_to_C_cairo_destroy_func_t(destroy))));
}

static Xen gxg_cairo_clip_extents(Xen cr, Xen ignore_x1, Xen ignore_y1, Xen ignore_x2, Xen ignore_y2)
{
  #define H_cairo_clip_extents "void cairo_clip_extents(cairo_t* cr, double* [x1], double* [y1], double* [x2], \
double* [y2])"
  double ref_x1;
  double ref_y1;
  double ref_x2;
  double ref_y2;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_clip_extents", "cairo_t*");
  cairo_clip_extents(Xen_to_C_cairo_t_(cr), &ref_x1, &ref_y1, &ref_x2, &ref_y2);
  return(Xen_list_4(C_to_Xen_double(ref_x1), C_to_Xen_double(ref_y1), C_to_Xen_double(ref_x2), C_to_Xen_double(ref_y2)));
}

static Xen gxg_cairo_copy_clip_rectangle_list(Xen cr)
{
  #define H_cairo_copy_clip_rectangle_list "cairo_rectangle_list_t* cairo_copy_clip_rectangle_list(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_copy_clip_rectangle_list", "cairo_t*");
  return(C_to_Xen_cairo_rectangle_list_t_(cairo_copy_clip_rectangle_list(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_rectangle_list_destroy(Xen rectangle_list)
{
  #define H_cairo_rectangle_list_destroy "void cairo_rectangle_list_destroy(cairo_rectangle_list_t* rectangle_list)"
  Xen_check_type(Xen_is_cairo_rectangle_list_t_(rectangle_list), rectangle_list, 1, "cairo_rectangle_list_destroy", "cairo_rectangle_list_t*");
  cairo_rectangle_list_destroy(Xen_to_C_cairo_rectangle_list_t_(rectangle_list));
  return(Xen_false);
}

static Xen gxg_cairo_font_face_get_reference_count(Xen font_face)
{
  #define H_cairo_font_face_get_reference_count "guint cairo_font_face_get_reference_count(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_font_face_get_reference_count", "cairo_font_face_t*");
  return(C_to_Xen_guint(cairo_font_face_get_reference_count(Xen_to_C_cairo_font_face_t_(font_face))));
}

static Xen gxg_cairo_scaled_font_get_reference_count(Xen scaled_font)
{
  #define H_cairo_scaled_font_get_reference_count "guint cairo_scaled_font_get_reference_count(cairo_scaled_font_t* scaled_font)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_reference_count", "cairo_scaled_font_t*");
  return(C_to_Xen_guint(cairo_scaled_font_get_reference_count(Xen_to_C_cairo_scaled_font_t_(scaled_font))));
}

static Xen gxg_cairo_scaled_font_get_user_data(Xen scaled_font, Xen key)
{
  #define H_cairo_scaled_font_get_user_data "void* cairo_scaled_font_get_user_data(cairo_scaled_font_t* scaled_font, \
cairo_user_data_key_t* key)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_user_data", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_scaled_font_get_user_data", "cairo_user_data_key_t*");
  return(C_to_Xen_void_(cairo_scaled_font_get_user_data(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_user_data_key_t_(key))));
}

static Xen gxg_cairo_scaled_font_set_user_data(Xen scaled_font, Xen key, Xen user_data, Xen destroy)
{
  #define H_cairo_scaled_font_set_user_data "cairo_status_t cairo_scaled_font_set_user_data(cairo_scaled_font_t* scaled_font, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_set_user_data", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_scaled_font_set_user_data", "cairo_user_data_key_t*");
  Xen_check_type(Xen_is_void_(user_data), user_data, 3, "cairo_scaled_font_set_user_data", "void*");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 4, "cairo_scaled_font_set_user_data", "cairo_destroy_func_t");
  return(C_to_Xen_cairo_status_t(cairo_scaled_font_set_user_data(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_user_data_key_t_(key), 
                                                                 Xen_to_C_void_(user_data), Xen_to_C_cairo_destroy_func_t(destroy))));
}

static Xen gxg_cairo_get_dash_count(Xen cr)
{
  #define H_cairo_get_dash_count "int cairo_get_dash_count(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_dash_count", "cairo_t*");
  return(C_to_Xen_int(cairo_get_dash_count(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_get_dash(Xen cr, Xen ignore_dashes, Xen ignore_offset)
{
  #define H_cairo_get_dash "void cairo_get_dash(cairo_t* cr, double* [dashes], double* [offset])"
  double ref_dashes;
  double ref_offset;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_dash", "cairo_t*");
  cairo_get_dash(Xen_to_C_cairo_t_(cr), &ref_dashes, &ref_offset);
  return(Xen_list_2(C_to_Xen_double(ref_dashes), C_to_Xen_double(ref_offset)));
}

static Xen gxg_cairo_surface_get_reference_count(Xen surface)
{
  #define H_cairo_surface_get_reference_count "guint cairo_surface_get_reference_count(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_reference_count", "cairo_surface_t*");
  return(C_to_Xen_guint(cairo_surface_get_reference_count(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_pattern_get_reference_count(Xen pattern)
{
  #define H_cairo_pattern_get_reference_count "guint cairo_pattern_get_reference_count(cairo_pattern_t* pattern)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_reference_count", "cairo_pattern_t*");
  return(C_to_Xen_guint(cairo_pattern_get_reference_count(Xen_to_C_cairo_pattern_t_(pattern))));
}

static Xen gxg_cairo_pattern_get_user_data(Xen pattern, Xen key)
{
  #define H_cairo_pattern_get_user_data "void* cairo_pattern_get_user_data(cairo_pattern_t* pattern, \
cairo_user_data_key_t* key)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_user_data", "cairo_pattern_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_pattern_get_user_data", "cairo_user_data_key_t*");
  return(C_to_Xen_void_(cairo_pattern_get_user_data(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_cairo_user_data_key_t_(key))));
}

static Xen gxg_cairo_pattern_set_user_data(Xen pattern, Xen key, Xen user_data, Xen destroy)
{
  #define H_cairo_pattern_set_user_data "cairo_status_t cairo_pattern_set_user_data(cairo_pattern_t* pattern, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_set_user_data", "cairo_pattern_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_pattern_set_user_data", "cairo_user_data_key_t*");
  Xen_check_type(Xen_is_void_(user_data), user_data, 3, "cairo_pattern_set_user_data", "void*");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 4, "cairo_pattern_set_user_data", "cairo_destroy_func_t");
  return(C_to_Xen_cairo_status_t(cairo_pattern_set_user_data(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_cairo_user_data_key_t_(key), 
                                                             Xen_to_C_void_(user_data), Xen_to_C_cairo_destroy_func_t(destroy))));
}

static Xen gxg_cairo_pattern_get_rgba(Xen pattern, Xen ignore_red, Xen ignore_green, Xen ignore_blue, Xen ignore_alpha)
{
  #define H_cairo_pattern_get_rgba "cairo_status_t cairo_pattern_get_rgba(cairo_pattern_t* pattern, double* [red], \
double* [green], double* [blue], double* [alpha])"
  double ref_red;
  double ref_green;
  double ref_blue;
  double ref_alpha;
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_rgba", "cairo_pattern_t*");
  {
    Xen result;
    result = C_to_Xen_cairo_status_t(cairo_pattern_get_rgba(Xen_to_C_cairo_pattern_t_(pattern), &ref_red, &ref_green, &ref_blue, 
                                                            &ref_alpha));
    return(Xen_list_5(result, C_to_Xen_double(ref_red), C_to_Xen_double(ref_green), C_to_Xen_double(ref_blue), C_to_Xen_double(ref_alpha)));
   }
}

static Xen gxg_cairo_pattern_get_surface(Xen pattern, Xen ignore_surface)
{
  #define H_cairo_pattern_get_surface "cairo_status_t cairo_pattern_get_surface(cairo_pattern_t* pattern, \
cairo_surface_t** [surface])"
  cairo_surface_t* ref_surface = NULL;
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_surface", "cairo_pattern_t*");
  {
    Xen result;
    result = C_to_Xen_cairo_status_t(cairo_pattern_get_surface(Xen_to_C_cairo_pattern_t_(pattern), &ref_surface));
    return(Xen_list_2(result, C_to_Xen_cairo_surface_t_(ref_surface)));
   }
}

static Xen gxg_cairo_pattern_get_color_stop_rgba(Xen pattern, Xen index, Xen ignore_offset, Xen ignore_red, Xen ignore_green, Xen ignore_blue, Xen ignore_alpha)
{
  #define H_cairo_pattern_get_color_stop_rgba "cairo_status_t cairo_pattern_get_color_stop_rgba(cairo_pattern_t* pattern, \
int index, double* [offset], double* [red], double* [green], double* [blue], double* [alpha])"
  double ref_offset;
  double ref_red;
  double ref_green;
  double ref_blue;
  double ref_alpha;
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_color_stop_rgba", "cairo_pattern_t*");
  Xen_check_type(Xen_is_int(index), index, 2, "cairo_pattern_get_color_stop_rgba", "int");
  {
    Xen result;
    result = C_to_Xen_cairo_status_t(cairo_pattern_get_color_stop_rgba(Xen_to_C_cairo_pattern_t_(pattern), Xen_to_C_int(index), 
                                                                       &ref_offset, &ref_red, &ref_green, &ref_blue, &ref_alpha));
    return(Xen_list_6(result, C_to_Xen_double(ref_offset), C_to_Xen_double(ref_red), C_to_Xen_double(ref_green), C_to_Xen_double(ref_blue), C_to_Xen_double(ref_alpha)));
   }
}

static Xen gxg_cairo_pattern_get_color_stop_count(Xen pattern, Xen ignore_count)
{
  #define H_cairo_pattern_get_color_stop_count "cairo_status_t cairo_pattern_get_color_stop_count(cairo_pattern_t* pattern, \
int* [count])"
  int ref_count;
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_color_stop_count", "cairo_pattern_t*");
  {
    Xen result;
    result = C_to_Xen_cairo_status_t(cairo_pattern_get_color_stop_count(Xen_to_C_cairo_pattern_t_(pattern), &ref_count));
    return(Xen_list_2(result, C_to_Xen_int(ref_count)));
   }
}

static Xen gxg_cairo_pattern_get_linear_points(Xen pattern, Xen ignore_x0, Xen ignore_y0, Xen ignore_x1, Xen ignore_y1)
{
  #define H_cairo_pattern_get_linear_points "cairo_status_t cairo_pattern_get_linear_points(cairo_pattern_t* pattern, \
double* [x0], double* [y0], double* [x1], double* [y1])"
  double ref_x0;
  double ref_y0;
  double ref_x1;
  double ref_y1;
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_linear_points", "cairo_pattern_t*");
  {
    Xen result;
    result = C_to_Xen_cairo_status_t(cairo_pattern_get_linear_points(Xen_to_C_cairo_pattern_t_(pattern), &ref_x0, &ref_y0, 
                                                                     &ref_x1, &ref_y1));
    return(Xen_list_5(result, C_to_Xen_double(ref_x0), C_to_Xen_double(ref_y0), C_to_Xen_double(ref_x1), C_to_Xen_double(ref_y1)));
   }
}

static Xen gxg_cairo_pattern_get_radial_circles(Xen pattern, Xen ignore_x0, Xen ignore_y0, Xen ignore_r0, Xen ignore_x1, Xen ignore_y1, Xen ignore_r1)
{
  #define H_cairo_pattern_get_radial_circles "cairo_status_t cairo_pattern_get_radial_circles(cairo_pattern_t* pattern, \
double* [x0], double* [y0], double* [r0], double* [x1], double* [y1], double* [r1])"
  double ref_x0;
  double ref_y0;
  double ref_r0;
  double ref_x1;
  double ref_y1;
  double ref_r1;
  Xen_check_type(Xen_is_cairo_pattern_t_(pattern), pattern, 1, "cairo_pattern_get_radial_circles", "cairo_pattern_t*");
  {
    Xen result;
    result = C_to_Xen_cairo_status_t(cairo_pattern_get_radial_circles(Xen_to_C_cairo_pattern_t_(pattern), &ref_x0, &ref_y0, 
                                                                      &ref_r0, &ref_x1, &ref_y1, &ref_r1));
    return(Xen_list_7(result, C_to_Xen_double(ref_x0), C_to_Xen_double(ref_y0), C_to_Xen_double(ref_r0), C_to_Xen_double(ref_x1), C_to_Xen_double(ref_y1), C_to_Xen_double(ref_r1)));
   }
}

static Xen gxg_cairo_get_scaled_font(Xen cr)
{
  #define H_cairo_get_scaled_font "cairo_scaled_font_t* cairo_get_scaled_font(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_get_scaled_font", "cairo_t*");
  return(C_to_Xen_cairo_scaled_font_t_(cairo_get_scaled_font(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_path_extents(Xen cr, Xen ignore_x1, Xen ignore_y1, Xen ignore_x2, Xen ignore_y2)
{
  #define H_cairo_path_extents "void cairo_path_extents(cairo_t* cr, double* [x1], double* [y1], double* [x2], \
double* [y2])"
  double ref_x1;
  double ref_y1;
  double ref_x2;
  double ref_y2;
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_path_extents", "cairo_t*");
  cairo_path_extents(Xen_to_C_cairo_t_(cr), &ref_x1, &ref_y1, &ref_x2, &ref_y2);
  return(Xen_list_4(C_to_Xen_double(ref_x1), C_to_Xen_double(ref_y1), C_to_Xen_double(ref_x2), C_to_Xen_double(ref_y2)));
}

static Xen gxg_cairo_has_current_point(Xen cr)
{
  #define H_cairo_has_current_point "bool cairo_has_current_point(cairo_t* cr)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_has_current_point", "cairo_t*");
  return(C_to_Xen_bool(cairo_has_current_point(Xen_to_C_cairo_t_(cr))));
}

static Xen gxg_cairo_surface_copy_page(Xen surface)
{
  #define H_cairo_surface_copy_page "void cairo_surface_copy_page(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_copy_page", "cairo_surface_t*");
  cairo_surface_copy_page(Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_cairo_surface_show_page(Xen surface)
{
  #define H_cairo_surface_show_page "void cairo_surface_show_page(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_show_page", "cairo_surface_t*");
  cairo_surface_show_page(Xen_to_C_cairo_surface_t_(surface));
  return(Xen_false);
}

static Xen gxg_cairo_format_stride_for_width(Xen format, Xen width)
{
  #define H_cairo_format_stride_for_width "int cairo_format_stride_for_width(cairo_format_t format, int width)"
  Xen_check_type(Xen_is_cairo_format_t(format), format, 1, "cairo_format_stride_for_width", "cairo_format_t");
  Xen_check_type(Xen_is_int(width), width, 2, "cairo_format_stride_for_width", "int");
  return(C_to_Xen_int(cairo_format_stride_for_width(Xen_to_C_cairo_format_t(format), Xen_to_C_int(width))));
}

static Xen gxg_cairo_image_surface_create_from_png(Xen filename)
{
  #define H_cairo_image_surface_create_from_png "cairo_surface_t* cairo_image_surface_create_from_png(char* filename)"
  Xen_check_type(Xen_is_char_(filename), filename, 1, "cairo_image_surface_create_from_png", "char*");
  return(C_to_Xen_cairo_surface_t_(cairo_image_surface_create_from_png((const char*)Xen_to_C_char_(filename))));
}

static Xen gxg_cairo_surface_write_to_png(Xen surface, Xen filename)
{
  #define H_cairo_surface_write_to_png "cairo_status_t cairo_surface_write_to_png(cairo_surface_t* surface, \
char* filename)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_write_to_png", "cairo_surface_t*");
  Xen_check_type(Xen_is_char_(filename), filename, 2, "cairo_surface_write_to_png", "char*");
  return(C_to_Xen_cairo_status_t(cairo_surface_write_to_png(Xen_to_C_cairo_surface_t_(surface), (const char*)Xen_to_C_char_(filename))));
}

#if HAVE_CAIRO_1_8
static Xen gxg_cairo_glyph_allocate(Xen num_glyphs)
{
  #define H_cairo_glyph_allocate "cairo_glyph_t* cairo_glyph_allocate(int num_glyphs)"
  Xen_check_type(Xen_is_int(num_glyphs), num_glyphs, 1, "cairo_glyph_allocate", "int");
  return(C_to_Xen_cairo_glyph_t_(cairo_glyph_allocate(Xen_to_C_int(num_glyphs))));
}

static Xen gxg_cairo_glyph_free(Xen glyphs)
{
  #define H_cairo_glyph_free "void cairo_glyph_free(cairo_glyph_t* glyphs)"
  Xen_check_type(Xen_is_cairo_glyph_t_(glyphs), glyphs, 1, "cairo_glyph_free", "cairo_glyph_t*");
  cairo_glyph_free(Xen_to_C_cairo_glyph_t_(glyphs));
  return(Xen_false);
}

static Xen gxg_cairo_text_cluster_allocate(Xen num_clusters)
{
  #define H_cairo_text_cluster_allocate "cairo_text_cluster_t* cairo_text_cluster_allocate(int num_clusters)"
  Xen_check_type(Xen_is_int(num_clusters), num_clusters, 1, "cairo_text_cluster_allocate", "int");
  return(C_to_Xen_cairo_text_cluster_t_(cairo_text_cluster_allocate(Xen_to_C_int(num_clusters))));
}

static Xen gxg_cairo_text_cluster_free(Xen clusters)
{
  #define H_cairo_text_cluster_free "void cairo_text_cluster_free(cairo_text_cluster_t* clusters)"
  Xen_check_type(Xen_is_cairo_text_cluster_t_(clusters), clusters, 1, "cairo_text_cluster_free", "cairo_text_cluster_t*");
  cairo_text_cluster_free(Xen_to_C_cairo_text_cluster_t_(clusters));
  return(Xen_false);
}

static Xen gxg_cairo_show_text_glyphs(Xen arglist)
{
  #define H_cairo_show_text_glyphs "void cairo_show_text_glyphs(cairo_t* cr, char* utf8, int utf8_len, \
cairo_glyph_t* glyphs, int num_glyphs, cairo_text_cluster_t* clusters, int num_clusters, cairo_text_cluster_flags_t cluster_flags)"
  Xen cr, utf8, utf8_len, glyphs, num_glyphs, clusters, num_clusters, cluster_flags;
  cr = Xen_list_ref(arglist, 0);
  utf8 = Xen_list_ref(arglist, 1);
  utf8_len = Xen_list_ref(arglist, 2);
  glyphs = Xen_list_ref(arglist, 3);
  num_glyphs = Xen_list_ref(arglist, 4);
  clusters = Xen_list_ref(arglist, 5);
  num_clusters = Xen_list_ref(arglist, 6);
  cluster_flags = Xen_list_ref(arglist, 7);
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_show_text_glyphs", "cairo_t*");
  Xen_check_type(Xen_is_char_(utf8), utf8, 2, "cairo_show_text_glyphs", "char*");
  Xen_check_type(Xen_is_int(utf8_len), utf8_len, 3, "cairo_show_text_glyphs", "int");
  Xen_check_type(Xen_is_cairo_glyph_t_(glyphs), glyphs, 4, "cairo_show_text_glyphs", "cairo_glyph_t*");
  Xen_check_type(Xen_is_int(num_glyphs), num_glyphs, 5, "cairo_show_text_glyphs", "int");
  Xen_check_type(Xen_is_cairo_text_cluster_t_(clusters), clusters, 6, "cairo_show_text_glyphs", "cairo_text_cluster_t*");
  Xen_check_type(Xen_is_int(num_clusters), num_clusters, 7, "cairo_show_text_glyphs", "int");
  Xen_check_type(Xen_is_cairo_text_cluster_flags_t(cluster_flags), cluster_flags, 8, "cairo_show_text_glyphs", "cairo_text_cluster_flags_t");
  cairo_show_text_glyphs(Xen_to_C_cairo_t_(cr), (const char*)Xen_to_C_char_(utf8), Xen_to_C_int(utf8_len), Xen_to_C_cairo_glyph_t_(glyphs), 
                         Xen_to_C_int(num_glyphs), Xen_to_C_cairo_text_cluster_t_(clusters), Xen_to_C_int(num_clusters), 
                         Xen_to_C_cairo_text_cluster_flags_t(cluster_flags));
  return(Xen_false);
}

static Xen gxg_cairo_scaled_font_text_to_glyphs(Xen arglist)
{
  #define H_cairo_scaled_font_text_to_glyphs "cairo_status_t cairo_scaled_font_text_to_glyphs(cairo_scaled_font_t* scaled_font, \
double x, double y, char* utf8, int utf8_len, cairo_glyph_t** glyphs, int* num_glyphs, cairo_text_cluster_t** clusters, \
int* num_clusters, cairo_text_cluster_flags_t* cluster_flags)"
  Xen scaled_font, x, y, utf8, utf8_len, glyphs, num_glyphs, clusters, num_clusters, cluster_flags;
  scaled_font = Xen_list_ref(arglist, 0);
  x = Xen_list_ref(arglist, 1);
  y = Xen_list_ref(arglist, 2);
  utf8 = Xen_list_ref(arglist, 3);
  utf8_len = Xen_list_ref(arglist, 4);
  glyphs = Xen_list_ref(arglist, 5);
  num_glyphs = Xen_list_ref(arglist, 6);
  clusters = Xen_list_ref(arglist, 7);
  num_clusters = Xen_list_ref(arglist, 8);
  cluster_flags = Xen_list_ref(arglist, 9);
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_text_to_glyphs", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_scaled_font_text_to_glyphs", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_scaled_font_text_to_glyphs", "double");
  Xen_check_type(Xen_is_char_(utf8), utf8, 4, "cairo_scaled_font_text_to_glyphs", "char*");
  Xen_check_type(Xen_is_int(utf8_len), utf8_len, 5, "cairo_scaled_font_text_to_glyphs", "int");
  Xen_check_type(Xen_is_cairo_glyph_t__(glyphs), glyphs, 6, "cairo_scaled_font_text_to_glyphs", "cairo_glyph_t**");
  Xen_check_type(Xen_is_int_(num_glyphs), num_glyphs, 7, "cairo_scaled_font_text_to_glyphs", "int*");
  Xen_check_type(Xen_is_cairo_text_cluster_t__(clusters), clusters, 8, "cairo_scaled_font_text_to_glyphs", "cairo_text_cluster_t**");
  Xen_check_type(Xen_is_int_(num_clusters), num_clusters, 9, "cairo_scaled_font_text_to_glyphs", "int*");
  Xen_check_type(Xen_is_cairo_text_cluster_flags_t_(cluster_flags), cluster_flags, 10, "cairo_scaled_font_text_to_glyphs", "cairo_text_cluster_flags_t*");
  return(C_to_Xen_cairo_status_t(cairo_scaled_font_text_to_glyphs(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_double(x), 
                                                                  Xen_to_C_double(y), (const char*)Xen_to_C_char_(utf8), Xen_to_C_int(utf8_len), 
                                                                  Xen_to_C_cairo_glyph_t__(glyphs), Xen_to_C_int_(num_glyphs), 
                                                                  Xen_to_C_cairo_text_cluster_t__(clusters), Xen_to_C_int_(num_clusters), 
                                                                  Xen_to_C_cairo_text_cluster_flags_t_(cluster_flags))));
}

static Xen gxg_cairo_scaled_font_get_scale_matrix(Xen scaled_font, Xen scale_matrix)
{
  #define H_cairo_scaled_font_get_scale_matrix "void cairo_scaled_font_get_scale_matrix(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* scale_matrix)"
  Xen_check_type(Xen_is_cairo_scaled_font_t_(scaled_font), scaled_font, 1, "cairo_scaled_font_get_scale_matrix", "cairo_scaled_font_t*");
  Xen_check_type(Xen_is_cairo_matrix_t_(scale_matrix), scale_matrix, 2, "cairo_scaled_font_get_scale_matrix", "cairo_matrix_t*");
  cairo_scaled_font_get_scale_matrix(Xen_to_C_cairo_scaled_font_t_(scaled_font), Xen_to_C_cairo_matrix_t_(scale_matrix));
  return(Xen_false);
}

static Xen gxg_cairo_toy_font_face_create(Xen family, Xen slant, Xen weight)
{
  #define H_cairo_toy_font_face_create "cairo_font_face_t* cairo_toy_font_face_create(char* family, cairo_font_slant_t slant, \
cairo_font_weight_t weight)"
  Xen_check_type(Xen_is_char_(family), family, 1, "cairo_toy_font_face_create", "char*");
  Xen_check_type(Xen_is_cairo_font_slant_t(slant), slant, 2, "cairo_toy_font_face_create", "cairo_font_slant_t");
  Xen_check_type(Xen_is_cairo_font_weight_t(weight), weight, 3, "cairo_toy_font_face_create", "cairo_font_weight_t");
  return(C_to_Xen_cairo_font_face_t_(cairo_toy_font_face_create((const char*)Xen_to_C_char_(family), Xen_to_C_cairo_font_slant_t(slant), 
                                                                Xen_to_C_cairo_font_weight_t(weight))));
}

static Xen gxg_cairo_toy_font_face_get_family(Xen font_face)
{
  #define H_cairo_toy_font_face_get_family "char* cairo_toy_font_face_get_family(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_toy_font_face_get_family", "cairo_font_face_t*");
  return(C_to_Xen_char_(cairo_toy_font_face_get_family(Xen_to_C_cairo_font_face_t_(font_face))));
}

static Xen gxg_cairo_toy_font_face_get_slant(Xen font_face)
{
  #define H_cairo_toy_font_face_get_slant "cairo_font_slant_t cairo_toy_font_face_get_slant(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_toy_font_face_get_slant", "cairo_font_face_t*");
  return(C_to_Xen_cairo_font_slant_t(cairo_toy_font_face_get_slant(Xen_to_C_cairo_font_face_t_(font_face))));
}

static Xen gxg_cairo_toy_font_face_get_weight(Xen font_face)
{
  #define H_cairo_toy_font_face_get_weight "cairo_font_weight_t cairo_toy_font_face_get_weight(cairo_font_face_t* font_face)"
  Xen_check_type(Xen_is_cairo_font_face_t_(font_face), font_face, 1, "cairo_toy_font_face_get_weight", "cairo_font_face_t*");
  return(C_to_Xen_cairo_font_weight_t(cairo_toy_font_face_get_weight(Xen_to_C_cairo_font_face_t_(font_face))));
}

static Xen gxg_cairo_user_font_face_create(void)
{
  #define H_cairo_user_font_face_create "cairo_font_face_t* cairo_user_font_face_create( void)"
  return(C_to_Xen_cairo_font_face_t_(cairo_user_font_face_create()));
}

static Xen gxg_cairo_surface_get_fallback_resolution(Xen surface, Xen ignore_x_pixels_per_inch, Xen ignore_y_pixels_per_inch)
{
  #define H_cairo_surface_get_fallback_resolution "void cairo_surface_get_fallback_resolution(cairo_surface_t* surface, \
double* [x_pixels_per_inch], double* [y_pixels_per_inch])"
  double ref_x_pixels_per_inch;
  double ref_y_pixels_per_inch;
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_fallback_resolution", "cairo_surface_t*");
  cairo_surface_get_fallback_resolution(Xen_to_C_cairo_surface_t_(surface), &ref_x_pixels_per_inch, &ref_y_pixels_per_inch);
  return(Xen_list_2(C_to_Xen_double(ref_x_pixels_per_inch), C_to_Xen_double(ref_y_pixels_per_inch)));
}

static Xen gxg_cairo_surface_has_show_text_glyphs(Xen surface)
{
  #define H_cairo_surface_has_show_text_glyphs "cairo_bool_t cairo_surface_has_show_text_glyphs(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_has_show_text_glyphs", "cairo_surface_t*");
  return(C_to_Xen_cairo_bool_t(cairo_surface_has_show_text_glyphs(Xen_to_C_cairo_surface_t_(surface))));
}

#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
static Xen gxg_cairo_in_clip(Xen cr, Xen x, Xen y)
{
  #define H_cairo_in_clip "cairo_bool_t cairo_in_clip(cairo_t* cr, double x, double y)"
  Xen_check_type(Xen_is_cairo_t_(cr), cr, 1, "cairo_in_clip", "cairo_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_in_clip", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_in_clip", "double");
  return(C_to_Xen_cairo_bool_t(cairo_in_clip(Xen_to_C_cairo_t_(cr), Xen_to_C_double(x), Xen_to_C_double(y))));
}

static Xen gxg_cairo_device_reference(Xen device)
{
  #define H_cairo_device_reference "cairo_device_t* cairo_device_reference(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_reference", "cairo_device_t*");
  return(C_to_Xen_cairo_device_t_(cairo_device_reference(Xen_to_C_cairo_device_t_(device))));
}

static Xen gxg_cairo_device_status(Xen device)
{
  #define H_cairo_device_status "cairo_status_t cairo_device_status(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_status", "cairo_device_t*");
  return(C_to_Xen_cairo_status_t(cairo_device_status(Xen_to_C_cairo_device_t_(device))));
}

static Xen gxg_cairo_device_acquire(Xen device)
{
  #define H_cairo_device_acquire "cairo_status_t cairo_device_acquire(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_acquire", "cairo_device_t*");
  return(C_to_Xen_cairo_status_t(cairo_device_acquire(Xen_to_C_cairo_device_t_(device))));
}

static Xen gxg_cairo_device_release(Xen device)
{
  #define H_cairo_device_release "void cairo_device_release(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_release", "cairo_device_t*");
  cairo_device_release(Xen_to_C_cairo_device_t_(device));
  return(Xen_false);
}

static Xen gxg_cairo_device_flush(Xen device)
{
  #define H_cairo_device_flush "void cairo_device_flush(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_flush", "cairo_device_t*");
  cairo_device_flush(Xen_to_C_cairo_device_t_(device));
  return(Xen_false);
}

static Xen gxg_cairo_device_finish(Xen device)
{
  #define H_cairo_device_finish "void cairo_device_finish(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_finish", "cairo_device_t*");
  cairo_device_finish(Xen_to_C_cairo_device_t_(device));
  return(Xen_false);
}

static Xen gxg_cairo_device_destroy(Xen device)
{
  #define H_cairo_device_destroy "void cairo_device_destroy(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_destroy", "cairo_device_t*");
  cairo_device_destroy(Xen_to_C_cairo_device_t_(device));
  return(Xen_false);
}

static Xen gxg_cairo_device_get_reference_count(Xen device)
{
  #define H_cairo_device_get_reference_count "guint cairo_device_get_reference_count(cairo_device_t* device)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_get_reference_count", "cairo_device_t*");
  return(C_to_Xen_guint(cairo_device_get_reference_count(Xen_to_C_cairo_device_t_(device))));
}

static Xen gxg_cairo_device_get_user_data(Xen device, Xen key)
{
  #define H_cairo_device_get_user_data "void* cairo_device_get_user_data(cairo_device_t* device, cairo_user_data_key_t* key)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_get_user_data", "cairo_device_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_device_get_user_data", "cairo_user_data_key_t*");
  return(C_to_Xen_void_(cairo_device_get_user_data(Xen_to_C_cairo_device_t_(device), Xen_to_C_cairo_user_data_key_t_(key))));
}

static Xen gxg_cairo_device_set_user_data(Xen device, Xen key, Xen user_data, Xen destroy)
{
  #define H_cairo_device_set_user_data "cairo_status_t cairo_device_set_user_data(cairo_device_t* device, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  Xen_check_type(Xen_is_cairo_device_t_(device), device, 1, "cairo_device_set_user_data", "cairo_device_t*");
  Xen_check_type(Xen_is_cairo_user_data_key_t_(key), key, 2, "cairo_device_set_user_data", "cairo_user_data_key_t*");
  Xen_check_type(Xen_is_void_(user_data), user_data, 3, "cairo_device_set_user_data", "void*");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 4, "cairo_device_set_user_data", "cairo_destroy_func_t");
  return(C_to_Xen_cairo_status_t(cairo_device_set_user_data(Xen_to_C_cairo_device_t_(device), Xen_to_C_cairo_user_data_key_t_(key), 
                                                            Xen_to_C_void_(user_data), Xen_to_C_cairo_destroy_func_t(destroy))));
}

static Xen gxg_cairo_surface_create_for_rectangle(Xen target, Xen x, Xen y, Xen width, Xen height)
{
  #define H_cairo_surface_create_for_rectangle "cairo_surface_t* cairo_surface_create_for_rectangle(cairo_surface_t* target, \
double x, double y, double width, double height)"
  Xen_check_type(Xen_is_cairo_surface_t_(target), target, 1, "cairo_surface_create_for_rectangle", "cairo_surface_t*");
  Xen_check_type(Xen_is_double(x), x, 2, "cairo_surface_create_for_rectangle", "double");
  Xen_check_type(Xen_is_double(y), y, 3, "cairo_surface_create_for_rectangle", "double");
  Xen_check_type(Xen_is_double(width), width, 4, "cairo_surface_create_for_rectangle", "double");
  Xen_check_type(Xen_is_double(height), height, 5, "cairo_surface_create_for_rectangle", "double");
  return(C_to_Xen_cairo_surface_t_(cairo_surface_create_for_rectangle(Xen_to_C_cairo_surface_t_(target), Xen_to_C_double(x), 
                                                                      Xen_to_C_double(y), Xen_to_C_double(width), Xen_to_C_double(height))));
}

static Xen gxg_cairo_surface_get_device(Xen surface)
{
  #define H_cairo_surface_get_device "cairo_device_t* cairo_surface_get_device(cairo_surface_t* surface)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_get_device", "cairo_surface_t*");
  return(C_to_Xen_cairo_device_t_(cairo_surface_get_device(Xen_to_C_cairo_surface_t_(surface))));
}

static Xen gxg_cairo_surface_set_mime_data(Xen surface, Xen mime_type, Xen data, Xen length, Xen destroy, Xen closure)
{
  #define H_cairo_surface_set_mime_data "cairo_status_t cairo_surface_set_mime_data(cairo_surface_t* surface, \
char* mime_type, guchar* data, gulong length, cairo_destroy_func_t destroy, void* closure)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_surface_set_mime_data", "cairo_surface_t*");
  Xen_check_type(Xen_is_char_(mime_type), mime_type, 2, "cairo_surface_set_mime_data", "char*");
  Xen_check_type(Xen_is_guchar_(data), data, 3, "cairo_surface_set_mime_data", "guchar*");
  Xen_check_type(Xen_is_gulong(length), length, 4, "cairo_surface_set_mime_data", "gulong");
  Xen_check_type(Xen_is_cairo_destroy_func_t(destroy), destroy, 5, "cairo_surface_set_mime_data", "cairo_destroy_func_t");
  Xen_check_type(Xen_is_void_(closure), closure, 6, "cairo_surface_set_mime_data", "void*");
  return(C_to_Xen_cairo_status_t(cairo_surface_set_mime_data(Xen_to_C_cairo_surface_t_(surface), (const char*)Xen_to_C_char_(mime_type), 
                                                             Xen_to_C_guchar_(data), Xen_to_C_gulong(length), Xen_to_C_cairo_destroy_func_t(destroy), 
                                                             Xen_to_C_void_(closure))));
}

static Xen gxg_cairo_recording_surface_create(Xen content, Xen extents)
{
  #define H_cairo_recording_surface_create "cairo_surface_t* cairo_recording_surface_create(cairo_content_t content, \
cairo_rectangle_t* extents)"
  Xen_check_type(Xen_is_cairo_content_t(content), content, 1, "cairo_recording_surface_create", "cairo_content_t");
  Xen_check_type(Xen_is_cairo_rectangle_t_(extents), extents, 2, "cairo_recording_surface_create", "cairo_rectangle_t*");
  return(C_to_Xen_cairo_surface_t_(cairo_recording_surface_create(Xen_to_C_cairo_content_t(content), Xen_to_C_cairo_rectangle_t_(extents))));
}

static Xen gxg_cairo_recording_surface_ink_extents(Xen surface, Xen x0, Xen y0, Xen width, Xen height)
{
  #define H_cairo_recording_surface_ink_extents "void cairo_recording_surface_ink_extents(cairo_surface_t* surface, \
double* x0, double* y0, double* width, double* height)"
  Xen_check_type(Xen_is_cairo_surface_t_(surface), surface, 1, "cairo_recording_surface_ink_extents", "cairo_surface_t*");
  Xen_check_type(Xen_is_double_(x0), x0, 2, "cairo_recording_surface_ink_extents", "double*");
  Xen_check_type(Xen_is_double_(y0), y0, 3, "cairo_recording_surface_ink_extents", "double*");
  Xen_check_type(Xen_is_double_(width), width, 4, "cairo_recording_surface_ink_extents", "double*");
  Xen_check_type(Xen_is_double_(height), height, 5, "cairo_recording_surface_ink_extents", "double*");
  cairo_recording_surface_ink_extents(Xen_to_C_cairo_surface_t_(surface), Xen_to_C_double_(x0), Xen_to_C_double_(y0), Xen_to_C_double_(width), 
                                      Xen_to_C_double_(height));
  return(Xen_false);
}

static Xen gxg_cairo_region_create(void)
{
  #define H_cairo_region_create "cairo_region_t* cairo_region_create( void)"
  return(C_to_Xen_cairo_region_t_(cairo_region_create()));
}

static Xen gxg_cairo_region_create_rectangle(Xen rectangle)
{
  #define H_cairo_region_create_rectangle "cairo_region_t* cairo_region_create_rectangle(cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 1, "cairo_region_create_rectangle", "cairo_rectangle_int_t*");
  return(C_to_Xen_cairo_region_t_(cairo_region_create_rectangle(Xen_to_C_cairo_rectangle_int_t_(rectangle))));
}

static Xen gxg_cairo_region_create_rectangles(Xen rects, Xen count)
{
  #define H_cairo_region_create_rectangles "cairo_region_t* cairo_region_create_rectangles(cairo_rectangle_int_t* rects, \
int count)"
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rects), rects, 1, "cairo_region_create_rectangles", "cairo_rectangle_int_t*");
  Xen_check_type(Xen_is_int(count), count, 2, "cairo_region_create_rectangles", "int");
  return(C_to_Xen_cairo_region_t_(cairo_region_create_rectangles(Xen_to_C_cairo_rectangle_int_t_(rects), Xen_to_C_int(count))));
}

static Xen gxg_cairo_region_copy(Xen original)
{
  #define H_cairo_region_copy "cairo_region_t* cairo_region_copy(cairo_region_t* original)"
  Xen_check_type(Xen_is_cairo_region_t_(original), original, 1, "cairo_region_copy", "cairo_region_t*");
  return(C_to_Xen_cairo_region_t_(cairo_region_copy(Xen_to_C_cairo_region_t_(original))));
}

static Xen gxg_cairo_region_reference(Xen region)
{
  #define H_cairo_region_reference "cairo_region_t* cairo_region_reference(cairo_region_t* region)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_reference", "cairo_region_t*");
  return(C_to_Xen_cairo_region_t_(cairo_region_reference(Xen_to_C_cairo_region_t_(region))));
}

static Xen gxg_cairo_region_destroy(Xen region)
{
  #define H_cairo_region_destroy "void cairo_region_destroy(cairo_region_t* region)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_destroy", "cairo_region_t*");
  cairo_region_destroy(Xen_to_C_cairo_region_t_(region));
  return(Xen_false);
}

static Xen gxg_cairo_region_equal(Xen a, Xen b)
{
  #define H_cairo_region_equal "cairo_bool_t cairo_region_equal(cairo_region_t* a, cairo_region_t* b)"
  Xen_check_type(Xen_is_cairo_region_t_(a), a, 1, "cairo_region_equal", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_region_t_(b), b, 2, "cairo_region_equal", "cairo_region_t*");
  return(C_to_Xen_cairo_bool_t(cairo_region_equal(Xen_to_C_cairo_region_t_(a), Xen_to_C_cairo_region_t_(b))));
}

static Xen gxg_cairo_region_status(Xen region)
{
  #define H_cairo_region_status "cairo_status_t cairo_region_status(cairo_region_t* region)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_status", "cairo_region_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_status(Xen_to_C_cairo_region_t_(region))));
}

static Xen gxg_cairo_region_get_extents(Xen region, Xen extents)
{
  #define H_cairo_region_get_extents "void cairo_region_get_extents(cairo_region_t* region, cairo_rectangle_int_t* extents)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_get_extents", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(extents), extents, 2, "cairo_region_get_extents", "cairo_rectangle_int_t*");
  cairo_region_get_extents(Xen_to_C_cairo_region_t_(region), Xen_to_C_cairo_rectangle_int_t_(extents));
  return(Xen_false);
}

static Xen gxg_cairo_region_num_rectangles(Xen region)
{
  #define H_cairo_region_num_rectangles "int cairo_region_num_rectangles(cairo_region_t* region)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_num_rectangles", "cairo_region_t*");
  return(C_to_Xen_int(cairo_region_num_rectangles(Xen_to_C_cairo_region_t_(region))));
}

static Xen gxg_cairo_region_get_rectangle(Xen region, Xen nth, Xen rectangle)
{
  #define H_cairo_region_get_rectangle "void cairo_region_get_rectangle(cairo_region_t* region, int nth, \
cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_get_rectangle", "cairo_region_t*");
  Xen_check_type(Xen_is_int(nth), nth, 2, "cairo_region_get_rectangle", "int");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 3, "cairo_region_get_rectangle", "cairo_rectangle_int_t*");
  cairo_region_get_rectangle(Xen_to_C_cairo_region_t_(region), Xen_to_C_int(nth), Xen_to_C_cairo_rectangle_int_t_(rectangle));
  return(Xen_false);
}

static Xen gxg_cairo_region_is_empty(Xen region)
{
  #define H_cairo_region_is_empty "cairo_bool_t cairo_region_is_empty(cairo_region_t* region)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_is_empty", "cairo_region_t*");
  return(C_to_Xen_cairo_bool_t(cairo_region_is_empty(Xen_to_C_cairo_region_t_(region))));
}

static Xen gxg_cairo_region_contains_rectangle(Xen region, Xen rectangle)
{
  #define H_cairo_region_contains_rectangle "cairo_region_overlap_t cairo_region_contains_rectangle(cairo_region_t* region, \
cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_contains_rectangle", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 2, "cairo_region_contains_rectangle", "cairo_rectangle_int_t*");
  return(C_to_Xen_cairo_region_overlap_t(cairo_region_contains_rectangle(Xen_to_C_cairo_region_t_(region), Xen_to_C_cairo_rectangle_int_t_(rectangle))));
}

static Xen gxg_cairo_region_contains_point(Xen region, Xen x, Xen y)
{
  #define H_cairo_region_contains_point "cairo_bool_t cairo_region_contains_point(cairo_region_t* region, \
int x, int y)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_contains_point", "cairo_region_t*");
  Xen_check_type(Xen_is_int(x), x, 2, "cairo_region_contains_point", "int");
  Xen_check_type(Xen_is_int(y), y, 3, "cairo_region_contains_point", "int");
  return(C_to_Xen_cairo_bool_t(cairo_region_contains_point(Xen_to_C_cairo_region_t_(region), Xen_to_C_int(x), Xen_to_C_int(y))));
}

static Xen gxg_cairo_region_translate(Xen region, Xen dx, Xen dy)
{
  #define H_cairo_region_translate "void cairo_region_translate(cairo_region_t* region, int dx, int dy)"
  Xen_check_type(Xen_is_cairo_region_t_(region), region, 1, "cairo_region_translate", "cairo_region_t*");
  Xen_check_type(Xen_is_int(dx), dx, 2, "cairo_region_translate", "int");
  Xen_check_type(Xen_is_int(dy), dy, 3, "cairo_region_translate", "int");
  cairo_region_translate(Xen_to_C_cairo_region_t_(region), Xen_to_C_int(dx), Xen_to_C_int(dy));
  return(Xen_false);
}

static Xen gxg_cairo_region_subtract(Xen dst, Xen other)
{
  #define H_cairo_region_subtract "cairo_status_t cairo_region_subtract(cairo_region_t* dst, cairo_region_t* other)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_subtract", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_region_t_(other), other, 2, "cairo_region_subtract", "cairo_region_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_subtract(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_region_t_(other))));
}

static Xen gxg_cairo_region_subtract_rectangle(Xen dst, Xen rectangle)
{
  #define H_cairo_region_subtract_rectangle "cairo_status_t cairo_region_subtract_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_subtract_rectangle", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 2, "cairo_region_subtract_rectangle", "cairo_rectangle_int_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_subtract_rectangle(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_rectangle_int_t_(rectangle))));
}

static Xen gxg_cairo_region_intersect(Xen dst, Xen other)
{
  #define H_cairo_region_intersect "cairo_status_t cairo_region_intersect(cairo_region_t* dst, cairo_region_t* other)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_intersect", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_region_t_(other), other, 2, "cairo_region_intersect", "cairo_region_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_intersect(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_region_t_(other))));
}

static Xen gxg_cairo_region_intersect_rectangle(Xen dst, Xen rectangle)
{
  #define H_cairo_region_intersect_rectangle "cairo_status_t cairo_region_intersect_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_intersect_rectangle", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 2, "cairo_region_intersect_rectangle", "cairo_rectangle_int_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_intersect_rectangle(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_rectangle_int_t_(rectangle))));
}

static Xen gxg_cairo_region_union(Xen dst, Xen other)
{
  #define H_cairo_region_union "cairo_status_t cairo_region_union(cairo_region_t* dst, cairo_region_t* other)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_union", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_region_t_(other), other, 2, "cairo_region_union", "cairo_region_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_union(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_region_t_(other))));
}

static Xen gxg_cairo_region_union_rectangle(Xen dst, Xen rectangle)
{
  #define H_cairo_region_union_rectangle "cairo_status_t cairo_region_union_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_union_rectangle", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 2, "cairo_region_union_rectangle", "cairo_rectangle_int_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_union_rectangle(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_rectangle_int_t_(rectangle))));
}

static Xen gxg_cairo_region_xor(Xen dst, Xen other)
{
  #define H_cairo_region_xor "cairo_status_t cairo_region_xor(cairo_region_t* dst, cairo_region_t* other)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_xor", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_region_t_(other), other, 2, "cairo_region_xor", "cairo_region_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_xor(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_region_t_(other))));
}

static Xen gxg_cairo_region_xor_rectangle(Xen dst, Xen rectangle)
{
  #define H_cairo_region_xor_rectangle "cairo_status_t cairo_region_xor_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  Xen_check_type(Xen_is_cairo_region_t_(dst), dst, 1, "cairo_region_xor_rectangle", "cairo_region_t*");
  Xen_check_type(Xen_is_cairo_rectangle_int_t_(rectangle), rectangle, 2, "cairo_region_xor_rectangle", "cairo_rectangle_int_t*");
  return(C_to_Xen_cairo_status_t(cairo_region_xor_rectangle(Xen_to_C_cairo_region_t_(dst), Xen_to_C_cairo_rectangle_int_t_(rectangle))));
}

#endif

#define Xen_is_wrapped_object(Obj) (Xen_is_list(Obj) && (Xen_list_length(Obj) >= 2) && (Xen_is_symbol(Xen_car(Obj))))

static Xen gxg_GPOINTER(Xen obj) {return(Xen_list_2(xg_gpointer_symbol, (Xen_is_wrapped_object(obj)) ? Xen_cadr(obj) : Xen_wrap_C_pointer(obj)));}
static Xen gxg_GDK_DRAG_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkDragContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_DEVICE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkDevice__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_KEYMAP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkKeymap__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_WINDOW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkWindow__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_PIXBUF(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkPixbuf__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ACCEL_GROUP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAccelGroup__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ACCEL_LABEL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAccelLabel__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ACCESSIBLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAccessible__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ADJUSTMENT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAdjustment__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ASPECT_FRAME(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAspectFrame__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_BUTTON_BOX(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkButtonBox__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_BIN(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkBin__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_BOX(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkBox__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CALENDAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCalendar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_EDITABLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellEditable__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRenderer__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_PIXBUF(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererPixbuf__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_TEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererText__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_TOGGLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererToggle__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CHECK_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCheckButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CHECK_MENU_ITEM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCheckMenuItem__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CONTAINER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkContainer__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_DIALOG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkDialog__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_DRAWING_AREA(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkDrawingArea__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_EDITABLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEditable__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ENTRY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEntry__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FIXED(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFixed__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FRAME(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFrame__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_IMAGE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkImage__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_IM_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkIMContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_IM_CONTEXT_SIMPLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkIMContextSimple__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_INVISIBLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkInvisible__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LABEL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkLabel__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LAYOUT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkLayout__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LIST_STORE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkListStore__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_MENU_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkMenuBar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_MENU(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkMenu__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_MENU_ITEM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkMenuItem__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_MENU_SHELL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkMenuShell__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_NOTEBOOK(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkNotebook__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_PANED(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPaned__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_PROGRESS_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkProgressBar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RADIO_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRadioButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RADIO_MENU_ITEM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRadioMenuItem__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RANGE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRange__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SCALE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkScale__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SCROLLBAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkScrollbar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SCROLLED_WINDOW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkScrolledWindow__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SEPARATOR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSeparator__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SEPARATOR_MENU_ITEM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSeparatorMenuItem__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SETTINGS(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSettings__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SIZE_GROUP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSizeGroup__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SPIN_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSpinButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_STATUSBAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkStatusbar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TEXT_BUFFER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTextBuffer__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TEXT_CHILD_ANCHOR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTextChildAnchor__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TEXT_MARK(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTextMark__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TEXT_TAG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTextTag__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TEXT_TAG_TABLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTextTagTable__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TEXT_VIEW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTextView__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOGGLE_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToggleButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOLBAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToolbar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_DRAG_SOURCE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeDragSource__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_DRAG_DEST(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeDragDest__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_MODEL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeModel__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_MODEL_SORT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeModelSort__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_SELECTION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeSelection__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_SORTABLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeSortable__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_STORE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeStore__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_VIEW_COLUMN(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeViewColumn__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_VIEW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeView__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_VIEWPORT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkViewport__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_WIDGET(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkWidget__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_WINDOW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkWindow__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_PANGO_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_PangoContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_PANGO_FONT_FAMILY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_PangoFontFamily__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_PANGO_FONT_FACE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_PangoFontFace__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_PANGO_FONT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_PangoFont__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_PANGO_FONT_MAP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_PangoFontMap__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_PANGO_LAYOUT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_PangoLayout__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_G_OBJECT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GObject__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_DISPLAY_OBJECT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkDisplay__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEvent__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_ANY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventAny__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_EXPOSE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventExpose__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_NOEXPOSE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventNoExpose__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_VISIBILITY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventVisibility__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_MOTION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventMotion__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_SCROLL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventScroll__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_KEY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventKey__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_CROSSING(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventCrossing__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_FOCUS(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventFocus__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_CONFIGURE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventConfigure__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_PROPERTY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventProperty__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_SELECTION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventSelection__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_PROXIMITY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventProximity__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_SETTING(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventSetting__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_WINDOWSTATE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventWindowState__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT_DND(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEventDND__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FILE_CHOOSER_DIALOG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFileChooserDialog__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FILE_CHOOSER_WIDGET(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFileChooserWidget__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TREE_MODEL_FILTER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTreeModelFilter__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_COMBO_BOX(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkComboBox__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_EXPANDER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkExpander__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FONT_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFontButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_COLOR_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkColorButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ENTRY_COMPLETION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEntryCompletion__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RADIO_TOOL_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRadioToolButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SEPARATOR_TOOL_ITEM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSeparatorToolItem__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOGGLE_TOOL_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToggleToolButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FILE_FILTER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFileFilter__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_LAYOUT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellLayout__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FILE_CHOOSER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFileChooser__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ICON_THEME(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkIconTheme__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOL_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToolButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOL_ITEM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToolItem__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ACCEL_MAP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAccelMap_symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_VIEW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellView__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ABOUT_DIALOG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAboutDialog__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_COMBO(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererCombo__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_PROGRESS(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererProgress__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ICON_VIEW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkIconView__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FILE_CHOOSER_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFileChooserButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_MENU_TOOL_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkMenuToolButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ASSISTANT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkAssistant__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_ACCEL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererAccel__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_SPIN(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererSpin__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LINK_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkLinkButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RECENT_CHOOSER_DIALOG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRecentChooserDialog__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RECENT_CHOOSER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRecentChooser__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RECENT_CHOOSER_MENU(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRecentChooserMenu__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RECENT_CHOOSER_WIDGET(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRecentChooserWidget__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RECENT_FILTER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRecentFilter__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_RECENT_MANAGER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRecentManager__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_PRINT_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPrintContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_PRINT_OPERATION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPrintOperation__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_PRINT_SETTINGS(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPrintSettings__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOLTIP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkTooltip__symbol, Xen_cadr(obj)) : Xen_false);}
#if GTK_CHECK_VERSION(2, 18, 0)
static Xen gxg_GTK_INFO_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkInfoBar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ENTRY_BUFFER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEntryBuffer__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
static Xen gxg_GTK_SPINNER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSpinner__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CELL_RENDERER_SPINNER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCellRendererSpinner__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOL_PALETTE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToolPalette__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOL_ITEM_GROUP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToolItemGroup__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
static Xen gxg_GTK_COMBO_BOX_TEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkComboBoxText__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GRID(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGrid__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SCROLLABLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkScrollable__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_RGBA(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkRGBA__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SWITCH(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSwitch__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ORIENTABLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkOrientable__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_WINDOW_GROUP(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkWindowGroup__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_TOOL_SHELL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkToolShell__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static Xen gxg_GTK_OVERLAY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkOverlay__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FONT_CHOOSER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFontChooser__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FONT_CHOOSER_DIALOG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFontChooserDialog__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FONT_CHOOSER_WIDGET(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFontChooserWidget__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static Xen gxg_GTK_APPLICATION_WINDOW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkApplicationWindow__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_COLOR_CHOOSER_DIALOG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkColorChooserDialog__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_COLOR_CHOOSER_WIDGET(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkColorWidget__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static Xen gxg_GTK_MENU_BUTTON(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkMenuButton__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SEARCH_ENTRY(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkWidget__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LEVEL_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkLevelBar__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static Xen gxg_GTK_PLACES_SIDEBAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPlacesSidebar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_STACK_SWITCHER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkStackSwitcher__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_STACK(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkStack__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_REVEALER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkRevealer__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_HEADER_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkHeaderBar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LIST_BOX(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkListBox__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_LIST_BOX_ROW(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkListBoxRow__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SEARCH_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkSearchBar__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static Xen gxg_GTK_FLOW_BOX(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFlowBox__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_FLOW_BOX_CHILD(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkFlowBoxChild__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_ACTION_BAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkActionBar__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_POPOVER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPopover__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static Xen gxg_GTK_GESTURE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGesture__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_DRAG(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureDrag__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_LONG_PRESS(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureLongPress__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_ZOOM(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureZoom__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_SWIPE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureSwipe__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_SINGLE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureSingle__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_PAN(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGesturePan__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_MULTI_PRESS(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureMultiPress__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_GESTURE_ROTATE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGestureRotate__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_EVENT_CONTROLLER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEventController__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static Xen gxg_GTK_GL_AREA(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkGLArea__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_GL_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkGLContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_POPOVER_MENU(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPopoverMenu__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_STACK_SIDEBAR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkStackSidebar__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static Xen gxg_GDK_SEAT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkSeat__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static Xen gxg_GDK_DEVICE_TOOL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkDeviceTool__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_MONITOR(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkMonitor__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_DRAWING_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkDrawingContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_DEVICE_PAD(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkDevicePad__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_PAD_CONTROLLER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkPadController__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_SHORTCUT_LABEL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkShortcutLabel__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static Xen gxg_GTK_CENTER_BOX(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCenterBox__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_STYLE_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkStyleContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_STYLE_PROVIDER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkStyleProvider__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_CSS_PROVIDER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkCssProvider__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static Xen gxg_GTK_EMOJI_CHOOSER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEmojiChooser__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_EVENT_CONTROLLER_SCROLL(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEventControllerScroll__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_EVENT_CONTROLLER_MOTION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkEventControllerMotion__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_TEXTURE(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkTexture__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_EVENT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkEvent__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_APP_LAUNCH_CONTEXT(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkAppLaunchContext__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_CLIPBOARD(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkClipboard__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_CONTENT_PROVIDER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkContentProvider__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_CONTENT_SERIALIZER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkContentSerializer__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GDK_CONTENT_DESERIALIZER(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GdkContentDeserializer__symbol, Xen_cadr(obj)) : Xen_false);}
static Xen gxg_GTK_APPLICATION(Xen obj) {return((Xen_is_wrapped_object(obj)) ? Xen_list_2(xg_GtkApplication__symbol, Xen_cadr(obj)) : Xen_false);}
#endif

static Xen gxg_GDK_IS_DRAG_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_DRAG_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_DEVICE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_DEVICE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_KEYMAP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_KEYMAP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_WINDOW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_WINDOW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_PIXBUF(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_PIXBUF((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ACCEL_GROUP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ACCEL_GROUP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ACCEL_LABEL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ACCEL_LABEL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ACCESSIBLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ACCESSIBLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ADJUSTMENT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ADJUSTMENT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ASPECT_FRAME(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ASPECT_FRAME((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_BUTTON_BOX(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_BUTTON_BOX((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_BIN(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_BIN((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_BOX(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_BOX((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CALENDAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CALENDAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_EDITABLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_EDITABLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_PIXBUF(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_PIXBUF((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_TEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_TEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_TOGGLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_TOGGLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CHECK_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CHECK_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CHECK_MENU_ITEM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CHECK_MENU_ITEM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CONTAINER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CONTAINER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_DIALOG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_DIALOG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_DRAWING_AREA(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_DRAWING_AREA((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_EDITABLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_EDITABLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ENTRY(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ENTRY((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FIXED(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FIXED((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FRAME(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FRAME((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_IMAGE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_IMAGE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_IM_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_IM_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_IM_CONTEXT_SIMPLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_IM_CONTEXT_SIMPLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_INVISIBLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_INVISIBLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LABEL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LABEL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LAYOUT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LAYOUT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LIST_STORE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LIST_STORE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_MENU_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_MENU_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_MENU(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_MENU((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_MENU_ITEM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_MENU_ITEM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_MENU_SHELL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_MENU_SHELL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_NOTEBOOK(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_NOTEBOOK((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_PANED(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PANED((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_PROGRESS_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PROGRESS_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RADIO_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RADIO_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RADIO_MENU_ITEM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RADIO_MENU_ITEM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RANGE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RANGE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SCALE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SCALE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SCROLLBAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SCROLLBAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SCROLLED_WINDOW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SCROLLED_WINDOW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SEPARATOR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SEPARATOR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SEPARATOR_MENU_ITEM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SEPARATOR_MENU_ITEM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SETTINGS(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SETTINGS((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SIZE_GROUP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SIZE_GROUP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SPIN_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SPIN_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_STATUSBAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_STATUSBAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TEXT_BUFFER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TEXT_BUFFER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TEXT_CHILD_ANCHOR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TEXT_CHILD_ANCHOR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TEXT_MARK(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TEXT_MARK((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TEXT_TAG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TEXT_TAG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TEXT_TAG_TABLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TEXT_TAG_TABLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TEXT_VIEW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TEXT_VIEW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOGGLE_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOGGLE_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOLBAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOLBAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_DRAG_SOURCE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_DRAG_SOURCE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_DRAG_DEST(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_DRAG_DEST((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_MODEL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_MODEL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_MODEL_SORT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_MODEL_SORT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_SELECTION(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_SELECTION((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_SORTABLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_SORTABLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_STORE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_STORE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_VIEW_COLUMN(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_VIEW_COLUMN((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_VIEW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_VIEW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_VIEWPORT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_VIEWPORT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_WIDGET(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_WIDGET((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_WINDOW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_WINDOW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_PANGO_IS_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && PANGO_IS_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_PANGO_IS_FONT_FAMILY(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && PANGO_IS_FONT_FAMILY((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_PANGO_IS_FONT_FACE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && PANGO_IS_FONT_FACE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_PANGO_IS_FONT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && PANGO_IS_FONT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_PANGO_IS_FONT_MAP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && PANGO_IS_FONT_MAP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_PANGO_IS_LAYOUT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && PANGO_IS_LAYOUT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_G_IS_OBJECT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && G_IS_OBJECT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_DISPLAY(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_DISPLAY((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FILE_CHOOSER_DIALOG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FILE_CHOOSER_DIALOG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FILE_CHOOSER_WIDGET(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FILE_CHOOSER_WIDGET((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TREE_MODEL_FILTER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TREE_MODEL_FILTER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_COMBO_BOX(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_COMBO_BOX((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_EXPANDER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_EXPANDER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FONT_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FONT_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_COLOR_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_COLOR_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ENTRY_COMPLETION(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ENTRY_COMPLETION((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RADIO_TOOL_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RADIO_TOOL_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SEPARATOR_TOOL_ITEM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SEPARATOR_TOOL_ITEM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOGGLE_TOOL_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOGGLE_TOOL_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FILE_FILTER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FILE_FILTER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_LAYOUT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_LAYOUT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FILE_CHOOSER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FILE_CHOOSER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ICON_THEME(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ICON_THEME((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOL_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOL_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOL_ITEM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOL_ITEM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ACCEL_MAP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ACCEL_MAP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_VIEW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_VIEW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ABOUT_DIALOG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ABOUT_DIALOG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_COMBO(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_COMBO((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_PROGRESS(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_PROGRESS((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ICON_VIEW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ICON_VIEW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FILE_CHOOSER_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FILE_CHOOSER_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_MENU_TOOL_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_MENU_TOOL_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ASSISTANT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ASSISTANT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_ACCEL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_ACCEL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_SPIN(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_SPIN((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LINK_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LINK_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RECENT_CHOOSER_DIALOG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RECENT_CHOOSER_DIALOG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RECENT_CHOOSER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RECENT_CHOOSER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RECENT_CHOOSER_MENU(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RECENT_CHOOSER_MENU((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RECENT_CHOOSER_WIDGET(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RECENT_CHOOSER_WIDGET((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RECENT_FILTER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RECENT_FILTER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_RECENT_MANAGER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_RECENT_MANAGER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_PRINT_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PRINT_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_PRINT_OPERATION(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PRINT_OPERATION((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_PRINT_SETTINGS(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PRINT_SETTINGS((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOLTIP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOLTIP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#if GTK_CHECK_VERSION(2, 18, 0)
static Xen gxg_GTK_IS_INFO_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_INFO_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ENTRY_BUFFER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ENTRY_BUFFER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
static Xen gxg_GTK_IS_SPINNER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SPINNER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CELL_RENDERER_SPINNER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CELL_RENDERER_SPINNER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOL_PALETTE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOL_PALETTE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOL_ITEM_GROUP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOL_ITEM_GROUP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
static Xen gxg_GTK_IS_COMBO_BOX_TEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_COMBO_BOX_TEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GRID(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GRID((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SCROLLABLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SCROLLABLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SWITCH(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SWITCH((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ORIENTABLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ORIENTABLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_WINDOW_GROUP(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_WINDOW_GROUP((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_TOOL_SHELL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_TOOL_SHELL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static Xen gxg_GTK_IS_OVERLAY(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_OVERLAY((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FONT_CHOOSER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FONT_CHOOSER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FONT_CHOOSER_DIALOG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FONT_CHOOSER_DIALOG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FONT_CHOOSER_WIDGET(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FONT_CHOOSER_WIDGET((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static Xen gxg_GTK_IS_APPLICATION_WINDOW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_APPLICATION_WINDOW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_COLOR_CHOOSER_DIALOG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_COLOR_CHOOSER_DIALOG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_COLOR_CHOOSER_WIDGET(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_COLOR_CHOOSER_WIDGET((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static Xen gxg_GTK_IS_MENU_BUTTON(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_MENU_BUTTON((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SEARCH_ENTRY(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SEARCH_ENTRY((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LEVEL_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LEVEL_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static Xen gxg_GTK_IS_PLACES_SIDEBAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PLACES_SIDEBAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_STACK_SWITCHER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_STACK_SWITCHER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_STACK(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_STACK((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_REVEALER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_REVEALER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_HEADER_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_HEADER_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LIST_BOX(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LIST_BOX((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_LIST_BOX_ROW(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_LIST_BOX_ROW((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SEARCH_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SEARCH_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static Xen gxg_GTK_IS_FLOW_BOX(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FLOW_BOX((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_FLOW_BOX_CHILD(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_FLOW_BOX_CHILD((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_ACTION_BAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_ACTION_BAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_POPOVER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_POPOVER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static Xen gxg_GTK_IS_GESTURE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_DRAG(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_DRAG((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_LONG_PRESS(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_LONG_PRESS((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_ZOOM(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_ZOOM((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_SWIPE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_SWIPE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_SINGLE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_SINGLE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_PAN(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_PAN((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_MULTI_PRESS(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_MULTI_PRESS((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_GESTURE_ROTATE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GESTURE_ROTATE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_EVENT_CONTROLLER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_EVENT_CONTROLLER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static Xen gxg_GTK_IS_GL_AREA(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_GL_AREA((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_GL_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_GL_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_POPOVER_MENU(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_POPOVER_MENU((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_STACK_SIDEBAR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_STACK_SIDEBAR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static Xen gxg_GDK_IS_SEAT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_SEAT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static Xen gxg_GDK_IS_DEVICE_TOOL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_DEVICE_TOOL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_MONITOR(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_MONITOR((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_DRAWING_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_DRAWING_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_DEVICE_PAD(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_DEVICE_PAD((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_PAD_CONTROLLER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_PAD_CONTROLLER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_SHORTCUT_LABEL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_SHORTCUT_LABEL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static Xen gxg_GTK_IS_CENTER_BOX(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CENTER_BOX((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_STYLE_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_STYLE_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_STYLE_PROVIDER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_STYLE_PROVIDER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_CSS_PROVIDER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_CSS_PROVIDER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static Xen gxg_GTK_IS_EMOJI_CHOOSER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_EMOJI_CHOOSER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_EVENT_CONTROLLER_SCROLL(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_EVENT_CONTROLLER_SCROLL((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_EVENT_CONTROLLER_MOTION(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_EVENT_CONTROLLER_MOTION((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_TEXTURE(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_TEXTURE((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_EVENT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_EVENT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_APP_LAUNCH_CONTEXT(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_APP_LAUNCH_CONTEXT((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_CLIPBOARD(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_CLIPBOARD((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_CONTENT_PROVIDER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_CONTENT_PROVIDER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_CONTENT_SERIALIZER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_CONTENT_SERIALIZER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GDK_IS_CONTENT_DESERIALIZER(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GDK_IS_CONTENT_DESERIALIZER((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
static Xen gxg_GTK_IS_APPLICATION(Xen obj) {return(C_bool_to_Xen_boolean(Xen_is_wrapped_object(obj) && GTK_IS_APPLICATION((GTypeInstance *)Xen_unwrap_C_pointer(Xen_cadr(obj)))));}
#endif



/* ---------------------------------------- special functions ---------------------------------------- */

#if (!GTK_CHECK_VERSION(3, 90, 0))
static Xen gxg_gtk_init(Xen argc, Xen argv) 
{ 
  #define H_gtk_init "void gtk_init(int* argc, char*** argv)" 
  int ref_argc = 0; 
  char** ref_argv = NULL; 
  if (Xen_is_bound(argv)) 
    { 
      if (Xen_is_bound(argc) && Xen_is_integer(argc) && Xen_to_C_int(argc) <= Xen_list_length(argv)) 
         ref_argc = Xen_to_C_int(argc); 
      else ref_argc = Xen_list_length(argv); 
    } 
  ref_argv = (char**)calloc(ref_argc, sizeof(char*)); 
  { 
    int i; 
    Xen lst; 
    lst = Xen_copy_arg(argv); 
    for (i = 0; i < ref_argc; i++, lst = Xen_cdr(lst)) ref_argv[i] = Xen_to_C_char_(Xen_car(lst));
  }
  gtk_init(&ref_argc, &ref_argv);
  return(Xen_list_2(C_to_Xen_int(ref_argc), C_to_Xen_char__(ref_argv)));
} 

static Xen gxg_gtk_init_check(Xen argc, Xen argv) 
{ 
  #define H_gtk_init_check "gboolean gtk_init_check(int* argc, char*** argv)" 
  int ref_argc = 0; 
  char** ref_argv = NULL; 
  if (Xen_is_bound(argc) && Xen_is_list(argc)) 
    { 
      argv = argc; 
      ref_argc = Xen_list_length(argv); 
    } 
  else 
    {
      if (Xen_is_bound(argv)) 
	{ 
	  int len; 
	  Xen_check_type(Xen_is_integer(argc), argc, 1, "gtk_init_check", "int argc"); 
	  Xen_check_type(Xen_is_list(argv), argv, 2, "gtk_init_check", "char *argv[]"); 
	  len = Xen_list_length(argv); 
	  ref_argc = Xen_to_C_int(argc); 
	  if (ref_argc > len) ref_argc = len; 
	}
    }
  ref_argv = (char**)calloc(ref_argc, sizeof(char*)); 
  { 
    int i; 
    Xen lst; 
    lst = Xen_copy_arg(argv); 
    for (i = 0; i < ref_argc; i++, lst = Xen_cdr(lst)) ref_argv[i] = Xen_to_C_char_(Xen_car(lst));
  }
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_init_check(&ref_argc, &ref_argv));
    return(Xen_list_3(result, C_to_Xen_int(ref_argc), C_to_Xen_char__(ref_argv)));
  }
}
#else
static Xen gxg_gtk_init(void) 
{ 
  gtk_init();
  return(Xen_false);
}
#endif

/* conversions */
static Xen c_array_to_xen_list(Xen val_1, Xen clen)
{
  Xen result = Xen_empty_list;
  Xen val, ctype;
  int i, len = -1;
  if (Xen_is_integer(clen))
    len = Xen_integer_to_C_int(clen);
  if (!(Xen_is_list(val_1))) return(Xen_false); /* type:location cons */
  val = Xen_copy_arg(val_1); /* protect Ruby arg */
  ctype = Xen_car(val);
  if (ctype == xg_gdouble__symbol)
    {
      gdouble* arr; arr = (gdouble*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_gdouble(arr[i]), result);
    }
  if (ctype == xg_gunichar__symbol)
    {
      gunichar* arr; arr = (gunichar*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_gunichar(arr[i]), result);
    }
  if (ctype == xg_GType__symbol)
    {
      GType* arr; arr = (GType*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_GType(arr[i]), result);
    }
  if (ctype == xg_guint__symbol)
    {
      guint* arr; arr = (guint*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_guint(arr[i]), result);
    }
  if (ctype == xg_guchar__symbol)
    {
      guchar* arr; arr = (guchar*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_guchar(arr[i]), result);
    }
  if (ctype == xg_char___symbol)
    {
      char** arr; arr = (char**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_char_(arr[i]), result);
    }
  if (ctype == xg_guint16__symbol)
    {
      guint16* arr; arr = (guint16*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_guint16(arr[i]), result);
    }
  if (ctype == xg_gint__symbol)
    {
      gint* arr; arr = (gint*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_gint(arr[i]), result);
    }
  if (ctype == xg_int__symbol)
    {
      int* arr; arr = (int*)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_int(arr[i]), result);
    }
  if (ctype == xg_gchar___symbol)
    {
      gchar** arr; arr = (gchar**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_gchar_(arr[i]), result);
    }
  if (ctype == xg_PangoFontFace___symbol)
    {
      PangoFontFace** arr; arr = (PangoFontFace**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_PangoFontFace_(arr[i]), result);
    }
  if (ctype == xg_PangoFontDescription___symbol)
    {
      PangoFontDescription** arr; arr = (PangoFontDescription**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_PangoFontDescription_(arr[i]), result);
    }
  if (ctype == xg_PangoFontFamily___symbol)
    {
      PangoFontFamily** arr; arr = (PangoFontFamily**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_PangoFontFamily_(arr[i]), result);
    }
  if (ctype == xg_PangoAttrList___symbol)
    {
      PangoAttrList** arr; arr = (PangoAttrList**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_PangoAttrList_(arr[i]), result);
    }
  if (ctype == xg_GtkTreeModel___symbol)
    {
      GtkTreeModel** arr; arr = (GtkTreeModel**)Xen_unwrap_C_pointer(Xen_cadr(val)); 
      if (len == -1) {for (i = 0; arr[i]; i++) {}; len = i;}
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_to_Xen_GtkTreeModel_(arr[i]), result);
    }
  if (ctype == xg_GList__symbol)
    { /* tagging these pointers is currently up to the caller */
      GList* lst;
      lst = (GList*)Xen_unwrap_C_pointer(Xen_cadr(val));
      len = g_list_length(lst);
      for (i = len - 1; i >= 0; i--) result = Xen_cons(C_ulong_to_Xen_ulong(g_list_nth_data(lst, i)), result);
    }
  return(result);
}

static Xen xg_object_get(Xen val, Xen name, Xen string_type)
{
  gint temp; gchar *str;
  Xen_check_type(Xen_is_gpointer(val), val, 1, "g_object_get", "gpointer");
  Xen_check_type(Xen_is_string(name), name, 2, "g_object_get", "string");
  if (Xen_is_false(string_type))
    {g_object_get(Xen_to_C_gpointer(val), (const gchar *)(Xen_string_to_C_string(name)), &temp, NULL); return(C_int_to_Xen_integer(temp));}
  else {g_object_get(Xen_to_C_gpointer(val), (const gchar *)(Xen_string_to_C_string(name)), &str, NULL); return(C_string_to_Xen_string(str));}
}

static Xen xg_object_set(Xen val, Xen name, Xen new_val)
{
  Xen_check_type(Xen_is_gpointer(val), val, 1, "g_object_set", "gpointer");
  Xen_check_type(Xen_is_string(name), name, 2, "g_object_set", "string");
  if (Xen_is_boolean(new_val))
    g_object_set(Xen_to_C_gpointer(val), (const gchar *)(Xen_string_to_C_string(name)), Xen_boolean_to_C_bool(new_val), NULL);
  else
    {
      if (Xen_is_number(new_val))
        g_object_set(Xen_to_C_gpointer(val), (const gchar *)(Xen_string_to_C_string(name)), Xen_integer_to_C_int(new_val), NULL);
      else g_object_set(Xen_to_C_gpointer(val), (const gchar *)(Xen_string_to_C_string(name)), Xen_string_to_C_string(new_val), NULL);
    }
  return(new_val);
}

static Xen xg_gtk_event_keyval(Xen event)
{
#if (GTK_CHECK_VERSION(3, 92, 1))
  GdkEvent *e;
  e = Xen_to_C_GdkEvent_(event);
  if (e) {guint val = 0; gdk_event_get_keyval(e, &val); return(C_int_to_Xen_integer((int)val));} return(XEN_ZERO);
#else
  GdkEventKey *e;
  e = Xen_to_C_GdkEventKey_(event);
  if (e) return(C_int_to_Xen_integer((int)(e->keyval)));
 return(XEN_ZERO);
#endif
}

static Xen xen_list_to_c_array(Xen val, Xen type)
{
  int i, len;
  len = Xen_list_length(val);
  if (type == xg_gdouble__symbol)
    {
      gdouble* arr; arr = (gdouble*)calloc(len + 1, sizeof(gdouble));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_gdouble(Xen_car(val));
      return(Xen_list_3(xg_gdouble__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_gunichar__symbol)
    {
      gunichar* arr; arr = (gunichar*)calloc(len + 1, sizeof(gunichar));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_gunichar(Xen_car(val));
      return(Xen_list_3(xg_gunichar__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_GType__symbol)
    {
      GType* arr; arr = (GType*)calloc(len + 1, sizeof(GType));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_GType(Xen_car(val));
      return(Xen_list_3(xg_GType__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_guint__symbol)
    {
      guint* arr; arr = (guint*)calloc(len + 1, sizeof(guint));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_guint(Xen_car(val));
      return(Xen_list_3(xg_guint__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_guchar__symbol)
    {
      guchar* arr; arr = (guchar*)calloc(len + 1, sizeof(guchar));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_guchar(Xen_car(val));
      return(Xen_list_3(xg_guchar__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_char___symbol)
    {
      char** arr; arr = (char**)calloc(len + 1, sizeof(char*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_char_(Xen_car(val));
      return(Xen_list_3(xg_char___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_guint16__symbol)
    {
      guint16* arr; arr = (guint16*)calloc(len + 1, sizeof(guint16));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_guint16(Xen_car(val));
      return(Xen_list_3(xg_guint16__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_gint__symbol)
    {
      gint* arr; arr = (gint*)calloc(len + 1, sizeof(gint));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_gint(Xen_car(val));
      return(Xen_list_3(xg_gint__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_int__symbol)
    {
      int* arr; arr = (int*)calloc(len + 1, sizeof(int));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_int(Xen_car(val));
      return(Xen_list_3(xg_int__symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_gchar___symbol)
    {
      gchar** arr; arr = (gchar**)calloc(len + 1, sizeof(gchar*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_gchar_(Xen_car(val));
      return(Xen_list_3(xg_gchar___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_PangoFontFace___symbol)
    {
      PangoFontFace** arr; arr = (PangoFontFace**)calloc(len + 1, sizeof(PangoFontFace*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_PangoFontFace_(Xen_car(val));
      return(Xen_list_3(xg_PangoFontFace___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_PangoFontDescription___symbol)
    {
      PangoFontDescription** arr; arr = (PangoFontDescription**)calloc(len + 1, sizeof(PangoFontDescription*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_PangoFontDescription_(Xen_car(val));
      return(Xen_list_3(xg_PangoFontDescription___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_PangoFontFamily___symbol)
    {
      PangoFontFamily** arr; arr = (PangoFontFamily**)calloc(len + 1, sizeof(PangoFontFamily*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_PangoFontFamily_(Xen_car(val));
      return(Xen_list_3(xg_PangoFontFamily___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_PangoAttrList___symbol)
    {
      PangoAttrList** arr; arr = (PangoAttrList**)calloc(len + 1, sizeof(PangoAttrList*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_PangoAttrList_(Xen_car(val));
      return(Xen_list_3(xg_PangoAttrList___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  if (type == xg_GtkTreeModel___symbol)
    {
      GtkTreeModel** arr; arr = (GtkTreeModel**)calloc(len + 1, sizeof(GtkTreeModel*));
      for (i = 0; i < len; i++, val = Xen_cdr(val)) arr[i] = Xen_to_C_GtkTreeModel_(Xen_car(val));
      return(Xen_list_3(xg_GtkTreeModel___symbol, Xen_wrap_C_pointer(arr), make_xm_obj(arr)));
    }
  return(Xen_false);
}
static Xen gxg_make_GtkTextIter(void)
{
  GtkTextIter* result;
  result = (GtkTextIter*)calloc(1, sizeof(GtkTextIter));
  return(Xen_list_3(C_string_to_Xen_symbol("GtkTextIter_"), Xen_wrap_C_pointer(result), make_xm_obj(result)));
}

static Xen gxg_make_GtkTreeIter(void)
{
  GtkTreeIter* result;
  result = (GtkTreeIter*)calloc(1, sizeof(GtkTreeIter));
  return(Xen_list_3(C_string_to_Xen_symbol("GtkTreeIter_"), Xen_wrap_C_pointer(result), make_xm_obj(result)));
}

static Xen gxg_make_PangoRectangle(void)
{
  PangoRectangle* result;
  result = (PangoRectangle*)calloc(1, sizeof(PangoRectangle));
  return(Xen_list_3(C_string_to_Xen_symbol("PangoRectangle_"), Xen_wrap_C_pointer(result), make_xm_obj(result)));
}

static Xen gxg_make_cairo_matrix_t(void)
{
  cairo_matrix_t* result;
  result = (cairo_matrix_t*)calloc(1, sizeof(cairo_matrix_t));
  return(Xen_list_3(C_string_to_Xen_symbol("cairo_matrix_t_"), Xen_wrap_C_pointer(result), make_xm_obj(result)));
}

#if GTK_CHECK_VERSION(3, 0, 0)
static Xen gxg_make_GdkRGBA(void)
{
  GdkRGBA* result;
  result = (GdkRGBA*)calloc(1, sizeof(GdkRGBA));
  return(Xen_list_3(C_string_to_Xen_symbol("GdkRGBA_"), Xen_wrap_C_pointer(result), make_xm_obj(result)));
}
#endif

static Xen gxg_gtk_text_view_get_iter_at_position(Xen text_view, Xen iter, Xen ignore_trailing, Xen x, Xen y)
{
  #define H_gtk_text_view_get_iter_at_position "gboolean gtk_text_view_get_iter_at_position(GtkTextView* text_view, GtkTextIter* iter, gint* [trailing], gint x, gint y)"
  gint ref_trailing;
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_iter_at_position", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_get_iter_at_position", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(x), x, 4, "gtk_text_view_get_iter_at_position", "gint");
  Xen_check_type(Xen_is_gint(y), y, 5, "gtk_text_view_get_iter_at_position", "gint");
#if GTK_CHECK_VERSION(3, 20, 0)
  {
    Xen result;
    result = C_to_Xen_gboolean(gtk_text_view_get_iter_at_position(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), 
                                                                  &ref_trailing, Xen_to_C_gint(x), Xen_to_C_gint(y)));
    return(Xen_list_2(result, C_to_Xen_gint(ref_trailing)));
   }
#else
  gtk_text_view_get_iter_at_position(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), &ref_trailing, Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_list_1(C_to_Xen_gint(ref_trailing)));
#endif
}

static Xen gxg_gtk_text_view_get_iter_at_location(Xen text_view, Xen iter, Xen x, Xen y)
{
  #define H_gtk_text_view_get_iter_at_location "gboolean gtk_text_view_get_iter_at_location(GtkTextView* text_view, GtkTextIter* iter, gint x, gint y)"
  Xen_check_type(Xen_is_GtkTextView_(text_view), text_view, 1, "gtk_text_view_get_iter_at_location", "GtkTextView*");
  Xen_check_type(Xen_is_GtkTextIter_(iter), iter, 2, "gtk_text_view_get_iter_at_location", "GtkTextIter*");
  Xen_check_type(Xen_is_gint(x), x, 3, "gtk_text_view_get_iter_at_location", "gint");
  Xen_check_type(Xen_is_gint(y), y, 4, "gtk_text_view_get_iter_at_location", "gint");
#if GTK_CHECK_VERSION(3, 20, 0)
  return(C_to_Xen_gboolean(gtk_text_view_get_iter_at_location(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(x), Xen_to_C_gint(y))));
#else
  gtk_text_view_get_iter_at_location(Xen_to_C_GtkTextView_(text_view), Xen_to_C_GtkTextIter_(iter), Xen_to_C_gint(x), Xen_to_C_gint(y));
  return(Xen_false);
#endif
}

#if HAVE_SCHEME
  #define Xg_define_procedure(Name, Value, A1, A2, A3, Help, Sig) s7_define_typed_function(s7, Xg_pre #Name Xg_post, Value, A1, A2, A3, Help, Sig)
#else
  #define Xg_define_procedure(Name, Value, A1, A2, A3, Help, Sig) Xen_define_safe_procedure(Xg_pre #Name Xg_post, Value, A1, A2, A3, Help)
#endif

Xen_wrap_no_args(gxg_make_GtkTextIter_w, gxg_make_GtkTextIter)
Xen_wrap_no_args(gxg_make_GtkTreeIter_w, gxg_make_GtkTreeIter)
Xen_wrap_no_args(gxg_make_PangoRectangle_w, gxg_make_PangoRectangle)
Xen_wrap_no_args(gxg_make_cairo_matrix_t_w, gxg_make_cairo_matrix_t)
Xen_wrap_4_args(gxg_gtk_text_view_get_iter_at_location_w, gxg_gtk_text_view_get_iter_at_location)
Xen_wrap_5_optional_args(gxg_gtk_text_view_get_iter_at_position_w, gxg_gtk_text_view_get_iter_at_position)
#if GTK_CHECK_VERSION(3, 0, 0)
Xen_wrap_no_args(gxg_make_GdkRGBA_w, gxg_make_GdkRGBA)
#endif


static void define_structs(void)
{
  Xg_define_procedure(GtkTextIter, gxg_make_GtkTextIter_w, 0, 0, 0, "(GtkTextIter): a new GtkTextIter struct", NULL);
  Xg_define_procedure(GtkTreeIter, gxg_make_GtkTreeIter_w, 0, 0, 0, "(GtkTreeIter): a new GtkTreeIter struct", NULL);
  Xg_define_procedure(PangoRectangle, gxg_make_PangoRectangle_w, 0, 0, 0, "(PangoRectangle): a new PangoRectangle struct", NULL);
  Xg_define_procedure(cairo_matrix_t, gxg_make_cairo_matrix_t_w, 0, 0, 0, "(cairo_matrix_t): a new cairo_matrix_t struct", NULL);
  Xg_define_procedure(gtk_text_view_get_iter_at_location, gxg_gtk_text_view_get_iter_at_location_w, 4, 0, 0, H_gtk_text_view_get_iter_at_location, NULL);
  Xg_define_procedure(gtk_text_view_get_iter_at_position, gxg_gtk_text_view_get_iter_at_position_w, 4, 1, 0, H_gtk_text_view_get_iter_at_position, NULL);
#if GTK_CHECK_VERSION(3, 0, 0)
  Xg_define_procedure(GdkRGBA, gxg_make_GdkRGBA_w, 0, 0, 0, "(GdkRGBA): a new GdkRGBA struct", NULL);
#endif
}

Xen_wrap_1_arg(gxg_g_unichar_validate_w, gxg_g_unichar_validate)
Xen_wrap_1_arg(gxg_g_unichar_isalnum_w, gxg_g_unichar_isalnum)
Xen_wrap_1_arg(gxg_g_unichar_isalpha_w, gxg_g_unichar_isalpha)
Xen_wrap_1_arg(gxg_g_unichar_iscntrl_w, gxg_g_unichar_iscntrl)
Xen_wrap_1_arg(gxg_g_unichar_isdefined_w, gxg_g_unichar_isdefined)
Xen_wrap_1_arg(gxg_g_unichar_isdigit_w, gxg_g_unichar_isdigit)
Xen_wrap_1_arg(gxg_g_unichar_isgraph_w, gxg_g_unichar_isgraph)
Xen_wrap_1_arg(gxg_g_unichar_islower_w, gxg_g_unichar_islower)
Xen_wrap_1_arg(gxg_g_unichar_ismark_w, gxg_g_unichar_ismark)
Xen_wrap_1_arg(gxg_g_unichar_isprint_w, gxg_g_unichar_isprint)
Xen_wrap_1_arg(gxg_g_unichar_ispunct_w, gxg_g_unichar_ispunct)
Xen_wrap_1_arg(gxg_g_unichar_isspace_w, gxg_g_unichar_isspace)
Xen_wrap_1_arg(gxg_g_unichar_istitle_w, gxg_g_unichar_istitle)
Xen_wrap_1_arg(gxg_g_unichar_isupper_w, gxg_g_unichar_isupper)
Xen_wrap_1_arg(gxg_g_unichar_isxdigit_w, gxg_g_unichar_isxdigit)
Xen_wrap_1_arg(gxg_g_unichar_iswide_w, gxg_g_unichar_iswide)
Xen_wrap_1_arg(gxg_g_unichar_iswide_cjk_w, gxg_g_unichar_iswide_cjk)
Xen_wrap_1_arg(gxg_g_unichar_iszerowidth_w, gxg_g_unichar_iszerowidth)
Xen_wrap_1_arg(gxg_g_unichar_toupper_w, gxg_g_unichar_toupper)
Xen_wrap_1_arg(gxg_g_unichar_tolower_w, gxg_g_unichar_tolower)
Xen_wrap_1_arg(gxg_g_unichar_totitle_w, gxg_g_unichar_totitle)
Xen_wrap_1_arg(gxg_g_unichar_digit_value_w, gxg_g_unichar_digit_value)
Xen_wrap_1_arg(gxg_g_unichar_xdigit_value_w, gxg_g_unichar_xdigit_value)
Xen_wrap_1_arg(gxg_g_unichar_combining_class_w, gxg_g_unichar_combining_class)
Xen_wrap_2_args(gxg_g_unicode_canonical_ordering_w, gxg_g_unicode_canonical_ordering)
Xen_wrap_1_arg(gxg_g_utf8_get_char_w, gxg_g_utf8_get_char)
Xen_wrap_2_args(gxg_g_utf8_get_char_validated_w, gxg_g_utf8_get_char_validated)
Xen_wrap_1_arg(gxg_g_utf8_prev_char_w, gxg_g_utf8_prev_char)
Xen_wrap_2_args(gxg_g_utf8_find_next_char_w, gxg_g_utf8_find_next_char)
Xen_wrap_2_args(gxg_g_utf8_find_prev_char_w, gxg_g_utf8_find_prev_char)
Xen_wrap_2_args(gxg_g_utf8_strlen_w, gxg_g_utf8_strlen)
Xen_wrap_3_args(gxg_g_utf8_strchr_w, gxg_g_utf8_strchr)
Xen_wrap_3_args(gxg_g_utf8_strrchr_w, gxg_g_utf8_strrchr)
Xen_wrap_2_args(gxg_g_utf8_strreverse_w, gxg_g_utf8_strreverse)
Xen_wrap_3_optional_args(gxg_g_utf8_validate_w, gxg_g_utf8_validate)
Xen_wrap_2_args(gxg_g_utf8_strup_w, gxg_g_utf8_strup)
Xen_wrap_2_args(gxg_g_utf8_strdown_w, gxg_g_utf8_strdown)
Xen_wrap_2_args(gxg_g_utf8_casefold_w, gxg_g_utf8_casefold)
Xen_wrap_3_args(gxg_g_utf8_normalize_w, gxg_g_utf8_normalize)
Xen_wrap_2_args(gxg_g_utf8_collate_w, gxg_g_utf8_collate)
Xen_wrap_2_args(gxg_g_utf8_collate_key_w, gxg_g_utf8_collate_key)
Xen_wrap_2_args(gxg_g_utf8_collate_key_for_filename_w, gxg_g_utf8_collate_key_for_filename)
Xen_wrap_3_args(gxg_g_cclosure_new_w, gxg_g_cclosure_new)
Xen_wrap_any_args(gxg_g_signal_newv_w, gxg_g_signal_newv)
Xen_wrap_2_args(gxg_g_signal_lookup_w, gxg_g_signal_lookup)
Xen_wrap_1_arg(gxg_g_signal_name_w, gxg_g_signal_name)
Xen_wrap_2_args(gxg_g_signal_query_w, gxg_g_signal_query)
Xen_wrap_2_args(gxg_g_signal_list_ids_w, gxg_g_signal_list_ids)
Xen_wrap_5_optional_args(gxg_g_signal_parse_name_w, gxg_g_signal_parse_name)
Xen_wrap_1_arg(gxg_g_signal_get_invocation_hint_w, gxg_g_signal_get_invocation_hint)
Xen_wrap_3_args(gxg_g_signal_stop_emission_w, gxg_g_signal_stop_emission)
Xen_wrap_2_args(gxg_g_signal_stop_emission_by_name_w, gxg_g_signal_stop_emission_by_name)
Xen_wrap_5_args(gxg_g_signal_add_emission_hook_w, gxg_g_signal_add_emission_hook)
Xen_wrap_2_args(gxg_g_signal_remove_emission_hook_w, gxg_g_signal_remove_emission_hook)
Xen_wrap_4_args(gxg_g_signal_has_handler_pending_w, gxg_g_signal_has_handler_pending)
Xen_wrap_5_args(gxg_g_signal_connect_closure_by_id_w, gxg_g_signal_connect_closure_by_id)
Xen_wrap_4_args(gxg_g_signal_connect_closure_w, gxg_g_signal_connect_closure)
Xen_wrap_6_args(gxg_g_signal_connect_data_w, gxg_g_signal_connect_data)
Xen_wrap_2_args(gxg_g_signal_handler_block_w, gxg_g_signal_handler_block)
Xen_wrap_2_args(gxg_g_signal_handler_unblock_w, gxg_g_signal_handler_unblock)
Xen_wrap_2_args(gxg_g_signal_handler_disconnect_w, gxg_g_signal_handler_disconnect)
Xen_wrap_2_args(gxg_g_signal_handler_is_connected_w, gxg_g_signal_handler_is_connected)
Xen_wrap_7_args(gxg_g_signal_handler_find_w, gxg_g_signal_handler_find)
Xen_wrap_7_args(gxg_g_signal_handlers_block_matched_w, gxg_g_signal_handlers_block_matched)
Xen_wrap_7_args(gxg_g_signal_handlers_unblock_matched_w, gxg_g_signal_handlers_unblock_matched)
Xen_wrap_7_args(gxg_g_signal_handlers_disconnect_matched_w, gxg_g_signal_handlers_disconnect_matched)
Xen_wrap_1_arg(gxg_g_signal_handlers_destroy_w, gxg_g_signal_handlers_destroy)
Xen_wrap_1_arg(gxg_g_object_ref_w, gxg_g_object_ref)
Xen_wrap_1_arg(gxg_g_object_unref_w, gxg_g_object_unref)
Xen_wrap_3_args(gxg_gdk_drag_status_w, gxg_gdk_drag_status)
Xen_wrap_3_args(gxg_gdk_drop_reply_w, gxg_gdk_drop_reply)
Xen_wrap_3_args(gxg_gdk_drop_finish_w, gxg_gdk_drop_finish)
Xen_wrap_1_arg(gxg_gdk_event_copy_w, gxg_gdk_event_copy)
Xen_wrap_1_arg(gxg_gdk_event_free_w, gxg_gdk_event_free)
Xen_wrap_1_arg(gxg_gdk_event_get_time_w, gxg_gdk_event_get_time)
Xen_wrap_2_optional_args(gxg_gdk_event_get_state_w, gxg_gdk_event_get_state)
Xen_wrap_3_optional_args(gxg_gdk_event_get_coords_w, gxg_gdk_event_get_coords)
Xen_wrap_3_optional_args(gxg_gdk_event_get_root_coords_w, gxg_gdk_event_get_root_coords)
Xen_wrap_3_args(gxg_gdk_event_handler_set_w, gxg_gdk_event_handler_set)
Xen_wrap_1_arg(gxg_gdk_set_show_events_w, gxg_gdk_set_show_events)
Xen_wrap_no_args(gxg_gdk_get_show_events_w, gxg_gdk_get_show_events)
Xen_wrap_3_args(gxg_gdk_rectangle_intersect_w, gxg_gdk_rectangle_intersect)
Xen_wrap_3_args(gxg_gdk_rectangle_union_w, gxg_gdk_rectangle_union)
Xen_wrap_2_args(gxg_gdk_keymap_lookup_key_w, gxg_gdk_keymap_lookup_key)
Xen_wrap_4_optional_args(gxg_gdk_keymap_get_entries_for_keyval_w, gxg_gdk_keymap_get_entries_for_keyval)
Xen_wrap_5_optional_args(gxg_gdk_keymap_get_entries_for_keycode_w, gxg_gdk_keymap_get_entries_for_keycode)
Xen_wrap_1_arg(gxg_gdk_keymap_get_direction_w, gxg_gdk_keymap_get_direction)
Xen_wrap_1_arg(gxg_gdk_keyval_name_w, gxg_gdk_keyval_name)
Xen_wrap_1_arg(gxg_gdk_keyval_from_name_w, gxg_gdk_keyval_from_name)
Xen_wrap_3_optional_args(gxg_gdk_keyval_convert_case_w, gxg_gdk_keyval_convert_case)
Xen_wrap_1_arg(gxg_gdk_keyval_to_upper_w, gxg_gdk_keyval_to_upper)
Xen_wrap_1_arg(gxg_gdk_keyval_to_lower_w, gxg_gdk_keyval_to_lower)
Xen_wrap_1_arg(gxg_gdk_keyval_is_upper_w, gxg_gdk_keyval_is_upper)
Xen_wrap_1_arg(gxg_gdk_keyval_is_lower_w, gxg_gdk_keyval_is_lower)
Xen_wrap_1_arg(gxg_gdk_keyval_to_unicode_w, gxg_gdk_keyval_to_unicode)
Xen_wrap_1_arg(gxg_gdk_unicode_to_keyval_w, gxg_gdk_unicode_to_keyval)
Xen_wrap_1_arg(gxg_gdk_utf8_to_string_target_w, gxg_gdk_utf8_to_string_target)
Xen_wrap_1_arg(gxg_gdk_window_destroy_w, gxg_gdk_window_destroy)
Xen_wrap_1_arg(gxg_gdk_window_get_window_type_w, gxg_gdk_window_get_window_type)
Xen_wrap_1_arg(gxg_gdk_window_show_w, gxg_gdk_window_show)
Xen_wrap_1_arg(gxg_gdk_window_hide_w, gxg_gdk_window_hide)
Xen_wrap_1_arg(gxg_gdk_window_withdraw_w, gxg_gdk_window_withdraw)
Xen_wrap_1_arg(gxg_gdk_window_show_unraised_w, gxg_gdk_window_show_unraised)
Xen_wrap_3_args(gxg_gdk_window_move_w, gxg_gdk_window_move)
Xen_wrap_3_args(gxg_gdk_window_resize_w, gxg_gdk_window_resize)
Xen_wrap_5_args(gxg_gdk_window_move_resize_w, gxg_gdk_window_move_resize)
Xen_wrap_1_arg(gxg_gdk_window_raise_w, gxg_gdk_window_raise)
Xen_wrap_1_arg(gxg_gdk_window_lower_w, gxg_gdk_window_lower)
Xen_wrap_2_args(gxg_gdk_window_focus_w, gxg_gdk_window_focus)
Xen_wrap_2_args(gxg_gdk_window_set_user_data_w, gxg_gdk_window_set_user_data)
Xen_wrap_3_args(gxg_gdk_window_add_filter_w, gxg_gdk_window_add_filter)
Xen_wrap_3_args(gxg_gdk_window_remove_filter_w, gxg_gdk_window_remove_filter)
Xen_wrap_3_args(gxg_gdk_window_scroll_w, gxg_gdk_window_scroll)
Xen_wrap_1_arg(gxg_gdk_window_set_child_shapes_w, gxg_gdk_window_set_child_shapes)
Xen_wrap_1_arg(gxg_gdk_window_merge_child_shapes_w, gxg_gdk_window_merge_child_shapes)
Xen_wrap_1_arg(gxg_gdk_window_is_visible_w, gxg_gdk_window_is_visible)
Xen_wrap_1_arg(gxg_gdk_window_is_viewable_w, gxg_gdk_window_is_viewable)
Xen_wrap_1_arg(gxg_gdk_window_get_state_w, gxg_gdk_window_get_state)
Xen_wrap_3_optional_args(gxg_gdk_window_get_root_origin_w, gxg_gdk_window_get_root_origin)
Xen_wrap_2_args(gxg_gdk_window_get_frame_extents_w, gxg_gdk_window_get_frame_extents)
Xen_wrap_1_arg(gxg_gdk_window_get_parent_w, gxg_gdk_window_get_parent)
Xen_wrap_1_arg(gxg_gdk_window_get_toplevel_w, gxg_gdk_window_get_toplevel)
Xen_wrap_1_arg(gxg_gdk_window_get_children_w, gxg_gdk_window_get_children)
Xen_wrap_1_arg(gxg_gdk_window_peek_children_w, gxg_gdk_window_peek_children)
Xen_wrap_1_arg(gxg_gdk_window_get_events_w, gxg_gdk_window_get_events)
Xen_wrap_2_args(gxg_gdk_window_set_events_w, gxg_gdk_window_set_events)
Xen_wrap_2_args(gxg_gdk_window_set_icon_name_w, gxg_gdk_window_set_icon_name)
Xen_wrap_2_args(gxg_gdk_window_set_group_w, gxg_gdk_window_set_group)
Xen_wrap_2_args(gxg_gdk_window_set_decorations_w, gxg_gdk_window_set_decorations)
Xen_wrap_2_optional_args(gxg_gdk_window_get_decorations_w, gxg_gdk_window_get_decorations)
Xen_wrap_2_args(gxg_gdk_window_set_functions_w, gxg_gdk_window_set_functions)
Xen_wrap_1_arg(gxg_gdk_window_iconify_w, gxg_gdk_window_iconify)
Xen_wrap_1_arg(gxg_gdk_window_deiconify_w, gxg_gdk_window_deiconify)
Xen_wrap_1_arg(gxg_gdk_window_stick_w, gxg_gdk_window_stick)
Xen_wrap_1_arg(gxg_gdk_window_unstick_w, gxg_gdk_window_unstick)
Xen_wrap_1_arg(gxg_gdk_window_maximize_w, gxg_gdk_window_maximize)
Xen_wrap_1_arg(gxg_gdk_window_unmaximize_w, gxg_gdk_window_unmaximize)
Xen_wrap_1_arg(gxg_gdk_window_register_dnd_w, gxg_gdk_window_register_dnd)
Xen_wrap_6_args(gxg_gdk_window_begin_resize_drag_w, gxg_gdk_window_begin_resize_drag)
Xen_wrap_5_args(gxg_gdk_window_begin_move_drag_w, gxg_gdk_window_begin_move_drag)
Xen_wrap_3_args(gxg_gdk_window_invalidate_rect_w, gxg_gdk_window_invalidate_rect)
Xen_wrap_1_arg(gxg_gdk_window_freeze_updates_w, gxg_gdk_window_freeze_updates)
Xen_wrap_1_arg(gxg_gdk_window_thaw_updates_w, gxg_gdk_window_thaw_updates)
Xen_wrap_6_optional_args(gxg_gdk_window_constrain_size_w, gxg_gdk_window_constrain_size)
Xen_wrap_2_args(gxg_gdk_window_set_type_hint_w, gxg_gdk_window_set_type_hint)
Xen_wrap_2_args(gxg_gdk_window_set_modal_hint_w, gxg_gdk_window_set_modal_hint)
Xen_wrap_2_args(gxg_gdk_window_set_title_w, gxg_gdk_window_set_title)
Xen_wrap_2_args(gxg_gdk_window_set_role_w, gxg_gdk_window_set_role)
Xen_wrap_2_args(gxg_gdk_window_set_transient_for_w, gxg_gdk_window_set_transient_for)
Xen_wrap_2_args(gxg_gdk_window_set_cursor_w, gxg_gdk_window_set_cursor)
Xen_wrap_2_optional_args(gxg_gdk_window_get_user_data_w, gxg_gdk_window_get_user_data)
Xen_wrap_3_optional_args(gxg_gdk_window_get_position_w, gxg_gdk_window_get_position)
Xen_wrap_3_optional_args(gxg_gdk_window_get_origin_w, gxg_gdk_window_get_origin)
Xen_wrap_no_args(gxg_gdk_pixbuf_error_quark_w, gxg_gdk_pixbuf_error_quark)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_colorspace_w, gxg_gdk_pixbuf_get_colorspace)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_n_channels_w, gxg_gdk_pixbuf_get_n_channels)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_has_alpha_w, gxg_gdk_pixbuf_get_has_alpha)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_bits_per_sample_w, gxg_gdk_pixbuf_get_bits_per_sample)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_pixels_w, gxg_gdk_pixbuf_get_pixels)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_width_w, gxg_gdk_pixbuf_get_width)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_height_w, gxg_gdk_pixbuf_get_height)
Xen_wrap_1_arg(gxg_gdk_pixbuf_get_rowstride_w, gxg_gdk_pixbuf_get_rowstride)
Xen_wrap_5_args(gxg_gdk_pixbuf_new_w, gxg_gdk_pixbuf_new)
Xen_wrap_1_arg(gxg_gdk_pixbuf_copy_w, gxg_gdk_pixbuf_copy)
Xen_wrap_5_args(gxg_gdk_pixbuf_new_subpixbuf_w, gxg_gdk_pixbuf_new_subpixbuf)
Xen_wrap_2_optional_args(gxg_gdk_pixbuf_new_from_file_w, gxg_gdk_pixbuf_new_from_file)
Xen_wrap_any_args(gxg_gdk_pixbuf_new_from_data_w, gxg_gdk_pixbuf_new_from_data)
Xen_wrap_1_arg(gxg_gdk_pixbuf_new_from_xpm_data_w, gxg_gdk_pixbuf_new_from_xpm_data)
Xen_wrap_2_args(gxg_gdk_pixbuf_fill_w, gxg_gdk_pixbuf_fill)
Xen_wrap_6_optional_args(gxg_gdk_pixbuf_savev_w, gxg_gdk_pixbuf_savev)
Xen_wrap_5_args(gxg_gdk_pixbuf_add_alpha_w, gxg_gdk_pixbuf_add_alpha)
Xen_wrap_any_args(gxg_gdk_pixbuf_copy_area_w, gxg_gdk_pixbuf_copy_area)
Xen_wrap_4_args(gxg_gdk_pixbuf_saturate_and_pixelate_w, gxg_gdk_pixbuf_saturate_and_pixelate)
Xen_wrap_any_args(gxg_gdk_pixbuf_scale_w, gxg_gdk_pixbuf_scale)
Xen_wrap_any_args(gxg_gdk_pixbuf_composite_w, gxg_gdk_pixbuf_composite)
Xen_wrap_any_args(gxg_gdk_pixbuf_composite_color_w, gxg_gdk_pixbuf_composite_color)
Xen_wrap_4_args(gxg_gdk_pixbuf_scale_simple_w, gxg_gdk_pixbuf_scale_simple)
Xen_wrap_any_args(gxg_gdk_pixbuf_composite_color_simple_w, gxg_gdk_pixbuf_composite_color_simple)
Xen_wrap_2_args(gxg_gdk_pixbuf_get_option_w, gxg_gdk_pixbuf_get_option)
Xen_wrap_no_args(gxg_gtk_accel_group_new_w, gxg_gtk_accel_group_new)
Xen_wrap_1_arg(gxg_gtk_accel_group_lock_w, gxg_gtk_accel_group_lock)
Xen_wrap_1_arg(gxg_gtk_accel_group_unlock_w, gxg_gtk_accel_group_unlock)
Xen_wrap_5_args(gxg_gtk_accel_group_connect_w, gxg_gtk_accel_group_connect)
Xen_wrap_3_args(gxg_gtk_accel_group_connect_by_path_w, gxg_gtk_accel_group_connect_by_path)
Xen_wrap_2_args(gxg_gtk_accel_group_disconnect_w, gxg_gtk_accel_group_disconnect)
Xen_wrap_3_args(gxg_gtk_accel_group_disconnect_key_w, gxg_gtk_accel_group_disconnect_key)
Xen_wrap_3_args(gxg_gtk_accel_groups_activate_w, gxg_gtk_accel_groups_activate)
Xen_wrap_1_arg(gxg_gtk_accel_groups_from_object_w, gxg_gtk_accel_groups_from_object)
Xen_wrap_3_args(gxg_gtk_accel_group_find_w, gxg_gtk_accel_group_find)
Xen_wrap_1_arg(gxg_gtk_accel_group_from_accel_closure_w, gxg_gtk_accel_group_from_accel_closure)
Xen_wrap_2_args(gxg_gtk_accelerator_valid_w, gxg_gtk_accelerator_valid)
Xen_wrap_3_optional_args(gxg_gtk_accelerator_parse_w, gxg_gtk_accelerator_parse)
Xen_wrap_2_args(gxg_gtk_accelerator_name_w, gxg_gtk_accelerator_name)
Xen_wrap_1_arg(gxg_gtk_accelerator_set_default_mod_mask_w, gxg_gtk_accelerator_set_default_mod_mask)
Xen_wrap_4_optional_args(gxg_gtk_accel_group_query_w, gxg_gtk_accel_group_query)
Xen_wrap_5_args(gxg_gtk_accel_group_activate_w, gxg_gtk_accel_group_activate)
Xen_wrap_1_arg(gxg_gtk_accel_label_new_w, gxg_gtk_accel_label_new)
Xen_wrap_1_arg(gxg_gtk_accel_label_get_accel_widget_w, gxg_gtk_accel_label_get_accel_widget)
Xen_wrap_1_arg(gxg_gtk_accel_label_get_accel_width_w, gxg_gtk_accel_label_get_accel_width)
Xen_wrap_2_args(gxg_gtk_accel_label_set_accel_widget_w, gxg_gtk_accel_label_set_accel_widget)
Xen_wrap_2_args(gxg_gtk_accel_label_set_accel_closure_w, gxg_gtk_accel_label_set_accel_closure)
Xen_wrap_1_arg(gxg_gtk_accel_label_refetch_w, gxg_gtk_accel_label_refetch)
Xen_wrap_3_args(gxg_gtk_accel_map_add_entry_w, gxg_gtk_accel_map_add_entry)
Xen_wrap_2_args(gxg_gtk_accel_map_lookup_entry_w, gxg_gtk_accel_map_lookup_entry)
Xen_wrap_4_args(gxg_gtk_accel_map_change_entry_w, gxg_gtk_accel_map_change_entry)
Xen_wrap_1_arg(gxg_gtk_accel_map_load_w, gxg_gtk_accel_map_load)
Xen_wrap_1_arg(gxg_gtk_accel_map_save_w, gxg_gtk_accel_map_save)
Xen_wrap_2_args(gxg_gtk_accel_map_foreach_w, gxg_gtk_accel_map_foreach)
Xen_wrap_1_arg(gxg_gtk_accel_map_load_fd_w, gxg_gtk_accel_map_load_fd)
Xen_wrap_1_arg(gxg_gtk_accel_map_save_fd_w, gxg_gtk_accel_map_save_fd)
Xen_wrap_1_arg(gxg_gtk_accel_map_add_filter_w, gxg_gtk_accel_map_add_filter)
Xen_wrap_2_args(gxg_gtk_accel_map_foreach_unfiltered_w, gxg_gtk_accel_map_foreach_unfiltered)
Xen_wrap_3_args(gxg_gtk_adjustment_clamp_page_w, gxg_gtk_adjustment_clamp_page)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_value_w, gxg_gtk_adjustment_get_value)
Xen_wrap_2_args(gxg_gtk_adjustment_set_value_w, gxg_gtk_adjustment_set_value)
Xen_wrap_5_args(gxg_gtk_aspect_frame_new_w, gxg_gtk_aspect_frame_new)
Xen_wrap_5_args(gxg_gtk_aspect_frame_set_w, gxg_gtk_aspect_frame_set)
Xen_wrap_1_arg(gxg_gtk_button_box_get_layout_w, gxg_gtk_button_box_get_layout)
Xen_wrap_2_args(gxg_gtk_button_box_set_layout_w, gxg_gtk_button_box_set_layout)
Xen_wrap_3_args(gxg_gtk_button_box_set_child_secondary_w, gxg_gtk_button_box_set_child_secondary)
Xen_wrap_1_arg(gxg_gtk_binding_set_new_w, gxg_gtk_binding_set_new)
Xen_wrap_1_arg(gxg_gtk_binding_set_by_class_w, gxg_gtk_binding_set_by_class)
Xen_wrap_1_arg(gxg_gtk_binding_set_find_w, gxg_gtk_binding_set_find)
Xen_wrap_3_args(gxg_gtk_binding_entry_remove_w, gxg_gtk_binding_entry_remove)
Xen_wrap_1_arg(gxg_gtk_bin_get_child_w, gxg_gtk_bin_get_child)
Xen_wrap_2_args(gxg_gtk_box_set_homogeneous_w, gxg_gtk_box_set_homogeneous)
Xen_wrap_1_arg(gxg_gtk_box_get_homogeneous_w, gxg_gtk_box_get_homogeneous)
Xen_wrap_2_args(gxg_gtk_box_set_spacing_w, gxg_gtk_box_set_spacing)
Xen_wrap_1_arg(gxg_gtk_box_get_spacing_w, gxg_gtk_box_get_spacing)
Xen_wrap_3_args(gxg_gtk_box_reorder_child_w, gxg_gtk_box_reorder_child)
Xen_wrap_no_args(gxg_gtk_button_new_w, gxg_gtk_button_new)
Xen_wrap_1_arg(gxg_gtk_button_new_with_label_w, gxg_gtk_button_new_with_label)
Xen_wrap_1_arg(gxg_gtk_button_new_with_mnemonic_w, gxg_gtk_button_new_with_mnemonic)
Xen_wrap_1_arg(gxg_gtk_button_clicked_w, gxg_gtk_button_clicked)
Xen_wrap_2_args(gxg_gtk_button_set_relief_w, gxg_gtk_button_set_relief)
Xen_wrap_1_arg(gxg_gtk_button_get_relief_w, gxg_gtk_button_get_relief)
Xen_wrap_2_args(gxg_gtk_button_set_label_w, gxg_gtk_button_set_label)
Xen_wrap_1_arg(gxg_gtk_button_get_label_w, gxg_gtk_button_get_label)
Xen_wrap_2_args(gxg_gtk_button_set_use_underline_w, gxg_gtk_button_set_use_underline)
Xen_wrap_1_arg(gxg_gtk_button_get_use_underline_w, gxg_gtk_button_get_use_underline)
Xen_wrap_no_args(gxg_gtk_calendar_new_w, gxg_gtk_calendar_new)
Xen_wrap_2_args(gxg_gtk_calendar_select_day_w, gxg_gtk_calendar_select_day)
Xen_wrap_1_arg(gxg_gtk_calendar_clear_marks_w, gxg_gtk_calendar_clear_marks)
Xen_wrap_4_optional_args(gxg_gtk_calendar_get_date_w, gxg_gtk_calendar_get_date)
Xen_wrap_2_args(gxg_gtk_cell_editable_start_editing_w, gxg_gtk_cell_editable_start_editing)
Xen_wrap_1_arg(gxg_gtk_cell_editable_editing_done_w, gxg_gtk_cell_editable_editing_done)
Xen_wrap_1_arg(gxg_gtk_cell_editable_remove_widget_w, gxg_gtk_cell_editable_remove_widget)
Xen_wrap_7_args(gxg_gtk_cell_renderer_activate_w, gxg_gtk_cell_renderer_activate)
Xen_wrap_7_args(gxg_gtk_cell_renderer_start_editing_w, gxg_gtk_cell_renderer_start_editing)
Xen_wrap_3_args(gxg_gtk_cell_renderer_set_fixed_size_w, gxg_gtk_cell_renderer_set_fixed_size)
Xen_wrap_3_optional_args(gxg_gtk_cell_renderer_get_fixed_size_w, gxg_gtk_cell_renderer_get_fixed_size)
Xen_wrap_no_args(gxg_gtk_cell_renderer_pixbuf_new_w, gxg_gtk_cell_renderer_pixbuf_new)
Xen_wrap_no_args(gxg_gtk_cell_renderer_text_new_w, gxg_gtk_cell_renderer_text_new)
Xen_wrap_2_args(gxg_gtk_cell_renderer_text_set_fixed_height_from_font_w, gxg_gtk_cell_renderer_text_set_fixed_height_from_font)
Xen_wrap_no_args(gxg_gtk_cell_renderer_toggle_new_w, gxg_gtk_cell_renderer_toggle_new)
Xen_wrap_1_arg(gxg_gtk_cell_renderer_toggle_get_radio_w, gxg_gtk_cell_renderer_toggle_get_radio)
Xen_wrap_2_args(gxg_gtk_cell_renderer_toggle_set_radio_w, gxg_gtk_cell_renderer_toggle_set_radio)
Xen_wrap_1_arg(gxg_gtk_cell_renderer_toggle_get_active_w, gxg_gtk_cell_renderer_toggle_get_active)
Xen_wrap_2_args(gxg_gtk_cell_renderer_toggle_set_active_w, gxg_gtk_cell_renderer_toggle_set_active)
Xen_wrap_no_args(gxg_gtk_check_button_new_w, gxg_gtk_check_button_new)
Xen_wrap_1_arg(gxg_gtk_check_button_new_with_label_w, gxg_gtk_check_button_new_with_label)
Xen_wrap_1_arg(gxg_gtk_check_button_new_with_mnemonic_w, gxg_gtk_check_button_new_with_mnemonic)
Xen_wrap_no_args(gxg_gtk_check_menu_item_new_w, gxg_gtk_check_menu_item_new)
Xen_wrap_1_arg(gxg_gtk_check_menu_item_new_with_label_w, gxg_gtk_check_menu_item_new_with_label)
Xen_wrap_1_arg(gxg_gtk_check_menu_item_new_with_mnemonic_w, gxg_gtk_check_menu_item_new_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_check_menu_item_set_active_w, gxg_gtk_check_menu_item_set_active)
Xen_wrap_1_arg(gxg_gtk_check_menu_item_get_active_w, gxg_gtk_check_menu_item_get_active)
Xen_wrap_1_arg(gxg_gtk_check_menu_item_toggled_w, gxg_gtk_check_menu_item_toggled)
Xen_wrap_2_args(gxg_gtk_check_menu_item_set_inconsistent_w, gxg_gtk_check_menu_item_set_inconsistent)
Xen_wrap_1_arg(gxg_gtk_check_menu_item_get_inconsistent_w, gxg_gtk_check_menu_item_get_inconsistent)
Xen_wrap_2_args(gxg_gtk_container_add_w, gxg_gtk_container_add)
Xen_wrap_2_args(gxg_gtk_container_remove_w, gxg_gtk_container_remove)
Xen_wrap_1_arg(gxg_gtk_container_check_resize_w, gxg_gtk_container_check_resize)
Xen_wrap_3_args(gxg_gtk_container_foreach_w, gxg_gtk_container_foreach)
Xen_wrap_1_arg(gxg_gtk_container_get_children_w, gxg_gtk_container_get_children)
Xen_wrap_no_args(gxg_gtk_dialog_new_w, gxg_gtk_dialog_new)
Xen_wrap_3_args(gxg_gtk_dialog_add_action_widget_w, gxg_gtk_dialog_add_action_widget)
Xen_wrap_3_args(gxg_gtk_dialog_add_button_w, gxg_gtk_dialog_add_button)
Xen_wrap_2_args(gxg_gtk_dialog_add_buttons_w, gxg_gtk_dialog_add_buttons)
Xen_wrap_3_args(gxg_gtk_dialog_set_response_sensitive_w, gxg_gtk_dialog_set_response_sensitive)
Xen_wrap_2_args(gxg_gtk_dialog_set_default_response_w, gxg_gtk_dialog_set_default_response)
Xen_wrap_2_args(gxg_gtk_dialog_response_w, gxg_gtk_dialog_response)
Xen_wrap_1_arg(gxg_gtk_dialog_run_w, gxg_gtk_dialog_run)
Xen_wrap_4_args(gxg_gtk_drag_get_data_w, gxg_gtk_drag_get_data)
Xen_wrap_1_arg(gxg_gtk_drag_get_source_widget_w, gxg_gtk_drag_get_source_widget)
Xen_wrap_1_arg(gxg_gtk_drag_highlight_w, gxg_gtk_drag_highlight)
Xen_wrap_1_arg(gxg_gtk_drag_unhighlight_w, gxg_gtk_drag_unhighlight)
Xen_wrap_1_arg(gxg_gtk_drag_dest_unset_w, gxg_gtk_drag_dest_unset)
Xen_wrap_1_arg(gxg_gtk_drag_source_unset_w, gxg_gtk_drag_source_unset)
Xen_wrap_4_args(gxg_gtk_drag_set_icon_widget_w, gxg_gtk_drag_set_icon_widget)
Xen_wrap_1_arg(gxg_gtk_drag_set_icon_default_w, gxg_gtk_drag_set_icon_default)
Xen_wrap_5_args(gxg_gtk_drag_check_threshold_w, gxg_gtk_drag_check_threshold)
Xen_wrap_no_args(gxg_gtk_drawing_area_new_w, gxg_gtk_drawing_area_new)
Xen_wrap_3_args(gxg_gtk_editable_select_region_w, gxg_gtk_editable_select_region)
Xen_wrap_3_optional_args(gxg_gtk_editable_get_selection_bounds_w, gxg_gtk_editable_get_selection_bounds)
Xen_wrap_4_optional_args(gxg_gtk_editable_insert_text_w, gxg_gtk_editable_insert_text)
Xen_wrap_3_args(gxg_gtk_editable_delete_text_w, gxg_gtk_editable_delete_text)
Xen_wrap_3_args(gxg_gtk_editable_get_chars_w, gxg_gtk_editable_get_chars)
Xen_wrap_1_arg(gxg_gtk_editable_cut_clipboard_w, gxg_gtk_editable_cut_clipboard)
Xen_wrap_1_arg(gxg_gtk_editable_copy_clipboard_w, gxg_gtk_editable_copy_clipboard)
Xen_wrap_1_arg(gxg_gtk_editable_paste_clipboard_w, gxg_gtk_editable_paste_clipboard)
Xen_wrap_1_arg(gxg_gtk_editable_delete_selection_w, gxg_gtk_editable_delete_selection)
Xen_wrap_2_args(gxg_gtk_editable_set_position_w, gxg_gtk_editable_set_position)
Xen_wrap_1_arg(gxg_gtk_editable_get_position_w, gxg_gtk_editable_get_position)
Xen_wrap_2_args(gxg_gtk_editable_set_editable_w, gxg_gtk_editable_set_editable)
Xen_wrap_1_arg(gxg_gtk_editable_get_editable_w, gxg_gtk_editable_get_editable)
Xen_wrap_no_args(gxg_gtk_entry_new_w, gxg_gtk_entry_new)
Xen_wrap_2_args(gxg_gtk_entry_set_visibility_w, gxg_gtk_entry_set_visibility)
Xen_wrap_1_arg(gxg_gtk_entry_get_visibility_w, gxg_gtk_entry_get_visibility)
Xen_wrap_2_args(gxg_gtk_entry_set_invisible_char_w, gxg_gtk_entry_set_invisible_char)
Xen_wrap_1_arg(gxg_gtk_entry_get_invisible_char_w, gxg_gtk_entry_get_invisible_char)
Xen_wrap_2_args(gxg_gtk_entry_set_has_frame_w, gxg_gtk_entry_set_has_frame)
Xen_wrap_1_arg(gxg_gtk_entry_get_has_frame_w, gxg_gtk_entry_get_has_frame)
Xen_wrap_2_args(gxg_gtk_entry_set_max_length_w, gxg_gtk_entry_set_max_length)
Xen_wrap_1_arg(gxg_gtk_entry_get_max_length_w, gxg_gtk_entry_get_max_length)
Xen_wrap_2_args(gxg_gtk_entry_set_activates_default_w, gxg_gtk_entry_set_activates_default)
Xen_wrap_1_arg(gxg_gtk_entry_get_activates_default_w, gxg_gtk_entry_get_activates_default)
Xen_wrap_2_args(gxg_gtk_entry_set_width_chars_w, gxg_gtk_entry_set_width_chars)
Xen_wrap_1_arg(gxg_gtk_entry_get_width_chars_w, gxg_gtk_entry_get_width_chars)
Xen_wrap_2_args(gxg_gtk_entry_set_text_w, gxg_gtk_entry_set_text)
Xen_wrap_1_arg(gxg_gtk_entry_get_text_w, gxg_gtk_entry_get_text)
Xen_wrap_1_arg(gxg_gtk_entry_get_layout_w, gxg_gtk_entry_get_layout)
Xen_wrap_3_optional_args(gxg_gtk_entry_get_layout_offsets_w, gxg_gtk_entry_get_layout_offsets)
Xen_wrap_no_args(gxg_gtk_fixed_new_w, gxg_gtk_fixed_new)
Xen_wrap_4_args(gxg_gtk_fixed_put_w, gxg_gtk_fixed_put)
Xen_wrap_4_args(gxg_gtk_fixed_move_w, gxg_gtk_fixed_move)
Xen_wrap_1_arg(gxg_gtk_frame_new_w, gxg_gtk_frame_new)
Xen_wrap_2_args(gxg_gtk_frame_set_label_w, gxg_gtk_frame_set_label)
Xen_wrap_1_arg(gxg_gtk_frame_get_label_w, gxg_gtk_frame_get_label)
Xen_wrap_2_args(gxg_gtk_frame_set_label_widget_w, gxg_gtk_frame_set_label_widget)
Xen_wrap_1_arg(gxg_gtk_frame_get_label_widget_w, gxg_gtk_frame_get_label_widget)
Xen_wrap_3_args(gxg_gtk_frame_set_label_align_w, gxg_gtk_frame_set_label_align)
Xen_wrap_3_optional_args(gxg_gtk_frame_get_label_align_w, gxg_gtk_frame_get_label_align)
Xen_wrap_2_args(gxg_gtk_frame_set_shadow_type_w, gxg_gtk_frame_set_shadow_type)
Xen_wrap_1_arg(gxg_gtk_frame_get_shadow_type_w, gxg_gtk_frame_get_shadow_type)
Xen_wrap_no_args(gxg_gtk_image_new_w, gxg_gtk_image_new)
Xen_wrap_1_arg(gxg_gtk_image_new_from_file_w, gxg_gtk_image_new_from_file)
Xen_wrap_1_arg(gxg_gtk_image_new_from_pixbuf_w, gxg_gtk_image_new_from_pixbuf)
Xen_wrap_2_args(gxg_gtk_image_set_from_file_w, gxg_gtk_image_set_from_file)
Xen_wrap_2_args(gxg_gtk_image_set_from_pixbuf_w, gxg_gtk_image_set_from_pixbuf)
Xen_wrap_1_arg(gxg_gtk_image_get_storage_type_w, gxg_gtk_image_get_storage_type)
Xen_wrap_4_optional_args(gxg_gtk_im_context_get_preedit_string_w, gxg_gtk_im_context_get_preedit_string)
Xen_wrap_2_args(gxg_gtk_im_context_filter_keypress_w, gxg_gtk_im_context_filter_keypress)
Xen_wrap_1_arg(gxg_gtk_im_context_focus_in_w, gxg_gtk_im_context_focus_in)
Xen_wrap_1_arg(gxg_gtk_im_context_focus_out_w, gxg_gtk_im_context_focus_out)
Xen_wrap_1_arg(gxg_gtk_im_context_reset_w, gxg_gtk_im_context_reset)
Xen_wrap_2_args(gxg_gtk_im_context_set_cursor_location_w, gxg_gtk_im_context_set_cursor_location)
Xen_wrap_2_args(gxg_gtk_im_context_set_use_preedit_w, gxg_gtk_im_context_set_use_preedit)
Xen_wrap_4_args(gxg_gtk_im_context_set_surrounding_w, gxg_gtk_im_context_set_surrounding)
Xen_wrap_3_optional_args(gxg_gtk_im_context_get_surrounding_w, gxg_gtk_im_context_get_surrounding)
Xen_wrap_3_args(gxg_gtk_im_context_delete_surrounding_w, gxg_gtk_im_context_delete_surrounding)
Xen_wrap_no_args(gxg_gtk_im_context_simple_new_w, gxg_gtk_im_context_simple_new)
Xen_wrap_4_args(gxg_gtk_im_context_simple_add_table_w, gxg_gtk_im_context_simple_add_table)
Xen_wrap_no_args(gxg_gtk_invisible_new_w, gxg_gtk_invisible_new)
Xen_wrap_1_arg(gxg_gtk_label_new_w, gxg_gtk_label_new)
Xen_wrap_1_arg(gxg_gtk_label_new_with_mnemonic_w, gxg_gtk_label_new_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_label_set_text_w, gxg_gtk_label_set_text)
Xen_wrap_1_arg(gxg_gtk_label_get_text_w, gxg_gtk_label_get_text)
Xen_wrap_2_args(gxg_gtk_label_set_attributes_w, gxg_gtk_label_set_attributes)
Xen_wrap_1_arg(gxg_gtk_label_get_attributes_w, gxg_gtk_label_get_attributes)
Xen_wrap_2_args(gxg_gtk_label_set_label_w, gxg_gtk_label_set_label)
Xen_wrap_1_arg(gxg_gtk_label_get_label_w, gxg_gtk_label_get_label)
Xen_wrap_2_args(gxg_gtk_label_set_markup_w, gxg_gtk_label_set_markup)
Xen_wrap_2_args(gxg_gtk_label_set_use_markup_w, gxg_gtk_label_set_use_markup)
Xen_wrap_1_arg(gxg_gtk_label_get_use_markup_w, gxg_gtk_label_get_use_markup)
Xen_wrap_2_args(gxg_gtk_label_set_use_underline_w, gxg_gtk_label_set_use_underline)
Xen_wrap_1_arg(gxg_gtk_label_get_use_underline_w, gxg_gtk_label_get_use_underline)
Xen_wrap_2_args(gxg_gtk_label_set_markup_with_mnemonic_w, gxg_gtk_label_set_markup_with_mnemonic)
Xen_wrap_1_arg(gxg_gtk_label_get_mnemonic_keyval_w, gxg_gtk_label_get_mnemonic_keyval)
Xen_wrap_2_args(gxg_gtk_label_set_mnemonic_widget_w, gxg_gtk_label_set_mnemonic_widget)
Xen_wrap_1_arg(gxg_gtk_label_get_mnemonic_widget_w, gxg_gtk_label_get_mnemonic_widget)
Xen_wrap_2_args(gxg_gtk_label_set_text_with_mnemonic_w, gxg_gtk_label_set_text_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_label_set_justify_w, gxg_gtk_label_set_justify)
Xen_wrap_1_arg(gxg_gtk_label_get_justify_w, gxg_gtk_label_get_justify)
Xen_wrap_2_args(gxg_gtk_label_set_pattern_w, gxg_gtk_label_set_pattern)
Xen_wrap_2_args(gxg_gtk_label_set_line_wrap_w, gxg_gtk_label_set_line_wrap)
Xen_wrap_1_arg(gxg_gtk_label_get_line_wrap_w, gxg_gtk_label_get_line_wrap)
Xen_wrap_2_args(gxg_gtk_label_set_selectable_w, gxg_gtk_label_set_selectable)
Xen_wrap_1_arg(gxg_gtk_label_get_selectable_w, gxg_gtk_label_get_selectable)
Xen_wrap_3_args(gxg_gtk_label_select_region_w, gxg_gtk_label_select_region)
Xen_wrap_3_optional_args(gxg_gtk_label_get_selection_bounds_w, gxg_gtk_label_get_selection_bounds)
Xen_wrap_1_arg(gxg_gtk_label_get_layout_w, gxg_gtk_label_get_layout)
Xen_wrap_3_optional_args(gxg_gtk_label_get_layout_offsets_w, gxg_gtk_label_get_layout_offsets)
Xen_wrap_2_args(gxg_gtk_layout_new_w, gxg_gtk_layout_new)
Xen_wrap_4_args(gxg_gtk_layout_put_w, gxg_gtk_layout_put)
Xen_wrap_4_args(gxg_gtk_layout_move_w, gxg_gtk_layout_move)
Xen_wrap_3_args(gxg_gtk_layout_set_size_w, gxg_gtk_layout_set_size)
Xen_wrap_3_optional_args(gxg_gtk_layout_get_size_w, gxg_gtk_layout_get_size)
Xen_wrap_2_args(gxg_gtk_list_store_new_w, gxg_gtk_list_store_new)
Xen_wrap_2_args(gxg_gtk_list_store_newv_w, gxg_gtk_list_store_newv)
Xen_wrap_3_args(gxg_gtk_list_store_set_column_types_w, gxg_gtk_list_store_set_column_types)
Xen_wrap_3_args(gxg_gtk_list_store_set_w, gxg_gtk_list_store_set)
Xen_wrap_3_args(gxg_gtk_list_store_insert_w, gxg_gtk_list_store_insert)
Xen_wrap_3_args(gxg_gtk_list_store_insert_before_w, gxg_gtk_list_store_insert_before)
Xen_wrap_3_args(gxg_gtk_list_store_insert_after_w, gxg_gtk_list_store_insert_after)
Xen_wrap_2_args(gxg_gtk_list_store_prepend_w, gxg_gtk_list_store_prepend)
Xen_wrap_2_args(gxg_gtk_list_store_append_w, gxg_gtk_list_store_append)
Xen_wrap_1_arg(gxg_gtk_list_store_clear_w, gxg_gtk_list_store_clear)
Xen_wrap_3_args(gxg_gtk_check_version_w, gxg_gtk_check_version)
Xen_wrap_no_args(gxg_gtk_disable_setlocale_w, gxg_gtk_disable_setlocale)
Xen_wrap_no_args(gxg_gtk_get_default_language_w, gxg_gtk_get_default_language)
Xen_wrap_no_args(gxg_gtk_events_pending_w, gxg_gtk_events_pending)
Xen_wrap_1_arg(gxg_gtk_main_do_event_w, gxg_gtk_main_do_event)
Xen_wrap_no_args(gxg_gtk_main_w, gxg_gtk_main)
Xen_wrap_no_args(gxg_gtk_main_level_w, gxg_gtk_main_level)
Xen_wrap_no_args(gxg_gtk_main_quit_w, gxg_gtk_main_quit)
Xen_wrap_no_args(gxg_gtk_main_iteration_w, gxg_gtk_main_iteration)
Xen_wrap_1_arg(gxg_gtk_main_iteration_do_w, gxg_gtk_main_iteration_do)
Xen_wrap_no_args(gxg_gtk_true_w, gxg_gtk_true)
Xen_wrap_no_args(gxg_gtk_false_w, gxg_gtk_false)
Xen_wrap_1_arg(gxg_gtk_grab_add_w, gxg_gtk_grab_add)
Xen_wrap_no_args(gxg_gtk_grab_get_current_w, gxg_gtk_grab_get_current)
Xen_wrap_1_arg(gxg_gtk_grab_remove_w, gxg_gtk_grab_remove)
Xen_wrap_no_args(gxg_gtk_get_current_event_w, gxg_gtk_get_current_event)
Xen_wrap_no_args(gxg_gtk_get_current_event_time_w, gxg_gtk_get_current_event_time)
Xen_wrap_1_optional_arg(gxg_gtk_get_current_event_state_w, gxg_gtk_get_current_event_state)
Xen_wrap_1_arg(gxg_gtk_get_event_widget_w, gxg_gtk_get_event_widget)
Xen_wrap_2_args(gxg_gtk_propagate_event_w, gxg_gtk_propagate_event)
Xen_wrap_no_args(gxg_gtk_menu_bar_new_w, gxg_gtk_menu_bar_new)
Xen_wrap_no_args(gxg_gtk_menu_new_w, gxg_gtk_menu_new)
Xen_wrap_1_arg(gxg_gtk_menu_reposition_w, gxg_gtk_menu_reposition)
Xen_wrap_1_arg(gxg_gtk_menu_popdown_w, gxg_gtk_menu_popdown)
Xen_wrap_1_arg(gxg_gtk_menu_get_active_w, gxg_gtk_menu_get_active)
Xen_wrap_2_args(gxg_gtk_menu_set_active_w, gxg_gtk_menu_set_active)
Xen_wrap_2_args(gxg_gtk_menu_set_accel_group_w, gxg_gtk_menu_set_accel_group)
Xen_wrap_1_arg(gxg_gtk_menu_get_accel_group_w, gxg_gtk_menu_get_accel_group)
Xen_wrap_2_args(gxg_gtk_menu_set_accel_path_w, gxg_gtk_menu_set_accel_path)
Xen_wrap_1_arg(gxg_gtk_menu_detach_w, gxg_gtk_menu_detach)
Xen_wrap_1_arg(gxg_gtk_menu_get_attach_widget_w, gxg_gtk_menu_get_attach_widget)
Xen_wrap_3_args(gxg_gtk_menu_reorder_child_w, gxg_gtk_menu_reorder_child)
Xen_wrap_2_args(gxg_gtk_menu_set_monitor_w, gxg_gtk_menu_set_monitor)
Xen_wrap_no_args(gxg_gtk_menu_item_new_w, gxg_gtk_menu_item_new)
Xen_wrap_1_arg(gxg_gtk_menu_item_new_with_label_w, gxg_gtk_menu_item_new_with_label)
Xen_wrap_1_arg(gxg_gtk_menu_item_new_with_mnemonic_w, gxg_gtk_menu_item_new_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_menu_item_set_submenu_w, gxg_gtk_menu_item_set_submenu)
Xen_wrap_1_arg(gxg_gtk_menu_item_get_submenu_w, gxg_gtk_menu_item_get_submenu)
Xen_wrap_1_arg(gxg_gtk_menu_item_select_w, gxg_gtk_menu_item_select)
Xen_wrap_1_arg(gxg_gtk_menu_item_deselect_w, gxg_gtk_menu_item_deselect)
Xen_wrap_1_arg(gxg_gtk_menu_item_activate_w, gxg_gtk_menu_item_activate)
Xen_wrap_2_args(gxg_gtk_menu_item_toggle_size_request_w, gxg_gtk_menu_item_toggle_size_request)
Xen_wrap_2_args(gxg_gtk_menu_item_toggle_size_allocate_w, gxg_gtk_menu_item_toggle_size_allocate)
Xen_wrap_2_args(gxg_gtk_menu_item_set_accel_path_w, gxg_gtk_menu_item_set_accel_path)
Xen_wrap_2_args(gxg_gtk_menu_shell_append_w, gxg_gtk_menu_shell_append)
Xen_wrap_2_args(gxg_gtk_menu_shell_prepend_w, gxg_gtk_menu_shell_prepend)
Xen_wrap_3_args(gxg_gtk_menu_shell_insert_w, gxg_gtk_menu_shell_insert)
Xen_wrap_1_arg(gxg_gtk_menu_shell_deactivate_w, gxg_gtk_menu_shell_deactivate)
Xen_wrap_2_args(gxg_gtk_menu_shell_select_item_w, gxg_gtk_menu_shell_select_item)
Xen_wrap_1_arg(gxg_gtk_menu_shell_deselect_w, gxg_gtk_menu_shell_deselect)
Xen_wrap_3_args(gxg_gtk_menu_shell_activate_item_w, gxg_gtk_menu_shell_activate_item)
Xen_wrap_no_args(gxg_gtk_notebook_new_w, gxg_gtk_notebook_new)
Xen_wrap_2_args(gxg_gtk_notebook_remove_page_w, gxg_gtk_notebook_remove_page)
Xen_wrap_1_arg(gxg_gtk_notebook_get_current_page_w, gxg_gtk_notebook_get_current_page)
Xen_wrap_2_args(gxg_gtk_notebook_get_nth_page_w, gxg_gtk_notebook_get_nth_page)
Xen_wrap_2_args(gxg_gtk_notebook_page_num_w, gxg_gtk_notebook_page_num)
Xen_wrap_2_args(gxg_gtk_notebook_set_current_page_w, gxg_gtk_notebook_set_current_page)
Xen_wrap_1_arg(gxg_gtk_notebook_next_page_w, gxg_gtk_notebook_next_page)
Xen_wrap_1_arg(gxg_gtk_notebook_prev_page_w, gxg_gtk_notebook_prev_page)
Xen_wrap_2_args(gxg_gtk_notebook_set_show_border_w, gxg_gtk_notebook_set_show_border)
Xen_wrap_1_arg(gxg_gtk_notebook_get_show_border_w, gxg_gtk_notebook_get_show_border)
Xen_wrap_2_args(gxg_gtk_notebook_set_show_tabs_w, gxg_gtk_notebook_set_show_tabs)
Xen_wrap_1_arg(gxg_gtk_notebook_get_show_tabs_w, gxg_gtk_notebook_get_show_tabs)
Xen_wrap_2_args(gxg_gtk_notebook_set_tab_pos_w, gxg_gtk_notebook_set_tab_pos)
Xen_wrap_1_arg(gxg_gtk_notebook_get_tab_pos_w, gxg_gtk_notebook_get_tab_pos)
Xen_wrap_2_args(gxg_gtk_notebook_set_scrollable_w, gxg_gtk_notebook_set_scrollable)
Xen_wrap_1_arg(gxg_gtk_notebook_get_scrollable_w, gxg_gtk_notebook_get_scrollable)
Xen_wrap_1_arg(gxg_gtk_notebook_popup_enable_w, gxg_gtk_notebook_popup_enable)
Xen_wrap_1_arg(gxg_gtk_notebook_popup_disable_w, gxg_gtk_notebook_popup_disable)
Xen_wrap_2_args(gxg_gtk_notebook_get_tab_label_w, gxg_gtk_notebook_get_tab_label)
Xen_wrap_3_args(gxg_gtk_notebook_set_tab_label_w, gxg_gtk_notebook_set_tab_label)
Xen_wrap_3_args(gxg_gtk_notebook_set_tab_label_text_w, gxg_gtk_notebook_set_tab_label_text)
Xen_wrap_2_args(gxg_gtk_notebook_get_tab_label_text_w, gxg_gtk_notebook_get_tab_label_text)
Xen_wrap_2_args(gxg_gtk_notebook_get_menu_label_w, gxg_gtk_notebook_get_menu_label)
Xen_wrap_3_args(gxg_gtk_notebook_set_menu_label_w, gxg_gtk_notebook_set_menu_label)
Xen_wrap_3_args(gxg_gtk_notebook_set_menu_label_text_w, gxg_gtk_notebook_set_menu_label_text)
Xen_wrap_2_args(gxg_gtk_notebook_get_menu_label_text_w, gxg_gtk_notebook_get_menu_label_text)
Xen_wrap_3_args(gxg_gtk_notebook_reorder_child_w, gxg_gtk_notebook_reorder_child)
Xen_wrap_3_args(gxg_gtk_notebook_append_page_w, gxg_gtk_notebook_append_page)
Xen_wrap_4_args(gxg_gtk_notebook_append_page_menu_w, gxg_gtk_notebook_append_page_menu)
Xen_wrap_3_args(gxg_gtk_notebook_prepend_page_w, gxg_gtk_notebook_prepend_page)
Xen_wrap_4_args(gxg_gtk_notebook_prepend_page_menu_w, gxg_gtk_notebook_prepend_page_menu)
Xen_wrap_4_args(gxg_gtk_notebook_insert_page_w, gxg_gtk_notebook_insert_page)
Xen_wrap_5_args(gxg_gtk_notebook_insert_page_menu_w, gxg_gtk_notebook_insert_page_menu)
Xen_wrap_2_args(gxg_gtk_paned_add1_w, gxg_gtk_paned_add1)
Xen_wrap_2_args(gxg_gtk_paned_add2_w, gxg_gtk_paned_add2)
Xen_wrap_4_args(gxg_gtk_paned_pack1_w, gxg_gtk_paned_pack1)
Xen_wrap_4_args(gxg_gtk_paned_pack2_w, gxg_gtk_paned_pack2)
Xen_wrap_1_arg(gxg_gtk_paned_get_position_w, gxg_gtk_paned_get_position)
Xen_wrap_2_args(gxg_gtk_paned_set_position_w, gxg_gtk_paned_set_position)
Xen_wrap_no_args(gxg_gtk_progress_bar_new_w, gxg_gtk_progress_bar_new)
Xen_wrap_1_arg(gxg_gtk_progress_bar_pulse_w, gxg_gtk_progress_bar_pulse)
Xen_wrap_2_args(gxg_gtk_progress_bar_set_text_w, gxg_gtk_progress_bar_set_text)
Xen_wrap_2_args(gxg_gtk_progress_bar_set_fraction_w, gxg_gtk_progress_bar_set_fraction)
Xen_wrap_2_args(gxg_gtk_progress_bar_set_pulse_step_w, gxg_gtk_progress_bar_set_pulse_step)
Xen_wrap_1_arg(gxg_gtk_progress_bar_get_text_w, gxg_gtk_progress_bar_get_text)
Xen_wrap_1_arg(gxg_gtk_progress_bar_get_fraction_w, gxg_gtk_progress_bar_get_fraction)
Xen_wrap_1_arg(gxg_gtk_progress_bar_get_pulse_step_w, gxg_gtk_progress_bar_get_pulse_step)
Xen_wrap_1_arg(gxg_gtk_radio_button_new_w, gxg_gtk_radio_button_new)
Xen_wrap_1_arg(gxg_gtk_radio_button_new_from_widget_w, gxg_gtk_radio_button_new_from_widget)
Xen_wrap_2_args(gxg_gtk_radio_button_new_with_label_w, gxg_gtk_radio_button_new_with_label)
Xen_wrap_2_args(gxg_gtk_radio_button_new_with_label_from_widget_w, gxg_gtk_radio_button_new_with_label_from_widget)
Xen_wrap_2_args(gxg_gtk_radio_button_new_with_mnemonic_w, gxg_gtk_radio_button_new_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_radio_button_new_with_mnemonic_from_widget_w, gxg_gtk_radio_button_new_with_mnemonic_from_widget)
Xen_wrap_1_arg(gxg_gtk_radio_button_get_group_w, gxg_gtk_radio_button_get_group)
Xen_wrap_2_args(gxg_gtk_radio_button_set_group_w, gxg_gtk_radio_button_set_group)
Xen_wrap_1_arg(gxg_gtk_radio_menu_item_new_w, gxg_gtk_radio_menu_item_new)
Xen_wrap_2_args(gxg_gtk_radio_menu_item_new_with_label_w, gxg_gtk_radio_menu_item_new_with_label)
Xen_wrap_2_args(gxg_gtk_radio_menu_item_new_with_mnemonic_w, gxg_gtk_radio_menu_item_new_with_mnemonic)
Xen_wrap_1_arg(gxg_gtk_radio_menu_item_get_group_w, gxg_gtk_radio_menu_item_get_group)
Xen_wrap_2_args(gxg_gtk_radio_menu_item_set_group_w, gxg_gtk_radio_menu_item_set_group)
Xen_wrap_2_args(gxg_gtk_range_set_adjustment_w, gxg_gtk_range_set_adjustment)
Xen_wrap_1_arg(gxg_gtk_range_get_adjustment_w, gxg_gtk_range_get_adjustment)
Xen_wrap_2_args(gxg_gtk_range_set_inverted_w, gxg_gtk_range_set_inverted)
Xen_wrap_1_arg(gxg_gtk_range_get_inverted_w, gxg_gtk_range_get_inverted)
Xen_wrap_3_args(gxg_gtk_range_set_increments_w, gxg_gtk_range_set_increments)
Xen_wrap_3_args(gxg_gtk_range_set_range_w, gxg_gtk_range_set_range)
Xen_wrap_2_args(gxg_gtk_range_set_value_w, gxg_gtk_range_set_value)
Xen_wrap_1_arg(gxg_gtk_range_get_value_w, gxg_gtk_range_get_value)
Xen_wrap_2_args(gxg_gtk_scale_set_digits_w, gxg_gtk_scale_set_digits)
Xen_wrap_1_arg(gxg_gtk_scale_get_digits_w, gxg_gtk_scale_get_digits)
Xen_wrap_2_args(gxg_gtk_scale_set_draw_value_w, gxg_gtk_scale_set_draw_value)
Xen_wrap_1_arg(gxg_gtk_scale_get_draw_value_w, gxg_gtk_scale_get_draw_value)
Xen_wrap_2_args(gxg_gtk_scale_set_value_pos_w, gxg_gtk_scale_set_value_pos)
Xen_wrap_1_arg(gxg_gtk_scale_get_value_pos_w, gxg_gtk_scale_get_value_pos)
Xen_wrap_2_args(gxg_gtk_scrolled_window_new_w, gxg_gtk_scrolled_window_new)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_hadjustment_w, gxg_gtk_scrolled_window_set_hadjustment)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_vadjustment_w, gxg_gtk_scrolled_window_set_vadjustment)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_hadjustment_w, gxg_gtk_scrolled_window_get_hadjustment)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_vadjustment_w, gxg_gtk_scrolled_window_get_vadjustment)
Xen_wrap_3_args(gxg_gtk_scrolled_window_set_policy_w, gxg_gtk_scrolled_window_set_policy)
Xen_wrap_3_optional_args(gxg_gtk_scrolled_window_get_policy_w, gxg_gtk_scrolled_window_get_policy)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_placement_w, gxg_gtk_scrolled_window_set_placement)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_placement_w, gxg_gtk_scrolled_window_get_placement)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_shadow_type_w, gxg_gtk_scrolled_window_set_shadow_type)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_shadow_type_w, gxg_gtk_scrolled_window_get_shadow_type)
Xen_wrap_1_arg(gxg_gtk_selection_data_copy_w, gxg_gtk_selection_data_copy)
Xen_wrap_1_arg(gxg_gtk_selection_data_free_w, gxg_gtk_selection_data_free)
Xen_wrap_no_args(gxg_gtk_separator_menu_item_new_w, gxg_gtk_separator_menu_item_new)
Xen_wrap_no_args(gxg_gtk_settings_get_default_w, gxg_gtk_settings_get_default)
Xen_wrap_1_arg(gxg_gtk_size_group_new_w, gxg_gtk_size_group_new)
Xen_wrap_2_args(gxg_gtk_size_group_set_mode_w, gxg_gtk_size_group_set_mode)
Xen_wrap_1_arg(gxg_gtk_size_group_get_mode_w, gxg_gtk_size_group_get_mode)
Xen_wrap_2_args(gxg_gtk_size_group_add_widget_w, gxg_gtk_size_group_add_widget)
Xen_wrap_2_args(gxg_gtk_size_group_remove_widget_w, gxg_gtk_size_group_remove_widget)
Xen_wrap_4_args(gxg_gtk_spin_button_configure_w, gxg_gtk_spin_button_configure)
Xen_wrap_3_args(gxg_gtk_spin_button_new_w, gxg_gtk_spin_button_new)
Xen_wrap_3_args(gxg_gtk_spin_button_new_with_range_w, gxg_gtk_spin_button_new_with_range)
Xen_wrap_2_args(gxg_gtk_spin_button_set_adjustment_w, gxg_gtk_spin_button_set_adjustment)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_adjustment_w, gxg_gtk_spin_button_get_adjustment)
Xen_wrap_2_args(gxg_gtk_spin_button_set_digits_w, gxg_gtk_spin_button_set_digits)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_digits_w, gxg_gtk_spin_button_get_digits)
Xen_wrap_3_args(gxg_gtk_spin_button_set_increments_w, gxg_gtk_spin_button_set_increments)
Xen_wrap_3_optional_args(gxg_gtk_spin_button_get_increments_w, gxg_gtk_spin_button_get_increments)
Xen_wrap_3_args(gxg_gtk_spin_button_set_range_w, gxg_gtk_spin_button_set_range)
Xen_wrap_3_optional_args(gxg_gtk_spin_button_get_range_w, gxg_gtk_spin_button_get_range)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_value_w, gxg_gtk_spin_button_get_value)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_value_as_int_w, gxg_gtk_spin_button_get_value_as_int)
Xen_wrap_2_args(gxg_gtk_spin_button_set_value_w, gxg_gtk_spin_button_set_value)
Xen_wrap_2_args(gxg_gtk_spin_button_set_update_policy_w, gxg_gtk_spin_button_set_update_policy)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_update_policy_w, gxg_gtk_spin_button_get_update_policy)
Xen_wrap_2_args(gxg_gtk_spin_button_set_numeric_w, gxg_gtk_spin_button_set_numeric)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_numeric_w, gxg_gtk_spin_button_get_numeric)
Xen_wrap_3_args(gxg_gtk_spin_button_spin_w, gxg_gtk_spin_button_spin)
Xen_wrap_2_args(gxg_gtk_spin_button_set_wrap_w, gxg_gtk_spin_button_set_wrap)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_wrap_w, gxg_gtk_spin_button_get_wrap)
Xen_wrap_2_args(gxg_gtk_spin_button_set_snap_to_ticks_w, gxg_gtk_spin_button_set_snap_to_ticks)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_snap_to_ticks_w, gxg_gtk_spin_button_get_snap_to_ticks)
Xen_wrap_1_arg(gxg_gtk_spin_button_update_w, gxg_gtk_spin_button_update)
Xen_wrap_no_args(gxg_gtk_statusbar_new_w, gxg_gtk_statusbar_new)
Xen_wrap_2_args(gxg_gtk_statusbar_get_context_id_w, gxg_gtk_statusbar_get_context_id)
Xen_wrap_3_args(gxg_gtk_statusbar_push_w, gxg_gtk_statusbar_push)
Xen_wrap_2_args(gxg_gtk_statusbar_pop_w, gxg_gtk_statusbar_pop)
Xen_wrap_3_args(gxg_gtk_statusbar_remove_w, gxg_gtk_statusbar_remove)
Xen_wrap_1_arg(gxg_gtk_text_buffer_new_w, gxg_gtk_text_buffer_new)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_line_count_w, gxg_gtk_text_buffer_get_line_count)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_char_count_w, gxg_gtk_text_buffer_get_char_count)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_tag_table_w, gxg_gtk_text_buffer_get_tag_table)
Xen_wrap_3_args(gxg_gtk_text_buffer_set_text_w, gxg_gtk_text_buffer_set_text)
Xen_wrap_4_args(gxg_gtk_text_buffer_insert_w, gxg_gtk_text_buffer_insert)
Xen_wrap_3_args(gxg_gtk_text_buffer_insert_at_cursor_w, gxg_gtk_text_buffer_insert_at_cursor)
Xen_wrap_5_args(gxg_gtk_text_buffer_insert_interactive_w, gxg_gtk_text_buffer_insert_interactive)
Xen_wrap_4_args(gxg_gtk_text_buffer_insert_interactive_at_cursor_w, gxg_gtk_text_buffer_insert_interactive_at_cursor)
Xen_wrap_4_args(gxg_gtk_text_buffer_insert_range_w, gxg_gtk_text_buffer_insert_range)
Xen_wrap_5_args(gxg_gtk_text_buffer_insert_range_interactive_w, gxg_gtk_text_buffer_insert_range_interactive)
Xen_wrap_5_args(gxg_gtk_text_buffer_insert_with_tags_w, gxg_gtk_text_buffer_insert_with_tags)
Xen_wrap_5_args(gxg_gtk_text_buffer_insert_with_tags_by_name_w, gxg_gtk_text_buffer_insert_with_tags_by_name)
Xen_wrap_3_args(gxg_gtk_text_buffer_delete_w, gxg_gtk_text_buffer_delete)
Xen_wrap_4_args(gxg_gtk_text_buffer_delete_interactive_w, gxg_gtk_text_buffer_delete_interactive)
Xen_wrap_4_args(gxg_gtk_text_buffer_get_text_w, gxg_gtk_text_buffer_get_text)
Xen_wrap_4_args(gxg_gtk_text_buffer_get_slice_w, gxg_gtk_text_buffer_get_slice)
Xen_wrap_3_args(gxg_gtk_text_buffer_insert_child_anchor_w, gxg_gtk_text_buffer_insert_child_anchor)
Xen_wrap_2_args(gxg_gtk_text_buffer_create_child_anchor_w, gxg_gtk_text_buffer_create_child_anchor)
Xen_wrap_4_args(gxg_gtk_text_buffer_create_mark_w, gxg_gtk_text_buffer_create_mark)
Xen_wrap_3_args(gxg_gtk_text_buffer_move_mark_w, gxg_gtk_text_buffer_move_mark)
Xen_wrap_2_args(gxg_gtk_text_buffer_delete_mark_w, gxg_gtk_text_buffer_delete_mark)
Xen_wrap_2_args(gxg_gtk_text_buffer_get_mark_w, gxg_gtk_text_buffer_get_mark)
Xen_wrap_3_args(gxg_gtk_text_buffer_move_mark_by_name_w, gxg_gtk_text_buffer_move_mark_by_name)
Xen_wrap_2_args(gxg_gtk_text_buffer_delete_mark_by_name_w, gxg_gtk_text_buffer_delete_mark_by_name)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_insert_w, gxg_gtk_text_buffer_get_insert)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_selection_bound_w, gxg_gtk_text_buffer_get_selection_bound)
Xen_wrap_2_args(gxg_gtk_text_buffer_place_cursor_w, gxg_gtk_text_buffer_place_cursor)
Xen_wrap_4_args(gxg_gtk_text_buffer_apply_tag_w, gxg_gtk_text_buffer_apply_tag)
Xen_wrap_4_args(gxg_gtk_text_buffer_remove_tag_w, gxg_gtk_text_buffer_remove_tag)
Xen_wrap_4_args(gxg_gtk_text_buffer_apply_tag_by_name_w, gxg_gtk_text_buffer_apply_tag_by_name)
Xen_wrap_4_args(gxg_gtk_text_buffer_remove_tag_by_name_w, gxg_gtk_text_buffer_remove_tag_by_name)
Xen_wrap_3_args(gxg_gtk_text_buffer_remove_all_tags_w, gxg_gtk_text_buffer_remove_all_tags)
Xen_wrap_3_optional_args(gxg_gtk_text_buffer_create_tag_w, gxg_gtk_text_buffer_create_tag)
Xen_wrap_4_args(gxg_gtk_text_buffer_get_iter_at_line_offset_w, gxg_gtk_text_buffer_get_iter_at_line_offset)
Xen_wrap_4_args(gxg_gtk_text_buffer_get_iter_at_line_index_w, gxg_gtk_text_buffer_get_iter_at_line_index)
Xen_wrap_3_args(gxg_gtk_text_buffer_get_iter_at_offset_w, gxg_gtk_text_buffer_get_iter_at_offset)
Xen_wrap_3_args(gxg_gtk_text_buffer_get_iter_at_line_w, gxg_gtk_text_buffer_get_iter_at_line)
Xen_wrap_2_args(gxg_gtk_text_buffer_get_start_iter_w, gxg_gtk_text_buffer_get_start_iter)
Xen_wrap_2_args(gxg_gtk_text_buffer_get_end_iter_w, gxg_gtk_text_buffer_get_end_iter)
Xen_wrap_3_args(gxg_gtk_text_buffer_get_bounds_w, gxg_gtk_text_buffer_get_bounds)
Xen_wrap_3_args(gxg_gtk_text_buffer_get_iter_at_mark_w, gxg_gtk_text_buffer_get_iter_at_mark)
Xen_wrap_3_args(gxg_gtk_text_buffer_get_iter_at_child_anchor_w, gxg_gtk_text_buffer_get_iter_at_child_anchor)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_modified_w, gxg_gtk_text_buffer_get_modified)
Xen_wrap_2_args(gxg_gtk_text_buffer_set_modified_w, gxg_gtk_text_buffer_set_modified)
Xen_wrap_3_args(gxg_gtk_text_buffer_get_selection_bounds_w, gxg_gtk_text_buffer_get_selection_bounds)
Xen_wrap_3_args(gxg_gtk_text_buffer_delete_selection_w, gxg_gtk_text_buffer_delete_selection)
Xen_wrap_1_arg(gxg_gtk_text_buffer_begin_user_action_w, gxg_gtk_text_buffer_begin_user_action)
Xen_wrap_1_arg(gxg_gtk_text_buffer_end_user_action_w, gxg_gtk_text_buffer_end_user_action)
Xen_wrap_no_args(gxg_gtk_text_child_anchor_new_w, gxg_gtk_text_child_anchor_new)
Xen_wrap_1_arg(gxg_gtk_text_child_anchor_get_widgets_w, gxg_gtk_text_child_anchor_get_widgets)
Xen_wrap_1_arg(gxg_gtk_text_child_anchor_get_deleted_w, gxg_gtk_text_child_anchor_get_deleted)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_buffer_w, gxg_gtk_text_iter_get_buffer)
Xen_wrap_1_arg(gxg_gtk_text_iter_copy_w, gxg_gtk_text_iter_copy)
Xen_wrap_1_arg(gxg_gtk_text_iter_free_w, gxg_gtk_text_iter_free)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_offset_w, gxg_gtk_text_iter_get_offset)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_line_w, gxg_gtk_text_iter_get_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_line_offset_w, gxg_gtk_text_iter_get_line_offset)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_line_index_w, gxg_gtk_text_iter_get_line_index)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_visible_line_offset_w, gxg_gtk_text_iter_get_visible_line_offset)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_visible_line_index_w, gxg_gtk_text_iter_get_visible_line_index)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_char_w, gxg_gtk_text_iter_get_char)
Xen_wrap_2_args(gxg_gtk_text_iter_get_slice_w, gxg_gtk_text_iter_get_slice)
Xen_wrap_2_args(gxg_gtk_text_iter_get_text_w, gxg_gtk_text_iter_get_text)
Xen_wrap_2_args(gxg_gtk_text_iter_get_visible_slice_w, gxg_gtk_text_iter_get_visible_slice)
Xen_wrap_2_args(gxg_gtk_text_iter_get_visible_text_w, gxg_gtk_text_iter_get_visible_text)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_marks_w, gxg_gtk_text_iter_get_marks)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_child_anchor_w, gxg_gtk_text_iter_get_child_anchor)
Xen_wrap_2_args(gxg_gtk_text_iter_get_toggled_tags_w, gxg_gtk_text_iter_get_toggled_tags)
Xen_wrap_2_args(gxg_gtk_text_iter_ends_tag_w, gxg_gtk_text_iter_ends_tag)
Xen_wrap_2_args(gxg_gtk_text_iter_toggles_tag_w, gxg_gtk_text_iter_toggles_tag)
Xen_wrap_2_args(gxg_gtk_text_iter_has_tag_w, gxg_gtk_text_iter_has_tag)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_tags_w, gxg_gtk_text_iter_get_tags)
Xen_wrap_2_args(gxg_gtk_text_iter_editable_w, gxg_gtk_text_iter_editable)
Xen_wrap_2_args(gxg_gtk_text_iter_can_insert_w, gxg_gtk_text_iter_can_insert)
Xen_wrap_1_arg(gxg_gtk_text_iter_starts_word_w, gxg_gtk_text_iter_starts_word)
Xen_wrap_1_arg(gxg_gtk_text_iter_ends_word_w, gxg_gtk_text_iter_ends_word)
Xen_wrap_1_arg(gxg_gtk_text_iter_inside_word_w, gxg_gtk_text_iter_inside_word)
Xen_wrap_1_arg(gxg_gtk_text_iter_starts_sentence_w, gxg_gtk_text_iter_starts_sentence)
Xen_wrap_1_arg(gxg_gtk_text_iter_ends_sentence_w, gxg_gtk_text_iter_ends_sentence)
Xen_wrap_1_arg(gxg_gtk_text_iter_inside_sentence_w, gxg_gtk_text_iter_inside_sentence)
Xen_wrap_1_arg(gxg_gtk_text_iter_starts_line_w, gxg_gtk_text_iter_starts_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_ends_line_w, gxg_gtk_text_iter_ends_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_is_cursor_position_w, gxg_gtk_text_iter_is_cursor_position)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_chars_in_line_w, gxg_gtk_text_iter_get_chars_in_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_bytes_in_line_w, gxg_gtk_text_iter_get_bytes_in_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_language_w, gxg_gtk_text_iter_get_language)
Xen_wrap_1_arg(gxg_gtk_text_iter_is_end_w, gxg_gtk_text_iter_is_end)
Xen_wrap_1_arg(gxg_gtk_text_iter_is_start_w, gxg_gtk_text_iter_is_start)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_char_w, gxg_gtk_text_iter_forward_char)
Xen_wrap_1_arg(gxg_gtk_text_iter_backward_char_w, gxg_gtk_text_iter_backward_char)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_chars_w, gxg_gtk_text_iter_forward_chars)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_chars_w, gxg_gtk_text_iter_backward_chars)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_line_w, gxg_gtk_text_iter_forward_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_backward_line_w, gxg_gtk_text_iter_backward_line)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_lines_w, gxg_gtk_text_iter_forward_lines)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_lines_w, gxg_gtk_text_iter_backward_lines)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_word_end_w, gxg_gtk_text_iter_forward_word_end)
Xen_wrap_1_arg(gxg_gtk_text_iter_backward_word_start_w, gxg_gtk_text_iter_backward_word_start)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_word_ends_w, gxg_gtk_text_iter_forward_word_ends)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_word_starts_w, gxg_gtk_text_iter_backward_word_starts)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_sentence_end_w, gxg_gtk_text_iter_forward_sentence_end)
Xen_wrap_1_arg(gxg_gtk_text_iter_backward_sentence_start_w, gxg_gtk_text_iter_backward_sentence_start)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_sentence_ends_w, gxg_gtk_text_iter_forward_sentence_ends)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_sentence_starts_w, gxg_gtk_text_iter_backward_sentence_starts)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_cursor_position_w, gxg_gtk_text_iter_forward_cursor_position)
Xen_wrap_1_arg(gxg_gtk_text_iter_backward_cursor_position_w, gxg_gtk_text_iter_backward_cursor_position)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_cursor_positions_w, gxg_gtk_text_iter_forward_cursor_positions)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_cursor_positions_w, gxg_gtk_text_iter_backward_cursor_positions)
Xen_wrap_2_args(gxg_gtk_text_iter_set_offset_w, gxg_gtk_text_iter_set_offset)
Xen_wrap_2_args(gxg_gtk_text_iter_set_line_w, gxg_gtk_text_iter_set_line)
Xen_wrap_2_args(gxg_gtk_text_iter_set_line_offset_w, gxg_gtk_text_iter_set_line_offset)
Xen_wrap_2_args(gxg_gtk_text_iter_set_line_index_w, gxg_gtk_text_iter_set_line_index)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_to_end_w, gxg_gtk_text_iter_forward_to_end)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_to_line_end_w, gxg_gtk_text_iter_forward_to_line_end)
Xen_wrap_2_args(gxg_gtk_text_iter_set_visible_line_offset_w, gxg_gtk_text_iter_set_visible_line_offset)
Xen_wrap_2_args(gxg_gtk_text_iter_set_visible_line_index_w, gxg_gtk_text_iter_set_visible_line_index)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_to_tag_toggle_w, gxg_gtk_text_iter_forward_to_tag_toggle)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_to_tag_toggle_w, gxg_gtk_text_iter_backward_to_tag_toggle)
Xen_wrap_4_args(gxg_gtk_text_iter_forward_find_char_w, gxg_gtk_text_iter_forward_find_char)
Xen_wrap_4_args(gxg_gtk_text_iter_backward_find_char_w, gxg_gtk_text_iter_backward_find_char)
Xen_wrap_6_args(gxg_gtk_text_iter_forward_search_w, gxg_gtk_text_iter_forward_search)
Xen_wrap_6_args(gxg_gtk_text_iter_backward_search_w, gxg_gtk_text_iter_backward_search)
Xen_wrap_2_args(gxg_gtk_text_iter_equal_w, gxg_gtk_text_iter_equal)
Xen_wrap_2_args(gxg_gtk_text_iter_compare_w, gxg_gtk_text_iter_compare)
Xen_wrap_3_args(gxg_gtk_text_iter_in_range_w, gxg_gtk_text_iter_in_range)
Xen_wrap_2_args(gxg_gtk_text_iter_order_w, gxg_gtk_text_iter_order)
Xen_wrap_2_args(gxg_gtk_text_mark_set_visible_w, gxg_gtk_text_mark_set_visible)
Xen_wrap_1_arg(gxg_gtk_text_mark_get_visible_w, gxg_gtk_text_mark_get_visible)
Xen_wrap_1_arg(gxg_gtk_text_mark_get_name_w, gxg_gtk_text_mark_get_name)
Xen_wrap_1_arg(gxg_gtk_text_mark_get_deleted_w, gxg_gtk_text_mark_get_deleted)
Xen_wrap_1_arg(gxg_gtk_text_mark_get_buffer_w, gxg_gtk_text_mark_get_buffer)
Xen_wrap_1_arg(gxg_gtk_text_mark_get_left_gravity_w, gxg_gtk_text_mark_get_left_gravity)
Xen_wrap_1_arg(gxg_gtk_text_tag_new_w, gxg_gtk_text_tag_new)
Xen_wrap_1_arg(gxg_gtk_text_tag_get_priority_w, gxg_gtk_text_tag_get_priority)
Xen_wrap_2_args(gxg_gtk_text_tag_set_priority_w, gxg_gtk_text_tag_set_priority)
Xen_wrap_no_args(gxg_gtk_text_tag_table_new_w, gxg_gtk_text_tag_table_new)
Xen_wrap_2_args(gxg_gtk_text_tag_table_add_w, gxg_gtk_text_tag_table_add)
Xen_wrap_2_args(gxg_gtk_text_tag_table_remove_w, gxg_gtk_text_tag_table_remove)
Xen_wrap_2_args(gxg_gtk_text_tag_table_lookup_w, gxg_gtk_text_tag_table_lookup)
Xen_wrap_3_args(gxg_gtk_text_tag_table_foreach_w, gxg_gtk_text_tag_table_foreach)
Xen_wrap_1_arg(gxg_gtk_text_tag_table_get_size_w, gxg_gtk_text_tag_table_get_size)
Xen_wrap_no_args(gxg_gtk_text_view_new_w, gxg_gtk_text_view_new)
Xen_wrap_1_arg(gxg_gtk_text_view_new_with_buffer_w, gxg_gtk_text_view_new_with_buffer)
Xen_wrap_2_args(gxg_gtk_text_view_set_buffer_w, gxg_gtk_text_view_set_buffer)
Xen_wrap_1_arg(gxg_gtk_text_view_get_buffer_w, gxg_gtk_text_view_get_buffer)
Xen_wrap_6_args(gxg_gtk_text_view_scroll_to_iter_w, gxg_gtk_text_view_scroll_to_iter)
Xen_wrap_6_args(gxg_gtk_text_view_scroll_to_mark_w, gxg_gtk_text_view_scroll_to_mark)
Xen_wrap_2_args(gxg_gtk_text_view_scroll_mark_onscreen_w, gxg_gtk_text_view_scroll_mark_onscreen)
Xen_wrap_2_args(gxg_gtk_text_view_move_mark_onscreen_w, gxg_gtk_text_view_move_mark_onscreen)
Xen_wrap_1_arg(gxg_gtk_text_view_place_cursor_onscreen_w, gxg_gtk_text_view_place_cursor_onscreen)
Xen_wrap_2_args(gxg_gtk_text_view_get_visible_rect_w, gxg_gtk_text_view_get_visible_rect)
Xen_wrap_2_args(gxg_gtk_text_view_set_cursor_visible_w, gxg_gtk_text_view_set_cursor_visible)
Xen_wrap_1_arg(gxg_gtk_text_view_get_cursor_visible_w, gxg_gtk_text_view_get_cursor_visible)
Xen_wrap_3_args(gxg_gtk_text_view_get_iter_location_w, gxg_gtk_text_view_get_iter_location)
Xen_wrap_4_optional_args(gxg_gtk_text_view_get_line_yrange_w, gxg_gtk_text_view_get_line_yrange)
Xen_wrap_4_optional_args(gxg_gtk_text_view_get_line_at_y_w, gxg_gtk_text_view_get_line_at_y)
Xen_wrap_6_optional_args(gxg_gtk_text_view_buffer_to_window_coords_w, gxg_gtk_text_view_buffer_to_window_coords)
Xen_wrap_6_optional_args(gxg_gtk_text_view_window_to_buffer_coords_w, gxg_gtk_text_view_window_to_buffer_coords)
Xen_wrap_3_args(gxg_gtk_text_view_set_border_window_size_w, gxg_gtk_text_view_set_border_window_size)
Xen_wrap_2_args(gxg_gtk_text_view_get_border_window_size_w, gxg_gtk_text_view_get_border_window_size)
Xen_wrap_2_args(gxg_gtk_text_view_forward_display_line_w, gxg_gtk_text_view_forward_display_line)
Xen_wrap_2_args(gxg_gtk_text_view_backward_display_line_w, gxg_gtk_text_view_backward_display_line)
Xen_wrap_2_args(gxg_gtk_text_view_forward_display_line_end_w, gxg_gtk_text_view_forward_display_line_end)
Xen_wrap_2_args(gxg_gtk_text_view_backward_display_line_start_w, gxg_gtk_text_view_backward_display_line_start)
Xen_wrap_2_args(gxg_gtk_text_view_starts_display_line_w, gxg_gtk_text_view_starts_display_line)
Xen_wrap_3_args(gxg_gtk_text_view_move_visually_w, gxg_gtk_text_view_move_visually)
Xen_wrap_3_args(gxg_gtk_text_view_add_child_at_anchor_w, gxg_gtk_text_view_add_child_at_anchor)
Xen_wrap_5_args(gxg_gtk_text_view_add_child_in_window_w, gxg_gtk_text_view_add_child_in_window)
Xen_wrap_4_args(gxg_gtk_text_view_move_child_w, gxg_gtk_text_view_move_child)
Xen_wrap_2_args(gxg_gtk_text_view_set_wrap_mode_w, gxg_gtk_text_view_set_wrap_mode)
Xen_wrap_1_arg(gxg_gtk_text_view_get_wrap_mode_w, gxg_gtk_text_view_get_wrap_mode)
Xen_wrap_2_args(gxg_gtk_text_view_set_editable_w, gxg_gtk_text_view_set_editable)
Xen_wrap_1_arg(gxg_gtk_text_view_get_editable_w, gxg_gtk_text_view_get_editable)
Xen_wrap_2_args(gxg_gtk_text_view_set_pixels_above_lines_w, gxg_gtk_text_view_set_pixels_above_lines)
Xen_wrap_1_arg(gxg_gtk_text_view_get_pixels_above_lines_w, gxg_gtk_text_view_get_pixels_above_lines)
Xen_wrap_2_args(gxg_gtk_text_view_set_pixels_below_lines_w, gxg_gtk_text_view_set_pixels_below_lines)
Xen_wrap_1_arg(gxg_gtk_text_view_get_pixels_below_lines_w, gxg_gtk_text_view_get_pixels_below_lines)
Xen_wrap_2_args(gxg_gtk_text_view_set_pixels_inside_wrap_w, gxg_gtk_text_view_set_pixels_inside_wrap)
Xen_wrap_1_arg(gxg_gtk_text_view_get_pixels_inside_wrap_w, gxg_gtk_text_view_get_pixels_inside_wrap)
Xen_wrap_2_args(gxg_gtk_text_view_set_justification_w, gxg_gtk_text_view_set_justification)
Xen_wrap_1_arg(gxg_gtk_text_view_get_justification_w, gxg_gtk_text_view_get_justification)
Xen_wrap_2_args(gxg_gtk_text_view_set_left_margin_w, gxg_gtk_text_view_set_left_margin)
Xen_wrap_1_arg(gxg_gtk_text_view_get_left_margin_w, gxg_gtk_text_view_get_left_margin)
Xen_wrap_2_args(gxg_gtk_text_view_set_right_margin_w, gxg_gtk_text_view_set_right_margin)
Xen_wrap_1_arg(gxg_gtk_text_view_get_right_margin_w, gxg_gtk_text_view_get_right_margin)
Xen_wrap_2_args(gxg_gtk_text_view_set_indent_w, gxg_gtk_text_view_set_indent)
Xen_wrap_1_arg(gxg_gtk_text_view_get_indent_w, gxg_gtk_text_view_get_indent)
Xen_wrap_2_args(gxg_gtk_text_view_set_tabs_w, gxg_gtk_text_view_set_tabs)
Xen_wrap_1_arg(gxg_gtk_text_view_get_tabs_w, gxg_gtk_text_view_get_tabs)
Xen_wrap_no_args(gxg_gtk_toggle_button_new_w, gxg_gtk_toggle_button_new)
Xen_wrap_1_arg(gxg_gtk_toggle_button_new_with_label_w, gxg_gtk_toggle_button_new_with_label)
Xen_wrap_1_arg(gxg_gtk_toggle_button_new_with_mnemonic_w, gxg_gtk_toggle_button_new_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_toggle_button_set_active_w, gxg_gtk_toggle_button_set_active)
Xen_wrap_1_arg(gxg_gtk_toggle_button_get_active_w, gxg_gtk_toggle_button_get_active)
Xen_wrap_1_arg(gxg_gtk_toggle_button_toggled_w, gxg_gtk_toggle_button_toggled)
Xen_wrap_no_args(gxg_gtk_toolbar_new_w, gxg_gtk_toolbar_new)
Xen_wrap_2_args(gxg_gtk_toolbar_set_style_w, gxg_gtk_toolbar_set_style)
Xen_wrap_1_arg(gxg_gtk_toolbar_unset_style_w, gxg_gtk_toolbar_unset_style)
Xen_wrap_1_arg(gxg_gtk_toolbar_get_style_w, gxg_gtk_toolbar_get_style)
Xen_wrap_2_args(gxg_gtk_tree_drag_source_row_draggable_w, gxg_gtk_tree_drag_source_row_draggable)
Xen_wrap_2_args(gxg_gtk_tree_drag_source_drag_data_delete_w, gxg_gtk_tree_drag_source_drag_data_delete)
Xen_wrap_3_args(gxg_gtk_tree_drag_source_drag_data_get_w, gxg_gtk_tree_drag_source_drag_data_get)
Xen_wrap_3_args(gxg_gtk_tree_drag_dest_drag_data_received_w, gxg_gtk_tree_drag_dest_drag_data_received)
Xen_wrap_3_args(gxg_gtk_tree_drag_dest_row_drop_possible_w, gxg_gtk_tree_drag_dest_row_drop_possible)
Xen_wrap_3_args(gxg_gtk_tree_set_row_drag_data_w, gxg_gtk_tree_set_row_drag_data)
Xen_wrap_3_optional_args(gxg_gtk_tree_get_row_drag_data_w, gxg_gtk_tree_get_row_drag_data)
Xen_wrap_no_args(gxg_gtk_tree_path_new_w, gxg_gtk_tree_path_new)
Xen_wrap_1_arg(gxg_gtk_tree_path_new_from_string_w, gxg_gtk_tree_path_new_from_string)
Xen_wrap_1_arg(gxg_gtk_tree_path_to_string_w, gxg_gtk_tree_path_to_string)
Xen_wrap_no_args(gxg_gtk_tree_path_new_first_w, gxg_gtk_tree_path_new_first)
Xen_wrap_2_args(gxg_gtk_tree_path_append_index_w, gxg_gtk_tree_path_append_index)
Xen_wrap_2_args(gxg_gtk_tree_path_prepend_index_w, gxg_gtk_tree_path_prepend_index)
Xen_wrap_1_arg(gxg_gtk_tree_path_get_depth_w, gxg_gtk_tree_path_get_depth)
Xen_wrap_1_arg(gxg_gtk_tree_path_get_indices_w, gxg_gtk_tree_path_get_indices)
Xen_wrap_1_arg(gxg_gtk_tree_path_free_w, gxg_gtk_tree_path_free)
Xen_wrap_1_arg(gxg_gtk_tree_path_copy_w, gxg_gtk_tree_path_copy)
Xen_wrap_2_args(gxg_gtk_tree_path_compare_w, gxg_gtk_tree_path_compare)
Xen_wrap_1_arg(gxg_gtk_tree_path_next_w, gxg_gtk_tree_path_next)
Xen_wrap_1_arg(gxg_gtk_tree_path_prev_w, gxg_gtk_tree_path_prev)
Xen_wrap_1_arg(gxg_gtk_tree_path_up_w, gxg_gtk_tree_path_up)
Xen_wrap_1_arg(gxg_gtk_tree_path_down_w, gxg_gtk_tree_path_down)
Xen_wrap_2_args(gxg_gtk_tree_path_is_ancestor_w, gxg_gtk_tree_path_is_ancestor)
Xen_wrap_2_args(gxg_gtk_tree_path_is_descendant_w, gxg_gtk_tree_path_is_descendant)
Xen_wrap_2_args(gxg_gtk_tree_row_reference_new_w, gxg_gtk_tree_row_reference_new)
Xen_wrap_3_args(gxg_gtk_tree_row_reference_new_proxy_w, gxg_gtk_tree_row_reference_new_proxy)
Xen_wrap_1_arg(gxg_gtk_tree_row_reference_get_path_w, gxg_gtk_tree_row_reference_get_path)
Xen_wrap_1_arg(gxg_gtk_tree_row_reference_valid_w, gxg_gtk_tree_row_reference_valid)
Xen_wrap_1_arg(gxg_gtk_tree_row_reference_free_w, gxg_gtk_tree_row_reference_free)
Xen_wrap_2_args(gxg_gtk_tree_row_reference_inserted_w, gxg_gtk_tree_row_reference_inserted)
Xen_wrap_2_args(gxg_gtk_tree_row_reference_deleted_w, gxg_gtk_tree_row_reference_deleted)
Xen_wrap_4_args(gxg_gtk_tree_row_reference_reordered_w, gxg_gtk_tree_row_reference_reordered)
Xen_wrap_1_arg(gxg_gtk_tree_iter_copy_w, gxg_gtk_tree_iter_copy)
Xen_wrap_1_arg(gxg_gtk_tree_iter_free_w, gxg_gtk_tree_iter_free)
Xen_wrap_1_arg(gxg_gtk_tree_model_get_flags_w, gxg_gtk_tree_model_get_flags)
Xen_wrap_1_arg(gxg_gtk_tree_model_get_n_columns_w, gxg_gtk_tree_model_get_n_columns)
Xen_wrap_2_args(gxg_gtk_tree_model_get_column_type_w, gxg_gtk_tree_model_get_column_type)
Xen_wrap_3_args(gxg_gtk_tree_model_get_iter_w, gxg_gtk_tree_model_get_iter)
Xen_wrap_3_args(gxg_gtk_tree_model_get_iter_from_string_w, gxg_gtk_tree_model_get_iter_from_string)
Xen_wrap_2_args(gxg_gtk_tree_model_get_iter_first_w, gxg_gtk_tree_model_get_iter_first)
Xen_wrap_2_args(gxg_gtk_tree_model_get_path_w, gxg_gtk_tree_model_get_path)
Xen_wrap_2_args(gxg_gtk_tree_model_iter_next_w, gxg_gtk_tree_model_iter_next)
Xen_wrap_3_args(gxg_gtk_tree_model_iter_children_w, gxg_gtk_tree_model_iter_children)
Xen_wrap_2_args(gxg_gtk_tree_model_iter_has_child_w, gxg_gtk_tree_model_iter_has_child)
Xen_wrap_2_args(gxg_gtk_tree_model_iter_n_children_w, gxg_gtk_tree_model_iter_n_children)
Xen_wrap_4_args(gxg_gtk_tree_model_iter_nth_child_w, gxg_gtk_tree_model_iter_nth_child)
Xen_wrap_3_args(gxg_gtk_tree_model_iter_parent_w, gxg_gtk_tree_model_iter_parent)
Xen_wrap_2_args(gxg_gtk_tree_model_ref_node_w, gxg_gtk_tree_model_ref_node)
Xen_wrap_2_args(gxg_gtk_tree_model_unref_node_w, gxg_gtk_tree_model_unref_node)
Xen_wrap_3_args(gxg_gtk_tree_model_foreach_w, gxg_gtk_tree_model_foreach)
Xen_wrap_3_args(gxg_gtk_tree_model_row_changed_w, gxg_gtk_tree_model_row_changed)
Xen_wrap_3_args(gxg_gtk_tree_model_row_inserted_w, gxg_gtk_tree_model_row_inserted)
Xen_wrap_3_args(gxg_gtk_tree_model_row_has_child_toggled_w, gxg_gtk_tree_model_row_has_child_toggled)
Xen_wrap_2_args(gxg_gtk_tree_model_row_deleted_w, gxg_gtk_tree_model_row_deleted)
Xen_wrap_4_args(gxg_gtk_tree_model_rows_reordered_w, gxg_gtk_tree_model_rows_reordered)
Xen_wrap_1_arg(gxg_gtk_tree_model_sort_new_with_model_w, gxg_gtk_tree_model_sort_new_with_model)
Xen_wrap_1_arg(gxg_gtk_tree_model_sort_get_model_w, gxg_gtk_tree_model_sort_get_model)
Xen_wrap_2_args(gxg_gtk_tree_model_sort_convert_child_path_to_path_w, gxg_gtk_tree_model_sort_convert_child_path_to_path)
Xen_wrap_3_args(gxg_gtk_tree_model_sort_convert_child_iter_to_iter_w, gxg_gtk_tree_model_sort_convert_child_iter_to_iter)
Xen_wrap_2_args(gxg_gtk_tree_model_sort_convert_path_to_child_path_w, gxg_gtk_tree_model_sort_convert_path_to_child_path)
Xen_wrap_3_args(gxg_gtk_tree_model_sort_convert_iter_to_child_iter_w, gxg_gtk_tree_model_sort_convert_iter_to_child_iter)
Xen_wrap_1_arg(gxg_gtk_tree_model_sort_reset_default_sort_func_w, gxg_gtk_tree_model_sort_reset_default_sort_func)
Xen_wrap_1_arg(gxg_gtk_tree_model_sort_clear_cache_w, gxg_gtk_tree_model_sort_clear_cache)
Xen_wrap_2_args(gxg_gtk_tree_selection_set_mode_w, gxg_gtk_tree_selection_set_mode)
Xen_wrap_1_arg(gxg_gtk_tree_selection_get_mode_w, gxg_gtk_tree_selection_get_mode)
Xen_wrap_4_args(gxg_gtk_tree_selection_set_select_function_w, gxg_gtk_tree_selection_set_select_function)
Xen_wrap_1_arg(gxg_gtk_tree_selection_get_user_data_w, gxg_gtk_tree_selection_get_user_data)
Xen_wrap_1_arg(gxg_gtk_tree_selection_get_tree_view_w, gxg_gtk_tree_selection_get_tree_view)
Xen_wrap_3_args(gxg_gtk_tree_selection_get_selected_w, gxg_gtk_tree_selection_get_selected)
Xen_wrap_3_args(gxg_gtk_tree_selection_selected_foreach_w, gxg_gtk_tree_selection_selected_foreach)
Xen_wrap_2_args(gxg_gtk_tree_selection_select_path_w, gxg_gtk_tree_selection_select_path)
Xen_wrap_2_args(gxg_gtk_tree_selection_unselect_path_w, gxg_gtk_tree_selection_unselect_path)
Xen_wrap_2_args(gxg_gtk_tree_selection_select_iter_w, gxg_gtk_tree_selection_select_iter)
Xen_wrap_2_args(gxg_gtk_tree_selection_unselect_iter_w, gxg_gtk_tree_selection_unselect_iter)
Xen_wrap_2_args(gxg_gtk_tree_selection_path_is_selected_w, gxg_gtk_tree_selection_path_is_selected)
Xen_wrap_2_args(gxg_gtk_tree_selection_iter_is_selected_w, gxg_gtk_tree_selection_iter_is_selected)
Xen_wrap_1_arg(gxg_gtk_tree_selection_select_all_w, gxg_gtk_tree_selection_select_all)
Xen_wrap_1_arg(gxg_gtk_tree_selection_unselect_all_w, gxg_gtk_tree_selection_unselect_all)
Xen_wrap_3_args(gxg_gtk_tree_selection_select_range_w, gxg_gtk_tree_selection_select_range)
Xen_wrap_1_arg(gxg_gtk_tree_sortable_sort_column_changed_w, gxg_gtk_tree_sortable_sort_column_changed)
Xen_wrap_3_optional_args(gxg_gtk_tree_sortable_get_sort_column_id_w, gxg_gtk_tree_sortable_get_sort_column_id)
Xen_wrap_3_args(gxg_gtk_tree_sortable_set_sort_column_id_w, gxg_gtk_tree_sortable_set_sort_column_id)
Xen_wrap_5_args(gxg_gtk_tree_sortable_set_sort_func_w, gxg_gtk_tree_sortable_set_sort_func)
Xen_wrap_4_args(gxg_gtk_tree_sortable_set_default_sort_func_w, gxg_gtk_tree_sortable_set_default_sort_func)
Xen_wrap_1_arg(gxg_gtk_tree_sortable_has_default_sort_func_w, gxg_gtk_tree_sortable_has_default_sort_func)
Xen_wrap_2_args(gxg_gtk_tree_store_new_w, gxg_gtk_tree_store_new)
Xen_wrap_2_args(gxg_gtk_tree_store_newv_w, gxg_gtk_tree_store_newv)
Xen_wrap_3_args(gxg_gtk_tree_store_set_column_types_w, gxg_gtk_tree_store_set_column_types)
Xen_wrap_3_args(gxg_gtk_tree_store_set_w, gxg_gtk_tree_store_set)
Xen_wrap_2_args(gxg_gtk_tree_store_remove_w, gxg_gtk_tree_store_remove)
Xen_wrap_4_args(gxg_gtk_tree_store_insert_w, gxg_gtk_tree_store_insert)
Xen_wrap_4_args(gxg_gtk_tree_store_insert_before_w, gxg_gtk_tree_store_insert_before)
Xen_wrap_4_args(gxg_gtk_tree_store_insert_after_w, gxg_gtk_tree_store_insert_after)
Xen_wrap_3_args(gxg_gtk_tree_store_prepend_w, gxg_gtk_tree_store_prepend)
Xen_wrap_3_args(gxg_gtk_tree_store_append_w, gxg_gtk_tree_store_append)
Xen_wrap_3_args(gxg_gtk_tree_store_is_ancestor_w, gxg_gtk_tree_store_is_ancestor)
Xen_wrap_2_args(gxg_gtk_tree_store_iter_depth_w, gxg_gtk_tree_store_iter_depth)
Xen_wrap_1_arg(gxg_gtk_tree_store_clear_w, gxg_gtk_tree_store_clear)
Xen_wrap_no_args(gxg_gtk_tree_view_column_new_w, gxg_gtk_tree_view_column_new)
Xen_wrap_3_args(gxg_gtk_tree_view_column_new_with_attributes_w, gxg_gtk_tree_view_column_new_with_attributes)
Xen_wrap_3_args(gxg_gtk_tree_view_column_pack_start_w, gxg_gtk_tree_view_column_pack_start)
Xen_wrap_3_args(gxg_gtk_tree_view_column_pack_end_w, gxg_gtk_tree_view_column_pack_end)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_clear_w, gxg_gtk_tree_view_column_clear)
Xen_wrap_4_args(gxg_gtk_tree_view_column_add_attribute_w, gxg_gtk_tree_view_column_add_attribute)
Xen_wrap_3_args(gxg_gtk_tree_view_column_set_attributes_w, gxg_gtk_tree_view_column_set_attributes)
Xen_wrap_5_args(gxg_gtk_tree_view_column_set_cell_data_func_w, gxg_gtk_tree_view_column_set_cell_data_func)
Xen_wrap_2_args(gxg_gtk_tree_view_column_clear_attributes_w, gxg_gtk_tree_view_column_clear_attributes)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_spacing_w, gxg_gtk_tree_view_column_set_spacing)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_spacing_w, gxg_gtk_tree_view_column_get_spacing)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_visible_w, gxg_gtk_tree_view_column_set_visible)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_visible_w, gxg_gtk_tree_view_column_get_visible)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_resizable_w, gxg_gtk_tree_view_column_set_resizable)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_resizable_w, gxg_gtk_tree_view_column_get_resizable)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_sizing_w, gxg_gtk_tree_view_column_set_sizing)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_sizing_w, gxg_gtk_tree_view_column_get_sizing)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_width_w, gxg_gtk_tree_view_column_get_width)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_fixed_width_w, gxg_gtk_tree_view_column_get_fixed_width)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_fixed_width_w, gxg_gtk_tree_view_column_set_fixed_width)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_min_width_w, gxg_gtk_tree_view_column_set_min_width)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_min_width_w, gxg_gtk_tree_view_column_get_min_width)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_max_width_w, gxg_gtk_tree_view_column_set_max_width)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_max_width_w, gxg_gtk_tree_view_column_get_max_width)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_clicked_w, gxg_gtk_tree_view_column_clicked)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_title_w, gxg_gtk_tree_view_column_set_title)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_title_w, gxg_gtk_tree_view_column_get_title)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_clickable_w, gxg_gtk_tree_view_column_set_clickable)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_clickable_w, gxg_gtk_tree_view_column_get_clickable)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_widget_w, gxg_gtk_tree_view_column_set_widget)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_widget_w, gxg_gtk_tree_view_column_get_widget)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_alignment_w, gxg_gtk_tree_view_column_set_alignment)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_alignment_w, gxg_gtk_tree_view_column_get_alignment)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_reorderable_w, gxg_gtk_tree_view_column_set_reorderable)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_reorderable_w, gxg_gtk_tree_view_column_get_reorderable)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_sort_column_id_w, gxg_gtk_tree_view_column_set_sort_column_id)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_sort_column_id_w, gxg_gtk_tree_view_column_get_sort_column_id)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_sort_indicator_w, gxg_gtk_tree_view_column_set_sort_indicator)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_sort_indicator_w, gxg_gtk_tree_view_column_get_sort_indicator)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_sort_order_w, gxg_gtk_tree_view_column_set_sort_order)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_sort_order_w, gxg_gtk_tree_view_column_get_sort_order)
Xen_wrap_5_args(gxg_gtk_tree_view_column_cell_set_cell_data_w, gxg_gtk_tree_view_column_cell_set_cell_data)
Xen_wrap_6_optional_args(gxg_gtk_tree_view_column_cell_get_size_w, gxg_gtk_tree_view_column_cell_get_size)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_cell_is_visible_w, gxg_gtk_tree_view_column_cell_is_visible)
Xen_wrap_4_optional_args(gxg_gtk_tree_view_column_cell_get_position_w, gxg_gtk_tree_view_column_cell_get_position)
Xen_wrap_no_args(gxg_gtk_tree_view_new_w, gxg_gtk_tree_view_new)
Xen_wrap_1_arg(gxg_gtk_tree_view_new_with_model_w, gxg_gtk_tree_view_new_with_model)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_model_w, gxg_gtk_tree_view_get_model)
Xen_wrap_2_args(gxg_gtk_tree_view_set_model_w, gxg_gtk_tree_view_set_model)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_selection_w, gxg_gtk_tree_view_get_selection)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_headers_visible_w, gxg_gtk_tree_view_get_headers_visible)
Xen_wrap_2_args(gxg_gtk_tree_view_set_headers_visible_w, gxg_gtk_tree_view_set_headers_visible)
Xen_wrap_1_arg(gxg_gtk_tree_view_columns_autosize_w, gxg_gtk_tree_view_columns_autosize)
Xen_wrap_2_args(gxg_gtk_tree_view_set_headers_clickable_w, gxg_gtk_tree_view_set_headers_clickable)
Xen_wrap_2_args(gxg_gtk_tree_view_append_column_w, gxg_gtk_tree_view_append_column)
Xen_wrap_2_args(gxg_gtk_tree_view_remove_column_w, gxg_gtk_tree_view_remove_column)
Xen_wrap_3_args(gxg_gtk_tree_view_insert_column_w, gxg_gtk_tree_view_insert_column)
Xen_wrap_5_args(gxg_gtk_tree_view_insert_column_with_attributes_w, gxg_gtk_tree_view_insert_column_with_attributes)
Xen_wrap_7_args(gxg_gtk_tree_view_insert_column_with_data_func_w, gxg_gtk_tree_view_insert_column_with_data_func)
Xen_wrap_2_args(gxg_gtk_tree_view_get_column_w, gxg_gtk_tree_view_get_column)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_columns_w, gxg_gtk_tree_view_get_columns)
Xen_wrap_3_args(gxg_gtk_tree_view_move_column_after_w, gxg_gtk_tree_view_move_column_after)
Xen_wrap_2_args(gxg_gtk_tree_view_set_expander_column_w, gxg_gtk_tree_view_set_expander_column)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_expander_column_w, gxg_gtk_tree_view_get_expander_column)
Xen_wrap_4_args(gxg_gtk_tree_view_set_column_drag_function_w, gxg_gtk_tree_view_set_column_drag_function)
Xen_wrap_3_args(gxg_gtk_tree_view_scroll_to_point_w, gxg_gtk_tree_view_scroll_to_point)
Xen_wrap_6_args(gxg_gtk_tree_view_scroll_to_cell_w, gxg_gtk_tree_view_scroll_to_cell)
Xen_wrap_3_args(gxg_gtk_tree_view_row_activated_w, gxg_gtk_tree_view_row_activated)
Xen_wrap_1_arg(gxg_gtk_tree_view_expand_all_w, gxg_gtk_tree_view_expand_all)
Xen_wrap_1_arg(gxg_gtk_tree_view_collapse_all_w, gxg_gtk_tree_view_collapse_all)
Xen_wrap_3_args(gxg_gtk_tree_view_expand_row_w, gxg_gtk_tree_view_expand_row)
Xen_wrap_2_args(gxg_gtk_tree_view_collapse_row_w, gxg_gtk_tree_view_collapse_row)
Xen_wrap_3_args(gxg_gtk_tree_view_map_expanded_rows_w, gxg_gtk_tree_view_map_expanded_rows)
Xen_wrap_2_args(gxg_gtk_tree_view_row_expanded_w, gxg_gtk_tree_view_row_expanded)
Xen_wrap_2_args(gxg_gtk_tree_view_set_reorderable_w, gxg_gtk_tree_view_set_reorderable)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_reorderable_w, gxg_gtk_tree_view_get_reorderable)
Xen_wrap_4_args(gxg_gtk_tree_view_set_cursor_w, gxg_gtk_tree_view_set_cursor)
Xen_wrap_3_optional_args(gxg_gtk_tree_view_get_cursor_w, gxg_gtk_tree_view_get_cursor)
Xen_wrap_7_optional_args(gxg_gtk_tree_view_get_path_at_pos_w, gxg_gtk_tree_view_get_path_at_pos)
Xen_wrap_4_args(gxg_gtk_tree_view_get_cell_area_w, gxg_gtk_tree_view_get_cell_area)
Xen_wrap_4_args(gxg_gtk_tree_view_get_background_area_w, gxg_gtk_tree_view_get_background_area)
Xen_wrap_2_args(gxg_gtk_tree_view_get_visible_rect_w, gxg_gtk_tree_view_get_visible_rect)
Xen_wrap_1_arg(gxg_gtk_tree_view_unset_rows_drag_source_w, gxg_gtk_tree_view_unset_rows_drag_source)
Xen_wrap_1_arg(gxg_gtk_tree_view_unset_rows_drag_dest_w, gxg_gtk_tree_view_unset_rows_drag_dest)
Xen_wrap_3_args(gxg_gtk_tree_view_set_drag_dest_row_w, gxg_gtk_tree_view_set_drag_dest_row)
Xen_wrap_3_optional_args(gxg_gtk_tree_view_get_drag_dest_row_w, gxg_gtk_tree_view_get_drag_dest_row)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_get_dest_row_at_pos_w, gxg_gtk_tree_view_get_dest_row_at_pos)
Xen_wrap_2_args(gxg_gtk_tree_view_set_enable_search_w, gxg_gtk_tree_view_set_enable_search)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_enable_search_w, gxg_gtk_tree_view_get_enable_search)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_search_column_w, gxg_gtk_tree_view_get_search_column)
Xen_wrap_2_args(gxg_gtk_tree_view_set_search_column_w, gxg_gtk_tree_view_set_search_column)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_search_equal_func_w, gxg_gtk_tree_view_get_search_equal_func)
Xen_wrap_4_args(gxg_gtk_tree_view_set_search_equal_func_w, gxg_gtk_tree_view_set_search_equal_func)
Xen_wrap_2_args(gxg_gtk_viewport_new_w, gxg_gtk_viewport_new)
Xen_wrap_2_args(gxg_gtk_viewport_set_shadow_type_w, gxg_gtk_viewport_set_shadow_type)
Xen_wrap_1_arg(gxg_gtk_viewport_get_shadow_type_w, gxg_gtk_viewport_get_shadow_type)
Xen_wrap_1_arg(gxg_gtk_widget_destroy_w, gxg_gtk_widget_destroy)
Xen_wrap_2_optional_args(gxg_gtk_widget_destroyed_w, gxg_gtk_widget_destroyed)
Xen_wrap_1_arg(gxg_gtk_widget_unparent_w, gxg_gtk_widget_unparent)
Xen_wrap_1_arg(gxg_gtk_widget_show_w, gxg_gtk_widget_show)
Xen_wrap_1_arg(gxg_gtk_widget_show_now_w, gxg_gtk_widget_show_now)
Xen_wrap_1_arg(gxg_gtk_widget_hide_w, gxg_gtk_widget_hide)
Xen_wrap_1_arg(gxg_gtk_widget_map_w, gxg_gtk_widget_map)
Xen_wrap_1_arg(gxg_gtk_widget_unmap_w, gxg_gtk_widget_unmap)
Xen_wrap_1_arg(gxg_gtk_widget_realize_w, gxg_gtk_widget_realize)
Xen_wrap_1_arg(gxg_gtk_widget_unrealize_w, gxg_gtk_widget_unrealize)
Xen_wrap_1_arg(gxg_gtk_widget_queue_draw_w, gxg_gtk_widget_queue_draw)
Xen_wrap_5_args(gxg_gtk_widget_queue_draw_area_w, gxg_gtk_widget_queue_draw_area)
Xen_wrap_1_arg(gxg_gtk_widget_queue_resize_w, gxg_gtk_widget_queue_resize)
Xen_wrap_6_args(gxg_gtk_widget_add_accelerator_w, gxg_gtk_widget_add_accelerator)
Xen_wrap_4_args(gxg_gtk_widget_remove_accelerator_w, gxg_gtk_widget_remove_accelerator)
Xen_wrap_1_arg(gxg_gtk_widget_list_accel_closures_w, gxg_gtk_widget_list_accel_closures)
Xen_wrap_2_args(gxg_gtk_widget_mnemonic_activate_w, gxg_gtk_widget_mnemonic_activate)
Xen_wrap_2_args(gxg_gtk_widget_event_w, gxg_gtk_widget_event)
Xen_wrap_1_arg(gxg_gtk_widget_activate_w, gxg_gtk_widget_activate)
Xen_wrap_3_args(gxg_gtk_widget_intersect_w, gxg_gtk_widget_intersect)
Xen_wrap_1_arg(gxg_gtk_widget_freeze_child_notify_w, gxg_gtk_widget_freeze_child_notify)
Xen_wrap_2_args(gxg_gtk_widget_child_notify_w, gxg_gtk_widget_child_notify)
Xen_wrap_1_arg(gxg_gtk_widget_thaw_child_notify_w, gxg_gtk_widget_thaw_child_notify)
Xen_wrap_1_arg(gxg_gtk_widget_is_focus_w, gxg_gtk_widget_is_focus)
Xen_wrap_1_arg(gxg_gtk_widget_grab_focus_w, gxg_gtk_widget_grab_focus)
Xen_wrap_1_arg(gxg_gtk_widget_grab_default_w, gxg_gtk_widget_grab_default)
Xen_wrap_2_args(gxg_gtk_widget_set_name_w, gxg_gtk_widget_set_name)
Xen_wrap_1_arg(gxg_gtk_widget_get_name_w, gxg_gtk_widget_get_name)
Xen_wrap_2_args(gxg_gtk_widget_set_sensitive_w, gxg_gtk_widget_set_sensitive)
Xen_wrap_2_args(gxg_gtk_widget_set_parent_w, gxg_gtk_widget_set_parent)
Xen_wrap_2_args(gxg_gtk_widget_set_parent_window_w, gxg_gtk_widget_set_parent_window)
Xen_wrap_2_args(gxg_gtk_widget_set_child_visible_w, gxg_gtk_widget_set_child_visible)
Xen_wrap_3_args(gxg_gtk_widget_set_accel_path_w, gxg_gtk_widget_set_accel_path)
Xen_wrap_1_arg(gxg_gtk_widget_get_child_visible_w, gxg_gtk_widget_get_child_visible)
Xen_wrap_1_arg(gxg_gtk_widget_get_parent_w, gxg_gtk_widget_get_parent)
Xen_wrap_1_arg(gxg_gtk_widget_get_parent_window_w, gxg_gtk_widget_get_parent_window)
Xen_wrap_2_args(gxg_gtk_widget_child_focus_w, gxg_gtk_widget_child_focus)
Xen_wrap_3_args(gxg_gtk_widget_set_size_request_w, gxg_gtk_widget_set_size_request)
Xen_wrap_3_optional_args(gxg_gtk_widget_get_size_request_w, gxg_gtk_widget_get_size_request)
Xen_wrap_1_arg(gxg_gtk_widget_get_toplevel_w, gxg_gtk_widget_get_toplevel)
Xen_wrap_2_args(gxg_gtk_widget_get_ancestor_w, gxg_gtk_widget_get_ancestor)
Xen_wrap_1_arg(gxg_gtk_widget_get_settings_w, gxg_gtk_widget_get_settings)
Xen_wrap_1_arg(gxg_gtk_widget_get_accessible_w, gxg_gtk_widget_get_accessible)
Xen_wrap_2_args(gxg_gtk_widget_is_ancestor_w, gxg_gtk_widget_is_ancestor)
Xen_wrap_6_optional_args(gxg_gtk_widget_translate_coordinates_w, gxg_gtk_widget_translate_coordinates)
Xen_wrap_1_arg(gxg_gtk_widget_hide_on_delete_w, gxg_gtk_widget_hide_on_delete)
Xen_wrap_1_arg(gxg_gtk_widget_create_pango_context_w, gxg_gtk_widget_create_pango_context)
Xen_wrap_1_arg(gxg_gtk_widget_get_pango_context_w, gxg_gtk_widget_get_pango_context)
Xen_wrap_2_args(gxg_gtk_widget_create_pango_layout_w, gxg_gtk_widget_create_pango_layout)
Xen_wrap_2_args(gxg_gtk_widget_set_direction_w, gxg_gtk_widget_set_direction)
Xen_wrap_1_arg(gxg_gtk_widget_get_direction_w, gxg_gtk_widget_get_direction)
Xen_wrap_1_arg(gxg_gtk_widget_set_default_direction_w, gxg_gtk_widget_set_default_direction)
Xen_wrap_no_args(gxg_gtk_widget_get_default_direction_w, gxg_gtk_widget_get_default_direction)
Xen_wrap_2_args(gxg_gtk_widget_can_activate_accel_w, gxg_gtk_widget_can_activate_accel)
Xen_wrap_1_arg(gxg_gtk_window_is_active_w, gxg_gtk_window_is_active)
Xen_wrap_1_arg(gxg_gtk_window_new_w, gxg_gtk_window_new)
Xen_wrap_2_args(gxg_gtk_window_set_title_w, gxg_gtk_window_set_title)
Xen_wrap_1_arg(gxg_gtk_window_set_auto_startup_notification_w, gxg_gtk_window_set_auto_startup_notification)
Xen_wrap_1_arg(gxg_gtk_window_get_title_w, gxg_gtk_window_get_title)
Xen_wrap_2_args(gxg_gtk_window_set_role_w, gxg_gtk_window_set_role)
Xen_wrap_1_arg(gxg_gtk_window_get_role_w, gxg_gtk_window_get_role)
Xen_wrap_2_args(gxg_gtk_window_add_accel_group_w, gxg_gtk_window_add_accel_group)
Xen_wrap_2_args(gxg_gtk_window_remove_accel_group_w, gxg_gtk_window_remove_accel_group)
Xen_wrap_2_args(gxg_gtk_window_set_position_w, gxg_gtk_window_set_position)
Xen_wrap_1_arg(gxg_gtk_window_activate_focus_w, gxg_gtk_window_activate_focus)
Xen_wrap_2_args(gxg_gtk_window_set_focus_w, gxg_gtk_window_set_focus)
Xen_wrap_1_arg(gxg_gtk_window_get_focus_w, gxg_gtk_window_get_focus)
Xen_wrap_2_args(gxg_gtk_window_set_default_w, gxg_gtk_window_set_default)
Xen_wrap_1_arg(gxg_gtk_window_activate_default_w, gxg_gtk_window_activate_default)
Xen_wrap_2_args(gxg_gtk_window_set_transient_for_w, gxg_gtk_window_set_transient_for)
Xen_wrap_1_arg(gxg_gtk_window_get_transient_for_w, gxg_gtk_window_get_transient_for)
Xen_wrap_2_args(gxg_gtk_window_set_type_hint_w, gxg_gtk_window_set_type_hint)
Xen_wrap_1_arg(gxg_gtk_window_get_type_hint_w, gxg_gtk_window_get_type_hint)
Xen_wrap_2_args(gxg_gtk_window_set_destroy_with_parent_w, gxg_gtk_window_set_destroy_with_parent)
Xen_wrap_1_arg(gxg_gtk_window_get_destroy_with_parent_w, gxg_gtk_window_get_destroy_with_parent)
Xen_wrap_2_args(gxg_gtk_window_set_resizable_w, gxg_gtk_window_set_resizable)
Xen_wrap_1_arg(gxg_gtk_window_get_resizable_w, gxg_gtk_window_get_resizable)
Xen_wrap_2_args(gxg_gtk_window_set_gravity_w, gxg_gtk_window_set_gravity)
Xen_wrap_1_arg(gxg_gtk_window_get_gravity_w, gxg_gtk_window_get_gravity)
Xen_wrap_2_args(gxg_gtk_window_set_decorated_w, gxg_gtk_window_set_decorated)
Xen_wrap_1_arg(gxg_gtk_window_get_decorated_w, gxg_gtk_window_get_decorated)
Xen_wrap_2_args(gxg_gtk_window_set_icon_list_w, gxg_gtk_window_set_icon_list)
Xen_wrap_no_args(gxg_gtk_window_get_default_icon_list_w, gxg_gtk_window_get_default_icon_list)
Xen_wrap_2_args(gxg_gtk_window_set_modal_w, gxg_gtk_window_set_modal)
Xen_wrap_1_arg(gxg_gtk_window_get_modal_w, gxg_gtk_window_get_modal)
Xen_wrap_no_args(gxg_gtk_window_list_toplevels_w, gxg_gtk_window_list_toplevels)
Xen_wrap_3_args(gxg_gtk_window_add_mnemonic_w, gxg_gtk_window_add_mnemonic)
Xen_wrap_3_args(gxg_gtk_window_remove_mnemonic_w, gxg_gtk_window_remove_mnemonic)
Xen_wrap_3_args(gxg_gtk_window_mnemonic_activate_w, gxg_gtk_window_mnemonic_activate)
Xen_wrap_2_args(gxg_gtk_window_set_mnemonic_modifier_w, gxg_gtk_window_set_mnemonic_modifier)
Xen_wrap_1_arg(gxg_gtk_window_get_mnemonic_modifier_w, gxg_gtk_window_get_mnemonic_modifier)
Xen_wrap_1_arg(gxg_gtk_window_present_w, gxg_gtk_window_present)
Xen_wrap_1_arg(gxg_gtk_window_iconify_w, gxg_gtk_window_iconify)
Xen_wrap_1_arg(gxg_gtk_window_deiconify_w, gxg_gtk_window_deiconify)
Xen_wrap_1_arg(gxg_gtk_window_stick_w, gxg_gtk_window_stick)
Xen_wrap_1_arg(gxg_gtk_window_unstick_w, gxg_gtk_window_unstick)
Xen_wrap_1_arg(gxg_gtk_window_maximize_w, gxg_gtk_window_maximize)
Xen_wrap_1_arg(gxg_gtk_window_unmaximize_w, gxg_gtk_window_unmaximize)
Xen_wrap_6_args(gxg_gtk_window_begin_resize_drag_w, gxg_gtk_window_begin_resize_drag)
Xen_wrap_5_args(gxg_gtk_window_begin_move_drag_w, gxg_gtk_window_begin_move_drag)
Xen_wrap_3_args(gxg_gtk_window_set_default_size_w, gxg_gtk_window_set_default_size)
Xen_wrap_3_optional_args(gxg_gtk_window_get_default_size_w, gxg_gtk_window_get_default_size)
Xen_wrap_3_args(gxg_gtk_window_resize_w, gxg_gtk_window_resize)
Xen_wrap_3_optional_args(gxg_gtk_window_get_size_w, gxg_gtk_window_get_size)
Xen_wrap_3_args(gxg_gtk_window_move_w, gxg_gtk_window_move)
Xen_wrap_3_optional_args(gxg_gtk_window_get_position_w, gxg_gtk_window_get_position)
Xen_wrap_1_arg(gxg_pango_color_copy_w, gxg_pango_color_copy)
Xen_wrap_1_arg(gxg_pango_color_free_w, gxg_pango_color_free)
Xen_wrap_2_args(gxg_pango_color_parse_w, gxg_pango_color_parse)
Xen_wrap_1_arg(gxg_pango_attr_type_register_w, gxg_pango_attr_type_register)
Xen_wrap_1_arg(gxg_pango_attribute_copy_w, gxg_pango_attribute_copy)
Xen_wrap_1_arg(gxg_pango_attribute_destroy_w, gxg_pango_attribute_destroy)
Xen_wrap_2_args(gxg_pango_attribute_equal_w, gxg_pango_attribute_equal)
Xen_wrap_1_arg(gxg_pango_attr_language_new_w, gxg_pango_attr_language_new)
Xen_wrap_1_arg(gxg_pango_attr_family_new_w, gxg_pango_attr_family_new)
Xen_wrap_3_args(gxg_pango_attr_foreground_new_w, gxg_pango_attr_foreground_new)
Xen_wrap_3_args(gxg_pango_attr_background_new_w, gxg_pango_attr_background_new)
Xen_wrap_1_arg(gxg_pango_attr_size_new_w, gxg_pango_attr_size_new)
Xen_wrap_1_arg(gxg_pango_attr_style_new_w, gxg_pango_attr_style_new)
Xen_wrap_1_arg(gxg_pango_attr_weight_new_w, gxg_pango_attr_weight_new)
Xen_wrap_1_arg(gxg_pango_attr_variant_new_w, gxg_pango_attr_variant_new)
Xen_wrap_1_arg(gxg_pango_attr_stretch_new_w, gxg_pango_attr_stretch_new)
Xen_wrap_1_arg(gxg_pango_attr_font_desc_new_w, gxg_pango_attr_font_desc_new)
Xen_wrap_1_arg(gxg_pango_attr_underline_new_w, gxg_pango_attr_underline_new)
Xen_wrap_1_arg(gxg_pango_attr_strikethrough_new_w, gxg_pango_attr_strikethrough_new)
Xen_wrap_1_arg(gxg_pango_attr_rise_new_w, gxg_pango_attr_rise_new)
Xen_wrap_2_args(gxg_pango_attr_shape_new_w, gxg_pango_attr_shape_new)
Xen_wrap_1_arg(gxg_pango_attr_scale_new_w, gxg_pango_attr_scale_new)
Xen_wrap_no_args(gxg_pango_attr_list_new_w, gxg_pango_attr_list_new)
Xen_wrap_1_arg(gxg_pango_attr_list_unref_w, gxg_pango_attr_list_unref)
Xen_wrap_1_arg(gxg_pango_attr_list_copy_w, gxg_pango_attr_list_copy)
Xen_wrap_2_args(gxg_pango_attr_list_insert_w, gxg_pango_attr_list_insert)
Xen_wrap_2_args(gxg_pango_attr_list_insert_before_w, gxg_pango_attr_list_insert_before)
Xen_wrap_2_args(gxg_pango_attr_list_change_w, gxg_pango_attr_list_change)
Xen_wrap_4_args(gxg_pango_attr_list_splice_w, gxg_pango_attr_list_splice)
Xen_wrap_1_arg(gxg_pango_attr_list_get_iterator_w, gxg_pango_attr_list_get_iterator)
Xen_wrap_3_optional_args(gxg_pango_attr_iterator_range_w, gxg_pango_attr_iterator_range)
Xen_wrap_1_arg(gxg_pango_attr_iterator_next_w, gxg_pango_attr_iterator_next)
Xen_wrap_1_arg(gxg_pango_attr_iterator_copy_w, gxg_pango_attr_iterator_copy)
Xen_wrap_1_arg(gxg_pango_attr_iterator_destroy_w, gxg_pango_attr_iterator_destroy)
Xen_wrap_2_args(gxg_pango_attr_iterator_get_w, gxg_pango_attr_iterator_get)
Xen_wrap_4_optional_args(gxg_pango_attr_iterator_get_font_w, gxg_pango_attr_iterator_get_font)
Xen_wrap_7_optional_args(gxg_pango_parse_markup_w, gxg_pango_parse_markup)
Xen_wrap_5_args(gxg_pango_break_w, gxg_pango_break)
Xen_wrap_4_optional_args(gxg_pango_find_paragraph_boundary_w, gxg_pango_find_paragraph_boundary)
Xen_wrap_6_args(gxg_pango_get_log_attrs_w, gxg_pango_get_log_attrs)
Xen_wrap_3_optional_args(gxg_pango_context_list_families_w, gxg_pango_context_list_families)
Xen_wrap_2_args(gxg_pango_context_load_font_w, gxg_pango_context_load_font)
Xen_wrap_3_args(gxg_pango_context_load_fontset_w, gxg_pango_context_load_fontset)
Xen_wrap_3_args(gxg_pango_context_get_metrics_w, gxg_pango_context_get_metrics)
Xen_wrap_2_args(gxg_pango_context_set_font_description_w, gxg_pango_context_set_font_description)
Xen_wrap_1_arg(gxg_pango_context_get_font_description_w, gxg_pango_context_get_font_description)
Xen_wrap_1_arg(gxg_pango_context_get_language_w, gxg_pango_context_get_language)
Xen_wrap_2_args(gxg_pango_context_set_language_w, gxg_pango_context_set_language)
Xen_wrap_2_args(gxg_pango_context_set_base_dir_w, gxg_pango_context_set_base_dir)
Xen_wrap_1_arg(gxg_pango_context_get_base_dir_w, gxg_pango_context_get_base_dir)
Xen_wrap_6_args(gxg_pango_itemize_w, gxg_pango_itemize)
Xen_wrap_no_args(gxg_pango_coverage_new_w, gxg_pango_coverage_new)
Xen_wrap_1_arg(gxg_pango_coverage_ref_w, gxg_pango_coverage_ref)
Xen_wrap_1_arg(gxg_pango_coverage_unref_w, gxg_pango_coverage_unref)
Xen_wrap_1_arg(gxg_pango_coverage_copy_w, gxg_pango_coverage_copy)
Xen_wrap_2_args(gxg_pango_coverage_get_w, gxg_pango_coverage_get)
Xen_wrap_3_args(gxg_pango_coverage_set_w, gxg_pango_coverage_set)
Xen_wrap_2_args(gxg_pango_coverage_max_w, gxg_pango_coverage_max)
Xen_wrap_3_optional_args(gxg_pango_coverage_to_bytes_w, gxg_pango_coverage_to_bytes)
Xen_wrap_2_args(gxg_pango_coverage_from_bytes_w, gxg_pango_coverage_from_bytes)
Xen_wrap_no_args(gxg_pango_font_description_new_w, gxg_pango_font_description_new)
Xen_wrap_1_arg(gxg_pango_font_description_copy_w, gxg_pango_font_description_copy)
Xen_wrap_1_arg(gxg_pango_font_description_copy_static_w, gxg_pango_font_description_copy_static)
Xen_wrap_1_arg(gxg_pango_font_description_hash_w, gxg_pango_font_description_hash)
Xen_wrap_2_args(gxg_pango_font_description_equal_w, gxg_pango_font_description_equal)
Xen_wrap_1_arg(gxg_pango_font_description_free_w, gxg_pango_font_description_free)
Xen_wrap_2_args(gxg_pango_font_descriptions_free_w, gxg_pango_font_descriptions_free)
Xen_wrap_2_args(gxg_pango_font_description_set_family_w, gxg_pango_font_description_set_family)
Xen_wrap_2_args(gxg_pango_font_description_set_family_static_w, gxg_pango_font_description_set_family_static)
Xen_wrap_1_arg(gxg_pango_font_description_get_family_w, gxg_pango_font_description_get_family)
Xen_wrap_2_args(gxg_pango_font_description_set_style_w, gxg_pango_font_description_set_style)
Xen_wrap_1_arg(gxg_pango_font_description_get_style_w, gxg_pango_font_description_get_style)
Xen_wrap_2_args(gxg_pango_font_description_set_variant_w, gxg_pango_font_description_set_variant)
Xen_wrap_1_arg(gxg_pango_font_description_get_variant_w, gxg_pango_font_description_get_variant)
Xen_wrap_2_args(gxg_pango_font_description_set_weight_w, gxg_pango_font_description_set_weight)
Xen_wrap_1_arg(gxg_pango_font_description_get_weight_w, gxg_pango_font_description_get_weight)
Xen_wrap_2_args(gxg_pango_font_description_set_stretch_w, gxg_pango_font_description_set_stretch)
Xen_wrap_1_arg(gxg_pango_font_description_get_stretch_w, gxg_pango_font_description_get_stretch)
Xen_wrap_2_args(gxg_pango_font_description_set_size_w, gxg_pango_font_description_set_size)
Xen_wrap_1_arg(gxg_pango_font_description_get_size_w, gxg_pango_font_description_get_size)
Xen_wrap_1_arg(gxg_pango_font_description_get_set_fields_w, gxg_pango_font_description_get_set_fields)
Xen_wrap_2_args(gxg_pango_font_description_unset_fields_w, gxg_pango_font_description_unset_fields)
Xen_wrap_3_args(gxg_pango_font_description_merge_w, gxg_pango_font_description_merge)
Xen_wrap_3_args(gxg_pango_font_description_merge_static_w, gxg_pango_font_description_merge_static)
Xen_wrap_3_args(gxg_pango_font_description_better_match_w, gxg_pango_font_description_better_match)
Xen_wrap_1_arg(gxg_pango_font_description_from_string_w, gxg_pango_font_description_from_string)
Xen_wrap_1_arg(gxg_pango_font_description_to_string_w, gxg_pango_font_description_to_string)
Xen_wrap_1_arg(gxg_pango_font_description_to_filename_w, gxg_pango_font_description_to_filename)
Xen_wrap_1_arg(gxg_pango_font_metrics_ref_w, gxg_pango_font_metrics_ref)
Xen_wrap_1_arg(gxg_pango_font_metrics_unref_w, gxg_pango_font_metrics_unref)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_ascent_w, gxg_pango_font_metrics_get_ascent)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_descent_w, gxg_pango_font_metrics_get_descent)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_approximate_char_width_w, gxg_pango_font_metrics_get_approximate_char_width)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_approximate_digit_width_w, gxg_pango_font_metrics_get_approximate_digit_width)
Xen_wrap_3_optional_args(gxg_pango_font_family_list_faces_w, gxg_pango_font_family_list_faces)
Xen_wrap_1_arg(gxg_pango_font_family_get_name_w, gxg_pango_font_family_get_name)
Xen_wrap_1_arg(gxg_pango_font_face_describe_w, gxg_pango_font_face_describe)
Xen_wrap_1_arg(gxg_pango_font_face_get_face_name_w, gxg_pango_font_face_get_face_name)
Xen_wrap_1_arg(gxg_pango_font_describe_w, gxg_pango_font_describe)
Xen_wrap_2_args(gxg_pango_font_get_coverage_w, gxg_pango_font_get_coverage)
Xen_wrap_2_args(gxg_pango_font_get_metrics_w, gxg_pango_font_get_metrics)
Xen_wrap_4_args(gxg_pango_font_get_glyph_extents_w, gxg_pango_font_get_glyph_extents)
Xen_wrap_3_args(gxg_pango_font_map_load_font_w, gxg_pango_font_map_load_font)
Xen_wrap_4_args(gxg_pango_font_map_load_fontset_w, gxg_pango_font_map_load_fontset)
Xen_wrap_3_optional_args(gxg_pango_font_map_list_families_w, gxg_pango_font_map_list_families)
Xen_wrap_no_args(gxg_pango_glyph_string_new_w, gxg_pango_glyph_string_new)
Xen_wrap_2_args(gxg_pango_glyph_string_set_size_w, gxg_pango_glyph_string_set_size)
Xen_wrap_1_arg(gxg_pango_glyph_string_copy_w, gxg_pango_glyph_string_copy)
Xen_wrap_1_arg(gxg_pango_glyph_string_free_w, gxg_pango_glyph_string_free)
Xen_wrap_4_args(gxg_pango_glyph_string_extents_w, gxg_pango_glyph_string_extents)
Xen_wrap_6_args(gxg_pango_glyph_string_extents_range_w, gxg_pango_glyph_string_extents_range)
Xen_wrap_5_optional_args(gxg_pango_glyph_string_get_logical_widths_w, gxg_pango_glyph_string_get_logical_widths)
Xen_wrap_7_optional_args(gxg_pango_glyph_string_index_to_x_w, gxg_pango_glyph_string_index_to_x)
Xen_wrap_7_optional_args(gxg_pango_glyph_string_x_to_index_w, gxg_pango_glyph_string_x_to_index)
Xen_wrap_4_args(gxg_pango_shape_w, gxg_pango_shape)
Xen_wrap_1_arg(gxg_pango_reorder_items_w, gxg_pango_reorder_items)
Xen_wrap_no_args(gxg_pango_item_new_w, gxg_pango_item_new)
Xen_wrap_1_arg(gxg_pango_item_copy_w, gxg_pango_item_copy)
Xen_wrap_1_arg(gxg_pango_item_free_w, gxg_pango_item_free)
Xen_wrap_3_args(gxg_pango_item_split_w, gxg_pango_item_split)
Xen_wrap_1_arg(gxg_pango_layout_new_w, gxg_pango_layout_new)
Xen_wrap_1_arg(gxg_pango_layout_copy_w, gxg_pango_layout_copy)
Xen_wrap_1_arg(gxg_pango_layout_get_context_w, gxg_pango_layout_get_context)
Xen_wrap_2_args(gxg_pango_layout_set_attributes_w, gxg_pango_layout_set_attributes)
Xen_wrap_1_arg(gxg_pango_layout_get_attributes_w, gxg_pango_layout_get_attributes)
Xen_wrap_3_args(gxg_pango_layout_set_text_w, gxg_pango_layout_set_text)
Xen_wrap_1_arg(gxg_pango_layout_get_text_w, gxg_pango_layout_get_text)
Xen_wrap_3_args(gxg_pango_layout_set_markup_w, gxg_pango_layout_set_markup)
Xen_wrap_5_args(gxg_pango_layout_set_markup_with_accel_w, gxg_pango_layout_set_markup_with_accel)
Xen_wrap_2_args(gxg_pango_layout_set_font_description_w, gxg_pango_layout_set_font_description)
Xen_wrap_2_args(gxg_pango_layout_set_width_w, gxg_pango_layout_set_width)
Xen_wrap_1_arg(gxg_pango_layout_get_width_w, gxg_pango_layout_get_width)
Xen_wrap_2_args(gxg_pango_layout_set_wrap_w, gxg_pango_layout_set_wrap)
Xen_wrap_1_arg(gxg_pango_layout_get_wrap_w, gxg_pango_layout_get_wrap)
Xen_wrap_2_args(gxg_pango_layout_set_indent_w, gxg_pango_layout_set_indent)
Xen_wrap_1_arg(gxg_pango_layout_get_indent_w, gxg_pango_layout_get_indent)
Xen_wrap_2_args(gxg_pango_layout_set_spacing_w, gxg_pango_layout_set_spacing)
Xen_wrap_1_arg(gxg_pango_layout_get_spacing_w, gxg_pango_layout_get_spacing)
Xen_wrap_2_args(gxg_pango_layout_set_justify_w, gxg_pango_layout_set_justify)
Xen_wrap_1_arg(gxg_pango_layout_get_justify_w, gxg_pango_layout_get_justify)
Xen_wrap_2_args(gxg_pango_layout_set_alignment_w, gxg_pango_layout_set_alignment)
Xen_wrap_1_arg(gxg_pango_layout_get_alignment_w, gxg_pango_layout_get_alignment)
Xen_wrap_2_args(gxg_pango_layout_set_tabs_w, gxg_pango_layout_set_tabs)
Xen_wrap_1_arg(gxg_pango_layout_get_tabs_w, gxg_pango_layout_get_tabs)
Xen_wrap_2_args(gxg_pango_layout_set_single_paragraph_mode_w, gxg_pango_layout_set_single_paragraph_mode)
Xen_wrap_1_arg(gxg_pango_layout_get_single_paragraph_mode_w, gxg_pango_layout_get_single_paragraph_mode)
Xen_wrap_1_arg(gxg_pango_layout_context_changed_w, gxg_pango_layout_context_changed)
Xen_wrap_3_optional_args(gxg_pango_layout_get_log_attrs_w, gxg_pango_layout_get_log_attrs)
Xen_wrap_3_args(gxg_pango_layout_index_to_pos_w, gxg_pango_layout_index_to_pos)
Xen_wrap_4_args(gxg_pango_layout_get_cursor_pos_w, gxg_pango_layout_get_cursor_pos)
Xen_wrap_7_args(gxg_pango_layout_move_cursor_visually_w, gxg_pango_layout_move_cursor_visually)
Xen_wrap_5_optional_args(gxg_pango_layout_xy_to_index_w, gxg_pango_layout_xy_to_index)
Xen_wrap_3_args(gxg_pango_layout_get_extents_w, gxg_pango_layout_get_extents)
Xen_wrap_3_args(gxg_pango_layout_get_pixel_extents_w, gxg_pango_layout_get_pixel_extents)
Xen_wrap_3_optional_args(gxg_pango_layout_get_size_w, gxg_pango_layout_get_size)
Xen_wrap_3_optional_args(gxg_pango_layout_get_pixel_size_w, gxg_pango_layout_get_pixel_size)
Xen_wrap_1_arg(gxg_pango_layout_get_line_count_w, gxg_pango_layout_get_line_count)
Xen_wrap_2_args(gxg_pango_layout_get_line_w, gxg_pango_layout_get_line)
Xen_wrap_1_arg(gxg_pango_layout_get_lines_w, gxg_pango_layout_get_lines)
Xen_wrap_1_arg(gxg_pango_layout_line_unref_w, gxg_pango_layout_line_unref)
Xen_wrap_4_optional_args(gxg_pango_layout_line_x_to_index_w, gxg_pango_layout_line_x_to_index)
Xen_wrap_4_optional_args(gxg_pango_layout_line_index_to_x_w, gxg_pango_layout_line_index_to_x)
Xen_wrap_5_optional_args(gxg_pango_layout_line_get_x_ranges_w, gxg_pango_layout_line_get_x_ranges)
Xen_wrap_3_args(gxg_pango_layout_line_get_extents_w, gxg_pango_layout_line_get_extents)
Xen_wrap_3_args(gxg_pango_layout_line_get_pixel_extents_w, gxg_pango_layout_line_get_pixel_extents)
Xen_wrap_1_arg(gxg_pango_layout_get_iter_w, gxg_pango_layout_get_iter)
Xen_wrap_1_arg(gxg_pango_layout_iter_free_w, gxg_pango_layout_iter_free)
Xen_wrap_1_arg(gxg_pango_layout_iter_get_index_w, gxg_pango_layout_iter_get_index)
Xen_wrap_1_arg(gxg_pango_layout_iter_get_run_w, gxg_pango_layout_iter_get_run)
Xen_wrap_1_arg(gxg_pango_layout_iter_get_line_w, gxg_pango_layout_iter_get_line)
Xen_wrap_1_arg(gxg_pango_layout_iter_at_last_line_w, gxg_pango_layout_iter_at_last_line)
Xen_wrap_1_arg(gxg_pango_layout_iter_next_char_w, gxg_pango_layout_iter_next_char)
Xen_wrap_1_arg(gxg_pango_layout_iter_next_cluster_w, gxg_pango_layout_iter_next_cluster)
Xen_wrap_1_arg(gxg_pango_layout_iter_next_run_w, gxg_pango_layout_iter_next_run)
Xen_wrap_1_arg(gxg_pango_layout_iter_next_line_w, gxg_pango_layout_iter_next_line)
Xen_wrap_2_args(gxg_pango_layout_iter_get_char_extents_w, gxg_pango_layout_iter_get_char_extents)
Xen_wrap_3_args(gxg_pango_layout_iter_get_cluster_extents_w, gxg_pango_layout_iter_get_cluster_extents)
Xen_wrap_3_args(gxg_pango_layout_iter_get_run_extents_w, gxg_pango_layout_iter_get_run_extents)
Xen_wrap_3_args(gxg_pango_layout_iter_get_line_extents_w, gxg_pango_layout_iter_get_line_extents)
Xen_wrap_3_optional_args(gxg_pango_layout_iter_get_line_yrange_w, gxg_pango_layout_iter_get_line_yrange)
Xen_wrap_3_args(gxg_pango_layout_iter_get_layout_extents_w, gxg_pango_layout_iter_get_layout_extents)
Xen_wrap_1_arg(gxg_pango_layout_iter_get_baseline_w, gxg_pango_layout_iter_get_baseline)
Xen_wrap_1_arg(gxg_pango_language_from_string_w, gxg_pango_language_from_string)
Xen_wrap_2_args(gxg_pango_language_matches_w, gxg_pango_language_matches)
Xen_wrap_1_arg(gxg_G_OBJECT_TYPE_w, gxg_G_OBJECT_TYPE)
Xen_wrap_2_args(gxg_gtk_tree_model_get_string_from_iter_w, gxg_gtk_tree_model_get_string_from_iter)
Xen_wrap_2_args(gxg_gtk_tree_model_sort_iter_is_valid_w, gxg_gtk_tree_model_sort_iter_is_valid)
Xen_wrap_2_args(gxg_gtk_tree_view_expand_to_path_w, gxg_gtk_tree_view_expand_to_path)
Xen_wrap_2_args(gxg_gtk_tree_selection_get_selected_rows_w, gxg_gtk_tree_selection_get_selected_rows)
Xen_wrap_1_arg(gxg_gtk_tree_selection_count_selected_rows_w, gxg_gtk_tree_selection_count_selected_rows)
Xen_wrap_2_args(gxg_gtk_menu_shell_select_first_w, gxg_gtk_menu_shell_select_first)
Xen_wrap_1_arg(gxg_gtk_notebook_get_n_pages_w, gxg_gtk_notebook_get_n_pages)
Xen_wrap_2_args(gxg_gtk_list_store_reorder_w, gxg_gtk_list_store_reorder)
Xen_wrap_3_args(gxg_gtk_list_store_swap_w, gxg_gtk_list_store_swap)
Xen_wrap_3_args(gxg_gtk_list_store_move_after_w, gxg_gtk_list_store_move_after)
Xen_wrap_3_args(gxg_gtk_list_store_move_before_w, gxg_gtk_list_store_move_before)
Xen_wrap_3_args(gxg_gtk_tree_store_reorder_w, gxg_gtk_tree_store_reorder)
Xen_wrap_3_args(gxg_gtk_tree_store_swap_w, gxg_gtk_tree_store_swap)
Xen_wrap_1_arg(gxg_gdk_display_open_w, gxg_gdk_display_open)
Xen_wrap_1_arg(gxg_gdk_display_get_name_w, gxg_gdk_display_get_name)
Xen_wrap_1_arg(gxg_gdk_display_beep_w, gxg_gdk_display_beep)
Xen_wrap_1_arg(gxg_gdk_display_sync_w, gxg_gdk_display_sync)
Xen_wrap_1_arg(gxg_gdk_display_close_w, gxg_gdk_display_close)
Xen_wrap_1_arg(gxg_gdk_display_get_event_w, gxg_gdk_display_get_event)
Xen_wrap_1_arg(gxg_gdk_display_peek_event_w, gxg_gdk_display_peek_event)
Xen_wrap_2_args(gxg_gdk_display_put_event_w, gxg_gdk_display_put_event)
Xen_wrap_no_args(gxg_gdk_display_get_default_w, gxg_gdk_display_get_default)
Xen_wrap_1_arg(gxg_gtk_widget_get_display_w, gxg_gtk_widget_get_display)
Xen_wrap_1_arg(gxg_g_list_free_w, gxg_g_list_free)
Xen_wrap_1_arg(gxg_g_list_reverse_w, gxg_g_list_reverse)
Xen_wrap_1_arg(gxg_g_list_copy_w, gxg_g_list_copy)
Xen_wrap_1_arg(gxg_g_list_last_w, gxg_g_list_last)
Xen_wrap_1_arg(gxg_g_list_first_w, gxg_g_list_first)
Xen_wrap_1_arg(gxg_g_list_length_w, gxg_g_list_length)
Xen_wrap_1_arg(gxg_g_free_w, gxg_g_free)
Xen_wrap_2_args(gxg_g_list_remove_link_w, gxg_g_list_remove_link)
Xen_wrap_2_args(gxg_g_object_get_data_w, gxg_g_object_get_data)
Xen_wrap_3_args(gxg_g_object_set_data_w, gxg_g_object_set_data)
Xen_wrap_1_arg(gxg_gdk_display_flush_w, gxg_gdk_display_flush)
Xen_wrap_1_arg(gxg_gdk_display_supports_cursor_alpha_w, gxg_gdk_display_supports_cursor_alpha)
Xen_wrap_1_arg(gxg_gdk_display_supports_cursor_color_w, gxg_gdk_display_supports_cursor_color)
Xen_wrap_1_arg(gxg_gdk_display_get_default_cursor_size_w, gxg_gdk_display_get_default_cursor_size)
Xen_wrap_3_optional_args(gxg_gdk_display_get_maximal_cursor_size_w, gxg_gdk_display_get_maximal_cursor_size)
Xen_wrap_2_args(gxg_gdk_window_set_keep_above_w, gxg_gdk_window_set_keep_above)
Xen_wrap_2_args(gxg_gdk_window_set_keep_below_w, gxg_gdk_window_set_keep_below)
Xen_wrap_2_args(gxg_gtk_button_box_get_child_secondary_w, gxg_gtk_button_box_get_child_secondary)
Xen_wrap_2_args(gxg_gtk_calendar_set_display_options_w, gxg_gtk_calendar_set_display_options)
Xen_wrap_1_arg(gxg_gtk_calendar_get_display_options_w, gxg_gtk_calendar_get_display_options)
Xen_wrap_2_args(gxg_gtk_check_menu_item_set_draw_as_radio_w, gxg_gtk_check_menu_item_set_draw_as_radio)
Xen_wrap_1_arg(gxg_gtk_check_menu_item_get_draw_as_radio_w, gxg_gtk_check_menu_item_get_draw_as_radio)
Xen_wrap_2_args(gxg_gtk_entry_set_completion_w, gxg_gtk_entry_set_completion)
Xen_wrap_1_arg(gxg_gtk_entry_get_completion_w, gxg_gtk_entry_get_completion)
Xen_wrap_6_args(gxg_gtk_menu_attach_w, gxg_gtk_menu_attach)
Xen_wrap_3_args(gxg_gtk_text_buffer_select_range_w, gxg_gtk_text_buffer_select_range)
Xen_wrap_2_args(gxg_gtk_text_view_set_overwrite_w, gxg_gtk_text_view_set_overwrite)
Xen_wrap_1_arg(gxg_gtk_text_view_get_overwrite_w, gxg_gtk_text_view_get_overwrite)
Xen_wrap_2_args(gxg_gtk_text_view_set_accepts_tab_w, gxg_gtk_text_view_set_accepts_tab)
Xen_wrap_1_arg(gxg_gtk_text_view_get_accepts_tab_w, gxg_gtk_text_view_get_accepts_tab)
Xen_wrap_3_args(gxg_gtk_toolbar_insert_w, gxg_gtk_toolbar_insert)
Xen_wrap_2_args(gxg_gtk_toolbar_get_item_index_w, gxg_gtk_toolbar_get_item_index)
Xen_wrap_1_arg(gxg_gtk_toolbar_get_n_items_w, gxg_gtk_toolbar_get_n_items)
Xen_wrap_2_args(gxg_gtk_toolbar_get_nth_item_w, gxg_gtk_toolbar_get_nth_item)
Xen_wrap_2_args(gxg_gtk_toolbar_set_show_arrow_w, gxg_gtk_toolbar_set_show_arrow)
Xen_wrap_1_arg(gxg_gtk_toolbar_get_show_arrow_w, gxg_gtk_toolbar_get_show_arrow)
Xen_wrap_3_args(gxg_gtk_toolbar_get_drop_index_w, gxg_gtk_toolbar_get_drop_index)
Xen_wrap_2_args(gxg_gtk_tree_view_column_set_expand_w, gxg_gtk_tree_view_column_set_expand)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_expand_w, gxg_gtk_tree_view_column_get_expand)
Xen_wrap_1_arg(gxg_gtk_widget_queue_resize_no_redraw_w, gxg_gtk_widget_queue_resize_no_redraw)
Xen_wrap_2_args(gxg_gtk_window_set_keep_above_w, gxg_gtk_window_set_keep_above)
Xen_wrap_2_args(gxg_gtk_window_set_keep_below_w, gxg_gtk_window_set_keep_below)
Xen_wrap_4_optional_args(gxg_gtk_file_chooser_dialog_new_w, gxg_gtk_file_chooser_dialog_new)
Xen_wrap_1_arg(gxg_gtk_file_chooser_widget_new_w, gxg_gtk_file_chooser_widget_new)
Xen_wrap_2_args(gxg_gtk_tree_model_filter_new_w, gxg_gtk_tree_model_filter_new)
Xen_wrap_2_args(gxg_gtk_tree_model_filter_set_visible_column_w, gxg_gtk_tree_model_filter_set_visible_column)
Xen_wrap_1_arg(gxg_gtk_tree_model_filter_get_model_w, gxg_gtk_tree_model_filter_get_model)
Xen_wrap_3_args(gxg_gtk_tree_model_filter_convert_iter_to_child_iter_w, gxg_gtk_tree_model_filter_convert_iter_to_child_iter)
Xen_wrap_2_args(gxg_gtk_tree_model_filter_convert_child_path_to_path_w, gxg_gtk_tree_model_filter_convert_child_path_to_path)
Xen_wrap_2_args(gxg_gtk_tree_model_filter_convert_path_to_child_path_w, gxg_gtk_tree_model_filter_convert_path_to_child_path)
Xen_wrap_1_arg(gxg_gtk_tree_model_filter_refilter_w, gxg_gtk_tree_model_filter_refilter)
Xen_wrap_1_arg(gxg_gtk_tree_model_filter_clear_cache_w, gxg_gtk_tree_model_filter_clear_cache)
Xen_wrap_no_args(gxg_gtk_combo_box_new_w, gxg_gtk_combo_box_new)
Xen_wrap_1_arg(gxg_gtk_combo_box_new_with_model_w, gxg_gtk_combo_box_new_with_model)
Xen_wrap_2_args(gxg_gtk_combo_box_set_model_w, gxg_gtk_combo_box_set_model)
Xen_wrap_2_args(gxg_gtk_combo_box_set_wrap_width_w, gxg_gtk_combo_box_set_wrap_width)
Xen_wrap_2_args(gxg_gtk_combo_box_set_row_span_column_w, gxg_gtk_combo_box_set_row_span_column)
Xen_wrap_2_args(gxg_gtk_combo_box_set_column_span_column_w, gxg_gtk_combo_box_set_column_span_column)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_active_w, gxg_gtk_combo_box_get_active)
Xen_wrap_2_args(gxg_gtk_combo_box_set_active_w, gxg_gtk_combo_box_set_active)
Xen_wrap_2_args(gxg_gtk_combo_box_get_active_iter_w, gxg_gtk_combo_box_get_active_iter)
Xen_wrap_2_args(gxg_gtk_combo_box_set_active_iter_w, gxg_gtk_combo_box_set_active_iter)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_model_w, gxg_gtk_combo_box_get_model)
Xen_wrap_1_arg(gxg_gtk_expander_new_w, gxg_gtk_expander_new)
Xen_wrap_1_arg(gxg_gtk_expander_new_with_mnemonic_w, gxg_gtk_expander_new_with_mnemonic)
Xen_wrap_2_args(gxg_gtk_expander_set_expanded_w, gxg_gtk_expander_set_expanded)
Xen_wrap_1_arg(gxg_gtk_expander_get_expanded_w, gxg_gtk_expander_get_expanded)
Xen_wrap_2_args(gxg_gtk_expander_set_label_w, gxg_gtk_expander_set_label)
Xen_wrap_1_arg(gxg_gtk_expander_get_label_w, gxg_gtk_expander_get_label)
Xen_wrap_2_args(gxg_gtk_expander_set_use_underline_w, gxg_gtk_expander_set_use_underline)
Xen_wrap_1_arg(gxg_gtk_expander_get_use_underline_w, gxg_gtk_expander_get_use_underline)
Xen_wrap_2_args(gxg_gtk_expander_set_label_widget_w, gxg_gtk_expander_set_label_widget)
Xen_wrap_1_arg(gxg_gtk_expander_get_label_widget_w, gxg_gtk_expander_get_label_widget)
Xen_wrap_2_args(gxg_gtk_expander_set_use_markup_w, gxg_gtk_expander_set_use_markup)
Xen_wrap_1_arg(gxg_gtk_expander_get_use_markup_w, gxg_gtk_expander_get_use_markup)
Xen_wrap_no_args(gxg_gtk_font_button_new_w, gxg_gtk_font_button_new)
Xen_wrap_1_arg(gxg_gtk_font_button_new_with_font_w, gxg_gtk_font_button_new_with_font)
Xen_wrap_1_arg(gxg_gtk_font_button_get_title_w, gxg_gtk_font_button_get_title)
Xen_wrap_2_args(gxg_gtk_font_button_set_title_w, gxg_gtk_font_button_set_title)
Xen_wrap_1_arg(gxg_gtk_font_button_get_use_font_w, gxg_gtk_font_button_get_use_font)
Xen_wrap_2_args(gxg_gtk_font_button_set_use_font_w, gxg_gtk_font_button_set_use_font)
Xen_wrap_1_arg(gxg_gtk_font_button_get_use_size_w, gxg_gtk_font_button_get_use_size)
Xen_wrap_2_args(gxg_gtk_font_button_set_use_size_w, gxg_gtk_font_button_set_use_size)
Xen_wrap_1_arg(gxg_gtk_font_button_get_show_style_w, gxg_gtk_font_button_get_show_style)
Xen_wrap_2_args(gxg_gtk_font_button_set_show_style_w, gxg_gtk_font_button_set_show_style)
Xen_wrap_1_arg(gxg_gtk_font_button_get_show_size_w, gxg_gtk_font_button_get_show_size)
Xen_wrap_2_args(gxg_gtk_font_button_set_show_size_w, gxg_gtk_font_button_set_show_size)
Xen_wrap_no_args(gxg_gtk_entry_completion_new_w, gxg_gtk_entry_completion_new)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_entry_w, gxg_gtk_entry_completion_get_entry)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_model_w, gxg_gtk_entry_completion_set_model)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_model_w, gxg_gtk_entry_completion_get_model)
Xen_wrap_4_args(gxg_gtk_entry_completion_set_match_func_w, gxg_gtk_entry_completion_set_match_func)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_minimum_key_length_w, gxg_gtk_entry_completion_set_minimum_key_length)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_minimum_key_length_w, gxg_gtk_entry_completion_get_minimum_key_length)
Xen_wrap_1_arg(gxg_gtk_entry_completion_complete_w, gxg_gtk_entry_completion_complete)
Xen_wrap_3_args(gxg_gtk_entry_completion_insert_action_text_w, gxg_gtk_entry_completion_insert_action_text)
Xen_wrap_3_args(gxg_gtk_entry_completion_insert_action_markup_w, gxg_gtk_entry_completion_insert_action_markup)
Xen_wrap_2_args(gxg_gtk_entry_completion_delete_action_w, gxg_gtk_entry_completion_delete_action)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_text_column_w, gxg_gtk_entry_completion_set_text_column)
Xen_wrap_1_arg(gxg_gtk_radio_tool_button_new_w, gxg_gtk_radio_tool_button_new)
Xen_wrap_1_arg(gxg_gtk_radio_tool_button_new_from_widget_w, gxg_gtk_radio_tool_button_new_from_widget)
Xen_wrap_1_arg(gxg_gtk_radio_tool_button_get_group_w, gxg_gtk_radio_tool_button_get_group)
Xen_wrap_2_args(gxg_gtk_radio_tool_button_set_group_w, gxg_gtk_radio_tool_button_set_group)
Xen_wrap_no_args(gxg_gtk_separator_tool_item_new_w, gxg_gtk_separator_tool_item_new)
Xen_wrap_1_arg(gxg_gtk_separator_tool_item_get_draw_w, gxg_gtk_separator_tool_item_get_draw)
Xen_wrap_2_args(gxg_gtk_separator_tool_item_set_draw_w, gxg_gtk_separator_tool_item_set_draw)
Xen_wrap_no_args(gxg_gtk_toggle_tool_button_new_w, gxg_gtk_toggle_tool_button_new)
Xen_wrap_2_args(gxg_gtk_toggle_tool_button_set_active_w, gxg_gtk_toggle_tool_button_set_active)
Xen_wrap_1_arg(gxg_gtk_toggle_tool_button_get_active_w, gxg_gtk_toggle_tool_button_get_active)
Xen_wrap_5_args(gxg_g_timeout_add_full_w, gxg_g_timeout_add_full)
Xen_wrap_3_args(gxg_g_timeout_add_w, gxg_g_timeout_add)
Xen_wrap_2_args(gxg_g_idle_add_w, gxg_g_idle_add)
Xen_wrap_4_args(gxg_g_idle_add_full_w, gxg_g_idle_add_full)
Xen_wrap_1_arg(gxg_g_idle_remove_by_data_w, gxg_g_idle_remove_by_data)
Xen_wrap_1_arg(gxg_g_source_remove_w, gxg_g_source_remove)
Xen_wrap_no_args(gxg_gtk_file_filter_new_w, gxg_gtk_file_filter_new)
Xen_wrap_2_args(gxg_gtk_file_filter_set_name_w, gxg_gtk_file_filter_set_name)
Xen_wrap_1_arg(gxg_gtk_file_filter_get_name_w, gxg_gtk_file_filter_get_name)
Xen_wrap_2_args(gxg_gtk_file_filter_add_mime_type_w, gxg_gtk_file_filter_add_mime_type)
Xen_wrap_2_args(gxg_gtk_file_filter_add_pattern_w, gxg_gtk_file_filter_add_pattern)
Xen_wrap_5_args(gxg_gtk_file_filter_add_custom_w, gxg_gtk_file_filter_add_custom)
Xen_wrap_1_arg(gxg_gtk_file_filter_get_needed_w, gxg_gtk_file_filter_get_needed)
Xen_wrap_2_args(gxg_gtk_file_filter_filter_w, gxg_gtk_file_filter_filter)
Xen_wrap_3_args(gxg_gtk_cell_layout_pack_start_w, gxg_gtk_cell_layout_pack_start)
Xen_wrap_3_args(gxg_gtk_cell_layout_pack_end_w, gxg_gtk_cell_layout_pack_end)
Xen_wrap_1_arg(gxg_gtk_cell_layout_clear_w, gxg_gtk_cell_layout_clear)
Xen_wrap_3_args(gxg_gtk_cell_layout_set_attributes_w, gxg_gtk_cell_layout_set_attributes)
Xen_wrap_4_args(gxg_gtk_cell_layout_add_attribute_w, gxg_gtk_cell_layout_add_attribute)
Xen_wrap_5_args(gxg_gtk_cell_layout_set_cell_data_func_w, gxg_gtk_cell_layout_set_cell_data_func)
Xen_wrap_2_args(gxg_gtk_cell_layout_clear_attributes_w, gxg_gtk_cell_layout_clear_attributes)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_action_w, gxg_gtk_file_chooser_set_action)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_action_w, gxg_gtk_file_chooser_get_action)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_local_only_w, gxg_gtk_file_chooser_set_local_only)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_local_only_w, gxg_gtk_file_chooser_get_local_only)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_select_multiple_w, gxg_gtk_file_chooser_set_select_multiple)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_select_multiple_w, gxg_gtk_file_chooser_get_select_multiple)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_current_name_w, gxg_gtk_file_chooser_set_current_name)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_filename_w, gxg_gtk_file_chooser_get_filename)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_filename_w, gxg_gtk_file_chooser_set_filename)
Xen_wrap_2_args(gxg_gtk_file_chooser_select_filename_w, gxg_gtk_file_chooser_select_filename)
Xen_wrap_2_args(gxg_gtk_file_chooser_unselect_filename_w, gxg_gtk_file_chooser_unselect_filename)
Xen_wrap_1_arg(gxg_gtk_file_chooser_select_all_w, gxg_gtk_file_chooser_select_all)
Xen_wrap_1_arg(gxg_gtk_file_chooser_unselect_all_w, gxg_gtk_file_chooser_unselect_all)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_filenames_w, gxg_gtk_file_chooser_get_filenames)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_current_folder_w, gxg_gtk_file_chooser_set_current_folder)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_current_folder_w, gxg_gtk_file_chooser_get_current_folder)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_uri_w, gxg_gtk_file_chooser_get_uri)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_uri_w, gxg_gtk_file_chooser_set_uri)
Xen_wrap_2_args(gxg_gtk_file_chooser_select_uri_w, gxg_gtk_file_chooser_select_uri)
Xen_wrap_2_args(gxg_gtk_file_chooser_unselect_uri_w, gxg_gtk_file_chooser_unselect_uri)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_uris_w, gxg_gtk_file_chooser_get_uris)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_current_folder_uri_w, gxg_gtk_file_chooser_set_current_folder_uri)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_current_folder_uri_w, gxg_gtk_file_chooser_get_current_folder_uri)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_preview_widget_w, gxg_gtk_file_chooser_set_preview_widget)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_preview_widget_w, gxg_gtk_file_chooser_get_preview_widget)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_preview_widget_active_w, gxg_gtk_file_chooser_set_preview_widget_active)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_preview_widget_active_w, gxg_gtk_file_chooser_get_preview_widget_active)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_preview_filename_w, gxg_gtk_file_chooser_get_preview_filename)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_preview_uri_w, gxg_gtk_file_chooser_get_preview_uri)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_extra_widget_w, gxg_gtk_file_chooser_set_extra_widget)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_extra_widget_w, gxg_gtk_file_chooser_get_extra_widget)
Xen_wrap_2_args(gxg_gtk_file_chooser_add_filter_w, gxg_gtk_file_chooser_add_filter)
Xen_wrap_2_args(gxg_gtk_file_chooser_remove_filter_w, gxg_gtk_file_chooser_remove_filter)
Xen_wrap_1_arg(gxg_gtk_file_chooser_list_filters_w, gxg_gtk_file_chooser_list_filters)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_filter_w, gxg_gtk_file_chooser_set_filter)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_filter_w, gxg_gtk_file_chooser_get_filter)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_add_shortcut_folder_w, gxg_gtk_file_chooser_add_shortcut_folder)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_remove_shortcut_folder_w, gxg_gtk_file_chooser_remove_shortcut_folder)
Xen_wrap_1_arg(gxg_gtk_file_chooser_list_shortcut_folders_w, gxg_gtk_file_chooser_list_shortcut_folders)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_add_shortcut_folder_uri_w, gxg_gtk_file_chooser_add_shortcut_folder_uri)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_remove_shortcut_folder_uri_w, gxg_gtk_file_chooser_remove_shortcut_folder_uri)
Xen_wrap_1_arg(gxg_gtk_file_chooser_list_shortcut_folder_uris_w, gxg_gtk_file_chooser_list_shortcut_folder_uris)
Xen_wrap_no_args(gxg_gtk_icon_theme_new_w, gxg_gtk_icon_theme_new)
Xen_wrap_no_args(gxg_gtk_icon_theme_get_default_w, gxg_gtk_icon_theme_get_default)
Xen_wrap_3_optional_args(gxg_gtk_icon_theme_get_search_path_w, gxg_gtk_icon_theme_get_search_path)
Xen_wrap_2_args(gxg_gtk_icon_theme_append_search_path_w, gxg_gtk_icon_theme_append_search_path)
Xen_wrap_2_args(gxg_gtk_icon_theme_prepend_search_path_w, gxg_gtk_icon_theme_prepend_search_path)
Xen_wrap_2_args(gxg_gtk_icon_theme_set_custom_theme_w, gxg_gtk_icon_theme_set_custom_theme)
Xen_wrap_2_args(gxg_gtk_icon_theme_has_icon_w, gxg_gtk_icon_theme_has_icon)
Xen_wrap_4_args(gxg_gtk_icon_theme_lookup_icon_w, gxg_gtk_icon_theme_lookup_icon)
Xen_wrap_5_optional_args(gxg_gtk_icon_theme_load_icon_w, gxg_gtk_icon_theme_load_icon)
Xen_wrap_2_args(gxg_gtk_icon_theme_list_icons_w, gxg_gtk_icon_theme_list_icons)
Xen_wrap_1_arg(gxg_gtk_icon_theme_get_example_icon_name_w, gxg_gtk_icon_theme_get_example_icon_name)
Xen_wrap_1_arg(gxg_gtk_icon_theme_rescan_if_needed_w, gxg_gtk_icon_theme_rescan_if_needed)
Xen_wrap_1_arg(gxg_gtk_icon_info_get_base_size_w, gxg_gtk_icon_info_get_base_size)
Xen_wrap_1_arg(gxg_gtk_icon_info_get_filename_w, gxg_gtk_icon_info_get_filename)
Xen_wrap_2_optional_args(gxg_gtk_icon_info_load_icon_w, gxg_gtk_icon_info_load_icon)
Xen_wrap_2_args(gxg_gtk_tool_button_new_w, gxg_gtk_tool_button_new)
Xen_wrap_2_args(gxg_gtk_tool_button_set_label_w, gxg_gtk_tool_button_set_label)
Xen_wrap_1_arg(gxg_gtk_tool_button_get_label_w, gxg_gtk_tool_button_get_label)
Xen_wrap_2_args(gxg_gtk_tool_button_set_use_underline_w, gxg_gtk_tool_button_set_use_underline)
Xen_wrap_1_arg(gxg_gtk_tool_button_get_use_underline_w, gxg_gtk_tool_button_get_use_underline)
Xen_wrap_2_args(gxg_gtk_tool_button_set_icon_widget_w, gxg_gtk_tool_button_set_icon_widget)
Xen_wrap_1_arg(gxg_gtk_tool_button_get_icon_widget_w, gxg_gtk_tool_button_get_icon_widget)
Xen_wrap_2_args(gxg_gtk_tool_button_set_label_widget_w, gxg_gtk_tool_button_set_label_widget)
Xen_wrap_1_arg(gxg_gtk_tool_button_get_label_widget_w, gxg_gtk_tool_button_get_label_widget)
Xen_wrap_no_args(gxg_gtk_tool_item_new_w, gxg_gtk_tool_item_new)
Xen_wrap_2_args(gxg_gtk_tool_item_set_homogeneous_w, gxg_gtk_tool_item_set_homogeneous)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_homogeneous_w, gxg_gtk_tool_item_get_homogeneous)
Xen_wrap_2_args(gxg_gtk_tool_item_set_expand_w, gxg_gtk_tool_item_set_expand)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_expand_w, gxg_gtk_tool_item_get_expand)
Xen_wrap_2_args(gxg_gtk_tool_item_set_visible_horizontal_w, gxg_gtk_tool_item_set_visible_horizontal)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_visible_horizontal_w, gxg_gtk_tool_item_get_visible_horizontal)
Xen_wrap_2_args(gxg_gtk_tool_item_set_visible_vertical_w, gxg_gtk_tool_item_set_visible_vertical)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_visible_vertical_w, gxg_gtk_tool_item_get_visible_vertical)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_is_important_w, gxg_gtk_tool_item_get_is_important)
Xen_wrap_2_args(gxg_gtk_tool_item_set_is_important_w, gxg_gtk_tool_item_set_is_important)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_orientation_w, gxg_gtk_tool_item_get_orientation)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_toolbar_style_w, gxg_gtk_tool_item_get_toolbar_style)
Xen_wrap_1_arg(gxg_gtk_tool_item_retrieve_proxy_menu_item_w, gxg_gtk_tool_item_retrieve_proxy_menu_item)
Xen_wrap_2_args(gxg_gtk_tool_item_get_proxy_menu_item_w, gxg_gtk_tool_item_get_proxy_menu_item)
Xen_wrap_3_args(gxg_gtk_tool_item_set_proxy_menu_item_w, gxg_gtk_tool_item_set_proxy_menu_item)
Xen_wrap_2_args(gxg_gtk_list_store_remove_w, gxg_gtk_list_store_remove)
Xen_wrap_1_arg(gxg_gdk_display_get_default_group_w, gxg_gdk_display_get_default_group)
Xen_wrap_1_arg(gxg_gdk_window_get_group_w, gxg_gdk_window_get_group)
Xen_wrap_3_args(gxg_gtk_cell_layout_reorder_w, gxg_gtk_cell_layout_reorder)
Xen_wrap_1_arg(gxg_gtk_menu_shell_cancel_w, gxg_gtk_menu_shell_cancel)
Xen_wrap_1_arg(gxg_gtk_paned_get_child1_w, gxg_gtk_paned_get_child1)
Xen_wrap_1_arg(gxg_gtk_paned_get_child2_w, gxg_gtk_paned_get_child2)
Xen_wrap_2_args(gxg_gtk_window_set_accept_focus_w, gxg_gtk_window_set_accept_focus)
Xen_wrap_1_arg(gxg_gtk_window_get_accept_focus_w, gxg_gtk_window_get_accept_focus)
Xen_wrap_2_args(gxg_g_list_nth_data_w, gxg_g_list_nth_data)
Xen_wrap_no_args(gxg_gtk_accel_map_get_w, gxg_gtk_accel_map_get)
Xen_wrap_1_arg(gxg_gtk_combo_box_popup_w, gxg_gtk_combo_box_popup)
Xen_wrap_1_arg(gxg_gtk_combo_box_popdown_w, gxg_gtk_combo_box_popdown)
Xen_wrap_1_arg(gxg_gtk_radio_menu_item_new_from_widget_w, gxg_gtk_radio_menu_item_new_from_widget)
Xen_wrap_2_args(gxg_gtk_radio_menu_item_new_with_mnemonic_from_widget_w, gxg_gtk_radio_menu_item_new_with_mnemonic_from_widget)
Xen_wrap_2_args(gxg_gtk_radio_menu_item_new_with_label_from_widget_w, gxg_gtk_radio_menu_item_new_with_label_from_widget)
Xen_wrap_1_arg(gxg_gtk_scale_get_layout_w, gxg_gtk_scale_get_layout)
Xen_wrap_3_optional_args(gxg_gtk_scale_get_layout_offsets_w, gxg_gtk_scale_get_layout_offsets)
Xen_wrap_2_args(gxg_gtk_entry_set_alignment_w, gxg_gtk_entry_set_alignment)
Xen_wrap_1_arg(gxg_gtk_entry_get_alignment_w, gxg_gtk_entry_get_alignment)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_use_preview_label_w, gxg_gtk_file_chooser_set_use_preview_label)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_use_preview_label_w, gxg_gtk_file_chooser_get_use_preview_label)
Xen_wrap_1_arg(gxg_gtk_widget_list_mnemonic_labels_w, gxg_gtk_widget_list_mnemonic_labels)
Xen_wrap_2_args(gxg_gtk_widget_add_mnemonic_label_w, gxg_gtk_widget_add_mnemonic_label)
Xen_wrap_2_args(gxg_gtk_widget_remove_mnemonic_label_w, gxg_gtk_widget_remove_mnemonic_label)
Xen_wrap_2_args(gxg_gtk_window_activate_key_w, gxg_gtk_window_activate_key)
Xen_wrap_2_args(gxg_gtk_window_propagate_key_event_w, gxg_gtk_window_propagate_key_event)
Xen_wrap_1_arg(gxg_g_quark_from_string_w, gxg_g_quark_from_string)
Xen_wrap_1_arg(gxg_g_quark_to_string_w, gxg_g_quark_to_string)
Xen_wrap_no_args(gxg_gtk_cell_view_new_w, gxg_gtk_cell_view_new)
Xen_wrap_1_arg(gxg_gtk_cell_view_new_with_text_w, gxg_gtk_cell_view_new_with_text)
Xen_wrap_1_arg(gxg_gtk_cell_view_new_with_markup_w, gxg_gtk_cell_view_new_with_markup)
Xen_wrap_2_args(gxg_gtk_cell_view_set_model_w, gxg_gtk_cell_view_set_model)
Xen_wrap_2_args(gxg_gtk_cell_view_set_displayed_row_w, gxg_gtk_cell_view_set_displayed_row)
Xen_wrap_1_arg(gxg_gtk_cell_view_get_displayed_row_w, gxg_gtk_cell_view_get_displayed_row)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_wrap_width_w, gxg_gtk_combo_box_get_wrap_width)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_row_span_column_w, gxg_gtk_combo_box_get_row_span_column)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_column_span_column_w, gxg_gtk_combo_box_get_column_span_column)
Xen_wrap_1_arg(gxg_gtk_drag_dest_add_text_targets_w, gxg_gtk_drag_dest_add_text_targets)
Xen_wrap_1_arg(gxg_gtk_drag_source_add_text_targets_w, gxg_gtk_drag_source_add_text_targets)
Xen_wrap_1_arg(gxg_gtk_entry_completion_insert_prefix_w, gxg_gtk_entry_completion_insert_prefix)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_inline_completion_w, gxg_gtk_entry_completion_set_inline_completion)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_inline_completion_w, gxg_gtk_entry_completion_get_inline_completion)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_popup_completion_w, gxg_gtk_entry_completion_set_popup_completion)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_popup_completion_w, gxg_gtk_entry_completion_get_popup_completion)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_text_column_w, gxg_gtk_entry_completion_get_text_column)
Xen_wrap_2_args(gxg_gtk_icon_theme_get_icon_sizes_w, gxg_gtk_icon_theme_get_icon_sizes)
Xen_wrap_1_arg(gxg_gtk_menu_get_for_attach_widget_w, gxg_gtk_menu_get_for_attach_widget)
Xen_wrap_2_args(gxg_gtk_tree_view_set_fixed_height_mode_w, gxg_gtk_tree_view_set_fixed_height_mode)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_fixed_height_mode_w, gxg_gtk_tree_view_get_fixed_height_mode)
Xen_wrap_2_args(gxg_gtk_tree_view_set_hover_selection_w, gxg_gtk_tree_view_set_hover_selection)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_hover_selection_w, gxg_gtk_tree_view_get_hover_selection)
Xen_wrap_4_args(gxg_gtk_tree_view_set_row_separator_func_w, gxg_gtk_tree_view_set_row_separator_func)
Xen_wrap_2_args(gxg_gtk_window_set_focus_on_map_w, gxg_gtk_window_set_focus_on_map)
Xen_wrap_1_arg(gxg_gtk_window_get_focus_on_map_w, gxg_gtk_window_get_focus_on_map)
Xen_wrap_2_args(gxg_gtk_window_set_icon_name_w, gxg_gtk_window_set_icon_name)
Xen_wrap_1_arg(gxg_gtk_window_get_icon_name_w, gxg_gtk_window_get_icon_name)
Xen_wrap_1_arg(gxg_gtk_window_set_default_icon_name_w, gxg_gtk_window_set_default_icon_name)
Xen_wrap_no_args(gxg_gtk_about_dialog_new_w, gxg_gtk_about_dialog_new)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_version_w, gxg_gtk_about_dialog_get_version)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_version_w, gxg_gtk_about_dialog_set_version)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_copyright_w, gxg_gtk_about_dialog_get_copyright)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_copyright_w, gxg_gtk_about_dialog_set_copyright)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_comments_w, gxg_gtk_about_dialog_get_comments)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_comments_w, gxg_gtk_about_dialog_set_comments)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_website_w, gxg_gtk_about_dialog_get_website)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_website_w, gxg_gtk_about_dialog_set_website)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_website_label_w, gxg_gtk_about_dialog_get_website_label)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_website_label_w, gxg_gtk_about_dialog_set_website_label)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_authors_w, gxg_gtk_about_dialog_get_authors)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_authors_w, gxg_gtk_about_dialog_set_authors)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_documenters_w, gxg_gtk_about_dialog_get_documenters)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_documenters_w, gxg_gtk_about_dialog_set_documenters)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_artists_w, gxg_gtk_about_dialog_get_artists)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_artists_w, gxg_gtk_about_dialog_set_artists)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_translator_credits_w, gxg_gtk_about_dialog_get_translator_credits)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_translator_credits_w, gxg_gtk_about_dialog_set_translator_credits)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_program_name_w, gxg_gtk_about_dialog_get_program_name)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_program_name_w, gxg_gtk_about_dialog_set_program_name)
Xen_wrap_no_args(gxg_gtk_icon_view_new_w, gxg_gtk_icon_view_new)
Xen_wrap_1_arg(gxg_gtk_icon_view_new_with_model_w, gxg_gtk_icon_view_new_with_model)
Xen_wrap_2_args(gxg_gtk_icon_view_set_model_w, gxg_gtk_icon_view_set_model)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_model_w, gxg_gtk_icon_view_get_model)
Xen_wrap_2_args(gxg_gtk_icon_view_set_text_column_w, gxg_gtk_icon_view_set_text_column)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_text_column_w, gxg_gtk_icon_view_get_text_column)
Xen_wrap_2_args(gxg_gtk_icon_view_set_markup_column_w, gxg_gtk_icon_view_set_markup_column)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_markup_column_w, gxg_gtk_icon_view_get_markup_column)
Xen_wrap_2_args(gxg_gtk_icon_view_set_pixbuf_column_w, gxg_gtk_icon_view_set_pixbuf_column)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_pixbuf_column_w, gxg_gtk_icon_view_get_pixbuf_column)
Xen_wrap_3_args(gxg_gtk_icon_view_get_path_at_pos_w, gxg_gtk_icon_view_get_path_at_pos)
Xen_wrap_3_args(gxg_gtk_icon_view_selected_foreach_w, gxg_gtk_icon_view_selected_foreach)
Xen_wrap_2_args(gxg_gtk_icon_view_set_selection_mode_w, gxg_gtk_icon_view_set_selection_mode)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_selection_mode_w, gxg_gtk_icon_view_get_selection_mode)
Xen_wrap_2_args(gxg_gtk_icon_view_select_path_w, gxg_gtk_icon_view_select_path)
Xen_wrap_2_args(gxg_gtk_icon_view_unselect_path_w, gxg_gtk_icon_view_unselect_path)
Xen_wrap_2_args(gxg_gtk_icon_view_path_is_selected_w, gxg_gtk_icon_view_path_is_selected)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_selected_items_w, gxg_gtk_icon_view_get_selected_items)
Xen_wrap_1_arg(gxg_gtk_icon_view_select_all_w, gxg_gtk_icon_view_select_all)
Xen_wrap_1_arg(gxg_gtk_icon_view_unselect_all_w, gxg_gtk_icon_view_unselect_all)
Xen_wrap_2_args(gxg_gtk_icon_view_item_activated_w, gxg_gtk_icon_view_item_activated)
Xen_wrap_no_args(gxg_gtk_cell_renderer_combo_new_w, gxg_gtk_cell_renderer_combo_new)
Xen_wrap_no_args(gxg_gtk_cell_renderer_progress_new_w, gxg_gtk_cell_renderer_progress_new)
Xen_wrap_4_args(gxg_gtk_combo_box_set_row_separator_func_w, gxg_gtk_combo_box_set_row_separator_func)
Xen_wrap_2_args(gxg_gtk_label_set_ellipsize_w, gxg_gtk_label_set_ellipsize)
Xen_wrap_1_arg(gxg_gtk_label_get_ellipsize_w, gxg_gtk_label_get_ellipsize)
Xen_wrap_1_arg(gxg_pango_attr_fallback_new_w, gxg_pango_attr_fallback_new)
Xen_wrap_1_arg(gxg_pango_attr_letter_spacing_new_w, gxg_pango_attr_letter_spacing_new)
Xen_wrap_3_args(gxg_pango_attr_list_filter_w, gxg_pango_attr_list_filter)
Xen_wrap_1_arg(gxg_pango_attr_iterator_get_attrs_w, gxg_pango_attr_iterator_get_attrs)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_underline_position_w, gxg_pango_font_metrics_get_underline_position)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_underline_thickness_w, gxg_pango_font_metrics_get_underline_thickness)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_strikethrough_position_w, gxg_pango_font_metrics_get_strikethrough_position)
Xen_wrap_1_arg(gxg_pango_font_metrics_get_strikethrough_thickness_w, gxg_pango_font_metrics_get_strikethrough_thickness)
Xen_wrap_1_arg(gxg_pango_font_family_is_monospace_w, gxg_pango_font_family_is_monospace)
Xen_wrap_3_optional_args(gxg_pango_font_face_list_sizes_w, gxg_pango_font_face_list_sizes)
Xen_wrap_2_args(gxg_pango_layout_set_auto_dir_w, gxg_pango_layout_set_auto_dir)
Xen_wrap_1_arg(gxg_pango_layout_get_auto_dir_w, gxg_pango_layout_get_auto_dir)
Xen_wrap_1_arg(gxg_pango_script_for_unichar_w, gxg_pango_script_for_unichar)
Xen_wrap_2_args(gxg_pango_script_iter_new_w, gxg_pango_script_iter_new)
Xen_wrap_4_optional_args(gxg_pango_script_iter_get_range_w, gxg_pango_script_iter_get_range)
Xen_wrap_1_arg(gxg_pango_script_iter_next_w, gxg_pango_script_iter_next)
Xen_wrap_1_arg(gxg_pango_script_iter_free_w, gxg_pango_script_iter_free)
Xen_wrap_1_arg(gxg_gtk_file_chooser_button_new_with_dialog_w, gxg_gtk_file_chooser_button_new_with_dialog)
Xen_wrap_1_arg(gxg_gtk_file_chooser_button_get_title_w, gxg_gtk_file_chooser_button_get_title)
Xen_wrap_2_args(gxg_gtk_file_chooser_button_set_title_w, gxg_gtk_file_chooser_button_set_title)
Xen_wrap_1_arg(gxg_gdk_drag_drop_succeeded_w, gxg_gdk_drag_drop_succeeded)
Xen_wrap_2_args(gxg_gtk_entry_layout_index_to_text_index_w, gxg_gtk_entry_layout_index_to_text_index)
Xen_wrap_2_args(gxg_gtk_entry_text_index_to_layout_index_w, gxg_gtk_entry_text_index_to_layout_index)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_show_hidden_w, gxg_gtk_file_chooser_set_show_hidden)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_show_hidden_w, gxg_gtk_file_chooser_get_show_hidden)
Xen_wrap_2_args(gxg_gtk_tree_view_set_hover_expand_w, gxg_gtk_tree_view_set_hover_expand)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_hover_expand_w, gxg_gtk_tree_view_get_hover_expand)
Xen_wrap_1_arg(gxg_gtk_tool_item_rebuild_menu_w, gxg_gtk_tool_item_rebuild_menu)
Xen_wrap_2_args(gxg_gtk_menu_tool_button_new_w, gxg_gtk_menu_tool_button_new)
Xen_wrap_2_args(gxg_gtk_menu_tool_button_set_menu_w, gxg_gtk_menu_tool_button_set_menu)
Xen_wrap_1_arg(gxg_gtk_menu_tool_button_get_menu_w, gxg_gtk_menu_tool_button_get_menu)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_logo_icon_name_w, gxg_gtk_about_dialog_get_logo_icon_name)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_logo_icon_name_w, gxg_gtk_about_dialog_set_logo_icon_name)
Xen_wrap_2_args(gxg_gtk_accelerator_get_label_w, gxg_gtk_accelerator_get_label)
Xen_wrap_1_arg(gxg_gtk_drag_dest_add_image_targets_w, gxg_gtk_drag_dest_add_image_targets)
Xen_wrap_1_arg(gxg_gtk_drag_dest_add_uri_targets_w, gxg_gtk_drag_dest_add_uri_targets)
Xen_wrap_1_arg(gxg_gtk_drag_source_add_image_targets_w, gxg_gtk_drag_source_add_image_targets)
Xen_wrap_1_arg(gxg_gtk_drag_source_add_uri_targets_w, gxg_gtk_drag_source_add_uri_targets)
Xen_wrap_1_arg(gxg_gtk_file_chooser_button_get_width_chars_w, gxg_gtk_file_chooser_button_get_width_chars)
Xen_wrap_2_args(gxg_gtk_file_chooser_button_set_width_chars_w, gxg_gtk_file_chooser_button_set_width_chars)
Xen_wrap_2_args(gxg_gtk_image_set_pixel_size_w, gxg_gtk_image_set_pixel_size)
Xen_wrap_1_arg(gxg_gtk_image_get_pixel_size_w, gxg_gtk_image_get_pixel_size)
Xen_wrap_2_args(gxg_gtk_label_set_width_chars_w, gxg_gtk_label_set_width_chars)
Xen_wrap_1_arg(gxg_gtk_label_get_width_chars_w, gxg_gtk_label_get_width_chars)
Xen_wrap_4_args(gxg_gtk_text_buffer_backspace_w, gxg_gtk_text_buffer_backspace)
Xen_wrap_1_arg(gxg_gtk_file_filter_add_pixbuf_formats_w, gxg_gtk_file_filter_add_pixbuf_formats)
Xen_wrap_2_args(gxg_gtk_label_set_single_line_mode_w, gxg_gtk_label_set_single_line_mode)
Xen_wrap_1_arg(gxg_gtk_label_get_single_line_mode_w, gxg_gtk_label_get_single_line_mode)
Xen_wrap_2_args(gxg_gtk_progress_bar_set_ellipsize_w, gxg_gtk_progress_bar_set_ellipsize)
Xen_wrap_1_arg(gxg_gtk_progress_bar_get_ellipsize_w, gxg_gtk_progress_bar_get_ellipsize)
Xen_wrap_2_args(gxg_gtk_selection_data_targets_include_image_w, gxg_gtk_selection_data_targets_include_image)
Xen_wrap_3_args(gxg_pango_attr_underline_color_new_w, gxg_pango_attr_underline_color_new)
Xen_wrap_3_args(gxg_pango_attr_strikethrough_color_new_w, gxg_pango_attr_strikethrough_color_new)
Xen_wrap_4_args(gxg_pango_renderer_draw_layout_w, gxg_pango_renderer_draw_layout)
Xen_wrap_4_args(gxg_pango_renderer_draw_layout_line_w, gxg_pango_renderer_draw_layout_line)
Xen_wrap_5_args(gxg_pango_renderer_draw_glyphs_w, gxg_pango_renderer_draw_glyphs)
Xen_wrap_6_args(gxg_pango_renderer_draw_rectangle_w, gxg_pango_renderer_draw_rectangle)
Xen_wrap_5_args(gxg_pango_renderer_draw_error_underline_w, gxg_pango_renderer_draw_error_underline)
Xen_wrap_any_args(gxg_pango_renderer_draw_trapezoid_w, gxg_pango_renderer_draw_trapezoid)
Xen_wrap_5_args(gxg_pango_renderer_draw_glyph_w, gxg_pango_renderer_draw_glyph)
Xen_wrap_1_arg(gxg_pango_renderer_activate_w, gxg_pango_renderer_activate)
Xen_wrap_1_arg(gxg_pango_renderer_deactivate_w, gxg_pango_renderer_deactivate)
Xen_wrap_2_args(gxg_pango_renderer_part_changed_w, gxg_pango_renderer_part_changed)
Xen_wrap_3_args(gxg_pango_renderer_set_color_w, gxg_pango_renderer_set_color)
Xen_wrap_2_args(gxg_pango_renderer_get_color_w, gxg_pango_renderer_get_color)
Xen_wrap_2_args(gxg_pango_renderer_set_matrix_w, gxg_pango_renderer_set_matrix)
Xen_wrap_4_args(gxg_g_log_set_handler_w, gxg_g_log_set_handler)
Xen_wrap_2_args(gxg_g_log_remove_handler_w, gxg_g_log_remove_handler)
Xen_wrap_2_args(gxg_gtk_cell_renderer_stop_editing_w, gxg_gtk_cell_renderer_stop_editing)
Xen_wrap_2_args(gxg_gtk_file_chooser_button_new_w, gxg_gtk_file_chooser_button_new)
Xen_wrap_2_args(gxg_gtk_icon_view_set_columns_w, gxg_gtk_icon_view_set_columns)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_columns_w, gxg_gtk_icon_view_get_columns)
Xen_wrap_2_args(gxg_gtk_icon_view_set_item_width_w, gxg_gtk_icon_view_set_item_width)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_item_width_w, gxg_gtk_icon_view_get_item_width)
Xen_wrap_2_args(gxg_gtk_icon_view_set_spacing_w, gxg_gtk_icon_view_set_spacing)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_spacing_w, gxg_gtk_icon_view_get_spacing)
Xen_wrap_2_args(gxg_gtk_icon_view_set_row_spacing_w, gxg_gtk_icon_view_set_row_spacing)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_row_spacing_w, gxg_gtk_icon_view_get_row_spacing)
Xen_wrap_2_args(gxg_gtk_icon_view_set_column_spacing_w, gxg_gtk_icon_view_set_column_spacing)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_column_spacing_w, gxg_gtk_icon_view_get_column_spacing)
Xen_wrap_2_args(gxg_gtk_icon_view_set_margin_w, gxg_gtk_icon_view_set_margin)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_margin_w, gxg_gtk_icon_view_get_margin)
Xen_wrap_2_args(gxg_gtk_label_set_max_width_chars_w, gxg_gtk_label_set_max_width_chars)
Xen_wrap_1_arg(gxg_gtk_label_get_max_width_chars_w, gxg_gtk_label_get_max_width_chars)
Xen_wrap_3_args(gxg_gtk_list_store_insert_with_values_w, gxg_gtk_list_store_insert_with_values)
Xen_wrap_6_args(gxg_gtk_list_store_insert_with_valuesv_w, gxg_gtk_list_store_insert_with_valuesv)
Xen_wrap_1_arg(gxg_pango_attr_size_new_absolute_w, gxg_pango_attr_size_new_absolute)
Xen_wrap_2_args(gxg_pango_font_description_set_absolute_size_w, gxg_pango_font_description_set_absolute_size)
Xen_wrap_1_arg(gxg_pango_layout_get_font_description_w, gxg_pango_layout_get_font_description)
Xen_wrap_2_args(gxg_gdk_window_set_urgency_hint_w, gxg_gdk_window_set_urgency_hint)
Xen_wrap_2_args(gxg_gtk_dialog_get_response_for_widget_w, gxg_gtk_dialog_get_response_for_widget)
Xen_wrap_2_args(gxg_gtk_drag_source_set_icon_name_w, gxg_gtk_drag_source_set_icon_name)
Xen_wrap_4_args(gxg_gtk_drag_set_icon_name_w, gxg_gtk_drag_set_icon_name)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_popup_set_width_w, gxg_gtk_entry_completion_set_popup_set_width)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_popup_set_width_w, gxg_gtk_entry_completion_get_popup_set_width)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_popup_single_match_w, gxg_gtk_entry_completion_set_popup_single_match)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_popup_single_match_w, gxg_gtk_entry_completion_get_popup_single_match)
Xen_wrap_5_optional_args(gxg_gtk_icon_view_get_item_at_pos_w, gxg_gtk_icon_view_get_item_at_pos)
Xen_wrap_3_optional_args(gxg_gtk_icon_view_get_visible_range_w, gxg_gtk_icon_view_get_visible_range)
Xen_wrap_4_args(gxg_gtk_icon_view_set_cursor_w, gxg_gtk_icon_view_set_cursor)
Xen_wrap_3_optional_args(gxg_gtk_icon_view_get_cursor_w, gxg_gtk_icon_view_get_cursor)
Xen_wrap_5_args(gxg_gtk_icon_view_scroll_to_path_w, gxg_gtk_icon_view_scroll_to_path)
Xen_wrap_1_arg(gxg_gtk_icon_view_unset_model_drag_source_w, gxg_gtk_icon_view_unset_model_drag_source)
Xen_wrap_1_arg(gxg_gtk_icon_view_unset_model_drag_dest_w, gxg_gtk_icon_view_unset_model_drag_dest)
Xen_wrap_2_args(gxg_gtk_icon_view_set_reorderable_w, gxg_gtk_icon_view_set_reorderable)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_reorderable_w, gxg_gtk_icon_view_get_reorderable)
Xen_wrap_3_args(gxg_gtk_icon_view_set_drag_dest_item_w, gxg_gtk_icon_view_set_drag_dest_item)
Xen_wrap_3_optional_args(gxg_gtk_icon_view_get_drag_dest_item_w, gxg_gtk_icon_view_get_drag_dest_item)
Xen_wrap_5_optional_args(gxg_gtk_icon_view_get_dest_item_at_pos_w, gxg_gtk_icon_view_get_dest_item_at_pos)
Xen_wrap_1_arg(gxg_gtk_image_clear_w, gxg_gtk_image_clear)
Xen_wrap_1_arg(gxg_gtk_menu_bar_get_pack_direction_w, gxg_gtk_menu_bar_get_pack_direction)
Xen_wrap_2_args(gxg_gtk_menu_bar_set_pack_direction_w, gxg_gtk_menu_bar_set_pack_direction)
Xen_wrap_1_arg(gxg_gtk_menu_bar_get_child_pack_direction_w, gxg_gtk_menu_bar_get_child_pack_direction)
Xen_wrap_2_args(gxg_gtk_menu_bar_set_child_pack_direction_w, gxg_gtk_menu_bar_set_child_pack_direction)
Xen_wrap_1_arg(gxg_gtk_menu_shell_get_take_focus_w, gxg_gtk_menu_shell_get_take_focus)
Xen_wrap_2_args(gxg_gtk_menu_shell_set_take_focus_w, gxg_gtk_menu_shell_set_take_focus)
Xen_wrap_1_arg(gxg_gtk_text_iter_forward_visible_line_w, gxg_gtk_text_iter_forward_visible_line)
Xen_wrap_1_arg(gxg_gtk_text_iter_backward_visible_line_w, gxg_gtk_text_iter_backward_visible_line)
Xen_wrap_2_args(gxg_gtk_text_iter_forward_visible_lines_w, gxg_gtk_text_iter_forward_visible_lines)
Xen_wrap_2_args(gxg_gtk_text_iter_backward_visible_lines_w, gxg_gtk_text_iter_backward_visible_lines)
Xen_wrap_2_args(gxg_gtk_tool_button_set_icon_name_w, gxg_gtk_tool_button_set_icon_name)
Xen_wrap_1_arg(gxg_gtk_tool_button_get_icon_name_w, gxg_gtk_tool_button_get_icon_name)
Xen_wrap_2_args(gxg_gtk_window_set_urgency_hint_w, gxg_gtk_window_set_urgency_hint)
Xen_wrap_1_arg(gxg_gtk_window_get_urgency_hint_w, gxg_gtk_window_get_urgency_hint)
Xen_wrap_2_args(gxg_gtk_window_present_with_time_w, gxg_gtk_window_present_with_time)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_do_overwrite_confirmation_w, gxg_gtk_file_chooser_set_do_overwrite_confirmation)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_do_overwrite_confirmation_w, gxg_gtk_file_chooser_get_do_overwrite_confirmation)
Xen_wrap_1_arg(gxg_gtk_tree_row_reference_get_model_w, gxg_gtk_tree_row_reference_get_model)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_queue_resize_w, gxg_gtk_tree_view_column_queue_resize)
Xen_wrap_3_optional_args(gxg_gtk_tree_view_get_visible_range_w, gxg_gtk_tree_view_get_visible_range)
Xen_wrap_1_arg(gxg_pango_attr_list_ref_w, gxg_pango_attr_list_ref)
Xen_wrap_1_arg(gxg_pango_layout_line_ref_w, gxg_pango_layout_line_ref)
Xen_wrap_5_optional_args(gxg_pango_layout_index_to_line_x_w, gxg_pango_layout_index_to_line_x)
Xen_wrap_1_arg(gxg_gdk_display_supports_shapes_w, gxg_gdk_display_supports_shapes)
Xen_wrap_1_arg(gxg_gdk_display_supports_input_shapes_w, gxg_gdk_display_supports_input_shapes)
Xen_wrap_1_arg(gxg_gdk_window_get_type_hint_w, gxg_gdk_window_get_type_hint)
Xen_wrap_2_args(gxg_gtk_drag_dest_set_track_motion_w, gxg_gtk_drag_dest_set_track_motion)
Xen_wrap_1_arg(gxg_gtk_drag_dest_get_track_motion_w, gxg_gtk_drag_dest_get_track_motion)
Xen_wrap_2_args(gxg_gtk_notebook_get_tab_reorderable_w, gxg_gtk_notebook_get_tab_reorderable)
Xen_wrap_3_args(gxg_gtk_notebook_set_tab_reorderable_w, gxg_gtk_notebook_set_tab_reorderable)
Xen_wrap_2_args(gxg_gtk_notebook_get_tab_detachable_w, gxg_gtk_notebook_get_tab_detachable)
Xen_wrap_3_args(gxg_gtk_notebook_set_tab_detachable_w, gxg_gtk_notebook_set_tab_detachable)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_unset_placement_w, gxg_gtk_scrolled_window_unset_placement)
Xen_wrap_1_arg(gxg_gtk_size_group_get_widgets_w, gxg_gtk_size_group_get_widgets)
Xen_wrap_1_arg(gxg_gtk_text_buffer_get_has_selection_w, gxg_gtk_text_buffer_get_has_selection)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_headers_clickable_w, gxg_gtk_tree_view_get_headers_clickable)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_search_entry_w, gxg_gtk_tree_view_get_search_entry)
Xen_wrap_2_args(gxg_gtk_tree_view_set_search_entry_w, gxg_gtk_tree_view_set_search_entry)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_search_position_func_w, gxg_gtk_tree_view_get_search_position_func)
Xen_wrap_4_args(gxg_gtk_tree_view_set_search_position_func_w, gxg_gtk_tree_view_set_search_position_func)
Xen_wrap_2_args(gxg_gtk_window_set_deletable_w, gxg_gtk_window_set_deletable)
Xen_wrap_1_arg(gxg_gtk_window_get_deletable_w, gxg_gtk_window_get_deletable)
Xen_wrap_no_args(gxg_gtk_assistant_new_w, gxg_gtk_assistant_new)
Xen_wrap_1_arg(gxg_gtk_assistant_get_current_page_w, gxg_gtk_assistant_get_current_page)
Xen_wrap_2_args(gxg_gtk_assistant_set_current_page_w, gxg_gtk_assistant_set_current_page)
Xen_wrap_1_arg(gxg_gtk_assistant_get_n_pages_w, gxg_gtk_assistant_get_n_pages)
Xen_wrap_2_args(gxg_gtk_assistant_get_nth_page_w, gxg_gtk_assistant_get_nth_page)
Xen_wrap_2_args(gxg_gtk_assistant_prepend_page_w, gxg_gtk_assistant_prepend_page)
Xen_wrap_2_args(gxg_gtk_assistant_append_page_w, gxg_gtk_assistant_append_page)
Xen_wrap_3_args(gxg_gtk_assistant_insert_page_w, gxg_gtk_assistant_insert_page)
Xen_wrap_4_args(gxg_gtk_assistant_set_forward_page_func_w, gxg_gtk_assistant_set_forward_page_func)
Xen_wrap_3_args(gxg_gtk_assistant_set_page_type_w, gxg_gtk_assistant_set_page_type)
Xen_wrap_2_args(gxg_gtk_assistant_get_page_type_w, gxg_gtk_assistant_get_page_type)
Xen_wrap_3_args(gxg_gtk_assistant_set_page_title_w, gxg_gtk_assistant_set_page_title)
Xen_wrap_2_args(gxg_gtk_assistant_get_page_title_w, gxg_gtk_assistant_get_page_title)
Xen_wrap_3_args(gxg_gtk_assistant_set_page_complete_w, gxg_gtk_assistant_set_page_complete)
Xen_wrap_2_args(gxg_gtk_assistant_get_page_complete_w, gxg_gtk_assistant_get_page_complete)
Xen_wrap_2_args(gxg_gtk_assistant_add_action_widget_w, gxg_gtk_assistant_add_action_widget)
Xen_wrap_2_args(gxg_gtk_assistant_remove_action_widget_w, gxg_gtk_assistant_remove_action_widget)
Xen_wrap_1_arg(gxg_gtk_assistant_update_buttons_state_w, gxg_gtk_assistant_update_buttons_state)
Xen_wrap_no_args(gxg_gtk_cell_renderer_accel_new_w, gxg_gtk_cell_renderer_accel_new)
Xen_wrap_no_args(gxg_gtk_cell_renderer_spin_new_w, gxg_gtk_cell_renderer_spin_new)
Xen_wrap_1_arg(gxg_gtk_link_button_new_w, gxg_gtk_link_button_new)
Xen_wrap_2_args(gxg_gtk_link_button_new_with_label_w, gxg_gtk_link_button_new_with_label)
Xen_wrap_1_arg(gxg_gtk_link_button_get_uri_w, gxg_gtk_link_button_get_uri)
Xen_wrap_2_args(gxg_gtk_link_button_set_uri_w, gxg_gtk_link_button_set_uri)
Xen_wrap_no_args(gxg_gtk_recent_chooser_error_quark_w, gxg_gtk_recent_chooser_error_quark)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_show_private_w, gxg_gtk_recent_chooser_set_show_private)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_show_private_w, gxg_gtk_recent_chooser_get_show_private)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_show_not_found_w, gxg_gtk_recent_chooser_set_show_not_found)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_show_not_found_w, gxg_gtk_recent_chooser_get_show_not_found)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_select_multiple_w, gxg_gtk_recent_chooser_set_select_multiple)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_select_multiple_w, gxg_gtk_recent_chooser_get_select_multiple)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_limit_w, gxg_gtk_recent_chooser_set_limit)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_limit_w, gxg_gtk_recent_chooser_get_limit)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_local_only_w, gxg_gtk_recent_chooser_set_local_only)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_local_only_w, gxg_gtk_recent_chooser_get_local_only)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_show_tips_w, gxg_gtk_recent_chooser_set_show_tips)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_show_tips_w, gxg_gtk_recent_chooser_get_show_tips)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_show_icons_w, gxg_gtk_recent_chooser_set_show_icons)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_show_icons_w, gxg_gtk_recent_chooser_get_show_icons)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_sort_type_w, gxg_gtk_recent_chooser_set_sort_type)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_sort_type_w, gxg_gtk_recent_chooser_get_sort_type)
Xen_wrap_4_args(gxg_gtk_recent_chooser_set_sort_func_w, gxg_gtk_recent_chooser_set_sort_func)
Xen_wrap_3_optional_args(gxg_gtk_recent_chooser_set_current_uri_w, gxg_gtk_recent_chooser_set_current_uri)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_current_uri_w, gxg_gtk_recent_chooser_get_current_uri)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_current_item_w, gxg_gtk_recent_chooser_get_current_item)
Xen_wrap_3_optional_args(gxg_gtk_recent_chooser_select_uri_w, gxg_gtk_recent_chooser_select_uri)
Xen_wrap_2_args(gxg_gtk_recent_chooser_unselect_uri_w, gxg_gtk_recent_chooser_unselect_uri)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_select_all_w, gxg_gtk_recent_chooser_select_all)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_unselect_all_w, gxg_gtk_recent_chooser_unselect_all)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_items_w, gxg_gtk_recent_chooser_get_items)
Xen_wrap_2_optional_args(gxg_gtk_recent_chooser_get_uris_w, gxg_gtk_recent_chooser_get_uris)
Xen_wrap_2_args(gxg_gtk_recent_chooser_add_filter_w, gxg_gtk_recent_chooser_add_filter)
Xen_wrap_2_args(gxg_gtk_recent_chooser_remove_filter_w, gxg_gtk_recent_chooser_remove_filter)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_list_filters_w, gxg_gtk_recent_chooser_list_filters)
Xen_wrap_2_args(gxg_gtk_recent_chooser_set_filter_w, gxg_gtk_recent_chooser_set_filter)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_get_filter_w, gxg_gtk_recent_chooser_get_filter)
Xen_wrap_no_args(gxg_gtk_recent_chooser_menu_new_w, gxg_gtk_recent_chooser_menu_new)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_menu_new_for_manager_w, gxg_gtk_recent_chooser_menu_new_for_manager)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_menu_get_show_numbers_w, gxg_gtk_recent_chooser_menu_get_show_numbers)
Xen_wrap_2_args(gxg_gtk_recent_chooser_menu_set_show_numbers_w, gxg_gtk_recent_chooser_menu_set_show_numbers)
Xen_wrap_no_args(gxg_gtk_recent_chooser_widget_new_w, gxg_gtk_recent_chooser_widget_new)
Xen_wrap_1_arg(gxg_gtk_recent_chooser_widget_new_for_manager_w, gxg_gtk_recent_chooser_widget_new_for_manager)
Xen_wrap_no_args(gxg_gtk_recent_filter_new_w, gxg_gtk_recent_filter_new)
Xen_wrap_2_args(gxg_gtk_recent_filter_set_name_w, gxg_gtk_recent_filter_set_name)
Xen_wrap_1_arg(gxg_gtk_recent_filter_get_name_w, gxg_gtk_recent_filter_get_name)
Xen_wrap_2_args(gxg_gtk_recent_filter_add_mime_type_w, gxg_gtk_recent_filter_add_mime_type)
Xen_wrap_2_args(gxg_gtk_recent_filter_add_pattern_w, gxg_gtk_recent_filter_add_pattern)
Xen_wrap_1_arg(gxg_gtk_recent_filter_add_pixbuf_formats_w, gxg_gtk_recent_filter_add_pixbuf_formats)
Xen_wrap_2_args(gxg_gtk_recent_filter_add_application_w, gxg_gtk_recent_filter_add_application)
Xen_wrap_2_args(gxg_gtk_recent_filter_add_group_w, gxg_gtk_recent_filter_add_group)
Xen_wrap_2_args(gxg_gtk_recent_filter_add_age_w, gxg_gtk_recent_filter_add_age)
Xen_wrap_no_args(gxg_gtk_recent_manager_error_quark_w, gxg_gtk_recent_manager_error_quark)
Xen_wrap_no_args(gxg_gtk_recent_manager_new_w, gxg_gtk_recent_manager_new)
Xen_wrap_no_args(gxg_gtk_recent_manager_get_default_w, gxg_gtk_recent_manager_get_default)
Xen_wrap_3_optional_args(gxg_gtk_recent_manager_remove_item_w, gxg_gtk_recent_manager_remove_item)
Xen_wrap_3_optional_args(gxg_gtk_recent_manager_lookup_item_w, gxg_gtk_recent_manager_lookup_item)
Xen_wrap_2_args(gxg_gtk_recent_manager_has_item_w, gxg_gtk_recent_manager_has_item)
Xen_wrap_4_optional_args(gxg_gtk_recent_manager_move_item_w, gxg_gtk_recent_manager_move_item)
Xen_wrap_1_arg(gxg_gtk_recent_manager_get_items_w, gxg_gtk_recent_manager_get_items)
Xen_wrap_2_optional_args(gxg_gtk_recent_manager_purge_items_w, gxg_gtk_recent_manager_purge_items)
Xen_wrap_1_arg(gxg_gtk_recent_info_ref_w, gxg_gtk_recent_info_ref)
Xen_wrap_1_arg(gxg_gtk_recent_info_unref_w, gxg_gtk_recent_info_unref)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_uri_w, gxg_gtk_recent_info_get_uri)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_display_name_w, gxg_gtk_recent_info_get_display_name)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_description_w, gxg_gtk_recent_info_get_description)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_mime_type_w, gxg_gtk_recent_info_get_mime_type)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_added_w, gxg_gtk_recent_info_get_added)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_modified_w, gxg_gtk_recent_info_get_modified)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_visited_w, gxg_gtk_recent_info_get_visited)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_private_hint_w, gxg_gtk_recent_info_get_private_hint)
Xen_wrap_2_optional_args(gxg_gtk_recent_info_get_applications_w, gxg_gtk_recent_info_get_applications)
Xen_wrap_1_arg(gxg_gtk_recent_info_last_application_w, gxg_gtk_recent_info_last_application)
Xen_wrap_2_args(gxg_gtk_recent_info_has_application_w, gxg_gtk_recent_info_has_application)
Xen_wrap_2_optional_args(gxg_gtk_recent_info_get_groups_w, gxg_gtk_recent_info_get_groups)
Xen_wrap_2_args(gxg_gtk_recent_info_has_group_w, gxg_gtk_recent_info_has_group)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_short_name_w, gxg_gtk_recent_info_get_short_name)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_uri_display_w, gxg_gtk_recent_info_get_uri_display)
Xen_wrap_1_arg(gxg_gtk_recent_info_get_age_w, gxg_gtk_recent_info_get_age)
Xen_wrap_1_arg(gxg_gtk_recent_info_is_local_w, gxg_gtk_recent_info_is_local)
Xen_wrap_1_arg(gxg_gtk_recent_info_exists_w, gxg_gtk_recent_info_exists)
Xen_wrap_2_args(gxg_gtk_recent_info_match_w, gxg_gtk_recent_info_match)
Xen_wrap_2_args(gxg_gtk_recent_manager_add_item_w, gxg_gtk_recent_manager_add_item)
Xen_wrap_3_args(gxg_gtk_recent_manager_add_full_w, gxg_gtk_recent_manager_add_full)
Xen_wrap_3_args(gxg_gtk_tree_model_filter_convert_child_iter_to_iter_w, gxg_gtk_tree_model_filter_convert_child_iter_to_iter)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_grid_lines_w, gxg_gtk_tree_view_get_grid_lines)
Xen_wrap_2_args(gxg_gtk_tree_view_set_grid_lines_w, gxg_gtk_tree_view_set_grid_lines)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_enable_tree_lines_w, gxg_gtk_tree_view_get_enable_tree_lines)
Xen_wrap_2_args(gxg_gtk_tree_view_set_enable_tree_lines_w, gxg_gtk_tree_view_set_enable_tree_lines)
Xen_wrap_2_args(gxg_gtk_label_set_line_wrap_mode_w, gxg_gtk_label_set_line_wrap_mode)
Xen_wrap_1_arg(gxg_gtk_label_get_line_wrap_mode_w, gxg_gtk_label_get_line_wrap_mode)
Xen_wrap_1_arg(gxg_gtk_print_context_get_cairo_context_w, gxg_gtk_print_context_get_cairo_context)
Xen_wrap_1_arg(gxg_gtk_print_context_get_page_setup_w, gxg_gtk_print_context_get_page_setup)
Xen_wrap_1_arg(gxg_gtk_print_context_get_width_w, gxg_gtk_print_context_get_width)
Xen_wrap_1_arg(gxg_gtk_print_context_get_height_w, gxg_gtk_print_context_get_height)
Xen_wrap_1_arg(gxg_gtk_print_context_get_dpi_x_w, gxg_gtk_print_context_get_dpi_x)
Xen_wrap_1_arg(gxg_gtk_print_context_get_dpi_y_w, gxg_gtk_print_context_get_dpi_y)
Xen_wrap_1_arg(gxg_gtk_print_context_create_pango_context_w, gxg_gtk_print_context_create_pango_context)
Xen_wrap_1_arg(gxg_gtk_print_context_create_pango_layout_w, gxg_gtk_print_context_create_pango_layout)
Xen_wrap_4_args(gxg_gtk_print_context_set_cairo_context_w, gxg_gtk_print_context_set_cairo_context)
Xen_wrap_no_args(gxg_gtk_print_operation_new_w, gxg_gtk_print_operation_new)
Xen_wrap_2_args(gxg_gtk_print_operation_set_default_page_setup_w, gxg_gtk_print_operation_set_default_page_setup)
Xen_wrap_1_arg(gxg_gtk_print_operation_get_default_page_setup_w, gxg_gtk_print_operation_get_default_page_setup)
Xen_wrap_2_args(gxg_gtk_print_operation_set_print_settings_w, gxg_gtk_print_operation_set_print_settings)
Xen_wrap_1_arg(gxg_gtk_print_operation_get_print_settings_w, gxg_gtk_print_operation_get_print_settings)
Xen_wrap_2_args(gxg_gtk_print_operation_set_job_name_w, gxg_gtk_print_operation_set_job_name)
Xen_wrap_2_args(gxg_gtk_print_operation_set_n_pages_w, gxg_gtk_print_operation_set_n_pages)
Xen_wrap_2_args(gxg_gtk_print_operation_set_current_page_w, gxg_gtk_print_operation_set_current_page)
Xen_wrap_2_args(gxg_gtk_print_operation_set_use_full_page_w, gxg_gtk_print_operation_set_use_full_page)
Xen_wrap_2_args(gxg_gtk_print_operation_set_unit_w, gxg_gtk_print_operation_set_unit)
Xen_wrap_2_args(gxg_gtk_print_operation_set_export_filename_w, gxg_gtk_print_operation_set_export_filename)
Xen_wrap_2_args(gxg_gtk_print_operation_set_track_print_status_w, gxg_gtk_print_operation_set_track_print_status)
Xen_wrap_2_args(gxg_gtk_print_operation_set_show_progress_w, gxg_gtk_print_operation_set_show_progress)
Xen_wrap_2_args(gxg_gtk_print_operation_set_allow_async_w, gxg_gtk_print_operation_set_allow_async)
Xen_wrap_2_args(gxg_gtk_print_operation_set_custom_tab_label_w, gxg_gtk_print_operation_set_custom_tab_label)
Xen_wrap_4_optional_args(gxg_gtk_print_operation_run_w, gxg_gtk_print_operation_run)
Xen_wrap_2_optional_args(gxg_gtk_print_operation_get_error_w, gxg_gtk_print_operation_get_error)
Xen_wrap_1_arg(gxg_gtk_print_operation_get_status_w, gxg_gtk_print_operation_get_status)
Xen_wrap_1_arg(gxg_gtk_print_operation_get_status_string_w, gxg_gtk_print_operation_get_status_string)
Xen_wrap_1_arg(gxg_gtk_print_operation_is_finished_w, gxg_gtk_print_operation_is_finished)
Xen_wrap_1_arg(gxg_gtk_print_operation_cancel_w, gxg_gtk_print_operation_cancel)
Xen_wrap_3_args(gxg_gtk_print_run_page_setup_dialog_w, gxg_gtk_print_run_page_setup_dialog)
Xen_wrap_5_args(gxg_gtk_print_run_page_setup_dialog_async_w, gxg_gtk_print_run_page_setup_dialog_async)
Xen_wrap_no_args(gxg_gtk_print_settings_new_w, gxg_gtk_print_settings_new)
Xen_wrap_1_arg(gxg_gtk_print_settings_copy_w, gxg_gtk_print_settings_copy)
Xen_wrap_2_args(gxg_gtk_print_settings_has_key_w, gxg_gtk_print_settings_has_key)
Xen_wrap_2_args(gxg_gtk_print_settings_get_w, gxg_gtk_print_settings_get)
Xen_wrap_3_args(gxg_gtk_print_settings_set_w, gxg_gtk_print_settings_set)
Xen_wrap_2_args(gxg_gtk_print_settings_unset_w, gxg_gtk_print_settings_unset)
Xen_wrap_3_args(gxg_gtk_print_settings_foreach_w, gxg_gtk_print_settings_foreach)
Xen_wrap_2_args(gxg_gtk_print_settings_get_bool_w, gxg_gtk_print_settings_get_bool)
Xen_wrap_3_args(gxg_gtk_print_settings_set_bool_w, gxg_gtk_print_settings_set_bool)
Xen_wrap_2_args(gxg_gtk_print_settings_get_double_w, gxg_gtk_print_settings_get_double)
Xen_wrap_3_args(gxg_gtk_print_settings_get_double_with_default_w, gxg_gtk_print_settings_get_double_with_default)
Xen_wrap_3_args(gxg_gtk_print_settings_set_double_w, gxg_gtk_print_settings_set_double)
Xen_wrap_3_args(gxg_gtk_print_settings_get_length_w, gxg_gtk_print_settings_get_length)
Xen_wrap_4_args(gxg_gtk_print_settings_set_length_w, gxg_gtk_print_settings_set_length)
Xen_wrap_2_args(gxg_gtk_print_settings_get_int_w, gxg_gtk_print_settings_get_int)
Xen_wrap_3_args(gxg_gtk_print_settings_get_int_with_default_w, gxg_gtk_print_settings_get_int_with_default)
Xen_wrap_3_args(gxg_gtk_print_settings_set_int_w, gxg_gtk_print_settings_set_int)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_printer_w, gxg_gtk_print_settings_get_printer)
Xen_wrap_2_args(gxg_gtk_print_settings_set_printer_w, gxg_gtk_print_settings_set_printer)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_orientation_w, gxg_gtk_print_settings_get_orientation)
Xen_wrap_2_args(gxg_gtk_print_settings_set_orientation_w, gxg_gtk_print_settings_set_orientation)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_paper_size_w, gxg_gtk_print_settings_get_paper_size)
Xen_wrap_2_args(gxg_gtk_print_settings_set_paper_size_w, gxg_gtk_print_settings_set_paper_size)
Xen_wrap_2_args(gxg_gtk_print_settings_get_paper_width_w, gxg_gtk_print_settings_get_paper_width)
Xen_wrap_3_args(gxg_gtk_print_settings_set_paper_width_w, gxg_gtk_print_settings_set_paper_width)
Xen_wrap_2_args(gxg_gtk_print_settings_get_paper_height_w, gxg_gtk_print_settings_get_paper_height)
Xen_wrap_3_args(gxg_gtk_print_settings_set_paper_height_w, gxg_gtk_print_settings_set_paper_height)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_use_color_w, gxg_gtk_print_settings_get_use_color)
Xen_wrap_2_args(gxg_gtk_print_settings_set_use_color_w, gxg_gtk_print_settings_set_use_color)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_collate_w, gxg_gtk_print_settings_get_collate)
Xen_wrap_2_args(gxg_gtk_print_settings_set_collate_w, gxg_gtk_print_settings_set_collate)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_reverse_w, gxg_gtk_print_settings_get_reverse)
Xen_wrap_2_args(gxg_gtk_print_settings_set_reverse_w, gxg_gtk_print_settings_set_reverse)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_duplex_w, gxg_gtk_print_settings_get_duplex)
Xen_wrap_2_args(gxg_gtk_print_settings_set_duplex_w, gxg_gtk_print_settings_set_duplex)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_quality_w, gxg_gtk_print_settings_get_quality)
Xen_wrap_2_args(gxg_gtk_print_settings_set_quality_w, gxg_gtk_print_settings_set_quality)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_n_copies_w, gxg_gtk_print_settings_get_n_copies)
Xen_wrap_2_args(gxg_gtk_print_settings_set_n_copies_w, gxg_gtk_print_settings_set_n_copies)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_number_up_w, gxg_gtk_print_settings_get_number_up)
Xen_wrap_2_args(gxg_gtk_print_settings_set_number_up_w, gxg_gtk_print_settings_set_number_up)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_resolution_w, gxg_gtk_print_settings_get_resolution)
Xen_wrap_2_args(gxg_gtk_print_settings_set_resolution_w, gxg_gtk_print_settings_set_resolution)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_scale_w, gxg_gtk_print_settings_get_scale)
Xen_wrap_2_args(gxg_gtk_print_settings_set_scale_w, gxg_gtk_print_settings_set_scale)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_print_pages_w, gxg_gtk_print_settings_get_print_pages)
Xen_wrap_2_args(gxg_gtk_print_settings_set_print_pages_w, gxg_gtk_print_settings_set_print_pages)
Xen_wrap_2_args(gxg_gtk_print_settings_get_page_ranges_w, gxg_gtk_print_settings_get_page_ranges)
Xen_wrap_3_args(gxg_gtk_print_settings_set_page_ranges_w, gxg_gtk_print_settings_set_page_ranges)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_page_set_w, gxg_gtk_print_settings_get_page_set)
Xen_wrap_2_args(gxg_gtk_print_settings_set_page_set_w, gxg_gtk_print_settings_set_page_set)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_default_source_w, gxg_gtk_print_settings_get_default_source)
Xen_wrap_2_args(gxg_gtk_print_settings_set_default_source_w, gxg_gtk_print_settings_set_default_source)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_media_type_w, gxg_gtk_print_settings_get_media_type)
Xen_wrap_2_args(gxg_gtk_print_settings_set_media_type_w, gxg_gtk_print_settings_set_media_type)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_dither_w, gxg_gtk_print_settings_get_dither)
Xen_wrap_2_args(gxg_gtk_print_settings_set_dither_w, gxg_gtk_print_settings_set_dither)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_finishings_w, gxg_gtk_print_settings_get_finishings)
Xen_wrap_2_args(gxg_gtk_print_settings_set_finishings_w, gxg_gtk_print_settings_set_finishings)
Xen_wrap_1_arg(gxg_gtk_print_settings_get_output_bin_w, gxg_gtk_print_settings_get_output_bin)
Xen_wrap_2_args(gxg_gtk_print_settings_set_output_bin_w, gxg_gtk_print_settings_set_output_bin)
Xen_wrap_1_arg(gxg_pango_cairo_create_layout_w, gxg_pango_cairo_create_layout)
Xen_wrap_2_args(gxg_pango_cairo_update_layout_w, gxg_pango_cairo_update_layout)
Xen_wrap_2_args(gxg_pango_cairo_update_context_w, gxg_pango_cairo_update_context)
Xen_wrap_2_args(gxg_pango_cairo_context_set_font_options_w, gxg_pango_cairo_context_set_font_options)
Xen_wrap_1_arg(gxg_pango_cairo_context_get_font_options_w, gxg_pango_cairo_context_get_font_options)
Xen_wrap_2_args(gxg_pango_cairo_context_set_resolution_w, gxg_pango_cairo_context_set_resolution)
Xen_wrap_1_arg(gxg_pango_cairo_context_get_resolution_w, gxg_pango_cairo_context_get_resolution)
Xen_wrap_3_args(gxg_pango_cairo_show_glyph_string_w, gxg_pango_cairo_show_glyph_string)
Xen_wrap_2_args(gxg_pango_cairo_show_layout_line_w, gxg_pango_cairo_show_layout_line)
Xen_wrap_2_args(gxg_pango_cairo_show_layout_w, gxg_pango_cairo_show_layout)
Xen_wrap_5_args(gxg_pango_cairo_show_error_underline_w, gxg_pango_cairo_show_error_underline)
Xen_wrap_3_args(gxg_pango_cairo_glyph_string_path_w, gxg_pango_cairo_glyph_string_path)
Xen_wrap_2_args(gxg_pango_cairo_layout_line_path_w, gxg_pango_cairo_layout_line_path)
Xen_wrap_2_args(gxg_pango_cairo_layout_path_w, gxg_pango_cairo_layout_path)
Xen_wrap_5_args(gxg_pango_cairo_error_underline_path_w, gxg_pango_cairo_error_underline_path)
Xen_wrap_4_args(gxg_gdk_cairo_set_source_pixbuf_w, gxg_gdk_cairo_set_source_pixbuf)
Xen_wrap_2_args(gxg_gdk_cairo_rectangle_w, gxg_gdk_cairo_rectangle)
Xen_wrap_4_args(gxg_gdk_threads_add_idle_full_w, gxg_gdk_threads_add_idle_full)
Xen_wrap_2_args(gxg_gdk_threads_add_idle_w, gxg_gdk_threads_add_idle)
Xen_wrap_5_args(gxg_gdk_threads_add_timeout_full_w, gxg_gdk_threads_add_timeout_full)
Xen_wrap_3_args(gxg_gdk_threads_add_timeout_w, gxg_gdk_threads_add_timeout)
Xen_wrap_2_args(gxg_gdk_window_set_startup_id_w, gxg_gdk_window_set_startup_id)
Xen_wrap_1_arg(gxg_gdk_window_beep_w, gxg_gdk_window_beep)
Xen_wrap_2_args(gxg_gdk_window_set_opacity_w, gxg_gdk_window_set_opacity)
Xen_wrap_3_args(gxg_gtk_binding_entry_skip_w, gxg_gtk_binding_entry_skip)
Xen_wrap_1_arg(gxg_gtk_cell_layout_get_cells_w, gxg_gtk_cell_layout_get_cells)
Xen_wrap_2_args(gxg_gtk_entry_completion_set_inline_selection_w, gxg_gtk_entry_completion_set_inline_selection)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_inline_selection_w, gxg_gtk_entry_completion_get_inline_selection)
Xen_wrap_1_arg(gxg_gtk_entry_completion_get_completion_prefix_w, gxg_gtk_entry_completion_get_completion_prefix)
Xen_wrap_2_args(gxg_gtk_entry_set_cursor_hadjustment_w, gxg_gtk_entry_set_cursor_hadjustment)
Xen_wrap_1_arg(gxg_gtk_entry_get_cursor_hadjustment_w, gxg_gtk_entry_get_cursor_hadjustment)
Xen_wrap_1_arg(gxg_gtk_icon_theme_list_contexts_w, gxg_gtk_icon_theme_list_contexts)
Xen_wrap_2_optional_args(gxg_gtk_print_settings_new_from_file_w, gxg_gtk_print_settings_new_from_file)
Xen_wrap_3_optional_args(gxg_gtk_print_settings_to_file_w, gxg_gtk_print_settings_to_file)
Xen_wrap_2_args(gxg_gtk_range_set_show_fill_level_w, gxg_gtk_range_set_show_fill_level)
Xen_wrap_1_arg(gxg_gtk_range_get_show_fill_level_w, gxg_gtk_range_get_show_fill_level)
Xen_wrap_2_args(gxg_gtk_range_set_restrict_to_fill_level_w, gxg_gtk_range_set_restrict_to_fill_level)
Xen_wrap_1_arg(gxg_gtk_range_get_restrict_to_fill_level_w, gxg_gtk_range_get_restrict_to_fill_level)
Xen_wrap_2_args(gxg_gtk_range_set_fill_level_w, gxg_gtk_range_set_fill_level)
Xen_wrap_1_arg(gxg_gtk_range_get_fill_level_w, gxg_gtk_range_get_fill_level)
Xen_wrap_2_args(gxg_gtk_tree_view_set_show_expanders_w, gxg_gtk_tree_view_set_show_expanders)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_show_expanders_w, gxg_gtk_tree_view_get_show_expanders)
Xen_wrap_2_args(gxg_gtk_tree_view_set_level_indentation_w, gxg_gtk_tree_view_set_level_indentation)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_level_indentation_w, gxg_gtk_tree_view_get_level_indentation)
Xen_wrap_2_args(gxg_gtk_widget_keynav_failed_w, gxg_gtk_widget_keynav_failed)
Xen_wrap_1_arg(gxg_gtk_widget_error_bell_w, gxg_gtk_widget_error_bell)
Xen_wrap_2_args(gxg_gtk_widget_set_tooltip_window_w, gxg_gtk_widget_set_tooltip_window)
Xen_wrap_1_arg(gxg_gtk_widget_get_tooltip_window_w, gxg_gtk_widget_get_tooltip_window)
Xen_wrap_1_arg(gxg_gtk_widget_trigger_tooltip_query_w, gxg_gtk_widget_trigger_tooltip_query)
Xen_wrap_2_args(gxg_gtk_window_set_startup_id_w, gxg_gtk_window_set_startup_id)
Xen_wrap_3_args(gxg_gtk_text_buffer_add_mark_w, gxg_gtk_text_buffer_add_mark)
Xen_wrap_2_args(gxg_gtk_text_mark_new_w, gxg_gtk_text_mark_new)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_tree_view_w, gxg_gtk_tree_view_column_get_tree_view)
Xen_wrap_2_args(gxg_gtk_tooltip_set_text_w, gxg_gtk_tooltip_set_text)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_convert_widget_to_tree_coords_w, gxg_gtk_tree_view_convert_widget_to_tree_coords)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_convert_tree_to_widget_coords_w, gxg_gtk_tree_view_convert_tree_to_widget_coords)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_convert_widget_to_bin_window_coords_w, gxg_gtk_tree_view_convert_widget_to_bin_window_coords)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_convert_bin_window_to_widget_coords_w, gxg_gtk_tree_view_convert_bin_window_to_widget_coords)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_convert_tree_to_bin_window_coords_w, gxg_gtk_tree_view_convert_tree_to_bin_window_coords)
Xen_wrap_5_optional_args(gxg_gtk_tree_view_convert_bin_window_to_tree_coords_w, gxg_gtk_tree_view_convert_bin_window_to_tree_coords)
Xen_wrap_2_args(gxg_gtk_widget_set_tooltip_text_w, gxg_gtk_widget_set_tooltip_text)
Xen_wrap_1_arg(gxg_gtk_widget_get_tooltip_text_w, gxg_gtk_widget_get_tooltip_text)
Xen_wrap_2_args(gxg_gtk_widget_set_tooltip_markup_w, gxg_gtk_widget_set_tooltip_markup)
Xen_wrap_1_arg(gxg_gtk_widget_get_tooltip_markup_w, gxg_gtk_widget_get_tooltip_markup)
Xen_wrap_1_arg(gxg_gtk_tree_view_is_rubber_banding_active_w, gxg_gtk_tree_view_is_rubber_banding_active)
Xen_wrap_3_args(gxg_gtk_icon_view_set_tooltip_item_w, gxg_gtk_icon_view_set_tooltip_item)
Xen_wrap_4_args(gxg_gtk_icon_view_set_tooltip_cell_w, gxg_gtk_icon_view_set_tooltip_cell)
Xen_wrap_7_optional_args(gxg_gtk_icon_view_get_tooltip_context_w, gxg_gtk_icon_view_get_tooltip_context)
Xen_wrap_2_args(gxg_gtk_icon_view_set_tooltip_column_w, gxg_gtk_icon_view_set_tooltip_column)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_tooltip_column_w, gxg_gtk_icon_view_get_tooltip_column)
Xen_wrap_2_args(gxg_gtk_menu_tool_button_set_arrow_tooltip_text_w, gxg_gtk_menu_tool_button_set_arrow_tooltip_text)
Xen_wrap_2_args(gxg_gtk_menu_tool_button_set_arrow_tooltip_markup_w, gxg_gtk_menu_tool_button_set_arrow_tooltip_markup)
Xen_wrap_2_args(gxg_gtk_tool_item_set_tooltip_text_w, gxg_gtk_tool_item_set_tooltip_text)
Xen_wrap_2_args(gxg_gtk_tool_item_set_tooltip_markup_w, gxg_gtk_tool_item_set_tooltip_markup)
Xen_wrap_2_args(gxg_gtk_tooltip_set_tip_area_w, gxg_gtk_tooltip_set_tip_area)
Xen_wrap_3_args(gxg_gtk_tree_view_set_tooltip_row_w, gxg_gtk_tree_view_set_tooltip_row)
Xen_wrap_5_args(gxg_gtk_tree_view_set_tooltip_cell_w, gxg_gtk_tree_view_set_tooltip_cell)
Xen_wrap_7_optional_args(gxg_gtk_tree_view_get_tooltip_context_w, gxg_gtk_tree_view_get_tooltip_context)
Xen_wrap_2_args(gxg_gtk_tree_view_set_tooltip_column_w, gxg_gtk_tree_view_set_tooltip_column)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_tooltip_column_w, gxg_gtk_tree_view_get_tooltip_column)
Xen_wrap_2_args(gxg_gtk_widget_set_has_tooltip_w, gxg_gtk_widget_set_has_tooltip)
Xen_wrap_1_arg(gxg_gtk_widget_get_has_tooltip_w, gxg_gtk_widget_get_has_tooltip)
#if GTK_CHECK_VERSION(2, 14, 0)
Xen_wrap_4_args(gxg_gtk_calendar_set_detail_func_w, gxg_gtk_calendar_set_detail_func)
Xen_wrap_2_args(gxg_gtk_calendar_set_detail_width_chars_w, gxg_gtk_calendar_set_detail_width_chars)
Xen_wrap_2_args(gxg_gtk_calendar_set_detail_height_rows_w, gxg_gtk_calendar_set_detail_height_rows)
Xen_wrap_1_arg(gxg_gtk_calendar_get_detail_width_chars_w, gxg_gtk_calendar_get_detail_width_chars)
Xen_wrap_1_arg(gxg_gtk_calendar_get_detail_height_rows_w, gxg_gtk_calendar_get_detail_height_rows)
Xen_wrap_1_arg(gxg_gtk_accel_group_get_is_locked_w, gxg_gtk_accel_group_get_is_locked)
Xen_wrap_1_arg(gxg_gtk_dialog_get_content_area_w, gxg_gtk_dialog_get_content_area)
Xen_wrap_2_args(gxg_gtk_entry_set_overwrite_mode_w, gxg_gtk_entry_set_overwrite_mode)
Xen_wrap_1_arg(gxg_gtk_entry_get_overwrite_mode_w, gxg_gtk_entry_get_overwrite_mode)
Xen_wrap_1_arg(gxg_gtk_entry_get_text_length_w, gxg_gtk_entry_get_text_length)
Xen_wrap_1_arg(gxg_gtk_menu_get_accel_path_w, gxg_gtk_menu_get_accel_path)
Xen_wrap_1_arg(gxg_gtk_menu_get_monitor_w, gxg_gtk_menu_get_monitor)
Xen_wrap_1_arg(gxg_gtk_menu_item_get_accel_path_w, gxg_gtk_menu_item_get_accel_path)
Xen_wrap_1_arg(gxg_gtk_scale_button_get_plus_button_w, gxg_gtk_scale_button_get_plus_button)
Xen_wrap_1_arg(gxg_gtk_scale_button_get_minus_button_w, gxg_gtk_scale_button_get_minus_button)
Xen_wrap_1_arg(gxg_gtk_scale_button_get_popup_w, gxg_gtk_scale_button_get_popup)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_target_w, gxg_gtk_selection_data_get_target)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_data_type_w, gxg_gtk_selection_data_get_data_type)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_format_w, gxg_gtk_selection_data_get_format)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_display_w, gxg_gtk_selection_data_get_display)
Xen_wrap_1_arg(gxg_gtk_widget_get_window_w, gxg_gtk_widget_get_window)
Xen_wrap_1_arg(gxg_gtk_accel_group_get_modifier_mask_w, gxg_gtk_accel_group_get_modifier_mask)
Xen_wrap_5_args(gxg_gdk_threads_add_timeout_seconds_full_w, gxg_gdk_threads_add_timeout_seconds_full)
Xen_wrap_3_args(gxg_gdk_threads_add_timeout_seconds_w, gxg_gdk_threads_add_timeout_seconds)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_lower_w, gxg_gtk_adjustment_get_lower)
Xen_wrap_2_args(gxg_gtk_adjustment_set_lower_w, gxg_gtk_adjustment_set_lower)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_upper_w, gxg_gtk_adjustment_get_upper)
Xen_wrap_2_args(gxg_gtk_adjustment_set_upper_w, gxg_gtk_adjustment_set_upper)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_step_increment_w, gxg_gtk_adjustment_get_step_increment)
Xen_wrap_2_args(gxg_gtk_adjustment_set_step_increment_w, gxg_gtk_adjustment_set_step_increment)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_page_increment_w, gxg_gtk_adjustment_get_page_increment)
Xen_wrap_2_args(gxg_gtk_adjustment_set_page_increment_w, gxg_gtk_adjustment_set_page_increment)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_page_size_w, gxg_gtk_adjustment_get_page_size)
Xen_wrap_2_args(gxg_gtk_adjustment_set_page_size_w, gxg_gtk_adjustment_set_page_size)
Xen_wrap_7_args(gxg_gtk_adjustment_configure_w, gxg_gtk_adjustment_configure)
Xen_wrap_2_args(gxg_gtk_combo_box_set_button_sensitivity_w, gxg_gtk_combo_box_set_button_sensitivity)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_button_sensitivity_w, gxg_gtk_combo_box_get_button_sensitivity)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_file_w, gxg_gtk_file_chooser_get_file)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_set_file_w, gxg_gtk_file_chooser_set_file)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_select_file_w, gxg_gtk_file_chooser_select_file)
Xen_wrap_2_args(gxg_gtk_file_chooser_unselect_file_w, gxg_gtk_file_chooser_unselect_file)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_files_w, gxg_gtk_file_chooser_get_files)
Xen_wrap_3_optional_args(gxg_gtk_file_chooser_set_current_folder_file_w, gxg_gtk_file_chooser_set_current_folder_file)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_current_folder_file_w, gxg_gtk_file_chooser_get_current_folder_file)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_preview_file_w, gxg_gtk_file_chooser_get_preview_file)
Xen_wrap_1_arg(gxg_gtk_window_get_default_widget_w, gxg_gtk_window_get_default_widget)
#endif

#if GTK_CHECK_VERSION(2, 16, 0)
Xen_wrap_1_arg(gxg_gtk_link_button_get_visited_w, gxg_gtk_link_button_get_visited)
Xen_wrap_2_args(gxg_gtk_link_button_set_visited_w, gxg_gtk_link_button_set_visited)
Xen_wrap_1_arg(gxg_gdk_keymap_get_caps_lock_state_w, gxg_gdk_keymap_get_caps_lock_state)
Xen_wrap_1_arg(gxg_gtk_cell_view_get_model_w, gxg_gtk_cell_view_get_model)
Xen_wrap_1_arg(gxg_gtk_entry_unset_invisible_char_w, gxg_gtk_entry_unset_invisible_char)
Xen_wrap_2_args(gxg_gtk_entry_set_progress_fraction_w, gxg_gtk_entry_set_progress_fraction)
Xen_wrap_1_arg(gxg_gtk_entry_get_progress_fraction_w, gxg_gtk_entry_get_progress_fraction)
Xen_wrap_2_args(gxg_gtk_entry_set_progress_pulse_step_w, gxg_gtk_entry_set_progress_pulse_step)
Xen_wrap_1_arg(gxg_gtk_entry_get_progress_pulse_step_w, gxg_gtk_entry_get_progress_pulse_step)
Xen_wrap_1_arg(gxg_gtk_entry_progress_pulse_w, gxg_gtk_entry_progress_pulse)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_name_w, gxg_gtk_entry_get_icon_name)
Xen_wrap_3_args(gxg_gtk_entry_set_icon_activatable_w, gxg_gtk_entry_set_icon_activatable)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_activatable_w, gxg_gtk_entry_get_icon_activatable)
Xen_wrap_3_args(gxg_gtk_entry_set_icon_sensitive_w, gxg_gtk_entry_set_icon_sensitive)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_sensitive_w, gxg_gtk_entry_get_icon_sensitive)
Xen_wrap_3_args(gxg_gtk_entry_get_icon_at_pos_w, gxg_gtk_entry_get_icon_at_pos)
Xen_wrap_3_args(gxg_gtk_entry_set_icon_tooltip_text_w, gxg_gtk_entry_set_icon_tooltip_text)
Xen_wrap_3_args(gxg_gtk_entry_set_icon_tooltip_markup_w, gxg_gtk_entry_set_icon_tooltip_markup)
Xen_wrap_2_args(gxg_gtk_menu_item_set_label_w, gxg_gtk_menu_item_set_label)
Xen_wrap_1_arg(gxg_gtk_menu_item_get_label_w, gxg_gtk_menu_item_get_label)
Xen_wrap_2_args(gxg_gtk_menu_item_set_use_underline_w, gxg_gtk_menu_item_set_use_underline)
Xen_wrap_1_arg(gxg_gtk_menu_item_get_use_underline_w, gxg_gtk_menu_item_get_use_underline)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_tooltip_text_w, gxg_gtk_entry_get_icon_tooltip_text)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_tooltip_markup_w, gxg_gtk_entry_get_icon_tooltip_markup)
Xen_wrap_4_args(gxg_gtk_scale_add_mark_w, gxg_gtk_scale_add_mark)
Xen_wrap_1_arg(gxg_gtk_scale_clear_marks_w, gxg_gtk_scale_clear_marks)
#endif

#if GTK_CHECK_VERSION(2, 18, 0)
Xen_wrap_no_args(gxg_gtk_window_get_default_icon_name_w, gxg_gtk_window_get_default_icon_name)
Xen_wrap_1_arg(gxg_gtk_label_get_current_uri_w, gxg_gtk_label_get_current_uri)
Xen_wrap_no_args(gxg_gtk_info_bar_new_w, gxg_gtk_info_bar_new)
Xen_wrap_1_arg(gxg_gtk_info_bar_get_action_area_w, gxg_gtk_info_bar_get_action_area)
Xen_wrap_1_arg(gxg_gtk_info_bar_get_content_area_w, gxg_gtk_info_bar_get_content_area)
Xen_wrap_3_args(gxg_gtk_info_bar_add_action_widget_w, gxg_gtk_info_bar_add_action_widget)
Xen_wrap_3_args(gxg_gtk_info_bar_add_button_w, gxg_gtk_info_bar_add_button)
Xen_wrap_3_args(gxg_gtk_info_bar_set_response_sensitive_w, gxg_gtk_info_bar_set_response_sensitive)
Xen_wrap_2_args(gxg_gtk_info_bar_set_default_response_w, gxg_gtk_info_bar_set_default_response)
Xen_wrap_2_args(gxg_gtk_info_bar_response_w, gxg_gtk_info_bar_response)
Xen_wrap_2_args(gxg_gtk_info_bar_set_message_type_w, gxg_gtk_info_bar_set_message_type)
Xen_wrap_1_arg(gxg_gtk_info_bar_get_message_type_w, gxg_gtk_info_bar_get_message_type)
Xen_wrap_5_optional_args(gxg_gdk_window_get_root_coords_w, gxg_gdk_window_get_root_coords)
Xen_wrap_2_args(gxg_gtk_menu_set_reserve_toggle_size_w, gxg_gtk_menu_set_reserve_toggle_size)
Xen_wrap_1_arg(gxg_gtk_menu_get_reserve_toggle_size_w, gxg_gtk_menu_get_reserve_toggle_size)
Xen_wrap_1_arg(gxg_gtk_entry_new_with_buffer_w, gxg_gtk_entry_new_with_buffer)
Xen_wrap_1_arg(gxg_gtk_entry_get_buffer_w, gxg_gtk_entry_get_buffer)
Xen_wrap_2_args(gxg_gtk_entry_set_buffer_w, gxg_gtk_entry_set_buffer)
Xen_wrap_2_args(gxg_gtk_label_set_track_visited_links_w, gxg_gtk_label_set_track_visited_links)
Xen_wrap_1_arg(gxg_gtk_label_get_track_visited_links_w, gxg_gtk_label_get_track_visited_links)
Xen_wrap_2_args(gxg_gtk_print_operation_set_embed_page_setup_w, gxg_gtk_print_operation_set_embed_page_setup)
Xen_wrap_1_arg(gxg_gtk_print_operation_get_embed_page_setup_w, gxg_gtk_print_operation_get_embed_page_setup)
Xen_wrap_2_args(gxg_gtk_entry_buffer_new_w, gxg_gtk_entry_buffer_new)
Xen_wrap_1_arg(gxg_gtk_entry_buffer_get_bytes_w, gxg_gtk_entry_buffer_get_bytes)
Xen_wrap_1_arg(gxg_gtk_entry_buffer_get_length_w, gxg_gtk_entry_buffer_get_length)
Xen_wrap_1_arg(gxg_gtk_entry_buffer_get_text_w, gxg_gtk_entry_buffer_get_text)
Xen_wrap_3_args(gxg_gtk_entry_buffer_set_text_w, gxg_gtk_entry_buffer_set_text)
Xen_wrap_2_args(gxg_gtk_entry_buffer_set_max_length_w, gxg_gtk_entry_buffer_set_max_length)
Xen_wrap_1_arg(gxg_gtk_entry_buffer_get_max_length_w, gxg_gtk_entry_buffer_get_max_length)
Xen_wrap_4_args(gxg_gtk_entry_buffer_insert_text_w, gxg_gtk_entry_buffer_insert_text)
Xen_wrap_3_args(gxg_gtk_entry_buffer_delete_text_w, gxg_gtk_entry_buffer_delete_text)
Xen_wrap_4_args(gxg_gtk_entry_buffer_emit_inserted_text_w, gxg_gtk_entry_buffer_emit_inserted_text)
Xen_wrap_3_args(gxg_gtk_entry_buffer_emit_deleted_text_w, gxg_gtk_entry_buffer_emit_deleted_text)
Xen_wrap_3_args(gxg_gtk_cell_renderer_set_alignment_w, gxg_gtk_cell_renderer_set_alignment)
Xen_wrap_3_optional_args(gxg_gtk_cell_renderer_get_alignment_w, gxg_gtk_cell_renderer_get_alignment)
Xen_wrap_3_args(gxg_gtk_cell_renderer_set_padding_w, gxg_gtk_cell_renderer_set_padding)
Xen_wrap_3_optional_args(gxg_gtk_cell_renderer_get_padding_w, gxg_gtk_cell_renderer_get_padding)
Xen_wrap_2_args(gxg_gtk_cell_renderer_set_visible_w, gxg_gtk_cell_renderer_set_visible)
Xen_wrap_1_arg(gxg_gtk_cell_renderer_get_visible_w, gxg_gtk_cell_renderer_get_visible)
Xen_wrap_2_args(gxg_gtk_cell_renderer_set_sensitive_w, gxg_gtk_cell_renderer_set_sensitive)
Xen_wrap_1_arg(gxg_gtk_cell_renderer_get_sensitive_w, gxg_gtk_cell_renderer_get_sensitive)
Xen_wrap_1_arg(gxg_gtk_cell_renderer_toggle_get_activatable_w, gxg_gtk_cell_renderer_toggle_get_activatable)
Xen_wrap_2_args(gxg_gtk_cell_renderer_toggle_set_activatable_w, gxg_gtk_cell_renderer_toggle_set_activatable)
Xen_wrap_2_args(gxg_gtk_widget_set_can_focus_w, gxg_gtk_widget_set_can_focus)
Xen_wrap_1_arg(gxg_gtk_widget_get_can_focus_w, gxg_gtk_widget_get_can_focus)
Xen_wrap_1_arg(gxg_gtk_widget_has_focus_w, gxg_gtk_widget_has_focus)
Xen_wrap_2_args(gxg_gtk_widget_set_can_default_w, gxg_gtk_widget_set_can_default)
Xen_wrap_1_arg(gxg_gtk_widget_get_can_default_w, gxg_gtk_widget_get_can_default)
Xen_wrap_1_arg(gxg_gtk_widget_has_default_w, gxg_gtk_widget_has_default)
Xen_wrap_1_arg(gxg_gtk_widget_get_sensitive_w, gxg_gtk_widget_get_sensitive)
Xen_wrap_1_arg(gxg_gtk_widget_is_sensitive_w, gxg_gtk_widget_is_sensitive)
Xen_wrap_2_args(gxg_gtk_widget_set_has_window_w, gxg_gtk_widget_set_has_window)
Xen_wrap_1_arg(gxg_gtk_widget_get_has_window_w, gxg_gtk_widget_get_has_window)
Xen_wrap_1_arg(gxg_gdk_window_get_cursor_w, gxg_gdk_window_get_cursor)
Xen_wrap_2_args(gxg_gtk_file_chooser_set_create_folders_w, gxg_gtk_file_chooser_set_create_folders)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_create_folders_w, gxg_gtk_file_chooser_get_create_folders)
Xen_wrap_2_args(gxg_gtk_icon_view_set_item_padding_w, gxg_gtk_icon_view_set_item_padding)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_item_padding_w, gxg_gtk_icon_view_get_item_padding)
Xen_wrap_1_arg(gxg_gtk_widget_has_grab_w, gxg_gtk_widget_has_grab)
Xen_wrap_2_args(gxg_gtk_widget_set_visible_w, gxg_gtk_widget_set_visible)
Xen_wrap_1_arg(gxg_gtk_widget_get_visible_w, gxg_gtk_widget_get_visible)
Xen_wrap_2_args(gxg_gtk_range_set_flippable_w, gxg_gtk_range_set_flippable)
Xen_wrap_1_arg(gxg_gtk_range_get_flippable_w, gxg_gtk_range_get_flippable)
Xen_wrap_1_arg(gxg_gtk_widget_is_toplevel_w, gxg_gtk_widget_is_toplevel)
Xen_wrap_1_arg(gxg_gtk_widget_is_drawable_w, gxg_gtk_widget_is_drawable)
Xen_wrap_2_args(gxg_gtk_widget_set_window_w, gxg_gtk_widget_set_window)
Xen_wrap_1_arg(gxg_gdk_window_is_destroyed_w, gxg_gdk_window_is_destroyed)
Xen_wrap_3_args(gxg_gdk_window_restack_w, gxg_gdk_window_restack)
Xen_wrap_2_args(gxg_gtk_widget_set_receives_default_w, gxg_gtk_widget_set_receives_default)
Xen_wrap_1_arg(gxg_gtk_widget_get_receives_default_w, gxg_gtk_widget_get_receives_default)
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
Xen_wrap_2_args(gxg_gtk_dialog_get_widget_for_response_w, gxg_gtk_dialog_get_widget_for_response)
Xen_wrap_no_args(gxg_gtk_spinner_new_w, gxg_gtk_spinner_new)
Xen_wrap_1_arg(gxg_gtk_spinner_start_w, gxg_gtk_spinner_start)
Xen_wrap_1_arg(gxg_gtk_spinner_stop_w, gxg_gtk_spinner_stop)
Xen_wrap_no_args(gxg_gtk_cell_renderer_spinner_new_w, gxg_gtk_cell_renderer_spinner_new)
Xen_wrap_2_args(gxg_gtk_notebook_get_action_widget_w, gxg_gtk_notebook_get_action_widget)
Xen_wrap_3_args(gxg_gtk_notebook_set_action_widget_w, gxg_gtk_notebook_set_action_widget)
Xen_wrap_1_arg(gxg_gtk_statusbar_get_message_area_w, gxg_gtk_statusbar_get_message_area)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_ellipsize_mode_w, gxg_gtk_tool_item_get_ellipsize_mode)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_text_alignment_w, gxg_gtk_tool_item_get_text_alignment)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_text_orientation_w, gxg_gtk_tool_item_get_text_orientation)
Xen_wrap_1_arg(gxg_gtk_tool_item_get_text_size_group_w, gxg_gtk_tool_item_get_text_size_group)
Xen_wrap_no_args(gxg_gtk_tool_palette_new_w, gxg_gtk_tool_palette_new)
Xen_wrap_3_args(gxg_gtk_tool_palette_set_group_position_w, gxg_gtk_tool_palette_set_group_position)
Xen_wrap_3_args(gxg_gtk_tool_palette_set_exclusive_w, gxg_gtk_tool_palette_set_exclusive)
Xen_wrap_3_args(gxg_gtk_tool_palette_set_expand_w, gxg_gtk_tool_palette_set_expand)
Xen_wrap_2_args(gxg_gtk_tool_palette_get_group_position_w, gxg_gtk_tool_palette_get_group_position)
Xen_wrap_2_args(gxg_gtk_tool_palette_get_exclusive_w, gxg_gtk_tool_palette_get_exclusive)
Xen_wrap_2_args(gxg_gtk_tool_palette_get_expand_w, gxg_gtk_tool_palette_get_expand)
Xen_wrap_2_args(gxg_gtk_tool_palette_set_style_w, gxg_gtk_tool_palette_set_style)
Xen_wrap_1_arg(gxg_gtk_tool_palette_unset_style_w, gxg_gtk_tool_palette_unset_style)
Xen_wrap_1_arg(gxg_gtk_tool_palette_get_style_w, gxg_gtk_tool_palette_get_style)
Xen_wrap_3_args(gxg_gtk_tool_palette_get_drop_item_w, gxg_gtk_tool_palette_get_drop_item)
Xen_wrap_3_args(gxg_gtk_tool_palette_get_drop_group_w, gxg_gtk_tool_palette_get_drop_group)
Xen_wrap_2_args(gxg_gtk_tool_palette_get_drag_item_w, gxg_gtk_tool_palette_get_drag_item)
Xen_wrap_2_args(gxg_gtk_tool_palette_set_drag_source_w, gxg_gtk_tool_palette_set_drag_source)
Xen_wrap_5_args(gxg_gtk_tool_palette_add_drag_dest_w, gxg_gtk_tool_palette_add_drag_dest)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_new_w, gxg_gtk_tool_item_group_new)
Xen_wrap_2_args(gxg_gtk_tool_item_group_set_label_w, gxg_gtk_tool_item_group_set_label)
Xen_wrap_2_args(gxg_gtk_tool_item_group_set_label_widget_w, gxg_gtk_tool_item_group_set_label_widget)
Xen_wrap_2_args(gxg_gtk_tool_item_group_set_collapsed_w, gxg_gtk_tool_item_group_set_collapsed)
Xen_wrap_2_args(gxg_gtk_tool_item_group_set_ellipsize_w, gxg_gtk_tool_item_group_set_ellipsize)
Xen_wrap_2_args(gxg_gtk_tool_item_group_set_header_relief_w, gxg_gtk_tool_item_group_set_header_relief)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_get_label_w, gxg_gtk_tool_item_group_get_label)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_get_label_widget_w, gxg_gtk_tool_item_group_get_label_widget)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_get_collapsed_w, gxg_gtk_tool_item_group_get_collapsed)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_get_ellipsize_w, gxg_gtk_tool_item_group_get_ellipsize)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_get_header_relief_w, gxg_gtk_tool_item_group_get_header_relief)
Xen_wrap_3_args(gxg_gtk_tool_item_group_insert_w, gxg_gtk_tool_item_group_insert)
Xen_wrap_3_args(gxg_gtk_tool_item_group_set_item_position_w, gxg_gtk_tool_item_group_set_item_position)
Xen_wrap_2_args(gxg_gtk_tool_item_group_get_item_position_w, gxg_gtk_tool_item_group_get_item_position)
Xen_wrap_1_arg(gxg_gtk_tool_item_group_get_n_items_w, gxg_gtk_tool_item_group_get_n_items)
Xen_wrap_2_args(gxg_gtk_tool_item_group_get_nth_item_w, gxg_gtk_tool_item_group_get_nth_item)
Xen_wrap_3_args(gxg_gtk_tool_item_group_get_drop_item_w, gxg_gtk_tool_item_group_get_drop_item)
Xen_wrap_2_args(gxg_gtk_window_set_mnemonics_visible_w, gxg_gtk_window_set_mnemonics_visible)
Xen_wrap_1_arg(gxg_gtk_window_get_mnemonics_visible_w, gxg_gtk_window_get_mnemonics_visible)
Xen_wrap_2_args(gxg_gtk_range_set_slider_size_fixed_w, gxg_gtk_range_set_slider_size_fixed)
Xen_wrap_1_arg(gxg_gtk_range_get_slider_size_fixed_w, gxg_gtk_range_get_slider_size_fixed)
Xen_wrap_2_args(gxg_gtk_range_get_range_rect_w, gxg_gtk_range_get_range_rect)
Xen_wrap_3_optional_args(gxg_gtk_range_get_slider_range_w, gxg_gtk_range_get_slider_range)
Xen_wrap_2_args(gxg_gtk_widget_set_realized_w, gxg_gtk_widget_set_realized)
Xen_wrap_1_arg(gxg_gtk_widget_get_realized_w, gxg_gtk_widget_get_realized)
Xen_wrap_1_arg(gxg_gtk_widget_get_mapped_w, gxg_gtk_widget_get_mapped)
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
Xen_wrap_5_optional_args(gxg_gdk_window_get_geometry_w, gxg_gdk_window_get_geometry)
Xen_wrap_2_args(gxg_gdk_keymap_add_virtual_modifiers_w, gxg_gdk_keymap_add_virtual_modifiers)
Xen_wrap_5_optional_args(gxg_gdk_window_coords_to_parent_w, gxg_gdk_window_coords_to_parent)
Xen_wrap_5_optional_args(gxg_gdk_window_coords_from_parent_w, gxg_gdk_window_coords_from_parent)
Xen_wrap_1_arg(gxg_gtk_accessible_get_widget_w, gxg_gtk_accessible_get_widget)
Xen_wrap_2_args(gxg_gtk_widget_send_focus_change_w, gxg_gtk_widget_send_focus_change)
Xen_wrap_1_arg(gxg_gdk_drag_context_get_device_w, gxg_gdk_drag_context_get_device)
Xen_wrap_2_args(gxg_gdk_event_set_device_w, gxg_gdk_event_set_device)
Xen_wrap_1_arg(gxg_gdk_event_get_device_w, gxg_gdk_event_get_device)
Xen_wrap_3_optional_args(gxg_gdk_events_get_distance_w, gxg_gdk_events_get_distance)
Xen_wrap_3_optional_args(gxg_gdk_events_get_angle_w, gxg_gdk_events_get_angle)
Xen_wrap_4_optional_args(gxg_gdk_events_get_center_w, gxg_gdk_events_get_center)
Xen_wrap_1_arg(gxg_gdk_window_get_accept_focus_w, gxg_gdk_window_get_accept_focus)
Xen_wrap_1_arg(gxg_gdk_window_get_focus_on_map_w, gxg_gdk_window_get_focus_on_map)
Xen_wrap_1_arg(gxg_gdk_window_is_input_only_w, gxg_gdk_window_is_input_only)
Xen_wrap_1_arg(gxg_gdk_window_is_shaped_w, gxg_gdk_window_is_shaped)
Xen_wrap_1_arg(gxg_gdk_window_get_modal_hint_w, gxg_gdk_window_get_modal_hint)
Xen_wrap_3_args(gxg_gdk_window_set_device_cursor_w, gxg_gdk_window_set_device_cursor)
Xen_wrap_2_args(gxg_gdk_window_get_device_cursor_w, gxg_gdk_window_get_device_cursor)
Xen_wrap_5_optional_args(gxg_gdk_window_get_device_position_w, gxg_gdk_window_get_device_position)
Xen_wrap_3_args(gxg_gdk_window_set_device_events_w, gxg_gdk_window_set_device_events)
Xen_wrap_2_args(gxg_gdk_window_get_device_events_w, gxg_gdk_window_get_device_events)
Xen_wrap_2_args(gxg_gtk_combo_box_popup_for_device_w, gxg_gtk_combo_box_popup_for_device)
Xen_wrap_3_args(gxg_gtk_device_grab_add_w, gxg_gtk_device_grab_add)
Xen_wrap_2_args(gxg_gtk_device_grab_remove_w, gxg_gtk_device_grab_remove)
Xen_wrap_no_args(gxg_gtk_get_current_event_device_w, gxg_gtk_get_current_event_device)
Xen_wrap_1_arg(gxg_gtk_paned_new_w, gxg_gtk_paned_new)
Xen_wrap_2_args(gxg_gtk_scale_new_w, gxg_gtk_scale_new)
Xen_wrap_4_args(gxg_gtk_scale_new_with_range_w, gxg_gtk_scale_new_with_range)
Xen_wrap_2_args(gxg_gtk_scrollbar_new_w, gxg_gtk_scrollbar_new)
Xen_wrap_1_arg(gxg_gtk_separator_new_w, gxg_gtk_separator_new)
Xen_wrap_2_args(gxg_gtk_widget_device_is_shadowed_w, gxg_gtk_widget_device_is_shadowed)
Xen_wrap_1_arg(gxg_gtk_widget_get_support_multidevice_w, gxg_gtk_widget_get_support_multidevice)
Xen_wrap_2_args(gxg_gtk_widget_set_support_multidevice_w, gxg_gtk_widget_set_support_multidevice)
Xen_wrap_2_args(gxg_gtk_icon_view_get_item_row_w, gxg_gtk_icon_view_get_item_row)
Xen_wrap_2_args(gxg_gtk_icon_view_get_item_column_w, gxg_gtk_icon_view_get_item_column)
Xen_wrap_2_args(gxg_gtk_statusbar_remove_all_w, gxg_gtk_statusbar_remove_all)
Xen_wrap_1_arg(gxg_gtk_window_has_group_w, gxg_gtk_window_has_group)
Xen_wrap_3_args(gxg_gtk_calendar_select_month_w, gxg_gtk_calendar_select_month)
Xen_wrap_2_args(gxg_gtk_calendar_mark_day_w, gxg_gtk_calendar_mark_day)
Xen_wrap_2_args(gxg_gtk_calendar_unmark_day_w, gxg_gtk_calendar_unmark_day)
Xen_wrap_1_arg(gxg_gdk_drag_context_get_source_window_w, gxg_gdk_drag_context_get_source_window)
Xen_wrap_2_args(gxg_gtk_accessible_set_widget_w, gxg_gtk_accessible_set_widget)
Xen_wrap_1_arg(gxg_gtk_message_dialog_get_message_area_w, gxg_gtk_message_dialog_get_message_area)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_length_w, gxg_gtk_selection_data_get_length)
Xen_wrap_5_args(gxg_gdk_pango_layout_line_get_clip_region_w, gxg_gdk_pango_layout_line_get_clip_region)
Xen_wrap_5_args(gxg_gdk_pango_layout_get_clip_region_w, gxg_gdk_pango_layout_get_clip_region)
Xen_wrap_4_args(gxg_gdk_window_shape_combine_region_w, gxg_gdk_window_shape_combine_region)
Xen_wrap_3_args(gxg_gdk_window_invalidate_region_w, gxg_gdk_window_invalidate_region)
Xen_wrap_1_arg(gxg_gdk_window_get_update_area_w, gxg_gdk_window_get_update_area)
Xen_wrap_4_args(gxg_gdk_window_move_region_w, gxg_gdk_window_move_region)
Xen_wrap_1_arg(gxg_gdk_keymap_get_num_lock_state_w, gxg_gdk_keymap_get_num_lock_state)
Xen_wrap_1_arg(gxg_gdk_window_has_native_w, gxg_gdk_window_has_native)
Xen_wrap_1_arg(gxg_gdk_display_is_closed_w, gxg_gdk_display_is_closed)
Xen_wrap_4_args(gxg_gdk_window_create_similar_surface_w, gxg_gdk_window_create_similar_surface)
Xen_wrap_2_args(gxg_gtk_expander_set_label_fill_w, gxg_gtk_expander_set_label_fill)
Xen_wrap_1_arg(gxg_gtk_expander_get_label_fill_w, gxg_gtk_expander_get_label_fill)
Xen_wrap_2_args(gxg_gtk_calendar_get_day_is_marked_w, gxg_gtk_calendar_get_day_is_marked)
Xen_wrap_2_args(gxg_gtk_progress_bar_set_inverted_w, gxg_gtk_progress_bar_set_inverted)
Xen_wrap_1_arg(gxg_gtk_progress_bar_get_inverted_w, gxg_gtk_progress_bar_get_inverted)
Xen_wrap_2_args(gxg_gtk_radio_button_join_group_w, gxg_gtk_radio_button_join_group)
Xen_wrap_6_args(gxg_gtk_adjustment_new_w, gxg_gtk_adjustment_new)
Xen_wrap_4_args(gxg_gtk_binding_set_activate_w, gxg_gtk_binding_set_activate)
Xen_wrap_3_args(gxg_gtk_bindings_activate_w, gxg_gtk_bindings_activate)
Xen_wrap_2_args(gxg_gtk_icon_view_create_drag_icon_w, gxg_gtk_icon_view_create_drag_icon)
Xen_wrap_2_args(gxg_gtk_tree_view_create_row_drag_icon_w, gxg_gtk_tree_view_create_row_drag_icon)
Xen_wrap_2_args(gxg_gdk_cairo_get_clip_rectangle_w, gxg_gdk_cairo_get_clip_rectangle)
Xen_wrap_1_arg(gxg_gdk_cairo_region_create_from_surface_w, gxg_gdk_cairo_region_create_from_surface)
Xen_wrap_1_arg(gxg_gdk_window_get_display_w, gxg_gdk_window_get_display)
Xen_wrap_1_arg(gxg_gdk_window_get_width_w, gxg_gdk_window_get_width)
Xen_wrap_1_arg(gxg_gdk_window_get_height_w, gxg_gdk_window_get_height)
Xen_wrap_1_arg(gxg_gtk_cell_renderer_get_request_mode_w, gxg_gtk_cell_renderer_get_request_mode)
Xen_wrap_4_optional_args(gxg_gtk_cell_renderer_get_preferred_width_w, gxg_gtk_cell_renderer_get_preferred_width)
Xen_wrap_5_optional_args(gxg_gtk_cell_renderer_get_preferred_height_for_width_w, gxg_gtk_cell_renderer_get_preferred_height_for_width)
Xen_wrap_4_optional_args(gxg_gtk_cell_renderer_get_preferred_height_w, gxg_gtk_cell_renderer_get_preferred_height)
Xen_wrap_5_optional_args(gxg_gtk_cell_renderer_get_preferred_width_for_height_w, gxg_gtk_cell_renderer_get_preferred_width_for_height)
Xen_wrap_2_args(gxg_gtk_drag_set_icon_surface_w, gxg_gtk_drag_set_icon_surface)
Xen_wrap_2_args(gxg_gtk_notebook_set_group_name_w, gxg_gtk_notebook_set_group_name)
Xen_wrap_1_arg(gxg_gtk_notebook_get_group_name_w, gxg_gtk_notebook_get_group_name)
Xen_wrap_2_args(gxg_gtk_widget_draw_w, gxg_gtk_widget_draw)
Xen_wrap_1_arg(gxg_gtk_widget_get_request_mode_w, gxg_gtk_widget_get_request_mode)
Xen_wrap_1_arg(gxg_gtk_widget_get_allocated_width_w, gxg_gtk_widget_get_allocated_width)
Xen_wrap_1_arg(gxg_gtk_widget_get_allocated_height_w, gxg_gtk_widget_get_allocated_height)
Xen_wrap_1_arg(gxg_gtk_widget_get_halign_w, gxg_gtk_widget_get_halign)
Xen_wrap_2_args(gxg_gtk_widget_set_halign_w, gxg_gtk_widget_set_halign)
Xen_wrap_1_arg(gxg_gtk_widget_get_valign_w, gxg_gtk_widget_get_valign)
Xen_wrap_2_args(gxg_gtk_widget_set_valign_w, gxg_gtk_widget_set_valign)
Xen_wrap_1_arg(gxg_gtk_widget_get_margin_top_w, gxg_gtk_widget_get_margin_top)
Xen_wrap_2_args(gxg_gtk_widget_set_margin_top_w, gxg_gtk_widget_set_margin_top)
Xen_wrap_1_arg(gxg_gtk_widget_get_margin_bottom_w, gxg_gtk_widget_get_margin_bottom)
Xen_wrap_2_args(gxg_gtk_widget_set_margin_bottom_w, gxg_gtk_widget_set_margin_bottom)
Xen_wrap_2_args(gxg_gtk_widget_shape_combine_region_w, gxg_gtk_widget_shape_combine_region)
Xen_wrap_2_args(gxg_gtk_widget_input_shape_combine_region_w, gxg_gtk_widget_input_shape_combine_region)
Xen_wrap_no_args(gxg_gtk_combo_box_new_with_entry_w, gxg_gtk_combo_box_new_with_entry)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_has_entry_w, gxg_gtk_combo_box_get_has_entry)
Xen_wrap_2_args(gxg_gtk_combo_box_set_entry_text_column_w, gxg_gtk_combo_box_set_entry_text_column)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_entry_text_column_w, gxg_gtk_combo_box_get_entry_text_column)
Xen_wrap_1_arg(gxg_gtk_widget_get_hexpand_w, gxg_gtk_widget_get_hexpand)
Xen_wrap_2_args(gxg_gtk_widget_set_hexpand_w, gxg_gtk_widget_set_hexpand)
Xen_wrap_1_arg(gxg_gtk_widget_get_hexpand_set_w, gxg_gtk_widget_get_hexpand_set)
Xen_wrap_2_args(gxg_gtk_widget_set_hexpand_set_w, gxg_gtk_widget_set_hexpand_set)
Xen_wrap_1_arg(gxg_gtk_widget_get_vexpand_w, gxg_gtk_widget_get_vexpand)
Xen_wrap_2_args(gxg_gtk_widget_set_vexpand_w, gxg_gtk_widget_set_vexpand)
Xen_wrap_1_arg(gxg_gtk_widget_get_vexpand_set_w, gxg_gtk_widget_get_vexpand_set)
Xen_wrap_2_args(gxg_gtk_widget_set_vexpand_set_w, gxg_gtk_widget_set_vexpand_set)
Xen_wrap_1_arg(gxg_gtk_widget_queue_compute_expand_w, gxg_gtk_widget_queue_compute_expand)
Xen_wrap_2_args(gxg_gtk_widget_compute_expand_w, gxg_gtk_widget_compute_expand)
Xen_wrap_no_args(gxg_gtk_combo_box_text_new_w, gxg_gtk_combo_box_text_new)
Xen_wrap_no_args(gxg_gtk_combo_box_text_new_with_entry_w, gxg_gtk_combo_box_text_new_with_entry)
Xen_wrap_2_args(gxg_gtk_combo_box_text_append_text_w, gxg_gtk_combo_box_text_append_text)
Xen_wrap_3_args(gxg_gtk_combo_box_text_insert_text_w, gxg_gtk_combo_box_text_insert_text)
Xen_wrap_2_args(gxg_gtk_combo_box_text_prepend_text_w, gxg_gtk_combo_box_text_prepend_text)
Xen_wrap_2_args(gxg_gtk_combo_box_text_remove_w, gxg_gtk_combo_box_text_remove)
Xen_wrap_1_arg(gxg_gtk_combo_box_text_get_active_text_w, gxg_gtk_combo_box_text_get_active_text)
Xen_wrap_2_args(gxg_gdk_cairo_set_source_rgba_w, gxg_gdk_cairo_set_source_rgba)
Xen_wrap_1_arg(gxg_gtk_combo_box_text_remove_all_w, gxg_gtk_combo_box_text_remove_all)
Xen_wrap_2_args(gxg_gtk_combo_box_set_popup_fixed_width_w, gxg_gtk_combo_box_set_popup_fixed_width)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_popup_fixed_width_w, gxg_gtk_combo_box_get_popup_fixed_width)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_min_content_width_w, gxg_gtk_scrolled_window_get_min_content_width)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_min_content_width_w, gxg_gtk_scrolled_window_set_min_content_width)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_min_content_height_w, gxg_gtk_scrolled_window_get_min_content_height)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_min_content_height_w, gxg_gtk_scrolled_window_set_min_content_height)
Xen_wrap_no_args(gxg_gtk_grid_new_w, gxg_gtk_grid_new)
Xen_wrap_6_args(gxg_gtk_grid_attach_w, gxg_gtk_grid_attach)
Xen_wrap_6_args(gxg_gtk_grid_attach_next_to_w, gxg_gtk_grid_attach_next_to)
Xen_wrap_2_args(gxg_gtk_grid_set_row_homogeneous_w, gxg_gtk_grid_set_row_homogeneous)
Xen_wrap_1_arg(gxg_gtk_grid_get_row_homogeneous_w, gxg_gtk_grid_get_row_homogeneous)
Xen_wrap_2_args(gxg_gtk_grid_set_row_spacing_w, gxg_gtk_grid_set_row_spacing)
Xen_wrap_1_arg(gxg_gtk_grid_get_row_spacing_w, gxg_gtk_grid_get_row_spacing)
Xen_wrap_2_args(gxg_gtk_grid_set_column_homogeneous_w, gxg_gtk_grid_set_column_homogeneous)
Xen_wrap_1_arg(gxg_gtk_grid_get_column_homogeneous_w, gxg_gtk_grid_get_column_homogeneous)
Xen_wrap_2_args(gxg_gtk_grid_set_column_spacing_w, gxg_gtk_grid_set_column_spacing)
Xen_wrap_1_arg(gxg_gtk_grid_get_column_spacing_w, gxg_gtk_grid_get_column_spacing)
Xen_wrap_1_arg(gxg_gtk_scrollable_get_hadjustment_w, gxg_gtk_scrollable_get_hadjustment)
Xen_wrap_2_args(gxg_gtk_scrollable_set_hadjustment_w, gxg_gtk_scrollable_set_hadjustment)
Xen_wrap_1_arg(gxg_gtk_scrollable_get_vadjustment_w, gxg_gtk_scrollable_get_vadjustment)
Xen_wrap_2_args(gxg_gtk_scrollable_set_vadjustment_w, gxg_gtk_scrollable_set_vadjustment)
Xen_wrap_1_arg(gxg_gtk_assistant_next_page_w, gxg_gtk_assistant_next_page)
Xen_wrap_1_arg(gxg_gtk_assistant_previous_page_w, gxg_gtk_assistant_previous_page)
Xen_wrap_1_arg(gxg_gtk_combo_box_new_with_model_and_entry_w, gxg_gtk_combo_box_new_with_model_and_entry)
Xen_wrap_1_arg(gxg_gtk_scrollable_get_hscroll_policy_w, gxg_gtk_scrollable_get_hscroll_policy)
Xen_wrap_2_args(gxg_gtk_scrollable_set_hscroll_policy_w, gxg_gtk_scrollable_set_hscroll_policy)
Xen_wrap_1_arg(gxg_gtk_scrollable_get_vscroll_policy_w, gxg_gtk_scrollable_get_vscroll_policy)
Xen_wrap_2_args(gxg_gtk_scrollable_set_vscroll_policy_w, gxg_gtk_scrollable_set_vscroll_policy)
Xen_wrap_no_args(gxg_gtk_switch_new_w, gxg_gtk_switch_new)
Xen_wrap_2_args(gxg_gtk_switch_set_active_w, gxg_gtk_switch_set_active)
Xen_wrap_1_arg(gxg_gtk_switch_get_active_w, gxg_gtk_switch_get_active)
Xen_wrap_1_arg(gxg_gdk_window_get_clip_region_w, gxg_gdk_window_get_clip_region)
Xen_wrap_1_arg(gxg_gdk_window_get_visible_region_w, gxg_gdk_window_get_visible_region)
Xen_wrap_no_args(gxg_gtk_border_new_w, gxg_gtk_border_new)
Xen_wrap_1_arg(gxg_gtk_border_copy_w, gxg_gtk_border_copy)
Xen_wrap_1_arg(gxg_gtk_border_free_w, gxg_gtk_border_free)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_id_column_w, gxg_gtk_combo_box_get_id_column)
Xen_wrap_2_args(gxg_gtk_combo_box_set_id_column_w, gxg_gtk_combo_box_set_id_column)
Xen_wrap_1_arg(gxg_gtk_combo_box_get_active_id_w, gxg_gtk_combo_box_get_active_id)
Xen_wrap_4_args(gxg_gtk_combo_box_text_insert_w, gxg_gtk_combo_box_text_insert)
Xen_wrap_3_args(gxg_gtk_combo_box_text_append_w, gxg_gtk_combo_box_text_append)
Xen_wrap_3_args(gxg_gtk_combo_box_text_prepend_w, gxg_gtk_combo_box_text_prepend)
Xen_wrap_1_arg(gxg_gtk_button_box_new_w, gxg_gtk_button_box_new)
Xen_wrap_2_args(gxg_gtk_box_new_w, gxg_gtk_box_new)
Xen_wrap_5_args(gxg_gtk_tree_view_set_cursor_on_cell_w, gxg_gtk_tree_view_set_cursor_on_cell)
Xen_wrap_2_args(gxg_gtk_tree_view_set_rubber_banding_w, gxg_gtk_tree_view_set_rubber_banding)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_rubber_banding_w, gxg_gtk_tree_view_get_rubber_banding)
Xen_wrap_2_args(gxg_gtk_tooltip_set_markup_w, gxg_gtk_tooltip_set_markup)
Xen_wrap_2_args(gxg_gtk_tooltip_set_custom_w, gxg_gtk_tooltip_set_custom)
Xen_wrap_1_arg(gxg_gtk_tooltip_trigger_tooltip_query_w, gxg_gtk_tooltip_trigger_tooltip_query)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_new_with_area_w, gxg_gtk_tree_view_column_new_with_area)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_button_w, gxg_gtk_tree_view_column_get_button)
Xen_wrap_2_args(gxg_gtk_tree_view_column_focus_cell_w, gxg_gtk_tree_view_column_focus_cell)
Xen_wrap_3_args(gxg_gtk_toolbar_set_drop_highlight_item_w, gxg_gtk_toolbar_set_drop_highlight_item)
Xen_wrap_1_arg(gxg_gtk_tool_item_toolbar_reconfigured_w, gxg_gtk_tool_item_toolbar_reconfigured)
Xen_wrap_2_args(gxg_gtk_orientable_set_orientation_w, gxg_gtk_orientable_set_orientation)
Xen_wrap_1_arg(gxg_gtk_orientable_get_orientation_w, gxg_gtk_orientable_get_orientation)
Xen_wrap_no_args(gxg_gtk_get_major_version_w, gxg_gtk_get_major_version)
Xen_wrap_no_args(gxg_gtk_get_minor_version_w, gxg_gtk_get_minor_version)
Xen_wrap_no_args(gxg_gtk_get_micro_version_w, gxg_gtk_get_micro_version)
Xen_wrap_no_args(gxg_gtk_get_binary_age_w, gxg_gtk_get_binary_age)
Xen_wrap_no_args(gxg_gtk_get_interface_age_w, gxg_gtk_get_interface_age)
Xen_wrap_2_args(gxg_gtk_progress_bar_set_show_text_w, gxg_gtk_progress_bar_set_show_text)
Xen_wrap_1_arg(gxg_gtk_progress_bar_get_show_text_w, gxg_gtk_progress_bar_get_show_text)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_storage_type_w, gxg_gtk_entry_get_icon_storage_type)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_gicon_w, gxg_gtk_entry_get_icon_gicon)
Xen_wrap_2_args(gxg_gtk_container_set_focus_chain_w, gxg_gtk_container_set_focus_chain)
Xen_wrap_2_optional_args(gxg_gtk_container_get_focus_chain_w, gxg_gtk_container_get_focus_chain)
Xen_wrap_1_arg(gxg_gtk_container_unset_focus_chain_w, gxg_gtk_container_unset_focus_chain)
Xen_wrap_2_args(gxg_gtk_container_set_focus_vadjustment_w, gxg_gtk_container_set_focus_vadjustment)
Xen_wrap_1_arg(gxg_gtk_container_get_focus_vadjustment_w, gxg_gtk_container_get_focus_vadjustment)
Xen_wrap_2_args(gxg_gtk_container_set_focus_hadjustment_w, gxg_gtk_container_set_focus_hadjustment)
Xen_wrap_1_arg(gxg_gtk_container_get_focus_hadjustment_w, gxg_gtk_container_get_focus_hadjustment)
Xen_wrap_1_arg(gxg_gtk_assistant_commit_w, gxg_gtk_assistant_commit)
Xen_wrap_2_args(gxg_gtk_window_set_skip_taskbar_hint_w, gxg_gtk_window_set_skip_taskbar_hint)
Xen_wrap_1_arg(gxg_gtk_window_get_skip_taskbar_hint_w, gxg_gtk_window_get_skip_taskbar_hint)
Xen_wrap_2_args(gxg_gtk_window_set_skip_pager_hint_w, gxg_gtk_window_set_skip_pager_hint)
Xen_wrap_1_arg(gxg_gtk_window_get_skip_pager_hint_w, gxg_gtk_window_get_skip_pager_hint)
Xen_wrap_3_optional_args(gxg_gtk_window_set_icon_from_file_w, gxg_gtk_window_set_icon_from_file)
Xen_wrap_2_optional_args(gxg_gtk_window_set_default_icon_from_file_w, gxg_gtk_window_set_default_icon_from_file)
Xen_wrap_1_arg(gxg_gtk_window_fullscreen_w, gxg_gtk_window_fullscreen)
Xen_wrap_1_arg(gxg_gtk_window_unfullscreen_w, gxg_gtk_window_unfullscreen)
Xen_wrap_1_arg(gxg_gtk_window_get_window_type_w, gxg_gtk_window_get_window_type)
Xen_wrap_2_args(gxg_gtk_window_group_add_window_w, gxg_gtk_window_group_add_window)
Xen_wrap_2_args(gxg_gtk_window_group_remove_window_w, gxg_gtk_window_group_remove_window)
Xen_wrap_no_args(gxg_gtk_window_group_new_w, gxg_gtk_window_group_new)
Xen_wrap_1_arg(gxg_gtk_window_get_group_w, gxg_gtk_window_get_group)
Xen_wrap_1_arg(gxg_gtk_window_group_list_windows_w, gxg_gtk_window_group_list_windows)
Xen_wrap_2_args(gxg_gtk_window_group_get_current_device_grab_w, gxg_gtk_window_group_get_current_device_grab)
Xen_wrap_1_arg(gxg_gtk_window_group_get_current_grab_w, gxg_gtk_window_group_get_current_grab)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_data_w, gxg_gtk_selection_data_get_data)
Xen_wrap_1_arg(gxg_gtk_tool_shell_get_text_orientation_w, gxg_gtk_tool_shell_get_text_orientation)
Xen_wrap_1_arg(gxg_gtk_tool_shell_get_text_alignment_w, gxg_gtk_tool_shell_get_text_alignment)
Xen_wrap_1_arg(gxg_gtk_tool_shell_get_ellipsize_mode_w, gxg_gtk_tool_shell_get_ellipsize_mode)
Xen_wrap_1_arg(gxg_gtk_tool_shell_get_text_size_group_w, gxg_gtk_tool_shell_get_text_size_group)
Xen_wrap_1_arg(gxg_gtk_tool_shell_get_orientation_w, gxg_gtk_tool_shell_get_orientation)
Xen_wrap_1_arg(gxg_gtk_tool_shell_get_style_w, gxg_gtk_tool_shell_get_style)
Xen_wrap_1_arg(gxg_gtk_tool_shell_rebuild_menu_w, gxg_gtk_tool_shell_rebuild_menu)
Xen_wrap_1_arg(gxg_gtk_accel_map_lock_path_w, gxg_gtk_accel_map_lock_path)
Xen_wrap_1_arg(gxg_gtk_accel_map_unlock_path_w, gxg_gtk_accel_map_unlock_path)
Xen_wrap_4_args(gxg_gtk_icon_theme_lookup_by_gicon_w, gxg_gtk_icon_theme_lookup_by_gicon)
Xen_wrap_2_args(gxg_gtk_icon_info_new_for_pixbuf_w, gxg_gtk_icon_info_new_for_pixbuf)
Xen_wrap_2_args(gxg_gtk_icon_view_set_item_orientation_w, gxg_gtk_icon_view_set_item_orientation)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_item_orientation_w, gxg_gtk_icon_view_get_item_orientation)
Xen_wrap_2_args(gxg_gtk_text_view_im_context_filter_keypress_w, gxg_gtk_text_view_im_context_filter_keypress)
Xen_wrap_1_arg(gxg_gtk_text_view_reset_im_context_w, gxg_gtk_text_view_reset_im_context)
Xen_wrap_3_optional_args(gxg_gdk_device_get_window_at_position_w, gxg_gdk_device_get_window_at_position)
Xen_wrap_1_arg(gxg_gtk_cell_view_get_draw_sensitive_w, gxg_gtk_cell_view_get_draw_sensitive)
Xen_wrap_2_args(gxg_gtk_cell_view_set_draw_sensitive_w, gxg_gtk_cell_view_set_draw_sensitive)
Xen_wrap_1_arg(gxg_gtk_cell_view_get_fit_model_w, gxg_gtk_cell_view_get_fit_model)
Xen_wrap_2_args(gxg_gtk_cell_view_set_fit_model_w, gxg_gtk_cell_view_set_fit_model)
Xen_wrap_1_arg(gxg_gtk_icon_view_new_with_area_w, gxg_gtk_icon_view_new_with_area)
Xen_wrap_2_args(gxg_gtk_menu_item_set_reserve_indicator_w, gxg_gtk_menu_item_set_reserve_indicator)
Xen_wrap_1_arg(gxg_gtk_menu_item_get_reserve_indicator_w, gxg_gtk_menu_item_get_reserve_indicator)
Xen_wrap_1_arg(gxg_gtk_menu_shell_get_selected_item_w, gxg_gtk_menu_shell_get_selected_item)
Xen_wrap_1_arg(gxg_gtk_menu_shell_get_parent_shell_w, gxg_gtk_menu_shell_get_parent_shell)
Xen_wrap_2_optional_args(gxg_gtk_selection_data_get_data_with_length_w, gxg_gtk_selection_data_get_data_with_length)
Xen_wrap_2_args(gxg_gtk_tree_model_iter_previous_w, gxg_gtk_tree_model_iter_previous)
Xen_wrap_7_optional_args(gxg_gtk_tree_view_is_blank_at_pos_w, gxg_gtk_tree_view_is_blank_at_pos)
Xen_wrap_2_args(gxg_gtk_window_set_has_user_ref_count_w, gxg_gtk_window_set_has_user_ref_count)
Xen_wrap_1_arg(gxg_gdk_rgba_copy_w, gxg_gdk_rgba_copy)
Xen_wrap_1_arg(gxg_gdk_rgba_free_w, gxg_gdk_rgba_free)
Xen_wrap_2_args(gxg_gdk_rgba_parse_w, gxg_gdk_rgba_parse)
Xen_wrap_1_arg(gxg_gdk_rgba_to_string_w, gxg_gdk_rgba_to_string)
Xen_wrap_3_args(gxg_gtk_widget_set_state_flags_w, gxg_gtk_widget_set_state_flags)
Xen_wrap_2_args(gxg_gtk_widget_unset_state_flags_w, gxg_gtk_widget_unset_state_flags)
Xen_wrap_1_arg(gxg_gtk_widget_get_state_flags_w, gxg_gtk_widget_get_state_flags)
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
Xen_wrap_1_arg(gxg_gtk_entry_get_placeholder_text_w, gxg_gtk_entry_get_placeholder_text)
Xen_wrap_2_args(gxg_gtk_entry_set_placeholder_text_w, gxg_gtk_entry_set_placeholder_text)
Xen_wrap_2_args(gxg_gtk_expander_set_resize_toplevel_w, gxg_gtk_expander_set_resize_toplevel)
Xen_wrap_1_arg(gxg_gtk_expander_get_resize_toplevel_w, gxg_gtk_expander_get_resize_toplevel)
Xen_wrap_1_arg(gxg_gtk_widget_path_to_string_w, gxg_gtk_widget_path_to_string)
Xen_wrap_2_args(gxg_gtk_button_box_get_child_non_homogeneous_w, gxg_gtk_button_box_get_child_non_homogeneous)
Xen_wrap_3_args(gxg_gtk_button_box_set_child_non_homogeneous_w, gxg_gtk_button_box_set_child_non_homogeneous)
Xen_wrap_3_args(gxg_gtk_container_child_notify_w, gxg_gtk_container_child_notify)
Xen_wrap_2_args(gxg_gtk_drag_source_set_icon_gicon_w, gxg_gtk_drag_source_set_icon_gicon)
Xen_wrap_4_args(gxg_gtk_drag_set_icon_gicon_w, gxg_gtk_drag_set_icon_gicon)
Xen_wrap_2_args(gxg_gtk_combo_box_set_active_id_w, gxg_gtk_combo_box_set_active_id)
Xen_wrap_1_arg(gxg_gtk_tree_view_column_get_x_offset_w, gxg_gtk_tree_view_column_get_x_offset)
Xen_wrap_no_args(gxg_gtk_overlay_new_w, gxg_gtk_overlay_new)
Xen_wrap_2_args(gxg_gtk_overlay_add_overlay_w, gxg_gtk_overlay_add_overlay)
Xen_wrap_1_arg(gxg_gtk_adjustment_get_minimum_increment_w, gxg_gtk_adjustment_get_minimum_increment)
Xen_wrap_2_args(gxg_gtk_grid_insert_row_w, gxg_gtk_grid_insert_row)
Xen_wrap_2_args(gxg_gtk_grid_insert_column_w, gxg_gtk_grid_insert_column)
Xen_wrap_3_args(gxg_gtk_grid_insert_next_to_w, gxg_gtk_grid_insert_next_to)
Xen_wrap_2_args(gxg_gtk_text_iter_assign_w, gxg_gtk_text_iter_assign)
Xen_wrap_1_arg(gxg_gtk_widget_has_visible_focus_w, gxg_gtk_widget_has_visible_focus)
Xen_wrap_2_args(gxg_gtk_window_set_focus_visible_w, gxg_gtk_window_set_focus_visible)
Xen_wrap_1_arg(gxg_gtk_window_get_focus_visible_w, gxg_gtk_window_get_focus_visible)
Xen_wrap_2_args(gxg_gtk_font_chooser_dialog_new_w, gxg_gtk_font_chooser_dialog_new)
Xen_wrap_2_args(gxg_gdk_event_get_button_w, gxg_gdk_event_get_button)
Xen_wrap_2_args(gxg_gdk_event_get_click_count_w, gxg_gdk_event_get_click_count)
Xen_wrap_2_args(gxg_gdk_event_get_keyval_w, gxg_gdk_event_get_keyval)
Xen_wrap_2_args(gxg_gdk_event_get_keycode_w, gxg_gdk_event_get_keycode)
Xen_wrap_2_optional_args(gxg_gdk_event_get_scroll_direction_w, gxg_gdk_event_get_scroll_direction)
Xen_wrap_3_args(gxg_gtk_grid_get_child_at_w, gxg_gtk_grid_get_child_at)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_font_family_w, gxg_gtk_font_chooser_get_font_family)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_font_face_w, gxg_gtk_font_chooser_get_font_face)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_font_size_w, gxg_gtk_font_chooser_get_font_size)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_font_desc_w, gxg_gtk_font_chooser_get_font_desc)
Xen_wrap_2_args(gxg_gtk_font_chooser_set_font_desc_w, gxg_gtk_font_chooser_set_font_desc)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_font_w, gxg_gtk_font_chooser_get_font)
Xen_wrap_2_args(gxg_gtk_font_chooser_set_font_w, gxg_gtk_font_chooser_set_font)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_preview_text_w, gxg_gtk_font_chooser_get_preview_text)
Xen_wrap_2_args(gxg_gtk_font_chooser_set_preview_text_w, gxg_gtk_font_chooser_set_preview_text)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_show_preview_entry_w, gxg_gtk_font_chooser_get_show_preview_entry)
Xen_wrap_2_args(gxg_gtk_font_chooser_set_show_preview_entry_w, gxg_gtk_font_chooser_set_show_preview_entry)
Xen_wrap_no_args(gxg_gtk_font_chooser_widget_new_w, gxg_gtk_font_chooser_widget_new)
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
Xen_wrap_2_args(gxg_gdk_keymap_get_modifier_mask_w, gxg_gdk_keymap_get_modifier_mask)
Xen_wrap_7_args(gxg_gdk_window_begin_resize_drag_for_device_w, gxg_gdk_window_begin_resize_drag_for_device)
Xen_wrap_6_args(gxg_gdk_window_begin_move_drag_for_device_w, gxg_gdk_window_begin_move_drag_for_device)
Xen_wrap_4_args(gxg_gtk_accelerator_parse_with_keycode_w, gxg_gtk_accelerator_parse_with_keycode)
Xen_wrap_4_args(gxg_gtk_accelerator_name_with_keycode_w, gxg_gtk_accelerator_name_with_keycode)
Xen_wrap_4_args(gxg_gtk_accelerator_get_label_with_keycode_w, gxg_gtk_accelerator_get_label_with_keycode)
Xen_wrap_1_arg(gxg_gtk_application_get_app_menu_w, gxg_gtk_application_get_app_menu)
Xen_wrap_2_args(gxg_gtk_application_set_app_menu_w, gxg_gtk_application_set_app_menu)
Xen_wrap_1_arg(gxg_gtk_application_get_menubar_w, gxg_gtk_application_get_menubar)
Xen_wrap_2_args(gxg_gtk_application_set_menubar_w, gxg_gtk_application_set_menubar)
Xen_wrap_2_args(gxg_gtk_entry_completion_compute_prefix_w, gxg_gtk_entry_completion_compute_prefix)
Xen_wrap_2_args(gxg_gtk_scale_set_has_origin_w, gxg_gtk_scale_set_has_origin)
Xen_wrap_1_arg(gxg_gtk_scale_get_has_origin_w, gxg_gtk_scale_get_has_origin)
Xen_wrap_1_arg(gxg_gtk_application_window_new_w, gxg_gtk_application_window_new)
Xen_wrap_2_args(gxg_gtk_application_window_set_show_menubar_w, gxg_gtk_application_window_set_show_menubar)
Xen_wrap_1_arg(gxg_gtk_application_window_get_show_menubar_w, gxg_gtk_application_window_get_show_menubar)
Xen_wrap_1_arg(gxg_gtk_image_new_from_resource_w, gxg_gtk_image_new_from_resource)
Xen_wrap_2_args(gxg_gtk_image_set_from_resource_w, gxg_gtk_image_set_from_resource)
Xen_wrap_2_args(gxg_gtk_window_set_attached_to_w, gxg_gtk_window_set_attached_to)
Xen_wrap_1_arg(gxg_gtk_window_get_attached_to_w, gxg_gtk_window_get_attached_to)
Xen_wrap_3_args(gxg_gtk_about_dialog_add_credit_section_w, gxg_gtk_about_dialog_add_credit_section)
Xen_wrap_1_arg(gxg_gdk_keymap_get_modifier_state_w, gxg_gdk_keymap_get_modifier_state)
Xen_wrap_6_optional_args(gxg_gtk_hsv_to_rgb_w, gxg_gtk_hsv_to_rgb)
Xen_wrap_6_optional_args(gxg_gtk_rgb_to_hsv_w, gxg_gtk_rgb_to_hsv)
Xen_wrap_2_args(gxg_gtk_color_chooser_get_rgba_w, gxg_gtk_color_chooser_get_rgba)
Xen_wrap_2_args(gxg_gtk_color_chooser_set_rgba_w, gxg_gtk_color_chooser_set_rgba)
Xen_wrap_1_arg(gxg_gtk_color_chooser_get_use_alpha_w, gxg_gtk_color_chooser_get_use_alpha)
Xen_wrap_2_args(gxg_gtk_color_chooser_set_use_alpha_w, gxg_gtk_color_chooser_set_use_alpha)
Xen_wrap_2_args(gxg_gtk_color_chooser_dialog_new_w, gxg_gtk_color_chooser_dialog_new)
Xen_wrap_no_args(gxg_gtk_color_chooser_widget_new_w, gxg_gtk_color_chooser_widget_new)
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
Xen_wrap_3_optional_args(gxg_gdk_event_get_scroll_deltas_w, gxg_gdk_event_get_scroll_deltas)
Xen_wrap_5_args(gxg_gtk_color_chooser_add_palette_w, gxg_gtk_color_chooser_add_palette)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_n_columns_w, gxg_gtk_tree_view_get_n_columns)
Xen_wrap_no_args(gxg_gtk_menu_button_new_w, gxg_gtk_menu_button_new)
Xen_wrap_2_args(gxg_gtk_menu_button_set_menu_model_w, gxg_gtk_menu_button_set_menu_model)
Xen_wrap_1_arg(gxg_gtk_menu_button_get_menu_model_w, gxg_gtk_menu_button_get_menu_model)
Xen_wrap_2_args(gxg_gtk_menu_button_set_align_widget_w, gxg_gtk_menu_button_set_align_widget)
Xen_wrap_1_arg(gxg_gtk_menu_button_get_align_widget_w, gxg_gtk_menu_button_get_align_widget)
Xen_wrap_no_args(gxg_gtk_search_entry_new_w, gxg_gtk_search_entry_new)
Xen_wrap_no_args(gxg_gtk_level_bar_new_w, gxg_gtk_level_bar_new)
Xen_wrap_2_args(gxg_gtk_level_bar_new_for_interval_w, gxg_gtk_level_bar_new_for_interval)
Xen_wrap_2_args(gxg_gtk_level_bar_set_mode_w, gxg_gtk_level_bar_set_mode)
Xen_wrap_1_arg(gxg_gtk_level_bar_get_mode_w, gxg_gtk_level_bar_get_mode)
Xen_wrap_2_args(gxg_gtk_level_bar_set_value_w, gxg_gtk_level_bar_set_value)
Xen_wrap_1_arg(gxg_gtk_level_bar_get_value_w, gxg_gtk_level_bar_get_value)
Xen_wrap_2_args(gxg_gtk_level_bar_set_min_value_w, gxg_gtk_level_bar_set_min_value)
Xen_wrap_1_arg(gxg_gtk_level_bar_get_min_value_w, gxg_gtk_level_bar_get_min_value)
Xen_wrap_2_args(gxg_gtk_level_bar_set_max_value_w, gxg_gtk_level_bar_set_max_value)
Xen_wrap_1_arg(gxg_gtk_level_bar_get_max_value_w, gxg_gtk_level_bar_get_max_value)
Xen_wrap_3_args(gxg_gtk_level_bar_add_offset_value_w, gxg_gtk_level_bar_add_offset_value)
Xen_wrap_2_args(gxg_gtk_level_bar_remove_offset_value_w, gxg_gtk_level_bar_remove_offset_value)
Xen_wrap_3_optional_args(gxg_gtk_level_bar_get_offset_value_w, gxg_gtk_level_bar_get_offset_value)
Xen_wrap_1_arg(gxg_gtk_application_get_active_window_w, gxg_gtk_application_get_active_window)
Xen_wrap_2_args(gxg_gtk_entry_set_input_purpose_w, gxg_gtk_entry_set_input_purpose)
Xen_wrap_1_arg(gxg_gtk_entry_get_input_purpose_w, gxg_gtk_entry_get_input_purpose)
Xen_wrap_2_args(gxg_gtk_entry_set_input_hints_w, gxg_gtk_entry_set_input_hints)
Xen_wrap_1_arg(gxg_gtk_entry_get_input_hints_w, gxg_gtk_entry_get_input_hints)
Xen_wrap_1_arg(gxg_gtk_menu_button_get_popup_w, gxg_gtk_menu_button_get_popup)
Xen_wrap_2_args(gxg_gtk_text_view_set_input_purpose_w, gxg_gtk_text_view_set_input_purpose)
Xen_wrap_1_arg(gxg_gtk_text_view_get_input_purpose_w, gxg_gtk_text_view_get_input_purpose)
Xen_wrap_2_args(gxg_gtk_text_view_set_input_hints_w, gxg_gtk_text_view_set_input_hints)
Xen_wrap_1_arg(gxg_gtk_text_view_get_input_hints_w, gxg_gtk_text_view_get_input_hints)
Xen_wrap_2_args(gxg_gtk_entry_set_attributes_w, gxg_gtk_entry_set_attributes)
Xen_wrap_1_arg(gxg_gtk_entry_get_attributes_w, gxg_gtk_entry_get_attributes)
Xen_wrap_3_args(gxg_gtk_accel_label_set_accel_w, gxg_gtk_accel_label_set_accel)
Xen_wrap_4_args(gxg_gtk_menu_shell_bind_model_w, gxg_gtk_menu_shell_bind_model)
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
Xen_wrap_2_args(gxg_gtk_level_bar_set_inverted_w, gxg_gtk_level_bar_set_inverted)
Xen_wrap_1_arg(gxg_gtk_level_bar_get_inverted_w, gxg_gtk_level_bar_get_inverted)
Xen_wrap_1_arg(gxg_gtk_widget_is_visible_w, gxg_gtk_widget_is_visible)
Xen_wrap_2_args(gxg_gdk_window_set_fullscreen_mode_w, gxg_gdk_window_set_fullscreen_mode)
Xen_wrap_1_arg(gxg_gdk_window_get_fullscreen_mode_w, gxg_gdk_window_get_fullscreen_mode)
Xen_wrap_2_args(gxg_gtk_icon_view_set_activate_on_single_click_w, gxg_gtk_icon_view_set_activate_on_single_click)
Xen_wrap_1_arg(gxg_gtk_icon_view_get_activate_on_single_click_w, gxg_gtk_icon_view_get_activate_on_single_click)
Xen_wrap_1_arg(gxg_gtk_tree_view_get_activate_on_single_click_w, gxg_gtk_tree_view_get_activate_on_single_click)
Xen_wrap_2_args(gxg_gtk_tree_view_set_activate_on_single_click_w, gxg_gtk_tree_view_set_activate_on_single_click)
Xen_wrap_2_args(gxg_gtk_widget_register_window_w, gxg_gtk_widget_register_window)
Xen_wrap_2_args(gxg_gtk_widget_unregister_window_w, gxg_gtk_widget_unregister_window)
Xen_wrap_2_args(gxg_gtk_widget_set_opacity_w, gxg_gtk_widget_set_opacity)
Xen_wrap_1_arg(gxg_gtk_widget_get_opacity_w, gxg_gtk_widget_get_opacity)
Xen_wrap_1_arg(gxg_pango_font_map_changed_w, gxg_pango_font_map_changed)
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
Xen_wrap_2_args(gxg_gtk_box_set_baseline_position_w, gxg_gtk_box_set_baseline_position)
Xen_wrap_1_arg(gxg_gtk_box_get_baseline_position_w, gxg_gtk_box_get_baseline_position)
Xen_wrap_2_args(gxg_gtk_grid_remove_row_w, gxg_gtk_grid_remove_row)
Xen_wrap_2_args(gxg_gtk_grid_remove_column_w, gxg_gtk_grid_remove_column)
Xen_wrap_3_args(gxg_gtk_grid_set_row_baseline_position_w, gxg_gtk_grid_set_row_baseline_position)
Xen_wrap_2_args(gxg_gtk_grid_get_row_baseline_position_w, gxg_gtk_grid_get_row_baseline_position)
Xen_wrap_2_args(gxg_gtk_grid_set_baseline_row_w, gxg_gtk_grid_set_baseline_row)
Xen_wrap_1_arg(gxg_gtk_grid_get_baseline_row_w, gxg_gtk_grid_get_baseline_row)
Xen_wrap_1_arg(gxg_gtk_widget_get_allocated_baseline_w, gxg_gtk_widget_get_allocated_baseline)
Xen_wrap_1_arg(gxg_gtk_widget_init_template_w, gxg_gtk_widget_init_template)
Xen_wrap_2_args(gxg_gtk_window_set_titlebar_w, gxg_gtk_window_set_titlebar)
Xen_wrap_no_args(gxg_gtk_places_sidebar_new_w, gxg_gtk_places_sidebar_new)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_open_flags_w, gxg_gtk_places_sidebar_get_open_flags)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_open_flags_w, gxg_gtk_places_sidebar_set_open_flags)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_location_w, gxg_gtk_places_sidebar_get_location)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_location_w, gxg_gtk_places_sidebar_set_location)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_show_desktop_w, gxg_gtk_places_sidebar_get_show_desktop)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_show_desktop_w, gxg_gtk_places_sidebar_set_show_desktop)
Xen_wrap_2_args(gxg_gtk_places_sidebar_add_shortcut_w, gxg_gtk_places_sidebar_add_shortcut)
Xen_wrap_2_args(gxg_gtk_places_sidebar_remove_shortcut_w, gxg_gtk_places_sidebar_remove_shortcut)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_list_shortcuts_w, gxg_gtk_places_sidebar_list_shortcuts)
Xen_wrap_2_args(gxg_gtk_places_sidebar_get_nth_bookmark_w, gxg_gtk_places_sidebar_get_nth_bookmark)
Xen_wrap_no_args(gxg_gtk_stack_switcher_new_w, gxg_gtk_stack_switcher_new)
Xen_wrap_2_args(gxg_gtk_stack_switcher_set_stack_w, gxg_gtk_stack_switcher_set_stack)
Xen_wrap_1_arg(gxg_gtk_stack_switcher_get_stack_w, gxg_gtk_stack_switcher_get_stack)
Xen_wrap_no_args(gxg_gtk_stack_new_w, gxg_gtk_stack_new)
Xen_wrap_3_args(gxg_gtk_stack_add_named_w, gxg_gtk_stack_add_named)
Xen_wrap_4_args(gxg_gtk_stack_add_titled_w, gxg_gtk_stack_add_titled)
Xen_wrap_2_args(gxg_gtk_stack_set_visible_child_w, gxg_gtk_stack_set_visible_child)
Xen_wrap_1_arg(gxg_gtk_stack_get_visible_child_w, gxg_gtk_stack_get_visible_child)
Xen_wrap_2_args(gxg_gtk_stack_set_visible_child_name_w, gxg_gtk_stack_set_visible_child_name)
Xen_wrap_1_arg(gxg_gtk_stack_get_visible_child_name_w, gxg_gtk_stack_get_visible_child_name)
Xen_wrap_3_args(gxg_gtk_stack_set_visible_child_full_w, gxg_gtk_stack_set_visible_child_full)
Xen_wrap_2_args(gxg_gtk_stack_set_homogeneous_w, gxg_gtk_stack_set_homogeneous)
Xen_wrap_1_arg(gxg_gtk_stack_get_homogeneous_w, gxg_gtk_stack_get_homogeneous)
Xen_wrap_2_args(gxg_gtk_stack_set_transition_duration_w, gxg_gtk_stack_set_transition_duration)
Xen_wrap_1_arg(gxg_gtk_stack_get_transition_duration_w, gxg_gtk_stack_get_transition_duration)
Xen_wrap_2_args(gxg_gtk_stack_set_transition_type_w, gxg_gtk_stack_set_transition_type)
Xen_wrap_1_arg(gxg_gtk_stack_get_transition_type_w, gxg_gtk_stack_get_transition_type)
Xen_wrap_no_args(gxg_gtk_revealer_new_w, gxg_gtk_revealer_new)
Xen_wrap_1_arg(gxg_gtk_revealer_get_reveal_child_w, gxg_gtk_revealer_get_reveal_child)
Xen_wrap_2_args(gxg_gtk_revealer_set_reveal_child_w, gxg_gtk_revealer_set_reveal_child)
Xen_wrap_1_arg(gxg_gtk_revealer_get_child_revealed_w, gxg_gtk_revealer_get_child_revealed)
Xen_wrap_1_arg(gxg_gtk_revealer_get_transition_duration_w, gxg_gtk_revealer_get_transition_duration)
Xen_wrap_2_args(gxg_gtk_revealer_set_transition_duration_w, gxg_gtk_revealer_set_transition_duration)
Xen_wrap_2_args(gxg_gtk_revealer_set_transition_type_w, gxg_gtk_revealer_set_transition_type)
Xen_wrap_1_arg(gxg_gtk_revealer_get_transition_type_w, gxg_gtk_revealer_get_transition_type)
Xen_wrap_no_args(gxg_gtk_header_bar_new_w, gxg_gtk_header_bar_new)
Xen_wrap_2_args(gxg_gtk_header_bar_set_title_w, gxg_gtk_header_bar_set_title)
Xen_wrap_1_arg(gxg_gtk_header_bar_get_title_w, gxg_gtk_header_bar_get_title)
Xen_wrap_2_args(gxg_gtk_header_bar_set_subtitle_w, gxg_gtk_header_bar_set_subtitle)
Xen_wrap_1_arg(gxg_gtk_header_bar_get_subtitle_w, gxg_gtk_header_bar_get_subtitle)
Xen_wrap_2_args(gxg_gtk_header_bar_set_custom_title_w, gxg_gtk_header_bar_set_custom_title)
Xen_wrap_1_arg(gxg_gtk_header_bar_get_custom_title_w, gxg_gtk_header_bar_get_custom_title)
Xen_wrap_2_args(gxg_gtk_header_bar_pack_start_w, gxg_gtk_header_bar_pack_start)
Xen_wrap_2_args(gxg_gtk_header_bar_pack_end_w, gxg_gtk_header_bar_pack_end)
Xen_wrap_no_args(gxg_gtk_list_box_row_new_w, gxg_gtk_list_box_row_new)
Xen_wrap_1_arg(gxg_gtk_list_box_row_get_header_w, gxg_gtk_list_box_row_get_header)
Xen_wrap_2_args(gxg_gtk_list_box_row_set_header_w, gxg_gtk_list_box_row_set_header)
Xen_wrap_1_arg(gxg_gtk_list_box_row_changed_w, gxg_gtk_list_box_row_changed)
Xen_wrap_1_arg(gxg_gtk_list_box_get_selected_row_w, gxg_gtk_list_box_get_selected_row)
Xen_wrap_2_args(gxg_gtk_list_box_get_row_at_index_w, gxg_gtk_list_box_get_row_at_index)
Xen_wrap_2_args(gxg_gtk_list_box_get_row_at_y_w, gxg_gtk_list_box_get_row_at_y)
Xen_wrap_2_args(gxg_gtk_list_box_select_row_w, gxg_gtk_list_box_select_row)
Xen_wrap_2_args(gxg_gtk_list_box_set_placeholder_w, gxg_gtk_list_box_set_placeholder)
Xen_wrap_2_args(gxg_gtk_list_box_set_adjustment_w, gxg_gtk_list_box_set_adjustment)
Xen_wrap_1_arg(gxg_gtk_list_box_get_adjustment_w, gxg_gtk_list_box_get_adjustment)
Xen_wrap_2_args(gxg_gtk_list_box_set_selection_mode_w, gxg_gtk_list_box_set_selection_mode)
Xen_wrap_1_arg(gxg_gtk_list_box_get_selection_mode_w, gxg_gtk_list_box_get_selection_mode)
Xen_wrap_1_arg(gxg_gtk_list_box_invalidate_filter_w, gxg_gtk_list_box_invalidate_filter)
Xen_wrap_1_arg(gxg_gtk_list_box_invalidate_sort_w, gxg_gtk_list_box_invalidate_sort)
Xen_wrap_1_arg(gxg_gtk_list_box_invalidate_headers_w, gxg_gtk_list_box_invalidate_headers)
Xen_wrap_2_args(gxg_gtk_list_box_set_activate_on_single_click_w, gxg_gtk_list_box_set_activate_on_single_click)
Xen_wrap_1_arg(gxg_gtk_list_box_get_activate_on_single_click_w, gxg_gtk_list_box_get_activate_on_single_click)
Xen_wrap_1_arg(gxg_gtk_list_box_drag_unhighlight_row_w, gxg_gtk_list_box_drag_unhighlight_row)
Xen_wrap_2_args(gxg_gtk_list_box_drag_highlight_row_w, gxg_gtk_list_box_drag_highlight_row)
Xen_wrap_no_args(gxg_gtk_list_box_new_w, gxg_gtk_list_box_new)
Xen_wrap_no_args(gxg_gtk_search_bar_new_w, gxg_gtk_search_bar_new)
Xen_wrap_2_args(gxg_gtk_search_bar_connect_entry_w, gxg_gtk_search_bar_connect_entry)
Xen_wrap_1_arg(gxg_gtk_search_bar_get_search_mode_w, gxg_gtk_search_bar_get_search_mode)
Xen_wrap_2_args(gxg_gtk_search_bar_set_search_mode_w, gxg_gtk_search_bar_set_search_mode)
Xen_wrap_2_args(gxg_gtk_search_bar_handle_event_w, gxg_gtk_search_bar_handle_event)
Xen_wrap_1_arg(gxg_gtk_file_chooser_get_current_name_w, gxg_gtk_file_chooser_get_current_name)
Xen_wrap_3_args(gxg_gdk_cairo_surface_create_from_pixbuf_w, gxg_gdk_cairo_surface_create_from_pixbuf)
Xen_wrap_3_optional_args(gxg_gdk_device_get_window_at_position_double_w, gxg_gdk_device_get_window_at_position_double)
Xen_wrap_1_arg(gxg_gdk_window_get_scale_factor_w, gxg_gdk_window_get_scale_factor)
Xen_wrap_5_optional_args(gxg_gdk_window_get_device_position_double_w, gxg_gdk_window_get_device_position_double)
Xen_wrap_5_args(gxg_gdk_window_create_similar_image_surface_w, gxg_gdk_window_create_similar_image_surface)
Xen_wrap_5_args(gxg_gtk_icon_theme_lookup_icon_for_scale_w, gxg_gtk_icon_theme_lookup_icon_for_scale)
Xen_wrap_6_optional_args(gxg_gtk_icon_theme_load_icon_for_scale_w, gxg_gtk_icon_theme_load_icon_for_scale)
Xen_wrap_7_optional_args(gxg_gtk_icon_theme_load_surface_w, gxg_gtk_icon_theme_load_surface)
Xen_wrap_5_args(gxg_gtk_icon_theme_lookup_by_gicon_for_scale_w, gxg_gtk_icon_theme_lookup_by_gicon_for_scale)
Xen_wrap_1_arg(gxg_gtk_icon_info_get_base_scale_w, gxg_gtk_icon_info_get_base_scale)
Xen_wrap_3_optional_args(gxg_gtk_icon_info_load_surface_w, gxg_gtk_icon_info_load_surface)
Xen_wrap_1_arg(gxg_gtk_image_new_from_surface_w, gxg_gtk_image_new_from_surface)
Xen_wrap_2_args(gxg_gtk_image_set_from_surface_w, gxg_gtk_image_set_from_surface)
Xen_wrap_1_arg(gxg_gtk_list_box_row_get_index_w, gxg_gtk_list_box_row_get_index)
Xen_wrap_1_arg(gxg_gtk_widget_get_scale_factor_w, gxg_gtk_widget_get_scale_factor)
Xen_wrap_1_arg(gxg_gtk_window_close_w, gxg_gtk_window_close)
Xen_wrap_2_args(gxg_gtk_info_bar_set_show_close_button_w, gxg_gtk_info_bar_set_show_close_button)
Xen_wrap_1_arg(gxg_gtk_info_bar_get_show_close_button_w, gxg_gtk_info_bar_get_show_close_button)
Xen_wrap_5_args(gxg_gtk_tree_model_rows_reordered_with_length_w, gxg_gtk_tree_model_rows_reordered_with_length)
Xen_wrap_1_arg(gxg_gdk_event_get_event_type_w, gxg_gdk_event_get_event_type)
Xen_wrap_2_args(gxg_gtk_entry_set_tabs_w, gxg_gtk_entry_set_tabs)
Xen_wrap_1_arg(gxg_gtk_entry_get_tabs_w, gxg_gtk_entry_get_tabs)
Xen_wrap_2_args(gxg_gtk_list_box_prepend_w, gxg_gtk_list_box_prepend)
Xen_wrap_3_args(gxg_gtk_list_box_insert_w, gxg_gtk_list_box_insert)
Xen_wrap_2_args(gxg_gdk_window_set_opaque_region_w, gxg_gdk_window_set_opaque_region)
Xen_wrap_2_args(gxg_gtk_label_set_lines_w, gxg_gtk_label_set_lines)
Xen_wrap_1_arg(gxg_gtk_label_get_lines_w, gxg_gtk_label_get_lines)
Xen_wrap_1_arg(gxg_gdk_event_get_window_w, gxg_gdk_event_get_window)
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
Xen_wrap_no_args(gxg_gtk_flow_box_child_new_w, gxg_gtk_flow_box_child_new)
Xen_wrap_1_arg(gxg_gtk_flow_box_child_get_index_w, gxg_gtk_flow_box_child_get_index)
Xen_wrap_1_arg(gxg_gtk_flow_box_child_is_selected_w, gxg_gtk_flow_box_child_is_selected)
Xen_wrap_1_arg(gxg_gtk_flow_box_child_changed_w, gxg_gtk_flow_box_child_changed)
Xen_wrap_no_args(gxg_gtk_flow_box_new_w, gxg_gtk_flow_box_new)
Xen_wrap_2_args(gxg_gtk_flow_box_set_homogeneous_w, gxg_gtk_flow_box_set_homogeneous)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_homogeneous_w, gxg_gtk_flow_box_get_homogeneous)
Xen_wrap_2_args(gxg_gtk_flow_box_set_row_spacing_w, gxg_gtk_flow_box_set_row_spacing)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_row_spacing_w, gxg_gtk_flow_box_get_row_spacing)
Xen_wrap_2_args(gxg_gtk_flow_box_set_column_spacing_w, gxg_gtk_flow_box_set_column_spacing)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_column_spacing_w, gxg_gtk_flow_box_get_column_spacing)
Xen_wrap_2_args(gxg_gtk_flow_box_set_min_children_per_line_w, gxg_gtk_flow_box_set_min_children_per_line)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_min_children_per_line_w, gxg_gtk_flow_box_get_min_children_per_line)
Xen_wrap_2_args(gxg_gtk_flow_box_set_max_children_per_line_w, gxg_gtk_flow_box_set_max_children_per_line)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_max_children_per_line_w, gxg_gtk_flow_box_get_max_children_per_line)
Xen_wrap_2_args(gxg_gtk_flow_box_set_activate_on_single_click_w, gxg_gtk_flow_box_set_activate_on_single_click)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_activate_on_single_click_w, gxg_gtk_flow_box_get_activate_on_single_click)
Xen_wrap_3_args(gxg_gtk_flow_box_insert_w, gxg_gtk_flow_box_insert)
Xen_wrap_2_args(gxg_gtk_flow_box_get_child_at_index_w, gxg_gtk_flow_box_get_child_at_index)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_selected_children_w, gxg_gtk_flow_box_get_selected_children)
Xen_wrap_2_args(gxg_gtk_flow_box_select_child_w, gxg_gtk_flow_box_select_child)
Xen_wrap_2_args(gxg_gtk_flow_box_unselect_child_w, gxg_gtk_flow_box_unselect_child)
Xen_wrap_1_arg(gxg_gtk_flow_box_select_all_w, gxg_gtk_flow_box_select_all)
Xen_wrap_1_arg(gxg_gtk_flow_box_unselect_all_w, gxg_gtk_flow_box_unselect_all)
Xen_wrap_2_args(gxg_gtk_flow_box_set_selection_mode_w, gxg_gtk_flow_box_set_selection_mode)
Xen_wrap_1_arg(gxg_gtk_flow_box_get_selection_mode_w, gxg_gtk_flow_box_get_selection_mode)
Xen_wrap_2_args(gxg_gtk_flow_box_set_hadjustment_w, gxg_gtk_flow_box_set_hadjustment)
Xen_wrap_2_args(gxg_gtk_flow_box_set_vadjustment_w, gxg_gtk_flow_box_set_vadjustment)
Xen_wrap_1_arg(gxg_gtk_flow_box_invalidate_filter_w, gxg_gtk_flow_box_invalidate_filter)
Xen_wrap_1_arg(gxg_gtk_flow_box_invalidate_sort_w, gxg_gtk_flow_box_invalidate_sort)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_local_only_w, gxg_gtk_places_sidebar_set_local_only)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_local_only_w, gxg_gtk_places_sidebar_get_local_only)
Xen_wrap_1_arg(gxg_gtk_stack_get_transition_running_w, gxg_gtk_stack_get_transition_running)
Xen_wrap_1_arg(gxg_gtk_widget_get_margin_start_w, gxg_gtk_widget_get_margin_start)
Xen_wrap_2_args(gxg_gtk_widget_set_margin_start_w, gxg_gtk_widget_set_margin_start)
Xen_wrap_1_arg(gxg_gtk_widget_get_margin_end_w, gxg_gtk_widget_get_margin_end)
Xen_wrap_2_args(gxg_gtk_widget_set_margin_end_w, gxg_gtk_widget_set_margin_end)
Xen_wrap_3_optional_args(gxg_gtk_accel_label_get_accel_w, gxg_gtk_accel_label_get_accel)
Xen_wrap_5_args(gxg_gdk_window_set_shadow_width_w, gxg_gdk_window_set_shadow_width)
Xen_wrap_no_args(gxg_gtk_action_bar_new_w, gxg_gtk_action_bar_new)
Xen_wrap_1_arg(gxg_gtk_action_bar_get_center_widget_w, gxg_gtk_action_bar_get_center_widget)
Xen_wrap_2_args(gxg_gtk_action_bar_set_center_widget_w, gxg_gtk_action_bar_set_center_widget)
Xen_wrap_2_args(gxg_gtk_action_bar_pack_start_w, gxg_gtk_action_bar_pack_start)
Xen_wrap_2_args(gxg_gtk_action_bar_pack_end_w, gxg_gtk_action_bar_pack_end)
Xen_wrap_2_args(gxg_gtk_header_bar_set_has_subtitle_w, gxg_gtk_header_bar_set_has_subtitle)
Xen_wrap_1_arg(gxg_gtk_header_bar_get_has_subtitle_w, gxg_gtk_header_bar_get_has_subtitle)
Xen_wrap_2_args(gxg_gtk_header_bar_set_decoration_layout_w, gxg_gtk_header_bar_set_decoration_layout)
Xen_wrap_1_arg(gxg_gtk_header_bar_get_decoration_layout_w, gxg_gtk_header_bar_get_decoration_layout)
Xen_wrap_1_arg(gxg_gtk_icon_info_is_symbolic_w, gxg_gtk_icon_info_is_symbolic)
Xen_wrap_no_args(gxg_gtk_get_locale_direction_w, gxg_gtk_get_locale_direction)
Xen_wrap_1_arg(gxg_gtk_window_is_maximized_w, gxg_gtk_window_is_maximized)
Xen_wrap_1_arg(gxg_gtk_dialog_get_header_bar_w, gxg_gtk_dialog_get_header_bar)
Xen_wrap_1_arg(gxg_gtk_popover_new_w, gxg_gtk_popover_new)
Xen_wrap_2_args(gxg_gtk_popover_set_relative_to_w, gxg_gtk_popover_set_relative_to)
Xen_wrap_1_arg(gxg_gtk_popover_get_relative_to_w, gxg_gtk_popover_get_relative_to)
Xen_wrap_2_args(gxg_gtk_popover_set_position_w, gxg_gtk_popover_set_position)
Xen_wrap_1_arg(gxg_gtk_popover_get_position_w, gxg_gtk_popover_get_position)
Xen_wrap_2_args(gxg_gtk_popover_set_modal_w, gxg_gtk_popover_set_modal)
Xen_wrap_1_arg(gxg_gtk_popover_get_modal_w, gxg_gtk_popover_get_modal)
Xen_wrap_2_args(gxg_gtk_entry_set_max_width_chars_w, gxg_gtk_entry_set_max_width_chars)
Xen_wrap_1_arg(gxg_gtk_entry_get_max_width_chars_w, gxg_gtk_entry_get_max_width_chars)
Xen_wrap_1_arg(gxg_gdk_device_get_last_event_window_w, gxg_gdk_device_get_last_event_window)
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
Xen_wrap_1_arg(gxg_gtk_list_box_row_is_selected_w, gxg_gtk_list_box_row_is_selected)
Xen_wrap_2_args(gxg_gtk_list_box_unselect_row_w, gxg_gtk_list_box_unselect_row)
Xen_wrap_1_arg(gxg_gtk_list_box_select_all_w, gxg_gtk_list_box_select_all)
Xen_wrap_1_arg(gxg_gtk_list_box_unselect_all_w, gxg_gtk_list_box_unselect_all)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_show_enter_location_w, gxg_gtk_places_sidebar_get_show_enter_location)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_show_enter_location_w, gxg_gtk_places_sidebar_set_show_enter_location)
Xen_wrap_2_args(gxg_gtk_switch_set_state_w, gxg_gtk_switch_set_state)
Xen_wrap_1_arg(gxg_gtk_switch_get_state_w, gxg_gtk_switch_get_state)
Xen_wrap_2_args(gxg_gdk_window_show_window_menu_w, gxg_gdk_window_show_window_menu)
Xen_wrap_2_args(gxg_gtk_widget_get_clip_w, gxg_gtk_widget_get_clip)
Xen_wrap_1_arg(gxg_gtk_gesture_get_device_w, gxg_gtk_gesture_get_device)
Xen_wrap_2_args(gxg_gtk_gesture_set_state_w, gxg_gtk_gesture_set_state)
Xen_wrap_2_args(gxg_gtk_gesture_get_sequence_state_w, gxg_gtk_gesture_get_sequence_state)
Xen_wrap_3_args(gxg_gtk_gesture_set_sequence_state_w, gxg_gtk_gesture_set_sequence_state)
Xen_wrap_1_arg(gxg_gtk_gesture_get_sequences_w, gxg_gtk_gesture_get_sequences)
Xen_wrap_1_arg(gxg_gtk_gesture_get_last_updated_sequence_w, gxg_gtk_gesture_get_last_updated_sequence)
Xen_wrap_2_args(gxg_gtk_gesture_handles_sequence_w, gxg_gtk_gesture_handles_sequence)
Xen_wrap_2_args(gxg_gtk_gesture_get_last_event_w, gxg_gtk_gesture_get_last_event)
Xen_wrap_4_optional_args(gxg_gtk_gesture_get_point_w, gxg_gtk_gesture_get_point)
Xen_wrap_2_args(gxg_gtk_gesture_get_bounding_box_w, gxg_gtk_gesture_get_bounding_box)
Xen_wrap_3_optional_args(gxg_gtk_gesture_get_bounding_box_center_w, gxg_gtk_gesture_get_bounding_box_center)
Xen_wrap_1_arg(gxg_gtk_gesture_is_active_w, gxg_gtk_gesture_is_active)
Xen_wrap_1_arg(gxg_gtk_gesture_is_recognized_w, gxg_gtk_gesture_is_recognized)
Xen_wrap_2_args(gxg_gtk_gesture_group_w, gxg_gtk_gesture_group)
Xen_wrap_1_arg(gxg_gtk_gesture_ungroup_w, gxg_gtk_gesture_ungroup)
Xen_wrap_1_arg(gxg_gtk_gesture_get_group_w, gxg_gtk_gesture_get_group)
Xen_wrap_2_args(gxg_gtk_gesture_is_grouped_with_w, gxg_gtk_gesture_is_grouped_with)
Xen_wrap_1_arg(gxg_gtk_gesture_drag_new_w, gxg_gtk_gesture_drag_new)
Xen_wrap_3_optional_args(gxg_gtk_gesture_drag_get_start_point_w, gxg_gtk_gesture_drag_get_start_point)
Xen_wrap_3_optional_args(gxg_gtk_gesture_drag_get_offset_w, gxg_gtk_gesture_drag_get_offset)
Xen_wrap_1_arg(gxg_gtk_gesture_long_press_new_w, gxg_gtk_gesture_long_press_new)
Xen_wrap_2_args(gxg_gtk_gesture_pan_new_w, gxg_gtk_gesture_pan_new)
Xen_wrap_1_arg(gxg_gtk_gesture_pan_get_orientation_w, gxg_gtk_gesture_pan_get_orientation)
Xen_wrap_2_args(gxg_gtk_gesture_pan_set_orientation_w, gxg_gtk_gesture_pan_set_orientation)
Xen_wrap_1_arg(gxg_gtk_gesture_multi_press_new_w, gxg_gtk_gesture_multi_press_new)
Xen_wrap_2_args(gxg_gtk_gesture_multi_press_set_area_w, gxg_gtk_gesture_multi_press_set_area)
Xen_wrap_2_args(gxg_gtk_gesture_multi_press_get_area_w, gxg_gtk_gesture_multi_press_get_area)
Xen_wrap_1_arg(gxg_gtk_gesture_rotate_new_w, gxg_gtk_gesture_rotate_new)
Xen_wrap_1_arg(gxg_gtk_gesture_rotate_get_angle_delta_w, gxg_gtk_gesture_rotate_get_angle_delta)
Xen_wrap_1_arg(gxg_gtk_gesture_single_get_touch_only_w, gxg_gtk_gesture_single_get_touch_only)
Xen_wrap_2_args(gxg_gtk_gesture_single_set_touch_only_w, gxg_gtk_gesture_single_set_touch_only)
Xen_wrap_1_arg(gxg_gtk_gesture_single_get_exclusive_w, gxg_gtk_gesture_single_get_exclusive)
Xen_wrap_2_args(gxg_gtk_gesture_single_set_exclusive_w, gxg_gtk_gesture_single_set_exclusive)
Xen_wrap_1_arg(gxg_gtk_gesture_single_get_button_w, gxg_gtk_gesture_single_get_button)
Xen_wrap_2_args(gxg_gtk_gesture_single_set_button_w, gxg_gtk_gesture_single_set_button)
Xen_wrap_1_arg(gxg_gtk_gesture_single_get_current_button_w, gxg_gtk_gesture_single_get_current_button)
Xen_wrap_1_arg(gxg_gtk_gesture_single_get_current_sequence_w, gxg_gtk_gesture_single_get_current_sequence)
Xen_wrap_1_arg(gxg_gtk_gesture_swipe_new_w, gxg_gtk_gesture_swipe_new)
Xen_wrap_3_optional_args(gxg_gtk_gesture_swipe_get_velocity_w, gxg_gtk_gesture_swipe_get_velocity)
Xen_wrap_1_arg(gxg_gtk_gesture_zoom_new_w, gxg_gtk_gesture_zoom_new)
Xen_wrap_1_arg(gxg_gtk_gesture_zoom_get_scale_delta_w, gxg_gtk_gesture_zoom_get_scale_delta)
Xen_wrap_1_arg(gxg_gtk_event_controller_get_widget_w, gxg_gtk_event_controller_get_widget)
Xen_wrap_2_args(gxg_gtk_event_controller_handle_event_w, gxg_gtk_event_controller_handle_event)
Xen_wrap_1_arg(gxg_gtk_event_controller_reset_w, gxg_gtk_event_controller_reset)
Xen_wrap_1_arg(gxg_gtk_event_controller_get_propagation_phase_w, gxg_gtk_event_controller_get_propagation_phase)
Xen_wrap_2_args(gxg_gtk_event_controller_set_propagation_phase_w, gxg_gtk_event_controller_set_propagation_phase)
Xen_wrap_2_args(gxg_gtk_icon_theme_add_resource_path_w, gxg_gtk_icon_theme_add_resource_path)
Xen_wrap_2_args(gxg_gtk_list_box_row_set_activatable_w, gxg_gtk_list_box_row_set_activatable)
Xen_wrap_1_arg(gxg_gtk_list_box_row_get_activatable_w, gxg_gtk_list_box_row_get_activatable)
Xen_wrap_2_args(gxg_gtk_list_box_row_set_selectable_w, gxg_gtk_list_box_row_set_selectable)
Xen_wrap_1_arg(gxg_gtk_list_box_row_get_selectable_w, gxg_gtk_list_box_row_get_selectable)
Xen_wrap_2_args(gxg_gtk_widget_path_iter_get_state_w, gxg_gtk_widget_path_iter_get_state)
Xen_wrap_3_args(gxg_gtk_widget_path_iter_set_state_w, gxg_gtk_widget_path_iter_set_state)
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
Xen_wrap_any_args(gxg_gdk_cairo_draw_from_gl_w, gxg_gdk_cairo_draw_from_gl)
Xen_wrap_2_args(gxg_gtk_label_set_xalign_w, gxg_gtk_label_set_xalign)
Xen_wrap_1_arg(gxg_gtk_label_get_xalign_w, gxg_gtk_label_get_xalign)
Xen_wrap_2_args(gxg_gtk_label_set_yalign_w, gxg_gtk_label_set_yalign)
Xen_wrap_1_arg(gxg_gtk_label_get_yalign_w, gxg_gtk_label_get_yalign)
Xen_wrap_2_args(gxg_gtk_paned_set_wide_handle_w, gxg_gtk_paned_set_wide_handle)
Xen_wrap_1_arg(gxg_gtk_paned_get_wide_handle_w, gxg_gtk_paned_get_wide_handle)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_overlay_scrolling_w, gxg_gtk_scrolled_window_set_overlay_scrolling)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_overlay_scrolling_w, gxg_gtk_scrolled_window_get_overlay_scrolling)
Xen_wrap_2_args(gxg_gtk_text_view_set_monospace_w, gxg_gtk_text_view_set_monospace)
Xen_wrap_1_arg(gxg_gtk_text_view_get_monospace_w, gxg_gtk_text_view_get_monospace)
Xen_wrap_1_arg(gxg_gtk_window_get_titlebar_w, gxg_gtk_window_get_titlebar)
Xen_wrap_no_args(gxg_gtk_gl_area_new_w, gxg_gtk_gl_area_new)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_has_alpha_w, gxg_gtk_gl_area_get_has_alpha)
Xen_wrap_2_args(gxg_gtk_gl_area_set_has_alpha_w, gxg_gtk_gl_area_set_has_alpha)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_has_depth_buffer_w, gxg_gtk_gl_area_get_has_depth_buffer)
Xen_wrap_2_args(gxg_gtk_gl_area_set_has_depth_buffer_w, gxg_gtk_gl_area_set_has_depth_buffer)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_context_w, gxg_gtk_gl_area_get_context)
Xen_wrap_1_arg(gxg_gtk_gl_area_make_current_w, gxg_gtk_gl_area_make_current)
Xen_wrap_6_args(gxg_gtk_render_check_w, gxg_gtk_render_check)
Xen_wrap_6_args(gxg_gtk_render_option_w, gxg_gtk_render_option)
Xen_wrap_6_args(gxg_gtk_render_arrow_w, gxg_gtk_render_arrow)
Xen_wrap_6_args(gxg_gtk_render_background_w, gxg_gtk_render_background)
Xen_wrap_6_args(gxg_gtk_render_frame_w, gxg_gtk_render_frame)
Xen_wrap_6_args(gxg_gtk_render_expander_w, gxg_gtk_render_expander)
Xen_wrap_6_args(gxg_gtk_render_focus_w, gxg_gtk_render_focus)
Xen_wrap_5_args(gxg_gtk_render_layout_w, gxg_gtk_render_layout)
Xen_wrap_6_args(gxg_gtk_render_line_w, gxg_gtk_render_line)
Xen_wrap_7_args(gxg_gtk_render_slider_w, gxg_gtk_render_slider)
Xen_wrap_any_args(gxg_gtk_render_frame_gap_w, gxg_gtk_render_frame_gap)
Xen_wrap_6_args(gxg_gtk_render_handle_w, gxg_gtk_render_handle)
Xen_wrap_6_args(gxg_gtk_render_activity_w, gxg_gtk_render_activity)
Xen_wrap_5_args(gxg_gtk_render_icon_surface_w, gxg_gtk_render_icon_surface)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_window_w, gxg_gdk_gl_context_get_window)
Xen_wrap_1_arg(gxg_gdk_gl_context_make_current_w, gxg_gdk_gl_context_make_current)
Xen_wrap_no_args(gxg_gdk_gl_context_get_current_w, gxg_gdk_gl_context_get_current)
Xen_wrap_no_args(gxg_gdk_gl_context_clear_current_w, gxg_gdk_gl_context_clear_current)
Xen_wrap_2_args(gxg_gtk_stack_set_hhomogeneous_w, gxg_gtk_stack_set_hhomogeneous)
Xen_wrap_1_arg(gxg_gtk_stack_get_hhomogeneous_w, gxg_gtk_stack_get_hhomogeneous)
Xen_wrap_2_args(gxg_gtk_stack_set_vhomogeneous_w, gxg_gtk_stack_set_vhomogeneous)
Xen_wrap_1_arg(gxg_gtk_stack_get_vhomogeneous_w, gxg_gtk_stack_get_vhomogeneous)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_display_w, gxg_gdk_gl_context_get_display)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_has_stencil_buffer_w, gxg_gtk_gl_area_get_has_stencil_buffer)
Xen_wrap_2_args(gxg_gtk_gl_area_set_has_stencil_buffer_w, gxg_gtk_gl_area_set_has_stencil_buffer)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_auto_render_w, gxg_gtk_gl_area_get_auto_render)
Xen_wrap_2_args(gxg_gtk_gl_area_set_auto_render_w, gxg_gtk_gl_area_set_auto_render)
Xen_wrap_1_arg(gxg_gtk_gl_area_queue_render_w, gxg_gtk_gl_area_queue_render)
Xen_wrap_1_arg(gxg_gtk_gl_area_attach_buffers_w, gxg_gtk_gl_area_attach_buffers)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_error_w, gxg_gtk_gl_area_get_error)
Xen_wrap_no_args(gxg_gtk_popover_menu_new_w, gxg_gtk_popover_menu_new)
Xen_wrap_2_args(gxg_gtk_popover_menu_open_submenu_w, gxg_gtk_popover_menu_open_submenu)
Xen_wrap_1_arg(gxg_gtk_entry_grab_focus_without_selecting_w, gxg_gtk_entry_grab_focus_without_selecting)
Xen_wrap_2_args(gxg_gtk_scrollable_get_border_w, gxg_gtk_scrollable_get_border)
Xen_wrap_4_args(gxg_gtk_text_buffer_insert_markup_w, gxg_gtk_text_buffer_insert_markup)
Xen_wrap_1_arg(gxg_gdk_device_get_vendor_id_w, gxg_gdk_device_get_vendor_id)
Xen_wrap_1_arg(gxg_gdk_device_get_product_id_w, gxg_gdk_device_get_product_id)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_shared_context_w, gxg_gdk_gl_context_get_shared_context)
Xen_wrap_3_args(gxg_gdk_gl_context_set_required_version_w, gxg_gdk_gl_context_set_required_version)
Xen_wrap_3_optional_args(gxg_gdk_gl_context_get_required_version_w, gxg_gdk_gl_context_get_required_version)
Xen_wrap_2_args(gxg_gdk_gl_context_set_debug_enabled_w, gxg_gdk_gl_context_set_debug_enabled)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_debug_enabled_w, gxg_gdk_gl_context_get_debug_enabled)
Xen_wrap_2_args(gxg_gdk_gl_context_set_forward_compatible_w, gxg_gdk_gl_context_set_forward_compatible)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_forward_compatible_w, gxg_gdk_gl_context_get_forward_compatible)
Xen_wrap_2_optional_args(gxg_gdk_gl_context_realize_w, gxg_gdk_gl_context_realize)
Xen_wrap_1_arg(gxg_gtk_drag_cancel_w, gxg_gtk_drag_cancel)
Xen_wrap_2_args(gxg_gtk_search_entry_handle_event_w, gxg_gtk_search_entry_handle_event)
Xen_wrap_3_optional_args(gxg_gdk_gl_context_get_version_w, gxg_gdk_gl_context_get_version)
Xen_wrap_3_args(gxg_gtk_gl_area_set_required_version_w, gxg_gtk_gl_area_set_required_version)
Xen_wrap_3_optional_args(gxg_gtk_gl_area_get_required_version_w, gxg_gtk_gl_area_get_required_version)
Xen_wrap_2_args(gxg_gtk_notebook_detach_tab_w, gxg_gtk_notebook_detach_tab)
Xen_wrap_no_args(gxg_gtk_stack_sidebar_new_w, gxg_gtk_stack_sidebar_new)
Xen_wrap_2_args(gxg_gtk_stack_sidebar_set_stack_w, gxg_gtk_stack_sidebar_set_stack)
Xen_wrap_1_arg(gxg_gtk_stack_sidebar_get_stack_w, gxg_gtk_stack_sidebar_get_stack)
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
Xen_wrap_1_arg(gxg_gdk_keymap_get_scroll_lock_state_w, gxg_gdk_keymap_get_scroll_lock_state)
Xen_wrap_2_args(gxg_gtk_radio_menu_item_join_group_w, gxg_gtk_radio_menu_item_join_group)
Xen_wrap_2_args(gxg_gtk_font_chooser_set_font_map_w, gxg_gtk_font_chooser_set_font_map)
Xen_wrap_1_arg(gxg_gtk_font_chooser_get_font_map_w, gxg_gtk_font_chooser_get_font_map)
Xen_wrap_2_args(gxg_gtk_popover_set_default_widget_w, gxg_gtk_popover_set_default_widget)
Xen_wrap_1_arg(gxg_gtk_popover_get_default_widget_w, gxg_gtk_popover_get_default_widget)
Xen_wrap_2_args(gxg_gdk_window_set_pass_through_w, gxg_gdk_window_set_pass_through)
Xen_wrap_1_arg(gxg_gdk_window_get_pass_through_w, gxg_gdk_window_get_pass_through)
Xen_wrap_3_args(gxg_gtk_overlay_reorder_overlay_w, gxg_gtk_overlay_reorder_overlay)
Xen_wrap_2_args(gxg_gtk_overlay_get_overlay_pass_through_w, gxg_gtk_overlay_get_overlay_pass_through)
Xen_wrap_3_args(gxg_gtk_overlay_set_overlay_pass_through_w, gxg_gtk_overlay_set_overlay_pass_through)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_show_recent_w, gxg_gtk_places_sidebar_get_show_recent)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_show_recent_w, gxg_gtk_places_sidebar_set_show_recent)
Xen_wrap_3_args(gxg_gtk_places_sidebar_set_drop_targets_visible_w, gxg_gtk_places_sidebar_set_drop_targets_visible)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_show_trash_w, gxg_gtk_places_sidebar_get_show_trash)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_show_trash_w, gxg_gtk_places_sidebar_set_show_trash)
Xen_wrap_2_args(gxg_gtk_places_sidebar_set_show_other_locations_w, gxg_gtk_places_sidebar_set_show_other_locations)
Xen_wrap_1_arg(gxg_gtk_places_sidebar_get_show_other_locations_w, gxg_gtk_places_sidebar_get_show_other_locations)
Xen_wrap_2_args(gxg_gtk_stack_set_interpolate_size_w, gxg_gtk_stack_set_interpolate_size)
Xen_wrap_1_arg(gxg_gtk_stack_get_interpolate_size_w, gxg_gtk_stack_get_interpolate_size)
Xen_wrap_2_args(gxg_gtk_widget_set_font_options_w, gxg_gtk_widget_set_font_options)
Xen_wrap_1_arg(gxg_gtk_widget_get_font_options_w, gxg_gtk_widget_get_font_options)
Xen_wrap_2_args(gxg_gtk_widget_set_font_map_w, gxg_gtk_widget_set_font_map)
Xen_wrap_1_arg(gxg_gtk_widget_get_font_map_w, gxg_gtk_widget_get_font_map)
Xen_wrap_2_args(gxg_gtk_text_view_set_top_margin_w, gxg_gtk_text_view_set_top_margin)
Xen_wrap_1_arg(gxg_gtk_text_view_get_top_margin_w, gxg_gtk_text_view_get_top_margin)
Xen_wrap_2_args(gxg_gtk_text_view_set_bottom_margin_w, gxg_gtk_text_view_set_bottom_margin)
Xen_wrap_1_arg(gxg_gtk_text_view_get_bottom_margin_w, gxg_gtk_text_view_get_bottom_margin)
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
Xen_wrap_1_arg(gxg_gdk_gl_context_is_legacy_w, gxg_gdk_gl_context_is_legacy)
Xen_wrap_2_args(gxg_gdk_rectangle_equal_w, gxg_gdk_rectangle_equal)
Xen_wrap_2_args(gxg_gtk_application_window_set_help_overlay_w, gxg_gtk_application_window_set_help_overlay)
Xen_wrap_2_args(gxg_gtk_settings_reset_property_w, gxg_gtk_settings_reset_property)
Xen_wrap_2_args(gxg_gtk_text_tag_changed_w, gxg_gtk_text_tag_changed)
Xen_wrap_2_args(gxg_gtk_widget_path_iter_get_object_name_w, gxg_gtk_widget_path_iter_get_object_name)
Xen_wrap_3_args(gxg_gtk_widget_path_iter_set_object_name_w, gxg_gtk_widget_path_iter_set_object_name)
Xen_wrap_1_arg(gxg_gtk_widget_queue_allocate_w, gxg_gtk_widget_queue_allocate)
Xen_wrap_2_args(gxg_gtk_widget_set_focus_on_click_w, gxg_gtk_widget_set_focus_on_click)
Xen_wrap_1_arg(gxg_gtk_widget_get_focus_on_click_w, gxg_gtk_widget_get_focus_on_click)
Xen_wrap_1_arg(gxg_gdk_drag_context_get_drag_window_w, gxg_gdk_drag_context_get_drag_window)
Xen_wrap_2_args(gxg_gtk_popover_set_constrain_to_w, gxg_gtk_popover_set_constrain_to)
Xen_wrap_1_arg(gxg_gtk_popover_get_constrain_to_w, gxg_gtk_popover_get_constrain_to)
Xen_wrap_2_args(gxg_gtk_text_iter_starts_tag_w, gxg_gtk_text_iter_starts_tag)
Xen_wrap_1_arg(gxg_gdk_device_get_seat_w, gxg_gdk_device_get_seat)
Xen_wrap_1_arg(gxg_gdk_display_get_default_seat_w, gxg_gdk_display_get_default_seat)
Xen_wrap_1_arg(gxg_gdk_display_list_seats_w, gxg_gdk_display_list_seats)
Xen_wrap_2_args(gxg_gdk_drag_drop_done_w, gxg_gdk_drag_drop_done)
Xen_wrap_3_args(gxg_gdk_drag_context_set_hotspot_w, gxg_gdk_drag_context_set_hotspot)
Xen_wrap_any_args(gxg_gdk_seat_grab_w, gxg_gdk_seat_grab)
Xen_wrap_1_arg(gxg_gdk_seat_ungrab_w, gxg_gdk_seat_ungrab)
Xen_wrap_1_arg(gxg_gdk_seat_get_display_w, gxg_gdk_seat_get_display)
Xen_wrap_1_arg(gxg_gdk_seat_get_capabilities_w, gxg_gdk_seat_get_capabilities)
Xen_wrap_2_args(gxg_gdk_seat_get_slaves_w, gxg_gdk_seat_get_slaves)
Xen_wrap_1_arg(gxg_gdk_seat_get_pointer_w, gxg_gdk_seat_get_pointer)
Xen_wrap_1_arg(gxg_gdk_seat_get_keyboard_w, gxg_gdk_seat_get_keyboard)
Xen_wrap_1_arg(gxg_gdk_event_is_scroll_stop_event_w, gxg_gdk_event_is_scroll_stop_event)
Xen_wrap_1_arg(gxg_gtk_text_view_reset_cursor_blink_w, gxg_gtk_text_view_reset_cursor_blink)
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
Xen_wrap_1_arg(gxg_gdk_device_get_axes_w, gxg_gdk_device_get_axes)
Xen_wrap_1_arg(gxg_gdk_event_get_device_tool_w, gxg_gdk_event_get_device_tool)
Xen_wrap_2_args(gxg_gdk_event_set_device_tool_w, gxg_gdk_event_set_device_tool)
Xen_wrap_1_arg(gxg_gdk_event_get_scancode_w, gxg_gdk_event_get_scancode)
Xen_wrap_2_args(gxg_gdk_gl_context_set_use_es_w, gxg_gdk_gl_context_set_use_es)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_use_es_w, gxg_gdk_gl_context_get_use_es)
Xen_wrap_2_args(gxg_gtk_gl_area_set_use_es_w, gxg_gtk_gl_area_set_use_es)
Xen_wrap_1_arg(gxg_gtk_gl_area_get_use_es_w, gxg_gtk_gl_area_get_use_es)
Xen_wrap_1_arg(gxg_gdk_device_tool_get_serial_w, gxg_gdk_device_tool_get_serial)
Xen_wrap_1_arg(gxg_gdk_display_get_n_monitors_w, gxg_gdk_display_get_n_monitors)
Xen_wrap_2_args(gxg_gdk_display_get_monitor_w, gxg_gdk_display_get_monitor)
Xen_wrap_1_arg(gxg_gdk_display_get_primary_monitor_w, gxg_gdk_display_get_primary_monitor)
Xen_wrap_3_args(gxg_gdk_display_get_monitor_at_point_w, gxg_gdk_display_get_monitor_at_point)
Xen_wrap_2_args(gxg_gdk_display_get_monitor_at_window_w, gxg_gdk_display_get_monitor_at_window)
Xen_wrap_1_arg(gxg_gdk_event_get_pointer_emulated_w, gxg_gdk_event_get_pointer_emulated)
Xen_wrap_2_args(gxg_gtk_menu_place_on_monitor_w, gxg_gtk_menu_place_on_monitor)
Xen_wrap_1_arg(gxg_gdk_monitor_get_display_w, gxg_gdk_monitor_get_display)
Xen_wrap_2_args(gxg_gdk_monitor_get_geometry_w, gxg_gdk_monitor_get_geometry)
Xen_wrap_2_args(gxg_gdk_monitor_get_workarea_w, gxg_gdk_monitor_get_workarea)
Xen_wrap_1_arg(gxg_gdk_monitor_get_width_mm_w, gxg_gdk_monitor_get_width_mm)
Xen_wrap_1_arg(gxg_gdk_monitor_get_height_mm_w, gxg_gdk_monitor_get_height_mm)
Xen_wrap_1_arg(gxg_gdk_monitor_get_manufacturer_w, gxg_gdk_monitor_get_manufacturer)
Xen_wrap_1_arg(gxg_gdk_monitor_get_model_w, gxg_gdk_monitor_get_model)
Xen_wrap_1_arg(gxg_gdk_monitor_get_scale_factor_w, gxg_gdk_monitor_get_scale_factor)
Xen_wrap_1_arg(gxg_gdk_monitor_get_refresh_rate_w, gxg_gdk_monitor_get_refresh_rate)
Xen_wrap_1_arg(gxg_gdk_monitor_get_subpixel_layout_w, gxg_gdk_monitor_get_subpixel_layout)
Xen_wrap_1_arg(gxg_gdk_monitor_is_primary_w, gxg_gdk_monitor_is_primary)
Xen_wrap_1_arg(gxg_gdk_drawing_context_get_window_w, gxg_gdk_drawing_context_get_window)
Xen_wrap_1_arg(gxg_gdk_drawing_context_get_clip_w, gxg_gdk_drawing_context_get_clip)
Xen_wrap_1_arg(gxg_gdk_drawing_context_is_valid_w, gxg_gdk_drawing_context_is_valid)
Xen_wrap_1_arg(gxg_gdk_drawing_context_get_cairo_context_w, gxg_gdk_drawing_context_get_cairo_context)
Xen_wrap_1_arg(gxg_gdk_cairo_get_drawing_context_w, gxg_gdk_cairo_get_drawing_context)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_max_content_width_w, gxg_gtk_scrolled_window_set_max_content_width)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_max_content_width_w, gxg_gtk_scrolled_window_get_max_content_width)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_max_content_height_w, gxg_gtk_scrolled_window_set_max_content_height)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_max_content_height_w, gxg_gtk_scrolled_window_get_max_content_height)
Xen_wrap_5_args(gxg_gtk_file_chooser_add_choice_w, gxg_gtk_file_chooser_add_choice)
Xen_wrap_2_args(gxg_gtk_file_chooser_remove_choice_w, gxg_gtk_file_chooser_remove_choice)
Xen_wrap_3_args(gxg_gtk_file_chooser_set_choice_w, gxg_gtk_file_chooser_set_choice)
Xen_wrap_2_args(gxg_gtk_file_chooser_get_choice_w, gxg_gtk_file_chooser_get_choice)
Xen_wrap_1_arg(gxg_gdk_device_pad_get_n_groups_w, gxg_gdk_device_pad_get_n_groups)
Xen_wrap_2_args(gxg_gdk_device_pad_get_group_n_modes_w, gxg_gdk_device_pad_get_group_n_modes)
Xen_wrap_2_args(gxg_gdk_device_pad_get_n_features_w, gxg_gdk_device_pad_get_n_features)
Xen_wrap_3_args(gxg_gdk_device_pad_get_feature_group_w, gxg_gdk_device_pad_get_feature_group)
Xen_wrap_6_args(gxg_gtk_menu_popup_at_rect_w, gxg_gtk_menu_popup_at_rect)
Xen_wrap_5_args(gxg_gtk_menu_popup_at_widget_w, gxg_gtk_menu_popup_at_widget)
Xen_wrap_2_args(gxg_gtk_menu_popup_at_pointer_w, gxg_gtk_menu_popup_at_pointer)
Xen_wrap_3_args(gxg_gtk_pad_controller_new_w, gxg_gtk_pad_controller_new)
Xen_wrap_3_args(gxg_gtk_pad_controller_set_action_entries_w, gxg_gtk_pad_controller_set_action_entries)
Xen_wrap_6_args(gxg_gtk_pad_controller_set_action_w, gxg_gtk_pad_controller_set_action)
Xen_wrap_1_arg(gxg_gtk_popover_popup_w, gxg_gtk_popover_popup)
Xen_wrap_1_arg(gxg_gtk_popover_popdown_w, gxg_gtk_popover_popdown)
Xen_wrap_1_arg(gxg_gtk_shortcut_label_new_w, gxg_gtk_shortcut_label_new)
Xen_wrap_1_arg(gxg_gtk_shortcut_label_get_accelerator_w, gxg_gtk_shortcut_label_get_accelerator)
Xen_wrap_2_args(gxg_gtk_shortcut_label_set_accelerator_w, gxg_gtk_shortcut_label_set_accelerator)
Xen_wrap_1_arg(gxg_gtk_shortcut_label_get_disabled_text_w, gxg_gtk_shortcut_label_get_disabled_text)
Xen_wrap_2_args(gxg_gtk_shortcut_label_set_disabled_text_w, gxg_gtk_shortcut_label_set_disabled_text)
Xen_wrap_2_args(gxg_gdk_window_end_draw_frame_w, gxg_gdk_window_end_draw_frame)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_propagate_natural_width_w, gxg_gtk_scrolled_window_set_propagate_natural_width)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_propagate_natural_width_w, gxg_gtk_scrolled_window_get_propagate_natural_width)
Xen_wrap_2_args(gxg_gtk_scrolled_window_set_propagate_natural_height_w, gxg_gtk_scrolled_window_set_propagate_natural_height)
Xen_wrap_1_arg(gxg_gtk_scrolled_window_get_propagate_natural_height_w, gxg_gtk_scrolled_window_get_propagate_natural_height)
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
Xen_wrap_1_arg(gxg_gdk_display_is_composited_w, gxg_gdk_display_is_composited)
Xen_wrap_1_arg(gxg_gdk_display_is_rgba_w, gxg_gdk_display_is_rgba)
Xen_wrap_4_args(gxg_gdk_window_new_toplevel_w, gxg_gdk_window_new_toplevel)
Xen_wrap_3_args(gxg_gdk_window_new_popup_w, gxg_gdk_window_new_popup)
Xen_wrap_1_arg(gxg_gdk_window_new_temp_w, gxg_gdk_window_new_temp)
Xen_wrap_3_args(gxg_gdk_window_new_child_w, gxg_gdk_window_new_child)
Xen_wrap_2_args(gxg_gtk_button_set_icon_name_w, gxg_gtk_button_set_icon_name)
Xen_wrap_1_arg(gxg_gtk_button_get_icon_name_w, gxg_gtk_button_get_icon_name)
Xen_wrap_2_args(gxg_gtk_drawing_area_set_content_width_w, gxg_gtk_drawing_area_set_content_width)
Xen_wrap_1_arg(gxg_gtk_drawing_area_get_content_width_w, gxg_gtk_drawing_area_get_content_width)
Xen_wrap_2_args(gxg_gtk_drawing_area_set_content_height_w, gxg_gtk_drawing_area_set_content_height)
Xen_wrap_1_arg(gxg_gtk_drawing_area_get_content_height_w, gxg_gtk_drawing_area_get_content_height)
Xen_wrap_4_args(gxg_gtk_drawing_area_set_draw_func_w, gxg_gtk_drawing_area_set_draw_func)
Xen_wrap_1_arg(gxg_gdk_drawing_context_get_paint_context_w, gxg_gdk_drawing_context_get_paint_context)
Xen_wrap_1_arg(gxg_gdk_gl_context_get_damage_w, gxg_gdk_gl_context_get_damage)
Xen_wrap_1_arg(gxg_gdk_rgba_is_clear_w, gxg_gdk_rgba_is_clear)
Xen_wrap_1_arg(gxg_gdk_rgba_is_opaque_w, gxg_gdk_rgba_is_opaque)
Xen_wrap_3_args(gxg_gdk_window_begin_draw_frame_w, gxg_gdk_window_begin_draw_frame)
Xen_wrap_3_args(gxg_gtk_flow_box_get_child_at_pos_w, gxg_gtk_flow_box_get_child_at_pos)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_system_information_w, gxg_gtk_about_dialog_get_system_information)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_system_information_w, gxg_gtk_about_dialog_set_system_information)
Xen_wrap_2_args(gxg_gtk_action_bar_set_revealed_w, gxg_gtk_action_bar_set_revealed)
Xen_wrap_1_arg(gxg_gtk_action_bar_get_revealed_w, gxg_gtk_action_bar_get_revealed)
Xen_wrap_2_args(gxg_gtk_check_button_set_draw_indicator_w, gxg_gtk_check_button_set_draw_indicator)
Xen_wrap_1_arg(gxg_gtk_check_button_get_draw_indicator_w, gxg_gtk_check_button_get_draw_indicator)
Xen_wrap_2_args(gxg_gtk_check_button_set_inconsistent_w, gxg_gtk_check_button_set_inconsistent)
Xen_wrap_1_arg(gxg_gtk_check_button_get_inconsistent_w, gxg_gtk_check_button_get_inconsistent)
Xen_wrap_2_args(gxg_gtk_info_bar_set_revealed_w, gxg_gtk_info_bar_set_revealed)
Xen_wrap_1_arg(gxg_gtk_info_bar_get_revealed_w, gxg_gtk_info_bar_get_revealed)
Xen_wrap_1_arg(gxg_gtk_widget_get_first_child_w, gxg_gtk_widget_get_first_child)
Xen_wrap_1_arg(gxg_gtk_widget_get_last_child_w, gxg_gtk_widget_get_last_child)
Xen_wrap_1_arg(gxg_gtk_widget_get_next_sibling_w, gxg_gtk_widget_get_next_sibling)
Xen_wrap_1_arg(gxg_gtk_widget_get_prev_sibling_w, gxg_gtk_widget_get_prev_sibling)
Xen_wrap_2_args(gxg_gtk_widget_set_focus_child_w, gxg_gtk_widget_set_focus_child)
Xen_wrap_4_optional_args(gxg_gtk_show_uri_on_window_w, gxg_gtk_show_uri_on_window)
Xen_wrap_2_args(gxg_gtk_box_pack_start_w, gxg_gtk_box_pack_start)
Xen_wrap_2_args(gxg_gtk_box_pack_end_w, gxg_gtk_box_pack_end)
Xen_wrap_3_args(gxg_gtk_widget_insert_after_w, gxg_gtk_widget_insert_after)
Xen_wrap_3_args(gxg_gtk_widget_insert_before_w, gxg_gtk_widget_insert_before)
Xen_wrap_no_args(gxg_gtk_center_box_new_w, gxg_gtk_center_box_new)
Xen_wrap_2_args(gxg_gtk_center_box_set_start_widget_w, gxg_gtk_center_box_set_start_widget)
Xen_wrap_2_args(gxg_gtk_center_box_set_center_widget_w, gxg_gtk_center_box_set_center_widget)
Xen_wrap_2_args(gxg_gtk_center_box_set_end_widget_w, gxg_gtk_center_box_set_end_widget)
Xen_wrap_1_arg(gxg_gtk_center_box_get_start_widget_w, gxg_gtk_center_box_get_start_widget)
Xen_wrap_1_arg(gxg_gtk_center_box_get_center_widget_w, gxg_gtk_center_box_get_center_widget)
Xen_wrap_1_arg(gxg_gtk_center_box_get_end_widget_w, gxg_gtk_center_box_get_end_widget)
Xen_wrap_2_args(gxg_gtk_center_box_set_baseline_position_w, gxg_gtk_center_box_set_baseline_position)
Xen_wrap_1_arg(gxg_gtk_center_box_get_baseline_position_w, gxg_gtk_center_box_get_baseline_position)
Xen_wrap_3_args(gxg_gdk_event_set_coords_w, gxg_gdk_event_set_coords)
Xen_wrap_2_args(gxg_gdk_event_set_user_data_w, gxg_gdk_event_set_user_data)
Xen_wrap_3_args(gxg_gdk_rectangle_contains_point_w, gxg_gdk_rectangle_contains_point)
Xen_wrap_1_arg(gxg_gtk_get_event_target_w, gxg_gtk_get_event_target)
Xen_wrap_2_args(gxg_gtk_accel_label_set_label_w, gxg_gtk_accel_label_set_label)
Xen_wrap_1_arg(gxg_gtk_accel_label_get_label_w, gxg_gtk_accel_label_get_label)
Xen_wrap_2_args(gxg_gtk_accel_label_set_use_underline_w, gxg_gtk_accel_label_set_use_underline)
Xen_wrap_1_arg(gxg_gtk_accel_label_get_use_underline_w, gxg_gtk_accel_label_get_use_underline)
Xen_wrap_2_args(gxg_gtk_scrollbar_set_adjustment_w, gxg_gtk_scrollbar_set_adjustment)
Xen_wrap_1_arg(gxg_gtk_scrollbar_get_adjustment_w, gxg_gtk_scrollbar_get_adjustment)
Xen_wrap_2_args(gxg_gtk_scrollbar_get_wheel_delta_w, gxg_gtk_scrollbar_get_wheel_delta)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_text_w, gxg_gtk_spin_button_get_text)
Xen_wrap_2_args(gxg_gtk_spin_button_set_text_w, gxg_gtk_spin_button_set_text)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_max_width_chars_w, gxg_gtk_spin_button_get_max_width_chars)
Xen_wrap_2_args(gxg_gtk_spin_button_set_max_width_chars_w, gxg_gtk_spin_button_set_max_width_chars)
Xen_wrap_1_arg(gxg_gtk_spin_button_get_width_chars_w, gxg_gtk_spin_button_get_width_chars)
Xen_wrap_2_args(gxg_gtk_spin_button_set_width_chars_w, gxg_gtk_spin_button_set_width_chars)
Xen_wrap_4_args(gxg_gtk_widget_size_allocate_w, gxg_gtk_widget_size_allocate)
Xen_wrap_no_args(gxg_gtk_style_context_new_w, gxg_gtk_style_context_new)
Xen_wrap_3_args(gxg_gtk_style_context_add_provider_w, gxg_gtk_style_context_add_provider)
Xen_wrap_1_arg(gxg_gtk_style_context_save_w, gxg_gtk_style_context_save)
Xen_wrap_1_arg(gxg_gtk_style_context_restore_w, gxg_gtk_style_context_restore)
Xen_wrap_2_args(gxg_gtk_style_context_get_section_w, gxg_gtk_style_context_get_section)
Xen_wrap_3_args(gxg_gtk_style_context_get_property_w, gxg_gtk_style_context_get_property)
Xen_wrap_2_args(gxg_gtk_style_context_set_state_w, gxg_gtk_style_context_set_state)
Xen_wrap_1_arg(gxg_gtk_style_context_get_state_w, gxg_gtk_style_context_get_state)
Xen_wrap_2_args(gxg_gtk_style_context_set_scale_w, gxg_gtk_style_context_set_scale)
Xen_wrap_1_arg(gxg_gtk_style_context_get_scale_w, gxg_gtk_style_context_get_scale)
Xen_wrap_2_args(gxg_gtk_style_context_set_path_w, gxg_gtk_style_context_set_path)
Xen_wrap_1_arg(gxg_gtk_style_context_get_path_w, gxg_gtk_style_context_get_path)
Xen_wrap_2_args(gxg_gtk_style_context_set_parent_w, gxg_gtk_style_context_set_parent)
Xen_wrap_1_arg(gxg_gtk_style_context_get_parent_w, gxg_gtk_style_context_get_parent)
Xen_wrap_1_arg(gxg_gtk_style_context_list_classes_w, gxg_gtk_style_context_list_classes)
Xen_wrap_2_args(gxg_gtk_style_context_add_class_w, gxg_gtk_style_context_add_class)
Xen_wrap_2_args(gxg_gtk_style_context_remove_class_w, gxg_gtk_style_context_remove_class)
Xen_wrap_2_args(gxg_gtk_style_context_has_class_w, gxg_gtk_style_context_has_class)
Xen_wrap_2_args(gxg_gtk_style_context_set_frame_clock_w, gxg_gtk_style_context_set_frame_clock)
Xen_wrap_1_arg(gxg_gtk_style_context_get_frame_clock_w, gxg_gtk_style_context_get_frame_clock)
Xen_wrap_3_args(gxg_gtk_style_context_lookup_color_w, gxg_gtk_style_context_lookup_color)
Xen_wrap_2_args(gxg_gtk_style_context_get_color_w, gxg_gtk_style_context_get_color)
Xen_wrap_2_args(gxg_gtk_style_context_get_border_w, gxg_gtk_style_context_get_border)
Xen_wrap_2_args(gxg_gtk_style_context_get_padding_w, gxg_gtk_style_context_get_padding)
Xen_wrap_2_args(gxg_gtk_style_context_get_margin_w, gxg_gtk_style_context_get_margin)
Xen_wrap_7_args(gxg_gtk_render_insertion_cursor_w, gxg_gtk_render_insertion_cursor)
Xen_wrap_2_args(gxg_gtk_style_context_to_string_w, gxg_gtk_style_context_to_string)
Xen_wrap_no_args(gxg_gtk_css_provider_new_w, gxg_gtk_css_provider_new)
Xen_wrap_1_arg(gxg_gtk_css_provider_to_string_w, gxg_gtk_css_provider_to_string)
Xen_wrap_3_args(gxg_gtk_css_provider_load_from_data_w, gxg_gtk_css_provider_load_from_data)
Xen_wrap_2_args(gxg_gtk_css_provider_load_from_file_w, gxg_gtk_css_provider_load_from_file)
Xen_wrap_2_args(gxg_gtk_css_provider_load_from_path_w, gxg_gtk_css_provider_load_from_path)
Xen_wrap_2_args(gxg_gtk_css_provider_load_from_resource_w, gxg_gtk_css_provider_load_from_resource)
Xen_wrap_no_args(gxg_gtk_css_provider_get_default_w, gxg_gtk_css_provider_get_default)
Xen_wrap_2_args(gxg_gtk_css_provider_get_named_w, gxg_gtk_css_provider_get_named)
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
Xen_wrap_2_args(gxg_gdk_event_set_keyval_w, gxg_gdk_event_set_keyval)
Xen_wrap_2_optional_args(gxg_gdk_event_get_key_is_modifier_w, gxg_gdk_event_get_key_is_modifier)
Xen_wrap_2_optional_args(gxg_gdk_event_get_key_group_w, gxg_gdk_event_get_key_group)
Xen_wrap_2_optional_args(gxg_gdk_event_get_string_w, gxg_gdk_event_get_string)
Xen_wrap_2_optional_args(gxg_gdk_event_get_setting_w, gxg_gdk_event_get_setting)
Xen_wrap_1_arg(gxg_gdk_event_is_sent_w, gxg_gdk_event_is_sent)
Xen_wrap_2_optional_args(gxg_gdk_event_get_drag_context_w, gxg_gdk_event_get_drag_context)
Xen_wrap_2_optional_args(gxg_gdk_event_get_crossing_mode_w, gxg_gdk_event_get_crossing_mode)
Xen_wrap_2_optional_args(gxg_gdk_event_get_crossing_detail_w, gxg_gdk_event_get_crossing_detail)
Xen_wrap_2_optional_args(gxg_gdk_event_get_touchpad_gesture_phase_w, gxg_gdk_event_get_touchpad_gesture_phase)
Xen_wrap_2_optional_args(gxg_gdk_event_get_touchpad_gesture_n_fingers_w, gxg_gdk_event_get_touchpad_gesture_n_fingers)
Xen_wrap_3_optional_args(gxg_gdk_event_get_touchpad_deltas_w, gxg_gdk_event_get_touchpad_deltas)
Xen_wrap_2_optional_args(gxg_gdk_event_get_touchpad_angle_delta_w, gxg_gdk_event_get_touchpad_angle_delta)
Xen_wrap_2_optional_args(gxg_gdk_event_get_touchpad_scale_w, gxg_gdk_event_get_touchpad_scale)
Xen_wrap_2_optional_args(gxg_gdk_event_get_touch_emulating_pointer_w, gxg_gdk_event_get_touch_emulating_pointer)
Xen_wrap_2_optional_args(gxg_gdk_event_get_grab_window_w, gxg_gdk_event_get_grab_window)
Xen_wrap_2_optional_args(gxg_gdk_event_get_focus_in_w, gxg_gdk_event_get_focus_in)
Xen_wrap_3_optional_args(gxg_gdk_event_get_pad_group_mode_w, gxg_gdk_event_get_pad_group_mode)
Xen_wrap_2_optional_args(gxg_gdk_event_get_pad_button_w, gxg_gdk_event_get_pad_button)
Xen_wrap_3_optional_args(gxg_gdk_event_get_pad_axis_value_w, gxg_gdk_event_get_pad_axis_value)
Xen_wrap_3_optional_args(gxg_gdk_event_get_axes_w, gxg_gdk_event_get_axes)
Xen_wrap_3_args(gxg_gtk_snapshot_push_blur_w, gxg_gtk_snapshot_push_blur)
Xen_wrap_no_args(gxg_gtk_emoji_chooser_new_w, gxg_gtk_emoji_chooser_new)
Xen_wrap_2_args(gxg_gtk_event_controller_scroll_new_w, gxg_gtk_event_controller_scroll_new)
Xen_wrap_2_args(gxg_gtk_event_controller_scroll_set_flags_w, gxg_gtk_event_controller_scroll_set_flags)
Xen_wrap_1_arg(gxg_gtk_event_controller_scroll_get_flags_w, gxg_gtk_event_controller_scroll_get_flags)
Xen_wrap_2_args(gxg_gdk_app_launch_context_set_desktop_w, gxg_gdk_app_launch_context_set_desktop)
Xen_wrap_2_args(gxg_gdk_app_launch_context_set_timestamp_w, gxg_gdk_app_launch_context_set_timestamp)
Xen_wrap_2_args(gxg_gdk_app_launch_context_set_icon_w, gxg_gdk_app_launch_context_set_icon)
Xen_wrap_2_args(gxg_gdk_app_launch_context_set_icon_name_w, gxg_gdk_app_launch_context_set_icon_name)
Xen_wrap_1_arg(gxg_gdk_clipboard_get_display_w, gxg_gdk_clipboard_get_display)
Xen_wrap_1_arg(gxg_gdk_clipboard_get_formats_w, gxg_gdk_clipboard_get_formats)
Xen_wrap_1_arg(gxg_gdk_clipboard_is_local_w, gxg_gdk_clipboard_is_local)
Xen_wrap_1_arg(gxg_gdk_clipboard_get_content_w, gxg_gdk_clipboard_get_content)
Xen_wrap_5_args(gxg_gdk_clipboard_store_async_w, gxg_gdk_clipboard_store_async)
Xen_wrap_3_optional_args(gxg_gdk_clipboard_store_finish_w, gxg_gdk_clipboard_store_finish)
Xen_wrap_6_args(gxg_gdk_clipboard_read_async_w, gxg_gdk_clipboard_read_async)
Xen_wrap_4_optional_args(gxg_gdk_clipboard_read_finish_w, gxg_gdk_clipboard_read_finish)
Xen_wrap_6_args(gxg_gdk_clipboard_read_value_async_w, gxg_gdk_clipboard_read_value_async)
Xen_wrap_3_optional_args(gxg_gdk_clipboard_read_value_finish_w, gxg_gdk_clipboard_read_value_finish)
Xen_wrap_4_args(gxg_gdk_clipboard_read_texture_async_w, gxg_gdk_clipboard_read_texture_async)
Xen_wrap_3_optional_args(gxg_gdk_clipboard_read_texture_finish_w, gxg_gdk_clipboard_read_texture_finish)
Xen_wrap_4_args(gxg_gdk_clipboard_read_text_async_w, gxg_gdk_clipboard_read_text_async)
Xen_wrap_3_optional_args(gxg_gdk_clipboard_read_text_finish_w, gxg_gdk_clipboard_read_text_finish)
Xen_wrap_2_args(gxg_gdk_clipboard_set_content_w, gxg_gdk_clipboard_set_content)
Xen_wrap_2_args(gxg_gdk_clipboard_set_w, gxg_gdk_clipboard_set)
Xen_wrap_2_args(gxg_gdk_clipboard_set_value_w, gxg_gdk_clipboard_set_value)
Xen_wrap_2_args(gxg_gdk_clipboard_set_text_w, gxg_gdk_clipboard_set_text)
Xen_wrap_2_args(gxg_gdk_clipboard_set_texture_w, gxg_gdk_clipboard_set_texture)
Xen_wrap_1_arg(gxg_gdk_intern_mime_type_w, gxg_gdk_intern_mime_type)
Xen_wrap_2_args(gxg_gdk_content_formats_new_w, gxg_gdk_content_formats_new)
Xen_wrap_1_arg(gxg_gdk_content_formats_new_for_gtype_w, gxg_gdk_content_formats_new_for_gtype)
Xen_wrap_1_arg(gxg_gdk_content_formats_ref_w, gxg_gdk_content_formats_ref)
Xen_wrap_1_arg(gxg_gdk_content_formats_unref_w, gxg_gdk_content_formats_unref)
Xen_wrap_2_args(gxg_gdk_content_formats_print_w, gxg_gdk_content_formats_print)
Xen_wrap_1_arg(gxg_gdk_content_formats_to_string_w, gxg_gdk_content_formats_to_string)
Xen_wrap_2_optional_args(gxg_gdk_content_formats_get_gtypes_w, gxg_gdk_content_formats_get_gtypes)
Xen_wrap_2_optional_args(gxg_gdk_content_formats_get_mime_types_w, gxg_gdk_content_formats_get_mime_types)
Xen_wrap_2_args(gxg_gdk_content_formats_union_w, gxg_gdk_content_formats_union)
Xen_wrap_2_args(gxg_gdk_content_formats_match_w, gxg_gdk_content_formats_match)
Xen_wrap_2_args(gxg_gdk_content_formats_match_gtype_w, gxg_gdk_content_formats_match_gtype)
Xen_wrap_2_args(gxg_gdk_content_formats_match_mime_type_w, gxg_gdk_content_formats_match_mime_type)
Xen_wrap_2_args(gxg_gdk_content_formats_contain_gtype_w, gxg_gdk_content_formats_contain_gtype)
Xen_wrap_2_args(gxg_gdk_content_formats_contain_mime_type_w, gxg_gdk_content_formats_contain_mime_type)
Xen_wrap_no_args(gxg_*gdk_content_formats_builder_new_w, gxg_*gdk_content_formats_builder_new)
Xen_wrap_1_arg(gxg_gdk_content_formats_builder_free_w, gxg_gdk_content_formats_builder_free)
Xen_wrap_2_args(gxg_gdk_content_formats_builder_add_formats_w, gxg_gdk_content_formats_builder_add_formats)
Xen_wrap_2_args(gxg_gdk_content_formats_builder_add_mime_type_w, gxg_gdk_content_formats_builder_add_mime_type)
Xen_wrap_2_args(gxg_gdk_content_formats_builder_add_gtype_w, gxg_gdk_content_formats_builder_add_gtype)
Xen_wrap_1_arg(gxg_gdk_content_provider_ref_formats_w, gxg_gdk_content_provider_ref_formats)
Xen_wrap_1_arg(gxg_gdk_content_provider_ref_storable_formats_w, gxg_gdk_content_provider_ref_storable_formats)
Xen_wrap_1_arg(gxg_gdk_content_provider_content_changed_w, gxg_gdk_content_provider_content_changed)
Xen_wrap_7_args(gxg_gdk_content_provider_write_mime_type_async_w, gxg_gdk_content_provider_write_mime_type_async)
Xen_wrap_3_optional_args(gxg_gdk_content_provider_write_mime_type_finish_w, gxg_gdk_content_provider_write_mime_type_finish)
Xen_wrap_3_optional_args(gxg_gdk_content_provider_get_value_w, gxg_gdk_content_provider_get_value)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_mime_type_w, gxg_gdk_content_serializer_get_mime_type)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_value_w, gxg_gdk_content_serializer_get_value)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_output_stream_w, gxg_gdk_content_serializer_get_output_stream)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_priority_w, gxg_gdk_content_serializer_get_priority)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_cancellable_w, gxg_gdk_content_serializer_get_cancellable)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_user_data_w, gxg_gdk_content_serializer_get_user_data)
Xen_wrap_3_args(gxg_gdk_content_serializer_set_task_data_w, gxg_gdk_content_serializer_set_task_data)
Xen_wrap_1_arg(gxg_gdk_content_serializer_get_task_data_w, gxg_gdk_content_serializer_get_task_data)
Xen_wrap_1_arg(gxg_gdk_content_serializer_return_success_w, gxg_gdk_content_serializer_return_success)
Xen_wrap_2_args(gxg_gdk_content_serializer_return_error_w, gxg_gdk_content_serializer_return_error)
Xen_wrap_1_arg(gxg_gdk_content_formats_union_serialize_gtypes_w, gxg_gdk_content_formats_union_serialize_gtypes)
Xen_wrap_1_arg(gxg_gdk_content_formats_union_serialize_mime_types_w, gxg_gdk_content_formats_union_serialize_mime_types)
Xen_wrap_5_args(gxg_gdk_content_register_serializer_w, gxg_gdk_content_register_serializer)
Xen_wrap_7_args(gxg_gdk_content_serialize_async_w, gxg_gdk_content_serialize_async)
Xen_wrap_2_optional_args(gxg_gdk_content_serialize_finish_w, gxg_gdk_content_serialize_finish)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_mime_type_w, gxg_gdk_content_deserializer_get_mime_type)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_value_w, gxg_gdk_content_deserializer_get_value)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_input_stream_w, gxg_gdk_content_deserializer_get_input_stream)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_priority_w, gxg_gdk_content_deserializer_get_priority)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_cancellable_w, gxg_gdk_content_deserializer_get_cancellable)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_user_data_w, gxg_gdk_content_deserializer_get_user_data)
Xen_wrap_3_args(gxg_gdk_content_deserializer_set_task_data_w, gxg_gdk_content_deserializer_set_task_data)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_get_task_data_w, gxg_gdk_content_deserializer_get_task_data)
Xen_wrap_1_arg(gxg_gdk_content_deserializer_return_success_w, gxg_gdk_content_deserializer_return_success)
Xen_wrap_2_args(gxg_gdk_content_deserializer_return_error_w, gxg_gdk_content_deserializer_return_error)
Xen_wrap_1_arg(gxg_gdk_content_formats_union_deserialize_gtypes_w, gxg_gdk_content_formats_union_deserialize_gtypes)
Xen_wrap_1_arg(gxg_gdk_content_formats_union_deserialize_mime_types_w, gxg_gdk_content_formats_union_deserialize_mime_types)
Xen_wrap_5_args(gxg_gdk_content_register_deserializer_w, gxg_gdk_content_register_deserializer)
Xen_wrap_7_args(gxg_gdk_content_deserialize_async_w, gxg_gdk_content_deserialize_async)
Xen_wrap_3_optional_args(gxg_gdk_content_deserialize_finish_w, gxg_gdk_content_deserialize_finish)
Xen_wrap_1_arg(gxg_gdk_content_provider_new_for_value_w, gxg_gdk_content_provider_new_for_value)
Xen_wrap_2_args(gxg_gdk_content_provider_new_for_bytes_w, gxg_gdk_content_provider_new_for_bytes)
Xen_wrap_1_arg(gxg_gtk_event_controller_motion_new_w, gxg_gtk_event_controller_motion_new)
Xen_wrap_4_args(gxg_gdk_texture_new_for_data_w, gxg_gdk_texture_new_for_data)
Xen_wrap_1_arg(gxg_gdk_texture_new_for_pixbuf_w, gxg_gdk_texture_new_for_pixbuf)
Xen_wrap_1_arg(gxg_gdk_texture_new_from_resource_w, gxg_gdk_texture_new_from_resource)
Xen_wrap_2_optional_args(gxg_gdk_texture_new_from_file_w, gxg_gdk_texture_new_from_file)
Xen_wrap_1_arg(gxg_gdk_texture_get_width_w, gxg_gdk_texture_get_width)
Xen_wrap_1_arg(gxg_gdk_texture_get_height_w, gxg_gdk_texture_get_height)
Xen_wrap_3_args(gxg_gdk_texture_download_w, gxg_gdk_texture_download)
Xen_wrap_4_args(gxg_gdk_cursor_new_from_texture_w, gxg_gdk_cursor_new_from_texture)
Xen_wrap_2_args(gxg_gdk_cursor_new_from_name_w, gxg_gdk_cursor_new_from_name)
Xen_wrap_1_arg(gxg_gdk_cursor_get_fallback_w, gxg_gdk_cursor_get_fallback)
Xen_wrap_1_arg(gxg_gdk_cursor_get_name_w, gxg_gdk_cursor_get_name)
Xen_wrap_1_arg(gxg_gdk_cursor_get_texture_w, gxg_gdk_cursor_get_texture)
Xen_wrap_1_arg(gxg_gdk_cursor_get_hotspot_x_w, gxg_gdk_cursor_get_hotspot_x)
Xen_wrap_1_arg(gxg_gdk_cursor_get_hotspot_y_w, gxg_gdk_cursor_get_hotspot_y)
Xen_wrap_3_optional_args(gxg_gdk_device_get_position_w, gxg_gdk_device_get_position)
Xen_wrap_3_optional_args(gxg_gdk_device_get_position_double_w, gxg_gdk_device_get_position_double)
Xen_wrap_1_arg(gxg_gdk_display_get_clipboard_w, gxg_gdk_display_get_clipboard)
Xen_wrap_1_arg(gxg_gdk_display_get_primary_clipboard_w, gxg_gdk_display_get_primary_clipboard)
Xen_wrap_1_arg(gxg_gdk_display_get_keymap_w, gxg_gdk_display_get_keymap)
Xen_wrap_3_optional_args(gxg_gdk_display_get_setting_w, gxg_gdk_display_get_setting)
Xen_wrap_1_arg(gxg_gdk_drag_context_get_display_w, gxg_gdk_drag_context_get_display)
Xen_wrap_1_arg(gxg_gdk_drag_context_get_formats_w, gxg_gdk_drag_context_get_formats)
Xen_wrap_6_args(gxg_gdk_drop_read_async_w, gxg_gdk_drop_read_async)
Xen_wrap_4_optional_args(gxg_gdk_drop_read_finish_w, gxg_gdk_drop_read_finish)
Xen_wrap_6_args(gxg_gdk_drag_begin_w, gxg_gdk_drag_begin)
Xen_wrap_1_arg(gxg_gdk_monitor_is_valid_w, gxg_gdk_monitor_is_valid)
Xen_wrap_2_args(gxg_gdk_seat_get_master_pointers_w, gxg_gdk_seat_get_master_pointers)
Xen_wrap_6_args(gxg_gtk_drag_begin_with_coordinates_w, gxg_gtk_drag_begin_with_coordinates)
Xen_wrap_2_args(gxg_gtk_drag_source_set_icon_surface_w, gxg_gtk_drag_source_set_icon_surface)
Xen_wrap_3_args(gxg_gtk_entry_set_icon_from_texture_w, gxg_gtk_entry_set_icon_from_texture)
Xen_wrap_2_args(gxg_gtk_entry_get_icon_texture_w, gxg_gtk_entry_get_icon_texture)
Xen_wrap_4_args(gxg_gtk_entry_set_icon_drag_source_w, gxg_gtk_entry_set_icon_drag_source)
Xen_wrap_1_arg(gxg_gtk_header_bar_get_show_title_buttons_w, gxg_gtk_header_bar_get_show_title_buttons)
Xen_wrap_2_args(gxg_gtk_header_bar_set_show_title_buttons_w, gxg_gtk_header_bar_set_show_title_buttons)
Xen_wrap_1_arg(gxg_gtk_icon_theme_get_for_display_w, gxg_gtk_icon_theme_get_for_display)
Xen_wrap_2_args(gxg_gtk_icon_theme_set_display_w, gxg_gtk_icon_theme_set_display)
Xen_wrap_1_arg(gxg_gtk_icon_info_load_texture_w, gxg_gtk_icon_info_load_texture)
Xen_wrap_1_arg(gxg_gtk_image_new_from_texture_w, gxg_gtk_image_new_from_texture)
Xen_wrap_1_arg(gxg_gtk_image_new_from_icon_name_w, gxg_gtk_image_new_from_icon_name)
Xen_wrap_1_arg(gxg_gtk_image_new_from_gicon_w, gxg_gtk_image_new_from_gicon)
Xen_wrap_2_args(gxg_gtk_image_set_from_texture_w, gxg_gtk_image_set_from_texture)
Xen_wrap_2_args(gxg_gtk_image_set_from_icon_name_w, gxg_gtk_image_set_from_icon_name)
Xen_wrap_2_args(gxg_gtk_image_set_from_gicon_w, gxg_gtk_image_set_from_gicon)
Xen_wrap_2_args(gxg_gtk_image_set_icon_size_w, gxg_gtk_image_set_icon_size)
Xen_wrap_1_arg(gxg_gtk_image_get_surface_w, gxg_gtk_image_get_surface)
Xen_wrap_1_arg(gxg_gtk_image_get_texture_w, gxg_gtk_image_get_texture)
Xen_wrap_1_arg(gxg_gtk_image_get_icon_size_w, gxg_gtk_image_get_icon_size)
Xen_wrap_1_arg(gxg_gtk_image_get_icon_name_w, gxg_gtk_image_get_icon_name)
Xen_wrap_1_arg(gxg_gtk_image_get_gicon_w, gxg_gtk_image_get_gicon)
Xen_wrap_1_arg(gxg_gtk_invisible_new_for_display_w, gxg_gtk_invisible_new_for_display)
Xen_wrap_2_args(gxg_gtk_invisible_set_display_w, gxg_gtk_invisible_set_display)
Xen_wrap_no_args(gxg_GtkInvisible*_w, gxg_GtkInvisible*)
Xen_wrap_2_args(gxg_gtk_menu_set_display_w, gxg_gtk_menu_set_display)
Xen_wrap_5_args(gxg_gtk_render_icon_w, gxg_gtk_render_icon)
Xen_wrap_1_arg(gxg_gtk_content_formats_add_text_targets_w, gxg_gtk_content_formats_add_text_targets)
Xen_wrap_2_args(gxg_gtk_content_formats_add_image_targets_w, gxg_gtk_content_formats_add_image_targets)
Xen_wrap_1_arg(gxg_gtk_content_formats_add_uri_targets_w, gxg_gtk_content_formats_add_uri_targets)
Xen_wrap_5_args(gxg_gtk_selection_data_set_w, gxg_gtk_selection_data_set)
Xen_wrap_3_args(gxg_gtk_selection_data_set_text_w, gxg_gtk_selection_data_set_text)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_text_w, gxg_gtk_selection_data_get_text)
Xen_wrap_2_args(gxg_gtk_selection_data_set_pixbuf_w, gxg_gtk_selection_data_set_pixbuf)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_surface_w, gxg_gtk_selection_data_get_surface)
Xen_wrap_2_args(gxg_gtk_selection_data_set_surface_w, gxg_gtk_selection_data_set_surface)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_pixbuf_w, gxg_gtk_selection_data_get_pixbuf)
Xen_wrap_2_args(gxg_gtk_selection_data_set_texture_w, gxg_gtk_selection_data_set_texture)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_texture_w, gxg_gtk_selection_data_get_texture)
Xen_wrap_2_args(gxg_gtk_selection_data_set_uris_w, gxg_gtk_selection_data_set_uris)
Xen_wrap_1_arg(gxg_gtk_selection_data_get_uris_w, gxg_gtk_selection_data_get_uris)
Xen_wrap_3_optional_args(gxg_gtk_selection_data_get_targets_w, gxg_gtk_selection_data_get_targets)
Xen_wrap_1_arg(gxg_gtk_selection_data_targets_include_text_w, gxg_gtk_selection_data_targets_include_text)
Xen_wrap_1_arg(gxg_gtk_selection_data_targets_include_uri_w, gxg_gtk_selection_data_targets_include_uri)
Xen_wrap_2_args(gxg_gtk_targets_include_text_w, gxg_gtk_targets_include_text)
Xen_wrap_3_args(gxg_gtk_targets_include_image_w, gxg_gtk_targets_include_image)
Xen_wrap_2_args(gxg_gtk_targets_include_uri_w, gxg_gtk_targets_include_uri)
Xen_wrap_1_arg(gxg_gtk_settings_get_for_display_w, gxg_gtk_settings_get_for_display)
Xen_wrap_3_args(gxg_gtk_style_context_add_provider_for_display_w, gxg_gtk_style_context_add_provider_for_display)
Xen_wrap_2_args(gxg_gtk_style_context_remove_provider_for_display_w, gxg_gtk_style_context_remove_provider_for_display)
Xen_wrap_2_args(gxg_gtk_style_context_set_display_w, gxg_gtk_style_context_set_display)
Xen_wrap_1_arg(gxg_gtk_style_context_get_display_w, gxg_gtk_style_context_get_display)
Xen_wrap_1_arg(gxg_gtk_style_context_reset_widgets_w, gxg_gtk_style_context_reset_widgets)
Xen_wrap_3_args(gxg_gtk_text_buffer_insert_texture_w, gxg_gtk_text_buffer_insert_texture)
Xen_wrap_2_args(gxg_gtk_text_buffer_add_selection_clipboard_w, gxg_gtk_text_buffer_add_selection_clipboard)
Xen_wrap_2_args(gxg_gtk_text_buffer_remove_selection_clipboard_w, gxg_gtk_text_buffer_remove_selection_clipboard)
Xen_wrap_3_args(gxg_gtk_text_buffer_cut_clipboard_w, gxg_gtk_text_buffer_cut_clipboard)
Xen_wrap_2_args(gxg_gtk_text_buffer_copy_clipboard_w, gxg_gtk_text_buffer_copy_clipboard)
Xen_wrap_2_args(gxg_gtk_text_buffer_paste_clipboard_w, gxg_gtk_text_buffer_paste_clipboard)
Xen_wrap_1_arg(gxg_override_location_w, gxg_override_location)
Xen_wrap_no_args(gxg_gtk_tool_palette_get_drag_target_item_w, gxg_gtk_tool_palette_get_drag_target_item)
Xen_wrap_no_args(gxg_gtk_tool_palette_get_drag_target_group_w, gxg_gtk_tool_palette_get_drag_target_group)
Xen_wrap_2_args(gxg_gtk_tooltip_set_icon_w, gxg_gtk_tooltip_set_icon)
Xen_wrap_2_args(gxg_gtk_tooltip_set_icon_from_icon_name_w, gxg_gtk_tooltip_set_icon_from_icon_name)
Xen_wrap_2_args(gxg_gtk_tooltip_set_icon_from_gicon_w, gxg_gtk_tooltip_set_icon_from_gicon)
Xen_wrap_4_args(gxg_gtk_tree_view_enable_model_drag_source_w, gxg_gtk_tree_view_enable_model_drag_source)
Xen_wrap_3_args(gxg_gtk_tree_view_enable_model_drag_dest_w, gxg_gtk_tree_view_enable_model_drag_dest)
Xen_wrap_1_arg(gxg_gtk_widget_get_width_w, gxg_gtk_widget_get_width)
Xen_wrap_1_arg(gxg_gtk_widget_get_height_w, gxg_gtk_widget_get_height)
Xen_wrap_1_arg(gxg_gtk_widget_get_clipboard_w, gxg_gtk_widget_get_clipboard)
Xen_wrap_1_arg(gxg_gtk_widget_get_primary_clipboard_w, gxg_gtk_widget_get_primary_clipboard)
Xen_wrap_3_args(gxg_gtk_widget_contains_w, gxg_gtk_widget_contains)
Xen_wrap_3_args(gxg_gtk_widget_pick_w, gxg_gtk_widget_pick)
Xen_wrap_2_args(gxg_gtk_widget_set_cursor_w, gxg_gtk_widget_set_cursor)
Xen_wrap_2_args(gxg_gtk_widget_set_cursor_from_name_w, gxg_gtk_widget_set_cursor_from_name)
Xen_wrap_1_arg(gxg_gtk_widget_get_cursor_w, gxg_gtk_widget_get_cursor)
Xen_wrap_2_args(gxg_gtk_window_set_display_w, gxg_gtk_window_set_display)
Xen_wrap_2_args(gxg_gtk_window_set_icon_w, gxg_gtk_window_set_icon)
Xen_wrap_1_arg(gxg_gtk_window_get_icon_w, gxg_gtk_window_get_icon)
Xen_wrap_1_arg(gxg_gtk_window_set_default_icon_w, gxg_gtk_window_set_default_icon)
Xen_wrap_2_args(gxg_gtk_window_fullscreen_on_monitor_w, gxg_gtk_window_fullscreen_on_monitor)
Xen_wrap_1_arg(gxg_gtk_text_iter_get_texture_w, gxg_gtk_text_iter_get_texture)
Xen_wrap_4_args(gxg_gtk_icon_view_enable_model_drag_source_w, gxg_gtk_icon_view_enable_model_drag_source)
Xen_wrap_3_args(gxg_gtk_icon_view_enable_model_drag_dest_w, gxg_gtk_icon_view_enable_model_drag_dest)
Xen_wrap_1_arg(gxg_gtk_about_dialog_get_logo_w, gxg_gtk_about_dialog_get_logo)
Xen_wrap_2_args(gxg_gtk_about_dialog_set_logo_w, gxg_gtk_about_dialog_set_logo)
Xen_wrap_1_arg(gxg_gtk_button_new_from_icon_name_w, gxg_gtk_button_new_from_icon_name)
Xen_wrap_1_arg(gxg_gtk_cell_view_new_with_texture_w, gxg_gtk_cell_view_new_with_texture)
Xen_wrap_3_args(gxg_gtk_drag_finish_w, gxg_gtk_drag_finish)
Xen_wrap_4_args(gxg_gtk_drag_set_icon_pixbuf_w, gxg_gtk_drag_set_icon_pixbuf)
Xen_wrap_4_args(gxg_gtk_drag_dest_set_w, gxg_gtk_drag_dest_set)
Xen_wrap_3_args(gxg_gtk_drag_dest_find_target_w, gxg_gtk_drag_dest_find_target)
Xen_wrap_1_arg(gxg_gtk_drag_dest_get_target_list_w, gxg_gtk_drag_dest_get_target_list)
Xen_wrap_2_args(gxg_gtk_drag_dest_set_target_list_w, gxg_gtk_drag_dest_set_target_list)
Xen_wrap_4_args(gxg_gtk_drag_source_set_w, gxg_gtk_drag_source_set)
Xen_wrap_1_arg(gxg_gtk_drag_source_get_target_list_w, gxg_gtk_drag_source_get_target_list)
Xen_wrap_2_args(gxg_gtk_drag_source_set_target_list_w, gxg_gtk_drag_source_set_target_list)
Xen_wrap_4_args(gxg_gtk_scale_button_new_w, gxg_gtk_scale_button_new)
Xen_wrap_2_args(gxg_gtk_application_new_w, gxg_gtk_application_new)
Xen_wrap_2_args(gxg_gtk_application_add_window_w, gxg_gtk_application_add_window)
Xen_wrap_2_args(gxg_gtk_application_remove_window_w, gxg_gtk_application_remove_window)
Xen_wrap_1_arg(gxg_gtk_application_get_windows_w, gxg_gtk_application_get_windows)
Xen_wrap_4_args(gxg_gtk_application_inhibit_w, gxg_gtk_application_inhibit)
Xen_wrap_2_args(gxg_gtk_application_uninhibit_w, gxg_gtk_application_uninhibit)
Xen_wrap_2_args(gxg_gtk_application_get_window_by_id_w, gxg_gtk_application_get_window_by_id)
Xen_wrap_1_arg(gxg_gtk_application_list_action_descriptions_w, gxg_gtk_application_list_action_descriptions)
Xen_wrap_2_args(gxg_gtk_application_get_accels_for_action_w, gxg_gtk_application_get_accels_for_action)
Xen_wrap_2_args(gxg_gtk_application_get_actions_for_accel_w, gxg_gtk_application_get_actions_for_accel)
Xen_wrap_3_args(gxg_gtk_application_set_accels_for_action_w, gxg_gtk_application_set_accels_for_action)
Xen_wrap_1_arg(gxg_gtk_application_prefers_app_menu_w, gxg_gtk_application_prefers_app_menu)
Xen_wrap_2_args(gxg_gtk_application_get_menu_by_id_w, gxg_gtk_application_get_menu_by_id)
#endif

Xen_wrap_1_arg(gxg_cairo_create_w, gxg_cairo_create)
Xen_wrap_no_args(gxg_cairo_version_w, gxg_cairo_version)
Xen_wrap_no_args(gxg_cairo_version_string_w, gxg_cairo_version_string)
Xen_wrap_1_arg(gxg_cairo_reference_w, gxg_cairo_reference)
Xen_wrap_1_arg(gxg_cairo_destroy_w, gxg_cairo_destroy)
Xen_wrap_1_arg(gxg_cairo_save_w, gxg_cairo_save)
Xen_wrap_1_arg(gxg_cairo_restore_w, gxg_cairo_restore)
Xen_wrap_1_arg(gxg_cairo_push_group_w, gxg_cairo_push_group)
Xen_wrap_2_args(gxg_cairo_push_group_with_content_w, gxg_cairo_push_group_with_content)
Xen_wrap_1_arg(gxg_cairo_pop_group_w, gxg_cairo_pop_group)
Xen_wrap_1_arg(gxg_cairo_pop_group_to_source_w, gxg_cairo_pop_group_to_source)
Xen_wrap_2_args(gxg_cairo_set_operator_w, gxg_cairo_set_operator)
Xen_wrap_2_args(gxg_cairo_set_source_w, gxg_cairo_set_source)
Xen_wrap_4_args(gxg_cairo_set_source_rgb_w, gxg_cairo_set_source_rgb)
Xen_wrap_5_args(gxg_cairo_set_source_rgba_w, gxg_cairo_set_source_rgba)
Xen_wrap_4_args(gxg_cairo_set_source_surface_w, gxg_cairo_set_source_surface)
Xen_wrap_2_args(gxg_cairo_set_tolerance_w, gxg_cairo_set_tolerance)
Xen_wrap_2_args(gxg_cairo_set_antialias_w, gxg_cairo_set_antialias)
Xen_wrap_2_args(gxg_cairo_set_fill_rule_w, gxg_cairo_set_fill_rule)
Xen_wrap_2_args(gxg_cairo_set_line_width_w, gxg_cairo_set_line_width)
Xen_wrap_2_args(gxg_cairo_set_line_cap_w, gxg_cairo_set_line_cap)
Xen_wrap_2_args(gxg_cairo_set_line_join_w, gxg_cairo_set_line_join)
Xen_wrap_4_args(gxg_cairo_set_dash_w, gxg_cairo_set_dash)
Xen_wrap_2_args(gxg_cairo_set_miter_limit_w, gxg_cairo_set_miter_limit)
Xen_wrap_3_args(gxg_cairo_translate_w, gxg_cairo_translate)
Xen_wrap_3_args(gxg_cairo_scale_w, gxg_cairo_scale)
Xen_wrap_2_args(gxg_cairo_rotate_w, gxg_cairo_rotate)
Xen_wrap_2_args(gxg_cairo_transform_w, gxg_cairo_transform)
Xen_wrap_2_args(gxg_cairo_set_matrix_w, gxg_cairo_set_matrix)
Xen_wrap_1_arg(gxg_cairo_identity_matrix_w, gxg_cairo_identity_matrix)
Xen_wrap_3_optional_args(gxg_cairo_user_to_device_w, gxg_cairo_user_to_device)
Xen_wrap_3_optional_args(gxg_cairo_user_to_device_distance_w, gxg_cairo_user_to_device_distance)
Xen_wrap_3_optional_args(gxg_cairo_device_to_user_w, gxg_cairo_device_to_user)
Xen_wrap_3_optional_args(gxg_cairo_device_to_user_distance_w, gxg_cairo_device_to_user_distance)
Xen_wrap_1_arg(gxg_cairo_new_path_w, gxg_cairo_new_path)
Xen_wrap_3_args(gxg_cairo_move_to_w, gxg_cairo_move_to)
Xen_wrap_1_arg(gxg_cairo_new_sub_path_w, gxg_cairo_new_sub_path)
Xen_wrap_3_args(gxg_cairo_line_to_w, gxg_cairo_line_to)
Xen_wrap_7_args(gxg_cairo_curve_to_w, gxg_cairo_curve_to)
Xen_wrap_6_args(gxg_cairo_arc_w, gxg_cairo_arc)
Xen_wrap_6_args(gxg_cairo_arc_negative_w, gxg_cairo_arc_negative)
Xen_wrap_3_args(gxg_cairo_rel_move_to_w, gxg_cairo_rel_move_to)
Xen_wrap_3_args(gxg_cairo_rel_line_to_w, gxg_cairo_rel_line_to)
Xen_wrap_7_args(gxg_cairo_rel_curve_to_w, gxg_cairo_rel_curve_to)
Xen_wrap_5_args(gxg_cairo_rectangle_w, gxg_cairo_rectangle)
Xen_wrap_1_arg(gxg_cairo_close_path_w, gxg_cairo_close_path)
Xen_wrap_1_arg(gxg_cairo_paint_w, gxg_cairo_paint)
Xen_wrap_2_args(gxg_cairo_paint_with_alpha_w, gxg_cairo_paint_with_alpha)
Xen_wrap_2_args(gxg_cairo_mask_w, gxg_cairo_mask)
Xen_wrap_4_args(gxg_cairo_mask_surface_w, gxg_cairo_mask_surface)
Xen_wrap_1_arg(gxg_cairo_stroke_w, gxg_cairo_stroke)
Xen_wrap_1_arg(gxg_cairo_stroke_preserve_w, gxg_cairo_stroke_preserve)
Xen_wrap_1_arg(gxg_cairo_fill_w, gxg_cairo_fill)
Xen_wrap_1_arg(gxg_cairo_fill_preserve_w, gxg_cairo_fill_preserve)
Xen_wrap_1_arg(gxg_cairo_copy_page_w, gxg_cairo_copy_page)
Xen_wrap_1_arg(gxg_cairo_show_page_w, gxg_cairo_show_page)
Xen_wrap_3_args(gxg_cairo_in_stroke_w, gxg_cairo_in_stroke)
Xen_wrap_3_args(gxg_cairo_in_fill_w, gxg_cairo_in_fill)
Xen_wrap_1_arg(gxg_cairo_reset_clip_w, gxg_cairo_reset_clip)
Xen_wrap_1_arg(gxg_cairo_clip_w, gxg_cairo_clip)
Xen_wrap_1_arg(gxg_cairo_clip_preserve_w, gxg_cairo_clip_preserve)
Xen_wrap_no_args(gxg_cairo_font_options_create_w, gxg_cairo_font_options_create)
Xen_wrap_1_arg(gxg_cairo_font_options_copy_w, gxg_cairo_font_options_copy)
Xen_wrap_1_arg(gxg_cairo_font_options_destroy_w, gxg_cairo_font_options_destroy)
Xen_wrap_1_arg(gxg_cairo_font_options_status_w, gxg_cairo_font_options_status)
Xen_wrap_2_args(gxg_cairo_font_options_merge_w, gxg_cairo_font_options_merge)
Xen_wrap_2_args(gxg_cairo_font_options_equal_w, gxg_cairo_font_options_equal)
Xen_wrap_1_arg(gxg_cairo_font_options_hash_w, gxg_cairo_font_options_hash)
Xen_wrap_2_args(gxg_cairo_font_options_set_antialias_w, gxg_cairo_font_options_set_antialias)
Xen_wrap_1_arg(gxg_cairo_font_options_get_antialias_w, gxg_cairo_font_options_get_antialias)
Xen_wrap_2_args(gxg_cairo_font_options_set_subpixel_order_w, gxg_cairo_font_options_set_subpixel_order)
Xen_wrap_1_arg(gxg_cairo_font_options_get_subpixel_order_w, gxg_cairo_font_options_get_subpixel_order)
Xen_wrap_2_args(gxg_cairo_font_options_set_hint_style_w, gxg_cairo_font_options_set_hint_style)
Xen_wrap_1_arg(gxg_cairo_font_options_get_hint_style_w, gxg_cairo_font_options_get_hint_style)
Xen_wrap_2_args(gxg_cairo_font_options_set_hint_metrics_w, gxg_cairo_font_options_set_hint_metrics)
Xen_wrap_1_arg(gxg_cairo_font_options_get_hint_metrics_w, gxg_cairo_font_options_get_hint_metrics)
Xen_wrap_4_args(gxg_cairo_select_font_face_w, gxg_cairo_select_font_face)
Xen_wrap_2_args(gxg_cairo_set_font_size_w, gxg_cairo_set_font_size)
Xen_wrap_2_args(gxg_cairo_set_font_matrix_w, gxg_cairo_set_font_matrix)
Xen_wrap_2_args(gxg_cairo_get_font_matrix_w, gxg_cairo_get_font_matrix)
Xen_wrap_2_args(gxg_cairo_set_font_options_w, gxg_cairo_set_font_options)
Xen_wrap_2_args(gxg_cairo_get_font_options_w, gxg_cairo_get_font_options)
Xen_wrap_2_args(gxg_cairo_set_scaled_font_w, gxg_cairo_set_scaled_font)
Xen_wrap_2_args(gxg_cairo_show_text_w, gxg_cairo_show_text)
Xen_wrap_3_args(gxg_cairo_show_glyphs_w, gxg_cairo_show_glyphs)
Xen_wrap_1_arg(gxg_cairo_get_font_face_w, gxg_cairo_get_font_face)
Xen_wrap_2_args(gxg_cairo_font_extents_w, gxg_cairo_font_extents)
Xen_wrap_2_args(gxg_cairo_set_font_face_w, gxg_cairo_set_font_face)
Xen_wrap_3_args(gxg_cairo_text_extents_w, gxg_cairo_text_extents)
Xen_wrap_4_args(gxg_cairo_glyph_extents_w, gxg_cairo_glyph_extents)
Xen_wrap_2_args(gxg_cairo_text_path_w, gxg_cairo_text_path)
Xen_wrap_3_args(gxg_cairo_glyph_path_w, gxg_cairo_glyph_path)
Xen_wrap_1_arg(gxg_cairo_font_face_reference_w, gxg_cairo_font_face_reference)
Xen_wrap_1_arg(gxg_cairo_font_face_destroy_w, gxg_cairo_font_face_destroy)
Xen_wrap_1_arg(gxg_cairo_font_face_status_w, gxg_cairo_font_face_status)
Xen_wrap_2_args(gxg_cairo_font_face_get_user_data_w, gxg_cairo_font_face_get_user_data)
Xen_wrap_4_args(gxg_cairo_font_face_set_user_data_w, gxg_cairo_font_face_set_user_data)
Xen_wrap_4_args(gxg_cairo_scaled_font_create_w, gxg_cairo_scaled_font_create)
Xen_wrap_1_arg(gxg_cairo_scaled_font_reference_w, gxg_cairo_scaled_font_reference)
Xen_wrap_1_arg(gxg_cairo_scaled_font_destroy_w, gxg_cairo_scaled_font_destroy)
Xen_wrap_1_arg(gxg_cairo_scaled_font_status_w, gxg_cairo_scaled_font_status)
Xen_wrap_2_args(gxg_cairo_scaled_font_extents_w, gxg_cairo_scaled_font_extents)
Xen_wrap_3_args(gxg_cairo_scaled_font_text_extents_w, gxg_cairo_scaled_font_text_extents)
Xen_wrap_4_args(gxg_cairo_scaled_font_glyph_extents_w, gxg_cairo_scaled_font_glyph_extents)
Xen_wrap_1_arg(gxg_cairo_scaled_font_get_font_face_w, gxg_cairo_scaled_font_get_font_face)
Xen_wrap_2_args(gxg_cairo_scaled_font_get_font_matrix_w, gxg_cairo_scaled_font_get_font_matrix)
Xen_wrap_2_args(gxg_cairo_scaled_font_get_ctm_w, gxg_cairo_scaled_font_get_ctm)
Xen_wrap_2_args(gxg_cairo_scaled_font_get_font_options_w, gxg_cairo_scaled_font_get_font_options)
Xen_wrap_1_arg(gxg_cairo_get_operator_w, gxg_cairo_get_operator)
Xen_wrap_1_arg(gxg_cairo_get_source_w, gxg_cairo_get_source)
Xen_wrap_1_arg(gxg_cairo_get_tolerance_w, gxg_cairo_get_tolerance)
Xen_wrap_1_arg(gxg_cairo_get_antialias_w, gxg_cairo_get_antialias)
Xen_wrap_3_optional_args(gxg_cairo_get_current_point_w, gxg_cairo_get_current_point)
Xen_wrap_1_arg(gxg_cairo_get_fill_rule_w, gxg_cairo_get_fill_rule)
Xen_wrap_1_arg(gxg_cairo_get_line_width_w, gxg_cairo_get_line_width)
Xen_wrap_1_arg(gxg_cairo_get_line_cap_w, gxg_cairo_get_line_cap)
Xen_wrap_1_arg(gxg_cairo_get_line_join_w, gxg_cairo_get_line_join)
Xen_wrap_1_arg(gxg_cairo_get_miter_limit_w, gxg_cairo_get_miter_limit)
Xen_wrap_2_args(gxg_cairo_get_matrix_w, gxg_cairo_get_matrix)
Xen_wrap_1_arg(gxg_cairo_get_target_w, gxg_cairo_get_target)
Xen_wrap_1_arg(gxg_cairo_get_group_target_w, gxg_cairo_get_group_target)
Xen_wrap_1_arg(gxg_cairo_copy_path_w, gxg_cairo_copy_path)
Xen_wrap_1_arg(gxg_cairo_copy_path_flat_w, gxg_cairo_copy_path_flat)
Xen_wrap_2_args(gxg_cairo_append_path_w, gxg_cairo_append_path)
Xen_wrap_1_arg(gxg_cairo_path_destroy_w, gxg_cairo_path_destroy)
Xen_wrap_1_arg(gxg_cairo_status_w, gxg_cairo_status)
Xen_wrap_1_arg(gxg_cairo_status_to_string_w, gxg_cairo_status_to_string)
Xen_wrap_4_args(gxg_cairo_surface_create_similar_w, gxg_cairo_surface_create_similar)
Xen_wrap_1_arg(gxg_cairo_surface_reference_w, gxg_cairo_surface_reference)
Xen_wrap_1_arg(gxg_cairo_surface_finish_w, gxg_cairo_surface_finish)
Xen_wrap_1_arg(gxg_cairo_surface_destroy_w, gxg_cairo_surface_destroy)
Xen_wrap_1_arg(gxg_cairo_surface_status_w, gxg_cairo_surface_status)
Xen_wrap_1_arg(gxg_cairo_surface_get_content_w, gxg_cairo_surface_get_content)
Xen_wrap_2_args(gxg_cairo_surface_get_user_data_w, gxg_cairo_surface_get_user_data)
Xen_wrap_4_args(gxg_cairo_surface_set_user_data_w, gxg_cairo_surface_set_user_data)
Xen_wrap_2_args(gxg_cairo_surface_get_font_options_w, gxg_cairo_surface_get_font_options)
Xen_wrap_1_arg(gxg_cairo_surface_flush_w, gxg_cairo_surface_flush)
Xen_wrap_1_arg(gxg_cairo_surface_mark_dirty_w, gxg_cairo_surface_mark_dirty)
Xen_wrap_5_args(gxg_cairo_surface_mark_dirty_rectangle_w, gxg_cairo_surface_mark_dirty_rectangle)
Xen_wrap_3_args(gxg_cairo_surface_set_device_offset_w, gxg_cairo_surface_set_device_offset)
Xen_wrap_3_optional_args(gxg_cairo_surface_get_device_offset_w, gxg_cairo_surface_get_device_offset)
Xen_wrap_3_args(gxg_cairo_surface_set_fallback_resolution_w, gxg_cairo_surface_set_fallback_resolution)
Xen_wrap_3_args(gxg_cairo_image_surface_create_w, gxg_cairo_image_surface_create)
Xen_wrap_5_args(gxg_cairo_image_surface_create_for_data_w, gxg_cairo_image_surface_create_for_data)
Xen_wrap_1_arg(gxg_cairo_image_surface_get_data_w, gxg_cairo_image_surface_get_data)
Xen_wrap_1_arg(gxg_cairo_image_surface_get_format_w, gxg_cairo_image_surface_get_format)
Xen_wrap_1_arg(gxg_cairo_image_surface_get_width_w, gxg_cairo_image_surface_get_width)
Xen_wrap_1_arg(gxg_cairo_image_surface_get_height_w, gxg_cairo_image_surface_get_height)
Xen_wrap_1_arg(gxg_cairo_image_surface_get_stride_w, gxg_cairo_image_surface_get_stride)
Xen_wrap_3_args(gxg_cairo_pattern_create_rgb_w, gxg_cairo_pattern_create_rgb)
Xen_wrap_4_args(gxg_cairo_pattern_create_rgba_w, gxg_cairo_pattern_create_rgba)
Xen_wrap_1_arg(gxg_cairo_pattern_create_for_surface_w, gxg_cairo_pattern_create_for_surface)
Xen_wrap_4_args(gxg_cairo_pattern_create_linear_w, gxg_cairo_pattern_create_linear)
Xen_wrap_6_args(gxg_cairo_pattern_create_radial_w, gxg_cairo_pattern_create_radial)
Xen_wrap_1_arg(gxg_cairo_pattern_reference_w, gxg_cairo_pattern_reference)
Xen_wrap_1_arg(gxg_cairo_pattern_destroy_w, gxg_cairo_pattern_destroy)
Xen_wrap_1_arg(gxg_cairo_pattern_status_w, gxg_cairo_pattern_status)
Xen_wrap_5_args(gxg_cairo_pattern_add_color_stop_rgb_w, gxg_cairo_pattern_add_color_stop_rgb)
Xen_wrap_6_args(gxg_cairo_pattern_add_color_stop_rgba_w, gxg_cairo_pattern_add_color_stop_rgba)
Xen_wrap_2_args(gxg_cairo_pattern_set_matrix_w, gxg_cairo_pattern_set_matrix)
Xen_wrap_2_args(gxg_cairo_pattern_get_matrix_w, gxg_cairo_pattern_get_matrix)
Xen_wrap_2_args(gxg_cairo_pattern_set_extend_w, gxg_cairo_pattern_set_extend)
Xen_wrap_1_arg(gxg_cairo_pattern_get_extend_w, gxg_cairo_pattern_get_extend)
Xen_wrap_2_args(gxg_cairo_pattern_set_filter_w, gxg_cairo_pattern_set_filter)
Xen_wrap_1_arg(gxg_cairo_pattern_get_filter_w, gxg_cairo_pattern_get_filter)
Xen_wrap_7_args(gxg_cairo_matrix_init_w, gxg_cairo_matrix_init)
Xen_wrap_1_arg(gxg_cairo_matrix_init_identity_w, gxg_cairo_matrix_init_identity)
Xen_wrap_3_args(gxg_cairo_matrix_init_translate_w, gxg_cairo_matrix_init_translate)
Xen_wrap_3_args(gxg_cairo_matrix_init_scale_w, gxg_cairo_matrix_init_scale)
Xen_wrap_2_args(gxg_cairo_matrix_init_rotate_w, gxg_cairo_matrix_init_rotate)
Xen_wrap_3_args(gxg_cairo_matrix_translate_w, gxg_cairo_matrix_translate)
Xen_wrap_3_args(gxg_cairo_matrix_scale_w, gxg_cairo_matrix_scale)
Xen_wrap_2_args(gxg_cairo_matrix_rotate_w, gxg_cairo_matrix_rotate)
Xen_wrap_1_arg(gxg_cairo_matrix_invert_w, gxg_cairo_matrix_invert)
Xen_wrap_3_args(gxg_cairo_matrix_multiply_w, gxg_cairo_matrix_multiply)
Xen_wrap_3_optional_args(gxg_cairo_matrix_transform_distance_w, gxg_cairo_matrix_transform_distance)
Xen_wrap_3_optional_args(gxg_cairo_matrix_transform_point_w, gxg_cairo_matrix_transform_point)
Xen_wrap_1_arg(gxg_cairo_get_reference_count_w, gxg_cairo_get_reference_count)
Xen_wrap_2_args(gxg_cairo_get_user_data_w, gxg_cairo_get_user_data)
Xen_wrap_4_args(gxg_cairo_set_user_data_w, gxg_cairo_set_user_data)
Xen_wrap_5_optional_args(gxg_cairo_clip_extents_w, gxg_cairo_clip_extents)
Xen_wrap_1_arg(gxg_cairo_copy_clip_rectangle_list_w, gxg_cairo_copy_clip_rectangle_list)
Xen_wrap_1_arg(gxg_cairo_rectangle_list_destroy_w, gxg_cairo_rectangle_list_destroy)
Xen_wrap_1_arg(gxg_cairo_font_face_get_reference_count_w, gxg_cairo_font_face_get_reference_count)
Xen_wrap_1_arg(gxg_cairo_scaled_font_get_reference_count_w, gxg_cairo_scaled_font_get_reference_count)
Xen_wrap_2_args(gxg_cairo_scaled_font_get_user_data_w, gxg_cairo_scaled_font_get_user_data)
Xen_wrap_4_args(gxg_cairo_scaled_font_set_user_data_w, gxg_cairo_scaled_font_set_user_data)
Xen_wrap_1_arg(gxg_cairo_get_dash_count_w, gxg_cairo_get_dash_count)
Xen_wrap_3_optional_args(gxg_cairo_get_dash_w, gxg_cairo_get_dash)
Xen_wrap_1_arg(gxg_cairo_surface_get_reference_count_w, gxg_cairo_surface_get_reference_count)
Xen_wrap_1_arg(gxg_cairo_pattern_get_reference_count_w, gxg_cairo_pattern_get_reference_count)
Xen_wrap_2_args(gxg_cairo_pattern_get_user_data_w, gxg_cairo_pattern_get_user_data)
Xen_wrap_4_args(gxg_cairo_pattern_set_user_data_w, gxg_cairo_pattern_set_user_data)
Xen_wrap_5_optional_args(gxg_cairo_pattern_get_rgba_w, gxg_cairo_pattern_get_rgba)
Xen_wrap_2_optional_args(gxg_cairo_pattern_get_surface_w, gxg_cairo_pattern_get_surface)
Xen_wrap_7_optional_args(gxg_cairo_pattern_get_color_stop_rgba_w, gxg_cairo_pattern_get_color_stop_rgba)
Xen_wrap_2_optional_args(gxg_cairo_pattern_get_color_stop_count_w, gxg_cairo_pattern_get_color_stop_count)
Xen_wrap_5_optional_args(gxg_cairo_pattern_get_linear_points_w, gxg_cairo_pattern_get_linear_points)
Xen_wrap_7_optional_args(gxg_cairo_pattern_get_radial_circles_w, gxg_cairo_pattern_get_radial_circles)
Xen_wrap_1_arg(gxg_cairo_get_scaled_font_w, gxg_cairo_get_scaled_font)
Xen_wrap_5_optional_args(gxg_cairo_path_extents_w, gxg_cairo_path_extents)
Xen_wrap_1_arg(gxg_cairo_has_current_point_w, gxg_cairo_has_current_point)
Xen_wrap_1_arg(gxg_cairo_surface_copy_page_w, gxg_cairo_surface_copy_page)
Xen_wrap_1_arg(gxg_cairo_surface_show_page_w, gxg_cairo_surface_show_page)
Xen_wrap_2_args(gxg_cairo_format_stride_for_width_w, gxg_cairo_format_stride_for_width)
Xen_wrap_1_arg(gxg_cairo_image_surface_create_from_png_w, gxg_cairo_image_surface_create_from_png)
Xen_wrap_2_args(gxg_cairo_surface_write_to_png_w, gxg_cairo_surface_write_to_png)
#if HAVE_CAIRO_1_8
Xen_wrap_1_arg(gxg_cairo_glyph_allocate_w, gxg_cairo_glyph_allocate)
Xen_wrap_1_arg(gxg_cairo_glyph_free_w, gxg_cairo_glyph_free)
Xen_wrap_1_arg(gxg_cairo_text_cluster_allocate_w, gxg_cairo_text_cluster_allocate)
Xen_wrap_1_arg(gxg_cairo_text_cluster_free_w, gxg_cairo_text_cluster_free)
Xen_wrap_any_args(gxg_cairo_show_text_glyphs_w, gxg_cairo_show_text_glyphs)
Xen_wrap_any_args(gxg_cairo_scaled_font_text_to_glyphs_w, gxg_cairo_scaled_font_text_to_glyphs)
Xen_wrap_2_args(gxg_cairo_scaled_font_get_scale_matrix_w, gxg_cairo_scaled_font_get_scale_matrix)
Xen_wrap_3_args(gxg_cairo_toy_font_face_create_w, gxg_cairo_toy_font_face_create)
Xen_wrap_1_arg(gxg_cairo_toy_font_face_get_family_w, gxg_cairo_toy_font_face_get_family)
Xen_wrap_1_arg(gxg_cairo_toy_font_face_get_slant_w, gxg_cairo_toy_font_face_get_slant)
Xen_wrap_1_arg(gxg_cairo_toy_font_face_get_weight_w, gxg_cairo_toy_font_face_get_weight)
Xen_wrap_no_args(gxg_cairo_user_font_face_create_w, gxg_cairo_user_font_face_create)
Xen_wrap_3_optional_args(gxg_cairo_surface_get_fallback_resolution_w, gxg_cairo_surface_get_fallback_resolution)
Xen_wrap_1_arg(gxg_cairo_surface_has_show_text_glyphs_w, gxg_cairo_surface_has_show_text_glyphs)
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
Xen_wrap_3_args(gxg_cairo_in_clip_w, gxg_cairo_in_clip)
Xen_wrap_1_arg(gxg_cairo_device_reference_w, gxg_cairo_device_reference)
Xen_wrap_1_arg(gxg_cairo_device_status_w, gxg_cairo_device_status)
Xen_wrap_1_arg(gxg_cairo_device_acquire_w, gxg_cairo_device_acquire)
Xen_wrap_1_arg(gxg_cairo_device_release_w, gxg_cairo_device_release)
Xen_wrap_1_arg(gxg_cairo_device_flush_w, gxg_cairo_device_flush)
Xen_wrap_1_arg(gxg_cairo_device_finish_w, gxg_cairo_device_finish)
Xen_wrap_1_arg(gxg_cairo_device_destroy_w, gxg_cairo_device_destroy)
Xen_wrap_1_arg(gxg_cairo_device_get_reference_count_w, gxg_cairo_device_get_reference_count)
Xen_wrap_2_args(gxg_cairo_device_get_user_data_w, gxg_cairo_device_get_user_data)
Xen_wrap_4_args(gxg_cairo_device_set_user_data_w, gxg_cairo_device_set_user_data)
Xen_wrap_5_args(gxg_cairo_surface_create_for_rectangle_w, gxg_cairo_surface_create_for_rectangle)
Xen_wrap_1_arg(gxg_cairo_surface_get_device_w, gxg_cairo_surface_get_device)
Xen_wrap_6_args(gxg_cairo_surface_set_mime_data_w, gxg_cairo_surface_set_mime_data)
Xen_wrap_2_args(gxg_cairo_recording_surface_create_w, gxg_cairo_recording_surface_create)
Xen_wrap_5_args(gxg_cairo_recording_surface_ink_extents_w, gxg_cairo_recording_surface_ink_extents)
Xen_wrap_no_args(gxg_cairo_region_create_w, gxg_cairo_region_create)
Xen_wrap_1_arg(gxg_cairo_region_create_rectangle_w, gxg_cairo_region_create_rectangle)
Xen_wrap_2_args(gxg_cairo_region_create_rectangles_w, gxg_cairo_region_create_rectangles)
Xen_wrap_1_arg(gxg_cairo_region_copy_w, gxg_cairo_region_copy)
Xen_wrap_1_arg(gxg_cairo_region_reference_w, gxg_cairo_region_reference)
Xen_wrap_1_arg(gxg_cairo_region_destroy_w, gxg_cairo_region_destroy)
Xen_wrap_2_args(gxg_cairo_region_equal_w, gxg_cairo_region_equal)
Xen_wrap_1_arg(gxg_cairo_region_status_w, gxg_cairo_region_status)
Xen_wrap_2_args(gxg_cairo_region_get_extents_w, gxg_cairo_region_get_extents)
Xen_wrap_1_arg(gxg_cairo_region_num_rectangles_w, gxg_cairo_region_num_rectangles)
Xen_wrap_3_args(gxg_cairo_region_get_rectangle_w, gxg_cairo_region_get_rectangle)
Xen_wrap_1_arg(gxg_cairo_region_is_empty_w, gxg_cairo_region_is_empty)
Xen_wrap_2_args(gxg_cairo_region_contains_rectangle_w, gxg_cairo_region_contains_rectangle)
Xen_wrap_3_args(gxg_cairo_region_contains_point_w, gxg_cairo_region_contains_point)
Xen_wrap_3_args(gxg_cairo_region_translate_w, gxg_cairo_region_translate)
Xen_wrap_2_args(gxg_cairo_region_subtract_w, gxg_cairo_region_subtract)
Xen_wrap_2_args(gxg_cairo_region_subtract_rectangle_w, gxg_cairo_region_subtract_rectangle)
Xen_wrap_2_args(gxg_cairo_region_intersect_w, gxg_cairo_region_intersect)
Xen_wrap_2_args(gxg_cairo_region_intersect_rectangle_w, gxg_cairo_region_intersect_rectangle)
Xen_wrap_2_args(gxg_cairo_region_union_w, gxg_cairo_region_union)
Xen_wrap_2_args(gxg_cairo_region_union_rectangle_w, gxg_cairo_region_union_rectangle)
Xen_wrap_2_args(gxg_cairo_region_xor_w, gxg_cairo_region_xor)
Xen_wrap_2_args(gxg_cairo_region_xor_rectangle_w, gxg_cairo_region_xor_rectangle)
#endif

Xen_wrap_1_arg(gxg_GPOINTER_w, gxg_GPOINTER)
Xen_wrap_2_args(c_array_to_xen_list_w, c_array_to_xen_list)
Xen_wrap_2_args(xen_list_to_c_array_w, xen_list_to_c_array)
Xen_wrap_3_args(xg_object_get_w, xg_object_get)
Xen_wrap_3_args(xg_object_set_w, xg_object_set)
Xen_wrap_1_arg(xg_gtk_event_keyval_w, xg_gtk_event_keyval)
#if (!GTK_CHECK_VERSION(3, 90, 0))
Xen_wrap_2_optional_args(gxg_gtk_init_w, gxg_gtk_init)
Xen_wrap_2_optional_args(gxg_gtk_init_check_w, gxg_gtk_init_check)
Xen_wrap_2_args(gxg_gtk_widget_set_events_w, gxg_gtk_widget_set_events)
#else
Xen_wrap_no_args(gxg_gtk_init_w, gxg_gtk_init)
#endif
Xen_wrap_1_arg(gxg_GDK_DRAG_CONTEXT_w, gxg_GDK_DRAG_CONTEXT)
Xen_wrap_1_arg(gxg_GDK_DEVICE_w, gxg_GDK_DEVICE)
Xen_wrap_1_arg(gxg_GDK_KEYMAP_w, gxg_GDK_KEYMAP)
Xen_wrap_1_arg(gxg_GDK_WINDOW_w, gxg_GDK_WINDOW)
Xen_wrap_1_arg(gxg_GDK_PIXBUF_w, gxg_GDK_PIXBUF)
Xen_wrap_1_arg(gxg_GTK_ACCEL_GROUP_w, gxg_GTK_ACCEL_GROUP)
Xen_wrap_1_arg(gxg_GTK_ACCEL_LABEL_w, gxg_GTK_ACCEL_LABEL)
Xen_wrap_1_arg(gxg_GTK_ACCESSIBLE_w, gxg_GTK_ACCESSIBLE)
Xen_wrap_1_arg(gxg_GTK_ADJUSTMENT_w, gxg_GTK_ADJUSTMENT)
Xen_wrap_1_arg(gxg_GTK_ASPECT_FRAME_w, gxg_GTK_ASPECT_FRAME)
Xen_wrap_1_arg(gxg_GTK_BUTTON_BOX_w, gxg_GTK_BUTTON_BOX)
Xen_wrap_1_arg(gxg_GTK_BIN_w, gxg_GTK_BIN)
Xen_wrap_1_arg(gxg_GTK_BOX_w, gxg_GTK_BOX)
Xen_wrap_1_arg(gxg_GTK_BUTTON_w, gxg_GTK_BUTTON)
Xen_wrap_1_arg(gxg_GTK_CALENDAR_w, gxg_GTK_CALENDAR)
Xen_wrap_1_arg(gxg_GTK_CELL_EDITABLE_w, gxg_GTK_CELL_EDITABLE)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_w, gxg_GTK_CELL_RENDERER)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_PIXBUF_w, gxg_GTK_CELL_RENDERER_PIXBUF)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_TEXT_w, gxg_GTK_CELL_RENDERER_TEXT)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_TOGGLE_w, gxg_GTK_CELL_RENDERER_TOGGLE)
Xen_wrap_1_arg(gxg_GTK_CHECK_BUTTON_w, gxg_GTK_CHECK_BUTTON)
Xen_wrap_1_arg(gxg_GTK_CHECK_MENU_ITEM_w, gxg_GTK_CHECK_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_CONTAINER_w, gxg_GTK_CONTAINER)
Xen_wrap_1_arg(gxg_GTK_DIALOG_w, gxg_GTK_DIALOG)
Xen_wrap_1_arg(gxg_GTK_DRAWING_AREA_w, gxg_GTK_DRAWING_AREA)
Xen_wrap_1_arg(gxg_GTK_EDITABLE_w, gxg_GTK_EDITABLE)
Xen_wrap_1_arg(gxg_GTK_ENTRY_w, gxg_GTK_ENTRY)
Xen_wrap_1_arg(gxg_GTK_FIXED_w, gxg_GTK_FIXED)
Xen_wrap_1_arg(gxg_GTK_FRAME_w, gxg_GTK_FRAME)
Xen_wrap_1_arg(gxg_GTK_IMAGE_w, gxg_GTK_IMAGE)
Xen_wrap_1_arg(gxg_GTK_IM_CONTEXT_w, gxg_GTK_IM_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_IM_CONTEXT_SIMPLE_w, gxg_GTK_IM_CONTEXT_SIMPLE)
Xen_wrap_1_arg(gxg_GTK_INVISIBLE_w, gxg_GTK_INVISIBLE)
Xen_wrap_1_arg(gxg_GTK_LABEL_w, gxg_GTK_LABEL)
Xen_wrap_1_arg(gxg_GTK_LAYOUT_w, gxg_GTK_LAYOUT)
Xen_wrap_1_arg(gxg_GTK_LIST_STORE_w, gxg_GTK_LIST_STORE)
Xen_wrap_1_arg(gxg_GTK_MENU_BAR_w, gxg_GTK_MENU_BAR)
Xen_wrap_1_arg(gxg_GTK_MENU_w, gxg_GTK_MENU)
Xen_wrap_1_arg(gxg_GTK_MENU_ITEM_w, gxg_GTK_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_MENU_SHELL_w, gxg_GTK_MENU_SHELL)
Xen_wrap_1_arg(gxg_GTK_NOTEBOOK_w, gxg_GTK_NOTEBOOK)
Xen_wrap_1_arg(gxg_GTK_PANED_w, gxg_GTK_PANED)
Xen_wrap_1_arg(gxg_GTK_PROGRESS_BAR_w, gxg_GTK_PROGRESS_BAR)
Xen_wrap_1_arg(gxg_GTK_RADIO_BUTTON_w, gxg_GTK_RADIO_BUTTON)
Xen_wrap_1_arg(gxg_GTK_RADIO_MENU_ITEM_w, gxg_GTK_RADIO_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_RANGE_w, gxg_GTK_RANGE)
Xen_wrap_1_arg(gxg_GTK_SCALE_w, gxg_GTK_SCALE)
Xen_wrap_1_arg(gxg_GTK_SCROLLBAR_w, gxg_GTK_SCROLLBAR)
Xen_wrap_1_arg(gxg_GTK_SCROLLED_WINDOW_w, gxg_GTK_SCROLLED_WINDOW)
Xen_wrap_1_arg(gxg_GTK_SEPARATOR_w, gxg_GTK_SEPARATOR)
Xen_wrap_1_arg(gxg_GTK_SEPARATOR_MENU_ITEM_w, gxg_GTK_SEPARATOR_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_SETTINGS_w, gxg_GTK_SETTINGS)
Xen_wrap_1_arg(gxg_GTK_SIZE_GROUP_w, gxg_GTK_SIZE_GROUP)
Xen_wrap_1_arg(gxg_GTK_SPIN_BUTTON_w, gxg_GTK_SPIN_BUTTON)
Xen_wrap_1_arg(gxg_GTK_STATUSBAR_w, gxg_GTK_STATUSBAR)
Xen_wrap_1_arg(gxg_GTK_TEXT_BUFFER_w, gxg_GTK_TEXT_BUFFER)
Xen_wrap_1_arg(gxg_GTK_TEXT_CHILD_ANCHOR_w, gxg_GTK_TEXT_CHILD_ANCHOR)
Xen_wrap_1_arg(gxg_GTK_TEXT_MARK_w, gxg_GTK_TEXT_MARK)
Xen_wrap_1_arg(gxg_GTK_TEXT_TAG_w, gxg_GTK_TEXT_TAG)
Xen_wrap_1_arg(gxg_GTK_TEXT_TAG_TABLE_w, gxg_GTK_TEXT_TAG_TABLE)
Xen_wrap_1_arg(gxg_GTK_TEXT_VIEW_w, gxg_GTK_TEXT_VIEW)
Xen_wrap_1_arg(gxg_GTK_TOGGLE_BUTTON_w, gxg_GTK_TOGGLE_BUTTON)
Xen_wrap_1_arg(gxg_GTK_TOOLBAR_w, gxg_GTK_TOOLBAR)
Xen_wrap_1_arg(gxg_GTK_TREE_DRAG_SOURCE_w, gxg_GTK_TREE_DRAG_SOURCE)
Xen_wrap_1_arg(gxg_GTK_TREE_DRAG_DEST_w, gxg_GTK_TREE_DRAG_DEST)
Xen_wrap_1_arg(gxg_GTK_TREE_MODEL_w, gxg_GTK_TREE_MODEL)
Xen_wrap_1_arg(gxg_GTK_TREE_MODEL_SORT_w, gxg_GTK_TREE_MODEL_SORT)
Xen_wrap_1_arg(gxg_GTK_TREE_SELECTION_w, gxg_GTK_TREE_SELECTION)
Xen_wrap_1_arg(gxg_GTK_TREE_SORTABLE_w, gxg_GTK_TREE_SORTABLE)
Xen_wrap_1_arg(gxg_GTK_TREE_STORE_w, gxg_GTK_TREE_STORE)
Xen_wrap_1_arg(gxg_GTK_TREE_VIEW_COLUMN_w, gxg_GTK_TREE_VIEW_COLUMN)
Xen_wrap_1_arg(gxg_GTK_TREE_VIEW_w, gxg_GTK_TREE_VIEW)
Xen_wrap_1_arg(gxg_GTK_VIEWPORT_w, gxg_GTK_VIEWPORT)
Xen_wrap_1_arg(gxg_GTK_WIDGET_w, gxg_GTK_WIDGET)
Xen_wrap_1_arg(gxg_GTK_WINDOW_w, gxg_GTK_WINDOW)
Xen_wrap_1_arg(gxg_PANGO_CONTEXT_w, gxg_PANGO_CONTEXT)
Xen_wrap_1_arg(gxg_PANGO_FONT_FAMILY_w, gxg_PANGO_FONT_FAMILY)
Xen_wrap_1_arg(gxg_PANGO_FONT_FACE_w, gxg_PANGO_FONT_FACE)
Xen_wrap_1_arg(gxg_PANGO_FONT_w, gxg_PANGO_FONT)
Xen_wrap_1_arg(gxg_PANGO_FONT_MAP_w, gxg_PANGO_FONT_MAP)
Xen_wrap_1_arg(gxg_PANGO_LAYOUT_w, gxg_PANGO_LAYOUT)
Xen_wrap_1_arg(gxg_G_OBJECT_w, gxg_G_OBJECT)
Xen_wrap_1_arg(gxg_GDK_DISPLAY_OBJECT_w, gxg_GDK_DISPLAY_OBJECT)
Xen_wrap_1_arg(gxg_GDK_EVENT_w, gxg_GDK_EVENT)
Xen_wrap_1_arg(gxg_GDK_EVENT_ANY_w, gxg_GDK_EVENT_ANY)
Xen_wrap_1_arg(gxg_GDK_EVENT_EXPOSE_w, gxg_GDK_EVENT_EXPOSE)
Xen_wrap_1_arg(gxg_GDK_EVENT_NOEXPOSE_w, gxg_GDK_EVENT_NOEXPOSE)
Xen_wrap_1_arg(gxg_GDK_EVENT_VISIBILITY_w, gxg_GDK_EVENT_VISIBILITY)
Xen_wrap_1_arg(gxg_GDK_EVENT_MOTION_w, gxg_GDK_EVENT_MOTION)
Xen_wrap_1_arg(gxg_GDK_EVENT_BUTTON_w, gxg_GDK_EVENT_BUTTON)
Xen_wrap_1_arg(gxg_GDK_EVENT_SCROLL_w, gxg_GDK_EVENT_SCROLL)
Xen_wrap_1_arg(gxg_GDK_EVENT_KEY_w, gxg_GDK_EVENT_KEY)
Xen_wrap_1_arg(gxg_GDK_EVENT_CROSSING_w, gxg_GDK_EVENT_CROSSING)
Xen_wrap_1_arg(gxg_GDK_EVENT_FOCUS_w, gxg_GDK_EVENT_FOCUS)
Xen_wrap_1_arg(gxg_GDK_EVENT_CONFIGURE_w, gxg_GDK_EVENT_CONFIGURE)
Xen_wrap_1_arg(gxg_GDK_EVENT_PROPERTY_w, gxg_GDK_EVENT_PROPERTY)
Xen_wrap_1_arg(gxg_GDK_EVENT_SELECTION_w, gxg_GDK_EVENT_SELECTION)
Xen_wrap_1_arg(gxg_GDK_EVENT_PROXIMITY_w, gxg_GDK_EVENT_PROXIMITY)
Xen_wrap_1_arg(gxg_GDK_EVENT_SETTING_w, gxg_GDK_EVENT_SETTING)
Xen_wrap_1_arg(gxg_GDK_EVENT_WINDOWSTATE_w, gxg_GDK_EVENT_WINDOWSTATE)
Xen_wrap_1_arg(gxg_GDK_EVENT_DND_w, gxg_GDK_EVENT_DND)
Xen_wrap_1_arg(gxg_GTK_FILE_CHOOSER_DIALOG_w, gxg_GTK_FILE_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_FILE_CHOOSER_WIDGET_w, gxg_GTK_FILE_CHOOSER_WIDGET)
Xen_wrap_1_arg(gxg_GTK_TREE_MODEL_FILTER_w, gxg_GTK_TREE_MODEL_FILTER)
Xen_wrap_1_arg(gxg_GTK_COMBO_BOX_w, gxg_GTK_COMBO_BOX)
Xen_wrap_1_arg(gxg_GTK_EXPANDER_w, gxg_GTK_EXPANDER)
Xen_wrap_1_arg(gxg_GTK_FONT_BUTTON_w, gxg_GTK_FONT_BUTTON)
Xen_wrap_1_arg(gxg_GTK_COLOR_BUTTON_w, gxg_GTK_COLOR_BUTTON)
Xen_wrap_1_arg(gxg_GTK_ENTRY_COMPLETION_w, gxg_GTK_ENTRY_COMPLETION)
Xen_wrap_1_arg(gxg_GTK_RADIO_TOOL_BUTTON_w, gxg_GTK_RADIO_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_SEPARATOR_TOOL_ITEM_w, gxg_GTK_SEPARATOR_TOOL_ITEM)
Xen_wrap_1_arg(gxg_GTK_TOGGLE_TOOL_BUTTON_w, gxg_GTK_TOGGLE_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_FILE_FILTER_w, gxg_GTK_FILE_FILTER)
Xen_wrap_1_arg(gxg_GTK_CELL_LAYOUT_w, gxg_GTK_CELL_LAYOUT)
Xen_wrap_1_arg(gxg_GTK_FILE_CHOOSER_w, gxg_GTK_FILE_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_ICON_THEME_w, gxg_GTK_ICON_THEME)
Xen_wrap_1_arg(gxg_GTK_TOOL_BUTTON_w, gxg_GTK_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_TOOL_ITEM_w, gxg_GTK_TOOL_ITEM)
Xen_wrap_1_arg(gxg_GTK_ACCEL_MAP_w, gxg_GTK_ACCEL_MAP)
Xen_wrap_1_arg(gxg_GTK_CELL_VIEW_w, gxg_GTK_CELL_VIEW)
Xen_wrap_1_arg(gxg_GTK_ABOUT_DIALOG_w, gxg_GTK_ABOUT_DIALOG)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_COMBO_w, gxg_GTK_CELL_RENDERER_COMBO)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_PROGRESS_w, gxg_GTK_CELL_RENDERER_PROGRESS)
Xen_wrap_1_arg(gxg_GTK_ICON_VIEW_w, gxg_GTK_ICON_VIEW)
Xen_wrap_1_arg(gxg_GTK_FILE_CHOOSER_BUTTON_w, gxg_GTK_FILE_CHOOSER_BUTTON)
Xen_wrap_1_arg(gxg_GTK_MENU_TOOL_BUTTON_w, gxg_GTK_MENU_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_ASSISTANT_w, gxg_GTK_ASSISTANT)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_ACCEL_w, gxg_GTK_CELL_RENDERER_ACCEL)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_SPIN_w, gxg_GTK_CELL_RENDERER_SPIN)
Xen_wrap_1_arg(gxg_GTK_LINK_BUTTON_w, gxg_GTK_LINK_BUTTON)
Xen_wrap_1_arg(gxg_GTK_RECENT_CHOOSER_DIALOG_w, gxg_GTK_RECENT_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_RECENT_CHOOSER_w, gxg_GTK_RECENT_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_RECENT_CHOOSER_MENU_w, gxg_GTK_RECENT_CHOOSER_MENU)
Xen_wrap_1_arg(gxg_GTK_RECENT_CHOOSER_WIDGET_w, gxg_GTK_RECENT_CHOOSER_WIDGET)
Xen_wrap_1_arg(gxg_GTK_RECENT_FILTER_w, gxg_GTK_RECENT_FILTER)
Xen_wrap_1_arg(gxg_GTK_RECENT_MANAGER_w, gxg_GTK_RECENT_MANAGER)
Xen_wrap_1_arg(gxg_GTK_PRINT_CONTEXT_w, gxg_GTK_PRINT_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_PRINT_OPERATION_w, gxg_GTK_PRINT_OPERATION)
Xen_wrap_1_arg(gxg_GTK_PRINT_SETTINGS_w, gxg_GTK_PRINT_SETTINGS)
Xen_wrap_1_arg(gxg_GTK_TOOLTIP_w, gxg_GTK_TOOLTIP)
#if GTK_CHECK_VERSION(2, 18, 0)
Xen_wrap_1_arg(gxg_GTK_INFO_BAR_w, gxg_GTK_INFO_BAR)
Xen_wrap_1_arg(gxg_GTK_ENTRY_BUFFER_w, gxg_GTK_ENTRY_BUFFER)
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
Xen_wrap_1_arg(gxg_GTK_SPINNER_w, gxg_GTK_SPINNER)
Xen_wrap_1_arg(gxg_GTK_CELL_RENDERER_SPINNER_w, gxg_GTK_CELL_RENDERER_SPINNER)
Xen_wrap_1_arg(gxg_GTK_TOOL_PALETTE_w, gxg_GTK_TOOL_PALETTE)
Xen_wrap_1_arg(gxg_GTK_TOOL_ITEM_GROUP_w, gxg_GTK_TOOL_ITEM_GROUP)
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
Xen_wrap_1_arg(gxg_GTK_COMBO_BOX_TEXT_w, gxg_GTK_COMBO_BOX_TEXT)
Xen_wrap_1_arg(gxg_GTK_GRID_w, gxg_GTK_GRID)
Xen_wrap_1_arg(gxg_GTK_SCROLLABLE_w, gxg_GTK_SCROLLABLE)
Xen_wrap_1_arg(gxg_GDK_RGBA_w, gxg_GDK_RGBA)
Xen_wrap_1_arg(gxg_GTK_SWITCH_w, gxg_GTK_SWITCH)
Xen_wrap_1_arg(gxg_GTK_ORIENTABLE_w, gxg_GTK_ORIENTABLE)
Xen_wrap_1_arg(gxg_GTK_WINDOW_GROUP_w, gxg_GTK_WINDOW_GROUP)
Xen_wrap_1_arg(gxg_GTK_TOOL_SHELL_w, gxg_GTK_TOOL_SHELL)
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
Xen_wrap_1_arg(gxg_GTK_OVERLAY_w, gxg_GTK_OVERLAY)
Xen_wrap_1_arg(gxg_GTK_FONT_CHOOSER_w, gxg_GTK_FONT_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_FONT_CHOOSER_DIALOG_w, gxg_GTK_FONT_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_FONT_CHOOSER_WIDGET_w, gxg_GTK_FONT_CHOOSER_WIDGET)
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
Xen_wrap_1_arg(gxg_GTK_APPLICATION_WINDOW_w, gxg_GTK_APPLICATION_WINDOW)
Xen_wrap_1_arg(gxg_GTK_COLOR_CHOOSER_DIALOG_w, gxg_GTK_COLOR_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_COLOR_CHOOSER_WIDGET_w, gxg_GTK_COLOR_CHOOSER_WIDGET)
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
Xen_wrap_1_arg(gxg_GTK_MENU_BUTTON_w, gxg_GTK_MENU_BUTTON)
Xen_wrap_1_arg(gxg_GTK_SEARCH_ENTRY_w, gxg_GTK_SEARCH_ENTRY)
Xen_wrap_1_arg(gxg_GTK_LEVEL_BAR_w, gxg_GTK_LEVEL_BAR)
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
Xen_wrap_1_arg(gxg_GTK_PLACES_SIDEBAR_w, gxg_GTK_PLACES_SIDEBAR)
Xen_wrap_1_arg(gxg_GTK_STACK_SWITCHER_w, gxg_GTK_STACK_SWITCHER)
Xen_wrap_1_arg(gxg_GTK_STACK_w, gxg_GTK_STACK)
Xen_wrap_1_arg(gxg_GTK_REVEALER_w, gxg_GTK_REVEALER)
Xen_wrap_1_arg(gxg_GTK_HEADER_BAR_w, gxg_GTK_HEADER_BAR)
Xen_wrap_1_arg(gxg_GTK_LIST_BOX_w, gxg_GTK_LIST_BOX)
Xen_wrap_1_arg(gxg_GTK_LIST_BOX_ROW_w, gxg_GTK_LIST_BOX_ROW)
Xen_wrap_1_arg(gxg_GTK_SEARCH_BAR_w, gxg_GTK_SEARCH_BAR)
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
Xen_wrap_1_arg(gxg_GTK_FLOW_BOX_w, gxg_GTK_FLOW_BOX)
Xen_wrap_1_arg(gxg_GTK_FLOW_BOX_CHILD_w, gxg_GTK_FLOW_BOX_CHILD)
Xen_wrap_1_arg(gxg_GTK_ACTION_BAR_w, gxg_GTK_ACTION_BAR)
Xen_wrap_1_arg(gxg_GTK_POPOVER_w, gxg_GTK_POPOVER)
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
Xen_wrap_1_arg(gxg_GTK_GESTURE_w, gxg_GTK_GESTURE)
Xen_wrap_1_arg(gxg_GTK_GESTURE_DRAG_w, gxg_GTK_GESTURE_DRAG)
Xen_wrap_1_arg(gxg_GTK_GESTURE_LONG_PRESS_w, gxg_GTK_GESTURE_LONG_PRESS)
Xen_wrap_1_arg(gxg_GTK_GESTURE_ZOOM_w, gxg_GTK_GESTURE_ZOOM)
Xen_wrap_1_arg(gxg_GTK_GESTURE_SWIPE_w, gxg_GTK_GESTURE_SWIPE)
Xen_wrap_1_arg(gxg_GTK_GESTURE_SINGLE_w, gxg_GTK_GESTURE_SINGLE)
Xen_wrap_1_arg(gxg_GTK_GESTURE_PAN_w, gxg_GTK_GESTURE_PAN)
Xen_wrap_1_arg(gxg_GTK_GESTURE_MULTI_PRESS_w, gxg_GTK_GESTURE_MULTI_PRESS)
Xen_wrap_1_arg(gxg_GTK_GESTURE_ROTATE_w, gxg_GTK_GESTURE_ROTATE)
Xen_wrap_1_arg(gxg_GTK_EVENT_CONTROLLER_w, gxg_GTK_EVENT_CONTROLLER)
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
Xen_wrap_1_arg(gxg_GTK_GL_AREA_w, gxg_GTK_GL_AREA)
Xen_wrap_1_arg(gxg_GDK_GL_CONTEXT_w, gxg_GDK_GL_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_POPOVER_MENU_w, gxg_GTK_POPOVER_MENU)
Xen_wrap_1_arg(gxg_GTK_STACK_SIDEBAR_w, gxg_GTK_STACK_SIDEBAR)
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
Xen_wrap_1_arg(gxg_GDK_SEAT_w, gxg_GDK_SEAT)
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
Xen_wrap_1_arg(gxg_GDK_DEVICE_TOOL_w, gxg_GDK_DEVICE_TOOL)
Xen_wrap_1_arg(gxg_GDK_MONITOR_w, gxg_GDK_MONITOR)
Xen_wrap_1_arg(gxg_GDK_DRAWING_CONTEXT_w, gxg_GDK_DRAWING_CONTEXT)
Xen_wrap_1_arg(gxg_GDK_DEVICE_PAD_w, gxg_GDK_DEVICE_PAD)
Xen_wrap_1_arg(gxg_GTK_PAD_CONTROLLER_w, gxg_GTK_PAD_CONTROLLER)
Xen_wrap_1_arg(gxg_GTK_SHORTCUT_LABEL_w, gxg_GTK_SHORTCUT_LABEL)
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
Xen_wrap_1_arg(gxg_GTK_CENTER_BOX_w, gxg_GTK_CENTER_BOX)
Xen_wrap_1_arg(gxg_GTK_STYLE_CONTEXT_w, gxg_GTK_STYLE_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_STYLE_PROVIDER_w, gxg_GTK_STYLE_PROVIDER)
Xen_wrap_1_arg(gxg_GTK_CSS_PROVIDER_w, gxg_GTK_CSS_PROVIDER)
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
Xen_wrap_1_arg(gxg_GTK_EMOJI_CHOOSER_w, gxg_GTK_EMOJI_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_EVENT_CONTROLLER_SCROLL_w, gxg_GTK_EVENT_CONTROLLER_SCROLL)
Xen_wrap_1_arg(gxg_GTK_EVENT_CONTROLLER_MOTION_w, gxg_GTK_EVENT_CONTROLLER_MOTION)
Xen_wrap_1_arg(gxg_GDK_TEXTURE_w, gxg_GDK_TEXTURE)
Xen_wrap_1_arg(gxg_GDK_EVENT_w, gxg_GDK_EVENT)
Xen_wrap_1_arg(gxg_GDK_APP_LAUNCH_CONTEXT_w, gxg_GDK_APP_LAUNCH_CONTEXT)
Xen_wrap_1_arg(gxg_GDK_CLIPBOARD_w, gxg_GDK_CLIPBOARD)
Xen_wrap_1_arg(gxg_GDK_CONTENT_PROVIDER_w, gxg_GDK_CONTENT_PROVIDER)
Xen_wrap_1_arg(gxg_GDK_CONTENT_SERIALIZER_w, gxg_GDK_CONTENT_SERIALIZER)
Xen_wrap_1_arg(gxg_GDK_CONTENT_DESERIALIZER_w, gxg_GDK_CONTENT_DESERIALIZER)
Xen_wrap_1_arg(gxg_GTK_APPLICATION_w, gxg_GTK_APPLICATION)
#endif

Xen_wrap_1_arg(gxg_GDK_IS_DRAG_CONTEXT_w, gxg_GDK_IS_DRAG_CONTEXT)
Xen_wrap_1_arg(gxg_GDK_IS_DEVICE_w, gxg_GDK_IS_DEVICE)
Xen_wrap_1_arg(gxg_GDK_IS_KEYMAP_w, gxg_GDK_IS_KEYMAP)
Xen_wrap_1_arg(gxg_GDK_IS_WINDOW_w, gxg_GDK_IS_WINDOW)
Xen_wrap_1_arg(gxg_GDK_IS_PIXBUF_w, gxg_GDK_IS_PIXBUF)
Xen_wrap_1_arg(gxg_GTK_IS_ACCEL_GROUP_w, gxg_GTK_IS_ACCEL_GROUP)
Xen_wrap_1_arg(gxg_GTK_IS_ACCEL_LABEL_w, gxg_GTK_IS_ACCEL_LABEL)
Xen_wrap_1_arg(gxg_GTK_IS_ACCESSIBLE_w, gxg_GTK_IS_ACCESSIBLE)
Xen_wrap_1_arg(gxg_GTK_IS_ADJUSTMENT_w, gxg_GTK_IS_ADJUSTMENT)
Xen_wrap_1_arg(gxg_GTK_IS_ASPECT_FRAME_w, gxg_GTK_IS_ASPECT_FRAME)
Xen_wrap_1_arg(gxg_GTK_IS_BUTTON_BOX_w, gxg_GTK_IS_BUTTON_BOX)
Xen_wrap_1_arg(gxg_GTK_IS_BIN_w, gxg_GTK_IS_BIN)
Xen_wrap_1_arg(gxg_GTK_IS_BOX_w, gxg_GTK_IS_BOX)
Xen_wrap_1_arg(gxg_GTK_IS_BUTTON_w, gxg_GTK_IS_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_CALENDAR_w, gxg_GTK_IS_CALENDAR)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_EDITABLE_w, gxg_GTK_IS_CELL_EDITABLE)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_w, gxg_GTK_IS_CELL_RENDERER)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_PIXBUF_w, gxg_GTK_IS_CELL_RENDERER_PIXBUF)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_TEXT_w, gxg_GTK_IS_CELL_RENDERER_TEXT)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_TOGGLE_w, gxg_GTK_IS_CELL_RENDERER_TOGGLE)
Xen_wrap_1_arg(gxg_GTK_IS_CHECK_BUTTON_w, gxg_GTK_IS_CHECK_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_CHECK_MENU_ITEM_w, gxg_GTK_IS_CHECK_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_IS_CONTAINER_w, gxg_GTK_IS_CONTAINER)
Xen_wrap_1_arg(gxg_GTK_IS_DIALOG_w, gxg_GTK_IS_DIALOG)
Xen_wrap_1_arg(gxg_GTK_IS_DRAWING_AREA_w, gxg_GTK_IS_DRAWING_AREA)
Xen_wrap_1_arg(gxg_GTK_IS_EDITABLE_w, gxg_GTK_IS_EDITABLE)
Xen_wrap_1_arg(gxg_GTK_IS_ENTRY_w, gxg_GTK_IS_ENTRY)
Xen_wrap_1_arg(gxg_GTK_IS_FIXED_w, gxg_GTK_IS_FIXED)
Xen_wrap_1_arg(gxg_GTK_IS_FRAME_w, gxg_GTK_IS_FRAME)
Xen_wrap_1_arg(gxg_GTK_IS_IMAGE_w, gxg_GTK_IS_IMAGE)
Xen_wrap_1_arg(gxg_GTK_IS_IM_CONTEXT_w, gxg_GTK_IS_IM_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_IS_IM_CONTEXT_SIMPLE_w, gxg_GTK_IS_IM_CONTEXT_SIMPLE)
Xen_wrap_1_arg(gxg_GTK_IS_INVISIBLE_w, gxg_GTK_IS_INVISIBLE)
Xen_wrap_1_arg(gxg_GTK_IS_LABEL_w, gxg_GTK_IS_LABEL)
Xen_wrap_1_arg(gxg_GTK_IS_LAYOUT_w, gxg_GTK_IS_LAYOUT)
Xen_wrap_1_arg(gxg_GTK_IS_LIST_STORE_w, gxg_GTK_IS_LIST_STORE)
Xen_wrap_1_arg(gxg_GTK_IS_MENU_BAR_w, gxg_GTK_IS_MENU_BAR)
Xen_wrap_1_arg(gxg_GTK_IS_MENU_w, gxg_GTK_IS_MENU)
Xen_wrap_1_arg(gxg_GTK_IS_MENU_ITEM_w, gxg_GTK_IS_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_IS_MENU_SHELL_w, gxg_GTK_IS_MENU_SHELL)
Xen_wrap_1_arg(gxg_GTK_IS_NOTEBOOK_w, gxg_GTK_IS_NOTEBOOK)
Xen_wrap_1_arg(gxg_GTK_IS_PANED_w, gxg_GTK_IS_PANED)
Xen_wrap_1_arg(gxg_GTK_IS_PROGRESS_BAR_w, gxg_GTK_IS_PROGRESS_BAR)
Xen_wrap_1_arg(gxg_GTK_IS_RADIO_BUTTON_w, gxg_GTK_IS_RADIO_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_RADIO_MENU_ITEM_w, gxg_GTK_IS_RADIO_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_IS_RANGE_w, gxg_GTK_IS_RANGE)
Xen_wrap_1_arg(gxg_GTK_IS_SCALE_w, gxg_GTK_IS_SCALE)
Xen_wrap_1_arg(gxg_GTK_IS_SCROLLBAR_w, gxg_GTK_IS_SCROLLBAR)
Xen_wrap_1_arg(gxg_GTK_IS_SCROLLED_WINDOW_w, gxg_GTK_IS_SCROLLED_WINDOW)
Xen_wrap_1_arg(gxg_GTK_IS_SEPARATOR_w, gxg_GTK_IS_SEPARATOR)
Xen_wrap_1_arg(gxg_GTK_IS_SEPARATOR_MENU_ITEM_w, gxg_GTK_IS_SEPARATOR_MENU_ITEM)
Xen_wrap_1_arg(gxg_GTK_IS_SETTINGS_w, gxg_GTK_IS_SETTINGS)
Xen_wrap_1_arg(gxg_GTK_IS_SIZE_GROUP_w, gxg_GTK_IS_SIZE_GROUP)
Xen_wrap_1_arg(gxg_GTK_IS_SPIN_BUTTON_w, gxg_GTK_IS_SPIN_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_STATUSBAR_w, gxg_GTK_IS_STATUSBAR)
Xen_wrap_1_arg(gxg_GTK_IS_TEXT_BUFFER_w, gxg_GTK_IS_TEXT_BUFFER)
Xen_wrap_1_arg(gxg_GTK_IS_TEXT_CHILD_ANCHOR_w, gxg_GTK_IS_TEXT_CHILD_ANCHOR)
Xen_wrap_1_arg(gxg_GTK_IS_TEXT_MARK_w, gxg_GTK_IS_TEXT_MARK)
Xen_wrap_1_arg(gxg_GTK_IS_TEXT_TAG_w, gxg_GTK_IS_TEXT_TAG)
Xen_wrap_1_arg(gxg_GTK_IS_TEXT_TAG_TABLE_w, gxg_GTK_IS_TEXT_TAG_TABLE)
Xen_wrap_1_arg(gxg_GTK_IS_TEXT_VIEW_w, gxg_GTK_IS_TEXT_VIEW)
Xen_wrap_1_arg(gxg_GTK_IS_TOGGLE_BUTTON_w, gxg_GTK_IS_TOGGLE_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_TOOLBAR_w, gxg_GTK_IS_TOOLBAR)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_DRAG_SOURCE_w, gxg_GTK_IS_TREE_DRAG_SOURCE)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_DRAG_DEST_w, gxg_GTK_IS_TREE_DRAG_DEST)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_MODEL_w, gxg_GTK_IS_TREE_MODEL)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_MODEL_SORT_w, gxg_GTK_IS_TREE_MODEL_SORT)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_SELECTION_w, gxg_GTK_IS_TREE_SELECTION)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_SORTABLE_w, gxg_GTK_IS_TREE_SORTABLE)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_STORE_w, gxg_GTK_IS_TREE_STORE)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_VIEW_COLUMN_w, gxg_GTK_IS_TREE_VIEW_COLUMN)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_VIEW_w, gxg_GTK_IS_TREE_VIEW)
Xen_wrap_1_arg(gxg_GTK_IS_VIEWPORT_w, gxg_GTK_IS_VIEWPORT)
Xen_wrap_1_arg(gxg_GTK_IS_WIDGET_w, gxg_GTK_IS_WIDGET)
Xen_wrap_1_arg(gxg_GTK_IS_WINDOW_w, gxg_GTK_IS_WINDOW)
Xen_wrap_1_arg(gxg_PANGO_IS_CONTEXT_w, gxg_PANGO_IS_CONTEXT)
Xen_wrap_1_arg(gxg_PANGO_IS_FONT_FAMILY_w, gxg_PANGO_IS_FONT_FAMILY)
Xen_wrap_1_arg(gxg_PANGO_IS_FONT_FACE_w, gxg_PANGO_IS_FONT_FACE)
Xen_wrap_1_arg(gxg_PANGO_IS_FONT_w, gxg_PANGO_IS_FONT)
Xen_wrap_1_arg(gxg_PANGO_IS_FONT_MAP_w, gxg_PANGO_IS_FONT_MAP)
Xen_wrap_1_arg(gxg_PANGO_IS_LAYOUT_w, gxg_PANGO_IS_LAYOUT)
Xen_wrap_1_arg(gxg_G_IS_OBJECT_w, gxg_G_IS_OBJECT)
Xen_wrap_1_arg(gxg_GDK_IS_DISPLAY_w, gxg_GDK_IS_DISPLAY)
Xen_wrap_1_arg(gxg_GTK_IS_FILE_CHOOSER_DIALOG_w, gxg_GTK_IS_FILE_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_IS_FILE_CHOOSER_WIDGET_w, gxg_GTK_IS_FILE_CHOOSER_WIDGET)
Xen_wrap_1_arg(gxg_GTK_IS_TREE_MODEL_FILTER_w, gxg_GTK_IS_TREE_MODEL_FILTER)
Xen_wrap_1_arg(gxg_GTK_IS_COMBO_BOX_w, gxg_GTK_IS_COMBO_BOX)
Xen_wrap_1_arg(gxg_GTK_IS_EXPANDER_w, gxg_GTK_IS_EXPANDER)
Xen_wrap_1_arg(gxg_GTK_IS_FONT_BUTTON_w, gxg_GTK_IS_FONT_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_COLOR_BUTTON_w, gxg_GTK_IS_COLOR_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_ENTRY_COMPLETION_w, gxg_GTK_IS_ENTRY_COMPLETION)
Xen_wrap_1_arg(gxg_GTK_IS_RADIO_TOOL_BUTTON_w, gxg_GTK_IS_RADIO_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_SEPARATOR_TOOL_ITEM_w, gxg_GTK_IS_SEPARATOR_TOOL_ITEM)
Xen_wrap_1_arg(gxg_GTK_IS_TOGGLE_TOOL_BUTTON_w, gxg_GTK_IS_TOGGLE_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_FILE_FILTER_w, gxg_GTK_IS_FILE_FILTER)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_LAYOUT_w, gxg_GTK_IS_CELL_LAYOUT)
Xen_wrap_1_arg(gxg_GTK_IS_FILE_CHOOSER_w, gxg_GTK_IS_FILE_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_IS_ICON_THEME_w, gxg_GTK_IS_ICON_THEME)
Xen_wrap_1_arg(gxg_GTK_IS_TOOL_BUTTON_w, gxg_GTK_IS_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_TOOL_ITEM_w, gxg_GTK_IS_TOOL_ITEM)
Xen_wrap_1_arg(gxg_GTK_IS_ACCEL_MAP_w, gxg_GTK_IS_ACCEL_MAP)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_VIEW_w, gxg_GTK_IS_CELL_VIEW)
Xen_wrap_1_arg(gxg_GTK_IS_ABOUT_DIALOG_w, gxg_GTK_IS_ABOUT_DIALOG)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_COMBO_w, gxg_GTK_IS_CELL_RENDERER_COMBO)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_PROGRESS_w, gxg_GTK_IS_CELL_RENDERER_PROGRESS)
Xen_wrap_1_arg(gxg_GTK_IS_ICON_VIEW_w, gxg_GTK_IS_ICON_VIEW)
Xen_wrap_1_arg(gxg_GTK_IS_FILE_CHOOSER_BUTTON_w, gxg_GTK_IS_FILE_CHOOSER_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_MENU_TOOL_BUTTON_w, gxg_GTK_IS_MENU_TOOL_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_ASSISTANT_w, gxg_GTK_IS_ASSISTANT)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_ACCEL_w, gxg_GTK_IS_CELL_RENDERER_ACCEL)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_SPIN_w, gxg_GTK_IS_CELL_RENDERER_SPIN)
Xen_wrap_1_arg(gxg_GTK_IS_LINK_BUTTON_w, gxg_GTK_IS_LINK_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_RECENT_CHOOSER_DIALOG_w, gxg_GTK_IS_RECENT_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_IS_RECENT_CHOOSER_w, gxg_GTK_IS_RECENT_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_IS_RECENT_CHOOSER_MENU_w, gxg_GTK_IS_RECENT_CHOOSER_MENU)
Xen_wrap_1_arg(gxg_GTK_IS_RECENT_CHOOSER_WIDGET_w, gxg_GTK_IS_RECENT_CHOOSER_WIDGET)
Xen_wrap_1_arg(gxg_GTK_IS_RECENT_FILTER_w, gxg_GTK_IS_RECENT_FILTER)
Xen_wrap_1_arg(gxg_GTK_IS_RECENT_MANAGER_w, gxg_GTK_IS_RECENT_MANAGER)
Xen_wrap_1_arg(gxg_GTK_IS_PRINT_CONTEXT_w, gxg_GTK_IS_PRINT_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_IS_PRINT_OPERATION_w, gxg_GTK_IS_PRINT_OPERATION)
Xen_wrap_1_arg(gxg_GTK_IS_PRINT_SETTINGS_w, gxg_GTK_IS_PRINT_SETTINGS)
Xen_wrap_1_arg(gxg_GTK_IS_TOOLTIP_w, gxg_GTK_IS_TOOLTIP)
#if GTK_CHECK_VERSION(2, 18, 0)
Xen_wrap_1_arg(gxg_GTK_IS_INFO_BAR_w, gxg_GTK_IS_INFO_BAR)
Xen_wrap_1_arg(gxg_GTK_IS_ENTRY_BUFFER_w, gxg_GTK_IS_ENTRY_BUFFER)
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
Xen_wrap_1_arg(gxg_GTK_IS_SPINNER_w, gxg_GTK_IS_SPINNER)
Xen_wrap_1_arg(gxg_GTK_IS_CELL_RENDERER_SPINNER_w, gxg_GTK_IS_CELL_RENDERER_SPINNER)
Xen_wrap_1_arg(gxg_GTK_IS_TOOL_PALETTE_w, gxg_GTK_IS_TOOL_PALETTE)
Xen_wrap_1_arg(gxg_GTK_IS_TOOL_ITEM_GROUP_w, gxg_GTK_IS_TOOL_ITEM_GROUP)
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
Xen_wrap_1_arg(gxg_GTK_IS_COMBO_BOX_TEXT_w, gxg_GTK_IS_COMBO_BOX_TEXT)
Xen_wrap_1_arg(gxg_GTK_IS_GRID_w, gxg_GTK_IS_GRID)
Xen_wrap_1_arg(gxg_GTK_IS_SCROLLABLE_w, gxg_GTK_IS_SCROLLABLE)
Xen_wrap_1_arg(gxg_GTK_IS_SWITCH_w, gxg_GTK_IS_SWITCH)
Xen_wrap_1_arg(gxg_GTK_IS_ORIENTABLE_w, gxg_GTK_IS_ORIENTABLE)
Xen_wrap_1_arg(gxg_GTK_IS_WINDOW_GROUP_w, gxg_GTK_IS_WINDOW_GROUP)
Xen_wrap_1_arg(gxg_GTK_IS_TOOL_SHELL_w, gxg_GTK_IS_TOOL_SHELL)
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
Xen_wrap_1_arg(gxg_GTK_IS_OVERLAY_w, gxg_GTK_IS_OVERLAY)
Xen_wrap_1_arg(gxg_GTK_IS_FONT_CHOOSER_w, gxg_GTK_IS_FONT_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_IS_FONT_CHOOSER_DIALOG_w, gxg_GTK_IS_FONT_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_IS_FONT_CHOOSER_WIDGET_w, gxg_GTK_IS_FONT_CHOOSER_WIDGET)
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
Xen_wrap_1_arg(gxg_GTK_IS_APPLICATION_WINDOW_w, gxg_GTK_IS_APPLICATION_WINDOW)
Xen_wrap_1_arg(gxg_GTK_IS_COLOR_CHOOSER_DIALOG_w, gxg_GTK_IS_COLOR_CHOOSER_DIALOG)
Xen_wrap_1_arg(gxg_GTK_IS_COLOR_CHOOSER_WIDGET_w, gxg_GTK_IS_COLOR_CHOOSER_WIDGET)
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
Xen_wrap_1_arg(gxg_GTK_IS_MENU_BUTTON_w, gxg_GTK_IS_MENU_BUTTON)
Xen_wrap_1_arg(gxg_GTK_IS_SEARCH_ENTRY_w, gxg_GTK_IS_SEARCH_ENTRY)
Xen_wrap_1_arg(gxg_GTK_IS_LEVEL_BAR_w, gxg_GTK_IS_LEVEL_BAR)
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
Xen_wrap_1_arg(gxg_GTK_IS_PLACES_SIDEBAR_w, gxg_GTK_IS_PLACES_SIDEBAR)
Xen_wrap_1_arg(gxg_GTK_IS_STACK_SWITCHER_w, gxg_GTK_IS_STACK_SWITCHER)
Xen_wrap_1_arg(gxg_GTK_IS_STACK_w, gxg_GTK_IS_STACK)
Xen_wrap_1_arg(gxg_GTK_IS_REVEALER_w, gxg_GTK_IS_REVEALER)
Xen_wrap_1_arg(gxg_GTK_IS_HEADER_BAR_w, gxg_GTK_IS_HEADER_BAR)
Xen_wrap_1_arg(gxg_GTK_IS_LIST_BOX_w, gxg_GTK_IS_LIST_BOX)
Xen_wrap_1_arg(gxg_GTK_IS_LIST_BOX_ROW_w, gxg_GTK_IS_LIST_BOX_ROW)
Xen_wrap_1_arg(gxg_GTK_IS_SEARCH_BAR_w, gxg_GTK_IS_SEARCH_BAR)
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
Xen_wrap_1_arg(gxg_GTK_IS_FLOW_BOX_w, gxg_GTK_IS_FLOW_BOX)
Xen_wrap_1_arg(gxg_GTK_IS_FLOW_BOX_CHILD_w, gxg_GTK_IS_FLOW_BOX_CHILD)
Xen_wrap_1_arg(gxg_GTK_IS_ACTION_BAR_w, gxg_GTK_IS_ACTION_BAR)
Xen_wrap_1_arg(gxg_GTK_IS_POPOVER_w, gxg_GTK_IS_POPOVER)
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_w, gxg_GTK_IS_GESTURE)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_DRAG_w, gxg_GTK_IS_GESTURE_DRAG)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_LONG_PRESS_w, gxg_GTK_IS_GESTURE_LONG_PRESS)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_ZOOM_w, gxg_GTK_IS_GESTURE_ZOOM)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_SWIPE_w, gxg_GTK_IS_GESTURE_SWIPE)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_SINGLE_w, gxg_GTK_IS_GESTURE_SINGLE)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_PAN_w, gxg_GTK_IS_GESTURE_PAN)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_MULTI_PRESS_w, gxg_GTK_IS_GESTURE_MULTI_PRESS)
Xen_wrap_1_arg(gxg_GTK_IS_GESTURE_ROTATE_w, gxg_GTK_IS_GESTURE_ROTATE)
Xen_wrap_1_arg(gxg_GTK_IS_EVENT_CONTROLLER_w, gxg_GTK_IS_EVENT_CONTROLLER)
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
Xen_wrap_1_arg(gxg_GTK_IS_GL_AREA_w, gxg_GTK_IS_GL_AREA)
Xen_wrap_1_arg(gxg_GDK_IS_GL_CONTEXT_w, gxg_GDK_IS_GL_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_IS_POPOVER_MENU_w, gxg_GTK_IS_POPOVER_MENU)
Xen_wrap_1_arg(gxg_GTK_IS_STACK_SIDEBAR_w, gxg_GTK_IS_STACK_SIDEBAR)
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
Xen_wrap_1_arg(gxg_GDK_IS_SEAT_w, gxg_GDK_IS_SEAT)
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
Xen_wrap_1_arg(gxg_GDK_IS_DEVICE_TOOL_w, gxg_GDK_IS_DEVICE_TOOL)
Xen_wrap_1_arg(gxg_GDK_IS_MONITOR_w, gxg_GDK_IS_MONITOR)
Xen_wrap_1_arg(gxg_GDK_IS_DRAWING_CONTEXT_w, gxg_GDK_IS_DRAWING_CONTEXT)
Xen_wrap_1_arg(gxg_GDK_IS_DEVICE_PAD_w, gxg_GDK_IS_DEVICE_PAD)
Xen_wrap_1_arg(gxg_GTK_IS_PAD_CONTROLLER_w, gxg_GTK_IS_PAD_CONTROLLER)
Xen_wrap_1_arg(gxg_GTK_IS_SHORTCUT_LABEL_w, gxg_GTK_IS_SHORTCUT_LABEL)
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
Xen_wrap_1_arg(gxg_GTK_IS_CENTER_BOX_w, gxg_GTK_IS_CENTER_BOX)
Xen_wrap_1_arg(gxg_GTK_IS_STYLE_CONTEXT_w, gxg_GTK_IS_STYLE_CONTEXT)
Xen_wrap_1_arg(gxg_GTK_IS_STYLE_PROVIDER_w, gxg_GTK_IS_STYLE_PROVIDER)
Xen_wrap_1_arg(gxg_GTK_IS_CSS_PROVIDER_w, gxg_GTK_IS_CSS_PROVIDER)
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
Xen_wrap_1_arg(gxg_GTK_IS_EMOJI_CHOOSER_w, gxg_GTK_IS_EMOJI_CHOOSER)
Xen_wrap_1_arg(gxg_GTK_IS_EVENT_CONTROLLER_SCROLL_w, gxg_GTK_IS_EVENT_CONTROLLER_SCROLL)
Xen_wrap_1_arg(gxg_GTK_IS_EVENT_CONTROLLER_MOTION_w, gxg_GTK_IS_EVENT_CONTROLLER_MOTION)
Xen_wrap_1_arg(gxg_GDK_IS_TEXTURE_w, gxg_GDK_IS_TEXTURE)
Xen_wrap_1_arg(gxg_GDK_IS_EVENT_w, gxg_GDK_IS_EVENT)
Xen_wrap_1_arg(gxg_GDK_IS_APP_LAUNCH_CONTEXT_w, gxg_GDK_IS_APP_LAUNCH_CONTEXT)
Xen_wrap_1_arg(gxg_GDK_IS_CLIPBOARD_w, gxg_GDK_IS_CLIPBOARD)
Xen_wrap_1_arg(gxg_GDK_IS_CONTENT_PROVIDER_w, gxg_GDK_IS_CONTENT_PROVIDER)
Xen_wrap_1_arg(gxg_GDK_IS_CONTENT_SERIALIZER_w, gxg_GDK_IS_CONTENT_SERIALIZER)
Xen_wrap_1_arg(gxg_GDK_IS_CONTENT_DESERIALIZER_w, gxg_GDK_IS_CONTENT_DESERIALIZER)
Xen_wrap_1_arg(gxg_GTK_IS_APPLICATION_w, gxg_GTK_IS_APPLICATION)
#endif

static void define_functions(void)
{
#if HAVE_SCHEME
  s7_pointer s_boolean, s_integer, s_real, s_string, s_any, s_pair, s_float, s_gtk_enum_t, s_pair_false;
  s7_pointer pl_p, pl_bt, pl_tb, pl_bti, pl_btiib, pl_si, pl_is, pl_isi, pl_sig, pl_isgt, pl_isigutttiiu, pl_gi, pl_igi, pl_pu, pl_pur, pl_pub, pl_pui, pl_pug, pl_pus, pl_put, pl_pugi, pl_pubi, pl_pusi, pl_puri, pl_pust, pl_pusu, pl_pugu, pl_puiu, pl_purru, pl_puuig, pl_puiig, pl_puigu, pl_pusiu, pl_pusub, pl_puiiu, pl_pussu, pl_puibu, pl_pusig, pl_puuiu, pl_puuugi, pl_pusiig, pl_puuiig, pl_puiiui, pl_puiigi, pl_puuubu, pl_pusigu, pl_pusiiu, pl_puuiiu, pl_pugiiu, pl_pusiigu, pl_pusiuiu, pl_pusiiugu, pl_puuusuug, pl_pusiuibu, pl_t, pl_bi, pl_big, pl_pt, pl_tu, pl_tur, pl_tub, pl_tui, pl_tus, pl_tut, pl_tug, pl_turs, pl_tubu, pl_tusg, pl_tugb, pl_tugs, pl_tubi, pl_tuib, pl_tusr, pl_tusi, pl_turi, pl_tuui, pl_tuur, pl_tuig, pl_tusb, pl_tuub, pl_tuus, pl_tuug, pl_tugu, pl_tugr, pl_tugi, pl_tusu, pl_tuut, pl_tugt, pl_tuis, pl_tust, pl_tuiu, pl_tuit, pl_tuiut, pl_tugug, pl_tuuiu, pl_tussu, pl_tuuur, pl_tuusb, pl_tugui, pl_tuisi, pl_turgs, pl_tuurb, pl_tuuti, pl_tuuri, pl_tusri, pl_tuuut, pl_tuubr, pl_tuuub, pl_tuuir, pl_tuuui, pl_tuusi, pl_tuiiu, pl_tuugi, pl_tuiiut, pl_tuuiut, pl_tutisi, pl_tuuggu, pl_tugiis, pl_tuurru, pl_tuuuui, pl_tugiiu, pl_tuuugi, pl_tuuuub, pl_tuiggu, pl_turrrb, pl_tuusit, pl_tusiis, pl_tusuig, pl_tuuubr, pl_tuurbr, pl_tusuiut, pl_tusiiut, pl_tuuuggu, pl_tuuiuui, pl_tubiiiu, pl_tusiuiui, pl_tuurruig, pl_tuurrrrg, pl_tuurrrrgr, pl_tuiiiiui, pl_tuuiiiirrrrg, pl_tuuiiiirrrrgi, pl_i, pl_tts, pl_tti, pl_iu, pl_pi, pl_iur, pl_ius, pl_iui, pl_piu, pl_pit, pl_iug, pl_iugi, pl_iuis, pl_iusi, pl_iuui, pl_iuugs, pl_iuisi, pl_iuuui, pl_iuuuui, pl_iuisut, pl_ti, pl_it, pl_tiu, pl_tist, pl_itsub, pl_itiiub, pl_itstttg, pl_itgiiut, pl_iit, pl_iiit, pl_du, pl_pr, pl_dus, pl_dui, pl_dusr, pl_dusi, pl_prrru, pl_ssi, pl_ssig, pl_sg, pl_gs, pl_bsu, pl_bsigb, pl_s, pl_g, pl_su, pl_ps, pl_pst, pl_sug, pl_sui, pl_psu, pl_psb, pl_sus, pl_psg, pl_psi, pl_psgi, pl_psiu, pl_psut, pl_suiig, pl_suuub, pl_psugt, pl_psiuub, pl_psrrrb, pl_guugbuut, pl_psgbiiiit, pl_psiiuusu, pl_gu, pl_pg, pl_gus, pl_pgr, pl_pgu, pl_pgi, pl_gug, pl_gui, pl_guut, pl_pgbi, pl_guuut, pl_gussitu, pl_gurrsiu, pl_b, pl_ts, pl_tsu, pl_tsi, pl_tsit, pl_tsig, pl_tsiu, pl_tsiuui, pl_tsiiuui, pl_buuusuug, pl_bu, pl_pb, pl_tg, pl_bur, pl_bug, pl_bus, pl_bui, pl_bub, pl_busi, pl_buib, pl_busu, pl_buub, pl_buig, pl_buus, pl_buui, pl_buigu, pl_busib, pl_buuub, pl_buttu, pl_busgu, pl_buuig, pl_buuui, pl_buiuig, pl_buusib, pl_buuuub, pl_buurbr, pl_bpt;
#endif

  xm_gc_table = Xen_make_vector(1, Xen_false);
  Xen_GC_protect(xm_gc_table);
  xm_protected_size = 512;
  xm_protected = Xen_make_vector(xm_protected_size, Xen_false);
  Xen_vector_set(xm_gc_table, 0, xm_protected);

#if HAVE_SCHEME
  s_boolean = s7_make_symbol(s7, "boolean?");
  s_integer = s7_make_symbol(s7, "integer?");
  s_real = s7_make_symbol(s7, "real?");
  s_float = s7_make_symbol(s7, "float?");
  s_string = s7_make_symbol(s7, "string?");
  s_pair = s7_make_symbol(s7, "pair?");
  s_pair_false = s7_make_signature(s7, 2, s_pair, s_boolean);
  s_gtk_enum_t = s7_make_symbol(s7, "gtk_enum_t?");
  s_any = s7_t(s7);

  pl_p = s7_make_circular_signature(s7, 0, 1, s_pair);
  pl_bt = s7_make_circular_signature(s7, 1, 2, s_boolean, s_any);
  pl_tb = s7_make_circular_signature(s7, 1, 2, s_any, s_boolean);
  pl_bti = s7_make_circular_signature(s7, 2, 3, s_boolean, s_any, s_integer);
  pl_btiib = s7_make_circular_signature(s7, 4, 5, s_boolean, s_any, s_integer, s_integer, s_boolean);
  pl_si = s7_make_circular_signature(s7, 1, 2, s_string, s_integer);
  pl_is = s7_make_circular_signature(s7, 1, 2, s_integer, s_string);
  pl_isi = s7_make_circular_signature(s7, 2, 3, s_integer, s_string, s_integer);
  pl_sig = s7_make_circular_signature(s7, 2, 3, s_string, s_integer, s_gtk_enum_t);
  pl_isgt = s7_make_circular_signature(s7, 3, 4, s_integer, s_string, s_gtk_enum_t, s_any);
  pl_isigutttiiu = s7_make_circular_signature(s7, 10, 11, s_integer, s_string, s_integer, s_gtk_enum_t, s_pair_false, s_any, s_any, s_any, s_integer, s_integer, s_pair_false);
  pl_gi = s7_make_circular_signature(s7, 1, 2, s_gtk_enum_t, s_integer);
  pl_igi = s7_make_circular_signature(s7, 2, 3, s_integer, s_gtk_enum_t, s_integer);
  pl_pu = s7_make_circular_signature(s7, 1, 2, s_pair, s_pair_false);
  pl_pur = s7_make_circular_signature(s7, 2, 3, s_pair, s_pair_false, s_real);
  pl_pub = s7_make_circular_signature(s7, 2, 3, s_pair, s_pair_false, s_boolean);
  pl_pui = s7_make_circular_signature(s7, 2, 3, s_pair, s_pair_false, s_integer);
  pl_pug = s7_make_circular_signature(s7, 2, 3, s_pair, s_pair_false, s_gtk_enum_t);
  pl_pus = s7_make_circular_signature(s7, 2, 3, s_pair, s_pair_false, s_string);
  pl_put = s7_make_circular_signature(s7, 2, 3, s_pair, s_pair_false, s_any);
  pl_pugi = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_gtk_enum_t, s_integer);
  pl_pubi = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_boolean, s_integer);
  pl_pusi = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_string, s_integer);
  pl_puri = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_real, s_integer);
  pl_pust = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_string, s_any);
  pl_pusu = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_string, s_pair_false);
  pl_pugu = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_puiu = s7_make_circular_signature(s7, 3, 4, s_pair, s_pair_false, s_integer, s_pair_false);
  pl_purru = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_real, s_real, s_pair_false);
  pl_puuig = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_pair_false, s_integer, s_gtk_enum_t);
  pl_puiig = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_puigu = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_integer, s_gtk_enum_t, s_pair_false);
  pl_pusiu = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_string, s_integer, s_pair_false);
  pl_pusub = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_string, s_pair_false, s_boolean);
  pl_puiiu = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_pussu = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_string, s_string, s_pair_false);
  pl_puibu = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_pusig = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_string, s_integer, s_gtk_enum_t);
  pl_puuiu = s7_make_circular_signature(s7, 4, 5, s_pair, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_puuugi = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_pusiig = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_integer, s_gtk_enum_t);
  pl_puuiig = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_puiiui = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_integer, s_integer, s_pair_false, s_integer);
  pl_puiigi = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_integer, s_integer, s_gtk_enum_t, s_integer);
  pl_puuubu = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_pair_false, s_pair_false, s_boolean, s_pair_false);
  pl_pusigu = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_gtk_enum_t, s_pair_false);
  pl_pusiiu = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_integer, s_pair_false);
  pl_puuiiu = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_pugiiu = s7_make_circular_signature(s7, 5, 6, s_pair, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_pair_false);
  pl_pusiigu = s7_make_circular_signature(s7, 6, 7, s_pair, s_pair_false, s_string, s_integer, s_integer, s_gtk_enum_t, s_pair_false);
  pl_pusiuiu = s7_make_circular_signature(s7, 6, 7, s_pair, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_pair_false);
  pl_pusiiugu = s7_make_circular_signature(s7, 7, 8, s_pair, s_pair_false, s_string, s_integer, s_integer, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_puuusuug = s7_make_circular_signature(s7, 7, 8, s_pair, s_pair_false, s_pair_false, s_pair_false, s_string, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_pusiuibu = s7_make_circular_signature(s7, 7, 8, s_pair, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_t = s7_make_circular_signature(s7, 0, 1, s_any);
  pl_bi = s7_make_circular_signature(s7, 1, 2, s_boolean, s_integer);
  pl_big = s7_make_circular_signature(s7, 2, 3, s_boolean, s_integer, s_gtk_enum_t);
  pl_pt = s7_make_circular_signature(s7, 1, 2, s_pair, s_any);
  pl_tu = s7_make_circular_signature(s7, 1, 2, s_any, s_pair_false);
  pl_tur = s7_make_circular_signature(s7, 2, 3, s_any, s_pair_false, s_real);
  pl_tub = s7_make_circular_signature(s7, 2, 3, s_any, s_pair_false, s_boolean);
  pl_tui = s7_make_circular_signature(s7, 2, 3, s_any, s_pair_false, s_integer);
  pl_tus = s7_make_circular_signature(s7, 2, 3, s_any, s_pair_false, s_string);
  pl_tut = s7_make_circular_signature(s7, 2, 3, s_any, s_pair_false, s_any);
  pl_tug = s7_make_circular_signature(s7, 2, 3, s_any, s_pair_false, s_gtk_enum_t);
  pl_turs = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_real, s_string);
  pl_tubu = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_boolean, s_pair_false);
  pl_tusg = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_string, s_gtk_enum_t);
  pl_tugb = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_boolean);
  pl_tugs = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_string);
  pl_tubi = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_boolean, s_integer);
  pl_tuib = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_integer, s_boolean);
  pl_tusr = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_string, s_real);
  pl_tusi = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_string, s_integer);
  pl_turi = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_real, s_integer);
  pl_tuui = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_pair_false, s_integer);
  pl_tuur = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_pair_false, s_real);
  pl_tuig = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tusb = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_string, s_boolean);
  pl_tuub = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_pair_false, s_boolean);
  pl_tuus = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_pair_false, s_string);
  pl_tuug = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_tugu = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_tugr = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_real);
  pl_tugi = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tusu = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_string, s_pair_false);
  pl_tuut = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_pair_false, s_any);
  pl_tugt = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_any);
  pl_tuis = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_integer, s_string);
  pl_tust = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_string, s_any);
  pl_tuiu = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_integer, s_pair_false);
  pl_tuit = s7_make_circular_signature(s7, 3, 4, s_any, s_pair_false, s_integer, s_any);
  pl_tuiut = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_integer, s_pair_false, s_any);
  pl_tugug = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_gtk_enum_t);
  pl_tuuiu = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_tussu = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_string, s_string, s_pair_false);
  pl_tuuur = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_real);
  pl_tuusb = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_string, s_boolean);
  pl_tugui = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_integer);
  pl_tuisi = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_integer, s_string, s_integer);
  pl_turgs = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_real, s_gtk_enum_t, s_string);
  pl_tuurb = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_real, s_boolean);
  pl_tuuti = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_any, s_integer);
  pl_tuuri = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_real, s_integer);
  pl_tusri = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_string, s_real, s_integer);
  pl_tuuut = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_tuubr = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_boolean, s_real);
  pl_tuuub = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_tuuir = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_real);
  pl_tuuui = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_tuusi = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_string, s_integer);
  pl_tuiiu = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_tuugi = s7_make_circular_signature(s7, 4, 5, s_any, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuiiut = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_integer, s_integer, s_pair_false, s_any);
  pl_tuuiut = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false, s_any);
  pl_tutisi = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_any, s_integer, s_string, s_integer);
  pl_tuuggu = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_gtk_enum_t, s_gtk_enum_t, s_pair_false);
  pl_tugiis = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_string);
  pl_tuurru = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_real, s_real, s_pair_false);
  pl_tuuuui = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_tugiiu = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_pair_false);
  pl_tuuugi = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuuuub = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_tuiggu = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_integer, s_gtk_enum_t, s_gtk_enum_t, s_pair_false);
  pl_turrrb = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_real, s_real, s_real, s_boolean);
  pl_tuusit = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_string, s_integer, s_any);
  pl_tusiis = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_string, s_integer, s_integer, s_string);
  pl_tusuig = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_string, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tuuubr = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_boolean, s_real);
  pl_tuurbr = s7_make_circular_signature(s7, 5, 6, s_any, s_pair_false, s_pair_false, s_real, s_boolean, s_real);
  pl_tusuiut = s7_make_circular_signature(s7, 6, 7, s_any, s_pair_false, s_string, s_pair_false, s_integer, s_pair_false, s_any);
  pl_tusiiut = s7_make_circular_signature(s7, 6, 7, s_any, s_pair_false, s_string, s_integer, s_integer, s_pair_false, s_any);
  pl_tuuuggu = s7_make_circular_signature(s7, 6, 7, s_any, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_gtk_enum_t, s_pair_false);
  pl_tuuiuui = s7_make_circular_signature(s7, 6, 7, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_tubiiiu = s7_make_circular_signature(s7, 6, 7, s_any, s_pair_false, s_boolean, s_integer, s_integer, s_integer, s_pair_false);
  pl_tusiuiui = s7_make_circular_signature(s7, 7, 8, s_any, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_pair_false, s_integer);
  pl_tuurruig = s7_make_circular_signature(s7, 7, 8, s_any, s_pair_false, s_pair_false, s_real, s_real, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tuurrrrg = s7_make_circular_signature(s7, 7, 8, s_any, s_pair_false, s_pair_false, s_real, s_real, s_real, s_real, s_gtk_enum_t);
  pl_tuurrrrgr = s7_make_circular_signature(s7, 8, 9, s_any, s_pair_false, s_pair_false, s_real, s_real, s_real, s_real, s_gtk_enum_t, s_real);
  pl_tuiiiiui = s7_make_circular_signature(s7, 7, 8, s_any, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_pair_false, s_integer);
  pl_tuuiiiirrrrg = s7_make_circular_signature(s7, 11, 12, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_real, s_real, s_real, s_real, s_gtk_enum_t);
  pl_tuuiiiirrrrgi = s7_make_circular_signature(s7, 12, 13, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_real, s_real, s_real, s_real, s_gtk_enum_t, s_integer);
  pl_i = s7_make_circular_signature(s7, 0, 1, s_integer);
  pl_tts = s7_make_circular_signature(s7, 2, 3, s_any, s_any, s_string);
  pl_tti = s7_make_circular_signature(s7, 2, 3, s_any, s_any, s_integer);
  pl_iu = s7_make_circular_signature(s7, 1, 2, s_integer, s_pair_false);
  pl_pi = s7_make_circular_signature(s7, 1, 2, s_pair, s_integer);
  pl_iur = s7_make_circular_signature(s7, 2, 3, s_integer, s_pair_false, s_real);
  pl_ius = s7_make_circular_signature(s7, 2, 3, s_integer, s_pair_false, s_string);
  pl_iui = s7_make_circular_signature(s7, 2, 3, s_integer, s_pair_false, s_integer);
  pl_piu = s7_make_circular_signature(s7, 2, 3, s_pair, s_integer, s_pair_false);
  pl_pit = s7_make_circular_signature(s7, 2, 3, s_pair, s_integer, s_any);
  pl_iug = s7_make_circular_signature(s7, 2, 3, s_integer, s_pair_false, s_gtk_enum_t);
  pl_iugi = s7_make_circular_signature(s7, 3, 4, s_integer, s_pair_false, s_gtk_enum_t, s_integer);
  pl_iuis = s7_make_circular_signature(s7, 3, 4, s_integer, s_pair_false, s_integer, s_string);
  pl_iusi = s7_make_circular_signature(s7, 3, 4, s_integer, s_pair_false, s_string, s_integer);
  pl_iuui = s7_make_circular_signature(s7, 3, 4, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_iuugs = s7_make_circular_signature(s7, 4, 5, s_integer, s_pair_false, s_pair_false, s_gtk_enum_t, s_string);
  pl_iuisi = s7_make_circular_signature(s7, 4, 5, s_integer, s_pair_false, s_integer, s_string, s_integer);
  pl_iuuui = s7_make_circular_signature(s7, 4, 5, s_integer, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_iuuuui = s7_make_circular_signature(s7, 5, 6, s_integer, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_iuisut = s7_make_circular_signature(s7, 5, 6, s_integer, s_pair_false, s_integer, s_string, s_pair_false, s_any);
  pl_ti = s7_make_circular_signature(s7, 1, 2, s_any, s_integer);
  pl_it = s7_make_circular_signature(s7, 1, 2, s_integer, s_any);
  pl_tiu = s7_make_circular_signature(s7, 2, 3, s_any, s_integer, s_pair_false);
  pl_tist = s7_make_circular_signature(s7, 3, 4, s_any, s_integer, s_string, s_any);
  pl_itsub = s7_make_circular_signature(s7, 4, 5, s_integer, s_any, s_string, s_pair_false, s_boolean);
  pl_itiiub = s7_make_circular_signature(s7, 5, 6, s_integer, s_any, s_integer, s_integer, s_pair_false, s_boolean);
  pl_itstttg = s7_make_circular_signature(s7, 6, 7, s_integer, s_any, s_string, s_any, s_any, s_any, s_gtk_enum_t);
  pl_itgiiut = s7_make_circular_signature(s7, 6, 7, s_integer, s_any, s_gtk_enum_t, s_integer, s_integer, s_pair_false, s_any);
  pl_iit = s7_make_circular_signature(s7, 2, 3, s_integer, s_integer, s_any);
  pl_iiit = s7_make_circular_signature(s7, 3, 4, s_integer, s_integer, s_integer, s_any);
  pl_du = s7_make_circular_signature(s7, 1, 2, s_float, s_pair_false);
  pl_pr = s7_make_circular_signature(s7, 1, 2, s_pair, s_real);
  pl_dus = s7_make_circular_signature(s7, 2, 3, s_float, s_pair_false, s_string);
  pl_dui = s7_make_circular_signature(s7, 2, 3, s_float, s_pair_false, s_integer);
  pl_dusr = s7_make_circular_signature(s7, 3, 4, s_float, s_pair_false, s_string, s_real);
  pl_dusi = s7_make_circular_signature(s7, 3, 4, s_float, s_pair_false, s_string, s_integer);
  pl_prrru = s7_make_circular_signature(s7, 4, 5, s_pair, s_real, s_real, s_real, s_pair_false);
  pl_ssi = s7_make_circular_signature(s7, 2, 3, s_string, s_string, s_integer);
  pl_ssig = s7_make_circular_signature(s7, 3, 4, s_string, s_string, s_integer, s_gtk_enum_t);
  pl_sg = s7_make_circular_signature(s7, 1, 2, s_string, s_gtk_enum_t);
  pl_gs = s7_make_circular_signature(s7, 1, 2, s_gtk_enum_t, s_string);
  pl_bsu = s7_make_circular_signature(s7, 2, 3, s_boolean, s_string, s_pair_false);
  pl_bsigb = s7_make_circular_signature(s7, 4, 5, s_boolean, s_string, s_integer, s_gtk_enum_t, s_boolean);
  pl_s = s7_make_circular_signature(s7, 0, 1, s_string);
  pl_g = s7_make_circular_signature(s7, 0, 1, s_gtk_enum_t);
  pl_su = s7_make_circular_signature(s7, 1, 2, s_string, s_pair_false);
  pl_ps = s7_make_circular_signature(s7, 1, 2, s_pair, s_string);
  pl_pst = s7_make_circular_signature(s7, 2, 3, s_pair, s_string, s_any);
  pl_sug = s7_make_circular_signature(s7, 2, 3, s_string, s_pair_false, s_gtk_enum_t);
  pl_sui = s7_make_circular_signature(s7, 2, 3, s_string, s_pair_false, s_integer);
  pl_psu = s7_make_circular_signature(s7, 2, 3, s_pair, s_string, s_pair_false);
  pl_psb = s7_make_circular_signature(s7, 2, 3, s_pair, s_string, s_boolean);
  pl_sus = s7_make_circular_signature(s7, 2, 3, s_string, s_pair_false, s_string);
  pl_psg = s7_make_circular_signature(s7, 2, 3, s_pair, s_string, s_gtk_enum_t);
  pl_psi = s7_make_circular_signature(s7, 2, 3, s_pair, s_string, s_integer);
  pl_psgi = s7_make_circular_signature(s7, 3, 4, s_pair, s_string, s_gtk_enum_t, s_integer);
  pl_psiu = s7_make_circular_signature(s7, 3, 4, s_pair, s_string, s_integer, s_pair_false);
  pl_psut = s7_make_circular_signature(s7, 3, 4, s_pair, s_string, s_pair_false, s_any);
  pl_suiig = s7_make_circular_signature(s7, 4, 5, s_string, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_suuub = s7_make_circular_signature(s7, 4, 5, s_string, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_psugt = s7_make_circular_signature(s7, 4, 5, s_pair, s_string, s_pair_false, s_gtk_enum_t, s_any);
  pl_psiuub = s7_make_circular_signature(s7, 5, 6, s_pair, s_string, s_integer, s_pair_false, s_pair_false, s_boolean);
  pl_psrrrb = s7_make_circular_signature(s7, 5, 6, s_pair, s_string, s_real, s_real, s_real, s_boolean);
  pl_guugbuut = s7_make_circular_signature(s7, 7, 8, s_gtk_enum_t, s_pair_false, s_pair_false, s_gtk_enum_t, s_boolean, s_pair_false, s_pair_false, s_any);
  pl_psgbiiiit = s7_make_circular_signature(s7, 8, 9, s_pair, s_string, s_gtk_enum_t, s_boolean, s_integer, s_integer, s_integer, s_integer, s_any);
  pl_psiiuusu = s7_make_circular_signature(s7, 7, 8, s_pair, s_string, s_integer, s_integer, s_pair_false, s_pair_false, s_string, s_pair_false);
  pl_gu = s7_make_circular_signature(s7, 1, 2, s_gtk_enum_t, s_pair_false);
  pl_pg = s7_make_circular_signature(s7, 1, 2, s_pair, s_gtk_enum_t);
  pl_gus = s7_make_circular_signature(s7, 2, 3, s_gtk_enum_t, s_pair_false, s_string);
  pl_pgr = s7_make_circular_signature(s7, 2, 3, s_pair, s_gtk_enum_t, s_real);
  pl_pgu = s7_make_circular_signature(s7, 2, 3, s_pair, s_gtk_enum_t, s_pair_false);
  pl_pgi = s7_make_circular_signature(s7, 2, 3, s_pair, s_gtk_enum_t, s_integer);
  pl_gug = s7_make_circular_signature(s7, 2, 3, s_gtk_enum_t, s_pair_false, s_gtk_enum_t);
  pl_gui = s7_make_circular_signature(s7, 2, 3, s_gtk_enum_t, s_pair_false, s_integer);
  pl_guut = s7_make_circular_signature(s7, 3, 4, s_gtk_enum_t, s_pair_false, s_pair_false, s_any);
  pl_pgbi = s7_make_circular_signature(s7, 3, 4, s_pair, s_gtk_enum_t, s_boolean, s_integer);
  pl_guuut = s7_make_circular_signature(s7, 4, 5, s_gtk_enum_t, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_gussitu = s7_make_circular_signature(s7, 6, 7, s_gtk_enum_t, s_pair_false, s_string, s_string, s_integer, s_any, s_pair_false);
  pl_gurrsiu = s7_make_circular_signature(s7, 6, 7, s_gtk_enum_t, s_pair_false, s_real, s_real, s_string, s_integer, s_pair_false);
  pl_b = s7_make_circular_signature(s7, 0, 1, s_boolean);
  pl_ts = s7_make_circular_signature(s7, 1, 2, s_any, s_string);
  pl_tsu = s7_make_circular_signature(s7, 2, 3, s_any, s_string, s_pair_false);
  pl_tsi = s7_make_circular_signature(s7, 2, 3, s_any, s_string, s_integer);
  pl_tsit = s7_make_circular_signature(s7, 3, 4, s_any, s_string, s_integer, s_any);
  pl_tsig = s7_make_circular_signature(s7, 3, 4, s_any, s_string, s_integer, s_gtk_enum_t);
  pl_tsiu = s7_make_circular_signature(s7, 3, 4, s_any, s_string, s_integer, s_pair_false);
  pl_tsiuui = s7_make_circular_signature(s7, 5, 6, s_any, s_string, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_tsiiuui = s7_make_circular_signature(s7, 6, 7, s_any, s_string, s_integer, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_buuusuug = s7_make_circular_signature(s7, 7, 8, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_string, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_bu = s7_make_circular_signature(s7, 1, 2, s_boolean, s_pair_false);
  pl_pb = s7_make_circular_signature(s7, 1, 2, s_pair, s_boolean);
  pl_tg = s7_make_circular_signature(s7, 1, 2, s_any, s_gtk_enum_t);
  pl_bur = s7_make_circular_signature(s7, 2, 3, s_boolean, s_pair_false, s_real);
  pl_bug = s7_make_circular_signature(s7, 2, 3, s_boolean, s_pair_false, s_gtk_enum_t);
  pl_bus = s7_make_circular_signature(s7, 2, 3, s_boolean, s_pair_false, s_string);
  pl_bui = s7_make_circular_signature(s7, 2, 3, s_boolean, s_pair_false, s_integer);
  pl_bub = s7_make_circular_signature(s7, 2, 3, s_boolean, s_pair_false, s_boolean);
  pl_busi = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_string, s_integer);
  pl_buib = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_integer, s_boolean);
  pl_busu = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_string, s_pair_false);
  pl_buub = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_pair_false, s_boolean);
  pl_buig = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_integer, s_gtk_enum_t);
  pl_buus = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_pair_false, s_string);
  pl_buui = s7_make_circular_signature(s7, 3, 4, s_boolean, s_pair_false, s_pair_false, s_integer);
  pl_buigu = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_integer, s_gtk_enum_t, s_pair_false);
  pl_busib = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_string, s_integer, s_boolean);
  pl_buuub = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_buttu = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_any, s_any, s_pair_false);
  pl_busgu = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_string, s_gtk_enum_t, s_pair_false);
  pl_buuig = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_pair_false, s_integer, s_gtk_enum_t);
  pl_buuui = s7_make_circular_signature(s7, 4, 5, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_buiuig = s7_make_circular_signature(s7, 5, 6, s_boolean, s_pair_false, s_integer, s_pair_false, s_integer, s_gtk_enum_t);
  pl_buusib = s7_make_circular_signature(s7, 5, 6, s_boolean, s_pair_false, s_pair_false, s_string, s_integer, s_boolean);
  pl_buuuub = s7_make_circular_signature(s7, 5, 6, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_buurbr = s7_make_circular_signature(s7, 5, 6, s_boolean, s_pair_false, s_pair_false, s_real, s_boolean, s_real);
  pl_bpt = s7_make_signature(s7, 2, s_pair_false, s_any);
#endif

  Xg_define_procedure(g_unichar_validate, gxg_g_unichar_validate_w, 1, 0, 0, H_g_unichar_validate, pl_bi);
  Xg_define_procedure(g_unichar_isalnum, gxg_g_unichar_isalnum_w, 1, 0, 0, H_g_unichar_isalnum, pl_bi);
  Xg_define_procedure(g_unichar_isalpha, gxg_g_unichar_isalpha_w, 1, 0, 0, H_g_unichar_isalpha, pl_bi);
  Xg_define_procedure(g_unichar_iscntrl, gxg_g_unichar_iscntrl_w, 1, 0, 0, H_g_unichar_iscntrl, pl_bi);
  Xg_define_procedure(g_unichar_isdefined, gxg_g_unichar_isdefined_w, 1, 0, 0, H_g_unichar_isdefined, pl_bi);
  Xg_define_procedure(g_unichar_isdigit, gxg_g_unichar_isdigit_w, 1, 0, 0, H_g_unichar_isdigit, pl_bi);
  Xg_define_procedure(g_unichar_isgraph, gxg_g_unichar_isgraph_w, 1, 0, 0, H_g_unichar_isgraph, pl_bi);
  Xg_define_procedure(g_unichar_islower, gxg_g_unichar_islower_w, 1, 0, 0, H_g_unichar_islower, pl_bi);
  Xg_define_procedure(g_unichar_ismark, gxg_g_unichar_ismark_w, 1, 0, 0, H_g_unichar_ismark, pl_bi);
  Xg_define_procedure(g_unichar_isprint, gxg_g_unichar_isprint_w, 1, 0, 0, H_g_unichar_isprint, pl_bi);
  Xg_define_procedure(g_unichar_ispunct, gxg_g_unichar_ispunct_w, 1, 0, 0, H_g_unichar_ispunct, pl_bi);
  Xg_define_procedure(g_unichar_isspace, gxg_g_unichar_isspace_w, 1, 0, 0, H_g_unichar_isspace, pl_bi);
  Xg_define_procedure(g_unichar_istitle, gxg_g_unichar_istitle_w, 1, 0, 0, H_g_unichar_istitle, pl_bi);
  Xg_define_procedure(g_unichar_isupper, gxg_g_unichar_isupper_w, 1, 0, 0, H_g_unichar_isupper, pl_bi);
  Xg_define_procedure(g_unichar_isxdigit, gxg_g_unichar_isxdigit_w, 1, 0, 0, H_g_unichar_isxdigit, pl_bi);
  Xg_define_procedure(g_unichar_iswide, gxg_g_unichar_iswide_w, 1, 0, 0, H_g_unichar_iswide, pl_bi);
  Xg_define_procedure(g_unichar_iswide_cjk, gxg_g_unichar_iswide_cjk_w, 1, 0, 0, H_g_unichar_iswide_cjk, pl_bi);
  Xg_define_procedure(g_unichar_iszerowidth, gxg_g_unichar_iszerowidth_w, 1, 0, 0, H_g_unichar_iszerowidth, pl_bi);
  Xg_define_procedure(g_unichar_toupper, gxg_g_unichar_toupper_w, 1, 0, 0, H_g_unichar_toupper, pl_i);
  Xg_define_procedure(g_unichar_tolower, gxg_g_unichar_tolower_w, 1, 0, 0, H_g_unichar_tolower, pl_i);
  Xg_define_procedure(g_unichar_totitle, gxg_g_unichar_totitle_w, 1, 0, 0, H_g_unichar_totitle, pl_i);
  Xg_define_procedure(g_unichar_digit_value, gxg_g_unichar_digit_value_w, 1, 0, 0, H_g_unichar_digit_value, pl_i);
  Xg_define_procedure(g_unichar_xdigit_value, gxg_g_unichar_xdigit_value_w, 1, 0, 0, H_g_unichar_xdigit_value, pl_i);
  Xg_define_procedure(g_unichar_combining_class, gxg_g_unichar_combining_class_w, 1, 0, 0, H_g_unichar_combining_class, pl_i);
  Xg_define_procedure(g_unicode_canonical_ordering, gxg_g_unicode_canonical_ordering_w, 2, 0, 0, H_g_unicode_canonical_ordering, pl_tsi);
  Xg_define_procedure(g_utf8_get_char, gxg_g_utf8_get_char_w, 1, 0, 0, H_g_utf8_get_char, pl_is);
  Xg_define_procedure(g_utf8_get_char_validated, gxg_g_utf8_get_char_validated_w, 2, 0, 0, H_g_utf8_get_char_validated, pl_isi);
  Xg_define_procedure(g_utf8_prev_char, gxg_g_utf8_prev_char_w, 1, 0, 0, H_g_utf8_prev_char, pl_s);
  Xg_define_procedure(g_utf8_find_next_char, gxg_g_utf8_find_next_char_w, 2, 0, 0, H_g_utf8_find_next_char, pl_s);
  Xg_define_procedure(g_utf8_find_prev_char, gxg_g_utf8_find_prev_char_w, 2, 0, 0, H_g_utf8_find_prev_char, pl_s);
  Xg_define_procedure(g_utf8_strlen, gxg_g_utf8_strlen_w, 2, 0, 0, H_g_utf8_strlen, pl_isi);
  Xg_define_procedure(g_utf8_strchr, gxg_g_utf8_strchr_w, 3, 0, 0, H_g_utf8_strchr, pl_ssi);
  Xg_define_procedure(g_utf8_strrchr, gxg_g_utf8_strrchr_w, 3, 0, 0, H_g_utf8_strrchr, pl_ssi);
  Xg_define_procedure(g_utf8_strreverse, gxg_g_utf8_strreverse_w, 2, 0, 0, H_g_utf8_strreverse, pl_ssi);
  Xg_define_procedure(g_utf8_validate, gxg_g_utf8_validate_w, 2, 1, 0, H_g_utf8_validate, pl_psiu);
  Xg_define_procedure(g_utf8_strup, gxg_g_utf8_strup_w, 2, 0, 0, H_g_utf8_strup, pl_ssi);
  Xg_define_procedure(g_utf8_strdown, gxg_g_utf8_strdown_w, 2, 0, 0, H_g_utf8_strdown, pl_ssi);
  Xg_define_procedure(g_utf8_casefold, gxg_g_utf8_casefold_w, 2, 0, 0, H_g_utf8_casefold, pl_ssi);
  Xg_define_procedure(g_utf8_normalize, gxg_g_utf8_normalize_w, 3, 0, 0, H_g_utf8_normalize, pl_ssig);
  Xg_define_procedure(g_utf8_collate, gxg_g_utf8_collate_w, 2, 0, 0, H_g_utf8_collate, pl_is);
  Xg_define_procedure(g_utf8_collate_key, gxg_g_utf8_collate_key_w, 2, 0, 0, H_g_utf8_collate_key, pl_ssi);
  Xg_define_procedure(g_utf8_collate_key_for_filename, gxg_g_utf8_collate_key_for_filename_w, 2, 0, 0, H_g_utf8_collate_key_for_filename, pl_ssi);
  Xg_define_procedure(g_cclosure_new, gxg_g_cclosure_new_w, 3, 0, 0, H_g_cclosure_new, pl_pt);
  Xg_define_procedure(g_signal_newv, gxg_g_signal_newv_w, 0, 0, 1, H_g_signal_newv, pl_isigutttiiu);
  Xg_define_procedure(g_signal_lookup, gxg_g_signal_lookup_w, 2, 0, 0, H_g_signal_lookup, pl_isi);
  Xg_define_procedure(g_signal_name, gxg_g_signal_name_w, 1, 0, 0, H_g_signal_name, pl_si);
  Xg_define_procedure(g_signal_query, gxg_g_signal_query_w, 2, 0, 0, H_g_signal_query, pl_tiu);
  Xg_define_procedure(g_signal_list_ids, gxg_g_signal_list_ids_w, 2, 0, 0, H_g_signal_list_ids, pl_piu);
  Xg_define_procedure(g_signal_parse_name, gxg_g_signal_parse_name_w, 3, 2, 0, H_g_signal_parse_name, pl_psiuub);
  Xg_define_procedure(g_signal_get_invocation_hint, gxg_g_signal_get_invocation_hint_w, 1, 0, 0, H_g_signal_get_invocation_hint, pl_pt);
  Xg_define_procedure(g_signal_stop_emission, gxg_g_signal_stop_emission_w, 3, 0, 0, H_g_signal_stop_emission, pl_tti);
  Xg_define_procedure(g_signal_stop_emission_by_name, gxg_g_signal_stop_emission_by_name_w, 2, 0, 0, H_g_signal_stop_emission_by_name, pl_tts);
  Xg_define_procedure(g_signal_add_emission_hook, gxg_g_signal_add_emission_hook_w, 5, 0, 0, H_g_signal_add_emission_hook, pl_iiit);
  Xg_define_procedure(g_signal_remove_emission_hook, gxg_g_signal_remove_emission_hook_w, 2, 0, 0, H_g_signal_remove_emission_hook, pl_ti);
  Xg_define_procedure(g_signal_has_handler_pending, gxg_g_signal_has_handler_pending_w, 4, 0, 0, H_g_signal_has_handler_pending, pl_btiib);
  Xg_define_procedure(g_signal_connect_closure_by_id, gxg_g_signal_connect_closure_by_id_w, 5, 0, 0, H_g_signal_connect_closure_by_id, pl_itiiub);
  Xg_define_procedure(g_signal_connect_closure, gxg_g_signal_connect_closure_w, 4, 0, 0, H_g_signal_connect_closure, pl_itsub);
  Xg_define_procedure(g_signal_connect_data, gxg_g_signal_connect_data_w, 6, 0, 0, H_g_signal_connect_data, pl_itstttg);
  Xg_define_procedure(g_signal_handler_block, gxg_g_signal_handler_block_w, 2, 0, 0, H_g_signal_handler_block, pl_tti);
  Xg_define_procedure(g_signal_handler_unblock, gxg_g_signal_handler_unblock_w, 2, 0, 0, H_g_signal_handler_unblock, pl_tti);
  Xg_define_procedure(g_signal_handler_disconnect, gxg_g_signal_handler_disconnect_w, 2, 0, 0, H_g_signal_handler_disconnect, pl_tti);
  Xg_define_procedure(g_signal_handler_is_connected, gxg_g_signal_handler_is_connected_w, 2, 0, 0, H_g_signal_handler_is_connected, pl_bti);
  Xg_define_procedure(g_signal_handler_find, gxg_g_signal_handler_find_w, 7, 0, 0, H_g_signal_handler_find, pl_itgiiut);
  Xg_define_procedure(g_signal_handlers_block_matched, gxg_g_signal_handlers_block_matched_w, 7, 0, 0, H_g_signal_handlers_block_matched, pl_itgiiut);
  Xg_define_procedure(g_signal_handlers_unblock_matched, gxg_g_signal_handlers_unblock_matched_w, 7, 0, 0, H_g_signal_handlers_unblock_matched, pl_itgiiut);
  Xg_define_procedure(g_signal_handlers_disconnect_matched, gxg_g_signal_handlers_disconnect_matched_w, 7, 0, 0, H_g_signal_handlers_disconnect_matched, pl_itgiiut);
  Xg_define_procedure(g_signal_handlers_destroy, gxg_g_signal_handlers_destroy_w, 1, 0, 0, H_g_signal_handlers_destroy, pl_t);
  Xg_define_procedure(g_object_ref, gxg_g_object_ref_w, 1, 0, 0, H_g_object_ref, pl_t);
  Xg_define_procedure(g_object_unref, gxg_g_object_unref_w, 1, 0, 0, H_g_object_unref, pl_t);
  Xg_define_procedure(gdk_drag_status, gxg_gdk_drag_status_w, 3, 0, 0, H_gdk_drag_status, pl_tugi);
  Xg_define_procedure(gdk_drop_reply, gxg_gdk_drop_reply_w, 3, 0, 0, H_gdk_drop_reply, pl_tubi);
  Xg_define_procedure(gdk_drop_finish, gxg_gdk_drop_finish_w, 3, 0, 0, H_gdk_drop_finish, pl_tubi);
  Xg_define_procedure(gdk_event_copy, gxg_gdk_event_copy_w, 1, 0, 0, H_gdk_event_copy, pl_pu);
  Xg_define_procedure(gdk_event_free, gxg_gdk_event_free_w, 1, 0, 0, H_gdk_event_free, pl_tu);
  Xg_define_procedure(gdk_event_get_time, gxg_gdk_event_get_time_w, 1, 0, 0, H_gdk_event_get_time, pl_iu);
  Xg_define_procedure(gdk_event_get_state, gxg_gdk_event_get_state_w, 1, 1, 0, H_gdk_event_get_state, pl_pu);
  Xg_define_procedure(gdk_event_get_coords, gxg_gdk_event_get_coords_w, 1, 2, 0, H_gdk_event_get_coords, pl_pu);
  Xg_define_procedure(gdk_event_get_root_coords, gxg_gdk_event_get_root_coords_w, 1, 2, 0, H_gdk_event_get_root_coords, pl_pu);
  Xg_define_procedure(gdk_event_handler_set, gxg_gdk_event_handler_set_w, 3, 0, 0, H_gdk_event_handler_set, pl_t);
  Xg_define_procedure(gdk_set_show_events, gxg_gdk_set_show_events_w, 1, 0, 0, H_gdk_set_show_events, pl_tb);
  Xg_define_procedure(gdk_get_show_events, gxg_gdk_get_show_events_w, 0, 0, 0, H_gdk_get_show_events, pl_b);
  Xg_define_procedure(gdk_rectangle_intersect, gxg_gdk_rectangle_intersect_w, 3, 0, 0, H_gdk_rectangle_intersect, pl_bu);
  Xg_define_procedure(gdk_rectangle_union, gxg_gdk_rectangle_union_w, 3, 0, 0, H_gdk_rectangle_union, pl_tu);
  Xg_define_procedure(gdk_keymap_lookup_key, gxg_gdk_keymap_lookup_key_w, 2, 0, 0, H_gdk_keymap_lookup_key, pl_iu);
  Xg_define_procedure(gdk_keymap_get_entries_for_keyval, gxg_gdk_keymap_get_entries_for_keyval_w, 2, 2, 0, H_gdk_keymap_get_entries_for_keyval, pl_puiu);
  Xg_define_procedure(gdk_keymap_get_entries_for_keycode, gxg_gdk_keymap_get_entries_for_keycode_w, 2, 3, 0, H_gdk_keymap_get_entries_for_keycode, pl_puiu);
  Xg_define_procedure(gdk_keymap_get_direction, gxg_gdk_keymap_get_direction_w, 1, 0, 0, H_gdk_keymap_get_direction, pl_gu);
  Xg_define_procedure(gdk_keyval_name, gxg_gdk_keyval_name_w, 1, 0, 0, H_gdk_keyval_name, pl_si);
  Xg_define_procedure(gdk_keyval_from_name, gxg_gdk_keyval_from_name_w, 1, 0, 0, H_gdk_keyval_from_name, pl_is);
  Xg_define_procedure(gdk_keyval_convert_case, gxg_gdk_keyval_convert_case_w, 1, 2, 0, H_gdk_keyval_convert_case, pl_piu);
  Xg_define_procedure(gdk_keyval_to_upper, gxg_gdk_keyval_to_upper_w, 1, 0, 0, H_gdk_keyval_to_upper, pl_i);
  Xg_define_procedure(gdk_keyval_to_lower, gxg_gdk_keyval_to_lower_w, 1, 0, 0, H_gdk_keyval_to_lower, pl_i);
  Xg_define_procedure(gdk_keyval_is_upper, gxg_gdk_keyval_is_upper_w, 1, 0, 0, H_gdk_keyval_is_upper, pl_bi);
  Xg_define_procedure(gdk_keyval_is_lower, gxg_gdk_keyval_is_lower_w, 1, 0, 0, H_gdk_keyval_is_lower, pl_bi);
  Xg_define_procedure(gdk_keyval_to_unicode, gxg_gdk_keyval_to_unicode_w, 1, 0, 0, H_gdk_keyval_to_unicode, pl_i);
  Xg_define_procedure(gdk_unicode_to_keyval, gxg_gdk_unicode_to_keyval_w, 1, 0, 0, H_gdk_unicode_to_keyval, pl_i);
  Xg_define_procedure(gdk_utf8_to_string_target, gxg_gdk_utf8_to_string_target_w, 1, 0, 0, H_gdk_utf8_to_string_target, pl_s);
  Xg_define_procedure(gdk_window_destroy, gxg_gdk_window_destroy_w, 1, 0, 0, H_gdk_window_destroy, pl_tu);
  Xg_define_procedure(gdk_window_get_window_type, gxg_gdk_window_get_window_type_w, 1, 0, 0, H_gdk_window_get_window_type, pl_gu);
  Xg_define_procedure(gdk_window_show, gxg_gdk_window_show_w, 1, 0, 0, H_gdk_window_show, pl_tu);
  Xg_define_procedure(gdk_window_hide, gxg_gdk_window_hide_w, 1, 0, 0, H_gdk_window_hide, pl_tu);
  Xg_define_procedure(gdk_window_withdraw, gxg_gdk_window_withdraw_w, 1, 0, 0, H_gdk_window_withdraw, pl_tu);
  Xg_define_procedure(gdk_window_show_unraised, gxg_gdk_window_show_unraised_w, 1, 0, 0, H_gdk_window_show_unraised, pl_tu);
  Xg_define_procedure(gdk_window_move, gxg_gdk_window_move_w, 3, 0, 0, H_gdk_window_move, pl_tui);
  Xg_define_procedure(gdk_window_resize, gxg_gdk_window_resize_w, 3, 0, 0, H_gdk_window_resize, pl_tui);
  Xg_define_procedure(gdk_window_move_resize, gxg_gdk_window_move_resize_w, 5, 0, 0, H_gdk_window_move_resize, pl_tui);
  Xg_define_procedure(gdk_window_raise, gxg_gdk_window_raise_w, 1, 0, 0, H_gdk_window_raise, pl_tu);
  Xg_define_procedure(gdk_window_lower, gxg_gdk_window_lower_w, 1, 0, 0, H_gdk_window_lower, pl_tu);
  Xg_define_procedure(gdk_window_focus, gxg_gdk_window_focus_w, 2, 0, 0, H_gdk_window_focus, pl_tui);
  Xg_define_procedure(gdk_window_set_user_data, gxg_gdk_window_set_user_data_w, 2, 0, 0, H_gdk_window_set_user_data, pl_tut);
  Xg_define_procedure(gdk_window_add_filter, gxg_gdk_window_add_filter_w, 3, 0, 0, H_gdk_window_add_filter, pl_tut);
  Xg_define_procedure(gdk_window_remove_filter, gxg_gdk_window_remove_filter_w, 3, 0, 0, H_gdk_window_remove_filter, pl_tut);
  Xg_define_procedure(gdk_window_scroll, gxg_gdk_window_scroll_w, 3, 0, 0, H_gdk_window_scroll, pl_tui);
  Xg_define_procedure(gdk_window_set_child_shapes, gxg_gdk_window_set_child_shapes_w, 1, 0, 0, H_gdk_window_set_child_shapes, pl_tu);
  Xg_define_procedure(gdk_window_merge_child_shapes, gxg_gdk_window_merge_child_shapes_w, 1, 0, 0, H_gdk_window_merge_child_shapes, pl_tu);
  Xg_define_procedure(gdk_window_is_visible, gxg_gdk_window_is_visible_w, 1, 0, 0, H_gdk_window_is_visible, pl_bu);
  Xg_define_procedure(gdk_window_is_viewable, gxg_gdk_window_is_viewable_w, 1, 0, 0, H_gdk_window_is_viewable, pl_bu);
  Xg_define_procedure(gdk_window_get_state, gxg_gdk_window_get_state_w, 1, 0, 0, H_gdk_window_get_state, pl_gu);
  Xg_define_procedure(gdk_window_get_root_origin, gxg_gdk_window_get_root_origin_w, 1, 2, 0, H_gdk_window_get_root_origin, pl_pu);
  Xg_define_procedure(gdk_window_get_frame_extents, gxg_gdk_window_get_frame_extents_w, 2, 0, 0, H_gdk_window_get_frame_extents, pl_tu);
  Xg_define_procedure(gdk_window_get_parent, gxg_gdk_window_get_parent_w, 1, 0, 0, H_gdk_window_get_parent, pl_pu);
  Xg_define_procedure(gdk_window_get_toplevel, gxg_gdk_window_get_toplevel_w, 1, 0, 0, H_gdk_window_get_toplevel, pl_pu);
  Xg_define_procedure(gdk_window_get_children, gxg_gdk_window_get_children_w, 1, 0, 0, H_gdk_window_get_children, pl_pu);
  Xg_define_procedure(gdk_window_peek_children, gxg_gdk_window_peek_children_w, 1, 0, 0, H_gdk_window_peek_children, pl_pu);
  Xg_define_procedure(gdk_window_get_events, gxg_gdk_window_get_events_w, 1, 0, 0, H_gdk_window_get_events, pl_gu);
  Xg_define_procedure(gdk_window_set_events, gxg_gdk_window_set_events_w, 2, 0, 0, H_gdk_window_set_events, pl_tug);
  Xg_define_procedure(gdk_window_set_icon_name, gxg_gdk_window_set_icon_name_w, 2, 0, 0, H_gdk_window_set_icon_name, pl_tus);
  Xg_define_procedure(gdk_window_set_group, gxg_gdk_window_set_group_w, 2, 0, 0, H_gdk_window_set_group, pl_tu);
  Xg_define_procedure(gdk_window_set_decorations, gxg_gdk_window_set_decorations_w, 2, 0, 0, H_gdk_window_set_decorations, pl_tug);
  Xg_define_procedure(gdk_window_get_decorations, gxg_gdk_window_get_decorations_w, 1, 1, 0, H_gdk_window_get_decorations, pl_pu);
  Xg_define_procedure(gdk_window_set_functions, gxg_gdk_window_set_functions_w, 2, 0, 0, H_gdk_window_set_functions, pl_tug);
  Xg_define_procedure(gdk_window_iconify, gxg_gdk_window_iconify_w, 1, 0, 0, H_gdk_window_iconify, pl_tu);
  Xg_define_procedure(gdk_window_deiconify, gxg_gdk_window_deiconify_w, 1, 0, 0, H_gdk_window_deiconify, pl_tu);
  Xg_define_procedure(gdk_window_stick, gxg_gdk_window_stick_w, 1, 0, 0, H_gdk_window_stick, pl_tu);
  Xg_define_procedure(gdk_window_unstick, gxg_gdk_window_unstick_w, 1, 0, 0, H_gdk_window_unstick, pl_tu);
  Xg_define_procedure(gdk_window_maximize, gxg_gdk_window_maximize_w, 1, 0, 0, H_gdk_window_maximize, pl_tu);
  Xg_define_procedure(gdk_window_unmaximize, gxg_gdk_window_unmaximize_w, 1, 0, 0, H_gdk_window_unmaximize, pl_tu);
  Xg_define_procedure(gdk_window_register_dnd, gxg_gdk_window_register_dnd_w, 1, 0, 0, H_gdk_window_register_dnd, pl_tu);
  Xg_define_procedure(gdk_window_begin_resize_drag, gxg_gdk_window_begin_resize_drag_w, 6, 0, 0, H_gdk_window_begin_resize_drag, pl_tugi);
  Xg_define_procedure(gdk_window_begin_move_drag, gxg_gdk_window_begin_move_drag_w, 5, 0, 0, H_gdk_window_begin_move_drag, pl_tui);
  Xg_define_procedure(gdk_window_invalidate_rect, gxg_gdk_window_invalidate_rect_w, 3, 0, 0, H_gdk_window_invalidate_rect, pl_tuub);
  Xg_define_procedure(gdk_window_freeze_updates, gxg_gdk_window_freeze_updates_w, 1, 0, 0, H_gdk_window_freeze_updates, pl_tu);
  Xg_define_procedure(gdk_window_thaw_updates, gxg_gdk_window_thaw_updates_w, 1, 0, 0, H_gdk_window_thaw_updates, pl_tu);
  Xg_define_procedure(gdk_window_constrain_size, gxg_gdk_window_constrain_size_w, 4, 2, 0, H_gdk_window_constrain_size, pl_pugiiu);
  Xg_define_procedure(gdk_window_set_type_hint, gxg_gdk_window_set_type_hint_w, 2, 0, 0, H_gdk_window_set_type_hint, pl_tug);
  Xg_define_procedure(gdk_window_set_modal_hint, gxg_gdk_window_set_modal_hint_w, 2, 0, 0, H_gdk_window_set_modal_hint, pl_tub);
  Xg_define_procedure(gdk_window_set_title, gxg_gdk_window_set_title_w, 2, 0, 0, H_gdk_window_set_title, pl_tus);
  Xg_define_procedure(gdk_window_set_role, gxg_gdk_window_set_role_w, 2, 0, 0, H_gdk_window_set_role, pl_tus);
  Xg_define_procedure(gdk_window_set_transient_for, gxg_gdk_window_set_transient_for_w, 2, 0, 0, H_gdk_window_set_transient_for, pl_tu);
  Xg_define_procedure(gdk_window_set_cursor, gxg_gdk_window_set_cursor_w, 2, 0, 0, H_gdk_window_set_cursor, pl_tu);
  Xg_define_procedure(gdk_window_get_user_data, gxg_gdk_window_get_user_data_w, 1, 1, 0, H_gdk_window_get_user_data, pl_pu);
  Xg_define_procedure(gdk_window_get_position, gxg_gdk_window_get_position_w, 1, 2, 0, H_gdk_window_get_position, pl_pu);
  Xg_define_procedure(gdk_window_get_origin, gxg_gdk_window_get_origin_w, 1, 2, 0, H_gdk_window_get_origin, pl_pu);
  Xg_define_procedure(gdk_pixbuf_error_quark, gxg_gdk_pixbuf_error_quark_w, 0, 0, 0, H_gdk_pixbuf_error_quark, pl_i);
  Xg_define_procedure(gdk_pixbuf_get_colorspace, gxg_gdk_pixbuf_get_colorspace_w, 1, 0, 0, H_gdk_pixbuf_get_colorspace, pl_gu);
  Xg_define_procedure(gdk_pixbuf_get_n_channels, gxg_gdk_pixbuf_get_n_channels_w, 1, 0, 0, H_gdk_pixbuf_get_n_channels, pl_iu);
  Xg_define_procedure(gdk_pixbuf_get_has_alpha, gxg_gdk_pixbuf_get_has_alpha_w, 1, 0, 0, H_gdk_pixbuf_get_has_alpha, pl_bu);
  Xg_define_procedure(gdk_pixbuf_get_bits_per_sample, gxg_gdk_pixbuf_get_bits_per_sample_w, 1, 0, 0, H_gdk_pixbuf_get_bits_per_sample, pl_iu);
  Xg_define_procedure(gdk_pixbuf_get_pixels, gxg_gdk_pixbuf_get_pixels_w, 1, 0, 0, H_gdk_pixbuf_get_pixels, pl_su);
  Xg_define_procedure(gdk_pixbuf_get_width, gxg_gdk_pixbuf_get_width_w, 1, 0, 0, H_gdk_pixbuf_get_width, pl_iu);
  Xg_define_procedure(gdk_pixbuf_get_height, gxg_gdk_pixbuf_get_height_w, 1, 0, 0, H_gdk_pixbuf_get_height, pl_iu);
  Xg_define_procedure(gdk_pixbuf_get_rowstride, gxg_gdk_pixbuf_get_rowstride_w, 1, 0, 0, H_gdk_pixbuf_get_rowstride, pl_iu);
  Xg_define_procedure(gdk_pixbuf_new, gxg_gdk_pixbuf_new_w, 5, 0, 0, H_gdk_pixbuf_new, pl_pgbi);
  Xg_define_procedure(gdk_pixbuf_copy, gxg_gdk_pixbuf_copy_w, 1, 0, 0, H_gdk_pixbuf_copy, pl_pu);
  Xg_define_procedure(gdk_pixbuf_new_subpixbuf, gxg_gdk_pixbuf_new_subpixbuf_w, 5, 0, 0, H_gdk_pixbuf_new_subpixbuf, pl_pui);
  Xg_define_procedure(gdk_pixbuf_new_from_file, gxg_gdk_pixbuf_new_from_file_w, 1, 1, 0, H_gdk_pixbuf_new_from_file, pl_psu);
  Xg_define_procedure(gdk_pixbuf_new_from_data, gxg_gdk_pixbuf_new_from_data_w, 0, 0, 1, H_gdk_pixbuf_new_from_data, pl_psgbiiiit);
  Xg_define_procedure(gdk_pixbuf_new_from_xpm_data, gxg_gdk_pixbuf_new_from_xpm_data_w, 1, 0, 0, H_gdk_pixbuf_new_from_xpm_data, pl_pu);
  Xg_define_procedure(gdk_pixbuf_fill, gxg_gdk_pixbuf_fill_w, 2, 0, 0, H_gdk_pixbuf_fill, pl_tui);
  Xg_define_procedure(gdk_pixbuf_savev, gxg_gdk_pixbuf_savev_w, 5, 1, 0, H_gdk_pixbuf_savev, pl_pussu);
  Xg_define_procedure(gdk_pixbuf_add_alpha, gxg_gdk_pixbuf_add_alpha_w, 5, 0, 0, H_gdk_pixbuf_add_alpha, pl_pubi);
  Xg_define_procedure(gdk_pixbuf_copy_area, gxg_gdk_pixbuf_copy_area_w, 0, 0, 1, H_gdk_pixbuf_copy_area, pl_tuiiiiui);
  Xg_define_procedure(gdk_pixbuf_saturate_and_pixelate, gxg_gdk_pixbuf_saturate_and_pixelate_w, 4, 0, 0, H_gdk_pixbuf_saturate_and_pixelate, pl_tuurb);
  Xg_define_procedure(gdk_pixbuf_scale, gxg_gdk_pixbuf_scale_w, 0, 0, 1, H_gdk_pixbuf_scale, pl_tuuiiiirrrrg);
  Xg_define_procedure(gdk_pixbuf_composite, gxg_gdk_pixbuf_composite_w, 0, 0, 1, H_gdk_pixbuf_composite, pl_tuuiiiirrrrgi);
  Xg_define_procedure(gdk_pixbuf_composite_color, gxg_gdk_pixbuf_composite_color_w, 0, 0, 1, H_gdk_pixbuf_composite_color, pl_tuuiiiirrrrgi);
  Xg_define_procedure(gdk_pixbuf_scale_simple, gxg_gdk_pixbuf_scale_simple_w, 4, 0, 0, H_gdk_pixbuf_scale_simple, pl_puiig);
  Xg_define_procedure(gdk_pixbuf_composite_color_simple, gxg_gdk_pixbuf_composite_color_simple_w, 0, 0, 1, H_gdk_pixbuf_composite_color_simple, pl_puiigi);
  Xg_define_procedure(gdk_pixbuf_get_option, gxg_gdk_pixbuf_get_option_w, 2, 0, 0, H_gdk_pixbuf_get_option, pl_sus);
  Xg_define_procedure(gtk_accel_group_new, gxg_gtk_accel_group_new_w, 0, 0, 0, H_gtk_accel_group_new, pl_p);
  Xg_define_procedure(gtk_accel_group_lock, gxg_gtk_accel_group_lock_w, 1, 0, 0, H_gtk_accel_group_lock, pl_tu);
  Xg_define_procedure(gtk_accel_group_unlock, gxg_gtk_accel_group_unlock_w, 1, 0, 0, H_gtk_accel_group_unlock, pl_tu);
  Xg_define_procedure(gtk_accel_group_connect, gxg_gtk_accel_group_connect_w, 5, 0, 0, H_gtk_accel_group_connect, pl_tuiggu);
  Xg_define_procedure(gtk_accel_group_connect_by_path, gxg_gtk_accel_group_connect_by_path_w, 3, 0, 0, H_gtk_accel_group_connect_by_path, pl_tusu);
  Xg_define_procedure(gtk_accel_group_disconnect, gxg_gtk_accel_group_disconnect_w, 2, 0, 0, H_gtk_accel_group_disconnect, pl_bu);
  Xg_define_procedure(gtk_accel_group_disconnect_key, gxg_gtk_accel_group_disconnect_key_w, 3, 0, 0, H_gtk_accel_group_disconnect_key, pl_buig);
  Xg_define_procedure(gtk_accel_groups_activate, gxg_gtk_accel_groups_activate_w, 3, 0, 0, H_gtk_accel_groups_activate, pl_buig);
  Xg_define_procedure(gtk_accel_groups_from_object, gxg_gtk_accel_groups_from_object_w, 1, 0, 0, H_gtk_accel_groups_from_object, pl_pu);
  Xg_define_procedure(gtk_accel_group_find, gxg_gtk_accel_group_find_w, 3, 0, 0, H_gtk_accel_group_find, pl_put);
  Xg_define_procedure(gtk_accel_group_from_accel_closure, gxg_gtk_accel_group_from_accel_closure_w, 1, 0, 0, H_gtk_accel_group_from_accel_closure, pl_pu);
  Xg_define_procedure(gtk_accelerator_valid, gxg_gtk_accelerator_valid_w, 2, 0, 0, H_gtk_accelerator_valid, pl_big);
  Xg_define_procedure(gtk_accelerator_parse, gxg_gtk_accelerator_parse_w, 1, 2, 0, H_gtk_accelerator_parse, pl_psu);
  Xg_define_procedure(gtk_accelerator_name, gxg_gtk_accelerator_name_w, 2, 0, 0, H_gtk_accelerator_name, pl_sig);
  Xg_define_procedure(gtk_accelerator_set_default_mod_mask, gxg_gtk_accelerator_set_default_mod_mask_w, 1, 0, 0, H_gtk_accelerator_set_default_mod_mask, pl_tg);
  Xg_define_procedure(gtk_accel_group_query, gxg_gtk_accel_group_query_w, 3, 1, 0, H_gtk_accel_group_query, pl_puigu);
  Xg_define_procedure(gtk_accel_group_activate, gxg_gtk_accel_group_activate_w, 5, 0, 0, H_gtk_accel_group_activate, pl_buiuig);
  Xg_define_procedure(gtk_accel_label_new, gxg_gtk_accel_label_new_w, 1, 0, 0, H_gtk_accel_label_new, pl_ps);
  Xg_define_procedure(gtk_accel_label_get_accel_widget, gxg_gtk_accel_label_get_accel_widget_w, 1, 0, 0, H_gtk_accel_label_get_accel_widget, pl_pu);
  Xg_define_procedure(gtk_accel_label_get_accel_width, gxg_gtk_accel_label_get_accel_width_w, 1, 0, 0, H_gtk_accel_label_get_accel_width, pl_iu);
  Xg_define_procedure(gtk_accel_label_set_accel_widget, gxg_gtk_accel_label_set_accel_widget_w, 2, 0, 0, H_gtk_accel_label_set_accel_widget, pl_tu);
  Xg_define_procedure(gtk_accel_label_set_accel_closure, gxg_gtk_accel_label_set_accel_closure_w, 2, 0, 0, H_gtk_accel_label_set_accel_closure, pl_tu);
  Xg_define_procedure(gtk_accel_label_refetch, gxg_gtk_accel_label_refetch_w, 1, 0, 0, H_gtk_accel_label_refetch, pl_bu);
  Xg_define_procedure(gtk_accel_map_add_entry, gxg_gtk_accel_map_add_entry_w, 3, 0, 0, H_gtk_accel_map_add_entry, pl_tsig);
  Xg_define_procedure(gtk_accel_map_lookup_entry, gxg_gtk_accel_map_lookup_entry_w, 2, 0, 0, H_gtk_accel_map_lookup_entry, pl_bsu);
  Xg_define_procedure(gtk_accel_map_change_entry, gxg_gtk_accel_map_change_entry_w, 4, 0, 0, H_gtk_accel_map_change_entry, pl_bsigb);
  Xg_define_procedure(gtk_accel_map_load, gxg_gtk_accel_map_load_w, 1, 0, 0, H_gtk_accel_map_load, pl_ts);
  Xg_define_procedure(gtk_accel_map_save, gxg_gtk_accel_map_save_w, 1, 0, 0, H_gtk_accel_map_save, pl_ts);
  Xg_define_procedure(gtk_accel_map_foreach, gxg_gtk_accel_map_foreach_w, 2, 0, 0, H_gtk_accel_map_foreach, pl_t);
  Xg_define_procedure(gtk_accel_map_load_fd, gxg_gtk_accel_map_load_fd_w, 1, 0, 0, H_gtk_accel_map_load_fd, pl_ti);
  Xg_define_procedure(gtk_accel_map_save_fd, gxg_gtk_accel_map_save_fd_w, 1, 0, 0, H_gtk_accel_map_save_fd, pl_ti);
  Xg_define_procedure(gtk_accel_map_add_filter, gxg_gtk_accel_map_add_filter_w, 1, 0, 0, H_gtk_accel_map_add_filter, pl_ts);
  Xg_define_procedure(gtk_accel_map_foreach_unfiltered, gxg_gtk_accel_map_foreach_unfiltered_w, 2, 0, 0, H_gtk_accel_map_foreach_unfiltered, pl_t);
  Xg_define_procedure(gtk_adjustment_clamp_page, gxg_gtk_adjustment_clamp_page_w, 3, 0, 0, H_gtk_adjustment_clamp_page, pl_tur);
  Xg_define_procedure(gtk_adjustment_get_value, gxg_gtk_adjustment_get_value_w, 1, 0, 0, H_gtk_adjustment_get_value, pl_du);
  Xg_define_procedure(gtk_adjustment_set_value, gxg_gtk_adjustment_set_value_w, 2, 0, 0, H_gtk_adjustment_set_value, pl_tur);
  Xg_define_procedure(gtk_aspect_frame_new, gxg_gtk_aspect_frame_new_w, 5, 0, 0, H_gtk_aspect_frame_new, pl_psrrrb);
  Xg_define_procedure(gtk_aspect_frame_set, gxg_gtk_aspect_frame_set_w, 5, 0, 0, H_gtk_aspect_frame_set, pl_turrrb);
  Xg_define_procedure(gtk_button_box_get_layout, gxg_gtk_button_box_get_layout_w, 1, 0, 0, H_gtk_button_box_get_layout, pl_gu);
  Xg_define_procedure(gtk_button_box_set_layout, gxg_gtk_button_box_set_layout_w, 2, 0, 0, H_gtk_button_box_set_layout, pl_tug);
  Xg_define_procedure(gtk_button_box_set_child_secondary, gxg_gtk_button_box_set_child_secondary_w, 3, 0, 0, H_gtk_button_box_set_child_secondary, pl_tuub);
  Xg_define_procedure(gtk_binding_set_new, gxg_gtk_binding_set_new_w, 1, 0, 0, H_gtk_binding_set_new, pl_ps);
  Xg_define_procedure(gtk_binding_set_by_class, gxg_gtk_binding_set_by_class_w, 1, 0, 0, H_gtk_binding_set_by_class, pl_pt);
  Xg_define_procedure(gtk_binding_set_find, gxg_gtk_binding_set_find_w, 1, 0, 0, H_gtk_binding_set_find, pl_ps);
  Xg_define_procedure(gtk_binding_entry_remove, gxg_gtk_binding_entry_remove_w, 3, 0, 0, H_gtk_binding_entry_remove, pl_tuig);
  Xg_define_procedure(gtk_bin_get_child, gxg_gtk_bin_get_child_w, 1, 0, 0, H_gtk_bin_get_child, pl_pu);
  Xg_define_procedure(gtk_box_set_homogeneous, gxg_gtk_box_set_homogeneous_w, 2, 0, 0, H_gtk_box_set_homogeneous, pl_tub);
  Xg_define_procedure(gtk_box_get_homogeneous, gxg_gtk_box_get_homogeneous_w, 1, 0, 0, H_gtk_box_get_homogeneous, pl_bu);
  Xg_define_procedure(gtk_box_set_spacing, gxg_gtk_box_set_spacing_w, 2, 0, 0, H_gtk_box_set_spacing, pl_tui);
  Xg_define_procedure(gtk_box_get_spacing, gxg_gtk_box_get_spacing_w, 1, 0, 0, H_gtk_box_get_spacing, pl_iu);
  Xg_define_procedure(gtk_box_reorder_child, gxg_gtk_box_reorder_child_w, 3, 0, 0, H_gtk_box_reorder_child, pl_tuui);
  Xg_define_procedure(gtk_button_new, gxg_gtk_button_new_w, 0, 0, 0, H_gtk_button_new, pl_p);
  Xg_define_procedure(gtk_button_new_with_label, gxg_gtk_button_new_with_label_w, 1, 0, 0, H_gtk_button_new_with_label, pl_ps);
  Xg_define_procedure(gtk_button_new_with_mnemonic, gxg_gtk_button_new_with_mnemonic_w, 1, 0, 0, H_gtk_button_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_button_clicked, gxg_gtk_button_clicked_w, 1, 0, 0, H_gtk_button_clicked, pl_tu);
  Xg_define_procedure(gtk_button_set_relief, gxg_gtk_button_set_relief_w, 2, 0, 0, H_gtk_button_set_relief, pl_tug);
  Xg_define_procedure(gtk_button_get_relief, gxg_gtk_button_get_relief_w, 1, 0, 0, H_gtk_button_get_relief, pl_gu);
  Xg_define_procedure(gtk_button_set_label, gxg_gtk_button_set_label_w, 2, 0, 0, H_gtk_button_set_label, pl_tus);
  Xg_define_procedure(gtk_button_get_label, gxg_gtk_button_get_label_w, 1, 0, 0, H_gtk_button_get_label, pl_su);
  Xg_define_procedure(gtk_button_set_use_underline, gxg_gtk_button_set_use_underline_w, 2, 0, 0, H_gtk_button_set_use_underline, pl_tub);
  Xg_define_procedure(gtk_button_get_use_underline, gxg_gtk_button_get_use_underline_w, 1, 0, 0, H_gtk_button_get_use_underline, pl_bu);
  Xg_define_procedure(gtk_calendar_new, gxg_gtk_calendar_new_w, 0, 0, 0, H_gtk_calendar_new, pl_p);
  Xg_define_procedure(gtk_calendar_select_day, gxg_gtk_calendar_select_day_w, 2, 0, 0, H_gtk_calendar_select_day, pl_tui);
  Xg_define_procedure(gtk_calendar_clear_marks, gxg_gtk_calendar_clear_marks_w, 1, 0, 0, H_gtk_calendar_clear_marks, pl_tu);
  Xg_define_procedure(gtk_calendar_get_date, gxg_gtk_calendar_get_date_w, 1, 3, 0, H_gtk_calendar_get_date, pl_pu);
  Xg_define_procedure(gtk_cell_editable_start_editing, gxg_gtk_cell_editable_start_editing_w, 2, 0, 0, H_gtk_cell_editable_start_editing, pl_tu);
  Xg_define_procedure(gtk_cell_editable_editing_done, gxg_gtk_cell_editable_editing_done_w, 1, 0, 0, H_gtk_cell_editable_editing_done, pl_tu);
  Xg_define_procedure(gtk_cell_editable_remove_widget, gxg_gtk_cell_editable_remove_widget_w, 1, 0, 0, H_gtk_cell_editable_remove_widget, pl_tu);
  Xg_define_procedure(gtk_cell_renderer_activate, gxg_gtk_cell_renderer_activate_w, 7, 0, 0, H_gtk_cell_renderer_activate, pl_buuusuug);
  Xg_define_procedure(gtk_cell_renderer_start_editing, gxg_gtk_cell_renderer_start_editing_w, 7, 0, 0, H_gtk_cell_renderer_start_editing, pl_puuusuug);
  Xg_define_procedure(gtk_cell_renderer_set_fixed_size, gxg_gtk_cell_renderer_set_fixed_size_w, 3, 0, 0, H_gtk_cell_renderer_set_fixed_size, pl_tui);
  Xg_define_procedure(gtk_cell_renderer_get_fixed_size, gxg_gtk_cell_renderer_get_fixed_size_w, 1, 2, 0, H_gtk_cell_renderer_get_fixed_size, pl_pu);
  Xg_define_procedure(gtk_cell_renderer_pixbuf_new, gxg_gtk_cell_renderer_pixbuf_new_w, 0, 0, 0, H_gtk_cell_renderer_pixbuf_new, pl_p);
  Xg_define_procedure(gtk_cell_renderer_text_new, gxg_gtk_cell_renderer_text_new_w, 0, 0, 0, H_gtk_cell_renderer_text_new, pl_p);
  Xg_define_procedure(gtk_cell_renderer_text_set_fixed_height_from_font, gxg_gtk_cell_renderer_text_set_fixed_height_from_font_w, 2, 0, 0, H_gtk_cell_renderer_text_set_fixed_height_from_font, pl_tui);
  Xg_define_procedure(gtk_cell_renderer_toggle_new, gxg_gtk_cell_renderer_toggle_new_w, 0, 0, 0, H_gtk_cell_renderer_toggle_new, pl_p);
  Xg_define_procedure(gtk_cell_renderer_toggle_get_radio, gxg_gtk_cell_renderer_toggle_get_radio_w, 1, 0, 0, H_gtk_cell_renderer_toggle_get_radio, pl_bu);
  Xg_define_procedure(gtk_cell_renderer_toggle_set_radio, gxg_gtk_cell_renderer_toggle_set_radio_w, 2, 0, 0, H_gtk_cell_renderer_toggle_set_radio, pl_tub);
  Xg_define_procedure(gtk_cell_renderer_toggle_get_active, gxg_gtk_cell_renderer_toggle_get_active_w, 1, 0, 0, H_gtk_cell_renderer_toggle_get_active, pl_bu);
  Xg_define_procedure(gtk_cell_renderer_toggle_set_active, gxg_gtk_cell_renderer_toggle_set_active_w, 2, 0, 0, H_gtk_cell_renderer_toggle_set_active, pl_tub);
  Xg_define_procedure(gtk_check_button_new, gxg_gtk_check_button_new_w, 0, 0, 0, H_gtk_check_button_new, pl_p);
  Xg_define_procedure(gtk_check_button_new_with_label, gxg_gtk_check_button_new_with_label_w, 1, 0, 0, H_gtk_check_button_new_with_label, pl_ps);
  Xg_define_procedure(gtk_check_button_new_with_mnemonic, gxg_gtk_check_button_new_with_mnemonic_w, 1, 0, 0, H_gtk_check_button_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_check_menu_item_new, gxg_gtk_check_menu_item_new_w, 0, 0, 0, H_gtk_check_menu_item_new, pl_p);
  Xg_define_procedure(gtk_check_menu_item_new_with_label, gxg_gtk_check_menu_item_new_with_label_w, 1, 0, 0, H_gtk_check_menu_item_new_with_label, pl_ps);
  Xg_define_procedure(gtk_check_menu_item_new_with_mnemonic, gxg_gtk_check_menu_item_new_with_mnemonic_w, 1, 0, 0, H_gtk_check_menu_item_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_check_menu_item_set_active, gxg_gtk_check_menu_item_set_active_w, 2, 0, 0, H_gtk_check_menu_item_set_active, pl_tub);
  Xg_define_procedure(gtk_check_menu_item_get_active, gxg_gtk_check_menu_item_get_active_w, 1, 0, 0, H_gtk_check_menu_item_get_active, pl_bu);
  Xg_define_procedure(gtk_check_menu_item_toggled, gxg_gtk_check_menu_item_toggled_w, 1, 0, 0, H_gtk_check_menu_item_toggled, pl_tu);
  Xg_define_procedure(gtk_check_menu_item_set_inconsistent, gxg_gtk_check_menu_item_set_inconsistent_w, 2, 0, 0, H_gtk_check_menu_item_set_inconsistent, pl_tub);
  Xg_define_procedure(gtk_check_menu_item_get_inconsistent, gxg_gtk_check_menu_item_get_inconsistent_w, 1, 0, 0, H_gtk_check_menu_item_get_inconsistent, pl_bu);
  Xg_define_procedure(gtk_container_add, gxg_gtk_container_add_w, 2, 0, 0, H_gtk_container_add, pl_tu);
  Xg_define_procedure(gtk_container_remove, gxg_gtk_container_remove_w, 2, 0, 0, H_gtk_container_remove, pl_tu);
  Xg_define_procedure(gtk_container_check_resize, gxg_gtk_container_check_resize_w, 1, 0, 0, H_gtk_container_check_resize, pl_tu);
  Xg_define_procedure(gtk_container_foreach, gxg_gtk_container_foreach_w, 3, 0, 0, H_gtk_container_foreach, pl_tut);
  Xg_define_procedure(gtk_container_get_children, gxg_gtk_container_get_children_w, 1, 0, 0, H_gtk_container_get_children, pl_pu);
  Xg_define_procedure(gtk_dialog_new, gxg_gtk_dialog_new_w, 0, 0, 0, H_gtk_dialog_new, pl_p);
  Xg_define_procedure(gtk_dialog_add_action_widget, gxg_gtk_dialog_add_action_widget_w, 3, 0, 0, H_gtk_dialog_add_action_widget, pl_tuui);
  Xg_define_procedure(gtk_dialog_add_button, gxg_gtk_dialog_add_button_w, 3, 0, 0, H_gtk_dialog_add_button, pl_pusi);
  Xg_define_procedure(gtk_dialog_add_buttons, gxg_gtk_dialog_add_buttons_w, 2, 0, 0, H_gtk_dialog_add_buttons, pl_tut);
  Xg_define_procedure(gtk_dialog_set_response_sensitive, gxg_gtk_dialog_set_response_sensitive_w, 3, 0, 0, H_gtk_dialog_set_response_sensitive, pl_tuib);
  Xg_define_procedure(gtk_dialog_set_default_response, gxg_gtk_dialog_set_default_response_w, 2, 0, 0, H_gtk_dialog_set_default_response, pl_tui);
  Xg_define_procedure(gtk_dialog_response, gxg_gtk_dialog_response_w, 2, 0, 0, H_gtk_dialog_response, pl_tui);
  Xg_define_procedure(gtk_dialog_run, gxg_gtk_dialog_run_w, 1, 0, 0, H_gtk_dialog_run, pl_iu);
  Xg_define_procedure(gtk_drag_get_data, gxg_gtk_drag_get_data_w, 4, 0, 0, H_gtk_drag_get_data, pl_tuuti);
  Xg_define_procedure(gtk_drag_get_source_widget, gxg_gtk_drag_get_source_widget_w, 1, 0, 0, H_gtk_drag_get_source_widget, pl_pu);
  Xg_define_procedure(gtk_drag_highlight, gxg_gtk_drag_highlight_w, 1, 0, 0, H_gtk_drag_highlight, pl_tu);
  Xg_define_procedure(gtk_drag_unhighlight, gxg_gtk_drag_unhighlight_w, 1, 0, 0, H_gtk_drag_unhighlight, pl_tu);
  Xg_define_procedure(gtk_drag_dest_unset, gxg_gtk_drag_dest_unset_w, 1, 0, 0, H_gtk_drag_dest_unset, pl_tu);
  Xg_define_procedure(gtk_drag_source_unset, gxg_gtk_drag_source_unset_w, 1, 0, 0, H_gtk_drag_source_unset, pl_tu);
  Xg_define_procedure(gtk_drag_set_icon_widget, gxg_gtk_drag_set_icon_widget_w, 4, 0, 0, H_gtk_drag_set_icon_widget, pl_tuui);
  Xg_define_procedure(gtk_drag_set_icon_default, gxg_gtk_drag_set_icon_default_w, 1, 0, 0, H_gtk_drag_set_icon_default, pl_tu);
  Xg_define_procedure(gtk_drag_check_threshold, gxg_gtk_drag_check_threshold_w, 5, 0, 0, H_gtk_drag_check_threshold, pl_bui);
  Xg_define_procedure(gtk_drawing_area_new, gxg_gtk_drawing_area_new_w, 0, 0, 0, H_gtk_drawing_area_new, pl_p);
  Xg_define_procedure(gtk_editable_select_region, gxg_gtk_editable_select_region_w, 3, 0, 0, H_gtk_editable_select_region, pl_tui);
  Xg_define_procedure(gtk_editable_get_selection_bounds, gxg_gtk_editable_get_selection_bounds_w, 1, 2, 0, H_gtk_editable_get_selection_bounds, pl_pu);
  Xg_define_procedure(gtk_editable_insert_text, gxg_gtk_editable_insert_text_w, 3, 1, 0, H_gtk_editable_insert_text, pl_pusiu);
  Xg_define_procedure(gtk_editable_delete_text, gxg_gtk_editable_delete_text_w, 3, 0, 0, H_gtk_editable_delete_text, pl_tui);
  Xg_define_procedure(gtk_editable_get_chars, gxg_gtk_editable_get_chars_w, 3, 0, 0, H_gtk_editable_get_chars, pl_sui);
  Xg_define_procedure(gtk_editable_cut_clipboard, gxg_gtk_editable_cut_clipboard_w, 1, 0, 0, H_gtk_editable_cut_clipboard, pl_tu);
  Xg_define_procedure(gtk_editable_copy_clipboard, gxg_gtk_editable_copy_clipboard_w, 1, 0, 0, H_gtk_editable_copy_clipboard, pl_tu);
  Xg_define_procedure(gtk_editable_paste_clipboard, gxg_gtk_editable_paste_clipboard_w, 1, 0, 0, H_gtk_editable_paste_clipboard, pl_tu);
  Xg_define_procedure(gtk_editable_delete_selection, gxg_gtk_editable_delete_selection_w, 1, 0, 0, H_gtk_editable_delete_selection, pl_tu);
  Xg_define_procedure(gtk_editable_set_position, gxg_gtk_editable_set_position_w, 2, 0, 0, H_gtk_editable_set_position, pl_tui);
  Xg_define_procedure(gtk_editable_get_position, gxg_gtk_editable_get_position_w, 1, 0, 0, H_gtk_editable_get_position, pl_iu);
  Xg_define_procedure(gtk_editable_set_editable, gxg_gtk_editable_set_editable_w, 2, 0, 0, H_gtk_editable_set_editable, pl_tub);
  Xg_define_procedure(gtk_editable_get_editable, gxg_gtk_editable_get_editable_w, 1, 0, 0, H_gtk_editable_get_editable, pl_bu);
  Xg_define_procedure(gtk_entry_new, gxg_gtk_entry_new_w, 0, 0, 0, H_gtk_entry_new, pl_p);
  Xg_define_procedure(gtk_entry_set_visibility, gxg_gtk_entry_set_visibility_w, 2, 0, 0, H_gtk_entry_set_visibility, pl_tub);
  Xg_define_procedure(gtk_entry_get_visibility, gxg_gtk_entry_get_visibility_w, 1, 0, 0, H_gtk_entry_get_visibility, pl_bu);
  Xg_define_procedure(gtk_entry_set_invisible_char, gxg_gtk_entry_set_invisible_char_w, 2, 0, 0, H_gtk_entry_set_invisible_char, pl_tui);
  Xg_define_procedure(gtk_entry_get_invisible_char, gxg_gtk_entry_get_invisible_char_w, 1, 0, 0, H_gtk_entry_get_invisible_char, pl_iu);
  Xg_define_procedure(gtk_entry_set_has_frame, gxg_gtk_entry_set_has_frame_w, 2, 0, 0, H_gtk_entry_set_has_frame, pl_tub);
  Xg_define_procedure(gtk_entry_get_has_frame, gxg_gtk_entry_get_has_frame_w, 1, 0, 0, H_gtk_entry_get_has_frame, pl_bu);
  Xg_define_procedure(gtk_entry_set_max_length, gxg_gtk_entry_set_max_length_w, 2, 0, 0, H_gtk_entry_set_max_length, pl_tui);
  Xg_define_procedure(gtk_entry_get_max_length, gxg_gtk_entry_get_max_length_w, 1, 0, 0, H_gtk_entry_get_max_length, pl_iu);
  Xg_define_procedure(gtk_entry_set_activates_default, gxg_gtk_entry_set_activates_default_w, 2, 0, 0, H_gtk_entry_set_activates_default, pl_tub);
  Xg_define_procedure(gtk_entry_get_activates_default, gxg_gtk_entry_get_activates_default_w, 1, 0, 0, H_gtk_entry_get_activates_default, pl_bu);
  Xg_define_procedure(gtk_entry_set_width_chars, gxg_gtk_entry_set_width_chars_w, 2, 0, 0, H_gtk_entry_set_width_chars, pl_tui);
  Xg_define_procedure(gtk_entry_get_width_chars, gxg_gtk_entry_get_width_chars_w, 1, 0, 0, H_gtk_entry_get_width_chars, pl_iu);
  Xg_define_procedure(gtk_entry_set_text, gxg_gtk_entry_set_text_w, 2, 0, 0, H_gtk_entry_set_text, pl_tus);
  Xg_define_procedure(gtk_entry_get_text, gxg_gtk_entry_get_text_w, 1, 0, 0, H_gtk_entry_get_text, pl_su);
  Xg_define_procedure(gtk_entry_get_layout, gxg_gtk_entry_get_layout_w, 1, 0, 0, H_gtk_entry_get_layout, pl_pu);
  Xg_define_procedure(gtk_entry_get_layout_offsets, gxg_gtk_entry_get_layout_offsets_w, 1, 2, 0, H_gtk_entry_get_layout_offsets, pl_pu);
  Xg_define_procedure(gtk_fixed_new, gxg_gtk_fixed_new_w, 0, 0, 0, H_gtk_fixed_new, pl_p);
  Xg_define_procedure(gtk_fixed_put, gxg_gtk_fixed_put_w, 4, 0, 0, H_gtk_fixed_put, pl_tuui);
  Xg_define_procedure(gtk_fixed_move, gxg_gtk_fixed_move_w, 4, 0, 0, H_gtk_fixed_move, pl_tuui);
  Xg_define_procedure(gtk_frame_new, gxg_gtk_frame_new_w, 1, 0, 0, H_gtk_frame_new, pl_ps);
  Xg_define_procedure(gtk_frame_set_label, gxg_gtk_frame_set_label_w, 2, 0, 0, H_gtk_frame_set_label, pl_tus);
  Xg_define_procedure(gtk_frame_get_label, gxg_gtk_frame_get_label_w, 1, 0, 0, H_gtk_frame_get_label, pl_su);
  Xg_define_procedure(gtk_frame_set_label_widget, gxg_gtk_frame_set_label_widget_w, 2, 0, 0, H_gtk_frame_set_label_widget, pl_tu);
  Xg_define_procedure(gtk_frame_get_label_widget, gxg_gtk_frame_get_label_widget_w, 1, 0, 0, H_gtk_frame_get_label_widget, pl_pu);
  Xg_define_procedure(gtk_frame_set_label_align, gxg_gtk_frame_set_label_align_w, 3, 0, 0, H_gtk_frame_set_label_align, pl_tur);
  Xg_define_procedure(gtk_frame_get_label_align, gxg_gtk_frame_get_label_align_w, 1, 2, 0, H_gtk_frame_get_label_align, pl_pu);
  Xg_define_procedure(gtk_frame_set_shadow_type, gxg_gtk_frame_set_shadow_type_w, 2, 0, 0, H_gtk_frame_set_shadow_type, pl_tug);
  Xg_define_procedure(gtk_frame_get_shadow_type, gxg_gtk_frame_get_shadow_type_w, 1, 0, 0, H_gtk_frame_get_shadow_type, pl_gu);
  Xg_define_procedure(gtk_image_new, gxg_gtk_image_new_w, 0, 0, 0, H_gtk_image_new, pl_p);
  Xg_define_procedure(gtk_image_new_from_file, gxg_gtk_image_new_from_file_w, 1, 0, 0, H_gtk_image_new_from_file, pl_ps);
  Xg_define_procedure(gtk_image_new_from_pixbuf, gxg_gtk_image_new_from_pixbuf_w, 1, 0, 0, H_gtk_image_new_from_pixbuf, pl_pu);
  Xg_define_procedure(gtk_image_set_from_file, gxg_gtk_image_set_from_file_w, 2, 0, 0, H_gtk_image_set_from_file, pl_tus);
  Xg_define_procedure(gtk_image_set_from_pixbuf, gxg_gtk_image_set_from_pixbuf_w, 2, 0, 0, H_gtk_image_set_from_pixbuf, pl_tu);
  Xg_define_procedure(gtk_image_get_storage_type, gxg_gtk_image_get_storage_type_w, 1, 0, 0, H_gtk_image_get_storage_type, pl_gu);
  Xg_define_procedure(gtk_im_context_get_preedit_string, gxg_gtk_im_context_get_preedit_string_w, 1, 3, 0, H_gtk_im_context_get_preedit_string, pl_pu);
  Xg_define_procedure(gtk_im_context_filter_keypress, gxg_gtk_im_context_filter_keypress_w, 2, 0, 0, H_gtk_im_context_filter_keypress, pl_bu);
  Xg_define_procedure(gtk_im_context_focus_in, gxg_gtk_im_context_focus_in_w, 1, 0, 0, H_gtk_im_context_focus_in, pl_tu);
  Xg_define_procedure(gtk_im_context_focus_out, gxg_gtk_im_context_focus_out_w, 1, 0, 0, H_gtk_im_context_focus_out, pl_tu);
  Xg_define_procedure(gtk_im_context_reset, gxg_gtk_im_context_reset_w, 1, 0, 0, H_gtk_im_context_reset, pl_tu);
  Xg_define_procedure(gtk_im_context_set_cursor_location, gxg_gtk_im_context_set_cursor_location_w, 2, 0, 0, H_gtk_im_context_set_cursor_location, pl_tu);
  Xg_define_procedure(gtk_im_context_set_use_preedit, gxg_gtk_im_context_set_use_preedit_w, 2, 0, 0, H_gtk_im_context_set_use_preedit, pl_tub);
  Xg_define_procedure(gtk_im_context_set_surrounding, gxg_gtk_im_context_set_surrounding_w, 4, 0, 0, H_gtk_im_context_set_surrounding, pl_tusi);
  Xg_define_procedure(gtk_im_context_get_surrounding, gxg_gtk_im_context_get_surrounding_w, 1, 2, 0, H_gtk_im_context_get_surrounding, pl_pu);
  Xg_define_procedure(gtk_im_context_delete_surrounding, gxg_gtk_im_context_delete_surrounding_w, 3, 0, 0, H_gtk_im_context_delete_surrounding, pl_bui);
  Xg_define_procedure(gtk_im_context_simple_new, gxg_gtk_im_context_simple_new_w, 0, 0, 0, H_gtk_im_context_simple_new, pl_p);
  Xg_define_procedure(gtk_im_context_simple_add_table, gxg_gtk_im_context_simple_add_table_w, 4, 0, 0, H_gtk_im_context_simple_add_table, pl_tuui);
  Xg_define_procedure(gtk_invisible_new, gxg_gtk_invisible_new_w, 0, 0, 0, H_gtk_invisible_new, pl_p);
  Xg_define_procedure(gtk_label_new, gxg_gtk_label_new_w, 1, 0, 0, H_gtk_label_new, pl_ps);
  Xg_define_procedure(gtk_label_new_with_mnemonic, gxg_gtk_label_new_with_mnemonic_w, 1, 0, 0, H_gtk_label_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_label_set_text, gxg_gtk_label_set_text_w, 2, 0, 0, H_gtk_label_set_text, pl_tus);
  Xg_define_procedure(gtk_label_get_text, gxg_gtk_label_get_text_w, 1, 0, 0, H_gtk_label_get_text, pl_su);
  Xg_define_procedure(gtk_label_set_attributes, gxg_gtk_label_set_attributes_w, 2, 0, 0, H_gtk_label_set_attributes, pl_tu);
  Xg_define_procedure(gtk_label_get_attributes, gxg_gtk_label_get_attributes_w, 1, 0, 0, H_gtk_label_get_attributes, pl_pu);
  Xg_define_procedure(gtk_label_set_label, gxg_gtk_label_set_label_w, 2, 0, 0, H_gtk_label_set_label, pl_tus);
  Xg_define_procedure(gtk_label_get_label, gxg_gtk_label_get_label_w, 1, 0, 0, H_gtk_label_get_label, pl_su);
  Xg_define_procedure(gtk_label_set_markup, gxg_gtk_label_set_markup_w, 2, 0, 0, H_gtk_label_set_markup, pl_tus);
  Xg_define_procedure(gtk_label_set_use_markup, gxg_gtk_label_set_use_markup_w, 2, 0, 0, H_gtk_label_set_use_markup, pl_tub);
  Xg_define_procedure(gtk_label_get_use_markup, gxg_gtk_label_get_use_markup_w, 1, 0, 0, H_gtk_label_get_use_markup, pl_bu);
  Xg_define_procedure(gtk_label_set_use_underline, gxg_gtk_label_set_use_underline_w, 2, 0, 0, H_gtk_label_set_use_underline, pl_tub);
  Xg_define_procedure(gtk_label_get_use_underline, gxg_gtk_label_get_use_underline_w, 1, 0, 0, H_gtk_label_get_use_underline, pl_bu);
  Xg_define_procedure(gtk_label_set_markup_with_mnemonic, gxg_gtk_label_set_markup_with_mnemonic_w, 2, 0, 0, H_gtk_label_set_markup_with_mnemonic, pl_tus);
  Xg_define_procedure(gtk_label_get_mnemonic_keyval, gxg_gtk_label_get_mnemonic_keyval_w, 1, 0, 0, H_gtk_label_get_mnemonic_keyval, pl_iu);
  Xg_define_procedure(gtk_label_set_mnemonic_widget, gxg_gtk_label_set_mnemonic_widget_w, 2, 0, 0, H_gtk_label_set_mnemonic_widget, pl_tu);
  Xg_define_procedure(gtk_label_get_mnemonic_widget, gxg_gtk_label_get_mnemonic_widget_w, 1, 0, 0, H_gtk_label_get_mnemonic_widget, pl_pu);
  Xg_define_procedure(gtk_label_set_text_with_mnemonic, gxg_gtk_label_set_text_with_mnemonic_w, 2, 0, 0, H_gtk_label_set_text_with_mnemonic, pl_tus);
  Xg_define_procedure(gtk_label_set_justify, gxg_gtk_label_set_justify_w, 2, 0, 0, H_gtk_label_set_justify, pl_tug);
  Xg_define_procedure(gtk_label_get_justify, gxg_gtk_label_get_justify_w, 1, 0, 0, H_gtk_label_get_justify, pl_gu);
  Xg_define_procedure(gtk_label_set_pattern, gxg_gtk_label_set_pattern_w, 2, 0, 0, H_gtk_label_set_pattern, pl_tus);
  Xg_define_procedure(gtk_label_set_line_wrap, gxg_gtk_label_set_line_wrap_w, 2, 0, 0, H_gtk_label_set_line_wrap, pl_tub);
  Xg_define_procedure(gtk_label_get_line_wrap, gxg_gtk_label_get_line_wrap_w, 1, 0, 0, H_gtk_label_get_line_wrap, pl_bu);
  Xg_define_procedure(gtk_label_set_selectable, gxg_gtk_label_set_selectable_w, 2, 0, 0, H_gtk_label_set_selectable, pl_tub);
  Xg_define_procedure(gtk_label_get_selectable, gxg_gtk_label_get_selectable_w, 1, 0, 0, H_gtk_label_get_selectable, pl_bu);
  Xg_define_procedure(gtk_label_select_region, gxg_gtk_label_select_region_w, 3, 0, 0, H_gtk_label_select_region, pl_tui);
  Xg_define_procedure(gtk_label_get_selection_bounds, gxg_gtk_label_get_selection_bounds_w, 1, 2, 0, H_gtk_label_get_selection_bounds, pl_pu);
  Xg_define_procedure(gtk_label_get_layout, gxg_gtk_label_get_layout_w, 1, 0, 0, H_gtk_label_get_layout, pl_pu);
  Xg_define_procedure(gtk_label_get_layout_offsets, gxg_gtk_label_get_layout_offsets_w, 1, 2, 0, H_gtk_label_get_layout_offsets, pl_pu);
  Xg_define_procedure(gtk_layout_new, gxg_gtk_layout_new_w, 2, 0, 0, H_gtk_layout_new, pl_pu);
  Xg_define_procedure(gtk_layout_put, gxg_gtk_layout_put_w, 4, 0, 0, H_gtk_layout_put, pl_tuui);
  Xg_define_procedure(gtk_layout_move, gxg_gtk_layout_move_w, 4, 0, 0, H_gtk_layout_move, pl_tuui);
  Xg_define_procedure(gtk_layout_set_size, gxg_gtk_layout_set_size_w, 3, 0, 0, H_gtk_layout_set_size, pl_tui);
  Xg_define_procedure(gtk_layout_get_size, gxg_gtk_layout_get_size_w, 1, 2, 0, H_gtk_layout_get_size, pl_pu);
  Xg_define_procedure(gtk_list_store_new, gxg_gtk_list_store_new_w, 2, 0, 0, H_gtk_list_store_new, pl_pit);
  Xg_define_procedure(gtk_list_store_newv, gxg_gtk_list_store_newv_w, 2, 0, 0, H_gtk_list_store_newv, pl_piu);
  Xg_define_procedure(gtk_list_store_set_column_types, gxg_gtk_list_store_set_column_types_w, 3, 0, 0, H_gtk_list_store_set_column_types, pl_tuiu);
  Xg_define_procedure(gtk_list_store_set, gxg_gtk_list_store_set_w, 3, 0, 0, H_gtk_list_store_set, pl_tuut);
  Xg_define_procedure(gtk_list_store_insert, gxg_gtk_list_store_insert_w, 3, 0, 0, H_gtk_list_store_insert, pl_tuui);
  Xg_define_procedure(gtk_list_store_insert_before, gxg_gtk_list_store_insert_before_w, 3, 0, 0, H_gtk_list_store_insert_before, pl_tu);
  Xg_define_procedure(gtk_list_store_insert_after, gxg_gtk_list_store_insert_after_w, 3, 0, 0, H_gtk_list_store_insert_after, pl_tu);
  Xg_define_procedure(gtk_list_store_prepend, gxg_gtk_list_store_prepend_w, 2, 0, 0, H_gtk_list_store_prepend, pl_tu);
  Xg_define_procedure(gtk_list_store_append, gxg_gtk_list_store_append_w, 2, 0, 0, H_gtk_list_store_append, pl_tu);
  Xg_define_procedure(gtk_list_store_clear, gxg_gtk_list_store_clear_w, 1, 0, 0, H_gtk_list_store_clear, pl_tu);
  Xg_define_procedure(gtk_check_version, gxg_gtk_check_version_w, 3, 0, 0, H_gtk_check_version, pl_si);
  Xg_define_procedure(gtk_disable_setlocale, gxg_gtk_disable_setlocale_w, 0, 0, 0, H_gtk_disable_setlocale, pl_t);
  Xg_define_procedure(gtk_get_default_language, gxg_gtk_get_default_language_w, 0, 0, 0, H_gtk_get_default_language, pl_p);
  Xg_define_procedure(gtk_events_pending, gxg_gtk_events_pending_w, 0, 0, 0, H_gtk_events_pending, pl_i);
  Xg_define_procedure(gtk_main_do_event, gxg_gtk_main_do_event_w, 1, 0, 0, H_gtk_main_do_event, pl_tu);
  Xg_define_procedure(gtk_main, gxg_gtk_main_w, 0, 0, 0, H_gtk_main, pl_t);
  Xg_define_procedure(gtk_main_level, gxg_gtk_main_level_w, 0, 0, 0, H_gtk_main_level, pl_i);
  Xg_define_procedure(gtk_main_quit, gxg_gtk_main_quit_w, 0, 0, 0, H_gtk_main_quit, pl_t);
  Xg_define_procedure(gtk_main_iteration, gxg_gtk_main_iteration_w, 0, 0, 0, H_gtk_main_iteration, pl_b);
  Xg_define_procedure(gtk_main_iteration_do, gxg_gtk_main_iteration_do_w, 1, 0, 0, H_gtk_main_iteration_do, pl_b);
  Xg_define_procedure(gtk_true, gxg_gtk_true_w, 0, 0, 0, H_gtk_true, pl_b);
  Xg_define_procedure(gtk_false, gxg_gtk_false_w, 0, 0, 0, H_gtk_false, pl_b);
  Xg_define_procedure(gtk_grab_add, gxg_gtk_grab_add_w, 1, 0, 0, H_gtk_grab_add, pl_tu);
  Xg_define_procedure(gtk_grab_get_current, gxg_gtk_grab_get_current_w, 0, 0, 0, H_gtk_grab_get_current, pl_p);
  Xg_define_procedure(gtk_grab_remove, gxg_gtk_grab_remove_w, 1, 0, 0, H_gtk_grab_remove, pl_tu);
  Xg_define_procedure(gtk_get_current_event, gxg_gtk_get_current_event_w, 0, 0, 0, H_gtk_get_current_event, pl_p);
  Xg_define_procedure(gtk_get_current_event_time, gxg_gtk_get_current_event_time_w, 0, 0, 0, H_gtk_get_current_event_time, pl_i);
  Xg_define_procedure(gtk_get_current_event_state, gxg_gtk_get_current_event_state_w, 0, 1, 0, H_gtk_get_current_event_state, pl_pu);
  Xg_define_procedure(gtk_get_event_widget, gxg_gtk_get_event_widget_w, 1, 0, 0, H_gtk_get_event_widget, pl_pu);
  Xg_define_procedure(gtk_propagate_event, gxg_gtk_propagate_event_w, 2, 0, 0, H_gtk_propagate_event, pl_tu);
  Xg_define_procedure(gtk_menu_bar_new, gxg_gtk_menu_bar_new_w, 0, 0, 0, H_gtk_menu_bar_new, pl_p);
  Xg_define_procedure(gtk_menu_new, gxg_gtk_menu_new_w, 0, 0, 0, H_gtk_menu_new, pl_p);
  Xg_define_procedure(gtk_menu_reposition, gxg_gtk_menu_reposition_w, 1, 0, 0, H_gtk_menu_reposition, pl_tu);
  Xg_define_procedure(gtk_menu_popdown, gxg_gtk_menu_popdown_w, 1, 0, 0, H_gtk_menu_popdown, pl_tu);
  Xg_define_procedure(gtk_menu_get_active, gxg_gtk_menu_get_active_w, 1, 0, 0, H_gtk_menu_get_active, pl_pu);
  Xg_define_procedure(gtk_menu_set_active, gxg_gtk_menu_set_active_w, 2, 0, 0, H_gtk_menu_set_active, pl_tui);
  Xg_define_procedure(gtk_menu_set_accel_group, gxg_gtk_menu_set_accel_group_w, 2, 0, 0, H_gtk_menu_set_accel_group, pl_tu);
  Xg_define_procedure(gtk_menu_get_accel_group, gxg_gtk_menu_get_accel_group_w, 1, 0, 0, H_gtk_menu_get_accel_group, pl_pu);
  Xg_define_procedure(gtk_menu_set_accel_path, gxg_gtk_menu_set_accel_path_w, 2, 0, 0, H_gtk_menu_set_accel_path, pl_tus);
  Xg_define_procedure(gtk_menu_detach, gxg_gtk_menu_detach_w, 1, 0, 0, H_gtk_menu_detach, pl_tu);
  Xg_define_procedure(gtk_menu_get_attach_widget, gxg_gtk_menu_get_attach_widget_w, 1, 0, 0, H_gtk_menu_get_attach_widget, pl_pu);
  Xg_define_procedure(gtk_menu_reorder_child, gxg_gtk_menu_reorder_child_w, 3, 0, 0, H_gtk_menu_reorder_child, pl_tuui);
  Xg_define_procedure(gtk_menu_set_monitor, gxg_gtk_menu_set_monitor_w, 2, 0, 0, H_gtk_menu_set_monitor, pl_tui);
  Xg_define_procedure(gtk_menu_item_new, gxg_gtk_menu_item_new_w, 0, 0, 0, H_gtk_menu_item_new, pl_p);
  Xg_define_procedure(gtk_menu_item_new_with_label, gxg_gtk_menu_item_new_with_label_w, 1, 0, 0, H_gtk_menu_item_new_with_label, pl_ps);
  Xg_define_procedure(gtk_menu_item_new_with_mnemonic, gxg_gtk_menu_item_new_with_mnemonic_w, 1, 0, 0, H_gtk_menu_item_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_menu_item_set_submenu, gxg_gtk_menu_item_set_submenu_w, 2, 0, 0, H_gtk_menu_item_set_submenu, pl_tu);
  Xg_define_procedure(gtk_menu_item_get_submenu, gxg_gtk_menu_item_get_submenu_w, 1, 0, 0, H_gtk_menu_item_get_submenu, pl_pu);
  Xg_define_procedure(gtk_menu_item_select, gxg_gtk_menu_item_select_w, 1, 0, 0, H_gtk_menu_item_select, pl_tu);
  Xg_define_procedure(gtk_menu_item_deselect, gxg_gtk_menu_item_deselect_w, 1, 0, 0, H_gtk_menu_item_deselect, pl_tu);
  Xg_define_procedure(gtk_menu_item_activate, gxg_gtk_menu_item_activate_w, 1, 0, 0, H_gtk_menu_item_activate, pl_tu);
  Xg_define_procedure(gtk_menu_item_toggle_size_request, gxg_gtk_menu_item_toggle_size_request_w, 2, 0, 0, H_gtk_menu_item_toggle_size_request, pl_tu);
  Xg_define_procedure(gtk_menu_item_toggle_size_allocate, gxg_gtk_menu_item_toggle_size_allocate_w, 2, 0, 0, H_gtk_menu_item_toggle_size_allocate, pl_tui);
  Xg_define_procedure(gtk_menu_item_set_accel_path, gxg_gtk_menu_item_set_accel_path_w, 2, 0, 0, H_gtk_menu_item_set_accel_path, pl_tus);
  Xg_define_procedure(gtk_menu_shell_append, gxg_gtk_menu_shell_append_w, 2, 0, 0, H_gtk_menu_shell_append, pl_tu);
  Xg_define_procedure(gtk_menu_shell_prepend, gxg_gtk_menu_shell_prepend_w, 2, 0, 0, H_gtk_menu_shell_prepend, pl_tu);
  Xg_define_procedure(gtk_menu_shell_insert, gxg_gtk_menu_shell_insert_w, 3, 0, 0, H_gtk_menu_shell_insert, pl_tuui);
  Xg_define_procedure(gtk_menu_shell_deactivate, gxg_gtk_menu_shell_deactivate_w, 1, 0, 0, H_gtk_menu_shell_deactivate, pl_tu);
  Xg_define_procedure(gtk_menu_shell_select_item, gxg_gtk_menu_shell_select_item_w, 2, 0, 0, H_gtk_menu_shell_select_item, pl_tu);
  Xg_define_procedure(gtk_menu_shell_deselect, gxg_gtk_menu_shell_deselect_w, 1, 0, 0, H_gtk_menu_shell_deselect, pl_tu);
  Xg_define_procedure(gtk_menu_shell_activate_item, gxg_gtk_menu_shell_activate_item_w, 3, 0, 0, H_gtk_menu_shell_activate_item, pl_tuub);
  Xg_define_procedure(gtk_notebook_new, gxg_gtk_notebook_new_w, 0, 0, 0, H_gtk_notebook_new, pl_p);
  Xg_define_procedure(gtk_notebook_remove_page, gxg_gtk_notebook_remove_page_w, 2, 0, 0, H_gtk_notebook_remove_page, pl_tui);
  Xg_define_procedure(gtk_notebook_get_current_page, gxg_gtk_notebook_get_current_page_w, 1, 0, 0, H_gtk_notebook_get_current_page, pl_iu);
  Xg_define_procedure(gtk_notebook_get_nth_page, gxg_gtk_notebook_get_nth_page_w, 2, 0, 0, H_gtk_notebook_get_nth_page, pl_pui);
  Xg_define_procedure(gtk_notebook_page_num, gxg_gtk_notebook_page_num_w, 2, 0, 0, H_gtk_notebook_page_num, pl_iu);
  Xg_define_procedure(gtk_notebook_set_current_page, gxg_gtk_notebook_set_current_page_w, 2, 0, 0, H_gtk_notebook_set_current_page, pl_tui);
  Xg_define_procedure(gtk_notebook_next_page, gxg_gtk_notebook_next_page_w, 1, 0, 0, H_gtk_notebook_next_page, pl_tu);
  Xg_define_procedure(gtk_notebook_prev_page, gxg_gtk_notebook_prev_page_w, 1, 0, 0, H_gtk_notebook_prev_page, pl_tu);
  Xg_define_procedure(gtk_notebook_set_show_border, gxg_gtk_notebook_set_show_border_w, 2, 0, 0, H_gtk_notebook_set_show_border, pl_tub);
  Xg_define_procedure(gtk_notebook_get_show_border, gxg_gtk_notebook_get_show_border_w, 1, 0, 0, H_gtk_notebook_get_show_border, pl_bu);
  Xg_define_procedure(gtk_notebook_set_show_tabs, gxg_gtk_notebook_set_show_tabs_w, 2, 0, 0, H_gtk_notebook_set_show_tabs, pl_tub);
  Xg_define_procedure(gtk_notebook_get_show_tabs, gxg_gtk_notebook_get_show_tabs_w, 1, 0, 0, H_gtk_notebook_get_show_tabs, pl_bu);
  Xg_define_procedure(gtk_notebook_set_tab_pos, gxg_gtk_notebook_set_tab_pos_w, 2, 0, 0, H_gtk_notebook_set_tab_pos, pl_tug);
  Xg_define_procedure(gtk_notebook_get_tab_pos, gxg_gtk_notebook_get_tab_pos_w, 1, 0, 0, H_gtk_notebook_get_tab_pos, pl_gu);
  Xg_define_procedure(gtk_notebook_set_scrollable, gxg_gtk_notebook_set_scrollable_w, 2, 0, 0, H_gtk_notebook_set_scrollable, pl_tub);
  Xg_define_procedure(gtk_notebook_get_scrollable, gxg_gtk_notebook_get_scrollable_w, 1, 0, 0, H_gtk_notebook_get_scrollable, pl_bu);
  Xg_define_procedure(gtk_notebook_popup_enable, gxg_gtk_notebook_popup_enable_w, 1, 0, 0, H_gtk_notebook_popup_enable, pl_tu);
  Xg_define_procedure(gtk_notebook_popup_disable, gxg_gtk_notebook_popup_disable_w, 1, 0, 0, H_gtk_notebook_popup_disable, pl_tu);
  Xg_define_procedure(gtk_notebook_get_tab_label, gxg_gtk_notebook_get_tab_label_w, 2, 0, 0, H_gtk_notebook_get_tab_label, pl_pu);
  Xg_define_procedure(gtk_notebook_set_tab_label, gxg_gtk_notebook_set_tab_label_w, 3, 0, 0, H_gtk_notebook_set_tab_label, pl_tu);
  Xg_define_procedure(gtk_notebook_set_tab_label_text, gxg_gtk_notebook_set_tab_label_text_w, 3, 0, 0, H_gtk_notebook_set_tab_label_text, pl_tuus);
  Xg_define_procedure(gtk_notebook_get_tab_label_text, gxg_gtk_notebook_get_tab_label_text_w, 2, 0, 0, H_gtk_notebook_get_tab_label_text, pl_su);
  Xg_define_procedure(gtk_notebook_get_menu_label, gxg_gtk_notebook_get_menu_label_w, 2, 0, 0, H_gtk_notebook_get_menu_label, pl_pu);
  Xg_define_procedure(gtk_notebook_set_menu_label, gxg_gtk_notebook_set_menu_label_w, 3, 0, 0, H_gtk_notebook_set_menu_label, pl_tu);
  Xg_define_procedure(gtk_notebook_set_menu_label_text, gxg_gtk_notebook_set_menu_label_text_w, 3, 0, 0, H_gtk_notebook_set_menu_label_text, pl_tuus);
  Xg_define_procedure(gtk_notebook_get_menu_label_text, gxg_gtk_notebook_get_menu_label_text_w, 2, 0, 0, H_gtk_notebook_get_menu_label_text, pl_su);
  Xg_define_procedure(gtk_notebook_reorder_child, gxg_gtk_notebook_reorder_child_w, 3, 0, 0, H_gtk_notebook_reorder_child, pl_tuui);
  Xg_define_procedure(gtk_notebook_append_page, gxg_gtk_notebook_append_page_w, 3, 0, 0, H_gtk_notebook_append_page, pl_iu);
  Xg_define_procedure(gtk_notebook_append_page_menu, gxg_gtk_notebook_append_page_menu_w, 4, 0, 0, H_gtk_notebook_append_page_menu, pl_iu);
  Xg_define_procedure(gtk_notebook_prepend_page, gxg_gtk_notebook_prepend_page_w, 3, 0, 0, H_gtk_notebook_prepend_page, pl_iu);
  Xg_define_procedure(gtk_notebook_prepend_page_menu, gxg_gtk_notebook_prepend_page_menu_w, 4, 0, 0, H_gtk_notebook_prepend_page_menu, pl_iu);
  Xg_define_procedure(gtk_notebook_insert_page, gxg_gtk_notebook_insert_page_w, 4, 0, 0, H_gtk_notebook_insert_page, pl_iuuui);
  Xg_define_procedure(gtk_notebook_insert_page_menu, gxg_gtk_notebook_insert_page_menu_w, 5, 0, 0, H_gtk_notebook_insert_page_menu, pl_iuuuui);
  Xg_define_procedure(gtk_paned_add1, gxg_gtk_paned_add1_w, 2, 0, 0, H_gtk_paned_add1, pl_tu);
  Xg_define_procedure(gtk_paned_add2, gxg_gtk_paned_add2_w, 2, 0, 0, H_gtk_paned_add2, pl_tu);
  Xg_define_procedure(gtk_paned_pack1, gxg_gtk_paned_pack1_w, 4, 0, 0, H_gtk_paned_pack1, pl_tuub);
  Xg_define_procedure(gtk_paned_pack2, gxg_gtk_paned_pack2_w, 4, 0, 0, H_gtk_paned_pack2, pl_tuub);
  Xg_define_procedure(gtk_paned_get_position, gxg_gtk_paned_get_position_w, 1, 0, 0, H_gtk_paned_get_position, pl_iu);
  Xg_define_procedure(gtk_paned_set_position, gxg_gtk_paned_set_position_w, 2, 0, 0, H_gtk_paned_set_position, pl_tui);
  Xg_define_procedure(gtk_progress_bar_new, gxg_gtk_progress_bar_new_w, 0, 0, 0, H_gtk_progress_bar_new, pl_p);
  Xg_define_procedure(gtk_progress_bar_pulse, gxg_gtk_progress_bar_pulse_w, 1, 0, 0, H_gtk_progress_bar_pulse, pl_tu);
  Xg_define_procedure(gtk_progress_bar_set_text, gxg_gtk_progress_bar_set_text_w, 2, 0, 0, H_gtk_progress_bar_set_text, pl_tus);
  Xg_define_procedure(gtk_progress_bar_set_fraction, gxg_gtk_progress_bar_set_fraction_w, 2, 0, 0, H_gtk_progress_bar_set_fraction, pl_tur);
  Xg_define_procedure(gtk_progress_bar_set_pulse_step, gxg_gtk_progress_bar_set_pulse_step_w, 2, 0, 0, H_gtk_progress_bar_set_pulse_step, pl_tur);
  Xg_define_procedure(gtk_progress_bar_get_text, gxg_gtk_progress_bar_get_text_w, 1, 0, 0, H_gtk_progress_bar_get_text, pl_su);
  Xg_define_procedure(gtk_progress_bar_get_fraction, gxg_gtk_progress_bar_get_fraction_w, 1, 0, 0, H_gtk_progress_bar_get_fraction, pl_du);
  Xg_define_procedure(gtk_progress_bar_get_pulse_step, gxg_gtk_progress_bar_get_pulse_step_w, 1, 0, 0, H_gtk_progress_bar_get_pulse_step, pl_du);
  Xg_define_procedure(gtk_radio_button_new, gxg_gtk_radio_button_new_w, 1, 0, 0, H_gtk_radio_button_new, pl_pu);
  Xg_define_procedure(gtk_radio_button_new_from_widget, gxg_gtk_radio_button_new_from_widget_w, 1, 0, 0, H_gtk_radio_button_new_from_widget, pl_pu);
  Xg_define_procedure(gtk_radio_button_new_with_label, gxg_gtk_radio_button_new_with_label_w, 2, 0, 0, H_gtk_radio_button_new_with_label, pl_pus);
  Xg_define_procedure(gtk_radio_button_new_with_label_from_widget, gxg_gtk_radio_button_new_with_label_from_widget_w, 2, 0, 0, H_gtk_radio_button_new_with_label_from_widget, pl_pus);
  Xg_define_procedure(gtk_radio_button_new_with_mnemonic, gxg_gtk_radio_button_new_with_mnemonic_w, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic, pl_pus);
  Xg_define_procedure(gtk_radio_button_new_with_mnemonic_from_widget, gxg_gtk_radio_button_new_with_mnemonic_from_widget_w, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic_from_widget, pl_pus);
  Xg_define_procedure(gtk_radio_button_get_group, gxg_gtk_radio_button_get_group_w, 1, 0, 0, H_gtk_radio_button_get_group, pl_pu);
  Xg_define_procedure(gtk_radio_button_set_group, gxg_gtk_radio_button_set_group_w, 2, 0, 0, H_gtk_radio_button_set_group, pl_tu);
  Xg_define_procedure(gtk_radio_menu_item_new, gxg_gtk_radio_menu_item_new_w, 1, 0, 0, H_gtk_radio_menu_item_new, pl_pu);
  Xg_define_procedure(gtk_radio_menu_item_new_with_label, gxg_gtk_radio_menu_item_new_with_label_w, 2, 0, 0, H_gtk_radio_menu_item_new_with_label, pl_pus);
  Xg_define_procedure(gtk_radio_menu_item_new_with_mnemonic, gxg_gtk_radio_menu_item_new_with_mnemonic_w, 2, 0, 0, H_gtk_radio_menu_item_new_with_mnemonic, pl_pus);
  Xg_define_procedure(gtk_radio_menu_item_get_group, gxg_gtk_radio_menu_item_get_group_w, 1, 0, 0, H_gtk_radio_menu_item_get_group, pl_pu);
  Xg_define_procedure(gtk_radio_menu_item_set_group, gxg_gtk_radio_menu_item_set_group_w, 2, 0, 0, H_gtk_radio_menu_item_set_group, pl_tu);
  Xg_define_procedure(gtk_range_set_adjustment, gxg_gtk_range_set_adjustment_w, 2, 0, 0, H_gtk_range_set_adjustment, pl_tu);
  Xg_define_procedure(gtk_range_get_adjustment, gxg_gtk_range_get_adjustment_w, 1, 0, 0, H_gtk_range_get_adjustment, pl_pu);
  Xg_define_procedure(gtk_range_set_inverted, gxg_gtk_range_set_inverted_w, 2, 0, 0, H_gtk_range_set_inverted, pl_tub);
  Xg_define_procedure(gtk_range_get_inverted, gxg_gtk_range_get_inverted_w, 1, 0, 0, H_gtk_range_get_inverted, pl_bu);
  Xg_define_procedure(gtk_range_set_increments, gxg_gtk_range_set_increments_w, 3, 0, 0, H_gtk_range_set_increments, pl_tur);
  Xg_define_procedure(gtk_range_set_range, gxg_gtk_range_set_range_w, 3, 0, 0, H_gtk_range_set_range, pl_tur);
  Xg_define_procedure(gtk_range_set_value, gxg_gtk_range_set_value_w, 2, 0, 0, H_gtk_range_set_value, pl_tur);
  Xg_define_procedure(gtk_range_get_value, gxg_gtk_range_get_value_w, 1, 0, 0, H_gtk_range_get_value, pl_du);
  Xg_define_procedure(gtk_scale_set_digits, gxg_gtk_scale_set_digits_w, 2, 0, 0, H_gtk_scale_set_digits, pl_tui);
  Xg_define_procedure(gtk_scale_get_digits, gxg_gtk_scale_get_digits_w, 1, 0, 0, H_gtk_scale_get_digits, pl_iu);
  Xg_define_procedure(gtk_scale_set_draw_value, gxg_gtk_scale_set_draw_value_w, 2, 0, 0, H_gtk_scale_set_draw_value, pl_tub);
  Xg_define_procedure(gtk_scale_get_draw_value, gxg_gtk_scale_get_draw_value_w, 1, 0, 0, H_gtk_scale_get_draw_value, pl_bu);
  Xg_define_procedure(gtk_scale_set_value_pos, gxg_gtk_scale_set_value_pos_w, 2, 0, 0, H_gtk_scale_set_value_pos, pl_tug);
  Xg_define_procedure(gtk_scale_get_value_pos, gxg_gtk_scale_get_value_pos_w, 1, 0, 0, H_gtk_scale_get_value_pos, pl_gu);
  Xg_define_procedure(gtk_scrolled_window_new, gxg_gtk_scrolled_window_new_w, 2, 0, 0, H_gtk_scrolled_window_new, pl_pu);
  Xg_define_procedure(gtk_scrolled_window_set_hadjustment, gxg_gtk_scrolled_window_set_hadjustment_w, 2, 0, 0, H_gtk_scrolled_window_set_hadjustment, pl_tu);
  Xg_define_procedure(gtk_scrolled_window_set_vadjustment, gxg_gtk_scrolled_window_set_vadjustment_w, 2, 0, 0, H_gtk_scrolled_window_set_vadjustment, pl_tu);
  Xg_define_procedure(gtk_scrolled_window_get_hadjustment, gxg_gtk_scrolled_window_get_hadjustment_w, 1, 0, 0, H_gtk_scrolled_window_get_hadjustment, pl_pu);
  Xg_define_procedure(gtk_scrolled_window_get_vadjustment, gxg_gtk_scrolled_window_get_vadjustment_w, 1, 0, 0, H_gtk_scrolled_window_get_vadjustment, pl_pu);
  Xg_define_procedure(gtk_scrolled_window_set_policy, gxg_gtk_scrolled_window_set_policy_w, 3, 0, 0, H_gtk_scrolled_window_set_policy, pl_tug);
  Xg_define_procedure(gtk_scrolled_window_get_policy, gxg_gtk_scrolled_window_get_policy_w, 1, 2, 0, H_gtk_scrolled_window_get_policy, pl_pu);
  Xg_define_procedure(gtk_scrolled_window_set_placement, gxg_gtk_scrolled_window_set_placement_w, 2, 0, 0, H_gtk_scrolled_window_set_placement, pl_tug);
  Xg_define_procedure(gtk_scrolled_window_get_placement, gxg_gtk_scrolled_window_get_placement_w, 1, 0, 0, H_gtk_scrolled_window_get_placement, pl_gu);
  Xg_define_procedure(gtk_scrolled_window_set_shadow_type, gxg_gtk_scrolled_window_set_shadow_type_w, 2, 0, 0, H_gtk_scrolled_window_set_shadow_type, pl_tug);
  Xg_define_procedure(gtk_scrolled_window_get_shadow_type, gxg_gtk_scrolled_window_get_shadow_type_w, 1, 0, 0, H_gtk_scrolled_window_get_shadow_type, pl_gu);
  Xg_define_procedure(gtk_selection_data_copy, gxg_gtk_selection_data_copy_w, 1, 0, 0, H_gtk_selection_data_copy, pl_pu);
  Xg_define_procedure(gtk_selection_data_free, gxg_gtk_selection_data_free_w, 1, 0, 0, H_gtk_selection_data_free, pl_tu);
  Xg_define_procedure(gtk_separator_menu_item_new, gxg_gtk_separator_menu_item_new_w, 0, 0, 0, H_gtk_separator_menu_item_new, pl_p);
  Xg_define_procedure(gtk_settings_get_default, gxg_gtk_settings_get_default_w, 0, 0, 0, H_gtk_settings_get_default, pl_p);
  Xg_define_procedure(gtk_size_group_new, gxg_gtk_size_group_new_w, 1, 0, 0, H_gtk_size_group_new, pl_pg);
  Xg_define_procedure(gtk_size_group_set_mode, gxg_gtk_size_group_set_mode_w, 2, 0, 0, H_gtk_size_group_set_mode, pl_tug);
  Xg_define_procedure(gtk_size_group_get_mode, gxg_gtk_size_group_get_mode_w, 1, 0, 0, H_gtk_size_group_get_mode, pl_gu);
  Xg_define_procedure(gtk_size_group_add_widget, gxg_gtk_size_group_add_widget_w, 2, 0, 0, H_gtk_size_group_add_widget, pl_tu);
  Xg_define_procedure(gtk_size_group_remove_widget, gxg_gtk_size_group_remove_widget_w, 2, 0, 0, H_gtk_size_group_remove_widget, pl_tu);
  Xg_define_procedure(gtk_spin_button_configure, gxg_gtk_spin_button_configure_w, 4, 0, 0, H_gtk_spin_button_configure, pl_tuuri);
  Xg_define_procedure(gtk_spin_button_new, gxg_gtk_spin_button_new_w, 3, 0, 0, H_gtk_spin_button_new, pl_puri);
  Xg_define_procedure(gtk_spin_button_new_with_range, gxg_gtk_spin_button_new_with_range_w, 3, 0, 0, H_gtk_spin_button_new_with_range, pl_pr);
  Xg_define_procedure(gtk_spin_button_set_adjustment, gxg_gtk_spin_button_set_adjustment_w, 2, 0, 0, H_gtk_spin_button_set_adjustment, pl_tu);
  Xg_define_procedure(gtk_spin_button_get_adjustment, gxg_gtk_spin_button_get_adjustment_w, 1, 0, 0, H_gtk_spin_button_get_adjustment, pl_pu);
  Xg_define_procedure(gtk_spin_button_set_digits, gxg_gtk_spin_button_set_digits_w, 2, 0, 0, H_gtk_spin_button_set_digits, pl_tui);
  Xg_define_procedure(gtk_spin_button_get_digits, gxg_gtk_spin_button_get_digits_w, 1, 0, 0, H_gtk_spin_button_get_digits, pl_iu);
  Xg_define_procedure(gtk_spin_button_set_increments, gxg_gtk_spin_button_set_increments_w, 3, 0, 0, H_gtk_spin_button_set_increments, pl_tur);
  Xg_define_procedure(gtk_spin_button_get_increments, gxg_gtk_spin_button_get_increments_w, 1, 2, 0, H_gtk_spin_button_get_increments, pl_pu);
  Xg_define_procedure(gtk_spin_button_set_range, gxg_gtk_spin_button_set_range_w, 3, 0, 0, H_gtk_spin_button_set_range, pl_tur);
  Xg_define_procedure(gtk_spin_button_get_range, gxg_gtk_spin_button_get_range_w, 1, 2, 0, H_gtk_spin_button_get_range, pl_pu);
  Xg_define_procedure(gtk_spin_button_get_value, gxg_gtk_spin_button_get_value_w, 1, 0, 0, H_gtk_spin_button_get_value, pl_du);
  Xg_define_procedure(gtk_spin_button_get_value_as_int, gxg_gtk_spin_button_get_value_as_int_w, 1, 0, 0, H_gtk_spin_button_get_value_as_int, pl_iu);
  Xg_define_procedure(gtk_spin_button_set_value, gxg_gtk_spin_button_set_value_w, 2, 0, 0, H_gtk_spin_button_set_value, pl_tur);
  Xg_define_procedure(gtk_spin_button_set_update_policy, gxg_gtk_spin_button_set_update_policy_w, 2, 0, 0, H_gtk_spin_button_set_update_policy, pl_tug);
  Xg_define_procedure(gtk_spin_button_get_update_policy, gxg_gtk_spin_button_get_update_policy_w, 1, 0, 0, H_gtk_spin_button_get_update_policy, pl_gu);
  Xg_define_procedure(gtk_spin_button_set_numeric, gxg_gtk_spin_button_set_numeric_w, 2, 0, 0, H_gtk_spin_button_set_numeric, pl_tub);
  Xg_define_procedure(gtk_spin_button_get_numeric, gxg_gtk_spin_button_get_numeric_w, 1, 0, 0, H_gtk_spin_button_get_numeric, pl_bu);
  Xg_define_procedure(gtk_spin_button_spin, gxg_gtk_spin_button_spin_w, 3, 0, 0, H_gtk_spin_button_spin, pl_tugr);
  Xg_define_procedure(gtk_spin_button_set_wrap, gxg_gtk_spin_button_set_wrap_w, 2, 0, 0, H_gtk_spin_button_set_wrap, pl_tub);
  Xg_define_procedure(gtk_spin_button_get_wrap, gxg_gtk_spin_button_get_wrap_w, 1, 0, 0, H_gtk_spin_button_get_wrap, pl_bu);
  Xg_define_procedure(gtk_spin_button_set_snap_to_ticks, gxg_gtk_spin_button_set_snap_to_ticks_w, 2, 0, 0, H_gtk_spin_button_set_snap_to_ticks, pl_tub);
  Xg_define_procedure(gtk_spin_button_get_snap_to_ticks, gxg_gtk_spin_button_get_snap_to_ticks_w, 1, 0, 0, H_gtk_spin_button_get_snap_to_ticks, pl_bu);
  Xg_define_procedure(gtk_spin_button_update, gxg_gtk_spin_button_update_w, 1, 0, 0, H_gtk_spin_button_update, pl_tu);
  Xg_define_procedure(gtk_statusbar_new, gxg_gtk_statusbar_new_w, 0, 0, 0, H_gtk_statusbar_new, pl_p);
  Xg_define_procedure(gtk_statusbar_get_context_id, gxg_gtk_statusbar_get_context_id_w, 2, 0, 0, H_gtk_statusbar_get_context_id, pl_ius);
  Xg_define_procedure(gtk_statusbar_push, gxg_gtk_statusbar_push_w, 3, 0, 0, H_gtk_statusbar_push, pl_iuis);
  Xg_define_procedure(gtk_statusbar_pop, gxg_gtk_statusbar_pop_w, 2, 0, 0, H_gtk_statusbar_pop, pl_tui);
  Xg_define_procedure(gtk_statusbar_remove, gxg_gtk_statusbar_remove_w, 3, 0, 0, H_gtk_statusbar_remove, pl_tui);
  Xg_define_procedure(gtk_text_buffer_new, gxg_gtk_text_buffer_new_w, 1, 0, 0, H_gtk_text_buffer_new, pl_pu);
  Xg_define_procedure(gtk_text_buffer_get_line_count, gxg_gtk_text_buffer_get_line_count_w, 1, 0, 0, H_gtk_text_buffer_get_line_count, pl_iu);
  Xg_define_procedure(gtk_text_buffer_get_char_count, gxg_gtk_text_buffer_get_char_count_w, 1, 0, 0, H_gtk_text_buffer_get_char_count, pl_iu);
  Xg_define_procedure(gtk_text_buffer_get_tag_table, gxg_gtk_text_buffer_get_tag_table_w, 1, 0, 0, H_gtk_text_buffer_get_tag_table, pl_pu);
  Xg_define_procedure(gtk_text_buffer_set_text, gxg_gtk_text_buffer_set_text_w, 3, 0, 0, H_gtk_text_buffer_set_text, pl_tusi);
  Xg_define_procedure(gtk_text_buffer_insert, gxg_gtk_text_buffer_insert_w, 4, 0, 0, H_gtk_text_buffer_insert, pl_tuusi);
  Xg_define_procedure(gtk_text_buffer_insert_at_cursor, gxg_gtk_text_buffer_insert_at_cursor_w, 3, 0, 0, H_gtk_text_buffer_insert_at_cursor, pl_tusi);
  Xg_define_procedure(gtk_text_buffer_insert_interactive, gxg_gtk_text_buffer_insert_interactive_w, 5, 0, 0, H_gtk_text_buffer_insert_interactive, pl_buusib);
  Xg_define_procedure(gtk_text_buffer_insert_interactive_at_cursor, gxg_gtk_text_buffer_insert_interactive_at_cursor_w, 4, 0, 0, H_gtk_text_buffer_insert_interactive_at_cursor, pl_busib);
  Xg_define_procedure(gtk_text_buffer_insert_range, gxg_gtk_text_buffer_insert_range_w, 4, 0, 0, H_gtk_text_buffer_insert_range, pl_tu);
  Xg_define_procedure(gtk_text_buffer_insert_range_interactive, gxg_gtk_text_buffer_insert_range_interactive_w, 5, 0, 0, H_gtk_text_buffer_insert_range_interactive, pl_buuuub);
  Xg_define_procedure(gtk_text_buffer_insert_with_tags, gxg_gtk_text_buffer_insert_with_tags_w, 5, 0, 0, H_gtk_text_buffer_insert_with_tags, pl_tuusit);
  Xg_define_procedure(gtk_text_buffer_insert_with_tags_by_name, gxg_gtk_text_buffer_insert_with_tags_by_name_w, 5, 0, 0, H_gtk_text_buffer_insert_with_tags_by_name, pl_tuusit);
  Xg_define_procedure(gtk_text_buffer_delete, gxg_gtk_text_buffer_delete_w, 3, 0, 0, H_gtk_text_buffer_delete, pl_tu);
  Xg_define_procedure(gtk_text_buffer_delete_interactive, gxg_gtk_text_buffer_delete_interactive_w, 4, 0, 0, H_gtk_text_buffer_delete_interactive, pl_buuub);
  Xg_define_procedure(gtk_text_buffer_get_text, gxg_gtk_text_buffer_get_text_w, 4, 0, 0, H_gtk_text_buffer_get_text, pl_suuub);
  Xg_define_procedure(gtk_text_buffer_get_slice, gxg_gtk_text_buffer_get_slice_w, 4, 0, 0, H_gtk_text_buffer_get_slice, pl_suuub);
  Xg_define_procedure(gtk_text_buffer_insert_child_anchor, gxg_gtk_text_buffer_insert_child_anchor_w, 3, 0, 0, H_gtk_text_buffer_insert_child_anchor, pl_tu);
  Xg_define_procedure(gtk_text_buffer_create_child_anchor, gxg_gtk_text_buffer_create_child_anchor_w, 2, 0, 0, H_gtk_text_buffer_create_child_anchor, pl_pu);
  Xg_define_procedure(gtk_text_buffer_create_mark, gxg_gtk_text_buffer_create_mark_w, 4, 0, 0, H_gtk_text_buffer_create_mark, pl_pusub);
  Xg_define_procedure(gtk_text_buffer_move_mark, gxg_gtk_text_buffer_move_mark_w, 3, 0, 0, H_gtk_text_buffer_move_mark, pl_tu);
  Xg_define_procedure(gtk_text_buffer_delete_mark, gxg_gtk_text_buffer_delete_mark_w, 2, 0, 0, H_gtk_text_buffer_delete_mark, pl_tu);
  Xg_define_procedure(gtk_text_buffer_get_mark, gxg_gtk_text_buffer_get_mark_w, 2, 0, 0, H_gtk_text_buffer_get_mark, pl_pus);
  Xg_define_procedure(gtk_text_buffer_move_mark_by_name, gxg_gtk_text_buffer_move_mark_by_name_w, 3, 0, 0, H_gtk_text_buffer_move_mark_by_name, pl_tusu);
  Xg_define_procedure(gtk_text_buffer_delete_mark_by_name, gxg_gtk_text_buffer_delete_mark_by_name_w, 2, 0, 0, H_gtk_text_buffer_delete_mark_by_name, pl_tus);
  Xg_define_procedure(gtk_text_buffer_get_insert, gxg_gtk_text_buffer_get_insert_w, 1, 0, 0, H_gtk_text_buffer_get_insert, pl_pu);
  Xg_define_procedure(gtk_text_buffer_get_selection_bound, gxg_gtk_text_buffer_get_selection_bound_w, 1, 0, 0, H_gtk_text_buffer_get_selection_bound, pl_pu);
  Xg_define_procedure(gtk_text_buffer_place_cursor, gxg_gtk_text_buffer_place_cursor_w, 2, 0, 0, H_gtk_text_buffer_place_cursor, pl_tu);
  Xg_define_procedure(gtk_text_buffer_apply_tag, gxg_gtk_text_buffer_apply_tag_w, 4, 0, 0, H_gtk_text_buffer_apply_tag, pl_tu);
  Xg_define_procedure(gtk_text_buffer_remove_tag, gxg_gtk_text_buffer_remove_tag_w, 4, 0, 0, H_gtk_text_buffer_remove_tag, pl_tu);
  Xg_define_procedure(gtk_text_buffer_apply_tag_by_name, gxg_gtk_text_buffer_apply_tag_by_name_w, 4, 0, 0, H_gtk_text_buffer_apply_tag_by_name, pl_tusu);
  Xg_define_procedure(gtk_text_buffer_remove_tag_by_name, gxg_gtk_text_buffer_remove_tag_by_name_w, 4, 0, 0, H_gtk_text_buffer_remove_tag_by_name, pl_tusu);
  Xg_define_procedure(gtk_text_buffer_remove_all_tags, gxg_gtk_text_buffer_remove_all_tags_w, 3, 0, 0, H_gtk_text_buffer_remove_all_tags, pl_tu);
  Xg_define_procedure(gtk_text_buffer_create_tag, gxg_gtk_text_buffer_create_tag_w, 2, 1, 0, H_gtk_text_buffer_create_tag, pl_pust);
  Xg_define_procedure(gtk_text_buffer_get_iter_at_line_offset, gxg_gtk_text_buffer_get_iter_at_line_offset_w, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_offset, pl_tuui);
  Xg_define_procedure(gtk_text_buffer_get_iter_at_line_index, gxg_gtk_text_buffer_get_iter_at_line_index_w, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_index, pl_tuui);
  Xg_define_procedure(gtk_text_buffer_get_iter_at_offset, gxg_gtk_text_buffer_get_iter_at_offset_w, 3, 0, 0, H_gtk_text_buffer_get_iter_at_offset, pl_tuui);
  Xg_define_procedure(gtk_text_buffer_get_iter_at_line, gxg_gtk_text_buffer_get_iter_at_line_w, 3, 0, 0, H_gtk_text_buffer_get_iter_at_line, pl_tuui);
  Xg_define_procedure(gtk_text_buffer_get_start_iter, gxg_gtk_text_buffer_get_start_iter_w, 2, 0, 0, H_gtk_text_buffer_get_start_iter, pl_tu);
  Xg_define_procedure(gtk_text_buffer_get_end_iter, gxg_gtk_text_buffer_get_end_iter_w, 2, 0, 0, H_gtk_text_buffer_get_end_iter, pl_tu);
  Xg_define_procedure(gtk_text_buffer_get_bounds, gxg_gtk_text_buffer_get_bounds_w, 3, 0, 0, H_gtk_text_buffer_get_bounds, pl_tu);
  Xg_define_procedure(gtk_text_buffer_get_iter_at_mark, gxg_gtk_text_buffer_get_iter_at_mark_w, 3, 0, 0, H_gtk_text_buffer_get_iter_at_mark, pl_tu);
  Xg_define_procedure(gtk_text_buffer_get_iter_at_child_anchor, gxg_gtk_text_buffer_get_iter_at_child_anchor_w, 3, 0, 0, H_gtk_text_buffer_get_iter_at_child_anchor, pl_tu);
  Xg_define_procedure(gtk_text_buffer_get_modified, gxg_gtk_text_buffer_get_modified_w, 1, 0, 0, H_gtk_text_buffer_get_modified, pl_bu);
  Xg_define_procedure(gtk_text_buffer_set_modified, gxg_gtk_text_buffer_set_modified_w, 2, 0, 0, H_gtk_text_buffer_set_modified, pl_tub);
  Xg_define_procedure(gtk_text_buffer_get_selection_bounds, gxg_gtk_text_buffer_get_selection_bounds_w, 3, 0, 0, H_gtk_text_buffer_get_selection_bounds, pl_bu);
  Xg_define_procedure(gtk_text_buffer_delete_selection, gxg_gtk_text_buffer_delete_selection_w, 3, 0, 0, H_gtk_text_buffer_delete_selection, pl_bub);
  Xg_define_procedure(gtk_text_buffer_begin_user_action, gxg_gtk_text_buffer_begin_user_action_w, 1, 0, 0, H_gtk_text_buffer_begin_user_action, pl_tu);
  Xg_define_procedure(gtk_text_buffer_end_user_action, gxg_gtk_text_buffer_end_user_action_w, 1, 0, 0, H_gtk_text_buffer_end_user_action, pl_tu);
  Xg_define_procedure(gtk_text_child_anchor_new, gxg_gtk_text_child_anchor_new_w, 0, 0, 0, H_gtk_text_child_anchor_new, pl_p);
  Xg_define_procedure(gtk_text_child_anchor_get_widgets, gxg_gtk_text_child_anchor_get_widgets_w, 1, 0, 0, H_gtk_text_child_anchor_get_widgets, pl_pu);
  Xg_define_procedure(gtk_text_child_anchor_get_deleted, gxg_gtk_text_child_anchor_get_deleted_w, 1, 0, 0, H_gtk_text_child_anchor_get_deleted, pl_bu);
  Xg_define_procedure(gtk_text_iter_get_buffer, gxg_gtk_text_iter_get_buffer_w, 1, 0, 0, H_gtk_text_iter_get_buffer, pl_pu);
  Xg_define_procedure(gtk_text_iter_copy, gxg_gtk_text_iter_copy_w, 1, 0, 0, H_gtk_text_iter_copy, pl_pu);
  Xg_define_procedure(gtk_text_iter_free, gxg_gtk_text_iter_free_w, 1, 0, 0, H_gtk_text_iter_free, pl_tu);
  Xg_define_procedure(gtk_text_iter_get_offset, gxg_gtk_text_iter_get_offset_w, 1, 0, 0, H_gtk_text_iter_get_offset, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_line, gxg_gtk_text_iter_get_line_w, 1, 0, 0, H_gtk_text_iter_get_line, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_line_offset, gxg_gtk_text_iter_get_line_offset_w, 1, 0, 0, H_gtk_text_iter_get_line_offset, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_line_index, gxg_gtk_text_iter_get_line_index_w, 1, 0, 0, H_gtk_text_iter_get_line_index, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_visible_line_offset, gxg_gtk_text_iter_get_visible_line_offset_w, 1, 0, 0, H_gtk_text_iter_get_visible_line_offset, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_visible_line_index, gxg_gtk_text_iter_get_visible_line_index_w, 1, 0, 0, H_gtk_text_iter_get_visible_line_index, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_char, gxg_gtk_text_iter_get_char_w, 1, 0, 0, H_gtk_text_iter_get_char, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_slice, gxg_gtk_text_iter_get_slice_w, 2, 0, 0, H_gtk_text_iter_get_slice, pl_su);
  Xg_define_procedure(gtk_text_iter_get_text, gxg_gtk_text_iter_get_text_w, 2, 0, 0, H_gtk_text_iter_get_text, pl_su);
  Xg_define_procedure(gtk_text_iter_get_visible_slice, gxg_gtk_text_iter_get_visible_slice_w, 2, 0, 0, H_gtk_text_iter_get_visible_slice, pl_su);
  Xg_define_procedure(gtk_text_iter_get_visible_text, gxg_gtk_text_iter_get_visible_text_w, 2, 0, 0, H_gtk_text_iter_get_visible_text, pl_su);
  Xg_define_procedure(gtk_text_iter_get_marks, gxg_gtk_text_iter_get_marks_w, 1, 0, 0, H_gtk_text_iter_get_marks, pl_pu);
  Xg_define_procedure(gtk_text_iter_get_child_anchor, gxg_gtk_text_iter_get_child_anchor_w, 1, 0, 0, H_gtk_text_iter_get_child_anchor, pl_pu);
  Xg_define_procedure(gtk_text_iter_get_toggled_tags, gxg_gtk_text_iter_get_toggled_tags_w, 2, 0, 0, H_gtk_text_iter_get_toggled_tags, pl_pub);
  Xg_define_procedure(gtk_text_iter_ends_tag, gxg_gtk_text_iter_ends_tag_w, 2, 0, 0, H_gtk_text_iter_ends_tag, pl_bu);
  Xg_define_procedure(gtk_text_iter_toggles_tag, gxg_gtk_text_iter_toggles_tag_w, 2, 0, 0, H_gtk_text_iter_toggles_tag, pl_bu);
  Xg_define_procedure(gtk_text_iter_has_tag, gxg_gtk_text_iter_has_tag_w, 2, 0, 0, H_gtk_text_iter_has_tag, pl_bu);
  Xg_define_procedure(gtk_text_iter_get_tags, gxg_gtk_text_iter_get_tags_w, 1, 0, 0, H_gtk_text_iter_get_tags, pl_pu);
  Xg_define_procedure(gtk_text_iter_editable, gxg_gtk_text_iter_editable_w, 2, 0, 0, H_gtk_text_iter_editable, pl_bub);
  Xg_define_procedure(gtk_text_iter_can_insert, gxg_gtk_text_iter_can_insert_w, 2, 0, 0, H_gtk_text_iter_can_insert, pl_bub);
  Xg_define_procedure(gtk_text_iter_starts_word, gxg_gtk_text_iter_starts_word_w, 1, 0, 0, H_gtk_text_iter_starts_word, pl_bu);
  Xg_define_procedure(gtk_text_iter_ends_word, gxg_gtk_text_iter_ends_word_w, 1, 0, 0, H_gtk_text_iter_ends_word, pl_bu);
  Xg_define_procedure(gtk_text_iter_inside_word, gxg_gtk_text_iter_inside_word_w, 1, 0, 0, H_gtk_text_iter_inside_word, pl_bu);
  Xg_define_procedure(gtk_text_iter_starts_sentence, gxg_gtk_text_iter_starts_sentence_w, 1, 0, 0, H_gtk_text_iter_starts_sentence, pl_bu);
  Xg_define_procedure(gtk_text_iter_ends_sentence, gxg_gtk_text_iter_ends_sentence_w, 1, 0, 0, H_gtk_text_iter_ends_sentence, pl_bu);
  Xg_define_procedure(gtk_text_iter_inside_sentence, gxg_gtk_text_iter_inside_sentence_w, 1, 0, 0, H_gtk_text_iter_inside_sentence, pl_bu);
  Xg_define_procedure(gtk_text_iter_starts_line, gxg_gtk_text_iter_starts_line_w, 1, 0, 0, H_gtk_text_iter_starts_line, pl_bu);
  Xg_define_procedure(gtk_text_iter_ends_line, gxg_gtk_text_iter_ends_line_w, 1, 0, 0, H_gtk_text_iter_ends_line, pl_bu);
  Xg_define_procedure(gtk_text_iter_is_cursor_position, gxg_gtk_text_iter_is_cursor_position_w, 1, 0, 0, H_gtk_text_iter_is_cursor_position, pl_bu);
  Xg_define_procedure(gtk_text_iter_get_chars_in_line, gxg_gtk_text_iter_get_chars_in_line_w, 1, 0, 0, H_gtk_text_iter_get_chars_in_line, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_bytes_in_line, gxg_gtk_text_iter_get_bytes_in_line_w, 1, 0, 0, H_gtk_text_iter_get_bytes_in_line, pl_iu);
  Xg_define_procedure(gtk_text_iter_get_language, gxg_gtk_text_iter_get_language_w, 1, 0, 0, H_gtk_text_iter_get_language, pl_pu);
  Xg_define_procedure(gtk_text_iter_is_end, gxg_gtk_text_iter_is_end_w, 1, 0, 0, H_gtk_text_iter_is_end, pl_bu);
  Xg_define_procedure(gtk_text_iter_is_start, gxg_gtk_text_iter_is_start_w, 1, 0, 0, H_gtk_text_iter_is_start, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_char, gxg_gtk_text_iter_forward_char_w, 1, 0, 0, H_gtk_text_iter_forward_char, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_char, gxg_gtk_text_iter_backward_char_w, 1, 0, 0, H_gtk_text_iter_backward_char, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_chars, gxg_gtk_text_iter_forward_chars_w, 2, 0, 0, H_gtk_text_iter_forward_chars, pl_bui);
  Xg_define_procedure(gtk_text_iter_backward_chars, gxg_gtk_text_iter_backward_chars_w, 2, 0, 0, H_gtk_text_iter_backward_chars, pl_bui);
  Xg_define_procedure(gtk_text_iter_forward_line, gxg_gtk_text_iter_forward_line_w, 1, 0, 0, H_gtk_text_iter_forward_line, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_line, gxg_gtk_text_iter_backward_line_w, 1, 0, 0, H_gtk_text_iter_backward_line, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_lines, gxg_gtk_text_iter_forward_lines_w, 2, 0, 0, H_gtk_text_iter_forward_lines, pl_bui);
  Xg_define_procedure(gtk_text_iter_backward_lines, gxg_gtk_text_iter_backward_lines_w, 2, 0, 0, H_gtk_text_iter_backward_lines, pl_bui);
  Xg_define_procedure(gtk_text_iter_forward_word_end, gxg_gtk_text_iter_forward_word_end_w, 1, 0, 0, H_gtk_text_iter_forward_word_end, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_word_start, gxg_gtk_text_iter_backward_word_start_w, 1, 0, 0, H_gtk_text_iter_backward_word_start, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_word_ends, gxg_gtk_text_iter_forward_word_ends_w, 2, 0, 0, H_gtk_text_iter_forward_word_ends, pl_bui);
  Xg_define_procedure(gtk_text_iter_backward_word_starts, gxg_gtk_text_iter_backward_word_starts_w, 2, 0, 0, H_gtk_text_iter_backward_word_starts, pl_bui);
  Xg_define_procedure(gtk_text_iter_forward_sentence_end, gxg_gtk_text_iter_forward_sentence_end_w, 1, 0, 0, H_gtk_text_iter_forward_sentence_end, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_sentence_start, gxg_gtk_text_iter_backward_sentence_start_w, 1, 0, 0, H_gtk_text_iter_backward_sentence_start, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_sentence_ends, gxg_gtk_text_iter_forward_sentence_ends_w, 2, 0, 0, H_gtk_text_iter_forward_sentence_ends, pl_bui);
  Xg_define_procedure(gtk_text_iter_backward_sentence_starts, gxg_gtk_text_iter_backward_sentence_starts_w, 2, 0, 0, H_gtk_text_iter_backward_sentence_starts, pl_bui);
  Xg_define_procedure(gtk_text_iter_forward_cursor_position, gxg_gtk_text_iter_forward_cursor_position_w, 1, 0, 0, H_gtk_text_iter_forward_cursor_position, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_cursor_position, gxg_gtk_text_iter_backward_cursor_position_w, 1, 0, 0, H_gtk_text_iter_backward_cursor_position, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_cursor_positions, gxg_gtk_text_iter_forward_cursor_positions_w, 2, 0, 0, H_gtk_text_iter_forward_cursor_positions, pl_bui);
  Xg_define_procedure(gtk_text_iter_backward_cursor_positions, gxg_gtk_text_iter_backward_cursor_positions_w, 2, 0, 0, H_gtk_text_iter_backward_cursor_positions, pl_bui);
  Xg_define_procedure(gtk_text_iter_set_offset, gxg_gtk_text_iter_set_offset_w, 2, 0, 0, H_gtk_text_iter_set_offset, pl_tui);
  Xg_define_procedure(gtk_text_iter_set_line, gxg_gtk_text_iter_set_line_w, 2, 0, 0, H_gtk_text_iter_set_line, pl_tui);
  Xg_define_procedure(gtk_text_iter_set_line_offset, gxg_gtk_text_iter_set_line_offset_w, 2, 0, 0, H_gtk_text_iter_set_line_offset, pl_tui);
  Xg_define_procedure(gtk_text_iter_set_line_index, gxg_gtk_text_iter_set_line_index_w, 2, 0, 0, H_gtk_text_iter_set_line_index, pl_tui);
  Xg_define_procedure(gtk_text_iter_forward_to_end, gxg_gtk_text_iter_forward_to_end_w, 1, 0, 0, H_gtk_text_iter_forward_to_end, pl_tu);
  Xg_define_procedure(gtk_text_iter_forward_to_line_end, gxg_gtk_text_iter_forward_to_line_end_w, 1, 0, 0, H_gtk_text_iter_forward_to_line_end, pl_bu);
  Xg_define_procedure(gtk_text_iter_set_visible_line_offset, gxg_gtk_text_iter_set_visible_line_offset_w, 2, 0, 0, H_gtk_text_iter_set_visible_line_offset, pl_tui);
  Xg_define_procedure(gtk_text_iter_set_visible_line_index, gxg_gtk_text_iter_set_visible_line_index_w, 2, 0, 0, H_gtk_text_iter_set_visible_line_index, pl_tui);
  Xg_define_procedure(gtk_text_iter_forward_to_tag_toggle, gxg_gtk_text_iter_forward_to_tag_toggle_w, 2, 0, 0, H_gtk_text_iter_forward_to_tag_toggle, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_to_tag_toggle, gxg_gtk_text_iter_backward_to_tag_toggle_w, 2, 0, 0, H_gtk_text_iter_backward_to_tag_toggle, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_find_char, gxg_gtk_text_iter_forward_find_char_w, 4, 0, 0, H_gtk_text_iter_forward_find_char, pl_buttu);
  Xg_define_procedure(gtk_text_iter_backward_find_char, gxg_gtk_text_iter_backward_find_char_w, 4, 0, 0, H_gtk_text_iter_backward_find_char, pl_buttu);
  Xg_define_procedure(gtk_text_iter_forward_search, gxg_gtk_text_iter_forward_search_w, 6, 0, 0, H_gtk_text_iter_forward_search, pl_busgu);
  Xg_define_procedure(gtk_text_iter_backward_search, gxg_gtk_text_iter_backward_search_w, 6, 0, 0, H_gtk_text_iter_backward_search, pl_busgu);
  Xg_define_procedure(gtk_text_iter_equal, gxg_gtk_text_iter_equal_w, 2, 0, 0, H_gtk_text_iter_equal, pl_bu);
  Xg_define_procedure(gtk_text_iter_compare, gxg_gtk_text_iter_compare_w, 2, 0, 0, H_gtk_text_iter_compare, pl_iu);
  Xg_define_procedure(gtk_text_iter_in_range, gxg_gtk_text_iter_in_range_w, 3, 0, 0, H_gtk_text_iter_in_range, pl_bu);
  Xg_define_procedure(gtk_text_iter_order, gxg_gtk_text_iter_order_w, 2, 0, 0, H_gtk_text_iter_order, pl_tu);
  Xg_define_procedure(gtk_text_mark_set_visible, gxg_gtk_text_mark_set_visible_w, 2, 0, 0, H_gtk_text_mark_set_visible, pl_tub);
  Xg_define_procedure(gtk_text_mark_get_visible, gxg_gtk_text_mark_get_visible_w, 1, 0, 0, H_gtk_text_mark_get_visible, pl_bu);
  Xg_define_procedure(gtk_text_mark_get_name, gxg_gtk_text_mark_get_name_w, 1, 0, 0, H_gtk_text_mark_get_name, pl_su);
  Xg_define_procedure(gtk_text_mark_get_deleted, gxg_gtk_text_mark_get_deleted_w, 1, 0, 0, H_gtk_text_mark_get_deleted, pl_bu);
  Xg_define_procedure(gtk_text_mark_get_buffer, gxg_gtk_text_mark_get_buffer_w, 1, 0, 0, H_gtk_text_mark_get_buffer, pl_pu);
  Xg_define_procedure(gtk_text_mark_get_left_gravity, gxg_gtk_text_mark_get_left_gravity_w, 1, 0, 0, H_gtk_text_mark_get_left_gravity, pl_bu);
  Xg_define_procedure(gtk_text_tag_new, gxg_gtk_text_tag_new_w, 1, 0, 0, H_gtk_text_tag_new, pl_ps);
  Xg_define_procedure(gtk_text_tag_get_priority, gxg_gtk_text_tag_get_priority_w, 1, 0, 0, H_gtk_text_tag_get_priority, pl_iu);
  Xg_define_procedure(gtk_text_tag_set_priority, gxg_gtk_text_tag_set_priority_w, 2, 0, 0, H_gtk_text_tag_set_priority, pl_tui);
  Xg_define_procedure(gtk_text_tag_table_new, gxg_gtk_text_tag_table_new_w, 0, 0, 0, H_gtk_text_tag_table_new, pl_p);
  Xg_define_procedure(gtk_text_tag_table_add, gxg_gtk_text_tag_table_add_w, 2, 0, 0, H_gtk_text_tag_table_add, pl_tu);
  Xg_define_procedure(gtk_text_tag_table_remove, gxg_gtk_text_tag_table_remove_w, 2, 0, 0, H_gtk_text_tag_table_remove, pl_tu);
  Xg_define_procedure(gtk_text_tag_table_lookup, gxg_gtk_text_tag_table_lookup_w, 2, 0, 0, H_gtk_text_tag_table_lookup, pl_pus);
  Xg_define_procedure(gtk_text_tag_table_foreach, gxg_gtk_text_tag_table_foreach_w, 3, 0, 0, H_gtk_text_tag_table_foreach, pl_tut);
  Xg_define_procedure(gtk_text_tag_table_get_size, gxg_gtk_text_tag_table_get_size_w, 1, 0, 0, H_gtk_text_tag_table_get_size, pl_iu);
  Xg_define_procedure(gtk_text_view_new, gxg_gtk_text_view_new_w, 0, 0, 0, H_gtk_text_view_new, pl_p);
  Xg_define_procedure(gtk_text_view_new_with_buffer, gxg_gtk_text_view_new_with_buffer_w, 1, 0, 0, H_gtk_text_view_new_with_buffer, pl_pu);
  Xg_define_procedure(gtk_text_view_set_buffer, gxg_gtk_text_view_set_buffer_w, 2, 0, 0, H_gtk_text_view_set_buffer, pl_tu);
  Xg_define_procedure(gtk_text_view_get_buffer, gxg_gtk_text_view_get_buffer_w, 1, 0, 0, H_gtk_text_view_get_buffer, pl_pu);
  Xg_define_procedure(gtk_text_view_scroll_to_iter, gxg_gtk_text_view_scroll_to_iter_w, 6, 0, 0, H_gtk_text_view_scroll_to_iter, pl_buurbr);
  Xg_define_procedure(gtk_text_view_scroll_to_mark, gxg_gtk_text_view_scroll_to_mark_w, 6, 0, 0, H_gtk_text_view_scroll_to_mark, pl_tuurbr);
  Xg_define_procedure(gtk_text_view_scroll_mark_onscreen, gxg_gtk_text_view_scroll_mark_onscreen_w, 2, 0, 0, H_gtk_text_view_scroll_mark_onscreen, pl_tu);
  Xg_define_procedure(gtk_text_view_move_mark_onscreen, gxg_gtk_text_view_move_mark_onscreen_w, 2, 0, 0, H_gtk_text_view_move_mark_onscreen, pl_bu);
  Xg_define_procedure(gtk_text_view_place_cursor_onscreen, gxg_gtk_text_view_place_cursor_onscreen_w, 1, 0, 0, H_gtk_text_view_place_cursor_onscreen, pl_bu);
  Xg_define_procedure(gtk_text_view_get_visible_rect, gxg_gtk_text_view_get_visible_rect_w, 2, 0, 0, H_gtk_text_view_get_visible_rect, pl_tu);
  Xg_define_procedure(gtk_text_view_set_cursor_visible, gxg_gtk_text_view_set_cursor_visible_w, 2, 0, 0, H_gtk_text_view_set_cursor_visible, pl_tub);
  Xg_define_procedure(gtk_text_view_get_cursor_visible, gxg_gtk_text_view_get_cursor_visible_w, 1, 0, 0, H_gtk_text_view_get_cursor_visible, pl_bu);
  Xg_define_procedure(gtk_text_view_get_iter_location, gxg_gtk_text_view_get_iter_location_w, 3, 0, 0, H_gtk_text_view_get_iter_location, pl_tu);
  Xg_define_procedure(gtk_text_view_get_line_yrange, gxg_gtk_text_view_get_line_yrange_w, 2, 2, 0, H_gtk_text_view_get_line_yrange, pl_pu);
  Xg_define_procedure(gtk_text_view_get_line_at_y, gxg_gtk_text_view_get_line_at_y_w, 3, 1, 0, H_gtk_text_view_get_line_at_y, pl_puuiu);
  Xg_define_procedure(gtk_text_view_buffer_to_window_coords, gxg_gtk_text_view_buffer_to_window_coords_w, 4, 2, 0, H_gtk_text_view_buffer_to_window_coords, pl_pugiiu);
  Xg_define_procedure(gtk_text_view_window_to_buffer_coords, gxg_gtk_text_view_window_to_buffer_coords_w, 4, 2, 0, H_gtk_text_view_window_to_buffer_coords, pl_pugiiu);
  Xg_define_procedure(gtk_text_view_set_border_window_size, gxg_gtk_text_view_set_border_window_size_w, 3, 0, 0, H_gtk_text_view_set_border_window_size, pl_tugi);
  Xg_define_procedure(gtk_text_view_get_border_window_size, gxg_gtk_text_view_get_border_window_size_w, 2, 0, 0, H_gtk_text_view_get_border_window_size, pl_iug);
  Xg_define_procedure(gtk_text_view_forward_display_line, gxg_gtk_text_view_forward_display_line_w, 2, 0, 0, H_gtk_text_view_forward_display_line, pl_bu);
  Xg_define_procedure(gtk_text_view_backward_display_line, gxg_gtk_text_view_backward_display_line_w, 2, 0, 0, H_gtk_text_view_backward_display_line, pl_bu);
  Xg_define_procedure(gtk_text_view_forward_display_line_end, gxg_gtk_text_view_forward_display_line_end_w, 2, 0, 0, H_gtk_text_view_forward_display_line_end, pl_bu);
  Xg_define_procedure(gtk_text_view_backward_display_line_start, gxg_gtk_text_view_backward_display_line_start_w, 2, 0, 0, H_gtk_text_view_backward_display_line_start, pl_bu);
  Xg_define_procedure(gtk_text_view_starts_display_line, gxg_gtk_text_view_starts_display_line_w, 2, 0, 0, H_gtk_text_view_starts_display_line, pl_bu);
  Xg_define_procedure(gtk_text_view_move_visually, gxg_gtk_text_view_move_visually_w, 3, 0, 0, H_gtk_text_view_move_visually, pl_buui);
  Xg_define_procedure(gtk_text_view_add_child_at_anchor, gxg_gtk_text_view_add_child_at_anchor_w, 3, 0, 0, H_gtk_text_view_add_child_at_anchor, pl_tu);
  Xg_define_procedure(gtk_text_view_add_child_in_window, gxg_gtk_text_view_add_child_in_window_w, 5, 0, 0, H_gtk_text_view_add_child_in_window, pl_tuugi);
  Xg_define_procedure(gtk_text_view_move_child, gxg_gtk_text_view_move_child_w, 4, 0, 0, H_gtk_text_view_move_child, pl_tuui);
  Xg_define_procedure(gtk_text_view_set_wrap_mode, gxg_gtk_text_view_set_wrap_mode_w, 2, 0, 0, H_gtk_text_view_set_wrap_mode, pl_tug);
  Xg_define_procedure(gtk_text_view_get_wrap_mode, gxg_gtk_text_view_get_wrap_mode_w, 1, 0, 0, H_gtk_text_view_get_wrap_mode, pl_gu);
  Xg_define_procedure(gtk_text_view_set_editable, gxg_gtk_text_view_set_editable_w, 2, 0, 0, H_gtk_text_view_set_editable, pl_tub);
  Xg_define_procedure(gtk_text_view_get_editable, gxg_gtk_text_view_get_editable_w, 1, 0, 0, H_gtk_text_view_get_editable, pl_bu);
  Xg_define_procedure(gtk_text_view_set_pixels_above_lines, gxg_gtk_text_view_set_pixels_above_lines_w, 2, 0, 0, H_gtk_text_view_set_pixels_above_lines, pl_tui);
  Xg_define_procedure(gtk_text_view_get_pixels_above_lines, gxg_gtk_text_view_get_pixels_above_lines_w, 1, 0, 0, H_gtk_text_view_get_pixels_above_lines, pl_iu);
  Xg_define_procedure(gtk_text_view_set_pixels_below_lines, gxg_gtk_text_view_set_pixels_below_lines_w, 2, 0, 0, H_gtk_text_view_set_pixels_below_lines, pl_tui);
  Xg_define_procedure(gtk_text_view_get_pixels_below_lines, gxg_gtk_text_view_get_pixels_below_lines_w, 1, 0, 0, H_gtk_text_view_get_pixels_below_lines, pl_iu);
  Xg_define_procedure(gtk_text_view_set_pixels_inside_wrap, gxg_gtk_text_view_set_pixels_inside_wrap_w, 2, 0, 0, H_gtk_text_view_set_pixels_inside_wrap, pl_tui);
  Xg_define_procedure(gtk_text_view_get_pixels_inside_wrap, gxg_gtk_text_view_get_pixels_inside_wrap_w, 1, 0, 0, H_gtk_text_view_get_pixels_inside_wrap, pl_iu);
  Xg_define_procedure(gtk_text_view_set_justification, gxg_gtk_text_view_set_justification_w, 2, 0, 0, H_gtk_text_view_set_justification, pl_tug);
  Xg_define_procedure(gtk_text_view_get_justification, gxg_gtk_text_view_get_justification_w, 1, 0, 0, H_gtk_text_view_get_justification, pl_gu);
  Xg_define_procedure(gtk_text_view_set_left_margin, gxg_gtk_text_view_set_left_margin_w, 2, 0, 0, H_gtk_text_view_set_left_margin, pl_tui);
  Xg_define_procedure(gtk_text_view_get_left_margin, gxg_gtk_text_view_get_left_margin_w, 1, 0, 0, H_gtk_text_view_get_left_margin, pl_iu);
  Xg_define_procedure(gtk_text_view_set_right_margin, gxg_gtk_text_view_set_right_margin_w, 2, 0, 0, H_gtk_text_view_set_right_margin, pl_tui);
  Xg_define_procedure(gtk_text_view_get_right_margin, gxg_gtk_text_view_get_right_margin_w, 1, 0, 0, H_gtk_text_view_get_right_margin, pl_iu);
  Xg_define_procedure(gtk_text_view_set_indent, gxg_gtk_text_view_set_indent_w, 2, 0, 0, H_gtk_text_view_set_indent, pl_tui);
  Xg_define_procedure(gtk_text_view_get_indent, gxg_gtk_text_view_get_indent_w, 1, 0, 0, H_gtk_text_view_get_indent, pl_iu);
  Xg_define_procedure(gtk_text_view_set_tabs, gxg_gtk_text_view_set_tabs_w, 2, 0, 0, H_gtk_text_view_set_tabs, pl_tu);
  Xg_define_procedure(gtk_text_view_get_tabs, gxg_gtk_text_view_get_tabs_w, 1, 0, 0, H_gtk_text_view_get_tabs, pl_pu);
  Xg_define_procedure(gtk_toggle_button_new, gxg_gtk_toggle_button_new_w, 0, 0, 0, H_gtk_toggle_button_new, pl_p);
  Xg_define_procedure(gtk_toggle_button_new_with_label, gxg_gtk_toggle_button_new_with_label_w, 1, 0, 0, H_gtk_toggle_button_new_with_label, pl_ps);
  Xg_define_procedure(gtk_toggle_button_new_with_mnemonic, gxg_gtk_toggle_button_new_with_mnemonic_w, 1, 0, 0, H_gtk_toggle_button_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_toggle_button_set_active, gxg_gtk_toggle_button_set_active_w, 2, 0, 0, H_gtk_toggle_button_set_active, pl_tub);
  Xg_define_procedure(gtk_toggle_button_get_active, gxg_gtk_toggle_button_get_active_w, 1, 0, 0, H_gtk_toggle_button_get_active, pl_bu);
  Xg_define_procedure(gtk_toggle_button_toggled, gxg_gtk_toggle_button_toggled_w, 1, 0, 0, H_gtk_toggle_button_toggled, pl_tu);
  Xg_define_procedure(gtk_toolbar_new, gxg_gtk_toolbar_new_w, 0, 0, 0, H_gtk_toolbar_new, pl_p);
  Xg_define_procedure(gtk_toolbar_set_style, gxg_gtk_toolbar_set_style_w, 2, 0, 0, H_gtk_toolbar_set_style, pl_tug);
  Xg_define_procedure(gtk_toolbar_unset_style, gxg_gtk_toolbar_unset_style_w, 1, 0, 0, H_gtk_toolbar_unset_style, pl_tu);
  Xg_define_procedure(gtk_toolbar_get_style, gxg_gtk_toolbar_get_style_w, 1, 0, 0, H_gtk_toolbar_get_style, pl_gu);
  Xg_define_procedure(gtk_tree_drag_source_row_draggable, gxg_gtk_tree_drag_source_row_draggable_w, 2, 0, 0, H_gtk_tree_drag_source_row_draggable, pl_bu);
  Xg_define_procedure(gtk_tree_drag_source_drag_data_delete, gxg_gtk_tree_drag_source_drag_data_delete_w, 2, 0, 0, H_gtk_tree_drag_source_drag_data_delete, pl_bu);
  Xg_define_procedure(gtk_tree_drag_source_drag_data_get, gxg_gtk_tree_drag_source_drag_data_get_w, 3, 0, 0, H_gtk_tree_drag_source_drag_data_get, pl_bu);
  Xg_define_procedure(gtk_tree_drag_dest_drag_data_received, gxg_gtk_tree_drag_dest_drag_data_received_w, 3, 0, 0, H_gtk_tree_drag_dest_drag_data_received, pl_bu);
  Xg_define_procedure(gtk_tree_drag_dest_row_drop_possible, gxg_gtk_tree_drag_dest_row_drop_possible_w, 3, 0, 0, H_gtk_tree_drag_dest_row_drop_possible, pl_bu);
  Xg_define_procedure(gtk_tree_set_row_drag_data, gxg_gtk_tree_set_row_drag_data_w, 3, 0, 0, H_gtk_tree_set_row_drag_data, pl_bu);
  Xg_define_procedure(gtk_tree_get_row_drag_data, gxg_gtk_tree_get_row_drag_data_w, 1, 2, 0, H_gtk_tree_get_row_drag_data, pl_pu);
  Xg_define_procedure(gtk_tree_path_new, gxg_gtk_tree_path_new_w, 0, 0, 0, H_gtk_tree_path_new, pl_p);
  Xg_define_procedure(gtk_tree_path_new_from_string, gxg_gtk_tree_path_new_from_string_w, 1, 0, 0, H_gtk_tree_path_new_from_string, pl_ps);
  Xg_define_procedure(gtk_tree_path_to_string, gxg_gtk_tree_path_to_string_w, 1, 0, 0, H_gtk_tree_path_to_string, pl_su);
  Xg_define_procedure(gtk_tree_path_new_first, gxg_gtk_tree_path_new_first_w, 0, 0, 0, H_gtk_tree_path_new_first, pl_p);
  Xg_define_procedure(gtk_tree_path_append_index, gxg_gtk_tree_path_append_index_w, 2, 0, 0, H_gtk_tree_path_append_index, pl_tui);
  Xg_define_procedure(gtk_tree_path_prepend_index, gxg_gtk_tree_path_prepend_index_w, 2, 0, 0, H_gtk_tree_path_prepend_index, pl_tui);
  Xg_define_procedure(gtk_tree_path_get_depth, gxg_gtk_tree_path_get_depth_w, 1, 0, 0, H_gtk_tree_path_get_depth, pl_iu);
  Xg_define_procedure(gtk_tree_path_get_indices, gxg_gtk_tree_path_get_indices_w, 1, 0, 0, H_gtk_tree_path_get_indices, pl_pu);
  Xg_define_procedure(gtk_tree_path_free, gxg_gtk_tree_path_free_w, 1, 0, 0, H_gtk_tree_path_free, pl_tu);
  Xg_define_procedure(gtk_tree_path_copy, gxg_gtk_tree_path_copy_w, 1, 0, 0, H_gtk_tree_path_copy, pl_pu);
  Xg_define_procedure(gtk_tree_path_compare, gxg_gtk_tree_path_compare_w, 2, 0, 0, H_gtk_tree_path_compare, pl_iu);
  Xg_define_procedure(gtk_tree_path_next, gxg_gtk_tree_path_next_w, 1, 0, 0, H_gtk_tree_path_next, pl_tu);
  Xg_define_procedure(gtk_tree_path_prev, gxg_gtk_tree_path_prev_w, 1, 0, 0, H_gtk_tree_path_prev, pl_bu);
  Xg_define_procedure(gtk_tree_path_up, gxg_gtk_tree_path_up_w, 1, 0, 0, H_gtk_tree_path_up, pl_bu);
  Xg_define_procedure(gtk_tree_path_down, gxg_gtk_tree_path_down_w, 1, 0, 0, H_gtk_tree_path_down, pl_tu);
  Xg_define_procedure(gtk_tree_path_is_ancestor, gxg_gtk_tree_path_is_ancestor_w, 2, 0, 0, H_gtk_tree_path_is_ancestor, pl_bu);
  Xg_define_procedure(gtk_tree_path_is_descendant, gxg_gtk_tree_path_is_descendant_w, 2, 0, 0, H_gtk_tree_path_is_descendant, pl_bu);
  Xg_define_procedure(gtk_tree_row_reference_new, gxg_gtk_tree_row_reference_new_w, 2, 0, 0, H_gtk_tree_row_reference_new, pl_pu);
  Xg_define_procedure(gtk_tree_row_reference_new_proxy, gxg_gtk_tree_row_reference_new_proxy_w, 3, 0, 0, H_gtk_tree_row_reference_new_proxy, pl_pu);
  Xg_define_procedure(gtk_tree_row_reference_get_path, gxg_gtk_tree_row_reference_get_path_w, 1, 0, 0, H_gtk_tree_row_reference_get_path, pl_pu);
  Xg_define_procedure(gtk_tree_row_reference_valid, gxg_gtk_tree_row_reference_valid_w, 1, 0, 0, H_gtk_tree_row_reference_valid, pl_bu);
  Xg_define_procedure(gtk_tree_row_reference_free, gxg_gtk_tree_row_reference_free_w, 1, 0, 0, H_gtk_tree_row_reference_free, pl_tu);
  Xg_define_procedure(gtk_tree_row_reference_inserted, gxg_gtk_tree_row_reference_inserted_w, 2, 0, 0, H_gtk_tree_row_reference_inserted, pl_tu);
  Xg_define_procedure(gtk_tree_row_reference_deleted, gxg_gtk_tree_row_reference_deleted_w, 2, 0, 0, H_gtk_tree_row_reference_deleted, pl_tu);
  Xg_define_procedure(gtk_tree_row_reference_reordered, gxg_gtk_tree_row_reference_reordered_w, 4, 0, 0, H_gtk_tree_row_reference_reordered, pl_tu);
  Xg_define_procedure(gtk_tree_iter_copy, gxg_gtk_tree_iter_copy_w, 1, 0, 0, H_gtk_tree_iter_copy, pl_pu);
  Xg_define_procedure(gtk_tree_iter_free, gxg_gtk_tree_iter_free_w, 1, 0, 0, H_gtk_tree_iter_free, pl_tu);
  Xg_define_procedure(gtk_tree_model_get_flags, gxg_gtk_tree_model_get_flags_w, 1, 0, 0, H_gtk_tree_model_get_flags, pl_gu);
  Xg_define_procedure(gtk_tree_model_get_n_columns, gxg_gtk_tree_model_get_n_columns_w, 1, 0, 0, H_gtk_tree_model_get_n_columns, pl_iu);
  Xg_define_procedure(gtk_tree_model_get_column_type, gxg_gtk_tree_model_get_column_type_w, 2, 0, 0, H_gtk_tree_model_get_column_type, pl_iui);
  Xg_define_procedure(gtk_tree_model_get_iter, gxg_gtk_tree_model_get_iter_w, 3, 0, 0, H_gtk_tree_model_get_iter, pl_bu);
  Xg_define_procedure(gtk_tree_model_get_iter_from_string, gxg_gtk_tree_model_get_iter_from_string_w, 3, 0, 0, H_gtk_tree_model_get_iter_from_string, pl_buus);
  Xg_define_procedure(gtk_tree_model_get_iter_first, gxg_gtk_tree_model_get_iter_first_w, 2, 0, 0, H_gtk_tree_model_get_iter_first, pl_bu);
  Xg_define_procedure(gtk_tree_model_get_path, gxg_gtk_tree_model_get_path_w, 2, 0, 0, H_gtk_tree_model_get_path, pl_pu);
  Xg_define_procedure(gtk_tree_model_iter_next, gxg_gtk_tree_model_iter_next_w, 2, 0, 0, H_gtk_tree_model_iter_next, pl_bu);
  Xg_define_procedure(gtk_tree_model_iter_children, gxg_gtk_tree_model_iter_children_w, 3, 0, 0, H_gtk_tree_model_iter_children, pl_bu);
  Xg_define_procedure(gtk_tree_model_iter_has_child, gxg_gtk_tree_model_iter_has_child_w, 2, 0, 0, H_gtk_tree_model_iter_has_child, pl_bu);
  Xg_define_procedure(gtk_tree_model_iter_n_children, gxg_gtk_tree_model_iter_n_children_w, 2, 0, 0, H_gtk_tree_model_iter_n_children, pl_iu);
  Xg_define_procedure(gtk_tree_model_iter_nth_child, gxg_gtk_tree_model_iter_nth_child_w, 4, 0, 0, H_gtk_tree_model_iter_nth_child, pl_buuui);
  Xg_define_procedure(gtk_tree_model_iter_parent, gxg_gtk_tree_model_iter_parent_w, 3, 0, 0, H_gtk_tree_model_iter_parent, pl_bu);
  Xg_define_procedure(gtk_tree_model_ref_node, gxg_gtk_tree_model_ref_node_w, 2, 0, 0, H_gtk_tree_model_ref_node, pl_tu);
  Xg_define_procedure(gtk_tree_model_unref_node, gxg_gtk_tree_model_unref_node_w, 2, 0, 0, H_gtk_tree_model_unref_node, pl_tu);
  Xg_define_procedure(gtk_tree_model_foreach, gxg_gtk_tree_model_foreach_w, 3, 0, 0, H_gtk_tree_model_foreach, pl_tut);
  Xg_define_procedure(gtk_tree_model_row_changed, gxg_gtk_tree_model_row_changed_w, 3, 0, 0, H_gtk_tree_model_row_changed, pl_tu);
  Xg_define_procedure(gtk_tree_model_row_inserted, gxg_gtk_tree_model_row_inserted_w, 3, 0, 0, H_gtk_tree_model_row_inserted, pl_tu);
  Xg_define_procedure(gtk_tree_model_row_has_child_toggled, gxg_gtk_tree_model_row_has_child_toggled_w, 3, 0, 0, H_gtk_tree_model_row_has_child_toggled, pl_tu);
  Xg_define_procedure(gtk_tree_model_row_deleted, gxg_gtk_tree_model_row_deleted_w, 2, 0, 0, H_gtk_tree_model_row_deleted, pl_tu);
  Xg_define_procedure(gtk_tree_model_rows_reordered, gxg_gtk_tree_model_rows_reordered_w, 4, 0, 0, H_gtk_tree_model_rows_reordered, pl_tu);
  Xg_define_procedure(gtk_tree_model_sort_new_with_model, gxg_gtk_tree_model_sort_new_with_model_w, 1, 0, 0, H_gtk_tree_model_sort_new_with_model, pl_pu);
  Xg_define_procedure(gtk_tree_model_sort_get_model, gxg_gtk_tree_model_sort_get_model_w, 1, 0, 0, H_gtk_tree_model_sort_get_model, pl_pu);
  Xg_define_procedure(gtk_tree_model_sort_convert_child_path_to_path, gxg_gtk_tree_model_sort_convert_child_path_to_path_w, 2, 0, 0, H_gtk_tree_model_sort_convert_child_path_to_path, pl_pu);
  Xg_define_procedure(gtk_tree_model_sort_convert_child_iter_to_iter, gxg_gtk_tree_model_sort_convert_child_iter_to_iter_w, 3, 0, 0, H_gtk_tree_model_sort_convert_child_iter_to_iter, pl_tu);
  Xg_define_procedure(gtk_tree_model_sort_convert_path_to_child_path, gxg_gtk_tree_model_sort_convert_path_to_child_path_w, 2, 0, 0, H_gtk_tree_model_sort_convert_path_to_child_path, pl_pu);
  Xg_define_procedure(gtk_tree_model_sort_convert_iter_to_child_iter, gxg_gtk_tree_model_sort_convert_iter_to_child_iter_w, 3, 0, 0, H_gtk_tree_model_sort_convert_iter_to_child_iter, pl_tu);
  Xg_define_procedure(gtk_tree_model_sort_reset_default_sort_func, gxg_gtk_tree_model_sort_reset_default_sort_func_w, 1, 0, 0, H_gtk_tree_model_sort_reset_default_sort_func, pl_tu);
  Xg_define_procedure(gtk_tree_model_sort_clear_cache, gxg_gtk_tree_model_sort_clear_cache_w, 1, 0, 0, H_gtk_tree_model_sort_clear_cache, pl_tu);
  Xg_define_procedure(gtk_tree_selection_set_mode, gxg_gtk_tree_selection_set_mode_w, 2, 0, 0, H_gtk_tree_selection_set_mode, pl_tug);
  Xg_define_procedure(gtk_tree_selection_get_mode, gxg_gtk_tree_selection_get_mode_w, 1, 0, 0, H_gtk_tree_selection_get_mode, pl_gu);
  Xg_define_procedure(gtk_tree_selection_set_select_function, gxg_gtk_tree_selection_set_select_function_w, 4, 0, 0, H_gtk_tree_selection_set_select_function, pl_tut);
  Xg_define_procedure(gtk_tree_selection_get_user_data, gxg_gtk_tree_selection_get_user_data_w, 1, 0, 0, H_gtk_tree_selection_get_user_data, pl_tu);
  Xg_define_procedure(gtk_tree_selection_get_tree_view, gxg_gtk_tree_selection_get_tree_view_w, 1, 0, 0, H_gtk_tree_selection_get_tree_view, pl_pu);
  Xg_define_procedure(gtk_tree_selection_get_selected, gxg_gtk_tree_selection_get_selected_w, 3, 0, 0, H_gtk_tree_selection_get_selected, pl_bu);
  Xg_define_procedure(gtk_tree_selection_selected_foreach, gxg_gtk_tree_selection_selected_foreach_w, 3, 0, 0, H_gtk_tree_selection_selected_foreach, pl_tut);
  Xg_define_procedure(gtk_tree_selection_select_path, gxg_gtk_tree_selection_select_path_w, 2, 0, 0, H_gtk_tree_selection_select_path, pl_tu);
  Xg_define_procedure(gtk_tree_selection_unselect_path, gxg_gtk_tree_selection_unselect_path_w, 2, 0, 0, H_gtk_tree_selection_unselect_path, pl_tu);
  Xg_define_procedure(gtk_tree_selection_select_iter, gxg_gtk_tree_selection_select_iter_w, 2, 0, 0, H_gtk_tree_selection_select_iter, pl_tu);
  Xg_define_procedure(gtk_tree_selection_unselect_iter, gxg_gtk_tree_selection_unselect_iter_w, 2, 0, 0, H_gtk_tree_selection_unselect_iter, pl_tu);
  Xg_define_procedure(gtk_tree_selection_path_is_selected, gxg_gtk_tree_selection_path_is_selected_w, 2, 0, 0, H_gtk_tree_selection_path_is_selected, pl_bu);
  Xg_define_procedure(gtk_tree_selection_iter_is_selected, gxg_gtk_tree_selection_iter_is_selected_w, 2, 0, 0, H_gtk_tree_selection_iter_is_selected, pl_bu);
  Xg_define_procedure(gtk_tree_selection_select_all, gxg_gtk_tree_selection_select_all_w, 1, 0, 0, H_gtk_tree_selection_select_all, pl_tu);
  Xg_define_procedure(gtk_tree_selection_unselect_all, gxg_gtk_tree_selection_unselect_all_w, 1, 0, 0, H_gtk_tree_selection_unselect_all, pl_tu);
  Xg_define_procedure(gtk_tree_selection_select_range, gxg_gtk_tree_selection_select_range_w, 3, 0, 0, H_gtk_tree_selection_select_range, pl_tu);
  Xg_define_procedure(gtk_tree_sortable_sort_column_changed, gxg_gtk_tree_sortable_sort_column_changed_w, 1, 0, 0, H_gtk_tree_sortable_sort_column_changed, pl_tu);
  Xg_define_procedure(gtk_tree_sortable_get_sort_column_id, gxg_gtk_tree_sortable_get_sort_column_id_w, 1, 2, 0, H_gtk_tree_sortable_get_sort_column_id, pl_pu);
  Xg_define_procedure(gtk_tree_sortable_set_sort_column_id, gxg_gtk_tree_sortable_set_sort_column_id_w, 3, 0, 0, H_gtk_tree_sortable_set_sort_column_id, pl_tuig);
  Xg_define_procedure(gtk_tree_sortable_set_sort_func, gxg_gtk_tree_sortable_set_sort_func_w, 5, 0, 0, H_gtk_tree_sortable_set_sort_func, pl_tuit);
  Xg_define_procedure(gtk_tree_sortable_set_default_sort_func, gxg_gtk_tree_sortable_set_default_sort_func_w, 4, 0, 0, H_gtk_tree_sortable_set_default_sort_func, pl_tut);
  Xg_define_procedure(gtk_tree_sortable_has_default_sort_func, gxg_gtk_tree_sortable_has_default_sort_func_w, 1, 0, 0, H_gtk_tree_sortable_has_default_sort_func, pl_bu);
  Xg_define_procedure(gtk_tree_store_new, gxg_gtk_tree_store_new_w, 2, 0, 0, H_gtk_tree_store_new, pl_pit);
  Xg_define_procedure(gtk_tree_store_newv, gxg_gtk_tree_store_newv_w, 2, 0, 0, H_gtk_tree_store_newv, pl_piu);
  Xg_define_procedure(gtk_tree_store_set_column_types, gxg_gtk_tree_store_set_column_types_w, 3, 0, 0, H_gtk_tree_store_set_column_types, pl_tuiu);
  Xg_define_procedure(gtk_tree_store_set, gxg_gtk_tree_store_set_w, 3, 0, 0, H_gtk_tree_store_set, pl_tuut);
  Xg_define_procedure(gtk_tree_store_remove, gxg_gtk_tree_store_remove_w, 2, 0, 0, H_gtk_tree_store_remove, pl_tu);
  Xg_define_procedure(gtk_tree_store_insert, gxg_gtk_tree_store_insert_w, 4, 0, 0, H_gtk_tree_store_insert, pl_tuuui);
  Xg_define_procedure(gtk_tree_store_insert_before, gxg_gtk_tree_store_insert_before_w, 4, 0, 0, H_gtk_tree_store_insert_before, pl_tu);
  Xg_define_procedure(gtk_tree_store_insert_after, gxg_gtk_tree_store_insert_after_w, 4, 0, 0, H_gtk_tree_store_insert_after, pl_tu);
  Xg_define_procedure(gtk_tree_store_prepend, gxg_gtk_tree_store_prepend_w, 3, 0, 0, H_gtk_tree_store_prepend, pl_tu);
  Xg_define_procedure(gtk_tree_store_append, gxg_gtk_tree_store_append_w, 3, 0, 0, H_gtk_tree_store_append, pl_tu);
  Xg_define_procedure(gtk_tree_store_is_ancestor, gxg_gtk_tree_store_is_ancestor_w, 3, 0, 0, H_gtk_tree_store_is_ancestor, pl_bu);
  Xg_define_procedure(gtk_tree_store_iter_depth, gxg_gtk_tree_store_iter_depth_w, 2, 0, 0, H_gtk_tree_store_iter_depth, pl_iu);
  Xg_define_procedure(gtk_tree_store_clear, gxg_gtk_tree_store_clear_w, 1, 0, 0, H_gtk_tree_store_clear, pl_tu);
  Xg_define_procedure(gtk_tree_view_column_new, gxg_gtk_tree_view_column_new_w, 0, 0, 0, H_gtk_tree_view_column_new, pl_p);
  Xg_define_procedure(gtk_tree_view_column_new_with_attributes, gxg_gtk_tree_view_column_new_with_attributes_w, 3, 0, 0, H_gtk_tree_view_column_new_with_attributes, pl_psut);
  Xg_define_procedure(gtk_tree_view_column_pack_start, gxg_gtk_tree_view_column_pack_start_w, 3, 0, 0, H_gtk_tree_view_column_pack_start, pl_tuub);
  Xg_define_procedure(gtk_tree_view_column_pack_end, gxg_gtk_tree_view_column_pack_end_w, 3, 0, 0, H_gtk_tree_view_column_pack_end, pl_tuub);
  Xg_define_procedure(gtk_tree_view_column_clear, gxg_gtk_tree_view_column_clear_w, 1, 0, 0, H_gtk_tree_view_column_clear, pl_tu);
  Xg_define_procedure(gtk_tree_view_column_add_attribute, gxg_gtk_tree_view_column_add_attribute_w, 4, 0, 0, H_gtk_tree_view_column_add_attribute, pl_tuusi);
  Xg_define_procedure(gtk_tree_view_column_set_attributes, gxg_gtk_tree_view_column_set_attributes_w, 3, 0, 0, H_gtk_tree_view_column_set_attributes, pl_tuut);
  Xg_define_procedure(gtk_tree_view_column_set_cell_data_func, gxg_gtk_tree_view_column_set_cell_data_func_w, 5, 0, 0, H_gtk_tree_view_column_set_cell_data_func, pl_tuut);
  Xg_define_procedure(gtk_tree_view_column_clear_attributes, gxg_gtk_tree_view_column_clear_attributes_w, 2, 0, 0, H_gtk_tree_view_column_clear_attributes, pl_tu);
  Xg_define_procedure(gtk_tree_view_column_set_spacing, gxg_gtk_tree_view_column_set_spacing_w, 2, 0, 0, H_gtk_tree_view_column_set_spacing, pl_tui);
  Xg_define_procedure(gtk_tree_view_column_get_spacing, gxg_gtk_tree_view_column_get_spacing_w, 1, 0, 0, H_gtk_tree_view_column_get_spacing, pl_iu);
  Xg_define_procedure(gtk_tree_view_column_set_visible, gxg_gtk_tree_view_column_set_visible_w, 2, 0, 0, H_gtk_tree_view_column_set_visible, pl_tub);
  Xg_define_procedure(gtk_tree_view_column_get_visible, gxg_gtk_tree_view_column_get_visible_w, 1, 0, 0, H_gtk_tree_view_column_get_visible, pl_bu);
  Xg_define_procedure(gtk_tree_view_column_set_resizable, gxg_gtk_tree_view_column_set_resizable_w, 2, 0, 0, H_gtk_tree_view_column_set_resizable, pl_tub);
  Xg_define_procedure(gtk_tree_view_column_get_resizable, gxg_gtk_tree_view_column_get_resizable_w, 1, 0, 0, H_gtk_tree_view_column_get_resizable, pl_bu);
  Xg_define_procedure(gtk_tree_view_column_set_sizing, gxg_gtk_tree_view_column_set_sizing_w, 2, 0, 0, H_gtk_tree_view_column_set_sizing, pl_tug);
  Xg_define_procedure(gtk_tree_view_column_get_sizing, gxg_gtk_tree_view_column_get_sizing_w, 1, 0, 0, H_gtk_tree_view_column_get_sizing, pl_gu);
  Xg_define_procedure(gtk_tree_view_column_get_width, gxg_gtk_tree_view_column_get_width_w, 1, 0, 0, H_gtk_tree_view_column_get_width, pl_iu);
  Xg_define_procedure(gtk_tree_view_column_get_fixed_width, gxg_gtk_tree_view_column_get_fixed_width_w, 1, 0, 0, H_gtk_tree_view_column_get_fixed_width, pl_iu);
  Xg_define_procedure(gtk_tree_view_column_set_fixed_width, gxg_gtk_tree_view_column_set_fixed_width_w, 2, 0, 0, H_gtk_tree_view_column_set_fixed_width, pl_tui);
  Xg_define_procedure(gtk_tree_view_column_set_min_width, gxg_gtk_tree_view_column_set_min_width_w, 2, 0, 0, H_gtk_tree_view_column_set_min_width, pl_tui);
  Xg_define_procedure(gtk_tree_view_column_get_min_width, gxg_gtk_tree_view_column_get_min_width_w, 1, 0, 0, H_gtk_tree_view_column_get_min_width, pl_iu);
  Xg_define_procedure(gtk_tree_view_column_set_max_width, gxg_gtk_tree_view_column_set_max_width_w, 2, 0, 0, H_gtk_tree_view_column_set_max_width, pl_tui);
  Xg_define_procedure(gtk_tree_view_column_get_max_width, gxg_gtk_tree_view_column_get_max_width_w, 1, 0, 0, H_gtk_tree_view_column_get_max_width, pl_iu);
  Xg_define_procedure(gtk_tree_view_column_clicked, gxg_gtk_tree_view_column_clicked_w, 1, 0, 0, H_gtk_tree_view_column_clicked, pl_tu);
  Xg_define_procedure(gtk_tree_view_column_set_title, gxg_gtk_tree_view_column_set_title_w, 2, 0, 0, H_gtk_tree_view_column_set_title, pl_tus);
  Xg_define_procedure(gtk_tree_view_column_get_title, gxg_gtk_tree_view_column_get_title_w, 1, 0, 0, H_gtk_tree_view_column_get_title, pl_su);
  Xg_define_procedure(gtk_tree_view_column_set_clickable, gxg_gtk_tree_view_column_set_clickable_w, 2, 0, 0, H_gtk_tree_view_column_set_clickable, pl_tub);
  Xg_define_procedure(gtk_tree_view_column_get_clickable, gxg_gtk_tree_view_column_get_clickable_w, 1, 0, 0, H_gtk_tree_view_column_get_clickable, pl_bu);
  Xg_define_procedure(gtk_tree_view_column_set_widget, gxg_gtk_tree_view_column_set_widget_w, 2, 0, 0, H_gtk_tree_view_column_set_widget, pl_tu);
  Xg_define_procedure(gtk_tree_view_column_get_widget, gxg_gtk_tree_view_column_get_widget_w, 1, 0, 0, H_gtk_tree_view_column_get_widget, pl_pu);
  Xg_define_procedure(gtk_tree_view_column_set_alignment, gxg_gtk_tree_view_column_set_alignment_w, 2, 0, 0, H_gtk_tree_view_column_set_alignment, pl_tur);
  Xg_define_procedure(gtk_tree_view_column_get_alignment, gxg_gtk_tree_view_column_get_alignment_w, 1, 0, 0, H_gtk_tree_view_column_get_alignment, pl_du);
  Xg_define_procedure(gtk_tree_view_column_set_reorderable, gxg_gtk_tree_view_column_set_reorderable_w, 2, 0, 0, H_gtk_tree_view_column_set_reorderable, pl_tub);
  Xg_define_procedure(gtk_tree_view_column_get_reorderable, gxg_gtk_tree_view_column_get_reorderable_w, 1, 0, 0, H_gtk_tree_view_column_get_reorderable, pl_bu);
  Xg_define_procedure(gtk_tree_view_column_set_sort_column_id, gxg_gtk_tree_view_column_set_sort_column_id_w, 2, 0, 0, H_gtk_tree_view_column_set_sort_column_id, pl_tui);
  Xg_define_procedure(gtk_tree_view_column_get_sort_column_id, gxg_gtk_tree_view_column_get_sort_column_id_w, 1, 0, 0, H_gtk_tree_view_column_get_sort_column_id, pl_iu);
  Xg_define_procedure(gtk_tree_view_column_set_sort_indicator, gxg_gtk_tree_view_column_set_sort_indicator_w, 2, 0, 0, H_gtk_tree_view_column_set_sort_indicator, pl_tub);
  Xg_define_procedure(gtk_tree_view_column_get_sort_indicator, gxg_gtk_tree_view_column_get_sort_indicator_w, 1, 0, 0, H_gtk_tree_view_column_get_sort_indicator, pl_bu);
  Xg_define_procedure(gtk_tree_view_column_set_sort_order, gxg_gtk_tree_view_column_set_sort_order_w, 2, 0, 0, H_gtk_tree_view_column_set_sort_order, pl_tug);
  Xg_define_procedure(gtk_tree_view_column_get_sort_order, gxg_gtk_tree_view_column_get_sort_order_w, 1, 0, 0, H_gtk_tree_view_column_get_sort_order, pl_gu);
  Xg_define_procedure(gtk_tree_view_column_cell_set_cell_data, gxg_gtk_tree_view_column_cell_set_cell_data_w, 5, 0, 0, H_gtk_tree_view_column_cell_set_cell_data, pl_tuuub);
  Xg_define_procedure(gtk_tree_view_column_cell_get_size, gxg_gtk_tree_view_column_cell_get_size_w, 2, 4, 0, H_gtk_tree_view_column_cell_get_size, pl_pu);
  Xg_define_procedure(gtk_tree_view_column_cell_is_visible, gxg_gtk_tree_view_column_cell_is_visible_w, 1, 0, 0, H_gtk_tree_view_column_cell_is_visible, pl_bu);
  Xg_define_procedure(gtk_tree_view_column_cell_get_position, gxg_gtk_tree_view_column_cell_get_position_w, 2, 2, 0, H_gtk_tree_view_column_cell_get_position, pl_pu);
  Xg_define_procedure(gtk_tree_view_new, gxg_gtk_tree_view_new_w, 0, 0, 0, H_gtk_tree_view_new, pl_p);
  Xg_define_procedure(gtk_tree_view_new_with_model, gxg_gtk_tree_view_new_with_model_w, 1, 0, 0, H_gtk_tree_view_new_with_model, pl_pu);
  Xg_define_procedure(gtk_tree_view_get_model, gxg_gtk_tree_view_get_model_w, 1, 0, 0, H_gtk_tree_view_get_model, pl_pu);
  Xg_define_procedure(gtk_tree_view_set_model, gxg_gtk_tree_view_set_model_w, 2, 0, 0, H_gtk_tree_view_set_model, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_selection, gxg_gtk_tree_view_get_selection_w, 1, 0, 0, H_gtk_tree_view_get_selection, pl_pu);
  Xg_define_procedure(gtk_tree_view_get_headers_visible, gxg_gtk_tree_view_get_headers_visible_w, 1, 0, 0, H_gtk_tree_view_get_headers_visible, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_headers_visible, gxg_gtk_tree_view_set_headers_visible_w, 2, 0, 0, H_gtk_tree_view_set_headers_visible, pl_tub);
  Xg_define_procedure(gtk_tree_view_columns_autosize, gxg_gtk_tree_view_columns_autosize_w, 1, 0, 0, H_gtk_tree_view_columns_autosize, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_headers_clickable, gxg_gtk_tree_view_set_headers_clickable_w, 2, 0, 0, H_gtk_tree_view_set_headers_clickable, pl_tub);
  Xg_define_procedure(gtk_tree_view_append_column, gxg_gtk_tree_view_append_column_w, 2, 0, 0, H_gtk_tree_view_append_column, pl_iu);
  Xg_define_procedure(gtk_tree_view_remove_column, gxg_gtk_tree_view_remove_column_w, 2, 0, 0, H_gtk_tree_view_remove_column, pl_iu);
  Xg_define_procedure(gtk_tree_view_insert_column, gxg_gtk_tree_view_insert_column_w, 3, 0, 0, H_gtk_tree_view_insert_column, pl_iuui);
  Xg_define_procedure(gtk_tree_view_insert_column_with_attributes, gxg_gtk_tree_view_insert_column_with_attributes_w, 5, 0, 0, H_gtk_tree_view_insert_column_with_attributes, pl_iuisut);
  Xg_define_procedure(gtk_tree_view_insert_column_with_data_func, gxg_gtk_tree_view_insert_column_with_data_func_w, 7, 0, 0, H_gtk_tree_view_insert_column_with_data_func, pl_iuisut);
  Xg_define_procedure(gtk_tree_view_get_column, gxg_gtk_tree_view_get_column_w, 2, 0, 0, H_gtk_tree_view_get_column, pl_pui);
  Xg_define_procedure(gtk_tree_view_get_columns, gxg_gtk_tree_view_get_columns_w, 1, 0, 0, H_gtk_tree_view_get_columns, pl_pu);
  Xg_define_procedure(gtk_tree_view_move_column_after, gxg_gtk_tree_view_move_column_after_w, 3, 0, 0, H_gtk_tree_view_move_column_after, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_expander_column, gxg_gtk_tree_view_set_expander_column_w, 2, 0, 0, H_gtk_tree_view_set_expander_column, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_expander_column, gxg_gtk_tree_view_get_expander_column_w, 1, 0, 0, H_gtk_tree_view_get_expander_column, pl_pu);
  Xg_define_procedure(gtk_tree_view_set_column_drag_function, gxg_gtk_tree_view_set_column_drag_function_w, 4, 0, 0, H_gtk_tree_view_set_column_drag_function, pl_tut);
  Xg_define_procedure(gtk_tree_view_scroll_to_point, gxg_gtk_tree_view_scroll_to_point_w, 3, 0, 0, H_gtk_tree_view_scroll_to_point, pl_tui);
  Xg_define_procedure(gtk_tree_view_scroll_to_cell, gxg_gtk_tree_view_scroll_to_cell_w, 6, 0, 0, H_gtk_tree_view_scroll_to_cell, pl_tuuubr);
  Xg_define_procedure(gtk_tree_view_row_activated, gxg_gtk_tree_view_row_activated_w, 3, 0, 0, H_gtk_tree_view_row_activated, pl_tu);
  Xg_define_procedure(gtk_tree_view_expand_all, gxg_gtk_tree_view_expand_all_w, 1, 0, 0, H_gtk_tree_view_expand_all, pl_tu);
  Xg_define_procedure(gtk_tree_view_collapse_all, gxg_gtk_tree_view_collapse_all_w, 1, 0, 0, H_gtk_tree_view_collapse_all, pl_tu);
  Xg_define_procedure(gtk_tree_view_expand_row, gxg_gtk_tree_view_expand_row_w, 3, 0, 0, H_gtk_tree_view_expand_row, pl_buub);
  Xg_define_procedure(gtk_tree_view_collapse_row, gxg_gtk_tree_view_collapse_row_w, 2, 0, 0, H_gtk_tree_view_collapse_row, pl_bu);
  Xg_define_procedure(gtk_tree_view_map_expanded_rows, gxg_gtk_tree_view_map_expanded_rows_w, 3, 0, 0, H_gtk_tree_view_map_expanded_rows, pl_tut);
  Xg_define_procedure(gtk_tree_view_row_expanded, gxg_gtk_tree_view_row_expanded_w, 2, 0, 0, H_gtk_tree_view_row_expanded, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_reorderable, gxg_gtk_tree_view_set_reorderable_w, 2, 0, 0, H_gtk_tree_view_set_reorderable, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_reorderable, gxg_gtk_tree_view_get_reorderable_w, 1, 0, 0, H_gtk_tree_view_get_reorderable, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_cursor, gxg_gtk_tree_view_set_cursor_w, 4, 0, 0, H_gtk_tree_view_set_cursor, pl_tuuub);
  Xg_define_procedure(gtk_tree_view_get_cursor, gxg_gtk_tree_view_get_cursor_w, 1, 2, 0, H_gtk_tree_view_get_cursor, pl_pu);
  Xg_define_procedure(gtk_tree_view_get_path_at_pos, gxg_gtk_tree_view_get_path_at_pos_w, 3, 4, 0, H_gtk_tree_view_get_path_at_pos, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_get_cell_area, gxg_gtk_tree_view_get_cell_area_w, 4, 0, 0, H_gtk_tree_view_get_cell_area, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_background_area, gxg_gtk_tree_view_get_background_area_w, 4, 0, 0, H_gtk_tree_view_get_background_area, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_visible_rect, gxg_gtk_tree_view_get_visible_rect_w, 2, 0, 0, H_gtk_tree_view_get_visible_rect, pl_tu);
  Xg_define_procedure(gtk_tree_view_unset_rows_drag_source, gxg_gtk_tree_view_unset_rows_drag_source_w, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_source, pl_tu);
  Xg_define_procedure(gtk_tree_view_unset_rows_drag_dest, gxg_gtk_tree_view_unset_rows_drag_dest_w, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_dest, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_drag_dest_row, gxg_gtk_tree_view_set_drag_dest_row_w, 3, 0, 0, H_gtk_tree_view_set_drag_dest_row, pl_tuug);
  Xg_define_procedure(gtk_tree_view_get_drag_dest_row, gxg_gtk_tree_view_get_drag_dest_row_w, 1, 2, 0, H_gtk_tree_view_get_drag_dest_row, pl_pu);
  Xg_define_procedure(gtk_tree_view_get_dest_row_at_pos, gxg_gtk_tree_view_get_dest_row_at_pos_w, 3, 2, 0, H_gtk_tree_view_get_dest_row_at_pos, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_set_enable_search, gxg_gtk_tree_view_set_enable_search_w, 2, 0, 0, H_gtk_tree_view_set_enable_search, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_enable_search, gxg_gtk_tree_view_get_enable_search_w, 1, 0, 0, H_gtk_tree_view_get_enable_search, pl_bu);
  Xg_define_procedure(gtk_tree_view_get_search_column, gxg_gtk_tree_view_get_search_column_w, 1, 0, 0, H_gtk_tree_view_get_search_column, pl_iu);
  Xg_define_procedure(gtk_tree_view_set_search_column, gxg_gtk_tree_view_set_search_column_w, 2, 0, 0, H_gtk_tree_view_set_search_column, pl_tui);
  Xg_define_procedure(gtk_tree_view_get_search_equal_func, gxg_gtk_tree_view_get_search_equal_func_w, 1, 0, 0, H_gtk_tree_view_get_search_equal_func, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_search_equal_func, gxg_gtk_tree_view_set_search_equal_func_w, 4, 0, 0, H_gtk_tree_view_set_search_equal_func, pl_tut);
  Xg_define_procedure(gtk_viewport_new, gxg_gtk_viewport_new_w, 2, 0, 0, H_gtk_viewport_new, pl_pu);
  Xg_define_procedure(gtk_viewport_set_shadow_type, gxg_gtk_viewport_set_shadow_type_w, 2, 0, 0, H_gtk_viewport_set_shadow_type, pl_tug);
  Xg_define_procedure(gtk_viewport_get_shadow_type, gxg_gtk_viewport_get_shadow_type_w, 1, 0, 0, H_gtk_viewport_get_shadow_type, pl_gu);
  Xg_define_procedure(gtk_widget_destroy, gxg_gtk_widget_destroy_w, 1, 0, 0, H_gtk_widget_destroy, pl_tu);
  Xg_define_procedure(gtk_widget_destroyed, gxg_gtk_widget_destroyed_w, 1, 1, 0, H_gtk_widget_destroyed, pl_pu);
  Xg_define_procedure(gtk_widget_unparent, gxg_gtk_widget_unparent_w, 1, 0, 0, H_gtk_widget_unparent, pl_tu);
  Xg_define_procedure(gtk_widget_show, gxg_gtk_widget_show_w, 1, 0, 0, H_gtk_widget_show, pl_tu);
  Xg_define_procedure(gtk_widget_show_now, gxg_gtk_widget_show_now_w, 1, 0, 0, H_gtk_widget_show_now, pl_tu);
  Xg_define_procedure(gtk_widget_hide, gxg_gtk_widget_hide_w, 1, 0, 0, H_gtk_widget_hide, pl_tu);
  Xg_define_procedure(gtk_widget_map, gxg_gtk_widget_map_w, 1, 0, 0, H_gtk_widget_map, pl_tu);
  Xg_define_procedure(gtk_widget_unmap, gxg_gtk_widget_unmap_w, 1, 0, 0, H_gtk_widget_unmap, pl_tu);
  Xg_define_procedure(gtk_widget_realize, gxg_gtk_widget_realize_w, 1, 0, 0, H_gtk_widget_realize, pl_tu);
  Xg_define_procedure(gtk_widget_unrealize, gxg_gtk_widget_unrealize_w, 1, 0, 0, H_gtk_widget_unrealize, pl_tu);
  Xg_define_procedure(gtk_widget_queue_draw, gxg_gtk_widget_queue_draw_w, 1, 0, 0, H_gtk_widget_queue_draw, pl_tu);
  Xg_define_procedure(gtk_widget_queue_draw_area, gxg_gtk_widget_queue_draw_area_w, 5, 0, 0, H_gtk_widget_queue_draw_area, pl_tui);
  Xg_define_procedure(gtk_widget_queue_resize, gxg_gtk_widget_queue_resize_w, 1, 0, 0, H_gtk_widget_queue_resize, pl_tu);
  Xg_define_procedure(gtk_widget_add_accelerator, gxg_gtk_widget_add_accelerator_w, 6, 0, 0, H_gtk_widget_add_accelerator, pl_tusuig);
  Xg_define_procedure(gtk_widget_remove_accelerator, gxg_gtk_widget_remove_accelerator_w, 4, 0, 0, H_gtk_widget_remove_accelerator, pl_buuig);
  Xg_define_procedure(gtk_widget_list_accel_closures, gxg_gtk_widget_list_accel_closures_w, 1, 0, 0, H_gtk_widget_list_accel_closures, pl_pu);
  Xg_define_procedure(gtk_widget_mnemonic_activate, gxg_gtk_widget_mnemonic_activate_w, 2, 0, 0, H_gtk_widget_mnemonic_activate, pl_bub);
  Xg_define_procedure(gtk_widget_event, gxg_gtk_widget_event_w, 2, 0, 0, H_gtk_widget_event, pl_bu);
  Xg_define_procedure(gtk_widget_activate, gxg_gtk_widget_activate_w, 1, 0, 0, H_gtk_widget_activate, pl_bu);
  Xg_define_procedure(gtk_widget_intersect, gxg_gtk_widget_intersect_w, 3, 0, 0, H_gtk_widget_intersect, pl_bu);
  Xg_define_procedure(gtk_widget_freeze_child_notify, gxg_gtk_widget_freeze_child_notify_w, 1, 0, 0, H_gtk_widget_freeze_child_notify, pl_tu);
  Xg_define_procedure(gtk_widget_child_notify, gxg_gtk_widget_child_notify_w, 2, 0, 0, H_gtk_widget_child_notify, pl_tus);
  Xg_define_procedure(gtk_widget_thaw_child_notify, gxg_gtk_widget_thaw_child_notify_w, 1, 0, 0, H_gtk_widget_thaw_child_notify, pl_tu);
  Xg_define_procedure(gtk_widget_is_focus, gxg_gtk_widget_is_focus_w, 1, 0, 0, H_gtk_widget_is_focus, pl_bu);
  Xg_define_procedure(gtk_widget_grab_focus, gxg_gtk_widget_grab_focus_w, 1, 0, 0, H_gtk_widget_grab_focus, pl_tu);
  Xg_define_procedure(gtk_widget_grab_default, gxg_gtk_widget_grab_default_w, 1, 0, 0, H_gtk_widget_grab_default, pl_tu);
  Xg_define_procedure(gtk_widget_set_name, gxg_gtk_widget_set_name_w, 2, 0, 0, H_gtk_widget_set_name, pl_tus);
  Xg_define_procedure(gtk_widget_get_name, gxg_gtk_widget_get_name_w, 1, 0, 0, H_gtk_widget_get_name, pl_su);
  Xg_define_procedure(gtk_widget_set_sensitive, gxg_gtk_widget_set_sensitive_w, 2, 0, 0, H_gtk_widget_set_sensitive, pl_tub);
  Xg_define_procedure(gtk_widget_set_parent, gxg_gtk_widget_set_parent_w, 2, 0, 0, H_gtk_widget_set_parent, pl_tu);
  Xg_define_procedure(gtk_widget_set_parent_window, gxg_gtk_widget_set_parent_window_w, 2, 0, 0, H_gtk_widget_set_parent_window, pl_tu);
  Xg_define_procedure(gtk_widget_set_child_visible, gxg_gtk_widget_set_child_visible_w, 2, 0, 0, H_gtk_widget_set_child_visible, pl_tub);
  Xg_define_procedure(gtk_widget_set_accel_path, gxg_gtk_widget_set_accel_path_w, 3, 0, 0, H_gtk_widget_set_accel_path, pl_tusu);
  Xg_define_procedure(gtk_widget_get_child_visible, gxg_gtk_widget_get_child_visible_w, 1, 0, 0, H_gtk_widget_get_child_visible, pl_bu);
  Xg_define_procedure(gtk_widget_get_parent, gxg_gtk_widget_get_parent_w, 1, 0, 0, H_gtk_widget_get_parent, pl_pu);
  Xg_define_procedure(gtk_widget_get_parent_window, gxg_gtk_widget_get_parent_window_w, 1, 0, 0, H_gtk_widget_get_parent_window, pl_pu);
  Xg_define_procedure(gtk_widget_child_focus, gxg_gtk_widget_child_focus_w, 2, 0, 0, H_gtk_widget_child_focus, pl_bug);
  Xg_define_procedure(gtk_widget_set_size_request, gxg_gtk_widget_set_size_request_w, 3, 0, 0, H_gtk_widget_set_size_request, pl_tui);
  Xg_define_procedure(gtk_widget_get_size_request, gxg_gtk_widget_get_size_request_w, 1, 2, 0, H_gtk_widget_get_size_request, pl_pu);
  Xg_define_procedure(gtk_widget_get_toplevel, gxg_gtk_widget_get_toplevel_w, 1, 0, 0, H_gtk_widget_get_toplevel, pl_pu);
  Xg_define_procedure(gtk_widget_get_ancestor, gxg_gtk_widget_get_ancestor_w, 2, 0, 0, H_gtk_widget_get_ancestor, pl_pui);
  Xg_define_procedure(gtk_widget_get_settings, gxg_gtk_widget_get_settings_w, 1, 0, 0, H_gtk_widget_get_settings, pl_pu);
  Xg_define_procedure(gtk_widget_get_accessible, gxg_gtk_widget_get_accessible_w, 1, 0, 0, H_gtk_widget_get_accessible, pl_pu);
  Xg_define_procedure(gtk_widget_is_ancestor, gxg_gtk_widget_is_ancestor_w, 2, 0, 0, H_gtk_widget_is_ancestor, pl_bu);
  Xg_define_procedure(gtk_widget_translate_coordinates, gxg_gtk_widget_translate_coordinates_w, 4, 2, 0, H_gtk_widget_translate_coordinates, pl_puuiiu);
  Xg_define_procedure(gtk_widget_hide_on_delete, gxg_gtk_widget_hide_on_delete_w, 1, 0, 0, H_gtk_widget_hide_on_delete, pl_bu);
  Xg_define_procedure(gtk_widget_create_pango_context, gxg_gtk_widget_create_pango_context_w, 1, 0, 0, H_gtk_widget_create_pango_context, pl_pu);
  Xg_define_procedure(gtk_widget_get_pango_context, gxg_gtk_widget_get_pango_context_w, 1, 0, 0, H_gtk_widget_get_pango_context, pl_pu);
  Xg_define_procedure(gtk_widget_create_pango_layout, gxg_gtk_widget_create_pango_layout_w, 2, 0, 0, H_gtk_widget_create_pango_layout, pl_pus);
  Xg_define_procedure(gtk_widget_set_direction, gxg_gtk_widget_set_direction_w, 2, 0, 0, H_gtk_widget_set_direction, pl_tug);
  Xg_define_procedure(gtk_widget_get_direction, gxg_gtk_widget_get_direction_w, 1, 0, 0, H_gtk_widget_get_direction, pl_gu);
  Xg_define_procedure(gtk_widget_set_default_direction, gxg_gtk_widget_set_default_direction_w, 1, 0, 0, H_gtk_widget_set_default_direction, pl_tg);
  Xg_define_procedure(gtk_widget_get_default_direction, gxg_gtk_widget_get_default_direction_w, 0, 0, 0, H_gtk_widget_get_default_direction, pl_g);
  Xg_define_procedure(gtk_widget_can_activate_accel, gxg_gtk_widget_can_activate_accel_w, 2, 0, 0, H_gtk_widget_can_activate_accel, pl_bui);
  Xg_define_procedure(gtk_window_is_active, gxg_gtk_window_is_active_w, 1, 0, 0, H_gtk_window_is_active, pl_bu);
  Xg_define_procedure(gtk_window_new, gxg_gtk_window_new_w, 1, 0, 0, H_gtk_window_new, pl_pg);
  Xg_define_procedure(gtk_window_set_title, gxg_gtk_window_set_title_w, 2, 0, 0, H_gtk_window_set_title, pl_tus);
  Xg_define_procedure(gtk_window_set_auto_startup_notification, gxg_gtk_window_set_auto_startup_notification_w, 1, 0, 0, H_gtk_window_set_auto_startup_notification, pl_tb);
  Xg_define_procedure(gtk_window_get_title, gxg_gtk_window_get_title_w, 1, 0, 0, H_gtk_window_get_title, pl_su);
  Xg_define_procedure(gtk_window_set_role, gxg_gtk_window_set_role_w, 2, 0, 0, H_gtk_window_set_role, pl_tus);
  Xg_define_procedure(gtk_window_get_role, gxg_gtk_window_get_role_w, 1, 0, 0, H_gtk_window_get_role, pl_su);
  Xg_define_procedure(gtk_window_add_accel_group, gxg_gtk_window_add_accel_group_w, 2, 0, 0, H_gtk_window_add_accel_group, pl_tu);
  Xg_define_procedure(gtk_window_remove_accel_group, gxg_gtk_window_remove_accel_group_w, 2, 0, 0, H_gtk_window_remove_accel_group, pl_tu);
  Xg_define_procedure(gtk_window_set_position, gxg_gtk_window_set_position_w, 2, 0, 0, H_gtk_window_set_position, pl_tug);
  Xg_define_procedure(gtk_window_activate_focus, gxg_gtk_window_activate_focus_w, 1, 0, 0, H_gtk_window_activate_focus, pl_bu);
  Xg_define_procedure(gtk_window_set_focus, gxg_gtk_window_set_focus_w, 2, 0, 0, H_gtk_window_set_focus, pl_tu);
  Xg_define_procedure(gtk_window_get_focus, gxg_gtk_window_get_focus_w, 1, 0, 0, H_gtk_window_get_focus, pl_pu);
  Xg_define_procedure(gtk_window_set_default, gxg_gtk_window_set_default_w, 2, 0, 0, H_gtk_window_set_default, pl_tu);
  Xg_define_procedure(gtk_window_activate_default, gxg_gtk_window_activate_default_w, 1, 0, 0, H_gtk_window_activate_default, pl_bu);
  Xg_define_procedure(gtk_window_set_transient_for, gxg_gtk_window_set_transient_for_w, 2, 0, 0, H_gtk_window_set_transient_for, pl_tu);
  Xg_define_procedure(gtk_window_get_transient_for, gxg_gtk_window_get_transient_for_w, 1, 0, 0, H_gtk_window_get_transient_for, pl_pu);
  Xg_define_procedure(gtk_window_set_type_hint, gxg_gtk_window_set_type_hint_w, 2, 0, 0, H_gtk_window_set_type_hint, pl_tug);
  Xg_define_procedure(gtk_window_get_type_hint, gxg_gtk_window_get_type_hint_w, 1, 0, 0, H_gtk_window_get_type_hint, pl_gu);
  Xg_define_procedure(gtk_window_set_destroy_with_parent, gxg_gtk_window_set_destroy_with_parent_w, 2, 0, 0, H_gtk_window_set_destroy_with_parent, pl_tub);
  Xg_define_procedure(gtk_window_get_destroy_with_parent, gxg_gtk_window_get_destroy_with_parent_w, 1, 0, 0, H_gtk_window_get_destroy_with_parent, pl_bu);
  Xg_define_procedure(gtk_window_set_resizable, gxg_gtk_window_set_resizable_w, 2, 0, 0, H_gtk_window_set_resizable, pl_tub);
  Xg_define_procedure(gtk_window_get_resizable, gxg_gtk_window_get_resizable_w, 1, 0, 0, H_gtk_window_get_resizable, pl_bu);
  Xg_define_procedure(gtk_window_set_gravity, gxg_gtk_window_set_gravity_w, 2, 0, 0, H_gtk_window_set_gravity, pl_tug);
  Xg_define_procedure(gtk_window_get_gravity, gxg_gtk_window_get_gravity_w, 1, 0, 0, H_gtk_window_get_gravity, pl_gu);
  Xg_define_procedure(gtk_window_set_decorated, gxg_gtk_window_set_decorated_w, 2, 0, 0, H_gtk_window_set_decorated, pl_tub);
  Xg_define_procedure(gtk_window_get_decorated, gxg_gtk_window_get_decorated_w, 1, 0, 0, H_gtk_window_get_decorated, pl_bu);
  Xg_define_procedure(gtk_window_set_icon_list, gxg_gtk_window_set_icon_list_w, 2, 0, 0, H_gtk_window_set_icon_list, pl_tu);
  Xg_define_procedure(gtk_window_get_default_icon_list, gxg_gtk_window_get_default_icon_list_w, 0, 0, 0, H_gtk_window_get_default_icon_list, pl_p);
  Xg_define_procedure(gtk_window_set_modal, gxg_gtk_window_set_modal_w, 2, 0, 0, H_gtk_window_set_modal, pl_tub);
  Xg_define_procedure(gtk_window_get_modal, gxg_gtk_window_get_modal_w, 1, 0, 0, H_gtk_window_get_modal, pl_bu);
  Xg_define_procedure(gtk_window_list_toplevels, gxg_gtk_window_list_toplevels_w, 0, 0, 0, H_gtk_window_list_toplevels, pl_p);
  Xg_define_procedure(gtk_window_add_mnemonic, gxg_gtk_window_add_mnemonic_w, 3, 0, 0, H_gtk_window_add_mnemonic, pl_tuiu);
  Xg_define_procedure(gtk_window_remove_mnemonic, gxg_gtk_window_remove_mnemonic_w, 3, 0, 0, H_gtk_window_remove_mnemonic, pl_tuiu);
  Xg_define_procedure(gtk_window_mnemonic_activate, gxg_gtk_window_mnemonic_activate_w, 3, 0, 0, H_gtk_window_mnemonic_activate, pl_buig);
  Xg_define_procedure(gtk_window_set_mnemonic_modifier, gxg_gtk_window_set_mnemonic_modifier_w, 2, 0, 0, H_gtk_window_set_mnemonic_modifier, pl_tug);
  Xg_define_procedure(gtk_window_get_mnemonic_modifier, gxg_gtk_window_get_mnemonic_modifier_w, 1, 0, 0, H_gtk_window_get_mnemonic_modifier, pl_gu);
  Xg_define_procedure(gtk_window_present, gxg_gtk_window_present_w, 1, 0, 0, H_gtk_window_present, pl_tu);
  Xg_define_procedure(gtk_window_iconify, gxg_gtk_window_iconify_w, 1, 0, 0, H_gtk_window_iconify, pl_tu);
  Xg_define_procedure(gtk_window_deiconify, gxg_gtk_window_deiconify_w, 1, 0, 0, H_gtk_window_deiconify, pl_tu);
  Xg_define_procedure(gtk_window_stick, gxg_gtk_window_stick_w, 1, 0, 0, H_gtk_window_stick, pl_tu);
  Xg_define_procedure(gtk_window_unstick, gxg_gtk_window_unstick_w, 1, 0, 0, H_gtk_window_unstick, pl_tu);
  Xg_define_procedure(gtk_window_maximize, gxg_gtk_window_maximize_w, 1, 0, 0, H_gtk_window_maximize, pl_tu);
  Xg_define_procedure(gtk_window_unmaximize, gxg_gtk_window_unmaximize_w, 1, 0, 0, H_gtk_window_unmaximize, pl_tu);
  Xg_define_procedure(gtk_window_begin_resize_drag, gxg_gtk_window_begin_resize_drag_w, 6, 0, 0, H_gtk_window_begin_resize_drag, pl_tugi);
  Xg_define_procedure(gtk_window_begin_move_drag, gxg_gtk_window_begin_move_drag_w, 5, 0, 0, H_gtk_window_begin_move_drag, pl_tui);
  Xg_define_procedure(gtk_window_set_default_size, gxg_gtk_window_set_default_size_w, 3, 0, 0, H_gtk_window_set_default_size, pl_tui);
  Xg_define_procedure(gtk_window_get_default_size, gxg_gtk_window_get_default_size_w, 1, 2, 0, H_gtk_window_get_default_size, pl_pu);
  Xg_define_procedure(gtk_window_resize, gxg_gtk_window_resize_w, 3, 0, 0, H_gtk_window_resize, pl_tui);
  Xg_define_procedure(gtk_window_get_size, gxg_gtk_window_get_size_w, 1, 2, 0, H_gtk_window_get_size, pl_pu);
  Xg_define_procedure(gtk_window_move, gxg_gtk_window_move_w, 3, 0, 0, H_gtk_window_move, pl_tui);
  Xg_define_procedure(gtk_window_get_position, gxg_gtk_window_get_position_w, 1, 2, 0, H_gtk_window_get_position, pl_pu);
  Xg_define_procedure(pango_color_copy, gxg_pango_color_copy_w, 1, 0, 0, H_pango_color_copy, pl_pu);
  Xg_define_procedure(pango_color_free, gxg_pango_color_free_w, 1, 0, 0, H_pango_color_free, pl_tu);
  Xg_define_procedure(pango_color_parse, gxg_pango_color_parse_w, 2, 0, 0, H_pango_color_parse, pl_bus);
  Xg_define_procedure(pango_attr_type_register, gxg_pango_attr_type_register_w, 1, 0, 0, H_pango_attr_type_register, pl_gs);
  Xg_define_procedure(pango_attribute_copy, gxg_pango_attribute_copy_w, 1, 0, 0, H_pango_attribute_copy, pl_pu);
  Xg_define_procedure(pango_attribute_destroy, gxg_pango_attribute_destroy_w, 1, 0, 0, H_pango_attribute_destroy, pl_tu);
  Xg_define_procedure(pango_attribute_equal, gxg_pango_attribute_equal_w, 2, 0, 0, H_pango_attribute_equal, pl_bu);
  Xg_define_procedure(pango_attr_language_new, gxg_pango_attr_language_new_w, 1, 0, 0, H_pango_attr_language_new, pl_pu);
  Xg_define_procedure(pango_attr_family_new, gxg_pango_attr_family_new_w, 1, 0, 0, H_pango_attr_family_new, pl_ps);
  Xg_define_procedure(pango_attr_foreground_new, gxg_pango_attr_foreground_new_w, 3, 0, 0, H_pango_attr_foreground_new, pl_pi);
  Xg_define_procedure(pango_attr_background_new, gxg_pango_attr_background_new_w, 3, 0, 0, H_pango_attr_background_new, pl_pi);
  Xg_define_procedure(pango_attr_size_new, gxg_pango_attr_size_new_w, 1, 0, 0, H_pango_attr_size_new, pl_pi);
  Xg_define_procedure(pango_attr_style_new, gxg_pango_attr_style_new_w, 1, 0, 0, H_pango_attr_style_new, pl_pg);
  Xg_define_procedure(pango_attr_weight_new, gxg_pango_attr_weight_new_w, 1, 0, 0, H_pango_attr_weight_new, pl_pg);
  Xg_define_procedure(pango_attr_variant_new, gxg_pango_attr_variant_new_w, 1, 0, 0, H_pango_attr_variant_new, pl_pg);
  Xg_define_procedure(pango_attr_stretch_new, gxg_pango_attr_stretch_new_w, 1, 0, 0, H_pango_attr_stretch_new, pl_pg);
  Xg_define_procedure(pango_attr_font_desc_new, gxg_pango_attr_font_desc_new_w, 1, 0, 0, H_pango_attr_font_desc_new, pl_pu);
  Xg_define_procedure(pango_attr_underline_new, gxg_pango_attr_underline_new_w, 1, 0, 0, H_pango_attr_underline_new, pl_pg);
  Xg_define_procedure(pango_attr_strikethrough_new, gxg_pango_attr_strikethrough_new_w, 1, 0, 0, H_pango_attr_strikethrough_new, pl_pb);
  Xg_define_procedure(pango_attr_rise_new, gxg_pango_attr_rise_new_w, 1, 0, 0, H_pango_attr_rise_new, pl_pi);
  Xg_define_procedure(pango_attr_shape_new, gxg_pango_attr_shape_new_w, 2, 0, 0, H_pango_attr_shape_new, pl_pu);
  Xg_define_procedure(pango_attr_scale_new, gxg_pango_attr_scale_new_w, 1, 0, 0, H_pango_attr_scale_new, pl_pr);
  Xg_define_procedure(pango_attr_list_new, gxg_pango_attr_list_new_w, 0, 0, 0, H_pango_attr_list_new, pl_p);
  Xg_define_procedure(pango_attr_list_unref, gxg_pango_attr_list_unref_w, 1, 0, 0, H_pango_attr_list_unref, pl_tu);
  Xg_define_procedure(pango_attr_list_copy, gxg_pango_attr_list_copy_w, 1, 0, 0, H_pango_attr_list_copy, pl_pu);
  Xg_define_procedure(pango_attr_list_insert, gxg_pango_attr_list_insert_w, 2, 0, 0, H_pango_attr_list_insert, pl_tu);
  Xg_define_procedure(pango_attr_list_insert_before, gxg_pango_attr_list_insert_before_w, 2, 0, 0, H_pango_attr_list_insert_before, pl_tu);
  Xg_define_procedure(pango_attr_list_change, gxg_pango_attr_list_change_w, 2, 0, 0, H_pango_attr_list_change, pl_tu);
  Xg_define_procedure(pango_attr_list_splice, gxg_pango_attr_list_splice_w, 4, 0, 0, H_pango_attr_list_splice, pl_tuui);
  Xg_define_procedure(pango_attr_list_get_iterator, gxg_pango_attr_list_get_iterator_w, 1, 0, 0, H_pango_attr_list_get_iterator, pl_pu);
  Xg_define_procedure(pango_attr_iterator_range, gxg_pango_attr_iterator_range_w, 1, 2, 0, H_pango_attr_iterator_range, pl_pu);
  Xg_define_procedure(pango_attr_iterator_next, gxg_pango_attr_iterator_next_w, 1, 0, 0, H_pango_attr_iterator_next, pl_bu);
  Xg_define_procedure(pango_attr_iterator_copy, gxg_pango_attr_iterator_copy_w, 1, 0, 0, H_pango_attr_iterator_copy, pl_pu);
  Xg_define_procedure(pango_attr_iterator_destroy, gxg_pango_attr_iterator_destroy_w, 1, 0, 0, H_pango_attr_iterator_destroy, pl_tu);
  Xg_define_procedure(pango_attr_iterator_get, gxg_pango_attr_iterator_get_w, 2, 0, 0, H_pango_attr_iterator_get, pl_pug);
  Xg_define_procedure(pango_attr_iterator_get_font, gxg_pango_attr_iterator_get_font_w, 2, 2, 0, H_pango_attr_iterator_get_font, pl_pu);
  Xg_define_procedure(pango_parse_markup, gxg_pango_parse_markup_w, 6, 1, 0, H_pango_parse_markup, pl_psiiuusu);
  Xg_define_procedure(pango_break, gxg_pango_break_w, 5, 0, 0, H_pango_break, pl_tsiuui);
  Xg_define_procedure(pango_find_paragraph_boundary, gxg_pango_find_paragraph_boundary_w, 2, 2, 0, H_pango_find_paragraph_boundary, pl_psiu);
  Xg_define_procedure(pango_get_log_attrs, gxg_pango_get_log_attrs_w, 6, 0, 0, H_pango_get_log_attrs, pl_tsiiuui);
  Xg_define_procedure(pango_context_list_families, gxg_pango_context_list_families_w, 1, 2, 0, H_pango_context_list_families, pl_pu);
  Xg_define_procedure(pango_context_load_font, gxg_pango_context_load_font_w, 2, 0, 0, H_pango_context_load_font, pl_pu);
  Xg_define_procedure(pango_context_load_fontset, gxg_pango_context_load_fontset_w, 3, 0, 0, H_pango_context_load_fontset, pl_pu);
  Xg_define_procedure(pango_context_get_metrics, gxg_pango_context_get_metrics_w, 3, 0, 0, H_pango_context_get_metrics, pl_pu);
  Xg_define_procedure(pango_context_set_font_description, gxg_pango_context_set_font_description_w, 2, 0, 0, H_pango_context_set_font_description, pl_tu);
  Xg_define_procedure(pango_context_get_font_description, gxg_pango_context_get_font_description_w, 1, 0, 0, H_pango_context_get_font_description, pl_pu);
  Xg_define_procedure(pango_context_get_language, gxg_pango_context_get_language_w, 1, 0, 0, H_pango_context_get_language, pl_pu);
  Xg_define_procedure(pango_context_set_language, gxg_pango_context_set_language_w, 2, 0, 0, H_pango_context_set_language, pl_tu);
  Xg_define_procedure(pango_context_set_base_dir, gxg_pango_context_set_base_dir_w, 2, 0, 0, H_pango_context_set_base_dir, pl_tug);
  Xg_define_procedure(pango_context_get_base_dir, gxg_pango_context_get_base_dir_w, 1, 0, 0, H_pango_context_get_base_dir, pl_gu);
  Xg_define_procedure(pango_itemize, gxg_pango_itemize_w, 6, 0, 0, H_pango_itemize, pl_pusiiu);
  Xg_define_procedure(pango_coverage_new, gxg_pango_coverage_new_w, 0, 0, 0, H_pango_coverage_new, pl_p);
  Xg_define_procedure(pango_coverage_ref, gxg_pango_coverage_ref_w, 1, 0, 0, H_pango_coverage_ref, pl_pu);
  Xg_define_procedure(pango_coverage_unref, gxg_pango_coverage_unref_w, 1, 0, 0, H_pango_coverage_unref, pl_tu);
  Xg_define_procedure(pango_coverage_copy, gxg_pango_coverage_copy_w, 1, 0, 0, H_pango_coverage_copy, pl_pu);
  Xg_define_procedure(pango_coverage_get, gxg_pango_coverage_get_w, 2, 0, 0, H_pango_coverage_get, pl_gui);
  Xg_define_procedure(pango_coverage_set, gxg_pango_coverage_set_w, 3, 0, 0, H_pango_coverage_set, pl_tuig);
  Xg_define_procedure(pango_coverage_max, gxg_pango_coverage_max_w, 2, 0, 0, H_pango_coverage_max, pl_tu);
  Xg_define_procedure(pango_coverage_to_bytes, gxg_pango_coverage_to_bytes_w, 1, 2, 0, H_pango_coverage_to_bytes, pl_pu);
  Xg_define_procedure(pango_coverage_from_bytes, gxg_pango_coverage_from_bytes_w, 2, 0, 0, H_pango_coverage_from_bytes, pl_psi);
  Xg_define_procedure(pango_font_description_new, gxg_pango_font_description_new_w, 0, 0, 0, H_pango_font_description_new, pl_p);
  Xg_define_procedure(pango_font_description_copy, gxg_pango_font_description_copy_w, 1, 0, 0, H_pango_font_description_copy, pl_pu);
  Xg_define_procedure(pango_font_description_copy_static, gxg_pango_font_description_copy_static_w, 1, 0, 0, H_pango_font_description_copy_static, pl_pu);
  Xg_define_procedure(pango_font_description_hash, gxg_pango_font_description_hash_w, 1, 0, 0, H_pango_font_description_hash, pl_iu);
  Xg_define_procedure(pango_font_description_equal, gxg_pango_font_description_equal_w, 2, 0, 0, H_pango_font_description_equal, pl_bu);
  Xg_define_procedure(pango_font_description_free, gxg_pango_font_description_free_w, 1, 0, 0, H_pango_font_description_free, pl_tu);
  Xg_define_procedure(pango_font_descriptions_free, gxg_pango_font_descriptions_free_w, 2, 0, 0, H_pango_font_descriptions_free, pl_tui);
  Xg_define_procedure(pango_font_description_set_family, gxg_pango_font_description_set_family_w, 2, 0, 0, H_pango_font_description_set_family, pl_tus);
  Xg_define_procedure(pango_font_description_set_family_static, gxg_pango_font_description_set_family_static_w, 2, 0, 0, H_pango_font_description_set_family_static, pl_tus);
  Xg_define_procedure(pango_font_description_get_family, gxg_pango_font_description_get_family_w, 1, 0, 0, H_pango_font_description_get_family, pl_su);
  Xg_define_procedure(pango_font_description_set_style, gxg_pango_font_description_set_style_w, 2, 0, 0, H_pango_font_description_set_style, pl_tug);
  Xg_define_procedure(pango_font_description_get_style, gxg_pango_font_description_get_style_w, 1, 0, 0, H_pango_font_description_get_style, pl_gu);
  Xg_define_procedure(pango_font_description_set_variant, gxg_pango_font_description_set_variant_w, 2, 0, 0, H_pango_font_description_set_variant, pl_tug);
  Xg_define_procedure(pango_font_description_get_variant, gxg_pango_font_description_get_variant_w, 1, 0, 0, H_pango_font_description_get_variant, pl_gu);
  Xg_define_procedure(pango_font_description_set_weight, gxg_pango_font_description_set_weight_w, 2, 0, 0, H_pango_font_description_set_weight, pl_tug);
  Xg_define_procedure(pango_font_description_get_weight, gxg_pango_font_description_get_weight_w, 1, 0, 0, H_pango_font_description_get_weight, pl_gu);
  Xg_define_procedure(pango_font_description_set_stretch, gxg_pango_font_description_set_stretch_w, 2, 0, 0, H_pango_font_description_set_stretch, pl_tug);
  Xg_define_procedure(pango_font_description_get_stretch, gxg_pango_font_description_get_stretch_w, 1, 0, 0, H_pango_font_description_get_stretch, pl_gu);
  Xg_define_procedure(pango_font_description_set_size, gxg_pango_font_description_set_size_w, 2, 0, 0, H_pango_font_description_set_size, pl_tui);
  Xg_define_procedure(pango_font_description_get_size, gxg_pango_font_description_get_size_w, 1, 0, 0, H_pango_font_description_get_size, pl_iu);
  Xg_define_procedure(pango_font_description_get_set_fields, gxg_pango_font_description_get_set_fields_w, 1, 0, 0, H_pango_font_description_get_set_fields, pl_gu);
  Xg_define_procedure(pango_font_description_unset_fields, gxg_pango_font_description_unset_fields_w, 2, 0, 0, H_pango_font_description_unset_fields, pl_tug);
  Xg_define_procedure(pango_font_description_merge, gxg_pango_font_description_merge_w, 3, 0, 0, H_pango_font_description_merge, pl_tuub);
  Xg_define_procedure(pango_font_description_merge_static, gxg_pango_font_description_merge_static_w, 3, 0, 0, H_pango_font_description_merge_static, pl_tuub);
  Xg_define_procedure(pango_font_description_better_match, gxg_pango_font_description_better_match_w, 3, 0, 0, H_pango_font_description_better_match, pl_bu);
  Xg_define_procedure(pango_font_description_from_string, gxg_pango_font_description_from_string_w, 1, 0, 0, H_pango_font_description_from_string, pl_ps);
  Xg_define_procedure(pango_font_description_to_string, gxg_pango_font_description_to_string_w, 1, 0, 0, H_pango_font_description_to_string, pl_su);
  Xg_define_procedure(pango_font_description_to_filename, gxg_pango_font_description_to_filename_w, 1, 0, 0, H_pango_font_description_to_filename, pl_su);
  Xg_define_procedure(pango_font_metrics_ref, gxg_pango_font_metrics_ref_w, 1, 0, 0, H_pango_font_metrics_ref, pl_pu);
  Xg_define_procedure(pango_font_metrics_unref, gxg_pango_font_metrics_unref_w, 1, 0, 0, H_pango_font_metrics_unref, pl_tu);
  Xg_define_procedure(pango_font_metrics_get_ascent, gxg_pango_font_metrics_get_ascent_w, 1, 0, 0, H_pango_font_metrics_get_ascent, pl_iu);
  Xg_define_procedure(pango_font_metrics_get_descent, gxg_pango_font_metrics_get_descent_w, 1, 0, 0, H_pango_font_metrics_get_descent, pl_iu);
  Xg_define_procedure(pango_font_metrics_get_approximate_char_width, gxg_pango_font_metrics_get_approximate_char_width_w, 1, 0, 0, H_pango_font_metrics_get_approximate_char_width, pl_iu);
  Xg_define_procedure(pango_font_metrics_get_approximate_digit_width, gxg_pango_font_metrics_get_approximate_digit_width_w, 1, 0, 0, H_pango_font_metrics_get_approximate_digit_width, pl_iu);
  Xg_define_procedure(pango_font_family_list_faces, gxg_pango_font_family_list_faces_w, 1, 2, 0, H_pango_font_family_list_faces, pl_pu);
  Xg_define_procedure(pango_font_family_get_name, gxg_pango_font_family_get_name_w, 1, 0, 0, H_pango_font_family_get_name, pl_su);
  Xg_define_procedure(pango_font_face_describe, gxg_pango_font_face_describe_w, 1, 0, 0, H_pango_font_face_describe, pl_pu);
  Xg_define_procedure(pango_font_face_get_face_name, gxg_pango_font_face_get_face_name_w, 1, 0, 0, H_pango_font_face_get_face_name, pl_su);
  Xg_define_procedure(pango_font_describe, gxg_pango_font_describe_w, 1, 0, 0, H_pango_font_describe, pl_pu);
  Xg_define_procedure(pango_font_get_coverage, gxg_pango_font_get_coverage_w, 2, 0, 0, H_pango_font_get_coverage, pl_pu);
  Xg_define_procedure(pango_font_get_metrics, gxg_pango_font_get_metrics_w, 2, 0, 0, H_pango_font_get_metrics, pl_pu);
  Xg_define_procedure(pango_font_get_glyph_extents, gxg_pango_font_get_glyph_extents_w, 4, 0, 0, H_pango_font_get_glyph_extents, pl_tuiu);
  Xg_define_procedure(pango_font_map_load_font, gxg_pango_font_map_load_font_w, 3, 0, 0, H_pango_font_map_load_font, pl_pu);
  Xg_define_procedure(pango_font_map_load_fontset, gxg_pango_font_map_load_fontset_w, 4, 0, 0, H_pango_font_map_load_fontset, pl_pu);
  Xg_define_procedure(pango_font_map_list_families, gxg_pango_font_map_list_families_w, 1, 2, 0, H_pango_font_map_list_families, pl_pu);
  Xg_define_procedure(pango_glyph_string_new, gxg_pango_glyph_string_new_w, 0, 0, 0, H_pango_glyph_string_new, pl_p);
  Xg_define_procedure(pango_glyph_string_set_size, gxg_pango_glyph_string_set_size_w, 2, 0, 0, H_pango_glyph_string_set_size, pl_tui);
  Xg_define_procedure(pango_glyph_string_copy, gxg_pango_glyph_string_copy_w, 1, 0, 0, H_pango_glyph_string_copy, pl_pu);
  Xg_define_procedure(pango_glyph_string_free, gxg_pango_glyph_string_free_w, 1, 0, 0, H_pango_glyph_string_free, pl_tu);
  Xg_define_procedure(pango_glyph_string_extents, gxg_pango_glyph_string_extents_w, 4, 0, 0, H_pango_glyph_string_extents, pl_tu);
  Xg_define_procedure(pango_glyph_string_extents_range, gxg_pango_glyph_string_extents_range_w, 6, 0, 0, H_pango_glyph_string_extents_range, pl_tuiiu);
  Xg_define_procedure(pango_glyph_string_get_logical_widths, gxg_pango_glyph_string_get_logical_widths_w, 4, 1, 0, H_pango_glyph_string_get_logical_widths, pl_pusiiu);
  Xg_define_procedure(pango_glyph_string_index_to_x, gxg_pango_glyph_string_index_to_x_w, 6, 1, 0, H_pango_glyph_string_index_to_x, pl_pusiuibu);
  Xg_define_procedure(pango_glyph_string_x_to_index, gxg_pango_glyph_string_x_to_index_w, 5, 2, 0, H_pango_glyph_string_x_to_index, pl_pusiuiu);
  Xg_define_procedure(pango_shape, gxg_pango_shape_w, 4, 0, 0, H_pango_shape, pl_tsiu);
  Xg_define_procedure(pango_reorder_items, gxg_pango_reorder_items_w, 1, 0, 0, H_pango_reorder_items, pl_pu);
  Xg_define_procedure(pango_item_new, gxg_pango_item_new_w, 0, 0, 0, H_pango_item_new, pl_p);
  Xg_define_procedure(pango_item_copy, gxg_pango_item_copy_w, 1, 0, 0, H_pango_item_copy, pl_pu);
  Xg_define_procedure(pango_item_free, gxg_pango_item_free_w, 1, 0, 0, H_pango_item_free, pl_tu);
  Xg_define_procedure(pango_item_split, gxg_pango_item_split_w, 3, 0, 0, H_pango_item_split, pl_pui);
  Xg_define_procedure(pango_layout_new, gxg_pango_layout_new_w, 1, 0, 0, H_pango_layout_new, pl_pu);
  Xg_define_procedure(pango_layout_copy, gxg_pango_layout_copy_w, 1, 0, 0, H_pango_layout_copy, pl_pu);
  Xg_define_procedure(pango_layout_get_context, gxg_pango_layout_get_context_w, 1, 0, 0, H_pango_layout_get_context, pl_pu);
  Xg_define_procedure(pango_layout_set_attributes, gxg_pango_layout_set_attributes_w, 2, 0, 0, H_pango_layout_set_attributes, pl_tu);
  Xg_define_procedure(pango_layout_get_attributes, gxg_pango_layout_get_attributes_w, 1, 0, 0, H_pango_layout_get_attributes, pl_pu);
  Xg_define_procedure(pango_layout_set_text, gxg_pango_layout_set_text_w, 3, 0, 0, H_pango_layout_set_text, pl_tusi);
  Xg_define_procedure(pango_layout_get_text, gxg_pango_layout_get_text_w, 1, 0, 0, H_pango_layout_get_text, pl_su);
  Xg_define_procedure(pango_layout_set_markup, gxg_pango_layout_set_markup_w, 3, 0, 0, H_pango_layout_set_markup, pl_tusi);
  Xg_define_procedure(pango_layout_set_markup_with_accel, gxg_pango_layout_set_markup_with_accel_w, 5, 0, 0, H_pango_layout_set_markup_with_accel, pl_tusiis);
  Xg_define_procedure(pango_layout_set_font_description, gxg_pango_layout_set_font_description_w, 2, 0, 0, H_pango_layout_set_font_description, pl_tu);
  Xg_define_procedure(pango_layout_set_width, gxg_pango_layout_set_width_w, 2, 0, 0, H_pango_layout_set_width, pl_tui);
  Xg_define_procedure(pango_layout_get_width, gxg_pango_layout_get_width_w, 1, 0, 0, H_pango_layout_get_width, pl_iu);
  Xg_define_procedure(pango_layout_set_wrap, gxg_pango_layout_set_wrap_w, 2, 0, 0, H_pango_layout_set_wrap, pl_tug);
  Xg_define_procedure(pango_layout_get_wrap, gxg_pango_layout_get_wrap_w, 1, 0, 0, H_pango_layout_get_wrap, pl_gu);
  Xg_define_procedure(pango_layout_set_indent, gxg_pango_layout_set_indent_w, 2, 0, 0, H_pango_layout_set_indent, pl_tui);
  Xg_define_procedure(pango_layout_get_indent, gxg_pango_layout_get_indent_w, 1, 0, 0, H_pango_layout_get_indent, pl_iu);
  Xg_define_procedure(pango_layout_set_spacing, gxg_pango_layout_set_spacing_w, 2, 0, 0, H_pango_layout_set_spacing, pl_tui);
  Xg_define_procedure(pango_layout_get_spacing, gxg_pango_layout_get_spacing_w, 1, 0, 0, H_pango_layout_get_spacing, pl_iu);
  Xg_define_procedure(pango_layout_set_justify, gxg_pango_layout_set_justify_w, 2, 0, 0, H_pango_layout_set_justify, pl_tub);
  Xg_define_procedure(pango_layout_get_justify, gxg_pango_layout_get_justify_w, 1, 0, 0, H_pango_layout_get_justify, pl_bu);
  Xg_define_procedure(pango_layout_set_alignment, gxg_pango_layout_set_alignment_w, 2, 0, 0, H_pango_layout_set_alignment, pl_tug);
  Xg_define_procedure(pango_layout_get_alignment, gxg_pango_layout_get_alignment_w, 1, 0, 0, H_pango_layout_get_alignment, pl_gu);
  Xg_define_procedure(pango_layout_set_tabs, gxg_pango_layout_set_tabs_w, 2, 0, 0, H_pango_layout_set_tabs, pl_tu);
  Xg_define_procedure(pango_layout_get_tabs, gxg_pango_layout_get_tabs_w, 1, 0, 0, H_pango_layout_get_tabs, pl_pu);
  Xg_define_procedure(pango_layout_set_single_paragraph_mode, gxg_pango_layout_set_single_paragraph_mode_w, 2, 0, 0, H_pango_layout_set_single_paragraph_mode, pl_tub);
  Xg_define_procedure(pango_layout_get_single_paragraph_mode, gxg_pango_layout_get_single_paragraph_mode_w, 1, 0, 0, H_pango_layout_get_single_paragraph_mode, pl_bu);
  Xg_define_procedure(pango_layout_context_changed, gxg_pango_layout_context_changed_w, 1, 0, 0, H_pango_layout_context_changed, pl_tu);
  Xg_define_procedure(pango_layout_get_log_attrs, gxg_pango_layout_get_log_attrs_w, 1, 2, 0, H_pango_layout_get_log_attrs, pl_pu);
  Xg_define_procedure(pango_layout_index_to_pos, gxg_pango_layout_index_to_pos_w, 3, 0, 0, H_pango_layout_index_to_pos, pl_tuiu);
  Xg_define_procedure(pango_layout_get_cursor_pos, gxg_pango_layout_get_cursor_pos_w, 4, 0, 0, H_pango_layout_get_cursor_pos, pl_tuiu);
  Xg_define_procedure(pango_layout_move_cursor_visually, gxg_pango_layout_move_cursor_visually_w, 7, 0, 0, H_pango_layout_move_cursor_visually, pl_tubiiiu);
  Xg_define_procedure(pango_layout_xy_to_index, gxg_pango_layout_xy_to_index_w, 3, 2, 0, H_pango_layout_xy_to_index, pl_puiiu);
  Xg_define_procedure(pango_layout_get_extents, gxg_pango_layout_get_extents_w, 3, 0, 0, H_pango_layout_get_extents, pl_tu);
  Xg_define_procedure(pango_layout_get_pixel_extents, gxg_pango_layout_get_pixel_extents_w, 3, 0, 0, H_pango_layout_get_pixel_extents, pl_tu);
  Xg_define_procedure(pango_layout_get_size, gxg_pango_layout_get_size_w, 1, 2, 0, H_pango_layout_get_size, pl_pu);
  Xg_define_procedure(pango_layout_get_pixel_size, gxg_pango_layout_get_pixel_size_w, 1, 2, 0, H_pango_layout_get_pixel_size, pl_pu);
  Xg_define_procedure(pango_layout_get_line_count, gxg_pango_layout_get_line_count_w, 1, 0, 0, H_pango_layout_get_line_count, pl_iu);
  Xg_define_procedure(pango_layout_get_line, gxg_pango_layout_get_line_w, 2, 0, 0, H_pango_layout_get_line, pl_pui);
  Xg_define_procedure(pango_layout_get_lines, gxg_pango_layout_get_lines_w, 1, 0, 0, H_pango_layout_get_lines, pl_pu);
  Xg_define_procedure(pango_layout_line_unref, gxg_pango_layout_line_unref_w, 1, 0, 0, H_pango_layout_line_unref, pl_tu);
  Xg_define_procedure(pango_layout_line_x_to_index, gxg_pango_layout_line_x_to_index_w, 2, 2, 0, H_pango_layout_line_x_to_index, pl_puiu);
  Xg_define_procedure(pango_layout_line_index_to_x, gxg_pango_layout_line_index_to_x_w, 3, 1, 0, H_pango_layout_line_index_to_x, pl_puibu);
  Xg_define_procedure(pango_layout_line_get_x_ranges, gxg_pango_layout_line_get_x_ranges_w, 3, 2, 0, H_pango_layout_line_get_x_ranges, pl_puiiu);
  Xg_define_procedure(pango_layout_line_get_extents, gxg_pango_layout_line_get_extents_w, 3, 0, 0, H_pango_layout_line_get_extents, pl_tu);
  Xg_define_procedure(pango_layout_line_get_pixel_extents, gxg_pango_layout_line_get_pixel_extents_w, 3, 0, 0, H_pango_layout_line_get_pixel_extents, pl_tu);
  Xg_define_procedure(pango_layout_get_iter, gxg_pango_layout_get_iter_w, 1, 0, 0, H_pango_layout_get_iter, pl_pu);
  Xg_define_procedure(pango_layout_iter_free, gxg_pango_layout_iter_free_w, 1, 0, 0, H_pango_layout_iter_free, pl_tu);
  Xg_define_procedure(pango_layout_iter_get_index, gxg_pango_layout_iter_get_index_w, 1, 0, 0, H_pango_layout_iter_get_index, pl_iu);
  Xg_define_procedure(pango_layout_iter_get_run, gxg_pango_layout_iter_get_run_w, 1, 0, 0, H_pango_layout_iter_get_run, pl_pu);
  Xg_define_procedure(pango_layout_iter_get_line, gxg_pango_layout_iter_get_line_w, 1, 0, 0, H_pango_layout_iter_get_line, pl_pu);
  Xg_define_procedure(pango_layout_iter_at_last_line, gxg_pango_layout_iter_at_last_line_w, 1, 0, 0, H_pango_layout_iter_at_last_line, pl_bu);
  Xg_define_procedure(pango_layout_iter_next_char, gxg_pango_layout_iter_next_char_w, 1, 0, 0, H_pango_layout_iter_next_char, pl_bu);
  Xg_define_procedure(pango_layout_iter_next_cluster, gxg_pango_layout_iter_next_cluster_w, 1, 0, 0, H_pango_layout_iter_next_cluster, pl_bu);
  Xg_define_procedure(pango_layout_iter_next_run, gxg_pango_layout_iter_next_run_w, 1, 0, 0, H_pango_layout_iter_next_run, pl_bu);
  Xg_define_procedure(pango_layout_iter_next_line, gxg_pango_layout_iter_next_line_w, 1, 0, 0, H_pango_layout_iter_next_line, pl_bu);
  Xg_define_procedure(pango_layout_iter_get_char_extents, gxg_pango_layout_iter_get_char_extents_w, 2, 0, 0, H_pango_layout_iter_get_char_extents, pl_tu);
  Xg_define_procedure(pango_layout_iter_get_cluster_extents, gxg_pango_layout_iter_get_cluster_extents_w, 3, 0, 0, H_pango_layout_iter_get_cluster_extents, pl_tu);
  Xg_define_procedure(pango_layout_iter_get_run_extents, gxg_pango_layout_iter_get_run_extents_w, 3, 0, 0, H_pango_layout_iter_get_run_extents, pl_tu);
  Xg_define_procedure(pango_layout_iter_get_line_extents, gxg_pango_layout_iter_get_line_extents_w, 3, 0, 0, H_pango_layout_iter_get_line_extents, pl_tu);
  Xg_define_procedure(pango_layout_iter_get_line_yrange, gxg_pango_layout_iter_get_line_yrange_w, 1, 2, 0, H_pango_layout_iter_get_line_yrange, pl_pu);
  Xg_define_procedure(pango_layout_iter_get_layout_extents, gxg_pango_layout_iter_get_layout_extents_w, 3, 0, 0, H_pango_layout_iter_get_layout_extents, pl_tu);
  Xg_define_procedure(pango_layout_iter_get_baseline, gxg_pango_layout_iter_get_baseline_w, 1, 0, 0, H_pango_layout_iter_get_baseline, pl_iu);
  Xg_define_procedure(pango_language_from_string, gxg_pango_language_from_string_w, 1, 0, 0, H_pango_language_from_string, pl_ps);
  Xg_define_procedure(pango_language_matches, gxg_pango_language_matches_w, 2, 0, 0, H_pango_language_matches, pl_bus);
  Xg_define_procedure(G_OBJECT_TYPE, gxg_G_OBJECT_TYPE_w, 1, 0, 0, H_G_OBJECT_TYPE, pl_iu);
  Xg_define_procedure(gtk_tree_model_get_string_from_iter, gxg_gtk_tree_model_get_string_from_iter_w, 2, 0, 0, H_gtk_tree_model_get_string_from_iter, pl_su);
  Xg_define_procedure(gtk_tree_model_sort_iter_is_valid, gxg_gtk_tree_model_sort_iter_is_valid_w, 2, 0, 0, H_gtk_tree_model_sort_iter_is_valid, pl_bu);
  Xg_define_procedure(gtk_tree_view_expand_to_path, gxg_gtk_tree_view_expand_to_path_w, 2, 0, 0, H_gtk_tree_view_expand_to_path, pl_tu);
  Xg_define_procedure(gtk_tree_selection_get_selected_rows, gxg_gtk_tree_selection_get_selected_rows_w, 2, 0, 0, H_gtk_tree_selection_get_selected_rows, pl_pu);
  Xg_define_procedure(gtk_tree_selection_count_selected_rows, gxg_gtk_tree_selection_count_selected_rows_w, 1, 0, 0, H_gtk_tree_selection_count_selected_rows, pl_iu);
  Xg_define_procedure(gtk_menu_shell_select_first, gxg_gtk_menu_shell_select_first_w, 2, 0, 0, H_gtk_menu_shell_select_first, pl_tub);
  Xg_define_procedure(gtk_notebook_get_n_pages, gxg_gtk_notebook_get_n_pages_w, 1, 0, 0, H_gtk_notebook_get_n_pages, pl_iu);
  Xg_define_procedure(gtk_list_store_reorder, gxg_gtk_list_store_reorder_w, 2, 0, 0, H_gtk_list_store_reorder, pl_tu);
  Xg_define_procedure(gtk_list_store_swap, gxg_gtk_list_store_swap_w, 3, 0, 0, H_gtk_list_store_swap, pl_tu);
  Xg_define_procedure(gtk_list_store_move_after, gxg_gtk_list_store_move_after_w, 3, 0, 0, H_gtk_list_store_move_after, pl_tu);
  Xg_define_procedure(gtk_list_store_move_before, gxg_gtk_list_store_move_before_w, 3, 0, 0, H_gtk_list_store_move_before, pl_tu);
  Xg_define_procedure(gtk_tree_store_reorder, gxg_gtk_tree_store_reorder_w, 3, 0, 0, H_gtk_tree_store_reorder, pl_tu);
  Xg_define_procedure(gtk_tree_store_swap, gxg_gtk_tree_store_swap_w, 3, 0, 0, H_gtk_tree_store_swap, pl_tu);
  Xg_define_procedure(gdk_display_open, gxg_gdk_display_open_w, 1, 0, 0, H_gdk_display_open, pl_ps);
  Xg_define_procedure(gdk_display_get_name, gxg_gdk_display_get_name_w, 1, 0, 0, H_gdk_display_get_name, pl_su);
  Xg_define_procedure(gdk_display_beep, gxg_gdk_display_beep_w, 1, 0, 0, H_gdk_display_beep, pl_tu);
  Xg_define_procedure(gdk_display_sync, gxg_gdk_display_sync_w, 1, 0, 0, H_gdk_display_sync, pl_tu);
  Xg_define_procedure(gdk_display_close, gxg_gdk_display_close_w, 1, 0, 0, H_gdk_display_close, pl_tu);
  Xg_define_procedure(gdk_display_get_event, gxg_gdk_display_get_event_w, 1, 0, 0, H_gdk_display_get_event, pl_pu);
  Xg_define_procedure(gdk_display_peek_event, gxg_gdk_display_peek_event_w, 1, 0, 0, H_gdk_display_peek_event, pl_pu);
  Xg_define_procedure(gdk_display_put_event, gxg_gdk_display_put_event_w, 2, 0, 0, H_gdk_display_put_event, pl_tu);
  Xg_define_procedure(gdk_display_get_default, gxg_gdk_display_get_default_w, 0, 0, 0, H_gdk_display_get_default, pl_p);
  Xg_define_procedure(gtk_widget_get_display, gxg_gtk_widget_get_display_w, 1, 0, 0, H_gtk_widget_get_display, pl_pu);
  Xg_define_procedure(g_list_free, gxg_g_list_free_w, 1, 0, 0, H_g_list_free, pl_tu);
  Xg_define_procedure(g_list_reverse, gxg_g_list_reverse_w, 1, 0, 0, H_g_list_reverse, pl_pu);
  Xg_define_procedure(g_list_copy, gxg_g_list_copy_w, 1, 0, 0, H_g_list_copy, pl_pu);
  Xg_define_procedure(g_list_last, gxg_g_list_last_w, 1, 0, 0, H_g_list_last, pl_pu);
  Xg_define_procedure(g_list_first, gxg_g_list_first_w, 1, 0, 0, H_g_list_first, pl_pu);
  Xg_define_procedure(g_list_length, gxg_g_list_length_w, 1, 0, 0, H_g_list_length, pl_iu);
  Xg_define_procedure(g_free, gxg_g_free_w, 1, 0, 0, H_g_free, pl_t);
  Xg_define_procedure(g_list_remove_link, gxg_g_list_remove_link_w, 2, 0, 0, H_g_list_remove_link, pl_pu);
  Xg_define_procedure(g_object_get_data, gxg_g_object_get_data_w, 2, 0, 0, H_g_object_get_data, pl_tus);
  Xg_define_procedure(g_object_set_data, gxg_g_object_set_data_w, 3, 0, 0, H_g_object_set_data, pl_tust);
  Xg_define_procedure(gdk_display_flush, gxg_gdk_display_flush_w, 1, 0, 0, H_gdk_display_flush, pl_tu);
  Xg_define_procedure(gdk_display_supports_cursor_alpha, gxg_gdk_display_supports_cursor_alpha_w, 1, 0, 0, H_gdk_display_supports_cursor_alpha, pl_bu);
  Xg_define_procedure(gdk_display_supports_cursor_color, gxg_gdk_display_supports_cursor_color_w, 1, 0, 0, H_gdk_display_supports_cursor_color, pl_bu);
  Xg_define_procedure(gdk_display_get_default_cursor_size, gxg_gdk_display_get_default_cursor_size_w, 1, 0, 0, H_gdk_display_get_default_cursor_size, pl_iu);
  Xg_define_procedure(gdk_display_get_maximal_cursor_size, gxg_gdk_display_get_maximal_cursor_size_w, 1, 2, 0, H_gdk_display_get_maximal_cursor_size, pl_pu);
  Xg_define_procedure(gdk_window_set_keep_above, gxg_gdk_window_set_keep_above_w, 2, 0, 0, H_gdk_window_set_keep_above, pl_tub);
  Xg_define_procedure(gdk_window_set_keep_below, gxg_gdk_window_set_keep_below_w, 2, 0, 0, H_gdk_window_set_keep_below, pl_tub);
  Xg_define_procedure(gtk_button_box_get_child_secondary, gxg_gtk_button_box_get_child_secondary_w, 2, 0, 0, H_gtk_button_box_get_child_secondary, pl_bu);
  Xg_define_procedure(gtk_calendar_set_display_options, gxg_gtk_calendar_set_display_options_w, 2, 0, 0, H_gtk_calendar_set_display_options, pl_tug);
  Xg_define_procedure(gtk_calendar_get_display_options, gxg_gtk_calendar_get_display_options_w, 1, 0, 0, H_gtk_calendar_get_display_options, pl_gu);
  Xg_define_procedure(gtk_check_menu_item_set_draw_as_radio, gxg_gtk_check_menu_item_set_draw_as_radio_w, 2, 0, 0, H_gtk_check_menu_item_set_draw_as_radio, pl_tub);
  Xg_define_procedure(gtk_check_menu_item_get_draw_as_radio, gxg_gtk_check_menu_item_get_draw_as_radio_w, 1, 0, 0, H_gtk_check_menu_item_get_draw_as_radio, pl_bu);
  Xg_define_procedure(gtk_entry_set_completion, gxg_gtk_entry_set_completion_w, 2, 0, 0, H_gtk_entry_set_completion, pl_tu);
  Xg_define_procedure(gtk_entry_get_completion, gxg_gtk_entry_get_completion_w, 1, 0, 0, H_gtk_entry_get_completion, pl_pu);
  Xg_define_procedure(gtk_menu_attach, gxg_gtk_menu_attach_w, 6, 0, 0, H_gtk_menu_attach, pl_tuui);
  Xg_define_procedure(gtk_text_buffer_select_range, gxg_gtk_text_buffer_select_range_w, 3, 0, 0, H_gtk_text_buffer_select_range, pl_tu);
  Xg_define_procedure(gtk_text_view_set_overwrite, gxg_gtk_text_view_set_overwrite_w, 2, 0, 0, H_gtk_text_view_set_overwrite, pl_tub);
  Xg_define_procedure(gtk_text_view_get_overwrite, gxg_gtk_text_view_get_overwrite_w, 1, 0, 0, H_gtk_text_view_get_overwrite, pl_bu);
  Xg_define_procedure(gtk_text_view_set_accepts_tab, gxg_gtk_text_view_set_accepts_tab_w, 2, 0, 0, H_gtk_text_view_set_accepts_tab, pl_tub);
  Xg_define_procedure(gtk_text_view_get_accepts_tab, gxg_gtk_text_view_get_accepts_tab_w, 1, 0, 0, H_gtk_text_view_get_accepts_tab, pl_bu);
  Xg_define_procedure(gtk_toolbar_insert, gxg_gtk_toolbar_insert_w, 3, 0, 0, H_gtk_toolbar_insert, pl_tuui);
  Xg_define_procedure(gtk_toolbar_get_item_index, gxg_gtk_toolbar_get_item_index_w, 2, 0, 0, H_gtk_toolbar_get_item_index, pl_iu);
  Xg_define_procedure(gtk_toolbar_get_n_items, gxg_gtk_toolbar_get_n_items_w, 1, 0, 0, H_gtk_toolbar_get_n_items, pl_iu);
  Xg_define_procedure(gtk_toolbar_get_nth_item, gxg_gtk_toolbar_get_nth_item_w, 2, 0, 0, H_gtk_toolbar_get_nth_item, pl_pui);
  Xg_define_procedure(gtk_toolbar_set_show_arrow, gxg_gtk_toolbar_set_show_arrow_w, 2, 0, 0, H_gtk_toolbar_set_show_arrow, pl_tub);
  Xg_define_procedure(gtk_toolbar_get_show_arrow, gxg_gtk_toolbar_get_show_arrow_w, 1, 0, 0, H_gtk_toolbar_get_show_arrow, pl_bu);
  Xg_define_procedure(gtk_toolbar_get_drop_index, gxg_gtk_toolbar_get_drop_index_w, 3, 0, 0, H_gtk_toolbar_get_drop_index, pl_iui);
  Xg_define_procedure(gtk_tree_view_column_set_expand, gxg_gtk_tree_view_column_set_expand_w, 2, 0, 0, H_gtk_tree_view_column_set_expand, pl_tub);
  Xg_define_procedure(gtk_tree_view_column_get_expand, gxg_gtk_tree_view_column_get_expand_w, 1, 0, 0, H_gtk_tree_view_column_get_expand, pl_bu);
  Xg_define_procedure(gtk_widget_queue_resize_no_redraw, gxg_gtk_widget_queue_resize_no_redraw_w, 1, 0, 0, H_gtk_widget_queue_resize_no_redraw, pl_tu);
  Xg_define_procedure(gtk_window_set_keep_above, gxg_gtk_window_set_keep_above_w, 2, 0, 0, H_gtk_window_set_keep_above, pl_tub);
  Xg_define_procedure(gtk_window_set_keep_below, gxg_gtk_window_set_keep_below_w, 2, 0, 0, H_gtk_window_set_keep_below, pl_tub);
  Xg_define_procedure(gtk_file_chooser_dialog_new, gxg_gtk_file_chooser_dialog_new_w, 3, 1, 0, H_gtk_file_chooser_dialog_new, pl_psugt);
  Xg_define_procedure(gtk_file_chooser_widget_new, gxg_gtk_file_chooser_widget_new_w, 1, 0, 0, H_gtk_file_chooser_widget_new, pl_pg);
  Xg_define_procedure(gtk_tree_model_filter_new, gxg_gtk_tree_model_filter_new_w, 2, 0, 0, H_gtk_tree_model_filter_new, pl_pu);
  Xg_define_procedure(gtk_tree_model_filter_set_visible_column, gxg_gtk_tree_model_filter_set_visible_column_w, 2, 0, 0, H_gtk_tree_model_filter_set_visible_column, pl_tui);
  Xg_define_procedure(gtk_tree_model_filter_get_model, gxg_gtk_tree_model_filter_get_model_w, 1, 0, 0, H_gtk_tree_model_filter_get_model, pl_pu);
  Xg_define_procedure(gtk_tree_model_filter_convert_iter_to_child_iter, gxg_gtk_tree_model_filter_convert_iter_to_child_iter_w, 3, 0, 0, H_gtk_tree_model_filter_convert_iter_to_child_iter, pl_tu);
  Xg_define_procedure(gtk_tree_model_filter_convert_child_path_to_path, gxg_gtk_tree_model_filter_convert_child_path_to_path_w, 2, 0, 0, H_gtk_tree_model_filter_convert_child_path_to_path, pl_pu);
  Xg_define_procedure(gtk_tree_model_filter_convert_path_to_child_path, gxg_gtk_tree_model_filter_convert_path_to_child_path_w, 2, 0, 0, H_gtk_tree_model_filter_convert_path_to_child_path, pl_pu);
  Xg_define_procedure(gtk_tree_model_filter_refilter, gxg_gtk_tree_model_filter_refilter_w, 1, 0, 0, H_gtk_tree_model_filter_refilter, pl_tu);
  Xg_define_procedure(gtk_tree_model_filter_clear_cache, gxg_gtk_tree_model_filter_clear_cache_w, 1, 0, 0, H_gtk_tree_model_filter_clear_cache, pl_tu);
  Xg_define_procedure(gtk_combo_box_new, gxg_gtk_combo_box_new_w, 0, 0, 0, H_gtk_combo_box_new, pl_p);
  Xg_define_procedure(gtk_combo_box_new_with_model, gxg_gtk_combo_box_new_with_model_w, 1, 0, 0, H_gtk_combo_box_new_with_model, pl_pu);
  Xg_define_procedure(gtk_combo_box_set_model, gxg_gtk_combo_box_set_model_w, 2, 0, 0, H_gtk_combo_box_set_model, pl_tu);
  Xg_define_procedure(gtk_combo_box_set_wrap_width, gxg_gtk_combo_box_set_wrap_width_w, 2, 0, 0, H_gtk_combo_box_set_wrap_width, pl_tui);
  Xg_define_procedure(gtk_combo_box_set_row_span_column, gxg_gtk_combo_box_set_row_span_column_w, 2, 0, 0, H_gtk_combo_box_set_row_span_column, pl_tui);
  Xg_define_procedure(gtk_combo_box_set_column_span_column, gxg_gtk_combo_box_set_column_span_column_w, 2, 0, 0, H_gtk_combo_box_set_column_span_column, pl_tui);
  Xg_define_procedure(gtk_combo_box_get_active, gxg_gtk_combo_box_get_active_w, 1, 0, 0, H_gtk_combo_box_get_active, pl_iu);
  Xg_define_procedure(gtk_combo_box_set_active, gxg_gtk_combo_box_set_active_w, 2, 0, 0, H_gtk_combo_box_set_active, pl_tui);
  Xg_define_procedure(gtk_combo_box_get_active_iter, gxg_gtk_combo_box_get_active_iter_w, 2, 0, 0, H_gtk_combo_box_get_active_iter, pl_bu);
  Xg_define_procedure(gtk_combo_box_set_active_iter, gxg_gtk_combo_box_set_active_iter_w, 2, 0, 0, H_gtk_combo_box_set_active_iter, pl_tu);
  Xg_define_procedure(gtk_combo_box_get_model, gxg_gtk_combo_box_get_model_w, 1, 0, 0, H_gtk_combo_box_get_model, pl_pu);
  Xg_define_procedure(gtk_expander_new, gxg_gtk_expander_new_w, 1, 0, 0, H_gtk_expander_new, pl_ps);
  Xg_define_procedure(gtk_expander_new_with_mnemonic, gxg_gtk_expander_new_with_mnemonic_w, 1, 0, 0, H_gtk_expander_new_with_mnemonic, pl_ps);
  Xg_define_procedure(gtk_expander_set_expanded, gxg_gtk_expander_set_expanded_w, 2, 0, 0, H_gtk_expander_set_expanded, pl_tub);
  Xg_define_procedure(gtk_expander_get_expanded, gxg_gtk_expander_get_expanded_w, 1, 0, 0, H_gtk_expander_get_expanded, pl_bu);
  Xg_define_procedure(gtk_expander_set_label, gxg_gtk_expander_set_label_w, 2, 0, 0, H_gtk_expander_set_label, pl_tus);
  Xg_define_procedure(gtk_expander_get_label, gxg_gtk_expander_get_label_w, 1, 0, 0, H_gtk_expander_get_label, pl_su);
  Xg_define_procedure(gtk_expander_set_use_underline, gxg_gtk_expander_set_use_underline_w, 2, 0, 0, H_gtk_expander_set_use_underline, pl_tub);
  Xg_define_procedure(gtk_expander_get_use_underline, gxg_gtk_expander_get_use_underline_w, 1, 0, 0, H_gtk_expander_get_use_underline, pl_bu);
  Xg_define_procedure(gtk_expander_set_label_widget, gxg_gtk_expander_set_label_widget_w, 2, 0, 0, H_gtk_expander_set_label_widget, pl_tu);
  Xg_define_procedure(gtk_expander_get_label_widget, gxg_gtk_expander_get_label_widget_w, 1, 0, 0, H_gtk_expander_get_label_widget, pl_pu);
  Xg_define_procedure(gtk_expander_set_use_markup, gxg_gtk_expander_set_use_markup_w, 2, 0, 0, H_gtk_expander_set_use_markup, pl_tub);
  Xg_define_procedure(gtk_expander_get_use_markup, gxg_gtk_expander_get_use_markup_w, 1, 0, 0, H_gtk_expander_get_use_markup, pl_bu);
  Xg_define_procedure(gtk_font_button_new, gxg_gtk_font_button_new_w, 0, 0, 0, H_gtk_font_button_new, pl_p);
  Xg_define_procedure(gtk_font_button_new_with_font, gxg_gtk_font_button_new_with_font_w, 1, 0, 0, H_gtk_font_button_new_with_font, pl_ps);
  Xg_define_procedure(gtk_font_button_get_title, gxg_gtk_font_button_get_title_w, 1, 0, 0, H_gtk_font_button_get_title, pl_su);
  Xg_define_procedure(gtk_font_button_set_title, gxg_gtk_font_button_set_title_w, 2, 0, 0, H_gtk_font_button_set_title, pl_tus);
  Xg_define_procedure(gtk_font_button_get_use_font, gxg_gtk_font_button_get_use_font_w, 1, 0, 0, H_gtk_font_button_get_use_font, pl_bu);
  Xg_define_procedure(gtk_font_button_set_use_font, gxg_gtk_font_button_set_use_font_w, 2, 0, 0, H_gtk_font_button_set_use_font, pl_tub);
  Xg_define_procedure(gtk_font_button_get_use_size, gxg_gtk_font_button_get_use_size_w, 1, 0, 0, H_gtk_font_button_get_use_size, pl_bu);
  Xg_define_procedure(gtk_font_button_set_use_size, gxg_gtk_font_button_set_use_size_w, 2, 0, 0, H_gtk_font_button_set_use_size, pl_tub);
  Xg_define_procedure(gtk_font_button_get_show_style, gxg_gtk_font_button_get_show_style_w, 1, 0, 0, H_gtk_font_button_get_show_style, pl_bu);
  Xg_define_procedure(gtk_font_button_set_show_style, gxg_gtk_font_button_set_show_style_w, 2, 0, 0, H_gtk_font_button_set_show_style, pl_tub);
  Xg_define_procedure(gtk_font_button_get_show_size, gxg_gtk_font_button_get_show_size_w, 1, 0, 0, H_gtk_font_button_get_show_size, pl_bu);
  Xg_define_procedure(gtk_font_button_set_show_size, gxg_gtk_font_button_set_show_size_w, 2, 0, 0, H_gtk_font_button_set_show_size, pl_tub);
  Xg_define_procedure(gtk_entry_completion_new, gxg_gtk_entry_completion_new_w, 0, 0, 0, H_gtk_entry_completion_new, pl_p);
  Xg_define_procedure(gtk_entry_completion_get_entry, gxg_gtk_entry_completion_get_entry_w, 1, 0, 0, H_gtk_entry_completion_get_entry, pl_pu);
  Xg_define_procedure(gtk_entry_completion_set_model, gxg_gtk_entry_completion_set_model_w, 2, 0, 0, H_gtk_entry_completion_set_model, pl_tu);
  Xg_define_procedure(gtk_entry_completion_get_model, gxg_gtk_entry_completion_get_model_w, 1, 0, 0, H_gtk_entry_completion_get_model, pl_pu);
  Xg_define_procedure(gtk_entry_completion_set_match_func, gxg_gtk_entry_completion_set_match_func_w, 4, 0, 0, H_gtk_entry_completion_set_match_func, pl_tut);
  Xg_define_procedure(gtk_entry_completion_set_minimum_key_length, gxg_gtk_entry_completion_set_minimum_key_length_w, 2, 0, 0, H_gtk_entry_completion_set_minimum_key_length, pl_tui);
  Xg_define_procedure(gtk_entry_completion_get_minimum_key_length, gxg_gtk_entry_completion_get_minimum_key_length_w, 1, 0, 0, H_gtk_entry_completion_get_minimum_key_length, pl_iu);
  Xg_define_procedure(gtk_entry_completion_complete, gxg_gtk_entry_completion_complete_w, 1, 0, 0, H_gtk_entry_completion_complete, pl_tu);
  Xg_define_procedure(gtk_entry_completion_insert_action_text, gxg_gtk_entry_completion_insert_action_text_w, 3, 0, 0, H_gtk_entry_completion_insert_action_text, pl_tuis);
  Xg_define_procedure(gtk_entry_completion_insert_action_markup, gxg_gtk_entry_completion_insert_action_markup_w, 3, 0, 0, H_gtk_entry_completion_insert_action_markup, pl_tuis);
  Xg_define_procedure(gtk_entry_completion_delete_action, gxg_gtk_entry_completion_delete_action_w, 2, 0, 0, H_gtk_entry_completion_delete_action, pl_tui);
  Xg_define_procedure(gtk_entry_completion_set_text_column, gxg_gtk_entry_completion_set_text_column_w, 2, 0, 0, H_gtk_entry_completion_set_text_column, pl_tui);
  Xg_define_procedure(gtk_radio_tool_button_new, gxg_gtk_radio_tool_button_new_w, 1, 0, 0, H_gtk_radio_tool_button_new, pl_pu);
  Xg_define_procedure(gtk_radio_tool_button_new_from_widget, gxg_gtk_radio_tool_button_new_from_widget_w, 1, 0, 0, H_gtk_radio_tool_button_new_from_widget, pl_pu);
  Xg_define_procedure(gtk_radio_tool_button_get_group, gxg_gtk_radio_tool_button_get_group_w, 1, 0, 0, H_gtk_radio_tool_button_get_group, pl_pu);
  Xg_define_procedure(gtk_radio_tool_button_set_group, gxg_gtk_radio_tool_button_set_group_w, 2, 0, 0, H_gtk_radio_tool_button_set_group, pl_tu);
  Xg_define_procedure(gtk_separator_tool_item_new, gxg_gtk_separator_tool_item_new_w, 0, 0, 0, H_gtk_separator_tool_item_new, pl_p);
  Xg_define_procedure(gtk_separator_tool_item_get_draw, gxg_gtk_separator_tool_item_get_draw_w, 1, 0, 0, H_gtk_separator_tool_item_get_draw, pl_bu);
  Xg_define_procedure(gtk_separator_tool_item_set_draw, gxg_gtk_separator_tool_item_set_draw_w, 2, 0, 0, H_gtk_separator_tool_item_set_draw, pl_tub);
  Xg_define_procedure(gtk_toggle_tool_button_new, gxg_gtk_toggle_tool_button_new_w, 0, 0, 0, H_gtk_toggle_tool_button_new, pl_p);
  Xg_define_procedure(gtk_toggle_tool_button_set_active, gxg_gtk_toggle_tool_button_set_active_w, 2, 0, 0, H_gtk_toggle_tool_button_set_active, pl_tub);
  Xg_define_procedure(gtk_toggle_tool_button_get_active, gxg_gtk_toggle_tool_button_get_active_w, 1, 0, 0, H_gtk_toggle_tool_button_get_active, pl_bu);
  Xg_define_procedure(g_timeout_add_full, gxg_g_timeout_add_full_w, 5, 0, 0, H_g_timeout_add_full, pl_iiit);
  Xg_define_procedure(g_timeout_add, gxg_g_timeout_add_w, 3, 0, 0, H_g_timeout_add, pl_iit);
  Xg_define_procedure(g_idle_add, gxg_g_idle_add_w, 2, 0, 0, H_g_idle_add, pl_it);
  Xg_define_procedure(g_idle_add_full, gxg_g_idle_add_full_w, 4, 0, 0, H_g_idle_add_full, pl_iit);
  Xg_define_procedure(g_idle_remove_by_data, gxg_g_idle_remove_by_data_w, 1, 0, 0, H_g_idle_remove_by_data, pl_bt);
  Xg_define_procedure(g_source_remove, gxg_g_source_remove_w, 1, 0, 0, H_g_source_remove, pl_bi);
  Xg_define_procedure(gtk_file_filter_new, gxg_gtk_file_filter_new_w, 0, 0, 0, H_gtk_file_filter_new, pl_p);
  Xg_define_procedure(gtk_file_filter_set_name, gxg_gtk_file_filter_set_name_w, 2, 0, 0, H_gtk_file_filter_set_name, pl_tus);
  Xg_define_procedure(gtk_file_filter_get_name, gxg_gtk_file_filter_get_name_w, 1, 0, 0, H_gtk_file_filter_get_name, pl_su);
  Xg_define_procedure(gtk_file_filter_add_mime_type, gxg_gtk_file_filter_add_mime_type_w, 2, 0, 0, H_gtk_file_filter_add_mime_type, pl_tus);
  Xg_define_procedure(gtk_file_filter_add_pattern, gxg_gtk_file_filter_add_pattern_w, 2, 0, 0, H_gtk_file_filter_add_pattern, pl_tus);
  Xg_define_procedure(gtk_file_filter_add_custom, gxg_gtk_file_filter_add_custom_w, 5, 0, 0, H_gtk_file_filter_add_custom, pl_tugt);
  Xg_define_procedure(gtk_file_filter_get_needed, gxg_gtk_file_filter_get_needed_w, 1, 0, 0, H_gtk_file_filter_get_needed, pl_gu);
  Xg_define_procedure(gtk_file_filter_filter, gxg_gtk_file_filter_filter_w, 2, 0, 0, H_gtk_file_filter_filter, pl_bu);
  Xg_define_procedure(gtk_cell_layout_pack_start, gxg_gtk_cell_layout_pack_start_w, 3, 0, 0, H_gtk_cell_layout_pack_start, pl_tuub);
  Xg_define_procedure(gtk_cell_layout_pack_end, gxg_gtk_cell_layout_pack_end_w, 3, 0, 0, H_gtk_cell_layout_pack_end, pl_tuub);
  Xg_define_procedure(gtk_cell_layout_clear, gxg_gtk_cell_layout_clear_w, 1, 0, 0, H_gtk_cell_layout_clear, pl_tu);
  Xg_define_procedure(gtk_cell_layout_set_attributes, gxg_gtk_cell_layout_set_attributes_w, 3, 0, 0, H_gtk_cell_layout_set_attributes, pl_tuut);
  Xg_define_procedure(gtk_cell_layout_add_attribute, gxg_gtk_cell_layout_add_attribute_w, 4, 0, 0, H_gtk_cell_layout_add_attribute, pl_tuusi);
  Xg_define_procedure(gtk_cell_layout_set_cell_data_func, gxg_gtk_cell_layout_set_cell_data_func_w, 5, 0, 0, H_gtk_cell_layout_set_cell_data_func, pl_tuut);
  Xg_define_procedure(gtk_cell_layout_clear_attributes, gxg_gtk_cell_layout_clear_attributes_w, 2, 0, 0, H_gtk_cell_layout_clear_attributes, pl_tu);
  Xg_define_procedure(gtk_file_chooser_set_action, gxg_gtk_file_chooser_set_action_w, 2, 0, 0, H_gtk_file_chooser_set_action, pl_tug);
  Xg_define_procedure(gtk_file_chooser_get_action, gxg_gtk_file_chooser_get_action_w, 1, 0, 0, H_gtk_file_chooser_get_action, pl_gu);
  Xg_define_procedure(gtk_file_chooser_set_local_only, gxg_gtk_file_chooser_set_local_only_w, 2, 0, 0, H_gtk_file_chooser_set_local_only, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_local_only, gxg_gtk_file_chooser_get_local_only_w, 1, 0, 0, H_gtk_file_chooser_get_local_only, pl_bu);
  Xg_define_procedure(gtk_file_chooser_set_select_multiple, gxg_gtk_file_chooser_set_select_multiple_w, 2, 0, 0, H_gtk_file_chooser_set_select_multiple, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_select_multiple, gxg_gtk_file_chooser_get_select_multiple_w, 1, 0, 0, H_gtk_file_chooser_get_select_multiple, pl_bu);
  Xg_define_procedure(gtk_file_chooser_set_current_name, gxg_gtk_file_chooser_set_current_name_w, 2, 0, 0, H_gtk_file_chooser_set_current_name, pl_tus);
  Xg_define_procedure(gtk_file_chooser_get_filename, gxg_gtk_file_chooser_get_filename_w, 1, 0, 0, H_gtk_file_chooser_get_filename, pl_su);
  Xg_define_procedure(gtk_file_chooser_set_filename, gxg_gtk_file_chooser_set_filename_w, 2, 0, 0, H_gtk_file_chooser_set_filename, pl_bus);
  Xg_define_procedure(gtk_file_chooser_select_filename, gxg_gtk_file_chooser_select_filename_w, 2, 0, 0, H_gtk_file_chooser_select_filename, pl_bus);
  Xg_define_procedure(gtk_file_chooser_unselect_filename, gxg_gtk_file_chooser_unselect_filename_w, 2, 0, 0, H_gtk_file_chooser_unselect_filename, pl_tus);
  Xg_define_procedure(gtk_file_chooser_select_all, gxg_gtk_file_chooser_select_all_w, 1, 0, 0, H_gtk_file_chooser_select_all, pl_tu);
  Xg_define_procedure(gtk_file_chooser_unselect_all, gxg_gtk_file_chooser_unselect_all_w, 1, 0, 0, H_gtk_file_chooser_unselect_all, pl_tu);
  Xg_define_procedure(gtk_file_chooser_get_filenames, gxg_gtk_file_chooser_get_filenames_w, 1, 0, 0, H_gtk_file_chooser_get_filenames, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_current_folder, gxg_gtk_file_chooser_set_current_folder_w, 2, 0, 0, H_gtk_file_chooser_set_current_folder, pl_bus);
  Xg_define_procedure(gtk_file_chooser_get_current_folder, gxg_gtk_file_chooser_get_current_folder_w, 1, 0, 0, H_gtk_file_chooser_get_current_folder, pl_su);
  Xg_define_procedure(gtk_file_chooser_get_uri, gxg_gtk_file_chooser_get_uri_w, 1, 0, 0, H_gtk_file_chooser_get_uri, pl_su);
  Xg_define_procedure(gtk_file_chooser_set_uri, gxg_gtk_file_chooser_set_uri_w, 2, 0, 0, H_gtk_file_chooser_set_uri, pl_bus);
  Xg_define_procedure(gtk_file_chooser_select_uri, gxg_gtk_file_chooser_select_uri_w, 2, 0, 0, H_gtk_file_chooser_select_uri, pl_bus);
  Xg_define_procedure(gtk_file_chooser_unselect_uri, gxg_gtk_file_chooser_unselect_uri_w, 2, 0, 0, H_gtk_file_chooser_unselect_uri, pl_tus);
  Xg_define_procedure(gtk_file_chooser_get_uris, gxg_gtk_file_chooser_get_uris_w, 1, 0, 0, H_gtk_file_chooser_get_uris, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_current_folder_uri, gxg_gtk_file_chooser_set_current_folder_uri_w, 2, 0, 0, H_gtk_file_chooser_set_current_folder_uri, pl_bus);
  Xg_define_procedure(gtk_file_chooser_get_current_folder_uri, gxg_gtk_file_chooser_get_current_folder_uri_w, 1, 0, 0, H_gtk_file_chooser_get_current_folder_uri, pl_su);
  Xg_define_procedure(gtk_file_chooser_set_preview_widget, gxg_gtk_file_chooser_set_preview_widget_w, 2, 0, 0, H_gtk_file_chooser_set_preview_widget, pl_tu);
  Xg_define_procedure(gtk_file_chooser_get_preview_widget, gxg_gtk_file_chooser_get_preview_widget_w, 1, 0, 0, H_gtk_file_chooser_get_preview_widget, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_preview_widget_active, gxg_gtk_file_chooser_set_preview_widget_active_w, 2, 0, 0, H_gtk_file_chooser_set_preview_widget_active, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_preview_widget_active, gxg_gtk_file_chooser_get_preview_widget_active_w, 1, 0, 0, H_gtk_file_chooser_get_preview_widget_active, pl_bu);
  Xg_define_procedure(gtk_file_chooser_get_preview_filename, gxg_gtk_file_chooser_get_preview_filename_w, 1, 0, 0, H_gtk_file_chooser_get_preview_filename, pl_su);
  Xg_define_procedure(gtk_file_chooser_get_preview_uri, gxg_gtk_file_chooser_get_preview_uri_w, 1, 0, 0, H_gtk_file_chooser_get_preview_uri, pl_su);
  Xg_define_procedure(gtk_file_chooser_set_extra_widget, gxg_gtk_file_chooser_set_extra_widget_w, 2, 0, 0, H_gtk_file_chooser_set_extra_widget, pl_tu);
  Xg_define_procedure(gtk_file_chooser_get_extra_widget, gxg_gtk_file_chooser_get_extra_widget_w, 1, 0, 0, H_gtk_file_chooser_get_extra_widget, pl_pu);
  Xg_define_procedure(gtk_file_chooser_add_filter, gxg_gtk_file_chooser_add_filter_w, 2, 0, 0, H_gtk_file_chooser_add_filter, pl_tu);
  Xg_define_procedure(gtk_file_chooser_remove_filter, gxg_gtk_file_chooser_remove_filter_w, 2, 0, 0, H_gtk_file_chooser_remove_filter, pl_tu);
  Xg_define_procedure(gtk_file_chooser_list_filters, gxg_gtk_file_chooser_list_filters_w, 1, 0, 0, H_gtk_file_chooser_list_filters, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_filter, gxg_gtk_file_chooser_set_filter_w, 2, 0, 0, H_gtk_file_chooser_set_filter, pl_tu);
  Xg_define_procedure(gtk_file_chooser_get_filter, gxg_gtk_file_chooser_get_filter_w, 1, 0, 0, H_gtk_file_chooser_get_filter, pl_pu);
  Xg_define_procedure(gtk_file_chooser_add_shortcut_folder, gxg_gtk_file_chooser_add_shortcut_folder_w, 2, 1, 0, H_gtk_file_chooser_add_shortcut_folder, pl_pusu);
  Xg_define_procedure(gtk_file_chooser_remove_shortcut_folder, gxg_gtk_file_chooser_remove_shortcut_folder_w, 2, 1, 0, H_gtk_file_chooser_remove_shortcut_folder, pl_pusu);
  Xg_define_procedure(gtk_file_chooser_list_shortcut_folders, gxg_gtk_file_chooser_list_shortcut_folders_w, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folders, pl_pu);
  Xg_define_procedure(gtk_file_chooser_add_shortcut_folder_uri, gxg_gtk_file_chooser_add_shortcut_folder_uri_w, 2, 1, 0, H_gtk_file_chooser_add_shortcut_folder_uri, pl_pusu);
  Xg_define_procedure(gtk_file_chooser_remove_shortcut_folder_uri, gxg_gtk_file_chooser_remove_shortcut_folder_uri_w, 2, 1, 0, H_gtk_file_chooser_remove_shortcut_folder_uri, pl_pusu);
  Xg_define_procedure(gtk_file_chooser_list_shortcut_folder_uris, gxg_gtk_file_chooser_list_shortcut_folder_uris_w, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folder_uris, pl_pu);
  Xg_define_procedure(gtk_icon_theme_new, gxg_gtk_icon_theme_new_w, 0, 0, 0, H_gtk_icon_theme_new, pl_p);
  Xg_define_procedure(gtk_icon_theme_get_default, gxg_gtk_icon_theme_get_default_w, 0, 0, 0, H_gtk_icon_theme_get_default, pl_p);
  Xg_define_procedure(gtk_icon_theme_get_search_path, gxg_gtk_icon_theme_get_search_path_w, 1, 2, 0, H_gtk_icon_theme_get_search_path, pl_pu);
  Xg_define_procedure(gtk_icon_theme_append_search_path, gxg_gtk_icon_theme_append_search_path_w, 2, 0, 0, H_gtk_icon_theme_append_search_path, pl_tus);
  Xg_define_procedure(gtk_icon_theme_prepend_search_path, gxg_gtk_icon_theme_prepend_search_path_w, 2, 0, 0, H_gtk_icon_theme_prepend_search_path, pl_tus);
  Xg_define_procedure(gtk_icon_theme_set_custom_theme, gxg_gtk_icon_theme_set_custom_theme_w, 2, 0, 0, H_gtk_icon_theme_set_custom_theme, pl_tus);
  Xg_define_procedure(gtk_icon_theme_has_icon, gxg_gtk_icon_theme_has_icon_w, 2, 0, 0, H_gtk_icon_theme_has_icon, pl_bus);
  Xg_define_procedure(gtk_icon_theme_lookup_icon, gxg_gtk_icon_theme_lookup_icon_w, 4, 0, 0, H_gtk_icon_theme_lookup_icon, pl_pusig);
  Xg_define_procedure(gtk_icon_theme_load_icon, gxg_gtk_icon_theme_load_icon_w, 4, 1, 0, H_gtk_icon_theme_load_icon, pl_pusigu);
  Xg_define_procedure(gtk_icon_theme_list_icons, gxg_gtk_icon_theme_list_icons_w, 2, 0, 0, H_gtk_icon_theme_list_icons, pl_pus);
  Xg_define_procedure(gtk_icon_theme_get_example_icon_name, gxg_gtk_icon_theme_get_example_icon_name_w, 1, 0, 0, H_gtk_icon_theme_get_example_icon_name, pl_su);
  Xg_define_procedure(gtk_icon_theme_rescan_if_needed, gxg_gtk_icon_theme_rescan_if_needed_w, 1, 0, 0, H_gtk_icon_theme_rescan_if_needed, pl_bu);
  Xg_define_procedure(gtk_icon_info_get_base_size, gxg_gtk_icon_info_get_base_size_w, 1, 0, 0, H_gtk_icon_info_get_base_size, pl_iu);
  Xg_define_procedure(gtk_icon_info_get_filename, gxg_gtk_icon_info_get_filename_w, 1, 0, 0, H_gtk_icon_info_get_filename, pl_su);
  Xg_define_procedure(gtk_icon_info_load_icon, gxg_gtk_icon_info_load_icon_w, 1, 1, 0, H_gtk_icon_info_load_icon, pl_pu);
  Xg_define_procedure(gtk_tool_button_new, gxg_gtk_tool_button_new_w, 2, 0, 0, H_gtk_tool_button_new, pl_pus);
  Xg_define_procedure(gtk_tool_button_set_label, gxg_gtk_tool_button_set_label_w, 2, 0, 0, H_gtk_tool_button_set_label, pl_tus);
  Xg_define_procedure(gtk_tool_button_get_label, gxg_gtk_tool_button_get_label_w, 1, 0, 0, H_gtk_tool_button_get_label, pl_su);
  Xg_define_procedure(gtk_tool_button_set_use_underline, gxg_gtk_tool_button_set_use_underline_w, 2, 0, 0, H_gtk_tool_button_set_use_underline, pl_tub);
  Xg_define_procedure(gtk_tool_button_get_use_underline, gxg_gtk_tool_button_get_use_underline_w, 1, 0, 0, H_gtk_tool_button_get_use_underline, pl_bu);
  Xg_define_procedure(gtk_tool_button_set_icon_widget, gxg_gtk_tool_button_set_icon_widget_w, 2, 0, 0, H_gtk_tool_button_set_icon_widget, pl_tu);
  Xg_define_procedure(gtk_tool_button_get_icon_widget, gxg_gtk_tool_button_get_icon_widget_w, 1, 0, 0, H_gtk_tool_button_get_icon_widget, pl_pu);
  Xg_define_procedure(gtk_tool_button_set_label_widget, gxg_gtk_tool_button_set_label_widget_w, 2, 0, 0, H_gtk_tool_button_set_label_widget, pl_tu);
  Xg_define_procedure(gtk_tool_button_get_label_widget, gxg_gtk_tool_button_get_label_widget_w, 1, 0, 0, H_gtk_tool_button_get_label_widget, pl_pu);
  Xg_define_procedure(gtk_tool_item_new, gxg_gtk_tool_item_new_w, 0, 0, 0, H_gtk_tool_item_new, pl_p);
  Xg_define_procedure(gtk_tool_item_set_homogeneous, gxg_gtk_tool_item_set_homogeneous_w, 2, 0, 0, H_gtk_tool_item_set_homogeneous, pl_tub);
  Xg_define_procedure(gtk_tool_item_get_homogeneous, gxg_gtk_tool_item_get_homogeneous_w, 1, 0, 0, H_gtk_tool_item_get_homogeneous, pl_bu);
  Xg_define_procedure(gtk_tool_item_set_expand, gxg_gtk_tool_item_set_expand_w, 2, 0, 0, H_gtk_tool_item_set_expand, pl_tub);
  Xg_define_procedure(gtk_tool_item_get_expand, gxg_gtk_tool_item_get_expand_w, 1, 0, 0, H_gtk_tool_item_get_expand, pl_bu);
  Xg_define_procedure(gtk_tool_item_set_visible_horizontal, gxg_gtk_tool_item_set_visible_horizontal_w, 2, 0, 0, H_gtk_tool_item_set_visible_horizontal, pl_tub);
  Xg_define_procedure(gtk_tool_item_get_visible_horizontal, gxg_gtk_tool_item_get_visible_horizontal_w, 1, 0, 0, H_gtk_tool_item_get_visible_horizontal, pl_bu);
  Xg_define_procedure(gtk_tool_item_set_visible_vertical, gxg_gtk_tool_item_set_visible_vertical_w, 2, 0, 0, H_gtk_tool_item_set_visible_vertical, pl_tub);
  Xg_define_procedure(gtk_tool_item_get_visible_vertical, gxg_gtk_tool_item_get_visible_vertical_w, 1, 0, 0, H_gtk_tool_item_get_visible_vertical, pl_bu);
  Xg_define_procedure(gtk_tool_item_get_is_important, gxg_gtk_tool_item_get_is_important_w, 1, 0, 0, H_gtk_tool_item_get_is_important, pl_bu);
  Xg_define_procedure(gtk_tool_item_set_is_important, gxg_gtk_tool_item_set_is_important_w, 2, 0, 0, H_gtk_tool_item_set_is_important, pl_tub);
  Xg_define_procedure(gtk_tool_item_get_orientation, gxg_gtk_tool_item_get_orientation_w, 1, 0, 0, H_gtk_tool_item_get_orientation, pl_gu);
  Xg_define_procedure(gtk_tool_item_get_toolbar_style, gxg_gtk_tool_item_get_toolbar_style_w, 1, 0, 0, H_gtk_tool_item_get_toolbar_style, pl_gu);
  Xg_define_procedure(gtk_tool_item_retrieve_proxy_menu_item, gxg_gtk_tool_item_retrieve_proxy_menu_item_w, 1, 0, 0, H_gtk_tool_item_retrieve_proxy_menu_item, pl_pu);
  Xg_define_procedure(gtk_tool_item_get_proxy_menu_item, gxg_gtk_tool_item_get_proxy_menu_item_w, 2, 0, 0, H_gtk_tool_item_get_proxy_menu_item, pl_pus);
  Xg_define_procedure(gtk_tool_item_set_proxy_menu_item, gxg_gtk_tool_item_set_proxy_menu_item_w, 3, 0, 0, H_gtk_tool_item_set_proxy_menu_item, pl_tusu);
  Xg_define_procedure(gtk_list_store_remove, gxg_gtk_list_store_remove_w, 2, 0, 0, H_gtk_list_store_remove, pl_bu);
  Xg_define_procedure(gdk_display_get_default_group, gxg_gdk_display_get_default_group_w, 1, 0, 0, H_gdk_display_get_default_group, pl_pu);
  Xg_define_procedure(gdk_window_get_group, gxg_gdk_window_get_group_w, 1, 0, 0, H_gdk_window_get_group, pl_pu);
  Xg_define_procedure(gtk_cell_layout_reorder, gxg_gtk_cell_layout_reorder_w, 3, 0, 0, H_gtk_cell_layout_reorder, pl_tuui);
  Xg_define_procedure(gtk_menu_shell_cancel, gxg_gtk_menu_shell_cancel_w, 1, 0, 0, H_gtk_menu_shell_cancel, pl_tu);
  Xg_define_procedure(gtk_paned_get_child1, gxg_gtk_paned_get_child1_w, 1, 0, 0, H_gtk_paned_get_child1, pl_pu);
  Xg_define_procedure(gtk_paned_get_child2, gxg_gtk_paned_get_child2_w, 1, 0, 0, H_gtk_paned_get_child2, pl_pu);
  Xg_define_procedure(gtk_window_set_accept_focus, gxg_gtk_window_set_accept_focus_w, 2, 0, 0, H_gtk_window_set_accept_focus, pl_tub);
  Xg_define_procedure(gtk_window_get_accept_focus, gxg_gtk_window_get_accept_focus_w, 1, 0, 0, H_gtk_window_get_accept_focus, pl_bu);
  Xg_define_procedure(g_list_nth_data, gxg_g_list_nth_data_w, 2, 0, 0, H_g_list_nth_data, pl_tui);
  Xg_define_procedure(gtk_accel_map_get, gxg_gtk_accel_map_get_w, 0, 0, 0, H_gtk_accel_map_get, pl_p);
  Xg_define_procedure(gtk_combo_box_popup, gxg_gtk_combo_box_popup_w, 1, 0, 0, H_gtk_combo_box_popup, pl_tu);
  Xg_define_procedure(gtk_combo_box_popdown, gxg_gtk_combo_box_popdown_w, 1, 0, 0, H_gtk_combo_box_popdown, pl_tu);
  Xg_define_procedure(gtk_radio_menu_item_new_from_widget, gxg_gtk_radio_menu_item_new_from_widget_w, 1, 0, 0, H_gtk_radio_menu_item_new_from_widget, pl_pu);
  Xg_define_procedure(gtk_radio_menu_item_new_with_mnemonic_from_widget, gxg_gtk_radio_menu_item_new_with_mnemonic_from_widget_w, 2, 0, 0, H_gtk_radio_menu_item_new_with_mnemonic_from_widget, pl_pus);
  Xg_define_procedure(gtk_radio_menu_item_new_with_label_from_widget, gxg_gtk_radio_menu_item_new_with_label_from_widget_w, 2, 0, 0, H_gtk_radio_menu_item_new_with_label_from_widget, pl_pus);
  Xg_define_procedure(gtk_scale_get_layout, gxg_gtk_scale_get_layout_w, 1, 0, 0, H_gtk_scale_get_layout, pl_pu);
  Xg_define_procedure(gtk_scale_get_layout_offsets, gxg_gtk_scale_get_layout_offsets_w, 1, 2, 0, H_gtk_scale_get_layout_offsets, pl_pu);
  Xg_define_procedure(gtk_entry_set_alignment, gxg_gtk_entry_set_alignment_w, 2, 0, 0, H_gtk_entry_set_alignment, pl_tur);
  Xg_define_procedure(gtk_entry_get_alignment, gxg_gtk_entry_get_alignment_w, 1, 0, 0, H_gtk_entry_get_alignment, pl_du);
  Xg_define_procedure(gtk_file_chooser_set_use_preview_label, gxg_gtk_file_chooser_set_use_preview_label_w, 2, 0, 0, H_gtk_file_chooser_set_use_preview_label, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_use_preview_label, gxg_gtk_file_chooser_get_use_preview_label_w, 1, 0, 0, H_gtk_file_chooser_get_use_preview_label, pl_bu);
  Xg_define_procedure(gtk_widget_list_mnemonic_labels, gxg_gtk_widget_list_mnemonic_labels_w, 1, 0, 0, H_gtk_widget_list_mnemonic_labels, pl_pu);
  Xg_define_procedure(gtk_widget_add_mnemonic_label, gxg_gtk_widget_add_mnemonic_label_w, 2, 0, 0, H_gtk_widget_add_mnemonic_label, pl_tu);
  Xg_define_procedure(gtk_widget_remove_mnemonic_label, gxg_gtk_widget_remove_mnemonic_label_w, 2, 0, 0, H_gtk_widget_remove_mnemonic_label, pl_tu);
  Xg_define_procedure(gtk_window_activate_key, gxg_gtk_window_activate_key_w, 2, 0, 0, H_gtk_window_activate_key, pl_bu);
  Xg_define_procedure(gtk_window_propagate_key_event, gxg_gtk_window_propagate_key_event_w, 2, 0, 0, H_gtk_window_propagate_key_event, pl_bu);
  Xg_define_procedure(g_quark_from_string, gxg_g_quark_from_string_w, 1, 0, 0, H_g_quark_from_string, pl_is);
  Xg_define_procedure(g_quark_to_string, gxg_g_quark_to_string_w, 1, 0, 0, H_g_quark_to_string, pl_si);
  Xg_define_procedure(gtk_cell_view_new, gxg_gtk_cell_view_new_w, 0, 0, 0, H_gtk_cell_view_new, pl_p);
  Xg_define_procedure(gtk_cell_view_new_with_text, gxg_gtk_cell_view_new_with_text_w, 1, 0, 0, H_gtk_cell_view_new_with_text, pl_ps);
  Xg_define_procedure(gtk_cell_view_new_with_markup, gxg_gtk_cell_view_new_with_markup_w, 1, 0, 0, H_gtk_cell_view_new_with_markup, pl_ps);
  Xg_define_procedure(gtk_cell_view_set_model, gxg_gtk_cell_view_set_model_w, 2, 0, 0, H_gtk_cell_view_set_model, pl_tu);
  Xg_define_procedure(gtk_cell_view_set_displayed_row, gxg_gtk_cell_view_set_displayed_row_w, 2, 0, 0, H_gtk_cell_view_set_displayed_row, pl_tu);
  Xg_define_procedure(gtk_cell_view_get_displayed_row, gxg_gtk_cell_view_get_displayed_row_w, 1, 0, 0, H_gtk_cell_view_get_displayed_row, pl_pu);
  Xg_define_procedure(gtk_combo_box_get_wrap_width, gxg_gtk_combo_box_get_wrap_width_w, 1, 0, 0, H_gtk_combo_box_get_wrap_width, pl_iu);
  Xg_define_procedure(gtk_combo_box_get_row_span_column, gxg_gtk_combo_box_get_row_span_column_w, 1, 0, 0, H_gtk_combo_box_get_row_span_column, pl_iu);
  Xg_define_procedure(gtk_combo_box_get_column_span_column, gxg_gtk_combo_box_get_column_span_column_w, 1, 0, 0, H_gtk_combo_box_get_column_span_column, pl_iu);
  Xg_define_procedure(gtk_drag_dest_add_text_targets, gxg_gtk_drag_dest_add_text_targets_w, 1, 0, 0, H_gtk_drag_dest_add_text_targets, pl_tu);
  Xg_define_procedure(gtk_drag_source_add_text_targets, gxg_gtk_drag_source_add_text_targets_w, 1, 0, 0, H_gtk_drag_source_add_text_targets, pl_tu);
  Xg_define_procedure(gtk_entry_completion_insert_prefix, gxg_gtk_entry_completion_insert_prefix_w, 1, 0, 0, H_gtk_entry_completion_insert_prefix, pl_tu);
  Xg_define_procedure(gtk_entry_completion_set_inline_completion, gxg_gtk_entry_completion_set_inline_completion_w, 2, 0, 0, H_gtk_entry_completion_set_inline_completion, pl_tub);
  Xg_define_procedure(gtk_entry_completion_get_inline_completion, gxg_gtk_entry_completion_get_inline_completion_w, 1, 0, 0, H_gtk_entry_completion_get_inline_completion, pl_bu);
  Xg_define_procedure(gtk_entry_completion_set_popup_completion, gxg_gtk_entry_completion_set_popup_completion_w, 2, 0, 0, H_gtk_entry_completion_set_popup_completion, pl_tub);
  Xg_define_procedure(gtk_entry_completion_get_popup_completion, gxg_gtk_entry_completion_get_popup_completion_w, 1, 0, 0, H_gtk_entry_completion_get_popup_completion, pl_bu);
  Xg_define_procedure(gtk_entry_completion_get_text_column, gxg_gtk_entry_completion_get_text_column_w, 1, 0, 0, H_gtk_entry_completion_get_text_column, pl_iu);
  Xg_define_procedure(gtk_icon_theme_get_icon_sizes, gxg_gtk_icon_theme_get_icon_sizes_w, 2, 0, 0, H_gtk_icon_theme_get_icon_sizes, pl_pus);
  Xg_define_procedure(gtk_menu_get_for_attach_widget, gxg_gtk_menu_get_for_attach_widget_w, 1, 0, 0, H_gtk_menu_get_for_attach_widget, pl_pu);
  Xg_define_procedure(gtk_tree_view_set_fixed_height_mode, gxg_gtk_tree_view_set_fixed_height_mode_w, 2, 0, 0, H_gtk_tree_view_set_fixed_height_mode, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_fixed_height_mode, gxg_gtk_tree_view_get_fixed_height_mode_w, 1, 0, 0, H_gtk_tree_view_get_fixed_height_mode, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_hover_selection, gxg_gtk_tree_view_set_hover_selection_w, 2, 0, 0, H_gtk_tree_view_set_hover_selection, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_hover_selection, gxg_gtk_tree_view_get_hover_selection_w, 1, 0, 0, H_gtk_tree_view_get_hover_selection, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_row_separator_func, gxg_gtk_tree_view_set_row_separator_func_w, 4, 0, 0, H_gtk_tree_view_set_row_separator_func, pl_tut);
  Xg_define_procedure(gtk_window_set_focus_on_map, gxg_gtk_window_set_focus_on_map_w, 2, 0, 0, H_gtk_window_set_focus_on_map, pl_tub);
  Xg_define_procedure(gtk_window_get_focus_on_map, gxg_gtk_window_get_focus_on_map_w, 1, 0, 0, H_gtk_window_get_focus_on_map, pl_bu);
  Xg_define_procedure(gtk_window_set_icon_name, gxg_gtk_window_set_icon_name_w, 2, 0, 0, H_gtk_window_set_icon_name, pl_tus);
  Xg_define_procedure(gtk_window_get_icon_name, gxg_gtk_window_get_icon_name_w, 1, 0, 0, H_gtk_window_get_icon_name, pl_su);
  Xg_define_procedure(gtk_window_set_default_icon_name, gxg_gtk_window_set_default_icon_name_w, 1, 0, 0, H_gtk_window_set_default_icon_name, pl_ts);
  Xg_define_procedure(gtk_about_dialog_new, gxg_gtk_about_dialog_new_w, 0, 0, 0, H_gtk_about_dialog_new, pl_p);
  Xg_define_procedure(gtk_about_dialog_get_version, gxg_gtk_about_dialog_get_version_w, 1, 0, 0, H_gtk_about_dialog_get_version, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_version, gxg_gtk_about_dialog_set_version_w, 2, 0, 0, H_gtk_about_dialog_set_version, pl_tus);
  Xg_define_procedure(gtk_about_dialog_get_copyright, gxg_gtk_about_dialog_get_copyright_w, 1, 0, 0, H_gtk_about_dialog_get_copyright, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_copyright, gxg_gtk_about_dialog_set_copyright_w, 2, 0, 0, H_gtk_about_dialog_set_copyright, pl_tus);
  Xg_define_procedure(gtk_about_dialog_get_comments, gxg_gtk_about_dialog_get_comments_w, 1, 0, 0, H_gtk_about_dialog_get_comments, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_comments, gxg_gtk_about_dialog_set_comments_w, 2, 0, 0, H_gtk_about_dialog_set_comments, pl_tus);
  Xg_define_procedure(gtk_about_dialog_get_website, gxg_gtk_about_dialog_get_website_w, 1, 0, 0, H_gtk_about_dialog_get_website, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_website, gxg_gtk_about_dialog_set_website_w, 2, 0, 0, H_gtk_about_dialog_set_website, pl_tus);
  Xg_define_procedure(gtk_about_dialog_get_website_label, gxg_gtk_about_dialog_get_website_label_w, 1, 0, 0, H_gtk_about_dialog_get_website_label, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_website_label, gxg_gtk_about_dialog_set_website_label_w, 2, 0, 0, H_gtk_about_dialog_set_website_label, pl_tus);
  Xg_define_procedure(gtk_about_dialog_get_authors, gxg_gtk_about_dialog_get_authors_w, 1, 0, 0, H_gtk_about_dialog_get_authors, pl_pu);
  Xg_define_procedure(gtk_about_dialog_set_authors, gxg_gtk_about_dialog_set_authors_w, 2, 0, 0, H_gtk_about_dialog_set_authors, pl_tu);
  Xg_define_procedure(gtk_about_dialog_get_documenters, gxg_gtk_about_dialog_get_documenters_w, 1, 0, 0, H_gtk_about_dialog_get_documenters, pl_pu);
  Xg_define_procedure(gtk_about_dialog_set_documenters, gxg_gtk_about_dialog_set_documenters_w, 2, 0, 0, H_gtk_about_dialog_set_documenters, pl_tu);
  Xg_define_procedure(gtk_about_dialog_get_artists, gxg_gtk_about_dialog_get_artists_w, 1, 0, 0, H_gtk_about_dialog_get_artists, pl_pu);
  Xg_define_procedure(gtk_about_dialog_set_artists, gxg_gtk_about_dialog_set_artists_w, 2, 0, 0, H_gtk_about_dialog_set_artists, pl_tu);
  Xg_define_procedure(gtk_about_dialog_get_translator_credits, gxg_gtk_about_dialog_get_translator_credits_w, 1, 0, 0, H_gtk_about_dialog_get_translator_credits, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_translator_credits, gxg_gtk_about_dialog_set_translator_credits_w, 2, 0, 0, H_gtk_about_dialog_set_translator_credits, pl_tus);
  Xg_define_procedure(gtk_about_dialog_get_program_name, gxg_gtk_about_dialog_get_program_name_w, 1, 0, 0, H_gtk_about_dialog_get_program_name, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_program_name, gxg_gtk_about_dialog_set_program_name_w, 2, 0, 0, H_gtk_about_dialog_set_program_name, pl_tus);
  Xg_define_procedure(gtk_icon_view_new, gxg_gtk_icon_view_new_w, 0, 0, 0, H_gtk_icon_view_new, pl_p);
  Xg_define_procedure(gtk_icon_view_new_with_model, gxg_gtk_icon_view_new_with_model_w, 1, 0, 0, H_gtk_icon_view_new_with_model, pl_pu);
  Xg_define_procedure(gtk_icon_view_set_model, gxg_gtk_icon_view_set_model_w, 2, 0, 0, H_gtk_icon_view_set_model, pl_tu);
  Xg_define_procedure(gtk_icon_view_get_model, gxg_gtk_icon_view_get_model_w, 1, 0, 0, H_gtk_icon_view_get_model, pl_pu);
  Xg_define_procedure(gtk_icon_view_set_text_column, gxg_gtk_icon_view_set_text_column_w, 2, 0, 0, H_gtk_icon_view_set_text_column, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_text_column, gxg_gtk_icon_view_get_text_column_w, 1, 0, 0, H_gtk_icon_view_get_text_column, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_markup_column, gxg_gtk_icon_view_set_markup_column_w, 2, 0, 0, H_gtk_icon_view_set_markup_column, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_markup_column, gxg_gtk_icon_view_get_markup_column_w, 1, 0, 0, H_gtk_icon_view_get_markup_column, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_pixbuf_column, gxg_gtk_icon_view_set_pixbuf_column_w, 2, 0, 0, H_gtk_icon_view_set_pixbuf_column, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_pixbuf_column, gxg_gtk_icon_view_get_pixbuf_column_w, 1, 0, 0, H_gtk_icon_view_get_pixbuf_column, pl_iu);
  Xg_define_procedure(gtk_icon_view_get_path_at_pos, gxg_gtk_icon_view_get_path_at_pos_w, 3, 0, 0, H_gtk_icon_view_get_path_at_pos, pl_pui);
  Xg_define_procedure(gtk_icon_view_selected_foreach, gxg_gtk_icon_view_selected_foreach_w, 3, 0, 0, H_gtk_icon_view_selected_foreach, pl_tut);
  Xg_define_procedure(gtk_icon_view_set_selection_mode, gxg_gtk_icon_view_set_selection_mode_w, 2, 0, 0, H_gtk_icon_view_set_selection_mode, pl_tug);
  Xg_define_procedure(gtk_icon_view_get_selection_mode, gxg_gtk_icon_view_get_selection_mode_w, 1, 0, 0, H_gtk_icon_view_get_selection_mode, pl_gu);
  Xg_define_procedure(gtk_icon_view_select_path, gxg_gtk_icon_view_select_path_w, 2, 0, 0, H_gtk_icon_view_select_path, pl_tu);
  Xg_define_procedure(gtk_icon_view_unselect_path, gxg_gtk_icon_view_unselect_path_w, 2, 0, 0, H_gtk_icon_view_unselect_path, pl_tu);
  Xg_define_procedure(gtk_icon_view_path_is_selected, gxg_gtk_icon_view_path_is_selected_w, 2, 0, 0, H_gtk_icon_view_path_is_selected, pl_bu);
  Xg_define_procedure(gtk_icon_view_get_selected_items, gxg_gtk_icon_view_get_selected_items_w, 1, 0, 0, H_gtk_icon_view_get_selected_items, pl_pu);
  Xg_define_procedure(gtk_icon_view_select_all, gxg_gtk_icon_view_select_all_w, 1, 0, 0, H_gtk_icon_view_select_all, pl_tu);
  Xg_define_procedure(gtk_icon_view_unselect_all, gxg_gtk_icon_view_unselect_all_w, 1, 0, 0, H_gtk_icon_view_unselect_all, pl_tu);
  Xg_define_procedure(gtk_icon_view_item_activated, gxg_gtk_icon_view_item_activated_w, 2, 0, 0, H_gtk_icon_view_item_activated, pl_tu);
  Xg_define_procedure(gtk_cell_renderer_combo_new, gxg_gtk_cell_renderer_combo_new_w, 0, 0, 0, H_gtk_cell_renderer_combo_new, pl_p);
  Xg_define_procedure(gtk_cell_renderer_progress_new, gxg_gtk_cell_renderer_progress_new_w, 0, 0, 0, H_gtk_cell_renderer_progress_new, pl_p);
  Xg_define_procedure(gtk_combo_box_set_row_separator_func, gxg_gtk_combo_box_set_row_separator_func_w, 4, 0, 0, H_gtk_combo_box_set_row_separator_func, pl_tut);
  Xg_define_procedure(gtk_label_set_ellipsize, gxg_gtk_label_set_ellipsize_w, 2, 0, 0, H_gtk_label_set_ellipsize, pl_tug);
  Xg_define_procedure(gtk_label_get_ellipsize, gxg_gtk_label_get_ellipsize_w, 1, 0, 0, H_gtk_label_get_ellipsize, pl_gu);
  Xg_define_procedure(pango_attr_fallback_new, gxg_pango_attr_fallback_new_w, 1, 0, 0, H_pango_attr_fallback_new, pl_pb);
  Xg_define_procedure(pango_attr_letter_spacing_new, gxg_pango_attr_letter_spacing_new_w, 1, 0, 0, H_pango_attr_letter_spacing_new, pl_pi);
  Xg_define_procedure(pango_attr_list_filter, gxg_pango_attr_list_filter_w, 3, 0, 0, H_pango_attr_list_filter, pl_put);
  Xg_define_procedure(pango_attr_iterator_get_attrs, gxg_pango_attr_iterator_get_attrs_w, 1, 0, 0, H_pango_attr_iterator_get_attrs, pl_pu);
  Xg_define_procedure(pango_font_metrics_get_underline_position, gxg_pango_font_metrics_get_underline_position_w, 1, 0, 0, H_pango_font_metrics_get_underline_position, pl_iu);
  Xg_define_procedure(pango_font_metrics_get_underline_thickness, gxg_pango_font_metrics_get_underline_thickness_w, 1, 0, 0, H_pango_font_metrics_get_underline_thickness, pl_iu);
  Xg_define_procedure(pango_font_metrics_get_strikethrough_position, gxg_pango_font_metrics_get_strikethrough_position_w, 1, 0, 0, H_pango_font_metrics_get_strikethrough_position, pl_iu);
  Xg_define_procedure(pango_font_metrics_get_strikethrough_thickness, gxg_pango_font_metrics_get_strikethrough_thickness_w, 1, 0, 0, H_pango_font_metrics_get_strikethrough_thickness, pl_iu);
  Xg_define_procedure(pango_font_family_is_monospace, gxg_pango_font_family_is_monospace_w, 1, 0, 0, H_pango_font_family_is_monospace, pl_bu);
  Xg_define_procedure(pango_font_face_list_sizes, gxg_pango_font_face_list_sizes_w, 1, 2, 0, H_pango_font_face_list_sizes, pl_pu);
  Xg_define_procedure(pango_layout_set_auto_dir, gxg_pango_layout_set_auto_dir_w, 2, 0, 0, H_pango_layout_set_auto_dir, pl_tub);
  Xg_define_procedure(pango_layout_get_auto_dir, gxg_pango_layout_get_auto_dir_w, 1, 0, 0, H_pango_layout_get_auto_dir, pl_bu);
  Xg_define_procedure(pango_script_for_unichar, gxg_pango_script_for_unichar_w, 1, 0, 0, H_pango_script_for_unichar, pl_gi);
  Xg_define_procedure(pango_script_iter_new, gxg_pango_script_iter_new_w, 2, 0, 0, H_pango_script_iter_new, pl_psi);
  Xg_define_procedure(pango_script_iter_get_range, gxg_pango_script_iter_get_range_w, 1, 3, 0, H_pango_script_iter_get_range, pl_pu);
  Xg_define_procedure(pango_script_iter_next, gxg_pango_script_iter_next_w, 1, 0, 0, H_pango_script_iter_next, pl_bu);
  Xg_define_procedure(pango_script_iter_free, gxg_pango_script_iter_free_w, 1, 0, 0, H_pango_script_iter_free, pl_tu);
  Xg_define_procedure(gtk_file_chooser_button_new_with_dialog, gxg_gtk_file_chooser_button_new_with_dialog_w, 1, 0, 0, H_gtk_file_chooser_button_new_with_dialog, pl_pu);
  Xg_define_procedure(gtk_file_chooser_button_get_title, gxg_gtk_file_chooser_button_get_title_w, 1, 0, 0, H_gtk_file_chooser_button_get_title, pl_su);
  Xg_define_procedure(gtk_file_chooser_button_set_title, gxg_gtk_file_chooser_button_set_title_w, 2, 0, 0, H_gtk_file_chooser_button_set_title, pl_tus);
  Xg_define_procedure(gdk_drag_drop_succeeded, gxg_gdk_drag_drop_succeeded_w, 1, 0, 0, H_gdk_drag_drop_succeeded, pl_bu);
  Xg_define_procedure(gtk_entry_layout_index_to_text_index, gxg_gtk_entry_layout_index_to_text_index_w, 2, 0, 0, H_gtk_entry_layout_index_to_text_index, pl_iui);
  Xg_define_procedure(gtk_entry_text_index_to_layout_index, gxg_gtk_entry_text_index_to_layout_index_w, 2, 0, 0, H_gtk_entry_text_index_to_layout_index, pl_iui);
  Xg_define_procedure(gtk_file_chooser_set_show_hidden, gxg_gtk_file_chooser_set_show_hidden_w, 2, 0, 0, H_gtk_file_chooser_set_show_hidden, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_show_hidden, gxg_gtk_file_chooser_get_show_hidden_w, 1, 0, 0, H_gtk_file_chooser_get_show_hidden, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_hover_expand, gxg_gtk_tree_view_set_hover_expand_w, 2, 0, 0, H_gtk_tree_view_set_hover_expand, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_hover_expand, gxg_gtk_tree_view_get_hover_expand_w, 1, 0, 0, H_gtk_tree_view_get_hover_expand, pl_bu);
  Xg_define_procedure(gtk_tool_item_rebuild_menu, gxg_gtk_tool_item_rebuild_menu_w, 1, 0, 0, H_gtk_tool_item_rebuild_menu, pl_tu);
  Xg_define_procedure(gtk_menu_tool_button_new, gxg_gtk_menu_tool_button_new_w, 2, 0, 0, H_gtk_menu_tool_button_new, pl_pus);
  Xg_define_procedure(gtk_menu_tool_button_set_menu, gxg_gtk_menu_tool_button_set_menu_w, 2, 0, 0, H_gtk_menu_tool_button_set_menu, pl_tu);
  Xg_define_procedure(gtk_menu_tool_button_get_menu, gxg_gtk_menu_tool_button_get_menu_w, 1, 0, 0, H_gtk_menu_tool_button_get_menu, pl_pu);
  Xg_define_procedure(gtk_about_dialog_get_logo_icon_name, gxg_gtk_about_dialog_get_logo_icon_name_w, 1, 0, 0, H_gtk_about_dialog_get_logo_icon_name, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_logo_icon_name, gxg_gtk_about_dialog_set_logo_icon_name_w, 2, 0, 0, H_gtk_about_dialog_set_logo_icon_name, pl_tus);
  Xg_define_procedure(gtk_accelerator_get_label, gxg_gtk_accelerator_get_label_w, 2, 0, 0, H_gtk_accelerator_get_label, pl_sig);
  Xg_define_procedure(gtk_drag_dest_add_image_targets, gxg_gtk_drag_dest_add_image_targets_w, 1, 0, 0, H_gtk_drag_dest_add_image_targets, pl_tu);
  Xg_define_procedure(gtk_drag_dest_add_uri_targets, gxg_gtk_drag_dest_add_uri_targets_w, 1, 0, 0, H_gtk_drag_dest_add_uri_targets, pl_tu);
  Xg_define_procedure(gtk_drag_source_add_image_targets, gxg_gtk_drag_source_add_image_targets_w, 1, 0, 0, H_gtk_drag_source_add_image_targets, pl_tu);
  Xg_define_procedure(gtk_drag_source_add_uri_targets, gxg_gtk_drag_source_add_uri_targets_w, 1, 0, 0, H_gtk_drag_source_add_uri_targets, pl_tu);
  Xg_define_procedure(gtk_file_chooser_button_get_width_chars, gxg_gtk_file_chooser_button_get_width_chars_w, 1, 0, 0, H_gtk_file_chooser_button_get_width_chars, pl_iu);
  Xg_define_procedure(gtk_file_chooser_button_set_width_chars, gxg_gtk_file_chooser_button_set_width_chars_w, 2, 0, 0, H_gtk_file_chooser_button_set_width_chars, pl_tui);
  Xg_define_procedure(gtk_image_set_pixel_size, gxg_gtk_image_set_pixel_size_w, 2, 0, 0, H_gtk_image_set_pixel_size, pl_tui);
  Xg_define_procedure(gtk_image_get_pixel_size, gxg_gtk_image_get_pixel_size_w, 1, 0, 0, H_gtk_image_get_pixel_size, pl_iu);
  Xg_define_procedure(gtk_label_set_width_chars, gxg_gtk_label_set_width_chars_w, 2, 0, 0, H_gtk_label_set_width_chars, pl_tui);
  Xg_define_procedure(gtk_label_get_width_chars, gxg_gtk_label_get_width_chars_w, 1, 0, 0, H_gtk_label_get_width_chars, pl_iu);
  Xg_define_procedure(gtk_text_buffer_backspace, gxg_gtk_text_buffer_backspace_w, 4, 0, 0, H_gtk_text_buffer_backspace, pl_buub);
  Xg_define_procedure(gtk_file_filter_add_pixbuf_formats, gxg_gtk_file_filter_add_pixbuf_formats_w, 1, 0, 0, H_gtk_file_filter_add_pixbuf_formats, pl_tu);
  Xg_define_procedure(gtk_label_set_single_line_mode, gxg_gtk_label_set_single_line_mode_w, 2, 0, 0, H_gtk_label_set_single_line_mode, pl_tub);
  Xg_define_procedure(gtk_label_get_single_line_mode, gxg_gtk_label_get_single_line_mode_w, 1, 0, 0, H_gtk_label_get_single_line_mode, pl_bu);
  Xg_define_procedure(gtk_progress_bar_set_ellipsize, gxg_gtk_progress_bar_set_ellipsize_w, 2, 0, 0, H_gtk_progress_bar_set_ellipsize, pl_tug);
  Xg_define_procedure(gtk_progress_bar_get_ellipsize, gxg_gtk_progress_bar_get_ellipsize_w, 1, 0, 0, H_gtk_progress_bar_get_ellipsize, pl_gu);
  Xg_define_procedure(gtk_selection_data_targets_include_image, gxg_gtk_selection_data_targets_include_image_w, 2, 0, 0, H_gtk_selection_data_targets_include_image, pl_bub);
  Xg_define_procedure(pango_attr_underline_color_new, gxg_pango_attr_underline_color_new_w, 3, 0, 0, H_pango_attr_underline_color_new, pl_pi);
  Xg_define_procedure(pango_attr_strikethrough_color_new, gxg_pango_attr_strikethrough_color_new_w, 3, 0, 0, H_pango_attr_strikethrough_color_new, pl_pi);
  Xg_define_procedure(pango_renderer_draw_layout, gxg_pango_renderer_draw_layout_w, 4, 0, 0, H_pango_renderer_draw_layout, pl_tuui);
  Xg_define_procedure(pango_renderer_draw_layout_line, gxg_pango_renderer_draw_layout_line_w, 4, 0, 0, H_pango_renderer_draw_layout_line, pl_tuui);
  Xg_define_procedure(pango_renderer_draw_glyphs, gxg_pango_renderer_draw_glyphs_w, 5, 0, 0, H_pango_renderer_draw_glyphs, pl_tuuui);
  Xg_define_procedure(pango_renderer_draw_rectangle, gxg_pango_renderer_draw_rectangle_w, 6, 0, 0, H_pango_renderer_draw_rectangle, pl_tugi);
  Xg_define_procedure(pango_renderer_draw_error_underline, gxg_pango_renderer_draw_error_underline_w, 5, 0, 0, H_pango_renderer_draw_error_underline, pl_tui);
  Xg_define_procedure(pango_renderer_draw_trapezoid, gxg_pango_renderer_draw_trapezoid_w, 0, 0, 1, H_pango_renderer_draw_trapezoid, pl_tugr);
  Xg_define_procedure(pango_renderer_draw_glyph, gxg_pango_renderer_draw_glyph_w, 5, 0, 0, H_pango_renderer_draw_glyph, pl_tuuir);
  Xg_define_procedure(pango_renderer_activate, gxg_pango_renderer_activate_w, 1, 0, 0, H_pango_renderer_activate, pl_tu);
  Xg_define_procedure(pango_renderer_deactivate, gxg_pango_renderer_deactivate_w, 1, 0, 0, H_pango_renderer_deactivate, pl_tu);
  Xg_define_procedure(pango_renderer_part_changed, gxg_pango_renderer_part_changed_w, 2, 0, 0, H_pango_renderer_part_changed, pl_tug);
  Xg_define_procedure(pango_renderer_set_color, gxg_pango_renderer_set_color_w, 3, 0, 0, H_pango_renderer_set_color, pl_tugu);
  Xg_define_procedure(pango_renderer_get_color, gxg_pango_renderer_get_color_w, 2, 0, 0, H_pango_renderer_get_color, pl_pug);
  Xg_define_procedure(pango_renderer_set_matrix, gxg_pango_renderer_set_matrix_w, 2, 0, 0, H_pango_renderer_set_matrix, pl_tu);
  Xg_define_procedure(g_log_set_handler, gxg_g_log_set_handler_w, 4, 0, 0, H_g_log_set_handler, pl_isgt);
  Xg_define_procedure(g_log_remove_handler, gxg_g_log_remove_handler_w, 2, 0, 0, H_g_log_remove_handler, pl_tsi);
  Xg_define_procedure(gtk_cell_renderer_stop_editing, gxg_gtk_cell_renderer_stop_editing_w, 2, 0, 0, H_gtk_cell_renderer_stop_editing, pl_tub);
  Xg_define_procedure(gtk_file_chooser_button_new, gxg_gtk_file_chooser_button_new_w, 2, 0, 0, H_gtk_file_chooser_button_new, pl_psg);
  Xg_define_procedure(gtk_icon_view_set_columns, gxg_gtk_icon_view_set_columns_w, 2, 0, 0, H_gtk_icon_view_set_columns, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_columns, gxg_gtk_icon_view_get_columns_w, 1, 0, 0, H_gtk_icon_view_get_columns, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_item_width, gxg_gtk_icon_view_set_item_width_w, 2, 0, 0, H_gtk_icon_view_set_item_width, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_item_width, gxg_gtk_icon_view_get_item_width_w, 1, 0, 0, H_gtk_icon_view_get_item_width, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_spacing, gxg_gtk_icon_view_set_spacing_w, 2, 0, 0, H_gtk_icon_view_set_spacing, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_spacing, gxg_gtk_icon_view_get_spacing_w, 1, 0, 0, H_gtk_icon_view_get_spacing, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_row_spacing, gxg_gtk_icon_view_set_row_spacing_w, 2, 0, 0, H_gtk_icon_view_set_row_spacing, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_row_spacing, gxg_gtk_icon_view_get_row_spacing_w, 1, 0, 0, H_gtk_icon_view_get_row_spacing, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_column_spacing, gxg_gtk_icon_view_set_column_spacing_w, 2, 0, 0, H_gtk_icon_view_set_column_spacing, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_column_spacing, gxg_gtk_icon_view_get_column_spacing_w, 1, 0, 0, H_gtk_icon_view_get_column_spacing, pl_iu);
  Xg_define_procedure(gtk_icon_view_set_margin, gxg_gtk_icon_view_set_margin_w, 2, 0, 0, H_gtk_icon_view_set_margin, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_margin, gxg_gtk_icon_view_get_margin_w, 1, 0, 0, H_gtk_icon_view_get_margin, pl_iu);
  Xg_define_procedure(gtk_label_set_max_width_chars, gxg_gtk_label_set_max_width_chars_w, 2, 0, 0, H_gtk_label_set_max_width_chars, pl_tui);
  Xg_define_procedure(gtk_label_get_max_width_chars, gxg_gtk_label_get_max_width_chars_w, 1, 0, 0, H_gtk_label_get_max_width_chars, pl_iu);
  Xg_define_procedure(gtk_list_store_insert_with_values, gxg_gtk_list_store_insert_with_values_w, 3, 0, 0, H_gtk_list_store_insert_with_values, pl_tuui);
  Xg_define_procedure(gtk_list_store_insert_with_valuesv, gxg_gtk_list_store_insert_with_valuesv_w, 6, 0, 0, H_gtk_list_store_insert_with_valuesv, pl_tuuiuui);
  Xg_define_procedure(pango_attr_size_new_absolute, gxg_pango_attr_size_new_absolute_w, 1, 0, 0, H_pango_attr_size_new_absolute, pl_pi);
  Xg_define_procedure(pango_font_description_set_absolute_size, gxg_pango_font_description_set_absolute_size_w, 2, 0, 0, H_pango_font_description_set_absolute_size, pl_tur);
  Xg_define_procedure(pango_layout_get_font_description, gxg_pango_layout_get_font_description_w, 1, 0, 0, H_pango_layout_get_font_description, pl_pu);
  Xg_define_procedure(gdk_window_set_urgency_hint, gxg_gdk_window_set_urgency_hint_w, 2, 0, 0, H_gdk_window_set_urgency_hint, pl_tub);
  Xg_define_procedure(gtk_dialog_get_response_for_widget, gxg_gtk_dialog_get_response_for_widget_w, 2, 0, 0, H_gtk_dialog_get_response_for_widget, pl_iu);
  Xg_define_procedure(gtk_drag_source_set_icon_name, gxg_gtk_drag_source_set_icon_name_w, 2, 0, 0, H_gtk_drag_source_set_icon_name, pl_tus);
  Xg_define_procedure(gtk_drag_set_icon_name, gxg_gtk_drag_set_icon_name_w, 4, 0, 0, H_gtk_drag_set_icon_name, pl_tusi);
  Xg_define_procedure(gtk_entry_completion_set_popup_set_width, gxg_gtk_entry_completion_set_popup_set_width_w, 2, 0, 0, H_gtk_entry_completion_set_popup_set_width, pl_tub);
  Xg_define_procedure(gtk_entry_completion_get_popup_set_width, gxg_gtk_entry_completion_get_popup_set_width_w, 1, 0, 0, H_gtk_entry_completion_get_popup_set_width, pl_bu);
  Xg_define_procedure(gtk_entry_completion_set_popup_single_match, gxg_gtk_entry_completion_set_popup_single_match_w, 2, 0, 0, H_gtk_entry_completion_set_popup_single_match, pl_tub);
  Xg_define_procedure(gtk_entry_completion_get_popup_single_match, gxg_gtk_entry_completion_get_popup_single_match_w, 1, 0, 0, H_gtk_entry_completion_get_popup_single_match, pl_bu);
  Xg_define_procedure(gtk_icon_view_get_item_at_pos, gxg_gtk_icon_view_get_item_at_pos_w, 3, 2, 0, H_gtk_icon_view_get_item_at_pos, pl_puiiu);
  Xg_define_procedure(gtk_icon_view_get_visible_range, gxg_gtk_icon_view_get_visible_range_w, 1, 2, 0, H_gtk_icon_view_get_visible_range, pl_pu);
  Xg_define_procedure(gtk_icon_view_set_cursor, gxg_gtk_icon_view_set_cursor_w, 4, 0, 0, H_gtk_icon_view_set_cursor, pl_tuuub);
  Xg_define_procedure(gtk_icon_view_get_cursor, gxg_gtk_icon_view_get_cursor_w, 1, 2, 0, H_gtk_icon_view_get_cursor, pl_pu);
  Xg_define_procedure(gtk_icon_view_scroll_to_path, gxg_gtk_icon_view_scroll_to_path_w, 5, 0, 0, H_gtk_icon_view_scroll_to_path, pl_tuubr);
  Xg_define_procedure(gtk_icon_view_unset_model_drag_source, gxg_gtk_icon_view_unset_model_drag_source_w, 1, 0, 0, H_gtk_icon_view_unset_model_drag_source, pl_tu);
  Xg_define_procedure(gtk_icon_view_unset_model_drag_dest, gxg_gtk_icon_view_unset_model_drag_dest_w, 1, 0, 0, H_gtk_icon_view_unset_model_drag_dest, pl_tu);
  Xg_define_procedure(gtk_icon_view_set_reorderable, gxg_gtk_icon_view_set_reorderable_w, 2, 0, 0, H_gtk_icon_view_set_reorderable, pl_tub);
  Xg_define_procedure(gtk_icon_view_get_reorderable, gxg_gtk_icon_view_get_reorderable_w, 1, 0, 0, H_gtk_icon_view_get_reorderable, pl_bu);
  Xg_define_procedure(gtk_icon_view_set_drag_dest_item, gxg_gtk_icon_view_set_drag_dest_item_w, 3, 0, 0, H_gtk_icon_view_set_drag_dest_item, pl_tuug);
  Xg_define_procedure(gtk_icon_view_get_drag_dest_item, gxg_gtk_icon_view_get_drag_dest_item_w, 1, 2, 0, H_gtk_icon_view_get_drag_dest_item, pl_pu);
  Xg_define_procedure(gtk_icon_view_get_dest_item_at_pos, gxg_gtk_icon_view_get_dest_item_at_pos_w, 3, 2, 0, H_gtk_icon_view_get_dest_item_at_pos, pl_puiiu);
  Xg_define_procedure(gtk_image_clear, gxg_gtk_image_clear_w, 1, 0, 0, H_gtk_image_clear, pl_tu);
  Xg_define_procedure(gtk_menu_bar_get_pack_direction, gxg_gtk_menu_bar_get_pack_direction_w, 1, 0, 0, H_gtk_menu_bar_get_pack_direction, pl_gu);
  Xg_define_procedure(gtk_menu_bar_set_pack_direction, gxg_gtk_menu_bar_set_pack_direction_w, 2, 0, 0, H_gtk_menu_bar_set_pack_direction, pl_tug);
  Xg_define_procedure(gtk_menu_bar_get_child_pack_direction, gxg_gtk_menu_bar_get_child_pack_direction_w, 1, 0, 0, H_gtk_menu_bar_get_child_pack_direction, pl_gu);
  Xg_define_procedure(gtk_menu_bar_set_child_pack_direction, gxg_gtk_menu_bar_set_child_pack_direction_w, 2, 0, 0, H_gtk_menu_bar_set_child_pack_direction, pl_tug);
  Xg_define_procedure(gtk_menu_shell_get_take_focus, gxg_gtk_menu_shell_get_take_focus_w, 1, 0, 0, H_gtk_menu_shell_get_take_focus, pl_bu);
  Xg_define_procedure(gtk_menu_shell_set_take_focus, gxg_gtk_menu_shell_set_take_focus_w, 2, 0, 0, H_gtk_menu_shell_set_take_focus, pl_tub);
  Xg_define_procedure(gtk_text_iter_forward_visible_line, gxg_gtk_text_iter_forward_visible_line_w, 1, 0, 0, H_gtk_text_iter_forward_visible_line, pl_bu);
  Xg_define_procedure(gtk_text_iter_backward_visible_line, gxg_gtk_text_iter_backward_visible_line_w, 1, 0, 0, H_gtk_text_iter_backward_visible_line, pl_bu);
  Xg_define_procedure(gtk_text_iter_forward_visible_lines, gxg_gtk_text_iter_forward_visible_lines_w, 2, 0, 0, H_gtk_text_iter_forward_visible_lines, pl_bui);
  Xg_define_procedure(gtk_text_iter_backward_visible_lines, gxg_gtk_text_iter_backward_visible_lines_w, 2, 0, 0, H_gtk_text_iter_backward_visible_lines, pl_bui);
  Xg_define_procedure(gtk_tool_button_set_icon_name, gxg_gtk_tool_button_set_icon_name_w, 2, 0, 0, H_gtk_tool_button_set_icon_name, pl_tus);
  Xg_define_procedure(gtk_tool_button_get_icon_name, gxg_gtk_tool_button_get_icon_name_w, 1, 0, 0, H_gtk_tool_button_get_icon_name, pl_su);
  Xg_define_procedure(gtk_window_set_urgency_hint, gxg_gtk_window_set_urgency_hint_w, 2, 0, 0, H_gtk_window_set_urgency_hint, pl_tub);
  Xg_define_procedure(gtk_window_get_urgency_hint, gxg_gtk_window_get_urgency_hint_w, 1, 0, 0, H_gtk_window_get_urgency_hint, pl_bu);
  Xg_define_procedure(gtk_window_present_with_time, gxg_gtk_window_present_with_time_w, 2, 0, 0, H_gtk_window_present_with_time, pl_tui);
  Xg_define_procedure(gtk_file_chooser_set_do_overwrite_confirmation, gxg_gtk_file_chooser_set_do_overwrite_confirmation_w, 2, 0, 0, H_gtk_file_chooser_set_do_overwrite_confirmation, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_do_overwrite_confirmation, gxg_gtk_file_chooser_get_do_overwrite_confirmation_w, 1, 0, 0, H_gtk_file_chooser_get_do_overwrite_confirmation, pl_bu);
  Xg_define_procedure(gtk_tree_row_reference_get_model, gxg_gtk_tree_row_reference_get_model_w, 1, 0, 0, H_gtk_tree_row_reference_get_model, pl_pu);
  Xg_define_procedure(gtk_tree_view_column_queue_resize, gxg_gtk_tree_view_column_queue_resize_w, 1, 0, 0, H_gtk_tree_view_column_queue_resize, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_visible_range, gxg_gtk_tree_view_get_visible_range_w, 1, 2, 0, H_gtk_tree_view_get_visible_range, pl_pu);
  Xg_define_procedure(pango_attr_list_ref, gxg_pango_attr_list_ref_w, 1, 0, 0, H_pango_attr_list_ref, pl_pu);
  Xg_define_procedure(pango_layout_line_ref, gxg_pango_layout_line_ref_w, 1, 0, 0, H_pango_layout_line_ref, pl_pu);
  Xg_define_procedure(pango_layout_index_to_line_x, gxg_pango_layout_index_to_line_x_w, 3, 2, 0, H_pango_layout_index_to_line_x, pl_puibu);
  Xg_define_procedure(gdk_display_supports_shapes, gxg_gdk_display_supports_shapes_w, 1, 0, 0, H_gdk_display_supports_shapes, pl_bu);
  Xg_define_procedure(gdk_display_supports_input_shapes, gxg_gdk_display_supports_input_shapes_w, 1, 0, 0, H_gdk_display_supports_input_shapes, pl_bu);
  Xg_define_procedure(gdk_window_get_type_hint, gxg_gdk_window_get_type_hint_w, 1, 0, 0, H_gdk_window_get_type_hint, pl_gu);
  Xg_define_procedure(gtk_drag_dest_set_track_motion, gxg_gtk_drag_dest_set_track_motion_w, 2, 0, 0, H_gtk_drag_dest_set_track_motion, pl_tub);
  Xg_define_procedure(gtk_drag_dest_get_track_motion, gxg_gtk_drag_dest_get_track_motion_w, 1, 0, 0, H_gtk_drag_dest_get_track_motion, pl_bu);
  Xg_define_procedure(gtk_notebook_get_tab_reorderable, gxg_gtk_notebook_get_tab_reorderable_w, 2, 0, 0, H_gtk_notebook_get_tab_reorderable, pl_bu);
  Xg_define_procedure(gtk_notebook_set_tab_reorderable, gxg_gtk_notebook_set_tab_reorderable_w, 3, 0, 0, H_gtk_notebook_set_tab_reorderable, pl_tuub);
  Xg_define_procedure(gtk_notebook_get_tab_detachable, gxg_gtk_notebook_get_tab_detachable_w, 2, 0, 0, H_gtk_notebook_get_tab_detachable, pl_bu);
  Xg_define_procedure(gtk_notebook_set_tab_detachable, gxg_gtk_notebook_set_tab_detachable_w, 3, 0, 0, H_gtk_notebook_set_tab_detachable, pl_tuub);
  Xg_define_procedure(gtk_scrolled_window_unset_placement, gxg_gtk_scrolled_window_unset_placement_w, 1, 0, 0, H_gtk_scrolled_window_unset_placement, pl_tu);
  Xg_define_procedure(gtk_size_group_get_widgets, gxg_gtk_size_group_get_widgets_w, 1, 0, 0, H_gtk_size_group_get_widgets, pl_pu);
  Xg_define_procedure(gtk_text_buffer_get_has_selection, gxg_gtk_text_buffer_get_has_selection_w, 1, 0, 0, H_gtk_text_buffer_get_has_selection, pl_bu);
  Xg_define_procedure(gtk_tree_view_get_headers_clickable, gxg_gtk_tree_view_get_headers_clickable_w, 1, 0, 0, H_gtk_tree_view_get_headers_clickable, pl_bu);
  Xg_define_procedure(gtk_tree_view_get_search_entry, gxg_gtk_tree_view_get_search_entry_w, 1, 0, 0, H_gtk_tree_view_get_search_entry, pl_pu);
  Xg_define_procedure(gtk_tree_view_set_search_entry, gxg_gtk_tree_view_set_search_entry_w, 2, 0, 0, H_gtk_tree_view_set_search_entry, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_search_position_func, gxg_gtk_tree_view_get_search_position_func_w, 1, 0, 0, H_gtk_tree_view_get_search_position_func, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_search_position_func, gxg_gtk_tree_view_set_search_position_func_w, 4, 0, 0, H_gtk_tree_view_set_search_position_func, pl_tut);
  Xg_define_procedure(gtk_window_set_deletable, gxg_gtk_window_set_deletable_w, 2, 0, 0, H_gtk_window_set_deletable, pl_tub);
  Xg_define_procedure(gtk_window_get_deletable, gxg_gtk_window_get_deletable_w, 1, 0, 0, H_gtk_window_get_deletable, pl_bu);
  Xg_define_procedure(gtk_assistant_new, gxg_gtk_assistant_new_w, 0, 0, 0, H_gtk_assistant_new, pl_p);
  Xg_define_procedure(gtk_assistant_get_current_page, gxg_gtk_assistant_get_current_page_w, 1, 0, 0, H_gtk_assistant_get_current_page, pl_iu);
  Xg_define_procedure(gtk_assistant_set_current_page, gxg_gtk_assistant_set_current_page_w, 2, 0, 0, H_gtk_assistant_set_current_page, pl_tui);
  Xg_define_procedure(gtk_assistant_get_n_pages, gxg_gtk_assistant_get_n_pages_w, 1, 0, 0, H_gtk_assistant_get_n_pages, pl_iu);
  Xg_define_procedure(gtk_assistant_get_nth_page, gxg_gtk_assistant_get_nth_page_w, 2, 0, 0, H_gtk_assistant_get_nth_page, pl_pui);
  Xg_define_procedure(gtk_assistant_prepend_page, gxg_gtk_assistant_prepend_page_w, 2, 0, 0, H_gtk_assistant_prepend_page, pl_iu);
  Xg_define_procedure(gtk_assistant_append_page, gxg_gtk_assistant_append_page_w, 2, 0, 0, H_gtk_assistant_append_page, pl_iu);
  Xg_define_procedure(gtk_assistant_insert_page, gxg_gtk_assistant_insert_page_w, 3, 0, 0, H_gtk_assistant_insert_page, pl_iuui);
  Xg_define_procedure(gtk_assistant_set_forward_page_func, gxg_gtk_assistant_set_forward_page_func_w, 4, 0, 0, H_gtk_assistant_set_forward_page_func, pl_tut);
  Xg_define_procedure(gtk_assistant_set_page_type, gxg_gtk_assistant_set_page_type_w, 3, 0, 0, H_gtk_assistant_set_page_type, pl_tuug);
  Xg_define_procedure(gtk_assistant_get_page_type, gxg_gtk_assistant_get_page_type_w, 2, 0, 0, H_gtk_assistant_get_page_type, pl_gu);
  Xg_define_procedure(gtk_assistant_set_page_title, gxg_gtk_assistant_set_page_title_w, 3, 0, 0, H_gtk_assistant_set_page_title, pl_tuus);
  Xg_define_procedure(gtk_assistant_get_page_title, gxg_gtk_assistant_get_page_title_w, 2, 0, 0, H_gtk_assistant_get_page_title, pl_su);
  Xg_define_procedure(gtk_assistant_set_page_complete, gxg_gtk_assistant_set_page_complete_w, 3, 0, 0, H_gtk_assistant_set_page_complete, pl_tuub);
  Xg_define_procedure(gtk_assistant_get_page_complete, gxg_gtk_assistant_get_page_complete_w, 2, 0, 0, H_gtk_assistant_get_page_complete, pl_bu);
  Xg_define_procedure(gtk_assistant_add_action_widget, gxg_gtk_assistant_add_action_widget_w, 2, 0, 0, H_gtk_assistant_add_action_widget, pl_tu);
  Xg_define_procedure(gtk_assistant_remove_action_widget, gxg_gtk_assistant_remove_action_widget_w, 2, 0, 0, H_gtk_assistant_remove_action_widget, pl_tu);
  Xg_define_procedure(gtk_assistant_update_buttons_state, gxg_gtk_assistant_update_buttons_state_w, 1, 0, 0, H_gtk_assistant_update_buttons_state, pl_tu);
  Xg_define_procedure(gtk_cell_renderer_accel_new, gxg_gtk_cell_renderer_accel_new_w, 0, 0, 0, H_gtk_cell_renderer_accel_new, pl_p);
  Xg_define_procedure(gtk_cell_renderer_spin_new, gxg_gtk_cell_renderer_spin_new_w, 0, 0, 0, H_gtk_cell_renderer_spin_new, pl_p);
  Xg_define_procedure(gtk_link_button_new, gxg_gtk_link_button_new_w, 1, 0, 0, H_gtk_link_button_new, pl_ps);
  Xg_define_procedure(gtk_link_button_new_with_label, gxg_gtk_link_button_new_with_label_w, 2, 0, 0, H_gtk_link_button_new_with_label, pl_ps);
  Xg_define_procedure(gtk_link_button_get_uri, gxg_gtk_link_button_get_uri_w, 1, 0, 0, H_gtk_link_button_get_uri, pl_su);
  Xg_define_procedure(gtk_link_button_set_uri, gxg_gtk_link_button_set_uri_w, 2, 0, 0, H_gtk_link_button_set_uri, pl_tus);
  Xg_define_procedure(gtk_recent_chooser_error_quark, gxg_gtk_recent_chooser_error_quark_w, 0, 0, 0, H_gtk_recent_chooser_error_quark, pl_i);
  Xg_define_procedure(gtk_recent_chooser_set_show_private, gxg_gtk_recent_chooser_set_show_private_w, 2, 0, 0, H_gtk_recent_chooser_set_show_private, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_get_show_private, gxg_gtk_recent_chooser_get_show_private_w, 1, 0, 0, H_gtk_recent_chooser_get_show_private, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_set_show_not_found, gxg_gtk_recent_chooser_set_show_not_found_w, 2, 0, 0, H_gtk_recent_chooser_set_show_not_found, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_get_show_not_found, gxg_gtk_recent_chooser_get_show_not_found_w, 1, 0, 0, H_gtk_recent_chooser_get_show_not_found, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_set_select_multiple, gxg_gtk_recent_chooser_set_select_multiple_w, 2, 0, 0, H_gtk_recent_chooser_set_select_multiple, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_get_select_multiple, gxg_gtk_recent_chooser_get_select_multiple_w, 1, 0, 0, H_gtk_recent_chooser_get_select_multiple, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_set_limit, gxg_gtk_recent_chooser_set_limit_w, 2, 0, 0, H_gtk_recent_chooser_set_limit, pl_tui);
  Xg_define_procedure(gtk_recent_chooser_get_limit, gxg_gtk_recent_chooser_get_limit_w, 1, 0, 0, H_gtk_recent_chooser_get_limit, pl_iu);
  Xg_define_procedure(gtk_recent_chooser_set_local_only, gxg_gtk_recent_chooser_set_local_only_w, 2, 0, 0, H_gtk_recent_chooser_set_local_only, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_get_local_only, gxg_gtk_recent_chooser_get_local_only_w, 1, 0, 0, H_gtk_recent_chooser_get_local_only, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_set_show_tips, gxg_gtk_recent_chooser_set_show_tips_w, 2, 0, 0, H_gtk_recent_chooser_set_show_tips, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_get_show_tips, gxg_gtk_recent_chooser_get_show_tips_w, 1, 0, 0, H_gtk_recent_chooser_get_show_tips, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_set_show_icons, gxg_gtk_recent_chooser_set_show_icons_w, 2, 0, 0, H_gtk_recent_chooser_set_show_icons, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_get_show_icons, gxg_gtk_recent_chooser_get_show_icons_w, 1, 0, 0, H_gtk_recent_chooser_get_show_icons, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_set_sort_type, gxg_gtk_recent_chooser_set_sort_type_w, 2, 0, 0, H_gtk_recent_chooser_set_sort_type, pl_tug);
  Xg_define_procedure(gtk_recent_chooser_get_sort_type, gxg_gtk_recent_chooser_get_sort_type_w, 1, 0, 0, H_gtk_recent_chooser_get_sort_type, pl_gu);
  Xg_define_procedure(gtk_recent_chooser_set_sort_func, gxg_gtk_recent_chooser_set_sort_func_w, 4, 0, 0, H_gtk_recent_chooser_set_sort_func, pl_tut);
  Xg_define_procedure(gtk_recent_chooser_set_current_uri, gxg_gtk_recent_chooser_set_current_uri_w, 2, 1, 0, H_gtk_recent_chooser_set_current_uri, pl_pusu);
  Xg_define_procedure(gtk_recent_chooser_get_current_uri, gxg_gtk_recent_chooser_get_current_uri_w, 1, 0, 0, H_gtk_recent_chooser_get_current_uri, pl_su);
  Xg_define_procedure(gtk_recent_chooser_get_current_item, gxg_gtk_recent_chooser_get_current_item_w, 1, 0, 0, H_gtk_recent_chooser_get_current_item, pl_pu);
  Xg_define_procedure(gtk_recent_chooser_select_uri, gxg_gtk_recent_chooser_select_uri_w, 2, 1, 0, H_gtk_recent_chooser_select_uri, pl_pusu);
  Xg_define_procedure(gtk_recent_chooser_unselect_uri, gxg_gtk_recent_chooser_unselect_uri_w, 2, 0, 0, H_gtk_recent_chooser_unselect_uri, pl_tus);
  Xg_define_procedure(gtk_recent_chooser_select_all, gxg_gtk_recent_chooser_select_all_w, 1, 0, 0, H_gtk_recent_chooser_select_all, pl_tu);
  Xg_define_procedure(gtk_recent_chooser_unselect_all, gxg_gtk_recent_chooser_unselect_all_w, 1, 0, 0, H_gtk_recent_chooser_unselect_all, pl_tu);
  Xg_define_procedure(gtk_recent_chooser_get_items, gxg_gtk_recent_chooser_get_items_w, 1, 0, 0, H_gtk_recent_chooser_get_items, pl_pu);
  Xg_define_procedure(gtk_recent_chooser_get_uris, gxg_gtk_recent_chooser_get_uris_w, 1, 1, 0, H_gtk_recent_chooser_get_uris, pl_pu);
  Xg_define_procedure(gtk_recent_chooser_add_filter, gxg_gtk_recent_chooser_add_filter_w, 2, 0, 0, H_gtk_recent_chooser_add_filter, pl_tu);
  Xg_define_procedure(gtk_recent_chooser_remove_filter, gxg_gtk_recent_chooser_remove_filter_w, 2, 0, 0, H_gtk_recent_chooser_remove_filter, pl_tu);
  Xg_define_procedure(gtk_recent_chooser_list_filters, gxg_gtk_recent_chooser_list_filters_w, 1, 0, 0, H_gtk_recent_chooser_list_filters, pl_pu);
  Xg_define_procedure(gtk_recent_chooser_set_filter, gxg_gtk_recent_chooser_set_filter_w, 2, 0, 0, H_gtk_recent_chooser_set_filter, pl_tu);
  Xg_define_procedure(gtk_recent_chooser_get_filter, gxg_gtk_recent_chooser_get_filter_w, 1, 0, 0, H_gtk_recent_chooser_get_filter, pl_pu);
  Xg_define_procedure(gtk_recent_chooser_menu_new, gxg_gtk_recent_chooser_menu_new_w, 0, 0, 0, H_gtk_recent_chooser_menu_new, pl_p);
  Xg_define_procedure(gtk_recent_chooser_menu_new_for_manager, gxg_gtk_recent_chooser_menu_new_for_manager_w, 1, 0, 0, H_gtk_recent_chooser_menu_new_for_manager, pl_pu);
  Xg_define_procedure(gtk_recent_chooser_menu_get_show_numbers, gxg_gtk_recent_chooser_menu_get_show_numbers_w, 1, 0, 0, H_gtk_recent_chooser_menu_get_show_numbers, pl_bu);
  Xg_define_procedure(gtk_recent_chooser_menu_set_show_numbers, gxg_gtk_recent_chooser_menu_set_show_numbers_w, 2, 0, 0, H_gtk_recent_chooser_menu_set_show_numbers, pl_tub);
  Xg_define_procedure(gtk_recent_chooser_widget_new, gxg_gtk_recent_chooser_widget_new_w, 0, 0, 0, H_gtk_recent_chooser_widget_new, pl_p);
  Xg_define_procedure(gtk_recent_chooser_widget_new_for_manager, gxg_gtk_recent_chooser_widget_new_for_manager_w, 1, 0, 0, H_gtk_recent_chooser_widget_new_for_manager, pl_pu);
  Xg_define_procedure(gtk_recent_filter_new, gxg_gtk_recent_filter_new_w, 0, 0, 0, H_gtk_recent_filter_new, pl_p);
  Xg_define_procedure(gtk_recent_filter_set_name, gxg_gtk_recent_filter_set_name_w, 2, 0, 0, H_gtk_recent_filter_set_name, pl_tus);
  Xg_define_procedure(gtk_recent_filter_get_name, gxg_gtk_recent_filter_get_name_w, 1, 0, 0, H_gtk_recent_filter_get_name, pl_su);
  Xg_define_procedure(gtk_recent_filter_add_mime_type, gxg_gtk_recent_filter_add_mime_type_w, 2, 0, 0, H_gtk_recent_filter_add_mime_type, pl_tus);
  Xg_define_procedure(gtk_recent_filter_add_pattern, gxg_gtk_recent_filter_add_pattern_w, 2, 0, 0, H_gtk_recent_filter_add_pattern, pl_tus);
  Xg_define_procedure(gtk_recent_filter_add_pixbuf_formats, gxg_gtk_recent_filter_add_pixbuf_formats_w, 1, 0, 0, H_gtk_recent_filter_add_pixbuf_formats, pl_tu);
  Xg_define_procedure(gtk_recent_filter_add_application, gxg_gtk_recent_filter_add_application_w, 2, 0, 0, H_gtk_recent_filter_add_application, pl_tus);
  Xg_define_procedure(gtk_recent_filter_add_group, gxg_gtk_recent_filter_add_group_w, 2, 0, 0, H_gtk_recent_filter_add_group, pl_tus);
  Xg_define_procedure(gtk_recent_filter_add_age, gxg_gtk_recent_filter_add_age_w, 2, 0, 0, H_gtk_recent_filter_add_age, pl_tui);
  Xg_define_procedure(gtk_recent_manager_error_quark, gxg_gtk_recent_manager_error_quark_w, 0, 0, 0, H_gtk_recent_manager_error_quark, pl_i);
  Xg_define_procedure(gtk_recent_manager_new, gxg_gtk_recent_manager_new_w, 0, 0, 0, H_gtk_recent_manager_new, pl_p);
  Xg_define_procedure(gtk_recent_manager_get_default, gxg_gtk_recent_manager_get_default_w, 0, 0, 0, H_gtk_recent_manager_get_default, pl_p);
  Xg_define_procedure(gtk_recent_manager_remove_item, gxg_gtk_recent_manager_remove_item_w, 2, 1, 0, H_gtk_recent_manager_remove_item, pl_pusu);
  Xg_define_procedure(gtk_recent_manager_lookup_item, gxg_gtk_recent_manager_lookup_item_w, 2, 1, 0, H_gtk_recent_manager_lookup_item, pl_pusu);
  Xg_define_procedure(gtk_recent_manager_has_item, gxg_gtk_recent_manager_has_item_w, 2, 0, 0, H_gtk_recent_manager_has_item, pl_bus);
  Xg_define_procedure(gtk_recent_manager_move_item, gxg_gtk_recent_manager_move_item_w, 3, 1, 0, H_gtk_recent_manager_move_item, pl_pussu);
  Xg_define_procedure(gtk_recent_manager_get_items, gxg_gtk_recent_manager_get_items_w, 1, 0, 0, H_gtk_recent_manager_get_items, pl_pu);
  Xg_define_procedure(gtk_recent_manager_purge_items, gxg_gtk_recent_manager_purge_items_w, 1, 1, 0, H_gtk_recent_manager_purge_items, pl_pu);
  Xg_define_procedure(gtk_recent_info_ref, gxg_gtk_recent_info_ref_w, 1, 0, 0, H_gtk_recent_info_ref, pl_pu);
  Xg_define_procedure(gtk_recent_info_unref, gxg_gtk_recent_info_unref_w, 1, 0, 0, H_gtk_recent_info_unref, pl_tu);
  Xg_define_procedure(gtk_recent_info_get_uri, gxg_gtk_recent_info_get_uri_w, 1, 0, 0, H_gtk_recent_info_get_uri, pl_su);
  Xg_define_procedure(gtk_recent_info_get_display_name, gxg_gtk_recent_info_get_display_name_w, 1, 0, 0, H_gtk_recent_info_get_display_name, pl_su);
  Xg_define_procedure(gtk_recent_info_get_description, gxg_gtk_recent_info_get_description_w, 1, 0, 0, H_gtk_recent_info_get_description, pl_su);
  Xg_define_procedure(gtk_recent_info_get_mime_type, gxg_gtk_recent_info_get_mime_type_w, 1, 0, 0, H_gtk_recent_info_get_mime_type, pl_su);
  Xg_define_procedure(gtk_recent_info_get_added, gxg_gtk_recent_info_get_added_w, 1, 0, 0, H_gtk_recent_info_get_added, pl_tu);
  Xg_define_procedure(gtk_recent_info_get_modified, gxg_gtk_recent_info_get_modified_w, 1, 0, 0, H_gtk_recent_info_get_modified, pl_tu);
  Xg_define_procedure(gtk_recent_info_get_visited, gxg_gtk_recent_info_get_visited_w, 1, 0, 0, H_gtk_recent_info_get_visited, pl_tu);
  Xg_define_procedure(gtk_recent_info_get_private_hint, gxg_gtk_recent_info_get_private_hint_w, 1, 0, 0, H_gtk_recent_info_get_private_hint, pl_bu);
  Xg_define_procedure(gtk_recent_info_get_applications, gxg_gtk_recent_info_get_applications_w, 1, 1, 0, H_gtk_recent_info_get_applications, pl_pu);
  Xg_define_procedure(gtk_recent_info_last_application, gxg_gtk_recent_info_last_application_w, 1, 0, 0, H_gtk_recent_info_last_application, pl_su);
  Xg_define_procedure(gtk_recent_info_has_application, gxg_gtk_recent_info_has_application_w, 2, 0, 0, H_gtk_recent_info_has_application, pl_bus);
  Xg_define_procedure(gtk_recent_info_get_groups, gxg_gtk_recent_info_get_groups_w, 1, 1, 0, H_gtk_recent_info_get_groups, pl_pu);
  Xg_define_procedure(gtk_recent_info_has_group, gxg_gtk_recent_info_has_group_w, 2, 0, 0, H_gtk_recent_info_has_group, pl_bus);
  Xg_define_procedure(gtk_recent_info_get_short_name, gxg_gtk_recent_info_get_short_name_w, 1, 0, 0, H_gtk_recent_info_get_short_name, pl_su);
  Xg_define_procedure(gtk_recent_info_get_uri_display, gxg_gtk_recent_info_get_uri_display_w, 1, 0, 0, H_gtk_recent_info_get_uri_display, pl_su);
  Xg_define_procedure(gtk_recent_info_get_age, gxg_gtk_recent_info_get_age_w, 1, 0, 0, H_gtk_recent_info_get_age, pl_iu);
  Xg_define_procedure(gtk_recent_info_is_local, gxg_gtk_recent_info_is_local_w, 1, 0, 0, H_gtk_recent_info_is_local, pl_bu);
  Xg_define_procedure(gtk_recent_info_exists, gxg_gtk_recent_info_exists_w, 1, 0, 0, H_gtk_recent_info_exists, pl_bu);
  Xg_define_procedure(gtk_recent_info_match, gxg_gtk_recent_info_match_w, 2, 0, 0, H_gtk_recent_info_match, pl_bu);
  Xg_define_procedure(gtk_recent_manager_add_item, gxg_gtk_recent_manager_add_item_w, 2, 0, 0, H_gtk_recent_manager_add_item, pl_bus);
  Xg_define_procedure(gtk_recent_manager_add_full, gxg_gtk_recent_manager_add_full_w, 3, 0, 0, H_gtk_recent_manager_add_full, pl_busu);
  Xg_define_procedure(gtk_tree_model_filter_convert_child_iter_to_iter, gxg_gtk_tree_model_filter_convert_child_iter_to_iter_w, 3, 0, 0, H_gtk_tree_model_filter_convert_child_iter_to_iter, pl_bu);
  Xg_define_procedure(gtk_tree_view_get_grid_lines, gxg_gtk_tree_view_get_grid_lines_w, 1, 0, 0, H_gtk_tree_view_get_grid_lines, pl_gu);
  Xg_define_procedure(gtk_tree_view_set_grid_lines, gxg_gtk_tree_view_set_grid_lines_w, 2, 0, 0, H_gtk_tree_view_set_grid_lines, pl_tug);
  Xg_define_procedure(gtk_tree_view_get_enable_tree_lines, gxg_gtk_tree_view_get_enable_tree_lines_w, 1, 0, 0, H_gtk_tree_view_get_enable_tree_lines, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_enable_tree_lines, gxg_gtk_tree_view_set_enable_tree_lines_w, 2, 0, 0, H_gtk_tree_view_set_enable_tree_lines, pl_tub);
  Xg_define_procedure(gtk_label_set_line_wrap_mode, gxg_gtk_label_set_line_wrap_mode_w, 2, 0, 0, H_gtk_label_set_line_wrap_mode, pl_tug);
  Xg_define_procedure(gtk_label_get_line_wrap_mode, gxg_gtk_label_get_line_wrap_mode_w, 1, 0, 0, H_gtk_label_get_line_wrap_mode, pl_gu);
  Xg_define_procedure(gtk_print_context_get_cairo_context, gxg_gtk_print_context_get_cairo_context_w, 1, 0, 0, H_gtk_print_context_get_cairo_context, pl_pu);
  Xg_define_procedure(gtk_print_context_get_page_setup, gxg_gtk_print_context_get_page_setup_w, 1, 0, 0, H_gtk_print_context_get_page_setup, pl_pu);
  Xg_define_procedure(gtk_print_context_get_width, gxg_gtk_print_context_get_width_w, 1, 0, 0, H_gtk_print_context_get_width, pl_du);
  Xg_define_procedure(gtk_print_context_get_height, gxg_gtk_print_context_get_height_w, 1, 0, 0, H_gtk_print_context_get_height, pl_du);
  Xg_define_procedure(gtk_print_context_get_dpi_x, gxg_gtk_print_context_get_dpi_x_w, 1, 0, 0, H_gtk_print_context_get_dpi_x, pl_du);
  Xg_define_procedure(gtk_print_context_get_dpi_y, gxg_gtk_print_context_get_dpi_y_w, 1, 0, 0, H_gtk_print_context_get_dpi_y, pl_du);
  Xg_define_procedure(gtk_print_context_create_pango_context, gxg_gtk_print_context_create_pango_context_w, 1, 0, 0, H_gtk_print_context_create_pango_context, pl_pu);
  Xg_define_procedure(gtk_print_context_create_pango_layout, gxg_gtk_print_context_create_pango_layout_w, 1, 0, 0, H_gtk_print_context_create_pango_layout, pl_pu);
  Xg_define_procedure(gtk_print_context_set_cairo_context, gxg_gtk_print_context_set_cairo_context_w, 4, 0, 0, H_gtk_print_context_set_cairo_context, pl_tuur);
  Xg_define_procedure(gtk_print_operation_new, gxg_gtk_print_operation_new_w, 0, 0, 0, H_gtk_print_operation_new, pl_p);
  Xg_define_procedure(gtk_print_operation_set_default_page_setup, gxg_gtk_print_operation_set_default_page_setup_w, 2, 0, 0, H_gtk_print_operation_set_default_page_setup, pl_tu);
  Xg_define_procedure(gtk_print_operation_get_default_page_setup, gxg_gtk_print_operation_get_default_page_setup_w, 1, 0, 0, H_gtk_print_operation_get_default_page_setup, pl_pu);
  Xg_define_procedure(gtk_print_operation_set_print_settings, gxg_gtk_print_operation_set_print_settings_w, 2, 0, 0, H_gtk_print_operation_set_print_settings, pl_tu);
  Xg_define_procedure(gtk_print_operation_get_print_settings, gxg_gtk_print_operation_get_print_settings_w, 1, 0, 0, H_gtk_print_operation_get_print_settings, pl_pu);
  Xg_define_procedure(gtk_print_operation_set_job_name, gxg_gtk_print_operation_set_job_name_w, 2, 0, 0, H_gtk_print_operation_set_job_name, pl_tus);
  Xg_define_procedure(gtk_print_operation_set_n_pages, gxg_gtk_print_operation_set_n_pages_w, 2, 0, 0, H_gtk_print_operation_set_n_pages, pl_tui);
  Xg_define_procedure(gtk_print_operation_set_current_page, gxg_gtk_print_operation_set_current_page_w, 2, 0, 0, H_gtk_print_operation_set_current_page, pl_tui);
  Xg_define_procedure(gtk_print_operation_set_use_full_page, gxg_gtk_print_operation_set_use_full_page_w, 2, 0, 0, H_gtk_print_operation_set_use_full_page, pl_tub);
  Xg_define_procedure(gtk_print_operation_set_unit, gxg_gtk_print_operation_set_unit_w, 2, 0, 0, H_gtk_print_operation_set_unit, pl_tui);
  Xg_define_procedure(gtk_print_operation_set_export_filename, gxg_gtk_print_operation_set_export_filename_w, 2, 0, 0, H_gtk_print_operation_set_export_filename, pl_tus);
  Xg_define_procedure(gtk_print_operation_set_track_print_status, gxg_gtk_print_operation_set_track_print_status_w, 2, 0, 0, H_gtk_print_operation_set_track_print_status, pl_tub);
  Xg_define_procedure(gtk_print_operation_set_show_progress, gxg_gtk_print_operation_set_show_progress_w, 2, 0, 0, H_gtk_print_operation_set_show_progress, pl_tub);
  Xg_define_procedure(gtk_print_operation_set_allow_async, gxg_gtk_print_operation_set_allow_async_w, 2, 0, 0, H_gtk_print_operation_set_allow_async, pl_tub);
  Xg_define_procedure(gtk_print_operation_set_custom_tab_label, gxg_gtk_print_operation_set_custom_tab_label_w, 2, 0, 0, H_gtk_print_operation_set_custom_tab_label, pl_tus);
  Xg_define_procedure(gtk_print_operation_run, gxg_gtk_print_operation_run_w, 3, 1, 0, H_gtk_print_operation_run, pl_pugu);
  Xg_define_procedure(gtk_print_operation_get_error, gxg_gtk_print_operation_get_error_w, 1, 1, 0, H_gtk_print_operation_get_error, pl_pu);
  Xg_define_procedure(gtk_print_operation_get_status, gxg_gtk_print_operation_get_status_w, 1, 0, 0, H_gtk_print_operation_get_status, pl_gu);
  Xg_define_procedure(gtk_print_operation_get_status_string, gxg_gtk_print_operation_get_status_string_w, 1, 0, 0, H_gtk_print_operation_get_status_string, pl_su);
  Xg_define_procedure(gtk_print_operation_is_finished, gxg_gtk_print_operation_is_finished_w, 1, 0, 0, H_gtk_print_operation_is_finished, pl_bu);
  Xg_define_procedure(gtk_print_operation_cancel, gxg_gtk_print_operation_cancel_w, 1, 0, 0, H_gtk_print_operation_cancel, pl_tu);
  Xg_define_procedure(gtk_print_run_page_setup_dialog, gxg_gtk_print_run_page_setup_dialog_w, 3, 0, 0, H_gtk_print_run_page_setup_dialog, pl_pu);
  Xg_define_procedure(gtk_print_run_page_setup_dialog_async, gxg_gtk_print_run_page_setup_dialog_async_w, 5, 0, 0, H_gtk_print_run_page_setup_dialog_async, pl_tuuut);
  Xg_define_procedure(gtk_print_settings_new, gxg_gtk_print_settings_new_w, 0, 0, 0, H_gtk_print_settings_new, pl_p);
  Xg_define_procedure(gtk_print_settings_copy, gxg_gtk_print_settings_copy_w, 1, 0, 0, H_gtk_print_settings_copy, pl_pu);
  Xg_define_procedure(gtk_print_settings_has_key, gxg_gtk_print_settings_has_key_w, 2, 0, 0, H_gtk_print_settings_has_key, pl_bus);
  Xg_define_procedure(gtk_print_settings_get, gxg_gtk_print_settings_get_w, 2, 0, 0, H_gtk_print_settings_get, pl_sus);
  Xg_define_procedure(gtk_print_settings_set, gxg_gtk_print_settings_set_w, 3, 0, 0, H_gtk_print_settings_set, pl_tus);
  Xg_define_procedure(gtk_print_settings_unset, gxg_gtk_print_settings_unset_w, 2, 0, 0, H_gtk_print_settings_unset, pl_tus);
  Xg_define_procedure(gtk_print_settings_foreach, gxg_gtk_print_settings_foreach_w, 3, 0, 0, H_gtk_print_settings_foreach, pl_tut);
  Xg_define_procedure(gtk_print_settings_get_bool, gxg_gtk_print_settings_get_bool_w, 2, 0, 0, H_gtk_print_settings_get_bool, pl_bus);
  Xg_define_procedure(gtk_print_settings_set_bool, gxg_gtk_print_settings_set_bool_w, 3, 0, 0, H_gtk_print_settings_set_bool, pl_tusb);
  Xg_define_procedure(gtk_print_settings_get_double, gxg_gtk_print_settings_get_double_w, 2, 0, 0, H_gtk_print_settings_get_double, pl_dus);
  Xg_define_procedure(gtk_print_settings_get_double_with_default, gxg_gtk_print_settings_get_double_with_default_w, 3, 0, 0, H_gtk_print_settings_get_double_with_default, pl_dusr);
  Xg_define_procedure(gtk_print_settings_set_double, gxg_gtk_print_settings_set_double_w, 3, 0, 0, H_gtk_print_settings_set_double, pl_tusr);
  Xg_define_procedure(gtk_print_settings_get_length, gxg_gtk_print_settings_get_length_w, 3, 0, 0, H_gtk_print_settings_get_length, pl_dusi);
  Xg_define_procedure(gtk_print_settings_set_length, gxg_gtk_print_settings_set_length_w, 4, 0, 0, H_gtk_print_settings_set_length, pl_tusri);
  Xg_define_procedure(gtk_print_settings_get_int, gxg_gtk_print_settings_get_int_w, 2, 0, 0, H_gtk_print_settings_get_int, pl_ius);
  Xg_define_procedure(gtk_print_settings_get_int_with_default, gxg_gtk_print_settings_get_int_with_default_w, 3, 0, 0, H_gtk_print_settings_get_int_with_default, pl_iusi);
  Xg_define_procedure(gtk_print_settings_set_int, gxg_gtk_print_settings_set_int_w, 3, 0, 0, H_gtk_print_settings_set_int, pl_tusi);
  Xg_define_procedure(gtk_print_settings_get_printer, gxg_gtk_print_settings_get_printer_w, 1, 0, 0, H_gtk_print_settings_get_printer, pl_su);
  Xg_define_procedure(gtk_print_settings_set_printer, gxg_gtk_print_settings_set_printer_w, 2, 0, 0, H_gtk_print_settings_set_printer, pl_tus);
  Xg_define_procedure(gtk_print_settings_get_orientation, gxg_gtk_print_settings_get_orientation_w, 1, 0, 0, H_gtk_print_settings_get_orientation, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_orientation, gxg_gtk_print_settings_set_orientation_w, 2, 0, 0, H_gtk_print_settings_set_orientation, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_paper_size, gxg_gtk_print_settings_get_paper_size_w, 1, 0, 0, H_gtk_print_settings_get_paper_size, pl_pu);
  Xg_define_procedure(gtk_print_settings_set_paper_size, gxg_gtk_print_settings_set_paper_size_w, 2, 0, 0, H_gtk_print_settings_set_paper_size, pl_tu);
  Xg_define_procedure(gtk_print_settings_get_paper_width, gxg_gtk_print_settings_get_paper_width_w, 2, 0, 0, H_gtk_print_settings_get_paper_width, pl_dui);
  Xg_define_procedure(gtk_print_settings_set_paper_width, gxg_gtk_print_settings_set_paper_width_w, 3, 0, 0, H_gtk_print_settings_set_paper_width, pl_turi);
  Xg_define_procedure(gtk_print_settings_get_paper_height, gxg_gtk_print_settings_get_paper_height_w, 2, 0, 0, H_gtk_print_settings_get_paper_height, pl_dui);
  Xg_define_procedure(gtk_print_settings_set_paper_height, gxg_gtk_print_settings_set_paper_height_w, 3, 0, 0, H_gtk_print_settings_set_paper_height, pl_turi);
  Xg_define_procedure(gtk_print_settings_get_use_color, gxg_gtk_print_settings_get_use_color_w, 1, 0, 0, H_gtk_print_settings_get_use_color, pl_bu);
  Xg_define_procedure(gtk_print_settings_set_use_color, gxg_gtk_print_settings_set_use_color_w, 2, 0, 0, H_gtk_print_settings_set_use_color, pl_tub);
  Xg_define_procedure(gtk_print_settings_get_collate, gxg_gtk_print_settings_get_collate_w, 1, 0, 0, H_gtk_print_settings_get_collate, pl_bu);
  Xg_define_procedure(gtk_print_settings_set_collate, gxg_gtk_print_settings_set_collate_w, 2, 0, 0, H_gtk_print_settings_set_collate, pl_tub);
  Xg_define_procedure(gtk_print_settings_get_reverse, gxg_gtk_print_settings_get_reverse_w, 1, 0, 0, H_gtk_print_settings_get_reverse, pl_bu);
  Xg_define_procedure(gtk_print_settings_set_reverse, gxg_gtk_print_settings_set_reverse_w, 2, 0, 0, H_gtk_print_settings_set_reverse, pl_tub);
  Xg_define_procedure(gtk_print_settings_get_duplex, gxg_gtk_print_settings_get_duplex_w, 1, 0, 0, H_gtk_print_settings_get_duplex, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_duplex, gxg_gtk_print_settings_set_duplex_w, 2, 0, 0, H_gtk_print_settings_set_duplex, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_quality, gxg_gtk_print_settings_get_quality_w, 1, 0, 0, H_gtk_print_settings_get_quality, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_quality, gxg_gtk_print_settings_set_quality_w, 2, 0, 0, H_gtk_print_settings_set_quality, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_n_copies, gxg_gtk_print_settings_get_n_copies_w, 1, 0, 0, H_gtk_print_settings_get_n_copies, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_n_copies, gxg_gtk_print_settings_set_n_copies_w, 2, 0, 0, H_gtk_print_settings_set_n_copies, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_number_up, gxg_gtk_print_settings_get_number_up_w, 1, 0, 0, H_gtk_print_settings_get_number_up, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_number_up, gxg_gtk_print_settings_set_number_up_w, 2, 0, 0, H_gtk_print_settings_set_number_up, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_resolution, gxg_gtk_print_settings_get_resolution_w, 1, 0, 0, H_gtk_print_settings_get_resolution, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_resolution, gxg_gtk_print_settings_set_resolution_w, 2, 0, 0, H_gtk_print_settings_set_resolution, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_scale, gxg_gtk_print_settings_get_scale_w, 1, 0, 0, H_gtk_print_settings_get_scale, pl_du);
  Xg_define_procedure(gtk_print_settings_set_scale, gxg_gtk_print_settings_set_scale_w, 2, 0, 0, H_gtk_print_settings_set_scale, pl_tur);
  Xg_define_procedure(gtk_print_settings_get_print_pages, gxg_gtk_print_settings_get_print_pages_w, 1, 0, 0, H_gtk_print_settings_get_print_pages, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_print_pages, gxg_gtk_print_settings_set_print_pages_w, 2, 0, 0, H_gtk_print_settings_set_print_pages, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_page_ranges, gxg_gtk_print_settings_get_page_ranges_w, 2, 0, 0, H_gtk_print_settings_get_page_ranges, pl_pu);
  Xg_define_procedure(gtk_print_settings_set_page_ranges, gxg_gtk_print_settings_set_page_ranges_w, 3, 0, 0, H_gtk_print_settings_set_page_ranges, pl_tuui);
  Xg_define_procedure(gtk_print_settings_get_page_set, gxg_gtk_print_settings_get_page_set_w, 1, 0, 0, H_gtk_print_settings_get_page_set, pl_iu);
  Xg_define_procedure(gtk_print_settings_set_page_set, gxg_gtk_print_settings_set_page_set_w, 2, 0, 0, H_gtk_print_settings_set_page_set, pl_tui);
  Xg_define_procedure(gtk_print_settings_get_default_source, gxg_gtk_print_settings_get_default_source_w, 1, 0, 0, H_gtk_print_settings_get_default_source, pl_su);
  Xg_define_procedure(gtk_print_settings_set_default_source, gxg_gtk_print_settings_set_default_source_w, 2, 0, 0, H_gtk_print_settings_set_default_source, pl_tus);
  Xg_define_procedure(gtk_print_settings_get_media_type, gxg_gtk_print_settings_get_media_type_w, 1, 0, 0, H_gtk_print_settings_get_media_type, pl_su);
  Xg_define_procedure(gtk_print_settings_set_media_type, gxg_gtk_print_settings_set_media_type_w, 2, 0, 0, H_gtk_print_settings_set_media_type, pl_tus);
  Xg_define_procedure(gtk_print_settings_get_dither, gxg_gtk_print_settings_get_dither_w, 1, 0, 0, H_gtk_print_settings_get_dither, pl_su);
  Xg_define_procedure(gtk_print_settings_set_dither, gxg_gtk_print_settings_set_dither_w, 2, 0, 0, H_gtk_print_settings_set_dither, pl_tus);
  Xg_define_procedure(gtk_print_settings_get_finishings, gxg_gtk_print_settings_get_finishings_w, 1, 0, 0, H_gtk_print_settings_get_finishings, pl_su);
  Xg_define_procedure(gtk_print_settings_set_finishings, gxg_gtk_print_settings_set_finishings_w, 2, 0, 0, H_gtk_print_settings_set_finishings, pl_tus);
  Xg_define_procedure(gtk_print_settings_get_output_bin, gxg_gtk_print_settings_get_output_bin_w, 1, 0, 0, H_gtk_print_settings_get_output_bin, pl_su);
  Xg_define_procedure(gtk_print_settings_set_output_bin, gxg_gtk_print_settings_set_output_bin_w, 2, 0, 0, H_gtk_print_settings_set_output_bin, pl_tus);
  Xg_define_procedure(pango_cairo_create_layout, gxg_pango_cairo_create_layout_w, 1, 0, 0, H_pango_cairo_create_layout, pl_pu);
  Xg_define_procedure(pango_cairo_update_layout, gxg_pango_cairo_update_layout_w, 2, 0, 0, H_pango_cairo_update_layout, pl_tu);
  Xg_define_procedure(pango_cairo_update_context, gxg_pango_cairo_update_context_w, 2, 0, 0, H_pango_cairo_update_context, pl_tu);
  Xg_define_procedure(pango_cairo_context_set_font_options, gxg_pango_cairo_context_set_font_options_w, 2, 0, 0, H_pango_cairo_context_set_font_options, pl_tu);
  Xg_define_procedure(pango_cairo_context_get_font_options, gxg_pango_cairo_context_get_font_options_w, 1, 0, 0, H_pango_cairo_context_get_font_options, pl_pu);
  Xg_define_procedure(pango_cairo_context_set_resolution, gxg_pango_cairo_context_set_resolution_w, 2, 0, 0, H_pango_cairo_context_set_resolution, pl_tur);
  Xg_define_procedure(pango_cairo_context_get_resolution, gxg_pango_cairo_context_get_resolution_w, 1, 0, 0, H_pango_cairo_context_get_resolution, pl_du);
  Xg_define_procedure(pango_cairo_show_glyph_string, gxg_pango_cairo_show_glyph_string_w, 3, 0, 0, H_pango_cairo_show_glyph_string, pl_tu);
  Xg_define_procedure(pango_cairo_show_layout_line, gxg_pango_cairo_show_layout_line_w, 2, 0, 0, H_pango_cairo_show_layout_line, pl_tu);
  Xg_define_procedure(pango_cairo_show_layout, gxg_pango_cairo_show_layout_w, 2, 0, 0, H_pango_cairo_show_layout, pl_tu);
  Xg_define_procedure(pango_cairo_show_error_underline, gxg_pango_cairo_show_error_underline_w, 5, 0, 0, H_pango_cairo_show_error_underline, pl_tur);
  Xg_define_procedure(pango_cairo_glyph_string_path, gxg_pango_cairo_glyph_string_path_w, 3, 0, 0, H_pango_cairo_glyph_string_path, pl_tu);
  Xg_define_procedure(pango_cairo_layout_line_path, gxg_pango_cairo_layout_line_path_w, 2, 0, 0, H_pango_cairo_layout_line_path, pl_tu);
  Xg_define_procedure(pango_cairo_layout_path, gxg_pango_cairo_layout_path_w, 2, 0, 0, H_pango_cairo_layout_path, pl_tu);
  Xg_define_procedure(pango_cairo_error_underline_path, gxg_pango_cairo_error_underline_path_w, 5, 0, 0, H_pango_cairo_error_underline_path, pl_tur);
  Xg_define_procedure(gdk_cairo_set_source_pixbuf, gxg_gdk_cairo_set_source_pixbuf_w, 4, 0, 0, H_gdk_cairo_set_source_pixbuf, pl_tuur);
  Xg_define_procedure(gdk_cairo_rectangle, gxg_gdk_cairo_rectangle_w, 2, 0, 0, H_gdk_cairo_rectangle, pl_tu);
  Xg_define_procedure(gdk_threads_add_idle_full, gxg_gdk_threads_add_idle_full_w, 4, 0, 0, H_gdk_threads_add_idle_full, pl_iit);
  Xg_define_procedure(gdk_threads_add_idle, gxg_gdk_threads_add_idle_w, 2, 0, 0, H_gdk_threads_add_idle, pl_it);
  Xg_define_procedure(gdk_threads_add_timeout_full, gxg_gdk_threads_add_timeout_full_w, 5, 0, 0, H_gdk_threads_add_timeout_full, pl_iiit);
  Xg_define_procedure(gdk_threads_add_timeout, gxg_gdk_threads_add_timeout_w, 3, 0, 0, H_gdk_threads_add_timeout, pl_iit);
  Xg_define_procedure(gdk_window_set_startup_id, gxg_gdk_window_set_startup_id_w, 2, 0, 0, H_gdk_window_set_startup_id, pl_tus);
  Xg_define_procedure(gdk_window_beep, gxg_gdk_window_beep_w, 1, 0, 0, H_gdk_window_beep, pl_tu);
  Xg_define_procedure(gdk_window_set_opacity, gxg_gdk_window_set_opacity_w, 2, 0, 0, H_gdk_window_set_opacity, pl_tur);
  Xg_define_procedure(gtk_binding_entry_skip, gxg_gtk_binding_entry_skip_w, 3, 0, 0, H_gtk_binding_entry_skip, pl_tuig);
  Xg_define_procedure(gtk_cell_layout_get_cells, gxg_gtk_cell_layout_get_cells_w, 1, 0, 0, H_gtk_cell_layout_get_cells, pl_pu);
  Xg_define_procedure(gtk_entry_completion_set_inline_selection, gxg_gtk_entry_completion_set_inline_selection_w, 2, 0, 0, H_gtk_entry_completion_set_inline_selection, pl_tub);
  Xg_define_procedure(gtk_entry_completion_get_inline_selection, gxg_gtk_entry_completion_get_inline_selection_w, 1, 0, 0, H_gtk_entry_completion_get_inline_selection, pl_bu);
  Xg_define_procedure(gtk_entry_completion_get_completion_prefix, gxg_gtk_entry_completion_get_completion_prefix_w, 1, 0, 0, H_gtk_entry_completion_get_completion_prefix, pl_su);
  Xg_define_procedure(gtk_entry_set_cursor_hadjustment, gxg_gtk_entry_set_cursor_hadjustment_w, 2, 0, 0, H_gtk_entry_set_cursor_hadjustment, pl_tu);
  Xg_define_procedure(gtk_entry_get_cursor_hadjustment, gxg_gtk_entry_get_cursor_hadjustment_w, 1, 0, 0, H_gtk_entry_get_cursor_hadjustment, pl_pu);
  Xg_define_procedure(gtk_icon_theme_list_contexts, gxg_gtk_icon_theme_list_contexts_w, 1, 0, 0, H_gtk_icon_theme_list_contexts, pl_pu);
  Xg_define_procedure(gtk_print_settings_new_from_file, gxg_gtk_print_settings_new_from_file_w, 1, 1, 0, H_gtk_print_settings_new_from_file, pl_psu);
  Xg_define_procedure(gtk_print_settings_to_file, gxg_gtk_print_settings_to_file_w, 2, 1, 0, H_gtk_print_settings_to_file, pl_pusu);
  Xg_define_procedure(gtk_range_set_show_fill_level, gxg_gtk_range_set_show_fill_level_w, 2, 0, 0, H_gtk_range_set_show_fill_level, pl_tub);
  Xg_define_procedure(gtk_range_get_show_fill_level, gxg_gtk_range_get_show_fill_level_w, 1, 0, 0, H_gtk_range_get_show_fill_level, pl_bu);
  Xg_define_procedure(gtk_range_set_restrict_to_fill_level, gxg_gtk_range_set_restrict_to_fill_level_w, 2, 0, 0, H_gtk_range_set_restrict_to_fill_level, pl_tub);
  Xg_define_procedure(gtk_range_get_restrict_to_fill_level, gxg_gtk_range_get_restrict_to_fill_level_w, 1, 0, 0, H_gtk_range_get_restrict_to_fill_level, pl_bu);
  Xg_define_procedure(gtk_range_set_fill_level, gxg_gtk_range_set_fill_level_w, 2, 0, 0, H_gtk_range_set_fill_level, pl_tur);
  Xg_define_procedure(gtk_range_get_fill_level, gxg_gtk_range_get_fill_level_w, 1, 0, 0, H_gtk_range_get_fill_level, pl_du);
  Xg_define_procedure(gtk_tree_view_set_show_expanders, gxg_gtk_tree_view_set_show_expanders_w, 2, 0, 0, H_gtk_tree_view_set_show_expanders, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_show_expanders, gxg_gtk_tree_view_get_show_expanders_w, 1, 0, 0, H_gtk_tree_view_get_show_expanders, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_level_indentation, gxg_gtk_tree_view_set_level_indentation_w, 2, 0, 0, H_gtk_tree_view_set_level_indentation, pl_tui);
  Xg_define_procedure(gtk_tree_view_get_level_indentation, gxg_gtk_tree_view_get_level_indentation_w, 1, 0, 0, H_gtk_tree_view_get_level_indentation, pl_iu);
  Xg_define_procedure(gtk_widget_keynav_failed, gxg_gtk_widget_keynav_failed_w, 2, 0, 0, H_gtk_widget_keynav_failed, pl_bug);
  Xg_define_procedure(gtk_widget_error_bell, gxg_gtk_widget_error_bell_w, 1, 0, 0, H_gtk_widget_error_bell, pl_tu);
  Xg_define_procedure(gtk_widget_set_tooltip_window, gxg_gtk_widget_set_tooltip_window_w, 2, 0, 0, H_gtk_widget_set_tooltip_window, pl_tu);
  Xg_define_procedure(gtk_widget_get_tooltip_window, gxg_gtk_widget_get_tooltip_window_w, 1, 0, 0, H_gtk_widget_get_tooltip_window, pl_pu);
  Xg_define_procedure(gtk_widget_trigger_tooltip_query, gxg_gtk_widget_trigger_tooltip_query_w, 1, 0, 0, H_gtk_widget_trigger_tooltip_query, pl_tu);
  Xg_define_procedure(gtk_window_set_startup_id, gxg_gtk_window_set_startup_id_w, 2, 0, 0, H_gtk_window_set_startup_id, pl_tus);
  Xg_define_procedure(gtk_text_buffer_add_mark, gxg_gtk_text_buffer_add_mark_w, 3, 0, 0, H_gtk_text_buffer_add_mark, pl_tu);
  Xg_define_procedure(gtk_text_mark_new, gxg_gtk_text_mark_new_w, 2, 0, 0, H_gtk_text_mark_new, pl_psb);
  Xg_define_procedure(gtk_tree_view_column_get_tree_view, gxg_gtk_tree_view_column_get_tree_view_w, 1, 0, 0, H_gtk_tree_view_column_get_tree_view, pl_pu);
  Xg_define_procedure(gtk_tooltip_set_text, gxg_gtk_tooltip_set_text_w, 2, 0, 0, H_gtk_tooltip_set_text, pl_tus);
  Xg_define_procedure(gtk_tree_view_convert_widget_to_tree_coords, gxg_gtk_tree_view_convert_widget_to_tree_coords_w, 3, 2, 0, H_gtk_tree_view_convert_widget_to_tree_coords, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_convert_tree_to_widget_coords, gxg_gtk_tree_view_convert_tree_to_widget_coords_w, 3, 2, 0, H_gtk_tree_view_convert_tree_to_widget_coords, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_convert_widget_to_bin_window_coords, gxg_gtk_tree_view_convert_widget_to_bin_window_coords_w, 3, 2, 0, H_gtk_tree_view_convert_widget_to_bin_window_coords, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_convert_bin_window_to_widget_coords, gxg_gtk_tree_view_convert_bin_window_to_widget_coords_w, 3, 2, 0, H_gtk_tree_view_convert_bin_window_to_widget_coords, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_convert_tree_to_bin_window_coords, gxg_gtk_tree_view_convert_tree_to_bin_window_coords_w, 3, 2, 0, H_gtk_tree_view_convert_tree_to_bin_window_coords, pl_puiiu);
  Xg_define_procedure(gtk_tree_view_convert_bin_window_to_tree_coords, gxg_gtk_tree_view_convert_bin_window_to_tree_coords_w, 3, 2, 0, H_gtk_tree_view_convert_bin_window_to_tree_coords, pl_puiiu);
  Xg_define_procedure(gtk_widget_set_tooltip_text, gxg_gtk_widget_set_tooltip_text_w, 2, 0, 0, H_gtk_widget_set_tooltip_text, pl_tus);
  Xg_define_procedure(gtk_widget_get_tooltip_text, gxg_gtk_widget_get_tooltip_text_w, 1, 0, 0, H_gtk_widget_get_tooltip_text, pl_su);
  Xg_define_procedure(gtk_widget_set_tooltip_markup, gxg_gtk_widget_set_tooltip_markup_w, 2, 0, 0, H_gtk_widget_set_tooltip_markup, pl_tus);
  Xg_define_procedure(gtk_widget_get_tooltip_markup, gxg_gtk_widget_get_tooltip_markup_w, 1, 0, 0, H_gtk_widget_get_tooltip_markup, pl_su);
  Xg_define_procedure(gtk_tree_view_is_rubber_banding_active, gxg_gtk_tree_view_is_rubber_banding_active_w, 1, 0, 0, H_gtk_tree_view_is_rubber_banding_active, pl_bu);
  Xg_define_procedure(gtk_icon_view_set_tooltip_item, gxg_gtk_icon_view_set_tooltip_item_w, 3, 0, 0, H_gtk_icon_view_set_tooltip_item, pl_tu);
  Xg_define_procedure(gtk_icon_view_set_tooltip_cell, gxg_gtk_icon_view_set_tooltip_cell_w, 4, 0, 0, H_gtk_icon_view_set_tooltip_cell, pl_tu);
  Xg_define_procedure(gtk_icon_view_get_tooltip_context, gxg_gtk_icon_view_get_tooltip_context_w, 3, 4, 0, H_gtk_icon_view_get_tooltip_context, pl_puuubu);
  Xg_define_procedure(gtk_icon_view_set_tooltip_column, gxg_gtk_icon_view_set_tooltip_column_w, 2, 0, 0, H_gtk_icon_view_set_tooltip_column, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_tooltip_column, gxg_gtk_icon_view_get_tooltip_column_w, 1, 0, 0, H_gtk_icon_view_get_tooltip_column, pl_iu);
  Xg_define_procedure(gtk_menu_tool_button_set_arrow_tooltip_text, gxg_gtk_menu_tool_button_set_arrow_tooltip_text_w, 2, 0, 0, H_gtk_menu_tool_button_set_arrow_tooltip_text, pl_tus);
  Xg_define_procedure(gtk_menu_tool_button_set_arrow_tooltip_markup, gxg_gtk_menu_tool_button_set_arrow_tooltip_markup_w, 2, 0, 0, H_gtk_menu_tool_button_set_arrow_tooltip_markup, pl_tus);
  Xg_define_procedure(gtk_tool_item_set_tooltip_text, gxg_gtk_tool_item_set_tooltip_text_w, 2, 0, 0, H_gtk_tool_item_set_tooltip_text, pl_tus);
  Xg_define_procedure(gtk_tool_item_set_tooltip_markup, gxg_gtk_tool_item_set_tooltip_markup_w, 2, 0, 0, H_gtk_tool_item_set_tooltip_markup, pl_tus);
  Xg_define_procedure(gtk_tooltip_set_tip_area, gxg_gtk_tooltip_set_tip_area_w, 2, 0, 0, H_gtk_tooltip_set_tip_area, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_tooltip_row, gxg_gtk_tree_view_set_tooltip_row_w, 3, 0, 0, H_gtk_tree_view_set_tooltip_row, pl_tu);
  Xg_define_procedure(gtk_tree_view_set_tooltip_cell, gxg_gtk_tree_view_set_tooltip_cell_w, 5, 0, 0, H_gtk_tree_view_set_tooltip_cell, pl_tu);
  Xg_define_procedure(gtk_tree_view_get_tooltip_context, gxg_gtk_tree_view_get_tooltip_context_w, 3, 4, 0, H_gtk_tree_view_get_tooltip_context, pl_puuubu);
  Xg_define_procedure(gtk_tree_view_set_tooltip_column, gxg_gtk_tree_view_set_tooltip_column_w, 2, 0, 0, H_gtk_tree_view_set_tooltip_column, pl_tui);
  Xg_define_procedure(gtk_tree_view_get_tooltip_column, gxg_gtk_tree_view_get_tooltip_column_w, 1, 0, 0, H_gtk_tree_view_get_tooltip_column, pl_iu);
  Xg_define_procedure(gtk_widget_set_has_tooltip, gxg_gtk_widget_set_has_tooltip_w, 2, 0, 0, H_gtk_widget_set_has_tooltip, pl_tub);
  Xg_define_procedure(gtk_widget_get_has_tooltip, gxg_gtk_widget_get_has_tooltip_w, 1, 0, 0, H_gtk_widget_get_has_tooltip, pl_bu);
#if GTK_CHECK_VERSION(2, 14, 0)
  Xg_define_procedure(gtk_calendar_set_detail_func, gxg_gtk_calendar_set_detail_func_w, 4, 0, 0, H_gtk_calendar_set_detail_func, pl_tut);
  Xg_define_procedure(gtk_calendar_set_detail_width_chars, gxg_gtk_calendar_set_detail_width_chars_w, 2, 0, 0, H_gtk_calendar_set_detail_width_chars, pl_tui);
  Xg_define_procedure(gtk_calendar_set_detail_height_rows, gxg_gtk_calendar_set_detail_height_rows_w, 2, 0, 0, H_gtk_calendar_set_detail_height_rows, pl_tui);
  Xg_define_procedure(gtk_calendar_get_detail_width_chars, gxg_gtk_calendar_get_detail_width_chars_w, 1, 0, 0, H_gtk_calendar_get_detail_width_chars, pl_iu);
  Xg_define_procedure(gtk_calendar_get_detail_height_rows, gxg_gtk_calendar_get_detail_height_rows_w, 1, 0, 0, H_gtk_calendar_get_detail_height_rows, pl_iu);
  Xg_define_procedure(gtk_accel_group_get_is_locked, gxg_gtk_accel_group_get_is_locked_w, 1, 0, 0, H_gtk_accel_group_get_is_locked, pl_bu);
  Xg_define_procedure(gtk_dialog_get_content_area, gxg_gtk_dialog_get_content_area_w, 1, 0, 0, H_gtk_dialog_get_content_area, pl_pu);
  Xg_define_procedure(gtk_entry_set_overwrite_mode, gxg_gtk_entry_set_overwrite_mode_w, 2, 0, 0, H_gtk_entry_set_overwrite_mode, pl_tub);
  Xg_define_procedure(gtk_entry_get_overwrite_mode, gxg_gtk_entry_get_overwrite_mode_w, 1, 0, 0, H_gtk_entry_get_overwrite_mode, pl_bu);
  Xg_define_procedure(gtk_entry_get_text_length, gxg_gtk_entry_get_text_length_w, 1, 0, 0, H_gtk_entry_get_text_length, pl_iu);
  Xg_define_procedure(gtk_menu_get_accel_path, gxg_gtk_menu_get_accel_path_w, 1, 0, 0, H_gtk_menu_get_accel_path, pl_su);
  Xg_define_procedure(gtk_menu_get_monitor, gxg_gtk_menu_get_monitor_w, 1, 0, 0, H_gtk_menu_get_monitor, pl_iu);
  Xg_define_procedure(gtk_menu_item_get_accel_path, gxg_gtk_menu_item_get_accel_path_w, 1, 0, 0, H_gtk_menu_item_get_accel_path, pl_su);
  Xg_define_procedure(gtk_scale_button_get_plus_button, gxg_gtk_scale_button_get_plus_button_w, 1, 0, 0, H_gtk_scale_button_get_plus_button, pl_pu);
  Xg_define_procedure(gtk_scale_button_get_minus_button, gxg_gtk_scale_button_get_minus_button_w, 1, 0, 0, H_gtk_scale_button_get_minus_button, pl_pu);
  Xg_define_procedure(gtk_scale_button_get_popup, gxg_gtk_scale_button_get_popup_w, 1, 0, 0, H_gtk_scale_button_get_popup, pl_pu);
  Xg_define_procedure(gtk_selection_data_get_target, gxg_gtk_selection_data_get_target_w, 1, 0, 0, H_gtk_selection_data_get_target, pl_tu);
  Xg_define_procedure(gtk_selection_data_get_data_type, gxg_gtk_selection_data_get_data_type_w, 1, 0, 0, H_gtk_selection_data_get_data_type, pl_tu);
  Xg_define_procedure(gtk_selection_data_get_format, gxg_gtk_selection_data_get_format_w, 1, 0, 0, H_gtk_selection_data_get_format, pl_iu);
  Xg_define_procedure(gtk_selection_data_get_display, gxg_gtk_selection_data_get_display_w, 1, 0, 0, H_gtk_selection_data_get_display, pl_pu);
  Xg_define_procedure(gtk_widget_get_window, gxg_gtk_widget_get_window_w, 1, 0, 0, H_gtk_widget_get_window, pl_pu);
  Xg_define_procedure(gtk_accel_group_get_modifier_mask, gxg_gtk_accel_group_get_modifier_mask_w, 1, 0, 0, H_gtk_accel_group_get_modifier_mask, pl_gu);
  Xg_define_procedure(gdk_threads_add_timeout_seconds_full, gxg_gdk_threads_add_timeout_seconds_full_w, 5, 0, 0, H_gdk_threads_add_timeout_seconds_full, pl_iiit);
  Xg_define_procedure(gdk_threads_add_timeout_seconds, gxg_gdk_threads_add_timeout_seconds_w, 3, 0, 0, H_gdk_threads_add_timeout_seconds, pl_iit);
  Xg_define_procedure(gtk_adjustment_get_lower, gxg_gtk_adjustment_get_lower_w, 1, 0, 0, H_gtk_adjustment_get_lower, pl_du);
  Xg_define_procedure(gtk_adjustment_set_lower, gxg_gtk_adjustment_set_lower_w, 2, 0, 0, H_gtk_adjustment_set_lower, pl_tur);
  Xg_define_procedure(gtk_adjustment_get_upper, gxg_gtk_adjustment_get_upper_w, 1, 0, 0, H_gtk_adjustment_get_upper, pl_du);
  Xg_define_procedure(gtk_adjustment_set_upper, gxg_gtk_adjustment_set_upper_w, 2, 0, 0, H_gtk_adjustment_set_upper, pl_tur);
  Xg_define_procedure(gtk_adjustment_get_step_increment, gxg_gtk_adjustment_get_step_increment_w, 1, 0, 0, H_gtk_adjustment_get_step_increment, pl_du);
  Xg_define_procedure(gtk_adjustment_set_step_increment, gxg_gtk_adjustment_set_step_increment_w, 2, 0, 0, H_gtk_adjustment_set_step_increment, pl_tur);
  Xg_define_procedure(gtk_adjustment_get_page_increment, gxg_gtk_adjustment_get_page_increment_w, 1, 0, 0, H_gtk_adjustment_get_page_increment, pl_du);
  Xg_define_procedure(gtk_adjustment_set_page_increment, gxg_gtk_adjustment_set_page_increment_w, 2, 0, 0, H_gtk_adjustment_set_page_increment, pl_tur);
  Xg_define_procedure(gtk_adjustment_get_page_size, gxg_gtk_adjustment_get_page_size_w, 1, 0, 0, H_gtk_adjustment_get_page_size, pl_du);
  Xg_define_procedure(gtk_adjustment_set_page_size, gxg_gtk_adjustment_set_page_size_w, 2, 0, 0, H_gtk_adjustment_set_page_size, pl_tur);
  Xg_define_procedure(gtk_adjustment_configure, gxg_gtk_adjustment_configure_w, 7, 0, 0, H_gtk_adjustment_configure, pl_tur);
  Xg_define_procedure(gtk_combo_box_set_button_sensitivity, gxg_gtk_combo_box_set_button_sensitivity_w, 2, 0, 0, H_gtk_combo_box_set_button_sensitivity, pl_tug);
  Xg_define_procedure(gtk_combo_box_get_button_sensitivity, gxg_gtk_combo_box_get_button_sensitivity_w, 1, 0, 0, H_gtk_combo_box_get_button_sensitivity, pl_gu);
  Xg_define_procedure(gtk_file_chooser_get_file, gxg_gtk_file_chooser_get_file_w, 1, 0, 0, H_gtk_file_chooser_get_file, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_file, gxg_gtk_file_chooser_set_file_w, 2, 1, 0, H_gtk_file_chooser_set_file, pl_pu);
  Xg_define_procedure(gtk_file_chooser_select_file, gxg_gtk_file_chooser_select_file_w, 2, 1, 0, H_gtk_file_chooser_select_file, pl_pu);
  Xg_define_procedure(gtk_file_chooser_unselect_file, gxg_gtk_file_chooser_unselect_file_w, 2, 0, 0, H_gtk_file_chooser_unselect_file, pl_tu);
  Xg_define_procedure(gtk_file_chooser_get_files, gxg_gtk_file_chooser_get_files_w, 1, 0, 0, H_gtk_file_chooser_get_files, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_current_folder_file, gxg_gtk_file_chooser_set_current_folder_file_w, 2, 1, 0, H_gtk_file_chooser_set_current_folder_file, pl_pu);
  Xg_define_procedure(gtk_file_chooser_get_current_folder_file, gxg_gtk_file_chooser_get_current_folder_file_w, 1, 0, 0, H_gtk_file_chooser_get_current_folder_file, pl_pu);
  Xg_define_procedure(gtk_file_chooser_get_preview_file, gxg_gtk_file_chooser_get_preview_file_w, 1, 0, 0, H_gtk_file_chooser_get_preview_file, pl_pu);
  Xg_define_procedure(gtk_window_get_default_widget, gxg_gtk_window_get_default_widget_w, 1, 0, 0, H_gtk_window_get_default_widget, pl_pu);
#endif

#if GTK_CHECK_VERSION(2, 16, 0)
  Xg_define_procedure(gtk_link_button_get_visited, gxg_gtk_link_button_get_visited_w, 1, 0, 0, H_gtk_link_button_get_visited, pl_bu);
  Xg_define_procedure(gtk_link_button_set_visited, gxg_gtk_link_button_set_visited_w, 2, 0, 0, H_gtk_link_button_set_visited, pl_tub);
  Xg_define_procedure(gdk_keymap_get_caps_lock_state, gxg_gdk_keymap_get_caps_lock_state_w, 1, 0, 0, H_gdk_keymap_get_caps_lock_state, pl_bu);
  Xg_define_procedure(gtk_cell_view_get_model, gxg_gtk_cell_view_get_model_w, 1, 0, 0, H_gtk_cell_view_get_model, pl_pu);
  Xg_define_procedure(gtk_entry_unset_invisible_char, gxg_gtk_entry_unset_invisible_char_w, 1, 0, 0, H_gtk_entry_unset_invisible_char, pl_tu);
  Xg_define_procedure(gtk_entry_set_progress_fraction, gxg_gtk_entry_set_progress_fraction_w, 2, 0, 0, H_gtk_entry_set_progress_fraction, pl_tur);
  Xg_define_procedure(gtk_entry_get_progress_fraction, gxg_gtk_entry_get_progress_fraction_w, 1, 0, 0, H_gtk_entry_get_progress_fraction, pl_du);
  Xg_define_procedure(gtk_entry_set_progress_pulse_step, gxg_gtk_entry_set_progress_pulse_step_w, 2, 0, 0, H_gtk_entry_set_progress_pulse_step, pl_tur);
  Xg_define_procedure(gtk_entry_get_progress_pulse_step, gxg_gtk_entry_get_progress_pulse_step_w, 1, 0, 0, H_gtk_entry_get_progress_pulse_step, pl_du);
  Xg_define_procedure(gtk_entry_progress_pulse, gxg_gtk_entry_progress_pulse_w, 1, 0, 0, H_gtk_entry_progress_pulse, pl_tu);
  Xg_define_procedure(gtk_entry_get_icon_name, gxg_gtk_entry_get_icon_name_w, 2, 0, 0, H_gtk_entry_get_icon_name, pl_sug);
  Xg_define_procedure(gtk_entry_set_icon_activatable, gxg_gtk_entry_set_icon_activatable_w, 3, 0, 0, H_gtk_entry_set_icon_activatable, pl_tugb);
  Xg_define_procedure(gtk_entry_get_icon_activatable, gxg_gtk_entry_get_icon_activatable_w, 2, 0, 0, H_gtk_entry_get_icon_activatable, pl_bug);
  Xg_define_procedure(gtk_entry_set_icon_sensitive, gxg_gtk_entry_set_icon_sensitive_w, 3, 0, 0, H_gtk_entry_set_icon_sensitive, pl_tugb);
  Xg_define_procedure(gtk_entry_get_icon_sensitive, gxg_gtk_entry_get_icon_sensitive_w, 2, 0, 0, H_gtk_entry_get_icon_sensitive, pl_bug);
  Xg_define_procedure(gtk_entry_get_icon_at_pos, gxg_gtk_entry_get_icon_at_pos_w, 3, 0, 0, H_gtk_entry_get_icon_at_pos, pl_iui);
  Xg_define_procedure(gtk_entry_set_icon_tooltip_text, gxg_gtk_entry_set_icon_tooltip_text_w, 3, 0, 0, H_gtk_entry_set_icon_tooltip_text, pl_tugs);
  Xg_define_procedure(gtk_entry_set_icon_tooltip_markup, gxg_gtk_entry_set_icon_tooltip_markup_w, 3, 0, 0, H_gtk_entry_set_icon_tooltip_markup, pl_tugs);
  Xg_define_procedure(gtk_menu_item_set_label, gxg_gtk_menu_item_set_label_w, 2, 0, 0, H_gtk_menu_item_set_label, pl_tus);
  Xg_define_procedure(gtk_menu_item_get_label, gxg_gtk_menu_item_get_label_w, 1, 0, 0, H_gtk_menu_item_get_label, pl_su);
  Xg_define_procedure(gtk_menu_item_set_use_underline, gxg_gtk_menu_item_set_use_underline_w, 2, 0, 0, H_gtk_menu_item_set_use_underline, pl_tub);
  Xg_define_procedure(gtk_menu_item_get_use_underline, gxg_gtk_menu_item_get_use_underline_w, 1, 0, 0, H_gtk_menu_item_get_use_underline, pl_bu);
  Xg_define_procedure(gtk_entry_get_icon_tooltip_text, gxg_gtk_entry_get_icon_tooltip_text_w, 2, 0, 0, H_gtk_entry_get_icon_tooltip_text, pl_sug);
  Xg_define_procedure(gtk_entry_get_icon_tooltip_markup, gxg_gtk_entry_get_icon_tooltip_markup_w, 2, 0, 0, H_gtk_entry_get_icon_tooltip_markup, pl_sug);
  Xg_define_procedure(gtk_scale_add_mark, gxg_gtk_scale_add_mark_w, 4, 0, 0, H_gtk_scale_add_mark, pl_turgs);
  Xg_define_procedure(gtk_scale_clear_marks, gxg_gtk_scale_clear_marks_w, 1, 0, 0, H_gtk_scale_clear_marks, pl_tu);
#endif

#if GTK_CHECK_VERSION(2, 18, 0)
  Xg_define_procedure(gtk_window_get_default_icon_name, gxg_gtk_window_get_default_icon_name_w, 0, 0, 0, H_gtk_window_get_default_icon_name, pl_s);
  Xg_define_procedure(gtk_label_get_current_uri, gxg_gtk_label_get_current_uri_w, 1, 0, 0, H_gtk_label_get_current_uri, pl_su);
  Xg_define_procedure(gtk_info_bar_new, gxg_gtk_info_bar_new_w, 0, 0, 0, H_gtk_info_bar_new, pl_p);
  Xg_define_procedure(gtk_info_bar_get_action_area, gxg_gtk_info_bar_get_action_area_w, 1, 0, 0, H_gtk_info_bar_get_action_area, pl_pu);
  Xg_define_procedure(gtk_info_bar_get_content_area, gxg_gtk_info_bar_get_content_area_w, 1, 0, 0, H_gtk_info_bar_get_content_area, pl_pu);
  Xg_define_procedure(gtk_info_bar_add_action_widget, gxg_gtk_info_bar_add_action_widget_w, 3, 0, 0, H_gtk_info_bar_add_action_widget, pl_tuui);
  Xg_define_procedure(gtk_info_bar_add_button, gxg_gtk_info_bar_add_button_w, 3, 0, 0, H_gtk_info_bar_add_button, pl_pusi);
  Xg_define_procedure(gtk_info_bar_set_response_sensitive, gxg_gtk_info_bar_set_response_sensitive_w, 3, 0, 0, H_gtk_info_bar_set_response_sensitive, pl_tuib);
  Xg_define_procedure(gtk_info_bar_set_default_response, gxg_gtk_info_bar_set_default_response_w, 2, 0, 0, H_gtk_info_bar_set_default_response, pl_tui);
  Xg_define_procedure(gtk_info_bar_response, gxg_gtk_info_bar_response_w, 2, 0, 0, H_gtk_info_bar_response, pl_tui);
  Xg_define_procedure(gtk_info_bar_set_message_type, gxg_gtk_info_bar_set_message_type_w, 2, 0, 0, H_gtk_info_bar_set_message_type, pl_tug);
  Xg_define_procedure(gtk_info_bar_get_message_type, gxg_gtk_info_bar_get_message_type_w, 1, 0, 0, H_gtk_info_bar_get_message_type, pl_gu);
  Xg_define_procedure(gdk_window_get_root_coords, gxg_gdk_window_get_root_coords_w, 3, 2, 0, H_gdk_window_get_root_coords, pl_puiiu);
  Xg_define_procedure(gtk_menu_set_reserve_toggle_size, gxg_gtk_menu_set_reserve_toggle_size_w, 2, 0, 0, H_gtk_menu_set_reserve_toggle_size, pl_tub);
  Xg_define_procedure(gtk_menu_get_reserve_toggle_size, gxg_gtk_menu_get_reserve_toggle_size_w, 1, 0, 0, H_gtk_menu_get_reserve_toggle_size, pl_bu);
  Xg_define_procedure(gtk_entry_new_with_buffer, gxg_gtk_entry_new_with_buffer_w, 1, 0, 0, H_gtk_entry_new_with_buffer, pl_pu);
  Xg_define_procedure(gtk_entry_get_buffer, gxg_gtk_entry_get_buffer_w, 1, 0, 0, H_gtk_entry_get_buffer, pl_pu);
  Xg_define_procedure(gtk_entry_set_buffer, gxg_gtk_entry_set_buffer_w, 2, 0, 0, H_gtk_entry_set_buffer, pl_tu);
  Xg_define_procedure(gtk_label_set_track_visited_links, gxg_gtk_label_set_track_visited_links_w, 2, 0, 0, H_gtk_label_set_track_visited_links, pl_tub);
  Xg_define_procedure(gtk_label_get_track_visited_links, gxg_gtk_label_get_track_visited_links_w, 1, 0, 0, H_gtk_label_get_track_visited_links, pl_bu);
  Xg_define_procedure(gtk_print_operation_set_embed_page_setup, gxg_gtk_print_operation_set_embed_page_setup_w, 2, 0, 0, H_gtk_print_operation_set_embed_page_setup, pl_tub);
  Xg_define_procedure(gtk_print_operation_get_embed_page_setup, gxg_gtk_print_operation_get_embed_page_setup_w, 1, 0, 0, H_gtk_print_operation_get_embed_page_setup, pl_bu);
  Xg_define_procedure(gtk_entry_buffer_new, gxg_gtk_entry_buffer_new_w, 2, 0, 0, H_gtk_entry_buffer_new, pl_psi);
  Xg_define_procedure(gtk_entry_buffer_get_bytes, gxg_gtk_entry_buffer_get_bytes_w, 1, 0, 0, H_gtk_entry_buffer_get_bytes, pl_iu);
  Xg_define_procedure(gtk_entry_buffer_get_length, gxg_gtk_entry_buffer_get_length_w, 1, 0, 0, H_gtk_entry_buffer_get_length, pl_iu);
  Xg_define_procedure(gtk_entry_buffer_get_text, gxg_gtk_entry_buffer_get_text_w, 1, 0, 0, H_gtk_entry_buffer_get_text, pl_su);
  Xg_define_procedure(gtk_entry_buffer_set_text, gxg_gtk_entry_buffer_set_text_w, 3, 0, 0, H_gtk_entry_buffer_set_text, pl_tusi);
  Xg_define_procedure(gtk_entry_buffer_set_max_length, gxg_gtk_entry_buffer_set_max_length_w, 2, 0, 0, H_gtk_entry_buffer_set_max_length, pl_tui);
  Xg_define_procedure(gtk_entry_buffer_get_max_length, gxg_gtk_entry_buffer_get_max_length_w, 1, 0, 0, H_gtk_entry_buffer_get_max_length, pl_iu);
  Xg_define_procedure(gtk_entry_buffer_insert_text, gxg_gtk_entry_buffer_insert_text_w, 4, 0, 0, H_gtk_entry_buffer_insert_text, pl_iuisi);
  Xg_define_procedure(gtk_entry_buffer_delete_text, gxg_gtk_entry_buffer_delete_text_w, 3, 0, 0, H_gtk_entry_buffer_delete_text, pl_iui);
  Xg_define_procedure(gtk_entry_buffer_emit_inserted_text, gxg_gtk_entry_buffer_emit_inserted_text_w, 4, 0, 0, H_gtk_entry_buffer_emit_inserted_text, pl_tuisi);
  Xg_define_procedure(gtk_entry_buffer_emit_deleted_text, gxg_gtk_entry_buffer_emit_deleted_text_w, 3, 0, 0, H_gtk_entry_buffer_emit_deleted_text, pl_tui);
  Xg_define_procedure(gtk_cell_renderer_set_alignment, gxg_gtk_cell_renderer_set_alignment_w, 3, 0, 0, H_gtk_cell_renderer_set_alignment, pl_tur);
  Xg_define_procedure(gtk_cell_renderer_get_alignment, gxg_gtk_cell_renderer_get_alignment_w, 1, 2, 0, H_gtk_cell_renderer_get_alignment, pl_pu);
  Xg_define_procedure(gtk_cell_renderer_set_padding, gxg_gtk_cell_renderer_set_padding_w, 3, 0, 0, H_gtk_cell_renderer_set_padding, pl_tui);
  Xg_define_procedure(gtk_cell_renderer_get_padding, gxg_gtk_cell_renderer_get_padding_w, 1, 2, 0, H_gtk_cell_renderer_get_padding, pl_pu);
  Xg_define_procedure(gtk_cell_renderer_set_visible, gxg_gtk_cell_renderer_set_visible_w, 2, 0, 0, H_gtk_cell_renderer_set_visible, pl_tub);
  Xg_define_procedure(gtk_cell_renderer_get_visible, gxg_gtk_cell_renderer_get_visible_w, 1, 0, 0, H_gtk_cell_renderer_get_visible, pl_bu);
  Xg_define_procedure(gtk_cell_renderer_set_sensitive, gxg_gtk_cell_renderer_set_sensitive_w, 2, 0, 0, H_gtk_cell_renderer_set_sensitive, pl_tub);
  Xg_define_procedure(gtk_cell_renderer_get_sensitive, gxg_gtk_cell_renderer_get_sensitive_w, 1, 0, 0, H_gtk_cell_renderer_get_sensitive, pl_bu);
  Xg_define_procedure(gtk_cell_renderer_toggle_get_activatable, gxg_gtk_cell_renderer_toggle_get_activatable_w, 1, 0, 0, H_gtk_cell_renderer_toggle_get_activatable, pl_bu);
  Xg_define_procedure(gtk_cell_renderer_toggle_set_activatable, gxg_gtk_cell_renderer_toggle_set_activatable_w, 2, 0, 0, H_gtk_cell_renderer_toggle_set_activatable, pl_tub);
  Xg_define_procedure(gtk_widget_set_can_focus, gxg_gtk_widget_set_can_focus_w, 2, 0, 0, H_gtk_widget_set_can_focus, pl_tub);
  Xg_define_procedure(gtk_widget_get_can_focus, gxg_gtk_widget_get_can_focus_w, 1, 0, 0, H_gtk_widget_get_can_focus, pl_bu);
  Xg_define_procedure(gtk_widget_has_focus, gxg_gtk_widget_has_focus_w, 1, 0, 0, H_gtk_widget_has_focus, pl_bu);
  Xg_define_procedure(gtk_widget_set_can_default, gxg_gtk_widget_set_can_default_w, 2, 0, 0, H_gtk_widget_set_can_default, pl_tub);
  Xg_define_procedure(gtk_widget_get_can_default, gxg_gtk_widget_get_can_default_w, 1, 0, 0, H_gtk_widget_get_can_default, pl_bu);
  Xg_define_procedure(gtk_widget_has_default, gxg_gtk_widget_has_default_w, 1, 0, 0, H_gtk_widget_has_default, pl_bu);
  Xg_define_procedure(gtk_widget_get_sensitive, gxg_gtk_widget_get_sensitive_w, 1, 0, 0, H_gtk_widget_get_sensitive, pl_bu);
  Xg_define_procedure(gtk_widget_is_sensitive, gxg_gtk_widget_is_sensitive_w, 1, 0, 0, H_gtk_widget_is_sensitive, pl_bu);
  Xg_define_procedure(gtk_widget_set_has_window, gxg_gtk_widget_set_has_window_w, 2, 0, 0, H_gtk_widget_set_has_window, pl_tub);
  Xg_define_procedure(gtk_widget_get_has_window, gxg_gtk_widget_get_has_window_w, 1, 0, 0, H_gtk_widget_get_has_window, pl_bu);
  Xg_define_procedure(gdk_window_get_cursor, gxg_gdk_window_get_cursor_w, 1, 0, 0, H_gdk_window_get_cursor, pl_pu);
  Xg_define_procedure(gtk_file_chooser_set_create_folders, gxg_gtk_file_chooser_set_create_folders_w, 2, 0, 0, H_gtk_file_chooser_set_create_folders, pl_tub);
  Xg_define_procedure(gtk_file_chooser_get_create_folders, gxg_gtk_file_chooser_get_create_folders_w, 1, 0, 0, H_gtk_file_chooser_get_create_folders, pl_bu);
  Xg_define_procedure(gtk_icon_view_set_item_padding, gxg_gtk_icon_view_set_item_padding_w, 2, 0, 0, H_gtk_icon_view_set_item_padding, pl_tui);
  Xg_define_procedure(gtk_icon_view_get_item_padding, gxg_gtk_icon_view_get_item_padding_w, 1, 0, 0, H_gtk_icon_view_get_item_padding, pl_iu);
  Xg_define_procedure(gtk_widget_has_grab, gxg_gtk_widget_has_grab_w, 1, 0, 0, H_gtk_widget_has_grab, pl_bu);
  Xg_define_procedure(gtk_widget_set_visible, gxg_gtk_widget_set_visible_w, 2, 0, 0, H_gtk_widget_set_visible, pl_tub);
  Xg_define_procedure(gtk_widget_get_visible, gxg_gtk_widget_get_visible_w, 1, 0, 0, H_gtk_widget_get_visible, pl_bu);
  Xg_define_procedure(gtk_range_set_flippable, gxg_gtk_range_set_flippable_w, 2, 0, 0, H_gtk_range_set_flippable, pl_tub);
  Xg_define_procedure(gtk_range_get_flippable, gxg_gtk_range_get_flippable_w, 1, 0, 0, H_gtk_range_get_flippable, pl_bu);
  Xg_define_procedure(gtk_widget_is_toplevel, gxg_gtk_widget_is_toplevel_w, 1, 0, 0, H_gtk_widget_is_toplevel, pl_bu);
  Xg_define_procedure(gtk_widget_is_drawable, gxg_gtk_widget_is_drawable_w, 1, 0, 0, H_gtk_widget_is_drawable, pl_bu);
  Xg_define_procedure(gtk_widget_set_window, gxg_gtk_widget_set_window_w, 2, 0, 0, H_gtk_widget_set_window, pl_tu);
  Xg_define_procedure(gdk_window_is_destroyed, gxg_gdk_window_is_destroyed_w, 1, 0, 0, H_gdk_window_is_destroyed, pl_bu);
  Xg_define_procedure(gdk_window_restack, gxg_gdk_window_restack_w, 3, 0, 0, H_gdk_window_restack, pl_tuub);
  Xg_define_procedure(gtk_widget_set_receives_default, gxg_gtk_widget_set_receives_default_w, 2, 0, 0, H_gtk_widget_set_receives_default, pl_tub);
  Xg_define_procedure(gtk_widget_get_receives_default, gxg_gtk_widget_get_receives_default_w, 1, 0, 0, H_gtk_widget_get_receives_default, pl_bu);
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
  Xg_define_procedure(gtk_dialog_get_widget_for_response, gxg_gtk_dialog_get_widget_for_response_w, 2, 0, 0, H_gtk_dialog_get_widget_for_response, pl_pui);
  Xg_define_procedure(gtk_spinner_new, gxg_gtk_spinner_new_w, 0, 0, 0, H_gtk_spinner_new, pl_p);
  Xg_define_procedure(gtk_spinner_start, gxg_gtk_spinner_start_w, 1, 0, 0, H_gtk_spinner_start, pl_tu);
  Xg_define_procedure(gtk_spinner_stop, gxg_gtk_spinner_stop_w, 1, 0, 0, H_gtk_spinner_stop, pl_tu);
  Xg_define_procedure(gtk_cell_renderer_spinner_new, gxg_gtk_cell_renderer_spinner_new_w, 0, 0, 0, H_gtk_cell_renderer_spinner_new, pl_p);
  Xg_define_procedure(gtk_notebook_get_action_widget, gxg_gtk_notebook_get_action_widget_w, 2, 0, 0, H_gtk_notebook_get_action_widget, pl_pug);
  Xg_define_procedure(gtk_notebook_set_action_widget, gxg_gtk_notebook_set_action_widget_w, 3, 0, 0, H_gtk_notebook_set_action_widget, pl_tuug);
  Xg_define_procedure(gtk_statusbar_get_message_area, gxg_gtk_statusbar_get_message_area_w, 1, 0, 0, H_gtk_statusbar_get_message_area, pl_pu);
  Xg_define_procedure(gtk_tool_item_get_ellipsize_mode, gxg_gtk_tool_item_get_ellipsize_mode_w, 1, 0, 0, H_gtk_tool_item_get_ellipsize_mode, pl_gu);
  Xg_define_procedure(gtk_tool_item_get_text_alignment, gxg_gtk_tool_item_get_text_alignment_w, 1, 0, 0, H_gtk_tool_item_get_text_alignment, pl_du);
  Xg_define_procedure(gtk_tool_item_get_text_orientation, gxg_gtk_tool_item_get_text_orientation_w, 1, 0, 0, H_gtk_tool_item_get_text_orientation, pl_gu);
  Xg_define_procedure(gtk_tool_item_get_text_size_group, gxg_gtk_tool_item_get_text_size_group_w, 1, 0, 0, H_gtk_tool_item_get_text_size_group, pl_pu);
  Xg_define_procedure(gtk_tool_palette_new, gxg_gtk_tool_palette_new_w, 0, 0, 0, H_gtk_tool_palette_new, pl_p);
  Xg_define_procedure(gtk_tool_palette_set_group_position, gxg_gtk_tool_palette_set_group_position_w, 3, 0, 0, H_gtk_tool_palette_set_group_position, pl_tuui);
  Xg_define_procedure(gtk_tool_palette_set_exclusive, gxg_gtk_tool_palette_set_exclusive_w, 3, 0, 0, H_gtk_tool_palette_set_exclusive, pl_tuub);
  Xg_define_procedure(gtk_tool_palette_set_expand, gxg_gtk_tool_palette_set_expand_w, 3, 0, 0, H_gtk_tool_palette_set_expand, pl_tuub);
  Xg_define_procedure(gtk_tool_palette_get_group_position, gxg_gtk_tool_palette_get_group_position_w, 2, 0, 0, H_gtk_tool_palette_get_group_position, pl_iu);
  Xg_define_procedure(gtk_tool_palette_get_exclusive, gxg_gtk_tool_palette_get_exclusive_w, 2, 0, 0, H_gtk_tool_palette_get_exclusive, pl_bu);
  Xg_define_procedure(gtk_tool_palette_get_expand, gxg_gtk_tool_palette_get_expand_w, 2, 0, 0, H_gtk_tool_palette_get_expand, pl_bu);
  Xg_define_procedure(gtk_tool_palette_set_style, gxg_gtk_tool_palette_set_style_w, 2, 0, 0, H_gtk_tool_palette_set_style, pl_tug);
  Xg_define_procedure(gtk_tool_palette_unset_style, gxg_gtk_tool_palette_unset_style_w, 1, 0, 0, H_gtk_tool_palette_unset_style, pl_tu);
  Xg_define_procedure(gtk_tool_palette_get_style, gxg_gtk_tool_palette_get_style_w, 1, 0, 0, H_gtk_tool_palette_get_style, pl_gu);
  Xg_define_procedure(gtk_tool_palette_get_drop_item, gxg_gtk_tool_palette_get_drop_item_w, 3, 0, 0, H_gtk_tool_palette_get_drop_item, pl_pui);
  Xg_define_procedure(gtk_tool_palette_get_drop_group, gxg_gtk_tool_palette_get_drop_group_w, 3, 0, 0, H_gtk_tool_palette_get_drop_group, pl_pui);
  Xg_define_procedure(gtk_tool_palette_get_drag_item, gxg_gtk_tool_palette_get_drag_item_w, 2, 0, 0, H_gtk_tool_palette_get_drag_item, pl_pu);
  Xg_define_procedure(gtk_tool_palette_set_drag_source, gxg_gtk_tool_palette_set_drag_source_w, 2, 0, 0, H_gtk_tool_palette_set_drag_source, pl_tug);
  Xg_define_procedure(gtk_tool_palette_add_drag_dest, gxg_gtk_tool_palette_add_drag_dest_w, 5, 0, 0, H_gtk_tool_palette_add_drag_dest, pl_tuug);
  Xg_define_procedure(gtk_tool_item_group_new, gxg_gtk_tool_item_group_new_w, 1, 0, 0, H_gtk_tool_item_group_new, pl_ps);
  Xg_define_procedure(gtk_tool_item_group_set_label, gxg_gtk_tool_item_group_set_label_w, 2, 0, 0, H_gtk_tool_item_group_set_label, pl_tus);
  Xg_define_procedure(gtk_tool_item_group_set_label_widget, gxg_gtk_tool_item_group_set_label_widget_w, 2, 0, 0, H_gtk_tool_item_group_set_label_widget, pl_tu);
  Xg_define_procedure(gtk_tool_item_group_set_collapsed, gxg_gtk_tool_item_group_set_collapsed_w, 2, 0, 0, H_gtk_tool_item_group_set_collapsed, pl_tub);
  Xg_define_procedure(gtk_tool_item_group_set_ellipsize, gxg_gtk_tool_item_group_set_ellipsize_w, 2, 0, 0, H_gtk_tool_item_group_set_ellipsize, pl_tug);
  Xg_define_procedure(gtk_tool_item_group_set_header_relief, gxg_gtk_tool_item_group_set_header_relief_w, 2, 0, 0, H_gtk_tool_item_group_set_header_relief, pl_tug);
  Xg_define_procedure(gtk_tool_item_group_get_label, gxg_gtk_tool_item_group_get_label_w, 1, 0, 0, H_gtk_tool_item_group_get_label, pl_su);
  Xg_define_procedure(gtk_tool_item_group_get_label_widget, gxg_gtk_tool_item_group_get_label_widget_w, 1, 0, 0, H_gtk_tool_item_group_get_label_widget, pl_pu);
  Xg_define_procedure(gtk_tool_item_group_get_collapsed, gxg_gtk_tool_item_group_get_collapsed_w, 1, 0, 0, H_gtk_tool_item_group_get_collapsed, pl_bu);
  Xg_define_procedure(gtk_tool_item_group_get_ellipsize, gxg_gtk_tool_item_group_get_ellipsize_w, 1, 0, 0, H_gtk_tool_item_group_get_ellipsize, pl_gu);
  Xg_define_procedure(gtk_tool_item_group_get_header_relief, gxg_gtk_tool_item_group_get_header_relief_w, 1, 0, 0, H_gtk_tool_item_group_get_header_relief, pl_gu);
  Xg_define_procedure(gtk_tool_item_group_insert, gxg_gtk_tool_item_group_insert_w, 3, 0, 0, H_gtk_tool_item_group_insert, pl_tuui);
  Xg_define_procedure(gtk_tool_item_group_set_item_position, gxg_gtk_tool_item_group_set_item_position_w, 3, 0, 0, H_gtk_tool_item_group_set_item_position, pl_tuui);
  Xg_define_procedure(gtk_tool_item_group_get_item_position, gxg_gtk_tool_item_group_get_item_position_w, 2, 0, 0, H_gtk_tool_item_group_get_item_position, pl_iu);
  Xg_define_procedure(gtk_tool_item_group_get_n_items, gxg_gtk_tool_item_group_get_n_items_w, 1, 0, 0, H_gtk_tool_item_group_get_n_items, pl_iu);
  Xg_define_procedure(gtk_tool_item_group_get_nth_item, gxg_gtk_tool_item_group_get_nth_item_w, 2, 0, 0, H_gtk_tool_item_group_get_nth_item, pl_pui);
  Xg_define_procedure(gtk_tool_item_group_get_drop_item, gxg_gtk_tool_item_group_get_drop_item_w, 3, 0, 0, H_gtk_tool_item_group_get_drop_item, pl_pui);
  Xg_define_procedure(gtk_window_set_mnemonics_visible, gxg_gtk_window_set_mnemonics_visible_w, 2, 0, 0, H_gtk_window_set_mnemonics_visible, pl_tub);
  Xg_define_procedure(gtk_window_get_mnemonics_visible, gxg_gtk_window_get_mnemonics_visible_w, 1, 0, 0, H_gtk_window_get_mnemonics_visible, pl_bu);
  Xg_define_procedure(gtk_range_set_slider_size_fixed, gxg_gtk_range_set_slider_size_fixed_w, 2, 0, 0, H_gtk_range_set_slider_size_fixed, pl_tub);
  Xg_define_procedure(gtk_range_get_slider_size_fixed, gxg_gtk_range_get_slider_size_fixed_w, 1, 0, 0, H_gtk_range_get_slider_size_fixed, pl_bu);
  Xg_define_procedure(gtk_range_get_range_rect, gxg_gtk_range_get_range_rect_w, 2, 0, 0, H_gtk_range_get_range_rect, pl_tu);
  Xg_define_procedure(gtk_range_get_slider_range, gxg_gtk_range_get_slider_range_w, 1, 2, 0, H_gtk_range_get_slider_range, pl_pu);
  Xg_define_procedure(gtk_widget_set_realized, gxg_gtk_widget_set_realized_w, 2, 0, 0, H_gtk_widget_set_realized, pl_tub);
  Xg_define_procedure(gtk_widget_get_realized, gxg_gtk_widget_get_realized_w, 1, 0, 0, H_gtk_widget_get_realized, pl_bu);
  Xg_define_procedure(gtk_widget_get_mapped, gxg_gtk_widget_get_mapped_w, 1, 0, 0, H_gtk_widget_get_mapped, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  Xg_define_procedure(gdk_window_get_geometry, gxg_gdk_window_get_geometry_w, 1, 4, 0, H_gdk_window_get_geometry, pl_pu);
  Xg_define_procedure(gdk_keymap_add_virtual_modifiers, gxg_gdk_keymap_add_virtual_modifiers_w, 2, 0, 0, H_gdk_keymap_add_virtual_modifiers, pl_tu);
  Xg_define_procedure(gdk_window_coords_to_parent, gxg_gdk_window_coords_to_parent_w, 3, 2, 0, H_gdk_window_coords_to_parent, pl_purru);
  Xg_define_procedure(gdk_window_coords_from_parent, gxg_gdk_window_coords_from_parent_w, 3, 2, 0, H_gdk_window_coords_from_parent, pl_purru);
  Xg_define_procedure(gtk_accessible_get_widget, gxg_gtk_accessible_get_widget_w, 1, 0, 0, H_gtk_accessible_get_widget, pl_pu);
  Xg_define_procedure(gtk_widget_send_focus_change, gxg_gtk_widget_send_focus_change_w, 2, 0, 0, H_gtk_widget_send_focus_change, pl_bu);
  Xg_define_procedure(gdk_drag_context_get_device, gxg_gdk_drag_context_get_device_w, 1, 0, 0, H_gdk_drag_context_get_device, pl_pu);
  Xg_define_procedure(gdk_event_set_device, gxg_gdk_event_set_device_w, 2, 0, 0, H_gdk_event_set_device, pl_tu);
  Xg_define_procedure(gdk_event_get_device, gxg_gdk_event_get_device_w, 1, 0, 0, H_gdk_event_get_device, pl_pu);
  Xg_define_procedure(gdk_events_get_distance, gxg_gdk_events_get_distance_w, 2, 1, 0, H_gdk_events_get_distance, pl_pu);
  Xg_define_procedure(gdk_events_get_angle, gxg_gdk_events_get_angle_w, 2, 1, 0, H_gdk_events_get_angle, pl_pu);
  Xg_define_procedure(gdk_events_get_center, gxg_gdk_events_get_center_w, 2, 2, 0, H_gdk_events_get_center, pl_pu);
  Xg_define_procedure(gdk_window_get_accept_focus, gxg_gdk_window_get_accept_focus_w, 1, 0, 0, H_gdk_window_get_accept_focus, pl_bu);
  Xg_define_procedure(gdk_window_get_focus_on_map, gxg_gdk_window_get_focus_on_map_w, 1, 0, 0, H_gdk_window_get_focus_on_map, pl_bu);
  Xg_define_procedure(gdk_window_is_input_only, gxg_gdk_window_is_input_only_w, 1, 0, 0, H_gdk_window_is_input_only, pl_bu);
  Xg_define_procedure(gdk_window_is_shaped, gxg_gdk_window_is_shaped_w, 1, 0, 0, H_gdk_window_is_shaped, pl_bu);
  Xg_define_procedure(gdk_window_get_modal_hint, gxg_gdk_window_get_modal_hint_w, 1, 0, 0, H_gdk_window_get_modal_hint, pl_bu);
  Xg_define_procedure(gdk_window_set_device_cursor, gxg_gdk_window_set_device_cursor_w, 3, 0, 0, H_gdk_window_set_device_cursor, pl_tu);
  Xg_define_procedure(gdk_window_get_device_cursor, gxg_gdk_window_get_device_cursor_w, 2, 0, 0, H_gdk_window_get_device_cursor, pl_pu);
  Xg_define_procedure(gdk_window_get_device_position, gxg_gdk_window_get_device_position_w, 2, 3, 0, H_gdk_window_get_device_position, pl_pu);
  Xg_define_procedure(gdk_window_set_device_events, gxg_gdk_window_set_device_events_w, 3, 0, 0, H_gdk_window_set_device_events, pl_tuug);
  Xg_define_procedure(gdk_window_get_device_events, gxg_gdk_window_get_device_events_w, 2, 0, 0, H_gdk_window_get_device_events, pl_gu);
  Xg_define_procedure(gtk_combo_box_popup_for_device, gxg_gtk_combo_box_popup_for_device_w, 2, 0, 0, H_gtk_combo_box_popup_for_device, pl_tu);
  Xg_define_procedure(gtk_device_grab_add, gxg_gtk_device_grab_add_w, 3, 0, 0, H_gtk_device_grab_add, pl_tuub);
  Xg_define_procedure(gtk_device_grab_remove, gxg_gtk_device_grab_remove_w, 2, 0, 0, H_gtk_device_grab_remove, pl_tu);
  Xg_define_procedure(gtk_get_current_event_device, gxg_gtk_get_current_event_device_w, 0, 0, 0, H_gtk_get_current_event_device, pl_p);
  Xg_define_procedure(gtk_paned_new, gxg_gtk_paned_new_w, 1, 0, 0, H_gtk_paned_new, pl_pg);
  Xg_define_procedure(gtk_scale_new, gxg_gtk_scale_new_w, 2, 0, 0, H_gtk_scale_new, pl_pgu);
  Xg_define_procedure(gtk_scale_new_with_range, gxg_gtk_scale_new_with_range_w, 4, 0, 0, H_gtk_scale_new_with_range, pl_pgr);
  Xg_define_procedure(gtk_scrollbar_new, gxg_gtk_scrollbar_new_w, 2, 0, 0, H_gtk_scrollbar_new, pl_pgu);
  Xg_define_procedure(gtk_separator_new, gxg_gtk_separator_new_w, 1, 0, 0, H_gtk_separator_new, pl_pg);
  Xg_define_procedure(gtk_widget_device_is_shadowed, gxg_gtk_widget_device_is_shadowed_w, 2, 0, 0, H_gtk_widget_device_is_shadowed, pl_bu);
  Xg_define_procedure(gtk_widget_get_support_multidevice, gxg_gtk_widget_get_support_multidevice_w, 1, 0, 0, H_gtk_widget_get_support_multidevice, pl_bu);
  Xg_define_procedure(gtk_widget_set_support_multidevice, gxg_gtk_widget_set_support_multidevice_w, 2, 0, 0, H_gtk_widget_set_support_multidevice, pl_tub);
  Xg_define_procedure(gtk_icon_view_get_item_row, gxg_gtk_icon_view_get_item_row_w, 2, 0, 0, H_gtk_icon_view_get_item_row, pl_iu);
  Xg_define_procedure(gtk_icon_view_get_item_column, gxg_gtk_icon_view_get_item_column_w, 2, 0, 0, H_gtk_icon_view_get_item_column, pl_iu);
  Xg_define_procedure(gtk_statusbar_remove_all, gxg_gtk_statusbar_remove_all_w, 2, 0, 0, H_gtk_statusbar_remove_all, pl_tui);
  Xg_define_procedure(gtk_window_has_group, gxg_gtk_window_has_group_w, 1, 0, 0, H_gtk_window_has_group, pl_bu);
  Xg_define_procedure(gtk_calendar_select_month, gxg_gtk_calendar_select_month_w, 3, 0, 0, H_gtk_calendar_select_month, pl_tui);
  Xg_define_procedure(gtk_calendar_mark_day, gxg_gtk_calendar_mark_day_w, 2, 0, 0, H_gtk_calendar_mark_day, pl_tui);
  Xg_define_procedure(gtk_calendar_unmark_day, gxg_gtk_calendar_unmark_day_w, 2, 0, 0, H_gtk_calendar_unmark_day, pl_tui);
  Xg_define_procedure(gdk_drag_context_get_source_window, gxg_gdk_drag_context_get_source_window_w, 1, 0, 0, H_gdk_drag_context_get_source_window, pl_pu);
  Xg_define_procedure(gtk_accessible_set_widget, gxg_gtk_accessible_set_widget_w, 2, 0, 0, H_gtk_accessible_set_widget, pl_tu);
  Xg_define_procedure(gtk_message_dialog_get_message_area, gxg_gtk_message_dialog_get_message_area_w, 1, 0, 0, H_gtk_message_dialog_get_message_area, pl_pu);
  Xg_define_procedure(gtk_selection_data_get_length, gxg_gtk_selection_data_get_length_w, 1, 0, 0, H_gtk_selection_data_get_length, pl_iu);
  Xg_define_procedure(gdk_pango_layout_line_get_clip_region, gxg_gdk_pango_layout_line_get_clip_region_w, 5, 0, 0, H_gdk_pango_layout_line_get_clip_region, pl_puiiui);
  Xg_define_procedure(gdk_pango_layout_get_clip_region, gxg_gdk_pango_layout_get_clip_region_w, 5, 0, 0, H_gdk_pango_layout_get_clip_region, pl_puiiui);
  Xg_define_procedure(gdk_window_shape_combine_region, gxg_gdk_window_shape_combine_region_w, 4, 0, 0, H_gdk_window_shape_combine_region, pl_tuui);
  Xg_define_procedure(gdk_window_invalidate_region, gxg_gdk_window_invalidate_region_w, 3, 0, 0, H_gdk_window_invalidate_region, pl_tuub);
  Xg_define_procedure(gdk_window_get_update_area, gxg_gdk_window_get_update_area_w, 1, 0, 0, H_gdk_window_get_update_area, pl_pu);
  Xg_define_procedure(gdk_window_move_region, gxg_gdk_window_move_region_w, 4, 0, 0, H_gdk_window_move_region, pl_tuui);
  Xg_define_procedure(gdk_keymap_get_num_lock_state, gxg_gdk_keymap_get_num_lock_state_w, 1, 0, 0, H_gdk_keymap_get_num_lock_state, pl_bu);
  Xg_define_procedure(gdk_window_has_native, gxg_gdk_window_has_native_w, 1, 0, 0, H_gdk_window_has_native, pl_bu);
  Xg_define_procedure(gdk_display_is_closed, gxg_gdk_display_is_closed_w, 1, 0, 0, H_gdk_display_is_closed, pl_bu);
  Xg_define_procedure(gdk_window_create_similar_surface, gxg_gdk_window_create_similar_surface_w, 4, 0, 0, H_gdk_window_create_similar_surface, pl_pugi);
  Xg_define_procedure(gtk_expander_set_label_fill, gxg_gtk_expander_set_label_fill_w, 2, 0, 0, H_gtk_expander_set_label_fill, pl_tub);
  Xg_define_procedure(gtk_expander_get_label_fill, gxg_gtk_expander_get_label_fill_w, 1, 0, 0, H_gtk_expander_get_label_fill, pl_bu);
  Xg_define_procedure(gtk_calendar_get_day_is_marked, gxg_gtk_calendar_get_day_is_marked_w, 2, 0, 0, H_gtk_calendar_get_day_is_marked, pl_bui);
  Xg_define_procedure(gtk_progress_bar_set_inverted, gxg_gtk_progress_bar_set_inverted_w, 2, 0, 0, H_gtk_progress_bar_set_inverted, pl_tub);
  Xg_define_procedure(gtk_progress_bar_get_inverted, gxg_gtk_progress_bar_get_inverted_w, 1, 0, 0, H_gtk_progress_bar_get_inverted, pl_bu);
  Xg_define_procedure(gtk_radio_button_join_group, gxg_gtk_radio_button_join_group_w, 2, 0, 0, H_gtk_radio_button_join_group, pl_tu);
  Xg_define_procedure(gtk_adjustment_new, gxg_gtk_adjustment_new_w, 6, 0, 0, H_gtk_adjustment_new, pl_pr);
  Xg_define_procedure(gtk_binding_set_activate, gxg_gtk_binding_set_activate_w, 4, 0, 0, H_gtk_binding_set_activate, pl_buigu);
  Xg_define_procedure(gtk_bindings_activate, gxg_gtk_bindings_activate_w, 3, 0, 0, H_gtk_bindings_activate, pl_buig);
  Xg_define_procedure(gtk_icon_view_create_drag_icon, gxg_gtk_icon_view_create_drag_icon_w, 2, 0, 0, H_gtk_icon_view_create_drag_icon, pl_pu);
  Xg_define_procedure(gtk_tree_view_create_row_drag_icon, gxg_gtk_tree_view_create_row_drag_icon_w, 2, 0, 0, H_gtk_tree_view_create_row_drag_icon, pl_pu);
  Xg_define_procedure(gdk_cairo_get_clip_rectangle, gxg_gdk_cairo_get_clip_rectangle_w, 2, 0, 0, H_gdk_cairo_get_clip_rectangle, pl_bu);
  Xg_define_procedure(gdk_cairo_region_create_from_surface, gxg_gdk_cairo_region_create_from_surface_w, 1, 0, 0, H_gdk_cairo_region_create_from_surface, pl_pu);
  Xg_define_procedure(gdk_window_get_display, gxg_gdk_window_get_display_w, 1, 0, 0, H_gdk_window_get_display, pl_pu);
  Xg_define_procedure(gdk_window_get_width, gxg_gdk_window_get_width_w, 1, 0, 0, H_gdk_window_get_width, pl_iu);
  Xg_define_procedure(gdk_window_get_height, gxg_gdk_window_get_height_w, 1, 0, 0, H_gdk_window_get_height, pl_iu);
  Xg_define_procedure(gtk_cell_renderer_get_request_mode, gxg_gtk_cell_renderer_get_request_mode_w, 1, 0, 0, H_gtk_cell_renderer_get_request_mode, pl_gu);
  Xg_define_procedure(gtk_cell_renderer_get_preferred_width, gxg_gtk_cell_renderer_get_preferred_width_w, 2, 2, 0, H_gtk_cell_renderer_get_preferred_width, pl_pu);
  Xg_define_procedure(gtk_cell_renderer_get_preferred_height_for_width, gxg_gtk_cell_renderer_get_preferred_height_for_width_w, 3, 2, 0, H_gtk_cell_renderer_get_preferred_height_for_width, pl_puuiu);
  Xg_define_procedure(gtk_cell_renderer_get_preferred_height, gxg_gtk_cell_renderer_get_preferred_height_w, 2, 2, 0, H_gtk_cell_renderer_get_preferred_height, pl_pu);
  Xg_define_procedure(gtk_cell_renderer_get_preferred_width_for_height, gxg_gtk_cell_renderer_get_preferred_width_for_height_w, 3, 2, 0, H_gtk_cell_renderer_get_preferred_width_for_height, pl_puuiu);
  Xg_define_procedure(gtk_drag_set_icon_surface, gxg_gtk_drag_set_icon_surface_w, 2, 0, 0, H_gtk_drag_set_icon_surface, pl_tu);
  Xg_define_procedure(gtk_notebook_set_group_name, gxg_gtk_notebook_set_group_name_w, 2, 0, 0, H_gtk_notebook_set_group_name, pl_tus);
  Xg_define_procedure(gtk_notebook_get_group_name, gxg_gtk_notebook_get_group_name_w, 1, 0, 0, H_gtk_notebook_get_group_name, pl_su);
  Xg_define_procedure(gtk_widget_draw, gxg_gtk_widget_draw_w, 2, 0, 0, H_gtk_widget_draw, pl_tu);
  Xg_define_procedure(gtk_widget_get_request_mode, gxg_gtk_widget_get_request_mode_w, 1, 0, 0, H_gtk_widget_get_request_mode, pl_gu);
  Xg_define_procedure(gtk_widget_get_allocated_width, gxg_gtk_widget_get_allocated_width_w, 1, 0, 0, H_gtk_widget_get_allocated_width, pl_iu);
  Xg_define_procedure(gtk_widget_get_allocated_height, gxg_gtk_widget_get_allocated_height_w, 1, 0, 0, H_gtk_widget_get_allocated_height, pl_iu);
  Xg_define_procedure(gtk_widget_get_halign, gxg_gtk_widget_get_halign_w, 1, 0, 0, H_gtk_widget_get_halign, pl_gu);
  Xg_define_procedure(gtk_widget_set_halign, gxg_gtk_widget_set_halign_w, 2, 0, 0, H_gtk_widget_set_halign, pl_tug);
  Xg_define_procedure(gtk_widget_get_valign, gxg_gtk_widget_get_valign_w, 1, 0, 0, H_gtk_widget_get_valign, pl_gu);
  Xg_define_procedure(gtk_widget_set_valign, gxg_gtk_widget_set_valign_w, 2, 0, 0, H_gtk_widget_set_valign, pl_tug);
  Xg_define_procedure(gtk_widget_get_margin_top, gxg_gtk_widget_get_margin_top_w, 1, 0, 0, H_gtk_widget_get_margin_top, pl_iu);
  Xg_define_procedure(gtk_widget_set_margin_top, gxg_gtk_widget_set_margin_top_w, 2, 0, 0, H_gtk_widget_set_margin_top, pl_tui);
  Xg_define_procedure(gtk_widget_get_margin_bottom, gxg_gtk_widget_get_margin_bottom_w, 1, 0, 0, H_gtk_widget_get_margin_bottom, pl_iu);
  Xg_define_procedure(gtk_widget_set_margin_bottom, gxg_gtk_widget_set_margin_bottom_w, 2, 0, 0, H_gtk_widget_set_margin_bottom, pl_tui);
  Xg_define_procedure(gtk_widget_shape_combine_region, gxg_gtk_widget_shape_combine_region_w, 2, 0, 0, H_gtk_widget_shape_combine_region, pl_tu);
  Xg_define_procedure(gtk_widget_input_shape_combine_region, gxg_gtk_widget_input_shape_combine_region_w, 2, 0, 0, H_gtk_widget_input_shape_combine_region, pl_tu);
  Xg_define_procedure(gtk_combo_box_new_with_entry, gxg_gtk_combo_box_new_with_entry_w, 0, 0, 0, H_gtk_combo_box_new_with_entry, pl_p);
  Xg_define_procedure(gtk_combo_box_get_has_entry, gxg_gtk_combo_box_get_has_entry_w, 1, 0, 0, H_gtk_combo_box_get_has_entry, pl_bu);
  Xg_define_procedure(gtk_combo_box_set_entry_text_column, gxg_gtk_combo_box_set_entry_text_column_w, 2, 0, 0, H_gtk_combo_box_set_entry_text_column, pl_tui);
  Xg_define_procedure(gtk_combo_box_get_entry_text_column, gxg_gtk_combo_box_get_entry_text_column_w, 1, 0, 0, H_gtk_combo_box_get_entry_text_column, pl_iu);
  Xg_define_procedure(gtk_widget_get_hexpand, gxg_gtk_widget_get_hexpand_w, 1, 0, 0, H_gtk_widget_get_hexpand, pl_bu);
  Xg_define_procedure(gtk_widget_set_hexpand, gxg_gtk_widget_set_hexpand_w, 2, 0, 0, H_gtk_widget_set_hexpand, pl_tub);
  Xg_define_procedure(gtk_widget_get_hexpand_set, gxg_gtk_widget_get_hexpand_set_w, 1, 0, 0, H_gtk_widget_get_hexpand_set, pl_bu);
  Xg_define_procedure(gtk_widget_set_hexpand_set, gxg_gtk_widget_set_hexpand_set_w, 2, 0, 0, H_gtk_widget_set_hexpand_set, pl_tub);
  Xg_define_procedure(gtk_widget_get_vexpand, gxg_gtk_widget_get_vexpand_w, 1, 0, 0, H_gtk_widget_get_vexpand, pl_bu);
  Xg_define_procedure(gtk_widget_set_vexpand, gxg_gtk_widget_set_vexpand_w, 2, 0, 0, H_gtk_widget_set_vexpand, pl_tub);
  Xg_define_procedure(gtk_widget_get_vexpand_set, gxg_gtk_widget_get_vexpand_set_w, 1, 0, 0, H_gtk_widget_get_vexpand_set, pl_bu);
  Xg_define_procedure(gtk_widget_set_vexpand_set, gxg_gtk_widget_set_vexpand_set_w, 2, 0, 0, H_gtk_widget_set_vexpand_set, pl_tub);
  Xg_define_procedure(gtk_widget_queue_compute_expand, gxg_gtk_widget_queue_compute_expand_w, 1, 0, 0, H_gtk_widget_queue_compute_expand, pl_tu);
  Xg_define_procedure(gtk_widget_compute_expand, gxg_gtk_widget_compute_expand_w, 2, 0, 0, H_gtk_widget_compute_expand, pl_bug);
  Xg_define_procedure(gtk_combo_box_text_new, gxg_gtk_combo_box_text_new_w, 0, 0, 0, H_gtk_combo_box_text_new, pl_p);
  Xg_define_procedure(gtk_combo_box_text_new_with_entry, gxg_gtk_combo_box_text_new_with_entry_w, 0, 0, 0, H_gtk_combo_box_text_new_with_entry, pl_p);
  Xg_define_procedure(gtk_combo_box_text_append_text, gxg_gtk_combo_box_text_append_text_w, 2, 0, 0, H_gtk_combo_box_text_append_text, pl_tus);
  Xg_define_procedure(gtk_combo_box_text_insert_text, gxg_gtk_combo_box_text_insert_text_w, 3, 0, 0, H_gtk_combo_box_text_insert_text, pl_tuis);
  Xg_define_procedure(gtk_combo_box_text_prepend_text, gxg_gtk_combo_box_text_prepend_text_w, 2, 0, 0, H_gtk_combo_box_text_prepend_text, pl_tus);
  Xg_define_procedure(gtk_combo_box_text_remove, gxg_gtk_combo_box_text_remove_w, 2, 0, 0, H_gtk_combo_box_text_remove, pl_tui);
  Xg_define_procedure(gtk_combo_box_text_get_active_text, gxg_gtk_combo_box_text_get_active_text_w, 1, 0, 0, H_gtk_combo_box_text_get_active_text, pl_su);
  Xg_define_procedure(gdk_cairo_set_source_rgba, gxg_gdk_cairo_set_source_rgba_w, 2, 0, 0, H_gdk_cairo_set_source_rgba, pl_tu);
  Xg_define_procedure(gtk_combo_box_text_remove_all, gxg_gtk_combo_box_text_remove_all_w, 1, 0, 0, H_gtk_combo_box_text_remove_all, pl_tu);
  Xg_define_procedure(gtk_combo_box_set_popup_fixed_width, gxg_gtk_combo_box_set_popup_fixed_width_w, 2, 0, 0, H_gtk_combo_box_set_popup_fixed_width, pl_tub);
  Xg_define_procedure(gtk_combo_box_get_popup_fixed_width, gxg_gtk_combo_box_get_popup_fixed_width_w, 1, 0, 0, H_gtk_combo_box_get_popup_fixed_width, pl_bu);
  Xg_define_procedure(gtk_scrolled_window_get_min_content_width, gxg_gtk_scrolled_window_get_min_content_width_w, 1, 0, 0, H_gtk_scrolled_window_get_min_content_width, pl_iu);
  Xg_define_procedure(gtk_scrolled_window_set_min_content_width, gxg_gtk_scrolled_window_set_min_content_width_w, 2, 0, 0, H_gtk_scrolled_window_set_min_content_width, pl_tui);
  Xg_define_procedure(gtk_scrolled_window_get_min_content_height, gxg_gtk_scrolled_window_get_min_content_height_w, 1, 0, 0, H_gtk_scrolled_window_get_min_content_height, pl_iu);
  Xg_define_procedure(gtk_scrolled_window_set_min_content_height, gxg_gtk_scrolled_window_set_min_content_height_w, 2, 0, 0, H_gtk_scrolled_window_set_min_content_height, pl_tui);
  Xg_define_procedure(gtk_grid_new, gxg_gtk_grid_new_w, 0, 0, 0, H_gtk_grid_new, pl_p);
  Xg_define_procedure(gtk_grid_attach, gxg_gtk_grid_attach_w, 6, 0, 0, H_gtk_grid_attach, pl_tuui);
  Xg_define_procedure(gtk_grid_attach_next_to, gxg_gtk_grid_attach_next_to_w, 6, 0, 0, H_gtk_grid_attach_next_to, pl_tuuugi);
  Xg_define_procedure(gtk_grid_set_row_homogeneous, gxg_gtk_grid_set_row_homogeneous_w, 2, 0, 0, H_gtk_grid_set_row_homogeneous, pl_tub);
  Xg_define_procedure(gtk_grid_get_row_homogeneous, gxg_gtk_grid_get_row_homogeneous_w, 1, 0, 0, H_gtk_grid_get_row_homogeneous, pl_bu);
  Xg_define_procedure(gtk_grid_set_row_spacing, gxg_gtk_grid_set_row_spacing_w, 2, 0, 0, H_gtk_grid_set_row_spacing, pl_tui);
  Xg_define_procedure(gtk_grid_get_row_spacing, gxg_gtk_grid_get_row_spacing_w, 1, 0, 0, H_gtk_grid_get_row_spacing, pl_iu);
  Xg_define_procedure(gtk_grid_set_column_homogeneous, gxg_gtk_grid_set_column_homogeneous_w, 2, 0, 0, H_gtk_grid_set_column_homogeneous, pl_tub);
  Xg_define_procedure(gtk_grid_get_column_homogeneous, gxg_gtk_grid_get_column_homogeneous_w, 1, 0, 0, H_gtk_grid_get_column_homogeneous, pl_bu);
  Xg_define_procedure(gtk_grid_set_column_spacing, gxg_gtk_grid_set_column_spacing_w, 2, 0, 0, H_gtk_grid_set_column_spacing, pl_tui);
  Xg_define_procedure(gtk_grid_get_column_spacing, gxg_gtk_grid_get_column_spacing_w, 1, 0, 0, H_gtk_grid_get_column_spacing, pl_iu);
  Xg_define_procedure(gtk_scrollable_get_hadjustment, gxg_gtk_scrollable_get_hadjustment_w, 1, 0, 0, H_gtk_scrollable_get_hadjustment, pl_pu);
  Xg_define_procedure(gtk_scrollable_set_hadjustment, gxg_gtk_scrollable_set_hadjustment_w, 2, 0, 0, H_gtk_scrollable_set_hadjustment, pl_tu);
  Xg_define_procedure(gtk_scrollable_get_vadjustment, gxg_gtk_scrollable_get_vadjustment_w, 1, 0, 0, H_gtk_scrollable_get_vadjustment, pl_pu);
  Xg_define_procedure(gtk_scrollable_set_vadjustment, gxg_gtk_scrollable_set_vadjustment_w, 2, 0, 0, H_gtk_scrollable_set_vadjustment, pl_tu);
  Xg_define_procedure(gtk_assistant_next_page, gxg_gtk_assistant_next_page_w, 1, 0, 0, H_gtk_assistant_next_page, pl_tu);
  Xg_define_procedure(gtk_assistant_previous_page, gxg_gtk_assistant_previous_page_w, 1, 0, 0, H_gtk_assistant_previous_page, pl_tu);
  Xg_define_procedure(gtk_combo_box_new_with_model_and_entry, gxg_gtk_combo_box_new_with_model_and_entry_w, 1, 0, 0, H_gtk_combo_box_new_with_model_and_entry, pl_pu);
  Xg_define_procedure(gtk_scrollable_get_hscroll_policy, gxg_gtk_scrollable_get_hscroll_policy_w, 1, 0, 0, H_gtk_scrollable_get_hscroll_policy, pl_gu);
  Xg_define_procedure(gtk_scrollable_set_hscroll_policy, gxg_gtk_scrollable_set_hscroll_policy_w, 2, 0, 0, H_gtk_scrollable_set_hscroll_policy, pl_tug);
  Xg_define_procedure(gtk_scrollable_get_vscroll_policy, gxg_gtk_scrollable_get_vscroll_policy_w, 1, 0, 0, H_gtk_scrollable_get_vscroll_policy, pl_gu);
  Xg_define_procedure(gtk_scrollable_set_vscroll_policy, gxg_gtk_scrollable_set_vscroll_policy_w, 2, 0, 0, H_gtk_scrollable_set_vscroll_policy, pl_tug);
  Xg_define_procedure(gtk_switch_new, gxg_gtk_switch_new_w, 0, 0, 0, H_gtk_switch_new, pl_p);
  Xg_define_procedure(gtk_switch_set_active, gxg_gtk_switch_set_active_w, 2, 0, 0, H_gtk_switch_set_active, pl_tub);
  Xg_define_procedure(gtk_switch_get_active, gxg_gtk_switch_get_active_w, 1, 0, 0, H_gtk_switch_get_active, pl_bu);
  Xg_define_procedure(gdk_window_get_clip_region, gxg_gdk_window_get_clip_region_w, 1, 0, 0, H_gdk_window_get_clip_region, pl_pu);
  Xg_define_procedure(gdk_window_get_visible_region, gxg_gdk_window_get_visible_region_w, 1, 0, 0, H_gdk_window_get_visible_region, pl_pu);
  Xg_define_procedure(gtk_border_new, gxg_gtk_border_new_w, 0, 0, 0, H_gtk_border_new, pl_p);
  Xg_define_procedure(gtk_border_copy, gxg_gtk_border_copy_w, 1, 0, 0, H_gtk_border_copy, pl_pu);
  Xg_define_procedure(gtk_border_free, gxg_gtk_border_free_w, 1, 0, 0, H_gtk_border_free, pl_tu);
  Xg_define_procedure(gtk_combo_box_get_id_column, gxg_gtk_combo_box_get_id_column_w, 1, 0, 0, H_gtk_combo_box_get_id_column, pl_iu);
  Xg_define_procedure(gtk_combo_box_set_id_column, gxg_gtk_combo_box_set_id_column_w, 2, 0, 0, H_gtk_combo_box_set_id_column, pl_tui);
  Xg_define_procedure(gtk_combo_box_get_active_id, gxg_gtk_combo_box_get_active_id_w, 1, 0, 0, H_gtk_combo_box_get_active_id, pl_su);
  Xg_define_procedure(gtk_combo_box_text_insert, gxg_gtk_combo_box_text_insert_w, 4, 0, 0, H_gtk_combo_box_text_insert, pl_tuis);
  Xg_define_procedure(gtk_combo_box_text_append, gxg_gtk_combo_box_text_append_w, 3, 0, 0, H_gtk_combo_box_text_append, pl_tus);
  Xg_define_procedure(gtk_combo_box_text_prepend, gxg_gtk_combo_box_text_prepend_w, 3, 0, 0, H_gtk_combo_box_text_prepend, pl_tus);
  Xg_define_procedure(gtk_button_box_new, gxg_gtk_button_box_new_w, 1, 0, 0, H_gtk_button_box_new, pl_pg);
  Xg_define_procedure(gtk_box_new, gxg_gtk_box_new_w, 2, 0, 0, H_gtk_box_new, pl_pgi);
  Xg_define_procedure(gtk_tree_view_set_cursor_on_cell, gxg_gtk_tree_view_set_cursor_on_cell_w, 5, 0, 0, H_gtk_tree_view_set_cursor_on_cell, pl_tuuuub);
  Xg_define_procedure(gtk_tree_view_set_rubber_banding, gxg_gtk_tree_view_set_rubber_banding_w, 2, 0, 0, H_gtk_tree_view_set_rubber_banding, pl_tub);
  Xg_define_procedure(gtk_tree_view_get_rubber_banding, gxg_gtk_tree_view_get_rubber_banding_w, 1, 0, 0, H_gtk_tree_view_get_rubber_banding, pl_bu);
  Xg_define_procedure(gtk_tooltip_set_markup, gxg_gtk_tooltip_set_markup_w, 2, 0, 0, H_gtk_tooltip_set_markup, pl_tus);
  Xg_define_procedure(gtk_tooltip_set_custom, gxg_gtk_tooltip_set_custom_w, 2, 0, 0, H_gtk_tooltip_set_custom, pl_tu);
  Xg_define_procedure(gtk_tooltip_trigger_tooltip_query, gxg_gtk_tooltip_trigger_tooltip_query_w, 1, 0, 0, H_gtk_tooltip_trigger_tooltip_query, pl_tu);
  Xg_define_procedure(gtk_tree_view_column_new_with_area, gxg_gtk_tree_view_column_new_with_area_w, 1, 0, 0, H_gtk_tree_view_column_new_with_area, pl_pu);
  Xg_define_procedure(gtk_tree_view_column_get_button, gxg_gtk_tree_view_column_get_button_w, 1, 0, 0, H_gtk_tree_view_column_get_button, pl_pu);
  Xg_define_procedure(gtk_tree_view_column_focus_cell, gxg_gtk_tree_view_column_focus_cell_w, 2, 0, 0, H_gtk_tree_view_column_focus_cell, pl_tu);
  Xg_define_procedure(gtk_toolbar_set_drop_highlight_item, gxg_gtk_toolbar_set_drop_highlight_item_w, 3, 0, 0, H_gtk_toolbar_set_drop_highlight_item, pl_tuui);
  Xg_define_procedure(gtk_tool_item_toolbar_reconfigured, gxg_gtk_tool_item_toolbar_reconfigured_w, 1, 0, 0, H_gtk_tool_item_toolbar_reconfigured, pl_tu);
  Xg_define_procedure(gtk_orientable_set_orientation, gxg_gtk_orientable_set_orientation_w, 2, 0, 0, H_gtk_orientable_set_orientation, pl_tug);
  Xg_define_procedure(gtk_orientable_get_orientation, gxg_gtk_orientable_get_orientation_w, 1, 0, 0, H_gtk_orientable_get_orientation, pl_gu);
  Xg_define_procedure(gtk_get_major_version, gxg_gtk_get_major_version_w, 0, 0, 0, H_gtk_get_major_version, pl_i);
  Xg_define_procedure(gtk_get_minor_version, gxg_gtk_get_minor_version_w, 0, 0, 0, H_gtk_get_minor_version, pl_i);
  Xg_define_procedure(gtk_get_micro_version, gxg_gtk_get_micro_version_w, 0, 0, 0, H_gtk_get_micro_version, pl_i);
  Xg_define_procedure(gtk_get_binary_age, gxg_gtk_get_binary_age_w, 0, 0, 0, H_gtk_get_binary_age, pl_i);
  Xg_define_procedure(gtk_get_interface_age, gxg_gtk_get_interface_age_w, 0, 0, 0, H_gtk_get_interface_age, pl_i);
  Xg_define_procedure(gtk_progress_bar_set_show_text, gxg_gtk_progress_bar_set_show_text_w, 2, 0, 0, H_gtk_progress_bar_set_show_text, pl_tub);
  Xg_define_procedure(gtk_progress_bar_get_show_text, gxg_gtk_progress_bar_get_show_text_w, 1, 0, 0, H_gtk_progress_bar_get_show_text, pl_bu);
  Xg_define_procedure(gtk_entry_get_icon_storage_type, gxg_gtk_entry_get_icon_storage_type_w, 2, 0, 0, H_gtk_entry_get_icon_storage_type, pl_gug);
  Xg_define_procedure(gtk_entry_get_icon_gicon, gxg_gtk_entry_get_icon_gicon_w, 2, 0, 0, H_gtk_entry_get_icon_gicon, pl_pug);
  Xg_define_procedure(gtk_container_set_focus_chain, gxg_gtk_container_set_focus_chain_w, 2, 0, 0, H_gtk_container_set_focus_chain, pl_tu);
  Xg_define_procedure(gtk_container_get_focus_chain, gxg_gtk_container_get_focus_chain_w, 1, 1, 0, H_gtk_container_get_focus_chain, pl_pu);
  Xg_define_procedure(gtk_container_unset_focus_chain, gxg_gtk_container_unset_focus_chain_w, 1, 0, 0, H_gtk_container_unset_focus_chain, pl_tu);
  Xg_define_procedure(gtk_container_set_focus_vadjustment, gxg_gtk_container_set_focus_vadjustment_w, 2, 0, 0, H_gtk_container_set_focus_vadjustment, pl_tu);
  Xg_define_procedure(gtk_container_get_focus_vadjustment, gxg_gtk_container_get_focus_vadjustment_w, 1, 0, 0, H_gtk_container_get_focus_vadjustment, pl_pu);
  Xg_define_procedure(gtk_container_set_focus_hadjustment, gxg_gtk_container_set_focus_hadjustment_w, 2, 0, 0, H_gtk_container_set_focus_hadjustment, pl_tu);
  Xg_define_procedure(gtk_container_get_focus_hadjustment, gxg_gtk_container_get_focus_hadjustment_w, 1, 0, 0, H_gtk_container_get_focus_hadjustment, pl_pu);
  Xg_define_procedure(gtk_assistant_commit, gxg_gtk_assistant_commit_w, 1, 0, 0, H_gtk_assistant_commit, pl_tu);
  Xg_define_procedure(gtk_window_set_skip_taskbar_hint, gxg_gtk_window_set_skip_taskbar_hint_w, 2, 0, 0, H_gtk_window_set_skip_taskbar_hint, pl_tub);
  Xg_define_procedure(gtk_window_get_skip_taskbar_hint, gxg_gtk_window_get_skip_taskbar_hint_w, 1, 0, 0, H_gtk_window_get_skip_taskbar_hint, pl_bu);
  Xg_define_procedure(gtk_window_set_skip_pager_hint, gxg_gtk_window_set_skip_pager_hint_w, 2, 0, 0, H_gtk_window_set_skip_pager_hint, pl_tub);
  Xg_define_procedure(gtk_window_get_skip_pager_hint, gxg_gtk_window_get_skip_pager_hint_w, 1, 0, 0, H_gtk_window_get_skip_pager_hint, pl_bu);
  Xg_define_procedure(gtk_window_set_icon_from_file, gxg_gtk_window_set_icon_from_file_w, 2, 1, 0, H_gtk_window_set_icon_from_file, pl_pusu);
  Xg_define_procedure(gtk_window_set_default_icon_from_file, gxg_gtk_window_set_default_icon_from_file_w, 1, 1, 0, H_gtk_window_set_default_icon_from_file, pl_psu);
  Xg_define_procedure(gtk_window_fullscreen, gxg_gtk_window_fullscreen_w, 1, 0, 0, H_gtk_window_fullscreen, pl_tu);
  Xg_define_procedure(gtk_window_unfullscreen, gxg_gtk_window_unfullscreen_w, 1, 0, 0, H_gtk_window_unfullscreen, pl_tu);
  Xg_define_procedure(gtk_window_get_window_type, gxg_gtk_window_get_window_type_w, 1, 0, 0, H_gtk_window_get_window_type, pl_gu);
  Xg_define_procedure(gtk_window_group_add_window, gxg_gtk_window_group_add_window_w, 2, 0, 0, H_gtk_window_group_add_window, pl_tu);
  Xg_define_procedure(gtk_window_group_remove_window, gxg_gtk_window_group_remove_window_w, 2, 0, 0, H_gtk_window_group_remove_window, pl_tu);
  Xg_define_procedure(gtk_window_group_new, gxg_gtk_window_group_new_w, 0, 0, 0, H_gtk_window_group_new, pl_p);
  Xg_define_procedure(gtk_window_get_group, gxg_gtk_window_get_group_w, 1, 0, 0, H_gtk_window_get_group, pl_pu);
  Xg_define_procedure(gtk_window_group_list_windows, gxg_gtk_window_group_list_windows_w, 1, 0, 0, H_gtk_window_group_list_windows, pl_pu);
  Xg_define_procedure(gtk_window_group_get_current_device_grab, gxg_gtk_window_group_get_current_device_grab_w, 2, 0, 0, H_gtk_window_group_get_current_device_grab, pl_pu);
  Xg_define_procedure(gtk_window_group_get_current_grab, gxg_gtk_window_group_get_current_grab_w, 1, 0, 0, H_gtk_window_group_get_current_grab, pl_pu);
  Xg_define_procedure(gtk_selection_data_get_data, gxg_gtk_selection_data_get_data_w, 1, 0, 0, H_gtk_selection_data_get_data, pl_su);
  Xg_define_procedure(gtk_tool_shell_get_text_orientation, gxg_gtk_tool_shell_get_text_orientation_w, 1, 0, 0, H_gtk_tool_shell_get_text_orientation, pl_gu);
  Xg_define_procedure(gtk_tool_shell_get_text_alignment, gxg_gtk_tool_shell_get_text_alignment_w, 1, 0, 0, H_gtk_tool_shell_get_text_alignment, pl_du);
  Xg_define_procedure(gtk_tool_shell_get_ellipsize_mode, gxg_gtk_tool_shell_get_ellipsize_mode_w, 1, 0, 0, H_gtk_tool_shell_get_ellipsize_mode, pl_gu);
  Xg_define_procedure(gtk_tool_shell_get_text_size_group, gxg_gtk_tool_shell_get_text_size_group_w, 1, 0, 0, H_gtk_tool_shell_get_text_size_group, pl_pu);
  Xg_define_procedure(gtk_tool_shell_get_orientation, gxg_gtk_tool_shell_get_orientation_w, 1, 0, 0, H_gtk_tool_shell_get_orientation, pl_gu);
  Xg_define_procedure(gtk_tool_shell_get_style, gxg_gtk_tool_shell_get_style_w, 1, 0, 0, H_gtk_tool_shell_get_style, pl_gu);
  Xg_define_procedure(gtk_tool_shell_rebuild_menu, gxg_gtk_tool_shell_rebuild_menu_w, 1, 0, 0, H_gtk_tool_shell_rebuild_menu, pl_tu);
  Xg_define_procedure(gtk_accel_map_lock_path, gxg_gtk_accel_map_lock_path_w, 1, 0, 0, H_gtk_accel_map_lock_path, pl_ts);
  Xg_define_procedure(gtk_accel_map_unlock_path, gxg_gtk_accel_map_unlock_path_w, 1, 0, 0, H_gtk_accel_map_unlock_path, pl_ts);
  Xg_define_procedure(gtk_icon_theme_lookup_by_gicon, gxg_gtk_icon_theme_lookup_by_gicon_w, 4, 0, 0, H_gtk_icon_theme_lookup_by_gicon, pl_puuig);
  Xg_define_procedure(gtk_icon_info_new_for_pixbuf, gxg_gtk_icon_info_new_for_pixbuf_w, 2, 0, 0, H_gtk_icon_info_new_for_pixbuf, pl_pu);
  Xg_define_procedure(gtk_icon_view_set_item_orientation, gxg_gtk_icon_view_set_item_orientation_w, 2, 0, 0, H_gtk_icon_view_set_item_orientation, pl_tug);
  Xg_define_procedure(gtk_icon_view_get_item_orientation, gxg_gtk_icon_view_get_item_orientation_w, 1, 0, 0, H_gtk_icon_view_get_item_orientation, pl_gu);
  Xg_define_procedure(gtk_text_view_im_context_filter_keypress, gxg_gtk_text_view_im_context_filter_keypress_w, 2, 0, 0, H_gtk_text_view_im_context_filter_keypress, pl_bu);
  Xg_define_procedure(gtk_text_view_reset_im_context, gxg_gtk_text_view_reset_im_context_w, 1, 0, 0, H_gtk_text_view_reset_im_context, pl_tu);
  Xg_define_procedure(gdk_device_get_window_at_position, gxg_gdk_device_get_window_at_position_w, 1, 2, 0, H_gdk_device_get_window_at_position, pl_pu);
  Xg_define_procedure(gtk_cell_view_get_draw_sensitive, gxg_gtk_cell_view_get_draw_sensitive_w, 1, 0, 0, H_gtk_cell_view_get_draw_sensitive, pl_bu);
  Xg_define_procedure(gtk_cell_view_set_draw_sensitive, gxg_gtk_cell_view_set_draw_sensitive_w, 2, 0, 0, H_gtk_cell_view_set_draw_sensitive, pl_tub);
  Xg_define_procedure(gtk_cell_view_get_fit_model, gxg_gtk_cell_view_get_fit_model_w, 1, 0, 0, H_gtk_cell_view_get_fit_model, pl_bu);
  Xg_define_procedure(gtk_cell_view_set_fit_model, gxg_gtk_cell_view_set_fit_model_w, 2, 0, 0, H_gtk_cell_view_set_fit_model, pl_tub);
  Xg_define_procedure(gtk_icon_view_new_with_area, gxg_gtk_icon_view_new_with_area_w, 1, 0, 0, H_gtk_icon_view_new_with_area, pl_pu);
  Xg_define_procedure(gtk_menu_item_set_reserve_indicator, gxg_gtk_menu_item_set_reserve_indicator_w, 2, 0, 0, H_gtk_menu_item_set_reserve_indicator, pl_tub);
  Xg_define_procedure(gtk_menu_item_get_reserve_indicator, gxg_gtk_menu_item_get_reserve_indicator_w, 1, 0, 0, H_gtk_menu_item_get_reserve_indicator, pl_bu);
  Xg_define_procedure(gtk_menu_shell_get_selected_item, gxg_gtk_menu_shell_get_selected_item_w, 1, 0, 0, H_gtk_menu_shell_get_selected_item, pl_pu);
  Xg_define_procedure(gtk_menu_shell_get_parent_shell, gxg_gtk_menu_shell_get_parent_shell_w, 1, 0, 0, H_gtk_menu_shell_get_parent_shell, pl_pu);
  Xg_define_procedure(gtk_selection_data_get_data_with_length, gxg_gtk_selection_data_get_data_with_length_w, 1, 1, 0, H_gtk_selection_data_get_data_with_length, pl_pu);
  Xg_define_procedure(gtk_tree_model_iter_previous, gxg_gtk_tree_model_iter_previous_w, 2, 0, 0, H_gtk_tree_model_iter_previous, pl_bu);
  Xg_define_procedure(gtk_tree_view_is_blank_at_pos, gxg_gtk_tree_view_is_blank_at_pos_w, 3, 4, 0, H_gtk_tree_view_is_blank_at_pos, pl_puiiu);
  Xg_define_procedure(gtk_window_set_has_user_ref_count, gxg_gtk_window_set_has_user_ref_count_w, 2, 0, 0, H_gtk_window_set_has_user_ref_count, pl_tub);
  Xg_define_procedure(gdk_rgba_copy, gxg_gdk_rgba_copy_w, 1, 0, 0, H_gdk_rgba_copy, pl_pu);
  Xg_define_procedure(gdk_rgba_free, gxg_gdk_rgba_free_w, 1, 0, 0, H_gdk_rgba_free, pl_tu);
  Xg_define_procedure(gdk_rgba_parse, gxg_gdk_rgba_parse_w, 2, 0, 0, H_gdk_rgba_parse, pl_bus);
  Xg_define_procedure(gdk_rgba_to_string, gxg_gdk_rgba_to_string_w, 1, 0, 0, H_gdk_rgba_to_string, pl_su);
  Xg_define_procedure(gtk_widget_set_state_flags, gxg_gtk_widget_set_state_flags_w, 3, 0, 0, H_gtk_widget_set_state_flags, pl_tugb);
  Xg_define_procedure(gtk_widget_unset_state_flags, gxg_gtk_widget_unset_state_flags_w, 2, 0, 0, H_gtk_widget_unset_state_flags, pl_tug);
  Xg_define_procedure(gtk_widget_get_state_flags, gxg_gtk_widget_get_state_flags_w, 1, 0, 0, H_gtk_widget_get_state_flags, pl_gu);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  Xg_define_procedure(gtk_entry_get_placeholder_text, gxg_gtk_entry_get_placeholder_text_w, 1, 0, 0, H_gtk_entry_get_placeholder_text, pl_su);
  Xg_define_procedure(gtk_entry_set_placeholder_text, gxg_gtk_entry_set_placeholder_text_w, 2, 0, 0, H_gtk_entry_set_placeholder_text, pl_tus);
  Xg_define_procedure(gtk_expander_set_resize_toplevel, gxg_gtk_expander_set_resize_toplevel_w, 2, 0, 0, H_gtk_expander_set_resize_toplevel, pl_tub);
  Xg_define_procedure(gtk_expander_get_resize_toplevel, gxg_gtk_expander_get_resize_toplevel_w, 1, 0, 0, H_gtk_expander_get_resize_toplevel, pl_bu);
  Xg_define_procedure(gtk_widget_path_to_string, gxg_gtk_widget_path_to_string_w, 1, 0, 0, H_gtk_widget_path_to_string, pl_su);
  Xg_define_procedure(gtk_button_box_get_child_non_homogeneous, gxg_gtk_button_box_get_child_non_homogeneous_w, 2, 0, 0, H_gtk_button_box_get_child_non_homogeneous, pl_bu);
  Xg_define_procedure(gtk_button_box_set_child_non_homogeneous, gxg_gtk_button_box_set_child_non_homogeneous_w, 3, 0, 0, H_gtk_button_box_set_child_non_homogeneous, pl_tuub);
  Xg_define_procedure(gtk_container_child_notify, gxg_gtk_container_child_notify_w, 3, 0, 0, H_gtk_container_child_notify, pl_tuus);
  Xg_define_procedure(gtk_drag_source_set_icon_gicon, gxg_gtk_drag_source_set_icon_gicon_w, 2, 0, 0, H_gtk_drag_source_set_icon_gicon, pl_tu);
  Xg_define_procedure(gtk_drag_set_icon_gicon, gxg_gtk_drag_set_icon_gicon_w, 4, 0, 0, H_gtk_drag_set_icon_gicon, pl_tuui);
  Xg_define_procedure(gtk_combo_box_set_active_id, gxg_gtk_combo_box_set_active_id_w, 2, 0, 0, H_gtk_combo_box_set_active_id, pl_bus);
  Xg_define_procedure(gtk_tree_view_column_get_x_offset, gxg_gtk_tree_view_column_get_x_offset_w, 1, 0, 0, H_gtk_tree_view_column_get_x_offset, pl_iu);
  Xg_define_procedure(gtk_overlay_new, gxg_gtk_overlay_new_w, 0, 0, 0, H_gtk_overlay_new, pl_p);
  Xg_define_procedure(gtk_overlay_add_overlay, gxg_gtk_overlay_add_overlay_w, 2, 0, 0, H_gtk_overlay_add_overlay, pl_tu);
  Xg_define_procedure(gtk_adjustment_get_minimum_increment, gxg_gtk_adjustment_get_minimum_increment_w, 1, 0, 0, H_gtk_adjustment_get_minimum_increment, pl_du);
  Xg_define_procedure(gtk_grid_insert_row, gxg_gtk_grid_insert_row_w, 2, 0, 0, H_gtk_grid_insert_row, pl_tui);
  Xg_define_procedure(gtk_grid_insert_column, gxg_gtk_grid_insert_column_w, 2, 0, 0, H_gtk_grid_insert_column, pl_tui);
  Xg_define_procedure(gtk_grid_insert_next_to, gxg_gtk_grid_insert_next_to_w, 3, 0, 0, H_gtk_grid_insert_next_to, pl_tuug);
  Xg_define_procedure(gtk_text_iter_assign, gxg_gtk_text_iter_assign_w, 2, 0, 0, H_gtk_text_iter_assign, pl_tu);
  Xg_define_procedure(gtk_widget_has_visible_focus, gxg_gtk_widget_has_visible_focus_w, 1, 0, 0, H_gtk_widget_has_visible_focus, pl_bu);
  Xg_define_procedure(gtk_window_set_focus_visible, gxg_gtk_window_set_focus_visible_w, 2, 0, 0, H_gtk_window_set_focus_visible, pl_tub);
  Xg_define_procedure(gtk_window_get_focus_visible, gxg_gtk_window_get_focus_visible_w, 1, 0, 0, H_gtk_window_get_focus_visible, pl_bu);
  Xg_define_procedure(gtk_font_chooser_dialog_new, gxg_gtk_font_chooser_dialog_new_w, 2, 0, 0, H_gtk_font_chooser_dialog_new, pl_psu);
  Xg_define_procedure(gdk_event_get_button, gxg_gdk_event_get_button_w, 2, 0, 0, H_gdk_event_get_button, pl_bu);
  Xg_define_procedure(gdk_event_get_click_count, gxg_gdk_event_get_click_count_w, 2, 0, 0, H_gdk_event_get_click_count, pl_bu);
  Xg_define_procedure(gdk_event_get_keyval, gxg_gdk_event_get_keyval_w, 2, 0, 0, H_gdk_event_get_keyval, pl_bu);
  Xg_define_procedure(gdk_event_get_keycode, gxg_gdk_event_get_keycode_w, 2, 0, 0, H_gdk_event_get_keycode, pl_bu);
  Xg_define_procedure(gdk_event_get_scroll_direction, gxg_gdk_event_get_scroll_direction_w, 1, 1, 0, H_gdk_event_get_scroll_direction, pl_pu);
  Xg_define_procedure(gtk_grid_get_child_at, gxg_gtk_grid_get_child_at_w, 3, 0, 0, H_gtk_grid_get_child_at, pl_pui);
  Xg_define_procedure(gtk_font_chooser_get_font_family, gxg_gtk_font_chooser_get_font_family_w, 1, 0, 0, H_gtk_font_chooser_get_font_family, pl_pu);
  Xg_define_procedure(gtk_font_chooser_get_font_face, gxg_gtk_font_chooser_get_font_face_w, 1, 0, 0, H_gtk_font_chooser_get_font_face, pl_pu);
  Xg_define_procedure(gtk_font_chooser_get_font_size, gxg_gtk_font_chooser_get_font_size_w, 1, 0, 0, H_gtk_font_chooser_get_font_size, pl_iu);
  Xg_define_procedure(gtk_font_chooser_get_font_desc, gxg_gtk_font_chooser_get_font_desc_w, 1, 0, 0, H_gtk_font_chooser_get_font_desc, pl_pu);
  Xg_define_procedure(gtk_font_chooser_set_font_desc, gxg_gtk_font_chooser_set_font_desc_w, 2, 0, 0, H_gtk_font_chooser_set_font_desc, pl_tu);
  Xg_define_procedure(gtk_font_chooser_get_font, gxg_gtk_font_chooser_get_font_w, 1, 0, 0, H_gtk_font_chooser_get_font, pl_su);
  Xg_define_procedure(gtk_font_chooser_set_font, gxg_gtk_font_chooser_set_font_w, 2, 0, 0, H_gtk_font_chooser_set_font, pl_tus);
  Xg_define_procedure(gtk_font_chooser_get_preview_text, gxg_gtk_font_chooser_get_preview_text_w, 1, 0, 0, H_gtk_font_chooser_get_preview_text, pl_su);
  Xg_define_procedure(gtk_font_chooser_set_preview_text, gxg_gtk_font_chooser_set_preview_text_w, 2, 0, 0, H_gtk_font_chooser_set_preview_text, pl_tus);
  Xg_define_procedure(gtk_font_chooser_get_show_preview_entry, gxg_gtk_font_chooser_get_show_preview_entry_w, 1, 0, 0, H_gtk_font_chooser_get_show_preview_entry, pl_bu);
  Xg_define_procedure(gtk_font_chooser_set_show_preview_entry, gxg_gtk_font_chooser_set_show_preview_entry_w, 2, 0, 0, H_gtk_font_chooser_set_show_preview_entry, pl_tub);
  Xg_define_procedure(gtk_font_chooser_widget_new, gxg_gtk_font_chooser_widget_new_w, 0, 0, 0, H_gtk_font_chooser_widget_new, pl_p);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  Xg_define_procedure(gdk_keymap_get_modifier_mask, gxg_gdk_keymap_get_modifier_mask_w, 2, 0, 0, H_gdk_keymap_get_modifier_mask, pl_gug);
  Xg_define_procedure(gdk_window_begin_resize_drag_for_device, gxg_gdk_window_begin_resize_drag_for_device_w, 7, 0, 0, H_gdk_window_begin_resize_drag_for_device, pl_tugui);
  Xg_define_procedure(gdk_window_begin_move_drag_for_device, gxg_gdk_window_begin_move_drag_for_device_w, 6, 0, 0, H_gdk_window_begin_move_drag_for_device, pl_tuui);
  Xg_define_procedure(gtk_accelerator_parse_with_keycode, gxg_gtk_accelerator_parse_with_keycode_w, 4, 0, 0, H_gtk_accelerator_parse_with_keycode, pl_tsu);
  Xg_define_procedure(gtk_accelerator_name_with_keycode, gxg_gtk_accelerator_name_with_keycode_w, 4, 0, 0, H_gtk_accelerator_name_with_keycode, pl_suiig);
  Xg_define_procedure(gtk_accelerator_get_label_with_keycode, gxg_gtk_accelerator_get_label_with_keycode_w, 4, 0, 0, H_gtk_accelerator_get_label_with_keycode, pl_suiig);
  Xg_define_procedure(gtk_application_get_app_menu, gxg_gtk_application_get_app_menu_w, 1, 0, 0, H_gtk_application_get_app_menu, pl_pu);
  Xg_define_procedure(gtk_application_set_app_menu, gxg_gtk_application_set_app_menu_w, 2, 0, 0, H_gtk_application_set_app_menu, pl_tu);
  Xg_define_procedure(gtk_application_get_menubar, gxg_gtk_application_get_menubar_w, 1, 0, 0, H_gtk_application_get_menubar, pl_pu);
  Xg_define_procedure(gtk_application_set_menubar, gxg_gtk_application_set_menubar_w, 2, 0, 0, H_gtk_application_set_menubar, pl_tu);
  Xg_define_procedure(gtk_entry_completion_compute_prefix, gxg_gtk_entry_completion_compute_prefix_w, 2, 0, 0, H_gtk_entry_completion_compute_prefix, pl_sus);
  Xg_define_procedure(gtk_scale_set_has_origin, gxg_gtk_scale_set_has_origin_w, 2, 0, 0, H_gtk_scale_set_has_origin, pl_tub);
  Xg_define_procedure(gtk_scale_get_has_origin, gxg_gtk_scale_get_has_origin_w, 1, 0, 0, H_gtk_scale_get_has_origin, pl_bu);
  Xg_define_procedure(gtk_application_window_new, gxg_gtk_application_window_new_w, 1, 0, 0, H_gtk_application_window_new, pl_pu);
  Xg_define_procedure(gtk_application_window_set_show_menubar, gxg_gtk_application_window_set_show_menubar_w, 2, 0, 0, H_gtk_application_window_set_show_menubar, pl_tub);
  Xg_define_procedure(gtk_application_window_get_show_menubar, gxg_gtk_application_window_get_show_menubar_w, 1, 0, 0, H_gtk_application_window_get_show_menubar, pl_bu);
  Xg_define_procedure(gtk_image_new_from_resource, gxg_gtk_image_new_from_resource_w, 1, 0, 0, H_gtk_image_new_from_resource, pl_ps);
  Xg_define_procedure(gtk_image_set_from_resource, gxg_gtk_image_set_from_resource_w, 2, 0, 0, H_gtk_image_set_from_resource, pl_tus);
  Xg_define_procedure(gtk_window_set_attached_to, gxg_gtk_window_set_attached_to_w, 2, 0, 0, H_gtk_window_set_attached_to, pl_tu);
  Xg_define_procedure(gtk_window_get_attached_to, gxg_gtk_window_get_attached_to_w, 1, 0, 0, H_gtk_window_get_attached_to, pl_pu);
  Xg_define_procedure(gtk_about_dialog_add_credit_section, gxg_gtk_about_dialog_add_credit_section_w, 3, 0, 0, H_gtk_about_dialog_add_credit_section, pl_tusu);
  Xg_define_procedure(gdk_keymap_get_modifier_state, gxg_gdk_keymap_get_modifier_state_w, 1, 0, 0, H_gdk_keymap_get_modifier_state, pl_iu);
  Xg_define_procedure(gtk_hsv_to_rgb, gxg_gtk_hsv_to_rgb_w, 3, 3, 0, H_gtk_hsv_to_rgb, pl_prrru);
  Xg_define_procedure(gtk_rgb_to_hsv, gxg_gtk_rgb_to_hsv_w, 3, 3, 0, H_gtk_rgb_to_hsv, pl_prrru);
  Xg_define_procedure(gtk_color_chooser_get_rgba, gxg_gtk_color_chooser_get_rgba_w, 2, 0, 0, H_gtk_color_chooser_get_rgba, pl_tu);
  Xg_define_procedure(gtk_color_chooser_set_rgba, gxg_gtk_color_chooser_set_rgba_w, 2, 0, 0, H_gtk_color_chooser_set_rgba, pl_tu);
  Xg_define_procedure(gtk_color_chooser_get_use_alpha, gxg_gtk_color_chooser_get_use_alpha_w, 1, 0, 0, H_gtk_color_chooser_get_use_alpha, pl_bu);
  Xg_define_procedure(gtk_color_chooser_set_use_alpha, gxg_gtk_color_chooser_set_use_alpha_w, 2, 0, 0, H_gtk_color_chooser_set_use_alpha, pl_tub);
  Xg_define_procedure(gtk_color_chooser_dialog_new, gxg_gtk_color_chooser_dialog_new_w, 2, 0, 0, H_gtk_color_chooser_dialog_new, pl_psu);
  Xg_define_procedure(gtk_color_chooser_widget_new, gxg_gtk_color_chooser_widget_new_w, 0, 0, 0, H_gtk_color_chooser_widget_new, pl_p);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  Xg_define_procedure(gdk_event_get_scroll_deltas, gxg_gdk_event_get_scroll_deltas_w, 1, 2, 0, H_gdk_event_get_scroll_deltas, pl_pu);
  Xg_define_procedure(gtk_color_chooser_add_palette, gxg_gtk_color_chooser_add_palette_w, 5, 0, 0, H_gtk_color_chooser_add_palette, pl_tugiiu);
  Xg_define_procedure(gtk_tree_view_get_n_columns, gxg_gtk_tree_view_get_n_columns_w, 1, 0, 0, H_gtk_tree_view_get_n_columns, pl_iu);
  Xg_define_procedure(gtk_menu_button_new, gxg_gtk_menu_button_new_w, 0, 0, 0, H_gtk_menu_button_new, pl_p);
  Xg_define_procedure(gtk_menu_button_set_menu_model, gxg_gtk_menu_button_set_menu_model_w, 2, 0, 0, H_gtk_menu_button_set_menu_model, pl_tu);
  Xg_define_procedure(gtk_menu_button_get_menu_model, gxg_gtk_menu_button_get_menu_model_w, 1, 0, 0, H_gtk_menu_button_get_menu_model, pl_pu);
  Xg_define_procedure(gtk_menu_button_set_align_widget, gxg_gtk_menu_button_set_align_widget_w, 2, 0, 0, H_gtk_menu_button_set_align_widget, pl_tu);
  Xg_define_procedure(gtk_menu_button_get_align_widget, gxg_gtk_menu_button_get_align_widget_w, 1, 0, 0, H_gtk_menu_button_get_align_widget, pl_pu);
  Xg_define_procedure(gtk_search_entry_new, gxg_gtk_search_entry_new_w, 0, 0, 0, H_gtk_search_entry_new, pl_p);
  Xg_define_procedure(gtk_level_bar_new, gxg_gtk_level_bar_new_w, 0, 0, 0, H_gtk_level_bar_new, pl_p);
  Xg_define_procedure(gtk_level_bar_new_for_interval, gxg_gtk_level_bar_new_for_interval_w, 2, 0, 0, H_gtk_level_bar_new_for_interval, pl_pr);
  Xg_define_procedure(gtk_level_bar_set_mode, gxg_gtk_level_bar_set_mode_w, 2, 0, 0, H_gtk_level_bar_set_mode, pl_tug);
  Xg_define_procedure(gtk_level_bar_get_mode, gxg_gtk_level_bar_get_mode_w, 1, 0, 0, H_gtk_level_bar_get_mode, pl_gu);
  Xg_define_procedure(gtk_level_bar_set_value, gxg_gtk_level_bar_set_value_w, 2, 0, 0, H_gtk_level_bar_set_value, pl_tur);
  Xg_define_procedure(gtk_level_bar_get_value, gxg_gtk_level_bar_get_value_w, 1, 0, 0, H_gtk_level_bar_get_value, pl_du);
  Xg_define_procedure(gtk_level_bar_set_min_value, gxg_gtk_level_bar_set_min_value_w, 2, 0, 0, H_gtk_level_bar_set_min_value, pl_tur);
  Xg_define_procedure(gtk_level_bar_get_min_value, gxg_gtk_level_bar_get_min_value_w, 1, 0, 0, H_gtk_level_bar_get_min_value, pl_du);
  Xg_define_procedure(gtk_level_bar_set_max_value, gxg_gtk_level_bar_set_max_value_w, 2, 0, 0, H_gtk_level_bar_set_max_value, pl_tur);
  Xg_define_procedure(gtk_level_bar_get_max_value, gxg_gtk_level_bar_get_max_value_w, 1, 0, 0, H_gtk_level_bar_get_max_value, pl_du);
  Xg_define_procedure(gtk_level_bar_add_offset_value, gxg_gtk_level_bar_add_offset_value_w, 3, 0, 0, H_gtk_level_bar_add_offset_value, pl_tusr);
  Xg_define_procedure(gtk_level_bar_remove_offset_value, gxg_gtk_level_bar_remove_offset_value_w, 2, 0, 0, H_gtk_level_bar_remove_offset_value, pl_tus);
  Xg_define_procedure(gtk_level_bar_get_offset_value, gxg_gtk_level_bar_get_offset_value_w, 2, 1, 0, H_gtk_level_bar_get_offset_value, pl_pusu);
  Xg_define_procedure(gtk_application_get_active_window, gxg_gtk_application_get_active_window_w, 1, 0, 0, H_gtk_application_get_active_window, pl_pu);
  Xg_define_procedure(gtk_entry_set_input_purpose, gxg_gtk_entry_set_input_purpose_w, 2, 0, 0, H_gtk_entry_set_input_purpose, pl_tug);
  Xg_define_procedure(gtk_entry_get_input_purpose, gxg_gtk_entry_get_input_purpose_w, 1, 0, 0, H_gtk_entry_get_input_purpose, pl_gu);
  Xg_define_procedure(gtk_entry_set_input_hints, gxg_gtk_entry_set_input_hints_w, 2, 0, 0, H_gtk_entry_set_input_hints, pl_tug);
  Xg_define_procedure(gtk_entry_get_input_hints, gxg_gtk_entry_get_input_hints_w, 1, 0, 0, H_gtk_entry_get_input_hints, pl_gu);
  Xg_define_procedure(gtk_menu_button_get_popup, gxg_gtk_menu_button_get_popup_w, 1, 0, 0, H_gtk_menu_button_get_popup, pl_pu);
  Xg_define_procedure(gtk_text_view_set_input_purpose, gxg_gtk_text_view_set_input_purpose_w, 2, 0, 0, H_gtk_text_view_set_input_purpose, pl_tug);
  Xg_define_procedure(gtk_text_view_get_input_purpose, gxg_gtk_text_view_get_input_purpose_w, 1, 0, 0, H_gtk_text_view_get_input_purpose, pl_gu);
  Xg_define_procedure(gtk_text_view_set_input_hints, gxg_gtk_text_view_set_input_hints_w, 2, 0, 0, H_gtk_text_view_set_input_hints, pl_tug);
  Xg_define_procedure(gtk_text_view_get_input_hints, gxg_gtk_text_view_get_input_hints_w, 1, 0, 0, H_gtk_text_view_get_input_hints, pl_gu);
  Xg_define_procedure(gtk_entry_set_attributes, gxg_gtk_entry_set_attributes_w, 2, 0, 0, H_gtk_entry_set_attributes, pl_tu);
  Xg_define_procedure(gtk_entry_get_attributes, gxg_gtk_entry_get_attributes_w, 1, 0, 0, H_gtk_entry_get_attributes, pl_pu);
  Xg_define_procedure(gtk_accel_label_set_accel, gxg_gtk_accel_label_set_accel_w, 3, 0, 0, H_gtk_accel_label_set_accel, pl_tuig);
  Xg_define_procedure(gtk_menu_shell_bind_model, gxg_gtk_menu_shell_bind_model_w, 4, 0, 0, H_gtk_menu_shell_bind_model, pl_tuusb);
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
  Xg_define_procedure(gtk_level_bar_set_inverted, gxg_gtk_level_bar_set_inverted_w, 2, 0, 0, H_gtk_level_bar_set_inverted, pl_tub);
  Xg_define_procedure(gtk_level_bar_get_inverted, gxg_gtk_level_bar_get_inverted_w, 1, 0, 0, H_gtk_level_bar_get_inverted, pl_bu);
  Xg_define_procedure(gtk_widget_is_visible, gxg_gtk_widget_is_visible_w, 1, 0, 0, H_gtk_widget_is_visible, pl_bu);
  Xg_define_procedure(gdk_window_set_fullscreen_mode, gxg_gdk_window_set_fullscreen_mode_w, 2, 0, 0, H_gdk_window_set_fullscreen_mode, pl_tug);
  Xg_define_procedure(gdk_window_get_fullscreen_mode, gxg_gdk_window_get_fullscreen_mode_w, 1, 0, 0, H_gdk_window_get_fullscreen_mode, pl_gu);
  Xg_define_procedure(gtk_icon_view_set_activate_on_single_click, gxg_gtk_icon_view_set_activate_on_single_click_w, 2, 0, 0, H_gtk_icon_view_set_activate_on_single_click, pl_tub);
  Xg_define_procedure(gtk_icon_view_get_activate_on_single_click, gxg_gtk_icon_view_get_activate_on_single_click_w, 1, 0, 0, H_gtk_icon_view_get_activate_on_single_click, pl_bu);
  Xg_define_procedure(gtk_tree_view_get_activate_on_single_click, gxg_gtk_tree_view_get_activate_on_single_click_w, 1, 0, 0, H_gtk_tree_view_get_activate_on_single_click, pl_bu);
  Xg_define_procedure(gtk_tree_view_set_activate_on_single_click, gxg_gtk_tree_view_set_activate_on_single_click_w, 2, 0, 0, H_gtk_tree_view_set_activate_on_single_click, pl_tub);
  Xg_define_procedure(gtk_widget_register_window, gxg_gtk_widget_register_window_w, 2, 0, 0, H_gtk_widget_register_window, pl_tu);
  Xg_define_procedure(gtk_widget_unregister_window, gxg_gtk_widget_unregister_window_w, 2, 0, 0, H_gtk_widget_unregister_window, pl_tu);
  Xg_define_procedure(gtk_widget_set_opacity, gxg_gtk_widget_set_opacity_w, 2, 0, 0, H_gtk_widget_set_opacity, pl_tur);
  Xg_define_procedure(gtk_widget_get_opacity, gxg_gtk_widget_get_opacity_w, 1, 0, 0, H_gtk_widget_get_opacity, pl_du);
  Xg_define_procedure(pango_font_map_changed, gxg_pango_font_map_changed_w, 1, 0, 0, H_pango_font_map_changed, pl_tu);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  Xg_define_procedure(gtk_box_set_baseline_position, gxg_gtk_box_set_baseline_position_w, 2, 0, 0, H_gtk_box_set_baseline_position, pl_tug);
  Xg_define_procedure(gtk_box_get_baseline_position, gxg_gtk_box_get_baseline_position_w, 1, 0, 0, H_gtk_box_get_baseline_position, pl_gu);
  Xg_define_procedure(gtk_grid_remove_row, gxg_gtk_grid_remove_row_w, 2, 0, 0, H_gtk_grid_remove_row, pl_tui);
  Xg_define_procedure(gtk_grid_remove_column, gxg_gtk_grid_remove_column_w, 2, 0, 0, H_gtk_grid_remove_column, pl_tui);
  Xg_define_procedure(gtk_grid_set_row_baseline_position, gxg_gtk_grid_set_row_baseline_position_w, 3, 0, 0, H_gtk_grid_set_row_baseline_position, pl_tuig);
  Xg_define_procedure(gtk_grid_get_row_baseline_position, gxg_gtk_grid_get_row_baseline_position_w, 2, 0, 0, H_gtk_grid_get_row_baseline_position, pl_gui);
  Xg_define_procedure(gtk_grid_set_baseline_row, gxg_gtk_grid_set_baseline_row_w, 2, 0, 0, H_gtk_grid_set_baseline_row, pl_tui);
  Xg_define_procedure(gtk_grid_get_baseline_row, gxg_gtk_grid_get_baseline_row_w, 1, 0, 0, H_gtk_grid_get_baseline_row, pl_iu);
  Xg_define_procedure(gtk_widget_get_allocated_baseline, gxg_gtk_widget_get_allocated_baseline_w, 1, 0, 0, H_gtk_widget_get_allocated_baseline, pl_iu);
  Xg_define_procedure(gtk_widget_init_template, gxg_gtk_widget_init_template_w, 1, 0, 0, H_gtk_widget_init_template, pl_tu);
  Xg_define_procedure(gtk_window_set_titlebar, gxg_gtk_window_set_titlebar_w, 2, 0, 0, H_gtk_window_set_titlebar, pl_tu);
  Xg_define_procedure(gtk_places_sidebar_new, gxg_gtk_places_sidebar_new_w, 0, 0, 0, H_gtk_places_sidebar_new, pl_p);
  Xg_define_procedure(gtk_places_sidebar_get_open_flags, gxg_gtk_places_sidebar_get_open_flags_w, 1, 0, 0, H_gtk_places_sidebar_get_open_flags, pl_gu);
  Xg_define_procedure(gtk_places_sidebar_set_open_flags, gxg_gtk_places_sidebar_set_open_flags_w, 2, 0, 0, H_gtk_places_sidebar_set_open_flags, pl_tug);
  Xg_define_procedure(gtk_places_sidebar_get_location, gxg_gtk_places_sidebar_get_location_w, 1, 0, 0, H_gtk_places_sidebar_get_location, pl_pu);
  Xg_define_procedure(gtk_places_sidebar_set_location, gxg_gtk_places_sidebar_set_location_w, 2, 0, 0, H_gtk_places_sidebar_set_location, pl_tu);
  Xg_define_procedure(gtk_places_sidebar_get_show_desktop, gxg_gtk_places_sidebar_get_show_desktop_w, 1, 0, 0, H_gtk_places_sidebar_get_show_desktop, pl_bu);
  Xg_define_procedure(gtk_places_sidebar_set_show_desktop, gxg_gtk_places_sidebar_set_show_desktop_w, 2, 0, 0, H_gtk_places_sidebar_set_show_desktop, pl_tub);
  Xg_define_procedure(gtk_places_sidebar_add_shortcut, gxg_gtk_places_sidebar_add_shortcut_w, 2, 0, 0, H_gtk_places_sidebar_add_shortcut, pl_tu);
  Xg_define_procedure(gtk_places_sidebar_remove_shortcut, gxg_gtk_places_sidebar_remove_shortcut_w, 2, 0, 0, H_gtk_places_sidebar_remove_shortcut, pl_tu);
  Xg_define_procedure(gtk_places_sidebar_list_shortcuts, gxg_gtk_places_sidebar_list_shortcuts_w, 1, 0, 0, H_gtk_places_sidebar_list_shortcuts, pl_pu);
  Xg_define_procedure(gtk_places_sidebar_get_nth_bookmark, gxg_gtk_places_sidebar_get_nth_bookmark_w, 2, 0, 0, H_gtk_places_sidebar_get_nth_bookmark, pl_pui);
  Xg_define_procedure(gtk_stack_switcher_new, gxg_gtk_stack_switcher_new_w, 0, 0, 0, H_gtk_stack_switcher_new, pl_p);
  Xg_define_procedure(gtk_stack_switcher_set_stack, gxg_gtk_stack_switcher_set_stack_w, 2, 0, 0, H_gtk_stack_switcher_set_stack, pl_tu);
  Xg_define_procedure(gtk_stack_switcher_get_stack, gxg_gtk_stack_switcher_get_stack_w, 1, 0, 0, H_gtk_stack_switcher_get_stack, pl_pu);
  Xg_define_procedure(gtk_stack_new, gxg_gtk_stack_new_w, 0, 0, 0, H_gtk_stack_new, pl_p);
  Xg_define_procedure(gtk_stack_add_named, gxg_gtk_stack_add_named_w, 3, 0, 0, H_gtk_stack_add_named, pl_tuus);
  Xg_define_procedure(gtk_stack_add_titled, gxg_gtk_stack_add_titled_w, 4, 0, 0, H_gtk_stack_add_titled, pl_tuus);
  Xg_define_procedure(gtk_stack_set_visible_child, gxg_gtk_stack_set_visible_child_w, 2, 0, 0, H_gtk_stack_set_visible_child, pl_tu);
  Xg_define_procedure(gtk_stack_get_visible_child, gxg_gtk_stack_get_visible_child_w, 1, 0, 0, H_gtk_stack_get_visible_child, pl_pu);
  Xg_define_procedure(gtk_stack_set_visible_child_name, gxg_gtk_stack_set_visible_child_name_w, 2, 0, 0, H_gtk_stack_set_visible_child_name, pl_tus);
  Xg_define_procedure(gtk_stack_get_visible_child_name, gxg_gtk_stack_get_visible_child_name_w, 1, 0, 0, H_gtk_stack_get_visible_child_name, pl_su);
  Xg_define_procedure(gtk_stack_set_visible_child_full, gxg_gtk_stack_set_visible_child_full_w, 3, 0, 0, H_gtk_stack_set_visible_child_full, pl_tusg);
  Xg_define_procedure(gtk_stack_set_homogeneous, gxg_gtk_stack_set_homogeneous_w, 2, 0, 0, H_gtk_stack_set_homogeneous, pl_tub);
  Xg_define_procedure(gtk_stack_get_homogeneous, gxg_gtk_stack_get_homogeneous_w, 1, 0, 0, H_gtk_stack_get_homogeneous, pl_bu);
  Xg_define_procedure(gtk_stack_set_transition_duration, gxg_gtk_stack_set_transition_duration_w, 2, 0, 0, H_gtk_stack_set_transition_duration, pl_tui);
  Xg_define_procedure(gtk_stack_get_transition_duration, gxg_gtk_stack_get_transition_duration_w, 1, 0, 0, H_gtk_stack_get_transition_duration, pl_iu);
  Xg_define_procedure(gtk_stack_set_transition_type, gxg_gtk_stack_set_transition_type_w, 2, 0, 0, H_gtk_stack_set_transition_type, pl_tug);
  Xg_define_procedure(gtk_stack_get_transition_type, gxg_gtk_stack_get_transition_type_w, 1, 0, 0, H_gtk_stack_get_transition_type, pl_gu);
  Xg_define_procedure(gtk_revealer_new, gxg_gtk_revealer_new_w, 0, 0, 0, H_gtk_revealer_new, pl_p);
  Xg_define_procedure(gtk_revealer_get_reveal_child, gxg_gtk_revealer_get_reveal_child_w, 1, 0, 0, H_gtk_revealer_get_reveal_child, pl_bu);
  Xg_define_procedure(gtk_revealer_set_reveal_child, gxg_gtk_revealer_set_reveal_child_w, 2, 0, 0, H_gtk_revealer_set_reveal_child, pl_tub);
  Xg_define_procedure(gtk_revealer_get_child_revealed, gxg_gtk_revealer_get_child_revealed_w, 1, 0, 0, H_gtk_revealer_get_child_revealed, pl_bu);
  Xg_define_procedure(gtk_revealer_get_transition_duration, gxg_gtk_revealer_get_transition_duration_w, 1, 0, 0, H_gtk_revealer_get_transition_duration, pl_iu);
  Xg_define_procedure(gtk_revealer_set_transition_duration, gxg_gtk_revealer_set_transition_duration_w, 2, 0, 0, H_gtk_revealer_set_transition_duration, pl_tui);
  Xg_define_procedure(gtk_revealer_set_transition_type, gxg_gtk_revealer_set_transition_type_w, 2, 0, 0, H_gtk_revealer_set_transition_type, pl_tug);
  Xg_define_procedure(gtk_revealer_get_transition_type, gxg_gtk_revealer_get_transition_type_w, 1, 0, 0, H_gtk_revealer_get_transition_type, pl_gu);
  Xg_define_procedure(gtk_header_bar_new, gxg_gtk_header_bar_new_w, 0, 0, 0, H_gtk_header_bar_new, pl_p);
  Xg_define_procedure(gtk_header_bar_set_title, gxg_gtk_header_bar_set_title_w, 2, 0, 0, H_gtk_header_bar_set_title, pl_tus);
  Xg_define_procedure(gtk_header_bar_get_title, gxg_gtk_header_bar_get_title_w, 1, 0, 0, H_gtk_header_bar_get_title, pl_su);
  Xg_define_procedure(gtk_header_bar_set_subtitle, gxg_gtk_header_bar_set_subtitle_w, 2, 0, 0, H_gtk_header_bar_set_subtitle, pl_tus);
  Xg_define_procedure(gtk_header_bar_get_subtitle, gxg_gtk_header_bar_get_subtitle_w, 1, 0, 0, H_gtk_header_bar_get_subtitle, pl_su);
  Xg_define_procedure(gtk_header_bar_set_custom_title, gxg_gtk_header_bar_set_custom_title_w, 2, 0, 0, H_gtk_header_bar_set_custom_title, pl_tu);
  Xg_define_procedure(gtk_header_bar_get_custom_title, gxg_gtk_header_bar_get_custom_title_w, 1, 0, 0, H_gtk_header_bar_get_custom_title, pl_pu);
  Xg_define_procedure(gtk_header_bar_pack_start, gxg_gtk_header_bar_pack_start_w, 2, 0, 0, H_gtk_header_bar_pack_start, pl_tu);
  Xg_define_procedure(gtk_header_bar_pack_end, gxg_gtk_header_bar_pack_end_w, 2, 0, 0, H_gtk_header_bar_pack_end, pl_tu);
  Xg_define_procedure(gtk_list_box_row_new, gxg_gtk_list_box_row_new_w, 0, 0, 0, H_gtk_list_box_row_new, pl_p);
  Xg_define_procedure(gtk_list_box_row_get_header, gxg_gtk_list_box_row_get_header_w, 1, 0, 0, H_gtk_list_box_row_get_header, pl_pu);
  Xg_define_procedure(gtk_list_box_row_set_header, gxg_gtk_list_box_row_set_header_w, 2, 0, 0, H_gtk_list_box_row_set_header, pl_tu);
  Xg_define_procedure(gtk_list_box_row_changed, gxg_gtk_list_box_row_changed_w, 1, 0, 0, H_gtk_list_box_row_changed, pl_tu);
  Xg_define_procedure(gtk_list_box_get_selected_row, gxg_gtk_list_box_get_selected_row_w, 1, 0, 0, H_gtk_list_box_get_selected_row, pl_pu);
  Xg_define_procedure(gtk_list_box_get_row_at_index, gxg_gtk_list_box_get_row_at_index_w, 2, 0, 0, H_gtk_list_box_get_row_at_index, pl_pui);
  Xg_define_procedure(gtk_list_box_get_row_at_y, gxg_gtk_list_box_get_row_at_y_w, 2, 0, 0, H_gtk_list_box_get_row_at_y, pl_pui);
  Xg_define_procedure(gtk_list_box_select_row, gxg_gtk_list_box_select_row_w, 2, 0, 0, H_gtk_list_box_select_row, pl_tu);
  Xg_define_procedure(gtk_list_box_set_placeholder, gxg_gtk_list_box_set_placeholder_w, 2, 0, 0, H_gtk_list_box_set_placeholder, pl_tu);
  Xg_define_procedure(gtk_list_box_set_adjustment, gxg_gtk_list_box_set_adjustment_w, 2, 0, 0, H_gtk_list_box_set_adjustment, pl_tu);
  Xg_define_procedure(gtk_list_box_get_adjustment, gxg_gtk_list_box_get_adjustment_w, 1, 0, 0, H_gtk_list_box_get_adjustment, pl_pu);
  Xg_define_procedure(gtk_list_box_set_selection_mode, gxg_gtk_list_box_set_selection_mode_w, 2, 0, 0, H_gtk_list_box_set_selection_mode, pl_tug);
  Xg_define_procedure(gtk_list_box_get_selection_mode, gxg_gtk_list_box_get_selection_mode_w, 1, 0, 0, H_gtk_list_box_get_selection_mode, pl_gu);
  Xg_define_procedure(gtk_list_box_invalidate_filter, gxg_gtk_list_box_invalidate_filter_w, 1, 0, 0, H_gtk_list_box_invalidate_filter, pl_tu);
  Xg_define_procedure(gtk_list_box_invalidate_sort, gxg_gtk_list_box_invalidate_sort_w, 1, 0, 0, H_gtk_list_box_invalidate_sort, pl_tu);
  Xg_define_procedure(gtk_list_box_invalidate_headers, gxg_gtk_list_box_invalidate_headers_w, 1, 0, 0, H_gtk_list_box_invalidate_headers, pl_tu);
  Xg_define_procedure(gtk_list_box_set_activate_on_single_click, gxg_gtk_list_box_set_activate_on_single_click_w, 2, 0, 0, H_gtk_list_box_set_activate_on_single_click, pl_tub);
  Xg_define_procedure(gtk_list_box_get_activate_on_single_click, gxg_gtk_list_box_get_activate_on_single_click_w, 1, 0, 0, H_gtk_list_box_get_activate_on_single_click, pl_bu);
  Xg_define_procedure(gtk_list_box_drag_unhighlight_row, gxg_gtk_list_box_drag_unhighlight_row_w, 1, 0, 0, H_gtk_list_box_drag_unhighlight_row, pl_tu);
  Xg_define_procedure(gtk_list_box_drag_highlight_row, gxg_gtk_list_box_drag_highlight_row_w, 2, 0, 0, H_gtk_list_box_drag_highlight_row, pl_tu);
  Xg_define_procedure(gtk_list_box_new, gxg_gtk_list_box_new_w, 0, 0, 0, H_gtk_list_box_new, pl_p);
  Xg_define_procedure(gtk_search_bar_new, gxg_gtk_search_bar_new_w, 0, 0, 0, H_gtk_search_bar_new, pl_p);
  Xg_define_procedure(gtk_search_bar_connect_entry, gxg_gtk_search_bar_connect_entry_w, 2, 0, 0, H_gtk_search_bar_connect_entry, pl_tu);
  Xg_define_procedure(gtk_search_bar_get_search_mode, gxg_gtk_search_bar_get_search_mode_w, 1, 0, 0, H_gtk_search_bar_get_search_mode, pl_bu);
  Xg_define_procedure(gtk_search_bar_set_search_mode, gxg_gtk_search_bar_set_search_mode_w, 2, 0, 0, H_gtk_search_bar_set_search_mode, pl_tub);
  Xg_define_procedure(gtk_search_bar_handle_event, gxg_gtk_search_bar_handle_event_w, 2, 0, 0, H_gtk_search_bar_handle_event, pl_bu);
  Xg_define_procedure(gtk_file_chooser_get_current_name, gxg_gtk_file_chooser_get_current_name_w, 1, 0, 0, H_gtk_file_chooser_get_current_name, pl_su);
  Xg_define_procedure(gdk_cairo_surface_create_from_pixbuf, gxg_gdk_cairo_surface_create_from_pixbuf_w, 3, 0, 0, H_gdk_cairo_surface_create_from_pixbuf, pl_puiu);
  Xg_define_procedure(gdk_device_get_window_at_position_double, gxg_gdk_device_get_window_at_position_double_w, 1, 2, 0, H_gdk_device_get_window_at_position_double, pl_pu);
  Xg_define_procedure(gdk_window_get_scale_factor, gxg_gdk_window_get_scale_factor_w, 1, 0, 0, H_gdk_window_get_scale_factor, pl_iu);
  Xg_define_procedure(gdk_window_get_device_position_double, gxg_gdk_window_get_device_position_double_w, 2, 3, 0, H_gdk_window_get_device_position_double, pl_pu);
  Xg_define_procedure(gdk_window_create_similar_image_surface, gxg_gdk_window_create_similar_image_surface_w, 5, 0, 0, H_gdk_window_create_similar_image_surface, pl_pugi);
  Xg_define_procedure(gtk_icon_theme_lookup_icon_for_scale, gxg_gtk_icon_theme_lookup_icon_for_scale_w, 5, 0, 0, H_gtk_icon_theme_lookup_icon_for_scale, pl_pusiig);
  Xg_define_procedure(gtk_icon_theme_load_icon_for_scale, gxg_gtk_icon_theme_load_icon_for_scale_w, 5, 1, 0, H_gtk_icon_theme_load_icon_for_scale, pl_pusiigu);
  Xg_define_procedure(gtk_icon_theme_load_surface, gxg_gtk_icon_theme_load_surface_w, 6, 1, 0, H_gtk_icon_theme_load_surface, pl_pusiiugu);
  Xg_define_procedure(gtk_icon_theme_lookup_by_gicon_for_scale, gxg_gtk_icon_theme_lookup_by_gicon_for_scale_w, 5, 0, 0, H_gtk_icon_theme_lookup_by_gicon_for_scale, pl_puuiig);
  Xg_define_procedure(gtk_icon_info_get_base_scale, gxg_gtk_icon_info_get_base_scale_w, 1, 0, 0, H_gtk_icon_info_get_base_scale, pl_iu);
  Xg_define_procedure(gtk_icon_info_load_surface, gxg_gtk_icon_info_load_surface_w, 2, 1, 0, H_gtk_icon_info_load_surface, pl_pu);
  Xg_define_procedure(gtk_image_new_from_surface, gxg_gtk_image_new_from_surface_w, 1, 0, 0, H_gtk_image_new_from_surface, pl_pu);
  Xg_define_procedure(gtk_image_set_from_surface, gxg_gtk_image_set_from_surface_w, 2, 0, 0, H_gtk_image_set_from_surface, pl_tu);
  Xg_define_procedure(gtk_list_box_row_get_index, gxg_gtk_list_box_row_get_index_w, 1, 0, 0, H_gtk_list_box_row_get_index, pl_iu);
  Xg_define_procedure(gtk_widget_get_scale_factor, gxg_gtk_widget_get_scale_factor_w, 1, 0, 0, H_gtk_widget_get_scale_factor, pl_iu);
  Xg_define_procedure(gtk_window_close, gxg_gtk_window_close_w, 1, 0, 0, H_gtk_window_close, pl_tu);
  Xg_define_procedure(gtk_info_bar_set_show_close_button, gxg_gtk_info_bar_set_show_close_button_w, 2, 0, 0, H_gtk_info_bar_set_show_close_button, pl_tub);
  Xg_define_procedure(gtk_info_bar_get_show_close_button, gxg_gtk_info_bar_get_show_close_button_w, 1, 0, 0, H_gtk_info_bar_get_show_close_button, pl_bu);
  Xg_define_procedure(gtk_tree_model_rows_reordered_with_length, gxg_gtk_tree_model_rows_reordered_with_length_w, 5, 0, 0, H_gtk_tree_model_rows_reordered_with_length, pl_tuuuui);
  Xg_define_procedure(gdk_event_get_event_type, gxg_gdk_event_get_event_type_w, 1, 0, 0, H_gdk_event_get_event_type, pl_gu);
  Xg_define_procedure(gtk_entry_set_tabs, gxg_gtk_entry_set_tabs_w, 2, 0, 0, H_gtk_entry_set_tabs, pl_tu);
  Xg_define_procedure(gtk_entry_get_tabs, gxg_gtk_entry_get_tabs_w, 1, 0, 0, H_gtk_entry_get_tabs, pl_pu);
  Xg_define_procedure(gtk_list_box_prepend, gxg_gtk_list_box_prepend_w, 2, 0, 0, H_gtk_list_box_prepend, pl_tu);
  Xg_define_procedure(gtk_list_box_insert, gxg_gtk_list_box_insert_w, 3, 0, 0, H_gtk_list_box_insert, pl_tuui);
  Xg_define_procedure(gdk_window_set_opaque_region, gxg_gdk_window_set_opaque_region_w, 2, 0, 0, H_gdk_window_set_opaque_region, pl_tu);
  Xg_define_procedure(gtk_label_set_lines, gxg_gtk_label_set_lines_w, 2, 0, 0, H_gtk_label_set_lines, pl_tui);
  Xg_define_procedure(gtk_label_get_lines, gxg_gtk_label_get_lines_w, 1, 0, 0, H_gtk_label_get_lines, pl_iu);
  Xg_define_procedure(gdk_event_get_window, gxg_gdk_event_get_window_w, 1, 0, 0, H_gdk_event_get_window, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  Xg_define_procedure(gtk_flow_box_child_new, gxg_gtk_flow_box_child_new_w, 0, 0, 0, H_gtk_flow_box_child_new, pl_p);
  Xg_define_procedure(gtk_flow_box_child_get_index, gxg_gtk_flow_box_child_get_index_w, 1, 0, 0, H_gtk_flow_box_child_get_index, pl_iu);
  Xg_define_procedure(gtk_flow_box_child_is_selected, gxg_gtk_flow_box_child_is_selected_w, 1, 0, 0, H_gtk_flow_box_child_is_selected, pl_bu);
  Xg_define_procedure(gtk_flow_box_child_changed, gxg_gtk_flow_box_child_changed_w, 1, 0, 0, H_gtk_flow_box_child_changed, pl_tu);
  Xg_define_procedure(gtk_flow_box_new, gxg_gtk_flow_box_new_w, 0, 0, 0, H_gtk_flow_box_new, pl_p);
  Xg_define_procedure(gtk_flow_box_set_homogeneous, gxg_gtk_flow_box_set_homogeneous_w, 2, 0, 0, H_gtk_flow_box_set_homogeneous, pl_tub);
  Xg_define_procedure(gtk_flow_box_get_homogeneous, gxg_gtk_flow_box_get_homogeneous_w, 1, 0, 0, H_gtk_flow_box_get_homogeneous, pl_bu);
  Xg_define_procedure(gtk_flow_box_set_row_spacing, gxg_gtk_flow_box_set_row_spacing_w, 2, 0, 0, H_gtk_flow_box_set_row_spacing, pl_tui);
  Xg_define_procedure(gtk_flow_box_get_row_spacing, gxg_gtk_flow_box_get_row_spacing_w, 1, 0, 0, H_gtk_flow_box_get_row_spacing, pl_iu);
  Xg_define_procedure(gtk_flow_box_set_column_spacing, gxg_gtk_flow_box_set_column_spacing_w, 2, 0, 0, H_gtk_flow_box_set_column_spacing, pl_tui);
  Xg_define_procedure(gtk_flow_box_get_column_spacing, gxg_gtk_flow_box_get_column_spacing_w, 1, 0, 0, H_gtk_flow_box_get_column_spacing, pl_iu);
  Xg_define_procedure(gtk_flow_box_set_min_children_per_line, gxg_gtk_flow_box_set_min_children_per_line_w, 2, 0, 0, H_gtk_flow_box_set_min_children_per_line, pl_tui);
  Xg_define_procedure(gtk_flow_box_get_min_children_per_line, gxg_gtk_flow_box_get_min_children_per_line_w, 1, 0, 0, H_gtk_flow_box_get_min_children_per_line, pl_iu);
  Xg_define_procedure(gtk_flow_box_set_max_children_per_line, gxg_gtk_flow_box_set_max_children_per_line_w, 2, 0, 0, H_gtk_flow_box_set_max_children_per_line, pl_tui);
  Xg_define_procedure(gtk_flow_box_get_max_children_per_line, gxg_gtk_flow_box_get_max_children_per_line_w, 1, 0, 0, H_gtk_flow_box_get_max_children_per_line, pl_iu);
  Xg_define_procedure(gtk_flow_box_set_activate_on_single_click, gxg_gtk_flow_box_set_activate_on_single_click_w, 2, 0, 0, H_gtk_flow_box_set_activate_on_single_click, pl_tub);
  Xg_define_procedure(gtk_flow_box_get_activate_on_single_click, gxg_gtk_flow_box_get_activate_on_single_click_w, 1, 0, 0, H_gtk_flow_box_get_activate_on_single_click, pl_bu);
  Xg_define_procedure(gtk_flow_box_insert, gxg_gtk_flow_box_insert_w, 3, 0, 0, H_gtk_flow_box_insert, pl_tuui);
  Xg_define_procedure(gtk_flow_box_get_child_at_index, gxg_gtk_flow_box_get_child_at_index_w, 2, 0, 0, H_gtk_flow_box_get_child_at_index, pl_pui);
  Xg_define_procedure(gtk_flow_box_get_selected_children, gxg_gtk_flow_box_get_selected_children_w, 1, 0, 0, H_gtk_flow_box_get_selected_children, pl_pu);
  Xg_define_procedure(gtk_flow_box_select_child, gxg_gtk_flow_box_select_child_w, 2, 0, 0, H_gtk_flow_box_select_child, pl_tu);
  Xg_define_procedure(gtk_flow_box_unselect_child, gxg_gtk_flow_box_unselect_child_w, 2, 0, 0, H_gtk_flow_box_unselect_child, pl_tu);
  Xg_define_procedure(gtk_flow_box_select_all, gxg_gtk_flow_box_select_all_w, 1, 0, 0, H_gtk_flow_box_select_all, pl_tu);
  Xg_define_procedure(gtk_flow_box_unselect_all, gxg_gtk_flow_box_unselect_all_w, 1, 0, 0, H_gtk_flow_box_unselect_all, pl_tu);
  Xg_define_procedure(gtk_flow_box_set_selection_mode, gxg_gtk_flow_box_set_selection_mode_w, 2, 0, 0, H_gtk_flow_box_set_selection_mode, pl_tug);
  Xg_define_procedure(gtk_flow_box_get_selection_mode, gxg_gtk_flow_box_get_selection_mode_w, 1, 0, 0, H_gtk_flow_box_get_selection_mode, pl_gu);
  Xg_define_procedure(gtk_flow_box_set_hadjustment, gxg_gtk_flow_box_set_hadjustment_w, 2, 0, 0, H_gtk_flow_box_set_hadjustment, pl_tu);
  Xg_define_procedure(gtk_flow_box_set_vadjustment, gxg_gtk_flow_box_set_vadjustment_w, 2, 0, 0, H_gtk_flow_box_set_vadjustment, pl_tu);
  Xg_define_procedure(gtk_flow_box_invalidate_filter, gxg_gtk_flow_box_invalidate_filter_w, 1, 0, 0, H_gtk_flow_box_invalidate_filter, pl_tu);
  Xg_define_procedure(gtk_flow_box_invalidate_sort, gxg_gtk_flow_box_invalidate_sort_w, 1, 0, 0, H_gtk_flow_box_invalidate_sort, pl_tu);
  Xg_define_procedure(gtk_places_sidebar_set_local_only, gxg_gtk_places_sidebar_set_local_only_w, 2, 0, 0, H_gtk_places_sidebar_set_local_only, pl_tub);
  Xg_define_procedure(gtk_places_sidebar_get_local_only, gxg_gtk_places_sidebar_get_local_only_w, 1, 0, 0, H_gtk_places_sidebar_get_local_only, pl_bu);
  Xg_define_procedure(gtk_stack_get_transition_running, gxg_gtk_stack_get_transition_running_w, 1, 0, 0, H_gtk_stack_get_transition_running, pl_bu);
  Xg_define_procedure(gtk_widget_get_margin_start, gxg_gtk_widget_get_margin_start_w, 1, 0, 0, H_gtk_widget_get_margin_start, pl_iu);
  Xg_define_procedure(gtk_widget_set_margin_start, gxg_gtk_widget_set_margin_start_w, 2, 0, 0, H_gtk_widget_set_margin_start, pl_tui);
  Xg_define_procedure(gtk_widget_get_margin_end, gxg_gtk_widget_get_margin_end_w, 1, 0, 0, H_gtk_widget_get_margin_end, pl_iu);
  Xg_define_procedure(gtk_widget_set_margin_end, gxg_gtk_widget_set_margin_end_w, 2, 0, 0, H_gtk_widget_set_margin_end, pl_tui);
  Xg_define_procedure(gtk_accel_label_get_accel, gxg_gtk_accel_label_get_accel_w, 1, 2, 0, H_gtk_accel_label_get_accel, pl_pu);
  Xg_define_procedure(gdk_window_set_shadow_width, gxg_gdk_window_set_shadow_width_w, 5, 0, 0, H_gdk_window_set_shadow_width, pl_tui);
  Xg_define_procedure(gtk_action_bar_new, gxg_gtk_action_bar_new_w, 0, 0, 0, H_gtk_action_bar_new, pl_p);
  Xg_define_procedure(gtk_action_bar_get_center_widget, gxg_gtk_action_bar_get_center_widget_w, 1, 0, 0, H_gtk_action_bar_get_center_widget, pl_pu);
  Xg_define_procedure(gtk_action_bar_set_center_widget, gxg_gtk_action_bar_set_center_widget_w, 2, 0, 0, H_gtk_action_bar_set_center_widget, pl_tu);
  Xg_define_procedure(gtk_action_bar_pack_start, gxg_gtk_action_bar_pack_start_w, 2, 0, 0, H_gtk_action_bar_pack_start, pl_tu);
  Xg_define_procedure(gtk_action_bar_pack_end, gxg_gtk_action_bar_pack_end_w, 2, 0, 0, H_gtk_action_bar_pack_end, pl_tu);
  Xg_define_procedure(gtk_header_bar_set_has_subtitle, gxg_gtk_header_bar_set_has_subtitle_w, 2, 0, 0, H_gtk_header_bar_set_has_subtitle, pl_tub);
  Xg_define_procedure(gtk_header_bar_get_has_subtitle, gxg_gtk_header_bar_get_has_subtitle_w, 1, 0, 0, H_gtk_header_bar_get_has_subtitle, pl_bu);
  Xg_define_procedure(gtk_header_bar_set_decoration_layout, gxg_gtk_header_bar_set_decoration_layout_w, 2, 0, 0, H_gtk_header_bar_set_decoration_layout, pl_tus);
  Xg_define_procedure(gtk_header_bar_get_decoration_layout, gxg_gtk_header_bar_get_decoration_layout_w, 1, 0, 0, H_gtk_header_bar_get_decoration_layout, pl_su);
  Xg_define_procedure(gtk_icon_info_is_symbolic, gxg_gtk_icon_info_is_symbolic_w, 1, 0, 0, H_gtk_icon_info_is_symbolic, pl_bu);
  Xg_define_procedure(gtk_get_locale_direction, gxg_gtk_get_locale_direction_w, 0, 0, 0, H_gtk_get_locale_direction, pl_g);
  Xg_define_procedure(gtk_window_is_maximized, gxg_gtk_window_is_maximized_w, 1, 0, 0, H_gtk_window_is_maximized, pl_bu);
  Xg_define_procedure(gtk_dialog_get_header_bar, gxg_gtk_dialog_get_header_bar_w, 1, 0, 0, H_gtk_dialog_get_header_bar, pl_pu);
  Xg_define_procedure(gtk_popover_new, gxg_gtk_popover_new_w, 1, 0, 0, H_gtk_popover_new, pl_pu);
  Xg_define_procedure(gtk_popover_set_relative_to, gxg_gtk_popover_set_relative_to_w, 2, 0, 0, H_gtk_popover_set_relative_to, pl_tu);
  Xg_define_procedure(gtk_popover_get_relative_to, gxg_gtk_popover_get_relative_to_w, 1, 0, 0, H_gtk_popover_get_relative_to, pl_pu);
  Xg_define_procedure(gtk_popover_set_position, gxg_gtk_popover_set_position_w, 2, 0, 0, H_gtk_popover_set_position, pl_tug);
  Xg_define_procedure(gtk_popover_get_position, gxg_gtk_popover_get_position_w, 1, 0, 0, H_gtk_popover_get_position, pl_gu);
  Xg_define_procedure(gtk_popover_set_modal, gxg_gtk_popover_set_modal_w, 2, 0, 0, H_gtk_popover_set_modal, pl_tub);
  Xg_define_procedure(gtk_popover_get_modal, gxg_gtk_popover_get_modal_w, 1, 0, 0, H_gtk_popover_get_modal, pl_bu);
  Xg_define_procedure(gtk_entry_set_max_width_chars, gxg_gtk_entry_set_max_width_chars_w, 2, 0, 0, H_gtk_entry_set_max_width_chars, pl_tui);
  Xg_define_procedure(gtk_entry_get_max_width_chars, gxg_gtk_entry_get_max_width_chars_w, 1, 0, 0, H_gtk_entry_get_max_width_chars, pl_iu);
  Xg_define_procedure(gdk_device_get_last_event_window, gxg_gdk_device_get_last_event_window_w, 1, 0, 0, H_gdk_device_get_last_event_window, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  Xg_define_procedure(gtk_list_box_row_is_selected, gxg_gtk_list_box_row_is_selected_w, 1, 0, 0, H_gtk_list_box_row_is_selected, pl_bu);
  Xg_define_procedure(gtk_list_box_unselect_row, gxg_gtk_list_box_unselect_row_w, 2, 0, 0, H_gtk_list_box_unselect_row, pl_tu);
  Xg_define_procedure(gtk_list_box_select_all, gxg_gtk_list_box_select_all_w, 1, 0, 0, H_gtk_list_box_select_all, pl_tu);
  Xg_define_procedure(gtk_list_box_unselect_all, gxg_gtk_list_box_unselect_all_w, 1, 0, 0, H_gtk_list_box_unselect_all, pl_tu);
  Xg_define_procedure(gtk_places_sidebar_get_show_enter_location, gxg_gtk_places_sidebar_get_show_enter_location_w, 1, 0, 0, H_gtk_places_sidebar_get_show_enter_location, pl_bu);
  Xg_define_procedure(gtk_places_sidebar_set_show_enter_location, gxg_gtk_places_sidebar_set_show_enter_location_w, 2, 0, 0, H_gtk_places_sidebar_set_show_enter_location, pl_tub);
  Xg_define_procedure(gtk_switch_set_state, gxg_gtk_switch_set_state_w, 2, 0, 0, H_gtk_switch_set_state, pl_tub);
  Xg_define_procedure(gtk_switch_get_state, gxg_gtk_switch_get_state_w, 1, 0, 0, H_gtk_switch_get_state, pl_bu);
  Xg_define_procedure(gdk_window_show_window_menu, gxg_gdk_window_show_window_menu_w, 2, 0, 0, H_gdk_window_show_window_menu, pl_bu);
  Xg_define_procedure(gtk_widget_get_clip, gxg_gtk_widget_get_clip_w, 2, 0, 0, H_gtk_widget_get_clip, pl_tu);
  Xg_define_procedure(gtk_gesture_get_device, gxg_gtk_gesture_get_device_w, 1, 0, 0, H_gtk_gesture_get_device, pl_pu);
  Xg_define_procedure(gtk_gesture_set_state, gxg_gtk_gesture_set_state_w, 2, 0, 0, H_gtk_gesture_set_state, pl_bui);
  Xg_define_procedure(gtk_gesture_get_sequence_state, gxg_gtk_gesture_get_sequence_state_w, 2, 0, 0, H_gtk_gesture_get_sequence_state, pl_iu);
  Xg_define_procedure(gtk_gesture_set_sequence_state, gxg_gtk_gesture_set_sequence_state_w, 3, 0, 0, H_gtk_gesture_set_sequence_state, pl_buui);
  Xg_define_procedure(gtk_gesture_get_sequences, gxg_gtk_gesture_get_sequences_w, 1, 0, 0, H_gtk_gesture_get_sequences, pl_pu);
  Xg_define_procedure(gtk_gesture_get_last_updated_sequence, gxg_gtk_gesture_get_last_updated_sequence_w, 1, 0, 0, H_gtk_gesture_get_last_updated_sequence, pl_pu);
  Xg_define_procedure(gtk_gesture_handles_sequence, gxg_gtk_gesture_handles_sequence_w, 2, 0, 0, H_gtk_gesture_handles_sequence, pl_bu);
  Xg_define_procedure(gtk_gesture_get_last_event, gxg_gtk_gesture_get_last_event_w, 2, 0, 0, H_gtk_gesture_get_last_event, pl_pu);
  Xg_define_procedure(gtk_gesture_get_point, gxg_gtk_gesture_get_point_w, 2, 2, 0, H_gtk_gesture_get_point, pl_pu);
  Xg_define_procedure(gtk_gesture_get_bounding_box, gxg_gtk_gesture_get_bounding_box_w, 2, 0, 0, H_gtk_gesture_get_bounding_box, pl_bu);
  Xg_define_procedure(gtk_gesture_get_bounding_box_center, gxg_gtk_gesture_get_bounding_box_center_w, 1, 2, 0, H_gtk_gesture_get_bounding_box_center, pl_pu);
  Xg_define_procedure(gtk_gesture_is_active, gxg_gtk_gesture_is_active_w, 1, 0, 0, H_gtk_gesture_is_active, pl_bu);
  Xg_define_procedure(gtk_gesture_is_recognized, gxg_gtk_gesture_is_recognized_w, 1, 0, 0, H_gtk_gesture_is_recognized, pl_bu);
  Xg_define_procedure(gtk_gesture_group, gxg_gtk_gesture_group_w, 2, 0, 0, H_gtk_gesture_group, pl_tu);
  Xg_define_procedure(gtk_gesture_ungroup, gxg_gtk_gesture_ungroup_w, 1, 0, 0, H_gtk_gesture_ungroup, pl_tu);
  Xg_define_procedure(gtk_gesture_get_group, gxg_gtk_gesture_get_group_w, 1, 0, 0, H_gtk_gesture_get_group, pl_pu);
  Xg_define_procedure(gtk_gesture_is_grouped_with, gxg_gtk_gesture_is_grouped_with_w, 2, 0, 0, H_gtk_gesture_is_grouped_with, pl_bu);
  Xg_define_procedure(gtk_gesture_drag_new, gxg_gtk_gesture_drag_new_w, 1, 0, 0, H_gtk_gesture_drag_new, pl_pu);
  Xg_define_procedure(gtk_gesture_drag_get_start_point, gxg_gtk_gesture_drag_get_start_point_w, 1, 2, 0, H_gtk_gesture_drag_get_start_point, pl_pu);
  Xg_define_procedure(gtk_gesture_drag_get_offset, gxg_gtk_gesture_drag_get_offset_w, 1, 2, 0, H_gtk_gesture_drag_get_offset, pl_pu);
  Xg_define_procedure(gtk_gesture_long_press_new, gxg_gtk_gesture_long_press_new_w, 1, 0, 0, H_gtk_gesture_long_press_new, pl_pu);
  Xg_define_procedure(gtk_gesture_pan_new, gxg_gtk_gesture_pan_new_w, 2, 0, 0, H_gtk_gesture_pan_new, pl_pug);
  Xg_define_procedure(gtk_gesture_pan_get_orientation, gxg_gtk_gesture_pan_get_orientation_w, 1, 0, 0, H_gtk_gesture_pan_get_orientation, pl_gu);
  Xg_define_procedure(gtk_gesture_pan_set_orientation, gxg_gtk_gesture_pan_set_orientation_w, 2, 0, 0, H_gtk_gesture_pan_set_orientation, pl_tug);
  Xg_define_procedure(gtk_gesture_multi_press_new, gxg_gtk_gesture_multi_press_new_w, 1, 0, 0, H_gtk_gesture_multi_press_new, pl_pu);
  Xg_define_procedure(gtk_gesture_multi_press_set_area, gxg_gtk_gesture_multi_press_set_area_w, 2, 0, 0, H_gtk_gesture_multi_press_set_area, pl_tu);
  Xg_define_procedure(gtk_gesture_multi_press_get_area, gxg_gtk_gesture_multi_press_get_area_w, 2, 0, 0, H_gtk_gesture_multi_press_get_area, pl_bu);
  Xg_define_procedure(gtk_gesture_rotate_new, gxg_gtk_gesture_rotate_new_w, 1, 0, 0, H_gtk_gesture_rotate_new, pl_pu);
  Xg_define_procedure(gtk_gesture_rotate_get_angle_delta, gxg_gtk_gesture_rotate_get_angle_delta_w, 1, 0, 0, H_gtk_gesture_rotate_get_angle_delta, pl_du);
  Xg_define_procedure(gtk_gesture_single_get_touch_only, gxg_gtk_gesture_single_get_touch_only_w, 1, 0, 0, H_gtk_gesture_single_get_touch_only, pl_bu);
  Xg_define_procedure(gtk_gesture_single_set_touch_only, gxg_gtk_gesture_single_set_touch_only_w, 2, 0, 0, H_gtk_gesture_single_set_touch_only, pl_tub);
  Xg_define_procedure(gtk_gesture_single_get_exclusive, gxg_gtk_gesture_single_get_exclusive_w, 1, 0, 0, H_gtk_gesture_single_get_exclusive, pl_bu);
  Xg_define_procedure(gtk_gesture_single_set_exclusive, gxg_gtk_gesture_single_set_exclusive_w, 2, 0, 0, H_gtk_gesture_single_set_exclusive, pl_tub);
  Xg_define_procedure(gtk_gesture_single_get_button, gxg_gtk_gesture_single_get_button_w, 1, 0, 0, H_gtk_gesture_single_get_button, pl_iu);
  Xg_define_procedure(gtk_gesture_single_set_button, gxg_gtk_gesture_single_set_button_w, 2, 0, 0, H_gtk_gesture_single_set_button, pl_tui);
  Xg_define_procedure(gtk_gesture_single_get_current_button, gxg_gtk_gesture_single_get_current_button_w, 1, 0, 0, H_gtk_gesture_single_get_current_button, pl_iu);
  Xg_define_procedure(gtk_gesture_single_get_current_sequence, gxg_gtk_gesture_single_get_current_sequence_w, 1, 0, 0, H_gtk_gesture_single_get_current_sequence, pl_pu);
  Xg_define_procedure(gtk_gesture_swipe_new, gxg_gtk_gesture_swipe_new_w, 1, 0, 0, H_gtk_gesture_swipe_new, pl_pu);
  Xg_define_procedure(gtk_gesture_swipe_get_velocity, gxg_gtk_gesture_swipe_get_velocity_w, 1, 2, 0, H_gtk_gesture_swipe_get_velocity, pl_pu);
  Xg_define_procedure(gtk_gesture_zoom_new, gxg_gtk_gesture_zoom_new_w, 1, 0, 0, H_gtk_gesture_zoom_new, pl_pu);
  Xg_define_procedure(gtk_gesture_zoom_get_scale_delta, gxg_gtk_gesture_zoom_get_scale_delta_w, 1, 0, 0, H_gtk_gesture_zoom_get_scale_delta, pl_du);
  Xg_define_procedure(gtk_event_controller_get_widget, gxg_gtk_event_controller_get_widget_w, 1, 0, 0, H_gtk_event_controller_get_widget, pl_pu);
  Xg_define_procedure(gtk_event_controller_handle_event, gxg_gtk_event_controller_handle_event_w, 2, 0, 0, H_gtk_event_controller_handle_event, pl_bu);
  Xg_define_procedure(gtk_event_controller_reset, gxg_gtk_event_controller_reset_w, 1, 0, 0, H_gtk_event_controller_reset, pl_tu);
  Xg_define_procedure(gtk_event_controller_get_propagation_phase, gxg_gtk_event_controller_get_propagation_phase_w, 1, 0, 0, H_gtk_event_controller_get_propagation_phase, pl_gu);
  Xg_define_procedure(gtk_event_controller_set_propagation_phase, gxg_gtk_event_controller_set_propagation_phase_w, 2, 0, 0, H_gtk_event_controller_set_propagation_phase, pl_tug);
  Xg_define_procedure(gtk_icon_theme_add_resource_path, gxg_gtk_icon_theme_add_resource_path_w, 2, 0, 0, H_gtk_icon_theme_add_resource_path, pl_tus);
  Xg_define_procedure(gtk_list_box_row_set_activatable, gxg_gtk_list_box_row_set_activatable_w, 2, 0, 0, H_gtk_list_box_row_set_activatable, pl_tub);
  Xg_define_procedure(gtk_list_box_row_get_activatable, gxg_gtk_list_box_row_get_activatable_w, 1, 0, 0, H_gtk_list_box_row_get_activatable, pl_bu);
  Xg_define_procedure(gtk_list_box_row_set_selectable, gxg_gtk_list_box_row_set_selectable_w, 2, 0, 0, H_gtk_list_box_row_set_selectable, pl_tub);
  Xg_define_procedure(gtk_list_box_row_get_selectable, gxg_gtk_list_box_row_get_selectable_w, 1, 0, 0, H_gtk_list_box_row_get_selectable, pl_bu);
  Xg_define_procedure(gtk_widget_path_iter_get_state, gxg_gtk_widget_path_iter_get_state_w, 2, 0, 0, H_gtk_widget_path_iter_get_state, pl_gui);
  Xg_define_procedure(gtk_widget_path_iter_set_state, gxg_gtk_widget_path_iter_set_state_w, 3, 0, 0, H_gtk_widget_path_iter_set_state, pl_tuig);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  Xg_define_procedure(gdk_cairo_draw_from_gl, gxg_gdk_cairo_draw_from_gl_w, 0, 0, 1, H_gdk_cairo_draw_from_gl, pl_tuui);
  Xg_define_procedure(gtk_label_set_xalign, gxg_gtk_label_set_xalign_w, 2, 0, 0, H_gtk_label_set_xalign, pl_tur);
  Xg_define_procedure(gtk_label_get_xalign, gxg_gtk_label_get_xalign_w, 1, 0, 0, H_gtk_label_get_xalign, pl_du);
  Xg_define_procedure(gtk_label_set_yalign, gxg_gtk_label_set_yalign_w, 2, 0, 0, H_gtk_label_set_yalign, pl_tur);
  Xg_define_procedure(gtk_label_get_yalign, gxg_gtk_label_get_yalign_w, 1, 0, 0, H_gtk_label_get_yalign, pl_du);
  Xg_define_procedure(gtk_paned_set_wide_handle, gxg_gtk_paned_set_wide_handle_w, 2, 0, 0, H_gtk_paned_set_wide_handle, pl_tub);
  Xg_define_procedure(gtk_paned_get_wide_handle, gxg_gtk_paned_get_wide_handle_w, 1, 0, 0, H_gtk_paned_get_wide_handle, pl_bu);
  Xg_define_procedure(gtk_scrolled_window_set_overlay_scrolling, gxg_gtk_scrolled_window_set_overlay_scrolling_w, 2, 0, 0, H_gtk_scrolled_window_set_overlay_scrolling, pl_tub);
  Xg_define_procedure(gtk_scrolled_window_get_overlay_scrolling, gxg_gtk_scrolled_window_get_overlay_scrolling_w, 1, 0, 0, H_gtk_scrolled_window_get_overlay_scrolling, pl_bu);
  Xg_define_procedure(gtk_text_view_set_monospace, gxg_gtk_text_view_set_monospace_w, 2, 0, 0, H_gtk_text_view_set_monospace, pl_tub);
  Xg_define_procedure(gtk_text_view_get_monospace, gxg_gtk_text_view_get_monospace_w, 1, 0, 0, H_gtk_text_view_get_monospace, pl_bu);
  Xg_define_procedure(gtk_window_get_titlebar, gxg_gtk_window_get_titlebar_w, 1, 0, 0, H_gtk_window_get_titlebar, pl_pu);
  Xg_define_procedure(gtk_gl_area_new, gxg_gtk_gl_area_new_w, 0, 0, 0, H_gtk_gl_area_new, pl_p);
  Xg_define_procedure(gtk_gl_area_get_has_alpha, gxg_gtk_gl_area_get_has_alpha_w, 1, 0, 0, H_gtk_gl_area_get_has_alpha, pl_bu);
  Xg_define_procedure(gtk_gl_area_set_has_alpha, gxg_gtk_gl_area_set_has_alpha_w, 2, 0, 0, H_gtk_gl_area_set_has_alpha, pl_tub);
  Xg_define_procedure(gtk_gl_area_get_has_depth_buffer, gxg_gtk_gl_area_get_has_depth_buffer_w, 1, 0, 0, H_gtk_gl_area_get_has_depth_buffer, pl_bu);
  Xg_define_procedure(gtk_gl_area_set_has_depth_buffer, gxg_gtk_gl_area_set_has_depth_buffer_w, 2, 0, 0, H_gtk_gl_area_set_has_depth_buffer, pl_tub);
  Xg_define_procedure(gtk_gl_area_get_context, gxg_gtk_gl_area_get_context_w, 1, 0, 0, H_gtk_gl_area_get_context, pl_pu);
  Xg_define_procedure(gtk_gl_area_make_current, gxg_gtk_gl_area_make_current_w, 1, 0, 0, H_gtk_gl_area_make_current, pl_tu);
  Xg_define_procedure(gtk_render_check, gxg_gtk_render_check_w, 6, 0, 0, H_gtk_render_check, pl_tuur);
  Xg_define_procedure(gtk_render_option, gxg_gtk_render_option_w, 6, 0, 0, H_gtk_render_option, pl_tuur);
  Xg_define_procedure(gtk_render_arrow, gxg_gtk_render_arrow_w, 6, 0, 0, H_gtk_render_arrow, pl_tuur);
  Xg_define_procedure(gtk_render_background, gxg_gtk_render_background_w, 6, 0, 0, H_gtk_render_background, pl_tuur);
  Xg_define_procedure(gtk_render_frame, gxg_gtk_render_frame_w, 6, 0, 0, H_gtk_render_frame, pl_tuur);
  Xg_define_procedure(gtk_render_expander, gxg_gtk_render_expander_w, 6, 0, 0, H_gtk_render_expander, pl_tuur);
  Xg_define_procedure(gtk_render_focus, gxg_gtk_render_focus_w, 6, 0, 0, H_gtk_render_focus, pl_tuur);
  Xg_define_procedure(gtk_render_layout, gxg_gtk_render_layout_w, 5, 0, 0, H_gtk_render_layout, pl_tuurru);
  Xg_define_procedure(gtk_render_line, gxg_gtk_render_line_w, 6, 0, 0, H_gtk_render_line, pl_tuur);
  Xg_define_procedure(gtk_render_slider, gxg_gtk_render_slider_w, 7, 0, 0, H_gtk_render_slider, pl_tuurrrrg);
  Xg_define_procedure(gtk_render_frame_gap, gxg_gtk_render_frame_gap_w, 0, 0, 1, H_gtk_render_frame_gap, pl_tuurrrrgr);
  Xg_define_procedure(gtk_render_handle, gxg_gtk_render_handle_w, 6, 0, 0, H_gtk_render_handle, pl_tuur);
  Xg_define_procedure(gtk_render_activity, gxg_gtk_render_activity_w, 6, 0, 0, H_gtk_render_activity, pl_tuur);
  Xg_define_procedure(gtk_render_icon_surface, gxg_gtk_render_icon_surface_w, 5, 0, 0, H_gtk_render_icon_surface, pl_tuuur);
  Xg_define_procedure(gdk_gl_context_get_window, gxg_gdk_gl_context_get_window_w, 1, 0, 0, H_gdk_gl_context_get_window, pl_pu);
  Xg_define_procedure(gdk_gl_context_make_current, gxg_gdk_gl_context_make_current_w, 1, 0, 0, H_gdk_gl_context_make_current, pl_tu);
  Xg_define_procedure(gdk_gl_context_get_current, gxg_gdk_gl_context_get_current_w, 0, 0, 0, H_gdk_gl_context_get_current, pl_p);
  Xg_define_procedure(gdk_gl_context_clear_current, gxg_gdk_gl_context_clear_current_w, 0, 0, 0, H_gdk_gl_context_clear_current, pl_t);
  Xg_define_procedure(gtk_stack_set_hhomogeneous, gxg_gtk_stack_set_hhomogeneous_w, 2, 0, 0, H_gtk_stack_set_hhomogeneous, pl_tub);
  Xg_define_procedure(gtk_stack_get_hhomogeneous, gxg_gtk_stack_get_hhomogeneous_w, 1, 0, 0, H_gtk_stack_get_hhomogeneous, pl_bu);
  Xg_define_procedure(gtk_stack_set_vhomogeneous, gxg_gtk_stack_set_vhomogeneous_w, 2, 0, 0, H_gtk_stack_set_vhomogeneous, pl_tub);
  Xg_define_procedure(gtk_stack_get_vhomogeneous, gxg_gtk_stack_get_vhomogeneous_w, 1, 0, 0, H_gtk_stack_get_vhomogeneous, pl_bu);
  Xg_define_procedure(gdk_gl_context_get_display, gxg_gdk_gl_context_get_display_w, 1, 0, 0, H_gdk_gl_context_get_display, pl_pu);
  Xg_define_procedure(gtk_gl_area_get_has_stencil_buffer, gxg_gtk_gl_area_get_has_stencil_buffer_w, 1, 0, 0, H_gtk_gl_area_get_has_stencil_buffer, pl_bu);
  Xg_define_procedure(gtk_gl_area_set_has_stencil_buffer, gxg_gtk_gl_area_set_has_stencil_buffer_w, 2, 0, 0, H_gtk_gl_area_set_has_stencil_buffer, pl_tub);
  Xg_define_procedure(gtk_gl_area_get_auto_render, gxg_gtk_gl_area_get_auto_render_w, 1, 0, 0, H_gtk_gl_area_get_auto_render, pl_bu);
  Xg_define_procedure(gtk_gl_area_set_auto_render, gxg_gtk_gl_area_set_auto_render_w, 2, 0, 0, H_gtk_gl_area_set_auto_render, pl_tub);
  Xg_define_procedure(gtk_gl_area_queue_render, gxg_gtk_gl_area_queue_render_w, 1, 0, 0, H_gtk_gl_area_queue_render, pl_tu);
  Xg_define_procedure(gtk_gl_area_attach_buffers, gxg_gtk_gl_area_attach_buffers_w, 1, 0, 0, H_gtk_gl_area_attach_buffers, pl_tu);
  Xg_define_procedure(gtk_gl_area_get_error, gxg_gtk_gl_area_get_error_w, 1, 0, 0, H_gtk_gl_area_get_error, pl_pu);
  Xg_define_procedure(gtk_popover_menu_new, gxg_gtk_popover_menu_new_w, 0, 0, 0, H_gtk_popover_menu_new, pl_p);
  Xg_define_procedure(gtk_popover_menu_open_submenu, gxg_gtk_popover_menu_open_submenu_w, 2, 0, 0, H_gtk_popover_menu_open_submenu, pl_tus);
  Xg_define_procedure(gtk_entry_grab_focus_without_selecting, gxg_gtk_entry_grab_focus_without_selecting_w, 1, 0, 0, H_gtk_entry_grab_focus_without_selecting, pl_tu);
  Xg_define_procedure(gtk_scrollable_get_border, gxg_gtk_scrollable_get_border_w, 2, 0, 0, H_gtk_scrollable_get_border, pl_bu);
  Xg_define_procedure(gtk_text_buffer_insert_markup, gxg_gtk_text_buffer_insert_markup_w, 4, 0, 0, H_gtk_text_buffer_insert_markup, pl_tuusi);
  Xg_define_procedure(gdk_device_get_vendor_id, gxg_gdk_device_get_vendor_id_w, 1, 0, 0, H_gdk_device_get_vendor_id, pl_su);
  Xg_define_procedure(gdk_device_get_product_id, gxg_gdk_device_get_product_id_w, 1, 0, 0, H_gdk_device_get_product_id, pl_su);
  Xg_define_procedure(gdk_gl_context_get_shared_context, gxg_gdk_gl_context_get_shared_context_w, 1, 0, 0, H_gdk_gl_context_get_shared_context, pl_pu);
  Xg_define_procedure(gdk_gl_context_set_required_version, gxg_gdk_gl_context_set_required_version_w, 3, 0, 0, H_gdk_gl_context_set_required_version, pl_tui);
  Xg_define_procedure(gdk_gl_context_get_required_version, gxg_gdk_gl_context_get_required_version_w, 1, 2, 0, H_gdk_gl_context_get_required_version, pl_pu);
  Xg_define_procedure(gdk_gl_context_set_debug_enabled, gxg_gdk_gl_context_set_debug_enabled_w, 2, 0, 0, H_gdk_gl_context_set_debug_enabled, pl_tub);
  Xg_define_procedure(gdk_gl_context_get_debug_enabled, gxg_gdk_gl_context_get_debug_enabled_w, 1, 0, 0, H_gdk_gl_context_get_debug_enabled, pl_bu);
  Xg_define_procedure(gdk_gl_context_set_forward_compatible, gxg_gdk_gl_context_set_forward_compatible_w, 2, 0, 0, H_gdk_gl_context_set_forward_compatible, pl_tub);
  Xg_define_procedure(gdk_gl_context_get_forward_compatible, gxg_gdk_gl_context_get_forward_compatible_w, 1, 0, 0, H_gdk_gl_context_get_forward_compatible, pl_bu);
  Xg_define_procedure(gdk_gl_context_realize, gxg_gdk_gl_context_realize_w, 1, 1, 0, H_gdk_gl_context_realize, pl_pu);
  Xg_define_procedure(gtk_drag_cancel, gxg_gtk_drag_cancel_w, 1, 0, 0, H_gtk_drag_cancel, pl_tu);
  Xg_define_procedure(gtk_search_entry_handle_event, gxg_gtk_search_entry_handle_event_w, 2, 0, 0, H_gtk_search_entry_handle_event, pl_bu);
  Xg_define_procedure(gdk_gl_context_get_version, gxg_gdk_gl_context_get_version_w, 1, 2, 0, H_gdk_gl_context_get_version, pl_pu);
  Xg_define_procedure(gtk_gl_area_set_required_version, gxg_gtk_gl_area_set_required_version_w, 3, 0, 0, H_gtk_gl_area_set_required_version, pl_tui);
  Xg_define_procedure(gtk_gl_area_get_required_version, gxg_gtk_gl_area_get_required_version_w, 1, 2, 0, H_gtk_gl_area_get_required_version, pl_pu);
  Xg_define_procedure(gtk_notebook_detach_tab, gxg_gtk_notebook_detach_tab_w, 2, 0, 0, H_gtk_notebook_detach_tab, pl_tu);
  Xg_define_procedure(gtk_stack_sidebar_new, gxg_gtk_stack_sidebar_new_w, 0, 0, 0, H_gtk_stack_sidebar_new, pl_p);
  Xg_define_procedure(gtk_stack_sidebar_set_stack, gxg_gtk_stack_sidebar_set_stack_w, 2, 0, 0, H_gtk_stack_sidebar_set_stack, pl_tu);
  Xg_define_procedure(gtk_stack_sidebar_get_stack, gxg_gtk_stack_sidebar_get_stack_w, 1, 0, 0, H_gtk_stack_sidebar_get_stack, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
  Xg_define_procedure(gdk_keymap_get_scroll_lock_state, gxg_gdk_keymap_get_scroll_lock_state_w, 1, 0, 0, H_gdk_keymap_get_scroll_lock_state, pl_bu);
  Xg_define_procedure(gtk_radio_menu_item_join_group, gxg_gtk_radio_menu_item_join_group_w, 2, 0, 0, H_gtk_radio_menu_item_join_group, pl_tu);
  Xg_define_procedure(gtk_font_chooser_set_font_map, gxg_gtk_font_chooser_set_font_map_w, 2, 0, 0, H_gtk_font_chooser_set_font_map, pl_tu);
  Xg_define_procedure(gtk_font_chooser_get_font_map, gxg_gtk_font_chooser_get_font_map_w, 1, 0, 0, H_gtk_font_chooser_get_font_map, pl_pu);
  Xg_define_procedure(gtk_popover_set_default_widget, gxg_gtk_popover_set_default_widget_w, 2, 0, 0, H_gtk_popover_set_default_widget, pl_tu);
  Xg_define_procedure(gtk_popover_get_default_widget, gxg_gtk_popover_get_default_widget_w, 1, 0, 0, H_gtk_popover_get_default_widget, pl_pu);
  Xg_define_procedure(gdk_window_set_pass_through, gxg_gdk_window_set_pass_through_w, 2, 0, 0, H_gdk_window_set_pass_through, pl_tub);
  Xg_define_procedure(gdk_window_get_pass_through, gxg_gdk_window_get_pass_through_w, 1, 0, 0, H_gdk_window_get_pass_through, pl_bu);
  Xg_define_procedure(gtk_overlay_reorder_overlay, gxg_gtk_overlay_reorder_overlay_w, 3, 0, 0, H_gtk_overlay_reorder_overlay, pl_tuui);
  Xg_define_procedure(gtk_overlay_get_overlay_pass_through, gxg_gtk_overlay_get_overlay_pass_through_w, 2, 0, 0, H_gtk_overlay_get_overlay_pass_through, pl_bu);
  Xg_define_procedure(gtk_overlay_set_overlay_pass_through, gxg_gtk_overlay_set_overlay_pass_through_w, 3, 0, 0, H_gtk_overlay_set_overlay_pass_through, pl_tuub);
  Xg_define_procedure(gtk_places_sidebar_get_show_recent, gxg_gtk_places_sidebar_get_show_recent_w, 1, 0, 0, H_gtk_places_sidebar_get_show_recent, pl_bu);
  Xg_define_procedure(gtk_places_sidebar_set_show_recent, gxg_gtk_places_sidebar_set_show_recent_w, 2, 0, 0, H_gtk_places_sidebar_set_show_recent, pl_tub);
  Xg_define_procedure(gtk_places_sidebar_set_drop_targets_visible, gxg_gtk_places_sidebar_set_drop_targets_visible_w, 3, 0, 0, H_gtk_places_sidebar_set_drop_targets_visible, pl_tubu);
  Xg_define_procedure(gtk_places_sidebar_get_show_trash, gxg_gtk_places_sidebar_get_show_trash_w, 1, 0, 0, H_gtk_places_sidebar_get_show_trash, pl_bu);
  Xg_define_procedure(gtk_places_sidebar_set_show_trash, gxg_gtk_places_sidebar_set_show_trash_w, 2, 0, 0, H_gtk_places_sidebar_set_show_trash, pl_tub);
  Xg_define_procedure(gtk_places_sidebar_set_show_other_locations, gxg_gtk_places_sidebar_set_show_other_locations_w, 2, 0, 0, H_gtk_places_sidebar_set_show_other_locations, pl_tub);
  Xg_define_procedure(gtk_places_sidebar_get_show_other_locations, gxg_gtk_places_sidebar_get_show_other_locations_w, 1, 0, 0, H_gtk_places_sidebar_get_show_other_locations, pl_bu);
  Xg_define_procedure(gtk_stack_set_interpolate_size, gxg_gtk_stack_set_interpolate_size_w, 2, 0, 0, H_gtk_stack_set_interpolate_size, pl_tub);
  Xg_define_procedure(gtk_stack_get_interpolate_size, gxg_gtk_stack_get_interpolate_size_w, 1, 0, 0, H_gtk_stack_get_interpolate_size, pl_bu);
  Xg_define_procedure(gtk_widget_set_font_options, gxg_gtk_widget_set_font_options_w, 2, 0, 0, H_gtk_widget_set_font_options, pl_tu);
  Xg_define_procedure(gtk_widget_get_font_options, gxg_gtk_widget_get_font_options_w, 1, 0, 0, H_gtk_widget_get_font_options, pl_pu);
  Xg_define_procedure(gtk_widget_set_font_map, gxg_gtk_widget_set_font_map_w, 2, 0, 0, H_gtk_widget_set_font_map, pl_tu);
  Xg_define_procedure(gtk_widget_get_font_map, gxg_gtk_widget_get_font_map_w, 1, 0, 0, H_gtk_widget_get_font_map, pl_pu);
  Xg_define_procedure(gtk_text_view_set_top_margin, gxg_gtk_text_view_set_top_margin_w, 2, 0, 0, H_gtk_text_view_set_top_margin, pl_tui);
  Xg_define_procedure(gtk_text_view_get_top_margin, gxg_gtk_text_view_get_top_margin_w, 1, 0, 0, H_gtk_text_view_get_top_margin, pl_iu);
  Xg_define_procedure(gtk_text_view_set_bottom_margin, gxg_gtk_text_view_set_bottom_margin_w, 2, 0, 0, H_gtk_text_view_set_bottom_margin, pl_tui);
  Xg_define_procedure(gtk_text_view_get_bottom_margin, gxg_gtk_text_view_get_bottom_margin_w, 1, 0, 0, H_gtk_text_view_get_bottom_margin, pl_iu);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  Xg_define_procedure(gdk_gl_context_is_legacy, gxg_gdk_gl_context_is_legacy_w, 1, 0, 0, H_gdk_gl_context_is_legacy, pl_bu);
  Xg_define_procedure(gdk_rectangle_equal, gxg_gdk_rectangle_equal_w, 2, 0, 0, H_gdk_rectangle_equal, pl_bu);
  Xg_define_procedure(gtk_application_window_set_help_overlay, gxg_gtk_application_window_set_help_overlay_w, 2, 0, 0, H_gtk_application_window_set_help_overlay, pl_tu);
  Xg_define_procedure(gtk_settings_reset_property, gxg_gtk_settings_reset_property_w, 2, 0, 0, H_gtk_settings_reset_property, pl_tus);
  Xg_define_procedure(gtk_text_tag_changed, gxg_gtk_text_tag_changed_w, 2, 0, 0, H_gtk_text_tag_changed, pl_tub);
  Xg_define_procedure(gtk_widget_path_iter_get_object_name, gxg_gtk_widget_path_iter_get_object_name_w, 2, 0, 0, H_gtk_widget_path_iter_get_object_name, pl_sui);
  Xg_define_procedure(gtk_widget_path_iter_set_object_name, gxg_gtk_widget_path_iter_set_object_name_w, 3, 0, 0, H_gtk_widget_path_iter_set_object_name, pl_tuis);
  Xg_define_procedure(gtk_widget_queue_allocate, gxg_gtk_widget_queue_allocate_w, 1, 0, 0, H_gtk_widget_queue_allocate, pl_tu);
  Xg_define_procedure(gtk_widget_set_focus_on_click, gxg_gtk_widget_set_focus_on_click_w, 2, 0, 0, H_gtk_widget_set_focus_on_click, pl_tub);
  Xg_define_procedure(gtk_widget_get_focus_on_click, gxg_gtk_widget_get_focus_on_click_w, 1, 0, 0, H_gtk_widget_get_focus_on_click, pl_bu);
  Xg_define_procedure(gdk_drag_context_get_drag_window, gxg_gdk_drag_context_get_drag_window_w, 1, 0, 0, H_gdk_drag_context_get_drag_window, pl_pu);
  Xg_define_procedure(gtk_popover_set_constrain_to, gxg_gtk_popover_set_constrain_to_w, 2, 0, 0, H_gtk_popover_set_constrain_to, pl_tug);
  Xg_define_procedure(gtk_popover_get_constrain_to, gxg_gtk_popover_get_constrain_to_w, 1, 0, 0, H_gtk_popover_get_constrain_to, pl_gu);
  Xg_define_procedure(gtk_text_iter_starts_tag, gxg_gtk_text_iter_starts_tag_w, 2, 0, 0, H_gtk_text_iter_starts_tag, pl_bu);
  Xg_define_procedure(gdk_device_get_seat, gxg_gdk_device_get_seat_w, 1, 0, 0, H_gdk_device_get_seat, pl_pu);
  Xg_define_procedure(gdk_display_get_default_seat, gxg_gdk_display_get_default_seat_w, 1, 0, 0, H_gdk_display_get_default_seat, pl_pu);
  Xg_define_procedure(gdk_display_list_seats, gxg_gdk_display_list_seats_w, 1, 0, 0, H_gdk_display_list_seats, pl_pu);
  Xg_define_procedure(gdk_drag_drop_done, gxg_gdk_drag_drop_done_w, 2, 0, 0, H_gdk_drag_drop_done, pl_tub);
  Xg_define_procedure(gdk_drag_context_set_hotspot, gxg_gdk_drag_context_set_hotspot_w, 3, 0, 0, H_gdk_drag_context_set_hotspot, pl_tui);
  Xg_define_procedure(gdk_seat_grab, gxg_gdk_seat_grab_w, 0, 0, 1, H_gdk_seat_grab, pl_guugbuut);
  Xg_define_procedure(gdk_seat_ungrab, gxg_gdk_seat_ungrab_w, 1, 0, 0, H_gdk_seat_ungrab, pl_tu);
  Xg_define_procedure(gdk_seat_get_display, gxg_gdk_seat_get_display_w, 1, 0, 0, H_gdk_seat_get_display, pl_pu);
  Xg_define_procedure(gdk_seat_get_capabilities, gxg_gdk_seat_get_capabilities_w, 1, 0, 0, H_gdk_seat_get_capabilities, pl_gu);
  Xg_define_procedure(gdk_seat_get_slaves, gxg_gdk_seat_get_slaves_w, 2, 0, 0, H_gdk_seat_get_slaves, pl_pug);
  Xg_define_procedure(gdk_seat_get_pointer, gxg_gdk_seat_get_pointer_w, 1, 0, 0, H_gdk_seat_get_pointer, pl_pu);
  Xg_define_procedure(gdk_seat_get_keyboard, gxg_gdk_seat_get_keyboard_w, 1, 0, 0, H_gdk_seat_get_keyboard, pl_pu);
  Xg_define_procedure(gdk_event_is_scroll_stop_event, gxg_gdk_event_is_scroll_stop_event_w, 1, 0, 0, H_gdk_event_is_scroll_stop_event, pl_bu);
  Xg_define_procedure(gtk_text_view_reset_cursor_blink, gxg_gtk_text_view_reset_cursor_blink_w, 1, 0, 0, H_gtk_text_view_reset_cursor_blink, pl_tu);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  Xg_define_procedure(gdk_device_get_axes, gxg_gdk_device_get_axes_w, 1, 0, 0, H_gdk_device_get_axes, pl_gu);
  Xg_define_procedure(gdk_event_get_device_tool, gxg_gdk_event_get_device_tool_w, 1, 0, 0, H_gdk_event_get_device_tool, pl_pu);
  Xg_define_procedure(gdk_event_set_device_tool, gxg_gdk_event_set_device_tool_w, 2, 0, 0, H_gdk_event_set_device_tool, pl_tu);
  Xg_define_procedure(gdk_event_get_scancode, gxg_gdk_event_get_scancode_w, 1, 0, 0, H_gdk_event_get_scancode, pl_iu);
  Xg_define_procedure(gdk_gl_context_set_use_es, gxg_gdk_gl_context_set_use_es_w, 2, 0, 0, H_gdk_gl_context_set_use_es, pl_tui);
  Xg_define_procedure(gdk_gl_context_get_use_es, gxg_gdk_gl_context_get_use_es_w, 1, 0, 0, H_gdk_gl_context_get_use_es, pl_bu);
  Xg_define_procedure(gtk_gl_area_set_use_es, gxg_gtk_gl_area_set_use_es_w, 2, 0, 0, H_gtk_gl_area_set_use_es, pl_tub);
  Xg_define_procedure(gtk_gl_area_get_use_es, gxg_gtk_gl_area_get_use_es_w, 1, 0, 0, H_gtk_gl_area_get_use_es, pl_bu);
  Xg_define_procedure(gdk_device_tool_get_serial, gxg_gdk_device_tool_get_serial_w, 1, 0, 0, H_gdk_device_tool_get_serial, pl_iu);
  Xg_define_procedure(gdk_display_get_n_monitors, gxg_gdk_display_get_n_monitors_w, 1, 0, 0, H_gdk_display_get_n_monitors, pl_iu);
  Xg_define_procedure(gdk_display_get_monitor, gxg_gdk_display_get_monitor_w, 2, 0, 0, H_gdk_display_get_monitor, pl_pui);
  Xg_define_procedure(gdk_display_get_primary_monitor, gxg_gdk_display_get_primary_monitor_w, 1, 0, 0, H_gdk_display_get_primary_monitor, pl_pu);
  Xg_define_procedure(gdk_display_get_monitor_at_point, gxg_gdk_display_get_monitor_at_point_w, 3, 0, 0, H_gdk_display_get_monitor_at_point, pl_pui);
  Xg_define_procedure(gdk_display_get_monitor_at_window, gxg_gdk_display_get_monitor_at_window_w, 2, 0, 0, H_gdk_display_get_monitor_at_window, pl_pu);
  Xg_define_procedure(gdk_event_get_pointer_emulated, gxg_gdk_event_get_pointer_emulated_w, 1, 0, 0, H_gdk_event_get_pointer_emulated, pl_bu);
  Xg_define_procedure(gtk_menu_place_on_monitor, gxg_gtk_menu_place_on_monitor_w, 2, 0, 0, H_gtk_menu_place_on_monitor, pl_tu);
  Xg_define_procedure(gdk_monitor_get_display, gxg_gdk_monitor_get_display_w, 1, 0, 0, H_gdk_monitor_get_display, pl_pu);
  Xg_define_procedure(gdk_monitor_get_geometry, gxg_gdk_monitor_get_geometry_w, 2, 0, 0, H_gdk_monitor_get_geometry, pl_tu);
  Xg_define_procedure(gdk_monitor_get_workarea, gxg_gdk_monitor_get_workarea_w, 2, 0, 0, H_gdk_monitor_get_workarea, pl_tu);
  Xg_define_procedure(gdk_monitor_get_width_mm, gxg_gdk_monitor_get_width_mm_w, 1, 0, 0, H_gdk_monitor_get_width_mm, pl_iu);
  Xg_define_procedure(gdk_monitor_get_height_mm, gxg_gdk_monitor_get_height_mm_w, 1, 0, 0, H_gdk_monitor_get_height_mm, pl_iu);
  Xg_define_procedure(gdk_monitor_get_manufacturer, gxg_gdk_monitor_get_manufacturer_w, 1, 0, 0, H_gdk_monitor_get_manufacturer, pl_su);
  Xg_define_procedure(gdk_monitor_get_model, gxg_gdk_monitor_get_model_w, 1, 0, 0, H_gdk_monitor_get_model, pl_su);
  Xg_define_procedure(gdk_monitor_get_scale_factor, gxg_gdk_monitor_get_scale_factor_w, 1, 0, 0, H_gdk_monitor_get_scale_factor, pl_iu);
  Xg_define_procedure(gdk_monitor_get_refresh_rate, gxg_gdk_monitor_get_refresh_rate_w, 1, 0, 0, H_gdk_monitor_get_refresh_rate, pl_iu);
  Xg_define_procedure(gdk_monitor_get_subpixel_layout, gxg_gdk_monitor_get_subpixel_layout_w, 1, 0, 0, H_gdk_monitor_get_subpixel_layout, pl_gu);
  Xg_define_procedure(gdk_monitor_is_primary, gxg_gdk_monitor_is_primary_w, 1, 0, 0, H_gdk_monitor_is_primary, pl_bu);
  Xg_define_procedure(gdk_drawing_context_get_window, gxg_gdk_drawing_context_get_window_w, 1, 0, 0, H_gdk_drawing_context_get_window, pl_pu);
  Xg_define_procedure(gdk_drawing_context_get_clip, gxg_gdk_drawing_context_get_clip_w, 1, 0, 0, H_gdk_drawing_context_get_clip, pl_pu);
  Xg_define_procedure(gdk_drawing_context_is_valid, gxg_gdk_drawing_context_is_valid_w, 1, 0, 0, H_gdk_drawing_context_is_valid, pl_bu);
  Xg_define_procedure(gdk_drawing_context_get_cairo_context, gxg_gdk_drawing_context_get_cairo_context_w, 1, 0, 0, H_gdk_drawing_context_get_cairo_context, pl_pu);
  Xg_define_procedure(gdk_cairo_get_drawing_context, gxg_gdk_cairo_get_drawing_context_w, 1, 0, 0, H_gdk_cairo_get_drawing_context, pl_pu);
  Xg_define_procedure(gtk_scrolled_window_set_max_content_width, gxg_gtk_scrolled_window_set_max_content_width_w, 2, 0, 0, H_gtk_scrolled_window_set_max_content_width, pl_tui);
  Xg_define_procedure(gtk_scrolled_window_get_max_content_width, gxg_gtk_scrolled_window_get_max_content_width_w, 1, 0, 0, H_gtk_scrolled_window_get_max_content_width, pl_iu);
  Xg_define_procedure(gtk_scrolled_window_set_max_content_height, gxg_gtk_scrolled_window_set_max_content_height_w, 2, 0, 0, H_gtk_scrolled_window_set_max_content_height, pl_tui);
  Xg_define_procedure(gtk_scrolled_window_get_max_content_height, gxg_gtk_scrolled_window_get_max_content_height_w, 1, 0, 0, H_gtk_scrolled_window_get_max_content_height, pl_iu);
  Xg_define_procedure(gtk_file_chooser_add_choice, gxg_gtk_file_chooser_add_choice_w, 5, 0, 0, H_gtk_file_chooser_add_choice, pl_tussu);
  Xg_define_procedure(gtk_file_chooser_remove_choice, gxg_gtk_file_chooser_remove_choice_w, 2, 0, 0, H_gtk_file_chooser_remove_choice, pl_tus);
  Xg_define_procedure(gtk_file_chooser_set_choice, gxg_gtk_file_chooser_set_choice_w, 3, 0, 0, H_gtk_file_chooser_set_choice, pl_tus);
  Xg_define_procedure(gtk_file_chooser_get_choice, gxg_gtk_file_chooser_get_choice_w, 2, 0, 0, H_gtk_file_chooser_get_choice, pl_sus);
  Xg_define_procedure(gdk_device_pad_get_n_groups, gxg_gdk_device_pad_get_n_groups_w, 1, 0, 0, H_gdk_device_pad_get_n_groups, pl_iu);
  Xg_define_procedure(gdk_device_pad_get_group_n_modes, gxg_gdk_device_pad_get_group_n_modes_w, 2, 0, 0, H_gdk_device_pad_get_group_n_modes, pl_iui);
  Xg_define_procedure(gdk_device_pad_get_n_features, gxg_gdk_device_pad_get_n_features_w, 2, 0, 0, H_gdk_device_pad_get_n_features, pl_iug);
  Xg_define_procedure(gdk_device_pad_get_feature_group, gxg_gdk_device_pad_get_feature_group_w, 3, 0, 0, H_gdk_device_pad_get_feature_group, pl_iugi);
  Xg_define_procedure(gtk_menu_popup_at_rect, gxg_gtk_menu_popup_at_rect_w, 6, 0, 0, H_gtk_menu_popup_at_rect, pl_tuuuggu);
  Xg_define_procedure(gtk_menu_popup_at_widget, gxg_gtk_menu_popup_at_widget_w, 5, 0, 0, H_gtk_menu_popup_at_widget, pl_tuuggu);
  Xg_define_procedure(gtk_menu_popup_at_pointer, gxg_gtk_menu_popup_at_pointer_w, 2, 0, 0, H_gtk_menu_popup_at_pointer, pl_tu);
  Xg_define_procedure(gtk_pad_controller_new, gxg_gtk_pad_controller_new_w, 3, 0, 0, H_gtk_pad_controller_new, pl_pu);
  Xg_define_procedure(gtk_pad_controller_set_action_entries, gxg_gtk_pad_controller_set_action_entries_w, 3, 0, 0, H_gtk_pad_controller_set_action_entries, pl_tuui);
  Xg_define_procedure(gtk_pad_controller_set_action, gxg_gtk_pad_controller_set_action_w, 6, 0, 0, H_gtk_pad_controller_set_action, pl_tugiis);
  Xg_define_procedure(gtk_popover_popup, gxg_gtk_popover_popup_w, 1, 0, 0, H_gtk_popover_popup, pl_tu);
  Xg_define_procedure(gtk_popover_popdown, gxg_gtk_popover_popdown_w, 1, 0, 0, H_gtk_popover_popdown, pl_tu);
  Xg_define_procedure(gtk_shortcut_label_new, gxg_gtk_shortcut_label_new_w, 1, 0, 0, H_gtk_shortcut_label_new, pl_ps);
  Xg_define_procedure(gtk_shortcut_label_get_accelerator, gxg_gtk_shortcut_label_get_accelerator_w, 1, 0, 0, H_gtk_shortcut_label_get_accelerator, pl_su);
  Xg_define_procedure(gtk_shortcut_label_set_accelerator, gxg_gtk_shortcut_label_set_accelerator_w, 2, 0, 0, H_gtk_shortcut_label_set_accelerator, pl_tus);
  Xg_define_procedure(gtk_shortcut_label_get_disabled_text, gxg_gtk_shortcut_label_get_disabled_text_w, 1, 0, 0, H_gtk_shortcut_label_get_disabled_text, pl_su);
  Xg_define_procedure(gtk_shortcut_label_set_disabled_text, gxg_gtk_shortcut_label_set_disabled_text_w, 2, 0, 0, H_gtk_shortcut_label_set_disabled_text, pl_tus);
  Xg_define_procedure(gdk_window_end_draw_frame, gxg_gdk_window_end_draw_frame_w, 2, 0, 0, H_gdk_window_end_draw_frame, pl_tu);
  Xg_define_procedure(gtk_scrolled_window_set_propagate_natural_width, gxg_gtk_scrolled_window_set_propagate_natural_width_w, 2, 0, 0, H_gtk_scrolled_window_set_propagate_natural_width, pl_tub);
  Xg_define_procedure(gtk_scrolled_window_get_propagate_natural_width, gxg_gtk_scrolled_window_get_propagate_natural_width_w, 1, 0, 0, H_gtk_scrolled_window_get_propagate_natural_width, pl_bu);
  Xg_define_procedure(gtk_scrolled_window_set_propagate_natural_height, gxg_gtk_scrolled_window_set_propagate_natural_height_w, 2, 0, 0, H_gtk_scrolled_window_set_propagate_natural_height, pl_tub);
  Xg_define_procedure(gtk_scrolled_window_get_propagate_natural_height, gxg_gtk_scrolled_window_get_propagate_natural_height_w, 1, 0, 0, H_gtk_scrolled_window_get_propagate_natural_height, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  Xg_define_procedure(gdk_display_is_composited, gxg_gdk_display_is_composited_w, 1, 0, 0, H_gdk_display_is_composited, pl_bu);
  Xg_define_procedure(gdk_display_is_rgba, gxg_gdk_display_is_rgba_w, 1, 0, 0, H_gdk_display_is_rgba, pl_bu);
  Xg_define_procedure(gdk_window_new_toplevel, gxg_gdk_window_new_toplevel_w, 4, 0, 0, H_gdk_window_new_toplevel, pl_pui);
  Xg_define_procedure(gdk_window_new_popup, gxg_gdk_window_new_popup_w, 3, 0, 0, H_gdk_window_new_popup, pl_puiu);
  Xg_define_procedure(gdk_window_new_temp, gxg_gdk_window_new_temp_w, 1, 0, 0, H_gdk_window_new_temp, pl_pu);
  Xg_define_procedure(gdk_window_new_child, gxg_gdk_window_new_child_w, 3, 0, 0, H_gdk_window_new_child, pl_puiu);
  Xg_define_procedure(gtk_button_set_icon_name, gxg_gtk_button_set_icon_name_w, 2, 0, 0, H_gtk_button_set_icon_name, pl_tus);
  Xg_define_procedure(gtk_button_get_icon_name, gxg_gtk_button_get_icon_name_w, 1, 0, 0, H_gtk_button_get_icon_name, pl_su);
  Xg_define_procedure(gtk_drawing_area_set_content_width, gxg_gtk_drawing_area_set_content_width_w, 2, 0, 0, H_gtk_drawing_area_set_content_width, pl_tui);
  Xg_define_procedure(gtk_drawing_area_get_content_width, gxg_gtk_drawing_area_get_content_width_w, 1, 0, 0, H_gtk_drawing_area_get_content_width, pl_iu);
  Xg_define_procedure(gtk_drawing_area_set_content_height, gxg_gtk_drawing_area_set_content_height_w, 2, 0, 0, H_gtk_drawing_area_set_content_height, pl_tui);
  Xg_define_procedure(gtk_drawing_area_get_content_height, gxg_gtk_drawing_area_get_content_height_w, 1, 0, 0, H_gtk_drawing_area_get_content_height, pl_iu);
  Xg_define_procedure(gtk_drawing_area_set_draw_func, gxg_gtk_drawing_area_set_draw_func_w, 4, 0, 0, H_gtk_drawing_area_set_draw_func, pl_tut);
  Xg_define_procedure(gdk_drawing_context_get_paint_context, gxg_gdk_drawing_context_get_paint_context_w, 1, 0, 0, H_gdk_drawing_context_get_paint_context, pl_pu);
  Xg_define_procedure(gdk_gl_context_get_damage, gxg_gdk_gl_context_get_damage_w, 1, 0, 0, H_gdk_gl_context_get_damage, pl_pu);
  Xg_define_procedure(gdk_rgba_is_clear, gxg_gdk_rgba_is_clear_w, 1, 0, 0, H_gdk_rgba_is_clear, pl_bu);
  Xg_define_procedure(gdk_rgba_is_opaque, gxg_gdk_rgba_is_opaque_w, 1, 0, 0, H_gdk_rgba_is_opaque, pl_bu);
  Xg_define_procedure(gdk_window_begin_draw_frame, gxg_gdk_window_begin_draw_frame_w, 3, 0, 0, H_gdk_window_begin_draw_frame, pl_pu);
  Xg_define_procedure(gtk_flow_box_get_child_at_pos, gxg_gtk_flow_box_get_child_at_pos_w, 3, 0, 0, H_gtk_flow_box_get_child_at_pos, pl_pui);
  Xg_define_procedure(gtk_about_dialog_get_system_information, gxg_gtk_about_dialog_get_system_information_w, 1, 0, 0, H_gtk_about_dialog_get_system_information, pl_su);
  Xg_define_procedure(gtk_about_dialog_set_system_information, gxg_gtk_about_dialog_set_system_information_w, 2, 0, 0, H_gtk_about_dialog_set_system_information, pl_tus);
  Xg_define_procedure(gtk_action_bar_set_revealed, gxg_gtk_action_bar_set_revealed_w, 2, 0, 0, H_gtk_action_bar_set_revealed, pl_tub);
  Xg_define_procedure(gtk_action_bar_get_revealed, gxg_gtk_action_bar_get_revealed_w, 1, 0, 0, H_gtk_action_bar_get_revealed, pl_bu);
  Xg_define_procedure(gtk_check_button_set_draw_indicator, gxg_gtk_check_button_set_draw_indicator_w, 2, 0, 0, H_gtk_check_button_set_draw_indicator, pl_tub);
  Xg_define_procedure(gtk_check_button_get_draw_indicator, gxg_gtk_check_button_get_draw_indicator_w, 1, 0, 0, H_gtk_check_button_get_draw_indicator, pl_bu);
  Xg_define_procedure(gtk_check_button_set_inconsistent, gxg_gtk_check_button_set_inconsistent_w, 2, 0, 0, H_gtk_check_button_set_inconsistent, pl_tub);
  Xg_define_procedure(gtk_check_button_get_inconsistent, gxg_gtk_check_button_get_inconsistent_w, 1, 0, 0, H_gtk_check_button_get_inconsistent, pl_bu);
  Xg_define_procedure(gtk_info_bar_set_revealed, gxg_gtk_info_bar_set_revealed_w, 2, 0, 0, H_gtk_info_bar_set_revealed, pl_tub);
  Xg_define_procedure(gtk_info_bar_get_revealed, gxg_gtk_info_bar_get_revealed_w, 1, 0, 0, H_gtk_info_bar_get_revealed, pl_bu);
  Xg_define_procedure(gtk_widget_get_first_child, gxg_gtk_widget_get_first_child_w, 1, 0, 0, H_gtk_widget_get_first_child, pl_pu);
  Xg_define_procedure(gtk_widget_get_last_child, gxg_gtk_widget_get_last_child_w, 1, 0, 0, H_gtk_widget_get_last_child, pl_pu);
  Xg_define_procedure(gtk_widget_get_next_sibling, gxg_gtk_widget_get_next_sibling_w, 1, 0, 0, H_gtk_widget_get_next_sibling, pl_pu);
  Xg_define_procedure(gtk_widget_get_prev_sibling, gxg_gtk_widget_get_prev_sibling_w, 1, 0, 0, H_gtk_widget_get_prev_sibling, pl_pu);
  Xg_define_procedure(gtk_widget_set_focus_child, gxg_gtk_widget_set_focus_child_w, 2, 0, 0, H_gtk_widget_set_focus_child, pl_tu);
  Xg_define_procedure(gtk_show_uri_on_window, gxg_gtk_show_uri_on_window_w, 3, 1, 0, H_gtk_show_uri_on_window, pl_pusiu);
  Xg_define_procedure(gtk_box_pack_start, gxg_gtk_box_pack_start_w, 2, 0, 0, H_gtk_box_pack_start, pl_tu);
  Xg_define_procedure(gtk_box_pack_end, gxg_gtk_box_pack_end_w, 2, 0, 0, H_gtk_box_pack_end, pl_tu);
  Xg_define_procedure(gtk_widget_insert_after, gxg_gtk_widget_insert_after_w, 3, 0, 0, H_gtk_widget_insert_after, pl_tu);
  Xg_define_procedure(gtk_widget_insert_before, gxg_gtk_widget_insert_before_w, 3, 0, 0, H_gtk_widget_insert_before, pl_tu);
  Xg_define_procedure(gtk_center_box_new, gxg_gtk_center_box_new_w, 0, 0, 0, H_gtk_center_box_new, pl_p);
  Xg_define_procedure(gtk_center_box_set_start_widget, gxg_gtk_center_box_set_start_widget_w, 2, 0, 0, H_gtk_center_box_set_start_widget, pl_tu);
  Xg_define_procedure(gtk_center_box_set_center_widget, gxg_gtk_center_box_set_center_widget_w, 2, 0, 0, H_gtk_center_box_set_center_widget, pl_tu);
  Xg_define_procedure(gtk_center_box_set_end_widget, gxg_gtk_center_box_set_end_widget_w, 2, 0, 0, H_gtk_center_box_set_end_widget, pl_tu);
  Xg_define_procedure(gtk_center_box_get_start_widget, gxg_gtk_center_box_get_start_widget_w, 1, 0, 0, H_gtk_center_box_get_start_widget, pl_pu);
  Xg_define_procedure(gtk_center_box_get_center_widget, gxg_gtk_center_box_get_center_widget_w, 1, 0, 0, H_gtk_center_box_get_center_widget, pl_pu);
  Xg_define_procedure(gtk_center_box_get_end_widget, gxg_gtk_center_box_get_end_widget_w, 1, 0, 0, H_gtk_center_box_get_end_widget, pl_pu);
  Xg_define_procedure(gtk_center_box_set_baseline_position, gxg_gtk_center_box_set_baseline_position_w, 2, 0, 0, H_gtk_center_box_set_baseline_position, pl_tug);
  Xg_define_procedure(gtk_center_box_get_baseline_position, gxg_gtk_center_box_get_baseline_position_w, 1, 0, 0, H_gtk_center_box_get_baseline_position, pl_gu);
  Xg_define_procedure(gdk_event_set_coords, gxg_gdk_event_set_coords_w, 3, 0, 0, H_gdk_event_set_coords, pl_tur);
  Xg_define_procedure(gdk_event_set_user_data, gxg_gdk_event_set_user_data_w, 2, 0, 0, H_gdk_event_set_user_data, pl_tu);
  Xg_define_procedure(gdk_rectangle_contains_point, gxg_gdk_rectangle_contains_point_w, 3, 0, 0, H_gdk_rectangle_contains_point, pl_bui);
  Xg_define_procedure(gtk_get_event_target, gxg_gtk_get_event_target_w, 1, 0, 0, H_gtk_get_event_target, pl_pu);
  Xg_define_procedure(gtk_accel_label_set_label, gxg_gtk_accel_label_set_label_w, 2, 0, 0, H_gtk_accel_label_set_label, pl_tus);
  Xg_define_procedure(gtk_accel_label_get_label, gxg_gtk_accel_label_get_label_w, 1, 0, 0, H_gtk_accel_label_get_label, pl_su);
  Xg_define_procedure(gtk_accel_label_set_use_underline, gxg_gtk_accel_label_set_use_underline_w, 2, 0, 0, H_gtk_accel_label_set_use_underline, pl_tub);
  Xg_define_procedure(gtk_accel_label_get_use_underline, gxg_gtk_accel_label_get_use_underline_w, 1, 0, 0, H_gtk_accel_label_get_use_underline, pl_bu);
  Xg_define_procedure(gtk_scrollbar_set_adjustment, gxg_gtk_scrollbar_set_adjustment_w, 2, 0, 0, H_gtk_scrollbar_set_adjustment, pl_tu);
  Xg_define_procedure(gtk_scrollbar_get_adjustment, gxg_gtk_scrollbar_get_adjustment_w, 1, 0, 0, H_gtk_scrollbar_get_adjustment, pl_pu);
  Xg_define_procedure(gtk_scrollbar_get_wheel_delta, gxg_gtk_scrollbar_get_wheel_delta_w, 2, 0, 0, H_gtk_scrollbar_get_wheel_delta, pl_du);
  Xg_define_procedure(gtk_spin_button_get_text, gxg_gtk_spin_button_get_text_w, 1, 0, 0, H_gtk_spin_button_get_text, pl_su);
  Xg_define_procedure(gtk_spin_button_set_text, gxg_gtk_spin_button_set_text_w, 2, 0, 0, H_gtk_spin_button_set_text, pl_tus);
  Xg_define_procedure(gtk_spin_button_get_max_width_chars, gxg_gtk_spin_button_get_max_width_chars_w, 1, 0, 0, H_gtk_spin_button_get_max_width_chars, pl_iu);
  Xg_define_procedure(gtk_spin_button_set_max_width_chars, gxg_gtk_spin_button_set_max_width_chars_w, 2, 0, 0, H_gtk_spin_button_set_max_width_chars, pl_tui);
  Xg_define_procedure(gtk_spin_button_get_width_chars, gxg_gtk_spin_button_get_width_chars_w, 1, 0, 0, H_gtk_spin_button_get_width_chars, pl_iu);
  Xg_define_procedure(gtk_spin_button_set_width_chars, gxg_gtk_spin_button_set_width_chars_w, 2, 0, 0, H_gtk_spin_button_set_width_chars, pl_tui);
  Xg_define_procedure(gtk_widget_size_allocate, gxg_gtk_widget_size_allocate_w, 4, 0, 0, H_gtk_widget_size_allocate, pl_tuuiu);
  Xg_define_procedure(gtk_style_context_new, gxg_gtk_style_context_new_w, 0, 0, 0, H_gtk_style_context_new, pl_p);
  Xg_define_procedure(gtk_style_context_add_provider, gxg_gtk_style_context_add_provider_w, 3, 0, 0, H_gtk_style_context_add_provider, pl_tuui);
  Xg_define_procedure(gtk_style_context_save, gxg_gtk_style_context_save_w, 1, 0, 0, H_gtk_style_context_save, pl_tu);
  Xg_define_procedure(gtk_style_context_restore, gxg_gtk_style_context_restore_w, 1, 0, 0, H_gtk_style_context_restore, pl_tu);
  Xg_define_procedure(gtk_style_context_get_section, gxg_gtk_style_context_get_section_w, 2, 0, 0, H_gtk_style_context_get_section, pl_pus);
  Xg_define_procedure(gtk_style_context_get_property, gxg_gtk_style_context_get_property_w, 3, 0, 0, H_gtk_style_context_get_property, pl_tusu);
  Xg_define_procedure(gtk_style_context_set_state, gxg_gtk_style_context_set_state_w, 2, 0, 0, H_gtk_style_context_set_state, pl_tug);
  Xg_define_procedure(gtk_style_context_get_state, gxg_gtk_style_context_get_state_w, 1, 0, 0, H_gtk_style_context_get_state, pl_gu);
  Xg_define_procedure(gtk_style_context_set_scale, gxg_gtk_style_context_set_scale_w, 2, 0, 0, H_gtk_style_context_set_scale, pl_tui);
  Xg_define_procedure(gtk_style_context_get_scale, gxg_gtk_style_context_get_scale_w, 1, 0, 0, H_gtk_style_context_get_scale, pl_iu);
  Xg_define_procedure(gtk_style_context_set_path, gxg_gtk_style_context_set_path_w, 2, 0, 0, H_gtk_style_context_set_path, pl_tu);
  Xg_define_procedure(gtk_style_context_get_path, gxg_gtk_style_context_get_path_w, 1, 0, 0, H_gtk_style_context_get_path, pl_pu);
  Xg_define_procedure(gtk_style_context_set_parent, gxg_gtk_style_context_set_parent_w, 2, 0, 0, H_gtk_style_context_set_parent, pl_tu);
  Xg_define_procedure(gtk_style_context_get_parent, gxg_gtk_style_context_get_parent_w, 1, 0, 0, H_gtk_style_context_get_parent, pl_pu);
  Xg_define_procedure(gtk_style_context_list_classes, gxg_gtk_style_context_list_classes_w, 1, 0, 0, H_gtk_style_context_list_classes, pl_pu);
  Xg_define_procedure(gtk_style_context_add_class, gxg_gtk_style_context_add_class_w, 2, 0, 0, H_gtk_style_context_add_class, pl_tus);
  Xg_define_procedure(gtk_style_context_remove_class, gxg_gtk_style_context_remove_class_w, 2, 0, 0, H_gtk_style_context_remove_class, pl_tus);
  Xg_define_procedure(gtk_style_context_has_class, gxg_gtk_style_context_has_class_w, 2, 0, 0, H_gtk_style_context_has_class, pl_bus);
  Xg_define_procedure(gtk_style_context_set_frame_clock, gxg_gtk_style_context_set_frame_clock_w, 2, 0, 0, H_gtk_style_context_set_frame_clock, pl_tu);
  Xg_define_procedure(gtk_style_context_get_frame_clock, gxg_gtk_style_context_get_frame_clock_w, 1, 0, 0, H_gtk_style_context_get_frame_clock, pl_pu);
  Xg_define_procedure(gtk_style_context_lookup_color, gxg_gtk_style_context_lookup_color_w, 3, 0, 0, H_gtk_style_context_lookup_color, pl_busu);
  Xg_define_procedure(gtk_style_context_get_color, gxg_gtk_style_context_get_color_w, 2, 0, 0, H_gtk_style_context_get_color, pl_tu);
  Xg_define_procedure(gtk_style_context_get_border, gxg_gtk_style_context_get_border_w, 2, 0, 0, H_gtk_style_context_get_border, pl_tu);
  Xg_define_procedure(gtk_style_context_get_padding, gxg_gtk_style_context_get_padding_w, 2, 0, 0, H_gtk_style_context_get_padding, pl_tu);
  Xg_define_procedure(gtk_style_context_get_margin, gxg_gtk_style_context_get_margin_w, 2, 0, 0, H_gtk_style_context_get_margin, pl_tu);
  Xg_define_procedure(gtk_render_insertion_cursor, gxg_gtk_render_insertion_cursor_w, 7, 0, 0, H_gtk_render_insertion_cursor, pl_tuurruig);
  Xg_define_procedure(gtk_style_context_to_string, gxg_gtk_style_context_to_string_w, 2, 0, 0, H_gtk_style_context_to_string, pl_sug);
  Xg_define_procedure(gtk_css_provider_new, gxg_gtk_css_provider_new_w, 0, 0, 0, H_gtk_css_provider_new, pl_p);
  Xg_define_procedure(gtk_css_provider_to_string, gxg_gtk_css_provider_to_string_w, 1, 0, 0, H_gtk_css_provider_to_string, pl_su);
  Xg_define_procedure(gtk_css_provider_load_from_data, gxg_gtk_css_provider_load_from_data_w, 3, 0, 0, H_gtk_css_provider_load_from_data, pl_tusi);
  Xg_define_procedure(gtk_css_provider_load_from_file, gxg_gtk_css_provider_load_from_file_w, 2, 0, 0, H_gtk_css_provider_load_from_file, pl_tu);
  Xg_define_procedure(gtk_css_provider_load_from_path, gxg_gtk_css_provider_load_from_path_w, 2, 0, 0, H_gtk_css_provider_load_from_path, pl_tus);
  Xg_define_procedure(gtk_css_provider_load_from_resource, gxg_gtk_css_provider_load_from_resource_w, 2, 0, 0, H_gtk_css_provider_load_from_resource, pl_tus);
  Xg_define_procedure(gtk_css_provider_get_default, gxg_gtk_css_provider_get_default_w, 0, 0, 0, H_gtk_css_provider_get_default, pl_p);
  Xg_define_procedure(gtk_css_provider_get_named, gxg_gtk_css_provider_get_named_w, 2, 0, 0, H_gtk_css_provider_get_named, pl_ps);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  Xg_define_procedure(gdk_event_set_keyval, gxg_gdk_event_set_keyval_w, 2, 0, 0, H_gdk_event_set_keyval, pl_tui);
  Xg_define_procedure(gdk_event_get_key_is_modifier, gxg_gdk_event_get_key_is_modifier_w, 1, 1, 0, H_gdk_event_get_key_is_modifier, pl_pu);
  Xg_define_procedure(gdk_event_get_key_group, gxg_gdk_event_get_key_group_w, 1, 1, 0, H_gdk_event_get_key_group, pl_pu);
  Xg_define_procedure(gdk_event_get_string, gxg_gdk_event_get_string_w, 1, 1, 0, H_gdk_event_get_string, pl_pu);
  Xg_define_procedure(gdk_event_get_setting, gxg_gdk_event_get_setting_w, 1, 1, 0, H_gdk_event_get_setting, pl_pu);
  Xg_define_procedure(gdk_event_is_sent, gxg_gdk_event_is_sent_w, 1, 0, 0, H_gdk_event_is_sent, pl_bu);
  Xg_define_procedure(gdk_event_get_drag_context, gxg_gdk_event_get_drag_context_w, 1, 1, 0, H_gdk_event_get_drag_context, pl_pu);
  Xg_define_procedure(gdk_event_get_crossing_mode, gxg_gdk_event_get_crossing_mode_w, 1, 1, 0, H_gdk_event_get_crossing_mode, pl_pu);
  Xg_define_procedure(gdk_event_get_crossing_detail, gxg_gdk_event_get_crossing_detail_w, 1, 1, 0, H_gdk_event_get_crossing_detail, pl_pu);
  Xg_define_procedure(gdk_event_get_touchpad_gesture_phase, gxg_gdk_event_get_touchpad_gesture_phase_w, 1, 1, 0, H_gdk_event_get_touchpad_gesture_phase, pl_pu);
  Xg_define_procedure(gdk_event_get_touchpad_gesture_n_fingers, gxg_gdk_event_get_touchpad_gesture_n_fingers_w, 1, 1, 0, H_gdk_event_get_touchpad_gesture_n_fingers, pl_pu);
  Xg_define_procedure(gdk_event_get_touchpad_deltas, gxg_gdk_event_get_touchpad_deltas_w, 1, 2, 0, H_gdk_event_get_touchpad_deltas, pl_pu);
  Xg_define_procedure(gdk_event_get_touchpad_angle_delta, gxg_gdk_event_get_touchpad_angle_delta_w, 1, 1, 0, H_gdk_event_get_touchpad_angle_delta, pl_pu);
  Xg_define_procedure(gdk_event_get_touchpad_scale, gxg_gdk_event_get_touchpad_scale_w, 1, 1, 0, H_gdk_event_get_touchpad_scale, pl_pu);
  Xg_define_procedure(gdk_event_get_touch_emulating_pointer, gxg_gdk_event_get_touch_emulating_pointer_w, 1, 1, 0, H_gdk_event_get_touch_emulating_pointer, pl_pu);
  Xg_define_procedure(gdk_event_get_grab_window, gxg_gdk_event_get_grab_window_w, 1, 1, 0, H_gdk_event_get_grab_window, pl_pu);
  Xg_define_procedure(gdk_event_get_focus_in, gxg_gdk_event_get_focus_in_w, 1, 1, 0, H_gdk_event_get_focus_in, pl_pu);
  Xg_define_procedure(gdk_event_get_pad_group_mode, gxg_gdk_event_get_pad_group_mode_w, 1, 2, 0, H_gdk_event_get_pad_group_mode, pl_pu);
  Xg_define_procedure(gdk_event_get_pad_button, gxg_gdk_event_get_pad_button_w, 1, 1, 0, H_gdk_event_get_pad_button, pl_pu);
  Xg_define_procedure(gdk_event_get_pad_axis_value, gxg_gdk_event_get_pad_axis_value_w, 1, 2, 0, H_gdk_event_get_pad_axis_value, pl_pu);
  Xg_define_procedure(gdk_event_get_axes, gxg_gdk_event_get_axes_w, 1, 2, 0, H_gdk_event_get_axes, pl_pu);
  Xg_define_procedure(gtk_snapshot_push_blur, gxg_gtk_snapshot_push_blur_w, 3, 0, 0, H_gtk_snapshot_push_blur, pl_turs);
  Xg_define_procedure(gtk_emoji_chooser_new, gxg_gtk_emoji_chooser_new_w, 0, 0, 0, H_gtk_emoji_chooser_new, pl_p);
  Xg_define_procedure(gtk_event_controller_scroll_new, gxg_gtk_event_controller_scroll_new_w, 2, 0, 0, H_gtk_event_controller_scroll_new, pl_pug);
  Xg_define_procedure(gtk_event_controller_scroll_set_flags, gxg_gtk_event_controller_scroll_set_flags_w, 2, 0, 0, H_gtk_event_controller_scroll_set_flags, pl_tug);
  Xg_define_procedure(gtk_event_controller_scroll_get_flags, gxg_gtk_event_controller_scroll_get_flags_w, 1, 0, 0, H_gtk_event_controller_scroll_get_flags, pl_gu);
  Xg_define_procedure(gdk_app_launch_context_set_desktop, gxg_gdk_app_launch_context_set_desktop_w, 2, 0, 0, H_gdk_app_launch_context_set_desktop, pl_tui);
  Xg_define_procedure(gdk_app_launch_context_set_timestamp, gxg_gdk_app_launch_context_set_timestamp_w, 2, 0, 0, H_gdk_app_launch_context_set_timestamp, pl_tui);
  Xg_define_procedure(gdk_app_launch_context_set_icon, gxg_gdk_app_launch_context_set_icon_w, 2, 0, 0, H_gdk_app_launch_context_set_icon, pl_tu);
  Xg_define_procedure(gdk_app_launch_context_set_icon_name, gxg_gdk_app_launch_context_set_icon_name_w, 2, 0, 0, H_gdk_app_launch_context_set_icon_name, pl_tus);
  Xg_define_procedure(gdk_clipboard_get_display, gxg_gdk_clipboard_get_display_w, 1, 0, 0, H_gdk_clipboard_get_display, pl_pu);
  Xg_define_procedure(gdk_clipboard_get_formats, gxg_gdk_clipboard_get_formats_w, 1, 0, 0, H_gdk_clipboard_get_formats, pl_pu);
  Xg_define_procedure(gdk_clipboard_is_local, gxg_gdk_clipboard_is_local_w, 1, 0, 0, H_gdk_clipboard_is_local, pl_bu);
  Xg_define_procedure(gdk_clipboard_get_content, gxg_gdk_clipboard_get_content_w, 1, 0, 0, H_gdk_clipboard_get_content, pl_pu);
  Xg_define_procedure(gdk_clipboard_store_async, gxg_gdk_clipboard_store_async_w, 5, 0, 0, H_gdk_clipboard_store_async, pl_tuiut);
  Xg_define_procedure(gdk_clipboard_store_finish, gxg_gdk_clipboard_store_finish_w, 2, 1, 0, H_gdk_clipboard_store_finish, pl_pu);
  Xg_define_procedure(gdk_clipboard_read_async, gxg_gdk_clipboard_read_async_w, 6, 0, 0, H_gdk_clipboard_read_async, pl_tuuiut);
  Xg_define_procedure(gdk_clipboard_read_finish, gxg_gdk_clipboard_read_finish_w, 3, 1, 0, H_gdk_clipboard_read_finish, pl_pu);
  Xg_define_procedure(gdk_clipboard_read_value_async, gxg_gdk_clipboard_read_value_async_w, 6, 0, 0, H_gdk_clipboard_read_value_async, pl_tuiiut);
  Xg_define_procedure(gdk_clipboard_read_value_finish, gxg_gdk_clipboard_read_value_finish_w, 2, 1, 0, H_gdk_clipboard_read_value_finish, pl_pu);
  Xg_define_procedure(gdk_clipboard_read_texture_async, gxg_gdk_clipboard_read_texture_async_w, 4, 0, 0, H_gdk_clipboard_read_texture_async, pl_tuut);
  Xg_define_procedure(gdk_clipboard_read_texture_finish, gxg_gdk_clipboard_read_texture_finish_w, 2, 1, 0, H_gdk_clipboard_read_texture_finish, pl_pu);
  Xg_define_procedure(gdk_clipboard_read_text_async, gxg_gdk_clipboard_read_text_async_w, 4, 0, 0, H_gdk_clipboard_read_text_async, pl_tuut);
  Xg_define_procedure(gdk_clipboard_read_text_finish, gxg_gdk_clipboard_read_text_finish_w, 2, 1, 0, H_gdk_clipboard_read_text_finish, pl_pu);
  Xg_define_procedure(gdk_clipboard_set_content, gxg_gdk_clipboard_set_content_w, 2, 0, 0, H_gdk_clipboard_set_content, pl_bu);
  Xg_define_procedure(gdk_clipboard_set, gxg_gdk_clipboard_set_w, 2, 0, 0, H_gdk_clipboard_set, pl_tui);
  Xg_define_procedure(gdk_clipboard_set_value, gxg_gdk_clipboard_set_value_w, 2, 0, 0, H_gdk_clipboard_set_value, pl_tu);
  Xg_define_procedure(gdk_clipboard_set_text, gxg_gdk_clipboard_set_text_w, 2, 0, 0, H_gdk_clipboard_set_text, pl_tus);
  Xg_define_procedure(gdk_clipboard_set_texture, gxg_gdk_clipboard_set_texture_w, 2, 0, 0, H_gdk_clipboard_set_texture, pl_tu);
  Xg_define_procedure(gdk_intern_mime_type, gxg_gdk_intern_mime_type_w, 1, 0, 0, H_gdk_intern_mime_type, pl_s);
  Xg_define_procedure(gdk_content_formats_new, gxg_gdk_content_formats_new_w, 2, 0, 0, H_gdk_content_formats_new, pl_pui);
  Xg_define_procedure(gdk_content_formats_new_for_gtype, gxg_gdk_content_formats_new_for_gtype_w, 1, 0, 0, H_gdk_content_formats_new_for_gtype, pl_pi);
  Xg_define_procedure(gdk_content_formats_ref, gxg_gdk_content_formats_ref_w, 1, 0, 0, H_gdk_content_formats_ref, pl_pu);
  Xg_define_procedure(gdk_content_formats_unref, gxg_gdk_content_formats_unref_w, 1, 0, 0, H_gdk_content_formats_unref, pl_tu);
  Xg_define_procedure(gdk_content_formats_print, gxg_gdk_content_formats_print_w, 2, 0, 0, H_gdk_content_formats_print, pl_tu);
  Xg_define_procedure(gdk_content_formats_to_string, gxg_gdk_content_formats_to_string_w, 1, 0, 0, H_gdk_content_formats_to_string, pl_su);
  Xg_define_procedure(gdk_content_formats_get_gtypes, gxg_gdk_content_formats_get_gtypes_w, 1, 1, 0, H_gdk_content_formats_get_gtypes, pl_pu);
  Xg_define_procedure(gdk_content_formats_get_mime_types, gxg_gdk_content_formats_get_mime_types_w, 1, 1, 0, H_gdk_content_formats_get_mime_types, pl_pu);
  Xg_define_procedure(gdk_content_formats_union, gxg_gdk_content_formats_union_w, 2, 0, 0, H_gdk_content_formats_union, pl_pu);
  Xg_define_procedure(gdk_content_formats_match, gxg_gdk_content_formats_match_w, 2, 0, 0, H_gdk_content_formats_match, pl_bu);
  Xg_define_procedure(gdk_content_formats_match_gtype, gxg_gdk_content_formats_match_gtype_w, 2, 0, 0, H_gdk_content_formats_match_gtype, pl_iu);
  Xg_define_procedure(gdk_content_formats_match_mime_type, gxg_gdk_content_formats_match_mime_type_w, 2, 0, 0, H_gdk_content_formats_match_mime_type, pl_su);
  Xg_define_procedure(gdk_content_formats_contain_gtype, gxg_gdk_content_formats_contain_gtype_w, 2, 0, 0, H_gdk_content_formats_contain_gtype, pl_bui);
  Xg_define_procedure(gdk_content_formats_contain_mime_type, gxg_gdk_content_formats_contain_mime_type_w, 2, 0, 0, H_gdk_content_formats_contain_mime_type, pl_bus);
  Xg_define_procedure(*gdk_content_formats_builder_new, gxg_*gdk_content_formats_builder_new_w, 0, 0, 0, H_*gdk_content_formats_builder_new, pl_t);
  Xg_define_procedure(gdk_content_formats_builder_free, gxg_gdk_content_formats_builder_free_w, 1, 0, 0, H_gdk_content_formats_builder_free, pl_pu);
  Xg_define_procedure(gdk_content_formats_builder_add_formats, gxg_gdk_content_formats_builder_add_formats_w, 2, 0, 0, H_gdk_content_formats_builder_add_formats, pl_tu);
  Xg_define_procedure(gdk_content_formats_builder_add_mime_type, gxg_gdk_content_formats_builder_add_mime_type_w, 2, 0, 0, H_gdk_content_formats_builder_add_mime_type, pl_tus);
  Xg_define_procedure(gdk_content_formats_builder_add_gtype, gxg_gdk_content_formats_builder_add_gtype_w, 2, 0, 0, H_gdk_content_formats_builder_add_gtype, pl_tui);
  Xg_define_procedure(gdk_content_provider_ref_formats, gxg_gdk_content_provider_ref_formats_w, 1, 0, 0, H_gdk_content_provider_ref_formats, pl_pu);
  Xg_define_procedure(gdk_content_provider_ref_storable_formats, gxg_gdk_content_provider_ref_storable_formats_w, 1, 0, 0, H_gdk_content_provider_ref_storable_formats, pl_pu);
  Xg_define_procedure(gdk_content_provider_content_changed, gxg_gdk_content_provider_content_changed_w, 1, 0, 0, H_gdk_content_provider_content_changed, pl_tu);
  Xg_define_procedure(gdk_content_provider_write_mime_type_async, gxg_gdk_content_provider_write_mime_type_async_w, 7, 0, 0, H_gdk_content_provider_write_mime_type_async, pl_tusuiut);
  Xg_define_procedure(gdk_content_provider_write_mime_type_finish, gxg_gdk_content_provider_write_mime_type_finish_w, 2, 1, 0, H_gdk_content_provider_write_mime_type_finish, pl_pu);
  Xg_define_procedure(gdk_content_provider_get_value, gxg_gdk_content_provider_get_value_w, 2, 1, 0, H_gdk_content_provider_get_value, pl_pu);
  Xg_define_procedure(gdk_content_serializer_get_mime_type, gxg_gdk_content_serializer_get_mime_type_w, 1, 0, 0, H_gdk_content_serializer_get_mime_type, pl_su);
  Xg_define_procedure(gdk_content_serializer_get_value, gxg_gdk_content_serializer_get_value_w, 1, 0, 0, H_gdk_content_serializer_get_value, pl_pu);
  Xg_define_procedure(gdk_content_serializer_get_output_stream, gxg_gdk_content_serializer_get_output_stream_w, 1, 0, 0, H_gdk_content_serializer_get_output_stream, pl_pu);
  Xg_define_procedure(gdk_content_serializer_get_priority, gxg_gdk_content_serializer_get_priority_w, 1, 0, 0, H_gdk_content_serializer_get_priority, pl_iu);
  Xg_define_procedure(gdk_content_serializer_get_cancellable, gxg_gdk_content_serializer_get_cancellable_w, 1, 0, 0, H_gdk_content_serializer_get_cancellable, pl_pu);
  Xg_define_procedure(gdk_content_serializer_get_user_data, gxg_gdk_content_serializer_get_user_data_w, 1, 0, 0, H_gdk_content_serializer_get_user_data, pl_tu);
  Xg_define_procedure(gdk_content_serializer_set_task_data, gxg_gdk_content_serializer_set_task_data_w, 3, 0, 0, H_gdk_content_serializer_set_task_data, pl_tut);
  Xg_define_procedure(gdk_content_serializer_get_task_data, gxg_gdk_content_serializer_get_task_data_w, 1, 0, 0, H_gdk_content_serializer_get_task_data, pl_tu);
  Xg_define_procedure(gdk_content_serializer_return_success, gxg_gdk_content_serializer_return_success_w, 1, 0, 0, H_gdk_content_serializer_return_success, pl_tu);
  Xg_define_procedure(gdk_content_serializer_return_error, gxg_gdk_content_serializer_return_error_w, 2, 0, 0, H_gdk_content_serializer_return_error, pl_tu);
  Xg_define_procedure(gdk_content_formats_union_serialize_gtypes, gxg_gdk_content_formats_union_serialize_gtypes_w, 1, 0, 0, H_gdk_content_formats_union_serialize_gtypes, pl_pu);
  Xg_define_procedure(gdk_content_formats_union_serialize_mime_types, gxg_gdk_content_formats_union_serialize_mime_types_w, 1, 0, 0, H_gdk_content_formats_union_serialize_mime_types, pl_pu);
  Xg_define_procedure(gdk_content_register_serializer, gxg_gdk_content_register_serializer_w, 5, 0, 0, H_gdk_content_register_serializer, pl_tist);
  Xg_define_procedure(gdk_content_serialize_async, gxg_gdk_content_serialize_async_w, 7, 0, 0, H_gdk_content_serialize_async, pl_tusuiut);
  Xg_define_procedure(gdk_content_serialize_finish, gxg_gdk_content_serialize_finish_w, 1, 1, 0, H_gdk_content_serialize_finish, pl_pu);
  Xg_define_procedure(gdk_content_deserializer_get_mime_type, gxg_gdk_content_deserializer_get_mime_type_w, 1, 0, 0, H_gdk_content_deserializer_get_mime_type, pl_su);
  Xg_define_procedure(gdk_content_deserializer_get_value, gxg_gdk_content_deserializer_get_value_w, 1, 0, 0, H_gdk_content_deserializer_get_value, pl_pu);
  Xg_define_procedure(gdk_content_deserializer_get_input_stream, gxg_gdk_content_deserializer_get_input_stream_w, 1, 0, 0, H_gdk_content_deserializer_get_input_stream, pl_pu);
  Xg_define_procedure(gdk_content_deserializer_get_priority, gxg_gdk_content_deserializer_get_priority_w, 1, 0, 0, H_gdk_content_deserializer_get_priority, pl_iu);
  Xg_define_procedure(gdk_content_deserializer_get_cancellable, gxg_gdk_content_deserializer_get_cancellable_w, 1, 0, 0, H_gdk_content_deserializer_get_cancellable, pl_pu);
  Xg_define_procedure(gdk_content_deserializer_get_user_data, gxg_gdk_content_deserializer_get_user_data_w, 1, 0, 0, H_gdk_content_deserializer_get_user_data, pl_tu);
  Xg_define_procedure(gdk_content_deserializer_set_task_data, gxg_gdk_content_deserializer_set_task_data_w, 3, 0, 0, H_gdk_content_deserializer_set_task_data, pl_tut);
  Xg_define_procedure(gdk_content_deserializer_get_task_data, gxg_gdk_content_deserializer_get_task_data_w, 1, 0, 0, H_gdk_content_deserializer_get_task_data, pl_tu);
  Xg_define_procedure(gdk_content_deserializer_return_success, gxg_gdk_content_deserializer_return_success_w, 1, 0, 0, H_gdk_content_deserializer_return_success, pl_tu);
  Xg_define_procedure(gdk_content_deserializer_return_error, gxg_gdk_content_deserializer_return_error_w, 2, 0, 0, H_gdk_content_deserializer_return_error, pl_tu);
  Xg_define_procedure(gdk_content_formats_union_deserialize_gtypes, gxg_gdk_content_formats_union_deserialize_gtypes_w, 1, 0, 0, H_gdk_content_formats_union_deserialize_gtypes, pl_pu);
  Xg_define_procedure(gdk_content_formats_union_deserialize_mime_types, gxg_gdk_content_formats_union_deserialize_mime_types_w, 1, 0, 0, H_gdk_content_formats_union_deserialize_mime_types, pl_pu);
  Xg_define_procedure(gdk_content_register_deserializer, gxg_gdk_content_register_deserializer_w, 5, 0, 0, H_gdk_content_register_deserializer, pl_tsit);
  Xg_define_procedure(gdk_content_deserialize_async, gxg_gdk_content_deserialize_async_w, 7, 0, 0, H_gdk_content_deserialize_async, pl_tusiiut);
  Xg_define_procedure(gdk_content_deserialize_finish, gxg_gdk_content_deserialize_finish_w, 2, 1, 0, H_gdk_content_deserialize_finish, pl_pu);
  Xg_define_procedure(gdk_content_provider_new_for_value, gxg_gdk_content_provider_new_for_value_w, 1, 0, 0, H_gdk_content_provider_new_for_value, pl_pu);
  Xg_define_procedure(gdk_content_provider_new_for_bytes, gxg_gdk_content_provider_new_for_bytes_w, 2, 0, 0, H_gdk_content_provider_new_for_bytes, pl_psu);
  Xg_define_procedure(gtk_event_controller_motion_new, gxg_gtk_event_controller_motion_new_w, 1, 0, 0, H_gtk_event_controller_motion_new, pl_pu);
  Xg_define_procedure(gdk_texture_new_for_data, gxg_gdk_texture_new_for_data_w, 4, 0, 0, H_gdk_texture_new_for_data, pl_psi);
  Xg_define_procedure(gdk_texture_new_for_pixbuf, gxg_gdk_texture_new_for_pixbuf_w, 1, 0, 0, H_gdk_texture_new_for_pixbuf, pl_pu);
  Xg_define_procedure(gdk_texture_new_from_resource, gxg_gdk_texture_new_from_resource_w, 1, 0, 0, H_gdk_texture_new_from_resource, pl_ps);
  Xg_define_procedure(gdk_texture_new_from_file, gxg_gdk_texture_new_from_file_w, 1, 1, 0, H_gdk_texture_new_from_file, pl_pu);
  Xg_define_procedure(gdk_texture_get_width, gxg_gdk_texture_get_width_w, 1, 0, 0, H_gdk_texture_get_width, pl_iu);
  Xg_define_procedure(gdk_texture_get_height, gxg_gdk_texture_get_height_w, 1, 0, 0, H_gdk_texture_get_height, pl_iu);
  Xg_define_procedure(gdk_texture_download, gxg_gdk_texture_download_w, 3, 0, 0, H_gdk_texture_download, pl_tusi);
  Xg_define_procedure(gdk_cursor_new_from_texture, gxg_gdk_cursor_new_from_texture_w, 4, 0, 0, H_gdk_cursor_new_from_texture, pl_puiiu);
  Xg_define_procedure(gdk_cursor_new_from_name, gxg_gdk_cursor_new_from_name_w, 2, 0, 0, H_gdk_cursor_new_from_name, pl_psu);
  Xg_define_procedure(gdk_cursor_get_fallback, gxg_gdk_cursor_get_fallback_w, 1, 0, 0, H_gdk_cursor_get_fallback, pl_pu);
  Xg_define_procedure(gdk_cursor_get_name, gxg_gdk_cursor_get_name_w, 1, 0, 0, H_gdk_cursor_get_name, pl_su);
  Xg_define_procedure(gdk_cursor_get_texture, gxg_gdk_cursor_get_texture_w, 1, 0, 0, H_gdk_cursor_get_texture, pl_pu);
  Xg_define_procedure(gdk_cursor_get_hotspot_x, gxg_gdk_cursor_get_hotspot_x_w, 1, 0, 0, H_gdk_cursor_get_hotspot_x, pl_iu);
  Xg_define_procedure(gdk_cursor_get_hotspot_y, gxg_gdk_cursor_get_hotspot_y_w, 1, 0, 0, H_gdk_cursor_get_hotspot_y, pl_iu);
  Xg_define_procedure(gdk_device_get_position, gxg_gdk_device_get_position_w, 1, 2, 0, H_gdk_device_get_position, pl_pu);
  Xg_define_procedure(gdk_device_get_position_double, gxg_gdk_device_get_position_double_w, 1, 2, 0, H_gdk_device_get_position_double, pl_pu);
  Xg_define_procedure(gdk_display_get_clipboard, gxg_gdk_display_get_clipboard_w, 1, 0, 0, H_gdk_display_get_clipboard, pl_pu);
  Xg_define_procedure(gdk_display_get_primary_clipboard, gxg_gdk_display_get_primary_clipboard_w, 1, 0, 0, H_gdk_display_get_primary_clipboard, pl_pu);
  Xg_define_procedure(gdk_display_get_keymap, gxg_gdk_display_get_keymap_w, 1, 0, 0, H_gdk_display_get_keymap, pl_pu);
  Xg_define_procedure(gdk_display_get_setting, gxg_gdk_display_get_setting_w, 2, 1, 0, H_gdk_display_get_setting, pl_pusu);
  Xg_define_procedure(gdk_drag_context_get_display, gxg_gdk_drag_context_get_display_w, 1, 0, 0, H_gdk_drag_context_get_display, pl_pu);
  Xg_define_procedure(gdk_drag_context_get_formats, gxg_gdk_drag_context_get_formats_w, 1, 0, 0, H_gdk_drag_context_get_formats, pl_pu);
  Xg_define_procedure(gdk_drop_read_async, gxg_gdk_drop_read_async_w, 6, 0, 0, H_gdk_drop_read_async, pl_tuuiut);
  Xg_define_procedure(gdk_drop_read_finish, gxg_gdk_drop_read_finish_w, 3, 1, 0, H_gdk_drop_read_finish, pl_pu);
  Xg_define_procedure(gdk_drag_begin, gxg_gdk_drag_begin_w, 6, 0, 0, H_gdk_drag_begin, pl_puuugi);
  Xg_define_procedure(gdk_monitor_is_valid, gxg_gdk_monitor_is_valid_w, 1, 0, 0, H_gdk_monitor_is_valid, pl_bu);
  Xg_define_procedure(gdk_seat_get_master_pointers, gxg_gdk_seat_get_master_pointers_w, 2, 0, 0, H_gdk_seat_get_master_pointers, pl_pug);
  Xg_define_procedure(gtk_drag_begin_with_coordinates, gxg_gtk_drag_begin_with_coordinates_w, 6, 0, 0, H_gtk_drag_begin_with_coordinates, pl_puuugi);
  Xg_define_procedure(gtk_drag_source_set_icon_surface, gxg_gtk_drag_source_set_icon_surface_w, 2, 0, 0, H_gtk_drag_source_set_icon_surface, pl_tu);
  Xg_define_procedure(gtk_entry_set_icon_from_texture, gxg_gtk_entry_set_icon_from_texture_w, 3, 0, 0, H_gtk_entry_set_icon_from_texture, pl_tugu);
  Xg_define_procedure(gtk_entry_get_icon_texture, gxg_gtk_entry_get_icon_texture_w, 2, 0, 0, H_gtk_entry_get_icon_texture, pl_pug);
  Xg_define_procedure(gtk_entry_set_icon_drag_source, gxg_gtk_entry_set_icon_drag_source_w, 4, 0, 0, H_gtk_entry_set_icon_drag_source, pl_tugug);
  Xg_define_procedure(gtk_header_bar_get_show_title_buttons, gxg_gtk_header_bar_get_show_title_buttons_w, 1, 0, 0, H_gtk_header_bar_get_show_title_buttons, pl_bu);
  Xg_define_procedure(gtk_header_bar_set_show_title_buttons, gxg_gtk_header_bar_set_show_title_buttons_w, 2, 0, 0, H_gtk_header_bar_set_show_title_buttons, pl_tub);
  Xg_define_procedure(gtk_icon_theme_get_for_display, gxg_gtk_icon_theme_get_for_display_w, 1, 0, 0, H_gtk_icon_theme_get_for_display, pl_pu);
  Xg_define_procedure(gtk_icon_theme_set_display, gxg_gtk_icon_theme_set_display_w, 2, 0, 0, H_gtk_icon_theme_set_display, pl_tu);
  Xg_define_procedure(gtk_icon_info_load_texture, gxg_gtk_icon_info_load_texture_w, 1, 0, 0, H_gtk_icon_info_load_texture, pl_pu);
  Xg_define_procedure(gtk_image_new_from_texture, gxg_gtk_image_new_from_texture_w, 1, 0, 0, H_gtk_image_new_from_texture, pl_pu);
  Xg_define_procedure(gtk_image_new_from_icon_name, gxg_gtk_image_new_from_icon_name_w, 1, 0, 0, H_gtk_image_new_from_icon_name, pl_ps);
  Xg_define_procedure(gtk_image_new_from_gicon, gxg_gtk_image_new_from_gicon_w, 1, 0, 0, H_gtk_image_new_from_gicon, pl_pu);
  Xg_define_procedure(gtk_image_set_from_texture, gxg_gtk_image_set_from_texture_w, 2, 0, 0, H_gtk_image_set_from_texture, pl_tu);
  Xg_define_procedure(gtk_image_set_from_icon_name, gxg_gtk_image_set_from_icon_name_w, 2, 0, 0, H_gtk_image_set_from_icon_name, pl_tus);
  Xg_define_procedure(gtk_image_set_from_gicon, gxg_gtk_image_set_from_gicon_w, 2, 0, 0, H_gtk_image_set_from_gicon, pl_tu);
  Xg_define_procedure(gtk_image_set_icon_size, gxg_gtk_image_set_icon_size_w, 2, 0, 0, H_gtk_image_set_icon_size, pl_tug);
  Xg_define_procedure(gtk_image_get_surface, gxg_gtk_image_get_surface_w, 1, 0, 0, H_gtk_image_get_surface, pl_pu);
  Xg_define_procedure(gtk_image_get_texture, gxg_gtk_image_get_texture_w, 1, 0, 0, H_gtk_image_get_texture, pl_pu);
  Xg_define_procedure(gtk_image_get_icon_size, gxg_gtk_image_get_icon_size_w, 1, 0, 0, H_gtk_image_get_icon_size, pl_gu);
  Xg_define_procedure(gtk_image_get_icon_name, gxg_gtk_image_get_icon_name_w, 1, 0, 0, H_gtk_image_get_icon_name, pl_su);
  Xg_define_procedure(gtk_image_get_gicon, gxg_gtk_image_get_gicon_w, 1, 0, 0, H_gtk_image_get_gicon, pl_pu);
  Xg_define_procedure(gtk_invisible_new_for_display, gxg_gtk_invisible_new_for_display_w, 1, 0, 0, H_gtk_invisible_new_for_display, pl_pu);
  Xg_define_procedure(gtk_invisible_set_display, gxg_gtk_invisible_set_display_w, 2, 0, 0, H_gtk_invisible_set_display, pl_tu);
  Xg_define_procedure(GtkInvisible*, gxg_GtkInvisible*_w, 0, 0, 0, H_GtkInvisible*, pl_p);
  Xg_define_procedure(gtk_menu_set_display, gxg_gtk_menu_set_display_w, 2, 0, 0, H_gtk_menu_set_display, pl_tu);
  Xg_define_procedure(gtk_render_icon, gxg_gtk_render_icon_w, 5, 0, 0, H_gtk_render_icon, pl_tuuur);
  Xg_define_procedure(gtk_content_formats_add_text_targets, gxg_gtk_content_formats_add_text_targets_w, 1, 0, 0, H_gtk_content_formats_add_text_targets, pl_pu);
  Xg_define_procedure(gtk_content_formats_add_image_targets, gxg_gtk_content_formats_add_image_targets_w, 2, 0, 0, H_gtk_content_formats_add_image_targets, pl_pub);
  Xg_define_procedure(gtk_content_formats_add_uri_targets, gxg_gtk_content_formats_add_uri_targets_w, 1, 0, 0, H_gtk_content_formats_add_uri_targets, pl_pu);
  Xg_define_procedure(gtk_selection_data_set, gxg_gtk_selection_data_set_w, 5, 0, 0, H_gtk_selection_data_set, pl_tutisi);
  Xg_define_procedure(gtk_selection_data_set_text, gxg_gtk_selection_data_set_text_w, 3, 0, 0, H_gtk_selection_data_set_text, pl_busi);
  Xg_define_procedure(gtk_selection_data_get_text, gxg_gtk_selection_data_get_text_w, 1, 0, 0, H_gtk_selection_data_get_text, pl_su);
  Xg_define_procedure(gtk_selection_data_set_pixbuf, gxg_gtk_selection_data_set_pixbuf_w, 2, 0, 0, H_gtk_selection_data_set_pixbuf, pl_bu);
  Xg_define_procedure(gtk_selection_data_get_surface, gxg_gtk_selection_data_get_surface_w, 1, 0, 0, H_gtk_selection_data_get_surface, pl_pu);
  Xg_define_procedure(gtk_selection_data_set_surface, gxg_gtk_selection_data_set_surface_w, 2, 0, 0, H_gtk_selection_data_set_surface, pl_bu);
  Xg_define_procedure(gtk_selection_data_get_pixbuf, gxg_gtk_selection_data_get_pixbuf_w, 1, 0, 0, H_gtk_selection_data_get_pixbuf, pl_pu);
  Xg_define_procedure(gtk_selection_data_set_texture, gxg_gtk_selection_data_set_texture_w, 2, 0, 0, H_gtk_selection_data_set_texture, pl_bu);
  Xg_define_procedure(gtk_selection_data_get_texture, gxg_gtk_selection_data_get_texture_w, 1, 0, 0, H_gtk_selection_data_get_texture, pl_pu);
  Xg_define_procedure(gtk_selection_data_set_uris, gxg_gtk_selection_data_set_uris_w, 2, 0, 0, H_gtk_selection_data_set_uris, pl_bu);
  Xg_define_procedure(gtk_selection_data_get_uris, gxg_gtk_selection_data_get_uris_w, 1, 0, 0, H_gtk_selection_data_get_uris, pl_pu);
  Xg_define_procedure(gtk_selection_data_get_targets, gxg_gtk_selection_data_get_targets_w, 1, 2, 0, H_gtk_selection_data_get_targets, pl_pu);
  Xg_define_procedure(gtk_selection_data_targets_include_text, gxg_gtk_selection_data_targets_include_text_w, 1, 0, 0, H_gtk_selection_data_targets_include_text, pl_bu);
  Xg_define_procedure(gtk_selection_data_targets_include_uri, gxg_gtk_selection_data_targets_include_uri_w, 1, 0, 0, H_gtk_selection_data_targets_include_uri, pl_bu);
  Xg_define_procedure(gtk_targets_include_text, gxg_gtk_targets_include_text_w, 2, 0, 0, H_gtk_targets_include_text, pl_bui);
  Xg_define_procedure(gtk_targets_include_image, gxg_gtk_targets_include_image_w, 3, 0, 0, H_gtk_targets_include_image, pl_buib);
  Xg_define_procedure(gtk_targets_include_uri, gxg_gtk_targets_include_uri_w, 2, 0, 0, H_gtk_targets_include_uri, pl_bui);
  Xg_define_procedure(gtk_settings_get_for_display, gxg_gtk_settings_get_for_display_w, 1, 0, 0, H_gtk_settings_get_for_display, pl_pu);
  Xg_define_procedure(gtk_style_context_add_provider_for_display, gxg_gtk_style_context_add_provider_for_display_w, 3, 0, 0, H_gtk_style_context_add_provider_for_display, pl_tuui);
  Xg_define_procedure(gtk_style_context_remove_provider_for_display, gxg_gtk_style_context_remove_provider_for_display_w, 2, 0, 0, H_gtk_style_context_remove_provider_for_display, pl_tu);
  Xg_define_procedure(gtk_style_context_set_display, gxg_gtk_style_context_set_display_w, 2, 0, 0, H_gtk_style_context_set_display, pl_tu);
  Xg_define_procedure(gtk_style_context_get_display, gxg_gtk_style_context_get_display_w, 1, 0, 0, H_gtk_style_context_get_display, pl_pu);
  Xg_define_procedure(gtk_style_context_reset_widgets, gxg_gtk_style_context_reset_widgets_w, 1, 0, 0, H_gtk_style_context_reset_widgets, pl_tu);
  Xg_define_procedure(gtk_text_buffer_insert_texture, gxg_gtk_text_buffer_insert_texture_w, 3, 0, 0, H_gtk_text_buffer_insert_texture, pl_tu);
  Xg_define_procedure(gtk_text_buffer_add_selection_clipboard, gxg_gtk_text_buffer_add_selection_clipboard_w, 2, 0, 0, H_gtk_text_buffer_add_selection_clipboard, pl_tu);
  Xg_define_procedure(gtk_text_buffer_remove_selection_clipboard, gxg_gtk_text_buffer_remove_selection_clipboard_w, 2, 0, 0, H_gtk_text_buffer_remove_selection_clipboard, pl_tu);
  Xg_define_procedure(gtk_text_buffer_cut_clipboard, gxg_gtk_text_buffer_cut_clipboard_w, 3, 0, 0, H_gtk_text_buffer_cut_clipboard, pl_tuub);
  Xg_define_procedure(gtk_text_buffer_copy_clipboard, gxg_gtk_text_buffer_copy_clipboard_w, 2, 0, 0, H_gtk_text_buffer_copy_clipboard, pl_tu);
  Xg_define_procedure(gtk_text_buffer_paste_clipboard, gxg_gtk_text_buffer_paste_clipboard_w, 2, 0, 0, H_gtk_text_buffer_paste_clipboard, pl_tu);
  Xg_define_procedure(override_location, gxg_override_location_w, 1, 0, 0, H_override_location, pl_pb);
  Xg_define_procedure(gtk_tool_palette_get_drag_target_item, gxg_gtk_tool_palette_get_drag_target_item_w, 0, 0, 0, H_gtk_tool_palette_get_drag_target_item, pl_s);
  Xg_define_procedure(gtk_tool_palette_get_drag_target_group, gxg_gtk_tool_palette_get_drag_target_group_w, 0, 0, 0, H_gtk_tool_palette_get_drag_target_group, pl_s);
  Xg_define_procedure(gtk_tooltip_set_icon, gxg_gtk_tooltip_set_icon_w, 2, 0, 0, H_gtk_tooltip_set_icon, pl_tu);
  Xg_define_procedure(gtk_tooltip_set_icon_from_icon_name, gxg_gtk_tooltip_set_icon_from_icon_name_w, 2, 0, 0, H_gtk_tooltip_set_icon_from_icon_name, pl_tus);
  Xg_define_procedure(gtk_tooltip_set_icon_from_gicon, gxg_gtk_tooltip_set_icon_from_gicon_w, 2, 0, 0, H_gtk_tooltip_set_icon_from_gicon, pl_tu);
  Xg_define_procedure(gtk_tree_view_enable_model_drag_source, gxg_gtk_tree_view_enable_model_drag_source_w, 4, 0, 0, H_gtk_tree_view_enable_model_drag_source, pl_tugug);
  Xg_define_procedure(gtk_tree_view_enable_model_drag_dest, gxg_gtk_tree_view_enable_model_drag_dest_w, 3, 0, 0, H_gtk_tree_view_enable_model_drag_dest, pl_tuug);
  Xg_define_procedure(gtk_widget_get_width, gxg_gtk_widget_get_width_w, 1, 0, 0, H_gtk_widget_get_width, pl_iu);
  Xg_define_procedure(gtk_widget_get_height, gxg_gtk_widget_get_height_w, 1, 0, 0, H_gtk_widget_get_height, pl_iu);
  Xg_define_procedure(gtk_widget_get_clipboard, gxg_gtk_widget_get_clipboard_w, 1, 0, 0, H_gtk_widget_get_clipboard, pl_pu);
  Xg_define_procedure(gtk_widget_get_primary_clipboard, gxg_gtk_widget_get_primary_clipboard_w, 1, 0, 0, H_gtk_widget_get_primary_clipboard, pl_pu);
  Xg_define_procedure(gtk_widget_contains, gxg_gtk_widget_contains_w, 3, 0, 0, H_gtk_widget_contains, pl_bur);
  Xg_define_procedure(gtk_widget_pick, gxg_gtk_widget_pick_w, 3, 0, 0, H_gtk_widget_pick, pl_pur);
  Xg_define_procedure(gtk_widget_set_cursor, gxg_gtk_widget_set_cursor_w, 2, 0, 0, H_gtk_widget_set_cursor, pl_tu);
  Xg_define_procedure(gtk_widget_set_cursor_from_name, gxg_gtk_widget_set_cursor_from_name_w, 2, 0, 0, H_gtk_widget_set_cursor_from_name, pl_tus);
  Xg_define_procedure(gtk_widget_get_cursor, gxg_gtk_widget_get_cursor_w, 1, 0, 0, H_gtk_widget_get_cursor, pl_pu);
  Xg_define_procedure(gtk_window_set_display, gxg_gtk_window_set_display_w, 2, 0, 0, H_gtk_window_set_display, pl_tu);
  Xg_define_procedure(gtk_window_set_icon, gxg_gtk_window_set_icon_w, 2, 0, 0, H_gtk_window_set_icon, pl_tu);
  Xg_define_procedure(gtk_window_get_icon, gxg_gtk_window_get_icon_w, 1, 0, 0, H_gtk_window_get_icon, pl_pu);
  Xg_define_procedure(gtk_window_set_default_icon, gxg_gtk_window_set_default_icon_w, 1, 0, 0, H_gtk_window_set_default_icon, pl_tu);
  Xg_define_procedure(gtk_window_fullscreen_on_monitor, gxg_gtk_window_fullscreen_on_monitor_w, 2, 0, 0, H_gtk_window_fullscreen_on_monitor, pl_tu);
  Xg_define_procedure(gtk_text_iter_get_texture, gxg_gtk_text_iter_get_texture_w, 1, 0, 0, H_gtk_text_iter_get_texture, pl_pu);
  Xg_define_procedure(gtk_icon_view_enable_model_drag_source, gxg_gtk_icon_view_enable_model_drag_source_w, 4, 0, 0, H_gtk_icon_view_enable_model_drag_source, pl_tugug);
  Xg_define_procedure(gtk_icon_view_enable_model_drag_dest, gxg_gtk_icon_view_enable_model_drag_dest_w, 3, 0, 0, H_gtk_icon_view_enable_model_drag_dest, pl_tuug);
  Xg_define_procedure(gtk_about_dialog_get_logo, gxg_gtk_about_dialog_get_logo_w, 1, 0, 0, H_gtk_about_dialog_get_logo, pl_pu);
  Xg_define_procedure(gtk_about_dialog_set_logo, gxg_gtk_about_dialog_set_logo_w, 2, 0, 0, H_gtk_about_dialog_set_logo, pl_tu);
  Xg_define_procedure(gtk_button_new_from_icon_name, gxg_gtk_button_new_from_icon_name_w, 1, 0, 0, H_gtk_button_new_from_icon_name, pl_ps);
  Xg_define_procedure(gtk_cell_view_new_with_texture, gxg_gtk_cell_view_new_with_texture_w, 1, 0, 0, H_gtk_cell_view_new_with_texture, pl_pu);
  Xg_define_procedure(gtk_drag_finish, gxg_gtk_drag_finish_w, 3, 0, 0, H_gtk_drag_finish, pl_tubi);
  Xg_define_procedure(gtk_drag_set_icon_pixbuf, gxg_gtk_drag_set_icon_pixbuf_w, 4, 0, 0, H_gtk_drag_set_icon_pixbuf, pl_tuui);
  Xg_define_procedure(gtk_drag_dest_set, gxg_gtk_drag_dest_set_w, 4, 0, 0, H_gtk_drag_dest_set, pl_tugug);
  Xg_define_procedure(gtk_drag_dest_find_target, gxg_gtk_drag_dest_find_target_w, 3, 0, 0, H_gtk_drag_dest_find_target, pl_su);
  Xg_define_procedure(gtk_drag_dest_get_target_list, gxg_gtk_drag_dest_get_target_list_w, 1, 0, 0, H_gtk_drag_dest_get_target_list, pl_pu);
  Xg_define_procedure(gtk_drag_dest_set_target_list, gxg_gtk_drag_dest_set_target_list_w, 2, 0, 0, H_gtk_drag_dest_set_target_list, pl_tu);
  Xg_define_procedure(gtk_drag_source_set, gxg_gtk_drag_source_set_w, 4, 0, 0, H_gtk_drag_source_set, pl_tugug);
  Xg_define_procedure(gtk_drag_source_get_target_list, gxg_gtk_drag_source_get_target_list_w, 1, 0, 0, H_gtk_drag_source_get_target_list, pl_pu);
  Xg_define_procedure(gtk_drag_source_set_target_list, gxg_gtk_drag_source_set_target_list_w, 2, 0, 0, H_gtk_drag_source_set_target_list, pl_tu);
  Xg_define_procedure(gtk_scale_button_new, gxg_gtk_scale_button_new_w, 4, 0, 0, H_gtk_scale_button_new, pl_prrru);
  Xg_define_procedure(gtk_application_new, gxg_gtk_application_new_w, 2, 0, 0, H_gtk_application_new, pl_pst);
  Xg_define_procedure(gtk_application_add_window, gxg_gtk_application_add_window_w, 2, 0, 0, H_gtk_application_add_window, pl_tu);
  Xg_define_procedure(gtk_application_remove_window, gxg_gtk_application_remove_window_w, 2, 0, 0, H_gtk_application_remove_window, pl_tu);
  Xg_define_procedure(gtk_application_get_windows, gxg_gtk_application_get_windows_w, 1, 0, 0, H_gtk_application_get_windows, pl_pu);
  Xg_define_procedure(gtk_application_inhibit, gxg_gtk_application_inhibit_w, 4, 0, 0, H_gtk_application_inhibit, pl_iuugs);
  Xg_define_procedure(gtk_application_uninhibit, gxg_gtk_application_uninhibit_w, 2, 0, 0, H_gtk_application_uninhibit, pl_tui);
  Xg_define_procedure(gtk_application_get_window_by_id, gxg_gtk_application_get_window_by_id_w, 2, 0, 0, H_gtk_application_get_window_by_id, pl_pui);
  Xg_define_procedure(gtk_application_list_action_descriptions, gxg_gtk_application_list_action_descriptions_w, 1, 0, 0, H_gtk_application_list_action_descriptions, pl_pu);
  Xg_define_procedure(gtk_application_get_accels_for_action, gxg_gtk_application_get_accels_for_action_w, 2, 0, 0, H_gtk_application_get_accels_for_action, pl_pus);
  Xg_define_procedure(gtk_application_get_actions_for_accel, gxg_gtk_application_get_actions_for_accel_w, 2, 0, 0, H_gtk_application_get_actions_for_accel, pl_pus);
  Xg_define_procedure(gtk_application_set_accels_for_action, gxg_gtk_application_set_accels_for_action_w, 3, 0, 0, H_gtk_application_set_accels_for_action, pl_tus);
  Xg_define_procedure(gtk_application_prefers_app_menu, gxg_gtk_application_prefers_app_menu_w, 1, 0, 0, H_gtk_application_prefers_app_menu, pl_bu);
  Xg_define_procedure(gtk_application_get_menu_by_id, gxg_gtk_application_get_menu_by_id_w, 2, 0, 0, H_gtk_application_get_menu_by_id, pl_pus);
#endif

  Xg_define_procedure(cairo_create, gxg_cairo_create_w, 1, 0, 0, H_cairo_create, pl_pu);
  Xg_define_procedure(cairo_version, gxg_cairo_version_w, 0, 0, 0, H_cairo_version, pl_i);
  Xg_define_procedure(cairo_version_string, gxg_cairo_version_string_w, 0, 0, 0, H_cairo_version_string, pl_s);
  Xg_define_procedure(cairo_reference, gxg_cairo_reference_w, 1, 0, 0, H_cairo_reference, pl_pu);
  Xg_define_procedure(cairo_destroy, gxg_cairo_destroy_w, 1, 0, 0, H_cairo_destroy, pl_tu);
  Xg_define_procedure(cairo_save, gxg_cairo_save_w, 1, 0, 0, H_cairo_save, pl_tu);
  Xg_define_procedure(cairo_restore, gxg_cairo_restore_w, 1, 0, 0, H_cairo_restore, pl_tu);
  Xg_define_procedure(cairo_push_group, gxg_cairo_push_group_w, 1, 0, 0, H_cairo_push_group, pl_tu);
  Xg_define_procedure(cairo_push_group_with_content, gxg_cairo_push_group_with_content_w, 2, 0, 0, H_cairo_push_group_with_content, pl_tug);
  Xg_define_procedure(cairo_pop_group, gxg_cairo_pop_group_w, 1, 0, 0, H_cairo_pop_group, pl_pu);
  Xg_define_procedure(cairo_pop_group_to_source, gxg_cairo_pop_group_to_source_w, 1, 0, 0, H_cairo_pop_group_to_source, pl_tu);
  Xg_define_procedure(cairo_set_operator, gxg_cairo_set_operator_w, 2, 0, 0, H_cairo_set_operator, pl_tug);
  Xg_define_procedure(cairo_set_source, gxg_cairo_set_source_w, 2, 0, 0, H_cairo_set_source, pl_tu);
  Xg_define_procedure(cairo_set_source_rgb, gxg_cairo_set_source_rgb_w, 4, 0, 0, H_cairo_set_source_rgb, pl_tur);
  Xg_define_procedure(cairo_set_source_rgba, gxg_cairo_set_source_rgba_w, 5, 0, 0, H_cairo_set_source_rgba, pl_tur);
  Xg_define_procedure(cairo_set_source_surface, gxg_cairo_set_source_surface_w, 4, 0, 0, H_cairo_set_source_surface, pl_tuur);
  Xg_define_procedure(cairo_set_tolerance, gxg_cairo_set_tolerance_w, 2, 0, 0, H_cairo_set_tolerance, pl_tur);
  Xg_define_procedure(cairo_set_antialias, gxg_cairo_set_antialias_w, 2, 0, 0, H_cairo_set_antialias, pl_tug);
  Xg_define_procedure(cairo_set_fill_rule, gxg_cairo_set_fill_rule_w, 2, 0, 0, H_cairo_set_fill_rule, pl_tug);
  Xg_define_procedure(cairo_set_line_width, gxg_cairo_set_line_width_w, 2, 0, 0, H_cairo_set_line_width, pl_tur);
  Xg_define_procedure(cairo_set_line_cap, gxg_cairo_set_line_cap_w, 2, 0, 0, H_cairo_set_line_cap, pl_tug);
  Xg_define_procedure(cairo_set_line_join, gxg_cairo_set_line_join_w, 2, 0, 0, H_cairo_set_line_join, pl_tug);
  Xg_define_procedure(cairo_set_dash, gxg_cairo_set_dash_w, 4, 0, 0, H_cairo_set_dash, pl_tuuir);
  Xg_define_procedure(cairo_set_miter_limit, gxg_cairo_set_miter_limit_w, 2, 0, 0, H_cairo_set_miter_limit, pl_tur);
  Xg_define_procedure(cairo_translate, gxg_cairo_translate_w, 3, 0, 0, H_cairo_translate, pl_tur);
  Xg_define_procedure(cairo_scale, gxg_cairo_scale_w, 3, 0, 0, H_cairo_scale, pl_tur);
  Xg_define_procedure(cairo_rotate, gxg_cairo_rotate_w, 2, 0, 0, H_cairo_rotate, pl_tur);
  Xg_define_procedure(cairo_transform, gxg_cairo_transform_w, 2, 0, 0, H_cairo_transform, pl_tu);
  Xg_define_procedure(cairo_set_matrix, gxg_cairo_set_matrix_w, 2, 0, 0, H_cairo_set_matrix, pl_tu);
  Xg_define_procedure(cairo_identity_matrix, gxg_cairo_identity_matrix_w, 1, 0, 0, H_cairo_identity_matrix, pl_tu);
  Xg_define_procedure(cairo_user_to_device, gxg_cairo_user_to_device_w, 1, 2, 0, H_cairo_user_to_device, pl_pu);
  Xg_define_procedure(cairo_user_to_device_distance, gxg_cairo_user_to_device_distance_w, 1, 2, 0, H_cairo_user_to_device_distance, pl_pu);
  Xg_define_procedure(cairo_device_to_user, gxg_cairo_device_to_user_w, 1, 2, 0, H_cairo_device_to_user, pl_pu);
  Xg_define_procedure(cairo_device_to_user_distance, gxg_cairo_device_to_user_distance_w, 1, 2, 0, H_cairo_device_to_user_distance, pl_pu);
  Xg_define_procedure(cairo_new_path, gxg_cairo_new_path_w, 1, 0, 0, H_cairo_new_path, pl_tu);
  Xg_define_procedure(cairo_move_to, gxg_cairo_move_to_w, 3, 0, 0, H_cairo_move_to, pl_tur);
  Xg_define_procedure(cairo_new_sub_path, gxg_cairo_new_sub_path_w, 1, 0, 0, H_cairo_new_sub_path, pl_tu);
  Xg_define_procedure(cairo_line_to, gxg_cairo_line_to_w, 3, 0, 0, H_cairo_line_to, pl_tur);
  Xg_define_procedure(cairo_curve_to, gxg_cairo_curve_to_w, 7, 0, 0, H_cairo_curve_to, pl_tur);
  Xg_define_procedure(cairo_arc, gxg_cairo_arc_w, 6, 0, 0, H_cairo_arc, pl_tur);
  Xg_define_procedure(cairo_arc_negative, gxg_cairo_arc_negative_w, 6, 0, 0, H_cairo_arc_negative, pl_tur);
  Xg_define_procedure(cairo_rel_move_to, gxg_cairo_rel_move_to_w, 3, 0, 0, H_cairo_rel_move_to, pl_tur);
  Xg_define_procedure(cairo_rel_line_to, gxg_cairo_rel_line_to_w, 3, 0, 0, H_cairo_rel_line_to, pl_tur);
  Xg_define_procedure(cairo_rel_curve_to, gxg_cairo_rel_curve_to_w, 7, 0, 0, H_cairo_rel_curve_to, pl_tur);
  Xg_define_procedure(cairo_rectangle, gxg_cairo_rectangle_w, 5, 0, 0, H_cairo_rectangle, pl_tur);
  Xg_define_procedure(cairo_close_path, gxg_cairo_close_path_w, 1, 0, 0, H_cairo_close_path, pl_tu);
  Xg_define_procedure(cairo_paint, gxg_cairo_paint_w, 1, 0, 0, H_cairo_paint, pl_tu);
  Xg_define_procedure(cairo_paint_with_alpha, gxg_cairo_paint_with_alpha_w, 2, 0, 0, H_cairo_paint_with_alpha, pl_tur);
  Xg_define_procedure(cairo_mask, gxg_cairo_mask_w, 2, 0, 0, H_cairo_mask, pl_tu);
  Xg_define_procedure(cairo_mask_surface, gxg_cairo_mask_surface_w, 4, 0, 0, H_cairo_mask_surface, pl_tuur);
  Xg_define_procedure(cairo_stroke, gxg_cairo_stroke_w, 1, 0, 0, H_cairo_stroke, pl_tu);
  Xg_define_procedure(cairo_stroke_preserve, gxg_cairo_stroke_preserve_w, 1, 0, 0, H_cairo_stroke_preserve, pl_tu);
  Xg_define_procedure(cairo_fill, gxg_cairo_fill_w, 1, 0, 0, H_cairo_fill, pl_tu);
  Xg_define_procedure(cairo_fill_preserve, gxg_cairo_fill_preserve_w, 1, 0, 0, H_cairo_fill_preserve, pl_tu);
  Xg_define_procedure(cairo_copy_page, gxg_cairo_copy_page_w, 1, 0, 0, H_cairo_copy_page, pl_tu);
  Xg_define_procedure(cairo_show_page, gxg_cairo_show_page_w, 1, 0, 0, H_cairo_show_page, pl_tu);
  Xg_define_procedure(cairo_in_stroke, gxg_cairo_in_stroke_w, 3, 0, 0, H_cairo_in_stroke, pl_bur);
  Xg_define_procedure(cairo_in_fill, gxg_cairo_in_fill_w, 3, 0, 0, H_cairo_in_fill, pl_bur);
  Xg_define_procedure(cairo_reset_clip, gxg_cairo_reset_clip_w, 1, 0, 0, H_cairo_reset_clip, pl_tu);
  Xg_define_procedure(cairo_clip, gxg_cairo_clip_w, 1, 0, 0, H_cairo_clip, pl_tu);
  Xg_define_procedure(cairo_clip_preserve, gxg_cairo_clip_preserve_w, 1, 0, 0, H_cairo_clip_preserve, pl_tu);
  Xg_define_procedure(cairo_font_options_create, gxg_cairo_font_options_create_w, 0, 0, 0, H_cairo_font_options_create, pl_p);
  Xg_define_procedure(cairo_font_options_copy, gxg_cairo_font_options_copy_w, 1, 0, 0, H_cairo_font_options_copy, pl_pu);
  Xg_define_procedure(cairo_font_options_destroy, gxg_cairo_font_options_destroy_w, 1, 0, 0, H_cairo_font_options_destroy, pl_tu);
  Xg_define_procedure(cairo_font_options_status, gxg_cairo_font_options_status_w, 1, 0, 0, H_cairo_font_options_status, pl_gu);
  Xg_define_procedure(cairo_font_options_merge, gxg_cairo_font_options_merge_w, 2, 0, 0, H_cairo_font_options_merge, pl_tu);
  Xg_define_procedure(cairo_font_options_equal, gxg_cairo_font_options_equal_w, 2, 0, 0, H_cairo_font_options_equal, pl_bu);
  Xg_define_procedure(cairo_font_options_hash, gxg_cairo_font_options_hash_w, 1, 0, 0, H_cairo_font_options_hash, pl_iu);
  Xg_define_procedure(cairo_font_options_set_antialias, gxg_cairo_font_options_set_antialias_w, 2, 0, 0, H_cairo_font_options_set_antialias, pl_tug);
  Xg_define_procedure(cairo_font_options_get_antialias, gxg_cairo_font_options_get_antialias_w, 1, 0, 0, H_cairo_font_options_get_antialias, pl_gu);
  Xg_define_procedure(cairo_font_options_set_subpixel_order, gxg_cairo_font_options_set_subpixel_order_w, 2, 0, 0, H_cairo_font_options_set_subpixel_order, pl_tug);
  Xg_define_procedure(cairo_font_options_get_subpixel_order, gxg_cairo_font_options_get_subpixel_order_w, 1, 0, 0, H_cairo_font_options_get_subpixel_order, pl_gu);
  Xg_define_procedure(cairo_font_options_set_hint_style, gxg_cairo_font_options_set_hint_style_w, 2, 0, 0, H_cairo_font_options_set_hint_style, pl_tug);
  Xg_define_procedure(cairo_font_options_get_hint_style, gxg_cairo_font_options_get_hint_style_w, 1, 0, 0, H_cairo_font_options_get_hint_style, pl_gu);
  Xg_define_procedure(cairo_font_options_set_hint_metrics, gxg_cairo_font_options_set_hint_metrics_w, 2, 0, 0, H_cairo_font_options_set_hint_metrics, pl_tug);
  Xg_define_procedure(cairo_font_options_get_hint_metrics, gxg_cairo_font_options_get_hint_metrics_w, 1, 0, 0, H_cairo_font_options_get_hint_metrics, pl_gu);
  Xg_define_procedure(cairo_select_font_face, gxg_cairo_select_font_face_w, 4, 0, 0, H_cairo_select_font_face, pl_tusg);
  Xg_define_procedure(cairo_set_font_size, gxg_cairo_set_font_size_w, 2, 0, 0, H_cairo_set_font_size, pl_tur);
  Xg_define_procedure(cairo_set_font_matrix, gxg_cairo_set_font_matrix_w, 2, 0, 0, H_cairo_set_font_matrix, pl_tu);
  Xg_define_procedure(cairo_get_font_matrix, gxg_cairo_get_font_matrix_w, 2, 0, 0, H_cairo_get_font_matrix, pl_tu);
  Xg_define_procedure(cairo_set_font_options, gxg_cairo_set_font_options_w, 2, 0, 0, H_cairo_set_font_options, pl_tu);
  Xg_define_procedure(cairo_get_font_options, gxg_cairo_get_font_options_w, 2, 0, 0, H_cairo_get_font_options, pl_tu);
  Xg_define_procedure(cairo_set_scaled_font, gxg_cairo_set_scaled_font_w, 2, 0, 0, H_cairo_set_scaled_font, pl_tu);
  Xg_define_procedure(cairo_show_text, gxg_cairo_show_text_w, 2, 0, 0, H_cairo_show_text, pl_tus);
  Xg_define_procedure(cairo_show_glyphs, gxg_cairo_show_glyphs_w, 3, 0, 0, H_cairo_show_glyphs, pl_tuui);
  Xg_define_procedure(cairo_get_font_face, gxg_cairo_get_font_face_w, 1, 0, 0, H_cairo_get_font_face, pl_pu);
  Xg_define_procedure(cairo_font_extents, gxg_cairo_font_extents_w, 2, 0, 0, H_cairo_font_extents, pl_tu);
  Xg_define_procedure(cairo_set_font_face, gxg_cairo_set_font_face_w, 2, 0, 0, H_cairo_set_font_face, pl_tu);
  Xg_define_procedure(cairo_text_extents, gxg_cairo_text_extents_w, 3, 0, 0, H_cairo_text_extents, pl_tusu);
  Xg_define_procedure(cairo_glyph_extents, gxg_cairo_glyph_extents_w, 4, 0, 0, H_cairo_glyph_extents, pl_tuuiu);
  Xg_define_procedure(cairo_text_path, gxg_cairo_text_path_w, 2, 0, 0, H_cairo_text_path, pl_tus);
  Xg_define_procedure(cairo_glyph_path, gxg_cairo_glyph_path_w, 3, 0, 0, H_cairo_glyph_path, pl_tuui);
  Xg_define_procedure(cairo_font_face_reference, gxg_cairo_font_face_reference_w, 1, 0, 0, H_cairo_font_face_reference, pl_pu);
  Xg_define_procedure(cairo_font_face_destroy, gxg_cairo_font_face_destroy_w, 1, 0, 0, H_cairo_font_face_destroy, pl_tu);
  Xg_define_procedure(cairo_font_face_status, gxg_cairo_font_face_status_w, 1, 0, 0, H_cairo_font_face_status, pl_gu);
  Xg_define_procedure(cairo_font_face_get_user_data, gxg_cairo_font_face_get_user_data_w, 2, 0, 0, H_cairo_font_face_get_user_data, pl_tu);
  Xg_define_procedure(cairo_font_face_set_user_data, gxg_cairo_font_face_set_user_data_w, 4, 0, 0, H_cairo_font_face_set_user_data, pl_guut);
  Xg_define_procedure(cairo_scaled_font_create, gxg_cairo_scaled_font_create_w, 4, 0, 0, H_cairo_scaled_font_create, pl_pu);
  Xg_define_procedure(cairo_scaled_font_reference, gxg_cairo_scaled_font_reference_w, 1, 0, 0, H_cairo_scaled_font_reference, pl_pu);
  Xg_define_procedure(cairo_scaled_font_destroy, gxg_cairo_scaled_font_destroy_w, 1, 0, 0, H_cairo_scaled_font_destroy, pl_tu);
  Xg_define_procedure(cairo_scaled_font_status, gxg_cairo_scaled_font_status_w, 1, 0, 0, H_cairo_scaled_font_status, pl_gu);
  Xg_define_procedure(cairo_scaled_font_extents, gxg_cairo_scaled_font_extents_w, 2, 0, 0, H_cairo_scaled_font_extents, pl_tu);
  Xg_define_procedure(cairo_scaled_font_text_extents, gxg_cairo_scaled_font_text_extents_w, 3, 0, 0, H_cairo_scaled_font_text_extents, pl_tusu);
  Xg_define_procedure(cairo_scaled_font_glyph_extents, gxg_cairo_scaled_font_glyph_extents_w, 4, 0, 0, H_cairo_scaled_font_glyph_extents, pl_tuuiu);
  Xg_define_procedure(cairo_scaled_font_get_font_face, gxg_cairo_scaled_font_get_font_face_w, 1, 0, 0, H_cairo_scaled_font_get_font_face, pl_pu);
  Xg_define_procedure(cairo_scaled_font_get_font_matrix, gxg_cairo_scaled_font_get_font_matrix_w, 2, 0, 0, H_cairo_scaled_font_get_font_matrix, pl_tu);
  Xg_define_procedure(cairo_scaled_font_get_ctm, gxg_cairo_scaled_font_get_ctm_w, 2, 0, 0, H_cairo_scaled_font_get_ctm, pl_tu);
  Xg_define_procedure(cairo_scaled_font_get_font_options, gxg_cairo_scaled_font_get_font_options_w, 2, 0, 0, H_cairo_scaled_font_get_font_options, pl_tu);
  Xg_define_procedure(cairo_get_operator, gxg_cairo_get_operator_w, 1, 0, 0, H_cairo_get_operator, pl_gu);
  Xg_define_procedure(cairo_get_source, gxg_cairo_get_source_w, 1, 0, 0, H_cairo_get_source, pl_pu);
  Xg_define_procedure(cairo_get_tolerance, gxg_cairo_get_tolerance_w, 1, 0, 0, H_cairo_get_tolerance, pl_du);
  Xg_define_procedure(cairo_get_antialias, gxg_cairo_get_antialias_w, 1, 0, 0, H_cairo_get_antialias, pl_gu);
  Xg_define_procedure(cairo_get_current_point, gxg_cairo_get_current_point_w, 1, 2, 0, H_cairo_get_current_point, pl_pu);
  Xg_define_procedure(cairo_get_fill_rule, gxg_cairo_get_fill_rule_w, 1, 0, 0, H_cairo_get_fill_rule, pl_gu);
  Xg_define_procedure(cairo_get_line_width, gxg_cairo_get_line_width_w, 1, 0, 0, H_cairo_get_line_width, pl_du);
  Xg_define_procedure(cairo_get_line_cap, gxg_cairo_get_line_cap_w, 1, 0, 0, H_cairo_get_line_cap, pl_gu);
  Xg_define_procedure(cairo_get_line_join, gxg_cairo_get_line_join_w, 1, 0, 0, H_cairo_get_line_join, pl_gu);
  Xg_define_procedure(cairo_get_miter_limit, gxg_cairo_get_miter_limit_w, 1, 0, 0, H_cairo_get_miter_limit, pl_du);
  Xg_define_procedure(cairo_get_matrix, gxg_cairo_get_matrix_w, 2, 0, 0, H_cairo_get_matrix, pl_tu);
  Xg_define_procedure(cairo_get_target, gxg_cairo_get_target_w, 1, 0, 0, H_cairo_get_target, pl_pu);
  Xg_define_procedure(cairo_get_group_target, gxg_cairo_get_group_target_w, 1, 0, 0, H_cairo_get_group_target, pl_pu);
  Xg_define_procedure(cairo_copy_path, gxg_cairo_copy_path_w, 1, 0, 0, H_cairo_copy_path, pl_pu);
  Xg_define_procedure(cairo_copy_path_flat, gxg_cairo_copy_path_flat_w, 1, 0, 0, H_cairo_copy_path_flat, pl_pu);
  Xg_define_procedure(cairo_append_path, gxg_cairo_append_path_w, 2, 0, 0, H_cairo_append_path, pl_tu);
  Xg_define_procedure(cairo_path_destroy, gxg_cairo_path_destroy_w, 1, 0, 0, H_cairo_path_destroy, pl_tu);
  Xg_define_procedure(cairo_status, gxg_cairo_status_w, 1, 0, 0, H_cairo_status, pl_gu);
  Xg_define_procedure(cairo_status_to_string, gxg_cairo_status_to_string_w, 1, 0, 0, H_cairo_status_to_string, pl_sg);
  Xg_define_procedure(cairo_surface_create_similar, gxg_cairo_surface_create_similar_w, 4, 0, 0, H_cairo_surface_create_similar, pl_pugi);
  Xg_define_procedure(cairo_surface_reference, gxg_cairo_surface_reference_w, 1, 0, 0, H_cairo_surface_reference, pl_pu);
  Xg_define_procedure(cairo_surface_finish, gxg_cairo_surface_finish_w, 1, 0, 0, H_cairo_surface_finish, pl_tu);
  Xg_define_procedure(cairo_surface_destroy, gxg_cairo_surface_destroy_w, 1, 0, 0, H_cairo_surface_destroy, pl_tu);
  Xg_define_procedure(cairo_surface_status, gxg_cairo_surface_status_w, 1, 0, 0, H_cairo_surface_status, pl_gu);
  Xg_define_procedure(cairo_surface_get_content, gxg_cairo_surface_get_content_w, 1, 0, 0, H_cairo_surface_get_content, pl_gu);
  Xg_define_procedure(cairo_surface_get_user_data, gxg_cairo_surface_get_user_data_w, 2, 0, 0, H_cairo_surface_get_user_data, pl_tu);
  Xg_define_procedure(cairo_surface_set_user_data, gxg_cairo_surface_set_user_data_w, 4, 0, 0, H_cairo_surface_set_user_data, pl_guut);
  Xg_define_procedure(cairo_surface_get_font_options, gxg_cairo_surface_get_font_options_w, 2, 0, 0, H_cairo_surface_get_font_options, pl_tu);
  Xg_define_procedure(cairo_surface_flush, gxg_cairo_surface_flush_w, 1, 0, 0, H_cairo_surface_flush, pl_tu);
  Xg_define_procedure(cairo_surface_mark_dirty, gxg_cairo_surface_mark_dirty_w, 1, 0, 0, H_cairo_surface_mark_dirty, pl_tu);
  Xg_define_procedure(cairo_surface_mark_dirty_rectangle, gxg_cairo_surface_mark_dirty_rectangle_w, 5, 0, 0, H_cairo_surface_mark_dirty_rectangle, pl_tui);
  Xg_define_procedure(cairo_surface_set_device_offset, gxg_cairo_surface_set_device_offset_w, 3, 0, 0, H_cairo_surface_set_device_offset, pl_tur);
  Xg_define_procedure(cairo_surface_get_device_offset, gxg_cairo_surface_get_device_offset_w, 1, 2, 0, H_cairo_surface_get_device_offset, pl_pu);
  Xg_define_procedure(cairo_surface_set_fallback_resolution, gxg_cairo_surface_set_fallback_resolution_w, 3, 0, 0, H_cairo_surface_set_fallback_resolution, pl_tur);
  Xg_define_procedure(cairo_image_surface_create, gxg_cairo_image_surface_create_w, 3, 0, 0, H_cairo_image_surface_create, pl_pgi);
  Xg_define_procedure(cairo_image_surface_create_for_data, gxg_cairo_image_surface_create_for_data_w, 5, 0, 0, H_cairo_image_surface_create_for_data, pl_psgi);
  Xg_define_procedure(cairo_image_surface_get_data, gxg_cairo_image_surface_get_data_w, 1, 0, 0, H_cairo_image_surface_get_data, pl_su);
  Xg_define_procedure(cairo_image_surface_get_format, gxg_cairo_image_surface_get_format_w, 1, 0, 0, H_cairo_image_surface_get_format, pl_gu);
  Xg_define_procedure(cairo_image_surface_get_width, gxg_cairo_image_surface_get_width_w, 1, 0, 0, H_cairo_image_surface_get_width, pl_iu);
  Xg_define_procedure(cairo_image_surface_get_height, gxg_cairo_image_surface_get_height_w, 1, 0, 0, H_cairo_image_surface_get_height, pl_iu);
  Xg_define_procedure(cairo_image_surface_get_stride, gxg_cairo_image_surface_get_stride_w, 1, 0, 0, H_cairo_image_surface_get_stride, pl_iu);
  Xg_define_procedure(cairo_pattern_create_rgb, gxg_cairo_pattern_create_rgb_w, 3, 0, 0, H_cairo_pattern_create_rgb, pl_pr);
  Xg_define_procedure(cairo_pattern_create_rgba, gxg_cairo_pattern_create_rgba_w, 4, 0, 0, H_cairo_pattern_create_rgba, pl_pr);
  Xg_define_procedure(cairo_pattern_create_for_surface, gxg_cairo_pattern_create_for_surface_w, 1, 0, 0, H_cairo_pattern_create_for_surface, pl_pu);
  Xg_define_procedure(cairo_pattern_create_linear, gxg_cairo_pattern_create_linear_w, 4, 0, 0, H_cairo_pattern_create_linear, pl_pr);
  Xg_define_procedure(cairo_pattern_create_radial, gxg_cairo_pattern_create_radial_w, 6, 0, 0, H_cairo_pattern_create_radial, pl_pr);
  Xg_define_procedure(cairo_pattern_reference, gxg_cairo_pattern_reference_w, 1, 0, 0, H_cairo_pattern_reference, pl_pu);
  Xg_define_procedure(cairo_pattern_destroy, gxg_cairo_pattern_destroy_w, 1, 0, 0, H_cairo_pattern_destroy, pl_tu);
  Xg_define_procedure(cairo_pattern_status, gxg_cairo_pattern_status_w, 1, 0, 0, H_cairo_pattern_status, pl_gu);
  Xg_define_procedure(cairo_pattern_add_color_stop_rgb, gxg_cairo_pattern_add_color_stop_rgb_w, 5, 0, 0, H_cairo_pattern_add_color_stop_rgb, pl_tur);
  Xg_define_procedure(cairo_pattern_add_color_stop_rgba, gxg_cairo_pattern_add_color_stop_rgba_w, 6, 0, 0, H_cairo_pattern_add_color_stop_rgba, pl_tur);
  Xg_define_procedure(cairo_pattern_set_matrix, gxg_cairo_pattern_set_matrix_w, 2, 0, 0, H_cairo_pattern_set_matrix, pl_tu);
  Xg_define_procedure(cairo_pattern_get_matrix, gxg_cairo_pattern_get_matrix_w, 2, 0, 0, H_cairo_pattern_get_matrix, pl_tu);
  Xg_define_procedure(cairo_pattern_set_extend, gxg_cairo_pattern_set_extend_w, 2, 0, 0, H_cairo_pattern_set_extend, pl_tug);
  Xg_define_procedure(cairo_pattern_get_extend, gxg_cairo_pattern_get_extend_w, 1, 0, 0, H_cairo_pattern_get_extend, pl_gu);
  Xg_define_procedure(cairo_pattern_set_filter, gxg_cairo_pattern_set_filter_w, 2, 0, 0, H_cairo_pattern_set_filter, pl_tug);
  Xg_define_procedure(cairo_pattern_get_filter, gxg_cairo_pattern_get_filter_w, 1, 0, 0, H_cairo_pattern_get_filter, pl_gu);
  Xg_define_procedure(cairo_matrix_init, gxg_cairo_matrix_init_w, 7, 0, 0, H_cairo_matrix_init, pl_tur);
  Xg_define_procedure(cairo_matrix_init_identity, gxg_cairo_matrix_init_identity_w, 1, 0, 0, H_cairo_matrix_init_identity, pl_tu);
  Xg_define_procedure(cairo_matrix_init_translate, gxg_cairo_matrix_init_translate_w, 3, 0, 0, H_cairo_matrix_init_translate, pl_tur);
  Xg_define_procedure(cairo_matrix_init_scale, gxg_cairo_matrix_init_scale_w, 3, 0, 0, H_cairo_matrix_init_scale, pl_tur);
  Xg_define_procedure(cairo_matrix_init_rotate, gxg_cairo_matrix_init_rotate_w, 2, 0, 0, H_cairo_matrix_init_rotate, pl_tur);
  Xg_define_procedure(cairo_matrix_translate, gxg_cairo_matrix_translate_w, 3, 0, 0, H_cairo_matrix_translate, pl_tur);
  Xg_define_procedure(cairo_matrix_scale, gxg_cairo_matrix_scale_w, 3, 0, 0, H_cairo_matrix_scale, pl_tur);
  Xg_define_procedure(cairo_matrix_rotate, gxg_cairo_matrix_rotate_w, 2, 0, 0, H_cairo_matrix_rotate, pl_tur);
  Xg_define_procedure(cairo_matrix_invert, gxg_cairo_matrix_invert_w, 1, 0, 0, H_cairo_matrix_invert, pl_gu);
  Xg_define_procedure(cairo_matrix_multiply, gxg_cairo_matrix_multiply_w, 3, 0, 0, H_cairo_matrix_multiply, pl_tu);
  Xg_define_procedure(cairo_matrix_transform_distance, gxg_cairo_matrix_transform_distance_w, 1, 2, 0, H_cairo_matrix_transform_distance, pl_pu);
  Xg_define_procedure(cairo_matrix_transform_point, gxg_cairo_matrix_transform_point_w, 1, 2, 0, H_cairo_matrix_transform_point, pl_pu);
  Xg_define_procedure(cairo_get_reference_count, gxg_cairo_get_reference_count_w, 1, 0, 0, H_cairo_get_reference_count, pl_iu);
  Xg_define_procedure(cairo_get_user_data, gxg_cairo_get_user_data_w, 2, 0, 0, H_cairo_get_user_data, pl_pu);
  Xg_define_procedure(cairo_set_user_data, gxg_cairo_set_user_data_w, 4, 0, 0, H_cairo_set_user_data, pl_guuut);
  Xg_define_procedure(cairo_clip_extents, gxg_cairo_clip_extents_w, 1, 4, 0, H_cairo_clip_extents, pl_pu);
  Xg_define_procedure(cairo_copy_clip_rectangle_list, gxg_cairo_copy_clip_rectangle_list_w, 1, 0, 0, H_cairo_copy_clip_rectangle_list, pl_pu);
  Xg_define_procedure(cairo_rectangle_list_destroy, gxg_cairo_rectangle_list_destroy_w, 1, 0, 0, H_cairo_rectangle_list_destroy, pl_tu);
  Xg_define_procedure(cairo_font_face_get_reference_count, gxg_cairo_font_face_get_reference_count_w, 1, 0, 0, H_cairo_font_face_get_reference_count, pl_iu);
  Xg_define_procedure(cairo_scaled_font_get_reference_count, gxg_cairo_scaled_font_get_reference_count_w, 1, 0, 0, H_cairo_scaled_font_get_reference_count, pl_iu);
  Xg_define_procedure(cairo_scaled_font_get_user_data, gxg_cairo_scaled_font_get_user_data_w, 2, 0, 0, H_cairo_scaled_font_get_user_data, pl_pu);
  Xg_define_procedure(cairo_scaled_font_set_user_data, gxg_cairo_scaled_font_set_user_data_w, 4, 0, 0, H_cairo_scaled_font_set_user_data, pl_guuut);
  Xg_define_procedure(cairo_get_dash_count, gxg_cairo_get_dash_count_w, 1, 0, 0, H_cairo_get_dash_count, pl_iu);
  Xg_define_procedure(cairo_get_dash, gxg_cairo_get_dash_w, 1, 2, 0, H_cairo_get_dash, pl_pu);
  Xg_define_procedure(cairo_surface_get_reference_count, gxg_cairo_surface_get_reference_count_w, 1, 0, 0, H_cairo_surface_get_reference_count, pl_iu);
  Xg_define_procedure(cairo_pattern_get_reference_count, gxg_cairo_pattern_get_reference_count_w, 1, 0, 0, H_cairo_pattern_get_reference_count, pl_iu);
  Xg_define_procedure(cairo_pattern_get_user_data, gxg_cairo_pattern_get_user_data_w, 2, 0, 0, H_cairo_pattern_get_user_data, pl_pu);
  Xg_define_procedure(cairo_pattern_set_user_data, gxg_cairo_pattern_set_user_data_w, 4, 0, 0, H_cairo_pattern_set_user_data, pl_guuut);
  Xg_define_procedure(cairo_pattern_get_rgba, gxg_cairo_pattern_get_rgba_w, 1, 4, 0, H_cairo_pattern_get_rgba, pl_pu);
  Xg_define_procedure(cairo_pattern_get_surface, gxg_cairo_pattern_get_surface_w, 1, 1, 0, H_cairo_pattern_get_surface, pl_pu);
  Xg_define_procedure(cairo_pattern_get_color_stop_rgba, gxg_cairo_pattern_get_color_stop_rgba_w, 2, 5, 0, H_cairo_pattern_get_color_stop_rgba, pl_puiu);
  Xg_define_procedure(cairo_pattern_get_color_stop_count, gxg_cairo_pattern_get_color_stop_count_w, 1, 1, 0, H_cairo_pattern_get_color_stop_count, pl_pu);
  Xg_define_procedure(cairo_pattern_get_linear_points, gxg_cairo_pattern_get_linear_points_w, 1, 4, 0, H_cairo_pattern_get_linear_points, pl_pu);
  Xg_define_procedure(cairo_pattern_get_radial_circles, gxg_cairo_pattern_get_radial_circles_w, 1, 6, 0, H_cairo_pattern_get_radial_circles, pl_pu);
  Xg_define_procedure(cairo_get_scaled_font, gxg_cairo_get_scaled_font_w, 1, 0, 0, H_cairo_get_scaled_font, pl_pu);
  Xg_define_procedure(cairo_path_extents, gxg_cairo_path_extents_w, 1, 4, 0, H_cairo_path_extents, pl_pu);
  Xg_define_procedure(cairo_has_current_point, gxg_cairo_has_current_point_w, 1, 0, 0, H_cairo_has_current_point, pl_bu);
  Xg_define_procedure(cairo_surface_copy_page, gxg_cairo_surface_copy_page_w, 1, 0, 0, H_cairo_surface_copy_page, pl_tu);
  Xg_define_procedure(cairo_surface_show_page, gxg_cairo_surface_show_page_w, 1, 0, 0, H_cairo_surface_show_page, pl_tu);
  Xg_define_procedure(cairo_format_stride_for_width, gxg_cairo_format_stride_for_width_w, 2, 0, 0, H_cairo_format_stride_for_width, pl_igi);
  Xg_define_procedure(cairo_image_surface_create_from_png, gxg_cairo_image_surface_create_from_png_w, 1, 0, 0, H_cairo_image_surface_create_from_png, pl_ps);
  Xg_define_procedure(cairo_surface_write_to_png, gxg_cairo_surface_write_to_png_w, 2, 0, 0, H_cairo_surface_write_to_png, pl_gus);
#if HAVE_CAIRO_1_8
  Xg_define_procedure(cairo_glyph_allocate, gxg_cairo_glyph_allocate_w, 1, 0, 0, H_cairo_glyph_allocate, pl_pi);
  Xg_define_procedure(cairo_glyph_free, gxg_cairo_glyph_free_w, 1, 0, 0, H_cairo_glyph_free, pl_tu);
  Xg_define_procedure(cairo_text_cluster_allocate, gxg_cairo_text_cluster_allocate_w, 1, 0, 0, H_cairo_text_cluster_allocate, pl_pi);
  Xg_define_procedure(cairo_text_cluster_free, gxg_cairo_text_cluster_free_w, 1, 0, 0, H_cairo_text_cluster_free, pl_tu);
  Xg_define_procedure(cairo_show_text_glyphs, gxg_cairo_show_text_glyphs_w, 0, 0, 1, H_cairo_show_text_glyphs, pl_tusiuiui);
  Xg_define_procedure(cairo_scaled_font_text_to_glyphs, gxg_cairo_scaled_font_text_to_glyphs_w, 0, 0, 1, H_cairo_scaled_font_text_to_glyphs, pl_gurrsiu);
  Xg_define_procedure(cairo_scaled_font_get_scale_matrix, gxg_cairo_scaled_font_get_scale_matrix_w, 2, 0, 0, H_cairo_scaled_font_get_scale_matrix, pl_tu);
  Xg_define_procedure(cairo_toy_font_face_create, gxg_cairo_toy_font_face_create_w, 3, 0, 0, H_cairo_toy_font_face_create, pl_psg);
  Xg_define_procedure(cairo_toy_font_face_get_family, gxg_cairo_toy_font_face_get_family_w, 1, 0, 0, H_cairo_toy_font_face_get_family, pl_su);
  Xg_define_procedure(cairo_toy_font_face_get_slant, gxg_cairo_toy_font_face_get_slant_w, 1, 0, 0, H_cairo_toy_font_face_get_slant, pl_gu);
  Xg_define_procedure(cairo_toy_font_face_get_weight, gxg_cairo_toy_font_face_get_weight_w, 1, 0, 0, H_cairo_toy_font_face_get_weight, pl_gu);
  Xg_define_procedure(cairo_user_font_face_create, gxg_cairo_user_font_face_create_w, 0, 0, 0, H_cairo_user_font_face_create, pl_p);
  Xg_define_procedure(cairo_surface_get_fallback_resolution, gxg_cairo_surface_get_fallback_resolution_w, 1, 2, 0, H_cairo_surface_get_fallback_resolution, pl_pu);
  Xg_define_procedure(cairo_surface_has_show_text_glyphs, gxg_cairo_surface_has_show_text_glyphs_w, 1, 0, 0, H_cairo_surface_has_show_text_glyphs, pl_iu);
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
  Xg_define_procedure(cairo_in_clip, gxg_cairo_in_clip_w, 3, 0, 0, H_cairo_in_clip, pl_iur);
  Xg_define_procedure(cairo_device_reference, gxg_cairo_device_reference_w, 1, 0, 0, H_cairo_device_reference, pl_pu);
  Xg_define_procedure(cairo_device_status, gxg_cairo_device_status_w, 1, 0, 0, H_cairo_device_status, pl_gu);
  Xg_define_procedure(cairo_device_acquire, gxg_cairo_device_acquire_w, 1, 0, 0, H_cairo_device_acquire, pl_gu);
  Xg_define_procedure(cairo_device_release, gxg_cairo_device_release_w, 1, 0, 0, H_cairo_device_release, pl_tu);
  Xg_define_procedure(cairo_device_flush, gxg_cairo_device_flush_w, 1, 0, 0, H_cairo_device_flush, pl_tu);
  Xg_define_procedure(cairo_device_finish, gxg_cairo_device_finish_w, 1, 0, 0, H_cairo_device_finish, pl_tu);
  Xg_define_procedure(cairo_device_destroy, gxg_cairo_device_destroy_w, 1, 0, 0, H_cairo_device_destroy, pl_tu);
  Xg_define_procedure(cairo_device_get_reference_count, gxg_cairo_device_get_reference_count_w, 1, 0, 0, H_cairo_device_get_reference_count, pl_iu);
  Xg_define_procedure(cairo_device_get_user_data, gxg_cairo_device_get_user_data_w, 2, 0, 0, H_cairo_device_get_user_data, pl_pu);
  Xg_define_procedure(cairo_device_set_user_data, gxg_cairo_device_set_user_data_w, 4, 0, 0, H_cairo_device_set_user_data, pl_guuut);
  Xg_define_procedure(cairo_surface_create_for_rectangle, gxg_cairo_surface_create_for_rectangle_w, 5, 0, 0, H_cairo_surface_create_for_rectangle, pl_pur);
  Xg_define_procedure(cairo_surface_get_device, gxg_cairo_surface_get_device_w, 1, 0, 0, H_cairo_surface_get_device, pl_pu);
  Xg_define_procedure(cairo_surface_set_mime_data, gxg_cairo_surface_set_mime_data_w, 6, 0, 0, H_cairo_surface_set_mime_data, pl_gussitu);
  Xg_define_procedure(cairo_recording_surface_create, gxg_cairo_recording_surface_create_w, 2, 0, 0, H_cairo_recording_surface_create, pl_pgu);
  Xg_define_procedure(cairo_recording_surface_ink_extents, gxg_cairo_recording_surface_ink_extents_w, 5, 0, 0, H_cairo_recording_surface_ink_extents, pl_tu);
  Xg_define_procedure(cairo_region_create, gxg_cairo_region_create_w, 0, 0, 0, H_cairo_region_create, pl_p);
  Xg_define_procedure(cairo_region_create_rectangle, gxg_cairo_region_create_rectangle_w, 1, 0, 0, H_cairo_region_create_rectangle, pl_pu);
  Xg_define_procedure(cairo_region_create_rectangles, gxg_cairo_region_create_rectangles_w, 2, 0, 0, H_cairo_region_create_rectangles, pl_pui);
  Xg_define_procedure(cairo_region_copy, gxg_cairo_region_copy_w, 1, 0, 0, H_cairo_region_copy, pl_pu);
  Xg_define_procedure(cairo_region_reference, gxg_cairo_region_reference_w, 1, 0, 0, H_cairo_region_reference, pl_pu);
  Xg_define_procedure(cairo_region_destroy, gxg_cairo_region_destroy_w, 1, 0, 0, H_cairo_region_destroy, pl_tu);
  Xg_define_procedure(cairo_region_equal, gxg_cairo_region_equal_w, 2, 0, 0, H_cairo_region_equal, pl_iu);
  Xg_define_procedure(cairo_region_status, gxg_cairo_region_status_w, 1, 0, 0, H_cairo_region_status, pl_gu);
  Xg_define_procedure(cairo_region_get_extents, gxg_cairo_region_get_extents_w, 2, 0, 0, H_cairo_region_get_extents, pl_tu);
  Xg_define_procedure(cairo_region_num_rectangles, gxg_cairo_region_num_rectangles_w, 1, 0, 0, H_cairo_region_num_rectangles, pl_iu);
  Xg_define_procedure(cairo_region_get_rectangle, gxg_cairo_region_get_rectangle_w, 3, 0, 0, H_cairo_region_get_rectangle, pl_tuiu);
  Xg_define_procedure(cairo_region_is_empty, gxg_cairo_region_is_empty_w, 1, 0, 0, H_cairo_region_is_empty, pl_iu);
  Xg_define_procedure(cairo_region_contains_rectangle, gxg_cairo_region_contains_rectangle_w, 2, 0, 0, H_cairo_region_contains_rectangle, pl_tu);
  Xg_define_procedure(cairo_region_contains_point, gxg_cairo_region_contains_point_w, 3, 0, 0, H_cairo_region_contains_point, pl_iui);
  Xg_define_procedure(cairo_region_translate, gxg_cairo_region_translate_w, 3, 0, 0, H_cairo_region_translate, pl_tui);
  Xg_define_procedure(cairo_region_subtract, gxg_cairo_region_subtract_w, 2, 0, 0, H_cairo_region_subtract, pl_gu);
  Xg_define_procedure(cairo_region_subtract_rectangle, gxg_cairo_region_subtract_rectangle_w, 2, 0, 0, H_cairo_region_subtract_rectangle, pl_gu);
  Xg_define_procedure(cairo_region_intersect, gxg_cairo_region_intersect_w, 2, 0, 0, H_cairo_region_intersect, pl_gu);
  Xg_define_procedure(cairo_region_intersect_rectangle, gxg_cairo_region_intersect_rectangle_w, 2, 0, 0, H_cairo_region_intersect_rectangle, pl_gu);
  Xg_define_procedure(cairo_region_union, gxg_cairo_region_union_w, 2, 0, 0, H_cairo_region_union, pl_gu);
  Xg_define_procedure(cairo_region_union_rectangle, gxg_cairo_region_union_rectangle_w, 2, 0, 0, H_cairo_region_union_rectangle, pl_gu);
  Xg_define_procedure(cairo_region_xor, gxg_cairo_region_xor_w, 2, 0, 0, H_cairo_region_xor, pl_gu);
  Xg_define_procedure(cairo_region_xor_rectangle, gxg_cairo_region_xor_rectangle_w, 2, 0, 0, H_cairo_region_xor_rectangle, pl_gu);
#endif

  Xg_define_procedure(GPOINTER, gxg_GPOINTER_w, 1, 0, 0, "(GPOINTER obj) casts obj to GPOINTER", NULL);
  Xg_define_procedure(GDK_DRAG_CONTEXT, gxg_GDK_DRAG_CONTEXT_w, 1, 0, 0, "(GDK_DRAG_CONTEXT obj) casts obj to GDK_DRAG_CONTEXT", pl_bpt);
  Xg_define_procedure(GDK_DEVICE, gxg_GDK_DEVICE_w, 1, 0, 0, "(GDK_DEVICE obj) casts obj to GDK_DEVICE", pl_bpt);
  Xg_define_procedure(GDK_KEYMAP, gxg_GDK_KEYMAP_w, 1, 0, 0, "(GDK_KEYMAP obj) casts obj to GDK_KEYMAP", pl_bpt);
  Xg_define_procedure(GDK_WINDOW, gxg_GDK_WINDOW_w, 1, 0, 0, "(GDK_WINDOW obj) casts obj to GDK_WINDOW", pl_bpt);
  Xg_define_procedure(GDK_PIXBUF, gxg_GDK_PIXBUF_w, 1, 0, 0, "(GDK_PIXBUF obj) casts obj to GDK_PIXBUF", pl_bpt);
  Xg_define_procedure(GTK_ACCEL_GROUP, gxg_GTK_ACCEL_GROUP_w, 1, 0, 0, "(GTK_ACCEL_GROUP obj) casts obj to GTK_ACCEL_GROUP", pl_bpt);
  Xg_define_procedure(GTK_ACCEL_LABEL, gxg_GTK_ACCEL_LABEL_w, 1, 0, 0, "(GTK_ACCEL_LABEL obj) casts obj to GTK_ACCEL_LABEL", pl_bpt);
  Xg_define_procedure(GTK_ACCESSIBLE, gxg_GTK_ACCESSIBLE_w, 1, 0, 0, "(GTK_ACCESSIBLE obj) casts obj to GTK_ACCESSIBLE", pl_bpt);
  Xg_define_procedure(GTK_ADJUSTMENT, gxg_GTK_ADJUSTMENT_w, 1, 0, 0, "(GTK_ADJUSTMENT obj) casts obj to GTK_ADJUSTMENT", pl_bpt);
  Xg_define_procedure(GTK_ASPECT_FRAME, gxg_GTK_ASPECT_FRAME_w, 1, 0, 0, "(GTK_ASPECT_FRAME obj) casts obj to GTK_ASPECT_FRAME", pl_bpt);
  Xg_define_procedure(GTK_BUTTON_BOX, gxg_GTK_BUTTON_BOX_w, 1, 0, 0, "(GTK_BUTTON_BOX obj) casts obj to GTK_BUTTON_BOX", pl_bpt);
  Xg_define_procedure(GTK_BIN, gxg_GTK_BIN_w, 1, 0, 0, "(GTK_BIN obj) casts obj to GTK_BIN", pl_bpt);
  Xg_define_procedure(GTK_BOX, gxg_GTK_BOX_w, 1, 0, 0, "(GTK_BOX obj) casts obj to GTK_BOX", pl_bpt);
  Xg_define_procedure(GTK_BUTTON, gxg_GTK_BUTTON_w, 1, 0, 0, "(GTK_BUTTON obj) casts obj to GTK_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_CALENDAR, gxg_GTK_CALENDAR_w, 1, 0, 0, "(GTK_CALENDAR obj) casts obj to GTK_CALENDAR", pl_bpt);
  Xg_define_procedure(GTK_CELL_EDITABLE, gxg_GTK_CELL_EDITABLE_w, 1, 0, 0, "(GTK_CELL_EDITABLE obj) casts obj to GTK_CELL_EDITABLE", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER, gxg_GTK_CELL_RENDERER_w, 1, 0, 0, "(GTK_CELL_RENDERER obj) casts obj to GTK_CELL_RENDERER", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_PIXBUF, gxg_GTK_CELL_RENDERER_PIXBUF_w, 1, 0, 0, "(GTK_CELL_RENDERER_PIXBUF obj) casts obj to GTK_CELL_RENDERER_PIXBUF", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_TEXT, gxg_GTK_CELL_RENDERER_TEXT_w, 1, 0, 0, "(GTK_CELL_RENDERER_TEXT obj) casts obj to GTK_CELL_RENDERER_TEXT", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_TOGGLE, gxg_GTK_CELL_RENDERER_TOGGLE_w, 1, 0, 0, "(GTK_CELL_RENDERER_TOGGLE obj) casts obj to GTK_CELL_RENDERER_TOGGLE", pl_bpt);
  Xg_define_procedure(GTK_CHECK_BUTTON, gxg_GTK_CHECK_BUTTON_w, 1, 0, 0, "(GTK_CHECK_BUTTON obj) casts obj to GTK_CHECK_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_CHECK_MENU_ITEM, gxg_GTK_CHECK_MENU_ITEM_w, 1, 0, 0, "(GTK_CHECK_MENU_ITEM obj) casts obj to GTK_CHECK_MENU_ITEM", pl_bpt);
  Xg_define_procedure(GTK_CONTAINER, gxg_GTK_CONTAINER_w, 1, 0, 0, "(GTK_CONTAINER obj) casts obj to GTK_CONTAINER", pl_bpt);
  Xg_define_procedure(GTK_DIALOG, gxg_GTK_DIALOG_w, 1, 0, 0, "(GTK_DIALOG obj) casts obj to GTK_DIALOG", pl_bpt);
  Xg_define_procedure(GTK_DRAWING_AREA, gxg_GTK_DRAWING_AREA_w, 1, 0, 0, "(GTK_DRAWING_AREA obj) casts obj to GTK_DRAWING_AREA", pl_bpt);
  Xg_define_procedure(GTK_EDITABLE, gxg_GTK_EDITABLE_w, 1, 0, 0, "(GTK_EDITABLE obj) casts obj to GTK_EDITABLE", pl_bpt);
  Xg_define_procedure(GTK_ENTRY, gxg_GTK_ENTRY_w, 1, 0, 0, "(GTK_ENTRY obj) casts obj to GTK_ENTRY", pl_bpt);
  Xg_define_procedure(GTK_FIXED, gxg_GTK_FIXED_w, 1, 0, 0, "(GTK_FIXED obj) casts obj to GTK_FIXED", pl_bpt);
  Xg_define_procedure(GTK_FRAME, gxg_GTK_FRAME_w, 1, 0, 0, "(GTK_FRAME obj) casts obj to GTK_FRAME", pl_bpt);
  Xg_define_procedure(GTK_IMAGE, gxg_GTK_IMAGE_w, 1, 0, 0, "(GTK_IMAGE obj) casts obj to GTK_IMAGE", pl_bpt);
  Xg_define_procedure(GTK_IM_CONTEXT, gxg_GTK_IM_CONTEXT_w, 1, 0, 0, "(GTK_IM_CONTEXT obj) casts obj to GTK_IM_CONTEXT", pl_bpt);
  Xg_define_procedure(GTK_IM_CONTEXT_SIMPLE, gxg_GTK_IM_CONTEXT_SIMPLE_w, 1, 0, 0, "(GTK_IM_CONTEXT_SIMPLE obj) casts obj to GTK_IM_CONTEXT_SIMPLE", pl_bpt);
  Xg_define_procedure(GTK_INVISIBLE, gxg_GTK_INVISIBLE_w, 1, 0, 0, "(GTK_INVISIBLE obj) casts obj to GTK_INVISIBLE", pl_bpt);
  Xg_define_procedure(GTK_LABEL, gxg_GTK_LABEL_w, 1, 0, 0, "(GTK_LABEL obj) casts obj to GTK_LABEL", pl_bpt);
  Xg_define_procedure(GTK_LAYOUT, gxg_GTK_LAYOUT_w, 1, 0, 0, "(GTK_LAYOUT obj) casts obj to GTK_LAYOUT", pl_bpt);
  Xg_define_procedure(GTK_LIST_STORE, gxg_GTK_LIST_STORE_w, 1, 0, 0, "(GTK_LIST_STORE obj) casts obj to GTK_LIST_STORE", pl_bpt);
  Xg_define_procedure(GTK_MENU_BAR, gxg_GTK_MENU_BAR_w, 1, 0, 0, "(GTK_MENU_BAR obj) casts obj to GTK_MENU_BAR", pl_bpt);
  Xg_define_procedure(GTK_MENU, gxg_GTK_MENU_w, 1, 0, 0, "(GTK_MENU obj) casts obj to GTK_MENU", pl_bpt);
  Xg_define_procedure(GTK_MENU_ITEM, gxg_GTK_MENU_ITEM_w, 1, 0, 0, "(GTK_MENU_ITEM obj) casts obj to GTK_MENU_ITEM", pl_bpt);
  Xg_define_procedure(GTK_MENU_SHELL, gxg_GTK_MENU_SHELL_w, 1, 0, 0, "(GTK_MENU_SHELL obj) casts obj to GTK_MENU_SHELL", pl_bpt);
  Xg_define_procedure(GTK_NOTEBOOK, gxg_GTK_NOTEBOOK_w, 1, 0, 0, "(GTK_NOTEBOOK obj) casts obj to GTK_NOTEBOOK", pl_bpt);
  Xg_define_procedure(GTK_PANED, gxg_GTK_PANED_w, 1, 0, 0, "(GTK_PANED obj) casts obj to GTK_PANED", pl_bpt);
  Xg_define_procedure(GTK_PROGRESS_BAR, gxg_GTK_PROGRESS_BAR_w, 1, 0, 0, "(GTK_PROGRESS_BAR obj) casts obj to GTK_PROGRESS_BAR", pl_bpt);
  Xg_define_procedure(GTK_RADIO_BUTTON, gxg_GTK_RADIO_BUTTON_w, 1, 0, 0, "(GTK_RADIO_BUTTON obj) casts obj to GTK_RADIO_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_RADIO_MENU_ITEM, gxg_GTK_RADIO_MENU_ITEM_w, 1, 0, 0, "(GTK_RADIO_MENU_ITEM obj) casts obj to GTK_RADIO_MENU_ITEM", pl_bpt);
  Xg_define_procedure(GTK_RANGE, gxg_GTK_RANGE_w, 1, 0, 0, "(GTK_RANGE obj) casts obj to GTK_RANGE", pl_bpt);
  Xg_define_procedure(GTK_SCALE, gxg_GTK_SCALE_w, 1, 0, 0, "(GTK_SCALE obj) casts obj to GTK_SCALE", pl_bpt);
  Xg_define_procedure(GTK_SCROLLBAR, gxg_GTK_SCROLLBAR_w, 1, 0, 0, "(GTK_SCROLLBAR obj) casts obj to GTK_SCROLLBAR", pl_bpt);
  Xg_define_procedure(GTK_SCROLLED_WINDOW, gxg_GTK_SCROLLED_WINDOW_w, 1, 0, 0, "(GTK_SCROLLED_WINDOW obj) casts obj to GTK_SCROLLED_WINDOW", pl_bpt);
  Xg_define_procedure(GTK_SEPARATOR, gxg_GTK_SEPARATOR_w, 1, 0, 0, "(GTK_SEPARATOR obj) casts obj to GTK_SEPARATOR", pl_bpt);
  Xg_define_procedure(GTK_SEPARATOR_MENU_ITEM, gxg_GTK_SEPARATOR_MENU_ITEM_w, 1, 0, 0, "(GTK_SEPARATOR_MENU_ITEM obj) casts obj to GTK_SEPARATOR_MENU_ITEM", pl_bpt);
  Xg_define_procedure(GTK_SETTINGS, gxg_GTK_SETTINGS_w, 1, 0, 0, "(GTK_SETTINGS obj) casts obj to GTK_SETTINGS", pl_bpt);
  Xg_define_procedure(GTK_SIZE_GROUP, gxg_GTK_SIZE_GROUP_w, 1, 0, 0, "(GTK_SIZE_GROUP obj) casts obj to GTK_SIZE_GROUP", pl_bpt);
  Xg_define_procedure(GTK_SPIN_BUTTON, gxg_GTK_SPIN_BUTTON_w, 1, 0, 0, "(GTK_SPIN_BUTTON obj) casts obj to GTK_SPIN_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_STATUSBAR, gxg_GTK_STATUSBAR_w, 1, 0, 0, "(GTK_STATUSBAR obj) casts obj to GTK_STATUSBAR", pl_bpt);
  Xg_define_procedure(GTK_TEXT_BUFFER, gxg_GTK_TEXT_BUFFER_w, 1, 0, 0, "(GTK_TEXT_BUFFER obj) casts obj to GTK_TEXT_BUFFER", pl_bpt);
  Xg_define_procedure(GTK_TEXT_CHILD_ANCHOR, gxg_GTK_TEXT_CHILD_ANCHOR_w, 1, 0, 0, "(GTK_TEXT_CHILD_ANCHOR obj) casts obj to GTK_TEXT_CHILD_ANCHOR", pl_bpt);
  Xg_define_procedure(GTK_TEXT_MARK, gxg_GTK_TEXT_MARK_w, 1, 0, 0, "(GTK_TEXT_MARK obj) casts obj to GTK_TEXT_MARK", pl_bpt);
  Xg_define_procedure(GTK_TEXT_TAG, gxg_GTK_TEXT_TAG_w, 1, 0, 0, "(GTK_TEXT_TAG obj) casts obj to GTK_TEXT_TAG", pl_bpt);
  Xg_define_procedure(GTK_TEXT_TAG_TABLE, gxg_GTK_TEXT_TAG_TABLE_w, 1, 0, 0, "(GTK_TEXT_TAG_TABLE obj) casts obj to GTK_TEXT_TAG_TABLE", pl_bpt);
  Xg_define_procedure(GTK_TEXT_VIEW, gxg_GTK_TEXT_VIEW_w, 1, 0, 0, "(GTK_TEXT_VIEW obj) casts obj to GTK_TEXT_VIEW", pl_bpt);
  Xg_define_procedure(GTK_TOGGLE_BUTTON, gxg_GTK_TOGGLE_BUTTON_w, 1, 0, 0, "(GTK_TOGGLE_BUTTON obj) casts obj to GTK_TOGGLE_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_TOOLBAR, gxg_GTK_TOOLBAR_w, 1, 0, 0, "(GTK_TOOLBAR obj) casts obj to GTK_TOOLBAR", pl_bpt);
  Xg_define_procedure(GTK_TREE_DRAG_SOURCE, gxg_GTK_TREE_DRAG_SOURCE_w, 1, 0, 0, "(GTK_TREE_DRAG_SOURCE obj) casts obj to GTK_TREE_DRAG_SOURCE", pl_bpt);
  Xg_define_procedure(GTK_TREE_DRAG_DEST, gxg_GTK_TREE_DRAG_DEST_w, 1, 0, 0, "(GTK_TREE_DRAG_DEST obj) casts obj to GTK_TREE_DRAG_DEST", pl_bpt);
  Xg_define_procedure(GTK_TREE_MODEL, gxg_GTK_TREE_MODEL_w, 1, 0, 0, "(GTK_TREE_MODEL obj) casts obj to GTK_TREE_MODEL", pl_bpt);
  Xg_define_procedure(GTK_TREE_MODEL_SORT, gxg_GTK_TREE_MODEL_SORT_w, 1, 0, 0, "(GTK_TREE_MODEL_SORT obj) casts obj to GTK_TREE_MODEL_SORT", pl_bpt);
  Xg_define_procedure(GTK_TREE_SELECTION, gxg_GTK_TREE_SELECTION_w, 1, 0, 0, "(GTK_TREE_SELECTION obj) casts obj to GTK_TREE_SELECTION", pl_bpt);
  Xg_define_procedure(GTK_TREE_SORTABLE, gxg_GTK_TREE_SORTABLE_w, 1, 0, 0, "(GTK_TREE_SORTABLE obj) casts obj to GTK_TREE_SORTABLE", pl_bpt);
  Xg_define_procedure(GTK_TREE_STORE, gxg_GTK_TREE_STORE_w, 1, 0, 0, "(GTK_TREE_STORE obj) casts obj to GTK_TREE_STORE", pl_bpt);
  Xg_define_procedure(GTK_TREE_VIEW_COLUMN, gxg_GTK_TREE_VIEW_COLUMN_w, 1, 0, 0, "(GTK_TREE_VIEW_COLUMN obj) casts obj to GTK_TREE_VIEW_COLUMN", pl_bpt);
  Xg_define_procedure(GTK_TREE_VIEW, gxg_GTK_TREE_VIEW_w, 1, 0, 0, "(GTK_TREE_VIEW obj) casts obj to GTK_TREE_VIEW", pl_bpt);
  Xg_define_procedure(GTK_VIEWPORT, gxg_GTK_VIEWPORT_w, 1, 0, 0, "(GTK_VIEWPORT obj) casts obj to GTK_VIEWPORT", pl_bpt);
  Xg_define_procedure(GTK_WIDGET, gxg_GTK_WIDGET_w, 1, 0, 0, "(GTK_WIDGET obj) casts obj to GTK_WIDGET", pl_bpt);
  Xg_define_procedure(GTK_WINDOW, gxg_GTK_WINDOW_w, 1, 0, 0, "(GTK_WINDOW obj) casts obj to GTK_WINDOW", pl_bpt);
  Xg_define_procedure(PANGO_CONTEXT, gxg_PANGO_CONTEXT_w, 1, 0, 0, "(PANGO_CONTEXT obj) casts obj to PANGO_CONTEXT", pl_bpt);
  Xg_define_procedure(PANGO_FONT_FAMILY, gxg_PANGO_FONT_FAMILY_w, 1, 0, 0, "(PANGO_FONT_FAMILY obj) casts obj to PANGO_FONT_FAMILY", pl_bpt);
  Xg_define_procedure(PANGO_FONT_FACE, gxg_PANGO_FONT_FACE_w, 1, 0, 0, "(PANGO_FONT_FACE obj) casts obj to PANGO_FONT_FACE", pl_bpt);
  Xg_define_procedure(PANGO_FONT, gxg_PANGO_FONT_w, 1, 0, 0, "(PANGO_FONT obj) casts obj to PANGO_FONT", pl_bpt);
  Xg_define_procedure(PANGO_FONT_MAP, gxg_PANGO_FONT_MAP_w, 1, 0, 0, "(PANGO_FONT_MAP obj) casts obj to PANGO_FONT_MAP", pl_bpt);
  Xg_define_procedure(PANGO_LAYOUT, gxg_PANGO_LAYOUT_w, 1, 0, 0, "(PANGO_LAYOUT obj) casts obj to PANGO_LAYOUT", pl_bpt);
  Xg_define_procedure(G_OBJECT, gxg_G_OBJECT_w, 1, 0, 0, "(G_OBJECT obj) casts obj to G_OBJECT", pl_bpt);
  Xg_define_procedure(GDK_DISPLAY_OBJECT, gxg_GDK_DISPLAY_OBJECT_w, 1, 0, 0, "(GDK_DISPLAY_OBJECT obj) casts obj to GDK_DISPLAY_OBJECT", pl_bpt);
  Xg_define_procedure(GDK_EVENT, gxg_GDK_EVENT_w, 1, 0, 0, "(GDK_EVENT obj) casts obj to GDK_EVENT", pl_bpt);
  Xg_define_procedure(GDK_EVENT_ANY, gxg_GDK_EVENT_ANY_w, 1, 0, 0, "(GDK_EVENT_ANY obj) casts obj to GDK_EVENT_ANY", pl_bpt);
  Xg_define_procedure(GDK_EVENT_EXPOSE, gxg_GDK_EVENT_EXPOSE_w, 1, 0, 0, "(GDK_EVENT_EXPOSE obj) casts obj to GDK_EVENT_EXPOSE", pl_bpt);
  Xg_define_procedure(GDK_EVENT_NOEXPOSE, gxg_GDK_EVENT_NOEXPOSE_w, 1, 0, 0, "(GDK_EVENT_NOEXPOSE obj) casts obj to GDK_EVENT_NOEXPOSE", pl_bpt);
  Xg_define_procedure(GDK_EVENT_VISIBILITY, gxg_GDK_EVENT_VISIBILITY_w, 1, 0, 0, "(GDK_EVENT_VISIBILITY obj) casts obj to GDK_EVENT_VISIBILITY", pl_bpt);
  Xg_define_procedure(GDK_EVENT_MOTION, gxg_GDK_EVENT_MOTION_w, 1, 0, 0, "(GDK_EVENT_MOTION obj) casts obj to GDK_EVENT_MOTION", pl_bpt);
  Xg_define_procedure(GDK_EVENT_BUTTON, gxg_GDK_EVENT_BUTTON_w, 1, 0, 0, "(GDK_EVENT_BUTTON obj) casts obj to GDK_EVENT_BUTTON", pl_bpt);
  Xg_define_procedure(GDK_EVENT_SCROLL, gxg_GDK_EVENT_SCROLL_w, 1, 0, 0, "(GDK_EVENT_SCROLL obj) casts obj to GDK_EVENT_SCROLL", pl_bpt);
  Xg_define_procedure(GDK_EVENT_KEY, gxg_GDK_EVENT_KEY_w, 1, 0, 0, "(GDK_EVENT_KEY obj) casts obj to GDK_EVENT_KEY", pl_bpt);
  Xg_define_procedure(GDK_EVENT_CROSSING, gxg_GDK_EVENT_CROSSING_w, 1, 0, 0, "(GDK_EVENT_CROSSING obj) casts obj to GDK_EVENT_CROSSING", pl_bpt);
  Xg_define_procedure(GDK_EVENT_FOCUS, gxg_GDK_EVENT_FOCUS_w, 1, 0, 0, "(GDK_EVENT_FOCUS obj) casts obj to GDK_EVENT_FOCUS", pl_bpt);
  Xg_define_procedure(GDK_EVENT_CONFIGURE, gxg_GDK_EVENT_CONFIGURE_w, 1, 0, 0, "(GDK_EVENT_CONFIGURE obj) casts obj to GDK_EVENT_CONFIGURE", pl_bpt);
  Xg_define_procedure(GDK_EVENT_PROPERTY, gxg_GDK_EVENT_PROPERTY_w, 1, 0, 0, "(GDK_EVENT_PROPERTY obj) casts obj to GDK_EVENT_PROPERTY", pl_bpt);
  Xg_define_procedure(GDK_EVENT_SELECTION, gxg_GDK_EVENT_SELECTION_w, 1, 0, 0, "(GDK_EVENT_SELECTION obj) casts obj to GDK_EVENT_SELECTION", pl_bpt);
  Xg_define_procedure(GDK_EVENT_PROXIMITY, gxg_GDK_EVENT_PROXIMITY_w, 1, 0, 0, "(GDK_EVENT_PROXIMITY obj) casts obj to GDK_EVENT_PROXIMITY", pl_bpt);
  Xg_define_procedure(GDK_EVENT_SETTING, gxg_GDK_EVENT_SETTING_w, 1, 0, 0, "(GDK_EVENT_SETTING obj) casts obj to GDK_EVENT_SETTING", pl_bpt);
  Xg_define_procedure(GDK_EVENT_WINDOWSTATE, gxg_GDK_EVENT_WINDOWSTATE_w, 1, 0, 0, "(GDK_EVENT_WINDOWSTATE obj) casts obj to GDK_EVENT_WINDOWSTATE", pl_bpt);
  Xg_define_procedure(GDK_EVENT_DND, gxg_GDK_EVENT_DND_w, 1, 0, 0, "(GDK_EVENT_DND obj) casts obj to GDK_EVENT_DND", pl_bpt);
  Xg_define_procedure(GTK_FILE_CHOOSER_DIALOG, gxg_GTK_FILE_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_FILE_CHOOSER_DIALOG obj) casts obj to GTK_FILE_CHOOSER_DIALOG", pl_bpt);
  Xg_define_procedure(GTK_FILE_CHOOSER_WIDGET, gxg_GTK_FILE_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_FILE_CHOOSER_WIDGET obj) casts obj to GTK_FILE_CHOOSER_WIDGET", pl_bpt);
  Xg_define_procedure(GTK_TREE_MODEL_FILTER, gxg_GTK_TREE_MODEL_FILTER_w, 1, 0, 0, "(GTK_TREE_MODEL_FILTER obj) casts obj to GTK_TREE_MODEL_FILTER", pl_bpt);
  Xg_define_procedure(GTK_COMBO_BOX, gxg_GTK_COMBO_BOX_w, 1, 0, 0, "(GTK_COMBO_BOX obj) casts obj to GTK_COMBO_BOX", pl_bpt);
  Xg_define_procedure(GTK_EXPANDER, gxg_GTK_EXPANDER_w, 1, 0, 0, "(GTK_EXPANDER obj) casts obj to GTK_EXPANDER", pl_bpt);
  Xg_define_procedure(GTK_FONT_BUTTON, gxg_GTK_FONT_BUTTON_w, 1, 0, 0, "(GTK_FONT_BUTTON obj) casts obj to GTK_FONT_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_COLOR_BUTTON, gxg_GTK_COLOR_BUTTON_w, 1, 0, 0, "(GTK_COLOR_BUTTON obj) casts obj to GTK_COLOR_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_ENTRY_COMPLETION, gxg_GTK_ENTRY_COMPLETION_w, 1, 0, 0, "(GTK_ENTRY_COMPLETION obj) casts obj to GTK_ENTRY_COMPLETION", pl_bpt);
  Xg_define_procedure(GTK_RADIO_TOOL_BUTTON, gxg_GTK_RADIO_TOOL_BUTTON_w, 1, 0, 0, "(GTK_RADIO_TOOL_BUTTON obj) casts obj to GTK_RADIO_TOOL_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_SEPARATOR_TOOL_ITEM, gxg_GTK_SEPARATOR_TOOL_ITEM_w, 1, 0, 0, "(GTK_SEPARATOR_TOOL_ITEM obj) casts obj to GTK_SEPARATOR_TOOL_ITEM", pl_bpt);
  Xg_define_procedure(GTK_TOGGLE_TOOL_BUTTON, gxg_GTK_TOGGLE_TOOL_BUTTON_w, 1, 0, 0, "(GTK_TOGGLE_TOOL_BUTTON obj) casts obj to GTK_TOGGLE_TOOL_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_FILE_FILTER, gxg_GTK_FILE_FILTER_w, 1, 0, 0, "(GTK_FILE_FILTER obj) casts obj to GTK_FILE_FILTER", pl_bpt);
  Xg_define_procedure(GTK_CELL_LAYOUT, gxg_GTK_CELL_LAYOUT_w, 1, 0, 0, "(GTK_CELL_LAYOUT obj) casts obj to GTK_CELL_LAYOUT", pl_bpt);
  Xg_define_procedure(GTK_FILE_CHOOSER, gxg_GTK_FILE_CHOOSER_w, 1, 0, 0, "(GTK_FILE_CHOOSER obj) casts obj to GTK_FILE_CHOOSER", pl_bpt);
  Xg_define_procedure(GTK_ICON_THEME, gxg_GTK_ICON_THEME_w, 1, 0, 0, "(GTK_ICON_THEME obj) casts obj to GTK_ICON_THEME", pl_bpt);
  Xg_define_procedure(GTK_TOOL_BUTTON, gxg_GTK_TOOL_BUTTON_w, 1, 0, 0, "(GTK_TOOL_BUTTON obj) casts obj to GTK_TOOL_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_TOOL_ITEM, gxg_GTK_TOOL_ITEM_w, 1, 0, 0, "(GTK_TOOL_ITEM obj) casts obj to GTK_TOOL_ITEM", pl_bpt);
  Xg_define_procedure(GTK_ACCEL_MAP, gxg_GTK_ACCEL_MAP_w, 1, 0, 0, "(GTK_ACCEL_MAP obj) casts obj to GTK_ACCEL_MAP", pl_bpt);
  Xg_define_procedure(GTK_CELL_VIEW, gxg_GTK_CELL_VIEW_w, 1, 0, 0, "(GTK_CELL_VIEW obj) casts obj to GTK_CELL_VIEW", pl_bpt);
  Xg_define_procedure(GTK_ABOUT_DIALOG, gxg_GTK_ABOUT_DIALOG_w, 1, 0, 0, "(GTK_ABOUT_DIALOG obj) casts obj to GTK_ABOUT_DIALOG", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_COMBO, gxg_GTK_CELL_RENDERER_COMBO_w, 1, 0, 0, "(GTK_CELL_RENDERER_COMBO obj) casts obj to GTK_CELL_RENDERER_COMBO", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_PROGRESS, gxg_GTK_CELL_RENDERER_PROGRESS_w, 1, 0, 0, "(GTK_CELL_RENDERER_PROGRESS obj) casts obj to GTK_CELL_RENDERER_PROGRESS", pl_bpt);
  Xg_define_procedure(GTK_ICON_VIEW, gxg_GTK_ICON_VIEW_w, 1, 0, 0, "(GTK_ICON_VIEW obj) casts obj to GTK_ICON_VIEW", pl_bpt);
  Xg_define_procedure(GTK_FILE_CHOOSER_BUTTON, gxg_GTK_FILE_CHOOSER_BUTTON_w, 1, 0, 0, "(GTK_FILE_CHOOSER_BUTTON obj) casts obj to GTK_FILE_CHOOSER_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_MENU_TOOL_BUTTON, gxg_GTK_MENU_TOOL_BUTTON_w, 1, 0, 0, "(GTK_MENU_TOOL_BUTTON obj) casts obj to GTK_MENU_TOOL_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_ASSISTANT, gxg_GTK_ASSISTANT_w, 1, 0, 0, "(GTK_ASSISTANT obj) casts obj to GTK_ASSISTANT", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_ACCEL, gxg_GTK_CELL_RENDERER_ACCEL_w, 1, 0, 0, "(GTK_CELL_RENDERER_ACCEL obj) casts obj to GTK_CELL_RENDERER_ACCEL", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_SPIN, gxg_GTK_CELL_RENDERER_SPIN_w, 1, 0, 0, "(GTK_CELL_RENDERER_SPIN obj) casts obj to GTK_CELL_RENDERER_SPIN", pl_bpt);
  Xg_define_procedure(GTK_LINK_BUTTON, gxg_GTK_LINK_BUTTON_w, 1, 0, 0, "(GTK_LINK_BUTTON obj) casts obj to GTK_LINK_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_RECENT_CHOOSER_DIALOG, gxg_GTK_RECENT_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_RECENT_CHOOSER_DIALOG obj) casts obj to GTK_RECENT_CHOOSER_DIALOG", pl_bpt);
  Xg_define_procedure(GTK_RECENT_CHOOSER, gxg_GTK_RECENT_CHOOSER_w, 1, 0, 0, "(GTK_RECENT_CHOOSER obj) casts obj to GTK_RECENT_CHOOSER", pl_bpt);
  Xg_define_procedure(GTK_RECENT_CHOOSER_MENU, gxg_GTK_RECENT_CHOOSER_MENU_w, 1, 0, 0, "(GTK_RECENT_CHOOSER_MENU obj) casts obj to GTK_RECENT_CHOOSER_MENU", pl_bpt);
  Xg_define_procedure(GTK_RECENT_CHOOSER_WIDGET, gxg_GTK_RECENT_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_RECENT_CHOOSER_WIDGET obj) casts obj to GTK_RECENT_CHOOSER_WIDGET", pl_bpt);
  Xg_define_procedure(GTK_RECENT_FILTER, gxg_GTK_RECENT_FILTER_w, 1, 0, 0, "(GTK_RECENT_FILTER obj) casts obj to GTK_RECENT_FILTER", pl_bpt);
  Xg_define_procedure(GTK_RECENT_MANAGER, gxg_GTK_RECENT_MANAGER_w, 1, 0, 0, "(GTK_RECENT_MANAGER obj) casts obj to GTK_RECENT_MANAGER", pl_bpt);
  Xg_define_procedure(GTK_PRINT_CONTEXT, gxg_GTK_PRINT_CONTEXT_w, 1, 0, 0, "(GTK_PRINT_CONTEXT obj) casts obj to GTK_PRINT_CONTEXT", pl_bpt);
  Xg_define_procedure(GTK_PRINT_OPERATION, gxg_GTK_PRINT_OPERATION_w, 1, 0, 0, "(GTK_PRINT_OPERATION obj) casts obj to GTK_PRINT_OPERATION", pl_bpt);
  Xg_define_procedure(GTK_PRINT_SETTINGS, gxg_GTK_PRINT_SETTINGS_w, 1, 0, 0, "(GTK_PRINT_SETTINGS obj) casts obj to GTK_PRINT_SETTINGS", pl_bpt);
  Xg_define_procedure(GTK_TOOLTIP, gxg_GTK_TOOLTIP_w, 1, 0, 0, "(GTK_TOOLTIP obj) casts obj to GTK_TOOLTIP", pl_bpt);
#if GTK_CHECK_VERSION(2, 18, 0)
  Xg_define_procedure(GTK_INFO_BAR, gxg_GTK_INFO_BAR_w, 1, 0, 0, "(GTK_INFO_BAR obj) casts obj to GTK_INFO_BAR", pl_bpt);
  Xg_define_procedure(GTK_ENTRY_BUFFER, gxg_GTK_ENTRY_BUFFER_w, 1, 0, 0, "(GTK_ENTRY_BUFFER obj) casts obj to GTK_ENTRY_BUFFER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
  Xg_define_procedure(GTK_SPINNER, gxg_GTK_SPINNER_w, 1, 0, 0, "(GTK_SPINNER obj) casts obj to GTK_SPINNER", pl_bpt);
  Xg_define_procedure(GTK_CELL_RENDERER_SPINNER, gxg_GTK_CELL_RENDERER_SPINNER_w, 1, 0, 0, "(GTK_CELL_RENDERER_SPINNER obj) casts obj to GTK_CELL_RENDERER_SPINNER", pl_bpt);
  Xg_define_procedure(GTK_TOOL_PALETTE, gxg_GTK_TOOL_PALETTE_w, 1, 0, 0, "(GTK_TOOL_PALETTE obj) casts obj to GTK_TOOL_PALETTE", pl_bpt);
  Xg_define_procedure(GTK_TOOL_ITEM_GROUP, gxg_GTK_TOOL_ITEM_GROUP_w, 1, 0, 0, "(GTK_TOOL_ITEM_GROUP obj) casts obj to GTK_TOOL_ITEM_GROUP", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  Xg_define_procedure(GTK_COMBO_BOX_TEXT, gxg_GTK_COMBO_BOX_TEXT_w, 1, 0, 0, "(GTK_COMBO_BOX_TEXT obj) casts obj to GTK_COMBO_BOX_TEXT", pl_bpt);
  Xg_define_procedure(GTK_GRID, gxg_GTK_GRID_w, 1, 0, 0, "(GTK_GRID obj) casts obj to GTK_GRID", pl_bpt);
  Xg_define_procedure(GTK_SCROLLABLE, gxg_GTK_SCROLLABLE_w, 1, 0, 0, "(GTK_SCROLLABLE obj) casts obj to GTK_SCROLLABLE", pl_bpt);
  Xg_define_procedure(GDK_RGBA, gxg_GDK_RGBA_w, 1, 0, 0, "(GDK_RGBA obj) casts obj to GDK_RGBA", pl_bpt);
  Xg_define_procedure(GTK_SWITCH, gxg_GTK_SWITCH_w, 1, 0, 0, "(GTK_SWITCH obj) casts obj to GTK_SWITCH", pl_bpt);
  Xg_define_procedure(GTK_ORIENTABLE, gxg_GTK_ORIENTABLE_w, 1, 0, 0, "(GTK_ORIENTABLE obj) casts obj to GTK_ORIENTABLE", pl_bpt);
  Xg_define_procedure(GTK_WINDOW_GROUP, gxg_GTK_WINDOW_GROUP_w, 1, 0, 0, "(GTK_WINDOW_GROUP obj) casts obj to GTK_WINDOW_GROUP", pl_bpt);
  Xg_define_procedure(GTK_TOOL_SHELL, gxg_GTK_TOOL_SHELL_w, 1, 0, 0, "(GTK_TOOL_SHELL obj) casts obj to GTK_TOOL_SHELL", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  Xg_define_procedure(GTK_OVERLAY, gxg_GTK_OVERLAY_w, 1, 0, 0, "(GTK_OVERLAY obj) casts obj to GTK_OVERLAY", pl_bpt);
  Xg_define_procedure(GTK_FONT_CHOOSER, gxg_GTK_FONT_CHOOSER_w, 1, 0, 0, "(GTK_FONT_CHOOSER obj) casts obj to GTK_FONT_CHOOSER", pl_bpt);
  Xg_define_procedure(GTK_FONT_CHOOSER_DIALOG, gxg_GTK_FONT_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_FONT_CHOOSER_DIALOG obj) casts obj to GTK_FONT_CHOOSER_DIALOG", pl_bpt);
  Xg_define_procedure(GTK_FONT_CHOOSER_WIDGET, gxg_GTK_FONT_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_FONT_CHOOSER_WIDGET obj) casts obj to GTK_FONT_CHOOSER_WIDGET", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  Xg_define_procedure(GTK_APPLICATION_WINDOW, gxg_GTK_APPLICATION_WINDOW_w, 1, 0, 0, "(GTK_APPLICATION_WINDOW obj) casts obj to GTK_APPLICATION_WINDOW", pl_bpt);
  Xg_define_procedure(GTK_COLOR_CHOOSER_DIALOG, gxg_GTK_COLOR_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_COLOR_CHOOSER_DIALOG obj) casts obj to GTK_COLOR_CHOOSER_DIALOG", pl_bpt);
  Xg_define_procedure(GTK_COLOR_CHOOSER_WIDGET, gxg_GTK_COLOR_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_COLOR_CHOOSER_WIDGET obj) casts obj to GTK_COLOR_CHOOSER_WIDGET", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  Xg_define_procedure(GTK_MENU_BUTTON, gxg_GTK_MENU_BUTTON_w, 1, 0, 0, "(GTK_MENU_BUTTON obj) casts obj to GTK_MENU_BUTTON", pl_bpt);
  Xg_define_procedure(GTK_SEARCH_ENTRY, gxg_GTK_SEARCH_ENTRY_w, 1, 0, 0, "(GTK_SEARCH_ENTRY obj) casts obj to GTK_SEARCH_ENTRY", pl_bpt);
  Xg_define_procedure(GTK_LEVEL_BAR, gxg_GTK_LEVEL_BAR_w, 1, 0, 0, "(GTK_LEVEL_BAR obj) casts obj to GTK_LEVEL_BAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  Xg_define_procedure(GTK_PLACES_SIDEBAR, gxg_GTK_PLACES_SIDEBAR_w, 1, 0, 0, "(GTK_PLACES_SIDEBAR obj) casts obj to GTK_PLACES_SIDEBAR", pl_bpt);
  Xg_define_procedure(GTK_STACK_SWITCHER, gxg_GTK_STACK_SWITCHER_w, 1, 0, 0, "(GTK_STACK_SWITCHER obj) casts obj to GTK_STACK_SWITCHER", pl_bpt);
  Xg_define_procedure(GTK_STACK, gxg_GTK_STACK_w, 1, 0, 0, "(GTK_STACK obj) casts obj to GTK_STACK", pl_bpt);
  Xg_define_procedure(GTK_REVEALER, gxg_GTK_REVEALER_w, 1, 0, 0, "(GTK_REVEALER obj) casts obj to GTK_REVEALER", pl_bpt);
  Xg_define_procedure(GTK_HEADER_BAR, gxg_GTK_HEADER_BAR_w, 1, 0, 0, "(GTK_HEADER_BAR obj) casts obj to GTK_HEADER_BAR", pl_bpt);
  Xg_define_procedure(GTK_LIST_BOX, gxg_GTK_LIST_BOX_w, 1, 0, 0, "(GTK_LIST_BOX obj) casts obj to GTK_LIST_BOX", pl_bpt);
  Xg_define_procedure(GTK_LIST_BOX_ROW, gxg_GTK_LIST_BOX_ROW_w, 1, 0, 0, "(GTK_LIST_BOX_ROW obj) casts obj to GTK_LIST_BOX_ROW", pl_bpt);
  Xg_define_procedure(GTK_SEARCH_BAR, gxg_GTK_SEARCH_BAR_w, 1, 0, 0, "(GTK_SEARCH_BAR obj) casts obj to GTK_SEARCH_BAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  Xg_define_procedure(GTK_FLOW_BOX, gxg_GTK_FLOW_BOX_w, 1, 0, 0, "(GTK_FLOW_BOX obj) casts obj to GTK_FLOW_BOX", pl_bpt);
  Xg_define_procedure(GTK_FLOW_BOX_CHILD, gxg_GTK_FLOW_BOX_CHILD_w, 1, 0, 0, "(GTK_FLOW_BOX_CHILD obj) casts obj to GTK_FLOW_BOX_CHILD", pl_bpt);
  Xg_define_procedure(GTK_ACTION_BAR, gxg_GTK_ACTION_BAR_w, 1, 0, 0, "(GTK_ACTION_BAR obj) casts obj to GTK_ACTION_BAR", pl_bpt);
  Xg_define_procedure(GTK_POPOVER, gxg_GTK_POPOVER_w, 1, 0, 0, "(GTK_POPOVER obj) casts obj to GTK_POPOVER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  Xg_define_procedure(GTK_GESTURE, gxg_GTK_GESTURE_w, 1, 0, 0, "(GTK_GESTURE obj) casts obj to GTK_GESTURE", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_DRAG, gxg_GTK_GESTURE_DRAG_w, 1, 0, 0, "(GTK_GESTURE_DRAG obj) casts obj to GTK_GESTURE_DRAG", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_LONG_PRESS, gxg_GTK_GESTURE_LONG_PRESS_w, 1, 0, 0, "(GTK_GESTURE_LONG_PRESS obj) casts obj to GTK_GESTURE_LONG_PRESS", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_ZOOM, gxg_GTK_GESTURE_ZOOM_w, 1, 0, 0, "(GTK_GESTURE_ZOOM obj) casts obj to GTK_GESTURE_ZOOM", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_SWIPE, gxg_GTK_GESTURE_SWIPE_w, 1, 0, 0, "(GTK_GESTURE_SWIPE obj) casts obj to GTK_GESTURE_SWIPE", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_SINGLE, gxg_GTK_GESTURE_SINGLE_w, 1, 0, 0, "(GTK_GESTURE_SINGLE obj) casts obj to GTK_GESTURE_SINGLE", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_PAN, gxg_GTK_GESTURE_PAN_w, 1, 0, 0, "(GTK_GESTURE_PAN obj) casts obj to GTK_GESTURE_PAN", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_MULTI_PRESS, gxg_GTK_GESTURE_MULTI_PRESS_w, 1, 0, 0, "(GTK_GESTURE_MULTI_PRESS obj) casts obj to GTK_GESTURE_MULTI_PRESS", pl_bpt);
  Xg_define_procedure(GTK_GESTURE_ROTATE, gxg_GTK_GESTURE_ROTATE_w, 1, 0, 0, "(GTK_GESTURE_ROTATE obj) casts obj to GTK_GESTURE_ROTATE", pl_bpt);
  Xg_define_procedure(GTK_EVENT_CONTROLLER, gxg_GTK_EVENT_CONTROLLER_w, 1, 0, 0, "(GTK_EVENT_CONTROLLER obj) casts obj to GTK_EVENT_CONTROLLER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  Xg_define_procedure(GTK_GL_AREA, gxg_GTK_GL_AREA_w, 1, 0, 0, "(GTK_GL_AREA obj) casts obj to GTK_GL_AREA", pl_bpt);
  Xg_define_procedure(GDK_GL_CONTEXT, gxg_GDK_GL_CONTEXT_w, 1, 0, 0, "(GDK_GL_CONTEXT obj) casts obj to GDK_GL_CONTEXT", pl_bpt);
  Xg_define_procedure(GTK_POPOVER_MENU, gxg_GTK_POPOVER_MENU_w, 1, 0, 0, "(GTK_POPOVER_MENU obj) casts obj to GTK_POPOVER_MENU", pl_bpt);
  Xg_define_procedure(GTK_STACK_SIDEBAR, gxg_GTK_STACK_SIDEBAR_w, 1, 0, 0, "(GTK_STACK_SIDEBAR obj) casts obj to GTK_STACK_SIDEBAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  Xg_define_procedure(GDK_SEAT, gxg_GDK_SEAT_w, 1, 0, 0, "(GDK_SEAT obj) casts obj to GDK_SEAT", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  Xg_define_procedure(GDK_DEVICE_TOOL, gxg_GDK_DEVICE_TOOL_w, 1, 0, 0, "(GDK_DEVICE_TOOL obj) casts obj to GDK_DEVICE_TOOL", pl_bpt);
  Xg_define_procedure(GDK_MONITOR, gxg_GDK_MONITOR_w, 1, 0, 0, "(GDK_MONITOR obj) casts obj to GDK_MONITOR", pl_bpt);
  Xg_define_procedure(GDK_DRAWING_CONTEXT, gxg_GDK_DRAWING_CONTEXT_w, 1, 0, 0, "(GDK_DRAWING_CONTEXT obj) casts obj to GDK_DRAWING_CONTEXT", pl_bpt);
  Xg_define_procedure(GDK_DEVICE_PAD, gxg_GDK_DEVICE_PAD_w, 1, 0, 0, "(GDK_DEVICE_PAD obj) casts obj to GDK_DEVICE_PAD", pl_bpt);
  Xg_define_procedure(GTK_PAD_CONTROLLER, gxg_GTK_PAD_CONTROLLER_w, 1, 0, 0, "(GTK_PAD_CONTROLLER obj) casts obj to GTK_PAD_CONTROLLER", pl_bpt);
  Xg_define_procedure(GTK_SHORTCUT_LABEL, gxg_GTK_SHORTCUT_LABEL_w, 1, 0, 0, "(GTK_SHORTCUT_LABEL obj) casts obj to GTK_SHORTCUT_LABEL", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  Xg_define_procedure(GTK_CENTER_BOX, gxg_GTK_CENTER_BOX_w, 1, 0, 0, "(GTK_CENTER_BOX obj) casts obj to GTK_CENTER_BOX", pl_bpt);
  Xg_define_procedure(GTK_STYLE_CONTEXT, gxg_GTK_STYLE_CONTEXT_w, 1, 0, 0, "(GTK_STYLE_CONTEXT obj) casts obj to GTK_STYLE_CONTEXT", pl_bpt);
  Xg_define_procedure(GTK_STYLE_PROVIDER, gxg_GTK_STYLE_PROVIDER_w, 1, 0, 0, "(GTK_STYLE_PROVIDER obj) casts obj to GTK_STYLE_PROVIDER", pl_bpt);
  Xg_define_procedure(GTK_CSS_PROVIDER, gxg_GTK_CSS_PROVIDER_w, 1, 0, 0, "(GTK_CSS_PROVIDER obj) casts obj to GTK_CSS_PROVIDER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  Xg_define_procedure(GTK_EMOJI_CHOOSER, gxg_GTK_EMOJI_CHOOSER_w, 1, 0, 0, "(GTK_EMOJI_CHOOSER obj) casts obj to GTK_EMOJI_CHOOSER", pl_bpt);
  Xg_define_procedure(GTK_EVENT_CONTROLLER_SCROLL, gxg_GTK_EVENT_CONTROLLER_SCROLL_w, 1, 0, 0, "(GTK_EVENT_CONTROLLER_SCROLL obj) casts obj to GTK_EVENT_CONTROLLER_SCROLL", pl_bpt);
  Xg_define_procedure(GTK_EVENT_CONTROLLER_MOTION, gxg_GTK_EVENT_CONTROLLER_MOTION_w, 1, 0, 0, "(GTK_EVENT_CONTROLLER_MOTION obj) casts obj to GTK_EVENT_CONTROLLER_MOTION", pl_bpt);
  Xg_define_procedure(GDK_TEXTURE, gxg_GDK_TEXTURE_w, 1, 0, 0, "(GDK_TEXTURE obj) casts obj to GDK_TEXTURE", pl_bpt);
  Xg_define_procedure(GDK_EVENT, gxg_GDK_EVENT_w, 1, 0, 0, "(GDK_EVENT obj) casts obj to GDK_EVENT", pl_bpt);
  Xg_define_procedure(GDK_APP_LAUNCH_CONTEXT, gxg_GDK_APP_LAUNCH_CONTEXT_w, 1, 0, 0, "(GDK_APP_LAUNCH_CONTEXT obj) casts obj to GDK_APP_LAUNCH_CONTEXT", pl_bpt);
  Xg_define_procedure(GDK_CLIPBOARD, gxg_GDK_CLIPBOARD_w, 1, 0, 0, "(GDK_CLIPBOARD obj) casts obj to GDK_CLIPBOARD", pl_bpt);
  Xg_define_procedure(GDK_CONTENT_PROVIDER, gxg_GDK_CONTENT_PROVIDER_w, 1, 0, 0, "(GDK_CONTENT_PROVIDER obj) casts obj to GDK_CONTENT_PROVIDER", pl_bpt);
  Xg_define_procedure(GDK_CONTENT_SERIALIZER, gxg_GDK_CONTENT_SERIALIZER_w, 1, 0, 0, "(GDK_CONTENT_SERIALIZER obj) casts obj to GDK_CONTENT_SERIALIZER", pl_bpt);
  Xg_define_procedure(GDK_CONTENT_DESERIALIZER, gxg_GDK_CONTENT_DESERIALIZER_w, 1, 0, 0, "(GDK_CONTENT_DESERIALIZER obj) casts obj to GDK_CONTENT_DESERIALIZER", pl_bpt);
  Xg_define_procedure(GTK_APPLICATION, gxg_GTK_APPLICATION_w, 1, 0, 0, "(GTK_APPLICATION obj) casts obj to GTK_APPLICATION", pl_bpt);
#endif

  Xg_define_procedure(c-array->list, c_array_to_xen_list_w, 2, 0, 0, NULL, NULL);
  Xg_define_procedure(list->c-array, xen_list_to_c_array_w, 2, 0, 0, NULL, NULL);
  Xg_define_procedure(g_object_get, xg_object_get_w, 3, 0, 0, NULL, NULL);
  Xg_define_procedure(g_object_set, xg_object_set_w, 3, 0, 0, NULL, NULL);
  Xg_define_procedure(gtk_event_keyval, xg_gtk_event_keyval_w, 1, 0, 0, NULL, NULL);
#if (!GTK_CHECK_VERSION(3, 90, 0))
  Xg_define_procedure(gtk_init, gxg_gtk_init_w, 0, 2, 0, H_gtk_init, NULL);
  Xg_define_procedure(gtk_init_check, gxg_gtk_init_check_w, 0, 2, 0, H_gtk_init_check, NULL);
  Xg_define_procedure(gtk_widget_set_events, gxg_gtk_widget_set_events_w, 2, 0, 0, H_gtk_widget_set_events, pl_tui);
#else
  Xg_define_procedure(gtk_init, gxg_gtk_init_w, 0, 0, 0, NULL, NULL);
#endif
  Xg_define_procedure(GDK_IS_DRAG_CONTEXT, gxg_GDK_IS_DRAG_CONTEXT_w, 1, 0, 0, "(GDK_IS_DRAG_CONTEXT obj): " PROC_TRUE " if obj is a GdkDragContext*", pl_bt);
  Xg_define_procedure(GDK_IS_DEVICE, gxg_GDK_IS_DEVICE_w, 1, 0, 0, "(GDK_IS_DEVICE obj): " PROC_TRUE " if obj is a GdkDevice*", pl_bt);
  Xg_define_procedure(GDK_IS_KEYMAP, gxg_GDK_IS_KEYMAP_w, 1, 0, 0, "(GDK_IS_KEYMAP obj): " PROC_TRUE " if obj is a GdkKeymap*", pl_bt);
  Xg_define_procedure(GDK_IS_WINDOW, gxg_GDK_IS_WINDOW_w, 1, 0, 0, "(GDK_IS_WINDOW obj): " PROC_TRUE " if obj is a GdkWindow*", pl_bt);
  Xg_define_procedure(GDK_IS_PIXBUF, gxg_GDK_IS_PIXBUF_w, 1, 0, 0, "(GDK_IS_PIXBUF obj): " PROC_TRUE " if obj is a GdkPixbuf*", pl_bt);
  Xg_define_procedure(GTK_IS_ACCEL_GROUP, gxg_GTK_IS_ACCEL_GROUP_w, 1, 0, 0, "(GTK_IS_ACCEL_GROUP obj): " PROC_TRUE " if obj is a GtkAccelGroup*", pl_bt);
  Xg_define_procedure(GTK_IS_ACCEL_LABEL, gxg_GTK_IS_ACCEL_LABEL_w, 1, 0, 0, "(GTK_IS_ACCEL_LABEL obj): " PROC_TRUE " if obj is a GtkAccelLabel*", pl_bt);
  Xg_define_procedure(GTK_IS_ACCESSIBLE, gxg_GTK_IS_ACCESSIBLE_w, 1, 0, 0, "(GTK_IS_ACCESSIBLE obj): " PROC_TRUE " if obj is a GtkAccessible*", pl_bt);
  Xg_define_procedure(GTK_IS_ADJUSTMENT, gxg_GTK_IS_ADJUSTMENT_w, 1, 0, 0, "(GTK_IS_ADJUSTMENT obj): " PROC_TRUE " if obj is a GtkAdjustment*", pl_bt);
  Xg_define_procedure(GTK_IS_ASPECT_FRAME, gxg_GTK_IS_ASPECT_FRAME_w, 1, 0, 0, "(GTK_IS_ASPECT_FRAME obj): " PROC_TRUE " if obj is a GtkAspectFrame*", pl_bt);
  Xg_define_procedure(GTK_IS_BUTTON_BOX, gxg_GTK_IS_BUTTON_BOX_w, 1, 0, 0, "(GTK_IS_BUTTON_BOX obj): " PROC_TRUE " if obj is a GtkButtonBox*", pl_bt);
  Xg_define_procedure(GTK_IS_BIN, gxg_GTK_IS_BIN_w, 1, 0, 0, "(GTK_IS_BIN obj): " PROC_TRUE " if obj is a GtkBin*", pl_bt);
  Xg_define_procedure(GTK_IS_BOX, gxg_GTK_IS_BOX_w, 1, 0, 0, "(GTK_IS_BOX obj): " PROC_TRUE " if obj is a GtkBox*", pl_bt);
  Xg_define_procedure(GTK_IS_BUTTON, gxg_GTK_IS_BUTTON_w, 1, 0, 0, "(GTK_IS_BUTTON obj): " PROC_TRUE " if obj is a GtkButton*", pl_bt);
  Xg_define_procedure(GTK_IS_CALENDAR, gxg_GTK_IS_CALENDAR_w, 1, 0, 0, "(GTK_IS_CALENDAR obj): " PROC_TRUE " if obj is a GtkCalendar*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_EDITABLE, gxg_GTK_IS_CELL_EDITABLE_w, 1, 0, 0, "(GTK_IS_CELL_EDITABLE obj): " PROC_TRUE " if obj is a GtkCellEditable*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER, gxg_GTK_IS_CELL_RENDERER_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER obj): " PROC_TRUE " if obj is a GtkCellRenderer*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_PIXBUF, gxg_GTK_IS_CELL_RENDERER_PIXBUF_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_PIXBUF obj): " PROC_TRUE " if obj is a GtkCellRendererPixbuf*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_TEXT, gxg_GTK_IS_CELL_RENDERER_TEXT_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_TEXT obj): " PROC_TRUE " if obj is a GtkCellRendererText*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_TOGGLE, gxg_GTK_IS_CELL_RENDERER_TOGGLE_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_TOGGLE obj): " PROC_TRUE " if obj is a GtkCellRendererToggle*", pl_bt);
  Xg_define_procedure(GTK_IS_CHECK_BUTTON, gxg_GTK_IS_CHECK_BUTTON_w, 1, 0, 0, "(GTK_IS_CHECK_BUTTON obj): " PROC_TRUE " if obj is a GtkCheckButton*", pl_bt);
  Xg_define_procedure(GTK_IS_CHECK_MENU_ITEM, gxg_GTK_IS_CHECK_MENU_ITEM_w, 1, 0, 0, "(GTK_IS_CHECK_MENU_ITEM obj): " PROC_TRUE " if obj is a GtkCheckMenuItem*", pl_bt);
  Xg_define_procedure(GTK_IS_CONTAINER, gxg_GTK_IS_CONTAINER_w, 1, 0, 0, "(GTK_IS_CONTAINER obj): " PROC_TRUE " if obj is a GtkContainer*", pl_bt);
  Xg_define_procedure(GTK_IS_DIALOG, gxg_GTK_IS_DIALOG_w, 1, 0, 0, "(GTK_IS_DIALOG obj): " PROC_TRUE " if obj is a GtkDialog*", pl_bt);
  Xg_define_procedure(GTK_IS_DRAWING_AREA, gxg_GTK_IS_DRAWING_AREA_w, 1, 0, 0, "(GTK_IS_DRAWING_AREA obj): " PROC_TRUE " if obj is a GtkDrawingArea*", pl_bt);
  Xg_define_procedure(GTK_IS_EDITABLE, gxg_GTK_IS_EDITABLE_w, 1, 0, 0, "(GTK_IS_EDITABLE obj): " PROC_TRUE " if obj is a GtkEditable*", pl_bt);
  Xg_define_procedure(GTK_IS_ENTRY, gxg_GTK_IS_ENTRY_w, 1, 0, 0, "(GTK_IS_ENTRY obj): " PROC_TRUE " if obj is a GtkEntry*", pl_bt);
  Xg_define_procedure(GTK_IS_FIXED, gxg_GTK_IS_FIXED_w, 1, 0, 0, "(GTK_IS_FIXED obj): " PROC_TRUE " if obj is a GtkFixed*", pl_bt);
  Xg_define_procedure(GTK_IS_FRAME, gxg_GTK_IS_FRAME_w, 1, 0, 0, "(GTK_IS_FRAME obj): " PROC_TRUE " if obj is a GtkFrame*", pl_bt);
  Xg_define_procedure(GTK_IS_IMAGE, gxg_GTK_IS_IMAGE_w, 1, 0, 0, "(GTK_IS_IMAGE obj): " PROC_TRUE " if obj is a GtkImage*", pl_bt);
  Xg_define_procedure(GTK_IS_IM_CONTEXT, gxg_GTK_IS_IM_CONTEXT_w, 1, 0, 0, "(GTK_IS_IM_CONTEXT obj): " PROC_TRUE " if obj is a GtkIMContext*", pl_bt);
  Xg_define_procedure(GTK_IS_IM_CONTEXT_SIMPLE, gxg_GTK_IS_IM_CONTEXT_SIMPLE_w, 1, 0, 0, "(GTK_IS_IM_CONTEXT_SIMPLE obj): " PROC_TRUE " if obj is a GtkIMContextSimple*", pl_bt);
  Xg_define_procedure(GTK_IS_INVISIBLE, gxg_GTK_IS_INVISIBLE_w, 1, 0, 0, "(GTK_IS_INVISIBLE obj): " PROC_TRUE " if obj is a GtkInvisible*", pl_bt);
  Xg_define_procedure(GTK_IS_LABEL, gxg_GTK_IS_LABEL_w, 1, 0, 0, "(GTK_IS_LABEL obj): " PROC_TRUE " if obj is a GtkLabel*", pl_bt);
  Xg_define_procedure(GTK_IS_LAYOUT, gxg_GTK_IS_LAYOUT_w, 1, 0, 0, "(GTK_IS_LAYOUT obj): " PROC_TRUE " if obj is a GtkLayout*", pl_bt);
  Xg_define_procedure(GTK_IS_LIST_STORE, gxg_GTK_IS_LIST_STORE_w, 1, 0, 0, "(GTK_IS_LIST_STORE obj): " PROC_TRUE " if obj is a GtkListStore*", pl_bt);
  Xg_define_procedure(GTK_IS_MENU_BAR, gxg_GTK_IS_MENU_BAR_w, 1, 0, 0, "(GTK_IS_MENU_BAR obj): " PROC_TRUE " if obj is a GtkMenuBar*", pl_bt);
  Xg_define_procedure(GTK_IS_MENU, gxg_GTK_IS_MENU_w, 1, 0, 0, "(GTK_IS_MENU obj): " PROC_TRUE " if obj is a GtkMenu*", pl_bt);
  Xg_define_procedure(GTK_IS_MENU_ITEM, gxg_GTK_IS_MENU_ITEM_w, 1, 0, 0, "(GTK_IS_MENU_ITEM obj): " PROC_TRUE " if obj is a GtkMenuItem*", pl_bt);
  Xg_define_procedure(GTK_IS_MENU_SHELL, gxg_GTK_IS_MENU_SHELL_w, 1, 0, 0, "(GTK_IS_MENU_SHELL obj): " PROC_TRUE " if obj is a GtkMenuShell*", pl_bt);
  Xg_define_procedure(GTK_IS_NOTEBOOK, gxg_GTK_IS_NOTEBOOK_w, 1, 0, 0, "(GTK_IS_NOTEBOOK obj): " PROC_TRUE " if obj is a GtkNotebook*", pl_bt);
  Xg_define_procedure(GTK_IS_PANED, gxg_GTK_IS_PANED_w, 1, 0, 0, "(GTK_IS_PANED obj): " PROC_TRUE " if obj is a GtkPaned*", pl_bt);
  Xg_define_procedure(GTK_IS_PROGRESS_BAR, gxg_GTK_IS_PROGRESS_BAR_w, 1, 0, 0, "(GTK_IS_PROGRESS_BAR obj): " PROC_TRUE " if obj is a GtkProgressBar*", pl_bt);
  Xg_define_procedure(GTK_IS_RADIO_BUTTON, gxg_GTK_IS_RADIO_BUTTON_w, 1, 0, 0, "(GTK_IS_RADIO_BUTTON obj): " PROC_TRUE " if obj is a GtkRadioButton*", pl_bt);
  Xg_define_procedure(GTK_IS_RADIO_MENU_ITEM, gxg_GTK_IS_RADIO_MENU_ITEM_w, 1, 0, 0, "(GTK_IS_RADIO_MENU_ITEM obj): " PROC_TRUE " if obj is a GtkRadioMenuItem*", pl_bt);
  Xg_define_procedure(GTK_IS_RANGE, gxg_GTK_IS_RANGE_w, 1, 0, 0, "(GTK_IS_RANGE obj): " PROC_TRUE " if obj is a GtkRange*", pl_bt);
  Xg_define_procedure(GTK_IS_SCALE, gxg_GTK_IS_SCALE_w, 1, 0, 0, "(GTK_IS_SCALE obj): " PROC_TRUE " if obj is a GtkScale*", pl_bt);
  Xg_define_procedure(GTK_IS_SCROLLBAR, gxg_GTK_IS_SCROLLBAR_w, 1, 0, 0, "(GTK_IS_SCROLLBAR obj): " PROC_TRUE " if obj is a GtkScrollbar*", pl_bt);
  Xg_define_procedure(GTK_IS_SCROLLED_WINDOW, gxg_GTK_IS_SCROLLED_WINDOW_w, 1, 0, 0, "(GTK_IS_SCROLLED_WINDOW obj): " PROC_TRUE " if obj is a GtkScrolledWindow*", pl_bt);
  Xg_define_procedure(GTK_IS_SEPARATOR, gxg_GTK_IS_SEPARATOR_w, 1, 0, 0, "(GTK_IS_SEPARATOR obj): " PROC_TRUE " if obj is a GtkSeparator*", pl_bt);
  Xg_define_procedure(GTK_IS_SEPARATOR_MENU_ITEM, gxg_GTK_IS_SEPARATOR_MENU_ITEM_w, 1, 0, 0, "(GTK_IS_SEPARATOR_MENU_ITEM obj): " PROC_TRUE " if obj is a GtkSeparatorMenuItem*", pl_bt);
  Xg_define_procedure(GTK_IS_SETTINGS, gxg_GTK_IS_SETTINGS_w, 1, 0, 0, "(GTK_IS_SETTINGS obj): " PROC_TRUE " if obj is a GtkSettings*", pl_bt);
  Xg_define_procedure(GTK_IS_SIZE_GROUP, gxg_GTK_IS_SIZE_GROUP_w, 1, 0, 0, "(GTK_IS_SIZE_GROUP obj): " PROC_TRUE " if obj is a GtkSizeGroup*", pl_bt);
  Xg_define_procedure(GTK_IS_SPIN_BUTTON, gxg_GTK_IS_SPIN_BUTTON_w, 1, 0, 0, "(GTK_IS_SPIN_BUTTON obj): " PROC_TRUE " if obj is a GtkSpinButton*", pl_bt);
  Xg_define_procedure(GTK_IS_STATUSBAR, gxg_GTK_IS_STATUSBAR_w, 1, 0, 0, "(GTK_IS_STATUSBAR obj): " PROC_TRUE " if obj is a GtkStatusbar*", pl_bt);
  Xg_define_procedure(GTK_IS_TEXT_BUFFER, gxg_GTK_IS_TEXT_BUFFER_w, 1, 0, 0, "(GTK_IS_TEXT_BUFFER obj): " PROC_TRUE " if obj is a GtkTextBuffer*", pl_bt);
  Xg_define_procedure(GTK_IS_TEXT_CHILD_ANCHOR, gxg_GTK_IS_TEXT_CHILD_ANCHOR_w, 1, 0, 0, "(GTK_IS_TEXT_CHILD_ANCHOR obj): " PROC_TRUE " if obj is a GtkTextChildAnchor*", pl_bt);
  Xg_define_procedure(GTK_IS_TEXT_MARK, gxg_GTK_IS_TEXT_MARK_w, 1, 0, 0, "(GTK_IS_TEXT_MARK obj): " PROC_TRUE " if obj is a GtkTextMark*", pl_bt);
  Xg_define_procedure(GTK_IS_TEXT_TAG, gxg_GTK_IS_TEXT_TAG_w, 1, 0, 0, "(GTK_IS_TEXT_TAG obj): " PROC_TRUE " if obj is a GtkTextTag*", pl_bt);
  Xg_define_procedure(GTK_IS_TEXT_TAG_TABLE, gxg_GTK_IS_TEXT_TAG_TABLE_w, 1, 0, 0, "(GTK_IS_TEXT_TAG_TABLE obj): " PROC_TRUE " if obj is a GtkTextTagTable*", pl_bt);
  Xg_define_procedure(GTK_IS_TEXT_VIEW, gxg_GTK_IS_TEXT_VIEW_w, 1, 0, 0, "(GTK_IS_TEXT_VIEW obj): " PROC_TRUE " if obj is a GtkTextView*", pl_bt);
  Xg_define_procedure(GTK_IS_TOGGLE_BUTTON, gxg_GTK_IS_TOGGLE_BUTTON_w, 1, 0, 0, "(GTK_IS_TOGGLE_BUTTON obj): " PROC_TRUE " if obj is a GtkToggleButton*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOLBAR, gxg_GTK_IS_TOOLBAR_w, 1, 0, 0, "(GTK_IS_TOOLBAR obj): " PROC_TRUE " if obj is a GtkToolbar*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_DRAG_SOURCE, gxg_GTK_IS_TREE_DRAG_SOURCE_w, 1, 0, 0, "(GTK_IS_TREE_DRAG_SOURCE obj): " PROC_TRUE " if obj is a GtkTreeDragSource*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_DRAG_DEST, gxg_GTK_IS_TREE_DRAG_DEST_w, 1, 0, 0, "(GTK_IS_TREE_DRAG_DEST obj): " PROC_TRUE " if obj is a GtkTreeDragDest*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_MODEL, gxg_GTK_IS_TREE_MODEL_w, 1, 0, 0, "(GTK_IS_TREE_MODEL obj): " PROC_TRUE " if obj is a GtkTreeModel*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_MODEL_SORT, gxg_GTK_IS_TREE_MODEL_SORT_w, 1, 0, 0, "(GTK_IS_TREE_MODEL_SORT obj): " PROC_TRUE " if obj is a GtkTreeModelSort*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_SELECTION, gxg_GTK_IS_TREE_SELECTION_w, 1, 0, 0, "(GTK_IS_TREE_SELECTION obj): " PROC_TRUE " if obj is a GtkTreeSelection*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_SORTABLE, gxg_GTK_IS_TREE_SORTABLE_w, 1, 0, 0, "(GTK_IS_TREE_SORTABLE obj): " PROC_TRUE " if obj is a GtkTreeSortable*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_STORE, gxg_GTK_IS_TREE_STORE_w, 1, 0, 0, "(GTK_IS_TREE_STORE obj): " PROC_TRUE " if obj is a GtkTreeStore*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_VIEW_COLUMN, gxg_GTK_IS_TREE_VIEW_COLUMN_w, 1, 0, 0, "(GTK_IS_TREE_VIEW_COLUMN obj): " PROC_TRUE " if obj is a GtkTreeViewColumn*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_VIEW, gxg_GTK_IS_TREE_VIEW_w, 1, 0, 0, "(GTK_IS_TREE_VIEW obj): " PROC_TRUE " if obj is a GtkTreeView*", pl_bt);
  Xg_define_procedure(GTK_IS_VIEWPORT, gxg_GTK_IS_VIEWPORT_w, 1, 0, 0, "(GTK_IS_VIEWPORT obj): " PROC_TRUE " if obj is a GtkViewport*", pl_bt);
  Xg_define_procedure(GTK_IS_WIDGET, gxg_GTK_IS_WIDGET_w, 1, 0, 0, "(GTK_IS_WIDGET obj): " PROC_TRUE " if obj is a GtkWidget*", pl_bt);
  Xg_define_procedure(GTK_IS_WINDOW, gxg_GTK_IS_WINDOW_w, 1, 0, 0, "(GTK_IS_WINDOW obj): " PROC_TRUE " if obj is a GtkWindow*", pl_bt);
  Xg_define_procedure(PANGO_IS_CONTEXT, gxg_PANGO_IS_CONTEXT_w, 1, 0, 0, "(PANGO_IS_CONTEXT obj): " PROC_TRUE " if obj is a PangoContext*", pl_bt);
  Xg_define_procedure(PANGO_IS_FONT_FAMILY, gxg_PANGO_IS_FONT_FAMILY_w, 1, 0, 0, "(PANGO_IS_FONT_FAMILY obj): " PROC_TRUE " if obj is a PangoFontFamily*", pl_bt);
  Xg_define_procedure(PANGO_IS_FONT_FACE, gxg_PANGO_IS_FONT_FACE_w, 1, 0, 0, "(PANGO_IS_FONT_FACE obj): " PROC_TRUE " if obj is a PangoFontFace*", pl_bt);
  Xg_define_procedure(PANGO_IS_FONT, gxg_PANGO_IS_FONT_w, 1, 0, 0, "(PANGO_IS_FONT obj): " PROC_TRUE " if obj is a PangoFont*", pl_bt);
  Xg_define_procedure(PANGO_IS_FONT_MAP, gxg_PANGO_IS_FONT_MAP_w, 1, 0, 0, "(PANGO_IS_FONT_MAP obj): " PROC_TRUE " if obj is a PangoFontMap*", pl_bt);
  Xg_define_procedure(PANGO_IS_LAYOUT, gxg_PANGO_IS_LAYOUT_w, 1, 0, 0, "(PANGO_IS_LAYOUT obj): " PROC_TRUE " if obj is a PangoLayout*", pl_bt);
  Xg_define_procedure(G_IS_OBJECT, gxg_G_IS_OBJECT_w, 1, 0, 0, "(G_IS_OBJECT obj): " PROC_TRUE " if obj is a GObject*", pl_bt);
  Xg_define_procedure(GDK_IS_DISPLAY, gxg_GDK_IS_DISPLAY_w, 1, 0, 0, "(GDK_IS_DISPLAY obj): " PROC_TRUE " if obj is a GdkDisplay*", pl_bt);
  Xg_define_procedure(GTK_IS_FILE_CHOOSER_DIALOG, gxg_GTK_IS_FILE_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_DIALOG obj): " PROC_TRUE " if obj is a GtkFileChooserDialog*", pl_bt);
  Xg_define_procedure(GTK_IS_FILE_CHOOSER_WIDGET, gxg_GTK_IS_FILE_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_WIDGET obj): " PROC_TRUE " if obj is a GtkFileChooserWidget*", pl_bt);
  Xg_define_procedure(GTK_IS_TREE_MODEL_FILTER, gxg_GTK_IS_TREE_MODEL_FILTER_w, 1, 0, 0, "(GTK_IS_TREE_MODEL_FILTER obj): " PROC_TRUE " if obj is a GtkTreeModelFilter*", pl_bt);
  Xg_define_procedure(GTK_IS_COMBO_BOX, gxg_GTK_IS_COMBO_BOX_w, 1, 0, 0, "(GTK_IS_COMBO_BOX obj): " PROC_TRUE " if obj is a GtkComboBox*", pl_bt);
  Xg_define_procedure(GTK_IS_EXPANDER, gxg_GTK_IS_EXPANDER_w, 1, 0, 0, "(GTK_IS_EXPANDER obj): " PROC_TRUE " if obj is a GtkExpander*", pl_bt);
  Xg_define_procedure(GTK_IS_FONT_BUTTON, gxg_GTK_IS_FONT_BUTTON_w, 1, 0, 0, "(GTK_IS_FONT_BUTTON obj): " PROC_TRUE " if obj is a GtkFontButton*", pl_bt);
  Xg_define_procedure(GTK_IS_COLOR_BUTTON, gxg_GTK_IS_COLOR_BUTTON_w, 1, 0, 0, "(GTK_IS_COLOR_BUTTON obj): " PROC_TRUE " if obj is a GtkColorButton*", pl_bt);
  Xg_define_procedure(GTK_IS_ENTRY_COMPLETION, gxg_GTK_IS_ENTRY_COMPLETION_w, 1, 0, 0, "(GTK_IS_ENTRY_COMPLETION obj): " PROC_TRUE " if obj is a GtkEntryCompletion*", pl_bt);
  Xg_define_procedure(GTK_IS_RADIO_TOOL_BUTTON, gxg_GTK_IS_RADIO_TOOL_BUTTON_w, 1, 0, 0, "(GTK_IS_RADIO_TOOL_BUTTON obj): " PROC_TRUE " if obj is a GtkRadioToolButton*", pl_bt);
  Xg_define_procedure(GTK_IS_SEPARATOR_TOOL_ITEM, gxg_GTK_IS_SEPARATOR_TOOL_ITEM_w, 1, 0, 0, "(GTK_IS_SEPARATOR_TOOL_ITEM obj): " PROC_TRUE " if obj is a GtkSeparatorToolItem*", pl_bt);
  Xg_define_procedure(GTK_IS_TOGGLE_TOOL_BUTTON, gxg_GTK_IS_TOGGLE_TOOL_BUTTON_w, 1, 0, 0, "(GTK_IS_TOGGLE_TOOL_BUTTON obj): " PROC_TRUE " if obj is a GtkToggleToolButton*", pl_bt);
  Xg_define_procedure(GTK_IS_FILE_FILTER, gxg_GTK_IS_FILE_FILTER_w, 1, 0, 0, "(GTK_IS_FILE_FILTER obj): " PROC_TRUE " if obj is a GtkFileFilter*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_LAYOUT, gxg_GTK_IS_CELL_LAYOUT_w, 1, 0, 0, "(GTK_IS_CELL_LAYOUT obj): " PROC_TRUE " if obj is a GtkCellLayout*", pl_bt);
  Xg_define_procedure(GTK_IS_FILE_CHOOSER, gxg_GTK_IS_FILE_CHOOSER_w, 1, 0, 0, "(GTK_IS_FILE_CHOOSER obj): " PROC_TRUE " if obj is a GtkFileChooser*", pl_bt);
  Xg_define_procedure(GTK_IS_ICON_THEME, gxg_GTK_IS_ICON_THEME_w, 1, 0, 0, "(GTK_IS_ICON_THEME obj): " PROC_TRUE " if obj is a GtkIconTheme*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOL_BUTTON, gxg_GTK_IS_TOOL_BUTTON_w, 1, 0, 0, "(GTK_IS_TOOL_BUTTON obj): " PROC_TRUE " if obj is a GtkToolButton*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOL_ITEM, gxg_GTK_IS_TOOL_ITEM_w, 1, 0, 0, "(GTK_IS_TOOL_ITEM obj): " PROC_TRUE " if obj is a GtkToolItem*", pl_bt);
  Xg_define_procedure(GTK_IS_ACCEL_MAP, gxg_GTK_IS_ACCEL_MAP_w, 1, 0, 0, "(GTK_IS_ACCEL_MAP obj): " PROC_TRUE " if obj is a GtkAccelMap", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_VIEW, gxg_GTK_IS_CELL_VIEW_w, 1, 0, 0, "(GTK_IS_CELL_VIEW obj): " PROC_TRUE " if obj is a GtkCellView*", pl_bt);
  Xg_define_procedure(GTK_IS_ABOUT_DIALOG, gxg_GTK_IS_ABOUT_DIALOG_w, 1, 0, 0, "(GTK_IS_ABOUT_DIALOG obj): " PROC_TRUE " if obj is a GtkAboutDialog*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_COMBO, gxg_GTK_IS_CELL_RENDERER_COMBO_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_COMBO obj): " PROC_TRUE " if obj is a GtkCellRendererCombo*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_PROGRESS, gxg_GTK_IS_CELL_RENDERER_PROGRESS_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_PROGRESS obj): " PROC_TRUE " if obj is a GtkCellRendererProgress*", pl_bt);
  Xg_define_procedure(GTK_IS_ICON_VIEW, gxg_GTK_IS_ICON_VIEW_w, 1, 0, 0, "(GTK_IS_ICON_VIEW obj): " PROC_TRUE " if obj is a GtkIconView*", pl_bt);
  Xg_define_procedure(GTK_IS_FILE_CHOOSER_BUTTON, gxg_GTK_IS_FILE_CHOOSER_BUTTON_w, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_BUTTON obj): " PROC_TRUE " if obj is a GtkFileChooserButton*", pl_bt);
  Xg_define_procedure(GTK_IS_MENU_TOOL_BUTTON, gxg_GTK_IS_MENU_TOOL_BUTTON_w, 1, 0, 0, "(GTK_IS_MENU_TOOL_BUTTON obj): " PROC_TRUE " if obj is a GtkMenuToolButton*", pl_bt);
  Xg_define_procedure(GTK_IS_ASSISTANT, gxg_GTK_IS_ASSISTANT_w, 1, 0, 0, "(GTK_IS_ASSISTANT obj): " PROC_TRUE " if obj is a GtkAssistant*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_ACCEL, gxg_GTK_IS_CELL_RENDERER_ACCEL_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_ACCEL obj): " PROC_TRUE " if obj is a GtkCellRendererAccel*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_SPIN, gxg_GTK_IS_CELL_RENDERER_SPIN_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_SPIN obj): " PROC_TRUE " if obj is a GtkCellRendererSpin*", pl_bt);
  Xg_define_procedure(GTK_IS_LINK_BUTTON, gxg_GTK_IS_LINK_BUTTON_w, 1, 0, 0, "(GTK_IS_LINK_BUTTON obj): " PROC_TRUE " if obj is a GtkLinkButton*", pl_bt);
  Xg_define_procedure(GTK_IS_RECENT_CHOOSER_DIALOG, gxg_GTK_IS_RECENT_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER_DIALOG obj): " PROC_TRUE " if obj is a GtkRecentChooserDialog*", pl_bt);
  Xg_define_procedure(GTK_IS_RECENT_CHOOSER, gxg_GTK_IS_RECENT_CHOOSER_w, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER obj): " PROC_TRUE " if obj is a GtkRecentChooser*", pl_bt);
  Xg_define_procedure(GTK_IS_RECENT_CHOOSER_MENU, gxg_GTK_IS_RECENT_CHOOSER_MENU_w, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER_MENU obj): " PROC_TRUE " if obj is a GtkRecentChooserMenu*", pl_bt);
  Xg_define_procedure(GTK_IS_RECENT_CHOOSER_WIDGET, gxg_GTK_IS_RECENT_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER_WIDGET obj): " PROC_TRUE " if obj is a GtkRecentChooserWidget*", pl_bt);
  Xg_define_procedure(GTK_IS_RECENT_FILTER, gxg_GTK_IS_RECENT_FILTER_w, 1, 0, 0, "(GTK_IS_RECENT_FILTER obj): " PROC_TRUE " if obj is a GtkRecentFilter*", pl_bt);
  Xg_define_procedure(GTK_IS_RECENT_MANAGER, gxg_GTK_IS_RECENT_MANAGER_w, 1, 0, 0, "(GTK_IS_RECENT_MANAGER obj): " PROC_TRUE " if obj is a GtkRecentManager*", pl_bt);
  Xg_define_procedure(GTK_IS_PRINT_CONTEXT, gxg_GTK_IS_PRINT_CONTEXT_w, 1, 0, 0, "(GTK_IS_PRINT_CONTEXT obj): " PROC_TRUE " if obj is a GtkPrintContext*", pl_bt);
  Xg_define_procedure(GTK_IS_PRINT_OPERATION, gxg_GTK_IS_PRINT_OPERATION_w, 1, 0, 0, "(GTK_IS_PRINT_OPERATION obj): " PROC_TRUE " if obj is a GtkPrintOperation*", pl_bt);
  Xg_define_procedure(GTK_IS_PRINT_SETTINGS, gxg_GTK_IS_PRINT_SETTINGS_w, 1, 0, 0, "(GTK_IS_PRINT_SETTINGS obj): " PROC_TRUE " if obj is a GtkPrintSettings*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOLTIP, gxg_GTK_IS_TOOLTIP_w, 1, 0, 0, "(GTK_IS_TOOLTIP obj): " PROC_TRUE " if obj is a GtkTooltip*", pl_bt);
#if GTK_CHECK_VERSION(2, 18, 0)
  Xg_define_procedure(GTK_IS_INFO_BAR, gxg_GTK_IS_INFO_BAR_w, 1, 0, 0, "(GTK_IS_INFO_BAR obj): " PROC_TRUE " if obj is a GtkInfoBar*", pl_bt);
  Xg_define_procedure(GTK_IS_ENTRY_BUFFER, gxg_GTK_IS_ENTRY_BUFFER_w, 1, 0, 0, "(GTK_IS_ENTRY_BUFFER obj): " PROC_TRUE " if obj is a GtkEntryBuffer*", pl_bt);
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
  Xg_define_procedure(GTK_IS_SPINNER, gxg_GTK_IS_SPINNER_w, 1, 0, 0, "(GTK_IS_SPINNER obj): " PROC_TRUE " if obj is a GtkSpinner*", pl_bt);
  Xg_define_procedure(GTK_IS_CELL_RENDERER_SPINNER, gxg_GTK_IS_CELL_RENDERER_SPINNER_w, 1, 0, 0, "(GTK_IS_CELL_RENDERER_SPINNER obj): " PROC_TRUE " if obj is a GtkCellRendererSpinner*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOL_PALETTE, gxg_GTK_IS_TOOL_PALETTE_w, 1, 0, 0, "(GTK_IS_TOOL_PALETTE obj): " PROC_TRUE " if obj is a GtkToolPalette*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOL_ITEM_GROUP, gxg_GTK_IS_TOOL_ITEM_GROUP_w, 1, 0, 0, "(GTK_IS_TOOL_ITEM_GROUP obj): " PROC_TRUE " if obj is a GtkToolItemGroup*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  Xg_define_procedure(GTK_IS_COMBO_BOX_TEXT, gxg_GTK_IS_COMBO_BOX_TEXT_w, 1, 0, 0, "(GTK_IS_COMBO_BOX_TEXT obj): " PROC_TRUE " if obj is a GtkComboBoxText*", pl_bt);
  Xg_define_procedure(GTK_IS_GRID, gxg_GTK_IS_GRID_w, 1, 0, 0, "(GTK_IS_GRID obj): " PROC_TRUE " if obj is a GtkGrid*", pl_bt);
  Xg_define_procedure(GTK_IS_SCROLLABLE, gxg_GTK_IS_SCROLLABLE_w, 1, 0, 0, "(GTK_IS_SCROLLABLE obj): " PROC_TRUE " if obj is a GtkScrollable*", pl_bt);
  Xg_define_procedure(GTK_IS_SWITCH, gxg_GTK_IS_SWITCH_w, 1, 0, 0, "(GTK_IS_SWITCH obj): " PROC_TRUE " if obj is a GtkSwitch*", pl_bt);
  Xg_define_procedure(GTK_IS_ORIENTABLE, gxg_GTK_IS_ORIENTABLE_w, 1, 0, 0, "(GTK_IS_ORIENTABLE obj): " PROC_TRUE " if obj is a GtkOrientable*", pl_bt);
  Xg_define_procedure(GTK_IS_WINDOW_GROUP, gxg_GTK_IS_WINDOW_GROUP_w, 1, 0, 0, "(GTK_IS_WINDOW_GROUP obj): " PROC_TRUE " if obj is a GtkWindowGroup*", pl_bt);
  Xg_define_procedure(GTK_IS_TOOL_SHELL, gxg_GTK_IS_TOOL_SHELL_w, 1, 0, 0, "(GTK_IS_TOOL_SHELL obj): " PROC_TRUE " if obj is a GtkToolShell*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  Xg_define_procedure(GTK_IS_OVERLAY, gxg_GTK_IS_OVERLAY_w, 1, 0, 0, "(GTK_IS_OVERLAY obj): " PROC_TRUE " if obj is a GtkOverlay*", pl_bt);
  Xg_define_procedure(GTK_IS_FONT_CHOOSER, gxg_GTK_IS_FONT_CHOOSER_w, 1, 0, 0, "(GTK_IS_FONT_CHOOSER obj): " PROC_TRUE " if obj is a GtkFontChooser*", pl_bt);
  Xg_define_procedure(GTK_IS_FONT_CHOOSER_DIALOG, gxg_GTK_IS_FONT_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_IS_FONT_CHOOSER_DIALOG obj): " PROC_TRUE " if obj is a GtkFontChooserDialog*", pl_bt);
  Xg_define_procedure(GTK_IS_FONT_CHOOSER_WIDGET, gxg_GTK_IS_FONT_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_IS_FONT_CHOOSER_WIDGET obj): " PROC_TRUE " if obj is a GtkFontChooserWidget*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  Xg_define_procedure(GTK_IS_APPLICATION_WINDOW, gxg_GTK_IS_APPLICATION_WINDOW_w, 1, 0, 0, "(GTK_IS_APPLICATION_WINDOW obj): " PROC_TRUE " if obj is a GtkApplicationWindow*", pl_bt);
  Xg_define_procedure(GTK_IS_COLOR_CHOOSER_DIALOG, gxg_GTK_IS_COLOR_CHOOSER_DIALOG_w, 1, 0, 0, "(GTK_IS_COLOR_CHOOSER_DIALOG obj): " PROC_TRUE " if obj is a GtkColorChooserDialog*", pl_bt);
  Xg_define_procedure(GTK_IS_COLOR_CHOOSER_WIDGET, gxg_GTK_IS_COLOR_CHOOSER_WIDGET_w, 1, 0, 0, "(GTK_IS_COLOR_CHOOSER_WIDGET obj): " PROC_TRUE " if obj is a GtkColorWidget*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  Xg_define_procedure(GTK_IS_MENU_BUTTON, gxg_GTK_IS_MENU_BUTTON_w, 1, 0, 0, "(GTK_IS_MENU_BUTTON obj): " PROC_TRUE " if obj is a GtkMenuButton*", pl_bt);
  Xg_define_procedure(GTK_IS_SEARCH_ENTRY, gxg_GTK_IS_SEARCH_ENTRY_w, 1, 0, 0, "(GTK_IS_SEARCH_ENTRY obj): " PROC_TRUE " if obj is a GtkWidget*", pl_bt);
  Xg_define_procedure(GTK_IS_LEVEL_BAR, gxg_GTK_IS_LEVEL_BAR_w, 1, 0, 0, "(GTK_IS_LEVEL_BAR obj): " PROC_TRUE " if obj is a GtkLevelBar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  Xg_define_procedure(GTK_IS_PLACES_SIDEBAR, gxg_GTK_IS_PLACES_SIDEBAR_w, 1, 0, 0, "(GTK_IS_PLACES_SIDEBAR obj): " PROC_TRUE " if obj is a GtkPlacesSidebar*", pl_bt);
  Xg_define_procedure(GTK_IS_STACK_SWITCHER, gxg_GTK_IS_STACK_SWITCHER_w, 1, 0, 0, "(GTK_IS_STACK_SWITCHER obj): " PROC_TRUE " if obj is a GtkStackSwitcher*", pl_bt);
  Xg_define_procedure(GTK_IS_STACK, gxg_GTK_IS_STACK_w, 1, 0, 0, "(GTK_IS_STACK obj): " PROC_TRUE " if obj is a GtkStack*", pl_bt);
  Xg_define_procedure(GTK_IS_REVEALER, gxg_GTK_IS_REVEALER_w, 1, 0, 0, "(GTK_IS_REVEALER obj): " PROC_TRUE " if obj is a GtkRevealer*", pl_bt);
  Xg_define_procedure(GTK_IS_HEADER_BAR, gxg_GTK_IS_HEADER_BAR_w, 1, 0, 0, "(GTK_IS_HEADER_BAR obj): " PROC_TRUE " if obj is a GtkHeaderBar*", pl_bt);
  Xg_define_procedure(GTK_IS_LIST_BOX, gxg_GTK_IS_LIST_BOX_w, 1, 0, 0, "(GTK_IS_LIST_BOX obj): " PROC_TRUE " if obj is a GtkListBox*", pl_bt);
  Xg_define_procedure(GTK_IS_LIST_BOX_ROW, gxg_GTK_IS_LIST_BOX_ROW_w, 1, 0, 0, "(GTK_IS_LIST_BOX_ROW obj): " PROC_TRUE " if obj is a GtkListBoxRow*", pl_bt);
  Xg_define_procedure(GTK_IS_SEARCH_BAR, gxg_GTK_IS_SEARCH_BAR_w, 1, 0, 0, "(GTK_IS_SEARCH_BAR obj): " PROC_TRUE " if obj is a GtkSearchBar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  Xg_define_procedure(GTK_IS_FLOW_BOX, gxg_GTK_IS_FLOW_BOX_w, 1, 0, 0, "(GTK_IS_FLOW_BOX obj): " PROC_TRUE " if obj is a GtkFlowBox*", pl_bt);
  Xg_define_procedure(GTK_IS_FLOW_BOX_CHILD, gxg_GTK_IS_FLOW_BOX_CHILD_w, 1, 0, 0, "(GTK_IS_FLOW_BOX_CHILD obj): " PROC_TRUE " if obj is a GtkFlowBoxChild*", pl_bt);
  Xg_define_procedure(GTK_IS_ACTION_BAR, gxg_GTK_IS_ACTION_BAR_w, 1, 0, 0, "(GTK_IS_ACTION_BAR obj): " PROC_TRUE " if obj is a GtkActionBar*", pl_bt);
  Xg_define_procedure(GTK_IS_POPOVER, gxg_GTK_IS_POPOVER_w, 1, 0, 0, "(GTK_IS_POPOVER obj): " PROC_TRUE " if obj is a GtkPopover*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  Xg_define_procedure(GTK_IS_GESTURE, gxg_GTK_IS_GESTURE_w, 1, 0, 0, "(GTK_IS_GESTURE obj): " PROC_TRUE " if obj is a GtkGesture*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_DRAG, gxg_GTK_IS_GESTURE_DRAG_w, 1, 0, 0, "(GTK_IS_GESTURE_DRAG obj): " PROC_TRUE " if obj is a GtkGestureDrag*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_LONG_PRESS, gxg_GTK_IS_GESTURE_LONG_PRESS_w, 1, 0, 0, "(GTK_IS_GESTURE_LONG_PRESS obj): " PROC_TRUE " if obj is a GtkGestureLongPress*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_ZOOM, gxg_GTK_IS_GESTURE_ZOOM_w, 1, 0, 0, "(GTK_IS_GESTURE_ZOOM obj): " PROC_TRUE " if obj is a GtkGestureZoom*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_SWIPE, gxg_GTK_IS_GESTURE_SWIPE_w, 1, 0, 0, "(GTK_IS_GESTURE_SWIPE obj): " PROC_TRUE " if obj is a GtkGestureSwipe*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_SINGLE, gxg_GTK_IS_GESTURE_SINGLE_w, 1, 0, 0, "(GTK_IS_GESTURE_SINGLE obj): " PROC_TRUE " if obj is a GtkGestureSingle*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_PAN, gxg_GTK_IS_GESTURE_PAN_w, 1, 0, 0, "(GTK_IS_GESTURE_PAN obj): " PROC_TRUE " if obj is a GtkGesturePan*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_MULTI_PRESS, gxg_GTK_IS_GESTURE_MULTI_PRESS_w, 1, 0, 0, "(GTK_IS_GESTURE_MULTI_PRESS obj): " PROC_TRUE " if obj is a GtkGestureMultiPress*", pl_bt);
  Xg_define_procedure(GTK_IS_GESTURE_ROTATE, gxg_GTK_IS_GESTURE_ROTATE_w, 1, 0, 0, "(GTK_IS_GESTURE_ROTATE obj): " PROC_TRUE " if obj is a GtkGestureRotate*", pl_bt);
  Xg_define_procedure(GTK_IS_EVENT_CONTROLLER, gxg_GTK_IS_EVENT_CONTROLLER_w, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER obj): " PROC_TRUE " if obj is a GtkEventController*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  Xg_define_procedure(GTK_IS_GL_AREA, gxg_GTK_IS_GL_AREA_w, 1, 0, 0, "(GTK_IS_GL_AREA obj): " PROC_TRUE " if obj is a GtkGLArea*", pl_bt);
  Xg_define_procedure(GDK_IS_GL_CONTEXT, gxg_GDK_IS_GL_CONTEXT_w, 1, 0, 0, "(GDK_IS_GL_CONTEXT obj): " PROC_TRUE " if obj is a GdkGLContext*", pl_bt);
  Xg_define_procedure(GTK_IS_POPOVER_MENU, gxg_GTK_IS_POPOVER_MENU_w, 1, 0, 0, "(GTK_IS_POPOVER_MENU obj): " PROC_TRUE " if obj is a GtkPopoverMenu*", pl_bt);
  Xg_define_procedure(GTK_IS_STACK_SIDEBAR, gxg_GTK_IS_STACK_SIDEBAR_w, 1, 0, 0, "(GTK_IS_STACK_SIDEBAR obj): " PROC_TRUE " if obj is a GtkStackSidebar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  Xg_define_procedure(GDK_IS_SEAT, gxg_GDK_IS_SEAT_w, 1, 0, 0, "(GDK_IS_SEAT obj): " PROC_TRUE " if obj is a GdkSeat*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  Xg_define_procedure(GDK_IS_DEVICE_TOOL, gxg_GDK_IS_DEVICE_TOOL_w, 1, 0, 0, "(GDK_IS_DEVICE_TOOL obj): " PROC_TRUE " if obj is a GdkDeviceTool*", pl_bt);
  Xg_define_procedure(GDK_IS_MONITOR, gxg_GDK_IS_MONITOR_w, 1, 0, 0, "(GDK_IS_MONITOR obj): " PROC_TRUE " if obj is a GdkMonitor*", pl_bt);
  Xg_define_procedure(GDK_IS_DRAWING_CONTEXT, gxg_GDK_IS_DRAWING_CONTEXT_w, 1, 0, 0, "(GDK_IS_DRAWING_CONTEXT obj): " PROC_TRUE " if obj is a GdkDrawingContext*", pl_bt);
  Xg_define_procedure(GDK_IS_DEVICE_PAD, gxg_GDK_IS_DEVICE_PAD_w, 1, 0, 0, "(GDK_IS_DEVICE_PAD obj): " PROC_TRUE " if obj is a GdkDevicePad*", pl_bt);
  Xg_define_procedure(GTK_IS_PAD_CONTROLLER, gxg_GTK_IS_PAD_CONTROLLER_w, 1, 0, 0, "(GTK_IS_PAD_CONTROLLER obj): " PROC_TRUE " if obj is a GtkPadController*", pl_bt);
  Xg_define_procedure(GTK_IS_SHORTCUT_LABEL, gxg_GTK_IS_SHORTCUT_LABEL_w, 1, 0, 0, "(GTK_IS_SHORTCUT_LABEL obj): " PROC_TRUE " if obj is a GtkShortcutLabel*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  Xg_define_procedure(GTK_IS_CENTER_BOX, gxg_GTK_IS_CENTER_BOX_w, 1, 0, 0, "(GTK_IS_CENTER_BOX obj): " PROC_TRUE " if obj is a GtkCenterBox*", pl_bt);
  Xg_define_procedure(GTK_IS_STYLE_CONTEXT, gxg_GTK_IS_STYLE_CONTEXT_w, 1, 0, 0, "(GTK_IS_STYLE_CONTEXT obj): " PROC_TRUE " if obj is a GtkStyleContext*", pl_bt);
  Xg_define_procedure(GTK_IS_STYLE_PROVIDER, gxg_GTK_IS_STYLE_PROVIDER_w, 1, 0, 0, "(GTK_IS_STYLE_PROVIDER obj): " PROC_TRUE " if obj is a GtkStyleProvider*", pl_bt);
  Xg_define_procedure(GTK_IS_CSS_PROVIDER, gxg_GTK_IS_CSS_PROVIDER_w, 1, 0, 0, "(GTK_IS_CSS_PROVIDER obj): " PROC_TRUE " if obj is a GtkCssProvider*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  Xg_define_procedure(GTK_IS_EMOJI_CHOOSER, gxg_GTK_IS_EMOJI_CHOOSER_w, 1, 0, 0, "(GTK_IS_EMOJI_CHOOSER obj): " PROC_TRUE " if obj is a GtkEmojiChooser*", pl_bt);
  Xg_define_procedure(GTK_IS_EVENT_CONTROLLER_SCROLL, gxg_GTK_IS_EVENT_CONTROLLER_SCROLL_w, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER_SCROLL obj): " PROC_TRUE " if obj is a GtkEventControllerScroll*", pl_bt);
  Xg_define_procedure(GTK_IS_EVENT_CONTROLLER_MOTION, gxg_GTK_IS_EVENT_CONTROLLER_MOTION_w, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER_MOTION obj): " PROC_TRUE " if obj is a GtkEventControllerMotion*", pl_bt);
  Xg_define_procedure(GDK_IS_TEXTURE, gxg_GDK_IS_TEXTURE_w, 1, 0, 0, "(GDK_IS_TEXTURE obj): " PROC_TRUE " if obj is a GdkTexture*", pl_bt);
  Xg_define_procedure(GDK_IS_EVENT, gxg_GDK_IS_EVENT_w, 1, 0, 0, "(GDK_IS_EVENT obj): " PROC_TRUE " if obj is a GdkEvent*", pl_bt);
  Xg_define_procedure(GDK_IS_APP_LAUNCH_CONTEXT, gxg_GDK_IS_APP_LAUNCH_CONTEXT_w, 1, 0, 0, "(GDK_IS_APP_LAUNCH_CONTEXT obj): " PROC_TRUE " if obj is a GdkAppLaunchContext*", pl_bt);
  Xg_define_procedure(GDK_IS_CLIPBOARD, gxg_GDK_IS_CLIPBOARD_w, 1, 0, 0, "(GDK_IS_CLIPBOARD obj): " PROC_TRUE " if obj is a GdkClipboard*", pl_bt);
  Xg_define_procedure(GDK_IS_CONTENT_PROVIDER, gxg_GDK_IS_CONTENT_PROVIDER_w, 1, 0, 0, "(GDK_IS_CONTENT_PROVIDER obj): " PROC_TRUE " if obj is a GdkContentProvider*", pl_bt);
  Xg_define_procedure(GDK_IS_CONTENT_SERIALIZER, gxg_GDK_IS_CONTENT_SERIALIZER_w, 1, 0, 0, "(GDK_IS_CONTENT_SERIALIZER obj): " PROC_TRUE " if obj is a GdkContentSerializer*", pl_bt);
  Xg_define_procedure(GDK_IS_CONTENT_DESERIALIZER, gxg_GDK_IS_CONTENT_DESERIALIZER_w, 1, 0, 0, "(GDK_IS_CONTENT_DESERIALIZER obj): " PROC_TRUE " if obj is a GdkContentDeserializer*", pl_bt);
  Xg_define_procedure(GTK_IS_APPLICATION, gxg_GTK_IS_APPLICATION_w, 1, 0, 0, "(GTK_IS_APPLICATION obj): " PROC_TRUE " if obj is a GtkApplication*", pl_bt);
#endif

}

/* ---------------------------------------- constants ---------------------------------------- */

static void define_integers(void)
{
#define define_integer(Name) Xen_define(Xg_pre #Name Xg_post, C_int_to_Xen_integer(Name))

#if !GLIB_CHECK_VERSION(2,35,0)
  g_type_init();
#endif
  define_integer(G_NORMALIZE_DEFAULT);
  define_integer(G_NORMALIZE_NFD);
  define_integer(G_NORMALIZE_DEFAULT_COMPOSE);
  define_integer(G_NORMALIZE_NFC);
  define_integer(G_NORMALIZE_ALL);
  define_integer(G_NORMALIZE_NFKD);
  define_integer(G_NORMALIZE_ALL_COMPOSE);
  define_integer(G_NORMALIZE_NFKC);
  define_integer(G_SIGNAL_RUN_FIRST);
  define_integer(G_SIGNAL_RUN_LAST);
  define_integer(G_SIGNAL_RUN_CLEANUP);
  define_integer(G_SIGNAL_NO_RECURSE);
  define_integer(G_SIGNAL_DETAILED);
  define_integer(G_SIGNAL_ACTION);
  define_integer(G_SIGNAL_NO_HOOKS);
  define_integer(G_CONNECT_AFTER);
  define_integer(G_CONNECT_SWAPPED);
  define_integer(G_SIGNAL_MATCH_ID);
  define_integer(G_SIGNAL_MATCH_DETAIL);
  define_integer(G_SIGNAL_MATCH_CLOSURE);
  define_integer(G_SIGNAL_MATCH_FUNC);
  define_integer(G_SIGNAL_MATCH_DATA);
  define_integer(G_SIGNAL_MATCH_UNBLOCKED);
  define_integer(GDK_FILTER_CONTINUE);
  define_integer(GDK_FILTER_TRANSLATE);
  define_integer(GDK_FILTER_REMOVE);
  define_integer(GDK_ACTION_DEFAULT);
  define_integer(GDK_ACTION_COPY);
  define_integer(GDK_ACTION_MOVE);
  define_integer(GDK_ACTION_LINK);
  define_integer(GDK_ACTION_PRIVATE);
  define_integer(GDK_ACTION_ASK);
  define_integer(GDK_PRIORITY_EVENTS);
  define_integer(GDK_PRIORITY_REDRAW);
  define_integer(GDK_NOTHING);
  define_integer(GDK_DELETE);
  define_integer(GDK_DESTROY);
  define_integer(GDK_EXPOSE);
  define_integer(GDK_MOTION_NOTIFY);
  define_integer(GDK_BUTTON_PRESS);
  define_integer(GDK_BUTTON_RELEASE);
  define_integer(GDK_KEY_PRESS);
  define_integer(GDK_KEY_RELEASE);
  define_integer(GDK_ENTER_NOTIFY);
  define_integer(GDK_LEAVE_NOTIFY);
  define_integer(GDK_FOCUS_CHANGE);
  define_integer(GDK_CONFIGURE);
  define_integer(GDK_MAP);
  define_integer(GDK_UNMAP);
  define_integer(GDK_PROXIMITY_IN);
  define_integer(GDK_PROXIMITY_OUT);
  define_integer(GDK_DRAG_ENTER);
  define_integer(GDK_DRAG_LEAVE);
  define_integer(GDK_DRAG_MOTION);
  define_integer(GDK_DROP_START);
  define_integer(GDK_SCROLL);
  define_integer(GDK_GRAB_BROKEN);
  define_integer(GDK_EXPOSURE_MASK);
  define_integer(GDK_POINTER_MOTION_MASK);
  define_integer(GDK_BUTTON_MOTION_MASK);
  define_integer(GDK_BUTTON1_MOTION_MASK);
  define_integer(GDK_BUTTON2_MOTION_MASK);
  define_integer(GDK_BUTTON3_MOTION_MASK);
  define_integer(GDK_BUTTON_PRESS_MASK);
  define_integer(GDK_BUTTON_RELEASE_MASK);
  define_integer(GDK_KEY_PRESS_MASK);
  define_integer(GDK_KEY_RELEASE_MASK);
  define_integer(GDK_ENTER_NOTIFY_MASK);
  define_integer(GDK_LEAVE_NOTIFY_MASK);
  define_integer(GDK_FOCUS_CHANGE_MASK);
  define_integer(GDK_STRUCTURE_MASK);
  define_integer(GDK_PROPERTY_CHANGE_MASK);
  define_integer(GDK_PROXIMITY_IN_MASK);
  define_integer(GDK_PROXIMITY_OUT_MASK);
  define_integer(GDK_SUBSTRUCTURE_MASK);
  define_integer(GDK_SCROLL_MASK);
  define_integer(GDK_SCROLL_UP);
  define_integer(GDK_SCROLL_DOWN);
  define_integer(GDK_SCROLL_LEFT);
  define_integer(GDK_SCROLL_RIGHT);
  define_integer(GDK_NOTIFY_ANCESTOR);
  define_integer(GDK_NOTIFY_VIRTUAL);
  define_integer(GDK_NOTIFY_INFERIOR);
  define_integer(GDK_NOTIFY_NONLINEAR);
  define_integer(GDK_NOTIFY_NONLINEAR_VIRTUAL);
  define_integer(GDK_NOTIFY_UNKNOWN);
  define_integer(GDK_CROSSING_NORMAL);
  define_integer(GDK_CROSSING_GRAB);
  define_integer(GDK_CROSSING_UNGRAB);
  define_integer(GDK_WINDOW_STATE_WITHDRAWN);
  define_integer(GDK_WINDOW_STATE_ICONIFIED);
  define_integer(GDK_WINDOW_STATE_MAXIMIZED);
  define_integer(GDK_WINDOW_STATE_STICKY);
  define_integer(GDK_CURRENT_TIME);
  define_integer(GDK_PARENT_RELATIVE);
  define_integer(GDK_LSB_FIRST);
  define_integer(GDK_MSB_FIRST);
  define_integer(GDK_SHIFT_MASK);
  define_integer(GDK_LOCK_MASK);
  define_integer(GDK_CONTROL_MASK);
  define_integer(GDK_MOD1_MASK);
  define_integer(GDK_MOD2_MASK);
  define_integer(GDK_MOD3_MASK);
  define_integer(GDK_MOD4_MASK);
  define_integer(GDK_MOD5_MASK);
  define_integer(GDK_BUTTON1_MASK);
  define_integer(GDK_BUTTON2_MASK);
  define_integer(GDK_BUTTON3_MASK);
  define_integer(GDK_BUTTON4_MASK);
  define_integer(GDK_BUTTON5_MASK);
  define_integer(GDK_RELEASE_MASK);
  define_integer(GDK_MODIFIER_MASK);
  define_integer(GDK_OK);
  define_integer(GDK_ERROR);
  define_integer(GDK_ERROR_PARAM);
  define_integer(GDK_ERROR_FILE);
  define_integer(GDK_ERROR_MEM);
  define_integer(GDK_GRAB_SUCCESS);
  define_integer(GDK_GRAB_ALREADY_GRABBED);
  define_integer(GDK_GRAB_INVALID_TIME);
  define_integer(GDK_GRAB_NOT_VIEWABLE);
  define_integer(GDK_GRAB_FROZEN);
  define_integer(GDK_WINDOW_ROOT);
  define_integer(GDK_WINDOW_TOPLEVEL);
  define_integer(GDK_WINDOW_CHILD);
  define_integer(GDK_WINDOW_TEMP);
  define_integer(GDK_WINDOW_FOREIGN);
  define_integer(GDK_HINT_POS);
  define_integer(GDK_HINT_MIN_SIZE);
  define_integer(GDK_HINT_MAX_SIZE);
  define_integer(GDK_HINT_BASE_SIZE);
  define_integer(GDK_HINT_ASPECT);
  define_integer(GDK_HINT_RESIZE_INC);
  define_integer(GDK_HINT_WIN_GRAVITY);
  define_integer(GDK_HINT_USER_POS);
  define_integer(GDK_HINT_USER_SIZE);
  define_integer(GDK_WINDOW_TYPE_HINT_NORMAL);
  define_integer(GDK_WINDOW_TYPE_HINT_DIALOG);
  define_integer(GDK_WINDOW_TYPE_HINT_MENU);
  define_integer(GDK_WINDOW_TYPE_HINT_TOOLBAR);
  define_integer(GDK_DECOR_ALL);
  define_integer(GDK_DECOR_BORDER);
  define_integer(GDK_DECOR_RESIZEH);
  define_integer(GDK_DECOR_TITLE);
  define_integer(GDK_DECOR_MENU);
  define_integer(GDK_DECOR_MINIMIZE);
  define_integer(GDK_DECOR_MAXIMIZE);
  define_integer(GDK_FUNC_ALL);
  define_integer(GDK_FUNC_RESIZE);
  define_integer(GDK_FUNC_MOVE);
  define_integer(GDK_FUNC_MINIMIZE);
  define_integer(GDK_FUNC_MAXIMIZE);
  define_integer(GDK_FUNC_CLOSE);
  define_integer(GDK_GRAVITY_NORTH_WEST);
  define_integer(GDK_GRAVITY_NORTH);
  define_integer(GDK_GRAVITY_NORTH_EAST);
  define_integer(GDK_GRAVITY_WEST);
  define_integer(GDK_GRAVITY_CENTER);
  define_integer(GDK_GRAVITY_EAST);
  define_integer(GDK_GRAVITY_SOUTH_WEST);
  define_integer(GDK_GRAVITY_SOUTH);
  define_integer(GDK_GRAVITY_SOUTH_EAST);
  define_integer(GDK_GRAVITY_STATIC);
  define_integer(GDK_WINDOW_EDGE_NORTH_WEST);
  define_integer(GDK_WINDOW_EDGE_NORTH);
  define_integer(GDK_WINDOW_EDGE_NORTH_EAST);
  define_integer(GDK_WINDOW_EDGE_WEST);
  define_integer(GDK_WINDOW_EDGE_EAST);
  define_integer(GDK_WINDOW_EDGE_SOUTH_WEST);
  define_integer(GDK_WINDOW_EDGE_SOUTH);
  define_integer(GDK_WINDOW_EDGE_SOUTH_EAST);
  define_integer(GDK_PIXBUF_ALPHA_BILEVEL);
  define_integer(GDK_PIXBUF_ALPHA_FULL);
  define_integer(GDK_COLORSPACE_RGB);
  define_integer(GDK_PIXBUF_ERROR_CORRUPT_IMAGE);
  define_integer(GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY);
  define_integer(GDK_PIXBUF_ERROR_BAD_OPTION);
  define_integer(GDK_PIXBUF_ERROR_UNKNOWN_TYPE);
  define_integer(GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION);
  define_integer(GDK_PIXBUF_ERROR_FAILED);
  define_integer(GDK_INTERP_NEAREST);
  define_integer(GDK_INTERP_TILES);
  define_integer(GDK_INTERP_BILINEAR);
  define_integer(GDK_INTERP_HYPER);
  define_integer(GTK_ACCEL_VISIBLE);
  define_integer(GTK_ACCEL_LOCKED);
  define_integer(GTK_ACCEL_MASK);
  define_integer(GTK_CALENDAR_SHOW_HEADING);
  define_integer(GTK_CALENDAR_SHOW_DAY_NAMES);
  define_integer(GTK_CALENDAR_NO_MONTH_CHANGE);
  define_integer(GTK_CALENDAR_SHOW_WEEK_NUMBERS);
  define_integer(GTK_CELL_RENDERER_SELECTED);
  define_integer(GTK_CELL_RENDERER_PRELIT);
  define_integer(GTK_CELL_RENDERER_INSENSITIVE);
  define_integer(GTK_CELL_RENDERER_SORTED);
  define_integer(GTK_CELL_RENDERER_FOCUSED);
  define_integer(GTK_DIALOG_MODAL);
  define_integer(GTK_DIALOG_DESTROY_WITH_PARENT);
  define_integer(GTK_RESPONSE_NONE);
  define_integer(GTK_RESPONSE_REJECT);
  define_integer(GTK_RESPONSE_ACCEPT);
  define_integer(GTK_RESPONSE_DELETE_EVENT);
  define_integer(GTK_RESPONSE_OK);
  define_integer(GTK_RESPONSE_CANCEL);
  define_integer(GTK_RESPONSE_CLOSE);
  define_integer(GTK_RESPONSE_YES);
  define_integer(GTK_RESPONSE_NO);
  define_integer(GTK_RESPONSE_APPLY);
  define_integer(GTK_RESPONSE_HELP);
  define_integer(GTK_DEST_DEFAULT_MOTION);
  define_integer(GTK_DEST_DEFAULT_HIGHLIGHT);
  define_integer(GTK_DEST_DEFAULT_DROP);
  define_integer(GTK_DEST_DEFAULT_ALL);
  define_integer(GTK_BUTTONBOX_SPREAD);
  define_integer(GTK_BUTTONBOX_EDGE);
  define_integer(GTK_BUTTONBOX_START);
  define_integer(GTK_BUTTONBOX_END);
  define_integer(GTK_BUTTONBOX_CENTER);
  define_integer(GTK_DELETE_CHARS);
  define_integer(GTK_DELETE_WORD_ENDS);
  define_integer(GTK_DELETE_WORDS);
  define_integer(GTK_DELETE_DISPLAY_LINES);
  define_integer(GTK_DELETE_DISPLAY_LINE_ENDS);
  define_integer(GTK_DELETE_PARAGRAPH_ENDS);
  define_integer(GTK_DELETE_PARAGRAPHS);
  define_integer(GTK_DELETE_WHITESPACE);
  define_integer(GTK_DIR_TAB_FORWARD);
  define_integer(GTK_DIR_TAB_BACKWARD);
  define_integer(GTK_DIR_UP);
  define_integer(GTK_DIR_DOWN);
  define_integer(GTK_DIR_LEFT);
  define_integer(GTK_DIR_RIGHT);
  define_integer(GTK_TEXT_DIR_NONE);
  define_integer(GTK_TEXT_DIR_LTR);
  define_integer(GTK_TEXT_DIR_RTL);
  define_integer(GTK_JUSTIFY_LEFT);
  define_integer(GTK_JUSTIFY_RIGHT);
  define_integer(GTK_JUSTIFY_CENTER);
  define_integer(GTK_JUSTIFY_FILL);
  define_integer(GTK_MENU_DIR_PARENT);
  define_integer(GTK_MENU_DIR_CHILD);
  define_integer(GTK_MENU_DIR_NEXT);
  define_integer(GTK_MENU_DIR_PREV);
  define_integer(GTK_MOVEMENT_LOGICAL_POSITIONS);
  define_integer(GTK_MOVEMENT_VISUAL_POSITIONS);
  define_integer(GTK_MOVEMENT_WORDS);
  define_integer(GTK_MOVEMENT_DISPLAY_LINES);
  define_integer(GTK_MOVEMENT_DISPLAY_LINE_ENDS);
  define_integer(GTK_MOVEMENT_PARAGRAPHS);
  define_integer(GTK_MOVEMENT_PARAGRAPH_ENDS);
  define_integer(GTK_MOVEMENT_PAGES);
  define_integer(GTK_MOVEMENT_BUFFER_ENDS);
  define_integer(GTK_ORIENTATION_HORIZONTAL);
  define_integer(GTK_ORIENTATION_VERTICAL);
  define_integer(GTK_CORNER_TOP_LEFT);
  define_integer(GTK_CORNER_BOTTOM_LEFT);
  define_integer(GTK_CORNER_TOP_RIGHT);
  define_integer(GTK_CORNER_BOTTOM_RIGHT);
  define_integer(GTK_PACK_START);
  define_integer(GTK_PACK_END);
  define_integer(GTK_POLICY_ALWAYS);
  define_integer(GTK_POLICY_AUTOMATIC);
  define_integer(GTK_POLICY_NEVER);
  define_integer(GTK_POS_LEFT);
  define_integer(GTK_POS_RIGHT);
  define_integer(GTK_POS_TOP);
  define_integer(GTK_POS_BOTTOM);
  define_integer(GTK_RELIEF_NORMAL);
  define_integer(GTK_RELIEF_NONE);
  define_integer(GTK_SCROLL_NONE);
  define_integer(GTK_SCROLL_JUMP);
  define_integer(GTK_SCROLL_STEP_BACKWARD);
  define_integer(GTK_SCROLL_STEP_FORWARD);
  define_integer(GTK_SCROLL_PAGE_BACKWARD);
  define_integer(GTK_SCROLL_PAGE_FORWARD);
  define_integer(GTK_SCROLL_STEP_UP);
  define_integer(GTK_SCROLL_STEP_DOWN);
  define_integer(GTK_SCROLL_PAGE_UP);
  define_integer(GTK_SCROLL_PAGE_DOWN);
  define_integer(GTK_SCROLL_STEP_LEFT);
  define_integer(GTK_SCROLL_STEP_RIGHT);
  define_integer(GTK_SCROLL_PAGE_LEFT);
  define_integer(GTK_SCROLL_PAGE_RIGHT);
  define_integer(GTK_SCROLL_START);
  define_integer(GTK_SCROLL_END);
  define_integer(GTK_SELECTION_NONE);
  define_integer(GTK_SELECTION_SINGLE);
  define_integer(GTK_SELECTION_BROWSE);
  define_integer(GTK_SELECTION_MULTIPLE);
  define_integer(GTK_SHADOW_NONE);
  define_integer(GTK_SHADOW_IN);
  define_integer(GTK_SHADOW_OUT);
  define_integer(GTK_SHADOW_ETCHED_IN);
  define_integer(GTK_SHADOW_ETCHED_OUT);
  define_integer(GTK_TOOLBAR_ICONS);
  define_integer(GTK_TOOLBAR_TEXT);
  define_integer(GTK_TOOLBAR_BOTH);
  define_integer(GTK_TOOLBAR_BOTH_HORIZ);
  define_integer(GTK_WIN_POS_NONE);
  define_integer(GTK_WIN_POS_CENTER);
  define_integer(GTK_WIN_POS_MOUSE);
  define_integer(GTK_WIN_POS_CENTER_ALWAYS);
  define_integer(GTK_WIN_POS_CENTER_ON_PARENT);
  define_integer(GTK_WINDOW_TOPLEVEL);
  define_integer(GTK_WINDOW_POPUP);
  define_integer(GTK_WRAP_NONE);
  define_integer(GTK_WRAP_CHAR);
  define_integer(GTK_WRAP_WORD);
  define_integer(GTK_SORT_ASCENDING);
  define_integer(GTK_SORT_DESCENDING);
  define_integer(GTK_IMAGE_EMPTY);
  define_integer(GTK_MAX_COMPOSE_LEN);
  define_integer(GTK_PRIORITY_RESIZE);
  define_integer(GTK_MESSAGE_INFO);
  define_integer(GTK_MESSAGE_WARNING);
  define_integer(GTK_MESSAGE_QUESTION);
  define_integer(GTK_MESSAGE_ERROR);
  define_integer(GTK_BUTTONS_NONE);
  define_integer(GTK_BUTTONS_OK);
  define_integer(GTK_BUTTONS_CLOSE);
  define_integer(GTK_BUTTONS_CANCEL);
  define_integer(GTK_BUTTONS_YES_NO);
  define_integer(GTK_BUTTONS_OK_CANCEL);
  define_integer(GTK_NOTEBOOK_TAB_FIRST);
  define_integer(GTK_NOTEBOOK_TAB_LAST);
  define_integer(GTK_SIZE_GROUP_NONE);
  define_integer(GTK_SIZE_GROUP_HORIZONTAL);
  define_integer(GTK_SIZE_GROUP_VERTICAL);
  define_integer(GTK_SIZE_GROUP_BOTH);
  define_integer(GTK_INPUT_ERROR);
  define_integer(GTK_UPDATE_ALWAYS);
  define_integer(GTK_UPDATE_IF_VALID);
  define_integer(GTK_SPIN_STEP_FORWARD);
  define_integer(GTK_SPIN_STEP_BACKWARD);
  define_integer(GTK_SPIN_PAGE_FORWARD);
  define_integer(GTK_SPIN_PAGE_BACKWARD);
  define_integer(GTK_SPIN_HOME);
  define_integer(GTK_SPIN_END);
  define_integer(GTK_SPIN_USER_DEFINED);
  define_integer(GTK_TEXT_SEARCH_VISIBLE_ONLY);
  define_integer(GTK_TEXT_SEARCH_TEXT_ONLY);
  define_integer(GTK_TEXT_WINDOW_PRIVATE);
  define_integer(GTK_TEXT_WINDOW_WIDGET);
  define_integer(GTK_TEXT_WINDOW_TEXT);
  define_integer(GTK_TEXT_WINDOW_LEFT);
  define_integer(GTK_TEXT_WINDOW_RIGHT);
  define_integer(GTK_TEXT_WINDOW_TOP);
  define_integer(GTK_TEXT_WINDOW_BOTTOM);
  define_integer(GTK_TEXT_VIEW_PRIORITY_VALIDATE);
  define_integer(GTK_TREE_MODEL_ITERS_PERSIST);
  define_integer(GTK_TREE_MODEL_LIST_ONLY);
  define_integer(GTK_TREE_VIEW_COLUMN_GROW_ONLY);
  define_integer(GTK_TREE_VIEW_COLUMN_AUTOSIZE);
  define_integer(GTK_TREE_VIEW_COLUMN_FIXED);
  define_integer(GTK_TREE_VIEW_DROP_BEFORE);
  define_integer(GTK_TREE_VIEW_DROP_AFTER);
  define_integer(GTK_TREE_VIEW_DROP_INTO_OR_BEFORE);
  define_integer(GTK_TREE_VIEW_DROP_INTO_OR_AFTER);
  define_integer(GTK_MAJOR_VERSION);
  define_integer(GTK_MINOR_VERSION);
  define_integer(GTK_MICRO_VERSION);
  define_integer(PANGO_ATTR_INVALID);
  define_integer(PANGO_ATTR_LANGUAGE);
  define_integer(PANGO_ATTR_FAMILY);
  define_integer(PANGO_ATTR_STYLE);
  define_integer(PANGO_ATTR_WEIGHT);
  define_integer(PANGO_ATTR_VARIANT);
  define_integer(PANGO_ATTR_STRETCH);
  define_integer(PANGO_ATTR_SIZE);
  define_integer(PANGO_ATTR_FONT_DESC);
  define_integer(PANGO_ATTR_FOREGROUND);
  define_integer(PANGO_ATTR_BACKGROUND);
  define_integer(PANGO_ATTR_UNDERLINE);
  define_integer(PANGO_ATTR_STRIKETHROUGH);
  define_integer(PANGO_ATTR_RISE);
  define_integer(PANGO_ATTR_SHAPE);
  define_integer(PANGO_ATTR_SCALE);
  define_integer(PANGO_UNDERLINE_NONE);
  define_integer(PANGO_UNDERLINE_SINGLE);
  define_integer(PANGO_UNDERLINE_DOUBLE);
  define_integer(PANGO_UNDERLINE_LOW);
  define_integer(PANGO_COVERAGE_NONE);
  define_integer(PANGO_COVERAGE_FALLBACK);
  define_integer(PANGO_COVERAGE_APPROXIMATE);
  define_integer(PANGO_COVERAGE_EXACT);
  define_integer(PANGO_STYLE_NORMAL);
  define_integer(PANGO_STYLE_OBLIQUE);
  define_integer(PANGO_STYLE_ITALIC);
  define_integer(PANGO_VARIANT_NORMAL);
  define_integer(PANGO_VARIANT_SMALL_CAPS);
  define_integer(PANGO_WEIGHT_ULTRALIGHT);
  define_integer(PANGO_WEIGHT_LIGHT);
  define_integer(PANGO_WEIGHT_NORMAL);
  define_integer(PANGO_WEIGHT_BOLD);
  define_integer(PANGO_WEIGHT_ULTRABOLD);
  define_integer(PANGO_WEIGHT_HEAVY);
  define_integer(PANGO_STRETCH_ULTRA_CONDENSED);
  define_integer(PANGO_STRETCH_EXTRA_CONDENSED);
  define_integer(PANGO_STRETCH_CONDENSED);
  define_integer(PANGO_STRETCH_SEMI_CONDENSED);
  define_integer(PANGO_STRETCH_NORMAL);
  define_integer(PANGO_STRETCH_SEMI_EXPANDED);
  define_integer(PANGO_STRETCH_EXPANDED);
  define_integer(PANGO_STRETCH_EXTRA_EXPANDED);
  define_integer(PANGO_STRETCH_ULTRA_EXPANDED);
  define_integer(PANGO_FONT_MASK_FAMILY);
  define_integer(PANGO_FONT_MASK_STYLE);
  define_integer(PANGO_FONT_MASK_VARIANT);
  define_integer(PANGO_FONT_MASK_WEIGHT);
  define_integer(PANGO_FONT_MASK_STRETCH);
  define_integer(PANGO_FONT_MASK_SIZE);
  define_integer(PANGO_ALIGN_LEFT);
  define_integer(PANGO_ALIGN_CENTER);
  define_integer(PANGO_ALIGN_RIGHT);
  define_integer(PANGO_WRAP_WORD);
  define_integer(PANGO_WRAP_CHAR);
  define_integer(PANGO_DIRECTION_LTR);
  define_integer(PANGO_DIRECTION_RTL);
  define_integer(PANGO_DIRECTION_TTB_LTR);
  define_integer(PANGO_DIRECTION_TTB_RTL);
  define_integer(GDK_WINDOW_STATE_FULLSCREEN);
  define_integer(GDK_WINDOW_STATE_ABOVE);
  define_integer(GDK_WINDOW_STATE_BELOW);
  define_integer(GTK_MOVEMENT_HORIZONTAL_PAGES);
  define_integer(GTK_SCROLL_STEPS);
  define_integer(GTK_SCROLL_PAGES);
  define_integer(GTK_SCROLL_ENDS);
  define_integer(GTK_SCROLL_HORIZONTAL_STEPS);
  define_integer(GTK_SCROLL_HORIZONTAL_PAGES);
  define_integer(GTK_SCROLL_HORIZONTAL_ENDS);
  define_integer(GTK_WRAP_WORD_CHAR);
  define_integer(GTK_FILE_FILTER_FILENAME);
  define_integer(GTK_FILE_FILTER_URI);
  define_integer(GTK_FILE_FILTER_DISPLAY_NAME);
  define_integer(GTK_FILE_FILTER_MIME_TYPE);
  define_integer(GTK_ICON_LOOKUP_NO_SVG);
  define_integer(GTK_ICON_LOOKUP_FORCE_SVG);
  define_integer(GTK_ICON_LOOKUP_USE_BUILTIN);
  define_integer(GTK_ICON_LOOKUP_GENERIC_FALLBACK);
  define_integer(GTK_FILE_CHOOSER_ACTION_OPEN);
  define_integer(GTK_FILE_CHOOSER_ACTION_SAVE);
  define_integer(GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
  define_integer(GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER);
  define_integer(G_PRIORITY_HIGH);
  define_integer(G_PRIORITY_DEFAULT);
  define_integer(G_PRIORITY_HIGH_IDLE);
  define_integer(G_PRIORITY_DEFAULT_IDLE);
  define_integer(G_PRIORITY_LOW);
  define_integer(PANGO_ATTR_FALLBACK);
  define_integer(PANGO_ATTR_LETTER_SPACING);
  define_integer(PANGO_UNDERLINE_ERROR);
  define_integer(PANGO_WRAP_WORD_CHAR);
  define_integer(PANGO_ELLIPSIZE_NONE);
  define_integer(PANGO_ELLIPSIZE_START);
  define_integer(PANGO_ELLIPSIZE_MIDDLE);
  define_integer(PANGO_ELLIPSIZE_END);
  define_integer(PANGO_SCRIPT_INVALID_CODE);
  define_integer(PANGO_SCRIPT_COMMON);
  define_integer(PANGO_SCRIPT_INHERITED);
  define_integer(PANGO_SCRIPT_ARABIC);
  define_integer(PANGO_SCRIPT_ARMENIAN);
  define_integer(PANGO_SCRIPT_BENGALI);
  define_integer(PANGO_SCRIPT_BOPOMOFO);
  define_integer(PANGO_SCRIPT_CHEROKEE);
  define_integer(PANGO_SCRIPT_COPTIC);
  define_integer(PANGO_SCRIPT_CYRILLIC);
  define_integer(PANGO_SCRIPT_DESERET);
  define_integer(PANGO_SCRIPT_DEVANAGARI);
  define_integer(PANGO_SCRIPT_ETHIOPIC);
  define_integer(PANGO_SCRIPT_GEORGIAN);
  define_integer(PANGO_SCRIPT_GOTHIC);
  define_integer(PANGO_SCRIPT_GREEK);
  define_integer(PANGO_SCRIPT_GUJARATI);
  define_integer(PANGO_SCRIPT_GURMUKHI);
  define_integer(PANGO_SCRIPT_HAN);
  define_integer(PANGO_SCRIPT_HANGUL);
  define_integer(PANGO_SCRIPT_HEBREW);
  define_integer(PANGO_SCRIPT_HIRAGANA);
  define_integer(PANGO_SCRIPT_KANNADA);
  define_integer(PANGO_SCRIPT_KATAKANA);
  define_integer(PANGO_SCRIPT_KHMER);
  define_integer(PANGO_SCRIPT_LAO);
  define_integer(PANGO_SCRIPT_LATIN);
  define_integer(PANGO_SCRIPT_MALAYALAM);
  define_integer(PANGO_SCRIPT_MONGOLIAN);
  define_integer(PANGO_SCRIPT_MYANMAR);
  define_integer(PANGO_SCRIPT_OGHAM);
  define_integer(PANGO_SCRIPT_OLD_ITALIC);
  define_integer(PANGO_SCRIPT_ORIYA);
  define_integer(PANGO_SCRIPT_RUNIC);
  define_integer(PANGO_SCRIPT_SINHALA);
  define_integer(PANGO_SCRIPT_SYRIAC);
  define_integer(PANGO_SCRIPT_TAMIL);
  define_integer(PANGO_SCRIPT_TELUGU);
  define_integer(PANGO_SCRIPT_THAANA);
  define_integer(PANGO_SCRIPT_THAI);
  define_integer(PANGO_SCRIPT_TIBETAN);
  define_integer(PANGO_SCRIPT_CANADIAN_ABORIGINAL);
  define_integer(PANGO_SCRIPT_YI);
  define_integer(PANGO_SCRIPT_TAGALOG);
  define_integer(PANGO_SCRIPT_HANUNOO);
  define_integer(PANGO_SCRIPT_BUHID);
  define_integer(PANGO_SCRIPT_TAGBANWA);
  define_integer(PANGO_SCRIPT_BRAILLE);
  define_integer(PANGO_SCRIPT_CYPRIOT);
  define_integer(PANGO_SCRIPT_LIMBU);
  define_integer(PANGO_SCRIPT_OSMANYA);
  define_integer(PANGO_SCRIPT_SHAVIAN);
  define_integer(PANGO_SCRIPT_LINEAR_B);
  define_integer(PANGO_SCRIPT_TAI_LE);
  define_integer(PANGO_SCRIPT_UGARITIC);
  define_integer(PANGO_TAB_LEFT);
  define_integer(PANGO_DIRECTION_WEAK_LTR);
  define_integer(PANGO_DIRECTION_WEAK_RTL);
  define_integer(PANGO_DIRECTION_NEUTRAL);
  define_integer(GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID);
  define_integer(GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID);
  define_integer(GTK_IMAGE_ICON_NAME);
  define_integer(PANGO_ATTR_UNDERLINE_COLOR);
  define_integer(PANGO_ATTR_STRIKETHROUGH_COLOR);
  define_integer(PANGO_RENDER_PART_FOREGROUND);
  define_integer(PANGO_RENDER_PART_BACKGROUND);
  define_integer(PANGO_RENDER_PART_UNDERLINE);
  define_integer(PANGO_RENDER_PART_STRIKETHROUGH);
  define_integer(G_LOG_FLAG_RECURSION);
  define_integer(G_LOG_FLAG_FATAL);
  define_integer(G_LOG_LEVEL_ERROR);
  define_integer(G_LOG_LEVEL_CRITICAL);
  define_integer(G_LOG_LEVEL_WARNING);
  define_integer(G_LOG_LEVEL_MESSAGE);
  define_integer(G_LOG_LEVEL_INFO);
  define_integer(G_LOG_LEVEL_DEBUG);
  define_integer(G_LOG_LEVEL_MASK);
  define_integer(G_LOG_FATAL_MASK);
  define_integer(PANGO_WEIGHT_SEMIBOLD);
  define_integer(GTK_PACK_DIRECTION_LTR);
  define_integer(GTK_PACK_DIRECTION_RTL);
  define_integer(GTK_PACK_DIRECTION_TTB);
  define_integer(GTK_PACK_DIRECTION_BTT);
  define_integer(GTK_ICON_VIEW_NO_DROP);
  define_integer(GTK_ICON_VIEW_DROP_INTO);
  define_integer(GTK_ICON_VIEW_DROP_LEFT);
  define_integer(GTK_ICON_VIEW_DROP_RIGHT);
  define_integer(GTK_ICON_VIEW_DROP_ABOVE);
  define_integer(GTK_ICON_VIEW_DROP_BELOW);
  define_integer(GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM);
  define_integer(GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME);
  define_integer(GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN);
  define_integer(PANGO_SCRIPT_NEW_TAI_LUE);
  define_integer(PANGO_SCRIPT_BUGINESE);
  define_integer(PANGO_SCRIPT_GLAGOLITIC);
  define_integer(PANGO_SCRIPT_TIFINAGH);
  define_integer(PANGO_SCRIPT_SYLOTI_NAGRI);
  define_integer(PANGO_SCRIPT_OLD_PERSIAN);
  define_integer(PANGO_SCRIPT_KHAROSHTHI);
  define_integer(GDK_SUPER_MASK);
  define_integer(GDK_HYPER_MASK);
  define_integer(GDK_META_MASK);
  define_integer(GTK_SENSITIVITY_AUTO);
  define_integer(GTK_SENSITIVITY_ON);
  define_integer(GTK_SENSITIVITY_OFF);
  define_integer(GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS);
  define_integer(GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT);
  define_integer(GTK_TEXT_BUFFER_TARGET_INFO_TEXT);
  define_integer(GTK_ASSISTANT_PAGE_CONTENT);
  define_integer(GTK_ASSISTANT_PAGE_INTRO);
  define_integer(GTK_ASSISTANT_PAGE_CONFIRM);
  define_integer(GTK_ASSISTANT_PAGE_SUMMARY);
  define_integer(GTK_ASSISTANT_PAGE_PROGRESS);
  define_integer(GTK_CELL_RENDERER_ACCEL_MODE_GTK);
  define_integer(GTK_CELL_RENDERER_ACCEL_MODE_OTHER);
  define_integer(GTK_RECENT_SORT_NONE);
  define_integer(GTK_RECENT_SORT_MRU);
  define_integer(GTK_RECENT_SORT_LRU);
  define_integer(GTK_RECENT_SORT_CUSTOM);
  define_integer(GTK_RECENT_CHOOSER_ERROR_NOT_FOUND);
  define_integer(GTK_RECENT_CHOOSER_ERROR_INVALID_URI);
  define_integer(GTK_RECENT_MANAGER_ERROR_NOT_FOUND);
  define_integer(GTK_RECENT_MANAGER_ERROR_INVALID_URI);
  define_integer(GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING);
  define_integer(GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED);
  define_integer(GTK_RECENT_MANAGER_ERROR_READ);
  define_integer(GTK_RECENT_MANAGER_ERROR_WRITE);
  define_integer(GTK_RECENT_MANAGER_ERROR_UNKNOWN);
  define_integer(GTK_MESSAGE_OTHER);
  define_integer(GTK_TREE_VIEW_GRID_LINES_NONE);
  define_integer(GTK_TREE_VIEW_GRID_LINES_HORIZONTAL);
  define_integer(GTK_TREE_VIEW_GRID_LINES_VERTICAL);
  define_integer(GTK_TREE_VIEW_GRID_LINES_BOTH);
  define_integer(GTK_PRINT_STATUS_INITIAL);
  define_integer(GTK_PRINT_STATUS_PREPARING);
  define_integer(GTK_PRINT_STATUS_GENERATING_DATA);
  define_integer(GTK_PRINT_STATUS_SENDING_DATA);
  define_integer(GTK_PRINT_STATUS_PENDING);
  define_integer(GTK_PRINT_STATUS_PENDING_ISSUE);
  define_integer(GTK_PRINT_STATUS_PRINTING);
  define_integer(GTK_PRINT_STATUS_FINISHED);
  define_integer(GTK_PRINT_STATUS_FINISHED_ABORTED);
  define_integer(GTK_PRINT_OPERATION_RESULT_ERROR);
  define_integer(GTK_PRINT_OPERATION_RESULT_APPLY);
  define_integer(GTK_PRINT_OPERATION_RESULT_CANCEL);
  define_integer(GTK_PRINT_OPERATION_RESULT_IN_PROGRESS);
  define_integer(GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG);
  define_integer(GTK_PRINT_OPERATION_ACTION_PRINT);
  define_integer(GTK_PRINT_OPERATION_ACTION_PREVIEW);
  define_integer(GTK_PRINT_OPERATION_ACTION_EXPORT);
  define_integer(GTK_PRINT_ERROR_GENERAL);
  define_integer(GTK_PRINT_ERROR_INTERNAL_ERROR);
  define_integer(GTK_PRINT_ERROR_NOMEM);
  define_integer(GTK_PRINT_ERROR_INVALID_FILE);
  define_integer(GTK_DRAG_RESULT_SUCCESS);
  define_integer(GTK_DRAG_RESULT_NO_TARGET);
  define_integer(GTK_DRAG_RESULT_USER_CANCELLED);
  define_integer(GTK_DRAG_RESULT_TIMEOUT_EXPIRED);
  define_integer(GTK_DRAG_RESULT_GRAB_BROKEN);
  define_integer(GTK_DRAG_RESULT_ERROR);
#if GTK_CHECK_VERSION(2, 14, 0)
  define_integer(GTK_CALENDAR_SHOW_DETAILS);
  define_integer(GDK_CROSSING_GTK_GRAB);
  define_integer(GDK_CROSSING_GTK_UNGRAB);
  define_integer(GDK_CROSSING_STATE_CHANGED);
#endif

#if GTK_CHECK_VERSION(2, 16, 0)
  define_integer(GTK_ENTRY_ICON_PRIMARY);
  define_integer(GTK_ENTRY_ICON_SECONDARY);
#endif

#if GTK_CHECK_VERSION(2, 18, 0)
  define_integer(PANGO_WEIGHT_THIN);
  define_integer(PANGO_WEIGHT_BOOK);
  define_integer(PANGO_WEIGHT_MEDIUM);
  define_integer(GTK_ENTRY_BUFFER_MAX_SIZE);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  define_integer(GDK_KEY_VoidSymbol);
  define_integer(GDK_KEY_BackSpace);
  define_integer(GDK_KEY_Tab);
  define_integer(GDK_KEY_Linefeed);
  define_integer(GDK_KEY_Clear);
  define_integer(GDK_KEY_Return);
  define_integer(GDK_KEY_Pause);
  define_integer(GDK_KEY_Scroll_Lock);
  define_integer(GDK_KEY_Sys_Req);
  define_integer(GDK_KEY_Escape);
  define_integer(GDK_KEY_Delete);
  define_integer(GDK_KEY_Home);
  define_integer(GDK_KEY_Left);
  define_integer(GDK_KEY_Up);
  define_integer(GDK_KEY_Right);
  define_integer(GDK_KEY_Down);
  define_integer(GDK_KEY_Prior);
  define_integer(GDK_KEY_Page_Up);
  define_integer(GDK_KEY_Next);
  define_integer(GDK_KEY_Page_Down);
  define_integer(GDK_KEY_End);
  define_integer(GDK_KEY_Begin);
  define_integer(GDK_KEY_Select);
  define_integer(GDK_KEY_Print);
  define_integer(GDK_KEY_Execute);
  define_integer(GDK_KEY_Insert);
  define_integer(GDK_KEY_Undo);
  define_integer(GDK_KEY_Redo);
  define_integer(GDK_KEY_Menu);
  define_integer(GDK_KEY_Find);
  define_integer(GDK_KEY_Cancel);
  define_integer(GDK_KEY_Help);
  define_integer(GDK_KEY_Break);
  define_integer(GDK_KEY_Mode_switch);
  define_integer(GDK_KEY_script_switch);
  define_integer(GDK_KEY_Num_Lock);
  define_integer(GDK_KEY_KP_Space);
  define_integer(GDK_KEY_KP_Tab);
  define_integer(GDK_KEY_KP_Enter);
  define_integer(GDK_KEY_KP_F1);
  define_integer(GDK_KEY_KP_F2);
  define_integer(GDK_KEY_KP_F3);
  define_integer(GDK_KEY_KP_F4);
  define_integer(GDK_KEY_KP_Home);
  define_integer(GDK_KEY_KP_Left);
  define_integer(GDK_KEY_KP_Up);
  define_integer(GDK_KEY_KP_Right);
  define_integer(GDK_KEY_KP_Down);
  define_integer(GDK_KEY_KP_Prior);
  define_integer(GDK_KEY_KP_Page_Up);
  define_integer(GDK_KEY_KP_Next);
  define_integer(GDK_KEY_KP_Page_Down);
  define_integer(GDK_KEY_KP_End);
  define_integer(GDK_KEY_KP_Begin);
  define_integer(GDK_KEY_KP_Insert);
  define_integer(GDK_KEY_KP_Delete);
  define_integer(GDK_KEY_KP_Equal);
  define_integer(GDK_KEY_KP_Multiply);
  define_integer(GDK_KEY_KP_Add);
  define_integer(GDK_KEY_KP_Separator);
  define_integer(GDK_KEY_KP_Subtract);
  define_integer(GDK_KEY_KP_Decimal);
  define_integer(GDK_KEY_KP_Divide);
  define_integer(GDK_KEY_KP_0);
  define_integer(GDK_KEY_KP_1);
  define_integer(GDK_KEY_KP_2);
  define_integer(GDK_KEY_KP_3);
  define_integer(GDK_KEY_KP_4);
  define_integer(GDK_KEY_KP_5);
  define_integer(GDK_KEY_KP_6);
  define_integer(GDK_KEY_KP_7);
  define_integer(GDK_KEY_KP_8);
  define_integer(GDK_KEY_KP_9);
  define_integer(GDK_KEY_F1);
  define_integer(GDK_KEY_F2);
  define_integer(GDK_KEY_F3);
  define_integer(GDK_KEY_F4);
  define_integer(GDK_KEY_F5);
  define_integer(GDK_KEY_F6);
  define_integer(GDK_KEY_F7);
  define_integer(GDK_KEY_F8);
  define_integer(GDK_KEY_F9);
  define_integer(GDK_KEY_F10);
  define_integer(GDK_KEY_F11);
  define_integer(GDK_KEY_L1);
  define_integer(GDK_KEY_F12);
  define_integer(GDK_KEY_L2);
  define_integer(GDK_KEY_F13);
  define_integer(GDK_KEY_L3);
  define_integer(GDK_KEY_F14);
  define_integer(GDK_KEY_L4);
  define_integer(GDK_KEY_F15);
  define_integer(GDK_KEY_L5);
  define_integer(GDK_KEY_F16);
  define_integer(GDK_KEY_L6);
  define_integer(GDK_KEY_F17);
  define_integer(GDK_KEY_L7);
  define_integer(GDK_KEY_F18);
  define_integer(GDK_KEY_L8);
  define_integer(GDK_KEY_F19);
  define_integer(GDK_KEY_L9);
  define_integer(GDK_KEY_F20);
  define_integer(GDK_KEY_L10);
  define_integer(GDK_KEY_F21);
  define_integer(GDK_KEY_R1);
  define_integer(GDK_KEY_F22);
  define_integer(GDK_KEY_R2);
  define_integer(GDK_KEY_F23);
  define_integer(GDK_KEY_R3);
  define_integer(GDK_KEY_F24);
  define_integer(GDK_KEY_R4);
  define_integer(GDK_KEY_F25);
  define_integer(GDK_KEY_R5);
  define_integer(GDK_KEY_F26);
  define_integer(GDK_KEY_R6);
  define_integer(GDK_KEY_F27);
  define_integer(GDK_KEY_R7);
  define_integer(GDK_KEY_F28);
  define_integer(GDK_KEY_R8);
  define_integer(GDK_KEY_F29);
  define_integer(GDK_KEY_R9);
  define_integer(GDK_KEY_F30);
  define_integer(GDK_KEY_R10);
  define_integer(GDK_KEY_F31);
  define_integer(GDK_KEY_R11);
  define_integer(GDK_KEY_F32);
  define_integer(GDK_KEY_R12);
  define_integer(GDK_KEY_F33);
  define_integer(GDK_KEY_R13);
  define_integer(GDK_KEY_F34);
  define_integer(GDK_KEY_R14);
  define_integer(GDK_KEY_F35);
  define_integer(GDK_KEY_R15);
  define_integer(GDK_KEY_Shift_L);
  define_integer(GDK_KEY_Shift_R);
  define_integer(GDK_KEY_Control_L);
  define_integer(GDK_KEY_Control_R);
  define_integer(GDK_KEY_Caps_Lock);
  define_integer(GDK_KEY_Shift_Lock);
  define_integer(GDK_KEY_Meta_L);
  define_integer(GDK_KEY_Meta_R);
  define_integer(GDK_KEY_Alt_L);
  define_integer(GDK_KEY_Alt_R);
  define_integer(GDK_KEY_space);
  define_integer(GDK_KEY_exclam);
  define_integer(GDK_KEY_quotedbl);
  define_integer(GDK_KEY_numbersign);
  define_integer(GDK_KEY_dollar);
  define_integer(GDK_KEY_percent);
  define_integer(GDK_KEY_ampersand);
  define_integer(GDK_KEY_apostrophe);
  define_integer(GDK_KEY_quoteright);
  define_integer(GDK_KEY_parenleft);
  define_integer(GDK_KEY_parenright);
  define_integer(GDK_KEY_asterisk);
  define_integer(GDK_KEY_plus);
  define_integer(GDK_KEY_comma);
  define_integer(GDK_KEY_minus);
  define_integer(GDK_KEY_period);
  define_integer(GDK_KEY_slash);
  define_integer(GDK_KEY_0);
  define_integer(GDK_KEY_1);
  define_integer(GDK_KEY_2);
  define_integer(GDK_KEY_3);
  define_integer(GDK_KEY_4);
  define_integer(GDK_KEY_5);
  define_integer(GDK_KEY_6);
  define_integer(GDK_KEY_7);
  define_integer(GDK_KEY_8);
  define_integer(GDK_KEY_9);
  define_integer(GDK_KEY_colon);
  define_integer(GDK_KEY_semicolon);
  define_integer(GDK_KEY_less);
  define_integer(GDK_KEY_equal);
  define_integer(GDK_KEY_greater);
  define_integer(GDK_KEY_question);
  define_integer(GDK_KEY_at);
  define_integer(GDK_KEY_A);
  define_integer(GDK_KEY_B);
  define_integer(GDK_KEY_C);
  define_integer(GDK_KEY_D);
  define_integer(GDK_KEY_E);
  define_integer(GDK_KEY_F);
  define_integer(GDK_KEY_G);
  define_integer(GDK_KEY_H);
  define_integer(GDK_KEY_I);
  define_integer(GDK_KEY_J);
  define_integer(GDK_KEY_K);
  define_integer(GDK_KEY_L);
  define_integer(GDK_KEY_M);
  define_integer(GDK_KEY_N);
  define_integer(GDK_KEY_O);
  define_integer(GDK_KEY_P);
  define_integer(GDK_KEY_Q);
  define_integer(GDK_KEY_R);
  define_integer(GDK_KEY_S);
  define_integer(GDK_KEY_T);
  define_integer(GDK_KEY_U);
  define_integer(GDK_KEY_V);
  define_integer(GDK_KEY_W);
  define_integer(GDK_KEY_X);
  define_integer(GDK_KEY_Y);
  define_integer(GDK_KEY_Z);
  define_integer(GDK_KEY_bracketleft);
  define_integer(GDK_KEY_backslash);
  define_integer(GDK_KEY_bracketright);
  define_integer(GDK_KEY_asciicircum);
  define_integer(GDK_KEY_underscore);
  define_integer(GDK_KEY_grave);
  define_integer(GDK_KEY_quoteleft);
  define_integer(GDK_KEY_a);
  define_integer(GDK_KEY_b);
  define_integer(GDK_KEY_c);
  define_integer(GDK_KEY_d);
  define_integer(GDK_KEY_e);
  define_integer(GDK_KEY_f);
  define_integer(GDK_KEY_g);
  define_integer(GDK_KEY_h);
  define_integer(GDK_KEY_i);
  define_integer(GDK_KEY_j);
  define_integer(GDK_KEY_k);
  define_integer(GDK_KEY_l);
  define_integer(GDK_KEY_m);
  define_integer(GDK_KEY_n);
  define_integer(GDK_KEY_o);
  define_integer(GDK_KEY_p);
  define_integer(GDK_KEY_q);
  define_integer(GDK_KEY_r);
  define_integer(GDK_KEY_s);
  define_integer(GDK_KEY_t);
  define_integer(GDK_KEY_u);
  define_integer(GDK_KEY_v);
  define_integer(GDK_KEY_w);
  define_integer(GDK_KEY_x);
  define_integer(GDK_KEY_y);
  define_integer(GDK_KEY_z);
  define_integer(GDK_KEY_braceleft);
  define_integer(GDK_KEY_bar);
  define_integer(GDK_KEY_braceright);
  define_integer(GDK_KEY_asciitilde);
  define_integer(GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH);
  define_integer(GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT);
  define_integer(GTK_ASSISTANT_PAGE_CUSTOM);
  define_integer(GTK_TEXT_SEARCH_CASE_INSENSITIVE);
  define_integer(GTK_SCROLL_MINIMUM);
  define_integer(GTK_SCROLL_NATURAL);
  define_integer(GTK_ALIGN_FILL);
  define_integer(GTK_ALIGN_START);
  define_integer(GTK_ALIGN_END);
  define_integer(GTK_ALIGN_CENTER);
  define_integer(GTK_TOOL_PALETTE_DRAG_ITEMS);
  define_integer(GTK_TOOL_PALETTE_DRAG_GROUPS);
  define_integer(GTK_IMAGE_GICON);
  define_integer(GTK_FILE_CHOOSER_ERROR_NONEXISTENT);
  define_integer(GTK_FILE_CHOOSER_ERROR_BAD_FILENAME);
  define_integer(GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS);
  define_integer(GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME);
  define_integer(GTK_ICON_LOOKUP_FORCE_SIZE);
  define_integer(GTK_ICON_THEME_NOT_FOUND);
  define_integer(GTK_ICON_THEME_FAILED);
  define_integer(GTK_STATE_FLAG_NORMAL);
  define_integer(GTK_STATE_FLAG_ACTIVE);
  define_integer(GTK_STATE_FLAG_PRELIGHT);
  define_integer(GTK_STATE_FLAG_SELECTED);
  define_integer(GTK_STATE_FLAG_INSENSITIVE);
  define_integer(GTK_STATE_FLAG_INCONSISTENT);
  define_integer(GTK_STATE_FLAG_FOCUSED);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  define_integer(GTK_SIZE_REQUEST_CONSTANT_SIZE);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  define_integer(GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR);
  define_integer(GDK_MODIFIER_INTENT_CONTEXT_MENU);
  define_integer(GDK_MODIFIER_INTENT_EXTEND_SELECTION);
  define_integer(GDK_MODIFIER_INTENT_MODIFY_SELECTION);
  define_integer(GDK_MODIFIER_INTENT_NO_TEXT_INPUT);
  define_integer(GDK_MODIFIER_INTENT_SHIFT_GROUP);
  define_integer(GDK_WINDOW_STATE_FOCUSED);
  define_integer(GTK_CELL_RENDERER_EXPANDABLE);
  define_integer(GTK_CELL_RENDERER_EXPANDED);
  define_integer(GTK_STATE_FLAG_BACKDROP);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  define_integer(GDK_TOUCH_BEGIN);
  define_integer(GDK_TOUCH_UPDATE);
  define_integer(GDK_TOUCH_END);
  define_integer(GDK_TOUCH_CANCEL);
  define_integer(GDK_SCROLL_SMOOTH);
  define_integer(GDK_CROSSING_TOUCH_BEGIN);
  define_integer(GDK_CROSSING_TOUCH_END);
  define_integer(GDK_CROSSING_DEVICE_SWITCH);
  define_integer(GDK_TOUCH_MASK);
  define_integer(GDK_SMOOTH_SCROLL_MASK);
  define_integer(GTK_LEVEL_BAR_MODE_CONTINUOUS);
  define_integer(GTK_LEVEL_BAR_MODE_DISCRETE);
  define_integer(GTK_INPUT_PURPOSE_FREE_FORM);
  define_integer(GTK_INPUT_PURPOSE_ALPHA);
  define_integer(GTK_INPUT_PURPOSE_DIGITS);
  define_integer(GTK_INPUT_PURPOSE_NUMBER);
  define_integer(GTK_INPUT_PURPOSE_PHONE);
  define_integer(GTK_INPUT_PURPOSE_URL);
  define_integer(GTK_INPUT_PURPOSE_EMAIL);
  define_integer(GTK_INPUT_PURPOSE_NAME);
  define_integer(GTK_INPUT_PURPOSE_PASSWORD);
  define_integer(GTK_INPUT_PURPOSE_PIN);
  define_integer(GTK_INPUT_HINT_NONE);
  define_integer(GTK_INPUT_HINT_SPELLCHECK);
  define_integer(GTK_INPUT_HINT_NO_SPELLCHECK);
  define_integer(GTK_INPUT_HINT_WORD_COMPLETION);
  define_integer(GTK_INPUT_HINT_LOWERCASE);
  define_integer(GTK_INPUT_HINT_UPPERCASE_CHARS);
  define_integer(GTK_INPUT_HINT_UPPERCASE_WORDS);
  define_integer(GTK_INPUT_HINT_UPPERCASE_SENTENCES);
  define_integer(GTK_INPUT_HINT_INHIBIT_OSK);
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
  define_integer(GTK_STATE_FLAG_DIR_LTR);
  define_integer(GTK_STATE_FLAG_DIR_RTL);
  define_integer(GDK_FULLSCREEN_ON_CURRENT_MONITOR);
  define_integer(GDK_FULLSCREEN_ON_ALL_MONITORS);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  define_integer(GTK_ALIGN_BASELINE);
  define_integer(GTK_BASELINE_POSITION_TOP);
  define_integer(GTK_BASELINE_POSITION_CENTER);
  define_integer(GTK_BASELINE_POSITION_BOTTOM);
  define_integer(GTK_PLACES_OPEN_NORMAL);
  define_integer(GTK_PLACES_OPEN_NEW_TAB);
  define_integer(GTK_PLACES_OPEN_NEW_WINDOW);
  define_integer(GTK_STACK_TRANSITION_TYPE_NONE);
  define_integer(GTK_STACK_TRANSITION_TYPE_CROSSFADE);
  define_integer(GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT);
  define_integer(GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT);
  define_integer(GTK_STACK_TRANSITION_TYPE_SLIDE_UP);
  define_integer(GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN);
  define_integer(GTK_REVEALER_TRANSITION_TYPE_NONE);
  define_integer(GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
  define_integer(GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
  define_integer(GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
  define_integer(GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
  define_integer(GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
  define_integer(GDK_WINDOW_STATE_TILED);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  define_integer(GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
  define_integer(GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN);
  define_integer(GTK_STACK_TRANSITION_TYPE_OVER_UP);
  define_integer(GTK_STACK_TRANSITION_TYPE_OVER_DOWN);
  define_integer(GTK_STACK_TRANSITION_TYPE_OVER_LEFT);
  define_integer(GTK_STACK_TRANSITION_TYPE_OVER_RIGHT);
  define_integer(GTK_STACK_TRANSITION_TYPE_UNDER_UP);
  define_integer(GTK_STACK_TRANSITION_TYPE_UNDER_DOWN);
  define_integer(GTK_STACK_TRANSITION_TYPE_UNDER_LEFT);
  define_integer(GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT);
  define_integer(GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  define_integer(GTK_PHASE_NONE);
  define_integer(GTK_PHASE_CAPTURE);
  define_integer(GTK_PHASE_BUBBLE);
  define_integer(GTK_PHASE_TARGET);
  define_integer(GTK_TEXT_VIEW_LAYER_BELOW);
  define_integer(GTK_TEXT_VIEW_LAYER_ABOVE);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  define_integer(GTK_POLICY_EXTERNAL);
  define_integer(PANGO_WEIGHT_SEMILIGHT);
  define_integer(GTK_TEXT_EXTEND_SELECTION_WORD);
  define_integer(GTK_TEXT_EXTEND_SELECTION_LINE);
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
  define_integer(GDK_TOUCHPAD_SWIPE);
  define_integer(GDK_TOUCHPAD_PINCH);
  define_integer(GDK_TOUCHPAD_GESTURE_PHASE_BEGIN);
  define_integer(GDK_TOUCHPAD_GESTURE_PHASE_UPDATE);
  define_integer(GDK_TOUCHPAD_GESTURE_PHASE_END);
  define_integer(GDK_TOUCHPAD_GESTURE_PHASE_CANCEL);
  define_integer(GDK_TOUCHPAD_GESTURE_MASK);
  define_integer(GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  define_integer(GTK_SHORTCUT_ACCELERATOR);
  define_integer(GTK_SHORTCUT_GESTURE_PINCH);
  define_integer(GTK_SHORTCUT_GESTURE_STRETCH);
  define_integer(GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE);
  define_integer(GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE);
  define_integer(GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT);
  define_integer(GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT);
  define_integer(GTK_SHORTCUT_GESTURE);
  define_integer(GTK_POPOVER_CONSTRAINT_NONE);
  define_integer(GTK_POPOVER_CONSTRAINT_WINDOW);
  define_integer(GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);
  define_integer(GDK_WINDOW_TYPE_HINT_UTILITY);
  define_integer(GDK_WINDOW_TYPE_HINT_DOCK);
  define_integer(GDK_WINDOW_TYPE_HINT_DESKTOP);
  define_integer(GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU);
  define_integer(GDK_WINDOW_TYPE_HINT_POPUP_MENU);
  define_integer(GDK_WINDOW_TYPE_HINT_TOOLTIP);
  define_integer(GDK_WINDOW_TYPE_HINT_NOTIFICATION);
  define_integer(GDK_WINDOW_TYPE_HINT_COMBO);
  define_integer(GDK_WINDOW_TYPE_HINT_DND);
  define_integer(GDK_SEAT_CAPABILITY_NONE);
  define_integer(GDK_SEAT_CAPABILITY_POINTER);
  define_integer(GDK_SEAT_CAPABILITY_TOUCH);
  define_integer(GDK_SEAT_CAPABILITY_TABLET_STYLUS);
  define_integer(GDK_SEAT_CAPABILITY_KEYBOARD);
  define_integer(GDK_SEAT_CAPABILITY_ALL_POINTING);
  define_integer(GDK_SEAT_CAPABILITY_ALL);
  define_integer(GTK_STATE_FLAG_DROP_ACTIVE);
  define_integer(GDK_DRAG_CANCEL_NO_TARGET);
  define_integer(GDK_DRAG_CANCEL_USER_CANCELLED);
  define_integer(GDK_DRAG_CANCEL_ERROR);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  define_integer(GDK_AXIS_IGNORE);
  define_integer(GDK_AXIS_X);
  define_integer(GDK_AXIS_Y);
  define_integer(GDK_AXIS_PRESSURE);
  define_integer(GDK_AXIS_XTILT);
  define_integer(GDK_AXIS_YTILT);
  define_integer(GDK_AXIS_WHEEL);
  define_integer(GDK_AXIS_LAST);
  define_integer(GDK_AXIS_FLAG_X);
  define_integer(GDK_AXIS_FLAG_Y);
  define_integer(GDK_AXIS_FLAG_PRESSURE);
  define_integer(GDK_AXIS_FLAG_XTILT);
  define_integer(GDK_AXIS_FLAG_YTILT);
  define_integer(GDK_AXIS_FLAG_WHEEL);
  define_integer(GDK_AXIS_FLAG_DISTANCE);
  define_integer(GDK_AXIS_FLAG_ROTATION);
  define_integer(GDK_AXIS_FLAG_SLIDER);
  define_integer(GDK_DEVICE_TOOL_TYPE_UNKNOWN);
  define_integer(GDK_DEVICE_TOOL_TYPE_PEN);
  define_integer(GDK_DEVICE_TOOL_TYPE_ERASER);
  define_integer(GDK_DEVICE_TOOL_TYPE_BRUSH);
  define_integer(GDK_DEVICE_TOOL_TYPE_PENCIL);
  define_integer(GDK_DEVICE_TOOL_TYPE_AIRBRUSH);
  define_integer(GDK_DEVICE_TOOL_TYPE_MOUSE);
  define_integer(GDK_DEVICE_TOOL_TYPE_LENS);
  define_integer(GDK_SUBPIXEL_LAYOUT_UNKNOWN);
  define_integer(GDK_SUBPIXEL_LAYOUT_NONE);
  define_integer(GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB);
  define_integer(GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR);
  define_integer(GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB);
  define_integer(GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR);
  define_integer(GDK_DEVICE_PAD_FEATURE_BUTTON);
  define_integer(GDK_DEVICE_PAD_FEATURE_RING);
  define_integer(GDK_DEVICE_PAD_FEATURE_STRIP);
  define_integer(GDK_PAD_BUTTON_PRESS);
  define_integer(GDK_PAD_BUTTON_RELEASE);
  define_integer(GDK_PAD_RING);
  define_integer(GDK_PAD_STRIP);
  define_integer(GDK_PAD_GROUP_MODE);
  define_integer(GDK_TABLET_PAD_MASK);
  define_integer(GDK_ANCHOR_FLIP_X);
  define_integer(GDK_ANCHOR_FLIP_Y);
  define_integer(GDK_ANCHOR_SLIDE_X);
  define_integer(GDK_ANCHOR_SLIDE_Y);
  define_integer(GDK_ANCHOR_RESIZE_X);
  define_integer(GDK_ANCHOR_RESIZE_Y);
  define_integer(GDK_ANCHOR_FLIP);
  define_integer(GDK_ANCHOR_SLIDE);
  define_integer(GDK_ANCHOR_RESIZE);
  define_integer(GTK_PAD_ACTION_BUTTON);
  define_integer(GTK_PAD_ACTION_RING);
  define_integer(GTK_PAD_ACTION_STRIP);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  define_integer(GTK_SHORTCUT_GESTURE_SWIPE_LEFT);
  define_integer(GTK_SHORTCUT_GESTURE_SWIPE_RIGHT);
  define_integer(GTK_STYLE_PROVIDER_PRIORITY_FALLBACK);
  define_integer(GTK_STYLE_PROVIDER_PRIORITY_THEME);
  define_integer(GTK_STYLE_PROVIDER_PRIORITY_SETTINGS);
  define_integer(GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
  define_integer(GTK_STYLE_PROVIDER_PRIORITY_USER);
  define_integer(GTK_STYLE_CONTEXT_PRINT_NONE);
  define_integer(GTK_STYLE_CONTEXT_PRINT_RECURSE);
  define_integer(GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE);
  define_integer(GTK_CSS_PROVIDER_ERROR_FAILED);
  define_integer(GTK_CSS_PROVIDER_ERROR_SYNTAX);
  define_integer(GTK_CSS_PROVIDER_ERROR_IMPORT);
  define_integer(GTK_CSS_PROVIDER_ERROR_NAME);
  define_integer(GTK_CSS_PROVIDER_ERROR_DEPRECATED);
  define_integer(GTK_CSS_PROVIDER_ERROR_UNKNOWN_VALUE);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  define_integer(GDK_WINDOW_STATE_TOP_TILED);
  define_integer(GDK_WINDOW_STATE_TOP_RESIZABLE);
  define_integer(GDK_WINDOW_STATE_RIGHT_TILED);
  define_integer(GDK_WINDOW_STATE_RIGHT_RESIZABLE);
  define_integer(GDK_WINDOW_STATE_BOTTOM_TILED);
  define_integer(GDK_WINDOW_STATE_BOTTOM_RESIZABLE);
  define_integer(GDK_WINDOW_STATE_LEFT_TILED);
  define_integer(GDK_WINDOW_STATE_LEFT_RESIZABLE);
  define_integer(GTK_INPUT_HINT_VERTICAL_WRITING);
  define_integer(GTK_INPUT_HINT_EMOJI);
  define_integer(GTK_INPUT_HINT_NO_EMOJI);
  define_integer(GTK_EVENT_CONTROLLER_SCROLL_NONE);
  define_integer(GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
  define_integer(GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL);
  define_integer(GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
  define_integer(GTK_EVENT_CONTROLLER_SCROLL_KINETIC);
  define_integer(GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES);
  define_integer(GDK_DEVICE_TYPE_MASTER);
  define_integer(GDK_DEVICE_TYPE_SLAVE);
  define_integer(GDK_DEVICE_TYPE_FLOATING);
  define_integer(GDK_SEAT_CAPABILITY_TABLET_PAD);
  define_integer(GTK_ICON_SIZE_INHERIT);
  define_integer(GTK_ICON_SIZE_NORMAL);
  define_integer(GTK_ICON_SIZE_LARGE);
  define_integer(GTK_STATE_FLAG_FOCUS_VISIBLE);
  define_integer(GTK_IMAGE_SURFACE);
  define_integer(GTK_IMAGE_TEXTURE);
  define_integer(GTK_APPLICATION_INHIBIT_LOGOUT);
  define_integer(GTK_APPLICATION_INHIBIT_SWITCH);
  define_integer(GTK_APPLICATION_INHIBIT_SUSPEND);
  define_integer(GTK_APPLICATION_INHIBIT_IDLE);
#endif

  define_integer(CAIRO_STATUS_SUCCESS);
  define_integer(CAIRO_STATUS_NO_MEMORY);
  define_integer(CAIRO_STATUS_INVALID_RESTORE);
  define_integer(CAIRO_STATUS_INVALID_POP_GROUP);
  define_integer(CAIRO_STATUS_NO_CURRENT_POINT);
  define_integer(CAIRO_STATUS_INVALID_MATRIX);
  define_integer(CAIRO_STATUS_INVALID_STATUS);
  define_integer(CAIRO_STATUS_NULL_POINTER);
  define_integer(CAIRO_STATUS_INVALID_STRING);
  define_integer(CAIRO_STATUS_INVALID_PATH_DATA);
  define_integer(CAIRO_STATUS_READ_ERROR);
  define_integer(CAIRO_STATUS_WRITE_ERROR);
  define_integer(CAIRO_STATUS_SURFACE_FINISHED);
  define_integer(CAIRO_STATUS_SURFACE_TYPE_MISMATCH);
  define_integer(CAIRO_STATUS_PATTERN_TYPE_MISMATCH);
  define_integer(CAIRO_STATUS_INVALID_CONTENT);
  define_integer(CAIRO_STATUS_INVALID_FORMAT);
  define_integer(CAIRO_STATUS_INVALID_VISUAL);
  define_integer(CAIRO_STATUS_FILE_NOT_FOUND);
  define_integer(CAIRO_STATUS_INVALID_DASH);
  define_integer(CAIRO_STATUS_INVALID_DSC_COMMENT);
  define_integer(CAIRO_STATUS_INVALID_INDEX);
  define_integer(CAIRO_STATUS_CLIP_NOT_REPRESENTABLE);
  define_integer(CAIRO_STATUS_TEMP_FILE_ERROR);
  define_integer(CAIRO_STATUS_INVALID_STRIDE);
  define_integer(CAIRO_CONTENT_COLOR);
  define_integer(CAIRO_CONTENT_ALPHA);
  define_integer(CAIRO_CONTENT_COLOR_ALPHA);
  define_integer(CAIRO_OPERATOR_CLEAR);
  define_integer(CAIRO_OPERATOR_SOURCE);
  define_integer(CAIRO_OPERATOR_OVER);
  define_integer(CAIRO_OPERATOR_IN);
  define_integer(CAIRO_OPERATOR_OUT);
  define_integer(CAIRO_OPERATOR_ATOP);
  define_integer(CAIRO_OPERATOR_DEST);
  define_integer(CAIRO_OPERATOR_DEST_OVER);
  define_integer(CAIRO_OPERATOR_DEST_IN);
  define_integer(CAIRO_OPERATOR_DEST_OUT);
  define_integer(CAIRO_OPERATOR_DEST_ATOP);
  define_integer(CAIRO_OPERATOR_XOR);
  define_integer(CAIRO_OPERATOR_ADD);
  define_integer(CAIRO_OPERATOR_SATURATE);
  define_integer(CAIRO_ANTIALIAS_DEFAULT);
  define_integer(CAIRO_ANTIALIAS_NONE);
  define_integer(CAIRO_ANTIALIAS_GRAY);
  define_integer(CAIRO_ANTIALIAS_SUBPIXEL);
  define_integer(CAIRO_FILL_RULE_WINDING);
  define_integer(CAIRO_FILL_RULE_EVEN_ODD);
  define_integer(CAIRO_LINE_CAP_BUTT);
  define_integer(CAIRO_LINE_CAP_ROUND);
  define_integer(CAIRO_LINE_CAP_SQUARE);
  define_integer(CAIRO_LINE_JOIN_MITER);
  define_integer(CAIRO_LINE_JOIN_ROUND);
  define_integer(CAIRO_LINE_JOIN_BEVEL);
  define_integer(CAIRO_FONT_SLANT_NORMAL);
  define_integer(CAIRO_FONT_SLANT_ITALIC);
  define_integer(CAIRO_FONT_SLANT_OBLIQUE);
  define_integer(CAIRO_FONT_WEIGHT_NORMAL);
  define_integer(CAIRO_FONT_WEIGHT_BOLD);
  define_integer(CAIRO_SUBPIXEL_ORDER_DEFAULT);
  define_integer(CAIRO_SUBPIXEL_ORDER_RGB);
  define_integer(CAIRO_SUBPIXEL_ORDER_BGR);
  define_integer(CAIRO_SUBPIXEL_ORDER_VRGB);
  define_integer(CAIRO_SUBPIXEL_ORDER_VBGR);
  define_integer(CAIRO_HINT_STYLE_DEFAULT);
  define_integer(CAIRO_HINT_STYLE_NONE);
  define_integer(CAIRO_HINT_STYLE_SLIGHT);
  define_integer(CAIRO_HINT_STYLE_MEDIUM);
  define_integer(CAIRO_HINT_STYLE_FULL);
  define_integer(CAIRO_HINT_METRICS_DEFAULT);
  define_integer(CAIRO_HINT_METRICS_OFF);
  define_integer(CAIRO_HINT_METRICS_ON);
  define_integer(CAIRO_FONT_TYPE_TOY);
  define_integer(CAIRO_FONT_TYPE_FT);
  define_integer(CAIRO_FONT_TYPE_WIN32);
  define_integer(CAIRO_FONT_TYPE_QUARTZ);
  define_integer(CAIRO_PATH_MOVE_TO);
  define_integer(CAIRO_PATH_LINE_TO);
  define_integer(CAIRO_PATH_CURVE_TO);
  define_integer(CAIRO_PATH_CLOSE_PATH);
  define_integer(CAIRO_SURFACE_TYPE_IMAGE);
  define_integer(CAIRO_SURFACE_TYPE_PDF);
  define_integer(CAIRO_SURFACE_TYPE_PS);
  define_integer(CAIRO_SURFACE_TYPE_XLIB);
  define_integer(CAIRO_SURFACE_TYPE_XCB);
  define_integer(CAIRO_SURFACE_TYPE_GLITZ);
  define_integer(CAIRO_SURFACE_TYPE_QUARTZ);
  define_integer(CAIRO_SURFACE_TYPE_WIN32);
  define_integer(CAIRO_SURFACE_TYPE_BEOS);
  define_integer(CAIRO_SURFACE_TYPE_DIRECTFB);
  define_integer(CAIRO_SURFACE_TYPE_SVG);
  define_integer(CAIRO_SURFACE_TYPE_OS2);
  define_integer(CAIRO_SURFACE_TYPE_WIN32_PRINTING);
  define_integer(CAIRO_SURFACE_TYPE_QUARTZ_IMAGE);
  define_integer(CAIRO_FORMAT_ARGB32);
  define_integer(CAIRO_FORMAT_RGB24);
  define_integer(CAIRO_FORMAT_A8);
  define_integer(CAIRO_FORMAT_A1);
  define_integer(CAIRO_PATTERN_TYPE_SOLID);
  define_integer(CAIRO_PATTERN_TYPE_SURFACE);
  define_integer(CAIRO_PATTERN_TYPE_LINEAR);
  define_integer(CAIRO_PATTERN_TYPE_RADIAL);
  define_integer(CAIRO_EXTEND_NONE);
  define_integer(CAIRO_EXTEND_REPEAT);
  define_integer(CAIRO_EXTEND_REFLECT);
  define_integer(CAIRO_EXTEND_PAD);
  define_integer(CAIRO_FILTER_FAST);
  define_integer(CAIRO_FILTER_GOOD);
  define_integer(CAIRO_FILTER_BEST);
  define_integer(CAIRO_FILTER_NEAREST);
  define_integer(CAIRO_FILTER_BILINEAR);
  define_integer(CAIRO_FILTER_GAUSSIAN);
#if HAVE_CAIRO_1_8
  define_integer(CAIRO_STATUS_FONT_TYPE_MISMATCH);
  define_integer(CAIRO_STATUS_USER_FONT_IMMUTABLE);
  define_integer(CAIRO_STATUS_USER_FONT_ERROR);
  define_integer(CAIRO_STATUS_NEGATIVE_COUNT);
  define_integer(CAIRO_STATUS_INVALID_CLUSTERS);
  define_integer(CAIRO_STATUS_INVALID_SLANT);
  define_integer(CAIRO_STATUS_INVALID_WEIGHT);
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
  define_integer(CAIRO_STATUS_INVALID_SIZE);
  define_integer(CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED);
  define_integer(CAIRO_STATUS_DEVICE_TYPE_MISMATCH);
  define_integer(CAIRO_STATUS_DEVICE_ERROR);
  define_integer(CAIRO_OPERATOR_MULTIPLY);
  define_integer(CAIRO_OPERATOR_SCREEN);
  define_integer(CAIRO_OPERATOR_OVERLAY);
  define_integer(CAIRO_OPERATOR_DARKEN);
  define_integer(CAIRO_OPERATOR_LIGHTEN);
  define_integer(CAIRO_OPERATOR_COLOR_DODGE);
  define_integer(CAIRO_OPERATOR_COLOR_BURN);
  define_integer(CAIRO_OPERATOR_HARD_LIGHT);
  define_integer(CAIRO_OPERATOR_SOFT_LIGHT);
  define_integer(CAIRO_OPERATOR_DIFFERENCE);
  define_integer(CAIRO_OPERATOR_EXCLUSION);
  define_integer(CAIRO_OPERATOR_HSL_HUE);
  define_integer(CAIRO_OPERATOR_HSL_SATURATION);
  define_integer(CAIRO_OPERATOR_HSL_COLOR);
  define_integer(CAIRO_OPERATOR_HSL_LUMINOSITY);
  define_integer(CAIRO_SURFACE_TYPE_SCRIPT);
  define_integer(CAIRO_SURFACE_TYPE_QT);
  define_integer(CAIRO_SURFACE_TYPE_RECORDING);
  define_integer(CAIRO_SURFACE_TYPE_VG);
  define_integer(CAIRO_SURFACE_TYPE_GL);
  define_integer(CAIRO_SURFACE_TYPE_DRM);
  define_integer(CAIRO_SURFACE_TYPE_TEE);
  define_integer(CAIRO_SURFACE_TYPE_XML);
  define_integer(CAIRO_SURFACE_TYPE_SKIA);
#endif

}

static void define_doubles(void)
{
#define define_double(Name) Xen_define(Xg_pre #Name Xg_post, C_double_to_Xen_real(Name))

  define_double(PANGO_SCALE_XX_SMALL);
  define_double(PANGO_SCALE_X_SMALL);
  define_double(PANGO_SCALE_SMALL);
  define_double(PANGO_SCALE_MEDIUM);
  define_double(PANGO_SCALE_LARGE);
  define_double(PANGO_SCALE_X_LARGE);
  define_double(PANGO_SCALE_XX_LARGE);
}

/* -------------------------------- symbols -------------------------------- */

static void define_symbols(void)
{
  xg_GMenu__symbol = C_string_to_Xen_symbol("GMenu_");
  xg_GtkApplicationInhibitFlags_symbol = C_string_to_Xen_symbol("GtkApplicationInhibitFlags");
  xg_GApplicationFlags_symbol = C_string_to_Xen_symbol("GApplicationFlags");
  xg_GtkContentFormats__symbol = C_string_to_Xen_symbol("GtkContentFormats_");
  xg_GdkAtom__symbol = C_string_to_Xen_symbol("GdkAtom_");
  xg_GdkDisplay_gtk_invisible_get_display_symbol = C_string_to_Xen_symbol("GdkDisplay_gtk_invisible_get_display");
  xg_GtkInvisible__symbol = C_string_to_Xen_symbol("GtkInvisible_");
  xg_GtkIconSize_symbol = C_string_to_Xen_symbol("GtkIconSize");
  xg_GValue_symbol = C_string_to_Xen_symbol("GValue");
  xg_GBytes__symbol = C_string_to_Xen_symbol("GBytes_");
  xg_GdkContentDeserializeFunc_symbol = C_string_to_Xen_symbol("GdkContentDeserializeFunc");
  xg_GdkContentDeserializer__symbol = C_string_to_Xen_symbol("GdkContentDeserializer_");
  xg_GdkContentSerializeFunc_symbol = C_string_to_Xen_symbol("GdkContentSerializeFunc");
  xg_GdkContentSerializer__symbol = C_string_to_Xen_symbol("GdkContentSerializer_");
  xg_GOutputStream__symbol = C_string_to_Xen_symbol("GOutputStream_");
  xg_GdkContentFormatsBuilder__symbol = C_string_to_Xen_symbol("GdkContentFormatsBuilder_");
  xg_GdkContentFormatsBuilder_symbol = C_string_to_Xen_symbol("GdkContentFormatsBuilder");
  xg_GString__symbol = C_string_to_Xen_symbol("GString_");
  xg_GdkTexture__symbol = C_string_to_Xen_symbol("GdkTexture_");
  xg_har___symbol = C_string_to_Xen_symbol("har__");
  xg_GInputStream__symbol = C_string_to_Xen_symbol("GInputStream_");
  xg_GAsyncResult__symbol = C_string_to_Xen_symbol("GAsyncResult_");
  xg_GAsyncReadyCallback_symbol = C_string_to_Xen_symbol("GAsyncReadyCallback");
  xg_GCancellable__symbol = C_string_to_Xen_symbol("GCancellable_");
  xg_GdkContentProvider__symbol = C_string_to_Xen_symbol("GdkContentProvider_");
  xg_GdkContentFormats__symbol = C_string_to_Xen_symbol("GdkContentFormats_");
  xg_GdkClipboard__symbol = C_string_to_Xen_symbol("GdkClipboard_");
  xg_GdkAppLaunchContext__symbol = C_string_to_Xen_symbol("GdkAppLaunchContext_");
  xg_GtkEventControllerScroll__symbol = C_string_to_Xen_symbol("GtkEventControllerScroll_");
  xg_GtkEventControllerScrollFlags_symbol = C_string_to_Xen_symbol("GtkEventControllerScrollFlags");
  xg_GtkSnapshot__symbol = C_string_to_Xen_symbol("GtkSnapshot_");
  xg_GdkTouchpadGesturePhase_symbol = C_string_to_Xen_symbol("GdkTouchpadGesturePhase");
  xg_GdkNotifyType_symbol = C_string_to_Xen_symbol("GdkNotifyType");
  xg_GdkCrossingMode_symbol = C_string_to_Xen_symbol("GdkCrossingMode");
  xg_GtkCssProvider__symbol = C_string_to_Xen_symbol("GtkCssProvider_");
  xg_GtkStyleContextPrintFlags_symbol = C_string_to_Xen_symbol("GtkStyleContextPrintFlags");
  xg_GdkFrameClock__symbol = C_string_to_Xen_symbol("GdkFrameClock_");
  xg_GtkCssSection__symbol = C_string_to_Xen_symbol("GtkCssSection_");
  xg_GtkStyleProvider__symbol = C_string_to_Xen_symbol("GtkStyleProvider_");
  xg_GdkEventScroll__symbol = C_string_to_Xen_symbol("GdkEventScroll_");
  xg_GtkScrollbar__symbol = C_string_to_Xen_symbol("GtkScrollbar_");
  xg_GtkCenterBox__symbol = C_string_to_Xen_symbol("GtkCenterBox_");
  xg_GtkCheckButton__symbol = C_string_to_Xen_symbol("GtkCheckButton_");
  xg_GdkDrawContext__symbol = C_string_to_Xen_symbol("GdkDrawContext_");
  xg_GtkDrawingAreaDrawFunc_symbol = C_string_to_Xen_symbol("GtkDrawingAreaDrawFunc");
  xg_GtkShortcutLabel__symbol = C_string_to_Xen_symbol("GtkShortcutLabel_");
  xg_GtkPadActionType_symbol = C_string_to_Xen_symbol("GtkPadActionType");
  xg_GtkPadActionEntry__symbol = C_string_to_Xen_symbol("GtkPadActionEntry_");
  xg_GActionGroup__symbol = C_string_to_Xen_symbol("GActionGroup_");
  xg_GtkPadController__symbol = C_string_to_Xen_symbol("GtkPadController_");
  xg_GdkDevicePadFeature_symbol = C_string_to_Xen_symbol("GdkDevicePadFeature");
  xg_GdkDevicePad__symbol = C_string_to_Xen_symbol("GdkDevicePad_");
  xg_GdkDrawingContext__symbol = C_string_to_Xen_symbol("GdkDrawingContext_");
  xg_GdkSubpixelLayout_symbol = C_string_to_Xen_symbol("GdkSubpixelLayout");
  xg_GdkMonitor__symbol = C_string_to_Xen_symbol("GdkMonitor_");
  xg_GdkDeviceTool__symbol = C_string_to_Xen_symbol("GdkDeviceTool_");
  xg_GdkAxisFlags_symbol = C_string_to_Xen_symbol("GdkAxisFlags");
  xg_GdkSeatGrabPrepareFunc_symbol = C_string_to_Xen_symbol("GdkSeatGrabPrepareFunc");
  xg_GdkSeatCapabilities_symbol = C_string_to_Xen_symbol("GdkSeatCapabilities");
  xg_GdkGrabStatus_symbol = C_string_to_Xen_symbol("GdkGrabStatus");
  xg_GtkPopoverConstraint_symbol = C_string_to_Xen_symbol("GtkPopoverConstraint");
  xg_GtkShortcutsWindow__symbol = C_string_to_Xen_symbol("GtkShortcutsWindow_");
  xg_GtkStackSidebar__symbol = C_string_to_Xen_symbol("GtkStackSidebar_");
  xg_GtkSearchEntry__symbol = C_string_to_Xen_symbol("GtkSearchEntry_");
  xg_GtkPopoverMenu__symbol = C_string_to_Xen_symbol("GtkPopoverMenu_");
  xg_GtkStyleContext__symbol = C_string_to_Xen_symbol("GtkStyleContext_");
  xg_GdkGLContext__symbol = C_string_to_Xen_symbol("GdkGLContext_");
  xg_GtkGLArea__symbol = C_string_to_Xen_symbol("GtkGLArea_");
  xg_GtkPropagationPhase_symbol = C_string_to_Xen_symbol("GtkPropagationPhase");
  xg_GtkEventController__symbol = C_string_to_Xen_symbol("GtkEventController_");
  xg_GtkGestureZoom__symbol = C_string_to_Xen_symbol("GtkGestureZoom_");
  xg_GtkGestureSwipe__symbol = C_string_to_Xen_symbol("GtkGestureSwipe_");
  xg_GtkGestureSingle__symbol = C_string_to_Xen_symbol("GtkGestureSingle_");
  xg_GtkGestureRotate__symbol = C_string_to_Xen_symbol("GtkGestureRotate_");
  xg_GtkGestureMultiPress__symbol = C_string_to_Xen_symbol("GtkGestureMultiPress_");
  xg_GtkGesturePan__symbol = C_string_to_Xen_symbol("GtkGesturePan_");
  xg_GtkGestureDrag__symbol = C_string_to_Xen_symbol("GtkGestureDrag_");
  xg_GdkEventSequence__symbol = C_string_to_Xen_symbol("GdkEventSequence_");
  xg_GtkEventSequenceState_symbol = C_string_to_Xen_symbol("GtkEventSequenceState");
  xg_GtkGesture__symbol = C_string_to_Xen_symbol("GtkGesture_");
  xg_GtkAllocation__symbol = C_string_to_Xen_symbol("GtkAllocation_");
  xg_GtkPopover__symbol = C_string_to_Xen_symbol("GtkPopover_");
  xg_GtkActionBar__symbol = C_string_to_Xen_symbol("GtkActionBar_");
  xg_GtkFlowBox__symbol = C_string_to_Xen_symbol("GtkFlowBox_");
  xg_GtkFlowBoxChild__symbol = C_string_to_Xen_symbol("GtkFlowBoxChild_");
  xg_GdkEventType_symbol = C_string_to_Xen_symbol("GdkEventType");
  xg_GtkSearchBar__symbol = C_string_to_Xen_symbol("GtkSearchBar_");
  xg_GtkListBox__symbol = C_string_to_Xen_symbol("GtkListBox_");
  xg_GtkListBoxRow__symbol = C_string_to_Xen_symbol("GtkListBoxRow_");
  xg_GtkHeaderBar__symbol = C_string_to_Xen_symbol("GtkHeaderBar_");
  xg_GtkRevealerTransitionType_symbol = C_string_to_Xen_symbol("GtkRevealerTransitionType");
  xg_GtkRevealer__symbol = C_string_to_Xen_symbol("GtkRevealer_");
  xg_GtkStackTransitionType_symbol = C_string_to_Xen_symbol("GtkStackTransitionType");
  xg_GtkStack__symbol = C_string_to_Xen_symbol("GtkStack_");
  xg_GtkStackSwitcher__symbol = C_string_to_Xen_symbol("GtkStackSwitcher_");
  xg_GtkPlacesSidebar__symbol = C_string_to_Xen_symbol("GtkPlacesSidebar_");
  xg_GtkPlacesOpenFlags_symbol = C_string_to_Xen_symbol("GtkPlacesOpenFlags");
  xg_GtkBaselinePosition_symbol = C_string_to_Xen_symbol("GtkBaselinePosition");
  xg_GdkFullscreenMode_symbol = C_string_to_Xen_symbol("GdkFullscreenMode");
  xg_GtkInputHints_symbol = C_string_to_Xen_symbol("GtkInputHints");
  xg_GtkInputPurpose_symbol = C_string_to_Xen_symbol("GtkInputPurpose");
  xg_GtkLevelBarMode_symbol = C_string_to_Xen_symbol("GtkLevelBarMode");
  xg_GtkLevelBar__symbol = C_string_to_Xen_symbol("GtkLevelBar_");
  xg_GtkMenuButton__symbol = C_string_to_Xen_symbol("GtkMenuButton_");
  xg_GtkColorChooser__symbol = C_string_to_Xen_symbol("GtkColorChooser_");
  xg_GtkApplicationWindow__symbol = C_string_to_Xen_symbol("GtkApplicationWindow_");
  xg_GtkApplication__symbol = C_string_to_Xen_symbol("GtkApplication_");
  xg_GMenuModel__symbol = C_string_to_Xen_symbol("GMenuModel_");
  xg_guint___symbol = C_string_to_Xen_symbol("guint__");
  xg_GdkModifierIntent_symbol = C_string_to_Xen_symbol("GdkModifierIntent");
  xg_GtkFontChooser__symbol = C_string_to_Xen_symbol("GtkFontChooser_");
  xg_GdkScrollDirection_symbol = C_string_to_Xen_symbol("GdkScrollDirection");
  xg_GtkOverlay__symbol = C_string_to_Xen_symbol("GtkOverlay_");
  xg_GtkWidgetPath__symbol = C_string_to_Xen_symbol("GtkWidgetPath_");
  xg_GtkStateFlags_symbol = C_string_to_Xen_symbol("GtkStateFlags");
  xg_GtkToolShell__symbol = C_string_to_Xen_symbol("GtkToolShell_");
  xg_GtkWindowGroup__symbol = C_string_to_Xen_symbol("GtkWindowGroup_");
  xg_GIcon__symbol = C_string_to_Xen_symbol("GIcon_");
  xg_GtkOrientable__symbol = C_string_to_Xen_symbol("GtkOrientable_");
  xg_GtkCellArea__symbol = C_string_to_Xen_symbol("GtkCellArea_");
  xg_GtkBorder__symbol = C_string_to_Xen_symbol("GtkBorder_");
  xg_GtkSwitch__symbol = C_string_to_Xen_symbol("GtkSwitch_");
  xg_GtkScrollablePolicy_symbol = C_string_to_Xen_symbol("GtkScrollablePolicy");
  xg_GtkScrollable__symbol = C_string_to_Xen_symbol("GtkScrollable_");
  xg_GtkGrid__symbol = C_string_to_Xen_symbol("GtkGrid_");
  xg_GdkRGBA__symbol = C_string_to_Xen_symbol("GdkRGBA_");
  xg_GtkComboBoxText__symbol = C_string_to_Xen_symbol("GtkComboBoxText_");
  xg_GtkAlign_symbol = C_string_to_Xen_symbol("GtkAlign");
  xg_GtkSizeRequestMode_symbol = C_string_to_Xen_symbol("GtkSizeRequestMode");
  xg_cairo_region_overlap_t_symbol = C_string_to_Xen_symbol("cairo_region_overlap_t");
  xg_cairo_rectangle_int_t__symbol = C_string_to_Xen_symbol("cairo_rectangle_int_t_");
  xg_double__symbol = C_string_to_Xen_symbol("double_");
  xg_cairo_rectangle_t__symbol = C_string_to_Xen_symbol("cairo_rectangle_t_");
  xg_cairo_device_t__symbol = C_string_to_Xen_symbol("cairo_device_t_");
  xg_cairo_bool_t_symbol = C_string_to_Xen_symbol("cairo_bool_t");
  xg_cairo_text_cluster_flags_t__symbol = C_string_to_Xen_symbol("cairo_text_cluster_flags_t_");
  xg_cairo_text_cluster_t___symbol = C_string_to_Xen_symbol("cairo_text_cluster_t__");
  xg_cairo_glyph_t___symbol = C_string_to_Xen_symbol("cairo_glyph_t__");
  xg_cairo_text_cluster_flags_t_symbol = C_string_to_Xen_symbol("cairo_text_cluster_flags_t");
  xg_cairo_text_cluster_t__symbol = C_string_to_Xen_symbol("cairo_text_cluster_t_");
  xg_cairo_region_t__symbol = C_string_to_Xen_symbol("cairo_region_t_");
  xg_GtkMessageDialog__symbol = C_string_to_Xen_symbol("GtkMessageDialog_");
  xg_GdkDevice__symbol = C_string_to_Xen_symbol("GdkDevice_");
  xg_GtkAccessible__symbol = C_string_to_Xen_symbol("GtkAccessible_");
  xg_GdkModifierType__symbol = C_string_to_Xen_symbol("GdkModifierType_");
  xg_GtkDestDefaults_symbol = C_string_to_Xen_symbol("GtkDestDefaults");
  xg_GtkToolPaletteDragTargets_symbol = C_string_to_Xen_symbol("GtkToolPaletteDragTargets");
  xg_GtkToolItemGroup__symbol = C_string_to_Xen_symbol("GtkToolItemGroup_");
  xg_GtkToolPalette__symbol = C_string_to_Xen_symbol("GtkToolPalette_");
  xg_GtkPackType_symbol = C_string_to_Xen_symbol("GtkPackType");
  xg_GtkSpinner__symbol = C_string_to_Xen_symbol("GtkSpinner_");
  xg_GtkEntryBuffer__symbol = C_string_to_Xen_symbol("GtkEntryBuffer_");
  xg_GtkMessageType_symbol = C_string_to_Xen_symbol("GtkMessageType");
  xg_GtkInfoBar__symbol = C_string_to_Xen_symbol("GtkInfoBar_");
  xg_GtkEntryIconPosition_symbol = C_string_to_Xen_symbol("GtkEntryIconPosition");
  xg_GFile__symbol = C_string_to_Xen_symbol("GFile_");
  xg_GtkSensitivityType_symbol = C_string_to_Xen_symbol("GtkSensitivityType");
  xg_GtkScaleButton__symbol = C_string_to_Xen_symbol("GtkScaleButton_");
  xg_GtkCalendarDetailFunc_symbol = C_string_to_Xen_symbol("GtkCalendarDetailFunc");
  xg_GtkTooltip__symbol = C_string_to_Xen_symbol("GtkTooltip_");
  xg_cairo_rectangle_list_t__symbol = C_string_to_Xen_symbol("cairo_rectangle_list_t_");
  xg_void__symbol = C_string_to_Xen_symbol("void_");
  xg_cairo_filter_t_symbol = C_string_to_Xen_symbol("cairo_filter_t");
  xg_cairo_extend_t_symbol = C_string_to_Xen_symbol("cairo_extend_t");
  xg_cairo_format_t_symbol = C_string_to_Xen_symbol("cairo_format_t");
  xg_cairo_path_t__symbol = C_string_to_Xen_symbol("cairo_path_t_");
  xg_cairo_destroy_func_t_symbol = C_string_to_Xen_symbol("cairo_destroy_func_t");
  xg_cairo_user_data_key_t__symbol = C_string_to_Xen_symbol("cairo_user_data_key_t_");
  xg_cairo_text_extents_t__symbol = C_string_to_Xen_symbol("cairo_text_extents_t_");
  xg_cairo_font_extents_t__symbol = C_string_to_Xen_symbol("cairo_font_extents_t_");
  xg_cairo_font_face_t__symbol = C_string_to_Xen_symbol("cairo_font_face_t_");
  xg_cairo_glyph_t__symbol = C_string_to_Xen_symbol("cairo_glyph_t_");
  xg_cairo_scaled_font_t__symbol = C_string_to_Xen_symbol("cairo_scaled_font_t_");
  xg_cairo_font_weight_t_symbol = C_string_to_Xen_symbol("cairo_font_weight_t");
  xg_cairo_font_slant_t_symbol = C_string_to_Xen_symbol("cairo_font_slant_t");
  xg_cairo_hint_metrics_t_symbol = C_string_to_Xen_symbol("cairo_hint_metrics_t");
  xg_cairo_hint_style_t_symbol = C_string_to_Xen_symbol("cairo_hint_style_t");
  xg_cairo_subpixel_order_t_symbol = C_string_to_Xen_symbol("cairo_subpixel_order_t");
  xg_cairo_status_t_symbol = C_string_to_Xen_symbol("cairo_status_t");
  xg_bool_symbol = C_string_to_Xen_symbol("bool");
  xg_cairo_matrix_t__symbol = C_string_to_Xen_symbol("cairo_matrix_t_");
  xg_cairo_line_join_t_symbol = C_string_to_Xen_symbol("cairo_line_join_t");
  xg_cairo_line_cap_t_symbol = C_string_to_Xen_symbol("cairo_line_cap_t");
  xg_cairo_fill_rule_t_symbol = C_string_to_Xen_symbol("cairo_fill_rule_t");
  xg_cairo_antialias_t_symbol = C_string_to_Xen_symbol("cairo_antialias_t");
  xg_cairo_operator_t_symbol = C_string_to_Xen_symbol("cairo_operator_t");
  xg_cairo_pattern_t__symbol = C_string_to_Xen_symbol("cairo_pattern_t_");
  xg_cairo_content_t_symbol = C_string_to_Xen_symbol("cairo_content_t");
  xg_GtkPageSet_symbol = C_string_to_Xen_symbol("GtkPageSet");
  xg_GtkPageRange__symbol = C_string_to_Xen_symbol("GtkPageRange_");
  xg_GtkPrintPages_symbol = C_string_to_Xen_symbol("GtkPrintPages");
  xg_GtkPrintQuality_symbol = C_string_to_Xen_symbol("GtkPrintQuality");
  xg_GtkPrintDuplex_symbol = C_string_to_Xen_symbol("GtkPrintDuplex");
  xg_GtkPaperSize__symbol = C_string_to_Xen_symbol("GtkPaperSize_");
  xg_GtkPageOrientation_symbol = C_string_to_Xen_symbol("GtkPageOrientation");
  xg_GtkPrintSettingsFunc_symbol = C_string_to_Xen_symbol("GtkPrintSettingsFunc");
  xg_GtkPageSetupDoneFunc_symbol = C_string_to_Xen_symbol("GtkPageSetupDoneFunc");
  xg_GtkPrintStatus_symbol = C_string_to_Xen_symbol("GtkPrintStatus");
  xg_GtkPrintOperationAction_symbol = C_string_to_Xen_symbol("GtkPrintOperationAction");
  xg_GtkPrintOperationResult_symbol = C_string_to_Xen_symbol("GtkPrintOperationResult");
  xg_GtkUnit_symbol = C_string_to_Xen_symbol("GtkUnit");
  xg_GtkPrintSettings__symbol = C_string_to_Xen_symbol("GtkPrintSettings_");
  xg_GtkPrintOperation__symbol = C_string_to_Xen_symbol("GtkPrintOperation_");
  xg_GtkPageSetup__symbol = C_string_to_Xen_symbol("GtkPageSetup_");
  xg_GtkPrintContext__symbol = C_string_to_Xen_symbol("GtkPrintContext_");
  xg_cairo_surface_t__symbol = C_string_to_Xen_symbol("cairo_surface_t_");
  xg_GtkTreeViewGridLines_symbol = C_string_to_Xen_symbol("GtkTreeViewGridLines");
  xg_GtkRecentData__symbol = C_string_to_Xen_symbol("GtkRecentData_");
  xg_time_t_symbol = C_string_to_Xen_symbol("time_t");
  xg_GtkRecentChooserMenu__symbol = C_string_to_Xen_symbol("GtkRecentChooserMenu_");
  xg_GtkRecentManager__symbol = C_string_to_Xen_symbol("GtkRecentManager_");
  xg_GtkRecentFilter__symbol = C_string_to_Xen_symbol("GtkRecentFilter_");
  xg_GtkRecentSortFunc_symbol = C_string_to_Xen_symbol("GtkRecentSortFunc");
  xg_GtkRecentSortType_symbol = C_string_to_Xen_symbol("GtkRecentSortType");
  xg_GtkRecentChooser__symbol = C_string_to_Xen_symbol("GtkRecentChooser_");
  xg_GtkLinkButton__symbol = C_string_to_Xen_symbol("GtkLinkButton_");
  xg_GtkAssistantPageType_symbol = C_string_to_Xen_symbol("GtkAssistantPageType");
  xg_GtkAssistantPageFunc_symbol = C_string_to_Xen_symbol("GtkAssistantPageFunc");
  xg_GtkAssistant__symbol = C_string_to_Xen_symbol("GtkAssistant_");
  xg_GDestroyNotify_symbol = C_string_to_Xen_symbol("GDestroyNotify");
  xg_GtkTreeViewSearchPositionFunc_symbol = C_string_to_Xen_symbol("GtkTreeViewSearchPositionFunc");
  xg_GtkMenuBar__symbol = C_string_to_Xen_symbol("GtkMenuBar_");
  xg_GtkPackDirection_symbol = C_string_to_Xen_symbol("GtkPackDirection");
  xg_GtkIconViewDropPosition_symbol = C_string_to_Xen_symbol("GtkIconViewDropPosition");
  xg_GValue__symbol = C_string_to_Xen_symbol("GValue_");
  xg_GLogFunc_symbol = C_string_to_Xen_symbol("GLogFunc");
  xg_PangoMatrix__symbol = C_string_to_Xen_symbol("PangoMatrix_");
  xg_PangoRenderPart_symbol = C_string_to_Xen_symbol("PangoRenderPart");
  xg_PangoRenderer__symbol = C_string_to_Xen_symbol("PangoRenderer_");
  xg_GtkMenuToolButton__symbol = C_string_to_Xen_symbol("GtkMenuToolButton_");
  xg_GtkFileChooserButton__symbol = C_string_to_Xen_symbol("GtkFileChooserButton_");
  xg_PangoScriptIter__symbol = C_string_to_Xen_symbol("PangoScriptIter_");
  xg_PangoScript_symbol = C_string_to_Xen_symbol("PangoScript");
  xg_PangoAttrFilterFunc_symbol = C_string_to_Xen_symbol("PangoAttrFilterFunc");
  xg_PangoEllipsizeMode_symbol = C_string_to_Xen_symbol("PangoEllipsizeMode");
  xg_GtkIconViewForeachFunc_symbol = C_string_to_Xen_symbol("GtkIconViewForeachFunc");
  xg_GtkAboutDialog__symbol = C_string_to_Xen_symbol("GtkAboutDialog_");
  xg_GtkTreeViewRowSeparatorFunc_symbol = C_string_to_Xen_symbol("GtkTreeViewRowSeparatorFunc");
  xg_GtkCellView__symbol = C_string_to_Xen_symbol("GtkCellView_");
  xg_GtkAccelMap__symbol = C_string_to_Xen_symbol("GtkAccelMap_");
  xg_GtkOrientation_symbol = C_string_to_Xen_symbol("GtkOrientation");
  xg_GtkToolButton__symbol = C_string_to_Xen_symbol("GtkToolButton_");
  xg_GtkIconLookupFlags_symbol = C_string_to_Xen_symbol("GtkIconLookupFlags");
  xg_GtkIconInfo__symbol = C_string_to_Xen_symbol("GtkIconInfo_");
  xg_gchar___symbol = C_string_to_Xen_symbol("gchar__");
  xg_GtkIconTheme__symbol = C_string_to_Xen_symbol("GtkIconTheme_");
  xg_GtkFileChooser__symbol = C_string_to_Xen_symbol("GtkFileChooser_");
  xg_GtkCellLayoutDataFunc_symbol = C_string_to_Xen_symbol("GtkCellLayoutDataFunc");
  xg_GtkCellLayout__symbol = C_string_to_Xen_symbol("GtkCellLayout_");
  xg_GtkFileFilterFunc_symbol = C_string_to_Xen_symbol("GtkFileFilterFunc");
  xg_GtkFileFilterFlags_symbol = C_string_to_Xen_symbol("GtkFileFilterFlags");
  xg_GtkFileFilter__symbol = C_string_to_Xen_symbol("GtkFileFilter_");
  xg_GSourceFunc_symbol = C_string_to_Xen_symbol("GSourceFunc");
  xg_GtkToggleToolButton__symbol = C_string_to_Xen_symbol("GtkToggleToolButton_");
  xg_GtkSeparatorToolItem__symbol = C_string_to_Xen_symbol("GtkSeparatorToolItem_");
  xg_GtkRadioToolButton__symbol = C_string_to_Xen_symbol("GtkRadioToolButton_");
  xg_GtkEntryCompletionMatchFunc_symbol = C_string_to_Xen_symbol("GtkEntryCompletionMatchFunc");
  xg_GtkFontButton__symbol = C_string_to_Xen_symbol("GtkFontButton_");
  xg_GtkExpander__symbol = C_string_to_Xen_symbol("GtkExpander_");
  xg_GtkComboBox__symbol = C_string_to_Xen_symbol("GtkComboBox_");
  xg_GtkTreeModelFilter__symbol = C_string_to_Xen_symbol("GtkTreeModelFilter_");
  xg_GtkFileChooserAction_symbol = C_string_to_Xen_symbol("GtkFileChooserAction");
  xg_GtkToolItem__symbol = C_string_to_Xen_symbol("GtkToolItem_");
  xg_GtkCalendarDisplayOptions_symbol = C_string_to_Xen_symbol("GtkCalendarDisplayOptions");
  xg_GdkDisplay__symbol = C_string_to_Xen_symbol("GdkDisplay_");
  xg_PangoLayoutRun__symbol = C_string_to_Xen_symbol("PangoLayoutRun_");
  xg_PangoLayoutIter__symbol = C_string_to_Xen_symbol("PangoLayoutIter_");
  xg_PangoLayoutLine__symbol = C_string_to_Xen_symbol("PangoLayoutLine_");
  xg_int__symbol = C_string_to_Xen_symbol("int_");
  xg_PangoAlignment_symbol = C_string_to_Xen_symbol("PangoAlignment");
  xg_PangoWrapMode_symbol = C_string_to_Xen_symbol("PangoWrapMode");
  xg_PangoItem__symbol = C_string_to_Xen_symbol("PangoItem_");
  xg_PangoGlyphString__symbol = C_string_to_Xen_symbol("PangoGlyphString_");
  xg_PangoFontMap__symbol = C_string_to_Xen_symbol("PangoFontMap_");
  xg_PangoGlyph_symbol = C_string_to_Xen_symbol("PangoGlyph");
  xg_PangoFontFace__symbol = C_string_to_Xen_symbol("PangoFontFace_");
  xg_PangoFontFace___symbol = C_string_to_Xen_symbol("PangoFontFace__");
  xg_PangoFontFamily__symbol = C_string_to_Xen_symbol("PangoFontFamily_");
  xg_PangoFontMask_symbol = C_string_to_Xen_symbol("PangoFontMask");
  xg_PangoFontDescription___symbol = C_string_to_Xen_symbol("PangoFontDescription__");
  xg_PangoCoverageLevel_symbol = C_string_to_Xen_symbol("PangoCoverageLevel");
  xg_PangoCoverage__symbol = C_string_to_Xen_symbol("PangoCoverage_");
  xg_PangoFontMetrics__symbol = C_string_to_Xen_symbol("PangoFontMetrics_");
  xg_PangoFontset__symbol = C_string_to_Xen_symbol("PangoFontset_");
  xg_PangoFont__symbol = C_string_to_Xen_symbol("PangoFont_");
  xg_PangoFontFamily___symbol = C_string_to_Xen_symbol("PangoFontFamily__");
  xg_PangoLogAttr__symbol = C_string_to_Xen_symbol("PangoLogAttr_");
  xg_PangoAnalysis__symbol = C_string_to_Xen_symbol("PangoAnalysis_");
  xg_PangoAttrList___symbol = C_string_to_Xen_symbol("PangoAttrList__");
  xg_PangoAttrIterator__symbol = C_string_to_Xen_symbol("PangoAttrIterator_");
  xg_PangoRectangle__symbol = C_string_to_Xen_symbol("PangoRectangle_");
  xg_PangoUnderline_symbol = C_string_to_Xen_symbol("PangoUnderline");
  xg_PangoStretch_symbol = C_string_to_Xen_symbol("PangoStretch");
  xg_PangoVariant_symbol = C_string_to_Xen_symbol("PangoVariant");
  xg_PangoWeight_symbol = C_string_to_Xen_symbol("PangoWeight");
  xg_PangoStyle_symbol = C_string_to_Xen_symbol("PangoStyle");
  xg_guint16_symbol = C_string_to_Xen_symbol("guint16");
  xg_PangoAttribute__symbol = C_string_to_Xen_symbol("PangoAttribute_");
  xg_PangoAttrType_symbol = C_string_to_Xen_symbol("PangoAttrType");
  xg_PangoColor__symbol = C_string_to_Xen_symbol("PangoColor_");
  xg_GdkGravity_symbol = C_string_to_Xen_symbol("GdkGravity");
  xg_GtkWindowPosition_symbol = C_string_to_Xen_symbol("GtkWindowPosition");
  xg_GtkWindowType_symbol = C_string_to_Xen_symbol("GtkWindowType");
  xg_GtkWindow__symbol = C_string_to_Xen_symbol("GtkWindow_");
  xg_GtkTextDirection_symbol = C_string_to_Xen_symbol("GtkTextDirection");
  xg_PangoContext__symbol = C_string_to_Xen_symbol("PangoContext_");
  xg_AtkObject__symbol = C_string_to_Xen_symbol("AtkObject_");
  xg_GtkDirectionType_symbol = C_string_to_Xen_symbol("GtkDirectionType");
  xg_GtkViewport__symbol = C_string_to_Xen_symbol("GtkViewport_");
  xg_GtkTreeViewSearchEqualFunc_symbol = C_string_to_Xen_symbol("GtkTreeViewSearchEqualFunc");
  xg_GtkTreeViewDropPosition_symbol = C_string_to_Xen_symbol("GtkTreeViewDropPosition");
  xg_GtkTreeViewMappingFunc_symbol = C_string_to_Xen_symbol("GtkTreeViewMappingFunc");
  xg_GtkTreeViewColumnDropFunc_symbol = C_string_to_Xen_symbol("GtkTreeViewColumnDropFunc");
  xg_GtkTreeViewColumnSizing_symbol = C_string_to_Xen_symbol("GtkTreeViewColumnSizing");
  xg_GtkTreeCellDataFunc_symbol = C_string_to_Xen_symbol("GtkTreeCellDataFunc");
  xg_GtkTreeStore__symbol = C_string_to_Xen_symbol("GtkTreeStore_");
  xg_GtkTreeIterCompareFunc_symbol = C_string_to_Xen_symbol("GtkTreeIterCompareFunc");
  xg_GtkSortType_symbol = C_string_to_Xen_symbol("GtkSortType");
  xg_GtkTreeSortable__symbol = C_string_to_Xen_symbol("GtkTreeSortable_");
  xg_GtkTreeSelectionForeachFunc_symbol = C_string_to_Xen_symbol("GtkTreeSelectionForeachFunc");
  xg_GtkTreeModel___symbol = C_string_to_Xen_symbol("GtkTreeModel__");
  xg_GtkTreeSelectionFunc_symbol = C_string_to_Xen_symbol("GtkTreeSelectionFunc");
  xg_GtkSelectionMode_symbol = C_string_to_Xen_symbol("GtkSelectionMode");
  xg_GtkTreeModelSort__symbol = C_string_to_Xen_symbol("GtkTreeModelSort_");
  xg_GtkTreeModelForeachFunc_symbol = C_string_to_Xen_symbol("GtkTreeModelForeachFunc");
  xg_GtkTreeModelFlags_symbol = C_string_to_Xen_symbol("GtkTreeModelFlags");
  xg_GtkTreeRowReference__symbol = C_string_to_Xen_symbol("GtkTreeRowReference_");
  xg_GtkTreeDragDest__symbol = C_string_to_Xen_symbol("GtkTreeDragDest_");
  xg_GtkTreeDragSource__symbol = C_string_to_Xen_symbol("GtkTreeDragSource_");
  xg_GtkToolbarStyle_symbol = C_string_to_Xen_symbol("GtkToolbarStyle");
  xg_GtkToolbar__symbol = C_string_to_Xen_symbol("GtkToolbar_");
  xg_GtkToggleButton__symbol = C_string_to_Xen_symbol("GtkToggleButton_");
  xg_PangoTabArray__symbol = C_string_to_Xen_symbol("PangoTabArray_");
  xg_GtkWrapMode_symbol = C_string_to_Xen_symbol("GtkWrapMode");
  xg_GtkTextWindowType_symbol = C_string_to_Xen_symbol("GtkTextWindowType");
  xg_GtkTextView__symbol = C_string_to_Xen_symbol("GtkTextView_");
  xg_GtkTextTagTableForeach_symbol = C_string_to_Xen_symbol("GtkTextTagTableForeach");
  xg_GtkTextSearchFlags_symbol = C_string_to_Xen_symbol("GtkTextSearchFlags");
  xg_GtkTextCharPredicate_symbol = C_string_to_Xen_symbol("GtkTextCharPredicate");
  xg_GtkTextMark__symbol = C_string_to_Xen_symbol("GtkTextMark_");
  xg_GtkTextChildAnchor__symbol = C_string_to_Xen_symbol("GtkTextChildAnchor_");
  xg_GtkTextIter__symbol = C_string_to_Xen_symbol("GtkTextIter_");
  xg_GtkTextTagTable__symbol = C_string_to_Xen_symbol("GtkTextTagTable_");
  xg_GtkTextBuffer__symbol = C_string_to_Xen_symbol("GtkTextBuffer_");
  xg_GtkStatusbar__symbol = C_string_to_Xen_symbol("GtkStatusbar_");
  xg_GtkSpinType_symbol = C_string_to_Xen_symbol("GtkSpinType");
  xg_GtkSpinButtonUpdatePolicy_symbol = C_string_to_Xen_symbol("GtkSpinButtonUpdatePolicy");
  xg_GtkSpinButton__symbol = C_string_to_Xen_symbol("GtkSpinButton_");
  xg_GtkSizeGroupMode_symbol = C_string_to_Xen_symbol("GtkSizeGroupMode");
  xg_GtkSizeGroup__symbol = C_string_to_Xen_symbol("GtkSizeGroup_");
  xg_GtkSettings__symbol = C_string_to_Xen_symbol("GtkSettings_");
  xg_GtkSelectionData__symbol = C_string_to_Xen_symbol("GtkSelectionData_");
  xg_GtkCornerType_symbol = C_string_to_Xen_symbol("GtkCornerType");
  xg_GtkPolicyType_symbol = C_string_to_Xen_symbol("GtkPolicyType");
  xg_GtkScrolledWindow__symbol = C_string_to_Xen_symbol("GtkScrolledWindow_");
  xg_GtkScale__symbol = C_string_to_Xen_symbol("GtkScale_");
  xg_GtkRange__symbol = C_string_to_Xen_symbol("GtkRange_");
  xg_GtkRadioMenuItem__symbol = C_string_to_Xen_symbol("GtkRadioMenuItem_");
  xg_GtkRadioButton__symbol = C_string_to_Xen_symbol("GtkRadioButton_");
  xg_GtkProgressBar__symbol = C_string_to_Xen_symbol("GtkProgressBar_");
  xg_GtkPaned__symbol = C_string_to_Xen_symbol("GtkPaned_");
  xg_GtkPositionType_symbol = C_string_to_Xen_symbol("GtkPositionType");
  xg_GtkNotebook__symbol = C_string_to_Xen_symbol("GtkNotebook_");
  xg_GtkMenuShell__symbol = C_string_to_Xen_symbol("GtkMenuShell_");
  xg_gint__symbol = C_string_to_Xen_symbol("gint_");
  xg_GtkMenuItem__symbol = C_string_to_Xen_symbol("GtkMenuItem_");
  xg_GtkMenu__symbol = C_string_to_Xen_symbol("GtkMenu_");
  xg_PangoLanguage__symbol = C_string_to_Xen_symbol("PangoLanguage_");
  xg_GtkListStore__symbol = C_string_to_Xen_symbol("GtkListStore_");
  xg_GtkLayout__symbol = C_string_to_Xen_symbol("GtkLayout_");
  xg_GtkJustification_symbol = C_string_to_Xen_symbol("GtkJustification");
  xg_GtkLabel__symbol = C_string_to_Xen_symbol("GtkLabel_");
  xg_guint16__symbol = C_string_to_Xen_symbol("guint16_");
  xg_GtkIMContextSimple__symbol = C_string_to_Xen_symbol("GtkIMContextSimple_");
  xg_GdkEventKey__symbol = C_string_to_Xen_symbol("GdkEventKey_");
  xg_PangoAttrList__symbol = C_string_to_Xen_symbol("PangoAttrList_");
  xg_GtkIMContext__symbol = C_string_to_Xen_symbol("GtkIMContext_");
  xg_GtkImageType_symbol = C_string_to_Xen_symbol("GtkImageType");
  xg_GtkImage__symbol = C_string_to_Xen_symbol("GtkImage_");
  xg_GtkShadowType_symbol = C_string_to_Xen_symbol("GtkShadowType");
  xg_GtkFrame__symbol = C_string_to_Xen_symbol("GtkFrame_");
  xg_GtkFixed__symbol = C_string_to_Xen_symbol("GtkFixed_");
  xg_PangoLayout__symbol = C_string_to_Xen_symbol("PangoLayout_");
  xg_GtkEntry__symbol = C_string_to_Xen_symbol("GtkEntry_");
  xg_GtkEditable__symbol = C_string_to_Xen_symbol("GtkEditable_");
  xg_GdkAtom_symbol = C_string_to_Xen_symbol("GdkAtom");
  xg_etc_symbol = C_string_to_Xen_symbol("etc");
  xg_GtkDialog__symbol = C_string_to_Xen_symbol("GtkDialog_");
  xg_GtkCallback_symbol = C_string_to_Xen_symbol("GtkCallback");
  xg_GtkContainer__symbol = C_string_to_Xen_symbol("GtkContainer_");
  xg_GtkCheckMenuItem__symbol = C_string_to_Xen_symbol("GtkCheckMenuItem_");
  xg_GtkCellRendererToggle__symbol = C_string_to_Xen_symbol("GtkCellRendererToggle_");
  xg_GtkCellRendererText__symbol = C_string_to_Xen_symbol("GtkCellRendererText_");
  xg_GtkCellRendererState_symbol = C_string_to_Xen_symbol("GtkCellRendererState");
  xg_GtkCellEditable__symbol = C_string_to_Xen_symbol("GtkCellEditable_");
  xg_GtkCalendar__symbol = C_string_to_Xen_symbol("GtkCalendar_");
  xg_GtkReliefStyle_symbol = C_string_to_Xen_symbol("GtkReliefStyle");
  xg_GtkButton__symbol = C_string_to_Xen_symbol("GtkButton_");
  xg_GtkBox__symbol = C_string_to_Xen_symbol("GtkBox_");
  xg_GtkBin__symbol = C_string_to_Xen_symbol("GtkBin_");
  xg_GtkBindingSet__symbol = C_string_to_Xen_symbol("GtkBindingSet_");
  xg_GtkButtonBox__symbol = C_string_to_Xen_symbol("GtkButtonBox_");
  xg_GtkButtonBoxStyle_symbol = C_string_to_Xen_symbol("GtkButtonBoxStyle");
  xg_GtkAspectFrame__symbol = C_string_to_Xen_symbol("GtkAspectFrame_");
  xg_GtkAdjustment__symbol = C_string_to_Xen_symbol("GtkAdjustment_");
  xg_GtkAccelMapForeach_symbol = C_string_to_Xen_symbol("GtkAccelMapForeach");
  xg_GtkAccelLabel__symbol = C_string_to_Xen_symbol("GtkAccelLabel_");
  xg_GtkAccelGroupEntry__symbol = C_string_to_Xen_symbol("GtkAccelGroupEntry_");
  xg_lambda3_symbol = C_string_to_Xen_symbol("lambda3");
  xg_GSList__symbol = C_string_to_Xen_symbol("GSList_");
  xg_GObject__symbol = C_string_to_Xen_symbol("GObject_");
  xg_GtkAccelFlags_symbol = C_string_to_Xen_symbol("GtkAccelFlags");
  xg_GtkAccelGroup__symbol = C_string_to_Xen_symbol("GtkAccelGroup_");
  xg_GdkInterpType_symbol = C_string_to_Xen_symbol("GdkInterpType");
  xg_double_symbol = C_string_to_Xen_symbol("double");
  xg_gfloat_symbol = C_string_to_Xen_symbol("gfloat");
  xg_guchar_symbol = C_string_to_Xen_symbol("guchar");
  xg_char___symbol = C_string_to_Xen_symbol("char__");
  xg_GdkPixbufDestroyNotify_symbol = C_string_to_Xen_symbol("GdkPixbufDestroyNotify");
  xg_GError__symbol = C_string_to_Xen_symbol("GError_");
  xg_char__symbol = C_string_to_Xen_symbol("char_");
  xg_guchar__symbol = C_string_to_Xen_symbol("guchar_");
  xg_GdkPixbuf__symbol = C_string_to_Xen_symbol("GdkPixbuf_");
  xg_GdkColorspace_symbol = C_string_to_Xen_symbol("GdkColorspace");
  xg_GdkCursor__symbol = C_string_to_Xen_symbol("GdkCursor_");
  xg_GdkWindowTypeHint_symbol = C_string_to_Xen_symbol("GdkWindowTypeHint");
  xg_GdkWindowHints_symbol = C_string_to_Xen_symbol("GdkWindowHints");
  xg_GdkGeometry__symbol = C_string_to_Xen_symbol("GdkGeometry_");
  xg_GdkWindowEdge_symbol = C_string_to_Xen_symbol("GdkWindowEdge");
  xg_GdkWMFunction_symbol = C_string_to_Xen_symbol("GdkWMFunction");
  xg_GdkWMDecoration_symbol = C_string_to_Xen_symbol("GdkWMDecoration");
  xg_GdkEventMask_symbol = C_string_to_Xen_symbol("GdkEventMask");
  xg_GList__symbol = C_string_to_Xen_symbol("GList_");
  xg_GdkWindowState_symbol = C_string_to_Xen_symbol("GdkWindowState");
  xg_GdkFilterFunc_symbol = C_string_to_Xen_symbol("GdkFilterFunc");
  xg_GdkWindowType_symbol = C_string_to_Xen_symbol("GdkWindowType");
  xg_PangoDirection_symbol = C_string_to_Xen_symbol("PangoDirection");
  xg_GdkKeymapKey__symbol = C_string_to_Xen_symbol("GdkKeymapKey_");
  xg_GdkKeymap__symbol = C_string_to_Xen_symbol("GdkKeymap_");
  xg_GdkRectangle__symbol = C_string_to_Xen_symbol("GdkRectangle_");
  xg_GdkEventFunc_symbol = C_string_to_Xen_symbol("GdkEventFunc");
  xg_gdouble_symbol = C_string_to_Xen_symbol("gdouble");
  xg_guint32_symbol = C_string_to_Xen_symbol("guint32");
  xg_GdkDragAction_symbol = C_string_to_Xen_symbol("GdkDragAction");
  xg_GdkDragContext__symbol = C_string_to_Xen_symbol("GdkDragContext_");
  xg_GSignalMatchType_symbol = C_string_to_Xen_symbol("GSignalMatchType");
  xg_GConnectFlags_symbol = C_string_to_Xen_symbol("GConnectFlags");
  xg_GtkDestroyNotify_symbol = C_string_to_Xen_symbol("GtkDestroyNotify");
  xg_GSignalEmissionHook_symbol = C_string_to_Xen_symbol("GSignalEmissionHook");
  xg_gulong_symbol = C_string_to_Xen_symbol("gulong");
  xg_GSignalInvocationHint__symbol = C_string_to_Xen_symbol("GSignalInvocationHint_");
  xg_GQuark_symbol = C_string_to_Xen_symbol("GQuark");
  xg_guint__symbol = C_string_to_Xen_symbol("guint_");
  xg_GSignalQuery__symbol = C_string_to_Xen_symbol("GSignalQuery_");
  xg_GType__symbol = C_string_to_Xen_symbol("GType_");
  xg_GSignalCMarshaller_symbol = C_string_to_Xen_symbol("GSignalCMarshaller");
  xg_GSignalAccumulator_symbol = C_string_to_Xen_symbol("GSignalAccumulator");
  xg_GSignalFlags_symbol = C_string_to_Xen_symbol("GSignalFlags");
  xg_GType_symbol = C_string_to_Xen_symbol("GType");
  xg_GClosureNotify_symbol = C_string_to_Xen_symbol("GClosureNotify");
  xg_GCallback_symbol = C_string_to_Xen_symbol("GCallback");
  xg_GNormalizeMode_symbol = C_string_to_Xen_symbol("GNormalizeMode");
  xg_glong_symbol = C_string_to_Xen_symbol("glong");
  xg_gssize_symbol = C_string_to_Xen_symbol("gssize");
  xg_gsize_symbol = C_string_to_Xen_symbol("gsize");
  xg_gunichar__symbol = C_string_to_Xen_symbol("gunichar_");
  xg_void_symbol = C_string_to_Xen_symbol("void");
  xg_int_symbol = C_string_to_Xen_symbol("int");
  xg_GtkDrawingArea__symbol = C_string_to_Xen_symbol("GtkDrawingArea_");
  xg_GdkSeat__symbol = C_string_to_Xen_symbol("GdkSeat_");
  xg_gpointer_symbol = C_string_to_Xen_symbol("gpointer");
  xg_GtkRecentInfo__symbol = C_string_to_Xen_symbol("GtkRecentInfo_");
  xg_GLogLevelFlags_symbol = C_string_to_Xen_symbol("GLogLevelFlags");
  xg_GtkIconView__symbol = C_string_to_Xen_symbol("GtkIconView_");
  xg_GtkEntryCompletion__symbol = C_string_to_Xen_symbol("GtkEntryCompletion_");
  xg_GtkFileFilterInfo__symbol = C_string_to_Xen_symbol("GtkFileFilterInfo_");
  xg_GtkTreeSelection__symbol = C_string_to_Xen_symbol("GtkTreeSelection_");
  xg_GtkCellRenderer__symbol = C_string_to_Xen_symbol("GtkCellRenderer_");
  xg_gint_symbol = C_string_to_Xen_symbol("gint");
  xg_GtkTreeViewColumn__symbol = C_string_to_Xen_symbol("GtkTreeViewColumn_");
  xg_GtkTreeView__symbol = C_string_to_Xen_symbol("GtkTreeView_");
  xg_gunichar_symbol = C_string_to_Xen_symbol("gunichar");
  xg_GtkTreeIter__symbol = C_string_to_Xen_symbol("GtkTreeIter_");
  xg_GtkTreePath__symbol = C_string_to_Xen_symbol("GtkTreePath_");
  xg_GtkTreeModel__symbol = C_string_to_Xen_symbol("GtkTreeModel_");
  xg_gboolean_symbol = C_string_to_Xen_symbol("gboolean");
  xg_GdkModifierType_symbol = C_string_to_Xen_symbol("GdkModifierType");
  xg_guint_symbol = C_string_to_Xen_symbol("guint");
  xg_gchar__symbol = C_string_to_Xen_symbol("gchar_");
  xg_GtkTextTag__symbol = C_string_to_Xen_symbol("GtkTextTag_");
  xg_GdkXEvent__symbol = C_string_to_Xen_symbol("GdkXEvent_");
  xg_GtkWidget__symbol = C_string_to_Xen_symbol("GtkWidget_");
  xg_lambda_data_symbol = C_string_to_Xen_symbol("lambda_data");
  xg_GClosure__symbol = C_string_to_Xen_symbol("GClosure_");
  xg_GtkAccelKey__symbol = C_string_to_Xen_symbol("GtkAccelKey_");
  xg_GdkEventMotion__symbol = C_string_to_Xen_symbol("GdkEventMotion_");
  xg_gdouble__symbol = C_string_to_Xen_symbol("gdouble_");
  xg_GdkEventAny__symbol = C_string_to_Xen_symbol("GdkEventAny_");
  xg_GdkEvent__symbol = C_string_to_Xen_symbol("GdkEvent_");
  xg_GdkWindow__symbol = C_string_to_Xen_symbol("GdkWindow_");
  xg_cairo_t__symbol = C_string_to_Xen_symbol("cairo_t_");
  xg_cairo_font_options_t__symbol = C_string_to_Xen_symbol("cairo_font_options_t_");
  xg_PangoFontDescription__symbol = C_string_to_Xen_symbol("PangoFontDescription_");
  xg_GtkCellRendererPixbuf__symbol = C_string_to_Xen_symbol("GtkCellRendererPixbuf_");
  xg_GtkSeparator__symbol = C_string_to_Xen_symbol("GtkSeparator_");
  xg_GtkSeparatorMenuItem__symbol = C_string_to_Xen_symbol("GtkSeparatorMenuItem_");
  xg_GdkEventExpose__symbol = C_string_to_Xen_symbol("GdkEventExpose_");
  xg_GdkEventNoExpose__symbol = C_string_to_Xen_symbol("GdkEventNoExpose_");
  xg_GdkEventVisibility__symbol = C_string_to_Xen_symbol("GdkEventVisibility_");
  xg_GdkEventButton__symbol = C_string_to_Xen_symbol("GdkEventButton_");
  xg_GdkEventCrossing__symbol = C_string_to_Xen_symbol("GdkEventCrossing_");
  xg_GdkEventFocus__symbol = C_string_to_Xen_symbol("GdkEventFocus_");
  xg_GdkEventConfigure__symbol = C_string_to_Xen_symbol("GdkEventConfigure_");
  xg_GdkEventProperty__symbol = C_string_to_Xen_symbol("GdkEventProperty_");
  xg_GdkEventSelection__symbol = C_string_to_Xen_symbol("GdkEventSelection_");
  xg_GdkEventProximity__symbol = C_string_to_Xen_symbol("GdkEventProximity_");
  xg_GdkEventSetting__symbol = C_string_to_Xen_symbol("GdkEventSetting_");
  xg_GdkEventWindowState__symbol = C_string_to_Xen_symbol("GdkEventWindowState_");
  xg_GdkEventDND__symbol = C_string_to_Xen_symbol("GdkEventDND_");
  xg_GtkFileChooserDialog__symbol = C_string_to_Xen_symbol("GtkFileChooserDialog_");
  xg_GtkFileChooserWidget__symbol = C_string_to_Xen_symbol("GtkFileChooserWidget_");
  xg_GtkColorButton__symbol = C_string_to_Xen_symbol("GtkColorButton_");
  xg_GtkAccelMap_symbol = C_string_to_Xen_symbol("GtkAccelMap");
  xg_GtkCellRendererCombo__symbol = C_string_to_Xen_symbol("GtkCellRendererCombo_");
  xg_GtkCellRendererProgress__symbol = C_string_to_Xen_symbol("GtkCellRendererProgress_");
  xg_GtkCellRendererAccel__symbol = C_string_to_Xen_symbol("GtkCellRendererAccel_");
  xg_GtkCellRendererSpin__symbol = C_string_to_Xen_symbol("GtkCellRendererSpin_");
  xg_GtkRecentChooserDialog__symbol = C_string_to_Xen_symbol("GtkRecentChooserDialog_");
  xg_GtkRecentChooserWidget__symbol = C_string_to_Xen_symbol("GtkRecentChooserWidget_");
  xg_GtkCellRendererSpinner__symbol = C_string_to_Xen_symbol("GtkCellRendererSpinner_");
  xg_GtkFontChooserDialog__symbol = C_string_to_Xen_symbol("GtkFontChooserDialog_");
  xg_GtkFontChooserWidget__symbol = C_string_to_Xen_symbol("GtkFontChooserWidget_");
  xg_GtkColorChooserDialog__symbol = C_string_to_Xen_symbol("GtkColorChooserDialog_");
  xg_GtkColorWidget__symbol = C_string_to_Xen_symbol("GtkColorWidget_");
  xg_GtkGestureLongPress__symbol = C_string_to_Xen_symbol("GtkGestureLongPress_");
}

/* -------------------------------- strings -------------------------------- */

static void define_strings(void)
{
  
#define define_string(Name) Xen_define(Xg_pre #Name Xg_post, C_string_to_Xen_string(Name))
  define_string(GTK_PRINT_SETTINGS_PRINTER);
  define_string(GTK_PRINT_SETTINGS_ORIENTATION);
  define_string(GTK_PRINT_SETTINGS_PAPER_FORMAT);
  define_string(GTK_PRINT_SETTINGS_PAPER_WIDTH);
  define_string(GTK_PRINT_SETTINGS_PAPER_HEIGHT);
  define_string(GTK_PRINT_SETTINGS_N_COPIES);
  define_string(GTK_PRINT_SETTINGS_DEFAULT_SOURCE);
  define_string(GTK_PRINT_SETTINGS_QUALITY);
  define_string(GTK_PRINT_SETTINGS_RESOLUTION);
  define_string(GTK_PRINT_SETTINGS_USE_COLOR);
  define_string(GTK_PRINT_SETTINGS_DUPLEX);
  define_string(GTK_PRINT_SETTINGS_COLLATE);
  define_string(GTK_PRINT_SETTINGS_REVERSE);
  define_string(GTK_PRINT_SETTINGS_MEDIA_TYPE);
  define_string(GTK_PRINT_SETTINGS_DITHER);
  define_string(GTK_PRINT_SETTINGS_SCALE);
  define_string(GTK_PRINT_SETTINGS_PRINT_PAGES);
  define_string(GTK_PRINT_SETTINGS_PAGE_RANGES);
  define_string(GTK_PRINT_SETTINGS_PAGE_SET);
  define_string(GTK_PRINT_SETTINGS_FINISHINGS);
  define_string(GTK_PRINT_SETTINGS_NUMBER_UP);
  define_string(GTK_PRINT_SETTINGS_OUTPUT_BIN);
  define_string(GTK_PRINT_SETTINGS_OUTPUT_FILE_FORMAT);
  define_string(GTK_PRINT_SETTINGS_OUTPUT_URI);
#if GTK_CHECK_VERSION(3, 0, 0)
  define_string(GTK_STYLE_CLASS_HIGHLIGHT);
  define_string(GTK_STYLE_CLASS_FRAME);
  define_string(GTK_STYLE_CLASS_DND);
  define_string(GTK_STYLE_CLASS_HORIZONTAL);
  define_string(GTK_STYLE_CLASS_VERTICAL);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  define_string(GTK_LEVEL_BAR_OFFSET_FULL);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  define_string(GTK_STYLE_PROPERTY_BACKGROUND_COLOR);
  define_string(GTK_STYLE_PROPERTY_COLOR);
  define_string(GTK_STYLE_PROPERTY_FONT);
  define_string(GTK_STYLE_PROPERTY_PADDING);
  define_string(GTK_STYLE_PROPERTY_BORDER_WIDTH);
  define_string(GTK_STYLE_PROPERTY_MARGIN);
  define_string(GTK_STYLE_PROPERTY_BORDER_RADIUS);
  define_string(GTK_STYLE_PROPERTY_BORDER_STYLE);
  define_string(GTK_STYLE_PROPERTY_BORDER_COLOR);
  define_string(GTK_STYLE_PROPERTY_BACKGROUND_IMAGE);
  define_string(GTK_STYLE_CLASS_CELL);
  define_string(GTK_STYLE_CLASS_DIM_LABEL);
  define_string(GTK_STYLE_CLASS_ENTRY);
  define_string(GTK_STYLE_CLASS_LABEL);
  define_string(GTK_STYLE_CLASS_COMBOBOX_ENTRY);
  define_string(GTK_STYLE_CLASS_BUTTON);
  define_string(GTK_STYLE_CLASS_LIST);
  define_string(GTK_STYLE_CLASS_LIST_ROW);
  define_string(GTK_STYLE_CLASS_CALENDAR);
  define_string(GTK_STYLE_CLASS_SLIDER);
  define_string(GTK_STYLE_CLASS_BACKGROUND);
  define_string(GTK_STYLE_CLASS_RUBBERBAND);
  define_string(GTK_STYLE_CLASS_CSD);
  define_string(GTK_STYLE_CLASS_TOOLTIP);
  define_string(GTK_STYLE_CLASS_MENU);
  define_string(GTK_STYLE_CLASS_CONTEXT_MENU);
  define_string(GTK_STYLE_CLASS_TOUCH_SELECTION);
  define_string(GTK_STYLE_CLASS_MENUBAR);
  define_string(GTK_STYLE_CLASS_MENUITEM);
  define_string(GTK_STYLE_CLASS_TOOLBAR);
  define_string(GTK_STYLE_CLASS_PRIMARY_TOOLBAR);
  define_string(GTK_STYLE_CLASS_INLINE_TOOLBAR);
  define_string(GTK_STYLE_CLASS_STATUSBAR);
  define_string(GTK_STYLE_CLASS_RADIO);
  define_string(GTK_STYLE_CLASS_CHECK);
  define_string(GTK_STYLE_CLASS_DEFAULT);
  define_string(GTK_STYLE_CLASS_TROUGH);
  define_string(GTK_STYLE_CLASS_SCROLLBAR);
  define_string(GTK_STYLE_CLASS_SCROLLBARS_JUNCTION);
  define_string(GTK_STYLE_CLASS_SCALE);
  define_string(GTK_STYLE_CLASS_SCALE_HAS_MARKS_ABOVE);
  define_string(GTK_STYLE_CLASS_SCALE_HAS_MARKS_BELOW);
  define_string(GTK_STYLE_CLASS_HEADER);
  define_string(GTK_STYLE_CLASS_ACCELERATOR);
  define_string(GTK_STYLE_CLASS_RAISED);
  define_string(GTK_STYLE_CLASS_LINKED);
  define_string(GTK_STYLE_CLASS_DOCK);
  define_string(GTK_STYLE_CLASS_PROGRESSBAR);
  define_string(GTK_STYLE_CLASS_SPINNER);
  define_string(GTK_STYLE_CLASS_MARK);
  define_string(GTK_STYLE_CLASS_EXPANDER);
  define_string(GTK_STYLE_CLASS_SPINBUTTON);
  define_string(GTK_STYLE_CLASS_NOTEBOOK);
  define_string(GTK_STYLE_CLASS_VIEW);
  define_string(GTK_STYLE_CLASS_SIDEBAR);
  define_string(GTK_STYLE_CLASS_IMAGE);
  define_string(GTK_STYLE_CLASS_PANE_SEPARATOR);
  define_string(GTK_STYLE_CLASS_SEPARATOR);
  define_string(GTK_STYLE_CLASS_INFO);
  define_string(GTK_STYLE_CLASS_WARNING);
  define_string(GTK_STYLE_CLASS_QUESTION);
  define_string(GTK_STYLE_CLASS_ERROR);
  define_string(GTK_STYLE_CLASS_TOP);
  define_string(GTK_STYLE_CLASS_BOTTOM);
  define_string(GTK_STYLE_CLASS_LEFT);
  define_string(GTK_STYLE_CLASS_RIGHT);
  define_string(GTK_STYLE_CLASS_PULSE);
  define_string(GTK_STYLE_CLASS_ARROW);
  define_string(GTK_STYLE_CLASS_OSD);
  define_string(GTK_STYLE_CLASS_LEVEL_BAR);
  define_string(GTK_STYLE_CLASS_CURSOR_HANDLE);
  define_string(GTK_STYLE_CLASS_INSERTION_CURSOR);
  define_string(GTK_STYLE_CLASS_TITLEBAR);
  define_string(GTK_STYLE_CLASS_TITLE);
  define_string(GTK_STYLE_CLASS_SUBTITLE);
  define_string(GTK_STYLE_CLASS_NEEDS_ATTENTION);
  define_string(GTK_STYLE_CLASS_SUGGESTED_ACTION);
  define_string(GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
  define_string(GTK_STYLE_CLASS_POPOVER);
  define_string(GTK_STYLE_CLASS_POPUP);
  define_string(GTK_STYLE_CLASS_MESSAGE_DIALOG);
  define_string(GTK_STYLE_CLASS_FLAT);
  define_string(GTK_STYLE_CLASS_READ_ONLY);
  define_string(GTK_STYLE_CLASS_OVERSHOOT);
  define_string(GTK_STYLE_CLASS_UNDERSHOOT);
  define_string(GTK_STYLE_CLASS_PAPER);
  define_string(GTK_STYLE_CLASS_MONOSPACE);
  define_string(GTK_STYLE_CLASS_WIDE);
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
  define_string(CAIRO_MIME_TYPE_JPEG);
  define_string(CAIRO_MIME_TYPE_PNG);
  define_string(CAIRO_MIME_TYPE_JP2);
  define_string(CAIRO_MIME_TYPE_URI);
#endif

}

/* -------------------------------- lint -------------------------------- */

#if HAVE_SCHEME
typedef struct {const char *name, *type; int64_t value;} enummer_t;
static enummer_t enum_info[] = {
#if GTK_CHECK_VERSION(2, 0, 0)
        {"G_NORMALIZE_DEFAULT", "GNormalizeMode", G_NORMALIZE_DEFAULT},
        {"G_NORMALIZE_NFD", "GNormalizeMode", G_NORMALIZE_NFD},
        {"G_NORMALIZE_DEFAULT_COMPOSE", "GNormalizeMode", G_NORMALIZE_DEFAULT_COMPOSE},
        {"G_NORMALIZE_NFC", "GNormalizeMode", G_NORMALIZE_NFC},
        {"G_NORMALIZE_ALL", "GNormalizeMode", G_NORMALIZE_ALL},
        {"G_NORMALIZE_NFKD", "GNormalizeMode", G_NORMALIZE_NFKD},
        {"G_NORMALIZE_ALL_COMPOSE", "GNormalizeMode", G_NORMALIZE_ALL_COMPOSE},
        {"G_NORMALIZE_NFKC", "GNormalizeMode", G_NORMALIZE_NFKC},
        {"G_SIGNAL_RUN_FIRST", "GSignalFlags", G_SIGNAL_RUN_FIRST},
        {"G_SIGNAL_RUN_LAST", "GSignalFlags", G_SIGNAL_RUN_LAST},
        {"G_SIGNAL_RUN_CLEANUP", "GSignalFlags", G_SIGNAL_RUN_CLEANUP},
        {"G_SIGNAL_NO_RECURSE", "GSignalFlags", G_SIGNAL_NO_RECURSE},
        {"G_SIGNAL_DETAILED", "GSignalFlags", G_SIGNAL_DETAILED},
        {"G_SIGNAL_ACTION", "GSignalFlags", G_SIGNAL_ACTION},
        {"G_SIGNAL_NO_HOOKS", "GSignalFlags", G_SIGNAL_NO_HOOKS},
        {"G_CONNECT_AFTER", "GConnectFlags", G_CONNECT_AFTER},
        {"G_CONNECT_SWAPPED", "GConnectFlags", G_CONNECT_SWAPPED},
        {"G_SIGNAL_MATCH_ID", "GSignalMatchType", G_SIGNAL_MATCH_ID},
        {"G_SIGNAL_MATCH_DETAIL", "GSignalMatchType", G_SIGNAL_MATCH_DETAIL},
        {"G_SIGNAL_MATCH_CLOSURE", "GSignalMatchType", G_SIGNAL_MATCH_CLOSURE},
        {"G_SIGNAL_MATCH_FUNC", "GSignalMatchType", G_SIGNAL_MATCH_FUNC},
        {"G_SIGNAL_MATCH_DATA", "GSignalMatchType", G_SIGNAL_MATCH_DATA},
        {"G_SIGNAL_MATCH_UNBLOCKED", "GSignalMatchType", G_SIGNAL_MATCH_UNBLOCKED},
        {"GDK_FILTER_CONTINUE", "GdkFilterReturn", GDK_FILTER_CONTINUE},
        {"GDK_FILTER_TRANSLATE", "GdkFilterReturn", GDK_FILTER_TRANSLATE},
        {"GDK_FILTER_REMOVE", "GdkFilterReturn", GDK_FILTER_REMOVE},
        {"GDK_ACTION_DEFAULT", "GdkDragAction", GDK_ACTION_DEFAULT},
        {"GDK_ACTION_COPY", "GdkDragAction", GDK_ACTION_COPY},
        {"GDK_ACTION_MOVE", "GdkDragAction", GDK_ACTION_MOVE},
        {"GDK_ACTION_LINK", "GdkDragAction", GDK_ACTION_LINK},
        {"GDK_ACTION_PRIVATE", "GdkDragAction", GDK_ACTION_PRIVATE},
        {"GDK_ACTION_ASK", "GdkDragAction", GDK_ACTION_ASK},
        {"GDK_NOTHING", "GdkEventType", GDK_NOTHING},
        {"GDK_DELETE", "GdkEventType", GDK_DELETE},
        {"GDK_DESTROY", "GdkEventType", GDK_DESTROY},
        {"GDK_EXPOSE", "GdkEventType", GDK_EXPOSE},
        {"GDK_MOTION_NOTIFY", "GdkEventType", GDK_MOTION_NOTIFY},
        {"GDK_BUTTON_PRESS", "GdkEventType", GDK_BUTTON_PRESS},
        {"GDK_BUTTON_RELEASE", "GdkEventType", GDK_BUTTON_RELEASE},
        {"GDK_KEY_PRESS", "GdkEventType", GDK_KEY_PRESS},
        {"GDK_KEY_RELEASE", "GdkEventType", GDK_KEY_RELEASE},
        {"GDK_ENTER_NOTIFY", "GdkEventType", GDK_ENTER_NOTIFY},
        {"GDK_LEAVE_NOTIFY", "GdkEventType", GDK_LEAVE_NOTIFY},
        {"GDK_FOCUS_CHANGE", "GdkEventType", GDK_FOCUS_CHANGE},
        {"GDK_CONFIGURE", "GdkEventType", GDK_CONFIGURE},
        {"GDK_MAP", "GdkEventType", GDK_MAP},
        {"GDK_UNMAP", "GdkEventType", GDK_UNMAP},
        {"GDK_PROXIMITY_IN", "GdkEventType", GDK_PROXIMITY_IN},
        {"GDK_PROXIMITY_OUT", "GdkEventType", GDK_PROXIMITY_OUT},
        {"GDK_DRAG_ENTER", "GdkEventType", GDK_DRAG_ENTER},
        {"GDK_DRAG_LEAVE", "GdkEventType", GDK_DRAG_LEAVE},
        {"GDK_DRAG_MOTION", "GdkEventType", GDK_DRAG_MOTION},
        {"GDK_DROP_START", "GdkEventType", GDK_DROP_START},
        {"GDK_SCROLL", "GdkEventType", GDK_SCROLL},
        {"GDK_GRAB_BROKEN", "GdkEventType", GDK_GRAB_BROKEN},
        {"GDK_EXPOSURE_MASK", "GdkEventMask", GDK_EXPOSURE_MASK},
        {"GDK_POINTER_MOTION_MASK", "GdkEventMask", GDK_POINTER_MOTION_MASK},
        {"GDK_BUTTON_MOTION_MASK", "GdkEventMask", GDK_BUTTON_MOTION_MASK},
        {"GDK_BUTTON1_MOTION_MASK", "GdkEventMask", GDK_BUTTON1_MOTION_MASK},
        {"GDK_BUTTON2_MOTION_MASK", "GdkEventMask", GDK_BUTTON2_MOTION_MASK},
        {"GDK_BUTTON3_MOTION_MASK", "GdkEventMask", GDK_BUTTON3_MOTION_MASK},
        {"GDK_BUTTON_PRESS_MASK", "GdkEventMask", GDK_BUTTON_PRESS_MASK},
        {"GDK_BUTTON_RELEASE_MASK", "GdkEventMask", GDK_BUTTON_RELEASE_MASK},
        {"GDK_KEY_PRESS_MASK", "GdkEventMask", GDK_KEY_PRESS_MASK},
        {"GDK_KEY_RELEASE_MASK", "GdkEventMask", GDK_KEY_RELEASE_MASK},
        {"GDK_ENTER_NOTIFY_MASK", "GdkEventMask", GDK_ENTER_NOTIFY_MASK},
        {"GDK_LEAVE_NOTIFY_MASK", "GdkEventMask", GDK_LEAVE_NOTIFY_MASK},
        {"GDK_FOCUS_CHANGE_MASK", "GdkEventMask", GDK_FOCUS_CHANGE_MASK},
        {"GDK_STRUCTURE_MASK", "GdkEventMask", GDK_STRUCTURE_MASK},
        {"GDK_PROPERTY_CHANGE_MASK", "GdkEventMask", GDK_PROPERTY_CHANGE_MASK},
        {"GDK_PROXIMITY_IN_MASK", "GdkEventMask", GDK_PROXIMITY_IN_MASK},
        {"GDK_PROXIMITY_OUT_MASK", "GdkEventMask", GDK_PROXIMITY_OUT_MASK},
        {"GDK_SUBSTRUCTURE_MASK", "GdkEventMask", GDK_SUBSTRUCTURE_MASK},
        {"GDK_SCROLL_MASK", "GdkEventMask", GDK_SCROLL_MASK},
        {"GDK_SCROLL_UP", "GdkScrollDirection", GDK_SCROLL_UP},
        {"GDK_SCROLL_DOWN", "GdkScrollDirection", GDK_SCROLL_DOWN},
        {"GDK_SCROLL_LEFT", "GdkScrollDirection", GDK_SCROLL_LEFT},
        {"GDK_SCROLL_RIGHT", "GdkScrollDirection", GDK_SCROLL_RIGHT},
        {"GDK_NOTIFY_ANCESTOR", "GdkNotifyType", GDK_NOTIFY_ANCESTOR},
        {"GDK_NOTIFY_VIRTUAL", "GdkNotifyType", GDK_NOTIFY_VIRTUAL},
        {"GDK_NOTIFY_INFERIOR", "GdkNotifyType", GDK_NOTIFY_INFERIOR},
        {"GDK_NOTIFY_NONLINEAR", "GdkNotifyType", GDK_NOTIFY_NONLINEAR},
        {"GDK_NOTIFY_NONLINEAR_VIRTUAL", "GdkNotifyType", GDK_NOTIFY_NONLINEAR_VIRTUAL},
        {"GDK_NOTIFY_UNKNOWN", "GdkNotifyType", GDK_NOTIFY_UNKNOWN},
        {"GDK_CROSSING_NORMAL", "GdkCrossingMode", GDK_CROSSING_NORMAL},
        {"GDK_CROSSING_GRAB", "GdkNotifyType", GDK_CROSSING_GRAB},
        {"GDK_CROSSING_UNGRAB", "GdkNotifyType", GDK_CROSSING_UNGRAB},
        {"GDK_WINDOW_STATE_WITHDRAWN", "GdkWindowState", GDK_WINDOW_STATE_WITHDRAWN},
        {"GDK_WINDOW_STATE_ICONIFIED", "GdkWindowState", GDK_WINDOW_STATE_ICONIFIED},
        {"GDK_WINDOW_STATE_MAXIMIZED", "GdkWindowState", GDK_WINDOW_STATE_MAXIMIZED},
        {"GDK_WINDOW_STATE_STICKY", "GdkWindowState", GDK_WINDOW_STATE_STICKY},
        {"GDK_LSB_FIRST", "GdkByteOrder", GDK_LSB_FIRST},
        {"GDK_MSB_FIRST", "GdkByteOrder", GDK_MSB_FIRST},
        {"GDK_SHIFT_MASK", "GdkModifierType", GDK_SHIFT_MASK},
        {"GDK_LOCK_MASK", "GdkModifierType", GDK_LOCK_MASK},
        {"GDK_CONTROL_MASK", "GdkModifierType", GDK_CONTROL_MASK},
        {"GDK_MOD1_MASK", "GdkModifierType", GDK_MOD1_MASK},
        {"GDK_MOD2_MASK", "GdkModifierType", GDK_MOD2_MASK},
        {"GDK_MOD3_MASK", "GdkModifierType", GDK_MOD3_MASK},
        {"GDK_MOD4_MASK", "GdkModifierType", GDK_MOD4_MASK},
        {"GDK_MOD5_MASK", "GdkModifierType", GDK_MOD5_MASK},
        {"GDK_BUTTON1_MASK", "GdkModifierType", GDK_BUTTON1_MASK},
        {"GDK_BUTTON2_MASK", "GdkModifierType", GDK_BUTTON2_MASK},
        {"GDK_BUTTON3_MASK", "GdkModifierType", GDK_BUTTON3_MASK},
        {"GDK_BUTTON4_MASK", "GdkModifierType", GDK_BUTTON4_MASK},
        {"GDK_BUTTON5_MASK", "GdkModifierType", GDK_BUTTON5_MASK},
        {"GDK_RELEASE_MASK", "GdkModifierType", GDK_RELEASE_MASK},
        {"GDK_MODIFIER_MASK", "GdkModifierType", GDK_MODIFIER_MASK},
        {"GDK_OK", "GdkStatus", GDK_OK},
        {"GDK_ERROR", "GdkStatus", GDK_ERROR},
        {"GDK_ERROR_PARAM", "GdkStatus", GDK_ERROR_PARAM},
        {"GDK_ERROR_FILE", "GdkStatus", GDK_ERROR_FILE},
        {"GDK_ERROR_MEM", "GdkStatus", GDK_ERROR_MEM},
        {"GDK_GRAB_SUCCESS", "GdkGrabStatus", GDK_GRAB_SUCCESS},
        {"GDK_GRAB_ALREADY_GRABBED", "GdkGrabStatus", GDK_GRAB_ALREADY_GRABBED},
        {"GDK_GRAB_INVALID_TIME", "GdkGrabStatus", GDK_GRAB_INVALID_TIME},
        {"GDK_GRAB_NOT_VIEWABLE", "GdkGrabStatus", GDK_GRAB_NOT_VIEWABLE},
        {"GDK_GRAB_FROZEN", "GdkGrabStatus", GDK_GRAB_FROZEN},
        {"GDK_WINDOW_ROOT", "GdkWindowType", GDK_WINDOW_ROOT},
        {"GDK_WINDOW_TOPLEVEL", "GdkWindowType", GDK_WINDOW_TOPLEVEL},
        {"GDK_WINDOW_CHILD", "GdkWindowType", GDK_WINDOW_CHILD},
        {"GDK_WINDOW_TEMP", "GdkWindowType", GDK_WINDOW_TEMP},
        {"GDK_WINDOW_FOREIGN", "GdkWindowType", GDK_WINDOW_FOREIGN},
        {"GDK_HINT_POS", "GdkWindowHints", GDK_HINT_POS},
        {"GDK_HINT_MIN_SIZE", "GdkWindowHints", GDK_HINT_MIN_SIZE},
        {"GDK_HINT_MAX_SIZE", "GdkWindowHints", GDK_HINT_MAX_SIZE},
        {"GDK_HINT_BASE_SIZE", "GdkWindowHints", GDK_HINT_BASE_SIZE},
        {"GDK_HINT_ASPECT", "GdkWindowHints", GDK_HINT_ASPECT},
        {"GDK_HINT_RESIZE_INC", "GdkWindowHints", GDK_HINT_RESIZE_INC},
        {"GDK_HINT_WIN_GRAVITY", "GdkWindowHints", GDK_HINT_WIN_GRAVITY},
        {"GDK_HINT_USER_POS", "GdkWindowHints", GDK_HINT_USER_POS},
        {"GDK_HINT_USER_SIZE", "GdkWindowHints", GDK_HINT_USER_SIZE},
        {"GDK_WINDOW_TYPE_HINT_NORMAL", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_NORMAL},
        {"GDK_WINDOW_TYPE_HINT_DIALOG", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DIALOG},
        {"GDK_WINDOW_TYPE_HINT_MENU", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_MENU},
        {"GDK_WINDOW_TYPE_HINT_TOOLBAR", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_TOOLBAR},
        {"GDK_DECOR_ALL", "GdkWMDecoration", GDK_DECOR_ALL},
        {"GDK_DECOR_BORDER", "GdkWMDecoration", GDK_DECOR_BORDER},
        {"GDK_DECOR_RESIZEH", "GdkWMDecoration", GDK_DECOR_RESIZEH},
        {"GDK_DECOR_TITLE", "GdkWMDecoration", GDK_DECOR_TITLE},
        {"GDK_DECOR_MENU", "GdkWMDecoration", GDK_DECOR_MENU},
        {"GDK_DECOR_MINIMIZE", "GdkWMDecoration", GDK_DECOR_MINIMIZE},
        {"GDK_DECOR_MAXIMIZE", "GdkWMDecoration", GDK_DECOR_MAXIMIZE},
        {"GDK_FUNC_ALL", "GdkWMFunction", GDK_FUNC_ALL},
        {"GDK_FUNC_RESIZE", "GdkWMFunction", GDK_FUNC_RESIZE},
        {"GDK_FUNC_MOVE", "GdkWMFunction", GDK_FUNC_MOVE},
        {"GDK_FUNC_MINIMIZE", "GdkWMFunction", GDK_FUNC_MINIMIZE},
        {"GDK_FUNC_MAXIMIZE", "GdkWMFunction", GDK_FUNC_MAXIMIZE},
        {"GDK_FUNC_CLOSE", "GdkWMFunction", GDK_FUNC_CLOSE},
        {"GDK_GRAVITY_NORTH_WEST", "GdkGravity", GDK_GRAVITY_NORTH_WEST},
        {"GDK_GRAVITY_NORTH", "GdkGravity", GDK_GRAVITY_NORTH},
        {"GDK_GRAVITY_NORTH_EAST", "GdkGravity", GDK_GRAVITY_NORTH_EAST},
        {"GDK_GRAVITY_WEST", "GdkGravity", GDK_GRAVITY_WEST},
        {"GDK_GRAVITY_CENTER", "GdkGravity", GDK_GRAVITY_CENTER},
        {"GDK_GRAVITY_EAST", "GdkGravity", GDK_GRAVITY_EAST},
        {"GDK_GRAVITY_SOUTH_WEST", "GdkGravity", GDK_GRAVITY_SOUTH_WEST},
        {"GDK_GRAVITY_SOUTH", "GdkGravity", GDK_GRAVITY_SOUTH},
        {"GDK_GRAVITY_SOUTH_EAST", "GdkGravity", GDK_GRAVITY_SOUTH_EAST},
        {"GDK_GRAVITY_STATIC", "GdkGravity", GDK_GRAVITY_STATIC},
        {"GDK_WINDOW_EDGE_NORTH_WEST", "GdkWindowEdge", GDK_WINDOW_EDGE_NORTH_WEST},
        {"GDK_WINDOW_EDGE_NORTH", "GdkWindowEdge", GDK_WINDOW_EDGE_NORTH},
        {"GDK_WINDOW_EDGE_NORTH_EAST", "GdkWindowEdge", GDK_WINDOW_EDGE_NORTH_EAST},
        {"GDK_WINDOW_EDGE_WEST", "GdkWindowEdge", GDK_WINDOW_EDGE_WEST},
        {"GDK_WINDOW_EDGE_EAST", "GdkWindowEdge", GDK_WINDOW_EDGE_EAST},
        {"GDK_WINDOW_EDGE_SOUTH_WEST", "GdkWindowEdge", GDK_WINDOW_EDGE_SOUTH_WEST},
        {"GDK_WINDOW_EDGE_SOUTH", "GdkWindowEdge", GDK_WINDOW_EDGE_SOUTH},
        {"GDK_WINDOW_EDGE_SOUTH_EAST", "GdkWindowEdge", GDK_WINDOW_EDGE_SOUTH_EAST},
        {"GDK_PIXBUF_ALPHA_BILEVEL", "GdkPixbufAlphaMode", GDK_PIXBUF_ALPHA_BILEVEL},
        {"GDK_PIXBUF_ALPHA_FULL", "GdkPixbufAlphaMode", GDK_PIXBUF_ALPHA_FULL},
        {"GDK_COLORSPACE_RGB", "GdkColorspace", GDK_COLORSPACE_RGB},
        {"GDK_PIXBUF_ERROR_CORRUPT_IMAGE", "GdkPixbufError", GDK_PIXBUF_ERROR_CORRUPT_IMAGE},
        {"GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY", "GdkPixbufError", GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY},
        {"GDK_PIXBUF_ERROR_BAD_OPTION", "GdkPixbufError", GDK_PIXBUF_ERROR_BAD_OPTION},
        {"GDK_PIXBUF_ERROR_UNKNOWN_TYPE", "GdkPixbufError", GDK_PIXBUF_ERROR_UNKNOWN_TYPE},
        {"GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION", "GdkPixbufError", GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION},
        {"GDK_PIXBUF_ERROR_FAILED", "GdkPixbufError", GDK_PIXBUF_ERROR_FAILED},
        {"GDK_INTERP_NEAREST", "GdkInterpType", GDK_INTERP_NEAREST},
        {"GDK_INTERP_TILES", "GdkInterpType", GDK_INTERP_TILES},
        {"GDK_INTERP_BILINEAR", "GdkInterpType", GDK_INTERP_BILINEAR},
        {"GDK_INTERP_HYPER", "GdkInterpType", GDK_INTERP_HYPER},
        {"GTK_ACCEL_VISIBLE", "GtkAccelFlags", GTK_ACCEL_VISIBLE},
        {"GTK_ACCEL_LOCKED", "GtkAccelFlags", GTK_ACCEL_LOCKED},
        {"GTK_ACCEL_MASK", "GtkAccelFlags", GTK_ACCEL_MASK},
        {"GTK_CALENDAR_SHOW_HEADING", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_HEADING},
        {"GTK_CALENDAR_SHOW_DAY_NAMES", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_DAY_NAMES},
        {"GTK_CALENDAR_NO_MONTH_CHANGE", "GtkCalendarDisplayOptions", GTK_CALENDAR_NO_MONTH_CHANGE},
        {"GTK_CALENDAR_SHOW_WEEK_NUMBERS", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_WEEK_NUMBERS},
        {"GTK_CELL_RENDERER_SELECTED", "GtkCellRendererState", GTK_CELL_RENDERER_SELECTED},
        {"GTK_CELL_RENDERER_PRELIT", "GtkCellRendererState", GTK_CELL_RENDERER_PRELIT},
        {"GTK_CELL_RENDERER_INSENSITIVE", "GtkCellRendererState", GTK_CELL_RENDERER_INSENSITIVE},
        {"GTK_CELL_RENDERER_SORTED", "GtkCellRendererState", GTK_CELL_RENDERER_SORTED},
        {"GTK_CELL_RENDERER_FOCUSED", "GtkCellRendererState", GTK_CELL_RENDERER_FOCUSED},
        {"GTK_DIALOG_MODAL", "GtkDialogFlags", GTK_DIALOG_MODAL},
        {"GTK_DIALOG_DESTROY_WITH_PARENT", "GtkDialogFlags", GTK_DIALOG_DESTROY_WITH_PARENT},
        {"GTK_RESPONSE_NONE", "GtkResponseType", GTK_RESPONSE_NONE},
        {"GTK_RESPONSE_REJECT", "GtkResponseType", GTK_RESPONSE_REJECT},
        {"GTK_RESPONSE_ACCEPT", "GtkResponseType", GTK_RESPONSE_ACCEPT},
        {"GTK_RESPONSE_DELETE_EVENT", "GtkResponseType", GTK_RESPONSE_DELETE_EVENT},
        {"GTK_RESPONSE_OK", "GtkResponseType", GTK_RESPONSE_OK},
        {"GTK_RESPONSE_CANCEL", "GtkResponseType", GTK_RESPONSE_CANCEL},
        {"GTK_RESPONSE_CLOSE", "GtkResponseType", GTK_RESPONSE_CLOSE},
        {"GTK_RESPONSE_YES", "GtkResponseType", GTK_RESPONSE_YES},
        {"GTK_RESPONSE_NO", "GtkResponseType", GTK_RESPONSE_NO},
        {"GTK_RESPONSE_APPLY", "GtkResponseType", GTK_RESPONSE_APPLY},
        {"GTK_RESPONSE_HELP", "GtkResponseType", GTK_RESPONSE_HELP},
        {"GTK_DEST_DEFAULT_MOTION", "GtkDestDefaults", GTK_DEST_DEFAULT_MOTION},
        {"GTK_DEST_DEFAULT_HIGHLIGHT", "GtkDestDefaults", GTK_DEST_DEFAULT_HIGHLIGHT},
        {"GTK_DEST_DEFAULT_DROP", "GtkDestDefaults", GTK_DEST_DEFAULT_DROP},
        {"GTK_DEST_DEFAULT_ALL", "GtkDestDefaults", GTK_DEST_DEFAULT_ALL},
        {"GTK_BUTTONBOX_SPREAD", "GtkButtonBoxStyle", GTK_BUTTONBOX_SPREAD},
        {"GTK_BUTTONBOX_EDGE", "GtkButtonBoxStyle", GTK_BUTTONBOX_EDGE},
        {"GTK_BUTTONBOX_START", "GtkButtonBoxStyle", GTK_BUTTONBOX_START},
        {"GTK_BUTTONBOX_END", "GtkButtonBoxStyle", GTK_BUTTONBOX_END},
        {"GTK_BUTTONBOX_CENTER", "GtkButtonBoxStyle", GTK_BUTTONBOX_CENTER},
        {"GTK_DELETE_CHARS", "GtkDeleteType", GTK_DELETE_CHARS},
        {"GTK_DELETE_WORD_ENDS", "GtkDeleteType", GTK_DELETE_WORD_ENDS},
        {"GTK_DELETE_WORDS", "GtkDeleteType", GTK_DELETE_WORDS},
        {"GTK_DELETE_DISPLAY_LINES", "GtkDeleteType", GTK_DELETE_DISPLAY_LINES},
        {"GTK_DELETE_DISPLAY_LINE_ENDS", "GtkDeleteType", GTK_DELETE_DISPLAY_LINE_ENDS},
        {"GTK_DELETE_PARAGRAPH_ENDS", "GtkDeleteType", GTK_DELETE_PARAGRAPH_ENDS},
        {"GTK_DELETE_PARAGRAPHS", "GtkDeleteType", GTK_DELETE_PARAGRAPHS},
        {"GTK_DELETE_WHITESPACE", "GtkDeleteType", GTK_DELETE_WHITESPACE},
        {"GTK_DIR_TAB_FORWARD", "GtkDirectionType", GTK_DIR_TAB_FORWARD},
        {"GTK_DIR_TAB_BACKWARD", "GtkDirectionType", GTK_DIR_TAB_BACKWARD},
        {"GTK_DIR_UP", "GtkDirectionType", GTK_DIR_UP},
        {"GTK_DIR_DOWN", "GtkDirectionType", GTK_DIR_DOWN},
        {"GTK_DIR_LEFT", "GtkDirectionType", GTK_DIR_LEFT},
        {"GTK_DIR_RIGHT", "GtkDirectionType", GTK_DIR_RIGHT},
        {"GTK_TEXT_DIR_NONE", "GtkTextDirection", GTK_TEXT_DIR_NONE},
        {"GTK_TEXT_DIR_LTR", "GtkTextDirection", GTK_TEXT_DIR_LTR},
        {"GTK_TEXT_DIR_RTL", "GtkTextDirection", GTK_TEXT_DIR_RTL},
        {"GTK_JUSTIFY_LEFT", "GtkJustification", GTK_JUSTIFY_LEFT},
        {"GTK_JUSTIFY_RIGHT", "GtkJustification", GTK_JUSTIFY_RIGHT},
        {"GTK_JUSTIFY_CENTER", "GtkJustification", GTK_JUSTIFY_CENTER},
        {"GTK_JUSTIFY_FILL", "GtkJustification", GTK_JUSTIFY_FILL},
        {"GTK_MENU_DIR_PARENT", "GtkMenuDirectionType", GTK_MENU_DIR_PARENT},
        {"GTK_MENU_DIR_CHILD", "GtkMenuDirectionType", GTK_MENU_DIR_CHILD},
        {"GTK_MENU_DIR_NEXT", "GtkMenuDirectionType", GTK_MENU_DIR_NEXT},
        {"GTK_MENU_DIR_PREV", "GtkMenuDirectionType", GTK_MENU_DIR_PREV},
        {"GTK_MOVEMENT_LOGICAL_POSITIONS", "GtkMovementStep", GTK_MOVEMENT_LOGICAL_POSITIONS},
        {"GTK_MOVEMENT_VISUAL_POSITIONS", "GtkMovementStep", GTK_MOVEMENT_VISUAL_POSITIONS},
        {"GTK_MOVEMENT_WORDS", "GtkMovementStep", GTK_MOVEMENT_WORDS},
        {"GTK_MOVEMENT_DISPLAY_LINES", "GtkMovementStep", GTK_MOVEMENT_DISPLAY_LINES},
        {"GTK_MOVEMENT_DISPLAY_LINE_ENDS", "GtkMovementStep", GTK_MOVEMENT_DISPLAY_LINE_ENDS},
        {"GTK_MOVEMENT_PARAGRAPHS", "GtkMovementStep", GTK_MOVEMENT_PARAGRAPHS},
        {"GTK_MOVEMENT_PARAGRAPH_ENDS", "GtkMovementStep", GTK_MOVEMENT_PARAGRAPH_ENDS},
        {"GTK_MOVEMENT_PAGES", "GtkMovementStep", GTK_MOVEMENT_PAGES},
        {"GTK_MOVEMENT_BUFFER_ENDS", "GtkMovementStep", GTK_MOVEMENT_BUFFER_ENDS},
        {"GTK_ORIENTATION_HORIZONTAL", "GtkOrientation", GTK_ORIENTATION_HORIZONTAL},
        {"GTK_ORIENTATION_VERTICAL", "GtkOrientation", GTK_ORIENTATION_VERTICAL},
        {"GTK_CORNER_TOP_LEFT", "GtkCornerType", GTK_CORNER_TOP_LEFT},
        {"GTK_CORNER_BOTTOM_LEFT", "GtkCornerType", GTK_CORNER_BOTTOM_LEFT},
        {"GTK_CORNER_TOP_RIGHT", "GtkCornerType", GTK_CORNER_TOP_RIGHT},
        {"GTK_CORNER_BOTTOM_RIGHT", "GtkCornerType", GTK_CORNER_BOTTOM_RIGHT},
        {"GTK_PACK_START", "GtkPackType", GTK_PACK_START},
        {"GTK_PACK_END", "GtkPackType", GTK_PACK_END},
        {"GTK_POLICY_ALWAYS", "GtkPolicyType", GTK_POLICY_ALWAYS},
        {"GTK_POLICY_AUTOMATIC", "GtkPolicyType", GTK_POLICY_AUTOMATIC},
        {"GTK_POLICY_NEVER", "GtkPolicyType", GTK_POLICY_NEVER},
        {"GTK_POS_LEFT", "GtkPositionType", GTK_POS_LEFT},
        {"GTK_POS_RIGHT", "GtkPositionType", GTK_POS_RIGHT},
        {"GTK_POS_TOP", "GtkPositionType", GTK_POS_TOP},
        {"GTK_POS_BOTTOM", "GtkPositionType", GTK_POS_BOTTOM},
        {"GTK_RELIEF_NORMAL", "GtkReliefStyle", GTK_RELIEF_NORMAL},
        {"GTK_RELIEF_NONE", "GtkReliefStyle", GTK_RELIEF_NONE},
        {"GTK_SCROLL_NONE", "GtkScrollType", GTK_SCROLL_NONE},
        {"GTK_SCROLL_JUMP", "GtkScrollType", GTK_SCROLL_JUMP},
        {"GTK_SCROLL_STEP_BACKWARD", "GtkScrollType", GTK_SCROLL_STEP_BACKWARD},
        {"GTK_SCROLL_STEP_FORWARD", "GtkScrollType", GTK_SCROLL_STEP_FORWARD},
        {"GTK_SCROLL_PAGE_BACKWARD", "GtkScrollType", GTK_SCROLL_PAGE_BACKWARD},
        {"GTK_SCROLL_PAGE_FORWARD", "GtkScrollType", GTK_SCROLL_PAGE_FORWARD},
        {"GTK_SCROLL_STEP_UP", "GtkScrollType", GTK_SCROLL_STEP_UP},
        {"GTK_SCROLL_STEP_DOWN", "GtkScrollType", GTK_SCROLL_STEP_DOWN},
        {"GTK_SCROLL_PAGE_UP", "GtkScrollType", GTK_SCROLL_PAGE_UP},
        {"GTK_SCROLL_PAGE_DOWN", "GtkScrollType", GTK_SCROLL_PAGE_DOWN},
        {"GTK_SCROLL_STEP_LEFT", "GtkScrollType", GTK_SCROLL_STEP_LEFT},
        {"GTK_SCROLL_STEP_RIGHT", "GtkScrollType", GTK_SCROLL_STEP_RIGHT},
        {"GTK_SCROLL_PAGE_LEFT", "GtkScrollType", GTK_SCROLL_PAGE_LEFT},
        {"GTK_SCROLL_PAGE_RIGHT", "GtkScrollType", GTK_SCROLL_PAGE_RIGHT},
        {"GTK_SCROLL_START", "GtkScrollType", GTK_SCROLL_START},
        {"GTK_SCROLL_END", "GtkScrollType", GTK_SCROLL_END},
        {"GTK_SELECTION_NONE", "GtkSelectionMode", GTK_SELECTION_NONE},
        {"GTK_SELECTION_SINGLE", "GtkSelectionMode", GTK_SELECTION_SINGLE},
        {"GTK_SELECTION_BROWSE", "GtkSelectionMode", GTK_SELECTION_BROWSE},
        {"GTK_SELECTION_MULTIPLE", "GtkSelectionMode", GTK_SELECTION_MULTIPLE},
        {"GTK_SHADOW_NONE", "GtkShadowType", GTK_SHADOW_NONE},
        {"GTK_SHADOW_IN", "GtkShadowType", GTK_SHADOW_IN},
        {"GTK_SHADOW_OUT", "GtkShadowType", GTK_SHADOW_OUT},
        {"GTK_SHADOW_ETCHED_IN", "GtkShadowType", GTK_SHADOW_ETCHED_IN},
        {"GTK_SHADOW_ETCHED_OUT", "GtkShadowType", GTK_SHADOW_ETCHED_OUT},
        {"GTK_TOOLBAR_ICONS", "GtkToolbarStyle", GTK_TOOLBAR_ICONS},
        {"GTK_TOOLBAR_TEXT", "GtkToolbarStyle", GTK_TOOLBAR_TEXT},
        {"GTK_TOOLBAR_BOTH", "GtkToolbarStyle", GTK_TOOLBAR_BOTH},
        {"GTK_TOOLBAR_BOTH_HORIZ", "GtkToolbarStyle", GTK_TOOLBAR_BOTH_HORIZ},
        {"GTK_WIN_POS_NONE", "GtkWindowPosition", GTK_WIN_POS_NONE},
        {"GTK_WIN_POS_CENTER", "GtkWindowPosition", GTK_WIN_POS_CENTER},
        {"GTK_WIN_POS_MOUSE", "GtkWindowPosition", GTK_WIN_POS_MOUSE},
        {"GTK_WIN_POS_CENTER_ALWAYS", "GtkWindowPosition", GTK_WIN_POS_CENTER_ALWAYS},
        {"GTK_WIN_POS_CENTER_ON_PARENT", "GtkWindowPosition", GTK_WIN_POS_CENTER_ON_PARENT},
        {"GTK_WINDOW_TOPLEVEL", "GtkWindowType", GTK_WINDOW_TOPLEVEL},
        {"GTK_WINDOW_POPUP", "GtkWindowType", GTK_WINDOW_POPUP},
        {"GTK_WRAP_NONE", "GtkWrapMode", GTK_WRAP_NONE},
        {"GTK_WRAP_CHAR", "GtkWrapMode", GTK_WRAP_CHAR},
        {"GTK_WRAP_WORD", "GtkWrapMode", GTK_WRAP_WORD},
        {"GTK_SORT_ASCENDING", "GtkSortType", GTK_SORT_ASCENDING},
        {"GTK_SORT_DESCENDING", "GtkSortType", GTK_SORT_DESCENDING},
        {"GTK_IMAGE_EMPTY", "GtkImageType", GTK_IMAGE_EMPTY},
        {"GTK_MESSAGE_INFO", "GtkMessageType", GTK_MESSAGE_INFO},
        {"GTK_MESSAGE_WARNING", "GtkMessageType", GTK_MESSAGE_WARNING},
        {"GTK_MESSAGE_QUESTION", "GtkMessageType", GTK_MESSAGE_QUESTION},
        {"GTK_MESSAGE_ERROR", "GtkMessageType", GTK_MESSAGE_ERROR},
        {"GTK_BUTTONS_NONE", "GtkButtonsType", GTK_BUTTONS_NONE},
        {"GTK_BUTTONS_OK", "GtkButtonsType", GTK_BUTTONS_OK},
        {"GTK_BUTTONS_CLOSE", "GtkButtonsType", GTK_BUTTONS_CLOSE},
        {"GTK_BUTTONS_CANCEL", "GtkButtonsType", GTK_BUTTONS_CANCEL},
        {"GTK_BUTTONS_YES_NO", "GtkButtonsType", GTK_BUTTONS_YES_NO},
        {"GTK_BUTTONS_OK_CANCEL", "GtkButtonsType", GTK_BUTTONS_OK_CANCEL},
        {"GTK_NOTEBOOK_TAB_FIRST", "GtkNotebookTab", GTK_NOTEBOOK_TAB_FIRST},
        {"GTK_NOTEBOOK_TAB_LAST", "GtkNotebookTab", GTK_NOTEBOOK_TAB_LAST},
        {"GTK_SIZE_GROUP_NONE", "GtkSizeGroupMode", GTK_SIZE_GROUP_NONE},
        {"GTK_SIZE_GROUP_HORIZONTAL", "GtkSizeGroupMode", GTK_SIZE_GROUP_HORIZONTAL},
        {"GTK_SIZE_GROUP_VERTICAL", "GtkSizeGroupMode", GTK_SIZE_GROUP_VERTICAL},
        {"GTK_SIZE_GROUP_BOTH", "GtkSizeGroupMode", GTK_SIZE_GROUP_BOTH},
        {"GTK_UPDATE_ALWAYS", "GtkSpinButtonUpdatePolicy", GTK_UPDATE_ALWAYS},
        {"GTK_UPDATE_IF_VALID", "GtkSpinButtonUpdatePolicy", GTK_UPDATE_IF_VALID},
        {"GTK_SPIN_STEP_FORWARD", "GtkSpinType", GTK_SPIN_STEP_FORWARD},
        {"GTK_SPIN_STEP_BACKWARD", "GtkSpinType", GTK_SPIN_STEP_BACKWARD},
        {"GTK_SPIN_PAGE_FORWARD", "GtkSpinType", GTK_SPIN_PAGE_FORWARD},
        {"GTK_SPIN_PAGE_BACKWARD", "GtkSpinType", GTK_SPIN_PAGE_BACKWARD},
        {"GTK_SPIN_HOME", "GtkSpinType", GTK_SPIN_HOME},
        {"GTK_SPIN_END", "GtkSpinType", GTK_SPIN_END},
        {"GTK_TEXT_SEARCH_VISIBLE_ONLY", "GtkTextSearchFlags", GTK_TEXT_SEARCH_VISIBLE_ONLY},
        {"GTK_TEXT_SEARCH_TEXT_ONLY", "GtkTextSearchFlags", GTK_TEXT_SEARCH_TEXT_ONLY},
        {"GTK_TEXT_WINDOW_PRIVATE", "GtkTextWindowType", GTK_TEXT_WINDOW_PRIVATE},
        {"GTK_TEXT_WINDOW_WIDGET", "GtkTextWindowType", GTK_TEXT_WINDOW_WIDGET},
        {"GTK_TEXT_WINDOW_TEXT", "GtkTextWindowType", GTK_TEXT_WINDOW_TEXT},
        {"GTK_TEXT_WINDOW_LEFT", "GtkTextWindowType", GTK_TEXT_WINDOW_LEFT},
        {"GTK_TEXT_WINDOW_RIGHT", "GtkTextWindowType", GTK_TEXT_WINDOW_RIGHT},
        {"GTK_TEXT_WINDOW_TOP", "GtkTextWindowType", GTK_TEXT_WINDOW_TOP},
        {"GTK_TEXT_WINDOW_BOTTOM", "GtkTextWindowType", GTK_TEXT_WINDOW_BOTTOM},
        {"GTK_TREE_MODEL_ITERS_PERSIST", "GtkTreeModelFlags", GTK_TREE_MODEL_ITERS_PERSIST},
        {"GTK_TREE_MODEL_LIST_ONLY", "GtkTreeModelFlags", GTK_TREE_MODEL_LIST_ONLY},
        {"GTK_TREE_VIEW_COLUMN_GROW_ONLY", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_GROW_ONLY},
        {"GTK_TREE_VIEW_COLUMN_AUTOSIZE", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_AUTOSIZE},
        {"GTK_TREE_VIEW_COLUMN_FIXED", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_FIXED},
        {"GTK_TREE_VIEW_DROP_BEFORE", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_BEFORE},
        {"GTK_TREE_VIEW_DROP_AFTER", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_AFTER},
        {"GTK_TREE_VIEW_DROP_INTO_OR_BEFORE", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_INTO_OR_BEFORE},
        {"GTK_TREE_VIEW_DROP_INTO_OR_AFTER", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_INTO_OR_AFTER},
        {"PANGO_ATTR_INVALID", "PangoAttrType", PANGO_ATTR_INVALID},
        {"PANGO_ATTR_LANGUAGE", "PangoAttrType", PANGO_ATTR_LANGUAGE},
        {"PANGO_ATTR_FAMILY", "PangoAttrType", PANGO_ATTR_FAMILY},
        {"PANGO_ATTR_STYLE", "PangoAttrType", PANGO_ATTR_STYLE},
        {"PANGO_ATTR_WEIGHT", "PangoAttrType", PANGO_ATTR_WEIGHT},
        {"PANGO_ATTR_VARIANT", "PangoAttrType", PANGO_ATTR_VARIANT},
        {"PANGO_ATTR_STRETCH", "PangoAttrType", PANGO_ATTR_STRETCH},
        {"PANGO_ATTR_SIZE", "PangoAttrType", PANGO_ATTR_SIZE},
        {"PANGO_ATTR_FONT_DESC", "PangoAttrType", PANGO_ATTR_FONT_DESC},
        {"PANGO_ATTR_FOREGROUND", "PangoAttrType", PANGO_ATTR_FOREGROUND},
        {"PANGO_ATTR_BACKGROUND", "PangoAttrType", PANGO_ATTR_BACKGROUND},
        {"PANGO_ATTR_UNDERLINE", "PangoAttrType", PANGO_ATTR_UNDERLINE},
        {"PANGO_ATTR_STRIKETHROUGH", "PangoAttrType", PANGO_ATTR_STRIKETHROUGH},
        {"PANGO_ATTR_RISE", "PangoAttrType", PANGO_ATTR_RISE},
        {"PANGO_ATTR_SHAPE", "PangoAttrType", PANGO_ATTR_SHAPE},
        {"PANGO_ATTR_SCALE", "PangoAttrType", PANGO_ATTR_SCALE},
        {"PANGO_UNDERLINE_NONE", "PangoUnderline", PANGO_UNDERLINE_NONE},
        {"PANGO_UNDERLINE_SINGLE", "PangoUnderline", PANGO_UNDERLINE_SINGLE},
        {"PANGO_UNDERLINE_DOUBLE", "PangoUnderline", PANGO_UNDERLINE_DOUBLE},
        {"PANGO_UNDERLINE_LOW", "PangoUnderline", PANGO_UNDERLINE_LOW},
        {"PANGO_COVERAGE_NONE", "PangoCoverageLevel", PANGO_COVERAGE_NONE},
        {"PANGO_COVERAGE_FALLBACK", "PangoCoverageLevel", PANGO_COVERAGE_FALLBACK},
        {"PANGO_COVERAGE_APPROXIMATE", "PangoCoverageLevel", PANGO_COVERAGE_APPROXIMATE},
        {"PANGO_COVERAGE_EXACT", "PangoCoverageLevel", PANGO_COVERAGE_EXACT},
        {"PANGO_STYLE_NORMAL", "PangoStyle", PANGO_STYLE_NORMAL},
        {"PANGO_STYLE_OBLIQUE", "PangoStyle", PANGO_STYLE_OBLIQUE},
        {"PANGO_STYLE_ITALIC", "PangoStyle", PANGO_STYLE_ITALIC},
        {"PANGO_VARIANT_NORMAL", "PangoVariant", PANGO_VARIANT_NORMAL},
        {"PANGO_VARIANT_SMALL_CAPS", "PangoVariant", PANGO_VARIANT_SMALL_CAPS},
        {"PANGO_WEIGHT_ULTRALIGHT", "PangoWeight", PANGO_WEIGHT_ULTRALIGHT},
        {"PANGO_WEIGHT_LIGHT", "PangoWeight", PANGO_WEIGHT_LIGHT},
        {"PANGO_WEIGHT_NORMAL", "PangoWeight", PANGO_WEIGHT_NORMAL},
        {"PANGO_WEIGHT_BOLD", "PangoWeight", PANGO_WEIGHT_BOLD},
        {"PANGO_WEIGHT_ULTRABOLD", "PangoWeight", PANGO_WEIGHT_ULTRABOLD},
        {"PANGO_WEIGHT_HEAVY", "PangoWeight", PANGO_WEIGHT_HEAVY},
        {"PANGO_STRETCH_ULTRA_CONDENSED", "PangoStretch", PANGO_STRETCH_ULTRA_CONDENSED},
        {"PANGO_STRETCH_EXTRA_CONDENSED", "PangoStretch", PANGO_STRETCH_EXTRA_CONDENSED},
        {"PANGO_STRETCH_CONDENSED", "PangoStretch", PANGO_STRETCH_CONDENSED},
        {"PANGO_STRETCH_SEMI_CONDENSED", "PangoStretch", PANGO_STRETCH_SEMI_CONDENSED},
        {"PANGO_STRETCH_NORMAL", "PangoStretch", PANGO_STRETCH_NORMAL},
        {"PANGO_STRETCH_SEMI_EXPANDED", "PangoStretch", PANGO_STRETCH_SEMI_EXPANDED},
        {"PANGO_STRETCH_EXPANDED", "PangoStretch", PANGO_STRETCH_EXPANDED},
        {"PANGO_STRETCH_EXTRA_EXPANDED", "PangoStretch", PANGO_STRETCH_EXTRA_EXPANDED},
        {"PANGO_STRETCH_ULTRA_EXPANDED", "PangoStretch", PANGO_STRETCH_ULTRA_EXPANDED},
        {"PANGO_FONT_MASK_FAMILY", "PangoFontMask", PANGO_FONT_MASK_FAMILY},
        {"PANGO_FONT_MASK_STYLE", "PangoFontMask", PANGO_FONT_MASK_STYLE},
        {"PANGO_FONT_MASK_VARIANT", "PangoFontMask", PANGO_FONT_MASK_VARIANT},
        {"PANGO_FONT_MASK_WEIGHT", "PangoFontMask", PANGO_FONT_MASK_WEIGHT},
        {"PANGO_FONT_MASK_STRETCH", "PangoFontMask", PANGO_FONT_MASK_STRETCH},
        {"PANGO_FONT_MASK_SIZE", "PangoFontMask", PANGO_FONT_MASK_SIZE},
        {"PANGO_ALIGN_LEFT", "PangoAlignment", PANGO_ALIGN_LEFT},
        {"PANGO_ALIGN_CENTER", "PangoAlignment", PANGO_ALIGN_CENTER},
        {"PANGO_ALIGN_RIGHT", "PangoAlignment", PANGO_ALIGN_RIGHT},
        {"PANGO_WRAP_WORD", "PangoWrapMode", PANGO_WRAP_WORD},
        {"PANGO_WRAP_CHAR", "PangoWrapMode", PANGO_WRAP_CHAR},
        {"PANGO_DIRECTION_LTR", "PangoDirection", PANGO_DIRECTION_LTR},
        {"PANGO_DIRECTION_RTL", "PangoDirection", PANGO_DIRECTION_RTL},
        {"PANGO_DIRECTION_TTB_LTR", "PangoDirection", PANGO_DIRECTION_TTB_LTR},
        {"PANGO_DIRECTION_TTB_RTL", "PangoDirection", PANGO_DIRECTION_TTB_RTL},
        {"GDK_WINDOW_STATE_FULLSCREEN", "GdkWindowState", GDK_WINDOW_STATE_FULLSCREEN},
        {"GDK_WINDOW_STATE_ABOVE", "GdkWindowState", GDK_WINDOW_STATE_ABOVE},
        {"GDK_WINDOW_STATE_BELOW", "GdkWindowState", GDK_WINDOW_STATE_BELOW},
        {"GTK_MOVEMENT_HORIZONTAL_PAGES", "GtkMovementStep", GTK_MOVEMENT_HORIZONTAL_PAGES},
        {"GTK_SCROLL_STEPS", "GtkScrollStep", GTK_SCROLL_STEPS},
        {"GTK_SCROLL_PAGES", "GtkScrollStep", GTK_SCROLL_PAGES},
        {"GTK_SCROLL_ENDS", "GtkScrollStep", GTK_SCROLL_ENDS},
        {"GTK_SCROLL_HORIZONTAL_STEPS", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_STEPS},
        {"GTK_SCROLL_HORIZONTAL_PAGES", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_PAGES},
        {"GTK_SCROLL_HORIZONTAL_ENDS", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_ENDS},
        {"GTK_WRAP_WORD_CHAR", "GtkWrapMode", GTK_WRAP_WORD_CHAR},
        {"GTK_FILE_FILTER_FILENAME", "GtkFileFilterFlags", GTK_FILE_FILTER_FILENAME},
        {"GTK_FILE_FILTER_URI", "GtkFileFilterFlags", GTK_FILE_FILTER_URI},
        {"GTK_FILE_FILTER_DISPLAY_NAME", "GtkFileFilterFlags", GTK_FILE_FILTER_DISPLAY_NAME},
        {"GTK_FILE_FILTER_MIME_TYPE", "GtkFileFilterFlags", GTK_FILE_FILTER_MIME_TYPE},
        {"GTK_ICON_LOOKUP_NO_SVG", "GtkIconLookupFlags", GTK_ICON_LOOKUP_NO_SVG},
        {"GTK_ICON_LOOKUP_FORCE_SVG", "GtkIconLookupFlags", GTK_ICON_LOOKUP_FORCE_SVG},
        {"GTK_ICON_LOOKUP_USE_BUILTIN", "GtkIconLookupFlags", GTK_ICON_LOOKUP_USE_BUILTIN},
        {"GTK_ICON_LOOKUP_GENERIC_FALLBACK", "GtkIconLookupFlags", GTK_ICON_LOOKUP_GENERIC_FALLBACK},
        {"GTK_FILE_CHOOSER_ACTION_OPEN", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_OPEN},
        {"GTK_FILE_CHOOSER_ACTION_SAVE", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_SAVE},
        {"GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER},
        {"GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER},
        {"PANGO_ATTR_FALLBACK", "PangoAttrType", PANGO_ATTR_FALLBACK},
        {"PANGO_ATTR_LETTER_SPACING", "PangoAttrType", PANGO_ATTR_LETTER_SPACING},
        {"PANGO_UNDERLINE_ERROR", "PangoUnderline", PANGO_UNDERLINE_ERROR},
        {"PANGO_WRAP_WORD_CHAR", "PangoWrapMode", PANGO_WRAP_WORD_CHAR},
        {"PANGO_ELLIPSIZE_NONE", "PangoEllipsizeMode", PANGO_ELLIPSIZE_NONE},
        {"PANGO_ELLIPSIZE_START", "PangoEllipsizeMode", PANGO_ELLIPSIZE_START},
        {"PANGO_ELLIPSIZE_MIDDLE", "PangoEllipsizeMode", PANGO_ELLIPSIZE_MIDDLE},
        {"PANGO_ELLIPSIZE_END", "PangoEllipsizeMode", PANGO_ELLIPSIZE_END},
        {"PANGO_SCRIPT_INVALID_CODE", "PangoScript", PANGO_SCRIPT_INVALID_CODE},
        {"PANGO_SCRIPT_COMMON", "PangoScript", PANGO_SCRIPT_COMMON},
        {"PANGO_SCRIPT_INHERITED", "PangoScript", PANGO_SCRIPT_INHERITED},
        {"PANGO_SCRIPT_ARABIC", "PangoScript", PANGO_SCRIPT_ARABIC},
        {"PANGO_SCRIPT_ARMENIAN", "PangoScript", PANGO_SCRIPT_ARMENIAN},
        {"PANGO_SCRIPT_BENGALI", "PangoScript", PANGO_SCRIPT_BENGALI},
        {"PANGO_SCRIPT_BOPOMOFO", "PangoScript", PANGO_SCRIPT_BOPOMOFO},
        {"PANGO_SCRIPT_CHEROKEE", "PangoScript", PANGO_SCRIPT_CHEROKEE},
        {"PANGO_SCRIPT_COPTIC", "PangoScript", PANGO_SCRIPT_COPTIC},
        {"PANGO_SCRIPT_CYRILLIC", "PangoScript", PANGO_SCRIPT_CYRILLIC},
        {"PANGO_SCRIPT_DESERET", "PangoScript", PANGO_SCRIPT_DESERET},
        {"PANGO_SCRIPT_DEVANAGARI", "PangoScript", PANGO_SCRIPT_DEVANAGARI},
        {"PANGO_SCRIPT_ETHIOPIC", "PangoScript", PANGO_SCRIPT_ETHIOPIC},
        {"PANGO_SCRIPT_GEORGIAN", "PangoScript", PANGO_SCRIPT_GEORGIAN},
        {"PANGO_SCRIPT_GOTHIC", "PangoScript", PANGO_SCRIPT_GOTHIC},
        {"PANGO_SCRIPT_GREEK", "PangoScript", PANGO_SCRIPT_GREEK},
        {"PANGO_SCRIPT_GUJARATI", "PangoScript", PANGO_SCRIPT_GUJARATI},
        {"PANGO_SCRIPT_GURMUKHI", "PangoScript", PANGO_SCRIPT_GURMUKHI},
        {"PANGO_SCRIPT_HAN", "PangoScript", PANGO_SCRIPT_HAN},
        {"PANGO_SCRIPT_HANGUL", "PangoScript", PANGO_SCRIPT_HANGUL},
        {"PANGO_SCRIPT_HEBREW", "PangoScript", PANGO_SCRIPT_HEBREW},
        {"PANGO_SCRIPT_HIRAGANA", "PangoScript", PANGO_SCRIPT_HIRAGANA},
        {"PANGO_SCRIPT_KANNADA", "PangoScript", PANGO_SCRIPT_KANNADA},
        {"PANGO_SCRIPT_KATAKANA", "PangoScript", PANGO_SCRIPT_KATAKANA},
        {"PANGO_SCRIPT_KHMER", "PangoScript", PANGO_SCRIPT_KHMER},
        {"PANGO_SCRIPT_LAO", "PangoScript", PANGO_SCRIPT_LAO},
        {"PANGO_SCRIPT_LATIN", "PangoScript", PANGO_SCRIPT_LATIN},
        {"PANGO_SCRIPT_MALAYALAM", "PangoScript", PANGO_SCRIPT_MALAYALAM},
        {"PANGO_SCRIPT_MONGOLIAN", "PangoScript", PANGO_SCRIPT_MONGOLIAN},
        {"PANGO_SCRIPT_MYANMAR", "PangoScript", PANGO_SCRIPT_MYANMAR},
        {"PANGO_SCRIPT_OGHAM", "PangoScript", PANGO_SCRIPT_OGHAM},
        {"PANGO_SCRIPT_OLD_ITALIC", "PangoScript", PANGO_SCRIPT_OLD_ITALIC},
        {"PANGO_SCRIPT_ORIYA", "PangoScript", PANGO_SCRIPT_ORIYA},
        {"PANGO_SCRIPT_RUNIC", "PangoScript", PANGO_SCRIPT_RUNIC},
        {"PANGO_SCRIPT_SINHALA", "PangoScript", PANGO_SCRIPT_SINHALA},
        {"PANGO_SCRIPT_SYRIAC", "PangoScript", PANGO_SCRIPT_SYRIAC},
        {"PANGO_SCRIPT_TAMIL", "PangoScript", PANGO_SCRIPT_TAMIL},
        {"PANGO_SCRIPT_TELUGU", "PangoScript", PANGO_SCRIPT_TELUGU},
        {"PANGO_SCRIPT_THAANA", "PangoScript", PANGO_SCRIPT_THAANA},
        {"PANGO_SCRIPT_THAI", "PangoScript", PANGO_SCRIPT_THAI},
        {"PANGO_SCRIPT_TIBETAN", "PangoScript", PANGO_SCRIPT_TIBETAN},
        {"PANGO_SCRIPT_CANADIAN_ABORIGINAL", "PangoScript", PANGO_SCRIPT_CANADIAN_ABORIGINAL},
        {"PANGO_SCRIPT_YI", "PangoScript", PANGO_SCRIPT_YI},
        {"PANGO_SCRIPT_TAGALOG", "PangoScript", PANGO_SCRIPT_TAGALOG},
        {"PANGO_SCRIPT_HANUNOO", "PangoScript", PANGO_SCRIPT_HANUNOO},
        {"PANGO_SCRIPT_BUHID", "PangoScript", PANGO_SCRIPT_BUHID},
        {"PANGO_SCRIPT_TAGBANWA", "PangoScript", PANGO_SCRIPT_TAGBANWA},
        {"PANGO_SCRIPT_BRAILLE", "PangoScript", PANGO_SCRIPT_BRAILLE},
        {"PANGO_SCRIPT_CYPRIOT", "PangoScript", PANGO_SCRIPT_CYPRIOT},
        {"PANGO_SCRIPT_LIMBU", "PangoScript", PANGO_SCRIPT_LIMBU},
        {"PANGO_SCRIPT_OSMANYA", "PangoScript", PANGO_SCRIPT_OSMANYA},
        {"PANGO_SCRIPT_SHAVIAN", "PangoScript", PANGO_SCRIPT_SHAVIAN},
        {"PANGO_SCRIPT_LINEAR_B", "PangoScript", PANGO_SCRIPT_LINEAR_B},
        {"PANGO_SCRIPT_TAI_LE", "PangoScript", PANGO_SCRIPT_TAI_LE},
        {"PANGO_SCRIPT_UGARITIC", "PangoScript", PANGO_SCRIPT_UGARITIC},
        {"PANGO_TAB_LEFT", "PangoTabAlign", PANGO_TAB_LEFT},
        {"PANGO_DIRECTION_WEAK_LTR", "PangoDirection", PANGO_DIRECTION_WEAK_LTR},
        {"PANGO_DIRECTION_WEAK_RTL", "PangoDirection", PANGO_DIRECTION_WEAK_RTL},
        {"PANGO_DIRECTION_NEUTRAL", "PangoDirection", PANGO_DIRECTION_NEUTRAL},
        {"GTK_IMAGE_ICON_NAME", "GtkImageType", GTK_IMAGE_ICON_NAME},
        {"PANGO_ATTR_UNDERLINE_COLOR", "PangoAttrType", PANGO_ATTR_UNDERLINE_COLOR},
        {"PANGO_ATTR_STRIKETHROUGH_COLOR", "PangoAttrType", PANGO_ATTR_STRIKETHROUGH_COLOR},
        {"PANGO_RENDER_PART_FOREGROUND", "PangoRenderPart", PANGO_RENDER_PART_FOREGROUND},
        {"PANGO_RENDER_PART_BACKGROUND", "PangoRenderPart", PANGO_RENDER_PART_BACKGROUND},
        {"PANGO_RENDER_PART_UNDERLINE", "PangoRenderPart", PANGO_RENDER_PART_UNDERLINE},
        {"PANGO_RENDER_PART_STRIKETHROUGH", "PangoRenderPart", PANGO_RENDER_PART_STRIKETHROUGH},
        {"G_LOG_FLAG_RECURSION", "GLogLevelFlags", G_LOG_FLAG_RECURSION},
        {"G_LOG_FLAG_FATAL", "GLogLevelFlags", G_LOG_FLAG_FATAL},
        {"G_LOG_LEVEL_ERROR", "GLogLevelFlags", G_LOG_LEVEL_ERROR},
        {"G_LOG_LEVEL_CRITICAL", "GLogLevelFlags", G_LOG_LEVEL_CRITICAL},
        {"G_LOG_LEVEL_WARNING", "GLogLevelFlags", G_LOG_LEVEL_WARNING},
        {"G_LOG_LEVEL_MESSAGE", "GLogLevelFlags", G_LOG_LEVEL_MESSAGE},
        {"G_LOG_LEVEL_INFO", "GLogLevelFlags", G_LOG_LEVEL_INFO},
        {"G_LOG_LEVEL_DEBUG", "GLogLevelFlags", G_LOG_LEVEL_DEBUG},
        {"G_LOG_LEVEL_MASK", "GLogLevelFlags", G_LOG_LEVEL_MASK},
        {"G_LOG_FATAL_MASK", "GLogLevelFlags", G_LOG_FATAL_MASK},
        {"GTK_PACK_DIRECTION_LTR", "GtkPackDirection", GTK_PACK_DIRECTION_LTR},
        {"GTK_PACK_DIRECTION_RTL", "GtkPackDirection", GTK_PACK_DIRECTION_RTL},
        {"GTK_PACK_DIRECTION_TTB", "GtkPackDirection", GTK_PACK_DIRECTION_TTB},
        {"GTK_PACK_DIRECTION_BTT", "GtkPackDirection", GTK_PACK_DIRECTION_BTT},
        {"GTK_ICON_VIEW_NO_DROP", "GtkIconViewDropPosition", GTK_ICON_VIEW_NO_DROP},
        {"GTK_ICON_VIEW_DROP_INTO", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_INTO},
        {"GTK_ICON_VIEW_DROP_LEFT", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_LEFT},
        {"GTK_ICON_VIEW_DROP_RIGHT", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_RIGHT},
        {"GTK_ICON_VIEW_DROP_ABOVE", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_ABOVE},
        {"GTK_ICON_VIEW_DROP_BELOW", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_BELOW},
        {"GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM", "GtkFileChooserConfirmation", GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM},
        {"GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME", "GtkFileChooserConfirmation", GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME},
        {"GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN", "GtkFileChooserConfirmation", GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN},
        {"PANGO_SCRIPT_NEW_TAI_LUE", "PangoScript", PANGO_SCRIPT_NEW_TAI_LUE},
        {"PANGO_SCRIPT_BUGINESE", "PangoScript", PANGO_SCRIPT_BUGINESE},
        {"PANGO_SCRIPT_GLAGOLITIC", "PangoScript", PANGO_SCRIPT_GLAGOLITIC},
        {"PANGO_SCRIPT_TIFINAGH", "PangoScript", PANGO_SCRIPT_TIFINAGH},
        {"PANGO_SCRIPT_SYLOTI_NAGRI", "PangoScript", PANGO_SCRIPT_SYLOTI_NAGRI},
        {"PANGO_SCRIPT_OLD_PERSIAN", "PangoScript", PANGO_SCRIPT_OLD_PERSIAN},
        {"PANGO_SCRIPT_KHAROSHTHI", "PangoScript", PANGO_SCRIPT_KHAROSHTHI},
        {"GDK_SUPER_MASK", "GdkModifierType", GDK_SUPER_MASK},
        {"GDK_HYPER_MASK", "GdkModifierType", GDK_HYPER_MASK},
        {"GDK_META_MASK", "GdkModifierType", GDK_META_MASK},
        {"GTK_SENSITIVITY_AUTO", "GtkSensitivityType", GTK_SENSITIVITY_AUTO},
        {"GTK_SENSITIVITY_ON", "GtkSensitivityType", GTK_SENSITIVITY_ON},
        {"GTK_SENSITIVITY_OFF", "GtkSensitivityType", GTK_SENSITIVITY_OFF},
        {"GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS},
        {"GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT},
        {"GTK_TEXT_BUFFER_TARGET_INFO_TEXT", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_TEXT},
        {"GTK_ASSISTANT_PAGE_CONTENT", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CONTENT},
        {"GTK_ASSISTANT_PAGE_INTRO", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_INTRO},
        {"GTK_ASSISTANT_PAGE_CONFIRM", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CONFIRM},
        {"GTK_ASSISTANT_PAGE_SUMMARY", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_SUMMARY},
        {"GTK_ASSISTANT_PAGE_PROGRESS", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_PROGRESS},
        {"GTK_CELL_RENDERER_ACCEL_MODE_GTK", "GtkCellRendererAccelMode", GTK_CELL_RENDERER_ACCEL_MODE_GTK},
        {"GTK_CELL_RENDERER_ACCEL_MODE_OTHER", "GtkCellRendererAccelMode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER},
        {"GTK_RECENT_SORT_NONE", "GtkRecentSortType", GTK_RECENT_SORT_NONE},
        {"GTK_RECENT_SORT_MRU", "GtkRecentSortType", GTK_RECENT_SORT_MRU},
        {"GTK_RECENT_SORT_LRU", "GtkRecentSortType", GTK_RECENT_SORT_LRU},
        {"GTK_RECENT_SORT_CUSTOM", "GtkRecentSortType", GTK_RECENT_SORT_CUSTOM},
        {"GTK_RECENT_CHOOSER_ERROR_NOT_FOUND", "GtkRecentChooserError", GTK_RECENT_CHOOSER_ERROR_NOT_FOUND},
        {"GTK_RECENT_CHOOSER_ERROR_INVALID_URI", "GtkRecentChooserError", GTK_RECENT_CHOOSER_ERROR_INVALID_URI},
        {"GTK_RECENT_MANAGER_ERROR_NOT_FOUND", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_NOT_FOUND},
        {"GTK_RECENT_MANAGER_ERROR_INVALID_URI", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_INVALID_URI},
        {"GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING},
        {"GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED},
        {"GTK_RECENT_MANAGER_ERROR_READ", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_READ},
        {"GTK_RECENT_MANAGER_ERROR_WRITE", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_WRITE},
        {"GTK_RECENT_MANAGER_ERROR_UNKNOWN", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_UNKNOWN},
        {"GTK_MESSAGE_OTHER", "GtkMessageType", GTK_MESSAGE_OTHER},
        {"GTK_TREE_VIEW_GRID_LINES_NONE", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_NONE},
        {"GTK_TREE_VIEW_GRID_LINES_HORIZONTAL", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_HORIZONTAL},
        {"GTK_TREE_VIEW_GRID_LINES_VERTICAL", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_VERTICAL},
        {"GTK_TREE_VIEW_GRID_LINES_BOTH", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_BOTH},
        {"GTK_PRINT_STATUS_INITIAL", "GtkPrintStatus", GTK_PRINT_STATUS_INITIAL},
        {"GTK_PRINT_STATUS_PREPARING", "GtkPrintStatus", GTK_PRINT_STATUS_PREPARING},
        {"GTK_PRINT_STATUS_GENERATING_DATA", "GtkPrintStatus", GTK_PRINT_STATUS_GENERATING_DATA},
        {"GTK_PRINT_STATUS_SENDING_DATA", "GtkPrintStatus", GTK_PRINT_STATUS_SENDING_DATA},
        {"GTK_PRINT_STATUS_PENDING", "GtkPrintStatus", GTK_PRINT_STATUS_PENDING},
        {"GTK_PRINT_STATUS_PENDING_ISSUE", "GtkPrintStatus", GTK_PRINT_STATUS_PENDING_ISSUE},
        {"GTK_PRINT_STATUS_PRINTING", "GtkPrintStatus", GTK_PRINT_STATUS_PRINTING},
        {"GTK_PRINT_STATUS_FINISHED", "GtkPrintStatus", GTK_PRINT_STATUS_FINISHED},
        {"GTK_PRINT_STATUS_FINISHED_ABORTED", "GtkPrintStatus", GTK_PRINT_STATUS_FINISHED_ABORTED},
        {"GTK_PRINT_OPERATION_RESULT_ERROR", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_ERROR},
        {"GTK_PRINT_OPERATION_RESULT_APPLY", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_APPLY},
        {"GTK_PRINT_OPERATION_RESULT_CANCEL", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_CANCEL},
        {"GTK_PRINT_OPERATION_RESULT_IN_PROGRESS", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_IN_PROGRESS},
        {"GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG},
        {"GTK_PRINT_OPERATION_ACTION_PRINT", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PRINT},
        {"GTK_PRINT_OPERATION_ACTION_PREVIEW", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PREVIEW},
        {"GTK_PRINT_OPERATION_ACTION_EXPORT", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_EXPORT},
        {"GTK_PRINT_ERROR_GENERAL", "GtkPrintError", GTK_PRINT_ERROR_GENERAL},
        {"GTK_PRINT_ERROR_INTERNAL_ERROR", "GtkPrintError", GTK_PRINT_ERROR_INTERNAL_ERROR},
        {"GTK_PRINT_ERROR_NOMEM", "GtkPrintError", GTK_PRINT_ERROR_NOMEM},
        {"GTK_PRINT_ERROR_INVALID_FILE", "GtkPrintError", GTK_PRINT_ERROR_INVALID_FILE},
        {"CAIRO_STATUS_SUCCESS", "cairo_status_t", CAIRO_STATUS_SUCCESS},
        {"CAIRO_STATUS_NO_MEMORY", "cairo_status_t", CAIRO_STATUS_NO_MEMORY},
        {"CAIRO_STATUS_INVALID_RESTORE", "cairo_status_t", CAIRO_STATUS_INVALID_RESTORE},
        {"CAIRO_STATUS_INVALID_POP_GROUP", "cairo_status_t", CAIRO_STATUS_INVALID_POP_GROUP},
        {"CAIRO_STATUS_NO_CURRENT_POINT", "cairo_status_t", CAIRO_STATUS_NO_CURRENT_POINT},
        {"CAIRO_STATUS_INVALID_MATRIX", "cairo_status_t", CAIRO_STATUS_INVALID_MATRIX},
        {"CAIRO_STATUS_INVALID_STATUS", "cairo_status_t", CAIRO_STATUS_INVALID_STATUS},
        {"CAIRO_STATUS_NULL_POINTER", "cairo_status_t", CAIRO_STATUS_NULL_POINTER},
        {"CAIRO_STATUS_INVALID_STRING", "cairo_status_t", CAIRO_STATUS_INVALID_STRING},
        {"CAIRO_STATUS_INVALID_PATH_DATA", "cairo_status_t", CAIRO_STATUS_INVALID_PATH_DATA},
        {"CAIRO_STATUS_READ_ERROR", "cairo_status_t", CAIRO_STATUS_READ_ERROR},
        {"CAIRO_STATUS_WRITE_ERROR", "cairo_status_t", CAIRO_STATUS_WRITE_ERROR},
        {"CAIRO_STATUS_SURFACE_FINISHED", "cairo_status_t", CAIRO_STATUS_SURFACE_FINISHED},
        {"CAIRO_STATUS_SURFACE_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_SURFACE_TYPE_MISMATCH},
        {"CAIRO_STATUS_PATTERN_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_PATTERN_TYPE_MISMATCH},
        {"CAIRO_STATUS_INVALID_CONTENT", "cairo_status_t", CAIRO_STATUS_INVALID_CONTENT},
        {"CAIRO_STATUS_INVALID_FORMAT", "cairo_status_t", CAIRO_STATUS_INVALID_FORMAT},
        {"CAIRO_STATUS_INVALID_VISUAL", "cairo_status_t", CAIRO_STATUS_INVALID_VISUAL},
        {"CAIRO_STATUS_FILE_NOT_FOUND", "cairo_status_t", CAIRO_STATUS_FILE_NOT_FOUND},
        {"CAIRO_STATUS_INVALID_DASH", "cairo_status_t", CAIRO_STATUS_INVALID_DASH},
        {"CAIRO_STATUS_INVALID_DSC_COMMENT", "cairo_status_t", CAIRO_STATUS_INVALID_DSC_COMMENT},
        {"CAIRO_STATUS_INVALID_INDEX", "cairo_status_t", CAIRO_STATUS_INVALID_INDEX},
        {"CAIRO_STATUS_CLIP_NOT_REPRESENTABLE", "cairo_status_t", CAIRO_STATUS_CLIP_NOT_REPRESENTABLE},
        {"CAIRO_STATUS_TEMP_FILE_ERROR", "cairo_status_t", CAIRO_STATUS_TEMP_FILE_ERROR},
        {"CAIRO_STATUS_INVALID_STRIDE", "cairo_status_t", CAIRO_STATUS_INVALID_STRIDE},
        {"CAIRO_CONTENT_COLOR", "cairo_content_t", CAIRO_CONTENT_COLOR},
        {"CAIRO_CONTENT_ALPHA", "cairo_content_t", CAIRO_CONTENT_ALPHA},
        {"CAIRO_CONTENT_COLOR_ALPHA", "cairo_content_t", CAIRO_CONTENT_COLOR_ALPHA},
        {"CAIRO_OPERATOR_CLEAR", "cairo_operator_t", CAIRO_OPERATOR_CLEAR},
        {"CAIRO_OPERATOR_SOURCE", "cairo_operator_t", CAIRO_OPERATOR_SOURCE},
        {"CAIRO_OPERATOR_OVER", "cairo_operator_t", CAIRO_OPERATOR_OVER},
        {"CAIRO_OPERATOR_IN", "cairo_operator_t", CAIRO_OPERATOR_IN},
        {"CAIRO_OPERATOR_OUT", "cairo_operator_t", CAIRO_OPERATOR_OUT},
        {"CAIRO_OPERATOR_ATOP", "cairo_operator_t", CAIRO_OPERATOR_ATOP},
        {"CAIRO_OPERATOR_DEST", "cairo_operator_t", CAIRO_OPERATOR_DEST},
        {"CAIRO_OPERATOR_DEST_OVER", "cairo_operator_t", CAIRO_OPERATOR_DEST_OVER},
        {"CAIRO_OPERATOR_DEST_IN", "cairo_operator_t", CAIRO_OPERATOR_DEST_IN},
        {"CAIRO_OPERATOR_DEST_OUT", "cairo_operator_t", CAIRO_OPERATOR_DEST_OUT},
        {"CAIRO_OPERATOR_DEST_ATOP", "cairo_operator_t", CAIRO_OPERATOR_DEST_ATOP},
        {"CAIRO_OPERATOR_XOR", "cairo_operator_t", CAIRO_OPERATOR_XOR},
        {"CAIRO_OPERATOR_ADD", "cairo_operator_t", CAIRO_OPERATOR_ADD},
        {"CAIRO_OPERATOR_SATURATE", "cairo_operator_t", CAIRO_OPERATOR_SATURATE},
        {"CAIRO_ANTIALIAS_DEFAULT", "cairo_antialias_t", CAIRO_ANTIALIAS_DEFAULT},
        {"CAIRO_ANTIALIAS_NONE", "cairo_antialias_t", CAIRO_ANTIALIAS_NONE},
        {"CAIRO_ANTIALIAS_GRAY", "cairo_antialias_t", CAIRO_ANTIALIAS_GRAY},
        {"CAIRO_ANTIALIAS_SUBPIXEL", "cairo_antialias_t", CAIRO_ANTIALIAS_SUBPIXEL},
        {"CAIRO_FILL_RULE_WINDING", "cairo_fill_rule_t", CAIRO_FILL_RULE_WINDING},
        {"CAIRO_FILL_RULE_EVEN_ODD", "cairo_fill_rule_t", CAIRO_FILL_RULE_EVEN_ODD},
        {"CAIRO_LINE_CAP_BUTT", "cairo_line_cap_t", CAIRO_LINE_CAP_BUTT},
        {"CAIRO_LINE_CAP_ROUND", "cairo_line_cap_t", CAIRO_LINE_CAP_ROUND},
        {"CAIRO_LINE_CAP_SQUARE", "cairo_line_cap_t", CAIRO_LINE_CAP_SQUARE},
        {"CAIRO_LINE_JOIN_MITER", "cairo_line_join_t", CAIRO_LINE_JOIN_MITER},
        {"CAIRO_LINE_JOIN_ROUND", "cairo_line_join_t", CAIRO_LINE_JOIN_ROUND},
        {"CAIRO_LINE_JOIN_BEVEL", "cairo_line_join_t", CAIRO_LINE_JOIN_BEVEL},
        {"CAIRO_FONT_SLANT_NORMAL", "cairo_font_slant_t", CAIRO_FONT_SLANT_NORMAL},
        {"CAIRO_FONT_SLANT_ITALIC", "cairo_font_slant_t", CAIRO_FONT_SLANT_ITALIC},
        {"CAIRO_FONT_SLANT_OBLIQUE", "cairo_font_slant_t", CAIRO_FONT_SLANT_OBLIQUE},
        {"CAIRO_FONT_WEIGHT_NORMAL", "cairo_font_weight_t", CAIRO_FONT_WEIGHT_NORMAL},
        {"CAIRO_FONT_WEIGHT_BOLD", "cairo_font_weight_t", CAIRO_FONT_WEIGHT_BOLD},
        {"CAIRO_SUBPIXEL_ORDER_DEFAULT", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_DEFAULT},
        {"CAIRO_SUBPIXEL_ORDER_RGB", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_RGB},
        {"CAIRO_SUBPIXEL_ORDER_BGR", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_BGR},
        {"CAIRO_SUBPIXEL_ORDER_VRGB", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_VRGB},
        {"CAIRO_SUBPIXEL_ORDER_VBGR", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_VBGR},
        {"CAIRO_HINT_STYLE_DEFAULT", "cairo_hint_style_t", CAIRO_HINT_STYLE_DEFAULT},
        {"CAIRO_HINT_STYLE_NONE", "cairo_hint_style_t", CAIRO_HINT_STYLE_NONE},
        {"CAIRO_HINT_STYLE_SLIGHT", "cairo_hint_style_t", CAIRO_HINT_STYLE_SLIGHT},
        {"CAIRO_HINT_STYLE_MEDIUM", "cairo_hint_style_t", CAIRO_HINT_STYLE_MEDIUM},
        {"CAIRO_HINT_STYLE_FULL", "cairo_hint_style_t", CAIRO_HINT_STYLE_FULL},
        {"CAIRO_HINT_METRICS_DEFAULT", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_DEFAULT},
        {"CAIRO_HINT_METRICS_OFF", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_OFF},
        {"CAIRO_HINT_METRICS_ON", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_ON},
        {"CAIRO_FONT_TYPE_TOY", "cairo_font_type_t", CAIRO_FONT_TYPE_TOY},
        {"CAIRO_FONT_TYPE_FT", "cairo_font_type_t", CAIRO_FONT_TYPE_FT},
        {"CAIRO_FONT_TYPE_WIN32", "cairo_font_type_t", CAIRO_FONT_TYPE_WIN32},
        {"CAIRO_FONT_TYPE_QUARTZ", "cairo_font_type_t", CAIRO_FONT_TYPE_QUARTZ},
        {"CAIRO_PATH_MOVE_TO", "cairo_path_data_type_t", CAIRO_PATH_MOVE_TO},
        {"CAIRO_PATH_LINE_TO", "cairo_path_data_type_t", CAIRO_PATH_LINE_TO},
        {"CAIRO_PATH_CURVE_TO", "cairo_path_data_type_t", CAIRO_PATH_CURVE_TO},
        {"CAIRO_PATH_CLOSE_PATH", "cairo_path_data_type_t", CAIRO_PATH_CLOSE_PATH},
        {"CAIRO_SURFACE_TYPE_IMAGE", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_IMAGE},
        {"CAIRO_SURFACE_TYPE_PDF", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_PDF},
        {"CAIRO_SURFACE_TYPE_PS", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_PS},
        {"CAIRO_SURFACE_TYPE_XLIB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_XLIB},
        {"CAIRO_SURFACE_TYPE_XCB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_XCB},
        {"CAIRO_SURFACE_TYPE_GLITZ", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_GLITZ},
        {"CAIRO_SURFACE_TYPE_QUARTZ", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_QUARTZ},
        {"CAIRO_SURFACE_TYPE_WIN32", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_WIN32},
        {"CAIRO_SURFACE_TYPE_BEOS", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_BEOS},
        {"CAIRO_SURFACE_TYPE_DIRECTFB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_DIRECTFB},
        {"CAIRO_SURFACE_TYPE_SVG", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_SVG},
        {"CAIRO_SURFACE_TYPE_OS2", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_OS2},
        {"CAIRO_SURFACE_TYPE_WIN32_PRINTING", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_WIN32_PRINTING},
        {"CAIRO_SURFACE_TYPE_QUARTZ_IMAGE", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_QUARTZ_IMAGE},
        {"CAIRO_FORMAT_ARGB32", "cairo_format_t", CAIRO_FORMAT_ARGB32},
        {"CAIRO_FORMAT_RGB24", "cairo_format_t", CAIRO_FORMAT_RGB24},
        {"CAIRO_FORMAT_A8", "cairo_format_t", CAIRO_FORMAT_A8},
        {"CAIRO_FORMAT_A1", "cairo_format_t", CAIRO_FORMAT_A1},
        {"CAIRO_PATTERN_TYPE_SOLID", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_SOLID},
        {"CAIRO_PATTERN_TYPE_SURFACE", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_SURFACE},
        {"CAIRO_PATTERN_TYPE_LINEAR", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_LINEAR},
        {"CAIRO_PATTERN_TYPE_RADIAL", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_RADIAL},
        {"CAIRO_EXTEND_NONE", "cairo_extend_t", CAIRO_EXTEND_NONE},
        {"CAIRO_EXTEND_REPEAT", "cairo_extend_t", CAIRO_EXTEND_REPEAT},
        {"CAIRO_EXTEND_REFLECT", "cairo_extend_t", CAIRO_EXTEND_REFLECT},
        {"CAIRO_EXTEND_PAD", "cairo_extend_t", CAIRO_EXTEND_PAD},
        {"CAIRO_FILTER_FAST", "cairo_filter_t", CAIRO_FILTER_FAST},
        {"CAIRO_FILTER_GOOD", "cairo_filter_t", CAIRO_FILTER_GOOD},
        {"CAIRO_FILTER_BEST", "cairo_filter_t", CAIRO_FILTER_BEST},
        {"CAIRO_FILTER_NEAREST", "cairo_filter_t", CAIRO_FILTER_NEAREST},
        {"CAIRO_FILTER_BILINEAR", "cairo_filter_t", CAIRO_FILTER_BILINEAR},
        {"CAIRO_FILTER_GAUSSIAN", "cairo_filter_t", CAIRO_FILTER_GAUSSIAN},
        {"GTK_DRAG_RESULT_SUCCESS", "GtkDragResult", GTK_DRAG_RESULT_SUCCESS},
        {"GTK_DRAG_RESULT_NO_TARGET", "GtkDragResult", GTK_DRAG_RESULT_NO_TARGET},
        {"GTK_DRAG_RESULT_USER_CANCELLED", "GtkDragResult", GTK_DRAG_RESULT_USER_CANCELLED},
        {"GTK_DRAG_RESULT_TIMEOUT_EXPIRED", "GtkDragResult", GTK_DRAG_RESULT_TIMEOUT_EXPIRED},
        {"GTK_DRAG_RESULT_GRAB_BROKEN", "GtkDragResult", GTK_DRAG_RESULT_GRAB_BROKEN},
        {"GTK_DRAG_RESULT_ERROR", "GtkDragResult", GTK_DRAG_RESULT_ERROR},
#endif
#if GTK_CHECK_VERSION(2, 14, 0)
        {"GTK_CALENDAR_SHOW_DETAILS", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_DETAILS},
        {"GDK_CROSSING_GTK_GRAB", "GdkCrossingMode", GDK_CROSSING_GTK_GRAB},
        {"GDK_CROSSING_GTK_UNGRAB", "GdkCrossingMode", GDK_CROSSING_GTK_UNGRAB},
        {"GDK_CROSSING_STATE_CHANGED", "GdkCrossingMode", GDK_CROSSING_STATE_CHANGED},
#endif
#if GTK_CHECK_VERSION(2, 16, 0)
        {"GTK_ENTRY_ICON_PRIMARY", "GtkEntryIconPosition", GTK_ENTRY_ICON_PRIMARY},
        {"GTK_ENTRY_ICON_SECONDARY", "GtkEntryIconPosition", GTK_ENTRY_ICON_SECONDARY},
#endif
#if GTK_CHECK_VERSION(2, 18, 0)
        {"PANGO_WEIGHT_THIN", "PangoWeight", PANGO_WEIGHT_THIN},
        {"PANGO_WEIGHT_BOOK", "PangoWeight", PANGO_WEIGHT_BOOK},
        {"PANGO_WEIGHT_MEDIUM", "PangoWeight", PANGO_WEIGHT_MEDIUM},
#endif
#if GTK_CHECK_VERSION(3, 0, 0)
        {"GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH", "GtkSizeRequestMode", GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH},
        {"GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT", "GtkSizeRequestMode", GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT},
        {"GTK_ASSISTANT_PAGE_CUSTOM", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CUSTOM},
        {"GTK_TEXT_SEARCH_CASE_INSENSITIVE", "GtkTextSearchFlags", GTK_TEXT_SEARCH_CASE_INSENSITIVE},
        {"GTK_SCROLL_MINIMUM", "GtkScrollablePolicy", GTK_SCROLL_MINIMUM},
        {"GTK_SCROLL_NATURAL", "GtkScrollablePolicy", GTK_SCROLL_NATURAL},
        {"GTK_ALIGN_FILL", "GtkAlign", GTK_ALIGN_FILL},
        {"GTK_ALIGN_START", "GtkAlign", GTK_ALIGN_START},
        {"GTK_ALIGN_END", "GtkAlign", GTK_ALIGN_END},
        {"GTK_ALIGN_CENTER", "GtkAlign", GTK_ALIGN_CENTER},
        {"GTK_TOOL_PALETTE_DRAG_ITEMS", "GtkToolPaletteDragTargets", GTK_TOOL_PALETTE_DRAG_ITEMS},
        {"GTK_TOOL_PALETTE_DRAG_GROUPS", "GtkToolPaletteDragTargets", GTK_TOOL_PALETTE_DRAG_GROUPS},
        {"GTK_IMAGE_GICON", "GtkImageType", GTK_IMAGE_GICON},
        {"GTK_FILE_CHOOSER_ERROR_NONEXISTENT", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_NONEXISTENT},
        {"GTK_FILE_CHOOSER_ERROR_BAD_FILENAME", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_BAD_FILENAME},
        {"GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS},
        {"GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME},
        {"GTK_ICON_LOOKUP_FORCE_SIZE", "GtkIconLookupFlags", GTK_ICON_LOOKUP_FORCE_SIZE},
        {"GTK_ICON_THEME_NOT_FOUND", "GtkIconThemeError", GTK_ICON_THEME_NOT_FOUND},
        {"GTK_ICON_THEME_FAILED", "GtkIconThemeError", GTK_ICON_THEME_FAILED},
        {"GTK_STATE_FLAG_NORMAL", "GtkStateFlags", GTK_STATE_FLAG_NORMAL},
        {"GTK_STATE_FLAG_ACTIVE", "GtkStateFlags", GTK_STATE_FLAG_ACTIVE},
        {"GTK_STATE_FLAG_PRELIGHT", "GtkStateFlags", GTK_STATE_FLAG_PRELIGHT},
        {"GTK_STATE_FLAG_SELECTED", "GtkStateFlags", GTK_STATE_FLAG_SELECTED},
        {"GTK_STATE_FLAG_INSENSITIVE", "GtkStateFlags", GTK_STATE_FLAG_INSENSITIVE},
        {"GTK_STATE_FLAG_INCONSISTENT", "GtkStateFlags", GTK_STATE_FLAG_INCONSISTENT},
        {"GTK_STATE_FLAG_FOCUSED", "GtkStateFlags", GTK_STATE_FLAG_FOCUSED},
#endif
#if GTK_CHECK_VERSION(3, 10, 0)
        {"GTK_ALIGN_BASELINE", "GtkAlign", GTK_ALIGN_BASELINE},
        {"GTK_BASELINE_POSITION_TOP", "GtkBaselinePosition", GTK_BASELINE_POSITION_TOP},
        {"GTK_BASELINE_POSITION_CENTER", "GtkBaselinePosition", GTK_BASELINE_POSITION_CENTER},
        {"GTK_BASELINE_POSITION_BOTTOM", "GtkBaselinePosition", GTK_BASELINE_POSITION_BOTTOM},
        {"GTK_PLACES_OPEN_NORMAL", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NORMAL},
        {"GTK_PLACES_OPEN_NEW_TAB", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NEW_TAB},
        {"GTK_PLACES_OPEN_NEW_WINDOW", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NEW_WINDOW},
        {"GTK_STACK_TRANSITION_TYPE_NONE", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_NONE},
        {"GTK_STACK_TRANSITION_TYPE_CROSSFADE", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_CROSSFADE},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_UP},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN},
        {"GTK_REVEALER_TRANSITION_TYPE_NONE", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_NONE},
        {"GTK_REVEALER_TRANSITION_TYPE_CROSSFADE", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_CROSSFADE},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN},
        {"GDK_WINDOW_STATE_TILED", "GdkWindowState", GDK_WINDOW_STATE_TILED},
#endif
#if GTK_CHECK_VERSION(3, 12, 0)
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_UP},
        {"GTK_STACK_TRANSITION_TYPE_OVER_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_UP},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN},
#endif
#if GTK_CHECK_VERSION(3, 14, 0)
        {"GTK_PHASE_NONE", "GtkPropagationPhase", GTK_PHASE_NONE},
        {"GTK_PHASE_CAPTURE", "GtkPropagationPhase", GTK_PHASE_CAPTURE},
        {"GTK_PHASE_BUBBLE", "GtkPropagationPhase", GTK_PHASE_BUBBLE},
        {"GTK_PHASE_TARGET", "GtkPropagationPhase", GTK_PHASE_TARGET},
        {"GTK_TEXT_VIEW_LAYER_BELOW", "GtkTextViewLayer", GTK_TEXT_VIEW_LAYER_BELOW},
        {"GTK_TEXT_VIEW_LAYER_ABOVE", "GtkTextViewLayer", GTK_TEXT_VIEW_LAYER_ABOVE},
#endif
#if GTK_CHECK_VERSION(3, 16, 0)
        {"GTK_POLICY_EXTERNAL", "GtkPolicyType", GTK_POLICY_EXTERNAL},
        {"PANGO_WEIGHT_SEMILIGHT", "PangoWeight", PANGO_WEIGHT_SEMILIGHT},
        {"GTK_TEXT_EXTEND_SELECTION_WORD", "GtkTextExtendSelection", GTK_TEXT_EXTEND_SELECTION_WORD},
        {"GTK_TEXT_EXTEND_SELECTION_LINE", "GtkTextExtendSelection", GTK_TEXT_EXTEND_SELECTION_LINE},
#endif
#if GTK_CHECK_VERSION(3, 18, 0)
        {"GDK_TOUCHPAD_SWIPE", "GdkEventType", GDK_TOUCHPAD_SWIPE},
        {"GDK_TOUCHPAD_PINCH", "GdkEventType", GDK_TOUCHPAD_PINCH},
        {"GDK_TOUCHPAD_GESTURE_PHASE_BEGIN", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_BEGIN},
        {"GDK_TOUCHPAD_GESTURE_PHASE_UPDATE", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_UPDATE},
        {"GDK_TOUCHPAD_GESTURE_PHASE_END", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_END},
        {"GDK_TOUCHPAD_GESTURE_PHASE_CANCEL", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_CANCEL},
        {"GDK_TOUCHPAD_GESTURE_MASK", "GdkEventMask", GDK_TOUCHPAD_GESTURE_MASK},
        {"GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK", "GdkModifierIntent", GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK},
#endif
#if GTK_CHECK_VERSION(3, 2, 0)
        {"GTK_SIZE_REQUEST_CONSTANT_SIZE", "GtkSizeRequestMode", GTK_SIZE_REQUEST_CONSTANT_SIZE},
#endif
#if GTK_CHECK_VERSION(3, 20, 0)
        {"GTK_SHORTCUT_ACCELERATOR", "GtkShortcutType", GTK_SHORTCUT_ACCELERATOR},
        {"GTK_SHORTCUT_GESTURE_PINCH", "GtkShortcutType", GTK_SHORTCUT_GESTURE_PINCH},
        {"GTK_SHORTCUT_GESTURE_STRETCH", "GtkShortcutType", GTK_SHORTCUT_GESTURE_STRETCH},
        {"GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE", "GtkShortcutType", GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE},
        {"GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE", "GtkShortcutType", GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE},
        {"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT},
        {"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT},
        {"GTK_SHORTCUT_GESTURE", "GtkShortcutType", GTK_SHORTCUT_GESTURE},
        {"GTK_POPOVER_CONSTRAINT_NONE", "GtkPopoverConstraint", GTK_POPOVER_CONSTRAINT_NONE},
        {"GTK_POPOVER_CONSTRAINT_WINDOW", "GtkPopoverConstraint", GTK_POPOVER_CONSTRAINT_WINDOW},
        {"GDK_WINDOW_TYPE_HINT_SPLASHSCREEN", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_SPLASHSCREEN},
        {"GDK_WINDOW_TYPE_HINT_UTILITY", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_UTILITY},
        {"GDK_WINDOW_TYPE_HINT_DOCK", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DOCK},
        {"GDK_WINDOW_TYPE_HINT_DESKTOP", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DESKTOP},
        {"GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU},
        {"GDK_WINDOW_TYPE_HINT_POPUP_MENU", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_POPUP_MENU},
        {"GDK_WINDOW_TYPE_HINT_TOOLTIP", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_TOOLTIP},
        {"GDK_WINDOW_TYPE_HINT_NOTIFICATION", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_NOTIFICATION},
        {"GDK_WINDOW_TYPE_HINT_COMBO", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_COMBO},
        {"GDK_WINDOW_TYPE_HINT_DND", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DND},
        {"GDK_SEAT_CAPABILITY_NONE", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_NONE},
        {"GDK_SEAT_CAPABILITY_POINTER", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_POINTER},
        {"GDK_SEAT_CAPABILITY_TOUCH", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TOUCH},
        {"GDK_SEAT_CAPABILITY_TABLET_STYLUS", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TABLET_STYLUS},
        {"GDK_SEAT_CAPABILITY_KEYBOARD", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_KEYBOARD},
        {"GDK_SEAT_CAPABILITY_ALL_POINTING", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_ALL_POINTING},
        {"GDK_SEAT_CAPABILITY_ALL", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_ALL},
        {"GTK_STATE_FLAG_DROP_ACTIVE", "GtkStateFlags", GTK_STATE_FLAG_DROP_ACTIVE},
        {"GDK_DRAG_CANCEL_NO_TARGET", "GdkDragCancelReason", GDK_DRAG_CANCEL_NO_TARGET},
        {"GDK_DRAG_CANCEL_USER_CANCELLED", "GdkDragCancelReason", GDK_DRAG_CANCEL_USER_CANCELLED},
        {"GDK_DRAG_CANCEL_ERROR", "GdkDragCancelReason", GDK_DRAG_CANCEL_ERROR},
#endif
#if GTK_CHECK_VERSION(3, 22, 0)
        {"GDK_AXIS_IGNORE", "GdkAxisUse", GDK_AXIS_IGNORE},
        {"GDK_AXIS_X", "GdkAxisUse", GDK_AXIS_X},
        {"GDK_AXIS_Y", "GdkAxisUse", GDK_AXIS_Y},
        {"GDK_AXIS_PRESSURE", "GdkAxisUse", GDK_AXIS_PRESSURE},
        {"GDK_AXIS_XTILT", "GdkAxisUse", GDK_AXIS_XTILT},
        {"GDK_AXIS_YTILT", "GdkAxisUse", GDK_AXIS_YTILT},
        {"GDK_AXIS_WHEEL", "GdkAxisUse", GDK_AXIS_WHEEL},
        {"GDK_AXIS_LAST", "GdkAxisUse", GDK_AXIS_LAST},
        {"GDK_AXIS_FLAG_X", "GdkAxisFlags", GDK_AXIS_FLAG_X},
        {"GDK_AXIS_FLAG_Y", "GdkAxisFlags", GDK_AXIS_FLAG_Y},
        {"GDK_AXIS_FLAG_PRESSURE", "GdkAxisFlags", GDK_AXIS_FLAG_PRESSURE},
        {"GDK_AXIS_FLAG_XTILT", "GdkAxisFlags", GDK_AXIS_FLAG_XTILT},
        {"GDK_AXIS_FLAG_YTILT", "GdkAxisFlags", GDK_AXIS_FLAG_YTILT},
        {"GDK_AXIS_FLAG_WHEEL", "GdkAxisFlags", GDK_AXIS_FLAG_WHEEL},
        {"GDK_AXIS_FLAG_DISTANCE", "GdkAxisFlags", GDK_AXIS_FLAG_DISTANCE},
        {"GDK_AXIS_FLAG_ROTATION", "GdkAxisFlags", GDK_AXIS_FLAG_ROTATION},
        {"GDK_AXIS_FLAG_SLIDER", "GdkAxisFlags", GDK_AXIS_FLAG_SLIDER},
        {"GDK_DEVICE_TOOL_TYPE_UNKNOWN", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_UNKNOWN},
        {"GDK_DEVICE_TOOL_TYPE_PEN", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_PEN},
        {"GDK_DEVICE_TOOL_TYPE_ERASER", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_ERASER},
        {"GDK_DEVICE_TOOL_TYPE_BRUSH", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_BRUSH},
        {"GDK_DEVICE_TOOL_TYPE_PENCIL", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_PENCIL},
        {"GDK_DEVICE_TOOL_TYPE_AIRBRUSH", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_AIRBRUSH},
        {"GDK_DEVICE_TOOL_TYPE_MOUSE", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_MOUSE},
        {"GDK_DEVICE_TOOL_TYPE_LENS", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_LENS},
        {"GDK_SUBPIXEL_LAYOUT_UNKNOWN", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_UNKNOWN},
        {"GDK_SUBPIXEL_LAYOUT_NONE", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_NONE},
        {"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB},
        {"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR},
        {"GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB},
        {"GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR},
        {"GDK_DEVICE_PAD_FEATURE_BUTTON", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_BUTTON},
        {"GDK_DEVICE_PAD_FEATURE_RING", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_RING},
        {"GDK_DEVICE_PAD_FEATURE_STRIP", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_STRIP},
        {"GDK_PAD_BUTTON_PRESS", "GdkEventType", GDK_PAD_BUTTON_PRESS},
        {"GDK_PAD_BUTTON_RELEASE", "GdkEventType", GDK_PAD_BUTTON_RELEASE},
        {"GDK_PAD_RING", "GdkEventType", GDK_PAD_RING},
        {"GDK_PAD_STRIP", "GdkEventType", GDK_PAD_STRIP},
        {"GDK_PAD_GROUP_MODE", "GdkEventType", GDK_PAD_GROUP_MODE},
        {"GDK_TABLET_PAD_MASK", "GdkEventMask", GDK_TABLET_PAD_MASK},
        {"GDK_ANCHOR_FLIP_X", "GdkAnchorHints", GDK_ANCHOR_FLIP_X},
        {"GDK_ANCHOR_FLIP_Y", "GdkAnchorHints", GDK_ANCHOR_FLIP_Y},
        {"GDK_ANCHOR_SLIDE_X", "GdkAnchorHints", GDK_ANCHOR_SLIDE_X},
        {"GDK_ANCHOR_SLIDE_Y", "GdkAnchorHints", GDK_ANCHOR_SLIDE_Y},
        {"GDK_ANCHOR_RESIZE_X", "GdkAnchorHints", GDK_ANCHOR_RESIZE_X},
        {"GDK_ANCHOR_RESIZE_Y", "GdkAnchorHints", GDK_ANCHOR_RESIZE_Y},
        {"GDK_ANCHOR_FLIP", "GdkAnchorHints", GDK_ANCHOR_FLIP},
        {"GDK_ANCHOR_SLIDE", "GdkAnchorHints", GDK_ANCHOR_SLIDE},
        {"GDK_ANCHOR_RESIZE", "GdkAnchorHints", GDK_ANCHOR_RESIZE},
        {"GTK_PAD_ACTION_BUTTON", "GtkPadActionType", GTK_PAD_ACTION_BUTTON},
        {"GTK_PAD_ACTION_RING", "GtkPadActionType", GTK_PAD_ACTION_RING},
        {"GTK_PAD_ACTION_STRIP", "GtkPadActionType", GTK_PAD_ACTION_STRIP},
#endif
#if GTK_CHECK_VERSION(3, 4, 0)
        {"GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR", "GdkModifierIntent", GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR},
        {"GDK_MODIFIER_INTENT_CONTEXT_MENU", "GdkModifierIntent", GDK_MODIFIER_INTENT_CONTEXT_MENU},
        {"GDK_MODIFIER_INTENT_EXTEND_SELECTION", "GdkModifierIntent", GDK_MODIFIER_INTENT_EXTEND_SELECTION},
        {"GDK_MODIFIER_INTENT_MODIFY_SELECTION", "GdkModifierIntent", GDK_MODIFIER_INTENT_MODIFY_SELECTION},
        {"GDK_MODIFIER_INTENT_NO_TEXT_INPUT", "GdkModifierIntent", GDK_MODIFIER_INTENT_NO_TEXT_INPUT},
        {"GDK_MODIFIER_INTENT_SHIFT_GROUP", "GdkModifierIntent", GDK_MODIFIER_INTENT_SHIFT_GROUP},
        {"GDK_WINDOW_STATE_FOCUSED", "GdkWindowState", GDK_WINDOW_STATE_FOCUSED},
        {"GTK_CELL_RENDERER_EXPANDABLE", "GtkCellRendererState", GTK_CELL_RENDERER_EXPANDABLE},
        {"GTK_CELL_RENDERER_EXPANDED", "GtkCellRendererState", GTK_CELL_RENDERER_EXPANDED},
        {"GTK_STATE_FLAG_BACKDROP", "GtkStateFlags", GTK_STATE_FLAG_BACKDROP},
#endif
#if GTK_CHECK_VERSION(3, 6, 0)
        {"GDK_TOUCH_BEGIN", "GdkEventType", GDK_TOUCH_BEGIN},
        {"GDK_TOUCH_UPDATE", "GdkEventType", GDK_TOUCH_UPDATE},
        {"GDK_TOUCH_END", "GdkEventType", GDK_TOUCH_END},
        {"GDK_TOUCH_CANCEL", "GdkEventType", GDK_TOUCH_CANCEL},
        {"GDK_SCROLL_SMOOTH", "GdkScrollDirection", GDK_SCROLL_SMOOTH},
        {"GDK_CROSSING_TOUCH_BEGIN", "GdkCrossingMode", GDK_CROSSING_TOUCH_BEGIN},
        {"GDK_CROSSING_TOUCH_END", "GdkCrossingMode", GDK_CROSSING_TOUCH_END},
        {"GDK_CROSSING_DEVICE_SWITCH", "GdkCrossingMode", GDK_CROSSING_DEVICE_SWITCH},
        {"GDK_TOUCH_MASK", "GdkEventMask", GDK_TOUCH_MASK},
        {"GDK_SMOOTH_SCROLL_MASK", "GdkEventMask", GDK_SMOOTH_SCROLL_MASK},
        {"GTK_LEVEL_BAR_MODE_CONTINUOUS", "GtkLevelBarMode", GTK_LEVEL_BAR_MODE_CONTINUOUS},
        {"GTK_LEVEL_BAR_MODE_DISCRETE", "GtkLevelBarMode", GTK_LEVEL_BAR_MODE_DISCRETE},
        {"GTK_INPUT_PURPOSE_FREE_FORM", "GtkInputPurpose", GTK_INPUT_PURPOSE_FREE_FORM},
        {"GTK_INPUT_PURPOSE_ALPHA", "GtkInputPurpose", GTK_INPUT_PURPOSE_ALPHA},
        {"GTK_INPUT_PURPOSE_DIGITS", "GtkInputPurpose", GTK_INPUT_PURPOSE_DIGITS},
        {"GTK_INPUT_PURPOSE_NUMBER", "GtkInputPurpose", GTK_INPUT_PURPOSE_NUMBER},
        {"GTK_INPUT_PURPOSE_PHONE", "GtkInputPurpose", GTK_INPUT_PURPOSE_PHONE},
        {"GTK_INPUT_PURPOSE_URL", "GtkInputPurpose", GTK_INPUT_PURPOSE_URL},
        {"GTK_INPUT_PURPOSE_EMAIL", "GtkInputPurpose", GTK_INPUT_PURPOSE_EMAIL},
        {"GTK_INPUT_PURPOSE_NAME", "GtkInputPurpose", GTK_INPUT_PURPOSE_NAME},
        {"GTK_INPUT_PURPOSE_PASSWORD", "GtkInputPurpose", GTK_INPUT_PURPOSE_PASSWORD},
        {"GTK_INPUT_PURPOSE_PIN", "GtkInputPurpose", GTK_INPUT_PURPOSE_PIN},
        {"GTK_INPUT_HINT_NONE", "GtkInputHints", GTK_INPUT_HINT_NONE},
        {"GTK_INPUT_HINT_SPELLCHECK", "GtkInputHints", GTK_INPUT_HINT_SPELLCHECK},
        {"GTK_INPUT_HINT_NO_SPELLCHECK", "GtkInputHints", GTK_INPUT_HINT_NO_SPELLCHECK},
        {"GTK_INPUT_HINT_WORD_COMPLETION", "GtkInputHints", GTK_INPUT_HINT_WORD_COMPLETION},
        {"GTK_INPUT_HINT_LOWERCASE", "GtkInputHints", GTK_INPUT_HINT_LOWERCASE},
        {"GTK_INPUT_HINT_UPPERCASE_CHARS", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_CHARS},
        {"GTK_INPUT_HINT_UPPERCASE_WORDS", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_WORDS},
        {"GTK_INPUT_HINT_UPPERCASE_SENTENCES", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_SENTENCES},
        {"GTK_INPUT_HINT_INHIBIT_OSK", "GtkInputHints", GTK_INPUT_HINT_INHIBIT_OSK},
#endif
#if GTK_CHECK_VERSION(3, 8, 0)
        {"GTK_STATE_FLAG_DIR_LTR", "GtkStateFlags", GTK_STATE_FLAG_DIR_LTR},
        {"GTK_STATE_FLAG_DIR_RTL", "GtkStateFlags", GTK_STATE_FLAG_DIR_RTL},
        {"GDK_FULLSCREEN_ON_CURRENT_MONITOR", "GdkFullscreenMode", GDK_FULLSCREEN_ON_CURRENT_MONITOR},
        {"GDK_FULLSCREEN_ON_ALL_MONITORS", "GdkFullscreenMode", GDK_FULLSCREEN_ON_ALL_MONITORS},
#endif
#if GTK_CHECK_VERSION(3, 92, 0)
        {"GTK_SHORTCUT_GESTURE_SWIPE_LEFT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_SWIPE_LEFT},
        {"GTK_SHORTCUT_GESTURE_SWIPE_RIGHT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_SWIPE_RIGHT},
        {"GTK_STYLE_CONTEXT_PRINT_NONE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_NONE},
        {"GTK_STYLE_CONTEXT_PRINT_RECURSE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_RECURSE},
        {"GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE},
        {"GTK_CSS_PROVIDER_ERROR_FAILED", "GtkCssProviderError", GTK_CSS_PROVIDER_ERROR_FAILED},
        {"GTK_CSS_PROVIDER_ERROR_SYNTAX", "GtkCssProviderError", GTK_CSS_PROVIDER_ERROR_SYNTAX},
        {"GTK_CSS_PROVIDER_ERROR_IMPORT", "GtkCssProviderError", GTK_CSS_PROVIDER_ERROR_IMPORT},
        {"GTK_CSS_PROVIDER_ERROR_NAME", "GtkCssProviderError", GTK_CSS_PROVIDER_ERROR_NAME},
        {"GTK_CSS_PROVIDER_ERROR_DEPRECATED", "GtkCssProviderError", GTK_CSS_PROVIDER_ERROR_DEPRECATED},
        {"GTK_CSS_PROVIDER_ERROR_UNKNOWN_VALUE", "GtkCssProviderError", GTK_CSS_PROVIDER_ERROR_UNKNOWN_VALUE},
#endif
#if GTK_CHECK_VERSION(3, 99, 0)
        {"GDK_WINDOW_STATE_TOP_TILED", "GdkWindowState", GDK_WINDOW_STATE_TOP_TILED},
        {"GDK_WINDOW_STATE_TOP_RESIZABLE", "GdkWindowState", GDK_WINDOW_STATE_TOP_RESIZABLE},
        {"GDK_WINDOW_STATE_RIGHT_TILED", "GdkWindowState", GDK_WINDOW_STATE_RIGHT_TILED},
        {"GDK_WINDOW_STATE_RIGHT_RESIZABLE", "GdkWindowState", GDK_WINDOW_STATE_RIGHT_RESIZABLE},
        {"GDK_WINDOW_STATE_BOTTOM_TILED", "GdkWindowState", GDK_WINDOW_STATE_BOTTOM_TILED},
        {"GDK_WINDOW_STATE_BOTTOM_RESIZABLE", "GdkWindowState", GDK_WINDOW_STATE_BOTTOM_RESIZABLE},
        {"GDK_WINDOW_STATE_LEFT_TILED", "GdkWindowState", GDK_WINDOW_STATE_LEFT_TILED},
        {"GDK_WINDOW_STATE_LEFT_RESIZABLE", "GdkWindowState", GDK_WINDOW_STATE_LEFT_RESIZABLE},
        {"GTK_INPUT_HINT_VERTICAL_WRITING", "GtkInputHints", GTK_INPUT_HINT_VERTICAL_WRITING},
        {"GTK_INPUT_HINT_EMOJI", "GtkInputHints", GTK_INPUT_HINT_EMOJI},
        {"GTK_INPUT_HINT_NO_EMOJI", "GtkInputHints", GTK_INPUT_HINT_NO_EMOJI},
        {"GTK_EVENT_CONTROLLER_SCROLL_NONE", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_NONE},
        {"GTK_EVENT_CONTROLLER_SCROLL_VERTICAL", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_VERTICAL},
        {"GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL},
        {"GTK_EVENT_CONTROLLER_SCROLL_DISCRETE", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_DISCRETE},
        {"GTK_EVENT_CONTROLLER_SCROLL_KINETIC", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_KINETIC},
        {"GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES},
        {"GDK_DEVICE_TYPE_MASTER", "GdkDeviceType", GDK_DEVICE_TYPE_MASTER},
        {"GDK_DEVICE_TYPE_SLAVE", "GdkDeviceType", GDK_DEVICE_TYPE_SLAVE},
        {"GDK_DEVICE_TYPE_FLOATING", "GdkDeviceType", GDK_DEVICE_TYPE_FLOATING},
        {"GDK_SEAT_CAPABILITY_TABLET_PAD", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TABLET_PAD},
        {"GTK_ICON_SIZE_INHERIT", "GtkIconSize", GTK_ICON_SIZE_INHERIT},
        {"GTK_ICON_SIZE_NORMAL", "GtkIconSize", GTK_ICON_SIZE_NORMAL},
        {"GTK_ICON_SIZE_LARGE", "GtkIconSize", GTK_ICON_SIZE_LARGE},
        {"GTK_STATE_FLAG_FOCUS_VISIBLE", "GtkStateFlags", GTK_STATE_FLAG_FOCUS_VISIBLE},
        {"GTK_IMAGE_SURFACE", "GtkImageType", GTK_IMAGE_SURFACE},
        {"GTK_IMAGE_TEXTURE", "GtkImageType", GTK_IMAGE_TEXTURE},
        {"GTK_APPLICATION_INHIBIT_LOGOUT", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_LOGOUT},
        {"GTK_APPLICATION_INHIBIT_SWITCH", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_SWITCH},
        {"GTK_APPLICATION_INHIBIT_SUSPEND", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_SUSPEND},
        {"GTK_APPLICATION_INHIBIT_IDLE", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_IDLE},
#endif
        {NULL, NULL, 0}};

static s7_pointer enum_value_to_name(s7_scheme *sc, int64_t val, const char *type) 
{ 
  int k; 
  int64_t range_min = 0, range_max = 0; 
  bool range_set = false; 
  for (k = 0; ; k++) 
    { 
      enummer_t nt; 
      nt = enum_info[k]; 
      if (!nt.name) 
	break; 
      if (strcmp(nt.type, type) == 0) 
	{ 
	  if (nt.value == val)        /* ... value should be <nt.name> */ 
	    return(s7_make_string(sc, nt.name)); 
	  if (!range_set) 
	    { 
	      range_min = nt.value; 
	      range_max = nt.value; 
	      range_set = true; 
	    } 
	  else 
	    { 
	      if (range_min > nt.value) range_min = nt.value; 
	      if (range_max < nt.value) range_max = nt.value; 
	    } 
	} 
    } 
  if (range_set)       /* here we found a matching name, its type is wrong, and it's out of range */ 
    { 
      char *range_string; 
      s7_pointer str; 
      range_string = (char *)malloc(256 * sizeof(char)); 
      snprintf(range_string, 256, "between %" PRId64 " and %" PRId64, range_min, range_max); 
      str = s7_make_string(sc, range_string); 
      free(range_string); 
      return(str);                            /* ... value should be between <min> and <max> */ 
    } 
  return(s7_make_symbol(sc, "integer?")); 
}

static s7_pointer g_gtk_enum_t(s7_scheme *sc, s7_pointer args) 
{ 
  s7_pointer form, argn, func, arg; 
  const char *doc_string, *p; 
  int arg_number; 
  form = s7_car(args);  
  argn = s7_cadr(args); 
  arg_number = s7_integer(argn); 
  arg = s7_list_ref(sc, form, arg_number); 
  if ((!s7_is_integer(arg)) && 
      (!s7_is_symbol(arg))) 
    return(s7_make_symbol(sc, "integer?")); 
  func = s7_car(form); 
  doc_string = s7_documentation(sc, func); 
  p = strchr(doc_string, (int)'('); 
  if (p) 
    { 
      int i; 
      for (i = 1; i < arg_number; i++) 
	p = strchr((char *)(p + 1), (int)','); 
      if (p) 
	{ 
	  const char *e; 
	  p += 2; /* past comma and space */ 
	  e = strchr(p, (int)' '); 
	  if (e) 
	    { 
	      int len; 
	      char *type; 
	      len = e - p + 1; 
	      type = (char *)malloc(len * sizeof(char)); 
	      for (i = 0; i < len; i++) type[i] = p[i]; 
	      type[len - 1] = '\0'; 
	      if (s7_is_symbol(arg)) 
		{ 
		  const char *arg_name; 
		  arg_name = s7_symbol_name(arg); /* no free */ 
		  for (i = 0; ; i++) 
		    { 
		      enummer_t et; 
		      et = enum_info[i]; 
		      if (!et.name) 
			break; 
		      if (strcmp(et.name, arg_name) == 0) 
			{ 
			  if (strcmp(et.type, type) == 0)                 /* success -- name and type match */ 
			    { 
			      free(type); 
			      return(s7_t(sc)); 
			    } 
			  return(enum_value_to_name(sc, et.value, type)); /* here the type is wrong, so try to find the correct name */ 
			} 
		    } 
		  return(s7_make_symbol(sc, "integer?"));               /* here we got no matches, so return 'integer? */ 
		} 
	      return(enum_value_to_name(sc, s7_integer(arg), type));      /* here arg is an integer */ 
	    } 
	} 
    } 
  return(s7_make_symbol(sc, "integer?")); 
}

static void define_lint(void)
{
  s7_define_safe_function(s7, "gtk_enum_t?", g_gtk_enum_t, 2, 0, 0, "lint helper");
}
#endif


/* -------------------------------- initialization -------------------------------- */

static bool xg_already_inited = false;

#if HAVE_SCHEME
void Init_libxg(s7_scheme *sc);
void Init_libxg(s7_scheme *sc)
#else
void Init_libxg(void);
void Init_libxg(void)
#endif
{
  if (!xg_already_inited)
    {
 #if HAVE_SCHEME
      s7_xen_initialize(sc);
 #endif
      define_symbols();
      define_xm_obj();
      define_integers();
      define_doubles();
      define_functions();
      define_strings();
      define_structs();
 #if HAVE_SCHEME
      define_lint();
 #endif
      Xen_provide_feature("xg");
      #if GTK_CHECK_VERSION(3, 90, 0)
        Xen_provide_feature("gtk4");
      #else
        #if GTK_CHECK_VERSION(3, 0, 0)
          Xen_provide_feature("gtk3");
        #else
          Xen_provide_feature("gtk2");
        #endif
      #endif
      Xen_define("xg-version", C_string_to_Xen_string("22-Apr-18"));
      xg_already_inited = true;
#if HAVE_SCHEME
#if USE_SND
      /* these are macros in glib/gobject/gsignal.h, but we want the types handled in some convenient way in the extension language */
      s7_define(s7, s7_nil(s7), s7_make_symbol(s7, "g_signal_connect"),
         Xen_eval_C_string("(lambda (obj name func . data)\
           ((*gtk* 'g_signal_connect_data) ((*gtk* 'GPOINTER) obj) name func (and (pair? data) (car data)) #f 0))"));
      s7_define(s7, s7_nil(s7), s7_make_symbol(s7, "g_signal_connect_after"),
         Xen_eval_C_string("(lambda (obj name func . data)\
           ((*gtk* 'g_signal_connect_data) ((*gtk* 'GPOINTER) obj) name func (and (pair? data) (car data)) #f (*gtk* 'G_CONNECT_AFTER)))"));
      s7_define(s7, s7_nil(s7), s7_make_symbol(s7, "g_signal_connect_swapped"),
         Xen_eval_C_string("(lambda (obj name func . data)\
           ((*gtk* 'g_signal_connect_data) ((*gtk* 'GPOINTER) obj) name func (and (pair? data) (car data)) #f (*gtk* 'G_CONNECT_SWAPPED)))"));
#else
      Xen_eval_C_string("(define (g_signal_connect obj name func . data) (g_signal_connect_data (GPOINTER obj) name func (and (pair? data) (car data)) #f 0))");
      Xen_eval_C_string("(define (g_signal_connect_after obj name func . data) (g_signal_connect_data (GPOINTER obj) name func (and (pair? data) (car data)) #f G_CONNECT_AFTER))");
      Xen_eval_C_string("(define (g_signal_connect_swapped obj name func . data) (g_signal_connect_data (GPOINTER obj) name func (and (pair? data) (car data)) #f G_CONNECT_SWAPPED))");
#endif
#endif
#if HAVE_RUBY 
      Xen_eval_C_string("def Rg_signal_connect(obj, name, func, data = false); Rg_signal_connect_data(RGPOINTER(obj), name, func, data, false, 0); end"); 
      Xen_eval_C_string("def Rg_signal_connect_after(obj, name, func, data = false); Rg_signal_connect_data(RGPOINTER(obj), name, func, data, false, RG_CONNECT_AFTER); end"); 
      Xen_eval_C_string("def Rg_signal_connect_swapped(obj, name, func, data = false); Rg_signal_connect_data(RGPOINTER(obj), name, func, data, false, RG_CONNECT_SWAPPED); end"); 
#endif 
#if HAVE_FORTH 
      Xen_eval_C_string(": Fg_signal_connect <{ obj name func :optional data #f -- n }> obj FGPOINTER name func data #f 0 Fg_signal_connect_data ;"); 
      Xen_eval_C_string(": Fg_signal_connect_after <{ obj name func :optional data #f -- n }> obj FGPOINTER name func data #f FG_CONNECT_AFTER Fg_signal_connect_data ;"); 
      Xen_eval_C_string(": Fg_signal_connect_swapped <{ obj name func :optional data #f -- n }> obj FGPOINTER name func data #f FG_CONNECT_SWAPPED Fg_signal_connect_data ;"); 
#endif 
    }
}
#else
 void Init_libxg(void);
 void Init_libxg(void)
{
}
#endif
